#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "2e7432b299d4ba499027a17319654f4bcd9372c2";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "ast";
Object module_standardGrace_init();
static char *originalSourceLines[] = {
  "#pragma noTypeChecks",
  "#pragma ExtendedLineups",
  "import \"util\" as util",
  "import \"identifierKinds\" as k",
  "",
  "// This module contains classes and pseudo-classes for all the AST nodes used",
  "// in the parser. Because of the limitations of the class syntax, classes that",
  "// need more than one method are written as object literals containing methods.",
  "// Each node has a different signature according to its function, but the",
  "// common interface is given by type ASTNode",
  "//",
  "// Most nodes also contain a \"value\" field, with varied type, holding the `main value`",
  "// in the node.  This field is confusing and should be appropriately re-named in",
  "// each case. Some nodes contain other fields for their specific use: while has",
  "// both a value (the condition) and a body, for example.",
  "",
  "def lineLength is public = 80",
  "def uninitialized = Singleton.named \"uninitialized\"",
  "method listMap(l, b) ancestors(as) is confidential {",
  "    def newList = [ ]",
  "    l.do { nd -> newList.addLast(nd.map(b) ancestors(as)) }",
  "    newList",
  "}",
  "method maybeMap(n, b) ancestors(as) is confidential {",
  "    if (false != n) then {",
  "        n.map(b) ancestors(as)",
  "    } else {",
  "        n",
  "    }",
  "}",
  "method maybeListMap(n, b) ancestors(as) is confidential {",
  "    if (false != n) then {",
  "        listMap(n, b) ancestors(as)",
  "    } else {",
  "        n",
  "    }",
  "}",
  "",
  "def ancestorChain = object {",
  "    class empty {",
  "        method isEmpty { true }",
  "        method asString { \"ancestorChain ▫\" }",
  "        method extend(n) { cons(n) onto(self) }",
  "    }",
  "    method with(n) { empty.extend(n) }",
  "    class cons(p) onto(as) is confidential {",
  "        method forebears { as }",
  "        method isEmpty { false }",
  "        method parent { p }",
  "        method grandparent { forebears.parent }",
  "",
  "        method asString {",
  "            var a := self",
  "            var s := \"ancestorChain \"",
  "            while { a.isEmpty.not } do {",
  "                s := s ++ a.parent ++ \"➤\"",
  "                a := a.forebears",
  "            }",
  "            s ++ \"▫\"",
  "        }",
  "        method extend(n) { cons(n) onto(self) }",
  "    }",
  "}",
  "",
  "def emptySeq = emptySequence",
  "",
  "type AstNode = type {",
  "    kind -> String",
  "        // Used for pseudo-instanceof tests.",
  "    register -> String",
  "        // Used in the code generator on to name the resulting object",
  "    line -> Number",
  "        // The source line the node came from",
  "    line:=(ln:Number)",
  "    linePos -> Number",
  "    linePos:=(lp:Number)",
  "    scope -> SymbolTable",
  "        // The symbolTable for names defined in this node and its sub-nodes",
  "    pretty(n:Number) -> String",
  "        // Pretty-print-string of node at depth n",
  "    comments -> AstNode",
  "        // Comments associated with this node",
  "}",
  "",
  "type SymbolTable = Unknown",
  "",
  "class baseNode {",
  "    // the superclass of all AST nodes",
  "    var register is public := \"\"",
  "    var line is public := util.linenum",
  "    var linePos is public := util.linepos",
  "    var symbolTable := fakeSymbolTable",
  "    var comments is public := false",
  "",
  "    method setLine (l) col (c) {",
  "        line := l",
  "        linePos := c",
  "        self",
  "    }",
  "    method setPositionFrom (token) {",
  "        line := token.line",
  "        linePos := token.linePos",
  "        self",
  "    }",
  "    method kind { abstract }",
  "    method ==(other) { self.isMe(other) }       // for usesAsType",
  "    method isAppliedOccurenceOfIdentifier { false }",
  "    method isMatchingBlock { false }",
  "    method isFieldDec { false }",
  "    method isInherits { false }",
  "    method isLegalInTrait { false }",
  "    method isMember { false }",
  "    method isMethod { false }",
  "    method isExecutable { true }",
  "    method isCall { false }",
  "    method isComment { false }",
  "    method isClass { false }    // is a method that returns a fresh object",
  "    method inClass { false }    // object in a syntactic class definiton",
  "    method isTrait { false }    // is a method that returns a trait object",
  "    method inTrait { false }    // object in a syntactic trait definition",
  "    method isBind { false }",
  "    method isSelf { false }",
  "    method isSuper { false }",
  "    method isPrelude { false }",
  "    method isOuter { false }",
  "    method isSelfOrOuter { false }",
  "    method isBlock { false }",
  "    method isObject { false }",
  "    method isIdentifier { false }",
  "    method isDialect { false }",
  "    method isImport { false }",
  "    method isTypeDec { false }",
  "    method isExternal { false }",
  "    method canInherit { false }",
  "    method returnsObject { false }",
  "    method isImplicit { false }",
  "    method usesAsType(aNode) { false }",
  "    method hash { line.hash * linePos.hash }",
  "    method asString { \"{kind} {nameString}\" }",
  "    method nameString { \"?\" }",
  "    method isWritable { true }",
  "    method isReadable { true }",
  "    method isPublic { true }",
  "    method isConfidential { isPublic.not }",
  "    method decType {",
  "        if (false == self.dtype) then {",
  "            return unknownType",
  "        }",
  "        return self.dtype",
  "    }",
  "    method isSimple { true }  // needs no parens when used as receiver",
  "    method isDelimited { false }  // needs no parens when used as argument",
  "    method description { kind }",
  "    method accept(visitor) {",
  "        self.accept(visitor) from (ancestorChain.empty)",
  "    }",
  "    method scope { symbolTable }",
  "",
  "    method scope:=(st) {",
  "        // override this method in subobjects that open a new scope. In such",
  "        // subobjects, and only in such subobjects, there should be a 2-way",
  "        // conection between the node and the symbol table that defines its scope.",
  "        symbolTable := st",
  "    }",
  "",
  "    method shallowCopyFieldsFrom(other) {",
  "        register := other.register",
  "        line := other.line",
  "        linePos := other.linePos",
  "        scope := other.scope",
  "        self",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        if ((scope.node == self) && {util.target == \"symbols\"}) then {",
  "            \"{line}:{linePos} {description}\\n{spc}Symbols({scope.variety}): {scope}{scope.elementScopesAsString}\"",
  "        } elseif {scope.variety == \"fake\"} then {",
  "            \"{line}:{linePos} {description}\"",
  "        } else {",
  "            \"{line}:{linePos} {description} {scope.asDebugString}\"",
  "        }",
  "    }",
  "    method deepCopy {",
  "        self.map { each -> each } ancestors(ancestorChain.empty)",
  "    }",
  "    method enclosingObject {",
  "        def obj = scope.enclosingObjectScope.node",
  "        obj",
  "    }",
  "    method addComment(cmtNode) {",
  "        if (false == comments) then {",
  "            comments := cmtNode",
  "        } else {",
  "            comments.extendCommentUsing(cmtNode)",
  "        }",
  "    }",
  "    method addComments(cmtNodeList) {",
  "        cmtNodeList.do { each -> addComment(each) }",
  "    }",
  "    method statementName { kind }",
  "}",
  "",
  "def implicit is public = object {",
  "    inherits baseNode",
  "    line := 0",
  "    linePos := 0",
  "    def kind is public = \"implicit\"",
  "    def nameString is public = \"implicit\"",
  "    method isImplicit { true }",
  "    method toGrace(depth) { \"implicit\" }",
  "    method asString { \"the implicit receiver\" }",
  "    method == (other) { self.isMe(other) }",
  "    method map(blk) ancestors(as) { self }",
  "    method accept(visitor) from (as) {",
  "        visitor.visitImplicit(self) up (as)",
  "    }",
  "    method pretty(depth) { \"implicit\" }",
  "}",
  "",
  "def nullNode is public = object {",
  "    inherits baseNode",
  "    def kind is public = \"null\"",
  "    method toGrace(depth) {",
  "        \"// null\"",
  "    }",
  "    method asString { \"the nullNode\" }",
  "    method == (other) { self.isMe(other) }",
  "}",
  "",
  "def fakeSymbolTable = object {",
  "    var node is public := nullNode",
  "    method asString { \"the fakeSymbolTable\" }",
  "    method addNode (n) as (kind) {",
  "        ProgrammingError.raise \"fakeSymbolTable(on node {node}).addNode({n}) as \\\"{kind}\\\" requested\"",
  "    }",
  "    method thatDefines (name) ifNone (action) {",
  "        ProgrammingError.raise \"fakeSymbolTable.thatDefines({name}).\"",
  "    }",
  "    method enclosingObjectScope {",
  "        ProgrammingError.raise \"fakeSymbolTable.enclosingObjectScope on node {node}\"",
  "    }",
  "    method variety { \"fake\" }",
  "    method ==(other) { self.isMe(other) }",
  "}",
  "",
  "def ifNode is public = object {",
  "  class new(cond, thenblock', elseblock') {",
  "    inherits baseNode",
  "    def kind is public = \"if\"",
  "    var value is public := cond",
  "    var thenblock is public := thenblock'",
  "    var elseblock is public := elseblock'",
  "    var handledIdentifiers is public := false",
  "    method isSimple { false }  // needs parens when used as reciever",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitIf(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            value.accept(visitor) from(newChain)",
  "            thenblock.accept(visitor) from(newChain)",
  "            elseblock.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.thenblock := thenblock.map(blk) ancestors(newChain)",
  "        n.elseblock := elseblock.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth+1)",
  "        s := s ++ \"\\n\"",
  "        if (util.target == \"symbols\") then {",
  "            s := s ++ spc ++ \"Then: {thenblock.pretty(depth+2)}\\n\"",
  "            s := s ++ spc ++ \"Else: {elseblock.pretty(depth+2)}\"",
  "        } else {",
  "            s := s ++ spc ++ \"Then:\"",
  "            for (self.thenblock.body) do { ix ->",
  "                s := s ++ \"\\n  \"++ spc ++ ix.pretty(depth+2)",
  "            }",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ \"Else:\"",
  "            for (self.elseblock.body) do { ix ->",
  "                s := s ++ \"\\n  \"++ spc ++ ix.pretty(depth+2)",
  "            }",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        repeat (depth) times {",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"if ({self.value.toGrace(0)}) then \\{\"",
  "        for (self.thenblock.body) do { ix ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ ix.toGrace(depth + 1)",
  "        }",
  "        if (self.elseblock.isntEmpty) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\} else \\{\"",
  "            for (self.elseblock.body) do { ix ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ ix.toGrace(depth + 1)",
  "            }",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        ifNode.new(nullNode, nullNode, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "    method shallowCopyFieldsFrom(other) {",
  "        super.shallowCopyFieldsFrom(other)",
  "        handledIdentifiers := other.handledIdentifiers",
  "        self",
  "    }",
  "  }",
  "}",
  "def blockNode is public = object {",
  "  class new(params', body') {",
  "    inherits baseNode",
  "    def kind is public = \"block\"",
  "    def value is public = \"block\"",
  "    var params is public := params'",
  "    var body is public := body'",
  "    def selfclosure is public = true",
  "    var matchingPattern is public := false",
  "    var extraRuntimeData is public := false",
  "    for (params') do {p->",
  "        p.accept(patternMarkVisitor) from(ancestorChain.with(self))",
  "    }",
  "    method isBlock { true }",
  "    method isDelimited { true }",
  "    method isEmpty { body.size == 0 }",
  "    method isntEmpty { body.size > 0 }",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node",
  "        // and the synmol table that defines the scope that I open.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "    method declarationKindWithAncestors(as) { k.parameter }",
  "    method isMatchingBlock { params.size == 1 }",
  "    method returnsObject {",
  "        (body.size > 0) && { body.last.returnsObject }",
  "    }",
  "    method returnedObjectScope {",
  "        // precondition: returnsObject",
  "        body.last.returnedObjectScope",
  "    }",
  "    method parametersDo(b) {",
  "        params.do(b)",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitBlock(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.params) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            for (self.body) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            if (false != self.matchingPattern) then {",
  "                self.matchingPattern.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.params := listMap(params, blk) ancestors(newChain)",
  "        n.body := listMap(body, blk) ancestors(newChain)",
  "        n.matchingPattern := maybeMap(matchingPattern, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ \"Parameters:\"",
  "        for (self.params) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+1)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ \"Body:\"",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+1)",
  "        }",
  "        if (false != self.matchingPattern) then {",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ \"Pattern:\"",
  "            s := s ++ \"\\n  \"++ spc ++ self.matchingPattern.pretty(depth+1)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        repeat (depth) times {",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\\{\"",
  "        if (self.params.size > 0) then {",
  "            s := s ++ \" \"",
  "            for (self.params.indices) do { i ->",
  "                var p := self.params.at(i)",
  "                if (false != self.matchingPattern) then {",
  "                    s := s ++ \"(\" ++ p.toGrace(0) ++ \")\"",
  "                } else {",
  "                    s := s ++ p.toGrace(0)",
  "                }",
  "                if (i < self.params.size) then {",
  "                    s := s ++ \", \"",
  "                } else {",
  "                    s := s ++ \" →\"",
  "                }",
  "            }",
  "        }",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n\" ++ spc ++ mx.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        repeat (depth - 1) times { s := s ++ \"    \" }",
  "        s ++ \"\\}\"",
  "    }",
  "    method shallowCopy {",
  "        blockNode.new(params, body).shallowCopyFieldsFrom(self)",
  "    }",
  "    method shallowCopyFieldsFrom(other) {",
  "        super.shallowCopyFieldsFrom(other)",
  "        matchingPattern := other.matchingPattern",
  "        extraRuntimeData := other.extraRuntimeData",
  "        self",
  "    }",
  "  }",
  "}",
  "def tryCatchNode is public = object {",
  "  class new(block, cases', finally') {",
  "    inherits baseNode",
  "    def kind is public = \"trycatch\"",
  "    var value is public := block",
  "    var cases is public := cases'",
  "    var finally is public := finally'",
  "    method isSimple { false }  // needs parens when used as reciever",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTryCatch(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            for (self.cases) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            if (false != self.finally) then {",
  "                self.finally.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.cases := listMap(cases, blk) ancestors(newChain)",
  "        n.finally := maybeMap(finally, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}\\n\"",
  "        s := s ++ spc ++ value.pretty(depth + 2)",
  "        for (self.cases) do { mx ->",
  "            s := s ++ \"\\n{spc}Case:\\n{spc}  {mx.pretty(depth+2)}\"",
  "        }",
  "        if (false != self.finally) then {",
  "            s := s ++ \"\\n{spc}Finally:\\n{spc}  {self.finally.pretty(depth+2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"try \" ++ self.value.toGrace(depth + 1) ++ \" \"",
  "        for (self.cases) do { case ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"catch \" ++ case.toGrace(depth + 1)",
  "        }",
  "        if (false != self.finally) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"finally \" ++ self.finally.toGrace(depth + 1)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        tryCatchNode.new(nullNode, emptySeq, false).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def matchCaseNode is public = object {",
  "  class new(matchee', cases', elsecase') {",
  "    inherits baseNode",
  "    def kind is public = \"matchcase\"",
  "    var value is public := matchee'",
  "    var cases is public := cases'",
  "    var elsecase is public := elsecase'",
  "    method isSimple { false }  // needs parens when used as reciever",
  "    method matchee { value }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitMatchCase(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            for (self.cases) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            if (false != self.elsecase) then {",
  "                self.elsecase.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.cases := listMap(cases, blk) ancestors(newChain)",
  "        n.elsecase := maybeMap(elsecase, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ matchee.pretty(depth + 2)",
  "        for (self.cases) do { mx ->",
  "            s := s ++ \"\\n{spc}Case:\\n{spc}  {mx.pretty(depth+2)}\"",
  "        }",
  "        if (false != self.elsecase) then {",
  "            s := s ++ \"\\n{spc}Else:\\n{spc}  {self.elsecase.pretty(depth+2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"match(\" ++ self.value.toGrace(0) ++ \")\"",
  "        for (self.cases) do { case ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"case \" ++ case.toGrace(depth + 2)",
  "        }",
  "        if (false != self.elsecase) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"else \" ++ self.elsecase.toGrace(depth + 2)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        matchCaseNode.new(nullNode, emptySeq, false).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def methodTypeNode is public = object {",
  "  class new(signature', rtype') {",
  "    // Represents the signature of a method in a type literal",
  "    // signature' is an Iterable of requestPart objects, which contain",
  "    // the parts of the name and the parameter lists.",
  "",
  "    inherits baseNode",
  "    def kind is public = \"methodtype\"",
  "    var signature is public := signature'",
  "    var rtype is public := rtype'",
  "    var typeParams is public := false",
  "    var cachedIdentifier := uninitialized",
  "",
  "    method nameString {",
  "        signature.fold { acc, each -> acc ++ each.nameString }",
  "            startingWith \"\"",
  "    }",
  "    method value {",
  "        if (uninitialized == cachedIdentifier) then {",
  "            cachedIdentifier := identifierNode.new(nameString, false)",
  "            cachedIdentifier.line := signature.first.line",
  "            cachedIdentifier.linePos := signature.first.linePos",
  "            cachedIdentifier.isBindingOccurrence := true",
  "        }",
  "        cachedIdentifier",
  "    }",
  "    method isExecutable { false }",
  "    method parametersDo(b) {",
  "        signature.do { part ->",
  "            part.params.do { each -> b.apply(each) }",
  "        }",
  "    }",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node",
  "        // and the symbol table that defines the scope that I open.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "    method declarationKindWithAncestors(as) { k.typedec }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitMethodType(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            if (false != typeParams) then {",
  "                typeParams.accept(visitor) from(newChain)",
  "            }",
  "            if (false != rtype) then {",
  "                rtype.accept(visitor) from(newChain)",
  "            }",
  "            for (signature) do { part ->",
  "                part.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.rtype := maybeMap(rtype, blk) ancestors(newChain)",
  "        n.signature := listMap(signature, blk) ancestors(newChain)",
  "        n.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := \"{s}{spc}Name: {value}\\n\"",
  "        if (false != rtype) then {",
  "            s := \"{s}{spc}Returns:\\n  {spc}{rtype.pretty(depth + 2)}\"",
  "        }",
  "        if (false != typeParams) then {",
  "            s := \"{s}\\n{spc}TypeParams:\\n\"",
  "            s := s ++ typeParams.pretty(depth + 2)",
  "        }",
  "        s := \"{s}\\n{spc}Signature:\"",
  "        for (signature) do { part ->",
  "            s := \"{s}\\n  {spc}{part.pretty(depth + 2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        signature.do { part -> s:= s ++ part.toGrace(depth + 1) }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        methodTypeNode.new(signature, rtype).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def typeLiteralNode is public = object {",
  "  class new(methods', types') {",
  "    inherits baseNode",
  "    def kind is public = \"typeliteral\"",
  "    var methods is public := methods'",
  "    var types is public := types'",
  "    var nominal is public := false",
  "    var anonymous is public := true",
  "    var value is public := \"‹anon›\"",
  "",
  "    method name { value }",
  "    method name:=(n) {",
  "        value := n",
  "        anonymous := false",
  "    }",
  "    method asString {",
  "        \"typeliteral: methods = {methods}, types = {types}\"",
  "    }",
  "    method declarationKindWithAncestors(as) { k.typedec }",
  "    method isExecutable { false }",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTypeLiteral(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.methods) do { each ->",
  "                each.accept(visitor) from(newChain)",
  "            }",
  "            for (self.types) do { each ->",
  "                each.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.methods := listMap(methods, blk) ancestors (as)",
  "        n.types := listMap(types, blk) ancestors (as)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}\\n\"",
  "        s := s ++ spc ++ \"Types:\"",
  "        for (types) do { each ->",
  "            s := s ++ \"\\n  \"++ spc ++ each.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"Methods:\"",
  "        for (methods) do { each ->",
  "            s := s ++ \"\\n  \"++ spc ++ each.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"type\"",
  "        s := s ++ \" = \\{\"",
  "        for (self.methods) do { each ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ each.toGrace(depth + 1)",
  "        }",
  "        for (self.types) do { each ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ each.toGrace(depth + 1)",
  "        }",
  "        s ++ \"\\}\"",
  "    }",
  "    method shallowCopy {",
  "        typeLiteralNode.new(emptySeq, emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "    method shallowCopyFieldsFrom(other) {",
  "        super.shallowCopyFieldsFrom(other)",
  "        nominal := other.nominal",
  "        anonymous := other.anonymous",
  "        value := other.value",
  "        self",
  "    }",
  "  }",
  "}",
  "",
  "def typeDecNode is public = object {",
  "  class new(name', typeValue) {",
  "    inherits baseNode",
  "    def kind is public = \"typedec\"",
  "    var name is public := name'",
  "    var value is public := typeValue",
  "    def nameString is public = name.value",
  "    var annotations is public := [ ]",
  "    var typeParams is public := false",
  "",
  "    method isLegalInTrait { true }",
  "    method isTypeDec { true }",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node",
  "        // and the synmol table that defines the scope that I open.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "",
  "    method isExecutable { true }",
  "    method declarationKindWithAncestors(as) { k.typeparam }",
  "    method isConfidential {",
  "        if (annotations.size == 0) then { return false }",
  "        findAnnotation(self, \"confidential\")",
  "    }",
  "    method isPublic { isConfidential.not }",
  "    method isWritable { false }",
  "    method isReadable { isPublic }",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTypeDec(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            name.accept(visitor) from(newChain)",
  "            if (false != typeParams) then {",
  "                typeParams.accept(visitor) from(newChain)",
  "            }",
  "            annotations.do { each -> each.accept(visitor) from(newChain) }",
  "            value.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.name := name.map(blk) ancestors(newChain)",
  "        n.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth + 1) ++ \"\\n\"",
  "        if (false != typeParams) then {",
  "            s := \"{s}{spc}Type parameters:\\n{typeParams.pretty(depth + 2)}\\n\"",
  "        }",
  "        s := s ++ spc ++ \"Value:\"",
  "        s := s ++ value.pretty(depth+2)",
  "        s := s ++ \"\\n\"",
  "        if (false != comments) then {",
  "            s := s ++ comments.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\"",
  "        s := \"type {self.name}\"",
  "        if (false != typeParams) then {",
  "            typeParams.toGrace(0)",
  "        }",
  "        s ++ \" = \" ++ value.toGrace(depth + 2)",
  "    }",
  "    method shallowCopy {",
  "        typeDecNode.new(name, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "",
  "def methodNode = object {",
  "    method new(signature, body, dtype) scope(s) {",
  "        def result = new(signature, body, dtype)",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    class new(signature', body', dtype') {",
  "        // Represents a method declaration",
  "        // The name of the method is constructed from signature',",
  "        // which is a sequence of signatureParts;",
  "        // body is a sequence of statements and declarations.",
  "        // dtype is the declared return type of the method, or false.",
  "",
  "        inherits baseNode",
  "        def kind is public = \"method\"",
  "        var signature is public := signature'",
  "        var body is public := body'",
  "        var dtype is public := dtype'",
  "        var typeParams is public := false",
  "        var selfclosure is public := false",
  "        var annotations is public := [ ]",
  "        var isFresh is public := false      // a method is 'fresh' if it answers a new object",
  "        var usesClassSyntax is public := false",
  "        var cachedIdentifier := uninitialized",
  "        var isBindingOccurence is readable := true",
  "            // the only exception is the oldMethodName in an alias clause",
  "",
  "        method appliedOccurence {",
  "            isBindingOccurence := false",
  "            if (uninitialized ≠ cachedIdentifier) then {",
  "                cachedIdentifier.isBindingOccurence := false",
  "            }",
  "            self",
  "        }",
  "        method numParams {",
  "            signature.fold { acc, p -> acc + p.numParams } startingWith 0",
  "        }",
  "        method endPos {",
  "            def lastPart = signature.last",
  "            lastPart.linePos + lastPart.name.size - 1",
  "        }",
  "",
  "        method nameString {",
  "            signature.fold { acc, each -> acc ++ each.nameString }",
  "                startingWith \"\"",
  "        }",
  "        method asIdentifier {",
  "            if (uninitialized == cachedIdentifier) then {",
  "                cachedIdentifier := identifierNode.new(nameString, false)",
  "                cachedIdentifier.line := signature.first.line",
  "                cachedIdentifier.linePos := signature.first.linePos",
  "                cachedIdentifier.isBindingOccurrence := isBindingOccurence",
  "                cachedIdentifier.canonicalName := canonicalName",
  "            }",
  "            cachedIdentifier",
  "        }",
  "        method value { asIdentifier }",
  "        method canonicalName {",
  "            signature.fold { acc, each -> acc ++ each.canonicalName }",
  "                startingWith \"\"",
  "        }",
  "        method hasParams { signature.first.params.isEmpty.not }",
  "        method numParamLists {",
  "            // the number of my parameter lists.  If I have a single",
  "            // part to my name, there may be 0 or 1",
  "            def sigSz = signature.size",
  "            if (sigSz > 1) then { return sigSz }",
  "            if {signature.first.params.isEmpty} then { return 0 }",
  "            return 1",
  "        }",
  "        method hasTypeParams { false ≠ signature.first.typeParams }",
  "        method isMethod { true }",
  "        method isExecutable { false }",
  "        method isLegalInTrait { true }",
  "        method isClass { isFresh || usesClassSyntax }",
  "        method isTrait {",
  "            if (isFresh) then {",
  "                body.last.isTrait",
  "            } else {",
  "                false",
  "            }",
  "        }",
  "        method needsArgChecks {",
  "            signature.do { part ->",
  "                part.params.do { p ->",
  "                    if ((false != p.dtype) && {",
  "                            p.dtype.nameString != \"Unknown\" }) then {",
  "                        return true",
  "                    }",
  "                }",
  "            }",
  "            return false",
  "        }",
  "        method scope:=(st) {",
  "            // sets up the 2-way conection between this node",
  "            // and the synmol table that defines the scope that I open.",
  "            symbolTable := st",
  "            st.node := self",
  "        }",
  "        method declarationKindWithAncestors(as) { k.parameter }",
  "        method isConfidential {",
  "            if (annotations.size == 0) then { return false }",
  "            findAnnotation(self, \"confidential\")",
  "        }",
  "        method isPublic { isConfidential.not }",
  "        method isWritable { false }",
  "        method isReadable { isPublic }",
  "        method usesAsType(aNode) {",
  "            aNode == dtype",
  "        }",
  "        method returnsObject {",
  "            body.isEmpty.not && {body.last.returnsObject}",
  "        }",
  "        method returnedObjectScope {",
  "            // precondition: returnsObject",
  "            body.last.returnedObjectScope",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitMethod(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.value.accept(visitor) from(newChain)",
  "                if (false != typeParams) then {",
  "                    typeParams.accept(visitor) from(newChain)",
  "                }",
  "                for (self.signature) do { part ->",
  "                    for (part.params) do { p ->",
  "                        p.accept(visitor) from(newChain)",
  "                    }",
  "                }",
  "                if (false != dtype) then {",
  "                    dtype.accept(visitor) from(newChain)",
  "                }",
  "                for (self.annotations) do { ann ->",
  "                    ann.accept(visitor) from(newChain)",
  "                }",
  "                for (self.body) do { mx ->",
  "                    mx.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as){",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.body := listMap(body, blk) ancestors(newChain)",
  "            n.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "            n.signature := listMap(signature, blk) ancestors(newChain)",
  "            n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "            n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth) ++ \"\\n\"",
  "            s := s ++ spc ++ \"Name: \" ++ value.pretty(depth+1) ++ \"\\n\"",
  "            if (false != self.dtype) then {",
  "                s := s ++ spc ++ \"Returns:\\n\" ++ spc ++ \"  \"",
  "                s := s ++ self.dtype.pretty(depth + 2) ++ \"\\n\"",
  "            }",
  "            if (isBindingOccurence.not) then { s := s ++ spc ++ \"Applied\\n\" }",
  "            if (isFresh) then { s := s ++ spc ++ \"Fresh\\n\" }",
  "            s := \"{s}{spc}Signature:\"",
  "            for (signature) do { part ->",
  "                s := \"{s}\\n  {spc}Part: {part.name}\"",
  "                s := \"{s}\\n    {spc}Parameters:\"",
  "                for (part.params) do { p ->",
  "                    s := \"{s}\\n      {spc}{p.pretty(depth + 4)}\"",
  "                }",
  "            }",
  "            s := s ++ \"\\n\"",
  "            if (false != typeParams) then {",
  "                s := \"{s}{spc}Generics:\"",
  "                typeParams.do {g->",
  "                    s := \"{s}\\n{spc}  {g.pretty(0)}\"",
  "                }",
  "                s := s ++ \"\\n\"",
  "            }",
  "            if (annotations.size > 0) then {",
  "                s := \"{s}{spc}Annotations:\"",
  "                for (annotations) do {an->",
  "                    s := \"{s}\\n{spc}  {an.pretty(depth + 2)}\"",
  "                }",
  "                s := s ++ \"\\n\"",
  "            }",
  "            s := s ++ spc ++ \"Body:\"",
  "            for (self.body) do { mx ->",
  "                s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "            }",
  "            if (false != comments) then {",
  "                s := s ++ comments.pretty(depth+2)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var spc := \"\"",
  "            for (0..(depth - 1)) do { i ->",
  "                spc := spc ++ \"    \"",
  "            }",
  "            var s := \"method \"",
  "            var firstPart := true",
  "            for (self.signature) do { part ->",
  "                s := s ++ part.name",
  "                if (firstPart && {false != typeParams}) then {",
  "                    s := s ++ typeParams.toGrace(depth + 1)",
  "                }",
  "                firstPart := false",
  "                if (part.params.size > 0) then {",
  "                    s := s ++ \"(\"",
  "                    for (part.params.indices) do { pnr ->",
  "                        var p := part.params.at(pnr)",
  "                        s := s ++ p.toGrace(depth + 1)",
  "                        if (pnr < part.params.size) then {",
  "                            s := s ++ \", \"",
  "                        }",
  "                    }",
  "                    s := s ++ \")\"",
  "                }",
  "            }",
  "            if (false != self.dtype) then {",
  "                s := s ++ \" -> {self.dtype.toGrace(0)}\"",
  "            }",
  "            if (self.annotations.size > 0) then {",
  "                s := s ++ \" is \"",
  "                s := s ++ self.annotations.fold{ a,b ->",
  "                    if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) }",
  "                        startingWith \"\"",
  "            }",
  "            s := s ++ \" \\{\"",
  "            if (false != comments) then {",
  "                s := s ++ comments.toGrace(depth + 1)",
  "            }",
  "            for (self.body) do { mx ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "            }",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            methodNode.new(signature, body, dtype).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            isFresh := other.isFresh",
  "            selfclosure := other.selfclosure",
  "            if (other.isBindingOccurence.not) then {",
  "                self.appliedOccurence",
  "            }",
  "            self",
  "        }",
  "    }",
  "}",
  "def callNode = object {",
  "    method new(receiver, parts) scope(s) {",
  "        def result = new(receiver, parts)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class new(receiver', parts) {",
  "        // requested as callNode.new(receiver':AstNode, parts:List)",
  "        // Represents a method request with arguments.",
  "        // The argument list is in `with`, as a sequence of `requestPart`s.",
  "",
  "        inherits baseNode",
  "        def kind is public = \"call\"",
  "        var with is public := parts            // [ argument parts ]",
  "        var generics is public := false",
  "        var isPattern is public := false",
  "        var receiver is public := receiver'    // formerly `value`",
  "        var isSelfRequest is public := false",
  "",
  "        method onSelf {",
  "            // mark as a self-request.  Answers self for chaining.",
  "            isSelfRequest := true",
  "            self",
  "        }",
  "",
  "        method nameString {",
  "            // the name of the method being requested, in numeric form",
  "            with.fold { acc, each -> acc ++ each.nameString } startingWith \"\"",
  "        }",
  "",
  "        method canonicalName {",
  "            // the name of the method being requested, in underscore form",
  "            with.fold { acc, each -> acc ++ each.canonicalName }",
  "                startingWith \"\"",
  "        }",
  "",
  "        method isCall { true }",
  "        method returnsObject {",
  "            // we recognize two special calls as returning a fresh object",
  "            // self.copy, and prelude.clone(_)",
  "            if ((receiver.isImplicit || receiver.isPrelude) &&",
  "                  (nameString == \"clone(1)\")) then {return true}",
  "            if ((receiver.isImplicit || receiver.isSelf) &&",
  "                  (nameString == \"copy\")) then {return true}",
  "            return false",
  "        }",
  "        method returnedObjectScope {",
  "            // precondition: returnsObject",
  "            self.scope",
  "        }",
  "        method arguments {",
  "            def result = [ ]",
  "            for (self.with) do { part ->",
  "                for (part.args) do { arg -> result.push(arg) }",
  "            }",
  "            result",
  "        }",
  "",
  "        method argumentsDo(action) {",
  "            for (self.with) do { part ->",
  "                for (part.args) do { arg -> action.apply(arg) }",
  "            }",
  "        }",
  "",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitCall(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.receiver.accept(visitor) from(newChain)",
  "                for (self.with) do { part ->",
  "                    for (part.args) do { arg ->",
  "                        arg.accept(visitor) from(newChain)",
  "                    }",
  "                }",
  "                if (false != generics) then {",
  "                    generics.do { each ->",
  "                        each.accept(visitor) from(newChain)",
  "                    }",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.receiver := receiver.map(blk) ancestors(newChain)",
  "            n.with := listMap(with, blk) ancestors(newChain)",
  "            n.generics := maybeListMap(generics, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth)",
  "            s := s ++ if (isSelfRequest) then { \" on self\\n\" } else { \"\\n\" }",
  "            s := s ++ spc ++ \"Receiver: {receiver.pretty(depth + 1)}\\n\"",
  "            s := s ++ spc ++ \"Method Name: {nameString}\\n\"",
  "            if (false != generics) then {",
  "                s := s ++ spc ++ \"  Generics:\\n\"",
  "                for (generics) do {g->",
  "                    s := s ++ spc ++ \"    \" ++ g.pretty(depth + 2) ++ \"\\n\"",
  "                }",
  "            }",
  "            s := s ++ spc ++ \"Arguments:\"",
  "            for (self.with) do { part ->",
  "                s := s ++ \"\\n  \" ++ spc ++ \"Part: \" ++ part.name",
  "                for (part.args) do { arg ->",
  "                    s := s ++ \"\\n      \" ++ spc ++ arg.pretty(depth + 2)",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s := \"\"",
  "            if (receiver.isImplicit.not) then {",
  "                if (receiver.isSimple) then {",
  "                    s := \"{receiver.toGrace (depth + 1)}.\"",
  "                } else {",
  "                    s := \"({receiver.toGrace (depth + 1)}).\"",
  "                }",
  "            }",
  "            with.do { part -> s := s ++ part.toGrace(depth + 1) }",
  "                separatedBy { s := s ++ \" \" }",
  "            s",
  "        }",
  "        method asIdentifier {",
  "            // make and return an identifiderNode for my request",
  "            if (fakeSymbolTable == scope) then {",
  "                ProgrammingError.raise \"asIdentifier requested on {pretty 0} when scope was fake\"",
  "            }",
  "            def resultNode = identifierNode.new (nameString, false) scope (scope)",
  "            resultNode.inRequest := true",
  "            resultNode.line := line",
  "            resultNode.linePos := linePos",
  "            return resultNode",
  "        }",
  "        method asString { \"call {receiver.pretty(0)}\" }",
  "        method shallowCopy {",
  "            callNode.new(receiver, with).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            isPattern := other.isPattern",
  "            isSelfRequest := other.isSelfRequest",
  "            self",
  "        }",
  "        method statementName { \"request\" }",
  "    }",
  "}",
  "def moduleNode = object {",
  "    method body(b) named(n) scope(s) {",
  "        def result = body(b)",
  "        result.name := n",
  "        result.scope := s",
  "        result",
  "    }",
  "    method body(b) named(n) {",
  "        def result = body(b)",
  "        result.name := n",
  "        result",
  "    }",
  "    class body(b) {",
  "        inherits objectNode.new(b, false)",
  "        def kind is public = \"module\"",
  "        def sourceLines = util.lines",
  "        line := 0       // because the module is always implicit",
  "        linePos := 0",
  "        var imports is public := [ ]",
  "",
  "        method isModule { true }",
  "        method returnsObject { false }",
  "        method externalsDo(action) {",
  "            value.do { o ->",
  "                if (o.isExternal) then { action.apply(o) }",
  "            }",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitModule(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (false != self.superclass) then {",
  "                    self.superclass.accept(visitor) from(newChain)",
  "                }",
  "                for (self.value) do { x ->",
  "                    x.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method shallowCopy {",
  "            moduleNode.body(emptySeq).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            imports := other.imports",
  "            self",
  "        }",
  "    }",
  "}",
  "def objectNode is public = object {",
  "    method body(b) named(n) scope(s) {",
  "        def result = new(b, false)",
  "        result.name := n",
  "        result.scope := s",
  "        result",
  "    }",
  "    method body(b) named(n) {",
  "        body(b) named(n) scope(fakeSymbolTable)",
  "    }",
  "    class new(b, superclass') {",
  "        inherits baseNode",
  "        def kind is public = \"object\"",
  "        var value is public := b",
  "        var superclass is public := superclass'",
  "        var usedTraits is public := [ ]",
  "        var name is public := \"object\"",
  "        var inClass is public := false",
  "        var inTrait is public := false",
  "        var myLocalNames := false",
  "        var annotations is public := [ ]",
  "",
  "        method description -> String {",
  "            if (isTrait) then {",
  "                \"{kind} (trait)\"",
  "            } elseif { inClass } then {",
  "                \"{kind} (class)\"",
  "            } else {",
  "                kind",
  "            }",
  "        }",
  "        method isTrait {",
  "            // answers true if this object qualifies to be a trait, whether",
  "            // or not it was declared with the trait syntax",
  "            if (inTrait) then { return true }",
  "            if (false != superclass) then { return false }",
  "            value.do { each ->",
  "                if (each.isLegalInTrait.not) then { return false }",
  "            }",
  "            return true",
  "        }",
  "",
  "        method localNames -> Set⟦String⟧ {",
  "            // answers the names of all of the methods defined directly in",
  "            // this object.  Inherited names are _not_ included.",
  "            if (false == myLocalNames) then {",
  "                myLocalNames := emptySet",
  "                value.do { node ->",
  "                    if (node.isFieldDec || node.isMethod) then {",
  "                        myLocalNames.add(node.nameString)",
  "                    }",
  "                }",
  "            }",
  "            myLocalNames",
  "        }",
  "",
  "        method parentsDo(action) {",
  "            // iterate over my superclass and my used traits",
  "",
  "            if (false != superclass) then { action.apply(superclass) }",
  "            usedTraits.do { t -> action.apply(t) }",
  "        }",
  "",
  "        method methodsDo(action) {",
  "            // iterate over my method declarations",
  "",
  "            value.do { o ->",
  "                if (o.isMethod) then { action.apply(o) }",
  "            }",
  "        }",
  "",
  "        method executableComponentsDo(action) {",
  "            // iterate over my executable code, including",
  "            // field declarations (since they may have initializers)",
  "            value.do { o ->",
  "                if (o.isExecutable) then { action.apply(o) }",
  "            }",
  "        }",
  "",
  "        method scope:=(st) {",
  "            // sets up the 2-way conection between this node",
  "            // and the symbol table that defines the scope that I open.",
  "            symbolTable := st",
  "            st.node := self",
  "        }",
  "        method body { value }",
  "        method returnsObject { true }",
  "        method returnedObjectScope { scope }",
  "        method canInherit { inTrait.not }   // an object can inherit if not in a trait",
  "        method canUse { true }",
  "        method isObject { true }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitObject(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (false != superclass) then {",
  "                    superclass.accept(visitor) from(newChain)",
  "                }",
  "                usedTraits.do { t -> t.accept(visitor) from(newChain) }",
  "                value.do { x -> x.accept(visitor) from(newChain) }",
  "            }",
  "        }",
  "        method nameString {",
  "            if (name == \"object\") then {",
  "                \"object_on_line_{line}\"",
  "            } else {",
  "                name",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.value := listMap(value, blk) ancestors(newChain)",
  "            n.superclass := maybeMap(superclass, blk) ancestors(newChain)",
  "            n.usedTraits := listMap(usedTraits, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth') {",
  "            var depth := depth'",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth)",
  "            s := \"{s}\\n{spc}Name: {self.name}\"",
  "            if (false != self.superclass) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Superclass: \" ++",
  "                        self.superclass.pretty(depth + 1)",
  "            }",
  "            if (usedTraits.isEmpty.not) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Traits:\"",
  "                usedTraits.do { t ->",
  "                    s := \"{s}\\n{spc}  {t.pretty(depth + 1)}\"",
  "                }",
  "            }",
  "            value.do { x ->",
  "                s := s ++ \"\\n\"++ spc ++ x.pretty(depth + 1)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var spc := \"\"",
  "            for (0..(depth - 1)) do { i ->",
  "                spc := spc ++ \"    \"",
  "            }",
  "            var s := \"object \\{\"",
  "            if (inTrait) then { s := s ++ \"   // trait\" }",
  "            if (inClass) then { s := s ++ \"   // class\" }",
  "            if (false != superclass) then {",
  "                s := s ++ \"\\n\" ++ superclass.toGrace(depth + 1)",
  "            }",
  "            usedTraits.do { t -> s := s ++ \"\\n\" ++ t.toGrace(depth + 1) }",
  "            value.do { x ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ x.toGrace(depth + 1)",
  "            }",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            objectNode.new(emptySeq, false).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            name := other.name",
  "            value := other.value",
  "            superclass := other.superclass",
  "            usedTraits := other.usedTraits",
  "            inClass := other.inClass",
  "            inTrait := other.inTrait",
  "            annotations := other.annotations",
  "            self",
  "        }",
  "        method asString {",
  "            \"object {nameString}\"",
  "        }",
  "    }",
  "}",
  "def arrayNode is public = object {",
  "  class new(values) {",
  "    inherits baseNode",
  "    def kind is public = \"array\"",
  "    var value is public := values",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitArray(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.value) do { ax ->",
  "                ax.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := listMap(value, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { ai ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth)",
  "        for (self.value) do { ax ->",
  "            s := s ++ \"\\n\"++ spc ++ ax.pretty(depth+1)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"[\"",
  "        for (self.value.indices) do { i ->",
  "            s := s ++ self.value.at(i).toGrace(0)",
  "            if (i < self.value.size) then {",
  "                s := s ++ \", \"",
  "            }",
  "        }",
  "        s := s ++ \"]\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        arrayNode.new(emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def memberNode = object {",
  "    method new(request, receiver) scope(s) {",
  "        // Represents a dotted request ‹receiver›.‹request› with no arguments.",
  "        def result = new(request, receiver)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class new(request, receiver') {",
  "        // Represents a dotted request ‹receiver›.‹request› with no arguments.",
  "        inherits baseNode",
  "        def kind is public = \"member\"",
  "        var value is public := request  // NB: value is a String, not an Identifier",
  "        var receiver is public := receiver'",
  "        var generics is public := false",
  "        var isSelfRequest is public := false",
  "",
  "        method onSelf {",
  "            isSelfRequest := true",
  "            self",
  "        }",
  "        method nameString { value }",
  "        method canonicalName { value }",
  "        method isMember { true }",
  "        method isCall { true }",
  "",
  "        method with { emptySeq }",
  "        method arguments { emptySeq }",
  "        method argumentsDo { }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitMember(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (false != generics) then {",
  "                    generics.do { each -> each.accept(visitor) from(newChain) }",
  "                }",
  "                receiver.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "        method isSelfOrOuter {",
  "            if (value ≠ \"outer\") then { return false }",
  "            receiver.isSelfOrOuter",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.receiver := receiver.map(blk) ancestors(newChain)",
  "            n.generics := maybeListMap(generics, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth)",
  "            s := s ++ if (isSelfRequest) then { \" on self \" } else { \" \" }",
  "            s := s ++ \"‹\" ++ self.value ++ \"›\\n\"",
  "            s := s ++ spc ++ receiver.pretty(depth)",
  "            if (false != generics) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"  Generics:\"",
  "                for (generics) do {g->",
  "                    s := s ++ \"\\n\" ++ spc ++ \"    \" ++ g.pretty(0)",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s := \"\"",
  "            if (self.value.substringFrom(1)to(6) == \"prefix\") then {",
  "                s := self.value.substringFrom(7)to(value.size)",
  "                s := s ++ \" \" ++ self.receiver.toGrace(0)",
  "            } else {",
  "                s := self.receiver.toGrace(depth) ++ \".\" ++ self.value",
  "            }",
  "            if (false != generics) then {",
  "                s := s ++ \"<\"",
  "                for (1..(generics.size - 1)) do {ix ->",
  "                    s := s ++ generics.at(ix).toGrace(depth + 1)",
  "                }",
  "                s := s ++ generics.last.toGrace(depth + 1) ++ \">\"",
  "            }",
  "            s",
  "        }",
  "        method asString { \"{receiver}.{value}\" }",
  "        method asIdentifier {",
  "            // make and return an identifiderNode for my request",
  "            if (fakeSymbolTable == scope) then {",
  "                ProgrammingError.raise \"asIdentifier requested on {pretty 0} when scope was fake\"",
  "            }",
  "            def resultNode = identifierNode.new (value, false) scope (scope)",
  "            resultNode.inRequest := true",
  "            resultNode.line := line",
  "            resultNode.linePos := linePos",
  "            return resultNode",
  "        }",
  "        method shallowCopy {",
  "            memberNode.new(nameString, receiver).shallowCopyFieldsFrom(self)",
  "        }",
  "        method statementName { \"expression\" }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            generics := other.generics",
  "            isSelfRequest := other.isSelfRequest",
  "            self",
  "        }",
  "    }",
  "}",
  "def genericNode is public = object {",
  "  class new(base, arguments) {",
  "    // represents an application of a parameterized type to some arguments.",
  "    inherits baseNode",
  "    def kind is public = \"generic\"",
  "    var value is public := base",
  "        // in a generic application, `value` is the applied type",
  "        // e.g. in List⟦Number⟧, value is Identifier‹List›",
  "    var args is public := arguments",
  "    method nameString { value.nameString }",
  "    method asString { toGrace 0 }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitGeneric(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            for (self.args) do { p ->",
  "                p.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.args := listMap(args, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var s := \"{super.pretty(depth)}({value.pretty(depth)})<\"",
  "        args.do { each -> s := s ++ each.pretty(depth+2) }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := nameString ++ \"<\"",
  "        args.do { each -> s := s ++ each.toGrace(0) }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method shallowCopy {",
  "        genericNode.new(value, args).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "",
  "def typeParametersNode is public = object {",
  "  class new(params') {",
  "    inherits baseNode",
  "    def kind is public = \"typeparams\"",
  "    var params is public := params'",
  "    method asString { toGrace 0 }",
  "    method declarationKindWithAncestors(as) { k.typeparam }",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTypeParameters(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            params.do { p ->",
  "                p.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method do(blk) {",
  "        params.do(blk)",
  "    }",
  "    method size { params.size }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.params := listMap(params, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := spc ++ super.pretty(depth) ++ \"<\"",
  "        params.do { each -> s := s ++ each.pretty(depth+2) }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method toGrace(depth:Number) -> String {",
  "        var s := \"<\"",
  "        params.do { each -> s := \"{s}{each.toGrace(depth)}\" }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method shallowCopy {",
  "        typeParametersNode.new(emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def identifierNode = object {",
  "",
  "    method new(name, dtype) scope(s) {",
  "        def result = new(name, dtype)",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    class new(name, dtype') {",
  "        inherits baseNode",
  "        def kind is public = \"identifier\"",
  "        var value is public := name",
  "        var wildcard is public := false",
  "        var dtype is public := dtype'",
  "        var isBindingOccurrence is public := false",
  "        var isAssigned is public := false",
  "        var inRequest is public := false",
  "        var generics is public := false",
  "        var isDeclaredByParent is public := false",
  "",
  "        method nameString { value }",
  "        var canonicalName is public := value",
  "        method quoted { value.quoted }",
  "        method isIdentifier { true }",
  "",
  "        method isSelf { \"self\" == value }",
  "        method isSuper { \"super\" == value }",
  "        method isPrelude { \"prelude\" == value }",
  "        method isOuter { \"outer\" == value }",
  "        method isSelfOrOuter {",
  "            if (isSelf) then { return true }",
  "            if (isOuter) then { return true }",
  "            return false",
  "        }",
  "        method isAppliedOccurenceOfIdentifier {",
  "            if (wildcard) then {",
  "                false",
  "            } else {",
  "                isBindingOccurrence.not",
  "            }",
  "        }",
  "        method declarationKindWithAncestors(as) {",
  "            as.parent.declarationKindWithAncestors(as)",
  "        }",
  "        method inTypePositionWithAncestors(as) {",
  "            // am I used by my parent node as a type?",
  "            // This is a hack, used as a subsitute for having information in the .gct",
  "            // telling us which identifiers represent types",
  "            if (as.isEmpty) then { return false }",
  "            as.parent.usesAsType(self)",
  "        }",
  "        method usesAsType(aNode) {",
  "            aNode == dtype",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitIdentifier(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (false != self.dtype) then {",
  "                    self.dtype.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth)",
  "            if ( wildcard ) then {",
  "                s := s ++ \" Wildcard\"",
  "            } elseif { isBindingOccurrence } then {",
  "                s := s ++ \"Binding‹{value}›\"",
  "            } else {",
  "                s := s ++ \"‹{value}›\"",
  "            }",
  "            if (false != self.dtype) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"  Type: \"",
  "                s := s ++ self.dtype.pretty(depth + 2)",
  "            }",
  "            if (false != generics) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Generics:\"",
  "                for (generics) do {g->",
  "                    s := s ++ \"\\n\" ++ spc ++ \"  \" ++ g.pretty(depth + 2)",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s",
  "            if(self.wildcard) then {",
  "                s := \"_\"",
  "            } else {",
  "                s := self.value",
  "            }",
  "            if (false != self.dtype) then {",
  "                s := s ++ \" : \" ++ self.dtype.toGrace(depth + 1)",
  "            }",
  "            if (false != generics) then {",
  "                s := s ++ \"<\"",
  "                for (1..(generics.size - 1)) do {ix ->",
  "                    s := s ++ generics.at(ix).toGrace(depth + 1)",
  "                }",
  "                s := s ++ generics.last.toGrace(depth + 1) ++ \">\"",
  "            }",
  "            s",
  "        }",
  "",
  "        method asString {",
  "            if (isBindingOccurrence) then {",
  "                \"identifierBinding‹{value}›\"",
  "            } else {",
  "                \"identifier‹{value}›\"",
  "            }",
  "        }",
  "        method shallowCopy {",
  "            identifierNode.new(value, false).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            wildcard := other.wildcard",
  "            isBindingOccurrence := other.isBindingOccurrence",
  "            isDeclaredByParent := other.isDeclaredByParent",
  "            isAssigned := other.isAssigned",
  "            inRequest := other.inRequest",
  "            self",
  "        }",
  "        method statementName { \"expression\" }",
  "    }",
  "}",
  "",
  "def typeType is public = identifierNode.new(\"Type\", false)",
  "def unknownType is public = identifierNode.new(\"Unknown\", typeType)",
  "",
  "def stringNode = object {",
  "    method new(v) scope(s) {",
  "        def result = new(v)",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    class new(v) {",
  "        inherits baseNode",
  "        def kind is public = \"string\"",
  "        var value is public := v",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            visitor.visitString(self) up(as)",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            \"{super.pretty(depth)}({self.value})\"",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            def q = \"\\\"\"",
  "            q ++ value.quoted ++ q",
  "        }",
  "        method asString { \"string {toGrace 0}\" }",
  "        method shallowCopy {",
  "            stringNode.new(value).shallowCopyFieldsFrom(self)",
  "        }",
  "        method statementName { \"expression\" }",
  "        method isDelimited { true }",
  "    }",
  "}",
  "def numNode is public = object {",
  "    class new(val) {",
  "        inherits baseNode",
  "        def kind is public = \"num\"",
  "        var value is public := val",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            visitor.visitNum(self) up(as)",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            \"{super.pretty(depth)}({self.value})\"",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            self.value.asString",
  "        }",
  "        method asString { \"num {value}\" }",
  "        method shallowCopy {",
  "            numNode.new(value).shallowCopyFieldsFrom(self)",
  "        }",
  "        method statementName { \"expression\" }",
  "        method isDelimited { true }",
  "    }",
  "}",
  "def opNode is public = object {",
  "  class new(op, l, r) {",
  "    inherits baseNode",
  "    def kind is public = \"op\"",
  "    def value is public = op     // a String",
  "    var left is public := l",
  "    var right is public := r",
  "    method isSimple { false }    // needs parens when used as reciever",
  "    method nameString { value ++ \"(1)\" }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitOp(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.left.accept(visitor) from(newChain)",
  "            self.right.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.left := left.map(blk) ancestors(newChain)",
  "        n.right := right.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}‹\" ++ self.nameString ++ \"›\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.left.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.right.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        if ((self.left.kind == \"op\") && {self.left.value != self.value}) then {",
  "            s := \"(\" ++ self.left.toGrace(0) ++ \")\"",
  "        } else {",
  "            s := self.left.toGrace(0)",
  "        }",
  "        if (self.value == \"..\") then {",
  "            s := s ++ self.value",
  "        } else {",
  "            s := s ++ \" \" ++ self.value ++ \" \"",
  "        }",
  "        if ((self.right.kind == \"op\") && {self.right.value != self.value}) then {",
  "            s := s ++ \"(\" ++ self.right.toGrace(0) ++ \")\"",
  "        } else {",
  "            s := s ++ self.right.toGrace(0)",
  "        }",
  "        s",
  "    }",
  "    method asIdentifier {",
  "        // make an identifiderNode with the same properties as me",
  "        def resultNode = identifierNode.new (nameString, false) scope (scope)",
  "        resultNode.inRequest := true",
  "        resultNode.line := line",
  "        resultNode.linePos := linePos",
  "        return resultNode",
  "    }",
  "    method shallowCopy {",
  "        opNode.new(value, nullNode, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def bindNode is public = object {",
  "  class new(dest', val') {",
  "    // an assignment, or a request of a setter-method",
  "    inherits baseNode",
  "    def kind is public = \"bind\"",
  "    var dest is public := dest'",
  "    var value is public := val'",
  "",
  "    method nameString { value ++ \":=(1)\" }",
  "    method canonicalName { value ++ \":=(_)\" }",
  "    method isBind { true }",
  "    method asString { \"bind {value}\" }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitBind(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.dest.accept(visitor) from(newChain)",
  "            self.value.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.dest := dest.map(blk) ancestors(newChain)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.dest.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := self.dest.toGrace(depth + 1)",
  "        s := s ++ \" := \" ++ self.value.toGrace(depth + 1)",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        bindNode.new(dest, value).shallowCopyFieldsFrom(self)",
  "    }",
  "    method statementName { \"assignment or assigment request\" }",
  "  }",
  "}",
  "def defDecNode = object {",
  "    method new(name', val, dtype') scope(s) {",
  "        def result = new(name', val, dtype')",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    class new(name', val, dtype') {",
  "        inherits baseNode",
  "        def kind is public = \"defdec\"",
  "        var name is public := name'",
  "        var value is public := val",
  "        var dtype is public := dtype'",
  "        def nameString is public = name.nameString",
  "        var annotations is public := [ ]",
  "        var startToken is public := false",
  "",
  "        method isPublic {",
  "            // defs are confidential by default",
  "            if (annotations.size == 0) then { return false }",
  "            if (findAnnotation(self, \"public\")) then { return true }",
  "            findAnnotation(self, \"readable\")",
  "        }",
  "        method isFieldDec { true }",
  "        method isWritable { false }",
  "        method isReadable { isPublic }",
  "",
  "        method returnsObject {",
  "            value.returnsObject",
  "        }",
  "        method returnedObjectScope {",
  "            // precondition: returnsObject",
  "            value.returnedObjectScope",
  "        }",
  "        method usesAsType(aNode) {",
  "            aNode == dtype",
  "        }",
  "        method declarationKindWithAncestors(as) { k.defdec }",
  "",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitDefDec(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.name.accept(visitor) from(newChain)",
  "                if (false != self.dtype) then {",
  "                    self.dtype.accept(visitor) from(newChain)",
  "                }",
  "                for (self.annotations) do { ann ->",
  "                    ann.accept(visitor) from(newChain)",
  "                }",
  "                value.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.name := name.map(blk) ancestors(newChain)",
  "            n.value := value.map(blk) ancestors(newChain)",
  "            n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "            n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth) ++ \"\\n\"",
  "            s := s ++ spc ++ self.name.pretty(depth)",
  "            if (false != dtype) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Type: \" ++ self.dtype.pretty(depth + 2)",
  "            }",
  "            if (false != value) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Value: \" ++ value.pretty(depth + 2)",
  "            }",
  "            if (annotations.isEmpty.not) then {",
  "                s := s ++ \"\\n{spc}Annotations:\"",
  "                annotations.do { ann ->",
  "                    s := \"{s} {ann.pretty(depth + 2)}\"",
  "                }",
  "            }",
  "            if (false != comments) then {",
  "                s := s ++ comments.pretty(depth+2)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var spc := \"\"",
  "            for (0..(depth - 1)) do { i ->",
  "                spc := spc ++ \"    \"",
  "            }",
  "            var s := \"def {self.name.toGrace(0)}\"",
  "            if ( (false != self.dtype) && {",
  "                    self.dtype.value != \"Unknown\" }) then {",
  "                s := s ++ \" : \" ++ self.dtype.toGrace(0)",
  "            }",
  "            if (self.annotations.size > 0) then {",
  "                s := s ++ \" is \"",
  "                s := s ++ self.annotations.fold{ a,b ->",
  "                    if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) }",
  "                        startingWith \"\"",
  "            }",
  "            if (false != self.value) then {",
  "                s := s ++ \" = \" ++ self.value.toGrace(depth)",
  "            }",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            defDecNode.new(name, value, dtype).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            startToken := other.startToken",
  "            self",
  "        }",
  "        method statementName { \"definition\" }",
  "    }",
  "}",
  "def varDecNode is public = object {",
  "  class new(name', val', dtype') {",
  "    inherits baseNode",
  "    def kind is public = \"vardec\"",
  "    var name is public := name'",
  "    var value is public := val'",
  "    var dtype is public := dtype'",
  "    def nameString is public = name.value",
  "    var annotations is public := [ ]",
  "",
  "    method isPublic {",
  "        // vars are confidential by default",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        findAnnotation(self, \"readable\")",
  "    }",
  "    method isWritable {",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        if (findAnnotation(self, \"writable\")) then { return true }",
  "        false",
  "    }",
  "    method isReadable {",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        if (findAnnotation(self, \"readable\")) then { return true }",
  "        false",
  "    }",
  "    method isFieldDec { true }",
  "",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "",
  "    method declarationKindWithAncestors(as) { k.vardec }",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitVarDec(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.name.accept(visitor) from(newChain)",
  "            if (false != self.dtype) then {",
  "                self.dtype.accept(visitor) from(newChain)",
  "            }",
  "            for (self.annotations) do { ann ->",
  "                ann.accept(visitor) from(newChain)",
  "            }",
  "            if (false != self.value) then {",
  "                self.value.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.name := name.map(blk) ancestors(newChain)",
  "        n.value := maybeMap(value, blk) ancestors(newChain)",
  "        n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for ((0..depth)) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth + 1)",
  "        if (false != self.dtype) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Type: \"",
  "            s := s ++ self.dtype.pretty(depth + 2)",
  "        }",
  "        if (false != self.value) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Value: \"",
  "            s := s ++ self.value.pretty(depth + 2)",
  "        }",
  "        if (false != comments) then {",
  "            s := s ++ comments.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        repeat (depth) times {",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"var {self.name.toGrace(0)}\"",
  "        if ( (false != self.dtype) && {",
  "                self.dtype.value != \"Unknown\" }) then {",
  "            s := s ++ \" : \" ++ self.dtype.toGrace(0)",
  "        }",
  "        if (self.annotations.size > 0) then {",
  "            s := s ++ \" is \"",
  "            s := s ++ self.annotations.fold{ a,b ->",
  "                if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) }",
  "                    startingWith \"\"",
  "        }",
  "        if (false != self.value) then {",
  "            s := s ++ \" := \" ++ self.value.toGrace(depth)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        varDecNode.new(name, value, dtype).shallowCopyFieldsFrom(self)",
  "    }",
  "    method statementName { \"variable declaration\" }",
  "",
  "  }",
  "}",
  "def importNode is public = object {",
  "  class new(path', name', dtype') {",
  "    inherits baseNode",
  "    def kind is public = \"import\"",
  "    var value is public := name'",
  "    var path is public := path'",
  "    var annotations is public := [ ]",
  "    var dtype is public := dtype'",
  "    method isImport { true }",
  "    method isExternal { true }",
  "    method isExecutable { false }",
  "    method name { value }",
  "    method nameString { value.nameString }",
  "    method isPublic {",
  "        // imports, like defs, are confidential by default",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        findAnnotation(self, \"readable\")",
  "    }",
  "    method moduleName {",
  "        var bnm := \"\"",
  "        for (path) do {c->",
  "            if (c == \"/\") then {",
  "                bnm := \"\"",
  "            } else {",
  "                bnm := bnm ++ c",
  "            }",
  "        }",
  "        bnm",
  "    }",
  "    method isWritable { false }",
  "    method isReadable { isPublic }",
  "    method declarationKindWithAncestors(as) { k.defdec }",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitImport(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.annotations) do { ann ->",
  "                ann.accept(visitor) from(newChain)",
  "            }",
  "            self.value.accept(visitor) from(newChain)",
  "            if (false != self.dtype) then {",
  "                self.dtype.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ \"{spc}Path: {path}\\n\"",
  "        s := s ++ \"{spc}Identifier: {value}\\n\"",
  "        if (annotations.size > 0) then {",
  "            s := s ++ \"{spc}Anotations: {annotations}\\n\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"import \\\"{self.path}\\\" as {nameString}\"",
  "    }",
  "    method shallowCopy {",
  "        importNode.new(path, nullNode, false).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def dialectNode is public = object {",
  "  class new(path') {",
  "    inherits baseNode",
  "    def kind is public = \"dialect\"",
  "    var value is public := path'",
  "",
  "    method isDialect { true }",
  "    method isExternal { true }",
  "    method isExecutable { false }",
  "    method moduleName {",
  "        var bnm := \"\"",
  "        for (value) do {c->",
  "            if (c == \"/\") then {",
  "                bnm := \"\"",
  "            } else {",
  "                bnm := bnm ++ c",
  "            }",
  "        }",
  "        bnm",
  "    }",
  "    method path {",
  "        value",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        visitor.visitDialect(self) up(as)",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ \"{spc}Path: {self.value}\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"dialect \\\"{self.value}\\\"\"",
  "    }",
  "    method shallowCopy {",
  "        dialectNode.new(value).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def returnNode is public = object {",
  "  class new(expr) {",
  "    inherits baseNode",
  "    def kind is public = \"return\"",
  "    var value is public := expr",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitReturn(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"return \" ++ self.value.toGrace(depth)",
  "    }",
  "    method shallowCopy {",
  "        returnNode.new(nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def inheritsNode = object {",
  "    method new(expr) scope(s) {",
  "        def result = new(expr)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class new(expr) {",
  "        inherits baseNode",
  "        def kind is public = \"inherits\"",
  "        var value is public := expr",
  "        var providedNames is public := emptySet",
  "        var aliases is public := [ ]",
  "        var exclusions is public := [ ]",
  "        var isUse is public := false  // this is a `use trait` clause, not an inherits",
  "",
  "        method isLegalInTrait { isUse }",
  "        method isInherits { true }",
  "        method inheritsFromMember { value.isMember }",
  "        method inheritsFromCall { value.isCall }",
  "        method isExecutable { false }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitInherits(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                value.accept(visitor) from(newChain)",
  "                aliases.do { a ->",
  "                    a.newName.accept(visitor) from(newChain)",
  "                    a.oldName.accept(visitor) from(newChain)",
  "                }",
  "                exclusions.do { e -> e.accept(visitor) from(newChain) }",
  "            }",
  "        }",
  "        method declarationKindWithAncestors(as) {",
  "            // identifiers declared in an inherits statement are aliases for",
  "            // methods.  We treat them as methods, because (unlike inherited names)",
  "            // they can't be overridden by local methods.",
  "            k.methdec",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.value := value.map(blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth)",
  "            if (isUse) then { s := \"{s} (use)\" }",
  "            s := s ++ \"\\n\" ++ spc ++ self.value.pretty(depth + 1)",
  "            aliases.do { a ->",
  "                s := \"{s}\\n{a.pretty(depth)}\"",
  "            }",
  "            if (exclusions.isEmpty.not) then { s := \"{s}\\n{spc}\" }",
  "            exclusions.do { e ->",
  "                s := \"{s} exclude {e} \"",
  "            }",
  "            if (providedNames.isEmpty.not) then {",
  "                s := s ++ \"\\n{spc}Provided names: {providedNames.asList.sort}\"",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s := \"\"",
  "            repeat (depth) times {",
  "                s := s ++ \"    \"",
  "            }",
  "            s := s ++ if (isUse) then { \"use \" } else { \"inherit \" }",
  "            s := s ++ self.value.toGrace(0)",
  "            aliases.do { a ->",
  "                s := \"{s} {a} \"",
  "            }",
  "            exclusions.do { e ->",
  "                s := \"{s} exclude {e.nameString} \"",
  "            }",
  "            s",
  "        }",
  "        method asString {",
  "            if (isUse) then { \"use \" } else { \"inherit \" } ++ value.toGrace 0",
  "        }",
  "        method nameString { value.toGrace(0) }",
  "        method addAlias (newName) for (oldName) {",
  "            aliases.push(aliasNew(newName) old(oldName))",
  "        }",
  "        method addExclusion(ident) {",
  "            exclusions.push(ident)",
  "        }",
  "        method shallowCopy {",
  "            inheritsNode.new(nullNode).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            providedNames := other.providedNames",
  "            aliases := other.aliases",
  "            exclusions := other.exclusions",
  "            isUse := other.isUse",
  "            self",
  "        }",
  "        method statementName {",
  "            if (isUse) then { \"use\" } else { \"inherit\" }",
  "        }",
  "    }",
  "}",
  "type AliasPair = {",
  "    newName",
  "    oldName",
  "}",
  "",
  "class aliasNew(n) old(o) {",
  "    method newName {n}",
  "    method oldName {o}",
  "    method asString { \"alias {n.nameString} = {o.nameString}\" }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        \"{spc}  alias {n.pretty(depth)} = {o.pretty(depth)}\"",
  "    }",
  "    method hash { (n.hash * 1171) + o.hash }",
  "    method isExecutable { false }",
  "    method == (other) {",
  "        match (other)",
  "            case { that:AliasPair -> (n == that.newName) && (o == that.oldName) }",
  "            case { _ -> false }",
  "    }",
  "}",
  "def blankNode is public = object {",
  "    class new {",
  "        inherits baseNode",
  "        def kind is public = \"blank\"",
  "        def value is public = \"blank\"",
  "        method isExecutable { false }",
  "",
  "",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            visitor.visitBlank(self) up(as)",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method nameString { \"\" }",
  "        method asString { \"blank\" }",
  "        method toGrace(depth : Number) -> String { \"\" }",
  "        method shallowCopy {",
  "            blankNode.new.shallowCopyFieldsFrom(self)",
  "        }",
  "    }",
  "}",
  "def signaturePart = object {",
  "    method new {",
  "        partName \"\" params []",
  "    }",
  "    method partName(n) scope(s) {",
  "        def result = partName(n) params []",
  "        result.scope := s",
  "        result",
  "    }",
  "    method partName(n) params(ps) scope(s) {",
  "        def result = partName(n) params(ps)",
  "        result.scope := s",
  "        result",
  "    }",
  "    method partName(n) {",
  "        partName(n) params []",
  "    }",
  "    class partName(n) params(ps) {",
  "        inherits baseNode",
  "        def kind is public = \"signaturepart\"",
  "        var name is public := n",
  "        var params is public := ps",
  "        var typeParams is public := false",
  "        var lineLength is public := 0",
  "",
  "        method nameString {",
  "            if (params.isEmpty) then {return name}",
  "            name ++ \"(\" ++ params.size ++ \")\"",
  "        }",
  "        method numParams { params.size }",
  "        method canonicalName {",
  "            if (params.size == 0) then {return name}",
  "            var underScores := \"\"",
  "            params.do { _ -> underScores := underScores ++ \"_\" }",
  "                separatedBy { underScores := underScores ++ \",\" }",
  "            name ++ \"(\" ++ underScores ++ \")\"",
  "        }",
  "",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitSignaturePart(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                params.do { p -> p.accept(visitor) from(newChain) }",
  "                if (false != typeParams) then {",
  "                    typeParams.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method declarationKindWithAncestors(as) { k.parameter }",
  "        method map(blk) ancestors(as) {",
  "            var nd := shallowCopy",
  "            def newChain = as.extend(nd)",
  "            nd.params := listMap(params, blk) ancestors(newChain)",
  "            nd.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "            blk.apply(nd, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := \"{super.pretty(depth)}: {name}\"",
  "            if (params.isEmpty.not) then { s := \"{s}\\n{spc}Parameters:\" }",
  "            for (params) do { p ->",
  "                s := \"{s}\\n  {spc}{p.pretty(depth + 2)}\"",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth) {",
  "            var s := name",
  "            if (params.isEmpty.not) then {",
  "                s := s ++ \"(\"",
  "                params.do { each -> s := each.toGrace(depth + 1) }",
  "                    separatedBy { s := s ++ \", \" }",
  "                s := s ++ \")\"",
  "            }",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            signaturePart.partName(name) params(params)",
  "                .shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            typeParams := other.typeParams",
  "            lineLength := other.lineLength",
  "            self",
  "        }",
  "        method asString {",
  "            \"part: {nameString}\"",
  "        }",
  "    }",
  "}",
  "",
  "def requestPart = object {",
  "    method new {",
  "        request \"\" withArgs( [] )",
  "    }",
  "    method request(name) withArgs(argList) scope (s) {",
  "        def result = request(name) withArgs(argList)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class request(rPart) withArgs(xs) {",
  "        inherits baseNode",
  "        def kind is public = \"callwithpart\"",
  "        var name is public := rPart",
  "        var args is public := xs",
  "        var typeArgs := emptySeq",
  "        var lineLength is public := 0",
  "",
  "        method nameString {",
  "            if (args.size == 0) then {return name}",
  "            name ++ \"(\" ++ args.size ++ \")\"",
  "        }",
  "",
  "        method canonicalName {",
  "            if (args.size == 0) then {return name}",
  "            var underScores := \"\"",
  "            args.do { _ -> underScores := underScores ++ \"_\" }",
  "                separatedBy { underScores := underScores ++ \",\" }",
  "            name ++ \"(\" ++ underScores ++ \")\"",
  "        }",
  "",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.args := listMap(args, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            repeat (depth+1) times {",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := \"{super.pretty(depth)}: {name}\"",
  "            s := \"{s}\\n    {spc}Args:\"",
  "            for (args) do { a ->",
  "                s := \"{s}\\n    {spc}{a.pretty(depth + 4)}\"",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth) {",
  "            var s := name",
  "            if (typeArgs.size > 0) then {",
  "                s := s ++ \"⟦\"",
  "                typeArgs.do { tArg ->",
  "                    s := s ++ tArg.toGrace(depth + 1)",
  "                } separatedBy { s := s ++ \", \" }",
  "                s := s ++ \"⟧\"",
  "            }",
  "            if (args.size > 0) then {",
  "                def needsParens = (args.size > 1) || (args.first.isDelimited.not)",
  "                s := s ++ if (needsParens) then { \"(\" } else { \" \" }",
  "                args.do { arg ->",
  "                    s := s ++ arg.toGrace(depth)",
  "                } separatedBy {",
  "                    s := s ++ \", \"",
  "                }",
  "                if (needsParens) then { s := s ++ \")\" }",
  "            }",
  "            s",
  "        }",
  "",
  "        method shallowCopy {",
  "            requestPart.request(name) withArgs(args).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            lineLength := other.lineLength",
  "            self",
  "        }",
  "        method statementName { \"request\" }",
  "    }",
  "}",
  "",
  "def commentNode = object {",
  "    class new(val') {",
  "        inherits baseNode",
  "        def kind is public = \"comment\"",
  "        var value is public := val'",
  "        var isPartialLine:Boolean is public := false",
  "        var isPreceededByBlankLine is public := false",
  "        var endLine is public := util.linenum",
  "        method isComment { true }",
  "        method isLegalInTrait { true }",
  "        method isExecutable { false }",
  "        method asString { \"comment ({line}–{endLine}): {value}\" }",
  "        method extendCommentUsing(cmtNode) {",
  "            value := value ++ \" \" ++ cmtNode.value",
  "            endLine := cmtNode.endLine",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            visitor.visitComment(self) up(as)",
  "        }",
  "        method pretty(depth) {",
  "            var s := \"\\n\"",
  "            repeat (depth-1) times {",
  "                s := s ++ \"  \"",
  "            }",
  "            def pb = if (isPreceededByBlankLine) then { \" > blank\" } else { \"\" }",
  "            \"{s}Comment{pb}({line}–{endLine}): ‹{value}›\"",
  "        }",
  "        method toGrace(depth) {",
  "            // Partial line comments don't start with a newline, whereas",
  "            // full-line comments do.  No newline at end in either case.",
  "            if (isPartialLine) then {",
  "                \"// (partial) {value}\"",
  "            } else {",
  "                var spc := \"\"",
  "                repeat (depth) times { spc := spc ++ \"    \" }",
  "                wrap(value) to (lineLength) prefix (spc ++ \"// \")",
  "            }",
  "        }",
  "        method shallowCopy {",
  "            commentNode.new(nullNode).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            value := other.value",
  "            isPartialLine := other.isPartialLine",
  "            endLine := other.endLine",
  "            self",
  "        }",
  "    }",
  "}",
  "",
  "method wrap(str) to (l:Number) prefix (margin) {",
  "    def ind = margin.size",
  "    def len = max(ind + 4, l)",
  "    if ((ind + str.size) <= len) then {",
  "        return \"\\n\" ++ margin ++ str",
  "    }",
  "    var currBreak",
  "    var trimmedLine",
  "",
  "    try {",
  "        currBreak := str.lastIndexOf \" \" startingAt (len - ind)",
  "            ifAbsent {len - ind}",
  "        trimmedLine := str.substringFrom (1) to (currBreak).trim",
  "    } catch { ex:NoSuchMethod ->  // C string libraries lack methods",
  "        currBreak := min(len - ind, str.size)",
  "        (1..currBreak).do { ix ->",
  "            if (str.at(ix) == \" \") then { currBreak := ix }",
  "        }",
  "        var end := currBreak",
  "        while {(end >= 1) && {str.at(end) == \" \"}} do {",
  "            end := end - 1",
  "        }",
  "        var start := 1",
  "        while {(start <= str.size) && {str.at(start) == \" \"}} do {",
  "            start := start + 1",
  "        }",
  "        trimmedLine := str.substringFrom (start) to (end)",
  "    }",
  "    \"\\n\" ++ margin ++ trimmedLine ++",
  "        wrap(str.substringFrom (currBreak+1) to (str.size))",
  "            to (l) prefix (margin)",
  "}",
  "",
  "",
  "type ASTVisitor = {",
  "    visitIf(o) up(as) -> Boolean",
  "    visitBlock(o) up(as) -> Boolean",
  "    visitMatchCase(o) up(as) -> Boolean",
  "    visitTryCatch(o) up(as) -> Boolean",
  "    visitMethodType(o) up(as) -> Boolean",
  "    visitSignaturePart(o) up(as) -> Boolean",
  "    visitTypeLiteral(o) up(as) -> Boolean",
  "    visitTypeParameters(o) up(as) -> Boolean",
  "    visitTypeDec(o) up(as) -> Boolean",
  "    visitMethod(o) up(as) -> Boolean",
  "    visitCall(o) up(as) -> Boolean",
  "    visitObject(o) up(as) -> Boolean",
  "    visitModule(o) up(as) -> Boolean",
  "    visitArray(o) up(as) -> Boolean",
  "    visitMember(o) up(as) -> Boolean",
  "    visitGeneric(o) up(as) -> Boolean",
  "    visitIdentifier(o) up(as) -> Boolean",
  "    visitString(o) up(as) -> Boolean",
  "    visitNum(o) up(as) -> Boolean",
  "    visitOp(o) up(as) -> Boolean",
  "    visitBind(o) up(as) -> Boolean",
  "    visitDefDec(o) up(as) -> Boolean",
  "    visitVarDec(o) up(as) -> Boolean",
  "    visitImport(o) up(as) -> Boolean",
  "    visitReturn(o) up(as) -> Boolean",
  "    visitInherits(o) up(as) -> Boolean",
  "    visitDialect(o) up(as) -> Boolean",
  "    visitBlank(o) up(as) -> Boolean",
  "    visitComment(o) up(as) -> Boolean",
  "    visitImplicit(o) up(as) -> Boolean",
  "}",
  "",
  "class baseVisitor -> ASTVisitor {",
  "    method visitIf(o) up(as) { visitIf(o) }",
  "    method visitBlock(o) up(as) { visitBlock(o) }",
  "    method visitMatchCase(o) up(as) { visitMatchCase(o) }",
  "    method visitTryCatch(o) up(as) { visitTryCatch(o) }",
  "    method visitMethodType(o) up(as) { visitMethodType(o) }",
  "    method visitSignaturePart(o) up(as) { visitSignaturePart(o) }",
  "    method visitTypeDec(o) up(as) { visitTypeDec(o) }",
  "    method visitTypeLiteral(o) up(as) { visitTypeLiteral(o) }",
  "    method visitTypeParameters(o) up(as) { visitTypeParameters(o) }",
  "    method visitMethod(o) up(as) { visitMethod(o) }",
  "    method visitCall(o) up(as) { visitCall(o) }",
  "    method visitObject(o) up(as) { visitObject(o) }",
  "    method visitModule(o) up(as) { visitObject(o) }",
  "    method visitArray(o) up(as) { visitArray(o) }",
  "    method visitMember(o) up(as) { visitMember(o) }",
  "    method visitGeneric(o) up(as) { visitGeneric(o) }",
  "    method visitIdentifier(o) up(as) { visitIdentifier(o) }",
  "    method visitString(o) up(as) { visitString(o) }",
  "    method visitNum(o) up(as) { visitNum(o) }",
  "    method visitOp(o) up(as) { visitOp(o) }",
  "    method visitBind(o) up(as) { visitBind(o) }",
  "    method visitDefDec(o) up(as) { visitDefDec(o) }",
  "    method visitVarDec(o) up(as) { visitVarDec(o) }",
  "    method visitImport(o) up(as) { visitImport(o) }",
  "    method visitReturn(o) up(as) { visitReturn(o) }",
  "    method visitInherits(o) up(as) { visitInherits(o) }",
  "    method visitDialect(o) up(as) { visitDialect(o) }",
  "    method visitBlank(o) up(as) { visitBlank(o) }",
  "    method visitComment(o) up(as) { visitComment(o) }",
  "    method visitImplicit(o) up(as) { visitImplicit(o) }",
  "",
  "    method visitIf(o) -> Boolean { true }",
  "    method visitBlock(o) -> Boolean { true }",
  "    method visitMatchCase(o) -> Boolean { true }",
  "    method visitTryCatch(o) -> Boolean { true }",
  "    method visitMethodType(o) -> Boolean { true }",
  "    method visitSignaturePart(o) -> Boolean { true }",
  "    method visitTypeDec(o) -> Boolean { true }",
  "    method visitTypeLiteral(o) -> Boolean { true }",
  "    method visitTypeParameters(o) -> Boolean { true }",
  "    method visitMethod(o) -> Boolean { true }",
  "    method visitCall(o) -> Boolean { true }",
  "    method visitObject(o) -> Boolean { true }",
  "    method visitModule(o) -> Boolean { true }",
  "    method visitArray(o) -> Boolean { true }",
  "    method visitMember(o) -> Boolean { true }",
  "    method visitGeneric(o) -> Boolean { true }",
  "    method visitIdentifier(o) -> Boolean { true }",
  "    method visitString(o) -> Boolean { true }",
  "    method visitNum(o) -> Boolean { true }",
  "    method visitOp(o) -> Boolean { true }",
  "    method visitBind(o) -> Boolean { true }",
  "    method visitDefDec(o) -> Boolean { true }",
  "    method visitVarDec(o) -> Boolean { true }",
  "    method visitImport(o) -> Boolean { true }",
  "    method visitReturn(o) -> Boolean { true }",
  "    method visitInherits(o) -> Boolean { true }",
  "    method visitDialect(o) -> Boolean { true }",
  "    method visitBlank(o) -> Boolean { true }",
  "    method visitComment(o) -> Boolean { true }",
  "    method visitImplicit(o) -> Boolean { true }",
  "",
  "    method asString { \"an AST visitor\" }",
  "}",
  "",
  "class pluggableVisitor(visitation:Block2) -> ASTVisitor {",
  "    // Manufactures a default visitor, given a 2-parameter block.",
  "    // Typically, some of the methods will be overridden.",
  "    // The block will be applied with the AST node as the first argument",
  "    // and the ancestor chain as the second, and should answer true if",
  "    // the visitation is to continue and false if it is to go no deeper.",
  "",
  "    method visitIf(o) up(as) { visitation.apply (o, as) }",
  "    method visitBlock(o) up(as) { visitation.apply (o, as) }",
  "    method visitMatchCase(o) up(as) { visitation.apply (o, as) }",
  "    method visitTryCatch(o) up(as) { visitation.apply (o, as) }",
  "    method visitMethodType(o) up(as) { visitation.apply (o, as) }",
  "    method visitSignaturePart(o) up(as) { visitation.apply (o, as) }",
  "    method visitTypeDec(o) up(as) { visitation.apply (o, as) }",
  "    method visitTypeLiteral(o) up(as) { visitation.apply (o, as) }",
  "    method visitMethod(o) up(as) { visitation.apply (o, as) }",
  "    method visitCall(o) up(as) { visitation.apply (o, as) }",
  "    method visitObject(o) up(as) { visitation.apply (o, as) }",
  "    method visitModule(o) up(as) { visitation.apply (o, as) }",
  "    method visitArray(o) up(as) { visitation.apply (o, as) }",
  "    method visitMember(o) up(as) { visitation.apply (o, as) }",
  "    method visitGeneric(o) up(as) { visitation.apply (o, as) }",
  "    method visitIdentifier(o) up(as) { visitation.apply (o, as) }",
  "    method visitString(o) up(as) { visitation.apply (o, as) }",
  "    method visitNum(o) up(as) { visitation.apply (o, as) }",
  "    method visitOp(o) up(as) { visitation.apply (o, as) }",
  "    method visitBind(o) up(as) { visitation.apply (o, as) }",
  "    method visitDefDec(o) up(as) { visitation.apply (o, as) }",
  "    method visitVarDec(o) up(as) { visitation.apply (o, as) }",
  "    method visitImport(o) up(as) { visitation.apply (o, as) }",
  "    method visitReturn(o) up(as) { visitation.apply (o, as) }",
  "    method visitInherits(o) up(as) { visitation.apply (o, as) }",
  "    method visitDialect(o) up(as) { visitation.apply (o, as) }",
  "    method visitBlank(o) up(as) { visitation.apply (o, as) }",
  "    method visitComment(o) up(as) { visitation.apply (o, as) }",
  "    method visitImplicit(o) up(as) { visitation.apply (o, as) }",
  "",
  "    method asString { \"a pluggable AST visitor\" }",
  "}",
  "",
  "",
  "def patternMarkVisitor = object {",
  "    inherits baseVisitor",
  "    method visitCall(c) up(as) {",
  "        c.isPattern := true",
  "        true",
  "    }",
  "}",
  "",
  "method findAnnotation(node, annName) {",
  "    for (node.annotations) do {ann->",
  "        if ((ann.kind == \"identifier\") && {",
  "            ann.value == annName }) then {",
  "            return object {",
  "                inherits true",
  "                def value is public = ann",
  "            }",
  "        }",
  "    }",
  "    false",
  "}",
  NULL
};
Object reader_ast_outer_30(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_register_31(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_ast_register_31(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_ast_line_32(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_line_32(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_linePos_33(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_linePos_33(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_symbolTable_34(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_symbolTable_34(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_comments_35(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_comments_35(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_435(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_718(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_874(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_990(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_value_991(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_outer_1005(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1008(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1026(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1083(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1084(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_nameString_1085(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_1115(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1116(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_outer_1131(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_node_1132(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_ast_node_1132(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_ast_outer_1199(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1202(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1203(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1204(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_1204(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_thenblock_1205(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_thenblock_1205(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_elseblock_1206(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_elseblock_1206(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_handledIdentifiers_1207(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_handledIdentifiers_1207(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_1558(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1561(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1562(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1563(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_params_1564(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_params_1564(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_body_1565(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_body_1565(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_selfclosure_1566(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_matchingPattern_1567(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_matchingPattern_1567(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_extraRuntimeData_1568(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_extraRuntimeData_1568(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_outer_2020(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2023(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2024(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_2025(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_2025(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_cases_2026(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_cases_2026(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_finally_2027(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_finally_2027(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_2332(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2335(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2336(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_2337(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_2337(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_cases_2338(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_cases_2338(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_elsecase_2339(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_elsecase_2339(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_2640(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2643(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2644(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_signature_2645(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_signature_2645(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_rtype_2646(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_rtype_2646(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_typeParams_2647(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_typeParams_2647(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_cachedIdentifier_2648(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_cachedIdentifier_2648(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_3023(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3026(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3027(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_methods_3028(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_methods_3028(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_types_3029(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_types_3029(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_nominal_3030(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_nominal_3030(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_anonymous_3031(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_anonymous_3031(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_value_3032(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_value_3032(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_3336(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3339(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3340(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_3341(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_3341(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_3342(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_3342(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_nameString_3343(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_annotations_3344(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_annotations_3344(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_typeParams_3345(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_typeParams_3345(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_3666(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3674(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3675(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_signature_3676(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_signature_3676(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_body_3677(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_body_3677(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_3678(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_3678(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_typeParams_3679(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_typeParams_3679(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_selfclosure_3680(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_selfclosure_3680(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_annotations_3681(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_annotations_3681(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_isFresh_3682(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_isFresh_3682(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_usesClassSyntax_3683(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_usesClassSyntax_3683(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_cachedIdentifier_3684(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[10];
}
Object writer_ast_cachedIdentifier_3684(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[10] = args[0];
  return done;
}
Object reader_ast_isBindingOccurence_3685(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[11];
}
Object writer_ast_isBindingOccurence_3685(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[11] = args[0];
  return done;
}
Object reader_ast_outer_4791(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_4799(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_4800(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_with_4801(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_with_4801(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_generics_4802(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_generics_4802(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_isPattern_4803(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_isPattern_4803(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_receiver_4804(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_receiver_4804(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_isSelfRequest_4805(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_isSelfRequest_4805(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_5327(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5342(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5343(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_sourceLines_5344(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_imports_5345(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_imports_5345(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_5417(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5431(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5432(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5433(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_5433(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_superclass_5434(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_superclass_5434(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_usedTraits_5435(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_usedTraits_5435(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_name_5436(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_name_5436(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_inClass_5437(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_inClass_5437(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_inTrait_5438(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_inTrait_5438(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_myLocalNames_5439(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_myLocalNames_5439(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_annotations_5440(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_annotations_5440(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_outer_6030(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6033(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6034(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6035(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6035(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_6165(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6173(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6174(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6175(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6175(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_receiver_6176(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_receiver_6176(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_generics_6177(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_generics_6177(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_isSelfRequest_6178(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_isSelfRequest_6178(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_6559(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6562(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6563(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6564(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6564(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_args_6565(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_args_6565(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_6720(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6723(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6724(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_params_6725(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_params_6725(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_6883(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6891(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6892(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6893(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6893(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_wildcard_6894(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_wildcard_6894(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_6895(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_6895(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_isBindingOccurrence_6896(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_isBindingOccurrence_6896(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_isAssigned_6897(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_isAssigned_6897(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_inRequest_6898(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_inRequest_6898(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_generics_6899(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_generics_6899(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_isDeclaredByParent_6900(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_isDeclaredByParent_6900(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_canonicalName_6904(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[11];
}
Object writer_ast_canonicalName_6904(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[11] = args[0];
  return done;
}
Object reader_ast_outer_7325(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7333(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7334(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7335(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_7335(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_7411(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7414(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7415(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7416(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_7416(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_7484(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7487(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7488(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7489(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_left_7490(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_left_7490(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_right_7491(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_right_7491(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_7768(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7771(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7772(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_dest_7773(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_dest_7773(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_7774(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_7774(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_7957(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7965(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7966(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_7967(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_7967(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_7968(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_7968(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_7969(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_7969(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_nameString_7970(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_annotations_7971(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_annotations_7971(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_startToken_7972(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_startToken_7972(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_outer_8423(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8426(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8427(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_8428(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_8428(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_8429(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_8429(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_8430(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_8430(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_nameString_8431(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_annotations_8432(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_annotations_8432(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_8881(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8884(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8885(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_8886(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_8886(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_path_8887(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_path_8887(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_annotations_8888(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_annotations_8888(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_dtype_8889(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_dtype_8889(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_9161(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9164(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9165(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9166(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9166(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_9277(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9280(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9281(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9282(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9282(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_9367(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9375(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9376(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9377(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9377(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_providedNames_9378(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_providedNames_9378(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_aliases_9379(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_aliases_9379(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_exclusions_9380(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_exclusions_9380(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_isUse_9381(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_isUse_9381(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_9763(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9766(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9767(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9768(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_9803(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9826(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9827(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_9828(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_9828(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_params_9829(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_params_9829(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_typeParams_9830(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_typeParams_9830(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_lineLength_9831(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_lineLength_9831(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_10143(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_10156(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_10157(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_10158(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_10158(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_args_10159(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_args_10159(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_typeArgs_10160(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_typeArgs_10160(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_lineLength_10161(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_lineLength_10161(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_10479(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_10482(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_10483(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_10484(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_10484(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_isPartialLine_10485(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_isPartialLine_10485(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_isPreceededByBlankLine_10486(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_isPreceededByBlankLine_10486(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_endLine_10487(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_endLine_10487(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_10688(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
static ClassData objclass29;
static Object strlit132;
static Object strlit139;
static Object strlit145;
static Object strlit151;
static Object strlit209;
static Object strlit218;
static Object strlit229;
static Object strlit245;
static Object strlit254;
static Object strlit261;
static Object strlit270;
static Object strlit275;
static Object strlit282;
static Object strlit289;
static Object strlit295;
static Object strlit312;
static Object strlit320;
static Object strlit327;
static Object strlit334;
static Object strlit340;
static Object strlit348;
static Object strlit357;
static Object strlit364;
static Object strlit371;
static Object strlit377;
static Object strlit426;
static ClassData objclass434;
static Object strlit440;
static Object strlit447;
static Object strlit453;
static Object strlit459;
static Object strlit468;
static Object strlit475;
static Object strlit482;
static Object strlit489;
static Object strlit493;
static Object strlit534;
static Object strlit568;
static Object strlit575;
static Object strlit609;
static Object strlit628;
static Object strlit658;
static Object strlit687;
static Object strlit712;
static ClassData objclass717;
static Object strlit870;
static ClassData objclass873;
static Object strlit963;
static Object strlit983;
static ClassData objclass989;
Object module_util;
Object module_util_init();
Object module_identifierKinds;
Object module_identifierKinds_init();
static Object strlit999;
static ClassData objclass1004;
static ClassData objclass1007;
static Object strlit1012;
static ClassData objclass1025;
static Object strlit1037;
static Object strlit1049;
static Object strlit1064;
static ClassData objclass1082;
static Object strlit1089;
static Object strlit1091;
static Object strlit1100;
static Object strlit1111;
static Object strlit1112;
static ClassData objclass1114;
static Object strlit1118;
static Object strlit1120;
static Object strlit1128;
static ClassData objclass1130;
static Object strlit1134;
static Object strlit1138;
static Object strlit1143;
static Object strlit1148;
static Object strlit1154;
static Object strlit1167;
static Object strlit1171;
static Object strlit1180;
static Object strlit1186;
static Object strlit1193;
static ClassData objclass1198;
static ClassData objclass1201;
static Object strlit1254;
static Object strlit1263;
static Object strlit1270;
static Object strlit1291;
static Object strlit1297;
static Object strlit1304;
static Object strlit1316;
static Object strlit1327;
static Object strlit1339;
static Object strlit1349;
static Object strlit1374;
static Object strlit1383;
static Object strlit1388;
static Object strlit1413;
static Object strlit1422;
static Object strlit1427;
static Object strlit1434;
static Object strlit1443;
static Object strlit1462;
static Object strlit1467;
static Object strlit1482;
static Object strlit1487;
static Object strlit1509;
static Object strlit1514;
static Object strlit1524;
static Object strlit1529;
static Object strlit1553;
static ClassData objclass1557;
static ClassData objclass1560;
static Object strlit1714;
static Object strlit1723;
static Object strlit1730;
static Object strlit1736;
static Object strlit1759;
static Object strlit1768;
static Object strlit1773;
static Object strlit1796;
static Object strlit1812;
static Object strlit1817;
static Object strlit1837;
static Object strlit1844;
static Object strlit1849;
static Object strlit1855;
static Object strlit1866;
static Object strlit1889;
static Object strlit1897;
static Object strlit1919;
static Object strlit1924;
static Object strlit1946;
static Object strlit1955;
static Object strlit1967;
static Object strlit1974;
static Object strlit2003;
static Object strlit2004;
static ClassData objclass2019;
static ClassData objclass2022;
static Object strlit2094;
static Object strlit2103;
static Object strlit2110;
static Object strlit2116;
static Object strlit2141;
static Object strlit2152;
static Object strlit2157;
static Object strlit2161;
static Object strlit2182;
static Object strlit2195;
static Object strlit2200;
static Object strlit2204;
static Object strlit2215;
static Object strlit2228;
static Object strlit2235;
static Object strlit2247;
static Object strlit2264;
static Object strlit2267;
static Object strlit2272;
static Object strlit2300;
static Object strlit2303;
static Object strlit2308;
static Object strlit2328;
static ClassData objclass2331;
static ClassData objclass2334;
static Object strlit2409;
static Object strlit2418;
static Object strlit2425;
static Object strlit2452;
static Object strlit2463;
static Object strlit2468;
static Object strlit2472;
static Object strlit2493;
static Object strlit2506;
static Object strlit2511;
static Object strlit2515;
static Object strlit2526;
static Object strlit2539;
static Object strlit2546;
static Object strlit2555;
static Object strlit2572;
static Object strlit2575;
static Object strlit2580;
static Object strlit2608;
static Object strlit2611;
static Object strlit2616;
static Object strlit2636;
static ClassData objclass2639;
static ClassData objclass2642;
static Object strlit2659;
static Object strlit2806;
static Object strlit2815;
static Object strlit2822;
static Object strlit2828;
static Object strlit2835;
static Object strlit2840;
static Object strlit2844;
static Object strlit2860;
static Object strlit2873;
static Object strlit2878;
static Object strlit2883;
static Object strlit2887;
static Object strlit2905;
static Object strlit2910;
static Object strlit2914;
static Object strlit2933;
static Object strlit2938;
static Object strlit2942;
static Object strlit2954;
static Object strlit2965;
static Object strlit2970;
static Object strlit2974;
static Object strlit2985;
static Object strlit3018;
static ClassData objclass3022;
static ClassData objclass3025;
static Object strlit3044;
static Object strlit3051;
static Object strlit3057;
static Object strlit3119;
static Object strlit3128;
static Object strlit3135;
static Object strlit3141;
static Object strlit3145;
static Object strlit3168;
static Object strlit3177;
static Object strlit3182;
static Object strlit3204;
static Object strlit3213;
static Object strlit3218;
static Object strlit3231;
static Object strlit3237;
static Object strlit3239;
static Object strlit3257;
static Object strlit3262;
static Object strlit3285;
static Object strlit3290;
static Object strlit3300;
static Object strlit3329;
static Object strlit3332;
static ClassData objclass3335;
static ClassData objclass3338;
static Object strlit3372;
static Object strlit3462;
static Object strlit3471;
static Object strlit3478;
static Object strlit3484;
static Object strlit3510;
static Object strlit3523;
static Object strlit3528;
static Object strlit3532;
static Object strlit3541;
static Object strlit3561;
static Object strlit3585;
static Object strlit3598;
static Object strlit3604;
static Object strlit3606;
static Object strlit3612;
static Object strlit3639;
static Object strlit3656;
static ClassData objclass3665;
static ClassData objclass3673;
static Object strlit3743;
static Object strlit3808;
static Object strlit3892;
static Object strlit3938;
static Object strlit4110;
static Object strlit4119;
static Object strlit4126;
static Object strlit4132;
static Object strlit4145;
static Object strlit4162;
static Object strlit4167;
static Object strlit4177;
static Object strlit4198;
static Object strlit4209;
static Object strlit4217;
static Object strlit4222;
static Object strlit4226;
static Object strlit4238;
static Object strlit4245;
static Object strlit4250;
static Object strlit4254;
static Object strlit4263;
static Object strlit4268;
static Object strlit4272;
static Object strlit4284;
static Object strlit4295;
static Object strlit4300;
static Object strlit4304;
static Object strlit4317;
static Object strlit4329;
static Object strlit4334;
static Object strlit4338;
static Object strlit4348;
static Object strlit4356;
static Object strlit4361;
static Object strlit4365;
static Object strlit4378;
static Object strlit4392;
static Object strlit4397;
static Object strlit4401;
static Object strlit4413;
static Object strlit4424;
static Object strlit4429;
static Object strlit4433;
static Object strlit4444;
static Object strlit4449;
static Object strlit4472;
static Object strlit4500;
static Object strlit4513;
static Object strlit4519;
static Object strlit4569;
static Object strlit4603;
static Object strlit4610;
static Object strlit4625;
static Object strlit4634;
static Object strlit4650;
static Object strlit4665;
static Object strlit4669;
static Object strlit4672;
static Object strlit4675;
static Object strlit4683;
static Object strlit4720;
static Object strlit4725;
static Object strlit4735;
static Object strlit4740;
static Object strlit4781;
static ClassData objclass4790;
static ClassData objclass4798;
static Object strlit4820;
static Object strlit4834;
static Object strlit4844;
static Object strlit4866;
static Object strlit5000;
static Object strlit5009;
static Object strlit5021;
static Object strlit5022;
static Object strlit5028;
static Object strlit5040;
static Object strlit5051;
static Object strlit5057;
static Object strlit5074;
static Object strlit5087;
static Object strlit5098;
static Object strlit5110;
static Object strlit5127;
static Object strlit5132;
static Object strlit5155;
static Object strlit5166;
static Object strlit5180;
static Object strlit5192;
static Object strlit5197;
static Object strlit5209;
static Object strlit5230;
static Object strlit5247;
static Object strlit5254;
static Object strlit5280;
static Object strlit5289;
static Object strlit5313;
static Object strlit5320;
static ClassData objclass5326;
static ClassData objclass5341;
static Object strlit5404;
static ClassData objclass5416;
static ClassData objclass5430;
static Object strlit5446;
static Object strlit5452;
static Object strlit5459;
static Object strlit5465;
static Object strlit5639;
static Object strlit5645;
static Object strlit5651;
static Object strlit5694;
static Object strlit5703;
static Object strlit5712;
static Object strlit5719;
static Object strlit5724;
static Object strlit5728;
static Object strlit5754;
static Object strlit5759;
static Object strlit5774;
static Object strlit5779;
static Object strlit5789;
static Object strlit5800;
static Object strlit5805;
static Object strlit5809;
static Object strlit5835;
static Object strlit5846;
static Object strlit5859;
static Object strlit5865;
static Object strlit5870;
static Object strlit5878;
static Object strlit5900;
static Object strlit5917;
static Object strlit5938;
static Object strlit5943;
static Object strlit5955;
static Object strlit5960;
static Object strlit6005;
static Object strlit6011;
static Object strlit6020;
static Object strlit6022;
static ClassData objclass6029;
static ClassData objclass6032;
static Object strlit6069;
static Object strlit6078;
static Object strlit6102;
static Object strlit6111;
static Object strlit6139;
static Object strlit6146;
static Object strlit6161;
static ClassData objclass6164;
static ClassData objclass6172;
static Object strlit6225;
static Object strlit6259;
static Object strlit6268;
static Object strlit6280;
static Object strlit6281;
static Object strlit6286;
static Object strlit6293;
static Object strlit6318;
static Object strlit6323;
static Object strlit6340;
static Object strlit6345;
static Object strlit6355;
static Object strlit6358;
static Object strlit6385;
static Object strlit6395;
static Object strlit6412;
static Object strlit6448;
static Object strlit6467;
static Object strlit6474;
static Object strlit6480;
static Object strlit6494;
static Object strlit6501;
static Object strlit6535;
static Object strlit6553;
static ClassData objclass6558;
static ClassData objclass6561;
static Object strlit6619;
static Object strlit6628;
static Object strlit6634;
static Object strlit6656;
static Object strlit6665;
static Object strlit6670;
static Object strlit6689;
static Object strlit6698;
static Object strlit6716;
static ClassData objclass6719;
static ClassData objclass6722;
static Object strlit6776;
static Object strlit6785;
static Object strlit6792;
static Object strlit6817;
static Object strlit6826;
static Object strlit6830;
static Object strlit6835;
static Object strlit6842;
static Object strlit6846;
static Object strlit6856;
static Object strlit6865;
static Object strlit6879;
static ClassData objclass6882;
static ClassData objclass6890;
static Object strlit6917;
static Object strlit6924;
static Object strlit6931;
static Object strlit6938;
static Object strlit7014;
static Object strlit7023;
static Object strlit7035;
static Object strlit7044;
static Object strlit7050;
static Object strlit7058;
static Object strlit7064;
static Object strlit7078;
static Object strlit7083;
static Object strlit7109;
static Object strlit7114;
static Object strlit7134;
static Object strlit7139;
static Object strlit7152;
static Object strlit7175;
static Object strlit7188;
static Object strlit7224;
static Object strlit7246;
static Object strlit7252;
static Object strlit7256;
static Object strlit7262;
static Object strlit7297;
static Object strlit7304;
static Object strlit7316;
static Object strlit7321;
static ClassData objclass7324;
static ClassData objclass7332;
static Object strlit7348;
static Object strlit7355;
static Object strlit7361;
static Object strlit7367;
static Object strlit7380;
static Object strlit7387;
static Object strlit7398;
static Object strlit7407;
static ClassData objclass7410;
static ClassData objclass7413;
static Object strlit7429;
static Object strlit7436;
static Object strlit7442;
static Object strlit7454;
static Object strlit7460;
static Object strlit7471;
static Object strlit7480;
static ClassData objclass7483;
static ClassData objclass7486;
static Object strlit7496;
static Object strlit7535;
static Object strlit7544;
static Object strlit7551;
static Object strlit7558;
static Object strlit7564;
static Object strlit7570;
static Object strlit7590;
static Object strlit7610;
static Object strlit7627;
static Object strlit7636;
static Object strlit7645;
static Object strlit7657;
static Object strlit7669;
static Object strlit7676;
static Object strlit7698;
static Object strlit7707;
static Object strlit7717;
static Object strlit7764;
static ClassData objclass7767;
static ClassData objclass7770;
static Object strlit7777;
static Object strlit7784;
static Object strlit7793;
static Object strlit7799;
static Object strlit7836;
static Object strlit7845;
static Object strlit7852;
static Object strlit7873;
static Object strlit7893;
static Object strlit7906;
static Object strlit7931;
static Object strlit7946;
static Object strlit7953;
static ClassData objclass7956;
static ClassData objclass7964;
static Object strlit7986;
static Object strlit7994;
static Object strlit8100;
static Object strlit8109;
static Object strlit8116;
static Object strlit8150;
static Object strlit8155;
static Object strlit8180;
static Object strlit8185;
static Object strlit8201;
static Object strlit8205;
static Object strlit8215;
static Object strlit8226;
static Object strlit8230;
static Object strlit8260;
static Object strlit8273;
static Object strlit8280;
static Object strlit8289;
static Object strlit8297;
static Object strlit8321;
static Object strlit8336;
static Object strlit8351;
static Object strlit8355;
static Object strlit8358;
static Object strlit8361;
static Object strlit8382;
static Object strlit8406;
static Object strlit8413;
static ClassData objclass8422;
static ClassData objclass8425;
static Object strlit8446;
static Object strlit8454;
static Object strlit8473;
static Object strlit8482;
static Object strlit8503;
static Object strlit8512;
static Object strlit8616;
static Object strlit8625;
static Object strlit8632;
static Object strlit8660;
static Object strlit8665;
static Object strlit8691;
static Object strlit8696;
static Object strlit8734;
static Object strlit8739;
static Object strlit8746;
static Object strlit8755;
static Object strlit8763;
static Object strlit8787;
static Object strlit8802;
static Object strlit8817;
static Object strlit8821;
static Object strlit8824;
static Object strlit8827;
static Object strlit8848;
static Object strlit8865;
static Object strlit8872;
static ClassData objclass8880;
static ClassData objclass8883;
static Object strlit8917;
static Object strlit8925;
static Object strlit8932;
static Object strlit8940;
static Object strlit8943;
static Object strlit9029;
static Object strlit9038;
static Object strlit9045;
static Object strlit9052;
static Object strlit9059;
static Object strlit9063;
static Object strlit9073;
static Object strlit9080;
static Object strlit9084;
static Object strlit9103;
static Object strlit9110;
static Object strlit9114;
static Object strlit9124;
static Object strlit9131;
static Object strlit9137;
static Object strlit9156;
static ClassData objclass9160;
static ClassData objclass9163;
static Object strlit9174;
static Object strlit9182;
static Object strlit9185;
static Object strlit9207;
static Object strlit9216;
static Object strlit9223;
static Object strlit9230;
static Object strlit9237;
static Object strlit9241;
static Object strlit9251;
static Object strlit9257;
static Object strlit9273;
static ClassData objclass9276;
static ClassData objclass9279;
static Object strlit9307;
static Object strlit9316;
static Object strlit9323;
static Object strlit9350;
static Object strlit9363;
static ClassData objclass9366;
static ClassData objclass9374;
static Object strlit9450;
static Object strlit9459;
static Object strlit9471;
static Object strlit9475;
static Object strlit9492;
static Object strlit9502;
static Object strlit9509;
static Object strlit9513;
static Object strlit9531;
static Object strlit9536;
static Object strlit9540;
static Object strlit9550;
static Object strlit9555;
static Object strlit9559;
static Object strlit9578;
static Object strlit9589;
static Object strlit9593;
static Object strlit9602;
static Object strlit9607;
static Object strlit9617;
static Object strlit9618;
static Object strlit9635;
static Object strlit9640;
static Object strlit9644;
static Object strlit9658;
static Object strlit9665;
static Object strlit9669;
static Object strlit9690;
static Object strlit9691;
static Object strlit9743;
static Object strlit9744;
static Object strlit9751;
static ClassData objclass9762;
static ClassData objclass9765;
static Object strlit9782;
static Object strlit9784;
static Object strlit9786;
static Object strlit9798;
static Object strlit9799;
static ClassData objclass9802;
static Object strlit9806;
static ClassData objclass9825;
static Object strlit9841;
static Object strlit9850;
static Object strlit9874;
static Object strlit9879;
static Object strlit9887;
static Object strlit9896;
static Object strlit9901;
static Object strlit9965;
static Object strlit9974;
static Object strlit9981;
static Object strlit9988;
static Object strlit9994;
static Object strlit10007;
static Object strlit10012;
static Object strlit10016;
static Object strlit10028;
static Object strlit10039;
static Object strlit10044;
static Object strlit10048;
static Object strlit10069;
static Object strlit10087;
static Object strlit10096;
static Object strlit10122;
static Object strlit10128;
static Object strlit10137;
static ClassData objclass10142;
static Object strlit10146;
static ClassData objclass10155;
static Object strlit10175;
static Object strlit10184;
static Object strlit10203;
static Object strlit10208;
static Object strlit10216;
static Object strlit10225;
static Object strlit10230;
static Object strlit10255;
static Object strlit10264;
static Object strlit10271;
static Object strlit10278;
static Object strlit10284;
static Object strlit10290;
static Object strlit10295;
static Object strlit10299;
static Object strlit10311;
static Object strlit10322;
static Object strlit10327;
static Object strlit10331;
static Object strlit10354;
static Object strlit10375;
static Object strlit10384;
static Object strlit10418;
static Object strlit10419;
static Object strlit10436;
static Object strlit10446;
static Object strlit10467;
static Object strlit10474;
static ClassData objclass10478;
static ClassData objclass10481;
static Object strlit10496;
static Object strlit10503;
static Object strlit10510;
static Object strlit10516;
static Object strlit10530;
static Object strlit10552;
static Object strlit10561;
static Object strlit10570;
static Object strlit10571;
static Object strlit10573;
static Object strlit10580;
static Object strlit10587;
static Object strlit10594;
static Object strlit10599;
static Object strlit10603;
static Object strlit10619;
static Object strlit10625;
static Object strlit10628;
static Object strlit10633;
static Object strlit10643;
static Object strlit10677;
static ClassData objclass10687;
Object meth_ast__apply_40_1_41_5(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_b = getfromclosure(closure, 0);
  Object *var_as = getfromclosure(closure, 1);
  Object *var_newList = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_nd = &(stackframe->slots[0]);
  *var_nd = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe6 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe7 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nd (depth = 6)
  params[0] = *var_b;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8 = callmethodflags(*var_nd, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7);
// compiled call node returning call8 (depth = 5)
  gc_frame_newslot(call8);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newList (depth = 5)
  params[0] = call8;
  partcv[0] = 1;
  Object call9 = callmethodflags(*var_newList, "addLast(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6);
// compiled call node returning call9 (depth = 4)
  gc_frame_end(frame);
  return call9;
}
Object meth_ast_listMap_40_2_41_ancestors_40_1_41_1(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "listMap(2)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method listMap(_,_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method listMap(_,_)ancestors(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for listMap(_,_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part listMap(_,_)");
  Object *var_as = &(stackframe->slots[2]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newList = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newList");
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array2 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2 (depth = 3)
  *var_newList = array2;
  if (array2 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4 = alloc_Block(NULL, NULL, "ast", 21);
  gc_frame_newslot(block4);
// method "_apply(_)"
  block_savedest(block4);
  Object closure5 = createclosure(4, "_apply(1)");
  setclosureframe(closure5, stackframe);
  addtoclosure(closure5, var_b);
  addtoclosure(closure5, var_as);
  addtoclosure(closure5, var_newList);
  addtoclosure(closure5, selfslot);
  struct UserObject *uo5 = (struct UserObject*)block4;
  uo5->data[0] = (Object)closure5;
  Method *meth_meth_ast__apply_40_1_41_5 = addmethod2pos(block4, "_apply(1)", &meth_ast__apply_40_1_41_5, 0);
  int argcv_meth_ast__apply_40_1_41_5[] = {1};
  meth_meth_ast__apply_40_1_41_5->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5);
  meth_meth_ast__apply_40_1_41_5->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5->definitionLine = 2981;
// compiled block node returning block4 (depth = 3)
  gc_frame_newslot(block4);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  params[0] = block4;
  partcv[0] = 1;
  Object call11 = callmethodflags(*var_l, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3);
// compiled call node returning call11 (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_newList (depth = 2)
  gc_frame_end(frame);
  return *var_newList;
}
Object meth_ast_maybeMap_40_2_41_ancestors_40_1_41_12(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "maybeMap(2)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method maybeMap(_,_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method maybeMap(_,_)ancestors(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for maybeMap(_,_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part maybeMap(_,_)");
  Object *var_as = &(stackframe->slots[2]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_right_14 = gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
  Object bool16 = alloc_Boolean(0);
// compiled identifier node returning bool16 (depth = 4)
  int op_slot_left_14 = gc_frame_newslot(bool16);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult17 = callmethod(bool16, "≠(1)", 1, partcv, params);
// compiled op node returning opresult17 (depth = 3)
  Object if13 = done;
  if (istrue(opresult17)) {
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe18 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = *var_b;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call19 = callmethodflags(*var_n, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe18);
// compiled call node returning call19 (depth = 3)
    gc_frame_newslot(call19);
    if13 = call19;
  } else {
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
    gc_frame_newslot(*var_n);
    if13 = *var_n;
  }
// compiled if node returning if13 (depth = 2)
  gc_frame_end(frame);
  return if13;
}
Object meth_ast_maybeListMap_40_2_41_ancestors_40_1_41_20(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "maybeListMap(2)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method maybeListMap(_,_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method maybeListMap(_,_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for maybeListMap(_,_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part maybeListMap(_,_)");
  Object *var_as = &(stackframe->slots[2]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_right_22 = gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
  Object bool24 = alloc_Boolean(0);
// compiled identifier node returning bool24 (depth = 4)
  int op_slot_left_22 = gc_frame_newslot(bool24);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult25 = callmethod(bool24, "≠(1)", 1, partcv, params);
// compiled op node returning opresult25 (depth = 3)
  Object if21 = done;
  if (istrue(opresult25)) {
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe26 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 4: self request
  params[0] = *var_n;
  params[1] = *var_b;
  params[2] = *var_as;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call27 = callmethodflags(self, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe26);
// compiled call node returning call27 (depth = 3)
    gc_frame_newslot(call27);
    if21 = call27;
  } else {
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
    gc_frame_newslot(*var_n);
    if21 = *var_n;
  }
// compiled if node returning if21 (depth = 2)
  gc_frame_end(frame);
  return if21;
}
Object meth_ast_setLine_40_1_41_col_40_1_41_36(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "setLine(1)col(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method setLine(_)col(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method setLine(_)col(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for setLine(_)col(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part setLine(_)");
  Object *var_c = &(stackframe->slots[1]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part col(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe37 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// call case 4: self request
  params[0] = *var_l;
  partcv[0] = 1;
  Object call38 = callmethodflags(self, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe37);
// compiled call node returning call38 (depth = 2)
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe39 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 4: self request
  params[0] = *var_c;
  partcv[0] = 1;
  Object call40 = callmethodflags(self, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe39);
// compiled call node returning call40 (depth = 2)
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_setPositionFrom_40_1_41_41(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "setPositionFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method setPositionFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for setPositionFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part setPositionFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe42 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe43 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_token (depth = 4)
  Object call44 = callmethodflags(*var_token, "line", 0, partcv, params, 0);
  gc_frame_end(callframe43);
// compiled member node returning call44 (depth = 3)
  gc_frame_newslot(call44);
// call case 4: self request
  params[0] = call44;
  partcv[0] = 1;
  Object call45 = callmethodflags(self, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe42);
// compiled call node returning call45 (depth = 2)
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe46 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe47 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_token (depth = 4)
  Object call48 = callmethodflags(*var_token, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe47);
// compiled member node returning call48 (depth = 3)
  gc_frame_newslot(call48);
// call case 4: self request
  params[0] = call48;
  partcv[0] = 1;
  Object call49 = callmethodflags(self, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe46);
// compiled call node returning call49 (depth = 2)
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_kind50(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "kind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe51 = gc_frame_new();
// call case 5: prelude request
  Object call52 = callmethodflags(prelude, "abstract", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe51);
// compiled member node returning call52 (depth = 2)
  gc_frame_end(frame);
  return call52;
}
Object meth_ast__61__61__40_1_41_53(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe54 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call55 = callmethodflags(self, "isMe(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe54);
// compiled call node returning call55 (depth = 2)
  gc_frame_end(frame);
  return call55;
}
Object meth_ast_isAppliedOccurenceOfIdentifier56(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isAppliedOccurenceOfIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool57 = alloc_Boolean(0);
// compiled identifier node returning bool57 (depth = 2)
  gc_frame_end(frame);
  return bool57;
}
Object meth_ast_isMatchingBlock58(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMatchingBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool59 = alloc_Boolean(0);
// compiled identifier node returning bool59 (depth = 2)
  gc_frame_end(frame);
  return bool59;
}
Object meth_ast_isFieldDec60(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool61 = alloc_Boolean(0);
// compiled identifier node returning bool61 (depth = 2)
  gc_frame_end(frame);
  return bool61;
}
Object meth_ast_isInherits62(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool63 = alloc_Boolean(0);
// compiled identifier node returning bool63 (depth = 2)
  gc_frame_end(frame);
  return bool63;
}
Object meth_ast_isLegalInTrait64(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool65 = alloc_Boolean(0);
// compiled identifier node returning bool65 (depth = 2)
  gc_frame_end(frame);
  return bool65;
}
Object meth_ast_isMember66(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 112
  setline(112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool67 = alloc_Boolean(0);
// compiled identifier node returning bool67 (depth = 2)
  gc_frame_end(frame);
  return bool67;
}
Object meth_ast_isMethod68(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool69 = alloc_Boolean(0);
// compiled identifier node returning bool69 (depth = 2)
  gc_frame_end(frame);
  return bool69;
}
Object meth_ast_isExecutable70(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool71 = alloc_Boolean(1);
// compiled identifier node returning bool71 (depth = 2)
  gc_frame_end(frame);
  return bool71;
}
Object meth_ast_isCall72(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool73 = alloc_Boolean(0);
// compiled identifier node returning bool73 (depth = 2)
  gc_frame_end(frame);
  return bool73;
}
Object meth_ast_isComment74(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isComment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 116
  setline(116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool75 = alloc_Boolean(0);
// compiled identifier node returning bool75 (depth = 2)
  gc_frame_end(frame);
  return bool75;
}
Object meth_ast_isClass76(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool77 = alloc_Boolean(0);
// compiled identifier node returning bool77 (depth = 2)
  gc_frame_end(frame);
  return bool77;
}
Object meth_ast_inClass78(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool79 = alloc_Boolean(0);
// compiled identifier node returning bool79 (depth = 2)
  gc_frame_end(frame);
  return bool79;
}
Object meth_ast_isTrait80(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 119
  setline(119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool81 = alloc_Boolean(0);
// compiled identifier node returning bool81 (depth = 2)
  gc_frame_end(frame);
  return bool81;
}
Object meth_ast_inTrait82(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool83 = alloc_Boolean(0);
// compiled identifier node returning bool83 (depth = 2)
  gc_frame_end(frame);
  return bool83;
}
Object meth_ast_isBind84(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool85 = alloc_Boolean(0);
// compiled identifier node returning bool85 (depth = 2)
  gc_frame_end(frame);
  return bool85;
}
Object meth_ast_isSelf86(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSelf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool87 = alloc_Boolean(0);
// compiled identifier node returning bool87 (depth = 2)
  gc_frame_end(frame);
  return bool87;
}
Object meth_ast_isSuper88(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSuper");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool89 = alloc_Boolean(0);
// compiled identifier node returning bool89 (depth = 2)
  gc_frame_end(frame);
  return bool89;
}
Object meth_ast_isPrelude90(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPrelude");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool91 = alloc_Boolean(0);
// compiled identifier node returning bool91 (depth = 2)
  gc_frame_end(frame);
  return bool91;
}
Object meth_ast_isOuter92(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isOuter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool93 = alloc_Boolean(0);
// compiled identifier node returning bool93 (depth = 2)
  gc_frame_end(frame);
  return bool93;
}
Object meth_ast_isSelfOrOuter94(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSelfOrOuter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool95 = alloc_Boolean(0);
// compiled identifier node returning bool95 (depth = 2)
  gc_frame_end(frame);
  return bool95;
}
Object meth_ast_isBlock96(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool97 = alloc_Boolean(0);
// compiled identifier node returning bool97 (depth = 2)
  gc_frame_end(frame);
  return bool97;
}
Object meth_ast_isObject98(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 128
  setline(128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool99 = alloc_Boolean(0);
// compiled identifier node returning bool99 (depth = 2)
  gc_frame_end(frame);
  return bool99;
}
Object meth_ast_isIdentifier100(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 129
  setline(129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool101 = alloc_Boolean(0);
// compiled identifier node returning bool101 (depth = 2)
  gc_frame_end(frame);
  return bool101;
}
Object meth_ast_isDialect102(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool103 = alloc_Boolean(0);
// compiled identifier node returning bool103 (depth = 2)
  gc_frame_end(frame);
  return bool103;
}
Object meth_ast_isImport104(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool105 = alloc_Boolean(0);
// compiled identifier node returning bool105 (depth = 2)
  gc_frame_end(frame);
  return bool105;
}
Object meth_ast_isTypeDec106(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTypeDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool107 = alloc_Boolean(0);
// compiled identifier node returning bool107 (depth = 2)
  gc_frame_end(frame);
  return bool107;
}
Object meth_ast_isExternal108(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExternal");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool109 = alloc_Boolean(0);
// compiled identifier node returning bool109 (depth = 2)
  gc_frame_end(frame);
  return bool109;
}
Object meth_ast_canInherit110(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canInherit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool111 = alloc_Boolean(0);
// compiled identifier node returning bool111 (depth = 2)
  gc_frame_end(frame);
  return bool111;
}
Object meth_ast_returnsObject112(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool113 = alloc_Boolean(0);
// compiled identifier node returning bool113 (depth = 2)
  gc_frame_end(frame);
  return bool113;
}
Object meth_ast_isImplicit114(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isImplicit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool115 = alloc_Boolean(0);
// compiled identifier node returning bool115 (depth = 2)
  gc_frame_end(frame);
  return bool115;
}
Object meth_ast_usesAsType_40_1_41_116(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part usesAsType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool117 = alloc_Boolean(0);
// compiled identifier node returning bool117 (depth = 2)
  gc_frame_end(frame);
  return bool117;
}
Object meth_ast_hash118(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hash");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe120 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe121 = gc_frame_new();
// call case 4: self request
  Object call122 = callmethodflags(self, "linePos", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe121);
// compiled member node returning call122 (depth = 4)
  Object call123 = callmethodflags(call122, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe120);
// compiled member node returning call123 (depth = 3)
  int op_slot_right_119 = gc_frame_newslot(call123);
// starting to compile member node (depth = 3)
  int callframe125 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe126 = gc_frame_new();
// call case 4: self request
  Object call127 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe126);
// compiled member node returning call127 (depth = 4)
  Object call128 = callmethodflags(call127, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe125);
// compiled member node returning call128 (depth = 3)
  int op_slot_left_119 = gc_frame_newslot(call128);
  params[0] = call123;
  partcv[0] = 1;
  Object prod129 = callmethod(call128, "*(1)", 1, partcv, params);
// compiled op node returning prod129 (depth = 2)
  gc_frame_end(frame);
  return prod129;
}
Object meth_ast_asString130(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit132 == NULL) {
    strlit132 = alloc_String("");
    gc_root(strlit132);
  }
// compiled string node returning strlit132 (depth = 3)
  int op_slot_right_131 = gc_frame_newslot(strlit132);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe135 = gc_frame_new();
// call case 4: self request
  Object call136 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe135);
// compiled member node returning call136 (depth = 4)
  int op_slot_right_134 = gc_frame_newslot(call136);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit139 == NULL) {
    strlit139 = alloc_String(" ");
    gc_root(strlit139);
  }
// compiled string node returning strlit139 (depth = 5)
  int op_slot_right_138 = gc_frame_newslot(strlit139);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe142 = gc_frame_new();
// call case 4: self request
  Object call143 = callmethodflags(self, "kind", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe142);
// compiled member node returning call143 (depth = 6)
  int op_slot_right_141 = gc_frame_newslot(call143);
// starting to compile string node (depth = 6)
  if (strlit145 == NULL) {
    strlit145 = alloc_String("");
    gc_root(strlit145);
  }
// compiled string node returning strlit145 (depth = 6)
  int op_slot_left_141 = gc_frame_newslot(strlit145);
  params[0] = call143;
  partcv[0] = 1;
  Object opresult146 = callmethod(strlit145, "++(1)", 1, partcv, params);
// compiled op node returning opresult146 (depth = 5)
  int op_slot_left_138 = gc_frame_newslot(opresult146);
  params[0] = strlit139;
  partcv[0] = 1;
  Object opresult147 = callmethod(opresult146, "++(1)", 1, partcv, params);
// compiled op node returning opresult147 (depth = 4)
  int op_slot_left_134 = gc_frame_newslot(opresult147);
  params[0] = call136;
  partcv[0] = 1;
  Object opresult148 = callmethod(opresult147, "++(1)", 1, partcv, params);
// compiled op node returning opresult148 (depth = 3)
  int op_slot_left_131 = gc_frame_newslot(opresult148);
  params[0] = strlit132;
  partcv[0] = 1;
  Object opresult149 = callmethod(opresult148, "++(1)", 1, partcv, params);
// compiled op node returning opresult149 (depth = 2)
  gc_frame_end(frame);
  return opresult149;
}
Object meth_ast_nameString150(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit151 == NULL) {
    strlit151 = alloc_String("?");
    gc_root(strlit151);
  }
// compiled string node returning strlit151 (depth = 2)
  gc_frame_end(frame);
  return strlit151;
}
Object meth_ast_isWritable152(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool153 = alloc_Boolean(1);
// compiled identifier node returning bool153 (depth = 2)
  gc_frame_end(frame);
  return bool153;
}
Object meth_ast_isReadable154(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool155 = alloc_Boolean(1);
// compiled identifier node returning bool155 (depth = 2)
  gc_frame_end(frame);
  return bool155;
}
Object meth_ast_isPublic156(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool157 = alloc_Boolean(1);
// compiled identifier node returning bool157 (depth = 2)
  gc_frame_end(frame);
  return bool157;
}
Object meth_ast_isConfidential158(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe159 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe160 = gc_frame_new();
// call case 4: self request
  Object call161 = callmethodflags(self, "isPublic", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe160);
// compiled member node returning call161 (depth = 3)
  Object call162 = callmethodflags(call161, "not", 0, partcv, params, 0);
  gc_frame_end(callframe159);
// compiled member node returning call162 (depth = 2)
  gc_frame_end(frame);
  return call162;
}
Object meth_ast_decType163(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 48, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "decType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe166 = gc_frame_new();
// call case 4: self request
  Object call167 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe166);
// compiled member node returning call167 (depth = 4)
  int op_slot_right_165 = gc_frame_newslot(call167);
// starting to compile identifier node (depth = 4)
  Object bool169 = alloc_Boolean(0);
// compiled identifier node returning bool169 (depth = 4)
  int op_slot_left_165 = gc_frame_newslot(bool169);
  params[0] = call167;
  partcv[0] = 1;
  Object opresult170 = callmethod(bool169, "==(1)", 1, partcv, params);
// compiled op node returning opresult170 (depth = 3)
  Object if164 = done;
  if (istrue(opresult170)) {
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unknownType (depth = 4)
  return *var_unknownType;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if164 = undefined;
  } else {
  }
// compiled if node returning if164 (depth = 2)
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe171 = gc_frame_new();
// call case 4: self request
  Object call172 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe171);
// compiled member node returning call172 (depth = 3)
  return call172;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_isSimple173(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool174 = alloc_Boolean(1);
// compiled identifier node returning bool174 (depth = 2)
  gc_frame_end(frame);
  return bool174;
}
Object meth_ast_isDelimited175(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDelimited");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool176 = alloc_Boolean(0);
// compiled identifier node returning bool176 (depth = 2)
  gc_frame_end(frame);
  return bool176;
}
Object meth_ast_description177(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "description");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe178 = gc_frame_new();
// call case 4: self request
  Object call179 = callmethodflags(self, "kind", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe178);
// compiled member node returning call179 (depth = 2)
  gc_frame_end(frame);
  return call179;
}
Object meth_ast_accept_40_1_41_180(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 52, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)");
  Object params[2];
  int partcv[2];
  Object *var_ancestorChain = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for accept(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe181 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitor (depth = 3)
  gc_frame_newslot(*var_visitor);
// starting to compile member node (depth = 3)
  int callframe182 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ancestorChain (depth = 4)
  Object call183 = callmethodflags(*var_ancestorChain, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe182);
// compiled member node returning call183 (depth = 3)
  gc_frame_newslot(call183);
// call case 4: self request
  params[0] = *var_visitor;
  params[1] = call183;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call184 = callmethodflags(self, "accept(1)from(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe181);
// compiled call node returning call184 (depth = 2)
  gc_frame_end(frame);
  return call184;
}
Object meth_ast_scope185(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 157
  setline(157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe186 = gc_frame_new();
// call case 4: self request
  Object call187 = callmethodflags(self, "symbolTable", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe186);
// compiled member node returning call187 (depth = 2)
  gc_frame_end(frame);
  return call187;
}
Object meth_ast_scope_58__61__40_1_41_188(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 163
  setline(163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe189 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_st (depth = 3)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call190 = callmethodflags(self, "symbolTable:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe189);
// compiled call node returning call190 (depth = 2)
  gc_frame_end(frame);
  return call190;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_191(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe192 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe193 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  Object call194 = callmethodflags(*var_other, "register", 0, partcv, params, 0);
  gc_frame_end(callframe193);
// compiled member node returning call194 (depth = 3)
  gc_frame_newslot(call194);
// call case 4: self request
  params[0] = call194;
  partcv[0] = 1;
  Object call195 = callmethodflags(self, "register:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe192);
// compiled call node returning call195 (depth = 2)
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe196 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe197 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  Object call198 = callmethodflags(*var_other, "line", 0, partcv, params, 0);
  gc_frame_end(callframe197);
// compiled member node returning call198 (depth = 3)
  gc_frame_newslot(call198);
// call case 4: self request
  params[0] = call198;
  partcv[0] = 1;
  Object call199 = callmethodflags(self, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe196);
// compiled call node returning call199 (depth = 2)
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe200 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe201 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  Object call202 = callmethodflags(*var_other, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe201);
// compiled member node returning call202 (depth = 3)
  gc_frame_newslot(call202);
// call case 4: self request
  params[0] = call202;
  partcv[0] = 1;
  Object call203 = callmethodflags(self, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe200);
// compiled call node returning call203 (depth = 2)
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe204 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe205 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  Object call206 = callmethodflags(*var_other, "scope", 0, partcv, params, 0);
  gc_frame_end(callframe205);
// compiled member node returning call206 (depth = 3)
  gc_frame_newslot(call206);
// call case 4: self request
  params[0] = call206;
  partcv[0] = 1;
  Object call207 = callmethodflags(self, "scope:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe204);
// compiled call node returning call207 (depth = 2)
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_ast__apply_40_1_41_216(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit218 == NULL) {
    strlit218 = alloc_String("  ");
    gc_root(strlit218);
  }
// compiled string node returning strlit218 (depth = 6)
  int op_slot_right_217 = gc_frame_newslot(strlit218);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_217 = gc_frame_newslot(*var_spc);
  params[0] = strlit218;
  partcv[0] = 1;
  Object opresult220 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult220 (depth = 5)
  *var_spc = opresult220;
  if (opresult220 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply227(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit229 == NULL) {
    strlit229 = alloc_String("symbols");
    gc_root(strlit229);
  }
// compiled string node returning strlit229 (depth = 6)
  int op_slot_right_228 = gc_frame_newslot(strlit229);
// starting to compile member node (depth = 6)
  int callframe231 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  Object call232 = callmethodflags(*var_util, "target", 0, partcv, params, 0);
  gc_frame_end(callframe231);
// compiled member node returning call232 (depth = 6)
  int op_slot_left_228 = gc_frame_newslot(call232);
  params[0] = strlit229;
  partcv[0] = 1;
  Object opresult233 = callmethod(call232, "==(1)", 1, partcv, params);
// compiled op node returning opresult233 (depth = 5)
  gc_frame_end(frame);
  return opresult233;
}
Object meth_ast_pretty_40_1_41_208(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 56, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit209 == NULL) {
    strlit209 = alloc_String("");
    gc_root(strlit209);
  }
// compiled string node returning strlit209 (depth = 3)
  *var_spc = strlit209;
  if (strlit209 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe210 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  int op_slot_right_211 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 4)
  Object num213 = alloc_Float64(0);
// compiled num node returning num213 (depth = 4)
  int op_slot_left_211 = gc_frame_newslot(num213);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult214 = callmethod(num213, "..(1)", 1, partcv, params);
// compiled op node returning opresult214 (depth = 3)
  gc_frame_newslot(opresult214);
// starting to compile block node (depth = 3)
  Object block215 = alloc_Block(NULL, NULL, "ast", 175);
  gc_frame_newslot(block215);
// method "_apply(_)"
  block_savedest(block215);
  Object closure216 = createclosure(2, "_apply(1)");
  setclosureframe(closure216, stackframe);
  addtoclosure(closure216, var_spc);
  addtoclosure(closure216, selfslot);
  struct UserObject *uo216 = (struct UserObject*)block215;
  uo216->data[0] = (Object)closure216;
  Method *meth_meth_ast__apply_40_1_41_216 = addmethod2pos(block215, "_apply(1)", &meth_ast__apply_40_1_41_216, 0);
  int argcv_meth_ast__apply_40_1_41_216[] = {1};
  meth_meth_ast__apply_40_1_41_216->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_216);
  meth_meth_ast__apply_40_1_41_216->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_216->definitionLine = 2981;
// compiled block node returning block215 (depth = 3)
  gc_frame_newslot(block215);
// call case 5: prelude request
  params[0] = opresult214;
  params[1] = block215;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call223 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe210);
// compiled call node returning call223 (depth = 2)
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile block node (depth = 4)
  Object block226 = alloc_Block(NULL, NULL, "ast", 178);
  gc_frame_newslot(block226);
// method "_apply"
  block_savedest(block226);
  Object closure227 = createclosure(2, "_apply");
  setclosureframe(closure227, stackframe);
  addtoclosure(closure227, var_util);
  addtoclosure(closure227, selfslot);
  struct UserObject *uo227 = (struct UserObject*)block226;
  uo227->data[0] = (Object)closure227;
  Method *meth_meth_ast__apply227 = addmethod2pos(block226, "_apply", &meth_ast__apply227, 0);
  int argcv_meth_ast__apply227[] = {0};
  meth_meth_ast__apply227->type = alloc_MethodType(1, argcv_meth_ast__apply227);
  meth_meth_ast__apply227->definitionModule = modulename;
  meth_meth_ast__apply227->definitionLine = 2981;
// compiled block node returning block226 (depth = 4)
  int op_slot_right_225 = gc_frame_newslot(block226);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  int op_slot_right_236 = gc_frame_newslot(self);
// starting to compile member node (depth = 5)
  int callframe238 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe239 = gc_frame_new();
// call case 4: self request
  Object call240 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe239);
// compiled member node returning call240 (depth = 6)
  Object call241 = callmethodflags(call240, "node", 0, partcv, params, 0);
  gc_frame_end(callframe238);
// compiled member node returning call241 (depth = 5)
  int op_slot_left_236 = gc_frame_newslot(call241);
  params[0] = self;
  partcv[0] = 1;
  Object opresult242 = callmethod(call241, "==(1)", 1, partcv, params);
// compiled op node returning opresult242 (depth = 4)
  int op_slot_left_225 = gc_frame_newslot(opresult242);
  params[0] = block226;
  partcv[0] = 1;
  Object opresult243 = callmethod(opresult242, "&&(1)", 1, partcv, params);
// compiled op node returning opresult243 (depth = 3)
  Object if224 = done;
  if (istrue(opresult243)) {
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit245 == NULL) {
    strlit245 = alloc_String("");
    gc_root(strlit245);
  }
// compiled string node returning strlit245 (depth = 4)
  int op_slot_right_244 = gc_frame_newslot(strlit245);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe248 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe249 = gc_frame_new();
// call case 4: self request
  Object call250 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe249);
// compiled member node returning call250 (depth = 6)
  Object call251 = callmethodflags(call250, "elementScopesAsString", 0, partcv, params, 0);
  gc_frame_end(callframe248);
// compiled member node returning call251 (depth = 5)
  int op_slot_right_247 = gc_frame_newslot(call251);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit254 == NULL) {
    strlit254 = alloc_String("");
    gc_root(strlit254);
  }
// compiled string node returning strlit254 (depth = 6)
  int op_slot_right_253 = gc_frame_newslot(strlit254);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe257 = gc_frame_new();
// call case 4: self request
  Object call258 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe257);
// compiled member node returning call258 (depth = 7)
  int op_slot_right_256 = gc_frame_newslot(call258);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit261 == NULL) {
    strlit261 = alloc_String("): ");
    gc_root(strlit261);
  }
// compiled string node returning strlit261 (depth = 8)
  int op_slot_right_260 = gc_frame_newslot(strlit261);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe264 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe265 = gc_frame_new();
// call case 4: self request
  Object call266 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe265);
// compiled member node returning call266 (depth = 10)
  Object call267 = callmethodflags(call266, "variety", 0, partcv, params, 0);
  gc_frame_end(callframe264);
// compiled member node returning call267 (depth = 9)
  int op_slot_right_263 = gc_frame_newslot(call267);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit270 == NULL) {
    strlit270 = alloc_String("Symbols(");
    gc_root(strlit270);
  }
// compiled string node returning strlit270 (depth = 10)
  int op_slot_right_269 = gc_frame_newslot(strlit270);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_272 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit275 == NULL) {
    strlit275 = alloc_String("""\x0a""");
    gc_root(strlit275);
  }
// compiled string node returning strlit275 (depth = 12)
  int op_slot_right_274 = gc_frame_newslot(strlit275);
// starting to compile op node (depth = 12)
// starting to compile member node (depth = 13)
  int callframe278 = gc_frame_new();
// call case 4: self request
  Object call279 = callmethodflags(self, "description", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe278);
// compiled member node returning call279 (depth = 13)
  int op_slot_right_277 = gc_frame_newslot(call279);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit282 == NULL) {
    strlit282 = alloc_String(" ");
    gc_root(strlit282);
  }
// compiled string node returning strlit282 (depth = 14)
  int op_slot_right_281 = gc_frame_newslot(strlit282);
// starting to compile op node (depth = 14)
// starting to compile member node (depth = 15)
  int callframe285 = gc_frame_new();
// call case 4: self request
  Object call286 = callmethodflags(self, "linePos", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe285);
// compiled member node returning call286 (depth = 15)
  int op_slot_right_284 = gc_frame_newslot(call286);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit289 == NULL) {
    strlit289 = alloc_String(":");
    gc_root(strlit289);
  }
// compiled string node returning strlit289 (depth = 16)
  int op_slot_right_288 = gc_frame_newslot(strlit289);
// starting to compile op node (depth = 16)
// starting to compile member node (depth = 17)
  int callframe292 = gc_frame_new();
// call case 4: self request
  Object call293 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe292);
// compiled member node returning call293 (depth = 17)
  int op_slot_right_291 = gc_frame_newslot(call293);
// starting to compile string node (depth = 17)
  if (strlit295 == NULL) {
    strlit295 = alloc_String("");
    gc_root(strlit295);
  }
// compiled string node returning strlit295 (depth = 17)
  int op_slot_left_291 = gc_frame_newslot(strlit295);
  params[0] = call293;
  partcv[0] = 1;
  Object opresult296 = callmethod(strlit295, "++(1)", 1, partcv, params);
// compiled op node returning opresult296 (depth = 16)
  int op_slot_left_288 = gc_frame_newslot(opresult296);
  params[0] = strlit289;
  partcv[0] = 1;
  Object opresult297 = callmethod(opresult296, "++(1)", 1, partcv, params);
// compiled op node returning opresult297 (depth = 15)
  int op_slot_left_284 = gc_frame_newslot(opresult297);
  params[0] = call286;
  partcv[0] = 1;
  Object opresult298 = callmethod(opresult297, "++(1)", 1, partcv, params);
// compiled op node returning opresult298 (depth = 14)
  int op_slot_left_281 = gc_frame_newslot(opresult298);
  params[0] = strlit282;
  partcv[0] = 1;
  Object opresult299 = callmethod(opresult298, "++(1)", 1, partcv, params);
// compiled op node returning opresult299 (depth = 13)
  int op_slot_left_277 = gc_frame_newslot(opresult299);
  params[0] = call279;
  partcv[0] = 1;
  Object opresult300 = callmethod(opresult299, "++(1)", 1, partcv, params);
// compiled op node returning opresult300 (depth = 12)
  int op_slot_left_274 = gc_frame_newslot(opresult300);
  params[0] = strlit275;
  partcv[0] = 1;
  Object opresult301 = callmethod(opresult300, "++(1)", 1, partcv, params);
// compiled op node returning opresult301 (depth = 11)
  int op_slot_left_272 = gc_frame_newslot(opresult301);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult302 = callmethod(opresult301, "++(1)", 1, partcv, params);
// compiled op node returning opresult302 (depth = 10)
  int op_slot_left_269 = gc_frame_newslot(opresult302);
  params[0] = strlit270;
  partcv[0] = 1;
  Object opresult303 = callmethod(opresult302, "++(1)", 1, partcv, params);
// compiled op node returning opresult303 (depth = 9)
  int op_slot_left_263 = gc_frame_newslot(opresult303);
  params[0] = call267;
  partcv[0] = 1;
  Object opresult304 = callmethod(opresult303, "++(1)", 1, partcv, params);
// compiled op node returning opresult304 (depth = 8)
  int op_slot_left_260 = gc_frame_newslot(opresult304);
  params[0] = strlit261;
  partcv[0] = 1;
  Object opresult305 = callmethod(opresult304, "++(1)", 1, partcv, params);
// compiled op node returning opresult305 (depth = 7)
  int op_slot_left_256 = gc_frame_newslot(opresult305);
  params[0] = call258;
  partcv[0] = 1;
  Object opresult306 = callmethod(opresult305, "++(1)", 1, partcv, params);
// compiled op node returning opresult306 (depth = 6)
  int op_slot_left_253 = gc_frame_newslot(opresult306);
  params[0] = strlit254;
  partcv[0] = 1;
  Object opresult307 = callmethod(opresult306, "++(1)", 1, partcv, params);
// compiled op node returning opresult307 (depth = 5)
  int op_slot_left_247 = gc_frame_newslot(opresult307);
  params[0] = call251;
  partcv[0] = 1;
  Object opresult308 = callmethod(opresult307, "++(1)", 1, partcv, params);
// compiled op node returning opresult308 (depth = 4)
  int op_slot_left_244 = gc_frame_newslot(opresult308);
  params[0] = strlit245;
  partcv[0] = 1;
  Object opresult309 = callmethod(opresult308, "++(1)", 1, partcv, params);
// compiled op node returning opresult309 (depth = 3)
    gc_frame_newslot(opresult309);
    if224 = opresult309;
  } else {
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit312 == NULL) {
    strlit312 = alloc_String("fake");
    gc_root(strlit312);
  }
// compiled string node returning strlit312 (depth = 5)
  int op_slot_right_311 = gc_frame_newslot(strlit312);
// starting to compile member node (depth = 5)
  int callframe314 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe315 = gc_frame_new();
// call case 4: self request
  Object call316 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe315);
// compiled member node returning call316 (depth = 6)
  Object call317 = callmethodflags(call316, "variety", 0, partcv, params, 0);
  gc_frame_end(callframe314);
// compiled member node returning call317 (depth = 5)
  int op_slot_left_311 = gc_frame_newslot(call317);
  params[0] = strlit312;
  partcv[0] = 1;
  Object opresult318 = callmethod(call317, "==(1)", 1, partcv, params);
// compiled op node returning opresult318 (depth = 4)
  Object if310 = done;
  if (istrue(opresult318)) {
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit320 == NULL) {
    strlit320 = alloc_String("");
    gc_root(strlit320);
  }
// compiled string node returning strlit320 (depth = 5)
  int op_slot_right_319 = gc_frame_newslot(strlit320);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe323 = gc_frame_new();
// call case 4: self request
  Object call324 = callmethodflags(self, "description", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe323);
// compiled member node returning call324 (depth = 6)
  int op_slot_right_322 = gc_frame_newslot(call324);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit327 == NULL) {
    strlit327 = alloc_String(" ");
    gc_root(strlit327);
  }
// compiled string node returning strlit327 (depth = 7)
  int op_slot_right_326 = gc_frame_newslot(strlit327);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe330 = gc_frame_new();
// call case 4: self request
  Object call331 = callmethodflags(self, "linePos", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe330);
// compiled member node returning call331 (depth = 8)
  int op_slot_right_329 = gc_frame_newslot(call331);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit334 == NULL) {
    strlit334 = alloc_String(":");
    gc_root(strlit334);
  }
// compiled string node returning strlit334 (depth = 9)
  int op_slot_right_333 = gc_frame_newslot(strlit334);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe337 = gc_frame_new();
// call case 4: self request
  Object call338 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe337);
// compiled member node returning call338 (depth = 10)
  int op_slot_right_336 = gc_frame_newslot(call338);
// starting to compile string node (depth = 10)
  if (strlit340 == NULL) {
    strlit340 = alloc_String("");
    gc_root(strlit340);
  }
// compiled string node returning strlit340 (depth = 10)
  int op_slot_left_336 = gc_frame_newslot(strlit340);
  params[0] = call338;
  partcv[0] = 1;
  Object opresult341 = callmethod(strlit340, "++(1)", 1, partcv, params);
// compiled op node returning opresult341 (depth = 9)
  int op_slot_left_333 = gc_frame_newslot(opresult341);
  params[0] = strlit334;
  partcv[0] = 1;
  Object opresult342 = callmethod(opresult341, "++(1)", 1, partcv, params);
// compiled op node returning opresult342 (depth = 8)
  int op_slot_left_329 = gc_frame_newslot(opresult342);
  params[0] = call331;
  partcv[0] = 1;
  Object opresult343 = callmethod(opresult342, "++(1)", 1, partcv, params);
// compiled op node returning opresult343 (depth = 7)
  int op_slot_left_326 = gc_frame_newslot(opresult343);
  params[0] = strlit327;
  partcv[0] = 1;
  Object opresult344 = callmethod(opresult343, "++(1)", 1, partcv, params);
// compiled op node returning opresult344 (depth = 6)
  int op_slot_left_322 = gc_frame_newslot(opresult344);
  params[0] = call324;
  partcv[0] = 1;
  Object opresult345 = callmethod(opresult344, "++(1)", 1, partcv, params);
// compiled op node returning opresult345 (depth = 5)
  int op_slot_left_319 = gc_frame_newslot(opresult345);
  params[0] = strlit320;
  partcv[0] = 1;
  Object opresult346 = callmethod(opresult345, "++(1)", 1, partcv, params);
// compiled op node returning opresult346 (depth = 4)
    gc_frame_newslot(opresult346);
    if310 = opresult346;
  } else {
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit348 == NULL) {
    strlit348 = alloc_String("");
    gc_root(strlit348);
  }
// compiled string node returning strlit348 (depth = 5)
  int op_slot_right_347 = gc_frame_newslot(strlit348);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe351 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe352 = gc_frame_new();
// call case 4: self request
  Object call353 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe352);
// compiled member node returning call353 (depth = 7)
  Object call354 = callmethodflags(call353, "asDebugString", 0, partcv, params, 0);
  gc_frame_end(callframe351);
// compiled member node returning call354 (depth = 6)
  int op_slot_right_350 = gc_frame_newslot(call354);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit357 == NULL) {
    strlit357 = alloc_String(" ");
    gc_root(strlit357);
  }
// compiled string node returning strlit357 (depth = 7)
  int op_slot_right_356 = gc_frame_newslot(strlit357);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe360 = gc_frame_new();
// call case 4: self request
  Object call361 = callmethodflags(self, "description", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe360);
// compiled member node returning call361 (depth = 8)
  int op_slot_right_359 = gc_frame_newslot(call361);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit364 == NULL) {
    strlit364 = alloc_String(" ");
    gc_root(strlit364);
  }
// compiled string node returning strlit364 (depth = 9)
  int op_slot_right_363 = gc_frame_newslot(strlit364);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe367 = gc_frame_new();
// call case 4: self request
  Object call368 = callmethodflags(self, "linePos", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe367);
// compiled member node returning call368 (depth = 10)
  int op_slot_right_366 = gc_frame_newslot(call368);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit371 == NULL) {
    strlit371 = alloc_String(":");
    gc_root(strlit371);
  }
// compiled string node returning strlit371 (depth = 11)
  int op_slot_right_370 = gc_frame_newslot(strlit371);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
  int callframe374 = gc_frame_new();
// call case 4: self request
  Object call375 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe374);
// compiled member node returning call375 (depth = 12)
  int op_slot_right_373 = gc_frame_newslot(call375);
// starting to compile string node (depth = 12)
  if (strlit377 == NULL) {
    strlit377 = alloc_String("");
    gc_root(strlit377);
  }
// compiled string node returning strlit377 (depth = 12)
  int op_slot_left_373 = gc_frame_newslot(strlit377);
  params[0] = call375;
  partcv[0] = 1;
  Object opresult378 = callmethod(strlit377, "++(1)", 1, partcv, params);
// compiled op node returning opresult378 (depth = 11)
  int op_slot_left_370 = gc_frame_newslot(opresult378);
  params[0] = strlit371;
  partcv[0] = 1;
  Object opresult379 = callmethod(opresult378, "++(1)", 1, partcv, params);
// compiled op node returning opresult379 (depth = 10)
  int op_slot_left_366 = gc_frame_newslot(opresult379);
  params[0] = call368;
  partcv[0] = 1;
  Object opresult380 = callmethod(opresult379, "++(1)", 1, partcv, params);
// compiled op node returning opresult380 (depth = 9)
  int op_slot_left_363 = gc_frame_newslot(opresult380);
  params[0] = strlit364;
  partcv[0] = 1;
  Object opresult381 = callmethod(opresult380, "++(1)", 1, partcv, params);
// compiled op node returning opresult381 (depth = 8)
  int op_slot_left_359 = gc_frame_newslot(opresult381);
  params[0] = call361;
  partcv[0] = 1;
  Object opresult382 = callmethod(opresult381, "++(1)", 1, partcv, params);
// compiled op node returning opresult382 (depth = 7)
  int op_slot_left_356 = gc_frame_newslot(opresult382);
  params[0] = strlit357;
  partcv[0] = 1;
  Object opresult383 = callmethod(opresult382, "++(1)", 1, partcv, params);
// compiled op node returning opresult383 (depth = 6)
  int op_slot_left_350 = gc_frame_newslot(opresult383);
  params[0] = call354;
  partcv[0] = 1;
  Object opresult384 = callmethod(opresult383, "++(1)", 1, partcv, params);
// compiled op node returning opresult384 (depth = 5)
  int op_slot_left_347 = gc_frame_newslot(opresult384);
  params[0] = strlit348;
  partcv[0] = 1;
  Object opresult385 = callmethod(opresult384, "++(1)", 1, partcv, params);
// compiled op node returning opresult385 (depth = 4)
    gc_frame_newslot(opresult385);
    if310 = opresult385;
  }
// compiled if node returning if310 (depth = 3)
    gc_frame_newslot(if310);
    if224 = if310;
  }
// compiled if node returning if224 (depth = 2)
  gc_frame_end(frame);
  return if224;
}
Object meth_ast__apply_40_1_41_389(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_each (depth = 4)
  gc_frame_end(frame);
  return *var_each;
}
Object meth_ast_deepCopy386(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 57, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "deepCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_ancestorChain = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 187
  setline(187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe387 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block388 = alloc_Block(NULL, NULL, "ast", 187);
  gc_frame_newslot(block388);
// method "_apply(_)"
  block_savedest(block388);
  Object closure389 = createclosure(1, "_apply(1)");
  setclosureframe(closure389, stackframe);
  addtoclosure(closure389, selfslot);
  struct UserObject *uo389 = (struct UserObject*)block388;
  uo389->data[0] = (Object)closure389;
  Method *meth_meth_ast__apply_40_1_41_389 = addmethod2pos(block388, "_apply(1)", &meth_ast__apply_40_1_41_389, 0);
  int argcv_meth_ast__apply_40_1_41_389[] = {1};
  meth_meth_ast__apply_40_1_41_389->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_389);
  meth_meth_ast__apply_40_1_41_389->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_389->definitionLine = 2981;
// compiled block node returning block388 (depth = 3)
  gc_frame_newslot(block388);
// starting to compile member node (depth = 3)
  int callframe391 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ancestorChain (depth = 4)
  Object call392 = callmethodflags(*var_ancestorChain, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe391);
// compiled member node returning call392 (depth = 3)
  gc_frame_newslot(call392);
// call case 4: self request
  params[0] = block388;
  params[1] = call392;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call393 = callmethodflags(self, "map(1)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe387);
// compiled call node returning call393 (depth = 2)
  gc_frame_end(frame);
  return call393;
}
Object meth_ast_enclosingObject394(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "enclosingObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_obj = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "obj");
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe395 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe396 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe397 = gc_frame_new();
// call case 4: self request
  Object call398 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe397);
// compiled member node returning call398 (depth = 5)
  Object call399 = callmethodflags(call398, "enclosingObjectScope", 0, partcv, params, 0);
  gc_frame_end(callframe396);
// compiled member node returning call399 (depth = 4)
  Object call400 = callmethodflags(call399, "node", 0, partcv, params, 0);
  gc_frame_end(callframe395);
// compiled member node returning call400 (depth = 3)
  *var_obj = call400;
  if (call400 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_obj (depth = 2)
  gc_frame_end(frame);
  return *var_obj;
}
Object meth_ast_addComment_40_1_41_401(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addComment(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addComment(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addComment(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cmtNode = &(stackframe->slots[0]);
  *var_cmtNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addComment(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe404 = gc_frame_new();
// call case 4: self request
  Object call405 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe404);
// compiled member node returning call405 (depth = 4)
  int op_slot_right_403 = gc_frame_newslot(call405);
// starting to compile identifier node (depth = 4)
  Object bool407 = alloc_Boolean(0);
// compiled identifier node returning bool407 (depth = 4)
  int op_slot_left_403 = gc_frame_newslot(bool407);
  params[0] = call405;
  partcv[0] = 1;
  Object opresult408 = callmethod(bool407, "==(1)", 1, partcv, params);
// compiled op node returning opresult408 (depth = 3)
  Object if402 = done;
  if (istrue(opresult408)) {
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe409 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cmtNode (depth = 4)
  gc_frame_newslot(*var_cmtNode);
// call case 4: self request
  params[0] = *var_cmtNode;
  partcv[0] = 1;
  Object call410 = callmethodflags(self, "comments:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe409);
// compiled call node returning call410 (depth = 3)
    gc_frame_newslot(call410);
    if402 = call410;
  } else {
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe411 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cmtNode (depth = 4)
  gc_frame_newslot(*var_cmtNode);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe412 = gc_frame_new();
// call case 4: self request
  Object call413 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe412);
// compiled member node returning call413 (depth = 4)
  params[0] = *var_cmtNode;
  partcv[0] = 1;
  Object call414 = callmethodflags(call413, "extendCommentUsing(1)", 1, partcv, params, 0);
  gc_frame_end(callframe411);
// compiled call node returning call414 (depth = 3)
    gc_frame_newslot(call414);
    if402 = call414;
  }
// compiled if node returning if402 (depth = 2)
  gc_frame_end(frame);
  return if402;
}
Object meth_ast__apply_40_1_41_418(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe419 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call420 = callmethodflags(self, "addComment(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe419);
// compiled call node returning call420 (depth = 4)
  gc_frame_end(frame);
  return call420;
}
Object meth_ast_addComments_40_1_41_415(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addComments(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addComments(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addComments(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cmtNodeList = &(stackframe->slots[0]);
  *var_cmtNodeList = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addComments(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe416 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block417 = alloc_Block(NULL, NULL, "ast", 201);
  gc_frame_newslot(block417);
// method "_apply(_)"
  block_savedest(block417);
  Object closure418 = createclosure(1, "_apply(1)");
  setclosureframe(closure418, stackframe);
  addtoclosure(closure418, selfslot);
  struct UserObject *uo418 = (struct UserObject*)block417;
  uo418->data[0] = (Object)closure418;
  Method *meth_meth_ast__apply_40_1_41_418 = addmethod2pos(block417, "_apply(1)", &meth_ast__apply_40_1_41_418, 0);
  int argcv_meth_ast__apply_40_1_41_418[] = {1};
  meth_meth_ast__apply_40_1_41_418->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_418);
  meth_meth_ast__apply_40_1_41_418->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_418->definitionLine = 2981;
// compiled block node returning block417 (depth = 3)
  gc_frame_newslot(block417);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cmtNodeList (depth = 3)
  params[0] = block417;
  partcv[0] = 1;
  Object call422 = callmethodflags(*var_cmtNodeList, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe416);
// compiled call node returning call422 (depth = 2)
  gc_frame_end(frame);
  return call422;
}
Object meth_ast_statementName423(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe424 = gc_frame_new();
// call case 4: self request
  Object call425 = callmethodflags(self, "kind", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe424);
// compiled member node returning call425 (depth = 2)
  gc_frame_end(frame);
  return call425;
}
Object meth_ast_baseNode28(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "baseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  Object *var_ancestorChain = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_fakeSymbolTable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject29 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj29 = alloc_userobj2(66,62, objclass29);
  gc_frame_newslot(obj29);
if (objclass29 == NULL) {
  glfree(obj29->class->name);
  obj29->class->name = "baseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj29, self, 0);
  addmethodreal(obj29,"outer", &reader_ast_outer_30);
  Object oldself29 = self;
  struct StackFrameObject *oldstackframe29 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe29);
  gc_frame_newslot((Object)stackframe);
  self = obj29;
  Object *oldselfslot29 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter29 = (*(struct UserObject *)self).data[0], lowerouter29 = thisouter29;
  if (inheritingObject29) {
    struct UserObject *inho29 = (struct UserObject *)inheritingObject29;
    while (inho29->super != GraceDefaultObject) inho29 = (struct UserObject *)inho29->super;
    inho29->super = obj29;
    self = inheritingObject29;
    *selfslot = self;
    lowerouter29 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter29;
  }
if (objclass29 == NULL) {
  Method *reader31 = addmethodrealflags(obj29, "register", &reader_ast_register_31, 0);
  Method *writer31 = addmethodrealflags(obj29, "register:=(1)", &writer_ast_register_31, 0);
  reader31->definitionModule = modulename;
  writer31->definitionModule = modulename;
  reader31->definitionLine = 89;
  writer31->definitionLine = 89;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 1);
if (objclass29 == NULL) {
  Method *reader32 = addmethodrealflags(obj29, "line", &reader_ast_line_32, 0);
  Method *writer32 = addmethodrealflags(obj29, "line:=(1)", &writer_ast_line_32, 0);
  reader32->definitionModule = modulename;
  writer32->definitionModule = modulename;
  reader32->definitionLine = 90;
  writer32->definitionLine = 90;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 2);
if (objclass29 == NULL) {
  Method *reader33 = addmethodrealflags(obj29, "linePos", &reader_ast_linePos_33, 0);
  Method *writer33 = addmethodrealflags(obj29, "linePos:=(1)", &writer_ast_linePos_33, 0);
  reader33->definitionModule = modulename;
  writer33->definitionModule = modulename;
  reader33->definitionLine = 91;
  writer33->definitionLine = 91;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 3);
if (objclass29 == NULL) {
  Method *reader34 = addmethodrealflags(obj29, "symbolTable", &reader_ast_symbolTable_34, MFLAG_CONFIDENTIAL);
  Method *writer34 = addmethodrealflags(obj29, "symbolTable:=(1)", &writer_ast_symbolTable_34, MFLAG_CONFIDENTIAL);
  reader34->definitionModule = modulename;
  writer34->definitionModule = modulename;
  reader34->definitionLine = 92;
  writer34->definitionLine = 92;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 4);
if (objclass29 == NULL) {
  Method *reader35 = addmethodrealflags(obj29, "comments", &reader_ast_comments_35, 0);
  Method *writer35 = addmethodrealflags(obj29, "comments:=(1)", &writer_ast_comments_35, 0);
  reader35->definitionModule = modulename;
  writer35->definitionModule = modulename;
  reader35->definitionLine = 93;
  writer35->definitionLine = 93;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 5);
// method "setLine(_)col(_)"
  struct UserObject *uo36 = (struct UserObject*)obj29;
  uo36->data[6] = emptyclosure;
  Method *meth_meth_ast_setLine_40_1_41_col_40_1_41_36 = addmethod2pos(obj29, "setLine(1)col(1)", &meth_ast_setLine_40_1_41_col_40_1_41_36, 6);
  int argcv_meth_ast_setLine_40_1_41_col_40_1_41_36[] = {1, 1};
  meth_meth_ast_setLine_40_1_41_col_40_1_41_36->type = alloc_MethodType(2, argcv_meth_ast_setLine_40_1_41_col_40_1_41_36);
  meth_meth_ast_setLine_40_1_41_col_40_1_41_36->definitionModule = modulename;
  meth_meth_ast_setLine_40_1_41_col_40_1_41_36->definitionLine = 95;
// method "setPositionFrom(_)"
  struct UserObject *uo41 = (struct UserObject*)obj29;
  uo41->data[7] = emptyclosure;
  Method *meth_meth_ast_setPositionFrom_40_1_41_41 = addmethod2pos(obj29, "setPositionFrom(1)", &meth_ast_setPositionFrom_40_1_41_41, 7);
  int argcv_meth_ast_setPositionFrom_40_1_41_41[] = {1};
  meth_meth_ast_setPositionFrom_40_1_41_41->type = alloc_MethodType(1, argcv_meth_ast_setPositionFrom_40_1_41_41);
  meth_meth_ast_setPositionFrom_40_1_41_41->definitionModule = modulename;
  meth_meth_ast_setPositionFrom_40_1_41_41->definitionLine = 100;
// method "kind"
  struct UserObject *uo50 = (struct UserObject*)obj29;
  uo50->data[8] = emptyclosure;
  Method *meth_meth_ast_kind50 = addmethod2pos(obj29, "kind", &meth_ast_kind50, 8);
  int argcv_meth_ast_kind50[] = {0};
  meth_meth_ast_kind50->type = alloc_MethodType(1, argcv_meth_ast_kind50);
  meth_meth_ast_kind50->definitionModule = modulename;
  meth_meth_ast_kind50->definitionLine = 105;
// method "==(_)"
  struct UserObject *uo53 = (struct UserObject*)obj29;
  uo53->data[9] = emptyclosure;
  Method *meth_meth_ast__61__61__40_1_41_53 = addmethod2pos(obj29, "==(1)", &meth_ast__61__61__40_1_41_53, 9);
  int argcv_meth_ast__61__61__40_1_41_53[] = {1};
  meth_meth_ast__61__61__40_1_41_53->type = alloc_MethodType(1, argcv_meth_ast__61__61__40_1_41_53);
  meth_meth_ast__61__61__40_1_41_53->definitionModule = modulename;
  meth_meth_ast__61__61__40_1_41_53->definitionLine = 106;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo56 = (struct UserObject*)obj29;
  uo56->data[10] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier56 = addmethod2pos(obj29, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier56, 10);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier56[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier56->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier56);
  meth_meth_ast_isAppliedOccurenceOfIdentifier56->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier56->definitionLine = 107;
// method "isMatchingBlock"
  struct UserObject *uo58 = (struct UserObject*)obj29;
  uo58->data[11] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock58 = addmethod2pos(obj29, "isMatchingBlock", &meth_ast_isMatchingBlock58, 11);
  int argcv_meth_ast_isMatchingBlock58[] = {0};
  meth_meth_ast_isMatchingBlock58->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock58);
  meth_meth_ast_isMatchingBlock58->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock58->definitionLine = 108;
// method "isFieldDec"
  struct UserObject *uo60 = (struct UserObject*)obj29;
  uo60->data[12] = emptyclosure;
  Method *meth_meth_ast_isFieldDec60 = addmethod2pos(obj29, "isFieldDec", &meth_ast_isFieldDec60, 12);
  int argcv_meth_ast_isFieldDec60[] = {0};
  meth_meth_ast_isFieldDec60->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec60);
  meth_meth_ast_isFieldDec60->definitionModule = modulename;
  meth_meth_ast_isFieldDec60->definitionLine = 109;
// method "isInherits"
  struct UserObject *uo62 = (struct UserObject*)obj29;
  uo62->data[13] = emptyclosure;
  Method *meth_meth_ast_isInherits62 = addmethod2pos(obj29, "isInherits", &meth_ast_isInherits62, 13);
  int argcv_meth_ast_isInherits62[] = {0};
  meth_meth_ast_isInherits62->type = alloc_MethodType(1, argcv_meth_ast_isInherits62);
  meth_meth_ast_isInherits62->definitionModule = modulename;
  meth_meth_ast_isInherits62->definitionLine = 110;
// method "isLegalInTrait"
  struct UserObject *uo64 = (struct UserObject*)obj29;
  uo64->data[14] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait64 = addmethod2pos(obj29, "isLegalInTrait", &meth_ast_isLegalInTrait64, 14);
  int argcv_meth_ast_isLegalInTrait64[] = {0};
  meth_meth_ast_isLegalInTrait64->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait64);
  meth_meth_ast_isLegalInTrait64->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait64->definitionLine = 111;
// method "isMember"
  struct UserObject *uo66 = (struct UserObject*)obj29;
  uo66->data[15] = emptyclosure;
  Method *meth_meth_ast_isMember66 = addmethod2pos(obj29, "isMember", &meth_ast_isMember66, 15);
  int argcv_meth_ast_isMember66[] = {0};
  meth_meth_ast_isMember66->type = alloc_MethodType(1, argcv_meth_ast_isMember66);
  meth_meth_ast_isMember66->definitionModule = modulename;
  meth_meth_ast_isMember66->definitionLine = 112;
// method "isMethod"
  struct UserObject *uo68 = (struct UserObject*)obj29;
  uo68->data[16] = emptyclosure;
  Method *meth_meth_ast_isMethod68 = addmethod2pos(obj29, "isMethod", &meth_ast_isMethod68, 16);
  int argcv_meth_ast_isMethod68[] = {0};
  meth_meth_ast_isMethod68->type = alloc_MethodType(1, argcv_meth_ast_isMethod68);
  meth_meth_ast_isMethod68->definitionModule = modulename;
  meth_meth_ast_isMethod68->definitionLine = 113;
// method "isExecutable"
  struct UserObject *uo70 = (struct UserObject*)obj29;
  uo70->data[17] = emptyclosure;
  Method *meth_meth_ast_isExecutable70 = addmethod2pos(obj29, "isExecutable", &meth_ast_isExecutable70, 17);
  int argcv_meth_ast_isExecutable70[] = {0};
  meth_meth_ast_isExecutable70->type = alloc_MethodType(1, argcv_meth_ast_isExecutable70);
  meth_meth_ast_isExecutable70->definitionModule = modulename;
  meth_meth_ast_isExecutable70->definitionLine = 114;
// method "isCall"
  struct UserObject *uo72 = (struct UserObject*)obj29;
  uo72->data[18] = emptyclosure;
  Method *meth_meth_ast_isCall72 = addmethod2pos(obj29, "isCall", &meth_ast_isCall72, 18);
  int argcv_meth_ast_isCall72[] = {0};
  meth_meth_ast_isCall72->type = alloc_MethodType(1, argcv_meth_ast_isCall72);
  meth_meth_ast_isCall72->definitionModule = modulename;
  meth_meth_ast_isCall72->definitionLine = 115;
// method "isComment"
  struct UserObject *uo74 = (struct UserObject*)obj29;
  uo74->data[19] = emptyclosure;
  Method *meth_meth_ast_isComment74 = addmethod2pos(obj29, "isComment", &meth_ast_isComment74, 19);
  int argcv_meth_ast_isComment74[] = {0};
  meth_meth_ast_isComment74->type = alloc_MethodType(1, argcv_meth_ast_isComment74);
  meth_meth_ast_isComment74->definitionModule = modulename;
  meth_meth_ast_isComment74->definitionLine = 116;
// method "isClass"
  struct UserObject *uo76 = (struct UserObject*)obj29;
  uo76->data[20] = emptyclosure;
  Method *meth_meth_ast_isClass76 = addmethod2pos(obj29, "isClass", &meth_ast_isClass76, 20);
  int argcv_meth_ast_isClass76[] = {0};
  meth_meth_ast_isClass76->type = alloc_MethodType(1, argcv_meth_ast_isClass76);
  meth_meth_ast_isClass76->definitionModule = modulename;
  meth_meth_ast_isClass76->definitionLine = 117;
// method "inClass"
  struct UserObject *uo78 = (struct UserObject*)obj29;
  uo78->data[21] = emptyclosure;
  Method *meth_meth_ast_inClass78 = addmethod2pos(obj29, "inClass", &meth_ast_inClass78, 21);
  int argcv_meth_ast_inClass78[] = {0};
  meth_meth_ast_inClass78->type = alloc_MethodType(1, argcv_meth_ast_inClass78);
  meth_meth_ast_inClass78->definitionModule = modulename;
  meth_meth_ast_inClass78->definitionLine = 118;
// method "isTrait"
  struct UserObject *uo80 = (struct UserObject*)obj29;
  uo80->data[22] = emptyclosure;
  Method *meth_meth_ast_isTrait80 = addmethod2pos(obj29, "isTrait", &meth_ast_isTrait80, 22);
  int argcv_meth_ast_isTrait80[] = {0};
  meth_meth_ast_isTrait80->type = alloc_MethodType(1, argcv_meth_ast_isTrait80);
  meth_meth_ast_isTrait80->definitionModule = modulename;
  meth_meth_ast_isTrait80->definitionLine = 119;
// method "inTrait"
  struct UserObject *uo82 = (struct UserObject*)obj29;
  uo82->data[23] = emptyclosure;
  Method *meth_meth_ast_inTrait82 = addmethod2pos(obj29, "inTrait", &meth_ast_inTrait82, 23);
  int argcv_meth_ast_inTrait82[] = {0};
  meth_meth_ast_inTrait82->type = alloc_MethodType(1, argcv_meth_ast_inTrait82);
  meth_meth_ast_inTrait82->definitionModule = modulename;
  meth_meth_ast_inTrait82->definitionLine = 120;
// method "isBind"
  struct UserObject *uo84 = (struct UserObject*)obj29;
  uo84->data[24] = emptyclosure;
  Method *meth_meth_ast_isBind84 = addmethod2pos(obj29, "isBind", &meth_ast_isBind84, 24);
  int argcv_meth_ast_isBind84[] = {0};
  meth_meth_ast_isBind84->type = alloc_MethodType(1, argcv_meth_ast_isBind84);
  meth_meth_ast_isBind84->definitionModule = modulename;
  meth_meth_ast_isBind84->definitionLine = 121;
// method "isSelf"
  struct UserObject *uo86 = (struct UserObject*)obj29;
  uo86->data[25] = emptyclosure;
  Method *meth_meth_ast_isSelf86 = addmethod2pos(obj29, "isSelf", &meth_ast_isSelf86, 25);
  int argcv_meth_ast_isSelf86[] = {0};
  meth_meth_ast_isSelf86->type = alloc_MethodType(1, argcv_meth_ast_isSelf86);
  meth_meth_ast_isSelf86->definitionModule = modulename;
  meth_meth_ast_isSelf86->definitionLine = 122;
// method "isSuper"
  struct UserObject *uo88 = (struct UserObject*)obj29;
  uo88->data[26] = emptyclosure;
  Method *meth_meth_ast_isSuper88 = addmethod2pos(obj29, "isSuper", &meth_ast_isSuper88, 26);
  int argcv_meth_ast_isSuper88[] = {0};
  meth_meth_ast_isSuper88->type = alloc_MethodType(1, argcv_meth_ast_isSuper88);
  meth_meth_ast_isSuper88->definitionModule = modulename;
  meth_meth_ast_isSuper88->definitionLine = 123;
// method "isPrelude"
  struct UserObject *uo90 = (struct UserObject*)obj29;
  uo90->data[27] = emptyclosure;
  Method *meth_meth_ast_isPrelude90 = addmethod2pos(obj29, "isPrelude", &meth_ast_isPrelude90, 27);
  int argcv_meth_ast_isPrelude90[] = {0};
  meth_meth_ast_isPrelude90->type = alloc_MethodType(1, argcv_meth_ast_isPrelude90);
  meth_meth_ast_isPrelude90->definitionModule = modulename;
  meth_meth_ast_isPrelude90->definitionLine = 124;
// method "isOuter"
  struct UserObject *uo92 = (struct UserObject*)obj29;
  uo92->data[28] = emptyclosure;
  Method *meth_meth_ast_isOuter92 = addmethod2pos(obj29, "isOuter", &meth_ast_isOuter92, 28);
  int argcv_meth_ast_isOuter92[] = {0};
  meth_meth_ast_isOuter92->type = alloc_MethodType(1, argcv_meth_ast_isOuter92);
  meth_meth_ast_isOuter92->definitionModule = modulename;
  meth_meth_ast_isOuter92->definitionLine = 125;
// method "isSelfOrOuter"
  struct UserObject *uo94 = (struct UserObject*)obj29;
  uo94->data[29] = emptyclosure;
  Method *meth_meth_ast_isSelfOrOuter94 = addmethod2pos(obj29, "isSelfOrOuter", &meth_ast_isSelfOrOuter94, 29);
  int argcv_meth_ast_isSelfOrOuter94[] = {0};
  meth_meth_ast_isSelfOrOuter94->type = alloc_MethodType(1, argcv_meth_ast_isSelfOrOuter94);
  meth_meth_ast_isSelfOrOuter94->definitionModule = modulename;
  meth_meth_ast_isSelfOrOuter94->definitionLine = 126;
// method "isBlock"
  struct UserObject *uo96 = (struct UserObject*)obj29;
  uo96->data[30] = emptyclosure;
  Method *meth_meth_ast_isBlock96 = addmethod2pos(obj29, "isBlock", &meth_ast_isBlock96, 30);
  int argcv_meth_ast_isBlock96[] = {0};
  meth_meth_ast_isBlock96->type = alloc_MethodType(1, argcv_meth_ast_isBlock96);
  meth_meth_ast_isBlock96->definitionModule = modulename;
  meth_meth_ast_isBlock96->definitionLine = 127;
// method "isObject"
  struct UserObject *uo98 = (struct UserObject*)obj29;
  uo98->data[31] = emptyclosure;
  Method *meth_meth_ast_isObject98 = addmethod2pos(obj29, "isObject", &meth_ast_isObject98, 31);
  int argcv_meth_ast_isObject98[] = {0};
  meth_meth_ast_isObject98->type = alloc_MethodType(1, argcv_meth_ast_isObject98);
  meth_meth_ast_isObject98->definitionModule = modulename;
  meth_meth_ast_isObject98->definitionLine = 128;
// method "isIdentifier"
  struct UserObject *uo100 = (struct UserObject*)obj29;
  uo100->data[32] = emptyclosure;
  Method *meth_meth_ast_isIdentifier100 = addmethod2pos(obj29, "isIdentifier", &meth_ast_isIdentifier100, 32);
  int argcv_meth_ast_isIdentifier100[] = {0};
  meth_meth_ast_isIdentifier100->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier100);
  meth_meth_ast_isIdentifier100->definitionModule = modulename;
  meth_meth_ast_isIdentifier100->definitionLine = 129;
// method "isDialect"
  struct UserObject *uo102 = (struct UserObject*)obj29;
  uo102->data[33] = emptyclosure;
  Method *meth_meth_ast_isDialect102 = addmethod2pos(obj29, "isDialect", &meth_ast_isDialect102, 33);
  int argcv_meth_ast_isDialect102[] = {0};
  meth_meth_ast_isDialect102->type = alloc_MethodType(1, argcv_meth_ast_isDialect102);
  meth_meth_ast_isDialect102->definitionModule = modulename;
  meth_meth_ast_isDialect102->definitionLine = 130;
// method "isImport"
  struct UserObject *uo104 = (struct UserObject*)obj29;
  uo104->data[34] = emptyclosure;
  Method *meth_meth_ast_isImport104 = addmethod2pos(obj29, "isImport", &meth_ast_isImport104, 34);
  int argcv_meth_ast_isImport104[] = {0};
  meth_meth_ast_isImport104->type = alloc_MethodType(1, argcv_meth_ast_isImport104);
  meth_meth_ast_isImport104->definitionModule = modulename;
  meth_meth_ast_isImport104->definitionLine = 131;
// method "isTypeDec"
  struct UserObject *uo106 = (struct UserObject*)obj29;
  uo106->data[35] = emptyclosure;
  Method *meth_meth_ast_isTypeDec106 = addmethod2pos(obj29, "isTypeDec", &meth_ast_isTypeDec106, 35);
  int argcv_meth_ast_isTypeDec106[] = {0};
  meth_meth_ast_isTypeDec106->type = alloc_MethodType(1, argcv_meth_ast_isTypeDec106);
  meth_meth_ast_isTypeDec106->definitionModule = modulename;
  meth_meth_ast_isTypeDec106->definitionLine = 132;
// method "isExternal"
  struct UserObject *uo108 = (struct UserObject*)obj29;
  uo108->data[36] = emptyclosure;
  Method *meth_meth_ast_isExternal108 = addmethod2pos(obj29, "isExternal", &meth_ast_isExternal108, 36);
  int argcv_meth_ast_isExternal108[] = {0};
  meth_meth_ast_isExternal108->type = alloc_MethodType(1, argcv_meth_ast_isExternal108);
  meth_meth_ast_isExternal108->definitionModule = modulename;
  meth_meth_ast_isExternal108->definitionLine = 133;
// method "canInherit"
  struct UserObject *uo110 = (struct UserObject*)obj29;
  uo110->data[37] = emptyclosure;
  Method *meth_meth_ast_canInherit110 = addmethod2pos(obj29, "canInherit", &meth_ast_canInherit110, 37);
  int argcv_meth_ast_canInherit110[] = {0};
  meth_meth_ast_canInherit110->type = alloc_MethodType(1, argcv_meth_ast_canInherit110);
  meth_meth_ast_canInherit110->definitionModule = modulename;
  meth_meth_ast_canInherit110->definitionLine = 134;
// method "returnsObject"
  struct UserObject *uo112 = (struct UserObject*)obj29;
  uo112->data[38] = emptyclosure;
  Method *meth_meth_ast_returnsObject112 = addmethod2pos(obj29, "returnsObject", &meth_ast_returnsObject112, 38);
  int argcv_meth_ast_returnsObject112[] = {0};
  meth_meth_ast_returnsObject112->type = alloc_MethodType(1, argcv_meth_ast_returnsObject112);
  meth_meth_ast_returnsObject112->definitionModule = modulename;
  meth_meth_ast_returnsObject112->definitionLine = 135;
// method "isImplicit"
  struct UserObject *uo114 = (struct UserObject*)obj29;
  uo114->data[39] = emptyclosure;
  Method *meth_meth_ast_isImplicit114 = addmethod2pos(obj29, "isImplicit", &meth_ast_isImplicit114, 39);
  int argcv_meth_ast_isImplicit114[] = {0};
  meth_meth_ast_isImplicit114->type = alloc_MethodType(1, argcv_meth_ast_isImplicit114);
  meth_meth_ast_isImplicit114->definitionModule = modulename;
  meth_meth_ast_isImplicit114->definitionLine = 136;
// method "usesAsType(_)"
  struct UserObject *uo116 = (struct UserObject*)obj29;
  uo116->data[40] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_116 = addmethod2pos(obj29, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_116, 40);
  int argcv_meth_ast_usesAsType_40_1_41_116[] = {1};
  meth_meth_ast_usesAsType_40_1_41_116->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_116);
  meth_meth_ast_usesAsType_40_1_41_116->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_116->definitionLine = 137;
// method "hash"
  struct UserObject *uo118 = (struct UserObject*)obj29;
  uo118->data[41] = emptyclosure;
  Method *meth_meth_ast_hash118 = addmethod2pos(obj29, "hash", &meth_ast_hash118, 41);
  int argcv_meth_ast_hash118[] = {0};
  meth_meth_ast_hash118->type = alloc_MethodType(1, argcv_meth_ast_hash118);
  meth_meth_ast_hash118->definitionModule = modulename;
  meth_meth_ast_hash118->definitionLine = 138;
// method "asString"
  struct UserObject *uo130 = (struct UserObject*)obj29;
  uo130->data[42] = emptyclosure;
  Method *meth_meth_ast_asString130 = addmethod2pos(obj29, "asString", &meth_ast_asString130, 42);
  int argcv_meth_ast_asString130[] = {0};
  meth_meth_ast_asString130->type = alloc_MethodType(1, argcv_meth_ast_asString130);
  meth_meth_ast_asString130->definitionModule = modulename;
  meth_meth_ast_asString130->definitionLine = 139;
// method "nameString"
  struct UserObject *uo150 = (struct UserObject*)obj29;
  uo150->data[43] = emptyclosure;
  Method *meth_meth_ast_nameString150 = addmethod2pos(obj29, "nameString", &meth_ast_nameString150, 43);
  int argcv_meth_ast_nameString150[] = {0};
  meth_meth_ast_nameString150->type = alloc_MethodType(1, argcv_meth_ast_nameString150);
  meth_meth_ast_nameString150->definitionModule = modulename;
  meth_meth_ast_nameString150->definitionLine = 140;
// method "isWritable"
  struct UserObject *uo152 = (struct UserObject*)obj29;
  uo152->data[44] = emptyclosure;
  Method *meth_meth_ast_isWritable152 = addmethod2pos(obj29, "isWritable", &meth_ast_isWritable152, 44);
  int argcv_meth_ast_isWritable152[] = {0};
  meth_meth_ast_isWritable152->type = alloc_MethodType(1, argcv_meth_ast_isWritable152);
  meth_meth_ast_isWritable152->definitionModule = modulename;
  meth_meth_ast_isWritable152->definitionLine = 141;
// method "isReadable"
  struct UserObject *uo154 = (struct UserObject*)obj29;
  uo154->data[45] = emptyclosure;
  Method *meth_meth_ast_isReadable154 = addmethod2pos(obj29, "isReadable", &meth_ast_isReadable154, 45);
  int argcv_meth_ast_isReadable154[] = {0};
  meth_meth_ast_isReadable154->type = alloc_MethodType(1, argcv_meth_ast_isReadable154);
  meth_meth_ast_isReadable154->definitionModule = modulename;
  meth_meth_ast_isReadable154->definitionLine = 142;
// method "isPublic"
  struct UserObject *uo156 = (struct UserObject*)obj29;
  uo156->data[46] = emptyclosure;
  Method *meth_meth_ast_isPublic156 = addmethod2pos(obj29, "isPublic", &meth_ast_isPublic156, 46);
  int argcv_meth_ast_isPublic156[] = {0};
  meth_meth_ast_isPublic156->type = alloc_MethodType(1, argcv_meth_ast_isPublic156);
  meth_meth_ast_isPublic156->definitionModule = modulename;
  meth_meth_ast_isPublic156->definitionLine = 143;
// method "isConfidential"
  struct UserObject *uo158 = (struct UserObject*)obj29;
  uo158->data[47] = emptyclosure;
  Method *meth_meth_ast_isConfidential158 = addmethod2pos(obj29, "isConfidential", &meth_ast_isConfidential158, 47);
  int argcv_meth_ast_isConfidential158[] = {0};
  meth_meth_ast_isConfidential158->type = alloc_MethodType(1, argcv_meth_ast_isConfidential158);
  meth_meth_ast_isConfidential158->definitionModule = modulename;
  meth_meth_ast_isConfidential158->definitionLine = 144;
// method "decType"
  block_savedest(obj29);
  Object closure163 = createclosure(1, "decType");
  setclosureframe(closure163, stackframe);
  addtoclosure(closure163, var_unknownType);
  struct UserObject *uo163 = (struct UserObject*)obj29;
  uo163->data[48] = (Object)closure163;
  Method *meth_meth_ast_decType163 = addmethod2pos(obj29, "decType", &meth_ast_decType163, 48);
  int argcv_meth_ast_decType163[] = {0};
  meth_meth_ast_decType163->type = alloc_MethodType(1, argcv_meth_ast_decType163);
  meth_meth_ast_decType163->definitionModule = modulename;
  meth_meth_ast_decType163->definitionLine = 145;
// method "isSimple"
  struct UserObject *uo173 = (struct UserObject*)obj29;
  uo173->data[49] = emptyclosure;
  Method *meth_meth_ast_isSimple173 = addmethod2pos(obj29, "isSimple", &meth_ast_isSimple173, 49);
  int argcv_meth_ast_isSimple173[] = {0};
  meth_meth_ast_isSimple173->type = alloc_MethodType(1, argcv_meth_ast_isSimple173);
  meth_meth_ast_isSimple173->definitionModule = modulename;
  meth_meth_ast_isSimple173->definitionLine = 151;
// method "isDelimited"
  struct UserObject *uo175 = (struct UserObject*)obj29;
  uo175->data[50] = emptyclosure;
  Method *meth_meth_ast_isDelimited175 = addmethod2pos(obj29, "isDelimited", &meth_ast_isDelimited175, 50);
  int argcv_meth_ast_isDelimited175[] = {0};
  meth_meth_ast_isDelimited175->type = alloc_MethodType(1, argcv_meth_ast_isDelimited175);
  meth_meth_ast_isDelimited175->definitionModule = modulename;
  meth_meth_ast_isDelimited175->definitionLine = 152;
// method "description"
  struct UserObject *uo177 = (struct UserObject*)obj29;
  uo177->data[51] = emptyclosure;
  Method *meth_meth_ast_description177 = addmethod2pos(obj29, "description", &meth_ast_description177, 51);
  int argcv_meth_ast_description177[] = {0};
  meth_meth_ast_description177->type = alloc_MethodType(1, argcv_meth_ast_description177);
  meth_meth_ast_description177->definitionModule = modulename;
  meth_meth_ast_description177->definitionLine = 153;
// method "accept(_)"
  block_savedest(obj29);
  Object closure180 = createclosure(1, "accept(1)");
  setclosureframe(closure180, stackframe);
  addtoclosure(closure180, var_ancestorChain);
  struct UserObject *uo180 = (struct UserObject*)obj29;
  uo180->data[52] = (Object)closure180;
  Method *meth_meth_ast_accept_40_1_41_180 = addmethod2pos(obj29, "accept(1)", &meth_ast_accept_40_1_41_180, 52);
  int argcv_meth_ast_accept_40_1_41_180[] = {1};
  meth_meth_ast_accept_40_1_41_180->type = alloc_MethodType(1, argcv_meth_ast_accept_40_1_41_180);
  meth_meth_ast_accept_40_1_41_180->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_180->definitionLine = 154;
// method "scope"
  struct UserObject *uo185 = (struct UserObject*)obj29;
  uo185->data[53] = emptyclosure;
  Method *meth_meth_ast_scope185 = addmethod2pos(obj29, "scope", &meth_ast_scope185, 53);
  int argcv_meth_ast_scope185[] = {0};
  meth_meth_ast_scope185->type = alloc_MethodType(1, argcv_meth_ast_scope185);
  meth_meth_ast_scope185->definitionModule = modulename;
  meth_meth_ast_scope185->definitionLine = 157;
// method "scope:=(_)"
  struct UserObject *uo188 = (struct UserObject*)obj29;
  uo188->data[54] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_188 = addmethod2pos(obj29, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_188, 54);
  int argcv_meth_ast_scope_58__61__40_1_41_188[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_188->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_188);
  meth_meth_ast_scope_58__61__40_1_41_188->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_188->definitionLine = 159;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo191 = (struct UserObject*)obj29;
  uo191->data[55] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_191 = addmethod2pos(obj29, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_191, 55);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_191[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_191->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_191);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_191->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_191->definitionLine = 166;
// method "pretty(_)"
  block_savedest(obj29);
  Object closure208 = createclosure(1, "pretty(1)");
  setclosureframe(closure208, stackframe);
  addtoclosure(closure208, var_util);
  struct UserObject *uo208 = (struct UserObject*)obj29;
  uo208->data[56] = (Object)closure208;
  Method *meth_meth_ast_pretty_40_1_41_208 = addmethod2pos(obj29, "pretty(1)", &meth_ast_pretty_40_1_41_208, 56);
  int argcv_meth_ast_pretty_40_1_41_208[] = {1};
  meth_meth_ast_pretty_40_1_41_208->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_208);
  meth_meth_ast_pretty_40_1_41_208->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_208->definitionLine = 173;
// method "deepCopy"
  block_savedest(obj29);
  Object closure386 = createclosure(1, "deepCopy");
  setclosureframe(closure386, stackframe);
  addtoclosure(closure386, var_ancestorChain);
  struct UserObject *uo386 = (struct UserObject*)obj29;
  uo386->data[57] = (Object)closure386;
  Method *meth_meth_ast_deepCopy386 = addmethod2pos(obj29, "deepCopy", &meth_ast_deepCopy386, 57);
  int argcv_meth_ast_deepCopy386[] = {0};
  meth_meth_ast_deepCopy386->type = alloc_MethodType(1, argcv_meth_ast_deepCopy386);
  meth_meth_ast_deepCopy386->definitionModule = modulename;
  meth_meth_ast_deepCopy386->definitionLine = 186;
// method "enclosingObject"
  struct UserObject *uo394 = (struct UserObject*)obj29;
  uo394->data[58] = emptyclosure;
  Method *meth_meth_ast_enclosingObject394 = addmethod2pos(obj29, "enclosingObject", &meth_ast_enclosingObject394, 58);
  int argcv_meth_ast_enclosingObject394[] = {0};
  meth_meth_ast_enclosingObject394->type = alloc_MethodType(1, argcv_meth_ast_enclosingObject394);
  meth_meth_ast_enclosingObject394->definitionModule = modulename;
  meth_meth_ast_enclosingObject394->definitionLine = 189;
// method "addComment(_)"
  struct UserObject *uo401 = (struct UserObject*)obj29;
  uo401->data[59] = emptyclosure;
  Method *meth_meth_ast_addComment_40_1_41_401 = addmethod2pos(obj29, "addComment(1)", &meth_ast_addComment_40_1_41_401, 59);
  int argcv_meth_ast_addComment_40_1_41_401[] = {1};
  meth_meth_ast_addComment_40_1_41_401->type = alloc_MethodType(1, argcv_meth_ast_addComment_40_1_41_401);
  meth_meth_ast_addComment_40_1_41_401->definitionModule = modulename;
  meth_meth_ast_addComment_40_1_41_401->definitionLine = 193;
// method "addComments(_)"
  struct UserObject *uo415 = (struct UserObject*)obj29;
  uo415->data[60] = emptyclosure;
  Method *meth_meth_ast_addComments_40_1_41_415 = addmethod2pos(obj29, "addComments(1)", &meth_ast_addComments_40_1_41_415, 60);
  int argcv_meth_ast_addComments_40_1_41_415[] = {1};
  meth_meth_ast_addComments_40_1_41_415->type = alloc_MethodType(1, argcv_meth_ast_addComments_40_1_41_415);
  meth_meth_ast_addComments_40_1_41_415->definitionModule = modulename;
  meth_meth_ast_addComments_40_1_41_415->definitionLine = 200;
// method "statementName"
  struct UserObject *uo423 = (struct UserObject*)obj29;
  uo423->data[61] = emptyclosure;
  Method *meth_meth_ast_statementName423 = addmethod2pos(obj29, "statementName", &meth_ast_statementName423, 61);
  int argcv_meth_ast_statementName423[] = {0};
  meth_meth_ast_statementName423->type = alloc_MethodType(1, argcv_meth_ast_statementName423);
  meth_meth_ast_statementName423->definitionModule = modulename;
  meth_meth_ast_statementName423->definitionLine = 203;
  sourceObject = obj29;
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit426 == NULL) {
    strlit426 = alloc_String("");
    gc_root(strlit426);
  }
// compiled string node returning strlit426 (depth = 2)
  adddatum2(obj29, strlit426, 1);
  sourceObject = obj29;
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe427 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  Object call428 = callmethodflags(*var_util, "linenum", 0, partcv, params, 0);
  gc_frame_end(callframe427);
// compiled member node returning call428 (depth = 2)
  adddatum2(obj29, call428, 2);
  sourceObject = obj29;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe429 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  Object call430 = callmethodflags(*var_util, "linepos", 0, partcv, params, 0);
  gc_frame_end(callframe429);
// compiled member node returning call430 (depth = 2)
  adddatum2(obj29, call430, 3);
  sourceObject = obj29;
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_fakeSymbolTable (depth = 2)
  adddatum2(obj29, *var_fakeSymbolTable, 4);
  sourceObject = obj29;
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool431 = alloc_Boolean(0);
// compiled identifier node returning bool431 (depth = 2)
  adddatum2(obj29, bool431, 5);
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  objclass29 = obj29->class;
  objclass29->definitionModule = modulename;
  objclass29->definitionLine = 87;
  (*(struct UserObject *)self).data[0] = lowerouter29;
  self = oldself29;
  selfslot = oldselfslot29;
  stackframe = oldstackframe29;
  gc_frame_end(frame);
  return obj29;
}
Object meth_ast_baseNode28_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "baseNode$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  Object *var_ancestorChain = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_fakeSymbolTable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject29 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj29 = alloc_userobj2(66,62, objclass29);
  gc_frame_newslot(obj29);
if (objclass29 == NULL) {
  glfree(obj29->class->name);
  obj29->class->name = "baseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj29, self, 0);
  addmethodreal(obj29,"outer", &reader_ast_outer_30);
  Object oldself29 = self;
  struct StackFrameObject *oldstackframe29 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe29);
  gc_frame_newslot((Object)stackframe);
  self = obj29;
  Object *oldselfslot29 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter29 = (*(struct UserObject *)self).data[0], lowerouter29 = thisouter29;
  if (inheritingObject29) {
    struct UserObject *inho29 = (struct UserObject *)inheritingObject29;
    while (inho29->super != GraceDefaultObject) inho29 = (struct UserObject *)inho29->super;
    inho29->super = obj29;
    self = inheritingObject29;
    *selfslot = self;
    lowerouter29 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter29;
  }
if (objclass29 == NULL) {
  Method *reader31 = addmethodrealflags(obj29, "register", &reader_ast_register_31, 0);
  Method *writer31 = addmethodrealflags(obj29, "register:=(1)", &writer_ast_register_31, 0);
  reader31->definitionModule = modulename;
  writer31->definitionModule = modulename;
  reader31->definitionLine = 89;
  writer31->definitionLine = 89;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 1);
if (objclass29 == NULL) {
  Method *reader32 = addmethodrealflags(obj29, "line", &reader_ast_line_32, 0);
  Method *writer32 = addmethodrealflags(obj29, "line:=(1)", &writer_ast_line_32, 0);
  reader32->definitionModule = modulename;
  writer32->definitionModule = modulename;
  reader32->definitionLine = 90;
  writer32->definitionLine = 90;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 2);
if (objclass29 == NULL) {
  Method *reader33 = addmethodrealflags(obj29, "linePos", &reader_ast_linePos_33, 0);
  Method *writer33 = addmethodrealflags(obj29, "linePos:=(1)", &writer_ast_linePos_33, 0);
  reader33->definitionModule = modulename;
  writer33->definitionModule = modulename;
  reader33->definitionLine = 91;
  writer33->definitionLine = 91;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 3);
if (objclass29 == NULL) {
  Method *reader34 = addmethodrealflags(obj29, "symbolTable", &reader_ast_symbolTable_34, MFLAG_CONFIDENTIAL);
  Method *writer34 = addmethodrealflags(obj29, "symbolTable:=(1)", &writer_ast_symbolTable_34, MFLAG_CONFIDENTIAL);
  reader34->definitionModule = modulename;
  writer34->definitionModule = modulename;
  reader34->definitionLine = 92;
  writer34->definitionLine = 92;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 4);
if (objclass29 == NULL) {
  Method *reader35 = addmethodrealflags(obj29, "comments", &reader_ast_comments_35, 0);
  Method *writer35 = addmethodrealflags(obj29, "comments:=(1)", &writer_ast_comments_35, 0);
  reader35->definitionModule = modulename;
  writer35->definitionModule = modulename;
  reader35->definitionLine = 93;
  writer35->definitionLine = 93;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 5);
// method "setLine(_)col(_)"
  struct UserObject *uo36 = (struct UserObject*)obj29;
  uo36->data[6] = emptyclosure;
  Method *meth_meth_ast_setLine_40_1_41_col_40_1_41_36 = addmethod2pos(obj29, "setLine(1)col(1)", &meth_ast_setLine_40_1_41_col_40_1_41_36, 6);
  int argcv_meth_ast_setLine_40_1_41_col_40_1_41_36[] = {1, 1};
  meth_meth_ast_setLine_40_1_41_col_40_1_41_36->type = alloc_MethodType(2, argcv_meth_ast_setLine_40_1_41_col_40_1_41_36);
  meth_meth_ast_setLine_40_1_41_col_40_1_41_36->definitionModule = modulename;
  meth_meth_ast_setLine_40_1_41_col_40_1_41_36->definitionLine = 95;
// method "setPositionFrom(_)"
  struct UserObject *uo41 = (struct UserObject*)obj29;
  uo41->data[7] = emptyclosure;
  Method *meth_meth_ast_setPositionFrom_40_1_41_41 = addmethod2pos(obj29, "setPositionFrom(1)", &meth_ast_setPositionFrom_40_1_41_41, 7);
  int argcv_meth_ast_setPositionFrom_40_1_41_41[] = {1};
  meth_meth_ast_setPositionFrom_40_1_41_41->type = alloc_MethodType(1, argcv_meth_ast_setPositionFrom_40_1_41_41);
  meth_meth_ast_setPositionFrom_40_1_41_41->definitionModule = modulename;
  meth_meth_ast_setPositionFrom_40_1_41_41->definitionLine = 100;
// method "kind"
  struct UserObject *uo50 = (struct UserObject*)obj29;
  uo50->data[8] = emptyclosure;
  Method *meth_meth_ast_kind50 = addmethod2pos(obj29, "kind", &meth_ast_kind50, 8);
  int argcv_meth_ast_kind50[] = {0};
  meth_meth_ast_kind50->type = alloc_MethodType(1, argcv_meth_ast_kind50);
  meth_meth_ast_kind50->definitionModule = modulename;
  meth_meth_ast_kind50->definitionLine = 105;
// method "==(_)"
  struct UserObject *uo53 = (struct UserObject*)obj29;
  uo53->data[9] = emptyclosure;
  Method *meth_meth_ast__61__61__40_1_41_53 = addmethod2pos(obj29, "==(1)", &meth_ast__61__61__40_1_41_53, 9);
  int argcv_meth_ast__61__61__40_1_41_53[] = {1};
  meth_meth_ast__61__61__40_1_41_53->type = alloc_MethodType(1, argcv_meth_ast__61__61__40_1_41_53);
  meth_meth_ast__61__61__40_1_41_53->definitionModule = modulename;
  meth_meth_ast__61__61__40_1_41_53->definitionLine = 106;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo56 = (struct UserObject*)obj29;
  uo56->data[10] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier56 = addmethod2pos(obj29, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier56, 10);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier56[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier56->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier56);
  meth_meth_ast_isAppliedOccurenceOfIdentifier56->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier56->definitionLine = 107;
// method "isMatchingBlock"
  struct UserObject *uo58 = (struct UserObject*)obj29;
  uo58->data[11] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock58 = addmethod2pos(obj29, "isMatchingBlock", &meth_ast_isMatchingBlock58, 11);
  int argcv_meth_ast_isMatchingBlock58[] = {0};
  meth_meth_ast_isMatchingBlock58->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock58);
  meth_meth_ast_isMatchingBlock58->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock58->definitionLine = 108;
// method "isFieldDec"
  struct UserObject *uo60 = (struct UserObject*)obj29;
  uo60->data[12] = emptyclosure;
  Method *meth_meth_ast_isFieldDec60 = addmethod2pos(obj29, "isFieldDec", &meth_ast_isFieldDec60, 12);
  int argcv_meth_ast_isFieldDec60[] = {0};
  meth_meth_ast_isFieldDec60->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec60);
  meth_meth_ast_isFieldDec60->definitionModule = modulename;
  meth_meth_ast_isFieldDec60->definitionLine = 109;
// method "isInherits"
  struct UserObject *uo62 = (struct UserObject*)obj29;
  uo62->data[13] = emptyclosure;
  Method *meth_meth_ast_isInherits62 = addmethod2pos(obj29, "isInherits", &meth_ast_isInherits62, 13);
  int argcv_meth_ast_isInherits62[] = {0};
  meth_meth_ast_isInherits62->type = alloc_MethodType(1, argcv_meth_ast_isInherits62);
  meth_meth_ast_isInherits62->definitionModule = modulename;
  meth_meth_ast_isInherits62->definitionLine = 110;
// method "isLegalInTrait"
  struct UserObject *uo64 = (struct UserObject*)obj29;
  uo64->data[14] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait64 = addmethod2pos(obj29, "isLegalInTrait", &meth_ast_isLegalInTrait64, 14);
  int argcv_meth_ast_isLegalInTrait64[] = {0};
  meth_meth_ast_isLegalInTrait64->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait64);
  meth_meth_ast_isLegalInTrait64->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait64->definitionLine = 111;
// method "isMember"
  struct UserObject *uo66 = (struct UserObject*)obj29;
  uo66->data[15] = emptyclosure;
  Method *meth_meth_ast_isMember66 = addmethod2pos(obj29, "isMember", &meth_ast_isMember66, 15);
  int argcv_meth_ast_isMember66[] = {0};
  meth_meth_ast_isMember66->type = alloc_MethodType(1, argcv_meth_ast_isMember66);
  meth_meth_ast_isMember66->definitionModule = modulename;
  meth_meth_ast_isMember66->definitionLine = 112;
// method "isMethod"
  struct UserObject *uo68 = (struct UserObject*)obj29;
  uo68->data[16] = emptyclosure;
  Method *meth_meth_ast_isMethod68 = addmethod2pos(obj29, "isMethod", &meth_ast_isMethod68, 16);
  int argcv_meth_ast_isMethod68[] = {0};
  meth_meth_ast_isMethod68->type = alloc_MethodType(1, argcv_meth_ast_isMethod68);
  meth_meth_ast_isMethod68->definitionModule = modulename;
  meth_meth_ast_isMethod68->definitionLine = 113;
// method "isExecutable"
  struct UserObject *uo70 = (struct UserObject*)obj29;
  uo70->data[17] = emptyclosure;
  Method *meth_meth_ast_isExecutable70 = addmethod2pos(obj29, "isExecutable", &meth_ast_isExecutable70, 17);
  int argcv_meth_ast_isExecutable70[] = {0};
  meth_meth_ast_isExecutable70->type = alloc_MethodType(1, argcv_meth_ast_isExecutable70);
  meth_meth_ast_isExecutable70->definitionModule = modulename;
  meth_meth_ast_isExecutable70->definitionLine = 114;
// method "isCall"
  struct UserObject *uo72 = (struct UserObject*)obj29;
  uo72->data[18] = emptyclosure;
  Method *meth_meth_ast_isCall72 = addmethod2pos(obj29, "isCall", &meth_ast_isCall72, 18);
  int argcv_meth_ast_isCall72[] = {0};
  meth_meth_ast_isCall72->type = alloc_MethodType(1, argcv_meth_ast_isCall72);
  meth_meth_ast_isCall72->definitionModule = modulename;
  meth_meth_ast_isCall72->definitionLine = 115;
// method "isComment"
  struct UserObject *uo74 = (struct UserObject*)obj29;
  uo74->data[19] = emptyclosure;
  Method *meth_meth_ast_isComment74 = addmethod2pos(obj29, "isComment", &meth_ast_isComment74, 19);
  int argcv_meth_ast_isComment74[] = {0};
  meth_meth_ast_isComment74->type = alloc_MethodType(1, argcv_meth_ast_isComment74);
  meth_meth_ast_isComment74->definitionModule = modulename;
  meth_meth_ast_isComment74->definitionLine = 116;
// method "isClass"
  struct UserObject *uo76 = (struct UserObject*)obj29;
  uo76->data[20] = emptyclosure;
  Method *meth_meth_ast_isClass76 = addmethod2pos(obj29, "isClass", &meth_ast_isClass76, 20);
  int argcv_meth_ast_isClass76[] = {0};
  meth_meth_ast_isClass76->type = alloc_MethodType(1, argcv_meth_ast_isClass76);
  meth_meth_ast_isClass76->definitionModule = modulename;
  meth_meth_ast_isClass76->definitionLine = 117;
// method "inClass"
  struct UserObject *uo78 = (struct UserObject*)obj29;
  uo78->data[21] = emptyclosure;
  Method *meth_meth_ast_inClass78 = addmethod2pos(obj29, "inClass", &meth_ast_inClass78, 21);
  int argcv_meth_ast_inClass78[] = {0};
  meth_meth_ast_inClass78->type = alloc_MethodType(1, argcv_meth_ast_inClass78);
  meth_meth_ast_inClass78->definitionModule = modulename;
  meth_meth_ast_inClass78->definitionLine = 118;
// method "isTrait"
  struct UserObject *uo80 = (struct UserObject*)obj29;
  uo80->data[22] = emptyclosure;
  Method *meth_meth_ast_isTrait80 = addmethod2pos(obj29, "isTrait", &meth_ast_isTrait80, 22);
  int argcv_meth_ast_isTrait80[] = {0};
  meth_meth_ast_isTrait80->type = alloc_MethodType(1, argcv_meth_ast_isTrait80);
  meth_meth_ast_isTrait80->definitionModule = modulename;
  meth_meth_ast_isTrait80->definitionLine = 119;
// method "inTrait"
  struct UserObject *uo82 = (struct UserObject*)obj29;
  uo82->data[23] = emptyclosure;
  Method *meth_meth_ast_inTrait82 = addmethod2pos(obj29, "inTrait", &meth_ast_inTrait82, 23);
  int argcv_meth_ast_inTrait82[] = {0};
  meth_meth_ast_inTrait82->type = alloc_MethodType(1, argcv_meth_ast_inTrait82);
  meth_meth_ast_inTrait82->definitionModule = modulename;
  meth_meth_ast_inTrait82->definitionLine = 120;
// method "isBind"
  struct UserObject *uo84 = (struct UserObject*)obj29;
  uo84->data[24] = emptyclosure;
  Method *meth_meth_ast_isBind84 = addmethod2pos(obj29, "isBind", &meth_ast_isBind84, 24);
  int argcv_meth_ast_isBind84[] = {0};
  meth_meth_ast_isBind84->type = alloc_MethodType(1, argcv_meth_ast_isBind84);
  meth_meth_ast_isBind84->definitionModule = modulename;
  meth_meth_ast_isBind84->definitionLine = 121;
// method "isSelf"
  struct UserObject *uo86 = (struct UserObject*)obj29;
  uo86->data[25] = emptyclosure;
  Method *meth_meth_ast_isSelf86 = addmethod2pos(obj29, "isSelf", &meth_ast_isSelf86, 25);
  int argcv_meth_ast_isSelf86[] = {0};
  meth_meth_ast_isSelf86->type = alloc_MethodType(1, argcv_meth_ast_isSelf86);
  meth_meth_ast_isSelf86->definitionModule = modulename;
  meth_meth_ast_isSelf86->definitionLine = 122;
// method "isSuper"
  struct UserObject *uo88 = (struct UserObject*)obj29;
  uo88->data[26] = emptyclosure;
  Method *meth_meth_ast_isSuper88 = addmethod2pos(obj29, "isSuper", &meth_ast_isSuper88, 26);
  int argcv_meth_ast_isSuper88[] = {0};
  meth_meth_ast_isSuper88->type = alloc_MethodType(1, argcv_meth_ast_isSuper88);
  meth_meth_ast_isSuper88->definitionModule = modulename;
  meth_meth_ast_isSuper88->definitionLine = 123;
// method "isPrelude"
  struct UserObject *uo90 = (struct UserObject*)obj29;
  uo90->data[27] = emptyclosure;
  Method *meth_meth_ast_isPrelude90 = addmethod2pos(obj29, "isPrelude", &meth_ast_isPrelude90, 27);
  int argcv_meth_ast_isPrelude90[] = {0};
  meth_meth_ast_isPrelude90->type = alloc_MethodType(1, argcv_meth_ast_isPrelude90);
  meth_meth_ast_isPrelude90->definitionModule = modulename;
  meth_meth_ast_isPrelude90->definitionLine = 124;
// method "isOuter"
  struct UserObject *uo92 = (struct UserObject*)obj29;
  uo92->data[28] = emptyclosure;
  Method *meth_meth_ast_isOuter92 = addmethod2pos(obj29, "isOuter", &meth_ast_isOuter92, 28);
  int argcv_meth_ast_isOuter92[] = {0};
  meth_meth_ast_isOuter92->type = alloc_MethodType(1, argcv_meth_ast_isOuter92);
  meth_meth_ast_isOuter92->definitionModule = modulename;
  meth_meth_ast_isOuter92->definitionLine = 125;
// method "isSelfOrOuter"
  struct UserObject *uo94 = (struct UserObject*)obj29;
  uo94->data[29] = emptyclosure;
  Method *meth_meth_ast_isSelfOrOuter94 = addmethod2pos(obj29, "isSelfOrOuter", &meth_ast_isSelfOrOuter94, 29);
  int argcv_meth_ast_isSelfOrOuter94[] = {0};
  meth_meth_ast_isSelfOrOuter94->type = alloc_MethodType(1, argcv_meth_ast_isSelfOrOuter94);
  meth_meth_ast_isSelfOrOuter94->definitionModule = modulename;
  meth_meth_ast_isSelfOrOuter94->definitionLine = 126;
// method "isBlock"
  struct UserObject *uo96 = (struct UserObject*)obj29;
  uo96->data[30] = emptyclosure;
  Method *meth_meth_ast_isBlock96 = addmethod2pos(obj29, "isBlock", &meth_ast_isBlock96, 30);
  int argcv_meth_ast_isBlock96[] = {0};
  meth_meth_ast_isBlock96->type = alloc_MethodType(1, argcv_meth_ast_isBlock96);
  meth_meth_ast_isBlock96->definitionModule = modulename;
  meth_meth_ast_isBlock96->definitionLine = 127;
// method "isObject"
  struct UserObject *uo98 = (struct UserObject*)obj29;
  uo98->data[31] = emptyclosure;
  Method *meth_meth_ast_isObject98 = addmethod2pos(obj29, "isObject", &meth_ast_isObject98, 31);
  int argcv_meth_ast_isObject98[] = {0};
  meth_meth_ast_isObject98->type = alloc_MethodType(1, argcv_meth_ast_isObject98);
  meth_meth_ast_isObject98->definitionModule = modulename;
  meth_meth_ast_isObject98->definitionLine = 128;
// method "isIdentifier"
  struct UserObject *uo100 = (struct UserObject*)obj29;
  uo100->data[32] = emptyclosure;
  Method *meth_meth_ast_isIdentifier100 = addmethod2pos(obj29, "isIdentifier", &meth_ast_isIdentifier100, 32);
  int argcv_meth_ast_isIdentifier100[] = {0};
  meth_meth_ast_isIdentifier100->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier100);
  meth_meth_ast_isIdentifier100->definitionModule = modulename;
  meth_meth_ast_isIdentifier100->definitionLine = 129;
// method "isDialect"
  struct UserObject *uo102 = (struct UserObject*)obj29;
  uo102->data[33] = emptyclosure;
  Method *meth_meth_ast_isDialect102 = addmethod2pos(obj29, "isDialect", &meth_ast_isDialect102, 33);
  int argcv_meth_ast_isDialect102[] = {0};
  meth_meth_ast_isDialect102->type = alloc_MethodType(1, argcv_meth_ast_isDialect102);
  meth_meth_ast_isDialect102->definitionModule = modulename;
  meth_meth_ast_isDialect102->definitionLine = 130;
// method "isImport"
  struct UserObject *uo104 = (struct UserObject*)obj29;
  uo104->data[34] = emptyclosure;
  Method *meth_meth_ast_isImport104 = addmethod2pos(obj29, "isImport", &meth_ast_isImport104, 34);
  int argcv_meth_ast_isImport104[] = {0};
  meth_meth_ast_isImport104->type = alloc_MethodType(1, argcv_meth_ast_isImport104);
  meth_meth_ast_isImport104->definitionModule = modulename;
  meth_meth_ast_isImport104->definitionLine = 131;
// method "isTypeDec"
  struct UserObject *uo106 = (struct UserObject*)obj29;
  uo106->data[35] = emptyclosure;
  Method *meth_meth_ast_isTypeDec106 = addmethod2pos(obj29, "isTypeDec", &meth_ast_isTypeDec106, 35);
  int argcv_meth_ast_isTypeDec106[] = {0};
  meth_meth_ast_isTypeDec106->type = alloc_MethodType(1, argcv_meth_ast_isTypeDec106);
  meth_meth_ast_isTypeDec106->definitionModule = modulename;
  meth_meth_ast_isTypeDec106->definitionLine = 132;
// method "isExternal"
  struct UserObject *uo108 = (struct UserObject*)obj29;
  uo108->data[36] = emptyclosure;
  Method *meth_meth_ast_isExternal108 = addmethod2pos(obj29, "isExternal", &meth_ast_isExternal108, 36);
  int argcv_meth_ast_isExternal108[] = {0};
  meth_meth_ast_isExternal108->type = alloc_MethodType(1, argcv_meth_ast_isExternal108);
  meth_meth_ast_isExternal108->definitionModule = modulename;
  meth_meth_ast_isExternal108->definitionLine = 133;
// method "canInherit"
  struct UserObject *uo110 = (struct UserObject*)obj29;
  uo110->data[37] = emptyclosure;
  Method *meth_meth_ast_canInherit110 = addmethod2pos(obj29, "canInherit", &meth_ast_canInherit110, 37);
  int argcv_meth_ast_canInherit110[] = {0};
  meth_meth_ast_canInherit110->type = alloc_MethodType(1, argcv_meth_ast_canInherit110);
  meth_meth_ast_canInherit110->definitionModule = modulename;
  meth_meth_ast_canInherit110->definitionLine = 134;
// method "returnsObject"
  struct UserObject *uo112 = (struct UserObject*)obj29;
  uo112->data[38] = emptyclosure;
  Method *meth_meth_ast_returnsObject112 = addmethod2pos(obj29, "returnsObject", &meth_ast_returnsObject112, 38);
  int argcv_meth_ast_returnsObject112[] = {0};
  meth_meth_ast_returnsObject112->type = alloc_MethodType(1, argcv_meth_ast_returnsObject112);
  meth_meth_ast_returnsObject112->definitionModule = modulename;
  meth_meth_ast_returnsObject112->definitionLine = 135;
// method "isImplicit"
  struct UserObject *uo114 = (struct UserObject*)obj29;
  uo114->data[39] = emptyclosure;
  Method *meth_meth_ast_isImplicit114 = addmethod2pos(obj29, "isImplicit", &meth_ast_isImplicit114, 39);
  int argcv_meth_ast_isImplicit114[] = {0};
  meth_meth_ast_isImplicit114->type = alloc_MethodType(1, argcv_meth_ast_isImplicit114);
  meth_meth_ast_isImplicit114->definitionModule = modulename;
  meth_meth_ast_isImplicit114->definitionLine = 136;
// method "usesAsType(_)"
  struct UserObject *uo116 = (struct UserObject*)obj29;
  uo116->data[40] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_116 = addmethod2pos(obj29, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_116, 40);
  int argcv_meth_ast_usesAsType_40_1_41_116[] = {1};
  meth_meth_ast_usesAsType_40_1_41_116->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_116);
  meth_meth_ast_usesAsType_40_1_41_116->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_116->definitionLine = 137;
// method "hash"
  struct UserObject *uo118 = (struct UserObject*)obj29;
  uo118->data[41] = emptyclosure;
  Method *meth_meth_ast_hash118 = addmethod2pos(obj29, "hash", &meth_ast_hash118, 41);
  int argcv_meth_ast_hash118[] = {0};
  meth_meth_ast_hash118->type = alloc_MethodType(1, argcv_meth_ast_hash118);
  meth_meth_ast_hash118->definitionModule = modulename;
  meth_meth_ast_hash118->definitionLine = 138;
// method "asString"
  struct UserObject *uo130 = (struct UserObject*)obj29;
  uo130->data[42] = emptyclosure;
  Method *meth_meth_ast_asString130 = addmethod2pos(obj29, "asString", &meth_ast_asString130, 42);
  int argcv_meth_ast_asString130[] = {0};
  meth_meth_ast_asString130->type = alloc_MethodType(1, argcv_meth_ast_asString130);
  meth_meth_ast_asString130->definitionModule = modulename;
  meth_meth_ast_asString130->definitionLine = 139;
// method "nameString"
  struct UserObject *uo150 = (struct UserObject*)obj29;
  uo150->data[43] = emptyclosure;
  Method *meth_meth_ast_nameString150 = addmethod2pos(obj29, "nameString", &meth_ast_nameString150, 43);
  int argcv_meth_ast_nameString150[] = {0};
  meth_meth_ast_nameString150->type = alloc_MethodType(1, argcv_meth_ast_nameString150);
  meth_meth_ast_nameString150->definitionModule = modulename;
  meth_meth_ast_nameString150->definitionLine = 140;
// method "isWritable"
  struct UserObject *uo152 = (struct UserObject*)obj29;
  uo152->data[44] = emptyclosure;
  Method *meth_meth_ast_isWritable152 = addmethod2pos(obj29, "isWritable", &meth_ast_isWritable152, 44);
  int argcv_meth_ast_isWritable152[] = {0};
  meth_meth_ast_isWritable152->type = alloc_MethodType(1, argcv_meth_ast_isWritable152);
  meth_meth_ast_isWritable152->definitionModule = modulename;
  meth_meth_ast_isWritable152->definitionLine = 141;
// method "isReadable"
  struct UserObject *uo154 = (struct UserObject*)obj29;
  uo154->data[45] = emptyclosure;
  Method *meth_meth_ast_isReadable154 = addmethod2pos(obj29, "isReadable", &meth_ast_isReadable154, 45);
  int argcv_meth_ast_isReadable154[] = {0};
  meth_meth_ast_isReadable154->type = alloc_MethodType(1, argcv_meth_ast_isReadable154);
  meth_meth_ast_isReadable154->definitionModule = modulename;
  meth_meth_ast_isReadable154->definitionLine = 142;
// method "isPublic"
  struct UserObject *uo156 = (struct UserObject*)obj29;
  uo156->data[46] = emptyclosure;
  Method *meth_meth_ast_isPublic156 = addmethod2pos(obj29, "isPublic", &meth_ast_isPublic156, 46);
  int argcv_meth_ast_isPublic156[] = {0};
  meth_meth_ast_isPublic156->type = alloc_MethodType(1, argcv_meth_ast_isPublic156);
  meth_meth_ast_isPublic156->definitionModule = modulename;
  meth_meth_ast_isPublic156->definitionLine = 143;
// method "isConfidential"
  struct UserObject *uo158 = (struct UserObject*)obj29;
  uo158->data[47] = emptyclosure;
  Method *meth_meth_ast_isConfidential158 = addmethod2pos(obj29, "isConfidential", &meth_ast_isConfidential158, 47);
  int argcv_meth_ast_isConfidential158[] = {0};
  meth_meth_ast_isConfidential158->type = alloc_MethodType(1, argcv_meth_ast_isConfidential158);
  meth_meth_ast_isConfidential158->definitionModule = modulename;
  meth_meth_ast_isConfidential158->definitionLine = 144;
// method "decType"
  block_savedest(obj29);
  Object closure163 = createclosure(1, "decType");
  setclosureframe(closure163, stackframe);
  addtoclosure(closure163, var_unknownType);
  struct UserObject *uo163 = (struct UserObject*)obj29;
  uo163->data[48] = (Object)closure163;
  Method *meth_meth_ast_decType163 = addmethod2pos(obj29, "decType", &meth_ast_decType163, 48);
  int argcv_meth_ast_decType163[] = {0};
  meth_meth_ast_decType163->type = alloc_MethodType(1, argcv_meth_ast_decType163);
  meth_meth_ast_decType163->definitionModule = modulename;
  meth_meth_ast_decType163->definitionLine = 145;
// method "isSimple"
  struct UserObject *uo173 = (struct UserObject*)obj29;
  uo173->data[49] = emptyclosure;
  Method *meth_meth_ast_isSimple173 = addmethod2pos(obj29, "isSimple", &meth_ast_isSimple173, 49);
  int argcv_meth_ast_isSimple173[] = {0};
  meth_meth_ast_isSimple173->type = alloc_MethodType(1, argcv_meth_ast_isSimple173);
  meth_meth_ast_isSimple173->definitionModule = modulename;
  meth_meth_ast_isSimple173->definitionLine = 151;
// method "isDelimited"
  struct UserObject *uo175 = (struct UserObject*)obj29;
  uo175->data[50] = emptyclosure;
  Method *meth_meth_ast_isDelimited175 = addmethod2pos(obj29, "isDelimited", &meth_ast_isDelimited175, 50);
  int argcv_meth_ast_isDelimited175[] = {0};
  meth_meth_ast_isDelimited175->type = alloc_MethodType(1, argcv_meth_ast_isDelimited175);
  meth_meth_ast_isDelimited175->definitionModule = modulename;
  meth_meth_ast_isDelimited175->definitionLine = 152;
// method "description"
  struct UserObject *uo177 = (struct UserObject*)obj29;
  uo177->data[51] = emptyclosure;
  Method *meth_meth_ast_description177 = addmethod2pos(obj29, "description", &meth_ast_description177, 51);
  int argcv_meth_ast_description177[] = {0};
  meth_meth_ast_description177->type = alloc_MethodType(1, argcv_meth_ast_description177);
  meth_meth_ast_description177->definitionModule = modulename;
  meth_meth_ast_description177->definitionLine = 153;
// method "accept(_)"
  block_savedest(obj29);
  Object closure180 = createclosure(1, "accept(1)");
  setclosureframe(closure180, stackframe);
  addtoclosure(closure180, var_ancestorChain);
  struct UserObject *uo180 = (struct UserObject*)obj29;
  uo180->data[52] = (Object)closure180;
  Method *meth_meth_ast_accept_40_1_41_180 = addmethod2pos(obj29, "accept(1)", &meth_ast_accept_40_1_41_180, 52);
  int argcv_meth_ast_accept_40_1_41_180[] = {1};
  meth_meth_ast_accept_40_1_41_180->type = alloc_MethodType(1, argcv_meth_ast_accept_40_1_41_180);
  meth_meth_ast_accept_40_1_41_180->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_180->definitionLine = 154;
// method "scope"
  struct UserObject *uo185 = (struct UserObject*)obj29;
  uo185->data[53] = emptyclosure;
  Method *meth_meth_ast_scope185 = addmethod2pos(obj29, "scope", &meth_ast_scope185, 53);
  int argcv_meth_ast_scope185[] = {0};
  meth_meth_ast_scope185->type = alloc_MethodType(1, argcv_meth_ast_scope185);
  meth_meth_ast_scope185->definitionModule = modulename;
  meth_meth_ast_scope185->definitionLine = 157;
// method "scope:=(_)"
  struct UserObject *uo188 = (struct UserObject*)obj29;
  uo188->data[54] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_188 = addmethod2pos(obj29, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_188, 54);
  int argcv_meth_ast_scope_58__61__40_1_41_188[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_188->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_188);
  meth_meth_ast_scope_58__61__40_1_41_188->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_188->definitionLine = 159;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo191 = (struct UserObject*)obj29;
  uo191->data[55] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_191 = addmethod2pos(obj29, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_191, 55);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_191[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_191->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_191);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_191->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_191->definitionLine = 166;
// method "pretty(_)"
  block_savedest(obj29);
  Object closure208 = createclosure(1, "pretty(1)");
  setclosureframe(closure208, stackframe);
  addtoclosure(closure208, var_util);
  struct UserObject *uo208 = (struct UserObject*)obj29;
  uo208->data[56] = (Object)closure208;
  Method *meth_meth_ast_pretty_40_1_41_208 = addmethod2pos(obj29, "pretty(1)", &meth_ast_pretty_40_1_41_208, 56);
  int argcv_meth_ast_pretty_40_1_41_208[] = {1};
  meth_meth_ast_pretty_40_1_41_208->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_208);
  meth_meth_ast_pretty_40_1_41_208->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_208->definitionLine = 173;
// method "deepCopy"
  block_savedest(obj29);
  Object closure386 = createclosure(1, "deepCopy");
  setclosureframe(closure386, stackframe);
  addtoclosure(closure386, var_ancestorChain);
  struct UserObject *uo386 = (struct UserObject*)obj29;
  uo386->data[57] = (Object)closure386;
  Method *meth_meth_ast_deepCopy386 = addmethod2pos(obj29, "deepCopy", &meth_ast_deepCopy386, 57);
  int argcv_meth_ast_deepCopy386[] = {0};
  meth_meth_ast_deepCopy386->type = alloc_MethodType(1, argcv_meth_ast_deepCopy386);
  meth_meth_ast_deepCopy386->definitionModule = modulename;
  meth_meth_ast_deepCopy386->definitionLine = 186;
// method "enclosingObject"
  struct UserObject *uo394 = (struct UserObject*)obj29;
  uo394->data[58] = emptyclosure;
  Method *meth_meth_ast_enclosingObject394 = addmethod2pos(obj29, "enclosingObject", &meth_ast_enclosingObject394, 58);
  int argcv_meth_ast_enclosingObject394[] = {0};
  meth_meth_ast_enclosingObject394->type = alloc_MethodType(1, argcv_meth_ast_enclosingObject394);
  meth_meth_ast_enclosingObject394->definitionModule = modulename;
  meth_meth_ast_enclosingObject394->definitionLine = 189;
// method "addComment(_)"
  struct UserObject *uo401 = (struct UserObject*)obj29;
  uo401->data[59] = emptyclosure;
  Method *meth_meth_ast_addComment_40_1_41_401 = addmethod2pos(obj29, "addComment(1)", &meth_ast_addComment_40_1_41_401, 59);
  int argcv_meth_ast_addComment_40_1_41_401[] = {1};
  meth_meth_ast_addComment_40_1_41_401->type = alloc_MethodType(1, argcv_meth_ast_addComment_40_1_41_401);
  meth_meth_ast_addComment_40_1_41_401->definitionModule = modulename;
  meth_meth_ast_addComment_40_1_41_401->definitionLine = 193;
// method "addComments(_)"
  struct UserObject *uo415 = (struct UserObject*)obj29;
  uo415->data[60] = emptyclosure;
  Method *meth_meth_ast_addComments_40_1_41_415 = addmethod2pos(obj29, "addComments(1)", &meth_ast_addComments_40_1_41_415, 60);
  int argcv_meth_ast_addComments_40_1_41_415[] = {1};
  meth_meth_ast_addComments_40_1_41_415->type = alloc_MethodType(1, argcv_meth_ast_addComments_40_1_41_415);
  meth_meth_ast_addComments_40_1_41_415->definitionModule = modulename;
  meth_meth_ast_addComments_40_1_41_415->definitionLine = 200;
// method "statementName"
  struct UserObject *uo423 = (struct UserObject*)obj29;
  uo423->data[61] = emptyclosure;
  Method *meth_meth_ast_statementName423 = addmethod2pos(obj29, "statementName", &meth_ast_statementName423, 61);
  int argcv_meth_ast_statementName423[] = {0};
  meth_meth_ast_statementName423->type = alloc_MethodType(1, argcv_meth_ast_statementName423);
  meth_meth_ast_statementName423->definitionModule = modulename;
  meth_meth_ast_statementName423->definitionLine = 203;
  sourceObject = obj29;
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit426 == NULL) {
    strlit426 = alloc_String("");
    gc_root(strlit426);
  }
// compiled string node returning strlit426 (depth = 2)
  adddatum2(obj29, strlit426, 1);
  sourceObject = obj29;
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe427 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  Object call428 = callmethodflags(*var_util, "linenum", 0, partcv, params, 0);
  gc_frame_end(callframe427);
// compiled member node returning call428 (depth = 2)
  adddatum2(obj29, call428, 2);
  sourceObject = obj29;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe429 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  Object call430 = callmethodflags(*var_util, "linepos", 0, partcv, params, 0);
  gc_frame_end(callframe429);
// compiled member node returning call430 (depth = 2)
  adddatum2(obj29, call430, 3);
  sourceObject = obj29;
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_fakeSymbolTable (depth = 2)
  adddatum2(obj29, *var_fakeSymbolTable, 4);
  sourceObject = obj29;
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool431 = alloc_Boolean(0);
// compiled identifier node returning bool431 (depth = 2)
  adddatum2(obj29, bool431, 5);
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  objclass29 = obj29->class;
  objclass29->definitionModule = modulename;
  objclass29->definitionLine = 87;
  (*(struct UserObject *)self).data[0] = lowerouter29;
  self = oldself29;
  selfslot = oldselfslot29;
  stackframe = oldstackframe29;
  gc_frame_end(frame);
  return obj29;
}
Object meth_ast_newName436(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "newName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2516
  setline(2516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_n (depth = 2)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast_oldName437(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "oldName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2517
  setline(2517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_o (depth = 2)
  gc_frame_end(frame);
  return *var_o;
}
Object meth_ast_asString438(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2518
  setline(2518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit440 == NULL) {
    strlit440 = alloc_String("");
    gc_root(strlit440);
  }
// compiled string node returning strlit440 (depth = 3)
  int op_slot_right_439 = gc_frame_newslot(strlit440);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe443 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  Object call444 = callmethodflags(*var_o, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe443);
// compiled member node returning call444 (depth = 4)
  int op_slot_right_442 = gc_frame_newslot(call444);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit447 == NULL) {
    strlit447 = alloc_String(" = ");
    gc_root(strlit447);
  }
// compiled string node returning strlit447 (depth = 5)
  int op_slot_right_446 = gc_frame_newslot(strlit447);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe450 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  Object call451 = callmethodflags(*var_n, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe450);
// compiled member node returning call451 (depth = 6)
  int op_slot_right_449 = gc_frame_newslot(call451);
// starting to compile string node (depth = 6)
  if (strlit453 == NULL) {
    strlit453 = alloc_String("alias ");
    gc_root(strlit453);
  }
// compiled string node returning strlit453 (depth = 6)
  int op_slot_left_449 = gc_frame_newslot(strlit453);
  params[0] = call451;
  partcv[0] = 1;
  Object opresult454 = callmethod(strlit453, "++(1)", 1, partcv, params);
// compiled op node returning opresult454 (depth = 5)
  int op_slot_left_446 = gc_frame_newslot(opresult454);
  params[0] = strlit447;
  partcv[0] = 1;
  Object opresult455 = callmethod(opresult454, "++(1)", 1, partcv, params);
// compiled op node returning opresult455 (depth = 4)
  int op_slot_left_442 = gc_frame_newslot(opresult455);
  params[0] = call444;
  partcv[0] = 1;
  Object opresult456 = callmethod(opresult455, "++(1)", 1, partcv, params);
// compiled op node returning opresult456 (depth = 3)
  int op_slot_left_439 = gc_frame_newslot(opresult456);
  params[0] = strlit440;
  partcv[0] = 1;
  Object opresult457 = callmethod(opresult456, "++(1)", 1, partcv, params);
// compiled op node returning opresult457 (depth = 2)
  gc_frame_end(frame);
  return opresult457;
}
Object meth_ast__apply_40_1_41_466(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2522
  setline(2522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit468 == NULL) {
    strlit468 = alloc_String("  ");
    gc_root(strlit468);
  }
// compiled string node returning strlit468 (depth = 6)
  int op_slot_right_467 = gc_frame_newslot(strlit468);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_467 = gc_frame_newslot(*var_spc);
  params[0] = strlit468;
  partcv[0] = 1;
  Object opresult470 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult470 (depth = 5)
  *var_spc = opresult470;
  if (opresult470 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_458(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 2520
  setline(2520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit459 == NULL) {
    strlit459 = alloc_String("");
    gc_root(strlit459);
  }
// compiled string node returning strlit459 (depth = 3)
  *var_spc = strlit459;
  if (strlit459 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2521
  setline(2521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe460 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  int op_slot_right_461 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 4)
  Object num463 = alloc_Float64(0);
// compiled num node returning num463 (depth = 4)
  int op_slot_left_461 = gc_frame_newslot(num463);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult464 = callmethod(num463, "..(1)", 1, partcv, params);
// compiled op node returning opresult464 (depth = 3)
  gc_frame_newslot(opresult464);
// starting to compile block node (depth = 3)
  Object block465 = alloc_Block(NULL, NULL, "ast", 2521);
  gc_frame_newslot(block465);
// method "_apply(_)"
  block_savedest(block465);
  Object closure466 = createclosure(2, "_apply(1)");
  setclosureframe(closure466, stackframe);
  addtoclosure(closure466, var_spc);
  addtoclosure(closure466, selfslot);
  struct UserObject *uo466 = (struct UserObject*)block465;
  uo466->data[0] = (Object)closure466;
  Method *meth_meth_ast__apply_40_1_41_466 = addmethod2pos(block465, "_apply(1)", &meth_ast__apply_40_1_41_466, 0);
  int argcv_meth_ast__apply_40_1_41_466[] = {1};
  meth_meth_ast__apply_40_1_41_466->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_466);
  meth_meth_ast__apply_40_1_41_466->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_466->definitionLine = 2981;
// compiled block node returning block465 (depth = 3)
  gc_frame_newslot(block465);
// call case 5: prelude request
  params[0] = opresult464;
  params[1] = block465;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call473 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe460);
// compiled call node returning call473 (depth = 2)
// Begin line 2524
  setline(2524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit475 == NULL) {
    strlit475 = alloc_String("");
    gc_root(strlit475);
  }
// compiled string node returning strlit475 (depth = 3)
  int op_slot_right_474 = gc_frame_newslot(strlit475);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe478 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call479 = callmethodflags(*var_o, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe478);
// compiled call node returning call479 (depth = 4)
  int op_slot_right_477 = gc_frame_newslot(call479);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit482 == NULL) {
    strlit482 = alloc_String(" = ");
    gc_root(strlit482);
  }
// compiled string node returning strlit482 (depth = 5)
  int op_slot_right_481 = gc_frame_newslot(strlit482);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe485 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call486 = callmethodflags(*var_n, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe485);
// compiled call node returning call486 (depth = 6)
  int op_slot_right_484 = gc_frame_newslot(call486);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit489 == NULL) {
    strlit489 = alloc_String("  alias ");
    gc_root(strlit489);
  }
// compiled string node returning strlit489 (depth = 7)
  int op_slot_right_488 = gc_frame_newslot(strlit489);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_491 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 8)
  if (strlit493 == NULL) {
    strlit493 = alloc_String("");
    gc_root(strlit493);
  }
// compiled string node returning strlit493 (depth = 8)
  int op_slot_left_491 = gc_frame_newslot(strlit493);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult494 = callmethod(strlit493, "++(1)", 1, partcv, params);
// compiled op node returning opresult494 (depth = 7)
  int op_slot_left_488 = gc_frame_newslot(opresult494);
  params[0] = strlit489;
  partcv[0] = 1;
  Object opresult495 = callmethod(opresult494, "++(1)", 1, partcv, params);
// compiled op node returning opresult495 (depth = 6)
  int op_slot_left_484 = gc_frame_newslot(opresult495);
  params[0] = call486;
  partcv[0] = 1;
  Object opresult496 = callmethod(opresult495, "++(1)", 1, partcv, params);
// compiled op node returning opresult496 (depth = 5)
  int op_slot_left_481 = gc_frame_newslot(opresult496);
  params[0] = strlit482;
  partcv[0] = 1;
  Object opresult497 = callmethod(opresult496, "++(1)", 1, partcv, params);
// compiled op node returning opresult497 (depth = 4)
  int op_slot_left_477 = gc_frame_newslot(opresult497);
  params[0] = call479;
  partcv[0] = 1;
  Object opresult498 = callmethod(opresult497, "++(1)", 1, partcv, params);
// compiled op node returning opresult498 (depth = 3)
  int op_slot_left_474 = gc_frame_newslot(opresult498);
  params[0] = strlit475;
  partcv[0] = 1;
  Object opresult499 = callmethod(opresult498, "++(1)", 1, partcv, params);
// compiled op node returning opresult499 (depth = 2)
  gc_frame_end(frame);
  return opresult499;
}
Object meth_ast_hash500(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hash");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2526
  setline(2526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe502 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  Object call503 = callmethodflags(*var_o, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe502);
// compiled member node returning call503 (depth = 3)
  int op_slot_right_501 = gc_frame_newslot(call503);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num506 = alloc_Float64(1171);
// compiled num node returning num506 (depth = 4)
  int op_slot_right_505 = gc_frame_newslot(num506);
// starting to compile member node (depth = 4)
  int callframe508 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  Object call509 = callmethodflags(*var_n, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe508);
// compiled member node returning call509 (depth = 4)
  int op_slot_left_505 = gc_frame_newslot(call509);
  params[0] = num506;
  partcv[0] = 1;
  Object prod510 = callmethod(call509, "*(1)", 1, partcv, params);
// compiled op node returning prod510 (depth = 3)
  int op_slot_left_501 = gc_frame_newslot(prod510);
  params[0] = call503;
  partcv[0] = 1;
  Object sum511 = callmethod(prod510, "+(1)", 1, partcv, params);
// compiled op node returning sum511 (depth = 2)
  gc_frame_end(frame);
  return sum511;
}
Object meth_ast_isExecutable512(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2527
  setline(2527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool513 = alloc_Boolean(0);
// compiled identifier node returning bool513 (depth = 2)
  gc_frame_end(frame);
  return bool513;
}
Object meth_ast__apply_40_1_41_517(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_that = &(stackframe->slots[0]);
  *var_that = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe520 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_that (depth = 7)
  Object call521 = callmethodflags(*var_that, "oldName", 0, partcv, params, 0);
  gc_frame_end(callframe520);
// compiled member node returning call521 (depth = 6)
  int op_slot_right_519 = gc_frame_newslot(call521);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  int op_slot_left_519 = gc_frame_newslot(*var_o);
  params[0] = call521;
  partcv[0] = 1;
  Object opresult523 = callmethod(*var_o, "==(1)", 1, partcv, params);
// compiled op node returning opresult523 (depth = 5)
  int op_slot_right_518 = gc_frame_newslot(opresult523);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe526 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_that (depth = 7)
  Object call527 = callmethodflags(*var_that, "newName", 0, partcv, params, 0);
  gc_frame_end(callframe526);
// compiled member node returning call527 (depth = 6)
  int op_slot_right_525 = gc_frame_newslot(call527);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_525 = gc_frame_newslot(*var_n);
  params[0] = call527;
  partcv[0] = 1;
  Object opresult529 = callmethod(*var_n, "==(1)", 1, partcv, params);
// compiled op node returning opresult529 (depth = 5)
  int op_slot_left_518 = gc_frame_newslot(opresult529);
  params[0] = opresult523;
  partcv[0] = 1;
  Object opresult530 = callmethod(opresult529, "&&(1)", 1, partcv, params);
// compiled op node returning opresult530 (depth = 4)
  gc_frame_end(frame);
  return opresult530;
}
Object meth_ast__apply_40_1_41_542(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___2 = &(stackframe->slots[0]);
  *var___2 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 4)
  Object bool543 = alloc_Boolean(0);
// compiled identifier node returning bool543 (depth = 4)
  gc_frame_end(frame);
  return bool543;
}
Object meth_ast__61__61__40_1_41_514(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object *var_AliasPair = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2529
  setline(2529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  int frame515 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 2530
  setline(2530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block516 = alloc_Block(NULL, NULL, "ast", 2530);
  gc_frame_newslot(block516);
// method "_apply(_)"
  block_savedest(block516);
  Object closure517 = createclosure(3, "_apply(1)");
  setclosureframe(closure517, stackframe);
  addtoclosure(closure517, var_o);
  addtoclosure(closure517, var_n);
  addtoclosure(closure517, selfslot);
  struct UserObject *uo517 = (struct UserObject*)block516;
  uo517->data[0] = (Object)closure517;
  Method *meth_meth_ast__apply_40_1_41_517 = addmethod2pos(block516, "_apply(1)", &meth_ast__apply_40_1_41_517, 0);
  int argcv_meth_ast__apply_40_1_41_517[] = {1};
  meth_meth_ast__apply_40_1_41_517->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_517);
  meth_meth_ast__apply_40_1_41_517->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_517->definitionLine = 2981;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe532 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe533 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit534 == NULL) {
    strlit534 = alloc_String("that");
    gc_root(strlit534);
  }
// compiled string node returning strlit534 (depth = 6)
  gc_frame_newslot(strlit534);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe535 = gc_frame_new();
// call case 5: prelude request
  Object call536 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe535);
// compiled member node returning call536 (depth = 6)
  params[0] = strlit534;
  partcv[0] = 1;
  Object call537 = callmethodflags(call536, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe533);
// compiled call node returning call537 (depth = 5)
  gc_frame_newslot(call537);
// Begin line 2530
  setline(2530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_AliasPair (depth = 5)
  gc_frame_newslot(*var_AliasPair);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe538 = gc_frame_new();
// call case 5: prelude request
  Object call539 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe538);
// compiled member node returning call539 (depth = 5)
  params[0] = call537;
  params[1] = *var_AliasPair;
  partcv[0] = 2;
  Object call540 = callmethodflags(call539, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe532);
// compiled call node returning call540 (depth = 4)
((struct UserObject *)block516)->data[1] = call540;
// compiled block node returning block516 (depth = 3)
  gc_frame_newslot(block516);
// Begin line 2531
  setline(2531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block541 = alloc_Block(NULL, NULL, "ast", 2531);
  gc_frame_newslot(block541);
// method "_apply(_)"
  block_savedest(block541);
  Object closure542 = createclosure(1, "_apply(1)");
  setclosureframe(closure542, stackframe);
  addtoclosure(closure542, selfslot);
  struct UserObject *uo542 = (struct UserObject*)block541;
  uo542->data[0] = (Object)closure542;
  Method *meth_meth_ast__apply_40_1_41_542 = addmethod2pos(block541, "_apply(1)", &meth_ast__apply_40_1_41_542, 0);
  int argcv_meth_ast__apply_40_1_41_542[] = {1};
  meth_meth_ast__apply_40_1_41_542->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_542);
  meth_meth_ast__apply_40_1_41_542->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_542->definitionLine = 2981;
// compiled block node returning block541 (depth = 3)
  gc_frame_newslot(block541);
  params[0] = block516;
  params[1] = block541;
  Object matchres515 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame515);
// compiled matchcase node returning matchres515 (depth = 2)
  gc_frame_end(frame);
  return matchres515;
}
Object meth_ast_aliasNew_40_1_41_old_40_1_41_433(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "aliasNew(1)old(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method aliasNew(_)old(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method aliasNew(_)old(_)");
  Object params[1];
  int partcv[1];
  Object *var_AliasPair = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for aliasNew(_)old(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part aliasNew(_)");
  Object *var_o = &(stackframe->slots[1]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part old(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject434 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj434 = alloc_userobj2(7,8, objclass434);
  gc_frame_newslot(obj434);
if (objclass434 == NULL) {
  glfree(obj434->class->name);
  obj434->class->name = "aliasNew(_)old(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj434, self, 0);
  addmethodreal(obj434,"outer", &reader_ast_outer_435);
  Object oldself434 = self;
  struct StackFrameObject *oldstackframe434 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe434);
  gc_frame_newslot((Object)stackframe);
  self = obj434;
  Object *oldselfslot434 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter434 = (*(struct UserObject *)self).data[0], lowerouter434 = thisouter434;
  if (inheritingObject434) {
    struct UserObject *inho434 = (struct UserObject *)inheritingObject434;
    while (inho434->super != GraceDefaultObject) inho434 = (struct UserObject *)inho434->super;
    inho434->super = obj434;
    self = inheritingObject434;
    *selfslot = self;
    lowerouter434 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter434;
  }
// method "newName"
  block_savedest(obj434);
  Object closure436 = createclosure(1, "newName");
  setclosureframe(closure436, stackframe);
  addtoclosure(closure436, var_n);
  struct UserObject *uo436 = (struct UserObject*)obj434;
  uo436->data[1] = (Object)closure436;
  Method *meth_meth_ast_newName436 = addmethod2pos(obj434, "newName", &meth_ast_newName436, 1);
  int argcv_meth_ast_newName436[] = {0};
  meth_meth_ast_newName436->type = alloc_MethodType(1, argcv_meth_ast_newName436);
  meth_meth_ast_newName436->definitionModule = modulename;
  meth_meth_ast_newName436->definitionLine = 2516;
// method "oldName"
  block_savedest(obj434);
  Object closure437 = createclosure(1, "oldName");
  setclosureframe(closure437, stackframe);
  addtoclosure(closure437, var_o);
  struct UserObject *uo437 = (struct UserObject*)obj434;
  uo437->data[2] = (Object)closure437;
  Method *meth_meth_ast_oldName437 = addmethod2pos(obj434, "oldName", &meth_ast_oldName437, 2);
  int argcv_meth_ast_oldName437[] = {0};
  meth_meth_ast_oldName437->type = alloc_MethodType(1, argcv_meth_ast_oldName437);
  meth_meth_ast_oldName437->definitionModule = modulename;
  meth_meth_ast_oldName437->definitionLine = 2517;
// method "asString"
  block_savedest(obj434);
  Object closure438 = createclosure(2, "asString");
  setclosureframe(closure438, stackframe);
  addtoclosure(closure438, var_o);
  addtoclosure(closure438, var_n);
  struct UserObject *uo438 = (struct UserObject*)obj434;
  uo438->data[3] = (Object)closure438;
  Method *meth_meth_ast_asString438 = addmethod2pos(obj434, "asString", &meth_ast_asString438, 3);
  int argcv_meth_ast_asString438[] = {0};
  meth_meth_ast_asString438->type = alloc_MethodType(1, argcv_meth_ast_asString438);
  meth_meth_ast_asString438->definitionModule = modulename;
  meth_meth_ast_asString438->definitionLine = 2518;
// method "pretty(_)"
  block_savedest(obj434);
  Object closure458 = createclosure(2, "pretty(1)");
  setclosureframe(closure458, stackframe);
  addtoclosure(closure458, var_o);
  addtoclosure(closure458, var_n);
  struct UserObject *uo458 = (struct UserObject*)obj434;
  uo458->data[4] = (Object)closure458;
  Method *meth_meth_ast_pretty_40_1_41_458 = addmethod2pos(obj434, "pretty(1)", &meth_ast_pretty_40_1_41_458, 4);
  int argcv_meth_ast_pretty_40_1_41_458[] = {1};
  meth_meth_ast_pretty_40_1_41_458->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_458);
  meth_meth_ast_pretty_40_1_41_458->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_458->definitionLine = 2519;
// method "hash"
  block_savedest(obj434);
  Object closure500 = createclosure(2, "hash");
  setclosureframe(closure500, stackframe);
  addtoclosure(closure500, var_o);
  addtoclosure(closure500, var_n);
  struct UserObject *uo500 = (struct UserObject*)obj434;
  uo500->data[5] = (Object)closure500;
  Method *meth_meth_ast_hash500 = addmethod2pos(obj434, "hash", &meth_ast_hash500, 5);
  int argcv_meth_ast_hash500[] = {0};
  meth_meth_ast_hash500->type = alloc_MethodType(1, argcv_meth_ast_hash500);
  meth_meth_ast_hash500->definitionModule = modulename;
  meth_meth_ast_hash500->definitionLine = 2526;
// method "isExecutable"
  struct UserObject *uo512 = (struct UserObject*)obj434;
  uo512->data[6] = emptyclosure;
  Method *meth_meth_ast_isExecutable512 = addmethod2pos(obj434, "isExecutable", &meth_ast_isExecutable512, 6);
  int argcv_meth_ast_isExecutable512[] = {0};
  meth_meth_ast_isExecutable512->type = alloc_MethodType(1, argcv_meth_ast_isExecutable512);
  meth_meth_ast_isExecutable512->definitionModule = modulename;
  meth_meth_ast_isExecutable512->definitionLine = 2527;
// method "==(_)"
  block_savedest(obj434);
  Object closure514 = createclosure(3, "==(1)");
  setclosureframe(closure514, stackframe);
  addtoclosure(closure514, var_o);
  addtoclosure(closure514, var_n);
  addtoclosure(closure514, var_AliasPair);
  struct UserObject *uo514 = (struct UserObject*)obj434;
  uo514->data[7] = (Object)closure514;
  Method *meth_meth_ast__61__61__40_1_41_514 = addmethod2pos(obj434, "==(1)", &meth_ast__61__61__40_1_41_514, 7);
  int argcv_meth_ast__61__61__40_1_41_514[] = {1};
  meth_meth_ast__61__61__40_1_41_514->type = alloc_MethodType(1, argcv_meth_ast__61__61__40_1_41_514);
  meth_meth_ast__61__61__40_1_41_514->definitionModule = modulename;
  meth_meth_ast__61__61__40_1_41_514->definitionLine = 2528;
  sourceObject = obj434;
  sourceObject = obj434;
  sourceObject = obj434;
  sourceObject = obj434;
  sourceObject = obj434;
  sourceObject = obj434;
  sourceObject = obj434;
  objclass434 = obj434->class;
  objclass434->definitionModule = modulename;
  objclass434->definitionLine = 2515;
  (*(struct UserObject *)self).data[0] = lowerouter434;
  self = oldself434;
  selfslot = oldselfslot434;
  stackframe = oldstackframe434;
  gc_frame_end(frame);
  return obj434;
}
Object meth_ast_aliasNew_40_1_41_old_40_1_41_433_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "aliasNew(1)old(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method aliasNew(_)old(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method aliasNew(_)old(_)");
  Object params[1];
  int partcv[1];
  Object *var_AliasPair = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for aliasNew(_)old(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part aliasNew(_)");
  Object *var_o = &(stackframe->slots[1]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part old(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject434 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj434 = alloc_userobj2(7,8, objclass434);
  gc_frame_newslot(obj434);
if (objclass434 == NULL) {
  glfree(obj434->class->name);
  obj434->class->name = "aliasNew(_)old(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj434, self, 0);
  addmethodreal(obj434,"outer", &reader_ast_outer_435);
  Object oldself434 = self;
  struct StackFrameObject *oldstackframe434 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe434);
  gc_frame_newslot((Object)stackframe);
  self = obj434;
  Object *oldselfslot434 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter434 = (*(struct UserObject *)self).data[0], lowerouter434 = thisouter434;
  if (inheritingObject434) {
    struct UserObject *inho434 = (struct UserObject *)inheritingObject434;
    while (inho434->super != GraceDefaultObject) inho434 = (struct UserObject *)inho434->super;
    inho434->super = obj434;
    self = inheritingObject434;
    *selfslot = self;
    lowerouter434 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter434;
  }
// method "newName"
  block_savedest(obj434);
  Object closure436 = createclosure(1, "newName");
  setclosureframe(closure436, stackframe);
  addtoclosure(closure436, var_n);
  struct UserObject *uo436 = (struct UserObject*)obj434;
  uo436->data[1] = (Object)closure436;
  Method *meth_meth_ast_newName436 = addmethod2pos(obj434, "newName", &meth_ast_newName436, 1);
  int argcv_meth_ast_newName436[] = {0};
  meth_meth_ast_newName436->type = alloc_MethodType(1, argcv_meth_ast_newName436);
  meth_meth_ast_newName436->definitionModule = modulename;
  meth_meth_ast_newName436->definitionLine = 2516;
// method "oldName"
  block_savedest(obj434);
  Object closure437 = createclosure(1, "oldName");
  setclosureframe(closure437, stackframe);
  addtoclosure(closure437, var_o);
  struct UserObject *uo437 = (struct UserObject*)obj434;
  uo437->data[2] = (Object)closure437;
  Method *meth_meth_ast_oldName437 = addmethod2pos(obj434, "oldName", &meth_ast_oldName437, 2);
  int argcv_meth_ast_oldName437[] = {0};
  meth_meth_ast_oldName437->type = alloc_MethodType(1, argcv_meth_ast_oldName437);
  meth_meth_ast_oldName437->definitionModule = modulename;
  meth_meth_ast_oldName437->definitionLine = 2517;
// method "asString"
  block_savedest(obj434);
  Object closure438 = createclosure(2, "asString");
  setclosureframe(closure438, stackframe);
  addtoclosure(closure438, var_o);
  addtoclosure(closure438, var_n);
  struct UserObject *uo438 = (struct UserObject*)obj434;
  uo438->data[3] = (Object)closure438;
  Method *meth_meth_ast_asString438 = addmethod2pos(obj434, "asString", &meth_ast_asString438, 3);
  int argcv_meth_ast_asString438[] = {0};
  meth_meth_ast_asString438->type = alloc_MethodType(1, argcv_meth_ast_asString438);
  meth_meth_ast_asString438->definitionModule = modulename;
  meth_meth_ast_asString438->definitionLine = 2518;
// method "pretty(_)"
  block_savedest(obj434);
  Object closure458 = createclosure(2, "pretty(1)");
  setclosureframe(closure458, stackframe);
  addtoclosure(closure458, var_o);
  addtoclosure(closure458, var_n);
  struct UserObject *uo458 = (struct UserObject*)obj434;
  uo458->data[4] = (Object)closure458;
  Method *meth_meth_ast_pretty_40_1_41_458 = addmethod2pos(obj434, "pretty(1)", &meth_ast_pretty_40_1_41_458, 4);
  int argcv_meth_ast_pretty_40_1_41_458[] = {1};
  meth_meth_ast_pretty_40_1_41_458->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_458);
  meth_meth_ast_pretty_40_1_41_458->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_458->definitionLine = 2519;
// method "hash"
  block_savedest(obj434);
  Object closure500 = createclosure(2, "hash");
  setclosureframe(closure500, stackframe);
  addtoclosure(closure500, var_o);
  addtoclosure(closure500, var_n);
  struct UserObject *uo500 = (struct UserObject*)obj434;
  uo500->data[5] = (Object)closure500;
  Method *meth_meth_ast_hash500 = addmethod2pos(obj434, "hash", &meth_ast_hash500, 5);
  int argcv_meth_ast_hash500[] = {0};
  meth_meth_ast_hash500->type = alloc_MethodType(1, argcv_meth_ast_hash500);
  meth_meth_ast_hash500->definitionModule = modulename;
  meth_meth_ast_hash500->definitionLine = 2526;
// method "isExecutable"
  struct UserObject *uo512 = (struct UserObject*)obj434;
  uo512->data[6] = emptyclosure;
  Method *meth_meth_ast_isExecutable512 = addmethod2pos(obj434, "isExecutable", &meth_ast_isExecutable512, 6);
  int argcv_meth_ast_isExecutable512[] = {0};
  meth_meth_ast_isExecutable512->type = alloc_MethodType(1, argcv_meth_ast_isExecutable512);
  meth_meth_ast_isExecutable512->definitionModule = modulename;
  meth_meth_ast_isExecutable512->definitionLine = 2527;
// method "==(_)"
  block_savedest(obj434);
  Object closure514 = createclosure(3, "==(1)");
  setclosureframe(closure514, stackframe);
  addtoclosure(closure514, var_o);
  addtoclosure(closure514, var_n);
  addtoclosure(closure514, var_AliasPair);
  struct UserObject *uo514 = (struct UserObject*)obj434;
  uo514->data[7] = (Object)closure514;
  Method *meth_meth_ast__61__61__40_1_41_514 = addmethod2pos(obj434, "==(1)", &meth_ast__61__61__40_1_41_514, 7);
  int argcv_meth_ast__61__61__40_1_41_514[] = {1};
  meth_meth_ast__61__61__40_1_41_514->type = alloc_MethodType(1, argcv_meth_ast__61__61__40_1_41_514);
  meth_meth_ast__61__61__40_1_41_514->definitionModule = modulename;
  meth_meth_ast__61__61__40_1_41_514->definitionLine = 2528;
  sourceObject = obj434;
  sourceObject = obj434;
  sourceObject = obj434;
  sourceObject = obj434;
  sourceObject = obj434;
  sourceObject = obj434;
  sourceObject = obj434;
  objclass434 = obj434->class;
  objclass434->definitionModule = modulename;
  objclass434->definitionLine = 2515;
  (*(struct UserObject *)self).data[0] = lowerouter434;
  self = oldself434;
  selfslot = oldselfslot434;
  stackframe = oldstackframe434;
  gc_frame_end(frame);
  return obj434;
}
Object meth_ast__apply580(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ind = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ind (depth = 8)
  int op_slot_right_581 = gc_frame_newslot(*var_ind);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_len (depth = 8)
  int op_slot_left_581 = gc_frame_newslot(*var_len);
  params[0] = *var_ind;
  partcv[0] = 1;
  Object diff583 = callmethod(*var_len, "-(1)", 1, partcv, params);
// compiled op node returning diff583 (depth = 7)
  gc_frame_end(frame);
  return diff583;
}
Object meth_ast__apply573(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_ind = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object *var_str = getfromclosure(closure, 2);
  Object *var_currBreak = getfromclosure(closure, 3);
  Object *var_trimmedLine = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 2799
  setline(2799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe574 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit575 == NULL) {
    strlit575 = alloc_String(" ");
    gc_root(strlit575);
  }
// compiled string node returning strlit575 (depth = 6)
  gc_frame_newslot(strlit575);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ind (depth = 7)
  int op_slot_right_576 = gc_frame_newslot(*var_ind);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_len (depth = 7)
  int op_slot_left_576 = gc_frame_newslot(*var_len);
  params[0] = *var_ind;
  partcv[0] = 1;
  Object diff578 = callmethod(*var_len, "-(1)", 1, partcv, params);
// compiled op node returning diff578 (depth = 6)
  gc_frame_newslot(diff578);
// Begin line 2800
  setline(2800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 6)
  Object block579 = alloc_Block(NULL, NULL, "ast", 2800);
  gc_frame_newslot(block579);
// method "_apply"
  block_savedest(block579);
  Object closure580 = createclosure(3, "_apply");
  setclosureframe(closure580, stackframe);
  addtoclosure(closure580, var_ind);
  addtoclosure(closure580, var_len);
  addtoclosure(closure580, selfslot);
  struct UserObject *uo580 = (struct UserObject*)block579;
  uo580->data[0] = (Object)closure580;
  Method *meth_meth_ast__apply580 = addmethod2pos(block579, "_apply", &meth_ast__apply580, 0);
  int argcv_meth_ast__apply580[] = {0};
  meth_meth_ast__apply580->type = alloc_MethodType(1, argcv_meth_ast__apply580);
  meth_meth_ast__apply580->definitionModule = modulename;
  meth_meth_ast__apply580->definitionLine = 2981;
// compiled block node returning block579 (depth = 6)
  gc_frame_newslot(block579);
// call case 6: other requests
// Begin line 2799
  setline(2799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_str (depth = 6)
  params[0] = strlit575;
  params[1] = diff578;
  params[2] = block579;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call585 = callmethodflags(*var_str, "lastIndexOf(1)startingAt(1)ifAbsent(1)", 3, partcv, params, 0);
  gc_frame_end(callframe574);
// compiled call node returning call585 (depth = 5)
  *var_currBreak = call585;
  if (call585 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2801
  setline(2801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe587 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe588 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num589 = alloc_Float64(1);
// compiled num node returning num589 (depth = 7)
  gc_frame_newslot(num589);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_currBreak (depth = 7)
  gc_frame_newslot(*var_currBreak);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_str (depth = 7)
  params[0] = num589;
  params[1] = *var_currBreak;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call590 = callmethodflags(*var_str, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe588);
// compiled call node returning call590 (depth = 6)
  Object call591 = callmethodflags(call590, "trim", 0, partcv, params, 0);
  gc_frame_end(callframe587);
// compiled member node returning call591 (depth = 5)
  *var_trimmedLine = call591;
  if (call591 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_606(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_str = getfromclosure(closure, 0);
  Object *var_currBreak = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2805
  setline(2805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit609 == NULL) {
    strlit609 = alloc_String(" ");
    gc_root(strlit609);
  }
// compiled string node returning strlit609 (depth = 8)
  int op_slot_right_608 = gc_frame_newslot(strlit609);
// starting to compile call node (depth = 8)
  int callframe611 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_str (depth = 9)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call612 = callmethodflags(*var_str, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe611);
// compiled call node returning call612 (depth = 8)
  int op_slot_left_608 = gc_frame_newslot(call612);
  params[0] = strlit609;
  partcv[0] = 1;
  Object opresult613 = callmethod(call612, "==(1)", 1, partcv, params);
// compiled op node returning opresult613 (depth = 7)
  Object if607 = done;
  if (istrue(opresult613)) {
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  *var_currBreak = *var_ix;
  if (*var_ix == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if607 = done;
  } else {
  }
// compiled if node returning if607 (depth = 6)
  gc_frame_end(frame);
  return if607;
}
Object meth_ast__apply626(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit628 == NULL) {
    strlit628 = alloc_String(" ");
    gc_root(strlit628);
  }
// compiled string node returning strlit628 (depth = 9)
  int op_slot_right_627 = gc_frame_newslot(strlit628);
// starting to compile call node (depth = 9)
  int callframe630 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_end (depth = 10)
  gc_frame_newslot(*var_end);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  params[0] = *var_end;
  partcv[0] = 1;
  Object call631 = callmethodflags(*var_str, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe630);
// compiled call node returning call631 (depth = 9)
  int op_slot_left_627 = gc_frame_newslot(call631);
  params[0] = strlit628;
  partcv[0] = 1;
  Object opresult632 = callmethod(call631, "==(1)", 1, partcv, params);
// compiled op node returning opresult632 (depth = 8)
  gc_frame_end(frame);
  return opresult632;
}
Object meth_ast__apply623(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block625 = alloc_Block(NULL, NULL, "ast", 2808);
  gc_frame_newslot(block625);
// method "_apply"
  block_savedest(block625);
  Object closure626 = createclosure(3, "_apply");
  setclosureframe(closure626, stackframe);
  addtoclosure(closure626, var_end);
  addtoclosure(closure626, var_str);
  addtoclosure(closure626, selfslot);
  struct UserObject *uo626 = (struct UserObject*)block625;
  uo626->data[0] = (Object)closure626;
  Method *meth_meth_ast__apply626 = addmethod2pos(block625, "_apply", &meth_ast__apply626, 0);
  int argcv_meth_ast__apply626[] = {0};
  meth_meth_ast__apply626->type = alloc_MethodType(1, argcv_meth_ast__apply626);
  meth_meth_ast__apply626->definitionModule = modulename;
  meth_meth_ast__apply626->definitionLine = 2981;
// compiled block node returning block625 (depth = 7)
  int op_slot_right_624 = gc_frame_newslot(block625);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num636 = alloc_Float64(1);
// compiled num node returning num636 (depth = 8)
  int op_slot_right_635 = gc_frame_newslot(num636);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  int op_slot_left_635 = gc_frame_newslot(*var_end);
  params[0] = num636;
  partcv[0] = 1;
  Object opresult638 = callmethod(*var_end, "≥(1)", 1, partcv, params);
// compiled op node returning opresult638 (depth = 7)
  int op_slot_left_624 = gc_frame_newslot(opresult638);
  params[0] = block625;
  partcv[0] = 1;
  Object opresult639 = callmethod(opresult638, "&&(1)", 1, partcv, params);
// compiled op node returning opresult639 (depth = 6)
  gc_frame_end(frame);
  return opresult639;
}
Object meth_ast__apply642(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 2809
  setline(2809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num644 = alloc_Float64(1);
// compiled num node returning num644 (depth = 8)
  int op_slot_right_643 = gc_frame_newslot(num644);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  int op_slot_left_643 = gc_frame_newslot(*var_end);
  params[0] = num644;
  partcv[0] = 1;
  Object diff646 = callmethod(*var_end, "-(1)", 1, partcv, params);
// compiled op node returning diff646 (depth = 7)
  *var_end = diff646;
  if (diff646 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply656(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_start = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit658 == NULL) {
    strlit658 = alloc_String(" ");
    gc_root(strlit658);
  }
// compiled string node returning strlit658 (depth = 9)
  int op_slot_right_657 = gc_frame_newslot(strlit658);
// starting to compile call node (depth = 9)
  int callframe660 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_start (depth = 10)
  gc_frame_newslot(*var_start);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  params[0] = *var_start;
  partcv[0] = 1;
  Object call661 = callmethodflags(*var_str, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe660);
// compiled call node returning call661 (depth = 9)
  int op_slot_left_657 = gc_frame_newslot(call661);
  params[0] = strlit658;
  partcv[0] = 1;
  Object opresult662 = callmethod(call661, "==(1)", 1, partcv, params);
// compiled op node returning opresult662 (depth = 8)
  gc_frame_end(frame);
  return opresult662;
}
Object meth_ast__apply653(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_start = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block655 = alloc_Block(NULL, NULL, "ast", 2812);
  gc_frame_newslot(block655);
// method "_apply"
  block_savedest(block655);
  Object closure656 = createclosure(3, "_apply");
  setclosureframe(closure656, stackframe);
  addtoclosure(closure656, var_start);
  addtoclosure(closure656, var_str);
  addtoclosure(closure656, selfslot);
  struct UserObject *uo656 = (struct UserObject*)block655;
  uo656->data[0] = (Object)closure656;
  Method *meth_meth_ast__apply656 = addmethod2pos(block655, "_apply", &meth_ast__apply656, 0);
  int argcv_meth_ast__apply656[] = {0};
  meth_meth_ast__apply656->type = alloc_MethodType(1, argcv_meth_ast__apply656);
  meth_meth_ast__apply656->definitionModule = modulename;
  meth_meth_ast__apply656->definitionLine = 2981;
// compiled block node returning block655 (depth = 7)
  int op_slot_right_654 = gc_frame_newslot(block655);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe666 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_str (depth = 9)
  Object call667 = callmethodflags(*var_str, "size", 0, partcv, params, 0);
  gc_frame_end(callframe666);
// compiled member node returning call667 (depth = 8)
  int op_slot_right_665 = gc_frame_newslot(call667);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  int op_slot_left_665 = gc_frame_newslot(*var_start);
  params[0] = call667;
  partcv[0] = 1;
  Object opresult669 = callmethod(*var_start, "≤(1)", 1, partcv, params);
// compiled op node returning opresult669 (depth = 7)
  int op_slot_left_654 = gc_frame_newslot(opresult669);
  params[0] = block655;
  partcv[0] = 1;
  Object opresult670 = callmethod(opresult669, "&&(1)", 1, partcv, params);
// compiled op node returning opresult670 (depth = 6)
  gc_frame_end(frame);
  return opresult670;
}
Object meth_ast__apply673(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_start = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 2813
  setline(2813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num675 = alloc_Float64(1);
// compiled num node returning num675 (depth = 8)
  int op_slot_right_674 = gc_frame_newslot(num675);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  int op_slot_left_674 = gc_frame_newslot(*var_start);
  params[0] = num675;
  partcv[0] = 1;
  Object sum677 = callmethod(*var_start, "+(1)", 1, partcv, params);
// compiled op node returning sum677 (depth = 7)
  *var_start = sum677;
  if (sum677 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_595(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_ind = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object *var_str = getfromclosure(closure, 2);
  Object *var_currBreak = getfromclosure(closure, 3);
  Object *var_trimmedLine = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ex = &(stackframe->slots[0]);
  *var_ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_end = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "end");
  Object *var_start = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "start");
// Begin line 2803
  setline(2803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe596 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ind (depth = 7)
  int op_slot_right_597 = gc_frame_newslot(*var_ind);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_len (depth = 7)
  int op_slot_left_597 = gc_frame_newslot(*var_len);
  params[0] = *var_ind;
  partcv[0] = 1;
  Object diff599 = callmethod(*var_len, "-(1)", 1, partcv, params);
// compiled op node returning diff599 (depth = 6)
  gc_frame_newslot(diff599);
// starting to compile member node (depth = 6)
  int callframe600 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_str (depth = 7)
  Object call601 = callmethodflags(*var_str, "size", 0, partcv, params, 0);
  gc_frame_end(callframe600);
// compiled member node returning call601 (depth = 6)
  gc_frame_newslot(call601);
// call case 5: prelude request
  params[0] = diff599;
  params[1] = call601;
  partcv[0] = 2;
  Object call602 = callmethodflags(prelude, "min(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe596);
// compiled call node returning call602 (depth = 5)
  *var_currBreak = call602;
  if (call602 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2804
  setline(2804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe604 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block605 = alloc_Block(NULL, NULL, "ast", 2804);
  gc_frame_newslot(block605);
// method "_apply(_)"
  block_savedest(block605);
  Object closure606 = createclosure(3, "_apply(1)");
  setclosureframe(closure606, stackframe);
  addtoclosure(closure606, var_str);
  addtoclosure(closure606, var_currBreak);
  addtoclosure(closure606, selfslot);
  struct UserObject *uo606 = (struct UserObject*)block605;
  uo606->data[0] = (Object)closure606;
  Method *meth_meth_ast__apply_40_1_41_606 = addmethod2pos(block605, "_apply(1)", &meth_ast__apply_40_1_41_606, 0);
  int argcv_meth_ast__apply_40_1_41_606[] = {1};
  meth_meth_ast__apply_40_1_41_606->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_606);
  meth_meth_ast__apply_40_1_41_606->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_606->definitionLine = 2981;
// compiled block node returning block605 (depth = 5)
  gc_frame_newslot(block605);
// call case 6: other requests
// Begin line 2804
  setline(2804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_currBreak (depth = 6)
  int op_slot_right_616 = gc_frame_newslot(*var_currBreak);
// starting to compile num node (depth = 6)
  Object num618 = alloc_Float64(1);
// compiled num node returning num618 (depth = 6)
  int op_slot_left_616 = gc_frame_newslot(num618);
  params[0] = *var_currBreak;
  partcv[0] = 1;
  Object opresult619 = callmethod(num618, "..(1)", 1, partcv, params);
// compiled op node returning opresult619 (depth = 5)
  params[0] = block605;
  partcv[0] = 1;
  Object call620 = callmethodflags(opresult619, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe604);
// compiled call node returning call620 (depth = 4)
// Begin line 2807
  setline(2807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_currBreak (depth = 5)
  *var_end = *var_currBreak;
  if (*var_currBreak == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2808
  setline(2808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe621 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block622 = alloc_Block(NULL, NULL, "ast", 2808);
  gc_frame_newslot(block622);
// method "_apply"
  block_savedest(block622);
  Object closure623 = createclosure(3, "_apply");
  setclosureframe(closure623, stackframe);
  addtoclosure(closure623, var_end);
  addtoclosure(closure623, var_str);
  addtoclosure(closure623, selfslot);
  struct UserObject *uo623 = (struct UserObject*)block622;
  uo623->data[0] = (Object)closure623;
  Method *meth_meth_ast__apply623 = addmethod2pos(block622, "_apply", &meth_ast__apply623, 0);
  int argcv_meth_ast__apply623[] = {0};
  meth_meth_ast__apply623->type = alloc_MethodType(1, argcv_meth_ast__apply623);
  meth_meth_ast__apply623->definitionModule = modulename;
  meth_meth_ast__apply623->definitionLine = 2981;
// compiled block node returning block622 (depth = 5)
  gc_frame_newslot(block622);
// starting to compile block node (depth = 5)
  Object block641 = alloc_Block(NULL, NULL, "ast", 2808);
  gc_frame_newslot(block641);
// method "_apply"
  block_savedest(block641);
  Object closure642 = createclosure(2, "_apply");
  setclosureframe(closure642, stackframe);
  addtoclosure(closure642, var_end);
  addtoclosure(closure642, selfslot);
  struct UserObject *uo642 = (struct UserObject*)block641;
  uo642->data[0] = (Object)closure642;
  Method *meth_meth_ast__apply642 = addmethod2pos(block641, "_apply", &meth_ast__apply642, 0);
  int argcv_meth_ast__apply642[] = {0};
  meth_meth_ast__apply642->type = alloc_MethodType(1, argcv_meth_ast__apply642);
  meth_meth_ast__apply642->definitionModule = modulename;
  meth_meth_ast__apply642->definitionLine = 2981;
// compiled block node returning block641 (depth = 5)
  gc_frame_newslot(block641);
// call case 5: prelude request
  params[0] = block622;
  params[1] = block641;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call649 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe621);
// compiled call node returning call649 (depth = 4)
// Begin line 2811
  setline(2811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile num node (depth = 5)
  Object num650 = alloc_Float64(1);
// compiled num node returning num650 (depth = 5)
  *var_start = num650;
  if (num650 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2812
  setline(2812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe651 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block652 = alloc_Block(NULL, NULL, "ast", 2812);
  gc_frame_newslot(block652);
// method "_apply"
  block_savedest(block652);
  Object closure653 = createclosure(3, "_apply");
  setclosureframe(closure653, stackframe);
  addtoclosure(closure653, var_start);
  addtoclosure(closure653, var_str);
  addtoclosure(closure653, selfslot);
  struct UserObject *uo653 = (struct UserObject*)block652;
  uo653->data[0] = (Object)closure653;
  Method *meth_meth_ast__apply653 = addmethod2pos(block652, "_apply", &meth_ast__apply653, 0);
  int argcv_meth_ast__apply653[] = {0};
  meth_meth_ast__apply653->type = alloc_MethodType(1, argcv_meth_ast__apply653);
  meth_meth_ast__apply653->definitionModule = modulename;
  meth_meth_ast__apply653->definitionLine = 2981;
// compiled block node returning block652 (depth = 5)
  gc_frame_newslot(block652);
// starting to compile block node (depth = 5)
  Object block672 = alloc_Block(NULL, NULL, "ast", 2812);
  gc_frame_newslot(block672);
// method "_apply"
  block_savedest(block672);
  Object closure673 = createclosure(2, "_apply");
  setclosureframe(closure673, stackframe);
  addtoclosure(closure673, var_start);
  addtoclosure(closure673, selfslot);
  struct UserObject *uo673 = (struct UserObject*)block672;
  uo673->data[0] = (Object)closure673;
  Method *meth_meth_ast__apply673 = addmethod2pos(block672, "_apply", &meth_ast__apply673, 0);
  int argcv_meth_ast__apply673[] = {0};
  meth_meth_ast__apply673->type = alloc_MethodType(1, argcv_meth_ast__apply673);
  meth_meth_ast__apply673->definitionModule = modulename;
  meth_meth_ast__apply673->definitionLine = 2981;
// compiled block node returning block672 (depth = 5)
  gc_frame_newslot(block672);
// call case 5: prelude request
  params[0] = block652;
  params[1] = block672;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call680 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe651);
// compiled call node returning call680 (depth = 4)
// Begin line 2815
  setline(2815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe681 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_end (depth = 6)
  gc_frame_newslot(*var_end);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_str (depth = 6)
  params[0] = *var_start;
  params[1] = *var_end;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call682 = callmethodflags(*var_str, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe681);
// compiled call node returning call682 (depth = 5)
  *var_trimmedLine = call682;
  if (call682 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_546(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(8, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "wrap(1)to(1)prefix(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method wrap(_)to(_)prefix(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method wrap(_)to(_)prefix(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method wrap(_)to(_)prefix(_)");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for wrap(_)to(_)prefix(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_str = &(stackframe->slots[0]);
  *var_str = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part wrap(_)");
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part to(_)");
  Object *var_margin = &(stackframe->slots[2]);
  *var_margin = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part prefix(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ind = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "ind");
  Object *var_len = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "len");
  Object *var_currBreak = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "currBreak");
  Object *var_trimmedLine = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "trimmedLine");
// Begin line 2790
  setline(2790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe547 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_margin (depth = 4)
  Object call548 = callmethodflags(*var_margin, "size", 0, partcv, params, 0);
  gc_frame_end(callframe547);
// compiled member node returning call548 (depth = 3)
  *var_ind = call548;
  if (call548 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2791
  setline(2791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe549 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num551 = alloc_Float64(4);
// compiled num node returning num551 (depth = 5)
  int op_slot_right_550 = gc_frame_newslot(num551);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ind (depth = 5)
  int op_slot_left_550 = gc_frame_newslot(*var_ind);
  params[0] = num551;
  partcv[0] = 1;
  Object sum553 = callmethod(*var_ind, "+(1)", 1, partcv, params);
// compiled op node returning sum553 (depth = 4)
  gc_frame_newslot(sum553);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  gc_frame_newslot(*var_l);
// call case 5: prelude request
  params[0] = sum553;
  params[1] = *var_l;
  partcv[0] = 2;
  Object call554 = callmethodflags(prelude, "max(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe549);
// compiled call node returning call554 (depth = 3)
  *var_len = call554;
  if (call554 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 2792
  setline(2792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_len (depth = 4)
  int op_slot_right_556 = gc_frame_newslot(*var_len);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe559 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_str (depth = 6)
  Object call560 = callmethodflags(*var_str, "size", 0, partcv, params, 0);
  gc_frame_end(callframe559);
// compiled member node returning call560 (depth = 5)
  int op_slot_right_558 = gc_frame_newslot(call560);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ind (depth = 5)
  int op_slot_left_558 = gc_frame_newslot(*var_ind);
  params[0] = call560;
  partcv[0] = 1;
  Object sum562 = callmethod(*var_ind, "+(1)", 1, partcv, params);
// compiled op node returning sum562 (depth = 4)
  int op_slot_left_556 = gc_frame_newslot(sum562);
  params[0] = *var_len;
  partcv[0] = 1;
  Object opresult563 = callmethod(sum562, "≤(1)", 1, partcv, params);
// compiled op node returning opresult563 (depth = 3)
  Object if555 = done;
  if (istrue(opresult563)) {
// Begin line 2793
  setline(2793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_str (depth = 5)
  int op_slot_right_564 = gc_frame_newslot(*var_str);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_margin (depth = 6)
  int op_slot_right_566 = gc_frame_newslot(*var_margin);
// starting to compile string node (depth = 6)
  if (strlit568 == NULL) {
    strlit568 = alloc_String("""\x0a""");
    gc_root(strlit568);
  }
// compiled string node returning strlit568 (depth = 6)
  int op_slot_left_566 = gc_frame_newslot(strlit568);
  params[0] = *var_margin;
  partcv[0] = 1;
  Object opresult569 = callmethod(strlit568, "++(1)", 1, partcv, params);
// compiled op node returning opresult569 (depth = 5)
  int op_slot_left_564 = gc_frame_newslot(opresult569);
  params[0] = *var_str;
  partcv[0] = 1;
  Object opresult570 = callmethod(opresult569, "++(1)", 1, partcv, params);
// compiled op node returning opresult570 (depth = 4)
  return opresult570;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if555 = undefined;
  } else {
  }
// compiled if node returning if555 (depth = 2)
// Begin line 2795
  setline(2795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_currBreak = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 2796
  setline(2796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_trimmedLine = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 2798
  setline(2798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile trycatch node (depth = 2)
// starting to compile block node (depth = 3)
  Object block572 = alloc_Block(NULL, NULL, "ast", 2798);
  gc_frame_newslot(block572);
// method "_apply"
  block_savedest(block572);
  Object closure573 = createclosure(6, "_apply");
  setclosureframe(closure573, stackframe);
  addtoclosure(closure573, var_ind);
  addtoclosure(closure573, var_len);
  addtoclosure(closure573, var_str);
  addtoclosure(closure573, var_currBreak);
  addtoclosure(closure573, var_trimmedLine);
  addtoclosure(closure573, selfslot);
  struct UserObject *uo573 = (struct UserObject*)block572;
  uo573->data[0] = (Object)closure573;
  Method *meth_meth_ast__apply573 = addmethod2pos(block572, "_apply", &meth_ast__apply573, 0);
  int argcv_meth_ast__apply573[] = {0};
  meth_meth_ast__apply573->type = alloc_MethodType(1, argcv_meth_ast__apply573);
  meth_meth_ast__apply573->definitionModule = modulename;
  meth_meth_ast__apply573->definitionLine = 2981;
// compiled block node returning block572 (depth = 3)
  int frame571 = gc_frame_new();
  gc_frame_newslot(block572);
// Begin line 2802
  setline(2802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block594 = alloc_Block(NULL, NULL, "ast", 2802);
  gc_frame_newslot(block594);
// method "_apply(_)"
  block_savedest(block594);
  Object closure595 = createclosure(6, "_apply(1)");
  setclosureframe(closure595, stackframe);
  addtoclosure(closure595, var_ind);
  addtoclosure(closure595, var_len);
  addtoclosure(closure595, var_str);
  addtoclosure(closure595, var_currBreak);
  addtoclosure(closure595, var_trimmedLine);
  addtoclosure(closure595, selfslot);
  struct UserObject *uo595 = (struct UserObject*)block594;
  uo595->data[0] = (Object)closure595;
  Method *meth_meth_ast__apply_40_1_41_595 = addmethod2pos(block594, "_apply(1)", &meth_ast__apply_40_1_41_595, 0);
  int argcv_meth_ast__apply_40_1_41_595[] = {1};
  meth_meth_ast__apply_40_1_41_595->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_595);
  meth_meth_ast__apply_40_1_41_595->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_595->definitionLine = 2981;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe685 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe686 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit687 == NULL) {
    strlit687 = alloc_String("ex");
    gc_root(strlit687);
  }
// compiled string node returning strlit687 (depth = 6)
  gc_frame_newslot(strlit687);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe688 = gc_frame_new();
// call case 5: prelude request
  Object call689 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe688);
// compiled member node returning call689 (depth = 6)
  params[0] = strlit687;
  partcv[0] = 1;
  Object call690 = callmethodflags(call689, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe686);
// compiled call node returning call690 (depth = 5)
  gc_frame_newslot(call690);
// Begin line 2802
  setline(2802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe691 = gc_frame_new();
// call case 5: prelude request
  Object call692 = callmethodflags(prelude, "NoSuchMethod", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe691);
// compiled member node returning call692 (depth = 5)
  gc_frame_newslot(call692);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe693 = gc_frame_new();
// call case 5: prelude request
  Object call694 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe693);
// compiled member node returning call694 (depth = 5)
  params[0] = call690;
  params[1] = call692;
  partcv[0] = 2;
  Object call695 = callmethodflags(call694, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe685);
// compiled call node returning call695 (depth = 4)
((struct UserObject *)block594)->data[1] = call695;
// compiled block node returning block594 (depth = 3)
  gc_frame_newslot(block594);
  params[0] = block594;
  setline(2798);
  Object catchres571 = tryCatch(block572, params, 1,NULL);
  gc_frame_end(frame571);
// compiled trycatch node returning catchres571 (depth = 2)
// Begin line 2817
  setline(2817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 2818
  setline(2818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe697 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe698 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num700 = alloc_Float64(1);
// compiled num node returning num700 (depth = 6)
  int op_slot_right_699 = gc_frame_newslot(num700);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_currBreak (depth = 6)
  int op_slot_left_699 = gc_frame_newslot(*var_currBreak);
  params[0] = num700;
  partcv[0] = 1;
  Object sum702 = callmethod(*var_currBreak, "+(1)", 1, partcv, params);
// compiled op node returning sum702 (depth = 5)
  gc_frame_newslot(sum702);
// starting to compile member node (depth = 5)
  int callframe703 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_str (depth = 6)
  Object call704 = callmethodflags(*var_str, "size", 0, partcv, params, 0);
  gc_frame_end(callframe703);
// compiled member node returning call704 (depth = 5)
  gc_frame_newslot(call704);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_str (depth = 5)
  params[0] = sum702;
  params[1] = call704;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call705 = callmethodflags(*var_str, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe698);
// compiled call node returning call705 (depth = 4)
  gc_frame_newslot(call705);
// Begin line 2819
  setline(2819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  gc_frame_newslot(*var_l);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_margin (depth = 4)
  gc_frame_newslot(*var_margin);
// call case 4: self request
  params[0] = call705;
  params[1] = *var_l;
  params[2] = *var_margin;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call706 = callmethodflags(self, "wrap(1)to(1)prefix(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe697);
// compiled call node returning call706 (depth = 3)
  int op_slot_right_696 = gc_frame_newslot(call706);
// Begin line 2817
  setline(2817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_trimmedLine (depth = 4)
  int op_slot_right_708 = gc_frame_newslot(*var_trimmedLine);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_margin (depth = 5)
  int op_slot_right_710 = gc_frame_newslot(*var_margin);
// starting to compile string node (depth = 5)
  if (strlit712 == NULL) {
    strlit712 = alloc_String("""\x0a""");
    gc_root(strlit712);
  }
// compiled string node returning strlit712 (depth = 5)
  int op_slot_left_710 = gc_frame_newslot(strlit712);
  params[0] = *var_margin;
  partcv[0] = 1;
  Object opresult713 = callmethod(strlit712, "++(1)", 1, partcv, params);
// compiled op node returning opresult713 (depth = 4)
  int op_slot_left_708 = gc_frame_newslot(opresult713);
  params[0] = *var_trimmedLine;
  partcv[0] = 1;
  Object opresult714 = callmethod(opresult713, "++(1)", 1, partcv, params);
// compiled op node returning opresult714 (depth = 3)
  int op_slot_left_696 = gc_frame_newslot(opresult714);
  params[0] = call706;
  partcv[0] = 1;
  Object opresult715 = callmethod(opresult714, "++(1)", 1, partcv, params);
// compiled op node returning opresult715 (depth = 2)
  gc_frame_end(frame);
  return opresult715;
}
Object meth_ast_visitIf_40_1_41_up_40_1_41_719(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIf(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIf(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitIf(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2857
  setline(2857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe720 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call721 = callmethodflags(self, "visitIf(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe720);
// compiled call node returning call721 (depth = 2)
  gc_frame_end(frame);
  return call721;
}
Object meth_ast_visitBlock_40_1_41_up_40_1_41_722(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlock(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBlock(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBlock(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2858
  setline(2858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe723 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call724 = callmethodflags(self, "visitBlock(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe723);
// compiled call node returning call724 (depth = 2)
  gc_frame_end(frame);
  return call724;
}
Object meth_ast_visitMatchCase_40_1_41_up_40_1_41_725(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMatchCase(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMatchCase(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMatchCase(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2859
  setline(2859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe726 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call727 = callmethodflags(self, "visitMatchCase(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe726);
// compiled call node returning call727 (depth = 2)
  gc_frame_end(frame);
  return call727;
}
Object meth_ast_visitTryCatch_40_1_41_up_40_1_41_728(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTryCatch(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTryCatch(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTryCatch(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2860
  setline(2860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe729 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call730 = callmethodflags(self, "visitTryCatch(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe729);
// compiled call node returning call730 (depth = 2)
  gc_frame_end(frame);
  return call730;
}
Object meth_ast_visitMethodType_40_1_41_up_40_1_41_731(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethodType(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethodType(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMethodType(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2861
  setline(2861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe732 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call733 = callmethodflags(self, "visitMethodType(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe732);
// compiled call node returning call733 (depth = 2)
  gc_frame_end(frame);
  return call733;
}
Object meth_ast_visitSignaturePart_40_1_41_up_40_1_41_734(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitSignaturePart(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitSignaturePart(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitSignaturePart(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2862
  setline(2862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe735 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call736 = callmethodflags(self, "visitSignaturePart(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe735);
// compiled call node returning call736 (depth = 2)
  gc_frame_end(frame);
  return call736;
}
Object meth_ast_visitTypeDec_40_1_41_up_40_1_41_737(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeDec(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeDec(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeDec(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2863
  setline(2863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe738 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call739 = callmethodflags(self, "visitTypeDec(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe738);
// compiled call node returning call739 (depth = 2)
  gc_frame_end(frame);
  return call739;
}
Object meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_740(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeLiteral(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeLiteral(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeLiteral(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2864
  setline(2864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe741 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call742 = callmethodflags(self, "visitTypeLiteral(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe741);
// compiled call node returning call742 (depth = 2)
  gc_frame_end(frame);
  return call742;
}
Object meth_ast_visitTypeParameters_40_1_41_up_40_1_41_743(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeParameters(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeParameters(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeParameters(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeParameters(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeParameters(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2865
  setline(2865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe744 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call745 = callmethodflags(self, "visitTypeParameters(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe744);
// compiled call node returning call745 (depth = 2)
  gc_frame_end(frame);
  return call745;
}
Object meth_ast_visitMethod_40_1_41_up_40_1_41_746(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethod(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethod(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMethod(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2866
  setline(2866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe747 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call748 = callmethodflags(self, "visitMethod(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe747);
// compiled call node returning call748 (depth = 2)
  gc_frame_end(frame);
  return call748;
}
Object meth_ast_visitCall_40_1_41_up_40_1_41_749(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitCall(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitCall(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2867
  setline(2867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe750 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call751 = callmethodflags(self, "visitCall(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe750);
// compiled call node returning call751 (depth = 2)
  gc_frame_end(frame);
  return call751;
}
Object meth_ast_visitObject_40_1_41_up_40_1_41_752(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitObject(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitObject(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitObject(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2868
  setline(2868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe753 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call754 = callmethodflags(self, "visitObject(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe753);
// compiled call node returning call754 (depth = 2)
  gc_frame_end(frame);
  return call754;
}
Object meth_ast_visitModule_40_1_41_up_40_1_41_755(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitModule(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitModule(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitModule(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2869
  setline(2869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe756 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call757 = callmethodflags(self, "visitObject(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe756);
// compiled call node returning call757 (depth = 2)
  gc_frame_end(frame);
  return call757;
}
Object meth_ast_visitArray_40_1_41_up_40_1_41_758(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitArray(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitArray(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitArray(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2870
  setline(2870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe759 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call760 = callmethodflags(self, "visitArray(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe759);
// compiled call node returning call760 (depth = 2)
  gc_frame_end(frame);
  return call760;
}
Object meth_ast_visitMember_40_1_41_up_40_1_41_761(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMember(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMember(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMember(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2871
  setline(2871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe762 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call763 = callmethodflags(self, "visitMember(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe762);
// compiled call node returning call763 (depth = 2)
  gc_frame_end(frame);
  return call763;
}
Object meth_ast_visitGeneric_40_1_41_up_40_1_41_764(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitGeneric(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitGeneric(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitGeneric(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe765 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call766 = callmethodflags(self, "visitGeneric(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe765);
// compiled call node returning call766 (depth = 2)
  gc_frame_end(frame);
  return call766;
}
Object meth_ast_visitIdentifier_40_1_41_up_40_1_41_767(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIdentifier(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIdentifier(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitIdentifier(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2873
  setline(2873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe768 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call769 = callmethodflags(self, "visitIdentifier(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe768);
// compiled call node returning call769 (depth = 2)
  gc_frame_end(frame);
  return call769;
}
Object meth_ast_visitString_40_1_41_up_40_1_41_770(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitString(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitString(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitString(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2874
  setline(2874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe771 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call772 = callmethodflags(self, "visitString(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe771);
// compiled call node returning call772 (depth = 2)
  gc_frame_end(frame);
  return call772;
}
Object meth_ast_visitNum_40_1_41_up_40_1_41_773(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitNum(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitNum(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitNum(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2875
  setline(2875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe774 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call775 = callmethodflags(self, "visitNum(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe774);
// compiled call node returning call775 (depth = 2)
  gc_frame_end(frame);
  return call775;
}
Object meth_ast_visitOp_40_1_41_up_40_1_41_776(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOp(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitOp(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitOp(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2876
  setline(2876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe777 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call778 = callmethodflags(self, "visitOp(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe777);
// compiled call node returning call778 (depth = 2)
  gc_frame_end(frame);
  return call778;
}
Object meth_ast_visitBind_40_1_41_up_40_1_41_779(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBind(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBind(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBind(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2877
  setline(2877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe780 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call781 = callmethodflags(self, "visitBind(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe780);
// compiled call node returning call781 (depth = 2)
  gc_frame_end(frame);
  return call781;
}
Object meth_ast_visitDefDec_40_1_41_up_40_1_41_782(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDefDec(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDefDec(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitDefDec(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2878
  setline(2878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe783 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call784 = callmethodflags(self, "visitDefDec(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe783);
// compiled call node returning call784 (depth = 2)
  gc_frame_end(frame);
  return call784;
}
Object meth_ast_visitVarDec_40_1_41_up_40_1_41_785(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitVarDec(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitVarDec(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitVarDec(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2879
  setline(2879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe786 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call787 = callmethodflags(self, "visitVarDec(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe786);
// compiled call node returning call787 (depth = 2)
  gc_frame_end(frame);
  return call787;
}
Object meth_ast_visitImport_40_1_41_up_40_1_41_788(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImport(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitImport(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitImport(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2880
  setline(2880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe789 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call790 = callmethodflags(self, "visitImport(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe789);
// compiled call node returning call790 (depth = 2)
  gc_frame_end(frame);
  return call790;
}
Object meth_ast_visitReturn_40_1_41_up_40_1_41_791(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitReturn(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitReturn(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitReturn(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2881
  setline(2881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe792 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call793 = callmethodflags(self, "visitReturn(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe792);
// compiled call node returning call793 (depth = 2)
  gc_frame_end(frame);
  return call793;
}
Object meth_ast_visitInherits_40_1_41_up_40_1_41_794(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitInherits(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitInherits(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitInherits(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2882
  setline(2882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe795 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call796 = callmethodflags(self, "visitInherits(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe795);
// compiled call node returning call796 (depth = 2)
  gc_frame_end(frame);
  return call796;
}
Object meth_ast_visitDialect_40_1_41_up_40_1_41_797(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDialect(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDialect(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitDialect(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2883
  setline(2883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe798 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call799 = callmethodflags(self, "visitDialect(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe798);
// compiled call node returning call799 (depth = 2)
  gc_frame_end(frame);
  return call799;
}
Object meth_ast_visitBlank_40_1_41_up_40_1_41_800(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlank(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBlank(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBlank(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2884
  setline(2884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe801 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call802 = callmethodflags(self, "visitBlank(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe801);
// compiled call node returning call802 (depth = 2)
  gc_frame_end(frame);
  return call802;
}
Object meth_ast_visitComment_40_1_41_up_40_1_41_803(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitComment(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitComment(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitComment(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2885
  setline(2885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe804 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call805 = callmethodflags(self, "visitComment(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe804);
// compiled call node returning call805 (depth = 2)
  gc_frame_end(frame);
  return call805;
}
Object meth_ast_visitImplicit_40_1_41_up_40_1_41_806(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImplicit(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImplicit(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImplicit(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitImplicit(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitImplicit(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2886
  setline(2886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe807 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call808 = callmethodflags(self, "visitImplicit(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe807);
// compiled call node returning call808 (depth = 2)
  gc_frame_end(frame);
  return call808;
}
Object meth_ast_visitIf_40_1_41_809(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIf(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitIf(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitIf(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2888
  setline(2888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool810 = alloc_Boolean(1);
// compiled identifier node returning bool810 (depth = 2)
  gc_frame_end(frame);
  return bool810;
}
Object meth_ast_visitBlock_40_1_41_811(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlock(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitBlock(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBlock(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2889
  setline(2889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool812 = alloc_Boolean(1);
// compiled identifier node returning bool812 (depth = 2)
  gc_frame_end(frame);
  return bool812;
}
Object meth_ast_visitMatchCase_40_1_41_813(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMatchCase(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMatchCase(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMatchCase(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2890
  setline(2890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool814 = alloc_Boolean(1);
// compiled identifier node returning bool814 (depth = 2)
  gc_frame_end(frame);
  return bool814;
}
Object meth_ast_visitTryCatch_40_1_41_815(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTryCatch(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTryCatch(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTryCatch(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2891
  setline(2891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool816 = alloc_Boolean(1);
// compiled identifier node returning bool816 (depth = 2)
  gc_frame_end(frame);
  return bool816;
}
Object meth_ast_visitMethodType_40_1_41_817(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethodType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMethodType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMethodType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2892
  setline(2892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool818 = alloc_Boolean(1);
// compiled identifier node returning bool818 (depth = 2)
  gc_frame_end(frame);
  return bool818;
}
Object meth_ast_visitSignaturePart_40_1_41_819(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitSignaturePart(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitSignaturePart(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitSignaturePart(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2893
  setline(2893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool820 = alloc_Boolean(1);
// compiled identifier node returning bool820 (depth = 2)
  gc_frame_end(frame);
  return bool820;
}
Object meth_ast_visitTypeDec_40_1_41_821(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeDec(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeDec(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeDec(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2894
  setline(2894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool822 = alloc_Boolean(1);
// compiled identifier node returning bool822 (depth = 2)
  gc_frame_end(frame);
  return bool822;
}
Object meth_ast_visitTypeLiteral_40_1_41_823(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeLiteral(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeLiteral(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeLiteral(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2895
  setline(2895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool824 = alloc_Boolean(1);
// compiled identifier node returning bool824 (depth = 2)
  gc_frame_end(frame);
  return bool824;
}
Object meth_ast_visitTypeParameters_40_1_41_825(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeParameters(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeParameters(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeParameters(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeParameters(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2896
  setline(2896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool826 = alloc_Boolean(1);
// compiled identifier node returning bool826 (depth = 2)
  gc_frame_end(frame);
  return bool826;
}
Object meth_ast_visitMethod_40_1_41_827(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethod(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMethod(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMethod(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2897
  setline(2897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool828 = alloc_Boolean(1);
// compiled identifier node returning bool828 (depth = 2)
  gc_frame_end(frame);
  return bool828;
}
Object meth_ast_visitCall_40_1_41_829(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitCall(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitCall(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2898
  setline(2898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool830 = alloc_Boolean(1);
// compiled identifier node returning bool830 (depth = 2)
  gc_frame_end(frame);
  return bool830;
}
Object meth_ast_visitObject_40_1_41_831(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitObject(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitObject(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitObject(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2899
  setline(2899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool832 = alloc_Boolean(1);
// compiled identifier node returning bool832 (depth = 2)
  gc_frame_end(frame);
  return bool832;
}
Object meth_ast_visitModule_40_1_41_833(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitModule(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitModule(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitModule(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2900
  setline(2900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool834 = alloc_Boolean(1);
// compiled identifier node returning bool834 (depth = 2)
  gc_frame_end(frame);
  return bool834;
}
Object meth_ast_visitArray_40_1_41_835(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitArray(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitArray(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitArray(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2901
  setline(2901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool836 = alloc_Boolean(1);
// compiled identifier node returning bool836 (depth = 2)
  gc_frame_end(frame);
  return bool836;
}
Object meth_ast_visitMember_40_1_41_837(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMember(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMember(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMember(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2902
  setline(2902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool838 = alloc_Boolean(1);
// compiled identifier node returning bool838 (depth = 2)
  gc_frame_end(frame);
  return bool838;
}
Object meth_ast_visitGeneric_40_1_41_839(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitGeneric(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitGeneric(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitGeneric(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2903
  setline(2903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool840 = alloc_Boolean(1);
// compiled identifier node returning bool840 (depth = 2)
  gc_frame_end(frame);
  return bool840;
}
Object meth_ast_visitIdentifier_40_1_41_841(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIdentifier(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitIdentifier(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitIdentifier(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2904
  setline(2904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool842 = alloc_Boolean(1);
// compiled identifier node returning bool842 (depth = 2)
  gc_frame_end(frame);
  return bool842;
}
Object meth_ast_visitString_40_1_41_843(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitString(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitString(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitString(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2905
  setline(2905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool844 = alloc_Boolean(1);
// compiled identifier node returning bool844 (depth = 2)
  gc_frame_end(frame);
  return bool844;
}
Object meth_ast_visitNum_40_1_41_845(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitNum(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitNum(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitNum(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2906
  setline(2906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool846 = alloc_Boolean(1);
// compiled identifier node returning bool846 (depth = 2)
  gc_frame_end(frame);
  return bool846;
}
Object meth_ast_visitOp_40_1_41_847(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOp(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitOp(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitOp(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2907
  setline(2907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool848 = alloc_Boolean(1);
// compiled identifier node returning bool848 (depth = 2)
  gc_frame_end(frame);
  return bool848;
}
Object meth_ast_visitBind_40_1_41_849(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBind(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitBind(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBind(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2908
  setline(2908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool850 = alloc_Boolean(1);
// compiled identifier node returning bool850 (depth = 2)
  gc_frame_end(frame);
  return bool850;
}
Object meth_ast_visitDefDec_40_1_41_851(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDefDec(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitDefDec(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitDefDec(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2909
  setline(2909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool852 = alloc_Boolean(1);
// compiled identifier node returning bool852 (depth = 2)
  gc_frame_end(frame);
  return bool852;
}
Object meth_ast_visitVarDec_40_1_41_853(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitVarDec(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitVarDec(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitVarDec(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2910
  setline(2910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool854 = alloc_Boolean(1);
// compiled identifier node returning bool854 (depth = 2)
  gc_frame_end(frame);
  return bool854;
}
Object meth_ast_visitImport_40_1_41_855(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImport(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitImport(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitImport(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2911
  setline(2911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool856 = alloc_Boolean(1);
// compiled identifier node returning bool856 (depth = 2)
  gc_frame_end(frame);
  return bool856;
}
Object meth_ast_visitReturn_40_1_41_857(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitReturn(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitReturn(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitReturn(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2912
  setline(2912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool858 = alloc_Boolean(1);
// compiled identifier node returning bool858 (depth = 2)
  gc_frame_end(frame);
  return bool858;
}
Object meth_ast_visitInherits_40_1_41_859(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitInherits(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitInherits(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitInherits(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2913
  setline(2913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool860 = alloc_Boolean(1);
// compiled identifier node returning bool860 (depth = 2)
  gc_frame_end(frame);
  return bool860;
}
Object meth_ast_visitDialect_40_1_41_861(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDialect(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitDialect(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitDialect(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2914
  setline(2914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool862 = alloc_Boolean(1);
// compiled identifier node returning bool862 (depth = 2)
  gc_frame_end(frame);
  return bool862;
}
Object meth_ast_visitBlank_40_1_41_863(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlank(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitBlank(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBlank(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2915
  setline(2915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool864 = alloc_Boolean(1);
// compiled identifier node returning bool864 (depth = 2)
  gc_frame_end(frame);
  return bool864;
}
Object meth_ast_visitComment_40_1_41_865(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitComment(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitComment(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitComment(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2916
  setline(2916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool866 = alloc_Boolean(1);
// compiled identifier node returning bool866 (depth = 2)
  gc_frame_end(frame);
  return bool866;
}
Object meth_ast_visitImplicit_40_1_41_867(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImplicit(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImplicit(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitImplicit(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitImplicit(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool868 = alloc_Boolean(1);
// compiled identifier node returning bool868 (depth = 2)
  gc_frame_end(frame);
  return bool868;
}
Object meth_ast_asString869(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2919
  setline(2919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit870 == NULL) {
    strlit870 = alloc_String("an AST visitor");
    gc_root(strlit870);
  }
// compiled string node returning strlit870 (depth = 2)
  gc_frame_end(frame);
  return strlit870;
}
Object meth_ast_baseVisitor716(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "baseVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject717 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj717 = alloc_userobj2(61,62, objclass717);
  gc_frame_newslot(obj717);
if (objclass717 == NULL) {
  glfree(obj717->class->name);
  obj717->class->name = "baseVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj717, self, 0);
  addmethodreal(obj717,"outer", &reader_ast_outer_718);
  Object oldself717 = self;
  struct StackFrameObject *oldstackframe717 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe717);
  gc_frame_newslot((Object)stackframe);
  self = obj717;
  Object *oldselfslot717 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter717 = (*(struct UserObject *)self).data[0], lowerouter717 = thisouter717;
  if (inheritingObject717) {
    struct UserObject *inho717 = (struct UserObject *)inheritingObject717;
    while (inho717->super != GraceDefaultObject) inho717 = (struct UserObject *)inho717->super;
    inho717->super = obj717;
    self = inheritingObject717;
    *selfslot = self;
    lowerouter717 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter717;
  }
// method "visitIf(_)up(_)"
  struct UserObject *uo719 = (struct UserObject*)obj717;
  uo719->data[1] = emptyclosure;
  Method *meth_meth_ast_visitIf_40_1_41_up_40_1_41_719 = addmethod2pos(obj717, "visitIf(1)up(1)", &meth_ast_visitIf_40_1_41_up_40_1_41_719, 1);
  int argcv_meth_ast_visitIf_40_1_41_up_40_1_41_719[] = {1, 1};
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_719->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40_1_41_up_40_1_41_719);
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_719->definitionModule = modulename;
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_719->definitionLine = 2857;
// method "visitBlock(_)up(_)"
  struct UserObject *uo722 = (struct UserObject*)obj717;
  uo722->data[2] = emptyclosure;
  Method *meth_meth_ast_visitBlock_40_1_41_up_40_1_41_722 = addmethod2pos(obj717, "visitBlock(1)up(1)", &meth_ast_visitBlock_40_1_41_up_40_1_41_722, 2);
  int argcv_meth_ast_visitBlock_40_1_41_up_40_1_41_722[] = {1, 1};
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_722->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40_1_41_up_40_1_41_722);
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_722->definitionModule = modulename;
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_722->definitionLine = 2858;
// method "visitMatchCase(_)up(_)"
  struct UserObject *uo725 = (struct UserObject*)obj717;
  uo725->data[3] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_725 = addmethod2pos(obj717, "visitMatchCase(1)up(1)", &meth_ast_visitMatchCase_40_1_41_up_40_1_41_725, 3);
  int argcv_meth_ast_visitMatchCase_40_1_41_up_40_1_41_725[] = {1, 1};
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_725->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40_1_41_up_40_1_41_725);
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_725->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_725->definitionLine = 2859;
// method "visitTryCatch(_)up(_)"
  struct UserObject *uo728 = (struct UserObject*)obj717;
  uo728->data[4] = emptyclosure;
  Method *meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_728 = addmethod2pos(obj717, "visitTryCatch(1)up(1)", &meth_ast_visitTryCatch_40_1_41_up_40_1_41_728, 4);
  int argcv_meth_ast_visitTryCatch_40_1_41_up_40_1_41_728[] = {1, 1};
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_728->type = alloc_MethodType(2, argcv_meth_ast_visitTryCatch_40_1_41_up_40_1_41_728);
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_728->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_728->definitionLine = 2860;
// method "visitMethodType(_)up(_)"
  struct UserObject *uo731 = (struct UserObject*)obj717;
  uo731->data[5] = emptyclosure;
  Method *meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_731 = addmethod2pos(obj717, "visitMethodType(1)up(1)", &meth_ast_visitMethodType_40_1_41_up_40_1_41_731, 5);
  int argcv_meth_ast_visitMethodType_40_1_41_up_40_1_41_731[] = {1, 1};
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_731->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40_1_41_up_40_1_41_731);
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_731->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_731->definitionLine = 2861;
// method "visitSignaturePart(_)up(_)"
  struct UserObject *uo734 = (struct UserObject*)obj717;
  uo734->data[6] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_734 = addmethod2pos(obj717, "visitSignaturePart(1)up(1)", &meth_ast_visitSignaturePart_40_1_41_up_40_1_41_734, 6);
  int argcv_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_734[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_734->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_734);
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_734->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_734->definitionLine = 2862;
// method "visitTypeDec(_)up(_)"
  struct UserObject *uo737 = (struct UserObject*)obj717;
  uo737->data[7] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_737 = addmethod2pos(obj717, "visitTypeDec(1)up(1)", &meth_ast_visitTypeDec_40_1_41_up_40_1_41_737, 7);
  int argcv_meth_ast_visitTypeDec_40_1_41_up_40_1_41_737[] = {1, 1};
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_737->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40_1_41_up_40_1_41_737);
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_737->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_737->definitionLine = 2863;
// method "visitTypeLiteral(_)up(_)"
  struct UserObject *uo740 = (struct UserObject*)obj717;
  uo740->data[8] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_740 = addmethod2pos(obj717, "visitTypeLiteral(1)up(1)", &meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_740, 8);
  int argcv_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_740[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_740->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_740);
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_740->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_740->definitionLine = 2864;
// method "visitTypeParameters(_)up(_)"
  struct UserObject *uo743 = (struct UserObject*)obj717;
  uo743->data[9] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_743 = addmethod2pos(obj717, "visitTypeParameters(1)up(1)", &meth_ast_visitTypeParameters_40_1_41_up_40_1_41_743, 9);
  int argcv_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_743[] = {1, 1};
  meth_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_743->type = alloc_MethodType(2, argcv_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_743);
  meth_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_743->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_743->definitionLine = 2865;
// method "visitMethod(_)up(_)"
  struct UserObject *uo746 = (struct UserObject*)obj717;
  uo746->data[10] = emptyclosure;
  Method *meth_meth_ast_visitMethod_40_1_41_up_40_1_41_746 = addmethod2pos(obj717, "visitMethod(1)up(1)", &meth_ast_visitMethod_40_1_41_up_40_1_41_746, 10);
  int argcv_meth_ast_visitMethod_40_1_41_up_40_1_41_746[] = {1, 1};
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_746->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40_1_41_up_40_1_41_746);
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_746->definitionModule = modulename;
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_746->definitionLine = 2866;
// method "visitCall(_)up(_)"
  struct UserObject *uo749 = (struct UserObject*)obj717;
  uo749->data[11] = emptyclosure;
  Method *meth_meth_ast_visitCall_40_1_41_up_40_1_41_749 = addmethod2pos(obj717, "visitCall(1)up(1)", &meth_ast_visitCall_40_1_41_up_40_1_41_749, 11);
  int argcv_meth_ast_visitCall_40_1_41_up_40_1_41_749[] = {1, 1};
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_749->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40_1_41_up_40_1_41_749);
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_749->definitionModule = modulename;
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_749->definitionLine = 2867;
// method "visitObject(_)up(_)"
  struct UserObject *uo752 = (struct UserObject*)obj717;
  uo752->data[12] = emptyclosure;
  Method *meth_meth_ast_visitObject_40_1_41_up_40_1_41_752 = addmethod2pos(obj717, "visitObject(1)up(1)", &meth_ast_visitObject_40_1_41_up_40_1_41_752, 12);
  int argcv_meth_ast_visitObject_40_1_41_up_40_1_41_752[] = {1, 1};
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_752->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40_1_41_up_40_1_41_752);
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_752->definitionModule = modulename;
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_752->definitionLine = 2868;
// method "visitModule(_)up(_)"
  struct UserObject *uo755 = (struct UserObject*)obj717;
  uo755->data[13] = emptyclosure;
  Method *meth_meth_ast_visitModule_40_1_41_up_40_1_41_755 = addmethod2pos(obj717, "visitModule(1)up(1)", &meth_ast_visitModule_40_1_41_up_40_1_41_755, 13);
  int argcv_meth_ast_visitModule_40_1_41_up_40_1_41_755[] = {1, 1};
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_755->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40_1_41_up_40_1_41_755);
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_755->definitionModule = modulename;
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_755->definitionLine = 2869;
// method "visitArray(_)up(_)"
  struct UserObject *uo758 = (struct UserObject*)obj717;
  uo758->data[14] = emptyclosure;
  Method *meth_meth_ast_visitArray_40_1_41_up_40_1_41_758 = addmethod2pos(obj717, "visitArray(1)up(1)", &meth_ast_visitArray_40_1_41_up_40_1_41_758, 14);
  int argcv_meth_ast_visitArray_40_1_41_up_40_1_41_758[] = {1, 1};
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_758->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40_1_41_up_40_1_41_758);
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_758->definitionModule = modulename;
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_758->definitionLine = 2870;
// method "visitMember(_)up(_)"
  struct UserObject *uo761 = (struct UserObject*)obj717;
  uo761->data[15] = emptyclosure;
  Method *meth_meth_ast_visitMember_40_1_41_up_40_1_41_761 = addmethod2pos(obj717, "visitMember(1)up(1)", &meth_ast_visitMember_40_1_41_up_40_1_41_761, 15);
  int argcv_meth_ast_visitMember_40_1_41_up_40_1_41_761[] = {1, 1};
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_761->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40_1_41_up_40_1_41_761);
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_761->definitionModule = modulename;
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_761->definitionLine = 2871;
// method "visitGeneric(_)up(_)"
  struct UserObject *uo764 = (struct UserObject*)obj717;
  uo764->data[16] = emptyclosure;
  Method *meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_764 = addmethod2pos(obj717, "visitGeneric(1)up(1)", &meth_ast_visitGeneric_40_1_41_up_40_1_41_764, 16);
  int argcv_meth_ast_visitGeneric_40_1_41_up_40_1_41_764[] = {1, 1};
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_764->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40_1_41_up_40_1_41_764);
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_764->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_764->definitionLine = 2872;
// method "visitIdentifier(_)up(_)"
  struct UserObject *uo767 = (struct UserObject*)obj717;
  uo767->data[17] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_767 = addmethod2pos(obj717, "visitIdentifier(1)up(1)", &meth_ast_visitIdentifier_40_1_41_up_40_1_41_767, 17);
  int argcv_meth_ast_visitIdentifier_40_1_41_up_40_1_41_767[] = {1, 1};
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_767->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40_1_41_up_40_1_41_767);
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_767->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_767->definitionLine = 2873;
// method "visitString(_)up(_)"
  struct UserObject *uo770 = (struct UserObject*)obj717;
  uo770->data[18] = emptyclosure;
  Method *meth_meth_ast_visitString_40_1_41_up_40_1_41_770 = addmethod2pos(obj717, "visitString(1)up(1)", &meth_ast_visitString_40_1_41_up_40_1_41_770, 18);
  int argcv_meth_ast_visitString_40_1_41_up_40_1_41_770[] = {1, 1};
  meth_meth_ast_visitString_40_1_41_up_40_1_41_770->type = alloc_MethodType(2, argcv_meth_ast_visitString_40_1_41_up_40_1_41_770);
  meth_meth_ast_visitString_40_1_41_up_40_1_41_770->definitionModule = modulename;
  meth_meth_ast_visitString_40_1_41_up_40_1_41_770->definitionLine = 2874;
// method "visitNum(_)up(_)"
  struct UserObject *uo773 = (struct UserObject*)obj717;
  uo773->data[19] = emptyclosure;
  Method *meth_meth_ast_visitNum_40_1_41_up_40_1_41_773 = addmethod2pos(obj717, "visitNum(1)up(1)", &meth_ast_visitNum_40_1_41_up_40_1_41_773, 19);
  int argcv_meth_ast_visitNum_40_1_41_up_40_1_41_773[] = {1, 1};
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_773->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40_1_41_up_40_1_41_773);
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_773->definitionModule = modulename;
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_773->definitionLine = 2875;
// method "visitOp(_)up(_)"
  struct UserObject *uo776 = (struct UserObject*)obj717;
  uo776->data[20] = emptyclosure;
  Method *meth_meth_ast_visitOp_40_1_41_up_40_1_41_776 = addmethod2pos(obj717, "visitOp(1)up(1)", &meth_ast_visitOp_40_1_41_up_40_1_41_776, 20);
  int argcv_meth_ast_visitOp_40_1_41_up_40_1_41_776[] = {1, 1};
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_776->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40_1_41_up_40_1_41_776);
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_776->definitionModule = modulename;
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_776->definitionLine = 2876;
// method "visitBind(_)up(_)"
  struct UserObject *uo779 = (struct UserObject*)obj717;
  uo779->data[21] = emptyclosure;
  Method *meth_meth_ast_visitBind_40_1_41_up_40_1_41_779 = addmethod2pos(obj717, "visitBind(1)up(1)", &meth_ast_visitBind_40_1_41_up_40_1_41_779, 21);
  int argcv_meth_ast_visitBind_40_1_41_up_40_1_41_779[] = {1, 1};
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_779->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40_1_41_up_40_1_41_779);
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_779->definitionModule = modulename;
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_779->definitionLine = 2877;
// method "visitDefDec(_)up(_)"
  struct UserObject *uo782 = (struct UserObject*)obj717;
  uo782->data[22] = emptyclosure;
  Method *meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_782 = addmethod2pos(obj717, "visitDefDec(1)up(1)", &meth_ast_visitDefDec_40_1_41_up_40_1_41_782, 22);
  int argcv_meth_ast_visitDefDec_40_1_41_up_40_1_41_782[] = {1, 1};
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_782->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40_1_41_up_40_1_41_782);
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_782->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_782->definitionLine = 2878;
// method "visitVarDec(_)up(_)"
  struct UserObject *uo785 = (struct UserObject*)obj717;
  uo785->data[23] = emptyclosure;
  Method *meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_785 = addmethod2pos(obj717, "visitVarDec(1)up(1)", &meth_ast_visitVarDec_40_1_41_up_40_1_41_785, 23);
  int argcv_meth_ast_visitVarDec_40_1_41_up_40_1_41_785[] = {1, 1};
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_785->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40_1_41_up_40_1_41_785);
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_785->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_785->definitionLine = 2879;
// method "visitImport(_)up(_)"
  struct UserObject *uo788 = (struct UserObject*)obj717;
  uo788->data[24] = emptyclosure;
  Method *meth_meth_ast_visitImport_40_1_41_up_40_1_41_788 = addmethod2pos(obj717, "visitImport(1)up(1)", &meth_ast_visitImport_40_1_41_up_40_1_41_788, 24);
  int argcv_meth_ast_visitImport_40_1_41_up_40_1_41_788[] = {1, 1};
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_788->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40_1_41_up_40_1_41_788);
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_788->definitionModule = modulename;
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_788->definitionLine = 2880;
// method "visitReturn(_)up(_)"
  struct UserObject *uo791 = (struct UserObject*)obj717;
  uo791->data[25] = emptyclosure;
  Method *meth_meth_ast_visitReturn_40_1_41_up_40_1_41_791 = addmethod2pos(obj717, "visitReturn(1)up(1)", &meth_ast_visitReturn_40_1_41_up_40_1_41_791, 25);
  int argcv_meth_ast_visitReturn_40_1_41_up_40_1_41_791[] = {1, 1};
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_791->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40_1_41_up_40_1_41_791);
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_791->definitionModule = modulename;
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_791->definitionLine = 2881;
// method "visitInherits(_)up(_)"
  struct UserObject *uo794 = (struct UserObject*)obj717;
  uo794->data[26] = emptyclosure;
  Method *meth_meth_ast_visitInherits_40_1_41_up_40_1_41_794 = addmethod2pos(obj717, "visitInherits(1)up(1)", &meth_ast_visitInherits_40_1_41_up_40_1_41_794, 26);
  int argcv_meth_ast_visitInherits_40_1_41_up_40_1_41_794[] = {1, 1};
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_794->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40_1_41_up_40_1_41_794);
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_794->definitionModule = modulename;
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_794->definitionLine = 2882;
// method "visitDialect(_)up(_)"
  struct UserObject *uo797 = (struct UserObject*)obj717;
  uo797->data[27] = emptyclosure;
  Method *meth_meth_ast_visitDialect_40_1_41_up_40_1_41_797 = addmethod2pos(obj717, "visitDialect(1)up(1)", &meth_ast_visitDialect_40_1_41_up_40_1_41_797, 27);
  int argcv_meth_ast_visitDialect_40_1_41_up_40_1_41_797[] = {1, 1};
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_797->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40_1_41_up_40_1_41_797);
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_797->definitionModule = modulename;
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_797->definitionLine = 2883;
// method "visitBlank(_)up(_)"
  struct UserObject *uo800 = (struct UserObject*)obj717;
  uo800->data[28] = emptyclosure;
  Method *meth_meth_ast_visitBlank_40_1_41_up_40_1_41_800 = addmethod2pos(obj717, "visitBlank(1)up(1)", &meth_ast_visitBlank_40_1_41_up_40_1_41_800, 28);
  int argcv_meth_ast_visitBlank_40_1_41_up_40_1_41_800[] = {1, 1};
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_800->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40_1_41_up_40_1_41_800);
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_800->definitionModule = modulename;
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_800->definitionLine = 2884;
// method "visitComment(_)up(_)"
  struct UserObject *uo803 = (struct UserObject*)obj717;
  uo803->data[29] = emptyclosure;
  Method *meth_meth_ast_visitComment_40_1_41_up_40_1_41_803 = addmethod2pos(obj717, "visitComment(1)up(1)", &meth_ast_visitComment_40_1_41_up_40_1_41_803, 29);
  int argcv_meth_ast_visitComment_40_1_41_up_40_1_41_803[] = {1, 1};
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_803->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40_1_41_up_40_1_41_803);
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_803->definitionModule = modulename;
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_803->definitionLine = 2885;
// method "visitImplicit(_)up(_)"
  struct UserObject *uo806 = (struct UserObject*)obj717;
  uo806->data[30] = emptyclosure;
  Method *meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_806 = addmethod2pos(obj717, "visitImplicit(1)up(1)", &meth_ast_visitImplicit_40_1_41_up_40_1_41_806, 30);
  int argcv_meth_ast_visitImplicit_40_1_41_up_40_1_41_806[] = {1, 1};
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_806->type = alloc_MethodType(2, argcv_meth_ast_visitImplicit_40_1_41_up_40_1_41_806);
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_806->definitionModule = modulename;
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_806->definitionLine = 2886;
// method "visitIf(_)"
  struct UserObject *uo809 = (struct UserObject*)obj717;
  uo809->data[31] = emptyclosure;
  Method *meth_meth_ast_visitIf_40_1_41_809 = addmethod2pos(obj717, "visitIf(1)", &meth_ast_visitIf_40_1_41_809, 31);
  int argcv_meth_ast_visitIf_40_1_41_809[] = {1};
  meth_meth_ast_visitIf_40_1_41_809->type = alloc_MethodType(1, argcv_meth_ast_visitIf_40_1_41_809);
  meth_meth_ast_visitIf_40_1_41_809->definitionModule = modulename;
  meth_meth_ast_visitIf_40_1_41_809->definitionLine = 2888;
// method "visitBlock(_)"
  struct UserObject *uo811 = (struct UserObject*)obj717;
  uo811->data[32] = emptyclosure;
  Method *meth_meth_ast_visitBlock_40_1_41_811 = addmethod2pos(obj717, "visitBlock(1)", &meth_ast_visitBlock_40_1_41_811, 32);
  int argcv_meth_ast_visitBlock_40_1_41_811[] = {1};
  meth_meth_ast_visitBlock_40_1_41_811->type = alloc_MethodType(1, argcv_meth_ast_visitBlock_40_1_41_811);
  meth_meth_ast_visitBlock_40_1_41_811->definitionModule = modulename;
  meth_meth_ast_visitBlock_40_1_41_811->definitionLine = 2889;
// method "visitMatchCase(_)"
  struct UserObject *uo813 = (struct UserObject*)obj717;
  uo813->data[33] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase_40_1_41_813 = addmethod2pos(obj717, "visitMatchCase(1)", &meth_ast_visitMatchCase_40_1_41_813, 33);
  int argcv_meth_ast_visitMatchCase_40_1_41_813[] = {1};
  meth_meth_ast_visitMatchCase_40_1_41_813->type = alloc_MethodType(1, argcv_meth_ast_visitMatchCase_40_1_41_813);
  meth_meth_ast_visitMatchCase_40_1_41_813->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40_1_41_813->definitionLine = 2890;
// method "visitTryCatch(_)"
  struct UserObject *uo815 = (struct UserObject*)obj717;
  uo815->data[34] = emptyclosure;
  Method *meth_meth_ast_visitTryCatch_40_1_41_815 = addmethod2pos(obj717, "visitTryCatch(1)", &meth_ast_visitTryCatch_40_1_41_815, 34);
  int argcv_meth_ast_visitTryCatch_40_1_41_815[] = {1};
  meth_meth_ast_visitTryCatch_40_1_41_815->type = alloc_MethodType(1, argcv_meth_ast_visitTryCatch_40_1_41_815);
  meth_meth_ast_visitTryCatch_40_1_41_815->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40_1_41_815->definitionLine = 2891;
// method "visitMethodType(_)"
  struct UserObject *uo817 = (struct UserObject*)obj717;
  uo817->data[35] = emptyclosure;
  Method *meth_meth_ast_visitMethodType_40_1_41_817 = addmethod2pos(obj717, "visitMethodType(1)", &meth_ast_visitMethodType_40_1_41_817, 35);
  int argcv_meth_ast_visitMethodType_40_1_41_817[] = {1};
  meth_meth_ast_visitMethodType_40_1_41_817->type = alloc_MethodType(1, argcv_meth_ast_visitMethodType_40_1_41_817);
  meth_meth_ast_visitMethodType_40_1_41_817->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40_1_41_817->definitionLine = 2892;
// method "visitSignaturePart(_)"
  struct UserObject *uo819 = (struct UserObject*)obj717;
  uo819->data[36] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart_40_1_41_819 = addmethod2pos(obj717, "visitSignaturePart(1)", &meth_ast_visitSignaturePart_40_1_41_819, 36);
  int argcv_meth_ast_visitSignaturePart_40_1_41_819[] = {1};
  meth_meth_ast_visitSignaturePart_40_1_41_819->type = alloc_MethodType(1, argcv_meth_ast_visitSignaturePart_40_1_41_819);
  meth_meth_ast_visitSignaturePart_40_1_41_819->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40_1_41_819->definitionLine = 2893;
// method "visitTypeDec(_)"
  struct UserObject *uo821 = (struct UserObject*)obj717;
  uo821->data[37] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec_40_1_41_821 = addmethod2pos(obj717, "visitTypeDec(1)", &meth_ast_visitTypeDec_40_1_41_821, 37);
  int argcv_meth_ast_visitTypeDec_40_1_41_821[] = {1};
  meth_meth_ast_visitTypeDec_40_1_41_821->type = alloc_MethodType(1, argcv_meth_ast_visitTypeDec_40_1_41_821);
  meth_meth_ast_visitTypeDec_40_1_41_821->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40_1_41_821->definitionLine = 2894;
// method "visitTypeLiteral(_)"
  struct UserObject *uo823 = (struct UserObject*)obj717;
  uo823->data[38] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral_40_1_41_823 = addmethod2pos(obj717, "visitTypeLiteral(1)", &meth_ast_visitTypeLiteral_40_1_41_823, 38);
  int argcv_meth_ast_visitTypeLiteral_40_1_41_823[] = {1};
  meth_meth_ast_visitTypeLiteral_40_1_41_823->type = alloc_MethodType(1, argcv_meth_ast_visitTypeLiteral_40_1_41_823);
  meth_meth_ast_visitTypeLiteral_40_1_41_823->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40_1_41_823->definitionLine = 2895;
// method "visitTypeParameters(_)"
  struct UserObject *uo825 = (struct UserObject*)obj717;
  uo825->data[39] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters_40_1_41_825 = addmethod2pos(obj717, "visitTypeParameters(1)", &meth_ast_visitTypeParameters_40_1_41_825, 39);
  int argcv_meth_ast_visitTypeParameters_40_1_41_825[] = {1};
  meth_meth_ast_visitTypeParameters_40_1_41_825->type = alloc_MethodType(1, argcv_meth_ast_visitTypeParameters_40_1_41_825);
  meth_meth_ast_visitTypeParameters_40_1_41_825->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters_40_1_41_825->definitionLine = 2896;
// method "visitMethod(_)"
  struct UserObject *uo827 = (struct UserObject*)obj717;
  uo827->data[40] = emptyclosure;
  Method *meth_meth_ast_visitMethod_40_1_41_827 = addmethod2pos(obj717, "visitMethod(1)", &meth_ast_visitMethod_40_1_41_827, 40);
  int argcv_meth_ast_visitMethod_40_1_41_827[] = {1};
  meth_meth_ast_visitMethod_40_1_41_827->type = alloc_MethodType(1, argcv_meth_ast_visitMethod_40_1_41_827);
  meth_meth_ast_visitMethod_40_1_41_827->definitionModule = modulename;
  meth_meth_ast_visitMethod_40_1_41_827->definitionLine = 2897;
// method "visitCall(_)"
  struct UserObject *uo829 = (struct UserObject*)obj717;
  uo829->data[41] = emptyclosure;
  Method *meth_meth_ast_visitCall_40_1_41_829 = addmethod2pos(obj717, "visitCall(1)", &meth_ast_visitCall_40_1_41_829, 41);
  int argcv_meth_ast_visitCall_40_1_41_829[] = {1};
  meth_meth_ast_visitCall_40_1_41_829->type = alloc_MethodType(1, argcv_meth_ast_visitCall_40_1_41_829);
  meth_meth_ast_visitCall_40_1_41_829->definitionModule = modulename;
  meth_meth_ast_visitCall_40_1_41_829->definitionLine = 2898;
// method "visitObject(_)"
  struct UserObject *uo831 = (struct UserObject*)obj717;
  uo831->data[42] = emptyclosure;
  Method *meth_meth_ast_visitObject_40_1_41_831 = addmethod2pos(obj717, "visitObject(1)", &meth_ast_visitObject_40_1_41_831, 42);
  int argcv_meth_ast_visitObject_40_1_41_831[] = {1};
  meth_meth_ast_visitObject_40_1_41_831->type = alloc_MethodType(1, argcv_meth_ast_visitObject_40_1_41_831);
  meth_meth_ast_visitObject_40_1_41_831->definitionModule = modulename;
  meth_meth_ast_visitObject_40_1_41_831->definitionLine = 2899;
// method "visitModule(_)"
  struct UserObject *uo833 = (struct UserObject*)obj717;
  uo833->data[43] = emptyclosure;
  Method *meth_meth_ast_visitModule_40_1_41_833 = addmethod2pos(obj717, "visitModule(1)", &meth_ast_visitModule_40_1_41_833, 43);
  int argcv_meth_ast_visitModule_40_1_41_833[] = {1};
  meth_meth_ast_visitModule_40_1_41_833->type = alloc_MethodType(1, argcv_meth_ast_visitModule_40_1_41_833);
  meth_meth_ast_visitModule_40_1_41_833->definitionModule = modulename;
  meth_meth_ast_visitModule_40_1_41_833->definitionLine = 2900;
// method "visitArray(_)"
  struct UserObject *uo835 = (struct UserObject*)obj717;
  uo835->data[44] = emptyclosure;
  Method *meth_meth_ast_visitArray_40_1_41_835 = addmethod2pos(obj717, "visitArray(1)", &meth_ast_visitArray_40_1_41_835, 44);
  int argcv_meth_ast_visitArray_40_1_41_835[] = {1};
  meth_meth_ast_visitArray_40_1_41_835->type = alloc_MethodType(1, argcv_meth_ast_visitArray_40_1_41_835);
  meth_meth_ast_visitArray_40_1_41_835->definitionModule = modulename;
  meth_meth_ast_visitArray_40_1_41_835->definitionLine = 2901;
// method "visitMember(_)"
  struct UserObject *uo837 = (struct UserObject*)obj717;
  uo837->data[45] = emptyclosure;
  Method *meth_meth_ast_visitMember_40_1_41_837 = addmethod2pos(obj717, "visitMember(1)", &meth_ast_visitMember_40_1_41_837, 45);
  int argcv_meth_ast_visitMember_40_1_41_837[] = {1};
  meth_meth_ast_visitMember_40_1_41_837->type = alloc_MethodType(1, argcv_meth_ast_visitMember_40_1_41_837);
  meth_meth_ast_visitMember_40_1_41_837->definitionModule = modulename;
  meth_meth_ast_visitMember_40_1_41_837->definitionLine = 2902;
// method "visitGeneric(_)"
  struct UserObject *uo839 = (struct UserObject*)obj717;
  uo839->data[46] = emptyclosure;
  Method *meth_meth_ast_visitGeneric_40_1_41_839 = addmethod2pos(obj717, "visitGeneric(1)", &meth_ast_visitGeneric_40_1_41_839, 46);
  int argcv_meth_ast_visitGeneric_40_1_41_839[] = {1};
  meth_meth_ast_visitGeneric_40_1_41_839->type = alloc_MethodType(1, argcv_meth_ast_visitGeneric_40_1_41_839);
  meth_meth_ast_visitGeneric_40_1_41_839->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40_1_41_839->definitionLine = 2903;
// method "visitIdentifier(_)"
  struct UserObject *uo841 = (struct UserObject*)obj717;
  uo841->data[47] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier_40_1_41_841 = addmethod2pos(obj717, "visitIdentifier(1)", &meth_ast_visitIdentifier_40_1_41_841, 47);
  int argcv_meth_ast_visitIdentifier_40_1_41_841[] = {1};
  meth_meth_ast_visitIdentifier_40_1_41_841->type = alloc_MethodType(1, argcv_meth_ast_visitIdentifier_40_1_41_841);
  meth_meth_ast_visitIdentifier_40_1_41_841->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40_1_41_841->definitionLine = 2904;
// method "visitString(_)"
  struct UserObject *uo843 = (struct UserObject*)obj717;
  uo843->data[48] = emptyclosure;
  Method *meth_meth_ast_visitString_40_1_41_843 = addmethod2pos(obj717, "visitString(1)", &meth_ast_visitString_40_1_41_843, 48);
  int argcv_meth_ast_visitString_40_1_41_843[] = {1};
  meth_meth_ast_visitString_40_1_41_843->type = alloc_MethodType(1, argcv_meth_ast_visitString_40_1_41_843);
  meth_meth_ast_visitString_40_1_41_843->definitionModule = modulename;
  meth_meth_ast_visitString_40_1_41_843->definitionLine = 2905;
// method "visitNum(_)"
  struct UserObject *uo845 = (struct UserObject*)obj717;
  uo845->data[49] = emptyclosure;
  Method *meth_meth_ast_visitNum_40_1_41_845 = addmethod2pos(obj717, "visitNum(1)", &meth_ast_visitNum_40_1_41_845, 49);
  int argcv_meth_ast_visitNum_40_1_41_845[] = {1};
  meth_meth_ast_visitNum_40_1_41_845->type = alloc_MethodType(1, argcv_meth_ast_visitNum_40_1_41_845);
  meth_meth_ast_visitNum_40_1_41_845->definitionModule = modulename;
  meth_meth_ast_visitNum_40_1_41_845->definitionLine = 2906;
// method "visitOp(_)"
  struct UserObject *uo847 = (struct UserObject*)obj717;
  uo847->data[50] = emptyclosure;
  Method *meth_meth_ast_visitOp_40_1_41_847 = addmethod2pos(obj717, "visitOp(1)", &meth_ast_visitOp_40_1_41_847, 50);
  int argcv_meth_ast_visitOp_40_1_41_847[] = {1};
  meth_meth_ast_visitOp_40_1_41_847->type = alloc_MethodType(1, argcv_meth_ast_visitOp_40_1_41_847);
  meth_meth_ast_visitOp_40_1_41_847->definitionModule = modulename;
  meth_meth_ast_visitOp_40_1_41_847->definitionLine = 2907;
// method "visitBind(_)"
  struct UserObject *uo849 = (struct UserObject*)obj717;
  uo849->data[51] = emptyclosure;
  Method *meth_meth_ast_visitBind_40_1_41_849 = addmethod2pos(obj717, "visitBind(1)", &meth_ast_visitBind_40_1_41_849, 51);
  int argcv_meth_ast_visitBind_40_1_41_849[] = {1};
  meth_meth_ast_visitBind_40_1_41_849->type = alloc_MethodType(1, argcv_meth_ast_visitBind_40_1_41_849);
  meth_meth_ast_visitBind_40_1_41_849->definitionModule = modulename;
  meth_meth_ast_visitBind_40_1_41_849->definitionLine = 2908;
// method "visitDefDec(_)"
  struct UserObject *uo851 = (struct UserObject*)obj717;
  uo851->data[52] = emptyclosure;
  Method *meth_meth_ast_visitDefDec_40_1_41_851 = addmethod2pos(obj717, "visitDefDec(1)", &meth_ast_visitDefDec_40_1_41_851, 52);
  int argcv_meth_ast_visitDefDec_40_1_41_851[] = {1};
  meth_meth_ast_visitDefDec_40_1_41_851->type = alloc_MethodType(1, argcv_meth_ast_visitDefDec_40_1_41_851);
  meth_meth_ast_visitDefDec_40_1_41_851->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40_1_41_851->definitionLine = 2909;
// method "visitVarDec(_)"
  struct UserObject *uo853 = (struct UserObject*)obj717;
  uo853->data[53] = emptyclosure;
  Method *meth_meth_ast_visitVarDec_40_1_41_853 = addmethod2pos(obj717, "visitVarDec(1)", &meth_ast_visitVarDec_40_1_41_853, 53);
  int argcv_meth_ast_visitVarDec_40_1_41_853[] = {1};
  meth_meth_ast_visitVarDec_40_1_41_853->type = alloc_MethodType(1, argcv_meth_ast_visitVarDec_40_1_41_853);
  meth_meth_ast_visitVarDec_40_1_41_853->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40_1_41_853->definitionLine = 2910;
// method "visitImport(_)"
  struct UserObject *uo855 = (struct UserObject*)obj717;
  uo855->data[54] = emptyclosure;
  Method *meth_meth_ast_visitImport_40_1_41_855 = addmethod2pos(obj717, "visitImport(1)", &meth_ast_visitImport_40_1_41_855, 54);
  int argcv_meth_ast_visitImport_40_1_41_855[] = {1};
  meth_meth_ast_visitImport_40_1_41_855->type = alloc_MethodType(1, argcv_meth_ast_visitImport_40_1_41_855);
  meth_meth_ast_visitImport_40_1_41_855->definitionModule = modulename;
  meth_meth_ast_visitImport_40_1_41_855->definitionLine = 2911;
// method "visitReturn(_)"
  struct UserObject *uo857 = (struct UserObject*)obj717;
  uo857->data[55] = emptyclosure;
  Method *meth_meth_ast_visitReturn_40_1_41_857 = addmethod2pos(obj717, "visitReturn(1)", &meth_ast_visitReturn_40_1_41_857, 55);
  int argcv_meth_ast_visitReturn_40_1_41_857[] = {1};
  meth_meth_ast_visitReturn_40_1_41_857->type = alloc_MethodType(1, argcv_meth_ast_visitReturn_40_1_41_857);
  meth_meth_ast_visitReturn_40_1_41_857->definitionModule = modulename;
  meth_meth_ast_visitReturn_40_1_41_857->definitionLine = 2912;
// method "visitInherits(_)"
  struct UserObject *uo859 = (struct UserObject*)obj717;
  uo859->data[56] = emptyclosure;
  Method *meth_meth_ast_visitInherits_40_1_41_859 = addmethod2pos(obj717, "visitInherits(1)", &meth_ast_visitInherits_40_1_41_859, 56);
  int argcv_meth_ast_visitInherits_40_1_41_859[] = {1};
  meth_meth_ast_visitInherits_40_1_41_859->type = alloc_MethodType(1, argcv_meth_ast_visitInherits_40_1_41_859);
  meth_meth_ast_visitInherits_40_1_41_859->definitionModule = modulename;
  meth_meth_ast_visitInherits_40_1_41_859->definitionLine = 2913;
// method "visitDialect(_)"
  struct UserObject *uo861 = (struct UserObject*)obj717;
  uo861->data[57] = emptyclosure;
  Method *meth_meth_ast_visitDialect_40_1_41_861 = addmethod2pos(obj717, "visitDialect(1)", &meth_ast_visitDialect_40_1_41_861, 57);
  int argcv_meth_ast_visitDialect_40_1_41_861[] = {1};
  meth_meth_ast_visitDialect_40_1_41_861->type = alloc_MethodType(1, argcv_meth_ast_visitDialect_40_1_41_861);
  meth_meth_ast_visitDialect_40_1_41_861->definitionModule = modulename;
  meth_meth_ast_visitDialect_40_1_41_861->definitionLine = 2914;
// method "visitBlank(_)"
  struct UserObject *uo863 = (struct UserObject*)obj717;
  uo863->data[58] = emptyclosure;
  Method *meth_meth_ast_visitBlank_40_1_41_863 = addmethod2pos(obj717, "visitBlank(1)", &meth_ast_visitBlank_40_1_41_863, 58);
  int argcv_meth_ast_visitBlank_40_1_41_863[] = {1};
  meth_meth_ast_visitBlank_40_1_41_863->type = alloc_MethodType(1, argcv_meth_ast_visitBlank_40_1_41_863);
  meth_meth_ast_visitBlank_40_1_41_863->definitionModule = modulename;
  meth_meth_ast_visitBlank_40_1_41_863->definitionLine = 2915;
// method "visitComment(_)"
  struct UserObject *uo865 = (struct UserObject*)obj717;
  uo865->data[59] = emptyclosure;
  Method *meth_meth_ast_visitComment_40_1_41_865 = addmethod2pos(obj717, "visitComment(1)", &meth_ast_visitComment_40_1_41_865, 59);
  int argcv_meth_ast_visitComment_40_1_41_865[] = {1};
  meth_meth_ast_visitComment_40_1_41_865->type = alloc_MethodType(1, argcv_meth_ast_visitComment_40_1_41_865);
  meth_meth_ast_visitComment_40_1_41_865->definitionModule = modulename;
  meth_meth_ast_visitComment_40_1_41_865->definitionLine = 2916;
// method "visitImplicit(_)"
  struct UserObject *uo867 = (struct UserObject*)obj717;
  uo867->data[60] = emptyclosure;
  Method *meth_meth_ast_visitImplicit_40_1_41_867 = addmethod2pos(obj717, "visitImplicit(1)", &meth_ast_visitImplicit_40_1_41_867, 60);
  int argcv_meth_ast_visitImplicit_40_1_41_867[] = {1};
  meth_meth_ast_visitImplicit_40_1_41_867->type = alloc_MethodType(1, argcv_meth_ast_visitImplicit_40_1_41_867);
  meth_meth_ast_visitImplicit_40_1_41_867->definitionModule = modulename;
  meth_meth_ast_visitImplicit_40_1_41_867->definitionLine = 2917;
// method "asString"
  struct UserObject *uo869 = (struct UserObject*)obj717;
  uo869->data[61] = emptyclosure;
  Method *meth_meth_ast_asString869 = addmethod2pos(obj717, "asString", &meth_ast_asString869, 61);
  int argcv_meth_ast_asString869[] = {0};
  meth_meth_ast_asString869->type = alloc_MethodType(1, argcv_meth_ast_asString869);
  meth_meth_ast_asString869->definitionModule = modulename;
  meth_meth_ast_asString869->definitionLine = 2919;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  objclass717 = obj717->class;
  objclass717->definitionModule = modulename;
  objclass717->definitionLine = 2856;
  (*(struct UserObject *)self).data[0] = lowerouter717;
  self = oldself717;
  selfslot = oldselfslot717;
  stackframe = oldstackframe717;
  gc_frame_end(frame);
  return obj717;
}
Object meth_ast_baseVisitor716_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "baseVisitor$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject717 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj717 = alloc_userobj2(61,62, objclass717);
  gc_frame_newslot(obj717);
if (objclass717 == NULL) {
  glfree(obj717->class->name);
  obj717->class->name = "baseVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj717, self, 0);
  addmethodreal(obj717,"outer", &reader_ast_outer_718);
  Object oldself717 = self;
  struct StackFrameObject *oldstackframe717 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe717);
  gc_frame_newslot((Object)stackframe);
  self = obj717;
  Object *oldselfslot717 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter717 = (*(struct UserObject *)self).data[0], lowerouter717 = thisouter717;
  if (inheritingObject717) {
    struct UserObject *inho717 = (struct UserObject *)inheritingObject717;
    while (inho717->super != GraceDefaultObject) inho717 = (struct UserObject *)inho717->super;
    inho717->super = obj717;
    self = inheritingObject717;
    *selfslot = self;
    lowerouter717 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter717;
  }
// method "visitIf(_)up(_)"
  struct UserObject *uo719 = (struct UserObject*)obj717;
  uo719->data[1] = emptyclosure;
  Method *meth_meth_ast_visitIf_40_1_41_up_40_1_41_719 = addmethod2pos(obj717, "visitIf(1)up(1)", &meth_ast_visitIf_40_1_41_up_40_1_41_719, 1);
  int argcv_meth_ast_visitIf_40_1_41_up_40_1_41_719[] = {1, 1};
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_719->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40_1_41_up_40_1_41_719);
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_719->definitionModule = modulename;
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_719->definitionLine = 2857;
// method "visitBlock(_)up(_)"
  struct UserObject *uo722 = (struct UserObject*)obj717;
  uo722->data[2] = emptyclosure;
  Method *meth_meth_ast_visitBlock_40_1_41_up_40_1_41_722 = addmethod2pos(obj717, "visitBlock(1)up(1)", &meth_ast_visitBlock_40_1_41_up_40_1_41_722, 2);
  int argcv_meth_ast_visitBlock_40_1_41_up_40_1_41_722[] = {1, 1};
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_722->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40_1_41_up_40_1_41_722);
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_722->definitionModule = modulename;
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_722->definitionLine = 2858;
// method "visitMatchCase(_)up(_)"
  struct UserObject *uo725 = (struct UserObject*)obj717;
  uo725->data[3] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_725 = addmethod2pos(obj717, "visitMatchCase(1)up(1)", &meth_ast_visitMatchCase_40_1_41_up_40_1_41_725, 3);
  int argcv_meth_ast_visitMatchCase_40_1_41_up_40_1_41_725[] = {1, 1};
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_725->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40_1_41_up_40_1_41_725);
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_725->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_725->definitionLine = 2859;
// method "visitTryCatch(_)up(_)"
  struct UserObject *uo728 = (struct UserObject*)obj717;
  uo728->data[4] = emptyclosure;
  Method *meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_728 = addmethod2pos(obj717, "visitTryCatch(1)up(1)", &meth_ast_visitTryCatch_40_1_41_up_40_1_41_728, 4);
  int argcv_meth_ast_visitTryCatch_40_1_41_up_40_1_41_728[] = {1, 1};
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_728->type = alloc_MethodType(2, argcv_meth_ast_visitTryCatch_40_1_41_up_40_1_41_728);
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_728->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_728->definitionLine = 2860;
// method "visitMethodType(_)up(_)"
  struct UserObject *uo731 = (struct UserObject*)obj717;
  uo731->data[5] = emptyclosure;
  Method *meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_731 = addmethod2pos(obj717, "visitMethodType(1)up(1)", &meth_ast_visitMethodType_40_1_41_up_40_1_41_731, 5);
  int argcv_meth_ast_visitMethodType_40_1_41_up_40_1_41_731[] = {1, 1};
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_731->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40_1_41_up_40_1_41_731);
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_731->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_731->definitionLine = 2861;
// method "visitSignaturePart(_)up(_)"
  struct UserObject *uo734 = (struct UserObject*)obj717;
  uo734->data[6] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_734 = addmethod2pos(obj717, "visitSignaturePart(1)up(1)", &meth_ast_visitSignaturePart_40_1_41_up_40_1_41_734, 6);
  int argcv_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_734[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_734->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_734);
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_734->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_734->definitionLine = 2862;
// method "visitTypeDec(_)up(_)"
  struct UserObject *uo737 = (struct UserObject*)obj717;
  uo737->data[7] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_737 = addmethod2pos(obj717, "visitTypeDec(1)up(1)", &meth_ast_visitTypeDec_40_1_41_up_40_1_41_737, 7);
  int argcv_meth_ast_visitTypeDec_40_1_41_up_40_1_41_737[] = {1, 1};
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_737->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40_1_41_up_40_1_41_737);
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_737->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_737->definitionLine = 2863;
// method "visitTypeLiteral(_)up(_)"
  struct UserObject *uo740 = (struct UserObject*)obj717;
  uo740->data[8] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_740 = addmethod2pos(obj717, "visitTypeLiteral(1)up(1)", &meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_740, 8);
  int argcv_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_740[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_740->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_740);
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_740->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_740->definitionLine = 2864;
// method "visitTypeParameters(_)up(_)"
  struct UserObject *uo743 = (struct UserObject*)obj717;
  uo743->data[9] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_743 = addmethod2pos(obj717, "visitTypeParameters(1)up(1)", &meth_ast_visitTypeParameters_40_1_41_up_40_1_41_743, 9);
  int argcv_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_743[] = {1, 1};
  meth_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_743->type = alloc_MethodType(2, argcv_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_743);
  meth_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_743->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters_40_1_41_up_40_1_41_743->definitionLine = 2865;
// method "visitMethod(_)up(_)"
  struct UserObject *uo746 = (struct UserObject*)obj717;
  uo746->data[10] = emptyclosure;
  Method *meth_meth_ast_visitMethod_40_1_41_up_40_1_41_746 = addmethod2pos(obj717, "visitMethod(1)up(1)", &meth_ast_visitMethod_40_1_41_up_40_1_41_746, 10);
  int argcv_meth_ast_visitMethod_40_1_41_up_40_1_41_746[] = {1, 1};
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_746->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40_1_41_up_40_1_41_746);
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_746->definitionModule = modulename;
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_746->definitionLine = 2866;
// method "visitCall(_)up(_)"
  struct UserObject *uo749 = (struct UserObject*)obj717;
  uo749->data[11] = emptyclosure;
  Method *meth_meth_ast_visitCall_40_1_41_up_40_1_41_749 = addmethod2pos(obj717, "visitCall(1)up(1)", &meth_ast_visitCall_40_1_41_up_40_1_41_749, 11);
  int argcv_meth_ast_visitCall_40_1_41_up_40_1_41_749[] = {1, 1};
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_749->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40_1_41_up_40_1_41_749);
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_749->definitionModule = modulename;
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_749->definitionLine = 2867;
// method "visitObject(_)up(_)"
  struct UserObject *uo752 = (struct UserObject*)obj717;
  uo752->data[12] = emptyclosure;
  Method *meth_meth_ast_visitObject_40_1_41_up_40_1_41_752 = addmethod2pos(obj717, "visitObject(1)up(1)", &meth_ast_visitObject_40_1_41_up_40_1_41_752, 12);
  int argcv_meth_ast_visitObject_40_1_41_up_40_1_41_752[] = {1, 1};
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_752->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40_1_41_up_40_1_41_752);
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_752->definitionModule = modulename;
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_752->definitionLine = 2868;
// method "visitModule(_)up(_)"
  struct UserObject *uo755 = (struct UserObject*)obj717;
  uo755->data[13] = emptyclosure;
  Method *meth_meth_ast_visitModule_40_1_41_up_40_1_41_755 = addmethod2pos(obj717, "visitModule(1)up(1)", &meth_ast_visitModule_40_1_41_up_40_1_41_755, 13);
  int argcv_meth_ast_visitModule_40_1_41_up_40_1_41_755[] = {1, 1};
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_755->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40_1_41_up_40_1_41_755);
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_755->definitionModule = modulename;
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_755->definitionLine = 2869;
// method "visitArray(_)up(_)"
  struct UserObject *uo758 = (struct UserObject*)obj717;
  uo758->data[14] = emptyclosure;
  Method *meth_meth_ast_visitArray_40_1_41_up_40_1_41_758 = addmethod2pos(obj717, "visitArray(1)up(1)", &meth_ast_visitArray_40_1_41_up_40_1_41_758, 14);
  int argcv_meth_ast_visitArray_40_1_41_up_40_1_41_758[] = {1, 1};
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_758->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40_1_41_up_40_1_41_758);
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_758->definitionModule = modulename;
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_758->definitionLine = 2870;
// method "visitMember(_)up(_)"
  struct UserObject *uo761 = (struct UserObject*)obj717;
  uo761->data[15] = emptyclosure;
  Method *meth_meth_ast_visitMember_40_1_41_up_40_1_41_761 = addmethod2pos(obj717, "visitMember(1)up(1)", &meth_ast_visitMember_40_1_41_up_40_1_41_761, 15);
  int argcv_meth_ast_visitMember_40_1_41_up_40_1_41_761[] = {1, 1};
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_761->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40_1_41_up_40_1_41_761);
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_761->definitionModule = modulename;
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_761->definitionLine = 2871;
// method "visitGeneric(_)up(_)"
  struct UserObject *uo764 = (struct UserObject*)obj717;
  uo764->data[16] = emptyclosure;
  Method *meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_764 = addmethod2pos(obj717, "visitGeneric(1)up(1)", &meth_ast_visitGeneric_40_1_41_up_40_1_41_764, 16);
  int argcv_meth_ast_visitGeneric_40_1_41_up_40_1_41_764[] = {1, 1};
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_764->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40_1_41_up_40_1_41_764);
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_764->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_764->definitionLine = 2872;
// method "visitIdentifier(_)up(_)"
  struct UserObject *uo767 = (struct UserObject*)obj717;
  uo767->data[17] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_767 = addmethod2pos(obj717, "visitIdentifier(1)up(1)", &meth_ast_visitIdentifier_40_1_41_up_40_1_41_767, 17);
  int argcv_meth_ast_visitIdentifier_40_1_41_up_40_1_41_767[] = {1, 1};
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_767->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40_1_41_up_40_1_41_767);
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_767->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_767->definitionLine = 2873;
// method "visitString(_)up(_)"
  struct UserObject *uo770 = (struct UserObject*)obj717;
  uo770->data[18] = emptyclosure;
  Method *meth_meth_ast_visitString_40_1_41_up_40_1_41_770 = addmethod2pos(obj717, "visitString(1)up(1)", &meth_ast_visitString_40_1_41_up_40_1_41_770, 18);
  int argcv_meth_ast_visitString_40_1_41_up_40_1_41_770[] = {1, 1};
  meth_meth_ast_visitString_40_1_41_up_40_1_41_770->type = alloc_MethodType(2, argcv_meth_ast_visitString_40_1_41_up_40_1_41_770);
  meth_meth_ast_visitString_40_1_41_up_40_1_41_770->definitionModule = modulename;
  meth_meth_ast_visitString_40_1_41_up_40_1_41_770->definitionLine = 2874;
// method "visitNum(_)up(_)"
  struct UserObject *uo773 = (struct UserObject*)obj717;
  uo773->data[19] = emptyclosure;
  Method *meth_meth_ast_visitNum_40_1_41_up_40_1_41_773 = addmethod2pos(obj717, "visitNum(1)up(1)", &meth_ast_visitNum_40_1_41_up_40_1_41_773, 19);
  int argcv_meth_ast_visitNum_40_1_41_up_40_1_41_773[] = {1, 1};
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_773->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40_1_41_up_40_1_41_773);
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_773->definitionModule = modulename;
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_773->definitionLine = 2875;
// method "visitOp(_)up(_)"
  struct UserObject *uo776 = (struct UserObject*)obj717;
  uo776->data[20] = emptyclosure;
  Method *meth_meth_ast_visitOp_40_1_41_up_40_1_41_776 = addmethod2pos(obj717, "visitOp(1)up(1)", &meth_ast_visitOp_40_1_41_up_40_1_41_776, 20);
  int argcv_meth_ast_visitOp_40_1_41_up_40_1_41_776[] = {1, 1};
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_776->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40_1_41_up_40_1_41_776);
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_776->definitionModule = modulename;
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_776->definitionLine = 2876;
// method "visitBind(_)up(_)"
  struct UserObject *uo779 = (struct UserObject*)obj717;
  uo779->data[21] = emptyclosure;
  Method *meth_meth_ast_visitBind_40_1_41_up_40_1_41_779 = addmethod2pos(obj717, "visitBind(1)up(1)", &meth_ast_visitBind_40_1_41_up_40_1_41_779, 21);
  int argcv_meth_ast_visitBind_40_1_41_up_40_1_41_779[] = {1, 1};
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_779->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40_1_41_up_40_1_41_779);
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_779->definitionModule = modulename;
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_779->definitionLine = 2877;
// method "visitDefDec(_)up(_)"
  struct UserObject *uo782 = (struct UserObject*)obj717;
  uo782->data[22] = emptyclosure;
  Method *meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_782 = addmethod2pos(obj717, "visitDefDec(1)up(1)", &meth_ast_visitDefDec_40_1_41_up_40_1_41_782, 22);
  int argcv_meth_ast_visitDefDec_40_1_41_up_40_1_41_782[] = {1, 1};
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_782->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40_1_41_up_40_1_41_782);
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_782->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_782->definitionLine = 2878;
// method "visitVarDec(_)up(_)"
  struct UserObject *uo785 = (struct UserObject*)obj717;
  uo785->data[23] = emptyclosure;
  Method *meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_785 = addmethod2pos(obj717, "visitVarDec(1)up(1)", &meth_ast_visitVarDec_40_1_41_up_40_1_41_785, 23);
  int argcv_meth_ast_visitVarDec_40_1_41_up_40_1_41_785[] = {1, 1};
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_785->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40_1_41_up_40_1_41_785);
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_785->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_785->definitionLine = 2879;
// method "visitImport(_)up(_)"
  struct UserObject *uo788 = (struct UserObject*)obj717;
  uo788->data[24] = emptyclosure;
  Method *meth_meth_ast_visitImport_40_1_41_up_40_1_41_788 = addmethod2pos(obj717, "visitImport(1)up(1)", &meth_ast_visitImport_40_1_41_up_40_1_41_788, 24);
  int argcv_meth_ast_visitImport_40_1_41_up_40_1_41_788[] = {1, 1};
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_788->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40_1_41_up_40_1_41_788);
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_788->definitionModule = modulename;
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_788->definitionLine = 2880;
// method "visitReturn(_)up(_)"
  struct UserObject *uo791 = (struct UserObject*)obj717;
  uo791->data[25] = emptyclosure;
  Method *meth_meth_ast_visitReturn_40_1_41_up_40_1_41_791 = addmethod2pos(obj717, "visitReturn(1)up(1)", &meth_ast_visitReturn_40_1_41_up_40_1_41_791, 25);
  int argcv_meth_ast_visitReturn_40_1_41_up_40_1_41_791[] = {1, 1};
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_791->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40_1_41_up_40_1_41_791);
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_791->definitionModule = modulename;
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_791->definitionLine = 2881;
// method "visitInherits(_)up(_)"
  struct UserObject *uo794 = (struct UserObject*)obj717;
  uo794->data[26] = emptyclosure;
  Method *meth_meth_ast_visitInherits_40_1_41_up_40_1_41_794 = addmethod2pos(obj717, "visitInherits(1)up(1)", &meth_ast_visitInherits_40_1_41_up_40_1_41_794, 26);
  int argcv_meth_ast_visitInherits_40_1_41_up_40_1_41_794[] = {1, 1};
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_794->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40_1_41_up_40_1_41_794);
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_794->definitionModule = modulename;
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_794->definitionLine = 2882;
// method "visitDialect(_)up(_)"
  struct UserObject *uo797 = (struct UserObject*)obj717;
  uo797->data[27] = emptyclosure;
  Method *meth_meth_ast_visitDialect_40_1_41_up_40_1_41_797 = addmethod2pos(obj717, "visitDialect(1)up(1)", &meth_ast_visitDialect_40_1_41_up_40_1_41_797, 27);
  int argcv_meth_ast_visitDialect_40_1_41_up_40_1_41_797[] = {1, 1};
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_797->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40_1_41_up_40_1_41_797);
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_797->definitionModule = modulename;
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_797->definitionLine = 2883;
// method "visitBlank(_)up(_)"
  struct UserObject *uo800 = (struct UserObject*)obj717;
  uo800->data[28] = emptyclosure;
  Method *meth_meth_ast_visitBlank_40_1_41_up_40_1_41_800 = addmethod2pos(obj717, "visitBlank(1)up(1)", &meth_ast_visitBlank_40_1_41_up_40_1_41_800, 28);
  int argcv_meth_ast_visitBlank_40_1_41_up_40_1_41_800[] = {1, 1};
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_800->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40_1_41_up_40_1_41_800);
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_800->definitionModule = modulename;
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_800->definitionLine = 2884;
// method "visitComment(_)up(_)"
  struct UserObject *uo803 = (struct UserObject*)obj717;
  uo803->data[29] = emptyclosure;
  Method *meth_meth_ast_visitComment_40_1_41_up_40_1_41_803 = addmethod2pos(obj717, "visitComment(1)up(1)", &meth_ast_visitComment_40_1_41_up_40_1_41_803, 29);
  int argcv_meth_ast_visitComment_40_1_41_up_40_1_41_803[] = {1, 1};
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_803->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40_1_41_up_40_1_41_803);
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_803->definitionModule = modulename;
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_803->definitionLine = 2885;
// method "visitImplicit(_)up(_)"
  struct UserObject *uo806 = (struct UserObject*)obj717;
  uo806->data[30] = emptyclosure;
  Method *meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_806 = addmethod2pos(obj717, "visitImplicit(1)up(1)", &meth_ast_visitImplicit_40_1_41_up_40_1_41_806, 30);
  int argcv_meth_ast_visitImplicit_40_1_41_up_40_1_41_806[] = {1, 1};
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_806->type = alloc_MethodType(2, argcv_meth_ast_visitImplicit_40_1_41_up_40_1_41_806);
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_806->definitionModule = modulename;
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_806->definitionLine = 2886;
// method "visitIf(_)"
  struct UserObject *uo809 = (struct UserObject*)obj717;
  uo809->data[31] = emptyclosure;
  Method *meth_meth_ast_visitIf_40_1_41_809 = addmethod2pos(obj717, "visitIf(1)", &meth_ast_visitIf_40_1_41_809, 31);
  int argcv_meth_ast_visitIf_40_1_41_809[] = {1};
  meth_meth_ast_visitIf_40_1_41_809->type = alloc_MethodType(1, argcv_meth_ast_visitIf_40_1_41_809);
  meth_meth_ast_visitIf_40_1_41_809->definitionModule = modulename;
  meth_meth_ast_visitIf_40_1_41_809->definitionLine = 2888;
// method "visitBlock(_)"
  struct UserObject *uo811 = (struct UserObject*)obj717;
  uo811->data[32] = emptyclosure;
  Method *meth_meth_ast_visitBlock_40_1_41_811 = addmethod2pos(obj717, "visitBlock(1)", &meth_ast_visitBlock_40_1_41_811, 32);
  int argcv_meth_ast_visitBlock_40_1_41_811[] = {1};
  meth_meth_ast_visitBlock_40_1_41_811->type = alloc_MethodType(1, argcv_meth_ast_visitBlock_40_1_41_811);
  meth_meth_ast_visitBlock_40_1_41_811->definitionModule = modulename;
  meth_meth_ast_visitBlock_40_1_41_811->definitionLine = 2889;
// method "visitMatchCase(_)"
  struct UserObject *uo813 = (struct UserObject*)obj717;
  uo813->data[33] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase_40_1_41_813 = addmethod2pos(obj717, "visitMatchCase(1)", &meth_ast_visitMatchCase_40_1_41_813, 33);
  int argcv_meth_ast_visitMatchCase_40_1_41_813[] = {1};
  meth_meth_ast_visitMatchCase_40_1_41_813->type = alloc_MethodType(1, argcv_meth_ast_visitMatchCase_40_1_41_813);
  meth_meth_ast_visitMatchCase_40_1_41_813->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40_1_41_813->definitionLine = 2890;
// method "visitTryCatch(_)"
  struct UserObject *uo815 = (struct UserObject*)obj717;
  uo815->data[34] = emptyclosure;
  Method *meth_meth_ast_visitTryCatch_40_1_41_815 = addmethod2pos(obj717, "visitTryCatch(1)", &meth_ast_visitTryCatch_40_1_41_815, 34);
  int argcv_meth_ast_visitTryCatch_40_1_41_815[] = {1};
  meth_meth_ast_visitTryCatch_40_1_41_815->type = alloc_MethodType(1, argcv_meth_ast_visitTryCatch_40_1_41_815);
  meth_meth_ast_visitTryCatch_40_1_41_815->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40_1_41_815->definitionLine = 2891;
// method "visitMethodType(_)"
  struct UserObject *uo817 = (struct UserObject*)obj717;
  uo817->data[35] = emptyclosure;
  Method *meth_meth_ast_visitMethodType_40_1_41_817 = addmethod2pos(obj717, "visitMethodType(1)", &meth_ast_visitMethodType_40_1_41_817, 35);
  int argcv_meth_ast_visitMethodType_40_1_41_817[] = {1};
  meth_meth_ast_visitMethodType_40_1_41_817->type = alloc_MethodType(1, argcv_meth_ast_visitMethodType_40_1_41_817);
  meth_meth_ast_visitMethodType_40_1_41_817->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40_1_41_817->definitionLine = 2892;
// method "visitSignaturePart(_)"
  struct UserObject *uo819 = (struct UserObject*)obj717;
  uo819->data[36] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart_40_1_41_819 = addmethod2pos(obj717, "visitSignaturePart(1)", &meth_ast_visitSignaturePart_40_1_41_819, 36);
  int argcv_meth_ast_visitSignaturePart_40_1_41_819[] = {1};
  meth_meth_ast_visitSignaturePart_40_1_41_819->type = alloc_MethodType(1, argcv_meth_ast_visitSignaturePart_40_1_41_819);
  meth_meth_ast_visitSignaturePart_40_1_41_819->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40_1_41_819->definitionLine = 2893;
// method "visitTypeDec(_)"
  struct UserObject *uo821 = (struct UserObject*)obj717;
  uo821->data[37] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec_40_1_41_821 = addmethod2pos(obj717, "visitTypeDec(1)", &meth_ast_visitTypeDec_40_1_41_821, 37);
  int argcv_meth_ast_visitTypeDec_40_1_41_821[] = {1};
  meth_meth_ast_visitTypeDec_40_1_41_821->type = alloc_MethodType(1, argcv_meth_ast_visitTypeDec_40_1_41_821);
  meth_meth_ast_visitTypeDec_40_1_41_821->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40_1_41_821->definitionLine = 2894;
// method "visitTypeLiteral(_)"
  struct UserObject *uo823 = (struct UserObject*)obj717;
  uo823->data[38] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral_40_1_41_823 = addmethod2pos(obj717, "visitTypeLiteral(1)", &meth_ast_visitTypeLiteral_40_1_41_823, 38);
  int argcv_meth_ast_visitTypeLiteral_40_1_41_823[] = {1};
  meth_meth_ast_visitTypeLiteral_40_1_41_823->type = alloc_MethodType(1, argcv_meth_ast_visitTypeLiteral_40_1_41_823);
  meth_meth_ast_visitTypeLiteral_40_1_41_823->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40_1_41_823->definitionLine = 2895;
// method "visitTypeParameters(_)"
  struct UserObject *uo825 = (struct UserObject*)obj717;
  uo825->data[39] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters_40_1_41_825 = addmethod2pos(obj717, "visitTypeParameters(1)", &meth_ast_visitTypeParameters_40_1_41_825, 39);
  int argcv_meth_ast_visitTypeParameters_40_1_41_825[] = {1};
  meth_meth_ast_visitTypeParameters_40_1_41_825->type = alloc_MethodType(1, argcv_meth_ast_visitTypeParameters_40_1_41_825);
  meth_meth_ast_visitTypeParameters_40_1_41_825->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters_40_1_41_825->definitionLine = 2896;
// method "visitMethod(_)"
  struct UserObject *uo827 = (struct UserObject*)obj717;
  uo827->data[40] = emptyclosure;
  Method *meth_meth_ast_visitMethod_40_1_41_827 = addmethod2pos(obj717, "visitMethod(1)", &meth_ast_visitMethod_40_1_41_827, 40);
  int argcv_meth_ast_visitMethod_40_1_41_827[] = {1};
  meth_meth_ast_visitMethod_40_1_41_827->type = alloc_MethodType(1, argcv_meth_ast_visitMethod_40_1_41_827);
  meth_meth_ast_visitMethod_40_1_41_827->definitionModule = modulename;
  meth_meth_ast_visitMethod_40_1_41_827->definitionLine = 2897;
// method "visitCall(_)"
  struct UserObject *uo829 = (struct UserObject*)obj717;
  uo829->data[41] = emptyclosure;
  Method *meth_meth_ast_visitCall_40_1_41_829 = addmethod2pos(obj717, "visitCall(1)", &meth_ast_visitCall_40_1_41_829, 41);
  int argcv_meth_ast_visitCall_40_1_41_829[] = {1};
  meth_meth_ast_visitCall_40_1_41_829->type = alloc_MethodType(1, argcv_meth_ast_visitCall_40_1_41_829);
  meth_meth_ast_visitCall_40_1_41_829->definitionModule = modulename;
  meth_meth_ast_visitCall_40_1_41_829->definitionLine = 2898;
// method "visitObject(_)"
  struct UserObject *uo831 = (struct UserObject*)obj717;
  uo831->data[42] = emptyclosure;
  Method *meth_meth_ast_visitObject_40_1_41_831 = addmethod2pos(obj717, "visitObject(1)", &meth_ast_visitObject_40_1_41_831, 42);
  int argcv_meth_ast_visitObject_40_1_41_831[] = {1};
  meth_meth_ast_visitObject_40_1_41_831->type = alloc_MethodType(1, argcv_meth_ast_visitObject_40_1_41_831);
  meth_meth_ast_visitObject_40_1_41_831->definitionModule = modulename;
  meth_meth_ast_visitObject_40_1_41_831->definitionLine = 2899;
// method "visitModule(_)"
  struct UserObject *uo833 = (struct UserObject*)obj717;
  uo833->data[43] = emptyclosure;
  Method *meth_meth_ast_visitModule_40_1_41_833 = addmethod2pos(obj717, "visitModule(1)", &meth_ast_visitModule_40_1_41_833, 43);
  int argcv_meth_ast_visitModule_40_1_41_833[] = {1};
  meth_meth_ast_visitModule_40_1_41_833->type = alloc_MethodType(1, argcv_meth_ast_visitModule_40_1_41_833);
  meth_meth_ast_visitModule_40_1_41_833->definitionModule = modulename;
  meth_meth_ast_visitModule_40_1_41_833->definitionLine = 2900;
// method "visitArray(_)"
  struct UserObject *uo835 = (struct UserObject*)obj717;
  uo835->data[44] = emptyclosure;
  Method *meth_meth_ast_visitArray_40_1_41_835 = addmethod2pos(obj717, "visitArray(1)", &meth_ast_visitArray_40_1_41_835, 44);
  int argcv_meth_ast_visitArray_40_1_41_835[] = {1};
  meth_meth_ast_visitArray_40_1_41_835->type = alloc_MethodType(1, argcv_meth_ast_visitArray_40_1_41_835);
  meth_meth_ast_visitArray_40_1_41_835->definitionModule = modulename;
  meth_meth_ast_visitArray_40_1_41_835->definitionLine = 2901;
// method "visitMember(_)"
  struct UserObject *uo837 = (struct UserObject*)obj717;
  uo837->data[45] = emptyclosure;
  Method *meth_meth_ast_visitMember_40_1_41_837 = addmethod2pos(obj717, "visitMember(1)", &meth_ast_visitMember_40_1_41_837, 45);
  int argcv_meth_ast_visitMember_40_1_41_837[] = {1};
  meth_meth_ast_visitMember_40_1_41_837->type = alloc_MethodType(1, argcv_meth_ast_visitMember_40_1_41_837);
  meth_meth_ast_visitMember_40_1_41_837->definitionModule = modulename;
  meth_meth_ast_visitMember_40_1_41_837->definitionLine = 2902;
// method "visitGeneric(_)"
  struct UserObject *uo839 = (struct UserObject*)obj717;
  uo839->data[46] = emptyclosure;
  Method *meth_meth_ast_visitGeneric_40_1_41_839 = addmethod2pos(obj717, "visitGeneric(1)", &meth_ast_visitGeneric_40_1_41_839, 46);
  int argcv_meth_ast_visitGeneric_40_1_41_839[] = {1};
  meth_meth_ast_visitGeneric_40_1_41_839->type = alloc_MethodType(1, argcv_meth_ast_visitGeneric_40_1_41_839);
  meth_meth_ast_visitGeneric_40_1_41_839->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40_1_41_839->definitionLine = 2903;
// method "visitIdentifier(_)"
  struct UserObject *uo841 = (struct UserObject*)obj717;
  uo841->data[47] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier_40_1_41_841 = addmethod2pos(obj717, "visitIdentifier(1)", &meth_ast_visitIdentifier_40_1_41_841, 47);
  int argcv_meth_ast_visitIdentifier_40_1_41_841[] = {1};
  meth_meth_ast_visitIdentifier_40_1_41_841->type = alloc_MethodType(1, argcv_meth_ast_visitIdentifier_40_1_41_841);
  meth_meth_ast_visitIdentifier_40_1_41_841->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40_1_41_841->definitionLine = 2904;
// method "visitString(_)"
  struct UserObject *uo843 = (struct UserObject*)obj717;
  uo843->data[48] = emptyclosure;
  Method *meth_meth_ast_visitString_40_1_41_843 = addmethod2pos(obj717, "visitString(1)", &meth_ast_visitString_40_1_41_843, 48);
  int argcv_meth_ast_visitString_40_1_41_843[] = {1};
  meth_meth_ast_visitString_40_1_41_843->type = alloc_MethodType(1, argcv_meth_ast_visitString_40_1_41_843);
  meth_meth_ast_visitString_40_1_41_843->definitionModule = modulename;
  meth_meth_ast_visitString_40_1_41_843->definitionLine = 2905;
// method "visitNum(_)"
  struct UserObject *uo845 = (struct UserObject*)obj717;
  uo845->data[49] = emptyclosure;
  Method *meth_meth_ast_visitNum_40_1_41_845 = addmethod2pos(obj717, "visitNum(1)", &meth_ast_visitNum_40_1_41_845, 49);
  int argcv_meth_ast_visitNum_40_1_41_845[] = {1};
  meth_meth_ast_visitNum_40_1_41_845->type = alloc_MethodType(1, argcv_meth_ast_visitNum_40_1_41_845);
  meth_meth_ast_visitNum_40_1_41_845->definitionModule = modulename;
  meth_meth_ast_visitNum_40_1_41_845->definitionLine = 2906;
// method "visitOp(_)"
  struct UserObject *uo847 = (struct UserObject*)obj717;
  uo847->data[50] = emptyclosure;
  Method *meth_meth_ast_visitOp_40_1_41_847 = addmethod2pos(obj717, "visitOp(1)", &meth_ast_visitOp_40_1_41_847, 50);
  int argcv_meth_ast_visitOp_40_1_41_847[] = {1};
  meth_meth_ast_visitOp_40_1_41_847->type = alloc_MethodType(1, argcv_meth_ast_visitOp_40_1_41_847);
  meth_meth_ast_visitOp_40_1_41_847->definitionModule = modulename;
  meth_meth_ast_visitOp_40_1_41_847->definitionLine = 2907;
// method "visitBind(_)"
  struct UserObject *uo849 = (struct UserObject*)obj717;
  uo849->data[51] = emptyclosure;
  Method *meth_meth_ast_visitBind_40_1_41_849 = addmethod2pos(obj717, "visitBind(1)", &meth_ast_visitBind_40_1_41_849, 51);
  int argcv_meth_ast_visitBind_40_1_41_849[] = {1};
  meth_meth_ast_visitBind_40_1_41_849->type = alloc_MethodType(1, argcv_meth_ast_visitBind_40_1_41_849);
  meth_meth_ast_visitBind_40_1_41_849->definitionModule = modulename;
  meth_meth_ast_visitBind_40_1_41_849->definitionLine = 2908;
// method "visitDefDec(_)"
  struct UserObject *uo851 = (struct UserObject*)obj717;
  uo851->data[52] = emptyclosure;
  Method *meth_meth_ast_visitDefDec_40_1_41_851 = addmethod2pos(obj717, "visitDefDec(1)", &meth_ast_visitDefDec_40_1_41_851, 52);
  int argcv_meth_ast_visitDefDec_40_1_41_851[] = {1};
  meth_meth_ast_visitDefDec_40_1_41_851->type = alloc_MethodType(1, argcv_meth_ast_visitDefDec_40_1_41_851);
  meth_meth_ast_visitDefDec_40_1_41_851->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40_1_41_851->definitionLine = 2909;
// method "visitVarDec(_)"
  struct UserObject *uo853 = (struct UserObject*)obj717;
  uo853->data[53] = emptyclosure;
  Method *meth_meth_ast_visitVarDec_40_1_41_853 = addmethod2pos(obj717, "visitVarDec(1)", &meth_ast_visitVarDec_40_1_41_853, 53);
  int argcv_meth_ast_visitVarDec_40_1_41_853[] = {1};
  meth_meth_ast_visitVarDec_40_1_41_853->type = alloc_MethodType(1, argcv_meth_ast_visitVarDec_40_1_41_853);
  meth_meth_ast_visitVarDec_40_1_41_853->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40_1_41_853->definitionLine = 2910;
// method "visitImport(_)"
  struct UserObject *uo855 = (struct UserObject*)obj717;
  uo855->data[54] = emptyclosure;
  Method *meth_meth_ast_visitImport_40_1_41_855 = addmethod2pos(obj717, "visitImport(1)", &meth_ast_visitImport_40_1_41_855, 54);
  int argcv_meth_ast_visitImport_40_1_41_855[] = {1};
  meth_meth_ast_visitImport_40_1_41_855->type = alloc_MethodType(1, argcv_meth_ast_visitImport_40_1_41_855);
  meth_meth_ast_visitImport_40_1_41_855->definitionModule = modulename;
  meth_meth_ast_visitImport_40_1_41_855->definitionLine = 2911;
// method "visitReturn(_)"
  struct UserObject *uo857 = (struct UserObject*)obj717;
  uo857->data[55] = emptyclosure;
  Method *meth_meth_ast_visitReturn_40_1_41_857 = addmethod2pos(obj717, "visitReturn(1)", &meth_ast_visitReturn_40_1_41_857, 55);
  int argcv_meth_ast_visitReturn_40_1_41_857[] = {1};
  meth_meth_ast_visitReturn_40_1_41_857->type = alloc_MethodType(1, argcv_meth_ast_visitReturn_40_1_41_857);
  meth_meth_ast_visitReturn_40_1_41_857->definitionModule = modulename;
  meth_meth_ast_visitReturn_40_1_41_857->definitionLine = 2912;
// method "visitInherits(_)"
  struct UserObject *uo859 = (struct UserObject*)obj717;
  uo859->data[56] = emptyclosure;
  Method *meth_meth_ast_visitInherits_40_1_41_859 = addmethod2pos(obj717, "visitInherits(1)", &meth_ast_visitInherits_40_1_41_859, 56);
  int argcv_meth_ast_visitInherits_40_1_41_859[] = {1};
  meth_meth_ast_visitInherits_40_1_41_859->type = alloc_MethodType(1, argcv_meth_ast_visitInherits_40_1_41_859);
  meth_meth_ast_visitInherits_40_1_41_859->definitionModule = modulename;
  meth_meth_ast_visitInherits_40_1_41_859->definitionLine = 2913;
// method "visitDialect(_)"
  struct UserObject *uo861 = (struct UserObject*)obj717;
  uo861->data[57] = emptyclosure;
  Method *meth_meth_ast_visitDialect_40_1_41_861 = addmethod2pos(obj717, "visitDialect(1)", &meth_ast_visitDialect_40_1_41_861, 57);
  int argcv_meth_ast_visitDialect_40_1_41_861[] = {1};
  meth_meth_ast_visitDialect_40_1_41_861->type = alloc_MethodType(1, argcv_meth_ast_visitDialect_40_1_41_861);
  meth_meth_ast_visitDialect_40_1_41_861->definitionModule = modulename;
  meth_meth_ast_visitDialect_40_1_41_861->definitionLine = 2914;
// method "visitBlank(_)"
  struct UserObject *uo863 = (struct UserObject*)obj717;
  uo863->data[58] = emptyclosure;
  Method *meth_meth_ast_visitBlank_40_1_41_863 = addmethod2pos(obj717, "visitBlank(1)", &meth_ast_visitBlank_40_1_41_863, 58);
  int argcv_meth_ast_visitBlank_40_1_41_863[] = {1};
  meth_meth_ast_visitBlank_40_1_41_863->type = alloc_MethodType(1, argcv_meth_ast_visitBlank_40_1_41_863);
  meth_meth_ast_visitBlank_40_1_41_863->definitionModule = modulename;
  meth_meth_ast_visitBlank_40_1_41_863->definitionLine = 2915;
// method "visitComment(_)"
  struct UserObject *uo865 = (struct UserObject*)obj717;
  uo865->data[59] = emptyclosure;
  Method *meth_meth_ast_visitComment_40_1_41_865 = addmethod2pos(obj717, "visitComment(1)", &meth_ast_visitComment_40_1_41_865, 59);
  int argcv_meth_ast_visitComment_40_1_41_865[] = {1};
  meth_meth_ast_visitComment_40_1_41_865->type = alloc_MethodType(1, argcv_meth_ast_visitComment_40_1_41_865);
  meth_meth_ast_visitComment_40_1_41_865->definitionModule = modulename;
  meth_meth_ast_visitComment_40_1_41_865->definitionLine = 2916;
// method "visitImplicit(_)"
  struct UserObject *uo867 = (struct UserObject*)obj717;
  uo867->data[60] = emptyclosure;
  Method *meth_meth_ast_visitImplicit_40_1_41_867 = addmethod2pos(obj717, "visitImplicit(1)", &meth_ast_visitImplicit_40_1_41_867, 60);
  int argcv_meth_ast_visitImplicit_40_1_41_867[] = {1};
  meth_meth_ast_visitImplicit_40_1_41_867->type = alloc_MethodType(1, argcv_meth_ast_visitImplicit_40_1_41_867);
  meth_meth_ast_visitImplicit_40_1_41_867->definitionModule = modulename;
  meth_meth_ast_visitImplicit_40_1_41_867->definitionLine = 2917;
// method "asString"
  struct UserObject *uo869 = (struct UserObject*)obj717;
  uo869->data[61] = emptyclosure;
  Method *meth_meth_ast_asString869 = addmethod2pos(obj717, "asString", &meth_ast_asString869, 61);
  int argcv_meth_ast_asString869[] = {0};
  meth_meth_ast_asString869->type = alloc_MethodType(1, argcv_meth_ast_asString869);
  meth_meth_ast_asString869->definitionModule = modulename;
  meth_meth_ast_asString869->definitionLine = 2919;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  sourceObject = obj717;
  objclass717 = obj717->class;
  objclass717->definitionModule = modulename;
  objclass717->definitionLine = 2856;
  (*(struct UserObject *)self).data[0] = lowerouter717;
  self = oldself717;
  selfslot = oldselfslot717;
  stackframe = oldstackframe717;
  gc_frame_end(frame);
  return obj717;
}
Object meth_ast_visitIf_40_1_41_up_40_1_41_875(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitIf(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIf(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitIf(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2929
  setline(2929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe876 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call877 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe876);
// compiled call node returning call877 (depth = 2)
  gc_frame_end(frame);
  return call877;
}
Object meth_ast_visitBlock_40_1_41_up_40_1_41_878(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitBlock(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBlock(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBlock(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2930
  setline(2930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe879 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call880 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe879);
// compiled call node returning call880 (depth = 2)
  gc_frame_end(frame);
  return call880;
}
Object meth_ast_visitMatchCase_40_1_41_up_40_1_41_881(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMatchCase(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMatchCase(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMatchCase(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2931
  setline(2931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe882 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call883 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe882);
// compiled call node returning call883 (depth = 2)
  gc_frame_end(frame);
  return call883;
}
Object meth_ast_visitTryCatch_40_1_41_up_40_1_41_884(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitTryCatch(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTryCatch(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTryCatch(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2932
  setline(2932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe885 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call886 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe885);
// compiled call node returning call886 (depth = 2)
  gc_frame_end(frame);
  return call886;
}
Object meth_ast_visitMethodType_40_1_41_up_40_1_41_887(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMethodType(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethodType(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMethodType(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2933
  setline(2933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe888 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call889 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe888);
// compiled call node returning call889 (depth = 2)
  gc_frame_end(frame);
  return call889;
}
Object meth_ast_visitSignaturePart_40_1_41_up_40_1_41_890(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitSignaturePart(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitSignaturePart(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitSignaturePart(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2934
  setline(2934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe891 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call892 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe891);
// compiled call node returning call892 (depth = 2)
  gc_frame_end(frame);
  return call892;
}
Object meth_ast_visitTypeDec_40_1_41_up_40_1_41_893(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitTypeDec(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeDec(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeDec(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2935
  setline(2935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe894 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call895 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe894);
// compiled call node returning call895 (depth = 2)
  gc_frame_end(frame);
  return call895;
}
Object meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_896(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitTypeLiteral(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeLiteral(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitTypeLiteral(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2936
  setline(2936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe897 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call898 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe897);
// compiled call node returning call898 (depth = 2)
  gc_frame_end(frame);
  return call898;
}
Object meth_ast_visitMethod_40_1_41_up_40_1_41_899(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMethod(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethod(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMethod(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2937
  setline(2937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe900 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call901 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe900);
// compiled call node returning call901 (depth = 2)
  gc_frame_end(frame);
  return call901;
}
Object meth_ast_visitCall_40_1_41_up_40_1_41_902(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitCall(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitCall(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitCall(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2938
  setline(2938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe903 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call904 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe903);
// compiled call node returning call904 (depth = 2)
  gc_frame_end(frame);
  return call904;
}
Object meth_ast_visitObject_40_1_41_up_40_1_41_905(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitObject(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitObject(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitObject(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2939
  setline(2939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe906 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call907 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe906);
// compiled call node returning call907 (depth = 2)
  gc_frame_end(frame);
  return call907;
}
Object meth_ast_visitModule_40_1_41_up_40_1_41_908(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitModule(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitModule(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitModule(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2940
  setline(2940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe909 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call910 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe909);
// compiled call node returning call910 (depth = 2)
  gc_frame_end(frame);
  return call910;
}
Object meth_ast_visitArray_40_1_41_up_40_1_41_911(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitArray(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitArray(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitArray(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2941
  setline(2941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe912 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call913 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe912);
// compiled call node returning call913 (depth = 2)
  gc_frame_end(frame);
  return call913;
}
Object meth_ast_visitMember_40_1_41_up_40_1_41_914(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMember(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMember(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitMember(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2942
  setline(2942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe915 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call916 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe915);
// compiled call node returning call916 (depth = 2)
  gc_frame_end(frame);
  return call916;
}
Object meth_ast_visitGeneric_40_1_41_up_40_1_41_917(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitGeneric(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitGeneric(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitGeneric(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2943
  setline(2943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe918 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call919 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe918);
// compiled call node returning call919 (depth = 2)
  gc_frame_end(frame);
  return call919;
}
Object meth_ast_visitIdentifier_40_1_41_up_40_1_41_920(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitIdentifier(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIdentifier(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitIdentifier(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2944
  setline(2944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe921 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call922 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe921);
// compiled call node returning call922 (depth = 2)
  gc_frame_end(frame);
  return call922;
}
Object meth_ast_visitString_40_1_41_up_40_1_41_923(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitString(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitString(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitString(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2945
  setline(2945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe924 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call925 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe924);
// compiled call node returning call925 (depth = 2)
  gc_frame_end(frame);
  return call925;
}
Object meth_ast_visitNum_40_1_41_up_40_1_41_926(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitNum(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitNum(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitNum(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2946
  setline(2946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe927 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call928 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe927);
// compiled call node returning call928 (depth = 2)
  gc_frame_end(frame);
  return call928;
}
Object meth_ast_visitOp_40_1_41_up_40_1_41_929(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitOp(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitOp(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitOp(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2947
  setline(2947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe930 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call931 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe930);
// compiled call node returning call931 (depth = 2)
  gc_frame_end(frame);
  return call931;
}
Object meth_ast_visitBind_40_1_41_up_40_1_41_932(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitBind(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBind(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBind(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2948
  setline(2948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe933 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call934 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe933);
// compiled call node returning call934 (depth = 2)
  gc_frame_end(frame);
  return call934;
}
Object meth_ast_visitDefDec_40_1_41_up_40_1_41_935(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitDefDec(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDefDec(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitDefDec(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2949
  setline(2949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe936 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call937 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe936);
// compiled call node returning call937 (depth = 2)
  gc_frame_end(frame);
  return call937;
}
Object meth_ast_visitVarDec_40_1_41_up_40_1_41_938(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitVarDec(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitVarDec(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitVarDec(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2950
  setline(2950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe939 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call940 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe939);
// compiled call node returning call940 (depth = 2)
  gc_frame_end(frame);
  return call940;
}
Object meth_ast_visitImport_40_1_41_up_40_1_41_941(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitImport(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitImport(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitImport(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2951
  setline(2951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe942 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call943 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe942);
// compiled call node returning call943 (depth = 2)
  gc_frame_end(frame);
  return call943;
}
Object meth_ast_visitReturn_40_1_41_up_40_1_41_944(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitReturn(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitReturn(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitReturn(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2952
  setline(2952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe945 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call946 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe945);
// compiled call node returning call946 (depth = 2)
  gc_frame_end(frame);
  return call946;
}
Object meth_ast_visitInherits_40_1_41_up_40_1_41_947(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitInherits(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitInherits(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitInherits(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2953
  setline(2953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe948 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call949 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe948);
// compiled call node returning call949 (depth = 2)
  gc_frame_end(frame);
  return call949;
}
Object meth_ast_visitDialect_40_1_41_up_40_1_41_950(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitDialect(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDialect(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitDialect(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2954
  setline(2954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe951 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call952 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe951);
// compiled call node returning call952 (depth = 2)
  gc_frame_end(frame);
  return call952;
}
Object meth_ast_visitBlank_40_1_41_up_40_1_41_953(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitBlank(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBlank(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitBlank(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2955
  setline(2955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe954 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call955 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe954);
// compiled call node returning call955 (depth = 2)
  gc_frame_end(frame);
  return call955;
}
Object meth_ast_visitComment_40_1_41_up_40_1_41_956(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitComment(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitComment(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitComment(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2956
  setline(2956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe957 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call958 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe957);
// compiled call node returning call958 (depth = 2)
  gc_frame_end(frame);
  return call958;
}
Object meth_ast_visitImplicit_40_1_41_up_40_1_41_959(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitImplicit(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImplicit(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImplicit(_)up(_)");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitImplicit(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitImplicit(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2957
  setline(2957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe960 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call961 = callmethodflags(*var_visitation, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe960);
// compiled call node returning call961 (depth = 2)
  gc_frame_end(frame);
  return call961;
}
Object meth_ast_asString962(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2959
  setline(2959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit963 == NULL) {
    strlit963 = alloc_String("a pluggable AST visitor");
    gc_root(strlit963);
  }
// compiled string node returning strlit963 (depth = 2)
  gc_frame_end(frame);
  return strlit963;
}
Object meth_ast_pluggableVisitor_40_1_41_872(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pluggableVisitor(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pluggableVisitor(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pluggableVisitor(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitation = &(stackframe->slots[0]);
  *var_visitation = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pluggableVisitor(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject873 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj873 = alloc_userobj2(30,31, objclass873);
  gc_frame_newslot(obj873);
if (objclass873 == NULL) {
  glfree(obj873->class->name);
  obj873->class->name = "pluggableVisitor(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj873, self, 0);
  addmethodreal(obj873,"outer", &reader_ast_outer_874);
  Object oldself873 = self;
  struct StackFrameObject *oldstackframe873 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe873);
  gc_frame_newslot((Object)stackframe);
  self = obj873;
  Object *oldselfslot873 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter873 = (*(struct UserObject *)self).data[0], lowerouter873 = thisouter873;
  if (inheritingObject873) {
    struct UserObject *inho873 = (struct UserObject *)inheritingObject873;
    while (inho873->super != GraceDefaultObject) inho873 = (struct UserObject *)inho873->super;
    inho873->super = obj873;
    self = inheritingObject873;
    *selfslot = self;
    lowerouter873 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter873;
  }
// method "visitIf(_)up(_)"
  block_savedest(obj873);
  Object closure875 = createclosure(1, "visitIf(1)up(1)");
  setclosureframe(closure875, stackframe);
  addtoclosure(closure875, var_visitation);
  struct UserObject *uo875 = (struct UserObject*)obj873;
  uo875->data[1] = (Object)closure875;
  Method *meth_meth_ast_visitIf_40_1_41_up_40_1_41_875 = addmethod2pos(obj873, "visitIf(1)up(1)", &meth_ast_visitIf_40_1_41_up_40_1_41_875, 1);
  int argcv_meth_ast_visitIf_40_1_41_up_40_1_41_875[] = {1, 1};
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_875->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40_1_41_up_40_1_41_875);
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_875->definitionModule = modulename;
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_875->definitionLine = 2929;
// method "visitBlock(_)up(_)"
  block_savedest(obj873);
  Object closure878 = createclosure(1, "visitBlock(1)up(1)");
  setclosureframe(closure878, stackframe);
  addtoclosure(closure878, var_visitation);
  struct UserObject *uo878 = (struct UserObject*)obj873;
  uo878->data[2] = (Object)closure878;
  Method *meth_meth_ast_visitBlock_40_1_41_up_40_1_41_878 = addmethod2pos(obj873, "visitBlock(1)up(1)", &meth_ast_visitBlock_40_1_41_up_40_1_41_878, 2);
  int argcv_meth_ast_visitBlock_40_1_41_up_40_1_41_878[] = {1, 1};
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_878->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40_1_41_up_40_1_41_878);
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_878->definitionModule = modulename;
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_878->definitionLine = 2930;
// method "visitMatchCase(_)up(_)"
  block_savedest(obj873);
  Object closure881 = createclosure(1, "visitMatchCase(1)up(1)");
  setclosureframe(closure881, stackframe);
  addtoclosure(closure881, var_visitation);
  struct UserObject *uo881 = (struct UserObject*)obj873;
  uo881->data[3] = (Object)closure881;
  Method *meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_881 = addmethod2pos(obj873, "visitMatchCase(1)up(1)", &meth_ast_visitMatchCase_40_1_41_up_40_1_41_881, 3);
  int argcv_meth_ast_visitMatchCase_40_1_41_up_40_1_41_881[] = {1, 1};
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_881->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40_1_41_up_40_1_41_881);
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_881->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_881->definitionLine = 2931;
// method "visitTryCatch(_)up(_)"
  block_savedest(obj873);
  Object closure884 = createclosure(1, "visitTryCatch(1)up(1)");
  setclosureframe(closure884, stackframe);
  addtoclosure(closure884, var_visitation);
  struct UserObject *uo884 = (struct UserObject*)obj873;
  uo884->data[4] = (Object)closure884;
  Method *meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_884 = addmethod2pos(obj873, "visitTryCatch(1)up(1)", &meth_ast_visitTryCatch_40_1_41_up_40_1_41_884, 4);
  int argcv_meth_ast_visitTryCatch_40_1_41_up_40_1_41_884[] = {1, 1};
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_884->type = alloc_MethodType(2, argcv_meth_ast_visitTryCatch_40_1_41_up_40_1_41_884);
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_884->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_884->definitionLine = 2932;
// method "visitMethodType(_)up(_)"
  block_savedest(obj873);
  Object closure887 = createclosure(1, "visitMethodType(1)up(1)");
  setclosureframe(closure887, stackframe);
  addtoclosure(closure887, var_visitation);
  struct UserObject *uo887 = (struct UserObject*)obj873;
  uo887->data[5] = (Object)closure887;
  Method *meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_887 = addmethod2pos(obj873, "visitMethodType(1)up(1)", &meth_ast_visitMethodType_40_1_41_up_40_1_41_887, 5);
  int argcv_meth_ast_visitMethodType_40_1_41_up_40_1_41_887[] = {1, 1};
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_887->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40_1_41_up_40_1_41_887);
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_887->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_887->definitionLine = 2933;
// method "visitSignaturePart(_)up(_)"
  block_savedest(obj873);
  Object closure890 = createclosure(1, "visitSignaturePart(1)up(1)");
  setclosureframe(closure890, stackframe);
  addtoclosure(closure890, var_visitation);
  struct UserObject *uo890 = (struct UserObject*)obj873;
  uo890->data[6] = (Object)closure890;
  Method *meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_890 = addmethod2pos(obj873, "visitSignaturePart(1)up(1)", &meth_ast_visitSignaturePart_40_1_41_up_40_1_41_890, 6);
  int argcv_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_890[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_890->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_890);
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_890->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_890->definitionLine = 2934;
// method "visitTypeDec(_)up(_)"
  block_savedest(obj873);
  Object closure893 = createclosure(1, "visitTypeDec(1)up(1)");
  setclosureframe(closure893, stackframe);
  addtoclosure(closure893, var_visitation);
  struct UserObject *uo893 = (struct UserObject*)obj873;
  uo893->data[7] = (Object)closure893;
  Method *meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_893 = addmethod2pos(obj873, "visitTypeDec(1)up(1)", &meth_ast_visitTypeDec_40_1_41_up_40_1_41_893, 7);
  int argcv_meth_ast_visitTypeDec_40_1_41_up_40_1_41_893[] = {1, 1};
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_893->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40_1_41_up_40_1_41_893);
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_893->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_893->definitionLine = 2935;
// method "visitTypeLiteral(_)up(_)"
  block_savedest(obj873);
  Object closure896 = createclosure(1, "visitTypeLiteral(1)up(1)");
  setclosureframe(closure896, stackframe);
  addtoclosure(closure896, var_visitation);
  struct UserObject *uo896 = (struct UserObject*)obj873;
  uo896->data[8] = (Object)closure896;
  Method *meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_896 = addmethod2pos(obj873, "visitTypeLiteral(1)up(1)", &meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_896, 8);
  int argcv_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_896[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_896->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_896);
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_896->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_896->definitionLine = 2936;
// method "visitMethod(_)up(_)"
  block_savedest(obj873);
  Object closure899 = createclosure(1, "visitMethod(1)up(1)");
  setclosureframe(closure899, stackframe);
  addtoclosure(closure899, var_visitation);
  struct UserObject *uo899 = (struct UserObject*)obj873;
  uo899->data[9] = (Object)closure899;
  Method *meth_meth_ast_visitMethod_40_1_41_up_40_1_41_899 = addmethod2pos(obj873, "visitMethod(1)up(1)", &meth_ast_visitMethod_40_1_41_up_40_1_41_899, 9);
  int argcv_meth_ast_visitMethod_40_1_41_up_40_1_41_899[] = {1, 1};
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_899->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40_1_41_up_40_1_41_899);
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_899->definitionModule = modulename;
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_899->definitionLine = 2937;
// method "visitCall(_)up(_)"
  block_savedest(obj873);
  Object closure902 = createclosure(1, "visitCall(1)up(1)");
  setclosureframe(closure902, stackframe);
  addtoclosure(closure902, var_visitation);
  struct UserObject *uo902 = (struct UserObject*)obj873;
  uo902->data[10] = (Object)closure902;
  Method *meth_meth_ast_visitCall_40_1_41_up_40_1_41_902 = addmethod2pos(obj873, "visitCall(1)up(1)", &meth_ast_visitCall_40_1_41_up_40_1_41_902, 10);
  int argcv_meth_ast_visitCall_40_1_41_up_40_1_41_902[] = {1, 1};
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_902->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40_1_41_up_40_1_41_902);
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_902->definitionModule = modulename;
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_902->definitionLine = 2938;
// method "visitObject(_)up(_)"
  block_savedest(obj873);
  Object closure905 = createclosure(1, "visitObject(1)up(1)");
  setclosureframe(closure905, stackframe);
  addtoclosure(closure905, var_visitation);
  struct UserObject *uo905 = (struct UserObject*)obj873;
  uo905->data[11] = (Object)closure905;
  Method *meth_meth_ast_visitObject_40_1_41_up_40_1_41_905 = addmethod2pos(obj873, "visitObject(1)up(1)", &meth_ast_visitObject_40_1_41_up_40_1_41_905, 11);
  int argcv_meth_ast_visitObject_40_1_41_up_40_1_41_905[] = {1, 1};
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_905->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40_1_41_up_40_1_41_905);
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_905->definitionModule = modulename;
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_905->definitionLine = 2939;
// method "visitModule(_)up(_)"
  block_savedest(obj873);
  Object closure908 = createclosure(1, "visitModule(1)up(1)");
  setclosureframe(closure908, stackframe);
  addtoclosure(closure908, var_visitation);
  struct UserObject *uo908 = (struct UserObject*)obj873;
  uo908->data[12] = (Object)closure908;
  Method *meth_meth_ast_visitModule_40_1_41_up_40_1_41_908 = addmethod2pos(obj873, "visitModule(1)up(1)", &meth_ast_visitModule_40_1_41_up_40_1_41_908, 12);
  int argcv_meth_ast_visitModule_40_1_41_up_40_1_41_908[] = {1, 1};
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_908->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40_1_41_up_40_1_41_908);
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_908->definitionModule = modulename;
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_908->definitionLine = 2940;
// method "visitArray(_)up(_)"
  block_savedest(obj873);
  Object closure911 = createclosure(1, "visitArray(1)up(1)");
  setclosureframe(closure911, stackframe);
  addtoclosure(closure911, var_visitation);
  struct UserObject *uo911 = (struct UserObject*)obj873;
  uo911->data[13] = (Object)closure911;
  Method *meth_meth_ast_visitArray_40_1_41_up_40_1_41_911 = addmethod2pos(obj873, "visitArray(1)up(1)", &meth_ast_visitArray_40_1_41_up_40_1_41_911, 13);
  int argcv_meth_ast_visitArray_40_1_41_up_40_1_41_911[] = {1, 1};
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_911->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40_1_41_up_40_1_41_911);
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_911->definitionModule = modulename;
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_911->definitionLine = 2941;
// method "visitMember(_)up(_)"
  block_savedest(obj873);
  Object closure914 = createclosure(1, "visitMember(1)up(1)");
  setclosureframe(closure914, stackframe);
  addtoclosure(closure914, var_visitation);
  struct UserObject *uo914 = (struct UserObject*)obj873;
  uo914->data[14] = (Object)closure914;
  Method *meth_meth_ast_visitMember_40_1_41_up_40_1_41_914 = addmethod2pos(obj873, "visitMember(1)up(1)", &meth_ast_visitMember_40_1_41_up_40_1_41_914, 14);
  int argcv_meth_ast_visitMember_40_1_41_up_40_1_41_914[] = {1, 1};
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_914->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40_1_41_up_40_1_41_914);
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_914->definitionModule = modulename;
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_914->definitionLine = 2942;
// method "visitGeneric(_)up(_)"
  block_savedest(obj873);
  Object closure917 = createclosure(1, "visitGeneric(1)up(1)");
  setclosureframe(closure917, stackframe);
  addtoclosure(closure917, var_visitation);
  struct UserObject *uo917 = (struct UserObject*)obj873;
  uo917->data[15] = (Object)closure917;
  Method *meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_917 = addmethod2pos(obj873, "visitGeneric(1)up(1)", &meth_ast_visitGeneric_40_1_41_up_40_1_41_917, 15);
  int argcv_meth_ast_visitGeneric_40_1_41_up_40_1_41_917[] = {1, 1};
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_917->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40_1_41_up_40_1_41_917);
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_917->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_917->definitionLine = 2943;
// method "visitIdentifier(_)up(_)"
  block_savedest(obj873);
  Object closure920 = createclosure(1, "visitIdentifier(1)up(1)");
  setclosureframe(closure920, stackframe);
  addtoclosure(closure920, var_visitation);
  struct UserObject *uo920 = (struct UserObject*)obj873;
  uo920->data[16] = (Object)closure920;
  Method *meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_920 = addmethod2pos(obj873, "visitIdentifier(1)up(1)", &meth_ast_visitIdentifier_40_1_41_up_40_1_41_920, 16);
  int argcv_meth_ast_visitIdentifier_40_1_41_up_40_1_41_920[] = {1, 1};
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_920->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40_1_41_up_40_1_41_920);
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_920->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_920->definitionLine = 2944;
// method "visitString(_)up(_)"
  block_savedest(obj873);
  Object closure923 = createclosure(1, "visitString(1)up(1)");
  setclosureframe(closure923, stackframe);
  addtoclosure(closure923, var_visitation);
  struct UserObject *uo923 = (struct UserObject*)obj873;
  uo923->data[17] = (Object)closure923;
  Method *meth_meth_ast_visitString_40_1_41_up_40_1_41_923 = addmethod2pos(obj873, "visitString(1)up(1)", &meth_ast_visitString_40_1_41_up_40_1_41_923, 17);
  int argcv_meth_ast_visitString_40_1_41_up_40_1_41_923[] = {1, 1};
  meth_meth_ast_visitString_40_1_41_up_40_1_41_923->type = alloc_MethodType(2, argcv_meth_ast_visitString_40_1_41_up_40_1_41_923);
  meth_meth_ast_visitString_40_1_41_up_40_1_41_923->definitionModule = modulename;
  meth_meth_ast_visitString_40_1_41_up_40_1_41_923->definitionLine = 2945;
// method "visitNum(_)up(_)"
  block_savedest(obj873);
  Object closure926 = createclosure(1, "visitNum(1)up(1)");
  setclosureframe(closure926, stackframe);
  addtoclosure(closure926, var_visitation);
  struct UserObject *uo926 = (struct UserObject*)obj873;
  uo926->data[18] = (Object)closure926;
  Method *meth_meth_ast_visitNum_40_1_41_up_40_1_41_926 = addmethod2pos(obj873, "visitNum(1)up(1)", &meth_ast_visitNum_40_1_41_up_40_1_41_926, 18);
  int argcv_meth_ast_visitNum_40_1_41_up_40_1_41_926[] = {1, 1};
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_926->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40_1_41_up_40_1_41_926);
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_926->definitionModule = modulename;
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_926->definitionLine = 2946;
// method "visitOp(_)up(_)"
  block_savedest(obj873);
  Object closure929 = createclosure(1, "visitOp(1)up(1)");
  setclosureframe(closure929, stackframe);
  addtoclosure(closure929, var_visitation);
  struct UserObject *uo929 = (struct UserObject*)obj873;
  uo929->data[19] = (Object)closure929;
  Method *meth_meth_ast_visitOp_40_1_41_up_40_1_41_929 = addmethod2pos(obj873, "visitOp(1)up(1)", &meth_ast_visitOp_40_1_41_up_40_1_41_929, 19);
  int argcv_meth_ast_visitOp_40_1_41_up_40_1_41_929[] = {1, 1};
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_929->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40_1_41_up_40_1_41_929);
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_929->definitionModule = modulename;
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_929->definitionLine = 2947;
// method "visitBind(_)up(_)"
  block_savedest(obj873);
  Object closure932 = createclosure(1, "visitBind(1)up(1)");
  setclosureframe(closure932, stackframe);
  addtoclosure(closure932, var_visitation);
  struct UserObject *uo932 = (struct UserObject*)obj873;
  uo932->data[20] = (Object)closure932;
  Method *meth_meth_ast_visitBind_40_1_41_up_40_1_41_932 = addmethod2pos(obj873, "visitBind(1)up(1)", &meth_ast_visitBind_40_1_41_up_40_1_41_932, 20);
  int argcv_meth_ast_visitBind_40_1_41_up_40_1_41_932[] = {1, 1};
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_932->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40_1_41_up_40_1_41_932);
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_932->definitionModule = modulename;
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_932->definitionLine = 2948;
// method "visitDefDec(_)up(_)"
  block_savedest(obj873);
  Object closure935 = createclosure(1, "visitDefDec(1)up(1)");
  setclosureframe(closure935, stackframe);
  addtoclosure(closure935, var_visitation);
  struct UserObject *uo935 = (struct UserObject*)obj873;
  uo935->data[21] = (Object)closure935;
  Method *meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_935 = addmethod2pos(obj873, "visitDefDec(1)up(1)", &meth_ast_visitDefDec_40_1_41_up_40_1_41_935, 21);
  int argcv_meth_ast_visitDefDec_40_1_41_up_40_1_41_935[] = {1, 1};
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_935->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40_1_41_up_40_1_41_935);
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_935->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_935->definitionLine = 2949;
// method "visitVarDec(_)up(_)"
  block_savedest(obj873);
  Object closure938 = createclosure(1, "visitVarDec(1)up(1)");
  setclosureframe(closure938, stackframe);
  addtoclosure(closure938, var_visitation);
  struct UserObject *uo938 = (struct UserObject*)obj873;
  uo938->data[22] = (Object)closure938;
  Method *meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_938 = addmethod2pos(obj873, "visitVarDec(1)up(1)", &meth_ast_visitVarDec_40_1_41_up_40_1_41_938, 22);
  int argcv_meth_ast_visitVarDec_40_1_41_up_40_1_41_938[] = {1, 1};
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_938->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40_1_41_up_40_1_41_938);
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_938->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_938->definitionLine = 2950;
// method "visitImport(_)up(_)"
  block_savedest(obj873);
  Object closure941 = createclosure(1, "visitImport(1)up(1)");
  setclosureframe(closure941, stackframe);
  addtoclosure(closure941, var_visitation);
  struct UserObject *uo941 = (struct UserObject*)obj873;
  uo941->data[23] = (Object)closure941;
  Method *meth_meth_ast_visitImport_40_1_41_up_40_1_41_941 = addmethod2pos(obj873, "visitImport(1)up(1)", &meth_ast_visitImport_40_1_41_up_40_1_41_941, 23);
  int argcv_meth_ast_visitImport_40_1_41_up_40_1_41_941[] = {1, 1};
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_941->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40_1_41_up_40_1_41_941);
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_941->definitionModule = modulename;
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_941->definitionLine = 2951;
// method "visitReturn(_)up(_)"
  block_savedest(obj873);
  Object closure944 = createclosure(1, "visitReturn(1)up(1)");
  setclosureframe(closure944, stackframe);
  addtoclosure(closure944, var_visitation);
  struct UserObject *uo944 = (struct UserObject*)obj873;
  uo944->data[24] = (Object)closure944;
  Method *meth_meth_ast_visitReturn_40_1_41_up_40_1_41_944 = addmethod2pos(obj873, "visitReturn(1)up(1)", &meth_ast_visitReturn_40_1_41_up_40_1_41_944, 24);
  int argcv_meth_ast_visitReturn_40_1_41_up_40_1_41_944[] = {1, 1};
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_944->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40_1_41_up_40_1_41_944);
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_944->definitionModule = modulename;
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_944->definitionLine = 2952;
// method "visitInherits(_)up(_)"
  block_savedest(obj873);
  Object closure947 = createclosure(1, "visitInherits(1)up(1)");
  setclosureframe(closure947, stackframe);
  addtoclosure(closure947, var_visitation);
  struct UserObject *uo947 = (struct UserObject*)obj873;
  uo947->data[25] = (Object)closure947;
  Method *meth_meth_ast_visitInherits_40_1_41_up_40_1_41_947 = addmethod2pos(obj873, "visitInherits(1)up(1)", &meth_ast_visitInherits_40_1_41_up_40_1_41_947, 25);
  int argcv_meth_ast_visitInherits_40_1_41_up_40_1_41_947[] = {1, 1};
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_947->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40_1_41_up_40_1_41_947);
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_947->definitionModule = modulename;
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_947->definitionLine = 2953;
// method "visitDialect(_)up(_)"
  block_savedest(obj873);
  Object closure950 = createclosure(1, "visitDialect(1)up(1)");
  setclosureframe(closure950, stackframe);
  addtoclosure(closure950, var_visitation);
  struct UserObject *uo950 = (struct UserObject*)obj873;
  uo950->data[26] = (Object)closure950;
  Method *meth_meth_ast_visitDialect_40_1_41_up_40_1_41_950 = addmethod2pos(obj873, "visitDialect(1)up(1)", &meth_ast_visitDialect_40_1_41_up_40_1_41_950, 26);
  int argcv_meth_ast_visitDialect_40_1_41_up_40_1_41_950[] = {1, 1};
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_950->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40_1_41_up_40_1_41_950);
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_950->definitionModule = modulename;
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_950->definitionLine = 2954;
// method "visitBlank(_)up(_)"
  block_savedest(obj873);
  Object closure953 = createclosure(1, "visitBlank(1)up(1)");
  setclosureframe(closure953, stackframe);
  addtoclosure(closure953, var_visitation);
  struct UserObject *uo953 = (struct UserObject*)obj873;
  uo953->data[27] = (Object)closure953;
  Method *meth_meth_ast_visitBlank_40_1_41_up_40_1_41_953 = addmethod2pos(obj873, "visitBlank(1)up(1)", &meth_ast_visitBlank_40_1_41_up_40_1_41_953, 27);
  int argcv_meth_ast_visitBlank_40_1_41_up_40_1_41_953[] = {1, 1};
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_953->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40_1_41_up_40_1_41_953);
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_953->definitionModule = modulename;
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_953->definitionLine = 2955;
// method "visitComment(_)up(_)"
  block_savedest(obj873);
  Object closure956 = createclosure(1, "visitComment(1)up(1)");
  setclosureframe(closure956, stackframe);
  addtoclosure(closure956, var_visitation);
  struct UserObject *uo956 = (struct UserObject*)obj873;
  uo956->data[28] = (Object)closure956;
  Method *meth_meth_ast_visitComment_40_1_41_up_40_1_41_956 = addmethod2pos(obj873, "visitComment(1)up(1)", &meth_ast_visitComment_40_1_41_up_40_1_41_956, 28);
  int argcv_meth_ast_visitComment_40_1_41_up_40_1_41_956[] = {1, 1};
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_956->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40_1_41_up_40_1_41_956);
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_956->definitionModule = modulename;
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_956->definitionLine = 2956;
// method "visitImplicit(_)up(_)"
  block_savedest(obj873);
  Object closure959 = createclosure(1, "visitImplicit(1)up(1)");
  setclosureframe(closure959, stackframe);
  addtoclosure(closure959, var_visitation);
  struct UserObject *uo959 = (struct UserObject*)obj873;
  uo959->data[29] = (Object)closure959;
  Method *meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_959 = addmethod2pos(obj873, "visitImplicit(1)up(1)", &meth_ast_visitImplicit_40_1_41_up_40_1_41_959, 29);
  int argcv_meth_ast_visitImplicit_40_1_41_up_40_1_41_959[] = {1, 1};
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_959->type = alloc_MethodType(2, argcv_meth_ast_visitImplicit_40_1_41_up_40_1_41_959);
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_959->definitionModule = modulename;
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_959->definitionLine = 2957;
// method "asString"
  struct UserObject *uo962 = (struct UserObject*)obj873;
  uo962->data[30] = emptyclosure;
  Method *meth_meth_ast_asString962 = addmethod2pos(obj873, "asString", &meth_ast_asString962, 30);
  int argcv_meth_ast_asString962[] = {0};
  meth_meth_ast_asString962->type = alloc_MethodType(1, argcv_meth_ast_asString962);
  meth_meth_ast_asString962->definitionModule = modulename;
  meth_meth_ast_asString962->definitionLine = 2959;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  objclass873 = obj873->class;
  objclass873->definitionModule = modulename;
  objclass873->definitionLine = 2922;
  (*(struct UserObject *)self).data[0] = lowerouter873;
  self = oldself873;
  selfslot = oldselfslot873;
  stackframe = oldstackframe873;
  gc_frame_end(frame);
  return obj873;
}
Object meth_ast_pluggableVisitor_40_1_41_872_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pluggableVisitor(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method pluggableVisitor(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pluggableVisitor(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitation = &(stackframe->slots[0]);
  *var_visitation = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pluggableVisitor(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject873 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj873 = alloc_userobj2(30,31, objclass873);
  gc_frame_newslot(obj873);
if (objclass873 == NULL) {
  glfree(obj873->class->name);
  obj873->class->name = "pluggableVisitor(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj873, self, 0);
  addmethodreal(obj873,"outer", &reader_ast_outer_874);
  Object oldself873 = self;
  struct StackFrameObject *oldstackframe873 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe873);
  gc_frame_newslot((Object)stackframe);
  self = obj873;
  Object *oldselfslot873 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter873 = (*(struct UserObject *)self).data[0], lowerouter873 = thisouter873;
  if (inheritingObject873) {
    struct UserObject *inho873 = (struct UserObject *)inheritingObject873;
    while (inho873->super != GraceDefaultObject) inho873 = (struct UserObject *)inho873->super;
    inho873->super = obj873;
    self = inheritingObject873;
    *selfslot = self;
    lowerouter873 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter873;
  }
// method "visitIf(_)up(_)"
  block_savedest(obj873);
  Object closure875 = createclosure(1, "visitIf(1)up(1)");
  setclosureframe(closure875, stackframe);
  addtoclosure(closure875, var_visitation);
  struct UserObject *uo875 = (struct UserObject*)obj873;
  uo875->data[1] = (Object)closure875;
  Method *meth_meth_ast_visitIf_40_1_41_up_40_1_41_875 = addmethod2pos(obj873, "visitIf(1)up(1)", &meth_ast_visitIf_40_1_41_up_40_1_41_875, 1);
  int argcv_meth_ast_visitIf_40_1_41_up_40_1_41_875[] = {1, 1};
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_875->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40_1_41_up_40_1_41_875);
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_875->definitionModule = modulename;
  meth_meth_ast_visitIf_40_1_41_up_40_1_41_875->definitionLine = 2929;
// method "visitBlock(_)up(_)"
  block_savedest(obj873);
  Object closure878 = createclosure(1, "visitBlock(1)up(1)");
  setclosureframe(closure878, stackframe);
  addtoclosure(closure878, var_visitation);
  struct UserObject *uo878 = (struct UserObject*)obj873;
  uo878->data[2] = (Object)closure878;
  Method *meth_meth_ast_visitBlock_40_1_41_up_40_1_41_878 = addmethod2pos(obj873, "visitBlock(1)up(1)", &meth_ast_visitBlock_40_1_41_up_40_1_41_878, 2);
  int argcv_meth_ast_visitBlock_40_1_41_up_40_1_41_878[] = {1, 1};
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_878->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40_1_41_up_40_1_41_878);
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_878->definitionModule = modulename;
  meth_meth_ast_visitBlock_40_1_41_up_40_1_41_878->definitionLine = 2930;
// method "visitMatchCase(_)up(_)"
  block_savedest(obj873);
  Object closure881 = createclosure(1, "visitMatchCase(1)up(1)");
  setclosureframe(closure881, stackframe);
  addtoclosure(closure881, var_visitation);
  struct UserObject *uo881 = (struct UserObject*)obj873;
  uo881->data[3] = (Object)closure881;
  Method *meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_881 = addmethod2pos(obj873, "visitMatchCase(1)up(1)", &meth_ast_visitMatchCase_40_1_41_up_40_1_41_881, 3);
  int argcv_meth_ast_visitMatchCase_40_1_41_up_40_1_41_881[] = {1, 1};
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_881->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40_1_41_up_40_1_41_881);
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_881->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40_1_41_up_40_1_41_881->definitionLine = 2931;
// method "visitTryCatch(_)up(_)"
  block_savedest(obj873);
  Object closure884 = createclosure(1, "visitTryCatch(1)up(1)");
  setclosureframe(closure884, stackframe);
  addtoclosure(closure884, var_visitation);
  struct UserObject *uo884 = (struct UserObject*)obj873;
  uo884->data[4] = (Object)closure884;
  Method *meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_884 = addmethod2pos(obj873, "visitTryCatch(1)up(1)", &meth_ast_visitTryCatch_40_1_41_up_40_1_41_884, 4);
  int argcv_meth_ast_visitTryCatch_40_1_41_up_40_1_41_884[] = {1, 1};
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_884->type = alloc_MethodType(2, argcv_meth_ast_visitTryCatch_40_1_41_up_40_1_41_884);
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_884->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40_1_41_up_40_1_41_884->definitionLine = 2932;
// method "visitMethodType(_)up(_)"
  block_savedest(obj873);
  Object closure887 = createclosure(1, "visitMethodType(1)up(1)");
  setclosureframe(closure887, stackframe);
  addtoclosure(closure887, var_visitation);
  struct UserObject *uo887 = (struct UserObject*)obj873;
  uo887->data[5] = (Object)closure887;
  Method *meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_887 = addmethod2pos(obj873, "visitMethodType(1)up(1)", &meth_ast_visitMethodType_40_1_41_up_40_1_41_887, 5);
  int argcv_meth_ast_visitMethodType_40_1_41_up_40_1_41_887[] = {1, 1};
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_887->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40_1_41_up_40_1_41_887);
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_887->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40_1_41_up_40_1_41_887->definitionLine = 2933;
// method "visitSignaturePart(_)up(_)"
  block_savedest(obj873);
  Object closure890 = createclosure(1, "visitSignaturePart(1)up(1)");
  setclosureframe(closure890, stackframe);
  addtoclosure(closure890, var_visitation);
  struct UserObject *uo890 = (struct UserObject*)obj873;
  uo890->data[6] = (Object)closure890;
  Method *meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_890 = addmethod2pos(obj873, "visitSignaturePart(1)up(1)", &meth_ast_visitSignaturePart_40_1_41_up_40_1_41_890, 6);
  int argcv_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_890[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_890->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_890);
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_890->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40_1_41_up_40_1_41_890->definitionLine = 2934;
// method "visitTypeDec(_)up(_)"
  block_savedest(obj873);
  Object closure893 = createclosure(1, "visitTypeDec(1)up(1)");
  setclosureframe(closure893, stackframe);
  addtoclosure(closure893, var_visitation);
  struct UserObject *uo893 = (struct UserObject*)obj873;
  uo893->data[7] = (Object)closure893;
  Method *meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_893 = addmethod2pos(obj873, "visitTypeDec(1)up(1)", &meth_ast_visitTypeDec_40_1_41_up_40_1_41_893, 7);
  int argcv_meth_ast_visitTypeDec_40_1_41_up_40_1_41_893[] = {1, 1};
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_893->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40_1_41_up_40_1_41_893);
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_893->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40_1_41_up_40_1_41_893->definitionLine = 2935;
// method "visitTypeLiteral(_)up(_)"
  block_savedest(obj873);
  Object closure896 = createclosure(1, "visitTypeLiteral(1)up(1)");
  setclosureframe(closure896, stackframe);
  addtoclosure(closure896, var_visitation);
  struct UserObject *uo896 = (struct UserObject*)obj873;
  uo896->data[8] = (Object)closure896;
  Method *meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_896 = addmethod2pos(obj873, "visitTypeLiteral(1)up(1)", &meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_896, 8);
  int argcv_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_896[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_896->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_896);
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_896->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40_1_41_up_40_1_41_896->definitionLine = 2936;
// method "visitMethod(_)up(_)"
  block_savedest(obj873);
  Object closure899 = createclosure(1, "visitMethod(1)up(1)");
  setclosureframe(closure899, stackframe);
  addtoclosure(closure899, var_visitation);
  struct UserObject *uo899 = (struct UserObject*)obj873;
  uo899->data[9] = (Object)closure899;
  Method *meth_meth_ast_visitMethod_40_1_41_up_40_1_41_899 = addmethod2pos(obj873, "visitMethod(1)up(1)", &meth_ast_visitMethod_40_1_41_up_40_1_41_899, 9);
  int argcv_meth_ast_visitMethod_40_1_41_up_40_1_41_899[] = {1, 1};
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_899->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40_1_41_up_40_1_41_899);
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_899->definitionModule = modulename;
  meth_meth_ast_visitMethod_40_1_41_up_40_1_41_899->definitionLine = 2937;
// method "visitCall(_)up(_)"
  block_savedest(obj873);
  Object closure902 = createclosure(1, "visitCall(1)up(1)");
  setclosureframe(closure902, stackframe);
  addtoclosure(closure902, var_visitation);
  struct UserObject *uo902 = (struct UserObject*)obj873;
  uo902->data[10] = (Object)closure902;
  Method *meth_meth_ast_visitCall_40_1_41_up_40_1_41_902 = addmethod2pos(obj873, "visitCall(1)up(1)", &meth_ast_visitCall_40_1_41_up_40_1_41_902, 10);
  int argcv_meth_ast_visitCall_40_1_41_up_40_1_41_902[] = {1, 1};
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_902->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40_1_41_up_40_1_41_902);
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_902->definitionModule = modulename;
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_902->definitionLine = 2938;
// method "visitObject(_)up(_)"
  block_savedest(obj873);
  Object closure905 = createclosure(1, "visitObject(1)up(1)");
  setclosureframe(closure905, stackframe);
  addtoclosure(closure905, var_visitation);
  struct UserObject *uo905 = (struct UserObject*)obj873;
  uo905->data[11] = (Object)closure905;
  Method *meth_meth_ast_visitObject_40_1_41_up_40_1_41_905 = addmethod2pos(obj873, "visitObject(1)up(1)", &meth_ast_visitObject_40_1_41_up_40_1_41_905, 11);
  int argcv_meth_ast_visitObject_40_1_41_up_40_1_41_905[] = {1, 1};
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_905->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40_1_41_up_40_1_41_905);
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_905->definitionModule = modulename;
  meth_meth_ast_visitObject_40_1_41_up_40_1_41_905->definitionLine = 2939;
// method "visitModule(_)up(_)"
  block_savedest(obj873);
  Object closure908 = createclosure(1, "visitModule(1)up(1)");
  setclosureframe(closure908, stackframe);
  addtoclosure(closure908, var_visitation);
  struct UserObject *uo908 = (struct UserObject*)obj873;
  uo908->data[12] = (Object)closure908;
  Method *meth_meth_ast_visitModule_40_1_41_up_40_1_41_908 = addmethod2pos(obj873, "visitModule(1)up(1)", &meth_ast_visitModule_40_1_41_up_40_1_41_908, 12);
  int argcv_meth_ast_visitModule_40_1_41_up_40_1_41_908[] = {1, 1};
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_908->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40_1_41_up_40_1_41_908);
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_908->definitionModule = modulename;
  meth_meth_ast_visitModule_40_1_41_up_40_1_41_908->definitionLine = 2940;
// method "visitArray(_)up(_)"
  block_savedest(obj873);
  Object closure911 = createclosure(1, "visitArray(1)up(1)");
  setclosureframe(closure911, stackframe);
  addtoclosure(closure911, var_visitation);
  struct UserObject *uo911 = (struct UserObject*)obj873;
  uo911->data[13] = (Object)closure911;
  Method *meth_meth_ast_visitArray_40_1_41_up_40_1_41_911 = addmethod2pos(obj873, "visitArray(1)up(1)", &meth_ast_visitArray_40_1_41_up_40_1_41_911, 13);
  int argcv_meth_ast_visitArray_40_1_41_up_40_1_41_911[] = {1, 1};
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_911->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40_1_41_up_40_1_41_911);
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_911->definitionModule = modulename;
  meth_meth_ast_visitArray_40_1_41_up_40_1_41_911->definitionLine = 2941;
// method "visitMember(_)up(_)"
  block_savedest(obj873);
  Object closure914 = createclosure(1, "visitMember(1)up(1)");
  setclosureframe(closure914, stackframe);
  addtoclosure(closure914, var_visitation);
  struct UserObject *uo914 = (struct UserObject*)obj873;
  uo914->data[14] = (Object)closure914;
  Method *meth_meth_ast_visitMember_40_1_41_up_40_1_41_914 = addmethod2pos(obj873, "visitMember(1)up(1)", &meth_ast_visitMember_40_1_41_up_40_1_41_914, 14);
  int argcv_meth_ast_visitMember_40_1_41_up_40_1_41_914[] = {1, 1};
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_914->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40_1_41_up_40_1_41_914);
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_914->definitionModule = modulename;
  meth_meth_ast_visitMember_40_1_41_up_40_1_41_914->definitionLine = 2942;
// method "visitGeneric(_)up(_)"
  block_savedest(obj873);
  Object closure917 = createclosure(1, "visitGeneric(1)up(1)");
  setclosureframe(closure917, stackframe);
  addtoclosure(closure917, var_visitation);
  struct UserObject *uo917 = (struct UserObject*)obj873;
  uo917->data[15] = (Object)closure917;
  Method *meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_917 = addmethod2pos(obj873, "visitGeneric(1)up(1)", &meth_ast_visitGeneric_40_1_41_up_40_1_41_917, 15);
  int argcv_meth_ast_visitGeneric_40_1_41_up_40_1_41_917[] = {1, 1};
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_917->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40_1_41_up_40_1_41_917);
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_917->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40_1_41_up_40_1_41_917->definitionLine = 2943;
// method "visitIdentifier(_)up(_)"
  block_savedest(obj873);
  Object closure920 = createclosure(1, "visitIdentifier(1)up(1)");
  setclosureframe(closure920, stackframe);
  addtoclosure(closure920, var_visitation);
  struct UserObject *uo920 = (struct UserObject*)obj873;
  uo920->data[16] = (Object)closure920;
  Method *meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_920 = addmethod2pos(obj873, "visitIdentifier(1)up(1)", &meth_ast_visitIdentifier_40_1_41_up_40_1_41_920, 16);
  int argcv_meth_ast_visitIdentifier_40_1_41_up_40_1_41_920[] = {1, 1};
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_920->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40_1_41_up_40_1_41_920);
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_920->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40_1_41_up_40_1_41_920->definitionLine = 2944;
// method "visitString(_)up(_)"
  block_savedest(obj873);
  Object closure923 = createclosure(1, "visitString(1)up(1)");
  setclosureframe(closure923, stackframe);
  addtoclosure(closure923, var_visitation);
  struct UserObject *uo923 = (struct UserObject*)obj873;
  uo923->data[17] = (Object)closure923;
  Method *meth_meth_ast_visitString_40_1_41_up_40_1_41_923 = addmethod2pos(obj873, "visitString(1)up(1)", &meth_ast_visitString_40_1_41_up_40_1_41_923, 17);
  int argcv_meth_ast_visitString_40_1_41_up_40_1_41_923[] = {1, 1};
  meth_meth_ast_visitString_40_1_41_up_40_1_41_923->type = alloc_MethodType(2, argcv_meth_ast_visitString_40_1_41_up_40_1_41_923);
  meth_meth_ast_visitString_40_1_41_up_40_1_41_923->definitionModule = modulename;
  meth_meth_ast_visitString_40_1_41_up_40_1_41_923->definitionLine = 2945;
// method "visitNum(_)up(_)"
  block_savedest(obj873);
  Object closure926 = createclosure(1, "visitNum(1)up(1)");
  setclosureframe(closure926, stackframe);
  addtoclosure(closure926, var_visitation);
  struct UserObject *uo926 = (struct UserObject*)obj873;
  uo926->data[18] = (Object)closure926;
  Method *meth_meth_ast_visitNum_40_1_41_up_40_1_41_926 = addmethod2pos(obj873, "visitNum(1)up(1)", &meth_ast_visitNum_40_1_41_up_40_1_41_926, 18);
  int argcv_meth_ast_visitNum_40_1_41_up_40_1_41_926[] = {1, 1};
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_926->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40_1_41_up_40_1_41_926);
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_926->definitionModule = modulename;
  meth_meth_ast_visitNum_40_1_41_up_40_1_41_926->definitionLine = 2946;
// method "visitOp(_)up(_)"
  block_savedest(obj873);
  Object closure929 = createclosure(1, "visitOp(1)up(1)");
  setclosureframe(closure929, stackframe);
  addtoclosure(closure929, var_visitation);
  struct UserObject *uo929 = (struct UserObject*)obj873;
  uo929->data[19] = (Object)closure929;
  Method *meth_meth_ast_visitOp_40_1_41_up_40_1_41_929 = addmethod2pos(obj873, "visitOp(1)up(1)", &meth_ast_visitOp_40_1_41_up_40_1_41_929, 19);
  int argcv_meth_ast_visitOp_40_1_41_up_40_1_41_929[] = {1, 1};
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_929->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40_1_41_up_40_1_41_929);
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_929->definitionModule = modulename;
  meth_meth_ast_visitOp_40_1_41_up_40_1_41_929->definitionLine = 2947;
// method "visitBind(_)up(_)"
  block_savedest(obj873);
  Object closure932 = createclosure(1, "visitBind(1)up(1)");
  setclosureframe(closure932, stackframe);
  addtoclosure(closure932, var_visitation);
  struct UserObject *uo932 = (struct UserObject*)obj873;
  uo932->data[20] = (Object)closure932;
  Method *meth_meth_ast_visitBind_40_1_41_up_40_1_41_932 = addmethod2pos(obj873, "visitBind(1)up(1)", &meth_ast_visitBind_40_1_41_up_40_1_41_932, 20);
  int argcv_meth_ast_visitBind_40_1_41_up_40_1_41_932[] = {1, 1};
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_932->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40_1_41_up_40_1_41_932);
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_932->definitionModule = modulename;
  meth_meth_ast_visitBind_40_1_41_up_40_1_41_932->definitionLine = 2948;
// method "visitDefDec(_)up(_)"
  block_savedest(obj873);
  Object closure935 = createclosure(1, "visitDefDec(1)up(1)");
  setclosureframe(closure935, stackframe);
  addtoclosure(closure935, var_visitation);
  struct UserObject *uo935 = (struct UserObject*)obj873;
  uo935->data[21] = (Object)closure935;
  Method *meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_935 = addmethod2pos(obj873, "visitDefDec(1)up(1)", &meth_ast_visitDefDec_40_1_41_up_40_1_41_935, 21);
  int argcv_meth_ast_visitDefDec_40_1_41_up_40_1_41_935[] = {1, 1};
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_935->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40_1_41_up_40_1_41_935);
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_935->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40_1_41_up_40_1_41_935->definitionLine = 2949;
// method "visitVarDec(_)up(_)"
  block_savedest(obj873);
  Object closure938 = createclosure(1, "visitVarDec(1)up(1)");
  setclosureframe(closure938, stackframe);
  addtoclosure(closure938, var_visitation);
  struct UserObject *uo938 = (struct UserObject*)obj873;
  uo938->data[22] = (Object)closure938;
  Method *meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_938 = addmethod2pos(obj873, "visitVarDec(1)up(1)", &meth_ast_visitVarDec_40_1_41_up_40_1_41_938, 22);
  int argcv_meth_ast_visitVarDec_40_1_41_up_40_1_41_938[] = {1, 1};
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_938->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40_1_41_up_40_1_41_938);
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_938->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40_1_41_up_40_1_41_938->definitionLine = 2950;
// method "visitImport(_)up(_)"
  block_savedest(obj873);
  Object closure941 = createclosure(1, "visitImport(1)up(1)");
  setclosureframe(closure941, stackframe);
  addtoclosure(closure941, var_visitation);
  struct UserObject *uo941 = (struct UserObject*)obj873;
  uo941->data[23] = (Object)closure941;
  Method *meth_meth_ast_visitImport_40_1_41_up_40_1_41_941 = addmethod2pos(obj873, "visitImport(1)up(1)", &meth_ast_visitImport_40_1_41_up_40_1_41_941, 23);
  int argcv_meth_ast_visitImport_40_1_41_up_40_1_41_941[] = {1, 1};
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_941->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40_1_41_up_40_1_41_941);
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_941->definitionModule = modulename;
  meth_meth_ast_visitImport_40_1_41_up_40_1_41_941->definitionLine = 2951;
// method "visitReturn(_)up(_)"
  block_savedest(obj873);
  Object closure944 = createclosure(1, "visitReturn(1)up(1)");
  setclosureframe(closure944, stackframe);
  addtoclosure(closure944, var_visitation);
  struct UserObject *uo944 = (struct UserObject*)obj873;
  uo944->data[24] = (Object)closure944;
  Method *meth_meth_ast_visitReturn_40_1_41_up_40_1_41_944 = addmethod2pos(obj873, "visitReturn(1)up(1)", &meth_ast_visitReturn_40_1_41_up_40_1_41_944, 24);
  int argcv_meth_ast_visitReturn_40_1_41_up_40_1_41_944[] = {1, 1};
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_944->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40_1_41_up_40_1_41_944);
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_944->definitionModule = modulename;
  meth_meth_ast_visitReturn_40_1_41_up_40_1_41_944->definitionLine = 2952;
// method "visitInherits(_)up(_)"
  block_savedest(obj873);
  Object closure947 = createclosure(1, "visitInherits(1)up(1)");
  setclosureframe(closure947, stackframe);
  addtoclosure(closure947, var_visitation);
  struct UserObject *uo947 = (struct UserObject*)obj873;
  uo947->data[25] = (Object)closure947;
  Method *meth_meth_ast_visitInherits_40_1_41_up_40_1_41_947 = addmethod2pos(obj873, "visitInherits(1)up(1)", &meth_ast_visitInherits_40_1_41_up_40_1_41_947, 25);
  int argcv_meth_ast_visitInherits_40_1_41_up_40_1_41_947[] = {1, 1};
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_947->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40_1_41_up_40_1_41_947);
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_947->definitionModule = modulename;
  meth_meth_ast_visitInherits_40_1_41_up_40_1_41_947->definitionLine = 2953;
// method "visitDialect(_)up(_)"
  block_savedest(obj873);
  Object closure950 = createclosure(1, "visitDialect(1)up(1)");
  setclosureframe(closure950, stackframe);
  addtoclosure(closure950, var_visitation);
  struct UserObject *uo950 = (struct UserObject*)obj873;
  uo950->data[26] = (Object)closure950;
  Method *meth_meth_ast_visitDialect_40_1_41_up_40_1_41_950 = addmethod2pos(obj873, "visitDialect(1)up(1)", &meth_ast_visitDialect_40_1_41_up_40_1_41_950, 26);
  int argcv_meth_ast_visitDialect_40_1_41_up_40_1_41_950[] = {1, 1};
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_950->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40_1_41_up_40_1_41_950);
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_950->definitionModule = modulename;
  meth_meth_ast_visitDialect_40_1_41_up_40_1_41_950->definitionLine = 2954;
// method "visitBlank(_)up(_)"
  block_savedest(obj873);
  Object closure953 = createclosure(1, "visitBlank(1)up(1)");
  setclosureframe(closure953, stackframe);
  addtoclosure(closure953, var_visitation);
  struct UserObject *uo953 = (struct UserObject*)obj873;
  uo953->data[27] = (Object)closure953;
  Method *meth_meth_ast_visitBlank_40_1_41_up_40_1_41_953 = addmethod2pos(obj873, "visitBlank(1)up(1)", &meth_ast_visitBlank_40_1_41_up_40_1_41_953, 27);
  int argcv_meth_ast_visitBlank_40_1_41_up_40_1_41_953[] = {1, 1};
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_953->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40_1_41_up_40_1_41_953);
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_953->definitionModule = modulename;
  meth_meth_ast_visitBlank_40_1_41_up_40_1_41_953->definitionLine = 2955;
// method "visitComment(_)up(_)"
  block_savedest(obj873);
  Object closure956 = createclosure(1, "visitComment(1)up(1)");
  setclosureframe(closure956, stackframe);
  addtoclosure(closure956, var_visitation);
  struct UserObject *uo956 = (struct UserObject*)obj873;
  uo956->data[28] = (Object)closure956;
  Method *meth_meth_ast_visitComment_40_1_41_up_40_1_41_956 = addmethod2pos(obj873, "visitComment(1)up(1)", &meth_ast_visitComment_40_1_41_up_40_1_41_956, 28);
  int argcv_meth_ast_visitComment_40_1_41_up_40_1_41_956[] = {1, 1};
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_956->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40_1_41_up_40_1_41_956);
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_956->definitionModule = modulename;
  meth_meth_ast_visitComment_40_1_41_up_40_1_41_956->definitionLine = 2956;
// method "visitImplicit(_)up(_)"
  block_savedest(obj873);
  Object closure959 = createclosure(1, "visitImplicit(1)up(1)");
  setclosureframe(closure959, stackframe);
  addtoclosure(closure959, var_visitation);
  struct UserObject *uo959 = (struct UserObject*)obj873;
  uo959->data[29] = (Object)closure959;
  Method *meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_959 = addmethod2pos(obj873, "visitImplicit(1)up(1)", &meth_ast_visitImplicit_40_1_41_up_40_1_41_959, 29);
  int argcv_meth_ast_visitImplicit_40_1_41_up_40_1_41_959[] = {1, 1};
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_959->type = alloc_MethodType(2, argcv_meth_ast_visitImplicit_40_1_41_up_40_1_41_959);
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_959->definitionModule = modulename;
  meth_meth_ast_visitImplicit_40_1_41_up_40_1_41_959->definitionLine = 2957;
// method "asString"
  struct UserObject *uo962 = (struct UserObject*)obj873;
  uo962->data[30] = emptyclosure;
  Method *meth_meth_ast_asString962 = addmethod2pos(obj873, "asString", &meth_ast_asString962, 30);
  int argcv_meth_ast_asString962[] = {0};
  meth_meth_ast_asString962->type = alloc_MethodType(1, argcv_meth_ast_asString962);
  meth_meth_ast_asString962->definitionModule = modulename;
  meth_meth_ast_asString962->definitionLine = 2959;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  sourceObject = obj873;
  objclass873 = obj873->class;
  objclass873->definitionModule = modulename;
  objclass873->definitionLine = 2922;
  (*(struct UserObject *)self).data[0] = lowerouter873;
  self = oldself873;
  selfslot = oldselfslot873;
  stackframe = oldstackframe873;
  gc_frame_end(frame);
  return obj873;
}
Object meth_ast__apply974(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_annName = getfromclosure(closure, 0);
  Object *var_ann = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2974
  setline(2974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_annName (depth = 8)
  int op_slot_right_975 = gc_frame_newslot(*var_annName);
// starting to compile member node (depth = 8)
  int callframe977 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ann (depth = 9)
  Object call978 = callmethodflags(*var_ann, "value", 0, partcv, params, 0);
  gc_frame_end(callframe977);
// compiled member node returning call978 (depth = 8)
  int op_slot_left_975 = gc_frame_newslot(call978);
  params[0] = *var_annName;
  partcv[0] = 1;
  Object opresult979 = callmethod(call978, "==(1)", 1, partcv, params);
// compiled op node returning opresult979 (depth = 7)
  gc_frame_end(frame);
  return opresult979;
}
Object meth_ast__apply_40_1_41_970(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_annName = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2973
  setline(2973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block973 = alloc_Block(NULL, NULL, "ast", 2973);
  gc_frame_newslot(block973);
// method "_apply"
  block_savedest(block973);
  Object closure974 = createclosure(3, "_apply");
  setclosureframe(closure974, stackframe);
  addtoclosure(closure974, var_annName);
  addtoclosure(closure974, var_ann);
  addtoclosure(closure974, selfslot);
  struct UserObject *uo974 = (struct UserObject*)block973;
  uo974->data[0] = (Object)closure974;
  Method *meth_meth_ast__apply974 = addmethod2pos(block973, "_apply", &meth_ast__apply974, 0);
  int argcv_meth_ast__apply974[] = {0};
  meth_meth_ast__apply974->type = alloc_MethodType(1, argcv_meth_ast__apply974);
  meth_meth_ast__apply974->definitionModule = modulename;
  meth_meth_ast__apply974->definitionLine = 2981;
// compiled block node returning block973 (depth = 6)
  int op_slot_right_972 = gc_frame_newslot(block973);
// Begin line 2973
  setline(2973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit983 == NULL) {
    strlit983 = alloc_String("identifier");
    gc_root(strlit983);
  }
// compiled string node returning strlit983 (depth = 7)
  int op_slot_right_982 = gc_frame_newslot(strlit983);
// starting to compile member node (depth = 7)
  int callframe985 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ann (depth = 8)
  Object call986 = callmethodflags(*var_ann, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe985);
// compiled member node returning call986 (depth = 7)
  int op_slot_left_982 = gc_frame_newslot(call986);
  params[0] = strlit983;
  partcv[0] = 1;
  Object opresult987 = callmethod(call986, "==(1)", 1, partcv, params);
// compiled op node returning opresult987 (depth = 6)
  int op_slot_left_972 = gc_frame_newslot(opresult987);
  params[0] = block973;
  partcv[0] = 1;
  Object opresult988 = callmethod(opresult987, "&&(1)", 1, partcv, params);
// compiled op node returning opresult988 (depth = 5)
  Object if971 = done;
  if (istrue(opresult988)) {
// Begin line 2975
  setline(2975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile object node (depth = 6)
  Object inheritingObject989 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj989 = alloc_userobj2(1,2, objclass989);
  gc_frame_newslot(obj989);
// OBJECT OUTER DEC outer
  adddatum2(obj989, self, 0);
  addmethodreal(obj989,"outer", &reader_ast_outer_990);
  Object oldself989 = self;
  struct StackFrameObject *oldstackframe989 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe989);
  gc_frame_newslot((Object)stackframe);
  self = obj989;
  Object *oldselfslot989 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter989 = (*(struct UserObject *)self).data[0], lowerouter989 = thisouter989;
  if (inheritingObject989) {
    struct UserObject *inho989 = (struct UserObject *)inheritingObject989;
    while (inho989->super != GraceDefaultObject) inho989 = (struct UserObject *)inho989->super;
    inho989->super = obj989;
    self = inheritingObject989;
    *selfslot = self;
    lowerouter989 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter989;
  }
if (objclass989 == NULL) {
  Method *reader991 = addmethodrealflags(obj989, "value",&reader_ast_value_991, MFLAG_DEF);
  reader991->definitionModule = modulename;
  reader991->definitionLine = 2977;
}
adddatum2(obj989, alloc_Undefined(), 1);
  sourceObject = obj989;
// Begin line 2976
  setline(2976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool992 = alloc_Boolean(1);
// compiled identifier node returning bool992 (depth = 7)
  struct UserObject *obj989_uo = (struct UserObject *)obj989;
  obj989_uo->super = bool992;
  sourceObject = obj989;
// Begin line 2977
  setline(2977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  adddatum2(obj989, *var_ann, 1);
  objclass989 = obj989->class;
  objclass989->definitionModule = modulename;
  objclass989->definitionLine = 2975;
  (*(struct UserObject *)self).data[0] = lowerouter989;
  self = oldself989;
  selfslot = oldselfslot989;
  stackframe = oldstackframe989;
// compiled object node returning obj989 (depth = 6)
  block_return(realself, obj989);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if971 = undefined;
  } else {
  }
// compiled if node returning if971 (depth = 4)
  gc_frame_end(frame);
  return if971;
}
Object meth_ast_findAnnotation_40_2_41_965(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "findAnnotation(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method findAnnotation(_,_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findAnnotation(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  Object *var_annName = &(stackframe->slots[1]);
  *var_annName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part findAnnotation(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2972
  setline(2972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe966 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe967 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_node (depth = 4)
  Object call968 = callmethodflags(*var_node, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe967);
// compiled member node returning call968 (depth = 3)
  gc_frame_newslot(call968);
// starting to compile block node (depth = 3)
  Object block969 = alloc_Block(NULL, NULL, "ast", 2972);
  gc_frame_newslot(block969);
// method "_apply(_)"
  block_savedest(block969);
  Object closure970 = createclosure(2, "_apply(1)");
  setclosureframe(closure970, stackframe);
  addtoclosure(closure970, var_annName);
  addtoclosure(closure970, selfslot);
  struct UserObject *uo970 = (struct UserObject*)block969;
  uo970->data[0] = (Object)closure970;
  Method *meth_meth_ast__apply_40_1_41_970 = addmethod2pos(block969, "_apply(1)", &meth_ast__apply_40_1_41_970, 0);
  int argcv_meth_ast__apply_40_1_41_970[] = {1};
  meth_meth_ast__apply_40_1_41_970->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_970);
  meth_meth_ast__apply_40_1_41_970->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_970->definitionLine = 2981;
// compiled block node returning block969 (depth = 3)
  gc_frame_newslot(block969);
// call case 5: prelude request
  params[0] = call968;
  params[1] = block969;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call994 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe966);
// compiled call node returning call994 (depth = 2)
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool995 = alloc_Boolean(0);
// compiled identifier node returning bool995 (depth = 2)
  gc_frame_end(frame);
  return bool995;
}
Object meth_ast_lineLength997(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lineLength");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lineLength = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lineLength (depth = 3)
  gc_frame_end(frame);
  return *var_lineLength;
}
Object meth_ast_uninitialized1003(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "uninitialized");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_uninitialized = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_uninitialized (depth = 3)
  gc_frame_end(frame);
  return *var_uninitialized;
}
Object meth_ast_isEmpty1009(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1010 = alloc_Boolean(1);
// compiled identifier node returning bool1010 (depth = 3)
  gc_frame_end(frame);
  return bool1010;
}
Object meth_ast_asString1011(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1012 == NULL) {
    strlit1012 = alloc_String("ancestorChain ""\xe2""""\x96""""\xab""");
    gc_root(strlit1012);
  }
// compiled string node returning strlit1012 (depth = 3)
  gc_frame_end(frame);
  return strlit1012;
}
Object meth_ast_extend_40_1_41_1013(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extend(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extend(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extend(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part extend(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1014 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1015 = gc_frame_new();
// call case 3: self.outer request
  Object call1016 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1015);
// compiled member node returning call1016 (depth = 4)
  params[0] = *var_n;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1017 = callmethodflags(call1016, "cons(1)onto(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1014);
// compiled call node returning call1017 (depth = 3)
  gc_frame_end(frame);
  return call1017;
}
Object meth_ast_empty1006(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1007 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1007 = alloc_userobj2(3,4, objclass1007);
  gc_frame_newslot(obj1007);
if (objclass1007 == NULL) {
  glfree(obj1007->class->name);
  obj1007->class->name = "ancestorChain.empty";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1007, self, 0);
  addmethodreal(obj1007,"outer", &reader_ast_outer_1008);
  Object oldself1007 = self;
  struct StackFrameObject *oldstackframe1007 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1007);
  gc_frame_newslot((Object)stackframe);
  self = obj1007;
  Object *oldselfslot1007 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1007 = (*(struct UserObject *)self).data[0], lowerouter1007 = thisouter1007;
  if (inheritingObject1007) {
    struct UserObject *inho1007 = (struct UserObject *)inheritingObject1007;
    while (inho1007->super != GraceDefaultObject) inho1007 = (struct UserObject *)inho1007->super;
    inho1007->super = obj1007;
    self = inheritingObject1007;
    *selfslot = self;
    lowerouter1007 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1007;
  }
// method "isEmpty"
  struct UserObject *uo1009 = (struct UserObject*)obj1007;
  uo1009->data[1] = emptyclosure;
  Method *meth_meth_ast_isEmpty1009 = addmethod2pos(obj1007, "isEmpty", &meth_ast_isEmpty1009, 1);
  int argcv_meth_ast_isEmpty1009[] = {0};
  meth_meth_ast_isEmpty1009->type = alloc_MethodType(1, argcv_meth_ast_isEmpty1009);
  meth_meth_ast_isEmpty1009->definitionModule = modulename;
  meth_meth_ast_isEmpty1009->definitionLine = 41;
// method "asString"
  struct UserObject *uo1011 = (struct UserObject*)obj1007;
  uo1011->data[2] = emptyclosure;
  Method *meth_meth_ast_asString1011 = addmethod2pos(obj1007, "asString", &meth_ast_asString1011, 2);
  int argcv_meth_ast_asString1011[] = {0};
  meth_meth_ast_asString1011->type = alloc_MethodType(1, argcv_meth_ast_asString1011);
  meth_meth_ast_asString1011->definitionModule = modulename;
  meth_meth_ast_asString1011->definitionLine = 42;
// method "extend(_)"
  struct UserObject *uo1013 = (struct UserObject*)obj1007;
  uo1013->data[3] = emptyclosure;
  Method *meth_meth_ast_extend_40_1_41_1013 = addmethod2pos(obj1007, "extend(1)", &meth_ast_extend_40_1_41_1013, 3);
  int argcv_meth_ast_extend_40_1_41_1013[] = {1};
  meth_meth_ast_extend_40_1_41_1013->type = alloc_MethodType(1, argcv_meth_ast_extend_40_1_41_1013);
  meth_meth_ast_extend_40_1_41_1013->definitionModule = modulename;
  meth_meth_ast_extend_40_1_41_1013->definitionLine = 43;
  sourceObject = obj1007;
  sourceObject = obj1007;
  sourceObject = obj1007;
  objclass1007 = obj1007->class;
  objclass1007->definitionModule = modulename;
  objclass1007->definitionLine = 40;
  (*(struct UserObject *)self).data[0] = lowerouter1007;
  self = oldself1007;
  selfslot = oldselfslot1007;
  stackframe = oldstackframe1007;
  gc_frame_end(frame);
  return obj1007;
}
Object meth_ast_empty1006_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "empty$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1007 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1007 = alloc_userobj2(3,4, objclass1007);
  gc_frame_newslot(obj1007);
if (objclass1007 == NULL) {
  glfree(obj1007->class->name);
  obj1007->class->name = "ancestorChain.empty";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1007, self, 0);
  addmethodreal(obj1007,"outer", &reader_ast_outer_1008);
  Object oldself1007 = self;
  struct StackFrameObject *oldstackframe1007 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1007);
  gc_frame_newslot((Object)stackframe);
  self = obj1007;
  Object *oldselfslot1007 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1007 = (*(struct UserObject *)self).data[0], lowerouter1007 = thisouter1007;
  if (inheritingObject1007) {
    struct UserObject *inho1007 = (struct UserObject *)inheritingObject1007;
    while (inho1007->super != GraceDefaultObject) inho1007 = (struct UserObject *)inho1007->super;
    inho1007->super = obj1007;
    self = inheritingObject1007;
    *selfslot = self;
    lowerouter1007 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1007;
  }
// method "isEmpty"
  struct UserObject *uo1009 = (struct UserObject*)obj1007;
  uo1009->data[1] = emptyclosure;
  Method *meth_meth_ast_isEmpty1009 = addmethod2pos(obj1007, "isEmpty", &meth_ast_isEmpty1009, 1);
  int argcv_meth_ast_isEmpty1009[] = {0};
  meth_meth_ast_isEmpty1009->type = alloc_MethodType(1, argcv_meth_ast_isEmpty1009);
  meth_meth_ast_isEmpty1009->definitionModule = modulename;
  meth_meth_ast_isEmpty1009->definitionLine = 41;
// method "asString"
  struct UserObject *uo1011 = (struct UserObject*)obj1007;
  uo1011->data[2] = emptyclosure;
  Method *meth_meth_ast_asString1011 = addmethod2pos(obj1007, "asString", &meth_ast_asString1011, 2);
  int argcv_meth_ast_asString1011[] = {0};
  meth_meth_ast_asString1011->type = alloc_MethodType(1, argcv_meth_ast_asString1011);
  meth_meth_ast_asString1011->definitionModule = modulename;
  meth_meth_ast_asString1011->definitionLine = 42;
// method "extend(_)"
  struct UserObject *uo1013 = (struct UserObject*)obj1007;
  uo1013->data[3] = emptyclosure;
  Method *meth_meth_ast_extend_40_1_41_1013 = addmethod2pos(obj1007, "extend(1)", &meth_ast_extend_40_1_41_1013, 3);
  int argcv_meth_ast_extend_40_1_41_1013[] = {1};
  meth_meth_ast_extend_40_1_41_1013->type = alloc_MethodType(1, argcv_meth_ast_extend_40_1_41_1013);
  meth_meth_ast_extend_40_1_41_1013->definitionModule = modulename;
  meth_meth_ast_extend_40_1_41_1013->definitionLine = 43;
  sourceObject = obj1007;
  sourceObject = obj1007;
  sourceObject = obj1007;
  objclass1007 = obj1007->class;
  objclass1007->definitionModule = modulename;
  objclass1007->definitionLine = 40;
  (*(struct UserObject *)self).data[0] = lowerouter1007;
  self = oldself1007;
  selfslot = oldselfslot1007;
  stackframe = oldstackframe1007;
  gc_frame_end(frame);
  return obj1007;
}
Object meth_ast_with_40_1_41_1019(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "with(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method with(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for with(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part with(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1020 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1021 = gc_frame_new();
// call case 4: self request
  Object call1022 = callmethodflags(self, "empty", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1021);
// compiled member node returning call1022 (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1023 = callmethodflags(call1022, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1020);
// compiled call node returning call1023 (depth = 3)
  gc_frame_end(frame);
  return call1023;
}
Object meth_ast_forebears1027(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "forebears");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_as = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_end(frame);
  return *var_as;
}
Object meth_ast_isEmpty1028(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1029 = alloc_Boolean(0);
// compiled identifier node returning bool1029 (depth = 3)
  gc_frame_end(frame);
  return bool1029;
}
Object meth_ast_parent1030(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_p = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_p (depth = 3)
  gc_frame_end(frame);
  return *var_p;
}
Object meth_ast_grandparent1031(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "grandparent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1032 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1033 = gc_frame_new();
// call case 4: self request
  Object call1034 = callmethodflags(self, "forebears", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1033);
// compiled member node returning call1034 (depth = 4)
  Object call1035 = callmethodflags(call1034, "parent", 0, partcv, params, 0);
  gc_frame_end(callframe1032);
// compiled member node returning call1035 (depth = 3)
  gc_frame_end(frame);
  return call1035;
}
Object meth_ast__apply1040(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe1041 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1042 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call1043 = callmethodflags(*var_a, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe1042);
// compiled member node returning call1043 (depth = 6)
  Object call1044 = callmethodflags(call1043, "not", 0, partcv, params, 0);
  gc_frame_end(callframe1041);
// compiled member node returning call1044 (depth = 5)
  gc_frame_end(frame);
  return call1044;
}
Object meth_ast__apply1047(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1049 == NULL) {
    strlit1049 = alloc_String("""\xe2""""\x9e""""\xa4""");
    gc_root(strlit1049);
  }
// compiled string node returning strlit1049 (depth = 7)
  int op_slot_right_1048 = gc_frame_newslot(strlit1049);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1052 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  Object call1053 = callmethodflags(*var_a, "parent", 0, partcv, params, 0);
  gc_frame_end(callframe1052);
// compiled member node returning call1053 (depth = 8)
  int op_slot_right_1051 = gc_frame_newslot(call1053);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1051 = gc_frame_newslot(*var_s);
  params[0] = call1053;
  partcv[0] = 1;
  Object opresult1055 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1055 (depth = 7)
  int op_slot_left_1048 = gc_frame_newslot(opresult1055);
  params[0] = strlit1049;
  partcv[0] = 1;
  Object opresult1056 = callmethod(opresult1055, "++(1)", 1, partcv, params);
// compiled op node returning opresult1056 (depth = 6)
  *var_s = opresult1056;
  if (opresult1056 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1058 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call1059 = callmethodflags(*var_a, "forebears", 0, partcv, params, 0);
  gc_frame_end(callframe1058);
// compiled member node returning call1059 (depth = 6)
  *var_a = call1059;
  if (call1059 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_asString1036(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "a");
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  *var_a = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1037 == NULL) {
    strlit1037 = alloc_String("ancestorChain ");
    gc_root(strlit1037);
  }
// compiled string node returning strlit1037 (depth = 4)
  *var_s = strlit1037;
  if (strlit1037 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1038 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1039 = alloc_Block(NULL, NULL, "ast", 55);
  gc_frame_newslot(block1039);
// method "_apply"
  block_savedest(block1039);
  Object closure1040 = createclosure(2, "_apply");
  setclosureframe(closure1040, stackframe);
  addtoclosure(closure1040, var_a);
  addtoclosure(closure1040, selfslot);
  struct UserObject *uo1040 = (struct UserObject*)block1039;
  uo1040->data[0] = (Object)closure1040;
  Method *meth_meth_ast__apply1040 = addmethod2pos(block1039, "_apply", &meth_ast__apply1040, 0);
  int argcv_meth_ast__apply1040[] = {0};
  meth_meth_ast__apply1040->type = alloc_MethodType(1, argcv_meth_ast__apply1040);
  meth_meth_ast__apply1040->definitionModule = modulename;
  meth_meth_ast__apply1040->definitionLine = 2981;
// compiled block node returning block1039 (depth = 4)
  gc_frame_newslot(block1039);
// starting to compile block node (depth = 4)
  Object block1046 = alloc_Block(NULL, NULL, "ast", 55);
  gc_frame_newslot(block1046);
// method "_apply"
  block_savedest(block1046);
  Object closure1047 = createclosure(3, "_apply");
  setclosureframe(closure1047, stackframe);
  addtoclosure(closure1047, var_a);
  addtoclosure(closure1047, var_s);
  addtoclosure(closure1047, selfslot);
  struct UserObject *uo1047 = (struct UserObject*)block1046;
  uo1047->data[0] = (Object)closure1047;
  Method *meth_meth_ast__apply1047 = addmethod2pos(block1046, "_apply", &meth_ast__apply1047, 0);
  int argcv_meth_ast__apply1047[] = {0};
  meth_meth_ast__apply1047->type = alloc_MethodType(1, argcv_meth_ast__apply1047);
  meth_meth_ast__apply1047->definitionModule = modulename;
  meth_meth_ast__apply1047->definitionLine = 2981;
// compiled block node returning block1046 (depth = 4)
  gc_frame_newslot(block1046);
// call case 5: prelude request
  params[0] = block1039;
  params[1] = block1046;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1062 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1038);
// compiled call node returning call1062 (depth = 3)
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1064 == NULL) {
    strlit1064 = alloc_String("""\xe2""""\x96""""\xab""");
    gc_root(strlit1064);
  }
// compiled string node returning strlit1064 (depth = 4)
  int op_slot_right_1063 = gc_frame_newslot(strlit1064);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_1063 = gc_frame_newslot(*var_s);
  params[0] = strlit1064;
  partcv[0] = 1;
  Object opresult1066 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1066 (depth = 3)
  gc_frame_end(frame);
  return opresult1066;
}
Object meth_ast_extend_40_1_41_1067(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extend(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extend(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extend(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part extend(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1068 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1069 = gc_frame_new();
// call case 3: self.outer request
  Object call1070 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1069);
// compiled member node returning call1070 (depth = 4)
  params[0] = *var_n;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1071 = callmethodflags(call1070, "cons(1)onto(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1068);
// compiled call node returning call1071 (depth = 3)
  gc_frame_end(frame);
  return call1071;
}
Object meth_ast_cons_40_1_41_onto_40_1_41_1024(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "cons(1)onto(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method cons(_)onto(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method cons(_)onto(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for cons(_)onto(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part cons(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onto(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1025 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1025 = alloc_userobj2(6,7, objclass1025);
  gc_frame_newslot(obj1025);
if (objclass1025 == NULL) {
  glfree(obj1025->class->name);
  obj1025->class->name = "ancestorChain.cons(_)onto(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1025, self, 0);
  addmethodreal(obj1025,"outer", &reader_ast_outer_1026);
  Object oldself1025 = self;
  struct StackFrameObject *oldstackframe1025 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1025);
  gc_frame_newslot((Object)stackframe);
  self = obj1025;
  Object *oldselfslot1025 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1025 = (*(struct UserObject *)self).data[0], lowerouter1025 = thisouter1025;
  if (inheritingObject1025) {
    struct UserObject *inho1025 = (struct UserObject *)inheritingObject1025;
    while (inho1025->super != GraceDefaultObject) inho1025 = (struct UserObject *)inho1025->super;
    inho1025->super = obj1025;
    self = inheritingObject1025;
    *selfslot = self;
    lowerouter1025 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1025;
  }
// method "forebears"
  block_savedest(obj1025);
  Object closure1027 = createclosure(1, "forebears");
  setclosureframe(closure1027, stackframe);
  addtoclosure(closure1027, var_as);
  struct UserObject *uo1027 = (struct UserObject*)obj1025;
  uo1027->data[1] = (Object)closure1027;
  Method *meth_meth_ast_forebears1027 = addmethod2pos(obj1025, "forebears", &meth_ast_forebears1027, 1);
  int argcv_meth_ast_forebears1027[] = {0};
  meth_meth_ast_forebears1027->type = alloc_MethodType(1, argcv_meth_ast_forebears1027);
  meth_meth_ast_forebears1027->definitionModule = modulename;
  meth_meth_ast_forebears1027->definitionLine = 47;
// method "isEmpty"
  struct UserObject *uo1028 = (struct UserObject*)obj1025;
  uo1028->data[2] = emptyclosure;
  Method *meth_meth_ast_isEmpty1028 = addmethod2pos(obj1025, "isEmpty", &meth_ast_isEmpty1028, 2);
  int argcv_meth_ast_isEmpty1028[] = {0};
  meth_meth_ast_isEmpty1028->type = alloc_MethodType(1, argcv_meth_ast_isEmpty1028);
  meth_meth_ast_isEmpty1028->definitionModule = modulename;
  meth_meth_ast_isEmpty1028->definitionLine = 48;
// method "parent"
  block_savedest(obj1025);
  Object closure1030 = createclosure(1, "parent");
  setclosureframe(closure1030, stackframe);
  addtoclosure(closure1030, var_p);
  struct UserObject *uo1030 = (struct UserObject*)obj1025;
  uo1030->data[3] = (Object)closure1030;
  Method *meth_meth_ast_parent1030 = addmethod2pos(obj1025, "parent", &meth_ast_parent1030, 3);
  int argcv_meth_ast_parent1030[] = {0};
  meth_meth_ast_parent1030->type = alloc_MethodType(1, argcv_meth_ast_parent1030);
  meth_meth_ast_parent1030->definitionModule = modulename;
  meth_meth_ast_parent1030->definitionLine = 49;
// method "grandparent"
  struct UserObject *uo1031 = (struct UserObject*)obj1025;
  uo1031->data[4] = emptyclosure;
  Method *meth_meth_ast_grandparent1031 = addmethod2pos(obj1025, "grandparent", &meth_ast_grandparent1031, 4);
  int argcv_meth_ast_grandparent1031[] = {0};
  meth_meth_ast_grandparent1031->type = alloc_MethodType(1, argcv_meth_ast_grandparent1031);
  meth_meth_ast_grandparent1031->definitionModule = modulename;
  meth_meth_ast_grandparent1031->definitionLine = 50;
// method "asString"
  struct UserObject *uo1036 = (struct UserObject*)obj1025;
  uo1036->data[5] = emptyclosure;
  Method *meth_meth_ast_asString1036 = addmethod2pos(obj1025, "asString", &meth_ast_asString1036, 5);
  int argcv_meth_ast_asString1036[] = {0};
  meth_meth_ast_asString1036->type = alloc_MethodType(1, argcv_meth_ast_asString1036);
  meth_meth_ast_asString1036->definitionModule = modulename;
  meth_meth_ast_asString1036->definitionLine = 52;
// method "extend(_)"
  struct UserObject *uo1067 = (struct UserObject*)obj1025;
  uo1067->data[6] = emptyclosure;
  Method *meth_meth_ast_extend_40_1_41_1067 = addmethod2pos(obj1025, "extend(1)", &meth_ast_extend_40_1_41_1067, 6);
  int argcv_meth_ast_extend_40_1_41_1067[] = {1};
  meth_meth_ast_extend_40_1_41_1067->type = alloc_MethodType(1, argcv_meth_ast_extend_40_1_41_1067);
  meth_meth_ast_extend_40_1_41_1067->definitionModule = modulename;
  meth_meth_ast_extend_40_1_41_1067->definitionLine = 61;
  sourceObject = obj1025;
  sourceObject = obj1025;
  sourceObject = obj1025;
  sourceObject = obj1025;
  sourceObject = obj1025;
  sourceObject = obj1025;
  objclass1025 = obj1025->class;
  objclass1025->definitionModule = modulename;
  objclass1025->definitionLine = 46;
  (*(struct UserObject *)self).data[0] = lowerouter1025;
  self = oldself1025;
  selfslot = oldselfslot1025;
  stackframe = oldstackframe1025;
  gc_frame_end(frame);
  return obj1025;
}
Object meth_ast_cons_40_1_41_onto_40_1_41_1024_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "cons(1)onto(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method cons(_)onto(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method cons(_)onto(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for cons(_)onto(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part cons(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part onto(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1025 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1025 = alloc_userobj2(6,7, objclass1025);
  gc_frame_newslot(obj1025);
if (objclass1025 == NULL) {
  glfree(obj1025->class->name);
  obj1025->class->name = "ancestorChain.cons(_)onto(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1025, self, 0);
  addmethodreal(obj1025,"outer", &reader_ast_outer_1026);
  Object oldself1025 = self;
  struct StackFrameObject *oldstackframe1025 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1025);
  gc_frame_newslot((Object)stackframe);
  self = obj1025;
  Object *oldselfslot1025 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1025 = (*(struct UserObject *)self).data[0], lowerouter1025 = thisouter1025;
  if (inheritingObject1025) {
    struct UserObject *inho1025 = (struct UserObject *)inheritingObject1025;
    while (inho1025->super != GraceDefaultObject) inho1025 = (struct UserObject *)inho1025->super;
    inho1025->super = obj1025;
    self = inheritingObject1025;
    *selfslot = self;
    lowerouter1025 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1025;
  }
// method "forebears"
  block_savedest(obj1025);
  Object closure1027 = createclosure(1, "forebears");
  setclosureframe(closure1027, stackframe);
  addtoclosure(closure1027, var_as);
  struct UserObject *uo1027 = (struct UserObject*)obj1025;
  uo1027->data[1] = (Object)closure1027;
  Method *meth_meth_ast_forebears1027 = addmethod2pos(obj1025, "forebears", &meth_ast_forebears1027, 1);
  int argcv_meth_ast_forebears1027[] = {0};
  meth_meth_ast_forebears1027->type = alloc_MethodType(1, argcv_meth_ast_forebears1027);
  meth_meth_ast_forebears1027->definitionModule = modulename;
  meth_meth_ast_forebears1027->definitionLine = 47;
// method "isEmpty"
  struct UserObject *uo1028 = (struct UserObject*)obj1025;
  uo1028->data[2] = emptyclosure;
  Method *meth_meth_ast_isEmpty1028 = addmethod2pos(obj1025, "isEmpty", &meth_ast_isEmpty1028, 2);
  int argcv_meth_ast_isEmpty1028[] = {0};
  meth_meth_ast_isEmpty1028->type = alloc_MethodType(1, argcv_meth_ast_isEmpty1028);
  meth_meth_ast_isEmpty1028->definitionModule = modulename;
  meth_meth_ast_isEmpty1028->definitionLine = 48;
// method "parent"
  block_savedest(obj1025);
  Object closure1030 = createclosure(1, "parent");
  setclosureframe(closure1030, stackframe);
  addtoclosure(closure1030, var_p);
  struct UserObject *uo1030 = (struct UserObject*)obj1025;
  uo1030->data[3] = (Object)closure1030;
  Method *meth_meth_ast_parent1030 = addmethod2pos(obj1025, "parent", &meth_ast_parent1030, 3);
  int argcv_meth_ast_parent1030[] = {0};
  meth_meth_ast_parent1030->type = alloc_MethodType(1, argcv_meth_ast_parent1030);
  meth_meth_ast_parent1030->definitionModule = modulename;
  meth_meth_ast_parent1030->definitionLine = 49;
// method "grandparent"
  struct UserObject *uo1031 = (struct UserObject*)obj1025;
  uo1031->data[4] = emptyclosure;
  Method *meth_meth_ast_grandparent1031 = addmethod2pos(obj1025, "grandparent", &meth_ast_grandparent1031, 4);
  int argcv_meth_ast_grandparent1031[] = {0};
  meth_meth_ast_grandparent1031->type = alloc_MethodType(1, argcv_meth_ast_grandparent1031);
  meth_meth_ast_grandparent1031->definitionModule = modulename;
  meth_meth_ast_grandparent1031->definitionLine = 50;
// method "asString"
  struct UserObject *uo1036 = (struct UserObject*)obj1025;
  uo1036->data[5] = emptyclosure;
  Method *meth_meth_ast_asString1036 = addmethod2pos(obj1025, "asString", &meth_ast_asString1036, 5);
  int argcv_meth_ast_asString1036[] = {0};
  meth_meth_ast_asString1036->type = alloc_MethodType(1, argcv_meth_ast_asString1036);
  meth_meth_ast_asString1036->definitionModule = modulename;
  meth_meth_ast_asString1036->definitionLine = 52;
// method "extend(_)"
  struct UserObject *uo1067 = (struct UserObject*)obj1025;
  uo1067->data[6] = emptyclosure;
  Method *meth_meth_ast_extend_40_1_41_1067 = addmethod2pos(obj1025, "extend(1)", &meth_ast_extend_40_1_41_1067, 6);
  int argcv_meth_ast_extend_40_1_41_1067[] = {1};
  meth_meth_ast_extend_40_1_41_1067->type = alloc_MethodType(1, argcv_meth_ast_extend_40_1_41_1067);
  meth_meth_ast_extend_40_1_41_1067->definitionModule = modulename;
  meth_meth_ast_extend_40_1_41_1067->definitionLine = 61;
  sourceObject = obj1025;
  sourceObject = obj1025;
  sourceObject = obj1025;
  sourceObject = obj1025;
  sourceObject = obj1025;
  sourceObject = obj1025;
  objclass1025 = obj1025->class;
  objclass1025->definitionModule = modulename;
  objclass1025->definitionLine = 46;
  (*(struct UserObject *)self).data[0] = lowerouter1025;
  self = oldself1025;
  selfslot = oldselfslot1025;
  stackframe = oldstackframe1025;
  gc_frame_end(frame);
  return obj1025;
}
Object meth_ast_ancestorChain1073(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ancestorChain");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ancestorChain = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ancestorChain (depth = 3)
  gc_frame_end(frame);
  return *var_ancestorChain;
}
Object meth_ast_emptySeq1076(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "emptySeq");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySeq (depth = 3)
  gc_frame_end(frame);
  return *var_emptySeq;
}
Object meth_ast_AstNode1079(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "AstNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_AstNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_AstNode (depth = 3)
  gc_frame_end(frame);
  return *var_AstNode;
}
Object meth_ast_SymbolTable1081(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SymbolTable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SymbolTable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SymbolTable (depth = 3)
  gc_frame_end(frame);
  return *var_SymbolTable;
}
Object meth_ast_isImplicit1086(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isImplicit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1087 = alloc_Boolean(1);
// compiled identifier node returning bool1087 (depth = 3)
  gc_frame_end(frame);
  return bool1087;
}
Object meth_ast_toGrace_40_1_41_1088(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1089 == NULL) {
    strlit1089 = alloc_String("implicit");
    gc_root(strlit1089);
  }
// compiled string node returning strlit1089 (depth = 3)
  gc_frame_end(frame);
  return strlit1089;
}
Object meth_ast_asString1090(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1091 == NULL) {
    strlit1091 = alloc_String("the implicit receiver");
    gc_root(strlit1091);
  }
// compiled string node returning strlit1091 (depth = 3)
  gc_frame_end(frame);
  return strlit1091;
}
Object meth_ast__61__61__40_1_41_1092(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1093 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1094 = callmethodflags(self, "isMe(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1093);
// compiled call node returning call1094 (depth = 3)
  gc_frame_end(frame);
  return call1094;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_1095(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_accept_40_1_41_from_40_1_41_1096(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1097 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1098 = callmethodflags(*var_visitor, "visitImplicit(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1097);
// compiled call node returning call1098 (depth = 3)
  gc_frame_end(frame);
  return call1098;
}
Object meth_ast_pretty_40_1_41_1099(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1100 == NULL) {
    strlit1100 = alloc_String("implicit");
    gc_root(strlit1100);
  }
// compiled string node returning strlit1100 (depth = 3)
  gc_frame_end(frame);
  return strlit1100;
}
Object meth_ast_implicit1113(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "implicit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_implicit = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_implicit (depth = 3)
  gc_frame_end(frame);
  return *var_implicit;
}
Object meth_ast_toGrace_40_1_41_1117(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1118 == NULL) {
    strlit1118 = alloc_String("// null");
    gc_root(strlit1118);
  }
// compiled string node returning strlit1118 (depth = 3)
  gc_frame_end(frame);
  return strlit1118;
}
Object meth_ast_asString1119(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1120 == NULL) {
    strlit1120 = alloc_String("the nullNode");
    gc_root(strlit1120);
  }
// compiled string node returning strlit1120 (depth = 3)
  gc_frame_end(frame);
  return strlit1120;
}
Object meth_ast__61__61__40_1_41_1121(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1122 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1123 = callmethodflags(self, "isMe(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1122);
// compiled call node returning call1123 (depth = 3)
  gc_frame_end(frame);
  return call1123;
}
Object meth_ast_nullNode1129(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "nullNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_nullNode (depth = 3)
  gc_frame_end(frame);
  return *var_nullNode;
}
Object meth_ast_asString1133(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 235
  setline(235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1134 == NULL) {
    strlit1134 = alloc_String("the fakeSymbolTable");
    gc_root(strlit1134);
  }
// compiled string node returning strlit1134 (depth = 3)
  gc_frame_end(frame);
  return strlit1134;
}
Object meth_ast_addNode_40_1_41_as_40_1_41_1135(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addNode(1)as(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addNode(_)as(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addNode(_)as(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for addNode(_)as(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addNode(_)");
  Object *var_kind = &(stackframe->slots[1]);
  *var_kind = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part as(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1136 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1138 == NULL) {
    strlit1138 = alloc_String("""\x22"" requested");
    gc_root(strlit1138);
  }
// compiled string node returning strlit1138 (depth = 5)
  int op_slot_right_1137 = gc_frame_newslot(strlit1138);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_kind (depth = 6)
  int op_slot_right_1140 = gc_frame_newslot(*var_kind);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1143 == NULL) {
    strlit1143 = alloc_String(") as ""\x22""");
    gc_root(strlit1143);
  }
// compiled string node returning strlit1143 (depth = 7)
  int op_slot_right_1142 = gc_frame_newslot(strlit1143);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_right_1145 = gc_frame_newslot(*var_n);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1148 == NULL) {
    strlit1148 = alloc_String(").addNode(");
    gc_root(strlit1148);
  }
// compiled string node returning strlit1148 (depth = 9)
  int op_slot_right_1147 = gc_frame_newslot(strlit1148);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe1151 = gc_frame_new();
// call case 4: self request
  Object call1152 = callmethodflags(self, "node", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1151);
// compiled member node returning call1152 (depth = 10)
  int op_slot_right_1150 = gc_frame_newslot(call1152);
// starting to compile string node (depth = 10)
  if (strlit1154 == NULL) {
    strlit1154 = alloc_String("fakeSymbolTable(on node ");
    gc_root(strlit1154);
  }
// compiled string node returning strlit1154 (depth = 10)
  int op_slot_left_1150 = gc_frame_newslot(strlit1154);
  params[0] = call1152;
  partcv[0] = 1;
  Object opresult1155 = callmethod(strlit1154, "++(1)", 1, partcv, params);
// compiled op node returning opresult1155 (depth = 9)
  int op_slot_left_1147 = gc_frame_newslot(opresult1155);
  params[0] = strlit1148;
  partcv[0] = 1;
  Object opresult1156 = callmethod(opresult1155, "++(1)", 1, partcv, params);
// compiled op node returning opresult1156 (depth = 8)
  int op_slot_left_1145 = gc_frame_newslot(opresult1156);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult1157 = callmethod(opresult1156, "++(1)", 1, partcv, params);
// compiled op node returning opresult1157 (depth = 7)
  int op_slot_left_1142 = gc_frame_newslot(opresult1157);
  params[0] = strlit1143;
  partcv[0] = 1;
  Object opresult1158 = callmethod(opresult1157, "++(1)", 1, partcv, params);
// compiled op node returning opresult1158 (depth = 6)
  int op_slot_left_1140 = gc_frame_newslot(opresult1158);
  params[0] = *var_kind;
  partcv[0] = 1;
  Object opresult1159 = callmethod(opresult1158, "++(1)", 1, partcv, params);
// compiled op node returning opresult1159 (depth = 5)
  int op_slot_left_1137 = gc_frame_newslot(opresult1159);
  params[0] = strlit1138;
  partcv[0] = 1;
  Object opresult1160 = callmethod(opresult1159, "++(1)", 1, partcv, params);
// compiled op node returning opresult1160 (depth = 4)
  gc_frame_newslot(opresult1160);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1161 = gc_frame_new();
// call case 5: prelude request
  Object call1162 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1161);
// compiled member node returning call1162 (depth = 4)
  params[0] = opresult1160;
  partcv[0] = 1;
  Object call1163 = callmethodflags(call1162, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1136);
// compiled call node returning call1163 (depth = 3)
  gc_frame_end(frame);
  return call1163;
}
Object meth_ast_thatDefines_40_1_41_ifNone_40_1_41_1164(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "thatDefines(1)ifNone(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method thatDefines(_)ifNone(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method thatDefines(_)ifNone(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for thatDefines(_)ifNone(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part thatDefines(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifNone(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1165 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1167 == NULL) {
    strlit1167 = alloc_String(").");
    gc_root(strlit1167);
  }
// compiled string node returning strlit1167 (depth = 5)
  int op_slot_right_1166 = gc_frame_newslot(strlit1167);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_name (depth = 6)
  int op_slot_right_1169 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 6)
  if (strlit1171 == NULL) {
    strlit1171 = alloc_String("fakeSymbolTable.thatDefines(");
    gc_root(strlit1171);
  }
// compiled string node returning strlit1171 (depth = 6)
  int op_slot_left_1169 = gc_frame_newslot(strlit1171);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult1172 = callmethod(strlit1171, "++(1)", 1, partcv, params);
// compiled op node returning opresult1172 (depth = 5)
  int op_slot_left_1166 = gc_frame_newslot(opresult1172);
  params[0] = strlit1167;
  partcv[0] = 1;
  Object opresult1173 = callmethod(opresult1172, "++(1)", 1, partcv, params);
// compiled op node returning opresult1173 (depth = 4)
  gc_frame_newslot(opresult1173);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1174 = gc_frame_new();
// call case 5: prelude request
  Object call1175 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1174);
// compiled member node returning call1175 (depth = 4)
  params[0] = opresult1173;
  partcv[0] = 1;
  Object call1176 = callmethodflags(call1175, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1165);
// compiled call node returning call1176 (depth = 3)
  gc_frame_end(frame);
  return call1176;
}
Object meth_ast_enclosingObjectScope1177(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "enclosingObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1178 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1180 == NULL) {
    strlit1180 = alloc_String("");
    gc_root(strlit1180);
  }
// compiled string node returning strlit1180 (depth = 5)
  int op_slot_right_1179 = gc_frame_newslot(strlit1180);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1183 = gc_frame_new();
// call case 4: self request
  Object call1184 = callmethodflags(self, "node", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1183);
// compiled member node returning call1184 (depth = 6)
  int op_slot_right_1182 = gc_frame_newslot(call1184);
// starting to compile string node (depth = 6)
  if (strlit1186 == NULL) {
    strlit1186 = alloc_String("fakeSymbolTable.enclosingObjectScope on node ");
    gc_root(strlit1186);
  }
// compiled string node returning strlit1186 (depth = 6)
  int op_slot_left_1182 = gc_frame_newslot(strlit1186);
  params[0] = call1184;
  partcv[0] = 1;
  Object opresult1187 = callmethod(strlit1186, "++(1)", 1, partcv, params);
// compiled op node returning opresult1187 (depth = 5)
  int op_slot_left_1179 = gc_frame_newslot(opresult1187);
  params[0] = strlit1180;
  partcv[0] = 1;
  Object opresult1188 = callmethod(opresult1187, "++(1)", 1, partcv, params);
// compiled op node returning opresult1188 (depth = 4)
  gc_frame_newslot(opresult1188);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1189 = gc_frame_new();
// call case 5: prelude request
  Object call1190 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1189);
// compiled member node returning call1190 (depth = 4)
  params[0] = opresult1188;
  partcv[0] = 1;
  Object call1191 = callmethodflags(call1190, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1178);
// compiled call node returning call1191 (depth = 3)
  gc_frame_end(frame);
  return call1191;
}
Object meth_ast_variety1192(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "variety");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1193 == NULL) {
    strlit1193 = alloc_String("fake");
    gc_root(strlit1193);
  }
// compiled string node returning strlit1193 (depth = 3)
  gc_frame_end(frame);
  return strlit1193;
}
Object meth_ast__61__61__40_1_41_1194(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1195 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1196 = callmethodflags(self, "isMe(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1195);
// compiled call node returning call1196 (depth = 3)
  gc_frame_end(frame);
  return call1196;
}
Object meth_ast_fakeSymbolTable1197(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fakeSymbolTable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_fakeSymbolTable (depth = 3)
  gc_frame_end(frame);
  return *var_fakeSymbolTable;
}
Object meth_ast_isSimple1208(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1209 = alloc_Boolean(0);
// compiled identifier node returning bool1209 (depth = 3)
  gc_frame_end(frame);
  return bool1209;
}
Object meth_ast_accept_40_1_41_from_40_1_41_1210(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1212 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1213 = callmethodflags(*var_visitor, "visitIf(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1212);
// compiled call node returning call1213 (depth = 4)
  Object if1211 = done;
  if (istrue(call1213)) {
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1214 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call1215 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1214);
// compiled call node returning call1215 (depth = 5)
  *var_newChain = call1215;
  if (call1215 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1216 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1217 = gc_frame_new();
// call case 4: self request
  Object call1218 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1217);
// compiled member node returning call1218 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1219 = callmethodflags(call1218, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1216);
// compiled call node returning call1219 (depth = 4)
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1220 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1221 = gc_frame_new();
// call case 4: self request
  Object call1222 = callmethodflags(self, "thenblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1221);
// compiled member node returning call1222 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1223 = callmethodflags(call1222, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1220);
// compiled call node returning call1223 (depth = 4)
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1224 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1225 = gc_frame_new();
// call case 4: self request
  Object call1226 = callmethodflags(self, "elseblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1225);
// compiled member node returning call1226 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1227 = callmethodflags(call1226, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1224);
// compiled call node returning call1227 (depth = 4)
    gc_frame_newslot(call1227);
    if1211 = call1227;
  } else {
  }
// compiled if node returning if1211 (depth = 3)
  gc_frame_end(frame);
  return if1211;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_1228(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1229 = gc_frame_new();
// call case 4: self request
  Object call1230 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1229);
// compiled member node returning call1230 (depth = 4)
  *var_n = call1230;
  if (call1230 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1231 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1232 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1231);
// compiled call node returning call1232 (depth = 4)
  *var_newChain = call1232;
  if (call1232 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1233 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1234 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1235 = gc_frame_new();
// call case 4: self request
  Object call1236 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1235);
// compiled member node returning call1236 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1237 = callmethodflags(call1236, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1234);
// compiled call node returning call1237 (depth = 4)
  gc_frame_newslot(call1237);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1237;
  partcv[0] = 1;
  Object call1238 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1233);
// compiled call node returning call1238 (depth = 3)
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1239 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1240 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1241 = gc_frame_new();
// call case 4: self request
  Object call1242 = callmethodflags(self, "thenblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1241);
// compiled member node returning call1242 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1243 = callmethodflags(call1242, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1240);
// compiled call node returning call1243 (depth = 4)
  gc_frame_newslot(call1243);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1243;
  partcv[0] = 1;
  Object call1244 = callmethodflags(*var_n, "thenblock:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1239);
// compiled call node returning call1244 (depth = 3)
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1245 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1246 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1247 = gc_frame_new();
// call case 4: self request
  Object call1248 = callmethodflags(self, "elseblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1247);
// compiled member node returning call1248 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1249 = callmethodflags(call1248, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1246);
// compiled call node returning call1249 (depth = 4)
  gc_frame_newslot(call1249);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1249;
  partcv[0] = 1;
  Object call1250 = callmethodflags(*var_n, "elseblock:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1245);
// compiled call node returning call1250 (depth = 3)
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1251 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1252 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1251);
// compiled call node returning call1252 (depth = 3)
  gc_frame_end(frame);
  return call1252;
}
Object meth_ast__apply_40_1_41_1261(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1263 == NULL) {
    strlit1263 = alloc_String("  ");
    gc_root(strlit1263);
  }
// compiled string node returning strlit1263 (depth = 7)
  int op_slot_right_1262 = gc_frame_newslot(strlit1263);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_1262 = gc_frame_newslot(*var_spc);
  params[0] = strlit1263;
  partcv[0] = 1;
  Object opresult1265 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult1265 (depth = 6)
  *var_spc = opresult1265;
  if (opresult1265 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_1362(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1364 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1366 = alloc_Float64(2);
// compiled num node returning num1366 (depth = 10)
  int op_slot_right_1365 = gc_frame_newslot(num1366);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1365 = gc_frame_newslot(*var_depth);
  params[0] = num1366;
  partcv[0] = 1;
  Object sum1368 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1368 (depth = 9)
  gc_frame_newslot(sum1368);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  params[0] = sum1368;
  partcv[0] = 1;
  Object call1369 = callmethodflags(*var_ix, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1364);
// compiled call node returning call1369 (depth = 8)
  int op_slot_right_1363 = gc_frame_newslot(call1369);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1371 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1374 == NULL) {
    strlit1374 = alloc_String("""\x0a""  ");
    gc_root(strlit1374);
  }
// compiled string node returning strlit1374 (depth = 10)
  int op_slot_right_1373 = gc_frame_newslot(strlit1374);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1373 = gc_frame_newslot(*var_s);
  params[0] = strlit1374;
  partcv[0] = 1;
  Object opresult1376 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1376 (depth = 9)
  int op_slot_left_1371 = gc_frame_newslot(opresult1376);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1377 = callmethod(opresult1376, "++(1)", 1, partcv, params);
// compiled op node returning opresult1377 (depth = 8)
  int op_slot_left_1363 = gc_frame_newslot(opresult1377);
  params[0] = call1369;
  partcv[0] = 1;
  Object opresult1378 = callmethod(opresult1377, "++(1)", 1, partcv, params);
// compiled op node returning opresult1378 (depth = 7)
  *var_s = opresult1378;
  if (opresult1378 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_1401(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1403 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1405 = alloc_Float64(2);
// compiled num node returning num1405 (depth = 10)
  int op_slot_right_1404 = gc_frame_newslot(num1405);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1404 = gc_frame_newslot(*var_depth);
  params[0] = num1405;
  partcv[0] = 1;
  Object sum1407 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1407 (depth = 9)
  gc_frame_newslot(sum1407);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  params[0] = sum1407;
  partcv[0] = 1;
  Object call1408 = callmethodflags(*var_ix, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1403);
// compiled call node returning call1408 (depth = 8)
  int op_slot_right_1402 = gc_frame_newslot(call1408);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1410 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1413 == NULL) {
    strlit1413 = alloc_String("""\x0a""  ");
    gc_root(strlit1413);
  }
// compiled string node returning strlit1413 (depth = 10)
  int op_slot_right_1412 = gc_frame_newslot(strlit1413);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1412 = gc_frame_newslot(*var_s);
  params[0] = strlit1413;
  partcv[0] = 1;
  Object opresult1415 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1415 (depth = 9)
  int op_slot_left_1410 = gc_frame_newslot(opresult1415);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1416 = callmethod(opresult1415, "++(1)", 1, partcv, params);
// compiled op node returning opresult1416 (depth = 8)
  int op_slot_left_1402 = gc_frame_newslot(opresult1416);
  params[0] = call1408;
  partcv[0] = 1;
  Object opresult1417 = callmethod(opresult1416, "++(1)", 1, partcv, params);
// compiled op node returning opresult1417 (depth = 7)
  *var_s = opresult1417;
  if (opresult1417 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_1253(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1254 == NULL) {
    strlit1254 = alloc_String("");
    gc_root(strlit1254);
  }
// compiled string node returning strlit1254 (depth = 4)
  *var_spc = strlit1254;
  if (strlit1254 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 276
  setline(276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1255 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_1256 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num1258 = alloc_Float64(0);
// compiled num node returning num1258 (depth = 5)
  int op_slot_left_1256 = gc_frame_newslot(num1258);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1259 = callmethod(num1258, "..(1)", 1, partcv, params);
// compiled op node returning opresult1259 (depth = 4)
  gc_frame_newslot(opresult1259);
// starting to compile block node (depth = 4)
  Object block1260 = alloc_Block(NULL, NULL, "ast", 276);
  gc_frame_newslot(block1260);
// method "_apply(_)"
  block_savedest(block1260);
  Object closure1261 = createclosure(2, "_apply(1)");
  setclosureframe(closure1261, stackframe);
  addtoclosure(closure1261, var_spc);
  addtoclosure(closure1261, selfslot);
  struct UserObject *uo1261 = (struct UserObject*)block1260;
  uo1261->data[0] = (Object)closure1261;
  Method *meth_meth_ast__apply_40_1_41_1261 = addmethod2pos(block1260, "_apply(1)", &meth_ast__apply_40_1_41_1261, 0);
  int argcv_meth_ast__apply_40_1_41_1261[] = {1};
  meth_meth_ast__apply_40_1_41_1261->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1261);
  meth_meth_ast__apply_40_1_41_1261->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1261->definitionLine = 2981;
// compiled block node returning block1260 (depth = 4)
  gc_frame_newslot(block1260);
// call case 5: prelude request
  params[0] = opresult1259;
  params[1] = block1260;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1268 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1255);
// compiled call node returning call1268 (depth = 3)
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1270 == NULL) {
    strlit1270 = alloc_String("""\x0a""");
    gc_root(strlit1270);
  }
// compiled string node returning strlit1270 (depth = 5)
  int op_slot_right_1269 = gc_frame_newslot(strlit1270);
// starting to compile call node (depth = 5)
  int callframe1272 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call1273 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1272);
// compiled call node returning call1273 (depth = 5)
  int op_slot_left_1269 = gc_frame_newslot(call1273);
  params[0] = strlit1270;
  partcv[0] = 1;
  Object opresult1274 = callmethod(call1273, "++(1)", 1, partcv, params);
// compiled op node returning opresult1274 (depth = 4)
  *var_s = opresult1274;
  if (opresult1274 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1276 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1278 = alloc_Float64(1);
// compiled num node returning num1278 (depth = 7)
  int op_slot_right_1277 = gc_frame_newslot(num1278);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_1277 = gc_frame_newslot(*var_depth);
  params[0] = num1278;
  partcv[0] = 1;
  Object sum1280 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1280 (depth = 6)
  gc_frame_newslot(sum1280);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1281 = gc_frame_new();
// call case 4: self request
  Object call1282 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1281);
// compiled member node returning call1282 (depth = 6)
  params[0] = sum1280;
  partcv[0] = 1;
  Object call1283 = callmethodflags(call1282, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1276);
// compiled call node returning call1283 (depth = 5)
  int op_slot_right_1275 = gc_frame_newslot(call1283);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1285 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1285 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1287 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1287 (depth = 5)
  int op_slot_left_1275 = gc_frame_newslot(opresult1287);
  params[0] = call1283;
  partcv[0] = 1;
  Object opresult1288 = callmethod(opresult1287, "++(1)", 1, partcv, params);
// compiled op node returning opresult1288 (depth = 4)
  *var_s = opresult1288;
  if (opresult1288 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1291 == NULL) {
    strlit1291 = alloc_String("""\x0a""");
    gc_root(strlit1291);
  }
// compiled string node returning strlit1291 (depth = 5)
  int op_slot_right_1290 = gc_frame_newslot(strlit1291);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_1290 = gc_frame_newslot(*var_s);
  params[0] = strlit1291;
  partcv[0] = 1;
  Object opresult1293 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1293 (depth = 4)
  *var_s = opresult1293;
  if (opresult1293 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1297 == NULL) {
    strlit1297 = alloc_String("symbols");
    gc_root(strlit1297);
  }
// compiled string node returning strlit1297 (depth = 5)
  int op_slot_right_1296 = gc_frame_newslot(strlit1297);
// starting to compile member node (depth = 5)
  int callframe1299 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  Object call1300 = callmethodflags(*var_util, "target", 0, partcv, params, 0);
  gc_frame_end(callframe1299);
// compiled member node returning call1300 (depth = 5)
  int op_slot_left_1296 = gc_frame_newslot(call1300);
  params[0] = strlit1297;
  partcv[0] = 1;
  Object opresult1301 = callmethod(call1300, "==(1)", 1, partcv, params);
// compiled op node returning opresult1301 (depth = 4)
  Object if1295 = done;
  if (istrue(opresult1301)) {
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1304 == NULL) {
    strlit1304 = alloc_String("""\x0a""");
    gc_root(strlit1304);
  }
// compiled string node returning strlit1304 (depth = 7)
  int op_slot_right_1303 = gc_frame_newslot(strlit1304);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1307 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1309 = alloc_Float64(2);
// compiled num node returning num1309 (depth = 10)
  int op_slot_right_1308 = gc_frame_newslot(num1309);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1308 = gc_frame_newslot(*var_depth);
  params[0] = num1309;
  partcv[0] = 1;
  Object sum1311 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1311 (depth = 9)
  gc_frame_newslot(sum1311);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1312 = gc_frame_new();
// call case 4: self request
  Object call1313 = callmethodflags(self, "thenblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1312);
// compiled member node returning call1313 (depth = 9)
  params[0] = sum1311;
  partcv[0] = 1;
  Object call1314 = callmethodflags(call1313, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1307);
// compiled call node returning call1314 (depth = 8)
  int op_slot_right_1306 = gc_frame_newslot(call1314);
// starting to compile string node (depth = 8)
  if (strlit1316 == NULL) {
    strlit1316 = alloc_String("Then: ");
    gc_root(strlit1316);
  }
// compiled string node returning strlit1316 (depth = 8)
  int op_slot_left_1306 = gc_frame_newslot(strlit1316);
  params[0] = call1314;
  partcv[0] = 1;
  Object opresult1317 = callmethod(strlit1316, "++(1)", 1, partcv, params);
// compiled op node returning opresult1317 (depth = 7)
  int op_slot_left_1303 = gc_frame_newslot(opresult1317);
  params[0] = strlit1304;
  partcv[0] = 1;
  Object opresult1318 = callmethod(opresult1317, "++(1)", 1, partcv, params);
// compiled op node returning opresult1318 (depth = 6)
  int op_slot_right_1302 = gc_frame_newslot(opresult1318);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1320 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1320 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1322 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1322 (depth = 6)
  int op_slot_left_1302 = gc_frame_newslot(opresult1322);
  params[0] = opresult1318;
  partcv[0] = 1;
  Object opresult1323 = callmethod(opresult1322, "++(1)", 1, partcv, params);
// compiled op node returning opresult1323 (depth = 5)
  *var_s = opresult1323;
  if (opresult1323 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1327 == NULL) {
    strlit1327 = alloc_String("");
    gc_root(strlit1327);
  }
// compiled string node returning strlit1327 (depth = 7)
  int op_slot_right_1326 = gc_frame_newslot(strlit1327);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1330 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1332 = alloc_Float64(2);
// compiled num node returning num1332 (depth = 10)
  int op_slot_right_1331 = gc_frame_newslot(num1332);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1331 = gc_frame_newslot(*var_depth);
  params[0] = num1332;
  partcv[0] = 1;
  Object sum1334 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1334 (depth = 9)
  gc_frame_newslot(sum1334);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1335 = gc_frame_new();
// call case 4: self request
  Object call1336 = callmethodflags(self, "elseblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1335);
// compiled member node returning call1336 (depth = 9)
  params[0] = sum1334;
  partcv[0] = 1;
  Object call1337 = callmethodflags(call1336, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1330);
// compiled call node returning call1337 (depth = 8)
  int op_slot_right_1329 = gc_frame_newslot(call1337);
// starting to compile string node (depth = 8)
  if (strlit1339 == NULL) {
    strlit1339 = alloc_String("Else: ");
    gc_root(strlit1339);
  }
// compiled string node returning strlit1339 (depth = 8)
  int op_slot_left_1329 = gc_frame_newslot(strlit1339);
  params[0] = call1337;
  partcv[0] = 1;
  Object opresult1340 = callmethod(strlit1339, "++(1)", 1, partcv, params);
// compiled op node returning opresult1340 (depth = 7)
  int op_slot_left_1326 = gc_frame_newslot(opresult1340);
  params[0] = strlit1327;
  partcv[0] = 1;
  Object opresult1341 = callmethod(opresult1340, "++(1)", 1, partcv, params);
// compiled op node returning opresult1341 (depth = 6)
  int op_slot_right_1325 = gc_frame_newslot(opresult1341);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1343 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1343 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1345 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1345 (depth = 6)
  int op_slot_left_1325 = gc_frame_newslot(opresult1345);
  params[0] = opresult1341;
  partcv[0] = 1;
  Object opresult1346 = callmethod(opresult1345, "++(1)", 1, partcv, params);
// compiled op node returning opresult1346 (depth = 5)
  *var_s = opresult1346;
  if (opresult1346 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1295 = done;
  } else {
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1349 == NULL) {
    strlit1349 = alloc_String("Then:");
    gc_root(strlit1349);
  }
// compiled string node returning strlit1349 (depth = 6)
  int op_slot_right_1348 = gc_frame_newslot(strlit1349);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1351 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1351 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1353 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1353 (depth = 6)
  int op_slot_left_1348 = gc_frame_newslot(opresult1353);
  params[0] = strlit1349;
  partcv[0] = 1;
  Object opresult1354 = callmethod(opresult1353, "++(1)", 1, partcv, params);
// compiled op node returning opresult1354 (depth = 5)
  *var_s = opresult1354;
  if (opresult1354 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1356 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1357 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1358 = gc_frame_new();
// call case 4: self request
  Object call1359 = callmethodflags(self, "thenblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1358);
// compiled member node returning call1359 (depth = 6)
  Object call1360 = callmethodflags(call1359, "body", 0, partcv, params, 0);
  gc_frame_end(callframe1357);
// compiled member node returning call1360 (depth = 5)
  gc_frame_newslot(call1360);
// starting to compile block node (depth = 5)
  Object block1361 = alloc_Block(NULL, NULL, "ast", 287);
  gc_frame_newslot(block1361);
// method "_apply(_)"
  block_savedest(block1361);
  Object closure1362 = createclosure(4, "_apply(1)");
  setclosureframe(closure1362, stackframe);
  addtoclosure(closure1362, var_depth);
  addtoclosure(closure1362, var_spc);
  addtoclosure(closure1362, var_s);
  addtoclosure(closure1362, selfslot);
  struct UserObject *uo1362 = (struct UserObject*)block1361;
  uo1362->data[0] = (Object)closure1362;
  Method *meth_meth_ast__apply_40_1_41_1362 = addmethod2pos(block1361, "_apply(1)", &meth_ast__apply_40_1_41_1362, 0);
  int argcv_meth_ast__apply_40_1_41_1362[] = {1};
  meth_meth_ast__apply_40_1_41_1362->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1362);
  meth_meth_ast__apply_40_1_41_1362->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1362->definitionLine = 2981;
// compiled block node returning block1361 (depth = 5)
  gc_frame_newslot(block1361);
// call case 5: prelude request
  params[0] = call1360;
  params[1] = block1361;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1381 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1356);
// compiled call node returning call1381 (depth = 4)
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1383 == NULL) {
    strlit1383 = alloc_String("""\x0a""");
    gc_root(strlit1383);
  }
// compiled string node returning strlit1383 (depth = 6)
  int op_slot_right_1382 = gc_frame_newslot(strlit1383);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1382 = gc_frame_newslot(*var_s);
  params[0] = strlit1383;
  partcv[0] = 1;
  Object opresult1385 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1385 (depth = 5)
  *var_s = opresult1385;
  if (opresult1385 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1388 == NULL) {
    strlit1388 = alloc_String("Else:");
    gc_root(strlit1388);
  }
// compiled string node returning strlit1388 (depth = 6)
  int op_slot_right_1387 = gc_frame_newslot(strlit1388);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1390 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1390 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1392 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1392 (depth = 6)
  int op_slot_left_1387 = gc_frame_newslot(opresult1392);
  params[0] = strlit1388;
  partcv[0] = 1;
  Object opresult1393 = callmethod(opresult1392, "++(1)", 1, partcv, params);
// compiled op node returning opresult1393 (depth = 5)
  *var_s = opresult1393;
  if (opresult1393 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1395 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1396 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1397 = gc_frame_new();
// call case 4: self request
  Object call1398 = callmethodflags(self, "elseblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1397);
// compiled member node returning call1398 (depth = 6)
  Object call1399 = callmethodflags(call1398, "body", 0, partcv, params, 0);
  gc_frame_end(callframe1396);
// compiled member node returning call1399 (depth = 5)
  gc_frame_newslot(call1399);
// starting to compile block node (depth = 5)
  Object block1400 = alloc_Block(NULL, NULL, "ast", 292);
  gc_frame_newslot(block1400);
// method "_apply(_)"
  block_savedest(block1400);
  Object closure1401 = createclosure(4, "_apply(1)");
  setclosureframe(closure1401, stackframe);
  addtoclosure(closure1401, var_depth);
  addtoclosure(closure1401, var_spc);
  addtoclosure(closure1401, var_s);
  addtoclosure(closure1401, selfslot);
  struct UserObject *uo1401 = (struct UserObject*)block1400;
  uo1401->data[0] = (Object)closure1401;
  Method *meth_meth_ast__apply_40_1_41_1401 = addmethod2pos(block1400, "_apply(1)", &meth_ast__apply_40_1_41_1401, 0);
  int argcv_meth_ast__apply_40_1_41_1401[] = {1};
  meth_meth_ast__apply_40_1_41_1401->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1401);
  meth_meth_ast__apply_40_1_41_1401->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1401->definitionLine = 2981;
// compiled block node returning block1400 (depth = 5)
  gc_frame_newslot(block1400);
// call case 5: prelude request
  params[0] = call1399;
  params[1] = block1400;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1420 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1395);
// compiled call node returning call1420 (depth = 4)
    gc_frame_newslot(call1420);
    if1295 = call1420;
  }
// compiled if node returning if1295 (depth = 3)
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1425(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1427 == NULL) {
    strlit1427 = alloc_String("    ");
    gc_root(strlit1427);
  }
// compiled string node returning strlit1427 (depth = 7)
  int op_slot_right_1426 = gc_frame_newslot(strlit1427);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_1426 = gc_frame_newslot(*var_spc);
  params[0] = strlit1427;
  partcv[0] = 1;
  Object opresult1429 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult1429 (depth = 6)
  *var_spc = opresult1429;
  if (opresult1429 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_1452(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1454 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1456 = alloc_Float64(1);
// compiled num node returning num1456 (depth = 9)
  int op_slot_right_1455 = gc_frame_newslot(num1456);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1455 = gc_frame_newslot(*var_depth);
  params[0] = num1456;
  partcv[0] = 1;
  Object sum1458 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1458 (depth = 8)
  gc_frame_newslot(sum1458);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  params[0] = sum1458;
  partcv[0] = 1;
  Object call1459 = callmethodflags(*var_ix, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1454);
// compiled call node returning call1459 (depth = 7)
  int op_slot_right_1453 = gc_frame_newslot(call1459);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1462 == NULL) {
    strlit1462 = alloc_String("    ");
    gc_root(strlit1462);
  }
// compiled string node returning strlit1462 (depth = 8)
  int op_slot_right_1461 = gc_frame_newslot(strlit1462);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1464 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1467 == NULL) {
    strlit1467 = alloc_String("""\x0a""");
    gc_root(strlit1467);
  }
// compiled string node returning strlit1467 (depth = 10)
  int op_slot_right_1466 = gc_frame_newslot(strlit1467);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1466 = gc_frame_newslot(*var_s);
  params[0] = strlit1467;
  partcv[0] = 1;
  Object opresult1469 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1469 (depth = 9)
  int op_slot_left_1464 = gc_frame_newslot(opresult1469);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1470 = callmethod(opresult1469, "++(1)", 1, partcv, params);
// compiled op node returning opresult1470 (depth = 8)
  int op_slot_left_1461 = gc_frame_newslot(opresult1470);
  params[0] = strlit1462;
  partcv[0] = 1;
  Object opresult1471 = callmethod(opresult1470, "++(1)", 1, partcv, params);
// compiled op node returning opresult1471 (depth = 7)
  int op_slot_left_1453 = gc_frame_newslot(opresult1471);
  params[0] = call1459;
  partcv[0] = 1;
  Object opresult1472 = callmethod(opresult1471, "++(1)", 1, partcv, params);
// compiled op node returning opresult1472 (depth = 6)
  *var_s = opresult1472;
  if (opresult1472 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_1499(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1501 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1503 = alloc_Float64(1);
// compiled num node returning num1503 (depth = 10)
  int op_slot_right_1502 = gc_frame_newslot(num1503);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1502 = gc_frame_newslot(*var_depth);
  params[0] = num1503;
  partcv[0] = 1;
  Object sum1505 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1505 (depth = 9)
  gc_frame_newslot(sum1505);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  params[0] = sum1505;
  partcv[0] = 1;
  Object call1506 = callmethodflags(*var_ix, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1501);
// compiled call node returning call1506 (depth = 8)
  int op_slot_right_1500 = gc_frame_newslot(call1506);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1509 == NULL) {
    strlit1509 = alloc_String("    ");
    gc_root(strlit1509);
  }
// compiled string node returning strlit1509 (depth = 9)
  int op_slot_right_1508 = gc_frame_newslot(strlit1509);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_1511 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1514 == NULL) {
    strlit1514 = alloc_String("""\x0a""");
    gc_root(strlit1514);
  }
// compiled string node returning strlit1514 (depth = 11)
  int op_slot_right_1513 = gc_frame_newslot(strlit1514);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1513 = gc_frame_newslot(*var_s);
  params[0] = strlit1514;
  partcv[0] = 1;
  Object opresult1516 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1516 (depth = 10)
  int op_slot_left_1511 = gc_frame_newslot(opresult1516);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1517 = callmethod(opresult1516, "++(1)", 1, partcv, params);
// compiled op node returning opresult1517 (depth = 9)
  int op_slot_left_1508 = gc_frame_newslot(opresult1517);
  params[0] = strlit1509;
  partcv[0] = 1;
  Object opresult1518 = callmethod(opresult1517, "++(1)", 1, partcv, params);
// compiled op node returning opresult1518 (depth = 8)
  int op_slot_left_1500 = gc_frame_newslot(opresult1518);
  params[0] = call1506;
  partcv[0] = 1;
  Object opresult1519 = callmethod(opresult1518, "++(1)", 1, partcv, params);
// compiled op node returning opresult1519 (depth = 7)
  *var_s = opresult1519;
  if (opresult1519 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_1421(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 299
  setline(299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1422 == NULL) {
    strlit1422 = alloc_String("");
    gc_root(strlit1422);
  }
// compiled string node returning strlit1422 (depth = 4)
  *var_spc = strlit1422;
  if (strlit1422 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1423 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 4)
  Object block1424 = alloc_Block(NULL, NULL, "ast", 300);
  gc_frame_newslot(block1424);
// method "_apply"
  block_savedest(block1424);
  Object closure1425 = createclosure(2, "_apply");
  setclosureframe(closure1425, stackframe);
  addtoclosure(closure1425, var_spc);
  addtoclosure(closure1425, selfslot);
  struct UserObject *uo1425 = (struct UserObject*)block1424;
  uo1425->data[0] = (Object)closure1425;
  Method *meth_meth_ast__apply1425 = addmethod2pos(block1424, "_apply", &meth_ast__apply1425, 0);
  int argcv_meth_ast__apply1425[] = {0};
  meth_meth_ast__apply1425->type = alloc_MethodType(1, argcv_meth_ast__apply1425);
  meth_meth_ast__apply1425->definitionModule = modulename;
  meth_meth_ast__apply1425->definitionLine = 2981;
// compiled block node returning block1424 (depth = 4)
  gc_frame_newslot(block1424);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block1424;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1432 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1423);
// compiled call node returning call1432 (depth = 3)
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1434 == NULL) {
    strlit1434 = alloc_String(") then {");
    gc_root(strlit1434);
  }
// compiled string node returning strlit1434 (depth = 5)
  int op_slot_right_1433 = gc_frame_newslot(strlit1434);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1437 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num1438 = alloc_Float64(0);
// compiled num node returning num1438 (depth = 7)
  gc_frame_newslot(num1438);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1439 = gc_frame_new();
// call case 4: self request
  Object call1440 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1439);
// compiled member node returning call1440 (depth = 7)
  params[0] = num1438;
  partcv[0] = 1;
  Object call1441 = callmethodflags(call1440, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1437);
// compiled call node returning call1441 (depth = 6)
  int op_slot_right_1436 = gc_frame_newslot(call1441);
// starting to compile string node (depth = 6)
  if (strlit1443 == NULL) {
    strlit1443 = alloc_String("if (");
    gc_root(strlit1443);
  }
// compiled string node returning strlit1443 (depth = 6)
  int op_slot_left_1436 = gc_frame_newslot(strlit1443);
  params[0] = call1441;
  partcv[0] = 1;
  Object opresult1444 = callmethod(strlit1443, "++(1)", 1, partcv, params);
// compiled op node returning opresult1444 (depth = 5)
  int op_slot_left_1433 = gc_frame_newslot(opresult1444);
  params[0] = strlit1434;
  partcv[0] = 1;
  Object opresult1445 = callmethod(opresult1444, "++(1)", 1, partcv, params);
// compiled op node returning opresult1445 (depth = 4)
  *var_s = opresult1445;
  if (opresult1445 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1446 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1447 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1448 = gc_frame_new();
// call case 4: self request
  Object call1449 = callmethodflags(self, "thenblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1448);
// compiled member node returning call1449 (depth = 5)
  Object call1450 = callmethodflags(call1449, "body", 0, partcv, params, 0);
  gc_frame_end(callframe1447);
// compiled member node returning call1450 (depth = 4)
  gc_frame_newslot(call1450);
// starting to compile block node (depth = 4)
  Object block1451 = alloc_Block(NULL, NULL, "ast", 304);
  gc_frame_newslot(block1451);
// method "_apply(_)"
  block_savedest(block1451);
  Object closure1452 = createclosure(4, "_apply(1)");
  setclosureframe(closure1452, stackframe);
  addtoclosure(closure1452, var_depth);
  addtoclosure(closure1452, var_spc);
  addtoclosure(closure1452, var_s);
  addtoclosure(closure1452, selfslot);
  struct UserObject *uo1452 = (struct UserObject*)block1451;
  uo1452->data[0] = (Object)closure1452;
  Method *meth_meth_ast__apply_40_1_41_1452 = addmethod2pos(block1451, "_apply(1)", &meth_ast__apply_40_1_41_1452, 0);
  int argcv_meth_ast__apply_40_1_41_1452[] = {1};
  meth_meth_ast__apply_40_1_41_1452->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1452);
  meth_meth_ast__apply_40_1_41_1452->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1452->definitionLine = 2981;
// compiled block node returning block1451 (depth = 4)
  gc_frame_newslot(block1451);
// call case 5: prelude request
  params[0] = call1450;
  params[1] = block1451;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1475 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1446);
// compiled call node returning call1475 (depth = 3)
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1477 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1478 = gc_frame_new();
// call case 4: self request
  Object call1479 = callmethodflags(self, "elseblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1478);
// compiled member node returning call1479 (depth = 5)
  Object call1480 = callmethodflags(call1479, "isntEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe1477);
// compiled member node returning call1480 (depth = 4)
  Object if1476 = done;
  if (istrue(call1480)) {
// Begin line 308
  setline(308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1482 == NULL) {
    strlit1482 = alloc_String("} else {");
    gc_root(strlit1482);
  }
// compiled string node returning strlit1482 (depth = 6)
  int op_slot_right_1481 = gc_frame_newslot(strlit1482);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1484 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1487 == NULL) {
    strlit1487 = alloc_String("""\x0a""");
    gc_root(strlit1487);
  }
// compiled string node returning strlit1487 (depth = 8)
  int op_slot_right_1486 = gc_frame_newslot(strlit1487);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1486 = gc_frame_newslot(*var_s);
  params[0] = strlit1487;
  partcv[0] = 1;
  Object opresult1489 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1489 (depth = 7)
  int op_slot_left_1484 = gc_frame_newslot(opresult1489);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1490 = callmethod(opresult1489, "++(1)", 1, partcv, params);
// compiled op node returning opresult1490 (depth = 6)
  int op_slot_left_1481 = gc_frame_newslot(opresult1490);
  params[0] = strlit1482;
  partcv[0] = 1;
  Object opresult1491 = callmethod(opresult1490, "++(1)", 1, partcv, params);
// compiled op node returning opresult1491 (depth = 5)
  *var_s = opresult1491;
  if (opresult1491 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1493 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1494 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1495 = gc_frame_new();
// call case 4: self request
  Object call1496 = callmethodflags(self, "elseblock", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1495);
// compiled member node returning call1496 (depth = 6)
  Object call1497 = callmethodflags(call1496, "body", 0, partcv, params, 0);
  gc_frame_end(callframe1494);
// compiled member node returning call1497 (depth = 5)
  gc_frame_newslot(call1497);
// starting to compile block node (depth = 5)
  Object block1498 = alloc_Block(NULL, NULL, "ast", 309);
  gc_frame_newslot(block1498);
// method "_apply(_)"
  block_savedest(block1498);
  Object closure1499 = createclosure(4, "_apply(1)");
  setclosureframe(closure1499, stackframe);
  addtoclosure(closure1499, var_depth);
  addtoclosure(closure1499, var_spc);
  addtoclosure(closure1499, var_s);
  addtoclosure(closure1499, selfslot);
  struct UserObject *uo1499 = (struct UserObject*)block1498;
  uo1499->data[0] = (Object)closure1499;
  Method *meth_meth_ast__apply_40_1_41_1499 = addmethod2pos(block1498, "_apply(1)", &meth_ast__apply_40_1_41_1499, 0);
  int argcv_meth_ast__apply_40_1_41_1499[] = {1};
  meth_meth_ast__apply_40_1_41_1499->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1499);
  meth_meth_ast__apply_40_1_41_1499->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1499->definitionLine = 2981;
// compiled block node returning block1498 (depth = 5)
  gc_frame_newslot(block1498);
// call case 5: prelude request
  params[0] = call1497;
  params[1] = block1498;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1522 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1493);
// compiled call node returning call1522 (depth = 4)
    gc_frame_newslot(call1522);
    if1476 = call1522;
  } else {
  }
// compiled if node returning if1476 (depth = 3)
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1524 == NULL) {
    strlit1524 = alloc_String("}");
    gc_root(strlit1524);
  }
// compiled string node returning strlit1524 (depth = 5)
  int op_slot_right_1523 = gc_frame_newslot(strlit1524);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1526 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1529 == NULL) {
    strlit1529 = alloc_String("""\x0a""");
    gc_root(strlit1529);
  }
// compiled string node returning strlit1529 (depth = 7)
  int op_slot_right_1528 = gc_frame_newslot(strlit1529);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1528 = gc_frame_newslot(*var_s);
  params[0] = strlit1529;
  partcv[0] = 1;
  Object opresult1531 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1531 (depth = 6)
  int op_slot_left_1526 = gc_frame_newslot(opresult1531);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1532 = callmethod(opresult1531, "++(1)", 1, partcv, params);
// compiled op node returning opresult1532 (depth = 5)
  int op_slot_left_1523 = gc_frame_newslot(opresult1532);
  params[0] = strlit1524;
  partcv[0] = 1;
  Object opresult1533 = callmethod(opresult1532, "++(1)", 1, partcv, params);
// compiled op node returning opresult1533 (depth = 4)
  *var_s = opresult1533;
  if (opresult1533 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy1535(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_ifNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1536 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe1537 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ifNode (depth = 5)
  params[0] = *var_nullNode;
  params[1] = *var_nullNode;
  params[2] = *var_nullNode;
  partcv[0] = 3;
  Object call1538 = callmethodflags(*var_ifNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe1537);
// compiled call node returning call1538 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call1539 = callmethodflags(call1538, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1536);
// compiled call node returning call1539 (depth = 3)
  gc_frame_end(frame);
  return call1539;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_1540(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1541 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1542 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1541);
// compiled call node returning call1542 (depth = 3)
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1543 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1544 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call1545 = callmethodflags(*var_other, "handledIdentifiers", 0, partcv, params, 0);
  gc_frame_end(callframe1544);
// compiled member node returning call1545 (depth = 4)
  gc_frame_newslot(call1545);
// call case 4: self request
  params[0] = call1545;
  partcv[0] = 1;
  Object call1546 = callmethodflags(self, "handledIdentifiers:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1543);
// compiled call node returning call1546 (depth = 3)
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new_40_3_41_1200(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_ifNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenblock_39_ = &(stackframe->slots[1]);
  *var_thenblock_39_ = args[curarg];
  curarg++;
  Object *var_elseblock_39_ = &(stackframe->slots[2]);
  *var_elseblock_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1201 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1201 = alloc_userobj2(16,13, objclass1201);
  gc_frame_newslot(obj1201);
if (objclass1201 == NULL) {
  glfree(obj1201->class->name);
  obj1201->class->name = "ifNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1201, self, 0);
  addmethodreal(obj1201,"outer", &reader_ast_outer_1202);
  Object oldself1201 = self;
  struct StackFrameObject *oldstackframe1201 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1201);
  gc_frame_newslot((Object)stackframe);
  self = obj1201;
  Object *oldselfslot1201 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1201 = (*(struct UserObject *)self).data[0], lowerouter1201 = thisouter1201;
  if (inheritingObject1201) {
    struct UserObject *inho1201 = (struct UserObject *)inheritingObject1201;
    while (inho1201->super != GraceDefaultObject) inho1201 = (struct UserObject *)inho1201->super;
    inho1201->super = obj1201;
    self = inheritingObject1201;
    *selfslot = self;
    lowerouter1201 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1201;
  }
if (objclass1201 == NULL) {
  Method *reader1203 = addmethodrealflags(obj1201, "kind",&reader_ast_kind_1203, MFLAG_DEF);
  reader1203->definitionModule = modulename;
  reader1203->definitionLine = 252;
}
adddatum2(obj1201, alloc_Undefined(), 1);
if (objclass1201 == NULL) {
  Method *reader1204 = addmethodrealflags(obj1201, "value", &reader_ast_value_1204, 0);
  Method *writer1204 = addmethodrealflags(obj1201, "value:=(1)", &writer_ast_value_1204, 0);
  reader1204->definitionModule = modulename;
  writer1204->definitionModule = modulename;
  reader1204->definitionLine = 253;
  writer1204->definitionLine = 253;
}
obj1201->flags |= OFLAG_MUTABLE;
adddatum2(obj1201, alloc_Undefined(), 2);
if (objclass1201 == NULL) {
  Method *reader1205 = addmethodrealflags(obj1201, "thenblock", &reader_ast_thenblock_1205, 0);
  Method *writer1205 = addmethodrealflags(obj1201, "thenblock:=(1)", &writer_ast_thenblock_1205, 0);
  reader1205->definitionModule = modulename;
  writer1205->definitionModule = modulename;
  reader1205->definitionLine = 254;
  writer1205->definitionLine = 254;
}
obj1201->flags |= OFLAG_MUTABLE;
adddatum2(obj1201, alloc_Undefined(), 3);
if (objclass1201 == NULL) {
  Method *reader1206 = addmethodrealflags(obj1201, "elseblock", &reader_ast_elseblock_1206, 0);
  Method *writer1206 = addmethodrealflags(obj1201, "elseblock:=(1)", &writer_ast_elseblock_1206, 0);
  reader1206->definitionModule = modulename;
  writer1206->definitionModule = modulename;
  reader1206->definitionLine = 255;
  writer1206->definitionLine = 255;
}
obj1201->flags |= OFLAG_MUTABLE;
adddatum2(obj1201, alloc_Undefined(), 4);
if (objclass1201 == NULL) {
  Method *reader1207 = addmethodrealflags(obj1201, "handledIdentifiers", &reader_ast_handledIdentifiers_1207, 0);
  Method *writer1207 = addmethodrealflags(obj1201, "handledIdentifiers:=(1)", &writer_ast_handledIdentifiers_1207, 0);
  reader1207->definitionModule = modulename;
  writer1207->definitionModule = modulename;
  reader1207->definitionLine = 256;
  writer1207->definitionLine = 256;
}
obj1201->flags |= OFLAG_MUTABLE;
adddatum2(obj1201, alloc_Undefined(), 5);
// method "isSimple"
  struct UserObject *uo1208 = (struct UserObject*)obj1201;
  uo1208->data[6] = emptyclosure;
  Method *meth_meth_ast_isSimple1208 = addmethod2pos(obj1201, "isSimple", &meth_ast_isSimple1208, 6);
  int argcv_meth_ast_isSimple1208[] = {0};
  meth_meth_ast_isSimple1208->type = alloc_MethodType(1, argcv_meth_ast_isSimple1208);
  meth_meth_ast_isSimple1208->definitionModule = modulename;
  meth_meth_ast_isSimple1208->definitionLine = 257;
// method "accept(_)from(_)"
  struct UserObject *uo1210 = (struct UserObject*)obj1201;
  uo1210->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_1210 = addmethod2pos(obj1201, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_1210, 7);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_1210[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_1210->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_1210);
  meth_meth_ast_accept_40_1_41_from_40_1_41_1210->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_1210->definitionLine = 258;
// method "map(_)ancestors(_)"
  struct UserObject *uo1228 = (struct UserObject*)obj1201;
  uo1228->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_1228 = addmethod2pos(obj1201, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_1228, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1228[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1228->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1228);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1228->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1228->definitionLine = 266;
// method "pretty(_)"
  block_savedest(obj1201);
  Object closure1253 = createclosure(1, "pretty(1)");
  setclosureframe(closure1253, stackframe);
  addtoclosure(closure1253, var_util);
  struct UserObject *uo1253 = (struct UserObject*)obj1201;
  uo1253->data[9] = (Object)closure1253;
  Method *meth_meth_ast_pretty_40_1_41_1253 = addmethod2pos(obj1201, "pretty(1)", &meth_ast_pretty_40_1_41_1253, 9);
  int argcv_meth_ast_pretty_40_1_41_1253[] = {1};
  meth_meth_ast_pretty_40_1_41_1253->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_1253);
  meth_meth_ast_pretty_40_1_41_1253->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_1253->definitionLine = 274;
// method "toGrace(_)"
  struct UserObject *uo1421 = (struct UserObject*)obj1201;
  uo1421->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_1421 = addmethod2pos(obj1201, "toGrace(1)", &meth_ast_toGrace_40_1_41_1421, 10);
  int argcv_meth_ast_toGrace_40_1_41_1421[] = {1};
  meth_meth_ast_toGrace_40_1_41_1421->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_1421);
meth_meth_ast_toGrace_40_1_41_1421->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_1421->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_1421->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_1421->definitionLine = 298;
// method "shallowCopy"
  block_savedest(obj1201);
  Object closure1535 = createclosure(2, "shallowCopy");
  setclosureframe(closure1535, stackframe);
  addtoclosure(closure1535, var_nullNode);
  addtoclosure(closure1535, var_ifNode);
  struct UserObject *uo1535 = (struct UserObject*)obj1201;
  uo1535->data[11] = (Object)closure1535;
  Method *meth_meth_ast_shallowCopy1535 = addmethod2pos(obj1201, "shallowCopy", &meth_ast_shallowCopy1535, 11);
  int argcv_meth_ast_shallowCopy1535[] = {0};
  meth_meth_ast_shallowCopy1535->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1535);
  meth_meth_ast_shallowCopy1535->definitionModule = modulename;
  meth_meth_ast_shallowCopy1535->definitionLine = 316;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo1540 = (struct UserObject*)obj1201;
  uo1540->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1540 = addmethod2pos(obj1201, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_1540, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_1540[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1540->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_1540);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1540->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1540->definitionLine = 319;
  sourceObject = obj1201;
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1547 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1548 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1549 = gc_frame_new();
// call case 3: self.outer request
  Object call1550 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1549);
// compiled member node returning call1550 (depth = 5)
  Object call1551 = callmethodflags(call1550, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1548);
// compiled member node returning call1551 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1552 = callmethodflags(call1551, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1547);
// compiled call node returning call1552 (depth = 3)
  struct UserObject *obj1201_uo = (struct UserObject *)obj1201;
  obj1201_uo->super = call1552;
  sourceObject = obj1201;
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1553 == NULL) {
    strlit1553 = alloc_String("if");
    gc_root(strlit1553);
  }
// compiled string node returning strlit1553 (depth = 3)
  adddatum2(obj1201, strlit1553, 1);
  sourceObject = obj1201;
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cond (depth = 3)
  adddatum2(obj1201, *var_cond, 2);
  sourceObject = obj1201;
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_thenblock_39_ (depth = 3)
  adddatum2(obj1201, *var_thenblock_39_, 3);
  sourceObject = obj1201;
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elseblock_39_ (depth = 3)
  adddatum2(obj1201, *var_elseblock_39_, 4);
  sourceObject = obj1201;
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1554 = alloc_Boolean(0);
// compiled identifier node returning bool1554 (depth = 3)
  adddatum2(obj1201, bool1554, 5);
  sourceObject = obj1201;
  sourceObject = obj1201;
  sourceObject = obj1201;
  sourceObject = obj1201;
  sourceObject = obj1201;
  sourceObject = obj1201;
  sourceObject = obj1201;
  objclass1201 = obj1201->class;
  objclass1201->definitionModule = modulename;
  objclass1201->definitionLine = 250;
  (*(struct UserObject *)self).data[0] = lowerouter1201;
  self = oldself1201;
  selfslot = oldselfslot1201;
  stackframe = oldstackframe1201;
  gc_frame_end(frame);
  return obj1201;
}
Object meth_ast_new_40_3_41_1200_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_ifNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenblock_39_ = &(stackframe->slots[1]);
  *var_thenblock_39_ = args[curarg];
  curarg++;
  Object *var_elseblock_39_ = &(stackframe->slots[2]);
  *var_elseblock_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1201 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1201 = alloc_userobj2(16,13, objclass1201);
  gc_frame_newslot(obj1201);
if (objclass1201 == NULL) {
  glfree(obj1201->class->name);
  obj1201->class->name = "ifNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1201, self, 0);
  addmethodreal(obj1201,"outer", &reader_ast_outer_1202);
  Object oldself1201 = self;
  struct StackFrameObject *oldstackframe1201 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1201);
  gc_frame_newslot((Object)stackframe);
  self = obj1201;
  Object *oldselfslot1201 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1201 = (*(struct UserObject *)self).data[0], lowerouter1201 = thisouter1201;
  if (inheritingObject1201) {
    struct UserObject *inho1201 = (struct UserObject *)inheritingObject1201;
    while (inho1201->super != GraceDefaultObject) inho1201 = (struct UserObject *)inho1201->super;
    inho1201->super = obj1201;
    self = inheritingObject1201;
    *selfslot = self;
    lowerouter1201 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1201;
  }
if (objclass1201 == NULL) {
  Method *reader1203 = addmethodrealflags(obj1201, "kind",&reader_ast_kind_1203, MFLAG_DEF);
  reader1203->definitionModule = modulename;
  reader1203->definitionLine = 252;
}
adddatum2(obj1201, alloc_Undefined(), 1);
if (objclass1201 == NULL) {
  Method *reader1204 = addmethodrealflags(obj1201, "value", &reader_ast_value_1204, 0);
  Method *writer1204 = addmethodrealflags(obj1201, "value:=(1)", &writer_ast_value_1204, 0);
  reader1204->definitionModule = modulename;
  writer1204->definitionModule = modulename;
  reader1204->definitionLine = 253;
  writer1204->definitionLine = 253;
}
obj1201->flags |= OFLAG_MUTABLE;
adddatum2(obj1201, alloc_Undefined(), 2);
if (objclass1201 == NULL) {
  Method *reader1205 = addmethodrealflags(obj1201, "thenblock", &reader_ast_thenblock_1205, 0);
  Method *writer1205 = addmethodrealflags(obj1201, "thenblock:=(1)", &writer_ast_thenblock_1205, 0);
  reader1205->definitionModule = modulename;
  writer1205->definitionModule = modulename;
  reader1205->definitionLine = 254;
  writer1205->definitionLine = 254;
}
obj1201->flags |= OFLAG_MUTABLE;
adddatum2(obj1201, alloc_Undefined(), 3);
if (objclass1201 == NULL) {
  Method *reader1206 = addmethodrealflags(obj1201, "elseblock", &reader_ast_elseblock_1206, 0);
  Method *writer1206 = addmethodrealflags(obj1201, "elseblock:=(1)", &writer_ast_elseblock_1206, 0);
  reader1206->definitionModule = modulename;
  writer1206->definitionModule = modulename;
  reader1206->definitionLine = 255;
  writer1206->definitionLine = 255;
}
obj1201->flags |= OFLAG_MUTABLE;
adddatum2(obj1201, alloc_Undefined(), 4);
if (objclass1201 == NULL) {
  Method *reader1207 = addmethodrealflags(obj1201, "handledIdentifiers", &reader_ast_handledIdentifiers_1207, 0);
  Method *writer1207 = addmethodrealflags(obj1201, "handledIdentifiers:=(1)", &writer_ast_handledIdentifiers_1207, 0);
  reader1207->definitionModule = modulename;
  writer1207->definitionModule = modulename;
  reader1207->definitionLine = 256;
  writer1207->definitionLine = 256;
}
obj1201->flags |= OFLAG_MUTABLE;
adddatum2(obj1201, alloc_Undefined(), 5);
// method "isSimple"
  struct UserObject *uo1208 = (struct UserObject*)obj1201;
  uo1208->data[6] = emptyclosure;
  Method *meth_meth_ast_isSimple1208 = addmethod2pos(obj1201, "isSimple", &meth_ast_isSimple1208, 6);
  int argcv_meth_ast_isSimple1208[] = {0};
  meth_meth_ast_isSimple1208->type = alloc_MethodType(1, argcv_meth_ast_isSimple1208);
  meth_meth_ast_isSimple1208->definitionModule = modulename;
  meth_meth_ast_isSimple1208->definitionLine = 257;
// method "accept(_)from(_)"
  struct UserObject *uo1210 = (struct UserObject*)obj1201;
  uo1210->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_1210 = addmethod2pos(obj1201, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_1210, 7);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_1210[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_1210->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_1210);
  meth_meth_ast_accept_40_1_41_from_40_1_41_1210->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_1210->definitionLine = 258;
// method "map(_)ancestors(_)"
  struct UserObject *uo1228 = (struct UserObject*)obj1201;
  uo1228->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_1228 = addmethod2pos(obj1201, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_1228, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1228[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1228->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1228);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1228->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1228->definitionLine = 266;
// method "pretty(_)"
  block_savedest(obj1201);
  Object closure1253 = createclosure(1, "pretty(1)");
  setclosureframe(closure1253, stackframe);
  addtoclosure(closure1253, var_util);
  struct UserObject *uo1253 = (struct UserObject*)obj1201;
  uo1253->data[9] = (Object)closure1253;
  Method *meth_meth_ast_pretty_40_1_41_1253 = addmethod2pos(obj1201, "pretty(1)", &meth_ast_pretty_40_1_41_1253, 9);
  int argcv_meth_ast_pretty_40_1_41_1253[] = {1};
  meth_meth_ast_pretty_40_1_41_1253->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_1253);
  meth_meth_ast_pretty_40_1_41_1253->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_1253->definitionLine = 274;
// method "toGrace(_)"
  struct UserObject *uo1421 = (struct UserObject*)obj1201;
  uo1421->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_1421 = addmethod2pos(obj1201, "toGrace(1)", &meth_ast_toGrace_40_1_41_1421, 10);
  int argcv_meth_ast_toGrace_40_1_41_1421[] = {1};
  meth_meth_ast_toGrace_40_1_41_1421->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_1421);
meth_meth_ast_toGrace_40_1_41_1421->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_1421->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_1421->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_1421->definitionLine = 298;
// method "shallowCopy"
  block_savedest(obj1201);
  Object closure1535 = createclosure(2, "shallowCopy");
  setclosureframe(closure1535, stackframe);
  addtoclosure(closure1535, var_nullNode);
  addtoclosure(closure1535, var_ifNode);
  struct UserObject *uo1535 = (struct UserObject*)obj1201;
  uo1535->data[11] = (Object)closure1535;
  Method *meth_meth_ast_shallowCopy1535 = addmethod2pos(obj1201, "shallowCopy", &meth_ast_shallowCopy1535, 11);
  int argcv_meth_ast_shallowCopy1535[] = {0};
  meth_meth_ast_shallowCopy1535->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1535);
  meth_meth_ast_shallowCopy1535->definitionModule = modulename;
  meth_meth_ast_shallowCopy1535->definitionLine = 316;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo1540 = (struct UserObject*)obj1201;
  uo1540->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1540 = addmethod2pos(obj1201, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_1540, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_1540[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1540->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_1540);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1540->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1540->definitionLine = 319;
  sourceObject = obj1201;
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1547 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1548 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1549 = gc_frame_new();
// call case 3: self.outer request
  Object call1550 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1549);
// compiled member node returning call1550 (depth = 5)
  Object call1551 = callmethodflags(call1550, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1548);
// compiled member node returning call1551 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1552 = callmethodflags(call1551, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1547);
// compiled call node returning call1552 (depth = 3)
  struct UserObject *obj1201_uo = (struct UserObject *)obj1201;
  obj1201_uo->super = call1552;
  sourceObject = obj1201;
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1553 == NULL) {
    strlit1553 = alloc_String("if");
    gc_root(strlit1553);
  }
// compiled string node returning strlit1553 (depth = 3)
  adddatum2(obj1201, strlit1553, 1);
  sourceObject = obj1201;
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cond (depth = 3)
  adddatum2(obj1201, *var_cond, 2);
  sourceObject = obj1201;
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_thenblock_39_ (depth = 3)
  adddatum2(obj1201, *var_thenblock_39_, 3);
  sourceObject = obj1201;
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elseblock_39_ (depth = 3)
  adddatum2(obj1201, *var_elseblock_39_, 4);
  sourceObject = obj1201;
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1554 = alloc_Boolean(0);
// compiled identifier node returning bool1554 (depth = 3)
  adddatum2(obj1201, bool1554, 5);
  sourceObject = obj1201;
  sourceObject = obj1201;
  sourceObject = obj1201;
  sourceObject = obj1201;
  sourceObject = obj1201;
  sourceObject = obj1201;
  sourceObject = obj1201;
  objclass1201 = obj1201->class;
  objclass1201->definitionModule = modulename;
  objclass1201->definitionLine = 250;
  (*(struct UserObject *)self).data[0] = lowerouter1201;
  self = oldself1201;
  selfslot = oldselfslot1201;
  stackframe = oldstackframe1201;
  gc_frame_end(frame);
  return obj1201;
}
Object meth_ast_ifNode1556(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ifNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ifNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ifNode (depth = 3)
  gc_frame_end(frame);
  return *var_ifNode;
}
Object meth_ast_isBlock1569(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1570 = alloc_Boolean(1);
// compiled identifier node returning bool1570 (depth = 3)
  gc_frame_end(frame);
  return bool1570;
}
Object meth_ast_isDelimited1571(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDelimited");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1572 = alloc_Boolean(1);
// compiled identifier node returning bool1572 (depth = 3)
  gc_frame_end(frame);
  return bool1572;
}
Object meth_ast_isEmpty1573(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1575 = alloc_Float64(0);
// compiled num node returning num1575 (depth = 4)
  int op_slot_right_1574 = gc_frame_newslot(num1575);
// starting to compile member node (depth = 4)
  int callframe1577 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1578 = gc_frame_new();
// call case 4: self request
  Object call1579 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1578);
// compiled member node returning call1579 (depth = 5)
  Object call1580 = callmethodflags(call1579, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1577);
// compiled member node returning call1580 (depth = 4)
  int op_slot_left_1574 = gc_frame_newslot(call1580);
  params[0] = num1575;
  partcv[0] = 1;
  Object opresult1581 = callmethod(call1580, "==(1)", 1, partcv, params);
// compiled op node returning opresult1581 (depth = 3)
  gc_frame_end(frame);
  return opresult1581;
}
Object meth_ast_isntEmpty1582(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isntEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1584 = alloc_Float64(0);
// compiled num node returning num1584 (depth = 4)
  int op_slot_right_1583 = gc_frame_newslot(num1584);
// starting to compile member node (depth = 4)
  int callframe1586 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1587 = gc_frame_new();
// call case 4: self request
  Object call1588 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1587);
// compiled member node returning call1588 (depth = 5)
  Object call1589 = callmethodflags(call1588, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1586);
// compiled member node returning call1589 (depth = 4)
  int op_slot_left_1583 = gc_frame_newslot(call1589);
  params[0] = num1584;
  partcv[0] = 1;
  Object opresult1590 = callmethod(call1589, ">(1)", 1, partcv, params);
// compiled op node returning opresult1590 (depth = 3)
  gc_frame_end(frame);
  return opresult1590;
}
Object meth_ast_scope_58__61__40_1_41_1591(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1592 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call1593 = callmethodflags(self, "symbolTable:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1592);
// compiled call node returning call1593 (depth = 3)
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1594 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call1595 = callmethodflags(*var_st, "node:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1594);
// compiled call node returning call1595 (depth = 3)
  gc_frame_end(frame);
  return call1595;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_1596(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1597 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call1598 = callmethodflags(*var_k, "parameter", 0, partcv, params, 0);
  gc_frame_end(callframe1597);
// compiled member node returning call1598 (depth = 3)
  gc_frame_end(frame);
  return call1598;
}
Object meth_ast_isMatchingBlock1599(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMatchingBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1601 = alloc_Float64(1);
// compiled num node returning num1601 (depth = 4)
  int op_slot_right_1600 = gc_frame_newslot(num1601);
// starting to compile member node (depth = 4)
  int callframe1603 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1604 = gc_frame_new();
// call case 4: self request
  Object call1605 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1604);
// compiled member node returning call1605 (depth = 5)
  Object call1606 = callmethodflags(call1605, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1603);
// compiled member node returning call1606 (depth = 4)
  int op_slot_left_1600 = gc_frame_newslot(call1606);
  params[0] = num1601;
  partcv[0] = 1;
  Object opresult1607 = callmethod(call1606, "==(1)", 1, partcv, params);
// compiled op node returning opresult1607 (depth = 3)
  gc_frame_end(frame);
  return opresult1607;
}
Object meth_ast__apply1611(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe1612 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1613 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1614 = gc_frame_new();
// call case 4: self request
  Object call1615 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1614);
// compiled member node returning call1615 (depth = 7)
  Object call1616 = callmethodflags(call1615, "last", 0, partcv, params, 0);
  gc_frame_end(callframe1613);
// compiled member node returning call1616 (depth = 6)
  Object call1617 = callmethodflags(call1616, "returnsObject", 0, partcv, params, 0);
  gc_frame_end(callframe1612);
// compiled member node returning call1617 (depth = 5)
  gc_frame_end(frame);
  return call1617;
}
Object meth_ast_returnsObject1608(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile block node (depth = 4)
  Object block1610 = alloc_Block(NULL, NULL, "ast", 352);
  gc_frame_newslot(block1610);
// method "_apply"
  block_savedest(block1610);
  Object closure1611 = createclosure(1, "_apply");
  setclosureframe(closure1611, stackframe);
  addtoclosure(closure1611, selfslot);
  struct UserObject *uo1611 = (struct UserObject*)block1610;
  uo1611->data[0] = (Object)closure1611;
  Method *meth_meth_ast__apply1611 = addmethod2pos(block1610, "_apply", &meth_ast__apply1611, 0);
  int argcv_meth_ast__apply1611[] = {0};
  meth_meth_ast__apply1611->type = alloc_MethodType(1, argcv_meth_ast__apply1611);
  meth_meth_ast__apply1611->definitionModule = modulename;
  meth_meth_ast__apply1611->definitionLine = 2981;
// compiled block node returning block1610 (depth = 4)
  int op_slot_right_1609 = gc_frame_newslot(block1610);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1621 = alloc_Float64(0);
// compiled num node returning num1621 (depth = 5)
  int op_slot_right_1620 = gc_frame_newslot(num1621);
// starting to compile member node (depth = 5)
  int callframe1623 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1624 = gc_frame_new();
// call case 4: self request
  Object call1625 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1624);
// compiled member node returning call1625 (depth = 6)
  Object call1626 = callmethodflags(call1625, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1623);
// compiled member node returning call1626 (depth = 5)
  int op_slot_left_1620 = gc_frame_newslot(call1626);
  params[0] = num1621;
  partcv[0] = 1;
  Object opresult1627 = callmethod(call1626, ">(1)", 1, partcv, params);
// compiled op node returning opresult1627 (depth = 4)
  int op_slot_left_1609 = gc_frame_newslot(opresult1627);
  params[0] = block1610;
  partcv[0] = 1;
  Object opresult1628 = callmethod(opresult1627, "&&(1)", 1, partcv, params);
// compiled op node returning opresult1628 (depth = 3)
  gc_frame_end(frame);
  return opresult1628;
}
Object meth_ast_returnedObjectScope1629(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe1630 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1631 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1632 = gc_frame_new();
// call case 4: self request
  Object call1633 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1632);
// compiled member node returning call1633 (depth = 5)
  Object call1634 = callmethodflags(call1633, "last", 0, partcv, params, 0);
  gc_frame_end(callframe1631);
// compiled member node returning call1634 (depth = 4)
  Object call1635 = callmethodflags(call1634, "returnedObjectScope", 0, partcv, params, 0);
  gc_frame_end(callframe1630);
// compiled member node returning call1635 (depth = 3)
  gc_frame_end(frame);
  return call1635;
}
Object meth_ast_parametersDo_40_1_41_1636(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parametersDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parametersDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parametersDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parametersDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1637 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1638 = gc_frame_new();
// call case 4: self request
  Object call1639 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1638);
// compiled member node returning call1639 (depth = 4)
  params[0] = *var_b;
  partcv[0] = 1;
  Object call1640 = callmethodflags(call1639, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1637);
// compiled call node returning call1640 (depth = 3)
  gc_frame_end(frame);
  return call1640;
}
Object meth_ast__apply_40_1_41_1651(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1652 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1653 = callmethodflags(*var_mx, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1652);
// compiled call node returning call1653 (depth = 6)
  gc_frame_end(frame);
  return call1653;
}
Object meth_ast__apply_40_1_41_1660(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1661 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1662 = callmethodflags(*var_mx, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1661);
// compiled call node returning call1662 (depth = 6)
  gc_frame_end(frame);
  return call1662;
}
Object meth_ast_accept_40_1_41_from_40_1_41_1641(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1643 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1644 = callmethodflags(*var_visitor, "visitBlock(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1643);
// compiled call node returning call1644 (depth = 4)
  Object if1642 = done;
  if (istrue(call1644)) {
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1645 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call1646 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1645);
// compiled call node returning call1646 (depth = 5)
  *var_newChain = call1646;
  if (call1646 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1647 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1648 = gc_frame_new();
// call case 4: self request
  Object call1649 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1648);
// compiled member node returning call1649 (depth = 5)
  gc_frame_newslot(call1649);
// starting to compile block node (depth = 5)
  Object block1650 = alloc_Block(NULL, NULL, "ast", 364);
  gc_frame_newslot(block1650);
// method "_apply(_)"
  block_savedest(block1650);
  Object closure1651 = createclosure(3, "_apply(1)");
  setclosureframe(closure1651, stackframe);
  addtoclosure(closure1651, var_visitor);
  addtoclosure(closure1651, var_newChain);
  addtoclosure(closure1651, selfslot);
  struct UserObject *uo1651 = (struct UserObject*)block1650;
  uo1651->data[0] = (Object)closure1651;
  Method *meth_meth_ast__apply_40_1_41_1651 = addmethod2pos(block1650, "_apply(1)", &meth_ast__apply_40_1_41_1651, 0);
  int argcv_meth_ast__apply_40_1_41_1651[] = {1};
  meth_meth_ast__apply_40_1_41_1651->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1651);
  meth_meth_ast__apply_40_1_41_1651->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1651->definitionLine = 2981;
// compiled block node returning block1650 (depth = 5)
  gc_frame_newslot(block1650);
// call case 5: prelude request
  params[0] = call1649;
  params[1] = block1650;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1655 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1647);
// compiled call node returning call1655 (depth = 4)
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1656 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1657 = gc_frame_new();
// call case 4: self request
  Object call1658 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1657);
// compiled member node returning call1658 (depth = 5)
  gc_frame_newslot(call1658);
// starting to compile block node (depth = 5)
  Object block1659 = alloc_Block(NULL, NULL, "ast", 367);
  gc_frame_newslot(block1659);
// method "_apply(_)"
  block_savedest(block1659);
  Object closure1660 = createclosure(3, "_apply(1)");
  setclosureframe(closure1660, stackframe);
  addtoclosure(closure1660, var_visitor);
  addtoclosure(closure1660, var_newChain);
  addtoclosure(closure1660, selfslot);
  struct UserObject *uo1660 = (struct UserObject*)block1659;
  uo1660->data[0] = (Object)closure1660;
  Method *meth_meth_ast__apply_40_1_41_1660 = addmethod2pos(block1659, "_apply(1)", &meth_ast__apply_40_1_41_1660, 0);
  int argcv_meth_ast__apply_40_1_41_1660[] = {1};
  meth_meth_ast__apply_40_1_41_1660->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1660);
  meth_meth_ast__apply_40_1_41_1660->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1660->definitionLine = 2981;
// compiled block node returning block1659 (depth = 5)
  gc_frame_newslot(block1659);
// call case 5: prelude request
  params[0] = call1658;
  params[1] = block1659;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1664 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1656);
// compiled call node returning call1664 (depth = 4)
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1667 = gc_frame_new();
// call case 4: self request
  Object call1668 = callmethodflags(self, "matchingPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1667);
// compiled member node returning call1668 (depth = 6)
  int op_slot_right_1666 = gc_frame_newslot(call1668);
// starting to compile identifier node (depth = 6)
  Object bool1670 = alloc_Boolean(0);
// compiled identifier node returning bool1670 (depth = 6)
  int op_slot_left_1666 = gc_frame_newslot(bool1670);
  params[0] = call1668;
  partcv[0] = 1;
  Object opresult1671 = callmethod(bool1670, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1671 (depth = 5)
  Object if1665 = done;
  if (istrue(opresult1671)) {
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1672 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1673 = gc_frame_new();
// call case 4: self request
  Object call1674 = callmethodflags(self, "matchingPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1673);
// compiled member node returning call1674 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1675 = callmethodflags(call1674, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1672);
// compiled call node returning call1675 (depth = 5)
    gc_frame_newslot(call1675);
    if1665 = call1675;
  } else {
  }
// compiled if node returning if1665 (depth = 4)
    gc_frame_newslot(if1665);
    if1642 = if1665;
  } else {
  }
// compiled if node returning if1642 (depth = 3)
  gc_frame_end(frame);
  return if1642;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_1676(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1677 = gc_frame_new();
// call case 4: self request
  Object call1678 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1677);
// compiled member node returning call1678 (depth = 4)
  *var_n = call1678;
  if (call1678 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1679 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1680 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1679);
// compiled call node returning call1680 (depth = 4)
  *var_newChain = call1680;
  if (call1680 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1681 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1682 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1683 = gc_frame_new();
// call case 4: self request
  Object call1684 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1683);
// compiled member node returning call1684 (depth = 5)
  gc_frame_newslot(call1684);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1685 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1686 = gc_frame_new();
// call case 3: self.outer request
  Object call1687 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1686);
// compiled member node returning call1687 (depth = 6)
  Object call1688 = callmethodflags(call1687, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1685);
// compiled member node returning call1688 (depth = 5)
  params[0] = call1684;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1689 = callmethodflags(call1688, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1682);
// compiled call node returning call1689 (depth = 4)
  gc_frame_newslot(call1689);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1689;
  partcv[0] = 1;
  Object call1690 = callmethodflags(*var_n, "params:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1681);
// compiled call node returning call1690 (depth = 3)
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1691 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1692 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1693 = gc_frame_new();
// call case 4: self request
  Object call1694 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1693);
// compiled member node returning call1694 (depth = 5)
  gc_frame_newslot(call1694);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1695 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1696 = gc_frame_new();
// call case 3: self.outer request
  Object call1697 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1696);
// compiled member node returning call1697 (depth = 6)
  Object call1698 = callmethodflags(call1697, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1695);
// compiled member node returning call1698 (depth = 5)
  params[0] = call1694;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1699 = callmethodflags(call1698, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1692);
// compiled call node returning call1699 (depth = 4)
  gc_frame_newslot(call1699);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1699;
  partcv[0] = 1;
  Object call1700 = callmethodflags(*var_n, "body:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1691);
// compiled call node returning call1700 (depth = 3)
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1701 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1702 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1703 = gc_frame_new();
// call case 4: self request
  Object call1704 = callmethodflags(self, "matchingPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1703);
// compiled member node returning call1704 (depth = 5)
  gc_frame_newslot(call1704);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1705 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1706 = gc_frame_new();
// call case 3: self.outer request
  Object call1707 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1706);
// compiled member node returning call1707 (depth = 6)
  Object call1708 = callmethodflags(call1707, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1705);
// compiled member node returning call1708 (depth = 5)
  params[0] = call1704;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1709 = callmethodflags(call1708, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1702);
// compiled call node returning call1709 (depth = 4)
  gc_frame_newslot(call1709);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1709;
  partcv[0] = 1;
  Object call1710 = callmethodflags(*var_n, "matchingPattern:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1701);
// compiled call node returning call1710 (depth = 3)
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1711 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1712 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1711);
// compiled call node returning call1712 (depth = 3)
  gc_frame_end(frame);
  return call1712;
}
Object meth_ast__apply_40_1_41_1721(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1723 == NULL) {
    strlit1723 = alloc_String("  ");
    gc_root(strlit1723);
  }
// compiled string node returning strlit1723 (depth = 7)
  int op_slot_right_1722 = gc_frame_newslot(strlit1723);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_1722 = gc_frame_newslot(*var_spc);
  params[0] = strlit1723;
  partcv[0] = 1;
  Object opresult1725 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult1725 (depth = 6)
  *var_spc = opresult1725;
  if (opresult1725 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_1747(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1749 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1751 = alloc_Float64(1);
// compiled num node returning num1751 (depth = 9)
  int op_slot_right_1750 = gc_frame_newslot(num1751);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1750 = gc_frame_newslot(*var_depth);
  params[0] = num1751;
  partcv[0] = 1;
  Object sum1753 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1753 (depth = 8)
  gc_frame_newslot(sum1753);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum1753;
  partcv[0] = 1;
  Object call1754 = callmethodflags(*var_mx, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1749);
// compiled call node returning call1754 (depth = 7)
  int op_slot_right_1748 = gc_frame_newslot(call1754);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1756 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1759 == NULL) {
    strlit1759 = alloc_String("""\x0a""  ");
    gc_root(strlit1759);
  }
// compiled string node returning strlit1759 (depth = 9)
  int op_slot_right_1758 = gc_frame_newslot(strlit1759);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1758 = gc_frame_newslot(*var_s);
  params[0] = strlit1759;
  partcv[0] = 1;
  Object opresult1761 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1761 (depth = 8)
  int op_slot_left_1756 = gc_frame_newslot(opresult1761);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1762 = callmethod(opresult1761, "++(1)", 1, partcv, params);
// compiled op node returning opresult1762 (depth = 7)
  int op_slot_left_1748 = gc_frame_newslot(opresult1762);
  params[0] = call1754;
  partcv[0] = 1;
  Object opresult1763 = callmethod(opresult1762, "++(1)", 1, partcv, params);
// compiled op node returning opresult1763 (depth = 6)
  *var_s = opresult1763;
  if (opresult1763 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_1784(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1786 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1788 = alloc_Float64(1);
// compiled num node returning num1788 (depth = 9)
  int op_slot_right_1787 = gc_frame_newslot(num1788);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1787 = gc_frame_newslot(*var_depth);
  params[0] = num1788;
  partcv[0] = 1;
  Object sum1790 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1790 (depth = 8)
  gc_frame_newslot(sum1790);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum1790;
  partcv[0] = 1;
  Object call1791 = callmethodflags(*var_mx, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1786);
// compiled call node returning call1791 (depth = 7)
  int op_slot_right_1785 = gc_frame_newslot(call1791);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1793 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1796 == NULL) {
    strlit1796 = alloc_String("""\x0a""  ");
    gc_root(strlit1796);
  }
// compiled string node returning strlit1796 (depth = 9)
  int op_slot_right_1795 = gc_frame_newslot(strlit1796);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1795 = gc_frame_newslot(*var_s);
  params[0] = strlit1796;
  partcv[0] = 1;
  Object opresult1798 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1798 (depth = 8)
  int op_slot_left_1793 = gc_frame_newslot(opresult1798);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1799 = callmethod(opresult1798, "++(1)", 1, partcv, params);
// compiled op node returning opresult1799 (depth = 7)
  int op_slot_left_1785 = gc_frame_newslot(opresult1799);
  params[0] = call1791;
  partcv[0] = 1;
  Object opresult1800 = callmethod(opresult1799, "++(1)", 1, partcv, params);
// compiled op node returning opresult1800 (depth = 6)
  *var_s = opresult1800;
  if (opresult1800 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_1713(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1714 == NULL) {
    strlit1714 = alloc_String("");
    gc_root(strlit1714);
  }
// compiled string node returning strlit1714 (depth = 4)
  *var_spc = strlit1714;
  if (strlit1714 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1715 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_1716 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num1718 = alloc_Float64(0);
// compiled num node returning num1718 (depth = 5)
  int op_slot_left_1716 = gc_frame_newslot(num1718);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1719 = callmethod(num1718, "..(1)", 1, partcv, params);
// compiled op node returning opresult1719 (depth = 4)
  gc_frame_newslot(opresult1719);
// starting to compile block node (depth = 4)
  Object block1720 = alloc_Block(NULL, NULL, "ast", 385);
  gc_frame_newslot(block1720);
// method "_apply(_)"
  block_savedest(block1720);
  Object closure1721 = createclosure(2, "_apply(1)");
  setclosureframe(closure1721, stackframe);
  addtoclosure(closure1721, var_spc);
  addtoclosure(closure1721, selfslot);
  struct UserObject *uo1721 = (struct UserObject*)block1720;
  uo1721->data[0] = (Object)closure1721;
  Method *meth_meth_ast__apply_40_1_41_1721 = addmethod2pos(block1720, "_apply(1)", &meth_ast__apply_40_1_41_1721, 0);
  int argcv_meth_ast__apply_40_1_41_1721[] = {1};
  meth_meth_ast__apply_40_1_41_1721->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1721);
  meth_meth_ast__apply_40_1_41_1721->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1721->definitionLine = 2981;
// compiled block node returning block1720 (depth = 4)
  gc_frame_newslot(block1720);
// call case 5: prelude request
  params[0] = opresult1719;
  params[1] = block1720;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1728 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1715);
// compiled call node returning call1728 (depth = 3)
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1730 == NULL) {
    strlit1730 = alloc_String("""\x0a""");
    gc_root(strlit1730);
  }
// compiled string node returning strlit1730 (depth = 5)
  int op_slot_right_1729 = gc_frame_newslot(strlit1730);
// starting to compile call node (depth = 5)
  int callframe1732 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call1733 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1732);
// compiled call node returning call1733 (depth = 5)
  int op_slot_left_1729 = gc_frame_newslot(call1733);
  params[0] = strlit1730;
  partcv[0] = 1;
  Object opresult1734 = callmethod(call1733, "++(1)", 1, partcv, params);
// compiled op node returning opresult1734 (depth = 4)
  *var_s = opresult1734;
  if (opresult1734 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1736 == NULL) {
    strlit1736 = alloc_String("Parameters:");
    gc_root(strlit1736);
  }
// compiled string node returning strlit1736 (depth = 5)
  int op_slot_right_1735 = gc_frame_newslot(strlit1736);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1738 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1738 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1740 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1740 (depth = 5)
  int op_slot_left_1735 = gc_frame_newslot(opresult1740);
  params[0] = strlit1736;
  partcv[0] = 1;
  Object opresult1741 = callmethod(opresult1740, "++(1)", 1, partcv, params);
// compiled op node returning opresult1741 (depth = 4)
  *var_s = opresult1741;
  if (opresult1741 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1743 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1744 = gc_frame_new();
// call case 4: self request
  Object call1745 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1744);
// compiled member node returning call1745 (depth = 4)
  gc_frame_newslot(call1745);
// starting to compile block node (depth = 4)
  Object block1746 = alloc_Block(NULL, NULL, "ast", 390);
  gc_frame_newslot(block1746);
// method "_apply(_)"
  block_savedest(block1746);
  Object closure1747 = createclosure(4, "_apply(1)");
  setclosureframe(closure1747, stackframe);
  addtoclosure(closure1747, var_depth);
  addtoclosure(closure1747, var_spc);
  addtoclosure(closure1747, var_s);
  addtoclosure(closure1747, selfslot);
  struct UserObject *uo1747 = (struct UserObject*)block1746;
  uo1747->data[0] = (Object)closure1747;
  Method *meth_meth_ast__apply_40_1_41_1747 = addmethod2pos(block1746, "_apply(1)", &meth_ast__apply_40_1_41_1747, 0);
  int argcv_meth_ast__apply_40_1_41_1747[] = {1};
  meth_meth_ast__apply_40_1_41_1747->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1747);
  meth_meth_ast__apply_40_1_41_1747->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1747->definitionLine = 2981;
// compiled block node returning block1746 (depth = 4)
  gc_frame_newslot(block1746);
// call case 5: prelude request
  params[0] = call1745;
  params[1] = block1746;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1766 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1743);
// compiled call node returning call1766 (depth = 3)
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1768 == NULL) {
    strlit1768 = alloc_String("""\x0a""");
    gc_root(strlit1768);
  }
// compiled string node returning strlit1768 (depth = 5)
  int op_slot_right_1767 = gc_frame_newslot(strlit1768);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_1767 = gc_frame_newslot(*var_s);
  params[0] = strlit1768;
  partcv[0] = 1;
  Object opresult1770 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1770 (depth = 4)
  *var_s = opresult1770;
  if (opresult1770 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1773 == NULL) {
    strlit1773 = alloc_String("Body:");
    gc_root(strlit1773);
  }
// compiled string node returning strlit1773 (depth = 5)
  int op_slot_right_1772 = gc_frame_newslot(strlit1773);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1775 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1775 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1777 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1777 (depth = 5)
  int op_slot_left_1772 = gc_frame_newslot(opresult1777);
  params[0] = strlit1773;
  partcv[0] = 1;
  Object opresult1778 = callmethod(opresult1777, "++(1)", 1, partcv, params);
// compiled op node returning opresult1778 (depth = 4)
  *var_s = opresult1778;
  if (opresult1778 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1780 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1781 = gc_frame_new();
// call case 4: self request
  Object call1782 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1781);
// compiled member node returning call1782 (depth = 4)
  gc_frame_newslot(call1782);
// starting to compile block node (depth = 4)
  Object block1783 = alloc_Block(NULL, NULL, "ast", 395);
  gc_frame_newslot(block1783);
// method "_apply(_)"
  block_savedest(block1783);
  Object closure1784 = createclosure(4, "_apply(1)");
  setclosureframe(closure1784, stackframe);
  addtoclosure(closure1784, var_depth);
  addtoclosure(closure1784, var_spc);
  addtoclosure(closure1784, var_s);
  addtoclosure(closure1784, selfslot);
  struct UserObject *uo1784 = (struct UserObject*)block1783;
  uo1784->data[0] = (Object)closure1784;
  Method *meth_meth_ast__apply_40_1_41_1784 = addmethod2pos(block1783, "_apply(1)", &meth_ast__apply_40_1_41_1784, 0);
  int argcv_meth_ast__apply_40_1_41_1784[] = {1};
  meth_meth_ast__apply_40_1_41_1784->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1784);
  meth_meth_ast__apply_40_1_41_1784->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1784->definitionLine = 2981;
// compiled block node returning block1783 (depth = 4)
  gc_frame_newslot(block1783);
// call case 5: prelude request
  params[0] = call1782;
  params[1] = block1783;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1803 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1780);
// compiled call node returning call1803 (depth = 3)
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1806 = gc_frame_new();
// call case 4: self request
  Object call1807 = callmethodflags(self, "matchingPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1806);
// compiled member node returning call1807 (depth = 5)
  int op_slot_right_1805 = gc_frame_newslot(call1807);
// starting to compile identifier node (depth = 5)
  Object bool1809 = alloc_Boolean(0);
// compiled identifier node returning bool1809 (depth = 5)
  int op_slot_left_1805 = gc_frame_newslot(bool1809);
  params[0] = call1807;
  partcv[0] = 1;
  Object opresult1810 = callmethod(bool1809, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1810 (depth = 4)
  Object if1804 = done;
  if (istrue(opresult1810)) {
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1812 == NULL) {
    strlit1812 = alloc_String("""\x0a""");
    gc_root(strlit1812);
  }
// compiled string node returning strlit1812 (depth = 6)
  int op_slot_right_1811 = gc_frame_newslot(strlit1812);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1811 = gc_frame_newslot(*var_s);
  params[0] = strlit1812;
  partcv[0] = 1;
  Object opresult1814 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1814 (depth = 5)
  *var_s = opresult1814;
  if (opresult1814 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1817 == NULL) {
    strlit1817 = alloc_String("Pattern:");
    gc_root(strlit1817);
  }
// compiled string node returning strlit1817 (depth = 6)
  int op_slot_right_1816 = gc_frame_newslot(strlit1817);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1819 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1819 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1821 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1821 (depth = 6)
  int op_slot_left_1816 = gc_frame_newslot(opresult1821);
  params[0] = strlit1817;
  partcv[0] = 1;
  Object opresult1822 = callmethod(opresult1821, "++(1)", 1, partcv, params);
// compiled op node returning opresult1822 (depth = 5)
  *var_s = opresult1822;
  if (opresult1822 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 401
  setline(401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1825 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1827 = alloc_Float64(1);
// compiled num node returning num1827 (depth = 8)
  int op_slot_right_1826 = gc_frame_newslot(num1827);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_1826 = gc_frame_newslot(*var_depth);
  params[0] = num1827;
  partcv[0] = 1;
  Object sum1829 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1829 (depth = 7)
  gc_frame_newslot(sum1829);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1830 = gc_frame_new();
// call case 4: self request
  Object call1831 = callmethodflags(self, "matchingPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1830);
// compiled member node returning call1831 (depth = 7)
  params[0] = sum1829;
  partcv[0] = 1;
  Object call1832 = callmethodflags(call1831, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1825);
// compiled call node returning call1832 (depth = 6)
  int op_slot_right_1824 = gc_frame_newslot(call1832);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1834 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1837 == NULL) {
    strlit1837 = alloc_String("""\x0a""  ");
    gc_root(strlit1837);
  }
// compiled string node returning strlit1837 (depth = 8)
  int op_slot_right_1836 = gc_frame_newslot(strlit1837);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1836 = gc_frame_newslot(*var_s);
  params[0] = strlit1837;
  partcv[0] = 1;
  Object opresult1839 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1839 (depth = 7)
  int op_slot_left_1834 = gc_frame_newslot(opresult1839);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1840 = callmethod(opresult1839, "++(1)", 1, partcv, params);
// compiled op node returning opresult1840 (depth = 6)
  int op_slot_left_1824 = gc_frame_newslot(opresult1840);
  params[0] = call1832;
  partcv[0] = 1;
  Object opresult1841 = callmethod(opresult1840, "++(1)", 1, partcv, params);
// compiled op node returning opresult1841 (depth = 5)
  *var_s = opresult1841;
  if (opresult1841 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1804 = done;
  } else {
  }
// compiled if node returning if1804 (depth = 3)
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1847(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 408
  setline(408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1849 == NULL) {
    strlit1849 = alloc_String("    ");
    gc_root(strlit1849);
  }
// compiled string node returning strlit1849 (depth = 7)
  int op_slot_right_1848 = gc_frame_newslot(strlit1849);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_1848 = gc_frame_newslot(*var_spc);
  params[0] = strlit1849;
  partcv[0] = 1;
  Object opresult1851 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult1851 (depth = 6)
  *var_spc = opresult1851;
  if (opresult1851 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_1876(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1877 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1878 = gc_frame_new();
// call case 4: self request
  Object call1879 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1878);
// compiled member node returning call1879 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1880 = callmethodflags(call1879, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1877);
// compiled call node returning call1880 (depth = 7)
  *var_p = call1880;
  if (call1880 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1883 = gc_frame_new();
// call case 4: self request
  Object call1884 = callmethodflags(self, "matchingPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1883);
// compiled member node returning call1884 (depth = 8)
  int op_slot_right_1882 = gc_frame_newslot(call1884);
// starting to compile identifier node (depth = 8)
  Object bool1886 = alloc_Boolean(0);
// compiled identifier node returning bool1886 (depth = 8)
  int op_slot_left_1882 = gc_frame_newslot(bool1886);
  params[0] = call1884;
  partcv[0] = 1;
  Object opresult1887 = callmethod(bool1886, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1887 (depth = 7)
  Object if1881 = done;
  if (istrue(opresult1887)) {
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1889 == NULL) {
    strlit1889 = alloc_String(")");
    gc_root(strlit1889);
  }
// compiled string node returning strlit1889 (depth = 9)
  int op_slot_right_1888 = gc_frame_newslot(strlit1889);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1892 = gc_frame_new();
// starting to compile num node (depth = 11)
  Object num1893 = alloc_Float64(0);
// compiled num node returning num1893 (depth = 11)
  gc_frame_newslot(num1893);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = num1893;
  partcv[0] = 1;
  Object call1894 = callmethodflags(*var_p, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1892);
// compiled call node returning call1894 (depth = 10)
  int op_slot_right_1891 = gc_frame_newslot(call1894);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1897 == NULL) {
    strlit1897 = alloc_String("(");
    gc_root(strlit1897);
  }
// compiled string node returning strlit1897 (depth = 11)
  int op_slot_right_1896 = gc_frame_newslot(strlit1897);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1896 = gc_frame_newslot(*var_s);
  params[0] = strlit1897;
  partcv[0] = 1;
  Object opresult1899 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1899 (depth = 10)
  int op_slot_left_1891 = gc_frame_newslot(opresult1899);
  params[0] = call1894;
  partcv[0] = 1;
  Object opresult1900 = callmethod(opresult1899, "++(1)", 1, partcv, params);
// compiled op node returning opresult1900 (depth = 9)
  int op_slot_left_1888 = gc_frame_newslot(opresult1900);
  params[0] = strlit1889;
  partcv[0] = 1;
  Object opresult1901 = callmethod(opresult1900, "++(1)", 1, partcv, params);
// compiled op node returning opresult1901 (depth = 8)
  *var_s = opresult1901;
  if (opresult1901 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1881 = done;
  } else {
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1904 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num1905 = alloc_Float64(0);
// compiled num node returning num1905 (depth = 10)
  gc_frame_newslot(num1905);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_p (depth = 10)
  params[0] = num1905;
  partcv[0] = 1;
  Object call1906 = callmethodflags(*var_p, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1904);
// compiled call node returning call1906 (depth = 9)
  int op_slot_right_1903 = gc_frame_newslot(call1906);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1903 = gc_frame_newslot(*var_s);
  params[0] = call1906;
  partcv[0] = 1;
  Object opresult1908 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1908 (depth = 8)
  *var_s = opresult1908;
  if (opresult1908 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1881 = done;
  }
// compiled if node returning if1881 (depth = 6)
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1912 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1913 = gc_frame_new();
// call case 4: self request
  Object call1914 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1913);
// compiled member node returning call1914 (depth = 9)
  Object call1915 = callmethodflags(call1914, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1912);
// compiled member node returning call1915 (depth = 8)
  int op_slot_right_1911 = gc_frame_newslot(call1915);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_left_1911 = gc_frame_newslot(*var_i);
  params[0] = call1915;
  partcv[0] = 1;
  Object opresult1917 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult1917 (depth = 7)
  Object if1910 = done;
  if (istrue(opresult1917)) {
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1919 == NULL) {
    strlit1919 = alloc_String(", ");
    gc_root(strlit1919);
  }
// compiled string node returning strlit1919 (depth = 9)
  int op_slot_right_1918 = gc_frame_newslot(strlit1919);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1918 = gc_frame_newslot(*var_s);
  params[0] = strlit1919;
  partcv[0] = 1;
  Object opresult1921 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1921 (depth = 8)
  *var_s = opresult1921;
  if (opresult1921 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1910 = done;
  } else {
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1924 == NULL) {
    strlit1924 = alloc_String(" ""\xe2""""\x86""""\x92""");
    gc_root(strlit1924);
  }
// compiled string node returning strlit1924 (depth = 9)
  int op_slot_right_1923 = gc_frame_newslot(strlit1924);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1923 = gc_frame_newslot(*var_s);
  params[0] = strlit1924;
  partcv[0] = 1;
  Object opresult1926 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1926 (depth = 8)
  *var_s = opresult1926;
  if (opresult1926 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1910 = done;
  }
// compiled if node returning if1910 (depth = 6)
  gc_frame_end(frame);
  return if1910;
}
Object meth_ast__apply_40_1_41_1934(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1936 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1938 = alloc_Float64(1);
// compiled num node returning num1938 (depth = 9)
  int op_slot_right_1937 = gc_frame_newslot(num1938);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1937 = gc_frame_newslot(*var_depth);
  params[0] = num1938;
  partcv[0] = 1;
  Object sum1940 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum1940 (depth = 8)
  gc_frame_newslot(sum1940);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum1940;
  partcv[0] = 1;
  Object call1941 = callmethodflags(*var_mx, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1936);
// compiled call node returning call1941 (depth = 7)
  int op_slot_right_1935 = gc_frame_newslot(call1941);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1943 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1946 == NULL) {
    strlit1946 = alloc_String("""\x0a""");
    gc_root(strlit1946);
  }
// compiled string node returning strlit1946 (depth = 9)
  int op_slot_right_1945 = gc_frame_newslot(strlit1946);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1945 = gc_frame_newslot(*var_s);
  params[0] = strlit1946;
  partcv[0] = 1;
  Object opresult1948 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1948 (depth = 8)
  int op_slot_left_1943 = gc_frame_newslot(opresult1948);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1949 = callmethod(opresult1948, "++(1)", 1, partcv, params);
// compiled op node returning opresult1949 (depth = 7)
  int op_slot_left_1935 = gc_frame_newslot(opresult1949);
  params[0] = call1941;
  partcv[0] = 1;
  Object opresult1950 = callmethod(opresult1949, "++(1)", 1, partcv, params);
// compiled op node returning opresult1950 (depth = 6)
  *var_s = opresult1950;
  if (opresult1950 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1965(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1967 == NULL) {
    strlit1967 = alloc_String("    ");
    gc_root(strlit1967);
  }
// compiled string node returning strlit1967 (depth = 7)
  int op_slot_right_1966 = gc_frame_newslot(strlit1967);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1966 = gc_frame_newslot(*var_s);
  params[0] = strlit1967;
  partcv[0] = 1;
  Object opresult1969 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1969 (depth = 6)
  *var_s = opresult1969;
  if (opresult1969 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_1843(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1844 == NULL) {
    strlit1844 = alloc_String("");
    gc_root(strlit1844);
  }
// compiled string node returning strlit1844 (depth = 4)
  *var_spc = strlit1844;
  if (strlit1844 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1845 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 4)
  Object block1846 = alloc_Block(NULL, NULL, "ast", 407);
  gc_frame_newslot(block1846);
// method "_apply"
  block_savedest(block1846);
  Object closure1847 = createclosure(2, "_apply");
  setclosureframe(closure1847, stackframe);
  addtoclosure(closure1847, var_spc);
  addtoclosure(closure1847, selfslot);
  struct UserObject *uo1847 = (struct UserObject*)block1846;
  uo1847->data[0] = (Object)closure1847;
  Method *meth_meth_ast__apply1847 = addmethod2pos(block1846, "_apply", &meth_ast__apply1847, 0);
  int argcv_meth_ast__apply1847[] = {0};
  meth_meth_ast__apply1847->type = alloc_MethodType(1, argcv_meth_ast__apply1847);
  meth_meth_ast__apply1847->definitionModule = modulename;
  meth_meth_ast__apply1847->definitionLine = 2981;
// compiled block node returning block1846 (depth = 4)
  gc_frame_newslot(block1846);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block1846;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1854 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1845);
// compiled call node returning call1854 (depth = 3)
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1855 == NULL) {
    strlit1855 = alloc_String("{");
    gc_root(strlit1855);
  }
// compiled string node returning strlit1855 (depth = 4)
  *var_s = strlit1855;
  if (strlit1855 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 411
  setline(411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1858 = alloc_Float64(0);
// compiled num node returning num1858 (depth = 5)
  int op_slot_right_1857 = gc_frame_newslot(num1858);
// starting to compile member node (depth = 5)
  int callframe1860 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1861 = gc_frame_new();
// call case 4: self request
  Object call1862 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1861);
// compiled member node returning call1862 (depth = 6)
  Object call1863 = callmethodflags(call1862, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1860);
// compiled member node returning call1863 (depth = 5)
  int op_slot_left_1857 = gc_frame_newslot(call1863);
  params[0] = num1858;
  partcv[0] = 1;
  Object opresult1864 = callmethod(call1863, ">(1)", 1, partcv, params);
// compiled op node returning opresult1864 (depth = 4)
  Object if1856 = done;
  if (istrue(opresult1864)) {
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1866 == NULL) {
    strlit1866 = alloc_String(" ");
    gc_root(strlit1866);
  }
// compiled string node returning strlit1866 (depth = 6)
  int op_slot_right_1865 = gc_frame_newslot(strlit1866);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1865 = gc_frame_newslot(*var_s);
  params[0] = strlit1866;
  partcv[0] = 1;
  Object opresult1868 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1868 (depth = 5)
  *var_s = opresult1868;
  if (opresult1868 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1870 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1871 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1872 = gc_frame_new();
// call case 4: self request
  Object call1873 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1872);
// compiled member node returning call1873 (depth = 6)
  Object call1874 = callmethodflags(call1873, "indices", 0, partcv, params, 0);
  gc_frame_end(callframe1871);
// compiled member node returning call1874 (depth = 5)
  gc_frame_newslot(call1874);
// starting to compile block node (depth = 5)
  Object block1875 = alloc_Block(NULL, NULL, "ast", 413);
  gc_frame_newslot(block1875);
// method "_apply(_)"
  block_savedest(block1875);
  Object closure1876 = createclosure(2, "_apply(1)");
  setclosureframe(closure1876, stackframe);
  addtoclosure(closure1876, var_s);
  addtoclosure(closure1876, selfslot);
  struct UserObject *uo1876 = (struct UserObject*)block1875;
  uo1876->data[0] = (Object)closure1876;
  Method *meth_meth_ast__apply_40_1_41_1876 = addmethod2pos(block1875, "_apply(1)", &meth_ast__apply_40_1_41_1876, 0);
  int argcv_meth_ast__apply_40_1_41_1876[] = {1};
  meth_meth_ast__apply_40_1_41_1876->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1876);
  meth_meth_ast__apply_40_1_41_1876->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1876->definitionLine = 2981;
// compiled block node returning block1875 (depth = 5)
  gc_frame_newslot(block1875);
// call case 5: prelude request
  params[0] = call1874;
  params[1] = block1875;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1929 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1870);
// compiled call node returning call1929 (depth = 4)
    gc_frame_newslot(call1929);
    if1856 = call1929;
  } else {
  }
// compiled if node returning if1856 (depth = 3)
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1930 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1931 = gc_frame_new();
// call case 4: self request
  Object call1932 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1931);
// compiled member node returning call1932 (depth = 4)
  gc_frame_newslot(call1932);
// starting to compile block node (depth = 4)
  Object block1933 = alloc_Block(NULL, NULL, "ast", 427);
  gc_frame_newslot(block1933);
// method "_apply(_)"
  block_savedest(block1933);
  Object closure1934 = createclosure(4, "_apply(1)");
  setclosureframe(closure1934, stackframe);
  addtoclosure(closure1934, var_depth);
  addtoclosure(closure1934, var_spc);
  addtoclosure(closure1934, var_s);
  addtoclosure(closure1934, selfslot);
  struct UserObject *uo1934 = (struct UserObject*)block1933;
  uo1934->data[0] = (Object)closure1934;
  Method *meth_meth_ast__apply_40_1_41_1934 = addmethod2pos(block1933, "_apply(1)", &meth_ast__apply_40_1_41_1934, 0);
  int argcv_meth_ast__apply_40_1_41_1934[] = {1};
  meth_meth_ast__apply_40_1_41_1934->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_1934);
  meth_meth_ast__apply_40_1_41_1934->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_1934->definitionLine = 2981;
// compiled block node returning block1933 (depth = 4)
  gc_frame_newslot(block1933);
// call case 5: prelude request
  params[0] = call1932;
  params[1] = block1933;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1953 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1930);
// compiled call node returning call1953 (depth = 3)
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1955 == NULL) {
    strlit1955 = alloc_String("""\x0a""");
    gc_root(strlit1955);
  }
// compiled string node returning strlit1955 (depth = 5)
  int op_slot_right_1954 = gc_frame_newslot(strlit1955);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_1954 = gc_frame_newslot(*var_s);
  params[0] = strlit1955;
  partcv[0] = 1;
  Object opresult1957 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1957 (depth = 4)
  *var_s = opresult1957;
  if (opresult1957 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1959 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1961 = alloc_Float64(1);
// compiled num node returning num1961 (depth = 5)
  int op_slot_right_1960 = gc_frame_newslot(num1961);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_left_1960 = gc_frame_newslot(*var_depth);
  params[0] = num1961;
  partcv[0] = 1;
  Object diff1963 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff1963 (depth = 4)
  gc_frame_newslot(diff1963);
// starting to compile block node (depth = 4)
  Object block1964 = alloc_Block(NULL, NULL, "ast", 431);
  gc_frame_newslot(block1964);
// method "_apply"
  block_savedest(block1964);
  Object closure1965 = createclosure(2, "_apply");
  setclosureframe(closure1965, stackframe);
  addtoclosure(closure1965, var_s);
  addtoclosure(closure1965, selfslot);
  struct UserObject *uo1965 = (struct UserObject*)block1964;
  uo1965->data[0] = (Object)closure1965;
  Method *meth_meth_ast__apply1965 = addmethod2pos(block1964, "_apply", &meth_ast__apply1965, 0);
  int argcv_meth_ast__apply1965[] = {0};
  meth_meth_ast__apply1965->type = alloc_MethodType(1, argcv_meth_ast__apply1965);
  meth_meth_ast__apply1965->definitionModule = modulename;
  meth_meth_ast__apply1965->definitionLine = 2981;
// compiled block node returning block1964 (depth = 4)
  gc_frame_newslot(block1964);
// call case 5: prelude request
  params[0] = diff1963;
  params[1] = block1964;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1972 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1959);
// compiled call node returning call1972 (depth = 3)
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1974 == NULL) {
    strlit1974 = alloc_String("}");
    gc_root(strlit1974);
  }
// compiled string node returning strlit1974 (depth = 4)
  int op_slot_right_1973 = gc_frame_newslot(strlit1974);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_1973 = gc_frame_newslot(*var_s);
  params[0] = strlit1974;
  partcv[0] = 1;
  Object opresult1976 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1976 (depth = 3)
  gc_frame_end(frame);
  return opresult1976;
}
Object meth_ast_shallowCopy1977(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_blockNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1978 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe1979 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1980 = gc_frame_new();
// call case 4: self request
  Object call1981 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1980);
// compiled member node returning call1981 (depth = 5)
  gc_frame_newslot(call1981);
// starting to compile member node (depth = 5)
  int callframe1982 = gc_frame_new();
// call case 4: self request
  Object call1983 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1982);
// compiled member node returning call1983 (depth = 5)
  gc_frame_newslot(call1983);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blockNode (depth = 5)
  params[0] = call1981;
  params[1] = call1983;
  partcv[0] = 2;
  Object call1984 = callmethodflags(*var_blockNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe1979);
// compiled call node returning call1984 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call1985 = callmethodflags(call1984, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1978);
// compiled call node returning call1985 (depth = 3)
  gc_frame_end(frame);
  return call1985;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_1986(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1987 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1988 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1987);
// compiled call node returning call1988 (depth = 3)
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1989 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1990 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call1991 = callmethodflags(*var_other, "matchingPattern", 0, partcv, params, 0);
  gc_frame_end(callframe1990);
// compiled member node returning call1991 (depth = 4)
  gc_frame_newslot(call1991);
// call case 4: self request
  params[0] = call1991;
  partcv[0] = 1;
  Object call1992 = callmethodflags(self, "matchingPattern:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1989);
// compiled call node returning call1992 (depth = 3)
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1993 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1994 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call1995 = callmethodflags(*var_other, "extraRuntimeData", 0, partcv, params, 0);
  gc_frame_end(callframe1994);
// compiled member node returning call1995 (depth = 4)
  gc_frame_newslot(call1995);
// call case 4: self request
  params[0] = call1995;
  partcv[0] = 1;
  Object call1996 = callmethodflags(self, "extraRuntimeData:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1993);
// compiled call node returning call1996 (depth = 3)
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast__apply_40_1_41_2010(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_patternMarkVisitor = getfromclosure(closure, 0);
  Object *var_ancestorChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2011 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_patternMarkVisitor (depth = 6)
  gc_frame_newslot(*var_patternMarkVisitor);
// starting to compile call node (depth = 6)
  int callframe2012 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ancestorChain (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call2013 = callmethodflags(*var_ancestorChain, "with(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2012);
// compiled call node returning call2013 (depth = 6)
  gc_frame_newslot(call2013);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  params[0] = *var_patternMarkVisitor;
  params[1] = call2013;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2014 = callmethodflags(*var_p, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2011);
// compiled call node returning call2014 (depth = 5)
  gc_frame_end(frame);
  return call2014;
}
Object meth_ast_new_40_2_41_1559(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_blockNode = getfromclosure(closure, 1);
  Object *var_patternMarkVisitor = getfromclosure(closure, 2);
  Object *var_ancestorChain = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1560 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1560 = alloc_userobj2(28,25, objclass1560);
  gc_frame_newslot(obj1560);
if (objclass1560 == NULL) {
  glfree(obj1560->class->name);
  obj1560->class->name = "blockNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1560, self, 0);
  addmethodreal(obj1560,"outer", &reader_ast_outer_1561);
  Object oldself1560 = self;
  struct StackFrameObject *oldstackframe1560 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1560);
  gc_frame_newslot((Object)stackframe);
  self = obj1560;
  Object *oldselfslot1560 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1560 = (*(struct UserObject *)self).data[0], lowerouter1560 = thisouter1560;
  if (inheritingObject1560) {
    struct UserObject *inho1560 = (struct UserObject *)inheritingObject1560;
    while (inho1560->super != GraceDefaultObject) inho1560 = (struct UserObject *)inho1560->super;
    inho1560->super = obj1560;
    self = inheritingObject1560;
    *selfslot = self;
    lowerouter1560 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1560;
  }
if (objclass1560 == NULL) {
  Method *reader1562 = addmethodrealflags(obj1560, "kind",&reader_ast_kind_1562, MFLAG_DEF);
  reader1562->definitionModule = modulename;
  reader1562->definitionLine = 329;
}
adddatum2(obj1560, alloc_Undefined(), 1);
if (objclass1560 == NULL) {
  Method *reader1563 = addmethodrealflags(obj1560, "value",&reader_ast_value_1563, MFLAG_DEF);
  reader1563->definitionModule = modulename;
  reader1563->definitionLine = 330;
}
adddatum2(obj1560, alloc_Undefined(), 2);
if (objclass1560 == NULL) {
  Method *reader1564 = addmethodrealflags(obj1560, "params", &reader_ast_params_1564, 0);
  Method *writer1564 = addmethodrealflags(obj1560, "params:=(1)", &writer_ast_params_1564, 0);
  reader1564->definitionModule = modulename;
  writer1564->definitionModule = modulename;
  reader1564->definitionLine = 331;
  writer1564->definitionLine = 331;
}
obj1560->flags |= OFLAG_MUTABLE;
adddatum2(obj1560, alloc_Undefined(), 3);
if (objclass1560 == NULL) {
  Method *reader1565 = addmethodrealflags(obj1560, "body", &reader_ast_body_1565, 0);
  Method *writer1565 = addmethodrealflags(obj1560, "body:=(1)", &writer_ast_body_1565, 0);
  reader1565->definitionModule = modulename;
  writer1565->definitionModule = modulename;
  reader1565->definitionLine = 332;
  writer1565->definitionLine = 332;
}
obj1560->flags |= OFLAG_MUTABLE;
adddatum2(obj1560, alloc_Undefined(), 4);
if (objclass1560 == NULL) {
  Method *reader1566 = addmethodrealflags(obj1560, "selfclosure",&reader_ast_selfclosure_1566, MFLAG_DEF);
  reader1566->definitionModule = modulename;
  reader1566->definitionLine = 333;
}
adddatum2(obj1560, alloc_Undefined(), 5);
if (objclass1560 == NULL) {
  Method *reader1567 = addmethodrealflags(obj1560, "matchingPattern", &reader_ast_matchingPattern_1567, 0);
  Method *writer1567 = addmethodrealflags(obj1560, "matchingPattern:=(1)", &writer_ast_matchingPattern_1567, 0);
  reader1567->definitionModule = modulename;
  writer1567->definitionModule = modulename;
  reader1567->definitionLine = 334;
  writer1567->definitionLine = 334;
}
obj1560->flags |= OFLAG_MUTABLE;
adddatum2(obj1560, alloc_Undefined(), 6);
if (objclass1560 == NULL) {
  Method *reader1568 = addmethodrealflags(obj1560, "extraRuntimeData", &reader_ast_extraRuntimeData_1568, 0);
  Method *writer1568 = addmethodrealflags(obj1560, "extraRuntimeData:=(1)", &writer_ast_extraRuntimeData_1568, 0);
  reader1568->definitionModule = modulename;
  writer1568->definitionModule = modulename;
  reader1568->definitionLine = 335;
  writer1568->definitionLine = 335;
}
obj1560->flags |= OFLAG_MUTABLE;
adddatum2(obj1560, alloc_Undefined(), 7);
// method "isBlock"
  struct UserObject *uo1569 = (struct UserObject*)obj1560;
  uo1569->data[8] = emptyclosure;
  Method *meth_meth_ast_isBlock1569 = addmethod2pos(obj1560, "isBlock", &meth_ast_isBlock1569, 8);
  int argcv_meth_ast_isBlock1569[] = {0};
  meth_meth_ast_isBlock1569->type = alloc_MethodType(1, argcv_meth_ast_isBlock1569);
  meth_meth_ast_isBlock1569->definitionModule = modulename;
  meth_meth_ast_isBlock1569->definitionLine = 339;
// method "isDelimited"
  struct UserObject *uo1571 = (struct UserObject*)obj1560;
  uo1571->data[9] = emptyclosure;
  Method *meth_meth_ast_isDelimited1571 = addmethod2pos(obj1560, "isDelimited", &meth_ast_isDelimited1571, 9);
  int argcv_meth_ast_isDelimited1571[] = {0};
  meth_meth_ast_isDelimited1571->type = alloc_MethodType(1, argcv_meth_ast_isDelimited1571);
  meth_meth_ast_isDelimited1571->definitionModule = modulename;
  meth_meth_ast_isDelimited1571->definitionLine = 340;
// method "isEmpty"
  struct UserObject *uo1573 = (struct UserObject*)obj1560;
  uo1573->data[10] = emptyclosure;
  Method *meth_meth_ast_isEmpty1573 = addmethod2pos(obj1560, "isEmpty", &meth_ast_isEmpty1573, 10);
  int argcv_meth_ast_isEmpty1573[] = {0};
  meth_meth_ast_isEmpty1573->type = alloc_MethodType(1, argcv_meth_ast_isEmpty1573);
  meth_meth_ast_isEmpty1573->definitionModule = modulename;
  meth_meth_ast_isEmpty1573->definitionLine = 341;
// method "isntEmpty"
  struct UserObject *uo1582 = (struct UserObject*)obj1560;
  uo1582->data[11] = emptyclosure;
  Method *meth_meth_ast_isntEmpty1582 = addmethod2pos(obj1560, "isntEmpty", &meth_ast_isntEmpty1582, 11);
  int argcv_meth_ast_isntEmpty1582[] = {0};
  meth_meth_ast_isntEmpty1582->type = alloc_MethodType(1, argcv_meth_ast_isntEmpty1582);
  meth_meth_ast_isntEmpty1582->definitionModule = modulename;
  meth_meth_ast_isntEmpty1582->definitionLine = 342;
// method "scope:=(_)"
  struct UserObject *uo1591 = (struct UserObject*)obj1560;
  uo1591->data[12] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_1591 = addmethod2pos(obj1560, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_1591, 12);
  int argcv_meth_ast_scope_58__61__40_1_41_1591[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_1591->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_1591);
  meth_meth_ast_scope_58__61__40_1_41_1591->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_1591->definitionLine = 343;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj1560);
  Object closure1596 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure1596, stackframe);
  addtoclosure(closure1596, var_k);
  struct UserObject *uo1596 = (struct UserObject*)obj1560;
  uo1596->data[13] = (Object)closure1596;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_1596 = addmethod2pos(obj1560, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_1596, 13);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_1596[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_1596->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_1596);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_1596->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_1596->definitionLine = 349;
// method "isMatchingBlock"
  struct UserObject *uo1599 = (struct UserObject*)obj1560;
  uo1599->data[14] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock1599 = addmethod2pos(obj1560, "isMatchingBlock", &meth_ast_isMatchingBlock1599, 14);
  int argcv_meth_ast_isMatchingBlock1599[] = {0};
  meth_meth_ast_isMatchingBlock1599->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock1599);
  meth_meth_ast_isMatchingBlock1599->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock1599->definitionLine = 350;
// method "returnsObject"
  struct UserObject *uo1608 = (struct UserObject*)obj1560;
  uo1608->data[15] = emptyclosure;
  Method *meth_meth_ast_returnsObject1608 = addmethod2pos(obj1560, "returnsObject", &meth_ast_returnsObject1608, 15);
  int argcv_meth_ast_returnsObject1608[] = {0};
  meth_meth_ast_returnsObject1608->type = alloc_MethodType(1, argcv_meth_ast_returnsObject1608);
  meth_meth_ast_returnsObject1608->definitionModule = modulename;
  meth_meth_ast_returnsObject1608->definitionLine = 351;
// method "returnedObjectScope"
  struct UserObject *uo1629 = (struct UserObject*)obj1560;
  uo1629->data[16] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope1629 = addmethod2pos(obj1560, "returnedObjectScope", &meth_ast_returnedObjectScope1629, 16);
  int argcv_meth_ast_returnedObjectScope1629[] = {0};
  meth_meth_ast_returnedObjectScope1629->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope1629);
  meth_meth_ast_returnedObjectScope1629->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope1629->definitionLine = 354;
// method "parametersDo(_)"
  struct UserObject *uo1636 = (struct UserObject*)obj1560;
  uo1636->data[17] = emptyclosure;
  Method *meth_meth_ast_parametersDo_40_1_41_1636 = addmethod2pos(obj1560, "parametersDo(1)", &meth_ast_parametersDo_40_1_41_1636, 17);
  int argcv_meth_ast_parametersDo_40_1_41_1636[] = {1};
  meth_meth_ast_parametersDo_40_1_41_1636->type = alloc_MethodType(1, argcv_meth_ast_parametersDo_40_1_41_1636);
  meth_meth_ast_parametersDo_40_1_41_1636->definitionModule = modulename;
  meth_meth_ast_parametersDo_40_1_41_1636->definitionLine = 358;
// method "accept(_)from(_)"
  struct UserObject *uo1641 = (struct UserObject*)obj1560;
  uo1641->data[18] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_1641 = addmethod2pos(obj1560, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_1641, 18);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_1641[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_1641->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_1641);
  meth_meth_ast_accept_40_1_41_from_40_1_41_1641->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_1641->definitionLine = 361;
// method "map(_)ancestors(_)"
  struct UserObject *uo1676 = (struct UserObject*)obj1560;
  uo1676->data[19] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_1676 = addmethod2pos(obj1560, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_1676, 19);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1676[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1676->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1676);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1676->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1676->definitionLine = 375;
// method "pretty(_)"
  struct UserObject *uo1713 = (struct UserObject*)obj1560;
  uo1713->data[20] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_1713 = addmethod2pos(obj1560, "pretty(1)", &meth_ast_pretty_40_1_41_1713, 20);
  int argcv_meth_ast_pretty_40_1_41_1713[] = {1};
  meth_meth_ast_pretty_40_1_41_1713->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_1713);
  meth_meth_ast_pretty_40_1_41_1713->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_1713->definitionLine = 383;
// method "toGrace(_)"
  struct UserObject *uo1843 = (struct UserObject*)obj1560;
  uo1843->data[21] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_1843 = addmethod2pos(obj1560, "toGrace(1)", &meth_ast_toGrace_40_1_41_1843, 21);
  int argcv_meth_ast_toGrace_40_1_41_1843[] = {1};
  meth_meth_ast_toGrace_40_1_41_1843->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_1843);
meth_meth_ast_toGrace_40_1_41_1843->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_1843->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_1843->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_1843->definitionLine = 405;
// method "shallowCopy"
  block_savedest(obj1560);
  Object closure1977 = createclosure(1, "shallowCopy");
  setclosureframe(closure1977, stackframe);
  addtoclosure(closure1977, var_blockNode);
  struct UserObject *uo1977 = (struct UserObject*)obj1560;
  uo1977->data[22] = (Object)closure1977;
  Method *meth_meth_ast_shallowCopy1977 = addmethod2pos(obj1560, "shallowCopy", &meth_ast_shallowCopy1977, 22);
  int argcv_meth_ast_shallowCopy1977[] = {0};
  meth_meth_ast_shallowCopy1977->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1977);
  meth_meth_ast_shallowCopy1977->definitionModule = modulename;
  meth_meth_ast_shallowCopy1977->definitionLine = 434;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo1986 = (struct UserObject*)obj1560;
  uo1986->data[23] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1986 = addmethod2pos(obj1560, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_1986, 23);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_1986[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1986->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_1986);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1986->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1986->definitionLine = 437;
  sourceObject = obj1560;
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1997 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1998 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1999 = gc_frame_new();
// call case 3: self.outer request
  Object call2000 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1999);
// compiled member node returning call2000 (depth = 5)
  Object call2001 = callmethodflags(call2000, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1998);
// compiled member node returning call2001 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2002 = callmethodflags(call2001, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1997);
// compiled call node returning call2002 (depth = 3)
  struct UserObject *obj1560_uo = (struct UserObject *)obj1560;
  obj1560_uo->super = call2002;
  sourceObject = obj1560;
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2003 == NULL) {
    strlit2003 = alloc_String("block");
    gc_root(strlit2003);
  }
// compiled string node returning strlit2003 (depth = 3)
  adddatum2(obj1560, strlit2003, 1);
  sourceObject = obj1560;
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2004 == NULL) {
    strlit2004 = alloc_String("block");
    gc_root(strlit2004);
  }
// compiled string node returning strlit2004 (depth = 3)
  adddatum2(obj1560, strlit2004, 2);
  sourceObject = obj1560;
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj1560, *var_params_39_, 3);
  sourceObject = obj1560;
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj1560, *var_body_39_, 4);
  sourceObject = obj1560;
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2005 = alloc_Boolean(1);
// compiled identifier node returning bool2005 (depth = 3)
  adddatum2(obj1560, bool2005, 5);
  sourceObject = obj1560;
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2006 = alloc_Boolean(0);
// compiled identifier node returning bool2006 (depth = 3)
  adddatum2(obj1560, bool2006, 6);
  sourceObject = obj1560;
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2007 = alloc_Boolean(0);
// compiled identifier node returning bool2007 (depth = 3)
  adddatum2(obj1560, bool2007, 7);
  sourceObject = obj1560;
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2008 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  gc_frame_newslot(*var_params_39_);
// starting to compile block node (depth = 4)
  Object block2009 = alloc_Block(NULL, NULL, "ast", 336);
  gc_frame_newslot(block2009);
// method "_apply(_)"
  block_savedest(block2009);
  Object closure2010 = createclosure(3, "_apply(1)");
  setclosureframe(closure2010, stackframe);
  addtoclosure(closure2010, var_patternMarkVisitor);
  addtoclosure(closure2010, var_ancestorChain);
  addtoclosure(closure2010, selfslot);
  struct UserObject *uo2010 = (struct UserObject*)block2009;
  uo2010->data[0] = (Object)closure2010;
  Method *meth_meth_ast__apply_40_1_41_2010 = addmethod2pos(block2009, "_apply(1)", &meth_ast__apply_40_1_41_2010, 0);
  int argcv_meth_ast__apply_40_1_41_2010[] = {1};
  meth_meth_ast__apply_40_1_41_2010->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2010);
  meth_meth_ast__apply_40_1_41_2010->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2010->definitionLine = 2981;
// compiled block node returning block2009 (depth = 4)
  gc_frame_newslot(block2009);
// call case 5: prelude request
  params[0] = *var_params_39_;
  params[1] = block2009;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2016 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2008);
// compiled call node returning call2016 (depth = 3)
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  objclass1560 = obj1560->class;
  objclass1560->definitionModule = modulename;
  objclass1560->definitionLine = 327;
  (*(struct UserObject *)self).data[0] = lowerouter1560;
  self = oldself1560;
  selfslot = oldselfslot1560;
  stackframe = oldstackframe1560;
  gc_frame_end(frame);
  return obj1560;
}
Object meth_ast_new_40_2_41_1559_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_blockNode = getfromclosure(closure, 1);
  Object *var_patternMarkVisitor = getfromclosure(closure, 2);
  Object *var_ancestorChain = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1560 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1560 = alloc_userobj2(28,25, objclass1560);
  gc_frame_newslot(obj1560);
if (objclass1560 == NULL) {
  glfree(obj1560->class->name);
  obj1560->class->name = "blockNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1560, self, 0);
  addmethodreal(obj1560,"outer", &reader_ast_outer_1561);
  Object oldself1560 = self;
  struct StackFrameObject *oldstackframe1560 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1560);
  gc_frame_newslot((Object)stackframe);
  self = obj1560;
  Object *oldselfslot1560 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1560 = (*(struct UserObject *)self).data[0], lowerouter1560 = thisouter1560;
  if (inheritingObject1560) {
    struct UserObject *inho1560 = (struct UserObject *)inheritingObject1560;
    while (inho1560->super != GraceDefaultObject) inho1560 = (struct UserObject *)inho1560->super;
    inho1560->super = obj1560;
    self = inheritingObject1560;
    *selfslot = self;
    lowerouter1560 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1560;
  }
if (objclass1560 == NULL) {
  Method *reader1562 = addmethodrealflags(obj1560, "kind",&reader_ast_kind_1562, MFLAG_DEF);
  reader1562->definitionModule = modulename;
  reader1562->definitionLine = 329;
}
adddatum2(obj1560, alloc_Undefined(), 1);
if (objclass1560 == NULL) {
  Method *reader1563 = addmethodrealflags(obj1560, "value",&reader_ast_value_1563, MFLAG_DEF);
  reader1563->definitionModule = modulename;
  reader1563->definitionLine = 330;
}
adddatum2(obj1560, alloc_Undefined(), 2);
if (objclass1560 == NULL) {
  Method *reader1564 = addmethodrealflags(obj1560, "params", &reader_ast_params_1564, 0);
  Method *writer1564 = addmethodrealflags(obj1560, "params:=(1)", &writer_ast_params_1564, 0);
  reader1564->definitionModule = modulename;
  writer1564->definitionModule = modulename;
  reader1564->definitionLine = 331;
  writer1564->definitionLine = 331;
}
obj1560->flags |= OFLAG_MUTABLE;
adddatum2(obj1560, alloc_Undefined(), 3);
if (objclass1560 == NULL) {
  Method *reader1565 = addmethodrealflags(obj1560, "body", &reader_ast_body_1565, 0);
  Method *writer1565 = addmethodrealflags(obj1560, "body:=(1)", &writer_ast_body_1565, 0);
  reader1565->definitionModule = modulename;
  writer1565->definitionModule = modulename;
  reader1565->definitionLine = 332;
  writer1565->definitionLine = 332;
}
obj1560->flags |= OFLAG_MUTABLE;
adddatum2(obj1560, alloc_Undefined(), 4);
if (objclass1560 == NULL) {
  Method *reader1566 = addmethodrealflags(obj1560, "selfclosure",&reader_ast_selfclosure_1566, MFLAG_DEF);
  reader1566->definitionModule = modulename;
  reader1566->definitionLine = 333;
}
adddatum2(obj1560, alloc_Undefined(), 5);
if (objclass1560 == NULL) {
  Method *reader1567 = addmethodrealflags(obj1560, "matchingPattern", &reader_ast_matchingPattern_1567, 0);
  Method *writer1567 = addmethodrealflags(obj1560, "matchingPattern:=(1)", &writer_ast_matchingPattern_1567, 0);
  reader1567->definitionModule = modulename;
  writer1567->definitionModule = modulename;
  reader1567->definitionLine = 334;
  writer1567->definitionLine = 334;
}
obj1560->flags |= OFLAG_MUTABLE;
adddatum2(obj1560, alloc_Undefined(), 6);
if (objclass1560 == NULL) {
  Method *reader1568 = addmethodrealflags(obj1560, "extraRuntimeData", &reader_ast_extraRuntimeData_1568, 0);
  Method *writer1568 = addmethodrealflags(obj1560, "extraRuntimeData:=(1)", &writer_ast_extraRuntimeData_1568, 0);
  reader1568->definitionModule = modulename;
  writer1568->definitionModule = modulename;
  reader1568->definitionLine = 335;
  writer1568->definitionLine = 335;
}
obj1560->flags |= OFLAG_MUTABLE;
adddatum2(obj1560, alloc_Undefined(), 7);
// method "isBlock"
  struct UserObject *uo1569 = (struct UserObject*)obj1560;
  uo1569->data[8] = emptyclosure;
  Method *meth_meth_ast_isBlock1569 = addmethod2pos(obj1560, "isBlock", &meth_ast_isBlock1569, 8);
  int argcv_meth_ast_isBlock1569[] = {0};
  meth_meth_ast_isBlock1569->type = alloc_MethodType(1, argcv_meth_ast_isBlock1569);
  meth_meth_ast_isBlock1569->definitionModule = modulename;
  meth_meth_ast_isBlock1569->definitionLine = 339;
// method "isDelimited"
  struct UserObject *uo1571 = (struct UserObject*)obj1560;
  uo1571->data[9] = emptyclosure;
  Method *meth_meth_ast_isDelimited1571 = addmethod2pos(obj1560, "isDelimited", &meth_ast_isDelimited1571, 9);
  int argcv_meth_ast_isDelimited1571[] = {0};
  meth_meth_ast_isDelimited1571->type = alloc_MethodType(1, argcv_meth_ast_isDelimited1571);
  meth_meth_ast_isDelimited1571->definitionModule = modulename;
  meth_meth_ast_isDelimited1571->definitionLine = 340;
// method "isEmpty"
  struct UserObject *uo1573 = (struct UserObject*)obj1560;
  uo1573->data[10] = emptyclosure;
  Method *meth_meth_ast_isEmpty1573 = addmethod2pos(obj1560, "isEmpty", &meth_ast_isEmpty1573, 10);
  int argcv_meth_ast_isEmpty1573[] = {0};
  meth_meth_ast_isEmpty1573->type = alloc_MethodType(1, argcv_meth_ast_isEmpty1573);
  meth_meth_ast_isEmpty1573->definitionModule = modulename;
  meth_meth_ast_isEmpty1573->definitionLine = 341;
// method "isntEmpty"
  struct UserObject *uo1582 = (struct UserObject*)obj1560;
  uo1582->data[11] = emptyclosure;
  Method *meth_meth_ast_isntEmpty1582 = addmethod2pos(obj1560, "isntEmpty", &meth_ast_isntEmpty1582, 11);
  int argcv_meth_ast_isntEmpty1582[] = {0};
  meth_meth_ast_isntEmpty1582->type = alloc_MethodType(1, argcv_meth_ast_isntEmpty1582);
  meth_meth_ast_isntEmpty1582->definitionModule = modulename;
  meth_meth_ast_isntEmpty1582->definitionLine = 342;
// method "scope:=(_)"
  struct UserObject *uo1591 = (struct UserObject*)obj1560;
  uo1591->data[12] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_1591 = addmethod2pos(obj1560, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_1591, 12);
  int argcv_meth_ast_scope_58__61__40_1_41_1591[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_1591->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_1591);
  meth_meth_ast_scope_58__61__40_1_41_1591->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_1591->definitionLine = 343;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj1560);
  Object closure1596 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure1596, stackframe);
  addtoclosure(closure1596, var_k);
  struct UserObject *uo1596 = (struct UserObject*)obj1560;
  uo1596->data[13] = (Object)closure1596;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_1596 = addmethod2pos(obj1560, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_1596, 13);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_1596[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_1596->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_1596);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_1596->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_1596->definitionLine = 349;
// method "isMatchingBlock"
  struct UserObject *uo1599 = (struct UserObject*)obj1560;
  uo1599->data[14] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock1599 = addmethod2pos(obj1560, "isMatchingBlock", &meth_ast_isMatchingBlock1599, 14);
  int argcv_meth_ast_isMatchingBlock1599[] = {0};
  meth_meth_ast_isMatchingBlock1599->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock1599);
  meth_meth_ast_isMatchingBlock1599->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock1599->definitionLine = 350;
// method "returnsObject"
  struct UserObject *uo1608 = (struct UserObject*)obj1560;
  uo1608->data[15] = emptyclosure;
  Method *meth_meth_ast_returnsObject1608 = addmethod2pos(obj1560, "returnsObject", &meth_ast_returnsObject1608, 15);
  int argcv_meth_ast_returnsObject1608[] = {0};
  meth_meth_ast_returnsObject1608->type = alloc_MethodType(1, argcv_meth_ast_returnsObject1608);
  meth_meth_ast_returnsObject1608->definitionModule = modulename;
  meth_meth_ast_returnsObject1608->definitionLine = 351;
// method "returnedObjectScope"
  struct UserObject *uo1629 = (struct UserObject*)obj1560;
  uo1629->data[16] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope1629 = addmethod2pos(obj1560, "returnedObjectScope", &meth_ast_returnedObjectScope1629, 16);
  int argcv_meth_ast_returnedObjectScope1629[] = {0};
  meth_meth_ast_returnedObjectScope1629->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope1629);
  meth_meth_ast_returnedObjectScope1629->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope1629->definitionLine = 354;
// method "parametersDo(_)"
  struct UserObject *uo1636 = (struct UserObject*)obj1560;
  uo1636->data[17] = emptyclosure;
  Method *meth_meth_ast_parametersDo_40_1_41_1636 = addmethod2pos(obj1560, "parametersDo(1)", &meth_ast_parametersDo_40_1_41_1636, 17);
  int argcv_meth_ast_parametersDo_40_1_41_1636[] = {1};
  meth_meth_ast_parametersDo_40_1_41_1636->type = alloc_MethodType(1, argcv_meth_ast_parametersDo_40_1_41_1636);
  meth_meth_ast_parametersDo_40_1_41_1636->definitionModule = modulename;
  meth_meth_ast_parametersDo_40_1_41_1636->definitionLine = 358;
// method "accept(_)from(_)"
  struct UserObject *uo1641 = (struct UserObject*)obj1560;
  uo1641->data[18] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_1641 = addmethod2pos(obj1560, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_1641, 18);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_1641[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_1641->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_1641);
  meth_meth_ast_accept_40_1_41_from_40_1_41_1641->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_1641->definitionLine = 361;
// method "map(_)ancestors(_)"
  struct UserObject *uo1676 = (struct UserObject*)obj1560;
  uo1676->data[19] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_1676 = addmethod2pos(obj1560, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_1676, 19);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1676[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1676->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1676);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1676->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1676->definitionLine = 375;
// method "pretty(_)"
  struct UserObject *uo1713 = (struct UserObject*)obj1560;
  uo1713->data[20] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_1713 = addmethod2pos(obj1560, "pretty(1)", &meth_ast_pretty_40_1_41_1713, 20);
  int argcv_meth_ast_pretty_40_1_41_1713[] = {1};
  meth_meth_ast_pretty_40_1_41_1713->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_1713);
  meth_meth_ast_pretty_40_1_41_1713->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_1713->definitionLine = 383;
// method "toGrace(_)"
  struct UserObject *uo1843 = (struct UserObject*)obj1560;
  uo1843->data[21] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_1843 = addmethod2pos(obj1560, "toGrace(1)", &meth_ast_toGrace_40_1_41_1843, 21);
  int argcv_meth_ast_toGrace_40_1_41_1843[] = {1};
  meth_meth_ast_toGrace_40_1_41_1843->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_1843);
meth_meth_ast_toGrace_40_1_41_1843->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_1843->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_1843->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_1843->definitionLine = 405;
// method "shallowCopy"
  block_savedest(obj1560);
  Object closure1977 = createclosure(1, "shallowCopy");
  setclosureframe(closure1977, stackframe);
  addtoclosure(closure1977, var_blockNode);
  struct UserObject *uo1977 = (struct UserObject*)obj1560;
  uo1977->data[22] = (Object)closure1977;
  Method *meth_meth_ast_shallowCopy1977 = addmethod2pos(obj1560, "shallowCopy", &meth_ast_shallowCopy1977, 22);
  int argcv_meth_ast_shallowCopy1977[] = {0};
  meth_meth_ast_shallowCopy1977->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1977);
  meth_meth_ast_shallowCopy1977->definitionModule = modulename;
  meth_meth_ast_shallowCopy1977->definitionLine = 434;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo1986 = (struct UserObject*)obj1560;
  uo1986->data[23] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1986 = addmethod2pos(obj1560, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_1986, 23);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_1986[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1986->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_1986);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1986->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_1986->definitionLine = 437;
  sourceObject = obj1560;
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1997 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1998 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1999 = gc_frame_new();
// call case 3: self.outer request
  Object call2000 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1999);
// compiled member node returning call2000 (depth = 5)
  Object call2001 = callmethodflags(call2000, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1998);
// compiled member node returning call2001 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2002 = callmethodflags(call2001, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1997);
// compiled call node returning call2002 (depth = 3)
  struct UserObject *obj1560_uo = (struct UserObject *)obj1560;
  obj1560_uo->super = call2002;
  sourceObject = obj1560;
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2003 == NULL) {
    strlit2003 = alloc_String("block");
    gc_root(strlit2003);
  }
// compiled string node returning strlit2003 (depth = 3)
  adddatum2(obj1560, strlit2003, 1);
  sourceObject = obj1560;
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2004 == NULL) {
    strlit2004 = alloc_String("block");
    gc_root(strlit2004);
  }
// compiled string node returning strlit2004 (depth = 3)
  adddatum2(obj1560, strlit2004, 2);
  sourceObject = obj1560;
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj1560, *var_params_39_, 3);
  sourceObject = obj1560;
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj1560, *var_body_39_, 4);
  sourceObject = obj1560;
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2005 = alloc_Boolean(1);
// compiled identifier node returning bool2005 (depth = 3)
  adddatum2(obj1560, bool2005, 5);
  sourceObject = obj1560;
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2006 = alloc_Boolean(0);
// compiled identifier node returning bool2006 (depth = 3)
  adddatum2(obj1560, bool2006, 6);
  sourceObject = obj1560;
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2007 = alloc_Boolean(0);
// compiled identifier node returning bool2007 (depth = 3)
  adddatum2(obj1560, bool2007, 7);
  sourceObject = obj1560;
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2008 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  gc_frame_newslot(*var_params_39_);
// starting to compile block node (depth = 4)
  Object block2009 = alloc_Block(NULL, NULL, "ast", 336);
  gc_frame_newslot(block2009);
// method "_apply(_)"
  block_savedest(block2009);
  Object closure2010 = createclosure(3, "_apply(1)");
  setclosureframe(closure2010, stackframe);
  addtoclosure(closure2010, var_patternMarkVisitor);
  addtoclosure(closure2010, var_ancestorChain);
  addtoclosure(closure2010, selfslot);
  struct UserObject *uo2010 = (struct UserObject*)block2009;
  uo2010->data[0] = (Object)closure2010;
  Method *meth_meth_ast__apply_40_1_41_2010 = addmethod2pos(block2009, "_apply(1)", &meth_ast__apply_40_1_41_2010, 0);
  int argcv_meth_ast__apply_40_1_41_2010[] = {1};
  meth_meth_ast__apply_40_1_41_2010->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2010);
  meth_meth_ast__apply_40_1_41_2010->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2010->definitionLine = 2981;
// compiled block node returning block2009 (depth = 4)
  gc_frame_newslot(block2009);
// call case 5: prelude request
  params[0] = *var_params_39_;
  params[1] = block2009;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2016 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2008);
// compiled call node returning call2016 (depth = 3)
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  sourceObject = obj1560;
  objclass1560 = obj1560->class;
  objclass1560->definitionModule = modulename;
  objclass1560->definitionLine = 327;
  (*(struct UserObject *)self).data[0] = lowerouter1560;
  self = oldself1560;
  selfslot = oldselfslot1560;
  stackframe = oldstackframe1560;
  gc_frame_end(frame);
  return obj1560;
}
Object meth_ast_blockNode2018(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blockNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blockNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blockNode (depth = 3)
  gc_frame_end(frame);
  return *var_blockNode;
}
Object meth_ast_isSimple2028(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2029 = alloc_Boolean(0);
// compiled identifier node returning bool2029 (depth = 3)
  gc_frame_end(frame);
  return bool2029;
}
Object meth_ast__apply_40_1_41_2044(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2045 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2046 = callmethodflags(*var_mx, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2045);
// compiled call node returning call2046 (depth = 6)
  gc_frame_end(frame);
  return call2046;
}
Object meth_ast_accept_40_1_41_from_40_1_41_2030(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2032 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2033 = callmethodflags(*var_visitor, "visitTryCatch(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2032);
// compiled call node returning call2033 (depth = 4)
  Object if2031 = done;
  if (istrue(call2033)) {
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2034 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call2035 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2034);
// compiled call node returning call2035 (depth = 5)
  *var_newChain = call2035;
  if (call2035 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2036 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2037 = gc_frame_new();
// call case 4: self request
  Object call2038 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2037);
// compiled member node returning call2038 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2039 = callmethodflags(call2038, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2036);
// compiled call node returning call2039 (depth = 4)
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2040 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2041 = gc_frame_new();
// call case 4: self request
  Object call2042 = callmethodflags(self, "cases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2041);
// compiled member node returning call2042 (depth = 5)
  gc_frame_newslot(call2042);
// starting to compile block node (depth = 5)
  Object block2043 = alloc_Block(NULL, NULL, "ast", 458);
  gc_frame_newslot(block2043);
// method "_apply(_)"
  block_savedest(block2043);
  Object closure2044 = createclosure(3, "_apply(1)");
  setclosureframe(closure2044, stackframe);
  addtoclosure(closure2044, var_visitor);
  addtoclosure(closure2044, var_newChain);
  addtoclosure(closure2044, selfslot);
  struct UserObject *uo2044 = (struct UserObject*)block2043;
  uo2044->data[0] = (Object)closure2044;
  Method *meth_meth_ast__apply_40_1_41_2044 = addmethod2pos(block2043, "_apply(1)", &meth_ast__apply_40_1_41_2044, 0);
  int argcv_meth_ast__apply_40_1_41_2044[] = {1};
  meth_meth_ast__apply_40_1_41_2044->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2044);
  meth_meth_ast__apply_40_1_41_2044->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2044->definitionLine = 2981;
// compiled block node returning block2043 (depth = 5)
  gc_frame_newslot(block2043);
// call case 5: prelude request
  params[0] = call2042;
  params[1] = block2043;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2048 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2040);
// compiled call node returning call2048 (depth = 4)
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2051 = gc_frame_new();
// call case 4: self request
  Object call2052 = callmethodflags(self, "finally", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2051);
// compiled member node returning call2052 (depth = 6)
  int op_slot_right_2050 = gc_frame_newslot(call2052);
// starting to compile identifier node (depth = 6)
  Object bool2054 = alloc_Boolean(0);
// compiled identifier node returning bool2054 (depth = 6)
  int op_slot_left_2050 = gc_frame_newslot(bool2054);
  params[0] = call2052;
  partcv[0] = 1;
  Object opresult2055 = callmethod(bool2054, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2055 (depth = 5)
  Object if2049 = done;
  if (istrue(opresult2055)) {
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2056 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2057 = gc_frame_new();
// call case 4: self request
  Object call2058 = callmethodflags(self, "finally", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2057);
// compiled member node returning call2058 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2059 = callmethodflags(call2058, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2056);
// compiled call node returning call2059 (depth = 5)
    gc_frame_newslot(call2059);
    if2049 = call2059;
  } else {
  }
// compiled if node returning if2049 (depth = 4)
    gc_frame_newslot(if2049);
    if2031 = if2049;
  } else {
  }
// compiled if node returning if2031 (depth = 3)
  gc_frame_end(frame);
  return if2031;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_2060(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2061 = gc_frame_new();
// call case 4: self request
  Object call2062 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2061);
// compiled member node returning call2062 (depth = 4)
  *var_n = call2062;
  if (call2062 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2063 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2064 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2063);
// compiled call node returning call2064 (depth = 4)
  *var_newChain = call2064;
  if (call2064 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 469
  setline(469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2065 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2066 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2067 = gc_frame_new();
// call case 4: self request
  Object call2068 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2067);
// compiled member node returning call2068 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2069 = callmethodflags(call2068, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2066);
// compiled call node returning call2069 (depth = 4)
  gc_frame_newslot(call2069);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2069;
  partcv[0] = 1;
  Object call2070 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2065);
// compiled call node returning call2070 (depth = 3)
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2071 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2072 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2073 = gc_frame_new();
// call case 4: self request
  Object call2074 = callmethodflags(self, "cases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2073);
// compiled member node returning call2074 (depth = 5)
  gc_frame_newslot(call2074);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2075 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2076 = gc_frame_new();
// call case 3: self.outer request
  Object call2077 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2076);
// compiled member node returning call2077 (depth = 6)
  Object call2078 = callmethodflags(call2077, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2075);
// compiled member node returning call2078 (depth = 5)
  params[0] = call2074;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2079 = callmethodflags(call2078, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2072);
// compiled call node returning call2079 (depth = 4)
  gc_frame_newslot(call2079);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2079;
  partcv[0] = 1;
  Object call2080 = callmethodflags(*var_n, "cases:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2071);
// compiled call node returning call2080 (depth = 3)
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2081 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2082 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2083 = gc_frame_new();
// call case 4: self request
  Object call2084 = callmethodflags(self, "finally", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2083);
// compiled member node returning call2084 (depth = 5)
  gc_frame_newslot(call2084);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2085 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2086 = gc_frame_new();
// call case 3: self.outer request
  Object call2087 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2086);
// compiled member node returning call2087 (depth = 6)
  Object call2088 = callmethodflags(call2087, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2085);
// compiled member node returning call2088 (depth = 5)
  params[0] = call2084;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2089 = callmethodflags(call2088, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2082);
// compiled call node returning call2089 (depth = 4)
  gc_frame_newslot(call2089);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2089;
  partcv[0] = 1;
  Object call2090 = callmethodflags(*var_n, "finally:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2081);
// compiled call node returning call2090 (depth = 3)
// Begin line 472
  setline(472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2091 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call2092 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2091);
// compiled call node returning call2092 (depth = 3)
  gc_frame_end(frame);
  return call2092;
}
Object meth_ast__apply_40_1_41_2101(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2103 == NULL) {
    strlit2103 = alloc_String("  ");
    gc_root(strlit2103);
  }
// compiled string node returning strlit2103 (depth = 7)
  int op_slot_right_2102 = gc_frame_newslot(strlit2103);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2102 = gc_frame_newslot(*var_spc);
  params[0] = strlit2103;
  partcv[0] = 1;
  Object opresult2105 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult2105 (depth = 6)
  *var_spc = opresult2105;
  if (opresult2105 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_2138(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2141 == NULL) {
    strlit2141 = alloc_String("");
    gc_root(strlit2141);
  }
// compiled string node returning strlit2141 (depth = 8)
  int op_slot_right_2140 = gc_frame_newslot(strlit2141);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2144 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2146 = alloc_Float64(2);
// compiled num node returning num2146 (depth = 11)
  int op_slot_right_2145 = gc_frame_newslot(num2146);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_2145 = gc_frame_newslot(*var_depth);
  params[0] = num2146;
  partcv[0] = 1;
  Object sum2148 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2148 (depth = 10)
  gc_frame_newslot(sum2148);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mx (depth = 10)
  params[0] = sum2148;
  partcv[0] = 1;
  Object call2149 = callmethodflags(*var_mx, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2144);
// compiled call node returning call2149 (depth = 9)
  int op_slot_right_2143 = gc_frame_newslot(call2149);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2152 == NULL) {
    strlit2152 = alloc_String("  ");
    gc_root(strlit2152);
  }
// compiled string node returning strlit2152 (depth = 10)
  int op_slot_right_2151 = gc_frame_newslot(strlit2152);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2154 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2157 == NULL) {
    strlit2157 = alloc_String("Case:""\x0a""");
    gc_root(strlit2157);
  }
// compiled string node returning strlit2157 (depth = 12)
  int op_slot_right_2156 = gc_frame_newslot(strlit2157);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_2159 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit2161 == NULL) {
    strlit2161 = alloc_String("""\x0a""");
    gc_root(strlit2161);
  }
// compiled string node returning strlit2161 (depth = 13)
  int op_slot_left_2159 = gc_frame_newslot(strlit2161);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2162 = callmethod(strlit2161, "++(1)", 1, partcv, params);
// compiled op node returning opresult2162 (depth = 12)
  int op_slot_left_2156 = gc_frame_newslot(opresult2162);
  params[0] = strlit2157;
  partcv[0] = 1;
  Object opresult2163 = callmethod(opresult2162, "++(1)", 1, partcv, params);
// compiled op node returning opresult2163 (depth = 11)
  int op_slot_left_2154 = gc_frame_newslot(opresult2163);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2164 = callmethod(opresult2163, "++(1)", 1, partcv, params);
// compiled op node returning opresult2164 (depth = 10)
  int op_slot_left_2151 = gc_frame_newslot(opresult2164);
  params[0] = strlit2152;
  partcv[0] = 1;
  Object opresult2165 = callmethod(opresult2164, "++(1)", 1, partcv, params);
// compiled op node returning opresult2165 (depth = 9)
  int op_slot_left_2143 = gc_frame_newslot(opresult2165);
  params[0] = call2149;
  partcv[0] = 1;
  Object opresult2166 = callmethod(opresult2165, "++(1)", 1, partcv, params);
// compiled op node returning opresult2166 (depth = 8)
  int op_slot_left_2140 = gc_frame_newslot(opresult2166);
  params[0] = strlit2141;
  partcv[0] = 1;
  Object opresult2167 = callmethod(opresult2166, "++(1)", 1, partcv, params);
// compiled op node returning opresult2167 (depth = 7)
  int op_slot_right_2139 = gc_frame_newslot(opresult2167);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2139 = gc_frame_newslot(*var_s);
  params[0] = opresult2167;
  partcv[0] = 1;
  Object opresult2169 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2169 (depth = 6)
  *var_s = opresult2169;
  if (opresult2169 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_2093(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2094 == NULL) {
    strlit2094 = alloc_String("");
    gc_root(strlit2094);
  }
// compiled string node returning strlit2094 (depth = 4)
  *var_spc = strlit2094;
  if (strlit2094 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2095 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_2096 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num2098 = alloc_Float64(0);
// compiled num node returning num2098 (depth = 5)
  int op_slot_left_2096 = gc_frame_newslot(num2098);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2099 = callmethod(num2098, "..(1)", 1, partcv, params);
// compiled op node returning opresult2099 (depth = 4)
  gc_frame_newslot(opresult2099);
// starting to compile block node (depth = 4)
  Object block2100 = alloc_Block(NULL, NULL, "ast", 476);
  gc_frame_newslot(block2100);
// method "_apply(_)"
  block_savedest(block2100);
  Object closure2101 = createclosure(2, "_apply(1)");
  setclosureframe(closure2101, stackframe);
  addtoclosure(closure2101, var_spc);
  addtoclosure(closure2101, selfslot);
  struct UserObject *uo2101 = (struct UserObject*)block2100;
  uo2101->data[0] = (Object)closure2101;
  Method *meth_meth_ast__apply_40_1_41_2101 = addmethod2pos(block2100, "_apply(1)", &meth_ast__apply_40_1_41_2101, 0);
  int argcv_meth_ast__apply_40_1_41_2101[] = {1};
  meth_meth_ast__apply_40_1_41_2101->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2101);
  meth_meth_ast__apply_40_1_41_2101->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2101->definitionLine = 2981;
// compiled block node returning block2100 (depth = 4)
  gc_frame_newslot(block2100);
// call case 5: prelude request
  params[0] = opresult2099;
  params[1] = block2100;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2108 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2095);
// compiled call node returning call2108 (depth = 3)
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2110 == NULL) {
    strlit2110 = alloc_String("""\x0a""");
    gc_root(strlit2110);
  }
// compiled string node returning strlit2110 (depth = 5)
  int op_slot_right_2109 = gc_frame_newslot(strlit2110);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2113 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2114 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe2113);
// compiled call node returning call2114 (depth = 6)
  int op_slot_right_2112 = gc_frame_newslot(call2114);
// starting to compile string node (depth = 6)
  if (strlit2116 == NULL) {
    strlit2116 = alloc_String("");
    gc_root(strlit2116);
  }
// compiled string node returning strlit2116 (depth = 6)
  int op_slot_left_2112 = gc_frame_newslot(strlit2116);
  params[0] = call2114;
  partcv[0] = 1;
  Object opresult2117 = callmethod(strlit2116, "++(1)", 1, partcv, params);
// compiled op node returning opresult2117 (depth = 5)
  int op_slot_left_2109 = gc_frame_newslot(opresult2117);
  params[0] = strlit2110;
  partcv[0] = 1;
  Object opresult2118 = callmethod(opresult2117, "++(1)", 1, partcv, params);
// compiled op node returning opresult2118 (depth = 4)
  *var_s = opresult2118;
  if (opresult2118 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2120 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2122 = alloc_Float64(2);
// compiled num node returning num2122 (depth = 7)
  int op_slot_right_2121 = gc_frame_newslot(num2122);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_2121 = gc_frame_newslot(*var_depth);
  params[0] = num2122;
  partcv[0] = 1;
  Object sum2124 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2124 (depth = 6)
  gc_frame_newslot(sum2124);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2125 = gc_frame_new();
// call case 4: self request
  Object call2126 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2125);
// compiled member node returning call2126 (depth = 6)
  params[0] = sum2124;
  partcv[0] = 1;
  Object call2127 = callmethodflags(call2126, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2120);
// compiled call node returning call2127 (depth = 5)
  int op_slot_right_2119 = gc_frame_newslot(call2127);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_2129 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2129 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2131 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2131 (depth = 5)
  int op_slot_left_2119 = gc_frame_newslot(opresult2131);
  params[0] = call2127;
  partcv[0] = 1;
  Object opresult2132 = callmethod(opresult2131, "++(1)", 1, partcv, params);
// compiled op node returning opresult2132 (depth = 4)
  *var_s = opresult2132;
  if (opresult2132 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2134 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2135 = gc_frame_new();
// call case 4: self request
  Object call2136 = callmethodflags(self, "cases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2135);
// compiled member node returning call2136 (depth = 4)
  gc_frame_newslot(call2136);
// starting to compile block node (depth = 4)
  Object block2137 = alloc_Block(NULL, NULL, "ast", 481);
  gc_frame_newslot(block2137);
// method "_apply(_)"
  block_savedest(block2137);
  Object closure2138 = createclosure(4, "_apply(1)");
  setclosureframe(closure2138, stackframe);
  addtoclosure(closure2138, var_depth);
  addtoclosure(closure2138, var_spc);
  addtoclosure(closure2138, var_s);
  addtoclosure(closure2138, selfslot);
  struct UserObject *uo2138 = (struct UserObject*)block2137;
  uo2138->data[0] = (Object)closure2138;
  Method *meth_meth_ast__apply_40_1_41_2138 = addmethod2pos(block2137, "_apply(1)", &meth_ast__apply_40_1_41_2138, 0);
  int argcv_meth_ast__apply_40_1_41_2138[] = {1};
  meth_meth_ast__apply_40_1_41_2138->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2138);
  meth_meth_ast__apply_40_1_41_2138->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2138->definitionLine = 2981;
// compiled block node returning block2137 (depth = 4)
  gc_frame_newslot(block2137);
// call case 5: prelude request
  params[0] = call2136;
  params[1] = block2137;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2172 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2134);
// compiled call node returning call2172 (depth = 3)
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2175 = gc_frame_new();
// call case 4: self request
  Object call2176 = callmethodflags(self, "finally", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2175);
// compiled member node returning call2176 (depth = 5)
  int op_slot_right_2174 = gc_frame_newslot(call2176);
// starting to compile identifier node (depth = 5)
  Object bool2178 = alloc_Boolean(0);
// compiled identifier node returning bool2178 (depth = 5)
  int op_slot_left_2174 = gc_frame_newslot(bool2178);
  params[0] = call2176;
  partcv[0] = 1;
  Object opresult2179 = callmethod(bool2178, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2179 (depth = 4)
  Object if2173 = done;
  if (istrue(opresult2179)) {
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2182 == NULL) {
    strlit2182 = alloc_String("");
    gc_root(strlit2182);
  }
// compiled string node returning strlit2182 (depth = 7)
  int op_slot_right_2181 = gc_frame_newslot(strlit2182);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2185 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2187 = alloc_Float64(2);
// compiled num node returning num2187 (depth = 10)
  int op_slot_right_2186 = gc_frame_newslot(num2187);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2186 = gc_frame_newslot(*var_depth);
  params[0] = num2187;
  partcv[0] = 1;
  Object sum2189 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2189 (depth = 9)
  gc_frame_newslot(sum2189);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2190 = gc_frame_new();
// call case 4: self request
  Object call2191 = callmethodflags(self, "finally", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2190);
// compiled member node returning call2191 (depth = 9)
  params[0] = sum2189;
  partcv[0] = 1;
  Object call2192 = callmethodflags(call2191, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2185);
// compiled call node returning call2192 (depth = 8)
  int op_slot_right_2184 = gc_frame_newslot(call2192);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2195 == NULL) {
    strlit2195 = alloc_String("  ");
    gc_root(strlit2195);
  }
// compiled string node returning strlit2195 (depth = 9)
  int op_slot_right_2194 = gc_frame_newslot(strlit2195);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2197 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2200 == NULL) {
    strlit2200 = alloc_String("Finally:""\x0a""");
    gc_root(strlit2200);
  }
// compiled string node returning strlit2200 (depth = 11)
  int op_slot_right_2199 = gc_frame_newslot(strlit2200);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_2202 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 12)
  if (strlit2204 == NULL) {
    strlit2204 = alloc_String("""\x0a""");
    gc_root(strlit2204);
  }
// compiled string node returning strlit2204 (depth = 12)
  int op_slot_left_2202 = gc_frame_newslot(strlit2204);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2205 = callmethod(strlit2204, "++(1)", 1, partcv, params);
// compiled op node returning opresult2205 (depth = 11)
  int op_slot_left_2199 = gc_frame_newslot(opresult2205);
  params[0] = strlit2200;
  partcv[0] = 1;
  Object opresult2206 = callmethod(opresult2205, "++(1)", 1, partcv, params);
// compiled op node returning opresult2206 (depth = 10)
  int op_slot_left_2197 = gc_frame_newslot(opresult2206);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2207 = callmethod(opresult2206, "++(1)", 1, partcv, params);
// compiled op node returning opresult2207 (depth = 9)
  int op_slot_left_2194 = gc_frame_newslot(opresult2207);
  params[0] = strlit2195;
  partcv[0] = 1;
  Object opresult2208 = callmethod(opresult2207, "++(1)", 1, partcv, params);
// compiled op node returning opresult2208 (depth = 8)
  int op_slot_left_2184 = gc_frame_newslot(opresult2208);
  params[0] = call2192;
  partcv[0] = 1;
  Object opresult2209 = callmethod(opresult2208, "++(1)", 1, partcv, params);
// compiled op node returning opresult2209 (depth = 7)
  int op_slot_left_2181 = gc_frame_newslot(opresult2209);
  params[0] = strlit2182;
  partcv[0] = 1;
  Object opresult2210 = callmethod(opresult2209, "++(1)", 1, partcv, params);
// compiled op node returning opresult2210 (depth = 6)
  int op_slot_right_2180 = gc_frame_newslot(opresult2210);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2180 = gc_frame_newslot(*var_s);
  params[0] = opresult2210;
  partcv[0] = 1;
  Object opresult2212 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2212 (depth = 5)
  *var_s = opresult2212;
  if (opresult2212 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2173 = done;
  } else {
  }
// compiled if node returning if2173 (depth = 3)
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_2226(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2228 == NULL) {
    strlit2228 = alloc_String("    ");
    gc_root(strlit2228);
  }
// compiled string node returning strlit2228 (depth = 7)
  int op_slot_right_2227 = gc_frame_newslot(strlit2228);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2227 = gc_frame_newslot(*var_spc);
  params[0] = strlit2228;
  partcv[0] = 1;
  Object opresult2230 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult2230 (depth = 6)
  *var_spc = opresult2230;
  if (opresult2230 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_2254(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_case = &(stackframe->slots[0]);
  *var_case = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 496
  setline(496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2256 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2258 = alloc_Float64(1);
// compiled num node returning num2258 (depth = 9)
  int op_slot_right_2257 = gc_frame_newslot(num2258);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2257 = gc_frame_newslot(*var_depth);
  params[0] = num2258;
  partcv[0] = 1;
  Object sum2260 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2260 (depth = 8)
  gc_frame_newslot(sum2260);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_case (depth = 8)
  params[0] = sum2260;
  partcv[0] = 1;
  Object call2261 = callmethodflags(*var_case, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2256);
// compiled call node returning call2261 (depth = 7)
  int op_slot_right_2255 = gc_frame_newslot(call2261);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2264 == NULL) {
    strlit2264 = alloc_String("catch ");
    gc_root(strlit2264);
  }
// compiled string node returning strlit2264 (depth = 8)
  int op_slot_right_2263 = gc_frame_newslot(strlit2264);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2267 == NULL) {
    strlit2267 = alloc_String("    ");
    gc_root(strlit2267);
  }
// compiled string node returning strlit2267 (depth = 9)
  int op_slot_right_2266 = gc_frame_newslot(strlit2267);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2269 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2272 == NULL) {
    strlit2272 = alloc_String("""\x0a""");
    gc_root(strlit2272);
  }
// compiled string node returning strlit2272 (depth = 11)
  int op_slot_right_2271 = gc_frame_newslot(strlit2272);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2271 = gc_frame_newslot(*var_s);
  params[0] = strlit2272;
  partcv[0] = 1;
  Object opresult2274 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2274 (depth = 10)
  int op_slot_left_2269 = gc_frame_newslot(opresult2274);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2275 = callmethod(opresult2274, "++(1)", 1, partcv, params);
// compiled op node returning opresult2275 (depth = 9)
  int op_slot_left_2266 = gc_frame_newslot(opresult2275);
  params[0] = strlit2267;
  partcv[0] = 1;
  Object opresult2276 = callmethod(opresult2275, "++(1)", 1, partcv, params);
// compiled op node returning opresult2276 (depth = 8)
  int op_slot_left_2263 = gc_frame_newslot(opresult2276);
  params[0] = strlit2264;
  partcv[0] = 1;
  Object opresult2277 = callmethod(opresult2276, "++(1)", 1, partcv, params);
// compiled op node returning opresult2277 (depth = 7)
  int op_slot_left_2255 = gc_frame_newslot(opresult2277);
  params[0] = call2261;
  partcv[0] = 1;
  Object opresult2278 = callmethod(opresult2277, "++(1)", 1, partcv, params);
// compiled op node returning opresult2278 (depth = 6)
  *var_s = opresult2278;
  if (opresult2278 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_2214(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2215 == NULL) {
    strlit2215 = alloc_String("");
    gc_root(strlit2215);
  }
// compiled string node returning strlit2215 (depth = 4)
  *var_spc = strlit2215;
  if (strlit2215 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2216 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2219 = alloc_Float64(1);
// compiled num node returning num2219 (depth = 6)
  int op_slot_right_2218 = gc_frame_newslot(num2219);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_2218 = gc_frame_newslot(*var_depth);
  params[0] = num2219;
  partcv[0] = 1;
  Object diff2221 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff2221 (depth = 5)
  int op_slot_right_2217 = gc_frame_newslot(diff2221);
// starting to compile num node (depth = 5)
  Object num2223 = alloc_Float64(0);
// compiled num node returning num2223 (depth = 5)
  int op_slot_left_2217 = gc_frame_newslot(num2223);
  params[0] = diff2221;
  partcv[0] = 1;
  Object opresult2224 = callmethod(num2223, "..(1)", 1, partcv, params);
// compiled op node returning opresult2224 (depth = 4)
  gc_frame_newslot(opresult2224);
// starting to compile block node (depth = 4)
  Object block2225 = alloc_Block(NULL, NULL, "ast", 491);
  gc_frame_newslot(block2225);
// method "_apply(_)"
  block_savedest(block2225);
  Object closure2226 = createclosure(2, "_apply(1)");
  setclosureframe(closure2226, stackframe);
  addtoclosure(closure2226, var_spc);
  addtoclosure(closure2226, selfslot);
  struct UserObject *uo2226 = (struct UserObject*)block2225;
  uo2226->data[0] = (Object)closure2226;
  Method *meth_meth_ast__apply_40_1_41_2226 = addmethod2pos(block2225, "_apply(1)", &meth_ast__apply_40_1_41_2226, 0);
  int argcv_meth_ast__apply_40_1_41_2226[] = {1};
  meth_meth_ast__apply_40_1_41_2226->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2226);
  meth_meth_ast__apply_40_1_41_2226->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2226->definitionLine = 2981;
// compiled block node returning block2225 (depth = 4)
  gc_frame_newslot(block2225);
// call case 5: prelude request
  params[0] = opresult2224;
  params[1] = block2225;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2233 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2216);
// compiled call node returning call2233 (depth = 3)
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2235 == NULL) {
    strlit2235 = alloc_String(" ");
    gc_root(strlit2235);
  }
// compiled string node returning strlit2235 (depth = 5)
  int op_slot_right_2234 = gc_frame_newslot(strlit2235);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2238 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2240 = alloc_Float64(1);
// compiled num node returning num2240 (depth = 8)
  int op_slot_right_2239 = gc_frame_newslot(num2240);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2239 = gc_frame_newslot(*var_depth);
  params[0] = num2240;
  partcv[0] = 1;
  Object sum2242 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2242 (depth = 7)
  gc_frame_newslot(sum2242);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2243 = gc_frame_new();
// call case 4: self request
  Object call2244 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2243);
// compiled member node returning call2244 (depth = 7)
  params[0] = sum2242;
  partcv[0] = 1;
  Object call2245 = callmethodflags(call2244, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2238);
// compiled call node returning call2245 (depth = 6)
  int op_slot_right_2237 = gc_frame_newslot(call2245);
// starting to compile string node (depth = 6)
  if (strlit2247 == NULL) {
    strlit2247 = alloc_String("try ");
    gc_root(strlit2247);
  }
// compiled string node returning strlit2247 (depth = 6)
  int op_slot_left_2237 = gc_frame_newslot(strlit2247);
  params[0] = call2245;
  partcv[0] = 1;
  Object opresult2248 = callmethod(strlit2247, "++(1)", 1, partcv, params);
// compiled op node returning opresult2248 (depth = 5)
  int op_slot_left_2234 = gc_frame_newslot(opresult2248);
  params[0] = strlit2235;
  partcv[0] = 1;
  Object opresult2249 = callmethod(opresult2248, "++(1)", 1, partcv, params);
// compiled op node returning opresult2249 (depth = 4)
  *var_s = opresult2249;
  if (opresult2249 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2250 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2251 = gc_frame_new();
// call case 4: self request
  Object call2252 = callmethodflags(self, "cases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2251);
// compiled member node returning call2252 (depth = 4)
  gc_frame_newslot(call2252);
// starting to compile block node (depth = 4)
  Object block2253 = alloc_Block(NULL, NULL, "ast", 495);
  gc_frame_newslot(block2253);
// method "_apply(_)"
  block_savedest(block2253);
  Object closure2254 = createclosure(4, "_apply(1)");
  setclosureframe(closure2254, stackframe);
  addtoclosure(closure2254, var_depth);
  addtoclosure(closure2254, var_spc);
  addtoclosure(closure2254, var_s);
  addtoclosure(closure2254, selfslot);
  struct UserObject *uo2254 = (struct UserObject*)block2253;
  uo2254->data[0] = (Object)closure2254;
  Method *meth_meth_ast__apply_40_1_41_2254 = addmethod2pos(block2253, "_apply(1)", &meth_ast__apply_40_1_41_2254, 0);
  int argcv_meth_ast__apply_40_1_41_2254[] = {1};
  meth_meth_ast__apply_40_1_41_2254->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2254);
  meth_meth_ast__apply_40_1_41_2254->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2254->definitionLine = 2981;
// compiled block node returning block2253 (depth = 4)
  gc_frame_newslot(block2253);
// call case 5: prelude request
  params[0] = call2252;
  params[1] = block2253;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2281 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2250);
// compiled call node returning call2281 (depth = 3)
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2284 = gc_frame_new();
// call case 4: self request
  Object call2285 = callmethodflags(self, "finally", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2284);
// compiled member node returning call2285 (depth = 5)
  int op_slot_right_2283 = gc_frame_newslot(call2285);
// starting to compile identifier node (depth = 5)
  Object bool2287 = alloc_Boolean(0);
// compiled identifier node returning bool2287 (depth = 5)
  int op_slot_left_2283 = gc_frame_newslot(bool2287);
  params[0] = call2285;
  partcv[0] = 1;
  Object opresult2288 = callmethod(bool2287, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2288 (depth = 4)
  Object if2282 = done;
  if (istrue(opresult2288)) {
// Begin line 499
  setline(499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2290 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2292 = alloc_Float64(1);
// compiled num node returning num2292 (depth = 8)
  int op_slot_right_2291 = gc_frame_newslot(num2292);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2291 = gc_frame_newslot(*var_depth);
  params[0] = num2292;
  partcv[0] = 1;
  Object sum2294 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2294 (depth = 7)
  gc_frame_newslot(sum2294);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2295 = gc_frame_new();
// call case 4: self request
  Object call2296 = callmethodflags(self, "finally", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2295);
// compiled member node returning call2296 (depth = 7)
  params[0] = sum2294;
  partcv[0] = 1;
  Object call2297 = callmethodflags(call2296, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2290);
// compiled call node returning call2297 (depth = 6)
  int op_slot_right_2289 = gc_frame_newslot(call2297);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2300 == NULL) {
    strlit2300 = alloc_String("finally ");
    gc_root(strlit2300);
  }
// compiled string node returning strlit2300 (depth = 7)
  int op_slot_right_2299 = gc_frame_newslot(strlit2300);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2303 == NULL) {
    strlit2303 = alloc_String("    ");
    gc_root(strlit2303);
  }
// compiled string node returning strlit2303 (depth = 8)
  int op_slot_right_2302 = gc_frame_newslot(strlit2303);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_2305 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2308 == NULL) {
    strlit2308 = alloc_String("""\x0a""");
    gc_root(strlit2308);
  }
// compiled string node returning strlit2308 (depth = 10)
  int op_slot_right_2307 = gc_frame_newslot(strlit2308);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_2307 = gc_frame_newslot(*var_s);
  params[0] = strlit2308;
  partcv[0] = 1;
  Object opresult2310 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2310 (depth = 9)
  int op_slot_left_2305 = gc_frame_newslot(opresult2310);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2311 = callmethod(opresult2310, "++(1)", 1, partcv, params);
// compiled op node returning opresult2311 (depth = 8)
  int op_slot_left_2302 = gc_frame_newslot(opresult2311);
  params[0] = strlit2303;
  partcv[0] = 1;
  Object opresult2312 = callmethod(opresult2311, "++(1)", 1, partcv, params);
// compiled op node returning opresult2312 (depth = 7)
  int op_slot_left_2299 = gc_frame_newslot(opresult2312);
  params[0] = strlit2300;
  partcv[0] = 1;
  Object opresult2313 = callmethod(opresult2312, "++(1)", 1, partcv, params);
// compiled op node returning opresult2313 (depth = 6)
  int op_slot_left_2289 = gc_frame_newslot(opresult2313);
  params[0] = call2297;
  partcv[0] = 1;
  Object opresult2314 = callmethod(opresult2313, "++(1)", 1, partcv, params);
// compiled op node returning opresult2314 (depth = 5)
  *var_s = opresult2314;
  if (opresult2314 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2282 = done;
  } else {
  }
// compiled if node returning if2282 (depth = 3)
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy2316(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_tryCatchNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 504
  setline(504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2317 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe2318 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
  Object bool2319 = alloc_Boolean(0);
// compiled identifier node returning bool2319 (depth = 5)
  gc_frame_newslot(bool2319);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tryCatchNode (depth = 5)
  params[0] = *var_nullNode;
  params[1] = *var_emptySeq;
  params[2] = bool2319;
  partcv[0] = 3;
  Object call2320 = callmethodflags(*var_tryCatchNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe2318);
// compiled call node returning call2320 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call2321 = callmethodflags(call2320, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2317);
// compiled call node returning call2321 (depth = 3)
  gc_frame_end(frame);
  return call2321;
}
Object meth_ast_new_40_3_41_2021(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_tryCatchNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block = &(stackframe->slots[0]);
  *var_block = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_finally_39_ = &(stackframe->slots[2]);
  *var_finally_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2022 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2022 = alloc_userobj2(13,11, objclass2022);
  gc_frame_newslot(obj2022);
if (objclass2022 == NULL) {
  glfree(obj2022->class->name);
  obj2022->class->name = "tryCatchNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2022, self, 0);
  addmethodreal(obj2022,"outer", &reader_ast_outer_2023);
  Object oldself2022 = self;
  struct StackFrameObject *oldstackframe2022 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2022);
  gc_frame_newslot((Object)stackframe);
  self = obj2022;
  Object *oldselfslot2022 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2022 = (*(struct UserObject *)self).data[0], lowerouter2022 = thisouter2022;
  if (inheritingObject2022) {
    struct UserObject *inho2022 = (struct UserObject *)inheritingObject2022;
    while (inho2022->super != GraceDefaultObject) inho2022 = (struct UserObject *)inho2022->super;
    inho2022->super = obj2022;
    self = inheritingObject2022;
    *selfslot = self;
    lowerouter2022 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2022;
  }
if (objclass2022 == NULL) {
  Method *reader2024 = addmethodrealflags(obj2022, "kind",&reader_ast_kind_2024, MFLAG_DEF);
  reader2024->definitionModule = modulename;
  reader2024->definitionLine = 448;
}
adddatum2(obj2022, alloc_Undefined(), 1);
if (objclass2022 == NULL) {
  Method *reader2025 = addmethodrealflags(obj2022, "value", &reader_ast_value_2025, 0);
  Method *writer2025 = addmethodrealflags(obj2022, "value:=(1)", &writer_ast_value_2025, 0);
  reader2025->definitionModule = modulename;
  writer2025->definitionModule = modulename;
  reader2025->definitionLine = 449;
  writer2025->definitionLine = 449;
}
obj2022->flags |= OFLAG_MUTABLE;
adddatum2(obj2022, alloc_Undefined(), 2);
if (objclass2022 == NULL) {
  Method *reader2026 = addmethodrealflags(obj2022, "cases", &reader_ast_cases_2026, 0);
  Method *writer2026 = addmethodrealflags(obj2022, "cases:=(1)", &writer_ast_cases_2026, 0);
  reader2026->definitionModule = modulename;
  writer2026->definitionModule = modulename;
  reader2026->definitionLine = 450;
  writer2026->definitionLine = 450;
}
obj2022->flags |= OFLAG_MUTABLE;
adddatum2(obj2022, alloc_Undefined(), 3);
if (objclass2022 == NULL) {
  Method *reader2027 = addmethodrealflags(obj2022, "finally", &reader_ast_finally_2027, 0);
  Method *writer2027 = addmethodrealflags(obj2022, "finally:=(1)", &writer_ast_finally_2027, 0);
  reader2027->definitionModule = modulename;
  writer2027->definitionModule = modulename;
  reader2027->definitionLine = 451;
  writer2027->definitionLine = 451;
}
obj2022->flags |= OFLAG_MUTABLE;
adddatum2(obj2022, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo2028 = (struct UserObject*)obj2022;
  uo2028->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple2028 = addmethod2pos(obj2022, "isSimple", &meth_ast_isSimple2028, 5);
  int argcv_meth_ast_isSimple2028[] = {0};
  meth_meth_ast_isSimple2028->type = alloc_MethodType(1, argcv_meth_ast_isSimple2028);
  meth_meth_ast_isSimple2028->definitionModule = modulename;
  meth_meth_ast_isSimple2028->definitionLine = 452;
// method "accept(_)from(_)"
  struct UserObject *uo2030 = (struct UserObject*)obj2022;
  uo2030->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_2030 = addmethod2pos(obj2022, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_2030, 6);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_2030[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_2030->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_2030);
  meth_meth_ast_accept_40_1_41_from_40_1_41_2030->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_2030->definitionLine = 454;
// method "map(_)ancestors(_)"
  struct UserObject *uo2060 = (struct UserObject*)obj2022;
  uo2060->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_2060 = addmethod2pos(obj2022, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_2060, 7);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2060[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2060->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2060);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2060->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2060->definitionLine = 466;
// method "pretty(_)"
  struct UserObject *uo2093 = (struct UserObject*)obj2022;
  uo2093->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_2093 = addmethod2pos(obj2022, "pretty(1)", &meth_ast_pretty_40_1_41_2093, 8);
  int argcv_meth_ast_pretty_40_1_41_2093[] = {1};
  meth_meth_ast_pretty_40_1_41_2093->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_2093);
  meth_meth_ast_pretty_40_1_41_2093->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_2093->definitionLine = 474;
// method "toGrace(_)"
  struct UserObject *uo2214 = (struct UserObject*)obj2022;
  uo2214->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_2214 = addmethod2pos(obj2022, "toGrace(1)", &meth_ast_toGrace_40_1_41_2214, 9);
  int argcv_meth_ast_toGrace_40_1_41_2214[] = {1};
  meth_meth_ast_toGrace_40_1_41_2214->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_2214);
meth_meth_ast_toGrace_40_1_41_2214->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_2214->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_2214->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_2214->definitionLine = 489;
// method "shallowCopy"
  block_savedest(obj2022);
  Object closure2316 = createclosure(3, "shallowCopy");
  setclosureframe(closure2316, stackframe);
  addtoclosure(closure2316, var_nullNode);
  addtoclosure(closure2316, var_emptySeq);
  addtoclosure(closure2316, var_tryCatchNode);
  struct UserObject *uo2316 = (struct UserObject*)obj2022;
  uo2316->data[10] = (Object)closure2316;
  Method *meth_meth_ast_shallowCopy2316 = addmethod2pos(obj2022, "shallowCopy", &meth_ast_shallowCopy2316, 10);
  int argcv_meth_ast_shallowCopy2316[] = {0};
  meth_meth_ast_shallowCopy2316->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2316);
  meth_meth_ast_shallowCopy2316->definitionModule = modulename;
  meth_meth_ast_shallowCopy2316->definitionLine = 503;
  sourceObject = obj2022;
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2322 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2323 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2324 = gc_frame_new();
// call case 3: self.outer request
  Object call2325 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2324);
// compiled member node returning call2325 (depth = 5)
  Object call2326 = callmethodflags(call2325, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2323);
// compiled member node returning call2326 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2327 = callmethodflags(call2326, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2322);
// compiled call node returning call2327 (depth = 3)
  struct UserObject *obj2022_uo = (struct UserObject *)obj2022;
  obj2022_uo->super = call2327;
  sourceObject = obj2022;
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2328 == NULL) {
    strlit2328 = alloc_String("trycatch");
    gc_root(strlit2328);
  }
// compiled string node returning strlit2328 (depth = 3)
  adddatum2(obj2022, strlit2328, 1);
  sourceObject = obj2022;
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_block (depth = 3)
  adddatum2(obj2022, *var_block, 2);
  sourceObject = obj2022;
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj2022, *var_cases_39_, 3);
  sourceObject = obj2022;
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_finally_39_ (depth = 3)
  adddatum2(obj2022, *var_finally_39_, 4);
  sourceObject = obj2022;
  sourceObject = obj2022;
  sourceObject = obj2022;
  sourceObject = obj2022;
  sourceObject = obj2022;
  sourceObject = obj2022;
  objclass2022 = obj2022->class;
  objclass2022->definitionModule = modulename;
  objclass2022->definitionLine = 446;
  (*(struct UserObject *)self).data[0] = lowerouter2022;
  self = oldself2022;
  selfslot = oldselfslot2022;
  stackframe = oldstackframe2022;
  gc_frame_end(frame);
  return obj2022;
}
Object meth_ast_new_40_3_41_2021_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_tryCatchNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block = &(stackframe->slots[0]);
  *var_block = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_finally_39_ = &(stackframe->slots[2]);
  *var_finally_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2022 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2022 = alloc_userobj2(13,11, objclass2022);
  gc_frame_newslot(obj2022);
if (objclass2022 == NULL) {
  glfree(obj2022->class->name);
  obj2022->class->name = "tryCatchNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2022, self, 0);
  addmethodreal(obj2022,"outer", &reader_ast_outer_2023);
  Object oldself2022 = self;
  struct StackFrameObject *oldstackframe2022 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2022);
  gc_frame_newslot((Object)stackframe);
  self = obj2022;
  Object *oldselfslot2022 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2022 = (*(struct UserObject *)self).data[0], lowerouter2022 = thisouter2022;
  if (inheritingObject2022) {
    struct UserObject *inho2022 = (struct UserObject *)inheritingObject2022;
    while (inho2022->super != GraceDefaultObject) inho2022 = (struct UserObject *)inho2022->super;
    inho2022->super = obj2022;
    self = inheritingObject2022;
    *selfslot = self;
    lowerouter2022 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2022;
  }
if (objclass2022 == NULL) {
  Method *reader2024 = addmethodrealflags(obj2022, "kind",&reader_ast_kind_2024, MFLAG_DEF);
  reader2024->definitionModule = modulename;
  reader2024->definitionLine = 448;
}
adddatum2(obj2022, alloc_Undefined(), 1);
if (objclass2022 == NULL) {
  Method *reader2025 = addmethodrealflags(obj2022, "value", &reader_ast_value_2025, 0);
  Method *writer2025 = addmethodrealflags(obj2022, "value:=(1)", &writer_ast_value_2025, 0);
  reader2025->definitionModule = modulename;
  writer2025->definitionModule = modulename;
  reader2025->definitionLine = 449;
  writer2025->definitionLine = 449;
}
obj2022->flags |= OFLAG_MUTABLE;
adddatum2(obj2022, alloc_Undefined(), 2);
if (objclass2022 == NULL) {
  Method *reader2026 = addmethodrealflags(obj2022, "cases", &reader_ast_cases_2026, 0);
  Method *writer2026 = addmethodrealflags(obj2022, "cases:=(1)", &writer_ast_cases_2026, 0);
  reader2026->definitionModule = modulename;
  writer2026->definitionModule = modulename;
  reader2026->definitionLine = 450;
  writer2026->definitionLine = 450;
}
obj2022->flags |= OFLAG_MUTABLE;
adddatum2(obj2022, alloc_Undefined(), 3);
if (objclass2022 == NULL) {
  Method *reader2027 = addmethodrealflags(obj2022, "finally", &reader_ast_finally_2027, 0);
  Method *writer2027 = addmethodrealflags(obj2022, "finally:=(1)", &writer_ast_finally_2027, 0);
  reader2027->definitionModule = modulename;
  writer2027->definitionModule = modulename;
  reader2027->definitionLine = 451;
  writer2027->definitionLine = 451;
}
obj2022->flags |= OFLAG_MUTABLE;
adddatum2(obj2022, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo2028 = (struct UserObject*)obj2022;
  uo2028->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple2028 = addmethod2pos(obj2022, "isSimple", &meth_ast_isSimple2028, 5);
  int argcv_meth_ast_isSimple2028[] = {0};
  meth_meth_ast_isSimple2028->type = alloc_MethodType(1, argcv_meth_ast_isSimple2028);
  meth_meth_ast_isSimple2028->definitionModule = modulename;
  meth_meth_ast_isSimple2028->definitionLine = 452;
// method "accept(_)from(_)"
  struct UserObject *uo2030 = (struct UserObject*)obj2022;
  uo2030->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_2030 = addmethod2pos(obj2022, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_2030, 6);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_2030[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_2030->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_2030);
  meth_meth_ast_accept_40_1_41_from_40_1_41_2030->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_2030->definitionLine = 454;
// method "map(_)ancestors(_)"
  struct UserObject *uo2060 = (struct UserObject*)obj2022;
  uo2060->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_2060 = addmethod2pos(obj2022, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_2060, 7);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2060[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2060->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2060);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2060->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2060->definitionLine = 466;
// method "pretty(_)"
  struct UserObject *uo2093 = (struct UserObject*)obj2022;
  uo2093->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_2093 = addmethod2pos(obj2022, "pretty(1)", &meth_ast_pretty_40_1_41_2093, 8);
  int argcv_meth_ast_pretty_40_1_41_2093[] = {1};
  meth_meth_ast_pretty_40_1_41_2093->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_2093);
  meth_meth_ast_pretty_40_1_41_2093->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_2093->definitionLine = 474;
// method "toGrace(_)"
  struct UserObject *uo2214 = (struct UserObject*)obj2022;
  uo2214->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_2214 = addmethod2pos(obj2022, "toGrace(1)", &meth_ast_toGrace_40_1_41_2214, 9);
  int argcv_meth_ast_toGrace_40_1_41_2214[] = {1};
  meth_meth_ast_toGrace_40_1_41_2214->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_2214);
meth_meth_ast_toGrace_40_1_41_2214->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_2214->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_2214->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_2214->definitionLine = 489;
// method "shallowCopy"
  block_savedest(obj2022);
  Object closure2316 = createclosure(3, "shallowCopy");
  setclosureframe(closure2316, stackframe);
  addtoclosure(closure2316, var_nullNode);
  addtoclosure(closure2316, var_emptySeq);
  addtoclosure(closure2316, var_tryCatchNode);
  struct UserObject *uo2316 = (struct UserObject*)obj2022;
  uo2316->data[10] = (Object)closure2316;
  Method *meth_meth_ast_shallowCopy2316 = addmethod2pos(obj2022, "shallowCopy", &meth_ast_shallowCopy2316, 10);
  int argcv_meth_ast_shallowCopy2316[] = {0};
  meth_meth_ast_shallowCopy2316->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2316);
  meth_meth_ast_shallowCopy2316->definitionModule = modulename;
  meth_meth_ast_shallowCopy2316->definitionLine = 503;
  sourceObject = obj2022;
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2322 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2323 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2324 = gc_frame_new();
// call case 3: self.outer request
  Object call2325 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2324);
// compiled member node returning call2325 (depth = 5)
  Object call2326 = callmethodflags(call2325, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2323);
// compiled member node returning call2326 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2327 = callmethodflags(call2326, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2322);
// compiled call node returning call2327 (depth = 3)
  struct UserObject *obj2022_uo = (struct UserObject *)obj2022;
  obj2022_uo->super = call2327;
  sourceObject = obj2022;
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2328 == NULL) {
    strlit2328 = alloc_String("trycatch");
    gc_root(strlit2328);
  }
// compiled string node returning strlit2328 (depth = 3)
  adddatum2(obj2022, strlit2328, 1);
  sourceObject = obj2022;
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_block (depth = 3)
  adddatum2(obj2022, *var_block, 2);
  sourceObject = obj2022;
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj2022, *var_cases_39_, 3);
  sourceObject = obj2022;
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_finally_39_ (depth = 3)
  adddatum2(obj2022, *var_finally_39_, 4);
  sourceObject = obj2022;
  sourceObject = obj2022;
  sourceObject = obj2022;
  sourceObject = obj2022;
  sourceObject = obj2022;
  sourceObject = obj2022;
  objclass2022 = obj2022->class;
  objclass2022->definitionModule = modulename;
  objclass2022->definitionLine = 446;
  (*(struct UserObject *)self).data[0] = lowerouter2022;
  self = oldself2022;
  selfslot = oldselfslot2022;
  stackframe = oldstackframe2022;
  gc_frame_end(frame);
  return obj2022;
}
Object meth_ast_tryCatchNode2330(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tryCatchNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tryCatchNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tryCatchNode (depth = 3)
  gc_frame_end(frame);
  return *var_tryCatchNode;
}
Object meth_ast_isSimple2340(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2341 = alloc_Boolean(0);
// compiled identifier node returning bool2341 (depth = 3)
  gc_frame_end(frame);
  return bool2341;
}
Object meth_ast_matchee2342(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "matchee");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe2343 = gc_frame_new();
// call case 4: self request
  Object call2344 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2343);
// compiled member node returning call2344 (depth = 3)
  gc_frame_end(frame);
  return call2344;
}
Object meth_ast__apply_40_1_41_2359(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 522
  setline(522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2360 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2361 = callmethodflags(*var_mx, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2360);
// compiled call node returning call2361 (depth = 6)
  gc_frame_end(frame);
  return call2361;
}
Object meth_ast_accept_40_1_41_from_40_1_41_2345(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2347 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2348 = callmethodflags(*var_visitor, "visitMatchCase(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2347);
// compiled call node returning call2348 (depth = 4)
  Object if2346 = done;
  if (istrue(call2348)) {
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2349 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call2350 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2349);
// compiled call node returning call2350 (depth = 5)
  *var_newChain = call2350;
  if (call2350 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2351 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2352 = gc_frame_new();
// call case 4: self request
  Object call2353 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2352);
// compiled member node returning call2353 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2354 = callmethodflags(call2353, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2351);
// compiled call node returning call2354 (depth = 4)
// Begin line 521
  setline(521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2355 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2356 = gc_frame_new();
// call case 4: self request
  Object call2357 = callmethodflags(self, "cases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2356);
// compiled member node returning call2357 (depth = 5)
  gc_frame_newslot(call2357);
// starting to compile block node (depth = 5)
  Object block2358 = alloc_Block(NULL, NULL, "ast", 521);
  gc_frame_newslot(block2358);
// method "_apply(_)"
  block_savedest(block2358);
  Object closure2359 = createclosure(3, "_apply(1)");
  setclosureframe(closure2359, stackframe);
  addtoclosure(closure2359, var_visitor);
  addtoclosure(closure2359, var_newChain);
  addtoclosure(closure2359, selfslot);
  struct UserObject *uo2359 = (struct UserObject*)block2358;
  uo2359->data[0] = (Object)closure2359;
  Method *meth_meth_ast__apply_40_1_41_2359 = addmethod2pos(block2358, "_apply(1)", &meth_ast__apply_40_1_41_2359, 0);
  int argcv_meth_ast__apply_40_1_41_2359[] = {1};
  meth_meth_ast__apply_40_1_41_2359->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2359);
  meth_meth_ast__apply_40_1_41_2359->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2359->definitionLine = 2981;
// compiled block node returning block2358 (depth = 5)
  gc_frame_newslot(block2358);
// call case 5: prelude request
  params[0] = call2357;
  params[1] = block2358;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2363 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2355);
// compiled call node returning call2363 (depth = 4)
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2366 = gc_frame_new();
// call case 4: self request
  Object call2367 = callmethodflags(self, "elsecase", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2366);
// compiled member node returning call2367 (depth = 6)
  int op_slot_right_2365 = gc_frame_newslot(call2367);
// starting to compile identifier node (depth = 6)
  Object bool2369 = alloc_Boolean(0);
// compiled identifier node returning bool2369 (depth = 6)
  int op_slot_left_2365 = gc_frame_newslot(bool2369);
  params[0] = call2367;
  partcv[0] = 1;
  Object opresult2370 = callmethod(bool2369, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2370 (depth = 5)
  Object if2364 = done;
  if (istrue(opresult2370)) {
// Begin line 525
  setline(525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2371 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2372 = gc_frame_new();
// call case 4: self request
  Object call2373 = callmethodflags(self, "elsecase", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2372);
// compiled member node returning call2373 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2374 = callmethodflags(call2373, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2371);
// compiled call node returning call2374 (depth = 5)
    gc_frame_newslot(call2374);
    if2364 = call2374;
  } else {
  }
// compiled if node returning if2364 (depth = 4)
    gc_frame_newslot(if2364);
    if2346 = if2364;
  } else {
  }
// compiled if node returning if2346 (depth = 3)
  gc_frame_end(frame);
  return if2346;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_2375(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2376 = gc_frame_new();
// call case 4: self request
  Object call2377 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2376);
// compiled member node returning call2377 (depth = 4)
  *var_n = call2377;
  if (call2377 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2378 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2379 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2378);
// compiled call node returning call2379 (depth = 4)
  *var_newChain = call2379;
  if (call2379 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2380 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2381 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2382 = gc_frame_new();
// call case 4: self request
  Object call2383 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2382);
// compiled member node returning call2383 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2384 = callmethodflags(call2383, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2381);
// compiled call node returning call2384 (depth = 4)
  gc_frame_newslot(call2384);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2384;
  partcv[0] = 1;
  Object call2385 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2380);
// compiled call node returning call2385 (depth = 3)
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2386 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2387 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2388 = gc_frame_new();
// call case 4: self request
  Object call2389 = callmethodflags(self, "cases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2388);
// compiled member node returning call2389 (depth = 5)
  gc_frame_newslot(call2389);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2390 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2391 = gc_frame_new();
// call case 3: self.outer request
  Object call2392 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2391);
// compiled member node returning call2392 (depth = 6)
  Object call2393 = callmethodflags(call2392, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2390);
// compiled member node returning call2393 (depth = 5)
  params[0] = call2389;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2394 = callmethodflags(call2393, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2387);
// compiled call node returning call2394 (depth = 4)
  gc_frame_newslot(call2394);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2394;
  partcv[0] = 1;
  Object call2395 = callmethodflags(*var_n, "cases:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2386);
// compiled call node returning call2395 (depth = 3)
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2396 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2397 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2398 = gc_frame_new();
// call case 4: self request
  Object call2399 = callmethodflags(self, "elsecase", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2398);
// compiled member node returning call2399 (depth = 5)
  gc_frame_newslot(call2399);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2400 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2401 = gc_frame_new();
// call case 3: self.outer request
  Object call2402 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2401);
// compiled member node returning call2402 (depth = 6)
  Object call2403 = callmethodflags(call2402, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2400);
// compiled member node returning call2403 (depth = 5)
  params[0] = call2399;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2404 = callmethodflags(call2403, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2397);
// compiled call node returning call2404 (depth = 4)
  gc_frame_newslot(call2404);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2404;
  partcv[0] = 1;
  Object call2405 = callmethodflags(*var_n, "elsecase:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2396);
// compiled call node returning call2405 (depth = 3)
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2406 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call2407 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2406);
// compiled call node returning call2407 (depth = 3)
  gc_frame_end(frame);
  return call2407;
}
Object meth_ast__apply_40_1_41_2416(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2418 == NULL) {
    strlit2418 = alloc_String("  ");
    gc_root(strlit2418);
  }
// compiled string node returning strlit2418 (depth = 7)
  int op_slot_right_2417 = gc_frame_newslot(strlit2418);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2417 = gc_frame_newslot(*var_spc);
  params[0] = strlit2418;
  partcv[0] = 1;
  Object opresult2420 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult2420 (depth = 6)
  *var_spc = opresult2420;
  if (opresult2420 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_2449(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 545
  setline(545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2452 == NULL) {
    strlit2452 = alloc_String("");
    gc_root(strlit2452);
  }
// compiled string node returning strlit2452 (depth = 8)
  int op_slot_right_2451 = gc_frame_newslot(strlit2452);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2455 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2457 = alloc_Float64(2);
// compiled num node returning num2457 (depth = 11)
  int op_slot_right_2456 = gc_frame_newslot(num2457);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_2456 = gc_frame_newslot(*var_depth);
  params[0] = num2457;
  partcv[0] = 1;
  Object sum2459 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2459 (depth = 10)
  gc_frame_newslot(sum2459);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mx (depth = 10)
  params[0] = sum2459;
  partcv[0] = 1;
  Object call2460 = callmethodflags(*var_mx, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2455);
// compiled call node returning call2460 (depth = 9)
  int op_slot_right_2454 = gc_frame_newslot(call2460);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2463 == NULL) {
    strlit2463 = alloc_String("  ");
    gc_root(strlit2463);
  }
// compiled string node returning strlit2463 (depth = 10)
  int op_slot_right_2462 = gc_frame_newslot(strlit2463);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2465 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2468 == NULL) {
    strlit2468 = alloc_String("Case:""\x0a""");
    gc_root(strlit2468);
  }
// compiled string node returning strlit2468 (depth = 12)
  int op_slot_right_2467 = gc_frame_newslot(strlit2468);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_2470 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit2472 == NULL) {
    strlit2472 = alloc_String("""\x0a""");
    gc_root(strlit2472);
  }
// compiled string node returning strlit2472 (depth = 13)
  int op_slot_left_2470 = gc_frame_newslot(strlit2472);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2473 = callmethod(strlit2472, "++(1)", 1, partcv, params);
// compiled op node returning opresult2473 (depth = 12)
  int op_slot_left_2467 = gc_frame_newslot(opresult2473);
  params[0] = strlit2468;
  partcv[0] = 1;
  Object opresult2474 = callmethod(opresult2473, "++(1)", 1, partcv, params);
// compiled op node returning opresult2474 (depth = 11)
  int op_slot_left_2465 = gc_frame_newslot(opresult2474);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2475 = callmethod(opresult2474, "++(1)", 1, partcv, params);
// compiled op node returning opresult2475 (depth = 10)
  int op_slot_left_2462 = gc_frame_newslot(opresult2475);
  params[0] = strlit2463;
  partcv[0] = 1;
  Object opresult2476 = callmethod(opresult2475, "++(1)", 1, partcv, params);
// compiled op node returning opresult2476 (depth = 9)
  int op_slot_left_2454 = gc_frame_newslot(opresult2476);
  params[0] = call2460;
  partcv[0] = 1;
  Object opresult2477 = callmethod(opresult2476, "++(1)", 1, partcv, params);
// compiled op node returning opresult2477 (depth = 8)
  int op_slot_left_2451 = gc_frame_newslot(opresult2477);
  params[0] = strlit2452;
  partcv[0] = 1;
  Object opresult2478 = callmethod(opresult2477, "++(1)", 1, partcv, params);
// compiled op node returning opresult2478 (depth = 7)
  int op_slot_right_2450 = gc_frame_newslot(opresult2478);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2450 = gc_frame_newslot(*var_s);
  params[0] = opresult2478;
  partcv[0] = 1;
  Object opresult2480 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2480 (depth = 6)
  *var_s = opresult2480;
  if (opresult2480 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_2408(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 538
  setline(538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2409 == NULL) {
    strlit2409 = alloc_String("");
    gc_root(strlit2409);
  }
// compiled string node returning strlit2409 (depth = 4)
  *var_spc = strlit2409;
  if (strlit2409 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2410 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_2411 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num2413 = alloc_Float64(0);
// compiled num node returning num2413 (depth = 5)
  int op_slot_left_2411 = gc_frame_newslot(num2413);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2414 = callmethod(num2413, "..(1)", 1, partcv, params);
// compiled op node returning opresult2414 (depth = 4)
  gc_frame_newslot(opresult2414);
// starting to compile block node (depth = 4)
  Object block2415 = alloc_Block(NULL, NULL, "ast", 539);
  gc_frame_newslot(block2415);
// method "_apply(_)"
  block_savedest(block2415);
  Object closure2416 = createclosure(2, "_apply(1)");
  setclosureframe(closure2416, stackframe);
  addtoclosure(closure2416, var_spc);
  addtoclosure(closure2416, selfslot);
  struct UserObject *uo2416 = (struct UserObject*)block2415;
  uo2416->data[0] = (Object)closure2416;
  Method *meth_meth_ast__apply_40_1_41_2416 = addmethod2pos(block2415, "_apply(1)", &meth_ast__apply_40_1_41_2416, 0);
  int argcv_meth_ast__apply_40_1_41_2416[] = {1};
  meth_meth_ast__apply_40_1_41_2416->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2416);
  meth_meth_ast__apply_40_1_41_2416->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2416->definitionLine = 2981;
// compiled block node returning block2415 (depth = 4)
  gc_frame_newslot(block2415);
// call case 5: prelude request
  params[0] = opresult2414;
  params[1] = block2415;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2423 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2410);
// compiled call node returning call2423 (depth = 3)
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2425 == NULL) {
    strlit2425 = alloc_String("""\x0a""");
    gc_root(strlit2425);
  }
// compiled string node returning strlit2425 (depth = 5)
  int op_slot_right_2424 = gc_frame_newslot(strlit2425);
// starting to compile call node (depth = 5)
  int callframe2427 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2428 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe2427);
// compiled call node returning call2428 (depth = 5)
  int op_slot_left_2424 = gc_frame_newslot(call2428);
  params[0] = strlit2425;
  partcv[0] = 1;
  Object opresult2429 = callmethod(call2428, "++(1)", 1, partcv, params);
// compiled op node returning opresult2429 (depth = 4)
  *var_s = opresult2429;
  if (opresult2429 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2431 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2433 = alloc_Float64(2);
// compiled num node returning num2433 (depth = 7)
  int op_slot_right_2432 = gc_frame_newslot(num2433);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_2432 = gc_frame_newslot(*var_depth);
  params[0] = num2433;
  partcv[0] = 1;
  Object sum2435 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2435 (depth = 6)
  gc_frame_newslot(sum2435);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2436 = gc_frame_new();
// call case 4: self request
  Object call2437 = callmethodflags(self, "matchee", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2436);
// compiled member node returning call2437 (depth = 6)
  params[0] = sum2435;
  partcv[0] = 1;
  Object call2438 = callmethodflags(call2437, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2431);
// compiled call node returning call2438 (depth = 5)
  int op_slot_right_2430 = gc_frame_newslot(call2438);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_2440 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2440 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2442 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2442 (depth = 5)
  int op_slot_left_2430 = gc_frame_newslot(opresult2442);
  params[0] = call2438;
  partcv[0] = 1;
  Object opresult2443 = callmethod(opresult2442, "++(1)", 1, partcv, params);
// compiled op node returning opresult2443 (depth = 4)
  *var_s = opresult2443;
  if (opresult2443 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2445 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2446 = gc_frame_new();
// call case 4: self request
  Object call2447 = callmethodflags(self, "cases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2446);
// compiled member node returning call2447 (depth = 4)
  gc_frame_newslot(call2447);
// starting to compile block node (depth = 4)
  Object block2448 = alloc_Block(NULL, NULL, "ast", 544);
  gc_frame_newslot(block2448);
// method "_apply(_)"
  block_savedest(block2448);
  Object closure2449 = createclosure(4, "_apply(1)");
  setclosureframe(closure2449, stackframe);
  addtoclosure(closure2449, var_depth);
  addtoclosure(closure2449, var_spc);
  addtoclosure(closure2449, var_s);
  addtoclosure(closure2449, selfslot);
  struct UserObject *uo2449 = (struct UserObject*)block2448;
  uo2449->data[0] = (Object)closure2449;
  Method *meth_meth_ast__apply_40_1_41_2449 = addmethod2pos(block2448, "_apply(1)", &meth_ast__apply_40_1_41_2449, 0);
  int argcv_meth_ast__apply_40_1_41_2449[] = {1};
  meth_meth_ast__apply_40_1_41_2449->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2449);
  meth_meth_ast__apply_40_1_41_2449->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2449->definitionLine = 2981;
// compiled block node returning block2448 (depth = 4)
  gc_frame_newslot(block2448);
// call case 5: prelude request
  params[0] = call2447;
  params[1] = block2448;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2483 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2445);
// compiled call node returning call2483 (depth = 3)
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2486 = gc_frame_new();
// call case 4: self request
  Object call2487 = callmethodflags(self, "elsecase", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2486);
// compiled member node returning call2487 (depth = 5)
  int op_slot_right_2485 = gc_frame_newslot(call2487);
// starting to compile identifier node (depth = 5)
  Object bool2489 = alloc_Boolean(0);
// compiled identifier node returning bool2489 (depth = 5)
  int op_slot_left_2485 = gc_frame_newslot(bool2489);
  params[0] = call2487;
  partcv[0] = 1;
  Object opresult2490 = callmethod(bool2489, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2490 (depth = 4)
  Object if2484 = done;
  if (istrue(opresult2490)) {
// Begin line 548
  setline(548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2493 == NULL) {
    strlit2493 = alloc_String("");
    gc_root(strlit2493);
  }
// compiled string node returning strlit2493 (depth = 7)
  int op_slot_right_2492 = gc_frame_newslot(strlit2493);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2496 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2498 = alloc_Float64(2);
// compiled num node returning num2498 (depth = 10)
  int op_slot_right_2497 = gc_frame_newslot(num2498);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2497 = gc_frame_newslot(*var_depth);
  params[0] = num2498;
  partcv[0] = 1;
  Object sum2500 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2500 (depth = 9)
  gc_frame_newslot(sum2500);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2501 = gc_frame_new();
// call case 4: self request
  Object call2502 = callmethodflags(self, "elsecase", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2501);
// compiled member node returning call2502 (depth = 9)
  params[0] = sum2500;
  partcv[0] = 1;
  Object call2503 = callmethodflags(call2502, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2496);
// compiled call node returning call2503 (depth = 8)
  int op_slot_right_2495 = gc_frame_newslot(call2503);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2506 == NULL) {
    strlit2506 = alloc_String("  ");
    gc_root(strlit2506);
  }
// compiled string node returning strlit2506 (depth = 9)
  int op_slot_right_2505 = gc_frame_newslot(strlit2506);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2508 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2511 == NULL) {
    strlit2511 = alloc_String("Else:""\x0a""");
    gc_root(strlit2511);
  }
// compiled string node returning strlit2511 (depth = 11)
  int op_slot_right_2510 = gc_frame_newslot(strlit2511);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_2513 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 12)
  if (strlit2515 == NULL) {
    strlit2515 = alloc_String("""\x0a""");
    gc_root(strlit2515);
  }
// compiled string node returning strlit2515 (depth = 12)
  int op_slot_left_2513 = gc_frame_newslot(strlit2515);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2516 = callmethod(strlit2515, "++(1)", 1, partcv, params);
// compiled op node returning opresult2516 (depth = 11)
  int op_slot_left_2510 = gc_frame_newslot(opresult2516);
  params[0] = strlit2511;
  partcv[0] = 1;
  Object opresult2517 = callmethod(opresult2516, "++(1)", 1, partcv, params);
// compiled op node returning opresult2517 (depth = 10)
  int op_slot_left_2508 = gc_frame_newslot(opresult2517);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2518 = callmethod(opresult2517, "++(1)", 1, partcv, params);
// compiled op node returning opresult2518 (depth = 9)
  int op_slot_left_2505 = gc_frame_newslot(opresult2518);
  params[0] = strlit2506;
  partcv[0] = 1;
  Object opresult2519 = callmethod(opresult2518, "++(1)", 1, partcv, params);
// compiled op node returning opresult2519 (depth = 8)
  int op_slot_left_2495 = gc_frame_newslot(opresult2519);
  params[0] = call2503;
  partcv[0] = 1;
  Object opresult2520 = callmethod(opresult2519, "++(1)", 1, partcv, params);
// compiled op node returning opresult2520 (depth = 7)
  int op_slot_left_2492 = gc_frame_newslot(opresult2520);
  params[0] = strlit2493;
  partcv[0] = 1;
  Object opresult2521 = callmethod(opresult2520, "++(1)", 1, partcv, params);
// compiled op node returning opresult2521 (depth = 6)
  int op_slot_right_2491 = gc_frame_newslot(opresult2521);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2491 = gc_frame_newslot(*var_s);
  params[0] = opresult2521;
  partcv[0] = 1;
  Object opresult2523 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2523 (depth = 5)
  *var_s = opresult2523;
  if (opresult2523 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2484 = done;
  } else {
  }
// compiled if node returning if2484 (depth = 3)
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_2537(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2539 == NULL) {
    strlit2539 = alloc_String("    ");
    gc_root(strlit2539);
  }
// compiled string node returning strlit2539 (depth = 7)
  int op_slot_right_2538 = gc_frame_newslot(strlit2539);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2538 = gc_frame_newslot(*var_spc);
  params[0] = strlit2539;
  partcv[0] = 1;
  Object opresult2541 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult2541 (depth = 6)
  *var_spc = opresult2541;
  if (opresult2541 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_2562(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_case = &(stackframe->slots[0]);
  *var_case = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2564 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2566 = alloc_Float64(2);
// compiled num node returning num2566 (depth = 9)
  int op_slot_right_2565 = gc_frame_newslot(num2566);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2565 = gc_frame_newslot(*var_depth);
  params[0] = num2566;
  partcv[0] = 1;
  Object sum2568 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2568 (depth = 8)
  gc_frame_newslot(sum2568);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_case (depth = 8)
  params[0] = sum2568;
  partcv[0] = 1;
  Object call2569 = callmethodflags(*var_case, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2564);
// compiled call node returning call2569 (depth = 7)
  int op_slot_right_2563 = gc_frame_newslot(call2569);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2572 == NULL) {
    strlit2572 = alloc_String("case ");
    gc_root(strlit2572);
  }
// compiled string node returning strlit2572 (depth = 8)
  int op_slot_right_2571 = gc_frame_newslot(strlit2572);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2575 == NULL) {
    strlit2575 = alloc_String("    ");
    gc_root(strlit2575);
  }
// compiled string node returning strlit2575 (depth = 9)
  int op_slot_right_2574 = gc_frame_newslot(strlit2575);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2577 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2580 == NULL) {
    strlit2580 = alloc_String("""\x0a""");
    gc_root(strlit2580);
  }
// compiled string node returning strlit2580 (depth = 11)
  int op_slot_right_2579 = gc_frame_newslot(strlit2580);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2579 = gc_frame_newslot(*var_s);
  params[0] = strlit2580;
  partcv[0] = 1;
  Object opresult2582 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2582 (depth = 10)
  int op_slot_left_2577 = gc_frame_newslot(opresult2582);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2583 = callmethod(opresult2582, "++(1)", 1, partcv, params);
// compiled op node returning opresult2583 (depth = 9)
  int op_slot_left_2574 = gc_frame_newslot(opresult2583);
  params[0] = strlit2575;
  partcv[0] = 1;
  Object opresult2584 = callmethod(opresult2583, "++(1)", 1, partcv, params);
// compiled op node returning opresult2584 (depth = 8)
  int op_slot_left_2571 = gc_frame_newslot(opresult2584);
  params[0] = strlit2572;
  partcv[0] = 1;
  Object opresult2585 = callmethod(opresult2584, "++(1)", 1, partcv, params);
// compiled op node returning opresult2585 (depth = 7)
  int op_slot_left_2563 = gc_frame_newslot(opresult2585);
  params[0] = call2569;
  partcv[0] = 1;
  Object opresult2586 = callmethod(opresult2585, "++(1)", 1, partcv, params);
// compiled op node returning opresult2586 (depth = 6)
  *var_s = opresult2586;
  if (opresult2586 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_2525(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2526 == NULL) {
    strlit2526 = alloc_String("");
    gc_root(strlit2526);
  }
// compiled string node returning strlit2526 (depth = 4)
  *var_spc = strlit2526;
  if (strlit2526 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2527 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2530 = alloc_Float64(1);
// compiled num node returning num2530 (depth = 6)
  int op_slot_right_2529 = gc_frame_newslot(num2530);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_2529 = gc_frame_newslot(*var_depth);
  params[0] = num2530;
  partcv[0] = 1;
  Object diff2532 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff2532 (depth = 5)
  int op_slot_right_2528 = gc_frame_newslot(diff2532);
// starting to compile num node (depth = 5)
  Object num2534 = alloc_Float64(0);
// compiled num node returning num2534 (depth = 5)
  int op_slot_left_2528 = gc_frame_newslot(num2534);
  params[0] = diff2532;
  partcv[0] = 1;
  Object opresult2535 = callmethod(num2534, "..(1)", 1, partcv, params);
// compiled op node returning opresult2535 (depth = 4)
  gc_frame_newslot(opresult2535);
// starting to compile block node (depth = 4)
  Object block2536 = alloc_Block(NULL, NULL, "ast", 554);
  gc_frame_newslot(block2536);
// method "_apply(_)"
  block_savedest(block2536);
  Object closure2537 = createclosure(2, "_apply(1)");
  setclosureframe(closure2537, stackframe);
  addtoclosure(closure2537, var_spc);
  addtoclosure(closure2537, selfslot);
  struct UserObject *uo2537 = (struct UserObject*)block2536;
  uo2537->data[0] = (Object)closure2537;
  Method *meth_meth_ast__apply_40_1_41_2537 = addmethod2pos(block2536, "_apply(1)", &meth_ast__apply_40_1_41_2537, 0);
  int argcv_meth_ast__apply_40_1_41_2537[] = {1};
  meth_meth_ast__apply_40_1_41_2537->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2537);
  meth_meth_ast__apply_40_1_41_2537->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2537->definitionLine = 2981;
// compiled block node returning block2536 (depth = 4)
  gc_frame_newslot(block2536);
// call case 5: prelude request
  params[0] = opresult2535;
  params[1] = block2536;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2544 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2527);
// compiled call node returning call2544 (depth = 3)
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2546 == NULL) {
    strlit2546 = alloc_String(")");
    gc_root(strlit2546);
  }
// compiled string node returning strlit2546 (depth = 5)
  int op_slot_right_2545 = gc_frame_newslot(strlit2546);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2549 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num2550 = alloc_Float64(0);
// compiled num node returning num2550 (depth = 7)
  gc_frame_newslot(num2550);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2551 = gc_frame_new();
// call case 4: self request
  Object call2552 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2551);
// compiled member node returning call2552 (depth = 7)
  params[0] = num2550;
  partcv[0] = 1;
  Object call2553 = callmethodflags(call2552, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2549);
// compiled call node returning call2553 (depth = 6)
  int op_slot_right_2548 = gc_frame_newslot(call2553);
// starting to compile string node (depth = 6)
  if (strlit2555 == NULL) {
    strlit2555 = alloc_String("match(");
    gc_root(strlit2555);
  }
// compiled string node returning strlit2555 (depth = 6)
  int op_slot_left_2548 = gc_frame_newslot(strlit2555);
  params[0] = call2553;
  partcv[0] = 1;
  Object opresult2556 = callmethod(strlit2555, "++(1)", 1, partcv, params);
// compiled op node returning opresult2556 (depth = 5)
  int op_slot_left_2545 = gc_frame_newslot(opresult2556);
  params[0] = strlit2546;
  partcv[0] = 1;
  Object opresult2557 = callmethod(opresult2556, "++(1)", 1, partcv, params);
// compiled op node returning opresult2557 (depth = 4)
  *var_s = opresult2557;
  if (opresult2557 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2558 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2559 = gc_frame_new();
// call case 4: self request
  Object call2560 = callmethodflags(self, "cases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2559);
// compiled member node returning call2560 (depth = 4)
  gc_frame_newslot(call2560);
// starting to compile block node (depth = 4)
  Object block2561 = alloc_Block(NULL, NULL, "ast", 558);
  gc_frame_newslot(block2561);
// method "_apply(_)"
  block_savedest(block2561);
  Object closure2562 = createclosure(4, "_apply(1)");
  setclosureframe(closure2562, stackframe);
  addtoclosure(closure2562, var_depth);
  addtoclosure(closure2562, var_spc);
  addtoclosure(closure2562, var_s);
  addtoclosure(closure2562, selfslot);
  struct UserObject *uo2562 = (struct UserObject*)block2561;
  uo2562->data[0] = (Object)closure2562;
  Method *meth_meth_ast__apply_40_1_41_2562 = addmethod2pos(block2561, "_apply(1)", &meth_ast__apply_40_1_41_2562, 0);
  int argcv_meth_ast__apply_40_1_41_2562[] = {1};
  meth_meth_ast__apply_40_1_41_2562->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2562);
  meth_meth_ast__apply_40_1_41_2562->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2562->definitionLine = 2981;
// compiled block node returning block2561 (depth = 4)
  gc_frame_newslot(block2561);
// call case 5: prelude request
  params[0] = call2560;
  params[1] = block2561;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2589 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2558);
// compiled call node returning call2589 (depth = 3)
// Begin line 561
  setline(561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2592 = gc_frame_new();
// call case 4: self request
  Object call2593 = callmethodflags(self, "elsecase", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2592);
// compiled member node returning call2593 (depth = 5)
  int op_slot_right_2591 = gc_frame_newslot(call2593);
// starting to compile identifier node (depth = 5)
  Object bool2595 = alloc_Boolean(0);
// compiled identifier node returning bool2595 (depth = 5)
  int op_slot_left_2591 = gc_frame_newslot(bool2595);
  params[0] = call2593;
  partcv[0] = 1;
  Object opresult2596 = callmethod(bool2595, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2596 (depth = 4)
  Object if2590 = done;
  if (istrue(opresult2596)) {
// Begin line 562
  setline(562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2598 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2600 = alloc_Float64(2);
// compiled num node returning num2600 (depth = 8)
  int op_slot_right_2599 = gc_frame_newslot(num2600);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2599 = gc_frame_newslot(*var_depth);
  params[0] = num2600;
  partcv[0] = 1;
  Object sum2602 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2602 (depth = 7)
  gc_frame_newslot(sum2602);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2603 = gc_frame_new();
// call case 4: self request
  Object call2604 = callmethodflags(self, "elsecase", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2603);
// compiled member node returning call2604 (depth = 7)
  params[0] = sum2602;
  partcv[0] = 1;
  Object call2605 = callmethodflags(call2604, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2598);
// compiled call node returning call2605 (depth = 6)
  int op_slot_right_2597 = gc_frame_newslot(call2605);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2608 == NULL) {
    strlit2608 = alloc_String("else ");
    gc_root(strlit2608);
  }
// compiled string node returning strlit2608 (depth = 7)
  int op_slot_right_2607 = gc_frame_newslot(strlit2608);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2611 == NULL) {
    strlit2611 = alloc_String("    ");
    gc_root(strlit2611);
  }
// compiled string node returning strlit2611 (depth = 8)
  int op_slot_right_2610 = gc_frame_newslot(strlit2611);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_2613 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2616 == NULL) {
    strlit2616 = alloc_String("""\x0a""");
    gc_root(strlit2616);
  }
// compiled string node returning strlit2616 (depth = 10)
  int op_slot_right_2615 = gc_frame_newslot(strlit2616);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_2615 = gc_frame_newslot(*var_s);
  params[0] = strlit2616;
  partcv[0] = 1;
  Object opresult2618 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2618 (depth = 9)
  int op_slot_left_2613 = gc_frame_newslot(opresult2618);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2619 = callmethod(opresult2618, "++(1)", 1, partcv, params);
// compiled op node returning opresult2619 (depth = 8)
  int op_slot_left_2610 = gc_frame_newslot(opresult2619);
  params[0] = strlit2611;
  partcv[0] = 1;
  Object opresult2620 = callmethod(opresult2619, "++(1)", 1, partcv, params);
// compiled op node returning opresult2620 (depth = 7)
  int op_slot_left_2607 = gc_frame_newslot(opresult2620);
  params[0] = strlit2608;
  partcv[0] = 1;
  Object opresult2621 = callmethod(opresult2620, "++(1)", 1, partcv, params);
// compiled op node returning opresult2621 (depth = 6)
  int op_slot_left_2597 = gc_frame_newslot(opresult2621);
  params[0] = call2605;
  partcv[0] = 1;
  Object opresult2622 = callmethod(opresult2621, "++(1)", 1, partcv, params);
// compiled op node returning opresult2622 (depth = 5)
  *var_s = opresult2622;
  if (opresult2622 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2590 = done;
  } else {
  }
// compiled if node returning if2590 (depth = 3)
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy2624(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2625 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe2626 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
  Object bool2627 = alloc_Boolean(0);
// compiled identifier node returning bool2627 (depth = 5)
  gc_frame_newslot(bool2627);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchCaseNode (depth = 5)
  params[0] = *var_nullNode;
  params[1] = *var_emptySeq;
  params[2] = bool2627;
  partcv[0] = 3;
  Object call2628 = callmethodflags(*var_matchCaseNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe2626);
// compiled call node returning call2628 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call2629 = callmethodflags(call2628, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2625);
// compiled call node returning call2629 (depth = 3)
  gc_frame_end(frame);
  return call2629;
}
Object meth_ast_new_40_3_41_2333(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_matchee_39_ = &(stackframe->slots[0]);
  *var_matchee_39_ = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_elsecase_39_ = &(stackframe->slots[2]);
  *var_elsecase_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2334 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2334 = alloc_userobj2(14,12, objclass2334);
  gc_frame_newslot(obj2334);
if (objclass2334 == NULL) {
  glfree(obj2334->class->name);
  obj2334->class->name = "matchCaseNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2334, self, 0);
  addmethodreal(obj2334,"outer", &reader_ast_outer_2335);
  Object oldself2334 = self;
  struct StackFrameObject *oldstackframe2334 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2334);
  gc_frame_newslot((Object)stackframe);
  self = obj2334;
  Object *oldselfslot2334 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2334 = (*(struct UserObject *)self).data[0], lowerouter2334 = thisouter2334;
  if (inheritingObject2334) {
    struct UserObject *inho2334 = (struct UserObject *)inheritingObject2334;
    while (inho2334->super != GraceDefaultObject) inho2334 = (struct UserObject *)inho2334->super;
    inho2334->super = obj2334;
    self = inheritingObject2334;
    *selfslot = self;
    lowerouter2334 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2334;
  }
if (objclass2334 == NULL) {
  Method *reader2336 = addmethodrealflags(obj2334, "kind",&reader_ast_kind_2336, MFLAG_DEF);
  reader2336->definitionModule = modulename;
  reader2336->definitionLine = 511;
}
adddatum2(obj2334, alloc_Undefined(), 1);
if (objclass2334 == NULL) {
  Method *reader2337 = addmethodrealflags(obj2334, "value", &reader_ast_value_2337, 0);
  Method *writer2337 = addmethodrealflags(obj2334, "value:=(1)", &writer_ast_value_2337, 0);
  reader2337->definitionModule = modulename;
  writer2337->definitionModule = modulename;
  reader2337->definitionLine = 512;
  writer2337->definitionLine = 512;
}
obj2334->flags |= OFLAG_MUTABLE;
adddatum2(obj2334, alloc_Undefined(), 2);
if (objclass2334 == NULL) {
  Method *reader2338 = addmethodrealflags(obj2334, "cases", &reader_ast_cases_2338, 0);
  Method *writer2338 = addmethodrealflags(obj2334, "cases:=(1)", &writer_ast_cases_2338, 0);
  reader2338->definitionModule = modulename;
  writer2338->definitionModule = modulename;
  reader2338->definitionLine = 513;
  writer2338->definitionLine = 513;
}
obj2334->flags |= OFLAG_MUTABLE;
adddatum2(obj2334, alloc_Undefined(), 3);
if (objclass2334 == NULL) {
  Method *reader2339 = addmethodrealflags(obj2334, "elsecase", &reader_ast_elsecase_2339, 0);
  Method *writer2339 = addmethodrealflags(obj2334, "elsecase:=(1)", &writer_ast_elsecase_2339, 0);
  reader2339->definitionModule = modulename;
  writer2339->definitionModule = modulename;
  reader2339->definitionLine = 514;
  writer2339->definitionLine = 514;
}
obj2334->flags |= OFLAG_MUTABLE;
adddatum2(obj2334, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo2340 = (struct UserObject*)obj2334;
  uo2340->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple2340 = addmethod2pos(obj2334, "isSimple", &meth_ast_isSimple2340, 5);
  int argcv_meth_ast_isSimple2340[] = {0};
  meth_meth_ast_isSimple2340->type = alloc_MethodType(1, argcv_meth_ast_isSimple2340);
  meth_meth_ast_isSimple2340->definitionModule = modulename;
  meth_meth_ast_isSimple2340->definitionLine = 515;
// method "matchee"
  struct UserObject *uo2342 = (struct UserObject*)obj2334;
  uo2342->data[6] = emptyclosure;
  Method *meth_meth_ast_matchee2342 = addmethod2pos(obj2334, "matchee", &meth_ast_matchee2342, 6);
  int argcv_meth_ast_matchee2342[] = {0};
  meth_meth_ast_matchee2342->type = alloc_MethodType(1, argcv_meth_ast_matchee2342);
  meth_meth_ast_matchee2342->definitionModule = modulename;
  meth_meth_ast_matchee2342->definitionLine = 516;
// method "accept(_)from(_)"
  struct UserObject *uo2345 = (struct UserObject*)obj2334;
  uo2345->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_2345 = addmethod2pos(obj2334, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_2345, 7);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_2345[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_2345->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_2345);
  meth_meth_ast_accept_40_1_41_from_40_1_41_2345->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_2345->definitionLine = 517;
// method "map(_)ancestors(_)"
  struct UserObject *uo2375 = (struct UserObject*)obj2334;
  uo2375->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_2375 = addmethod2pos(obj2334, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_2375, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2375[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2375->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2375);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2375->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2375->definitionLine = 529;
// method "pretty(_)"
  struct UserObject *uo2408 = (struct UserObject*)obj2334;
  uo2408->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_2408 = addmethod2pos(obj2334, "pretty(1)", &meth_ast_pretty_40_1_41_2408, 9);
  int argcv_meth_ast_pretty_40_1_41_2408[] = {1};
  meth_meth_ast_pretty_40_1_41_2408->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_2408);
  meth_meth_ast_pretty_40_1_41_2408->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_2408->definitionLine = 537;
// method "toGrace(_)"
  struct UserObject *uo2525 = (struct UserObject*)obj2334;
  uo2525->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_2525 = addmethod2pos(obj2334, "toGrace(1)", &meth_ast_toGrace_40_1_41_2525, 10);
  int argcv_meth_ast_toGrace_40_1_41_2525[] = {1};
  meth_meth_ast_toGrace_40_1_41_2525->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_2525);
meth_meth_ast_toGrace_40_1_41_2525->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_2525->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_2525->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_2525->definitionLine = 552;
// method "shallowCopy"
  block_savedest(obj2334);
  Object closure2624 = createclosure(3, "shallowCopy");
  setclosureframe(closure2624, stackframe);
  addtoclosure(closure2624, var_nullNode);
  addtoclosure(closure2624, var_emptySeq);
  addtoclosure(closure2624, var_matchCaseNode);
  struct UserObject *uo2624 = (struct UserObject*)obj2334;
  uo2624->data[11] = (Object)closure2624;
  Method *meth_meth_ast_shallowCopy2624 = addmethod2pos(obj2334, "shallowCopy", &meth_ast_shallowCopy2624, 11);
  int argcv_meth_ast_shallowCopy2624[] = {0};
  meth_meth_ast_shallowCopy2624->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2624);
  meth_meth_ast_shallowCopy2624->definitionModule = modulename;
  meth_meth_ast_shallowCopy2624->definitionLine = 566;
  sourceObject = obj2334;
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2630 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2631 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2632 = gc_frame_new();
// call case 3: self.outer request
  Object call2633 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2632);
// compiled member node returning call2633 (depth = 5)
  Object call2634 = callmethodflags(call2633, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2631);
// compiled member node returning call2634 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2635 = callmethodflags(call2634, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2630);
// compiled call node returning call2635 (depth = 3)
  struct UserObject *obj2334_uo = (struct UserObject *)obj2334;
  obj2334_uo->super = call2635;
  sourceObject = obj2334;
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2636 == NULL) {
    strlit2636 = alloc_String("matchcase");
    gc_root(strlit2636);
  }
// compiled string node returning strlit2636 (depth = 3)
  adddatum2(obj2334, strlit2636, 1);
  sourceObject = obj2334;
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_matchee_39_ (depth = 3)
  adddatum2(obj2334, *var_matchee_39_, 2);
  sourceObject = obj2334;
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj2334, *var_cases_39_, 3);
  sourceObject = obj2334;
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elsecase_39_ (depth = 3)
  adddatum2(obj2334, *var_elsecase_39_, 4);
  sourceObject = obj2334;
  sourceObject = obj2334;
  sourceObject = obj2334;
  sourceObject = obj2334;
  sourceObject = obj2334;
  sourceObject = obj2334;
  sourceObject = obj2334;
  objclass2334 = obj2334->class;
  objclass2334->definitionModule = modulename;
  objclass2334->definitionLine = 509;
  (*(struct UserObject *)self).data[0] = lowerouter2334;
  self = oldself2334;
  selfslot = oldselfslot2334;
  stackframe = oldstackframe2334;
  gc_frame_end(frame);
  return obj2334;
}
Object meth_ast_new_40_3_41_2333_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_matchee_39_ = &(stackframe->slots[0]);
  *var_matchee_39_ = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_elsecase_39_ = &(stackframe->slots[2]);
  *var_elsecase_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2334 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2334 = alloc_userobj2(14,12, objclass2334);
  gc_frame_newslot(obj2334);
if (objclass2334 == NULL) {
  glfree(obj2334->class->name);
  obj2334->class->name = "matchCaseNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2334, self, 0);
  addmethodreal(obj2334,"outer", &reader_ast_outer_2335);
  Object oldself2334 = self;
  struct StackFrameObject *oldstackframe2334 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2334);
  gc_frame_newslot((Object)stackframe);
  self = obj2334;
  Object *oldselfslot2334 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2334 = (*(struct UserObject *)self).data[0], lowerouter2334 = thisouter2334;
  if (inheritingObject2334) {
    struct UserObject *inho2334 = (struct UserObject *)inheritingObject2334;
    while (inho2334->super != GraceDefaultObject) inho2334 = (struct UserObject *)inho2334->super;
    inho2334->super = obj2334;
    self = inheritingObject2334;
    *selfslot = self;
    lowerouter2334 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2334;
  }
if (objclass2334 == NULL) {
  Method *reader2336 = addmethodrealflags(obj2334, "kind",&reader_ast_kind_2336, MFLAG_DEF);
  reader2336->definitionModule = modulename;
  reader2336->definitionLine = 511;
}
adddatum2(obj2334, alloc_Undefined(), 1);
if (objclass2334 == NULL) {
  Method *reader2337 = addmethodrealflags(obj2334, "value", &reader_ast_value_2337, 0);
  Method *writer2337 = addmethodrealflags(obj2334, "value:=(1)", &writer_ast_value_2337, 0);
  reader2337->definitionModule = modulename;
  writer2337->definitionModule = modulename;
  reader2337->definitionLine = 512;
  writer2337->definitionLine = 512;
}
obj2334->flags |= OFLAG_MUTABLE;
adddatum2(obj2334, alloc_Undefined(), 2);
if (objclass2334 == NULL) {
  Method *reader2338 = addmethodrealflags(obj2334, "cases", &reader_ast_cases_2338, 0);
  Method *writer2338 = addmethodrealflags(obj2334, "cases:=(1)", &writer_ast_cases_2338, 0);
  reader2338->definitionModule = modulename;
  writer2338->definitionModule = modulename;
  reader2338->definitionLine = 513;
  writer2338->definitionLine = 513;
}
obj2334->flags |= OFLAG_MUTABLE;
adddatum2(obj2334, alloc_Undefined(), 3);
if (objclass2334 == NULL) {
  Method *reader2339 = addmethodrealflags(obj2334, "elsecase", &reader_ast_elsecase_2339, 0);
  Method *writer2339 = addmethodrealflags(obj2334, "elsecase:=(1)", &writer_ast_elsecase_2339, 0);
  reader2339->definitionModule = modulename;
  writer2339->definitionModule = modulename;
  reader2339->definitionLine = 514;
  writer2339->definitionLine = 514;
}
obj2334->flags |= OFLAG_MUTABLE;
adddatum2(obj2334, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo2340 = (struct UserObject*)obj2334;
  uo2340->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple2340 = addmethod2pos(obj2334, "isSimple", &meth_ast_isSimple2340, 5);
  int argcv_meth_ast_isSimple2340[] = {0};
  meth_meth_ast_isSimple2340->type = alloc_MethodType(1, argcv_meth_ast_isSimple2340);
  meth_meth_ast_isSimple2340->definitionModule = modulename;
  meth_meth_ast_isSimple2340->definitionLine = 515;
// method "matchee"
  struct UserObject *uo2342 = (struct UserObject*)obj2334;
  uo2342->data[6] = emptyclosure;
  Method *meth_meth_ast_matchee2342 = addmethod2pos(obj2334, "matchee", &meth_ast_matchee2342, 6);
  int argcv_meth_ast_matchee2342[] = {0};
  meth_meth_ast_matchee2342->type = alloc_MethodType(1, argcv_meth_ast_matchee2342);
  meth_meth_ast_matchee2342->definitionModule = modulename;
  meth_meth_ast_matchee2342->definitionLine = 516;
// method "accept(_)from(_)"
  struct UserObject *uo2345 = (struct UserObject*)obj2334;
  uo2345->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_2345 = addmethod2pos(obj2334, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_2345, 7);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_2345[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_2345->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_2345);
  meth_meth_ast_accept_40_1_41_from_40_1_41_2345->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_2345->definitionLine = 517;
// method "map(_)ancestors(_)"
  struct UserObject *uo2375 = (struct UserObject*)obj2334;
  uo2375->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_2375 = addmethod2pos(obj2334, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_2375, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2375[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2375->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2375);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2375->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2375->definitionLine = 529;
// method "pretty(_)"
  struct UserObject *uo2408 = (struct UserObject*)obj2334;
  uo2408->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_2408 = addmethod2pos(obj2334, "pretty(1)", &meth_ast_pretty_40_1_41_2408, 9);
  int argcv_meth_ast_pretty_40_1_41_2408[] = {1};
  meth_meth_ast_pretty_40_1_41_2408->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_2408);
  meth_meth_ast_pretty_40_1_41_2408->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_2408->definitionLine = 537;
// method "toGrace(_)"
  struct UserObject *uo2525 = (struct UserObject*)obj2334;
  uo2525->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_2525 = addmethod2pos(obj2334, "toGrace(1)", &meth_ast_toGrace_40_1_41_2525, 10);
  int argcv_meth_ast_toGrace_40_1_41_2525[] = {1};
  meth_meth_ast_toGrace_40_1_41_2525->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_2525);
meth_meth_ast_toGrace_40_1_41_2525->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_2525->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_2525->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_2525->definitionLine = 552;
// method "shallowCopy"
  block_savedest(obj2334);
  Object closure2624 = createclosure(3, "shallowCopy");
  setclosureframe(closure2624, stackframe);
  addtoclosure(closure2624, var_nullNode);
  addtoclosure(closure2624, var_emptySeq);
  addtoclosure(closure2624, var_matchCaseNode);
  struct UserObject *uo2624 = (struct UserObject*)obj2334;
  uo2624->data[11] = (Object)closure2624;
  Method *meth_meth_ast_shallowCopy2624 = addmethod2pos(obj2334, "shallowCopy", &meth_ast_shallowCopy2624, 11);
  int argcv_meth_ast_shallowCopy2624[] = {0};
  meth_meth_ast_shallowCopy2624->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2624);
  meth_meth_ast_shallowCopy2624->definitionModule = modulename;
  meth_meth_ast_shallowCopy2624->definitionLine = 566;
  sourceObject = obj2334;
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2630 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2631 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2632 = gc_frame_new();
// call case 3: self.outer request
  Object call2633 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2632);
// compiled member node returning call2633 (depth = 5)
  Object call2634 = callmethodflags(call2633, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2631);
// compiled member node returning call2634 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2635 = callmethodflags(call2634, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2630);
// compiled call node returning call2635 (depth = 3)
  struct UserObject *obj2334_uo = (struct UserObject *)obj2334;
  obj2334_uo->super = call2635;
  sourceObject = obj2334;
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2636 == NULL) {
    strlit2636 = alloc_String("matchcase");
    gc_root(strlit2636);
  }
// compiled string node returning strlit2636 (depth = 3)
  adddatum2(obj2334, strlit2636, 1);
  sourceObject = obj2334;
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_matchee_39_ (depth = 3)
  adddatum2(obj2334, *var_matchee_39_, 2);
  sourceObject = obj2334;
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj2334, *var_cases_39_, 3);
  sourceObject = obj2334;
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elsecase_39_ (depth = 3)
  adddatum2(obj2334, *var_elsecase_39_, 4);
  sourceObject = obj2334;
  sourceObject = obj2334;
  sourceObject = obj2334;
  sourceObject = obj2334;
  sourceObject = obj2334;
  sourceObject = obj2334;
  sourceObject = obj2334;
  objclass2334 = obj2334->class;
  objclass2334->definitionModule = modulename;
  objclass2334->definitionLine = 509;
  (*(struct UserObject *)self).data[0] = lowerouter2334;
  self = oldself2334;
  selfslot = oldselfslot2334;
  stackframe = oldstackframe2334;
  gc_frame_end(frame);
  return obj2334;
}
Object meth_ast_matchCaseNode2638(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "matchCaseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_matchCaseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_matchCaseNode (depth = 3)
  gc_frame_end(frame);
  return *var_matchCaseNode;
}
Object meth_ast__apply_40_2_41_2652(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_each = &(stackframe->slots[1]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2654 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  Object call2655 = callmethodflags(*var_each, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe2654);
// compiled member node returning call2655 (depth = 6)
  int op_slot_right_2653 = gc_frame_newslot(call2655);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_2653 = gc_frame_newslot(*var_acc);
  params[0] = call2655;
  partcv[0] = 1;
  Object opresult2657 = callmethod(*var_acc, "++(1)", 1, partcv, params);
// compiled op node returning opresult2657 (depth = 5)
  gc_frame_end(frame);
  return opresult2657;
}
Object meth_ast_nameString2649(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2650 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block2651 = alloc_Block(NULL, NULL, "ast", 585);
  gc_frame_newslot(block2651);
// method "_apply(_,_)"
  block_savedest(block2651);
  Object closure2652 = createclosure(1, "_apply(2)");
  setclosureframe(closure2652, stackframe);
  addtoclosure(closure2652, selfslot);
  struct UserObject *uo2652 = (struct UserObject*)block2651;
  uo2652->data[0] = (Object)closure2652;
  Method *meth_meth_ast__apply_40_2_41_2652 = addmethod2pos(block2651, "_apply(2)", &meth_ast__apply_40_2_41_2652, 0);
  int argcv_meth_ast__apply_40_2_41_2652[] = {2};
  meth_meth_ast__apply_40_2_41_2652->type = alloc_MethodType(1, argcv_meth_ast__apply_40_2_41_2652);
  meth_meth_ast__apply_40_2_41_2652->definitionModule = modulename;
  meth_meth_ast__apply_40_2_41_2652->definitionLine = 2981;
// compiled block node returning block2651 (depth = 4)
  gc_frame_newslot(block2651);
// Begin line 586
  setline(586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2659 == NULL) {
    strlit2659 = alloc_String("");
    gc_root(strlit2659);
  }
// compiled string node returning strlit2659 (depth = 4)
  gc_frame_newslot(strlit2659);
// call case 6: other requests
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2660 = gc_frame_new();
// call case 4: self request
  Object call2661 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2660);
// compiled member node returning call2661 (depth = 4)
  params[0] = block2651;
  params[1] = strlit2659;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2662 = callmethodflags(call2661, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2650);
// compiled call node returning call2662 (depth = 3)
  gc_frame_end(frame);
  return call2662;
}
Object meth_ast_value2663(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "value");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2666 = gc_frame_new();
// call case 4: self request
  Object call2667 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2666);
// compiled member node returning call2667 (depth = 5)
  int op_slot_right_2665 = gc_frame_newslot(call2667);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_uninitialized (depth = 5)
  int op_slot_left_2665 = gc_frame_newslot(*var_uninitialized);
  params[0] = call2667;
  partcv[0] = 1;
  Object opresult2669 = callmethod(*var_uninitialized, "==(1)", 1, partcv, params);
// compiled op node returning opresult2669 (depth = 4)
  Object if2664 = done;
  if (istrue(opresult2669)) {
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2670 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe2671 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2672 = gc_frame_new();
// call case 4: self request
  Object call2673 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2672);
// compiled member node returning call2673 (depth = 6)
  gc_frame_newslot(call2673);
// starting to compile identifier node (depth = 6)
  Object bool2674 = alloc_Boolean(0);
// compiled identifier node returning bool2674 (depth = 6)
  gc_frame_newslot(bool2674);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_identifierNode (depth = 6)
  params[0] = call2673;
  params[1] = bool2674;
  partcv[0] = 2;
  Object call2675 = callmethodflags(*var_identifierNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2671);
// compiled call node returning call2675 (depth = 5)
  gc_frame_newslot(call2675);
// call case 4: self request
  params[0] = call2675;
  partcv[0] = 1;
  Object call2676 = callmethodflags(self, "cachedIdentifier:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2670);
// compiled call node returning call2676 (depth = 4)
// Begin line 591
  setline(591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2677 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2678 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2679 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2680 = gc_frame_new();
// call case 4: self request
  Object call2681 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2680);
// compiled member node returning call2681 (depth = 7)
  Object call2682 = callmethodflags(call2681, "first", 0, partcv, params, 0);
  gc_frame_end(callframe2679);
// compiled member node returning call2682 (depth = 6)
  Object call2683 = callmethodflags(call2682, "line", 0, partcv, params, 0);
  gc_frame_end(callframe2678);
// compiled member node returning call2683 (depth = 5)
  gc_frame_newslot(call2683);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2684 = gc_frame_new();
// call case 4: self request
  Object call2685 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2684);
// compiled member node returning call2685 (depth = 5)
  params[0] = call2683;
  partcv[0] = 1;
  Object call2686 = callmethodflags(call2685, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2677);
// compiled call node returning call2686 (depth = 4)
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2687 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2688 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2689 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2690 = gc_frame_new();
// call case 4: self request
  Object call2691 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2690);
// compiled member node returning call2691 (depth = 7)
  Object call2692 = callmethodflags(call2691, "first", 0, partcv, params, 0);
  gc_frame_end(callframe2689);
// compiled member node returning call2692 (depth = 6)
  Object call2693 = callmethodflags(call2692, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe2688);
// compiled member node returning call2693 (depth = 5)
  gc_frame_newslot(call2693);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2694 = gc_frame_new();
// call case 4: self request
  Object call2695 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2694);
// compiled member node returning call2695 (depth = 5)
  params[0] = call2693;
  partcv[0] = 1;
  Object call2696 = callmethodflags(call2695, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2687);
// compiled call node returning call2696 (depth = 4)
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2697 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool2698 = alloc_Boolean(1);
// compiled identifier node returning bool2698 (depth = 5)
  gc_frame_newslot(bool2698);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2699 = gc_frame_new();
// call case 4: self request
  Object call2700 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2699);
// compiled member node returning call2700 (depth = 5)
  params[0] = bool2698;
  partcv[0] = 1;
  Object call2701 = callmethodflags(call2700, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2697);
// compiled call node returning call2701 (depth = 4)
    gc_frame_newslot(call2701);
    if2664 = call2701;
  } else {
  }
// compiled if node returning if2664 (depth = 3)
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe2702 = gc_frame_new();
// call case 4: self request
  Object call2703 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2702);
// compiled member node returning call2703 (depth = 3)
  gc_frame_end(frame);
  return call2703;
}
Object meth_ast_isExecutable2704(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2705 = alloc_Boolean(0);
// compiled identifier node returning bool2705 (depth = 3)
  gc_frame_end(frame);
  return bool2705;
}
Object meth_ast__apply_40_1_41_2712(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe2713 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_b (depth = 8)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2714 = callmethodflags(*var_b, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2713);
// compiled call node returning call2714 (depth = 7)
  gc_frame_end(frame);
  return call2714;
}
Object meth_ast__apply_40_1_41_2709(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2710 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2711 = alloc_Block(NULL, NULL, "ast", 600);
  gc_frame_newslot(block2711);
// method "_apply(_)"
  block_savedest(block2711);
  Object closure2712 = createclosure(2, "_apply(1)");
  setclosureframe(closure2712, stackframe);
  addtoclosure(closure2712, var_b);
  addtoclosure(closure2712, selfslot);
  struct UserObject *uo2712 = (struct UserObject*)block2711;
  uo2712->data[0] = (Object)closure2712;
  Method *meth_meth_ast__apply_40_1_41_2712 = addmethod2pos(block2711, "_apply(1)", &meth_ast__apply_40_1_41_2712, 0);
  int argcv_meth_ast__apply_40_1_41_2712[] = {1};
  meth_meth_ast__apply_40_1_41_2712->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2712);
  meth_meth_ast__apply_40_1_41_2712->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2712->definitionLine = 2981;
// compiled block node returning block2711 (depth = 6)
  gc_frame_newslot(block2711);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2716 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call2717 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe2716);
// compiled member node returning call2717 (depth = 6)
  params[0] = block2711;
  partcv[0] = 1;
  Object call2718 = callmethodflags(call2717, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2710);
// compiled call node returning call2718 (depth = 5)
  gc_frame_end(frame);
  return call2718;
}
Object meth_ast_parametersDo_40_1_41_2706(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parametersDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parametersDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parametersDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parametersDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2707 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block2708 = alloc_Block(NULL, NULL, "ast", 599);
  gc_frame_newslot(block2708);
// method "_apply(_)"
  block_savedest(block2708);
  Object closure2709 = createclosure(2, "_apply(1)");
  setclosureframe(closure2709, stackframe);
  addtoclosure(closure2709, var_b);
  addtoclosure(closure2709, selfslot);
  struct UserObject *uo2709 = (struct UserObject*)block2708;
  uo2709->data[0] = (Object)closure2709;
  Method *meth_meth_ast__apply_40_1_41_2709 = addmethod2pos(block2708, "_apply(1)", &meth_ast__apply_40_1_41_2709, 0);
  int argcv_meth_ast__apply_40_1_41_2709[] = {1};
  meth_meth_ast__apply_40_1_41_2709->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2709);
  meth_meth_ast__apply_40_1_41_2709->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2709->definitionLine = 2981;
// compiled block node returning block2708 (depth = 4)
  gc_frame_newslot(block2708);
// call case 6: other requests
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2720 = gc_frame_new();
// call case 4: self request
  Object call2721 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2720);
// compiled member node returning call2721 (depth = 4)
  params[0] = block2708;
  partcv[0] = 1;
  Object call2722 = callmethodflags(call2721, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2707);
// compiled call node returning call2722 (depth = 3)
  gc_frame_end(frame);
  return call2722;
}
Object meth_ast_scope_58__61__40_1_41_2723(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2724 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call2725 = callmethodflags(self, "symbolTable:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2724);
// compiled call node returning call2725 (depth = 3)
// Begin line 607
  setline(607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2726 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call2727 = callmethodflags(*var_st, "node:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2726);
// compiled call node returning call2727 (depth = 3)
  gc_frame_end(frame);
  return call2727;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_2728(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe2729 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call2730 = callmethodflags(*var_k, "typedec", 0, partcv, params, 0);
  gc_frame_end(callframe2729);
// compiled member node returning call2730 (depth = 3)
  gc_frame_end(frame);
  return call2730;
}
Object meth_ast__apply_40_1_41_2763(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2764 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2765 = callmethodflags(*var_part, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2764);
// compiled call node returning call2765 (depth = 6)
  gc_frame_end(frame);
  return call2765;
}
Object meth_ast_accept_40_1_41_from_40_1_41_2731(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2733 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2734 = callmethodflags(*var_visitor, "visitMethodType(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2733);
// compiled call node returning call2734 (depth = 4)
  Object if2732 = done;
  if (istrue(call2734)) {
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2735 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call2736 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2735);
// compiled call node returning call2736 (depth = 5)
  *var_newChain = call2736;
  if (call2736 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 613
  setline(613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2739 = gc_frame_new();
// call case 4: self request
  Object call2740 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2739);
// compiled member node returning call2740 (depth = 6)
  int op_slot_right_2738 = gc_frame_newslot(call2740);
// starting to compile identifier node (depth = 6)
  Object bool2742 = alloc_Boolean(0);
// compiled identifier node returning bool2742 (depth = 6)
  int op_slot_left_2738 = gc_frame_newslot(bool2742);
  params[0] = call2740;
  partcv[0] = 1;
  Object opresult2743 = callmethod(bool2742, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2743 (depth = 5)
  Object if2737 = done;
  if (istrue(opresult2743)) {
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2744 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2745 = gc_frame_new();
// call case 4: self request
  Object call2746 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2745);
// compiled member node returning call2746 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2747 = callmethodflags(call2746, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2744);
// compiled call node returning call2747 (depth = 5)
    gc_frame_newslot(call2747);
    if2737 = call2747;
  } else {
  }
// compiled if node returning if2737 (depth = 4)
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2750 = gc_frame_new();
// call case 4: self request
  Object call2751 = callmethodflags(self, "rtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2750);
// compiled member node returning call2751 (depth = 6)
  int op_slot_right_2749 = gc_frame_newslot(call2751);
// starting to compile identifier node (depth = 6)
  Object bool2753 = alloc_Boolean(0);
// compiled identifier node returning bool2753 (depth = 6)
  int op_slot_left_2749 = gc_frame_newslot(bool2753);
  params[0] = call2751;
  partcv[0] = 1;
  Object opresult2754 = callmethod(bool2753, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2754 (depth = 5)
  Object if2748 = done;
  if (istrue(opresult2754)) {
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2755 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2756 = gc_frame_new();
// call case 4: self request
  Object call2757 = callmethodflags(self, "rtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2756);
// compiled member node returning call2757 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2758 = callmethodflags(call2757, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2755);
// compiled call node returning call2758 (depth = 5)
    gc_frame_newslot(call2758);
    if2748 = call2758;
  } else {
  }
// compiled if node returning if2748 (depth = 4)
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2759 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2760 = gc_frame_new();
// call case 4: self request
  Object call2761 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2760);
// compiled member node returning call2761 (depth = 5)
  gc_frame_newslot(call2761);
// starting to compile block node (depth = 5)
  Object block2762 = alloc_Block(NULL, NULL, "ast", 619);
  gc_frame_newslot(block2762);
// method "_apply(_)"
  block_savedest(block2762);
  Object closure2763 = createclosure(3, "_apply(1)");
  setclosureframe(closure2763, stackframe);
  addtoclosure(closure2763, var_visitor);
  addtoclosure(closure2763, var_newChain);
  addtoclosure(closure2763, selfslot);
  struct UserObject *uo2763 = (struct UserObject*)block2762;
  uo2763->data[0] = (Object)closure2763;
  Method *meth_meth_ast__apply_40_1_41_2763 = addmethod2pos(block2762, "_apply(1)", &meth_ast__apply_40_1_41_2763, 0);
  int argcv_meth_ast__apply_40_1_41_2763[] = {1};
  meth_meth_ast__apply_40_1_41_2763->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2763);
  meth_meth_ast__apply_40_1_41_2763->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2763->definitionLine = 2981;
// compiled block node returning block2762 (depth = 5)
  gc_frame_newslot(block2762);
// call case 5: prelude request
  params[0] = call2761;
  params[1] = block2762;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2767 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2759);
// compiled call node returning call2767 (depth = 4)
    gc_frame_newslot(call2767);
    if2732 = call2767;
  } else {
  }
// compiled if node returning if2732 (depth = 3)
  gc_frame_end(frame);
  return if2732;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_2768(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2769 = gc_frame_new();
// call case 4: self request
  Object call2770 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2769);
// compiled member node returning call2770 (depth = 4)
  *var_n = call2770;
  if (call2770 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2771 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2772 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2771);
// compiled call node returning call2772 (depth = 4)
  *var_newChain = call2772;
  if (call2772 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2773 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2774 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2775 = gc_frame_new();
// call case 4: self request
  Object call2776 = callmethodflags(self, "rtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2775);
// compiled member node returning call2776 (depth = 5)
  gc_frame_newslot(call2776);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2777 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2778 = gc_frame_new();
// call case 3: self.outer request
  Object call2779 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2778);
// compiled member node returning call2779 (depth = 6)
  Object call2780 = callmethodflags(call2779, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2777);
// compiled member node returning call2780 (depth = 5)
  params[0] = call2776;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2781 = callmethodflags(call2780, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2774);
// compiled call node returning call2781 (depth = 4)
  gc_frame_newslot(call2781);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2781;
  partcv[0] = 1;
  Object call2782 = callmethodflags(*var_n, "rtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2773);
// compiled call node returning call2782 (depth = 3)
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2783 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2784 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2785 = gc_frame_new();
// call case 4: self request
  Object call2786 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2785);
// compiled member node returning call2786 (depth = 5)
  gc_frame_newslot(call2786);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2787 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2788 = gc_frame_new();
// call case 3: self.outer request
  Object call2789 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2788);
// compiled member node returning call2789 (depth = 6)
  Object call2790 = callmethodflags(call2789, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2787);
// compiled member node returning call2790 (depth = 5)
  params[0] = call2786;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2791 = callmethodflags(call2790, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2784);
// compiled call node returning call2791 (depth = 4)
  gc_frame_newslot(call2791);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2791;
  partcv[0] = 1;
  Object call2792 = callmethodflags(*var_n, "signature:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2783);
// compiled call node returning call2792 (depth = 3)
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2793 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2794 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe2795 = gc_frame_new();
// call case 4: self request
  Object call2796 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2795);
// compiled member node returning call2796 (depth = 5)
  gc_frame_newslot(call2796);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2797 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2798 = gc_frame_new();
// call case 3: self.outer request
  Object call2799 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2798);
// compiled member node returning call2799 (depth = 6)
  Object call2800 = callmethodflags(call2799, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2797);
// compiled member node returning call2800 (depth = 5)
  params[0] = call2796;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2801 = callmethodflags(call2800, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2794);
// compiled call node returning call2801 (depth = 4)
  gc_frame_newslot(call2801);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2801;
  partcv[0] = 1;
  Object call2802 = callmethodflags(*var_n, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2793);
// compiled call node returning call2802 (depth = 3)
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2803 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call2804 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe2803);
// compiled call node returning call2804 (depth = 3)
  gc_frame_end(frame);
  return call2804;
}
Object meth_ast__apply_40_1_41_2813(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2815 == NULL) {
    strlit2815 = alloc_String("  ");
    gc_root(strlit2815);
  }
// compiled string node returning strlit2815 (depth = 7)
  int op_slot_right_2814 = gc_frame_newslot(strlit2815);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2814 = gc_frame_newslot(*var_spc);
  params[0] = strlit2815;
  partcv[0] = 1;
  Object opresult2817 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult2817 (depth = 6)
  *var_spc = opresult2817;
  if (opresult2817 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_2952(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2954 == NULL) {
    strlit2954 = alloc_String("");
    gc_root(strlit2954);
  }
// compiled string node returning strlit2954 (depth = 7)
  int op_slot_right_2953 = gc_frame_newslot(strlit2954);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2957 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2959 = alloc_Float64(2);
// compiled num node returning num2959 (depth = 10)
  int op_slot_right_2958 = gc_frame_newslot(num2959);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2958 = gc_frame_newslot(*var_depth);
  params[0] = num2959;
  partcv[0] = 1;
  Object sum2961 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2961 (depth = 9)
  gc_frame_newslot(sum2961);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  params[0] = sum2961;
  partcv[0] = 1;
  Object call2962 = callmethodflags(*var_part, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2957);
// compiled call node returning call2962 (depth = 8)
  int op_slot_right_2956 = gc_frame_newslot(call2962);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2965 == NULL) {
    strlit2965 = alloc_String("");
    gc_root(strlit2965);
  }
// compiled string node returning strlit2965 (depth = 9)
  int op_slot_right_2964 = gc_frame_newslot(strlit2965);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2967 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2970 == NULL) {
    strlit2970 = alloc_String("""\x0a""  ");
    gc_root(strlit2970);
  }
// compiled string node returning strlit2970 (depth = 11)
  int op_slot_right_2969 = gc_frame_newslot(strlit2970);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_2972 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit2974 == NULL) {
    strlit2974 = alloc_String("");
    gc_root(strlit2974);
  }
// compiled string node returning strlit2974 (depth = 12)
  int op_slot_left_2972 = gc_frame_newslot(strlit2974);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2975 = callmethod(strlit2974, "++(1)", 1, partcv, params);
// compiled op node returning opresult2975 (depth = 11)
  int op_slot_left_2969 = gc_frame_newslot(opresult2975);
  params[0] = strlit2970;
  partcv[0] = 1;
  Object opresult2976 = callmethod(opresult2975, "++(1)", 1, partcv, params);
// compiled op node returning opresult2976 (depth = 10)
  int op_slot_left_2967 = gc_frame_newslot(opresult2976);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2977 = callmethod(opresult2976, "++(1)", 1, partcv, params);
// compiled op node returning opresult2977 (depth = 9)
  int op_slot_left_2964 = gc_frame_newslot(opresult2977);
  params[0] = strlit2965;
  partcv[0] = 1;
  Object opresult2978 = callmethod(opresult2977, "++(1)", 1, partcv, params);
// compiled op node returning opresult2978 (depth = 8)
  int op_slot_left_2956 = gc_frame_newslot(opresult2978);
  params[0] = call2962;
  partcv[0] = 1;
  Object opresult2979 = callmethod(opresult2978, "++(1)", 1, partcv, params);
// compiled op node returning opresult2979 (depth = 7)
  int op_slot_left_2953 = gc_frame_newslot(opresult2979);
  params[0] = strlit2954;
  partcv[0] = 1;
  Object opresult2980 = callmethod(opresult2979, "++(1)", 1, partcv, params);
// compiled op node returning opresult2980 (depth = 6)
  *var_s = opresult2980;
  if (opresult2980 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_2805(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2806 == NULL) {
    strlit2806 = alloc_String("");
    gc_root(strlit2806);
  }
// compiled string node returning strlit2806 (depth = 4)
  *var_spc = strlit2806;
  if (strlit2806 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2807 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_2808 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num2810 = alloc_Float64(0);
// compiled num node returning num2810 (depth = 5)
  int op_slot_left_2808 = gc_frame_newslot(num2810);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2811 = callmethod(num2810, "..(1)", 1, partcv, params);
// compiled op node returning opresult2811 (depth = 4)
  gc_frame_newslot(opresult2811);
// starting to compile block node (depth = 4)
  Object block2812 = alloc_Block(NULL, NULL, "ast", 634);
  gc_frame_newslot(block2812);
// method "_apply(_)"
  block_savedest(block2812);
  Object closure2813 = createclosure(2, "_apply(1)");
  setclosureframe(closure2813, stackframe);
  addtoclosure(closure2813, var_spc);
  addtoclosure(closure2813, selfslot);
  struct UserObject *uo2813 = (struct UserObject*)block2812;
  uo2813->data[0] = (Object)closure2813;
  Method *meth_meth_ast__apply_40_1_41_2813 = addmethod2pos(block2812, "_apply(1)", &meth_ast__apply_40_1_41_2813, 0);
  int argcv_meth_ast__apply_40_1_41_2813[] = {1};
  meth_meth_ast__apply_40_1_41_2813->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2813);
  meth_meth_ast__apply_40_1_41_2813->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2813->definitionLine = 2981;
// compiled block node returning block2812 (depth = 4)
  gc_frame_newslot(block2812);
// call case 5: prelude request
  params[0] = opresult2811;
  params[1] = block2812;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2820 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2807);
// compiled call node returning call2820 (depth = 3)
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2822 == NULL) {
    strlit2822 = alloc_String("""\x0a""");
    gc_root(strlit2822);
  }
// compiled string node returning strlit2822 (depth = 5)
  int op_slot_right_2821 = gc_frame_newslot(strlit2822);
// starting to compile call node (depth = 5)
  int callframe2824 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2825 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe2824);
// compiled call node returning call2825 (depth = 5)
  int op_slot_left_2821 = gc_frame_newslot(call2825);
  params[0] = strlit2822;
  partcv[0] = 1;
  Object opresult2826 = callmethod(call2825, "++(1)", 1, partcv, params);
// compiled op node returning opresult2826 (depth = 4)
  *var_s = opresult2826;
  if (opresult2826 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2828 == NULL) {
    strlit2828 = alloc_String("""\x0a""");
    gc_root(strlit2828);
  }
// compiled string node returning strlit2828 (depth = 5)
  int op_slot_right_2827 = gc_frame_newslot(strlit2828);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2831 = gc_frame_new();
// call case 4: self request
  Object call2832 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2831);
// compiled member node returning call2832 (depth = 6)
  int op_slot_right_2830 = gc_frame_newslot(call2832);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2835 == NULL) {
    strlit2835 = alloc_String("Name: ");
    gc_root(strlit2835);
  }
// compiled string node returning strlit2835 (depth = 7)
  int op_slot_right_2834 = gc_frame_newslot(strlit2835);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_2837 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2840 == NULL) {
    strlit2840 = alloc_String("");
    gc_root(strlit2840);
  }
// compiled string node returning strlit2840 (depth = 9)
  int op_slot_right_2839 = gc_frame_newslot(strlit2840);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_2842 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit2844 == NULL) {
    strlit2844 = alloc_String("");
    gc_root(strlit2844);
  }
// compiled string node returning strlit2844 (depth = 10)
  int op_slot_left_2842 = gc_frame_newslot(strlit2844);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2845 = callmethod(strlit2844, "++(1)", 1, partcv, params);
// compiled op node returning opresult2845 (depth = 9)
  int op_slot_left_2839 = gc_frame_newslot(opresult2845);
  params[0] = strlit2840;
  partcv[0] = 1;
  Object opresult2846 = callmethod(opresult2845, "++(1)", 1, partcv, params);
// compiled op node returning opresult2846 (depth = 8)
  int op_slot_left_2837 = gc_frame_newslot(opresult2846);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2847 = callmethod(opresult2846, "++(1)", 1, partcv, params);
// compiled op node returning opresult2847 (depth = 7)
  int op_slot_left_2834 = gc_frame_newslot(opresult2847);
  params[0] = strlit2835;
  partcv[0] = 1;
  Object opresult2848 = callmethod(opresult2847, "++(1)", 1, partcv, params);
// compiled op node returning opresult2848 (depth = 6)
  int op_slot_left_2830 = gc_frame_newslot(opresult2848);
  params[0] = call2832;
  partcv[0] = 1;
  Object opresult2849 = callmethod(opresult2848, "++(1)", 1, partcv, params);
// compiled op node returning opresult2849 (depth = 5)
  int op_slot_left_2827 = gc_frame_newslot(opresult2849);
  params[0] = strlit2828;
  partcv[0] = 1;
  Object opresult2850 = callmethod(opresult2849, "++(1)", 1, partcv, params);
// compiled op node returning opresult2850 (depth = 4)
  *var_s = opresult2850;
  if (opresult2850 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2854 = gc_frame_new();
// call case 4: self request
  Object call2855 = callmethodflags(self, "rtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2854);
// compiled member node returning call2855 (depth = 5)
  int op_slot_right_2853 = gc_frame_newslot(call2855);
// starting to compile identifier node (depth = 5)
  Object bool2857 = alloc_Boolean(0);
// compiled identifier node returning bool2857 (depth = 5)
  int op_slot_left_2853 = gc_frame_newslot(bool2857);
  params[0] = call2855;
  partcv[0] = 1;
  Object opresult2858 = callmethod(bool2857, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2858 (depth = 4)
  Object if2852 = done;
  if (istrue(opresult2858)) {
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2860 == NULL) {
    strlit2860 = alloc_String("");
    gc_root(strlit2860);
  }
// compiled string node returning strlit2860 (depth = 6)
  int op_slot_right_2859 = gc_frame_newslot(strlit2860);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2863 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2865 = alloc_Float64(2);
// compiled num node returning num2865 (depth = 9)
  int op_slot_right_2864 = gc_frame_newslot(num2865);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2864 = gc_frame_newslot(*var_depth);
  params[0] = num2865;
  partcv[0] = 1;
  Object sum2867 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2867 (depth = 8)
  gc_frame_newslot(sum2867);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2868 = gc_frame_new();
// call case 4: self request
  Object call2869 = callmethodflags(self, "rtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2868);
// compiled member node returning call2869 (depth = 8)
  params[0] = sum2867;
  partcv[0] = 1;
  Object call2870 = callmethodflags(call2869, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2863);
// compiled call node returning call2870 (depth = 7)
  int op_slot_right_2862 = gc_frame_newslot(call2870);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2873 == NULL) {
    strlit2873 = alloc_String("");
    gc_root(strlit2873);
  }
// compiled string node returning strlit2873 (depth = 8)
  int op_slot_right_2872 = gc_frame_newslot(strlit2873);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_2875 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2878 == NULL) {
    strlit2878 = alloc_String("Returns:""\x0a""  ");
    gc_root(strlit2878);
  }
// compiled string node returning strlit2878 (depth = 10)
  int op_slot_right_2877 = gc_frame_newslot(strlit2878);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2880 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2883 == NULL) {
    strlit2883 = alloc_String("");
    gc_root(strlit2883);
  }
// compiled string node returning strlit2883 (depth = 12)
  int op_slot_right_2882 = gc_frame_newslot(strlit2883);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_2885 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit2887 == NULL) {
    strlit2887 = alloc_String("");
    gc_root(strlit2887);
  }
// compiled string node returning strlit2887 (depth = 13)
  int op_slot_left_2885 = gc_frame_newslot(strlit2887);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2888 = callmethod(strlit2887, "++(1)", 1, partcv, params);
// compiled op node returning opresult2888 (depth = 12)
  int op_slot_left_2882 = gc_frame_newslot(opresult2888);
  params[0] = strlit2883;
  partcv[0] = 1;
  Object opresult2889 = callmethod(opresult2888, "++(1)", 1, partcv, params);
// compiled op node returning opresult2889 (depth = 11)
  int op_slot_left_2880 = gc_frame_newslot(opresult2889);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2890 = callmethod(opresult2889, "++(1)", 1, partcv, params);
// compiled op node returning opresult2890 (depth = 10)
  int op_slot_left_2877 = gc_frame_newslot(opresult2890);
  params[0] = strlit2878;
  partcv[0] = 1;
  Object opresult2891 = callmethod(opresult2890, "++(1)", 1, partcv, params);
// compiled op node returning opresult2891 (depth = 9)
  int op_slot_left_2875 = gc_frame_newslot(opresult2891);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2892 = callmethod(opresult2891, "++(1)", 1, partcv, params);
// compiled op node returning opresult2892 (depth = 8)
  int op_slot_left_2872 = gc_frame_newslot(opresult2892);
  params[0] = strlit2873;
  partcv[0] = 1;
  Object opresult2893 = callmethod(opresult2892, "++(1)", 1, partcv, params);
// compiled op node returning opresult2893 (depth = 7)
  int op_slot_left_2862 = gc_frame_newslot(opresult2893);
  params[0] = call2870;
  partcv[0] = 1;
  Object opresult2894 = callmethod(opresult2893, "++(1)", 1, partcv, params);
// compiled op node returning opresult2894 (depth = 6)
  int op_slot_left_2859 = gc_frame_newslot(opresult2894);
  params[0] = strlit2860;
  partcv[0] = 1;
  Object opresult2895 = callmethod(opresult2894, "++(1)", 1, partcv, params);
// compiled op node returning opresult2895 (depth = 5)
  *var_s = opresult2895;
  if (opresult2895 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2852 = done;
  } else {
  }
// compiled if node returning if2852 (depth = 3)
// Begin line 642
  setline(642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2899 = gc_frame_new();
// call case 4: self request
  Object call2900 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2899);
// compiled member node returning call2900 (depth = 5)
  int op_slot_right_2898 = gc_frame_newslot(call2900);
// starting to compile identifier node (depth = 5)
  Object bool2902 = alloc_Boolean(0);
// compiled identifier node returning bool2902 (depth = 5)
  int op_slot_left_2898 = gc_frame_newslot(bool2902);
  params[0] = call2900;
  partcv[0] = 1;
  Object opresult2903 = callmethod(bool2902, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2903 (depth = 4)
  Object if2897 = done;
  if (istrue(opresult2903)) {
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2905 == NULL) {
    strlit2905 = alloc_String("TypeParams:""\x0a""");
    gc_root(strlit2905);
  }
// compiled string node returning strlit2905 (depth = 6)
  int op_slot_right_2904 = gc_frame_newslot(strlit2905);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_2907 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2910 == NULL) {
    strlit2910 = alloc_String("""\x0a""");
    gc_root(strlit2910);
  }
// compiled string node returning strlit2910 (depth = 8)
  int op_slot_right_2909 = gc_frame_newslot(strlit2910);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_2912 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit2914 == NULL) {
    strlit2914 = alloc_String("");
    gc_root(strlit2914);
  }
// compiled string node returning strlit2914 (depth = 9)
  int op_slot_left_2912 = gc_frame_newslot(strlit2914);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2915 = callmethod(strlit2914, "++(1)", 1, partcv, params);
// compiled op node returning opresult2915 (depth = 8)
  int op_slot_left_2909 = gc_frame_newslot(opresult2915);
  params[0] = strlit2910;
  partcv[0] = 1;
  Object opresult2916 = callmethod(opresult2915, "++(1)", 1, partcv, params);
// compiled op node returning opresult2916 (depth = 7)
  int op_slot_left_2907 = gc_frame_newslot(opresult2916);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2917 = callmethod(opresult2916, "++(1)", 1, partcv, params);
// compiled op node returning opresult2917 (depth = 6)
  int op_slot_left_2904 = gc_frame_newslot(opresult2917);
  params[0] = strlit2905;
  partcv[0] = 1;
  Object opresult2918 = callmethod(opresult2917, "++(1)", 1, partcv, params);
// compiled op node returning opresult2918 (depth = 5)
  *var_s = opresult2918;
  if (opresult2918 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 644
  setline(644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2921 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2923 = alloc_Float64(2);
// compiled num node returning num2923 (depth = 8)
  int op_slot_right_2922 = gc_frame_newslot(num2923);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2922 = gc_frame_newslot(*var_depth);
  params[0] = num2923;
  partcv[0] = 1;
  Object sum2925 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2925 (depth = 7)
  gc_frame_newslot(sum2925);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2926 = gc_frame_new();
// call case 4: self request
  Object call2927 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2926);
// compiled member node returning call2927 (depth = 7)
  params[0] = sum2925;
  partcv[0] = 1;
  Object call2928 = callmethodflags(call2927, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2921);
// compiled call node returning call2928 (depth = 6)
  int op_slot_right_2920 = gc_frame_newslot(call2928);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2920 = gc_frame_newslot(*var_s);
  params[0] = call2928;
  partcv[0] = 1;
  Object opresult2930 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2930 (depth = 5)
  *var_s = opresult2930;
  if (opresult2930 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2897 = done;
  } else {
  }
// compiled if node returning if2897 (depth = 3)
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2933 == NULL) {
    strlit2933 = alloc_String("Signature:");
    gc_root(strlit2933);
  }
// compiled string node returning strlit2933 (depth = 5)
  int op_slot_right_2932 = gc_frame_newslot(strlit2933);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_2935 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2938 == NULL) {
    strlit2938 = alloc_String("""\x0a""");
    gc_root(strlit2938);
  }
// compiled string node returning strlit2938 (depth = 7)
  int op_slot_right_2937 = gc_frame_newslot(strlit2938);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_right_2940 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 8)
  if (strlit2942 == NULL) {
    strlit2942 = alloc_String("");
    gc_root(strlit2942);
  }
// compiled string node returning strlit2942 (depth = 8)
  int op_slot_left_2940 = gc_frame_newslot(strlit2942);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2943 = callmethod(strlit2942, "++(1)", 1, partcv, params);
// compiled op node returning opresult2943 (depth = 7)
  int op_slot_left_2937 = gc_frame_newslot(opresult2943);
  params[0] = strlit2938;
  partcv[0] = 1;
  Object opresult2944 = callmethod(opresult2943, "++(1)", 1, partcv, params);
// compiled op node returning opresult2944 (depth = 6)
  int op_slot_left_2935 = gc_frame_newslot(opresult2944);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2945 = callmethod(opresult2944, "++(1)", 1, partcv, params);
// compiled op node returning opresult2945 (depth = 5)
  int op_slot_left_2932 = gc_frame_newslot(opresult2945);
  params[0] = strlit2933;
  partcv[0] = 1;
  Object opresult2946 = callmethod(opresult2945, "++(1)", 1, partcv, params);
// compiled op node returning opresult2946 (depth = 4)
  *var_s = opresult2946;
  if (opresult2946 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2948 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2949 = gc_frame_new();
// call case 4: self request
  Object call2950 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2949);
// compiled member node returning call2950 (depth = 4)
  gc_frame_newslot(call2950);
// starting to compile block node (depth = 4)
  Object block2951 = alloc_Block(NULL, NULL, "ast", 647);
  gc_frame_newslot(block2951);
// method "_apply(_)"
  block_savedest(block2951);
  Object closure2952 = createclosure(4, "_apply(1)");
  setclosureframe(closure2952, stackframe);
  addtoclosure(closure2952, var_depth);
  addtoclosure(closure2952, var_spc);
  addtoclosure(closure2952, var_s);
  addtoclosure(closure2952, selfslot);
  struct UserObject *uo2952 = (struct UserObject*)block2951;
  uo2952->data[0] = (Object)closure2952;
  Method *meth_meth_ast__apply_40_1_41_2952 = addmethod2pos(block2951, "_apply(1)", &meth_ast__apply_40_1_41_2952, 0);
  int argcv_meth_ast__apply_40_1_41_2952[] = {1};
  meth_meth_ast__apply_40_1_41_2952->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2952);
  meth_meth_ast__apply_40_1_41_2952->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2952->definitionLine = 2981;
// compiled block node returning block2951 (depth = 4)
  gc_frame_newslot(block2951);
// call case 5: prelude request
  params[0] = call2950;
  params[1] = block2951;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2983 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2948);
// compiled call node returning call2983 (depth = 3)
// Begin line 650
  setline(650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_2988(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2990 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2992 = alloc_Float64(1);
// compiled num node returning num2992 (depth = 9)
  int op_slot_right_2991 = gc_frame_newslot(num2992);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2991 = gc_frame_newslot(*var_depth);
  params[0] = num2992;
  partcv[0] = 1;
  Object sum2994 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum2994 (depth = 8)
  gc_frame_newslot(sum2994);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  params[0] = sum2994;
  partcv[0] = 1;
  Object call2995 = callmethodflags(*var_part, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2990);
// compiled call node returning call2995 (depth = 7)
  int op_slot_right_2989 = gc_frame_newslot(call2995);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2989 = gc_frame_newslot(*var_s);
  params[0] = call2995;
  partcv[0] = 1;
  Object opresult2997 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2997 (depth = 6)
  *var_s = opresult2997;
  if (opresult2997 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_2984(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2985 == NULL) {
    strlit2985 = alloc_String("");
    gc_root(strlit2985);
  }
// compiled string node returning strlit2985 (depth = 4)
  *var_s = strlit2985;
  if (strlit2985 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2986 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block2987 = alloc_Block(NULL, NULL, "ast", 654);
  gc_frame_newslot(block2987);
// method "_apply(_)"
  block_savedest(block2987);
  Object closure2988 = createclosure(3, "_apply(1)");
  setclosureframe(closure2988, stackframe);
  addtoclosure(closure2988, var_depth);
  addtoclosure(closure2988, var_s);
  addtoclosure(closure2988, selfslot);
  struct UserObject *uo2988 = (struct UserObject*)block2987;
  uo2988->data[0] = (Object)closure2988;
  Method *meth_meth_ast__apply_40_1_41_2988 = addmethod2pos(block2987, "_apply(1)", &meth_ast__apply_40_1_41_2988, 0);
  int argcv_meth_ast__apply_40_1_41_2988[] = {1};
  meth_meth_ast__apply_40_1_41_2988->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_2988);
  meth_meth_ast__apply_40_1_41_2988->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_2988->definitionLine = 2981;
// compiled block node returning block2987 (depth = 4)
  gc_frame_newslot(block2987);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3000 = gc_frame_new();
// call case 4: self request
  Object call3001 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3000);
// compiled member node returning call3001 (depth = 4)
  params[0] = block2987;
  partcv[0] = 1;
  Object call3002 = callmethodflags(call3001, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2986);
// compiled call node returning call3002 (depth = 3)
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy3003(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_methodTypeNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3004 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe3005 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3006 = gc_frame_new();
// call case 4: self request
  Object call3007 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3006);
// compiled member node returning call3007 (depth = 5)
  gc_frame_newslot(call3007);
// starting to compile member node (depth = 5)
  int callframe3008 = gc_frame_new();
// call case 4: self request
  Object call3009 = callmethodflags(self, "rtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3008);
// compiled member node returning call3009 (depth = 5)
  gc_frame_newslot(call3009);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodTypeNode (depth = 5)
  params[0] = call3007;
  params[1] = call3009;
  partcv[0] = 2;
  Object call3010 = callmethodflags(*var_methodTypeNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3005);
// compiled call node returning call3010 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3011 = callmethodflags(call3010, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3004);
// compiled call node returning call3011 (depth = 3)
  gc_frame_end(frame);
  return call3011;
}
Object meth_ast_new_40_2_41_2641(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_k = getfromclosure(closure, 2);
  Object *var_methodTypeNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_signature_39_ = &(stackframe->slots[0]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_rtype_39_ = &(stackframe->slots[1]);
  *var_rtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2642 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2642 = alloc_userobj2(20,17, objclass2642);
  gc_frame_newslot(obj2642);
if (objclass2642 == NULL) {
  glfree(obj2642->class->name);
  obj2642->class->name = "methodTypeNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2642, self, 0);
  addmethodreal(obj2642,"outer", &reader_ast_outer_2643);
  Object oldself2642 = self;
  struct StackFrameObject *oldstackframe2642 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2642);
  gc_frame_newslot((Object)stackframe);
  self = obj2642;
  Object *oldselfslot2642 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2642 = (*(struct UserObject *)self).data[0], lowerouter2642 = thisouter2642;
  if (inheritingObject2642) {
    struct UserObject *inho2642 = (struct UserObject *)inheritingObject2642;
    while (inho2642->super != GraceDefaultObject) inho2642 = (struct UserObject *)inho2642->super;
    inho2642->super = obj2642;
    self = inheritingObject2642;
    *selfslot = self;
    lowerouter2642 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2642;
  }
if (objclass2642 == NULL) {
  Method *reader2644 = addmethodrealflags(obj2642, "kind",&reader_ast_kind_2644, MFLAG_DEF);
  reader2644->definitionModule = modulename;
  reader2644->definitionLine = 578;
}
adddatum2(obj2642, alloc_Undefined(), 1);
if (objclass2642 == NULL) {
  Method *reader2645 = addmethodrealflags(obj2642, "signature", &reader_ast_signature_2645, 0);
  Method *writer2645 = addmethodrealflags(obj2642, "signature:=(1)", &writer_ast_signature_2645, 0);
  reader2645->definitionModule = modulename;
  writer2645->definitionModule = modulename;
  reader2645->definitionLine = 579;
  writer2645->definitionLine = 579;
}
obj2642->flags |= OFLAG_MUTABLE;
adddatum2(obj2642, alloc_Undefined(), 2);
if (objclass2642 == NULL) {
  Method *reader2646 = addmethodrealflags(obj2642, "rtype", &reader_ast_rtype_2646, 0);
  Method *writer2646 = addmethodrealflags(obj2642, "rtype:=(1)", &writer_ast_rtype_2646, 0);
  reader2646->definitionModule = modulename;
  writer2646->definitionModule = modulename;
  reader2646->definitionLine = 580;
  writer2646->definitionLine = 580;
}
obj2642->flags |= OFLAG_MUTABLE;
adddatum2(obj2642, alloc_Undefined(), 3);
if (objclass2642 == NULL) {
  Method *reader2647 = addmethodrealflags(obj2642, "typeParams", &reader_ast_typeParams_2647, 0);
  Method *writer2647 = addmethodrealflags(obj2642, "typeParams:=(1)", &writer_ast_typeParams_2647, 0);
  reader2647->definitionModule = modulename;
  writer2647->definitionModule = modulename;
  reader2647->definitionLine = 581;
  writer2647->definitionLine = 581;
}
obj2642->flags |= OFLAG_MUTABLE;
adddatum2(obj2642, alloc_Undefined(), 4);
if (objclass2642 == NULL) {
  Method *reader2648 = addmethodrealflags(obj2642, "cachedIdentifier", &reader_ast_cachedIdentifier_2648, MFLAG_CONFIDENTIAL);
  Method *writer2648 = addmethodrealflags(obj2642, "cachedIdentifier:=(1)", &writer_ast_cachedIdentifier_2648, MFLAG_CONFIDENTIAL);
  reader2648->definitionModule = modulename;
  writer2648->definitionModule = modulename;
  reader2648->definitionLine = 582;
  writer2648->definitionLine = 582;
}
obj2642->flags |= OFLAG_MUTABLE;
adddatum2(obj2642, alloc_Undefined(), 5);
// method "nameString"
  struct UserObject *uo2649 = (struct UserObject*)obj2642;
  uo2649->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString2649 = addmethod2pos(obj2642, "nameString", &meth_ast_nameString2649, 6);
  int argcv_meth_ast_nameString2649[] = {0};
  meth_meth_ast_nameString2649->type = alloc_MethodType(1, argcv_meth_ast_nameString2649);
  meth_meth_ast_nameString2649->definitionModule = modulename;
  meth_meth_ast_nameString2649->definitionLine = 584;
// method "value"
  block_savedest(obj2642);
  Object closure2663 = createclosure(2, "value");
  setclosureframe(closure2663, stackframe);
  addtoclosure(closure2663, var_uninitialized);
  addtoclosure(closure2663, var_identifierNode);
  struct UserObject *uo2663 = (struct UserObject*)obj2642;
  uo2663->data[7] = (Object)closure2663;
  Method *meth_meth_ast_value2663 = addmethod2pos(obj2642, "value", &meth_ast_value2663, 7);
  int argcv_meth_ast_value2663[] = {0};
  meth_meth_ast_value2663->type = alloc_MethodType(1, argcv_meth_ast_value2663);
  meth_meth_ast_value2663->definitionModule = modulename;
  meth_meth_ast_value2663->definitionLine = 588;
// method "isExecutable"
  struct UserObject *uo2704 = (struct UserObject*)obj2642;
  uo2704->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable2704 = addmethod2pos(obj2642, "isExecutable", &meth_ast_isExecutable2704, 8);
  int argcv_meth_ast_isExecutable2704[] = {0};
  meth_meth_ast_isExecutable2704->type = alloc_MethodType(1, argcv_meth_ast_isExecutable2704);
  meth_meth_ast_isExecutable2704->definitionModule = modulename;
  meth_meth_ast_isExecutable2704->definitionLine = 597;
// method "parametersDo(_)"
  struct UserObject *uo2706 = (struct UserObject*)obj2642;
  uo2706->data[9] = emptyclosure;
  Method *meth_meth_ast_parametersDo_40_1_41_2706 = addmethod2pos(obj2642, "parametersDo(1)", &meth_ast_parametersDo_40_1_41_2706, 9);
  int argcv_meth_ast_parametersDo_40_1_41_2706[] = {1};
  meth_meth_ast_parametersDo_40_1_41_2706->type = alloc_MethodType(1, argcv_meth_ast_parametersDo_40_1_41_2706);
  meth_meth_ast_parametersDo_40_1_41_2706->definitionModule = modulename;
  meth_meth_ast_parametersDo_40_1_41_2706->definitionLine = 598;
// method "scope:=(_)"
  struct UserObject *uo2723 = (struct UserObject*)obj2642;
  uo2723->data[10] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_2723 = addmethod2pos(obj2642, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_2723, 10);
  int argcv_meth_ast_scope_58__61__40_1_41_2723[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_2723->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_2723);
  meth_meth_ast_scope_58__61__40_1_41_2723->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_2723->definitionLine = 603;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj2642);
  Object closure2728 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure2728, stackframe);
  addtoclosure(closure2728, var_k);
  struct UserObject *uo2728 = (struct UserObject*)obj2642;
  uo2728->data[11] = (Object)closure2728;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_2728 = addmethod2pos(obj2642, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_2728, 11);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_2728[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_2728->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_2728);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_2728->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_2728->definitionLine = 609;
// method "accept(_)from(_)"
  struct UserObject *uo2731 = (struct UserObject*)obj2642;
  uo2731->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_2731 = addmethod2pos(obj2642, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_2731, 12);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_2731[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_2731->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_2731);
  meth_meth_ast_accept_40_1_41_from_40_1_41_2731->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_2731->definitionLine = 610;
// method "map(_)ancestors(_)"
  struct UserObject *uo2768 = (struct UserObject*)obj2642;
  uo2768->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_2768 = addmethod2pos(obj2642, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_2768, 13);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2768[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2768->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2768);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2768->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2768->definitionLine = 624;
// method "pretty(_)"
  struct UserObject *uo2805 = (struct UserObject*)obj2642;
  uo2805->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_2805 = addmethod2pos(obj2642, "pretty(1)", &meth_ast_pretty_40_1_41_2805, 14);
  int argcv_meth_ast_pretty_40_1_41_2805[] = {1};
  meth_meth_ast_pretty_40_1_41_2805->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_2805);
  meth_meth_ast_pretty_40_1_41_2805->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_2805->definitionLine = 632;
// method "toGrace(_)"
  struct UserObject *uo2984 = (struct UserObject*)obj2642;
  uo2984->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_2984 = addmethod2pos(obj2642, "toGrace(1)", &meth_ast_toGrace_40_1_41_2984, 15);
  int argcv_meth_ast_toGrace_40_1_41_2984[] = {1};
  meth_meth_ast_toGrace_40_1_41_2984->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_2984);
meth_meth_ast_toGrace_40_1_41_2984->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_2984->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_2984->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_2984->definitionLine = 652;
// method "shallowCopy"
  block_savedest(obj2642);
  Object closure3003 = createclosure(1, "shallowCopy");
  setclosureframe(closure3003, stackframe);
  addtoclosure(closure3003, var_methodTypeNode);
  struct UserObject *uo3003 = (struct UserObject*)obj2642;
  uo3003->data[16] = (Object)closure3003;
  Method *meth_meth_ast_shallowCopy3003 = addmethod2pos(obj2642, "shallowCopy", &meth_ast_shallowCopy3003, 16);
  int argcv_meth_ast_shallowCopy3003[] = {0};
  meth_meth_ast_shallowCopy3003->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3003);
  meth_meth_ast_shallowCopy3003->definitionModule = modulename;
  meth_meth_ast_shallowCopy3003->definitionLine = 657;
  sourceObject = obj2642;
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3012 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3013 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3014 = gc_frame_new();
// call case 3: self.outer request
  Object call3015 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3014);
// compiled member node returning call3015 (depth = 5)
  Object call3016 = callmethodflags(call3015, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3013);
// compiled member node returning call3016 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3017 = callmethodflags(call3016, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3012);
// compiled call node returning call3017 (depth = 3)
  struct UserObject *obj2642_uo = (struct UserObject *)obj2642;
  obj2642_uo->super = call3017;
  sourceObject = obj2642;
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3018 == NULL) {
    strlit3018 = alloc_String("methodtype");
    gc_root(strlit3018);
  }
// compiled string node returning strlit3018 (depth = 3)
  adddatum2(obj2642, strlit3018, 1);
  sourceObject = obj2642;
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj2642, *var_signature_39_, 2);
  sourceObject = obj2642;
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rtype_39_ (depth = 3)
  adddatum2(obj2642, *var_rtype_39_, 3);
  sourceObject = obj2642;
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3019 = alloc_Boolean(0);
// compiled identifier node returning bool3019 (depth = 3)
  adddatum2(obj2642, bool3019, 4);
  sourceObject = obj2642;
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_uninitialized (depth = 3)
  adddatum2(obj2642, *var_uninitialized, 5);
  sourceObject = obj2642;
  sourceObject = obj2642;
  sourceObject = obj2642;
  sourceObject = obj2642;
  sourceObject = obj2642;
  sourceObject = obj2642;
  sourceObject = obj2642;
  sourceObject = obj2642;
  sourceObject = obj2642;
  sourceObject = obj2642;
  sourceObject = obj2642;
  objclass2642 = obj2642->class;
  objclass2642->definitionModule = modulename;
  objclass2642->definitionLine = 572;
  (*(struct UserObject *)self).data[0] = lowerouter2642;
  self = oldself2642;
  selfslot = oldselfslot2642;
  stackframe = oldstackframe2642;
  gc_frame_end(frame);
  return obj2642;
}
Object meth_ast_new_40_2_41_2641_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_k = getfromclosure(closure, 2);
  Object *var_methodTypeNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_signature_39_ = &(stackframe->slots[0]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_rtype_39_ = &(stackframe->slots[1]);
  *var_rtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2642 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2642 = alloc_userobj2(20,17, objclass2642);
  gc_frame_newslot(obj2642);
if (objclass2642 == NULL) {
  glfree(obj2642->class->name);
  obj2642->class->name = "methodTypeNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2642, self, 0);
  addmethodreal(obj2642,"outer", &reader_ast_outer_2643);
  Object oldself2642 = self;
  struct StackFrameObject *oldstackframe2642 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2642);
  gc_frame_newslot((Object)stackframe);
  self = obj2642;
  Object *oldselfslot2642 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2642 = (*(struct UserObject *)self).data[0], lowerouter2642 = thisouter2642;
  if (inheritingObject2642) {
    struct UserObject *inho2642 = (struct UserObject *)inheritingObject2642;
    while (inho2642->super != GraceDefaultObject) inho2642 = (struct UserObject *)inho2642->super;
    inho2642->super = obj2642;
    self = inheritingObject2642;
    *selfslot = self;
    lowerouter2642 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2642;
  }
if (objclass2642 == NULL) {
  Method *reader2644 = addmethodrealflags(obj2642, "kind",&reader_ast_kind_2644, MFLAG_DEF);
  reader2644->definitionModule = modulename;
  reader2644->definitionLine = 578;
}
adddatum2(obj2642, alloc_Undefined(), 1);
if (objclass2642 == NULL) {
  Method *reader2645 = addmethodrealflags(obj2642, "signature", &reader_ast_signature_2645, 0);
  Method *writer2645 = addmethodrealflags(obj2642, "signature:=(1)", &writer_ast_signature_2645, 0);
  reader2645->definitionModule = modulename;
  writer2645->definitionModule = modulename;
  reader2645->definitionLine = 579;
  writer2645->definitionLine = 579;
}
obj2642->flags |= OFLAG_MUTABLE;
adddatum2(obj2642, alloc_Undefined(), 2);
if (objclass2642 == NULL) {
  Method *reader2646 = addmethodrealflags(obj2642, "rtype", &reader_ast_rtype_2646, 0);
  Method *writer2646 = addmethodrealflags(obj2642, "rtype:=(1)", &writer_ast_rtype_2646, 0);
  reader2646->definitionModule = modulename;
  writer2646->definitionModule = modulename;
  reader2646->definitionLine = 580;
  writer2646->definitionLine = 580;
}
obj2642->flags |= OFLAG_MUTABLE;
adddatum2(obj2642, alloc_Undefined(), 3);
if (objclass2642 == NULL) {
  Method *reader2647 = addmethodrealflags(obj2642, "typeParams", &reader_ast_typeParams_2647, 0);
  Method *writer2647 = addmethodrealflags(obj2642, "typeParams:=(1)", &writer_ast_typeParams_2647, 0);
  reader2647->definitionModule = modulename;
  writer2647->definitionModule = modulename;
  reader2647->definitionLine = 581;
  writer2647->definitionLine = 581;
}
obj2642->flags |= OFLAG_MUTABLE;
adddatum2(obj2642, alloc_Undefined(), 4);
if (objclass2642 == NULL) {
  Method *reader2648 = addmethodrealflags(obj2642, "cachedIdentifier", &reader_ast_cachedIdentifier_2648, MFLAG_CONFIDENTIAL);
  Method *writer2648 = addmethodrealflags(obj2642, "cachedIdentifier:=(1)", &writer_ast_cachedIdentifier_2648, MFLAG_CONFIDENTIAL);
  reader2648->definitionModule = modulename;
  writer2648->definitionModule = modulename;
  reader2648->definitionLine = 582;
  writer2648->definitionLine = 582;
}
obj2642->flags |= OFLAG_MUTABLE;
adddatum2(obj2642, alloc_Undefined(), 5);
// method "nameString"
  struct UserObject *uo2649 = (struct UserObject*)obj2642;
  uo2649->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString2649 = addmethod2pos(obj2642, "nameString", &meth_ast_nameString2649, 6);
  int argcv_meth_ast_nameString2649[] = {0};
  meth_meth_ast_nameString2649->type = alloc_MethodType(1, argcv_meth_ast_nameString2649);
  meth_meth_ast_nameString2649->definitionModule = modulename;
  meth_meth_ast_nameString2649->definitionLine = 584;
// method "value"
  block_savedest(obj2642);
  Object closure2663 = createclosure(2, "value");
  setclosureframe(closure2663, stackframe);
  addtoclosure(closure2663, var_uninitialized);
  addtoclosure(closure2663, var_identifierNode);
  struct UserObject *uo2663 = (struct UserObject*)obj2642;
  uo2663->data[7] = (Object)closure2663;
  Method *meth_meth_ast_value2663 = addmethod2pos(obj2642, "value", &meth_ast_value2663, 7);
  int argcv_meth_ast_value2663[] = {0};
  meth_meth_ast_value2663->type = alloc_MethodType(1, argcv_meth_ast_value2663);
  meth_meth_ast_value2663->definitionModule = modulename;
  meth_meth_ast_value2663->definitionLine = 588;
// method "isExecutable"
  struct UserObject *uo2704 = (struct UserObject*)obj2642;
  uo2704->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable2704 = addmethod2pos(obj2642, "isExecutable", &meth_ast_isExecutable2704, 8);
  int argcv_meth_ast_isExecutable2704[] = {0};
  meth_meth_ast_isExecutable2704->type = alloc_MethodType(1, argcv_meth_ast_isExecutable2704);
  meth_meth_ast_isExecutable2704->definitionModule = modulename;
  meth_meth_ast_isExecutable2704->definitionLine = 597;
// method "parametersDo(_)"
  struct UserObject *uo2706 = (struct UserObject*)obj2642;
  uo2706->data[9] = emptyclosure;
  Method *meth_meth_ast_parametersDo_40_1_41_2706 = addmethod2pos(obj2642, "parametersDo(1)", &meth_ast_parametersDo_40_1_41_2706, 9);
  int argcv_meth_ast_parametersDo_40_1_41_2706[] = {1};
  meth_meth_ast_parametersDo_40_1_41_2706->type = alloc_MethodType(1, argcv_meth_ast_parametersDo_40_1_41_2706);
  meth_meth_ast_parametersDo_40_1_41_2706->definitionModule = modulename;
  meth_meth_ast_parametersDo_40_1_41_2706->definitionLine = 598;
// method "scope:=(_)"
  struct UserObject *uo2723 = (struct UserObject*)obj2642;
  uo2723->data[10] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_2723 = addmethod2pos(obj2642, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_2723, 10);
  int argcv_meth_ast_scope_58__61__40_1_41_2723[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_2723->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_2723);
  meth_meth_ast_scope_58__61__40_1_41_2723->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_2723->definitionLine = 603;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj2642);
  Object closure2728 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure2728, stackframe);
  addtoclosure(closure2728, var_k);
  struct UserObject *uo2728 = (struct UserObject*)obj2642;
  uo2728->data[11] = (Object)closure2728;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_2728 = addmethod2pos(obj2642, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_2728, 11);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_2728[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_2728->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_2728);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_2728->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_2728->definitionLine = 609;
// method "accept(_)from(_)"
  struct UserObject *uo2731 = (struct UserObject*)obj2642;
  uo2731->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_2731 = addmethod2pos(obj2642, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_2731, 12);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_2731[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_2731->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_2731);
  meth_meth_ast_accept_40_1_41_from_40_1_41_2731->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_2731->definitionLine = 610;
// method "map(_)ancestors(_)"
  struct UserObject *uo2768 = (struct UserObject*)obj2642;
  uo2768->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_2768 = addmethod2pos(obj2642, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_2768, 13);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2768[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2768->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_2768);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2768->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_2768->definitionLine = 624;
// method "pretty(_)"
  struct UserObject *uo2805 = (struct UserObject*)obj2642;
  uo2805->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_2805 = addmethod2pos(obj2642, "pretty(1)", &meth_ast_pretty_40_1_41_2805, 14);
  int argcv_meth_ast_pretty_40_1_41_2805[] = {1};
  meth_meth_ast_pretty_40_1_41_2805->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_2805);
  meth_meth_ast_pretty_40_1_41_2805->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_2805->definitionLine = 632;
// method "toGrace(_)"
  struct UserObject *uo2984 = (struct UserObject*)obj2642;
  uo2984->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_2984 = addmethod2pos(obj2642, "toGrace(1)", &meth_ast_toGrace_40_1_41_2984, 15);
  int argcv_meth_ast_toGrace_40_1_41_2984[] = {1};
  meth_meth_ast_toGrace_40_1_41_2984->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_2984);
meth_meth_ast_toGrace_40_1_41_2984->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_2984->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_2984->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_2984->definitionLine = 652;
// method "shallowCopy"
  block_savedest(obj2642);
  Object closure3003 = createclosure(1, "shallowCopy");
  setclosureframe(closure3003, stackframe);
  addtoclosure(closure3003, var_methodTypeNode);
  struct UserObject *uo3003 = (struct UserObject*)obj2642;
  uo3003->data[16] = (Object)closure3003;
  Method *meth_meth_ast_shallowCopy3003 = addmethod2pos(obj2642, "shallowCopy", &meth_ast_shallowCopy3003, 16);
  int argcv_meth_ast_shallowCopy3003[] = {0};
  meth_meth_ast_shallowCopy3003->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3003);
  meth_meth_ast_shallowCopy3003->definitionModule = modulename;
  meth_meth_ast_shallowCopy3003->definitionLine = 657;
  sourceObject = obj2642;
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3012 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3013 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3014 = gc_frame_new();
// call case 3: self.outer request
  Object call3015 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3014);
// compiled member node returning call3015 (depth = 5)
  Object call3016 = callmethodflags(call3015, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3013);
// compiled member node returning call3016 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3017 = callmethodflags(call3016, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3012);
// compiled call node returning call3017 (depth = 3)
  struct UserObject *obj2642_uo = (struct UserObject *)obj2642;
  obj2642_uo->super = call3017;
  sourceObject = obj2642;
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3018 == NULL) {
    strlit3018 = alloc_String("methodtype");
    gc_root(strlit3018);
  }
// compiled string node returning strlit3018 (depth = 3)
  adddatum2(obj2642, strlit3018, 1);
  sourceObject = obj2642;
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj2642, *var_signature_39_, 2);
  sourceObject = obj2642;
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rtype_39_ (depth = 3)
  adddatum2(obj2642, *var_rtype_39_, 3);
  sourceObject = obj2642;
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3019 = alloc_Boolean(0);
// compiled identifier node returning bool3019 (depth = 3)
  adddatum2(obj2642, bool3019, 4);
  sourceObject = obj2642;
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_uninitialized (depth = 3)
  adddatum2(obj2642, *var_uninitialized, 5);
  sourceObject = obj2642;
  sourceObject = obj2642;
  sourceObject = obj2642;
  sourceObject = obj2642;
  sourceObject = obj2642;
  sourceObject = obj2642;
  sourceObject = obj2642;
  sourceObject = obj2642;
  sourceObject = obj2642;
  sourceObject = obj2642;
  sourceObject = obj2642;
  objclass2642 = obj2642->class;
  objclass2642->definitionModule = modulename;
  objclass2642->definitionLine = 572;
  (*(struct UserObject *)self).data[0] = lowerouter2642;
  self = oldself2642;
  selfslot = oldselfslot2642;
  stackframe = oldstackframe2642;
  gc_frame_end(frame);
  return obj2642;
}
Object meth_ast_methodTypeNode3021(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodTypeNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_methodTypeNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methodTypeNode (depth = 3)
  gc_frame_end(frame);
  return *var_methodTypeNode;
}
Object meth_ast_name3033(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3034 = gc_frame_new();
// call case 4: self request
  Object call3035 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3034);
// compiled member node returning call3035 (depth = 3)
  gc_frame_end(frame);
  return call3035;
}
Object meth_ast_name_58__61__40_1_41_3036(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method name:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for name:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part name:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3037 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3038 = callmethodflags(self, "value:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3037);
// compiled call node returning call3038 (depth = 3)
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3039 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool3040 = alloc_Boolean(0);
// compiled identifier node returning bool3040 (depth = 4)
  gc_frame_newslot(bool3040);
// call case 4: self request
  params[0] = bool3040;
  partcv[0] = 1;
  Object call3041 = callmethodflags(self, "anonymous:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3039);
// compiled call node returning call3041 (depth = 3)
  gc_frame_end(frame);
  return call3041;
}
Object meth_ast_asString3042(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 678
  setline(678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3044 == NULL) {
    strlit3044 = alloc_String("");
    gc_root(strlit3044);
  }
// compiled string node returning strlit3044 (depth = 4)
  int op_slot_right_3043 = gc_frame_newslot(strlit3044);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3047 = gc_frame_new();
// call case 4: self request
  Object call3048 = callmethodflags(self, "types", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3047);
// compiled member node returning call3048 (depth = 5)
  int op_slot_right_3046 = gc_frame_newslot(call3048);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3051 == NULL) {
    strlit3051 = alloc_String(", types = ");
    gc_root(strlit3051);
  }
// compiled string node returning strlit3051 (depth = 6)
  int op_slot_right_3050 = gc_frame_newslot(strlit3051);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe3054 = gc_frame_new();
// call case 4: self request
  Object call3055 = callmethodflags(self, "methods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3054);
// compiled member node returning call3055 (depth = 7)
  int op_slot_right_3053 = gc_frame_newslot(call3055);
// starting to compile string node (depth = 7)
  if (strlit3057 == NULL) {
    strlit3057 = alloc_String("typeliteral: methods = ");
    gc_root(strlit3057);
  }
// compiled string node returning strlit3057 (depth = 7)
  int op_slot_left_3053 = gc_frame_newslot(strlit3057);
  params[0] = call3055;
  partcv[0] = 1;
  Object opresult3058 = callmethod(strlit3057, "++(1)", 1, partcv, params);
// compiled op node returning opresult3058 (depth = 6)
  int op_slot_left_3050 = gc_frame_newslot(opresult3058);
  params[0] = strlit3051;
  partcv[0] = 1;
  Object opresult3059 = callmethod(opresult3058, "++(1)", 1, partcv, params);
// compiled op node returning opresult3059 (depth = 5)
  int op_slot_left_3046 = gc_frame_newslot(opresult3059);
  params[0] = call3048;
  partcv[0] = 1;
  Object opresult3060 = callmethod(opresult3059, "++(1)", 1, partcv, params);
// compiled op node returning opresult3060 (depth = 4)
  int op_slot_left_3043 = gc_frame_newslot(opresult3060);
  params[0] = strlit3044;
  partcv[0] = 1;
  Object opresult3061 = callmethod(opresult3060, "++(1)", 1, partcv, params);
// compiled op node returning opresult3061 (depth = 3)
  gc_frame_end(frame);
  return opresult3061;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_3062(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3063 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call3064 = callmethodflags(*var_k, "typedec", 0, partcv, params, 0);
  gc_frame_end(callframe3063);
// compiled member node returning call3064 (depth = 3)
  gc_frame_end(frame);
  return call3064;
}
Object meth_ast_isExecutable3065(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 681
  setline(681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3066 = alloc_Boolean(0);
// compiled identifier node returning bool3066 (depth = 3)
  gc_frame_end(frame);
  return bool3066;
}
Object meth_ast__apply_40_1_41_3077(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3078 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3079 = callmethodflags(*var_each, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3078);
// compiled call node returning call3079 (depth = 6)
  gc_frame_end(frame);
  return call3079;
}
Object meth_ast__apply_40_1_41_3086(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3087 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3088 = callmethodflags(*var_each, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3087);
// compiled call node returning call3088 (depth = 6)
  gc_frame_end(frame);
  return call3088;
}
Object meth_ast_accept_40_1_41_from_40_1_41_3067(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 684
  setline(684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3069 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3070 = callmethodflags(*var_visitor, "visitTypeLiteral(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3069);
// compiled call node returning call3070 (depth = 4)
  Object if3068 = done;
  if (istrue(call3070)) {
// Begin line 685
  setline(685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3071 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call3072 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3071);
// compiled call node returning call3072 (depth = 5)
  *var_newChain = call3072;
  if (call3072 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3073 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3074 = gc_frame_new();
// call case 4: self request
  Object call3075 = callmethodflags(self, "methods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3074);
// compiled member node returning call3075 (depth = 5)
  gc_frame_newslot(call3075);
// starting to compile block node (depth = 5)
  Object block3076 = alloc_Block(NULL, NULL, "ast", 686);
  gc_frame_newslot(block3076);
// method "_apply(_)"
  block_savedest(block3076);
  Object closure3077 = createclosure(3, "_apply(1)");
  setclosureframe(closure3077, stackframe);
  addtoclosure(closure3077, var_visitor);
  addtoclosure(closure3077, var_newChain);
  addtoclosure(closure3077, selfslot);
  struct UserObject *uo3077 = (struct UserObject*)block3076;
  uo3077->data[0] = (Object)closure3077;
  Method *meth_meth_ast__apply_40_1_41_3077 = addmethod2pos(block3076, "_apply(1)", &meth_ast__apply_40_1_41_3077, 0);
  int argcv_meth_ast__apply_40_1_41_3077[] = {1};
  meth_meth_ast__apply_40_1_41_3077->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3077);
  meth_meth_ast__apply_40_1_41_3077->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3077->definitionLine = 2981;
// compiled block node returning block3076 (depth = 5)
  gc_frame_newslot(block3076);
// call case 5: prelude request
  params[0] = call3075;
  params[1] = block3076;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3081 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3073);
// compiled call node returning call3081 (depth = 4)
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3082 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3083 = gc_frame_new();
// call case 4: self request
  Object call3084 = callmethodflags(self, "types", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3083);
// compiled member node returning call3084 (depth = 5)
  gc_frame_newslot(call3084);
// starting to compile block node (depth = 5)
  Object block3085 = alloc_Block(NULL, NULL, "ast", 689);
  gc_frame_newslot(block3085);
// method "_apply(_)"
  block_savedest(block3085);
  Object closure3086 = createclosure(3, "_apply(1)");
  setclosureframe(closure3086, stackframe);
  addtoclosure(closure3086, var_visitor);
  addtoclosure(closure3086, var_newChain);
  addtoclosure(closure3086, selfslot);
  struct UserObject *uo3086 = (struct UserObject*)block3085;
  uo3086->data[0] = (Object)closure3086;
  Method *meth_meth_ast__apply_40_1_41_3086 = addmethod2pos(block3085, "_apply(1)", &meth_ast__apply_40_1_41_3086, 0);
  int argcv_meth_ast__apply_40_1_41_3086[] = {1};
  meth_meth_ast__apply_40_1_41_3086->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3086);
  meth_meth_ast__apply_40_1_41_3086->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3086->definitionLine = 2981;
// compiled block node returning block3085 (depth = 5)
  gc_frame_newslot(block3085);
// call case 5: prelude request
  params[0] = call3084;
  params[1] = block3085;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3090 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3082);
// compiled call node returning call3090 (depth = 4)
    gc_frame_newslot(call3090);
    if3068 = call3090;
  } else {
  }
// compiled if node returning if3068 (depth = 3)
  gc_frame_end(frame);
  return if3068;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_3091(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3092 = gc_frame_new();
// call case 4: self request
  Object call3093 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3092);
// compiled member node returning call3093 (depth = 4)
  *var_n = call3093;
  if (call3093 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3094 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3095 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3094);
// compiled call node returning call3095 (depth = 4)
  *var_newChain = call3095;
  if (call3095 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3096 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3097 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3098 = gc_frame_new();
// call case 4: self request
  Object call3099 = callmethodflags(self, "methods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3098);
// compiled member node returning call3099 (depth = 5)
  gc_frame_newslot(call3099);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3100 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3101 = gc_frame_new();
// call case 3: self.outer request
  Object call3102 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3101);
// compiled member node returning call3102 (depth = 6)
  Object call3103 = callmethodflags(call3102, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3100);
// compiled member node returning call3103 (depth = 5)
  params[0] = call3099;
  params[1] = *var_blk;
  params[2] = *var_as;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3104 = callmethodflags(call3103, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3097);
// compiled call node returning call3104 (depth = 4)
  gc_frame_newslot(call3104);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3104;
  partcv[0] = 1;
  Object call3105 = callmethodflags(*var_n, "methods:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3096);
// compiled call node returning call3105 (depth = 3)
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3106 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3107 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3108 = gc_frame_new();
// call case 4: self request
  Object call3109 = callmethodflags(self, "types", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3108);
// compiled member node returning call3109 (depth = 5)
  gc_frame_newslot(call3109);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3110 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3111 = gc_frame_new();
// call case 3: self.outer request
  Object call3112 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3111);
// compiled member node returning call3112 (depth = 6)
  Object call3113 = callmethodflags(call3112, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3110);
// compiled member node returning call3113 (depth = 5)
  params[0] = call3109;
  params[1] = *var_blk;
  params[2] = *var_as;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3114 = callmethodflags(call3113, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3107);
// compiled call node returning call3114 (depth = 4)
  gc_frame_newslot(call3114);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3114;
  partcv[0] = 1;
  Object call3115 = callmethodflags(*var_n, "types:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3106);
// compiled call node returning call3115 (depth = 3)
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3116 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call3117 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3116);
// compiled call node returning call3117 (depth = 3)
  gc_frame_end(frame);
  return call3117;
}
Object meth_ast__apply_40_1_41_3126(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3128 == NULL) {
    strlit3128 = alloc_String("  ");
    gc_root(strlit3128);
  }
// compiled string node returning strlit3128 (depth = 7)
  int op_slot_right_3127 = gc_frame_newslot(strlit3128);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3127 = gc_frame_newslot(*var_spc);
  params[0] = strlit3128;
  partcv[0] = 1;
  Object opresult3130 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult3130 (depth = 6)
  *var_spc = opresult3130;
  if (opresult3130 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_3156(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 709
  setline(709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3158 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3160 = alloc_Float64(2);
// compiled num node returning num3160 (depth = 9)
  int op_slot_right_3159 = gc_frame_newslot(num3160);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3159 = gc_frame_newslot(*var_depth);
  params[0] = num3160;
  partcv[0] = 1;
  Object sum3162 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3162 (depth = 8)
  gc_frame_newslot(sum3162);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3162;
  partcv[0] = 1;
  Object call3163 = callmethodflags(*var_each, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3158);
// compiled call node returning call3163 (depth = 7)
  int op_slot_right_3157 = gc_frame_newslot(call3163);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3165 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3168 == NULL) {
    strlit3168 = alloc_String("""\x0a""  ");
    gc_root(strlit3168);
  }
// compiled string node returning strlit3168 (depth = 9)
  int op_slot_right_3167 = gc_frame_newslot(strlit3168);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_3167 = gc_frame_newslot(*var_s);
  params[0] = strlit3168;
  partcv[0] = 1;
  Object opresult3170 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3170 (depth = 8)
  int op_slot_left_3165 = gc_frame_newslot(opresult3170);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3171 = callmethod(opresult3170, "++(1)", 1, partcv, params);
// compiled op node returning opresult3171 (depth = 7)
  int op_slot_left_3157 = gc_frame_newslot(opresult3171);
  params[0] = call3163;
  partcv[0] = 1;
  Object opresult3172 = callmethod(opresult3171, "++(1)", 1, partcv, params);
// compiled op node returning opresult3172 (depth = 6)
  *var_s = opresult3172;
  if (opresult3172 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_3192(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3194 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3196 = alloc_Float64(2);
// compiled num node returning num3196 (depth = 9)
  int op_slot_right_3195 = gc_frame_newslot(num3196);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3195 = gc_frame_newslot(*var_depth);
  params[0] = num3196;
  partcv[0] = 1;
  Object sum3198 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3198 (depth = 8)
  gc_frame_newslot(sum3198);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3198;
  partcv[0] = 1;
  Object call3199 = callmethodflags(*var_each, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3194);
// compiled call node returning call3199 (depth = 7)
  int op_slot_right_3193 = gc_frame_newslot(call3199);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3201 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3204 == NULL) {
    strlit3204 = alloc_String("""\x0a""  ");
    gc_root(strlit3204);
  }
// compiled string node returning strlit3204 (depth = 9)
  int op_slot_right_3203 = gc_frame_newslot(strlit3204);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_3203 = gc_frame_newslot(*var_s);
  params[0] = strlit3204;
  partcv[0] = 1;
  Object opresult3206 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3206 (depth = 8)
  int op_slot_left_3201 = gc_frame_newslot(opresult3206);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3207 = callmethod(opresult3206, "++(1)", 1, partcv, params);
// compiled op node returning opresult3207 (depth = 7)
  int op_slot_left_3193 = gc_frame_newslot(opresult3207);
  params[0] = call3199;
  partcv[0] = 1;
  Object opresult3208 = callmethod(opresult3207, "++(1)", 1, partcv, params);
// compiled op node returning opresult3208 (depth = 6)
  *var_s = opresult3208;
  if (opresult3208 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_3118(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3119 == NULL) {
    strlit3119 = alloc_String("");
    gc_root(strlit3119);
  }
// compiled string node returning strlit3119 (depth = 4)
  *var_spc = strlit3119;
  if (strlit3119 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3120 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_3121 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num3123 = alloc_Float64(0);
// compiled num node returning num3123 (depth = 5)
  int op_slot_left_3121 = gc_frame_newslot(num3123);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult3124 = callmethod(num3123, "..(1)", 1, partcv, params);
// compiled op node returning opresult3124 (depth = 4)
  gc_frame_newslot(opresult3124);
// starting to compile block node (depth = 4)
  Object block3125 = alloc_Block(NULL, NULL, "ast", 703);
  gc_frame_newslot(block3125);
// method "_apply(_)"
  block_savedest(block3125);
  Object closure3126 = createclosure(2, "_apply(1)");
  setclosureframe(closure3126, stackframe);
  addtoclosure(closure3126, var_spc);
  addtoclosure(closure3126, selfslot);
  struct UserObject *uo3126 = (struct UserObject*)block3125;
  uo3126->data[0] = (Object)closure3126;
  Method *meth_meth_ast__apply_40_1_41_3126 = addmethod2pos(block3125, "_apply(1)", &meth_ast__apply_40_1_41_3126, 0);
  int argcv_meth_ast__apply_40_1_41_3126[] = {1};
  meth_meth_ast__apply_40_1_41_3126->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3126);
  meth_meth_ast__apply_40_1_41_3126->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3126->definitionLine = 2981;
// compiled block node returning block3125 (depth = 4)
  gc_frame_newslot(block3125);
// call case 5: prelude request
  params[0] = opresult3124;
  params[1] = block3125;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3133 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3120);
// compiled call node returning call3133 (depth = 3)
// Begin line 706
  setline(706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3135 == NULL) {
    strlit3135 = alloc_String("""\x0a""");
    gc_root(strlit3135);
  }
// compiled string node returning strlit3135 (depth = 5)
  int op_slot_right_3134 = gc_frame_newslot(strlit3135);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3138 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call3139 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3138);
// compiled call node returning call3139 (depth = 6)
  int op_slot_right_3137 = gc_frame_newslot(call3139);
// starting to compile string node (depth = 6)
  if (strlit3141 == NULL) {
    strlit3141 = alloc_String("");
    gc_root(strlit3141);
  }
// compiled string node returning strlit3141 (depth = 6)
  int op_slot_left_3137 = gc_frame_newslot(strlit3141);
  params[0] = call3139;
  partcv[0] = 1;
  Object opresult3142 = callmethod(strlit3141, "++(1)", 1, partcv, params);
// compiled op node returning opresult3142 (depth = 5)
  int op_slot_left_3134 = gc_frame_newslot(opresult3142);
  params[0] = strlit3135;
  partcv[0] = 1;
  Object opresult3143 = callmethod(opresult3142, "++(1)", 1, partcv, params);
// compiled op node returning opresult3143 (depth = 4)
  *var_s = opresult3143;
  if (opresult3143 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3145 == NULL) {
    strlit3145 = alloc_String("Types:");
    gc_root(strlit3145);
  }
// compiled string node returning strlit3145 (depth = 5)
  int op_slot_right_3144 = gc_frame_newslot(strlit3145);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_3147 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3147 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3149 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3149 (depth = 5)
  int op_slot_left_3144 = gc_frame_newslot(opresult3149);
  params[0] = strlit3145;
  partcv[0] = 1;
  Object opresult3150 = callmethod(opresult3149, "++(1)", 1, partcv, params);
// compiled op node returning opresult3150 (depth = 4)
  *var_s = opresult3150;
  if (opresult3150 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3152 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3153 = gc_frame_new();
// call case 4: self request
  Object call3154 = callmethodflags(self, "types", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3153);
// compiled member node returning call3154 (depth = 4)
  gc_frame_newslot(call3154);
// starting to compile block node (depth = 4)
  Object block3155 = alloc_Block(NULL, NULL, "ast", 708);
  gc_frame_newslot(block3155);
// method "_apply(_)"
  block_savedest(block3155);
  Object closure3156 = createclosure(4, "_apply(1)");
  setclosureframe(closure3156, stackframe);
  addtoclosure(closure3156, var_depth);
  addtoclosure(closure3156, var_spc);
  addtoclosure(closure3156, var_s);
  addtoclosure(closure3156, selfslot);
  struct UserObject *uo3156 = (struct UserObject*)block3155;
  uo3156->data[0] = (Object)closure3156;
  Method *meth_meth_ast__apply_40_1_41_3156 = addmethod2pos(block3155, "_apply(1)", &meth_ast__apply_40_1_41_3156, 0);
  int argcv_meth_ast__apply_40_1_41_3156[] = {1};
  meth_meth_ast__apply_40_1_41_3156->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3156);
  meth_meth_ast__apply_40_1_41_3156->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3156->definitionLine = 2981;
// compiled block node returning block3155 (depth = 4)
  gc_frame_newslot(block3155);
// call case 5: prelude request
  params[0] = call3154;
  params[1] = block3155;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3175 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3152);
// compiled call node returning call3175 (depth = 3)
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3177 == NULL) {
    strlit3177 = alloc_String("Methods:");
    gc_root(strlit3177);
  }
// compiled string node returning strlit3177 (depth = 5)
  int op_slot_right_3176 = gc_frame_newslot(strlit3177);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_3179 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3182 == NULL) {
    strlit3182 = alloc_String("""\x0a""");
    gc_root(strlit3182);
  }
// compiled string node returning strlit3182 (depth = 7)
  int op_slot_right_3181 = gc_frame_newslot(strlit3182);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3181 = gc_frame_newslot(*var_s);
  params[0] = strlit3182;
  partcv[0] = 1;
  Object opresult3184 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3184 (depth = 6)
  int op_slot_left_3179 = gc_frame_newslot(opresult3184);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3185 = callmethod(opresult3184, "++(1)", 1, partcv, params);
// compiled op node returning opresult3185 (depth = 5)
  int op_slot_left_3176 = gc_frame_newslot(opresult3185);
  params[0] = strlit3177;
  partcv[0] = 1;
  Object opresult3186 = callmethod(opresult3185, "++(1)", 1, partcv, params);
// compiled op node returning opresult3186 (depth = 4)
  *var_s = opresult3186;
  if (opresult3186 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3188 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3189 = gc_frame_new();
// call case 4: self request
  Object call3190 = callmethodflags(self, "methods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3189);
// compiled member node returning call3190 (depth = 4)
  gc_frame_newslot(call3190);
// starting to compile block node (depth = 4)
  Object block3191 = alloc_Block(NULL, NULL, "ast", 712);
  gc_frame_newslot(block3191);
// method "_apply(_)"
  block_savedest(block3191);
  Object closure3192 = createclosure(4, "_apply(1)");
  setclosureframe(closure3192, stackframe);
  addtoclosure(closure3192, var_depth);
  addtoclosure(closure3192, var_spc);
  addtoclosure(closure3192, var_s);
  addtoclosure(closure3192, selfslot);
  struct UserObject *uo3192 = (struct UserObject*)block3191;
  uo3192->data[0] = (Object)closure3192;
  Method *meth_meth_ast__apply_40_1_41_3192 = addmethod2pos(block3191, "_apply(1)", &meth_ast__apply_40_1_41_3192, 0);
  int argcv_meth_ast__apply_40_1_41_3192[] = {1};
  meth_meth_ast__apply_40_1_41_3192->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3192);
  meth_meth_ast__apply_40_1_41_3192->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3192->definitionLine = 2981;
// compiled block node returning block3191 (depth = 4)
  gc_frame_newslot(block3191);
// call case 5: prelude request
  params[0] = call3190;
  params[1] = block3191;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3211 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3188);
// compiled call node returning call3211 (depth = 3)
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3213 == NULL) {
    strlit3213 = alloc_String("""\x0a""");
    gc_root(strlit3213);
  }
// compiled string node returning strlit3213 (depth = 5)
  int op_slot_right_3212 = gc_frame_newslot(strlit3213);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3212 = gc_frame_newslot(*var_s);
  params[0] = strlit3213;
  partcv[0] = 1;
  Object opresult3215 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3215 (depth = 4)
  *var_s = opresult3215;
  if (opresult3215 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 716
  setline(716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_3229(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3231 == NULL) {
    strlit3231 = alloc_String("    ");
    gc_root(strlit3231);
  }
// compiled string node returning strlit3231 (depth = 7)
  int op_slot_right_3230 = gc_frame_newslot(strlit3231);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3230 = gc_frame_newslot(*var_spc);
  params[0] = strlit3231;
  partcv[0] = 1;
  Object opresult3233 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult3233 (depth = 6)
  *var_spc = opresult3233;
  if (opresult3233 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_3247(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3249 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3251 = alloc_Float64(1);
// compiled num node returning num3251 (depth = 9)
  int op_slot_right_3250 = gc_frame_newslot(num3251);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3250 = gc_frame_newslot(*var_depth);
  params[0] = num3251;
  partcv[0] = 1;
  Object sum3253 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3253 (depth = 8)
  gc_frame_newslot(sum3253);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3253;
  partcv[0] = 1;
  Object call3254 = callmethodflags(*var_each, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3249);
// compiled call node returning call3254 (depth = 7)
  int op_slot_right_3248 = gc_frame_newslot(call3254);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3257 == NULL) {
    strlit3257 = alloc_String("    ");
    gc_root(strlit3257);
  }
// compiled string node returning strlit3257 (depth = 8)
  int op_slot_right_3256 = gc_frame_newslot(strlit3257);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3259 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3262 == NULL) {
    strlit3262 = alloc_String("""\x0a""");
    gc_root(strlit3262);
  }
// compiled string node returning strlit3262 (depth = 10)
  int op_slot_right_3261 = gc_frame_newslot(strlit3262);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_3261 = gc_frame_newslot(*var_s);
  params[0] = strlit3262;
  partcv[0] = 1;
  Object opresult3264 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3264 (depth = 9)
  int op_slot_left_3259 = gc_frame_newslot(opresult3264);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3265 = callmethod(opresult3264, "++(1)", 1, partcv, params);
// compiled op node returning opresult3265 (depth = 8)
  int op_slot_left_3256 = gc_frame_newslot(opresult3265);
  params[0] = strlit3257;
  partcv[0] = 1;
  Object opresult3266 = callmethod(opresult3265, "++(1)", 1, partcv, params);
// compiled op node returning opresult3266 (depth = 7)
  int op_slot_left_3248 = gc_frame_newslot(opresult3266);
  params[0] = call3254;
  partcv[0] = 1;
  Object opresult3267 = callmethod(opresult3266, "++(1)", 1, partcv, params);
// compiled op node returning opresult3267 (depth = 6)
  *var_s = opresult3267;
  if (opresult3267 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_3275(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3277 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3279 = alloc_Float64(1);
// compiled num node returning num3279 (depth = 9)
  int op_slot_right_3278 = gc_frame_newslot(num3279);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3278 = gc_frame_newslot(*var_depth);
  params[0] = num3279;
  partcv[0] = 1;
  Object sum3281 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3281 (depth = 8)
  gc_frame_newslot(sum3281);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3281;
  partcv[0] = 1;
  Object call3282 = callmethodflags(*var_each, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3277);
// compiled call node returning call3282 (depth = 7)
  int op_slot_right_3276 = gc_frame_newslot(call3282);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3285 == NULL) {
    strlit3285 = alloc_String("    ");
    gc_root(strlit3285);
  }
// compiled string node returning strlit3285 (depth = 8)
  int op_slot_right_3284 = gc_frame_newslot(strlit3285);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3287 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3290 == NULL) {
    strlit3290 = alloc_String("""\x0a""");
    gc_root(strlit3290);
  }
// compiled string node returning strlit3290 (depth = 10)
  int op_slot_right_3289 = gc_frame_newslot(strlit3290);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_3289 = gc_frame_newslot(*var_s);
  params[0] = strlit3290;
  partcv[0] = 1;
  Object opresult3292 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3292 (depth = 9)
  int op_slot_left_3287 = gc_frame_newslot(opresult3292);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3293 = callmethod(opresult3292, "++(1)", 1, partcv, params);
// compiled op node returning opresult3293 (depth = 8)
  int op_slot_left_3284 = gc_frame_newslot(opresult3293);
  params[0] = strlit3285;
  partcv[0] = 1;
  Object opresult3294 = callmethod(opresult3293, "++(1)", 1, partcv, params);
// compiled op node returning opresult3294 (depth = 7)
  int op_slot_left_3276 = gc_frame_newslot(opresult3294);
  params[0] = call3282;
  partcv[0] = 1;
  Object opresult3295 = callmethod(opresult3294, "++(1)", 1, partcv, params);
// compiled op node returning opresult3295 (depth = 6)
  *var_s = opresult3295;
  if (opresult3295 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_3217(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3218 == NULL) {
    strlit3218 = alloc_String("");
    gc_root(strlit3218);
  }
// compiled string node returning strlit3218 (depth = 4)
  *var_spc = strlit3218;
  if (strlit3218 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3219 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3222 = alloc_Float64(1);
// compiled num node returning num3222 (depth = 6)
  int op_slot_right_3221 = gc_frame_newslot(num3222);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_3221 = gc_frame_newslot(*var_depth);
  params[0] = num3222;
  partcv[0] = 1;
  Object diff3224 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff3224 (depth = 5)
  int op_slot_right_3220 = gc_frame_newslot(diff3224);
// starting to compile num node (depth = 5)
  Object num3226 = alloc_Float64(0);
// compiled num node returning num3226 (depth = 5)
  int op_slot_left_3220 = gc_frame_newslot(num3226);
  params[0] = diff3224;
  partcv[0] = 1;
  Object opresult3227 = callmethod(num3226, "..(1)", 1, partcv, params);
// compiled op node returning opresult3227 (depth = 4)
  gc_frame_newslot(opresult3227);
// starting to compile block node (depth = 4)
  Object block3228 = alloc_Block(NULL, NULL, "ast", 720);
  gc_frame_newslot(block3228);
// method "_apply(_)"
  block_savedest(block3228);
  Object closure3229 = createclosure(2, "_apply(1)");
  setclosureframe(closure3229, stackframe);
  addtoclosure(closure3229, var_spc);
  addtoclosure(closure3229, selfslot);
  struct UserObject *uo3229 = (struct UserObject*)block3228;
  uo3229->data[0] = (Object)closure3229;
  Method *meth_meth_ast__apply_40_1_41_3229 = addmethod2pos(block3228, "_apply(1)", &meth_ast__apply_40_1_41_3229, 0);
  int argcv_meth_ast__apply_40_1_41_3229[] = {1};
  meth_meth_ast__apply_40_1_41_3229->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3229);
  meth_meth_ast__apply_40_1_41_3229->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3229->definitionLine = 2981;
// compiled block node returning block3228 (depth = 4)
  gc_frame_newslot(block3228);
// call case 5: prelude request
  params[0] = opresult3227;
  params[1] = block3228;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3236 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3219);
// compiled call node returning call3236 (depth = 3)
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3237 == NULL) {
    strlit3237 = alloc_String("type");
    gc_root(strlit3237);
  }
// compiled string node returning strlit3237 (depth = 4)
  *var_s = strlit3237;
  if (strlit3237 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3239 == NULL) {
    strlit3239 = alloc_String(" = {");
    gc_root(strlit3239);
  }
// compiled string node returning strlit3239 (depth = 5)
  int op_slot_right_3238 = gc_frame_newslot(strlit3239);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3238 = gc_frame_newslot(*var_s);
  params[0] = strlit3239;
  partcv[0] = 1;
  Object opresult3241 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3241 (depth = 4)
  *var_s = opresult3241;
  if (opresult3241 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3243 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3244 = gc_frame_new();
// call case 4: self request
  Object call3245 = callmethodflags(self, "methods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3244);
// compiled member node returning call3245 (depth = 4)
  gc_frame_newslot(call3245);
// starting to compile block node (depth = 4)
  Object block3246 = alloc_Block(NULL, NULL, "ast", 725);
  gc_frame_newslot(block3246);
// method "_apply(_)"
  block_savedest(block3246);
  Object closure3247 = createclosure(4, "_apply(1)");
  setclosureframe(closure3247, stackframe);
  addtoclosure(closure3247, var_depth);
  addtoclosure(closure3247, var_spc);
  addtoclosure(closure3247, var_s);
  addtoclosure(closure3247, selfslot);
  struct UserObject *uo3247 = (struct UserObject*)block3246;
  uo3247->data[0] = (Object)closure3247;
  Method *meth_meth_ast__apply_40_1_41_3247 = addmethod2pos(block3246, "_apply(1)", &meth_ast__apply_40_1_41_3247, 0);
  int argcv_meth_ast__apply_40_1_41_3247[] = {1};
  meth_meth_ast__apply_40_1_41_3247->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3247);
  meth_meth_ast__apply_40_1_41_3247->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3247->definitionLine = 2981;
// compiled block node returning block3246 (depth = 4)
  gc_frame_newslot(block3246);
// call case 5: prelude request
  params[0] = call3245;
  params[1] = block3246;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3270 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3243);
// compiled call node returning call3270 (depth = 3)
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3271 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3272 = gc_frame_new();
// call case 4: self request
  Object call3273 = callmethodflags(self, "types", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3272);
// compiled member node returning call3273 (depth = 4)
  gc_frame_newslot(call3273);
// starting to compile block node (depth = 4)
  Object block3274 = alloc_Block(NULL, NULL, "ast", 728);
  gc_frame_newslot(block3274);
// method "_apply(_)"
  block_savedest(block3274);
  Object closure3275 = createclosure(4, "_apply(1)");
  setclosureframe(closure3275, stackframe);
  addtoclosure(closure3275, var_depth);
  addtoclosure(closure3275, var_spc);
  addtoclosure(closure3275, var_s);
  addtoclosure(closure3275, selfslot);
  struct UserObject *uo3275 = (struct UserObject*)block3274;
  uo3275->data[0] = (Object)closure3275;
  Method *meth_meth_ast__apply_40_1_41_3275 = addmethod2pos(block3274, "_apply(1)", &meth_ast__apply_40_1_41_3275, 0);
  int argcv_meth_ast__apply_40_1_41_3275[] = {1};
  meth_meth_ast__apply_40_1_41_3275->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3275);
  meth_meth_ast__apply_40_1_41_3275->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3275->definitionLine = 2981;
// compiled block node returning block3274 (depth = 4)
  gc_frame_newslot(block3274);
// call case 5: prelude request
  params[0] = call3273;
  params[1] = block3274;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3298 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3271);
// compiled call node returning call3298 (depth = 3)
// Begin line 731
  setline(731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3300 == NULL) {
    strlit3300 = alloc_String("}");
    gc_root(strlit3300);
  }
// compiled string node returning strlit3300 (depth = 4)
  int op_slot_right_3299 = gc_frame_newslot(strlit3300);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_3299 = gc_frame_newslot(*var_s);
  params[0] = strlit3300;
  partcv[0] = 1;
  Object opresult3302 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3302 (depth = 3)
  gc_frame_end(frame);
  return opresult3302;
}
Object meth_ast_shallowCopy3303(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeLiteralNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3304 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe3305 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeLiteralNode (depth = 5)
  params[0] = *var_emptySeq;
  params[1] = *var_emptySeq;
  partcv[0] = 2;
  Object call3306 = callmethodflags(*var_typeLiteralNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3305);
// compiled call node returning call3306 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3307 = callmethodflags(call3306, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3304);
// compiled call node returning call3307 (depth = 3)
  gc_frame_end(frame);
  return call3307;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_3308(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3309 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call3310 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3309);
// compiled call node returning call3310 (depth = 3)
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3311 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3312 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call3313 = callmethodflags(*var_other, "nominal", 0, partcv, params, 0);
  gc_frame_end(callframe3312);
// compiled member node returning call3313 (depth = 4)
  gc_frame_newslot(call3313);
// call case 4: self request
  params[0] = call3313;
  partcv[0] = 1;
  Object call3314 = callmethodflags(self, "nominal:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3311);
// compiled call node returning call3314 (depth = 3)
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3315 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3316 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call3317 = callmethodflags(*var_other, "anonymous", 0, partcv, params, 0);
  gc_frame_end(callframe3316);
// compiled member node returning call3317 (depth = 4)
  gc_frame_newslot(call3317);
// call case 4: self request
  params[0] = call3317;
  partcv[0] = 1;
  Object call3318 = callmethodflags(self, "anonymous:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3315);
// compiled call node returning call3318 (depth = 3)
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3319 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3320 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call3321 = callmethodflags(*var_other, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3320);
// compiled member node returning call3321 (depth = 4)
  gc_frame_newslot(call3321);
// call case 4: self request
  params[0] = call3321;
  partcv[0] = 1;
  Object call3322 = callmethodflags(self, "value:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3319);
// compiled call node returning call3322 (depth = 3)
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new_40_2_41_3024(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_typeLiteralNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_methods_39_ = &(stackframe->slots[0]);
  *var_methods_39_ = args[curarg];
  curarg++;
  Object *var_types_39_ = &(stackframe->slots[1]);
  *var_types_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3025 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3025 = alloc_userobj2(22,18, objclass3025);
  gc_frame_newslot(obj3025);
if (objclass3025 == NULL) {
  glfree(obj3025->class->name);
  obj3025->class->name = "typeLiteralNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3025, self, 0);
  addmethodreal(obj3025,"outer", &reader_ast_outer_3026);
  Object oldself3025 = self;
  struct StackFrameObject *oldstackframe3025 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3025);
  gc_frame_newslot((Object)stackframe);
  self = obj3025;
  Object *oldselfslot3025 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3025 = (*(struct UserObject *)self).data[0], lowerouter3025 = thisouter3025;
  if (inheritingObject3025) {
    struct UserObject *inho3025 = (struct UserObject *)inheritingObject3025;
    while (inho3025->super != GraceDefaultObject) inho3025 = (struct UserObject *)inho3025->super;
    inho3025->super = obj3025;
    self = inheritingObject3025;
    *selfslot = self;
    lowerouter3025 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3025;
  }
if (objclass3025 == NULL) {
  Method *reader3027 = addmethodrealflags(obj3025, "kind",&reader_ast_kind_3027, MFLAG_DEF);
  reader3027->definitionModule = modulename;
  reader3027->definitionLine = 665;
}
adddatum2(obj3025, alloc_Undefined(), 1);
if (objclass3025 == NULL) {
  Method *reader3028 = addmethodrealflags(obj3025, "methods", &reader_ast_methods_3028, 0);
  Method *writer3028 = addmethodrealflags(obj3025, "methods:=(1)", &writer_ast_methods_3028, 0);
  reader3028->definitionModule = modulename;
  writer3028->definitionModule = modulename;
  reader3028->definitionLine = 666;
  writer3028->definitionLine = 666;
}
obj3025->flags |= OFLAG_MUTABLE;
adddatum2(obj3025, alloc_Undefined(), 2);
if (objclass3025 == NULL) {
  Method *reader3029 = addmethodrealflags(obj3025, "types", &reader_ast_types_3029, 0);
  Method *writer3029 = addmethodrealflags(obj3025, "types:=(1)", &writer_ast_types_3029, 0);
  reader3029->definitionModule = modulename;
  writer3029->definitionModule = modulename;
  reader3029->definitionLine = 667;
  writer3029->definitionLine = 667;
}
obj3025->flags |= OFLAG_MUTABLE;
adddatum2(obj3025, alloc_Undefined(), 3);
if (objclass3025 == NULL) {
  Method *reader3030 = addmethodrealflags(obj3025, "nominal", &reader_ast_nominal_3030, 0);
  Method *writer3030 = addmethodrealflags(obj3025, "nominal:=(1)", &writer_ast_nominal_3030, 0);
  reader3030->definitionModule = modulename;
  writer3030->definitionModule = modulename;
  reader3030->definitionLine = 668;
  writer3030->definitionLine = 668;
}
obj3025->flags |= OFLAG_MUTABLE;
adddatum2(obj3025, alloc_Undefined(), 4);
if (objclass3025 == NULL) {
  Method *reader3031 = addmethodrealflags(obj3025, "anonymous", &reader_ast_anonymous_3031, 0);
  Method *writer3031 = addmethodrealflags(obj3025, "anonymous:=(1)", &writer_ast_anonymous_3031, 0);
  reader3031->definitionModule = modulename;
  writer3031->definitionModule = modulename;
  reader3031->definitionLine = 669;
  writer3031->definitionLine = 669;
}
obj3025->flags |= OFLAG_MUTABLE;
adddatum2(obj3025, alloc_Undefined(), 5);
if (objclass3025 == NULL) {
  Method *reader3032 = addmethodrealflags(obj3025, "value", &reader_ast_value_3032, 0);
  Method *writer3032 = addmethodrealflags(obj3025, "value:=(1)", &writer_ast_value_3032, 0);
  reader3032->definitionModule = modulename;
  writer3032->definitionModule = modulename;
  reader3032->definitionLine = 670;
  writer3032->definitionLine = 670;
}
obj3025->flags |= OFLAG_MUTABLE;
adddatum2(obj3025, alloc_Undefined(), 6);
// method "name"
  struct UserObject *uo3033 = (struct UserObject*)obj3025;
  uo3033->data[7] = emptyclosure;
  Method *meth_meth_ast_name3033 = addmethod2pos(obj3025, "name", &meth_ast_name3033, 7);
  int argcv_meth_ast_name3033[] = {0};
  meth_meth_ast_name3033->type = alloc_MethodType(1, argcv_meth_ast_name3033);
  meth_meth_ast_name3033->definitionModule = modulename;
  meth_meth_ast_name3033->definitionLine = 672;
// method "name:=(_)"
  struct UserObject *uo3036 = (struct UserObject*)obj3025;
  uo3036->data[8] = emptyclosure;
  Method *meth_meth_ast_name_58__61__40_1_41_3036 = addmethod2pos(obj3025, "name:=(1)", &meth_ast_name_58__61__40_1_41_3036, 8);
  int argcv_meth_ast_name_58__61__40_1_41_3036[] = {1};
  meth_meth_ast_name_58__61__40_1_41_3036->type = alloc_MethodType(1, argcv_meth_ast_name_58__61__40_1_41_3036);
  meth_meth_ast_name_58__61__40_1_41_3036->definitionModule = modulename;
  meth_meth_ast_name_58__61__40_1_41_3036->definitionLine = 673;
// method "asString"
  struct UserObject *uo3042 = (struct UserObject*)obj3025;
  uo3042->data[9] = emptyclosure;
  Method *meth_meth_ast_asString3042 = addmethod2pos(obj3025, "asString", &meth_ast_asString3042, 9);
  int argcv_meth_ast_asString3042[] = {0};
  meth_meth_ast_asString3042->type = alloc_MethodType(1, argcv_meth_ast_asString3042);
  meth_meth_ast_asString3042->definitionModule = modulename;
  meth_meth_ast_asString3042->definitionLine = 677;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj3025);
  Object closure3062 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure3062, stackframe);
  addtoclosure(closure3062, var_k);
  struct UserObject *uo3062 = (struct UserObject*)obj3025;
  uo3062->data[10] = (Object)closure3062;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_3062 = addmethod2pos(obj3025, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_3062, 10);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_3062[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3062->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_3062);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3062->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3062->definitionLine = 680;
// method "isExecutable"
  struct UserObject *uo3065 = (struct UserObject*)obj3025;
  uo3065->data[11] = emptyclosure;
  Method *meth_meth_ast_isExecutable3065 = addmethod2pos(obj3025, "isExecutable", &meth_ast_isExecutable3065, 11);
  int argcv_meth_ast_isExecutable3065[] = {0};
  meth_meth_ast_isExecutable3065->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3065);
  meth_meth_ast_isExecutable3065->definitionModule = modulename;
  meth_meth_ast_isExecutable3065->definitionLine = 681;
// method "accept(_)from(_)"
  struct UserObject *uo3067 = (struct UserObject*)obj3025;
  uo3067->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_3067 = addmethod2pos(obj3025, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_3067, 12);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_3067[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_3067->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_3067);
  meth_meth_ast_accept_40_1_41_from_40_1_41_3067->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_3067->definitionLine = 683;
// method "map(_)ancestors(_)"
  struct UserObject *uo3091 = (struct UserObject*)obj3025;
  uo3091->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_3091 = addmethod2pos(obj3025, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_3091, 13);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_3091[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3091->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_3091);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3091->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3091->definitionLine = 694;
// method "pretty(_)"
  struct UserObject *uo3118 = (struct UserObject*)obj3025;
  uo3118->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_3118 = addmethod2pos(obj3025, "pretty(1)", &meth_ast_pretty_40_1_41_3118, 14);
  int argcv_meth_ast_pretty_40_1_41_3118[] = {1};
  meth_meth_ast_pretty_40_1_41_3118->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_3118);
  meth_meth_ast_pretty_40_1_41_3118->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_3118->definitionLine = 701;
// method "toGrace(_)"
  struct UserObject *uo3217 = (struct UserObject*)obj3025;
  uo3217->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_3217 = addmethod2pos(obj3025, "toGrace(1)", &meth_ast_toGrace_40_1_41_3217, 15);
  int argcv_meth_ast_toGrace_40_1_41_3217[] = {1};
  meth_meth_ast_toGrace_40_1_41_3217->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_3217);
meth_meth_ast_toGrace_40_1_41_3217->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_3217->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_3217->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_3217->definitionLine = 718;
// method "shallowCopy"
  block_savedest(obj3025);
  Object closure3303 = createclosure(2, "shallowCopy");
  setclosureframe(closure3303, stackframe);
  addtoclosure(closure3303, var_emptySeq);
  addtoclosure(closure3303, var_typeLiteralNode);
  struct UserObject *uo3303 = (struct UserObject*)obj3025;
  uo3303->data[16] = (Object)closure3303;
  Method *meth_meth_ast_shallowCopy3303 = addmethod2pos(obj3025, "shallowCopy", &meth_ast_shallowCopy3303, 16);
  int argcv_meth_ast_shallowCopy3303[] = {0};
  meth_meth_ast_shallowCopy3303->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3303);
  meth_meth_ast_shallowCopy3303->definitionModule = modulename;
  meth_meth_ast_shallowCopy3303->definitionLine = 733;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo3308 = (struct UserObject*)obj3025;
  uo3308->data[17] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_3308 = addmethod2pos(obj3025, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_3308, 17);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_3308[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_3308->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_3308);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_3308->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_3308->definitionLine = 736;
  sourceObject = obj3025;
// Begin line 664
  setline(664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3323 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3324 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3325 = gc_frame_new();
// call case 3: self.outer request
  Object call3326 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3325);
// compiled member node returning call3326 (depth = 5)
  Object call3327 = callmethodflags(call3326, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3324);
// compiled member node returning call3327 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3328 = callmethodflags(call3327, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3323);
// compiled call node returning call3328 (depth = 3)
  struct UserObject *obj3025_uo = (struct UserObject *)obj3025;
  obj3025_uo->super = call3328;
  sourceObject = obj3025;
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3329 == NULL) {
    strlit3329 = alloc_String("typeliteral");
    gc_root(strlit3329);
  }
// compiled string node returning strlit3329 (depth = 3)
  adddatum2(obj3025, strlit3329, 1);
  sourceObject = obj3025;
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methods_39_ (depth = 3)
  adddatum2(obj3025, *var_methods_39_, 2);
  sourceObject = obj3025;
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_types_39_ (depth = 3)
  adddatum2(obj3025, *var_types_39_, 3);
  sourceObject = obj3025;
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3330 = alloc_Boolean(0);
// compiled identifier node returning bool3330 (depth = 3)
  adddatum2(obj3025, bool3330, 4);
  sourceObject = obj3025;
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3331 = alloc_Boolean(1);
// compiled identifier node returning bool3331 (depth = 3)
  adddatum2(obj3025, bool3331, 5);
  sourceObject = obj3025;
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3332 == NULL) {
    strlit3332 = alloc_String("""\xe2""""\x80""""\xb9""anon""\xe2""""\x80""""\xba""");
    gc_root(strlit3332);
  }
// compiled string node returning strlit3332 (depth = 3)
  adddatum2(obj3025, strlit3332, 6);
  sourceObject = obj3025;
  sourceObject = obj3025;
  sourceObject = obj3025;
  sourceObject = obj3025;
  sourceObject = obj3025;
  sourceObject = obj3025;
  sourceObject = obj3025;
  sourceObject = obj3025;
  sourceObject = obj3025;
  sourceObject = obj3025;
  sourceObject = obj3025;
  objclass3025 = obj3025->class;
  objclass3025->definitionModule = modulename;
  objclass3025->definitionLine = 663;
  (*(struct UserObject *)self).data[0] = lowerouter3025;
  self = oldself3025;
  selfslot = oldselfslot3025;
  stackframe = oldstackframe3025;
  gc_frame_end(frame);
  return obj3025;
}
Object meth_ast_new_40_2_41_3024_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_typeLiteralNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_methods_39_ = &(stackframe->slots[0]);
  *var_methods_39_ = args[curarg];
  curarg++;
  Object *var_types_39_ = &(stackframe->slots[1]);
  *var_types_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3025 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3025 = alloc_userobj2(22,18, objclass3025);
  gc_frame_newslot(obj3025);
if (objclass3025 == NULL) {
  glfree(obj3025->class->name);
  obj3025->class->name = "typeLiteralNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3025, self, 0);
  addmethodreal(obj3025,"outer", &reader_ast_outer_3026);
  Object oldself3025 = self;
  struct StackFrameObject *oldstackframe3025 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3025);
  gc_frame_newslot((Object)stackframe);
  self = obj3025;
  Object *oldselfslot3025 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3025 = (*(struct UserObject *)self).data[0], lowerouter3025 = thisouter3025;
  if (inheritingObject3025) {
    struct UserObject *inho3025 = (struct UserObject *)inheritingObject3025;
    while (inho3025->super != GraceDefaultObject) inho3025 = (struct UserObject *)inho3025->super;
    inho3025->super = obj3025;
    self = inheritingObject3025;
    *selfslot = self;
    lowerouter3025 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3025;
  }
if (objclass3025 == NULL) {
  Method *reader3027 = addmethodrealflags(obj3025, "kind",&reader_ast_kind_3027, MFLAG_DEF);
  reader3027->definitionModule = modulename;
  reader3027->definitionLine = 665;
}
adddatum2(obj3025, alloc_Undefined(), 1);
if (objclass3025 == NULL) {
  Method *reader3028 = addmethodrealflags(obj3025, "methods", &reader_ast_methods_3028, 0);
  Method *writer3028 = addmethodrealflags(obj3025, "methods:=(1)", &writer_ast_methods_3028, 0);
  reader3028->definitionModule = modulename;
  writer3028->definitionModule = modulename;
  reader3028->definitionLine = 666;
  writer3028->definitionLine = 666;
}
obj3025->flags |= OFLAG_MUTABLE;
adddatum2(obj3025, alloc_Undefined(), 2);
if (objclass3025 == NULL) {
  Method *reader3029 = addmethodrealflags(obj3025, "types", &reader_ast_types_3029, 0);
  Method *writer3029 = addmethodrealflags(obj3025, "types:=(1)", &writer_ast_types_3029, 0);
  reader3029->definitionModule = modulename;
  writer3029->definitionModule = modulename;
  reader3029->definitionLine = 667;
  writer3029->definitionLine = 667;
}
obj3025->flags |= OFLAG_MUTABLE;
adddatum2(obj3025, alloc_Undefined(), 3);
if (objclass3025 == NULL) {
  Method *reader3030 = addmethodrealflags(obj3025, "nominal", &reader_ast_nominal_3030, 0);
  Method *writer3030 = addmethodrealflags(obj3025, "nominal:=(1)", &writer_ast_nominal_3030, 0);
  reader3030->definitionModule = modulename;
  writer3030->definitionModule = modulename;
  reader3030->definitionLine = 668;
  writer3030->definitionLine = 668;
}
obj3025->flags |= OFLAG_MUTABLE;
adddatum2(obj3025, alloc_Undefined(), 4);
if (objclass3025 == NULL) {
  Method *reader3031 = addmethodrealflags(obj3025, "anonymous", &reader_ast_anonymous_3031, 0);
  Method *writer3031 = addmethodrealflags(obj3025, "anonymous:=(1)", &writer_ast_anonymous_3031, 0);
  reader3031->definitionModule = modulename;
  writer3031->definitionModule = modulename;
  reader3031->definitionLine = 669;
  writer3031->definitionLine = 669;
}
obj3025->flags |= OFLAG_MUTABLE;
adddatum2(obj3025, alloc_Undefined(), 5);
if (objclass3025 == NULL) {
  Method *reader3032 = addmethodrealflags(obj3025, "value", &reader_ast_value_3032, 0);
  Method *writer3032 = addmethodrealflags(obj3025, "value:=(1)", &writer_ast_value_3032, 0);
  reader3032->definitionModule = modulename;
  writer3032->definitionModule = modulename;
  reader3032->definitionLine = 670;
  writer3032->definitionLine = 670;
}
obj3025->flags |= OFLAG_MUTABLE;
adddatum2(obj3025, alloc_Undefined(), 6);
// method "name"
  struct UserObject *uo3033 = (struct UserObject*)obj3025;
  uo3033->data[7] = emptyclosure;
  Method *meth_meth_ast_name3033 = addmethod2pos(obj3025, "name", &meth_ast_name3033, 7);
  int argcv_meth_ast_name3033[] = {0};
  meth_meth_ast_name3033->type = alloc_MethodType(1, argcv_meth_ast_name3033);
  meth_meth_ast_name3033->definitionModule = modulename;
  meth_meth_ast_name3033->definitionLine = 672;
// method "name:=(_)"
  struct UserObject *uo3036 = (struct UserObject*)obj3025;
  uo3036->data[8] = emptyclosure;
  Method *meth_meth_ast_name_58__61__40_1_41_3036 = addmethod2pos(obj3025, "name:=(1)", &meth_ast_name_58__61__40_1_41_3036, 8);
  int argcv_meth_ast_name_58__61__40_1_41_3036[] = {1};
  meth_meth_ast_name_58__61__40_1_41_3036->type = alloc_MethodType(1, argcv_meth_ast_name_58__61__40_1_41_3036);
  meth_meth_ast_name_58__61__40_1_41_3036->definitionModule = modulename;
  meth_meth_ast_name_58__61__40_1_41_3036->definitionLine = 673;
// method "asString"
  struct UserObject *uo3042 = (struct UserObject*)obj3025;
  uo3042->data[9] = emptyclosure;
  Method *meth_meth_ast_asString3042 = addmethod2pos(obj3025, "asString", &meth_ast_asString3042, 9);
  int argcv_meth_ast_asString3042[] = {0};
  meth_meth_ast_asString3042->type = alloc_MethodType(1, argcv_meth_ast_asString3042);
  meth_meth_ast_asString3042->definitionModule = modulename;
  meth_meth_ast_asString3042->definitionLine = 677;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj3025);
  Object closure3062 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure3062, stackframe);
  addtoclosure(closure3062, var_k);
  struct UserObject *uo3062 = (struct UserObject*)obj3025;
  uo3062->data[10] = (Object)closure3062;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_3062 = addmethod2pos(obj3025, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_3062, 10);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_3062[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3062->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_3062);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3062->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3062->definitionLine = 680;
// method "isExecutable"
  struct UserObject *uo3065 = (struct UserObject*)obj3025;
  uo3065->data[11] = emptyclosure;
  Method *meth_meth_ast_isExecutable3065 = addmethod2pos(obj3025, "isExecutable", &meth_ast_isExecutable3065, 11);
  int argcv_meth_ast_isExecutable3065[] = {0};
  meth_meth_ast_isExecutable3065->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3065);
  meth_meth_ast_isExecutable3065->definitionModule = modulename;
  meth_meth_ast_isExecutable3065->definitionLine = 681;
// method "accept(_)from(_)"
  struct UserObject *uo3067 = (struct UserObject*)obj3025;
  uo3067->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_3067 = addmethod2pos(obj3025, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_3067, 12);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_3067[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_3067->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_3067);
  meth_meth_ast_accept_40_1_41_from_40_1_41_3067->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_3067->definitionLine = 683;
// method "map(_)ancestors(_)"
  struct UserObject *uo3091 = (struct UserObject*)obj3025;
  uo3091->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_3091 = addmethod2pos(obj3025, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_3091, 13);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_3091[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3091->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_3091);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3091->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3091->definitionLine = 694;
// method "pretty(_)"
  struct UserObject *uo3118 = (struct UserObject*)obj3025;
  uo3118->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_3118 = addmethod2pos(obj3025, "pretty(1)", &meth_ast_pretty_40_1_41_3118, 14);
  int argcv_meth_ast_pretty_40_1_41_3118[] = {1};
  meth_meth_ast_pretty_40_1_41_3118->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_3118);
  meth_meth_ast_pretty_40_1_41_3118->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_3118->definitionLine = 701;
// method "toGrace(_)"
  struct UserObject *uo3217 = (struct UserObject*)obj3025;
  uo3217->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_3217 = addmethod2pos(obj3025, "toGrace(1)", &meth_ast_toGrace_40_1_41_3217, 15);
  int argcv_meth_ast_toGrace_40_1_41_3217[] = {1};
  meth_meth_ast_toGrace_40_1_41_3217->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_3217);
meth_meth_ast_toGrace_40_1_41_3217->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_3217->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_3217->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_3217->definitionLine = 718;
// method "shallowCopy"
  block_savedest(obj3025);
  Object closure3303 = createclosure(2, "shallowCopy");
  setclosureframe(closure3303, stackframe);
  addtoclosure(closure3303, var_emptySeq);
  addtoclosure(closure3303, var_typeLiteralNode);
  struct UserObject *uo3303 = (struct UserObject*)obj3025;
  uo3303->data[16] = (Object)closure3303;
  Method *meth_meth_ast_shallowCopy3303 = addmethod2pos(obj3025, "shallowCopy", &meth_ast_shallowCopy3303, 16);
  int argcv_meth_ast_shallowCopy3303[] = {0};
  meth_meth_ast_shallowCopy3303->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3303);
  meth_meth_ast_shallowCopy3303->definitionModule = modulename;
  meth_meth_ast_shallowCopy3303->definitionLine = 733;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo3308 = (struct UserObject*)obj3025;
  uo3308->data[17] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_3308 = addmethod2pos(obj3025, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_3308, 17);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_3308[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_3308->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_3308);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_3308->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_3308->definitionLine = 736;
  sourceObject = obj3025;
// Begin line 664
  setline(664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3323 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3324 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3325 = gc_frame_new();
// call case 3: self.outer request
  Object call3326 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3325);
// compiled member node returning call3326 (depth = 5)
  Object call3327 = callmethodflags(call3326, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3324);
// compiled member node returning call3327 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3328 = callmethodflags(call3327, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3323);
// compiled call node returning call3328 (depth = 3)
  struct UserObject *obj3025_uo = (struct UserObject *)obj3025;
  obj3025_uo->super = call3328;
  sourceObject = obj3025;
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3329 == NULL) {
    strlit3329 = alloc_String("typeliteral");
    gc_root(strlit3329);
  }
// compiled string node returning strlit3329 (depth = 3)
  adddatum2(obj3025, strlit3329, 1);
  sourceObject = obj3025;
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methods_39_ (depth = 3)
  adddatum2(obj3025, *var_methods_39_, 2);
  sourceObject = obj3025;
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_types_39_ (depth = 3)
  adddatum2(obj3025, *var_types_39_, 3);
  sourceObject = obj3025;
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3330 = alloc_Boolean(0);
// compiled identifier node returning bool3330 (depth = 3)
  adddatum2(obj3025, bool3330, 4);
  sourceObject = obj3025;
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3331 = alloc_Boolean(1);
// compiled identifier node returning bool3331 (depth = 3)
  adddatum2(obj3025, bool3331, 5);
  sourceObject = obj3025;
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3332 == NULL) {
    strlit3332 = alloc_String("""\xe2""""\x80""""\xb9""anon""\xe2""""\x80""""\xba""");
    gc_root(strlit3332);
  }
// compiled string node returning strlit3332 (depth = 3)
  adddatum2(obj3025, strlit3332, 6);
  sourceObject = obj3025;
  sourceObject = obj3025;
  sourceObject = obj3025;
  sourceObject = obj3025;
  sourceObject = obj3025;
  sourceObject = obj3025;
  sourceObject = obj3025;
  sourceObject = obj3025;
  sourceObject = obj3025;
  sourceObject = obj3025;
  sourceObject = obj3025;
  objclass3025 = obj3025->class;
  objclass3025->definitionModule = modulename;
  objclass3025->definitionLine = 663;
  (*(struct UserObject *)self).data[0] = lowerouter3025;
  self = oldself3025;
  selfslot = oldselfslot3025;
  stackframe = oldstackframe3025;
  gc_frame_end(frame);
  return obj3025;
}
Object meth_ast_typeLiteralNode3334(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeLiteralNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeLiteralNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeLiteralNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeLiteralNode;
}
Object meth_ast_isLegalInTrait3346(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 756
  setline(756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3347 = alloc_Boolean(1);
// compiled identifier node returning bool3347 (depth = 3)
  gc_frame_end(frame);
  return bool3347;
}
Object meth_ast_isTypeDec3348(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTypeDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3349 = alloc_Boolean(1);
// compiled identifier node returning bool3349 (depth = 3)
  gc_frame_end(frame);
  return bool3349;
}
Object meth_ast_scope_58__61__40_1_41_3350(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3351 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call3352 = callmethodflags(self, "symbolTable:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3351);
// compiled call node returning call3352 (depth = 3)
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3353 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3354 = callmethodflags(*var_st, "node:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3353);
// compiled call node returning call3354 (depth = 3)
  gc_frame_end(frame);
  return call3354;
}
Object meth_ast_isExecutable3355(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3356 = alloc_Boolean(1);
// compiled identifier node returning bool3356 (depth = 3)
  gc_frame_end(frame);
  return bool3356;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_3357(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3358 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call3359 = callmethodflags(*var_k, "typeparam", 0, partcv, params, 0);
  gc_frame_end(callframe3358);
// compiled member node returning call3359 (depth = 3)
  gc_frame_end(frame);
  return call3359;
}
Object meth_ast_isConfidential3360(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3363 = alloc_Float64(0);
// compiled num node returning num3363 (depth = 5)
  int op_slot_right_3362 = gc_frame_newslot(num3363);
// starting to compile member node (depth = 5)
  int callframe3365 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3366 = gc_frame_new();
// call case 4: self request
  Object call3367 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3366);
// compiled member node returning call3367 (depth = 6)
  Object call3368 = callmethodflags(call3367, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3365);
// compiled member node returning call3368 (depth = 5)
  int op_slot_left_3362 = gc_frame_newslot(call3368);
  params[0] = num3363;
  partcv[0] = 1;
  Object opresult3369 = callmethod(call3368, "==(1)", 1, partcv, params);
// compiled op node returning opresult3369 (depth = 4)
  Object if3361 = done;
  if (istrue(opresult3369)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool3370 = alloc_Boolean(0);
// compiled identifier node returning bool3370 (depth = 5)
  return bool3370;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if3361 = undefined;
  } else {
  }
// compiled if node returning if3361 (depth = 3)
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3371 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit3372 == NULL) {
    strlit3372 = alloc_String("confidential");
    gc_root(strlit3372);
  }
// compiled string node returning strlit3372 (depth = 4)
  gc_frame_newslot(strlit3372);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3373 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3374 = gc_frame_new();
// call case 3: self.outer request
  Object call3375 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3374);
// compiled member node returning call3375 (depth = 5)
  Object call3376 = callmethodflags(call3375, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3373);
// compiled member node returning call3376 (depth = 4)
  params[0] = self;
  params[1] = strlit3372;
  partcv[0] = 2;
  Object call3377 = callmethodflags(call3376, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3371);
// compiled call node returning call3377 (depth = 3)
  gc_frame_end(frame);
  return call3377;
}
Object meth_ast_isPublic3378(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3379 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3380 = gc_frame_new();
// call case 4: self request
  Object call3381 = callmethodflags(self, "isConfidential", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3380);
// compiled member node returning call3381 (depth = 4)
  Object call3382 = callmethodflags(call3381, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3379);
// compiled member node returning call3382 (depth = 3)
  gc_frame_end(frame);
  return call3382;
}
Object meth_ast_isWritable3383(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 772
  setline(772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3384 = alloc_Boolean(0);
// compiled identifier node returning bool3384 (depth = 3)
  gc_frame_end(frame);
  return bool3384;
}
Object meth_ast_isReadable3385(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3386 = gc_frame_new();
// call case 4: self request
  Object call3387 = callmethodflags(self, "isPublic", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3386);
// compiled member node returning call3387 (depth = 3)
  gc_frame_end(frame);
  return call3387;
}
Object meth_ast__apply_40_1_41_3411(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe3412 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3413 = callmethodflags(*var_each, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3412);
// compiled call node returning call3413 (depth = 6)
  gc_frame_end(frame);
  return call3413;
}
Object meth_ast_accept_40_1_41_from_40_1_41_3388(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3390 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3391 = callmethodflags(*var_visitor, "visitTypeDec(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3390);
// compiled call node returning call3391 (depth = 4)
  Object if3389 = done;
  if (istrue(call3391)) {
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3392 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call3393 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3392);
// compiled call node returning call3393 (depth = 5)
  *var_newChain = call3393;
  if (call3393 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3394 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3395 = gc_frame_new();
// call case 4: self request
  Object call3396 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3395);
// compiled member node returning call3396 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3397 = callmethodflags(call3396, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3394);
// compiled call node returning call3397 (depth = 4)
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3400 = gc_frame_new();
// call case 4: self request
  Object call3401 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3400);
// compiled member node returning call3401 (depth = 6)
  int op_slot_right_3399 = gc_frame_newslot(call3401);
// starting to compile identifier node (depth = 6)
  Object bool3403 = alloc_Boolean(0);
// compiled identifier node returning bool3403 (depth = 6)
  int op_slot_left_3399 = gc_frame_newslot(bool3403);
  params[0] = call3401;
  partcv[0] = 1;
  Object opresult3404 = callmethod(bool3403, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3404 (depth = 5)
  Object if3398 = done;
  if (istrue(opresult3404)) {
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3405 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3406 = gc_frame_new();
// call case 4: self request
  Object call3407 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3406);
// compiled member node returning call3407 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3408 = callmethodflags(call3407, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3405);
// compiled call node returning call3408 (depth = 5)
    gc_frame_newslot(call3408);
    if3398 = call3408;
  } else {
  }
// compiled if node returning if3398 (depth = 4)
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3409 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block3410 = alloc_Block(NULL, NULL, "ast", 782);
  gc_frame_newslot(block3410);
// method "_apply(_)"
  block_savedest(block3410);
  Object closure3411 = createclosure(3, "_apply(1)");
  setclosureframe(closure3411, stackframe);
  addtoclosure(closure3411, var_visitor);
  addtoclosure(closure3411, var_newChain);
  addtoclosure(closure3411, selfslot);
  struct UserObject *uo3411 = (struct UserObject*)block3410;
  uo3411->data[0] = (Object)closure3411;
  Method *meth_meth_ast__apply_40_1_41_3411 = addmethod2pos(block3410, "_apply(1)", &meth_ast__apply_40_1_41_3411, 0);
  int argcv_meth_ast__apply_40_1_41_3411[] = {1};
  meth_meth_ast__apply_40_1_41_3411->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3411);
  meth_meth_ast__apply_40_1_41_3411->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3411->definitionLine = 2981;
// compiled block node returning block3410 (depth = 5)
  gc_frame_newslot(block3410);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3415 = gc_frame_new();
// call case 4: self request
  Object call3416 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3415);
// compiled member node returning call3416 (depth = 5)
  params[0] = block3410;
  partcv[0] = 1;
  Object call3417 = callmethodflags(call3416, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3409);
// compiled call node returning call3417 (depth = 4)
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3418 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3419 = gc_frame_new();
// call case 4: self request
  Object call3420 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3419);
// compiled member node returning call3420 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3421 = callmethodflags(call3420, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3418);
// compiled call node returning call3421 (depth = 4)
    gc_frame_newslot(call3421);
    if3389 = call3421;
  } else {
  }
// compiled if node returning if3389 (depth = 3)
  gc_frame_end(frame);
  return if3389;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_3422(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3423 = gc_frame_new();
// call case 4: self request
  Object call3424 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3423);
// compiled member node returning call3424 (depth = 4)
  *var_n = call3424;
  if (call3424 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3425 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3426 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3425);
// compiled call node returning call3426 (depth = 4)
  *var_newChain = call3426;
  if (call3426 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3427 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3428 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3429 = gc_frame_new();
// call case 4: self request
  Object call3430 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3429);
// compiled member node returning call3430 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3431 = callmethodflags(call3430, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3428);
// compiled call node returning call3431 (depth = 4)
  gc_frame_newslot(call3431);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3431;
  partcv[0] = 1;
  Object call3432 = callmethodflags(*var_n, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3427);
// compiled call node returning call3432 (depth = 3)
// Begin line 790
  setline(790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3433 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3434 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3435 = gc_frame_new();
// call case 4: self request
  Object call3436 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3435);
// compiled member node returning call3436 (depth = 5)
  gc_frame_newslot(call3436);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3437 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3438 = gc_frame_new();
// call case 3: self.outer request
  Object call3439 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3438);
// compiled member node returning call3439 (depth = 6)
  Object call3440 = callmethodflags(call3439, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3437);
// compiled member node returning call3440 (depth = 5)
  params[0] = call3436;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3441 = callmethodflags(call3440, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3434);
// compiled call node returning call3441 (depth = 4)
  gc_frame_newslot(call3441);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3441;
  partcv[0] = 1;
  Object call3442 = callmethodflags(*var_n, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3433);
// compiled call node returning call3442 (depth = 3)
// Begin line 791
  setline(791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3443 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3444 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3445 = gc_frame_new();
// call case 4: self request
  Object call3446 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3445);
// compiled member node returning call3446 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3447 = callmethodflags(call3446, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3444);
// compiled call node returning call3447 (depth = 4)
  gc_frame_newslot(call3447);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3447;
  partcv[0] = 1;
  Object call3448 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3443);
// compiled call node returning call3448 (depth = 3)
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3449 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3450 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3451 = gc_frame_new();
// call case 4: self request
  Object call3452 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3451);
// compiled member node returning call3452 (depth = 5)
  gc_frame_newslot(call3452);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3453 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3454 = gc_frame_new();
// call case 3: self.outer request
  Object call3455 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3454);
// compiled member node returning call3455 (depth = 6)
  Object call3456 = callmethodflags(call3455, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3453);
// compiled member node returning call3456 (depth = 5)
  params[0] = call3452;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3457 = callmethodflags(call3456, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3450);
// compiled call node returning call3457 (depth = 4)
  gc_frame_newslot(call3457);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3457;
  partcv[0] = 1;
  Object call3458 = callmethodflags(*var_n, "annotations:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3449);
// compiled call node returning call3458 (depth = 3)
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3459 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call3460 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3459);
// compiled call node returning call3460 (depth = 3)
  gc_frame_end(frame);
  return call3460;
}
Object meth_ast__apply_40_1_41_3469(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 798
  setline(798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3471 == NULL) {
    strlit3471 = alloc_String("  ");
    gc_root(strlit3471);
  }
// compiled string node returning strlit3471 (depth = 7)
  int op_slot_right_3470 = gc_frame_newslot(strlit3471);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3470 = gc_frame_newslot(*var_spc);
  params[0] = strlit3471;
  partcv[0] = 1;
  Object opresult3473 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult3473 (depth = 6)
  *var_spc = opresult3473;
  if (opresult3473 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_3461(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3462 == NULL) {
    strlit3462 = alloc_String("");
    gc_root(strlit3462);
  }
// compiled string node returning strlit3462 (depth = 4)
  *var_spc = strlit3462;
  if (strlit3462 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3463 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_3464 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num3466 = alloc_Float64(0);
// compiled num node returning num3466 (depth = 5)
  int op_slot_left_3464 = gc_frame_newslot(num3466);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult3467 = callmethod(num3466, "..(1)", 1, partcv, params);
// compiled op node returning opresult3467 (depth = 4)
  gc_frame_newslot(opresult3467);
// starting to compile block node (depth = 4)
  Object block3468 = alloc_Block(NULL, NULL, "ast", 797);
  gc_frame_newslot(block3468);
// method "_apply(_)"
  block_savedest(block3468);
  Object closure3469 = createclosure(2, "_apply(1)");
  setclosureframe(closure3469, stackframe);
  addtoclosure(closure3469, var_spc);
  addtoclosure(closure3469, selfslot);
  struct UserObject *uo3469 = (struct UserObject*)block3468;
  uo3469->data[0] = (Object)closure3469;
  Method *meth_meth_ast__apply_40_1_41_3469 = addmethod2pos(block3468, "_apply(1)", &meth_ast__apply_40_1_41_3469, 0);
  int argcv_meth_ast__apply_40_1_41_3469[] = {1};
  meth_meth_ast__apply_40_1_41_3469->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3469);
  meth_meth_ast__apply_40_1_41_3469->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3469->definitionLine = 2981;
// compiled block node returning block3468 (depth = 4)
  gc_frame_newslot(block3468);
// call case 5: prelude request
  params[0] = opresult3467;
  params[1] = block3468;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3476 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3463);
// compiled call node returning call3476 (depth = 3)
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3478 == NULL) {
    strlit3478 = alloc_String("""\x0a""");
    gc_root(strlit3478);
  }
// compiled string node returning strlit3478 (depth = 5)
  int op_slot_right_3477 = gc_frame_newslot(strlit3478);
// starting to compile call node (depth = 5)
  int callframe3480 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call3481 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3480);
// compiled call node returning call3481 (depth = 5)
  int op_slot_left_3477 = gc_frame_newslot(call3481);
  params[0] = strlit3478;
  partcv[0] = 1;
  Object opresult3482 = callmethod(call3481, "++(1)", 1, partcv, params);
// compiled op node returning opresult3482 (depth = 4)
  *var_s = opresult3482;
  if (opresult3482 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3484 == NULL) {
    strlit3484 = alloc_String("""\x0a""");
    gc_root(strlit3484);
  }
// compiled string node returning strlit3484 (depth = 5)
  int op_slot_right_3483 = gc_frame_newslot(strlit3484);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3487 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3489 = alloc_Float64(1);
// compiled num node returning num3489 (depth = 8)
  int op_slot_right_3488 = gc_frame_newslot(num3489);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_3488 = gc_frame_newslot(*var_depth);
  params[0] = num3489;
  partcv[0] = 1;
  Object sum3491 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3491 (depth = 7)
  gc_frame_newslot(sum3491);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3492 = gc_frame_new();
// call case 4: self request
  Object call3493 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3492);
// compiled member node returning call3493 (depth = 7)
  params[0] = sum3491;
  partcv[0] = 1;
  Object call3494 = callmethodflags(call3493, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3487);
// compiled call node returning call3494 (depth = 6)
  int op_slot_right_3486 = gc_frame_newslot(call3494);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3496 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3496 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3498 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3498 (depth = 6)
  int op_slot_left_3486 = gc_frame_newslot(opresult3498);
  params[0] = call3494;
  partcv[0] = 1;
  Object opresult3499 = callmethod(opresult3498, "++(1)", 1, partcv, params);
// compiled op node returning opresult3499 (depth = 5)
  int op_slot_left_3483 = gc_frame_newslot(opresult3499);
  params[0] = strlit3484;
  partcv[0] = 1;
  Object opresult3500 = callmethod(opresult3499, "++(1)", 1, partcv, params);
// compiled op node returning opresult3500 (depth = 4)
  *var_s = opresult3500;
  if (opresult3500 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3504 = gc_frame_new();
// call case 4: self request
  Object call3505 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3504);
// compiled member node returning call3505 (depth = 5)
  int op_slot_right_3503 = gc_frame_newslot(call3505);
// starting to compile identifier node (depth = 5)
  Object bool3507 = alloc_Boolean(0);
// compiled identifier node returning bool3507 (depth = 5)
  int op_slot_left_3503 = gc_frame_newslot(bool3507);
  params[0] = call3505;
  partcv[0] = 1;
  Object opresult3508 = callmethod(bool3507, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3508 (depth = 4)
  Object if3502 = done;
  if (istrue(opresult3508)) {
// Begin line 803
  setline(803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3510 == NULL) {
    strlit3510 = alloc_String("""\x0a""");
    gc_root(strlit3510);
  }
// compiled string node returning strlit3510 (depth = 6)
  int op_slot_right_3509 = gc_frame_newslot(strlit3510);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3513 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3515 = alloc_Float64(2);
// compiled num node returning num3515 (depth = 9)
  int op_slot_right_3514 = gc_frame_newslot(num3515);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3514 = gc_frame_newslot(*var_depth);
  params[0] = num3515;
  partcv[0] = 1;
  Object sum3517 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3517 (depth = 8)
  gc_frame_newslot(sum3517);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3518 = gc_frame_new();
// call case 4: self request
  Object call3519 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3518);
// compiled member node returning call3519 (depth = 8)
  params[0] = sum3517;
  partcv[0] = 1;
  Object call3520 = callmethodflags(call3519, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3513);
// compiled call node returning call3520 (depth = 7)
  int op_slot_right_3512 = gc_frame_newslot(call3520);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3523 == NULL) {
    strlit3523 = alloc_String("Type parameters:""\x0a""");
    gc_root(strlit3523);
  }
// compiled string node returning strlit3523 (depth = 8)
  int op_slot_right_3522 = gc_frame_newslot(strlit3523);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3525 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3528 == NULL) {
    strlit3528 = alloc_String("");
    gc_root(strlit3528);
  }
// compiled string node returning strlit3528 (depth = 10)
  int op_slot_right_3527 = gc_frame_newslot(strlit3528);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_3530 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit3532 == NULL) {
    strlit3532 = alloc_String("");
    gc_root(strlit3532);
  }
// compiled string node returning strlit3532 (depth = 11)
  int op_slot_left_3530 = gc_frame_newslot(strlit3532);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3533 = callmethod(strlit3532, "++(1)", 1, partcv, params);
// compiled op node returning opresult3533 (depth = 10)
  int op_slot_left_3527 = gc_frame_newslot(opresult3533);
  params[0] = strlit3528;
  partcv[0] = 1;
  Object opresult3534 = callmethod(opresult3533, "++(1)", 1, partcv, params);
// compiled op node returning opresult3534 (depth = 9)
  int op_slot_left_3525 = gc_frame_newslot(opresult3534);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3535 = callmethod(opresult3534, "++(1)", 1, partcv, params);
// compiled op node returning opresult3535 (depth = 8)
  int op_slot_left_3522 = gc_frame_newslot(opresult3535);
  params[0] = strlit3523;
  partcv[0] = 1;
  Object opresult3536 = callmethod(opresult3535, "++(1)", 1, partcv, params);
// compiled op node returning opresult3536 (depth = 7)
  int op_slot_left_3512 = gc_frame_newslot(opresult3536);
  params[0] = call3520;
  partcv[0] = 1;
  Object opresult3537 = callmethod(opresult3536, "++(1)", 1, partcv, params);
// compiled op node returning opresult3537 (depth = 6)
  int op_slot_left_3509 = gc_frame_newslot(opresult3537);
  params[0] = strlit3510;
  partcv[0] = 1;
  Object opresult3538 = callmethod(opresult3537, "++(1)", 1, partcv, params);
// compiled op node returning opresult3538 (depth = 5)
  *var_s = opresult3538;
  if (opresult3538 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if3502 = done;
  } else {
  }
// compiled if node returning if3502 (depth = 3)
// Begin line 805
  setline(805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3541 == NULL) {
    strlit3541 = alloc_String("Value:");
    gc_root(strlit3541);
  }
// compiled string node returning strlit3541 (depth = 5)
  int op_slot_right_3540 = gc_frame_newslot(strlit3541);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_3543 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3543 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3545 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3545 (depth = 5)
  int op_slot_left_3540 = gc_frame_newslot(opresult3545);
  params[0] = strlit3541;
  partcv[0] = 1;
  Object opresult3546 = callmethod(opresult3545, "++(1)", 1, partcv, params);
// compiled op node returning opresult3546 (depth = 4)
  *var_s = opresult3546;
  if (opresult3546 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3549 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3551 = alloc_Float64(2);
// compiled num node returning num3551 (depth = 7)
  int op_slot_right_3550 = gc_frame_newslot(num3551);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_3550 = gc_frame_newslot(*var_depth);
  params[0] = num3551;
  partcv[0] = 1;
  Object sum3553 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3553 (depth = 6)
  gc_frame_newslot(sum3553);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3554 = gc_frame_new();
// call case 4: self request
  Object call3555 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3554);
// compiled member node returning call3555 (depth = 6)
  params[0] = sum3553;
  partcv[0] = 1;
  Object call3556 = callmethodflags(call3555, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3549);
// compiled call node returning call3556 (depth = 5)
  int op_slot_right_3548 = gc_frame_newslot(call3556);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3548 = gc_frame_newslot(*var_s);
  params[0] = call3556;
  partcv[0] = 1;
  Object opresult3558 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3558 (depth = 4)
  *var_s = opresult3558;
  if (opresult3558 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 807
  setline(807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3561 == NULL) {
    strlit3561 = alloc_String("""\x0a""");
    gc_root(strlit3561);
  }
// compiled string node returning strlit3561 (depth = 5)
  int op_slot_right_3560 = gc_frame_newslot(strlit3561);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3560 = gc_frame_newslot(*var_s);
  params[0] = strlit3561;
  partcv[0] = 1;
  Object opresult3563 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3563 (depth = 4)
  *var_s = opresult3563;
  if (opresult3563 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3567 = gc_frame_new();
// call case 4: self request
  Object call3568 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3567);
// compiled member node returning call3568 (depth = 5)
  int op_slot_right_3566 = gc_frame_newslot(call3568);
// starting to compile identifier node (depth = 5)
  Object bool3570 = alloc_Boolean(0);
// compiled identifier node returning bool3570 (depth = 5)
  int op_slot_left_3566 = gc_frame_newslot(bool3570);
  params[0] = call3568;
  partcv[0] = 1;
  Object opresult3571 = callmethod(bool3570, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3571 (depth = 4)
  Object if3565 = done;
  if (istrue(opresult3571)) {
// Begin line 809
  setline(809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3573 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3575 = alloc_Float64(2);
// compiled num node returning num3575 (depth = 8)
  int op_slot_right_3574 = gc_frame_newslot(num3575);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_3574 = gc_frame_newslot(*var_depth);
  params[0] = num3575;
  partcv[0] = 1;
  Object sum3577 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3577 (depth = 7)
  gc_frame_newslot(sum3577);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3578 = gc_frame_new();
// call case 4: self request
  Object call3579 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3578);
// compiled member node returning call3579 (depth = 7)
  params[0] = sum3577;
  partcv[0] = 1;
  Object call3580 = callmethodflags(call3579, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3573);
// compiled call node returning call3580 (depth = 6)
  int op_slot_right_3572 = gc_frame_newslot(call3580);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3572 = gc_frame_newslot(*var_s);
  params[0] = call3580;
  partcv[0] = 1;
  Object opresult3582 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3582 (depth = 5)
  *var_s = opresult3582;
  if (opresult3582 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if3565 = done;
  } else {
  }
// compiled if node returning if3565 (depth = 3)
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_3596(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3598 == NULL) {
    strlit3598 = alloc_String("    ");
    gc_root(strlit3598);
  }
// compiled string node returning strlit3598 (depth = 7)
  int op_slot_right_3597 = gc_frame_newslot(strlit3598);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3597 = gc_frame_newslot(*var_spc);
  params[0] = strlit3598;
  partcv[0] = 1;
  Object opresult3600 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult3600 (depth = 6)
  *var_spc = opresult3600;
  if (opresult3600 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_3584(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3585 == NULL) {
    strlit3585 = alloc_String("");
    gc_root(strlit3585);
  }
// compiled string node returning strlit3585 (depth = 4)
  *var_spc = strlit3585;
  if (strlit3585 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3586 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3589 = alloc_Float64(1);
// compiled num node returning num3589 (depth = 6)
  int op_slot_right_3588 = gc_frame_newslot(num3589);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_3588 = gc_frame_newslot(*var_depth);
  params[0] = num3589;
  partcv[0] = 1;
  Object diff3591 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff3591 (depth = 5)
  int op_slot_right_3587 = gc_frame_newslot(diff3591);
// starting to compile num node (depth = 5)
  Object num3593 = alloc_Float64(0);
// compiled num node returning num3593 (depth = 5)
  int op_slot_left_3587 = gc_frame_newslot(num3593);
  params[0] = diff3591;
  partcv[0] = 1;
  Object opresult3594 = callmethod(num3593, "..(1)", 1, partcv, params);
// compiled op node returning opresult3594 (depth = 4)
  gc_frame_newslot(opresult3594);
// starting to compile block node (depth = 4)
  Object block3595 = alloc_Block(NULL, NULL, "ast", 815);
  gc_frame_newslot(block3595);
// method "_apply(_)"
  block_savedest(block3595);
  Object closure3596 = createclosure(2, "_apply(1)");
  setclosureframe(closure3596, stackframe);
  addtoclosure(closure3596, var_spc);
  addtoclosure(closure3596, selfslot);
  struct UserObject *uo3596 = (struct UserObject*)block3595;
  uo3596->data[0] = (Object)closure3596;
  Method *meth_meth_ast__apply_40_1_41_3596 = addmethod2pos(block3595, "_apply(1)", &meth_ast__apply_40_1_41_3596, 0);
  int argcv_meth_ast__apply_40_1_41_3596[] = {1};
  meth_meth_ast__apply_40_1_41_3596->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3596);
  meth_meth_ast__apply_40_1_41_3596->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3596->definitionLine = 2981;
// compiled block node returning block3595 (depth = 4)
  gc_frame_newslot(block3595);
// call case 5: prelude request
  params[0] = opresult3594;
  params[1] = block3595;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3603 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3586);
// compiled call node returning call3603 (depth = 3)
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3604 == NULL) {
    strlit3604 = alloc_String("");
    gc_root(strlit3604);
  }
// compiled string node returning strlit3604 (depth = 4)
  *var_s = strlit3604;
  if (strlit3604 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3606 == NULL) {
    strlit3606 = alloc_String("");
    gc_root(strlit3606);
  }
// compiled string node returning strlit3606 (depth = 5)
  int op_slot_right_3605 = gc_frame_newslot(strlit3606);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3609 = gc_frame_new();
// call case 4: self request
  Object call3610 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3609);
// compiled member node returning call3610 (depth = 6)
  int op_slot_right_3608 = gc_frame_newslot(call3610);
// starting to compile string node (depth = 6)
  if (strlit3612 == NULL) {
    strlit3612 = alloc_String("type ");
    gc_root(strlit3612);
  }
// compiled string node returning strlit3612 (depth = 6)
  int op_slot_left_3608 = gc_frame_newslot(strlit3612);
  params[0] = call3610;
  partcv[0] = 1;
  Object opresult3613 = callmethod(strlit3612, "++(1)", 1, partcv, params);
// compiled op node returning opresult3613 (depth = 5)
  int op_slot_left_3605 = gc_frame_newslot(opresult3613);
  params[0] = strlit3606;
  partcv[0] = 1;
  Object opresult3614 = callmethod(opresult3613, "++(1)", 1, partcv, params);
// compiled op node returning opresult3614 (depth = 4)
  *var_s = opresult3614;
  if (opresult3614 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3618 = gc_frame_new();
// call case 4: self request
  Object call3619 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3618);
// compiled member node returning call3619 (depth = 5)
  int op_slot_right_3617 = gc_frame_newslot(call3619);
// starting to compile identifier node (depth = 5)
  Object bool3621 = alloc_Boolean(0);
// compiled identifier node returning bool3621 (depth = 5)
  int op_slot_left_3617 = gc_frame_newslot(bool3621);
  params[0] = call3619;
  partcv[0] = 1;
  Object opresult3622 = callmethod(bool3621, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3622 (depth = 4)
  Object if3616 = done;
  if (istrue(opresult3622)) {
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3623 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num3624 = alloc_Float64(0);
// compiled num node returning num3624 (depth = 5)
  gc_frame_newslot(num3624);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3625 = gc_frame_new();
// call case 4: self request
  Object call3626 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3625);
// compiled member node returning call3626 (depth = 5)
  params[0] = num3624;
  partcv[0] = 1;
  Object call3627 = callmethodflags(call3626, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3623);
// compiled call node returning call3627 (depth = 4)
    gc_frame_newslot(call3627);
    if3616 = call3627;
  } else {
  }
// compiled if node returning if3616 (depth = 3)
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3629 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3631 = alloc_Float64(2);
// compiled num node returning num3631 (depth = 6)
  int op_slot_right_3630 = gc_frame_newslot(num3631);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_3630 = gc_frame_newslot(*var_depth);
  params[0] = num3631;
  partcv[0] = 1;
  Object sum3633 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum3633 (depth = 5)
  gc_frame_newslot(sum3633);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3634 = gc_frame_new();
// call case 4: self request
  Object call3635 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3634);
// compiled member node returning call3635 (depth = 5)
  params[0] = sum3633;
  partcv[0] = 1;
  Object call3636 = callmethodflags(call3635, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3629);
// compiled call node returning call3636 (depth = 4)
  int op_slot_right_3628 = gc_frame_newslot(call3636);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3639 == NULL) {
    strlit3639 = alloc_String(" = ");
    gc_root(strlit3639);
  }
// compiled string node returning strlit3639 (depth = 5)
  int op_slot_right_3638 = gc_frame_newslot(strlit3639);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3638 = gc_frame_newslot(*var_s);
  params[0] = strlit3639;
  partcv[0] = 1;
  Object opresult3641 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3641 (depth = 4)
  int op_slot_left_3628 = gc_frame_newslot(opresult3641);
  params[0] = call3636;
  partcv[0] = 1;
  Object opresult3642 = callmethod(opresult3641, "++(1)", 1, partcv, params);
// compiled op node returning opresult3642 (depth = 3)
  gc_frame_end(frame);
  return opresult3642;
}
Object meth_ast_shallowCopy3643(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_typeDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3644 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe3645 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3646 = gc_frame_new();
// call case 4: self request
  Object call3647 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3646);
// compiled member node returning call3647 (depth = 5)
  gc_frame_newslot(call3647);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeDecNode (depth = 5)
  params[0] = call3647;
  params[1] = *var_nullNode;
  partcv[0] = 2;
  Object call3648 = callmethodflags(*var_typeDecNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3645);
// compiled call node returning call3648 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3649 = callmethodflags(call3648, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3644);
// compiled call node returning call3649 (depth = 3)
  gc_frame_end(frame);
  return call3649;
}
Object meth_ast_new_40_2_41_3337(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_typeDecNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_typeValue = &(stackframe->slots[1]);
  *var_typeValue = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3338 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3338 = alloc_userobj2(24,21, objclass3338);
  gc_frame_newslot(obj3338);
if (objclass3338 == NULL) {
  glfree(obj3338->class->name);
  obj3338->class->name = "typeDecNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3338, self, 0);
  addmethodreal(obj3338,"outer", &reader_ast_outer_3339);
  Object oldself3338 = self;
  struct StackFrameObject *oldstackframe3338 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3338);
  gc_frame_newslot((Object)stackframe);
  self = obj3338;
  Object *oldselfslot3338 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3338 = (*(struct UserObject *)self).data[0], lowerouter3338 = thisouter3338;
  if (inheritingObject3338) {
    struct UserObject *inho3338 = (struct UserObject *)inheritingObject3338;
    while (inho3338->super != GraceDefaultObject) inho3338 = (struct UserObject *)inho3338->super;
    inho3338->super = obj3338;
    self = inheritingObject3338;
    *selfslot = self;
    lowerouter3338 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3338;
  }
if (objclass3338 == NULL) {
  Method *reader3340 = addmethodrealflags(obj3338, "kind",&reader_ast_kind_3340, MFLAG_DEF);
  reader3340->definitionModule = modulename;
  reader3340->definitionLine = 749;
}
adddatum2(obj3338, alloc_Undefined(), 1);
if (objclass3338 == NULL) {
  Method *reader3341 = addmethodrealflags(obj3338, "name", &reader_ast_name_3341, 0);
  Method *writer3341 = addmethodrealflags(obj3338, "name:=(1)", &writer_ast_name_3341, 0);
  reader3341->definitionModule = modulename;
  writer3341->definitionModule = modulename;
  reader3341->definitionLine = 750;
  writer3341->definitionLine = 750;
}
obj3338->flags |= OFLAG_MUTABLE;
adddatum2(obj3338, alloc_Undefined(), 2);
if (objclass3338 == NULL) {
  Method *reader3342 = addmethodrealflags(obj3338, "value", &reader_ast_value_3342, 0);
  Method *writer3342 = addmethodrealflags(obj3338, "value:=(1)", &writer_ast_value_3342, 0);
  reader3342->definitionModule = modulename;
  writer3342->definitionModule = modulename;
  reader3342->definitionLine = 751;
  writer3342->definitionLine = 751;
}
obj3338->flags |= OFLAG_MUTABLE;
adddatum2(obj3338, alloc_Undefined(), 3);
if (objclass3338 == NULL) {
  Method *reader3343 = addmethodrealflags(obj3338, "nameString",&reader_ast_nameString_3343, MFLAG_DEF);
  reader3343->definitionModule = modulename;
  reader3343->definitionLine = 752;
}
adddatum2(obj3338, alloc_Undefined(), 4);
if (objclass3338 == NULL) {
  Method *reader3344 = addmethodrealflags(obj3338, "annotations", &reader_ast_annotations_3344, 0);
  Method *writer3344 = addmethodrealflags(obj3338, "annotations:=(1)", &writer_ast_annotations_3344, 0);
  reader3344->definitionModule = modulename;
  writer3344->definitionModule = modulename;
  reader3344->definitionLine = 753;
  writer3344->definitionLine = 753;
}
obj3338->flags |= OFLAG_MUTABLE;
adddatum2(obj3338, alloc_Undefined(), 5);
if (objclass3338 == NULL) {
  Method *reader3345 = addmethodrealflags(obj3338, "typeParams", &reader_ast_typeParams_3345, 0);
  Method *writer3345 = addmethodrealflags(obj3338, "typeParams:=(1)", &writer_ast_typeParams_3345, 0);
  reader3345->definitionModule = modulename;
  writer3345->definitionModule = modulename;
  reader3345->definitionLine = 754;
  writer3345->definitionLine = 754;
}
obj3338->flags |= OFLAG_MUTABLE;
adddatum2(obj3338, alloc_Undefined(), 6);
// method "isLegalInTrait"
  struct UserObject *uo3346 = (struct UserObject*)obj3338;
  uo3346->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait3346 = addmethod2pos(obj3338, "isLegalInTrait", &meth_ast_isLegalInTrait3346, 7);
  int argcv_meth_ast_isLegalInTrait3346[] = {0};
  meth_meth_ast_isLegalInTrait3346->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait3346);
  meth_meth_ast_isLegalInTrait3346->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait3346->definitionLine = 756;
// method "isTypeDec"
  struct UserObject *uo3348 = (struct UserObject*)obj3338;
  uo3348->data[8] = emptyclosure;
  Method *meth_meth_ast_isTypeDec3348 = addmethod2pos(obj3338, "isTypeDec", &meth_ast_isTypeDec3348, 8);
  int argcv_meth_ast_isTypeDec3348[] = {0};
  meth_meth_ast_isTypeDec3348->type = alloc_MethodType(1, argcv_meth_ast_isTypeDec3348);
  meth_meth_ast_isTypeDec3348->definitionModule = modulename;
  meth_meth_ast_isTypeDec3348->definitionLine = 757;
// method "scope:=(_)"
  struct UserObject *uo3350 = (struct UserObject*)obj3338;
  uo3350->data[9] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_3350 = addmethod2pos(obj3338, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_3350, 9);
  int argcv_meth_ast_scope_58__61__40_1_41_3350[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_3350->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_3350);
  meth_meth_ast_scope_58__61__40_1_41_3350->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_3350->definitionLine = 758;
// method "isExecutable"
  struct UserObject *uo3355 = (struct UserObject*)obj3338;
  uo3355->data[10] = emptyclosure;
  Method *meth_meth_ast_isExecutable3355 = addmethod2pos(obj3338, "isExecutable", &meth_ast_isExecutable3355, 10);
  int argcv_meth_ast_isExecutable3355[] = {0};
  meth_meth_ast_isExecutable3355->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3355);
  meth_meth_ast_isExecutable3355->definitionModule = modulename;
  meth_meth_ast_isExecutable3355->definitionLine = 765;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj3338);
  Object closure3357 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure3357, stackframe);
  addtoclosure(closure3357, var_k);
  struct UserObject *uo3357 = (struct UserObject*)obj3338;
  uo3357->data[11] = (Object)closure3357;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_3357 = addmethod2pos(obj3338, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_3357, 11);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_3357[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3357->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_3357);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3357->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3357->definitionLine = 766;
// method "isConfidential"
  struct UserObject *uo3360 = (struct UserObject*)obj3338;
  uo3360->data[12] = emptyclosure;
  Method *meth_meth_ast_isConfidential3360 = addmethod2pos(obj3338, "isConfidential", &meth_ast_isConfidential3360, 12);
  int argcv_meth_ast_isConfidential3360[] = {0};
  meth_meth_ast_isConfidential3360->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3360);
  meth_meth_ast_isConfidential3360->definitionModule = modulename;
  meth_meth_ast_isConfidential3360->definitionLine = 767;
// method "isPublic"
  struct UserObject *uo3378 = (struct UserObject*)obj3338;
  uo3378->data[13] = emptyclosure;
  Method *meth_meth_ast_isPublic3378 = addmethod2pos(obj3338, "isPublic", &meth_ast_isPublic3378, 13);
  int argcv_meth_ast_isPublic3378[] = {0};
  meth_meth_ast_isPublic3378->type = alloc_MethodType(1, argcv_meth_ast_isPublic3378);
  meth_meth_ast_isPublic3378->definitionModule = modulename;
  meth_meth_ast_isPublic3378->definitionLine = 771;
// method "isWritable"
  struct UserObject *uo3383 = (struct UserObject*)obj3338;
  uo3383->data[14] = emptyclosure;
  Method *meth_meth_ast_isWritable3383 = addmethod2pos(obj3338, "isWritable", &meth_ast_isWritable3383, 14);
  int argcv_meth_ast_isWritable3383[] = {0};
  meth_meth_ast_isWritable3383->type = alloc_MethodType(1, argcv_meth_ast_isWritable3383);
  meth_meth_ast_isWritable3383->definitionModule = modulename;
  meth_meth_ast_isWritable3383->definitionLine = 772;
// method "isReadable"
  struct UserObject *uo3385 = (struct UserObject*)obj3338;
  uo3385->data[15] = emptyclosure;
  Method *meth_meth_ast_isReadable3385 = addmethod2pos(obj3338, "isReadable", &meth_ast_isReadable3385, 15);
  int argcv_meth_ast_isReadable3385[] = {0};
  meth_meth_ast_isReadable3385->type = alloc_MethodType(1, argcv_meth_ast_isReadable3385);
  meth_meth_ast_isReadable3385->definitionModule = modulename;
  meth_meth_ast_isReadable3385->definitionLine = 773;
// method "accept(_)from(_)"
  struct UserObject *uo3388 = (struct UserObject*)obj3338;
  uo3388->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_3388 = addmethod2pos(obj3338, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_3388, 16);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_3388[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_3388->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_3388);
  meth_meth_ast_accept_40_1_41_from_40_1_41_3388->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_3388->definitionLine = 775;
// method "map(_)ancestors(_)"
  struct UserObject *uo3422 = (struct UserObject*)obj3338;
  uo3422->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_3422 = addmethod2pos(obj3338, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_3422, 17);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_3422[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3422->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_3422);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3422->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3422->definitionLine = 786;
// method "pretty(_)"
  struct UserObject *uo3461 = (struct UserObject*)obj3338;
  uo3461->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_3461 = addmethod2pos(obj3338, "pretty(1)", &meth_ast_pretty_40_1_41_3461, 18);
  int argcv_meth_ast_pretty_40_1_41_3461[] = {1};
  meth_meth_ast_pretty_40_1_41_3461->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_3461);
  meth_meth_ast_pretty_40_1_41_3461->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_3461->definitionLine = 795;
// method "toGrace(_)"
  struct UserObject *uo3584 = (struct UserObject*)obj3338;
  uo3584->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_3584 = addmethod2pos(obj3338, "toGrace(1)", &meth_ast_toGrace_40_1_41_3584, 19);
  int argcv_meth_ast_toGrace_40_1_41_3584[] = {1};
  meth_meth_ast_toGrace_40_1_41_3584->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_3584);
meth_meth_ast_toGrace_40_1_41_3584->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_3584->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_3584->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_3584->definitionLine = 813;
// method "shallowCopy"
  block_savedest(obj3338);
  Object closure3643 = createclosure(2, "shallowCopy");
  setclosureframe(closure3643, stackframe);
  addtoclosure(closure3643, var_nullNode);
  addtoclosure(closure3643, var_typeDecNode);
  struct UserObject *uo3643 = (struct UserObject*)obj3338;
  uo3643->data[20] = (Object)closure3643;
  Method *meth_meth_ast_shallowCopy3643 = addmethod2pos(obj3338, "shallowCopy", &meth_ast_shallowCopy3643, 20);
  int argcv_meth_ast_shallowCopy3643[] = {0};
  meth_meth_ast_shallowCopy3643->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3643);
  meth_meth_ast_shallowCopy3643->definitionModule = modulename;
  meth_meth_ast_shallowCopy3643->definitionLine = 825;
  sourceObject = obj3338;
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3650 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3651 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3652 = gc_frame_new();
// call case 3: self.outer request
  Object call3653 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3652);
// compiled member node returning call3653 (depth = 5)
  Object call3654 = callmethodflags(call3653, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3651);
// compiled member node returning call3654 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3655 = callmethodflags(call3654, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3650);
// compiled call node returning call3655 (depth = 3)
  struct UserObject *obj3338_uo = (struct UserObject *)obj3338;
  obj3338_uo->super = call3655;
  sourceObject = obj3338;
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3656 == NULL) {
    strlit3656 = alloc_String("typedec");
    gc_root(strlit3656);
  }
// compiled string node returning strlit3656 (depth = 3)
  adddatum2(obj3338, strlit3656, 1);
  sourceObject = obj3338;
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj3338, *var_name_39_, 2);
  sourceObject = obj3338;
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeValue (depth = 3)
  adddatum2(obj3338, *var_typeValue, 3);
  sourceObject = obj3338;
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3657 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3658 = gc_frame_new();
// call case 4: self request
  Object call3659 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3658);
// compiled member node returning call3659 (depth = 4)
  Object call3660 = callmethodflags(call3659, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3657);
// compiled member node returning call3660 (depth = 3)
  adddatum2(obj3338, call3660, 4);
  sourceObject = obj3338;
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array3661 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3661 (depth = 3)
  adddatum2(obj3338, array3661, 5);
  sourceObject = obj3338;
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3662 = alloc_Boolean(0);
// compiled identifier node returning bool3662 (depth = 3)
  adddatum2(obj3338, bool3662, 6);
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  objclass3338 = obj3338->class;
  objclass3338->definitionModule = modulename;
  objclass3338->definitionLine = 747;
  (*(struct UserObject *)self).data[0] = lowerouter3338;
  self = oldself3338;
  selfslot = oldselfslot3338;
  stackframe = oldstackframe3338;
  gc_frame_end(frame);
  return obj3338;
}
Object meth_ast_new_40_2_41_3337_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_typeDecNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_typeValue = &(stackframe->slots[1]);
  *var_typeValue = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3338 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3338 = alloc_userobj2(24,21, objclass3338);
  gc_frame_newslot(obj3338);
if (objclass3338 == NULL) {
  glfree(obj3338->class->name);
  obj3338->class->name = "typeDecNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3338, self, 0);
  addmethodreal(obj3338,"outer", &reader_ast_outer_3339);
  Object oldself3338 = self;
  struct StackFrameObject *oldstackframe3338 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3338);
  gc_frame_newslot((Object)stackframe);
  self = obj3338;
  Object *oldselfslot3338 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3338 = (*(struct UserObject *)self).data[0], lowerouter3338 = thisouter3338;
  if (inheritingObject3338) {
    struct UserObject *inho3338 = (struct UserObject *)inheritingObject3338;
    while (inho3338->super != GraceDefaultObject) inho3338 = (struct UserObject *)inho3338->super;
    inho3338->super = obj3338;
    self = inheritingObject3338;
    *selfslot = self;
    lowerouter3338 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3338;
  }
if (objclass3338 == NULL) {
  Method *reader3340 = addmethodrealflags(obj3338, "kind",&reader_ast_kind_3340, MFLAG_DEF);
  reader3340->definitionModule = modulename;
  reader3340->definitionLine = 749;
}
adddatum2(obj3338, alloc_Undefined(), 1);
if (objclass3338 == NULL) {
  Method *reader3341 = addmethodrealflags(obj3338, "name", &reader_ast_name_3341, 0);
  Method *writer3341 = addmethodrealflags(obj3338, "name:=(1)", &writer_ast_name_3341, 0);
  reader3341->definitionModule = modulename;
  writer3341->definitionModule = modulename;
  reader3341->definitionLine = 750;
  writer3341->definitionLine = 750;
}
obj3338->flags |= OFLAG_MUTABLE;
adddatum2(obj3338, alloc_Undefined(), 2);
if (objclass3338 == NULL) {
  Method *reader3342 = addmethodrealflags(obj3338, "value", &reader_ast_value_3342, 0);
  Method *writer3342 = addmethodrealflags(obj3338, "value:=(1)", &writer_ast_value_3342, 0);
  reader3342->definitionModule = modulename;
  writer3342->definitionModule = modulename;
  reader3342->definitionLine = 751;
  writer3342->definitionLine = 751;
}
obj3338->flags |= OFLAG_MUTABLE;
adddatum2(obj3338, alloc_Undefined(), 3);
if (objclass3338 == NULL) {
  Method *reader3343 = addmethodrealflags(obj3338, "nameString",&reader_ast_nameString_3343, MFLAG_DEF);
  reader3343->definitionModule = modulename;
  reader3343->definitionLine = 752;
}
adddatum2(obj3338, alloc_Undefined(), 4);
if (objclass3338 == NULL) {
  Method *reader3344 = addmethodrealflags(obj3338, "annotations", &reader_ast_annotations_3344, 0);
  Method *writer3344 = addmethodrealflags(obj3338, "annotations:=(1)", &writer_ast_annotations_3344, 0);
  reader3344->definitionModule = modulename;
  writer3344->definitionModule = modulename;
  reader3344->definitionLine = 753;
  writer3344->definitionLine = 753;
}
obj3338->flags |= OFLAG_MUTABLE;
adddatum2(obj3338, alloc_Undefined(), 5);
if (objclass3338 == NULL) {
  Method *reader3345 = addmethodrealflags(obj3338, "typeParams", &reader_ast_typeParams_3345, 0);
  Method *writer3345 = addmethodrealflags(obj3338, "typeParams:=(1)", &writer_ast_typeParams_3345, 0);
  reader3345->definitionModule = modulename;
  writer3345->definitionModule = modulename;
  reader3345->definitionLine = 754;
  writer3345->definitionLine = 754;
}
obj3338->flags |= OFLAG_MUTABLE;
adddatum2(obj3338, alloc_Undefined(), 6);
// method "isLegalInTrait"
  struct UserObject *uo3346 = (struct UserObject*)obj3338;
  uo3346->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait3346 = addmethod2pos(obj3338, "isLegalInTrait", &meth_ast_isLegalInTrait3346, 7);
  int argcv_meth_ast_isLegalInTrait3346[] = {0};
  meth_meth_ast_isLegalInTrait3346->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait3346);
  meth_meth_ast_isLegalInTrait3346->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait3346->definitionLine = 756;
// method "isTypeDec"
  struct UserObject *uo3348 = (struct UserObject*)obj3338;
  uo3348->data[8] = emptyclosure;
  Method *meth_meth_ast_isTypeDec3348 = addmethod2pos(obj3338, "isTypeDec", &meth_ast_isTypeDec3348, 8);
  int argcv_meth_ast_isTypeDec3348[] = {0};
  meth_meth_ast_isTypeDec3348->type = alloc_MethodType(1, argcv_meth_ast_isTypeDec3348);
  meth_meth_ast_isTypeDec3348->definitionModule = modulename;
  meth_meth_ast_isTypeDec3348->definitionLine = 757;
// method "scope:=(_)"
  struct UserObject *uo3350 = (struct UserObject*)obj3338;
  uo3350->data[9] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_3350 = addmethod2pos(obj3338, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_3350, 9);
  int argcv_meth_ast_scope_58__61__40_1_41_3350[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_3350->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_3350);
  meth_meth_ast_scope_58__61__40_1_41_3350->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_3350->definitionLine = 758;
// method "isExecutable"
  struct UserObject *uo3355 = (struct UserObject*)obj3338;
  uo3355->data[10] = emptyclosure;
  Method *meth_meth_ast_isExecutable3355 = addmethod2pos(obj3338, "isExecutable", &meth_ast_isExecutable3355, 10);
  int argcv_meth_ast_isExecutable3355[] = {0};
  meth_meth_ast_isExecutable3355->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3355);
  meth_meth_ast_isExecutable3355->definitionModule = modulename;
  meth_meth_ast_isExecutable3355->definitionLine = 765;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj3338);
  Object closure3357 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure3357, stackframe);
  addtoclosure(closure3357, var_k);
  struct UserObject *uo3357 = (struct UserObject*)obj3338;
  uo3357->data[11] = (Object)closure3357;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_3357 = addmethod2pos(obj3338, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_3357, 11);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_3357[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3357->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_3357);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3357->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3357->definitionLine = 766;
// method "isConfidential"
  struct UserObject *uo3360 = (struct UserObject*)obj3338;
  uo3360->data[12] = emptyclosure;
  Method *meth_meth_ast_isConfidential3360 = addmethod2pos(obj3338, "isConfidential", &meth_ast_isConfidential3360, 12);
  int argcv_meth_ast_isConfidential3360[] = {0};
  meth_meth_ast_isConfidential3360->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3360);
  meth_meth_ast_isConfidential3360->definitionModule = modulename;
  meth_meth_ast_isConfidential3360->definitionLine = 767;
// method "isPublic"
  struct UserObject *uo3378 = (struct UserObject*)obj3338;
  uo3378->data[13] = emptyclosure;
  Method *meth_meth_ast_isPublic3378 = addmethod2pos(obj3338, "isPublic", &meth_ast_isPublic3378, 13);
  int argcv_meth_ast_isPublic3378[] = {0};
  meth_meth_ast_isPublic3378->type = alloc_MethodType(1, argcv_meth_ast_isPublic3378);
  meth_meth_ast_isPublic3378->definitionModule = modulename;
  meth_meth_ast_isPublic3378->definitionLine = 771;
// method "isWritable"
  struct UserObject *uo3383 = (struct UserObject*)obj3338;
  uo3383->data[14] = emptyclosure;
  Method *meth_meth_ast_isWritable3383 = addmethod2pos(obj3338, "isWritable", &meth_ast_isWritable3383, 14);
  int argcv_meth_ast_isWritable3383[] = {0};
  meth_meth_ast_isWritable3383->type = alloc_MethodType(1, argcv_meth_ast_isWritable3383);
  meth_meth_ast_isWritable3383->definitionModule = modulename;
  meth_meth_ast_isWritable3383->definitionLine = 772;
// method "isReadable"
  struct UserObject *uo3385 = (struct UserObject*)obj3338;
  uo3385->data[15] = emptyclosure;
  Method *meth_meth_ast_isReadable3385 = addmethod2pos(obj3338, "isReadable", &meth_ast_isReadable3385, 15);
  int argcv_meth_ast_isReadable3385[] = {0};
  meth_meth_ast_isReadable3385->type = alloc_MethodType(1, argcv_meth_ast_isReadable3385);
  meth_meth_ast_isReadable3385->definitionModule = modulename;
  meth_meth_ast_isReadable3385->definitionLine = 773;
// method "accept(_)from(_)"
  struct UserObject *uo3388 = (struct UserObject*)obj3338;
  uo3388->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_3388 = addmethod2pos(obj3338, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_3388, 16);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_3388[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_3388->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_3388);
  meth_meth_ast_accept_40_1_41_from_40_1_41_3388->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_3388->definitionLine = 775;
// method "map(_)ancestors(_)"
  struct UserObject *uo3422 = (struct UserObject*)obj3338;
  uo3422->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_3422 = addmethod2pos(obj3338, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_3422, 17);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_3422[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3422->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_3422);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3422->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_3422->definitionLine = 786;
// method "pretty(_)"
  struct UserObject *uo3461 = (struct UserObject*)obj3338;
  uo3461->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_3461 = addmethod2pos(obj3338, "pretty(1)", &meth_ast_pretty_40_1_41_3461, 18);
  int argcv_meth_ast_pretty_40_1_41_3461[] = {1};
  meth_meth_ast_pretty_40_1_41_3461->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_3461);
  meth_meth_ast_pretty_40_1_41_3461->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_3461->definitionLine = 795;
// method "toGrace(_)"
  struct UserObject *uo3584 = (struct UserObject*)obj3338;
  uo3584->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_3584 = addmethod2pos(obj3338, "toGrace(1)", &meth_ast_toGrace_40_1_41_3584, 19);
  int argcv_meth_ast_toGrace_40_1_41_3584[] = {1};
  meth_meth_ast_toGrace_40_1_41_3584->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_3584);
meth_meth_ast_toGrace_40_1_41_3584->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_3584->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_3584->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_3584->definitionLine = 813;
// method "shallowCopy"
  block_savedest(obj3338);
  Object closure3643 = createclosure(2, "shallowCopy");
  setclosureframe(closure3643, stackframe);
  addtoclosure(closure3643, var_nullNode);
  addtoclosure(closure3643, var_typeDecNode);
  struct UserObject *uo3643 = (struct UserObject*)obj3338;
  uo3643->data[20] = (Object)closure3643;
  Method *meth_meth_ast_shallowCopy3643 = addmethod2pos(obj3338, "shallowCopy", &meth_ast_shallowCopy3643, 20);
  int argcv_meth_ast_shallowCopy3643[] = {0};
  meth_meth_ast_shallowCopy3643->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3643);
  meth_meth_ast_shallowCopy3643->definitionModule = modulename;
  meth_meth_ast_shallowCopy3643->definitionLine = 825;
  sourceObject = obj3338;
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3650 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3651 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3652 = gc_frame_new();
// call case 3: self.outer request
  Object call3653 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3652);
// compiled member node returning call3653 (depth = 5)
  Object call3654 = callmethodflags(call3653, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3651);
// compiled member node returning call3654 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3655 = callmethodflags(call3654, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3650);
// compiled call node returning call3655 (depth = 3)
  struct UserObject *obj3338_uo = (struct UserObject *)obj3338;
  obj3338_uo->super = call3655;
  sourceObject = obj3338;
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3656 == NULL) {
    strlit3656 = alloc_String("typedec");
    gc_root(strlit3656);
  }
// compiled string node returning strlit3656 (depth = 3)
  adddatum2(obj3338, strlit3656, 1);
  sourceObject = obj3338;
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj3338, *var_name_39_, 2);
  sourceObject = obj3338;
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeValue (depth = 3)
  adddatum2(obj3338, *var_typeValue, 3);
  sourceObject = obj3338;
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3657 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3658 = gc_frame_new();
// call case 4: self request
  Object call3659 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3658);
// compiled member node returning call3659 (depth = 4)
  Object call3660 = callmethodflags(call3659, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3657);
// compiled member node returning call3660 (depth = 3)
  adddatum2(obj3338, call3660, 4);
  sourceObject = obj3338;
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array3661 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3661 (depth = 3)
  adddatum2(obj3338, array3661, 5);
  sourceObject = obj3338;
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3662 = alloc_Boolean(0);
// compiled identifier node returning bool3662 (depth = 3)
  adddatum2(obj3338, bool3662, 6);
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  sourceObject = obj3338;
  objclass3338 = obj3338->class;
  objclass3338->definitionModule = modulename;
  objclass3338->definitionLine = 747;
  (*(struct UserObject *)self).data[0] = lowerouter3338;
  self = oldself3338;
  selfslot = oldselfslot3338;
  stackframe = oldstackframe3338;
  gc_frame_end(frame);
  return obj3338;
}
Object meth_ast_typeDecNode3664(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeDecNode;
}
Object meth_ast_new_40_3_41_scope_40_1_41_3667(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(3)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)scope(_)");
  Object params[3];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_signature = &(stackframe->slots[0]);
  *var_signature = args[curarg];
  curarg++;
  Object *var_body = &(stackframe->slots[1]);
  *var_body = args[curarg];
  curarg++;
  Object *var_dtype = &(stackframe->slots[2]);
  *var_dtype = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *var_s = &(stackframe->slots[3]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "result");
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3668 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 4: self request
  params[0] = *var_signature;
  params[1] = *var_body;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call3669 = callmethodflags(self, "new(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3668);
// compiled call node returning call3669 (depth = 4)
  *var_result = call3669;
  if (call3669 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3670 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call3671 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3670);
// compiled call node returning call3671 (depth = 3)
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_appliedOccurence3686(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "appliedOccurence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_uninitialized = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3687 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool3688 = alloc_Boolean(0);
// compiled identifier node returning bool3688 (depth = 4)
  gc_frame_newslot(bool3688);
// call case 4: self request
  params[0] = bool3688;
  partcv[0] = 1;
  Object call3689 = callmethodflags(self, "isBindingOccurence:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3687);
// compiled call node returning call3689 (depth = 3)
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3692 = gc_frame_new();
// call case 4: self request
  Object call3693 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3692);
// compiled member node returning call3693 (depth = 5)
  int op_slot_right_3691 = gc_frame_newslot(call3693);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_uninitialized (depth = 5)
  int op_slot_left_3691 = gc_frame_newslot(*var_uninitialized);
  params[0] = call3693;
  partcv[0] = 1;
  Object opresult3695 = callmethod(*var_uninitialized, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3695 (depth = 4)
  Object if3690 = done;
  if (istrue(opresult3695)) {
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3696 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool3697 = alloc_Boolean(0);
// compiled identifier node returning bool3697 (depth = 5)
  gc_frame_newslot(bool3697);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3698 = gc_frame_new();
// call case 4: self request
  Object call3699 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3698);
// compiled member node returning call3699 (depth = 5)
  params[0] = bool3697;
  partcv[0] = 1;
  Object call3700 = callmethodflags(call3699, "isBindingOccurence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3696);
// compiled call node returning call3700 (depth = 4)
    gc_frame_newslot(call3700);
    if3690 = call3700;
  } else {
  }
// compiled if node returning if3690 (depth = 3)
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast__apply_40_2_41_3704(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3706 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  Object call3707 = callmethodflags(*var_p, "numParams", 0, partcv, params, 0);
  gc_frame_end(callframe3706);
// compiled member node returning call3707 (depth = 6)
  int op_slot_right_3705 = gc_frame_newslot(call3707);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_3705 = gc_frame_newslot(*var_acc);
  params[0] = call3707;
  partcv[0] = 1;
  Object sum3709 = callmethod(*var_acc, "+(1)", 1, partcv, params);
// compiled op node returning sum3709 (depth = 5)
  gc_frame_end(frame);
  return sum3709;
}
Object meth_ast_numParams3701(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "numParams");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 867
  setline(867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3702 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3703 = alloc_Block(NULL, NULL, "ast", 867);
  gc_frame_newslot(block3703);
// method "_apply(_,_)"
  block_savedest(block3703);
  Object closure3704 = createclosure(1, "_apply(2)");
  setclosureframe(closure3704, stackframe);
  addtoclosure(closure3704, selfslot);
  struct UserObject *uo3704 = (struct UserObject*)block3703;
  uo3704->data[0] = (Object)closure3704;
  Method *meth_meth_ast__apply_40_2_41_3704 = addmethod2pos(block3703, "_apply(2)", &meth_ast__apply_40_2_41_3704, 0);
  int argcv_meth_ast__apply_40_2_41_3704[] = {2};
  meth_meth_ast__apply_40_2_41_3704->type = alloc_MethodType(1, argcv_meth_ast__apply_40_2_41_3704);
  meth_meth_ast__apply_40_2_41_3704->definitionModule = modulename;
  meth_meth_ast__apply_40_2_41_3704->definitionLine = 2981;
// compiled block node returning block3703 (depth = 4)
  gc_frame_newslot(block3703);
// starting to compile num node (depth = 4)
  Object num3711 = alloc_Float64(0);
// compiled num node returning num3711 (depth = 4)
  gc_frame_newslot(num3711);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3712 = gc_frame_new();
// call case 4: self request
  Object call3713 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3712);
// compiled member node returning call3713 (depth = 4)
  params[0] = block3703;
  params[1] = num3711;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3714 = callmethodflags(call3713, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3702);
// compiled call node returning call3714 (depth = 3)
  gc_frame_end(frame);
  return call3714;
}
Object meth_ast_endPos3715(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "endPos");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_lastPart = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "lastPart");
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3716 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3717 = gc_frame_new();
// call case 4: self request
  Object call3718 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3717);
// compiled member node returning call3718 (depth = 5)
  Object call3719 = callmethodflags(call3718, "last", 0, partcv, params, 0);
  gc_frame_end(callframe3716);
// compiled member node returning call3719 (depth = 4)
  *var_lastPart = call3719;
  if (call3719 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3721 = alloc_Float64(1);
// compiled num node returning num3721 (depth = 4)
  int op_slot_right_3720 = gc_frame_newslot(num3721);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3724 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3725 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastPart (depth = 7)
  Object call3726 = callmethodflags(*var_lastPart, "name", 0, partcv, params, 0);
  gc_frame_end(callframe3725);
// compiled member node returning call3726 (depth = 6)
  Object call3727 = callmethodflags(call3726, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3724);
// compiled member node returning call3727 (depth = 5)
  int op_slot_right_3723 = gc_frame_newslot(call3727);
// starting to compile member node (depth = 5)
  int callframe3729 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastPart (depth = 6)
  Object call3730 = callmethodflags(*var_lastPart, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3729);
// compiled member node returning call3730 (depth = 5)
  int op_slot_left_3723 = gc_frame_newslot(call3730);
  params[0] = call3727;
  partcv[0] = 1;
  Object sum3731 = callmethod(call3730, "+(1)", 1, partcv, params);
// compiled op node returning sum3731 (depth = 4)
  int op_slot_left_3720 = gc_frame_newslot(sum3731);
  params[0] = num3721;
  partcv[0] = 1;
  Object diff3732 = callmethod(sum3731, "-(1)", 1, partcv, params);
// compiled op node returning diff3732 (depth = 3)
  gc_frame_end(frame);
  return diff3732;
}
Object meth_ast__apply_40_2_41_3736(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_each = &(stackframe->slots[1]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3738 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  Object call3739 = callmethodflags(*var_each, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe3738);
// compiled member node returning call3739 (depth = 6)
  int op_slot_right_3737 = gc_frame_newslot(call3739);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_3737 = gc_frame_newslot(*var_acc);
  params[0] = call3739;
  partcv[0] = 1;
  Object opresult3741 = callmethod(*var_acc, "++(1)", 1, partcv, params);
// compiled op node returning opresult3741 (depth = 5)
  gc_frame_end(frame);
  return opresult3741;
}
Object meth_ast_nameString3733(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 875
  setline(875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3734 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3735 = alloc_Block(NULL, NULL, "ast", 875);
  gc_frame_newslot(block3735);
// method "_apply(_,_)"
  block_savedest(block3735);
  Object closure3736 = createclosure(1, "_apply(2)");
  setclosureframe(closure3736, stackframe);
  addtoclosure(closure3736, selfslot);
  struct UserObject *uo3736 = (struct UserObject*)block3735;
  uo3736->data[0] = (Object)closure3736;
  Method *meth_meth_ast__apply_40_2_41_3736 = addmethod2pos(block3735, "_apply(2)", &meth_ast__apply_40_2_41_3736, 0);
  int argcv_meth_ast__apply_40_2_41_3736[] = {2};
  meth_meth_ast__apply_40_2_41_3736->type = alloc_MethodType(1, argcv_meth_ast__apply_40_2_41_3736);
  meth_meth_ast__apply_40_2_41_3736->definitionModule = modulename;
  meth_meth_ast__apply_40_2_41_3736->definitionLine = 2981;
// compiled block node returning block3735 (depth = 4)
  gc_frame_newslot(block3735);
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit3743 == NULL) {
    strlit3743 = alloc_String("");
    gc_root(strlit3743);
  }
// compiled string node returning strlit3743 (depth = 4)
  gc_frame_newslot(strlit3743);
// call case 6: other requests
// Begin line 875
  setline(875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3744 = gc_frame_new();
// call case 4: self request
  Object call3745 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3744);
// compiled member node returning call3745 (depth = 4)
  params[0] = block3735;
  params[1] = strlit3743;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3746 = callmethodflags(call3745, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3734);
// compiled call node returning call3746 (depth = 3)
  gc_frame_end(frame);
  return call3746;
}
Object meth_ast_asIdentifier3747(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 879
  setline(879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3750 = gc_frame_new();
// call case 4: self request
  Object call3751 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3750);
// compiled member node returning call3751 (depth = 5)
  int op_slot_right_3749 = gc_frame_newslot(call3751);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_uninitialized (depth = 5)
  int op_slot_left_3749 = gc_frame_newslot(*var_uninitialized);
  params[0] = call3751;
  partcv[0] = 1;
  Object opresult3753 = callmethod(*var_uninitialized, "==(1)", 1, partcv, params);
// compiled op node returning opresult3753 (depth = 4)
  Object if3748 = done;
  if (istrue(opresult3753)) {
// Begin line 880
  setline(880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3754 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe3755 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe3756 = gc_frame_new();
// call case 4: self request
  Object call3757 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3756);
// compiled member node returning call3757 (depth = 6)
  gc_frame_newslot(call3757);
// starting to compile identifier node (depth = 6)
  Object bool3758 = alloc_Boolean(0);
// compiled identifier node returning bool3758 (depth = 6)
  gc_frame_newslot(bool3758);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_identifierNode (depth = 6)
  params[0] = call3757;
  params[1] = bool3758;
  partcv[0] = 2;
  Object call3759 = callmethodflags(*var_identifierNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe3755);
// compiled call node returning call3759 (depth = 5)
  gc_frame_newslot(call3759);
// call case 4: self request
  params[0] = call3759;
  partcv[0] = 1;
  Object call3760 = callmethodflags(self, "cachedIdentifier:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3754);
// compiled call node returning call3760 (depth = 4)
// Begin line 881
  setline(881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3761 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3762 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3763 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3764 = gc_frame_new();
// call case 4: self request
  Object call3765 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3764);
// compiled member node returning call3765 (depth = 7)
  Object call3766 = callmethodflags(call3765, "first", 0, partcv, params, 0);
  gc_frame_end(callframe3763);
// compiled member node returning call3766 (depth = 6)
  Object call3767 = callmethodflags(call3766, "line", 0, partcv, params, 0);
  gc_frame_end(callframe3762);
// compiled member node returning call3767 (depth = 5)
  gc_frame_newslot(call3767);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3768 = gc_frame_new();
// call case 4: self request
  Object call3769 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3768);
// compiled member node returning call3769 (depth = 5)
  params[0] = call3767;
  partcv[0] = 1;
  Object call3770 = callmethodflags(call3769, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3761);
// compiled call node returning call3770 (depth = 4)
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3771 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3772 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3773 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3774 = gc_frame_new();
// call case 4: self request
  Object call3775 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3774);
// compiled member node returning call3775 (depth = 7)
  Object call3776 = callmethodflags(call3775, "first", 0, partcv, params, 0);
  gc_frame_end(callframe3773);
// compiled member node returning call3776 (depth = 6)
  Object call3777 = callmethodflags(call3776, "linePos", 0, partcv, params, 0);
  gc_frame_end(callframe3772);
// compiled member node returning call3777 (depth = 5)
  gc_frame_newslot(call3777);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3778 = gc_frame_new();
// call case 4: self request
  Object call3779 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3778);
// compiled member node returning call3779 (depth = 5)
  params[0] = call3777;
  partcv[0] = 1;
  Object call3780 = callmethodflags(call3779, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3771);
// compiled call node returning call3780 (depth = 4)
// Begin line 883
  setline(883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3781 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3782 = gc_frame_new();
// call case 4: self request
  Object call3783 = callmethodflags(self, "isBindingOccurence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3782);
// compiled member node returning call3783 (depth = 5)
  gc_frame_newslot(call3783);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3784 = gc_frame_new();
// call case 4: self request
  Object call3785 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3784);
// compiled member node returning call3785 (depth = 5)
  params[0] = call3783;
  partcv[0] = 1;
  Object call3786 = callmethodflags(call3785, "isBindingOccurrence:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3781);
// compiled call node returning call3786 (depth = 4)
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3787 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe3788 = gc_frame_new();
// call case 4: self request
  Object call3789 = callmethodflags(self, "canonicalName", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3788);
// compiled member node returning call3789 (depth = 5)
  gc_frame_newslot(call3789);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3790 = gc_frame_new();
// call case 4: self request
  Object call3791 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3790);
// compiled member node returning call3791 (depth = 5)
  params[0] = call3789;
  partcv[0] = 1;
  Object call3792 = callmethodflags(call3791, "canonicalName:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3787);
// compiled call node returning call3792 (depth = 4)
    gc_frame_newslot(call3792);
    if3748 = call3792;
  } else {
  }
// compiled if node returning if3748 (depth = 3)
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3793 = gc_frame_new();
// call case 4: self request
  Object call3794 = callmethodflags(self, "cachedIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3793);
// compiled member node returning call3794 (depth = 3)
  gc_frame_end(frame);
  return call3794;
}
Object meth_ast_value3795(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "value");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3796 = gc_frame_new();
// call case 4: self request
  Object call3797 = callmethodflags(self, "asIdentifier", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3796);
// compiled member node returning call3797 (depth = 3)
  gc_frame_end(frame);
  return call3797;
}
Object meth_ast__apply_40_2_41_3801(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_each = &(stackframe->slots[1]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3803 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  Object call3804 = callmethodflags(*var_each, "canonicalName", 0, partcv, params, 0);
  gc_frame_end(callframe3803);
// compiled member node returning call3804 (depth = 6)
  int op_slot_right_3802 = gc_frame_newslot(call3804);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_3802 = gc_frame_newslot(*var_acc);
  params[0] = call3804;
  partcv[0] = 1;
  Object opresult3806 = callmethod(*var_acc, "++(1)", 1, partcv, params);
// compiled op node returning opresult3806 (depth = 5)
  gc_frame_end(frame);
  return opresult3806;
}
Object meth_ast_canonicalName3798(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3799 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3800 = alloc_Block(NULL, NULL, "ast", 890);
  gc_frame_newslot(block3800);
// method "_apply(_,_)"
  block_savedest(block3800);
  Object closure3801 = createclosure(1, "_apply(2)");
  setclosureframe(closure3801, stackframe);
  addtoclosure(closure3801, selfslot);
  struct UserObject *uo3801 = (struct UserObject*)block3800;
  uo3801->data[0] = (Object)closure3801;
  Method *meth_meth_ast__apply_40_2_41_3801 = addmethod2pos(block3800, "_apply(2)", &meth_ast__apply_40_2_41_3801, 0);
  int argcv_meth_ast__apply_40_2_41_3801[] = {2};
  meth_meth_ast__apply_40_2_41_3801->type = alloc_MethodType(1, argcv_meth_ast__apply_40_2_41_3801);
  meth_meth_ast__apply_40_2_41_3801->definitionModule = modulename;
  meth_meth_ast__apply_40_2_41_3801->definitionLine = 2981;
// compiled block node returning block3800 (depth = 4)
  gc_frame_newslot(block3800);
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit3808 == NULL) {
    strlit3808 = alloc_String("");
    gc_root(strlit3808);
  }
// compiled string node returning strlit3808 (depth = 4)
  gc_frame_newslot(strlit3808);
// call case 6: other requests
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3809 = gc_frame_new();
// call case 4: self request
  Object call3810 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3809);
// compiled member node returning call3810 (depth = 4)
  params[0] = block3800;
  params[1] = strlit3808;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3811 = callmethodflags(call3810, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3799);
// compiled call node returning call3811 (depth = 3)
  gc_frame_end(frame);
  return call3811;
}
Object meth_ast_hasParams3812(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasParams");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3813 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3814 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3815 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3816 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3817 = gc_frame_new();
// call case 4: self request
  Object call3818 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3817);
// compiled member node returning call3818 (depth = 7)
  Object call3819 = callmethodflags(call3818, "first", 0, partcv, params, 0);
  gc_frame_end(callframe3816);
// compiled member node returning call3819 (depth = 6)
  Object call3820 = callmethodflags(call3819, "params", 0, partcv, params, 0);
  gc_frame_end(callframe3815);
// compiled member node returning call3820 (depth = 5)
  Object call3821 = callmethodflags(call3820, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe3814);
// compiled member node returning call3821 (depth = 4)
  Object call3822 = callmethodflags(call3821, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3813);
// compiled member node returning call3822 (depth = 3)
  gc_frame_end(frame);
  return call3822;
}
Object meth_ast_numParamLists3823(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "numParamLists");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sigSz = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sigSz");
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3824 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3825 = gc_frame_new();
// call case 4: self request
  Object call3826 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3825);
// compiled member node returning call3826 (depth = 5)
  Object call3827 = callmethodflags(call3826, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3824);
// compiled member node returning call3827 (depth = 4)
  *var_sigSz = call3827;
  if (call3827 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 898
  setline(898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3830 = alloc_Float64(1);
// compiled num node returning num3830 (depth = 5)
  int op_slot_right_3829 = gc_frame_newslot(num3830);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sigSz (depth = 5)
  int op_slot_left_3829 = gc_frame_newslot(*var_sigSz);
  params[0] = num3830;
  partcv[0] = 1;
  Object opresult3832 = callmethod(*var_sigSz, ">(1)", 1, partcv, params);
// compiled op node returning opresult3832 (depth = 4)
  Object if3828 = done;
  if (istrue(opresult3832)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sigSz (depth = 5)
  return *var_sigSz;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if3828 = undefined;
  } else {
  }
// compiled if node returning if3828 (depth = 3)
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3834 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3835 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3836 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3837 = gc_frame_new();
// call case 4: self request
  Object call3838 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3837);
// compiled member node returning call3838 (depth = 7)
  Object call3839 = callmethodflags(call3838, "first", 0, partcv, params, 0);
  gc_frame_end(callframe3836);
// compiled member node returning call3839 (depth = 6)
  Object call3840 = callmethodflags(call3839, "params", 0, partcv, params, 0);
  gc_frame_end(callframe3835);
// compiled member node returning call3840 (depth = 5)
  Object call3841 = callmethodflags(call3840, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe3834);
// compiled member node returning call3841 (depth = 4)
  Object if3833 = done;
  if (istrue(call3841)) {
// starting to compile return node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3842 = alloc_Float64(0);
// compiled num node returning num3842 (depth = 5)
  return num3842;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if3833 = undefined;
  } else {
  }
// compiled if node returning if3833 (depth = 3)
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3843 = alloc_Float64(1);
// compiled num node returning num3843 (depth = 4)
  return num3843;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_hasTypeParams3844(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasTypeParams");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 902
  setline(902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3846 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3847 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3848 = gc_frame_new();
// call case 4: self request
  Object call3849 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3848);
// compiled member node returning call3849 (depth = 6)
  Object call3850 = callmethodflags(call3849, "first", 0, partcv, params, 0);
  gc_frame_end(callframe3847);
// compiled member node returning call3850 (depth = 5)
  Object call3851 = callmethodflags(call3850, "typeParams", 0, partcv, params, 0);
  gc_frame_end(callframe3846);
// compiled member node returning call3851 (depth = 4)
  int op_slot_right_3845 = gc_frame_newslot(call3851);
// starting to compile identifier node (depth = 4)
  Object bool3853 = alloc_Boolean(0);
// compiled identifier node returning bool3853 (depth = 4)
  int op_slot_left_3845 = gc_frame_newslot(bool3853);
  params[0] = call3851;
  partcv[0] = 1;
  Object opresult3854 = callmethod(bool3853, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3854 (depth = 3)
  gc_frame_end(frame);
  return opresult3854;
}
Object meth_ast_isMethod3855(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3856 = alloc_Boolean(1);
// compiled identifier node returning bool3856 (depth = 3)
  gc_frame_end(frame);
  return bool3856;
}
Object meth_ast_isExecutable3857(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3858 = alloc_Boolean(0);
// compiled identifier node returning bool3858 (depth = 3)
  gc_frame_end(frame);
  return bool3858;
}
Object meth_ast_isLegalInTrait3859(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 905
  setline(905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3860 = alloc_Boolean(1);
// compiled identifier node returning bool3860 (depth = 3)
  gc_frame_end(frame);
  return bool3860;
}
Object meth_ast_isClass3861(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3863 = gc_frame_new();
// call case 4: self request
  Object call3864 = callmethodflags(self, "usesClassSyntax", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3863);
// compiled member node returning call3864 (depth = 4)
  int op_slot_right_3862 = gc_frame_newslot(call3864);
// starting to compile member node (depth = 4)
  int callframe3866 = gc_frame_new();
// call case 4: self request
  Object call3867 = callmethodflags(self, "isFresh", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3866);
// compiled member node returning call3867 (depth = 4)
  int op_slot_left_3862 = gc_frame_newslot(call3867);
  params[0] = call3864;
  partcv[0] = 1;
  Object opresult3868 = callmethod(call3867, "||(1)", 1, partcv, params);
// compiled op node returning opresult3868 (depth = 3)
  gc_frame_end(frame);
  return opresult3868;
}
Object meth_ast_isTrait3869(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3871 = gc_frame_new();
// call case 4: self request
  Object call3872 = callmethodflags(self, "isFresh", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3871);
// compiled member node returning call3872 (depth = 4)
  Object if3870 = done;
  if (istrue(call3872)) {
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3873 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3874 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3875 = gc_frame_new();
// call case 4: self request
  Object call3876 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3875);
// compiled member node returning call3876 (depth = 6)
  Object call3877 = callmethodflags(call3876, "last", 0, partcv, params, 0);
  gc_frame_end(callframe3874);
// compiled member node returning call3877 (depth = 5)
  Object call3878 = callmethodflags(call3877, "isTrait", 0, partcv, params, 0);
  gc_frame_end(callframe3873);
// compiled member node returning call3878 (depth = 4)
    gc_frame_newslot(call3878);
    if3870 = call3878;
  } else {
// Begin line 911
  setline(911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool3879 = alloc_Boolean(0);
// compiled identifier node returning bool3879 (depth = 4)
    gc_frame_newslot(bool3879);
    if3870 = bool3879;
  }
// compiled if node returning if3870 (depth = 3)
  gc_frame_end(frame);
  return if3870;
}
Object meth_ast__apply3890(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_p = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3892 == NULL) {
    strlit3892 = alloc_String("Unknown");
    gc_root(strlit3892);
  }
// compiled string node returning strlit3892 (depth = 11)
  int op_slot_right_3891 = gc_frame_newslot(strlit3892);
// starting to compile member node (depth = 11)
  int callframe3894 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 12)
  int callframe3895 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_p (depth = 13)
  Object call3896 = callmethodflags(*var_p, "dtype", 0, partcv, params, 0);
  gc_frame_end(callframe3895);
// compiled member node returning call3896 (depth = 12)
  Object call3897 = callmethodflags(call3896, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe3894);
// compiled member node returning call3897 (depth = 11)
  int op_slot_left_3891 = gc_frame_newslot(call3897);
  params[0] = strlit3892;
  partcv[0] = 1;
  Object opresult3898 = callmethod(call3897, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3898 (depth = 10)
  gc_frame_end(frame);
  return opresult3898;
}
Object meth_ast__apply_40_1_41_3886(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile block node (depth = 9)
  Object block3889 = alloc_Block(NULL, NULL, "ast", 917);
  gc_frame_newslot(block3889);
// method "_apply"
  block_savedest(block3889);
  Object closure3890 = createclosure(2, "_apply");
  setclosureframe(closure3890, stackframe);
  addtoclosure(closure3890, var_p);
  addtoclosure(closure3890, selfslot);
  struct UserObject *uo3890 = (struct UserObject*)block3889;
  uo3890->data[0] = (Object)closure3890;
  Method *meth_meth_ast__apply3890 = addmethod2pos(block3889, "_apply", &meth_ast__apply3890, 0);
  int argcv_meth_ast__apply3890[] = {0};
  meth_meth_ast__apply3890->type = alloc_MethodType(1, argcv_meth_ast__apply3890);
  meth_meth_ast__apply3890->definitionModule = modulename;
  meth_meth_ast__apply3890->definitionLine = 2981;
// compiled block node returning block3889 (depth = 9)
  int op_slot_right_3888 = gc_frame_newslot(block3889);
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe3902 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  Object call3903 = callmethodflags(*var_p, "dtype", 0, partcv, params, 0);
  gc_frame_end(callframe3902);
// compiled member node returning call3903 (depth = 10)
  int op_slot_right_3901 = gc_frame_newslot(call3903);
// starting to compile identifier node (depth = 10)
  Object bool3905 = alloc_Boolean(0);
// compiled identifier node returning bool3905 (depth = 10)
  int op_slot_left_3901 = gc_frame_newslot(bool3905);
  params[0] = call3903;
  partcv[0] = 1;
  Object opresult3906 = callmethod(bool3905, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3906 (depth = 9)
  int op_slot_left_3888 = gc_frame_newslot(opresult3906);
  params[0] = block3889;
  partcv[0] = 1;
  Object opresult3907 = callmethod(opresult3906, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3907 (depth = 8)
  Object if3887 = done;
  if (istrue(opresult3907)) {
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool3908 = alloc_Boolean(1);
// compiled identifier node returning bool3908 (depth = 9)
  block_return(realself, bool3908);
// compiled return node returning undefined (depth = 8)
    gc_frame_newslot(undefined);
    if3887 = undefined;
  } else {
  }
// compiled if node returning if3887 (depth = 7)
  gc_frame_end(frame);
  return if3887;
}
Object meth_ast__apply_40_1_41_3883(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3884 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3885 = alloc_Block(NULL, NULL, "ast", 916);
  gc_frame_newslot(block3885);
// method "_apply(_)"
  block_savedest(block3885);
  Object closure3886 = createclosure(1, "_apply(1)");
  setclosureframe(closure3886, stackframe);
  addtoclosure(closure3886, selfslot);
  struct UserObject *uo3886 = (struct UserObject*)block3885;
  uo3886->data[0] = (Object)closure3886;
  Method *meth_meth_ast__apply_40_1_41_3886 = addmethod2pos(block3885, "_apply(1)", &meth_ast__apply_40_1_41_3886, 0);
  int argcv_meth_ast__apply_40_1_41_3886[] = {1};
  meth_meth_ast__apply_40_1_41_3886->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3886);
  meth_meth_ast__apply_40_1_41_3886->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3886->definitionLine = 2981;
// compiled block node returning block3885 (depth = 6)
  gc_frame_newslot(block3885);
// call case 6: other requests
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe3910 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call3911 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe3910);
// compiled member node returning call3911 (depth = 6)
  params[0] = block3885;
  partcv[0] = 1;
  Object call3912 = callmethodflags(call3911, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3884);
// compiled call node returning call3912 (depth = 5)
  gc_frame_end(frame);
  return call3912;
}
Object meth_ast_needsArgChecks3880(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "needsArgChecks");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3881 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3882 = alloc_Block(NULL, NULL, "ast", 915);
  gc_frame_newslot(block3882);
// method "_apply(_)"
  block_savedest(block3882);
  Object closure3883 = createclosure(1, "_apply(1)");
  setclosureframe(closure3883, stackframe);
  addtoclosure(closure3883, selfslot);
  struct UserObject *uo3883 = (struct UserObject*)block3882;
  uo3883->data[0] = (Object)closure3883;
  Method *meth_meth_ast__apply_40_1_41_3883 = addmethod2pos(block3882, "_apply(1)", &meth_ast__apply_40_1_41_3883, 0);
  int argcv_meth_ast__apply_40_1_41_3883[] = {1};
  meth_meth_ast__apply_40_1_41_3883->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_3883);
  meth_meth_ast__apply_40_1_41_3883->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_3883->definitionLine = 2981;
// compiled block node returning block3882 (depth = 4)
  gc_frame_newslot(block3882);
// call case 6: other requests
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe3914 = gc_frame_new();
// call case 4: self request
  Object call3915 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3914);
// compiled member node returning call3915 (depth = 4)
  params[0] = block3882;
  partcv[0] = 1;
  Object call3916 = callmethodflags(call3915, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3881);
// compiled call node returning call3916 (depth = 3)
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool3917 = alloc_Boolean(0);
// compiled identifier node returning bool3917 (depth = 4)
  return bool3917;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_scope_58__61__40_1_41_3918(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3919 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call3920 = callmethodflags(self, "symbolTable:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3919);
// compiled call node returning call3920 (depth = 3)
// Begin line 929
  setline(929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3921 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3922 = callmethodflags(*var_st, "node:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3921);
// compiled call node returning call3922 (depth = 3)
  gc_frame_end(frame);
  return call3922;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_3923(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3924 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call3925 = callmethodflags(*var_k, "parameter", 0, partcv, params, 0);
  gc_frame_end(callframe3924);
// compiled member node returning call3925 (depth = 3)
  gc_frame_end(frame);
  return call3925;
}
Object meth_ast_isConfidential3926(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3929 = alloc_Float64(0);
// compiled num node returning num3929 (depth = 5)
  int op_slot_right_3928 = gc_frame_newslot(num3929);
// starting to compile member node (depth = 5)
  int callframe3931 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3932 = gc_frame_new();
// call case 4: self request
  Object call3933 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3932);
// compiled member node returning call3933 (depth = 6)
  Object call3934 = callmethodflags(call3933, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3931);
// compiled member node returning call3934 (depth = 5)
  int op_slot_left_3928 = gc_frame_newslot(call3934);
  params[0] = num3929;
  partcv[0] = 1;
  Object opresult3935 = callmethod(call3934, "==(1)", 1, partcv, params);
// compiled op node returning opresult3935 (depth = 4)
  Object if3927 = done;
  if (istrue(opresult3935)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool3936 = alloc_Boolean(0);
// compiled identifier node returning bool3936 (depth = 5)
  return bool3936;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if3927 = undefined;
  } else {
  }
// compiled if node returning if3927 (depth = 3)
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3937 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit3938 == NULL) {
    strlit3938 = alloc_String("confidential");
    gc_root(strlit3938);
  }
// compiled string node returning strlit3938 (depth = 4)
  gc_frame_newslot(strlit3938);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3939 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3940 = gc_frame_new();
// call case 3: self.outer request
  Object call3941 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3940);
// compiled member node returning call3941 (depth = 5)
  Object call3942 = callmethodflags(call3941, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3939);
// compiled member node returning call3942 (depth = 4)
  params[0] = self;
  params[1] = strlit3938;
  partcv[0] = 2;
  Object call3943 = callmethodflags(call3942, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3937);
// compiled call node returning call3943 (depth = 3)
  gc_frame_end(frame);
  return call3943;
}
Object meth_ast_isPublic3944(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3945 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3946 = gc_frame_new();
// call case 4: self request
  Object call3947 = callmethodflags(self, "isConfidential", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3946);
// compiled member node returning call3947 (depth = 4)
  Object call3948 = callmethodflags(call3947, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3945);
// compiled member node returning call3948 (depth = 3)
  gc_frame_end(frame);
  return call3948;
}
Object meth_ast_isWritable3949(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3950 = alloc_Boolean(0);
// compiled identifier node returning bool3950 (depth = 3)
  gc_frame_end(frame);
  return bool3950;
}
Object meth_ast_isReadable3951(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3952 = gc_frame_new();
// call case 4: self request
  Object call3953 = callmethodflags(self, "isPublic", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3952);
// compiled member node returning call3953 (depth = 3)
  gc_frame_end(frame);
  return call3953;
}
Object meth_ast_usesAsType_40_1_41_3954(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part usesAsType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3956 = gc_frame_new();
// call case 4: self request
  Object call3957 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3956);
// compiled member node returning call3957 (depth = 4)
  int op_slot_right_3955 = gc_frame_newslot(call3957);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_3955 = gc_frame_newslot(*var_aNode);
  params[0] = call3957;
  partcv[0] = 1;
  Object opresult3959 = callmethod(*var_aNode, "==(1)", 1, partcv, params);
// compiled op node returning opresult3959 (depth = 3)
  gc_frame_end(frame);
  return opresult3959;
}
Object meth_ast__apply3963(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe3964 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3965 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3966 = gc_frame_new();
// call case 4: self request
  Object call3967 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3966);
// compiled member node returning call3967 (depth = 7)
  Object call3968 = callmethodflags(call3967, "last", 0, partcv, params, 0);
  gc_frame_end(callframe3965);
// compiled member node returning call3968 (depth = 6)
  Object call3969 = callmethodflags(call3968, "returnsObject", 0, partcv, params, 0);
  gc_frame_end(callframe3964);
// compiled member node returning call3969 (depth = 5)
  gc_frame_end(frame);
  return call3969;
}
Object meth_ast_returnsObject3960(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile block node (depth = 4)
  Object block3962 = alloc_Block(NULL, NULL, "ast", 943);
  gc_frame_newslot(block3962);
// method "_apply"
  block_savedest(block3962);
  Object closure3963 = createclosure(1, "_apply");
  setclosureframe(closure3963, stackframe);
  addtoclosure(closure3963, selfslot);
  struct UserObject *uo3963 = (struct UserObject*)block3962;
  uo3963->data[0] = (Object)closure3963;
  Method *meth_meth_ast__apply3963 = addmethod2pos(block3962, "_apply", &meth_ast__apply3963, 0);
  int argcv_meth_ast__apply3963[] = {0};
  meth_meth_ast__apply3963->type = alloc_MethodType(1, argcv_meth_ast__apply3963);
  meth_meth_ast__apply3963->definitionModule = modulename;
  meth_meth_ast__apply3963->definitionLine = 2981;
// compiled block node returning block3962 (depth = 4)
  int op_slot_right_3961 = gc_frame_newslot(block3962);
// starting to compile member node (depth = 4)
  int callframe3972 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3973 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3974 = gc_frame_new();
// call case 4: self request
  Object call3975 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3974);
// compiled member node returning call3975 (depth = 6)
  Object call3976 = callmethodflags(call3975, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe3973);
// compiled member node returning call3976 (depth = 5)
  Object call3977 = callmethodflags(call3976, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3972);
// compiled member node returning call3977 (depth = 4)
  int op_slot_left_3961 = gc_frame_newslot(call3977);
  params[0] = block3962;
  partcv[0] = 1;
  Object opresult3978 = callmethod(call3977, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3978 (depth = 3)
  gc_frame_end(frame);
  return opresult3978;
}
Object meth_ast_returnedObjectScope3979(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 947
  setline(947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3980 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3981 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3982 = gc_frame_new();
// call case 4: self request
  Object call3983 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3982);
// compiled member node returning call3983 (depth = 5)
  Object call3984 = callmethodflags(call3983, "last", 0, partcv, params, 0);
  gc_frame_end(callframe3981);
// compiled member node returning call3984 (depth = 4)
  Object call3985 = callmethodflags(call3984, "returnedObjectScope", 0, partcv, params, 0);
  gc_frame_end(callframe3980);
// compiled member node returning call3985 (depth = 3)
  gc_frame_end(frame);
  return call3985;
}
Object meth_ast__apply_40_1_41_4016(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4017 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_visitor (depth = 9)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newChain (depth = 9)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_p (depth = 9)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4018 = callmethodflags(*var_p, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4017);
// compiled call node returning call4018 (depth = 8)
  gc_frame_end(frame);
  return call4018;
}
Object meth_ast__apply_40_1_41_4011(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4012 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe4013 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  Object call4014 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe4013);
// compiled member node returning call4014 (depth = 7)
  gc_frame_newslot(call4014);
// starting to compile block node (depth = 7)
  Object block4015 = alloc_Block(NULL, NULL, "ast", 957);
  gc_frame_newslot(block4015);
// method "_apply(_)"
  block_savedest(block4015);
  Object closure4016 = createclosure(3, "_apply(1)");
  setclosureframe(closure4016, stackframe);
  addtoclosure(closure4016, var_visitor);
  addtoclosure(closure4016, var_newChain);
  addtoclosure(closure4016, selfslot);
  struct UserObject *uo4016 = (struct UserObject*)block4015;
  uo4016->data[0] = (Object)closure4016;
  Method *meth_meth_ast__apply_40_1_41_4016 = addmethod2pos(block4015, "_apply(1)", &meth_ast__apply_40_1_41_4016, 0);
  int argcv_meth_ast__apply_40_1_41_4016[] = {1};
  meth_meth_ast__apply_40_1_41_4016->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4016);
  meth_meth_ast__apply_40_1_41_4016->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4016->definitionLine = 2981;
// compiled block node returning block4015 (depth = 7)
  gc_frame_newslot(block4015);
// call case 5: prelude request
  params[0] = call4014;
  params[1] = block4015;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4020 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4012);
// compiled call node returning call4020 (depth = 6)
  gc_frame_end(frame);
  return call4020;
}
Object meth_ast__apply_40_1_41_4038(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4039 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4040 = callmethodflags(*var_ann, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4039);
// compiled call node returning call4040 (depth = 6)
  gc_frame_end(frame);
  return call4040;
}
Object meth_ast__apply_40_1_41_4047(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4048 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4049 = callmethodflags(*var_mx, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4048);
// compiled call node returning call4049 (depth = 6)
  gc_frame_end(frame);
  return call4049;
}
Object meth_ast_accept_40_1_41_from_40_1_41_3986(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3988 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3989 = callmethodflags(*var_visitor, "visitMethod(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3988);
// compiled call node returning call3989 (depth = 4)
  Object if3987 = done;
  if (istrue(call3989)) {
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3990 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call3991 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3990);
// compiled call node returning call3991 (depth = 5)
  *var_newChain = call3991;
  if (call3991 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 952
  setline(952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3992 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3993 = gc_frame_new();
// call case 4: self request
  Object call3994 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3993);
// compiled member node returning call3994 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3995 = callmethodflags(call3994, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3992);
// compiled call node returning call3995 (depth = 4)
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3998 = gc_frame_new();
// call case 4: self request
  Object call3999 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3998);
// compiled member node returning call3999 (depth = 6)
  int op_slot_right_3997 = gc_frame_newslot(call3999);
// starting to compile identifier node (depth = 6)
  Object bool4001 = alloc_Boolean(0);
// compiled identifier node returning bool4001 (depth = 6)
  int op_slot_left_3997 = gc_frame_newslot(bool4001);
  params[0] = call3999;
  partcv[0] = 1;
  Object opresult4002 = callmethod(bool4001, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4002 (depth = 5)
  Object if3996 = done;
  if (istrue(opresult4002)) {
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4003 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4004 = gc_frame_new();
// call case 4: self request
  Object call4005 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4004);
// compiled member node returning call4005 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4006 = callmethodflags(call4005, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4003);
// compiled call node returning call4006 (depth = 5)
    gc_frame_newslot(call4006);
    if3996 = call4006;
  } else {
  }
// compiled if node returning if3996 (depth = 4)
// Begin line 956
  setline(956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4007 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4008 = gc_frame_new();
// call case 4: self request
  Object call4009 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4008);
// compiled member node returning call4009 (depth = 5)
  gc_frame_newslot(call4009);
// starting to compile block node (depth = 5)
  Object block4010 = alloc_Block(NULL, NULL, "ast", 956);
  gc_frame_newslot(block4010);
// method "_apply(_)"
  block_savedest(block4010);
  Object closure4011 = createclosure(3, "_apply(1)");
  setclosureframe(closure4011, stackframe);
  addtoclosure(closure4011, var_visitor);
  addtoclosure(closure4011, var_newChain);
  addtoclosure(closure4011, selfslot);
  struct UserObject *uo4011 = (struct UserObject*)block4010;
  uo4011->data[0] = (Object)closure4011;
  Method *meth_meth_ast__apply_40_1_41_4011 = addmethod2pos(block4010, "_apply(1)", &meth_ast__apply_40_1_41_4011, 0);
  int argcv_meth_ast__apply_40_1_41_4011[] = {1};
  meth_meth_ast__apply_40_1_41_4011->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4011);
  meth_meth_ast__apply_40_1_41_4011->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4011->definitionLine = 2981;
// compiled block node returning block4010 (depth = 5)
  gc_frame_newslot(block4010);
// call case 5: prelude request
  params[0] = call4009;
  params[1] = block4010;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4022 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4007);
// compiled call node returning call4022 (depth = 4)
// Begin line 961
  setline(961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4025 = gc_frame_new();
// call case 4: self request
  Object call4026 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4025);
// compiled member node returning call4026 (depth = 6)
  int op_slot_right_4024 = gc_frame_newslot(call4026);
// starting to compile identifier node (depth = 6)
  Object bool4028 = alloc_Boolean(0);
// compiled identifier node returning bool4028 (depth = 6)
  int op_slot_left_4024 = gc_frame_newslot(bool4028);
  params[0] = call4026;
  partcv[0] = 1;
  Object opresult4029 = callmethod(bool4028, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4029 (depth = 5)
  Object if4023 = done;
  if (istrue(opresult4029)) {
// Begin line 962
  setline(962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4030 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4031 = gc_frame_new();
// call case 4: self request
  Object call4032 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4031);
// compiled member node returning call4032 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4033 = callmethodflags(call4032, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4030);
// compiled call node returning call4033 (depth = 5)
    gc_frame_newslot(call4033);
    if4023 = call4033;
  } else {
  }
// compiled if node returning if4023 (depth = 4)
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4034 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4035 = gc_frame_new();
// call case 4: self request
  Object call4036 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4035);
// compiled member node returning call4036 (depth = 5)
  gc_frame_newslot(call4036);
// starting to compile block node (depth = 5)
  Object block4037 = alloc_Block(NULL, NULL, "ast", 964);
  gc_frame_newslot(block4037);
// method "_apply(_)"
  block_savedest(block4037);
  Object closure4038 = createclosure(3, "_apply(1)");
  setclosureframe(closure4038, stackframe);
  addtoclosure(closure4038, var_visitor);
  addtoclosure(closure4038, var_newChain);
  addtoclosure(closure4038, selfslot);
  struct UserObject *uo4038 = (struct UserObject*)block4037;
  uo4038->data[0] = (Object)closure4038;
  Method *meth_meth_ast__apply_40_1_41_4038 = addmethod2pos(block4037, "_apply(1)", &meth_ast__apply_40_1_41_4038, 0);
  int argcv_meth_ast__apply_40_1_41_4038[] = {1};
  meth_meth_ast__apply_40_1_41_4038->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4038);
  meth_meth_ast__apply_40_1_41_4038->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4038->definitionLine = 2981;
// compiled block node returning block4037 (depth = 5)
  gc_frame_newslot(block4037);
// call case 5: prelude request
  params[0] = call4036;
  params[1] = block4037;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4042 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4034);
// compiled call node returning call4042 (depth = 4)
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4043 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4044 = gc_frame_new();
// call case 4: self request
  Object call4045 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4044);
// compiled member node returning call4045 (depth = 5)
  gc_frame_newslot(call4045);
// starting to compile block node (depth = 5)
  Object block4046 = alloc_Block(NULL, NULL, "ast", 967);
  gc_frame_newslot(block4046);
// method "_apply(_)"
  block_savedest(block4046);
  Object closure4047 = createclosure(3, "_apply(1)");
  setclosureframe(closure4047, stackframe);
  addtoclosure(closure4047, var_visitor);
  addtoclosure(closure4047, var_newChain);
  addtoclosure(closure4047, selfslot);
  struct UserObject *uo4047 = (struct UserObject*)block4046;
  uo4047->data[0] = (Object)closure4047;
  Method *meth_meth_ast__apply_40_1_41_4047 = addmethod2pos(block4046, "_apply(1)", &meth_ast__apply_40_1_41_4047, 0);
  int argcv_meth_ast__apply_40_1_41_4047[] = {1};
  meth_meth_ast__apply_40_1_41_4047->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4047);
  meth_meth_ast__apply_40_1_41_4047->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4047->definitionLine = 2981;
// compiled block node returning block4046 (depth = 5)
  gc_frame_newslot(block4046);
// call case 5: prelude request
  params[0] = call4045;
  params[1] = block4046;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4051 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4043);
// compiled call node returning call4051 (depth = 4)
    gc_frame_newslot(call4051);
    if3987 = call4051;
  } else {
  }
// compiled if node returning if3987 (depth = 3)
  gc_frame_end(frame);
  return if3987;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_4052(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4053 = gc_frame_new();
// call case 4: self request
  Object call4054 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4053);
// compiled member node returning call4054 (depth = 4)
  *var_n = call4054;
  if (call4054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4055 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call4056 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4055);
// compiled call node returning call4056 (depth = 4)
  *var_newChain = call4056;
  if (call4056 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4057 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4058 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4059 = gc_frame_new();
// call case 4: self request
  Object call4060 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4059);
// compiled member node returning call4060 (depth = 5)
  gc_frame_newslot(call4060);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4061 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4062 = gc_frame_new();
// call case 3: self.outer request
  Object call4063 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4062);
// compiled member node returning call4063 (depth = 6)
  Object call4064 = callmethodflags(call4063, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4061);
// compiled member node returning call4064 (depth = 5)
  params[0] = call4060;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4065 = callmethodflags(call4064, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4058);
// compiled call node returning call4065 (depth = 4)
  gc_frame_newslot(call4065);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4065;
  partcv[0] = 1;
  Object call4066 = callmethodflags(*var_n, "body:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4057);
// compiled call node returning call4066 (depth = 3)
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4067 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4068 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4069 = gc_frame_new();
// call case 4: self request
  Object call4070 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4069);
// compiled member node returning call4070 (depth = 5)
  gc_frame_newslot(call4070);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4071 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4072 = gc_frame_new();
// call case 3: self.outer request
  Object call4073 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4072);
// compiled member node returning call4073 (depth = 6)
  Object call4074 = callmethodflags(call4073, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4071);
// compiled member node returning call4074 (depth = 5)
  params[0] = call4070;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4075 = callmethodflags(call4074, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4068);
// compiled call node returning call4075 (depth = 4)
  gc_frame_newslot(call4075);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4075;
  partcv[0] = 1;
  Object call4076 = callmethodflags(*var_n, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4067);
// compiled call node returning call4076 (depth = 3)
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4077 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4078 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4079 = gc_frame_new();
// call case 4: self request
  Object call4080 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4079);
// compiled member node returning call4080 (depth = 5)
  gc_frame_newslot(call4080);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4081 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4082 = gc_frame_new();
// call case 3: self.outer request
  Object call4083 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4082);
// compiled member node returning call4083 (depth = 6)
  Object call4084 = callmethodflags(call4083, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4081);
// compiled member node returning call4084 (depth = 5)
  params[0] = call4080;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4085 = callmethodflags(call4084, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4078);
// compiled call node returning call4085 (depth = 4)
  gc_frame_newslot(call4085);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4085;
  partcv[0] = 1;
  Object call4086 = callmethodflags(*var_n, "signature:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4077);
// compiled call node returning call4086 (depth = 3)
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4087 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4088 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4089 = gc_frame_new();
// call case 4: self request
  Object call4090 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4089);
// compiled member node returning call4090 (depth = 5)
  gc_frame_newslot(call4090);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4091 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4092 = gc_frame_new();
// call case 3: self.outer request
  Object call4093 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4092);
// compiled member node returning call4093 (depth = 6)
  Object call4094 = callmethodflags(call4093, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4091);
// compiled member node returning call4094 (depth = 5)
  params[0] = call4090;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4095 = callmethodflags(call4094, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4088);
// compiled call node returning call4095 (depth = 4)
  gc_frame_newslot(call4095);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4095;
  partcv[0] = 1;
  Object call4096 = callmethodflags(*var_n, "annotations:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4087);
// compiled call node returning call4096 (depth = 3)
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4097 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4098 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4099 = gc_frame_new();
// call case 4: self request
  Object call4100 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4099);
// compiled member node returning call4100 (depth = 5)
  gc_frame_newslot(call4100);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4101 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4102 = gc_frame_new();
// call case 3: self.outer request
  Object call4103 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4102);
// compiled member node returning call4103 (depth = 6)
  Object call4104 = callmethodflags(call4103, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4101);
// compiled member node returning call4104 (depth = 5)
  params[0] = call4100;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4105 = callmethodflags(call4104, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4098);
// compiled call node returning call4105 (depth = 4)
  gc_frame_newslot(call4105);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4105;
  partcv[0] = 1;
  Object call4106 = callmethodflags(*var_n, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4097);
// compiled call node returning call4106 (depth = 3)
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4107 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call4108 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4107);
// compiled call node returning call4108 (depth = 3)
  gc_frame_end(frame);
  return call4108;
}
Object meth_ast__apply_40_1_41_4117(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4119 == NULL) {
    strlit4119 = alloc_String("  ");
    gc_root(strlit4119);
  }
// compiled string node returning strlit4119 (depth = 7)
  int op_slot_right_4118 = gc_frame_newslot(strlit4119);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_4118 = gc_frame_newslot(*var_spc);
  params[0] = strlit4119;
  partcv[0] = 1;
  Object opresult4121 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult4121 (depth = 6)
  *var_spc = opresult4121;
  if (opresult4121 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_4282(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1000
  setline(1000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4284 == NULL) {
    strlit4284 = alloc_String("");
    gc_root(strlit4284);
  }
// compiled string node returning strlit4284 (depth = 9)
  int op_slot_right_4283 = gc_frame_newslot(strlit4284);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4287 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num4289 = alloc_Float64(4);
// compiled num node returning num4289 (depth = 12)
  int op_slot_right_4288 = gc_frame_newslot(num4289);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_4288 = gc_frame_newslot(*var_depth);
  params[0] = num4289;
  partcv[0] = 1;
  Object sum4291 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4291 (depth = 11)
  gc_frame_newslot(sum4291);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = sum4291;
  partcv[0] = 1;
  Object call4292 = callmethodflags(*var_p, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4287);
// compiled call node returning call4292 (depth = 10)
  int op_slot_right_4286 = gc_frame_newslot(call4292);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4295 == NULL) {
    strlit4295 = alloc_String("");
    gc_root(strlit4295);
  }
// compiled string node returning strlit4295 (depth = 11)
  int op_slot_right_4294 = gc_frame_newslot(strlit4295);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_4297 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit4300 == NULL) {
    strlit4300 = alloc_String("""\x0a""      ");
    gc_root(strlit4300);
  }
// compiled string node returning strlit4300 (depth = 13)
  int op_slot_right_4299 = gc_frame_newslot(strlit4300);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_s (depth = 14)
  int op_slot_right_4302 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 14)
  if (strlit4304 == NULL) {
    strlit4304 = alloc_String("");
    gc_root(strlit4304);
  }
// compiled string node returning strlit4304 (depth = 14)
  int op_slot_left_4302 = gc_frame_newslot(strlit4304);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4305 = callmethod(strlit4304, "++(1)", 1, partcv, params);
// compiled op node returning opresult4305 (depth = 13)
  int op_slot_left_4299 = gc_frame_newslot(opresult4305);
  params[0] = strlit4300;
  partcv[0] = 1;
  Object opresult4306 = callmethod(opresult4305, "++(1)", 1, partcv, params);
// compiled op node returning opresult4306 (depth = 12)
  int op_slot_left_4297 = gc_frame_newslot(opresult4306);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4307 = callmethod(opresult4306, "++(1)", 1, partcv, params);
// compiled op node returning opresult4307 (depth = 11)
  int op_slot_left_4294 = gc_frame_newslot(opresult4307);
  params[0] = strlit4295;
  partcv[0] = 1;
  Object opresult4308 = callmethod(opresult4307, "++(1)", 1, partcv, params);
// compiled op node returning opresult4308 (depth = 10)
  int op_slot_left_4286 = gc_frame_newslot(opresult4308);
  params[0] = call4292;
  partcv[0] = 1;
  Object opresult4309 = callmethod(opresult4308, "++(1)", 1, partcv, params);
// compiled op node returning opresult4309 (depth = 9)
  int op_slot_left_4283 = gc_frame_newslot(opresult4309);
  params[0] = strlit4284;
  partcv[0] = 1;
  Object opresult4310 = callmethod(opresult4309, "++(1)", 1, partcv, params);
// compiled op node returning opresult4310 (depth = 8)
  *var_s = opresult4310;
  if (opresult4310 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_4236(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4238 == NULL) {
    strlit4238 = alloc_String("");
    gc_root(strlit4238);
  }
// compiled string node returning strlit4238 (depth = 7)
  int op_slot_right_4237 = gc_frame_newslot(strlit4238);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4241 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  Object call4242 = callmethodflags(*var_part, "name", 0, partcv, params, 0);
  gc_frame_end(callframe4241);
// compiled member node returning call4242 (depth = 8)
  int op_slot_right_4240 = gc_frame_newslot(call4242);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4245 == NULL) {
    strlit4245 = alloc_String("Part: ");
    gc_root(strlit4245);
  }
// compiled string node returning strlit4245 (depth = 9)
  int op_slot_right_4244 = gc_frame_newslot(strlit4245);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_4247 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4250 == NULL) {
    strlit4250 = alloc_String("""\x0a""  ");
    gc_root(strlit4250);
  }
// compiled string node returning strlit4250 (depth = 11)
  int op_slot_right_4249 = gc_frame_newslot(strlit4250);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_4252 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit4254 == NULL) {
    strlit4254 = alloc_String("");
    gc_root(strlit4254);
  }
// compiled string node returning strlit4254 (depth = 12)
  int op_slot_left_4252 = gc_frame_newslot(strlit4254);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4255 = callmethod(strlit4254, "++(1)", 1, partcv, params);
// compiled op node returning opresult4255 (depth = 11)
  int op_slot_left_4249 = gc_frame_newslot(opresult4255);
  params[0] = strlit4250;
  partcv[0] = 1;
  Object opresult4256 = callmethod(opresult4255, "++(1)", 1, partcv, params);
// compiled op node returning opresult4256 (depth = 10)
  int op_slot_left_4247 = gc_frame_newslot(opresult4256);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4257 = callmethod(opresult4256, "++(1)", 1, partcv, params);
// compiled op node returning opresult4257 (depth = 9)
  int op_slot_left_4244 = gc_frame_newslot(opresult4257);
  params[0] = strlit4245;
  partcv[0] = 1;
  Object opresult4258 = callmethod(opresult4257, "++(1)", 1, partcv, params);
// compiled op node returning opresult4258 (depth = 8)
  int op_slot_left_4240 = gc_frame_newslot(opresult4258);
  params[0] = call4242;
  partcv[0] = 1;
  Object opresult4259 = callmethod(opresult4258, "++(1)", 1, partcv, params);
// compiled op node returning opresult4259 (depth = 7)
  int op_slot_left_4237 = gc_frame_newslot(opresult4259);
  params[0] = strlit4238;
  partcv[0] = 1;
  Object opresult4260 = callmethod(opresult4259, "++(1)", 1, partcv, params);
// compiled op node returning opresult4260 (depth = 6)
  *var_s = opresult4260;
  if (opresult4260 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4263 == NULL) {
    strlit4263 = alloc_String("Parameters:");
    gc_root(strlit4263);
  }
// compiled string node returning strlit4263 (depth = 7)
  int op_slot_right_4262 = gc_frame_newslot(strlit4263);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_4265 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4268 == NULL) {
    strlit4268 = alloc_String("""\x0a""    ");
    gc_root(strlit4268);
  }
// compiled string node returning strlit4268 (depth = 9)
  int op_slot_right_4267 = gc_frame_newslot(strlit4268);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_4270 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit4272 == NULL) {
    strlit4272 = alloc_String("");
    gc_root(strlit4272);
  }
// compiled string node returning strlit4272 (depth = 10)
  int op_slot_left_4270 = gc_frame_newslot(strlit4272);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4273 = callmethod(strlit4272, "++(1)", 1, partcv, params);
// compiled op node returning opresult4273 (depth = 9)
  int op_slot_left_4267 = gc_frame_newslot(opresult4273);
  params[0] = strlit4268;
  partcv[0] = 1;
  Object opresult4274 = callmethod(opresult4273, "++(1)", 1, partcv, params);
// compiled op node returning opresult4274 (depth = 8)
  int op_slot_left_4265 = gc_frame_newslot(opresult4274);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4275 = callmethod(opresult4274, "++(1)", 1, partcv, params);
// compiled op node returning opresult4275 (depth = 7)
  int op_slot_left_4262 = gc_frame_newslot(opresult4275);
  params[0] = strlit4263;
  partcv[0] = 1;
  Object opresult4276 = callmethod(opresult4275, "++(1)", 1, partcv, params);
// compiled op node returning opresult4276 (depth = 6)
  *var_s = opresult4276;
  if (opresult4276 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 999
  setline(999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4278 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4279 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call4280 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe4279);
// compiled member node returning call4280 (depth = 6)
  gc_frame_newslot(call4280);
// starting to compile block node (depth = 6)
  Object block4281 = alloc_Block(NULL, NULL, "ast", 999);
  gc_frame_newslot(block4281);
// method "_apply(_)"
  block_savedest(block4281);
  Object closure4282 = createclosure(4, "_apply(1)");
  setclosureframe(closure4282, stackframe);
  addtoclosure(closure4282, var_depth);
  addtoclosure(closure4282, var_spc);
  addtoclosure(closure4282, var_s);
  addtoclosure(closure4282, selfslot);
  struct UserObject *uo4282 = (struct UserObject*)block4281;
  uo4282->data[0] = (Object)closure4282;
  Method *meth_meth_ast__apply_40_1_41_4282 = addmethod2pos(block4281, "_apply(1)", &meth_ast__apply_40_1_41_4282, 0);
  int argcv_meth_ast__apply_40_1_41_4282[] = {1};
  meth_meth_ast__apply_40_1_41_4282->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4282);
  meth_meth_ast__apply_40_1_41_4282->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4282->definitionLine = 2981;
// compiled block node returning block4281 (depth = 6)
  gc_frame_newslot(block4281);
// call case 5: prelude request
  params[0] = call4280;
  params[1] = block4281;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4313 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4278);
// compiled call node returning call4313 (depth = 5)
  gc_frame_end(frame);
  return call4313;
}
Object meth_ast__apply_40_1_41_4346(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4348 == NULL) {
    strlit4348 = alloc_String("");
    gc_root(strlit4348);
  }
// compiled string node returning strlit4348 (depth = 8)
  int op_slot_right_4347 = gc_frame_newslot(strlit4348);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4351 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num4352 = alloc_Float64(0);
// compiled num node returning num4352 (depth = 10)
  gc_frame_newslot(num4352);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_g (depth = 10)
  params[0] = num4352;
  partcv[0] = 1;
  Object call4353 = callmethodflags(*var_g, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4351);
// compiled call node returning call4353 (depth = 9)
  int op_slot_right_4350 = gc_frame_newslot(call4353);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4356 == NULL) {
    strlit4356 = alloc_String("  ");
    gc_root(strlit4356);
  }
// compiled string node returning strlit4356 (depth = 10)
  int op_slot_right_4355 = gc_frame_newslot(strlit4356);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_4358 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit4361 == NULL) {
    strlit4361 = alloc_String("""\x0a""");
    gc_root(strlit4361);
  }
// compiled string node returning strlit4361 (depth = 12)
  int op_slot_right_4360 = gc_frame_newslot(strlit4361);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_4363 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit4365 == NULL) {
    strlit4365 = alloc_String("");
    gc_root(strlit4365);
  }
// compiled string node returning strlit4365 (depth = 13)
  int op_slot_left_4363 = gc_frame_newslot(strlit4365);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4366 = callmethod(strlit4365, "++(1)", 1, partcv, params);
// compiled op node returning opresult4366 (depth = 12)
  int op_slot_left_4360 = gc_frame_newslot(opresult4366);
  params[0] = strlit4361;
  partcv[0] = 1;
  Object opresult4367 = callmethod(opresult4366, "++(1)", 1, partcv, params);
// compiled op node returning opresult4367 (depth = 11)
  int op_slot_left_4358 = gc_frame_newslot(opresult4367);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4368 = callmethod(opresult4367, "++(1)", 1, partcv, params);
// compiled op node returning opresult4368 (depth = 10)
  int op_slot_left_4355 = gc_frame_newslot(opresult4368);
  params[0] = strlit4356;
  partcv[0] = 1;
  Object opresult4369 = callmethod(opresult4368, "++(1)", 1, partcv, params);
// compiled op node returning opresult4369 (depth = 9)
  int op_slot_left_4350 = gc_frame_newslot(opresult4369);
  params[0] = call4353;
  partcv[0] = 1;
  Object opresult4370 = callmethod(opresult4369, "++(1)", 1, partcv, params);
// compiled op node returning opresult4370 (depth = 8)
  int op_slot_left_4347 = gc_frame_newslot(opresult4370);
  params[0] = strlit4348;
  partcv[0] = 1;
  Object opresult4371 = callmethod(opresult4370, "++(1)", 1, partcv, params);
// compiled op node returning opresult4371 (depth = 7)
  *var_s = opresult4371;
  if (opresult4371 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_4411(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_an = &(stackframe->slots[0]);
  *var_an = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4413 == NULL) {
    strlit4413 = alloc_String("");
    gc_root(strlit4413);
  }
// compiled string node returning strlit4413 (depth = 8)
  int op_slot_right_4412 = gc_frame_newslot(strlit4413);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4416 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num4418 = alloc_Float64(2);
// compiled num node returning num4418 (depth = 11)
  int op_slot_right_4417 = gc_frame_newslot(num4418);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_4417 = gc_frame_newslot(*var_depth);
  params[0] = num4418;
  partcv[0] = 1;
  Object sum4420 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4420 (depth = 10)
  gc_frame_newslot(sum4420);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_an (depth = 10)
  params[0] = sum4420;
  partcv[0] = 1;
  Object call4421 = callmethodflags(*var_an, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4416);
// compiled call node returning call4421 (depth = 9)
  int op_slot_right_4415 = gc_frame_newslot(call4421);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4424 == NULL) {
    strlit4424 = alloc_String("  ");
    gc_root(strlit4424);
  }
// compiled string node returning strlit4424 (depth = 10)
  int op_slot_right_4423 = gc_frame_newslot(strlit4424);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_4426 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit4429 == NULL) {
    strlit4429 = alloc_String("""\x0a""");
    gc_root(strlit4429);
  }
// compiled string node returning strlit4429 (depth = 12)
  int op_slot_right_4428 = gc_frame_newslot(strlit4429);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_4431 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit4433 == NULL) {
    strlit4433 = alloc_String("");
    gc_root(strlit4433);
  }
// compiled string node returning strlit4433 (depth = 13)
  int op_slot_left_4431 = gc_frame_newslot(strlit4433);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4434 = callmethod(strlit4433, "++(1)", 1, partcv, params);
// compiled op node returning opresult4434 (depth = 12)
  int op_slot_left_4428 = gc_frame_newslot(opresult4434);
  params[0] = strlit4429;
  partcv[0] = 1;
  Object opresult4435 = callmethod(opresult4434, "++(1)", 1, partcv, params);
// compiled op node returning opresult4435 (depth = 11)
  int op_slot_left_4426 = gc_frame_newslot(opresult4435);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4436 = callmethod(opresult4435, "++(1)", 1, partcv, params);
// compiled op node returning opresult4436 (depth = 10)
  int op_slot_left_4423 = gc_frame_newslot(opresult4436);
  params[0] = strlit4424;
  partcv[0] = 1;
  Object opresult4437 = callmethod(opresult4436, "++(1)", 1, partcv, params);
// compiled op node returning opresult4437 (depth = 9)
  int op_slot_left_4415 = gc_frame_newslot(opresult4437);
  params[0] = call4421;
  partcv[0] = 1;
  Object opresult4438 = callmethod(opresult4437, "++(1)", 1, partcv, params);
// compiled op node returning opresult4438 (depth = 8)
  int op_slot_left_4412 = gc_frame_newslot(opresult4438);
  params[0] = strlit4413;
  partcv[0] = 1;
  Object opresult4439 = callmethod(opresult4438, "++(1)", 1, partcv, params);
// compiled op node returning opresult4439 (depth = 7)
  *var_s = opresult4439;
  if (opresult4439 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_4460(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4462 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4464 = alloc_Float64(2);
// compiled num node returning num4464 (depth = 9)
  int op_slot_right_4463 = gc_frame_newslot(num4464);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_4463 = gc_frame_newslot(*var_depth);
  params[0] = num4464;
  partcv[0] = 1;
  Object sum4466 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4466 (depth = 8)
  gc_frame_newslot(sum4466);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum4466;
  partcv[0] = 1;
  Object call4467 = callmethodflags(*var_mx, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4462);
// compiled call node returning call4467 (depth = 7)
  int op_slot_right_4461 = gc_frame_newslot(call4467);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_4469 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4472 == NULL) {
    strlit4472 = alloc_String("""\x0a""  ");
    gc_root(strlit4472);
  }
// compiled string node returning strlit4472 (depth = 9)
  int op_slot_right_4471 = gc_frame_newslot(strlit4472);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_4471 = gc_frame_newslot(*var_s);
  params[0] = strlit4472;
  partcv[0] = 1;
  Object opresult4474 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4474 (depth = 8)
  int op_slot_left_4469 = gc_frame_newslot(opresult4474);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4475 = callmethod(opresult4474, "++(1)", 1, partcv, params);
// compiled op node returning opresult4475 (depth = 7)
  int op_slot_left_4461 = gc_frame_newslot(opresult4475);
  params[0] = call4467;
  partcv[0] = 1;
  Object opresult4476 = callmethod(opresult4475, "++(1)", 1, partcv, params);
// compiled op node returning opresult4476 (depth = 6)
  *var_s = opresult4476;
  if (opresult4476 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_4109(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4110 == NULL) {
    strlit4110 = alloc_String("");
    gc_root(strlit4110);
  }
// compiled string node returning strlit4110 (depth = 4)
  *var_spc = strlit4110;
  if (strlit4110 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4111 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_4112 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num4114 = alloc_Float64(0);
// compiled num node returning num4114 (depth = 5)
  int op_slot_left_4112 = gc_frame_newslot(num4114);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult4115 = callmethod(num4114, "..(1)", 1, partcv, params);
// compiled op node returning opresult4115 (depth = 4)
  gc_frame_newslot(opresult4115);
// starting to compile block node (depth = 4)
  Object block4116 = alloc_Block(NULL, NULL, "ast", 984);
  gc_frame_newslot(block4116);
// method "_apply(_)"
  block_savedest(block4116);
  Object closure4117 = createclosure(2, "_apply(1)");
  setclosureframe(closure4117, stackframe);
  addtoclosure(closure4117, var_spc);
  addtoclosure(closure4117, selfslot);
  struct UserObject *uo4117 = (struct UserObject*)block4116;
  uo4117->data[0] = (Object)closure4117;
  Method *meth_meth_ast__apply_40_1_41_4117 = addmethod2pos(block4116, "_apply(1)", &meth_ast__apply_40_1_41_4117, 0);
  int argcv_meth_ast__apply_40_1_41_4117[] = {1};
  meth_meth_ast__apply_40_1_41_4117->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4117);
  meth_meth_ast__apply_40_1_41_4117->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4117->definitionLine = 2981;
// compiled block node returning block4116 (depth = 4)
  gc_frame_newslot(block4116);
// call case 5: prelude request
  params[0] = opresult4115;
  params[1] = block4116;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4124 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4111);
// compiled call node returning call4124 (depth = 3)
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4126 == NULL) {
    strlit4126 = alloc_String("""\x0a""");
    gc_root(strlit4126);
  }
// compiled string node returning strlit4126 (depth = 5)
  int op_slot_right_4125 = gc_frame_newslot(strlit4126);
// starting to compile call node (depth = 5)
  int callframe4128 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call4129 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4128);
// compiled call node returning call4129 (depth = 5)
  int op_slot_left_4125 = gc_frame_newslot(call4129);
  params[0] = strlit4126;
  partcv[0] = 1;
  Object opresult4130 = callmethod(call4129, "++(1)", 1, partcv, params);
// compiled op node returning opresult4130 (depth = 4)
  *var_s = opresult4130;
  if (opresult4130 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4132 == NULL) {
    strlit4132 = alloc_String("""\x0a""");
    gc_root(strlit4132);
  }
// compiled string node returning strlit4132 (depth = 5)
  int op_slot_right_4131 = gc_frame_newslot(strlit4132);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4135 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4137 = alloc_Float64(1);
// compiled num node returning num4137 (depth = 8)
  int op_slot_right_4136 = gc_frame_newslot(num4137);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_4136 = gc_frame_newslot(*var_depth);
  params[0] = num4137;
  partcv[0] = 1;
  Object sum4139 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4139 (depth = 7)
  gc_frame_newslot(sum4139);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4140 = gc_frame_new();
// call case 4: self request
  Object call4141 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4140);
// compiled member node returning call4141 (depth = 7)
  params[0] = sum4139;
  partcv[0] = 1;
  Object call4142 = callmethodflags(call4141, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4135);
// compiled call node returning call4142 (depth = 6)
  int op_slot_right_4134 = gc_frame_newslot(call4142);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4145 == NULL) {
    strlit4145 = alloc_String("Name: ");
    gc_root(strlit4145);
  }
// compiled string node returning strlit4145 (depth = 7)
  int op_slot_right_4144 = gc_frame_newslot(strlit4145);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_4147 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4147 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4149 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4149 (depth = 7)
  int op_slot_left_4144 = gc_frame_newslot(opresult4149);
  params[0] = strlit4145;
  partcv[0] = 1;
  Object opresult4150 = callmethod(opresult4149, "++(1)", 1, partcv, params);
// compiled op node returning opresult4150 (depth = 6)
  int op_slot_left_4134 = gc_frame_newslot(opresult4150);
  params[0] = call4142;
  partcv[0] = 1;
  Object opresult4151 = callmethod(opresult4150, "++(1)", 1, partcv, params);
// compiled op node returning opresult4151 (depth = 5)
  int op_slot_left_4131 = gc_frame_newslot(opresult4151);
  params[0] = strlit4132;
  partcv[0] = 1;
  Object opresult4152 = callmethod(opresult4151, "++(1)", 1, partcv, params);
// compiled op node returning opresult4152 (depth = 4)
  *var_s = opresult4152;
  if (opresult4152 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4156 = gc_frame_new();
// call case 4: self request
  Object call4157 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4156);
// compiled member node returning call4157 (depth = 5)
  int op_slot_right_4155 = gc_frame_newslot(call4157);
// starting to compile identifier node (depth = 5)
  Object bool4159 = alloc_Boolean(0);
// compiled identifier node returning bool4159 (depth = 5)
  int op_slot_left_4155 = gc_frame_newslot(bool4159);
  params[0] = call4157;
  partcv[0] = 1;
  Object opresult4160 = callmethod(bool4159, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4160 (depth = 4)
  Object if4154 = done;
  if (istrue(opresult4160)) {
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4162 == NULL) {
    strlit4162 = alloc_String("  ");
    gc_root(strlit4162);
  }
// compiled string node returning strlit4162 (depth = 6)
  int op_slot_right_4161 = gc_frame_newslot(strlit4162);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4164 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4167 == NULL) {
    strlit4167 = alloc_String("Returns:""\x0a""");
    gc_root(strlit4167);
  }
// compiled string node returning strlit4167 (depth = 8)
  int op_slot_right_4166 = gc_frame_newslot(strlit4167);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_4169 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_4169 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4171 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4171 (depth = 8)
  int op_slot_left_4166 = gc_frame_newslot(opresult4171);
  params[0] = strlit4167;
  partcv[0] = 1;
  Object opresult4172 = callmethod(opresult4171, "++(1)", 1, partcv, params);
// compiled op node returning opresult4172 (depth = 7)
  int op_slot_left_4164 = gc_frame_newslot(opresult4172);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4173 = callmethod(opresult4172, "++(1)", 1, partcv, params);
// compiled op node returning opresult4173 (depth = 6)
  int op_slot_left_4161 = gc_frame_newslot(opresult4173);
  params[0] = strlit4162;
  partcv[0] = 1;
  Object opresult4174 = callmethod(opresult4173, "++(1)", 1, partcv, params);
// compiled op node returning opresult4174 (depth = 5)
  *var_s = opresult4174;
  if (opresult4174 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 991
  setline(991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4177 == NULL) {
    strlit4177 = alloc_String("""\x0a""");
    gc_root(strlit4177);
  }
// compiled string node returning strlit4177 (depth = 6)
  int op_slot_right_4176 = gc_frame_newslot(strlit4177);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4180 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4182 = alloc_Float64(2);
// compiled num node returning num4182 (depth = 9)
  int op_slot_right_4181 = gc_frame_newslot(num4182);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_4181 = gc_frame_newslot(*var_depth);
  params[0] = num4182;
  partcv[0] = 1;
  Object sum4184 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4184 (depth = 8)
  gc_frame_newslot(sum4184);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4185 = gc_frame_new();
// call case 4: self request
  Object call4186 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4185);
// compiled member node returning call4186 (depth = 8)
  params[0] = sum4184;
  partcv[0] = 1;
  Object call4187 = callmethodflags(call4186, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4180);
// compiled call node returning call4187 (depth = 7)
  int op_slot_right_4179 = gc_frame_newslot(call4187);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4179 = gc_frame_newslot(*var_s);
  params[0] = call4187;
  partcv[0] = 1;
  Object opresult4189 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4189 (depth = 6)
  int op_slot_left_4176 = gc_frame_newslot(opresult4189);
  params[0] = strlit4177;
  partcv[0] = 1;
  Object opresult4190 = callmethod(opresult4189, "++(1)", 1, partcv, params);
// compiled op node returning opresult4190 (depth = 5)
  *var_s = opresult4190;
  if (opresult4190 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4154 = done;
  } else {
  }
// compiled if node returning if4154 (depth = 3)
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4193 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4194 = gc_frame_new();
// call case 4: self request
  Object call4195 = callmethodflags(self, "isBindingOccurence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4194);
// compiled member node returning call4195 (depth = 5)
  Object call4196 = callmethodflags(call4195, "not", 0, partcv, params, 0);
  gc_frame_end(callframe4193);
// compiled member node returning call4196 (depth = 4)
  Object if4192 = done;
  if (istrue(call4196)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4198 == NULL) {
    strlit4198 = alloc_String("Applied""\x0a""");
    gc_root(strlit4198);
  }
// compiled string node returning strlit4198 (depth = 6)
  int op_slot_right_4197 = gc_frame_newslot(strlit4198);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4200 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4200 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4202 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4202 (depth = 6)
  int op_slot_left_4197 = gc_frame_newslot(opresult4202);
  params[0] = strlit4198;
  partcv[0] = 1;
  Object opresult4203 = callmethod(opresult4202, "++(1)", 1, partcv, params);
// compiled op node returning opresult4203 (depth = 5)
  *var_s = opresult4203;
  if (opresult4203 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4192 = done;
  } else {
  }
// compiled if node returning if4192 (depth = 3)
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4206 = gc_frame_new();
// call case 4: self request
  Object call4207 = callmethodflags(self, "isFresh", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4206);
// compiled member node returning call4207 (depth = 4)
  Object if4205 = done;
  if (istrue(call4207)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4209 == NULL) {
    strlit4209 = alloc_String("Fresh""\x0a""");
    gc_root(strlit4209);
  }
// compiled string node returning strlit4209 (depth = 6)
  int op_slot_right_4208 = gc_frame_newslot(strlit4209);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4211 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4211 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4213 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4213 (depth = 6)
  int op_slot_left_4208 = gc_frame_newslot(opresult4213);
  params[0] = strlit4209;
  partcv[0] = 1;
  Object opresult4214 = callmethod(opresult4213, "++(1)", 1, partcv, params);
// compiled op node returning opresult4214 (depth = 5)
  *var_s = opresult4214;
  if (opresult4214 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4205 = done;
  } else {
  }
// compiled if node returning if4205 (depth = 3)
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4217 == NULL) {
    strlit4217 = alloc_String("Signature:");
    gc_root(strlit4217);
  }
// compiled string node returning strlit4217 (depth = 5)
  int op_slot_right_4216 = gc_frame_newslot(strlit4217);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4219 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4222 == NULL) {
    strlit4222 = alloc_String("");
    gc_root(strlit4222);
  }
// compiled string node returning strlit4222 (depth = 7)
  int op_slot_right_4221 = gc_frame_newslot(strlit4222);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_right_4224 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 8)
  if (strlit4226 == NULL) {
    strlit4226 = alloc_String("");
    gc_root(strlit4226);
  }
// compiled string node returning strlit4226 (depth = 8)
  int op_slot_left_4224 = gc_frame_newslot(strlit4226);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4227 = callmethod(strlit4226, "++(1)", 1, partcv, params);
// compiled op node returning opresult4227 (depth = 7)
  int op_slot_left_4221 = gc_frame_newslot(opresult4227);
  params[0] = strlit4222;
  partcv[0] = 1;
  Object opresult4228 = callmethod(opresult4227, "++(1)", 1, partcv, params);
// compiled op node returning opresult4228 (depth = 6)
  int op_slot_left_4219 = gc_frame_newslot(opresult4228);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4229 = callmethod(opresult4228, "++(1)", 1, partcv, params);
// compiled op node returning opresult4229 (depth = 5)
  int op_slot_left_4216 = gc_frame_newslot(opresult4229);
  params[0] = strlit4217;
  partcv[0] = 1;
  Object opresult4230 = callmethod(opresult4229, "++(1)", 1, partcv, params);
// compiled op node returning opresult4230 (depth = 4)
  *var_s = opresult4230;
  if (opresult4230 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4232 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4233 = gc_frame_new();
// call case 4: self request
  Object call4234 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4233);
// compiled member node returning call4234 (depth = 4)
  gc_frame_newslot(call4234);
// starting to compile block node (depth = 4)
  Object block4235 = alloc_Block(NULL, NULL, "ast", 996);
  gc_frame_newslot(block4235);
// method "_apply(_)"
  block_savedest(block4235);
  Object closure4236 = createclosure(4, "_apply(1)");
  setclosureframe(closure4236, stackframe);
  addtoclosure(closure4236, var_spc);
  addtoclosure(closure4236, var_s);
  addtoclosure(closure4236, var_depth);
  addtoclosure(closure4236, selfslot);
  struct UserObject *uo4236 = (struct UserObject*)block4235;
  uo4236->data[0] = (Object)closure4236;
  Method *meth_meth_ast__apply_40_1_41_4236 = addmethod2pos(block4235, "_apply(1)", &meth_ast__apply_40_1_41_4236, 0);
  int argcv_meth_ast__apply_40_1_41_4236[] = {1};
  meth_meth_ast__apply_40_1_41_4236->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4236);
  meth_meth_ast__apply_40_1_41_4236->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4236->definitionLine = 2981;
// compiled block node returning block4235 (depth = 4)
  gc_frame_newslot(block4235);
// call case 5: prelude request
  params[0] = call4234;
  params[1] = block4235;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4315 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4232);
// compiled call node returning call4315 (depth = 3)
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4317 == NULL) {
    strlit4317 = alloc_String("""\x0a""");
    gc_root(strlit4317);
  }
// compiled string node returning strlit4317 (depth = 5)
  int op_slot_right_4316 = gc_frame_newslot(strlit4317);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_4316 = gc_frame_newslot(*var_s);
  params[0] = strlit4317;
  partcv[0] = 1;
  Object opresult4319 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4319 (depth = 4)
  *var_s = opresult4319;
  if (opresult4319 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4323 = gc_frame_new();
// call case 4: self request
  Object call4324 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4323);
// compiled member node returning call4324 (depth = 5)
  int op_slot_right_4322 = gc_frame_newslot(call4324);
// starting to compile identifier node (depth = 5)
  Object bool4326 = alloc_Boolean(0);
// compiled identifier node returning bool4326 (depth = 5)
  int op_slot_left_4322 = gc_frame_newslot(bool4326);
  params[0] = call4324;
  partcv[0] = 1;
  Object opresult4327 = callmethod(bool4326, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4327 (depth = 4)
  Object if4321 = done;
  if (istrue(opresult4327)) {
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4329 == NULL) {
    strlit4329 = alloc_String("Generics:");
    gc_root(strlit4329);
  }
// compiled string node returning strlit4329 (depth = 6)
  int op_slot_right_4328 = gc_frame_newslot(strlit4329);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4331 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4334 == NULL) {
    strlit4334 = alloc_String("");
    gc_root(strlit4334);
  }
// compiled string node returning strlit4334 (depth = 8)
  int op_slot_right_4333 = gc_frame_newslot(strlit4334);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_4336 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit4338 == NULL) {
    strlit4338 = alloc_String("");
    gc_root(strlit4338);
  }
// compiled string node returning strlit4338 (depth = 9)
  int op_slot_left_4336 = gc_frame_newslot(strlit4338);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4339 = callmethod(strlit4338, "++(1)", 1, partcv, params);
// compiled op node returning opresult4339 (depth = 8)
  int op_slot_left_4333 = gc_frame_newslot(opresult4339);
  params[0] = strlit4334;
  partcv[0] = 1;
  Object opresult4340 = callmethod(opresult4339, "++(1)", 1, partcv, params);
// compiled op node returning opresult4340 (depth = 7)
  int op_slot_left_4331 = gc_frame_newslot(opresult4340);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4341 = callmethod(opresult4340, "++(1)", 1, partcv, params);
// compiled op node returning opresult4341 (depth = 6)
  int op_slot_left_4328 = gc_frame_newslot(opresult4341);
  params[0] = strlit4329;
  partcv[0] = 1;
  Object opresult4342 = callmethod(opresult4341, "++(1)", 1, partcv, params);
// compiled op node returning opresult4342 (depth = 5)
  *var_s = opresult4342;
  if (opresult4342 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4344 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4345 = alloc_Block(NULL, NULL, "ast", 1006);
  gc_frame_newslot(block4345);
// method "_apply(_)"
  block_savedest(block4345);
  Object closure4346 = createclosure(3, "_apply(1)");
  setclosureframe(closure4346, stackframe);
  addtoclosure(closure4346, var_spc);
  addtoclosure(closure4346, var_s);
  addtoclosure(closure4346, selfslot);
  struct UserObject *uo4346 = (struct UserObject*)block4345;
  uo4346->data[0] = (Object)closure4346;
  Method *meth_meth_ast__apply_40_1_41_4346 = addmethod2pos(block4345, "_apply(1)", &meth_ast__apply_40_1_41_4346, 0);
  int argcv_meth_ast__apply_40_1_41_4346[] = {1};
  meth_meth_ast__apply_40_1_41_4346->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4346);
  meth_meth_ast__apply_40_1_41_4346->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4346->definitionLine = 2981;
// compiled block node returning block4345 (depth = 5)
  gc_frame_newslot(block4345);
// call case 6: other requests
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4374 = gc_frame_new();
// call case 4: self request
  Object call4375 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4374);
// compiled member node returning call4375 (depth = 5)
  params[0] = block4345;
  partcv[0] = 1;
  Object call4376 = callmethodflags(call4375, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4344);
// compiled call node returning call4376 (depth = 4)
// Begin line 1009
  setline(1009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4378 == NULL) {
    strlit4378 = alloc_String("""\x0a""");
    gc_root(strlit4378);
  }
// compiled string node returning strlit4378 (depth = 6)
  int op_slot_right_4377 = gc_frame_newslot(strlit4378);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4377 = gc_frame_newslot(*var_s);
  params[0] = strlit4378;
  partcv[0] = 1;
  Object opresult4380 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4380 (depth = 5)
  *var_s = opresult4380;
  if (opresult4380 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4321 = done;
  } else {
  }
// compiled if node returning if4321 (depth = 3)
// Begin line 1011
  setline(1011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4384 = alloc_Float64(0);
// compiled num node returning num4384 (depth = 5)
  int op_slot_right_4383 = gc_frame_newslot(num4384);
// starting to compile member node (depth = 5)
  int callframe4386 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4387 = gc_frame_new();
// call case 4: self request
  Object call4388 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4387);
// compiled member node returning call4388 (depth = 6)
  Object call4389 = callmethodflags(call4388, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4386);
// compiled member node returning call4389 (depth = 5)
  int op_slot_left_4383 = gc_frame_newslot(call4389);
  params[0] = num4384;
  partcv[0] = 1;
  Object opresult4390 = callmethod(call4389, ">(1)", 1, partcv, params);
// compiled op node returning opresult4390 (depth = 4)
  Object if4382 = done;
  if (istrue(opresult4390)) {
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4392 == NULL) {
    strlit4392 = alloc_String("Annotations:");
    gc_root(strlit4392);
  }
// compiled string node returning strlit4392 (depth = 6)
  int op_slot_right_4391 = gc_frame_newslot(strlit4392);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4394 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4397 == NULL) {
    strlit4397 = alloc_String("");
    gc_root(strlit4397);
  }
// compiled string node returning strlit4397 (depth = 8)
  int op_slot_right_4396 = gc_frame_newslot(strlit4397);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_4399 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit4401 == NULL) {
    strlit4401 = alloc_String("");
    gc_root(strlit4401);
  }
// compiled string node returning strlit4401 (depth = 9)
  int op_slot_left_4399 = gc_frame_newslot(strlit4401);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4402 = callmethod(strlit4401, "++(1)", 1, partcv, params);
// compiled op node returning opresult4402 (depth = 8)
  int op_slot_left_4396 = gc_frame_newslot(opresult4402);
  params[0] = strlit4397;
  partcv[0] = 1;
  Object opresult4403 = callmethod(opresult4402, "++(1)", 1, partcv, params);
// compiled op node returning opresult4403 (depth = 7)
  int op_slot_left_4394 = gc_frame_newslot(opresult4403);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4404 = callmethod(opresult4403, "++(1)", 1, partcv, params);
// compiled op node returning opresult4404 (depth = 6)
  int op_slot_left_4391 = gc_frame_newslot(opresult4404);
  params[0] = strlit4392;
  partcv[0] = 1;
  Object opresult4405 = callmethod(opresult4404, "++(1)", 1, partcv, params);
// compiled op node returning opresult4405 (depth = 5)
  *var_s = opresult4405;
  if (opresult4405 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1013
  setline(1013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4407 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4408 = gc_frame_new();
// call case 4: self request
  Object call4409 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4408);
// compiled member node returning call4409 (depth = 5)
  gc_frame_newslot(call4409);
// starting to compile block node (depth = 5)
  Object block4410 = alloc_Block(NULL, NULL, "ast", 1013);
  gc_frame_newslot(block4410);
// method "_apply(_)"
  block_savedest(block4410);
  Object closure4411 = createclosure(4, "_apply(1)");
  setclosureframe(closure4411, stackframe);
  addtoclosure(closure4411, var_depth);
  addtoclosure(closure4411, var_spc);
  addtoclosure(closure4411, var_s);
  addtoclosure(closure4411, selfslot);
  struct UserObject *uo4411 = (struct UserObject*)block4410;
  uo4411->data[0] = (Object)closure4411;
  Method *meth_meth_ast__apply_40_1_41_4411 = addmethod2pos(block4410, "_apply(1)", &meth_ast__apply_40_1_41_4411, 0);
  int argcv_meth_ast__apply_40_1_41_4411[] = {1};
  meth_meth_ast__apply_40_1_41_4411->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4411);
  meth_meth_ast__apply_40_1_41_4411->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4411->definitionLine = 2981;
// compiled block node returning block4410 (depth = 5)
  gc_frame_newslot(block4410);
// call case 5: prelude request
  params[0] = call4409;
  params[1] = block4410;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4442 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4407);
// compiled call node returning call4442 (depth = 4)
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4444 == NULL) {
    strlit4444 = alloc_String("""\x0a""");
    gc_root(strlit4444);
  }
// compiled string node returning strlit4444 (depth = 6)
  int op_slot_right_4443 = gc_frame_newslot(strlit4444);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4443 = gc_frame_newslot(*var_s);
  params[0] = strlit4444;
  partcv[0] = 1;
  Object opresult4446 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4446 (depth = 5)
  *var_s = opresult4446;
  if (opresult4446 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4382 = done;
  } else {
  }
// compiled if node returning if4382 (depth = 3)
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4449 == NULL) {
    strlit4449 = alloc_String("Body:");
    gc_root(strlit4449);
  }
// compiled string node returning strlit4449 (depth = 5)
  int op_slot_right_4448 = gc_frame_newslot(strlit4449);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4451 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4451 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4453 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4453 (depth = 5)
  int op_slot_left_4448 = gc_frame_newslot(opresult4453);
  params[0] = strlit4449;
  partcv[0] = 1;
  Object opresult4454 = callmethod(opresult4453, "++(1)", 1, partcv, params);
// compiled op node returning opresult4454 (depth = 4)
  *var_s = opresult4454;
  if (opresult4454 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1019
  setline(1019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4456 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4457 = gc_frame_new();
// call case 4: self request
  Object call4458 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4457);
// compiled member node returning call4458 (depth = 4)
  gc_frame_newslot(call4458);
// starting to compile block node (depth = 4)
  Object block4459 = alloc_Block(NULL, NULL, "ast", 1019);
  gc_frame_newslot(block4459);
// method "_apply(_)"
  block_savedest(block4459);
  Object closure4460 = createclosure(4, "_apply(1)");
  setclosureframe(closure4460, stackframe);
  addtoclosure(closure4460, var_depth);
  addtoclosure(closure4460, var_spc);
  addtoclosure(closure4460, var_s);
  addtoclosure(closure4460, selfslot);
  struct UserObject *uo4460 = (struct UserObject*)block4459;
  uo4460->data[0] = (Object)closure4460;
  Method *meth_meth_ast__apply_40_1_41_4460 = addmethod2pos(block4459, "_apply(1)", &meth_ast__apply_40_1_41_4460, 0);
  int argcv_meth_ast__apply_40_1_41_4460[] = {1};
  meth_meth_ast__apply_40_1_41_4460->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4460);
  meth_meth_ast__apply_40_1_41_4460->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4460->definitionLine = 2981;
// compiled block node returning block4459 (depth = 4)
  gc_frame_newslot(block4459);
// call case 5: prelude request
  params[0] = call4458;
  params[1] = block4459;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4479 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4456);
// compiled call node returning call4479 (depth = 3)
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4482 = gc_frame_new();
// call case 4: self request
  Object call4483 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4482);
// compiled member node returning call4483 (depth = 5)
  int op_slot_right_4481 = gc_frame_newslot(call4483);
// starting to compile identifier node (depth = 5)
  Object bool4485 = alloc_Boolean(0);
// compiled identifier node returning bool4485 (depth = 5)
  int op_slot_left_4481 = gc_frame_newslot(bool4485);
  params[0] = call4483;
  partcv[0] = 1;
  Object opresult4486 = callmethod(bool4485, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4486 (depth = 4)
  Object if4480 = done;
  if (istrue(opresult4486)) {
// Begin line 1023
  setline(1023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4488 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4490 = alloc_Float64(2);
// compiled num node returning num4490 (depth = 8)
  int op_slot_right_4489 = gc_frame_newslot(num4490);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_4489 = gc_frame_newslot(*var_depth);
  params[0] = num4490;
  partcv[0] = 1;
  Object sum4492 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4492 (depth = 7)
  gc_frame_newslot(sum4492);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4493 = gc_frame_new();
// call case 4: self request
  Object call4494 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4493);
// compiled member node returning call4494 (depth = 7)
  params[0] = sum4492;
  partcv[0] = 1;
  Object call4495 = callmethodflags(call4494, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4488);
// compiled call node returning call4495 (depth = 6)
  int op_slot_right_4487 = gc_frame_newslot(call4495);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4487 = gc_frame_newslot(*var_s);
  params[0] = call4495;
  partcv[0] = 1;
  Object opresult4497 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4497 (depth = 5)
  *var_s = opresult4497;
  if (opresult4497 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4480 = done;
  } else {
  }
// compiled if node returning if4480 (depth = 3)
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_4511(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4513 == NULL) {
    strlit4513 = alloc_String("    ");
    gc_root(strlit4513);
  }
// compiled string node returning strlit4513 (depth = 7)
  int op_slot_right_4512 = gc_frame_newslot(strlit4513);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_4512 = gc_frame_newslot(*var_spc);
  params[0] = strlit4513;
  partcv[0] = 1;
  Object opresult4515 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult4515 (depth = 6)
  *var_spc = opresult4515;
  if (opresult4515 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4535(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe4537 = gc_frame_new();
// call case 4: self request
  Object call4538 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4537);
// compiled member node returning call4538 (depth = 9)
  int op_slot_right_4536 = gc_frame_newslot(call4538);
// starting to compile identifier node (depth = 9)
  Object bool4540 = alloc_Boolean(0);
// compiled identifier node returning bool4540 (depth = 9)
  int op_slot_left_4536 = gc_frame_newslot(bool4540);
  params[0] = call4538;
  partcv[0] = 1;
  Object opresult4541 = callmethod(bool4540, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4541 (depth = 8)
  gc_frame_end(frame);
  return opresult4541;
}
Object meth_ast__apply_40_1_41_4579(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4580 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_pnr (depth = 10)
  gc_frame_newslot(*var_pnr);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe4581 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  Object call4582 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe4581);
// compiled member node returning call4582 (depth = 10)
  params[0] = *var_pnr;
  partcv[0] = 1;
  Object call4583 = callmethodflags(call4582, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4580);
// compiled call node returning call4583 (depth = 9)
  *var_p = call4583;
  if (call4583 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4585 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num4587 = alloc_Float64(1);
// compiled num node returning num4587 (depth = 12)
  int op_slot_right_4586 = gc_frame_newslot(num4587);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_4586 = gc_frame_newslot(*var_depth);
  params[0] = num4587;
  partcv[0] = 1;
  Object sum4589 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4589 (depth = 11)
  gc_frame_newslot(sum4589);
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = sum4589;
  partcv[0] = 1;
  Object call4590 = callmethodflags(*var_p, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4585);
// compiled call node returning call4590 (depth = 10)
  int op_slot_right_4584 = gc_frame_newslot(call4590);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4584 = gc_frame_newslot(*var_s);
  params[0] = call4590;
  partcv[0] = 1;
  Object opresult4592 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4592 (depth = 9)
  *var_s = opresult4592;
  if (opresult4592 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe4596 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 11)
  int callframe4597 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  Object call4598 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe4597);
// compiled member node returning call4598 (depth = 11)
  Object call4599 = callmethodflags(call4598, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4596);
// compiled member node returning call4599 (depth = 10)
  int op_slot_right_4595 = gc_frame_newslot(call4599);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_pnr (depth = 10)
  int op_slot_left_4595 = gc_frame_newslot(*var_pnr);
  params[0] = call4599;
  partcv[0] = 1;
  Object opresult4601 = callmethod(*var_pnr, "<(1)", 1, partcv, params);
// compiled op node returning opresult4601 (depth = 9)
  Object if4594 = done;
  if (istrue(opresult4601)) {
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4603 == NULL) {
    strlit4603 = alloc_String(", ");
    gc_root(strlit4603);
  }
// compiled string node returning strlit4603 (depth = 11)
  int op_slot_right_4602 = gc_frame_newslot(strlit4603);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_4602 = gc_frame_newslot(*var_s);
  params[0] = strlit4603;
  partcv[0] = 1;
  Object opresult4605 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4605 (depth = 10)
  *var_s = opresult4605;
  if (opresult4605 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if4594 = done;
  } else {
  }
// compiled if node returning if4594 (depth = 8)
  gc_frame_end(frame);
  return if4594;
}
Object meth_ast__apply_40_1_41_4525(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_firstPart = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe4527 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  Object call4528 = callmethodflags(*var_part, "name", 0, partcv, params, 0);
  gc_frame_end(callframe4527);
// compiled member node returning call4528 (depth = 7)
  int op_slot_right_4526 = gc_frame_newslot(call4528);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4526 = gc_frame_newslot(*var_s);
  params[0] = call4528;
  partcv[0] = 1;
  Object opresult4530 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4530 (depth = 6)
  *var_s = opresult4530;
  if (opresult4530 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block4534 = alloc_Block(NULL, NULL, "ast", 1036);
  gc_frame_newslot(block4534);
// method "_apply"
  block_savedest(block4534);
  Object closure4535 = createclosure(1, "_apply");
  setclosureframe(closure4535, stackframe);
  addtoclosure(closure4535, selfslot);
  struct UserObject *uo4535 = (struct UserObject*)block4534;
  uo4535->data[0] = (Object)closure4535;
  Method *meth_meth_ast__apply4535 = addmethod2pos(block4534, "_apply", &meth_ast__apply4535, 0);
  int argcv_meth_ast__apply4535[] = {0};
  meth_meth_ast__apply4535->type = alloc_MethodType(1, argcv_meth_ast__apply4535);
  meth_meth_ast__apply4535->definitionModule = modulename;
  meth_meth_ast__apply4535->definitionLine = 2981;
// compiled block node returning block4534 (depth = 7)
  int op_slot_right_4533 = gc_frame_newslot(block4534);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_firstPart (depth = 7)
  int op_slot_left_4533 = gc_frame_newslot(*var_firstPart);
  params[0] = block4534;
  partcv[0] = 1;
  Object opresult4544 = callmethod(*var_firstPart, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4544 (depth = 6)
  Object if4532 = done;
  if (istrue(opresult4544)) {
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4546 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num4548 = alloc_Float64(1);
// compiled num node returning num4548 (depth = 10)
  int op_slot_right_4547 = gc_frame_newslot(num4548);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_4547 = gc_frame_newslot(*var_depth);
  params[0] = num4548;
  partcv[0] = 1;
  Object sum4550 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4550 (depth = 9)
  gc_frame_newslot(sum4550);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4551 = gc_frame_new();
// call case 4: self request
  Object call4552 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4551);
// compiled member node returning call4552 (depth = 9)
  params[0] = sum4550;
  partcv[0] = 1;
  Object call4553 = callmethodflags(call4552, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4546);
// compiled call node returning call4553 (depth = 8)
  int op_slot_right_4545 = gc_frame_newslot(call4553);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4545 = gc_frame_newslot(*var_s);
  params[0] = call4553;
  partcv[0] = 1;
  Object opresult4555 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4555 (depth = 7)
  *var_s = opresult4555;
  if (opresult4555 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if4532 = done;
  } else {
  }
// compiled if node returning if4532 (depth = 5)
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4557 = alloc_Boolean(0);
// compiled identifier node returning bool4557 (depth = 6)
  *var_firstPart = bool4557;
  if (bool4557 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num4561 = alloc_Float64(0);
// compiled num node returning num4561 (depth = 7)
  int op_slot_right_4560 = gc_frame_newslot(num4561);
// starting to compile member node (depth = 7)
  int callframe4563 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4564 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  Object call4565 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe4564);
// compiled member node returning call4565 (depth = 8)
  Object call4566 = callmethodflags(call4565, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4563);
// compiled member node returning call4566 (depth = 7)
  int op_slot_left_4560 = gc_frame_newslot(call4566);
  params[0] = num4561;
  partcv[0] = 1;
  Object opresult4567 = callmethod(call4566, ">(1)", 1, partcv, params);
// compiled op node returning opresult4567 (depth = 6)
  Object if4559 = done;
  if (istrue(opresult4567)) {
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4569 == NULL) {
    strlit4569 = alloc_String("(");
    gc_root(strlit4569);
  }
// compiled string node returning strlit4569 (depth = 8)
  int op_slot_right_4568 = gc_frame_newslot(strlit4569);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4568 = gc_frame_newslot(*var_s);
  params[0] = strlit4569;
  partcv[0] = 1;
  Object opresult4571 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4571 (depth = 7)
  *var_s = opresult4571;
  if (opresult4571 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4573 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe4574 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe4575 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  Object call4576 = callmethodflags(*var_part, "params", 0, partcv, params, 0);
  gc_frame_end(callframe4575);
// compiled member node returning call4576 (depth = 8)
  Object call4577 = callmethodflags(call4576, "indices", 0, partcv, params, 0);
  gc_frame_end(callframe4574);
// compiled member node returning call4577 (depth = 7)
  gc_frame_newslot(call4577);
// starting to compile block node (depth = 7)
  Object block4578 = alloc_Block(NULL, NULL, "ast", 1042);
  gc_frame_newslot(block4578);
// method "_apply(_)"
  block_savedest(block4578);
  Object closure4579 = createclosure(4, "_apply(1)");
  setclosureframe(closure4579, stackframe);
  addtoclosure(closure4579, var_part);
  addtoclosure(closure4579, var_depth);
  addtoclosure(closure4579, var_s);
  addtoclosure(closure4579, selfslot);
  struct UserObject *uo4579 = (struct UserObject*)block4578;
  uo4579->data[0] = (Object)closure4579;
  Method *meth_meth_ast__apply_40_1_41_4579 = addmethod2pos(block4578, "_apply(1)", &meth_ast__apply_40_1_41_4579, 0);
  int argcv_meth_ast__apply_40_1_41_4579[] = {1};
  meth_meth_ast__apply_40_1_41_4579->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4579);
  meth_meth_ast__apply_40_1_41_4579->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4579->definitionLine = 2981;
// compiled block node returning block4578 (depth = 7)
  gc_frame_newslot(block4578);
// call case 5: prelude request
  params[0] = call4577;
  params[1] = block4578;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4608 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4573);
// compiled call node returning call4608 (depth = 6)
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4610 == NULL) {
    strlit4610 = alloc_String(")");
    gc_root(strlit4610);
  }
// compiled string node returning strlit4610 (depth = 8)
  int op_slot_right_4609 = gc_frame_newslot(strlit4610);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4609 = gc_frame_newslot(*var_s);
  params[0] = strlit4610;
  partcv[0] = 1;
  Object opresult4612 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4612 (depth = 7)
  *var_s = opresult4612;
  if (opresult4612 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if4559 = done;
  } else {
  }
// compiled if node returning if4559 (depth = 5)
  gc_frame_end(frame);
  return if4559;
}
Object meth_ast__apply_40_2_41_4657(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4659 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num4660 = alloc_Float64(0);
// compiled num node returning num4660 (depth = 10)
  gc_frame_newslot(num4660);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_b (depth = 10)
  params[0] = num4660;
  partcv[0] = 1;
  Object call4661 = callmethodflags(*var_b, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4659);
// compiled call node returning call4661 (depth = 9)
  int op_slot_right_4658 = gc_frame_newslot(call4661);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4665 == NULL) {
    strlit4665 = alloc_String("");
    gc_root(strlit4665);
  }
// compiled string node returning strlit4665 (depth = 11)
  int op_slot_right_4664 = gc_frame_newslot(strlit4665);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_4664 = gc_frame_newslot(*var_a);
  params[0] = strlit4665;
  partcv[0] = 1;
  Object opresult4667 = callmethod(*var_a, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4667 (depth = 10)
  Object if4663 = done;
struct StackFrameObject *iftmpstackframe4663 = stackframe;
  if (istrue(opresult4667)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4663);
gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4669 == NULL) {
    strlit4669 = alloc_String(", ");
    gc_root(strlit4669);
  }
// compiled string node returning strlit4669 (depth = 11)
  int op_slot_right_4668 = gc_frame_newslot(strlit4669);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_4668 = gc_frame_newslot(*var_a);
  params[0] = strlit4669;
  partcv[0] = 1;
  Object opresult4671 = callmethod(*var_a, "++(1)", 1, partcv, params);
// compiled op node returning opresult4671 (depth = 10)
    gc_frame_newslot(opresult4671);
    if4663 = opresult4671;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe4663);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 10)
  if (strlit4672 == NULL) {
    strlit4672 = alloc_String("");
    gc_root(strlit4672);
  }
// compiled string node returning strlit4672 (depth = 10)
    gc_frame_newslot(strlit4672);
    if4663 = strlit4672;
  }
stackframe = iftmpstackframe4663;
// compiled if node returning if4663 (depth = 9)
  int op_slot_left_4658 = gc_frame_newslot(if4663);
  params[0] = call4661;
  partcv[0] = 1;
  Object opresult4673 = callmethod(if4663, "++(1)", 1, partcv, params);
// compiled op node returning opresult4673 (depth = 8)
  gc_frame_end(frame);
  return opresult4673;
}
Object meth_ast__apply_40_1_41_4710(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1066
  setline(1066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4712 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4714 = alloc_Float64(1);
// compiled num node returning num4714 (depth = 9)
  int op_slot_right_4713 = gc_frame_newslot(num4714);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_4713 = gc_frame_newslot(*var_depth);
  params[0] = num4714;
  partcv[0] = 1;
  Object sum4716 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4716 (depth = 8)
  gc_frame_newslot(sum4716);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum4716;
  partcv[0] = 1;
  Object call4717 = callmethodflags(*var_mx, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4712);
// compiled call node returning call4717 (depth = 7)
  int op_slot_right_4711 = gc_frame_newslot(call4717);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4720 == NULL) {
    strlit4720 = alloc_String("    ");
    gc_root(strlit4720);
  }
// compiled string node returning strlit4720 (depth = 8)
  int op_slot_right_4719 = gc_frame_newslot(strlit4720);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_4722 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4725 == NULL) {
    strlit4725 = alloc_String("""\x0a""");
    gc_root(strlit4725);
  }
// compiled string node returning strlit4725 (depth = 10)
  int op_slot_right_4724 = gc_frame_newslot(strlit4725);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4724 = gc_frame_newslot(*var_s);
  params[0] = strlit4725;
  partcv[0] = 1;
  Object opresult4727 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4727 (depth = 9)
  int op_slot_left_4722 = gc_frame_newslot(opresult4727);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4728 = callmethod(opresult4727, "++(1)", 1, partcv, params);
// compiled op node returning opresult4728 (depth = 8)
  int op_slot_left_4719 = gc_frame_newslot(opresult4728);
  params[0] = strlit4720;
  partcv[0] = 1;
  Object opresult4729 = callmethod(opresult4728, "++(1)", 1, partcv, params);
// compiled op node returning opresult4729 (depth = 7)
  int op_slot_left_4711 = gc_frame_newslot(opresult4729);
  params[0] = call4717;
  partcv[0] = 1;
  Object opresult4730 = callmethod(opresult4729, "++(1)", 1, partcv, params);
// compiled op node returning opresult4730 (depth = 6)
  *var_s = opresult4730;
  if (opresult4730 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_4499(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_firstPart = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "firstPart");
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4500 == NULL) {
    strlit4500 = alloc_String("");
    gc_root(strlit4500);
  }
// compiled string node returning strlit4500 (depth = 4)
  *var_spc = strlit4500;
  if (strlit4500 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1029
  setline(1029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4501 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4504 = alloc_Float64(1);
// compiled num node returning num4504 (depth = 6)
  int op_slot_right_4503 = gc_frame_newslot(num4504);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_4503 = gc_frame_newslot(*var_depth);
  params[0] = num4504;
  partcv[0] = 1;
  Object diff4506 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff4506 (depth = 5)
  int op_slot_right_4502 = gc_frame_newslot(diff4506);
// starting to compile num node (depth = 5)
  Object num4508 = alloc_Float64(0);
// compiled num node returning num4508 (depth = 5)
  int op_slot_left_4502 = gc_frame_newslot(num4508);
  params[0] = diff4506;
  partcv[0] = 1;
  Object opresult4509 = callmethod(num4508, "..(1)", 1, partcv, params);
// compiled op node returning opresult4509 (depth = 4)
  gc_frame_newslot(opresult4509);
// starting to compile block node (depth = 4)
  Object block4510 = alloc_Block(NULL, NULL, "ast", 1029);
  gc_frame_newslot(block4510);
// method "_apply(_)"
  block_savedest(block4510);
  Object closure4511 = createclosure(2, "_apply(1)");
  setclosureframe(closure4511, stackframe);
  addtoclosure(closure4511, var_spc);
  addtoclosure(closure4511, selfslot);
  struct UserObject *uo4511 = (struct UserObject*)block4510;
  uo4511->data[0] = (Object)closure4511;
  Method *meth_meth_ast__apply_40_1_41_4511 = addmethod2pos(block4510, "_apply(1)", &meth_ast__apply_40_1_41_4511, 0);
  int argcv_meth_ast__apply_40_1_41_4511[] = {1};
  meth_meth_ast__apply_40_1_41_4511->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4511);
  meth_meth_ast__apply_40_1_41_4511->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4511->definitionLine = 2981;
// compiled block node returning block4510 (depth = 4)
  gc_frame_newslot(block4510);
// call case 5: prelude request
  params[0] = opresult4509;
  params[1] = block4510;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4518 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4501);
// compiled call node returning call4518 (depth = 3)
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4519 == NULL) {
    strlit4519 = alloc_String("method ");
    gc_root(strlit4519);
  }
// compiled string node returning strlit4519 (depth = 4)
  *var_s = strlit4519;
  if (strlit4519 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool4520 = alloc_Boolean(1);
// compiled identifier node returning bool4520 (depth = 4)
  *var_firstPart = bool4520;
  if (bool4520 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4521 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4522 = gc_frame_new();
// call case 4: self request
  Object call4523 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4522);
// compiled member node returning call4523 (depth = 4)
  gc_frame_newslot(call4523);
// starting to compile block node (depth = 4)
  Object block4524 = alloc_Block(NULL, NULL, "ast", 1034);
  gc_frame_newslot(block4524);
// method "_apply(_)"
  block_savedest(block4524);
  Object closure4525 = createclosure(4, "_apply(1)");
  setclosureframe(closure4525, stackframe);
  addtoclosure(closure4525, var_s);
  addtoclosure(closure4525, var_firstPart);
  addtoclosure(closure4525, var_depth);
  addtoclosure(closure4525, selfslot);
  struct UserObject *uo4525 = (struct UserObject*)block4524;
  uo4525->data[0] = (Object)closure4525;
  Method *meth_meth_ast__apply_40_1_41_4525 = addmethod2pos(block4524, "_apply(1)", &meth_ast__apply_40_1_41_4525, 0);
  int argcv_meth_ast__apply_40_1_41_4525[] = {1};
  meth_meth_ast__apply_40_1_41_4525->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4525);
  meth_meth_ast__apply_40_1_41_4525->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4525->definitionLine = 2981;
// compiled block node returning block4524 (depth = 4)
  gc_frame_newslot(block4524);
// call case 5: prelude request
  params[0] = call4523;
  params[1] = block4524;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4615 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4521);
// compiled call node returning call4615 (depth = 3)
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4618 = gc_frame_new();
// call case 4: self request
  Object call4619 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4618);
// compiled member node returning call4619 (depth = 5)
  int op_slot_right_4617 = gc_frame_newslot(call4619);
// starting to compile identifier node (depth = 5)
  Object bool4621 = alloc_Boolean(0);
// compiled identifier node returning bool4621 (depth = 5)
  int op_slot_left_4617 = gc_frame_newslot(bool4621);
  params[0] = call4619;
  partcv[0] = 1;
  Object opresult4622 = callmethod(bool4621, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4622 (depth = 4)
  Object if4616 = done;
  if (istrue(opresult4622)) {
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4625 == NULL) {
    strlit4625 = alloc_String("");
    gc_root(strlit4625);
  }
// compiled string node returning strlit4625 (depth = 7)
  int op_slot_right_4624 = gc_frame_newslot(strlit4625);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4628 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num4629 = alloc_Float64(0);
// compiled num node returning num4629 (depth = 9)
  gc_frame_newslot(num4629);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe4630 = gc_frame_new();
// call case 4: self request
  Object call4631 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4630);
// compiled member node returning call4631 (depth = 9)
  params[0] = num4629;
  partcv[0] = 1;
  Object call4632 = callmethodflags(call4631, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4628);
// compiled call node returning call4632 (depth = 8)
  int op_slot_right_4627 = gc_frame_newslot(call4632);
// starting to compile string node (depth = 8)
  if (strlit4634 == NULL) {
    strlit4634 = alloc_String(" -> ");
    gc_root(strlit4634);
  }
// compiled string node returning strlit4634 (depth = 8)
  int op_slot_left_4627 = gc_frame_newslot(strlit4634);
  params[0] = call4632;
  partcv[0] = 1;
  Object opresult4635 = callmethod(strlit4634, "++(1)", 1, partcv, params);
// compiled op node returning opresult4635 (depth = 7)
  int op_slot_left_4624 = gc_frame_newslot(opresult4635);
  params[0] = strlit4625;
  partcv[0] = 1;
  Object opresult4636 = callmethod(opresult4635, "++(1)", 1, partcv, params);
// compiled op node returning opresult4636 (depth = 6)
  int op_slot_right_4623 = gc_frame_newslot(opresult4636);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4623 = gc_frame_newslot(*var_s);
  params[0] = opresult4636;
  partcv[0] = 1;
  Object opresult4638 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4638 (depth = 5)
  *var_s = opresult4638;
  if (opresult4638 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4616 = done;
  } else {
  }
// compiled if node returning if4616 (depth = 3)
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4642 = alloc_Float64(0);
// compiled num node returning num4642 (depth = 5)
  int op_slot_right_4641 = gc_frame_newslot(num4642);
// starting to compile member node (depth = 5)
  int callframe4644 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4645 = gc_frame_new();
// call case 4: self request
  Object call4646 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4645);
// compiled member node returning call4646 (depth = 6)
  Object call4647 = callmethodflags(call4646, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4644);
// compiled member node returning call4647 (depth = 5)
  int op_slot_left_4641 = gc_frame_newslot(call4647);
  params[0] = num4642;
  partcv[0] = 1;
  Object opresult4648 = callmethod(call4647, ">(1)", 1, partcv, params);
// compiled op node returning opresult4648 (depth = 4)
  Object if4640 = done;
  if (istrue(opresult4648)) {
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4650 == NULL) {
    strlit4650 = alloc_String(" is ");
    gc_root(strlit4650);
  }
// compiled string node returning strlit4650 (depth = 6)
  int op_slot_right_4649 = gc_frame_newslot(strlit4650);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4649 = gc_frame_newslot(*var_s);
  params[0] = strlit4650;
  partcv[0] = 1;
  Object opresult4652 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4652 (depth = 5)
  *var_s = opresult4652;
  if (opresult4652 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4655 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block4656 = alloc_Block(NULL, NULL, "ast", 1057);
  gc_frame_newslot(block4656);
// method "_apply(_,_)"
  block_savedest(block4656);
  Object closure4657 = createclosure(1, "_apply(2)");
  setclosureframe(closure4657, stackframe);
  addtoclosure(closure4657, selfslot);
  struct UserObject *uo4657 = (struct UserObject*)block4656;
  uo4657->data[0] = (Object)closure4657;
  Method *meth_meth_ast__apply_40_2_41_4657 = addmethod2pos(block4656, "_apply(2)", &meth_ast__apply_40_2_41_4657, 0);
  int argcv_meth_ast__apply_40_2_41_4657[] = {2};
  meth_meth_ast__apply_40_2_41_4657->type = alloc_MethodType(1, argcv_meth_ast__apply_40_2_41_4657);
  meth_meth_ast__apply_40_2_41_4657->definitionModule = modulename;
  meth_meth_ast__apply_40_2_41_4657->definitionLine = 2981;
// compiled block node returning block4656 (depth = 7)
  gc_frame_newslot(block4656);
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit4675 == NULL) {
    strlit4675 = alloc_String("");
    gc_root(strlit4675);
  }
// compiled string node returning strlit4675 (depth = 7)
  gc_frame_newslot(strlit4675);
// call case 6: other requests
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe4676 = gc_frame_new();
// call case 4: self request
  Object call4677 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4676);
// compiled member node returning call4677 (depth = 7)
  params[0] = block4656;
  params[1] = strlit4675;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4678 = callmethodflags(call4677, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4655);
// compiled call node returning call4678 (depth = 6)
  int op_slot_right_4654 = gc_frame_newslot(call4678);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4654 = gc_frame_newslot(*var_s);
  params[0] = call4678;
  partcv[0] = 1;
  Object opresult4680 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4680 (depth = 5)
  *var_s = opresult4680;
  if (opresult4680 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4640 = done;
  } else {
  }
// compiled if node returning if4640 (depth = 3)
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4683 == NULL) {
    strlit4683 = alloc_String(" {");
    gc_root(strlit4683);
  }
// compiled string node returning strlit4683 (depth = 5)
  int op_slot_right_4682 = gc_frame_newslot(strlit4683);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_4682 = gc_frame_newslot(*var_s);
  params[0] = strlit4683;
  partcv[0] = 1;
  Object opresult4685 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4685 (depth = 4)
  *var_s = opresult4685;
  if (opresult4685 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4689 = gc_frame_new();
// call case 4: self request
  Object call4690 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4689);
// compiled member node returning call4690 (depth = 5)
  int op_slot_right_4688 = gc_frame_newslot(call4690);
// starting to compile identifier node (depth = 5)
  Object bool4692 = alloc_Boolean(0);
// compiled identifier node returning bool4692 (depth = 5)
  int op_slot_left_4688 = gc_frame_newslot(bool4692);
  params[0] = call4690;
  partcv[0] = 1;
  Object opresult4693 = callmethod(bool4692, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4693 (depth = 4)
  Object if4687 = done;
  if (istrue(opresult4693)) {
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4695 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4697 = alloc_Float64(1);
// compiled num node returning num4697 (depth = 8)
  int op_slot_right_4696 = gc_frame_newslot(num4697);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_4696 = gc_frame_newslot(*var_depth);
  params[0] = num4697;
  partcv[0] = 1;
  Object sum4699 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum4699 (depth = 7)
  gc_frame_newslot(sum4699);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4700 = gc_frame_new();
// call case 4: self request
  Object call4701 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4700);
// compiled member node returning call4701 (depth = 7)
  params[0] = sum4699;
  partcv[0] = 1;
  Object call4702 = callmethodflags(call4701, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4695);
// compiled call node returning call4702 (depth = 6)
  int op_slot_right_4694 = gc_frame_newslot(call4702);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4694 = gc_frame_newslot(*var_s);
  params[0] = call4702;
  partcv[0] = 1;
  Object opresult4704 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4704 (depth = 5)
  *var_s = opresult4704;
  if (opresult4704 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4687 = done;
  } else {
  }
// compiled if node returning if4687 (depth = 3)
// Begin line 1065
  setline(1065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4706 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4707 = gc_frame_new();
// call case 4: self request
  Object call4708 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4707);
// compiled member node returning call4708 (depth = 4)
  gc_frame_newslot(call4708);
// starting to compile block node (depth = 4)
  Object block4709 = alloc_Block(NULL, NULL, "ast", 1065);
  gc_frame_newslot(block4709);
// method "_apply(_)"
  block_savedest(block4709);
  Object closure4710 = createclosure(4, "_apply(1)");
  setclosureframe(closure4710, stackframe);
  addtoclosure(closure4710, var_depth);
  addtoclosure(closure4710, var_spc);
  addtoclosure(closure4710, var_s);
  addtoclosure(closure4710, selfslot);
  struct UserObject *uo4710 = (struct UserObject*)block4709;
  uo4710->data[0] = (Object)closure4710;
  Method *meth_meth_ast__apply_40_1_41_4710 = addmethod2pos(block4709, "_apply(1)", &meth_ast__apply_40_1_41_4710, 0);
  int argcv_meth_ast__apply_40_1_41_4710[] = {1};
  meth_meth_ast__apply_40_1_41_4710->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4710);
  meth_meth_ast__apply_40_1_41_4710->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4710->definitionLine = 2981;
// compiled block node returning block4709 (depth = 4)
  gc_frame_newslot(block4709);
// call case 5: prelude request
  params[0] = call4708;
  params[1] = block4709;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4733 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4706);
// compiled call node returning call4733 (depth = 3)
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4735 == NULL) {
    strlit4735 = alloc_String("}");
    gc_root(strlit4735);
  }
// compiled string node returning strlit4735 (depth = 5)
  int op_slot_right_4734 = gc_frame_newslot(strlit4735);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4737 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4740 == NULL) {
    strlit4740 = alloc_String("""\x0a""");
    gc_root(strlit4740);
  }
// compiled string node returning strlit4740 (depth = 7)
  int op_slot_right_4739 = gc_frame_newslot(strlit4740);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4739 = gc_frame_newslot(*var_s);
  params[0] = strlit4740;
  partcv[0] = 1;
  Object opresult4742 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult4742 (depth = 6)
  int op_slot_left_4737 = gc_frame_newslot(opresult4742);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4743 = callmethod(opresult4742, "++(1)", 1, partcv, params);
// compiled op node returning opresult4743 (depth = 5)
  int op_slot_left_4734 = gc_frame_newslot(opresult4743);
  params[0] = strlit4735;
  partcv[0] = 1;
  Object opresult4744 = callmethod(opresult4743, "++(1)", 1, partcv, params);
// compiled op node returning opresult4744 (depth = 4)
  *var_s = opresult4744;
  if (opresult4744 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1069
  setline(1069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy4746(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_methodNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1072
  setline(1072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4747 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe4748 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4749 = gc_frame_new();
// call case 4: self request
  Object call4750 = callmethodflags(self, "signature", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4749);
// compiled member node returning call4750 (depth = 5)
  gc_frame_newslot(call4750);
// starting to compile member node (depth = 5)
  int callframe4751 = gc_frame_new();
// call case 4: self request
  Object call4752 = callmethodflags(self, "body", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4751);
// compiled member node returning call4752 (depth = 5)
  gc_frame_newslot(call4752);
// starting to compile member node (depth = 5)
  int callframe4753 = gc_frame_new();
// call case 4: self request
  Object call4754 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4753);
// compiled member node returning call4754 (depth = 5)
  gc_frame_newslot(call4754);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodNode (depth = 5)
  params[0] = call4750;
  params[1] = call4752;
  params[2] = call4754;
  partcv[0] = 3;
  Object call4755 = callmethodflags(*var_methodNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe4748);
// compiled call node returning call4755 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call4756 = callmethodflags(call4755, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4747);
// compiled call node returning call4756 (depth = 3)
  gc_frame_end(frame);
  return call4756;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_4757(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4758 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call4759 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4758);
// compiled call node returning call4759 (depth = 3)
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4760 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4761 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call4762 = callmethodflags(*var_other, "isFresh", 0, partcv, params, 0);
  gc_frame_end(callframe4761);
// compiled member node returning call4762 (depth = 4)
  gc_frame_newslot(call4762);
// call case 4: self request
  params[0] = call4762;
  partcv[0] = 1;
  Object call4763 = callmethodflags(self, "isFresh:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4760);
// compiled call node returning call4763 (depth = 3)
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4764 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4765 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call4766 = callmethodflags(*var_other, "selfclosure", 0, partcv, params, 0);
  gc_frame_end(callframe4765);
// compiled member node returning call4766 (depth = 4)
  gc_frame_newslot(call4766);
// call case 4: self request
  params[0] = call4766;
  partcv[0] = 1;
  Object call4767 = callmethodflags(self, "selfclosure:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4764);
// compiled call node returning call4767 (depth = 3)
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4769 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4770 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  Object call4771 = callmethodflags(*var_other, "isBindingOccurence", 0, partcv, params, 0);
  gc_frame_end(callframe4770);
// compiled member node returning call4771 (depth = 5)
  Object call4772 = callmethodflags(call4771, "not", 0, partcv, params, 0);
  gc_frame_end(callframe4769);
// compiled member node returning call4772 (depth = 4)
  Object if4768 = done;
  if (istrue(call4772)) {
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4773 = gc_frame_new();
// call case 4: self request
  Object call4774 = callmethodflags(self, "appliedOccurence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4773);
// compiled member node returning call4774 (depth = 4)
    gc_frame_newslot(call4774);
    if4768 = call4774;
  } else {
  }
// compiled if node returning if4768 (depth = 3)
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new_40_3_41_3672(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_k = getfromclosure(closure, 2);
  Object *var_methodNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_signature_39_ = &(stackframe->slots[0]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3673 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3673 = alloc_userobj2(52,43, objclass3673);
  gc_frame_newslot(obj3673);
if (objclass3673 == NULL) {
  glfree(obj3673->class->name);
  obj3673->class->name = "methodNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3673, self, 0);
  addmethodreal(obj3673,"outer", &reader_ast_outer_3674);
  Object oldself3673 = self;
  struct StackFrameObject *oldstackframe3673 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3673);
  gc_frame_newslot((Object)stackframe);
  self = obj3673;
  Object *oldselfslot3673 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3673 = (*(struct UserObject *)self).data[0], lowerouter3673 = thisouter3673;
  if (inheritingObject3673) {
    struct UserObject *inho3673 = (struct UserObject *)inheritingObject3673;
    while (inho3673->super != GraceDefaultObject) inho3673 = (struct UserObject *)inho3673->super;
    inho3673->super = obj3673;
    self = inheritingObject3673;
    *selfslot = self;
    lowerouter3673 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3673;
  }
if (objclass3673 == NULL) {
  Method *reader3675 = addmethodrealflags(obj3673, "kind",&reader_ast_kind_3675, MFLAG_DEF);
  reader3675->definitionModule = modulename;
  reader3675->definitionLine = 846;
}
adddatum2(obj3673, alloc_Undefined(), 1);
if (objclass3673 == NULL) {
  Method *reader3676 = addmethodrealflags(obj3673, "signature", &reader_ast_signature_3676, 0);
  Method *writer3676 = addmethodrealflags(obj3673, "signature:=(1)", &writer_ast_signature_3676, 0);
  reader3676->definitionModule = modulename;
  writer3676->definitionModule = modulename;
  reader3676->definitionLine = 847;
  writer3676->definitionLine = 847;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 2);
if (objclass3673 == NULL) {
  Method *reader3677 = addmethodrealflags(obj3673, "body", &reader_ast_body_3677, 0);
  Method *writer3677 = addmethodrealflags(obj3673, "body:=(1)", &writer_ast_body_3677, 0);
  reader3677->definitionModule = modulename;
  writer3677->definitionModule = modulename;
  reader3677->definitionLine = 848;
  writer3677->definitionLine = 848;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 3);
if (objclass3673 == NULL) {
  Method *reader3678 = addmethodrealflags(obj3673, "dtype", &reader_ast_dtype_3678, 0);
  Method *writer3678 = addmethodrealflags(obj3673, "dtype:=(1)", &writer_ast_dtype_3678, 0);
  reader3678->definitionModule = modulename;
  writer3678->definitionModule = modulename;
  reader3678->definitionLine = 849;
  writer3678->definitionLine = 849;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 4);
if (objclass3673 == NULL) {
  Method *reader3679 = addmethodrealflags(obj3673, "typeParams", &reader_ast_typeParams_3679, 0);
  Method *writer3679 = addmethodrealflags(obj3673, "typeParams:=(1)", &writer_ast_typeParams_3679, 0);
  reader3679->definitionModule = modulename;
  writer3679->definitionModule = modulename;
  reader3679->definitionLine = 850;
  writer3679->definitionLine = 850;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 5);
if (objclass3673 == NULL) {
  Method *reader3680 = addmethodrealflags(obj3673, "selfclosure", &reader_ast_selfclosure_3680, 0);
  Method *writer3680 = addmethodrealflags(obj3673, "selfclosure:=(1)", &writer_ast_selfclosure_3680, 0);
  reader3680->definitionModule = modulename;
  writer3680->definitionModule = modulename;
  reader3680->definitionLine = 851;
  writer3680->definitionLine = 851;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 6);
if (objclass3673 == NULL) {
  Method *reader3681 = addmethodrealflags(obj3673, "annotations", &reader_ast_annotations_3681, 0);
  Method *writer3681 = addmethodrealflags(obj3673, "annotations:=(1)", &writer_ast_annotations_3681, 0);
  reader3681->definitionModule = modulename;
  writer3681->definitionModule = modulename;
  reader3681->definitionLine = 852;
  writer3681->definitionLine = 852;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 7);
if (objclass3673 == NULL) {
  Method *reader3682 = addmethodrealflags(obj3673, "isFresh", &reader_ast_isFresh_3682, 0);
  Method *writer3682 = addmethodrealflags(obj3673, "isFresh:=(1)", &writer_ast_isFresh_3682, 0);
  reader3682->definitionModule = modulename;
  writer3682->definitionModule = modulename;
  reader3682->definitionLine = 853;
  writer3682->definitionLine = 853;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 8);
if (objclass3673 == NULL) {
  Method *reader3683 = addmethodrealflags(obj3673, "usesClassSyntax", &reader_ast_usesClassSyntax_3683, 0);
  Method *writer3683 = addmethodrealflags(obj3673, "usesClassSyntax:=(1)", &writer_ast_usesClassSyntax_3683, 0);
  reader3683->definitionModule = modulename;
  writer3683->definitionModule = modulename;
  reader3683->definitionLine = 854;
  writer3683->definitionLine = 854;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 9);
if (objclass3673 == NULL) {
  Method *reader3684 = addmethodrealflags(obj3673, "cachedIdentifier", &reader_ast_cachedIdentifier_3684, MFLAG_CONFIDENTIAL);
  Method *writer3684 = addmethodrealflags(obj3673, "cachedIdentifier:=(1)", &writer_ast_cachedIdentifier_3684, MFLAG_CONFIDENTIAL);
  reader3684->definitionModule = modulename;
  writer3684->definitionModule = modulename;
  reader3684->definitionLine = 855;
  writer3684->definitionLine = 855;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 10);
if (objclass3673 == NULL) {
  Method *reader3685 = addmethodrealflags(obj3673, "isBindingOccurence", &reader_ast_isBindingOccurence_3685, 0);
  Method *writer3685 = addmethodrealflags(obj3673, "isBindingOccurence:=(1)", &writer_ast_isBindingOccurence_3685, MFLAG_CONFIDENTIAL);
  reader3685->definitionModule = modulename;
  writer3685->definitionModule = modulename;
  reader3685->definitionLine = 856;
  writer3685->definitionLine = 856;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 11);
// method "appliedOccurence"
  block_savedest(obj3673);
  Object closure3686 = createclosure(1, "appliedOccurence");
  setclosureframe(closure3686, stackframe);
  addtoclosure(closure3686, var_uninitialized);
  struct UserObject *uo3686 = (struct UserObject*)obj3673;
  uo3686->data[12] = (Object)closure3686;
  Method *meth_meth_ast_appliedOccurence3686 = addmethod2pos(obj3673, "appliedOccurence", &meth_ast_appliedOccurence3686, 12);
  int argcv_meth_ast_appliedOccurence3686[] = {0};
  meth_meth_ast_appliedOccurence3686->type = alloc_MethodType(1, argcv_meth_ast_appliedOccurence3686);
  meth_meth_ast_appliedOccurence3686->definitionModule = modulename;
  meth_meth_ast_appliedOccurence3686->definitionLine = 859;
// method "numParams"
  struct UserObject *uo3701 = (struct UserObject*)obj3673;
  uo3701->data[13] = emptyclosure;
  Method *meth_meth_ast_numParams3701 = addmethod2pos(obj3673, "numParams", &meth_ast_numParams3701, 13);
  int argcv_meth_ast_numParams3701[] = {0};
  meth_meth_ast_numParams3701->type = alloc_MethodType(1, argcv_meth_ast_numParams3701);
  meth_meth_ast_numParams3701->definitionModule = modulename;
  meth_meth_ast_numParams3701->definitionLine = 866;
// method "endPos"
  struct UserObject *uo3715 = (struct UserObject*)obj3673;
  uo3715->data[14] = emptyclosure;
  Method *meth_meth_ast_endPos3715 = addmethod2pos(obj3673, "endPos", &meth_ast_endPos3715, 14);
  int argcv_meth_ast_endPos3715[] = {0};
  meth_meth_ast_endPos3715->type = alloc_MethodType(1, argcv_meth_ast_endPos3715);
  meth_meth_ast_endPos3715->definitionModule = modulename;
  meth_meth_ast_endPos3715->definitionLine = 869;
// method "nameString"
  struct UserObject *uo3733 = (struct UserObject*)obj3673;
  uo3733->data[15] = emptyclosure;
  Method *meth_meth_ast_nameString3733 = addmethod2pos(obj3673, "nameString", &meth_ast_nameString3733, 15);
  int argcv_meth_ast_nameString3733[] = {0};
  meth_meth_ast_nameString3733->type = alloc_MethodType(1, argcv_meth_ast_nameString3733);
  meth_meth_ast_nameString3733->definitionModule = modulename;
  meth_meth_ast_nameString3733->definitionLine = 874;
// method "asIdentifier"
  block_savedest(obj3673);
  Object closure3747 = createclosure(2, "asIdentifier");
  setclosureframe(closure3747, stackframe);
  addtoclosure(closure3747, var_uninitialized);
  addtoclosure(closure3747, var_identifierNode);
  struct UserObject *uo3747 = (struct UserObject*)obj3673;
  uo3747->data[16] = (Object)closure3747;
  Method *meth_meth_ast_asIdentifier3747 = addmethod2pos(obj3673, "asIdentifier", &meth_ast_asIdentifier3747, 16);
  int argcv_meth_ast_asIdentifier3747[] = {0};
  meth_meth_ast_asIdentifier3747->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier3747);
  meth_meth_ast_asIdentifier3747->definitionModule = modulename;
  meth_meth_ast_asIdentifier3747->definitionLine = 878;
// method "value"
  struct UserObject *uo3795 = (struct UserObject*)obj3673;
  uo3795->data[17] = emptyclosure;
  Method *meth_meth_ast_value3795 = addmethod2pos(obj3673, "value", &meth_ast_value3795, 17);
  int argcv_meth_ast_value3795[] = {0};
  meth_meth_ast_value3795->type = alloc_MethodType(1, argcv_meth_ast_value3795);
  meth_meth_ast_value3795->definitionModule = modulename;
  meth_meth_ast_value3795->definitionLine = 888;
// method "canonicalName"
  struct UserObject *uo3798 = (struct UserObject*)obj3673;
  uo3798->data[18] = emptyclosure;
  Method *meth_meth_ast_canonicalName3798 = addmethod2pos(obj3673, "canonicalName", &meth_ast_canonicalName3798, 18);
  int argcv_meth_ast_canonicalName3798[] = {0};
  meth_meth_ast_canonicalName3798->type = alloc_MethodType(1, argcv_meth_ast_canonicalName3798);
  meth_meth_ast_canonicalName3798->definitionModule = modulename;
  meth_meth_ast_canonicalName3798->definitionLine = 889;
// method "hasParams"
  struct UserObject *uo3812 = (struct UserObject*)obj3673;
  uo3812->data[19] = emptyclosure;
  Method *meth_meth_ast_hasParams3812 = addmethod2pos(obj3673, "hasParams", &meth_ast_hasParams3812, 19);
  int argcv_meth_ast_hasParams3812[] = {0};
  meth_meth_ast_hasParams3812->type = alloc_MethodType(1, argcv_meth_ast_hasParams3812);
  meth_meth_ast_hasParams3812->definitionModule = modulename;
  meth_meth_ast_hasParams3812->definitionLine = 893;
// method "numParamLists"
  struct UserObject *uo3823 = (struct UserObject*)obj3673;
  uo3823->data[20] = emptyclosure;
  Method *meth_meth_ast_numParamLists3823 = addmethod2pos(obj3673, "numParamLists", &meth_ast_numParamLists3823, 20);
  int argcv_meth_ast_numParamLists3823[] = {0};
  meth_meth_ast_numParamLists3823->type = alloc_MethodType(1, argcv_meth_ast_numParamLists3823);
  meth_meth_ast_numParamLists3823->definitionModule = modulename;
  meth_meth_ast_numParamLists3823->definitionLine = 894;
// method "hasTypeParams"
  struct UserObject *uo3844 = (struct UserObject*)obj3673;
  uo3844->data[21] = emptyclosure;
  Method *meth_meth_ast_hasTypeParams3844 = addmethod2pos(obj3673, "hasTypeParams", &meth_ast_hasTypeParams3844, 21);
  int argcv_meth_ast_hasTypeParams3844[] = {0};
  meth_meth_ast_hasTypeParams3844->type = alloc_MethodType(1, argcv_meth_ast_hasTypeParams3844);
  meth_meth_ast_hasTypeParams3844->definitionModule = modulename;
  meth_meth_ast_hasTypeParams3844->definitionLine = 902;
// method "isMethod"
  struct UserObject *uo3855 = (struct UserObject*)obj3673;
  uo3855->data[22] = emptyclosure;
  Method *meth_meth_ast_isMethod3855 = addmethod2pos(obj3673, "isMethod", &meth_ast_isMethod3855, 22);
  int argcv_meth_ast_isMethod3855[] = {0};
  meth_meth_ast_isMethod3855->type = alloc_MethodType(1, argcv_meth_ast_isMethod3855);
  meth_meth_ast_isMethod3855->definitionModule = modulename;
  meth_meth_ast_isMethod3855->definitionLine = 903;
// method "isExecutable"
  struct UserObject *uo3857 = (struct UserObject*)obj3673;
  uo3857->data[23] = emptyclosure;
  Method *meth_meth_ast_isExecutable3857 = addmethod2pos(obj3673, "isExecutable", &meth_ast_isExecutable3857, 23);
  int argcv_meth_ast_isExecutable3857[] = {0};
  meth_meth_ast_isExecutable3857->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3857);
  meth_meth_ast_isExecutable3857->definitionModule = modulename;
  meth_meth_ast_isExecutable3857->definitionLine = 904;
// method "isLegalInTrait"
  struct UserObject *uo3859 = (struct UserObject*)obj3673;
  uo3859->data[24] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait3859 = addmethod2pos(obj3673, "isLegalInTrait", &meth_ast_isLegalInTrait3859, 24);
  int argcv_meth_ast_isLegalInTrait3859[] = {0};
  meth_meth_ast_isLegalInTrait3859->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait3859);
  meth_meth_ast_isLegalInTrait3859->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait3859->definitionLine = 905;
// method "isClass"
  struct UserObject *uo3861 = (struct UserObject*)obj3673;
  uo3861->data[25] = emptyclosure;
  Method *meth_meth_ast_isClass3861 = addmethod2pos(obj3673, "isClass", &meth_ast_isClass3861, 25);
  int argcv_meth_ast_isClass3861[] = {0};
  meth_meth_ast_isClass3861->type = alloc_MethodType(1, argcv_meth_ast_isClass3861);
  meth_meth_ast_isClass3861->definitionModule = modulename;
  meth_meth_ast_isClass3861->definitionLine = 906;
// method "isTrait"
  struct UserObject *uo3869 = (struct UserObject*)obj3673;
  uo3869->data[26] = emptyclosure;
  Method *meth_meth_ast_isTrait3869 = addmethod2pos(obj3673, "isTrait", &meth_ast_isTrait3869, 26);
  int argcv_meth_ast_isTrait3869[] = {0};
  meth_meth_ast_isTrait3869->type = alloc_MethodType(1, argcv_meth_ast_isTrait3869);
  meth_meth_ast_isTrait3869->definitionModule = modulename;
  meth_meth_ast_isTrait3869->definitionLine = 907;
// method "needsArgChecks"
  struct UserObject *uo3880 = (struct UserObject*)obj3673;
  uo3880->data[27] = emptyclosure;
  Method *meth_meth_ast_needsArgChecks3880 = addmethod2pos(obj3673, "needsArgChecks", &meth_ast_needsArgChecks3880, 27);
  int argcv_meth_ast_needsArgChecks3880[] = {0};
  meth_meth_ast_needsArgChecks3880->type = alloc_MethodType(1, argcv_meth_ast_needsArgChecks3880);
  meth_meth_ast_needsArgChecks3880->definitionModule = modulename;
  meth_meth_ast_needsArgChecks3880->definitionLine = 914;
// method "scope:=(_)"
  struct UserObject *uo3918 = (struct UserObject*)obj3673;
  uo3918->data[28] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_3918 = addmethod2pos(obj3673, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_3918, 28);
  int argcv_meth_ast_scope_58__61__40_1_41_3918[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_3918->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_3918);
  meth_meth_ast_scope_58__61__40_1_41_3918->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_3918->definitionLine = 925;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj3673);
  Object closure3923 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure3923, stackframe);
  addtoclosure(closure3923, var_k);
  struct UserObject *uo3923 = (struct UserObject*)obj3673;
  uo3923->data[29] = (Object)closure3923;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_3923 = addmethod2pos(obj3673, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_3923, 29);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_3923[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3923->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_3923);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3923->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3923->definitionLine = 931;
// method "isConfidential"
  struct UserObject *uo3926 = (struct UserObject*)obj3673;
  uo3926->data[30] = emptyclosure;
  Method *meth_meth_ast_isConfidential3926 = addmethod2pos(obj3673, "isConfidential", &meth_ast_isConfidential3926, 30);
  int argcv_meth_ast_isConfidential3926[] = {0};
  meth_meth_ast_isConfidential3926->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3926);
  meth_meth_ast_isConfidential3926->definitionModule = modulename;
  meth_meth_ast_isConfidential3926->definitionLine = 932;
// method "isPublic"
  struct UserObject *uo3944 = (struct UserObject*)obj3673;
  uo3944->data[31] = emptyclosure;
  Method *meth_meth_ast_isPublic3944 = addmethod2pos(obj3673, "isPublic", &meth_ast_isPublic3944, 31);
  int argcv_meth_ast_isPublic3944[] = {0};
  meth_meth_ast_isPublic3944->type = alloc_MethodType(1, argcv_meth_ast_isPublic3944);
  meth_meth_ast_isPublic3944->definitionModule = modulename;
  meth_meth_ast_isPublic3944->definitionLine = 936;
// method "isWritable"
  struct UserObject *uo3949 = (struct UserObject*)obj3673;
  uo3949->data[32] = emptyclosure;
  Method *meth_meth_ast_isWritable3949 = addmethod2pos(obj3673, "isWritable", &meth_ast_isWritable3949, 32);
  int argcv_meth_ast_isWritable3949[] = {0};
  meth_meth_ast_isWritable3949->type = alloc_MethodType(1, argcv_meth_ast_isWritable3949);
  meth_meth_ast_isWritable3949->definitionModule = modulename;
  meth_meth_ast_isWritable3949->definitionLine = 937;
// method "isReadable"
  struct UserObject *uo3951 = (struct UserObject*)obj3673;
  uo3951->data[33] = emptyclosure;
  Method *meth_meth_ast_isReadable3951 = addmethod2pos(obj3673, "isReadable", &meth_ast_isReadable3951, 33);
  int argcv_meth_ast_isReadable3951[] = {0};
  meth_meth_ast_isReadable3951->type = alloc_MethodType(1, argcv_meth_ast_isReadable3951);
  meth_meth_ast_isReadable3951->definitionModule = modulename;
  meth_meth_ast_isReadable3951->definitionLine = 938;
// method "usesAsType(_)"
  struct UserObject *uo3954 = (struct UserObject*)obj3673;
  uo3954->data[34] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_3954 = addmethod2pos(obj3673, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_3954, 34);
  int argcv_meth_ast_usesAsType_40_1_41_3954[] = {1};
  meth_meth_ast_usesAsType_40_1_41_3954->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_3954);
  meth_meth_ast_usesAsType_40_1_41_3954->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_3954->definitionLine = 939;
// method "returnsObject"
  struct UserObject *uo3960 = (struct UserObject*)obj3673;
  uo3960->data[35] = emptyclosure;
  Method *meth_meth_ast_returnsObject3960 = addmethod2pos(obj3673, "returnsObject", &meth_ast_returnsObject3960, 35);
  int argcv_meth_ast_returnsObject3960[] = {0};
  meth_meth_ast_returnsObject3960->type = alloc_MethodType(1, argcv_meth_ast_returnsObject3960);
  meth_meth_ast_returnsObject3960->definitionModule = modulename;
  meth_meth_ast_returnsObject3960->definitionLine = 942;
// method "returnedObjectScope"
  struct UserObject *uo3979 = (struct UserObject*)obj3673;
  uo3979->data[36] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope3979 = addmethod2pos(obj3673, "returnedObjectScope", &meth_ast_returnedObjectScope3979, 36);
  int argcv_meth_ast_returnedObjectScope3979[] = {0};
  meth_meth_ast_returnedObjectScope3979->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope3979);
  meth_meth_ast_returnedObjectScope3979->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope3979->definitionLine = 945;
// method "accept(_)from(_)"
  struct UserObject *uo3986 = (struct UserObject*)obj3673;
  uo3986->data[37] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_3986 = addmethod2pos(obj3673, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_3986, 37);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_3986[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_3986->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_3986);
  meth_meth_ast_accept_40_1_41_from_40_1_41_3986->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_3986->definitionLine = 949;
// method "map(_)ancestors(_)"
  struct UserObject *uo4052 = (struct UserObject*)obj3673;
  uo4052->data[38] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_4052 = addmethod2pos(obj3673, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_4052, 38);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_4052[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4052->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_4052);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4052->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4052->definitionLine = 972;
// method "pretty(_)"
  struct UserObject *uo4109 = (struct UserObject*)obj3673;
  uo4109->data[39] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_4109 = addmethod2pos(obj3673, "pretty(1)", &meth_ast_pretty_40_1_41_4109, 39);
  int argcv_meth_ast_pretty_40_1_41_4109[] = {1};
  meth_meth_ast_pretty_40_1_41_4109->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_4109);
  meth_meth_ast_pretty_40_1_41_4109->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_4109->definitionLine = 982;
// method "toGrace(_)"
  struct UserObject *uo4499 = (struct UserObject*)obj3673;
  uo4499->data[40] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_4499 = addmethod2pos(obj3673, "toGrace(1)", &meth_ast_toGrace_40_1_41_4499, 40);
  int argcv_meth_ast_toGrace_40_1_41_4499[] = {1};
  meth_meth_ast_toGrace_40_1_41_4499->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_4499);
meth_meth_ast_toGrace_40_1_41_4499->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_4499->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_4499->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_4499->definitionLine = 1027;
// method "shallowCopy"
  block_savedest(obj3673);
  Object closure4746 = createclosure(1, "shallowCopy");
  setclosureframe(closure4746, stackframe);
  addtoclosure(closure4746, var_methodNode);
  struct UserObject *uo4746 = (struct UserObject*)obj3673;
  uo4746->data[41] = (Object)closure4746;
  Method *meth_meth_ast_shallowCopy4746 = addmethod2pos(obj3673, "shallowCopy", &meth_ast_shallowCopy4746, 41);
  int argcv_meth_ast_shallowCopy4746[] = {0};
  meth_meth_ast_shallowCopy4746->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy4746);
  meth_meth_ast_shallowCopy4746->definitionModule = modulename;
  meth_meth_ast_shallowCopy4746->definitionLine = 1071;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo4757 = (struct UserObject*)obj3673;
  uo4757->data[42] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_4757 = addmethod2pos(obj3673, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_4757, 42);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_4757[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_4757->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_4757);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_4757->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_4757->definitionLine = 1074;
  sourceObject = obj3673;
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4775 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4776 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4777 = gc_frame_new();
// call case 3: self.outer request
  Object call4778 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4777);
// compiled member node returning call4778 (depth = 5)
  Object call4779 = callmethodflags(call4778, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4776);
// compiled member node returning call4779 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4780 = callmethodflags(call4779, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4775);
// compiled call node returning call4780 (depth = 3)
  struct UserObject *obj3673_uo = (struct UserObject *)obj3673;
  obj3673_uo->super = call4780;
  sourceObject = obj3673;
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit4781 == NULL) {
    strlit4781 = alloc_String("method");
    gc_root(strlit4781);
  }
// compiled string node returning strlit4781 (depth = 3)
  adddatum2(obj3673, strlit4781, 1);
  sourceObject = obj3673;
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj3673, *var_signature_39_, 2);
  sourceObject = obj3673;
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj3673, *var_body_39_, 3);
  sourceObject = obj3673;
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj3673, *var_dtype_39_, 4);
  sourceObject = obj3673;
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4782 = alloc_Boolean(0);
// compiled identifier node returning bool4782 (depth = 3)
  adddatum2(obj3673, bool4782, 5);
  sourceObject = obj3673;
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4783 = alloc_Boolean(0);
// compiled identifier node returning bool4783 (depth = 3)
  adddatum2(obj3673, bool4783, 6);
  sourceObject = obj3673;
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array4784 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4784 (depth = 3)
  adddatum2(obj3673, array4784, 7);
  sourceObject = obj3673;
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4785 = alloc_Boolean(0);
// compiled identifier node returning bool4785 (depth = 3)
  adddatum2(obj3673, bool4785, 8);
  sourceObject = obj3673;
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4786 = alloc_Boolean(0);
// compiled identifier node returning bool4786 (depth = 3)
  adddatum2(obj3673, bool4786, 9);
  sourceObject = obj3673;
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_uninitialized (depth = 3)
  adddatum2(obj3673, *var_uninitialized, 10);
  sourceObject = obj3673;
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4787 = alloc_Boolean(1);
// compiled identifier node returning bool4787 (depth = 3)
  adddatum2(obj3673, bool4787, 11);
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  objclass3673 = obj3673->class;
  objclass3673->definitionModule = modulename;
  objclass3673->definitionLine = 838;
  (*(struct UserObject *)self).data[0] = lowerouter3673;
  self = oldself3673;
  selfslot = oldselfslot3673;
  stackframe = oldstackframe3673;
  gc_frame_end(frame);
  return obj3673;
}
Object meth_ast_new_40_3_41_3672_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_uninitialized = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_k = getfromclosure(closure, 2);
  Object *var_methodNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_signature_39_ = &(stackframe->slots[0]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3673 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3673 = alloc_userobj2(52,43, objclass3673);
  gc_frame_newslot(obj3673);
if (objclass3673 == NULL) {
  glfree(obj3673->class->name);
  obj3673->class->name = "methodNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3673, self, 0);
  addmethodreal(obj3673,"outer", &reader_ast_outer_3674);
  Object oldself3673 = self;
  struct StackFrameObject *oldstackframe3673 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3673);
  gc_frame_newslot((Object)stackframe);
  self = obj3673;
  Object *oldselfslot3673 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3673 = (*(struct UserObject *)self).data[0], lowerouter3673 = thisouter3673;
  if (inheritingObject3673) {
    struct UserObject *inho3673 = (struct UserObject *)inheritingObject3673;
    while (inho3673->super != GraceDefaultObject) inho3673 = (struct UserObject *)inho3673->super;
    inho3673->super = obj3673;
    self = inheritingObject3673;
    *selfslot = self;
    lowerouter3673 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3673;
  }
if (objclass3673 == NULL) {
  Method *reader3675 = addmethodrealflags(obj3673, "kind",&reader_ast_kind_3675, MFLAG_DEF);
  reader3675->definitionModule = modulename;
  reader3675->definitionLine = 846;
}
adddatum2(obj3673, alloc_Undefined(), 1);
if (objclass3673 == NULL) {
  Method *reader3676 = addmethodrealflags(obj3673, "signature", &reader_ast_signature_3676, 0);
  Method *writer3676 = addmethodrealflags(obj3673, "signature:=(1)", &writer_ast_signature_3676, 0);
  reader3676->definitionModule = modulename;
  writer3676->definitionModule = modulename;
  reader3676->definitionLine = 847;
  writer3676->definitionLine = 847;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 2);
if (objclass3673 == NULL) {
  Method *reader3677 = addmethodrealflags(obj3673, "body", &reader_ast_body_3677, 0);
  Method *writer3677 = addmethodrealflags(obj3673, "body:=(1)", &writer_ast_body_3677, 0);
  reader3677->definitionModule = modulename;
  writer3677->definitionModule = modulename;
  reader3677->definitionLine = 848;
  writer3677->definitionLine = 848;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 3);
if (objclass3673 == NULL) {
  Method *reader3678 = addmethodrealflags(obj3673, "dtype", &reader_ast_dtype_3678, 0);
  Method *writer3678 = addmethodrealflags(obj3673, "dtype:=(1)", &writer_ast_dtype_3678, 0);
  reader3678->definitionModule = modulename;
  writer3678->definitionModule = modulename;
  reader3678->definitionLine = 849;
  writer3678->definitionLine = 849;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 4);
if (objclass3673 == NULL) {
  Method *reader3679 = addmethodrealflags(obj3673, "typeParams", &reader_ast_typeParams_3679, 0);
  Method *writer3679 = addmethodrealflags(obj3673, "typeParams:=(1)", &writer_ast_typeParams_3679, 0);
  reader3679->definitionModule = modulename;
  writer3679->definitionModule = modulename;
  reader3679->definitionLine = 850;
  writer3679->definitionLine = 850;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 5);
if (objclass3673 == NULL) {
  Method *reader3680 = addmethodrealflags(obj3673, "selfclosure", &reader_ast_selfclosure_3680, 0);
  Method *writer3680 = addmethodrealflags(obj3673, "selfclosure:=(1)", &writer_ast_selfclosure_3680, 0);
  reader3680->definitionModule = modulename;
  writer3680->definitionModule = modulename;
  reader3680->definitionLine = 851;
  writer3680->definitionLine = 851;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 6);
if (objclass3673 == NULL) {
  Method *reader3681 = addmethodrealflags(obj3673, "annotations", &reader_ast_annotations_3681, 0);
  Method *writer3681 = addmethodrealflags(obj3673, "annotations:=(1)", &writer_ast_annotations_3681, 0);
  reader3681->definitionModule = modulename;
  writer3681->definitionModule = modulename;
  reader3681->definitionLine = 852;
  writer3681->definitionLine = 852;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 7);
if (objclass3673 == NULL) {
  Method *reader3682 = addmethodrealflags(obj3673, "isFresh", &reader_ast_isFresh_3682, 0);
  Method *writer3682 = addmethodrealflags(obj3673, "isFresh:=(1)", &writer_ast_isFresh_3682, 0);
  reader3682->definitionModule = modulename;
  writer3682->definitionModule = modulename;
  reader3682->definitionLine = 853;
  writer3682->definitionLine = 853;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 8);
if (objclass3673 == NULL) {
  Method *reader3683 = addmethodrealflags(obj3673, "usesClassSyntax", &reader_ast_usesClassSyntax_3683, 0);
  Method *writer3683 = addmethodrealflags(obj3673, "usesClassSyntax:=(1)", &writer_ast_usesClassSyntax_3683, 0);
  reader3683->definitionModule = modulename;
  writer3683->definitionModule = modulename;
  reader3683->definitionLine = 854;
  writer3683->definitionLine = 854;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 9);
if (objclass3673 == NULL) {
  Method *reader3684 = addmethodrealflags(obj3673, "cachedIdentifier", &reader_ast_cachedIdentifier_3684, MFLAG_CONFIDENTIAL);
  Method *writer3684 = addmethodrealflags(obj3673, "cachedIdentifier:=(1)", &writer_ast_cachedIdentifier_3684, MFLAG_CONFIDENTIAL);
  reader3684->definitionModule = modulename;
  writer3684->definitionModule = modulename;
  reader3684->definitionLine = 855;
  writer3684->definitionLine = 855;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 10);
if (objclass3673 == NULL) {
  Method *reader3685 = addmethodrealflags(obj3673, "isBindingOccurence", &reader_ast_isBindingOccurence_3685, 0);
  Method *writer3685 = addmethodrealflags(obj3673, "isBindingOccurence:=(1)", &writer_ast_isBindingOccurence_3685, MFLAG_CONFIDENTIAL);
  reader3685->definitionModule = modulename;
  writer3685->definitionModule = modulename;
  reader3685->definitionLine = 856;
  writer3685->definitionLine = 856;
}
obj3673->flags |= OFLAG_MUTABLE;
adddatum2(obj3673, alloc_Undefined(), 11);
// method "appliedOccurence"
  block_savedest(obj3673);
  Object closure3686 = createclosure(1, "appliedOccurence");
  setclosureframe(closure3686, stackframe);
  addtoclosure(closure3686, var_uninitialized);
  struct UserObject *uo3686 = (struct UserObject*)obj3673;
  uo3686->data[12] = (Object)closure3686;
  Method *meth_meth_ast_appliedOccurence3686 = addmethod2pos(obj3673, "appliedOccurence", &meth_ast_appliedOccurence3686, 12);
  int argcv_meth_ast_appliedOccurence3686[] = {0};
  meth_meth_ast_appliedOccurence3686->type = alloc_MethodType(1, argcv_meth_ast_appliedOccurence3686);
  meth_meth_ast_appliedOccurence3686->definitionModule = modulename;
  meth_meth_ast_appliedOccurence3686->definitionLine = 859;
// method "numParams"
  struct UserObject *uo3701 = (struct UserObject*)obj3673;
  uo3701->data[13] = emptyclosure;
  Method *meth_meth_ast_numParams3701 = addmethod2pos(obj3673, "numParams", &meth_ast_numParams3701, 13);
  int argcv_meth_ast_numParams3701[] = {0};
  meth_meth_ast_numParams3701->type = alloc_MethodType(1, argcv_meth_ast_numParams3701);
  meth_meth_ast_numParams3701->definitionModule = modulename;
  meth_meth_ast_numParams3701->definitionLine = 866;
// method "endPos"
  struct UserObject *uo3715 = (struct UserObject*)obj3673;
  uo3715->data[14] = emptyclosure;
  Method *meth_meth_ast_endPos3715 = addmethod2pos(obj3673, "endPos", &meth_ast_endPos3715, 14);
  int argcv_meth_ast_endPos3715[] = {0};
  meth_meth_ast_endPos3715->type = alloc_MethodType(1, argcv_meth_ast_endPos3715);
  meth_meth_ast_endPos3715->definitionModule = modulename;
  meth_meth_ast_endPos3715->definitionLine = 869;
// method "nameString"
  struct UserObject *uo3733 = (struct UserObject*)obj3673;
  uo3733->data[15] = emptyclosure;
  Method *meth_meth_ast_nameString3733 = addmethod2pos(obj3673, "nameString", &meth_ast_nameString3733, 15);
  int argcv_meth_ast_nameString3733[] = {0};
  meth_meth_ast_nameString3733->type = alloc_MethodType(1, argcv_meth_ast_nameString3733);
  meth_meth_ast_nameString3733->definitionModule = modulename;
  meth_meth_ast_nameString3733->definitionLine = 874;
// method "asIdentifier"
  block_savedest(obj3673);
  Object closure3747 = createclosure(2, "asIdentifier");
  setclosureframe(closure3747, stackframe);
  addtoclosure(closure3747, var_uninitialized);
  addtoclosure(closure3747, var_identifierNode);
  struct UserObject *uo3747 = (struct UserObject*)obj3673;
  uo3747->data[16] = (Object)closure3747;
  Method *meth_meth_ast_asIdentifier3747 = addmethod2pos(obj3673, "asIdentifier", &meth_ast_asIdentifier3747, 16);
  int argcv_meth_ast_asIdentifier3747[] = {0};
  meth_meth_ast_asIdentifier3747->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier3747);
  meth_meth_ast_asIdentifier3747->definitionModule = modulename;
  meth_meth_ast_asIdentifier3747->definitionLine = 878;
// method "value"
  struct UserObject *uo3795 = (struct UserObject*)obj3673;
  uo3795->data[17] = emptyclosure;
  Method *meth_meth_ast_value3795 = addmethod2pos(obj3673, "value", &meth_ast_value3795, 17);
  int argcv_meth_ast_value3795[] = {0};
  meth_meth_ast_value3795->type = alloc_MethodType(1, argcv_meth_ast_value3795);
  meth_meth_ast_value3795->definitionModule = modulename;
  meth_meth_ast_value3795->definitionLine = 888;
// method "canonicalName"
  struct UserObject *uo3798 = (struct UserObject*)obj3673;
  uo3798->data[18] = emptyclosure;
  Method *meth_meth_ast_canonicalName3798 = addmethod2pos(obj3673, "canonicalName", &meth_ast_canonicalName3798, 18);
  int argcv_meth_ast_canonicalName3798[] = {0};
  meth_meth_ast_canonicalName3798->type = alloc_MethodType(1, argcv_meth_ast_canonicalName3798);
  meth_meth_ast_canonicalName3798->definitionModule = modulename;
  meth_meth_ast_canonicalName3798->definitionLine = 889;
// method "hasParams"
  struct UserObject *uo3812 = (struct UserObject*)obj3673;
  uo3812->data[19] = emptyclosure;
  Method *meth_meth_ast_hasParams3812 = addmethod2pos(obj3673, "hasParams", &meth_ast_hasParams3812, 19);
  int argcv_meth_ast_hasParams3812[] = {0};
  meth_meth_ast_hasParams3812->type = alloc_MethodType(1, argcv_meth_ast_hasParams3812);
  meth_meth_ast_hasParams3812->definitionModule = modulename;
  meth_meth_ast_hasParams3812->definitionLine = 893;
// method "numParamLists"
  struct UserObject *uo3823 = (struct UserObject*)obj3673;
  uo3823->data[20] = emptyclosure;
  Method *meth_meth_ast_numParamLists3823 = addmethod2pos(obj3673, "numParamLists", &meth_ast_numParamLists3823, 20);
  int argcv_meth_ast_numParamLists3823[] = {0};
  meth_meth_ast_numParamLists3823->type = alloc_MethodType(1, argcv_meth_ast_numParamLists3823);
  meth_meth_ast_numParamLists3823->definitionModule = modulename;
  meth_meth_ast_numParamLists3823->definitionLine = 894;
// method "hasTypeParams"
  struct UserObject *uo3844 = (struct UserObject*)obj3673;
  uo3844->data[21] = emptyclosure;
  Method *meth_meth_ast_hasTypeParams3844 = addmethod2pos(obj3673, "hasTypeParams", &meth_ast_hasTypeParams3844, 21);
  int argcv_meth_ast_hasTypeParams3844[] = {0};
  meth_meth_ast_hasTypeParams3844->type = alloc_MethodType(1, argcv_meth_ast_hasTypeParams3844);
  meth_meth_ast_hasTypeParams3844->definitionModule = modulename;
  meth_meth_ast_hasTypeParams3844->definitionLine = 902;
// method "isMethod"
  struct UserObject *uo3855 = (struct UserObject*)obj3673;
  uo3855->data[22] = emptyclosure;
  Method *meth_meth_ast_isMethod3855 = addmethod2pos(obj3673, "isMethod", &meth_ast_isMethod3855, 22);
  int argcv_meth_ast_isMethod3855[] = {0};
  meth_meth_ast_isMethod3855->type = alloc_MethodType(1, argcv_meth_ast_isMethod3855);
  meth_meth_ast_isMethod3855->definitionModule = modulename;
  meth_meth_ast_isMethod3855->definitionLine = 903;
// method "isExecutable"
  struct UserObject *uo3857 = (struct UserObject*)obj3673;
  uo3857->data[23] = emptyclosure;
  Method *meth_meth_ast_isExecutable3857 = addmethod2pos(obj3673, "isExecutable", &meth_ast_isExecutable3857, 23);
  int argcv_meth_ast_isExecutable3857[] = {0};
  meth_meth_ast_isExecutable3857->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3857);
  meth_meth_ast_isExecutable3857->definitionModule = modulename;
  meth_meth_ast_isExecutable3857->definitionLine = 904;
// method "isLegalInTrait"
  struct UserObject *uo3859 = (struct UserObject*)obj3673;
  uo3859->data[24] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait3859 = addmethod2pos(obj3673, "isLegalInTrait", &meth_ast_isLegalInTrait3859, 24);
  int argcv_meth_ast_isLegalInTrait3859[] = {0};
  meth_meth_ast_isLegalInTrait3859->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait3859);
  meth_meth_ast_isLegalInTrait3859->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait3859->definitionLine = 905;
// method "isClass"
  struct UserObject *uo3861 = (struct UserObject*)obj3673;
  uo3861->data[25] = emptyclosure;
  Method *meth_meth_ast_isClass3861 = addmethod2pos(obj3673, "isClass", &meth_ast_isClass3861, 25);
  int argcv_meth_ast_isClass3861[] = {0};
  meth_meth_ast_isClass3861->type = alloc_MethodType(1, argcv_meth_ast_isClass3861);
  meth_meth_ast_isClass3861->definitionModule = modulename;
  meth_meth_ast_isClass3861->definitionLine = 906;
// method "isTrait"
  struct UserObject *uo3869 = (struct UserObject*)obj3673;
  uo3869->data[26] = emptyclosure;
  Method *meth_meth_ast_isTrait3869 = addmethod2pos(obj3673, "isTrait", &meth_ast_isTrait3869, 26);
  int argcv_meth_ast_isTrait3869[] = {0};
  meth_meth_ast_isTrait3869->type = alloc_MethodType(1, argcv_meth_ast_isTrait3869);
  meth_meth_ast_isTrait3869->definitionModule = modulename;
  meth_meth_ast_isTrait3869->definitionLine = 907;
// method "needsArgChecks"
  struct UserObject *uo3880 = (struct UserObject*)obj3673;
  uo3880->data[27] = emptyclosure;
  Method *meth_meth_ast_needsArgChecks3880 = addmethod2pos(obj3673, "needsArgChecks", &meth_ast_needsArgChecks3880, 27);
  int argcv_meth_ast_needsArgChecks3880[] = {0};
  meth_meth_ast_needsArgChecks3880->type = alloc_MethodType(1, argcv_meth_ast_needsArgChecks3880);
  meth_meth_ast_needsArgChecks3880->definitionModule = modulename;
  meth_meth_ast_needsArgChecks3880->definitionLine = 914;
// method "scope:=(_)"
  struct UserObject *uo3918 = (struct UserObject*)obj3673;
  uo3918->data[28] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_3918 = addmethod2pos(obj3673, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_3918, 28);
  int argcv_meth_ast_scope_58__61__40_1_41_3918[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_3918->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_3918);
  meth_meth_ast_scope_58__61__40_1_41_3918->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_3918->definitionLine = 925;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj3673);
  Object closure3923 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure3923, stackframe);
  addtoclosure(closure3923, var_k);
  struct UserObject *uo3923 = (struct UserObject*)obj3673;
  uo3923->data[29] = (Object)closure3923;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_3923 = addmethod2pos(obj3673, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_3923, 29);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_3923[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3923->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_3923);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3923->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_3923->definitionLine = 931;
// method "isConfidential"
  struct UserObject *uo3926 = (struct UserObject*)obj3673;
  uo3926->data[30] = emptyclosure;
  Method *meth_meth_ast_isConfidential3926 = addmethod2pos(obj3673, "isConfidential", &meth_ast_isConfidential3926, 30);
  int argcv_meth_ast_isConfidential3926[] = {0};
  meth_meth_ast_isConfidential3926->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3926);
  meth_meth_ast_isConfidential3926->definitionModule = modulename;
  meth_meth_ast_isConfidential3926->definitionLine = 932;
// method "isPublic"
  struct UserObject *uo3944 = (struct UserObject*)obj3673;
  uo3944->data[31] = emptyclosure;
  Method *meth_meth_ast_isPublic3944 = addmethod2pos(obj3673, "isPublic", &meth_ast_isPublic3944, 31);
  int argcv_meth_ast_isPublic3944[] = {0};
  meth_meth_ast_isPublic3944->type = alloc_MethodType(1, argcv_meth_ast_isPublic3944);
  meth_meth_ast_isPublic3944->definitionModule = modulename;
  meth_meth_ast_isPublic3944->definitionLine = 936;
// method "isWritable"
  struct UserObject *uo3949 = (struct UserObject*)obj3673;
  uo3949->data[32] = emptyclosure;
  Method *meth_meth_ast_isWritable3949 = addmethod2pos(obj3673, "isWritable", &meth_ast_isWritable3949, 32);
  int argcv_meth_ast_isWritable3949[] = {0};
  meth_meth_ast_isWritable3949->type = alloc_MethodType(1, argcv_meth_ast_isWritable3949);
  meth_meth_ast_isWritable3949->definitionModule = modulename;
  meth_meth_ast_isWritable3949->definitionLine = 937;
// method "isReadable"
  struct UserObject *uo3951 = (struct UserObject*)obj3673;
  uo3951->data[33] = emptyclosure;
  Method *meth_meth_ast_isReadable3951 = addmethod2pos(obj3673, "isReadable", &meth_ast_isReadable3951, 33);
  int argcv_meth_ast_isReadable3951[] = {0};
  meth_meth_ast_isReadable3951->type = alloc_MethodType(1, argcv_meth_ast_isReadable3951);
  meth_meth_ast_isReadable3951->definitionModule = modulename;
  meth_meth_ast_isReadable3951->definitionLine = 938;
// method "usesAsType(_)"
  struct UserObject *uo3954 = (struct UserObject*)obj3673;
  uo3954->data[34] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_3954 = addmethod2pos(obj3673, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_3954, 34);
  int argcv_meth_ast_usesAsType_40_1_41_3954[] = {1};
  meth_meth_ast_usesAsType_40_1_41_3954->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_3954);
  meth_meth_ast_usesAsType_40_1_41_3954->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_3954->definitionLine = 939;
// method "returnsObject"
  struct UserObject *uo3960 = (struct UserObject*)obj3673;
  uo3960->data[35] = emptyclosure;
  Method *meth_meth_ast_returnsObject3960 = addmethod2pos(obj3673, "returnsObject", &meth_ast_returnsObject3960, 35);
  int argcv_meth_ast_returnsObject3960[] = {0};
  meth_meth_ast_returnsObject3960->type = alloc_MethodType(1, argcv_meth_ast_returnsObject3960);
  meth_meth_ast_returnsObject3960->definitionModule = modulename;
  meth_meth_ast_returnsObject3960->definitionLine = 942;
// method "returnedObjectScope"
  struct UserObject *uo3979 = (struct UserObject*)obj3673;
  uo3979->data[36] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope3979 = addmethod2pos(obj3673, "returnedObjectScope", &meth_ast_returnedObjectScope3979, 36);
  int argcv_meth_ast_returnedObjectScope3979[] = {0};
  meth_meth_ast_returnedObjectScope3979->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope3979);
  meth_meth_ast_returnedObjectScope3979->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope3979->definitionLine = 945;
// method "accept(_)from(_)"
  struct UserObject *uo3986 = (struct UserObject*)obj3673;
  uo3986->data[37] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_3986 = addmethod2pos(obj3673, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_3986, 37);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_3986[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_3986->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_3986);
  meth_meth_ast_accept_40_1_41_from_40_1_41_3986->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_3986->definitionLine = 949;
// method "map(_)ancestors(_)"
  struct UserObject *uo4052 = (struct UserObject*)obj3673;
  uo4052->data[38] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_4052 = addmethod2pos(obj3673, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_4052, 38);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_4052[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4052->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_4052);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4052->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4052->definitionLine = 972;
// method "pretty(_)"
  struct UserObject *uo4109 = (struct UserObject*)obj3673;
  uo4109->data[39] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_4109 = addmethod2pos(obj3673, "pretty(1)", &meth_ast_pretty_40_1_41_4109, 39);
  int argcv_meth_ast_pretty_40_1_41_4109[] = {1};
  meth_meth_ast_pretty_40_1_41_4109->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_4109);
  meth_meth_ast_pretty_40_1_41_4109->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_4109->definitionLine = 982;
// method "toGrace(_)"
  struct UserObject *uo4499 = (struct UserObject*)obj3673;
  uo4499->data[40] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_4499 = addmethod2pos(obj3673, "toGrace(1)", &meth_ast_toGrace_40_1_41_4499, 40);
  int argcv_meth_ast_toGrace_40_1_41_4499[] = {1};
  meth_meth_ast_toGrace_40_1_41_4499->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_4499);
meth_meth_ast_toGrace_40_1_41_4499->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_4499->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_4499->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_4499->definitionLine = 1027;
// method "shallowCopy"
  block_savedest(obj3673);
  Object closure4746 = createclosure(1, "shallowCopy");
  setclosureframe(closure4746, stackframe);
  addtoclosure(closure4746, var_methodNode);
  struct UserObject *uo4746 = (struct UserObject*)obj3673;
  uo4746->data[41] = (Object)closure4746;
  Method *meth_meth_ast_shallowCopy4746 = addmethod2pos(obj3673, "shallowCopy", &meth_ast_shallowCopy4746, 41);
  int argcv_meth_ast_shallowCopy4746[] = {0};
  meth_meth_ast_shallowCopy4746->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy4746);
  meth_meth_ast_shallowCopy4746->definitionModule = modulename;
  meth_meth_ast_shallowCopy4746->definitionLine = 1071;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo4757 = (struct UserObject*)obj3673;
  uo4757->data[42] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_4757 = addmethod2pos(obj3673, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_4757, 42);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_4757[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_4757->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_4757);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_4757->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_4757->definitionLine = 1074;
  sourceObject = obj3673;
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4775 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4776 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4777 = gc_frame_new();
// call case 3: self.outer request
  Object call4778 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4777);
// compiled member node returning call4778 (depth = 5)
  Object call4779 = callmethodflags(call4778, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4776);
// compiled member node returning call4779 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4780 = callmethodflags(call4779, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4775);
// compiled call node returning call4780 (depth = 3)
  struct UserObject *obj3673_uo = (struct UserObject *)obj3673;
  obj3673_uo->super = call4780;
  sourceObject = obj3673;
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit4781 == NULL) {
    strlit4781 = alloc_String("method");
    gc_root(strlit4781);
  }
// compiled string node returning strlit4781 (depth = 3)
  adddatum2(obj3673, strlit4781, 1);
  sourceObject = obj3673;
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj3673, *var_signature_39_, 2);
  sourceObject = obj3673;
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj3673, *var_body_39_, 3);
  sourceObject = obj3673;
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj3673, *var_dtype_39_, 4);
  sourceObject = obj3673;
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4782 = alloc_Boolean(0);
// compiled identifier node returning bool4782 (depth = 3)
  adddatum2(obj3673, bool4782, 5);
  sourceObject = obj3673;
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4783 = alloc_Boolean(0);
// compiled identifier node returning bool4783 (depth = 3)
  adddatum2(obj3673, bool4783, 6);
  sourceObject = obj3673;
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array4784 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4784 (depth = 3)
  adddatum2(obj3673, array4784, 7);
  sourceObject = obj3673;
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4785 = alloc_Boolean(0);
// compiled identifier node returning bool4785 (depth = 3)
  adddatum2(obj3673, bool4785, 8);
  sourceObject = obj3673;
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4786 = alloc_Boolean(0);
// compiled identifier node returning bool4786 (depth = 3)
  adddatum2(obj3673, bool4786, 9);
  sourceObject = obj3673;
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_uninitialized (depth = 3)
  adddatum2(obj3673, *var_uninitialized, 10);
  sourceObject = obj3673;
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4787 = alloc_Boolean(1);
// compiled identifier node returning bool4787 (depth = 3)
  adddatum2(obj3673, bool4787, 11);
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  sourceObject = obj3673;
  objclass3673 = obj3673->class;
  objclass3673->definitionModule = modulename;
  objclass3673->definitionLine = 838;
  (*(struct UserObject *)self).data[0] = lowerouter3673;
  self = oldself3673;
  selfslot = oldselfslot3673;
  stackframe = oldstackframe3673;
  gc_frame_end(frame);
  return obj3673;
}
Object meth_ast_methodNode4789(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_methodNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methodNode (depth = 3)
  gc_frame_end(frame);
  return *var_methodNode;
}
Object meth_ast_new_40_2_41_scope_40_1_41_4792(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(2)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)scope(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_receiver = &(stackframe->slots[0]);
  *var_receiver = args[curarg];
  curarg++;
  Object *var_parts = &(stackframe->slots[1]);
  *var_parts = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4793 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_receiver (depth = 5)
  gc_frame_newslot(*var_receiver);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_parts (depth = 5)
  gc_frame_newslot(*var_parts);
// call case 4: self request
  params[0] = *var_receiver;
  params[1] = *var_parts;
  partcv[0] = 2;
  Object call4794 = callmethodflags(self, "new(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4793);
// compiled call node returning call4794 (depth = 4)
  *var_result = call4794;
  if (call4794 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4795 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call4796 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4795);
// compiled call node returning call4796 (depth = 3)
// Begin line 1089
  setline(1089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_onSelf4806(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "onSelf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4807 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool4808 = alloc_Boolean(1);
// compiled identifier node returning bool4808 (depth = 4)
  gc_frame_newslot(bool4808);
// call case 4: self request
  params[0] = bool4808;
  partcv[0] = 1;
  Object call4809 = callmethodflags(self, "isSelfRequest:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4807);
// compiled call node returning call4809 (depth = 3)
// Begin line 1107
  setline(1107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast__apply_40_2_41_4813(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_each = &(stackframe->slots[1]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4815 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  Object call4816 = callmethodflags(*var_each, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe4815);
// compiled member node returning call4816 (depth = 6)
  int op_slot_right_4814 = gc_frame_newslot(call4816);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_4814 = gc_frame_newslot(*var_acc);
  params[0] = call4816;
  partcv[0] = 1;
  Object opresult4818 = callmethod(*var_acc, "++(1)", 1, partcv, params);
// compiled op node returning opresult4818 (depth = 5)
  gc_frame_end(frame);
  return opresult4818;
}
Object meth_ast_nameString4810(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4811 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block4812 = alloc_Block(NULL, NULL, "ast", 1112);
  gc_frame_newslot(block4812);
// method "_apply(_,_)"
  block_savedest(block4812);
  Object closure4813 = createclosure(1, "_apply(2)");
  setclosureframe(closure4813, stackframe);
  addtoclosure(closure4813, selfslot);
  struct UserObject *uo4813 = (struct UserObject*)block4812;
  uo4813->data[0] = (Object)closure4813;
  Method *meth_meth_ast__apply_40_2_41_4813 = addmethod2pos(block4812, "_apply(2)", &meth_ast__apply_40_2_41_4813, 0);
  int argcv_meth_ast__apply_40_2_41_4813[] = {2};
  meth_meth_ast__apply_40_2_41_4813->type = alloc_MethodType(1, argcv_meth_ast__apply_40_2_41_4813);
  meth_meth_ast__apply_40_2_41_4813->definitionModule = modulename;
  meth_meth_ast__apply_40_2_41_4813->definitionLine = 2981;
// compiled block node returning block4812 (depth = 4)
  gc_frame_newslot(block4812);
// starting to compile string node (depth = 4)
  if (strlit4820 == NULL) {
    strlit4820 = alloc_String("");
    gc_root(strlit4820);
  }
// compiled string node returning strlit4820 (depth = 4)
  gc_frame_newslot(strlit4820);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4821 = gc_frame_new();
// call case 4: self request
  Object call4822 = callmethodflags(self, "with", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4821);
// compiled member node returning call4822 (depth = 4)
  params[0] = block4812;
  params[1] = strlit4820;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4823 = callmethodflags(call4822, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4811);
// compiled call node returning call4823 (depth = 3)
  gc_frame_end(frame);
  return call4823;
}
Object meth_ast__apply_40_2_41_4827(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_acc = &(stackframe->slots[0]);
  *var_acc = args[curarg];
  curarg++;
  Object *var_each = &(stackframe->slots[1]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4829 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  Object call4830 = callmethodflags(*var_each, "canonicalName", 0, partcv, params, 0);
  gc_frame_end(callframe4829);
// compiled member node returning call4830 (depth = 6)
  int op_slot_right_4828 = gc_frame_newslot(call4830);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acc (depth = 6)
  int op_slot_left_4828 = gc_frame_newslot(*var_acc);
  params[0] = call4830;
  partcv[0] = 1;
  Object opresult4832 = callmethod(*var_acc, "++(1)", 1, partcv, params);
// compiled op node returning opresult4832 (depth = 5)
  gc_frame_end(frame);
  return opresult4832;
}
Object meth_ast_canonicalName4824(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4825 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block4826 = alloc_Block(NULL, NULL, "ast", 1117);
  gc_frame_newslot(block4826);
// method "_apply(_,_)"
  block_savedest(block4826);
  Object closure4827 = createclosure(1, "_apply(2)");
  setclosureframe(closure4827, stackframe);
  addtoclosure(closure4827, selfslot);
  struct UserObject *uo4827 = (struct UserObject*)block4826;
  uo4827->data[0] = (Object)closure4827;
  Method *meth_meth_ast__apply_40_2_41_4827 = addmethod2pos(block4826, "_apply(2)", &meth_ast__apply_40_2_41_4827, 0);
  int argcv_meth_ast__apply_40_2_41_4827[] = {2};
  meth_meth_ast__apply_40_2_41_4827->type = alloc_MethodType(1, argcv_meth_ast__apply_40_2_41_4827);
  meth_meth_ast__apply_40_2_41_4827->definitionModule = modulename;
  meth_meth_ast__apply_40_2_41_4827->definitionLine = 2981;
// compiled block node returning block4826 (depth = 4)
  gc_frame_newslot(block4826);
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit4834 == NULL) {
    strlit4834 = alloc_String("");
    gc_root(strlit4834);
  }
// compiled string node returning strlit4834 (depth = 4)
  gc_frame_newslot(strlit4834);
// call case 6: other requests
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe4835 = gc_frame_new();
// call case 4: self request
  Object call4836 = callmethodflags(self, "with", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4835);
// compiled member node returning call4836 (depth = 4)
  params[0] = block4826;
  params[1] = strlit4834;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4837 = callmethodflags(call4836, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4825);
// compiled call node returning call4837 (depth = 3)
  gc_frame_end(frame);
  return call4837;
}
Object meth_ast_isCall4838(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1121
  setline(1121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4839 = alloc_Boolean(1);
// compiled identifier node returning bool4839 (depth = 3)
  gc_frame_end(frame);
  return bool4839;
}
Object meth_ast_returnsObject4840(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4844 == NULL) {
    strlit4844 = alloc_String("clone(1)");
    gc_root(strlit4844);
  }
// compiled string node returning strlit4844 (depth = 6)
  int op_slot_right_4843 = gc_frame_newslot(strlit4844);
// starting to compile member node (depth = 6)
  int callframe4846 = gc_frame_new();
// call case 4: self request
  Object call4847 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4846);
// compiled member node returning call4847 (depth = 6)
  int op_slot_left_4843 = gc_frame_newslot(call4847);
  params[0] = strlit4844;
  partcv[0] = 1;
  Object opresult4848 = callmethod(call4847, "==(1)", 1, partcv, params);
// compiled op node returning opresult4848 (depth = 5)
  int op_slot_right_4842 = gc_frame_newslot(opresult4848);
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4851 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4852 = gc_frame_new();
// call case 4: self request
  Object call4853 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4852);
// compiled member node returning call4853 (depth = 7)
  Object call4854 = callmethodflags(call4853, "isPrelude", 0, partcv, params, 0);
  gc_frame_end(callframe4851);
// compiled member node returning call4854 (depth = 6)
  int op_slot_right_4850 = gc_frame_newslot(call4854);
// starting to compile member node (depth = 6)
  int callframe4856 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4857 = gc_frame_new();
// call case 4: self request
  Object call4858 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4857);
// compiled member node returning call4858 (depth = 7)
  Object call4859 = callmethodflags(call4858, "isImplicit", 0, partcv, params, 0);
  gc_frame_end(callframe4856);
// compiled member node returning call4859 (depth = 6)
  int op_slot_left_4850 = gc_frame_newslot(call4859);
  params[0] = call4854;
  partcv[0] = 1;
  Object opresult4860 = callmethod(call4859, "||(1)", 1, partcv, params);
// compiled op node returning opresult4860 (depth = 5)
  int op_slot_left_4842 = gc_frame_newslot(opresult4860);
  params[0] = opresult4848;
  partcv[0] = 1;
  Object opresult4861 = callmethod(opresult4860, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4861 (depth = 4)
  Object if4841 = done;
  if (istrue(opresult4861)) {
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4862 = alloc_Boolean(1);
// compiled identifier node returning bool4862 (depth = 5)
  return bool4862;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4841 = undefined;
  } else {
  }
// compiled if node returning if4841 (depth = 3)
// Begin line 1127
  setline(1127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4866 == NULL) {
    strlit4866 = alloc_String("copy");
    gc_root(strlit4866);
  }
// compiled string node returning strlit4866 (depth = 6)
  int op_slot_right_4865 = gc_frame_newslot(strlit4866);
// starting to compile member node (depth = 6)
  int callframe4868 = gc_frame_new();
// call case 4: self request
  Object call4869 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4868);
// compiled member node returning call4869 (depth = 6)
  int op_slot_left_4865 = gc_frame_newslot(call4869);
  params[0] = strlit4866;
  partcv[0] = 1;
  Object opresult4870 = callmethod(call4869, "==(1)", 1, partcv, params);
// compiled op node returning opresult4870 (depth = 5)
  int op_slot_right_4864 = gc_frame_newslot(opresult4870);
// Begin line 1127
  setline(1127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4873 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4874 = gc_frame_new();
// call case 4: self request
  Object call4875 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4874);
// compiled member node returning call4875 (depth = 7)
  Object call4876 = callmethodflags(call4875, "isSelf", 0, partcv, params, 0);
  gc_frame_end(callframe4873);
// compiled member node returning call4876 (depth = 6)
  int op_slot_right_4872 = gc_frame_newslot(call4876);
// starting to compile member node (depth = 6)
  int callframe4878 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4879 = gc_frame_new();
// call case 4: self request
  Object call4880 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4879);
// compiled member node returning call4880 (depth = 7)
  Object call4881 = callmethodflags(call4880, "isImplicit", 0, partcv, params, 0);
  gc_frame_end(callframe4878);
// compiled member node returning call4881 (depth = 6)
  int op_slot_left_4872 = gc_frame_newslot(call4881);
  params[0] = call4876;
  partcv[0] = 1;
  Object opresult4882 = callmethod(call4881, "||(1)", 1, partcv, params);
// compiled op node returning opresult4882 (depth = 5)
  int op_slot_left_4864 = gc_frame_newslot(opresult4882);
  params[0] = opresult4870;
  partcv[0] = 1;
  Object opresult4883 = callmethod(opresult4882, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4883 (depth = 4)
  Object if4863 = done;
  if (istrue(opresult4883)) {
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4884 = alloc_Boolean(1);
// compiled identifier node returning bool4884 (depth = 5)
  return bool4884;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4863 = undefined;
  } else {
  }
// compiled if node returning if4863 (depth = 3)
// Begin line 1129
  setline(1129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool4885 = alloc_Boolean(0);
// compiled identifier node returning bool4885 (depth = 4)
  return bool4885;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_returnedObjectScope4886(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe4887 = gc_frame_new();
// call case 4: self request
  Object call4888 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4887);
// compiled member node returning call4888 (depth = 3)
  gc_frame_end(frame);
  return call4888;
}
Object meth_ast__apply_40_1_41_4900(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe4901 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_arg (depth = 8)
  gc_frame_newslot(*var_arg);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_result (depth = 8)
  params[0] = *var_arg;
  partcv[0] = 1;
  Object call4902 = callmethodflags(*var_result, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4901);
// compiled call node returning call4902 (depth = 7)
  gc_frame_end(frame);
  return call4902;
}
Object meth_ast__apply_40_1_41_4895(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1138
  setline(1138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4896 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4897 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call4898 = callmethodflags(*var_part, "args", 0, partcv, params, 0);
  gc_frame_end(callframe4897);
// compiled member node returning call4898 (depth = 6)
  gc_frame_newslot(call4898);
// starting to compile block node (depth = 6)
  Object block4899 = alloc_Block(NULL, NULL, "ast", 1138);
  gc_frame_newslot(block4899);
// method "_apply(_)"
  block_savedest(block4899);
  Object closure4900 = createclosure(2, "_apply(1)");
  setclosureframe(closure4900, stackframe);
  addtoclosure(closure4900, var_result);
  addtoclosure(closure4900, selfslot);
  struct UserObject *uo4900 = (struct UserObject*)block4899;
  uo4900->data[0] = (Object)closure4900;
  Method *meth_meth_ast__apply_40_1_41_4900 = addmethod2pos(block4899, "_apply(1)", &meth_ast__apply_40_1_41_4900, 0);
  int argcv_meth_ast__apply_40_1_41_4900[] = {1};
  meth_meth_ast__apply_40_1_41_4900->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4900);
  meth_meth_ast__apply_40_1_41_4900->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4900->definitionLine = 2981;
// compiled block node returning block4899 (depth = 6)
  gc_frame_newslot(block4899);
// call case 5: prelude request
  params[0] = call4898;
  params[1] = block4899;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4904 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4896);
// compiled call node returning call4904 (depth = 5)
  gc_frame_end(frame);
  return call4904;
}
Object meth_ast_arguments4889(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "arguments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array4890 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4890 (depth = 4)
  *var_result = array4890;
  if (array4890 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4891 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4892 = gc_frame_new();
// call case 4: self request
  Object call4893 = callmethodflags(self, "with", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4892);
// compiled member node returning call4893 (depth = 4)
  gc_frame_newslot(call4893);
// starting to compile block node (depth = 4)
  Object block4894 = alloc_Block(NULL, NULL, "ast", 1137);
  gc_frame_newslot(block4894);
// method "_apply(_)"
  block_savedest(block4894);
  Object closure4895 = createclosure(2, "_apply(1)");
  setclosureframe(closure4895, stackframe);
  addtoclosure(closure4895, var_result);
  addtoclosure(closure4895, selfslot);
  struct UserObject *uo4895 = (struct UserObject*)block4894;
  uo4895->data[0] = (Object)closure4895;
  Method *meth_meth_ast__apply_40_1_41_4895 = addmethod2pos(block4894, "_apply(1)", &meth_ast__apply_40_1_41_4895, 0);
  int argcv_meth_ast__apply_40_1_41_4895[] = {1};
  meth_meth_ast__apply_40_1_41_4895->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4895);
  meth_meth_ast__apply_40_1_41_4895->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4895->definitionLine = 2981;
// compiled block node returning block4894 (depth = 4)
  gc_frame_newslot(block4894);
// call case 5: prelude request
  params[0] = call4893;
  params[1] = block4894;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4906 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4891);
// compiled call node returning call4906 (depth = 3)
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast__apply_40_1_41_4917(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe4918 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_arg (depth = 8)
  gc_frame_newslot(*var_arg);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_action (depth = 8)
  params[0] = *var_arg;
  partcv[0] = 1;
  Object call4919 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4918);
// compiled call node returning call4919 (depth = 7)
  gc_frame_end(frame);
  return call4919;
}
Object meth_ast__apply_40_1_41_4912(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4913 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4914 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call4915 = callmethodflags(*var_part, "args", 0, partcv, params, 0);
  gc_frame_end(callframe4914);
// compiled member node returning call4915 (depth = 6)
  gc_frame_newslot(call4915);
// starting to compile block node (depth = 6)
  Object block4916 = alloc_Block(NULL, NULL, "ast", 1145);
  gc_frame_newslot(block4916);
// method "_apply(_)"
  block_savedest(block4916);
  Object closure4917 = createclosure(2, "_apply(1)");
  setclosureframe(closure4917, stackframe);
  addtoclosure(closure4917, var_action);
  addtoclosure(closure4917, selfslot);
  struct UserObject *uo4917 = (struct UserObject*)block4916;
  uo4917->data[0] = (Object)closure4917;
  Method *meth_meth_ast__apply_40_1_41_4917 = addmethod2pos(block4916, "_apply(1)", &meth_ast__apply_40_1_41_4917, 0);
  int argcv_meth_ast__apply_40_1_41_4917[] = {1};
  meth_meth_ast__apply_40_1_41_4917->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4917);
  meth_meth_ast__apply_40_1_41_4917->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4917->definitionLine = 2981;
// compiled block node returning block4916 (depth = 6)
  gc_frame_newslot(block4916);
// call case 5: prelude request
  params[0] = call4915;
  params[1] = block4916;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4921 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4913);
// compiled call node returning call4921 (depth = 5)
  gc_frame_end(frame);
  return call4921;
}
Object meth_ast_argumentsDo_40_1_41_4907(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "argumentsDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method argumentsDo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for argumentsDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part argumentsDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1144
  setline(1144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4908 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4909 = gc_frame_new();
// call case 4: self request
  Object call4910 = callmethodflags(self, "with", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4909);
// compiled member node returning call4910 (depth = 4)
  gc_frame_newslot(call4910);
// starting to compile block node (depth = 4)
  Object block4911 = alloc_Block(NULL, NULL, "ast", 1144);
  gc_frame_newslot(block4911);
// method "_apply(_)"
  block_savedest(block4911);
  Object closure4912 = createclosure(2, "_apply(1)");
  setclosureframe(closure4912, stackframe);
  addtoclosure(closure4912, var_action);
  addtoclosure(closure4912, selfslot);
  struct UserObject *uo4912 = (struct UserObject*)block4911;
  uo4912->data[0] = (Object)closure4912;
  Method *meth_meth_ast__apply_40_1_41_4912 = addmethod2pos(block4911, "_apply(1)", &meth_ast__apply_40_1_41_4912, 0);
  int argcv_meth_ast__apply_40_1_41_4912[] = {1};
  meth_meth_ast__apply_40_1_41_4912->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4912);
  meth_meth_ast__apply_40_1_41_4912->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4912->definitionLine = 2981;
// compiled block node returning block4911 (depth = 4)
  gc_frame_newslot(block4911);
// call case 5: prelude request
  params[0] = call4910;
  params[1] = block4911;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4923 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4908);
// compiled call node returning call4923 (depth = 3)
  gc_frame_end(frame);
  return call4923;
}
Object meth_ast__apply_40_1_41_4943(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4944 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_visitor (depth = 9)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newChain (depth = 9)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_arg (depth = 9)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4945 = callmethodflags(*var_arg, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4944);
// compiled call node returning call4945 (depth = 8)
  gc_frame_end(frame);
  return call4945;
}
Object meth_ast__apply_40_1_41_4938(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4939 = gc_frame_new();
// starting to compile member node (depth = 7)
  int callframe4940 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  Object call4941 = callmethodflags(*var_part, "args", 0, partcv, params, 0);
  gc_frame_end(callframe4940);
// compiled member node returning call4941 (depth = 7)
  gc_frame_newslot(call4941);
// starting to compile block node (depth = 7)
  Object block4942 = alloc_Block(NULL, NULL, "ast", 1154);
  gc_frame_newslot(block4942);
// method "_apply(_)"
  block_savedest(block4942);
  Object closure4943 = createclosure(3, "_apply(1)");
  setclosureframe(closure4943, stackframe);
  addtoclosure(closure4943, var_visitor);
  addtoclosure(closure4943, var_newChain);
  addtoclosure(closure4943, selfslot);
  struct UserObject *uo4943 = (struct UserObject*)block4942;
  uo4943->data[0] = (Object)closure4943;
  Method *meth_meth_ast__apply_40_1_41_4943 = addmethod2pos(block4942, "_apply(1)", &meth_ast__apply_40_1_41_4943, 0);
  int argcv_meth_ast__apply_40_1_41_4943[] = {1};
  meth_meth_ast__apply_40_1_41_4943->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4943);
  meth_meth_ast__apply_40_1_41_4943->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4943->definitionLine = 2981;
// compiled block node returning block4942 (depth = 7)
  gc_frame_newslot(block4942);
// call case 5: prelude request
  params[0] = call4941;
  params[1] = block4942;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4947 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4939);
// compiled call node returning call4947 (depth = 6)
  gc_frame_end(frame);
  return call4947;
}
Object meth_ast__apply_40_1_41_4959(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1160
  setline(1160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4960 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4961 = callmethodflags(*var_each, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4960);
// compiled call node returning call4961 (depth = 7)
  gc_frame_end(frame);
  return call4961;
}
Object meth_ast_accept_40_1_41_from_40_1_41_4924(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4926 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4927 = callmethodflags(*var_visitor, "visitCall(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4926);
// compiled call node returning call4927 (depth = 4)
  Object if4925 = done;
  if (istrue(call4927)) {
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4928 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call4929 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4928);
// compiled call node returning call4929 (depth = 5)
  *var_newChain = call4929;
  if (call4929 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4930 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4931 = gc_frame_new();
// call case 4: self request
  Object call4932 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4931);
// compiled member node returning call4932 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4933 = callmethodflags(call4932, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4930);
// compiled call node returning call4933 (depth = 4)
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4934 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4935 = gc_frame_new();
// call case 4: self request
  Object call4936 = callmethodflags(self, "with", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4935);
// compiled member node returning call4936 (depth = 5)
  gc_frame_newslot(call4936);
// starting to compile block node (depth = 5)
  Object block4937 = alloc_Block(NULL, NULL, "ast", 1153);
  gc_frame_newslot(block4937);
// method "_apply(_)"
  block_savedest(block4937);
  Object closure4938 = createclosure(3, "_apply(1)");
  setclosureframe(closure4938, stackframe);
  addtoclosure(closure4938, var_visitor);
  addtoclosure(closure4938, var_newChain);
  addtoclosure(closure4938, selfslot);
  struct UserObject *uo4938 = (struct UserObject*)block4937;
  uo4938->data[0] = (Object)closure4938;
  Method *meth_meth_ast__apply_40_1_41_4938 = addmethod2pos(block4937, "_apply(1)", &meth_ast__apply_40_1_41_4938, 0);
  int argcv_meth_ast__apply_40_1_41_4938[] = {1};
  meth_meth_ast__apply_40_1_41_4938->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4938);
  meth_meth_ast__apply_40_1_41_4938->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4938->definitionLine = 2981;
// compiled block node returning block4937 (depth = 5)
  gc_frame_newslot(block4937);
// call case 5: prelude request
  params[0] = call4936;
  params[1] = block4937;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4949 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4934);
// compiled call node returning call4949 (depth = 4)
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4952 = gc_frame_new();
// call case 4: self request
  Object call4953 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4952);
// compiled member node returning call4953 (depth = 6)
  int op_slot_right_4951 = gc_frame_newslot(call4953);
// starting to compile identifier node (depth = 6)
  Object bool4955 = alloc_Boolean(0);
// compiled identifier node returning bool4955 (depth = 6)
  int op_slot_left_4951 = gc_frame_newslot(bool4955);
  params[0] = call4953;
  partcv[0] = 1;
  Object opresult4956 = callmethod(bool4955, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4956 (depth = 5)
  Object if4950 = done;
  if (istrue(opresult4956)) {
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4957 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4958 = alloc_Block(NULL, NULL, "ast", 1159);
  gc_frame_newslot(block4958);
// method "_apply(_)"
  block_savedest(block4958);
  Object closure4959 = createclosure(3, "_apply(1)");
  setclosureframe(closure4959, stackframe);
  addtoclosure(closure4959, var_visitor);
  addtoclosure(closure4959, var_newChain);
  addtoclosure(closure4959, selfslot);
  struct UserObject *uo4959 = (struct UserObject*)block4958;
  uo4959->data[0] = (Object)closure4959;
  Method *meth_meth_ast__apply_40_1_41_4959 = addmethod2pos(block4958, "_apply(1)", &meth_ast__apply_40_1_41_4959, 0);
  int argcv_meth_ast__apply_40_1_41_4959[] = {1};
  meth_meth_ast__apply_40_1_41_4959->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_4959);
  meth_meth_ast__apply_40_1_41_4959->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_4959->definitionLine = 2981;
// compiled block node returning block4958 (depth = 6)
  gc_frame_newslot(block4958);
// call case 6: other requests
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe4963 = gc_frame_new();
// call case 4: self request
  Object call4964 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4963);
// compiled member node returning call4964 (depth = 6)
  params[0] = block4958;
  partcv[0] = 1;
  Object call4965 = callmethodflags(call4964, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4957);
// compiled call node returning call4965 (depth = 5)
    gc_frame_newslot(call4965);
    if4950 = call4965;
  } else {
  }
// compiled if node returning if4950 (depth = 4)
    gc_frame_newslot(if4950);
    if4925 = if4950;
  } else {
  }
// compiled if node returning if4925 (depth = 3)
  gc_frame_end(frame);
  return if4925;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_4966(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4967 = gc_frame_new();
// call case 4: self request
  Object call4968 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4967);
// compiled member node returning call4968 (depth = 4)
  *var_n = call4968;
  if (call4968 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1167
  setline(1167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4969 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call4970 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4969);
// compiled call node returning call4970 (depth = 4)
  *var_newChain = call4970;
  if (call4970 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4971 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4972 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4973 = gc_frame_new();
// call case 4: self request
  Object call4974 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4973);
// compiled member node returning call4974 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4975 = callmethodflags(call4974, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4972);
// compiled call node returning call4975 (depth = 4)
  gc_frame_newslot(call4975);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4975;
  partcv[0] = 1;
  Object call4976 = callmethodflags(*var_n, "receiver:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4971);
// compiled call node returning call4976 (depth = 3)
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4977 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4978 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4979 = gc_frame_new();
// call case 4: self request
  Object call4980 = callmethodflags(self, "with", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4979);
// compiled member node returning call4980 (depth = 5)
  gc_frame_newslot(call4980);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4981 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4982 = gc_frame_new();
// call case 3: self.outer request
  Object call4983 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4982);
// compiled member node returning call4983 (depth = 6)
  Object call4984 = callmethodflags(call4983, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4981);
// compiled member node returning call4984 (depth = 5)
  params[0] = call4980;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4985 = callmethodflags(call4984, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4978);
// compiled call node returning call4985 (depth = 4)
  gc_frame_newslot(call4985);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4985;
  partcv[0] = 1;
  Object call4986 = callmethodflags(*var_n, "with:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4977);
// compiled call node returning call4986 (depth = 3)
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4987 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4988 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe4989 = gc_frame_new();
// call case 4: self request
  Object call4990 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4989);
// compiled member node returning call4990 (depth = 5)
  gc_frame_newslot(call4990);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4991 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4992 = gc_frame_new();
// call case 3: self.outer request
  Object call4993 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4992);
// compiled member node returning call4993 (depth = 6)
  Object call4994 = callmethodflags(call4993, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4991);
// compiled member node returning call4994 (depth = 5)
  params[0] = call4990;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4995 = callmethodflags(call4994, "maybeListMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4988);
// compiled call node returning call4995 (depth = 4)
  gc_frame_newslot(call4995);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4995;
  partcv[0] = 1;
  Object call4996 = callmethodflags(*var_n, "generics:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4987);
// compiled call node returning call4996 (depth = 3)
// Begin line 1171
  setline(1171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4997 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call4998 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4997);
// compiled call node returning call4998 (depth = 3)
  gc_frame_end(frame);
  return call4998;
}
Object meth_ast__apply_40_1_41_5007(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1176
  setline(1176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5009 == NULL) {
    strlit5009 = alloc_String("  ");
    gc_root(strlit5009);
  }
// compiled string node returning strlit5009 (depth = 7)
  int op_slot_right_5008 = gc_frame_newslot(strlit5009);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_5008 = gc_frame_newslot(*var_spc);
  params[0] = strlit5009;
  partcv[0] = 1;
  Object opresult5011 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult5011 (depth = 6)
  *var_spc = opresult5011;
  if (opresult5011 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_5085(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1185
  setline(1185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5087 == NULL) {
    strlit5087 = alloc_String("""\x0a""");
    gc_root(strlit5087);
  }
// compiled string node returning strlit5087 (depth = 8)
  int op_slot_right_5086 = gc_frame_newslot(strlit5087);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5090 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num5092 = alloc_Float64(2);
// compiled num node returning num5092 (depth = 11)
  int op_slot_right_5091 = gc_frame_newslot(num5092);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_5091 = gc_frame_newslot(*var_depth);
  params[0] = num5092;
  partcv[0] = 1;
  Object sum5094 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5094 (depth = 10)
  gc_frame_newslot(sum5094);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_g (depth = 10)
  params[0] = sum5094;
  partcv[0] = 1;
  Object call5095 = callmethodflags(*var_g, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5090);
// compiled call node returning call5095 (depth = 9)
  int op_slot_right_5089 = gc_frame_newslot(call5095);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5098 == NULL) {
    strlit5098 = alloc_String("    ");
    gc_root(strlit5098);
  }
// compiled string node returning strlit5098 (depth = 10)
  int op_slot_right_5097 = gc_frame_newslot(strlit5098);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_5100 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_5100 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5102 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5102 (depth = 10)
  int op_slot_left_5097 = gc_frame_newslot(opresult5102);
  params[0] = strlit5098;
  partcv[0] = 1;
  Object opresult5103 = callmethod(opresult5102, "++(1)", 1, partcv, params);
// compiled op node returning opresult5103 (depth = 9)
  int op_slot_left_5089 = gc_frame_newslot(opresult5103);
  params[0] = call5095;
  partcv[0] = 1;
  Object opresult5104 = callmethod(opresult5103, "++(1)", 1, partcv, params);
// compiled op node returning opresult5104 (depth = 8)
  int op_slot_left_5086 = gc_frame_newslot(opresult5104);
  params[0] = strlit5087;
  partcv[0] = 1;
  Object opresult5105 = callmethod(opresult5104, "++(1)", 1, partcv, params);
// compiled op node returning opresult5105 (depth = 7)
  *var_s = opresult5105;
  if (opresult5105 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_5143(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5145 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num5147 = alloc_Float64(2);
// compiled num node returning num5147 (depth = 11)
  int op_slot_right_5146 = gc_frame_newslot(num5147);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_5146 = gc_frame_newslot(*var_depth);
  params[0] = num5147;
  partcv[0] = 1;
  Object sum5149 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5149 (depth = 10)
  gc_frame_newslot(sum5149);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_arg (depth = 10)
  params[0] = sum5149;
  partcv[0] = 1;
  Object call5150 = callmethodflags(*var_arg, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5145);
// compiled call node returning call5150 (depth = 9)
  int op_slot_right_5144 = gc_frame_newslot(call5150);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_5152 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit5155 == NULL) {
    strlit5155 = alloc_String("""\x0a""      ");
    gc_root(strlit5155);
  }
// compiled string node returning strlit5155 (depth = 11)
  int op_slot_right_5154 = gc_frame_newslot(strlit5155);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_5154 = gc_frame_newslot(*var_s);
  params[0] = strlit5155;
  partcv[0] = 1;
  Object opresult5157 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5157 (depth = 10)
  int op_slot_left_5152 = gc_frame_newslot(opresult5157);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5158 = callmethod(opresult5157, "++(1)", 1, partcv, params);
// compiled op node returning opresult5158 (depth = 9)
  int op_slot_left_5144 = gc_frame_newslot(opresult5158);
  params[0] = call5150;
  partcv[0] = 1;
  Object opresult5159 = callmethod(opresult5158, "++(1)", 1, partcv, params);
// compiled op node returning opresult5159 (depth = 8)
  *var_s = opresult5159;
  if (opresult5159 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_5121(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5123 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  Object call5124 = callmethodflags(*var_part, "name", 0, partcv, params, 0);
  gc_frame_end(callframe5123);
// compiled member node returning call5124 (depth = 7)
  int op_slot_right_5122 = gc_frame_newslot(call5124);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5127 == NULL) {
    strlit5127 = alloc_String("Part: ");
    gc_root(strlit5127);
  }
// compiled string node returning strlit5127 (depth = 8)
  int op_slot_right_5126 = gc_frame_newslot(strlit5127);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_5129 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5132 == NULL) {
    strlit5132 = alloc_String("""\x0a""  ");
    gc_root(strlit5132);
  }
// compiled string node returning strlit5132 (depth = 10)
  int op_slot_right_5131 = gc_frame_newslot(strlit5132);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_5131 = gc_frame_newslot(*var_s);
  params[0] = strlit5132;
  partcv[0] = 1;
  Object opresult5134 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5134 (depth = 9)
  int op_slot_left_5129 = gc_frame_newslot(opresult5134);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5135 = callmethod(opresult5134, "++(1)", 1, partcv, params);
// compiled op node returning opresult5135 (depth = 8)
  int op_slot_left_5126 = gc_frame_newslot(opresult5135);
  params[0] = strlit5127;
  partcv[0] = 1;
  Object opresult5136 = callmethod(opresult5135, "++(1)", 1, partcv, params);
// compiled op node returning opresult5136 (depth = 7)
  int op_slot_left_5122 = gc_frame_newslot(opresult5136);
  params[0] = call5124;
  partcv[0] = 1;
  Object opresult5137 = callmethod(opresult5136, "++(1)", 1, partcv, params);
// compiled op node returning opresult5137 (depth = 6)
  *var_s = opresult5137;
  if (opresult5137 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1191
  setline(1191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5139 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5140 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  Object call5141 = callmethodflags(*var_part, "args", 0, partcv, params, 0);
  gc_frame_end(callframe5140);
// compiled member node returning call5141 (depth = 6)
  gc_frame_newslot(call5141);
// starting to compile block node (depth = 6)
  Object block5142 = alloc_Block(NULL, NULL, "ast", 1191);
  gc_frame_newslot(block5142);
// method "_apply(_)"
  block_savedest(block5142);
  Object closure5143 = createclosure(4, "_apply(1)");
  setclosureframe(closure5143, stackframe);
  addtoclosure(closure5143, var_depth);
  addtoclosure(closure5143, var_spc);
  addtoclosure(closure5143, var_s);
  addtoclosure(closure5143, selfslot);
  struct UserObject *uo5143 = (struct UserObject*)block5142;
  uo5143->data[0] = (Object)closure5143;
  Method *meth_meth_ast__apply_40_1_41_5143 = addmethod2pos(block5142, "_apply(1)", &meth_ast__apply_40_1_41_5143, 0);
  int argcv_meth_ast__apply_40_1_41_5143[] = {1};
  meth_meth_ast__apply_40_1_41_5143->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5143);
  meth_meth_ast__apply_40_1_41_5143->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5143->definitionLine = 2981;
// compiled block node returning block5142 (depth = 6)
  gc_frame_newslot(block5142);
// call case 5: prelude request
  params[0] = call5141;
  params[1] = block5142;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5162 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5139);
// compiled call node returning call5162 (depth = 5)
  gc_frame_end(frame);
  return call5162;
}
Object meth_ast_pretty_40_1_41_4999(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5000 == NULL) {
    strlit5000 = alloc_String("");
    gc_root(strlit5000);
  }
// compiled string node returning strlit5000 (depth = 4)
  *var_spc = strlit5000;
  if (strlit5000 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1175
  setline(1175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5001 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_5002 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num5004 = alloc_Float64(0);
// compiled num node returning num5004 (depth = 5)
  int op_slot_left_5002 = gc_frame_newslot(num5004);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult5005 = callmethod(num5004, "..(1)", 1, partcv, params);
// compiled op node returning opresult5005 (depth = 4)
  gc_frame_newslot(opresult5005);
// starting to compile block node (depth = 4)
  Object block5006 = alloc_Block(NULL, NULL, "ast", 1175);
  gc_frame_newslot(block5006);
// method "_apply(_)"
  block_savedest(block5006);
  Object closure5007 = createclosure(2, "_apply(1)");
  setclosureframe(closure5007, stackframe);
  addtoclosure(closure5007, var_spc);
  addtoclosure(closure5007, selfslot);
  struct UserObject *uo5007 = (struct UserObject*)block5006;
  uo5007->data[0] = (Object)closure5007;
  Method *meth_meth_ast__apply_40_1_41_5007 = addmethod2pos(block5006, "_apply(1)", &meth_ast__apply_40_1_41_5007, 0);
  int argcv_meth_ast__apply_40_1_41_5007[] = {1};
  meth_meth_ast__apply_40_1_41_5007->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5007);
  meth_meth_ast__apply_40_1_41_5007->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5007->definitionLine = 2981;
// compiled block node returning block5006 (depth = 4)
  gc_frame_newslot(block5006);
// call case 5: prelude request
  params[0] = opresult5005;
  params[1] = block5006;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5014 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5001);
// compiled call node returning call5014 (depth = 3)
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5015 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call5016 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5015);
// compiled call node returning call5016 (depth = 4)
  *var_s = call5016;
  if (call5016 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5019 = gc_frame_new();
// call case 4: self request
  Object call5020 = callmethodflags(self, "isSelfRequest", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5019);
// compiled member node returning call5020 (depth = 6)
  Object if5018 = done;
struct StackFrameObject *iftmpstackframe5018 = stackframe;
  if (istrue(call5020)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5018);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 6)
  if (strlit5021 == NULL) {
    strlit5021 = alloc_String(" on self""\x0a""");
    gc_root(strlit5021);
  }
// compiled string node returning strlit5021 (depth = 6)
    gc_frame_newslot(strlit5021);
    if5018 = strlit5021;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe5018);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 6)
  if (strlit5022 == NULL) {
    strlit5022 = alloc_String("""\x0a""");
    gc_root(strlit5022);
  }
// compiled string node returning strlit5022 (depth = 6)
    gc_frame_newslot(strlit5022);
    if5018 = strlit5022;
  }
stackframe = iftmpstackframe5018;
// compiled if node returning if5018 (depth = 5)
  int op_slot_right_5017 = gc_frame_newslot(if5018);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_5017 = gc_frame_newslot(*var_s);
  params[0] = if5018;
  partcv[0] = 1;
  Object opresult5024 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5024 (depth = 4)
  *var_s = opresult5024;
  if (opresult5024 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5028 == NULL) {
    strlit5028 = alloc_String("""\x0a""");
    gc_root(strlit5028);
  }
// compiled string node returning strlit5028 (depth = 6)
  int op_slot_right_5027 = gc_frame_newslot(strlit5028);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5031 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5033 = alloc_Float64(1);
// compiled num node returning num5033 (depth = 9)
  int op_slot_right_5032 = gc_frame_newslot(num5033);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5032 = gc_frame_newslot(*var_depth);
  params[0] = num5033;
  partcv[0] = 1;
  Object sum5035 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5035 (depth = 8)
  gc_frame_newslot(sum5035);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5036 = gc_frame_new();
// call case 4: self request
  Object call5037 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5036);
// compiled member node returning call5037 (depth = 8)
  params[0] = sum5035;
  partcv[0] = 1;
  Object call5038 = callmethodflags(call5037, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5031);
// compiled call node returning call5038 (depth = 7)
  int op_slot_right_5030 = gc_frame_newslot(call5038);
// starting to compile string node (depth = 7)
  if (strlit5040 == NULL) {
    strlit5040 = alloc_String("Receiver: ");
    gc_root(strlit5040);
  }
// compiled string node returning strlit5040 (depth = 7)
  int op_slot_left_5030 = gc_frame_newslot(strlit5040);
  params[0] = call5038;
  partcv[0] = 1;
  Object opresult5041 = callmethod(strlit5040, "++(1)", 1, partcv, params);
// compiled op node returning opresult5041 (depth = 6)
  int op_slot_left_5027 = gc_frame_newslot(opresult5041);
  params[0] = strlit5028;
  partcv[0] = 1;
  Object opresult5042 = callmethod(opresult5041, "++(1)", 1, partcv, params);
// compiled op node returning opresult5042 (depth = 5)
  int op_slot_right_5026 = gc_frame_newslot(opresult5042);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_5044 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5044 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5046 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5046 (depth = 5)
  int op_slot_left_5026 = gc_frame_newslot(opresult5046);
  params[0] = opresult5042;
  partcv[0] = 1;
  Object opresult5047 = callmethod(opresult5046, "++(1)", 1, partcv, params);
// compiled op node returning opresult5047 (depth = 4)
  *var_s = opresult5047;
  if (opresult5047 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5051 == NULL) {
    strlit5051 = alloc_String("""\x0a""");
    gc_root(strlit5051);
  }
// compiled string node returning strlit5051 (depth = 6)
  int op_slot_right_5050 = gc_frame_newslot(strlit5051);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5054 = gc_frame_new();
// call case 4: self request
  Object call5055 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5054);
// compiled member node returning call5055 (depth = 7)
  int op_slot_right_5053 = gc_frame_newslot(call5055);
// starting to compile string node (depth = 7)
  if (strlit5057 == NULL) {
    strlit5057 = alloc_String("Method Name: ");
    gc_root(strlit5057);
  }
// compiled string node returning strlit5057 (depth = 7)
  int op_slot_left_5053 = gc_frame_newslot(strlit5057);
  params[0] = call5055;
  partcv[0] = 1;
  Object opresult5058 = callmethod(strlit5057, "++(1)", 1, partcv, params);
// compiled op node returning opresult5058 (depth = 6)
  int op_slot_left_5050 = gc_frame_newslot(opresult5058);
  params[0] = strlit5051;
  partcv[0] = 1;
  Object opresult5059 = callmethod(opresult5058, "++(1)", 1, partcv, params);
// compiled op node returning opresult5059 (depth = 5)
  int op_slot_right_5049 = gc_frame_newslot(opresult5059);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_5061 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5061 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5063 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5063 (depth = 5)
  int op_slot_left_5049 = gc_frame_newslot(opresult5063);
  params[0] = opresult5059;
  partcv[0] = 1;
  Object opresult5064 = callmethod(opresult5063, "++(1)", 1, partcv, params);
// compiled op node returning opresult5064 (depth = 4)
  *var_s = opresult5064;
  if (opresult5064 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5068 = gc_frame_new();
// call case 4: self request
  Object call5069 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5068);
// compiled member node returning call5069 (depth = 5)
  int op_slot_right_5067 = gc_frame_newslot(call5069);
// starting to compile identifier node (depth = 5)
  Object bool5071 = alloc_Boolean(0);
// compiled identifier node returning bool5071 (depth = 5)
  int op_slot_left_5067 = gc_frame_newslot(bool5071);
  params[0] = call5069;
  partcv[0] = 1;
  Object opresult5072 = callmethod(bool5071, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5072 (depth = 4)
  Object if5066 = done;
  if (istrue(opresult5072)) {
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5074 == NULL) {
    strlit5074 = alloc_String("  Generics:""\x0a""");
    gc_root(strlit5074);
  }
// compiled string node returning strlit5074 (depth = 6)
  int op_slot_right_5073 = gc_frame_newslot(strlit5074);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_5076 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5076 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5078 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5078 (depth = 6)
  int op_slot_left_5073 = gc_frame_newslot(opresult5078);
  params[0] = strlit5074;
  partcv[0] = 1;
  Object opresult5079 = callmethod(opresult5078, "++(1)", 1, partcv, params);
// compiled op node returning opresult5079 (depth = 5)
  *var_s = opresult5079;
  if (opresult5079 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5081 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5082 = gc_frame_new();
// call case 4: self request
  Object call5083 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5082);
// compiled member node returning call5083 (depth = 5)
  gc_frame_newslot(call5083);
// starting to compile block node (depth = 5)
  Object block5084 = alloc_Block(NULL, NULL, "ast", 1184);
  gc_frame_newslot(block5084);
// method "_apply(_)"
  block_savedest(block5084);
  Object closure5085 = createclosure(4, "_apply(1)");
  setclosureframe(closure5085, stackframe);
  addtoclosure(closure5085, var_depth);
  addtoclosure(closure5085, var_spc);
  addtoclosure(closure5085, var_s);
  addtoclosure(closure5085, selfslot);
  struct UserObject *uo5085 = (struct UserObject*)block5084;
  uo5085->data[0] = (Object)closure5085;
  Method *meth_meth_ast__apply_40_1_41_5085 = addmethod2pos(block5084, "_apply(1)", &meth_ast__apply_40_1_41_5085, 0);
  int argcv_meth_ast__apply_40_1_41_5085[] = {1};
  meth_meth_ast__apply_40_1_41_5085->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5085);
  meth_meth_ast__apply_40_1_41_5085->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5085->definitionLine = 2981;
// compiled block node returning block5084 (depth = 5)
  gc_frame_newslot(block5084);
// call case 5: prelude request
  params[0] = call5083;
  params[1] = block5084;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5108 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5081);
// compiled call node returning call5108 (depth = 4)
    gc_frame_newslot(call5108);
    if5066 = call5108;
  } else {
  }
// compiled if node returning if5066 (depth = 3)
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5110 == NULL) {
    strlit5110 = alloc_String("Arguments:");
    gc_root(strlit5110);
  }
// compiled string node returning strlit5110 (depth = 5)
  int op_slot_right_5109 = gc_frame_newslot(strlit5110);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_5112 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5112 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5114 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5114 (depth = 5)
  int op_slot_left_5109 = gc_frame_newslot(opresult5114);
  params[0] = strlit5110;
  partcv[0] = 1;
  Object opresult5115 = callmethod(opresult5114, "++(1)", 1, partcv, params);
// compiled op node returning opresult5115 (depth = 4)
  *var_s = opresult5115;
  if (opresult5115 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1189
  setline(1189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5117 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5118 = gc_frame_new();
// call case 4: self request
  Object call5119 = callmethodflags(self, "with", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5118);
// compiled member node returning call5119 (depth = 4)
  gc_frame_newslot(call5119);
// starting to compile block node (depth = 4)
  Object block5120 = alloc_Block(NULL, NULL, "ast", 1189);
  gc_frame_newslot(block5120);
// method "_apply(_)"
  block_savedest(block5120);
  Object closure5121 = createclosure(4, "_apply(1)");
  setclosureframe(closure5121, stackframe);
  addtoclosure(closure5121, var_spc);
  addtoclosure(closure5121, var_s);
  addtoclosure(closure5121, var_depth);
  addtoclosure(closure5121, selfslot);
  struct UserObject *uo5121 = (struct UserObject*)block5120;
  uo5121->data[0] = (Object)closure5121;
  Method *meth_meth_ast__apply_40_1_41_5121 = addmethod2pos(block5120, "_apply(1)", &meth_ast__apply_40_1_41_5121, 0);
  int argcv_meth_ast__apply_40_1_41_5121[] = {1};
  meth_meth_ast__apply_40_1_41_5121->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5121);
  meth_meth_ast__apply_40_1_41_5121->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5121->definitionLine = 2981;
// compiled block node returning block5120 (depth = 4)
  gc_frame_newslot(block5120);
// call case 5: prelude request
  params[0] = call5119;
  params[1] = block5120;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5164 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5117);
// compiled call node returning call5164 (depth = 3)
// Begin line 1195
  setline(1195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_5215(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5217 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5219 = alloc_Float64(1);
// compiled num node returning num5219 (depth = 9)
  int op_slot_right_5218 = gc_frame_newslot(num5219);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5218 = gc_frame_newslot(*var_depth);
  params[0] = num5219;
  partcv[0] = 1;
  Object sum5221 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5221 (depth = 8)
  gc_frame_newslot(sum5221);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  params[0] = sum5221;
  partcv[0] = 1;
  Object call5222 = callmethodflags(*var_part, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5217);
// compiled call node returning call5222 (depth = 7)
  int op_slot_right_5216 = gc_frame_newslot(call5222);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5216 = gc_frame_newslot(*var_s);
  params[0] = call5222;
  partcv[0] = 1;
  Object opresult5224 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5224 (depth = 6)
  *var_s = opresult5224;
  if (opresult5224 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5228(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5230 == NULL) {
    strlit5230 = alloc_String(" ");
    gc_root(strlit5230);
  }
// compiled string node returning strlit5230 (depth = 7)
  int op_slot_right_5229 = gc_frame_newslot(strlit5230);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5229 = gc_frame_newslot(*var_s);
  params[0] = strlit5230;
  partcv[0] = 1;
  Object opresult5232 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5232 (depth = 6)
  *var_s = opresult5232;
  if (opresult5232 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_5165(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5166 == NULL) {
    strlit5166 = alloc_String("");
    gc_root(strlit5166);
  }
// compiled string node returning strlit5166 (depth = 4)
  *var_s = strlit5166;
  if (strlit5166 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5168 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5169 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5170 = gc_frame_new();
// call case 4: self request
  Object call5171 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5170);
// compiled member node returning call5171 (depth = 6)
  Object call5172 = callmethodflags(call5171, "isImplicit", 0, partcv, params, 0);
  gc_frame_end(callframe5169);
// compiled member node returning call5172 (depth = 5)
  Object call5173 = callmethodflags(call5172, "not", 0, partcv, params, 0);
  gc_frame_end(callframe5168);
// compiled member node returning call5173 (depth = 4)
  Object if5167 = done;
  if (istrue(call5173)) {
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5175 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5176 = gc_frame_new();
// call case 4: self request
  Object call5177 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5176);
// compiled member node returning call5177 (depth = 6)
  Object call5178 = callmethodflags(call5177, "isSimple", 0, partcv, params, 0);
  gc_frame_end(callframe5175);
// compiled member node returning call5178 (depth = 5)
  Object if5174 = done;
  if (istrue(call5178)) {
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5180 == NULL) {
    strlit5180 = alloc_String(".");
    gc_root(strlit5180);
  }
// compiled string node returning strlit5180 (depth = 7)
  int op_slot_right_5179 = gc_frame_newslot(strlit5180);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5183 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num5185 = alloc_Float64(1);
// compiled num node returning num5185 (depth = 10)
  int op_slot_right_5184 = gc_frame_newslot(num5185);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_5184 = gc_frame_newslot(*var_depth);
  params[0] = num5185;
  partcv[0] = 1;
  Object sum5187 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5187 (depth = 9)
  gc_frame_newslot(sum5187);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe5188 = gc_frame_new();
// call case 4: self request
  Object call5189 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5188);
// compiled member node returning call5189 (depth = 9)
  params[0] = sum5187;
  partcv[0] = 1;
  Object call5190 = callmethodflags(call5189, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5183);
// compiled call node returning call5190 (depth = 8)
  int op_slot_right_5182 = gc_frame_newslot(call5190);
// starting to compile string node (depth = 8)
  if (strlit5192 == NULL) {
    strlit5192 = alloc_String("");
    gc_root(strlit5192);
  }
// compiled string node returning strlit5192 (depth = 8)
  int op_slot_left_5182 = gc_frame_newslot(strlit5192);
  params[0] = call5190;
  partcv[0] = 1;
  Object opresult5193 = callmethod(strlit5192, "++(1)", 1, partcv, params);
// compiled op node returning opresult5193 (depth = 7)
  int op_slot_left_5179 = gc_frame_newslot(opresult5193);
  params[0] = strlit5180;
  partcv[0] = 1;
  Object opresult5194 = callmethod(opresult5193, "++(1)", 1, partcv, params);
// compiled op node returning opresult5194 (depth = 6)
  *var_s = opresult5194;
  if (opresult5194 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5174 = done;
  } else {
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5197 == NULL) {
    strlit5197 = alloc_String(").");
    gc_root(strlit5197);
  }
// compiled string node returning strlit5197 (depth = 7)
  int op_slot_right_5196 = gc_frame_newslot(strlit5197);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5200 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num5202 = alloc_Float64(1);
// compiled num node returning num5202 (depth = 10)
  int op_slot_right_5201 = gc_frame_newslot(num5202);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_5201 = gc_frame_newslot(*var_depth);
  params[0] = num5202;
  partcv[0] = 1;
  Object sum5204 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5204 (depth = 9)
  gc_frame_newslot(sum5204);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe5205 = gc_frame_new();
// call case 4: self request
  Object call5206 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5205);
// compiled member node returning call5206 (depth = 9)
  params[0] = sum5204;
  partcv[0] = 1;
  Object call5207 = callmethodflags(call5206, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5200);
// compiled call node returning call5207 (depth = 8)
  int op_slot_right_5199 = gc_frame_newslot(call5207);
// starting to compile string node (depth = 8)
  if (strlit5209 == NULL) {
    strlit5209 = alloc_String("(");
    gc_root(strlit5209);
  }
// compiled string node returning strlit5209 (depth = 8)
  int op_slot_left_5199 = gc_frame_newslot(strlit5209);
  params[0] = call5207;
  partcv[0] = 1;
  Object opresult5210 = callmethod(strlit5209, "++(1)", 1, partcv, params);
// compiled op node returning opresult5210 (depth = 7)
  int op_slot_left_5196 = gc_frame_newslot(opresult5210);
  params[0] = strlit5197;
  partcv[0] = 1;
  Object opresult5211 = callmethod(opresult5210, "++(1)", 1, partcv, params);
// compiled op node returning opresult5211 (depth = 6)
  *var_s = opresult5211;
  if (opresult5211 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5174 = done;
  }
// compiled if node returning if5174 (depth = 4)
    gc_frame_newslot(if5174);
    if5167 = if5174;
  } else {
  }
// compiled if node returning if5167 (depth = 3)
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5213 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5214 = alloc_Block(NULL, NULL, "ast", 1206);
  gc_frame_newslot(block5214);
// method "_apply(_)"
  block_savedest(block5214);
  Object closure5215 = createclosure(3, "_apply(1)");
  setclosureframe(closure5215, stackframe);
  addtoclosure(closure5215, var_depth);
  addtoclosure(closure5215, var_s);
  addtoclosure(closure5215, selfslot);
  struct UserObject *uo5215 = (struct UserObject*)block5214;
  uo5215->data[0] = (Object)closure5215;
  Method *meth_meth_ast__apply_40_1_41_5215 = addmethod2pos(block5214, "_apply(1)", &meth_ast__apply_40_1_41_5215, 0);
  int argcv_meth_ast__apply_40_1_41_5215[] = {1};
  meth_meth_ast__apply_40_1_41_5215->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5215);
  meth_meth_ast__apply_40_1_41_5215->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5215->definitionLine = 2981;
// compiled block node returning block5214 (depth = 4)
  gc_frame_newslot(block5214);
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block5227 = alloc_Block(NULL, NULL, "ast", 1207);
  gc_frame_newslot(block5227);
// method "_apply"
  block_savedest(block5227);
  Object closure5228 = createclosure(2, "_apply");
  setclosureframe(closure5228, stackframe);
  addtoclosure(closure5228, var_s);
  addtoclosure(closure5228, selfslot);
  struct UserObject *uo5228 = (struct UserObject*)block5227;
  uo5228->data[0] = (Object)closure5228;
  Method *meth_meth_ast__apply5228 = addmethod2pos(block5227, "_apply", &meth_ast__apply5228, 0);
  int argcv_meth_ast__apply5228[] = {0};
  meth_meth_ast__apply5228->type = alloc_MethodType(1, argcv_meth_ast__apply5228);
  meth_meth_ast__apply5228->definitionModule = modulename;
  meth_meth_ast__apply5228->definitionLine = 2981;
// compiled block node returning block5227 (depth = 4)
  gc_frame_newslot(block5227);
// call case 6: other requests
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5235 = gc_frame_new();
// call case 4: self request
  Object call5236 = callmethodflags(self, "with", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5235);
// compiled member node returning call5236 (depth = 4)
  params[0] = block5214;
  params[1] = block5227;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5237 = callmethodflags(call5236, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5213);
// compiled call node returning call5237 (depth = 3)
// Begin line 1208
  setline(1208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asIdentifier5238(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_resultNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "resultNode");
// Begin line 1212
  setline(1212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5241 = gc_frame_new();
// call case 4: self request
  Object call5242 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5241);
// compiled member node returning call5242 (depth = 5)
  int op_slot_right_5240 = gc_frame_newslot(call5242);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_fakeSymbolTable (depth = 5)
  int op_slot_left_5240 = gc_frame_newslot(*var_fakeSymbolTable);
  params[0] = call5242;
  partcv[0] = 1;
  Object opresult5244 = callmethod(*var_fakeSymbolTable, "==(1)", 1, partcv, params);
// compiled op node returning opresult5244 (depth = 4)
  Object if5239 = done;
  if (istrue(opresult5244)) {
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5245 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5247 == NULL) {
    strlit5247 = alloc_String(" when scope was fake");
    gc_root(strlit5247);
  }
// compiled string node returning strlit5247 (depth = 6)
  int op_slot_right_5246 = gc_frame_newslot(strlit5247);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5250 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num5251 = alloc_Float64(0);
// compiled num node returning num5251 (depth = 8)
  gc_frame_newslot(num5251);
// call case 4: self request
  params[0] = num5251;
  partcv[0] = 1;
  Object call5252 = callmethodflags(self, "pretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5250);
// compiled call node returning call5252 (depth = 7)
  int op_slot_right_5249 = gc_frame_newslot(call5252);
// starting to compile string node (depth = 7)
  if (strlit5254 == NULL) {
    strlit5254 = alloc_String("asIdentifier requested on ");
    gc_root(strlit5254);
  }
// compiled string node returning strlit5254 (depth = 7)
  int op_slot_left_5249 = gc_frame_newslot(strlit5254);
  params[0] = call5252;
  partcv[0] = 1;
  Object opresult5255 = callmethod(strlit5254, "++(1)", 1, partcv, params);
// compiled op node returning opresult5255 (depth = 6)
  int op_slot_left_5246 = gc_frame_newslot(opresult5255);
  params[0] = strlit5247;
  partcv[0] = 1;
  Object opresult5256 = callmethod(opresult5255, "++(1)", 1, partcv, params);
// compiled op node returning opresult5256 (depth = 5)
  gc_frame_newslot(opresult5256);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5257 = gc_frame_new();
// call case 5: prelude request
  Object call5258 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5257);
// compiled member node returning call5258 (depth = 5)
  params[0] = opresult5256;
  partcv[0] = 1;
  Object call5259 = callmethodflags(call5258, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5245);
// compiled call node returning call5259 (depth = 4)
    gc_frame_newslot(call5259);
    if5239 = call5259;
  } else {
  }
// compiled if node returning if5239 (depth = 3)
// Begin line 1215
  setline(1215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5260 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5261 = gc_frame_new();
// call case 4: self request
  Object call5262 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5261);
// compiled member node returning call5262 (depth = 5)
  gc_frame_newslot(call5262);
// starting to compile identifier node (depth = 5)
  Object bool5263 = alloc_Boolean(0);
// compiled identifier node returning bool5263 (depth = 5)
  gc_frame_newslot(bool5263);
// starting to compile member node (depth = 5)
  int callframe5264 = gc_frame_new();
// call case 4: self request
  Object call5265 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5264);
// compiled member node returning call5265 (depth = 5)
  gc_frame_newslot(call5265);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call5262;
  params[1] = bool5263;
  params[2] = call5265;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5266 = callmethodflags(*var_identifierNode, "new(2)scope(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5260);
// compiled call node returning call5266 (depth = 4)
  *var_resultNode = call5266;
  if (call5266 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5267 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool5268 = alloc_Boolean(1);
// compiled identifier node returning bool5268 (depth = 4)
  gc_frame_newslot(bool5268);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = bool5268;
  partcv[0] = 1;
  Object call5269 = callmethodflags(*var_resultNode, "inRequest:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5267);
// compiled call node returning call5269 (depth = 3)
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5270 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5271 = gc_frame_new();
// call case 4: self request
  Object call5272 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5271);
// compiled member node returning call5272 (depth = 4)
  gc_frame_newslot(call5272);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call5272;
  partcv[0] = 1;
  Object call5273 = callmethodflags(*var_resultNode, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5270);
// compiled call node returning call5273 (depth = 3)
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5274 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5275 = gc_frame_new();
// call case 4: self request
  Object call5276 = callmethodflags(self, "linePos", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5275);
// compiled member node returning call5276 (depth = 4)
  gc_frame_newslot(call5276);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call5276;
  partcv[0] = 1;
  Object call5277 = callmethodflags(*var_resultNode, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5274);
// compiled call node returning call5277 (depth = 3)
// Begin line 1219
  setline(1219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  return *var_resultNode;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_asString5278(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5280 == NULL) {
    strlit5280 = alloc_String("");
    gc_root(strlit5280);
  }
// compiled string node returning strlit5280 (depth = 4)
  int op_slot_right_5279 = gc_frame_newslot(strlit5280);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5283 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num5284 = alloc_Float64(0);
// compiled num node returning num5284 (depth = 6)
  gc_frame_newslot(num5284);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5285 = gc_frame_new();
// call case 4: self request
  Object call5286 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5285);
// compiled member node returning call5286 (depth = 6)
  params[0] = num5284;
  partcv[0] = 1;
  Object call5287 = callmethodflags(call5286, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5283);
// compiled call node returning call5287 (depth = 5)
  int op_slot_right_5282 = gc_frame_newslot(call5287);
// starting to compile string node (depth = 5)
  if (strlit5289 == NULL) {
    strlit5289 = alloc_String("call ");
    gc_root(strlit5289);
  }
// compiled string node returning strlit5289 (depth = 5)
  int op_slot_left_5282 = gc_frame_newslot(strlit5289);
  params[0] = call5287;
  partcv[0] = 1;
  Object opresult5290 = callmethod(strlit5289, "++(1)", 1, partcv, params);
// compiled op node returning opresult5290 (depth = 4)
  int op_slot_left_5279 = gc_frame_newslot(opresult5290);
  params[0] = strlit5280;
  partcv[0] = 1;
  Object opresult5291 = callmethod(opresult5290, "++(1)", 1, partcv, params);
// compiled op node returning opresult5291 (depth = 3)
  gc_frame_end(frame);
  return opresult5291;
}
Object meth_ast_shallowCopy5292(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1223
  setline(1223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5293 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe5294 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5295 = gc_frame_new();
// call case 4: self request
  Object call5296 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5295);
// compiled member node returning call5296 (depth = 5)
  gc_frame_newslot(call5296);
// starting to compile member node (depth = 5)
  int callframe5297 = gc_frame_new();
// call case 4: self request
  Object call5298 = callmethodflags(self, "with", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5297);
// compiled member node returning call5298 (depth = 5)
  gc_frame_newslot(call5298);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_callNode (depth = 5)
  params[0] = call5296;
  params[1] = call5298;
  partcv[0] = 2;
  Object call5299 = callmethodflags(*var_callNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5294);
// compiled call node returning call5299 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5300 = callmethodflags(call5299, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5293);
// compiled call node returning call5300 (depth = 3)
  gc_frame_end(frame);
  return call5300;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_5301(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1226
  setline(1226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5302 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call5303 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5302);
// compiled call node returning call5303 (depth = 3)
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5304 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5305 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5306 = callmethodflags(*var_other, "isPattern", 0, partcv, params, 0);
  gc_frame_end(callframe5305);
// compiled member node returning call5306 (depth = 4)
  gc_frame_newslot(call5306);
// call case 4: self request
  params[0] = call5306;
  partcv[0] = 1;
  Object call5307 = callmethodflags(self, "isPattern:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5304);
// compiled call node returning call5307 (depth = 3)
// Begin line 1228
  setline(1228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5308 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5309 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5310 = callmethodflags(*var_other, "isSelfRequest", 0, partcv, params, 0);
  gc_frame_end(callframe5309);
// compiled member node returning call5310 (depth = 4)
  gc_frame_newslot(call5310);
// call case 4: self request
  params[0] = call5310;
  partcv[0] = 1;
  Object call5311 = callmethodflags(self, "isSelfRequest:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5308);
// compiled call node returning call5311 (depth = 3)
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName5312(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5313 == NULL) {
    strlit5313 = alloc_String("request");
    gc_root(strlit5313);
  }
// compiled string node returning strlit5313 (depth = 3)
  gc_frame_end(frame);
  return strlit5313;
}
Object meth_ast_new_40_2_41_4797(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_callNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_receiver_39_ = &(stackframe->slots[0]);
  *var_receiver_39_ = args[curarg];
  curarg++;
  Object *var_parts = &(stackframe->slots[1]);
  *var_parts = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4798 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4798 = alloc_userobj2(28,24, objclass4798);
  gc_frame_newslot(obj4798);
if (objclass4798 == NULL) {
  glfree(obj4798->class->name);
  obj4798->class->name = "callNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4798, self, 0);
  addmethodreal(obj4798,"outer", &reader_ast_outer_4799);
  Object oldself4798 = self;
  struct StackFrameObject *oldstackframe4798 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4798);
  gc_frame_newslot((Object)stackframe);
  self = obj4798;
  Object *oldselfslot4798 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4798 = (*(struct UserObject *)self).data[0], lowerouter4798 = thisouter4798;
  if (inheritingObject4798) {
    struct UserObject *inho4798 = (struct UserObject *)inheritingObject4798;
    while (inho4798->super != GraceDefaultObject) inho4798 = (struct UserObject *)inho4798->super;
    inho4798->super = obj4798;
    self = inheritingObject4798;
    *selfslot = self;
    lowerouter4798 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4798;
  }
if (objclass4798 == NULL) {
  Method *reader4800 = addmethodrealflags(obj4798, "kind",&reader_ast_kind_4800, MFLAG_DEF);
  reader4800->definitionModule = modulename;
  reader4800->definitionLine = 1097;
}
adddatum2(obj4798, alloc_Undefined(), 1);
if (objclass4798 == NULL) {
  Method *reader4801 = addmethodrealflags(obj4798, "with", &reader_ast_with_4801, 0);
  Method *writer4801 = addmethodrealflags(obj4798, "with:=(1)", &writer_ast_with_4801, 0);
  reader4801->definitionModule = modulename;
  writer4801->definitionModule = modulename;
  reader4801->definitionLine = 1098;
  writer4801->definitionLine = 1098;
}
obj4798->flags |= OFLAG_MUTABLE;
adddatum2(obj4798, alloc_Undefined(), 2);
if (objclass4798 == NULL) {
  Method *reader4802 = addmethodrealflags(obj4798, "generics", &reader_ast_generics_4802, 0);
  Method *writer4802 = addmethodrealflags(obj4798, "generics:=(1)", &writer_ast_generics_4802, 0);
  reader4802->definitionModule = modulename;
  writer4802->definitionModule = modulename;
  reader4802->definitionLine = 1099;
  writer4802->definitionLine = 1099;
}
obj4798->flags |= OFLAG_MUTABLE;
adddatum2(obj4798, alloc_Undefined(), 3);
if (objclass4798 == NULL) {
  Method *reader4803 = addmethodrealflags(obj4798, "isPattern", &reader_ast_isPattern_4803, 0);
  Method *writer4803 = addmethodrealflags(obj4798, "isPattern:=(1)", &writer_ast_isPattern_4803, 0);
  reader4803->definitionModule = modulename;
  writer4803->definitionModule = modulename;
  reader4803->definitionLine = 1100;
  writer4803->definitionLine = 1100;
}
obj4798->flags |= OFLAG_MUTABLE;
adddatum2(obj4798, alloc_Undefined(), 4);
if (objclass4798 == NULL) {
  Method *reader4804 = addmethodrealflags(obj4798, "receiver", &reader_ast_receiver_4804, 0);
  Method *writer4804 = addmethodrealflags(obj4798, "receiver:=(1)", &writer_ast_receiver_4804, 0);
  reader4804->definitionModule = modulename;
  writer4804->definitionModule = modulename;
  reader4804->definitionLine = 1101;
  writer4804->definitionLine = 1101;
}
obj4798->flags |= OFLAG_MUTABLE;
adddatum2(obj4798, alloc_Undefined(), 5);
if (objclass4798 == NULL) {
  Method *reader4805 = addmethodrealflags(obj4798, "isSelfRequest", &reader_ast_isSelfRequest_4805, 0);
  Method *writer4805 = addmethodrealflags(obj4798, "isSelfRequest:=(1)", &writer_ast_isSelfRequest_4805, 0);
  reader4805->definitionModule = modulename;
  writer4805->definitionModule = modulename;
  reader4805->definitionLine = 1102;
  writer4805->definitionLine = 1102;
}
obj4798->flags |= OFLAG_MUTABLE;
adddatum2(obj4798, alloc_Undefined(), 6);
// method "onSelf"
  struct UserObject *uo4806 = (struct UserObject*)obj4798;
  uo4806->data[7] = emptyclosure;
  Method *meth_meth_ast_onSelf4806 = addmethod2pos(obj4798, "onSelf", &meth_ast_onSelf4806, 7);
  int argcv_meth_ast_onSelf4806[] = {0};
  meth_meth_ast_onSelf4806->type = alloc_MethodType(1, argcv_meth_ast_onSelf4806);
  meth_meth_ast_onSelf4806->definitionModule = modulename;
  meth_meth_ast_onSelf4806->definitionLine = 1104;
// method "nameString"
  struct UserObject *uo4810 = (struct UserObject*)obj4798;
  uo4810->data[8] = emptyclosure;
  Method *meth_meth_ast_nameString4810 = addmethod2pos(obj4798, "nameString", &meth_ast_nameString4810, 8);
  int argcv_meth_ast_nameString4810[] = {0};
  meth_meth_ast_nameString4810->type = alloc_MethodType(1, argcv_meth_ast_nameString4810);
  meth_meth_ast_nameString4810->definitionModule = modulename;
  meth_meth_ast_nameString4810->definitionLine = 1110;
// method "canonicalName"
  struct UserObject *uo4824 = (struct UserObject*)obj4798;
  uo4824->data[9] = emptyclosure;
  Method *meth_meth_ast_canonicalName4824 = addmethod2pos(obj4798, "canonicalName", &meth_ast_canonicalName4824, 9);
  int argcv_meth_ast_canonicalName4824[] = {0};
  meth_meth_ast_canonicalName4824->type = alloc_MethodType(1, argcv_meth_ast_canonicalName4824);
  meth_meth_ast_canonicalName4824->definitionModule = modulename;
  meth_meth_ast_canonicalName4824->definitionLine = 1115;
// method "isCall"
  struct UserObject *uo4838 = (struct UserObject*)obj4798;
  uo4838->data[10] = emptyclosure;
  Method *meth_meth_ast_isCall4838 = addmethod2pos(obj4798, "isCall", &meth_ast_isCall4838, 10);
  int argcv_meth_ast_isCall4838[] = {0};
  meth_meth_ast_isCall4838->type = alloc_MethodType(1, argcv_meth_ast_isCall4838);
  meth_meth_ast_isCall4838->definitionModule = modulename;
  meth_meth_ast_isCall4838->definitionLine = 1121;
// method "returnsObject"
  struct UserObject *uo4840 = (struct UserObject*)obj4798;
  uo4840->data[11] = emptyclosure;
  Method *meth_meth_ast_returnsObject4840 = addmethod2pos(obj4798, "returnsObject", &meth_ast_returnsObject4840, 11);
  int argcv_meth_ast_returnsObject4840[] = {0};
  meth_meth_ast_returnsObject4840->type = alloc_MethodType(1, argcv_meth_ast_returnsObject4840);
  meth_meth_ast_returnsObject4840->definitionModule = modulename;
  meth_meth_ast_returnsObject4840->definitionLine = 1122;
// method "returnedObjectScope"
  struct UserObject *uo4886 = (struct UserObject*)obj4798;
  uo4886->data[12] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope4886 = addmethod2pos(obj4798, "returnedObjectScope", &meth_ast_returnedObjectScope4886, 12);
  int argcv_meth_ast_returnedObjectScope4886[] = {0};
  meth_meth_ast_returnedObjectScope4886->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope4886);
  meth_meth_ast_returnedObjectScope4886->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope4886->definitionLine = 1131;
// method "arguments"
  struct UserObject *uo4889 = (struct UserObject*)obj4798;
  uo4889->data[13] = emptyclosure;
  Method *meth_meth_ast_arguments4889 = addmethod2pos(obj4798, "arguments", &meth_ast_arguments4889, 13);
  int argcv_meth_ast_arguments4889[] = {0};
  meth_meth_ast_arguments4889->type = alloc_MethodType(1, argcv_meth_ast_arguments4889);
  meth_meth_ast_arguments4889->definitionModule = modulename;
  meth_meth_ast_arguments4889->definitionLine = 1135;
// method "argumentsDo(_)"
  struct UserObject *uo4907 = (struct UserObject*)obj4798;
  uo4907->data[14] = emptyclosure;
  Method *meth_meth_ast_argumentsDo_40_1_41_4907 = addmethod2pos(obj4798, "argumentsDo(1)", &meth_ast_argumentsDo_40_1_41_4907, 14);
  int argcv_meth_ast_argumentsDo_40_1_41_4907[] = {1};
  meth_meth_ast_argumentsDo_40_1_41_4907->type = alloc_MethodType(1, argcv_meth_ast_argumentsDo_40_1_41_4907);
  meth_meth_ast_argumentsDo_40_1_41_4907->definitionModule = modulename;
  meth_meth_ast_argumentsDo_40_1_41_4907->definitionLine = 1143;
// method "accept(_)from(_)"
  struct UserObject *uo4924 = (struct UserObject*)obj4798;
  uo4924->data[15] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_4924 = addmethod2pos(obj4798, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_4924, 15);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_4924[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_4924->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_4924);
  meth_meth_ast_accept_40_1_41_from_40_1_41_4924->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_4924->definitionLine = 1149;
// method "map(_)ancestors(_)"
  struct UserObject *uo4966 = (struct UserObject*)obj4798;
  uo4966->data[16] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_4966 = addmethod2pos(obj4798, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_4966, 16);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_4966[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4966->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_4966);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4966->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4966->definitionLine = 1165;
// method "pretty(_)"
  struct UserObject *uo4999 = (struct UserObject*)obj4798;
  uo4999->data[17] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_4999 = addmethod2pos(obj4798, "pretty(1)", &meth_ast_pretty_40_1_41_4999, 17);
  int argcv_meth_ast_pretty_40_1_41_4999[] = {1};
  meth_meth_ast_pretty_40_1_41_4999->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_4999);
  meth_meth_ast_pretty_40_1_41_4999->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_4999->definitionLine = 1173;
// method "toGrace(_)"
  struct UserObject *uo5165 = (struct UserObject*)obj4798;
  uo5165->data[18] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_5165 = addmethod2pos(obj4798, "toGrace(1)", &meth_ast_toGrace_40_1_41_5165, 18);
  int argcv_meth_ast_toGrace_40_1_41_5165[] = {1};
  meth_meth_ast_toGrace_40_1_41_5165->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_5165);
meth_meth_ast_toGrace_40_1_41_5165->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_5165->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_5165->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_5165->definitionLine = 1197;
// method "asIdentifier"
  block_savedest(obj4798);
  Object closure5238 = createclosure(2, "asIdentifier");
  setclosureframe(closure5238, stackframe);
  addtoclosure(closure5238, var_fakeSymbolTable);
  addtoclosure(closure5238, var_identifierNode);
  struct UserObject *uo5238 = (struct UserObject*)obj4798;
  uo5238->data[19] = (Object)closure5238;
  Method *meth_meth_ast_asIdentifier5238 = addmethod2pos(obj4798, "asIdentifier", &meth_ast_asIdentifier5238, 19);
  int argcv_meth_ast_asIdentifier5238[] = {0};
  meth_meth_ast_asIdentifier5238->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier5238);
  meth_meth_ast_asIdentifier5238->definitionModule = modulename;
  meth_meth_ast_asIdentifier5238->definitionLine = 1210;
// method "asString"
  struct UserObject *uo5278 = (struct UserObject*)obj4798;
  uo5278->data[20] = emptyclosure;
  Method *meth_meth_ast_asString5278 = addmethod2pos(obj4798, "asString", &meth_ast_asString5278, 20);
  int argcv_meth_ast_asString5278[] = {0};
  meth_meth_ast_asString5278->type = alloc_MethodType(1, argcv_meth_ast_asString5278);
  meth_meth_ast_asString5278->definitionModule = modulename;
  meth_meth_ast_asString5278->definitionLine = 1221;
// method "shallowCopy"
  block_savedest(obj4798);
  Object closure5292 = createclosure(1, "shallowCopy");
  setclosureframe(closure5292, stackframe);
  addtoclosure(closure5292, var_callNode);
  struct UserObject *uo5292 = (struct UserObject*)obj4798;
  uo5292->data[21] = (Object)closure5292;
  Method *meth_meth_ast_shallowCopy5292 = addmethod2pos(obj4798, "shallowCopy", &meth_ast_shallowCopy5292, 21);
  int argcv_meth_ast_shallowCopy5292[] = {0};
  meth_meth_ast_shallowCopy5292->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5292);
  meth_meth_ast_shallowCopy5292->definitionModule = modulename;
  meth_meth_ast_shallowCopy5292->definitionLine = 1222;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo5301 = (struct UserObject*)obj4798;
  uo5301->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5301 = addmethod2pos(obj4798, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_5301, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5301[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5301->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5301);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5301->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5301->definitionLine = 1225;
// method "statementName"
  struct UserObject *uo5312 = (struct UserObject*)obj4798;
  uo5312->data[23] = emptyclosure;
  Method *meth_meth_ast_statementName5312 = addmethod2pos(obj4798, "statementName", &meth_ast_statementName5312, 23);
  int argcv_meth_ast_statementName5312[] = {0};
  meth_meth_ast_statementName5312->type = alloc_MethodType(1, argcv_meth_ast_statementName5312);
  meth_meth_ast_statementName5312->definitionModule = modulename;
  meth_meth_ast_statementName5312->definitionLine = 1231;
  sourceObject = obj4798;
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5314 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5315 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5316 = gc_frame_new();
// call case 3: self.outer request
  Object call5317 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5316);
// compiled member node returning call5317 (depth = 5)
  Object call5318 = callmethodflags(call5317, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5315);
// compiled member node returning call5318 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5319 = callmethodflags(call5318, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5314);
// compiled call node returning call5319 (depth = 3)
  struct UserObject *obj4798_uo = (struct UserObject *)obj4798;
  obj4798_uo->super = call5319;
  sourceObject = obj4798;
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5320 == NULL) {
    strlit5320 = alloc_String("call");
    gc_root(strlit5320);
  }
// compiled string node returning strlit5320 (depth = 3)
  adddatum2(obj4798, strlit5320, 1);
  sourceObject = obj4798;
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_parts (depth = 3)
  adddatum2(obj4798, *var_parts, 2);
  sourceObject = obj4798;
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5321 = alloc_Boolean(0);
// compiled identifier node returning bool5321 (depth = 3)
  adddatum2(obj4798, bool5321, 3);
  sourceObject = obj4798;
// Begin line 1100
  setline(1100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5322 = alloc_Boolean(0);
// compiled identifier node returning bool5322 (depth = 3)
  adddatum2(obj4798, bool5322, 4);
  sourceObject = obj4798;
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_receiver_39_ (depth = 3)
  adddatum2(obj4798, *var_receiver_39_, 5);
  sourceObject = obj4798;
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5323 = alloc_Boolean(0);
// compiled identifier node returning bool5323 (depth = 3)
  adddatum2(obj4798, bool5323, 6);
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  objclass4798 = obj4798->class;
  objclass4798->definitionModule = modulename;
  objclass4798->definitionLine = 1091;
  (*(struct UserObject *)self).data[0] = lowerouter4798;
  self = oldself4798;
  selfslot = oldselfslot4798;
  stackframe = oldstackframe4798;
  gc_frame_end(frame);
  return obj4798;
}
Object meth_ast_new_40_2_41_4797_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_callNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_receiver_39_ = &(stackframe->slots[0]);
  *var_receiver_39_ = args[curarg];
  curarg++;
  Object *var_parts = &(stackframe->slots[1]);
  *var_parts = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4798 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4798 = alloc_userobj2(28,24, objclass4798);
  gc_frame_newslot(obj4798);
if (objclass4798 == NULL) {
  glfree(obj4798->class->name);
  obj4798->class->name = "callNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4798, self, 0);
  addmethodreal(obj4798,"outer", &reader_ast_outer_4799);
  Object oldself4798 = self;
  struct StackFrameObject *oldstackframe4798 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4798);
  gc_frame_newslot((Object)stackframe);
  self = obj4798;
  Object *oldselfslot4798 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4798 = (*(struct UserObject *)self).data[0], lowerouter4798 = thisouter4798;
  if (inheritingObject4798) {
    struct UserObject *inho4798 = (struct UserObject *)inheritingObject4798;
    while (inho4798->super != GraceDefaultObject) inho4798 = (struct UserObject *)inho4798->super;
    inho4798->super = obj4798;
    self = inheritingObject4798;
    *selfslot = self;
    lowerouter4798 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4798;
  }
if (objclass4798 == NULL) {
  Method *reader4800 = addmethodrealflags(obj4798, "kind",&reader_ast_kind_4800, MFLAG_DEF);
  reader4800->definitionModule = modulename;
  reader4800->definitionLine = 1097;
}
adddatum2(obj4798, alloc_Undefined(), 1);
if (objclass4798 == NULL) {
  Method *reader4801 = addmethodrealflags(obj4798, "with", &reader_ast_with_4801, 0);
  Method *writer4801 = addmethodrealflags(obj4798, "with:=(1)", &writer_ast_with_4801, 0);
  reader4801->definitionModule = modulename;
  writer4801->definitionModule = modulename;
  reader4801->definitionLine = 1098;
  writer4801->definitionLine = 1098;
}
obj4798->flags |= OFLAG_MUTABLE;
adddatum2(obj4798, alloc_Undefined(), 2);
if (objclass4798 == NULL) {
  Method *reader4802 = addmethodrealflags(obj4798, "generics", &reader_ast_generics_4802, 0);
  Method *writer4802 = addmethodrealflags(obj4798, "generics:=(1)", &writer_ast_generics_4802, 0);
  reader4802->definitionModule = modulename;
  writer4802->definitionModule = modulename;
  reader4802->definitionLine = 1099;
  writer4802->definitionLine = 1099;
}
obj4798->flags |= OFLAG_MUTABLE;
adddatum2(obj4798, alloc_Undefined(), 3);
if (objclass4798 == NULL) {
  Method *reader4803 = addmethodrealflags(obj4798, "isPattern", &reader_ast_isPattern_4803, 0);
  Method *writer4803 = addmethodrealflags(obj4798, "isPattern:=(1)", &writer_ast_isPattern_4803, 0);
  reader4803->definitionModule = modulename;
  writer4803->definitionModule = modulename;
  reader4803->definitionLine = 1100;
  writer4803->definitionLine = 1100;
}
obj4798->flags |= OFLAG_MUTABLE;
adddatum2(obj4798, alloc_Undefined(), 4);
if (objclass4798 == NULL) {
  Method *reader4804 = addmethodrealflags(obj4798, "receiver", &reader_ast_receiver_4804, 0);
  Method *writer4804 = addmethodrealflags(obj4798, "receiver:=(1)", &writer_ast_receiver_4804, 0);
  reader4804->definitionModule = modulename;
  writer4804->definitionModule = modulename;
  reader4804->definitionLine = 1101;
  writer4804->definitionLine = 1101;
}
obj4798->flags |= OFLAG_MUTABLE;
adddatum2(obj4798, alloc_Undefined(), 5);
if (objclass4798 == NULL) {
  Method *reader4805 = addmethodrealflags(obj4798, "isSelfRequest", &reader_ast_isSelfRequest_4805, 0);
  Method *writer4805 = addmethodrealflags(obj4798, "isSelfRequest:=(1)", &writer_ast_isSelfRequest_4805, 0);
  reader4805->definitionModule = modulename;
  writer4805->definitionModule = modulename;
  reader4805->definitionLine = 1102;
  writer4805->definitionLine = 1102;
}
obj4798->flags |= OFLAG_MUTABLE;
adddatum2(obj4798, alloc_Undefined(), 6);
// method "onSelf"
  struct UserObject *uo4806 = (struct UserObject*)obj4798;
  uo4806->data[7] = emptyclosure;
  Method *meth_meth_ast_onSelf4806 = addmethod2pos(obj4798, "onSelf", &meth_ast_onSelf4806, 7);
  int argcv_meth_ast_onSelf4806[] = {0};
  meth_meth_ast_onSelf4806->type = alloc_MethodType(1, argcv_meth_ast_onSelf4806);
  meth_meth_ast_onSelf4806->definitionModule = modulename;
  meth_meth_ast_onSelf4806->definitionLine = 1104;
// method "nameString"
  struct UserObject *uo4810 = (struct UserObject*)obj4798;
  uo4810->data[8] = emptyclosure;
  Method *meth_meth_ast_nameString4810 = addmethod2pos(obj4798, "nameString", &meth_ast_nameString4810, 8);
  int argcv_meth_ast_nameString4810[] = {0};
  meth_meth_ast_nameString4810->type = alloc_MethodType(1, argcv_meth_ast_nameString4810);
  meth_meth_ast_nameString4810->definitionModule = modulename;
  meth_meth_ast_nameString4810->definitionLine = 1110;
// method "canonicalName"
  struct UserObject *uo4824 = (struct UserObject*)obj4798;
  uo4824->data[9] = emptyclosure;
  Method *meth_meth_ast_canonicalName4824 = addmethod2pos(obj4798, "canonicalName", &meth_ast_canonicalName4824, 9);
  int argcv_meth_ast_canonicalName4824[] = {0};
  meth_meth_ast_canonicalName4824->type = alloc_MethodType(1, argcv_meth_ast_canonicalName4824);
  meth_meth_ast_canonicalName4824->definitionModule = modulename;
  meth_meth_ast_canonicalName4824->definitionLine = 1115;
// method "isCall"
  struct UserObject *uo4838 = (struct UserObject*)obj4798;
  uo4838->data[10] = emptyclosure;
  Method *meth_meth_ast_isCall4838 = addmethod2pos(obj4798, "isCall", &meth_ast_isCall4838, 10);
  int argcv_meth_ast_isCall4838[] = {0};
  meth_meth_ast_isCall4838->type = alloc_MethodType(1, argcv_meth_ast_isCall4838);
  meth_meth_ast_isCall4838->definitionModule = modulename;
  meth_meth_ast_isCall4838->definitionLine = 1121;
// method "returnsObject"
  struct UserObject *uo4840 = (struct UserObject*)obj4798;
  uo4840->data[11] = emptyclosure;
  Method *meth_meth_ast_returnsObject4840 = addmethod2pos(obj4798, "returnsObject", &meth_ast_returnsObject4840, 11);
  int argcv_meth_ast_returnsObject4840[] = {0};
  meth_meth_ast_returnsObject4840->type = alloc_MethodType(1, argcv_meth_ast_returnsObject4840);
  meth_meth_ast_returnsObject4840->definitionModule = modulename;
  meth_meth_ast_returnsObject4840->definitionLine = 1122;
// method "returnedObjectScope"
  struct UserObject *uo4886 = (struct UserObject*)obj4798;
  uo4886->data[12] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope4886 = addmethod2pos(obj4798, "returnedObjectScope", &meth_ast_returnedObjectScope4886, 12);
  int argcv_meth_ast_returnedObjectScope4886[] = {0};
  meth_meth_ast_returnedObjectScope4886->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope4886);
  meth_meth_ast_returnedObjectScope4886->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope4886->definitionLine = 1131;
// method "arguments"
  struct UserObject *uo4889 = (struct UserObject*)obj4798;
  uo4889->data[13] = emptyclosure;
  Method *meth_meth_ast_arguments4889 = addmethod2pos(obj4798, "arguments", &meth_ast_arguments4889, 13);
  int argcv_meth_ast_arguments4889[] = {0};
  meth_meth_ast_arguments4889->type = alloc_MethodType(1, argcv_meth_ast_arguments4889);
  meth_meth_ast_arguments4889->definitionModule = modulename;
  meth_meth_ast_arguments4889->definitionLine = 1135;
// method "argumentsDo(_)"
  struct UserObject *uo4907 = (struct UserObject*)obj4798;
  uo4907->data[14] = emptyclosure;
  Method *meth_meth_ast_argumentsDo_40_1_41_4907 = addmethod2pos(obj4798, "argumentsDo(1)", &meth_ast_argumentsDo_40_1_41_4907, 14);
  int argcv_meth_ast_argumentsDo_40_1_41_4907[] = {1};
  meth_meth_ast_argumentsDo_40_1_41_4907->type = alloc_MethodType(1, argcv_meth_ast_argumentsDo_40_1_41_4907);
  meth_meth_ast_argumentsDo_40_1_41_4907->definitionModule = modulename;
  meth_meth_ast_argumentsDo_40_1_41_4907->definitionLine = 1143;
// method "accept(_)from(_)"
  struct UserObject *uo4924 = (struct UserObject*)obj4798;
  uo4924->data[15] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_4924 = addmethod2pos(obj4798, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_4924, 15);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_4924[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_4924->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_4924);
  meth_meth_ast_accept_40_1_41_from_40_1_41_4924->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_4924->definitionLine = 1149;
// method "map(_)ancestors(_)"
  struct UserObject *uo4966 = (struct UserObject*)obj4798;
  uo4966->data[16] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_4966 = addmethod2pos(obj4798, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_4966, 16);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_4966[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4966->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_4966);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4966->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_4966->definitionLine = 1165;
// method "pretty(_)"
  struct UserObject *uo4999 = (struct UserObject*)obj4798;
  uo4999->data[17] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_4999 = addmethod2pos(obj4798, "pretty(1)", &meth_ast_pretty_40_1_41_4999, 17);
  int argcv_meth_ast_pretty_40_1_41_4999[] = {1};
  meth_meth_ast_pretty_40_1_41_4999->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_4999);
  meth_meth_ast_pretty_40_1_41_4999->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_4999->definitionLine = 1173;
// method "toGrace(_)"
  struct UserObject *uo5165 = (struct UserObject*)obj4798;
  uo5165->data[18] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_5165 = addmethod2pos(obj4798, "toGrace(1)", &meth_ast_toGrace_40_1_41_5165, 18);
  int argcv_meth_ast_toGrace_40_1_41_5165[] = {1};
  meth_meth_ast_toGrace_40_1_41_5165->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_5165);
meth_meth_ast_toGrace_40_1_41_5165->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_5165->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_5165->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_5165->definitionLine = 1197;
// method "asIdentifier"
  block_savedest(obj4798);
  Object closure5238 = createclosure(2, "asIdentifier");
  setclosureframe(closure5238, stackframe);
  addtoclosure(closure5238, var_fakeSymbolTable);
  addtoclosure(closure5238, var_identifierNode);
  struct UserObject *uo5238 = (struct UserObject*)obj4798;
  uo5238->data[19] = (Object)closure5238;
  Method *meth_meth_ast_asIdentifier5238 = addmethod2pos(obj4798, "asIdentifier", &meth_ast_asIdentifier5238, 19);
  int argcv_meth_ast_asIdentifier5238[] = {0};
  meth_meth_ast_asIdentifier5238->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier5238);
  meth_meth_ast_asIdentifier5238->definitionModule = modulename;
  meth_meth_ast_asIdentifier5238->definitionLine = 1210;
// method "asString"
  struct UserObject *uo5278 = (struct UserObject*)obj4798;
  uo5278->data[20] = emptyclosure;
  Method *meth_meth_ast_asString5278 = addmethod2pos(obj4798, "asString", &meth_ast_asString5278, 20);
  int argcv_meth_ast_asString5278[] = {0};
  meth_meth_ast_asString5278->type = alloc_MethodType(1, argcv_meth_ast_asString5278);
  meth_meth_ast_asString5278->definitionModule = modulename;
  meth_meth_ast_asString5278->definitionLine = 1221;
// method "shallowCopy"
  block_savedest(obj4798);
  Object closure5292 = createclosure(1, "shallowCopy");
  setclosureframe(closure5292, stackframe);
  addtoclosure(closure5292, var_callNode);
  struct UserObject *uo5292 = (struct UserObject*)obj4798;
  uo5292->data[21] = (Object)closure5292;
  Method *meth_meth_ast_shallowCopy5292 = addmethod2pos(obj4798, "shallowCopy", &meth_ast_shallowCopy5292, 21);
  int argcv_meth_ast_shallowCopy5292[] = {0};
  meth_meth_ast_shallowCopy5292->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5292);
  meth_meth_ast_shallowCopy5292->definitionModule = modulename;
  meth_meth_ast_shallowCopy5292->definitionLine = 1222;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo5301 = (struct UserObject*)obj4798;
  uo5301->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5301 = addmethod2pos(obj4798, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_5301, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5301[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5301->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5301);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5301->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5301->definitionLine = 1225;
// method "statementName"
  struct UserObject *uo5312 = (struct UserObject*)obj4798;
  uo5312->data[23] = emptyclosure;
  Method *meth_meth_ast_statementName5312 = addmethod2pos(obj4798, "statementName", &meth_ast_statementName5312, 23);
  int argcv_meth_ast_statementName5312[] = {0};
  meth_meth_ast_statementName5312->type = alloc_MethodType(1, argcv_meth_ast_statementName5312);
  meth_meth_ast_statementName5312->definitionModule = modulename;
  meth_meth_ast_statementName5312->definitionLine = 1231;
  sourceObject = obj4798;
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5314 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5315 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5316 = gc_frame_new();
// call case 3: self.outer request
  Object call5317 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5316);
// compiled member node returning call5317 (depth = 5)
  Object call5318 = callmethodflags(call5317, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5315);
// compiled member node returning call5318 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5319 = callmethodflags(call5318, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5314);
// compiled call node returning call5319 (depth = 3)
  struct UserObject *obj4798_uo = (struct UserObject *)obj4798;
  obj4798_uo->super = call5319;
  sourceObject = obj4798;
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5320 == NULL) {
    strlit5320 = alloc_String("call");
    gc_root(strlit5320);
  }
// compiled string node returning strlit5320 (depth = 3)
  adddatum2(obj4798, strlit5320, 1);
  sourceObject = obj4798;
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_parts (depth = 3)
  adddatum2(obj4798, *var_parts, 2);
  sourceObject = obj4798;
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5321 = alloc_Boolean(0);
// compiled identifier node returning bool5321 (depth = 3)
  adddatum2(obj4798, bool5321, 3);
  sourceObject = obj4798;
// Begin line 1100
  setline(1100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5322 = alloc_Boolean(0);
// compiled identifier node returning bool5322 (depth = 3)
  adddatum2(obj4798, bool5322, 4);
  sourceObject = obj4798;
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_receiver_39_ (depth = 3)
  adddatum2(obj4798, *var_receiver_39_, 5);
  sourceObject = obj4798;
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5323 = alloc_Boolean(0);
// compiled identifier node returning bool5323 (depth = 3)
  adddatum2(obj4798, bool5323, 6);
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  sourceObject = obj4798;
  objclass4798 = obj4798->class;
  objclass4798->definitionModule = modulename;
  objclass4798->definitionLine = 1091;
  (*(struct UserObject *)self).data[0] = lowerouter4798;
  self = oldself4798;
  selfslot = oldselfslot4798;
  stackframe = oldstackframe4798;
  gc_frame_end(frame);
  return obj4798;
}
Object meth_ast_callNode5325(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_callNode (depth = 3)
  gc_frame_end(frame);
  return *var_callNode;
}
Object meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5328(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body(1)named(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)scope(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)scope(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for body(_)named(_)scope(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part body(_)");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part named(_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1236
  setline(1236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5329 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// call case 4: self request
  params[0] = *var_b;
  partcv[0] = 1;
  Object call5330 = callmethodflags(self, "body(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5329);
// compiled call node returning call5330 (depth = 4)
  *var_result = call5330;
  if (call5330 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5331 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5332 = callmethodflags(*var_result, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5331);
// compiled call node returning call5332 (depth = 3)
// Begin line 1238
  setline(1238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5333 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call5334 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5333);
// compiled call node returning call5334 (depth = 3)
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_body_40_1_41_named_40_1_41_5335(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body(1)named(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for body(_)named(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part body(_)");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part named(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5336 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// call case 4: self request
  params[0] = *var_b;
  partcv[0] = 1;
  Object call5337 = callmethodflags(self, "body(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5336);
// compiled call node returning call5337 (depth = 4)
  *var_result = call5337;
  if (call5337 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5338 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5339 = callmethodflags(*var_result, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5338);
// compiled call node returning call5339 (depth = 3)
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_isModule5346(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isModule");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1254
  setline(1254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5347 = alloc_Boolean(1);
// compiled identifier node returning bool5347 (depth = 3)
  gc_frame_end(frame);
  return bool5347;
}
Object meth_ast_returnsObject5348(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1255
  setline(1255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5349 = alloc_Boolean(0);
// compiled identifier node returning bool5349 (depth = 3)
  gc_frame_end(frame);
  return bool5349;
}
Object meth_ast__apply_40_1_41_5353(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1258
  setline(1258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5355 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  Object call5356 = callmethodflags(*var_o, "isExternal", 0, partcv, params, 0);
  gc_frame_end(callframe5355);
// compiled member node returning call5356 (depth = 6)
  Object if5354 = done;
  if (istrue(call5356)) {
// starting to compile call node (depth = 6)
  int callframe5357 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5358 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5357);
// compiled call node returning call5358 (depth = 6)
    gc_frame_newslot(call5358);
    if5354 = call5358;
  } else {
  }
// compiled if node returning if5354 (depth = 5)
  gc_frame_end(frame);
  return if5354;
}
Object meth_ast_externalsDo_40_1_41_5350(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "externalsDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method externalsDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for externalsDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part externalsDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5351 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5352 = alloc_Block(NULL, NULL, "ast", 1257);
  gc_frame_newslot(block5352);
// method "_apply(_)"
  block_savedest(block5352);
  Object closure5353 = createclosure(2, "_apply(1)");
  setclosureframe(closure5353, stackframe);
  addtoclosure(closure5353, var_action);
  addtoclosure(closure5353, selfslot);
  struct UserObject *uo5353 = (struct UserObject*)block5352;
  uo5353->data[0] = (Object)closure5353;
  Method *meth_meth_ast__apply_40_1_41_5353 = addmethod2pos(block5352, "_apply(1)", &meth_ast__apply_40_1_41_5353, 0);
  int argcv_meth_ast__apply_40_1_41_5353[] = {1};
  meth_meth_ast__apply_40_1_41_5353->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5353);
  meth_meth_ast__apply_40_1_41_5353->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5353->definitionLine = 2981;
// compiled block node returning block5352 (depth = 4)
  gc_frame_newslot(block5352);
// call case 6: other requests
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5360 = gc_frame_new();
// call case 4: self request
  Object call5361 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5360);
// compiled member node returning call5361 (depth = 4)
  params[0] = block5352;
  partcv[0] = 1;
  Object call5362 = callmethodflags(call5361, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5351);
// compiled call node returning call5362 (depth = 3)
  gc_frame_end(frame);
  return call5362;
}
Object meth_ast__apply_40_1_41_5384(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1268
  setline(1268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5385 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5386 = callmethodflags(*var_x, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5385);
// compiled call node returning call5386 (depth = 6)
  gc_frame_end(frame);
  return call5386;
}
Object meth_ast_accept_40_1_41_from_40_1_41_5363(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5365 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5366 = callmethodflags(*var_visitor, "visitModule(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5365);
// compiled call node returning call5366 (depth = 4)
  Object if5364 = done;
  if (istrue(call5366)) {
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5367 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call5368 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5367);
// compiled call node returning call5368 (depth = 5)
  *var_newChain = call5368;
  if (call5368 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5371 = gc_frame_new();
// call case 4: self request
  Object call5372 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5371);
// compiled member node returning call5372 (depth = 6)
  int op_slot_right_5370 = gc_frame_newslot(call5372);
// starting to compile identifier node (depth = 6)
  Object bool5374 = alloc_Boolean(0);
// compiled identifier node returning bool5374 (depth = 6)
  int op_slot_left_5370 = gc_frame_newslot(bool5374);
  params[0] = call5372;
  partcv[0] = 1;
  Object opresult5375 = callmethod(bool5374, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5375 (depth = 5)
  Object if5369 = done;
  if (istrue(opresult5375)) {
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5376 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5377 = gc_frame_new();
// call case 4: self request
  Object call5378 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5377);
// compiled member node returning call5378 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5379 = callmethodflags(call5378, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5376);
// compiled call node returning call5379 (depth = 5)
    gc_frame_newslot(call5379);
    if5369 = call5379;
  } else {
  }
// compiled if node returning if5369 (depth = 4)
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5380 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5381 = gc_frame_new();
// call case 4: self request
  Object call5382 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5381);
// compiled member node returning call5382 (depth = 5)
  gc_frame_newslot(call5382);
// starting to compile block node (depth = 5)
  Object block5383 = alloc_Block(NULL, NULL, "ast", 1267);
  gc_frame_newslot(block5383);
// method "_apply(_)"
  block_savedest(block5383);
  Object closure5384 = createclosure(3, "_apply(1)");
  setclosureframe(closure5384, stackframe);
  addtoclosure(closure5384, var_visitor);
  addtoclosure(closure5384, var_newChain);
  addtoclosure(closure5384, selfslot);
  struct UserObject *uo5384 = (struct UserObject*)block5383;
  uo5384->data[0] = (Object)closure5384;
  Method *meth_meth_ast__apply_40_1_41_5384 = addmethod2pos(block5383, "_apply(1)", &meth_ast__apply_40_1_41_5384, 0);
  int argcv_meth_ast__apply_40_1_41_5384[] = {1};
  meth_meth_ast__apply_40_1_41_5384->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5384);
  meth_meth_ast__apply_40_1_41_5384->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5384->definitionLine = 2981;
// compiled block node returning block5383 (depth = 5)
  gc_frame_newslot(block5383);
// call case 5: prelude request
  params[0] = call5382;
  params[1] = block5383;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5388 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5380);
// compiled call node returning call5388 (depth = 4)
    gc_frame_newslot(call5388);
    if5364 = call5388;
  } else {
  }
// compiled if node returning if5364 (depth = 3)
  gc_frame_end(frame);
  return if5364;
}
Object meth_ast_shallowCopy5389(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_moduleNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1273
  setline(1273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5390 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe5391 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_moduleNode (depth = 5)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call5392 = callmethodflags(*var_moduleNode, "body(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5391);
// compiled call node returning call5392 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5393 = callmethodflags(call5392, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5390);
// compiled call node returning call5393 (depth = 3)
  gc_frame_end(frame);
  return call5393;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_5394(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1276
  setline(1276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5395 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call5396 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5395);
// compiled call node returning call5396 (depth = 3)
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5397 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5398 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5399 = callmethodflags(*var_other, "imports", 0, partcv, params, 0);
  gc_frame_end(callframe5398);
// compiled member node returning call5399 (depth = 4)
  gc_frame_newslot(call5399);
// call case 4: self request
  params[0] = call5399;
  partcv[0] = 1;
  Object call5400 = callmethodflags(self, "imports:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5397);
// compiled call node returning call5400 (depth = 3)
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_body_40_1_41_5340(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "body(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)");
  Object params[3];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_moduleNode = getfromclosure(closure, 1);
  Object *var_objectNode = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for body(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part body(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5341 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5341 = alloc_userobj2(12,12, objclass5341);
  gc_frame_newslot(obj5341);
if (objclass5341 == NULL) {
  glfree(obj5341->class->name);
  obj5341->class->name = "moduleNode.body(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5341, self, 0);
  addmethodreal(obj5341,"outer", &reader_ast_outer_5342);
  Object oldself5341 = self;
  struct StackFrameObject *oldstackframe5341 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5341);
  gc_frame_newslot((Object)stackframe);
  self = obj5341;
  Object *oldselfslot5341 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5341 = (*(struct UserObject *)self).data[0], lowerouter5341 = thisouter5341;
  if (inheritingObject5341) {
    struct UserObject *inho5341 = (struct UserObject *)inheritingObject5341;
    while (inho5341->super != GraceDefaultObject) inho5341 = (struct UserObject *)inho5341->super;
    inho5341->super = obj5341;
    self = inheritingObject5341;
    *selfslot = self;
    lowerouter5341 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5341;
  }
if (objclass5341 == NULL) {
  Method *reader5343 = addmethodrealflags(obj5341, "kind",&reader_ast_kind_5343, MFLAG_DEF);
  reader5343->definitionModule = modulename;
  reader5343->definitionLine = 1248;
}
adddatum2(obj5341, alloc_Undefined(), 1);
if (objclass5341 == NULL) {
  Method *reader5344 = addmethodrealflags(obj5341, "sourceLines",&reader_ast_sourceLines_5344, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader5344->definitionModule = modulename;
  reader5344->definitionLine = 1249;
}
adddatum2(obj5341, alloc_Undefined(), 2);
if (objclass5341 == NULL) {
  Method *reader5345 = addmethodrealflags(obj5341, "imports", &reader_ast_imports_5345, 0);
  Method *writer5345 = addmethodrealflags(obj5341, "imports:=(1)", &writer_ast_imports_5345, 0);
  reader5345->definitionModule = modulename;
  writer5345->definitionModule = modulename;
  reader5345->definitionLine = 1252;
  writer5345->definitionLine = 1252;
}
obj5341->flags |= OFLAG_MUTABLE;
adddatum2(obj5341, alloc_Undefined(), 3);
// method "isModule"
  struct UserObject *uo5346 = (struct UserObject*)obj5341;
  uo5346->data[4] = emptyclosure;
  Method *meth_meth_ast_isModule5346 = addmethod2pos(obj5341, "isModule", &meth_ast_isModule5346, 4);
  int argcv_meth_ast_isModule5346[] = {0};
  meth_meth_ast_isModule5346->type = alloc_MethodType(1, argcv_meth_ast_isModule5346);
  meth_meth_ast_isModule5346->definitionModule = modulename;
  meth_meth_ast_isModule5346->definitionLine = 1254;
// method "returnsObject"
  struct UserObject *uo5348 = (struct UserObject*)obj5341;
  uo5348->data[5] = emptyclosure;
  Method *meth_meth_ast_returnsObject5348 = addmethod2pos(obj5341, "returnsObject", &meth_ast_returnsObject5348, 5);
  int argcv_meth_ast_returnsObject5348[] = {0};
  meth_meth_ast_returnsObject5348->type = alloc_MethodType(1, argcv_meth_ast_returnsObject5348);
  meth_meth_ast_returnsObject5348->definitionModule = modulename;
  meth_meth_ast_returnsObject5348->definitionLine = 1255;
// method "externalsDo(_)"
  struct UserObject *uo5350 = (struct UserObject*)obj5341;
  uo5350->data[6] = emptyclosure;
  Method *meth_meth_ast_externalsDo_40_1_41_5350 = addmethod2pos(obj5341, "externalsDo(1)", &meth_ast_externalsDo_40_1_41_5350, 6);
  int argcv_meth_ast_externalsDo_40_1_41_5350[] = {1};
  meth_meth_ast_externalsDo_40_1_41_5350->type = alloc_MethodType(1, argcv_meth_ast_externalsDo_40_1_41_5350);
  meth_meth_ast_externalsDo_40_1_41_5350->definitionModule = modulename;
  meth_meth_ast_externalsDo_40_1_41_5350->definitionLine = 1256;
// method "accept(_)from(_)"
  struct UserObject *uo5363 = (struct UserObject*)obj5341;
  uo5363->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_5363 = addmethod2pos(obj5341, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_5363, 7);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_5363[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_5363->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_5363);
  meth_meth_ast_accept_40_1_41_from_40_1_41_5363->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_5363->definitionLine = 1261;
// method "shallowCopy"
  block_savedest(obj5341);
  Object closure5389 = createclosure(2, "shallowCopy");
  setclosureframe(closure5389, stackframe);
  addtoclosure(closure5389, var_emptySeq);
  addtoclosure(closure5389, var_moduleNode);
  struct UserObject *uo5389 = (struct UserObject*)obj5341;
  uo5389->data[8] = (Object)closure5389;
  Method *meth_meth_ast_shallowCopy5389 = addmethod2pos(obj5341, "shallowCopy", &meth_ast_shallowCopy5389, 8);
  int argcv_meth_ast_shallowCopy5389[] = {0};
  meth_meth_ast_shallowCopy5389->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5389);
  meth_meth_ast_shallowCopy5389->definitionModule = modulename;
  meth_meth_ast_shallowCopy5389->definitionLine = 1272;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo5394 = (struct UserObject*)obj5341;
  uo5394->data[9] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5394 = addmethod2pos(obj5341, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_5394, 9);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5394[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5394->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5394);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5394->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5394->definitionLine = 1275;
  sourceObject = obj5341;
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5401 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
  Object bool5402 = alloc_Boolean(0);
// compiled identifier node returning bool5402 (depth = 4)
  gc_frame_newslot(bool5402);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objectNode (depth = 4)
  params[0] = *var_b;
  params[1] = bool5402;
  params[2] = self;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5403 = callmethodflags(*var_objectNode, "new(2)$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5401);
// compiled call node returning call5403 (depth = 3)
  struct UserObject *obj5341_uo = (struct UserObject *)obj5341;
  obj5341_uo->super = call5403;
  sourceObject = obj5341;
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5404 == NULL) {
    strlit5404 = alloc_String("module");
    gc_root(strlit5404);
  }
// compiled string node returning strlit5404 (depth = 3)
  adddatum2(obj5341, strlit5404, 1);
  sourceObject = obj5341;
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5405 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  Object call5406 = callmethodflags(*var_util, "lines", 0, partcv, params, 0);
  gc_frame_end(callframe5405);
// compiled member node returning call5406 (depth = 3)
  adddatum2(obj5341, call5406, 2);
  sourceObject = obj5341;
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5407 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5408 = alloc_Float64(0);
// compiled num node returning num5408 (depth = 4)
  gc_frame_newslot(num5408);
// call case 4: self request
  params[0] = num5408;
  partcv[0] = 1;
  Object call5409 = callmethodflags(self, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5407);
// compiled call node returning call5409 (depth = 3)
  sourceObject = obj5341;
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5410 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5411 = alloc_Float64(0);
// compiled num node returning num5411 (depth = 4)
  gc_frame_newslot(num5411);
// call case 4: self request
  params[0] = num5411;
  partcv[0] = 1;
  Object call5412 = callmethodflags(self, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5410);
// compiled call node returning call5412 (depth = 3)
  sourceObject = obj5341;
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array5413 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5413 (depth = 3)
  adddatum2(obj5341, array5413, 3);
  sourceObject = obj5341;
  sourceObject = obj5341;
  sourceObject = obj5341;
  sourceObject = obj5341;
  sourceObject = obj5341;
  sourceObject = obj5341;
  objclass5341 = obj5341->class;
  objclass5341->definitionModule = modulename;
  objclass5341->definitionLine = 1246;
  (*(struct UserObject *)self).data[0] = lowerouter5341;
  self = oldself5341;
  selfslot = oldselfslot5341;
  stackframe = oldstackframe5341;
  gc_frame_end(frame);
  return obj5341;
}
Object meth_ast_body_40_1_41_5340_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "body(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method body(_)");
  Object params[3];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_moduleNode = getfromclosure(closure, 1);
  Object *var_objectNode = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for body(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part body(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5341 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5341 = alloc_userobj2(12,12, objclass5341);
  gc_frame_newslot(obj5341);
if (objclass5341 == NULL) {
  glfree(obj5341->class->name);
  obj5341->class->name = "moduleNode.body(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5341, self, 0);
  addmethodreal(obj5341,"outer", &reader_ast_outer_5342);
  Object oldself5341 = self;
  struct StackFrameObject *oldstackframe5341 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5341);
  gc_frame_newslot((Object)stackframe);
  self = obj5341;
  Object *oldselfslot5341 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5341 = (*(struct UserObject *)self).data[0], lowerouter5341 = thisouter5341;
  if (inheritingObject5341) {
    struct UserObject *inho5341 = (struct UserObject *)inheritingObject5341;
    while (inho5341->super != GraceDefaultObject) inho5341 = (struct UserObject *)inho5341->super;
    inho5341->super = obj5341;
    self = inheritingObject5341;
    *selfslot = self;
    lowerouter5341 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5341;
  }
if (objclass5341 == NULL) {
  Method *reader5343 = addmethodrealflags(obj5341, "kind",&reader_ast_kind_5343, MFLAG_DEF);
  reader5343->definitionModule = modulename;
  reader5343->definitionLine = 1248;
}
adddatum2(obj5341, alloc_Undefined(), 1);
if (objclass5341 == NULL) {
  Method *reader5344 = addmethodrealflags(obj5341, "sourceLines",&reader_ast_sourceLines_5344, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader5344->definitionModule = modulename;
  reader5344->definitionLine = 1249;
}
adddatum2(obj5341, alloc_Undefined(), 2);
if (objclass5341 == NULL) {
  Method *reader5345 = addmethodrealflags(obj5341, "imports", &reader_ast_imports_5345, 0);
  Method *writer5345 = addmethodrealflags(obj5341, "imports:=(1)", &writer_ast_imports_5345, 0);
  reader5345->definitionModule = modulename;
  writer5345->definitionModule = modulename;
  reader5345->definitionLine = 1252;
  writer5345->definitionLine = 1252;
}
obj5341->flags |= OFLAG_MUTABLE;
adddatum2(obj5341, alloc_Undefined(), 3);
// method "isModule"
  struct UserObject *uo5346 = (struct UserObject*)obj5341;
  uo5346->data[4] = emptyclosure;
  Method *meth_meth_ast_isModule5346 = addmethod2pos(obj5341, "isModule", &meth_ast_isModule5346, 4);
  int argcv_meth_ast_isModule5346[] = {0};
  meth_meth_ast_isModule5346->type = alloc_MethodType(1, argcv_meth_ast_isModule5346);
  meth_meth_ast_isModule5346->definitionModule = modulename;
  meth_meth_ast_isModule5346->definitionLine = 1254;
// method "returnsObject"
  struct UserObject *uo5348 = (struct UserObject*)obj5341;
  uo5348->data[5] = emptyclosure;
  Method *meth_meth_ast_returnsObject5348 = addmethod2pos(obj5341, "returnsObject", &meth_ast_returnsObject5348, 5);
  int argcv_meth_ast_returnsObject5348[] = {0};
  meth_meth_ast_returnsObject5348->type = alloc_MethodType(1, argcv_meth_ast_returnsObject5348);
  meth_meth_ast_returnsObject5348->definitionModule = modulename;
  meth_meth_ast_returnsObject5348->definitionLine = 1255;
// method "externalsDo(_)"
  struct UserObject *uo5350 = (struct UserObject*)obj5341;
  uo5350->data[6] = emptyclosure;
  Method *meth_meth_ast_externalsDo_40_1_41_5350 = addmethod2pos(obj5341, "externalsDo(1)", &meth_ast_externalsDo_40_1_41_5350, 6);
  int argcv_meth_ast_externalsDo_40_1_41_5350[] = {1};
  meth_meth_ast_externalsDo_40_1_41_5350->type = alloc_MethodType(1, argcv_meth_ast_externalsDo_40_1_41_5350);
  meth_meth_ast_externalsDo_40_1_41_5350->definitionModule = modulename;
  meth_meth_ast_externalsDo_40_1_41_5350->definitionLine = 1256;
// method "accept(_)from(_)"
  struct UserObject *uo5363 = (struct UserObject*)obj5341;
  uo5363->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_5363 = addmethod2pos(obj5341, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_5363, 7);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_5363[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_5363->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_5363);
  meth_meth_ast_accept_40_1_41_from_40_1_41_5363->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_5363->definitionLine = 1261;
// method "shallowCopy"
  block_savedest(obj5341);
  Object closure5389 = createclosure(2, "shallowCopy");
  setclosureframe(closure5389, stackframe);
  addtoclosure(closure5389, var_emptySeq);
  addtoclosure(closure5389, var_moduleNode);
  struct UserObject *uo5389 = (struct UserObject*)obj5341;
  uo5389->data[8] = (Object)closure5389;
  Method *meth_meth_ast_shallowCopy5389 = addmethod2pos(obj5341, "shallowCopy", &meth_ast_shallowCopy5389, 8);
  int argcv_meth_ast_shallowCopy5389[] = {0};
  meth_meth_ast_shallowCopy5389->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5389);
  meth_meth_ast_shallowCopy5389->definitionModule = modulename;
  meth_meth_ast_shallowCopy5389->definitionLine = 1272;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo5394 = (struct UserObject*)obj5341;
  uo5394->data[9] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5394 = addmethod2pos(obj5341, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_5394, 9);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5394[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5394->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5394);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5394->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5394->definitionLine = 1275;
  sourceObject = obj5341;
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5401 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
  Object bool5402 = alloc_Boolean(0);
// compiled identifier node returning bool5402 (depth = 4)
  gc_frame_newslot(bool5402);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objectNode (depth = 4)
  params[0] = *var_b;
  params[1] = bool5402;
  params[2] = self;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5403 = callmethodflags(*var_objectNode, "new(2)$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5401);
// compiled call node returning call5403 (depth = 3)
  struct UserObject *obj5341_uo = (struct UserObject *)obj5341;
  obj5341_uo->super = call5403;
  sourceObject = obj5341;
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5404 == NULL) {
    strlit5404 = alloc_String("module");
    gc_root(strlit5404);
  }
// compiled string node returning strlit5404 (depth = 3)
  adddatum2(obj5341, strlit5404, 1);
  sourceObject = obj5341;
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5405 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  Object call5406 = callmethodflags(*var_util, "lines", 0, partcv, params, 0);
  gc_frame_end(callframe5405);
// compiled member node returning call5406 (depth = 3)
  adddatum2(obj5341, call5406, 2);
  sourceObject = obj5341;
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5407 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5408 = alloc_Float64(0);
// compiled num node returning num5408 (depth = 4)
  gc_frame_newslot(num5408);
// call case 4: self request
  params[0] = num5408;
  partcv[0] = 1;
  Object call5409 = callmethodflags(self, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5407);
// compiled call node returning call5409 (depth = 3)
  sourceObject = obj5341;
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5410 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5411 = alloc_Float64(0);
// compiled num node returning num5411 (depth = 4)
  gc_frame_newslot(num5411);
// call case 4: self request
  params[0] = num5411;
  partcv[0] = 1;
  Object call5412 = callmethodflags(self, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5410);
// compiled call node returning call5412 (depth = 3)
  sourceObject = obj5341;
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array5413 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5413 (depth = 3)
  adddatum2(obj5341, array5413, 3);
  sourceObject = obj5341;
  sourceObject = obj5341;
  sourceObject = obj5341;
  sourceObject = obj5341;
  sourceObject = obj5341;
  sourceObject = obj5341;
  objclass5341 = obj5341->class;
  objclass5341->definitionModule = modulename;
  objclass5341->definitionLine = 1246;
  (*(struct UserObject *)self).data[0] = lowerouter5341;
  self = oldself5341;
  selfslot = oldselfslot5341;
  stackframe = oldstackframe5341;
  gc_frame_end(frame);
  return obj5341;
}
Object meth_ast_moduleNode5415(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "moduleNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_moduleNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1234
  setline(1234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_moduleNode (depth = 3)
  gc_frame_end(frame);
  return *var_moduleNode;
}
Object meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5418(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body(1)named(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)scope(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)scope(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for body(_)named(_)scope(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part body(_)");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part named(_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5419 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 5)
  Object bool5420 = alloc_Boolean(0);
// compiled identifier node returning bool5420 (depth = 5)
  gc_frame_newslot(bool5420);
// call case 4: self request
  params[0] = *var_b;
  params[1] = bool5420;
  partcv[0] = 2;
  Object call5421 = callmethodflags(self, "new(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5419);
// compiled call node returning call5421 (depth = 4)
  *var_result = call5421;
  if (call5421 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5422 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5423 = callmethodflags(*var_result, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5422);
// compiled call node returning call5423 (depth = 3)
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5424 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call5425 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5424);
// compiled call node returning call5425 (depth = 3)
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_body_40_1_41_named_40_1_41_5426(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "body(1)named(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body(_)named(_)");
  Object params[3];
  int partcv[3];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for body(_)named(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part body(_)");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part named(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5427 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_fakeSymbolTable (depth = 4)
  gc_frame_newslot(*var_fakeSymbolTable);
// call case 4: self request
  params[0] = *var_b;
  params[1] = *var_n;
  params[2] = *var_fakeSymbolTable;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5428 = callmethodflags(self, "body(1)named(1)scope(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5427);
// compiled call node returning call5428 (depth = 3)
  gc_frame_end(frame);
  return call5428;
}
Object meth_ast_description5441(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "description");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1305
  setline(1305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5443 = gc_frame_new();
// call case 4: self request
  Object call5444 = callmethodflags(self, "isTrait", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5443);
// compiled member node returning call5444 (depth = 4)
  Object if5442 = done;
  if (istrue(call5444)) {
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5446 == NULL) {
    strlit5446 = alloc_String(" (trait)");
    gc_root(strlit5446);
  }
// compiled string node returning strlit5446 (depth = 5)
  int op_slot_right_5445 = gc_frame_newslot(strlit5446);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5449 = gc_frame_new();
// call case 4: self request
  Object call5450 = callmethodflags(self, "kind", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5449);
// compiled member node returning call5450 (depth = 6)
  int op_slot_right_5448 = gc_frame_newslot(call5450);
// starting to compile string node (depth = 6)
  if (strlit5452 == NULL) {
    strlit5452 = alloc_String("");
    gc_root(strlit5452);
  }
// compiled string node returning strlit5452 (depth = 6)
  int op_slot_left_5448 = gc_frame_newslot(strlit5452);
  params[0] = call5450;
  partcv[0] = 1;
  Object opresult5453 = callmethod(strlit5452, "++(1)", 1, partcv, params);
// compiled op node returning opresult5453 (depth = 5)
  int op_slot_left_5445 = gc_frame_newslot(opresult5453);
  params[0] = strlit5446;
  partcv[0] = 1;
  Object opresult5454 = callmethod(opresult5453, "++(1)", 1, partcv, params);
// compiled op node returning opresult5454 (depth = 4)
    gc_frame_newslot(opresult5454);
    if5442 = opresult5454;
  } else {
// Begin line 1309
  setline(1309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1307
  setline(1307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5456 = gc_frame_new();
// call case 4: self request
  Object call5457 = callmethodflags(self, "inClass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5456);
// compiled member node returning call5457 (depth = 5)
  Object if5455 = done;
  if (istrue(call5457)) {
// Begin line 1308
  setline(1308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5459 == NULL) {
    strlit5459 = alloc_String(" (class)");
    gc_root(strlit5459);
  }
// compiled string node returning strlit5459 (depth = 6)
  int op_slot_right_5458 = gc_frame_newslot(strlit5459);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5462 = gc_frame_new();
// call case 4: self request
  Object call5463 = callmethodflags(self, "kind", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5462);
// compiled member node returning call5463 (depth = 7)
  int op_slot_right_5461 = gc_frame_newslot(call5463);
// starting to compile string node (depth = 7)
  if (strlit5465 == NULL) {
    strlit5465 = alloc_String("");
    gc_root(strlit5465);
  }
// compiled string node returning strlit5465 (depth = 7)
  int op_slot_left_5461 = gc_frame_newslot(strlit5465);
  params[0] = call5463;
  partcv[0] = 1;
  Object opresult5466 = callmethod(strlit5465, "++(1)", 1, partcv, params);
// compiled op node returning opresult5466 (depth = 6)
  int op_slot_left_5458 = gc_frame_newslot(opresult5466);
  params[0] = strlit5459;
  partcv[0] = 1;
  Object opresult5467 = callmethod(opresult5466, "++(1)", 1, partcv, params);
// compiled op node returning opresult5467 (depth = 5)
    gc_frame_newslot(opresult5467);
    if5455 = opresult5467;
  } else {
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5468 = gc_frame_new();
// call case 4: self request
  Object call5469 = callmethodflags(self, "kind", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5468);
// compiled member node returning call5469 (depth = 5)
    gc_frame_newslot(call5469);
    if5455 = call5469;
  }
// compiled if node returning if5455 (depth = 4)
    gc_frame_newslot(if5455);
    if5442 = if5455;
  }
// compiled if node returning if5442 (depth = 3)
  gc_frame_end(frame);
  return if5442;
}
Object meth_ast__apply_40_1_41_5485(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1319
  setline(1319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5487 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5488 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  Object call5489 = callmethodflags(*var_each, "isLegalInTrait", 0, partcv, params, 0);
  gc_frame_end(callframe5488);
// compiled member node returning call5489 (depth = 7)
  Object call5490 = callmethodflags(call5489, "not", 0, partcv, params, 0);
  gc_frame_end(callframe5487);
// compiled member node returning call5490 (depth = 6)
  Object if5486 = done;
  if (istrue(call5490)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool5491 = alloc_Boolean(0);
// compiled identifier node returning bool5491 (depth = 7)
  block_return(realself, bool5491);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if5486 = undefined;
  } else {
  }
// compiled if node returning if5486 (depth = 5)
  gc_frame_end(frame);
  return if5486;
}
Object meth_ast_isTrait5470(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1316
  setline(1316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5472 = gc_frame_new();
// call case 4: self request
  Object call5473 = callmethodflags(self, "inTrait", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5472);
// compiled member node returning call5473 (depth = 4)
  Object if5471 = done;
  if (istrue(call5473)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool5474 = alloc_Boolean(1);
// compiled identifier node returning bool5474 (depth = 5)
  return bool5474;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5471 = undefined;
  } else {
  }
// compiled if node returning if5471 (depth = 3)
// Begin line 1317
  setline(1317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5477 = gc_frame_new();
// call case 4: self request
  Object call5478 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5477);
// compiled member node returning call5478 (depth = 5)
  int op_slot_right_5476 = gc_frame_newslot(call5478);
// starting to compile identifier node (depth = 5)
  Object bool5480 = alloc_Boolean(0);
// compiled identifier node returning bool5480 (depth = 5)
  int op_slot_left_5476 = gc_frame_newslot(bool5480);
  params[0] = call5478;
  partcv[0] = 1;
  Object opresult5481 = callmethod(bool5480, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5481 (depth = 4)
  Object if5475 = done;
  if (istrue(opresult5481)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool5482 = alloc_Boolean(0);
// compiled identifier node returning bool5482 (depth = 5)
  return bool5482;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5475 = undefined;
  } else {
  }
// compiled if node returning if5475 (depth = 3)
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5483 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5484 = alloc_Block(NULL, NULL, "ast", 1318);
  gc_frame_newslot(block5484);
// method "_apply(_)"
  block_savedest(block5484);
  Object closure5485 = createclosure(1, "_apply(1)");
  setclosureframe(closure5485, stackframe);
  addtoclosure(closure5485, selfslot);
  struct UserObject *uo5485 = (struct UserObject*)block5484;
  uo5485->data[0] = (Object)closure5485;
  Method *meth_meth_ast__apply_40_1_41_5485 = addmethod2pos(block5484, "_apply(1)", &meth_ast__apply_40_1_41_5485, 0);
  int argcv_meth_ast__apply_40_1_41_5485[] = {1};
  meth_meth_ast__apply_40_1_41_5485->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5485);
  meth_meth_ast__apply_40_1_41_5485->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5485->definitionLine = 2981;
// compiled block node returning block5484 (depth = 4)
  gc_frame_newslot(block5484);
// call case 6: other requests
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5493 = gc_frame_new();
// call case 4: self request
  Object call5494 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5493);
// compiled member node returning call5494 (depth = 4)
  params[0] = block5484;
  partcv[0] = 1;
  Object call5495 = callmethodflags(call5494, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5483);
// compiled call node returning call5495 (depth = 3)
// Begin line 1321
  setline(1321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool5496 = alloc_Boolean(1);
// compiled identifier node returning bool5496 (depth = 4)
  return bool5496;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast__apply_40_1_41_5511(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1330
  setline(1330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe5514 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_node (depth = 9)
  Object call5515 = callmethodflags(*var_node, "isMethod", 0, partcv, params, 0);
  gc_frame_end(callframe5514);
// compiled member node returning call5515 (depth = 8)
  int op_slot_right_5513 = gc_frame_newslot(call5515);
// starting to compile member node (depth = 8)
  int callframe5517 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_node (depth = 9)
  Object call5518 = callmethodflags(*var_node, "isFieldDec", 0, partcv, params, 0);
  gc_frame_end(callframe5517);
// compiled member node returning call5518 (depth = 8)
  int op_slot_left_5513 = gc_frame_newslot(call5518);
  params[0] = call5515;
  partcv[0] = 1;
  Object opresult5519 = callmethod(call5518, "||(1)", 1, partcv, params);
// compiled op node returning opresult5519 (depth = 7)
  Object if5512 = done;
  if (istrue(opresult5519)) {
// Begin line 1331
  setline(1331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5520 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe5521 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_node (depth = 9)
  Object call5522 = callmethodflags(*var_node, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe5521);
// compiled member node returning call5522 (depth = 8)
  gc_frame_newslot(call5522);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe5523 = gc_frame_new();
// call case 4: self request
  Object call5524 = callmethodflags(self, "myLocalNames", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5523);
// compiled member node returning call5524 (depth = 8)
  params[0] = call5522;
  partcv[0] = 1;
  Object call5525 = callmethodflags(call5524, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5520);
// compiled call node returning call5525 (depth = 7)
    gc_frame_newslot(call5525);
    if5512 = call5525;
  } else {
  }
// compiled if node returning if5512 (depth = 6)
  gc_frame_end(frame);
  return if5512;
}
Object meth_ast_localNames5497(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "localNames");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1327
  setline(1327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5500 = gc_frame_new();
// call case 4: self request
  Object call5501 = callmethodflags(self, "myLocalNames", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5500);
// compiled member node returning call5501 (depth = 5)
  int op_slot_right_5499 = gc_frame_newslot(call5501);
// starting to compile identifier node (depth = 5)
  Object bool5503 = alloc_Boolean(0);
// compiled identifier node returning bool5503 (depth = 5)
  int op_slot_left_5499 = gc_frame_newslot(bool5503);
  params[0] = call5501;
  partcv[0] = 1;
  Object opresult5504 = callmethod(bool5503, "==(1)", 1, partcv, params);
// compiled op node returning opresult5504 (depth = 4)
  Object if5498 = done;
  if (istrue(opresult5504)) {
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5505 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5506 = gc_frame_new();
// call case 5: prelude request
  Object call5507 = callmethodflags(prelude, "emptySet", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5506);
// compiled member node returning call5507 (depth = 5)
  gc_frame_newslot(call5507);
// call case 4: self request
  params[0] = call5507;
  partcv[0] = 1;
  Object call5508 = callmethodflags(self, "myLocalNames:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5505);
// compiled call node returning call5508 (depth = 4)
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5509 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5510 = alloc_Block(NULL, NULL, "ast", 1329);
  gc_frame_newslot(block5510);
// method "_apply(_)"
  block_savedest(block5510);
  Object closure5511 = createclosure(1, "_apply(1)");
  setclosureframe(closure5511, stackframe);
  addtoclosure(closure5511, selfslot);
  struct UserObject *uo5511 = (struct UserObject*)block5510;
  uo5511->data[0] = (Object)closure5511;
  Method *meth_meth_ast__apply_40_1_41_5511 = addmethod2pos(block5510, "_apply(1)", &meth_ast__apply_40_1_41_5511, 0);
  int argcv_meth_ast__apply_40_1_41_5511[] = {1};
  meth_meth_ast__apply_40_1_41_5511->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5511);
  meth_meth_ast__apply_40_1_41_5511->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5511->definitionLine = 2981;
// compiled block node returning block5510 (depth = 5)
  gc_frame_newslot(block5510);
// call case 6: other requests
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5527 = gc_frame_new();
// call case 4: self request
  Object call5528 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5527);
// compiled member node returning call5528 (depth = 5)
  params[0] = block5510;
  partcv[0] = 1;
  Object call5529 = callmethodflags(call5528, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5509);
// compiled call node returning call5529 (depth = 4)
    gc_frame_newslot(call5529);
    if5498 = call5529;
  } else {
  }
// compiled if node returning if5498 (depth = 3)
// Begin line 1335
  setline(1335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5530 = gc_frame_new();
// call case 4: self request
  Object call5531 = callmethodflags(self, "myLocalNames", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5530);
// compiled member node returning call5531 (depth = 3)
  gc_frame_end(frame);
  return call5531;
}
Object meth_ast__apply_40_1_41_5546(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe5547 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_action (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call5548 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5547);
// compiled call node returning call5548 (depth = 5)
  gc_frame_end(frame);
  return call5548;
}
Object meth_ast_parentsDo_40_1_41_5532(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parentsDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parentsDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parentsDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part parentsDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1341
  setline(1341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5535 = gc_frame_new();
// call case 4: self request
  Object call5536 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5535);
// compiled member node returning call5536 (depth = 5)
  int op_slot_right_5534 = gc_frame_newslot(call5536);
// starting to compile identifier node (depth = 5)
  Object bool5538 = alloc_Boolean(0);
// compiled identifier node returning bool5538 (depth = 5)
  int op_slot_left_5534 = gc_frame_newslot(bool5538);
  params[0] = call5536;
  partcv[0] = 1;
  Object opresult5539 = callmethod(bool5538, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5539 (depth = 4)
  Object if5533 = done;
  if (istrue(opresult5539)) {
// starting to compile call node (depth = 4)
  int callframe5540 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5541 = gc_frame_new();
// call case 4: self request
  Object call5542 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5541);
// compiled member node returning call5542 (depth = 5)
  gc_frame_newslot(call5542);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_action (depth = 5)
  params[0] = call5542;
  partcv[0] = 1;
  Object call5543 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5540);
// compiled call node returning call5543 (depth = 4)
    gc_frame_newslot(call5543);
    if5533 = call5543;
  } else {
  }
// compiled if node returning if5533 (depth = 3)
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5544 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5545 = alloc_Block(NULL, NULL, "ast", 1342);
  gc_frame_newslot(block5545);
// method "_apply(_)"
  block_savedest(block5545);
  Object closure5546 = createclosure(2, "_apply(1)");
  setclosureframe(closure5546, stackframe);
  addtoclosure(closure5546, var_action);
  addtoclosure(closure5546, selfslot);
  struct UserObject *uo5546 = (struct UserObject*)block5545;
  uo5546->data[0] = (Object)closure5546;
  Method *meth_meth_ast__apply_40_1_41_5546 = addmethod2pos(block5545, "_apply(1)", &meth_ast__apply_40_1_41_5546, 0);
  int argcv_meth_ast__apply_40_1_41_5546[] = {1};
  meth_meth_ast__apply_40_1_41_5546->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5546);
  meth_meth_ast__apply_40_1_41_5546->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5546->definitionLine = 2981;
// compiled block node returning block5545 (depth = 4)
  gc_frame_newslot(block5545);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5550 = gc_frame_new();
// call case 4: self request
  Object call5551 = callmethodflags(self, "usedTraits", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5550);
// compiled member node returning call5551 (depth = 4)
  params[0] = block5545;
  partcv[0] = 1;
  Object call5552 = callmethodflags(call5551, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5544);
// compiled call node returning call5552 (depth = 3)
  gc_frame_end(frame);
  return call5552;
}
Object meth_ast__apply_40_1_41_5556(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1349
  setline(1349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5558 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  Object call5559 = callmethodflags(*var_o, "isMethod", 0, partcv, params, 0);
  gc_frame_end(callframe5558);
// compiled member node returning call5559 (depth = 6)
  Object if5557 = done;
  if (istrue(call5559)) {
// starting to compile call node (depth = 6)
  int callframe5560 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5561 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5560);
// compiled call node returning call5561 (depth = 6)
    gc_frame_newslot(call5561);
    if5557 = call5561;
  } else {
  }
// compiled if node returning if5557 (depth = 5)
  gc_frame_end(frame);
  return if5557;
}
Object meth_ast_methodsDo_40_1_41_5553(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "methodsDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method methodsDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodsDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part methodsDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5554 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5555 = alloc_Block(NULL, NULL, "ast", 1348);
  gc_frame_newslot(block5555);
// method "_apply(_)"
  block_savedest(block5555);
  Object closure5556 = createclosure(2, "_apply(1)");
  setclosureframe(closure5556, stackframe);
  addtoclosure(closure5556, var_action);
  addtoclosure(closure5556, selfslot);
  struct UserObject *uo5556 = (struct UserObject*)block5555;
  uo5556->data[0] = (Object)closure5556;
  Method *meth_meth_ast__apply_40_1_41_5556 = addmethod2pos(block5555, "_apply(1)", &meth_ast__apply_40_1_41_5556, 0);
  int argcv_meth_ast__apply_40_1_41_5556[] = {1};
  meth_meth_ast__apply_40_1_41_5556->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5556);
  meth_meth_ast__apply_40_1_41_5556->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5556->definitionLine = 2981;
// compiled block node returning block5555 (depth = 4)
  gc_frame_newslot(block5555);
// call case 6: other requests
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5563 = gc_frame_new();
// call case 4: self request
  Object call5564 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5563);
// compiled member node returning call5564 (depth = 4)
  params[0] = block5555;
  partcv[0] = 1;
  Object call5565 = callmethodflags(call5564, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5554);
// compiled call node returning call5565 (depth = 3)
  gc_frame_end(frame);
  return call5565;
}
Object meth_ast__apply_40_1_41_5569(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1357
  setline(1357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5571 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  Object call5572 = callmethodflags(*var_o, "isExecutable", 0, partcv, params, 0);
  gc_frame_end(callframe5571);
// compiled member node returning call5572 (depth = 6)
  Object if5570 = done;
  if (istrue(call5572)) {
// starting to compile call node (depth = 6)
  int callframe5573 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5574 = callmethodflags(*var_action, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5573);
// compiled call node returning call5574 (depth = 6)
    gc_frame_newslot(call5574);
    if5570 = call5574;
  } else {
  }
// compiled if node returning if5570 (depth = 5)
  gc_frame_end(frame);
  return if5570;
}
Object meth_ast_executableComponentsDo_40_1_41_5566(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "executableComponentsDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method executableComponentsDo(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for executableComponentsDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part executableComponentsDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5567 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5568 = alloc_Block(NULL, NULL, "ast", 1356);
  gc_frame_newslot(block5568);
// method "_apply(_)"
  block_savedest(block5568);
  Object closure5569 = createclosure(2, "_apply(1)");
  setclosureframe(closure5569, stackframe);
  addtoclosure(closure5569, var_action);
  addtoclosure(closure5569, selfslot);
  struct UserObject *uo5569 = (struct UserObject*)block5568;
  uo5569->data[0] = (Object)closure5569;
  Method *meth_meth_ast__apply_40_1_41_5569 = addmethod2pos(block5568, "_apply(1)", &meth_ast__apply_40_1_41_5569, 0);
  int argcv_meth_ast__apply_40_1_41_5569[] = {1};
  meth_meth_ast__apply_40_1_41_5569->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5569);
  meth_meth_ast__apply_40_1_41_5569->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5569->definitionLine = 2981;
// compiled block node returning block5568 (depth = 4)
  gc_frame_newslot(block5568);
// call case 6: other requests
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5576 = gc_frame_new();
// call case 4: self request
  Object call5577 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5576);
// compiled member node returning call5577 (depth = 4)
  params[0] = block5568;
  partcv[0] = 1;
  Object call5578 = callmethodflags(call5577, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5567);
// compiled call node returning call5578 (depth = 3)
  gc_frame_end(frame);
  return call5578;
}
Object meth_ast_scope_58__61__40_1_41_5579(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:=(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope:=(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1364
  setline(1364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5580 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call5581 = callmethodflags(self, "symbolTable:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5580);
// compiled call node returning call5581 (depth = 3)
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5582 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5583 = callmethodflags(*var_st, "node:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5582);
// compiled call node returning call5583 (depth = 3)
  gc_frame_end(frame);
  return call5583;
}
Object meth_ast_body5584(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5585 = gc_frame_new();
// call case 4: self request
  Object call5586 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5585);
// compiled member node returning call5586 (depth = 3)
  gc_frame_end(frame);
  return call5586;
}
Object meth_ast_returnsObject5587(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5588 = alloc_Boolean(1);
// compiled identifier node returning bool5588 (depth = 3)
  gc_frame_end(frame);
  return bool5588;
}
Object meth_ast_returnedObjectScope5589(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5590 = gc_frame_new();
// call case 4: self request
  Object call5591 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5590);
// compiled member node returning call5591 (depth = 3)
  gc_frame_end(frame);
  return call5591;
}
Object meth_ast_canInherit5592(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canInherit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5593 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5594 = gc_frame_new();
// call case 4: self request
  Object call5595 = callmethodflags(self, "inTrait", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5594);
// compiled member node returning call5595 (depth = 4)
  Object call5596 = callmethodflags(call5595, "not", 0, partcv, params, 0);
  gc_frame_end(callframe5593);
// compiled member node returning call5596 (depth = 3)
  gc_frame_end(frame);
  return call5596;
}
Object meth_ast_canUse5597(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canUse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5598 = alloc_Boolean(1);
// compiled identifier node returning bool5598 (depth = 3)
  gc_frame_end(frame);
  return bool5598;
}
Object meth_ast_isObject5599(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5600 = alloc_Boolean(1);
// compiled identifier node returning bool5600 (depth = 3)
  gc_frame_end(frame);
  return bool5600;
}
Object meth_ast__apply_40_1_41_5620(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe5621 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5622 = callmethodflags(*var_t, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5621);
// compiled call node returning call5622 (depth = 6)
  gc_frame_end(frame);
  return call5622;
}
Object meth_ast__apply_40_1_41_5629(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe5630 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5631 = callmethodflags(*var_x, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5630);
// compiled call node returning call5631 (depth = 6)
  gc_frame_end(frame);
  return call5631;
}
Object meth_ast_accept_40_1_41_from_40_1_41_5601(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5603 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5604 = callmethodflags(*var_visitor, "visitObject(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5603);
// compiled call node returning call5604 (depth = 4)
  Object if5602 = done;
  if (istrue(call5604)) {
// Begin line 1375
  setline(1375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5605 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call5606 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5605);
// compiled call node returning call5606 (depth = 5)
  *var_newChain = call5606;
  if (call5606 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1376
  setline(1376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5609 = gc_frame_new();
// call case 4: self request
  Object call5610 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5609);
// compiled member node returning call5610 (depth = 6)
  int op_slot_right_5608 = gc_frame_newslot(call5610);
// starting to compile identifier node (depth = 6)
  Object bool5612 = alloc_Boolean(0);
// compiled identifier node returning bool5612 (depth = 6)
  int op_slot_left_5608 = gc_frame_newslot(bool5612);
  params[0] = call5610;
  partcv[0] = 1;
  Object opresult5613 = callmethod(bool5612, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5613 (depth = 5)
  Object if5607 = done;
  if (istrue(opresult5613)) {
// Begin line 1377
  setline(1377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5614 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5615 = gc_frame_new();
// call case 4: self request
  Object call5616 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5615);
// compiled member node returning call5616 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5617 = callmethodflags(call5616, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5614);
// compiled call node returning call5617 (depth = 5)
    gc_frame_newslot(call5617);
    if5607 = call5617;
  } else {
  }
// compiled if node returning if5607 (depth = 4)
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5618 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5619 = alloc_Block(NULL, NULL, "ast", 1379);
  gc_frame_newslot(block5619);
// method "_apply(_)"
  block_savedest(block5619);
  Object closure5620 = createclosure(3, "_apply(1)");
  setclosureframe(closure5620, stackframe);
  addtoclosure(closure5620, var_visitor);
  addtoclosure(closure5620, var_newChain);
  addtoclosure(closure5620, selfslot);
  struct UserObject *uo5620 = (struct UserObject*)block5619;
  uo5620->data[0] = (Object)closure5620;
  Method *meth_meth_ast__apply_40_1_41_5620 = addmethod2pos(block5619, "_apply(1)", &meth_ast__apply_40_1_41_5620, 0);
  int argcv_meth_ast__apply_40_1_41_5620[] = {1};
  meth_meth_ast__apply_40_1_41_5620->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5620);
  meth_meth_ast__apply_40_1_41_5620->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5620->definitionLine = 2981;
// compiled block node returning block5619 (depth = 5)
  gc_frame_newslot(block5619);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5624 = gc_frame_new();
// call case 4: self request
  Object call5625 = callmethodflags(self, "usedTraits", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5624);
// compiled member node returning call5625 (depth = 5)
  params[0] = block5619;
  partcv[0] = 1;
  Object call5626 = callmethodflags(call5625, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5618);
// compiled call node returning call5626 (depth = 4)
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5627 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5628 = alloc_Block(NULL, NULL, "ast", 1380);
  gc_frame_newslot(block5628);
// method "_apply(_)"
  block_savedest(block5628);
  Object closure5629 = createclosure(3, "_apply(1)");
  setclosureframe(closure5629, stackframe);
  addtoclosure(closure5629, var_visitor);
  addtoclosure(closure5629, var_newChain);
  addtoclosure(closure5629, selfslot);
  struct UserObject *uo5629 = (struct UserObject*)block5628;
  uo5629->data[0] = (Object)closure5629;
  Method *meth_meth_ast__apply_40_1_41_5629 = addmethod2pos(block5628, "_apply(1)", &meth_ast__apply_40_1_41_5629, 0);
  int argcv_meth_ast__apply_40_1_41_5629[] = {1};
  meth_meth_ast__apply_40_1_41_5629->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5629);
  meth_meth_ast__apply_40_1_41_5629->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5629->definitionLine = 2981;
// compiled block node returning block5628 (depth = 5)
  gc_frame_newslot(block5628);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5633 = gc_frame_new();
// call case 4: self request
  Object call5634 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5633);
// compiled member node returning call5634 (depth = 5)
  params[0] = block5628;
  partcv[0] = 1;
  Object call5635 = callmethodflags(call5634, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5627);
// compiled call node returning call5635 (depth = 4)
    gc_frame_newslot(call5635);
    if5602 = call5635;
  } else {
  }
// compiled if node returning if5602 (depth = 3)
  gc_frame_end(frame);
  return if5602;
}
Object meth_ast_nameString5636(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1384
  setline(1384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5639 == NULL) {
    strlit5639 = alloc_String("object");
    gc_root(strlit5639);
  }
// compiled string node returning strlit5639 (depth = 5)
  int op_slot_right_5638 = gc_frame_newslot(strlit5639);
// starting to compile member node (depth = 5)
  int callframe5641 = gc_frame_new();
// call case 4: self request
  Object call5642 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5641);
// compiled member node returning call5642 (depth = 5)
  int op_slot_left_5638 = gc_frame_newslot(call5642);
  params[0] = strlit5639;
  partcv[0] = 1;
  Object opresult5643 = callmethod(call5642, "==(1)", 1, partcv, params);
// compiled op node returning opresult5643 (depth = 4)
  Object if5637 = done;
  if (istrue(opresult5643)) {
// Begin line 1385
  setline(1385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5645 == NULL) {
    strlit5645 = alloc_String("");
    gc_root(strlit5645);
  }
// compiled string node returning strlit5645 (depth = 5)
  int op_slot_right_5644 = gc_frame_newslot(strlit5645);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5648 = gc_frame_new();
// call case 4: self request
  Object call5649 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5648);
// compiled member node returning call5649 (depth = 6)
  int op_slot_right_5647 = gc_frame_newslot(call5649);
// starting to compile string node (depth = 6)
  if (strlit5651 == NULL) {
    strlit5651 = alloc_String("object_on_line_");
    gc_root(strlit5651);
  }
// compiled string node returning strlit5651 (depth = 6)
  int op_slot_left_5647 = gc_frame_newslot(strlit5651);
  params[0] = call5649;
  partcv[0] = 1;
  Object opresult5652 = callmethod(strlit5651, "++(1)", 1, partcv, params);
// compiled op node returning opresult5652 (depth = 5)
  int op_slot_left_5644 = gc_frame_newslot(opresult5652);
  params[0] = strlit5645;
  partcv[0] = 1;
  Object opresult5653 = callmethod(opresult5652, "++(1)", 1, partcv, params);
// compiled op node returning opresult5653 (depth = 4)
    gc_frame_newslot(opresult5653);
    if5637 = opresult5653;
  } else {
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5654 = gc_frame_new();
// call case 4: self request
  Object call5655 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5654);
// compiled member node returning call5655 (depth = 4)
    gc_frame_newslot(call5655);
    if5637 = call5655;
  }
// compiled if node returning if5637 (depth = 3)
  gc_frame_end(frame);
  return if5637;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_5656(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1391
  setline(1391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5657 = gc_frame_new();
// call case 4: self request
  Object call5658 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5657);
// compiled member node returning call5658 (depth = 4)
  *var_n = call5658;
  if (call5658 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5659 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5660 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5659);
// compiled call node returning call5660 (depth = 4)
  *var_newChain = call5660;
  if (call5660 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5661 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5662 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5663 = gc_frame_new();
// call case 4: self request
  Object call5664 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5663);
// compiled member node returning call5664 (depth = 5)
  gc_frame_newslot(call5664);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5665 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5666 = gc_frame_new();
// call case 3: self.outer request
  Object call5667 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5666);
// compiled member node returning call5667 (depth = 6)
  Object call5668 = callmethodflags(call5667, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5665);
// compiled member node returning call5668 (depth = 5)
  params[0] = call5664;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5669 = callmethodflags(call5668, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5662);
// compiled call node returning call5669 (depth = 4)
  gc_frame_newslot(call5669);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5669;
  partcv[0] = 1;
  Object call5670 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5661);
// compiled call node returning call5670 (depth = 3)
// Begin line 1394
  setline(1394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5671 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5672 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5673 = gc_frame_new();
// call case 4: self request
  Object call5674 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5673);
// compiled member node returning call5674 (depth = 5)
  gc_frame_newslot(call5674);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5675 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5676 = gc_frame_new();
// call case 3: self.outer request
  Object call5677 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5676);
// compiled member node returning call5677 (depth = 6)
  Object call5678 = callmethodflags(call5677, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5675);
// compiled member node returning call5678 (depth = 5)
  params[0] = call5674;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5679 = callmethodflags(call5678, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5672);
// compiled call node returning call5679 (depth = 4)
  gc_frame_newslot(call5679);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5679;
  partcv[0] = 1;
  Object call5680 = callmethodflags(*var_n, "superclass:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5671);
// compiled call node returning call5680 (depth = 3)
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5681 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5682 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe5683 = gc_frame_new();
// call case 4: self request
  Object call5684 = callmethodflags(self, "usedTraits", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5683);
// compiled member node returning call5684 (depth = 5)
  gc_frame_newslot(call5684);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5685 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5686 = gc_frame_new();
// call case 3: self.outer request
  Object call5687 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5686);
// compiled member node returning call5687 (depth = 6)
  Object call5688 = callmethodflags(call5687, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5685);
// compiled member node returning call5688 (depth = 5)
  params[0] = call5684;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5689 = callmethodflags(call5688, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5682);
// compiled call node returning call5689 (depth = 4)
  gc_frame_newslot(call5689);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5689;
  partcv[0] = 1;
  Object call5690 = callmethodflags(*var_n, "usedTraits:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5681);
// compiled call node returning call5690 (depth = 3)
// Begin line 1396
  setline(1396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5691 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call5692 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5691);
// compiled call node returning call5692 (depth = 3)
  gc_frame_end(frame);
  return call5692;
}
Object meth_ast__apply_40_1_41_5701(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5703 == NULL) {
    strlit5703 = alloc_String("  ");
    gc_root(strlit5703);
  }
// compiled string node returning strlit5703 (depth = 7)
  int op_slot_right_5702 = gc_frame_newslot(strlit5703);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_5702 = gc_frame_newslot(*var_spc);
  params[0] = strlit5703;
  partcv[0] = 1;
  Object opresult5705 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult5705 (depth = 6)
  *var_spc = opresult5705;
  if (opresult5705 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_5787(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1413
  setline(1413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5789 == NULL) {
    strlit5789 = alloc_String("");
    gc_root(strlit5789);
  }
// compiled string node returning strlit5789 (depth = 8)
  int op_slot_right_5788 = gc_frame_newslot(strlit5789);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5792 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num5794 = alloc_Float64(1);
// compiled num node returning num5794 (depth = 11)
  int op_slot_right_5793 = gc_frame_newslot(num5794);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_5793 = gc_frame_newslot(*var_depth);
  params[0] = num5794;
  partcv[0] = 1;
  Object sum5796 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5796 (depth = 10)
  gc_frame_newslot(sum5796);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  params[0] = sum5796;
  partcv[0] = 1;
  Object call5797 = callmethodflags(*var_t, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5792);
// compiled call node returning call5797 (depth = 9)
  int op_slot_right_5791 = gc_frame_newslot(call5797);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5800 == NULL) {
    strlit5800 = alloc_String("  ");
    gc_root(strlit5800);
  }
// compiled string node returning strlit5800 (depth = 10)
  int op_slot_right_5799 = gc_frame_newslot(strlit5800);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_5802 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit5805 == NULL) {
    strlit5805 = alloc_String("""\x0a""");
    gc_root(strlit5805);
  }
// compiled string node returning strlit5805 (depth = 12)
  int op_slot_right_5804 = gc_frame_newslot(strlit5805);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_5807 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit5809 == NULL) {
    strlit5809 = alloc_String("");
    gc_root(strlit5809);
  }
// compiled string node returning strlit5809 (depth = 13)
  int op_slot_left_5807 = gc_frame_newslot(strlit5809);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5810 = callmethod(strlit5809, "++(1)", 1, partcv, params);
// compiled op node returning opresult5810 (depth = 12)
  int op_slot_left_5804 = gc_frame_newslot(opresult5810);
  params[0] = strlit5805;
  partcv[0] = 1;
  Object opresult5811 = callmethod(opresult5810, "++(1)", 1, partcv, params);
// compiled op node returning opresult5811 (depth = 11)
  int op_slot_left_5802 = gc_frame_newslot(opresult5811);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5812 = callmethod(opresult5811, "++(1)", 1, partcv, params);
// compiled op node returning opresult5812 (depth = 10)
  int op_slot_left_5799 = gc_frame_newslot(opresult5812);
  params[0] = strlit5800;
  partcv[0] = 1;
  Object opresult5813 = callmethod(opresult5812, "++(1)", 1, partcv, params);
// compiled op node returning opresult5813 (depth = 9)
  int op_slot_left_5791 = gc_frame_newslot(opresult5813);
  params[0] = call5797;
  partcv[0] = 1;
  Object opresult5814 = callmethod(opresult5813, "++(1)", 1, partcv, params);
// compiled op node returning opresult5814 (depth = 8)
  int op_slot_left_5788 = gc_frame_newslot(opresult5814);
  params[0] = strlit5789;
  partcv[0] = 1;
  Object opresult5815 = callmethod(opresult5814, "++(1)", 1, partcv, params);
// compiled op node returning opresult5815 (depth = 7)
  *var_s = opresult5815;
  if (opresult5815 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_5823(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1417
  setline(1417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5825 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5827 = alloc_Float64(1);
// compiled num node returning num5827 (depth = 9)
  int op_slot_right_5826 = gc_frame_newslot(num5827);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5826 = gc_frame_newslot(*var_depth);
  params[0] = num5827;
  partcv[0] = 1;
  Object sum5829 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5829 (depth = 8)
  gc_frame_newslot(sum5829);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_x (depth = 8)
  params[0] = sum5829;
  partcv[0] = 1;
  Object call5830 = callmethodflags(*var_x, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5825);
// compiled call node returning call5830 (depth = 7)
  int op_slot_right_5824 = gc_frame_newslot(call5830);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5832 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5835 == NULL) {
    strlit5835 = alloc_String("""\x0a""");
    gc_root(strlit5835);
  }
// compiled string node returning strlit5835 (depth = 9)
  int op_slot_right_5834 = gc_frame_newslot(strlit5835);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5834 = gc_frame_newslot(*var_s);
  params[0] = strlit5835;
  partcv[0] = 1;
  Object opresult5837 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5837 (depth = 8)
  int op_slot_left_5832 = gc_frame_newslot(opresult5837);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5838 = callmethod(opresult5837, "++(1)", 1, partcv, params);
// compiled op node returning opresult5838 (depth = 7)
  int op_slot_left_5824 = gc_frame_newslot(opresult5838);
  params[0] = call5830;
  partcv[0] = 1;
  Object opresult5839 = callmethod(opresult5838, "++(1)", 1, partcv, params);
// compiled op node returning opresult5839 (depth = 6)
  *var_s = opresult5839;
  if (opresult5839 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_5693(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth_39_ = &(stackframe->slots[0]);
  *var_depth_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_depth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "depth");
  Object *var_spc = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "spc");
  Object *var_s = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "s");
// Begin line 1399
  setline(1399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth_39_ (depth = 4)
  *var_depth = *var_depth_39_;
  if (*var_depth_39_ == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1400
  setline(1400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5694 == NULL) {
    strlit5694 = alloc_String("");
    gc_root(strlit5694);
  }
// compiled string node returning strlit5694 (depth = 4)
  *var_spc = strlit5694;
  if (strlit5694 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5695 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_5696 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num5698 = alloc_Float64(0);
// compiled num node returning num5698 (depth = 5)
  int op_slot_left_5696 = gc_frame_newslot(num5698);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult5699 = callmethod(num5698, "..(1)", 1, partcv, params);
// compiled op node returning opresult5699 (depth = 4)
  gc_frame_newslot(opresult5699);
// starting to compile block node (depth = 4)
  Object block5700 = alloc_Block(NULL, NULL, "ast", 1401);
  gc_frame_newslot(block5700);
// method "_apply(_)"
  block_savedest(block5700);
  Object closure5701 = createclosure(2, "_apply(1)");
  setclosureframe(closure5701, stackframe);
  addtoclosure(closure5701, var_spc);
  addtoclosure(closure5701, selfslot);
  struct UserObject *uo5701 = (struct UserObject*)block5700;
  uo5701->data[0] = (Object)closure5701;
  Method *meth_meth_ast__apply_40_1_41_5701 = addmethod2pos(block5700, "_apply(1)", &meth_ast__apply_40_1_41_5701, 0);
  int argcv_meth_ast__apply_40_1_41_5701[] = {1};
  meth_meth_ast__apply_40_1_41_5701->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5701);
  meth_meth_ast__apply_40_1_41_5701->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5701->definitionLine = 2981;
// compiled block node returning block5700 (depth = 4)
  gc_frame_newslot(block5700);
// call case 5: prelude request
  params[0] = opresult5699;
  params[1] = block5700;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5708 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5695);
// compiled call node returning call5708 (depth = 3)
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5709 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call5710 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5709);
// compiled call node returning call5710 (depth = 4)
  *var_s = call5710;
  if (call5710 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5712 == NULL) {
    strlit5712 = alloc_String("");
    gc_root(strlit5712);
  }
// compiled string node returning strlit5712 (depth = 5)
  int op_slot_right_5711 = gc_frame_newslot(strlit5712);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5715 = gc_frame_new();
// call case 4: self request
  Object call5716 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5715);
// compiled member node returning call5716 (depth = 6)
  int op_slot_right_5714 = gc_frame_newslot(call5716);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5719 == NULL) {
    strlit5719 = alloc_String("Name: ");
    gc_root(strlit5719);
  }
// compiled string node returning strlit5719 (depth = 7)
  int op_slot_right_5718 = gc_frame_newslot(strlit5719);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5721 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5724 == NULL) {
    strlit5724 = alloc_String("""\x0a""");
    gc_root(strlit5724);
  }
// compiled string node returning strlit5724 (depth = 9)
  int op_slot_right_5723 = gc_frame_newslot(strlit5724);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_5726 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit5728 == NULL) {
    strlit5728 = alloc_String("");
    gc_root(strlit5728);
  }
// compiled string node returning strlit5728 (depth = 10)
  int op_slot_left_5726 = gc_frame_newslot(strlit5728);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5729 = callmethod(strlit5728, "++(1)", 1, partcv, params);
// compiled op node returning opresult5729 (depth = 9)
  int op_slot_left_5723 = gc_frame_newslot(opresult5729);
  params[0] = strlit5724;
  partcv[0] = 1;
  Object opresult5730 = callmethod(opresult5729, "++(1)", 1, partcv, params);
// compiled op node returning opresult5730 (depth = 8)
  int op_slot_left_5721 = gc_frame_newslot(opresult5730);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5731 = callmethod(opresult5730, "++(1)", 1, partcv, params);
// compiled op node returning opresult5731 (depth = 7)
  int op_slot_left_5718 = gc_frame_newslot(opresult5731);
  params[0] = strlit5719;
  partcv[0] = 1;
  Object opresult5732 = callmethod(opresult5731, "++(1)", 1, partcv, params);
// compiled op node returning opresult5732 (depth = 6)
  int op_slot_left_5714 = gc_frame_newslot(opresult5732);
  params[0] = call5716;
  partcv[0] = 1;
  Object opresult5733 = callmethod(opresult5732, "++(1)", 1, partcv, params);
// compiled op node returning opresult5733 (depth = 5)
  int op_slot_left_5711 = gc_frame_newslot(opresult5733);
  params[0] = strlit5712;
  partcv[0] = 1;
  Object opresult5734 = callmethod(opresult5733, "++(1)", 1, partcv, params);
// compiled op node returning opresult5734 (depth = 4)
  *var_s = opresult5734;
  if (opresult5734 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5738 = gc_frame_new();
// call case 4: self request
  Object call5739 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5738);
// compiled member node returning call5739 (depth = 5)
  int op_slot_right_5737 = gc_frame_newslot(call5739);
// starting to compile identifier node (depth = 5)
  Object bool5741 = alloc_Boolean(0);
// compiled identifier node returning bool5741 (depth = 5)
  int op_slot_left_5737 = gc_frame_newslot(bool5741);
  params[0] = call5739;
  partcv[0] = 1;
  Object opresult5742 = callmethod(bool5741, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5742 (depth = 4)
  Object if5736 = done;
  if (istrue(opresult5742)) {
// Begin line 1407
  setline(1407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1408
  setline(1408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5744 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num5746 = alloc_Float64(1);
// compiled num node returning num5746 (depth = 8)
  int op_slot_right_5745 = gc_frame_newslot(num5746);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_5745 = gc_frame_newslot(*var_depth);
  params[0] = num5746;
  partcv[0] = 1;
  Object sum5748 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5748 (depth = 7)
  gc_frame_newslot(sum5748);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5749 = gc_frame_new();
// call case 4: self request
  Object call5750 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5749);
// compiled member node returning call5750 (depth = 7)
  params[0] = sum5748;
  partcv[0] = 1;
  Object call5751 = callmethodflags(call5750, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5744);
// compiled call node returning call5751 (depth = 6)
  int op_slot_right_5743 = gc_frame_newslot(call5751);
// Begin line 1407
  setline(1407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5754 == NULL) {
    strlit5754 = alloc_String("Superclass: ");
    gc_root(strlit5754);
  }
// compiled string node returning strlit5754 (depth = 7)
  int op_slot_right_5753 = gc_frame_newslot(strlit5754);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5756 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5759 == NULL) {
    strlit5759 = alloc_String("""\x0a""");
    gc_root(strlit5759);
  }
// compiled string node returning strlit5759 (depth = 9)
  int op_slot_right_5758 = gc_frame_newslot(strlit5759);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5758 = gc_frame_newslot(*var_s);
  params[0] = strlit5759;
  partcv[0] = 1;
  Object opresult5761 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5761 (depth = 8)
  int op_slot_left_5756 = gc_frame_newslot(opresult5761);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5762 = callmethod(opresult5761, "++(1)", 1, partcv, params);
// compiled op node returning opresult5762 (depth = 7)
  int op_slot_left_5753 = gc_frame_newslot(opresult5762);
  params[0] = strlit5754;
  partcv[0] = 1;
  Object opresult5763 = callmethod(opresult5762, "++(1)", 1, partcv, params);
// compiled op node returning opresult5763 (depth = 6)
  int op_slot_left_5743 = gc_frame_newslot(opresult5763);
  params[0] = call5751;
  partcv[0] = 1;
  Object opresult5764 = callmethod(opresult5763, "++(1)", 1, partcv, params);
// compiled op node returning opresult5764 (depth = 5)
  *var_s = opresult5764;
  if (opresult5764 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5736 = done;
  } else {
  }
// compiled if node returning if5736 (depth = 3)
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5767 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5768 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5769 = gc_frame_new();
// call case 4: self request
  Object call5770 = callmethodflags(self, "usedTraits", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5769);
// compiled member node returning call5770 (depth = 6)
  Object call5771 = callmethodflags(call5770, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe5768);
// compiled member node returning call5771 (depth = 5)
  Object call5772 = callmethodflags(call5771, "not", 0, partcv, params, 0);
  gc_frame_end(callframe5767);
// compiled member node returning call5772 (depth = 4)
  Object if5766 = done;
  if (istrue(call5772)) {
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5774 == NULL) {
    strlit5774 = alloc_String("Traits:");
    gc_root(strlit5774);
  }
// compiled string node returning strlit5774 (depth = 6)
  int op_slot_right_5773 = gc_frame_newslot(strlit5774);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_5776 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5779 == NULL) {
    strlit5779 = alloc_String("""\x0a""");
    gc_root(strlit5779);
  }
// compiled string node returning strlit5779 (depth = 8)
  int op_slot_right_5778 = gc_frame_newslot(strlit5779);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5778 = gc_frame_newslot(*var_s);
  params[0] = strlit5779;
  partcv[0] = 1;
  Object opresult5781 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5781 (depth = 7)
  int op_slot_left_5776 = gc_frame_newslot(opresult5781);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5782 = callmethod(opresult5781, "++(1)", 1, partcv, params);
// compiled op node returning opresult5782 (depth = 6)
  int op_slot_left_5773 = gc_frame_newslot(opresult5782);
  params[0] = strlit5774;
  partcv[0] = 1;
  Object opresult5783 = callmethod(opresult5782, "++(1)", 1, partcv, params);
// compiled op node returning opresult5783 (depth = 5)
  *var_s = opresult5783;
  if (opresult5783 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1412
  setline(1412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5785 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5786 = alloc_Block(NULL, NULL, "ast", 1412);
  gc_frame_newslot(block5786);
// method "_apply(_)"
  block_savedest(block5786);
  Object closure5787 = createclosure(4, "_apply(1)");
  setclosureframe(closure5787, stackframe);
  addtoclosure(closure5787, var_depth);
  addtoclosure(closure5787, var_spc);
  addtoclosure(closure5787, var_s);
  addtoclosure(closure5787, selfslot);
  struct UserObject *uo5787 = (struct UserObject*)block5786;
  uo5787->data[0] = (Object)closure5787;
  Method *meth_meth_ast__apply_40_1_41_5787 = addmethod2pos(block5786, "_apply(1)", &meth_ast__apply_40_1_41_5787, 0);
  int argcv_meth_ast__apply_40_1_41_5787[] = {1};
  meth_meth_ast__apply_40_1_41_5787->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5787);
  meth_meth_ast__apply_40_1_41_5787->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5787->definitionLine = 2981;
// compiled block node returning block5786 (depth = 5)
  gc_frame_newslot(block5786);
// call case 6: other requests
// Begin line 1412
  setline(1412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5818 = gc_frame_new();
// call case 4: self request
  Object call5819 = callmethodflags(self, "usedTraits", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5818);
// compiled member node returning call5819 (depth = 5)
  params[0] = block5786;
  partcv[0] = 1;
  Object call5820 = callmethodflags(call5819, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5785);
// compiled call node returning call5820 (depth = 4)
    gc_frame_newslot(call5820);
    if5766 = call5820;
  } else {
  }
// compiled if node returning if5766 (depth = 3)
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5821 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5822 = alloc_Block(NULL, NULL, "ast", 1416);
  gc_frame_newslot(block5822);
// method "_apply(_)"
  block_savedest(block5822);
  Object closure5823 = createclosure(4, "_apply(1)");
  setclosureframe(closure5823, stackframe);
  addtoclosure(closure5823, var_depth);
  addtoclosure(closure5823, var_spc);
  addtoclosure(closure5823, var_s);
  addtoclosure(closure5823, selfslot);
  struct UserObject *uo5823 = (struct UserObject*)block5822;
  uo5823->data[0] = (Object)closure5823;
  Method *meth_meth_ast__apply_40_1_41_5823 = addmethod2pos(block5822, "_apply(1)", &meth_ast__apply_40_1_41_5823, 0);
  int argcv_meth_ast__apply_40_1_41_5823[] = {1};
  meth_meth_ast__apply_40_1_41_5823->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5823);
  meth_meth_ast__apply_40_1_41_5823->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5823->definitionLine = 2981;
// compiled block node returning block5822 (depth = 4)
  gc_frame_newslot(block5822);
// call case 6: other requests
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5842 = gc_frame_new();
// call case 4: self request
  Object call5843 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5842);
// compiled member node returning call5843 (depth = 4)
  params[0] = block5822;
  partcv[0] = 1;
  Object call5844 = callmethodflags(call5843, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5821);
// compiled call node returning call5844 (depth = 3)
// Begin line 1419
  setline(1419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_5857(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5859 == NULL) {
    strlit5859 = alloc_String("    ");
    gc_root(strlit5859);
  }
// compiled string node returning strlit5859 (depth = 7)
  int op_slot_right_5858 = gc_frame_newslot(strlit5859);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_5858 = gc_frame_newslot(*var_spc);
  params[0] = strlit5859;
  partcv[0] = 1;
  Object opresult5861 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult5861 (depth = 6)
  *var_spc = opresult5861;
  if (opresult5861 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_5907(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5909 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5911 = alloc_Float64(1);
// compiled num node returning num5911 (depth = 9)
  int op_slot_right_5910 = gc_frame_newslot(num5911);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5910 = gc_frame_newslot(*var_depth);
  params[0] = num5911;
  partcv[0] = 1;
  Object sum5913 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5913 (depth = 8)
  gc_frame_newslot(sum5913);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  params[0] = sum5913;
  partcv[0] = 1;
  Object call5914 = callmethodflags(*var_t, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5909);
// compiled call node returning call5914 (depth = 7)
  int op_slot_right_5908 = gc_frame_newslot(call5914);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5917 == NULL) {
    strlit5917 = alloc_String("""\x0a""");
    gc_root(strlit5917);
  }
// compiled string node returning strlit5917 (depth = 8)
  int op_slot_right_5916 = gc_frame_newslot(strlit5917);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5916 = gc_frame_newslot(*var_s);
  params[0] = strlit5917;
  partcv[0] = 1;
  Object opresult5919 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5919 (depth = 7)
  int op_slot_left_5908 = gc_frame_newslot(opresult5919);
  params[0] = call5914;
  partcv[0] = 1;
  Object opresult5920 = callmethod(opresult5919, "++(1)", 1, partcv, params);
// compiled op node returning opresult5920 (depth = 6)
  *var_s = opresult5920;
  if (opresult5920 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_5928(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1434
  setline(1434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5930 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5932 = alloc_Float64(1);
// compiled num node returning num5932 (depth = 9)
  int op_slot_right_5931 = gc_frame_newslot(num5932);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5931 = gc_frame_newslot(*var_depth);
  params[0] = num5932;
  partcv[0] = 1;
  Object sum5934 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5934 (depth = 8)
  gc_frame_newslot(sum5934);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_x (depth = 8)
  params[0] = sum5934;
  partcv[0] = 1;
  Object call5935 = callmethodflags(*var_x, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5930);
// compiled call node returning call5935 (depth = 7)
  int op_slot_right_5929 = gc_frame_newslot(call5935);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5938 == NULL) {
    strlit5938 = alloc_String("    ");
    gc_root(strlit5938);
  }
// compiled string node returning strlit5938 (depth = 8)
  int op_slot_right_5937 = gc_frame_newslot(strlit5938);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_5940 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5943 == NULL) {
    strlit5943 = alloc_String("""\x0a""");
    gc_root(strlit5943);
  }
// compiled string node returning strlit5943 (depth = 10)
  int op_slot_right_5942 = gc_frame_newslot(strlit5943);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_5942 = gc_frame_newslot(*var_s);
  params[0] = strlit5943;
  partcv[0] = 1;
  Object opresult5945 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5945 (depth = 9)
  int op_slot_left_5940 = gc_frame_newslot(opresult5945);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5946 = callmethod(opresult5945, "++(1)", 1, partcv, params);
// compiled op node returning opresult5946 (depth = 8)
  int op_slot_left_5937 = gc_frame_newslot(opresult5946);
  params[0] = strlit5938;
  partcv[0] = 1;
  Object opresult5947 = callmethod(opresult5946, "++(1)", 1, partcv, params);
// compiled op node returning opresult5947 (depth = 7)
  int op_slot_left_5929 = gc_frame_newslot(opresult5947);
  params[0] = call5935;
  partcv[0] = 1;
  Object opresult5948 = callmethod(opresult5947, "++(1)", 1, partcv, params);
// compiled op node returning opresult5948 (depth = 6)
  *var_s = opresult5948;
  if (opresult5948 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_5845(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5846 == NULL) {
    strlit5846 = alloc_String("");
    gc_root(strlit5846);
  }
// compiled string node returning strlit5846 (depth = 4)
  *var_spc = strlit5846;
  if (strlit5846 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5847 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5850 = alloc_Float64(1);
// compiled num node returning num5850 (depth = 6)
  int op_slot_right_5849 = gc_frame_newslot(num5850);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_5849 = gc_frame_newslot(*var_depth);
  params[0] = num5850;
  partcv[0] = 1;
  Object diff5852 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff5852 (depth = 5)
  int op_slot_right_5848 = gc_frame_newslot(diff5852);
// starting to compile num node (depth = 5)
  Object num5854 = alloc_Float64(0);
// compiled num node returning num5854 (depth = 5)
  int op_slot_left_5848 = gc_frame_newslot(num5854);
  params[0] = diff5852;
  partcv[0] = 1;
  Object opresult5855 = callmethod(num5854, "..(1)", 1, partcv, params);
// compiled op node returning opresult5855 (depth = 4)
  gc_frame_newslot(opresult5855);
// starting to compile block node (depth = 4)
  Object block5856 = alloc_Block(NULL, NULL, "ast", 1423);
  gc_frame_newslot(block5856);
// method "_apply(_)"
  block_savedest(block5856);
  Object closure5857 = createclosure(2, "_apply(1)");
  setclosureframe(closure5857, stackframe);
  addtoclosure(closure5857, var_spc);
  addtoclosure(closure5857, selfslot);
  struct UserObject *uo5857 = (struct UserObject*)block5856;
  uo5857->data[0] = (Object)closure5857;
  Method *meth_meth_ast__apply_40_1_41_5857 = addmethod2pos(block5856, "_apply(1)", &meth_ast__apply_40_1_41_5857, 0);
  int argcv_meth_ast__apply_40_1_41_5857[] = {1};
  meth_meth_ast__apply_40_1_41_5857->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5857);
  meth_meth_ast__apply_40_1_41_5857->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5857->definitionLine = 2981;
// compiled block node returning block5856 (depth = 4)
  gc_frame_newslot(block5856);
// call case 5: prelude request
  params[0] = opresult5855;
  params[1] = block5856;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5864 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5847);
// compiled call node returning call5864 (depth = 3)
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5865 == NULL) {
    strlit5865 = alloc_String("object {");
    gc_root(strlit5865);
  }
// compiled string node returning strlit5865 (depth = 4)
  *var_s = strlit5865;
  if (strlit5865 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5867 = gc_frame_new();
// call case 4: self request
  Object call5868 = callmethodflags(self, "inTrait", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5867);
// compiled member node returning call5868 (depth = 4)
  Object if5866 = done;
  if (istrue(call5868)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5870 == NULL) {
    strlit5870 = alloc_String("   // trait");
    gc_root(strlit5870);
  }
// compiled string node returning strlit5870 (depth = 6)
  int op_slot_right_5869 = gc_frame_newslot(strlit5870);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5869 = gc_frame_newslot(*var_s);
  params[0] = strlit5870;
  partcv[0] = 1;
  Object opresult5872 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5872 (depth = 5)
  *var_s = opresult5872;
  if (opresult5872 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5866 = done;
  } else {
  }
// compiled if node returning if5866 (depth = 3)
// Begin line 1428
  setline(1428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5875 = gc_frame_new();
// call case 4: self request
  Object call5876 = callmethodflags(self, "inClass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5875);
// compiled member node returning call5876 (depth = 4)
  Object if5874 = done;
  if (istrue(call5876)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5878 == NULL) {
    strlit5878 = alloc_String("   // class");
    gc_root(strlit5878);
  }
// compiled string node returning strlit5878 (depth = 6)
  int op_slot_right_5877 = gc_frame_newslot(strlit5878);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5877 = gc_frame_newslot(*var_s);
  params[0] = strlit5878;
  partcv[0] = 1;
  Object opresult5880 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5880 (depth = 5)
  *var_s = opresult5880;
  if (opresult5880 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5874 = done;
  } else {
  }
// compiled if node returning if5874 (depth = 3)
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5884 = gc_frame_new();
// call case 4: self request
  Object call5885 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5884);
// compiled member node returning call5885 (depth = 5)
  int op_slot_right_5883 = gc_frame_newslot(call5885);
// starting to compile identifier node (depth = 5)
  Object bool5887 = alloc_Boolean(0);
// compiled identifier node returning bool5887 (depth = 5)
  int op_slot_left_5883 = gc_frame_newslot(bool5887);
  params[0] = call5885;
  partcv[0] = 1;
  Object opresult5888 = callmethod(bool5887, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5888 (depth = 4)
  Object if5882 = done;
  if (istrue(opresult5888)) {
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5890 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num5892 = alloc_Float64(1);
// compiled num node returning num5892 (depth = 8)
  int op_slot_right_5891 = gc_frame_newslot(num5892);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_5891 = gc_frame_newslot(*var_depth);
  params[0] = num5892;
  partcv[0] = 1;
  Object sum5894 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum5894 (depth = 7)
  gc_frame_newslot(sum5894);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5895 = gc_frame_new();
// call case 4: self request
  Object call5896 = callmethodflags(self, "superclass", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5895);
// compiled member node returning call5896 (depth = 7)
  params[0] = sum5894;
  partcv[0] = 1;
  Object call5897 = callmethodflags(call5896, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5890);
// compiled call node returning call5897 (depth = 6)
  int op_slot_right_5889 = gc_frame_newslot(call5897);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5900 == NULL) {
    strlit5900 = alloc_String("""\x0a""");
    gc_root(strlit5900);
  }
// compiled string node returning strlit5900 (depth = 7)
  int op_slot_right_5899 = gc_frame_newslot(strlit5900);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5899 = gc_frame_newslot(*var_s);
  params[0] = strlit5900;
  partcv[0] = 1;
  Object opresult5902 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5902 (depth = 6)
  int op_slot_left_5889 = gc_frame_newslot(opresult5902);
  params[0] = call5897;
  partcv[0] = 1;
  Object opresult5903 = callmethod(opresult5902, "++(1)", 1, partcv, params);
// compiled op node returning opresult5903 (depth = 5)
  *var_s = opresult5903;
  if (opresult5903 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5882 = done;
  } else {
  }
// compiled if node returning if5882 (depth = 3)
// Begin line 1432
  setline(1432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5905 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5906 = alloc_Block(NULL, NULL, "ast", 1432);
  gc_frame_newslot(block5906);
// method "_apply(_)"
  block_savedest(block5906);
  Object closure5907 = createclosure(3, "_apply(1)");
  setclosureframe(closure5907, stackframe);
  addtoclosure(closure5907, var_depth);
  addtoclosure(closure5907, var_s);
  addtoclosure(closure5907, selfslot);
  struct UserObject *uo5907 = (struct UserObject*)block5906;
  uo5907->data[0] = (Object)closure5907;
  Method *meth_meth_ast__apply_40_1_41_5907 = addmethod2pos(block5906, "_apply(1)", &meth_ast__apply_40_1_41_5907, 0);
  int argcv_meth_ast__apply_40_1_41_5907[] = {1};
  meth_meth_ast__apply_40_1_41_5907->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5907);
  meth_meth_ast__apply_40_1_41_5907->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5907->definitionLine = 2981;
// compiled block node returning block5906 (depth = 4)
  gc_frame_newslot(block5906);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5923 = gc_frame_new();
// call case 4: self request
  Object call5924 = callmethodflags(self, "usedTraits", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5923);
// compiled member node returning call5924 (depth = 4)
  params[0] = block5906;
  partcv[0] = 1;
  Object call5925 = callmethodflags(call5924, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5905);
// compiled call node returning call5925 (depth = 3)
// Begin line 1433
  setline(1433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5926 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5927 = alloc_Block(NULL, NULL, "ast", 1433);
  gc_frame_newslot(block5927);
// method "_apply(_)"
  block_savedest(block5927);
  Object closure5928 = createclosure(4, "_apply(1)");
  setclosureframe(closure5928, stackframe);
  addtoclosure(closure5928, var_depth);
  addtoclosure(closure5928, var_spc);
  addtoclosure(closure5928, var_s);
  addtoclosure(closure5928, selfslot);
  struct UserObject *uo5928 = (struct UserObject*)block5927;
  uo5928->data[0] = (Object)closure5928;
  Method *meth_meth_ast__apply_40_1_41_5928 = addmethod2pos(block5927, "_apply(1)", &meth_ast__apply_40_1_41_5928, 0);
  int argcv_meth_ast__apply_40_1_41_5928[] = {1};
  meth_meth_ast__apply_40_1_41_5928->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_5928);
  meth_meth_ast__apply_40_1_41_5928->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_5928->definitionLine = 2981;
// compiled block node returning block5927 (depth = 4)
  gc_frame_newslot(block5927);
// call case 6: other requests
// Begin line 1433
  setline(1433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5951 = gc_frame_new();
// call case 4: self request
  Object call5952 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5951);
// compiled member node returning call5952 (depth = 4)
  params[0] = block5927;
  partcv[0] = 1;
  Object call5953 = callmethodflags(call5952, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5926);
// compiled call node returning call5953 (depth = 3)
// Begin line 1436
  setline(1436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5955 == NULL) {
    strlit5955 = alloc_String("}");
    gc_root(strlit5955);
  }
// compiled string node returning strlit5955 (depth = 5)
  int op_slot_right_5954 = gc_frame_newslot(strlit5955);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_5957 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5960 == NULL) {
    strlit5960 = alloc_String("""\x0a""");
    gc_root(strlit5960);
  }
// compiled string node returning strlit5960 (depth = 7)
  int op_slot_right_5959 = gc_frame_newslot(strlit5960);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5959 = gc_frame_newslot(*var_s);
  params[0] = strlit5960;
  partcv[0] = 1;
  Object opresult5962 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5962 (depth = 6)
  int op_slot_left_5957 = gc_frame_newslot(opresult5962);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5963 = callmethod(opresult5962, "++(1)", 1, partcv, params);
// compiled op node returning opresult5963 (depth = 5)
  int op_slot_left_5954 = gc_frame_newslot(opresult5963);
  params[0] = strlit5955;
  partcv[0] = 1;
  Object opresult5964 = callmethod(opresult5963, "++(1)", 1, partcv, params);
// compiled op node returning opresult5964 (depth = 4)
  *var_s = opresult5964;
  if (opresult5964 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy5966(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5967 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe5968 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
  Object bool5969 = alloc_Boolean(0);
// compiled identifier node returning bool5969 (depth = 5)
  gc_frame_newslot(bool5969);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objectNode (depth = 5)
  params[0] = *var_emptySeq;
  params[1] = bool5969;
  partcv[0] = 2;
  Object call5970 = callmethodflags(*var_objectNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5968);
// compiled call node returning call5970 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5971 = callmethodflags(call5970, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5967);
// compiled call node returning call5971 (depth = 3)
  gc_frame_end(frame);
  return call5971;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_5972(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5973 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call5974 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5973);
// compiled call node returning call5974 (depth = 3)
// Begin line 1444
  setline(1444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5975 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5976 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5977 = callmethodflags(*var_other, "name", 0, partcv, params, 0);
  gc_frame_end(callframe5976);
// compiled member node returning call5977 (depth = 4)
  gc_frame_newslot(call5977);
// call case 4: self request
  params[0] = call5977;
  partcv[0] = 1;
  Object call5978 = callmethodflags(self, "name:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5975);
// compiled call node returning call5978 (depth = 3)
// Begin line 1445
  setline(1445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5979 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5980 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5981 = callmethodflags(*var_other, "value", 0, partcv, params, 0);
  gc_frame_end(callframe5980);
// compiled member node returning call5981 (depth = 4)
  gc_frame_newslot(call5981);
// call case 4: self request
  params[0] = call5981;
  partcv[0] = 1;
  Object call5982 = callmethodflags(self, "value:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5979);
// compiled call node returning call5982 (depth = 3)
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5983 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5984 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5985 = callmethodflags(*var_other, "superclass", 0, partcv, params, 0);
  gc_frame_end(callframe5984);
// compiled member node returning call5985 (depth = 4)
  gc_frame_newslot(call5985);
// call case 4: self request
  params[0] = call5985;
  partcv[0] = 1;
  Object call5986 = callmethodflags(self, "superclass:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5983);
// compiled call node returning call5986 (depth = 3)
// Begin line 1447
  setline(1447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5987 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5988 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5989 = callmethodflags(*var_other, "usedTraits", 0, partcv, params, 0);
  gc_frame_end(callframe5988);
// compiled member node returning call5989 (depth = 4)
  gc_frame_newslot(call5989);
// call case 4: self request
  params[0] = call5989;
  partcv[0] = 1;
  Object call5990 = callmethodflags(self, "usedTraits:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5987);
// compiled call node returning call5990 (depth = 3)
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5991 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5992 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5993 = callmethodflags(*var_other, "inClass", 0, partcv, params, 0);
  gc_frame_end(callframe5992);
// compiled member node returning call5993 (depth = 4)
  gc_frame_newslot(call5993);
// call case 4: self request
  params[0] = call5993;
  partcv[0] = 1;
  Object call5994 = callmethodflags(self, "inClass:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5991);
// compiled call node returning call5994 (depth = 3)
// Begin line 1449
  setline(1449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5995 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5996 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call5997 = callmethodflags(*var_other, "inTrait", 0, partcv, params, 0);
  gc_frame_end(callframe5996);
// compiled member node returning call5997 (depth = 4)
  gc_frame_newslot(call5997);
// call case 4: self request
  params[0] = call5997;
  partcv[0] = 1;
  Object call5998 = callmethodflags(self, "inTrait:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5995);
// compiled call node returning call5998 (depth = 3)
// Begin line 1450
  setline(1450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5999 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6000 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call6001 = callmethodflags(*var_other, "annotations", 0, partcv, params, 0);
  gc_frame_end(callframe6000);
// compiled member node returning call6001 (depth = 4)
  gc_frame_newslot(call6001);
// call case 4: self request
  params[0] = call6001;
  partcv[0] = 1;
  Object call6002 = callmethodflags(self, "annotations:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5999);
// compiled call node returning call6002 (depth = 3)
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_asString6003(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1454
  setline(1454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6005 == NULL) {
    strlit6005 = alloc_String("");
    gc_root(strlit6005);
  }
// compiled string node returning strlit6005 (depth = 4)
  int op_slot_right_6004 = gc_frame_newslot(strlit6005);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6008 = gc_frame_new();
// call case 4: self request
  Object call6009 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6008);
// compiled member node returning call6009 (depth = 5)
  int op_slot_right_6007 = gc_frame_newslot(call6009);
// starting to compile string node (depth = 5)
  if (strlit6011 == NULL) {
    strlit6011 = alloc_String("object ");
    gc_root(strlit6011);
  }
// compiled string node returning strlit6011 (depth = 5)
  int op_slot_left_6007 = gc_frame_newslot(strlit6011);
  params[0] = call6009;
  partcv[0] = 1;
  Object opresult6012 = callmethod(strlit6011, "++(1)", 1, partcv, params);
// compiled op node returning opresult6012 (depth = 4)
  int op_slot_left_6004 = gc_frame_newslot(opresult6012);
  params[0] = strlit6005;
  partcv[0] = 1;
  Object opresult6013 = callmethod(opresult6012, "++(1)", 1, partcv, params);
// compiled op node returning opresult6013 (depth = 3)
  gc_frame_end(frame);
  return opresult6013;
}
Object meth_ast_new_40_2_41_5429(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[1]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5430 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5430 = alloc_userobj2(38,31, objclass5430);
  gc_frame_newslot(obj5430);
if (objclass5430 == NULL) {
  glfree(obj5430->class->name);
  obj5430->class->name = "objectNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5430, self, 0);
  addmethodreal(obj5430,"outer", &reader_ast_outer_5431);
  Object oldself5430 = self;
  struct StackFrameObject *oldstackframe5430 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5430);
  gc_frame_newslot((Object)stackframe);
  self = obj5430;
  Object *oldselfslot5430 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5430 = (*(struct UserObject *)self).data[0], lowerouter5430 = thisouter5430;
  if (inheritingObject5430) {
    struct UserObject *inho5430 = (struct UserObject *)inheritingObject5430;
    while (inho5430->super != GraceDefaultObject) inho5430 = (struct UserObject *)inho5430->super;
    inho5430->super = obj5430;
    self = inheritingObject5430;
    *selfslot = self;
    lowerouter5430 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5430;
  }
if (objclass5430 == NULL) {
  Method *reader5432 = addmethodrealflags(obj5430, "kind",&reader_ast_kind_5432, MFLAG_DEF);
  reader5432->definitionModule = modulename;
  reader5432->definitionLine = 1294;
}
adddatum2(obj5430, alloc_Undefined(), 1);
if (objclass5430 == NULL) {
  Method *reader5433 = addmethodrealflags(obj5430, "value", &reader_ast_value_5433, 0);
  Method *writer5433 = addmethodrealflags(obj5430, "value:=(1)", &writer_ast_value_5433, 0);
  reader5433->definitionModule = modulename;
  writer5433->definitionModule = modulename;
  reader5433->definitionLine = 1295;
  writer5433->definitionLine = 1295;
}
obj5430->flags |= OFLAG_MUTABLE;
adddatum2(obj5430, alloc_Undefined(), 2);
if (objclass5430 == NULL) {
  Method *reader5434 = addmethodrealflags(obj5430, "superclass", &reader_ast_superclass_5434, 0);
  Method *writer5434 = addmethodrealflags(obj5430, "superclass:=(1)", &writer_ast_superclass_5434, 0);
  reader5434->definitionModule = modulename;
  writer5434->definitionModule = modulename;
  reader5434->definitionLine = 1296;
  writer5434->definitionLine = 1296;
}
obj5430->flags |= OFLAG_MUTABLE;
adddatum2(obj5430, alloc_Undefined(), 3);
if (objclass5430 == NULL) {
  Method *reader5435 = addmethodrealflags(obj5430, "usedTraits", &reader_ast_usedTraits_5435, 0);
  Method *writer5435 = addmethodrealflags(obj5430, "usedTraits:=(1)", &writer_ast_usedTraits_5435, 0);
  reader5435->definitionModule = modulename;
  writer5435->definitionModule = modulename;
  reader5435->definitionLine = 1297;
  writer5435->definitionLine = 1297;
}
obj5430->flags |= OFLAG_MUTABLE;
adddatum2(obj5430, alloc_Undefined(), 4);
if (objclass5430 == NULL) {
  Method *reader5436 = addmethodrealflags(obj5430, "name", &reader_ast_name_5436, 0);
  Method *writer5436 = addmethodrealflags(obj5430, "name:=(1)", &writer_ast_name_5436, 0);
  reader5436->definitionModule = modulename;
  writer5436->definitionModule = modulename;
  reader5436->definitionLine = 1298;
  writer5436->definitionLine = 1298;
}
obj5430->flags |= OFLAG_MUTABLE;
adddatum2(obj5430, alloc_Undefined(), 5);
if (objclass5430 == NULL) {
  Method *reader5437 = addmethodrealflags(obj5430, "inClass", &reader_ast_inClass_5437, 0);
  Method *writer5437 = addmethodrealflags(obj5430, "inClass:=(1)", &writer_ast_inClass_5437, 0);
  reader5437->definitionModule = modulename;
  writer5437->definitionModule = modulename;
  reader5437->definitionLine = 1299;
  writer5437->definitionLine = 1299;
}
obj5430->flags |= OFLAG_MUTABLE;
adddatum2(obj5430, alloc_Undefined(), 6);
if (objclass5430 == NULL) {
  Method *reader5438 = addmethodrealflags(obj5430, "inTrait", &reader_ast_inTrait_5438, 0);
  Method *writer5438 = addmethodrealflags(obj5430, "inTrait:=(1)", &writer_ast_inTrait_5438, 0);
  reader5438->definitionModule = modulename;
  writer5438->definitionModule = modulename;
  reader5438->definitionLine = 1300;
  writer5438->definitionLine = 1300;
}
obj5430->flags |= OFLAG_MUTABLE;
adddatum2(obj5430, alloc_Undefined(), 7);
if (objclass5430 == NULL) {
  Method *reader5439 = addmethodrealflags(obj5430, "myLocalNames", &reader_ast_myLocalNames_5439, MFLAG_CONFIDENTIAL);
  Method *writer5439 = addmethodrealflags(obj5430, "myLocalNames:=(1)", &writer_ast_myLocalNames_5439, MFLAG_CONFIDENTIAL);
  reader5439->definitionModule = modulename;
  writer5439->definitionModule = modulename;
  reader5439->definitionLine = 1301;
  writer5439->definitionLine = 1301;
}
obj5430->flags |= OFLAG_MUTABLE;
adddatum2(obj5430, alloc_Undefined(), 8);
if (objclass5430 == NULL) {
  Method *reader5440 = addmethodrealflags(obj5430, "annotations", &reader_ast_annotations_5440, 0);
  Method *writer5440 = addmethodrealflags(obj5430, "annotations:=(1)", &writer_ast_annotations_5440, 0);
  reader5440->definitionModule = modulename;
  writer5440->definitionModule = modulename;
  reader5440->definitionLine = 1302;
  writer5440->definitionLine = 1302;
}
obj5430->flags |= OFLAG_MUTABLE;
adddatum2(obj5430, alloc_Undefined(), 9);
// method "description"
  struct UserObject *uo5441 = (struct UserObject*)obj5430;
  uo5441->data[10] = emptyclosure;
  Method *meth_meth_ast_description5441 = addmethod2pos(obj5430, "description", &meth_ast_description5441, 10);
  int argcv_meth_ast_description5441[] = {0};
  meth_meth_ast_description5441->type = alloc_MethodType(1, argcv_meth_ast_description5441);
  meth_meth_ast_description5441->definitionModule = modulename;
  meth_meth_ast_description5441->definitionLine = 1304;
// method "isTrait"
  struct UserObject *uo5470 = (struct UserObject*)obj5430;
  uo5470->data[11] = emptyclosure;
  Method *meth_meth_ast_isTrait5470 = addmethod2pos(obj5430, "isTrait", &meth_ast_isTrait5470, 11);
  int argcv_meth_ast_isTrait5470[] = {0};
  meth_meth_ast_isTrait5470->type = alloc_MethodType(1, argcv_meth_ast_isTrait5470);
  meth_meth_ast_isTrait5470->definitionModule = modulename;
  meth_meth_ast_isTrait5470->definitionLine = 1313;
// method "localNames"
  struct UserObject *uo5497 = (struct UserObject*)obj5430;
  uo5497->data[12] = emptyclosure;
  Method *meth_meth_ast_localNames5497 = addmethod2pos(obj5430, "localNames", &meth_ast_localNames5497, 12);
  int argcv_meth_ast_localNames5497[] = {0};
  meth_meth_ast_localNames5497->type = alloc_MethodType(1, argcv_meth_ast_localNames5497);
  meth_meth_ast_localNames5497->definitionModule = modulename;
  meth_meth_ast_localNames5497->definitionLine = 1324;
// method "parentsDo(_)"
  struct UserObject *uo5532 = (struct UserObject*)obj5430;
  uo5532->data[13] = emptyclosure;
  Method *meth_meth_ast_parentsDo_40_1_41_5532 = addmethod2pos(obj5430, "parentsDo(1)", &meth_ast_parentsDo_40_1_41_5532, 13);
  int argcv_meth_ast_parentsDo_40_1_41_5532[] = {1};
  meth_meth_ast_parentsDo_40_1_41_5532->type = alloc_MethodType(1, argcv_meth_ast_parentsDo_40_1_41_5532);
  meth_meth_ast_parentsDo_40_1_41_5532->definitionModule = modulename;
  meth_meth_ast_parentsDo_40_1_41_5532->definitionLine = 1338;
// method "methodsDo(_)"
  struct UserObject *uo5553 = (struct UserObject*)obj5430;
  uo5553->data[14] = emptyclosure;
  Method *meth_meth_ast_methodsDo_40_1_41_5553 = addmethod2pos(obj5430, "methodsDo(1)", &meth_ast_methodsDo_40_1_41_5553, 14);
  int argcv_meth_ast_methodsDo_40_1_41_5553[] = {1};
  meth_meth_ast_methodsDo_40_1_41_5553->type = alloc_MethodType(1, argcv_meth_ast_methodsDo_40_1_41_5553);
  meth_meth_ast_methodsDo_40_1_41_5553->definitionModule = modulename;
  meth_meth_ast_methodsDo_40_1_41_5553->definitionLine = 1345;
// method "executableComponentsDo(_)"
  struct UserObject *uo5566 = (struct UserObject*)obj5430;
  uo5566->data[15] = emptyclosure;
  Method *meth_meth_ast_executableComponentsDo_40_1_41_5566 = addmethod2pos(obj5430, "executableComponentsDo(1)", &meth_ast_executableComponentsDo_40_1_41_5566, 15);
  int argcv_meth_ast_executableComponentsDo_40_1_41_5566[] = {1};
  meth_meth_ast_executableComponentsDo_40_1_41_5566->type = alloc_MethodType(1, argcv_meth_ast_executableComponentsDo_40_1_41_5566);
  meth_meth_ast_executableComponentsDo_40_1_41_5566->definitionModule = modulename;
  meth_meth_ast_executableComponentsDo_40_1_41_5566->definitionLine = 1353;
// method "scope:=(_)"
  struct UserObject *uo5579 = (struct UserObject*)obj5430;
  uo5579->data[16] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_5579 = addmethod2pos(obj5430, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_5579, 16);
  int argcv_meth_ast_scope_58__61__40_1_41_5579[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_5579->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_5579);
  meth_meth_ast_scope_58__61__40_1_41_5579->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_5579->definitionLine = 1361;
// method "body"
  struct UserObject *uo5584 = (struct UserObject*)obj5430;
  uo5584->data[17] = emptyclosure;
  Method *meth_meth_ast_body5584 = addmethod2pos(obj5430, "body", &meth_ast_body5584, 17);
  int argcv_meth_ast_body5584[] = {0};
  meth_meth_ast_body5584->type = alloc_MethodType(1, argcv_meth_ast_body5584);
  meth_meth_ast_body5584->definitionModule = modulename;
  meth_meth_ast_body5584->definitionLine = 1367;
// method "returnsObject"
  struct UserObject *uo5587 = (struct UserObject*)obj5430;
  uo5587->data[18] = emptyclosure;
  Method *meth_meth_ast_returnsObject5587 = addmethod2pos(obj5430, "returnsObject", &meth_ast_returnsObject5587, 18);
  int argcv_meth_ast_returnsObject5587[] = {0};
  meth_meth_ast_returnsObject5587->type = alloc_MethodType(1, argcv_meth_ast_returnsObject5587);
  meth_meth_ast_returnsObject5587->definitionModule = modulename;
  meth_meth_ast_returnsObject5587->definitionLine = 1368;
// method "returnedObjectScope"
  struct UserObject *uo5589 = (struct UserObject*)obj5430;
  uo5589->data[19] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope5589 = addmethod2pos(obj5430, "returnedObjectScope", &meth_ast_returnedObjectScope5589, 19);
  int argcv_meth_ast_returnedObjectScope5589[] = {0};
  meth_meth_ast_returnedObjectScope5589->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope5589);
  meth_meth_ast_returnedObjectScope5589->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope5589->definitionLine = 1369;
// method "canInherit"
  struct UserObject *uo5592 = (struct UserObject*)obj5430;
  uo5592->data[20] = emptyclosure;
  Method *meth_meth_ast_canInherit5592 = addmethod2pos(obj5430, "canInherit", &meth_ast_canInherit5592, 20);
  int argcv_meth_ast_canInherit5592[] = {0};
  meth_meth_ast_canInherit5592->type = alloc_MethodType(1, argcv_meth_ast_canInherit5592);
  meth_meth_ast_canInherit5592->definitionModule = modulename;
  meth_meth_ast_canInherit5592->definitionLine = 1370;
// method "canUse"
  struct UserObject *uo5597 = (struct UserObject*)obj5430;
  uo5597->data[21] = emptyclosure;
  Method *meth_meth_ast_canUse5597 = addmethod2pos(obj5430, "canUse", &meth_ast_canUse5597, 21);
  int argcv_meth_ast_canUse5597[] = {0};
  meth_meth_ast_canUse5597->type = alloc_MethodType(1, argcv_meth_ast_canUse5597);
  meth_meth_ast_canUse5597->definitionModule = modulename;
  meth_meth_ast_canUse5597->definitionLine = 1371;
// method "isObject"
  struct UserObject *uo5599 = (struct UserObject*)obj5430;
  uo5599->data[22] = emptyclosure;
  Method *meth_meth_ast_isObject5599 = addmethod2pos(obj5430, "isObject", &meth_ast_isObject5599, 22);
  int argcv_meth_ast_isObject5599[] = {0};
  meth_meth_ast_isObject5599->type = alloc_MethodType(1, argcv_meth_ast_isObject5599);
  meth_meth_ast_isObject5599->definitionModule = modulename;
  meth_meth_ast_isObject5599->definitionLine = 1372;
// method "accept(_)from(_)"
  struct UserObject *uo5601 = (struct UserObject*)obj5430;
  uo5601->data[23] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_5601 = addmethod2pos(obj5430, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_5601, 23);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_5601[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_5601->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_5601);
  meth_meth_ast_accept_40_1_41_from_40_1_41_5601->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_5601->definitionLine = 1373;
// method "nameString"
  struct UserObject *uo5636 = (struct UserObject*)obj5430;
  uo5636->data[24] = emptyclosure;
  Method *meth_meth_ast_nameString5636 = addmethod2pos(obj5430, "nameString", &meth_ast_nameString5636, 24);
  int argcv_meth_ast_nameString5636[] = {0};
  meth_meth_ast_nameString5636->type = alloc_MethodType(1, argcv_meth_ast_nameString5636);
  meth_meth_ast_nameString5636->definitionModule = modulename;
  meth_meth_ast_nameString5636->definitionLine = 1383;
// method "map(_)ancestors(_)"
  struct UserObject *uo5656 = (struct UserObject*)obj5430;
  uo5656->data[25] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_5656 = addmethod2pos(obj5430, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_5656, 25);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_5656[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_5656->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_5656);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_5656->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_5656->definitionLine = 1390;
// method "pretty(_)"
  struct UserObject *uo5693 = (struct UserObject*)obj5430;
  uo5693->data[26] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_5693 = addmethod2pos(obj5430, "pretty(1)", &meth_ast_pretty_40_1_41_5693, 26);
  int argcv_meth_ast_pretty_40_1_41_5693[] = {1};
  meth_meth_ast_pretty_40_1_41_5693->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_5693);
  meth_meth_ast_pretty_40_1_41_5693->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_5693->definitionLine = 1398;
// method "toGrace(_)"
  struct UserObject *uo5845 = (struct UserObject*)obj5430;
  uo5845->data[27] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_5845 = addmethod2pos(obj5430, "toGrace(1)", &meth_ast_toGrace_40_1_41_5845, 27);
  int argcv_meth_ast_toGrace_40_1_41_5845[] = {1};
  meth_meth_ast_toGrace_40_1_41_5845->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_5845);
meth_meth_ast_toGrace_40_1_41_5845->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_5845->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_5845->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_5845->definitionLine = 1421;
// method "shallowCopy"
  block_savedest(obj5430);
  Object closure5966 = createclosure(2, "shallowCopy");
  setclosureframe(closure5966, stackframe);
  addtoclosure(closure5966, var_emptySeq);
  addtoclosure(closure5966, var_objectNode);
  struct UserObject *uo5966 = (struct UserObject*)obj5430;
  uo5966->data[28] = (Object)closure5966;
  Method *meth_meth_ast_shallowCopy5966 = addmethod2pos(obj5430, "shallowCopy", &meth_ast_shallowCopy5966, 28);
  int argcv_meth_ast_shallowCopy5966[] = {0};
  meth_meth_ast_shallowCopy5966->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5966);
  meth_meth_ast_shallowCopy5966->definitionModule = modulename;
  meth_meth_ast_shallowCopy5966->definitionLine = 1439;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo5972 = (struct UserObject*)obj5430;
  uo5972->data[29] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5972 = addmethod2pos(obj5430, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_5972, 29);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5972[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5972->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5972);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5972->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5972->definitionLine = 1442;
// method "asString"
  struct UserObject *uo6003 = (struct UserObject*)obj5430;
  uo6003->data[30] = emptyclosure;
  Method *meth_meth_ast_asString6003 = addmethod2pos(obj5430, "asString", &meth_ast_asString6003, 30);
  int argcv_meth_ast_asString6003[] = {0};
  meth_meth_ast_asString6003->type = alloc_MethodType(1, argcv_meth_ast_asString6003);
  meth_meth_ast_asString6003->definitionModule = modulename;
  meth_meth_ast_asString6003->definitionLine = 1453;
  sourceObject = obj5430;
// Begin line 1293
  setline(1293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6014 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6015 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6016 = gc_frame_new();
// call case 3: self.outer request
  Object call6017 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6016);
// compiled member node returning call6017 (depth = 5)
  Object call6018 = callmethodflags(call6017, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6015);
// compiled member node returning call6018 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6019 = callmethodflags(call6018, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6014);
// compiled call node returning call6019 (depth = 3)
  struct UserObject *obj5430_uo = (struct UserObject *)obj5430;
  obj5430_uo->super = call6019;
  sourceObject = obj5430;
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6020 == NULL) {
    strlit6020 = alloc_String("object");
    gc_root(strlit6020);
  }
// compiled string node returning strlit6020 (depth = 3)
  adddatum2(obj5430, strlit6020, 1);
  sourceObject = obj5430;
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_b (depth = 3)
  adddatum2(obj5430, *var_b, 2);
  sourceObject = obj5430;
// Begin line 1296
  setline(1296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_superclass_39_ (depth = 3)
  adddatum2(obj5430, *var_superclass_39_, 3);
  sourceObject = obj5430;
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array6021 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6021 (depth = 3)
  adddatum2(obj5430, array6021, 4);
  sourceObject = obj5430;
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6022 == NULL) {
    strlit6022 = alloc_String("object");
    gc_root(strlit6022);
  }
// compiled string node returning strlit6022 (depth = 3)
  adddatum2(obj5430, strlit6022, 5);
  sourceObject = obj5430;
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6023 = alloc_Boolean(0);
// compiled identifier node returning bool6023 (depth = 3)
  adddatum2(obj5430, bool6023, 6);
  sourceObject = obj5430;
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6024 = alloc_Boolean(0);
// compiled identifier node returning bool6024 (depth = 3)
  adddatum2(obj5430, bool6024, 7);
  sourceObject = obj5430;
// Begin line 1301
  setline(1301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6025 = alloc_Boolean(0);
// compiled identifier node returning bool6025 (depth = 3)
  adddatum2(obj5430, bool6025, 8);
  sourceObject = obj5430;
// Begin line 1302
  setline(1302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array6026 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6026 (depth = 3)
  adddatum2(obj5430, array6026, 9);
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  objclass5430 = obj5430->class;
  objclass5430->definitionModule = modulename;
  objclass5430->definitionLine = 1292;
  (*(struct UserObject *)self).data[0] = lowerouter5430;
  self = oldself5430;
  selfslot = oldselfslot5430;
  stackframe = oldstackframe5430;
  gc_frame_end(frame);
  return obj5430;
}
Object meth_ast_new_40_2_41_5429_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[1]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5430 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5430 = alloc_userobj2(38,31, objclass5430);
  gc_frame_newslot(obj5430);
if (objclass5430 == NULL) {
  glfree(obj5430->class->name);
  obj5430->class->name = "objectNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5430, self, 0);
  addmethodreal(obj5430,"outer", &reader_ast_outer_5431);
  Object oldself5430 = self;
  struct StackFrameObject *oldstackframe5430 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5430);
  gc_frame_newslot((Object)stackframe);
  self = obj5430;
  Object *oldselfslot5430 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5430 = (*(struct UserObject *)self).data[0], lowerouter5430 = thisouter5430;
  if (inheritingObject5430) {
    struct UserObject *inho5430 = (struct UserObject *)inheritingObject5430;
    while (inho5430->super != GraceDefaultObject) inho5430 = (struct UserObject *)inho5430->super;
    inho5430->super = obj5430;
    self = inheritingObject5430;
    *selfslot = self;
    lowerouter5430 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5430;
  }
if (objclass5430 == NULL) {
  Method *reader5432 = addmethodrealflags(obj5430, "kind",&reader_ast_kind_5432, MFLAG_DEF);
  reader5432->definitionModule = modulename;
  reader5432->definitionLine = 1294;
}
adddatum2(obj5430, alloc_Undefined(), 1);
if (objclass5430 == NULL) {
  Method *reader5433 = addmethodrealflags(obj5430, "value", &reader_ast_value_5433, 0);
  Method *writer5433 = addmethodrealflags(obj5430, "value:=(1)", &writer_ast_value_5433, 0);
  reader5433->definitionModule = modulename;
  writer5433->definitionModule = modulename;
  reader5433->definitionLine = 1295;
  writer5433->definitionLine = 1295;
}
obj5430->flags |= OFLAG_MUTABLE;
adddatum2(obj5430, alloc_Undefined(), 2);
if (objclass5430 == NULL) {
  Method *reader5434 = addmethodrealflags(obj5430, "superclass", &reader_ast_superclass_5434, 0);
  Method *writer5434 = addmethodrealflags(obj5430, "superclass:=(1)", &writer_ast_superclass_5434, 0);
  reader5434->definitionModule = modulename;
  writer5434->definitionModule = modulename;
  reader5434->definitionLine = 1296;
  writer5434->definitionLine = 1296;
}
obj5430->flags |= OFLAG_MUTABLE;
adddatum2(obj5430, alloc_Undefined(), 3);
if (objclass5430 == NULL) {
  Method *reader5435 = addmethodrealflags(obj5430, "usedTraits", &reader_ast_usedTraits_5435, 0);
  Method *writer5435 = addmethodrealflags(obj5430, "usedTraits:=(1)", &writer_ast_usedTraits_5435, 0);
  reader5435->definitionModule = modulename;
  writer5435->definitionModule = modulename;
  reader5435->definitionLine = 1297;
  writer5435->definitionLine = 1297;
}
obj5430->flags |= OFLAG_MUTABLE;
adddatum2(obj5430, alloc_Undefined(), 4);
if (objclass5430 == NULL) {
  Method *reader5436 = addmethodrealflags(obj5430, "name", &reader_ast_name_5436, 0);
  Method *writer5436 = addmethodrealflags(obj5430, "name:=(1)", &writer_ast_name_5436, 0);
  reader5436->definitionModule = modulename;
  writer5436->definitionModule = modulename;
  reader5436->definitionLine = 1298;
  writer5436->definitionLine = 1298;
}
obj5430->flags |= OFLAG_MUTABLE;
adddatum2(obj5430, alloc_Undefined(), 5);
if (objclass5430 == NULL) {
  Method *reader5437 = addmethodrealflags(obj5430, "inClass", &reader_ast_inClass_5437, 0);
  Method *writer5437 = addmethodrealflags(obj5430, "inClass:=(1)", &writer_ast_inClass_5437, 0);
  reader5437->definitionModule = modulename;
  writer5437->definitionModule = modulename;
  reader5437->definitionLine = 1299;
  writer5437->definitionLine = 1299;
}
obj5430->flags |= OFLAG_MUTABLE;
adddatum2(obj5430, alloc_Undefined(), 6);
if (objclass5430 == NULL) {
  Method *reader5438 = addmethodrealflags(obj5430, "inTrait", &reader_ast_inTrait_5438, 0);
  Method *writer5438 = addmethodrealflags(obj5430, "inTrait:=(1)", &writer_ast_inTrait_5438, 0);
  reader5438->definitionModule = modulename;
  writer5438->definitionModule = modulename;
  reader5438->definitionLine = 1300;
  writer5438->definitionLine = 1300;
}
obj5430->flags |= OFLAG_MUTABLE;
adddatum2(obj5430, alloc_Undefined(), 7);
if (objclass5430 == NULL) {
  Method *reader5439 = addmethodrealflags(obj5430, "myLocalNames", &reader_ast_myLocalNames_5439, MFLAG_CONFIDENTIAL);
  Method *writer5439 = addmethodrealflags(obj5430, "myLocalNames:=(1)", &writer_ast_myLocalNames_5439, MFLAG_CONFIDENTIAL);
  reader5439->definitionModule = modulename;
  writer5439->definitionModule = modulename;
  reader5439->definitionLine = 1301;
  writer5439->definitionLine = 1301;
}
obj5430->flags |= OFLAG_MUTABLE;
adddatum2(obj5430, alloc_Undefined(), 8);
if (objclass5430 == NULL) {
  Method *reader5440 = addmethodrealflags(obj5430, "annotations", &reader_ast_annotations_5440, 0);
  Method *writer5440 = addmethodrealflags(obj5430, "annotations:=(1)", &writer_ast_annotations_5440, 0);
  reader5440->definitionModule = modulename;
  writer5440->definitionModule = modulename;
  reader5440->definitionLine = 1302;
  writer5440->definitionLine = 1302;
}
obj5430->flags |= OFLAG_MUTABLE;
adddatum2(obj5430, alloc_Undefined(), 9);
// method "description"
  struct UserObject *uo5441 = (struct UserObject*)obj5430;
  uo5441->data[10] = emptyclosure;
  Method *meth_meth_ast_description5441 = addmethod2pos(obj5430, "description", &meth_ast_description5441, 10);
  int argcv_meth_ast_description5441[] = {0};
  meth_meth_ast_description5441->type = alloc_MethodType(1, argcv_meth_ast_description5441);
  meth_meth_ast_description5441->definitionModule = modulename;
  meth_meth_ast_description5441->definitionLine = 1304;
// method "isTrait"
  struct UserObject *uo5470 = (struct UserObject*)obj5430;
  uo5470->data[11] = emptyclosure;
  Method *meth_meth_ast_isTrait5470 = addmethod2pos(obj5430, "isTrait", &meth_ast_isTrait5470, 11);
  int argcv_meth_ast_isTrait5470[] = {0};
  meth_meth_ast_isTrait5470->type = alloc_MethodType(1, argcv_meth_ast_isTrait5470);
  meth_meth_ast_isTrait5470->definitionModule = modulename;
  meth_meth_ast_isTrait5470->definitionLine = 1313;
// method "localNames"
  struct UserObject *uo5497 = (struct UserObject*)obj5430;
  uo5497->data[12] = emptyclosure;
  Method *meth_meth_ast_localNames5497 = addmethod2pos(obj5430, "localNames", &meth_ast_localNames5497, 12);
  int argcv_meth_ast_localNames5497[] = {0};
  meth_meth_ast_localNames5497->type = alloc_MethodType(1, argcv_meth_ast_localNames5497);
  meth_meth_ast_localNames5497->definitionModule = modulename;
  meth_meth_ast_localNames5497->definitionLine = 1324;
// method "parentsDo(_)"
  struct UserObject *uo5532 = (struct UserObject*)obj5430;
  uo5532->data[13] = emptyclosure;
  Method *meth_meth_ast_parentsDo_40_1_41_5532 = addmethod2pos(obj5430, "parentsDo(1)", &meth_ast_parentsDo_40_1_41_5532, 13);
  int argcv_meth_ast_parentsDo_40_1_41_5532[] = {1};
  meth_meth_ast_parentsDo_40_1_41_5532->type = alloc_MethodType(1, argcv_meth_ast_parentsDo_40_1_41_5532);
  meth_meth_ast_parentsDo_40_1_41_5532->definitionModule = modulename;
  meth_meth_ast_parentsDo_40_1_41_5532->definitionLine = 1338;
// method "methodsDo(_)"
  struct UserObject *uo5553 = (struct UserObject*)obj5430;
  uo5553->data[14] = emptyclosure;
  Method *meth_meth_ast_methodsDo_40_1_41_5553 = addmethod2pos(obj5430, "methodsDo(1)", &meth_ast_methodsDo_40_1_41_5553, 14);
  int argcv_meth_ast_methodsDo_40_1_41_5553[] = {1};
  meth_meth_ast_methodsDo_40_1_41_5553->type = alloc_MethodType(1, argcv_meth_ast_methodsDo_40_1_41_5553);
  meth_meth_ast_methodsDo_40_1_41_5553->definitionModule = modulename;
  meth_meth_ast_methodsDo_40_1_41_5553->definitionLine = 1345;
// method "executableComponentsDo(_)"
  struct UserObject *uo5566 = (struct UserObject*)obj5430;
  uo5566->data[15] = emptyclosure;
  Method *meth_meth_ast_executableComponentsDo_40_1_41_5566 = addmethod2pos(obj5430, "executableComponentsDo(1)", &meth_ast_executableComponentsDo_40_1_41_5566, 15);
  int argcv_meth_ast_executableComponentsDo_40_1_41_5566[] = {1};
  meth_meth_ast_executableComponentsDo_40_1_41_5566->type = alloc_MethodType(1, argcv_meth_ast_executableComponentsDo_40_1_41_5566);
  meth_meth_ast_executableComponentsDo_40_1_41_5566->definitionModule = modulename;
  meth_meth_ast_executableComponentsDo_40_1_41_5566->definitionLine = 1353;
// method "scope:=(_)"
  struct UserObject *uo5579 = (struct UserObject*)obj5430;
  uo5579->data[16] = emptyclosure;
  Method *meth_meth_ast_scope_58__61__40_1_41_5579 = addmethod2pos(obj5430, "scope:=(1)", &meth_ast_scope_58__61__40_1_41_5579, 16);
  int argcv_meth_ast_scope_58__61__40_1_41_5579[] = {1};
  meth_meth_ast_scope_58__61__40_1_41_5579->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61__40_1_41_5579);
  meth_meth_ast_scope_58__61__40_1_41_5579->definitionModule = modulename;
  meth_meth_ast_scope_58__61__40_1_41_5579->definitionLine = 1361;
// method "body"
  struct UserObject *uo5584 = (struct UserObject*)obj5430;
  uo5584->data[17] = emptyclosure;
  Method *meth_meth_ast_body5584 = addmethod2pos(obj5430, "body", &meth_ast_body5584, 17);
  int argcv_meth_ast_body5584[] = {0};
  meth_meth_ast_body5584->type = alloc_MethodType(1, argcv_meth_ast_body5584);
  meth_meth_ast_body5584->definitionModule = modulename;
  meth_meth_ast_body5584->definitionLine = 1367;
// method "returnsObject"
  struct UserObject *uo5587 = (struct UserObject*)obj5430;
  uo5587->data[18] = emptyclosure;
  Method *meth_meth_ast_returnsObject5587 = addmethod2pos(obj5430, "returnsObject", &meth_ast_returnsObject5587, 18);
  int argcv_meth_ast_returnsObject5587[] = {0};
  meth_meth_ast_returnsObject5587->type = alloc_MethodType(1, argcv_meth_ast_returnsObject5587);
  meth_meth_ast_returnsObject5587->definitionModule = modulename;
  meth_meth_ast_returnsObject5587->definitionLine = 1368;
// method "returnedObjectScope"
  struct UserObject *uo5589 = (struct UserObject*)obj5430;
  uo5589->data[19] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope5589 = addmethod2pos(obj5430, "returnedObjectScope", &meth_ast_returnedObjectScope5589, 19);
  int argcv_meth_ast_returnedObjectScope5589[] = {0};
  meth_meth_ast_returnedObjectScope5589->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope5589);
  meth_meth_ast_returnedObjectScope5589->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope5589->definitionLine = 1369;
// method "canInherit"
  struct UserObject *uo5592 = (struct UserObject*)obj5430;
  uo5592->data[20] = emptyclosure;
  Method *meth_meth_ast_canInherit5592 = addmethod2pos(obj5430, "canInherit", &meth_ast_canInherit5592, 20);
  int argcv_meth_ast_canInherit5592[] = {0};
  meth_meth_ast_canInherit5592->type = alloc_MethodType(1, argcv_meth_ast_canInherit5592);
  meth_meth_ast_canInherit5592->definitionModule = modulename;
  meth_meth_ast_canInherit5592->definitionLine = 1370;
// method "canUse"
  struct UserObject *uo5597 = (struct UserObject*)obj5430;
  uo5597->data[21] = emptyclosure;
  Method *meth_meth_ast_canUse5597 = addmethod2pos(obj5430, "canUse", &meth_ast_canUse5597, 21);
  int argcv_meth_ast_canUse5597[] = {0};
  meth_meth_ast_canUse5597->type = alloc_MethodType(1, argcv_meth_ast_canUse5597);
  meth_meth_ast_canUse5597->definitionModule = modulename;
  meth_meth_ast_canUse5597->definitionLine = 1371;
// method "isObject"
  struct UserObject *uo5599 = (struct UserObject*)obj5430;
  uo5599->data[22] = emptyclosure;
  Method *meth_meth_ast_isObject5599 = addmethod2pos(obj5430, "isObject", &meth_ast_isObject5599, 22);
  int argcv_meth_ast_isObject5599[] = {0};
  meth_meth_ast_isObject5599->type = alloc_MethodType(1, argcv_meth_ast_isObject5599);
  meth_meth_ast_isObject5599->definitionModule = modulename;
  meth_meth_ast_isObject5599->definitionLine = 1372;
// method "accept(_)from(_)"
  struct UserObject *uo5601 = (struct UserObject*)obj5430;
  uo5601->data[23] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_5601 = addmethod2pos(obj5430, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_5601, 23);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_5601[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_5601->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_5601);
  meth_meth_ast_accept_40_1_41_from_40_1_41_5601->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_5601->definitionLine = 1373;
// method "nameString"
  struct UserObject *uo5636 = (struct UserObject*)obj5430;
  uo5636->data[24] = emptyclosure;
  Method *meth_meth_ast_nameString5636 = addmethod2pos(obj5430, "nameString", &meth_ast_nameString5636, 24);
  int argcv_meth_ast_nameString5636[] = {0};
  meth_meth_ast_nameString5636->type = alloc_MethodType(1, argcv_meth_ast_nameString5636);
  meth_meth_ast_nameString5636->definitionModule = modulename;
  meth_meth_ast_nameString5636->definitionLine = 1383;
// method "map(_)ancestors(_)"
  struct UserObject *uo5656 = (struct UserObject*)obj5430;
  uo5656->data[25] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_5656 = addmethod2pos(obj5430, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_5656, 25);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_5656[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_5656->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_5656);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_5656->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_5656->definitionLine = 1390;
// method "pretty(_)"
  struct UserObject *uo5693 = (struct UserObject*)obj5430;
  uo5693->data[26] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_5693 = addmethod2pos(obj5430, "pretty(1)", &meth_ast_pretty_40_1_41_5693, 26);
  int argcv_meth_ast_pretty_40_1_41_5693[] = {1};
  meth_meth_ast_pretty_40_1_41_5693->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_5693);
  meth_meth_ast_pretty_40_1_41_5693->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_5693->definitionLine = 1398;
// method "toGrace(_)"
  struct UserObject *uo5845 = (struct UserObject*)obj5430;
  uo5845->data[27] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_5845 = addmethod2pos(obj5430, "toGrace(1)", &meth_ast_toGrace_40_1_41_5845, 27);
  int argcv_meth_ast_toGrace_40_1_41_5845[] = {1};
  meth_meth_ast_toGrace_40_1_41_5845->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_5845);
meth_meth_ast_toGrace_40_1_41_5845->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_5845->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_5845->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_5845->definitionLine = 1421;
// method "shallowCopy"
  block_savedest(obj5430);
  Object closure5966 = createclosure(2, "shallowCopy");
  setclosureframe(closure5966, stackframe);
  addtoclosure(closure5966, var_emptySeq);
  addtoclosure(closure5966, var_objectNode);
  struct UserObject *uo5966 = (struct UserObject*)obj5430;
  uo5966->data[28] = (Object)closure5966;
  Method *meth_meth_ast_shallowCopy5966 = addmethod2pos(obj5430, "shallowCopy", &meth_ast_shallowCopy5966, 28);
  int argcv_meth_ast_shallowCopy5966[] = {0};
  meth_meth_ast_shallowCopy5966->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5966);
  meth_meth_ast_shallowCopy5966->definitionModule = modulename;
  meth_meth_ast_shallowCopy5966->definitionLine = 1439;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo5972 = (struct UserObject*)obj5430;
  uo5972->data[29] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5972 = addmethod2pos(obj5430, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_5972, 29);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5972[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5972->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_5972);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5972->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_5972->definitionLine = 1442;
// method "asString"
  struct UserObject *uo6003 = (struct UserObject*)obj5430;
  uo6003->data[30] = emptyclosure;
  Method *meth_meth_ast_asString6003 = addmethod2pos(obj5430, "asString", &meth_ast_asString6003, 30);
  int argcv_meth_ast_asString6003[] = {0};
  meth_meth_ast_asString6003->type = alloc_MethodType(1, argcv_meth_ast_asString6003);
  meth_meth_ast_asString6003->definitionModule = modulename;
  meth_meth_ast_asString6003->definitionLine = 1453;
  sourceObject = obj5430;
// Begin line 1293
  setline(1293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6014 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6015 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6016 = gc_frame_new();
// call case 3: self.outer request
  Object call6017 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6016);
// compiled member node returning call6017 (depth = 5)
  Object call6018 = callmethodflags(call6017, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6015);
// compiled member node returning call6018 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6019 = callmethodflags(call6018, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6014);
// compiled call node returning call6019 (depth = 3)
  struct UserObject *obj5430_uo = (struct UserObject *)obj5430;
  obj5430_uo->super = call6019;
  sourceObject = obj5430;
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6020 == NULL) {
    strlit6020 = alloc_String("object");
    gc_root(strlit6020);
  }
// compiled string node returning strlit6020 (depth = 3)
  adddatum2(obj5430, strlit6020, 1);
  sourceObject = obj5430;
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_b (depth = 3)
  adddatum2(obj5430, *var_b, 2);
  sourceObject = obj5430;
// Begin line 1296
  setline(1296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_superclass_39_ (depth = 3)
  adddatum2(obj5430, *var_superclass_39_, 3);
  sourceObject = obj5430;
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array6021 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6021 (depth = 3)
  adddatum2(obj5430, array6021, 4);
  sourceObject = obj5430;
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6022 == NULL) {
    strlit6022 = alloc_String("object");
    gc_root(strlit6022);
  }
// compiled string node returning strlit6022 (depth = 3)
  adddatum2(obj5430, strlit6022, 5);
  sourceObject = obj5430;
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6023 = alloc_Boolean(0);
// compiled identifier node returning bool6023 (depth = 3)
  adddatum2(obj5430, bool6023, 6);
  sourceObject = obj5430;
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6024 = alloc_Boolean(0);
// compiled identifier node returning bool6024 (depth = 3)
  adddatum2(obj5430, bool6024, 7);
  sourceObject = obj5430;
// Begin line 1301
  setline(1301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6025 = alloc_Boolean(0);
// compiled identifier node returning bool6025 (depth = 3)
  adddatum2(obj5430, bool6025, 8);
  sourceObject = obj5430;
// Begin line 1302
  setline(1302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array6026 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6026 (depth = 3)
  adddatum2(obj5430, array6026, 9);
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  sourceObject = obj5430;
  objclass5430 = obj5430->class;
  objclass5430->definitionModule = modulename;
  objclass5430->definitionLine = 1292;
  (*(struct UserObject *)self).data[0] = lowerouter5430;
  self = oldself5430;
  selfslot = oldselfslot5430;
  stackframe = oldstackframe5430;
  gc_frame_end(frame);
  return obj5430;
}
Object meth_ast_objectNode6028(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "objectNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_objectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1282
  setline(1282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_objectNode (depth = 3)
  gc_frame_end(frame);
  return *var_objectNode;
}
Object meth_ast__apply_40_1_41_6046(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ax = &(stackframe->slots[0]);
  *var_ax = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1467
  setline(1467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6047 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ax (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6048 = callmethodflags(*var_ax, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6047);
// compiled call node returning call6048 (depth = 6)
  gc_frame_end(frame);
  return call6048;
}
Object meth_ast_accept_40_1_41_from_40_1_41_6036(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6038 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6039 = callmethodflags(*var_visitor, "visitArray(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6038);
// compiled call node returning call6039 (depth = 4)
  Object if6037 = done;
  if (istrue(call6039)) {
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6040 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6041 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6040);
// compiled call node returning call6041 (depth = 5)
  *var_newChain = call6041;
  if (call6041 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1466
  setline(1466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6042 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6043 = gc_frame_new();
// call case 4: self request
  Object call6044 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6043);
// compiled member node returning call6044 (depth = 5)
  gc_frame_newslot(call6044);
// starting to compile block node (depth = 5)
  Object block6045 = alloc_Block(NULL, NULL, "ast", 1466);
  gc_frame_newslot(block6045);
// method "_apply(_)"
  block_savedest(block6045);
  Object closure6046 = createclosure(3, "_apply(1)");
  setclosureframe(closure6046, stackframe);
  addtoclosure(closure6046, var_visitor);
  addtoclosure(closure6046, var_newChain);
  addtoclosure(closure6046, selfslot);
  struct UserObject *uo6046 = (struct UserObject*)block6045;
  uo6046->data[0] = (Object)closure6046;
  Method *meth_meth_ast__apply_40_1_41_6046 = addmethod2pos(block6045, "_apply(1)", &meth_ast__apply_40_1_41_6046, 0);
  int argcv_meth_ast__apply_40_1_41_6046[] = {1};
  meth_meth_ast__apply_40_1_41_6046->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6046);
  meth_meth_ast__apply_40_1_41_6046->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6046->definitionLine = 2981;
// compiled block node returning block6045 (depth = 5)
  gc_frame_newslot(block6045);
// call case 5: prelude request
  params[0] = call6044;
  params[1] = block6045;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6050 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6042);
// compiled call node returning call6050 (depth = 4)
    gc_frame_newslot(call6050);
    if6037 = call6050;
  } else {
  }
// compiled if node returning if6037 (depth = 3)
  gc_frame_end(frame);
  return if6037;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_6051(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1472
  setline(1472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6052 = gc_frame_new();
// call case 4: self request
  Object call6053 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6052);
// compiled member node returning call6053 (depth = 4)
  *var_n = call6053;
  if (call6053 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6054 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6055 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6054);
// compiled call node returning call6055 (depth = 4)
  *var_newChain = call6055;
  if (call6055 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6056 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6057 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6058 = gc_frame_new();
// call case 4: self request
  Object call6059 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6058);
// compiled member node returning call6059 (depth = 5)
  gc_frame_newslot(call6059);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6060 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6061 = gc_frame_new();
// call case 3: self.outer request
  Object call6062 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6061);
// compiled member node returning call6062 (depth = 6)
  Object call6063 = callmethodflags(call6062, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6060);
// compiled member node returning call6063 (depth = 5)
  params[0] = call6059;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6064 = callmethodflags(call6063, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6057);
// compiled call node returning call6064 (depth = 4)
  gc_frame_newslot(call6064);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6064;
  partcv[0] = 1;
  Object call6065 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6056);
// compiled call node returning call6065 (depth = 3)
// Begin line 1475
  setline(1475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6066 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6067 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6066);
// compiled call node returning call6067 (depth = 3)
  gc_frame_end(frame);
  return call6067;
}
Object meth_ast__apply_40_1_41_6076(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ai = &(stackframe->slots[0]);
  *var_ai = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1480
  setline(1480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6078 == NULL) {
    strlit6078 = alloc_String("  ");
    gc_root(strlit6078);
  }
// compiled string node returning strlit6078 (depth = 7)
  int op_slot_right_6077 = gc_frame_newslot(strlit6078);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_6077 = gc_frame_newslot(*var_spc);
  params[0] = strlit6078;
  partcv[0] = 1;
  Object opresult6080 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult6080 (depth = 6)
  *var_spc = opresult6080;
  if (opresult6080 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_6090(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ax = &(stackframe->slots[0]);
  *var_ax = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6092 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6094 = alloc_Float64(1);
// compiled num node returning num6094 (depth = 9)
  int op_slot_right_6093 = gc_frame_newslot(num6094);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6093 = gc_frame_newslot(*var_depth);
  params[0] = num6094;
  partcv[0] = 1;
  Object sum6096 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6096 (depth = 8)
  gc_frame_newslot(sum6096);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ax (depth = 8)
  params[0] = sum6096;
  partcv[0] = 1;
  Object call6097 = callmethodflags(*var_ax, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6092);
// compiled call node returning call6097 (depth = 7)
  int op_slot_right_6091 = gc_frame_newslot(call6097);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_6099 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6102 == NULL) {
    strlit6102 = alloc_String("""\x0a""");
    gc_root(strlit6102);
  }
// compiled string node returning strlit6102 (depth = 9)
  int op_slot_right_6101 = gc_frame_newslot(strlit6102);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_6101 = gc_frame_newslot(*var_s);
  params[0] = strlit6102;
  partcv[0] = 1;
  Object opresult6104 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6104 (depth = 8)
  int op_slot_left_6099 = gc_frame_newslot(opresult6104);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6105 = callmethod(opresult6104, "++(1)", 1, partcv, params);
// compiled op node returning opresult6105 (depth = 7)
  int op_slot_left_6091 = gc_frame_newslot(opresult6105);
  params[0] = call6097;
  partcv[0] = 1;
  Object opresult6106 = callmethod(opresult6105, "++(1)", 1, partcv, params);
// compiled op node returning opresult6106 (depth = 6)
  *var_s = opresult6106;
  if (opresult6106 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_6068(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1478
  setline(1478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6069 == NULL) {
    strlit6069 = alloc_String("");
    gc_root(strlit6069);
  }
// compiled string node returning strlit6069 (depth = 4)
  *var_spc = strlit6069;
  if (strlit6069 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1479
  setline(1479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6070 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_6071 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num6073 = alloc_Float64(0);
// compiled num node returning num6073 (depth = 5)
  int op_slot_left_6071 = gc_frame_newslot(num6073);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6074 = callmethod(num6073, "..(1)", 1, partcv, params);
// compiled op node returning opresult6074 (depth = 4)
  gc_frame_newslot(opresult6074);
// starting to compile block node (depth = 4)
  Object block6075 = alloc_Block(NULL, NULL, "ast", 1479);
  gc_frame_newslot(block6075);
// method "_apply(_)"
  block_savedest(block6075);
  Object closure6076 = createclosure(2, "_apply(1)");
  setclosureframe(closure6076, stackframe);
  addtoclosure(closure6076, var_spc);
  addtoclosure(closure6076, selfslot);
  struct UserObject *uo6076 = (struct UserObject*)block6075;
  uo6076->data[0] = (Object)closure6076;
  Method *meth_meth_ast__apply_40_1_41_6076 = addmethod2pos(block6075, "_apply(1)", &meth_ast__apply_40_1_41_6076, 0);
  int argcv_meth_ast__apply_40_1_41_6076[] = {1};
  meth_meth_ast__apply_40_1_41_6076->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6076);
  meth_meth_ast__apply_40_1_41_6076->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6076->definitionLine = 2981;
// compiled block node returning block6075 (depth = 4)
  gc_frame_newslot(block6075);
// call case 5: prelude request
  params[0] = opresult6074;
  params[1] = block6075;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6083 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6070);
// compiled call node returning call6083 (depth = 3)
// Begin line 1482
  setline(1482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6084 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6085 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6084);
// compiled call node returning call6085 (depth = 4)
  *var_s = call6085;
  if (call6085 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6086 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6087 = gc_frame_new();
// call case 4: self request
  Object call6088 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6087);
// compiled member node returning call6088 (depth = 4)
  gc_frame_newslot(call6088);
// starting to compile block node (depth = 4)
  Object block6089 = alloc_Block(NULL, NULL, "ast", 1483);
  gc_frame_newslot(block6089);
// method "_apply(_)"
  block_savedest(block6089);
  Object closure6090 = createclosure(4, "_apply(1)");
  setclosureframe(closure6090, stackframe);
  addtoclosure(closure6090, var_depth);
  addtoclosure(closure6090, var_spc);
  addtoclosure(closure6090, var_s);
  addtoclosure(closure6090, selfslot);
  struct UserObject *uo6090 = (struct UserObject*)block6089;
  uo6090->data[0] = (Object)closure6090;
  Method *meth_meth_ast__apply_40_1_41_6090 = addmethod2pos(block6089, "_apply(1)", &meth_ast__apply_40_1_41_6090, 0);
  int argcv_meth_ast__apply_40_1_41_6090[] = {1};
  meth_meth_ast__apply_40_1_41_6090->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6090);
  meth_meth_ast__apply_40_1_41_6090->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6090->definitionLine = 2981;
// compiled block node returning block6089 (depth = 4)
  gc_frame_newslot(block6089);
// call case 5: prelude request
  params[0] = call6088;
  params[1] = block6089;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6109 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6086);
// compiled call node returning call6109 (depth = 3)
// Begin line 1486
  setline(1486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_6118(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1491
  setline(1491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6120 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num6121 = alloc_Float64(0);
// compiled num node returning num6121 (depth = 8)
  gc_frame_newslot(num6121);
// call case 6: other requests
// starting to compile call node (depth = 8)
  int callframe6122 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe6123 = gc_frame_new();
// call case 4: self request
  Object call6124 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6123);
// compiled member node returning call6124 (depth = 9)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call6125 = callmethodflags(call6124, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6122);
// compiled call node returning call6125 (depth = 8)
  params[0] = num6121;
  partcv[0] = 1;
  Object call6126 = callmethodflags(call6125, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6120);
// compiled call node returning call6126 (depth = 7)
  int op_slot_right_6119 = gc_frame_newslot(call6126);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6119 = gc_frame_newslot(*var_s);
  params[0] = call6126;
  partcv[0] = 1;
  Object opresult6128 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6128 (depth = 6)
  *var_s = opresult6128;
  if (opresult6128 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6132 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe6133 = gc_frame_new();
// call case 4: self request
  Object call6134 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6133);
// compiled member node returning call6134 (depth = 8)
  Object call6135 = callmethodflags(call6134, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6132);
// compiled member node returning call6135 (depth = 7)
  int op_slot_right_6131 = gc_frame_newslot(call6135);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  int op_slot_left_6131 = gc_frame_newslot(*var_i);
  params[0] = call6135;
  partcv[0] = 1;
  Object opresult6137 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult6137 (depth = 6)
  Object if6130 = done;
  if (istrue(opresult6137)) {
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6139 == NULL) {
    strlit6139 = alloc_String(", ");
    gc_root(strlit6139);
  }
// compiled string node returning strlit6139 (depth = 8)
  int op_slot_right_6138 = gc_frame_newslot(strlit6139);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6138 = gc_frame_newslot(*var_s);
  params[0] = strlit6139;
  partcv[0] = 1;
  Object opresult6141 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6141 (depth = 7)
  *var_s = opresult6141;
  if (opresult6141 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if6130 = done;
  } else {
  }
// compiled if node returning if6130 (depth = 5)
  gc_frame_end(frame);
  return if6130;
}
Object meth_ast_toGrace_40_1_41_6110(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6111 == NULL) {
    strlit6111 = alloc_String("[");
    gc_root(strlit6111);
  }
// compiled string node returning strlit6111 (depth = 4)
  *var_s = strlit6111;
  if (strlit6111 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6112 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6113 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6114 = gc_frame_new();
// call case 4: self request
  Object call6115 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6114);
// compiled member node returning call6115 (depth = 5)
  Object call6116 = callmethodflags(call6115, "indices", 0, partcv, params, 0);
  gc_frame_end(callframe6113);
// compiled member node returning call6116 (depth = 4)
  gc_frame_newslot(call6116);
// starting to compile block node (depth = 4)
  Object block6117 = alloc_Block(NULL, NULL, "ast", 1490);
  gc_frame_newslot(block6117);
// method "_apply(_)"
  block_savedest(block6117);
  Object closure6118 = createclosure(2, "_apply(1)");
  setclosureframe(closure6118, stackframe);
  addtoclosure(closure6118, var_s);
  addtoclosure(closure6118, selfslot);
  struct UserObject *uo6118 = (struct UserObject*)block6117;
  uo6118->data[0] = (Object)closure6118;
  Method *meth_meth_ast__apply_40_1_41_6118 = addmethod2pos(block6117, "_apply(1)", &meth_ast__apply_40_1_41_6118, 0);
  int argcv_meth_ast__apply_40_1_41_6118[] = {1};
  meth_meth_ast__apply_40_1_41_6118->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6118);
  meth_meth_ast__apply_40_1_41_6118->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6118->definitionLine = 2981;
// compiled block node returning block6117 (depth = 4)
  gc_frame_newslot(block6117);
// call case 5: prelude request
  params[0] = call6116;
  params[1] = block6117;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6144 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6112);
// compiled call node returning call6144 (depth = 3)
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6146 == NULL) {
    strlit6146 = alloc_String("]");
    gc_root(strlit6146);
  }
// compiled string node returning strlit6146 (depth = 5)
  int op_slot_right_6145 = gc_frame_newslot(strlit6146);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_6145 = gc_frame_newslot(*var_s);
  params[0] = strlit6146;
  partcv[0] = 1;
  Object opresult6148 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6148 (depth = 4)
  *var_s = opresult6148;
  if (opresult6148 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1497
  setline(1497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy6150(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1500
  setline(1500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6151 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6152 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_arrayNode (depth = 5)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call6153 = callmethodflags(*var_arrayNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6152);
// compiled call node returning call6153 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6154 = callmethodflags(call6153, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6151);
// compiled call node returning call6154 (depth = 3)
  gc_frame_end(frame);
  return call6154;
}
Object meth_ast_new_40_1_41_6031(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_values = &(stackframe->slots[0]);
  *var_values = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6032 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6032 = alloc_userobj2(8,8, objclass6032);
  gc_frame_newslot(obj6032);
if (objclass6032 == NULL) {
  glfree(obj6032->class->name);
  obj6032->class->name = "arrayNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6032, self, 0);
  addmethodreal(obj6032,"outer", &reader_ast_outer_6033);
  Object oldself6032 = self;
  struct StackFrameObject *oldstackframe6032 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6032);
  gc_frame_newslot((Object)stackframe);
  self = obj6032;
  Object *oldselfslot6032 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6032 = (*(struct UserObject *)self).data[0], lowerouter6032 = thisouter6032;
  if (inheritingObject6032) {
    struct UserObject *inho6032 = (struct UserObject *)inheritingObject6032;
    while (inho6032->super != GraceDefaultObject) inho6032 = (struct UserObject *)inho6032->super;
    inho6032->super = obj6032;
    self = inheritingObject6032;
    *selfslot = self;
    lowerouter6032 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6032;
  }
if (objclass6032 == NULL) {
  Method *reader6034 = addmethodrealflags(obj6032, "kind",&reader_ast_kind_6034, MFLAG_DEF);
  reader6034->definitionModule = modulename;
  reader6034->definitionLine = 1461;
}
adddatum2(obj6032, alloc_Undefined(), 1);
if (objclass6032 == NULL) {
  Method *reader6035 = addmethodrealflags(obj6032, "value", &reader_ast_value_6035, 0);
  Method *writer6035 = addmethodrealflags(obj6032, "value:=(1)", &writer_ast_value_6035, 0);
  reader6035->definitionModule = modulename;
  writer6035->definitionModule = modulename;
  reader6035->definitionLine = 1462;
  writer6035->definitionLine = 1462;
}
obj6032->flags |= OFLAG_MUTABLE;
adddatum2(obj6032, alloc_Undefined(), 2);
// method "accept(_)from(_)"
  struct UserObject *uo6036 = (struct UserObject*)obj6032;
  uo6036->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6036 = addmethod2pos(obj6032, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6036, 3);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6036[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6036->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6036);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6036->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6036->definitionLine = 1463;
// method "map(_)ancestors(_)"
  struct UserObject *uo6051 = (struct UserObject*)obj6032;
  uo6051->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6051 = addmethod2pos(obj6032, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6051, 4);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6051[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6051->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6051);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6051->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6051->definitionLine = 1471;
// method "pretty(_)"
  struct UserObject *uo6068 = (struct UserObject*)obj6032;
  uo6068->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_6068 = addmethod2pos(obj6032, "pretty(1)", &meth_ast_pretty_40_1_41_6068, 5);
  int argcv_meth_ast_pretty_40_1_41_6068[] = {1};
  meth_meth_ast_pretty_40_1_41_6068->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_6068);
  meth_meth_ast_pretty_40_1_41_6068->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_6068->definitionLine = 1477;
// method "toGrace(_)"
  struct UserObject *uo6110 = (struct UserObject*)obj6032;
  uo6110->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_6110 = addmethod2pos(obj6032, "toGrace(1)", &meth_ast_toGrace_40_1_41_6110, 6);
  int argcv_meth_ast_toGrace_40_1_41_6110[] = {1};
  meth_meth_ast_toGrace_40_1_41_6110->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_6110);
meth_meth_ast_toGrace_40_1_41_6110->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_6110->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_6110->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_6110->definitionLine = 1488;
// method "shallowCopy"
  block_savedest(obj6032);
  Object closure6150 = createclosure(2, "shallowCopy");
  setclosureframe(closure6150, stackframe);
  addtoclosure(closure6150, var_emptySeq);
  addtoclosure(closure6150, var_arrayNode);
  struct UserObject *uo6150 = (struct UserObject*)obj6032;
  uo6150->data[7] = (Object)closure6150;
  Method *meth_meth_ast_shallowCopy6150 = addmethod2pos(obj6032, "shallowCopy", &meth_ast_shallowCopy6150, 7);
  int argcv_meth_ast_shallowCopy6150[] = {0};
  meth_meth_ast_shallowCopy6150->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6150);
  meth_meth_ast_shallowCopy6150->definitionModule = modulename;
  meth_meth_ast_shallowCopy6150->definitionLine = 1499;
  sourceObject = obj6032;
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6155 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6156 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6157 = gc_frame_new();
// call case 3: self.outer request
  Object call6158 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6157);
// compiled member node returning call6158 (depth = 5)
  Object call6159 = callmethodflags(call6158, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6156);
// compiled member node returning call6159 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6160 = callmethodflags(call6159, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6155);
// compiled call node returning call6160 (depth = 3)
  struct UserObject *obj6032_uo = (struct UserObject *)obj6032;
  obj6032_uo->super = call6160;
  sourceObject = obj6032;
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6161 == NULL) {
    strlit6161 = alloc_String("array");
    gc_root(strlit6161);
  }
// compiled string node returning strlit6161 (depth = 3)
  adddatum2(obj6032, strlit6161, 1);
  sourceObject = obj6032;
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  adddatum2(obj6032, *var_values, 2);
  sourceObject = obj6032;
  sourceObject = obj6032;
  sourceObject = obj6032;
  sourceObject = obj6032;
  sourceObject = obj6032;
  objclass6032 = obj6032->class;
  objclass6032->definitionModule = modulename;
  objclass6032->definitionLine = 1459;
  (*(struct UserObject *)self).data[0] = lowerouter6032;
  self = oldself6032;
  selfslot = oldselfslot6032;
  stackframe = oldstackframe6032;
  gc_frame_end(frame);
  return obj6032;
}
Object meth_ast_new_40_1_41_6031_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_values = &(stackframe->slots[0]);
  *var_values = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6032 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6032 = alloc_userobj2(8,8, objclass6032);
  gc_frame_newslot(obj6032);
if (objclass6032 == NULL) {
  glfree(obj6032->class->name);
  obj6032->class->name = "arrayNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6032, self, 0);
  addmethodreal(obj6032,"outer", &reader_ast_outer_6033);
  Object oldself6032 = self;
  struct StackFrameObject *oldstackframe6032 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6032);
  gc_frame_newslot((Object)stackframe);
  self = obj6032;
  Object *oldselfslot6032 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6032 = (*(struct UserObject *)self).data[0], lowerouter6032 = thisouter6032;
  if (inheritingObject6032) {
    struct UserObject *inho6032 = (struct UserObject *)inheritingObject6032;
    while (inho6032->super != GraceDefaultObject) inho6032 = (struct UserObject *)inho6032->super;
    inho6032->super = obj6032;
    self = inheritingObject6032;
    *selfslot = self;
    lowerouter6032 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6032;
  }
if (objclass6032 == NULL) {
  Method *reader6034 = addmethodrealflags(obj6032, "kind",&reader_ast_kind_6034, MFLAG_DEF);
  reader6034->definitionModule = modulename;
  reader6034->definitionLine = 1461;
}
adddatum2(obj6032, alloc_Undefined(), 1);
if (objclass6032 == NULL) {
  Method *reader6035 = addmethodrealflags(obj6032, "value", &reader_ast_value_6035, 0);
  Method *writer6035 = addmethodrealflags(obj6032, "value:=(1)", &writer_ast_value_6035, 0);
  reader6035->definitionModule = modulename;
  writer6035->definitionModule = modulename;
  reader6035->definitionLine = 1462;
  writer6035->definitionLine = 1462;
}
obj6032->flags |= OFLAG_MUTABLE;
adddatum2(obj6032, alloc_Undefined(), 2);
// method "accept(_)from(_)"
  struct UserObject *uo6036 = (struct UserObject*)obj6032;
  uo6036->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6036 = addmethod2pos(obj6032, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6036, 3);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6036[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6036->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6036);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6036->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6036->definitionLine = 1463;
// method "map(_)ancestors(_)"
  struct UserObject *uo6051 = (struct UserObject*)obj6032;
  uo6051->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6051 = addmethod2pos(obj6032, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6051, 4);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6051[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6051->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6051);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6051->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6051->definitionLine = 1471;
// method "pretty(_)"
  struct UserObject *uo6068 = (struct UserObject*)obj6032;
  uo6068->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_6068 = addmethod2pos(obj6032, "pretty(1)", &meth_ast_pretty_40_1_41_6068, 5);
  int argcv_meth_ast_pretty_40_1_41_6068[] = {1};
  meth_meth_ast_pretty_40_1_41_6068->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_6068);
  meth_meth_ast_pretty_40_1_41_6068->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_6068->definitionLine = 1477;
// method "toGrace(_)"
  struct UserObject *uo6110 = (struct UserObject*)obj6032;
  uo6110->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_6110 = addmethod2pos(obj6032, "toGrace(1)", &meth_ast_toGrace_40_1_41_6110, 6);
  int argcv_meth_ast_toGrace_40_1_41_6110[] = {1};
  meth_meth_ast_toGrace_40_1_41_6110->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_6110);
meth_meth_ast_toGrace_40_1_41_6110->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_6110->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_6110->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_6110->definitionLine = 1488;
// method "shallowCopy"
  block_savedest(obj6032);
  Object closure6150 = createclosure(2, "shallowCopy");
  setclosureframe(closure6150, stackframe);
  addtoclosure(closure6150, var_emptySeq);
  addtoclosure(closure6150, var_arrayNode);
  struct UserObject *uo6150 = (struct UserObject*)obj6032;
  uo6150->data[7] = (Object)closure6150;
  Method *meth_meth_ast_shallowCopy6150 = addmethod2pos(obj6032, "shallowCopy", &meth_ast_shallowCopy6150, 7);
  int argcv_meth_ast_shallowCopy6150[] = {0};
  meth_meth_ast_shallowCopy6150->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6150);
  meth_meth_ast_shallowCopy6150->definitionModule = modulename;
  meth_meth_ast_shallowCopy6150->definitionLine = 1499;
  sourceObject = obj6032;
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6155 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6156 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6157 = gc_frame_new();
// call case 3: self.outer request
  Object call6158 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6157);
// compiled member node returning call6158 (depth = 5)
  Object call6159 = callmethodflags(call6158, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6156);
// compiled member node returning call6159 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6160 = callmethodflags(call6159, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6155);
// compiled call node returning call6160 (depth = 3)
  struct UserObject *obj6032_uo = (struct UserObject *)obj6032;
  obj6032_uo->super = call6160;
  sourceObject = obj6032;
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6161 == NULL) {
    strlit6161 = alloc_String("array");
    gc_root(strlit6161);
  }
// compiled string node returning strlit6161 (depth = 3)
  adddatum2(obj6032, strlit6161, 1);
  sourceObject = obj6032;
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  adddatum2(obj6032, *var_values, 2);
  sourceObject = obj6032;
  sourceObject = obj6032;
  sourceObject = obj6032;
  sourceObject = obj6032;
  sourceObject = obj6032;
  objclass6032 = obj6032->class;
  objclass6032->definitionModule = modulename;
  objclass6032->definitionLine = 1459;
  (*(struct UserObject *)self).data[0] = lowerouter6032;
  self = oldself6032;
  selfslot = oldselfslot6032;
  stackframe = oldstackframe6032;
  gc_frame_end(frame);
  return obj6032;
}
Object meth_ast_arrayNode6163(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "arrayNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_arrayNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arrayNode (depth = 3)
  gc_frame_end(frame);
  return *var_arrayNode;
}
Object meth_ast_new_40_2_41_scope_40_1_41_6166(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(2)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)scope(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_request = &(stackframe->slots[0]);
  *var_request = args[curarg];
  curarg++;
  Object *var_receiver = &(stackframe->slots[1]);
  *var_receiver = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1507
  setline(1507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6167 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_request (depth = 5)
  gc_frame_newslot(*var_request);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_receiver (depth = 5)
  gc_frame_newslot(*var_receiver);
// call case 4: self request
  params[0] = *var_request;
  params[1] = *var_receiver;
  partcv[0] = 2;
  Object call6168 = callmethodflags(self, "new(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6167);
// compiled call node returning call6168 (depth = 4)
  *var_result = call6168;
  if (call6168 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1508
  setline(1508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6169 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call6170 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6169);
// compiled call node returning call6170 (depth = 3)
// Begin line 1509
  setline(1509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_onSelf6179(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "onSelf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1521
  setline(1521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6180 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool6181 = alloc_Boolean(1);
// compiled identifier node returning bool6181 (depth = 4)
  gc_frame_newslot(bool6181);
// call case 4: self request
  params[0] = bool6181;
  partcv[0] = 1;
  Object call6182 = callmethodflags(self, "isSelfRequest:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6180);
// compiled call node returning call6182 (depth = 3)
// Begin line 1522
  setline(1522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_nameString6183(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1524
  setline(1524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6184 = gc_frame_new();
// call case 4: self request
  Object call6185 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6184);
// compiled member node returning call6185 (depth = 3)
  gc_frame_end(frame);
  return call6185;
}
Object meth_ast_canonicalName6186(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1525
  setline(1525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6187 = gc_frame_new();
// call case 4: self request
  Object call6188 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6187);
// compiled member node returning call6188 (depth = 3)
  gc_frame_end(frame);
  return call6188;
}
Object meth_ast_isMember6189(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1526
  setline(1526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6190 = alloc_Boolean(1);
// compiled identifier node returning bool6190 (depth = 3)
  gc_frame_end(frame);
  return bool6190;
}
Object meth_ast_isCall6191(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1527
  setline(1527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6192 = alloc_Boolean(1);
// compiled identifier node returning bool6192 (depth = 3)
  gc_frame_end(frame);
  return bool6192;
}
Object meth_ast_with6193(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "with");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1529
  setline(1529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySeq (depth = 3)
  gc_frame_end(frame);
  return *var_emptySeq;
}
Object meth_ast_arguments6194(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "arguments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1530
  setline(1530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySeq (depth = 3)
  gc_frame_end(frame);
  return *var_emptySeq;
}
Object meth_ast_argumentsDo6195(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "argumentsDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_6211(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe6212 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6213 = callmethodflags(*var_each, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6212);
// compiled call node returning call6213 (depth = 7)
  gc_frame_end(frame);
  return call6213;
}
Object meth_ast_accept_40_1_41_from_40_1_41_6196(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1533
  setline(1533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6198 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6199 = callmethodflags(*var_visitor, "visitMember(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6198);
// compiled call node returning call6199 (depth = 4)
  Object if6197 = done;
  if (istrue(call6199)) {
// Begin line 1534
  setline(1534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6200 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6201 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6200);
// compiled call node returning call6201 (depth = 5)
  *var_newChain = call6201;
  if (call6201 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1535
  setline(1535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6204 = gc_frame_new();
// call case 4: self request
  Object call6205 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6204);
// compiled member node returning call6205 (depth = 6)
  int op_slot_right_6203 = gc_frame_newslot(call6205);
// starting to compile identifier node (depth = 6)
  Object bool6207 = alloc_Boolean(0);
// compiled identifier node returning bool6207 (depth = 6)
  int op_slot_left_6203 = gc_frame_newslot(bool6207);
  params[0] = call6205;
  partcv[0] = 1;
  Object opresult6208 = callmethod(bool6207, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6208 (depth = 5)
  Object if6202 = done;
  if (istrue(opresult6208)) {
// Begin line 1536
  setline(1536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6209 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block6210 = alloc_Block(NULL, NULL, "ast", 1536);
  gc_frame_newslot(block6210);
// method "_apply(_)"
  block_savedest(block6210);
  Object closure6211 = createclosure(3, "_apply(1)");
  setclosureframe(closure6211, stackframe);
  addtoclosure(closure6211, var_visitor);
  addtoclosure(closure6211, var_newChain);
  addtoclosure(closure6211, selfslot);
  struct UserObject *uo6211 = (struct UserObject*)block6210;
  uo6211->data[0] = (Object)closure6211;
  Method *meth_meth_ast__apply_40_1_41_6211 = addmethod2pos(block6210, "_apply(1)", &meth_ast__apply_40_1_41_6211, 0);
  int argcv_meth_ast__apply_40_1_41_6211[] = {1};
  meth_meth_ast__apply_40_1_41_6211->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6211);
  meth_meth_ast__apply_40_1_41_6211->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6211->definitionLine = 2981;
// compiled block node returning block6210 (depth = 6)
  gc_frame_newslot(block6210);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6215 = gc_frame_new();
// call case 4: self request
  Object call6216 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6215);
// compiled member node returning call6216 (depth = 6)
  params[0] = block6210;
  partcv[0] = 1;
  Object call6217 = callmethodflags(call6216, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6209);
// compiled call node returning call6217 (depth = 5)
    gc_frame_newslot(call6217);
    if6202 = call6217;
  } else {
  }
// compiled if node returning if6202 (depth = 4)
// Begin line 1538
  setline(1538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6218 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6219 = gc_frame_new();
// call case 4: self request
  Object call6220 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6219);
// compiled member node returning call6220 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6221 = callmethodflags(call6220, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6218);
// compiled call node returning call6221 (depth = 4)
    gc_frame_newslot(call6221);
    if6197 = call6221;
  } else {
  }
// compiled if node returning if6197 (depth = 3)
  gc_frame_end(frame);
  return if6197;
}
Object meth_ast_isSelfOrOuter6222(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSelfOrOuter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1542
  setline(1542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6225 == NULL) {
    strlit6225 = alloc_String("outer");
    gc_root(strlit6225);
  }
// compiled string node returning strlit6225 (depth = 5)
  int op_slot_right_6224 = gc_frame_newslot(strlit6225);
// starting to compile member node (depth = 5)
  int callframe6227 = gc_frame_new();
// call case 4: self request
  Object call6228 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6227);
// compiled member node returning call6228 (depth = 5)
  int op_slot_left_6224 = gc_frame_newslot(call6228);
  params[0] = strlit6225;
  partcv[0] = 1;
  Object opresult6229 = callmethod(call6228, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6229 (depth = 4)
  Object if6223 = done;
  if (istrue(opresult6229)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6230 = alloc_Boolean(0);
// compiled identifier node returning bool6230 (depth = 5)
  return bool6230;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if6223 = undefined;
  } else {
  }
// compiled if node returning if6223 (depth = 3)
// Begin line 1543
  setline(1543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6231 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6232 = gc_frame_new();
// call case 4: self request
  Object call6233 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6232);
// compiled member node returning call6233 (depth = 4)
  Object call6234 = callmethodflags(call6233, "isSelfOrOuter", 0, partcv, params, 0);
  gc_frame_end(callframe6231);
// compiled member node returning call6234 (depth = 3)
  gc_frame_end(frame);
  return call6234;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_6235(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1546
  setline(1546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6236 = gc_frame_new();
// call case 4: self request
  Object call6237 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6236);
// compiled member node returning call6237 (depth = 4)
  *var_n = call6237;
  if (call6237 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1547
  setline(1547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6238 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6239 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6238);
// compiled call node returning call6239 (depth = 4)
  *var_newChain = call6239;
  if (call6239 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1548
  setline(1548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6240 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6241 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6242 = gc_frame_new();
// call case 4: self request
  Object call6243 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6242);
// compiled member node returning call6243 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6244 = callmethodflags(call6243, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6241);
// compiled call node returning call6244 (depth = 4)
  gc_frame_newslot(call6244);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6244;
  partcv[0] = 1;
  Object call6245 = callmethodflags(*var_n, "receiver:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6240);
// compiled call node returning call6245 (depth = 3)
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6246 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6247 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6248 = gc_frame_new();
// call case 4: self request
  Object call6249 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6248);
// compiled member node returning call6249 (depth = 5)
  gc_frame_newslot(call6249);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6250 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6251 = gc_frame_new();
// call case 3: self.outer request
  Object call6252 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6251);
// compiled member node returning call6252 (depth = 6)
  Object call6253 = callmethodflags(call6252, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6250);
// compiled member node returning call6253 (depth = 5)
  params[0] = call6249;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6254 = callmethodflags(call6253, "maybeListMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6247);
// compiled call node returning call6254 (depth = 4)
  gc_frame_newslot(call6254);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6254;
  partcv[0] = 1;
  Object call6255 = callmethodflags(*var_n, "generics:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6246);
// compiled call node returning call6255 (depth = 3)
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6256 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6257 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6256);
// compiled call node returning call6257 (depth = 3)
  gc_frame_end(frame);
  return call6257;
}
Object meth_ast__apply_40_1_41_6266(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1555
  setline(1555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6268 == NULL) {
    strlit6268 = alloc_String("  ");
    gc_root(strlit6268);
  }
// compiled string node returning strlit6268 (depth = 7)
  int op_slot_right_6267 = gc_frame_newslot(strlit6268);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_6267 = gc_frame_newslot(*var_spc);
  params[0] = strlit6268;
  partcv[0] = 1;
  Object opresult6270 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult6270 (depth = 6)
  *var_spc = opresult6270;
  if (opresult6270 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_6333(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6335 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num6336 = alloc_Float64(0);
// compiled num node returning num6336 (depth = 9)
  gc_frame_newslot(num6336);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_g (depth = 9)
  params[0] = num6336;
  partcv[0] = 1;
  Object call6337 = callmethodflags(*var_g, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6335);
// compiled call node returning call6337 (depth = 8)
  int op_slot_right_6334 = gc_frame_newslot(call6337);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6340 == NULL) {
    strlit6340 = alloc_String("    ");
    gc_root(strlit6340);
  }
// compiled string node returning strlit6340 (depth = 9)
  int op_slot_right_6339 = gc_frame_newslot(strlit6340);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_6342 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit6345 == NULL) {
    strlit6345 = alloc_String("""\x0a""");
    gc_root(strlit6345);
  }
// compiled string node returning strlit6345 (depth = 11)
  int op_slot_right_6344 = gc_frame_newslot(strlit6345);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_6344 = gc_frame_newslot(*var_s);
  params[0] = strlit6345;
  partcv[0] = 1;
  Object opresult6347 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6347 (depth = 10)
  int op_slot_left_6342 = gc_frame_newslot(opresult6347);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6348 = callmethod(opresult6347, "++(1)", 1, partcv, params);
// compiled op node returning opresult6348 (depth = 9)
  int op_slot_left_6339 = gc_frame_newslot(opresult6348);
  params[0] = strlit6340;
  partcv[0] = 1;
  Object opresult6349 = callmethod(opresult6348, "++(1)", 1, partcv, params);
// compiled op node returning opresult6349 (depth = 8)
  int op_slot_left_6334 = gc_frame_newslot(opresult6349);
  params[0] = call6337;
  partcv[0] = 1;
  Object opresult6350 = callmethod(opresult6349, "++(1)", 1, partcv, params);
// compiled op node returning opresult6350 (depth = 7)
  *var_s = opresult6350;
  if (opresult6350 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_6258(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1553
  setline(1553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6259 == NULL) {
    strlit6259 = alloc_String("");
    gc_root(strlit6259);
  }
// compiled string node returning strlit6259 (depth = 4)
  *var_spc = strlit6259;
  if (strlit6259 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1554
  setline(1554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6260 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_6261 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num6263 = alloc_Float64(0);
// compiled num node returning num6263 (depth = 5)
  int op_slot_left_6261 = gc_frame_newslot(num6263);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6264 = callmethod(num6263, "..(1)", 1, partcv, params);
// compiled op node returning opresult6264 (depth = 4)
  gc_frame_newslot(opresult6264);
// starting to compile block node (depth = 4)
  Object block6265 = alloc_Block(NULL, NULL, "ast", 1554);
  gc_frame_newslot(block6265);
// method "_apply(_)"
  block_savedest(block6265);
  Object closure6266 = createclosure(2, "_apply(1)");
  setclosureframe(closure6266, stackframe);
  addtoclosure(closure6266, var_spc);
  addtoclosure(closure6266, selfslot);
  struct UserObject *uo6266 = (struct UserObject*)block6265;
  uo6266->data[0] = (Object)closure6266;
  Method *meth_meth_ast__apply_40_1_41_6266 = addmethod2pos(block6265, "_apply(1)", &meth_ast__apply_40_1_41_6266, 0);
  int argcv_meth_ast__apply_40_1_41_6266[] = {1};
  meth_meth_ast__apply_40_1_41_6266->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6266);
  meth_meth_ast__apply_40_1_41_6266->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6266->definitionLine = 2981;
// compiled block node returning block6265 (depth = 4)
  gc_frame_newslot(block6265);
// call case 5: prelude request
  params[0] = opresult6264;
  params[1] = block6265;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6273 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6260);
// compiled call node returning call6273 (depth = 3)
// Begin line 1557
  setline(1557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6274 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6275 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6274);
// compiled call node returning call6275 (depth = 4)
  *var_s = call6275;
  if (call6275 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1558
  setline(1558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6278 = gc_frame_new();
// call case 4: self request
  Object call6279 = callmethodflags(self, "isSelfRequest", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6278);
// compiled member node returning call6279 (depth = 6)
  Object if6277 = done;
struct StackFrameObject *iftmpstackframe6277 = stackframe;
  if (istrue(call6279)) {
stackframe = alloc_StackFrame(0, iftmpstackframe6277);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 6)
  if (strlit6280 == NULL) {
    strlit6280 = alloc_String(" on self ");
    gc_root(strlit6280);
  }
// compiled string node returning strlit6280 (depth = 6)
    gc_frame_newslot(strlit6280);
    if6277 = strlit6280;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe6277);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 6)
  if (strlit6281 == NULL) {
    strlit6281 = alloc_String(" ");
    gc_root(strlit6281);
  }
// compiled string node returning strlit6281 (depth = 6)
    gc_frame_newslot(strlit6281);
    if6277 = strlit6281;
  }
stackframe = iftmpstackframe6277;
// compiled if node returning if6277 (depth = 5)
  int op_slot_right_6276 = gc_frame_newslot(if6277);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_6276 = gc_frame_newslot(*var_s);
  params[0] = if6277;
  partcv[0] = 1;
  Object opresult6283 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6283 (depth = 4)
  *var_s = opresult6283;
  if (opresult6283 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6286 == NULL) {
    strlit6286 = alloc_String("""\xe2""""\x80""""\xba""""\x0a""");
    gc_root(strlit6286);
  }
// compiled string node returning strlit6286 (depth = 5)
  int op_slot_right_6285 = gc_frame_newslot(strlit6286);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6289 = gc_frame_new();
// call case 4: self request
  Object call6290 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6289);
// compiled member node returning call6290 (depth = 6)
  int op_slot_right_6288 = gc_frame_newslot(call6290);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6293 == NULL) {
    strlit6293 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit6293);
  }
// compiled string node returning strlit6293 (depth = 7)
  int op_slot_right_6292 = gc_frame_newslot(strlit6293);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6292 = gc_frame_newslot(*var_s);
  params[0] = strlit6293;
  partcv[0] = 1;
  Object opresult6295 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6295 (depth = 6)
  int op_slot_left_6288 = gc_frame_newslot(opresult6295);
  params[0] = call6290;
  partcv[0] = 1;
  Object opresult6296 = callmethod(opresult6295, "++(1)", 1, partcv, params);
// compiled op node returning opresult6296 (depth = 5)
  int op_slot_left_6285 = gc_frame_newslot(opresult6296);
  params[0] = strlit6286;
  partcv[0] = 1;
  Object opresult6297 = callmethod(opresult6296, "++(1)", 1, partcv, params);
// compiled op node returning opresult6297 (depth = 4)
  *var_s = opresult6297;
  if (opresult6297 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1560
  setline(1560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6300 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6301 = gc_frame_new();
// call case 4: self request
  Object call6302 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6301);
// compiled member node returning call6302 (depth = 6)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6303 = callmethodflags(call6302, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6300);
// compiled call node returning call6303 (depth = 5)
  int op_slot_right_6299 = gc_frame_newslot(call6303);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_6305 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6305 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6307 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6307 (depth = 5)
  int op_slot_left_6299 = gc_frame_newslot(opresult6307);
  params[0] = call6303;
  partcv[0] = 1;
  Object opresult6308 = callmethod(opresult6307, "++(1)", 1, partcv, params);
// compiled op node returning opresult6308 (depth = 4)
  *var_s = opresult6308;
  if (opresult6308 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6312 = gc_frame_new();
// call case 4: self request
  Object call6313 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6312);
// compiled member node returning call6313 (depth = 5)
  int op_slot_right_6311 = gc_frame_newslot(call6313);
// starting to compile identifier node (depth = 5)
  Object bool6315 = alloc_Boolean(0);
// compiled identifier node returning bool6315 (depth = 5)
  int op_slot_left_6311 = gc_frame_newslot(bool6315);
  params[0] = call6313;
  partcv[0] = 1;
  Object opresult6316 = callmethod(bool6315, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6316 (depth = 4)
  Object if6310 = done;
  if (istrue(opresult6316)) {
// Begin line 1562
  setline(1562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6318 == NULL) {
    strlit6318 = alloc_String("  Generics:");
    gc_root(strlit6318);
  }
// compiled string node returning strlit6318 (depth = 6)
  int op_slot_right_6317 = gc_frame_newslot(strlit6318);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_6320 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6323 == NULL) {
    strlit6323 = alloc_String("""\x0a""");
    gc_root(strlit6323);
  }
// compiled string node returning strlit6323 (depth = 8)
  int op_slot_right_6322 = gc_frame_newslot(strlit6323);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6322 = gc_frame_newslot(*var_s);
  params[0] = strlit6323;
  partcv[0] = 1;
  Object opresult6325 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6325 (depth = 7)
  int op_slot_left_6320 = gc_frame_newslot(opresult6325);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6326 = callmethod(opresult6325, "++(1)", 1, partcv, params);
// compiled op node returning opresult6326 (depth = 6)
  int op_slot_left_6317 = gc_frame_newslot(opresult6326);
  params[0] = strlit6318;
  partcv[0] = 1;
  Object opresult6327 = callmethod(opresult6326, "++(1)", 1, partcv, params);
// compiled op node returning opresult6327 (depth = 5)
  *var_s = opresult6327;
  if (opresult6327 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1563
  setline(1563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6329 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6330 = gc_frame_new();
// call case 4: self request
  Object call6331 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6330);
// compiled member node returning call6331 (depth = 5)
  gc_frame_newslot(call6331);
// starting to compile block node (depth = 5)
  Object block6332 = alloc_Block(NULL, NULL, "ast", 1563);
  gc_frame_newslot(block6332);
// method "_apply(_)"
  block_savedest(block6332);
  Object closure6333 = createclosure(3, "_apply(1)");
  setclosureframe(closure6333, stackframe);
  addtoclosure(closure6333, var_spc);
  addtoclosure(closure6333, var_s);
  addtoclosure(closure6333, selfslot);
  struct UserObject *uo6333 = (struct UserObject*)block6332;
  uo6333->data[0] = (Object)closure6333;
  Method *meth_meth_ast__apply_40_1_41_6333 = addmethod2pos(block6332, "_apply(1)", &meth_ast__apply_40_1_41_6333, 0);
  int argcv_meth_ast__apply_40_1_41_6333[] = {1};
  meth_meth_ast__apply_40_1_41_6333->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6333);
  meth_meth_ast__apply_40_1_41_6333->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6333->definitionLine = 2981;
// compiled block node returning block6332 (depth = 5)
  gc_frame_newslot(block6332);
// call case 5: prelude request
  params[0] = call6331;
  params[1] = block6332;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6353 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6329);
// compiled call node returning call6353 (depth = 4)
    gc_frame_newslot(call6353);
    if6310 = call6353;
  } else {
  }
// compiled if node returning if6310 (depth = 3)
// Begin line 1567
  setline(1567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_6430(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1580
  setline(1580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6432 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num6434 = alloc_Float64(1);
// compiled num node returning num6434 (depth = 10)
  int op_slot_right_6433 = gc_frame_newslot(num6434);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_6433 = gc_frame_newslot(*var_depth);
  params[0] = num6434;
  partcv[0] = 1;
  Object sum6436 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6436 (depth = 9)
  gc_frame_newslot(sum6436);
// call case 6: other requests
// starting to compile call node (depth = 9)
  int callframe6437 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe6438 = gc_frame_new();
// call case 4: self request
  Object call6439 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6438);
// compiled member node returning call6439 (depth = 10)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call6440 = callmethodflags(call6439, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6437);
// compiled call node returning call6440 (depth = 9)
  params[0] = sum6436;
  partcv[0] = 1;
  Object call6441 = callmethodflags(call6440, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6432);
// compiled call node returning call6441 (depth = 8)
  int op_slot_right_6431 = gc_frame_newslot(call6441);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6431 = gc_frame_newslot(*var_s);
  params[0] = call6441;
  partcv[0] = 1;
  Object opresult6443 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6443 (depth = 7)
  *var_s = opresult6443;
  if (opresult6443 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_6354(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1570
  setline(1570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6355 == NULL) {
    strlit6355 = alloc_String("");
    gc_root(strlit6355);
  }
// compiled string node returning strlit6355 (depth = 4)
  *var_s = strlit6355;
  if (strlit6355 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1571
  setline(1571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6358 == NULL) {
    strlit6358 = alloc_String("prefix");
    gc_root(strlit6358);
  }
// compiled string node returning strlit6358 (depth = 5)
  int op_slot_right_6357 = gc_frame_newslot(strlit6358);
// starting to compile call node (depth = 5)
  int callframe6360 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num6361 = alloc_Float64(1);
// compiled num node returning num6361 (depth = 6)
  gc_frame_newslot(num6361);
// starting to compile num node (depth = 6)
  Object num6362 = alloc_Float64(6);
// compiled num node returning num6362 (depth = 6)
  gc_frame_newslot(num6362);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6363 = gc_frame_new();
// call case 4: self request
  Object call6364 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6363);
// compiled member node returning call6364 (depth = 6)
  params[0] = num6361;
  params[1] = num6362;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6365 = callmethodflags(call6364, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6360);
// compiled call node returning call6365 (depth = 5)
  int op_slot_left_6357 = gc_frame_newslot(call6365);
  params[0] = strlit6358;
  partcv[0] = 1;
  Object opresult6366 = callmethod(call6365, "==(1)", 1, partcv, params);
// compiled op node returning opresult6366 (depth = 4)
  Object if6356 = done;
  if (istrue(opresult6366)) {
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6367 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num6368 = alloc_Float64(7);
// compiled num node returning num6368 (depth = 6)
  gc_frame_newslot(num6368);
// starting to compile member node (depth = 6)
  int callframe6369 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6370 = gc_frame_new();
// call case 4: self request
  Object call6371 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6370);
// compiled member node returning call6371 (depth = 7)
  Object call6372 = callmethodflags(call6371, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6369);
// compiled member node returning call6372 (depth = 6)
  gc_frame_newslot(call6372);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6373 = gc_frame_new();
// call case 4: self request
  Object call6374 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6373);
// compiled member node returning call6374 (depth = 6)
  params[0] = num6368;
  params[1] = call6372;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6375 = callmethodflags(call6374, "substringFrom(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6367);
// compiled call node returning call6375 (depth = 5)
  *var_s = call6375;
  if (call6375 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6378 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num6379 = alloc_Float64(0);
// compiled num node returning num6379 (depth = 7)
  gc_frame_newslot(num6379);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6380 = gc_frame_new();
// call case 4: self request
  Object call6381 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6380);
// compiled member node returning call6381 (depth = 7)
  params[0] = num6379;
  partcv[0] = 1;
  Object call6382 = callmethodflags(call6381, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6378);
// compiled call node returning call6382 (depth = 6)
  int op_slot_right_6377 = gc_frame_newslot(call6382);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6385 == NULL) {
    strlit6385 = alloc_String(" ");
    gc_root(strlit6385);
  }
// compiled string node returning strlit6385 (depth = 7)
  int op_slot_right_6384 = gc_frame_newslot(strlit6385);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6384 = gc_frame_newslot(*var_s);
  params[0] = strlit6385;
  partcv[0] = 1;
  Object opresult6387 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6387 (depth = 6)
  int op_slot_left_6377 = gc_frame_newslot(opresult6387);
  params[0] = call6382;
  partcv[0] = 1;
  Object opresult6388 = callmethod(opresult6387, "++(1)", 1, partcv, params);
// compiled op node returning opresult6388 (depth = 5)
  *var_s = opresult6388;
  if (opresult6388 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6356 = done;
  } else {
// Begin line 1575
  setline(1575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6391 = gc_frame_new();
// call case 4: self request
  Object call6392 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6391);
// compiled member node returning call6392 (depth = 6)
  int op_slot_right_6390 = gc_frame_newslot(call6392);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6395 == NULL) {
    strlit6395 = alloc_String(".");
    gc_root(strlit6395);
  }
// compiled string node returning strlit6395 (depth = 7)
  int op_slot_right_6394 = gc_frame_newslot(strlit6395);
// starting to compile call node (depth = 7)
  int callframe6397 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe6398 = gc_frame_new();
// call case 4: self request
  Object call6399 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6398);
// compiled member node returning call6399 (depth = 8)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6400 = callmethodflags(call6399, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6397);
// compiled call node returning call6400 (depth = 7)
  int op_slot_left_6394 = gc_frame_newslot(call6400);
  params[0] = strlit6395;
  partcv[0] = 1;
  Object opresult6401 = callmethod(call6400, "++(1)", 1, partcv, params);
// compiled op node returning opresult6401 (depth = 6)
  int op_slot_left_6390 = gc_frame_newslot(opresult6401);
  params[0] = call6392;
  partcv[0] = 1;
  Object opresult6402 = callmethod(opresult6401, "++(1)", 1, partcv, params);
// compiled op node returning opresult6402 (depth = 5)
  *var_s = opresult6402;
  if (opresult6402 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6356 = done;
  }
// compiled if node returning if6356 (depth = 3)
// Begin line 1577
  setline(1577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6406 = gc_frame_new();
// call case 4: self request
  Object call6407 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6406);
// compiled member node returning call6407 (depth = 5)
  int op_slot_right_6405 = gc_frame_newslot(call6407);
// starting to compile identifier node (depth = 5)
  Object bool6409 = alloc_Boolean(0);
// compiled identifier node returning bool6409 (depth = 5)
  int op_slot_left_6405 = gc_frame_newslot(bool6409);
  params[0] = call6407;
  partcv[0] = 1;
  Object opresult6410 = callmethod(bool6409, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6410 (depth = 4)
  Object if6404 = done;
  if (istrue(opresult6410)) {
// Begin line 1578
  setline(1578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6412 == NULL) {
    strlit6412 = alloc_String("<");
    gc_root(strlit6412);
  }
// compiled string node returning strlit6412 (depth = 6)
  int op_slot_right_6411 = gc_frame_newslot(strlit6412);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6411 = gc_frame_newslot(*var_s);
  params[0] = strlit6412;
  partcv[0] = 1;
  Object opresult6414 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6414 (depth = 5)
  *var_s = opresult6414;
  if (opresult6414 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1579
  setline(1579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6416 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num6419 = alloc_Float64(1);
// compiled num node returning num6419 (depth = 7)
  int op_slot_right_6418 = gc_frame_newslot(num6419);
// starting to compile member node (depth = 7)
  int callframe6421 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe6422 = gc_frame_new();
// call case 4: self request
  Object call6423 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6422);
// compiled member node returning call6423 (depth = 8)
  Object call6424 = callmethodflags(call6423, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6421);
// compiled member node returning call6424 (depth = 7)
  int op_slot_left_6418 = gc_frame_newslot(call6424);
  params[0] = num6419;
  partcv[0] = 1;
  Object diff6425 = callmethod(call6424, "-(1)", 1, partcv, params);
// compiled op node returning diff6425 (depth = 6)
  int op_slot_right_6417 = gc_frame_newslot(diff6425);
// starting to compile num node (depth = 6)
  Object num6427 = alloc_Float64(1);
// compiled num node returning num6427 (depth = 6)
  int op_slot_left_6417 = gc_frame_newslot(num6427);
  params[0] = diff6425;
  partcv[0] = 1;
  Object opresult6428 = callmethod(num6427, "..(1)", 1, partcv, params);
// compiled op node returning opresult6428 (depth = 5)
  gc_frame_newslot(opresult6428);
// starting to compile block node (depth = 5)
  Object block6429 = alloc_Block(NULL, NULL, "ast", 1579);
  gc_frame_newslot(block6429);
// method "_apply(_)"
  block_savedest(block6429);
  Object closure6430 = createclosure(3, "_apply(1)");
  setclosureframe(closure6430, stackframe);
  addtoclosure(closure6430, var_depth);
  addtoclosure(closure6430, var_s);
  addtoclosure(closure6430, selfslot);
  struct UserObject *uo6430 = (struct UserObject*)block6429;
  uo6430->data[0] = (Object)closure6430;
  Method *meth_meth_ast__apply_40_1_41_6430 = addmethod2pos(block6429, "_apply(1)", &meth_ast__apply_40_1_41_6430, 0);
  int argcv_meth_ast__apply_40_1_41_6430[] = {1};
  meth_meth_ast__apply_40_1_41_6430->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6430);
  meth_meth_ast__apply_40_1_41_6430->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6430->definitionLine = 2981;
// compiled block node returning block6429 (depth = 5)
  gc_frame_newslot(block6429);
// call case 5: prelude request
  params[0] = opresult6428;
  params[1] = block6429;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6446 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6416);
// compiled call node returning call6446 (depth = 4)
// Begin line 1582
  setline(1582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6448 == NULL) {
    strlit6448 = alloc_String(">");
    gc_root(strlit6448);
  }
// compiled string node returning strlit6448 (depth = 6)
  int op_slot_right_6447 = gc_frame_newslot(strlit6448);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6451 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6453 = alloc_Float64(1);
// compiled num node returning num6453 (depth = 9)
  int op_slot_right_6452 = gc_frame_newslot(num6453);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6452 = gc_frame_newslot(*var_depth);
  params[0] = num6453;
  partcv[0] = 1;
  Object sum6455 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6455 (depth = 8)
  gc_frame_newslot(sum6455);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe6456 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe6457 = gc_frame_new();
// call case 4: self request
  Object call6458 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6457);
// compiled member node returning call6458 (depth = 9)
  Object call6459 = callmethodflags(call6458, "last", 0, partcv, params, 0);
  gc_frame_end(callframe6456);
// compiled member node returning call6459 (depth = 8)
  params[0] = sum6455;
  partcv[0] = 1;
  Object call6460 = callmethodflags(call6459, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6451);
// compiled call node returning call6460 (depth = 7)
  int op_slot_right_6450 = gc_frame_newslot(call6460);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6450 = gc_frame_newslot(*var_s);
  params[0] = call6460;
  partcv[0] = 1;
  Object opresult6462 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6462 (depth = 6)
  int op_slot_left_6447 = gc_frame_newslot(opresult6462);
  params[0] = strlit6448;
  partcv[0] = 1;
  Object opresult6463 = callmethod(opresult6462, "++(1)", 1, partcv, params);
// compiled op node returning opresult6463 (depth = 5)
  *var_s = opresult6463;
  if (opresult6463 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6404 = done;
  } else {
  }
// compiled if node returning if6404 (depth = 3)
// Begin line 1584
  setline(1584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString6465(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1586
  setline(1586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6467 == NULL) {
    strlit6467 = alloc_String("");
    gc_root(strlit6467);
  }
// compiled string node returning strlit6467 (depth = 4)
  int op_slot_right_6466 = gc_frame_newslot(strlit6467);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6470 = gc_frame_new();
// call case 4: self request
  Object call6471 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6470);
// compiled member node returning call6471 (depth = 5)
  int op_slot_right_6469 = gc_frame_newslot(call6471);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6474 == NULL) {
    strlit6474 = alloc_String(".");
    gc_root(strlit6474);
  }
// compiled string node returning strlit6474 (depth = 6)
  int op_slot_right_6473 = gc_frame_newslot(strlit6474);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6477 = gc_frame_new();
// call case 4: self request
  Object call6478 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6477);
// compiled member node returning call6478 (depth = 7)
  int op_slot_right_6476 = gc_frame_newslot(call6478);
// starting to compile string node (depth = 7)
  if (strlit6480 == NULL) {
    strlit6480 = alloc_String("");
    gc_root(strlit6480);
  }
// compiled string node returning strlit6480 (depth = 7)
  int op_slot_left_6476 = gc_frame_newslot(strlit6480);
  params[0] = call6478;
  partcv[0] = 1;
  Object opresult6481 = callmethod(strlit6480, "++(1)", 1, partcv, params);
// compiled op node returning opresult6481 (depth = 6)
  int op_slot_left_6473 = gc_frame_newslot(opresult6481);
  params[0] = strlit6474;
  partcv[0] = 1;
  Object opresult6482 = callmethod(opresult6481, "++(1)", 1, partcv, params);
// compiled op node returning opresult6482 (depth = 5)
  int op_slot_left_6469 = gc_frame_newslot(opresult6482);
  params[0] = call6471;
  partcv[0] = 1;
  Object opresult6483 = callmethod(opresult6482, "++(1)", 1, partcv, params);
// compiled op node returning opresult6483 (depth = 4)
  int op_slot_left_6466 = gc_frame_newslot(opresult6483);
  params[0] = strlit6467;
  partcv[0] = 1;
  Object opresult6484 = callmethod(opresult6483, "++(1)", 1, partcv, params);
// compiled op node returning opresult6484 (depth = 3)
  gc_frame_end(frame);
  return opresult6484;
}
Object meth_ast_asIdentifier6485(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_resultNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "resultNode");
// Begin line 1589
  setline(1589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe6488 = gc_frame_new();
// call case 4: self request
  Object call6489 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6488);
// compiled member node returning call6489 (depth = 5)
  int op_slot_right_6487 = gc_frame_newslot(call6489);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_fakeSymbolTable (depth = 5)
  int op_slot_left_6487 = gc_frame_newslot(*var_fakeSymbolTable);
  params[0] = call6489;
  partcv[0] = 1;
  Object opresult6491 = callmethod(*var_fakeSymbolTable, "==(1)", 1, partcv, params);
// compiled op node returning opresult6491 (depth = 4)
  Object if6486 = done;
  if (istrue(opresult6491)) {
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6492 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6494 == NULL) {
    strlit6494 = alloc_String(" when scope was fake");
    gc_root(strlit6494);
  }
// compiled string node returning strlit6494 (depth = 6)
  int op_slot_right_6493 = gc_frame_newslot(strlit6494);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6497 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num6498 = alloc_Float64(0);
// compiled num node returning num6498 (depth = 8)
  gc_frame_newslot(num6498);
// call case 4: self request
  params[0] = num6498;
  partcv[0] = 1;
  Object call6499 = callmethodflags(self, "pretty(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6497);
// compiled call node returning call6499 (depth = 7)
  int op_slot_right_6496 = gc_frame_newslot(call6499);
// starting to compile string node (depth = 7)
  if (strlit6501 == NULL) {
    strlit6501 = alloc_String("asIdentifier requested on ");
    gc_root(strlit6501);
  }
// compiled string node returning strlit6501 (depth = 7)
  int op_slot_left_6496 = gc_frame_newslot(strlit6501);
  params[0] = call6499;
  partcv[0] = 1;
  Object opresult6502 = callmethod(strlit6501, "++(1)", 1, partcv, params);
// compiled op node returning opresult6502 (depth = 6)
  int op_slot_left_6493 = gc_frame_newslot(opresult6502);
  params[0] = strlit6494;
  partcv[0] = 1;
  Object opresult6503 = callmethod(opresult6502, "++(1)", 1, partcv, params);
// compiled op node returning opresult6503 (depth = 5)
  gc_frame_newslot(opresult6503);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6504 = gc_frame_new();
// call case 5: prelude request
  Object call6505 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6504);
// compiled member node returning call6505 (depth = 5)
  params[0] = opresult6503;
  partcv[0] = 1;
  Object call6506 = callmethodflags(call6505, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6492);
// compiled call node returning call6506 (depth = 4)
    gc_frame_newslot(call6506);
    if6486 = call6506;
  } else {
  }
// compiled if node returning if6486 (depth = 3)
// Begin line 1592
  setline(1592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6507 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6508 = gc_frame_new();
// call case 4: self request
  Object call6509 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6508);
// compiled member node returning call6509 (depth = 5)
  gc_frame_newslot(call6509);
// starting to compile identifier node (depth = 5)
  Object bool6510 = alloc_Boolean(0);
// compiled identifier node returning bool6510 (depth = 5)
  gc_frame_newslot(bool6510);
// starting to compile member node (depth = 5)
  int callframe6511 = gc_frame_new();
// call case 4: self request
  Object call6512 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6511);
// compiled member node returning call6512 (depth = 5)
  gc_frame_newslot(call6512);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call6509;
  params[1] = bool6510;
  params[2] = call6512;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6513 = callmethodflags(*var_identifierNode, "new(2)scope(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6507);
// compiled call node returning call6513 (depth = 4)
  *var_resultNode = call6513;
  if (call6513 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6514 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool6515 = alloc_Boolean(1);
// compiled identifier node returning bool6515 (depth = 4)
  gc_frame_newslot(bool6515);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = bool6515;
  partcv[0] = 1;
  Object call6516 = callmethodflags(*var_resultNode, "inRequest:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6514);
// compiled call node returning call6516 (depth = 3)
// Begin line 1594
  setline(1594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6517 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6518 = gc_frame_new();
// call case 4: self request
  Object call6519 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6518);
// compiled member node returning call6519 (depth = 4)
  gc_frame_newslot(call6519);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call6519;
  partcv[0] = 1;
  Object call6520 = callmethodflags(*var_resultNode, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6517);
// compiled call node returning call6520 (depth = 3)
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6521 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6522 = gc_frame_new();
// call case 4: self request
  Object call6523 = callmethodflags(self, "linePos", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6522);
// compiled member node returning call6523 (depth = 4)
  gc_frame_newslot(call6523);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call6523;
  partcv[0] = 1;
  Object call6524 = callmethodflags(*var_resultNode, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6521);
// compiled call node returning call6524 (depth = 3)
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  return *var_resultNode;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_shallowCopy6525(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_memberNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1599
  setline(1599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6526 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6527 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6528 = gc_frame_new();
// call case 4: self request
  Object call6529 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6528);
// compiled member node returning call6529 (depth = 5)
  gc_frame_newslot(call6529);
// starting to compile member node (depth = 5)
  int callframe6530 = gc_frame_new();
// call case 4: self request
  Object call6531 = callmethodflags(self, "receiver", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6530);
// compiled member node returning call6531 (depth = 5)
  gc_frame_newslot(call6531);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_memberNode (depth = 5)
  params[0] = call6529;
  params[1] = call6531;
  partcv[0] = 2;
  Object call6532 = callmethodflags(*var_memberNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6527);
// compiled call node returning call6532 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6533 = callmethodflags(call6532, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6526);
// compiled call node returning call6533 (depth = 3)
  gc_frame_end(frame);
  return call6533;
}
Object meth_ast_statementName6534(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1601
  setline(1601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6535 == NULL) {
    strlit6535 = alloc_String("expression");
    gc_root(strlit6535);
  }
// compiled string node returning strlit6535 (depth = 3)
  gc_frame_end(frame);
  return strlit6535;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_6536(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1603
  setline(1603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6537 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call6538 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6537);
// compiled call node returning call6538 (depth = 3)
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6539 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6540 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call6541 = callmethodflags(*var_other, "generics", 0, partcv, params, 0);
  gc_frame_end(callframe6540);
// compiled member node returning call6541 (depth = 4)
  gc_frame_newslot(call6541);
// call case 4: self request
  params[0] = call6541;
  partcv[0] = 1;
  Object call6542 = callmethodflags(self, "generics:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6539);
// compiled call node returning call6542 (depth = 3)
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6543 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe6544 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call6545 = callmethodflags(*var_other, "isSelfRequest", 0, partcv, params, 0);
  gc_frame_end(callframe6544);
// compiled member node returning call6545 (depth = 4)
  gc_frame_newslot(call6545);
// call case 4: self request
  params[0] = call6545;
  partcv[0] = 1;
  Object call6546 = callmethodflags(self, "isSelfRequest:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6543);
// compiled call node returning call6546 (depth = 3)
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new_40_2_41_6171(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_fakeSymbolTable = getfromclosure(closure, 1);
  Object *var_identifierNode = getfromclosure(closure, 2);
  Object *var_memberNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_request = &(stackframe->slots[0]);
  *var_request = args[curarg];
  curarg++;
  Object *var_receiver_39_ = &(stackframe->slots[1]);
  *var_receiver_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6172 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6172 = alloc_userobj2(27,24, objclass6172);
  gc_frame_newslot(obj6172);
if (objclass6172 == NULL) {
  glfree(obj6172->class->name);
  obj6172->class->name = "memberNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6172, self, 0);
  addmethodreal(obj6172,"outer", &reader_ast_outer_6173);
  Object oldself6172 = self;
  struct StackFrameObject *oldstackframe6172 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6172);
  gc_frame_newslot((Object)stackframe);
  self = obj6172;
  Object *oldselfslot6172 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6172 = (*(struct UserObject *)self).data[0], lowerouter6172 = thisouter6172;
  if (inheritingObject6172) {
    struct UserObject *inho6172 = (struct UserObject *)inheritingObject6172;
    while (inho6172->super != GraceDefaultObject) inho6172 = (struct UserObject *)inho6172->super;
    inho6172->super = obj6172;
    self = inheritingObject6172;
    *selfslot = self;
    lowerouter6172 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6172;
  }
if (objclass6172 == NULL) {
  Method *reader6174 = addmethodrealflags(obj6172, "kind",&reader_ast_kind_6174, MFLAG_DEF);
  reader6174->definitionModule = modulename;
  reader6174->definitionLine = 1514;
}
adddatum2(obj6172, alloc_Undefined(), 1);
if (objclass6172 == NULL) {
  Method *reader6175 = addmethodrealflags(obj6172, "value", &reader_ast_value_6175, 0);
  Method *writer6175 = addmethodrealflags(obj6172, "value:=(1)", &writer_ast_value_6175, 0);
  reader6175->definitionModule = modulename;
  writer6175->definitionModule = modulename;
  reader6175->definitionLine = 1515;
  writer6175->definitionLine = 1515;
}
obj6172->flags |= OFLAG_MUTABLE;
adddatum2(obj6172, alloc_Undefined(), 2);
if (objclass6172 == NULL) {
  Method *reader6176 = addmethodrealflags(obj6172, "receiver", &reader_ast_receiver_6176, 0);
  Method *writer6176 = addmethodrealflags(obj6172, "receiver:=(1)", &writer_ast_receiver_6176, 0);
  reader6176->definitionModule = modulename;
  writer6176->definitionModule = modulename;
  reader6176->definitionLine = 1516;
  writer6176->definitionLine = 1516;
}
obj6172->flags |= OFLAG_MUTABLE;
adddatum2(obj6172, alloc_Undefined(), 3);
if (objclass6172 == NULL) {
  Method *reader6177 = addmethodrealflags(obj6172, "generics", &reader_ast_generics_6177, 0);
  Method *writer6177 = addmethodrealflags(obj6172, "generics:=(1)", &writer_ast_generics_6177, 0);
  reader6177->definitionModule = modulename;
  writer6177->definitionModule = modulename;
  reader6177->definitionLine = 1517;
  writer6177->definitionLine = 1517;
}
obj6172->flags |= OFLAG_MUTABLE;
adddatum2(obj6172, alloc_Undefined(), 4);
if (objclass6172 == NULL) {
  Method *reader6178 = addmethodrealflags(obj6172, "isSelfRequest", &reader_ast_isSelfRequest_6178, 0);
  Method *writer6178 = addmethodrealflags(obj6172, "isSelfRequest:=(1)", &writer_ast_isSelfRequest_6178, 0);
  reader6178->definitionModule = modulename;
  writer6178->definitionModule = modulename;
  reader6178->definitionLine = 1518;
  writer6178->definitionLine = 1518;
}
obj6172->flags |= OFLAG_MUTABLE;
adddatum2(obj6172, alloc_Undefined(), 5);
// method "onSelf"
  struct UserObject *uo6179 = (struct UserObject*)obj6172;
  uo6179->data[6] = emptyclosure;
  Method *meth_meth_ast_onSelf6179 = addmethod2pos(obj6172, "onSelf", &meth_ast_onSelf6179, 6);
  int argcv_meth_ast_onSelf6179[] = {0};
  meth_meth_ast_onSelf6179->type = alloc_MethodType(1, argcv_meth_ast_onSelf6179);
  meth_meth_ast_onSelf6179->definitionModule = modulename;
  meth_meth_ast_onSelf6179->definitionLine = 1520;
// method "nameString"
  struct UserObject *uo6183 = (struct UserObject*)obj6172;
  uo6183->data[7] = emptyclosure;
  Method *meth_meth_ast_nameString6183 = addmethod2pos(obj6172, "nameString", &meth_ast_nameString6183, 7);
  int argcv_meth_ast_nameString6183[] = {0};
  meth_meth_ast_nameString6183->type = alloc_MethodType(1, argcv_meth_ast_nameString6183);
  meth_meth_ast_nameString6183->definitionModule = modulename;
  meth_meth_ast_nameString6183->definitionLine = 1524;
// method "canonicalName"
  struct UserObject *uo6186 = (struct UserObject*)obj6172;
  uo6186->data[8] = emptyclosure;
  Method *meth_meth_ast_canonicalName6186 = addmethod2pos(obj6172, "canonicalName", &meth_ast_canonicalName6186, 8);
  int argcv_meth_ast_canonicalName6186[] = {0};
  meth_meth_ast_canonicalName6186->type = alloc_MethodType(1, argcv_meth_ast_canonicalName6186);
  meth_meth_ast_canonicalName6186->definitionModule = modulename;
  meth_meth_ast_canonicalName6186->definitionLine = 1525;
// method "isMember"
  struct UserObject *uo6189 = (struct UserObject*)obj6172;
  uo6189->data[9] = emptyclosure;
  Method *meth_meth_ast_isMember6189 = addmethod2pos(obj6172, "isMember", &meth_ast_isMember6189, 9);
  int argcv_meth_ast_isMember6189[] = {0};
  meth_meth_ast_isMember6189->type = alloc_MethodType(1, argcv_meth_ast_isMember6189);
  meth_meth_ast_isMember6189->definitionModule = modulename;
  meth_meth_ast_isMember6189->definitionLine = 1526;
// method "isCall"
  struct UserObject *uo6191 = (struct UserObject*)obj6172;
  uo6191->data[10] = emptyclosure;
  Method *meth_meth_ast_isCall6191 = addmethod2pos(obj6172, "isCall", &meth_ast_isCall6191, 10);
  int argcv_meth_ast_isCall6191[] = {0};
  meth_meth_ast_isCall6191->type = alloc_MethodType(1, argcv_meth_ast_isCall6191);
  meth_meth_ast_isCall6191->definitionModule = modulename;
  meth_meth_ast_isCall6191->definitionLine = 1527;
// method "with"
  block_savedest(obj6172);
  Object closure6193 = createclosure(1, "with");
  setclosureframe(closure6193, stackframe);
  addtoclosure(closure6193, var_emptySeq);
  struct UserObject *uo6193 = (struct UserObject*)obj6172;
  uo6193->data[11] = (Object)closure6193;
  Method *meth_meth_ast_with6193 = addmethod2pos(obj6172, "with", &meth_ast_with6193, 11);
  int argcv_meth_ast_with6193[] = {0};
  meth_meth_ast_with6193->type = alloc_MethodType(1, argcv_meth_ast_with6193);
  meth_meth_ast_with6193->definitionModule = modulename;
  meth_meth_ast_with6193->definitionLine = 1529;
// method "arguments"
  block_savedest(obj6172);
  Object closure6194 = createclosure(1, "arguments");
  setclosureframe(closure6194, stackframe);
  addtoclosure(closure6194, var_emptySeq);
  struct UserObject *uo6194 = (struct UserObject*)obj6172;
  uo6194->data[12] = (Object)closure6194;
  Method *meth_meth_ast_arguments6194 = addmethod2pos(obj6172, "arguments", &meth_ast_arguments6194, 12);
  int argcv_meth_ast_arguments6194[] = {0};
  meth_meth_ast_arguments6194->type = alloc_MethodType(1, argcv_meth_ast_arguments6194);
  meth_meth_ast_arguments6194->definitionModule = modulename;
  meth_meth_ast_arguments6194->definitionLine = 1530;
// method "argumentsDo"
  struct UserObject *uo6195 = (struct UserObject*)obj6172;
  uo6195->data[13] = emptyclosure;
  Method *meth_meth_ast_argumentsDo6195 = addmethod2pos(obj6172, "argumentsDo", &meth_ast_argumentsDo6195, 13);
  int argcv_meth_ast_argumentsDo6195[] = {0};
  meth_meth_ast_argumentsDo6195->type = alloc_MethodType(1, argcv_meth_ast_argumentsDo6195);
  meth_meth_ast_argumentsDo6195->definitionModule = modulename;
  meth_meth_ast_argumentsDo6195->definitionLine = 1531;
// method "accept(_)from(_)"
  struct UserObject *uo6196 = (struct UserObject*)obj6172;
  uo6196->data[14] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6196 = addmethod2pos(obj6172, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6196, 14);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6196[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6196->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6196);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6196->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6196->definitionLine = 1532;
// method "isSelfOrOuter"
  struct UserObject *uo6222 = (struct UserObject*)obj6172;
  uo6222->data[15] = emptyclosure;
  Method *meth_meth_ast_isSelfOrOuter6222 = addmethod2pos(obj6172, "isSelfOrOuter", &meth_ast_isSelfOrOuter6222, 15);
  int argcv_meth_ast_isSelfOrOuter6222[] = {0};
  meth_meth_ast_isSelfOrOuter6222->type = alloc_MethodType(1, argcv_meth_ast_isSelfOrOuter6222);
  meth_meth_ast_isSelfOrOuter6222->definitionModule = modulename;
  meth_meth_ast_isSelfOrOuter6222->definitionLine = 1541;
// method "map(_)ancestors(_)"
  struct UserObject *uo6235 = (struct UserObject*)obj6172;
  uo6235->data[16] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6235 = addmethod2pos(obj6172, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6235, 16);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6235[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6235->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6235);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6235->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6235->definitionLine = 1545;
// method "pretty(_)"
  struct UserObject *uo6258 = (struct UserObject*)obj6172;
  uo6258->data[17] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_6258 = addmethod2pos(obj6172, "pretty(1)", &meth_ast_pretty_40_1_41_6258, 17);
  int argcv_meth_ast_pretty_40_1_41_6258[] = {1};
  meth_meth_ast_pretty_40_1_41_6258->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_6258);
  meth_meth_ast_pretty_40_1_41_6258->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_6258->definitionLine = 1552;
// method "toGrace(_)"
  struct UserObject *uo6354 = (struct UserObject*)obj6172;
  uo6354->data[18] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_6354 = addmethod2pos(obj6172, "toGrace(1)", &meth_ast_toGrace_40_1_41_6354, 18);
  int argcv_meth_ast_toGrace_40_1_41_6354[] = {1};
  meth_meth_ast_toGrace_40_1_41_6354->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_6354);
meth_meth_ast_toGrace_40_1_41_6354->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_6354->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_6354->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_6354->definitionLine = 1569;
// method "asString"
  struct UserObject *uo6465 = (struct UserObject*)obj6172;
  uo6465->data[19] = emptyclosure;
  Method *meth_meth_ast_asString6465 = addmethod2pos(obj6172, "asString", &meth_ast_asString6465, 19);
  int argcv_meth_ast_asString6465[] = {0};
  meth_meth_ast_asString6465->type = alloc_MethodType(1, argcv_meth_ast_asString6465);
  meth_meth_ast_asString6465->definitionModule = modulename;
  meth_meth_ast_asString6465->definitionLine = 1586;
// method "asIdentifier"
  block_savedest(obj6172);
  Object closure6485 = createclosure(2, "asIdentifier");
  setclosureframe(closure6485, stackframe);
  addtoclosure(closure6485, var_fakeSymbolTable);
  addtoclosure(closure6485, var_identifierNode);
  struct UserObject *uo6485 = (struct UserObject*)obj6172;
  uo6485->data[20] = (Object)closure6485;
  Method *meth_meth_ast_asIdentifier6485 = addmethod2pos(obj6172, "asIdentifier", &meth_ast_asIdentifier6485, 20);
  int argcv_meth_ast_asIdentifier6485[] = {0};
  meth_meth_ast_asIdentifier6485->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier6485);
  meth_meth_ast_asIdentifier6485->definitionModule = modulename;
  meth_meth_ast_asIdentifier6485->definitionLine = 1587;
// method "shallowCopy"
  block_savedest(obj6172);
  Object closure6525 = createclosure(1, "shallowCopy");
  setclosureframe(closure6525, stackframe);
  addtoclosure(closure6525, var_memberNode);
  struct UserObject *uo6525 = (struct UserObject*)obj6172;
  uo6525->data[21] = (Object)closure6525;
  Method *meth_meth_ast_shallowCopy6525 = addmethod2pos(obj6172, "shallowCopy", &meth_ast_shallowCopy6525, 21);
  int argcv_meth_ast_shallowCopy6525[] = {0};
  meth_meth_ast_shallowCopy6525->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6525);
  meth_meth_ast_shallowCopy6525->definitionModule = modulename;
  meth_meth_ast_shallowCopy6525->definitionLine = 1598;
// method "statementName"
  struct UserObject *uo6534 = (struct UserObject*)obj6172;
  uo6534->data[22] = emptyclosure;
  Method *meth_meth_ast_statementName6534 = addmethod2pos(obj6172, "statementName", &meth_ast_statementName6534, 22);
  int argcv_meth_ast_statementName6534[] = {0};
  meth_meth_ast_statementName6534->type = alloc_MethodType(1, argcv_meth_ast_statementName6534);
  meth_meth_ast_statementName6534->definitionModule = modulename;
  meth_meth_ast_statementName6534->definitionLine = 1601;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo6536 = (struct UserObject*)obj6172;
  uo6536->data[23] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_6536 = addmethod2pos(obj6172, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_6536, 23);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_6536[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_6536->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_6536);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_6536->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_6536->definitionLine = 1602;
  sourceObject = obj6172;
// Begin line 1513
  setline(1513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6547 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6548 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6549 = gc_frame_new();
// call case 3: self.outer request
  Object call6550 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6549);
// compiled member node returning call6550 (depth = 5)
  Object call6551 = callmethodflags(call6550, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6548);
// compiled member node returning call6551 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6552 = callmethodflags(call6551, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6547);
// compiled call node returning call6552 (depth = 3)
  struct UserObject *obj6172_uo = (struct UserObject *)obj6172;
  obj6172_uo->super = call6552;
  sourceObject = obj6172;
// Begin line 1514
  setline(1514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6553 == NULL) {
    strlit6553 = alloc_String("member");
    gc_root(strlit6553);
  }
// compiled string node returning strlit6553 (depth = 3)
  adddatum2(obj6172, strlit6553, 1);
  sourceObject = obj6172;
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_request (depth = 3)
  adddatum2(obj6172, *var_request, 2);
  sourceObject = obj6172;
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_receiver_39_ (depth = 3)
  adddatum2(obj6172, *var_receiver_39_, 3);
  sourceObject = obj6172;
// Begin line 1517
  setline(1517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6554 = alloc_Boolean(0);
// compiled identifier node returning bool6554 (depth = 3)
  adddatum2(obj6172, bool6554, 4);
  sourceObject = obj6172;
// Begin line 1518
  setline(1518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6555 = alloc_Boolean(0);
// compiled identifier node returning bool6555 (depth = 3)
  adddatum2(obj6172, bool6555, 5);
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  objclass6172 = obj6172->class;
  objclass6172->definitionModule = modulename;
  objclass6172->definitionLine = 1511;
  (*(struct UserObject *)self).data[0] = lowerouter6172;
  self = oldself6172;
  selfslot = oldselfslot6172;
  stackframe = oldstackframe6172;
  gc_frame_end(frame);
  return obj6172;
}
Object meth_ast_new_40_2_41_6171_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_fakeSymbolTable = getfromclosure(closure, 1);
  Object *var_identifierNode = getfromclosure(closure, 2);
  Object *var_memberNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_request = &(stackframe->slots[0]);
  *var_request = args[curarg];
  curarg++;
  Object *var_receiver_39_ = &(stackframe->slots[1]);
  *var_receiver_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6172 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6172 = alloc_userobj2(27,24, objclass6172);
  gc_frame_newslot(obj6172);
if (objclass6172 == NULL) {
  glfree(obj6172->class->name);
  obj6172->class->name = "memberNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6172, self, 0);
  addmethodreal(obj6172,"outer", &reader_ast_outer_6173);
  Object oldself6172 = self;
  struct StackFrameObject *oldstackframe6172 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6172);
  gc_frame_newslot((Object)stackframe);
  self = obj6172;
  Object *oldselfslot6172 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6172 = (*(struct UserObject *)self).data[0], lowerouter6172 = thisouter6172;
  if (inheritingObject6172) {
    struct UserObject *inho6172 = (struct UserObject *)inheritingObject6172;
    while (inho6172->super != GraceDefaultObject) inho6172 = (struct UserObject *)inho6172->super;
    inho6172->super = obj6172;
    self = inheritingObject6172;
    *selfslot = self;
    lowerouter6172 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6172;
  }
if (objclass6172 == NULL) {
  Method *reader6174 = addmethodrealflags(obj6172, "kind",&reader_ast_kind_6174, MFLAG_DEF);
  reader6174->definitionModule = modulename;
  reader6174->definitionLine = 1514;
}
adddatum2(obj6172, alloc_Undefined(), 1);
if (objclass6172 == NULL) {
  Method *reader6175 = addmethodrealflags(obj6172, "value", &reader_ast_value_6175, 0);
  Method *writer6175 = addmethodrealflags(obj6172, "value:=(1)", &writer_ast_value_6175, 0);
  reader6175->definitionModule = modulename;
  writer6175->definitionModule = modulename;
  reader6175->definitionLine = 1515;
  writer6175->definitionLine = 1515;
}
obj6172->flags |= OFLAG_MUTABLE;
adddatum2(obj6172, alloc_Undefined(), 2);
if (objclass6172 == NULL) {
  Method *reader6176 = addmethodrealflags(obj6172, "receiver", &reader_ast_receiver_6176, 0);
  Method *writer6176 = addmethodrealflags(obj6172, "receiver:=(1)", &writer_ast_receiver_6176, 0);
  reader6176->definitionModule = modulename;
  writer6176->definitionModule = modulename;
  reader6176->definitionLine = 1516;
  writer6176->definitionLine = 1516;
}
obj6172->flags |= OFLAG_MUTABLE;
adddatum2(obj6172, alloc_Undefined(), 3);
if (objclass6172 == NULL) {
  Method *reader6177 = addmethodrealflags(obj6172, "generics", &reader_ast_generics_6177, 0);
  Method *writer6177 = addmethodrealflags(obj6172, "generics:=(1)", &writer_ast_generics_6177, 0);
  reader6177->definitionModule = modulename;
  writer6177->definitionModule = modulename;
  reader6177->definitionLine = 1517;
  writer6177->definitionLine = 1517;
}
obj6172->flags |= OFLAG_MUTABLE;
adddatum2(obj6172, alloc_Undefined(), 4);
if (objclass6172 == NULL) {
  Method *reader6178 = addmethodrealflags(obj6172, "isSelfRequest", &reader_ast_isSelfRequest_6178, 0);
  Method *writer6178 = addmethodrealflags(obj6172, "isSelfRequest:=(1)", &writer_ast_isSelfRequest_6178, 0);
  reader6178->definitionModule = modulename;
  writer6178->definitionModule = modulename;
  reader6178->definitionLine = 1518;
  writer6178->definitionLine = 1518;
}
obj6172->flags |= OFLAG_MUTABLE;
adddatum2(obj6172, alloc_Undefined(), 5);
// method "onSelf"
  struct UserObject *uo6179 = (struct UserObject*)obj6172;
  uo6179->data[6] = emptyclosure;
  Method *meth_meth_ast_onSelf6179 = addmethod2pos(obj6172, "onSelf", &meth_ast_onSelf6179, 6);
  int argcv_meth_ast_onSelf6179[] = {0};
  meth_meth_ast_onSelf6179->type = alloc_MethodType(1, argcv_meth_ast_onSelf6179);
  meth_meth_ast_onSelf6179->definitionModule = modulename;
  meth_meth_ast_onSelf6179->definitionLine = 1520;
// method "nameString"
  struct UserObject *uo6183 = (struct UserObject*)obj6172;
  uo6183->data[7] = emptyclosure;
  Method *meth_meth_ast_nameString6183 = addmethod2pos(obj6172, "nameString", &meth_ast_nameString6183, 7);
  int argcv_meth_ast_nameString6183[] = {0};
  meth_meth_ast_nameString6183->type = alloc_MethodType(1, argcv_meth_ast_nameString6183);
  meth_meth_ast_nameString6183->definitionModule = modulename;
  meth_meth_ast_nameString6183->definitionLine = 1524;
// method "canonicalName"
  struct UserObject *uo6186 = (struct UserObject*)obj6172;
  uo6186->data[8] = emptyclosure;
  Method *meth_meth_ast_canonicalName6186 = addmethod2pos(obj6172, "canonicalName", &meth_ast_canonicalName6186, 8);
  int argcv_meth_ast_canonicalName6186[] = {0};
  meth_meth_ast_canonicalName6186->type = alloc_MethodType(1, argcv_meth_ast_canonicalName6186);
  meth_meth_ast_canonicalName6186->definitionModule = modulename;
  meth_meth_ast_canonicalName6186->definitionLine = 1525;
// method "isMember"
  struct UserObject *uo6189 = (struct UserObject*)obj6172;
  uo6189->data[9] = emptyclosure;
  Method *meth_meth_ast_isMember6189 = addmethod2pos(obj6172, "isMember", &meth_ast_isMember6189, 9);
  int argcv_meth_ast_isMember6189[] = {0};
  meth_meth_ast_isMember6189->type = alloc_MethodType(1, argcv_meth_ast_isMember6189);
  meth_meth_ast_isMember6189->definitionModule = modulename;
  meth_meth_ast_isMember6189->definitionLine = 1526;
// method "isCall"
  struct UserObject *uo6191 = (struct UserObject*)obj6172;
  uo6191->data[10] = emptyclosure;
  Method *meth_meth_ast_isCall6191 = addmethod2pos(obj6172, "isCall", &meth_ast_isCall6191, 10);
  int argcv_meth_ast_isCall6191[] = {0};
  meth_meth_ast_isCall6191->type = alloc_MethodType(1, argcv_meth_ast_isCall6191);
  meth_meth_ast_isCall6191->definitionModule = modulename;
  meth_meth_ast_isCall6191->definitionLine = 1527;
// method "with"
  block_savedest(obj6172);
  Object closure6193 = createclosure(1, "with");
  setclosureframe(closure6193, stackframe);
  addtoclosure(closure6193, var_emptySeq);
  struct UserObject *uo6193 = (struct UserObject*)obj6172;
  uo6193->data[11] = (Object)closure6193;
  Method *meth_meth_ast_with6193 = addmethod2pos(obj6172, "with", &meth_ast_with6193, 11);
  int argcv_meth_ast_with6193[] = {0};
  meth_meth_ast_with6193->type = alloc_MethodType(1, argcv_meth_ast_with6193);
  meth_meth_ast_with6193->definitionModule = modulename;
  meth_meth_ast_with6193->definitionLine = 1529;
// method "arguments"
  block_savedest(obj6172);
  Object closure6194 = createclosure(1, "arguments");
  setclosureframe(closure6194, stackframe);
  addtoclosure(closure6194, var_emptySeq);
  struct UserObject *uo6194 = (struct UserObject*)obj6172;
  uo6194->data[12] = (Object)closure6194;
  Method *meth_meth_ast_arguments6194 = addmethod2pos(obj6172, "arguments", &meth_ast_arguments6194, 12);
  int argcv_meth_ast_arguments6194[] = {0};
  meth_meth_ast_arguments6194->type = alloc_MethodType(1, argcv_meth_ast_arguments6194);
  meth_meth_ast_arguments6194->definitionModule = modulename;
  meth_meth_ast_arguments6194->definitionLine = 1530;
// method "argumentsDo"
  struct UserObject *uo6195 = (struct UserObject*)obj6172;
  uo6195->data[13] = emptyclosure;
  Method *meth_meth_ast_argumentsDo6195 = addmethod2pos(obj6172, "argumentsDo", &meth_ast_argumentsDo6195, 13);
  int argcv_meth_ast_argumentsDo6195[] = {0};
  meth_meth_ast_argumentsDo6195->type = alloc_MethodType(1, argcv_meth_ast_argumentsDo6195);
  meth_meth_ast_argumentsDo6195->definitionModule = modulename;
  meth_meth_ast_argumentsDo6195->definitionLine = 1531;
// method "accept(_)from(_)"
  struct UserObject *uo6196 = (struct UserObject*)obj6172;
  uo6196->data[14] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6196 = addmethod2pos(obj6172, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6196, 14);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6196[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6196->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6196);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6196->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6196->definitionLine = 1532;
// method "isSelfOrOuter"
  struct UserObject *uo6222 = (struct UserObject*)obj6172;
  uo6222->data[15] = emptyclosure;
  Method *meth_meth_ast_isSelfOrOuter6222 = addmethod2pos(obj6172, "isSelfOrOuter", &meth_ast_isSelfOrOuter6222, 15);
  int argcv_meth_ast_isSelfOrOuter6222[] = {0};
  meth_meth_ast_isSelfOrOuter6222->type = alloc_MethodType(1, argcv_meth_ast_isSelfOrOuter6222);
  meth_meth_ast_isSelfOrOuter6222->definitionModule = modulename;
  meth_meth_ast_isSelfOrOuter6222->definitionLine = 1541;
// method "map(_)ancestors(_)"
  struct UserObject *uo6235 = (struct UserObject*)obj6172;
  uo6235->data[16] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6235 = addmethod2pos(obj6172, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6235, 16);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6235[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6235->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6235);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6235->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6235->definitionLine = 1545;
// method "pretty(_)"
  struct UserObject *uo6258 = (struct UserObject*)obj6172;
  uo6258->data[17] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_6258 = addmethod2pos(obj6172, "pretty(1)", &meth_ast_pretty_40_1_41_6258, 17);
  int argcv_meth_ast_pretty_40_1_41_6258[] = {1};
  meth_meth_ast_pretty_40_1_41_6258->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_6258);
  meth_meth_ast_pretty_40_1_41_6258->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_6258->definitionLine = 1552;
// method "toGrace(_)"
  struct UserObject *uo6354 = (struct UserObject*)obj6172;
  uo6354->data[18] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_6354 = addmethod2pos(obj6172, "toGrace(1)", &meth_ast_toGrace_40_1_41_6354, 18);
  int argcv_meth_ast_toGrace_40_1_41_6354[] = {1};
  meth_meth_ast_toGrace_40_1_41_6354->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_6354);
meth_meth_ast_toGrace_40_1_41_6354->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_6354->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_6354->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_6354->definitionLine = 1569;
// method "asString"
  struct UserObject *uo6465 = (struct UserObject*)obj6172;
  uo6465->data[19] = emptyclosure;
  Method *meth_meth_ast_asString6465 = addmethod2pos(obj6172, "asString", &meth_ast_asString6465, 19);
  int argcv_meth_ast_asString6465[] = {0};
  meth_meth_ast_asString6465->type = alloc_MethodType(1, argcv_meth_ast_asString6465);
  meth_meth_ast_asString6465->definitionModule = modulename;
  meth_meth_ast_asString6465->definitionLine = 1586;
// method "asIdentifier"
  block_savedest(obj6172);
  Object closure6485 = createclosure(2, "asIdentifier");
  setclosureframe(closure6485, stackframe);
  addtoclosure(closure6485, var_fakeSymbolTable);
  addtoclosure(closure6485, var_identifierNode);
  struct UserObject *uo6485 = (struct UserObject*)obj6172;
  uo6485->data[20] = (Object)closure6485;
  Method *meth_meth_ast_asIdentifier6485 = addmethod2pos(obj6172, "asIdentifier", &meth_ast_asIdentifier6485, 20);
  int argcv_meth_ast_asIdentifier6485[] = {0};
  meth_meth_ast_asIdentifier6485->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier6485);
  meth_meth_ast_asIdentifier6485->definitionModule = modulename;
  meth_meth_ast_asIdentifier6485->definitionLine = 1587;
// method "shallowCopy"
  block_savedest(obj6172);
  Object closure6525 = createclosure(1, "shallowCopy");
  setclosureframe(closure6525, stackframe);
  addtoclosure(closure6525, var_memberNode);
  struct UserObject *uo6525 = (struct UserObject*)obj6172;
  uo6525->data[21] = (Object)closure6525;
  Method *meth_meth_ast_shallowCopy6525 = addmethod2pos(obj6172, "shallowCopy", &meth_ast_shallowCopy6525, 21);
  int argcv_meth_ast_shallowCopy6525[] = {0};
  meth_meth_ast_shallowCopy6525->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6525);
  meth_meth_ast_shallowCopy6525->definitionModule = modulename;
  meth_meth_ast_shallowCopy6525->definitionLine = 1598;
// method "statementName"
  struct UserObject *uo6534 = (struct UserObject*)obj6172;
  uo6534->data[22] = emptyclosure;
  Method *meth_meth_ast_statementName6534 = addmethod2pos(obj6172, "statementName", &meth_ast_statementName6534, 22);
  int argcv_meth_ast_statementName6534[] = {0};
  meth_meth_ast_statementName6534->type = alloc_MethodType(1, argcv_meth_ast_statementName6534);
  meth_meth_ast_statementName6534->definitionModule = modulename;
  meth_meth_ast_statementName6534->definitionLine = 1601;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo6536 = (struct UserObject*)obj6172;
  uo6536->data[23] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_6536 = addmethod2pos(obj6172, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_6536, 23);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_6536[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_6536->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_6536);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_6536->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_6536->definitionLine = 1602;
  sourceObject = obj6172;
// Begin line 1513
  setline(1513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6547 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6548 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6549 = gc_frame_new();
// call case 3: self.outer request
  Object call6550 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6549);
// compiled member node returning call6550 (depth = 5)
  Object call6551 = callmethodflags(call6550, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6548);
// compiled member node returning call6551 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6552 = callmethodflags(call6551, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6547);
// compiled call node returning call6552 (depth = 3)
  struct UserObject *obj6172_uo = (struct UserObject *)obj6172;
  obj6172_uo->super = call6552;
  sourceObject = obj6172;
// Begin line 1514
  setline(1514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6553 == NULL) {
    strlit6553 = alloc_String("member");
    gc_root(strlit6553);
  }
// compiled string node returning strlit6553 (depth = 3)
  adddatum2(obj6172, strlit6553, 1);
  sourceObject = obj6172;
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_request (depth = 3)
  adddatum2(obj6172, *var_request, 2);
  sourceObject = obj6172;
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_receiver_39_ (depth = 3)
  adddatum2(obj6172, *var_receiver_39_, 3);
  sourceObject = obj6172;
// Begin line 1517
  setline(1517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6554 = alloc_Boolean(0);
// compiled identifier node returning bool6554 (depth = 3)
  adddatum2(obj6172, bool6554, 4);
  sourceObject = obj6172;
// Begin line 1518
  setline(1518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6555 = alloc_Boolean(0);
// compiled identifier node returning bool6555 (depth = 3)
  adddatum2(obj6172, bool6555, 5);
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  sourceObject = obj6172;
  objclass6172 = obj6172->class;
  objclass6172->definitionModule = modulename;
  objclass6172->definitionLine = 1511;
  (*(struct UserObject *)self).data[0] = lowerouter6172;
  self = oldself6172;
  selfslot = oldselfslot6172;
  stackframe = oldstackframe6172;
  gc_frame_end(frame);
  return obj6172;
}
Object meth_ast_memberNode6557(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "memberNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_memberNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1504
  setline(1504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_memberNode (depth = 3)
  gc_frame_end(frame);
  return *var_memberNode;
}
Object meth_ast_nameString6566(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1619
  setline(1619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6567 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6568 = gc_frame_new();
// call case 4: self request
  Object call6569 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6568);
// compiled member node returning call6569 (depth = 4)
  Object call6570 = callmethodflags(call6569, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe6567);
// compiled member node returning call6570 (depth = 3)
  gc_frame_end(frame);
  return call6570;
}
Object meth_ast_asString6571(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1620
  setline(1620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6572 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num6573 = alloc_Float64(0);
// compiled num node returning num6573 (depth = 4)
  gc_frame_newslot(num6573);
// call case 4: self request
  params[0] = num6573;
  partcv[0] = 1;
  Object call6574 = callmethodflags(self, "toGrace(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6572);
// compiled call node returning call6574 (depth = 3)
  gc_frame_end(frame);
  return call6574;
}
Object meth_ast__apply_40_1_41_6589(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6590 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6591 = callmethodflags(*var_p, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6590);
// compiled call node returning call6591 (depth = 6)
  gc_frame_end(frame);
  return call6591;
}
Object meth_ast_accept_40_1_41_from_40_1_41_6575(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1622
  setline(1622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6577 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6578 = callmethodflags(*var_visitor, "visitGeneric(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6577);
// compiled call node returning call6578 (depth = 4)
  Object if6576 = done;
  if (istrue(call6578)) {
// Begin line 1623
  setline(1623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6579 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6580 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6579);
// compiled call node returning call6580 (depth = 5)
  *var_newChain = call6580;
  if (call6580 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1624
  setline(1624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6581 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6582 = gc_frame_new();
// call case 4: self request
  Object call6583 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6582);
// compiled member node returning call6583 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6584 = callmethodflags(call6583, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6581);
// compiled call node returning call6584 (depth = 4)
// Begin line 1625
  setline(1625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6585 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6586 = gc_frame_new();
// call case 4: self request
  Object call6587 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6586);
// compiled member node returning call6587 (depth = 5)
  gc_frame_newslot(call6587);
// starting to compile block node (depth = 5)
  Object block6588 = alloc_Block(NULL, NULL, "ast", 1625);
  gc_frame_newslot(block6588);
// method "_apply(_)"
  block_savedest(block6588);
  Object closure6589 = createclosure(3, "_apply(1)");
  setclosureframe(closure6589, stackframe);
  addtoclosure(closure6589, var_visitor);
  addtoclosure(closure6589, var_newChain);
  addtoclosure(closure6589, selfslot);
  struct UserObject *uo6589 = (struct UserObject*)block6588;
  uo6589->data[0] = (Object)closure6589;
  Method *meth_meth_ast__apply_40_1_41_6589 = addmethod2pos(block6588, "_apply(1)", &meth_ast__apply_40_1_41_6589, 0);
  int argcv_meth_ast__apply_40_1_41_6589[] = {1};
  meth_meth_ast__apply_40_1_41_6589->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6589);
  meth_meth_ast__apply_40_1_41_6589->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6589->definitionLine = 2981;
// compiled block node returning block6588 (depth = 5)
  gc_frame_newslot(block6588);
// call case 5: prelude request
  params[0] = call6587;
  params[1] = block6588;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6593 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6585);
// compiled call node returning call6593 (depth = 4)
    gc_frame_newslot(call6593);
    if6576 = call6593;
  } else {
  }
// compiled if node returning if6576 (depth = 3)
  gc_frame_end(frame);
  return if6576;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_6594(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6595 = gc_frame_new();
// call case 4: self request
  Object call6596 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6595);
// compiled member node returning call6596 (depth = 4)
  *var_n = call6596;
  if (call6596 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1632
  setline(1632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6597 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6598 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6597);
// compiled call node returning call6598 (depth = 4)
  *var_newChain = call6598;
  if (call6598 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6599 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6600 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6601 = gc_frame_new();
// call case 4: self request
  Object call6602 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6601);
// compiled member node returning call6602 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6603 = callmethodflags(call6602, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6600);
// compiled call node returning call6603 (depth = 4)
  gc_frame_newslot(call6603);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6603;
  partcv[0] = 1;
  Object call6604 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6599);
// compiled call node returning call6604 (depth = 3)
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6605 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6606 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6607 = gc_frame_new();
// call case 4: self request
  Object call6608 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6607);
// compiled member node returning call6608 (depth = 5)
  gc_frame_newslot(call6608);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6609 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6610 = gc_frame_new();
// call case 3: self.outer request
  Object call6611 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6610);
// compiled member node returning call6611 (depth = 6)
  Object call6612 = callmethodflags(call6611, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6609);
// compiled member node returning call6612 (depth = 5)
  params[0] = call6608;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6613 = callmethodflags(call6612, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6606);
// compiled call node returning call6613 (depth = 4)
  gc_frame_newslot(call6613);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6613;
  partcv[0] = 1;
  Object call6614 = callmethodflags(*var_n, "args:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6605);
// compiled call node returning call6614 (depth = 3)
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6615 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6616 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6615);
// compiled call node returning call6616 (depth = 3)
  gc_frame_end(frame);
  return call6616;
}
Object meth_ast__apply_40_1_41_6641(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6643 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6645 = alloc_Float64(2);
// compiled num node returning num6645 (depth = 9)
  int op_slot_right_6644 = gc_frame_newslot(num6645);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6644 = gc_frame_newslot(*var_depth);
  params[0] = num6645;
  partcv[0] = 1;
  Object sum6647 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6647 (depth = 8)
  gc_frame_newslot(sum6647);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum6647;
  partcv[0] = 1;
  Object call6648 = callmethodflags(*var_each, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6643);
// compiled call node returning call6648 (depth = 7)
  int op_slot_right_6642 = gc_frame_newslot(call6648);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6642 = gc_frame_newslot(*var_s);
  params[0] = call6648;
  partcv[0] = 1;
  Object opresult6650 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6650 (depth = 6)
  *var_s = opresult6650;
  if (opresult6650 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6654(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6656 == NULL) {
    strlit6656 = alloc_String(", ");
    gc_root(strlit6656);
  }
// compiled string node returning strlit6656 (depth = 7)
  int op_slot_right_6655 = gc_frame_newslot(strlit6656);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6655 = gc_frame_newslot(*var_s);
  params[0] = strlit6656;
  partcv[0] = 1;
  Object opresult6658 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6658 (depth = 6)
  *var_s = opresult6658;
  if (opresult6658 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_6617(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1638
  setline(1638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6619 == NULL) {
    strlit6619 = alloc_String(")<");
    gc_root(strlit6619);
  }
// compiled string node returning strlit6619 (depth = 5)
  int op_slot_right_6618 = gc_frame_newslot(strlit6619);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6622 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6623 = gc_frame_new();
// call case 4: self request
  Object call6624 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6623);
// compiled member node returning call6624 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6625 = callmethodflags(call6624, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6622);
// compiled call node returning call6625 (depth = 6)
  int op_slot_right_6621 = gc_frame_newslot(call6625);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6628 == NULL) {
    strlit6628 = alloc_String("(");
    gc_root(strlit6628);
  }
// compiled string node returning strlit6628 (depth = 7)
  int op_slot_right_6627 = gc_frame_newslot(strlit6628);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6631 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6632 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6631);
// compiled call node returning call6632 (depth = 8)
  int op_slot_right_6630 = gc_frame_newslot(call6632);
// starting to compile string node (depth = 8)
  if (strlit6634 == NULL) {
    strlit6634 = alloc_String("");
    gc_root(strlit6634);
  }
// compiled string node returning strlit6634 (depth = 8)
  int op_slot_left_6630 = gc_frame_newslot(strlit6634);
  params[0] = call6632;
  partcv[0] = 1;
  Object opresult6635 = callmethod(strlit6634, "++(1)", 1, partcv, params);
// compiled op node returning opresult6635 (depth = 7)
  int op_slot_left_6627 = gc_frame_newslot(opresult6635);
  params[0] = strlit6628;
  partcv[0] = 1;
  Object opresult6636 = callmethod(opresult6635, "++(1)", 1, partcv, params);
// compiled op node returning opresult6636 (depth = 6)
  int op_slot_left_6621 = gc_frame_newslot(opresult6636);
  params[0] = call6625;
  partcv[0] = 1;
  Object opresult6637 = callmethod(opresult6636, "++(1)", 1, partcv, params);
// compiled op node returning opresult6637 (depth = 5)
  int op_slot_left_6618 = gc_frame_newslot(opresult6637);
  params[0] = strlit6619;
  partcv[0] = 1;
  Object opresult6638 = callmethod(opresult6637, "++(1)", 1, partcv, params);
// compiled op node returning opresult6638 (depth = 4)
  *var_s = opresult6638;
  if (opresult6638 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6639 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6640 = alloc_Block(NULL, NULL, "ast", 1639);
  gc_frame_newslot(block6640);
// method "_apply(_)"
  block_savedest(block6640);
  Object closure6641 = createclosure(3, "_apply(1)");
  setclosureframe(closure6641, stackframe);
  addtoclosure(closure6641, var_depth);
  addtoclosure(closure6641, var_s);
  addtoclosure(closure6641, selfslot);
  struct UserObject *uo6641 = (struct UserObject*)block6640;
  uo6641->data[0] = (Object)closure6641;
  Method *meth_meth_ast__apply_40_1_41_6641 = addmethod2pos(block6640, "_apply(1)", &meth_ast__apply_40_1_41_6641, 0);
  int argcv_meth_ast__apply_40_1_41_6641[] = {1};
  meth_meth_ast__apply_40_1_41_6641->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6641);
  meth_meth_ast__apply_40_1_41_6641->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6641->definitionLine = 2981;
// compiled block node returning block6640 (depth = 4)
  gc_frame_newslot(block6640);
// Begin line 1640
  setline(1640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6653 = alloc_Block(NULL, NULL, "ast", 1640);
  gc_frame_newslot(block6653);
// method "_apply"
  block_savedest(block6653);
  Object closure6654 = createclosure(2, "_apply");
  setclosureframe(closure6654, stackframe);
  addtoclosure(closure6654, var_s);
  addtoclosure(closure6654, selfslot);
  struct UserObject *uo6654 = (struct UserObject*)block6653;
  uo6654->data[0] = (Object)closure6654;
  Method *meth_meth_ast__apply6654 = addmethod2pos(block6653, "_apply", &meth_ast__apply6654, 0);
  int argcv_meth_ast__apply6654[] = {0};
  meth_meth_ast__apply6654->type = alloc_MethodType(1, argcv_meth_ast__apply6654);
  meth_meth_ast__apply6654->definitionModule = modulename;
  meth_meth_ast__apply6654->definitionLine = 2981;
// compiled block node returning block6653 (depth = 4)
  gc_frame_newslot(block6653);
// call case 6: other requests
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6661 = gc_frame_new();
// call case 4: self request
  Object call6662 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6661);
// compiled member node returning call6662 (depth = 4)
  params[0] = block6640;
  params[1] = block6653;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6663 = callmethodflags(call6662, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6639);
// compiled call node returning call6663 (depth = 3)
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6665 == NULL) {
    strlit6665 = alloc_String(">");
    gc_root(strlit6665);
  }
// compiled string node returning strlit6665 (depth = 4)
  int op_slot_right_6664 = gc_frame_newslot(strlit6665);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_6664 = gc_frame_newslot(*var_s);
  params[0] = strlit6665;
  partcv[0] = 1;
  Object opresult6667 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6667 (depth = 3)
  gc_frame_end(frame);
  return opresult6667;
}
Object meth_ast__apply_40_1_41_6677(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6679 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num6680 = alloc_Float64(0);
// compiled num node returning num6680 (depth = 8)
  gc_frame_newslot(num6680);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = num6680;
  partcv[0] = 1;
  Object call6681 = callmethodflags(*var_each, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6679);
// compiled call node returning call6681 (depth = 7)
  int op_slot_right_6678 = gc_frame_newslot(call6681);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6678 = gc_frame_newslot(*var_s);
  params[0] = call6681;
  partcv[0] = 1;
  Object opresult6683 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6683 (depth = 6)
  *var_s = opresult6683;
  if (opresult6683 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6687(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6689 == NULL) {
    strlit6689 = alloc_String(", ");
    gc_root(strlit6689);
  }
// compiled string node returning strlit6689 (depth = 7)
  int op_slot_right_6688 = gc_frame_newslot(strlit6689);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6688 = gc_frame_newslot(*var_s);
  params[0] = strlit6689;
  partcv[0] = 1;
  Object opresult6691 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6691 (depth = 6)
  *var_s = opresult6691;
  if (opresult6691 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_6668(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6670 == NULL) {
    strlit6670 = alloc_String("<");
    gc_root(strlit6670);
  }
// compiled string node returning strlit6670 (depth = 5)
  int op_slot_right_6669 = gc_frame_newslot(strlit6670);
// starting to compile member node (depth = 5)
  int callframe6672 = gc_frame_new();
// call case 4: self request
  Object call6673 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6672);
// compiled member node returning call6673 (depth = 5)
  int op_slot_left_6669 = gc_frame_newslot(call6673);
  params[0] = strlit6670;
  partcv[0] = 1;
  Object opresult6674 = callmethod(call6673, "++(1)", 1, partcv, params);
// compiled op node returning opresult6674 (depth = 4)
  *var_s = opresult6674;
  if (opresult6674 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1645
  setline(1645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6675 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6676 = alloc_Block(NULL, NULL, "ast", 1645);
  gc_frame_newslot(block6676);
// method "_apply(_)"
  block_savedest(block6676);
  Object closure6677 = createclosure(2, "_apply(1)");
  setclosureframe(closure6677, stackframe);
  addtoclosure(closure6677, var_s);
  addtoclosure(closure6677, selfslot);
  struct UserObject *uo6677 = (struct UserObject*)block6676;
  uo6677->data[0] = (Object)closure6677;
  Method *meth_meth_ast__apply_40_1_41_6677 = addmethod2pos(block6676, "_apply(1)", &meth_ast__apply_40_1_41_6677, 0);
  int argcv_meth_ast__apply_40_1_41_6677[] = {1};
  meth_meth_ast__apply_40_1_41_6677->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6677);
  meth_meth_ast__apply_40_1_41_6677->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6677->definitionLine = 2981;
// compiled block node returning block6676 (depth = 4)
  gc_frame_newslot(block6676);
// Begin line 1646
  setline(1646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6686 = alloc_Block(NULL, NULL, "ast", 1646);
  gc_frame_newslot(block6686);
// method "_apply"
  block_savedest(block6686);
  Object closure6687 = createclosure(2, "_apply");
  setclosureframe(closure6687, stackframe);
  addtoclosure(closure6687, var_s);
  addtoclosure(closure6687, selfslot);
  struct UserObject *uo6687 = (struct UserObject*)block6686;
  uo6687->data[0] = (Object)closure6687;
  Method *meth_meth_ast__apply6687 = addmethod2pos(block6686, "_apply", &meth_ast__apply6687, 0);
  int argcv_meth_ast__apply6687[] = {0};
  meth_meth_ast__apply6687->type = alloc_MethodType(1, argcv_meth_ast__apply6687);
  meth_meth_ast__apply6687->definitionModule = modulename;
  meth_meth_ast__apply6687->definitionLine = 2981;
// compiled block node returning block6686 (depth = 4)
  gc_frame_newslot(block6686);
// call case 6: other requests
// Begin line 1645
  setline(1645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6694 = gc_frame_new();
// call case 4: self request
  Object call6695 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6694);
// compiled member node returning call6695 (depth = 4)
  params[0] = block6676;
  params[1] = block6686;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6696 = callmethodflags(call6695, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6675);
// compiled call node returning call6696 (depth = 3)
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6698 == NULL) {
    strlit6698 = alloc_String(">");
    gc_root(strlit6698);
  }
// compiled string node returning strlit6698 (depth = 4)
  int op_slot_right_6697 = gc_frame_newslot(strlit6698);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_6697 = gc_frame_newslot(*var_s);
  params[0] = strlit6698;
  partcv[0] = 1;
  Object opresult6700 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6700 (depth = 3)
  gc_frame_end(frame);
  return opresult6700;
}
Object meth_ast_shallowCopy6701(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6702 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6703 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6704 = gc_frame_new();
// call case 4: self request
  Object call6705 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6704);
// compiled member node returning call6705 (depth = 5)
  gc_frame_newslot(call6705);
// starting to compile member node (depth = 5)
  int callframe6706 = gc_frame_new();
// call case 4: self request
  Object call6707 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6706);
// compiled member node returning call6707 (depth = 5)
  gc_frame_newslot(call6707);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_genericNode (depth = 5)
  params[0] = call6705;
  params[1] = call6707;
  partcv[0] = 2;
  Object call6708 = callmethodflags(*var_genericNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6703);
// compiled call node returning call6708 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6709 = callmethodflags(call6708, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6702);
// compiled call node returning call6709 (depth = 3)
  gc_frame_end(frame);
  return call6709;
}
Object meth_ast_new_40_2_41_6560(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_base = &(stackframe->slots[0]);
  *var_base = args[curarg];
  curarg++;
  Object *var_arguments = &(stackframe->slots[1]);
  *var_arguments = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6561 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6561 = alloc_userobj2(12,11, objclass6561);
  gc_frame_newslot(obj6561);
if (objclass6561 == NULL) {
  glfree(obj6561->class->name);
  obj6561->class->name = "genericNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6561, self, 0);
  addmethodreal(obj6561,"outer", &reader_ast_outer_6562);
  Object oldself6561 = self;
  struct StackFrameObject *oldstackframe6561 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6561);
  gc_frame_newslot((Object)stackframe);
  self = obj6561;
  Object *oldselfslot6561 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6561 = (*(struct UserObject *)self).data[0], lowerouter6561 = thisouter6561;
  if (inheritingObject6561) {
    struct UserObject *inho6561 = (struct UserObject *)inheritingObject6561;
    while (inho6561->super != GraceDefaultObject) inho6561 = (struct UserObject *)inho6561->super;
    inho6561->super = obj6561;
    self = inheritingObject6561;
    *selfslot = self;
    lowerouter6561 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6561;
  }
if (objclass6561 == NULL) {
  Method *reader6563 = addmethodrealflags(obj6561, "kind",&reader_ast_kind_6563, MFLAG_DEF);
  reader6563->definitionModule = modulename;
  reader6563->definitionLine = 1614;
}
adddatum2(obj6561, alloc_Undefined(), 1);
if (objclass6561 == NULL) {
  Method *reader6564 = addmethodrealflags(obj6561, "value", &reader_ast_value_6564, 0);
  Method *writer6564 = addmethodrealflags(obj6561, "value:=(1)", &writer_ast_value_6564, 0);
  reader6564->definitionModule = modulename;
  writer6564->definitionModule = modulename;
  reader6564->definitionLine = 1615;
  writer6564->definitionLine = 1615;
}
obj6561->flags |= OFLAG_MUTABLE;
adddatum2(obj6561, alloc_Undefined(), 2);
if (objclass6561 == NULL) {
  Method *reader6565 = addmethodrealflags(obj6561, "args", &reader_ast_args_6565, 0);
  Method *writer6565 = addmethodrealflags(obj6561, "args:=(1)", &writer_ast_args_6565, 0);
  reader6565->definitionModule = modulename;
  writer6565->definitionModule = modulename;
  reader6565->definitionLine = 1618;
  writer6565->definitionLine = 1618;
}
obj6561->flags |= OFLAG_MUTABLE;
adddatum2(obj6561, alloc_Undefined(), 3);
// method "nameString"
  struct UserObject *uo6566 = (struct UserObject*)obj6561;
  uo6566->data[4] = emptyclosure;
  Method *meth_meth_ast_nameString6566 = addmethod2pos(obj6561, "nameString", &meth_ast_nameString6566, 4);
  int argcv_meth_ast_nameString6566[] = {0};
  meth_meth_ast_nameString6566->type = alloc_MethodType(1, argcv_meth_ast_nameString6566);
  meth_meth_ast_nameString6566->definitionModule = modulename;
  meth_meth_ast_nameString6566->definitionLine = 1619;
// method "asString"
  struct UserObject *uo6571 = (struct UserObject*)obj6561;
  uo6571->data[5] = emptyclosure;
  Method *meth_meth_ast_asString6571 = addmethod2pos(obj6561, "asString", &meth_ast_asString6571, 5);
  int argcv_meth_ast_asString6571[] = {0};
  meth_meth_ast_asString6571->type = alloc_MethodType(1, argcv_meth_ast_asString6571);
  meth_meth_ast_asString6571->definitionModule = modulename;
  meth_meth_ast_asString6571->definitionLine = 1620;
// method "accept(_)from(_)"
  struct UserObject *uo6575 = (struct UserObject*)obj6561;
  uo6575->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6575 = addmethod2pos(obj6561, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6575, 6);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6575[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6575->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6575);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6575->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6575->definitionLine = 1621;
// method "map(_)ancestors(_)"
  struct UserObject *uo6594 = (struct UserObject*)obj6561;
  uo6594->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6594 = addmethod2pos(obj6561, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6594, 7);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6594[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6594->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6594);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6594->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6594->definitionLine = 1630;
// method "pretty(_)"
  struct UserObject *uo6617 = (struct UserObject*)obj6561;
  uo6617->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_6617 = addmethod2pos(obj6561, "pretty(1)", &meth_ast_pretty_40_1_41_6617, 8);
  int argcv_meth_ast_pretty_40_1_41_6617[] = {1};
  meth_meth_ast_pretty_40_1_41_6617->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_6617);
  meth_meth_ast_pretty_40_1_41_6617->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_6617->definitionLine = 1637;
// method "toGrace(_)"
  struct UserObject *uo6668 = (struct UserObject*)obj6561;
  uo6668->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_6668 = addmethod2pos(obj6561, "toGrace(1)", &meth_ast_toGrace_40_1_41_6668, 9);
  int argcv_meth_ast_toGrace_40_1_41_6668[] = {1};
  meth_meth_ast_toGrace_40_1_41_6668->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_6668);
meth_meth_ast_toGrace_40_1_41_6668->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_6668->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_6668->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_6668->definitionLine = 1643;
// method "shallowCopy"
  block_savedest(obj6561);
  Object closure6701 = createclosure(1, "shallowCopy");
  setclosureframe(closure6701, stackframe);
  addtoclosure(closure6701, var_genericNode);
  struct UserObject *uo6701 = (struct UserObject*)obj6561;
  uo6701->data[10] = (Object)closure6701;
  Method *meth_meth_ast_shallowCopy6701 = addmethod2pos(obj6561, "shallowCopy", &meth_ast_shallowCopy6701, 10);
  int argcv_meth_ast_shallowCopy6701[] = {0};
  meth_meth_ast_shallowCopy6701->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6701);
  meth_meth_ast_shallowCopy6701->definitionModule = modulename;
  meth_meth_ast_shallowCopy6701->definitionLine = 1649;
  sourceObject = obj6561;
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6710 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6711 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6712 = gc_frame_new();
// call case 3: self.outer request
  Object call6713 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6712);
// compiled member node returning call6713 (depth = 5)
  Object call6714 = callmethodflags(call6713, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6711);
// compiled member node returning call6714 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6715 = callmethodflags(call6714, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6710);
// compiled call node returning call6715 (depth = 3)
  struct UserObject *obj6561_uo = (struct UserObject *)obj6561;
  obj6561_uo->super = call6715;
  sourceObject = obj6561;
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6716 == NULL) {
    strlit6716 = alloc_String("generic");
    gc_root(strlit6716);
  }
// compiled string node returning strlit6716 (depth = 3)
  adddatum2(obj6561, strlit6716, 1);
  sourceObject = obj6561;
// Begin line 1615
  setline(1615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_base (depth = 3)
  adddatum2(obj6561, *var_base, 2);
  sourceObject = obj6561;
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arguments (depth = 3)
  adddatum2(obj6561, *var_arguments, 3);
  sourceObject = obj6561;
  sourceObject = obj6561;
  sourceObject = obj6561;
  sourceObject = obj6561;
  sourceObject = obj6561;
  sourceObject = obj6561;
  sourceObject = obj6561;
  objclass6561 = obj6561->class;
  objclass6561->definitionModule = modulename;
  objclass6561->definitionLine = 1611;
  (*(struct UserObject *)self).data[0] = lowerouter6561;
  self = oldself6561;
  selfslot = oldselfslot6561;
  stackframe = oldstackframe6561;
  gc_frame_end(frame);
  return obj6561;
}
Object meth_ast_new_40_2_41_6560_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_base = &(stackframe->slots[0]);
  *var_base = args[curarg];
  curarg++;
  Object *var_arguments = &(stackframe->slots[1]);
  *var_arguments = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6561 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6561 = alloc_userobj2(12,11, objclass6561);
  gc_frame_newslot(obj6561);
if (objclass6561 == NULL) {
  glfree(obj6561->class->name);
  obj6561->class->name = "genericNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6561, self, 0);
  addmethodreal(obj6561,"outer", &reader_ast_outer_6562);
  Object oldself6561 = self;
  struct StackFrameObject *oldstackframe6561 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6561);
  gc_frame_newslot((Object)stackframe);
  self = obj6561;
  Object *oldselfslot6561 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6561 = (*(struct UserObject *)self).data[0], lowerouter6561 = thisouter6561;
  if (inheritingObject6561) {
    struct UserObject *inho6561 = (struct UserObject *)inheritingObject6561;
    while (inho6561->super != GraceDefaultObject) inho6561 = (struct UserObject *)inho6561->super;
    inho6561->super = obj6561;
    self = inheritingObject6561;
    *selfslot = self;
    lowerouter6561 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6561;
  }
if (objclass6561 == NULL) {
  Method *reader6563 = addmethodrealflags(obj6561, "kind",&reader_ast_kind_6563, MFLAG_DEF);
  reader6563->definitionModule = modulename;
  reader6563->definitionLine = 1614;
}
adddatum2(obj6561, alloc_Undefined(), 1);
if (objclass6561 == NULL) {
  Method *reader6564 = addmethodrealflags(obj6561, "value", &reader_ast_value_6564, 0);
  Method *writer6564 = addmethodrealflags(obj6561, "value:=(1)", &writer_ast_value_6564, 0);
  reader6564->definitionModule = modulename;
  writer6564->definitionModule = modulename;
  reader6564->definitionLine = 1615;
  writer6564->definitionLine = 1615;
}
obj6561->flags |= OFLAG_MUTABLE;
adddatum2(obj6561, alloc_Undefined(), 2);
if (objclass6561 == NULL) {
  Method *reader6565 = addmethodrealflags(obj6561, "args", &reader_ast_args_6565, 0);
  Method *writer6565 = addmethodrealflags(obj6561, "args:=(1)", &writer_ast_args_6565, 0);
  reader6565->definitionModule = modulename;
  writer6565->definitionModule = modulename;
  reader6565->definitionLine = 1618;
  writer6565->definitionLine = 1618;
}
obj6561->flags |= OFLAG_MUTABLE;
adddatum2(obj6561, alloc_Undefined(), 3);
// method "nameString"
  struct UserObject *uo6566 = (struct UserObject*)obj6561;
  uo6566->data[4] = emptyclosure;
  Method *meth_meth_ast_nameString6566 = addmethod2pos(obj6561, "nameString", &meth_ast_nameString6566, 4);
  int argcv_meth_ast_nameString6566[] = {0};
  meth_meth_ast_nameString6566->type = alloc_MethodType(1, argcv_meth_ast_nameString6566);
  meth_meth_ast_nameString6566->definitionModule = modulename;
  meth_meth_ast_nameString6566->definitionLine = 1619;
// method "asString"
  struct UserObject *uo6571 = (struct UserObject*)obj6561;
  uo6571->data[5] = emptyclosure;
  Method *meth_meth_ast_asString6571 = addmethod2pos(obj6561, "asString", &meth_ast_asString6571, 5);
  int argcv_meth_ast_asString6571[] = {0};
  meth_meth_ast_asString6571->type = alloc_MethodType(1, argcv_meth_ast_asString6571);
  meth_meth_ast_asString6571->definitionModule = modulename;
  meth_meth_ast_asString6571->definitionLine = 1620;
// method "accept(_)from(_)"
  struct UserObject *uo6575 = (struct UserObject*)obj6561;
  uo6575->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6575 = addmethod2pos(obj6561, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6575, 6);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6575[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6575->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6575);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6575->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6575->definitionLine = 1621;
// method "map(_)ancestors(_)"
  struct UserObject *uo6594 = (struct UserObject*)obj6561;
  uo6594->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6594 = addmethod2pos(obj6561, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6594, 7);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6594[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6594->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6594);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6594->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6594->definitionLine = 1630;
// method "pretty(_)"
  struct UserObject *uo6617 = (struct UserObject*)obj6561;
  uo6617->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_6617 = addmethod2pos(obj6561, "pretty(1)", &meth_ast_pretty_40_1_41_6617, 8);
  int argcv_meth_ast_pretty_40_1_41_6617[] = {1};
  meth_meth_ast_pretty_40_1_41_6617->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_6617);
  meth_meth_ast_pretty_40_1_41_6617->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_6617->definitionLine = 1637;
// method "toGrace(_)"
  struct UserObject *uo6668 = (struct UserObject*)obj6561;
  uo6668->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_6668 = addmethod2pos(obj6561, "toGrace(1)", &meth_ast_toGrace_40_1_41_6668, 9);
  int argcv_meth_ast_toGrace_40_1_41_6668[] = {1};
  meth_meth_ast_toGrace_40_1_41_6668->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_6668);
meth_meth_ast_toGrace_40_1_41_6668->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_6668->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_6668->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_6668->definitionLine = 1643;
// method "shallowCopy"
  block_savedest(obj6561);
  Object closure6701 = createclosure(1, "shallowCopy");
  setclosureframe(closure6701, stackframe);
  addtoclosure(closure6701, var_genericNode);
  struct UserObject *uo6701 = (struct UserObject*)obj6561;
  uo6701->data[10] = (Object)closure6701;
  Method *meth_meth_ast_shallowCopy6701 = addmethod2pos(obj6561, "shallowCopy", &meth_ast_shallowCopy6701, 10);
  int argcv_meth_ast_shallowCopy6701[] = {0};
  meth_meth_ast_shallowCopy6701->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6701);
  meth_meth_ast_shallowCopy6701->definitionModule = modulename;
  meth_meth_ast_shallowCopy6701->definitionLine = 1649;
  sourceObject = obj6561;
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6710 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6711 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6712 = gc_frame_new();
// call case 3: self.outer request
  Object call6713 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6712);
// compiled member node returning call6713 (depth = 5)
  Object call6714 = callmethodflags(call6713, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6711);
// compiled member node returning call6714 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6715 = callmethodflags(call6714, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6710);
// compiled call node returning call6715 (depth = 3)
  struct UserObject *obj6561_uo = (struct UserObject *)obj6561;
  obj6561_uo->super = call6715;
  sourceObject = obj6561;
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6716 == NULL) {
    strlit6716 = alloc_String("generic");
    gc_root(strlit6716);
  }
// compiled string node returning strlit6716 (depth = 3)
  adddatum2(obj6561, strlit6716, 1);
  sourceObject = obj6561;
// Begin line 1615
  setline(1615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_base (depth = 3)
  adddatum2(obj6561, *var_base, 2);
  sourceObject = obj6561;
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arguments (depth = 3)
  adddatum2(obj6561, *var_arguments, 3);
  sourceObject = obj6561;
  sourceObject = obj6561;
  sourceObject = obj6561;
  sourceObject = obj6561;
  sourceObject = obj6561;
  sourceObject = obj6561;
  sourceObject = obj6561;
  objclass6561 = obj6561->class;
  objclass6561->definitionModule = modulename;
  objclass6561->definitionLine = 1611;
  (*(struct UserObject *)self).data[0] = lowerouter6561;
  self = oldself6561;
  selfslot = oldselfslot6561;
  stackframe = oldstackframe6561;
  gc_frame_end(frame);
  return obj6561;
}
Object meth_ast_genericNode6718(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "genericNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1610
  setline(1610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_genericNode (depth = 3)
  gc_frame_end(frame);
  return *var_genericNode;
}
Object meth_ast_asString6726(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6727 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num6728 = alloc_Float64(0);
// compiled num node returning num6728 (depth = 4)
  gc_frame_newslot(num6728);
// call case 4: self request
  params[0] = num6728;
  partcv[0] = 1;
  Object call6729 = callmethodflags(self, "toGrace(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6727);
// compiled call node returning call6729 (depth = 3)
  gc_frame_end(frame);
  return call6729;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_6730(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1661
  setline(1661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6731 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call6732 = callmethodflags(*var_k, "typeparam", 0, partcv, params, 0);
  gc_frame_end(callframe6731);
// compiled member node returning call6732 (depth = 3)
  gc_frame_end(frame);
  return call6732;
}
Object meth_ast__apply_40_1_41_6741(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6742 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6743 = callmethodflags(*var_p, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6742);
// compiled call node returning call6743 (depth = 6)
  gc_frame_end(frame);
  return call6743;
}
Object meth_ast_accept_40_1_41_from_40_1_41_6733(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1664
  setline(1664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6735 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6736 = callmethodflags(*var_visitor, "visitTypeParameters(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6735);
// compiled call node returning call6736 (depth = 4)
  Object if6734 = done;
  if (istrue(call6736)) {
// Begin line 1665
  setline(1665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6737 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6738 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6737);
// compiled call node returning call6738 (depth = 5)
  *var_newChain = call6738;
  if (call6738 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6739 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6740 = alloc_Block(NULL, NULL, "ast", 1666);
  gc_frame_newslot(block6740);
// method "_apply(_)"
  block_savedest(block6740);
  Object closure6741 = createclosure(3, "_apply(1)");
  setclosureframe(closure6741, stackframe);
  addtoclosure(closure6741, var_visitor);
  addtoclosure(closure6741, var_newChain);
  addtoclosure(closure6741, selfslot);
  struct UserObject *uo6741 = (struct UserObject*)block6740;
  uo6741->data[0] = (Object)closure6741;
  Method *meth_meth_ast__apply_40_1_41_6741 = addmethod2pos(block6740, "_apply(1)", &meth_ast__apply_40_1_41_6741, 0);
  int argcv_meth_ast__apply_40_1_41_6741[] = {1};
  meth_meth_ast__apply_40_1_41_6741->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6741);
  meth_meth_ast__apply_40_1_41_6741->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6741->definitionLine = 2981;
// compiled block node returning block6740 (depth = 5)
  gc_frame_newslot(block6740);
// call case 6: other requests
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6745 = gc_frame_new();
// call case 4: self request
  Object call6746 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6745);
// compiled member node returning call6746 (depth = 5)
  params[0] = block6740;
  partcv[0] = 1;
  Object call6747 = callmethodflags(call6746, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6739);
// compiled call node returning call6747 (depth = 4)
    gc_frame_newslot(call6747);
    if6734 = call6747;
  } else {
  }
// compiled if node returning if6734 (depth = 3)
  gc_frame_end(frame);
  return if6734;
}
Object meth_ast_do_40_1_41_6748(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1672
  setline(1672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6749 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  gc_frame_newslot(*var_blk);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6750 = gc_frame_new();
// call case 4: self request
  Object call6751 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6750);
// compiled member node returning call6751 (depth = 4)
  params[0] = *var_blk;
  partcv[0] = 1;
  Object call6752 = callmethodflags(call6751, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6749);
// compiled call node returning call6752 (depth = 3)
  gc_frame_end(frame);
  return call6752;
}
Object meth_ast_size6753(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1674
  setline(1674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6754 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6755 = gc_frame_new();
// call case 4: self request
  Object call6756 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6755);
// compiled member node returning call6756 (depth = 4)
  Object call6757 = callmethodflags(call6756, "size", 0, partcv, params, 0);
  gc_frame_end(callframe6754);
// compiled member node returning call6757 (depth = 3)
  gc_frame_end(frame);
  return call6757;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_6758(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1676
  setline(1676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6759 = gc_frame_new();
// call case 4: self request
  Object call6760 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6759);
// compiled member node returning call6760 (depth = 4)
  *var_n = call6760;
  if (call6760 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1677
  setline(1677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6761 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6762 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6761);
// compiled call node returning call6762 (depth = 4)
  *var_newChain = call6762;
  if (call6762 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1678
  setline(1678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6763 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6764 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe6765 = gc_frame_new();
// call case 4: self request
  Object call6766 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6765);
// compiled member node returning call6766 (depth = 5)
  gc_frame_newslot(call6766);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6767 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6768 = gc_frame_new();
// call case 3: self.outer request
  Object call6769 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6768);
// compiled member node returning call6769 (depth = 6)
  Object call6770 = callmethodflags(call6769, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6767);
// compiled member node returning call6770 (depth = 5)
  params[0] = call6766;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6771 = callmethodflags(call6770, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6764);
// compiled call node returning call6771 (depth = 4)
  gc_frame_newslot(call6771);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6771;
  partcv[0] = 1;
  Object call6772 = callmethodflags(*var_n, "params:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6763);
// compiled call node returning call6772 (depth = 3)
// Begin line 1679
  setline(1679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6773 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6774 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6773);
// compiled call node returning call6774 (depth = 3)
  gc_frame_end(frame);
  return call6774;
}
Object meth_ast__apply_40_1_41_6783(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1684
  setline(1684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6785 == NULL) {
    strlit6785 = alloc_String("  ");
    gc_root(strlit6785);
  }
// compiled string node returning strlit6785 (depth = 7)
  int op_slot_right_6784 = gc_frame_newslot(strlit6785);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_6784 = gc_frame_newslot(*var_spc);
  params[0] = strlit6785;
  partcv[0] = 1;
  Object opresult6787 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult6787 (depth = 6)
  *var_spc = opresult6787;
  if (opresult6787 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_6802(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6804 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6806 = alloc_Float64(2);
// compiled num node returning num6806 (depth = 9)
  int op_slot_right_6805 = gc_frame_newslot(num6806);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6805 = gc_frame_newslot(*var_depth);
  params[0] = num6806;
  partcv[0] = 1;
  Object sum6808 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum6808 (depth = 8)
  gc_frame_newslot(sum6808);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum6808;
  partcv[0] = 1;
  Object call6809 = callmethodflags(*var_each, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6804);
// compiled call node returning call6809 (depth = 7)
  int op_slot_right_6803 = gc_frame_newslot(call6809);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6803 = gc_frame_newslot(*var_s);
  params[0] = call6809;
  partcv[0] = 1;
  Object opresult6811 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6811 (depth = 6)
  *var_s = opresult6811;
  if (opresult6811 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6815(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6817 == NULL) {
    strlit6817 = alloc_String(", ");
    gc_root(strlit6817);
  }
// compiled string node returning strlit6817 (depth = 7)
  int op_slot_right_6816 = gc_frame_newslot(strlit6817);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6816 = gc_frame_newslot(*var_s);
  params[0] = strlit6817;
  partcv[0] = 1;
  Object opresult6819 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6819 (depth = 6)
  *var_s = opresult6819;
  if (opresult6819 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_6775(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6776 == NULL) {
    strlit6776 = alloc_String("");
    gc_root(strlit6776);
  }
// compiled string node returning strlit6776 (depth = 4)
  *var_spc = strlit6776;
  if (strlit6776 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6777 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_6778 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num6780 = alloc_Float64(0);
// compiled num node returning num6780 (depth = 5)
  int op_slot_left_6778 = gc_frame_newslot(num6780);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6781 = callmethod(num6780, "..(1)", 1, partcv, params);
// compiled op node returning opresult6781 (depth = 4)
  gc_frame_newslot(opresult6781);
// starting to compile block node (depth = 4)
  Object block6782 = alloc_Block(NULL, NULL, "ast", 1683);
  gc_frame_newslot(block6782);
// method "_apply(_)"
  block_savedest(block6782);
  Object closure6783 = createclosure(2, "_apply(1)");
  setclosureframe(closure6783, stackframe);
  addtoclosure(closure6783, var_spc);
  addtoclosure(closure6783, selfslot);
  struct UserObject *uo6783 = (struct UserObject*)block6782;
  uo6783->data[0] = (Object)closure6783;
  Method *meth_meth_ast__apply_40_1_41_6783 = addmethod2pos(block6782, "_apply(1)", &meth_ast__apply_40_1_41_6783, 0);
  int argcv_meth_ast__apply_40_1_41_6783[] = {1};
  meth_meth_ast__apply_40_1_41_6783->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6783);
  meth_meth_ast__apply_40_1_41_6783->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6783->definitionLine = 2981;
// compiled block node returning block6782 (depth = 4)
  gc_frame_newslot(block6782);
// call case 5: prelude request
  params[0] = opresult6781;
  params[1] = block6782;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6790 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6777);
// compiled call node returning call6790 (depth = 3)
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6792 == NULL) {
    strlit6792 = alloc_String("<");
    gc_root(strlit6792);
  }
// compiled string node returning strlit6792 (depth = 5)
  int op_slot_right_6791 = gc_frame_newslot(strlit6792);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6795 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6796 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6795);
// compiled call node returning call6796 (depth = 6)
  int op_slot_right_6794 = gc_frame_newslot(call6796);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_6794 = gc_frame_newslot(*var_spc);
  params[0] = call6796;
  partcv[0] = 1;
  Object opresult6798 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult6798 (depth = 5)
  int op_slot_left_6791 = gc_frame_newslot(opresult6798);
  params[0] = strlit6792;
  partcv[0] = 1;
  Object opresult6799 = callmethod(opresult6798, "++(1)", 1, partcv, params);
// compiled op node returning opresult6799 (depth = 4)
  *var_s = opresult6799;
  if (opresult6799 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6800 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6801 = alloc_Block(NULL, NULL, "ast", 1687);
  gc_frame_newslot(block6801);
// method "_apply(_)"
  block_savedest(block6801);
  Object closure6802 = createclosure(3, "_apply(1)");
  setclosureframe(closure6802, stackframe);
  addtoclosure(closure6802, var_depth);
  addtoclosure(closure6802, var_s);
  addtoclosure(closure6802, selfslot);
  struct UserObject *uo6802 = (struct UserObject*)block6801;
  uo6802->data[0] = (Object)closure6802;
  Method *meth_meth_ast__apply_40_1_41_6802 = addmethod2pos(block6801, "_apply(1)", &meth_ast__apply_40_1_41_6802, 0);
  int argcv_meth_ast__apply_40_1_41_6802[] = {1};
  meth_meth_ast__apply_40_1_41_6802->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6802);
  meth_meth_ast__apply_40_1_41_6802->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6802->definitionLine = 2981;
// compiled block node returning block6801 (depth = 4)
  gc_frame_newslot(block6801);
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6814 = alloc_Block(NULL, NULL, "ast", 1688);
  gc_frame_newslot(block6814);
// method "_apply"
  block_savedest(block6814);
  Object closure6815 = createclosure(2, "_apply");
  setclosureframe(closure6815, stackframe);
  addtoclosure(closure6815, var_s);
  addtoclosure(closure6815, selfslot);
  struct UserObject *uo6815 = (struct UserObject*)block6814;
  uo6815->data[0] = (Object)closure6815;
  Method *meth_meth_ast__apply6815 = addmethod2pos(block6814, "_apply", &meth_ast__apply6815, 0);
  int argcv_meth_ast__apply6815[] = {0};
  meth_meth_ast__apply6815->type = alloc_MethodType(1, argcv_meth_ast__apply6815);
  meth_meth_ast__apply6815->definitionModule = modulename;
  meth_meth_ast__apply6815->definitionLine = 2981;
// compiled block node returning block6814 (depth = 4)
  gc_frame_newslot(block6814);
// call case 6: other requests
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6822 = gc_frame_new();
// call case 4: self request
  Object call6823 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6822);
// compiled member node returning call6823 (depth = 4)
  params[0] = block6801;
  params[1] = block6814;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6824 = callmethodflags(call6823, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6800);
// compiled call node returning call6824 (depth = 3)
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6826 == NULL) {
    strlit6826 = alloc_String(">");
    gc_root(strlit6826);
  }
// compiled string node returning strlit6826 (depth = 4)
  int op_slot_right_6825 = gc_frame_newslot(strlit6826);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_6825 = gc_frame_newslot(*var_s);
  params[0] = strlit6826;
  partcv[0] = 1;
  Object opresult6828 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6828 (depth = 3)
  gc_frame_end(frame);
  return opresult6828;
}
Object meth_ast__apply_40_1_41_6833(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6835 == NULL) {
    strlit6835 = alloc_String("");
    gc_root(strlit6835);
  }
// compiled string node returning strlit6835 (depth = 7)
  int op_slot_right_6834 = gc_frame_newslot(strlit6835);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6838 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6839 = callmethodflags(*var_each, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6838);
// compiled call node returning call6839 (depth = 8)
  int op_slot_right_6837 = gc_frame_newslot(call6839);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6842 == NULL) {
    strlit6842 = alloc_String("");
    gc_root(strlit6842);
  }
// compiled string node returning strlit6842 (depth = 9)
  int op_slot_right_6841 = gc_frame_newslot(strlit6842);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_6844 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit6846 == NULL) {
    strlit6846 = alloc_String("");
    gc_root(strlit6846);
  }
// compiled string node returning strlit6846 (depth = 10)
  int op_slot_left_6844 = gc_frame_newslot(strlit6846);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult6847 = callmethod(strlit6846, "++(1)", 1, partcv, params);
// compiled op node returning opresult6847 (depth = 9)
  int op_slot_left_6841 = gc_frame_newslot(opresult6847);
  params[0] = strlit6842;
  partcv[0] = 1;
  Object opresult6848 = callmethod(opresult6847, "++(1)", 1, partcv, params);
// compiled op node returning opresult6848 (depth = 8)
  int op_slot_left_6837 = gc_frame_newslot(opresult6848);
  params[0] = call6839;
  partcv[0] = 1;
  Object opresult6849 = callmethod(opresult6848, "++(1)", 1, partcv, params);
// compiled op node returning opresult6849 (depth = 7)
  int op_slot_left_6834 = gc_frame_newslot(opresult6849);
  params[0] = strlit6835;
  partcv[0] = 1;
  Object opresult6850 = callmethod(opresult6849, "++(1)", 1, partcv, params);
// compiled op node returning opresult6850 (depth = 6)
  *var_s = opresult6850;
  if (opresult6850 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6854(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6856 == NULL) {
    strlit6856 = alloc_String(", ");
    gc_root(strlit6856);
  }
// compiled string node returning strlit6856 (depth = 7)
  int op_slot_right_6855 = gc_frame_newslot(strlit6856);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6855 = gc_frame_newslot(*var_s);
  params[0] = strlit6856;
  partcv[0] = 1;
  Object opresult6858 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6858 (depth = 6)
  *var_s = opresult6858;
  if (opresult6858 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_6829(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6830 == NULL) {
    strlit6830 = alloc_String("<");
    gc_root(strlit6830);
  }
// compiled string node returning strlit6830 (depth = 4)
  *var_s = strlit6830;
  if (strlit6830 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6831 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6832 = alloc_Block(NULL, NULL, "ast", 1693);
  gc_frame_newslot(block6832);
// method "_apply(_)"
  block_savedest(block6832);
  Object closure6833 = createclosure(3, "_apply(1)");
  setclosureframe(closure6833, stackframe);
  addtoclosure(closure6833, var_depth);
  addtoclosure(closure6833, var_s);
  addtoclosure(closure6833, selfslot);
  struct UserObject *uo6833 = (struct UserObject*)block6832;
  uo6833->data[0] = (Object)closure6833;
  Method *meth_meth_ast__apply_40_1_41_6833 = addmethod2pos(block6832, "_apply(1)", &meth_ast__apply_40_1_41_6833, 0);
  int argcv_meth_ast__apply_40_1_41_6833[] = {1};
  meth_meth_ast__apply_40_1_41_6833->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_6833);
  meth_meth_ast__apply_40_1_41_6833->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_6833->definitionLine = 2981;
// compiled block node returning block6832 (depth = 4)
  gc_frame_newslot(block6832);
// Begin line 1694
  setline(1694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6853 = alloc_Block(NULL, NULL, "ast", 1694);
  gc_frame_newslot(block6853);
// method "_apply"
  block_savedest(block6853);
  Object closure6854 = createclosure(2, "_apply");
  setclosureframe(closure6854, stackframe);
  addtoclosure(closure6854, var_s);
  addtoclosure(closure6854, selfslot);
  struct UserObject *uo6854 = (struct UserObject*)block6853;
  uo6854->data[0] = (Object)closure6854;
  Method *meth_meth_ast__apply6854 = addmethod2pos(block6853, "_apply", &meth_ast__apply6854, 0);
  int argcv_meth_ast__apply6854[] = {0};
  meth_meth_ast__apply6854->type = alloc_MethodType(1, argcv_meth_ast__apply6854);
  meth_meth_ast__apply6854->definitionModule = modulename;
  meth_meth_ast__apply6854->definitionLine = 2981;
// compiled block node returning block6853 (depth = 4)
  gc_frame_newslot(block6853);
// call case 6: other requests
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6861 = gc_frame_new();
// call case 4: self request
  Object call6862 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6861);
// compiled member node returning call6862 (depth = 4)
  params[0] = block6832;
  params[1] = block6853;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6863 = callmethodflags(call6862, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6831);
// compiled call node returning call6863 (depth = 3)
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6865 == NULL) {
    strlit6865 = alloc_String(">");
    gc_root(strlit6865);
  }
// compiled string node returning strlit6865 (depth = 4)
  int op_slot_right_6864 = gc_frame_newslot(strlit6865);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_6864 = gc_frame_newslot(*var_s);
  params[0] = strlit6865;
  partcv[0] = 1;
  Object opresult6867 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult6867 (depth = 3)
  gc_frame_end(frame);
  return opresult6867;
}
Object meth_ast_shallowCopy6868(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeParametersNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6869 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe6870 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeParametersNode (depth = 5)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call6871 = callmethodflags(*var_typeParametersNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6870);
// compiled call node returning call6871 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6872 = callmethodflags(call6871, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6869);
// compiled call node returning call6872 (depth = 3)
  gc_frame_end(frame);
  return call6872;
}
Object meth_ast_new_40_1_41_6721(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_typeParametersNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6722 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6722 = alloc_userobj2(12,12, objclass6722);
  gc_frame_newslot(obj6722);
if (objclass6722 == NULL) {
  glfree(obj6722->class->name);
  obj6722->class->name = "typeParametersNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6722, self, 0);
  addmethodreal(obj6722,"outer", &reader_ast_outer_6723);
  Object oldself6722 = self;
  struct StackFrameObject *oldstackframe6722 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6722);
  gc_frame_newslot((Object)stackframe);
  self = obj6722;
  Object *oldselfslot6722 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6722 = (*(struct UserObject *)self).data[0], lowerouter6722 = thisouter6722;
  if (inheritingObject6722) {
    struct UserObject *inho6722 = (struct UserObject *)inheritingObject6722;
    while (inho6722->super != GraceDefaultObject) inho6722 = (struct UserObject *)inho6722->super;
    inho6722->super = obj6722;
    self = inheritingObject6722;
    *selfslot = self;
    lowerouter6722 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6722;
  }
if (objclass6722 == NULL) {
  Method *reader6724 = addmethodrealflags(obj6722, "kind",&reader_ast_kind_6724, MFLAG_DEF);
  reader6724->definitionModule = modulename;
  reader6724->definitionLine = 1658;
}
adddatum2(obj6722, alloc_Undefined(), 1);
if (objclass6722 == NULL) {
  Method *reader6725 = addmethodrealflags(obj6722, "params", &reader_ast_params_6725, 0);
  Method *writer6725 = addmethodrealflags(obj6722, "params:=(1)", &writer_ast_params_6725, 0);
  reader6725->definitionModule = modulename;
  writer6725->definitionModule = modulename;
  reader6725->definitionLine = 1659;
  writer6725->definitionLine = 1659;
}
obj6722->flags |= OFLAG_MUTABLE;
adddatum2(obj6722, alloc_Undefined(), 2);
// method "asString"
  struct UserObject *uo6726 = (struct UserObject*)obj6722;
  uo6726->data[3] = emptyclosure;
  Method *meth_meth_ast_asString6726 = addmethod2pos(obj6722, "asString", &meth_ast_asString6726, 3);
  int argcv_meth_ast_asString6726[] = {0};
  meth_meth_ast_asString6726->type = alloc_MethodType(1, argcv_meth_ast_asString6726);
  meth_meth_ast_asString6726->definitionModule = modulename;
  meth_meth_ast_asString6726->definitionLine = 1660;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj6722);
  Object closure6730 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure6730, stackframe);
  addtoclosure(closure6730, var_k);
  struct UserObject *uo6730 = (struct UserObject*)obj6722;
  uo6730->data[4] = (Object)closure6730;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_6730 = addmethod2pos(obj6722, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_6730, 4);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_6730[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6730->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_6730);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6730->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6730->definitionLine = 1661;
// method "accept(_)from(_)"
  struct UserObject *uo6733 = (struct UserObject*)obj6722;
  uo6733->data[5] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6733 = addmethod2pos(obj6722, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6733, 5);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6733[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6733->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6733);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6733->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6733->definitionLine = 1663;
// method "do(_)"
  struct UserObject *uo6748 = (struct UserObject*)obj6722;
  uo6748->data[6] = emptyclosure;
  Method *meth_meth_ast_do_40_1_41_6748 = addmethod2pos(obj6722, "do(1)", &meth_ast_do_40_1_41_6748, 6);
  int argcv_meth_ast_do_40_1_41_6748[] = {1};
  meth_meth_ast_do_40_1_41_6748->type = alloc_MethodType(1, argcv_meth_ast_do_40_1_41_6748);
  meth_meth_ast_do_40_1_41_6748->definitionModule = modulename;
  meth_meth_ast_do_40_1_41_6748->definitionLine = 1671;
// method "size"
  struct UserObject *uo6753 = (struct UserObject*)obj6722;
  uo6753->data[7] = emptyclosure;
  Method *meth_meth_ast_size6753 = addmethod2pos(obj6722, "size", &meth_ast_size6753, 7);
  int argcv_meth_ast_size6753[] = {0};
  meth_meth_ast_size6753->type = alloc_MethodType(1, argcv_meth_ast_size6753);
  meth_meth_ast_size6753->definitionModule = modulename;
  meth_meth_ast_size6753->definitionLine = 1674;
// method "map(_)ancestors(_)"
  struct UserObject *uo6758 = (struct UserObject*)obj6722;
  uo6758->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6758 = addmethod2pos(obj6722, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6758, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6758[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6758->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6758);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6758->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6758->definitionLine = 1675;
// method "pretty(_)"
  struct UserObject *uo6775 = (struct UserObject*)obj6722;
  uo6775->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_6775 = addmethod2pos(obj6722, "pretty(1)", &meth_ast_pretty_40_1_41_6775, 9);
  int argcv_meth_ast_pretty_40_1_41_6775[] = {1};
  meth_meth_ast_pretty_40_1_41_6775->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_6775);
  meth_meth_ast_pretty_40_1_41_6775->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_6775->definitionLine = 1681;
// method "toGrace(_)"
  struct UserObject *uo6829 = (struct UserObject*)obj6722;
  uo6829->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_6829 = addmethod2pos(obj6722, "toGrace(1)", &meth_ast_toGrace_40_1_41_6829, 10);
  int argcv_meth_ast_toGrace_40_1_41_6829[] = {1};
  meth_meth_ast_toGrace_40_1_41_6829->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_6829);
meth_meth_ast_toGrace_40_1_41_6829->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_6829->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_6829->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_6829->definitionLine = 1691;
// method "shallowCopy"
  block_savedest(obj6722);
  Object closure6868 = createclosure(2, "shallowCopy");
  setclosureframe(closure6868, stackframe);
  addtoclosure(closure6868, var_emptySeq);
  addtoclosure(closure6868, var_typeParametersNode);
  struct UserObject *uo6868 = (struct UserObject*)obj6722;
  uo6868->data[11] = (Object)closure6868;
  Method *meth_meth_ast_shallowCopy6868 = addmethod2pos(obj6722, "shallowCopy", &meth_ast_shallowCopy6868, 11);
  int argcv_meth_ast_shallowCopy6868[] = {0};
  meth_meth_ast_shallowCopy6868->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6868);
  meth_meth_ast_shallowCopy6868->definitionModule = modulename;
  meth_meth_ast_shallowCopy6868->definitionLine = 1697;
  sourceObject = obj6722;
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6873 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6874 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6875 = gc_frame_new();
// call case 3: self.outer request
  Object call6876 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6875);
// compiled member node returning call6876 (depth = 5)
  Object call6877 = callmethodflags(call6876, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6874);
// compiled member node returning call6877 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6878 = callmethodflags(call6877, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6873);
// compiled call node returning call6878 (depth = 3)
  struct UserObject *obj6722_uo = (struct UserObject *)obj6722;
  obj6722_uo->super = call6878;
  sourceObject = obj6722;
// Begin line 1658
  setline(1658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6879 == NULL) {
    strlit6879 = alloc_String("typeparams");
    gc_root(strlit6879);
  }
// compiled string node returning strlit6879 (depth = 3)
  adddatum2(obj6722, strlit6879, 1);
  sourceObject = obj6722;
// Begin line 1659
  setline(1659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj6722, *var_params_39_, 2);
  sourceObject = obj6722;
  sourceObject = obj6722;
  sourceObject = obj6722;
  sourceObject = obj6722;
  sourceObject = obj6722;
  sourceObject = obj6722;
  sourceObject = obj6722;
  sourceObject = obj6722;
  sourceObject = obj6722;
  objclass6722 = obj6722->class;
  objclass6722->definitionModule = modulename;
  objclass6722->definitionLine = 1656;
  (*(struct UserObject *)self).data[0] = lowerouter6722;
  self = oldself6722;
  selfslot = oldselfslot6722;
  stackframe = oldstackframe6722;
  gc_frame_end(frame);
  return obj6722;
}
Object meth_ast_new_40_1_41_6721_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_typeParametersNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6722 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6722 = alloc_userobj2(12,12, objclass6722);
  gc_frame_newslot(obj6722);
if (objclass6722 == NULL) {
  glfree(obj6722->class->name);
  obj6722->class->name = "typeParametersNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6722, self, 0);
  addmethodreal(obj6722,"outer", &reader_ast_outer_6723);
  Object oldself6722 = self;
  struct StackFrameObject *oldstackframe6722 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6722);
  gc_frame_newslot((Object)stackframe);
  self = obj6722;
  Object *oldselfslot6722 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6722 = (*(struct UserObject *)self).data[0], lowerouter6722 = thisouter6722;
  if (inheritingObject6722) {
    struct UserObject *inho6722 = (struct UserObject *)inheritingObject6722;
    while (inho6722->super != GraceDefaultObject) inho6722 = (struct UserObject *)inho6722->super;
    inho6722->super = obj6722;
    self = inheritingObject6722;
    *selfslot = self;
    lowerouter6722 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6722;
  }
if (objclass6722 == NULL) {
  Method *reader6724 = addmethodrealflags(obj6722, "kind",&reader_ast_kind_6724, MFLAG_DEF);
  reader6724->definitionModule = modulename;
  reader6724->definitionLine = 1658;
}
adddatum2(obj6722, alloc_Undefined(), 1);
if (objclass6722 == NULL) {
  Method *reader6725 = addmethodrealflags(obj6722, "params", &reader_ast_params_6725, 0);
  Method *writer6725 = addmethodrealflags(obj6722, "params:=(1)", &writer_ast_params_6725, 0);
  reader6725->definitionModule = modulename;
  writer6725->definitionModule = modulename;
  reader6725->definitionLine = 1659;
  writer6725->definitionLine = 1659;
}
obj6722->flags |= OFLAG_MUTABLE;
adddatum2(obj6722, alloc_Undefined(), 2);
// method "asString"
  struct UserObject *uo6726 = (struct UserObject*)obj6722;
  uo6726->data[3] = emptyclosure;
  Method *meth_meth_ast_asString6726 = addmethod2pos(obj6722, "asString", &meth_ast_asString6726, 3);
  int argcv_meth_ast_asString6726[] = {0};
  meth_meth_ast_asString6726->type = alloc_MethodType(1, argcv_meth_ast_asString6726);
  meth_meth_ast_asString6726->definitionModule = modulename;
  meth_meth_ast_asString6726->definitionLine = 1660;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj6722);
  Object closure6730 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure6730, stackframe);
  addtoclosure(closure6730, var_k);
  struct UserObject *uo6730 = (struct UserObject*)obj6722;
  uo6730->data[4] = (Object)closure6730;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_6730 = addmethod2pos(obj6722, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_6730, 4);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_6730[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6730->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_6730);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6730->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6730->definitionLine = 1661;
// method "accept(_)from(_)"
  struct UserObject *uo6733 = (struct UserObject*)obj6722;
  uo6733->data[5] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6733 = addmethod2pos(obj6722, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6733, 5);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6733[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6733->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6733);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6733->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6733->definitionLine = 1663;
// method "do(_)"
  struct UserObject *uo6748 = (struct UserObject*)obj6722;
  uo6748->data[6] = emptyclosure;
  Method *meth_meth_ast_do_40_1_41_6748 = addmethod2pos(obj6722, "do(1)", &meth_ast_do_40_1_41_6748, 6);
  int argcv_meth_ast_do_40_1_41_6748[] = {1};
  meth_meth_ast_do_40_1_41_6748->type = alloc_MethodType(1, argcv_meth_ast_do_40_1_41_6748);
  meth_meth_ast_do_40_1_41_6748->definitionModule = modulename;
  meth_meth_ast_do_40_1_41_6748->definitionLine = 1671;
// method "size"
  struct UserObject *uo6753 = (struct UserObject*)obj6722;
  uo6753->data[7] = emptyclosure;
  Method *meth_meth_ast_size6753 = addmethod2pos(obj6722, "size", &meth_ast_size6753, 7);
  int argcv_meth_ast_size6753[] = {0};
  meth_meth_ast_size6753->type = alloc_MethodType(1, argcv_meth_ast_size6753);
  meth_meth_ast_size6753->definitionModule = modulename;
  meth_meth_ast_size6753->definitionLine = 1674;
// method "map(_)ancestors(_)"
  struct UserObject *uo6758 = (struct UserObject*)obj6722;
  uo6758->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6758 = addmethod2pos(obj6722, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6758, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6758[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6758->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6758);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6758->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6758->definitionLine = 1675;
// method "pretty(_)"
  struct UserObject *uo6775 = (struct UserObject*)obj6722;
  uo6775->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_6775 = addmethod2pos(obj6722, "pretty(1)", &meth_ast_pretty_40_1_41_6775, 9);
  int argcv_meth_ast_pretty_40_1_41_6775[] = {1};
  meth_meth_ast_pretty_40_1_41_6775->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_6775);
  meth_meth_ast_pretty_40_1_41_6775->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_6775->definitionLine = 1681;
// method "toGrace(_)"
  struct UserObject *uo6829 = (struct UserObject*)obj6722;
  uo6829->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_6829 = addmethod2pos(obj6722, "toGrace(1)", &meth_ast_toGrace_40_1_41_6829, 10);
  int argcv_meth_ast_toGrace_40_1_41_6829[] = {1};
  meth_meth_ast_toGrace_40_1_41_6829->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_6829);
meth_meth_ast_toGrace_40_1_41_6829->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_6829->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_6829->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_6829->definitionLine = 1691;
// method "shallowCopy"
  block_savedest(obj6722);
  Object closure6868 = createclosure(2, "shallowCopy");
  setclosureframe(closure6868, stackframe);
  addtoclosure(closure6868, var_emptySeq);
  addtoclosure(closure6868, var_typeParametersNode);
  struct UserObject *uo6868 = (struct UserObject*)obj6722;
  uo6868->data[11] = (Object)closure6868;
  Method *meth_meth_ast_shallowCopy6868 = addmethod2pos(obj6722, "shallowCopy", &meth_ast_shallowCopy6868, 11);
  int argcv_meth_ast_shallowCopy6868[] = {0};
  meth_meth_ast_shallowCopy6868->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6868);
  meth_meth_ast_shallowCopy6868->definitionModule = modulename;
  meth_meth_ast_shallowCopy6868->definitionLine = 1697;
  sourceObject = obj6722;
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6873 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6874 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6875 = gc_frame_new();
// call case 3: self.outer request
  Object call6876 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6875);
// compiled member node returning call6876 (depth = 5)
  Object call6877 = callmethodflags(call6876, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6874);
// compiled member node returning call6877 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6878 = callmethodflags(call6877, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6873);
// compiled call node returning call6878 (depth = 3)
  struct UserObject *obj6722_uo = (struct UserObject *)obj6722;
  obj6722_uo->super = call6878;
  sourceObject = obj6722;
// Begin line 1658
  setline(1658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6879 == NULL) {
    strlit6879 = alloc_String("typeparams");
    gc_root(strlit6879);
  }
// compiled string node returning strlit6879 (depth = 3)
  adddatum2(obj6722, strlit6879, 1);
  sourceObject = obj6722;
// Begin line 1659
  setline(1659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj6722, *var_params_39_, 2);
  sourceObject = obj6722;
  sourceObject = obj6722;
  sourceObject = obj6722;
  sourceObject = obj6722;
  sourceObject = obj6722;
  sourceObject = obj6722;
  sourceObject = obj6722;
  sourceObject = obj6722;
  sourceObject = obj6722;
  objclass6722 = obj6722->class;
  objclass6722->definitionModule = modulename;
  objclass6722->definitionLine = 1656;
  (*(struct UserObject *)self).data[0] = lowerouter6722;
  self = oldself6722;
  selfslot = oldselfslot6722;
  stackframe = oldstackframe6722;
  gc_frame_end(frame);
  return obj6722;
}
Object meth_ast_typeParametersNode6881(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeParametersNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeParametersNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1655
  setline(1655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeParametersNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeParametersNode;
}
Object meth_ast_new_40_2_41_scope_40_1_41_6884(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(2)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)scope(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype = &(stackframe->slots[1]);
  *var_dtype = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6885 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 4: self request
  params[0] = *var_name;
  params[1] = *var_dtype;
  partcv[0] = 2;
  Object call6886 = callmethodflags(self, "new(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6885);
// compiled call node returning call6886 (depth = 4)
  *var_result = call6886;
  if (call6886 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1706
  setline(1706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6887 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call6888 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6887);
// compiled call node returning call6888 (depth = 3)
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_nameString6901(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1722
  setline(1722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6902 = gc_frame_new();
// call case 4: self request
  Object call6903 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6902);
// compiled member node returning call6903 (depth = 3)
  gc_frame_end(frame);
  return call6903;
}
Object meth_ast_quoted6905(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "quoted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1724
  setline(1724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe6906 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6907 = gc_frame_new();
// call case 4: self request
  Object call6908 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6907);
// compiled member node returning call6908 (depth = 4)
  Object call6909 = callmethodflags(call6908, "quoted", 0, partcv, params, 0);
  gc_frame_end(callframe6906);
// compiled member node returning call6909 (depth = 3)
  gc_frame_end(frame);
  return call6909;
}
Object meth_ast_isIdentifier6910(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1725
  setline(1725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6911 = alloc_Boolean(1);
// compiled identifier node returning bool6911 (depth = 3)
  gc_frame_end(frame);
  return bool6911;
}
Object meth_ast_isSelf6912(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSelf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1727
  setline(1727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6914 = gc_frame_new();
// call case 4: self request
  Object call6915 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6914);
// compiled member node returning call6915 (depth = 4)
  int op_slot_right_6913 = gc_frame_newslot(call6915);
// starting to compile string node (depth = 4)
  if (strlit6917 == NULL) {
    strlit6917 = alloc_String("self");
    gc_root(strlit6917);
  }
// compiled string node returning strlit6917 (depth = 4)
  int op_slot_left_6913 = gc_frame_newslot(strlit6917);
  params[0] = call6915;
  partcv[0] = 1;
  Object opresult6918 = callmethod(strlit6917, "==(1)", 1, partcv, params);
// compiled op node returning opresult6918 (depth = 3)
  gc_frame_end(frame);
  return opresult6918;
}
Object meth_ast_isSuper6919(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSuper");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6921 = gc_frame_new();
// call case 4: self request
  Object call6922 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6921);
// compiled member node returning call6922 (depth = 4)
  int op_slot_right_6920 = gc_frame_newslot(call6922);
// starting to compile string node (depth = 4)
  if (strlit6924 == NULL) {
    strlit6924 = alloc_String("super");
    gc_root(strlit6924);
  }
// compiled string node returning strlit6924 (depth = 4)
  int op_slot_left_6920 = gc_frame_newslot(strlit6924);
  params[0] = call6922;
  partcv[0] = 1;
  Object opresult6925 = callmethod(strlit6924, "==(1)", 1, partcv, params);
// compiled op node returning opresult6925 (depth = 3)
  gc_frame_end(frame);
  return opresult6925;
}
Object meth_ast_isPrelude6926(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPrelude");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6928 = gc_frame_new();
// call case 4: self request
  Object call6929 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6928);
// compiled member node returning call6929 (depth = 4)
  int op_slot_right_6927 = gc_frame_newslot(call6929);
// starting to compile string node (depth = 4)
  if (strlit6931 == NULL) {
    strlit6931 = alloc_String("prelude");
    gc_root(strlit6931);
  }
// compiled string node returning strlit6931 (depth = 4)
  int op_slot_left_6927 = gc_frame_newslot(strlit6931);
  params[0] = call6929;
  partcv[0] = 1;
  Object opresult6932 = callmethod(strlit6931, "==(1)", 1, partcv, params);
// compiled op node returning opresult6932 (depth = 3)
  gc_frame_end(frame);
  return opresult6932;
}
Object meth_ast_isOuter6933(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isOuter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6935 = gc_frame_new();
// call case 4: self request
  Object call6936 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6935);
// compiled member node returning call6936 (depth = 4)
  int op_slot_right_6934 = gc_frame_newslot(call6936);
// starting to compile string node (depth = 4)
  if (strlit6938 == NULL) {
    strlit6938 = alloc_String("outer");
    gc_root(strlit6938);
  }
// compiled string node returning strlit6938 (depth = 4)
  int op_slot_left_6934 = gc_frame_newslot(strlit6938);
  params[0] = call6936;
  partcv[0] = 1;
  Object opresult6939 = callmethod(strlit6938, "==(1)", 1, partcv, params);
// compiled op node returning opresult6939 (depth = 3)
  gc_frame_end(frame);
  return opresult6939;
}
Object meth_ast_isSelfOrOuter6940(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSelfOrOuter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1732
  setline(1732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6942 = gc_frame_new();
// call case 4: self request
  Object call6943 = callmethodflags(self, "isSelf", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6942);
// compiled member node returning call6943 (depth = 4)
  Object if6941 = done;
  if (istrue(call6943)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6944 = alloc_Boolean(1);
// compiled identifier node returning bool6944 (depth = 5)
  return bool6944;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if6941 = undefined;
  } else {
  }
// compiled if node returning if6941 (depth = 3)
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6946 = gc_frame_new();
// call case 4: self request
  Object call6947 = callmethodflags(self, "isOuter", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6946);
// compiled member node returning call6947 (depth = 4)
  Object if6945 = done;
  if (istrue(call6947)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6948 = alloc_Boolean(1);
// compiled identifier node returning bool6948 (depth = 5)
  return bool6948;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if6945 = undefined;
  } else {
  }
// compiled if node returning if6945 (depth = 3)
// Begin line 1734
  setline(1734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool6949 = alloc_Boolean(0);
// compiled identifier node returning bool6949 (depth = 4)
  return bool6949;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_isAppliedOccurenceOfIdentifier6950(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isAppliedOccurenceOfIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6952 = gc_frame_new();
// call case 4: self request
  Object call6953 = callmethodflags(self, "wildcard", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6952);
// compiled member node returning call6953 (depth = 4)
  Object if6951 = done;
  if (istrue(call6953)) {
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool6954 = alloc_Boolean(0);
// compiled identifier node returning bool6954 (depth = 4)
    gc_frame_newslot(bool6954);
    if6951 = bool6954;
  } else {
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe6955 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6956 = gc_frame_new();
// call case 4: self request
  Object call6957 = callmethodflags(self, "isBindingOccurrence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6956);
// compiled member node returning call6957 (depth = 5)
  Object call6958 = callmethodflags(call6957, "not", 0, partcv, params, 0);
  gc_frame_end(callframe6955);
// compiled member node returning call6958 (depth = 4)
    gc_frame_newslot(call6958);
    if6951 = call6958;
  }
// compiled if node returning if6951 (depth = 3)
  gc_frame_end(frame);
  return if6951;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_6959(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1744
  setline(1744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6960 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6961 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  Object call6962 = callmethodflags(*var_as, "parent", 0, partcv, params, 0);
  gc_frame_end(callframe6961);
// compiled member node returning call6962 (depth = 4)
  params[0] = *var_as;
  partcv[0] = 1;
  Object call6963 = callmethodflags(call6962, "declarationKindWithAncestors(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6960);
// compiled call node returning call6963 (depth = 3)
  gc_frame_end(frame);
  return call6963;
}
Object meth_ast_inTypePositionWithAncestors_40_1_41_6964(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inTypePositionWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method inTypePositionWithAncestors(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for inTypePositionWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part inTypePositionWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6966 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  Object call6967 = callmethodflags(*var_as, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe6966);
// compiled member node returning call6967 (depth = 4)
  Object if6965 = done;
  if (istrue(call6967)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6968 = alloc_Boolean(0);
// compiled identifier node returning bool6968 (depth = 5)
  return bool6968;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if6965 = undefined;
  } else {
  }
// compiled if node returning if6965 (depth = 3)
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6969 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6970 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  Object call6971 = callmethodflags(*var_as, "parent", 0, partcv, params, 0);
  gc_frame_end(callframe6970);
// compiled member node returning call6971 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6972 = callmethodflags(call6971, "usesAsType(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6969);
// compiled call node returning call6972 (depth = 3)
  gc_frame_end(frame);
  return call6972;
}
Object meth_ast_usesAsType_40_1_41_6973(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part usesAsType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6975 = gc_frame_new();
// call case 4: self request
  Object call6976 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6975);
// compiled member node returning call6976 (depth = 4)
  int op_slot_right_6974 = gc_frame_newslot(call6976);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_6974 = gc_frame_newslot(*var_aNode);
  params[0] = call6976;
  partcv[0] = 1;
  Object opresult6978 = callmethod(*var_aNode, "==(1)", 1, partcv, params);
// compiled op node returning opresult6978 (depth = 3)
  gc_frame_end(frame);
  return opresult6978;
}
Object meth_ast_accept_40_1_41_from_40_1_41_6979(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1757
  setline(1757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6981 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6982 = callmethodflags(*var_visitor, "visitIdentifier(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6981);
// compiled call node returning call6982 (depth = 4)
  Object if6980 = done;
  if (istrue(call6982)) {
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6983 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6984 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6983);
// compiled call node returning call6984 (depth = 5)
  *var_newChain = call6984;
  if (call6984 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe6987 = gc_frame_new();
// call case 4: self request
  Object call6988 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6987);
// compiled member node returning call6988 (depth = 6)
  int op_slot_right_6986 = gc_frame_newslot(call6988);
// starting to compile identifier node (depth = 6)
  Object bool6990 = alloc_Boolean(0);
// compiled identifier node returning bool6990 (depth = 6)
  int op_slot_left_6986 = gc_frame_newslot(bool6990);
  params[0] = call6988;
  partcv[0] = 1;
  Object opresult6991 = callmethod(bool6990, "≠(1)", 1, partcv, params);
// compiled op node returning opresult6991 (depth = 5)
  Object if6985 = done;
  if (istrue(opresult6991)) {
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6992 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6993 = gc_frame_new();
// call case 4: self request
  Object call6994 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6993);
// compiled member node returning call6994 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6995 = callmethodflags(call6994, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6992);
// compiled call node returning call6995 (depth = 5)
    gc_frame_newslot(call6995);
    if6985 = call6995;
  } else {
  }
// compiled if node returning if6985 (depth = 4)
    gc_frame_newslot(if6985);
    if6980 = if6985;
  } else {
  }
// compiled if node returning if6980 (depth = 3)
  gc_frame_end(frame);
  return if6980;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_6996(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6997 = gc_frame_new();
// call case 4: self request
  Object call6998 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6997);
// compiled member node returning call6998 (depth = 4)
  *var_n = call6998;
  if (call6998 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6999 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7000 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6999);
// compiled call node returning call7000 (depth = 4)
  *var_newChain = call7000;
  if (call7000 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7001 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7002 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7003 = gc_frame_new();
// call case 4: self request
  Object call7004 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7003);
// compiled member node returning call7004 (depth = 5)
  gc_frame_newslot(call7004);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7005 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7006 = gc_frame_new();
// call case 3: self.outer request
  Object call7007 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7006);
// compiled member node returning call7007 (depth = 6)
  Object call7008 = callmethodflags(call7007, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7005);
// compiled member node returning call7008 (depth = 5)
  params[0] = call7004;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call7009 = callmethodflags(call7008, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7002);
// compiled call node returning call7009 (depth = 4)
  gc_frame_newslot(call7009);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7009;
  partcv[0] = 1;
  Object call7010 = callmethodflags(*var_n, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7001);
// compiled call node returning call7010 (depth = 3)
// Begin line 1768
  setline(1768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7011 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7012 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7011);
// compiled call node returning call7012 (depth = 3)
  gc_frame_end(frame);
  return call7012;
}
Object meth_ast__apply_40_1_41_7021(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7023 == NULL) {
    strlit7023 = alloc_String("  ");
    gc_root(strlit7023);
  }
// compiled string node returning strlit7023 (depth = 7)
  int op_slot_right_7022 = gc_frame_newslot(strlit7023);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_7022 = gc_frame_newslot(*var_spc);
  params[0] = strlit7023;
  partcv[0] = 1;
  Object opresult7025 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult7025 (depth = 6)
  *var_spc = opresult7025;
  if (opresult7025 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_7124(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7126 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num7128 = alloc_Float64(2);
// compiled num node returning num7128 (depth = 10)
  int op_slot_right_7127 = gc_frame_newslot(num7128);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_7127 = gc_frame_newslot(*var_depth);
  params[0] = num7128;
  partcv[0] = 1;
  Object sum7130 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7130 (depth = 9)
  gc_frame_newslot(sum7130);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_g (depth = 9)
  params[0] = sum7130;
  partcv[0] = 1;
  Object call7131 = callmethodflags(*var_g, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7126);
// compiled call node returning call7131 (depth = 8)
  int op_slot_right_7125 = gc_frame_newslot(call7131);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7134 == NULL) {
    strlit7134 = alloc_String("  ");
    gc_root(strlit7134);
  }
// compiled string node returning strlit7134 (depth = 9)
  int op_slot_right_7133 = gc_frame_newslot(strlit7134);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_7136 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit7139 == NULL) {
    strlit7139 = alloc_String("""\x0a""");
    gc_root(strlit7139);
  }
// compiled string node returning strlit7139 (depth = 11)
  int op_slot_right_7138 = gc_frame_newslot(strlit7139);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_7138 = gc_frame_newslot(*var_s);
  params[0] = strlit7139;
  partcv[0] = 1;
  Object opresult7141 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7141 (depth = 10)
  int op_slot_left_7136 = gc_frame_newslot(opresult7141);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7142 = callmethod(opresult7141, "++(1)", 1, partcv, params);
// compiled op node returning opresult7142 (depth = 9)
  int op_slot_left_7133 = gc_frame_newslot(opresult7142);
  params[0] = strlit7134;
  partcv[0] = 1;
  Object opresult7143 = callmethod(opresult7142, "++(1)", 1, partcv, params);
// compiled op node returning opresult7143 (depth = 8)
  int op_slot_left_7125 = gc_frame_newslot(opresult7143);
  params[0] = call7131;
  partcv[0] = 1;
  Object opresult7144 = callmethod(opresult7143, "++(1)", 1, partcv, params);
// compiled op node returning opresult7144 (depth = 7)
  *var_s = opresult7144;
  if (opresult7144 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_7013(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1771
  setline(1771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7014 == NULL) {
    strlit7014 = alloc_String("");
    gc_root(strlit7014);
  }
// compiled string node returning strlit7014 (depth = 4)
  *var_spc = strlit7014;
  if (strlit7014 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1772
  setline(1772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7015 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_7016 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num7018 = alloc_Float64(0);
// compiled num node returning num7018 (depth = 5)
  int op_slot_left_7016 = gc_frame_newslot(num7018);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7019 = callmethod(num7018, "..(1)", 1, partcv, params);
// compiled op node returning opresult7019 (depth = 4)
  gc_frame_newslot(opresult7019);
// starting to compile block node (depth = 4)
  Object block7020 = alloc_Block(NULL, NULL, "ast", 1772);
  gc_frame_newslot(block7020);
// method "_apply(_)"
  block_savedest(block7020);
  Object closure7021 = createclosure(2, "_apply(1)");
  setclosureframe(closure7021, stackframe);
  addtoclosure(closure7021, var_spc);
  addtoclosure(closure7021, selfslot);
  struct UserObject *uo7021 = (struct UserObject*)block7020;
  uo7021->data[0] = (Object)closure7021;
  Method *meth_meth_ast__apply_40_1_41_7021 = addmethod2pos(block7020, "_apply(1)", &meth_ast__apply_40_1_41_7021, 0);
  int argcv_meth_ast__apply_40_1_41_7021[] = {1};
  meth_meth_ast__apply_40_1_41_7021->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_7021);
  meth_meth_ast__apply_40_1_41_7021->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_7021->definitionLine = 2981;
// compiled block node returning block7020 (depth = 4)
  gc_frame_newslot(block7020);
// call case 5: prelude request
  params[0] = opresult7019;
  params[1] = block7020;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7028 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7015);
// compiled call node returning call7028 (depth = 3)
// Begin line 1775
  setline(1775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7029 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7030 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7029);
// compiled call node returning call7030 (depth = 4)
  *var_s = call7030;
  if (call7030 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1776
  setline(1776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7032 = gc_frame_new();
// call case 4: self request
  Object call7033 = callmethodflags(self, "wildcard", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7032);
// compiled member node returning call7033 (depth = 4)
  Object if7031 = done;
  if (istrue(call7033)) {
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7035 == NULL) {
    strlit7035 = alloc_String(" Wildcard");
    gc_root(strlit7035);
  }
// compiled string node returning strlit7035 (depth = 6)
  int op_slot_right_7034 = gc_frame_newslot(strlit7035);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7034 = gc_frame_newslot(*var_s);
  params[0] = strlit7035;
  partcv[0] = 1;
  Object opresult7037 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7037 (depth = 5)
  *var_s = opresult7037;
  if (opresult7037 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7031 = done;
  } else {
// Begin line 1780
  setline(1780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe7040 = gc_frame_new();
// call case 4: self request
  Object call7041 = callmethodflags(self, "isBindingOccurrence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7040);
// compiled member node returning call7041 (depth = 5)
  Object if7039 = done;
  if (istrue(call7041)) {
// Begin line 1779
  setline(1779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7044 == NULL) {
    strlit7044 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7044);
  }
// compiled string node returning strlit7044 (depth = 8)
  int op_slot_right_7043 = gc_frame_newslot(strlit7044);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe7047 = gc_frame_new();
// call case 4: self request
  Object call7048 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7047);
// compiled member node returning call7048 (depth = 9)
  int op_slot_right_7046 = gc_frame_newslot(call7048);
// starting to compile string node (depth = 9)
  if (strlit7050 == NULL) {
    strlit7050 = alloc_String("Binding""\xe2""""\x80""""\xb9""");
    gc_root(strlit7050);
  }
// compiled string node returning strlit7050 (depth = 9)
  int op_slot_left_7046 = gc_frame_newslot(strlit7050);
  params[0] = call7048;
  partcv[0] = 1;
  Object opresult7051 = callmethod(strlit7050, "++(1)", 1, partcv, params);
// compiled op node returning opresult7051 (depth = 8)
  int op_slot_left_7043 = gc_frame_newslot(opresult7051);
  params[0] = strlit7044;
  partcv[0] = 1;
  Object opresult7052 = callmethod(opresult7051, "++(1)", 1, partcv, params);
// compiled op node returning opresult7052 (depth = 7)
  int op_slot_right_7042 = gc_frame_newslot(opresult7052);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7042 = gc_frame_newslot(*var_s);
  params[0] = opresult7052;
  partcv[0] = 1;
  Object opresult7054 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7054 (depth = 6)
  *var_s = opresult7054;
  if (opresult7054 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7039 = done;
  } else {
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7058 == NULL) {
    strlit7058 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7058);
  }
// compiled string node returning strlit7058 (depth = 8)
  int op_slot_right_7057 = gc_frame_newslot(strlit7058);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe7061 = gc_frame_new();
// call case 4: self request
  Object call7062 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7061);
// compiled member node returning call7062 (depth = 9)
  int op_slot_right_7060 = gc_frame_newslot(call7062);
// starting to compile string node (depth = 9)
  if (strlit7064 == NULL) {
    strlit7064 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit7064);
  }
// compiled string node returning strlit7064 (depth = 9)
  int op_slot_left_7060 = gc_frame_newslot(strlit7064);
  params[0] = call7062;
  partcv[0] = 1;
  Object opresult7065 = callmethod(strlit7064, "++(1)", 1, partcv, params);
// compiled op node returning opresult7065 (depth = 8)
  int op_slot_left_7057 = gc_frame_newslot(opresult7065);
  params[0] = strlit7058;
  partcv[0] = 1;
  Object opresult7066 = callmethod(opresult7065, "++(1)", 1, partcv, params);
// compiled op node returning opresult7066 (depth = 7)
  int op_slot_right_7056 = gc_frame_newslot(opresult7066);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7056 = gc_frame_newslot(*var_s);
  params[0] = opresult7066;
  partcv[0] = 1;
  Object opresult7068 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7068 (depth = 6)
  *var_s = opresult7068;
  if (opresult7068 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7039 = done;
  }
// compiled if node returning if7039 (depth = 4)
    gc_frame_newslot(if7039);
    if7031 = if7039;
  }
// compiled if node returning if7031 (depth = 3)
// Begin line 1783
  setline(1783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7072 = gc_frame_new();
// call case 4: self request
  Object call7073 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7072);
// compiled member node returning call7073 (depth = 5)
  int op_slot_right_7071 = gc_frame_newslot(call7073);
// starting to compile identifier node (depth = 5)
  Object bool7075 = alloc_Boolean(0);
// compiled identifier node returning bool7075 (depth = 5)
  int op_slot_left_7071 = gc_frame_newslot(bool7075);
  params[0] = call7073;
  partcv[0] = 1;
  Object opresult7076 = callmethod(bool7075, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7076 (depth = 4)
  Object if7070 = done;
  if (istrue(opresult7076)) {
// Begin line 1784
  setline(1784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7078 == NULL) {
    strlit7078 = alloc_String("  Type: ");
    gc_root(strlit7078);
  }
// compiled string node returning strlit7078 (depth = 6)
  int op_slot_right_7077 = gc_frame_newslot(strlit7078);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_7080 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7083 == NULL) {
    strlit7083 = alloc_String("""\x0a""");
    gc_root(strlit7083);
  }
// compiled string node returning strlit7083 (depth = 8)
  int op_slot_right_7082 = gc_frame_newslot(strlit7083);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7082 = gc_frame_newslot(*var_s);
  params[0] = strlit7083;
  partcv[0] = 1;
  Object opresult7085 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7085 (depth = 7)
  int op_slot_left_7080 = gc_frame_newslot(opresult7085);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7086 = callmethod(opresult7085, "++(1)", 1, partcv, params);
// compiled op node returning opresult7086 (depth = 6)
  int op_slot_left_7077 = gc_frame_newslot(opresult7086);
  params[0] = strlit7078;
  partcv[0] = 1;
  Object opresult7087 = callmethod(opresult7086, "++(1)", 1, partcv, params);
// compiled op node returning opresult7087 (depth = 5)
  *var_s = opresult7087;
  if (opresult7087 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1785
  setline(1785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7090 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7092 = alloc_Float64(2);
// compiled num node returning num7092 (depth = 8)
  int op_slot_right_7091 = gc_frame_newslot(num7092);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7091 = gc_frame_newslot(*var_depth);
  params[0] = num7092;
  partcv[0] = 1;
  Object sum7094 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7094 (depth = 7)
  gc_frame_newslot(sum7094);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7095 = gc_frame_new();
// call case 4: self request
  Object call7096 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7095);
// compiled member node returning call7096 (depth = 7)
  params[0] = sum7094;
  partcv[0] = 1;
  Object call7097 = callmethodflags(call7096, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7090);
// compiled call node returning call7097 (depth = 6)
  int op_slot_right_7089 = gc_frame_newslot(call7097);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7089 = gc_frame_newslot(*var_s);
  params[0] = call7097;
  partcv[0] = 1;
  Object opresult7099 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7099 (depth = 5)
  *var_s = opresult7099;
  if (opresult7099 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7070 = done;
  } else {
  }
// compiled if node returning if7070 (depth = 3)
// Begin line 1787
  setline(1787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7103 = gc_frame_new();
// call case 4: self request
  Object call7104 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7103);
// compiled member node returning call7104 (depth = 5)
  int op_slot_right_7102 = gc_frame_newslot(call7104);
// starting to compile identifier node (depth = 5)
  Object bool7106 = alloc_Boolean(0);
// compiled identifier node returning bool7106 (depth = 5)
  int op_slot_left_7102 = gc_frame_newslot(bool7106);
  params[0] = call7104;
  partcv[0] = 1;
  Object opresult7107 = callmethod(bool7106, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7107 (depth = 4)
  Object if7101 = done;
  if (istrue(opresult7107)) {
// Begin line 1788
  setline(1788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7109 == NULL) {
    strlit7109 = alloc_String("Generics:");
    gc_root(strlit7109);
  }
// compiled string node returning strlit7109 (depth = 6)
  int op_slot_right_7108 = gc_frame_newslot(strlit7109);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_7111 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7114 == NULL) {
    strlit7114 = alloc_String("""\x0a""");
    gc_root(strlit7114);
  }
// compiled string node returning strlit7114 (depth = 8)
  int op_slot_right_7113 = gc_frame_newslot(strlit7114);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7113 = gc_frame_newslot(*var_s);
  params[0] = strlit7114;
  partcv[0] = 1;
  Object opresult7116 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7116 (depth = 7)
  int op_slot_left_7111 = gc_frame_newslot(opresult7116);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7117 = callmethod(opresult7116, "++(1)", 1, partcv, params);
// compiled op node returning opresult7117 (depth = 6)
  int op_slot_left_7108 = gc_frame_newslot(opresult7117);
  params[0] = strlit7109;
  partcv[0] = 1;
  Object opresult7118 = callmethod(opresult7117, "++(1)", 1, partcv, params);
// compiled op node returning opresult7118 (depth = 5)
  *var_s = opresult7118;
  if (opresult7118 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1789
  setline(1789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7120 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7121 = gc_frame_new();
// call case 4: self request
  Object call7122 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7121);
// compiled member node returning call7122 (depth = 5)
  gc_frame_newslot(call7122);
// starting to compile block node (depth = 5)
  Object block7123 = alloc_Block(NULL, NULL, "ast", 1789);
  gc_frame_newslot(block7123);
// method "_apply(_)"
  block_savedest(block7123);
  Object closure7124 = createclosure(4, "_apply(1)");
  setclosureframe(closure7124, stackframe);
  addtoclosure(closure7124, var_depth);
  addtoclosure(closure7124, var_spc);
  addtoclosure(closure7124, var_s);
  addtoclosure(closure7124, selfslot);
  struct UserObject *uo7124 = (struct UserObject*)block7123;
  uo7124->data[0] = (Object)closure7124;
  Method *meth_meth_ast__apply_40_1_41_7124 = addmethod2pos(block7123, "_apply(1)", &meth_ast__apply_40_1_41_7124, 0);
  int argcv_meth_ast__apply_40_1_41_7124[] = {1};
  meth_meth_ast__apply_40_1_41_7124->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_7124);
  meth_meth_ast__apply_40_1_41_7124->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_7124->definitionLine = 2981;
// compiled block node returning block7123 (depth = 5)
  gc_frame_newslot(block7123);
// call case 5: prelude request
  params[0] = call7122;
  params[1] = block7123;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7147 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7120);
// compiled call node returning call7147 (depth = 4)
    gc_frame_newslot(call7147);
    if7101 = call7147;
  } else {
  }
// compiled if node returning if7101 (depth = 3)
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_7206(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1808
  setline(1808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7208 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num7210 = alloc_Float64(1);
// compiled num node returning num7210 (depth = 10)
  int op_slot_right_7209 = gc_frame_newslot(num7210);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_7209 = gc_frame_newslot(*var_depth);
  params[0] = num7210;
  partcv[0] = 1;
  Object sum7212 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7212 (depth = 9)
  gc_frame_newslot(sum7212);
// call case 6: other requests
// starting to compile call node (depth = 9)
  int callframe7213 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe7214 = gc_frame_new();
// call case 4: self request
  Object call7215 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7214);
// compiled member node returning call7215 (depth = 10)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call7216 = callmethodflags(call7215, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7213);
// compiled call node returning call7216 (depth = 9)
  params[0] = sum7212;
  partcv[0] = 1;
  Object call7217 = callmethodflags(call7216, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7208);
// compiled call node returning call7217 (depth = 8)
  int op_slot_right_7207 = gc_frame_newslot(call7217);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7207 = gc_frame_newslot(*var_s);
  params[0] = call7217;
  partcv[0] = 1;
  Object opresult7219 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7219 (depth = 7)
  *var_s = opresult7219;
  if (opresult7219 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_7148(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1796
  setline(1796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_s = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 1797
  setline(1797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7150 = gc_frame_new();
// call case 4: self request
  Object call7151 = callmethodflags(self, "wildcard", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7150);
// compiled member node returning call7151 (depth = 4)
  Object if7149 = done;
  if (istrue(call7151)) {
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7152 == NULL) {
    strlit7152 = alloc_String("_");
    gc_root(strlit7152);
  }
// compiled string node returning strlit7152 (depth = 5)
  *var_s = strlit7152;
  if (strlit7152 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7149 = done;
  } else {
// Begin line 1800
  setline(1800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7154 = gc_frame_new();
// call case 4: self request
  Object call7155 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7154);
// compiled member node returning call7155 (depth = 5)
  *var_s = call7155;
  if (call7155 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7149 = done;
  }
// compiled if node returning if7149 (depth = 3)
// Begin line 1802
  setline(1802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7159 = gc_frame_new();
// call case 4: self request
  Object call7160 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7159);
// compiled member node returning call7160 (depth = 5)
  int op_slot_right_7158 = gc_frame_newslot(call7160);
// starting to compile identifier node (depth = 5)
  Object bool7162 = alloc_Boolean(0);
// compiled identifier node returning bool7162 (depth = 5)
  int op_slot_left_7158 = gc_frame_newslot(bool7162);
  params[0] = call7160;
  partcv[0] = 1;
  Object opresult7163 = callmethod(bool7162, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7163 (depth = 4)
  Object if7157 = done;
  if (istrue(opresult7163)) {
// Begin line 1803
  setline(1803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7165 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7167 = alloc_Float64(1);
// compiled num node returning num7167 (depth = 8)
  int op_slot_right_7166 = gc_frame_newslot(num7167);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7166 = gc_frame_newslot(*var_depth);
  params[0] = num7167;
  partcv[0] = 1;
  Object sum7169 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7169 (depth = 7)
  gc_frame_newslot(sum7169);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7170 = gc_frame_new();
// call case 4: self request
  Object call7171 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7170);
// compiled member node returning call7171 (depth = 7)
  params[0] = sum7169;
  partcv[0] = 1;
  Object call7172 = callmethodflags(call7171, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7165);
// compiled call node returning call7172 (depth = 6)
  int op_slot_right_7164 = gc_frame_newslot(call7172);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7175 == NULL) {
    strlit7175 = alloc_String(" : ");
    gc_root(strlit7175);
  }
// compiled string node returning strlit7175 (depth = 7)
  int op_slot_right_7174 = gc_frame_newslot(strlit7175);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7174 = gc_frame_newslot(*var_s);
  params[0] = strlit7175;
  partcv[0] = 1;
  Object opresult7177 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7177 (depth = 6)
  int op_slot_left_7164 = gc_frame_newslot(opresult7177);
  params[0] = call7172;
  partcv[0] = 1;
  Object opresult7178 = callmethod(opresult7177, "++(1)", 1, partcv, params);
// compiled op node returning opresult7178 (depth = 5)
  *var_s = opresult7178;
  if (opresult7178 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7157 = done;
  } else {
  }
// compiled if node returning if7157 (depth = 3)
// Begin line 1805
  setline(1805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7182 = gc_frame_new();
// call case 4: self request
  Object call7183 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7182);
// compiled member node returning call7183 (depth = 5)
  int op_slot_right_7181 = gc_frame_newslot(call7183);
// starting to compile identifier node (depth = 5)
  Object bool7185 = alloc_Boolean(0);
// compiled identifier node returning bool7185 (depth = 5)
  int op_slot_left_7181 = gc_frame_newslot(bool7185);
  params[0] = call7183;
  partcv[0] = 1;
  Object opresult7186 = callmethod(bool7185, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7186 (depth = 4)
  Object if7180 = done;
  if (istrue(opresult7186)) {
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7188 == NULL) {
    strlit7188 = alloc_String("<");
    gc_root(strlit7188);
  }
// compiled string node returning strlit7188 (depth = 6)
  int op_slot_right_7187 = gc_frame_newslot(strlit7188);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7187 = gc_frame_newslot(*var_s);
  params[0] = strlit7188;
  partcv[0] = 1;
  Object opresult7190 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7190 (depth = 5)
  *var_s = opresult7190;
  if (opresult7190 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7192 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7195 = alloc_Float64(1);
// compiled num node returning num7195 (depth = 7)
  int op_slot_right_7194 = gc_frame_newslot(num7195);
// starting to compile member node (depth = 7)
  int callframe7197 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe7198 = gc_frame_new();
// call case 4: self request
  Object call7199 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7198);
// compiled member node returning call7199 (depth = 8)
  Object call7200 = callmethodflags(call7199, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7197);
// compiled member node returning call7200 (depth = 7)
  int op_slot_left_7194 = gc_frame_newslot(call7200);
  params[0] = num7195;
  partcv[0] = 1;
  Object diff7201 = callmethod(call7200, "-(1)", 1, partcv, params);
// compiled op node returning diff7201 (depth = 6)
  int op_slot_right_7193 = gc_frame_newslot(diff7201);
// starting to compile num node (depth = 6)
  Object num7203 = alloc_Float64(1);
// compiled num node returning num7203 (depth = 6)
  int op_slot_left_7193 = gc_frame_newslot(num7203);
  params[0] = diff7201;
  partcv[0] = 1;
  Object opresult7204 = callmethod(num7203, "..(1)", 1, partcv, params);
// compiled op node returning opresult7204 (depth = 5)
  gc_frame_newslot(opresult7204);
// starting to compile block node (depth = 5)
  Object block7205 = alloc_Block(NULL, NULL, "ast", 1807);
  gc_frame_newslot(block7205);
// method "_apply(_)"
  block_savedest(block7205);
  Object closure7206 = createclosure(3, "_apply(1)");
  setclosureframe(closure7206, stackframe);
  addtoclosure(closure7206, var_depth);
  addtoclosure(closure7206, var_s);
  addtoclosure(closure7206, selfslot);
  struct UserObject *uo7206 = (struct UserObject*)block7205;
  uo7206->data[0] = (Object)closure7206;
  Method *meth_meth_ast__apply_40_1_41_7206 = addmethod2pos(block7205, "_apply(1)", &meth_ast__apply_40_1_41_7206, 0);
  int argcv_meth_ast__apply_40_1_41_7206[] = {1};
  meth_meth_ast__apply_40_1_41_7206->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_7206);
  meth_meth_ast__apply_40_1_41_7206->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_7206->definitionLine = 2981;
// compiled block node returning block7205 (depth = 5)
  gc_frame_newslot(block7205);
// call case 5: prelude request
  params[0] = opresult7204;
  params[1] = block7205;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7222 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7192);
// compiled call node returning call7222 (depth = 4)
// Begin line 1810
  setline(1810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7224 == NULL) {
    strlit7224 = alloc_String(">");
    gc_root(strlit7224);
  }
// compiled string node returning strlit7224 (depth = 6)
  int op_slot_right_7223 = gc_frame_newslot(strlit7224);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7227 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num7229 = alloc_Float64(1);
// compiled num node returning num7229 (depth = 9)
  int op_slot_right_7228 = gc_frame_newslot(num7229);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_7228 = gc_frame_newslot(*var_depth);
  params[0] = num7229;
  partcv[0] = 1;
  Object sum7231 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7231 (depth = 8)
  gc_frame_newslot(sum7231);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe7232 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe7233 = gc_frame_new();
// call case 4: self request
  Object call7234 = callmethodflags(self, "generics", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7233);
// compiled member node returning call7234 (depth = 9)
  Object call7235 = callmethodflags(call7234, "last", 0, partcv, params, 0);
  gc_frame_end(callframe7232);
// compiled member node returning call7235 (depth = 8)
  params[0] = sum7231;
  partcv[0] = 1;
  Object call7236 = callmethodflags(call7235, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7227);
// compiled call node returning call7236 (depth = 7)
  int op_slot_right_7226 = gc_frame_newslot(call7236);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7226 = gc_frame_newslot(*var_s);
  params[0] = call7236;
  partcv[0] = 1;
  Object opresult7238 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7238 (depth = 6)
  int op_slot_left_7223 = gc_frame_newslot(opresult7238);
  params[0] = strlit7224;
  partcv[0] = 1;
  Object opresult7239 = callmethod(opresult7238, "++(1)", 1, partcv, params);
// compiled op node returning opresult7239 (depth = 5)
  *var_s = opresult7239;
  if (opresult7239 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7180 = done;
  } else {
  }
// compiled if node returning if7180 (depth = 3)
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString7241(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1816
  setline(1816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7243 = gc_frame_new();
// call case 4: self request
  Object call7244 = callmethodflags(self, "isBindingOccurrence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7243);
// compiled member node returning call7244 (depth = 4)
  Object if7242 = done;
  if (istrue(call7244)) {
// Begin line 1817
  setline(1817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7246 == NULL) {
    strlit7246 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7246);
  }
// compiled string node returning strlit7246 (depth = 5)
  int op_slot_right_7245 = gc_frame_newslot(strlit7246);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7249 = gc_frame_new();
// call case 4: self request
  Object call7250 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7249);
// compiled member node returning call7250 (depth = 6)
  int op_slot_right_7248 = gc_frame_newslot(call7250);
// starting to compile string node (depth = 6)
  if (strlit7252 == NULL) {
    strlit7252 = alloc_String("identifierBinding""\xe2""""\x80""""\xb9""");
    gc_root(strlit7252);
  }
// compiled string node returning strlit7252 (depth = 6)
  int op_slot_left_7248 = gc_frame_newslot(strlit7252);
  params[0] = call7250;
  partcv[0] = 1;
  Object opresult7253 = callmethod(strlit7252, "++(1)", 1, partcv, params);
// compiled op node returning opresult7253 (depth = 5)
  int op_slot_left_7245 = gc_frame_newslot(opresult7253);
  params[0] = strlit7246;
  partcv[0] = 1;
  Object opresult7254 = callmethod(opresult7253, "++(1)", 1, partcv, params);
// compiled op node returning opresult7254 (depth = 4)
    gc_frame_newslot(opresult7254);
    if7242 = opresult7254;
  } else {
// Begin line 1819
  setline(1819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7256 == NULL) {
    strlit7256 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7256);
  }
// compiled string node returning strlit7256 (depth = 5)
  int op_slot_right_7255 = gc_frame_newslot(strlit7256);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7259 = gc_frame_new();
// call case 4: self request
  Object call7260 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7259);
// compiled member node returning call7260 (depth = 6)
  int op_slot_right_7258 = gc_frame_newslot(call7260);
// starting to compile string node (depth = 6)
  if (strlit7262 == NULL) {
    strlit7262 = alloc_String("identifier""\xe2""""\x80""""\xb9""");
    gc_root(strlit7262);
  }
// compiled string node returning strlit7262 (depth = 6)
  int op_slot_left_7258 = gc_frame_newslot(strlit7262);
  params[0] = call7260;
  partcv[0] = 1;
  Object opresult7263 = callmethod(strlit7262, "++(1)", 1, partcv, params);
// compiled op node returning opresult7263 (depth = 5)
  int op_slot_left_7255 = gc_frame_newslot(opresult7263);
  params[0] = strlit7256;
  partcv[0] = 1;
  Object opresult7264 = callmethod(opresult7263, "++(1)", 1, partcv, params);
// compiled op node returning opresult7264 (depth = 4)
    gc_frame_newslot(opresult7264);
    if7242 = opresult7264;
  }
// compiled if node returning if7242 (depth = 3)
  gc_frame_end(frame);
  return if7242;
}
Object meth_ast_shallowCopy7265(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1823
  setline(1823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7266 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe7267 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7268 = gc_frame_new();
// call case 4: self request
  Object call7269 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7268);
// compiled member node returning call7269 (depth = 5)
  gc_frame_newslot(call7269);
// starting to compile identifier node (depth = 5)
  Object bool7270 = alloc_Boolean(0);
// compiled identifier node returning bool7270 (depth = 5)
  gc_frame_newslot(bool7270);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call7269;
  params[1] = bool7270;
  partcv[0] = 2;
  Object call7271 = callmethodflags(*var_identifierNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7267);
// compiled call node returning call7271 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7272 = callmethodflags(call7271, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7266);
// compiled call node returning call7272 (depth = 3)
  gc_frame_end(frame);
  return call7272;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_7273(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1826
  setline(1826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7274 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call7275 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7274);
// compiled call node returning call7275 (depth = 3)
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7276 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7277 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call7278 = callmethodflags(*var_other, "wildcard", 0, partcv, params, 0);
  gc_frame_end(callframe7277);
// compiled member node returning call7278 (depth = 4)
  gc_frame_newslot(call7278);
// call case 4: self request
  params[0] = call7278;
  partcv[0] = 1;
  Object call7279 = callmethodflags(self, "wildcard:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7276);
// compiled call node returning call7279 (depth = 3)
// Begin line 1828
  setline(1828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7280 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7281 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call7282 = callmethodflags(*var_other, "isBindingOccurrence", 0, partcv, params, 0);
  gc_frame_end(callframe7281);
// compiled member node returning call7282 (depth = 4)
  gc_frame_newslot(call7282);
// call case 4: self request
  params[0] = call7282;
  partcv[0] = 1;
  Object call7283 = callmethodflags(self, "isBindingOccurrence:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7280);
// compiled call node returning call7283 (depth = 3)
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7284 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7285 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call7286 = callmethodflags(*var_other, "isDeclaredByParent", 0, partcv, params, 0);
  gc_frame_end(callframe7285);
// compiled member node returning call7286 (depth = 4)
  gc_frame_newslot(call7286);
// call case 4: self request
  params[0] = call7286;
  partcv[0] = 1;
  Object call7287 = callmethodflags(self, "isDeclaredByParent:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7284);
// compiled call node returning call7287 (depth = 3)
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7288 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7289 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call7290 = callmethodflags(*var_other, "isAssigned", 0, partcv, params, 0);
  gc_frame_end(callframe7289);
// compiled member node returning call7290 (depth = 4)
  gc_frame_newslot(call7290);
// call case 4: self request
  params[0] = call7290;
  partcv[0] = 1;
  Object call7291 = callmethodflags(self, "isAssigned:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7288);
// compiled call node returning call7291 (depth = 3)
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7292 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7293 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call7294 = callmethodflags(*var_other, "inRequest", 0, partcv, params, 0);
  gc_frame_end(callframe7293);
// compiled member node returning call7294 (depth = 4)
  gc_frame_newslot(call7294);
// call case 4: self request
  params[0] = call7294;
  partcv[0] = 1;
  Object call7295 = callmethodflags(self, "inRequest:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7292);
// compiled call node returning call7295 (depth = 3)
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName7296(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1834
  setline(1834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7297 == NULL) {
    strlit7297 = alloc_String("expression");
    gc_root(strlit7297);
  }
// compiled string node returning strlit7297 (depth = 3)
  gc_frame_end(frame);
  return strlit7297;
}
Object meth_ast_new_40_2_41_6889(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[1]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6890 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6890 = alloc_userobj2(39,31, objclass6890);
  gc_frame_newslot(obj6890);
if (objclass6890 == NULL) {
  glfree(obj6890->class->name);
  obj6890->class->name = "identifierNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6890, self, 0);
  addmethodreal(obj6890,"outer", &reader_ast_outer_6891);
  Object oldself6890 = self;
  struct StackFrameObject *oldstackframe6890 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6890);
  gc_frame_newslot((Object)stackframe);
  self = obj6890;
  Object *oldselfslot6890 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6890 = (*(struct UserObject *)self).data[0], lowerouter6890 = thisouter6890;
  if (inheritingObject6890) {
    struct UserObject *inho6890 = (struct UserObject *)inheritingObject6890;
    while (inho6890->super != GraceDefaultObject) inho6890 = (struct UserObject *)inho6890->super;
    inho6890->super = obj6890;
    self = inheritingObject6890;
    *selfslot = self;
    lowerouter6890 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6890;
  }
if (objclass6890 == NULL) {
  Method *reader6892 = addmethodrealflags(obj6890, "kind",&reader_ast_kind_6892, MFLAG_DEF);
  reader6892->definitionModule = modulename;
  reader6892->definitionLine = 1712;
}
adddatum2(obj6890, alloc_Undefined(), 1);
if (objclass6890 == NULL) {
  Method *reader6893 = addmethodrealflags(obj6890, "value", &reader_ast_value_6893, 0);
  Method *writer6893 = addmethodrealflags(obj6890, "value:=(1)", &writer_ast_value_6893, 0);
  reader6893->definitionModule = modulename;
  writer6893->definitionModule = modulename;
  reader6893->definitionLine = 1713;
  writer6893->definitionLine = 1713;
}
obj6890->flags |= OFLAG_MUTABLE;
adddatum2(obj6890, alloc_Undefined(), 2);
if (objclass6890 == NULL) {
  Method *reader6894 = addmethodrealflags(obj6890, "wildcard", &reader_ast_wildcard_6894, 0);
  Method *writer6894 = addmethodrealflags(obj6890, "wildcard:=(1)", &writer_ast_wildcard_6894, 0);
  reader6894->definitionModule = modulename;
  writer6894->definitionModule = modulename;
  reader6894->definitionLine = 1714;
  writer6894->definitionLine = 1714;
}
obj6890->flags |= OFLAG_MUTABLE;
adddatum2(obj6890, alloc_Undefined(), 3);
if (objclass6890 == NULL) {
  Method *reader6895 = addmethodrealflags(obj6890, "dtype", &reader_ast_dtype_6895, 0);
  Method *writer6895 = addmethodrealflags(obj6890, "dtype:=(1)", &writer_ast_dtype_6895, 0);
  reader6895->definitionModule = modulename;
  writer6895->definitionModule = modulename;
  reader6895->definitionLine = 1715;
  writer6895->definitionLine = 1715;
}
obj6890->flags |= OFLAG_MUTABLE;
adddatum2(obj6890, alloc_Undefined(), 4);
if (objclass6890 == NULL) {
  Method *reader6896 = addmethodrealflags(obj6890, "isBindingOccurrence", &reader_ast_isBindingOccurrence_6896, 0);
  Method *writer6896 = addmethodrealflags(obj6890, "isBindingOccurrence:=(1)", &writer_ast_isBindingOccurrence_6896, 0);
  reader6896->definitionModule = modulename;
  writer6896->definitionModule = modulename;
  reader6896->definitionLine = 1716;
  writer6896->definitionLine = 1716;
}
obj6890->flags |= OFLAG_MUTABLE;
adddatum2(obj6890, alloc_Undefined(), 5);
if (objclass6890 == NULL) {
  Method *reader6897 = addmethodrealflags(obj6890, "isAssigned", &reader_ast_isAssigned_6897, 0);
  Method *writer6897 = addmethodrealflags(obj6890, "isAssigned:=(1)", &writer_ast_isAssigned_6897, 0);
  reader6897->definitionModule = modulename;
  writer6897->definitionModule = modulename;
  reader6897->definitionLine = 1717;
  writer6897->definitionLine = 1717;
}
obj6890->flags |= OFLAG_MUTABLE;
adddatum2(obj6890, alloc_Undefined(), 6);
if (objclass6890 == NULL) {
  Method *reader6898 = addmethodrealflags(obj6890, "inRequest", &reader_ast_inRequest_6898, 0);
  Method *writer6898 = addmethodrealflags(obj6890, "inRequest:=(1)", &writer_ast_inRequest_6898, 0);
  reader6898->definitionModule = modulename;
  writer6898->definitionModule = modulename;
  reader6898->definitionLine = 1718;
  writer6898->definitionLine = 1718;
}
obj6890->flags |= OFLAG_MUTABLE;
adddatum2(obj6890, alloc_Undefined(), 7);
if (objclass6890 == NULL) {
  Method *reader6899 = addmethodrealflags(obj6890, "generics", &reader_ast_generics_6899, 0);
  Method *writer6899 = addmethodrealflags(obj6890, "generics:=(1)", &writer_ast_generics_6899, 0);
  reader6899->definitionModule = modulename;
  writer6899->definitionModule = modulename;
  reader6899->definitionLine = 1719;
  writer6899->definitionLine = 1719;
}
obj6890->flags |= OFLAG_MUTABLE;
adddatum2(obj6890, alloc_Undefined(), 8);
if (objclass6890 == NULL) {
  Method *reader6900 = addmethodrealflags(obj6890, "isDeclaredByParent", &reader_ast_isDeclaredByParent_6900, 0);
  Method *writer6900 = addmethodrealflags(obj6890, "isDeclaredByParent:=(1)", &writer_ast_isDeclaredByParent_6900, 0);
  reader6900->definitionModule = modulename;
  writer6900->definitionModule = modulename;
  reader6900->definitionLine = 1720;
  writer6900->definitionLine = 1720;
}
obj6890->flags |= OFLAG_MUTABLE;
adddatum2(obj6890, alloc_Undefined(), 9);
// method "nameString"
  struct UserObject *uo6901 = (struct UserObject*)obj6890;
  uo6901->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString6901 = addmethod2pos(obj6890, "nameString", &meth_ast_nameString6901, 10);
  int argcv_meth_ast_nameString6901[] = {0};
  meth_meth_ast_nameString6901->type = alloc_MethodType(1, argcv_meth_ast_nameString6901);
  meth_meth_ast_nameString6901->definitionModule = modulename;
  meth_meth_ast_nameString6901->definitionLine = 1722;
if (objclass6890 == NULL) {
  Method *reader6904 = addmethodrealflags(obj6890, "canonicalName", &reader_ast_canonicalName_6904, 0);
  Method *writer6904 = addmethodrealflags(obj6890, "canonicalName:=(1)", &writer_ast_canonicalName_6904, 0);
  reader6904->definitionModule = modulename;
  writer6904->definitionModule = modulename;
  reader6904->definitionLine = 1723;
  writer6904->definitionLine = 1723;
}
obj6890->flags |= OFLAG_MUTABLE;
adddatum2(obj6890, alloc_Undefined(), 11);
// method "quoted"
  struct UserObject *uo6905 = (struct UserObject*)obj6890;
  uo6905->data[12] = emptyclosure;
  Method *meth_meth_ast_quoted6905 = addmethod2pos(obj6890, "quoted", &meth_ast_quoted6905, 12);
  int argcv_meth_ast_quoted6905[] = {0};
  meth_meth_ast_quoted6905->type = alloc_MethodType(1, argcv_meth_ast_quoted6905);
  meth_meth_ast_quoted6905->definitionModule = modulename;
  meth_meth_ast_quoted6905->definitionLine = 1724;
// method "isIdentifier"
  struct UserObject *uo6910 = (struct UserObject*)obj6890;
  uo6910->data[13] = emptyclosure;
  Method *meth_meth_ast_isIdentifier6910 = addmethod2pos(obj6890, "isIdentifier", &meth_ast_isIdentifier6910, 13);
  int argcv_meth_ast_isIdentifier6910[] = {0};
  meth_meth_ast_isIdentifier6910->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier6910);
  meth_meth_ast_isIdentifier6910->definitionModule = modulename;
  meth_meth_ast_isIdentifier6910->definitionLine = 1725;
// method "isSelf"
  struct UserObject *uo6912 = (struct UserObject*)obj6890;
  uo6912->data[14] = emptyclosure;
  Method *meth_meth_ast_isSelf6912 = addmethod2pos(obj6890, "isSelf", &meth_ast_isSelf6912, 14);
  int argcv_meth_ast_isSelf6912[] = {0};
  meth_meth_ast_isSelf6912->type = alloc_MethodType(1, argcv_meth_ast_isSelf6912);
  meth_meth_ast_isSelf6912->definitionModule = modulename;
  meth_meth_ast_isSelf6912->definitionLine = 1727;
// method "isSuper"
  struct UserObject *uo6919 = (struct UserObject*)obj6890;
  uo6919->data[15] = emptyclosure;
  Method *meth_meth_ast_isSuper6919 = addmethod2pos(obj6890, "isSuper", &meth_ast_isSuper6919, 15);
  int argcv_meth_ast_isSuper6919[] = {0};
  meth_meth_ast_isSuper6919->type = alloc_MethodType(1, argcv_meth_ast_isSuper6919);
  meth_meth_ast_isSuper6919->definitionModule = modulename;
  meth_meth_ast_isSuper6919->definitionLine = 1728;
// method "isPrelude"
  struct UserObject *uo6926 = (struct UserObject*)obj6890;
  uo6926->data[16] = emptyclosure;
  Method *meth_meth_ast_isPrelude6926 = addmethod2pos(obj6890, "isPrelude", &meth_ast_isPrelude6926, 16);
  int argcv_meth_ast_isPrelude6926[] = {0};
  meth_meth_ast_isPrelude6926->type = alloc_MethodType(1, argcv_meth_ast_isPrelude6926);
  meth_meth_ast_isPrelude6926->definitionModule = modulename;
  meth_meth_ast_isPrelude6926->definitionLine = 1729;
// method "isOuter"
  struct UserObject *uo6933 = (struct UserObject*)obj6890;
  uo6933->data[17] = emptyclosure;
  Method *meth_meth_ast_isOuter6933 = addmethod2pos(obj6890, "isOuter", &meth_ast_isOuter6933, 17);
  int argcv_meth_ast_isOuter6933[] = {0};
  meth_meth_ast_isOuter6933->type = alloc_MethodType(1, argcv_meth_ast_isOuter6933);
  meth_meth_ast_isOuter6933->definitionModule = modulename;
  meth_meth_ast_isOuter6933->definitionLine = 1730;
// method "isSelfOrOuter"
  struct UserObject *uo6940 = (struct UserObject*)obj6890;
  uo6940->data[18] = emptyclosure;
  Method *meth_meth_ast_isSelfOrOuter6940 = addmethod2pos(obj6890, "isSelfOrOuter", &meth_ast_isSelfOrOuter6940, 18);
  int argcv_meth_ast_isSelfOrOuter6940[] = {0};
  meth_meth_ast_isSelfOrOuter6940->type = alloc_MethodType(1, argcv_meth_ast_isSelfOrOuter6940);
  meth_meth_ast_isSelfOrOuter6940->definitionModule = modulename;
  meth_meth_ast_isSelfOrOuter6940->definitionLine = 1731;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo6950 = (struct UserObject*)obj6890;
  uo6950->data[19] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier6950 = addmethod2pos(obj6890, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier6950, 19);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier6950[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier6950->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier6950);
  meth_meth_ast_isAppliedOccurenceOfIdentifier6950->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier6950->definitionLine = 1736;
// method "declarationKindWithAncestors(_)"
  struct UserObject *uo6959 = (struct UserObject*)obj6890;
  uo6959->data[20] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_6959 = addmethod2pos(obj6890, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_6959, 20);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_6959[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6959->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_6959);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6959->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6959->definitionLine = 1743;
// method "inTypePositionWithAncestors(_)"
  struct UserObject *uo6964 = (struct UserObject*)obj6890;
  uo6964->data[21] = emptyclosure;
  Method *meth_meth_ast_inTypePositionWithAncestors_40_1_41_6964 = addmethod2pos(obj6890, "inTypePositionWithAncestors(1)", &meth_ast_inTypePositionWithAncestors_40_1_41_6964, 21);
  int argcv_meth_ast_inTypePositionWithAncestors_40_1_41_6964[] = {1};
  meth_meth_ast_inTypePositionWithAncestors_40_1_41_6964->type = alloc_MethodType(1, argcv_meth_ast_inTypePositionWithAncestors_40_1_41_6964);
  meth_meth_ast_inTypePositionWithAncestors_40_1_41_6964->definitionModule = modulename;
  meth_meth_ast_inTypePositionWithAncestors_40_1_41_6964->definitionLine = 1746;
// method "usesAsType(_)"
  struct UserObject *uo6973 = (struct UserObject*)obj6890;
  uo6973->data[22] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_6973 = addmethod2pos(obj6890, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_6973, 22);
  int argcv_meth_ast_usesAsType_40_1_41_6973[] = {1};
  meth_meth_ast_usesAsType_40_1_41_6973->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_6973);
  meth_meth_ast_usesAsType_40_1_41_6973->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_6973->definitionLine = 1753;
// method "accept(_)from(_)"
  struct UserObject *uo6979 = (struct UserObject*)obj6890;
  uo6979->data[23] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6979 = addmethod2pos(obj6890, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6979, 23);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6979[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6979->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6979);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6979->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6979->definitionLine = 1756;
// method "map(_)ancestors(_)"
  struct UserObject *uo6996 = (struct UserObject*)obj6890;
  uo6996->data[24] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6996 = addmethod2pos(obj6890, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6996, 24);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6996[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6996->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6996);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6996->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6996->definitionLine = 1764;
// method "pretty(_)"
  struct UserObject *uo7013 = (struct UserObject*)obj6890;
  uo7013->data[25] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_7013 = addmethod2pos(obj6890, "pretty(1)", &meth_ast_pretty_40_1_41_7013, 25);
  int argcv_meth_ast_pretty_40_1_41_7013[] = {1};
  meth_meth_ast_pretty_40_1_41_7013->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_7013);
  meth_meth_ast_pretty_40_1_41_7013->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_7013->definitionLine = 1770;
// method "toGrace(_)"
  struct UserObject *uo7148 = (struct UserObject*)obj6890;
  uo7148->data[26] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7148 = addmethod2pos(obj6890, "toGrace(1)", &meth_ast_toGrace_40_1_41_7148, 26);
  int argcv_meth_ast_toGrace_40_1_41_7148[] = {1};
  meth_meth_ast_toGrace_40_1_41_7148->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7148);
meth_meth_ast_toGrace_40_1_41_7148->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7148->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7148->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7148->definitionLine = 1795;
// method "asString"
  struct UserObject *uo7241 = (struct UserObject*)obj6890;
  uo7241->data[27] = emptyclosure;
  Method *meth_meth_ast_asString7241 = addmethod2pos(obj6890, "asString", &meth_ast_asString7241, 27);
  int argcv_meth_ast_asString7241[] = {0};
  meth_meth_ast_asString7241->type = alloc_MethodType(1, argcv_meth_ast_asString7241);
  meth_meth_ast_asString7241->definitionModule = modulename;
  meth_meth_ast_asString7241->definitionLine = 1815;
// method "shallowCopy"
  block_savedest(obj6890);
  Object closure7265 = createclosure(1, "shallowCopy");
  setclosureframe(closure7265, stackframe);
  addtoclosure(closure7265, var_identifierNode);
  struct UserObject *uo7265 = (struct UserObject*)obj6890;
  uo7265->data[28] = (Object)closure7265;
  Method *meth_meth_ast_shallowCopy7265 = addmethod2pos(obj6890, "shallowCopy", &meth_ast_shallowCopy7265, 28);
  int argcv_meth_ast_shallowCopy7265[] = {0};
  meth_meth_ast_shallowCopy7265->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7265);
  meth_meth_ast_shallowCopy7265->definitionModule = modulename;
  meth_meth_ast_shallowCopy7265->definitionLine = 1822;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo7273 = (struct UserObject*)obj6890;
  uo7273->data[29] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_7273 = addmethod2pos(obj6890, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_7273, 29);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_7273[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_7273->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_7273);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_7273->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_7273->definitionLine = 1825;
// method "statementName"
  struct UserObject *uo7296 = (struct UserObject*)obj6890;
  uo7296->data[30] = emptyclosure;
  Method *meth_meth_ast_statementName7296 = addmethod2pos(obj6890, "statementName", &meth_ast_statementName7296, 30);
  int argcv_meth_ast_statementName7296[] = {0};
  meth_meth_ast_statementName7296->type = alloc_MethodType(1, argcv_meth_ast_statementName7296);
  meth_meth_ast_statementName7296->definitionModule = modulename;
  meth_meth_ast_statementName7296->definitionLine = 1834;
  sourceObject = obj6890;
// Begin line 1711
  setline(1711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7298 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7299 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7300 = gc_frame_new();
// call case 3: self.outer request
  Object call7301 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7300);
// compiled member node returning call7301 (depth = 5)
  Object call7302 = callmethodflags(call7301, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7299);
// compiled member node returning call7302 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7303 = callmethodflags(call7302, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7298);
// compiled call node returning call7303 (depth = 3)
  struct UserObject *obj6890_uo = (struct UserObject *)obj6890;
  obj6890_uo->super = call7303;
  sourceObject = obj6890;
// Begin line 1712
  setline(1712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7304 == NULL) {
    strlit7304 = alloc_String("identifier");
    gc_root(strlit7304);
  }
// compiled string node returning strlit7304 (depth = 3)
  adddatum2(obj6890, strlit7304, 1);
  sourceObject = obj6890;
// Begin line 1713
  setline(1713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name (depth = 3)
  adddatum2(obj6890, *var_name, 2);
  sourceObject = obj6890;
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7305 = alloc_Boolean(0);
// compiled identifier node returning bool7305 (depth = 3)
  adddatum2(obj6890, bool7305, 3);
  sourceObject = obj6890;
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj6890, *var_dtype_39_, 4);
  sourceObject = obj6890;
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7306 = alloc_Boolean(0);
// compiled identifier node returning bool7306 (depth = 3)
  adddatum2(obj6890, bool7306, 5);
  sourceObject = obj6890;
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7307 = alloc_Boolean(0);
// compiled identifier node returning bool7307 (depth = 3)
  adddatum2(obj6890, bool7307, 6);
  sourceObject = obj6890;
// Begin line 1718
  setline(1718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7308 = alloc_Boolean(0);
// compiled identifier node returning bool7308 (depth = 3)
  adddatum2(obj6890, bool7308, 7);
  sourceObject = obj6890;
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7309 = alloc_Boolean(0);
// compiled identifier node returning bool7309 (depth = 3)
  adddatum2(obj6890, bool7309, 8);
  sourceObject = obj6890;
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7310 = alloc_Boolean(0);
// compiled identifier node returning bool7310 (depth = 3)
  adddatum2(obj6890, bool7310, 9);
  sourceObject = obj6890;
  sourceObject = obj6890;
// Begin line 1723
  setline(1723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7311 = gc_frame_new();
// call case 4: self request
  Object call7312 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7311);
// compiled member node returning call7312 (depth = 3)
  adddatum2(obj6890, call7312, 11);
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  objclass6890 = obj6890->class;
  objclass6890->definitionModule = modulename;
  objclass6890->definitionLine = 1710;
  (*(struct UserObject *)self).data[0] = lowerouter6890;
  self = oldself6890;
  selfslot = oldselfslot6890;
  stackframe = oldstackframe6890;
  gc_frame_end(frame);
  return obj6890;
}
Object meth_ast_new_40_2_41_6889_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[1]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6890 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6890 = alloc_userobj2(39,31, objclass6890);
  gc_frame_newslot(obj6890);
if (objclass6890 == NULL) {
  glfree(obj6890->class->name);
  obj6890->class->name = "identifierNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6890, self, 0);
  addmethodreal(obj6890,"outer", &reader_ast_outer_6891);
  Object oldself6890 = self;
  struct StackFrameObject *oldstackframe6890 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6890);
  gc_frame_newslot((Object)stackframe);
  self = obj6890;
  Object *oldselfslot6890 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6890 = (*(struct UserObject *)self).data[0], lowerouter6890 = thisouter6890;
  if (inheritingObject6890) {
    struct UserObject *inho6890 = (struct UserObject *)inheritingObject6890;
    while (inho6890->super != GraceDefaultObject) inho6890 = (struct UserObject *)inho6890->super;
    inho6890->super = obj6890;
    self = inheritingObject6890;
    *selfslot = self;
    lowerouter6890 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6890;
  }
if (objclass6890 == NULL) {
  Method *reader6892 = addmethodrealflags(obj6890, "kind",&reader_ast_kind_6892, MFLAG_DEF);
  reader6892->definitionModule = modulename;
  reader6892->definitionLine = 1712;
}
adddatum2(obj6890, alloc_Undefined(), 1);
if (objclass6890 == NULL) {
  Method *reader6893 = addmethodrealflags(obj6890, "value", &reader_ast_value_6893, 0);
  Method *writer6893 = addmethodrealflags(obj6890, "value:=(1)", &writer_ast_value_6893, 0);
  reader6893->definitionModule = modulename;
  writer6893->definitionModule = modulename;
  reader6893->definitionLine = 1713;
  writer6893->definitionLine = 1713;
}
obj6890->flags |= OFLAG_MUTABLE;
adddatum2(obj6890, alloc_Undefined(), 2);
if (objclass6890 == NULL) {
  Method *reader6894 = addmethodrealflags(obj6890, "wildcard", &reader_ast_wildcard_6894, 0);
  Method *writer6894 = addmethodrealflags(obj6890, "wildcard:=(1)", &writer_ast_wildcard_6894, 0);
  reader6894->definitionModule = modulename;
  writer6894->definitionModule = modulename;
  reader6894->definitionLine = 1714;
  writer6894->definitionLine = 1714;
}
obj6890->flags |= OFLAG_MUTABLE;
adddatum2(obj6890, alloc_Undefined(), 3);
if (objclass6890 == NULL) {
  Method *reader6895 = addmethodrealflags(obj6890, "dtype", &reader_ast_dtype_6895, 0);
  Method *writer6895 = addmethodrealflags(obj6890, "dtype:=(1)", &writer_ast_dtype_6895, 0);
  reader6895->definitionModule = modulename;
  writer6895->definitionModule = modulename;
  reader6895->definitionLine = 1715;
  writer6895->definitionLine = 1715;
}
obj6890->flags |= OFLAG_MUTABLE;
adddatum2(obj6890, alloc_Undefined(), 4);
if (objclass6890 == NULL) {
  Method *reader6896 = addmethodrealflags(obj6890, "isBindingOccurrence", &reader_ast_isBindingOccurrence_6896, 0);
  Method *writer6896 = addmethodrealflags(obj6890, "isBindingOccurrence:=(1)", &writer_ast_isBindingOccurrence_6896, 0);
  reader6896->definitionModule = modulename;
  writer6896->definitionModule = modulename;
  reader6896->definitionLine = 1716;
  writer6896->definitionLine = 1716;
}
obj6890->flags |= OFLAG_MUTABLE;
adddatum2(obj6890, alloc_Undefined(), 5);
if (objclass6890 == NULL) {
  Method *reader6897 = addmethodrealflags(obj6890, "isAssigned", &reader_ast_isAssigned_6897, 0);
  Method *writer6897 = addmethodrealflags(obj6890, "isAssigned:=(1)", &writer_ast_isAssigned_6897, 0);
  reader6897->definitionModule = modulename;
  writer6897->definitionModule = modulename;
  reader6897->definitionLine = 1717;
  writer6897->definitionLine = 1717;
}
obj6890->flags |= OFLAG_MUTABLE;
adddatum2(obj6890, alloc_Undefined(), 6);
if (objclass6890 == NULL) {
  Method *reader6898 = addmethodrealflags(obj6890, "inRequest", &reader_ast_inRequest_6898, 0);
  Method *writer6898 = addmethodrealflags(obj6890, "inRequest:=(1)", &writer_ast_inRequest_6898, 0);
  reader6898->definitionModule = modulename;
  writer6898->definitionModule = modulename;
  reader6898->definitionLine = 1718;
  writer6898->definitionLine = 1718;
}
obj6890->flags |= OFLAG_MUTABLE;
adddatum2(obj6890, alloc_Undefined(), 7);
if (objclass6890 == NULL) {
  Method *reader6899 = addmethodrealflags(obj6890, "generics", &reader_ast_generics_6899, 0);
  Method *writer6899 = addmethodrealflags(obj6890, "generics:=(1)", &writer_ast_generics_6899, 0);
  reader6899->definitionModule = modulename;
  writer6899->definitionModule = modulename;
  reader6899->definitionLine = 1719;
  writer6899->definitionLine = 1719;
}
obj6890->flags |= OFLAG_MUTABLE;
adddatum2(obj6890, alloc_Undefined(), 8);
if (objclass6890 == NULL) {
  Method *reader6900 = addmethodrealflags(obj6890, "isDeclaredByParent", &reader_ast_isDeclaredByParent_6900, 0);
  Method *writer6900 = addmethodrealflags(obj6890, "isDeclaredByParent:=(1)", &writer_ast_isDeclaredByParent_6900, 0);
  reader6900->definitionModule = modulename;
  writer6900->definitionModule = modulename;
  reader6900->definitionLine = 1720;
  writer6900->definitionLine = 1720;
}
obj6890->flags |= OFLAG_MUTABLE;
adddatum2(obj6890, alloc_Undefined(), 9);
// method "nameString"
  struct UserObject *uo6901 = (struct UserObject*)obj6890;
  uo6901->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString6901 = addmethod2pos(obj6890, "nameString", &meth_ast_nameString6901, 10);
  int argcv_meth_ast_nameString6901[] = {0};
  meth_meth_ast_nameString6901->type = alloc_MethodType(1, argcv_meth_ast_nameString6901);
  meth_meth_ast_nameString6901->definitionModule = modulename;
  meth_meth_ast_nameString6901->definitionLine = 1722;
if (objclass6890 == NULL) {
  Method *reader6904 = addmethodrealflags(obj6890, "canonicalName", &reader_ast_canonicalName_6904, 0);
  Method *writer6904 = addmethodrealflags(obj6890, "canonicalName:=(1)", &writer_ast_canonicalName_6904, 0);
  reader6904->definitionModule = modulename;
  writer6904->definitionModule = modulename;
  reader6904->definitionLine = 1723;
  writer6904->definitionLine = 1723;
}
obj6890->flags |= OFLAG_MUTABLE;
adddatum2(obj6890, alloc_Undefined(), 11);
// method "quoted"
  struct UserObject *uo6905 = (struct UserObject*)obj6890;
  uo6905->data[12] = emptyclosure;
  Method *meth_meth_ast_quoted6905 = addmethod2pos(obj6890, "quoted", &meth_ast_quoted6905, 12);
  int argcv_meth_ast_quoted6905[] = {0};
  meth_meth_ast_quoted6905->type = alloc_MethodType(1, argcv_meth_ast_quoted6905);
  meth_meth_ast_quoted6905->definitionModule = modulename;
  meth_meth_ast_quoted6905->definitionLine = 1724;
// method "isIdentifier"
  struct UserObject *uo6910 = (struct UserObject*)obj6890;
  uo6910->data[13] = emptyclosure;
  Method *meth_meth_ast_isIdentifier6910 = addmethod2pos(obj6890, "isIdentifier", &meth_ast_isIdentifier6910, 13);
  int argcv_meth_ast_isIdentifier6910[] = {0};
  meth_meth_ast_isIdentifier6910->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier6910);
  meth_meth_ast_isIdentifier6910->definitionModule = modulename;
  meth_meth_ast_isIdentifier6910->definitionLine = 1725;
// method "isSelf"
  struct UserObject *uo6912 = (struct UserObject*)obj6890;
  uo6912->data[14] = emptyclosure;
  Method *meth_meth_ast_isSelf6912 = addmethod2pos(obj6890, "isSelf", &meth_ast_isSelf6912, 14);
  int argcv_meth_ast_isSelf6912[] = {0};
  meth_meth_ast_isSelf6912->type = alloc_MethodType(1, argcv_meth_ast_isSelf6912);
  meth_meth_ast_isSelf6912->definitionModule = modulename;
  meth_meth_ast_isSelf6912->definitionLine = 1727;
// method "isSuper"
  struct UserObject *uo6919 = (struct UserObject*)obj6890;
  uo6919->data[15] = emptyclosure;
  Method *meth_meth_ast_isSuper6919 = addmethod2pos(obj6890, "isSuper", &meth_ast_isSuper6919, 15);
  int argcv_meth_ast_isSuper6919[] = {0};
  meth_meth_ast_isSuper6919->type = alloc_MethodType(1, argcv_meth_ast_isSuper6919);
  meth_meth_ast_isSuper6919->definitionModule = modulename;
  meth_meth_ast_isSuper6919->definitionLine = 1728;
// method "isPrelude"
  struct UserObject *uo6926 = (struct UserObject*)obj6890;
  uo6926->data[16] = emptyclosure;
  Method *meth_meth_ast_isPrelude6926 = addmethod2pos(obj6890, "isPrelude", &meth_ast_isPrelude6926, 16);
  int argcv_meth_ast_isPrelude6926[] = {0};
  meth_meth_ast_isPrelude6926->type = alloc_MethodType(1, argcv_meth_ast_isPrelude6926);
  meth_meth_ast_isPrelude6926->definitionModule = modulename;
  meth_meth_ast_isPrelude6926->definitionLine = 1729;
// method "isOuter"
  struct UserObject *uo6933 = (struct UserObject*)obj6890;
  uo6933->data[17] = emptyclosure;
  Method *meth_meth_ast_isOuter6933 = addmethod2pos(obj6890, "isOuter", &meth_ast_isOuter6933, 17);
  int argcv_meth_ast_isOuter6933[] = {0};
  meth_meth_ast_isOuter6933->type = alloc_MethodType(1, argcv_meth_ast_isOuter6933);
  meth_meth_ast_isOuter6933->definitionModule = modulename;
  meth_meth_ast_isOuter6933->definitionLine = 1730;
// method "isSelfOrOuter"
  struct UserObject *uo6940 = (struct UserObject*)obj6890;
  uo6940->data[18] = emptyclosure;
  Method *meth_meth_ast_isSelfOrOuter6940 = addmethod2pos(obj6890, "isSelfOrOuter", &meth_ast_isSelfOrOuter6940, 18);
  int argcv_meth_ast_isSelfOrOuter6940[] = {0};
  meth_meth_ast_isSelfOrOuter6940->type = alloc_MethodType(1, argcv_meth_ast_isSelfOrOuter6940);
  meth_meth_ast_isSelfOrOuter6940->definitionModule = modulename;
  meth_meth_ast_isSelfOrOuter6940->definitionLine = 1731;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo6950 = (struct UserObject*)obj6890;
  uo6950->data[19] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier6950 = addmethod2pos(obj6890, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier6950, 19);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier6950[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier6950->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier6950);
  meth_meth_ast_isAppliedOccurenceOfIdentifier6950->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier6950->definitionLine = 1736;
// method "declarationKindWithAncestors(_)"
  struct UserObject *uo6959 = (struct UserObject*)obj6890;
  uo6959->data[20] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_6959 = addmethod2pos(obj6890, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_6959, 20);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_6959[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6959->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_6959);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6959->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_6959->definitionLine = 1743;
// method "inTypePositionWithAncestors(_)"
  struct UserObject *uo6964 = (struct UserObject*)obj6890;
  uo6964->data[21] = emptyclosure;
  Method *meth_meth_ast_inTypePositionWithAncestors_40_1_41_6964 = addmethod2pos(obj6890, "inTypePositionWithAncestors(1)", &meth_ast_inTypePositionWithAncestors_40_1_41_6964, 21);
  int argcv_meth_ast_inTypePositionWithAncestors_40_1_41_6964[] = {1};
  meth_meth_ast_inTypePositionWithAncestors_40_1_41_6964->type = alloc_MethodType(1, argcv_meth_ast_inTypePositionWithAncestors_40_1_41_6964);
  meth_meth_ast_inTypePositionWithAncestors_40_1_41_6964->definitionModule = modulename;
  meth_meth_ast_inTypePositionWithAncestors_40_1_41_6964->definitionLine = 1746;
// method "usesAsType(_)"
  struct UserObject *uo6973 = (struct UserObject*)obj6890;
  uo6973->data[22] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_6973 = addmethod2pos(obj6890, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_6973, 22);
  int argcv_meth_ast_usesAsType_40_1_41_6973[] = {1};
  meth_meth_ast_usesAsType_40_1_41_6973->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_6973);
  meth_meth_ast_usesAsType_40_1_41_6973->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_6973->definitionLine = 1753;
// method "accept(_)from(_)"
  struct UserObject *uo6979 = (struct UserObject*)obj6890;
  uo6979->data[23] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_6979 = addmethod2pos(obj6890, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_6979, 23);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_6979[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_6979->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_6979);
  meth_meth_ast_accept_40_1_41_from_40_1_41_6979->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_6979->definitionLine = 1756;
// method "map(_)ancestors(_)"
  struct UserObject *uo6996 = (struct UserObject*)obj6890;
  uo6996->data[24] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_6996 = addmethod2pos(obj6890, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_6996, 24);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6996[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6996->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_6996);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6996->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_6996->definitionLine = 1764;
// method "pretty(_)"
  struct UserObject *uo7013 = (struct UserObject*)obj6890;
  uo7013->data[25] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_7013 = addmethod2pos(obj6890, "pretty(1)", &meth_ast_pretty_40_1_41_7013, 25);
  int argcv_meth_ast_pretty_40_1_41_7013[] = {1};
  meth_meth_ast_pretty_40_1_41_7013->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_7013);
  meth_meth_ast_pretty_40_1_41_7013->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_7013->definitionLine = 1770;
// method "toGrace(_)"
  struct UserObject *uo7148 = (struct UserObject*)obj6890;
  uo7148->data[26] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7148 = addmethod2pos(obj6890, "toGrace(1)", &meth_ast_toGrace_40_1_41_7148, 26);
  int argcv_meth_ast_toGrace_40_1_41_7148[] = {1};
  meth_meth_ast_toGrace_40_1_41_7148->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7148);
meth_meth_ast_toGrace_40_1_41_7148->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7148->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7148->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7148->definitionLine = 1795;
// method "asString"
  struct UserObject *uo7241 = (struct UserObject*)obj6890;
  uo7241->data[27] = emptyclosure;
  Method *meth_meth_ast_asString7241 = addmethod2pos(obj6890, "asString", &meth_ast_asString7241, 27);
  int argcv_meth_ast_asString7241[] = {0};
  meth_meth_ast_asString7241->type = alloc_MethodType(1, argcv_meth_ast_asString7241);
  meth_meth_ast_asString7241->definitionModule = modulename;
  meth_meth_ast_asString7241->definitionLine = 1815;
// method "shallowCopy"
  block_savedest(obj6890);
  Object closure7265 = createclosure(1, "shallowCopy");
  setclosureframe(closure7265, stackframe);
  addtoclosure(closure7265, var_identifierNode);
  struct UserObject *uo7265 = (struct UserObject*)obj6890;
  uo7265->data[28] = (Object)closure7265;
  Method *meth_meth_ast_shallowCopy7265 = addmethod2pos(obj6890, "shallowCopy", &meth_ast_shallowCopy7265, 28);
  int argcv_meth_ast_shallowCopy7265[] = {0};
  meth_meth_ast_shallowCopy7265->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7265);
  meth_meth_ast_shallowCopy7265->definitionModule = modulename;
  meth_meth_ast_shallowCopy7265->definitionLine = 1822;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo7273 = (struct UserObject*)obj6890;
  uo7273->data[29] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_7273 = addmethod2pos(obj6890, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_7273, 29);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_7273[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_7273->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_7273);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_7273->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_7273->definitionLine = 1825;
// method "statementName"
  struct UserObject *uo7296 = (struct UserObject*)obj6890;
  uo7296->data[30] = emptyclosure;
  Method *meth_meth_ast_statementName7296 = addmethod2pos(obj6890, "statementName", &meth_ast_statementName7296, 30);
  int argcv_meth_ast_statementName7296[] = {0};
  meth_meth_ast_statementName7296->type = alloc_MethodType(1, argcv_meth_ast_statementName7296);
  meth_meth_ast_statementName7296->definitionModule = modulename;
  meth_meth_ast_statementName7296->definitionLine = 1834;
  sourceObject = obj6890;
// Begin line 1711
  setline(1711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7298 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7299 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7300 = gc_frame_new();
// call case 3: self.outer request
  Object call7301 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7300);
// compiled member node returning call7301 (depth = 5)
  Object call7302 = callmethodflags(call7301, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7299);
// compiled member node returning call7302 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7303 = callmethodflags(call7302, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7298);
// compiled call node returning call7303 (depth = 3)
  struct UserObject *obj6890_uo = (struct UserObject *)obj6890;
  obj6890_uo->super = call7303;
  sourceObject = obj6890;
// Begin line 1712
  setline(1712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7304 == NULL) {
    strlit7304 = alloc_String("identifier");
    gc_root(strlit7304);
  }
// compiled string node returning strlit7304 (depth = 3)
  adddatum2(obj6890, strlit7304, 1);
  sourceObject = obj6890;
// Begin line 1713
  setline(1713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name (depth = 3)
  adddatum2(obj6890, *var_name, 2);
  sourceObject = obj6890;
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7305 = alloc_Boolean(0);
// compiled identifier node returning bool7305 (depth = 3)
  adddatum2(obj6890, bool7305, 3);
  sourceObject = obj6890;
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj6890, *var_dtype_39_, 4);
  sourceObject = obj6890;
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7306 = alloc_Boolean(0);
// compiled identifier node returning bool7306 (depth = 3)
  adddatum2(obj6890, bool7306, 5);
  sourceObject = obj6890;
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7307 = alloc_Boolean(0);
// compiled identifier node returning bool7307 (depth = 3)
  adddatum2(obj6890, bool7307, 6);
  sourceObject = obj6890;
// Begin line 1718
  setline(1718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7308 = alloc_Boolean(0);
// compiled identifier node returning bool7308 (depth = 3)
  adddatum2(obj6890, bool7308, 7);
  sourceObject = obj6890;
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7309 = alloc_Boolean(0);
// compiled identifier node returning bool7309 (depth = 3)
  adddatum2(obj6890, bool7309, 8);
  sourceObject = obj6890;
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7310 = alloc_Boolean(0);
// compiled identifier node returning bool7310 (depth = 3)
  adddatum2(obj6890, bool7310, 9);
  sourceObject = obj6890;
  sourceObject = obj6890;
// Begin line 1723
  setline(1723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7311 = gc_frame_new();
// call case 4: self request
  Object call7312 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7311);
// compiled member node returning call7312 (depth = 3)
  adddatum2(obj6890, call7312, 11);
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  sourceObject = obj6890;
  objclass6890 = obj6890->class;
  objclass6890->definitionModule = modulename;
  objclass6890->definitionLine = 1710;
  (*(struct UserObject *)self).data[0] = lowerouter6890;
  self = oldself6890;
  selfslot = oldselfslot6890;
  stackframe = oldstackframe6890;
  gc_frame_end(frame);
  return obj6890;
}
Object meth_ast_identifierNode7314(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "identifierNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1702
  setline(1702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  gc_frame_end(frame);
  return *var_identifierNode;
}
Object meth_ast_typeType7319(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1838
  setline(1838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeType (depth = 3)
  gc_frame_end(frame);
  return *var_typeType;
}
Object meth_ast_unknownType7323(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "unknownType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1839
  setline(1839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_unknownType (depth = 3)
  gc_frame_end(frame);
  return *var_unknownType;
}
Object meth_ast_new_40_1_41_scope_40_1_41_7326(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)scope(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 1843
  setline(1843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7327 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 4: self request
  params[0] = *var_v;
  partcv[0] = 1;
  Object call7328 = callmethodflags(self, "new(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7327);
// compiled call node returning call7328 (depth = 4)
  *var_result = call7328;
  if (call7328 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1844
  setline(1844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7329 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call7330 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7329);
// compiled call node returning call7330 (depth = 3)
// Begin line 1845
  setline(1845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_accept_40_1_41_from_40_1_41_7336(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7337 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7338 = callmethodflags(*var_visitor, "visitString(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7337);
// compiled call node returning call7338 (depth = 3)
  gc_frame_end(frame);
  return call7338;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_7339(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7340 = gc_frame_new();
// call case 4: self request
  Object call7341 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7340);
// compiled member node returning call7341 (depth = 4)
  *var_n = call7341;
  if (call7341 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7342 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7343 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7342);
// compiled call node returning call7343 (depth = 4)
  *var_newChain = call7343;
  if (call7343 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7344 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7345 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7344);
// compiled call node returning call7345 (depth = 3)
  gc_frame_end(frame);
  return call7345;
}
Object meth_ast_pretty_40_1_41_7346(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7348 == NULL) {
    strlit7348 = alloc_String(")");
    gc_root(strlit7348);
  }
// compiled string node returning strlit7348 (depth = 4)
  int op_slot_right_7347 = gc_frame_newslot(strlit7348);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7351 = gc_frame_new();
// call case 4: self request
  Object call7352 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7351);
// compiled member node returning call7352 (depth = 5)
  int op_slot_right_7350 = gc_frame_newslot(call7352);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7355 == NULL) {
    strlit7355 = alloc_String("(");
    gc_root(strlit7355);
  }
// compiled string node returning strlit7355 (depth = 6)
  int op_slot_right_7354 = gc_frame_newslot(strlit7355);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7358 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7359 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7358);
// compiled call node returning call7359 (depth = 7)
  int op_slot_right_7357 = gc_frame_newslot(call7359);
// starting to compile string node (depth = 7)
  if (strlit7361 == NULL) {
    strlit7361 = alloc_String("");
    gc_root(strlit7361);
  }
// compiled string node returning strlit7361 (depth = 7)
  int op_slot_left_7357 = gc_frame_newslot(strlit7361);
  params[0] = call7359;
  partcv[0] = 1;
  Object opresult7362 = callmethod(strlit7361, "++(1)", 1, partcv, params);
// compiled op node returning opresult7362 (depth = 6)
  int op_slot_left_7354 = gc_frame_newslot(opresult7362);
  params[0] = strlit7355;
  partcv[0] = 1;
  Object opresult7363 = callmethod(opresult7362, "++(1)", 1, partcv, params);
// compiled op node returning opresult7363 (depth = 5)
  int op_slot_left_7350 = gc_frame_newslot(opresult7363);
  params[0] = call7352;
  partcv[0] = 1;
  Object opresult7364 = callmethod(opresult7363, "++(1)", 1, partcv, params);
// compiled op node returning opresult7364 (depth = 4)
  int op_slot_left_7347 = gc_frame_newslot(opresult7364);
  params[0] = strlit7348;
  partcv[0] = 1;
  Object opresult7365 = callmethod(opresult7364, "++(1)", 1, partcv, params);
// compiled op node returning opresult7365 (depth = 3)
  gc_frame_end(frame);
  return opresult7365;
}
Object meth_ast_toGrace_40_1_41_7366(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_q = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "q");
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7367 == NULL) {
    strlit7367 = alloc_String("""\x22""");
    gc_root(strlit7367);
  }
// compiled string node returning strlit7367 (depth = 4)
  *var_q = strlit7367;
  if (strlit7367 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_q (depth = 4)
  int op_slot_right_7368 = gc_frame_newslot(*var_q);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7371 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7372 = gc_frame_new();
// call case 4: self request
  Object call7373 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7372);
// compiled member node returning call7373 (depth = 6)
  Object call7374 = callmethodflags(call7373, "quoted", 0, partcv, params, 0);
  gc_frame_end(callframe7371);
// compiled member node returning call7374 (depth = 5)
  int op_slot_right_7370 = gc_frame_newslot(call7374);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_q (depth = 5)
  int op_slot_left_7370 = gc_frame_newslot(*var_q);
  params[0] = call7374;
  partcv[0] = 1;
  Object opresult7376 = callmethod(*var_q, "++(1)", 1, partcv, params);
// compiled op node returning opresult7376 (depth = 4)
  int op_slot_left_7368 = gc_frame_newslot(opresult7376);
  params[0] = *var_q;
  partcv[0] = 1;
  Object opresult7377 = callmethod(opresult7376, "++(1)", 1, partcv, params);
// compiled op node returning opresult7377 (depth = 3)
  gc_frame_end(frame);
  return opresult7377;
}
Object meth_ast_asString7378(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7380 == NULL) {
    strlit7380 = alloc_String("");
    gc_root(strlit7380);
  }
// compiled string node returning strlit7380 (depth = 4)
  int op_slot_right_7379 = gc_frame_newslot(strlit7380);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7383 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num7384 = alloc_Float64(0);
// compiled num node returning num7384 (depth = 6)
  gc_frame_newslot(num7384);
// call case 4: self request
  params[0] = num7384;
  partcv[0] = 1;
  Object call7385 = callmethodflags(self, "toGrace(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7383);
// compiled call node returning call7385 (depth = 5)
  int op_slot_right_7382 = gc_frame_newslot(call7385);
// starting to compile string node (depth = 5)
  if (strlit7387 == NULL) {
    strlit7387 = alloc_String("string ");
    gc_root(strlit7387);
  }
// compiled string node returning strlit7387 (depth = 5)
  int op_slot_left_7382 = gc_frame_newslot(strlit7387);
  params[0] = call7385;
  partcv[0] = 1;
  Object opresult7388 = callmethod(strlit7387, "++(1)", 1, partcv, params);
// compiled op node returning opresult7388 (depth = 4)
  int op_slot_left_7379 = gc_frame_newslot(opresult7388);
  params[0] = strlit7380;
  partcv[0] = 1;
  Object opresult7389 = callmethod(opresult7388, "++(1)", 1, partcv, params);
// compiled op node returning opresult7389 (depth = 3)
  gc_frame_end(frame);
  return opresult7389;
}
Object meth_ast_shallowCopy7390(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1869
  setline(1869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7391 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe7392 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7393 = gc_frame_new();
// call case 4: self request
  Object call7394 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7393);
// compiled member node returning call7394 (depth = 5)
  gc_frame_newslot(call7394);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_stringNode (depth = 5)
  params[0] = call7394;
  partcv[0] = 1;
  Object call7395 = callmethodflags(*var_stringNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7392);
// compiled call node returning call7395 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7396 = callmethodflags(call7395, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7391);
// compiled call node returning call7396 (depth = 3)
  gc_frame_end(frame);
  return call7396;
}
Object meth_ast_statementName7397(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1871
  setline(1871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7398 == NULL) {
    strlit7398 = alloc_String("expression");
    gc_root(strlit7398);
  }
// compiled string node returning strlit7398 (depth = 3)
  gc_frame_end(frame);
  return strlit7398;
}
Object meth_ast_isDelimited7399(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDelimited");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1872
  setline(1872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7400 = alloc_Boolean(1);
// compiled identifier node returning bool7400 (depth = 3)
  gc_frame_end(frame);
  return bool7400;
}
Object meth_ast_new_40_1_41_7331(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7332 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7332 = alloc_userobj2(11,11, objclass7332);
  gc_frame_newslot(obj7332);
if (objclass7332 == NULL) {
  glfree(obj7332->class->name);
  obj7332->class->name = "stringNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7332, self, 0);
  addmethodreal(obj7332,"outer", &reader_ast_outer_7333);
  Object oldself7332 = self;
  struct StackFrameObject *oldstackframe7332 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7332);
  gc_frame_newslot((Object)stackframe);
  self = obj7332;
  Object *oldselfslot7332 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7332 = (*(struct UserObject *)self).data[0], lowerouter7332 = thisouter7332;
  if (inheritingObject7332) {
    struct UserObject *inho7332 = (struct UserObject *)inheritingObject7332;
    while (inho7332->super != GraceDefaultObject) inho7332 = (struct UserObject *)inho7332->super;
    inho7332->super = obj7332;
    self = inheritingObject7332;
    *selfslot = self;
    lowerouter7332 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7332;
  }
if (objclass7332 == NULL) {
  Method *reader7334 = addmethodrealflags(obj7332, "kind",&reader_ast_kind_7334, MFLAG_DEF);
  reader7334->definitionModule = modulename;
  reader7334->definitionLine = 1850;
}
adddatum2(obj7332, alloc_Undefined(), 1);
if (objclass7332 == NULL) {
  Method *reader7335 = addmethodrealflags(obj7332, "value", &reader_ast_value_7335, 0);
  Method *writer7335 = addmethodrealflags(obj7332, "value:=(1)", &writer_ast_value_7335, 0);
  reader7335->definitionModule = modulename;
  writer7335->definitionModule = modulename;
  reader7335->definitionLine = 1851;
  writer7335->definitionLine = 1851;
}
obj7332->flags |= OFLAG_MUTABLE;
adddatum2(obj7332, alloc_Undefined(), 2);
// method "accept(_)from(_)"
  struct UserObject *uo7336 = (struct UserObject*)obj7332;
  uo7336->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_7336 = addmethod2pos(obj7332, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_7336, 3);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_7336[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_7336->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_7336);
  meth_meth_ast_accept_40_1_41_from_40_1_41_7336->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_7336->definitionLine = 1852;
// method "map(_)ancestors(_)"
  struct UserObject *uo7339 = (struct UserObject*)obj7332;
  uo7339->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_7339 = addmethod2pos(obj7332, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_7339, 4);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7339[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7339->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7339);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7339->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7339->definitionLine = 1855;
// method "pretty(_)"
  struct UserObject *uo7346 = (struct UserObject*)obj7332;
  uo7346->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_7346 = addmethod2pos(obj7332, "pretty(1)", &meth_ast_pretty_40_1_41_7346, 5);
  int argcv_meth_ast_pretty_40_1_41_7346[] = {1};
  meth_meth_ast_pretty_40_1_41_7346->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_7346);
  meth_meth_ast_pretty_40_1_41_7346->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_7346->definitionLine = 1860;
// method "toGrace(_)"
  struct UserObject *uo7366 = (struct UserObject*)obj7332;
  uo7366->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7366 = addmethod2pos(obj7332, "toGrace(1)", &meth_ast_toGrace_40_1_41_7366, 6);
  int argcv_meth_ast_toGrace_40_1_41_7366[] = {1};
  meth_meth_ast_toGrace_40_1_41_7366->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7366);
meth_meth_ast_toGrace_40_1_41_7366->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7366->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7366->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7366->definitionLine = 1863;
// method "asString"
  struct UserObject *uo7378 = (struct UserObject*)obj7332;
  uo7378->data[7] = emptyclosure;
  Method *meth_meth_ast_asString7378 = addmethod2pos(obj7332, "asString", &meth_ast_asString7378, 7);
  int argcv_meth_ast_asString7378[] = {0};
  meth_meth_ast_asString7378->type = alloc_MethodType(1, argcv_meth_ast_asString7378);
  meth_meth_ast_asString7378->definitionModule = modulename;
  meth_meth_ast_asString7378->definitionLine = 1867;
// method "shallowCopy"
  block_savedest(obj7332);
  Object closure7390 = createclosure(1, "shallowCopy");
  setclosureframe(closure7390, stackframe);
  addtoclosure(closure7390, var_stringNode);
  struct UserObject *uo7390 = (struct UserObject*)obj7332;
  uo7390->data[8] = (Object)closure7390;
  Method *meth_meth_ast_shallowCopy7390 = addmethod2pos(obj7332, "shallowCopy", &meth_ast_shallowCopy7390, 8);
  int argcv_meth_ast_shallowCopy7390[] = {0};
  meth_meth_ast_shallowCopy7390->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7390);
  meth_meth_ast_shallowCopy7390->definitionModule = modulename;
  meth_meth_ast_shallowCopy7390->definitionLine = 1868;
// method "statementName"
  struct UserObject *uo7397 = (struct UserObject*)obj7332;
  uo7397->data[9] = emptyclosure;
  Method *meth_meth_ast_statementName7397 = addmethod2pos(obj7332, "statementName", &meth_ast_statementName7397, 9);
  int argcv_meth_ast_statementName7397[] = {0};
  meth_meth_ast_statementName7397->type = alloc_MethodType(1, argcv_meth_ast_statementName7397);
  meth_meth_ast_statementName7397->definitionModule = modulename;
  meth_meth_ast_statementName7397->definitionLine = 1871;
// method "isDelimited"
  struct UserObject *uo7399 = (struct UserObject*)obj7332;
  uo7399->data[10] = emptyclosure;
  Method *meth_meth_ast_isDelimited7399 = addmethod2pos(obj7332, "isDelimited", &meth_ast_isDelimited7399, 10);
  int argcv_meth_ast_isDelimited7399[] = {0};
  meth_meth_ast_isDelimited7399->type = alloc_MethodType(1, argcv_meth_ast_isDelimited7399);
  meth_meth_ast_isDelimited7399->definitionModule = modulename;
  meth_meth_ast_isDelimited7399->definitionLine = 1872;
  sourceObject = obj7332;
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7401 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7402 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7403 = gc_frame_new();
// call case 3: self.outer request
  Object call7404 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7403);
// compiled member node returning call7404 (depth = 5)
  Object call7405 = callmethodflags(call7404, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7402);
// compiled member node returning call7405 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7406 = callmethodflags(call7405, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7401);
// compiled call node returning call7406 (depth = 3)
  struct UserObject *obj7332_uo = (struct UserObject *)obj7332;
  obj7332_uo->super = call7406;
  sourceObject = obj7332;
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7407 == NULL) {
    strlit7407 = alloc_String("string");
    gc_root(strlit7407);
  }
// compiled string node returning strlit7407 (depth = 3)
  adddatum2(obj7332, strlit7407, 1);
  sourceObject = obj7332;
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  adddatum2(obj7332, *var_v, 2);
  sourceObject = obj7332;
  sourceObject = obj7332;
  sourceObject = obj7332;
  sourceObject = obj7332;
  sourceObject = obj7332;
  sourceObject = obj7332;
  sourceObject = obj7332;
  sourceObject = obj7332;
  objclass7332 = obj7332->class;
  objclass7332->definitionModule = modulename;
  objclass7332->definitionLine = 1848;
  (*(struct UserObject *)self).data[0] = lowerouter7332;
  self = oldself7332;
  selfslot = oldselfslot7332;
  stackframe = oldstackframe7332;
  gc_frame_end(frame);
  return obj7332;
}
Object meth_ast_new_40_1_41_7331_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7332 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7332 = alloc_userobj2(11,11, objclass7332);
  gc_frame_newslot(obj7332);
if (objclass7332 == NULL) {
  glfree(obj7332->class->name);
  obj7332->class->name = "stringNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7332, self, 0);
  addmethodreal(obj7332,"outer", &reader_ast_outer_7333);
  Object oldself7332 = self;
  struct StackFrameObject *oldstackframe7332 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7332);
  gc_frame_newslot((Object)stackframe);
  self = obj7332;
  Object *oldselfslot7332 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7332 = (*(struct UserObject *)self).data[0], lowerouter7332 = thisouter7332;
  if (inheritingObject7332) {
    struct UserObject *inho7332 = (struct UserObject *)inheritingObject7332;
    while (inho7332->super != GraceDefaultObject) inho7332 = (struct UserObject *)inho7332->super;
    inho7332->super = obj7332;
    self = inheritingObject7332;
    *selfslot = self;
    lowerouter7332 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7332;
  }
if (objclass7332 == NULL) {
  Method *reader7334 = addmethodrealflags(obj7332, "kind",&reader_ast_kind_7334, MFLAG_DEF);
  reader7334->definitionModule = modulename;
  reader7334->definitionLine = 1850;
}
adddatum2(obj7332, alloc_Undefined(), 1);
if (objclass7332 == NULL) {
  Method *reader7335 = addmethodrealflags(obj7332, "value", &reader_ast_value_7335, 0);
  Method *writer7335 = addmethodrealflags(obj7332, "value:=(1)", &writer_ast_value_7335, 0);
  reader7335->definitionModule = modulename;
  writer7335->definitionModule = modulename;
  reader7335->definitionLine = 1851;
  writer7335->definitionLine = 1851;
}
obj7332->flags |= OFLAG_MUTABLE;
adddatum2(obj7332, alloc_Undefined(), 2);
// method "accept(_)from(_)"
  struct UserObject *uo7336 = (struct UserObject*)obj7332;
  uo7336->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_7336 = addmethod2pos(obj7332, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_7336, 3);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_7336[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_7336->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_7336);
  meth_meth_ast_accept_40_1_41_from_40_1_41_7336->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_7336->definitionLine = 1852;
// method "map(_)ancestors(_)"
  struct UserObject *uo7339 = (struct UserObject*)obj7332;
  uo7339->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_7339 = addmethod2pos(obj7332, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_7339, 4);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7339[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7339->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7339);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7339->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7339->definitionLine = 1855;
// method "pretty(_)"
  struct UserObject *uo7346 = (struct UserObject*)obj7332;
  uo7346->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_7346 = addmethod2pos(obj7332, "pretty(1)", &meth_ast_pretty_40_1_41_7346, 5);
  int argcv_meth_ast_pretty_40_1_41_7346[] = {1};
  meth_meth_ast_pretty_40_1_41_7346->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_7346);
  meth_meth_ast_pretty_40_1_41_7346->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_7346->definitionLine = 1860;
// method "toGrace(_)"
  struct UserObject *uo7366 = (struct UserObject*)obj7332;
  uo7366->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7366 = addmethod2pos(obj7332, "toGrace(1)", &meth_ast_toGrace_40_1_41_7366, 6);
  int argcv_meth_ast_toGrace_40_1_41_7366[] = {1};
  meth_meth_ast_toGrace_40_1_41_7366->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7366);
meth_meth_ast_toGrace_40_1_41_7366->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7366->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7366->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7366->definitionLine = 1863;
// method "asString"
  struct UserObject *uo7378 = (struct UserObject*)obj7332;
  uo7378->data[7] = emptyclosure;
  Method *meth_meth_ast_asString7378 = addmethod2pos(obj7332, "asString", &meth_ast_asString7378, 7);
  int argcv_meth_ast_asString7378[] = {0};
  meth_meth_ast_asString7378->type = alloc_MethodType(1, argcv_meth_ast_asString7378);
  meth_meth_ast_asString7378->definitionModule = modulename;
  meth_meth_ast_asString7378->definitionLine = 1867;
// method "shallowCopy"
  block_savedest(obj7332);
  Object closure7390 = createclosure(1, "shallowCopy");
  setclosureframe(closure7390, stackframe);
  addtoclosure(closure7390, var_stringNode);
  struct UserObject *uo7390 = (struct UserObject*)obj7332;
  uo7390->data[8] = (Object)closure7390;
  Method *meth_meth_ast_shallowCopy7390 = addmethod2pos(obj7332, "shallowCopy", &meth_ast_shallowCopy7390, 8);
  int argcv_meth_ast_shallowCopy7390[] = {0};
  meth_meth_ast_shallowCopy7390->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7390);
  meth_meth_ast_shallowCopy7390->definitionModule = modulename;
  meth_meth_ast_shallowCopy7390->definitionLine = 1868;
// method "statementName"
  struct UserObject *uo7397 = (struct UserObject*)obj7332;
  uo7397->data[9] = emptyclosure;
  Method *meth_meth_ast_statementName7397 = addmethod2pos(obj7332, "statementName", &meth_ast_statementName7397, 9);
  int argcv_meth_ast_statementName7397[] = {0};
  meth_meth_ast_statementName7397->type = alloc_MethodType(1, argcv_meth_ast_statementName7397);
  meth_meth_ast_statementName7397->definitionModule = modulename;
  meth_meth_ast_statementName7397->definitionLine = 1871;
// method "isDelimited"
  struct UserObject *uo7399 = (struct UserObject*)obj7332;
  uo7399->data[10] = emptyclosure;
  Method *meth_meth_ast_isDelimited7399 = addmethod2pos(obj7332, "isDelimited", &meth_ast_isDelimited7399, 10);
  int argcv_meth_ast_isDelimited7399[] = {0};
  meth_meth_ast_isDelimited7399->type = alloc_MethodType(1, argcv_meth_ast_isDelimited7399);
  meth_meth_ast_isDelimited7399->definitionModule = modulename;
  meth_meth_ast_isDelimited7399->definitionLine = 1872;
  sourceObject = obj7332;
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7401 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7402 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7403 = gc_frame_new();
// call case 3: self.outer request
  Object call7404 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7403);
// compiled member node returning call7404 (depth = 5)
  Object call7405 = callmethodflags(call7404, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7402);
// compiled member node returning call7405 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7406 = callmethodflags(call7405, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7401);
// compiled call node returning call7406 (depth = 3)
  struct UserObject *obj7332_uo = (struct UserObject *)obj7332;
  obj7332_uo->super = call7406;
  sourceObject = obj7332;
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7407 == NULL) {
    strlit7407 = alloc_String("string");
    gc_root(strlit7407);
  }
// compiled string node returning strlit7407 (depth = 3)
  adddatum2(obj7332, strlit7407, 1);
  sourceObject = obj7332;
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  adddatum2(obj7332, *var_v, 2);
  sourceObject = obj7332;
  sourceObject = obj7332;
  sourceObject = obj7332;
  sourceObject = obj7332;
  sourceObject = obj7332;
  sourceObject = obj7332;
  sourceObject = obj7332;
  sourceObject = obj7332;
  objclass7332 = obj7332->class;
  objclass7332->definitionModule = modulename;
  objclass7332->definitionLine = 1848;
  (*(struct UserObject *)self).data[0] = lowerouter7332;
  self = oldself7332;
  selfslot = oldselfslot7332;
  stackframe = oldstackframe7332;
  gc_frame_end(frame);
  return obj7332;
}
Object meth_ast_stringNode7409(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "stringNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1841
  setline(1841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_stringNode (depth = 3)
  gc_frame_end(frame);
  return *var_stringNode;
}
Object meth_ast_accept_40_1_41_from_40_1_41_7417(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1881
  setline(1881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7418 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7419 = callmethodflags(*var_visitor, "visitNum(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7418);
// compiled call node returning call7419 (depth = 3)
  gc_frame_end(frame);
  return call7419;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_7420(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1884
  setline(1884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7421 = gc_frame_new();
// call case 4: self request
  Object call7422 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7421);
// compiled member node returning call7422 (depth = 4)
  *var_n = call7422;
  if (call7422 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7423 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7424 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7423);
// compiled call node returning call7424 (depth = 4)
  *var_newChain = call7424;
  if (call7424 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7425 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7426 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7425);
// compiled call node returning call7426 (depth = 3)
  gc_frame_end(frame);
  return call7426;
}
Object meth_ast_pretty_40_1_41_7427(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7429 == NULL) {
    strlit7429 = alloc_String(")");
    gc_root(strlit7429);
  }
// compiled string node returning strlit7429 (depth = 4)
  int op_slot_right_7428 = gc_frame_newslot(strlit7429);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7432 = gc_frame_new();
// call case 4: self request
  Object call7433 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7432);
// compiled member node returning call7433 (depth = 5)
  int op_slot_right_7431 = gc_frame_newslot(call7433);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7436 == NULL) {
    strlit7436 = alloc_String("(");
    gc_root(strlit7436);
  }
// compiled string node returning strlit7436 (depth = 6)
  int op_slot_right_7435 = gc_frame_newslot(strlit7436);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7439 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7440 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7439);
// compiled call node returning call7440 (depth = 7)
  int op_slot_right_7438 = gc_frame_newslot(call7440);
// starting to compile string node (depth = 7)
  if (strlit7442 == NULL) {
    strlit7442 = alloc_String("");
    gc_root(strlit7442);
  }
// compiled string node returning strlit7442 (depth = 7)
  int op_slot_left_7438 = gc_frame_newslot(strlit7442);
  params[0] = call7440;
  partcv[0] = 1;
  Object opresult7443 = callmethod(strlit7442, "++(1)", 1, partcv, params);
// compiled op node returning opresult7443 (depth = 6)
  int op_slot_left_7435 = gc_frame_newslot(opresult7443);
  params[0] = strlit7436;
  partcv[0] = 1;
  Object opresult7444 = callmethod(opresult7443, "++(1)", 1, partcv, params);
// compiled op node returning opresult7444 (depth = 5)
  int op_slot_left_7431 = gc_frame_newslot(opresult7444);
  params[0] = call7433;
  partcv[0] = 1;
  Object opresult7445 = callmethod(opresult7444, "++(1)", 1, partcv, params);
// compiled op node returning opresult7445 (depth = 4)
  int op_slot_left_7428 = gc_frame_newslot(opresult7445);
  params[0] = strlit7429;
  partcv[0] = 1;
  Object opresult7446 = callmethod(opresult7445, "++(1)", 1, partcv, params);
// compiled op node returning opresult7446 (depth = 3)
  gc_frame_end(frame);
  return opresult7446;
}
Object meth_ast_toGrace_40_1_41_7447(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe7448 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7449 = gc_frame_new();
// call case 4: self request
  Object call7450 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7449);
// compiled member node returning call7450 (depth = 4)
  Object call7451 = callmethodflags(call7450, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe7448);
// compiled member node returning call7451 (depth = 3)
  gc_frame_end(frame);
  return call7451;
}
Object meth_ast_asString7452(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7454 == NULL) {
    strlit7454 = alloc_String("");
    gc_root(strlit7454);
  }
// compiled string node returning strlit7454 (depth = 4)
  int op_slot_right_7453 = gc_frame_newslot(strlit7454);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7457 = gc_frame_new();
// call case 4: self request
  Object call7458 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7457);
// compiled member node returning call7458 (depth = 5)
  int op_slot_right_7456 = gc_frame_newslot(call7458);
// starting to compile string node (depth = 5)
  if (strlit7460 == NULL) {
    strlit7460 = alloc_String("num ");
    gc_root(strlit7460);
  }
// compiled string node returning strlit7460 (depth = 5)
  int op_slot_left_7456 = gc_frame_newslot(strlit7460);
  params[0] = call7458;
  partcv[0] = 1;
  Object opresult7461 = callmethod(strlit7460, "++(1)", 1, partcv, params);
// compiled op node returning opresult7461 (depth = 4)
  int op_slot_left_7453 = gc_frame_newslot(opresult7461);
  params[0] = strlit7454;
  partcv[0] = 1;
  Object opresult7462 = callmethod(opresult7461, "++(1)", 1, partcv, params);
// compiled op node returning opresult7462 (depth = 3)
  gc_frame_end(frame);
  return opresult7462;
}
Object meth_ast_shallowCopy7463(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7464 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe7465 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7466 = gc_frame_new();
// call case 4: self request
  Object call7467 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7466);
// compiled member node returning call7467 (depth = 5)
  gc_frame_newslot(call7467);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_numNode (depth = 5)
  params[0] = call7467;
  partcv[0] = 1;
  Object call7468 = callmethodflags(*var_numNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7465);
// compiled call node returning call7468 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7469 = callmethodflags(call7468, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7464);
// compiled call node returning call7469 (depth = 3)
  gc_frame_end(frame);
  return call7469;
}
Object meth_ast_statementName7470(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1898
  setline(1898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7471 == NULL) {
    strlit7471 = alloc_String("expression");
    gc_root(strlit7471);
  }
// compiled string node returning strlit7471 (depth = 3)
  gc_frame_end(frame);
  return strlit7471;
}
Object meth_ast_isDelimited7472(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDelimited");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7473 = alloc_Boolean(1);
// compiled identifier node returning bool7473 (depth = 3)
  gc_frame_end(frame);
  return bool7473;
}
Object meth_ast_new_40_1_41_7412(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val = &(stackframe->slots[0]);
  *var_val = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7413 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7413 = alloc_userobj2(11,11, objclass7413);
  gc_frame_newslot(obj7413);
if (objclass7413 == NULL) {
  glfree(obj7413->class->name);
  obj7413->class->name = "numNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7413, self, 0);
  addmethodreal(obj7413,"outer", &reader_ast_outer_7414);
  Object oldself7413 = self;
  struct StackFrameObject *oldstackframe7413 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7413);
  gc_frame_newslot((Object)stackframe);
  self = obj7413;
  Object *oldselfslot7413 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7413 = (*(struct UserObject *)self).data[0], lowerouter7413 = thisouter7413;
  if (inheritingObject7413) {
    struct UserObject *inho7413 = (struct UserObject *)inheritingObject7413;
    while (inho7413->super != GraceDefaultObject) inho7413 = (struct UserObject *)inho7413->super;
    inho7413->super = obj7413;
    self = inheritingObject7413;
    *selfslot = self;
    lowerouter7413 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7413;
  }
if (objclass7413 == NULL) {
  Method *reader7415 = addmethodrealflags(obj7413, "kind",&reader_ast_kind_7415, MFLAG_DEF);
  reader7415->definitionModule = modulename;
  reader7415->definitionLine = 1878;
}
adddatum2(obj7413, alloc_Undefined(), 1);
if (objclass7413 == NULL) {
  Method *reader7416 = addmethodrealflags(obj7413, "value", &reader_ast_value_7416, 0);
  Method *writer7416 = addmethodrealflags(obj7413, "value:=(1)", &writer_ast_value_7416, 0);
  reader7416->definitionModule = modulename;
  writer7416->definitionModule = modulename;
  reader7416->definitionLine = 1879;
  writer7416->definitionLine = 1879;
}
obj7413->flags |= OFLAG_MUTABLE;
adddatum2(obj7413, alloc_Undefined(), 2);
// method "accept(_)from(_)"
  struct UserObject *uo7417 = (struct UserObject*)obj7413;
  uo7417->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_7417 = addmethod2pos(obj7413, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_7417, 3);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_7417[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_7417->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_7417);
  meth_meth_ast_accept_40_1_41_from_40_1_41_7417->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_7417->definitionLine = 1880;
// method "map(_)ancestors(_)"
  struct UserObject *uo7420 = (struct UserObject*)obj7413;
  uo7420->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_7420 = addmethod2pos(obj7413, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_7420, 4);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7420[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7420->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7420);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7420->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7420->definitionLine = 1883;
// method "pretty(_)"
  struct UserObject *uo7427 = (struct UserObject*)obj7413;
  uo7427->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_7427 = addmethod2pos(obj7413, "pretty(1)", &meth_ast_pretty_40_1_41_7427, 5);
  int argcv_meth_ast_pretty_40_1_41_7427[] = {1};
  meth_meth_ast_pretty_40_1_41_7427->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_7427);
  meth_meth_ast_pretty_40_1_41_7427->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_7427->definitionLine = 1888;
// method "toGrace(_)"
  struct UserObject *uo7447 = (struct UserObject*)obj7413;
  uo7447->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7447 = addmethod2pos(obj7413, "toGrace(1)", &meth_ast_toGrace_40_1_41_7447, 6);
  int argcv_meth_ast_toGrace_40_1_41_7447[] = {1};
  meth_meth_ast_toGrace_40_1_41_7447->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7447);
meth_meth_ast_toGrace_40_1_41_7447->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7447->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7447->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7447->definitionLine = 1891;
// method "asString"
  struct UserObject *uo7452 = (struct UserObject*)obj7413;
  uo7452->data[7] = emptyclosure;
  Method *meth_meth_ast_asString7452 = addmethod2pos(obj7413, "asString", &meth_ast_asString7452, 7);
  int argcv_meth_ast_asString7452[] = {0};
  meth_meth_ast_asString7452->type = alloc_MethodType(1, argcv_meth_ast_asString7452);
  meth_meth_ast_asString7452->definitionModule = modulename;
  meth_meth_ast_asString7452->definitionLine = 1894;
// method "shallowCopy"
  block_savedest(obj7413);
  Object closure7463 = createclosure(1, "shallowCopy");
  setclosureframe(closure7463, stackframe);
  addtoclosure(closure7463, var_numNode);
  struct UserObject *uo7463 = (struct UserObject*)obj7413;
  uo7463->data[8] = (Object)closure7463;
  Method *meth_meth_ast_shallowCopy7463 = addmethod2pos(obj7413, "shallowCopy", &meth_ast_shallowCopy7463, 8);
  int argcv_meth_ast_shallowCopy7463[] = {0};
  meth_meth_ast_shallowCopy7463->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7463);
  meth_meth_ast_shallowCopy7463->definitionModule = modulename;
  meth_meth_ast_shallowCopy7463->definitionLine = 1895;
// method "statementName"
  struct UserObject *uo7470 = (struct UserObject*)obj7413;
  uo7470->data[9] = emptyclosure;
  Method *meth_meth_ast_statementName7470 = addmethod2pos(obj7413, "statementName", &meth_ast_statementName7470, 9);
  int argcv_meth_ast_statementName7470[] = {0};
  meth_meth_ast_statementName7470->type = alloc_MethodType(1, argcv_meth_ast_statementName7470);
  meth_meth_ast_statementName7470->definitionModule = modulename;
  meth_meth_ast_statementName7470->definitionLine = 1898;
// method "isDelimited"
  struct UserObject *uo7472 = (struct UserObject*)obj7413;
  uo7472->data[10] = emptyclosure;
  Method *meth_meth_ast_isDelimited7472 = addmethod2pos(obj7413, "isDelimited", &meth_ast_isDelimited7472, 10);
  int argcv_meth_ast_isDelimited7472[] = {0};
  meth_meth_ast_isDelimited7472->type = alloc_MethodType(1, argcv_meth_ast_isDelimited7472);
  meth_meth_ast_isDelimited7472->definitionModule = modulename;
  meth_meth_ast_isDelimited7472->definitionLine = 1899;
  sourceObject = obj7413;
// Begin line 1877
  setline(1877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7474 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7475 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7476 = gc_frame_new();
// call case 3: self.outer request
  Object call7477 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7476);
// compiled member node returning call7477 (depth = 5)
  Object call7478 = callmethodflags(call7477, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7475);
// compiled member node returning call7478 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7479 = callmethodflags(call7478, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7474);
// compiled call node returning call7479 (depth = 3)
  struct UserObject *obj7413_uo = (struct UserObject *)obj7413;
  obj7413_uo->super = call7479;
  sourceObject = obj7413;
// Begin line 1878
  setline(1878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7480 == NULL) {
    strlit7480 = alloc_String("num");
    gc_root(strlit7480);
  }
// compiled string node returning strlit7480 (depth = 3)
  adddatum2(obj7413, strlit7480, 1);
  sourceObject = obj7413;
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj7413, *var_val, 2);
  sourceObject = obj7413;
  sourceObject = obj7413;
  sourceObject = obj7413;
  sourceObject = obj7413;
  sourceObject = obj7413;
  sourceObject = obj7413;
  sourceObject = obj7413;
  sourceObject = obj7413;
  objclass7413 = obj7413->class;
  objclass7413->definitionModule = modulename;
  objclass7413->definitionLine = 1876;
  (*(struct UserObject *)self).data[0] = lowerouter7413;
  self = oldself7413;
  selfslot = oldselfslot7413;
  stackframe = oldstackframe7413;
  gc_frame_end(frame);
  return obj7413;
}
Object meth_ast_new_40_1_41_7412_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val = &(stackframe->slots[0]);
  *var_val = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7413 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7413 = alloc_userobj2(11,11, objclass7413);
  gc_frame_newslot(obj7413);
if (objclass7413 == NULL) {
  glfree(obj7413->class->name);
  obj7413->class->name = "numNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7413, self, 0);
  addmethodreal(obj7413,"outer", &reader_ast_outer_7414);
  Object oldself7413 = self;
  struct StackFrameObject *oldstackframe7413 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7413);
  gc_frame_newslot((Object)stackframe);
  self = obj7413;
  Object *oldselfslot7413 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7413 = (*(struct UserObject *)self).data[0], lowerouter7413 = thisouter7413;
  if (inheritingObject7413) {
    struct UserObject *inho7413 = (struct UserObject *)inheritingObject7413;
    while (inho7413->super != GraceDefaultObject) inho7413 = (struct UserObject *)inho7413->super;
    inho7413->super = obj7413;
    self = inheritingObject7413;
    *selfslot = self;
    lowerouter7413 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7413;
  }
if (objclass7413 == NULL) {
  Method *reader7415 = addmethodrealflags(obj7413, "kind",&reader_ast_kind_7415, MFLAG_DEF);
  reader7415->definitionModule = modulename;
  reader7415->definitionLine = 1878;
}
adddatum2(obj7413, alloc_Undefined(), 1);
if (objclass7413 == NULL) {
  Method *reader7416 = addmethodrealflags(obj7413, "value", &reader_ast_value_7416, 0);
  Method *writer7416 = addmethodrealflags(obj7413, "value:=(1)", &writer_ast_value_7416, 0);
  reader7416->definitionModule = modulename;
  writer7416->definitionModule = modulename;
  reader7416->definitionLine = 1879;
  writer7416->definitionLine = 1879;
}
obj7413->flags |= OFLAG_MUTABLE;
adddatum2(obj7413, alloc_Undefined(), 2);
// method "accept(_)from(_)"
  struct UserObject *uo7417 = (struct UserObject*)obj7413;
  uo7417->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_7417 = addmethod2pos(obj7413, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_7417, 3);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_7417[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_7417->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_7417);
  meth_meth_ast_accept_40_1_41_from_40_1_41_7417->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_7417->definitionLine = 1880;
// method "map(_)ancestors(_)"
  struct UserObject *uo7420 = (struct UserObject*)obj7413;
  uo7420->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_7420 = addmethod2pos(obj7413, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_7420, 4);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7420[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7420->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7420);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7420->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7420->definitionLine = 1883;
// method "pretty(_)"
  struct UserObject *uo7427 = (struct UserObject*)obj7413;
  uo7427->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_7427 = addmethod2pos(obj7413, "pretty(1)", &meth_ast_pretty_40_1_41_7427, 5);
  int argcv_meth_ast_pretty_40_1_41_7427[] = {1};
  meth_meth_ast_pretty_40_1_41_7427->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_7427);
  meth_meth_ast_pretty_40_1_41_7427->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_7427->definitionLine = 1888;
// method "toGrace(_)"
  struct UserObject *uo7447 = (struct UserObject*)obj7413;
  uo7447->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7447 = addmethod2pos(obj7413, "toGrace(1)", &meth_ast_toGrace_40_1_41_7447, 6);
  int argcv_meth_ast_toGrace_40_1_41_7447[] = {1};
  meth_meth_ast_toGrace_40_1_41_7447->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7447);
meth_meth_ast_toGrace_40_1_41_7447->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7447->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7447->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7447->definitionLine = 1891;
// method "asString"
  struct UserObject *uo7452 = (struct UserObject*)obj7413;
  uo7452->data[7] = emptyclosure;
  Method *meth_meth_ast_asString7452 = addmethod2pos(obj7413, "asString", &meth_ast_asString7452, 7);
  int argcv_meth_ast_asString7452[] = {0};
  meth_meth_ast_asString7452->type = alloc_MethodType(1, argcv_meth_ast_asString7452);
  meth_meth_ast_asString7452->definitionModule = modulename;
  meth_meth_ast_asString7452->definitionLine = 1894;
// method "shallowCopy"
  block_savedest(obj7413);
  Object closure7463 = createclosure(1, "shallowCopy");
  setclosureframe(closure7463, stackframe);
  addtoclosure(closure7463, var_numNode);
  struct UserObject *uo7463 = (struct UserObject*)obj7413;
  uo7463->data[8] = (Object)closure7463;
  Method *meth_meth_ast_shallowCopy7463 = addmethod2pos(obj7413, "shallowCopy", &meth_ast_shallowCopy7463, 8);
  int argcv_meth_ast_shallowCopy7463[] = {0};
  meth_meth_ast_shallowCopy7463->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7463);
  meth_meth_ast_shallowCopy7463->definitionModule = modulename;
  meth_meth_ast_shallowCopy7463->definitionLine = 1895;
// method "statementName"
  struct UserObject *uo7470 = (struct UserObject*)obj7413;
  uo7470->data[9] = emptyclosure;
  Method *meth_meth_ast_statementName7470 = addmethod2pos(obj7413, "statementName", &meth_ast_statementName7470, 9);
  int argcv_meth_ast_statementName7470[] = {0};
  meth_meth_ast_statementName7470->type = alloc_MethodType(1, argcv_meth_ast_statementName7470);
  meth_meth_ast_statementName7470->definitionModule = modulename;
  meth_meth_ast_statementName7470->definitionLine = 1898;
// method "isDelimited"
  struct UserObject *uo7472 = (struct UserObject*)obj7413;
  uo7472->data[10] = emptyclosure;
  Method *meth_meth_ast_isDelimited7472 = addmethod2pos(obj7413, "isDelimited", &meth_ast_isDelimited7472, 10);
  int argcv_meth_ast_isDelimited7472[] = {0};
  meth_meth_ast_isDelimited7472->type = alloc_MethodType(1, argcv_meth_ast_isDelimited7472);
  meth_meth_ast_isDelimited7472->definitionModule = modulename;
  meth_meth_ast_isDelimited7472->definitionLine = 1899;
  sourceObject = obj7413;
// Begin line 1877
  setline(1877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7474 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7475 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7476 = gc_frame_new();
// call case 3: self.outer request
  Object call7477 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7476);
// compiled member node returning call7477 (depth = 5)
  Object call7478 = callmethodflags(call7477, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7475);
// compiled member node returning call7478 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7479 = callmethodflags(call7478, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7474);
// compiled call node returning call7479 (depth = 3)
  struct UserObject *obj7413_uo = (struct UserObject *)obj7413;
  obj7413_uo->super = call7479;
  sourceObject = obj7413;
// Begin line 1878
  setline(1878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7480 == NULL) {
    strlit7480 = alloc_String("num");
    gc_root(strlit7480);
  }
// compiled string node returning strlit7480 (depth = 3)
  adddatum2(obj7413, strlit7480, 1);
  sourceObject = obj7413;
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj7413, *var_val, 2);
  sourceObject = obj7413;
  sourceObject = obj7413;
  sourceObject = obj7413;
  sourceObject = obj7413;
  sourceObject = obj7413;
  sourceObject = obj7413;
  sourceObject = obj7413;
  sourceObject = obj7413;
  objclass7413 = obj7413->class;
  objclass7413->definitionModule = modulename;
  objclass7413->definitionLine = 1876;
  (*(struct UserObject *)self).data[0] = lowerouter7413;
  self = oldself7413;
  selfslot = oldselfslot7413;
  stackframe = oldstackframe7413;
  gc_frame_end(frame);
  return obj7413;
}
Object meth_ast_numNode7482(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "numNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_numNode (depth = 3)
  gc_frame_end(frame);
  return *var_numNode;
}
Object meth_ast_isSimple7492(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1909
  setline(1909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7493 = alloc_Boolean(0);
// compiled identifier node returning bool7493 (depth = 3)
  gc_frame_end(frame);
  return bool7493;
}
Object meth_ast_nameString7494(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1910
  setline(1910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7496 == NULL) {
    strlit7496 = alloc_String("(1)");
    gc_root(strlit7496);
  }
// compiled string node returning strlit7496 (depth = 4)
  int op_slot_right_7495 = gc_frame_newslot(strlit7496);
// starting to compile member node (depth = 4)
  int callframe7498 = gc_frame_new();
// call case 4: self request
  Object call7499 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7498);
// compiled member node returning call7499 (depth = 4)
  int op_slot_left_7495 = gc_frame_newslot(call7499);
  params[0] = strlit7496;
  partcv[0] = 1;
  Object opresult7500 = callmethod(call7499, "++(1)", 1, partcv, params);
// compiled op node returning opresult7500 (depth = 3)
  gc_frame_end(frame);
  return opresult7500;
}
Object meth_ast_accept_40_1_41_from_40_1_41_7501(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7503 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7504 = callmethodflags(*var_visitor, "visitOp(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7503);
// compiled call node returning call7504 (depth = 4)
  Object if7502 = done;
  if (istrue(call7504)) {
// Begin line 1913
  setline(1913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7505 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call7506 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7505);
// compiled call node returning call7506 (depth = 5)
  *var_newChain = call7506;
  if (call7506 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1914
  setline(1914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7507 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7508 = gc_frame_new();
// call case 4: self request
  Object call7509 = callmethodflags(self, "left", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7508);
// compiled member node returning call7509 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7510 = callmethodflags(call7509, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7507);
// compiled call node returning call7510 (depth = 4)
// Begin line 1915
  setline(1915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7511 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7512 = gc_frame_new();
// call case 4: self request
  Object call7513 = callmethodflags(self, "right", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7512);
// compiled member node returning call7513 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7514 = callmethodflags(call7513, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7511);
// compiled call node returning call7514 (depth = 4)
    gc_frame_newslot(call7514);
    if7502 = call7514;
  } else {
  }
// compiled if node returning if7502 (depth = 3)
  gc_frame_end(frame);
  return if7502;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_7515(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7516 = gc_frame_new();
// call case 4: self request
  Object call7517 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7516);
// compiled member node returning call7517 (depth = 4)
  *var_n = call7517;
  if (call7517 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1920
  setline(1920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7518 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7519 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7518);
// compiled call node returning call7519 (depth = 4)
  *var_newChain = call7519;
  if (call7519 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1921
  setline(1921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7520 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7521 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7522 = gc_frame_new();
// call case 4: self request
  Object call7523 = callmethodflags(self, "left", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7522);
// compiled member node returning call7523 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7524 = callmethodflags(call7523, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7521);
// compiled call node returning call7524 (depth = 4)
  gc_frame_newslot(call7524);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7524;
  partcv[0] = 1;
  Object call7525 = callmethodflags(*var_n, "left:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7520);
// compiled call node returning call7525 (depth = 3)
// Begin line 1922
  setline(1922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7526 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7527 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7528 = gc_frame_new();
// call case 4: self request
  Object call7529 = callmethodflags(self, "right", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7528);
// compiled member node returning call7529 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7530 = callmethodflags(call7529, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7527);
// compiled call node returning call7530 (depth = 4)
  gc_frame_newslot(call7530);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7530;
  partcv[0] = 1;
  Object call7531 = callmethodflags(*var_n, "right:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7526);
// compiled call node returning call7531 (depth = 3)
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7532 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7533 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7532);
// compiled call node returning call7533 (depth = 3)
  gc_frame_end(frame);
  return call7533;
}
Object meth_ast__apply_40_1_41_7542(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1928
  setline(1928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7544 == NULL) {
    strlit7544 = alloc_String("  ");
    gc_root(strlit7544);
  }
// compiled string node returning strlit7544 (depth = 7)
  int op_slot_right_7543 = gc_frame_newslot(strlit7544);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_7543 = gc_frame_newslot(*var_spc);
  params[0] = strlit7544;
  partcv[0] = 1;
  Object opresult7546 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult7546 (depth = 6)
  *var_spc = opresult7546;
  if (opresult7546 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_7534(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7535 == NULL) {
    strlit7535 = alloc_String("");
    gc_root(strlit7535);
  }
// compiled string node returning strlit7535 (depth = 4)
  *var_spc = strlit7535;
  if (strlit7535 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7536 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_7537 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num7539 = alloc_Float64(0);
// compiled num node returning num7539 (depth = 5)
  int op_slot_left_7537 = gc_frame_newslot(num7539);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7540 = callmethod(num7539, "..(1)", 1, partcv, params);
// compiled op node returning opresult7540 (depth = 4)
  gc_frame_newslot(opresult7540);
// starting to compile block node (depth = 4)
  Object block7541 = alloc_Block(NULL, NULL, "ast", 1927);
  gc_frame_newslot(block7541);
// method "_apply(_)"
  block_savedest(block7541);
  Object closure7542 = createclosure(2, "_apply(1)");
  setclosureframe(closure7542, stackframe);
  addtoclosure(closure7542, var_spc);
  addtoclosure(closure7542, selfslot);
  struct UserObject *uo7542 = (struct UserObject*)block7541;
  uo7542->data[0] = (Object)closure7542;
  Method *meth_meth_ast__apply_40_1_41_7542 = addmethod2pos(block7541, "_apply(1)", &meth_ast__apply_40_1_41_7542, 0);
  int argcv_meth_ast__apply_40_1_41_7542[] = {1};
  meth_meth_ast__apply_40_1_41_7542->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_7542);
  meth_meth_ast__apply_40_1_41_7542->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_7542->definitionLine = 2981;
// compiled block node returning block7541 (depth = 4)
  gc_frame_newslot(block7541);
// call case 5: prelude request
  params[0] = opresult7540;
  params[1] = block7541;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7549 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7536);
// compiled call node returning call7549 (depth = 3)
// Begin line 1930
  setline(1930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7551 == NULL) {
    strlit7551 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7551);
  }
// compiled string node returning strlit7551 (depth = 5)
  int op_slot_right_7550 = gc_frame_newslot(strlit7551);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7554 = gc_frame_new();
// call case 4: self request
  Object call7555 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7554);
// compiled member node returning call7555 (depth = 6)
  int op_slot_right_7553 = gc_frame_newslot(call7555);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7558 == NULL) {
    strlit7558 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit7558);
  }
// compiled string node returning strlit7558 (depth = 7)
  int op_slot_right_7557 = gc_frame_newslot(strlit7558);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7561 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7562 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7561);
// compiled call node returning call7562 (depth = 8)
  int op_slot_right_7560 = gc_frame_newslot(call7562);
// starting to compile string node (depth = 8)
  if (strlit7564 == NULL) {
    strlit7564 = alloc_String("");
    gc_root(strlit7564);
  }
// compiled string node returning strlit7564 (depth = 8)
  int op_slot_left_7560 = gc_frame_newslot(strlit7564);
  params[0] = call7562;
  partcv[0] = 1;
  Object opresult7565 = callmethod(strlit7564, "++(1)", 1, partcv, params);
// compiled op node returning opresult7565 (depth = 7)
  int op_slot_left_7557 = gc_frame_newslot(opresult7565);
  params[0] = strlit7558;
  partcv[0] = 1;
  Object opresult7566 = callmethod(opresult7565, "++(1)", 1, partcv, params);
// compiled op node returning opresult7566 (depth = 6)
  int op_slot_left_7553 = gc_frame_newslot(opresult7566);
  params[0] = call7555;
  partcv[0] = 1;
  Object opresult7567 = callmethod(opresult7566, "++(1)", 1, partcv, params);
// compiled op node returning opresult7567 (depth = 5)
  int op_slot_left_7550 = gc_frame_newslot(opresult7567);
  params[0] = strlit7551;
  partcv[0] = 1;
  Object opresult7568 = callmethod(opresult7567, "++(1)", 1, partcv, params);
// compiled op node returning opresult7568 (depth = 4)
  *var_s = opresult7568;
  if (opresult7568 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1931
  setline(1931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7570 == NULL) {
    strlit7570 = alloc_String("""\x0a""");
    gc_root(strlit7570);
  }
// compiled string node returning strlit7570 (depth = 5)
  int op_slot_right_7569 = gc_frame_newslot(strlit7570);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_7569 = gc_frame_newslot(*var_s);
  params[0] = strlit7570;
  partcv[0] = 1;
  Object opresult7572 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7572 (depth = 4)
  *var_s = opresult7572;
  if (opresult7572 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7575 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7577 = alloc_Float64(1);
// compiled num node returning num7577 (depth = 7)
  int op_slot_right_7576 = gc_frame_newslot(num7577);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7576 = gc_frame_newslot(*var_depth);
  params[0] = num7577;
  partcv[0] = 1;
  Object sum7579 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7579 (depth = 6)
  gc_frame_newslot(sum7579);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7580 = gc_frame_new();
// call case 4: self request
  Object call7581 = callmethodflags(self, "left", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7580);
// compiled member node returning call7581 (depth = 6)
  params[0] = sum7579;
  partcv[0] = 1;
  Object call7582 = callmethodflags(call7581, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7575);
// compiled call node returning call7582 (depth = 5)
  int op_slot_right_7574 = gc_frame_newslot(call7582);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7584 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7584 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7586 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7586 (depth = 5)
  int op_slot_left_7574 = gc_frame_newslot(opresult7586);
  params[0] = call7582;
  partcv[0] = 1;
  Object opresult7587 = callmethod(opresult7586, "++(1)", 1, partcv, params);
// compiled op node returning opresult7587 (depth = 4)
  *var_s = opresult7587;
  if (opresult7587 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1933
  setline(1933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7590 == NULL) {
    strlit7590 = alloc_String("""\x0a""");
    gc_root(strlit7590);
  }
// compiled string node returning strlit7590 (depth = 5)
  int op_slot_right_7589 = gc_frame_newslot(strlit7590);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_7589 = gc_frame_newslot(*var_s);
  params[0] = strlit7590;
  partcv[0] = 1;
  Object opresult7592 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7592 (depth = 4)
  *var_s = opresult7592;
  if (opresult7592 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1934
  setline(1934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7595 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7597 = alloc_Float64(1);
// compiled num node returning num7597 (depth = 7)
  int op_slot_right_7596 = gc_frame_newslot(num7597);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7596 = gc_frame_newslot(*var_depth);
  params[0] = num7597;
  partcv[0] = 1;
  Object sum7599 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7599 (depth = 6)
  gc_frame_newslot(sum7599);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7600 = gc_frame_new();
// call case 4: self request
  Object call7601 = callmethodflags(self, "right", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7600);
// compiled member node returning call7601 (depth = 6)
  params[0] = sum7599;
  partcv[0] = 1;
  Object call7602 = callmethodflags(call7601, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7595);
// compiled call node returning call7602 (depth = 5)
  int op_slot_right_7594 = gc_frame_newslot(call7602);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7604 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7604 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7606 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7606 (depth = 5)
  int op_slot_left_7594 = gc_frame_newslot(opresult7606);
  params[0] = call7602;
  partcv[0] = 1;
  Object opresult7607 = callmethod(opresult7606, "++(1)", 1, partcv, params);
// compiled op node returning opresult7607 (depth = 4)
  *var_s = opresult7607;
  if (opresult7607 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply7614(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7616 = gc_frame_new();
// call case 4: self request
  Object call7617 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7616);
// compiled member node returning call7617 (depth = 7)
  int op_slot_right_7615 = gc_frame_newslot(call7617);
// starting to compile member node (depth = 7)
  int callframe7619 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe7620 = gc_frame_new();
// call case 4: self request
  Object call7621 = callmethodflags(self, "left", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7620);
// compiled member node returning call7621 (depth = 8)
  Object call7622 = callmethodflags(call7621, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7619);
// compiled member node returning call7622 (depth = 7)
  int op_slot_left_7615 = gc_frame_newslot(call7622);
  params[0] = call7617;
  partcv[0] = 1;
  Object opresult7623 = callmethod(call7622, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7623 (depth = 6)
  gc_frame_end(frame);
  return opresult7623;
}
Object meth_ast__apply7685(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7687 = gc_frame_new();
// call case 4: self request
  Object call7688 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7687);
// compiled member node returning call7688 (depth = 7)
  int op_slot_right_7686 = gc_frame_newslot(call7688);
// starting to compile member node (depth = 7)
  int callframe7690 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe7691 = gc_frame_new();
// call case 4: self request
  Object call7692 = callmethodflags(self, "right", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7691);
// compiled member node returning call7692 (depth = 8)
  Object call7693 = callmethodflags(call7692, "value", 0, partcv, params, 0);
  gc_frame_end(callframe7690);
// compiled member node returning call7693 (depth = 7)
  int op_slot_left_7686 = gc_frame_newslot(call7693);
  params[0] = call7688;
  partcv[0] = 1;
  Object opresult7694 = callmethod(call7693, "≠(1)", 1, partcv, params);
// compiled op node returning opresult7694 (depth = 6)
  gc_frame_end(frame);
  return opresult7694;
}
Object meth_ast_toGrace_40_1_41_7609(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1938
  setline(1938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7610 == NULL) {
    strlit7610 = alloc_String("");
    gc_root(strlit7610);
  }
// compiled string node returning strlit7610 (depth = 4)
  *var_s = strlit7610;
  if (strlit7610 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1939
  setline(1939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block7613 = alloc_Block(NULL, NULL, "ast", 1939);
  gc_frame_newslot(block7613);
// method "_apply"
  block_savedest(block7613);
  Object closure7614 = createclosure(1, "_apply");
  setclosureframe(closure7614, stackframe);
  addtoclosure(closure7614, selfslot);
  struct UserObject *uo7614 = (struct UserObject*)block7613;
  uo7614->data[0] = (Object)closure7614;
  Method *meth_meth_ast__apply7614 = addmethod2pos(block7613, "_apply", &meth_ast__apply7614, 0);
  int argcv_meth_ast__apply7614[] = {0};
  meth_meth_ast__apply7614->type = alloc_MethodType(1, argcv_meth_ast__apply7614);
  meth_meth_ast__apply7614->definitionModule = modulename;
  meth_meth_ast__apply7614->definitionLine = 2981;
// compiled block node returning block7613 (depth = 5)
  int op_slot_right_7612 = gc_frame_newslot(block7613);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7627 == NULL) {
    strlit7627 = alloc_String("op");
    gc_root(strlit7627);
  }
// compiled string node returning strlit7627 (depth = 6)
  int op_slot_right_7626 = gc_frame_newslot(strlit7627);
// starting to compile member node (depth = 6)
  int callframe7629 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7630 = gc_frame_new();
// call case 4: self request
  Object call7631 = callmethodflags(self, "left", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7630);
// compiled member node returning call7631 (depth = 7)
  Object call7632 = callmethodflags(call7631, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7629);
// compiled member node returning call7632 (depth = 6)
  int op_slot_left_7626 = gc_frame_newslot(call7632);
  params[0] = strlit7627;
  partcv[0] = 1;
  Object opresult7633 = callmethod(call7632, "==(1)", 1, partcv, params);
// compiled op node returning opresult7633 (depth = 5)
  int op_slot_left_7612 = gc_frame_newslot(opresult7633);
  params[0] = block7613;
  partcv[0] = 1;
  Object opresult7634 = callmethod(opresult7633, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7634 (depth = 4)
  Object if7611 = done;
  if (istrue(opresult7634)) {
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7636 == NULL) {
    strlit7636 = alloc_String(")");
    gc_root(strlit7636);
  }
// compiled string node returning strlit7636 (depth = 6)
  int op_slot_right_7635 = gc_frame_newslot(strlit7636);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7639 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num7640 = alloc_Float64(0);
// compiled num node returning num7640 (depth = 8)
  gc_frame_newslot(num7640);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe7641 = gc_frame_new();
// call case 4: self request
  Object call7642 = callmethodflags(self, "left", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7641);
// compiled member node returning call7642 (depth = 8)
  params[0] = num7640;
  partcv[0] = 1;
  Object call7643 = callmethodflags(call7642, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7639);
// compiled call node returning call7643 (depth = 7)
  int op_slot_right_7638 = gc_frame_newslot(call7643);
// starting to compile string node (depth = 7)
  if (strlit7645 == NULL) {
    strlit7645 = alloc_String("(");
    gc_root(strlit7645);
  }
// compiled string node returning strlit7645 (depth = 7)
  int op_slot_left_7638 = gc_frame_newslot(strlit7645);
  params[0] = call7643;
  partcv[0] = 1;
  Object opresult7646 = callmethod(strlit7645, "++(1)", 1, partcv, params);
// compiled op node returning opresult7646 (depth = 6)
  int op_slot_left_7635 = gc_frame_newslot(opresult7646);
  params[0] = strlit7636;
  partcv[0] = 1;
  Object opresult7647 = callmethod(opresult7646, "++(1)", 1, partcv, params);
// compiled op node returning opresult7647 (depth = 5)
  *var_s = opresult7647;
  if (opresult7647 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7611 = done;
  } else {
// Begin line 1942
  setline(1942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7649 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num7650 = alloc_Float64(0);
// compiled num node returning num7650 (depth = 6)
  gc_frame_newslot(num7650);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7651 = gc_frame_new();
// call case 4: self request
  Object call7652 = callmethodflags(self, "left", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7651);
// compiled member node returning call7652 (depth = 6)
  params[0] = num7650;
  partcv[0] = 1;
  Object call7653 = callmethodflags(call7652, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7649);
// compiled call node returning call7653 (depth = 5)
  *var_s = call7653;
  if (call7653 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7611 = done;
  }
// compiled if node returning if7611 (depth = 3)
// Begin line 1944
  setline(1944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7657 == NULL) {
    strlit7657 = alloc_String("..");
    gc_root(strlit7657);
  }
// compiled string node returning strlit7657 (depth = 5)
  int op_slot_right_7656 = gc_frame_newslot(strlit7657);
// starting to compile member node (depth = 5)
  int callframe7659 = gc_frame_new();
// call case 4: self request
  Object call7660 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7659);
// compiled member node returning call7660 (depth = 5)
  int op_slot_left_7656 = gc_frame_newslot(call7660);
  params[0] = strlit7657;
  partcv[0] = 1;
  Object opresult7661 = callmethod(call7660, "==(1)", 1, partcv, params);
// compiled op node returning opresult7661 (depth = 4)
  Object if7655 = done;
  if (istrue(opresult7661)) {
// Begin line 1945
  setline(1945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe7663 = gc_frame_new();
// call case 4: self request
  Object call7664 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7663);
// compiled member node returning call7664 (depth = 6)
  int op_slot_right_7662 = gc_frame_newslot(call7664);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7662 = gc_frame_newslot(*var_s);
  params[0] = call7664;
  partcv[0] = 1;
  Object opresult7666 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7666 (depth = 5)
  *var_s = opresult7666;
  if (opresult7666 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7655 = done;
  } else {
// Begin line 1947
  setline(1947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7669 == NULL) {
    strlit7669 = alloc_String(" ");
    gc_root(strlit7669);
  }
// compiled string node returning strlit7669 (depth = 6)
  int op_slot_right_7668 = gc_frame_newslot(strlit7669);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe7672 = gc_frame_new();
// call case 4: self request
  Object call7673 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7672);
// compiled member node returning call7673 (depth = 7)
  int op_slot_right_7671 = gc_frame_newslot(call7673);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7676 == NULL) {
    strlit7676 = alloc_String(" ");
    gc_root(strlit7676);
  }
// compiled string node returning strlit7676 (depth = 8)
  int op_slot_right_7675 = gc_frame_newslot(strlit7676);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7675 = gc_frame_newslot(*var_s);
  params[0] = strlit7676;
  partcv[0] = 1;
  Object opresult7678 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7678 (depth = 7)
  int op_slot_left_7671 = gc_frame_newslot(opresult7678);
  params[0] = call7673;
  partcv[0] = 1;
  Object opresult7679 = callmethod(opresult7678, "++(1)", 1, partcv, params);
// compiled op node returning opresult7679 (depth = 6)
  int op_slot_left_7668 = gc_frame_newslot(opresult7679);
  params[0] = strlit7669;
  partcv[0] = 1;
  Object opresult7680 = callmethod(opresult7679, "++(1)", 1, partcv, params);
// compiled op node returning opresult7680 (depth = 5)
  *var_s = opresult7680;
  if (opresult7680 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7655 = done;
  }
// compiled if node returning if7655 (depth = 3)
// Begin line 1949
  setline(1949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block7684 = alloc_Block(NULL, NULL, "ast", 1949);
  gc_frame_newslot(block7684);
// method "_apply"
  block_savedest(block7684);
  Object closure7685 = createclosure(1, "_apply");
  setclosureframe(closure7685, stackframe);
  addtoclosure(closure7685, selfslot);
  struct UserObject *uo7685 = (struct UserObject*)block7684;
  uo7685->data[0] = (Object)closure7685;
  Method *meth_meth_ast__apply7685 = addmethod2pos(block7684, "_apply", &meth_ast__apply7685, 0);
  int argcv_meth_ast__apply7685[] = {0};
  meth_meth_ast__apply7685->type = alloc_MethodType(1, argcv_meth_ast__apply7685);
  meth_meth_ast__apply7685->definitionModule = modulename;
  meth_meth_ast__apply7685->definitionLine = 2981;
// compiled block node returning block7684 (depth = 5)
  int op_slot_right_7683 = gc_frame_newslot(block7684);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7698 == NULL) {
    strlit7698 = alloc_String("op");
    gc_root(strlit7698);
  }
// compiled string node returning strlit7698 (depth = 6)
  int op_slot_right_7697 = gc_frame_newslot(strlit7698);
// starting to compile member node (depth = 6)
  int callframe7700 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7701 = gc_frame_new();
// call case 4: self request
  Object call7702 = callmethodflags(self, "right", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7701);
// compiled member node returning call7702 (depth = 7)
  Object call7703 = callmethodflags(call7702, "kind", 0, partcv, params, 0);
  gc_frame_end(callframe7700);
// compiled member node returning call7703 (depth = 6)
  int op_slot_left_7697 = gc_frame_newslot(call7703);
  params[0] = strlit7698;
  partcv[0] = 1;
  Object opresult7704 = callmethod(call7703, "==(1)", 1, partcv, params);
// compiled op node returning opresult7704 (depth = 5)
  int op_slot_left_7683 = gc_frame_newslot(opresult7704);
  params[0] = block7684;
  partcv[0] = 1;
  Object opresult7705 = callmethod(opresult7704, "&&(1)", 1, partcv, params);
// compiled op node returning opresult7705 (depth = 4)
  Object if7682 = done;
  if (istrue(opresult7705)) {
// Begin line 1950
  setline(1950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7707 == NULL) {
    strlit7707 = alloc_String(")");
    gc_root(strlit7707);
  }
// compiled string node returning strlit7707 (depth = 6)
  int op_slot_right_7706 = gc_frame_newslot(strlit7707);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7710 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num7711 = alloc_Float64(0);
// compiled num node returning num7711 (depth = 8)
  gc_frame_newslot(num7711);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe7712 = gc_frame_new();
// call case 4: self request
  Object call7713 = callmethodflags(self, "right", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7712);
// compiled member node returning call7713 (depth = 8)
  params[0] = num7711;
  partcv[0] = 1;
  Object call7714 = callmethodflags(call7713, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7710);
// compiled call node returning call7714 (depth = 7)
  int op_slot_right_7709 = gc_frame_newslot(call7714);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7717 == NULL) {
    strlit7717 = alloc_String("(");
    gc_root(strlit7717);
  }
// compiled string node returning strlit7717 (depth = 8)
  int op_slot_right_7716 = gc_frame_newslot(strlit7717);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7716 = gc_frame_newslot(*var_s);
  params[0] = strlit7717;
  partcv[0] = 1;
  Object opresult7719 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7719 (depth = 7)
  int op_slot_left_7709 = gc_frame_newslot(opresult7719);
  params[0] = call7714;
  partcv[0] = 1;
  Object opresult7720 = callmethod(opresult7719, "++(1)", 1, partcv, params);
// compiled op node returning opresult7720 (depth = 6)
  int op_slot_left_7706 = gc_frame_newslot(opresult7720);
  params[0] = strlit7707;
  partcv[0] = 1;
  Object opresult7721 = callmethod(opresult7720, "++(1)", 1, partcv, params);
// compiled op node returning opresult7721 (depth = 5)
  *var_s = opresult7721;
  if (opresult7721 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7682 = done;
  } else {
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7724 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num7725 = alloc_Float64(0);
// compiled num node returning num7725 (depth = 7)
  gc_frame_newslot(num7725);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe7726 = gc_frame_new();
// call case 4: self request
  Object call7727 = callmethodflags(self, "right", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7726);
// compiled member node returning call7727 (depth = 7)
  params[0] = num7725;
  partcv[0] = 1;
  Object call7728 = callmethodflags(call7727, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7724);
// compiled call node returning call7728 (depth = 6)
  int op_slot_right_7723 = gc_frame_newslot(call7728);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7723 = gc_frame_newslot(*var_s);
  params[0] = call7728;
  partcv[0] = 1;
  Object opresult7730 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7730 (depth = 5)
  *var_s = opresult7730;
  if (opresult7730 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7682 = done;
  }
// compiled if node returning if7682 (depth = 3)
// Begin line 1954
  setline(1954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asIdentifier7732(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_resultNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "resultNode");
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7733 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7734 = gc_frame_new();
// call case 4: self request
  Object call7735 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7734);
// compiled member node returning call7735 (depth = 5)
  gc_frame_newslot(call7735);
// starting to compile identifier node (depth = 5)
  Object bool7736 = alloc_Boolean(0);
// compiled identifier node returning bool7736 (depth = 5)
  gc_frame_newslot(bool7736);
// starting to compile member node (depth = 5)
  int callframe7737 = gc_frame_new();
// call case 4: self request
  Object call7738 = callmethodflags(self, "scope", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7737);
// compiled member node returning call7738 (depth = 5)
  gc_frame_newslot(call7738);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call7735;
  params[1] = bool7736;
  params[2] = call7738;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call7739 = callmethodflags(*var_identifierNode, "new(2)scope(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7733);
// compiled call node returning call7739 (depth = 4)
  *var_resultNode = call7739;
  if (call7739 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7740 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool7741 = alloc_Boolean(1);
// compiled identifier node returning bool7741 (depth = 4)
  gc_frame_newslot(bool7741);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = bool7741;
  partcv[0] = 1;
  Object call7742 = callmethodflags(*var_resultNode, "inRequest:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7740);
// compiled call node returning call7742 (depth = 3)
// Begin line 1960
  setline(1960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7743 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7744 = gc_frame_new();
// call case 4: self request
  Object call7745 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7744);
// compiled member node returning call7745 (depth = 4)
  gc_frame_newslot(call7745);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call7745;
  partcv[0] = 1;
  Object call7746 = callmethodflags(*var_resultNode, "line:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7743);
// compiled call node returning call7746 (depth = 3)
// Begin line 1961
  setline(1961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7747 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe7748 = gc_frame_new();
// call case 4: self request
  Object call7749 = callmethodflags(self, "linePos", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7748);
// compiled member node returning call7749 (depth = 4)
  gc_frame_newslot(call7749);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call7749;
  partcv[0] = 1;
  Object call7750 = callmethodflags(*var_resultNode, "linePos:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7747);
// compiled call node returning call7750 (depth = 3)
// Begin line 1962
  setline(1962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  return *var_resultNode;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_shallowCopy7751(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_opNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7752 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe7753 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7754 = gc_frame_new();
// call case 4: self request
  Object call7755 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7754);
// compiled member node returning call7755 (depth = 5)
  gc_frame_newslot(call7755);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_opNode (depth = 5)
  params[0] = call7755;
  params[1] = *var_nullNode;
  params[2] = *var_nullNode;
  partcv[0] = 3;
  Object call7756 = callmethodflags(*var_opNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe7753);
// compiled call node returning call7756 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7757 = callmethodflags(call7756, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7752);
// compiled call node returning call7757 (depth = 3)
  gc_frame_end(frame);
  return call7757;
}
Object meth_ast_new_40_3_41_7485(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_opNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_op = &(stackframe->slots[0]);
  *var_op = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[2]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7486 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7486 = alloc_userobj2(14,13, objclass7486);
  gc_frame_newslot(obj7486);
if (objclass7486 == NULL) {
  glfree(obj7486->class->name);
  obj7486->class->name = "opNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7486, self, 0);
  addmethodreal(obj7486,"outer", &reader_ast_outer_7487);
  Object oldself7486 = self;
  struct StackFrameObject *oldstackframe7486 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7486);
  gc_frame_newslot((Object)stackframe);
  self = obj7486;
  Object *oldselfslot7486 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7486 = (*(struct UserObject *)self).data[0], lowerouter7486 = thisouter7486;
  if (inheritingObject7486) {
    struct UserObject *inho7486 = (struct UserObject *)inheritingObject7486;
    while (inho7486->super != GraceDefaultObject) inho7486 = (struct UserObject *)inho7486->super;
    inho7486->super = obj7486;
    self = inheritingObject7486;
    *selfslot = self;
    lowerouter7486 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7486;
  }
if (objclass7486 == NULL) {
  Method *reader7488 = addmethodrealflags(obj7486, "kind",&reader_ast_kind_7488, MFLAG_DEF);
  reader7488->definitionModule = modulename;
  reader7488->definitionLine = 1905;
}
adddatum2(obj7486, alloc_Undefined(), 1);
if (objclass7486 == NULL) {
  Method *reader7489 = addmethodrealflags(obj7486, "value",&reader_ast_value_7489, MFLAG_DEF);
  reader7489->definitionModule = modulename;
  reader7489->definitionLine = 1906;
}
adddatum2(obj7486, alloc_Undefined(), 2);
if (objclass7486 == NULL) {
  Method *reader7490 = addmethodrealflags(obj7486, "left", &reader_ast_left_7490, 0);
  Method *writer7490 = addmethodrealflags(obj7486, "left:=(1)", &writer_ast_left_7490, 0);
  reader7490->definitionModule = modulename;
  writer7490->definitionModule = modulename;
  reader7490->definitionLine = 1907;
  writer7490->definitionLine = 1907;
}
obj7486->flags |= OFLAG_MUTABLE;
adddatum2(obj7486, alloc_Undefined(), 3);
if (objclass7486 == NULL) {
  Method *reader7491 = addmethodrealflags(obj7486, "right", &reader_ast_right_7491, 0);
  Method *writer7491 = addmethodrealflags(obj7486, "right:=(1)", &writer_ast_right_7491, 0);
  reader7491->definitionModule = modulename;
  writer7491->definitionModule = modulename;
  reader7491->definitionLine = 1908;
  writer7491->definitionLine = 1908;
}
obj7486->flags |= OFLAG_MUTABLE;
adddatum2(obj7486, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo7492 = (struct UserObject*)obj7486;
  uo7492->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple7492 = addmethod2pos(obj7486, "isSimple", &meth_ast_isSimple7492, 5);
  int argcv_meth_ast_isSimple7492[] = {0};
  meth_meth_ast_isSimple7492->type = alloc_MethodType(1, argcv_meth_ast_isSimple7492);
  meth_meth_ast_isSimple7492->definitionModule = modulename;
  meth_meth_ast_isSimple7492->definitionLine = 1909;
// method "nameString"
  struct UserObject *uo7494 = (struct UserObject*)obj7486;
  uo7494->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString7494 = addmethod2pos(obj7486, "nameString", &meth_ast_nameString7494, 6);
  int argcv_meth_ast_nameString7494[] = {0};
  meth_meth_ast_nameString7494->type = alloc_MethodType(1, argcv_meth_ast_nameString7494);
  meth_meth_ast_nameString7494->definitionModule = modulename;
  meth_meth_ast_nameString7494->definitionLine = 1910;
// method "accept(_)from(_)"
  struct UserObject *uo7501 = (struct UserObject*)obj7486;
  uo7501->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_7501 = addmethod2pos(obj7486, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_7501, 7);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_7501[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_7501->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_7501);
  meth_meth_ast_accept_40_1_41_from_40_1_41_7501->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_7501->definitionLine = 1911;
// method "map(_)ancestors(_)"
  struct UserObject *uo7515 = (struct UserObject*)obj7486;
  uo7515->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_7515 = addmethod2pos(obj7486, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_7515, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7515[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7515->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7515);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7515->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7515->definitionLine = 1918;
// method "pretty(_)"
  struct UserObject *uo7534 = (struct UserObject*)obj7486;
  uo7534->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_7534 = addmethod2pos(obj7486, "pretty(1)", &meth_ast_pretty_40_1_41_7534, 9);
  int argcv_meth_ast_pretty_40_1_41_7534[] = {1};
  meth_meth_ast_pretty_40_1_41_7534->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_7534);
  meth_meth_ast_pretty_40_1_41_7534->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_7534->definitionLine = 1925;
// method "toGrace(_)"
  struct UserObject *uo7609 = (struct UserObject*)obj7486;
  uo7609->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7609 = addmethod2pos(obj7486, "toGrace(1)", &meth_ast_toGrace_40_1_41_7609, 10);
  int argcv_meth_ast_toGrace_40_1_41_7609[] = {1};
  meth_meth_ast_toGrace_40_1_41_7609->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7609);
meth_meth_ast_toGrace_40_1_41_7609->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7609->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7609->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7609->definitionLine = 1937;
// method "asIdentifier"
  block_savedest(obj7486);
  Object closure7732 = createclosure(1, "asIdentifier");
  setclosureframe(closure7732, stackframe);
  addtoclosure(closure7732, var_identifierNode);
  struct UserObject *uo7732 = (struct UserObject*)obj7486;
  uo7732->data[11] = (Object)closure7732;
  Method *meth_meth_ast_asIdentifier7732 = addmethod2pos(obj7486, "asIdentifier", &meth_ast_asIdentifier7732, 11);
  int argcv_meth_ast_asIdentifier7732[] = {0};
  meth_meth_ast_asIdentifier7732->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier7732);
  meth_meth_ast_asIdentifier7732->definitionModule = modulename;
  meth_meth_ast_asIdentifier7732->definitionLine = 1956;
// method "shallowCopy"
  block_savedest(obj7486);
  Object closure7751 = createclosure(2, "shallowCopy");
  setclosureframe(closure7751, stackframe);
  addtoclosure(closure7751, var_nullNode);
  addtoclosure(closure7751, var_opNode);
  struct UserObject *uo7751 = (struct UserObject*)obj7486;
  uo7751->data[12] = (Object)closure7751;
  Method *meth_meth_ast_shallowCopy7751 = addmethod2pos(obj7486, "shallowCopy", &meth_ast_shallowCopy7751, 12);
  int argcv_meth_ast_shallowCopy7751[] = {0};
  meth_meth_ast_shallowCopy7751->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7751);
  meth_meth_ast_shallowCopy7751->definitionModule = modulename;
  meth_meth_ast_shallowCopy7751->definitionLine = 1964;
  sourceObject = obj7486;
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7758 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7759 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7760 = gc_frame_new();
// call case 3: self.outer request
  Object call7761 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7760);
// compiled member node returning call7761 (depth = 5)
  Object call7762 = callmethodflags(call7761, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7759);
// compiled member node returning call7762 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7763 = callmethodflags(call7762, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7758);
// compiled call node returning call7763 (depth = 3)
  struct UserObject *obj7486_uo = (struct UserObject *)obj7486;
  obj7486_uo->super = call7763;
  sourceObject = obj7486;
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7764 == NULL) {
    strlit7764 = alloc_String("op");
    gc_root(strlit7764);
  }
// compiled string node returning strlit7764 (depth = 3)
  adddatum2(obj7486, strlit7764, 1);
  sourceObject = obj7486;
// Begin line 1906
  setline(1906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_op (depth = 3)
  adddatum2(obj7486, *var_op, 2);
  sourceObject = obj7486;
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  adddatum2(obj7486, *var_l, 3);
  sourceObject = obj7486;
// Begin line 1908
  setline(1908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_r (depth = 3)
  adddatum2(obj7486, *var_r, 4);
  sourceObject = obj7486;
  sourceObject = obj7486;
  sourceObject = obj7486;
  sourceObject = obj7486;
  sourceObject = obj7486;
  sourceObject = obj7486;
  sourceObject = obj7486;
  sourceObject = obj7486;
  objclass7486 = obj7486->class;
  objclass7486->definitionModule = modulename;
  objclass7486->definitionLine = 1903;
  (*(struct UserObject *)self).data[0] = lowerouter7486;
  self = oldself7486;
  selfslot = oldselfslot7486;
  stackframe = oldstackframe7486;
  gc_frame_end(frame);
  return obj7486;
}
Object meth_ast_new_40_3_41_7485_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_opNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_op = &(stackframe->slots[0]);
  *var_op = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[2]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7486 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7486 = alloc_userobj2(14,13, objclass7486);
  gc_frame_newslot(obj7486);
if (objclass7486 == NULL) {
  glfree(obj7486->class->name);
  obj7486->class->name = "opNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7486, self, 0);
  addmethodreal(obj7486,"outer", &reader_ast_outer_7487);
  Object oldself7486 = self;
  struct StackFrameObject *oldstackframe7486 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7486);
  gc_frame_newslot((Object)stackframe);
  self = obj7486;
  Object *oldselfslot7486 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7486 = (*(struct UserObject *)self).data[0], lowerouter7486 = thisouter7486;
  if (inheritingObject7486) {
    struct UserObject *inho7486 = (struct UserObject *)inheritingObject7486;
    while (inho7486->super != GraceDefaultObject) inho7486 = (struct UserObject *)inho7486->super;
    inho7486->super = obj7486;
    self = inheritingObject7486;
    *selfslot = self;
    lowerouter7486 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7486;
  }
if (objclass7486 == NULL) {
  Method *reader7488 = addmethodrealflags(obj7486, "kind",&reader_ast_kind_7488, MFLAG_DEF);
  reader7488->definitionModule = modulename;
  reader7488->definitionLine = 1905;
}
adddatum2(obj7486, alloc_Undefined(), 1);
if (objclass7486 == NULL) {
  Method *reader7489 = addmethodrealflags(obj7486, "value",&reader_ast_value_7489, MFLAG_DEF);
  reader7489->definitionModule = modulename;
  reader7489->definitionLine = 1906;
}
adddatum2(obj7486, alloc_Undefined(), 2);
if (objclass7486 == NULL) {
  Method *reader7490 = addmethodrealflags(obj7486, "left", &reader_ast_left_7490, 0);
  Method *writer7490 = addmethodrealflags(obj7486, "left:=(1)", &writer_ast_left_7490, 0);
  reader7490->definitionModule = modulename;
  writer7490->definitionModule = modulename;
  reader7490->definitionLine = 1907;
  writer7490->definitionLine = 1907;
}
obj7486->flags |= OFLAG_MUTABLE;
adddatum2(obj7486, alloc_Undefined(), 3);
if (objclass7486 == NULL) {
  Method *reader7491 = addmethodrealflags(obj7486, "right", &reader_ast_right_7491, 0);
  Method *writer7491 = addmethodrealflags(obj7486, "right:=(1)", &writer_ast_right_7491, 0);
  reader7491->definitionModule = modulename;
  writer7491->definitionModule = modulename;
  reader7491->definitionLine = 1908;
  writer7491->definitionLine = 1908;
}
obj7486->flags |= OFLAG_MUTABLE;
adddatum2(obj7486, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo7492 = (struct UserObject*)obj7486;
  uo7492->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple7492 = addmethod2pos(obj7486, "isSimple", &meth_ast_isSimple7492, 5);
  int argcv_meth_ast_isSimple7492[] = {0};
  meth_meth_ast_isSimple7492->type = alloc_MethodType(1, argcv_meth_ast_isSimple7492);
  meth_meth_ast_isSimple7492->definitionModule = modulename;
  meth_meth_ast_isSimple7492->definitionLine = 1909;
// method "nameString"
  struct UserObject *uo7494 = (struct UserObject*)obj7486;
  uo7494->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString7494 = addmethod2pos(obj7486, "nameString", &meth_ast_nameString7494, 6);
  int argcv_meth_ast_nameString7494[] = {0};
  meth_meth_ast_nameString7494->type = alloc_MethodType(1, argcv_meth_ast_nameString7494);
  meth_meth_ast_nameString7494->definitionModule = modulename;
  meth_meth_ast_nameString7494->definitionLine = 1910;
// method "accept(_)from(_)"
  struct UserObject *uo7501 = (struct UserObject*)obj7486;
  uo7501->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_7501 = addmethod2pos(obj7486, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_7501, 7);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_7501[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_7501->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_7501);
  meth_meth_ast_accept_40_1_41_from_40_1_41_7501->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_7501->definitionLine = 1911;
// method "map(_)ancestors(_)"
  struct UserObject *uo7515 = (struct UserObject*)obj7486;
  uo7515->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_7515 = addmethod2pos(obj7486, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_7515, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7515[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7515->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7515);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7515->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7515->definitionLine = 1918;
// method "pretty(_)"
  struct UserObject *uo7534 = (struct UserObject*)obj7486;
  uo7534->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_7534 = addmethod2pos(obj7486, "pretty(1)", &meth_ast_pretty_40_1_41_7534, 9);
  int argcv_meth_ast_pretty_40_1_41_7534[] = {1};
  meth_meth_ast_pretty_40_1_41_7534->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_7534);
  meth_meth_ast_pretty_40_1_41_7534->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_7534->definitionLine = 1925;
// method "toGrace(_)"
  struct UserObject *uo7609 = (struct UserObject*)obj7486;
  uo7609->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7609 = addmethod2pos(obj7486, "toGrace(1)", &meth_ast_toGrace_40_1_41_7609, 10);
  int argcv_meth_ast_toGrace_40_1_41_7609[] = {1};
  meth_meth_ast_toGrace_40_1_41_7609->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7609);
meth_meth_ast_toGrace_40_1_41_7609->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7609->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7609->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7609->definitionLine = 1937;
// method "asIdentifier"
  block_savedest(obj7486);
  Object closure7732 = createclosure(1, "asIdentifier");
  setclosureframe(closure7732, stackframe);
  addtoclosure(closure7732, var_identifierNode);
  struct UserObject *uo7732 = (struct UserObject*)obj7486;
  uo7732->data[11] = (Object)closure7732;
  Method *meth_meth_ast_asIdentifier7732 = addmethod2pos(obj7486, "asIdentifier", &meth_ast_asIdentifier7732, 11);
  int argcv_meth_ast_asIdentifier7732[] = {0};
  meth_meth_ast_asIdentifier7732->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier7732);
  meth_meth_ast_asIdentifier7732->definitionModule = modulename;
  meth_meth_ast_asIdentifier7732->definitionLine = 1956;
// method "shallowCopy"
  block_savedest(obj7486);
  Object closure7751 = createclosure(2, "shallowCopy");
  setclosureframe(closure7751, stackframe);
  addtoclosure(closure7751, var_nullNode);
  addtoclosure(closure7751, var_opNode);
  struct UserObject *uo7751 = (struct UserObject*)obj7486;
  uo7751->data[12] = (Object)closure7751;
  Method *meth_meth_ast_shallowCopy7751 = addmethod2pos(obj7486, "shallowCopy", &meth_ast_shallowCopy7751, 12);
  int argcv_meth_ast_shallowCopy7751[] = {0};
  meth_meth_ast_shallowCopy7751->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7751);
  meth_meth_ast_shallowCopy7751->definitionModule = modulename;
  meth_meth_ast_shallowCopy7751->definitionLine = 1964;
  sourceObject = obj7486;
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7758 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7759 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7760 = gc_frame_new();
// call case 3: self.outer request
  Object call7761 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7760);
// compiled member node returning call7761 (depth = 5)
  Object call7762 = callmethodflags(call7761, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7759);
// compiled member node returning call7762 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7763 = callmethodflags(call7762, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7758);
// compiled call node returning call7763 (depth = 3)
  struct UserObject *obj7486_uo = (struct UserObject *)obj7486;
  obj7486_uo->super = call7763;
  sourceObject = obj7486;
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7764 == NULL) {
    strlit7764 = alloc_String("op");
    gc_root(strlit7764);
  }
// compiled string node returning strlit7764 (depth = 3)
  adddatum2(obj7486, strlit7764, 1);
  sourceObject = obj7486;
// Begin line 1906
  setline(1906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_op (depth = 3)
  adddatum2(obj7486, *var_op, 2);
  sourceObject = obj7486;
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  adddatum2(obj7486, *var_l, 3);
  sourceObject = obj7486;
// Begin line 1908
  setline(1908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_r (depth = 3)
  adddatum2(obj7486, *var_r, 4);
  sourceObject = obj7486;
  sourceObject = obj7486;
  sourceObject = obj7486;
  sourceObject = obj7486;
  sourceObject = obj7486;
  sourceObject = obj7486;
  sourceObject = obj7486;
  sourceObject = obj7486;
  objclass7486 = obj7486->class;
  objclass7486->definitionModule = modulename;
  objclass7486->definitionLine = 1903;
  (*(struct UserObject *)self).data[0] = lowerouter7486;
  self = oldself7486;
  selfslot = oldselfslot7486;
  stackframe = oldstackframe7486;
  gc_frame_end(frame);
  return obj7486;
}
Object meth_ast_opNode7766(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "opNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_opNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1902
  setline(1902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_opNode (depth = 3)
  gc_frame_end(frame);
  return *var_opNode;
}
Object meth_ast_nameString7775(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7777 == NULL) {
    strlit7777 = alloc_String(":=(1)");
    gc_root(strlit7777);
  }
// compiled string node returning strlit7777 (depth = 4)
  int op_slot_right_7776 = gc_frame_newslot(strlit7777);
// starting to compile member node (depth = 4)
  int callframe7779 = gc_frame_new();
// call case 4: self request
  Object call7780 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7779);
// compiled member node returning call7780 (depth = 4)
  int op_slot_left_7776 = gc_frame_newslot(call7780);
  params[0] = strlit7777;
  partcv[0] = 1;
  Object opresult7781 = callmethod(call7780, "++(1)", 1, partcv, params);
// compiled op node returning opresult7781 (depth = 3)
  gc_frame_end(frame);
  return opresult7781;
}
Object meth_ast_canonicalName7782(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1978
  setline(1978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7784 == NULL) {
    strlit7784 = alloc_String(":=(_)");
    gc_root(strlit7784);
  }
// compiled string node returning strlit7784 (depth = 4)
  int op_slot_right_7783 = gc_frame_newslot(strlit7784);
// starting to compile member node (depth = 4)
  int callframe7786 = gc_frame_new();
// call case 4: self request
  Object call7787 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7786);
// compiled member node returning call7787 (depth = 4)
  int op_slot_left_7783 = gc_frame_newslot(call7787);
  params[0] = strlit7784;
  partcv[0] = 1;
  Object opresult7788 = callmethod(call7787, "++(1)", 1, partcv, params);
// compiled op node returning opresult7788 (depth = 3)
  gc_frame_end(frame);
  return opresult7788;
}
Object meth_ast_isBind7789(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7790 = alloc_Boolean(1);
// compiled identifier node returning bool7790 (depth = 3)
  gc_frame_end(frame);
  return bool7790;
}
Object meth_ast_asString7791(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1980
  setline(1980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7793 == NULL) {
    strlit7793 = alloc_String("");
    gc_root(strlit7793);
  }
// compiled string node returning strlit7793 (depth = 4)
  int op_slot_right_7792 = gc_frame_newslot(strlit7793);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe7796 = gc_frame_new();
// call case 4: self request
  Object call7797 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7796);
// compiled member node returning call7797 (depth = 5)
  int op_slot_right_7795 = gc_frame_newslot(call7797);
// starting to compile string node (depth = 5)
  if (strlit7799 == NULL) {
    strlit7799 = alloc_String("bind ");
    gc_root(strlit7799);
  }
// compiled string node returning strlit7799 (depth = 5)
  int op_slot_left_7795 = gc_frame_newslot(strlit7799);
  params[0] = call7797;
  partcv[0] = 1;
  Object opresult7800 = callmethod(strlit7799, "++(1)", 1, partcv, params);
// compiled op node returning opresult7800 (depth = 4)
  int op_slot_left_7792 = gc_frame_newslot(opresult7800);
  params[0] = strlit7793;
  partcv[0] = 1;
  Object opresult7801 = callmethod(opresult7800, "++(1)", 1, partcv, params);
// compiled op node returning opresult7801 (depth = 3)
  gc_frame_end(frame);
  return opresult7801;
}
Object meth_ast_accept_40_1_41_from_40_1_41_7802(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1982
  setline(1982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7804 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7805 = callmethodflags(*var_visitor, "visitBind(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7804);
// compiled call node returning call7805 (depth = 4)
  Object if7803 = done;
  if (istrue(call7805)) {
// Begin line 1983
  setline(1983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7806 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call7807 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7806);
// compiled call node returning call7807 (depth = 5)
  *var_newChain = call7807;
  if (call7807 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1984
  setline(1984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7808 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7809 = gc_frame_new();
// call case 4: self request
  Object call7810 = callmethodflags(self, "dest", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7809);
// compiled member node returning call7810 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7811 = callmethodflags(call7810, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7808);
// compiled call node returning call7811 (depth = 4)
// Begin line 1985
  setline(1985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7812 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7813 = gc_frame_new();
// call case 4: self request
  Object call7814 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7813);
// compiled member node returning call7814 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7815 = callmethodflags(call7814, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7812);
// compiled call node returning call7815 (depth = 4)
    gc_frame_newslot(call7815);
    if7803 = call7815;
  } else {
  }
// compiled if node returning if7803 (depth = 3)
  gc_frame_end(frame);
  return if7803;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_7816(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1989
  setline(1989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe7817 = gc_frame_new();
// call case 4: self request
  Object call7818 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7817);
// compiled member node returning call7818 (depth = 4)
  *var_n = call7818;
  if (call7818 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1990
  setline(1990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7819 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7820 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7819);
// compiled call node returning call7820 (depth = 4)
  *var_newChain = call7820;
  if (call7820 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7821 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7822 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7823 = gc_frame_new();
// call case 4: self request
  Object call7824 = callmethodflags(self, "dest", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7823);
// compiled member node returning call7824 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7825 = callmethodflags(call7824, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7822);
// compiled call node returning call7825 (depth = 4)
  gc_frame_newslot(call7825);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7825;
  partcv[0] = 1;
  Object call7826 = callmethodflags(*var_n, "dest:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7821);
// compiled call node returning call7826 (depth = 3)
// Begin line 1992
  setline(1992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7827 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7828 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7829 = gc_frame_new();
// call case 4: self request
  Object call7830 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7829);
// compiled member node returning call7830 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7831 = callmethodflags(call7830, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7828);
// compiled call node returning call7831 (depth = 4)
  gc_frame_newslot(call7831);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7831;
  partcv[0] = 1;
  Object call7832 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7827);
// compiled call node returning call7832 (depth = 3)
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7833 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7834 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7833);
// compiled call node returning call7834 (depth = 3)
  gc_frame_end(frame);
  return call7834;
}
Object meth_ast__apply_40_1_41_7843(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1998
  setline(1998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7845 == NULL) {
    strlit7845 = alloc_String("  ");
    gc_root(strlit7845);
  }
// compiled string node returning strlit7845 (depth = 7)
  int op_slot_right_7844 = gc_frame_newslot(strlit7845);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_7844 = gc_frame_newslot(*var_spc);
  params[0] = strlit7845;
  partcv[0] = 1;
  Object opresult7847 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult7847 (depth = 6)
  *var_spc = opresult7847;
  if (opresult7847 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_7835(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1996
  setline(1996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7836 == NULL) {
    strlit7836 = alloc_String("");
    gc_root(strlit7836);
  }
// compiled string node returning strlit7836 (depth = 4)
  *var_spc = strlit7836;
  if (strlit7836 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7837 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_7838 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num7840 = alloc_Float64(0);
// compiled num node returning num7840 (depth = 5)
  int op_slot_left_7838 = gc_frame_newslot(num7840);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7841 = callmethod(num7840, "..(1)", 1, partcv, params);
// compiled op node returning opresult7841 (depth = 4)
  gc_frame_newslot(opresult7841);
// starting to compile block node (depth = 4)
  Object block7842 = alloc_Block(NULL, NULL, "ast", 1997);
  gc_frame_newslot(block7842);
// method "_apply(_)"
  block_savedest(block7842);
  Object closure7843 = createclosure(2, "_apply(1)");
  setclosureframe(closure7843, stackframe);
  addtoclosure(closure7843, var_spc);
  addtoclosure(closure7843, selfslot);
  struct UserObject *uo7843 = (struct UserObject*)block7842;
  uo7843->data[0] = (Object)closure7843;
  Method *meth_meth_ast__apply_40_1_41_7843 = addmethod2pos(block7842, "_apply(1)", &meth_ast__apply_40_1_41_7843, 0);
  int argcv_meth_ast__apply_40_1_41_7843[] = {1};
  meth_meth_ast__apply_40_1_41_7843->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_7843);
  meth_meth_ast__apply_40_1_41_7843->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_7843->definitionLine = 2981;
// compiled block node returning block7842 (depth = 4)
  gc_frame_newslot(block7842);
// call case 5: prelude request
  params[0] = opresult7841;
  params[1] = block7842;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7850 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7837);
// compiled call node returning call7850 (depth = 3)
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7852 == NULL) {
    strlit7852 = alloc_String("""\x0a""");
    gc_root(strlit7852);
  }
// compiled string node returning strlit7852 (depth = 5)
  int op_slot_right_7851 = gc_frame_newslot(strlit7852);
// starting to compile call node (depth = 5)
  int callframe7854 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7855 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7854);
// compiled call node returning call7855 (depth = 5)
  int op_slot_left_7851 = gc_frame_newslot(call7855);
  params[0] = strlit7852;
  partcv[0] = 1;
  Object opresult7856 = callmethod(call7855, "++(1)", 1, partcv, params);
// compiled op node returning opresult7856 (depth = 4)
  *var_s = opresult7856;
  if (opresult7856 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2001
  setline(2001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7858 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7860 = alloc_Float64(1);
// compiled num node returning num7860 (depth = 7)
  int op_slot_right_7859 = gc_frame_newslot(num7860);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7859 = gc_frame_newslot(*var_depth);
  params[0] = num7860;
  partcv[0] = 1;
  Object sum7862 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7862 (depth = 6)
  gc_frame_newslot(sum7862);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7863 = gc_frame_new();
// call case 4: self request
  Object call7864 = callmethodflags(self, "dest", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7863);
// compiled member node returning call7864 (depth = 6)
  params[0] = sum7862;
  partcv[0] = 1;
  Object call7865 = callmethodflags(call7864, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7858);
// compiled call node returning call7865 (depth = 5)
  int op_slot_right_7857 = gc_frame_newslot(call7865);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7867 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7867 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7869 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7869 (depth = 5)
  int op_slot_left_7857 = gc_frame_newslot(opresult7869);
  params[0] = call7865;
  partcv[0] = 1;
  Object opresult7870 = callmethod(opresult7869, "++(1)", 1, partcv, params);
// compiled op node returning opresult7870 (depth = 4)
  *var_s = opresult7870;
  if (opresult7870 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2002
  setline(2002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7873 == NULL) {
    strlit7873 = alloc_String("""\x0a""");
    gc_root(strlit7873);
  }
// compiled string node returning strlit7873 (depth = 5)
  int op_slot_right_7872 = gc_frame_newslot(strlit7873);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_7872 = gc_frame_newslot(*var_s);
  params[0] = strlit7873;
  partcv[0] = 1;
  Object opresult7875 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7875 (depth = 4)
  *var_s = opresult7875;
  if (opresult7875 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7878 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7880 = alloc_Float64(1);
// compiled num node returning num7880 (depth = 7)
  int op_slot_right_7879 = gc_frame_newslot(num7880);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7879 = gc_frame_newslot(*var_depth);
  params[0] = num7880;
  partcv[0] = 1;
  Object sum7882 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7882 (depth = 6)
  gc_frame_newslot(sum7882);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7883 = gc_frame_new();
// call case 4: self request
  Object call7884 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7883);
// compiled member node returning call7884 (depth = 6)
  params[0] = sum7882;
  partcv[0] = 1;
  Object call7885 = callmethodflags(call7884, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7878);
// compiled call node returning call7885 (depth = 5)
  int op_slot_right_7877 = gc_frame_newslot(call7885);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7887 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7887 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7889 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7889 (depth = 5)
  int op_slot_left_7877 = gc_frame_newslot(opresult7889);
  params[0] = call7885;
  partcv[0] = 1;
  Object opresult7890 = callmethod(opresult7889, "++(1)", 1, partcv, params);
// compiled op node returning opresult7890 (depth = 4)
  *var_s = opresult7890;
  if (opresult7890 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_7904(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2009
  setline(2009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7906 == NULL) {
    strlit7906 = alloc_String("    ");
    gc_root(strlit7906);
  }
// compiled string node returning strlit7906 (depth = 7)
  int op_slot_right_7905 = gc_frame_newslot(strlit7906);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_7905 = gc_frame_newslot(*var_spc);
  params[0] = strlit7906;
  partcv[0] = 1;
  Object opresult7908 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult7908 (depth = 6)
  *var_spc = opresult7908;
  if (opresult7908 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_7892(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2007
  setline(2007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7893 == NULL) {
    strlit7893 = alloc_String("");
    gc_root(strlit7893);
  }
// compiled string node returning strlit7893 (depth = 4)
  *var_spc = strlit7893;
  if (strlit7893 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7894 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7897 = alloc_Float64(1);
// compiled num node returning num7897 (depth = 6)
  int op_slot_right_7896 = gc_frame_newslot(num7897);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_7896 = gc_frame_newslot(*var_depth);
  params[0] = num7897;
  partcv[0] = 1;
  Object diff7899 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff7899 (depth = 5)
  int op_slot_right_7895 = gc_frame_newslot(diff7899);
// starting to compile num node (depth = 5)
  Object num7901 = alloc_Float64(0);
// compiled num node returning num7901 (depth = 5)
  int op_slot_left_7895 = gc_frame_newslot(num7901);
  params[0] = diff7899;
  partcv[0] = 1;
  Object opresult7902 = callmethod(num7901, "..(1)", 1, partcv, params);
// compiled op node returning opresult7902 (depth = 4)
  gc_frame_newslot(opresult7902);
// starting to compile block node (depth = 4)
  Object block7903 = alloc_Block(NULL, NULL, "ast", 2008);
  gc_frame_newslot(block7903);
// method "_apply(_)"
  block_savedest(block7903);
  Object closure7904 = createclosure(2, "_apply(1)");
  setclosureframe(closure7904, stackframe);
  addtoclosure(closure7904, var_spc);
  addtoclosure(closure7904, selfslot);
  struct UserObject *uo7904 = (struct UserObject*)block7903;
  uo7904->data[0] = (Object)closure7904;
  Method *meth_meth_ast__apply_40_1_41_7904 = addmethod2pos(block7903, "_apply(1)", &meth_ast__apply_40_1_41_7904, 0);
  int argcv_meth_ast__apply_40_1_41_7904[] = {1};
  meth_meth_ast__apply_40_1_41_7904->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_7904);
  meth_meth_ast__apply_40_1_41_7904->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_7904->definitionLine = 2981;
// compiled block node returning block7903 (depth = 4)
  gc_frame_newslot(block7903);
// call case 5: prelude request
  params[0] = opresult7902;
  params[1] = block7903;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7911 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7894);
// compiled call node returning call7911 (depth = 3)
// Begin line 2011
  setline(2011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7912 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7914 = alloc_Float64(1);
// compiled num node returning num7914 (depth = 6)
  int op_slot_right_7913 = gc_frame_newslot(num7914);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_7913 = gc_frame_newslot(*var_depth);
  params[0] = num7914;
  partcv[0] = 1;
  Object sum7916 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7916 (depth = 5)
  gc_frame_newslot(sum7916);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7917 = gc_frame_new();
// call case 4: self request
  Object call7918 = callmethodflags(self, "dest", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7917);
// compiled member node returning call7918 (depth = 5)
  params[0] = sum7916;
  partcv[0] = 1;
  Object call7919 = callmethodflags(call7918, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7912);
// compiled call node returning call7919 (depth = 4)
  *var_s = call7919;
  if (call7919 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2012
  setline(2012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7921 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7923 = alloc_Float64(1);
// compiled num node returning num7923 (depth = 7)
  int op_slot_right_7922 = gc_frame_newslot(num7923);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7922 = gc_frame_newslot(*var_depth);
  params[0] = num7923;
  partcv[0] = 1;
  Object sum7925 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum7925 (depth = 6)
  gc_frame_newslot(sum7925);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7926 = gc_frame_new();
// call case 4: self request
  Object call7927 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7926);
// compiled member node returning call7927 (depth = 6)
  params[0] = sum7925;
  partcv[0] = 1;
  Object call7928 = callmethodflags(call7927, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7921);
// compiled call node returning call7928 (depth = 5)
  int op_slot_right_7920 = gc_frame_newslot(call7928);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7931 == NULL) {
    strlit7931 = alloc_String(" := ");
    gc_root(strlit7931);
  }
// compiled string node returning strlit7931 (depth = 6)
  int op_slot_right_7930 = gc_frame_newslot(strlit7931);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7930 = gc_frame_newslot(*var_s);
  params[0] = strlit7931;
  partcv[0] = 1;
  Object opresult7933 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult7933 (depth = 5)
  int op_slot_left_7920 = gc_frame_newslot(opresult7933);
  params[0] = call7928;
  partcv[0] = 1;
  Object opresult7934 = callmethod(opresult7933, "++(1)", 1, partcv, params);
// compiled op node returning opresult7934 (depth = 4)
  *var_s = opresult7934;
  if (opresult7934 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy7936(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2016
  setline(2016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7937 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe7938 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe7939 = gc_frame_new();
// call case 4: self request
  Object call7940 = callmethodflags(self, "dest", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7939);
// compiled member node returning call7940 (depth = 5)
  gc_frame_newslot(call7940);
// starting to compile member node (depth = 5)
  int callframe7941 = gc_frame_new();
// call case 4: self request
  Object call7942 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7941);
// compiled member node returning call7942 (depth = 5)
  gc_frame_newslot(call7942);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_bindNode (depth = 5)
  params[0] = call7940;
  params[1] = call7942;
  partcv[0] = 2;
  Object call7943 = callmethodflags(*var_bindNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7938);
// compiled call node returning call7943 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7944 = callmethodflags(call7943, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7937);
// compiled call node returning call7944 (depth = 3)
  gc_frame_end(frame);
  return call7944;
}
Object meth_ast_statementName7945(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2018
  setline(2018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7946 == NULL) {
    strlit7946 = alloc_String("assignment or assigment request");
    gc_root(strlit7946);
  }
// compiled string node returning strlit7946 (depth = 3)
  gc_frame_end(frame);
  return strlit7946;
}
Object meth_ast_new_40_2_41_7769(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dest_39_ = &(stackframe->slots[0]);
  *var_dest_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7770 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7770 = alloc_userobj2(15,14, objclass7770);
  gc_frame_newslot(obj7770);
if (objclass7770 == NULL) {
  glfree(obj7770->class->name);
  obj7770->class->name = "bindNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7770, self, 0);
  addmethodreal(obj7770,"outer", &reader_ast_outer_7771);
  Object oldself7770 = self;
  struct StackFrameObject *oldstackframe7770 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7770);
  gc_frame_newslot((Object)stackframe);
  self = obj7770;
  Object *oldselfslot7770 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7770 = (*(struct UserObject *)self).data[0], lowerouter7770 = thisouter7770;
  if (inheritingObject7770) {
    struct UserObject *inho7770 = (struct UserObject *)inheritingObject7770;
    while (inho7770->super != GraceDefaultObject) inho7770 = (struct UserObject *)inho7770->super;
    inho7770->super = obj7770;
    self = inheritingObject7770;
    *selfslot = self;
    lowerouter7770 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7770;
  }
if (objclass7770 == NULL) {
  Method *reader7772 = addmethodrealflags(obj7770, "kind",&reader_ast_kind_7772, MFLAG_DEF);
  reader7772->definitionModule = modulename;
  reader7772->definitionLine = 1973;
}
adddatum2(obj7770, alloc_Undefined(), 1);
if (objclass7770 == NULL) {
  Method *reader7773 = addmethodrealflags(obj7770, "dest", &reader_ast_dest_7773, 0);
  Method *writer7773 = addmethodrealflags(obj7770, "dest:=(1)", &writer_ast_dest_7773, 0);
  reader7773->definitionModule = modulename;
  writer7773->definitionModule = modulename;
  reader7773->definitionLine = 1974;
  writer7773->definitionLine = 1974;
}
obj7770->flags |= OFLAG_MUTABLE;
adddatum2(obj7770, alloc_Undefined(), 2);
if (objclass7770 == NULL) {
  Method *reader7774 = addmethodrealflags(obj7770, "value", &reader_ast_value_7774, 0);
  Method *writer7774 = addmethodrealflags(obj7770, "value:=(1)", &writer_ast_value_7774, 0);
  reader7774->definitionModule = modulename;
  writer7774->definitionModule = modulename;
  reader7774->definitionLine = 1975;
  writer7774->definitionLine = 1975;
}
obj7770->flags |= OFLAG_MUTABLE;
adddatum2(obj7770, alloc_Undefined(), 3);
// method "nameString"
  struct UserObject *uo7775 = (struct UserObject*)obj7770;
  uo7775->data[4] = emptyclosure;
  Method *meth_meth_ast_nameString7775 = addmethod2pos(obj7770, "nameString", &meth_ast_nameString7775, 4);
  int argcv_meth_ast_nameString7775[] = {0};
  meth_meth_ast_nameString7775->type = alloc_MethodType(1, argcv_meth_ast_nameString7775);
  meth_meth_ast_nameString7775->definitionModule = modulename;
  meth_meth_ast_nameString7775->definitionLine = 1977;
// method "canonicalName"
  struct UserObject *uo7782 = (struct UserObject*)obj7770;
  uo7782->data[5] = emptyclosure;
  Method *meth_meth_ast_canonicalName7782 = addmethod2pos(obj7770, "canonicalName", &meth_ast_canonicalName7782, 5);
  int argcv_meth_ast_canonicalName7782[] = {0};
  meth_meth_ast_canonicalName7782->type = alloc_MethodType(1, argcv_meth_ast_canonicalName7782);
  meth_meth_ast_canonicalName7782->definitionModule = modulename;
  meth_meth_ast_canonicalName7782->definitionLine = 1978;
// method "isBind"
  struct UserObject *uo7789 = (struct UserObject*)obj7770;
  uo7789->data[6] = emptyclosure;
  Method *meth_meth_ast_isBind7789 = addmethod2pos(obj7770, "isBind", &meth_ast_isBind7789, 6);
  int argcv_meth_ast_isBind7789[] = {0};
  meth_meth_ast_isBind7789->type = alloc_MethodType(1, argcv_meth_ast_isBind7789);
  meth_meth_ast_isBind7789->definitionModule = modulename;
  meth_meth_ast_isBind7789->definitionLine = 1979;
// method "asString"
  struct UserObject *uo7791 = (struct UserObject*)obj7770;
  uo7791->data[7] = emptyclosure;
  Method *meth_meth_ast_asString7791 = addmethod2pos(obj7770, "asString", &meth_ast_asString7791, 7);
  int argcv_meth_ast_asString7791[] = {0};
  meth_meth_ast_asString7791->type = alloc_MethodType(1, argcv_meth_ast_asString7791);
  meth_meth_ast_asString7791->definitionModule = modulename;
  meth_meth_ast_asString7791->definitionLine = 1980;
// method "accept(_)from(_)"
  struct UserObject *uo7802 = (struct UserObject*)obj7770;
  uo7802->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_7802 = addmethod2pos(obj7770, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_7802, 8);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_7802[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_7802->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_7802);
  meth_meth_ast_accept_40_1_41_from_40_1_41_7802->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_7802->definitionLine = 1981;
// method "map(_)ancestors(_)"
  struct UserObject *uo7816 = (struct UserObject*)obj7770;
  uo7816->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_7816 = addmethod2pos(obj7770, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_7816, 9);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7816[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7816->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7816);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7816->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7816->definitionLine = 1988;
// method "pretty(_)"
  struct UserObject *uo7835 = (struct UserObject*)obj7770;
  uo7835->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_7835 = addmethod2pos(obj7770, "pretty(1)", &meth_ast_pretty_40_1_41_7835, 10);
  int argcv_meth_ast_pretty_40_1_41_7835[] = {1};
  meth_meth_ast_pretty_40_1_41_7835->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_7835);
  meth_meth_ast_pretty_40_1_41_7835->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_7835->definitionLine = 1995;
// method "toGrace(_)"
  struct UserObject *uo7892 = (struct UserObject*)obj7770;
  uo7892->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7892 = addmethod2pos(obj7770, "toGrace(1)", &meth_ast_toGrace_40_1_41_7892, 11);
  int argcv_meth_ast_toGrace_40_1_41_7892[] = {1};
  meth_meth_ast_toGrace_40_1_41_7892->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7892);
meth_meth_ast_toGrace_40_1_41_7892->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7892->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7892->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7892->definitionLine = 2006;
// method "shallowCopy"
  block_savedest(obj7770);
  Object closure7936 = createclosure(1, "shallowCopy");
  setclosureframe(closure7936, stackframe);
  addtoclosure(closure7936, var_bindNode);
  struct UserObject *uo7936 = (struct UserObject*)obj7770;
  uo7936->data[12] = (Object)closure7936;
  Method *meth_meth_ast_shallowCopy7936 = addmethod2pos(obj7770, "shallowCopy", &meth_ast_shallowCopy7936, 12);
  int argcv_meth_ast_shallowCopy7936[] = {0};
  meth_meth_ast_shallowCopy7936->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7936);
  meth_meth_ast_shallowCopy7936->definitionModule = modulename;
  meth_meth_ast_shallowCopy7936->definitionLine = 2015;
// method "statementName"
  struct UserObject *uo7945 = (struct UserObject*)obj7770;
  uo7945->data[13] = emptyclosure;
  Method *meth_meth_ast_statementName7945 = addmethod2pos(obj7770, "statementName", &meth_ast_statementName7945, 13);
  int argcv_meth_ast_statementName7945[] = {0};
  meth_meth_ast_statementName7945->type = alloc_MethodType(1, argcv_meth_ast_statementName7945);
  meth_meth_ast_statementName7945->definitionModule = modulename;
  meth_meth_ast_statementName7945->definitionLine = 2018;
  sourceObject = obj7770;
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7947 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7948 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7949 = gc_frame_new();
// call case 3: self.outer request
  Object call7950 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7949);
// compiled member node returning call7950 (depth = 5)
  Object call7951 = callmethodflags(call7950, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7948);
// compiled member node returning call7951 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7952 = callmethodflags(call7951, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7947);
// compiled call node returning call7952 (depth = 3)
  struct UserObject *obj7770_uo = (struct UserObject *)obj7770;
  obj7770_uo->super = call7952;
  sourceObject = obj7770;
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7953 == NULL) {
    strlit7953 = alloc_String("bind");
    gc_root(strlit7953);
  }
// compiled string node returning strlit7953 (depth = 3)
  adddatum2(obj7770, strlit7953, 1);
  sourceObject = obj7770;
// Begin line 1974
  setline(1974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dest_39_ (depth = 3)
  adddatum2(obj7770, *var_dest_39_, 2);
  sourceObject = obj7770;
// Begin line 1975
  setline(1975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj7770, *var_val_39_, 3);
  sourceObject = obj7770;
  sourceObject = obj7770;
  sourceObject = obj7770;
  sourceObject = obj7770;
  sourceObject = obj7770;
  sourceObject = obj7770;
  sourceObject = obj7770;
  sourceObject = obj7770;
  sourceObject = obj7770;
  sourceObject = obj7770;
  objclass7770 = obj7770->class;
  objclass7770->definitionModule = modulename;
  objclass7770->definitionLine = 1970;
  (*(struct UserObject *)self).data[0] = lowerouter7770;
  self = oldself7770;
  selfslot = oldselfslot7770;
  stackframe = oldstackframe7770;
  gc_frame_end(frame);
  return obj7770;
}
Object meth_ast_new_40_2_41_7769_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dest_39_ = &(stackframe->slots[0]);
  *var_dest_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7770 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7770 = alloc_userobj2(15,14, objclass7770);
  gc_frame_newslot(obj7770);
if (objclass7770 == NULL) {
  glfree(obj7770->class->name);
  obj7770->class->name = "bindNode.new(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7770, self, 0);
  addmethodreal(obj7770,"outer", &reader_ast_outer_7771);
  Object oldself7770 = self;
  struct StackFrameObject *oldstackframe7770 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7770);
  gc_frame_newslot((Object)stackframe);
  self = obj7770;
  Object *oldselfslot7770 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7770 = (*(struct UserObject *)self).data[0], lowerouter7770 = thisouter7770;
  if (inheritingObject7770) {
    struct UserObject *inho7770 = (struct UserObject *)inheritingObject7770;
    while (inho7770->super != GraceDefaultObject) inho7770 = (struct UserObject *)inho7770->super;
    inho7770->super = obj7770;
    self = inheritingObject7770;
    *selfslot = self;
    lowerouter7770 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7770;
  }
if (objclass7770 == NULL) {
  Method *reader7772 = addmethodrealflags(obj7770, "kind",&reader_ast_kind_7772, MFLAG_DEF);
  reader7772->definitionModule = modulename;
  reader7772->definitionLine = 1973;
}
adddatum2(obj7770, alloc_Undefined(), 1);
if (objclass7770 == NULL) {
  Method *reader7773 = addmethodrealflags(obj7770, "dest", &reader_ast_dest_7773, 0);
  Method *writer7773 = addmethodrealflags(obj7770, "dest:=(1)", &writer_ast_dest_7773, 0);
  reader7773->definitionModule = modulename;
  writer7773->definitionModule = modulename;
  reader7773->definitionLine = 1974;
  writer7773->definitionLine = 1974;
}
obj7770->flags |= OFLAG_MUTABLE;
adddatum2(obj7770, alloc_Undefined(), 2);
if (objclass7770 == NULL) {
  Method *reader7774 = addmethodrealflags(obj7770, "value", &reader_ast_value_7774, 0);
  Method *writer7774 = addmethodrealflags(obj7770, "value:=(1)", &writer_ast_value_7774, 0);
  reader7774->definitionModule = modulename;
  writer7774->definitionModule = modulename;
  reader7774->definitionLine = 1975;
  writer7774->definitionLine = 1975;
}
obj7770->flags |= OFLAG_MUTABLE;
adddatum2(obj7770, alloc_Undefined(), 3);
// method "nameString"
  struct UserObject *uo7775 = (struct UserObject*)obj7770;
  uo7775->data[4] = emptyclosure;
  Method *meth_meth_ast_nameString7775 = addmethod2pos(obj7770, "nameString", &meth_ast_nameString7775, 4);
  int argcv_meth_ast_nameString7775[] = {0};
  meth_meth_ast_nameString7775->type = alloc_MethodType(1, argcv_meth_ast_nameString7775);
  meth_meth_ast_nameString7775->definitionModule = modulename;
  meth_meth_ast_nameString7775->definitionLine = 1977;
// method "canonicalName"
  struct UserObject *uo7782 = (struct UserObject*)obj7770;
  uo7782->data[5] = emptyclosure;
  Method *meth_meth_ast_canonicalName7782 = addmethod2pos(obj7770, "canonicalName", &meth_ast_canonicalName7782, 5);
  int argcv_meth_ast_canonicalName7782[] = {0};
  meth_meth_ast_canonicalName7782->type = alloc_MethodType(1, argcv_meth_ast_canonicalName7782);
  meth_meth_ast_canonicalName7782->definitionModule = modulename;
  meth_meth_ast_canonicalName7782->definitionLine = 1978;
// method "isBind"
  struct UserObject *uo7789 = (struct UserObject*)obj7770;
  uo7789->data[6] = emptyclosure;
  Method *meth_meth_ast_isBind7789 = addmethod2pos(obj7770, "isBind", &meth_ast_isBind7789, 6);
  int argcv_meth_ast_isBind7789[] = {0};
  meth_meth_ast_isBind7789->type = alloc_MethodType(1, argcv_meth_ast_isBind7789);
  meth_meth_ast_isBind7789->definitionModule = modulename;
  meth_meth_ast_isBind7789->definitionLine = 1979;
// method "asString"
  struct UserObject *uo7791 = (struct UserObject*)obj7770;
  uo7791->data[7] = emptyclosure;
  Method *meth_meth_ast_asString7791 = addmethod2pos(obj7770, "asString", &meth_ast_asString7791, 7);
  int argcv_meth_ast_asString7791[] = {0};
  meth_meth_ast_asString7791->type = alloc_MethodType(1, argcv_meth_ast_asString7791);
  meth_meth_ast_asString7791->definitionModule = modulename;
  meth_meth_ast_asString7791->definitionLine = 1980;
// method "accept(_)from(_)"
  struct UserObject *uo7802 = (struct UserObject*)obj7770;
  uo7802->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_7802 = addmethod2pos(obj7770, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_7802, 8);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_7802[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_7802->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_7802);
  meth_meth_ast_accept_40_1_41_from_40_1_41_7802->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_7802->definitionLine = 1981;
// method "map(_)ancestors(_)"
  struct UserObject *uo7816 = (struct UserObject*)obj7770;
  uo7816->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_7816 = addmethod2pos(obj7770, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_7816, 9);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7816[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7816->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_7816);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7816->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_7816->definitionLine = 1988;
// method "pretty(_)"
  struct UserObject *uo7835 = (struct UserObject*)obj7770;
  uo7835->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_7835 = addmethod2pos(obj7770, "pretty(1)", &meth_ast_pretty_40_1_41_7835, 10);
  int argcv_meth_ast_pretty_40_1_41_7835[] = {1};
  meth_meth_ast_pretty_40_1_41_7835->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_7835);
  meth_meth_ast_pretty_40_1_41_7835->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_7835->definitionLine = 1995;
// method "toGrace(_)"
  struct UserObject *uo7892 = (struct UserObject*)obj7770;
  uo7892->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_7892 = addmethod2pos(obj7770, "toGrace(1)", &meth_ast_toGrace_40_1_41_7892, 11);
  int argcv_meth_ast_toGrace_40_1_41_7892[] = {1};
  meth_meth_ast_toGrace_40_1_41_7892->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_7892);
meth_meth_ast_toGrace_40_1_41_7892->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_7892->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_7892->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_7892->definitionLine = 2006;
// method "shallowCopy"
  block_savedest(obj7770);
  Object closure7936 = createclosure(1, "shallowCopy");
  setclosureframe(closure7936, stackframe);
  addtoclosure(closure7936, var_bindNode);
  struct UserObject *uo7936 = (struct UserObject*)obj7770;
  uo7936->data[12] = (Object)closure7936;
  Method *meth_meth_ast_shallowCopy7936 = addmethod2pos(obj7770, "shallowCopy", &meth_ast_shallowCopy7936, 12);
  int argcv_meth_ast_shallowCopy7936[] = {0};
  meth_meth_ast_shallowCopy7936->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7936);
  meth_meth_ast_shallowCopy7936->definitionModule = modulename;
  meth_meth_ast_shallowCopy7936->definitionLine = 2015;
// method "statementName"
  struct UserObject *uo7945 = (struct UserObject*)obj7770;
  uo7945->data[13] = emptyclosure;
  Method *meth_meth_ast_statementName7945 = addmethod2pos(obj7770, "statementName", &meth_ast_statementName7945, 13);
  int argcv_meth_ast_statementName7945[] = {0};
  meth_meth_ast_statementName7945->type = alloc_MethodType(1, argcv_meth_ast_statementName7945);
  meth_meth_ast_statementName7945->definitionModule = modulename;
  meth_meth_ast_statementName7945->definitionLine = 2018;
  sourceObject = obj7770;
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7947 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7948 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7949 = gc_frame_new();
// call case 3: self.outer request
  Object call7950 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7949);
// compiled member node returning call7950 (depth = 5)
  Object call7951 = callmethodflags(call7950, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7948);
// compiled member node returning call7951 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7952 = callmethodflags(call7951, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe7947);
// compiled call node returning call7952 (depth = 3)
  struct UserObject *obj7770_uo = (struct UserObject *)obj7770;
  obj7770_uo->super = call7952;
  sourceObject = obj7770;
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7953 == NULL) {
    strlit7953 = alloc_String("bind");
    gc_root(strlit7953);
  }
// compiled string node returning strlit7953 (depth = 3)
  adddatum2(obj7770, strlit7953, 1);
  sourceObject = obj7770;
// Begin line 1974
  setline(1974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dest_39_ (depth = 3)
  adddatum2(obj7770, *var_dest_39_, 2);
  sourceObject = obj7770;
// Begin line 1975
  setline(1975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj7770, *var_val_39_, 3);
  sourceObject = obj7770;
  sourceObject = obj7770;
  sourceObject = obj7770;
  sourceObject = obj7770;
  sourceObject = obj7770;
  sourceObject = obj7770;
  sourceObject = obj7770;
  sourceObject = obj7770;
  sourceObject = obj7770;
  sourceObject = obj7770;
  objclass7770 = obj7770->class;
  objclass7770->definitionModule = modulename;
  objclass7770->definitionLine = 1970;
  (*(struct UserObject *)self).data[0] = lowerouter7770;
  self = oldself7770;
  selfslot = oldselfslot7770;
  stackframe = oldstackframe7770;
  gc_frame_end(frame);
  return obj7770;
}
Object meth_ast_bindNode7955(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1969
  setline(1969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_bindNode (depth = 3)
  gc_frame_end(frame);
  return *var_bindNode;
}
Object meth_ast_new_40_3_41_scope_40_1_41_7958(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(3)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)scope(_)");
  Object params[3];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *var_s = &(stackframe->slots[3]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "result");
// Begin line 2023
  setline(2023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7959 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name_39_ (depth = 5)
  gc_frame_newslot(*var_name_39_);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype_39_ (depth = 5)
  gc_frame_newslot(*var_dtype_39_);
// call case 4: self request
  params[0] = *var_name_39_;
  params[1] = *var_val;
  params[2] = *var_dtype_39_;
  partcv[0] = 3;
  Object call7960 = callmethodflags(self, "new(3)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7959);
// compiled call node returning call7960 (depth = 4)
  *var_result = call7960;
  if (call7960 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2024
  setline(2024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7961 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call7962 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe7961);
// compiled call node returning call7962 (depth = 3)
// Begin line 2025
  setline(2025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_isPublic7973(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2040
  setline(2040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num7976 = alloc_Float64(0);
// compiled num node returning num7976 (depth = 5)
  int op_slot_right_7975 = gc_frame_newslot(num7976);
// starting to compile member node (depth = 5)
  int callframe7978 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7979 = gc_frame_new();
// call case 4: self request
  Object call7980 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7979);
// compiled member node returning call7980 (depth = 6)
  Object call7981 = callmethodflags(call7980, "size", 0, partcv, params, 0);
  gc_frame_end(callframe7978);
// compiled member node returning call7981 (depth = 5)
  int op_slot_left_7975 = gc_frame_newslot(call7981);
  params[0] = num7976;
  partcv[0] = 1;
  Object opresult7982 = callmethod(call7981, "==(1)", 1, partcv, params);
// compiled op node returning opresult7982 (depth = 4)
  Object if7974 = done;
  if (istrue(opresult7982)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7983 = alloc_Boolean(0);
// compiled identifier node returning bool7983 (depth = 5)
  return bool7983;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if7974 = undefined;
  } else {
  }
// compiled if node returning if7974 (depth = 3)
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7985 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit7986 == NULL) {
    strlit7986 = alloc_String("public");
    gc_root(strlit7986);
  }
// compiled string node returning strlit7986 (depth = 5)
  gc_frame_newslot(strlit7986);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7987 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe7988 = gc_frame_new();
// call case 3: self.outer request
  Object call7989 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7988);
// compiled member node returning call7989 (depth = 6)
  Object call7990 = callmethodflags(call7989, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7987);
// compiled member node returning call7990 (depth = 5)
  params[0] = self;
  params[1] = strlit7986;
  partcv[0] = 2;
  Object call7991 = callmethodflags(call7990, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7985);
// compiled call node returning call7991 (depth = 4)
  Object if7984 = done;
  if (istrue(call7991)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7992 = alloc_Boolean(1);
// compiled identifier node returning bool7992 (depth = 5)
  return bool7992;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if7984 = undefined;
  } else {
  }
// compiled if node returning if7984 (depth = 3)
// Begin line 2042
  setline(2042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7993 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit7994 == NULL) {
    strlit7994 = alloc_String("readable");
    gc_root(strlit7994);
  }
// compiled string node returning strlit7994 (depth = 4)
  gc_frame_newslot(strlit7994);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe7995 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe7996 = gc_frame_new();
// call case 3: self.outer request
  Object call7997 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7996);
// compiled member node returning call7997 (depth = 5)
  Object call7998 = callmethodflags(call7997, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe7995);
// compiled member node returning call7998 (depth = 4)
  params[0] = self;
  params[1] = strlit7994;
  partcv[0] = 2;
  Object call7999 = callmethodflags(call7998, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7993);
// compiled call node returning call7999 (depth = 3)
  gc_frame_end(frame);
  return call7999;
}
Object meth_ast_isFieldDec8000(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2044
  setline(2044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8001 = alloc_Boolean(1);
// compiled identifier node returning bool8001 (depth = 3)
  gc_frame_end(frame);
  return bool8001;
}
Object meth_ast_isWritable8002(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2045
  setline(2045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8003 = alloc_Boolean(0);
// compiled identifier node returning bool8003 (depth = 3)
  gc_frame_end(frame);
  return bool8003;
}
Object meth_ast_isReadable8004(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2046
  setline(2046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8005 = gc_frame_new();
// call case 4: self request
  Object call8006 = callmethodflags(self, "isPublic", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8005);
// compiled member node returning call8006 (depth = 3)
  gc_frame_end(frame);
  return call8006;
}
Object meth_ast_returnsObject8007(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2049
  setline(2049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8008 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8009 = gc_frame_new();
// call case 4: self request
  Object call8010 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8009);
// compiled member node returning call8010 (depth = 4)
  Object call8011 = callmethodflags(call8010, "returnsObject", 0, partcv, params, 0);
  gc_frame_end(callframe8008);
// compiled member node returning call8011 (depth = 3)
  gc_frame_end(frame);
  return call8011;
}
Object meth_ast_returnedObjectScope8012(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8013 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8014 = gc_frame_new();
// call case 4: self request
  Object call8015 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8014);
// compiled member node returning call8015 (depth = 4)
  Object call8016 = callmethodflags(call8015, "returnedObjectScope", 0, partcv, params, 0);
  gc_frame_end(callframe8013);
// compiled member node returning call8016 (depth = 3)
  gc_frame_end(frame);
  return call8016;
}
Object meth_ast_usesAsType_40_1_41_8017(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part usesAsType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2056
  setline(2056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8019 = gc_frame_new();
// call case 4: self request
  Object call8020 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8019);
// compiled member node returning call8020 (depth = 4)
  int op_slot_right_8018 = gc_frame_newslot(call8020);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_8018 = gc_frame_newslot(*var_aNode);
  params[0] = call8020;
  partcv[0] = 1;
  Object opresult8022 = callmethod(*var_aNode, "==(1)", 1, partcv, params);
// compiled op node returning opresult8022 (depth = 3)
  gc_frame_end(frame);
  return opresult8022;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_8023(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2058
  setline(2058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8024 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call8025 = callmethodflags(*var_k, "defdec", 0, partcv, params, 0);
  gc_frame_end(callframe8024);
// compiled member node returning call8025 (depth = 3)
  gc_frame_end(frame);
  return call8025;
}
Object meth_ast__apply_40_1_41_8051(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2068
  setline(2068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8052 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8053 = callmethodflags(*var_ann, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8052);
// compiled call node returning call8053 (depth = 6)
  gc_frame_end(frame);
  return call8053;
}
Object meth_ast_accept_40_1_41_from_40_1_41_8026(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8028 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8029 = callmethodflags(*var_visitor, "visitDefDec(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8028);
// compiled call node returning call8029 (depth = 4)
  Object if8027 = done;
  if (istrue(call8029)) {
// Begin line 2062
  setline(2062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8030 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call8031 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8030);
// compiled call node returning call8031 (depth = 5)
  *var_newChain = call8031;
  if (call8031 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2063
  setline(2063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8032 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8033 = gc_frame_new();
// call case 4: self request
  Object call8034 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8033);
// compiled member node returning call8034 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8035 = callmethodflags(call8034, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8032);
// compiled call node returning call8035 (depth = 4)
// Begin line 2064
  setline(2064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8038 = gc_frame_new();
// call case 4: self request
  Object call8039 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8038);
// compiled member node returning call8039 (depth = 6)
  int op_slot_right_8037 = gc_frame_newslot(call8039);
// starting to compile identifier node (depth = 6)
  Object bool8041 = alloc_Boolean(0);
// compiled identifier node returning bool8041 (depth = 6)
  int op_slot_left_8037 = gc_frame_newslot(bool8041);
  params[0] = call8039;
  partcv[0] = 1;
  Object opresult8042 = callmethod(bool8041, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8042 (depth = 5)
  Object if8036 = done;
  if (istrue(opresult8042)) {
// Begin line 2065
  setline(2065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8043 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8044 = gc_frame_new();
// call case 4: self request
  Object call8045 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8044);
// compiled member node returning call8045 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8046 = callmethodflags(call8045, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8043);
// compiled call node returning call8046 (depth = 5)
    gc_frame_newslot(call8046);
    if8036 = call8046;
  } else {
  }
// compiled if node returning if8036 (depth = 4)
// Begin line 2067
  setline(2067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8047 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8048 = gc_frame_new();
// call case 4: self request
  Object call8049 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8048);
// compiled member node returning call8049 (depth = 5)
  gc_frame_newslot(call8049);
// starting to compile block node (depth = 5)
  Object block8050 = alloc_Block(NULL, NULL, "ast", 2067);
  gc_frame_newslot(block8050);
// method "_apply(_)"
  block_savedest(block8050);
  Object closure8051 = createclosure(3, "_apply(1)");
  setclosureframe(closure8051, stackframe);
  addtoclosure(closure8051, var_visitor);
  addtoclosure(closure8051, var_newChain);
  addtoclosure(closure8051, selfslot);
  struct UserObject *uo8051 = (struct UserObject*)block8050;
  uo8051->data[0] = (Object)closure8051;
  Method *meth_meth_ast__apply_40_1_41_8051 = addmethod2pos(block8050, "_apply(1)", &meth_ast__apply_40_1_41_8051, 0);
  int argcv_meth_ast__apply_40_1_41_8051[] = {1};
  meth_meth_ast__apply_40_1_41_8051->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_8051);
  meth_meth_ast__apply_40_1_41_8051->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_8051->definitionLine = 2981;
// compiled block node returning block8050 (depth = 5)
  gc_frame_newslot(block8050);
// call case 5: prelude request
  params[0] = call8049;
  params[1] = block8050;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8055 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8047);
// compiled call node returning call8055 (depth = 4)
// Begin line 2070
  setline(2070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8056 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8057 = gc_frame_new();
// call case 4: self request
  Object call8058 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8057);
// compiled member node returning call8058 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8059 = callmethodflags(call8058, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8056);
// compiled call node returning call8059 (depth = 4)
    gc_frame_newslot(call8059);
    if8027 = call8059;
  } else {
  }
// compiled if node returning if8027 (depth = 3)
  gc_frame_end(frame);
  return if8027;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_8060(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2074
  setline(2074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8061 = gc_frame_new();
// call case 4: self request
  Object call8062 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8061);
// compiled member node returning call8062 (depth = 4)
  *var_n = call8062;
  if (call8062 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2075
  setline(2075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8063 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8064 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8063);
// compiled call node returning call8064 (depth = 4)
  *var_newChain = call8064;
  if (call8064 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2076
  setline(2076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8065 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8066 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8067 = gc_frame_new();
// call case 4: self request
  Object call8068 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8067);
// compiled member node returning call8068 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8069 = callmethodflags(call8068, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8066);
// compiled call node returning call8069 (depth = 4)
  gc_frame_newslot(call8069);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8069;
  partcv[0] = 1;
  Object call8070 = callmethodflags(*var_n, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8065);
// compiled call node returning call8070 (depth = 3)
// Begin line 2077
  setline(2077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8071 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8072 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8073 = gc_frame_new();
// call case 4: self request
  Object call8074 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8073);
// compiled member node returning call8074 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8075 = callmethodflags(call8074, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8072);
// compiled call node returning call8075 (depth = 4)
  gc_frame_newslot(call8075);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8075;
  partcv[0] = 1;
  Object call8076 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8071);
// compiled call node returning call8076 (depth = 3)
// Begin line 2078
  setline(2078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8077 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8078 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8079 = gc_frame_new();
// call case 4: self request
  Object call8080 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8079);
// compiled member node returning call8080 (depth = 5)
  gc_frame_newslot(call8080);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8081 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8082 = gc_frame_new();
// call case 3: self.outer request
  Object call8083 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8082);
// compiled member node returning call8083 (depth = 6)
  Object call8084 = callmethodflags(call8083, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8081);
// compiled member node returning call8084 (depth = 5)
  params[0] = call8080;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8085 = callmethodflags(call8084, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8078);
// compiled call node returning call8085 (depth = 4)
  gc_frame_newslot(call8085);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8085;
  partcv[0] = 1;
  Object call8086 = callmethodflags(*var_n, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8077);
// compiled call node returning call8086 (depth = 3)
// Begin line 2079
  setline(2079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8087 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8088 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8089 = gc_frame_new();
// call case 4: self request
  Object call8090 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8089);
// compiled member node returning call8090 (depth = 5)
  gc_frame_newslot(call8090);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8091 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8092 = gc_frame_new();
// call case 3: self.outer request
  Object call8093 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8092);
// compiled member node returning call8093 (depth = 6)
  Object call8094 = callmethodflags(call8093, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8091);
// compiled member node returning call8094 (depth = 5)
  params[0] = call8090;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8095 = callmethodflags(call8094, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8088);
// compiled call node returning call8095 (depth = 4)
  gc_frame_newslot(call8095);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8095;
  partcv[0] = 1;
  Object call8096 = callmethodflags(*var_n, "annotations:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8087);
// compiled call node returning call8096 (depth = 3)
// Begin line 2080
  setline(2080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8097 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8098 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8097);
// compiled call node returning call8098 (depth = 3)
  gc_frame_end(frame);
  return call8098;
}
Object meth_ast__apply_40_1_41_8107(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2085
  setline(2085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8109 == NULL) {
    strlit8109 = alloc_String("  ");
    gc_root(strlit8109);
  }
// compiled string node returning strlit8109 (depth = 7)
  int op_slot_right_8108 = gc_frame_newslot(strlit8109);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8108 = gc_frame_newslot(*var_spc);
  params[0] = strlit8109;
  partcv[0] = 1;
  Object opresult8111 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult8111 (depth = 6)
  *var_spc = opresult8111;
  if (opresult8111 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_8213(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2098
  setline(2098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8215 == NULL) {
    strlit8215 = alloc_String("");
    gc_root(strlit8215);
  }
// compiled string node returning strlit8215 (depth = 8)
  int op_slot_right_8214 = gc_frame_newslot(strlit8215);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8218 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num8220 = alloc_Float64(2);
// compiled num node returning num8220 (depth = 11)
  int op_slot_right_8219 = gc_frame_newslot(num8220);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_8219 = gc_frame_newslot(*var_depth);
  params[0] = num8220;
  partcv[0] = 1;
  Object sum8222 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8222 (depth = 10)
  gc_frame_newslot(sum8222);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ann (depth = 10)
  params[0] = sum8222;
  partcv[0] = 1;
  Object call8223 = callmethodflags(*var_ann, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8218);
// compiled call node returning call8223 (depth = 9)
  int op_slot_right_8217 = gc_frame_newslot(call8223);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit8226 == NULL) {
    strlit8226 = alloc_String(" ");
    gc_root(strlit8226);
  }
// compiled string node returning strlit8226 (depth = 10)
  int op_slot_right_8225 = gc_frame_newslot(strlit8226);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_8228 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit8230 == NULL) {
    strlit8230 = alloc_String("");
    gc_root(strlit8230);
  }
// compiled string node returning strlit8230 (depth = 11)
  int op_slot_left_8228 = gc_frame_newslot(strlit8230);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult8231 = callmethod(strlit8230, "++(1)", 1, partcv, params);
// compiled op node returning opresult8231 (depth = 10)
  int op_slot_left_8225 = gc_frame_newslot(opresult8231);
  params[0] = strlit8226;
  partcv[0] = 1;
  Object opresult8232 = callmethod(opresult8231, "++(1)", 1, partcv, params);
// compiled op node returning opresult8232 (depth = 9)
  int op_slot_left_8217 = gc_frame_newslot(opresult8232);
  params[0] = call8223;
  partcv[0] = 1;
  Object opresult8233 = callmethod(opresult8232, "++(1)", 1, partcv, params);
// compiled op node returning opresult8233 (depth = 8)
  int op_slot_left_8214 = gc_frame_newslot(opresult8233);
  params[0] = strlit8215;
  partcv[0] = 1;
  Object opresult8234 = callmethod(opresult8233, "++(1)", 1, partcv, params);
// compiled op node returning opresult8234 (depth = 7)
  *var_s = opresult8234;
  if (opresult8234 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_8099(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2083
  setline(2083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8100 == NULL) {
    strlit8100 = alloc_String("");
    gc_root(strlit8100);
  }
// compiled string node returning strlit8100 (depth = 4)
  *var_spc = strlit8100;
  if (strlit8100 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2084
  setline(2084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8101 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_8102 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num8104 = alloc_Float64(0);
// compiled num node returning num8104 (depth = 5)
  int op_slot_left_8102 = gc_frame_newslot(num8104);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8105 = callmethod(num8104, "..(1)", 1, partcv, params);
// compiled op node returning opresult8105 (depth = 4)
  gc_frame_newslot(opresult8105);
// starting to compile block node (depth = 4)
  Object block8106 = alloc_Block(NULL, NULL, "ast", 2084);
  gc_frame_newslot(block8106);
// method "_apply(_)"
  block_savedest(block8106);
  Object closure8107 = createclosure(2, "_apply(1)");
  setclosureframe(closure8107, stackframe);
  addtoclosure(closure8107, var_spc);
  addtoclosure(closure8107, selfslot);
  struct UserObject *uo8107 = (struct UserObject*)block8106;
  uo8107->data[0] = (Object)closure8107;
  Method *meth_meth_ast__apply_40_1_41_8107 = addmethod2pos(block8106, "_apply(1)", &meth_ast__apply_40_1_41_8107, 0);
  int argcv_meth_ast__apply_40_1_41_8107[] = {1};
  meth_meth_ast__apply_40_1_41_8107->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_8107);
  meth_meth_ast__apply_40_1_41_8107->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_8107->definitionLine = 2981;
// compiled block node returning block8106 (depth = 4)
  gc_frame_newslot(block8106);
// call case 5: prelude request
  params[0] = opresult8105;
  params[1] = block8106;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8114 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8101);
// compiled call node returning call8114 (depth = 3)
// Begin line 2087
  setline(2087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8116 == NULL) {
    strlit8116 = alloc_String("""\x0a""");
    gc_root(strlit8116);
  }
// compiled string node returning strlit8116 (depth = 5)
  int op_slot_right_8115 = gc_frame_newslot(strlit8116);
// starting to compile call node (depth = 5)
  int callframe8118 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8119 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8118);
// compiled call node returning call8119 (depth = 5)
  int op_slot_left_8115 = gc_frame_newslot(call8119);
  params[0] = strlit8116;
  partcv[0] = 1;
  Object opresult8120 = callmethod(call8119, "++(1)", 1, partcv, params);
// compiled op node returning opresult8120 (depth = 4)
  *var_s = opresult8120;
  if (opresult8120 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2088
  setline(2088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8122 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8123 = gc_frame_new();
// call case 4: self request
  Object call8124 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8123);
// compiled member node returning call8124 (depth = 6)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8125 = callmethodflags(call8124, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8122);
// compiled call node returning call8125 (depth = 5)
  int op_slot_right_8121 = gc_frame_newslot(call8125);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_8127 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8127 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8129 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8129 (depth = 5)
  int op_slot_left_8121 = gc_frame_newslot(opresult8129);
  params[0] = call8125;
  partcv[0] = 1;
  Object opresult8130 = callmethod(opresult8129, "++(1)", 1, partcv, params);
// compiled op node returning opresult8130 (depth = 4)
  *var_s = opresult8130;
  if (opresult8130 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2089
  setline(2089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8134 = gc_frame_new();
// call case 4: self request
  Object call8135 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8134);
// compiled member node returning call8135 (depth = 5)
  int op_slot_right_8133 = gc_frame_newslot(call8135);
// starting to compile identifier node (depth = 5)
  Object bool8137 = alloc_Boolean(0);
// compiled identifier node returning bool8137 (depth = 5)
  int op_slot_left_8133 = gc_frame_newslot(bool8137);
  params[0] = call8135;
  partcv[0] = 1;
  Object opresult8138 = callmethod(bool8137, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8138 (depth = 4)
  Object if8132 = done;
  if (istrue(opresult8138)) {
// Begin line 2090
  setline(2090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8140 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8142 = alloc_Float64(2);
// compiled num node returning num8142 (depth = 8)
  int op_slot_right_8141 = gc_frame_newslot(num8142);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8141 = gc_frame_newslot(*var_depth);
  params[0] = num8142;
  partcv[0] = 1;
  Object sum8144 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8144 (depth = 7)
  gc_frame_newslot(sum8144);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8145 = gc_frame_new();
// call case 4: self request
  Object call8146 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8145);
// compiled member node returning call8146 (depth = 7)
  params[0] = sum8144;
  partcv[0] = 1;
  Object call8147 = callmethodflags(call8146, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8140);
// compiled call node returning call8147 (depth = 6)
  int op_slot_right_8139 = gc_frame_newslot(call8147);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8150 == NULL) {
    strlit8150 = alloc_String("Type: ");
    gc_root(strlit8150);
  }
// compiled string node returning strlit8150 (depth = 7)
  int op_slot_right_8149 = gc_frame_newslot(strlit8150);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_8152 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8155 == NULL) {
    strlit8155 = alloc_String("""\x0a""");
    gc_root(strlit8155);
  }
// compiled string node returning strlit8155 (depth = 9)
  int op_slot_right_8154 = gc_frame_newslot(strlit8155);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_8154 = gc_frame_newslot(*var_s);
  params[0] = strlit8155;
  partcv[0] = 1;
  Object opresult8157 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8157 (depth = 8)
  int op_slot_left_8152 = gc_frame_newslot(opresult8157);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8158 = callmethod(opresult8157, "++(1)", 1, partcv, params);
// compiled op node returning opresult8158 (depth = 7)
  int op_slot_left_8149 = gc_frame_newslot(opresult8158);
  params[0] = strlit8150;
  partcv[0] = 1;
  Object opresult8159 = callmethod(opresult8158, "++(1)", 1, partcv, params);
// compiled op node returning opresult8159 (depth = 6)
  int op_slot_left_8139 = gc_frame_newslot(opresult8159);
  params[0] = call8147;
  partcv[0] = 1;
  Object opresult8160 = callmethod(opresult8159, "++(1)", 1, partcv, params);
// compiled op node returning opresult8160 (depth = 5)
  *var_s = opresult8160;
  if (opresult8160 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8132 = done;
  } else {
  }
// compiled if node returning if8132 (depth = 3)
// Begin line 2092
  setline(2092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8164 = gc_frame_new();
// call case 4: self request
  Object call8165 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8164);
// compiled member node returning call8165 (depth = 5)
  int op_slot_right_8163 = gc_frame_newslot(call8165);
// starting to compile identifier node (depth = 5)
  Object bool8167 = alloc_Boolean(0);
// compiled identifier node returning bool8167 (depth = 5)
  int op_slot_left_8163 = gc_frame_newslot(bool8167);
  params[0] = call8165;
  partcv[0] = 1;
  Object opresult8168 = callmethod(bool8167, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8168 (depth = 4)
  Object if8162 = done;
  if (istrue(opresult8168)) {
// Begin line 2093
  setline(2093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8170 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8172 = alloc_Float64(2);
// compiled num node returning num8172 (depth = 8)
  int op_slot_right_8171 = gc_frame_newslot(num8172);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8171 = gc_frame_newslot(*var_depth);
  params[0] = num8172;
  partcv[0] = 1;
  Object sum8174 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8174 (depth = 7)
  gc_frame_newslot(sum8174);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8175 = gc_frame_new();
// call case 4: self request
  Object call8176 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8175);
// compiled member node returning call8176 (depth = 7)
  params[0] = sum8174;
  partcv[0] = 1;
  Object call8177 = callmethodflags(call8176, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8170);
// compiled call node returning call8177 (depth = 6)
  int op_slot_right_8169 = gc_frame_newslot(call8177);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8180 == NULL) {
    strlit8180 = alloc_String("Value: ");
    gc_root(strlit8180);
  }
// compiled string node returning strlit8180 (depth = 7)
  int op_slot_right_8179 = gc_frame_newslot(strlit8180);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_8182 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8185 == NULL) {
    strlit8185 = alloc_String("""\x0a""");
    gc_root(strlit8185);
  }
// compiled string node returning strlit8185 (depth = 9)
  int op_slot_right_8184 = gc_frame_newslot(strlit8185);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_8184 = gc_frame_newslot(*var_s);
  params[0] = strlit8185;
  partcv[0] = 1;
  Object opresult8187 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8187 (depth = 8)
  int op_slot_left_8182 = gc_frame_newslot(opresult8187);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8188 = callmethod(opresult8187, "++(1)", 1, partcv, params);
// compiled op node returning opresult8188 (depth = 7)
  int op_slot_left_8179 = gc_frame_newslot(opresult8188);
  params[0] = strlit8180;
  partcv[0] = 1;
  Object opresult8189 = callmethod(opresult8188, "++(1)", 1, partcv, params);
// compiled op node returning opresult8189 (depth = 6)
  int op_slot_left_8169 = gc_frame_newslot(opresult8189);
  params[0] = call8177;
  partcv[0] = 1;
  Object opresult8190 = callmethod(opresult8189, "++(1)", 1, partcv, params);
// compiled op node returning opresult8190 (depth = 5)
  *var_s = opresult8190;
  if (opresult8190 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8162 = done;
  } else {
  }
// compiled if node returning if8162 (depth = 3)
// Begin line 2095
  setline(2095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8193 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8194 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8195 = gc_frame_new();
// call case 4: self request
  Object call8196 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8195);
// compiled member node returning call8196 (depth = 6)
  Object call8197 = callmethodflags(call8196, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe8194);
// compiled member node returning call8197 (depth = 5)
  Object call8198 = callmethodflags(call8197, "not", 0, partcv, params, 0);
  gc_frame_end(callframe8193);
// compiled member node returning call8198 (depth = 4)
  Object if8192 = done;
  if (istrue(call8198)) {
// Begin line 2096
  setline(2096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8201 == NULL) {
    strlit8201 = alloc_String("Annotations:");
    gc_root(strlit8201);
  }
// compiled string node returning strlit8201 (depth = 7)
  int op_slot_right_8200 = gc_frame_newslot(strlit8201);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_8203 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 8)
  if (strlit8205 == NULL) {
    strlit8205 = alloc_String("""\x0a""");
    gc_root(strlit8205);
  }
// compiled string node returning strlit8205 (depth = 8)
  int op_slot_left_8203 = gc_frame_newslot(strlit8205);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8206 = callmethod(strlit8205, "++(1)", 1, partcv, params);
// compiled op node returning opresult8206 (depth = 7)
  int op_slot_left_8200 = gc_frame_newslot(opresult8206);
  params[0] = strlit8201;
  partcv[0] = 1;
  Object opresult8207 = callmethod(opresult8206, "++(1)", 1, partcv, params);
// compiled op node returning opresult8207 (depth = 6)
  int op_slot_right_8199 = gc_frame_newslot(opresult8207);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8199 = gc_frame_newslot(*var_s);
  params[0] = opresult8207;
  partcv[0] = 1;
  Object opresult8209 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8209 (depth = 5)
  *var_s = opresult8209;
  if (opresult8209 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2097
  setline(2097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8211 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8212 = alloc_Block(NULL, NULL, "ast", 2097);
  gc_frame_newslot(block8212);
// method "_apply(_)"
  block_savedest(block8212);
  Object closure8213 = createclosure(3, "_apply(1)");
  setclosureframe(closure8213, stackframe);
  addtoclosure(closure8213, var_depth);
  addtoclosure(closure8213, var_s);
  addtoclosure(closure8213, selfslot);
  struct UserObject *uo8213 = (struct UserObject*)block8212;
  uo8213->data[0] = (Object)closure8213;
  Method *meth_meth_ast__apply_40_1_41_8213 = addmethod2pos(block8212, "_apply(1)", &meth_ast__apply_40_1_41_8213, 0);
  int argcv_meth_ast__apply_40_1_41_8213[] = {1};
  meth_meth_ast__apply_40_1_41_8213->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_8213);
  meth_meth_ast__apply_40_1_41_8213->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_8213->definitionLine = 2981;
// compiled block node returning block8212 (depth = 5)
  gc_frame_newslot(block8212);
// call case 6: other requests
// Begin line 2097
  setline(2097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe8237 = gc_frame_new();
// call case 4: self request
  Object call8238 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8237);
// compiled member node returning call8238 (depth = 5)
  params[0] = block8212;
  partcv[0] = 1;
  Object call8239 = callmethodflags(call8238, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8211);
// compiled call node returning call8239 (depth = 4)
    gc_frame_newslot(call8239);
    if8192 = call8239;
  } else {
  }
// compiled if node returning if8192 (depth = 3)
// Begin line 2101
  setline(2101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8242 = gc_frame_new();
// call case 4: self request
  Object call8243 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8242);
// compiled member node returning call8243 (depth = 5)
  int op_slot_right_8241 = gc_frame_newslot(call8243);
// starting to compile identifier node (depth = 5)
  Object bool8245 = alloc_Boolean(0);
// compiled identifier node returning bool8245 (depth = 5)
  int op_slot_left_8241 = gc_frame_newslot(bool8245);
  params[0] = call8243;
  partcv[0] = 1;
  Object opresult8246 = callmethod(bool8245, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8246 (depth = 4)
  Object if8240 = done;
  if (istrue(opresult8246)) {
// Begin line 2102
  setline(2102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8248 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8250 = alloc_Float64(2);
// compiled num node returning num8250 (depth = 8)
  int op_slot_right_8249 = gc_frame_newslot(num8250);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8249 = gc_frame_newslot(*var_depth);
  params[0] = num8250;
  partcv[0] = 1;
  Object sum8252 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8252 (depth = 7)
  gc_frame_newslot(sum8252);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8253 = gc_frame_new();
// call case 4: self request
  Object call8254 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8253);
// compiled member node returning call8254 (depth = 7)
  params[0] = sum8252;
  partcv[0] = 1;
  Object call8255 = callmethodflags(call8254, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8248);
// compiled call node returning call8255 (depth = 6)
  int op_slot_right_8247 = gc_frame_newslot(call8255);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8247 = gc_frame_newslot(*var_s);
  params[0] = call8255;
  partcv[0] = 1;
  Object opresult8257 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8257 (depth = 5)
  *var_s = opresult8257;
  if (opresult8257 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8240 = done;
  } else {
  }
// compiled if node returning if8240 (depth = 3)
// Begin line 2104
  setline(2104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_8271(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2109
  setline(2109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8273 == NULL) {
    strlit8273 = alloc_String("    ");
    gc_root(strlit8273);
  }
// compiled string node returning strlit8273 (depth = 7)
  int op_slot_right_8272 = gc_frame_newslot(strlit8273);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8272 = gc_frame_newslot(*var_spc);
  params[0] = strlit8273;
  partcv[0] = 1;
  Object opresult8275 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult8275 (depth = 6)
  *var_spc = opresult8275;
  if (opresult8275 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply8295(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2113
  setline(2113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8297 == NULL) {
    strlit8297 = alloc_String("Unknown");
    gc_root(strlit8297);
  }
// compiled string node returning strlit8297 (depth = 7)
  int op_slot_right_8296 = gc_frame_newslot(strlit8297);
// starting to compile member node (depth = 7)
  int callframe8299 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe8300 = gc_frame_new();
// call case 4: self request
  Object call8301 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8300);
// compiled member node returning call8301 (depth = 8)
  Object call8302 = callmethodflags(call8301, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8299);
// compiled member node returning call8302 (depth = 7)
  int op_slot_left_8296 = gc_frame_newslot(call8302);
  params[0] = strlit8297;
  partcv[0] = 1;
  Object opresult8303 = callmethod(call8302, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8303 (depth = 6)
  gc_frame_end(frame);
  return opresult8303;
}
Object meth_ast__apply_40_2_41_8343(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2119
  setline(2119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8345 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num8346 = alloc_Float64(0);
// compiled num node returning num8346 (depth = 10)
  gc_frame_newslot(num8346);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_b (depth = 10)
  params[0] = num8346;
  partcv[0] = 1;
  Object call8347 = callmethodflags(*var_b, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8345);
// compiled call node returning call8347 (depth = 9)
  int op_slot_right_8344 = gc_frame_newslot(call8347);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8351 == NULL) {
    strlit8351 = alloc_String("");
    gc_root(strlit8351);
  }
// compiled string node returning strlit8351 (depth = 11)
  int op_slot_right_8350 = gc_frame_newslot(strlit8351);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_8350 = gc_frame_newslot(*var_a);
  params[0] = strlit8351;
  partcv[0] = 1;
  Object opresult8353 = callmethod(*var_a, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8353 (depth = 10)
  Object if8349 = done;
struct StackFrameObject *iftmpstackframe8349 = stackframe;
  if (istrue(opresult8353)) {
stackframe = alloc_StackFrame(0, iftmpstackframe8349);
gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8355 == NULL) {
    strlit8355 = alloc_String(", ");
    gc_root(strlit8355);
  }
// compiled string node returning strlit8355 (depth = 11)
  int op_slot_right_8354 = gc_frame_newslot(strlit8355);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_8354 = gc_frame_newslot(*var_a);
  params[0] = strlit8355;
  partcv[0] = 1;
  Object opresult8357 = callmethod(*var_a, "++(1)", 1, partcv, params);
// compiled op node returning opresult8357 (depth = 10)
    gc_frame_newslot(opresult8357);
    if8349 = opresult8357;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe8349);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 10)
  if (strlit8358 == NULL) {
    strlit8358 = alloc_String("");
    gc_root(strlit8358);
  }
// compiled string node returning strlit8358 (depth = 10)
    gc_frame_newslot(strlit8358);
    if8349 = strlit8358;
  }
stackframe = iftmpstackframe8349;
// compiled if node returning if8349 (depth = 9)
  int op_slot_left_8344 = gc_frame_newslot(if8349);
  params[0] = call8347;
  partcv[0] = 1;
  Object opresult8359 = callmethod(if8349, "++(1)", 1, partcv, params);
// compiled op node returning opresult8359 (depth = 8)
  gc_frame_end(frame);
  return opresult8359;
}
Object meth_ast_toGrace_40_1_41_8259(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2107
  setline(2107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8260 == NULL) {
    strlit8260 = alloc_String("");
    gc_root(strlit8260);
  }
// compiled string node returning strlit8260 (depth = 4)
  *var_spc = strlit8260;
  if (strlit8260 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2108
  setline(2108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8261 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8264 = alloc_Float64(1);
// compiled num node returning num8264 (depth = 6)
  int op_slot_right_8263 = gc_frame_newslot(num8264);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_8263 = gc_frame_newslot(*var_depth);
  params[0] = num8264;
  partcv[0] = 1;
  Object diff8266 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff8266 (depth = 5)
  int op_slot_right_8262 = gc_frame_newslot(diff8266);
// starting to compile num node (depth = 5)
  Object num8268 = alloc_Float64(0);
// compiled num node returning num8268 (depth = 5)
  int op_slot_left_8262 = gc_frame_newslot(num8268);
  params[0] = diff8266;
  partcv[0] = 1;
  Object opresult8269 = callmethod(num8268, "..(1)", 1, partcv, params);
// compiled op node returning opresult8269 (depth = 4)
  gc_frame_newslot(opresult8269);
// starting to compile block node (depth = 4)
  Object block8270 = alloc_Block(NULL, NULL, "ast", 2108);
  gc_frame_newslot(block8270);
// method "_apply(_)"
  block_savedest(block8270);
  Object closure8271 = createclosure(2, "_apply(1)");
  setclosureframe(closure8271, stackframe);
  addtoclosure(closure8271, var_spc);
  addtoclosure(closure8271, selfslot);
  struct UserObject *uo8271 = (struct UserObject*)block8270;
  uo8271->data[0] = (Object)closure8271;
  Method *meth_meth_ast__apply_40_1_41_8271 = addmethod2pos(block8270, "_apply(1)", &meth_ast__apply_40_1_41_8271, 0);
  int argcv_meth_ast__apply_40_1_41_8271[] = {1};
  meth_meth_ast__apply_40_1_41_8271->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_8271);
  meth_meth_ast__apply_40_1_41_8271->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_8271->definitionLine = 2981;
// compiled block node returning block8270 (depth = 4)
  gc_frame_newslot(block8270);
// call case 5: prelude request
  params[0] = opresult8269;
  params[1] = block8270;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8278 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8261);
// compiled call node returning call8278 (depth = 3)
// Begin line 2111
  setline(2111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8280 == NULL) {
    strlit8280 = alloc_String("");
    gc_root(strlit8280);
  }
// compiled string node returning strlit8280 (depth = 5)
  int op_slot_right_8279 = gc_frame_newslot(strlit8280);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8283 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num8284 = alloc_Float64(0);
// compiled num node returning num8284 (depth = 7)
  gc_frame_newslot(num8284);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8285 = gc_frame_new();
// call case 4: self request
  Object call8286 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8285);
// compiled member node returning call8286 (depth = 7)
  params[0] = num8284;
  partcv[0] = 1;
  Object call8287 = callmethodflags(call8286, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8283);
// compiled call node returning call8287 (depth = 6)
  int op_slot_right_8282 = gc_frame_newslot(call8287);
// starting to compile string node (depth = 6)
  if (strlit8289 == NULL) {
    strlit8289 = alloc_String("def ");
    gc_root(strlit8289);
  }
// compiled string node returning strlit8289 (depth = 6)
  int op_slot_left_8282 = gc_frame_newslot(strlit8289);
  params[0] = call8287;
  partcv[0] = 1;
  Object opresult8290 = callmethod(strlit8289, "++(1)", 1, partcv, params);
// compiled op node returning opresult8290 (depth = 5)
  int op_slot_left_8279 = gc_frame_newslot(opresult8290);
  params[0] = strlit8280;
  partcv[0] = 1;
  Object opresult8291 = callmethod(opresult8290, "++(1)", 1, partcv, params);
// compiled op node returning opresult8291 (depth = 4)
  *var_s = opresult8291;
  if (opresult8291 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2112
  setline(2112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block8294 = alloc_Block(NULL, NULL, "ast", 2112);
  gc_frame_newslot(block8294);
// method "_apply"
  block_savedest(block8294);
  Object closure8295 = createclosure(1, "_apply");
  setclosureframe(closure8295, stackframe);
  addtoclosure(closure8295, selfslot);
  struct UserObject *uo8295 = (struct UserObject*)block8294;
  uo8295->data[0] = (Object)closure8295;
  Method *meth_meth_ast__apply8295 = addmethod2pos(block8294, "_apply", &meth_ast__apply8295, 0);
  int argcv_meth_ast__apply8295[] = {0};
  meth_meth_ast__apply8295->type = alloc_MethodType(1, argcv_meth_ast__apply8295);
  meth_meth_ast__apply8295->definitionModule = modulename;
  meth_meth_ast__apply8295->definitionLine = 2981;
// compiled block node returning block8294 (depth = 5)
  int op_slot_right_8293 = gc_frame_newslot(block8294);
// Begin line 2112
  setline(2112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8307 = gc_frame_new();
// call case 4: self request
  Object call8308 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8307);
// compiled member node returning call8308 (depth = 6)
  int op_slot_right_8306 = gc_frame_newslot(call8308);
// starting to compile identifier node (depth = 6)
  Object bool8310 = alloc_Boolean(0);
// compiled identifier node returning bool8310 (depth = 6)
  int op_slot_left_8306 = gc_frame_newslot(bool8310);
  params[0] = call8308;
  partcv[0] = 1;
  Object opresult8311 = callmethod(bool8310, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8311 (depth = 5)
  int op_slot_left_8293 = gc_frame_newslot(opresult8311);
  params[0] = block8294;
  partcv[0] = 1;
  Object opresult8312 = callmethod(opresult8311, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8312 (depth = 4)
  Object if8292 = done;
  if (istrue(opresult8312)) {
// Begin line 2114
  setline(2114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8314 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num8315 = alloc_Float64(0);
// compiled num node returning num8315 (depth = 7)
  gc_frame_newslot(num8315);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8316 = gc_frame_new();
// call case 4: self request
  Object call8317 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8316);
// compiled member node returning call8317 (depth = 7)
  params[0] = num8315;
  partcv[0] = 1;
  Object call8318 = callmethodflags(call8317, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8314);
// compiled call node returning call8318 (depth = 6)
  int op_slot_right_8313 = gc_frame_newslot(call8318);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8321 == NULL) {
    strlit8321 = alloc_String(" : ");
    gc_root(strlit8321);
  }
// compiled string node returning strlit8321 (depth = 7)
  int op_slot_right_8320 = gc_frame_newslot(strlit8321);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8320 = gc_frame_newslot(*var_s);
  params[0] = strlit8321;
  partcv[0] = 1;
  Object opresult8323 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8323 (depth = 6)
  int op_slot_left_8313 = gc_frame_newslot(opresult8323);
  params[0] = call8318;
  partcv[0] = 1;
  Object opresult8324 = callmethod(opresult8323, "++(1)", 1, partcv, params);
// compiled op node returning opresult8324 (depth = 5)
  *var_s = opresult8324;
  if (opresult8324 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8292 = done;
  } else {
  }
// compiled if node returning if8292 (depth = 3)
// Begin line 2116
  setline(2116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8328 = alloc_Float64(0);
// compiled num node returning num8328 (depth = 5)
  int op_slot_right_8327 = gc_frame_newslot(num8328);
// starting to compile member node (depth = 5)
  int callframe8330 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8331 = gc_frame_new();
// call case 4: self request
  Object call8332 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8331);
// compiled member node returning call8332 (depth = 6)
  Object call8333 = callmethodflags(call8332, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8330);
// compiled member node returning call8333 (depth = 5)
  int op_slot_left_8327 = gc_frame_newslot(call8333);
  params[0] = num8328;
  partcv[0] = 1;
  Object opresult8334 = callmethod(call8333, ">(1)", 1, partcv, params);
// compiled op node returning opresult8334 (depth = 4)
  Object if8326 = done;
  if (istrue(opresult8334)) {
// Begin line 2117
  setline(2117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8336 == NULL) {
    strlit8336 = alloc_String(" is ");
    gc_root(strlit8336);
  }
// compiled string node returning strlit8336 (depth = 6)
  int op_slot_right_8335 = gc_frame_newslot(strlit8336);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8335 = gc_frame_newslot(*var_s);
  params[0] = strlit8336;
  partcv[0] = 1;
  Object opresult8338 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8338 (depth = 5)
  *var_s = opresult8338;
  if (opresult8338 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2118
  setline(2118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8341 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block8342 = alloc_Block(NULL, NULL, "ast", 2118);
  gc_frame_newslot(block8342);
// method "_apply(_,_)"
  block_savedest(block8342);
  Object closure8343 = createclosure(1, "_apply(2)");
  setclosureframe(closure8343, stackframe);
  addtoclosure(closure8343, selfslot);
  struct UserObject *uo8343 = (struct UserObject*)block8342;
  uo8343->data[0] = (Object)closure8343;
  Method *meth_meth_ast__apply_40_2_41_8343 = addmethod2pos(block8342, "_apply(2)", &meth_ast__apply_40_2_41_8343, 0);
  int argcv_meth_ast__apply_40_2_41_8343[] = {2};
  meth_meth_ast__apply_40_2_41_8343->type = alloc_MethodType(1, argcv_meth_ast__apply_40_2_41_8343);
  meth_meth_ast__apply_40_2_41_8343->definitionModule = modulename;
  meth_meth_ast__apply_40_2_41_8343->definitionLine = 2981;
// compiled block node returning block8342 (depth = 7)
  gc_frame_newslot(block8342);
// Begin line 2120
  setline(2120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8361 == NULL) {
    strlit8361 = alloc_String("");
    gc_root(strlit8361);
  }
// compiled string node returning strlit8361 (depth = 7)
  gc_frame_newslot(strlit8361);
// call case 6: other requests
// Begin line 2118
  setline(2118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe8362 = gc_frame_new();
// call case 4: self request
  Object call8363 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8362);
// compiled member node returning call8363 (depth = 7)
  params[0] = block8342;
  params[1] = strlit8361;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8364 = callmethodflags(call8363, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8341);
// compiled call node returning call8364 (depth = 6)
  int op_slot_right_8340 = gc_frame_newslot(call8364);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8340 = gc_frame_newslot(*var_s);
  params[0] = call8364;
  partcv[0] = 1;
  Object opresult8366 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8366 (depth = 5)
  *var_s = opresult8366;
  if (opresult8366 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8326 = done;
  } else {
  }
// compiled if node returning if8326 (depth = 3)
// Begin line 2122
  setline(2122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8370 = gc_frame_new();
// call case 4: self request
  Object call8371 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8370);
// compiled member node returning call8371 (depth = 5)
  int op_slot_right_8369 = gc_frame_newslot(call8371);
// starting to compile identifier node (depth = 5)
  Object bool8373 = alloc_Boolean(0);
// compiled identifier node returning bool8373 (depth = 5)
  int op_slot_left_8369 = gc_frame_newslot(bool8373);
  params[0] = call8371;
  partcv[0] = 1;
  Object opresult8374 = callmethod(bool8373, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8374 (depth = 4)
  Object if8368 = done;
  if (istrue(opresult8374)) {
// Begin line 2123
  setline(2123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8376 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8377 = gc_frame_new();
// call case 4: self request
  Object call8378 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8377);
// compiled member node returning call8378 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8379 = callmethodflags(call8378, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8376);
// compiled call node returning call8379 (depth = 6)
  int op_slot_right_8375 = gc_frame_newslot(call8379);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8382 == NULL) {
    strlit8382 = alloc_String(" = ");
    gc_root(strlit8382);
  }
// compiled string node returning strlit8382 (depth = 7)
  int op_slot_right_8381 = gc_frame_newslot(strlit8382);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8381 = gc_frame_newslot(*var_s);
  params[0] = strlit8382;
  partcv[0] = 1;
  Object opresult8384 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8384 (depth = 6)
  int op_slot_left_8375 = gc_frame_newslot(opresult8384);
  params[0] = call8379;
  partcv[0] = 1;
  Object opresult8385 = callmethod(opresult8384, "++(1)", 1, partcv, params);
// compiled op node returning opresult8385 (depth = 5)
  *var_s = opresult8385;
  if (opresult8385 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8368 = done;
  } else {
  }
// compiled if node returning if8368 (depth = 3)
// Begin line 2125
  setline(2125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy8387(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_defDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2128
  setline(2128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8388 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe8389 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8390 = gc_frame_new();
// call case 4: self request
  Object call8391 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8390);
// compiled member node returning call8391 (depth = 5)
  gc_frame_newslot(call8391);
// starting to compile member node (depth = 5)
  int callframe8392 = gc_frame_new();
// call case 4: self request
  Object call8393 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8392);
// compiled member node returning call8393 (depth = 5)
  gc_frame_newslot(call8393);
// starting to compile member node (depth = 5)
  int callframe8394 = gc_frame_new();
// call case 4: self request
  Object call8395 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8394);
// compiled member node returning call8395 (depth = 5)
  gc_frame_newslot(call8395);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_defDecNode (depth = 5)
  params[0] = call8391;
  params[1] = call8393;
  params[2] = call8395;
  partcv[0] = 3;
  Object call8396 = callmethodflags(*var_defDecNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe8389);
// compiled call node returning call8396 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call8397 = callmethodflags(call8396, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8388);
// compiled call node returning call8397 (depth = 3)
  gc_frame_end(frame);
  return call8397;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_8398(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8399 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call8400 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8399);
// compiled call node returning call8400 (depth = 3)
// Begin line 2132
  setline(2132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8401 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8402 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call8403 = callmethodflags(*var_other, "startToken", 0, partcv, params, 0);
  gc_frame_end(callframe8402);
// compiled member node returning call8403 (depth = 4)
  gc_frame_newslot(call8403);
// call case 4: self request
  params[0] = call8403;
  partcv[0] = 1;
  Object call8404 = callmethodflags(self, "startToken:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8401);
// compiled call node returning call8404 (depth = 3)
// Begin line 2133
  setline(2133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName8405(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2135
  setline(2135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8406 == NULL) {
    strlit8406 = alloc_String("definition");
    gc_root(strlit8406);
  }
// compiled string node returning strlit8406 (depth = 3)
  gc_frame_end(frame);
  return strlit8406;
}
Object meth_ast_new_40_3_41_7963(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_defDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7964 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7964 = alloc_userobj2(27,23, objclass7964);
  gc_frame_newslot(obj7964);
if (objclass7964 == NULL) {
  glfree(obj7964->class->name);
  obj7964->class->name = "defDecNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7964, self, 0);
  addmethodreal(obj7964,"outer", &reader_ast_outer_7965);
  Object oldself7964 = self;
  struct StackFrameObject *oldstackframe7964 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7964);
  gc_frame_newslot((Object)stackframe);
  self = obj7964;
  Object *oldselfslot7964 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7964 = (*(struct UserObject *)self).data[0], lowerouter7964 = thisouter7964;
  if (inheritingObject7964) {
    struct UserObject *inho7964 = (struct UserObject *)inheritingObject7964;
    while (inho7964->super != GraceDefaultObject) inho7964 = (struct UserObject *)inho7964->super;
    inho7964->super = obj7964;
    self = inheritingObject7964;
    *selfslot = self;
    lowerouter7964 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7964;
  }
if (objclass7964 == NULL) {
  Method *reader7966 = addmethodrealflags(obj7964, "kind",&reader_ast_kind_7966, MFLAG_DEF);
  reader7966->definitionModule = modulename;
  reader7966->definitionLine = 2030;
}
adddatum2(obj7964, alloc_Undefined(), 1);
if (objclass7964 == NULL) {
  Method *reader7967 = addmethodrealflags(obj7964, "name", &reader_ast_name_7967, 0);
  Method *writer7967 = addmethodrealflags(obj7964, "name:=(1)", &writer_ast_name_7967, 0);
  reader7967->definitionModule = modulename;
  writer7967->definitionModule = modulename;
  reader7967->definitionLine = 2031;
  writer7967->definitionLine = 2031;
}
obj7964->flags |= OFLAG_MUTABLE;
adddatum2(obj7964, alloc_Undefined(), 2);
if (objclass7964 == NULL) {
  Method *reader7968 = addmethodrealflags(obj7964, "value", &reader_ast_value_7968, 0);
  Method *writer7968 = addmethodrealflags(obj7964, "value:=(1)", &writer_ast_value_7968, 0);
  reader7968->definitionModule = modulename;
  writer7968->definitionModule = modulename;
  reader7968->definitionLine = 2032;
  writer7968->definitionLine = 2032;
}
obj7964->flags |= OFLAG_MUTABLE;
adddatum2(obj7964, alloc_Undefined(), 3);
if (objclass7964 == NULL) {
  Method *reader7969 = addmethodrealflags(obj7964, "dtype", &reader_ast_dtype_7969, 0);
  Method *writer7969 = addmethodrealflags(obj7964, "dtype:=(1)", &writer_ast_dtype_7969, 0);
  reader7969->definitionModule = modulename;
  writer7969->definitionModule = modulename;
  reader7969->definitionLine = 2033;
  writer7969->definitionLine = 2033;
}
obj7964->flags |= OFLAG_MUTABLE;
adddatum2(obj7964, alloc_Undefined(), 4);
if (objclass7964 == NULL) {
  Method *reader7970 = addmethodrealflags(obj7964, "nameString",&reader_ast_nameString_7970, MFLAG_DEF);
  reader7970->definitionModule = modulename;
  reader7970->definitionLine = 2034;
}
adddatum2(obj7964, alloc_Undefined(), 5);
if (objclass7964 == NULL) {
  Method *reader7971 = addmethodrealflags(obj7964, "annotations", &reader_ast_annotations_7971, 0);
  Method *writer7971 = addmethodrealflags(obj7964, "annotations:=(1)", &writer_ast_annotations_7971, 0);
  reader7971->definitionModule = modulename;
  writer7971->definitionModule = modulename;
  reader7971->definitionLine = 2035;
  writer7971->definitionLine = 2035;
}
obj7964->flags |= OFLAG_MUTABLE;
adddatum2(obj7964, alloc_Undefined(), 6);
if (objclass7964 == NULL) {
  Method *reader7972 = addmethodrealflags(obj7964, "startToken", &reader_ast_startToken_7972, 0);
  Method *writer7972 = addmethodrealflags(obj7964, "startToken:=(1)", &writer_ast_startToken_7972, 0);
  reader7972->definitionModule = modulename;
  writer7972->definitionModule = modulename;
  reader7972->definitionLine = 2036;
  writer7972->definitionLine = 2036;
}
obj7964->flags |= OFLAG_MUTABLE;
adddatum2(obj7964, alloc_Undefined(), 7);
// method "isPublic"
  struct UserObject *uo7973 = (struct UserObject*)obj7964;
  uo7973->data[8] = emptyclosure;
  Method *meth_meth_ast_isPublic7973 = addmethod2pos(obj7964, "isPublic", &meth_ast_isPublic7973, 8);
  int argcv_meth_ast_isPublic7973[] = {0};
  meth_meth_ast_isPublic7973->type = alloc_MethodType(1, argcv_meth_ast_isPublic7973);
  meth_meth_ast_isPublic7973->definitionModule = modulename;
  meth_meth_ast_isPublic7973->definitionLine = 2038;
// method "isFieldDec"
  struct UserObject *uo8000 = (struct UserObject*)obj7964;
  uo8000->data[9] = emptyclosure;
  Method *meth_meth_ast_isFieldDec8000 = addmethod2pos(obj7964, "isFieldDec", &meth_ast_isFieldDec8000, 9);
  int argcv_meth_ast_isFieldDec8000[] = {0};
  meth_meth_ast_isFieldDec8000->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec8000);
  meth_meth_ast_isFieldDec8000->definitionModule = modulename;
  meth_meth_ast_isFieldDec8000->definitionLine = 2044;
// method "isWritable"
  struct UserObject *uo8002 = (struct UserObject*)obj7964;
  uo8002->data[10] = emptyclosure;
  Method *meth_meth_ast_isWritable8002 = addmethod2pos(obj7964, "isWritable", &meth_ast_isWritable8002, 10);
  int argcv_meth_ast_isWritable8002[] = {0};
  meth_meth_ast_isWritable8002->type = alloc_MethodType(1, argcv_meth_ast_isWritable8002);
  meth_meth_ast_isWritable8002->definitionModule = modulename;
  meth_meth_ast_isWritable8002->definitionLine = 2045;
// method "isReadable"
  struct UserObject *uo8004 = (struct UserObject*)obj7964;
  uo8004->data[11] = emptyclosure;
  Method *meth_meth_ast_isReadable8004 = addmethod2pos(obj7964, "isReadable", &meth_ast_isReadable8004, 11);
  int argcv_meth_ast_isReadable8004[] = {0};
  meth_meth_ast_isReadable8004->type = alloc_MethodType(1, argcv_meth_ast_isReadable8004);
  meth_meth_ast_isReadable8004->definitionModule = modulename;
  meth_meth_ast_isReadable8004->definitionLine = 2046;
// method "returnsObject"
  struct UserObject *uo8007 = (struct UserObject*)obj7964;
  uo8007->data[12] = emptyclosure;
  Method *meth_meth_ast_returnsObject8007 = addmethod2pos(obj7964, "returnsObject", &meth_ast_returnsObject8007, 12);
  int argcv_meth_ast_returnsObject8007[] = {0};
  meth_meth_ast_returnsObject8007->type = alloc_MethodType(1, argcv_meth_ast_returnsObject8007);
  meth_meth_ast_returnsObject8007->definitionModule = modulename;
  meth_meth_ast_returnsObject8007->definitionLine = 2048;
// method "returnedObjectScope"
  struct UserObject *uo8012 = (struct UserObject*)obj7964;
  uo8012->data[13] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope8012 = addmethod2pos(obj7964, "returnedObjectScope", &meth_ast_returnedObjectScope8012, 13);
  int argcv_meth_ast_returnedObjectScope8012[] = {0};
  meth_meth_ast_returnedObjectScope8012->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope8012);
  meth_meth_ast_returnedObjectScope8012->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope8012->definitionLine = 2051;
// method "usesAsType(_)"
  struct UserObject *uo8017 = (struct UserObject*)obj7964;
  uo8017->data[14] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_8017 = addmethod2pos(obj7964, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_8017, 14);
  int argcv_meth_ast_usesAsType_40_1_41_8017[] = {1};
  meth_meth_ast_usesAsType_40_1_41_8017->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_8017);
  meth_meth_ast_usesAsType_40_1_41_8017->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_8017->definitionLine = 2055;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj7964);
  Object closure8023 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure8023, stackframe);
  addtoclosure(closure8023, var_k);
  struct UserObject *uo8023 = (struct UserObject*)obj7964;
  uo8023->data[15] = (Object)closure8023;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_8023 = addmethod2pos(obj7964, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_8023, 15);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_8023[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8023->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_8023);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8023->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8023->definitionLine = 2058;
// method "accept(_)from(_)"
  struct UserObject *uo8026 = (struct UserObject*)obj7964;
  uo8026->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_8026 = addmethod2pos(obj7964, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_8026, 16);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_8026[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_8026->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_8026);
  meth_meth_ast_accept_40_1_41_from_40_1_41_8026->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_8026->definitionLine = 2060;
// method "map(_)ancestors(_)"
  struct UserObject *uo8060 = (struct UserObject*)obj7964;
  uo8060->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_8060 = addmethod2pos(obj7964, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_8060, 17);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8060[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8060->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8060);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8060->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8060->definitionLine = 2073;
// method "pretty(_)"
  struct UserObject *uo8099 = (struct UserObject*)obj7964;
  uo8099->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_8099 = addmethod2pos(obj7964, "pretty(1)", &meth_ast_pretty_40_1_41_8099, 18);
  int argcv_meth_ast_pretty_40_1_41_8099[] = {1};
  meth_meth_ast_pretty_40_1_41_8099->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_8099);
  meth_meth_ast_pretty_40_1_41_8099->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_8099->definitionLine = 2082;
// method "toGrace(_)"
  struct UserObject *uo8259 = (struct UserObject*)obj7964;
  uo8259->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_8259 = addmethod2pos(obj7964, "toGrace(1)", &meth_ast_toGrace_40_1_41_8259, 19);
  int argcv_meth_ast_toGrace_40_1_41_8259[] = {1};
  meth_meth_ast_toGrace_40_1_41_8259->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_8259);
meth_meth_ast_toGrace_40_1_41_8259->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_8259->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_8259->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_8259->definitionLine = 2106;
// method "shallowCopy"
  block_savedest(obj7964);
  Object closure8387 = createclosure(1, "shallowCopy");
  setclosureframe(closure8387, stackframe);
  addtoclosure(closure8387, var_defDecNode);
  struct UserObject *uo8387 = (struct UserObject*)obj7964;
  uo8387->data[20] = (Object)closure8387;
  Method *meth_meth_ast_shallowCopy8387 = addmethod2pos(obj7964, "shallowCopy", &meth_ast_shallowCopy8387, 20);
  int argcv_meth_ast_shallowCopy8387[] = {0};
  meth_meth_ast_shallowCopy8387->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8387);
  meth_meth_ast_shallowCopy8387->definitionModule = modulename;
  meth_meth_ast_shallowCopy8387->definitionLine = 2127;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo8398 = (struct UserObject*)obj7964;
  uo8398->data[21] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_8398 = addmethod2pos(obj7964, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_8398, 21);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_8398[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_8398->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_8398);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_8398->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_8398->definitionLine = 2130;
// method "statementName"
  struct UserObject *uo8405 = (struct UserObject*)obj7964;
  uo8405->data[22] = emptyclosure;
  Method *meth_meth_ast_statementName8405 = addmethod2pos(obj7964, "statementName", &meth_ast_statementName8405, 22);
  int argcv_meth_ast_statementName8405[] = {0};
  meth_meth_ast_statementName8405->type = alloc_MethodType(1, argcv_meth_ast_statementName8405);
  meth_meth_ast_statementName8405->definitionModule = modulename;
  meth_meth_ast_statementName8405->definitionLine = 2135;
  sourceObject = obj7964;
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8407 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8408 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8409 = gc_frame_new();
// call case 3: self.outer request
  Object call8410 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8409);
// compiled member node returning call8410 (depth = 5)
  Object call8411 = callmethodflags(call8410, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8408);
// compiled member node returning call8411 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8412 = callmethodflags(call8411, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8407);
// compiled call node returning call8412 (depth = 3)
  struct UserObject *obj7964_uo = (struct UserObject *)obj7964;
  obj7964_uo->super = call8412;
  sourceObject = obj7964;
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8413 == NULL) {
    strlit8413 = alloc_String("defdec");
    gc_root(strlit8413);
  }
// compiled string node returning strlit8413 (depth = 3)
  adddatum2(obj7964, strlit8413, 1);
  sourceObject = obj7964;
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj7964, *var_name_39_, 2);
  sourceObject = obj7964;
// Begin line 2032
  setline(2032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj7964, *var_val, 3);
  sourceObject = obj7964;
// Begin line 2033
  setline(2033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj7964, *var_dtype_39_, 4);
  sourceObject = obj7964;
// Begin line 2034
  setline(2034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8414 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8415 = gc_frame_new();
// call case 4: self request
  Object call8416 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8415);
// compiled member node returning call8416 (depth = 4)
  Object call8417 = callmethodflags(call8416, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe8414);
// compiled member node returning call8417 (depth = 3)
  adddatum2(obj7964, call8417, 5);
  sourceObject = obj7964;
// Begin line 2035
  setline(2035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array8418 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8418 (depth = 3)
  adddatum2(obj7964, array8418, 6);
  sourceObject = obj7964;
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8419 = alloc_Boolean(0);
// compiled identifier node returning bool8419 (depth = 3)
  adddatum2(obj7964, bool8419, 7);
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  objclass7964 = obj7964->class;
  objclass7964->definitionModule = modulename;
  objclass7964->definitionLine = 2028;
  (*(struct UserObject *)self).data[0] = lowerouter7964;
  self = oldself7964;
  selfslot = oldselfslot7964;
  stackframe = oldstackframe7964;
  gc_frame_end(frame);
  return obj7964;
}
Object meth_ast_new_40_3_41_7963_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_defDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7964 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7964 = alloc_userobj2(27,23, objclass7964);
  gc_frame_newslot(obj7964);
if (objclass7964 == NULL) {
  glfree(obj7964->class->name);
  obj7964->class->name = "defDecNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7964, self, 0);
  addmethodreal(obj7964,"outer", &reader_ast_outer_7965);
  Object oldself7964 = self;
  struct StackFrameObject *oldstackframe7964 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7964);
  gc_frame_newslot((Object)stackframe);
  self = obj7964;
  Object *oldselfslot7964 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7964 = (*(struct UserObject *)self).data[0], lowerouter7964 = thisouter7964;
  if (inheritingObject7964) {
    struct UserObject *inho7964 = (struct UserObject *)inheritingObject7964;
    while (inho7964->super != GraceDefaultObject) inho7964 = (struct UserObject *)inho7964->super;
    inho7964->super = obj7964;
    self = inheritingObject7964;
    *selfslot = self;
    lowerouter7964 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7964;
  }
if (objclass7964 == NULL) {
  Method *reader7966 = addmethodrealflags(obj7964, "kind",&reader_ast_kind_7966, MFLAG_DEF);
  reader7966->definitionModule = modulename;
  reader7966->definitionLine = 2030;
}
adddatum2(obj7964, alloc_Undefined(), 1);
if (objclass7964 == NULL) {
  Method *reader7967 = addmethodrealflags(obj7964, "name", &reader_ast_name_7967, 0);
  Method *writer7967 = addmethodrealflags(obj7964, "name:=(1)", &writer_ast_name_7967, 0);
  reader7967->definitionModule = modulename;
  writer7967->definitionModule = modulename;
  reader7967->definitionLine = 2031;
  writer7967->definitionLine = 2031;
}
obj7964->flags |= OFLAG_MUTABLE;
adddatum2(obj7964, alloc_Undefined(), 2);
if (objclass7964 == NULL) {
  Method *reader7968 = addmethodrealflags(obj7964, "value", &reader_ast_value_7968, 0);
  Method *writer7968 = addmethodrealflags(obj7964, "value:=(1)", &writer_ast_value_7968, 0);
  reader7968->definitionModule = modulename;
  writer7968->definitionModule = modulename;
  reader7968->definitionLine = 2032;
  writer7968->definitionLine = 2032;
}
obj7964->flags |= OFLAG_MUTABLE;
adddatum2(obj7964, alloc_Undefined(), 3);
if (objclass7964 == NULL) {
  Method *reader7969 = addmethodrealflags(obj7964, "dtype", &reader_ast_dtype_7969, 0);
  Method *writer7969 = addmethodrealflags(obj7964, "dtype:=(1)", &writer_ast_dtype_7969, 0);
  reader7969->definitionModule = modulename;
  writer7969->definitionModule = modulename;
  reader7969->definitionLine = 2033;
  writer7969->definitionLine = 2033;
}
obj7964->flags |= OFLAG_MUTABLE;
adddatum2(obj7964, alloc_Undefined(), 4);
if (objclass7964 == NULL) {
  Method *reader7970 = addmethodrealflags(obj7964, "nameString",&reader_ast_nameString_7970, MFLAG_DEF);
  reader7970->definitionModule = modulename;
  reader7970->definitionLine = 2034;
}
adddatum2(obj7964, alloc_Undefined(), 5);
if (objclass7964 == NULL) {
  Method *reader7971 = addmethodrealflags(obj7964, "annotations", &reader_ast_annotations_7971, 0);
  Method *writer7971 = addmethodrealflags(obj7964, "annotations:=(1)", &writer_ast_annotations_7971, 0);
  reader7971->definitionModule = modulename;
  writer7971->definitionModule = modulename;
  reader7971->definitionLine = 2035;
  writer7971->definitionLine = 2035;
}
obj7964->flags |= OFLAG_MUTABLE;
adddatum2(obj7964, alloc_Undefined(), 6);
if (objclass7964 == NULL) {
  Method *reader7972 = addmethodrealflags(obj7964, "startToken", &reader_ast_startToken_7972, 0);
  Method *writer7972 = addmethodrealflags(obj7964, "startToken:=(1)", &writer_ast_startToken_7972, 0);
  reader7972->definitionModule = modulename;
  writer7972->definitionModule = modulename;
  reader7972->definitionLine = 2036;
  writer7972->definitionLine = 2036;
}
obj7964->flags |= OFLAG_MUTABLE;
adddatum2(obj7964, alloc_Undefined(), 7);
// method "isPublic"
  struct UserObject *uo7973 = (struct UserObject*)obj7964;
  uo7973->data[8] = emptyclosure;
  Method *meth_meth_ast_isPublic7973 = addmethod2pos(obj7964, "isPublic", &meth_ast_isPublic7973, 8);
  int argcv_meth_ast_isPublic7973[] = {0};
  meth_meth_ast_isPublic7973->type = alloc_MethodType(1, argcv_meth_ast_isPublic7973);
  meth_meth_ast_isPublic7973->definitionModule = modulename;
  meth_meth_ast_isPublic7973->definitionLine = 2038;
// method "isFieldDec"
  struct UserObject *uo8000 = (struct UserObject*)obj7964;
  uo8000->data[9] = emptyclosure;
  Method *meth_meth_ast_isFieldDec8000 = addmethod2pos(obj7964, "isFieldDec", &meth_ast_isFieldDec8000, 9);
  int argcv_meth_ast_isFieldDec8000[] = {0};
  meth_meth_ast_isFieldDec8000->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec8000);
  meth_meth_ast_isFieldDec8000->definitionModule = modulename;
  meth_meth_ast_isFieldDec8000->definitionLine = 2044;
// method "isWritable"
  struct UserObject *uo8002 = (struct UserObject*)obj7964;
  uo8002->data[10] = emptyclosure;
  Method *meth_meth_ast_isWritable8002 = addmethod2pos(obj7964, "isWritable", &meth_ast_isWritable8002, 10);
  int argcv_meth_ast_isWritable8002[] = {0};
  meth_meth_ast_isWritable8002->type = alloc_MethodType(1, argcv_meth_ast_isWritable8002);
  meth_meth_ast_isWritable8002->definitionModule = modulename;
  meth_meth_ast_isWritable8002->definitionLine = 2045;
// method "isReadable"
  struct UserObject *uo8004 = (struct UserObject*)obj7964;
  uo8004->data[11] = emptyclosure;
  Method *meth_meth_ast_isReadable8004 = addmethod2pos(obj7964, "isReadable", &meth_ast_isReadable8004, 11);
  int argcv_meth_ast_isReadable8004[] = {0};
  meth_meth_ast_isReadable8004->type = alloc_MethodType(1, argcv_meth_ast_isReadable8004);
  meth_meth_ast_isReadable8004->definitionModule = modulename;
  meth_meth_ast_isReadable8004->definitionLine = 2046;
// method "returnsObject"
  struct UserObject *uo8007 = (struct UserObject*)obj7964;
  uo8007->data[12] = emptyclosure;
  Method *meth_meth_ast_returnsObject8007 = addmethod2pos(obj7964, "returnsObject", &meth_ast_returnsObject8007, 12);
  int argcv_meth_ast_returnsObject8007[] = {0};
  meth_meth_ast_returnsObject8007->type = alloc_MethodType(1, argcv_meth_ast_returnsObject8007);
  meth_meth_ast_returnsObject8007->definitionModule = modulename;
  meth_meth_ast_returnsObject8007->definitionLine = 2048;
// method "returnedObjectScope"
  struct UserObject *uo8012 = (struct UserObject*)obj7964;
  uo8012->data[13] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope8012 = addmethod2pos(obj7964, "returnedObjectScope", &meth_ast_returnedObjectScope8012, 13);
  int argcv_meth_ast_returnedObjectScope8012[] = {0};
  meth_meth_ast_returnedObjectScope8012->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope8012);
  meth_meth_ast_returnedObjectScope8012->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope8012->definitionLine = 2051;
// method "usesAsType(_)"
  struct UserObject *uo8017 = (struct UserObject*)obj7964;
  uo8017->data[14] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_8017 = addmethod2pos(obj7964, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_8017, 14);
  int argcv_meth_ast_usesAsType_40_1_41_8017[] = {1};
  meth_meth_ast_usesAsType_40_1_41_8017->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_8017);
  meth_meth_ast_usesAsType_40_1_41_8017->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_8017->definitionLine = 2055;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj7964);
  Object closure8023 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure8023, stackframe);
  addtoclosure(closure8023, var_k);
  struct UserObject *uo8023 = (struct UserObject*)obj7964;
  uo8023->data[15] = (Object)closure8023;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_8023 = addmethod2pos(obj7964, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_8023, 15);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_8023[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8023->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_8023);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8023->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8023->definitionLine = 2058;
// method "accept(_)from(_)"
  struct UserObject *uo8026 = (struct UserObject*)obj7964;
  uo8026->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_8026 = addmethod2pos(obj7964, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_8026, 16);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_8026[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_8026->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_8026);
  meth_meth_ast_accept_40_1_41_from_40_1_41_8026->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_8026->definitionLine = 2060;
// method "map(_)ancestors(_)"
  struct UserObject *uo8060 = (struct UserObject*)obj7964;
  uo8060->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_8060 = addmethod2pos(obj7964, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_8060, 17);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8060[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8060->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8060);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8060->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8060->definitionLine = 2073;
// method "pretty(_)"
  struct UserObject *uo8099 = (struct UserObject*)obj7964;
  uo8099->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_8099 = addmethod2pos(obj7964, "pretty(1)", &meth_ast_pretty_40_1_41_8099, 18);
  int argcv_meth_ast_pretty_40_1_41_8099[] = {1};
  meth_meth_ast_pretty_40_1_41_8099->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_8099);
  meth_meth_ast_pretty_40_1_41_8099->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_8099->definitionLine = 2082;
// method "toGrace(_)"
  struct UserObject *uo8259 = (struct UserObject*)obj7964;
  uo8259->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_8259 = addmethod2pos(obj7964, "toGrace(1)", &meth_ast_toGrace_40_1_41_8259, 19);
  int argcv_meth_ast_toGrace_40_1_41_8259[] = {1};
  meth_meth_ast_toGrace_40_1_41_8259->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_8259);
meth_meth_ast_toGrace_40_1_41_8259->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_8259->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_8259->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_8259->definitionLine = 2106;
// method "shallowCopy"
  block_savedest(obj7964);
  Object closure8387 = createclosure(1, "shallowCopy");
  setclosureframe(closure8387, stackframe);
  addtoclosure(closure8387, var_defDecNode);
  struct UserObject *uo8387 = (struct UserObject*)obj7964;
  uo8387->data[20] = (Object)closure8387;
  Method *meth_meth_ast_shallowCopy8387 = addmethod2pos(obj7964, "shallowCopy", &meth_ast_shallowCopy8387, 20);
  int argcv_meth_ast_shallowCopy8387[] = {0};
  meth_meth_ast_shallowCopy8387->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8387);
  meth_meth_ast_shallowCopy8387->definitionModule = modulename;
  meth_meth_ast_shallowCopy8387->definitionLine = 2127;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo8398 = (struct UserObject*)obj7964;
  uo8398->data[21] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_8398 = addmethod2pos(obj7964, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_8398, 21);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_8398[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_8398->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_8398);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_8398->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_8398->definitionLine = 2130;
// method "statementName"
  struct UserObject *uo8405 = (struct UserObject*)obj7964;
  uo8405->data[22] = emptyclosure;
  Method *meth_meth_ast_statementName8405 = addmethod2pos(obj7964, "statementName", &meth_ast_statementName8405, 22);
  int argcv_meth_ast_statementName8405[] = {0};
  meth_meth_ast_statementName8405->type = alloc_MethodType(1, argcv_meth_ast_statementName8405);
  meth_meth_ast_statementName8405->definitionModule = modulename;
  meth_meth_ast_statementName8405->definitionLine = 2135;
  sourceObject = obj7964;
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8407 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8408 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8409 = gc_frame_new();
// call case 3: self.outer request
  Object call8410 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8409);
// compiled member node returning call8410 (depth = 5)
  Object call8411 = callmethodflags(call8410, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8408);
// compiled member node returning call8411 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8412 = callmethodflags(call8411, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8407);
// compiled call node returning call8412 (depth = 3)
  struct UserObject *obj7964_uo = (struct UserObject *)obj7964;
  obj7964_uo->super = call8412;
  sourceObject = obj7964;
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8413 == NULL) {
    strlit8413 = alloc_String("defdec");
    gc_root(strlit8413);
  }
// compiled string node returning strlit8413 (depth = 3)
  adddatum2(obj7964, strlit8413, 1);
  sourceObject = obj7964;
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj7964, *var_name_39_, 2);
  sourceObject = obj7964;
// Begin line 2032
  setline(2032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj7964, *var_val, 3);
  sourceObject = obj7964;
// Begin line 2033
  setline(2033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj7964, *var_dtype_39_, 4);
  sourceObject = obj7964;
// Begin line 2034
  setline(2034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8414 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8415 = gc_frame_new();
// call case 4: self request
  Object call8416 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8415);
// compiled member node returning call8416 (depth = 4)
  Object call8417 = callmethodflags(call8416, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe8414);
// compiled member node returning call8417 (depth = 3)
  adddatum2(obj7964, call8417, 5);
  sourceObject = obj7964;
// Begin line 2035
  setline(2035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array8418 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8418 (depth = 3)
  adddatum2(obj7964, array8418, 6);
  sourceObject = obj7964;
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8419 = alloc_Boolean(0);
// compiled identifier node returning bool8419 (depth = 3)
  adddatum2(obj7964, bool8419, 7);
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  sourceObject = obj7964;
  objclass7964 = obj7964->class;
  objclass7964->definitionModule = modulename;
  objclass7964->definitionLine = 2028;
  (*(struct UserObject *)self).data[0] = lowerouter7964;
  self = oldself7964;
  selfslot = oldselfslot7964;
  stackframe = oldstackframe7964;
  gc_frame_end(frame);
  return obj7964;
}
Object meth_ast_defDecNode8421(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2021
  setline(2021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_defDecNode;
}
Object meth_ast_isPublic8433(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2150
  setline(2150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8436 = alloc_Float64(0);
// compiled num node returning num8436 (depth = 5)
  int op_slot_right_8435 = gc_frame_newslot(num8436);
// starting to compile member node (depth = 5)
  int callframe8438 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8439 = gc_frame_new();
// call case 4: self request
  Object call8440 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8439);
// compiled member node returning call8440 (depth = 6)
  Object call8441 = callmethodflags(call8440, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8438);
// compiled member node returning call8441 (depth = 5)
  int op_slot_left_8435 = gc_frame_newslot(call8441);
  params[0] = num8436;
  partcv[0] = 1;
  Object opresult8442 = callmethod(call8441, "==(1)", 1, partcv, params);
// compiled op node returning opresult8442 (depth = 4)
  Object if8434 = done;
  if (istrue(opresult8442)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8443 = alloc_Boolean(0);
// compiled identifier node returning bool8443 (depth = 5)
  return bool8443;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8434 = undefined;
  } else {
  }
// compiled if node returning if8434 (depth = 3)
// Begin line 2151
  setline(2151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8445 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8446 == NULL) {
    strlit8446 = alloc_String("public");
    gc_root(strlit8446);
  }
// compiled string node returning strlit8446 (depth = 5)
  gc_frame_newslot(strlit8446);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8447 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8448 = gc_frame_new();
// call case 3: self.outer request
  Object call8449 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8448);
// compiled member node returning call8449 (depth = 6)
  Object call8450 = callmethodflags(call8449, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8447);
// compiled member node returning call8450 (depth = 5)
  params[0] = self;
  params[1] = strlit8446;
  partcv[0] = 2;
  Object call8451 = callmethodflags(call8450, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8445);
// compiled call node returning call8451 (depth = 4)
  Object if8444 = done;
  if (istrue(call8451)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8452 = alloc_Boolean(1);
// compiled identifier node returning bool8452 (depth = 5)
  return bool8452;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8444 = undefined;
  } else {
  }
// compiled if node returning if8444 (depth = 3)
// Begin line 2152
  setline(2152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8453 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit8454 == NULL) {
    strlit8454 = alloc_String("readable");
    gc_root(strlit8454);
  }
// compiled string node returning strlit8454 (depth = 4)
  gc_frame_newslot(strlit8454);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8455 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8456 = gc_frame_new();
// call case 3: self.outer request
  Object call8457 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8456);
// compiled member node returning call8457 (depth = 5)
  Object call8458 = callmethodflags(call8457, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8455);
// compiled member node returning call8458 (depth = 4)
  params[0] = self;
  params[1] = strlit8454;
  partcv[0] = 2;
  Object call8459 = callmethodflags(call8458, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8453);
// compiled call node returning call8459 (depth = 3)
  gc_frame_end(frame);
  return call8459;
}
Object meth_ast_isWritable8460(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2155
  setline(2155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8463 = alloc_Float64(0);
// compiled num node returning num8463 (depth = 5)
  int op_slot_right_8462 = gc_frame_newslot(num8463);
// starting to compile member node (depth = 5)
  int callframe8465 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8466 = gc_frame_new();
// call case 4: self request
  Object call8467 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8466);
// compiled member node returning call8467 (depth = 6)
  Object call8468 = callmethodflags(call8467, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8465);
// compiled member node returning call8468 (depth = 5)
  int op_slot_left_8462 = gc_frame_newslot(call8468);
  params[0] = num8463;
  partcv[0] = 1;
  Object opresult8469 = callmethod(call8468, "==(1)", 1, partcv, params);
// compiled op node returning opresult8469 (depth = 4)
  Object if8461 = done;
  if (istrue(opresult8469)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8470 = alloc_Boolean(0);
// compiled identifier node returning bool8470 (depth = 5)
  return bool8470;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8461 = undefined;
  } else {
  }
// compiled if node returning if8461 (depth = 3)
// Begin line 2156
  setline(2156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8472 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8473 == NULL) {
    strlit8473 = alloc_String("public");
    gc_root(strlit8473);
  }
// compiled string node returning strlit8473 (depth = 5)
  gc_frame_newslot(strlit8473);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8474 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8475 = gc_frame_new();
// call case 3: self.outer request
  Object call8476 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8475);
// compiled member node returning call8476 (depth = 6)
  Object call8477 = callmethodflags(call8476, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8474);
// compiled member node returning call8477 (depth = 5)
  params[0] = self;
  params[1] = strlit8473;
  partcv[0] = 2;
  Object call8478 = callmethodflags(call8477, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8472);
// compiled call node returning call8478 (depth = 4)
  Object if8471 = done;
  if (istrue(call8478)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8479 = alloc_Boolean(1);
// compiled identifier node returning bool8479 (depth = 5)
  return bool8479;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8471 = undefined;
  } else {
  }
// compiled if node returning if8471 (depth = 3)
// Begin line 2157
  setline(2157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8481 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8482 == NULL) {
    strlit8482 = alloc_String("writable");
    gc_root(strlit8482);
  }
// compiled string node returning strlit8482 (depth = 5)
  gc_frame_newslot(strlit8482);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8483 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8484 = gc_frame_new();
// call case 3: self.outer request
  Object call8485 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8484);
// compiled member node returning call8485 (depth = 6)
  Object call8486 = callmethodflags(call8485, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8483);
// compiled member node returning call8486 (depth = 5)
  params[0] = self;
  params[1] = strlit8482;
  partcv[0] = 2;
  Object call8487 = callmethodflags(call8486, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8481);
// compiled call node returning call8487 (depth = 4)
  Object if8480 = done;
  if (istrue(call8487)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8488 = alloc_Boolean(1);
// compiled identifier node returning bool8488 (depth = 5)
  return bool8488;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8480 = undefined;
  } else {
  }
// compiled if node returning if8480 (depth = 3)
// Begin line 2158
  setline(2158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8489 = alloc_Boolean(0);
// compiled identifier node returning bool8489 (depth = 3)
  gc_frame_end(frame);
  return bool8489;
}
Object meth_ast_isReadable8490(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2161
  setline(2161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8493 = alloc_Float64(0);
// compiled num node returning num8493 (depth = 5)
  int op_slot_right_8492 = gc_frame_newslot(num8493);
// starting to compile member node (depth = 5)
  int callframe8495 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8496 = gc_frame_new();
// call case 4: self request
  Object call8497 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8496);
// compiled member node returning call8497 (depth = 6)
  Object call8498 = callmethodflags(call8497, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8495);
// compiled member node returning call8498 (depth = 5)
  int op_slot_left_8492 = gc_frame_newslot(call8498);
  params[0] = num8493;
  partcv[0] = 1;
  Object opresult8499 = callmethod(call8498, "==(1)", 1, partcv, params);
// compiled op node returning opresult8499 (depth = 4)
  Object if8491 = done;
  if (istrue(opresult8499)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8500 = alloc_Boolean(0);
// compiled identifier node returning bool8500 (depth = 5)
  return bool8500;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8491 = undefined;
  } else {
  }
// compiled if node returning if8491 (depth = 3)
// Begin line 2162
  setline(2162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8502 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8503 == NULL) {
    strlit8503 = alloc_String("public");
    gc_root(strlit8503);
  }
// compiled string node returning strlit8503 (depth = 5)
  gc_frame_newslot(strlit8503);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8504 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8505 = gc_frame_new();
// call case 3: self.outer request
  Object call8506 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8505);
// compiled member node returning call8506 (depth = 6)
  Object call8507 = callmethodflags(call8506, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8504);
// compiled member node returning call8507 (depth = 5)
  params[0] = self;
  params[1] = strlit8503;
  partcv[0] = 2;
  Object call8508 = callmethodflags(call8507, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8502);
// compiled call node returning call8508 (depth = 4)
  Object if8501 = done;
  if (istrue(call8508)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8509 = alloc_Boolean(1);
// compiled identifier node returning bool8509 (depth = 5)
  return bool8509;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8501 = undefined;
  } else {
  }
// compiled if node returning if8501 (depth = 3)
// Begin line 2163
  setline(2163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8511 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8512 == NULL) {
    strlit8512 = alloc_String("readable");
    gc_root(strlit8512);
  }
// compiled string node returning strlit8512 (depth = 5)
  gc_frame_newslot(strlit8512);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8513 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8514 = gc_frame_new();
// call case 3: self.outer request
  Object call8515 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8514);
// compiled member node returning call8515 (depth = 6)
  Object call8516 = callmethodflags(call8515, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8513);
// compiled member node returning call8516 (depth = 5)
  params[0] = self;
  params[1] = strlit8512;
  partcv[0] = 2;
  Object call8517 = callmethodflags(call8516, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8511);
// compiled call node returning call8517 (depth = 4)
  Object if8510 = done;
  if (istrue(call8517)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8518 = alloc_Boolean(1);
// compiled identifier node returning bool8518 (depth = 5)
  return bool8518;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8510 = undefined;
  } else {
  }
// compiled if node returning if8510 (depth = 3)
// Begin line 2164
  setline(2164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8519 = alloc_Boolean(0);
// compiled identifier node returning bool8519 (depth = 3)
  gc_frame_end(frame);
  return bool8519;
}
Object meth_ast_isFieldDec8520(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2166
  setline(2166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8521 = alloc_Boolean(1);
// compiled identifier node returning bool8521 (depth = 3)
  gc_frame_end(frame);
  return bool8521;
}
Object meth_ast_usesAsType_40_1_41_8522(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part usesAsType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2169
  setline(2169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8524 = gc_frame_new();
// call case 4: self request
  Object call8525 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8524);
// compiled member node returning call8525 (depth = 4)
  int op_slot_right_8523 = gc_frame_newslot(call8525);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_8523 = gc_frame_newslot(*var_aNode);
  params[0] = call8525;
  partcv[0] = 1;
  Object opresult8527 = callmethod(*var_aNode, "==(1)", 1, partcv, params);
// compiled op node returning opresult8527 (depth = 3)
  gc_frame_end(frame);
  return opresult8527;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_8528(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2172
  setline(2172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8529 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call8530 = callmethodflags(*var_k, "vardec", 0, partcv, params, 0);
  gc_frame_end(callframe8529);
// compiled member node returning call8530 (depth = 3)
  gc_frame_end(frame);
  return call8530;
}
Object meth_ast__apply_40_1_41_8556(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2182
  setline(2182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8557 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8558 = callmethodflags(*var_ann, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8557);
// compiled call node returning call8558 (depth = 6)
  gc_frame_end(frame);
  return call8558;
}
Object meth_ast_accept_40_1_41_from_40_1_41_8531(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2175
  setline(2175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8533 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8534 = callmethodflags(*var_visitor, "visitVarDec(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8533);
// compiled call node returning call8534 (depth = 4)
  Object if8532 = done;
  if (istrue(call8534)) {
// Begin line 2176
  setline(2176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8535 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call8536 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8535);
// compiled call node returning call8536 (depth = 5)
  *var_newChain = call8536;
  if (call8536 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2177
  setline(2177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8537 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8538 = gc_frame_new();
// call case 4: self request
  Object call8539 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8538);
// compiled member node returning call8539 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8540 = callmethodflags(call8539, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8537);
// compiled call node returning call8540 (depth = 4)
// Begin line 2178
  setline(2178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8543 = gc_frame_new();
// call case 4: self request
  Object call8544 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8543);
// compiled member node returning call8544 (depth = 6)
  int op_slot_right_8542 = gc_frame_newslot(call8544);
// starting to compile identifier node (depth = 6)
  Object bool8546 = alloc_Boolean(0);
// compiled identifier node returning bool8546 (depth = 6)
  int op_slot_left_8542 = gc_frame_newslot(bool8546);
  params[0] = call8544;
  partcv[0] = 1;
  Object opresult8547 = callmethod(bool8546, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8547 (depth = 5)
  Object if8541 = done;
  if (istrue(opresult8547)) {
// Begin line 2179
  setline(2179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8548 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8549 = gc_frame_new();
// call case 4: self request
  Object call8550 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8549);
// compiled member node returning call8550 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8551 = callmethodflags(call8550, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8548);
// compiled call node returning call8551 (depth = 5)
    gc_frame_newslot(call8551);
    if8541 = call8551;
  } else {
  }
// compiled if node returning if8541 (depth = 4)
// Begin line 2181
  setline(2181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8552 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8553 = gc_frame_new();
// call case 4: self request
  Object call8554 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8553);
// compiled member node returning call8554 (depth = 5)
  gc_frame_newslot(call8554);
// starting to compile block node (depth = 5)
  Object block8555 = alloc_Block(NULL, NULL, "ast", 2181);
  gc_frame_newslot(block8555);
// method "_apply(_)"
  block_savedest(block8555);
  Object closure8556 = createclosure(3, "_apply(1)");
  setclosureframe(closure8556, stackframe);
  addtoclosure(closure8556, var_visitor);
  addtoclosure(closure8556, var_newChain);
  addtoclosure(closure8556, selfslot);
  struct UserObject *uo8556 = (struct UserObject*)block8555;
  uo8556->data[0] = (Object)closure8556;
  Method *meth_meth_ast__apply_40_1_41_8556 = addmethod2pos(block8555, "_apply(1)", &meth_ast__apply_40_1_41_8556, 0);
  int argcv_meth_ast__apply_40_1_41_8556[] = {1};
  meth_meth_ast__apply_40_1_41_8556->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_8556);
  meth_meth_ast__apply_40_1_41_8556->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_8556->definitionLine = 2981;
// compiled block node returning block8555 (depth = 5)
  gc_frame_newslot(block8555);
// call case 5: prelude request
  params[0] = call8554;
  params[1] = block8555;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8560 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8552);
// compiled call node returning call8560 (depth = 4)
// Begin line 2184
  setline(2184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8563 = gc_frame_new();
// call case 4: self request
  Object call8564 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8563);
// compiled member node returning call8564 (depth = 6)
  int op_slot_right_8562 = gc_frame_newslot(call8564);
// starting to compile identifier node (depth = 6)
  Object bool8566 = alloc_Boolean(0);
// compiled identifier node returning bool8566 (depth = 6)
  int op_slot_left_8562 = gc_frame_newslot(bool8566);
  params[0] = call8564;
  partcv[0] = 1;
  Object opresult8567 = callmethod(bool8566, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8567 (depth = 5)
  Object if8561 = done;
  if (istrue(opresult8567)) {
// Begin line 2185
  setline(2185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8568 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8569 = gc_frame_new();
// call case 4: self request
  Object call8570 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8569);
// compiled member node returning call8570 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8571 = callmethodflags(call8570, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8568);
// compiled call node returning call8571 (depth = 5)
    gc_frame_newslot(call8571);
    if8561 = call8571;
  } else {
  }
// compiled if node returning if8561 (depth = 4)
    gc_frame_newslot(if8561);
    if8532 = if8561;
  } else {
  }
// compiled if node returning if8532 (depth = 3)
  gc_frame_end(frame);
  return if8532;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_8572(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2190
  setline(2190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8573 = gc_frame_new();
// call case 4: self request
  Object call8574 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8573);
// compiled member node returning call8574 (depth = 4)
  *var_n = call8574;
  if (call8574 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2191
  setline(2191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8575 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8576 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8575);
// compiled call node returning call8576 (depth = 4)
  *var_newChain = call8576;
  if (call8576 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2192
  setline(2192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8577 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8578 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8579 = gc_frame_new();
// call case 4: self request
  Object call8580 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8579);
// compiled member node returning call8580 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8581 = callmethodflags(call8580, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8578);
// compiled call node returning call8581 (depth = 4)
  gc_frame_newslot(call8581);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8581;
  partcv[0] = 1;
  Object call8582 = callmethodflags(*var_n, "name:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8577);
// compiled call node returning call8582 (depth = 3)
// Begin line 2193
  setline(2193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8583 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8584 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8585 = gc_frame_new();
// call case 4: self request
  Object call8586 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8585);
// compiled member node returning call8586 (depth = 5)
  gc_frame_newslot(call8586);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8587 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8588 = gc_frame_new();
// call case 3: self.outer request
  Object call8589 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8588);
// compiled member node returning call8589 (depth = 6)
  Object call8590 = callmethodflags(call8589, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8587);
// compiled member node returning call8590 (depth = 5)
  params[0] = call8586;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8591 = callmethodflags(call8590, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8584);
// compiled call node returning call8591 (depth = 4)
  gc_frame_newslot(call8591);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8591;
  partcv[0] = 1;
  Object call8592 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8583);
// compiled call node returning call8592 (depth = 3)
// Begin line 2194
  setline(2194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8593 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8594 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8595 = gc_frame_new();
// call case 4: self request
  Object call8596 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8595);
// compiled member node returning call8596 (depth = 5)
  gc_frame_newslot(call8596);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8597 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8598 = gc_frame_new();
// call case 3: self.outer request
  Object call8599 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8598);
// compiled member node returning call8599 (depth = 6)
  Object call8600 = callmethodflags(call8599, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8597);
// compiled member node returning call8600 (depth = 5)
  params[0] = call8596;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8601 = callmethodflags(call8600, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8594);
// compiled call node returning call8601 (depth = 4)
  gc_frame_newslot(call8601);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8601;
  partcv[0] = 1;
  Object call8602 = callmethodflags(*var_n, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8593);
// compiled call node returning call8602 (depth = 3)
// Begin line 2195
  setline(2195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8603 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8604 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8605 = gc_frame_new();
// call case 4: self request
  Object call8606 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8605);
// compiled member node returning call8606 (depth = 5)
  gc_frame_newslot(call8606);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8607 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8608 = gc_frame_new();
// call case 3: self.outer request
  Object call8609 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8608);
// compiled member node returning call8609 (depth = 6)
  Object call8610 = callmethodflags(call8609, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8607);
// compiled member node returning call8610 (depth = 5)
  params[0] = call8606;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8611 = callmethodflags(call8610, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8604);
// compiled call node returning call8611 (depth = 4)
  gc_frame_newslot(call8611);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8611;
  partcv[0] = 1;
  Object call8612 = callmethodflags(*var_n, "annotations:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8603);
// compiled call node returning call8612 (depth = 3)
// Begin line 2196
  setline(2196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8613 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8614 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe8613);
// compiled call node returning call8614 (depth = 3)
  gc_frame_end(frame);
  return call8614;
}
Object meth_ast__apply_40_1_41_8623(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2201
  setline(2201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8625 == NULL) {
    strlit8625 = alloc_String("  ");
    gc_root(strlit8625);
  }
// compiled string node returning strlit8625 (depth = 7)
  int op_slot_right_8624 = gc_frame_newslot(strlit8625);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8624 = gc_frame_newslot(*var_spc);
  params[0] = strlit8625;
  partcv[0] = 1;
  Object opresult8627 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult8627 (depth = 6)
  *var_spc = opresult8627;
  if (opresult8627 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_8615(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2199
  setline(2199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8616 == NULL) {
    strlit8616 = alloc_String("");
    gc_root(strlit8616);
  }
// compiled string node returning strlit8616 (depth = 4)
  *var_spc = strlit8616;
  if (strlit8616 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2200
  setline(2200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8617 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_8618 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num8620 = alloc_Float64(0);
// compiled num node returning num8620 (depth = 5)
  int op_slot_left_8618 = gc_frame_newslot(num8620);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8621 = callmethod(num8620, "..(1)", 1, partcv, params);
// compiled op node returning opresult8621 (depth = 4)
  gc_frame_newslot(opresult8621);
// starting to compile block node (depth = 4)
  Object block8622 = alloc_Block(NULL, NULL, "ast", 2200);
  gc_frame_newslot(block8622);
// method "_apply(_)"
  block_savedest(block8622);
  Object closure8623 = createclosure(2, "_apply(1)");
  setclosureframe(closure8623, stackframe);
  addtoclosure(closure8623, var_spc);
  addtoclosure(closure8623, selfslot);
  struct UserObject *uo8623 = (struct UserObject*)block8622;
  uo8623->data[0] = (Object)closure8623;
  Method *meth_meth_ast__apply_40_1_41_8623 = addmethod2pos(block8622, "_apply(1)", &meth_ast__apply_40_1_41_8623, 0);
  int argcv_meth_ast__apply_40_1_41_8623[] = {1};
  meth_meth_ast__apply_40_1_41_8623->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_8623);
  meth_meth_ast__apply_40_1_41_8623->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_8623->definitionLine = 2981;
// compiled block node returning block8622 (depth = 4)
  gc_frame_newslot(block8622);
// call case 5: prelude request
  params[0] = opresult8621;
  params[1] = block8622;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8630 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8617);
// compiled call node returning call8630 (depth = 3)
// Begin line 2203
  setline(2203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8632 == NULL) {
    strlit8632 = alloc_String("""\x0a""");
    gc_root(strlit8632);
  }
// compiled string node returning strlit8632 (depth = 5)
  int op_slot_right_8631 = gc_frame_newslot(strlit8632);
// starting to compile call node (depth = 5)
  int callframe8634 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8635 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8634);
// compiled call node returning call8635 (depth = 5)
  int op_slot_left_8631 = gc_frame_newslot(call8635);
  params[0] = strlit8632;
  partcv[0] = 1;
  Object opresult8636 = callmethod(call8635, "++(1)", 1, partcv, params);
// compiled op node returning opresult8636 (depth = 4)
  *var_s = opresult8636;
  if (opresult8636 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2204
  setline(2204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8638 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8640 = alloc_Float64(1);
// compiled num node returning num8640 (depth = 7)
  int op_slot_right_8639 = gc_frame_newslot(num8640);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_8639 = gc_frame_newslot(*var_depth);
  params[0] = num8640;
  partcv[0] = 1;
  Object sum8642 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8642 (depth = 6)
  gc_frame_newslot(sum8642);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8643 = gc_frame_new();
// call case 4: self request
  Object call8644 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8643);
// compiled member node returning call8644 (depth = 6)
  params[0] = sum8642;
  partcv[0] = 1;
  Object call8645 = callmethodflags(call8644, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8638);
// compiled call node returning call8645 (depth = 5)
  int op_slot_right_8637 = gc_frame_newslot(call8645);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_8647 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8647 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8649 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8649 (depth = 5)
  int op_slot_left_8637 = gc_frame_newslot(opresult8649);
  params[0] = call8645;
  partcv[0] = 1;
  Object opresult8650 = callmethod(opresult8649, "++(1)", 1, partcv, params);
// compiled op node returning opresult8650 (depth = 4)
  *var_s = opresult8650;
  if (opresult8650 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2205
  setline(2205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8654 = gc_frame_new();
// call case 4: self request
  Object call8655 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8654);
// compiled member node returning call8655 (depth = 5)
  int op_slot_right_8653 = gc_frame_newslot(call8655);
// starting to compile identifier node (depth = 5)
  Object bool8657 = alloc_Boolean(0);
// compiled identifier node returning bool8657 (depth = 5)
  int op_slot_left_8653 = gc_frame_newslot(bool8657);
  params[0] = call8655;
  partcv[0] = 1;
  Object opresult8658 = callmethod(bool8657, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8658 (depth = 4)
  Object if8652 = done;
  if (istrue(opresult8658)) {
// Begin line 2206
  setline(2206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8660 == NULL) {
    strlit8660 = alloc_String("Type: ");
    gc_root(strlit8660);
  }
// compiled string node returning strlit8660 (depth = 6)
  int op_slot_right_8659 = gc_frame_newslot(strlit8660);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_8662 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8665 == NULL) {
    strlit8665 = alloc_String("""\x0a""");
    gc_root(strlit8665);
  }
// compiled string node returning strlit8665 (depth = 8)
  int op_slot_right_8664 = gc_frame_newslot(strlit8665);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_8664 = gc_frame_newslot(*var_s);
  params[0] = strlit8665;
  partcv[0] = 1;
  Object opresult8667 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8667 (depth = 7)
  int op_slot_left_8662 = gc_frame_newslot(opresult8667);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8668 = callmethod(opresult8667, "++(1)", 1, partcv, params);
// compiled op node returning opresult8668 (depth = 6)
  int op_slot_left_8659 = gc_frame_newslot(opresult8668);
  params[0] = strlit8660;
  partcv[0] = 1;
  Object opresult8669 = callmethod(opresult8668, "++(1)", 1, partcv, params);
// compiled op node returning opresult8669 (depth = 5)
  *var_s = opresult8669;
  if (opresult8669 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2207
  setline(2207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8672 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8674 = alloc_Float64(2);
// compiled num node returning num8674 (depth = 8)
  int op_slot_right_8673 = gc_frame_newslot(num8674);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8673 = gc_frame_newslot(*var_depth);
  params[0] = num8674;
  partcv[0] = 1;
  Object sum8676 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8676 (depth = 7)
  gc_frame_newslot(sum8676);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8677 = gc_frame_new();
// call case 4: self request
  Object call8678 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8677);
// compiled member node returning call8678 (depth = 7)
  params[0] = sum8676;
  partcv[0] = 1;
  Object call8679 = callmethodflags(call8678, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8672);
// compiled call node returning call8679 (depth = 6)
  int op_slot_right_8671 = gc_frame_newslot(call8679);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8671 = gc_frame_newslot(*var_s);
  params[0] = call8679;
  partcv[0] = 1;
  Object opresult8681 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8681 (depth = 5)
  *var_s = opresult8681;
  if (opresult8681 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8652 = done;
  } else {
  }
// compiled if node returning if8652 (depth = 3)
// Begin line 2209
  setline(2209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8685 = gc_frame_new();
// call case 4: self request
  Object call8686 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8685);
// compiled member node returning call8686 (depth = 5)
  int op_slot_right_8684 = gc_frame_newslot(call8686);
// starting to compile identifier node (depth = 5)
  Object bool8688 = alloc_Boolean(0);
// compiled identifier node returning bool8688 (depth = 5)
  int op_slot_left_8684 = gc_frame_newslot(bool8688);
  params[0] = call8686;
  partcv[0] = 1;
  Object opresult8689 = callmethod(bool8688, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8689 (depth = 4)
  Object if8683 = done;
  if (istrue(opresult8689)) {
// Begin line 2210
  setline(2210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8691 == NULL) {
    strlit8691 = alloc_String("Value: ");
    gc_root(strlit8691);
  }
// compiled string node returning strlit8691 (depth = 6)
  int op_slot_right_8690 = gc_frame_newslot(strlit8691);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_8693 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8696 == NULL) {
    strlit8696 = alloc_String("""\x0a""");
    gc_root(strlit8696);
  }
// compiled string node returning strlit8696 (depth = 8)
  int op_slot_right_8695 = gc_frame_newslot(strlit8696);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_8695 = gc_frame_newslot(*var_s);
  params[0] = strlit8696;
  partcv[0] = 1;
  Object opresult8698 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8698 (depth = 7)
  int op_slot_left_8693 = gc_frame_newslot(opresult8698);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8699 = callmethod(opresult8698, "++(1)", 1, partcv, params);
// compiled op node returning opresult8699 (depth = 6)
  int op_slot_left_8690 = gc_frame_newslot(opresult8699);
  params[0] = strlit8691;
  partcv[0] = 1;
  Object opresult8700 = callmethod(opresult8699, "++(1)", 1, partcv, params);
// compiled op node returning opresult8700 (depth = 5)
  *var_s = opresult8700;
  if (opresult8700 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2211
  setline(2211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8703 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8705 = alloc_Float64(2);
// compiled num node returning num8705 (depth = 8)
  int op_slot_right_8704 = gc_frame_newslot(num8705);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8704 = gc_frame_newslot(*var_depth);
  params[0] = num8705;
  partcv[0] = 1;
  Object sum8707 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8707 (depth = 7)
  gc_frame_newslot(sum8707);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8708 = gc_frame_new();
// call case 4: self request
  Object call8709 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8708);
// compiled member node returning call8709 (depth = 7)
  params[0] = sum8707;
  partcv[0] = 1;
  Object call8710 = callmethodflags(call8709, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8703);
// compiled call node returning call8710 (depth = 6)
  int op_slot_right_8702 = gc_frame_newslot(call8710);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8702 = gc_frame_newslot(*var_s);
  params[0] = call8710;
  partcv[0] = 1;
  Object opresult8712 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8712 (depth = 5)
  *var_s = opresult8712;
  if (opresult8712 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8683 = done;
  } else {
  }
// compiled if node returning if8683 (depth = 3)
// Begin line 2213
  setline(2213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8716 = gc_frame_new();
// call case 4: self request
  Object call8717 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8716);
// compiled member node returning call8717 (depth = 5)
  int op_slot_right_8715 = gc_frame_newslot(call8717);
// starting to compile identifier node (depth = 5)
  Object bool8719 = alloc_Boolean(0);
// compiled identifier node returning bool8719 (depth = 5)
  int op_slot_left_8715 = gc_frame_newslot(bool8719);
  params[0] = call8717;
  partcv[0] = 1;
  Object opresult8720 = callmethod(bool8719, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8720 (depth = 4)
  Object if8714 = done;
  if (istrue(opresult8720)) {
// Begin line 2214
  setline(2214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8722 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8724 = alloc_Float64(2);
// compiled num node returning num8724 (depth = 8)
  int op_slot_right_8723 = gc_frame_newslot(num8724);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8723 = gc_frame_newslot(*var_depth);
  params[0] = num8724;
  partcv[0] = 1;
  Object sum8726 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum8726 (depth = 7)
  gc_frame_newslot(sum8726);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8727 = gc_frame_new();
// call case 4: self request
  Object call8728 = callmethodflags(self, "comments", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8727);
// compiled member node returning call8728 (depth = 7)
  params[0] = sum8726;
  partcv[0] = 1;
  Object call8729 = callmethodflags(call8728, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8722);
// compiled call node returning call8729 (depth = 6)
  int op_slot_right_8721 = gc_frame_newslot(call8729);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8721 = gc_frame_newslot(*var_s);
  params[0] = call8729;
  partcv[0] = 1;
  Object opresult8731 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8731 (depth = 5)
  *var_s = opresult8731;
  if (opresult8731 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8714 = done;
  } else {
  }
// compiled if node returning if8714 (depth = 3)
// Begin line 2216
  setline(2216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply8737(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 2221
  setline(2221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8739 == NULL) {
    strlit8739 = alloc_String("    ");
    gc_root(strlit8739);
  }
// compiled string node returning strlit8739 (depth = 7)
  int op_slot_right_8738 = gc_frame_newslot(strlit8739);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8738 = gc_frame_newslot(*var_spc);
  params[0] = strlit8739;
  partcv[0] = 1;
  Object opresult8741 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult8741 (depth = 6)
  *var_spc = opresult8741;
  if (opresult8741 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply8761(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2225
  setline(2225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8763 == NULL) {
    strlit8763 = alloc_String("Unknown");
    gc_root(strlit8763);
  }
// compiled string node returning strlit8763 (depth = 7)
  int op_slot_right_8762 = gc_frame_newslot(strlit8763);
// starting to compile member node (depth = 7)
  int callframe8765 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe8766 = gc_frame_new();
// call case 4: self request
  Object call8767 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8766);
// compiled member node returning call8767 (depth = 8)
  Object call8768 = callmethodflags(call8767, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8765);
// compiled member node returning call8768 (depth = 7)
  int op_slot_left_8762 = gc_frame_newslot(call8768);
  params[0] = strlit8763;
  partcv[0] = 1;
  Object opresult8769 = callmethod(call8768, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8769 (depth = 6)
  gc_frame_end(frame);
  return opresult8769;
}
Object meth_ast__apply_40_2_41_8809(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2231
  setline(2231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8811 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num8812 = alloc_Float64(0);
// compiled num node returning num8812 (depth = 10)
  gc_frame_newslot(num8812);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_b (depth = 10)
  params[0] = num8812;
  partcv[0] = 1;
  Object call8813 = callmethodflags(*var_b, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8811);
// compiled call node returning call8813 (depth = 9)
  int op_slot_right_8810 = gc_frame_newslot(call8813);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8817 == NULL) {
    strlit8817 = alloc_String("");
    gc_root(strlit8817);
  }
// compiled string node returning strlit8817 (depth = 11)
  int op_slot_right_8816 = gc_frame_newslot(strlit8817);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_8816 = gc_frame_newslot(*var_a);
  params[0] = strlit8817;
  partcv[0] = 1;
  Object opresult8819 = callmethod(*var_a, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8819 (depth = 10)
  Object if8815 = done;
struct StackFrameObject *iftmpstackframe8815 = stackframe;
  if (istrue(opresult8819)) {
stackframe = alloc_StackFrame(0, iftmpstackframe8815);
gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8821 == NULL) {
    strlit8821 = alloc_String(", ");
    gc_root(strlit8821);
  }
// compiled string node returning strlit8821 (depth = 11)
  int op_slot_right_8820 = gc_frame_newslot(strlit8821);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_8820 = gc_frame_newslot(*var_a);
  params[0] = strlit8821;
  partcv[0] = 1;
  Object opresult8823 = callmethod(*var_a, "++(1)", 1, partcv, params);
// compiled op node returning opresult8823 (depth = 10)
    gc_frame_newslot(opresult8823);
    if8815 = opresult8823;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe8815);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 10)
  if (strlit8824 == NULL) {
    strlit8824 = alloc_String("");
    gc_root(strlit8824);
  }
// compiled string node returning strlit8824 (depth = 10)
    gc_frame_newslot(strlit8824);
    if8815 = strlit8824;
  }
stackframe = iftmpstackframe8815;
// compiled if node returning if8815 (depth = 9)
  int op_slot_left_8810 = gc_frame_newslot(if8815);
  params[0] = call8813;
  partcv[0] = 1;
  Object opresult8825 = callmethod(if8815, "++(1)", 1, partcv, params);
// compiled op node returning opresult8825 (depth = 8)
  gc_frame_end(frame);
  return opresult8825;
}
Object meth_ast_toGrace_40_1_41_8733(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2219
  setline(2219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8734 == NULL) {
    strlit8734 = alloc_String("");
    gc_root(strlit8734);
  }
// compiled string node returning strlit8734 (depth = 4)
  *var_spc = strlit8734;
  if (strlit8734 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2220
  setline(2220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8735 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 4)
  Object block8736 = alloc_Block(NULL, NULL, "ast", 2220);
  gc_frame_newslot(block8736);
// method "_apply"
  block_savedest(block8736);
  Object closure8737 = createclosure(2, "_apply");
  setclosureframe(closure8737, stackframe);
  addtoclosure(closure8737, var_spc);
  addtoclosure(closure8737, selfslot);
  struct UserObject *uo8737 = (struct UserObject*)block8736;
  uo8737->data[0] = (Object)closure8737;
  Method *meth_meth_ast__apply8737 = addmethod2pos(block8736, "_apply", &meth_ast__apply8737, 0);
  int argcv_meth_ast__apply8737[] = {0};
  meth_meth_ast__apply8737->type = alloc_MethodType(1, argcv_meth_ast__apply8737);
  meth_meth_ast__apply8737->definitionModule = modulename;
  meth_meth_ast__apply8737->definitionLine = 2981;
// compiled block node returning block8736 (depth = 4)
  gc_frame_newslot(block8736);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block8736;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8744 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8735);
// compiled call node returning call8744 (depth = 3)
// Begin line 2223
  setline(2223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8746 == NULL) {
    strlit8746 = alloc_String("");
    gc_root(strlit8746);
  }
// compiled string node returning strlit8746 (depth = 5)
  int op_slot_right_8745 = gc_frame_newslot(strlit8746);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8749 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num8750 = alloc_Float64(0);
// compiled num node returning num8750 (depth = 7)
  gc_frame_newslot(num8750);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8751 = gc_frame_new();
// call case 4: self request
  Object call8752 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8751);
// compiled member node returning call8752 (depth = 7)
  params[0] = num8750;
  partcv[0] = 1;
  Object call8753 = callmethodflags(call8752, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8749);
// compiled call node returning call8753 (depth = 6)
  int op_slot_right_8748 = gc_frame_newslot(call8753);
// starting to compile string node (depth = 6)
  if (strlit8755 == NULL) {
    strlit8755 = alloc_String("var ");
    gc_root(strlit8755);
  }
// compiled string node returning strlit8755 (depth = 6)
  int op_slot_left_8748 = gc_frame_newslot(strlit8755);
  params[0] = call8753;
  partcv[0] = 1;
  Object opresult8756 = callmethod(strlit8755, "++(1)", 1, partcv, params);
// compiled op node returning opresult8756 (depth = 5)
  int op_slot_left_8745 = gc_frame_newslot(opresult8756);
  params[0] = strlit8746;
  partcv[0] = 1;
  Object opresult8757 = callmethod(opresult8756, "++(1)", 1, partcv, params);
// compiled op node returning opresult8757 (depth = 4)
  *var_s = opresult8757;
  if (opresult8757 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2224
  setline(2224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block8760 = alloc_Block(NULL, NULL, "ast", 2224);
  gc_frame_newslot(block8760);
// method "_apply"
  block_savedest(block8760);
  Object closure8761 = createclosure(1, "_apply");
  setclosureframe(closure8761, stackframe);
  addtoclosure(closure8761, selfslot);
  struct UserObject *uo8761 = (struct UserObject*)block8760;
  uo8761->data[0] = (Object)closure8761;
  Method *meth_meth_ast__apply8761 = addmethod2pos(block8760, "_apply", &meth_ast__apply8761, 0);
  int argcv_meth_ast__apply8761[] = {0};
  meth_meth_ast__apply8761->type = alloc_MethodType(1, argcv_meth_ast__apply8761);
  meth_meth_ast__apply8761->definitionModule = modulename;
  meth_meth_ast__apply8761->definitionLine = 2981;
// compiled block node returning block8760 (depth = 5)
  int op_slot_right_8759 = gc_frame_newslot(block8760);
// Begin line 2224
  setline(2224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8773 = gc_frame_new();
// call case 4: self request
  Object call8774 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8773);
// compiled member node returning call8774 (depth = 6)
  int op_slot_right_8772 = gc_frame_newslot(call8774);
// starting to compile identifier node (depth = 6)
  Object bool8776 = alloc_Boolean(0);
// compiled identifier node returning bool8776 (depth = 6)
  int op_slot_left_8772 = gc_frame_newslot(bool8776);
  params[0] = call8774;
  partcv[0] = 1;
  Object opresult8777 = callmethod(bool8776, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8777 (depth = 5)
  int op_slot_left_8759 = gc_frame_newslot(opresult8777);
  params[0] = block8760;
  partcv[0] = 1;
  Object opresult8778 = callmethod(opresult8777, "&&(1)", 1, partcv, params);
// compiled op node returning opresult8778 (depth = 4)
  Object if8758 = done;
  if (istrue(opresult8778)) {
// Begin line 2226
  setline(2226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8780 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num8781 = alloc_Float64(0);
// compiled num node returning num8781 (depth = 7)
  gc_frame_newslot(num8781);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8782 = gc_frame_new();
// call case 4: self request
  Object call8783 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8782);
// compiled member node returning call8783 (depth = 7)
  params[0] = num8781;
  partcv[0] = 1;
  Object call8784 = callmethodflags(call8783, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8780);
// compiled call node returning call8784 (depth = 6)
  int op_slot_right_8779 = gc_frame_newslot(call8784);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8787 == NULL) {
    strlit8787 = alloc_String(" : ");
    gc_root(strlit8787);
  }
// compiled string node returning strlit8787 (depth = 7)
  int op_slot_right_8786 = gc_frame_newslot(strlit8787);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8786 = gc_frame_newslot(*var_s);
  params[0] = strlit8787;
  partcv[0] = 1;
  Object opresult8789 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8789 (depth = 6)
  int op_slot_left_8779 = gc_frame_newslot(opresult8789);
  params[0] = call8784;
  partcv[0] = 1;
  Object opresult8790 = callmethod(opresult8789, "++(1)", 1, partcv, params);
// compiled op node returning opresult8790 (depth = 5)
  *var_s = opresult8790;
  if (opresult8790 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8758 = done;
  } else {
  }
// compiled if node returning if8758 (depth = 3)
// Begin line 2228
  setline(2228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8794 = alloc_Float64(0);
// compiled num node returning num8794 (depth = 5)
  int op_slot_right_8793 = gc_frame_newslot(num8794);
// starting to compile member node (depth = 5)
  int callframe8796 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8797 = gc_frame_new();
// call case 4: self request
  Object call8798 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8797);
// compiled member node returning call8798 (depth = 6)
  Object call8799 = callmethodflags(call8798, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8796);
// compiled member node returning call8799 (depth = 5)
  int op_slot_left_8793 = gc_frame_newslot(call8799);
  params[0] = num8794;
  partcv[0] = 1;
  Object opresult8800 = callmethod(call8799, ">(1)", 1, partcv, params);
// compiled op node returning opresult8800 (depth = 4)
  Object if8792 = done;
  if (istrue(opresult8800)) {
// Begin line 2229
  setline(2229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8802 == NULL) {
    strlit8802 = alloc_String(" is ");
    gc_root(strlit8802);
  }
// compiled string node returning strlit8802 (depth = 6)
  int op_slot_right_8801 = gc_frame_newslot(strlit8802);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8801 = gc_frame_newslot(*var_s);
  params[0] = strlit8802;
  partcv[0] = 1;
  Object opresult8804 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8804 (depth = 5)
  *var_s = opresult8804;
  if (opresult8804 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2230
  setline(2230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8807 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block8808 = alloc_Block(NULL, NULL, "ast", 2230);
  gc_frame_newslot(block8808);
// method "_apply(_,_)"
  block_savedest(block8808);
  Object closure8809 = createclosure(1, "_apply(2)");
  setclosureframe(closure8809, stackframe);
  addtoclosure(closure8809, selfslot);
  struct UserObject *uo8809 = (struct UserObject*)block8808;
  uo8809->data[0] = (Object)closure8809;
  Method *meth_meth_ast__apply_40_2_41_8809 = addmethod2pos(block8808, "_apply(2)", &meth_ast__apply_40_2_41_8809, 0);
  int argcv_meth_ast__apply_40_2_41_8809[] = {2};
  meth_meth_ast__apply_40_2_41_8809->type = alloc_MethodType(1, argcv_meth_ast__apply_40_2_41_8809);
  meth_meth_ast__apply_40_2_41_8809->definitionModule = modulename;
  meth_meth_ast__apply_40_2_41_8809->definitionLine = 2981;
// compiled block node returning block8808 (depth = 7)
  gc_frame_newslot(block8808);
// Begin line 2232
  setline(2232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8827 == NULL) {
    strlit8827 = alloc_String("");
    gc_root(strlit8827);
  }
// compiled string node returning strlit8827 (depth = 7)
  gc_frame_newslot(strlit8827);
// call case 6: other requests
// Begin line 2230
  setline(2230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
  int callframe8828 = gc_frame_new();
// call case 4: self request
  Object call8829 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8828);
// compiled member node returning call8829 (depth = 7)
  params[0] = block8808;
  params[1] = strlit8827;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8830 = callmethodflags(call8829, "fold(1)startingWith(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8807);
// compiled call node returning call8830 (depth = 6)
  int op_slot_right_8806 = gc_frame_newslot(call8830);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8806 = gc_frame_newslot(*var_s);
  params[0] = call8830;
  partcv[0] = 1;
  Object opresult8832 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8832 (depth = 5)
  *var_s = opresult8832;
  if (opresult8832 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8792 = done;
  } else {
  }
// compiled if node returning if8792 (depth = 3)
// Begin line 2234
  setline(2234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe8836 = gc_frame_new();
// call case 4: self request
  Object call8837 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8836);
// compiled member node returning call8837 (depth = 5)
  int op_slot_right_8835 = gc_frame_newslot(call8837);
// starting to compile identifier node (depth = 5)
  Object bool8839 = alloc_Boolean(0);
// compiled identifier node returning bool8839 (depth = 5)
  int op_slot_left_8835 = gc_frame_newslot(bool8839);
  params[0] = call8837;
  partcv[0] = 1;
  Object opresult8840 = callmethod(bool8839, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8840 (depth = 4)
  Object if8834 = done;
  if (istrue(opresult8840)) {
// Begin line 2235
  setline(2235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8842 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe8843 = gc_frame_new();
// call case 4: self request
  Object call8844 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8843);
// compiled member node returning call8844 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8845 = callmethodflags(call8844, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8842);
// compiled call node returning call8845 (depth = 6)
  int op_slot_right_8841 = gc_frame_newslot(call8845);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8848 == NULL) {
    strlit8848 = alloc_String(" := ");
    gc_root(strlit8848);
  }
// compiled string node returning strlit8848 (depth = 7)
  int op_slot_right_8847 = gc_frame_newslot(strlit8848);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8847 = gc_frame_newslot(*var_s);
  params[0] = strlit8848;
  partcv[0] = 1;
  Object opresult8850 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult8850 (depth = 6)
  int op_slot_left_8841 = gc_frame_newslot(opresult8850);
  params[0] = call8845;
  partcv[0] = 1;
  Object opresult8851 = callmethod(opresult8850, "++(1)", 1, partcv, params);
// compiled op node returning opresult8851 (depth = 5)
  *var_s = opresult8851;
  if (opresult8851 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8834 = done;
  } else {
  }
// compiled if node returning if8834 (depth = 3)
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy8853(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_varDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2240
  setline(2240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8854 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe8855 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8856 = gc_frame_new();
// call case 4: self request
  Object call8857 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8856);
// compiled member node returning call8857 (depth = 5)
  gc_frame_newslot(call8857);
// starting to compile member node (depth = 5)
  int callframe8858 = gc_frame_new();
// call case 4: self request
  Object call8859 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8858);
// compiled member node returning call8859 (depth = 5)
  gc_frame_newslot(call8859);
// starting to compile member node (depth = 5)
  int callframe8860 = gc_frame_new();
// call case 4: self request
  Object call8861 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8860);
// compiled member node returning call8861 (depth = 5)
  gc_frame_newslot(call8861);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_varDecNode (depth = 5)
  params[0] = call8857;
  params[1] = call8859;
  params[2] = call8861;
  partcv[0] = 3;
  Object call8862 = callmethodflags(*var_varDecNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe8855);
// compiled call node returning call8862 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call8863 = callmethodflags(call8862, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8854);
// compiled call node returning call8863 (depth = 3)
  gc_frame_end(frame);
  return call8863;
}
Object meth_ast_statementName8864(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8865 == NULL) {
    strlit8865 = alloc_String("variable declaration");
    gc_root(strlit8865);
  }
// compiled string node returning strlit8865 (depth = 3)
  gc_frame_end(frame);
  return strlit8865;
}
Object meth_ast_new_40_3_41_8424(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_varDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8425 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8425 = alloc_userobj2(22,19, objclass8425);
  gc_frame_newslot(obj8425);
if (objclass8425 == NULL) {
  glfree(obj8425->class->name);
  obj8425->class->name = "varDecNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8425, self, 0);
  addmethodreal(obj8425,"outer", &reader_ast_outer_8426);
  Object oldself8425 = self;
  struct StackFrameObject *oldstackframe8425 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8425);
  gc_frame_newslot((Object)stackframe);
  self = obj8425;
  Object *oldselfslot8425 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8425 = (*(struct UserObject *)self).data[0], lowerouter8425 = thisouter8425;
  if (inheritingObject8425) {
    struct UserObject *inho8425 = (struct UserObject *)inheritingObject8425;
    while (inho8425->super != GraceDefaultObject) inho8425 = (struct UserObject *)inho8425->super;
    inho8425->super = obj8425;
    self = inheritingObject8425;
    *selfslot = self;
    lowerouter8425 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8425;
  }
if (objclass8425 == NULL) {
  Method *reader8427 = addmethodrealflags(obj8425, "kind",&reader_ast_kind_8427, MFLAG_DEF);
  reader8427->definitionModule = modulename;
  reader8427->definitionLine = 2141;
}
adddatum2(obj8425, alloc_Undefined(), 1);
if (objclass8425 == NULL) {
  Method *reader8428 = addmethodrealflags(obj8425, "name", &reader_ast_name_8428, 0);
  Method *writer8428 = addmethodrealflags(obj8425, "name:=(1)", &writer_ast_name_8428, 0);
  reader8428->definitionModule = modulename;
  writer8428->definitionModule = modulename;
  reader8428->definitionLine = 2142;
  writer8428->definitionLine = 2142;
}
obj8425->flags |= OFLAG_MUTABLE;
adddatum2(obj8425, alloc_Undefined(), 2);
if (objclass8425 == NULL) {
  Method *reader8429 = addmethodrealflags(obj8425, "value", &reader_ast_value_8429, 0);
  Method *writer8429 = addmethodrealflags(obj8425, "value:=(1)", &writer_ast_value_8429, 0);
  reader8429->definitionModule = modulename;
  writer8429->definitionModule = modulename;
  reader8429->definitionLine = 2143;
  writer8429->definitionLine = 2143;
}
obj8425->flags |= OFLAG_MUTABLE;
adddatum2(obj8425, alloc_Undefined(), 3);
if (objclass8425 == NULL) {
  Method *reader8430 = addmethodrealflags(obj8425, "dtype", &reader_ast_dtype_8430, 0);
  Method *writer8430 = addmethodrealflags(obj8425, "dtype:=(1)", &writer_ast_dtype_8430, 0);
  reader8430->definitionModule = modulename;
  writer8430->definitionModule = modulename;
  reader8430->definitionLine = 2144;
  writer8430->definitionLine = 2144;
}
obj8425->flags |= OFLAG_MUTABLE;
adddatum2(obj8425, alloc_Undefined(), 4);
if (objclass8425 == NULL) {
  Method *reader8431 = addmethodrealflags(obj8425, "nameString",&reader_ast_nameString_8431, MFLAG_DEF);
  reader8431->definitionModule = modulename;
  reader8431->definitionLine = 2145;
}
adddatum2(obj8425, alloc_Undefined(), 5);
if (objclass8425 == NULL) {
  Method *reader8432 = addmethodrealflags(obj8425, "annotations", &reader_ast_annotations_8432, 0);
  Method *writer8432 = addmethodrealflags(obj8425, "annotations:=(1)", &writer_ast_annotations_8432, 0);
  reader8432->definitionModule = modulename;
  writer8432->definitionModule = modulename;
  reader8432->definitionLine = 2146;
  writer8432->definitionLine = 2146;
}
obj8425->flags |= OFLAG_MUTABLE;
adddatum2(obj8425, alloc_Undefined(), 6);
// method "isPublic"
  struct UserObject *uo8433 = (struct UserObject*)obj8425;
  uo8433->data[7] = emptyclosure;
  Method *meth_meth_ast_isPublic8433 = addmethod2pos(obj8425, "isPublic", &meth_ast_isPublic8433, 7);
  int argcv_meth_ast_isPublic8433[] = {0};
  meth_meth_ast_isPublic8433->type = alloc_MethodType(1, argcv_meth_ast_isPublic8433);
  meth_meth_ast_isPublic8433->definitionModule = modulename;
  meth_meth_ast_isPublic8433->definitionLine = 2148;
// method "isWritable"
  struct UserObject *uo8460 = (struct UserObject*)obj8425;
  uo8460->data[8] = emptyclosure;
  Method *meth_meth_ast_isWritable8460 = addmethod2pos(obj8425, "isWritable", &meth_ast_isWritable8460, 8);
  int argcv_meth_ast_isWritable8460[] = {0};
  meth_meth_ast_isWritable8460->type = alloc_MethodType(1, argcv_meth_ast_isWritable8460);
  meth_meth_ast_isWritable8460->definitionModule = modulename;
  meth_meth_ast_isWritable8460->definitionLine = 2154;
// method "isReadable"
  struct UserObject *uo8490 = (struct UserObject*)obj8425;
  uo8490->data[9] = emptyclosure;
  Method *meth_meth_ast_isReadable8490 = addmethod2pos(obj8425, "isReadable", &meth_ast_isReadable8490, 9);
  int argcv_meth_ast_isReadable8490[] = {0};
  meth_meth_ast_isReadable8490->type = alloc_MethodType(1, argcv_meth_ast_isReadable8490);
  meth_meth_ast_isReadable8490->definitionModule = modulename;
  meth_meth_ast_isReadable8490->definitionLine = 2160;
// method "isFieldDec"
  struct UserObject *uo8520 = (struct UserObject*)obj8425;
  uo8520->data[10] = emptyclosure;
  Method *meth_meth_ast_isFieldDec8520 = addmethod2pos(obj8425, "isFieldDec", &meth_ast_isFieldDec8520, 10);
  int argcv_meth_ast_isFieldDec8520[] = {0};
  meth_meth_ast_isFieldDec8520->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec8520);
  meth_meth_ast_isFieldDec8520->definitionModule = modulename;
  meth_meth_ast_isFieldDec8520->definitionLine = 2166;
// method "usesAsType(_)"
  struct UserObject *uo8522 = (struct UserObject*)obj8425;
  uo8522->data[11] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_8522 = addmethod2pos(obj8425, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_8522, 11);
  int argcv_meth_ast_usesAsType_40_1_41_8522[] = {1};
  meth_meth_ast_usesAsType_40_1_41_8522->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_8522);
  meth_meth_ast_usesAsType_40_1_41_8522->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_8522->definitionLine = 2168;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj8425);
  Object closure8528 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure8528, stackframe);
  addtoclosure(closure8528, var_k);
  struct UserObject *uo8528 = (struct UserObject*)obj8425;
  uo8528->data[12] = (Object)closure8528;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_8528 = addmethod2pos(obj8425, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_8528, 12);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_8528[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8528->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_8528);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8528->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8528->definitionLine = 2172;
// method "accept(_)from(_)"
  struct UserObject *uo8531 = (struct UserObject*)obj8425;
  uo8531->data[13] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_8531 = addmethod2pos(obj8425, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_8531, 13);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_8531[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_8531->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_8531);
  meth_meth_ast_accept_40_1_41_from_40_1_41_8531->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_8531->definitionLine = 2174;
// method "map(_)ancestors(_)"
  struct UserObject *uo8572 = (struct UserObject*)obj8425;
  uo8572->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_8572 = addmethod2pos(obj8425, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_8572, 14);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8572[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8572->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8572);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8572->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8572->definitionLine = 2189;
// method "pretty(_)"
  struct UserObject *uo8615 = (struct UserObject*)obj8425;
  uo8615->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_8615 = addmethod2pos(obj8425, "pretty(1)", &meth_ast_pretty_40_1_41_8615, 15);
  int argcv_meth_ast_pretty_40_1_41_8615[] = {1};
  meth_meth_ast_pretty_40_1_41_8615->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_8615);
  meth_meth_ast_pretty_40_1_41_8615->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_8615->definitionLine = 2198;
// method "toGrace(_)"
  struct UserObject *uo8733 = (struct UserObject*)obj8425;
  uo8733->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_8733 = addmethod2pos(obj8425, "toGrace(1)", &meth_ast_toGrace_40_1_41_8733, 16);
  int argcv_meth_ast_toGrace_40_1_41_8733[] = {1};
  meth_meth_ast_toGrace_40_1_41_8733->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_8733);
meth_meth_ast_toGrace_40_1_41_8733->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_8733->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_8733->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_8733->definitionLine = 2218;
// method "shallowCopy"
  block_savedest(obj8425);
  Object closure8853 = createclosure(1, "shallowCopy");
  setclosureframe(closure8853, stackframe);
  addtoclosure(closure8853, var_varDecNode);
  struct UserObject *uo8853 = (struct UserObject*)obj8425;
  uo8853->data[17] = (Object)closure8853;
  Method *meth_meth_ast_shallowCopy8853 = addmethod2pos(obj8425, "shallowCopy", &meth_ast_shallowCopy8853, 17);
  int argcv_meth_ast_shallowCopy8853[] = {0};
  meth_meth_ast_shallowCopy8853->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8853);
  meth_meth_ast_shallowCopy8853->definitionModule = modulename;
  meth_meth_ast_shallowCopy8853->definitionLine = 2239;
// method "statementName"
  struct UserObject *uo8864 = (struct UserObject*)obj8425;
  uo8864->data[18] = emptyclosure;
  Method *meth_meth_ast_statementName8864 = addmethod2pos(obj8425, "statementName", &meth_ast_statementName8864, 18);
  int argcv_meth_ast_statementName8864[] = {0};
  meth_meth_ast_statementName8864->type = alloc_MethodType(1, argcv_meth_ast_statementName8864);
  meth_meth_ast_statementName8864->definitionModule = modulename;
  meth_meth_ast_statementName8864->definitionLine = 2242;
  sourceObject = obj8425;
// Begin line 2140
  setline(2140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8866 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8867 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8868 = gc_frame_new();
// call case 3: self.outer request
  Object call8869 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8868);
// compiled member node returning call8869 (depth = 5)
  Object call8870 = callmethodflags(call8869, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8867);
// compiled member node returning call8870 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8871 = callmethodflags(call8870, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8866);
// compiled call node returning call8871 (depth = 3)
  struct UserObject *obj8425_uo = (struct UserObject *)obj8425;
  obj8425_uo->super = call8871;
  sourceObject = obj8425;
// Begin line 2141
  setline(2141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8872 == NULL) {
    strlit8872 = alloc_String("vardec");
    gc_root(strlit8872);
  }
// compiled string node returning strlit8872 (depth = 3)
  adddatum2(obj8425, strlit8872, 1);
  sourceObject = obj8425;
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8425, *var_name_39_, 2);
  sourceObject = obj8425;
// Begin line 2143
  setline(2143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj8425, *var_val_39_, 3);
  sourceObject = obj8425;
// Begin line 2144
  setline(2144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8425, *var_dtype_39_, 4);
  sourceObject = obj8425;
// Begin line 2145
  setline(2145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8873 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8874 = gc_frame_new();
// call case 4: self request
  Object call8875 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8874);
// compiled member node returning call8875 (depth = 4)
  Object call8876 = callmethodflags(call8875, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8873);
// compiled member node returning call8876 (depth = 3)
  adddatum2(obj8425, call8876, 5);
  sourceObject = obj8425;
// Begin line 2146
  setline(2146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array8877 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8877 (depth = 3)
  adddatum2(obj8425, array8877, 6);
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  objclass8425 = obj8425->class;
  objclass8425->definitionModule = modulename;
  objclass8425->definitionLine = 2139;
  (*(struct UserObject *)self).data[0] = lowerouter8425;
  self = oldself8425;
  selfslot = oldselfslot8425;
  stackframe = oldstackframe8425;
  gc_frame_end(frame);
  return obj8425;
}
Object meth_ast_new_40_3_41_8424_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_varDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8425 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8425 = alloc_userobj2(22,19, objclass8425);
  gc_frame_newslot(obj8425);
if (objclass8425 == NULL) {
  glfree(obj8425->class->name);
  obj8425->class->name = "varDecNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8425, self, 0);
  addmethodreal(obj8425,"outer", &reader_ast_outer_8426);
  Object oldself8425 = self;
  struct StackFrameObject *oldstackframe8425 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8425);
  gc_frame_newslot((Object)stackframe);
  self = obj8425;
  Object *oldselfslot8425 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8425 = (*(struct UserObject *)self).data[0], lowerouter8425 = thisouter8425;
  if (inheritingObject8425) {
    struct UserObject *inho8425 = (struct UserObject *)inheritingObject8425;
    while (inho8425->super != GraceDefaultObject) inho8425 = (struct UserObject *)inho8425->super;
    inho8425->super = obj8425;
    self = inheritingObject8425;
    *selfslot = self;
    lowerouter8425 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8425;
  }
if (objclass8425 == NULL) {
  Method *reader8427 = addmethodrealflags(obj8425, "kind",&reader_ast_kind_8427, MFLAG_DEF);
  reader8427->definitionModule = modulename;
  reader8427->definitionLine = 2141;
}
adddatum2(obj8425, alloc_Undefined(), 1);
if (objclass8425 == NULL) {
  Method *reader8428 = addmethodrealflags(obj8425, "name", &reader_ast_name_8428, 0);
  Method *writer8428 = addmethodrealflags(obj8425, "name:=(1)", &writer_ast_name_8428, 0);
  reader8428->definitionModule = modulename;
  writer8428->definitionModule = modulename;
  reader8428->definitionLine = 2142;
  writer8428->definitionLine = 2142;
}
obj8425->flags |= OFLAG_MUTABLE;
adddatum2(obj8425, alloc_Undefined(), 2);
if (objclass8425 == NULL) {
  Method *reader8429 = addmethodrealflags(obj8425, "value", &reader_ast_value_8429, 0);
  Method *writer8429 = addmethodrealflags(obj8425, "value:=(1)", &writer_ast_value_8429, 0);
  reader8429->definitionModule = modulename;
  writer8429->definitionModule = modulename;
  reader8429->definitionLine = 2143;
  writer8429->definitionLine = 2143;
}
obj8425->flags |= OFLAG_MUTABLE;
adddatum2(obj8425, alloc_Undefined(), 3);
if (objclass8425 == NULL) {
  Method *reader8430 = addmethodrealflags(obj8425, "dtype", &reader_ast_dtype_8430, 0);
  Method *writer8430 = addmethodrealflags(obj8425, "dtype:=(1)", &writer_ast_dtype_8430, 0);
  reader8430->definitionModule = modulename;
  writer8430->definitionModule = modulename;
  reader8430->definitionLine = 2144;
  writer8430->definitionLine = 2144;
}
obj8425->flags |= OFLAG_MUTABLE;
adddatum2(obj8425, alloc_Undefined(), 4);
if (objclass8425 == NULL) {
  Method *reader8431 = addmethodrealflags(obj8425, "nameString",&reader_ast_nameString_8431, MFLAG_DEF);
  reader8431->definitionModule = modulename;
  reader8431->definitionLine = 2145;
}
adddatum2(obj8425, alloc_Undefined(), 5);
if (objclass8425 == NULL) {
  Method *reader8432 = addmethodrealflags(obj8425, "annotations", &reader_ast_annotations_8432, 0);
  Method *writer8432 = addmethodrealflags(obj8425, "annotations:=(1)", &writer_ast_annotations_8432, 0);
  reader8432->definitionModule = modulename;
  writer8432->definitionModule = modulename;
  reader8432->definitionLine = 2146;
  writer8432->definitionLine = 2146;
}
obj8425->flags |= OFLAG_MUTABLE;
adddatum2(obj8425, alloc_Undefined(), 6);
// method "isPublic"
  struct UserObject *uo8433 = (struct UserObject*)obj8425;
  uo8433->data[7] = emptyclosure;
  Method *meth_meth_ast_isPublic8433 = addmethod2pos(obj8425, "isPublic", &meth_ast_isPublic8433, 7);
  int argcv_meth_ast_isPublic8433[] = {0};
  meth_meth_ast_isPublic8433->type = alloc_MethodType(1, argcv_meth_ast_isPublic8433);
  meth_meth_ast_isPublic8433->definitionModule = modulename;
  meth_meth_ast_isPublic8433->definitionLine = 2148;
// method "isWritable"
  struct UserObject *uo8460 = (struct UserObject*)obj8425;
  uo8460->data[8] = emptyclosure;
  Method *meth_meth_ast_isWritable8460 = addmethod2pos(obj8425, "isWritable", &meth_ast_isWritable8460, 8);
  int argcv_meth_ast_isWritable8460[] = {0};
  meth_meth_ast_isWritable8460->type = alloc_MethodType(1, argcv_meth_ast_isWritable8460);
  meth_meth_ast_isWritable8460->definitionModule = modulename;
  meth_meth_ast_isWritable8460->definitionLine = 2154;
// method "isReadable"
  struct UserObject *uo8490 = (struct UserObject*)obj8425;
  uo8490->data[9] = emptyclosure;
  Method *meth_meth_ast_isReadable8490 = addmethod2pos(obj8425, "isReadable", &meth_ast_isReadable8490, 9);
  int argcv_meth_ast_isReadable8490[] = {0};
  meth_meth_ast_isReadable8490->type = alloc_MethodType(1, argcv_meth_ast_isReadable8490);
  meth_meth_ast_isReadable8490->definitionModule = modulename;
  meth_meth_ast_isReadable8490->definitionLine = 2160;
// method "isFieldDec"
  struct UserObject *uo8520 = (struct UserObject*)obj8425;
  uo8520->data[10] = emptyclosure;
  Method *meth_meth_ast_isFieldDec8520 = addmethod2pos(obj8425, "isFieldDec", &meth_ast_isFieldDec8520, 10);
  int argcv_meth_ast_isFieldDec8520[] = {0};
  meth_meth_ast_isFieldDec8520->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec8520);
  meth_meth_ast_isFieldDec8520->definitionModule = modulename;
  meth_meth_ast_isFieldDec8520->definitionLine = 2166;
// method "usesAsType(_)"
  struct UserObject *uo8522 = (struct UserObject*)obj8425;
  uo8522->data[11] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_8522 = addmethod2pos(obj8425, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_8522, 11);
  int argcv_meth_ast_usesAsType_40_1_41_8522[] = {1};
  meth_meth_ast_usesAsType_40_1_41_8522->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_8522);
  meth_meth_ast_usesAsType_40_1_41_8522->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_8522->definitionLine = 2168;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj8425);
  Object closure8528 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure8528, stackframe);
  addtoclosure(closure8528, var_k);
  struct UserObject *uo8528 = (struct UserObject*)obj8425;
  uo8528->data[12] = (Object)closure8528;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_8528 = addmethod2pos(obj8425, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_8528, 12);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_8528[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8528->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_8528);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8528->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8528->definitionLine = 2172;
// method "accept(_)from(_)"
  struct UserObject *uo8531 = (struct UserObject*)obj8425;
  uo8531->data[13] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_8531 = addmethod2pos(obj8425, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_8531, 13);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_8531[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_8531->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_8531);
  meth_meth_ast_accept_40_1_41_from_40_1_41_8531->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_8531->definitionLine = 2174;
// method "map(_)ancestors(_)"
  struct UserObject *uo8572 = (struct UserObject*)obj8425;
  uo8572->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_8572 = addmethod2pos(obj8425, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_8572, 14);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8572[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8572->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8572);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8572->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8572->definitionLine = 2189;
// method "pretty(_)"
  struct UserObject *uo8615 = (struct UserObject*)obj8425;
  uo8615->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_8615 = addmethod2pos(obj8425, "pretty(1)", &meth_ast_pretty_40_1_41_8615, 15);
  int argcv_meth_ast_pretty_40_1_41_8615[] = {1};
  meth_meth_ast_pretty_40_1_41_8615->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_8615);
  meth_meth_ast_pretty_40_1_41_8615->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_8615->definitionLine = 2198;
// method "toGrace(_)"
  struct UserObject *uo8733 = (struct UserObject*)obj8425;
  uo8733->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_8733 = addmethod2pos(obj8425, "toGrace(1)", &meth_ast_toGrace_40_1_41_8733, 16);
  int argcv_meth_ast_toGrace_40_1_41_8733[] = {1};
  meth_meth_ast_toGrace_40_1_41_8733->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_8733);
meth_meth_ast_toGrace_40_1_41_8733->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_8733->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_8733->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_8733->definitionLine = 2218;
// method "shallowCopy"
  block_savedest(obj8425);
  Object closure8853 = createclosure(1, "shallowCopy");
  setclosureframe(closure8853, stackframe);
  addtoclosure(closure8853, var_varDecNode);
  struct UserObject *uo8853 = (struct UserObject*)obj8425;
  uo8853->data[17] = (Object)closure8853;
  Method *meth_meth_ast_shallowCopy8853 = addmethod2pos(obj8425, "shallowCopy", &meth_ast_shallowCopy8853, 17);
  int argcv_meth_ast_shallowCopy8853[] = {0};
  meth_meth_ast_shallowCopy8853->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8853);
  meth_meth_ast_shallowCopy8853->definitionModule = modulename;
  meth_meth_ast_shallowCopy8853->definitionLine = 2239;
// method "statementName"
  struct UserObject *uo8864 = (struct UserObject*)obj8425;
  uo8864->data[18] = emptyclosure;
  Method *meth_meth_ast_statementName8864 = addmethod2pos(obj8425, "statementName", &meth_ast_statementName8864, 18);
  int argcv_meth_ast_statementName8864[] = {0};
  meth_meth_ast_statementName8864->type = alloc_MethodType(1, argcv_meth_ast_statementName8864);
  meth_meth_ast_statementName8864->definitionModule = modulename;
  meth_meth_ast_statementName8864->definitionLine = 2242;
  sourceObject = obj8425;
// Begin line 2140
  setline(2140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8866 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8867 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8868 = gc_frame_new();
// call case 3: self.outer request
  Object call8869 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8868);
// compiled member node returning call8869 (depth = 5)
  Object call8870 = callmethodflags(call8869, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8867);
// compiled member node returning call8870 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8871 = callmethodflags(call8870, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8866);
// compiled call node returning call8871 (depth = 3)
  struct UserObject *obj8425_uo = (struct UserObject *)obj8425;
  obj8425_uo->super = call8871;
  sourceObject = obj8425;
// Begin line 2141
  setline(2141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8872 == NULL) {
    strlit8872 = alloc_String("vardec");
    gc_root(strlit8872);
  }
// compiled string node returning strlit8872 (depth = 3)
  adddatum2(obj8425, strlit8872, 1);
  sourceObject = obj8425;
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8425, *var_name_39_, 2);
  sourceObject = obj8425;
// Begin line 2143
  setline(2143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj8425, *var_val_39_, 3);
  sourceObject = obj8425;
// Begin line 2144
  setline(2144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8425, *var_dtype_39_, 4);
  sourceObject = obj8425;
// Begin line 2145
  setline(2145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8873 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8874 = gc_frame_new();
// call case 4: self request
  Object call8875 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8874);
// compiled member node returning call8875 (depth = 4)
  Object call8876 = callmethodflags(call8875, "value", 0, partcv, params, 0);
  gc_frame_end(callframe8873);
// compiled member node returning call8876 (depth = 3)
  adddatum2(obj8425, call8876, 5);
  sourceObject = obj8425;
// Begin line 2146
  setline(2146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array8877 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8877 (depth = 3)
  adddatum2(obj8425, array8877, 6);
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  sourceObject = obj8425;
  objclass8425 = obj8425->class;
  objclass8425->definitionModule = modulename;
  objclass8425->definitionLine = 2139;
  (*(struct UserObject *)self).data[0] = lowerouter8425;
  self = oldself8425;
  selfslot = oldselfslot8425;
  stackframe = oldstackframe8425;
  gc_frame_end(frame);
  return obj8425;
}
Object meth_ast_varDecNode8879(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "varDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_varDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2138
  setline(2138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_varDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_varDecNode;
}
Object meth_ast_isImport8890(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2254
  setline(2254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8891 = alloc_Boolean(1);
// compiled identifier node returning bool8891 (depth = 3)
  gc_frame_end(frame);
  return bool8891;
}
Object meth_ast_isExternal8892(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExternal");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2255
  setline(2255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8893 = alloc_Boolean(1);
// compiled identifier node returning bool8893 (depth = 3)
  gc_frame_end(frame);
  return bool8893;
}
Object meth_ast_isExecutable8894(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2256
  setline(2256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8895 = alloc_Boolean(0);
// compiled identifier node returning bool8895 (depth = 3)
  gc_frame_end(frame);
  return bool8895;
}
Object meth_ast_name8896(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2257
  setline(2257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8897 = gc_frame_new();
// call case 4: self request
  Object call8898 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8897);
// compiled member node returning call8898 (depth = 3)
  gc_frame_end(frame);
  return call8898;
}
Object meth_ast_nameString8899(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2258
  setline(2258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8900 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8901 = gc_frame_new();
// call case 4: self request
  Object call8902 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8901);
// compiled member node returning call8902 (depth = 4)
  Object call8903 = callmethodflags(call8902, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe8900);
// compiled member node returning call8903 (depth = 3)
  gc_frame_end(frame);
  return call8903;
}
Object meth_ast_isPublic8904(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2261
  setline(2261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8907 = alloc_Float64(0);
// compiled num node returning num8907 (depth = 5)
  int op_slot_right_8906 = gc_frame_newslot(num8907);
// starting to compile member node (depth = 5)
  int callframe8909 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8910 = gc_frame_new();
// call case 4: self request
  Object call8911 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8910);
// compiled member node returning call8911 (depth = 6)
  Object call8912 = callmethodflags(call8911, "size", 0, partcv, params, 0);
  gc_frame_end(callframe8909);
// compiled member node returning call8912 (depth = 5)
  int op_slot_left_8906 = gc_frame_newslot(call8912);
  params[0] = num8907;
  partcv[0] = 1;
  Object opresult8913 = callmethod(call8912, "==(1)", 1, partcv, params);
// compiled op node returning opresult8913 (depth = 4)
  Object if8905 = done;
  if (istrue(opresult8913)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8914 = alloc_Boolean(0);
// compiled identifier node returning bool8914 (depth = 5)
  return bool8914;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8905 = undefined;
  } else {
  }
// compiled if node returning if8905 (depth = 3)
// Begin line 2262
  setline(2262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8916 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8917 == NULL) {
    strlit8917 = alloc_String("public");
    gc_root(strlit8917);
  }
// compiled string node returning strlit8917 (depth = 5)
  gc_frame_newslot(strlit8917);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8918 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8919 = gc_frame_new();
// call case 3: self.outer request
  Object call8920 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8919);
// compiled member node returning call8920 (depth = 6)
  Object call8921 = callmethodflags(call8920, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8918);
// compiled member node returning call8921 (depth = 5)
  params[0] = self;
  params[1] = strlit8917;
  partcv[0] = 2;
  Object call8922 = callmethodflags(call8921, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8916);
// compiled call node returning call8922 (depth = 4)
  Object if8915 = done;
  if (istrue(call8922)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8923 = alloc_Boolean(1);
// compiled identifier node returning bool8923 (depth = 5)
  return bool8923;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8915 = undefined;
  } else {
  }
// compiled if node returning if8915 (depth = 3)
// Begin line 2263
  setline(2263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8924 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit8925 == NULL) {
    strlit8925 = alloc_String("readable");
    gc_root(strlit8925);
  }
// compiled string node returning strlit8925 (depth = 4)
  gc_frame_newslot(strlit8925);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe8926 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8927 = gc_frame_new();
// call case 3: self.outer request
  Object call8928 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8927);
// compiled member node returning call8928 (depth = 5)
  Object call8929 = callmethodflags(call8928, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe8926);
// compiled member node returning call8929 (depth = 4)
  params[0] = self;
  params[1] = strlit8925;
  partcv[0] = 2;
  Object call8930 = callmethodflags(call8929, "findAnnotation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8924);
// compiled call node returning call8930 (depth = 3)
  gc_frame_end(frame);
  return call8930;
}
Object meth_ast__apply_40_1_41_8937(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_bnm = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2268
  setline(2268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8940 == NULL) {
    strlit8940 = alloc_String("/");
    gc_root(strlit8940);
  }
// compiled string node returning strlit8940 (depth = 7)
  int op_slot_right_8939 = gc_frame_newslot(strlit8940);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_8939 = gc_frame_newslot(*var_c);
  params[0] = strlit8940;
  partcv[0] = 1;
  Object opresult8942 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult8942 (depth = 6)
  Object if8938 = done;
  if (istrue(opresult8942)) {
// Begin line 2269
  setline(2269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8943 == NULL) {
    strlit8943 = alloc_String("");
    gc_root(strlit8943);
  }
// compiled string node returning strlit8943 (depth = 7)
  *var_bnm = strlit8943;
  if (strlit8943 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if8938 = done;
  } else {
// Begin line 2271
  setline(2271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_right_8945 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_bnm (depth = 8)
  int op_slot_left_8945 = gc_frame_newslot(*var_bnm);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult8947 = callmethod(*var_bnm, "++(1)", 1, partcv, params);
// compiled op node returning opresult8947 (depth = 7)
  *var_bnm = opresult8947;
  if (opresult8947 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if8938 = done;
  }
// compiled if node returning if8938 (depth = 5)
  gc_frame_end(frame);
  return if8938;
}
Object meth_ast_moduleName8931(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "moduleName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_bnm = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "bnm");
// Begin line 2266
  setline(2266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8932 == NULL) {
    strlit8932 = alloc_String("");
    gc_root(strlit8932);
  }
// compiled string node returning strlit8932 (depth = 4)
  *var_bnm = strlit8932;
  if (strlit8932 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2267
  setline(2267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8933 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe8934 = gc_frame_new();
// call case 4: self request
  Object call8935 = callmethodflags(self, "path", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8934);
// compiled member node returning call8935 (depth = 4)
  gc_frame_newslot(call8935);
// starting to compile block node (depth = 4)
  Object block8936 = alloc_Block(NULL, NULL, "ast", 2267);
  gc_frame_newslot(block8936);
// method "_apply(_)"
  block_savedest(block8936);
  Object closure8937 = createclosure(2, "_apply(1)");
  setclosureframe(closure8937, stackframe);
  addtoclosure(closure8937, var_bnm);
  addtoclosure(closure8937, selfslot);
  struct UserObject *uo8937 = (struct UserObject*)block8936;
  uo8937->data[0] = (Object)closure8937;
  Method *meth_meth_ast__apply_40_1_41_8937 = addmethod2pos(block8936, "_apply(1)", &meth_ast__apply_40_1_41_8937, 0);
  int argcv_meth_ast__apply_40_1_41_8937[] = {1};
  meth_meth_ast__apply_40_1_41_8937->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_8937);
  meth_meth_ast__apply_40_1_41_8937->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_8937->definitionLine = 2981;
// compiled block node returning block8936 (depth = 4)
  gc_frame_newslot(block8936);
// call case 5: prelude request
  params[0] = call8935;
  params[1] = block8936;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8950 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8933);
// compiled call node returning call8950 (depth = 3)
// Begin line 2274
  setline(2274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_bnm (depth = 3)
  gc_frame_end(frame);
  return *var_bnm;
}
Object meth_ast_isWritable8951(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2276
  setline(2276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8952 = alloc_Boolean(0);
// compiled identifier node returning bool8952 (depth = 3)
  gc_frame_end(frame);
  return bool8952;
}
Object meth_ast_isReadable8953(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2277
  setline(2277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8954 = gc_frame_new();
// call case 4: self request
  Object call8955 = callmethodflags(self, "isPublic", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8954);
// compiled member node returning call8955 (depth = 3)
  gc_frame_end(frame);
  return call8955;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_8956(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2278
  setline(2278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe8957 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call8958 = callmethodflags(*var_k, "defdec", 0, partcv, params, 0);
  gc_frame_end(callframe8957);
// compiled member node returning call8958 (depth = 3)
  gc_frame_end(frame);
  return call8958;
}
Object meth_ast_usesAsType_40_1_41_8959(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part usesAsType(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2280
  setline(2280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8961 = gc_frame_new();
// call case 4: self request
  Object call8962 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8961);
// compiled member node returning call8962 (depth = 4)
  int op_slot_right_8960 = gc_frame_newslot(call8962);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_8960 = gc_frame_newslot(*var_aNode);
  params[0] = call8962;
  partcv[0] = 1;
  Object opresult8964 = callmethod(*var_aNode, "==(1)", 1, partcv, params);
// compiled op node returning opresult8964 (depth = 3)
  gc_frame_end(frame);
  return opresult8964;
}
Object meth_ast__apply_40_1_41_8975(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2286
  setline(2286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8976 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8977 = callmethodflags(*var_ann, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8976);
// compiled call node returning call8977 (depth = 6)
  gc_frame_end(frame);
  return call8977;
}
Object meth_ast_accept_40_1_41_from_40_1_41_8965(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2283
  setline(2283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8967 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8968 = callmethodflags(*var_visitor, "visitImport(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8967);
// compiled call node returning call8968 (depth = 4)
  Object if8966 = done;
  if (istrue(call8968)) {
// Begin line 2284
  setline(2284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8969 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call8970 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8969);
// compiled call node returning call8970 (depth = 5)
  *var_newChain = call8970;
  if (call8970 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2285
  setline(2285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8971 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe8972 = gc_frame_new();
// call case 4: self request
  Object call8973 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8972);
// compiled member node returning call8973 (depth = 5)
  gc_frame_newslot(call8973);
// starting to compile block node (depth = 5)
  Object block8974 = alloc_Block(NULL, NULL, "ast", 2285);
  gc_frame_newslot(block8974);
// method "_apply(_)"
  block_savedest(block8974);
  Object closure8975 = createclosure(3, "_apply(1)");
  setclosureframe(closure8975, stackframe);
  addtoclosure(closure8975, var_visitor);
  addtoclosure(closure8975, var_newChain);
  addtoclosure(closure8975, selfslot);
  struct UserObject *uo8975 = (struct UserObject*)block8974;
  uo8975->data[0] = (Object)closure8975;
  Method *meth_meth_ast__apply_40_1_41_8975 = addmethod2pos(block8974, "_apply(1)", &meth_ast__apply_40_1_41_8975, 0);
  int argcv_meth_ast__apply_40_1_41_8975[] = {1};
  meth_meth_ast__apply_40_1_41_8975->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_8975);
  meth_meth_ast__apply_40_1_41_8975->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_8975->definitionLine = 2981;
// compiled block node returning block8974 (depth = 5)
  gc_frame_newslot(block8974);
// call case 5: prelude request
  params[0] = call8973;
  params[1] = block8974;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8979 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8971);
// compiled call node returning call8979 (depth = 4)
// Begin line 2288
  setline(2288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8980 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe8981 = gc_frame_new();
// call case 4: self request
  Object call8982 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8981);
// compiled member node returning call8982 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8983 = callmethodflags(call8982, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8980);
// compiled call node returning call8983 (depth = 4)
// Begin line 2289
  setline(2289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe8986 = gc_frame_new();
// call case 4: self request
  Object call8987 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8986);
// compiled member node returning call8987 (depth = 6)
  int op_slot_right_8985 = gc_frame_newslot(call8987);
// starting to compile identifier node (depth = 6)
  Object bool8989 = alloc_Boolean(0);
// compiled identifier node returning bool8989 (depth = 6)
  int op_slot_left_8985 = gc_frame_newslot(bool8989);
  params[0] = call8987;
  partcv[0] = 1;
  Object opresult8990 = callmethod(bool8989, "≠(1)", 1, partcv, params);
// compiled op node returning opresult8990 (depth = 5)
  Object if8984 = done;
  if (istrue(opresult8990)) {
// Begin line 2290
  setline(2290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8991 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe8992 = gc_frame_new();
// call case 4: self request
  Object call8993 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8992);
// compiled member node returning call8993 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8994 = callmethodflags(call8993, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe8991);
// compiled call node returning call8994 (depth = 5)
    gc_frame_newslot(call8994);
    if8984 = call8994;
  } else {
  }
// compiled if node returning if8984 (depth = 4)
    gc_frame_newslot(if8984);
    if8966 = if8984;
  } else {
  }
// compiled if node returning if8966 (depth = 3)
  gc_frame_end(frame);
  return if8966;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_8995(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2295
  setline(2295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe8996 = gc_frame_new();
// call case 4: self request
  Object call8997 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8996);
// compiled member node returning call8997 (depth = 4)
  *var_n = call8997;
  if (call8997 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2296
  setline(2296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8998 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8999 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe8998);
// compiled call node returning call8999 (depth = 4)
  *var_newChain = call8999;
  if (call8999 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2297
  setline(2297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9000 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9001 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9002 = gc_frame_new();
// call case 4: self request
  Object call9003 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9002);
// compiled member node returning call9003 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9004 = callmethodflags(call9003, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9001);
// compiled call node returning call9004 (depth = 4)
  gc_frame_newslot(call9004);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call9004;
  partcv[0] = 1;
  Object call9005 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9000);
// compiled call node returning call9005 (depth = 3)
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9006 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9007 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9008 = gc_frame_new();
// call case 4: self request
  Object call9009 = callmethodflags(self, "dtype", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9008);
// compiled member node returning call9009 (depth = 5)
  gc_frame_newslot(call9009);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9010 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9011 = gc_frame_new();
// call case 3: self.outer request
  Object call9012 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9011);
// compiled member node returning call9012 (depth = 6)
  Object call9013 = callmethodflags(call9012, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9010);
// compiled member node returning call9013 (depth = 5)
  params[0] = call9009;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9014 = callmethodflags(call9013, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9007);
// compiled call node returning call9014 (depth = 4)
  gc_frame_newslot(call9014);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call9014;
  partcv[0] = 1;
  Object call9015 = callmethodflags(*var_n, "dtype:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9006);
// compiled call node returning call9015 (depth = 3)
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9016 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9017 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9018 = gc_frame_new();
// call case 4: self request
  Object call9019 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9018);
// compiled member node returning call9019 (depth = 5)
  gc_frame_newslot(call9019);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9020 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9021 = gc_frame_new();
// call case 3: self.outer request
  Object call9022 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9021);
// compiled member node returning call9022 (depth = 6)
  Object call9023 = callmethodflags(call9022, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9020);
// compiled member node returning call9023 (depth = 5)
  params[0] = call9019;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9024 = callmethodflags(call9023, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9017);
// compiled call node returning call9024 (depth = 4)
  gc_frame_newslot(call9024);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call9024;
  partcv[0] = 1;
  Object call9025 = callmethodflags(*var_n, "annotations:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9016);
// compiled call node returning call9025 (depth = 3)
// Begin line 2300
  setline(2300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9026 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9027 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9026);
// compiled call node returning call9027 (depth = 3)
  gc_frame_end(frame);
  return call9027;
}
Object meth_ast__apply_40_1_41_9036(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2305
  setline(2305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9038 == NULL) {
    strlit9038 = alloc_String("  ");
    gc_root(strlit9038);
  }
// compiled string node returning strlit9038 (depth = 7)
  int op_slot_right_9037 = gc_frame_newslot(strlit9038);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_9037 = gc_frame_newslot(*var_spc);
  params[0] = strlit9038;
  partcv[0] = 1;
  Object opresult9040 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult9040 (depth = 6)
  *var_spc = opresult9040;
  if (opresult9040 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_9028(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2303
  setline(2303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9029 == NULL) {
    strlit9029 = alloc_String("");
    gc_root(strlit9029);
  }
// compiled string node returning strlit9029 (depth = 4)
  *var_spc = strlit9029;
  if (strlit9029 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2304
  setline(2304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9030 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_9031 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num9033 = alloc_Float64(0);
// compiled num node returning num9033 (depth = 5)
  int op_slot_left_9031 = gc_frame_newslot(num9033);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9034 = callmethod(num9033, "..(1)", 1, partcv, params);
// compiled op node returning opresult9034 (depth = 4)
  gc_frame_newslot(opresult9034);
// starting to compile block node (depth = 4)
  Object block9035 = alloc_Block(NULL, NULL, "ast", 2304);
  gc_frame_newslot(block9035);
// method "_apply(_)"
  block_savedest(block9035);
  Object closure9036 = createclosure(2, "_apply(1)");
  setclosureframe(closure9036, stackframe);
  addtoclosure(closure9036, var_spc);
  addtoclosure(closure9036, selfslot);
  struct UserObject *uo9036 = (struct UserObject*)block9035;
  uo9036->data[0] = (Object)closure9036;
  Method *meth_meth_ast__apply_40_1_41_9036 = addmethod2pos(block9035, "_apply(1)", &meth_ast__apply_40_1_41_9036, 0);
  int argcv_meth_ast__apply_40_1_41_9036[] = {1};
  meth_meth_ast__apply_40_1_41_9036->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9036);
  meth_meth_ast__apply_40_1_41_9036->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9036->definitionLine = 2981;
// compiled block node returning block9035 (depth = 4)
  gc_frame_newslot(block9035);
// call case 5: prelude request
  params[0] = opresult9034;
  params[1] = block9035;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9043 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9030);
// compiled call node returning call9043 (depth = 3)
// Begin line 2307
  setline(2307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9045 == NULL) {
    strlit9045 = alloc_String("""\x0a""");
    gc_root(strlit9045);
  }
// compiled string node returning strlit9045 (depth = 5)
  int op_slot_right_9044 = gc_frame_newslot(strlit9045);
// starting to compile call node (depth = 5)
  int callframe9047 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9048 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9047);
// compiled call node returning call9048 (depth = 5)
  int op_slot_left_9044 = gc_frame_newslot(call9048);
  params[0] = strlit9045;
  partcv[0] = 1;
  Object opresult9049 = callmethod(call9048, "++(1)", 1, partcv, params);
// compiled op node returning opresult9049 (depth = 4)
  *var_s = opresult9049;
  if (opresult9049 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2308
  setline(2308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9052 == NULL) {
    strlit9052 = alloc_String("""\x0a""");
    gc_root(strlit9052);
  }
// compiled string node returning strlit9052 (depth = 6)
  int op_slot_right_9051 = gc_frame_newslot(strlit9052);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9055 = gc_frame_new();
// call case 4: self request
  Object call9056 = callmethodflags(self, "path", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9055);
// compiled member node returning call9056 (depth = 7)
  int op_slot_right_9054 = gc_frame_newslot(call9056);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9059 == NULL) {
    strlit9059 = alloc_String("Path: ");
    gc_root(strlit9059);
  }
// compiled string node returning strlit9059 (depth = 8)
  int op_slot_right_9058 = gc_frame_newslot(strlit9059);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_9061 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 9)
  if (strlit9063 == NULL) {
    strlit9063 = alloc_String("");
    gc_root(strlit9063);
  }
// compiled string node returning strlit9063 (depth = 9)
  int op_slot_left_9061 = gc_frame_newslot(strlit9063);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9064 = callmethod(strlit9063, "++(1)", 1, partcv, params);
// compiled op node returning opresult9064 (depth = 8)
  int op_slot_left_9058 = gc_frame_newslot(opresult9064);
  params[0] = strlit9059;
  partcv[0] = 1;
  Object opresult9065 = callmethod(opresult9064, "++(1)", 1, partcv, params);
// compiled op node returning opresult9065 (depth = 7)
  int op_slot_left_9054 = gc_frame_newslot(opresult9065);
  params[0] = call9056;
  partcv[0] = 1;
  Object opresult9066 = callmethod(opresult9065, "++(1)", 1, partcv, params);
// compiled op node returning opresult9066 (depth = 6)
  int op_slot_left_9051 = gc_frame_newslot(opresult9066);
  params[0] = strlit9052;
  partcv[0] = 1;
  Object opresult9067 = callmethod(opresult9066, "++(1)", 1, partcv, params);
// compiled op node returning opresult9067 (depth = 5)
  int op_slot_right_9050 = gc_frame_newslot(opresult9067);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_9050 = gc_frame_newslot(*var_s);
  params[0] = opresult9067;
  partcv[0] = 1;
  Object opresult9069 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9069 (depth = 4)
  *var_s = opresult9069;
  if (opresult9069 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2309
  setline(2309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9073 == NULL) {
    strlit9073 = alloc_String("""\x0a""");
    gc_root(strlit9073);
  }
// compiled string node returning strlit9073 (depth = 6)
  int op_slot_right_9072 = gc_frame_newslot(strlit9073);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9076 = gc_frame_new();
// call case 4: self request
  Object call9077 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9076);
// compiled member node returning call9077 (depth = 7)
  int op_slot_right_9075 = gc_frame_newslot(call9077);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9080 == NULL) {
    strlit9080 = alloc_String("Identifier: ");
    gc_root(strlit9080);
  }
// compiled string node returning strlit9080 (depth = 8)
  int op_slot_right_9079 = gc_frame_newslot(strlit9080);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_9082 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 9)
  if (strlit9084 == NULL) {
    strlit9084 = alloc_String("");
    gc_root(strlit9084);
  }
// compiled string node returning strlit9084 (depth = 9)
  int op_slot_left_9082 = gc_frame_newslot(strlit9084);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9085 = callmethod(strlit9084, "++(1)", 1, partcv, params);
// compiled op node returning opresult9085 (depth = 8)
  int op_slot_left_9079 = gc_frame_newslot(opresult9085);
  params[0] = strlit9080;
  partcv[0] = 1;
  Object opresult9086 = callmethod(opresult9085, "++(1)", 1, partcv, params);
// compiled op node returning opresult9086 (depth = 7)
  int op_slot_left_9075 = gc_frame_newslot(opresult9086);
  params[0] = call9077;
  partcv[0] = 1;
  Object opresult9087 = callmethod(opresult9086, "++(1)", 1, partcv, params);
// compiled op node returning opresult9087 (depth = 6)
  int op_slot_left_9072 = gc_frame_newslot(opresult9087);
  params[0] = strlit9073;
  partcv[0] = 1;
  Object opresult9088 = callmethod(opresult9087, "++(1)", 1, partcv, params);
// compiled op node returning opresult9088 (depth = 5)
  int op_slot_right_9071 = gc_frame_newslot(opresult9088);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_9071 = gc_frame_newslot(*var_s);
  params[0] = opresult9088;
  partcv[0] = 1;
  Object opresult9090 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9090 (depth = 4)
  *var_s = opresult9090;
  if (opresult9090 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2310
  setline(2310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9094 = alloc_Float64(0);
// compiled num node returning num9094 (depth = 5)
  int op_slot_right_9093 = gc_frame_newslot(num9094);
// starting to compile member node (depth = 5)
  int callframe9096 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9097 = gc_frame_new();
// call case 4: self request
  Object call9098 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9097);
// compiled member node returning call9098 (depth = 6)
  Object call9099 = callmethodflags(call9098, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9096);
// compiled member node returning call9099 (depth = 5)
  int op_slot_left_9093 = gc_frame_newslot(call9099);
  params[0] = num9094;
  partcv[0] = 1;
  Object opresult9100 = callmethod(call9099, ">(1)", 1, partcv, params);
// compiled op node returning opresult9100 (depth = 4)
  Object if9092 = done;
  if (istrue(opresult9100)) {
// Begin line 2311
  setline(2311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9103 == NULL) {
    strlit9103 = alloc_String("""\x0a""");
    gc_root(strlit9103);
  }
// compiled string node returning strlit9103 (depth = 7)
  int op_slot_right_9102 = gc_frame_newslot(strlit9103);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9106 = gc_frame_new();
// call case 4: self request
  Object call9107 = callmethodflags(self, "annotations", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9106);
// compiled member node returning call9107 (depth = 8)
  int op_slot_right_9105 = gc_frame_newslot(call9107);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9110 == NULL) {
    strlit9110 = alloc_String("Anotations: ");
    gc_root(strlit9110);
  }
// compiled string node returning strlit9110 (depth = 9)
  int op_slot_right_9109 = gc_frame_newslot(strlit9110);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_9112 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 10)
  if (strlit9114 == NULL) {
    strlit9114 = alloc_String("");
    gc_root(strlit9114);
  }
// compiled string node returning strlit9114 (depth = 10)
  int op_slot_left_9112 = gc_frame_newslot(strlit9114);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9115 = callmethod(strlit9114, "++(1)", 1, partcv, params);
// compiled op node returning opresult9115 (depth = 9)
  int op_slot_left_9109 = gc_frame_newslot(opresult9115);
  params[0] = strlit9110;
  partcv[0] = 1;
  Object opresult9116 = callmethod(opresult9115, "++(1)", 1, partcv, params);
// compiled op node returning opresult9116 (depth = 8)
  int op_slot_left_9105 = gc_frame_newslot(opresult9116);
  params[0] = call9107;
  partcv[0] = 1;
  Object opresult9117 = callmethod(opresult9116, "++(1)", 1, partcv, params);
// compiled op node returning opresult9117 (depth = 7)
  int op_slot_left_9102 = gc_frame_newslot(opresult9117);
  params[0] = strlit9103;
  partcv[0] = 1;
  Object opresult9118 = callmethod(opresult9117, "++(1)", 1, partcv, params);
// compiled op node returning opresult9118 (depth = 6)
  int op_slot_right_9101 = gc_frame_newslot(opresult9118);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9101 = gc_frame_newslot(*var_s);
  params[0] = opresult9118;
  partcv[0] = 1;
  Object opresult9120 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9120 (depth = 5)
  *var_s = opresult9120;
  if (opresult9120 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9092 = done;
  } else {
  }
// compiled if node returning if9092 (depth = 3)
// Begin line 2313
  setline(2313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace_40_1_41_9122(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2316
  setline(2316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9124 == NULL) {
    strlit9124 = alloc_String("");
    gc_root(strlit9124);
  }
// compiled string node returning strlit9124 (depth = 4)
  int op_slot_right_9123 = gc_frame_newslot(strlit9124);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9127 = gc_frame_new();
// call case 4: self request
  Object call9128 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9127);
// compiled member node returning call9128 (depth = 5)
  int op_slot_right_9126 = gc_frame_newslot(call9128);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9131 == NULL) {
    strlit9131 = alloc_String("""\x22"" as ");
    gc_root(strlit9131);
  }
// compiled string node returning strlit9131 (depth = 6)
  int op_slot_right_9130 = gc_frame_newslot(strlit9131);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9134 = gc_frame_new();
// call case 4: self request
  Object call9135 = callmethodflags(self, "path", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9134);
// compiled member node returning call9135 (depth = 7)
  int op_slot_right_9133 = gc_frame_newslot(call9135);
// starting to compile string node (depth = 7)
  if (strlit9137 == NULL) {
    strlit9137 = alloc_String("import ""\x22""");
    gc_root(strlit9137);
  }
// compiled string node returning strlit9137 (depth = 7)
  int op_slot_left_9133 = gc_frame_newslot(strlit9137);
  params[0] = call9135;
  partcv[0] = 1;
  Object opresult9138 = callmethod(strlit9137, "++(1)", 1, partcv, params);
// compiled op node returning opresult9138 (depth = 6)
  int op_slot_left_9130 = gc_frame_newslot(opresult9138);
  params[0] = strlit9131;
  partcv[0] = 1;
  Object opresult9139 = callmethod(opresult9138, "++(1)", 1, partcv, params);
// compiled op node returning opresult9139 (depth = 5)
  int op_slot_left_9126 = gc_frame_newslot(opresult9139);
  params[0] = call9128;
  partcv[0] = 1;
  Object opresult9140 = callmethod(opresult9139, "++(1)", 1, partcv, params);
// compiled op node returning opresult9140 (depth = 4)
  int op_slot_left_9123 = gc_frame_newslot(opresult9140);
  params[0] = strlit9124;
  partcv[0] = 1;
  Object opresult9141 = callmethod(opresult9140, "++(1)", 1, partcv, params);
// compiled op node returning opresult9141 (depth = 3)
  gc_frame_end(frame);
  return opresult9141;
}
Object meth_ast_shallowCopy9142(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_importNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2319
  setline(2319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9143 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe9144 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9145 = gc_frame_new();
// call case 4: self request
  Object call9146 = callmethodflags(self, "path", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9145);
// compiled member node returning call9146 (depth = 5)
  gc_frame_newslot(call9146);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
  Object bool9147 = alloc_Boolean(0);
// compiled identifier node returning bool9147 (depth = 5)
  gc_frame_newslot(bool9147);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_importNode (depth = 5)
  params[0] = call9146;
  params[1] = *var_nullNode;
  params[2] = bool9147;
  partcv[0] = 3;
  Object call9148 = callmethodflags(*var_importNode, "new(3)", 1, partcv, params, 0);
  gc_frame_end(callframe9144);
// compiled call node returning call9148 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9149 = callmethodflags(call9148, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9143);
// compiled call node returning call9149 (depth = 3)
  gc_frame_end(frame);
  return call9149;
}
Object meth_ast_new_40_3_41_8882(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_importNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  Object *var_name_39_ = &(stackframe->slots[1]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8883 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8883 = alloc_userobj2(25,22, objclass8883);
  gc_frame_newslot(obj8883);
if (objclass8883 == NULL) {
  glfree(obj8883->class->name);
  obj8883->class->name = "importNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8883, self, 0);
  addmethodreal(obj8883,"outer", &reader_ast_outer_8884);
  Object oldself8883 = self;
  struct StackFrameObject *oldstackframe8883 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8883);
  gc_frame_newslot((Object)stackframe);
  self = obj8883;
  Object *oldselfslot8883 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8883 = (*(struct UserObject *)self).data[0], lowerouter8883 = thisouter8883;
  if (inheritingObject8883) {
    struct UserObject *inho8883 = (struct UserObject *)inheritingObject8883;
    while (inho8883->super != GraceDefaultObject) inho8883 = (struct UserObject *)inho8883->super;
    inho8883->super = obj8883;
    self = inheritingObject8883;
    *selfslot = self;
    lowerouter8883 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8883;
  }
if (objclass8883 == NULL) {
  Method *reader8885 = addmethodrealflags(obj8883, "kind",&reader_ast_kind_8885, MFLAG_DEF);
  reader8885->definitionModule = modulename;
  reader8885->definitionLine = 2249;
}
adddatum2(obj8883, alloc_Undefined(), 1);
if (objclass8883 == NULL) {
  Method *reader8886 = addmethodrealflags(obj8883, "value", &reader_ast_value_8886, 0);
  Method *writer8886 = addmethodrealflags(obj8883, "value:=(1)", &writer_ast_value_8886, 0);
  reader8886->definitionModule = modulename;
  writer8886->definitionModule = modulename;
  reader8886->definitionLine = 2250;
  writer8886->definitionLine = 2250;
}
obj8883->flags |= OFLAG_MUTABLE;
adddatum2(obj8883, alloc_Undefined(), 2);
if (objclass8883 == NULL) {
  Method *reader8887 = addmethodrealflags(obj8883, "path", &reader_ast_path_8887, 0);
  Method *writer8887 = addmethodrealflags(obj8883, "path:=(1)", &writer_ast_path_8887, 0);
  reader8887->definitionModule = modulename;
  writer8887->definitionModule = modulename;
  reader8887->definitionLine = 2251;
  writer8887->definitionLine = 2251;
}
obj8883->flags |= OFLAG_MUTABLE;
adddatum2(obj8883, alloc_Undefined(), 3);
if (objclass8883 == NULL) {
  Method *reader8888 = addmethodrealflags(obj8883, "annotations", &reader_ast_annotations_8888, 0);
  Method *writer8888 = addmethodrealflags(obj8883, "annotations:=(1)", &writer_ast_annotations_8888, 0);
  reader8888->definitionModule = modulename;
  writer8888->definitionModule = modulename;
  reader8888->definitionLine = 2252;
  writer8888->definitionLine = 2252;
}
obj8883->flags |= OFLAG_MUTABLE;
adddatum2(obj8883, alloc_Undefined(), 4);
if (objclass8883 == NULL) {
  Method *reader8889 = addmethodrealflags(obj8883, "dtype", &reader_ast_dtype_8889, 0);
  Method *writer8889 = addmethodrealflags(obj8883, "dtype:=(1)", &writer_ast_dtype_8889, 0);
  reader8889->definitionModule = modulename;
  writer8889->definitionModule = modulename;
  reader8889->definitionLine = 2253;
  writer8889->definitionLine = 2253;
}
obj8883->flags |= OFLAG_MUTABLE;
adddatum2(obj8883, alloc_Undefined(), 5);
// method "isImport"
  struct UserObject *uo8890 = (struct UserObject*)obj8883;
  uo8890->data[6] = emptyclosure;
  Method *meth_meth_ast_isImport8890 = addmethod2pos(obj8883, "isImport", &meth_ast_isImport8890, 6);
  int argcv_meth_ast_isImport8890[] = {0};
  meth_meth_ast_isImport8890->type = alloc_MethodType(1, argcv_meth_ast_isImport8890);
  meth_meth_ast_isImport8890->definitionModule = modulename;
  meth_meth_ast_isImport8890->definitionLine = 2254;
// method "isExternal"
  struct UserObject *uo8892 = (struct UserObject*)obj8883;
  uo8892->data[7] = emptyclosure;
  Method *meth_meth_ast_isExternal8892 = addmethod2pos(obj8883, "isExternal", &meth_ast_isExternal8892, 7);
  int argcv_meth_ast_isExternal8892[] = {0};
  meth_meth_ast_isExternal8892->type = alloc_MethodType(1, argcv_meth_ast_isExternal8892);
  meth_meth_ast_isExternal8892->definitionModule = modulename;
  meth_meth_ast_isExternal8892->definitionLine = 2255;
// method "isExecutable"
  struct UserObject *uo8894 = (struct UserObject*)obj8883;
  uo8894->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable8894 = addmethod2pos(obj8883, "isExecutable", &meth_ast_isExecutable8894, 8);
  int argcv_meth_ast_isExecutable8894[] = {0};
  meth_meth_ast_isExecutable8894->type = alloc_MethodType(1, argcv_meth_ast_isExecutable8894);
  meth_meth_ast_isExecutable8894->definitionModule = modulename;
  meth_meth_ast_isExecutable8894->definitionLine = 2256;
// method "name"
  struct UserObject *uo8896 = (struct UserObject*)obj8883;
  uo8896->data[9] = emptyclosure;
  Method *meth_meth_ast_name8896 = addmethod2pos(obj8883, "name", &meth_ast_name8896, 9);
  int argcv_meth_ast_name8896[] = {0};
  meth_meth_ast_name8896->type = alloc_MethodType(1, argcv_meth_ast_name8896);
  meth_meth_ast_name8896->definitionModule = modulename;
  meth_meth_ast_name8896->definitionLine = 2257;
// method "nameString"
  struct UserObject *uo8899 = (struct UserObject*)obj8883;
  uo8899->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString8899 = addmethod2pos(obj8883, "nameString", &meth_ast_nameString8899, 10);
  int argcv_meth_ast_nameString8899[] = {0};
  meth_meth_ast_nameString8899->type = alloc_MethodType(1, argcv_meth_ast_nameString8899);
  meth_meth_ast_nameString8899->definitionModule = modulename;
  meth_meth_ast_nameString8899->definitionLine = 2258;
// method "isPublic"
  struct UserObject *uo8904 = (struct UserObject*)obj8883;
  uo8904->data[11] = emptyclosure;
  Method *meth_meth_ast_isPublic8904 = addmethod2pos(obj8883, "isPublic", &meth_ast_isPublic8904, 11);
  int argcv_meth_ast_isPublic8904[] = {0};
  meth_meth_ast_isPublic8904->type = alloc_MethodType(1, argcv_meth_ast_isPublic8904);
  meth_meth_ast_isPublic8904->definitionModule = modulename;
  meth_meth_ast_isPublic8904->definitionLine = 2259;
// method "moduleName"
  struct UserObject *uo8931 = (struct UserObject*)obj8883;
  uo8931->data[12] = emptyclosure;
  Method *meth_meth_ast_moduleName8931 = addmethod2pos(obj8883, "moduleName", &meth_ast_moduleName8931, 12);
  int argcv_meth_ast_moduleName8931[] = {0};
  meth_meth_ast_moduleName8931->type = alloc_MethodType(1, argcv_meth_ast_moduleName8931);
  meth_meth_ast_moduleName8931->definitionModule = modulename;
  meth_meth_ast_moduleName8931->definitionLine = 2265;
// method "isWritable"
  struct UserObject *uo8951 = (struct UserObject*)obj8883;
  uo8951->data[13] = emptyclosure;
  Method *meth_meth_ast_isWritable8951 = addmethod2pos(obj8883, "isWritable", &meth_ast_isWritable8951, 13);
  int argcv_meth_ast_isWritable8951[] = {0};
  meth_meth_ast_isWritable8951->type = alloc_MethodType(1, argcv_meth_ast_isWritable8951);
  meth_meth_ast_isWritable8951->definitionModule = modulename;
  meth_meth_ast_isWritable8951->definitionLine = 2276;
// method "isReadable"
  struct UserObject *uo8953 = (struct UserObject*)obj8883;
  uo8953->data[14] = emptyclosure;
  Method *meth_meth_ast_isReadable8953 = addmethod2pos(obj8883, "isReadable", &meth_ast_isReadable8953, 14);
  int argcv_meth_ast_isReadable8953[] = {0};
  meth_meth_ast_isReadable8953->type = alloc_MethodType(1, argcv_meth_ast_isReadable8953);
  meth_meth_ast_isReadable8953->definitionModule = modulename;
  meth_meth_ast_isReadable8953->definitionLine = 2277;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj8883);
  Object closure8956 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure8956, stackframe);
  addtoclosure(closure8956, var_k);
  struct UserObject *uo8956 = (struct UserObject*)obj8883;
  uo8956->data[15] = (Object)closure8956;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_8956 = addmethod2pos(obj8883, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_8956, 15);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_8956[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8956->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_8956);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8956->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8956->definitionLine = 2278;
// method "usesAsType(_)"
  struct UserObject *uo8959 = (struct UserObject*)obj8883;
  uo8959->data[16] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_8959 = addmethod2pos(obj8883, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_8959, 16);
  int argcv_meth_ast_usesAsType_40_1_41_8959[] = {1};
  meth_meth_ast_usesAsType_40_1_41_8959->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_8959);
  meth_meth_ast_usesAsType_40_1_41_8959->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_8959->definitionLine = 2279;
// method "accept(_)from(_)"
  struct UserObject *uo8965 = (struct UserObject*)obj8883;
  uo8965->data[17] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_8965 = addmethod2pos(obj8883, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_8965, 17);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_8965[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_8965->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_8965);
  meth_meth_ast_accept_40_1_41_from_40_1_41_8965->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_8965->definitionLine = 2282;
// method "map(_)ancestors(_)"
  struct UserObject *uo8995 = (struct UserObject*)obj8883;
  uo8995->data[18] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_8995 = addmethod2pos(obj8883, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_8995, 18);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8995[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8995->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8995);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8995->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8995->definitionLine = 2294;
// method "pretty(_)"
  struct UserObject *uo9028 = (struct UserObject*)obj8883;
  uo9028->data[19] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_9028 = addmethod2pos(obj8883, "pretty(1)", &meth_ast_pretty_40_1_41_9028, 19);
  int argcv_meth_ast_pretty_40_1_41_9028[] = {1};
  meth_meth_ast_pretty_40_1_41_9028->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_9028);
  meth_meth_ast_pretty_40_1_41_9028->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_9028->definitionLine = 2302;
// method "toGrace(_)"
  struct UserObject *uo9122 = (struct UserObject*)obj8883;
  uo9122->data[20] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9122 = addmethod2pos(obj8883, "toGrace(1)", &meth_ast_toGrace_40_1_41_9122, 20);
  int argcv_meth_ast_toGrace_40_1_41_9122[] = {1};
  meth_meth_ast_toGrace_40_1_41_9122->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9122);
meth_meth_ast_toGrace_40_1_41_9122->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9122->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9122->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9122->definitionLine = 2315;
// method "shallowCopy"
  block_savedest(obj8883);
  Object closure9142 = createclosure(2, "shallowCopy");
  setclosureframe(closure9142, stackframe);
  addtoclosure(closure9142, var_nullNode);
  addtoclosure(closure9142, var_importNode);
  struct UserObject *uo9142 = (struct UserObject*)obj8883;
  uo9142->data[21] = (Object)closure9142;
  Method *meth_meth_ast_shallowCopy9142 = addmethod2pos(obj8883, "shallowCopy", &meth_ast_shallowCopy9142, 21);
  int argcv_meth_ast_shallowCopy9142[] = {0};
  meth_meth_ast_shallowCopy9142->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9142);
  meth_meth_ast_shallowCopy9142->definitionModule = modulename;
  meth_meth_ast_shallowCopy9142->definitionLine = 2318;
  sourceObject = obj8883;
// Begin line 2248
  setline(2248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9150 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9151 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9152 = gc_frame_new();
// call case 3: self.outer request
  Object call9153 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9152);
// compiled member node returning call9153 (depth = 5)
  Object call9154 = callmethodflags(call9153, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9151);
// compiled member node returning call9154 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9155 = callmethodflags(call9154, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9150);
// compiled call node returning call9155 (depth = 3)
  struct UserObject *obj8883_uo = (struct UserObject *)obj8883;
  obj8883_uo->super = call9155;
  sourceObject = obj8883;
// Begin line 2249
  setline(2249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9156 == NULL) {
    strlit9156 = alloc_String("import");
    gc_root(strlit9156);
  }
// compiled string node returning strlit9156 (depth = 3)
  adddatum2(obj8883, strlit9156, 1);
  sourceObject = obj8883;
// Begin line 2250
  setline(2250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8883, *var_name_39_, 2);
  sourceObject = obj8883;
// Begin line 2251
  setline(2251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_path_39_ (depth = 3)
  adddatum2(obj8883, *var_path_39_, 3);
  sourceObject = obj8883;
// Begin line 2252
  setline(2252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9157 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9157 (depth = 3)
  adddatum2(obj8883, array9157, 4);
  sourceObject = obj8883;
// Begin line 2253
  setline(2253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8883, *var_dtype_39_, 5);
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  objclass8883 = obj8883->class;
  objclass8883->definitionModule = modulename;
  objclass8883->definitionLine = 2247;
  (*(struct UserObject *)self).data[0] = lowerouter8883;
  self = oldself8883;
  selfslot = oldselfslot8883;
  stackframe = oldstackframe8883;
  gc_frame_end(frame);
  return obj8883;
}
Object meth_ast_new_40_3_41_8882_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(3)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments for method new(_,_,_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_importNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_,_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  Object *var_name_39_ = &(stackframe->slots[1]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for part new(_,_,_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8883 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8883 = alloc_userobj2(25,22, objclass8883);
  gc_frame_newslot(obj8883);
if (objclass8883 == NULL) {
  glfree(obj8883->class->name);
  obj8883->class->name = "importNode.new(_,_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8883, self, 0);
  addmethodreal(obj8883,"outer", &reader_ast_outer_8884);
  Object oldself8883 = self;
  struct StackFrameObject *oldstackframe8883 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8883);
  gc_frame_newslot((Object)stackframe);
  self = obj8883;
  Object *oldselfslot8883 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8883 = (*(struct UserObject *)self).data[0], lowerouter8883 = thisouter8883;
  if (inheritingObject8883) {
    struct UserObject *inho8883 = (struct UserObject *)inheritingObject8883;
    while (inho8883->super != GraceDefaultObject) inho8883 = (struct UserObject *)inho8883->super;
    inho8883->super = obj8883;
    self = inheritingObject8883;
    *selfslot = self;
    lowerouter8883 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8883;
  }
if (objclass8883 == NULL) {
  Method *reader8885 = addmethodrealflags(obj8883, "kind",&reader_ast_kind_8885, MFLAG_DEF);
  reader8885->definitionModule = modulename;
  reader8885->definitionLine = 2249;
}
adddatum2(obj8883, alloc_Undefined(), 1);
if (objclass8883 == NULL) {
  Method *reader8886 = addmethodrealflags(obj8883, "value", &reader_ast_value_8886, 0);
  Method *writer8886 = addmethodrealflags(obj8883, "value:=(1)", &writer_ast_value_8886, 0);
  reader8886->definitionModule = modulename;
  writer8886->definitionModule = modulename;
  reader8886->definitionLine = 2250;
  writer8886->definitionLine = 2250;
}
obj8883->flags |= OFLAG_MUTABLE;
adddatum2(obj8883, alloc_Undefined(), 2);
if (objclass8883 == NULL) {
  Method *reader8887 = addmethodrealflags(obj8883, "path", &reader_ast_path_8887, 0);
  Method *writer8887 = addmethodrealflags(obj8883, "path:=(1)", &writer_ast_path_8887, 0);
  reader8887->definitionModule = modulename;
  writer8887->definitionModule = modulename;
  reader8887->definitionLine = 2251;
  writer8887->definitionLine = 2251;
}
obj8883->flags |= OFLAG_MUTABLE;
adddatum2(obj8883, alloc_Undefined(), 3);
if (objclass8883 == NULL) {
  Method *reader8888 = addmethodrealflags(obj8883, "annotations", &reader_ast_annotations_8888, 0);
  Method *writer8888 = addmethodrealflags(obj8883, "annotations:=(1)", &writer_ast_annotations_8888, 0);
  reader8888->definitionModule = modulename;
  writer8888->definitionModule = modulename;
  reader8888->definitionLine = 2252;
  writer8888->definitionLine = 2252;
}
obj8883->flags |= OFLAG_MUTABLE;
adddatum2(obj8883, alloc_Undefined(), 4);
if (objclass8883 == NULL) {
  Method *reader8889 = addmethodrealflags(obj8883, "dtype", &reader_ast_dtype_8889, 0);
  Method *writer8889 = addmethodrealflags(obj8883, "dtype:=(1)", &writer_ast_dtype_8889, 0);
  reader8889->definitionModule = modulename;
  writer8889->definitionModule = modulename;
  reader8889->definitionLine = 2253;
  writer8889->definitionLine = 2253;
}
obj8883->flags |= OFLAG_MUTABLE;
adddatum2(obj8883, alloc_Undefined(), 5);
// method "isImport"
  struct UserObject *uo8890 = (struct UserObject*)obj8883;
  uo8890->data[6] = emptyclosure;
  Method *meth_meth_ast_isImport8890 = addmethod2pos(obj8883, "isImport", &meth_ast_isImport8890, 6);
  int argcv_meth_ast_isImport8890[] = {0};
  meth_meth_ast_isImport8890->type = alloc_MethodType(1, argcv_meth_ast_isImport8890);
  meth_meth_ast_isImport8890->definitionModule = modulename;
  meth_meth_ast_isImport8890->definitionLine = 2254;
// method "isExternal"
  struct UserObject *uo8892 = (struct UserObject*)obj8883;
  uo8892->data[7] = emptyclosure;
  Method *meth_meth_ast_isExternal8892 = addmethod2pos(obj8883, "isExternal", &meth_ast_isExternal8892, 7);
  int argcv_meth_ast_isExternal8892[] = {0};
  meth_meth_ast_isExternal8892->type = alloc_MethodType(1, argcv_meth_ast_isExternal8892);
  meth_meth_ast_isExternal8892->definitionModule = modulename;
  meth_meth_ast_isExternal8892->definitionLine = 2255;
// method "isExecutable"
  struct UserObject *uo8894 = (struct UserObject*)obj8883;
  uo8894->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable8894 = addmethod2pos(obj8883, "isExecutable", &meth_ast_isExecutable8894, 8);
  int argcv_meth_ast_isExecutable8894[] = {0};
  meth_meth_ast_isExecutable8894->type = alloc_MethodType(1, argcv_meth_ast_isExecutable8894);
  meth_meth_ast_isExecutable8894->definitionModule = modulename;
  meth_meth_ast_isExecutable8894->definitionLine = 2256;
// method "name"
  struct UserObject *uo8896 = (struct UserObject*)obj8883;
  uo8896->data[9] = emptyclosure;
  Method *meth_meth_ast_name8896 = addmethod2pos(obj8883, "name", &meth_ast_name8896, 9);
  int argcv_meth_ast_name8896[] = {0};
  meth_meth_ast_name8896->type = alloc_MethodType(1, argcv_meth_ast_name8896);
  meth_meth_ast_name8896->definitionModule = modulename;
  meth_meth_ast_name8896->definitionLine = 2257;
// method "nameString"
  struct UserObject *uo8899 = (struct UserObject*)obj8883;
  uo8899->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString8899 = addmethod2pos(obj8883, "nameString", &meth_ast_nameString8899, 10);
  int argcv_meth_ast_nameString8899[] = {0};
  meth_meth_ast_nameString8899->type = alloc_MethodType(1, argcv_meth_ast_nameString8899);
  meth_meth_ast_nameString8899->definitionModule = modulename;
  meth_meth_ast_nameString8899->definitionLine = 2258;
// method "isPublic"
  struct UserObject *uo8904 = (struct UserObject*)obj8883;
  uo8904->data[11] = emptyclosure;
  Method *meth_meth_ast_isPublic8904 = addmethod2pos(obj8883, "isPublic", &meth_ast_isPublic8904, 11);
  int argcv_meth_ast_isPublic8904[] = {0};
  meth_meth_ast_isPublic8904->type = alloc_MethodType(1, argcv_meth_ast_isPublic8904);
  meth_meth_ast_isPublic8904->definitionModule = modulename;
  meth_meth_ast_isPublic8904->definitionLine = 2259;
// method "moduleName"
  struct UserObject *uo8931 = (struct UserObject*)obj8883;
  uo8931->data[12] = emptyclosure;
  Method *meth_meth_ast_moduleName8931 = addmethod2pos(obj8883, "moduleName", &meth_ast_moduleName8931, 12);
  int argcv_meth_ast_moduleName8931[] = {0};
  meth_meth_ast_moduleName8931->type = alloc_MethodType(1, argcv_meth_ast_moduleName8931);
  meth_meth_ast_moduleName8931->definitionModule = modulename;
  meth_meth_ast_moduleName8931->definitionLine = 2265;
// method "isWritable"
  struct UserObject *uo8951 = (struct UserObject*)obj8883;
  uo8951->data[13] = emptyclosure;
  Method *meth_meth_ast_isWritable8951 = addmethod2pos(obj8883, "isWritable", &meth_ast_isWritable8951, 13);
  int argcv_meth_ast_isWritable8951[] = {0};
  meth_meth_ast_isWritable8951->type = alloc_MethodType(1, argcv_meth_ast_isWritable8951);
  meth_meth_ast_isWritable8951->definitionModule = modulename;
  meth_meth_ast_isWritable8951->definitionLine = 2276;
// method "isReadable"
  struct UserObject *uo8953 = (struct UserObject*)obj8883;
  uo8953->data[14] = emptyclosure;
  Method *meth_meth_ast_isReadable8953 = addmethod2pos(obj8883, "isReadable", &meth_ast_isReadable8953, 14);
  int argcv_meth_ast_isReadable8953[] = {0};
  meth_meth_ast_isReadable8953->type = alloc_MethodType(1, argcv_meth_ast_isReadable8953);
  meth_meth_ast_isReadable8953->definitionModule = modulename;
  meth_meth_ast_isReadable8953->definitionLine = 2277;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj8883);
  Object closure8956 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure8956, stackframe);
  addtoclosure(closure8956, var_k);
  struct UserObject *uo8956 = (struct UserObject*)obj8883;
  uo8956->data[15] = (Object)closure8956;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_8956 = addmethod2pos(obj8883, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_8956, 15);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_8956[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8956->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_8956);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8956->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_8956->definitionLine = 2278;
// method "usesAsType(_)"
  struct UserObject *uo8959 = (struct UserObject*)obj8883;
  uo8959->data[16] = emptyclosure;
  Method *meth_meth_ast_usesAsType_40_1_41_8959 = addmethod2pos(obj8883, "usesAsType(1)", &meth_ast_usesAsType_40_1_41_8959, 16);
  int argcv_meth_ast_usesAsType_40_1_41_8959[] = {1};
  meth_meth_ast_usesAsType_40_1_41_8959->type = alloc_MethodType(1, argcv_meth_ast_usesAsType_40_1_41_8959);
  meth_meth_ast_usesAsType_40_1_41_8959->definitionModule = modulename;
  meth_meth_ast_usesAsType_40_1_41_8959->definitionLine = 2279;
// method "accept(_)from(_)"
  struct UserObject *uo8965 = (struct UserObject*)obj8883;
  uo8965->data[17] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_8965 = addmethod2pos(obj8883, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_8965, 17);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_8965[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_8965->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_8965);
  meth_meth_ast_accept_40_1_41_from_40_1_41_8965->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_8965->definitionLine = 2282;
// method "map(_)ancestors(_)"
  struct UserObject *uo8995 = (struct UserObject*)obj8883;
  uo8995->data[18] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_8995 = addmethod2pos(obj8883, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_8995, 18);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8995[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8995->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_8995);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8995->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_8995->definitionLine = 2294;
// method "pretty(_)"
  struct UserObject *uo9028 = (struct UserObject*)obj8883;
  uo9028->data[19] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_9028 = addmethod2pos(obj8883, "pretty(1)", &meth_ast_pretty_40_1_41_9028, 19);
  int argcv_meth_ast_pretty_40_1_41_9028[] = {1};
  meth_meth_ast_pretty_40_1_41_9028->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_9028);
  meth_meth_ast_pretty_40_1_41_9028->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_9028->definitionLine = 2302;
// method "toGrace(_)"
  struct UserObject *uo9122 = (struct UserObject*)obj8883;
  uo9122->data[20] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9122 = addmethod2pos(obj8883, "toGrace(1)", &meth_ast_toGrace_40_1_41_9122, 20);
  int argcv_meth_ast_toGrace_40_1_41_9122[] = {1};
  meth_meth_ast_toGrace_40_1_41_9122->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9122);
meth_meth_ast_toGrace_40_1_41_9122->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9122->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9122->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9122->definitionLine = 2315;
// method "shallowCopy"
  block_savedest(obj8883);
  Object closure9142 = createclosure(2, "shallowCopy");
  setclosureframe(closure9142, stackframe);
  addtoclosure(closure9142, var_nullNode);
  addtoclosure(closure9142, var_importNode);
  struct UserObject *uo9142 = (struct UserObject*)obj8883;
  uo9142->data[21] = (Object)closure9142;
  Method *meth_meth_ast_shallowCopy9142 = addmethod2pos(obj8883, "shallowCopy", &meth_ast_shallowCopy9142, 21);
  int argcv_meth_ast_shallowCopy9142[] = {0};
  meth_meth_ast_shallowCopy9142->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9142);
  meth_meth_ast_shallowCopy9142->definitionModule = modulename;
  meth_meth_ast_shallowCopy9142->definitionLine = 2318;
  sourceObject = obj8883;
// Begin line 2248
  setline(2248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9150 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9151 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9152 = gc_frame_new();
// call case 3: self.outer request
  Object call9153 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9152);
// compiled member node returning call9153 (depth = 5)
  Object call9154 = callmethodflags(call9153, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9151);
// compiled member node returning call9154 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9155 = callmethodflags(call9154, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9150);
// compiled call node returning call9155 (depth = 3)
  struct UserObject *obj8883_uo = (struct UserObject *)obj8883;
  obj8883_uo->super = call9155;
  sourceObject = obj8883;
// Begin line 2249
  setline(2249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9156 == NULL) {
    strlit9156 = alloc_String("import");
    gc_root(strlit9156);
  }
// compiled string node returning strlit9156 (depth = 3)
  adddatum2(obj8883, strlit9156, 1);
  sourceObject = obj8883;
// Begin line 2250
  setline(2250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8883, *var_name_39_, 2);
  sourceObject = obj8883;
// Begin line 2251
  setline(2251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_path_39_ (depth = 3)
  adddatum2(obj8883, *var_path_39_, 3);
  sourceObject = obj8883;
// Begin line 2252
  setline(2252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9157 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9157 (depth = 3)
  adddatum2(obj8883, array9157, 4);
  sourceObject = obj8883;
// Begin line 2253
  setline(2253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8883, *var_dtype_39_, 5);
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  sourceObject = obj8883;
  objclass8883 = obj8883->class;
  objclass8883->definitionModule = modulename;
  objclass8883->definitionLine = 2247;
  (*(struct UserObject *)self).data[0] = lowerouter8883;
  self = oldself8883;
  selfslot = oldselfslot8883;
  stackframe = oldstackframe8883;
  gc_frame_end(frame);
  return obj8883;
}
Object meth_ast_importNode9159(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 43, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "importNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_importNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2246
  setline(2246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_importNode (depth = 3)
  gc_frame_end(frame);
  return *var_importNode;
}
Object meth_ast_isDialect9167(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2329
  setline(2329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9168 = alloc_Boolean(1);
// compiled identifier node returning bool9168 (depth = 3)
  gc_frame_end(frame);
  return bool9168;
}
Object meth_ast_isExternal9169(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExternal");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2330
  setline(2330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9170 = alloc_Boolean(1);
// compiled identifier node returning bool9170 (depth = 3)
  gc_frame_end(frame);
  return bool9170;
}
Object meth_ast_isExecutable9171(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2331
  setline(2331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9172 = alloc_Boolean(0);
// compiled identifier node returning bool9172 (depth = 3)
  gc_frame_end(frame);
  return bool9172;
}
Object meth_ast__apply_40_1_41_9179(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_bnm = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2335
  setline(2335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9182 == NULL) {
    strlit9182 = alloc_String("/");
    gc_root(strlit9182);
  }
// compiled string node returning strlit9182 (depth = 7)
  int op_slot_right_9181 = gc_frame_newslot(strlit9182);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_9181 = gc_frame_newslot(*var_c);
  params[0] = strlit9182;
  partcv[0] = 1;
  Object opresult9184 = callmethod(*var_c, "==(1)", 1, partcv, params);
// compiled op node returning opresult9184 (depth = 6)
  Object if9180 = done;
  if (istrue(opresult9184)) {
// Begin line 2336
  setline(2336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9185 == NULL) {
    strlit9185 = alloc_String("");
    gc_root(strlit9185);
  }
// compiled string node returning strlit9185 (depth = 7)
  *var_bnm = strlit9185;
  if (strlit9185 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if9180 = done;
  } else {
// Begin line 2338
  setline(2338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_right_9187 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_bnm (depth = 8)
  int op_slot_left_9187 = gc_frame_newslot(*var_bnm);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult9189 = callmethod(*var_bnm, "++(1)", 1, partcv, params);
// compiled op node returning opresult9189 (depth = 7)
  *var_bnm = opresult9189;
  if (opresult9189 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if9180 = done;
  }
// compiled if node returning if9180 (depth = 5)
  gc_frame_end(frame);
  return if9180;
}
Object meth_ast_moduleName9173(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "moduleName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_bnm = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "bnm");
// Begin line 2333
  setline(2333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9174 == NULL) {
    strlit9174 = alloc_String("");
    gc_root(strlit9174);
  }
// compiled string node returning strlit9174 (depth = 4)
  *var_bnm = strlit9174;
  if (strlit9174 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2334
  setline(2334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9175 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9176 = gc_frame_new();
// call case 4: self request
  Object call9177 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9176);
// compiled member node returning call9177 (depth = 4)
  gc_frame_newslot(call9177);
// starting to compile block node (depth = 4)
  Object block9178 = alloc_Block(NULL, NULL, "ast", 2334);
  gc_frame_newslot(block9178);
// method "_apply(_)"
  block_savedest(block9178);
  Object closure9179 = createclosure(2, "_apply(1)");
  setclosureframe(closure9179, stackframe);
  addtoclosure(closure9179, var_bnm);
  addtoclosure(closure9179, selfslot);
  struct UserObject *uo9179 = (struct UserObject*)block9178;
  uo9179->data[0] = (Object)closure9179;
  Method *meth_meth_ast__apply_40_1_41_9179 = addmethod2pos(block9178, "_apply(1)", &meth_ast__apply_40_1_41_9179, 0);
  int argcv_meth_ast__apply_40_1_41_9179[] = {1};
  meth_meth_ast__apply_40_1_41_9179->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9179);
  meth_meth_ast__apply_40_1_41_9179->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9179->definitionLine = 2981;
// compiled block node returning block9178 (depth = 4)
  gc_frame_newslot(block9178);
// call case 5: prelude request
  params[0] = call9177;
  params[1] = block9178;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9192 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9175);
// compiled call node returning call9192 (depth = 3)
// Begin line 2341
  setline(2341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_bnm (depth = 3)
  gc_frame_end(frame);
  return *var_bnm;
}
Object meth_ast_path9193(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "path");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2344
  setline(2344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9194 = gc_frame_new();
// call case 4: self request
  Object call9195 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9194);
// compiled member node returning call9195 (depth = 3)
  gc_frame_end(frame);
  return call9195;
}
Object meth_ast_accept_40_1_41_from_40_1_41_9196(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2347
  setline(2347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9197 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9198 = callmethodflags(*var_visitor, "visitDialect(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9197);
// compiled call node returning call9198 (depth = 3)
  gc_frame_end(frame);
  return call9198;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_9199(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2350
  setline(2350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9200 = gc_frame_new();
// call case 4: self request
  Object call9201 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9200);
// compiled member node returning call9201 (depth = 4)
  *var_n = call9201;
  if (call9201 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2351
  setline(2351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9202 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9203 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9202);
// compiled call node returning call9203 (depth = 4)
  *var_newChain = call9203;
  if (call9203 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2352
  setline(2352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9204 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9205 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9204);
// compiled call node returning call9205 (depth = 3)
  gc_frame_end(frame);
  return call9205;
}
Object meth_ast__apply_40_1_41_9214(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2357
  setline(2357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9216 == NULL) {
    strlit9216 = alloc_String("  ");
    gc_root(strlit9216);
  }
// compiled string node returning strlit9216 (depth = 7)
  int op_slot_right_9215 = gc_frame_newslot(strlit9216);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_9215 = gc_frame_newslot(*var_spc);
  params[0] = strlit9216;
  partcv[0] = 1;
  Object opresult9218 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult9218 (depth = 6)
  *var_spc = opresult9218;
  if (opresult9218 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_9206(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2355
  setline(2355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9207 == NULL) {
    strlit9207 = alloc_String("");
    gc_root(strlit9207);
  }
// compiled string node returning strlit9207 (depth = 4)
  *var_spc = strlit9207;
  if (strlit9207 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2356
  setline(2356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9208 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_9209 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num9211 = alloc_Float64(0);
// compiled num node returning num9211 (depth = 5)
  int op_slot_left_9209 = gc_frame_newslot(num9211);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9212 = callmethod(num9211, "..(1)", 1, partcv, params);
// compiled op node returning opresult9212 (depth = 4)
  gc_frame_newslot(opresult9212);
// starting to compile block node (depth = 4)
  Object block9213 = alloc_Block(NULL, NULL, "ast", 2356);
  gc_frame_newslot(block9213);
// method "_apply(_)"
  block_savedest(block9213);
  Object closure9214 = createclosure(2, "_apply(1)");
  setclosureframe(closure9214, stackframe);
  addtoclosure(closure9214, var_spc);
  addtoclosure(closure9214, selfslot);
  struct UserObject *uo9214 = (struct UserObject*)block9213;
  uo9214->data[0] = (Object)closure9214;
  Method *meth_meth_ast__apply_40_1_41_9214 = addmethod2pos(block9213, "_apply(1)", &meth_ast__apply_40_1_41_9214, 0);
  int argcv_meth_ast__apply_40_1_41_9214[] = {1};
  meth_meth_ast__apply_40_1_41_9214->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9214);
  meth_meth_ast__apply_40_1_41_9214->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9214->definitionLine = 2981;
// compiled block node returning block9213 (depth = 4)
  gc_frame_newslot(block9213);
// call case 5: prelude request
  params[0] = opresult9212;
  params[1] = block9213;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9221 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9208);
// compiled call node returning call9221 (depth = 3)
// Begin line 2359
  setline(2359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9223 == NULL) {
    strlit9223 = alloc_String("""\x0a""");
    gc_root(strlit9223);
  }
// compiled string node returning strlit9223 (depth = 5)
  int op_slot_right_9222 = gc_frame_newslot(strlit9223);
// starting to compile call node (depth = 5)
  int callframe9225 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9226 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9225);
// compiled call node returning call9226 (depth = 5)
  int op_slot_left_9222 = gc_frame_newslot(call9226);
  params[0] = strlit9223;
  partcv[0] = 1;
  Object opresult9227 = callmethod(call9226, "++(1)", 1, partcv, params);
// compiled op node returning opresult9227 (depth = 4)
  *var_s = opresult9227;
  if (opresult9227 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2360
  setline(2360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9230 == NULL) {
    strlit9230 = alloc_String("""\x0a""");
    gc_root(strlit9230);
  }
// compiled string node returning strlit9230 (depth = 6)
  int op_slot_right_9229 = gc_frame_newslot(strlit9230);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe9233 = gc_frame_new();
// call case 4: self request
  Object call9234 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9233);
// compiled member node returning call9234 (depth = 7)
  int op_slot_right_9232 = gc_frame_newslot(call9234);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9237 == NULL) {
    strlit9237 = alloc_String("Path: ");
    gc_root(strlit9237);
  }
// compiled string node returning strlit9237 (depth = 8)
  int op_slot_right_9236 = gc_frame_newslot(strlit9237);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_9239 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 9)
  if (strlit9241 == NULL) {
    strlit9241 = alloc_String("");
    gc_root(strlit9241);
  }
// compiled string node returning strlit9241 (depth = 9)
  int op_slot_left_9239 = gc_frame_newslot(strlit9241);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9242 = callmethod(strlit9241, "++(1)", 1, partcv, params);
// compiled op node returning opresult9242 (depth = 8)
  int op_slot_left_9236 = gc_frame_newslot(opresult9242);
  params[0] = strlit9237;
  partcv[0] = 1;
  Object opresult9243 = callmethod(opresult9242, "++(1)", 1, partcv, params);
// compiled op node returning opresult9243 (depth = 7)
  int op_slot_left_9232 = gc_frame_newslot(opresult9243);
  params[0] = call9234;
  partcv[0] = 1;
  Object opresult9244 = callmethod(opresult9243, "++(1)", 1, partcv, params);
// compiled op node returning opresult9244 (depth = 6)
  int op_slot_left_9229 = gc_frame_newslot(opresult9244);
  params[0] = strlit9230;
  partcv[0] = 1;
  Object opresult9245 = callmethod(opresult9244, "++(1)", 1, partcv, params);
// compiled op node returning opresult9245 (depth = 5)
  int op_slot_right_9228 = gc_frame_newslot(opresult9245);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_9228 = gc_frame_newslot(*var_s);
  params[0] = opresult9245;
  partcv[0] = 1;
  Object opresult9247 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9247 (depth = 4)
  *var_s = opresult9247;
  if (opresult9247 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2361
  setline(2361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace_40_1_41_9249(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2364
  setline(2364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9251 == NULL) {
    strlit9251 = alloc_String("""\x22""");
    gc_root(strlit9251);
  }
// compiled string node returning strlit9251 (depth = 4)
  int op_slot_right_9250 = gc_frame_newslot(strlit9251);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9254 = gc_frame_new();
// call case 4: self request
  Object call9255 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9254);
// compiled member node returning call9255 (depth = 5)
  int op_slot_right_9253 = gc_frame_newslot(call9255);
// starting to compile string node (depth = 5)
  if (strlit9257 == NULL) {
    strlit9257 = alloc_String("dialect ""\x22""");
    gc_root(strlit9257);
  }
// compiled string node returning strlit9257 (depth = 5)
  int op_slot_left_9253 = gc_frame_newslot(strlit9257);
  params[0] = call9255;
  partcv[0] = 1;
  Object opresult9258 = callmethod(strlit9257, "++(1)", 1, partcv, params);
// compiled op node returning opresult9258 (depth = 4)
  int op_slot_left_9250 = gc_frame_newslot(opresult9258);
  params[0] = strlit9251;
  partcv[0] = 1;
  Object opresult9259 = callmethod(opresult9258, "++(1)", 1, partcv, params);
// compiled op node returning opresult9259 (depth = 3)
  gc_frame_end(frame);
  return opresult9259;
}
Object meth_ast_shallowCopy9260(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2367
  setline(2367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9261 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe9262 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9263 = gc_frame_new();
// call case 4: self request
  Object call9264 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9263);
// compiled member node returning call9264 (depth = 5)
  gc_frame_newslot(call9264);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dialectNode (depth = 5)
  params[0] = call9264;
  partcv[0] = 1;
  Object call9265 = callmethodflags(*var_dialectNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9262);
// compiled call node returning call9265 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9266 = callmethodflags(call9265, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9261);
// compiled call node returning call9266 (depth = 3)
  gc_frame_end(frame);
  return call9266;
}
Object meth_ast_new_40_1_41_9162(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9163 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9163 = alloc_userobj2(13,13, objclass9163);
  gc_frame_newslot(obj9163);
if (objclass9163 == NULL) {
  glfree(obj9163->class->name);
  obj9163->class->name = "dialectNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9163, self, 0);
  addmethodreal(obj9163,"outer", &reader_ast_outer_9164);
  Object oldself9163 = self;
  struct StackFrameObject *oldstackframe9163 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9163);
  gc_frame_newslot((Object)stackframe);
  self = obj9163;
  Object *oldselfslot9163 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9163 = (*(struct UserObject *)self).data[0], lowerouter9163 = thisouter9163;
  if (inheritingObject9163) {
    struct UserObject *inho9163 = (struct UserObject *)inheritingObject9163;
    while (inho9163->super != GraceDefaultObject) inho9163 = (struct UserObject *)inho9163->super;
    inho9163->super = obj9163;
    self = inheritingObject9163;
    *selfslot = self;
    lowerouter9163 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9163;
  }
if (objclass9163 == NULL) {
  Method *reader9165 = addmethodrealflags(obj9163, "kind",&reader_ast_kind_9165, MFLAG_DEF);
  reader9165->definitionModule = modulename;
  reader9165->definitionLine = 2326;
}
adddatum2(obj9163, alloc_Undefined(), 1);
if (objclass9163 == NULL) {
  Method *reader9166 = addmethodrealflags(obj9163, "value", &reader_ast_value_9166, 0);
  Method *writer9166 = addmethodrealflags(obj9163, "value:=(1)", &writer_ast_value_9166, 0);
  reader9166->definitionModule = modulename;
  writer9166->definitionModule = modulename;
  reader9166->definitionLine = 2327;
  writer9166->definitionLine = 2327;
}
obj9163->flags |= OFLAG_MUTABLE;
adddatum2(obj9163, alloc_Undefined(), 2);
// method "isDialect"
  struct UserObject *uo9167 = (struct UserObject*)obj9163;
  uo9167->data[3] = emptyclosure;
  Method *meth_meth_ast_isDialect9167 = addmethod2pos(obj9163, "isDialect", &meth_ast_isDialect9167, 3);
  int argcv_meth_ast_isDialect9167[] = {0};
  meth_meth_ast_isDialect9167->type = alloc_MethodType(1, argcv_meth_ast_isDialect9167);
  meth_meth_ast_isDialect9167->definitionModule = modulename;
  meth_meth_ast_isDialect9167->definitionLine = 2329;
// method "isExternal"
  struct UserObject *uo9169 = (struct UserObject*)obj9163;
  uo9169->data[4] = emptyclosure;
  Method *meth_meth_ast_isExternal9169 = addmethod2pos(obj9163, "isExternal", &meth_ast_isExternal9169, 4);
  int argcv_meth_ast_isExternal9169[] = {0};
  meth_meth_ast_isExternal9169->type = alloc_MethodType(1, argcv_meth_ast_isExternal9169);
  meth_meth_ast_isExternal9169->definitionModule = modulename;
  meth_meth_ast_isExternal9169->definitionLine = 2330;
// method "isExecutable"
  struct UserObject *uo9171 = (struct UserObject*)obj9163;
  uo9171->data[5] = emptyclosure;
  Method *meth_meth_ast_isExecutable9171 = addmethod2pos(obj9163, "isExecutable", &meth_ast_isExecutable9171, 5);
  int argcv_meth_ast_isExecutable9171[] = {0};
  meth_meth_ast_isExecutable9171->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9171);
  meth_meth_ast_isExecutable9171->definitionModule = modulename;
  meth_meth_ast_isExecutable9171->definitionLine = 2331;
// method "moduleName"
  struct UserObject *uo9173 = (struct UserObject*)obj9163;
  uo9173->data[6] = emptyclosure;
  Method *meth_meth_ast_moduleName9173 = addmethod2pos(obj9163, "moduleName", &meth_ast_moduleName9173, 6);
  int argcv_meth_ast_moduleName9173[] = {0};
  meth_meth_ast_moduleName9173->type = alloc_MethodType(1, argcv_meth_ast_moduleName9173);
  meth_meth_ast_moduleName9173->definitionModule = modulename;
  meth_meth_ast_moduleName9173->definitionLine = 2332;
// method "path"
  struct UserObject *uo9193 = (struct UserObject*)obj9163;
  uo9193->data[7] = emptyclosure;
  Method *meth_meth_ast_path9193 = addmethod2pos(obj9163, "path", &meth_ast_path9193, 7);
  int argcv_meth_ast_path9193[] = {0};
  meth_meth_ast_path9193->type = alloc_MethodType(1, argcv_meth_ast_path9193);
  meth_meth_ast_path9193->definitionModule = modulename;
  meth_meth_ast_path9193->definitionLine = 2343;
// method "accept(_)from(_)"
  struct UserObject *uo9196 = (struct UserObject*)obj9163;
  uo9196->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9196 = addmethod2pos(obj9163, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9196, 8);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9196[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9196->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9196);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9196->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9196->definitionLine = 2346;
// method "map(_)ancestors(_)"
  struct UserObject *uo9199 = (struct UserObject*)obj9163;
  uo9199->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9199 = addmethod2pos(obj9163, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9199, 9);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9199[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9199->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9199);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9199->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9199->definitionLine = 2349;
// method "pretty(_)"
  struct UserObject *uo9206 = (struct UserObject*)obj9163;
  uo9206->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_9206 = addmethod2pos(obj9163, "pretty(1)", &meth_ast_pretty_40_1_41_9206, 10);
  int argcv_meth_ast_pretty_40_1_41_9206[] = {1};
  meth_meth_ast_pretty_40_1_41_9206->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_9206);
  meth_meth_ast_pretty_40_1_41_9206->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_9206->definitionLine = 2354;
// method "toGrace(_)"
  struct UserObject *uo9249 = (struct UserObject*)obj9163;
  uo9249->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9249 = addmethod2pos(obj9163, "toGrace(1)", &meth_ast_toGrace_40_1_41_9249, 11);
  int argcv_meth_ast_toGrace_40_1_41_9249[] = {1};
  meth_meth_ast_toGrace_40_1_41_9249->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9249);
meth_meth_ast_toGrace_40_1_41_9249->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9249->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9249->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9249->definitionLine = 2363;
// method "shallowCopy"
  block_savedest(obj9163);
  Object closure9260 = createclosure(1, "shallowCopy");
  setclosureframe(closure9260, stackframe);
  addtoclosure(closure9260, var_dialectNode);
  struct UserObject *uo9260 = (struct UserObject*)obj9163;
  uo9260->data[12] = (Object)closure9260;
  Method *meth_meth_ast_shallowCopy9260 = addmethod2pos(obj9163, "shallowCopy", &meth_ast_shallowCopy9260, 12);
  int argcv_meth_ast_shallowCopy9260[] = {0};
  meth_meth_ast_shallowCopy9260->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9260);
  meth_meth_ast_shallowCopy9260->definitionModule = modulename;
  meth_meth_ast_shallowCopy9260->definitionLine = 2366;
  sourceObject = obj9163;
// Begin line 2325
  setline(2325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9267 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9268 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9269 = gc_frame_new();
// call case 3: self.outer request
  Object call9270 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9269);
// compiled member node returning call9270 (depth = 5)
  Object call9271 = callmethodflags(call9270, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9268);
// compiled member node returning call9271 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9272 = callmethodflags(call9271, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9267);
// compiled call node returning call9272 (depth = 3)
  struct UserObject *obj9163_uo = (struct UserObject *)obj9163;
  obj9163_uo->super = call9272;
  sourceObject = obj9163;
// Begin line 2326
  setline(2326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9273 == NULL) {
    strlit9273 = alloc_String("dialect");
    gc_root(strlit9273);
  }
// compiled string node returning strlit9273 (depth = 3)
  adddatum2(obj9163, strlit9273, 1);
  sourceObject = obj9163;
// Begin line 2327
  setline(2327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_path_39_ (depth = 3)
  adddatum2(obj9163, *var_path_39_, 2);
  sourceObject = obj9163;
  sourceObject = obj9163;
  sourceObject = obj9163;
  sourceObject = obj9163;
  sourceObject = obj9163;
  sourceObject = obj9163;
  sourceObject = obj9163;
  sourceObject = obj9163;
  sourceObject = obj9163;
  sourceObject = obj9163;
  objclass9163 = obj9163->class;
  objclass9163->definitionModule = modulename;
  objclass9163->definitionLine = 2324;
  (*(struct UserObject *)self).data[0] = lowerouter9163;
  self = oldself9163;
  selfslot = oldselfslot9163;
  stackframe = oldstackframe9163;
  gc_frame_end(frame);
  return obj9163;
}
Object meth_ast_new_40_1_41_9162_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9163 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9163 = alloc_userobj2(13,13, objclass9163);
  gc_frame_newslot(obj9163);
if (objclass9163 == NULL) {
  glfree(obj9163->class->name);
  obj9163->class->name = "dialectNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9163, self, 0);
  addmethodreal(obj9163,"outer", &reader_ast_outer_9164);
  Object oldself9163 = self;
  struct StackFrameObject *oldstackframe9163 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9163);
  gc_frame_newslot((Object)stackframe);
  self = obj9163;
  Object *oldselfslot9163 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9163 = (*(struct UserObject *)self).data[0], lowerouter9163 = thisouter9163;
  if (inheritingObject9163) {
    struct UserObject *inho9163 = (struct UserObject *)inheritingObject9163;
    while (inho9163->super != GraceDefaultObject) inho9163 = (struct UserObject *)inho9163->super;
    inho9163->super = obj9163;
    self = inheritingObject9163;
    *selfslot = self;
    lowerouter9163 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9163;
  }
if (objclass9163 == NULL) {
  Method *reader9165 = addmethodrealflags(obj9163, "kind",&reader_ast_kind_9165, MFLAG_DEF);
  reader9165->definitionModule = modulename;
  reader9165->definitionLine = 2326;
}
adddatum2(obj9163, alloc_Undefined(), 1);
if (objclass9163 == NULL) {
  Method *reader9166 = addmethodrealflags(obj9163, "value", &reader_ast_value_9166, 0);
  Method *writer9166 = addmethodrealflags(obj9163, "value:=(1)", &writer_ast_value_9166, 0);
  reader9166->definitionModule = modulename;
  writer9166->definitionModule = modulename;
  reader9166->definitionLine = 2327;
  writer9166->definitionLine = 2327;
}
obj9163->flags |= OFLAG_MUTABLE;
adddatum2(obj9163, alloc_Undefined(), 2);
// method "isDialect"
  struct UserObject *uo9167 = (struct UserObject*)obj9163;
  uo9167->data[3] = emptyclosure;
  Method *meth_meth_ast_isDialect9167 = addmethod2pos(obj9163, "isDialect", &meth_ast_isDialect9167, 3);
  int argcv_meth_ast_isDialect9167[] = {0};
  meth_meth_ast_isDialect9167->type = alloc_MethodType(1, argcv_meth_ast_isDialect9167);
  meth_meth_ast_isDialect9167->definitionModule = modulename;
  meth_meth_ast_isDialect9167->definitionLine = 2329;
// method "isExternal"
  struct UserObject *uo9169 = (struct UserObject*)obj9163;
  uo9169->data[4] = emptyclosure;
  Method *meth_meth_ast_isExternal9169 = addmethod2pos(obj9163, "isExternal", &meth_ast_isExternal9169, 4);
  int argcv_meth_ast_isExternal9169[] = {0};
  meth_meth_ast_isExternal9169->type = alloc_MethodType(1, argcv_meth_ast_isExternal9169);
  meth_meth_ast_isExternal9169->definitionModule = modulename;
  meth_meth_ast_isExternal9169->definitionLine = 2330;
// method "isExecutable"
  struct UserObject *uo9171 = (struct UserObject*)obj9163;
  uo9171->data[5] = emptyclosure;
  Method *meth_meth_ast_isExecutable9171 = addmethod2pos(obj9163, "isExecutable", &meth_ast_isExecutable9171, 5);
  int argcv_meth_ast_isExecutable9171[] = {0};
  meth_meth_ast_isExecutable9171->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9171);
  meth_meth_ast_isExecutable9171->definitionModule = modulename;
  meth_meth_ast_isExecutable9171->definitionLine = 2331;
// method "moduleName"
  struct UserObject *uo9173 = (struct UserObject*)obj9163;
  uo9173->data[6] = emptyclosure;
  Method *meth_meth_ast_moduleName9173 = addmethod2pos(obj9163, "moduleName", &meth_ast_moduleName9173, 6);
  int argcv_meth_ast_moduleName9173[] = {0};
  meth_meth_ast_moduleName9173->type = alloc_MethodType(1, argcv_meth_ast_moduleName9173);
  meth_meth_ast_moduleName9173->definitionModule = modulename;
  meth_meth_ast_moduleName9173->definitionLine = 2332;
// method "path"
  struct UserObject *uo9193 = (struct UserObject*)obj9163;
  uo9193->data[7] = emptyclosure;
  Method *meth_meth_ast_path9193 = addmethod2pos(obj9163, "path", &meth_ast_path9193, 7);
  int argcv_meth_ast_path9193[] = {0};
  meth_meth_ast_path9193->type = alloc_MethodType(1, argcv_meth_ast_path9193);
  meth_meth_ast_path9193->definitionModule = modulename;
  meth_meth_ast_path9193->definitionLine = 2343;
// method "accept(_)from(_)"
  struct UserObject *uo9196 = (struct UserObject*)obj9163;
  uo9196->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9196 = addmethod2pos(obj9163, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9196, 8);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9196[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9196->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9196);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9196->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9196->definitionLine = 2346;
// method "map(_)ancestors(_)"
  struct UserObject *uo9199 = (struct UserObject*)obj9163;
  uo9199->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9199 = addmethod2pos(obj9163, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9199, 9);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9199[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9199->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9199);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9199->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9199->definitionLine = 2349;
// method "pretty(_)"
  struct UserObject *uo9206 = (struct UserObject*)obj9163;
  uo9206->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_9206 = addmethod2pos(obj9163, "pretty(1)", &meth_ast_pretty_40_1_41_9206, 10);
  int argcv_meth_ast_pretty_40_1_41_9206[] = {1};
  meth_meth_ast_pretty_40_1_41_9206->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_9206);
  meth_meth_ast_pretty_40_1_41_9206->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_9206->definitionLine = 2354;
// method "toGrace(_)"
  struct UserObject *uo9249 = (struct UserObject*)obj9163;
  uo9249->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9249 = addmethod2pos(obj9163, "toGrace(1)", &meth_ast_toGrace_40_1_41_9249, 11);
  int argcv_meth_ast_toGrace_40_1_41_9249[] = {1};
  meth_meth_ast_toGrace_40_1_41_9249->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9249);
meth_meth_ast_toGrace_40_1_41_9249->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9249->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9249->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9249->definitionLine = 2363;
// method "shallowCopy"
  block_savedest(obj9163);
  Object closure9260 = createclosure(1, "shallowCopy");
  setclosureframe(closure9260, stackframe);
  addtoclosure(closure9260, var_dialectNode);
  struct UserObject *uo9260 = (struct UserObject*)obj9163;
  uo9260->data[12] = (Object)closure9260;
  Method *meth_meth_ast_shallowCopy9260 = addmethod2pos(obj9163, "shallowCopy", &meth_ast_shallowCopy9260, 12);
  int argcv_meth_ast_shallowCopy9260[] = {0};
  meth_meth_ast_shallowCopy9260->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9260);
  meth_meth_ast_shallowCopy9260->definitionModule = modulename;
  meth_meth_ast_shallowCopy9260->definitionLine = 2366;
  sourceObject = obj9163;
// Begin line 2325
  setline(2325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9267 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9268 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9269 = gc_frame_new();
// call case 3: self.outer request
  Object call9270 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9269);
// compiled member node returning call9270 (depth = 5)
  Object call9271 = callmethodflags(call9270, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9268);
// compiled member node returning call9271 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9272 = callmethodflags(call9271, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9267);
// compiled call node returning call9272 (depth = 3)
  struct UserObject *obj9163_uo = (struct UserObject *)obj9163;
  obj9163_uo->super = call9272;
  sourceObject = obj9163;
// Begin line 2326
  setline(2326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9273 == NULL) {
    strlit9273 = alloc_String("dialect");
    gc_root(strlit9273);
  }
// compiled string node returning strlit9273 (depth = 3)
  adddatum2(obj9163, strlit9273, 1);
  sourceObject = obj9163;
// Begin line 2327
  setline(2327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_path_39_ (depth = 3)
  adddatum2(obj9163, *var_path_39_, 2);
  sourceObject = obj9163;
  sourceObject = obj9163;
  sourceObject = obj9163;
  sourceObject = obj9163;
  sourceObject = obj9163;
  sourceObject = obj9163;
  sourceObject = obj9163;
  sourceObject = obj9163;
  sourceObject = obj9163;
  sourceObject = obj9163;
  objclass9163 = obj9163->class;
  objclass9163->definitionModule = modulename;
  objclass9163->definitionLine = 2324;
  (*(struct UserObject *)self).data[0] = lowerouter9163;
  self = oldself9163;
  selfslot = oldselfslot9163;
  stackframe = oldstackframe9163;
  gc_frame_end(frame);
  return obj9163;
}
Object meth_ast_dialectNode9275(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 44, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dialectNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2323
  setline(2323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dialectNode (depth = 3)
  gc_frame_end(frame);
  return *var_dialectNode;
}
Object meth_ast_accept_40_1_41_from_40_1_41_9283(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2378
  setline(2378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9285 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9286 = callmethodflags(*var_visitor, "visitReturn(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9285);
// compiled call node returning call9286 (depth = 4)
  Object if9284 = done;
  if (istrue(call9286)) {
// Begin line 2379
  setline(2379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9287 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call9288 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9287);
// compiled call node returning call9288 (depth = 5)
  *var_newChain = call9288;
  if (call9288 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2380
  setline(2380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9289 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9290 = gc_frame_new();
// call case 4: self request
  Object call9291 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9290);
// compiled member node returning call9291 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9292 = callmethodflags(call9291, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9289);
// compiled call node returning call9292 (depth = 4)
    gc_frame_newslot(call9292);
    if9284 = call9292;
  } else {
  }
// compiled if node returning if9284 (depth = 3)
  gc_frame_end(frame);
  return if9284;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_9293(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2384
  setline(2384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9294 = gc_frame_new();
// call case 4: self request
  Object call9295 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9294);
// compiled member node returning call9295 (depth = 4)
  *var_n = call9295;
  if (call9295 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2385
  setline(2385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9296 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9297 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9296);
// compiled call node returning call9297 (depth = 4)
  *var_newChain = call9297;
  if (call9297 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2386
  setline(2386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9298 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9299 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9300 = gc_frame_new();
// call case 4: self request
  Object call9301 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9300);
// compiled member node returning call9301 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9302 = callmethodflags(call9301, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9299);
// compiled call node returning call9302 (depth = 4)
  gc_frame_newslot(call9302);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call9302;
  partcv[0] = 1;
  Object call9303 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9298);
// compiled call node returning call9303 (depth = 3)
// Begin line 2387
  setline(2387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9304 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9305 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9304);
// compiled call node returning call9305 (depth = 3)
  gc_frame_end(frame);
  return call9305;
}
Object meth_ast__apply_40_1_41_9314(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2392
  setline(2392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9316 == NULL) {
    strlit9316 = alloc_String("  ");
    gc_root(strlit9316);
  }
// compiled string node returning strlit9316 (depth = 7)
  int op_slot_right_9315 = gc_frame_newslot(strlit9316);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_9315 = gc_frame_newslot(*var_spc);
  params[0] = strlit9316;
  partcv[0] = 1;
  Object opresult9318 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult9318 (depth = 6)
  *var_spc = opresult9318;
  if (opresult9318 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_9306(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2390
  setline(2390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9307 == NULL) {
    strlit9307 = alloc_String("");
    gc_root(strlit9307);
  }
// compiled string node returning strlit9307 (depth = 4)
  *var_spc = strlit9307;
  if (strlit9307 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2391
  setline(2391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9308 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_9309 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num9311 = alloc_Float64(0);
// compiled num node returning num9311 (depth = 5)
  int op_slot_left_9309 = gc_frame_newslot(num9311);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9312 = callmethod(num9311, "..(1)", 1, partcv, params);
// compiled op node returning opresult9312 (depth = 4)
  gc_frame_newslot(opresult9312);
// starting to compile block node (depth = 4)
  Object block9313 = alloc_Block(NULL, NULL, "ast", 2391);
  gc_frame_newslot(block9313);
// method "_apply(_)"
  block_savedest(block9313);
  Object closure9314 = createclosure(2, "_apply(1)");
  setclosureframe(closure9314, stackframe);
  addtoclosure(closure9314, var_spc);
  addtoclosure(closure9314, selfslot);
  struct UserObject *uo9314 = (struct UserObject*)block9313;
  uo9314->data[0] = (Object)closure9314;
  Method *meth_meth_ast__apply_40_1_41_9314 = addmethod2pos(block9313, "_apply(1)", &meth_ast__apply_40_1_41_9314, 0);
  int argcv_meth_ast__apply_40_1_41_9314[] = {1};
  meth_meth_ast__apply_40_1_41_9314->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9314);
  meth_meth_ast__apply_40_1_41_9314->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9314->definitionLine = 2981;
// compiled block node returning block9313 (depth = 4)
  gc_frame_newslot(block9313);
// call case 5: prelude request
  params[0] = opresult9312;
  params[1] = block9313;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9321 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9308);
// compiled call node returning call9321 (depth = 3)
// Begin line 2394
  setline(2394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9323 == NULL) {
    strlit9323 = alloc_String("""\x0a""");
    gc_root(strlit9323);
  }
// compiled string node returning strlit9323 (depth = 5)
  int op_slot_right_9322 = gc_frame_newslot(strlit9323);
// starting to compile call node (depth = 5)
  int callframe9325 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9326 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9325);
// compiled call node returning call9326 (depth = 5)
  int op_slot_left_9322 = gc_frame_newslot(call9326);
  params[0] = strlit9323;
  partcv[0] = 1;
  Object opresult9327 = callmethod(call9326, "++(1)", 1, partcv, params);
// compiled op node returning opresult9327 (depth = 4)
  *var_s = opresult9327;
  if (opresult9327 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2395
  setline(2395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9329 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9331 = alloc_Float64(1);
// compiled num node returning num9331 (depth = 7)
  int op_slot_right_9330 = gc_frame_newslot(num9331);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_9330 = gc_frame_newslot(*var_depth);
  params[0] = num9331;
  partcv[0] = 1;
  Object sum9333 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum9333 (depth = 6)
  gc_frame_newslot(sum9333);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9334 = gc_frame_new();
// call case 4: self request
  Object call9335 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9334);
// compiled member node returning call9335 (depth = 6)
  params[0] = sum9333;
  partcv[0] = 1;
  Object call9336 = callmethodflags(call9335, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9329);
// compiled call node returning call9336 (depth = 5)
  int op_slot_right_9328 = gc_frame_newslot(call9336);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_9338 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9338 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9340 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9340 (depth = 5)
  int op_slot_left_9328 = gc_frame_newslot(opresult9340);
  params[0] = call9336;
  partcv[0] = 1;
  Object opresult9341 = callmethod(opresult9340, "++(1)", 1, partcv, params);
// compiled op node returning opresult9341 (depth = 4)
  *var_s = opresult9341;
  if (opresult9341 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2396
  setline(2396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace_40_1_41_9343(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2399
  setline(2399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9345 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9346 = gc_frame_new();
// call case 4: self request
  Object call9347 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9346);
// compiled member node returning call9347 (depth = 5)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9348 = callmethodflags(call9347, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9345);
// compiled call node returning call9348 (depth = 4)
  int op_slot_right_9344 = gc_frame_newslot(call9348);
// starting to compile string node (depth = 4)
  if (strlit9350 == NULL) {
    strlit9350 = alloc_String("return ");
    gc_root(strlit9350);
  }
// compiled string node returning strlit9350 (depth = 4)
  int op_slot_left_9344 = gc_frame_newslot(strlit9350);
  params[0] = call9348;
  partcv[0] = 1;
  Object opresult9351 = callmethod(strlit9350, "++(1)", 1, partcv, params);
// compiled op node returning opresult9351 (depth = 3)
  gc_frame_end(frame);
  return opresult9351;
}
Object meth_ast_shallowCopy9352(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2402
  setline(2402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9353 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe9354 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_returnNode (depth = 5)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call9355 = callmethodflags(*var_returnNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9354);
// compiled call node returning call9355 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9356 = callmethodflags(call9355, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9353);
// compiled call node returning call9356 (depth = 3)
  gc_frame_end(frame);
  return call9356;
}
Object meth_ast_new_40_1_41_9278(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9279 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9279 = alloc_userobj2(8,8, objclass9279);
  gc_frame_newslot(obj9279);
if (objclass9279 == NULL) {
  glfree(obj9279->class->name);
  obj9279->class->name = "returnNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9279, self, 0);
  addmethodreal(obj9279,"outer", &reader_ast_outer_9280);
  Object oldself9279 = self;
  struct StackFrameObject *oldstackframe9279 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9279);
  gc_frame_newslot((Object)stackframe);
  self = obj9279;
  Object *oldselfslot9279 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9279 = (*(struct UserObject *)self).data[0], lowerouter9279 = thisouter9279;
  if (inheritingObject9279) {
    struct UserObject *inho9279 = (struct UserObject *)inheritingObject9279;
    while (inho9279->super != GraceDefaultObject) inho9279 = (struct UserObject *)inho9279->super;
    inho9279->super = obj9279;
    self = inheritingObject9279;
    *selfslot = self;
    lowerouter9279 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9279;
  }
if (objclass9279 == NULL) {
  Method *reader9281 = addmethodrealflags(obj9279, "kind",&reader_ast_kind_9281, MFLAG_DEF);
  reader9281->definitionModule = modulename;
  reader9281->definitionLine = 2374;
}
adddatum2(obj9279, alloc_Undefined(), 1);
if (objclass9279 == NULL) {
  Method *reader9282 = addmethodrealflags(obj9279, "value", &reader_ast_value_9282, 0);
  Method *writer9282 = addmethodrealflags(obj9279, "value:=(1)", &writer_ast_value_9282, 0);
  reader9282->definitionModule = modulename;
  writer9282->definitionModule = modulename;
  reader9282->definitionLine = 2375;
  writer9282->definitionLine = 2375;
}
obj9279->flags |= OFLAG_MUTABLE;
adddatum2(obj9279, alloc_Undefined(), 2);
// method "accept(_)from(_)"
  struct UserObject *uo9283 = (struct UserObject*)obj9279;
  uo9283->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9283 = addmethod2pos(obj9279, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9283, 3);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9283[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9283->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9283);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9283->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9283->definitionLine = 2377;
// method "map(_)ancestors(_)"
  struct UserObject *uo9293 = (struct UserObject*)obj9279;
  uo9293->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9293 = addmethod2pos(obj9279, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9293, 4);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9293[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9293->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9293);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9293->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9293->definitionLine = 2383;
// method "pretty(_)"
  struct UserObject *uo9306 = (struct UserObject*)obj9279;
  uo9306->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_9306 = addmethod2pos(obj9279, "pretty(1)", &meth_ast_pretty_40_1_41_9306, 5);
  int argcv_meth_ast_pretty_40_1_41_9306[] = {1};
  meth_meth_ast_pretty_40_1_41_9306->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_9306);
  meth_meth_ast_pretty_40_1_41_9306->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_9306->definitionLine = 2389;
// method "toGrace(_)"
  struct UserObject *uo9343 = (struct UserObject*)obj9279;
  uo9343->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9343 = addmethod2pos(obj9279, "toGrace(1)", &meth_ast_toGrace_40_1_41_9343, 6);
  int argcv_meth_ast_toGrace_40_1_41_9343[] = {1};
  meth_meth_ast_toGrace_40_1_41_9343->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9343);
meth_meth_ast_toGrace_40_1_41_9343->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9343->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9343->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9343->definitionLine = 2398;
// method "shallowCopy"
  block_savedest(obj9279);
  Object closure9352 = createclosure(2, "shallowCopy");
  setclosureframe(closure9352, stackframe);
  addtoclosure(closure9352, var_nullNode);
  addtoclosure(closure9352, var_returnNode);
  struct UserObject *uo9352 = (struct UserObject*)obj9279;
  uo9352->data[7] = (Object)closure9352;
  Method *meth_meth_ast_shallowCopy9352 = addmethod2pos(obj9279, "shallowCopy", &meth_ast_shallowCopy9352, 7);
  int argcv_meth_ast_shallowCopy9352[] = {0};
  meth_meth_ast_shallowCopy9352->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9352);
  meth_meth_ast_shallowCopy9352->definitionModule = modulename;
  meth_meth_ast_shallowCopy9352->definitionLine = 2401;
  sourceObject = obj9279;
// Begin line 2373
  setline(2373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9357 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9358 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9359 = gc_frame_new();
// call case 3: self.outer request
  Object call9360 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9359);
// compiled member node returning call9360 (depth = 5)
  Object call9361 = callmethodflags(call9360, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9358);
// compiled member node returning call9361 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9362 = callmethodflags(call9361, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9357);
// compiled call node returning call9362 (depth = 3)
  struct UserObject *obj9279_uo = (struct UserObject *)obj9279;
  obj9279_uo->super = call9362;
  sourceObject = obj9279;
// Begin line 2374
  setline(2374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9363 == NULL) {
    strlit9363 = alloc_String("return");
    gc_root(strlit9363);
  }
// compiled string node returning strlit9363 (depth = 3)
  adddatum2(obj9279, strlit9363, 1);
  sourceObject = obj9279;
// Begin line 2375
  setline(2375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj9279, *var_expr, 2);
  sourceObject = obj9279;
  sourceObject = obj9279;
  sourceObject = obj9279;
  sourceObject = obj9279;
  sourceObject = obj9279;
  objclass9279 = obj9279->class;
  objclass9279->definitionModule = modulename;
  objclass9279->definitionLine = 2372;
  (*(struct UserObject *)self).data[0] = lowerouter9279;
  self = oldself9279;
  selfslot = oldselfslot9279;
  stackframe = oldstackframe9279;
  gc_frame_end(frame);
  return obj9279;
}
Object meth_ast_new_40_1_41_9278_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9279 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9279 = alloc_userobj2(8,8, objclass9279);
  gc_frame_newslot(obj9279);
if (objclass9279 == NULL) {
  glfree(obj9279->class->name);
  obj9279->class->name = "returnNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9279, self, 0);
  addmethodreal(obj9279,"outer", &reader_ast_outer_9280);
  Object oldself9279 = self;
  struct StackFrameObject *oldstackframe9279 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9279);
  gc_frame_newslot((Object)stackframe);
  self = obj9279;
  Object *oldselfslot9279 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9279 = (*(struct UserObject *)self).data[0], lowerouter9279 = thisouter9279;
  if (inheritingObject9279) {
    struct UserObject *inho9279 = (struct UserObject *)inheritingObject9279;
    while (inho9279->super != GraceDefaultObject) inho9279 = (struct UserObject *)inho9279->super;
    inho9279->super = obj9279;
    self = inheritingObject9279;
    *selfslot = self;
    lowerouter9279 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9279;
  }
if (objclass9279 == NULL) {
  Method *reader9281 = addmethodrealflags(obj9279, "kind",&reader_ast_kind_9281, MFLAG_DEF);
  reader9281->definitionModule = modulename;
  reader9281->definitionLine = 2374;
}
adddatum2(obj9279, alloc_Undefined(), 1);
if (objclass9279 == NULL) {
  Method *reader9282 = addmethodrealflags(obj9279, "value", &reader_ast_value_9282, 0);
  Method *writer9282 = addmethodrealflags(obj9279, "value:=(1)", &writer_ast_value_9282, 0);
  reader9282->definitionModule = modulename;
  writer9282->definitionModule = modulename;
  reader9282->definitionLine = 2375;
  writer9282->definitionLine = 2375;
}
obj9279->flags |= OFLAG_MUTABLE;
adddatum2(obj9279, alloc_Undefined(), 2);
// method "accept(_)from(_)"
  struct UserObject *uo9283 = (struct UserObject*)obj9279;
  uo9283->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9283 = addmethod2pos(obj9279, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9283, 3);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9283[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9283->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9283);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9283->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9283->definitionLine = 2377;
// method "map(_)ancestors(_)"
  struct UserObject *uo9293 = (struct UserObject*)obj9279;
  uo9293->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9293 = addmethod2pos(obj9279, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9293, 4);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9293[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9293->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9293);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9293->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9293->definitionLine = 2383;
// method "pretty(_)"
  struct UserObject *uo9306 = (struct UserObject*)obj9279;
  uo9306->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_9306 = addmethod2pos(obj9279, "pretty(1)", &meth_ast_pretty_40_1_41_9306, 5);
  int argcv_meth_ast_pretty_40_1_41_9306[] = {1};
  meth_meth_ast_pretty_40_1_41_9306->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_9306);
  meth_meth_ast_pretty_40_1_41_9306->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_9306->definitionLine = 2389;
// method "toGrace(_)"
  struct UserObject *uo9343 = (struct UserObject*)obj9279;
  uo9343->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9343 = addmethod2pos(obj9279, "toGrace(1)", &meth_ast_toGrace_40_1_41_9343, 6);
  int argcv_meth_ast_toGrace_40_1_41_9343[] = {1};
  meth_meth_ast_toGrace_40_1_41_9343->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9343);
meth_meth_ast_toGrace_40_1_41_9343->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9343->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9343->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9343->definitionLine = 2398;
// method "shallowCopy"
  block_savedest(obj9279);
  Object closure9352 = createclosure(2, "shallowCopy");
  setclosureframe(closure9352, stackframe);
  addtoclosure(closure9352, var_nullNode);
  addtoclosure(closure9352, var_returnNode);
  struct UserObject *uo9352 = (struct UserObject*)obj9279;
  uo9352->data[7] = (Object)closure9352;
  Method *meth_meth_ast_shallowCopy9352 = addmethod2pos(obj9279, "shallowCopy", &meth_ast_shallowCopy9352, 7);
  int argcv_meth_ast_shallowCopy9352[] = {0};
  meth_meth_ast_shallowCopy9352->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9352);
  meth_meth_ast_shallowCopy9352->definitionModule = modulename;
  meth_meth_ast_shallowCopy9352->definitionLine = 2401;
  sourceObject = obj9279;
// Begin line 2373
  setline(2373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9357 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9358 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9359 = gc_frame_new();
// call case 3: self.outer request
  Object call9360 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9359);
// compiled member node returning call9360 (depth = 5)
  Object call9361 = callmethodflags(call9360, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9358);
// compiled member node returning call9361 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9362 = callmethodflags(call9361, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9357);
// compiled call node returning call9362 (depth = 3)
  struct UserObject *obj9279_uo = (struct UserObject *)obj9279;
  obj9279_uo->super = call9362;
  sourceObject = obj9279;
// Begin line 2374
  setline(2374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9363 == NULL) {
    strlit9363 = alloc_String("return");
    gc_root(strlit9363);
  }
// compiled string node returning strlit9363 (depth = 3)
  adddatum2(obj9279, strlit9363, 1);
  sourceObject = obj9279;
// Begin line 2375
  setline(2375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj9279, *var_expr, 2);
  sourceObject = obj9279;
  sourceObject = obj9279;
  sourceObject = obj9279;
  sourceObject = obj9279;
  sourceObject = obj9279;
  objclass9279 = obj9279->class;
  objclass9279->definitionModule = modulename;
  objclass9279->definitionLine = 2372;
  (*(struct UserObject *)self).data[0] = lowerouter9279;
  self = oldself9279;
  selfslot = oldselfslot9279;
  stackframe = oldstackframe9279;
  gc_frame_end(frame);
  return obj9279;
}
Object meth_ast_returnNode9365(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 45, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "returnNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_returnNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2371
  setline(2371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_returnNode (depth = 3)
  gc_frame_end(frame);
  return *var_returnNode;
}
Object meth_ast_new_40_1_41_scope_40_1_41_9368(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)scope(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new(_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 2408
  setline(2408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9369 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_expr (depth = 5)
  gc_frame_newslot(*var_expr);
// call case 4: self request
  params[0] = *var_expr;
  partcv[0] = 1;
  Object call9370 = callmethodflags(self, "new(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9369);
// compiled call node returning call9370 (depth = 4)
  *var_result = call9370;
  if (call9370 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2409
  setline(2409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9371 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call9372 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9371);
// compiled call node returning call9372 (depth = 3)
// Begin line 2410
  setline(2410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_isLegalInTrait9382(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2421
  setline(2421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9383 = gc_frame_new();
// call case 4: self request
  Object call9384 = callmethodflags(self, "isUse", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9383);
// compiled member node returning call9384 (depth = 3)
  gc_frame_end(frame);
  return call9384;
}
Object meth_ast_isInherits9385(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2422
  setline(2422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9386 = alloc_Boolean(1);
// compiled identifier node returning bool9386 (depth = 3)
  gc_frame_end(frame);
  return bool9386;
}
Object meth_ast_inheritsFromMember9387(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inheritsFromMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2423
  setline(2423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9388 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9389 = gc_frame_new();
// call case 4: self request
  Object call9390 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9389);
// compiled member node returning call9390 (depth = 4)
  Object call9391 = callmethodflags(call9390, "isMember", 0, partcv, params, 0);
  gc_frame_end(callframe9388);
// compiled member node returning call9391 (depth = 3)
  gc_frame_end(frame);
  return call9391;
}
Object meth_ast_inheritsFromCall9392(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inheritsFromCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2424
  setline(2424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9393 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9394 = gc_frame_new();
// call case 4: self request
  Object call9395 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9394);
// compiled member node returning call9395 (depth = 4)
  Object call9396 = callmethodflags(call9395, "isCall", 0, partcv, params, 0);
  gc_frame_end(callframe9393);
// compiled member node returning call9396 (depth = 3)
  gc_frame_end(frame);
  return call9396;
}
Object meth_ast_isExecutable9397(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2425
  setline(2425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9398 = alloc_Boolean(0);
// compiled identifier node returning bool9398 (depth = 3)
  gc_frame_end(frame);
  return bool9398;
}
Object meth_ast__apply_40_1_41_9411(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2431
  setline(2431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9412 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9413 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  Object call9414 = callmethodflags(*var_a, "newName", 0, partcv, params, 0);
  gc_frame_end(callframe9413);
// compiled member node returning call9414 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9415 = callmethodflags(call9414, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9412);
// compiled call node returning call9415 (depth = 6)
// Begin line 2432
  setline(2432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9416 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe9417 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  Object call9418 = callmethodflags(*var_a, "oldName", 0, partcv, params, 0);
  gc_frame_end(callframe9417);
// compiled member node returning call9418 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9419 = callmethodflags(call9418, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9416);
// compiled call node returning call9419 (depth = 6)
  gc_frame_end(frame);
  return call9419;
}
Object meth_ast__apply_40_1_41_9426(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe9427 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_e (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9428 = callmethodflags(*var_e, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9427);
// compiled call node returning call9428 (depth = 6)
  gc_frame_end(frame);
  return call9428;
}
Object meth_ast_accept_40_1_41_from_40_1_41_9399(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2427
  setline(2427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9401 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9402 = callmethodflags(*var_visitor, "visitInherits(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9401);
// compiled call node returning call9402 (depth = 4)
  Object if9400 = done;
  if (istrue(call9402)) {
// Begin line 2428
  setline(2428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9403 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call9404 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9403);
// compiled call node returning call9404 (depth = 5)
  *var_newChain = call9404;
  if (call9404 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2429
  setline(2429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9405 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9406 = gc_frame_new();
// call case 4: self request
  Object call9407 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9406);
// compiled member node returning call9407 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9408 = callmethodflags(call9407, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9405);
// compiled call node returning call9408 (depth = 4)
// Begin line 2430
  setline(2430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9409 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block9410 = alloc_Block(NULL, NULL, "ast", 2430);
  gc_frame_newslot(block9410);
// method "_apply(_)"
  block_savedest(block9410);
  Object closure9411 = createclosure(3, "_apply(1)");
  setclosureframe(closure9411, stackframe);
  addtoclosure(closure9411, var_visitor);
  addtoclosure(closure9411, var_newChain);
  addtoclosure(closure9411, selfslot);
  struct UserObject *uo9411 = (struct UserObject*)block9410;
  uo9411->data[0] = (Object)closure9411;
  Method *meth_meth_ast__apply_40_1_41_9411 = addmethod2pos(block9410, "_apply(1)", &meth_ast__apply_40_1_41_9411, 0);
  int argcv_meth_ast__apply_40_1_41_9411[] = {1};
  meth_meth_ast__apply_40_1_41_9411->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9411);
  meth_meth_ast__apply_40_1_41_9411->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9411->definitionLine = 2981;
// compiled block node returning block9410 (depth = 5)
  gc_frame_newslot(block9410);
// call case 6: other requests
// Begin line 2430
  setline(2430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe9421 = gc_frame_new();
// call case 4: self request
  Object call9422 = callmethodflags(self, "aliases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9421);
// compiled member node returning call9422 (depth = 5)
  params[0] = block9410;
  partcv[0] = 1;
  Object call9423 = callmethodflags(call9422, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9409);
// compiled call node returning call9423 (depth = 4)
// Begin line 2434
  setline(2434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9424 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block9425 = alloc_Block(NULL, NULL, "ast", 2434);
  gc_frame_newslot(block9425);
// method "_apply(_)"
  block_savedest(block9425);
  Object closure9426 = createclosure(3, "_apply(1)");
  setclosureframe(closure9426, stackframe);
  addtoclosure(closure9426, var_visitor);
  addtoclosure(closure9426, var_newChain);
  addtoclosure(closure9426, selfslot);
  struct UserObject *uo9426 = (struct UserObject*)block9425;
  uo9426->data[0] = (Object)closure9426;
  Method *meth_meth_ast__apply_40_1_41_9426 = addmethod2pos(block9425, "_apply(1)", &meth_ast__apply_40_1_41_9426, 0);
  int argcv_meth_ast__apply_40_1_41_9426[] = {1};
  meth_meth_ast__apply_40_1_41_9426->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9426);
  meth_meth_ast__apply_40_1_41_9426->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9426->definitionLine = 2981;
// compiled block node returning block9425 (depth = 5)
  gc_frame_newslot(block9425);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9430 = gc_frame_new();
// call case 4: self request
  Object call9431 = callmethodflags(self, "exclusions", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9430);
// compiled member node returning call9431 (depth = 5)
  params[0] = block9425;
  partcv[0] = 1;
  Object call9432 = callmethodflags(call9431, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9424);
// compiled call node returning call9432 (depth = 4)
    gc_frame_newslot(call9432);
    if9400 = call9432;
  } else {
  }
// compiled if node returning if9400 (depth = 3)
  gc_frame_end(frame);
  return if9400;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_9433(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2441
  setline(2441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9434 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call9435 = callmethodflags(*var_k, "methdec", 0, partcv, params, 0);
  gc_frame_end(callframe9434);
// compiled member node returning call9435 (depth = 3)
  gc_frame_end(frame);
  return call9435;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_9436(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2444
  setline(2444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9437 = gc_frame_new();
// call case 4: self request
  Object call9438 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9437);
// compiled member node returning call9438 (depth = 4)
  *var_n = call9438;
  if (call9438 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2445
  setline(2445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9439 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9440 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9439);
// compiled call node returning call9440 (depth = 4)
  *var_newChain = call9440;
  if (call9440 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2446
  setline(2446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9441 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9442 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9443 = gc_frame_new();
// call case 4: self request
  Object call9444 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9443);
// compiled member node returning call9444 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9445 = callmethodflags(call9444, "map(1)ancestors(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9442);
// compiled call node returning call9445 (depth = 4)
  gc_frame_newslot(call9445);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call9445;
  partcv[0] = 1;
  Object call9446 = callmethodflags(*var_n, "value:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9441);
// compiled call node returning call9446 (depth = 3)
// Begin line 2447
  setline(2447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9447 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9448 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9447);
// compiled call node returning call9448 (depth = 3)
  gc_frame_end(frame);
  return call9448;
}
Object meth_ast__apply_40_1_41_9457(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2452
  setline(2452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9459 == NULL) {
    strlit9459 = alloc_String("  ");
    gc_root(strlit9459);
  }
// compiled string node returning strlit9459 (depth = 7)
  int op_slot_right_9458 = gc_frame_newslot(strlit9459);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_9458 = gc_frame_newslot(*var_spc);
  params[0] = strlit9459;
  partcv[0] = 1;
  Object opresult9461 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult9461 (depth = 6)
  *var_spc = opresult9461;
  if (opresult9461 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_9500(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2458
  setline(2458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9502 == NULL) {
    strlit9502 = alloc_String("");
    gc_root(strlit9502);
  }
// compiled string node returning strlit9502 (depth = 7)
  int op_slot_right_9501 = gc_frame_newslot(strlit9502);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9505 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9506 = callmethodflags(*var_a, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9505);
// compiled call node returning call9506 (depth = 8)
  int op_slot_right_9504 = gc_frame_newslot(call9506);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9509 == NULL) {
    strlit9509 = alloc_String("""\x0a""");
    gc_root(strlit9509);
  }
// compiled string node returning strlit9509 (depth = 9)
  int op_slot_right_9508 = gc_frame_newslot(strlit9509);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_9511 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit9513 == NULL) {
    strlit9513 = alloc_String("");
    gc_root(strlit9513);
  }
// compiled string node returning strlit9513 (depth = 10)
  int op_slot_left_9511 = gc_frame_newslot(strlit9513);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9514 = callmethod(strlit9513, "++(1)", 1, partcv, params);
// compiled op node returning opresult9514 (depth = 9)
  int op_slot_left_9508 = gc_frame_newslot(opresult9514);
  params[0] = strlit9509;
  partcv[0] = 1;
  Object opresult9515 = callmethod(opresult9514, "++(1)", 1, partcv, params);
// compiled op node returning opresult9515 (depth = 8)
  int op_slot_left_9504 = gc_frame_newslot(opresult9515);
  params[0] = call9506;
  partcv[0] = 1;
  Object opresult9516 = callmethod(opresult9515, "++(1)", 1, partcv, params);
// compiled op node returning opresult9516 (depth = 7)
  int op_slot_left_9501 = gc_frame_newslot(opresult9516);
  params[0] = strlit9502;
  partcv[0] = 1;
  Object opresult9517 = callmethod(opresult9516, "++(1)", 1, partcv, params);
// compiled op node returning opresult9517 (depth = 6)
  *var_s = opresult9517;
  if (opresult9517 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_9548(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2462
  setline(2462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9550 == NULL) {
    strlit9550 = alloc_String(" ");
    gc_root(strlit9550);
  }
// compiled string node returning strlit9550 (depth = 7)
  int op_slot_right_9549 = gc_frame_newslot(strlit9550);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_e (depth = 8)
  int op_slot_right_9552 = gc_frame_newslot(*var_e);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9555 == NULL) {
    strlit9555 = alloc_String(" exclude ");
    gc_root(strlit9555);
  }
// compiled string node returning strlit9555 (depth = 9)
  int op_slot_right_9554 = gc_frame_newslot(strlit9555);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_9557 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit9559 == NULL) {
    strlit9559 = alloc_String("");
    gc_root(strlit9559);
  }
// compiled string node returning strlit9559 (depth = 10)
  int op_slot_left_9557 = gc_frame_newslot(strlit9559);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9560 = callmethod(strlit9559, "++(1)", 1, partcv, params);
// compiled op node returning opresult9560 (depth = 9)
  int op_slot_left_9554 = gc_frame_newslot(opresult9560);
  params[0] = strlit9555;
  partcv[0] = 1;
  Object opresult9561 = callmethod(opresult9560, "++(1)", 1, partcv, params);
// compiled op node returning opresult9561 (depth = 8)
  int op_slot_left_9552 = gc_frame_newslot(opresult9561);
  params[0] = *var_e;
  partcv[0] = 1;
  Object opresult9562 = callmethod(opresult9561, "++(1)", 1, partcv, params);
// compiled op node returning opresult9562 (depth = 7)
  int op_slot_left_9549 = gc_frame_newslot(opresult9562);
  params[0] = strlit9550;
  partcv[0] = 1;
  Object opresult9563 = callmethod(opresult9562, "++(1)", 1, partcv, params);
// compiled op node returning opresult9563 (depth = 6)
  *var_s = opresult9563;
  if (opresult9563 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_9449(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2450
  setline(2450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9450 == NULL) {
    strlit9450 = alloc_String("");
    gc_root(strlit9450);
  }
// compiled string node returning strlit9450 (depth = 4)
  *var_spc = strlit9450;
  if (strlit9450 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2451
  setline(2451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9451 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_9452 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num9454 = alloc_Float64(0);
// compiled num node returning num9454 (depth = 5)
  int op_slot_left_9452 = gc_frame_newslot(num9454);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9455 = callmethod(num9454, "..(1)", 1, partcv, params);
// compiled op node returning opresult9455 (depth = 4)
  gc_frame_newslot(opresult9455);
// starting to compile block node (depth = 4)
  Object block9456 = alloc_Block(NULL, NULL, "ast", 2451);
  gc_frame_newslot(block9456);
// method "_apply(_)"
  block_savedest(block9456);
  Object closure9457 = createclosure(2, "_apply(1)");
  setclosureframe(closure9457, stackframe);
  addtoclosure(closure9457, var_spc);
  addtoclosure(closure9457, selfslot);
  struct UserObject *uo9457 = (struct UserObject*)block9456;
  uo9457->data[0] = (Object)closure9457;
  Method *meth_meth_ast__apply_40_1_41_9457 = addmethod2pos(block9456, "_apply(1)", &meth_ast__apply_40_1_41_9457, 0);
  int argcv_meth_ast__apply_40_1_41_9457[] = {1};
  meth_meth_ast__apply_40_1_41_9457->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9457);
  meth_meth_ast__apply_40_1_41_9457->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9457->definitionLine = 2981;
// compiled block node returning block9456 (depth = 4)
  gc_frame_newslot(block9456);
// call case 5: prelude request
  params[0] = opresult9455;
  params[1] = block9456;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9464 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9451);
// compiled call node returning call9464 (depth = 3)
// Begin line 2454
  setline(2454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9465 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9466 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9465);
// compiled call node returning call9466 (depth = 4)
  *var_s = call9466;
  if (call9466 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2455
  setline(2455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9468 = gc_frame_new();
// call case 4: self request
  Object call9469 = callmethodflags(self, "isUse", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9468);
// compiled member node returning call9469 (depth = 4)
  Object if9467 = done;
  if (istrue(call9469)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9471 == NULL) {
    strlit9471 = alloc_String(" (use)");
    gc_root(strlit9471);
  }
// compiled string node returning strlit9471 (depth = 6)
  int op_slot_right_9470 = gc_frame_newslot(strlit9471);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_9473 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 7)
  if (strlit9475 == NULL) {
    strlit9475 = alloc_String("");
    gc_root(strlit9475);
  }
// compiled string node returning strlit9475 (depth = 7)
  int op_slot_left_9473 = gc_frame_newslot(strlit9475);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9476 = callmethod(strlit9475, "++(1)", 1, partcv, params);
// compiled op node returning opresult9476 (depth = 6)
  int op_slot_left_9470 = gc_frame_newslot(opresult9476);
  params[0] = strlit9471;
  partcv[0] = 1;
  Object opresult9477 = callmethod(opresult9476, "++(1)", 1, partcv, params);
// compiled op node returning opresult9477 (depth = 5)
  *var_s = opresult9477;
  if (opresult9477 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9467 = done;
  } else {
  }
// compiled if node returning if9467 (depth = 3)
// Begin line 2456
  setline(2456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9480 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9482 = alloc_Float64(1);
// compiled num node returning num9482 (depth = 7)
  int op_slot_right_9481 = gc_frame_newslot(num9482);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_9481 = gc_frame_newslot(*var_depth);
  params[0] = num9482;
  partcv[0] = 1;
  Object sum9484 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum9484 (depth = 6)
  gc_frame_newslot(sum9484);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9485 = gc_frame_new();
// call case 4: self request
  Object call9486 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9485);
// compiled member node returning call9486 (depth = 6)
  params[0] = sum9484;
  partcv[0] = 1;
  Object call9487 = callmethodflags(call9486, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9480);
// compiled call node returning call9487 (depth = 5)
  int op_slot_right_9479 = gc_frame_newslot(call9487);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_9489 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9492 == NULL) {
    strlit9492 = alloc_String("""\x0a""");
    gc_root(strlit9492);
  }
// compiled string node returning strlit9492 (depth = 7)
  int op_slot_right_9491 = gc_frame_newslot(strlit9492);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9491 = gc_frame_newslot(*var_s);
  params[0] = strlit9492;
  partcv[0] = 1;
  Object opresult9494 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9494 (depth = 6)
  int op_slot_left_9489 = gc_frame_newslot(opresult9494);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9495 = callmethod(opresult9494, "++(1)", 1, partcv, params);
// compiled op node returning opresult9495 (depth = 5)
  int op_slot_left_9479 = gc_frame_newslot(opresult9495);
  params[0] = call9487;
  partcv[0] = 1;
  Object opresult9496 = callmethod(opresult9495, "++(1)", 1, partcv, params);
// compiled op node returning opresult9496 (depth = 4)
  *var_s = opresult9496;
  if (opresult9496 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2457
  setline(2457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9498 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9499 = alloc_Block(NULL, NULL, "ast", 2457);
  gc_frame_newslot(block9499);
// method "_apply(_)"
  block_savedest(block9499);
  Object closure9500 = createclosure(3, "_apply(1)");
  setclosureframe(closure9500, stackframe);
  addtoclosure(closure9500, var_depth);
  addtoclosure(closure9500, var_s);
  addtoclosure(closure9500, selfslot);
  struct UserObject *uo9500 = (struct UserObject*)block9499;
  uo9500->data[0] = (Object)closure9500;
  Method *meth_meth_ast__apply_40_1_41_9500 = addmethod2pos(block9499, "_apply(1)", &meth_ast__apply_40_1_41_9500, 0);
  int argcv_meth_ast__apply_40_1_41_9500[] = {1};
  meth_meth_ast__apply_40_1_41_9500->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9500);
  meth_meth_ast__apply_40_1_41_9500->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9500->definitionLine = 2981;
// compiled block node returning block9499 (depth = 4)
  gc_frame_newslot(block9499);
// call case 6: other requests
// Begin line 2457
  setline(2457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9520 = gc_frame_new();
// call case 4: self request
  Object call9521 = callmethodflags(self, "aliases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9520);
// compiled member node returning call9521 (depth = 4)
  params[0] = block9499;
  partcv[0] = 1;
  Object call9522 = callmethodflags(call9521, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9498);
// compiled call node returning call9522 (depth = 3)
// Begin line 2460
  setline(2460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9524 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9525 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9526 = gc_frame_new();
// call case 4: self request
  Object call9527 = callmethodflags(self, "exclusions", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9526);
// compiled member node returning call9527 (depth = 6)
  Object call9528 = callmethodflags(call9527, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe9525);
// compiled member node returning call9528 (depth = 5)
  Object call9529 = callmethodflags(call9528, "not", 0, partcv, params, 0);
  gc_frame_end(callframe9524);
// compiled member node returning call9529 (depth = 4)
  Object if9523 = done;
  if (istrue(call9529)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9531 == NULL) {
    strlit9531 = alloc_String("");
    gc_root(strlit9531);
  }
// compiled string node returning strlit9531 (depth = 6)
  int op_slot_right_9530 = gc_frame_newslot(strlit9531);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_9533 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9536 == NULL) {
    strlit9536 = alloc_String("""\x0a""");
    gc_root(strlit9536);
  }
// compiled string node returning strlit9536 (depth = 8)
  int op_slot_right_9535 = gc_frame_newslot(strlit9536);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_9538 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit9540 == NULL) {
    strlit9540 = alloc_String("");
    gc_root(strlit9540);
  }
// compiled string node returning strlit9540 (depth = 9)
  int op_slot_left_9538 = gc_frame_newslot(strlit9540);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9541 = callmethod(strlit9540, "++(1)", 1, partcv, params);
// compiled op node returning opresult9541 (depth = 8)
  int op_slot_left_9535 = gc_frame_newslot(opresult9541);
  params[0] = strlit9536;
  partcv[0] = 1;
  Object opresult9542 = callmethod(opresult9541, "++(1)", 1, partcv, params);
// compiled op node returning opresult9542 (depth = 7)
  int op_slot_left_9533 = gc_frame_newslot(opresult9542);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9543 = callmethod(opresult9542, "++(1)", 1, partcv, params);
// compiled op node returning opresult9543 (depth = 6)
  int op_slot_left_9530 = gc_frame_newslot(opresult9543);
  params[0] = strlit9531;
  partcv[0] = 1;
  Object opresult9544 = callmethod(opresult9543, "++(1)", 1, partcv, params);
// compiled op node returning opresult9544 (depth = 5)
  *var_s = opresult9544;
  if (opresult9544 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9523 = done;
  } else {
  }
// compiled if node returning if9523 (depth = 3)
// Begin line 2461
  setline(2461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9546 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9547 = alloc_Block(NULL, NULL, "ast", 2461);
  gc_frame_newslot(block9547);
// method "_apply(_)"
  block_savedest(block9547);
  Object closure9548 = createclosure(2, "_apply(1)");
  setclosureframe(closure9548, stackframe);
  addtoclosure(closure9548, var_s);
  addtoclosure(closure9548, selfslot);
  struct UserObject *uo9548 = (struct UserObject*)block9547;
  uo9548->data[0] = (Object)closure9548;
  Method *meth_meth_ast__apply_40_1_41_9548 = addmethod2pos(block9547, "_apply(1)", &meth_ast__apply_40_1_41_9548, 0);
  int argcv_meth_ast__apply_40_1_41_9548[] = {1};
  meth_meth_ast__apply_40_1_41_9548->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9548);
  meth_meth_ast__apply_40_1_41_9548->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9548->definitionLine = 2981;
// compiled block node returning block9547 (depth = 4)
  gc_frame_newslot(block9547);
// call case 6: other requests
// Begin line 2461
  setline(2461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9566 = gc_frame_new();
// call case 4: self request
  Object call9567 = callmethodflags(self, "exclusions", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9566);
// compiled member node returning call9567 (depth = 4)
  params[0] = block9547;
  partcv[0] = 1;
  Object call9568 = callmethodflags(call9567, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9546);
// compiled call node returning call9568 (depth = 3)
// Begin line 2464
  setline(2464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9570 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9571 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9572 = gc_frame_new();
// call case 4: self request
  Object call9573 = callmethodflags(self, "providedNames", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9572);
// compiled member node returning call9573 (depth = 6)
  Object call9574 = callmethodflags(call9573, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe9571);
// compiled member node returning call9574 (depth = 5)
  Object call9575 = callmethodflags(call9574, "not", 0, partcv, params, 0);
  gc_frame_end(callframe9570);
// compiled member node returning call9575 (depth = 4)
  Object if9569 = done;
  if (istrue(call9575)) {
// Begin line 2465
  setline(2465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9578 == NULL) {
    strlit9578 = alloc_String("");
    gc_root(strlit9578);
  }
// compiled string node returning strlit9578 (depth = 7)
  int op_slot_right_9577 = gc_frame_newslot(strlit9578);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9581 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe9582 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe9583 = gc_frame_new();
// call case 4: self request
  Object call9584 = callmethodflags(self, "providedNames", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9583);
// compiled member node returning call9584 (depth = 10)
  Object call9585 = callmethodflags(call9584, "asList", 0, partcv, params, 0);
  gc_frame_end(callframe9582);
// compiled member node returning call9585 (depth = 9)
  Object call9586 = callmethodflags(call9585, "sort", 0, partcv, params, 0);
  gc_frame_end(callframe9581);
// compiled member node returning call9586 (depth = 8)
  int op_slot_right_9580 = gc_frame_newslot(call9586);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9589 == NULL) {
    strlit9589 = alloc_String("Provided names: ");
    gc_root(strlit9589);
  }
// compiled string node returning strlit9589 (depth = 9)
  int op_slot_right_9588 = gc_frame_newslot(strlit9589);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_9591 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 10)
  if (strlit9593 == NULL) {
    strlit9593 = alloc_String("""\x0a""");
    gc_root(strlit9593);
  }
// compiled string node returning strlit9593 (depth = 10)
  int op_slot_left_9591 = gc_frame_newslot(strlit9593);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9594 = callmethod(strlit9593, "++(1)", 1, partcv, params);
// compiled op node returning opresult9594 (depth = 9)
  int op_slot_left_9588 = gc_frame_newslot(opresult9594);
  params[0] = strlit9589;
  partcv[0] = 1;
  Object opresult9595 = callmethod(opresult9594, "++(1)", 1, partcv, params);
// compiled op node returning opresult9595 (depth = 8)
  int op_slot_left_9580 = gc_frame_newslot(opresult9595);
  params[0] = call9586;
  partcv[0] = 1;
  Object opresult9596 = callmethod(opresult9595, "++(1)", 1, partcv, params);
// compiled op node returning opresult9596 (depth = 7)
  int op_slot_left_9577 = gc_frame_newslot(opresult9596);
  params[0] = strlit9578;
  partcv[0] = 1;
  Object opresult9597 = callmethod(opresult9596, "++(1)", 1, partcv, params);
// compiled op node returning opresult9597 (depth = 6)
  int op_slot_right_9576 = gc_frame_newslot(opresult9597);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9576 = gc_frame_newslot(*var_s);
  params[0] = opresult9597;
  partcv[0] = 1;
  Object opresult9599 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9599 (depth = 5)
  *var_s = opresult9599;
  if (opresult9599 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9569 = done;
  } else {
  }
// compiled if node returning if9569 (depth = 3)
// Begin line 2467
  setline(2467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply9605(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 2472
  setline(2472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9607 == NULL) {
    strlit9607 = alloc_String("    ");
    gc_root(strlit9607);
  }
// compiled string node returning strlit9607 (depth = 7)
  int op_slot_right_9606 = gc_frame_newslot(strlit9607);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9606 = gc_frame_newslot(*var_s);
  params[0] = strlit9607;
  partcv[0] = 1;
  Object opresult9609 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9609 (depth = 6)
  *var_s = opresult9609;
  if (opresult9609 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_9633(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2477
  setline(2477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9635 == NULL) {
    strlit9635 = alloc_String(" ");
    gc_root(strlit9635);
  }
// compiled string node returning strlit9635 (depth = 7)
  int op_slot_right_9634 = gc_frame_newslot(strlit9635);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  int op_slot_right_9637 = gc_frame_newslot(*var_a);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9640 == NULL) {
    strlit9640 = alloc_String(" ");
    gc_root(strlit9640);
  }
// compiled string node returning strlit9640 (depth = 9)
  int op_slot_right_9639 = gc_frame_newslot(strlit9640);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_9642 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit9644 == NULL) {
    strlit9644 = alloc_String("");
    gc_root(strlit9644);
  }
// compiled string node returning strlit9644 (depth = 10)
  int op_slot_left_9642 = gc_frame_newslot(strlit9644);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9645 = callmethod(strlit9644, "++(1)", 1, partcv, params);
// compiled op node returning opresult9645 (depth = 9)
  int op_slot_left_9639 = gc_frame_newslot(opresult9645);
  params[0] = strlit9640;
  partcv[0] = 1;
  Object opresult9646 = callmethod(opresult9645, "++(1)", 1, partcv, params);
// compiled op node returning opresult9646 (depth = 8)
  int op_slot_left_9637 = gc_frame_newslot(opresult9646);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult9647 = callmethod(opresult9646, "++(1)", 1, partcv, params);
// compiled op node returning opresult9647 (depth = 7)
  int op_slot_left_9634 = gc_frame_newslot(opresult9647);
  params[0] = strlit9635;
  partcv[0] = 1;
  Object opresult9648 = callmethod(opresult9647, "++(1)", 1, partcv, params);
// compiled op node returning opresult9648 (depth = 6)
  *var_s = opresult9648;
  if (opresult9648 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_9656(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2480
  setline(2480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9658 == NULL) {
    strlit9658 = alloc_String(" ");
    gc_root(strlit9658);
  }
// compiled string node returning strlit9658 (depth = 7)
  int op_slot_right_9657 = gc_frame_newslot(strlit9658);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe9661 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_e (depth = 9)
  Object call9662 = callmethodflags(*var_e, "nameString", 0, partcv, params, 0);
  gc_frame_end(callframe9661);
// compiled member node returning call9662 (depth = 8)
  int op_slot_right_9660 = gc_frame_newslot(call9662);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9665 == NULL) {
    strlit9665 = alloc_String(" exclude ");
    gc_root(strlit9665);
  }
// compiled string node returning strlit9665 (depth = 9)
  int op_slot_right_9664 = gc_frame_newslot(strlit9665);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_9667 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit9669 == NULL) {
    strlit9669 = alloc_String("");
    gc_root(strlit9669);
  }
// compiled string node returning strlit9669 (depth = 10)
  int op_slot_left_9667 = gc_frame_newslot(strlit9669);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9670 = callmethod(strlit9669, "++(1)", 1, partcv, params);
// compiled op node returning opresult9670 (depth = 9)
  int op_slot_left_9664 = gc_frame_newslot(opresult9670);
  params[0] = strlit9665;
  partcv[0] = 1;
  Object opresult9671 = callmethod(opresult9670, "++(1)", 1, partcv, params);
// compiled op node returning opresult9671 (depth = 8)
  int op_slot_left_9660 = gc_frame_newslot(opresult9671);
  params[0] = call9662;
  partcv[0] = 1;
  Object opresult9672 = callmethod(opresult9671, "++(1)", 1, partcv, params);
// compiled op node returning opresult9672 (depth = 7)
  int op_slot_left_9657 = gc_frame_newslot(opresult9672);
  params[0] = strlit9658;
  partcv[0] = 1;
  Object opresult9673 = callmethod(opresult9672, "++(1)", 1, partcv, params);
// compiled op node returning opresult9673 (depth = 6)
  *var_s = opresult9673;
  if (opresult9673 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_9601(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 2470
  setline(2470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9602 == NULL) {
    strlit9602 = alloc_String("");
    gc_root(strlit9602);
  }
// compiled string node returning strlit9602 (depth = 4)
  *var_s = strlit9602;
  if (strlit9602 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2471
  setline(2471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9603 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 4)
  Object block9604 = alloc_Block(NULL, NULL, "ast", 2471);
  gc_frame_newslot(block9604);
// method "_apply"
  block_savedest(block9604);
  Object closure9605 = createclosure(2, "_apply");
  setclosureframe(closure9605, stackframe);
  addtoclosure(closure9605, var_s);
  addtoclosure(closure9605, selfslot);
  struct UserObject *uo9605 = (struct UserObject*)block9604;
  uo9605->data[0] = (Object)closure9605;
  Method *meth_meth_ast__apply9605 = addmethod2pos(block9604, "_apply", &meth_ast__apply9605, 0);
  int argcv_meth_ast__apply9605[] = {0};
  meth_meth_ast__apply9605->type = alloc_MethodType(1, argcv_meth_ast__apply9605);
  meth_meth_ast__apply9605->definitionModule = modulename;
  meth_meth_ast__apply9605->definitionLine = 2981;
// compiled block node returning block9604 (depth = 4)
  gc_frame_newslot(block9604);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block9604;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9612 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9603);
// compiled call node returning call9612 (depth = 3)
// Begin line 2474
  setline(2474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9615 = gc_frame_new();
// call case 4: self request
  Object call9616 = callmethodflags(self, "isUse", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9615);
// compiled member node returning call9616 (depth = 6)
  Object if9614 = done;
struct StackFrameObject *iftmpstackframe9614 = stackframe;
  if (istrue(call9616)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9614);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 6)
  if (strlit9617 == NULL) {
    strlit9617 = alloc_String("use ");
    gc_root(strlit9617);
  }
// compiled string node returning strlit9617 (depth = 6)
    gc_frame_newslot(strlit9617);
    if9614 = strlit9617;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe9614);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 6)
  if (strlit9618 == NULL) {
    strlit9618 = alloc_String("inherit ");
    gc_root(strlit9618);
  }
// compiled string node returning strlit9618 (depth = 6)
    gc_frame_newslot(strlit9618);
    if9614 = strlit9618;
  }
stackframe = iftmpstackframe9614;
// compiled if node returning if9614 (depth = 5)
  int op_slot_right_9613 = gc_frame_newslot(if9614);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_9613 = gc_frame_newslot(*var_s);
  params[0] = if9614;
  partcv[0] = 1;
  Object opresult9620 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9620 (depth = 4)
  *var_s = opresult9620;
  if (opresult9620 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2475
  setline(2475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9623 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num9624 = alloc_Float64(0);
// compiled num node returning num9624 (depth = 6)
  gc_frame_newslot(num9624);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9625 = gc_frame_new();
// call case 4: self request
  Object call9626 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9625);
// compiled member node returning call9626 (depth = 6)
  params[0] = num9624;
  partcv[0] = 1;
  Object call9627 = callmethodflags(call9626, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9623);
// compiled call node returning call9627 (depth = 5)
  int op_slot_right_9622 = gc_frame_newslot(call9627);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_9622 = gc_frame_newslot(*var_s);
  params[0] = call9627;
  partcv[0] = 1;
  Object opresult9629 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult9629 (depth = 4)
  *var_s = opresult9629;
  if (opresult9629 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2476
  setline(2476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9631 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9632 = alloc_Block(NULL, NULL, "ast", 2476);
  gc_frame_newslot(block9632);
// method "_apply(_)"
  block_savedest(block9632);
  Object closure9633 = createclosure(2, "_apply(1)");
  setclosureframe(closure9633, stackframe);
  addtoclosure(closure9633, var_s);
  addtoclosure(closure9633, selfslot);
  struct UserObject *uo9633 = (struct UserObject*)block9632;
  uo9633->data[0] = (Object)closure9633;
  Method *meth_meth_ast__apply_40_1_41_9633 = addmethod2pos(block9632, "_apply(1)", &meth_ast__apply_40_1_41_9633, 0);
  int argcv_meth_ast__apply_40_1_41_9633[] = {1};
  meth_meth_ast__apply_40_1_41_9633->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9633);
  meth_meth_ast__apply_40_1_41_9633->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9633->definitionLine = 2981;
// compiled block node returning block9632 (depth = 4)
  gc_frame_newslot(block9632);
// call case 6: other requests
// Begin line 2476
  setline(2476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9651 = gc_frame_new();
// call case 4: self request
  Object call9652 = callmethodflags(self, "aliases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9651);
// compiled member node returning call9652 (depth = 4)
  params[0] = block9632;
  partcv[0] = 1;
  Object call9653 = callmethodflags(call9652, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9631);
// compiled call node returning call9653 (depth = 3)
// Begin line 2479
  setline(2479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9654 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9655 = alloc_Block(NULL, NULL, "ast", 2479);
  gc_frame_newslot(block9655);
// method "_apply(_)"
  block_savedest(block9655);
  Object closure9656 = createclosure(2, "_apply(1)");
  setclosureframe(closure9656, stackframe);
  addtoclosure(closure9656, var_s);
  addtoclosure(closure9656, selfslot);
  struct UserObject *uo9656 = (struct UserObject*)block9655;
  uo9656->data[0] = (Object)closure9656;
  Method *meth_meth_ast__apply_40_1_41_9656 = addmethod2pos(block9655, "_apply(1)", &meth_ast__apply_40_1_41_9656, 0);
  int argcv_meth_ast__apply_40_1_41_9656[] = {1};
  meth_meth_ast__apply_40_1_41_9656->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9656);
  meth_meth_ast__apply_40_1_41_9656->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9656->definitionLine = 2981;
// compiled block node returning block9655 (depth = 4)
  gc_frame_newslot(block9655);
// call case 6: other requests
// Begin line 2479
  setline(2479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9676 = gc_frame_new();
// call case 4: self request
  Object call9677 = callmethodflags(self, "exclusions", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9676);
// compiled member node returning call9677 (depth = 4)
  params[0] = block9655;
  partcv[0] = 1;
  Object call9678 = callmethodflags(call9677, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9654);
// compiled call node returning call9678 (depth = 3)
// Begin line 2482
  setline(2482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString9679(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2485
  setline(2485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9681 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num9682 = alloc_Float64(0);
// compiled num node returning num9682 (depth = 5)
  gc_frame_newslot(num9682);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9683 = gc_frame_new();
// call case 4: self request
  Object call9684 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9683);
// compiled member node returning call9684 (depth = 5)
  params[0] = num9682;
  partcv[0] = 1;
  Object call9685 = callmethodflags(call9684, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9681);
// compiled call node returning call9685 (depth = 4)
  int op_slot_right_9680 = gc_frame_newslot(call9685);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9688 = gc_frame_new();
// call case 4: self request
  Object call9689 = callmethodflags(self, "isUse", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9688);
// compiled member node returning call9689 (depth = 5)
  Object if9687 = done;
struct StackFrameObject *iftmpstackframe9687 = stackframe;
  if (istrue(call9689)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9687);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit9690 == NULL) {
    strlit9690 = alloc_String("use ");
    gc_root(strlit9690);
  }
// compiled string node returning strlit9690 (depth = 5)
    gc_frame_newslot(strlit9690);
    if9687 = strlit9690;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe9687);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit9691 == NULL) {
    strlit9691 = alloc_String("inherit ");
    gc_root(strlit9691);
  }
// compiled string node returning strlit9691 (depth = 5)
    gc_frame_newslot(strlit9691);
    if9687 = strlit9691;
  }
stackframe = iftmpstackframe9687;
// compiled if node returning if9687 (depth = 4)
  int op_slot_left_9680 = gc_frame_newslot(if9687);
  params[0] = call9685;
  partcv[0] = 1;
  Object opresult9692 = callmethod(if9687, "++(1)", 1, partcv, params);
// compiled op node returning opresult9692 (depth = 3)
  gc_frame_end(frame);
  return opresult9692;
}
Object meth_ast_nameString9693(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2487
  setline(2487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9694 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num9695 = alloc_Float64(0);
// compiled num node returning num9695 (depth = 4)
  gc_frame_newslot(num9695);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9696 = gc_frame_new();
// call case 4: self request
  Object call9697 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9696);
// compiled member node returning call9697 (depth = 4)
  params[0] = num9695;
  partcv[0] = 1;
  Object call9698 = callmethodflags(call9697, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9694);
// compiled call node returning call9698 (depth = 3)
  gc_frame_end(frame);
  return call9698;
}
Object meth_ast_addAlias_40_1_41_for_40_1_41_9699(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAlias(1)for(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAlias(_)for(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAlias(_)for(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for addAlias(_)for(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_newName = &(stackframe->slots[0]);
  *var_newName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addAlias(_)");
  Object *var_oldName = &(stackframe->slots[1]);
  *var_oldName = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part for(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2489
  setline(2489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9700 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9701 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newName (depth = 5)
  gc_frame_newslot(*var_newName);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_oldName (depth = 5)
  gc_frame_newslot(*var_oldName);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9702 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9703 = gc_frame_new();
// call case 3: self.outer request
  Object call9704 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9703);
// compiled member node returning call9704 (depth = 6)
  Object call9705 = callmethodflags(call9704, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9702);
// compiled member node returning call9705 (depth = 5)
  params[0] = *var_newName;
  params[1] = *var_oldName;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9706 = callmethodflags(call9705, "aliasNew(1)old(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9701);
// compiled call node returning call9706 (depth = 4)
  gc_frame_newslot(call9706);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9707 = gc_frame_new();
// call case 4: self request
  Object call9708 = callmethodflags(self, "aliases", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9707);
// compiled member node returning call9708 (depth = 4)
  params[0] = call9706;
  partcv[0] = 1;
  Object call9709 = callmethodflags(call9708, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9700);
// compiled call node returning call9709 (depth = 3)
  gc_frame_end(frame);
  return call9709;
}
Object meth_ast_addExclusion_40_1_41_9710(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addExclusion(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addExclusion(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addExclusion(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ident = &(stackframe->slots[0]);
  *var_ident = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addExclusion(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2492
  setline(2492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9711 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ident (depth = 4)
  gc_frame_newslot(*var_ident);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9712 = gc_frame_new();
// call case 4: self request
  Object call9713 = callmethodflags(self, "exclusions", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9712);
// compiled member node returning call9713 (depth = 4)
  params[0] = *var_ident;
  partcv[0] = 1;
  Object call9714 = callmethodflags(call9713, "push(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9711);
// compiled call node returning call9714 (depth = 3)
  gc_frame_end(frame);
  return call9714;
}
Object meth_ast_shallowCopy9715(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_inheritsNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2495
  setline(2495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9716 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe9717 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_inheritsNode (depth = 5)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call9718 = callmethodflags(*var_inheritsNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9717);
// compiled call node returning call9718 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9719 = callmethodflags(call9718, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9716);
// compiled call node returning call9719 (depth = 3)
  gc_frame_end(frame);
  return call9719;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_9720(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2498
  setline(2498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9721 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call9722 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9721);
// compiled call node returning call9722 (depth = 3)
// Begin line 2499
  setline(2499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9723 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9724 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call9725 = callmethodflags(*var_other, "providedNames", 0, partcv, params, 0);
  gc_frame_end(callframe9724);
// compiled member node returning call9725 (depth = 4)
  gc_frame_newslot(call9725);
// call case 4: self request
  params[0] = call9725;
  partcv[0] = 1;
  Object call9726 = callmethodflags(self, "providedNames:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9723);
// compiled call node returning call9726 (depth = 3)
// Begin line 2500
  setline(2500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9727 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9728 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call9729 = callmethodflags(*var_other, "aliases", 0, partcv, params, 0);
  gc_frame_end(callframe9728);
// compiled member node returning call9729 (depth = 4)
  gc_frame_newslot(call9729);
// call case 4: self request
  params[0] = call9729;
  partcv[0] = 1;
  Object call9730 = callmethodflags(self, "aliases:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9727);
// compiled call node returning call9730 (depth = 3)
// Begin line 2501
  setline(2501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9731 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9732 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call9733 = callmethodflags(*var_other, "exclusions", 0, partcv, params, 0);
  gc_frame_end(callframe9732);
// compiled member node returning call9733 (depth = 4)
  gc_frame_newslot(call9733);
// call case 4: self request
  params[0] = call9733;
  partcv[0] = 1;
  Object call9734 = callmethodflags(self, "exclusions:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9731);
// compiled call node returning call9734 (depth = 3)
// Begin line 2502
  setline(2502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9735 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe9736 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call9737 = callmethodflags(*var_other, "isUse", 0, partcv, params, 0);
  gc_frame_end(callframe9736);
// compiled member node returning call9737 (depth = 4)
  gc_frame_newslot(call9737);
// call case 4: self request
  params[0] = call9737;
  partcv[0] = 1;
  Object call9738 = callmethodflags(self, "isUse:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9735);
// compiled call node returning call9738 (depth = 3)
// Begin line 2503
  setline(2503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName9739(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2506
  setline(2506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9741 = gc_frame_new();
// call case 4: self request
  Object call9742 = callmethodflags(self, "isUse", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9741);
// compiled member node returning call9742 (depth = 4)
  Object if9740 = done;
  if (istrue(call9742)) {
// starting to compile string node (depth = 4)
  if (strlit9743 == NULL) {
    strlit9743 = alloc_String("use");
    gc_root(strlit9743);
  }
// compiled string node returning strlit9743 (depth = 4)
    gc_frame_newslot(strlit9743);
    if9740 = strlit9743;
  } else {
// starting to compile string node (depth = 4)
  if (strlit9744 == NULL) {
    strlit9744 = alloc_String("inherit");
    gc_root(strlit9744);
  }
// compiled string node returning strlit9744 (depth = 4)
    gc_frame_newslot(strlit9744);
    if9740 = strlit9744;
  }
// compiled if node returning if9740 (depth = 3)
  gc_frame_end(frame);
  return if9740;
}
Object meth_ast_new_40_1_41_9373(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_inheritsNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9374 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9374 = alloc_userobj2(28,24, objclass9374);
  gc_frame_newslot(obj9374);
if (objclass9374 == NULL) {
  glfree(obj9374->class->name);
  obj9374->class->name = "inheritsNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9374, self, 0);
  addmethodreal(obj9374,"outer", &reader_ast_outer_9375);
  Object oldself9374 = self;
  struct StackFrameObject *oldstackframe9374 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9374);
  gc_frame_newslot((Object)stackframe);
  self = obj9374;
  Object *oldselfslot9374 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9374 = (*(struct UserObject *)self).data[0], lowerouter9374 = thisouter9374;
  if (inheritingObject9374) {
    struct UserObject *inho9374 = (struct UserObject *)inheritingObject9374;
    while (inho9374->super != GraceDefaultObject) inho9374 = (struct UserObject *)inho9374->super;
    inho9374->super = obj9374;
    self = inheritingObject9374;
    *selfslot = self;
    lowerouter9374 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9374;
  }
if (objclass9374 == NULL) {
  Method *reader9376 = addmethodrealflags(obj9374, "kind",&reader_ast_kind_9376, MFLAG_DEF);
  reader9376->definitionModule = modulename;
  reader9376->definitionLine = 2414;
}
adddatum2(obj9374, alloc_Undefined(), 1);
if (objclass9374 == NULL) {
  Method *reader9377 = addmethodrealflags(obj9374, "value", &reader_ast_value_9377, 0);
  Method *writer9377 = addmethodrealflags(obj9374, "value:=(1)", &writer_ast_value_9377, 0);
  reader9377->definitionModule = modulename;
  writer9377->definitionModule = modulename;
  reader9377->definitionLine = 2415;
  writer9377->definitionLine = 2415;
}
obj9374->flags |= OFLAG_MUTABLE;
adddatum2(obj9374, alloc_Undefined(), 2);
if (objclass9374 == NULL) {
  Method *reader9378 = addmethodrealflags(obj9374, "providedNames", &reader_ast_providedNames_9378, 0);
  Method *writer9378 = addmethodrealflags(obj9374, "providedNames:=(1)", &writer_ast_providedNames_9378, 0);
  reader9378->definitionModule = modulename;
  writer9378->definitionModule = modulename;
  reader9378->definitionLine = 2416;
  writer9378->definitionLine = 2416;
}
obj9374->flags |= OFLAG_MUTABLE;
adddatum2(obj9374, alloc_Undefined(), 3);
if (objclass9374 == NULL) {
  Method *reader9379 = addmethodrealflags(obj9374, "aliases", &reader_ast_aliases_9379, 0);
  Method *writer9379 = addmethodrealflags(obj9374, "aliases:=(1)", &writer_ast_aliases_9379, 0);
  reader9379->definitionModule = modulename;
  writer9379->definitionModule = modulename;
  reader9379->definitionLine = 2417;
  writer9379->definitionLine = 2417;
}
obj9374->flags |= OFLAG_MUTABLE;
adddatum2(obj9374, alloc_Undefined(), 4);
if (objclass9374 == NULL) {
  Method *reader9380 = addmethodrealflags(obj9374, "exclusions", &reader_ast_exclusions_9380, 0);
  Method *writer9380 = addmethodrealflags(obj9374, "exclusions:=(1)", &writer_ast_exclusions_9380, 0);
  reader9380->definitionModule = modulename;
  writer9380->definitionModule = modulename;
  reader9380->definitionLine = 2418;
  writer9380->definitionLine = 2418;
}
obj9374->flags |= OFLAG_MUTABLE;
adddatum2(obj9374, alloc_Undefined(), 5);
if (objclass9374 == NULL) {
  Method *reader9381 = addmethodrealflags(obj9374, "isUse", &reader_ast_isUse_9381, 0);
  Method *writer9381 = addmethodrealflags(obj9374, "isUse:=(1)", &writer_ast_isUse_9381, 0);
  reader9381->definitionModule = modulename;
  writer9381->definitionModule = modulename;
  reader9381->definitionLine = 2419;
  writer9381->definitionLine = 2419;
}
obj9374->flags |= OFLAG_MUTABLE;
adddatum2(obj9374, alloc_Undefined(), 6);
// method "isLegalInTrait"
  struct UserObject *uo9382 = (struct UserObject*)obj9374;
  uo9382->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait9382 = addmethod2pos(obj9374, "isLegalInTrait", &meth_ast_isLegalInTrait9382, 7);
  int argcv_meth_ast_isLegalInTrait9382[] = {0};
  meth_meth_ast_isLegalInTrait9382->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait9382);
  meth_meth_ast_isLegalInTrait9382->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait9382->definitionLine = 2421;
// method "isInherits"
  struct UserObject *uo9385 = (struct UserObject*)obj9374;
  uo9385->data[8] = emptyclosure;
  Method *meth_meth_ast_isInherits9385 = addmethod2pos(obj9374, "isInherits", &meth_ast_isInherits9385, 8);
  int argcv_meth_ast_isInherits9385[] = {0};
  meth_meth_ast_isInherits9385->type = alloc_MethodType(1, argcv_meth_ast_isInherits9385);
  meth_meth_ast_isInherits9385->definitionModule = modulename;
  meth_meth_ast_isInherits9385->definitionLine = 2422;
// method "inheritsFromMember"
  struct UserObject *uo9387 = (struct UserObject*)obj9374;
  uo9387->data[9] = emptyclosure;
  Method *meth_meth_ast_inheritsFromMember9387 = addmethod2pos(obj9374, "inheritsFromMember", &meth_ast_inheritsFromMember9387, 9);
  int argcv_meth_ast_inheritsFromMember9387[] = {0};
  meth_meth_ast_inheritsFromMember9387->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromMember9387);
  meth_meth_ast_inheritsFromMember9387->definitionModule = modulename;
  meth_meth_ast_inheritsFromMember9387->definitionLine = 2423;
// method "inheritsFromCall"
  struct UserObject *uo9392 = (struct UserObject*)obj9374;
  uo9392->data[10] = emptyclosure;
  Method *meth_meth_ast_inheritsFromCall9392 = addmethod2pos(obj9374, "inheritsFromCall", &meth_ast_inheritsFromCall9392, 10);
  int argcv_meth_ast_inheritsFromCall9392[] = {0};
  meth_meth_ast_inheritsFromCall9392->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromCall9392);
  meth_meth_ast_inheritsFromCall9392->definitionModule = modulename;
  meth_meth_ast_inheritsFromCall9392->definitionLine = 2424;
// method "isExecutable"
  struct UserObject *uo9397 = (struct UserObject*)obj9374;
  uo9397->data[11] = emptyclosure;
  Method *meth_meth_ast_isExecutable9397 = addmethod2pos(obj9374, "isExecutable", &meth_ast_isExecutable9397, 11);
  int argcv_meth_ast_isExecutable9397[] = {0};
  meth_meth_ast_isExecutable9397->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9397);
  meth_meth_ast_isExecutable9397->definitionModule = modulename;
  meth_meth_ast_isExecutable9397->definitionLine = 2425;
// method "accept(_)from(_)"
  struct UserObject *uo9399 = (struct UserObject*)obj9374;
  uo9399->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9399 = addmethod2pos(obj9374, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9399, 12);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9399[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9399->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9399);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9399->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9399->definitionLine = 2426;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj9374);
  Object closure9433 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure9433, stackframe);
  addtoclosure(closure9433, var_k);
  struct UserObject *uo9433 = (struct UserObject*)obj9374;
  uo9433->data[13] = (Object)closure9433;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_9433 = addmethod2pos(obj9374, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_9433, 13);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_9433[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9433->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_9433);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9433->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9433->definitionLine = 2437;
// method "map(_)ancestors(_)"
  struct UserObject *uo9436 = (struct UserObject*)obj9374;
  uo9436->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9436 = addmethod2pos(obj9374, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9436, 14);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9436[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9436->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9436);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9436->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9436->definitionLine = 2443;
// method "pretty(_)"
  struct UserObject *uo9449 = (struct UserObject*)obj9374;
  uo9449->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_9449 = addmethod2pos(obj9374, "pretty(1)", &meth_ast_pretty_40_1_41_9449, 15);
  int argcv_meth_ast_pretty_40_1_41_9449[] = {1};
  meth_meth_ast_pretty_40_1_41_9449->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_9449);
  meth_meth_ast_pretty_40_1_41_9449->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_9449->definitionLine = 2449;
// method "toGrace(_)"
  struct UserObject *uo9601 = (struct UserObject*)obj9374;
  uo9601->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9601 = addmethod2pos(obj9374, "toGrace(1)", &meth_ast_toGrace_40_1_41_9601, 16);
  int argcv_meth_ast_toGrace_40_1_41_9601[] = {1};
  meth_meth_ast_toGrace_40_1_41_9601->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9601);
meth_meth_ast_toGrace_40_1_41_9601->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9601->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9601->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9601->definitionLine = 2469;
// method "asString"
  struct UserObject *uo9679 = (struct UserObject*)obj9374;
  uo9679->data[17] = emptyclosure;
  Method *meth_meth_ast_asString9679 = addmethod2pos(obj9374, "asString", &meth_ast_asString9679, 17);
  int argcv_meth_ast_asString9679[] = {0};
  meth_meth_ast_asString9679->type = alloc_MethodType(1, argcv_meth_ast_asString9679);
  meth_meth_ast_asString9679->definitionModule = modulename;
  meth_meth_ast_asString9679->definitionLine = 2484;
// method "nameString"
  struct UserObject *uo9693 = (struct UserObject*)obj9374;
  uo9693->data[18] = emptyclosure;
  Method *meth_meth_ast_nameString9693 = addmethod2pos(obj9374, "nameString", &meth_ast_nameString9693, 18);
  int argcv_meth_ast_nameString9693[] = {0};
  meth_meth_ast_nameString9693->type = alloc_MethodType(1, argcv_meth_ast_nameString9693);
  meth_meth_ast_nameString9693->definitionModule = modulename;
  meth_meth_ast_nameString9693->definitionLine = 2487;
// method "addAlias(_)for(_)"
  struct UserObject *uo9699 = (struct UserObject*)obj9374;
  uo9699->data[19] = emptyclosure;
  Method *meth_meth_ast_addAlias_40_1_41_for_40_1_41_9699 = addmethod2pos(obj9374, "addAlias(1)for(1)", &meth_ast_addAlias_40_1_41_for_40_1_41_9699, 19);
  int argcv_meth_ast_addAlias_40_1_41_for_40_1_41_9699[] = {1, 1};
  meth_meth_ast_addAlias_40_1_41_for_40_1_41_9699->type = alloc_MethodType(2, argcv_meth_ast_addAlias_40_1_41_for_40_1_41_9699);
  meth_meth_ast_addAlias_40_1_41_for_40_1_41_9699->definitionModule = modulename;
  meth_meth_ast_addAlias_40_1_41_for_40_1_41_9699->definitionLine = 2488;
// method "addExclusion(_)"
  struct UserObject *uo9710 = (struct UserObject*)obj9374;
  uo9710->data[20] = emptyclosure;
  Method *meth_meth_ast_addExclusion_40_1_41_9710 = addmethod2pos(obj9374, "addExclusion(1)", &meth_ast_addExclusion_40_1_41_9710, 20);
  int argcv_meth_ast_addExclusion_40_1_41_9710[] = {1};
  meth_meth_ast_addExclusion_40_1_41_9710->type = alloc_MethodType(1, argcv_meth_ast_addExclusion_40_1_41_9710);
  meth_meth_ast_addExclusion_40_1_41_9710->definitionModule = modulename;
  meth_meth_ast_addExclusion_40_1_41_9710->definitionLine = 2491;
// method "shallowCopy"
  block_savedest(obj9374);
  Object closure9715 = createclosure(2, "shallowCopy");
  setclosureframe(closure9715, stackframe);
  addtoclosure(closure9715, var_nullNode);
  addtoclosure(closure9715, var_inheritsNode);
  struct UserObject *uo9715 = (struct UserObject*)obj9374;
  uo9715->data[21] = (Object)closure9715;
  Method *meth_meth_ast_shallowCopy9715 = addmethod2pos(obj9374, "shallowCopy", &meth_ast_shallowCopy9715, 21);
  int argcv_meth_ast_shallowCopy9715[] = {0};
  meth_meth_ast_shallowCopy9715->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9715);
  meth_meth_ast_shallowCopy9715->definitionModule = modulename;
  meth_meth_ast_shallowCopy9715->definitionLine = 2494;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo9720 = (struct UserObject*)obj9374;
  uo9720->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_9720 = addmethod2pos(obj9374, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_9720, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_9720[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_9720->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_9720);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_9720->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_9720->definitionLine = 2497;
// method "statementName"
  struct UserObject *uo9739 = (struct UserObject*)obj9374;
  uo9739->data[23] = emptyclosure;
  Method *meth_meth_ast_statementName9739 = addmethod2pos(obj9374, "statementName", &meth_ast_statementName9739, 23);
  int argcv_meth_ast_statementName9739[] = {0};
  meth_meth_ast_statementName9739->type = alloc_MethodType(1, argcv_meth_ast_statementName9739);
  meth_meth_ast_statementName9739->definitionModule = modulename;
  meth_meth_ast_statementName9739->definitionLine = 2505;
  sourceObject = obj9374;
// Begin line 2413
  setline(2413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9745 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9746 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9747 = gc_frame_new();
// call case 3: self.outer request
  Object call9748 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9747);
// compiled member node returning call9748 (depth = 5)
  Object call9749 = callmethodflags(call9748, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9746);
// compiled member node returning call9749 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9750 = callmethodflags(call9749, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9745);
// compiled call node returning call9750 (depth = 3)
  struct UserObject *obj9374_uo = (struct UserObject *)obj9374;
  obj9374_uo->super = call9750;
  sourceObject = obj9374;
// Begin line 2414
  setline(2414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9751 == NULL) {
    strlit9751 = alloc_String("inherits");
    gc_root(strlit9751);
  }
// compiled string node returning strlit9751 (depth = 3)
  adddatum2(obj9374, strlit9751, 1);
  sourceObject = obj9374;
// Begin line 2415
  setline(2415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj9374, *var_expr, 2);
  sourceObject = obj9374;
// Begin line 2416
  setline(2416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9752 = gc_frame_new();
// call case 5: prelude request
  Object call9753 = callmethodflags(prelude, "emptySet", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9752);
// compiled member node returning call9753 (depth = 3)
  adddatum2(obj9374, call9753, 3);
  sourceObject = obj9374;
// Begin line 2417
  setline(2417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9754 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9754 (depth = 3)
  adddatum2(obj9374, array9754, 4);
  sourceObject = obj9374;
// Begin line 2418
  setline(2418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9755 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9755 (depth = 3)
  adddatum2(obj9374, array9755, 5);
  sourceObject = obj9374;
// Begin line 2419
  setline(2419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9756 = alloc_Boolean(0);
// compiled identifier node returning bool9756 (depth = 3)
  adddatum2(obj9374, bool9756, 6);
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  objclass9374 = obj9374->class;
  objclass9374->definitionModule = modulename;
  objclass9374->definitionLine = 2412;
  (*(struct UserObject *)self).data[0] = lowerouter9374;
  self = oldself9374;
  selfslot = oldselfslot9374;
  stackframe = oldstackframe9374;
  gc_frame_end(frame);
  return obj9374;
}
Object meth_ast_new_40_1_41_9373_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_inheritsNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9374 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9374 = alloc_userobj2(28,24, objclass9374);
  gc_frame_newslot(obj9374);
if (objclass9374 == NULL) {
  glfree(obj9374->class->name);
  obj9374->class->name = "inheritsNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9374, self, 0);
  addmethodreal(obj9374,"outer", &reader_ast_outer_9375);
  Object oldself9374 = self;
  struct StackFrameObject *oldstackframe9374 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9374);
  gc_frame_newslot((Object)stackframe);
  self = obj9374;
  Object *oldselfslot9374 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9374 = (*(struct UserObject *)self).data[0], lowerouter9374 = thisouter9374;
  if (inheritingObject9374) {
    struct UserObject *inho9374 = (struct UserObject *)inheritingObject9374;
    while (inho9374->super != GraceDefaultObject) inho9374 = (struct UserObject *)inho9374->super;
    inho9374->super = obj9374;
    self = inheritingObject9374;
    *selfslot = self;
    lowerouter9374 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9374;
  }
if (objclass9374 == NULL) {
  Method *reader9376 = addmethodrealflags(obj9374, "kind",&reader_ast_kind_9376, MFLAG_DEF);
  reader9376->definitionModule = modulename;
  reader9376->definitionLine = 2414;
}
adddatum2(obj9374, alloc_Undefined(), 1);
if (objclass9374 == NULL) {
  Method *reader9377 = addmethodrealflags(obj9374, "value", &reader_ast_value_9377, 0);
  Method *writer9377 = addmethodrealflags(obj9374, "value:=(1)", &writer_ast_value_9377, 0);
  reader9377->definitionModule = modulename;
  writer9377->definitionModule = modulename;
  reader9377->definitionLine = 2415;
  writer9377->definitionLine = 2415;
}
obj9374->flags |= OFLAG_MUTABLE;
adddatum2(obj9374, alloc_Undefined(), 2);
if (objclass9374 == NULL) {
  Method *reader9378 = addmethodrealflags(obj9374, "providedNames", &reader_ast_providedNames_9378, 0);
  Method *writer9378 = addmethodrealflags(obj9374, "providedNames:=(1)", &writer_ast_providedNames_9378, 0);
  reader9378->definitionModule = modulename;
  writer9378->definitionModule = modulename;
  reader9378->definitionLine = 2416;
  writer9378->definitionLine = 2416;
}
obj9374->flags |= OFLAG_MUTABLE;
adddatum2(obj9374, alloc_Undefined(), 3);
if (objclass9374 == NULL) {
  Method *reader9379 = addmethodrealflags(obj9374, "aliases", &reader_ast_aliases_9379, 0);
  Method *writer9379 = addmethodrealflags(obj9374, "aliases:=(1)", &writer_ast_aliases_9379, 0);
  reader9379->definitionModule = modulename;
  writer9379->definitionModule = modulename;
  reader9379->definitionLine = 2417;
  writer9379->definitionLine = 2417;
}
obj9374->flags |= OFLAG_MUTABLE;
adddatum2(obj9374, alloc_Undefined(), 4);
if (objclass9374 == NULL) {
  Method *reader9380 = addmethodrealflags(obj9374, "exclusions", &reader_ast_exclusions_9380, 0);
  Method *writer9380 = addmethodrealflags(obj9374, "exclusions:=(1)", &writer_ast_exclusions_9380, 0);
  reader9380->definitionModule = modulename;
  writer9380->definitionModule = modulename;
  reader9380->definitionLine = 2418;
  writer9380->definitionLine = 2418;
}
obj9374->flags |= OFLAG_MUTABLE;
adddatum2(obj9374, alloc_Undefined(), 5);
if (objclass9374 == NULL) {
  Method *reader9381 = addmethodrealflags(obj9374, "isUse", &reader_ast_isUse_9381, 0);
  Method *writer9381 = addmethodrealflags(obj9374, "isUse:=(1)", &writer_ast_isUse_9381, 0);
  reader9381->definitionModule = modulename;
  writer9381->definitionModule = modulename;
  reader9381->definitionLine = 2419;
  writer9381->definitionLine = 2419;
}
obj9374->flags |= OFLAG_MUTABLE;
adddatum2(obj9374, alloc_Undefined(), 6);
// method "isLegalInTrait"
  struct UserObject *uo9382 = (struct UserObject*)obj9374;
  uo9382->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait9382 = addmethod2pos(obj9374, "isLegalInTrait", &meth_ast_isLegalInTrait9382, 7);
  int argcv_meth_ast_isLegalInTrait9382[] = {0};
  meth_meth_ast_isLegalInTrait9382->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait9382);
  meth_meth_ast_isLegalInTrait9382->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait9382->definitionLine = 2421;
// method "isInherits"
  struct UserObject *uo9385 = (struct UserObject*)obj9374;
  uo9385->data[8] = emptyclosure;
  Method *meth_meth_ast_isInherits9385 = addmethod2pos(obj9374, "isInherits", &meth_ast_isInherits9385, 8);
  int argcv_meth_ast_isInherits9385[] = {0};
  meth_meth_ast_isInherits9385->type = alloc_MethodType(1, argcv_meth_ast_isInherits9385);
  meth_meth_ast_isInherits9385->definitionModule = modulename;
  meth_meth_ast_isInherits9385->definitionLine = 2422;
// method "inheritsFromMember"
  struct UserObject *uo9387 = (struct UserObject*)obj9374;
  uo9387->data[9] = emptyclosure;
  Method *meth_meth_ast_inheritsFromMember9387 = addmethod2pos(obj9374, "inheritsFromMember", &meth_ast_inheritsFromMember9387, 9);
  int argcv_meth_ast_inheritsFromMember9387[] = {0};
  meth_meth_ast_inheritsFromMember9387->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromMember9387);
  meth_meth_ast_inheritsFromMember9387->definitionModule = modulename;
  meth_meth_ast_inheritsFromMember9387->definitionLine = 2423;
// method "inheritsFromCall"
  struct UserObject *uo9392 = (struct UserObject*)obj9374;
  uo9392->data[10] = emptyclosure;
  Method *meth_meth_ast_inheritsFromCall9392 = addmethod2pos(obj9374, "inheritsFromCall", &meth_ast_inheritsFromCall9392, 10);
  int argcv_meth_ast_inheritsFromCall9392[] = {0};
  meth_meth_ast_inheritsFromCall9392->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromCall9392);
  meth_meth_ast_inheritsFromCall9392->definitionModule = modulename;
  meth_meth_ast_inheritsFromCall9392->definitionLine = 2424;
// method "isExecutable"
  struct UserObject *uo9397 = (struct UserObject*)obj9374;
  uo9397->data[11] = emptyclosure;
  Method *meth_meth_ast_isExecutable9397 = addmethod2pos(obj9374, "isExecutable", &meth_ast_isExecutable9397, 11);
  int argcv_meth_ast_isExecutable9397[] = {0};
  meth_meth_ast_isExecutable9397->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9397);
  meth_meth_ast_isExecutable9397->definitionModule = modulename;
  meth_meth_ast_isExecutable9397->definitionLine = 2425;
// method "accept(_)from(_)"
  struct UserObject *uo9399 = (struct UserObject*)obj9374;
  uo9399->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9399 = addmethod2pos(obj9374, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9399, 12);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9399[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9399->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9399);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9399->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9399->definitionLine = 2426;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj9374);
  Object closure9433 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure9433, stackframe);
  addtoclosure(closure9433, var_k);
  struct UserObject *uo9433 = (struct UserObject*)obj9374;
  uo9433->data[13] = (Object)closure9433;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_9433 = addmethod2pos(obj9374, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_9433, 13);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_9433[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9433->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_9433);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9433->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9433->definitionLine = 2437;
// method "map(_)ancestors(_)"
  struct UserObject *uo9436 = (struct UserObject*)obj9374;
  uo9436->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9436 = addmethod2pos(obj9374, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9436, 14);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9436[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9436->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9436);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9436->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9436->definitionLine = 2443;
// method "pretty(_)"
  struct UserObject *uo9449 = (struct UserObject*)obj9374;
  uo9449->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_9449 = addmethod2pos(obj9374, "pretty(1)", &meth_ast_pretty_40_1_41_9449, 15);
  int argcv_meth_ast_pretty_40_1_41_9449[] = {1};
  meth_meth_ast_pretty_40_1_41_9449->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_9449);
  meth_meth_ast_pretty_40_1_41_9449->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_9449->definitionLine = 2449;
// method "toGrace(_)"
  struct UserObject *uo9601 = (struct UserObject*)obj9374;
  uo9601->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9601 = addmethod2pos(obj9374, "toGrace(1)", &meth_ast_toGrace_40_1_41_9601, 16);
  int argcv_meth_ast_toGrace_40_1_41_9601[] = {1};
  meth_meth_ast_toGrace_40_1_41_9601->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9601);
meth_meth_ast_toGrace_40_1_41_9601->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9601->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9601->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9601->definitionLine = 2469;
// method "asString"
  struct UserObject *uo9679 = (struct UserObject*)obj9374;
  uo9679->data[17] = emptyclosure;
  Method *meth_meth_ast_asString9679 = addmethod2pos(obj9374, "asString", &meth_ast_asString9679, 17);
  int argcv_meth_ast_asString9679[] = {0};
  meth_meth_ast_asString9679->type = alloc_MethodType(1, argcv_meth_ast_asString9679);
  meth_meth_ast_asString9679->definitionModule = modulename;
  meth_meth_ast_asString9679->definitionLine = 2484;
// method "nameString"
  struct UserObject *uo9693 = (struct UserObject*)obj9374;
  uo9693->data[18] = emptyclosure;
  Method *meth_meth_ast_nameString9693 = addmethod2pos(obj9374, "nameString", &meth_ast_nameString9693, 18);
  int argcv_meth_ast_nameString9693[] = {0};
  meth_meth_ast_nameString9693->type = alloc_MethodType(1, argcv_meth_ast_nameString9693);
  meth_meth_ast_nameString9693->definitionModule = modulename;
  meth_meth_ast_nameString9693->definitionLine = 2487;
// method "addAlias(_)for(_)"
  struct UserObject *uo9699 = (struct UserObject*)obj9374;
  uo9699->data[19] = emptyclosure;
  Method *meth_meth_ast_addAlias_40_1_41_for_40_1_41_9699 = addmethod2pos(obj9374, "addAlias(1)for(1)", &meth_ast_addAlias_40_1_41_for_40_1_41_9699, 19);
  int argcv_meth_ast_addAlias_40_1_41_for_40_1_41_9699[] = {1, 1};
  meth_meth_ast_addAlias_40_1_41_for_40_1_41_9699->type = alloc_MethodType(2, argcv_meth_ast_addAlias_40_1_41_for_40_1_41_9699);
  meth_meth_ast_addAlias_40_1_41_for_40_1_41_9699->definitionModule = modulename;
  meth_meth_ast_addAlias_40_1_41_for_40_1_41_9699->definitionLine = 2488;
// method "addExclusion(_)"
  struct UserObject *uo9710 = (struct UserObject*)obj9374;
  uo9710->data[20] = emptyclosure;
  Method *meth_meth_ast_addExclusion_40_1_41_9710 = addmethod2pos(obj9374, "addExclusion(1)", &meth_ast_addExclusion_40_1_41_9710, 20);
  int argcv_meth_ast_addExclusion_40_1_41_9710[] = {1};
  meth_meth_ast_addExclusion_40_1_41_9710->type = alloc_MethodType(1, argcv_meth_ast_addExclusion_40_1_41_9710);
  meth_meth_ast_addExclusion_40_1_41_9710->definitionModule = modulename;
  meth_meth_ast_addExclusion_40_1_41_9710->definitionLine = 2491;
// method "shallowCopy"
  block_savedest(obj9374);
  Object closure9715 = createclosure(2, "shallowCopy");
  setclosureframe(closure9715, stackframe);
  addtoclosure(closure9715, var_nullNode);
  addtoclosure(closure9715, var_inheritsNode);
  struct UserObject *uo9715 = (struct UserObject*)obj9374;
  uo9715->data[21] = (Object)closure9715;
  Method *meth_meth_ast_shallowCopy9715 = addmethod2pos(obj9374, "shallowCopy", &meth_ast_shallowCopy9715, 21);
  int argcv_meth_ast_shallowCopy9715[] = {0};
  meth_meth_ast_shallowCopy9715->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9715);
  meth_meth_ast_shallowCopy9715->definitionModule = modulename;
  meth_meth_ast_shallowCopy9715->definitionLine = 2494;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo9720 = (struct UserObject*)obj9374;
  uo9720->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_9720 = addmethod2pos(obj9374, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_9720, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_9720[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_9720->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_9720);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_9720->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_9720->definitionLine = 2497;
// method "statementName"
  struct UserObject *uo9739 = (struct UserObject*)obj9374;
  uo9739->data[23] = emptyclosure;
  Method *meth_meth_ast_statementName9739 = addmethod2pos(obj9374, "statementName", &meth_ast_statementName9739, 23);
  int argcv_meth_ast_statementName9739[] = {0};
  meth_meth_ast_statementName9739->type = alloc_MethodType(1, argcv_meth_ast_statementName9739);
  meth_meth_ast_statementName9739->definitionModule = modulename;
  meth_meth_ast_statementName9739->definitionLine = 2505;
  sourceObject = obj9374;
// Begin line 2413
  setline(2413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9745 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9746 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9747 = gc_frame_new();
// call case 3: self.outer request
  Object call9748 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9747);
// compiled member node returning call9748 (depth = 5)
  Object call9749 = callmethodflags(call9748, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9746);
// compiled member node returning call9749 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9750 = callmethodflags(call9749, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9745);
// compiled call node returning call9750 (depth = 3)
  struct UserObject *obj9374_uo = (struct UserObject *)obj9374;
  obj9374_uo->super = call9750;
  sourceObject = obj9374;
// Begin line 2414
  setline(2414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9751 == NULL) {
    strlit9751 = alloc_String("inherits");
    gc_root(strlit9751);
  }
// compiled string node returning strlit9751 (depth = 3)
  adddatum2(obj9374, strlit9751, 1);
  sourceObject = obj9374;
// Begin line 2415
  setline(2415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj9374, *var_expr, 2);
  sourceObject = obj9374;
// Begin line 2416
  setline(2416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9752 = gc_frame_new();
// call case 5: prelude request
  Object call9753 = callmethodflags(prelude, "emptySet", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9752);
// compiled member node returning call9753 (depth = 3)
  adddatum2(obj9374, call9753, 3);
  sourceObject = obj9374;
// Begin line 2417
  setline(2417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9754 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9754 (depth = 3)
  adddatum2(obj9374, array9754, 4);
  sourceObject = obj9374;
// Begin line 2418
  setline(2418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9755 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9755 (depth = 3)
  adddatum2(obj9374, array9755, 5);
  sourceObject = obj9374;
// Begin line 2419
  setline(2419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9756 = alloc_Boolean(0);
// compiled identifier node returning bool9756 (depth = 3)
  adddatum2(obj9374, bool9756, 6);
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  sourceObject = obj9374;
  objclass9374 = obj9374->class;
  objclass9374->definitionModule = modulename;
  objclass9374->definitionLine = 2412;
  (*(struct UserObject *)self).data[0] = lowerouter9374;
  self = oldself9374;
  selfslot = oldselfslot9374;
  stackframe = oldstackframe9374;
  gc_frame_end(frame);
  return obj9374;
}
Object meth_ast_inheritsNode9758(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 46, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritsNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_inheritsNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2406
  setline(2406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_inheritsNode (depth = 3)
  gc_frame_end(frame);
  return *var_inheritsNode;
}
Object meth_ast_AliasPair9761(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 47, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "AliasPair");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_AliasPair = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2510
  setline(2510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_AliasPair (depth = 3)
  gc_frame_end(frame);
  return *var_AliasPair;
}
Object meth_ast_isExecutable9769(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2539
  setline(2539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9770 = alloc_Boolean(0);
// compiled identifier node returning bool9770 (depth = 3)
  gc_frame_end(frame);
  return bool9770;
}
Object meth_ast_accept_40_1_41_from_40_1_41_9771(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2543
  setline(2543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9772 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9773 = callmethodflags(*var_visitor, "visitBlank(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9772);
// compiled call node returning call9773 (depth = 3)
  gc_frame_end(frame);
  return call9773;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_9774(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2546
  setline(2546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9775 = gc_frame_new();
// call case 4: self request
  Object call9776 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9775);
// compiled member node returning call9776 (depth = 4)
  *var_n = call9776;
  if (call9776 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2547
  setline(2547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9777 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9778 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9777);
// compiled call node returning call9778 (depth = 4)
  *var_newChain = call9778;
  if (call9778 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2548
  setline(2548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9779 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9780 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9779);
// compiled call node returning call9780 (depth = 3)
  gc_frame_end(frame);
  return call9780;
}
Object meth_ast_nameString9781(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2550
  setline(2550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9782 == NULL) {
    strlit9782 = alloc_String("");
    gc_root(strlit9782);
  }
// compiled string node returning strlit9782 (depth = 3)
  gc_frame_end(frame);
  return strlit9782;
}
Object meth_ast_asString9783(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2551
  setline(2551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9784 == NULL) {
    strlit9784 = alloc_String("blank");
    gc_root(strlit9784);
  }
// compiled string node returning strlit9784 (depth = 3)
  gc_frame_end(frame);
  return strlit9784;
}
Object meth_ast_toGrace_40_1_41_9785(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2552
  setline(2552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9786 == NULL) {
    strlit9786 = alloc_String("");
    gc_root(strlit9786);
  }
// compiled string node returning strlit9786 (depth = 3)
  gc_frame_end(frame);
  return strlit9786;
}
Object meth_ast_shallowCopy9787(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2554
  setline(2554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9788 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9789 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blankNode (depth = 5)
  Object call9790 = callmethodflags(*var_blankNode, "new", 0, partcv, params, 0);
  gc_frame_end(callframe9789);
// compiled member node returning call9790 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9791 = callmethodflags(call9790, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9788);
// compiled call node returning call9791 (depth = 3)
  gc_frame_end(frame);
  return call9791;
}
Object meth_ast_new9764(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9765 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9765 = alloc_userobj2(9,10, objclass9765);
  gc_frame_newslot(obj9765);
if (objclass9765 == NULL) {
  glfree(obj9765->class->name);
  obj9765->class->name = "blankNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9765, self, 0);
  addmethodreal(obj9765,"outer", &reader_ast_outer_9766);
  Object oldself9765 = self;
  struct StackFrameObject *oldstackframe9765 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9765);
  gc_frame_newslot((Object)stackframe);
  self = obj9765;
  Object *oldselfslot9765 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9765 = (*(struct UserObject *)self).data[0], lowerouter9765 = thisouter9765;
  if (inheritingObject9765) {
    struct UserObject *inho9765 = (struct UserObject *)inheritingObject9765;
    while (inho9765->super != GraceDefaultObject) inho9765 = (struct UserObject *)inho9765->super;
    inho9765->super = obj9765;
    self = inheritingObject9765;
    *selfslot = self;
    lowerouter9765 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9765;
  }
if (objclass9765 == NULL) {
  Method *reader9767 = addmethodrealflags(obj9765, "kind",&reader_ast_kind_9767, MFLAG_DEF);
  reader9767->definitionModule = modulename;
  reader9767->definitionLine = 2537;
}
adddatum2(obj9765, alloc_Undefined(), 1);
if (objclass9765 == NULL) {
  Method *reader9768 = addmethodrealflags(obj9765, "value",&reader_ast_value_9768, MFLAG_DEF);
  reader9768->definitionModule = modulename;
  reader9768->definitionLine = 2538;
}
adddatum2(obj9765, alloc_Undefined(), 2);
// method "isExecutable"
  struct UserObject *uo9769 = (struct UserObject*)obj9765;
  uo9769->data[3] = emptyclosure;
  Method *meth_meth_ast_isExecutable9769 = addmethod2pos(obj9765, "isExecutable", &meth_ast_isExecutable9769, 3);
  int argcv_meth_ast_isExecutable9769[] = {0};
  meth_meth_ast_isExecutable9769->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9769);
  meth_meth_ast_isExecutable9769->definitionModule = modulename;
  meth_meth_ast_isExecutable9769->definitionLine = 2539;
// method "accept(_)from(_)"
  struct UserObject *uo9771 = (struct UserObject*)obj9765;
  uo9771->data[4] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9771 = addmethod2pos(obj9765, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9771, 4);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9771[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9771->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9771);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9771->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9771->definitionLine = 2542;
// method "map(_)ancestors(_)"
  struct UserObject *uo9774 = (struct UserObject*)obj9765;
  uo9774->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9774 = addmethod2pos(obj9765, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9774, 5);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9774[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9774->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9774);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9774->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9774->definitionLine = 2545;
// method "nameString"
  struct UserObject *uo9781 = (struct UserObject*)obj9765;
  uo9781->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString9781 = addmethod2pos(obj9765, "nameString", &meth_ast_nameString9781, 6);
  int argcv_meth_ast_nameString9781[] = {0};
  meth_meth_ast_nameString9781->type = alloc_MethodType(1, argcv_meth_ast_nameString9781);
  meth_meth_ast_nameString9781->definitionModule = modulename;
  meth_meth_ast_nameString9781->definitionLine = 2550;
// method "asString"
  struct UserObject *uo9783 = (struct UserObject*)obj9765;
  uo9783->data[7] = emptyclosure;
  Method *meth_meth_ast_asString9783 = addmethod2pos(obj9765, "asString", &meth_ast_asString9783, 7);
  int argcv_meth_ast_asString9783[] = {0};
  meth_meth_ast_asString9783->type = alloc_MethodType(1, argcv_meth_ast_asString9783);
  meth_meth_ast_asString9783->definitionModule = modulename;
  meth_meth_ast_asString9783->definitionLine = 2551;
// method "toGrace(_)"
  struct UserObject *uo9785 = (struct UserObject*)obj9765;
  uo9785->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9785 = addmethod2pos(obj9765, "toGrace(1)", &meth_ast_toGrace_40_1_41_9785, 8);
  int argcv_meth_ast_toGrace_40_1_41_9785[] = {1};
  meth_meth_ast_toGrace_40_1_41_9785->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9785);
meth_meth_ast_toGrace_40_1_41_9785->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9785->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9785->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9785->definitionLine = 2552;
// method "shallowCopy"
  block_savedest(obj9765);
  Object closure9787 = createclosure(1, "shallowCopy");
  setclosureframe(closure9787, stackframe);
  addtoclosure(closure9787, var_blankNode);
  struct UserObject *uo9787 = (struct UserObject*)obj9765;
  uo9787->data[9] = (Object)closure9787;
  Method *meth_meth_ast_shallowCopy9787 = addmethod2pos(obj9765, "shallowCopy", &meth_ast_shallowCopy9787, 9);
  int argcv_meth_ast_shallowCopy9787[] = {0};
  meth_meth_ast_shallowCopy9787->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9787);
  meth_meth_ast_shallowCopy9787->definitionModule = modulename;
  meth_meth_ast_shallowCopy9787->definitionLine = 2553;
  sourceObject = obj9765;
// Begin line 2536
  setline(2536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9792 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9793 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9794 = gc_frame_new();
// call case 3: self.outer request
  Object call9795 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9794);
// compiled member node returning call9795 (depth = 5)
  Object call9796 = callmethodflags(call9795, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9793);
// compiled member node returning call9796 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9797 = callmethodflags(call9796, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9792);
// compiled call node returning call9797 (depth = 3)
  struct UserObject *obj9765_uo = (struct UserObject *)obj9765;
  obj9765_uo->super = call9797;
  sourceObject = obj9765;
// Begin line 2537
  setline(2537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9798 == NULL) {
    strlit9798 = alloc_String("blank");
    gc_root(strlit9798);
  }
// compiled string node returning strlit9798 (depth = 3)
  adddatum2(obj9765, strlit9798, 1);
  sourceObject = obj9765;
// Begin line 2538
  setline(2538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9799 == NULL) {
    strlit9799 = alloc_String("blank");
    gc_root(strlit9799);
  }
// compiled string node returning strlit9799 (depth = 3)
  adddatum2(obj9765, strlit9799, 2);
  sourceObject = obj9765;
  sourceObject = obj9765;
  sourceObject = obj9765;
  sourceObject = obj9765;
  sourceObject = obj9765;
  sourceObject = obj9765;
  sourceObject = obj9765;
  objclass9765 = obj9765->class;
  objclass9765->definitionModule = modulename;
  objclass9765->definitionLine = 2535;
  (*(struct UserObject *)self).data[0] = lowerouter9765;
  self = oldself9765;
  selfslot = oldselfslot9765;
  stackframe = oldstackframe9765;
  gc_frame_end(frame);
  return obj9765;
}
Object meth_ast_new9764_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9765 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9765 = alloc_userobj2(9,10, objclass9765);
  gc_frame_newslot(obj9765);
if (objclass9765 == NULL) {
  glfree(obj9765->class->name);
  obj9765->class->name = "blankNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9765, self, 0);
  addmethodreal(obj9765,"outer", &reader_ast_outer_9766);
  Object oldself9765 = self;
  struct StackFrameObject *oldstackframe9765 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9765);
  gc_frame_newslot((Object)stackframe);
  self = obj9765;
  Object *oldselfslot9765 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9765 = (*(struct UserObject *)self).data[0], lowerouter9765 = thisouter9765;
  if (inheritingObject9765) {
    struct UserObject *inho9765 = (struct UserObject *)inheritingObject9765;
    while (inho9765->super != GraceDefaultObject) inho9765 = (struct UserObject *)inho9765->super;
    inho9765->super = obj9765;
    self = inheritingObject9765;
    *selfslot = self;
    lowerouter9765 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9765;
  }
if (objclass9765 == NULL) {
  Method *reader9767 = addmethodrealflags(obj9765, "kind",&reader_ast_kind_9767, MFLAG_DEF);
  reader9767->definitionModule = modulename;
  reader9767->definitionLine = 2537;
}
adddatum2(obj9765, alloc_Undefined(), 1);
if (objclass9765 == NULL) {
  Method *reader9768 = addmethodrealflags(obj9765, "value",&reader_ast_value_9768, MFLAG_DEF);
  reader9768->definitionModule = modulename;
  reader9768->definitionLine = 2538;
}
adddatum2(obj9765, alloc_Undefined(), 2);
// method "isExecutable"
  struct UserObject *uo9769 = (struct UserObject*)obj9765;
  uo9769->data[3] = emptyclosure;
  Method *meth_meth_ast_isExecutable9769 = addmethod2pos(obj9765, "isExecutable", &meth_ast_isExecutable9769, 3);
  int argcv_meth_ast_isExecutable9769[] = {0};
  meth_meth_ast_isExecutable9769->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9769);
  meth_meth_ast_isExecutable9769->definitionModule = modulename;
  meth_meth_ast_isExecutable9769->definitionLine = 2539;
// method "accept(_)from(_)"
  struct UserObject *uo9771 = (struct UserObject*)obj9765;
  uo9771->data[4] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9771 = addmethod2pos(obj9765, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9771, 4);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9771[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9771->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9771);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9771->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9771->definitionLine = 2542;
// method "map(_)ancestors(_)"
  struct UserObject *uo9774 = (struct UserObject*)obj9765;
  uo9774->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9774 = addmethod2pos(obj9765, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9774, 5);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9774[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9774->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9774);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9774->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9774->definitionLine = 2545;
// method "nameString"
  struct UserObject *uo9781 = (struct UserObject*)obj9765;
  uo9781->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString9781 = addmethod2pos(obj9765, "nameString", &meth_ast_nameString9781, 6);
  int argcv_meth_ast_nameString9781[] = {0};
  meth_meth_ast_nameString9781->type = alloc_MethodType(1, argcv_meth_ast_nameString9781);
  meth_meth_ast_nameString9781->definitionModule = modulename;
  meth_meth_ast_nameString9781->definitionLine = 2550;
// method "asString"
  struct UserObject *uo9783 = (struct UserObject*)obj9765;
  uo9783->data[7] = emptyclosure;
  Method *meth_meth_ast_asString9783 = addmethod2pos(obj9765, "asString", &meth_ast_asString9783, 7);
  int argcv_meth_ast_asString9783[] = {0};
  meth_meth_ast_asString9783->type = alloc_MethodType(1, argcv_meth_ast_asString9783);
  meth_meth_ast_asString9783->definitionModule = modulename;
  meth_meth_ast_asString9783->definitionLine = 2551;
// method "toGrace(_)"
  struct UserObject *uo9785 = (struct UserObject*)obj9765;
  uo9785->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_9785 = addmethod2pos(obj9765, "toGrace(1)", &meth_ast_toGrace_40_1_41_9785, 8);
  int argcv_meth_ast_toGrace_40_1_41_9785[] = {1};
  meth_meth_ast_toGrace_40_1_41_9785->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_9785);
meth_meth_ast_toGrace_40_1_41_9785->type->types[0] = type_Number;
meth_meth_ast_toGrace_40_1_41_9785->type->names[0] = "depth";
  meth_meth_ast_toGrace_40_1_41_9785->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_9785->definitionLine = 2552;
// method "shallowCopy"
  block_savedest(obj9765);
  Object closure9787 = createclosure(1, "shallowCopy");
  setclosureframe(closure9787, stackframe);
  addtoclosure(closure9787, var_blankNode);
  struct UserObject *uo9787 = (struct UserObject*)obj9765;
  uo9787->data[9] = (Object)closure9787;
  Method *meth_meth_ast_shallowCopy9787 = addmethod2pos(obj9765, "shallowCopy", &meth_ast_shallowCopy9787, 9);
  int argcv_meth_ast_shallowCopy9787[] = {0};
  meth_meth_ast_shallowCopy9787->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9787);
  meth_meth_ast_shallowCopy9787->definitionModule = modulename;
  meth_meth_ast_shallowCopy9787->definitionLine = 2553;
  sourceObject = obj9765;
// Begin line 2536
  setline(2536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9792 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9793 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9794 = gc_frame_new();
// call case 3: self.outer request
  Object call9795 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9794);
// compiled member node returning call9795 (depth = 5)
  Object call9796 = callmethodflags(call9795, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9793);
// compiled member node returning call9796 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9797 = callmethodflags(call9796, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9792);
// compiled call node returning call9797 (depth = 3)
  struct UserObject *obj9765_uo = (struct UserObject *)obj9765;
  obj9765_uo->super = call9797;
  sourceObject = obj9765;
// Begin line 2537
  setline(2537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9798 == NULL) {
    strlit9798 = alloc_String("blank");
    gc_root(strlit9798);
  }
// compiled string node returning strlit9798 (depth = 3)
  adddatum2(obj9765, strlit9798, 1);
  sourceObject = obj9765;
// Begin line 2538
  setline(2538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9799 == NULL) {
    strlit9799 = alloc_String("blank");
    gc_root(strlit9799);
  }
// compiled string node returning strlit9799 (depth = 3)
  adddatum2(obj9765, strlit9799, 2);
  sourceObject = obj9765;
  sourceObject = obj9765;
  sourceObject = obj9765;
  sourceObject = obj9765;
  sourceObject = obj9765;
  sourceObject = obj9765;
  sourceObject = obj9765;
  objclass9765 = obj9765->class;
  objclass9765->definitionModule = modulename;
  objclass9765->definitionLine = 2535;
  (*(struct UserObject *)self).data[0] = lowerouter9765;
  self = oldself9765;
  selfslot = oldselfslot9765;
  stackframe = oldstackframe9765;
  gc_frame_end(frame);
  return obj9765;
}
Object meth_ast_blankNode9801(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 48, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blankNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2534
  setline(2534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blankNode (depth = 3)
  gc_frame_end(frame);
  return *var_blankNode;
}
Object meth_ast_new9804(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2560
  setline(2560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9805 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9806 == NULL) {
    strlit9806 = alloc_String("");
    gc_root(strlit9806);
  }
// compiled string node returning strlit9806 (depth = 4)
  gc_frame_newslot(strlit9806);
// starting to compile array node (depth = 4)
  Object array9807 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9807 (depth = 4)
  gc_frame_newslot(array9807);
// call case 4: self request
  params[0] = strlit9806;
  params[1] = array9807;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9808 = callmethodflags(self, "partName(1)params(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9805);
// compiled call node returning call9808 (depth = 3)
  gc_frame_end(frame);
  return call9808;
}
Object meth_ast_partName_40_1_41_scope_40_1_41_9809(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "partName(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)scope(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for partName(_)scope(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part partName(_)");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 2563
  setline(2563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9810 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile array node (depth = 5)
  Object array9811 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9811 (depth = 5)
  gc_frame_newslot(array9811);
// call case 4: self request
  params[0] = *var_n;
  params[1] = array9811;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9812 = callmethodflags(self, "partName(1)params(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9810);
// compiled call node returning call9812 (depth = 4)
  *var_result = call9812;
  if (call9812 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2564
  setline(2564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9813 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call9814 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9813);
// compiled call node returning call9814 (depth = 3)
// Begin line 2565
  setline(2565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_partName_40_1_41_params_40_1_41_scope_40_1_41_9815(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "partName(1)params(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)params(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)params(_)scope(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)params(_)scope(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for partName(_)params(_)scope(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part partName(_)");
  Object *var_ps = &(stackframe->slots[1]);
  *var_ps = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part params(_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 2568
  setline(2568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9816 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ps (depth = 5)
  gc_frame_newslot(*var_ps);
// call case 4: self request
  params[0] = *var_n;
  params[1] = *var_ps;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9817 = callmethodflags(self, "partName(1)params(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9816);
// compiled call node returning call9817 (depth = 4)
  *var_result = call9817;
  if (call9817 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2569
  setline(2569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9818 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call9819 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9818);
// compiled call node returning call9819 (depth = 3)
// Begin line 2570
  setline(2570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_partName_40_1_41_9820(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "partName(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for partName(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part partName(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2573
  setline(2573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9821 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile array node (depth = 4)
  Object array9822 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9822 (depth = 4)
  gc_frame_newslot(array9822);
// call case 4: self request
  params[0] = *var_n;
  params[1] = array9822;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9823 = callmethodflags(self, "partName(1)params(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9821);
// compiled call node returning call9823 (depth = 3)
  gc_frame_end(frame);
  return call9823;
}
Object meth_ast_nameString9832(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2584
  setline(2584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9834 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9835 = gc_frame_new();
// call case 4: self request
  Object call9836 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9835);
// compiled member node returning call9836 (depth = 5)
  Object call9837 = callmethodflags(call9836, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe9834);
// compiled member node returning call9837 (depth = 4)
  Object if9833 = done;
  if (istrue(call9837)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9838 = gc_frame_new();
// call case 4: self request
  Object call9839 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9838);
// compiled member node returning call9839 (depth = 5)
  return call9839;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9833 = undefined;
  } else {
  }
// compiled if node returning if9833 (depth = 3)
// Begin line 2585
  setline(2585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9841 == NULL) {
    strlit9841 = alloc_String(")");
    gc_root(strlit9841);
  }
// compiled string node returning strlit9841 (depth = 4)
  int op_slot_right_9840 = gc_frame_newslot(strlit9841);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9844 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9845 = gc_frame_new();
// call case 4: self request
  Object call9846 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9845);
// compiled member node returning call9846 (depth = 6)
  Object call9847 = callmethodflags(call9846, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9844);
// compiled member node returning call9847 (depth = 5)
  int op_slot_right_9843 = gc_frame_newslot(call9847);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9850 == NULL) {
    strlit9850 = alloc_String("(");
    gc_root(strlit9850);
  }
// compiled string node returning strlit9850 (depth = 6)
  int op_slot_right_9849 = gc_frame_newslot(strlit9850);
// starting to compile member node (depth = 6)
  int callframe9852 = gc_frame_new();
// call case 4: self request
  Object call9853 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9852);
// compiled member node returning call9853 (depth = 6)
  int op_slot_left_9849 = gc_frame_newslot(call9853);
  params[0] = strlit9850;
  partcv[0] = 1;
  Object opresult9854 = callmethod(call9853, "++(1)", 1, partcv, params);
// compiled op node returning opresult9854 (depth = 5)
  int op_slot_left_9843 = gc_frame_newslot(opresult9854);
  params[0] = call9847;
  partcv[0] = 1;
  Object opresult9855 = callmethod(opresult9854, "++(1)", 1, partcv, params);
// compiled op node returning opresult9855 (depth = 4)
  int op_slot_left_9840 = gc_frame_newslot(opresult9855);
  params[0] = strlit9841;
  partcv[0] = 1;
  Object opresult9856 = callmethod(opresult9855, "++(1)", 1, partcv, params);
// compiled op node returning opresult9856 (depth = 3)
  gc_frame_end(frame);
  return opresult9856;
}
Object meth_ast_numParams9857(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "numParams");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2587
  setline(2587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9858 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe9859 = gc_frame_new();
// call case 4: self request
  Object call9860 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9859);
// compiled member node returning call9860 (depth = 4)
  Object call9861 = callmethodflags(call9860, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9858);
// compiled member node returning call9861 (depth = 3)
  gc_frame_end(frame);
  return call9861;
}
Object meth_ast__apply_40_1_41_9877(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_underScores = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___3 = &(stackframe->slots[0]);
  *var___3 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9879 == NULL) {
    strlit9879 = alloc_String("_");
    gc_root(strlit9879);
  }
// compiled string node returning strlit9879 (depth = 7)
  int op_slot_right_9878 = gc_frame_newslot(strlit9879);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_underScores (depth = 7)
  int op_slot_left_9878 = gc_frame_newslot(*var_underScores);
  params[0] = strlit9879;
  partcv[0] = 1;
  Object opresult9881 = callmethod(*var_underScores, "++(1)", 1, partcv, params);
// compiled op node returning opresult9881 (depth = 6)
  *var_underScores = opresult9881;
  if (opresult9881 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply9885(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_underScores = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9887 == NULL) {
    strlit9887 = alloc_String(",");
    gc_root(strlit9887);
  }
// compiled string node returning strlit9887 (depth = 7)
  int op_slot_right_9886 = gc_frame_newslot(strlit9887);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_underScores (depth = 7)
  int op_slot_left_9886 = gc_frame_newslot(*var_underScores);
  params[0] = strlit9887;
  partcv[0] = 1;
  Object opresult9889 = callmethod(*var_underScores, "++(1)", 1, partcv, params);
// compiled op node returning opresult9889 (depth = 6)
  *var_underScores = opresult9889;
  if (opresult9889 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_canonicalName9862(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_underScores = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "underScores");
// Begin line 2589
  setline(2589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9865 = alloc_Float64(0);
// compiled num node returning num9865 (depth = 5)
  int op_slot_right_9864 = gc_frame_newslot(num9865);
// starting to compile member node (depth = 5)
  int callframe9867 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9868 = gc_frame_new();
// call case 4: self request
  Object call9869 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9868);
// compiled member node returning call9869 (depth = 6)
  Object call9870 = callmethodflags(call9869, "size", 0, partcv, params, 0);
  gc_frame_end(callframe9867);
// compiled member node returning call9870 (depth = 5)
  int op_slot_left_9864 = gc_frame_newslot(call9870);
  params[0] = num9865;
  partcv[0] = 1;
  Object opresult9871 = callmethod(call9870, "==(1)", 1, partcv, params);
// compiled op node returning opresult9871 (depth = 4)
  Object if9863 = done;
  if (istrue(opresult9871)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe9872 = gc_frame_new();
// call case 4: self request
  Object call9873 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9872);
// compiled member node returning call9873 (depth = 5)
  return call9873;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9863 = undefined;
  } else {
  }
// compiled if node returning if9863 (depth = 3)
// Begin line 2590
  setline(2590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9874 == NULL) {
    strlit9874 = alloc_String("");
    gc_root(strlit9874);
  }
// compiled string node returning strlit9874 (depth = 4)
  *var_underScores = strlit9874;
  if (strlit9874 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2591
  setline(2591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9875 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9876 = alloc_Block(NULL, NULL, "ast", 2591);
  gc_frame_newslot(block9876);
// method "_apply(_)"
  block_savedest(block9876);
  Object closure9877 = createclosure(2, "_apply(1)");
  setclosureframe(closure9877, stackframe);
  addtoclosure(closure9877, var_underScores);
  addtoclosure(closure9877, selfslot);
  struct UserObject *uo9877 = (struct UserObject*)block9876;
  uo9877->data[0] = (Object)closure9877;
  Method *meth_meth_ast__apply_40_1_41_9877 = addmethod2pos(block9876, "_apply(1)", &meth_ast__apply_40_1_41_9877, 0);
  int argcv_meth_ast__apply_40_1_41_9877[] = {1};
  meth_meth_ast__apply_40_1_41_9877->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9877);
  meth_meth_ast__apply_40_1_41_9877->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9877->definitionLine = 2981;
// compiled block node returning block9876 (depth = 4)
  gc_frame_newslot(block9876);
// Begin line 2592
  setline(2592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block9884 = alloc_Block(NULL, NULL, "ast", 2592);
  gc_frame_newslot(block9884);
// method "_apply"
  block_savedest(block9884);
  Object closure9885 = createclosure(2, "_apply");
  setclosureframe(closure9885, stackframe);
  addtoclosure(closure9885, var_underScores);
  addtoclosure(closure9885, selfslot);
  struct UserObject *uo9885 = (struct UserObject*)block9884;
  uo9885->data[0] = (Object)closure9885;
  Method *meth_meth_ast__apply9885 = addmethod2pos(block9884, "_apply", &meth_ast__apply9885, 0);
  int argcv_meth_ast__apply9885[] = {0};
  meth_meth_ast__apply9885->type = alloc_MethodType(1, argcv_meth_ast__apply9885);
  meth_meth_ast__apply9885->definitionModule = modulename;
  meth_meth_ast__apply9885->definitionLine = 2981;
// compiled block node returning block9884 (depth = 4)
  gc_frame_newslot(block9884);
// call case 6: other requests
// Begin line 2591
  setline(2591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe9892 = gc_frame_new();
// call case 4: self request
  Object call9893 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9892);
// compiled member node returning call9893 (depth = 4)
  params[0] = block9876;
  params[1] = block9884;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9894 = callmethodflags(call9893, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9875);
// compiled call node returning call9894 (depth = 3)
// Begin line 2593
  setline(2593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9896 == NULL) {
    strlit9896 = alloc_String(")");
    gc_root(strlit9896);
  }
// compiled string node returning strlit9896 (depth = 4)
  int op_slot_right_9895 = gc_frame_newslot(strlit9896);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_underScores (depth = 5)
  int op_slot_right_9898 = gc_frame_newslot(*var_underScores);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9901 == NULL) {
    strlit9901 = alloc_String("(");
    gc_root(strlit9901);
  }
// compiled string node returning strlit9901 (depth = 6)
  int op_slot_right_9900 = gc_frame_newslot(strlit9901);
// starting to compile member node (depth = 6)
  int callframe9903 = gc_frame_new();
// call case 4: self request
  Object call9904 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9903);
// compiled member node returning call9904 (depth = 6)
  int op_slot_left_9900 = gc_frame_newslot(call9904);
  params[0] = strlit9901;
  partcv[0] = 1;
  Object opresult9905 = callmethod(call9904, "++(1)", 1, partcv, params);
// compiled op node returning opresult9905 (depth = 5)
  int op_slot_left_9898 = gc_frame_newslot(opresult9905);
  params[0] = *var_underScores;
  partcv[0] = 1;
  Object opresult9906 = callmethod(opresult9905, "++(1)", 1, partcv, params);
// compiled op node returning opresult9906 (depth = 4)
  int op_slot_left_9895 = gc_frame_newslot(opresult9906);
  params[0] = strlit9896;
  partcv[0] = 1;
  Object opresult9907 = callmethod(opresult9906, "++(1)", 1, partcv, params);
// compiled op node returning opresult9907 (depth = 3)
  gc_frame_end(frame);
  return opresult9907;
}
Object meth_ast__apply_40_1_41_9916(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe9917 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9918 = callmethodflags(*var_p, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9917);
// compiled call node returning call9918 (depth = 6)
  gc_frame_end(frame);
  return call9918;
}
Object meth_ast_accept_40_1_41_from_40_1_41_9908(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2597
  setline(2597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9910 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9911 = callmethodflags(*var_visitor, "visitSignaturePart(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9910);
// compiled call node returning call9911 (depth = 4)
  Object if9909 = done;
  if (istrue(call9911)) {
// Begin line 2598
  setline(2598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9912 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call9913 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9912);
// compiled call node returning call9913 (depth = 5)
  *var_newChain = call9913;
  if (call9913 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2599
  setline(2599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9914 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block9915 = alloc_Block(NULL, NULL, "ast", 2599);
  gc_frame_newslot(block9915);
// method "_apply(_)"
  block_savedest(block9915);
  Object closure9916 = createclosure(3, "_apply(1)");
  setclosureframe(closure9916, stackframe);
  addtoclosure(closure9916, var_visitor);
  addtoclosure(closure9916, var_newChain);
  addtoclosure(closure9916, selfslot);
  struct UserObject *uo9916 = (struct UserObject*)block9915;
  uo9916->data[0] = (Object)closure9916;
  Method *meth_meth_ast__apply_40_1_41_9916 = addmethod2pos(block9915, "_apply(1)", &meth_ast__apply_40_1_41_9916, 0);
  int argcv_meth_ast__apply_40_1_41_9916[] = {1};
  meth_meth_ast__apply_40_1_41_9916->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9916);
  meth_meth_ast__apply_40_1_41_9916->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9916->definitionLine = 2981;
// compiled block node returning block9915 (depth = 5)
  gc_frame_newslot(block9915);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9920 = gc_frame_new();
// call case 4: self request
  Object call9921 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9920);
// compiled member node returning call9921 (depth = 5)
  params[0] = block9915;
  partcv[0] = 1;
  Object call9922 = callmethodflags(call9921, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9914);
// compiled call node returning call9922 (depth = 4)
// Begin line 2600
  setline(2600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9925 = gc_frame_new();
// call case 4: self request
  Object call9926 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9925);
// compiled member node returning call9926 (depth = 6)
  int op_slot_right_9924 = gc_frame_newslot(call9926);
// starting to compile identifier node (depth = 6)
  Object bool9928 = alloc_Boolean(0);
// compiled identifier node returning bool9928 (depth = 6)
  int op_slot_left_9924 = gc_frame_newslot(bool9928);
  params[0] = call9926;
  partcv[0] = 1;
  Object opresult9929 = callmethod(bool9928, "≠(1)", 1, partcv, params);
// compiled op node returning opresult9929 (depth = 5)
  Object if9923 = done;
  if (istrue(opresult9929)) {
// Begin line 2601
  setline(2601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9930 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9931 = gc_frame_new();
// call case 4: self request
  Object call9932 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9931);
// compiled member node returning call9932 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9933 = callmethodflags(call9932, "accept(1)from(1)", 2, partcv, params, 0);
  gc_frame_end(callframe9930);
// compiled call node returning call9933 (depth = 5)
    gc_frame_newslot(call9933);
    if9923 = call9933;
  } else {
  }
// compiled if node returning if9923 (depth = 4)
    gc_frame_newslot(if9923);
    if9909 = if9923;
  } else {
  }
// compiled if node returning if9909 (depth = 3)
  gc_frame_end(frame);
  return if9909;
}
Object meth_ast_declarationKindWithAncestors_40_1_41_9934(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors(_)");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part declarationKindWithAncestors(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2605
  setline(2605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe9935 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  Object call9936 = callmethodflags(*var_k, "parameter", 0, partcv, params, 0);
  gc_frame_end(callframe9935);
// compiled member node returning call9936 (depth = 3)
  gc_frame_end(frame);
  return call9936;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_9937(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_nd = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nd");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2607
  setline(2607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe9938 = gc_frame_new();
// call case 4: self request
  Object call9939 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9938);
// compiled member node returning call9939 (depth = 4)
  *var_nd = call9939;
  if (call9939 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2608
  setline(2608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9940 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nd (depth = 5)
  gc_frame_newslot(*var_nd);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_nd;
  partcv[0] = 1;
  Object call9941 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9940);
// compiled call node returning call9941 (depth = 4)
  *var_newChain = call9941;
  if (call9941 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2609
  setline(2609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9942 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9943 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9944 = gc_frame_new();
// call case 4: self request
  Object call9945 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9944);
// compiled member node returning call9945 (depth = 5)
  gc_frame_newslot(call9945);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9946 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9947 = gc_frame_new();
// call case 3: self.outer request
  Object call9948 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9947);
// compiled member node returning call9948 (depth = 6)
  Object call9949 = callmethodflags(call9948, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9946);
// compiled member node returning call9949 (depth = 5)
  params[0] = call9945;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9950 = callmethodflags(call9949, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9943);
// compiled call node returning call9950 (depth = 4)
  gc_frame_newslot(call9950);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  params[0] = call9950;
  partcv[0] = 1;
  Object call9951 = callmethodflags(*var_nd, "params:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9942);
// compiled call node returning call9951 (depth = 3)
// Begin line 2610
  setline(2610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9952 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9953 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe9954 = gc_frame_new();
// call case 4: self request
  Object call9955 = callmethodflags(self, "typeParams", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9954);
// compiled member node returning call9955 (depth = 5)
  gc_frame_newslot(call9955);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe9956 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe9957 = gc_frame_new();
// call case 3: self.outer request
  Object call9958 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9957);
// compiled member node returning call9958 (depth = 6)
  Object call9959 = callmethodflags(call9958, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe9956);
// compiled member node returning call9959 (depth = 5)
  params[0] = call9955;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9960 = callmethodflags(call9959, "maybeMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9953);
// compiled call node returning call9960 (depth = 4)
  gc_frame_newslot(call9960);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  params[0] = call9960;
  partcv[0] = 1;
  Object call9961 = callmethodflags(*var_nd, "typeParams:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe9952);
// compiled call node returning call9961 (depth = 3)
// Begin line 2611
  setline(2611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9962 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  gc_frame_newslot(*var_nd);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_nd;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9963 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe9962);
// compiled call node returning call9963 (depth = 3)
  gc_frame_end(frame);
  return call9963;
}
Object meth_ast__apply_40_1_41_9972(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2616
  setline(2616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9974 == NULL) {
    strlit9974 = alloc_String("  ");
    gc_root(strlit9974);
  }
// compiled string node returning strlit9974 (depth = 7)
  int op_slot_right_9973 = gc_frame_newslot(strlit9974);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_9973 = gc_frame_newslot(*var_spc);
  params[0] = strlit9974;
  partcv[0] = 1;
  Object opresult9976 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult9976 (depth = 6)
  *var_spc = opresult9976;
  if (opresult9976 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_10026(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2621
  setline(2621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10028 == NULL) {
    strlit10028 = alloc_String("");
    gc_root(strlit10028);
  }
// compiled string node returning strlit10028 (depth = 7)
  int op_slot_right_10027 = gc_frame_newslot(strlit10028);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10031 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10033 = alloc_Float64(2);
// compiled num node returning num10033 (depth = 10)
  int op_slot_right_10032 = gc_frame_newslot(num10033);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_10032 = gc_frame_newslot(*var_depth);
  params[0] = num10033;
  partcv[0] = 1;
  Object sum10035 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum10035 (depth = 9)
  gc_frame_newslot(sum10035);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_p (depth = 9)
  params[0] = sum10035;
  partcv[0] = 1;
  Object call10036 = callmethodflags(*var_p, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10031);
// compiled call node returning call10036 (depth = 8)
  int op_slot_right_10030 = gc_frame_newslot(call10036);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10039 == NULL) {
    strlit10039 = alloc_String("");
    gc_root(strlit10039);
  }
// compiled string node returning strlit10039 (depth = 9)
  int op_slot_right_10038 = gc_frame_newslot(strlit10039);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_10041 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit10044 == NULL) {
    strlit10044 = alloc_String("""\x0a""  ");
    gc_root(strlit10044);
  }
// compiled string node returning strlit10044 (depth = 11)
  int op_slot_right_10043 = gc_frame_newslot(strlit10044);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_10046 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit10048 == NULL) {
    strlit10048 = alloc_String("");
    gc_root(strlit10048);
  }
// compiled string node returning strlit10048 (depth = 12)
  int op_slot_left_10046 = gc_frame_newslot(strlit10048);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10049 = callmethod(strlit10048, "++(1)", 1, partcv, params);
// compiled op node returning opresult10049 (depth = 11)
  int op_slot_left_10043 = gc_frame_newslot(opresult10049);
  params[0] = strlit10044;
  partcv[0] = 1;
  Object opresult10050 = callmethod(opresult10049, "++(1)", 1, partcv, params);
// compiled op node returning opresult10050 (depth = 10)
  int op_slot_left_10041 = gc_frame_newslot(opresult10050);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10051 = callmethod(opresult10050, "++(1)", 1, partcv, params);
// compiled op node returning opresult10051 (depth = 9)
  int op_slot_left_10038 = gc_frame_newslot(opresult10051);
  params[0] = strlit10039;
  partcv[0] = 1;
  Object opresult10052 = callmethod(opresult10051, "++(1)", 1, partcv, params);
// compiled op node returning opresult10052 (depth = 8)
  int op_slot_left_10030 = gc_frame_newslot(opresult10052);
  params[0] = call10036;
  partcv[0] = 1;
  Object opresult10053 = callmethod(opresult10052, "++(1)", 1, partcv, params);
// compiled op node returning opresult10053 (depth = 7)
  int op_slot_left_10027 = gc_frame_newslot(opresult10053);
  params[0] = strlit10028;
  partcv[0] = 1;
  Object opresult10054 = callmethod(opresult10053, "++(1)", 1, partcv, params);
// compiled op node returning opresult10054 (depth = 6)
  *var_s = opresult10054;
  if (opresult10054 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_9964(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2614
  setline(2614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9965 == NULL) {
    strlit9965 = alloc_String("");
    gc_root(strlit9965);
  }
// compiled string node returning strlit9965 (depth = 4)
  *var_spc = strlit9965;
  if (strlit9965 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2615
  setline(2615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9966 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_9967 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num9969 = alloc_Float64(0);
// compiled num node returning num9969 (depth = 5)
  int op_slot_left_9967 = gc_frame_newslot(num9969);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9970 = callmethod(num9969, "..(1)", 1, partcv, params);
// compiled op node returning opresult9970 (depth = 4)
  gc_frame_newslot(opresult9970);
// starting to compile block node (depth = 4)
  Object block9971 = alloc_Block(NULL, NULL, "ast", 2615);
  gc_frame_newslot(block9971);
// method "_apply(_)"
  block_savedest(block9971);
  Object closure9972 = createclosure(2, "_apply(1)");
  setclosureframe(closure9972, stackframe);
  addtoclosure(closure9972, var_spc);
  addtoclosure(closure9972, selfslot);
  struct UserObject *uo9972 = (struct UserObject*)block9971;
  uo9972->data[0] = (Object)closure9972;
  Method *meth_meth_ast__apply_40_1_41_9972 = addmethod2pos(block9971, "_apply(1)", &meth_ast__apply_40_1_41_9972, 0);
  int argcv_meth_ast__apply_40_1_41_9972[] = {1};
  meth_meth_ast__apply_40_1_41_9972->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_9972);
  meth_meth_ast__apply_40_1_41_9972->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_9972->definitionLine = 2981;
// compiled block node returning block9971 (depth = 4)
  gc_frame_newslot(block9971);
// call case 5: prelude request
  params[0] = opresult9970;
  params[1] = block9971;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9979 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9966);
// compiled call node returning call9979 (depth = 3)
// Begin line 2618
  setline(2618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9981 == NULL) {
    strlit9981 = alloc_String("");
    gc_root(strlit9981);
  }
// compiled string node returning strlit9981 (depth = 5)
  int op_slot_right_9980 = gc_frame_newslot(strlit9981);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe9984 = gc_frame_new();
// call case 4: self request
  Object call9985 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9984);
// compiled member node returning call9985 (depth = 6)
  int op_slot_right_9983 = gc_frame_newslot(call9985);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9988 == NULL) {
    strlit9988 = alloc_String(": ");
    gc_root(strlit9988);
  }
// compiled string node returning strlit9988 (depth = 7)
  int op_slot_right_9987 = gc_frame_newslot(strlit9988);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9991 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9992 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9991);
// compiled call node returning call9992 (depth = 8)
  int op_slot_right_9990 = gc_frame_newslot(call9992);
// starting to compile string node (depth = 8)
  if (strlit9994 == NULL) {
    strlit9994 = alloc_String("");
    gc_root(strlit9994);
  }
// compiled string node returning strlit9994 (depth = 8)
  int op_slot_left_9990 = gc_frame_newslot(strlit9994);
  params[0] = call9992;
  partcv[0] = 1;
  Object opresult9995 = callmethod(strlit9994, "++(1)", 1, partcv, params);
// compiled op node returning opresult9995 (depth = 7)
  int op_slot_left_9987 = gc_frame_newslot(opresult9995);
  params[0] = strlit9988;
  partcv[0] = 1;
  Object opresult9996 = callmethod(opresult9995, "++(1)", 1, partcv, params);
// compiled op node returning opresult9996 (depth = 6)
  int op_slot_left_9983 = gc_frame_newslot(opresult9996);
  params[0] = call9985;
  partcv[0] = 1;
  Object opresult9997 = callmethod(opresult9996, "++(1)", 1, partcv, params);
// compiled op node returning opresult9997 (depth = 5)
  int op_slot_left_9980 = gc_frame_newslot(opresult9997);
  params[0] = strlit9981;
  partcv[0] = 1;
  Object opresult9998 = callmethod(opresult9997, "++(1)", 1, partcv, params);
// compiled op node returning opresult9998 (depth = 4)
  *var_s = opresult9998;
  if (opresult9998 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2619
  setline(2619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10000 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10001 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10002 = gc_frame_new();
// call case 4: self request
  Object call10003 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10002);
// compiled member node returning call10003 (depth = 6)
  Object call10004 = callmethodflags(call10003, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe10001);
// compiled member node returning call10004 (depth = 5)
  Object call10005 = callmethodflags(call10004, "not", 0, partcv, params, 0);
  gc_frame_end(callframe10000);
// compiled member node returning call10005 (depth = 4)
  Object if9999 = done;
  if (istrue(call10005)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10007 == NULL) {
    strlit10007 = alloc_String("Parameters:");
    gc_root(strlit10007);
  }
// compiled string node returning strlit10007 (depth = 6)
  int op_slot_right_10006 = gc_frame_newslot(strlit10007);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_10009 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10012 == NULL) {
    strlit10012 = alloc_String("""\x0a""");
    gc_root(strlit10012);
  }
// compiled string node returning strlit10012 (depth = 8)
  int op_slot_right_10011 = gc_frame_newslot(strlit10012);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_10014 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit10016 == NULL) {
    strlit10016 = alloc_String("");
    gc_root(strlit10016);
  }
// compiled string node returning strlit10016 (depth = 9)
  int op_slot_left_10014 = gc_frame_newslot(strlit10016);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10017 = callmethod(strlit10016, "++(1)", 1, partcv, params);
// compiled op node returning opresult10017 (depth = 8)
  int op_slot_left_10011 = gc_frame_newslot(opresult10017);
  params[0] = strlit10012;
  partcv[0] = 1;
  Object opresult10018 = callmethod(opresult10017, "++(1)", 1, partcv, params);
// compiled op node returning opresult10018 (depth = 7)
  int op_slot_left_10009 = gc_frame_newslot(opresult10018);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10019 = callmethod(opresult10018, "++(1)", 1, partcv, params);
// compiled op node returning opresult10019 (depth = 6)
  int op_slot_left_10006 = gc_frame_newslot(opresult10019);
  params[0] = strlit10007;
  partcv[0] = 1;
  Object opresult10020 = callmethod(opresult10019, "++(1)", 1, partcv, params);
// compiled op node returning opresult10020 (depth = 5)
  *var_s = opresult10020;
  if (opresult10020 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9999 = done;
  } else {
  }
// compiled if node returning if9999 (depth = 3)
// Begin line 2620
  setline(2620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10022 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10023 = gc_frame_new();
// call case 4: self request
  Object call10024 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10023);
// compiled member node returning call10024 (depth = 4)
  gc_frame_newslot(call10024);
// starting to compile block node (depth = 4)
  Object block10025 = alloc_Block(NULL, NULL, "ast", 2620);
  gc_frame_newslot(block10025);
// method "_apply(_)"
  block_savedest(block10025);
  Object closure10026 = createclosure(4, "_apply(1)");
  setclosureframe(closure10026, stackframe);
  addtoclosure(closure10026, var_depth);
  addtoclosure(closure10026, var_spc);
  addtoclosure(closure10026, var_s);
  addtoclosure(closure10026, selfslot);
  struct UserObject *uo10026 = (struct UserObject*)block10025;
  uo10026->data[0] = (Object)closure10026;
  Method *meth_meth_ast__apply_40_1_41_10026 = addmethod2pos(block10025, "_apply(1)", &meth_ast__apply_40_1_41_10026, 0);
  int argcv_meth_ast__apply_40_1_41_10026[] = {1};
  meth_meth_ast__apply_40_1_41_10026->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_10026);
  meth_meth_ast__apply_40_1_41_10026->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_10026->definitionLine = 2981;
// compiled block node returning block10025 (depth = 4)
  gc_frame_newslot(block10025);
// call case 5: prelude request
  params[0] = call10024;
  params[1] = block10025;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10057 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10022);
// compiled call node returning call10057 (depth = 3)
// Begin line 2623
  setline(2623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_10075(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10076 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num10078 = alloc_Float64(1);
// compiled num node returning num10078 (depth = 9)
  int op_slot_right_10077 = gc_frame_newslot(num10078);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_10077 = gc_frame_newslot(*var_depth);
  params[0] = num10078;
  partcv[0] = 1;
  Object sum10080 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum10080 (depth = 8)
  gc_frame_newslot(sum10080);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum10080;
  partcv[0] = 1;
  Object call10081 = callmethodflags(*var_each, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10076);
// compiled call node returning call10081 (depth = 7)
  *var_s = call10081;
  if (call10081 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply10085(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10087 == NULL) {
    strlit10087 = alloc_String(", ");
    gc_root(strlit10087);
  }
// compiled string node returning strlit10087 (depth = 8)
  int op_slot_right_10086 = gc_frame_newslot(strlit10087);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_10086 = gc_frame_newslot(*var_s);
  params[0] = strlit10087;
  partcv[0] = 1;
  Object opresult10089 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10089 (depth = 7)
  *var_s = opresult10089;
  if (opresult10089 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_10058(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 2626
  setline(2626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10059 = gc_frame_new();
// call case 4: self request
  Object call10060 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10059);
// compiled member node returning call10060 (depth = 4)
  *var_s = call10060;
  if (call10060 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2627
  setline(2627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10062 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10063 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10064 = gc_frame_new();
// call case 4: self request
  Object call10065 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10064);
// compiled member node returning call10065 (depth = 6)
  Object call10066 = callmethodflags(call10065, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe10063);
// compiled member node returning call10066 (depth = 5)
  Object call10067 = callmethodflags(call10066, "not", 0, partcv, params, 0);
  gc_frame_end(callframe10062);
// compiled member node returning call10067 (depth = 4)
  Object if10061 = done;
  if (istrue(call10067)) {
// Begin line 2628
  setline(2628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10069 == NULL) {
    strlit10069 = alloc_String("(");
    gc_root(strlit10069);
  }
// compiled string node returning strlit10069 (depth = 6)
  int op_slot_right_10068 = gc_frame_newslot(strlit10069);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_10068 = gc_frame_newslot(*var_s);
  params[0] = strlit10069;
  partcv[0] = 1;
  Object opresult10071 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10071 (depth = 5)
  *var_s = opresult10071;
  if (opresult10071 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2629
  setline(2629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10073 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block10074 = alloc_Block(NULL, NULL, "ast", 2629);
  gc_frame_newslot(block10074);
// method "_apply(_)"
  block_savedest(block10074);
  Object closure10075 = createclosure(3, "_apply(1)");
  setclosureframe(closure10075, stackframe);
  addtoclosure(closure10075, var_depth);
  addtoclosure(closure10075, var_s);
  addtoclosure(closure10075, selfslot);
  struct UserObject *uo10075 = (struct UserObject*)block10074;
  uo10075->data[0] = (Object)closure10075;
  Method *meth_meth_ast__apply_40_1_41_10075 = addmethod2pos(block10074, "_apply(1)", &meth_ast__apply_40_1_41_10075, 0);
  int argcv_meth_ast__apply_40_1_41_10075[] = {1};
  meth_meth_ast__apply_40_1_41_10075->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_10075);
  meth_meth_ast__apply_40_1_41_10075->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_10075->definitionLine = 2981;
// compiled block node returning block10074 (depth = 5)
  gc_frame_newslot(block10074);
// Begin line 2630
  setline(2630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block10084 = alloc_Block(NULL, NULL, "ast", 2630);
  gc_frame_newslot(block10084);
// method "_apply"
  block_savedest(block10084);
  Object closure10085 = createclosure(2, "_apply");
  setclosureframe(closure10085, stackframe);
  addtoclosure(closure10085, var_s);
  addtoclosure(closure10085, selfslot);
  struct UserObject *uo10085 = (struct UserObject*)block10084;
  uo10085->data[0] = (Object)closure10085;
  Method *meth_meth_ast__apply10085 = addmethod2pos(block10084, "_apply", &meth_ast__apply10085, 0);
  int argcv_meth_ast__apply10085[] = {0};
  meth_meth_ast__apply10085->type = alloc_MethodType(1, argcv_meth_ast__apply10085);
  meth_meth_ast__apply10085->definitionModule = modulename;
  meth_meth_ast__apply10085->definitionLine = 2981;
// compiled block node returning block10084 (depth = 5)
  gc_frame_newslot(block10084);
// call case 6: other requests
// Begin line 2629
  setline(2629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe10092 = gc_frame_new();
// call case 4: self request
  Object call10093 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10092);
// compiled member node returning call10093 (depth = 5)
  params[0] = block10074;
  params[1] = block10084;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10094 = callmethodflags(call10093, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10073);
// compiled call node returning call10094 (depth = 4)
// Begin line 2631
  setline(2631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10096 == NULL) {
    strlit10096 = alloc_String(")");
    gc_root(strlit10096);
  }
// compiled string node returning strlit10096 (depth = 6)
  int op_slot_right_10095 = gc_frame_newslot(strlit10096);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_10095 = gc_frame_newslot(*var_s);
  params[0] = strlit10096;
  partcv[0] = 1;
  Object opresult10098 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10098 (depth = 5)
  *var_s = opresult10098;
  if (opresult10098 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10061 = done;
  } else {
  }
// compiled if node returning if10061 (depth = 3)
// Begin line 2633
  setline(2633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy10100(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_signaturePart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2637
  setline(2637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10101 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// Begin line 2636
  setline(2636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10102 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe10103 = gc_frame_new();
// call case 4: self request
  Object call10104 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10103);
// compiled member node returning call10104 (depth = 5)
  gc_frame_newslot(call10104);
// starting to compile member node (depth = 5)
  int callframe10105 = gc_frame_new();
// call case 4: self request
  Object call10106 = callmethodflags(self, "params", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10105);
// compiled member node returning call10106 (depth = 5)
  gc_frame_newslot(call10106);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signaturePart (depth = 5)
  params[0] = call10104;
  params[1] = call10106;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10107 = callmethodflags(*var_signaturePart, "partName(1)params(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10102);
// compiled call node returning call10107 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call10108 = callmethodflags(call10107, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10101);
// compiled call node returning call10108 (depth = 3)
  gc_frame_end(frame);
  return call10108;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_10109(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2640
  setline(2640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10110 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call10111 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe10110);
// compiled call node returning call10111 (depth = 3)
// Begin line 2641
  setline(2641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10112 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10113 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call10114 = callmethodflags(*var_other, "typeParams", 0, partcv, params, 0);
  gc_frame_end(callframe10113);
// compiled member node returning call10114 (depth = 4)
  gc_frame_newslot(call10114);
// call case 4: self request
  params[0] = call10114;
  partcv[0] = 1;
  Object call10115 = callmethodflags(self, "typeParams:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10112);
// compiled call node returning call10115 (depth = 3)
// Begin line 2642
  setline(2642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10116 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10117 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call10118 = callmethodflags(*var_other, "lineLength", 0, partcv, params, 0);
  gc_frame_end(callframe10117);
// compiled member node returning call10118 (depth = 4)
  gc_frame_newslot(call10118);
// call case 4: self request
  params[0] = call10118;
  partcv[0] = 1;
  Object call10119 = callmethodflags(self, "lineLength:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10116);
// compiled call node returning call10119 (depth = 3)
// Begin line 2643
  setline(2643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_asString10120(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2646
  setline(2646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10122 == NULL) {
    strlit10122 = alloc_String("");
    gc_root(strlit10122);
  }
// compiled string node returning strlit10122 (depth = 4)
  int op_slot_right_10121 = gc_frame_newslot(strlit10122);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10125 = gc_frame_new();
// call case 4: self request
  Object call10126 = callmethodflags(self, "nameString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10125);
// compiled member node returning call10126 (depth = 5)
  int op_slot_right_10124 = gc_frame_newslot(call10126);
// starting to compile string node (depth = 5)
  if (strlit10128 == NULL) {
    strlit10128 = alloc_String("part: ");
    gc_root(strlit10128);
  }
// compiled string node returning strlit10128 (depth = 5)
  int op_slot_left_10124 = gc_frame_newslot(strlit10128);
  params[0] = call10126;
  partcv[0] = 1;
  Object opresult10129 = callmethod(strlit10128, "++(1)", 1, partcv, params);
// compiled op node returning opresult10129 (depth = 4)
  int op_slot_left_10121 = gc_frame_newslot(opresult10129);
  params[0] = strlit10122;
  partcv[0] = 1;
  Object opresult10130 = callmethod(opresult10129, "++(1)", 1, partcv, params);
// compiled op node returning opresult10130 (depth = 3)
  gc_frame_end(frame);
  return opresult10130;
}
Object meth_ast_partName_40_1_41_params_40_1_41_9824(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "partName(1)params(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)params(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName(_)params(_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_signaturePart = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for partName(_)params(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part partName(_)");
  Object *var_ps = &(stackframe->slots[1]);
  *var_ps = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part params(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9825 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9825 = alloc_userobj2(20,17, objclass9825);
  gc_frame_newslot(obj9825);
if (objclass9825 == NULL) {
  glfree(obj9825->class->name);
  obj9825->class->name = "signaturePart.partName(_)params(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9825, self, 0);
  addmethodreal(obj9825,"outer", &reader_ast_outer_9826);
  Object oldself9825 = self;
  struct StackFrameObject *oldstackframe9825 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9825);
  gc_frame_newslot((Object)stackframe);
  self = obj9825;
  Object *oldselfslot9825 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9825 = (*(struct UserObject *)self).data[0], lowerouter9825 = thisouter9825;
  if (inheritingObject9825) {
    struct UserObject *inho9825 = (struct UserObject *)inheritingObject9825;
    while (inho9825->super != GraceDefaultObject) inho9825 = (struct UserObject *)inho9825->super;
    inho9825->super = obj9825;
    self = inheritingObject9825;
    *selfslot = self;
    lowerouter9825 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9825;
  }
if (objclass9825 == NULL) {
  Method *reader9827 = addmethodrealflags(obj9825, "kind",&reader_ast_kind_9827, MFLAG_DEF);
  reader9827->definitionModule = modulename;
  reader9827->definitionLine = 2577;
}
adddatum2(obj9825, alloc_Undefined(), 1);
if (objclass9825 == NULL) {
  Method *reader9828 = addmethodrealflags(obj9825, "name", &reader_ast_name_9828, 0);
  Method *writer9828 = addmethodrealflags(obj9825, "name:=(1)", &writer_ast_name_9828, 0);
  reader9828->definitionModule = modulename;
  writer9828->definitionModule = modulename;
  reader9828->definitionLine = 2578;
  writer9828->definitionLine = 2578;
}
obj9825->flags |= OFLAG_MUTABLE;
adddatum2(obj9825, alloc_Undefined(), 2);
if (objclass9825 == NULL) {
  Method *reader9829 = addmethodrealflags(obj9825, "params", &reader_ast_params_9829, 0);
  Method *writer9829 = addmethodrealflags(obj9825, "params:=(1)", &writer_ast_params_9829, 0);
  reader9829->definitionModule = modulename;
  writer9829->definitionModule = modulename;
  reader9829->definitionLine = 2579;
  writer9829->definitionLine = 2579;
}
obj9825->flags |= OFLAG_MUTABLE;
adddatum2(obj9825, alloc_Undefined(), 3);
if (objclass9825 == NULL) {
  Method *reader9830 = addmethodrealflags(obj9825, "typeParams", &reader_ast_typeParams_9830, 0);
  Method *writer9830 = addmethodrealflags(obj9825, "typeParams:=(1)", &writer_ast_typeParams_9830, 0);
  reader9830->definitionModule = modulename;
  writer9830->definitionModule = modulename;
  reader9830->definitionLine = 2580;
  writer9830->definitionLine = 2580;
}
obj9825->flags |= OFLAG_MUTABLE;
adddatum2(obj9825, alloc_Undefined(), 4);
if (objclass9825 == NULL) {
  Method *reader9831 = addmethodrealflags(obj9825, "lineLength", &reader_ast_lineLength_9831, 0);
  Method *writer9831 = addmethodrealflags(obj9825, "lineLength:=(1)", &writer_ast_lineLength_9831, 0);
  reader9831->definitionModule = modulename;
  writer9831->definitionModule = modulename;
  reader9831->definitionLine = 2581;
  writer9831->definitionLine = 2581;
}
obj9825->flags |= OFLAG_MUTABLE;
adddatum2(obj9825, alloc_Undefined(), 5);
// method "nameString"
  struct UserObject *uo9832 = (struct UserObject*)obj9825;
  uo9832->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString9832 = addmethod2pos(obj9825, "nameString", &meth_ast_nameString9832, 6);
  int argcv_meth_ast_nameString9832[] = {0};
  meth_meth_ast_nameString9832->type = alloc_MethodType(1, argcv_meth_ast_nameString9832);
  meth_meth_ast_nameString9832->definitionModule = modulename;
  meth_meth_ast_nameString9832->definitionLine = 2583;
// method "numParams"
  struct UserObject *uo9857 = (struct UserObject*)obj9825;
  uo9857->data[7] = emptyclosure;
  Method *meth_meth_ast_numParams9857 = addmethod2pos(obj9825, "numParams", &meth_ast_numParams9857, 7);
  int argcv_meth_ast_numParams9857[] = {0};
  meth_meth_ast_numParams9857->type = alloc_MethodType(1, argcv_meth_ast_numParams9857);
  meth_meth_ast_numParams9857->definitionModule = modulename;
  meth_meth_ast_numParams9857->definitionLine = 2587;
// method "canonicalName"
  struct UserObject *uo9862 = (struct UserObject*)obj9825;
  uo9862->data[8] = emptyclosure;
  Method *meth_meth_ast_canonicalName9862 = addmethod2pos(obj9825, "canonicalName", &meth_ast_canonicalName9862, 8);
  int argcv_meth_ast_canonicalName9862[] = {0};
  meth_meth_ast_canonicalName9862->type = alloc_MethodType(1, argcv_meth_ast_canonicalName9862);
  meth_meth_ast_canonicalName9862->definitionModule = modulename;
  meth_meth_ast_canonicalName9862->definitionLine = 2588;
// method "accept(_)from(_)"
  struct UserObject *uo9908 = (struct UserObject*)obj9825;
  uo9908->data[9] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9908 = addmethod2pos(obj9825, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9908, 9);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9908[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9908->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9908);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9908->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9908->definitionLine = 2596;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj9825);
  Object closure9934 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure9934, stackframe);
  addtoclosure(closure9934, var_k);
  struct UserObject *uo9934 = (struct UserObject*)obj9825;
  uo9934->data[10] = (Object)closure9934;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_9934 = addmethod2pos(obj9825, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_9934, 10);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_9934[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9934->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_9934);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9934->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9934->definitionLine = 2605;
// method "map(_)ancestors(_)"
  struct UserObject *uo9937 = (struct UserObject*)obj9825;
  uo9937->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9937 = addmethod2pos(obj9825, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9937, 11);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9937[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9937->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9937);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9937->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9937->definitionLine = 2606;
// method "pretty(_)"
  struct UserObject *uo9964 = (struct UserObject*)obj9825;
  uo9964->data[12] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_9964 = addmethod2pos(obj9825, "pretty(1)", &meth_ast_pretty_40_1_41_9964, 12);
  int argcv_meth_ast_pretty_40_1_41_9964[] = {1};
  meth_meth_ast_pretty_40_1_41_9964->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_9964);
  meth_meth_ast_pretty_40_1_41_9964->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_9964->definitionLine = 2613;
// method "toGrace(_)"
  struct UserObject *uo10058 = (struct UserObject*)obj9825;
  uo10058->data[13] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_10058 = addmethod2pos(obj9825, "toGrace(1)", &meth_ast_toGrace_40_1_41_10058, 13);
  int argcv_meth_ast_toGrace_40_1_41_10058[] = {1};
  meth_meth_ast_toGrace_40_1_41_10058->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_10058);
  meth_meth_ast_toGrace_40_1_41_10058->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_10058->definitionLine = 2625;
// method "shallowCopy"
  block_savedest(obj9825);
  Object closure10100 = createclosure(1, "shallowCopy");
  setclosureframe(closure10100, stackframe);
  addtoclosure(closure10100, var_signaturePart);
  struct UserObject *uo10100 = (struct UserObject*)obj9825;
  uo10100->data[14] = (Object)closure10100;
  Method *meth_meth_ast_shallowCopy10100 = addmethod2pos(obj9825, "shallowCopy", &meth_ast_shallowCopy10100, 14);
  int argcv_meth_ast_shallowCopy10100[] = {0};
  meth_meth_ast_shallowCopy10100->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10100);
  meth_meth_ast_shallowCopy10100->definitionModule = modulename;
  meth_meth_ast_shallowCopy10100->definitionLine = 2635;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo10109 = (struct UserObject*)obj9825;
  uo10109->data[15] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10109 = addmethod2pos(obj9825, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_10109, 15);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10109[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10109->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10109);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10109->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10109->definitionLine = 2639;
// method "asString"
  struct UserObject *uo10120 = (struct UserObject*)obj9825;
  uo10120->data[16] = emptyclosure;
  Method *meth_meth_ast_asString10120 = addmethod2pos(obj9825, "asString", &meth_ast_asString10120, 16);
  int argcv_meth_ast_asString10120[] = {0};
  meth_meth_ast_asString10120->type = alloc_MethodType(1, argcv_meth_ast_asString10120);
  meth_meth_ast_asString10120->definitionModule = modulename;
  meth_meth_ast_asString10120->definitionLine = 2645;
  sourceObject = obj9825;
// Begin line 2576
  setline(2576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10131 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10132 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10133 = gc_frame_new();
// call case 3: self.outer request
  Object call10134 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10133);
// compiled member node returning call10134 (depth = 5)
  Object call10135 = callmethodflags(call10134, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe10132);
// compiled member node returning call10135 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10136 = callmethodflags(call10135, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10131);
// compiled call node returning call10136 (depth = 3)
  struct UserObject *obj9825_uo = (struct UserObject *)obj9825;
  obj9825_uo->super = call10136;
  sourceObject = obj9825;
// Begin line 2577
  setline(2577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10137 == NULL) {
    strlit10137 = alloc_String("signaturepart");
    gc_root(strlit10137);
  }
// compiled string node returning strlit10137 (depth = 3)
  adddatum2(obj9825, strlit10137, 1);
  sourceObject = obj9825;
// Begin line 2578
  setline(2578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  adddatum2(obj9825, *var_n, 2);
  sourceObject = obj9825;
// Begin line 2579
  setline(2579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ps (depth = 3)
  adddatum2(obj9825, *var_ps, 3);
  sourceObject = obj9825;
// Begin line 2580
  setline(2580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10138 = alloc_Boolean(0);
// compiled identifier node returning bool10138 (depth = 3)
  adddatum2(obj9825, bool10138, 4);
  sourceObject = obj9825;
// Begin line 2581
  setline(2581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num10139 = alloc_Float64(0);
// compiled num node returning num10139 (depth = 3)
  adddatum2(obj9825, num10139, 5);
  sourceObject = obj9825;
  sourceObject = obj9825;
  sourceObject = obj9825;
  sourceObject = obj9825;
  sourceObject = obj9825;
  sourceObject = obj9825;
  sourceObject = obj9825;
  sourceObject = obj9825;
  sourceObject = obj9825;
  sourceObject = obj9825;
  sourceObject = obj9825;
  objclass9825 = obj9825->class;
  objclass9825->definitionModule = modulename;
  objclass9825->definitionLine = 2575;
  (*(struct UserObject *)self).data[0] = lowerouter9825;
  self = oldself9825;
  selfslot = oldselfslot9825;
  stackframe = oldstackframe9825;
  gc_frame_end(frame);
  return obj9825;
}
Object meth_ast_partName_40_1_41_params_40_1_41_9824_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "partName(1)params(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method partName(_)params(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method partName(_)params(_)");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_signaturePart = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for partName(_)params(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part partName(_)");
  Object *var_ps = &(stackframe->slots[1]);
  *var_ps = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part params(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9825 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9825 = alloc_userobj2(20,17, objclass9825);
  gc_frame_newslot(obj9825);
if (objclass9825 == NULL) {
  glfree(obj9825->class->name);
  obj9825->class->name = "signaturePart.partName(_)params(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9825, self, 0);
  addmethodreal(obj9825,"outer", &reader_ast_outer_9826);
  Object oldself9825 = self;
  struct StackFrameObject *oldstackframe9825 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9825);
  gc_frame_newslot((Object)stackframe);
  self = obj9825;
  Object *oldselfslot9825 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9825 = (*(struct UserObject *)self).data[0], lowerouter9825 = thisouter9825;
  if (inheritingObject9825) {
    struct UserObject *inho9825 = (struct UserObject *)inheritingObject9825;
    while (inho9825->super != GraceDefaultObject) inho9825 = (struct UserObject *)inho9825->super;
    inho9825->super = obj9825;
    self = inheritingObject9825;
    *selfslot = self;
    lowerouter9825 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9825;
  }
if (objclass9825 == NULL) {
  Method *reader9827 = addmethodrealflags(obj9825, "kind",&reader_ast_kind_9827, MFLAG_DEF);
  reader9827->definitionModule = modulename;
  reader9827->definitionLine = 2577;
}
adddatum2(obj9825, alloc_Undefined(), 1);
if (objclass9825 == NULL) {
  Method *reader9828 = addmethodrealflags(obj9825, "name", &reader_ast_name_9828, 0);
  Method *writer9828 = addmethodrealflags(obj9825, "name:=(1)", &writer_ast_name_9828, 0);
  reader9828->definitionModule = modulename;
  writer9828->definitionModule = modulename;
  reader9828->definitionLine = 2578;
  writer9828->definitionLine = 2578;
}
obj9825->flags |= OFLAG_MUTABLE;
adddatum2(obj9825, alloc_Undefined(), 2);
if (objclass9825 == NULL) {
  Method *reader9829 = addmethodrealflags(obj9825, "params", &reader_ast_params_9829, 0);
  Method *writer9829 = addmethodrealflags(obj9825, "params:=(1)", &writer_ast_params_9829, 0);
  reader9829->definitionModule = modulename;
  writer9829->definitionModule = modulename;
  reader9829->definitionLine = 2579;
  writer9829->definitionLine = 2579;
}
obj9825->flags |= OFLAG_MUTABLE;
adddatum2(obj9825, alloc_Undefined(), 3);
if (objclass9825 == NULL) {
  Method *reader9830 = addmethodrealflags(obj9825, "typeParams", &reader_ast_typeParams_9830, 0);
  Method *writer9830 = addmethodrealflags(obj9825, "typeParams:=(1)", &writer_ast_typeParams_9830, 0);
  reader9830->definitionModule = modulename;
  writer9830->definitionModule = modulename;
  reader9830->definitionLine = 2580;
  writer9830->definitionLine = 2580;
}
obj9825->flags |= OFLAG_MUTABLE;
adddatum2(obj9825, alloc_Undefined(), 4);
if (objclass9825 == NULL) {
  Method *reader9831 = addmethodrealflags(obj9825, "lineLength", &reader_ast_lineLength_9831, 0);
  Method *writer9831 = addmethodrealflags(obj9825, "lineLength:=(1)", &writer_ast_lineLength_9831, 0);
  reader9831->definitionModule = modulename;
  writer9831->definitionModule = modulename;
  reader9831->definitionLine = 2581;
  writer9831->definitionLine = 2581;
}
obj9825->flags |= OFLAG_MUTABLE;
adddatum2(obj9825, alloc_Undefined(), 5);
// method "nameString"
  struct UserObject *uo9832 = (struct UserObject*)obj9825;
  uo9832->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString9832 = addmethod2pos(obj9825, "nameString", &meth_ast_nameString9832, 6);
  int argcv_meth_ast_nameString9832[] = {0};
  meth_meth_ast_nameString9832->type = alloc_MethodType(1, argcv_meth_ast_nameString9832);
  meth_meth_ast_nameString9832->definitionModule = modulename;
  meth_meth_ast_nameString9832->definitionLine = 2583;
// method "numParams"
  struct UserObject *uo9857 = (struct UserObject*)obj9825;
  uo9857->data[7] = emptyclosure;
  Method *meth_meth_ast_numParams9857 = addmethod2pos(obj9825, "numParams", &meth_ast_numParams9857, 7);
  int argcv_meth_ast_numParams9857[] = {0};
  meth_meth_ast_numParams9857->type = alloc_MethodType(1, argcv_meth_ast_numParams9857);
  meth_meth_ast_numParams9857->definitionModule = modulename;
  meth_meth_ast_numParams9857->definitionLine = 2587;
// method "canonicalName"
  struct UserObject *uo9862 = (struct UserObject*)obj9825;
  uo9862->data[8] = emptyclosure;
  Method *meth_meth_ast_canonicalName9862 = addmethod2pos(obj9825, "canonicalName", &meth_ast_canonicalName9862, 8);
  int argcv_meth_ast_canonicalName9862[] = {0};
  meth_meth_ast_canonicalName9862->type = alloc_MethodType(1, argcv_meth_ast_canonicalName9862);
  meth_meth_ast_canonicalName9862->definitionModule = modulename;
  meth_meth_ast_canonicalName9862->definitionLine = 2588;
// method "accept(_)from(_)"
  struct UserObject *uo9908 = (struct UserObject*)obj9825;
  uo9908->data[9] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_9908 = addmethod2pos(obj9825, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_9908, 9);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_9908[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_9908->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_9908);
  meth_meth_ast_accept_40_1_41_from_40_1_41_9908->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_9908->definitionLine = 2596;
// method "declarationKindWithAncestors(_)"
  block_savedest(obj9825);
  Object closure9934 = createclosure(1, "declarationKindWithAncestors(1)");
  setclosureframe(closure9934, stackframe);
  addtoclosure(closure9934, var_k);
  struct UserObject *uo9934 = (struct UserObject*)obj9825;
  uo9934->data[10] = (Object)closure9934;
  Method *meth_meth_ast_declarationKindWithAncestors_40_1_41_9934 = addmethod2pos(obj9825, "declarationKindWithAncestors(1)", &meth_ast_declarationKindWithAncestors_40_1_41_9934, 10);
  int argcv_meth_ast_declarationKindWithAncestors_40_1_41_9934[] = {1};
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9934->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors_40_1_41_9934);
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9934->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors_40_1_41_9934->definitionLine = 2605;
// method "map(_)ancestors(_)"
  struct UserObject *uo9937 = (struct UserObject*)obj9825;
  uo9937->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_9937 = addmethod2pos(obj9825, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_9937, 11);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9937[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9937->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_9937);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9937->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_9937->definitionLine = 2606;
// method "pretty(_)"
  struct UserObject *uo9964 = (struct UserObject*)obj9825;
  uo9964->data[12] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_9964 = addmethod2pos(obj9825, "pretty(1)", &meth_ast_pretty_40_1_41_9964, 12);
  int argcv_meth_ast_pretty_40_1_41_9964[] = {1};
  meth_meth_ast_pretty_40_1_41_9964->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_9964);
  meth_meth_ast_pretty_40_1_41_9964->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_9964->definitionLine = 2613;
// method "toGrace(_)"
  struct UserObject *uo10058 = (struct UserObject*)obj9825;
  uo10058->data[13] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_10058 = addmethod2pos(obj9825, "toGrace(1)", &meth_ast_toGrace_40_1_41_10058, 13);
  int argcv_meth_ast_toGrace_40_1_41_10058[] = {1};
  meth_meth_ast_toGrace_40_1_41_10058->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_10058);
  meth_meth_ast_toGrace_40_1_41_10058->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_10058->definitionLine = 2625;
// method "shallowCopy"
  block_savedest(obj9825);
  Object closure10100 = createclosure(1, "shallowCopy");
  setclosureframe(closure10100, stackframe);
  addtoclosure(closure10100, var_signaturePart);
  struct UserObject *uo10100 = (struct UserObject*)obj9825;
  uo10100->data[14] = (Object)closure10100;
  Method *meth_meth_ast_shallowCopy10100 = addmethod2pos(obj9825, "shallowCopy", &meth_ast_shallowCopy10100, 14);
  int argcv_meth_ast_shallowCopy10100[] = {0};
  meth_meth_ast_shallowCopy10100->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10100);
  meth_meth_ast_shallowCopy10100->definitionModule = modulename;
  meth_meth_ast_shallowCopy10100->definitionLine = 2635;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo10109 = (struct UserObject*)obj9825;
  uo10109->data[15] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10109 = addmethod2pos(obj9825, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_10109, 15);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10109[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10109->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10109);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10109->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10109->definitionLine = 2639;
// method "asString"
  struct UserObject *uo10120 = (struct UserObject*)obj9825;
  uo10120->data[16] = emptyclosure;
  Method *meth_meth_ast_asString10120 = addmethod2pos(obj9825, "asString", &meth_ast_asString10120, 16);
  int argcv_meth_ast_asString10120[] = {0};
  meth_meth_ast_asString10120->type = alloc_MethodType(1, argcv_meth_ast_asString10120);
  meth_meth_ast_asString10120->definitionModule = modulename;
  meth_meth_ast_asString10120->definitionLine = 2645;
  sourceObject = obj9825;
// Begin line 2576
  setline(2576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10131 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10132 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10133 = gc_frame_new();
// call case 3: self.outer request
  Object call10134 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10133);
// compiled member node returning call10134 (depth = 5)
  Object call10135 = callmethodflags(call10134, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe10132);
// compiled member node returning call10135 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10136 = callmethodflags(call10135, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10131);
// compiled call node returning call10136 (depth = 3)
  struct UserObject *obj9825_uo = (struct UserObject *)obj9825;
  obj9825_uo->super = call10136;
  sourceObject = obj9825;
// Begin line 2577
  setline(2577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10137 == NULL) {
    strlit10137 = alloc_String("signaturepart");
    gc_root(strlit10137);
  }
// compiled string node returning strlit10137 (depth = 3)
  adddatum2(obj9825, strlit10137, 1);
  sourceObject = obj9825;
// Begin line 2578
  setline(2578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  adddatum2(obj9825, *var_n, 2);
  sourceObject = obj9825;
// Begin line 2579
  setline(2579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ps (depth = 3)
  adddatum2(obj9825, *var_ps, 3);
  sourceObject = obj9825;
// Begin line 2580
  setline(2580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10138 = alloc_Boolean(0);
// compiled identifier node returning bool10138 (depth = 3)
  adddatum2(obj9825, bool10138, 4);
  sourceObject = obj9825;
// Begin line 2581
  setline(2581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num10139 = alloc_Float64(0);
// compiled num node returning num10139 (depth = 3)
  adddatum2(obj9825, num10139, 5);
  sourceObject = obj9825;
  sourceObject = obj9825;
  sourceObject = obj9825;
  sourceObject = obj9825;
  sourceObject = obj9825;
  sourceObject = obj9825;
  sourceObject = obj9825;
  sourceObject = obj9825;
  sourceObject = obj9825;
  sourceObject = obj9825;
  sourceObject = obj9825;
  objclass9825 = obj9825->class;
  objclass9825->definitionModule = modulename;
  objclass9825->definitionLine = 2575;
  (*(struct UserObject *)self).data[0] = lowerouter9825;
  self = oldself9825;
  selfslot = oldselfslot9825;
  stackframe = oldstackframe9825;
  gc_frame_end(frame);
  return obj9825;
}
Object meth_ast_signaturePart10141(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 49, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "signaturePart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_signaturePart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2558
  setline(2558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signaturePart (depth = 3)
  gc_frame_end(frame);
  return *var_signaturePart;
}
Object meth_ast_new10144(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2653
  setline(2653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10145 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10146 == NULL) {
    strlit10146 = alloc_String("");
    gc_root(strlit10146);
  }
// compiled string node returning strlit10146 (depth = 4)
  gc_frame_newslot(strlit10146);
// starting to compile array node (depth = 4)
  Object array10147 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10147 (depth = 4)
  gc_frame_newslot(array10147);
// call case 4: self request
  params[0] = strlit10146;
  params[1] = array10147;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10148 = callmethodflags(self, "request(1)withArgs(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10145);
// compiled call node returning call10148 (depth = 3)
  gc_frame_end(frame);
  return call10148;
}
Object meth_ast_request_40_1_41_withArgs_40_1_41_scope_40_1_41_10149(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "request(1)withArgs(1)scope(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request(_)withArgs(_)scope(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request(_)withArgs(_)scope(_)");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request(_)withArgs(_)scope(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for request(_)withArgs(_)scope(_) (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part request(_)");
  Object *var_argList = &(stackframe->slots[1]);
  *var_argList = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withArgs(_)");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part scope(_)");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 2656
  setline(2656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10150 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_argList (depth = 5)
  gc_frame_newslot(*var_argList);
// call case 4: self request
  params[0] = *var_name;
  params[1] = *var_argList;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10151 = callmethodflags(self, "request(1)withArgs(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10150);
// compiled call node returning call10151 (depth = 4)
  *var_result = call10151;
  if (call10151 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2657
  setline(2657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10152 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call10153 = callmethodflags(*var_result, "scope:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10152);
// compiled call node returning call10153 (depth = 3)
// Begin line 2658
  setline(2658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_nameString10162(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2669
  setline(2669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10165 = alloc_Float64(0);
// compiled num node returning num10165 (depth = 5)
  int op_slot_right_10164 = gc_frame_newslot(num10165);
// starting to compile member node (depth = 5)
  int callframe10167 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10168 = gc_frame_new();
// call case 4: self request
  Object call10169 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10168);
// compiled member node returning call10169 (depth = 6)
  Object call10170 = callmethodflags(call10169, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10167);
// compiled member node returning call10170 (depth = 5)
  int op_slot_left_10164 = gc_frame_newslot(call10170);
  params[0] = num10165;
  partcv[0] = 1;
  Object opresult10171 = callmethod(call10170, "==(1)", 1, partcv, params);
// compiled op node returning opresult10171 (depth = 4)
  Object if10163 = done;
  if (istrue(opresult10171)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10172 = gc_frame_new();
// call case 4: self request
  Object call10173 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10172);
// compiled member node returning call10173 (depth = 5)
  return call10173;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if10163 = undefined;
  } else {
  }
// compiled if node returning if10163 (depth = 3)
// Begin line 2670
  setline(2670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10175 == NULL) {
    strlit10175 = alloc_String(")");
    gc_root(strlit10175);
  }
// compiled string node returning strlit10175 (depth = 4)
  int op_slot_right_10174 = gc_frame_newslot(strlit10175);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10178 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10179 = gc_frame_new();
// call case 4: self request
  Object call10180 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10179);
// compiled member node returning call10180 (depth = 6)
  Object call10181 = callmethodflags(call10180, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10178);
// compiled member node returning call10181 (depth = 5)
  int op_slot_right_10177 = gc_frame_newslot(call10181);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10184 == NULL) {
    strlit10184 = alloc_String("(");
    gc_root(strlit10184);
  }
// compiled string node returning strlit10184 (depth = 6)
  int op_slot_right_10183 = gc_frame_newslot(strlit10184);
// starting to compile member node (depth = 6)
  int callframe10186 = gc_frame_new();
// call case 4: self request
  Object call10187 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10186);
// compiled member node returning call10187 (depth = 6)
  int op_slot_left_10183 = gc_frame_newslot(call10187);
  params[0] = strlit10184;
  partcv[0] = 1;
  Object opresult10188 = callmethod(call10187, "++(1)", 1, partcv, params);
// compiled op node returning opresult10188 (depth = 5)
  int op_slot_left_10177 = gc_frame_newslot(opresult10188);
  params[0] = call10181;
  partcv[0] = 1;
  Object opresult10189 = callmethod(opresult10188, "++(1)", 1, partcv, params);
// compiled op node returning opresult10189 (depth = 4)
  int op_slot_left_10174 = gc_frame_newslot(opresult10189);
  params[0] = strlit10175;
  partcv[0] = 1;
  Object opresult10190 = callmethod(opresult10189, "++(1)", 1, partcv, params);
// compiled op node returning opresult10190 (depth = 3)
  gc_frame_end(frame);
  return opresult10190;
}
Object meth_ast__apply_40_1_41_10206(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_underScores = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___4 = &(stackframe->slots[0]);
  *var___4 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10208 == NULL) {
    strlit10208 = alloc_String("_");
    gc_root(strlit10208);
  }
// compiled string node returning strlit10208 (depth = 7)
  int op_slot_right_10207 = gc_frame_newslot(strlit10208);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_underScores (depth = 7)
  int op_slot_left_10207 = gc_frame_newslot(*var_underScores);
  params[0] = strlit10208;
  partcv[0] = 1;
  Object opresult10210 = callmethod(*var_underScores, "++(1)", 1, partcv, params);
// compiled op node returning opresult10210 (depth = 6)
  *var_underScores = opresult10210;
  if (opresult10210 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply10214(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_underScores = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10216 == NULL) {
    strlit10216 = alloc_String(",");
    gc_root(strlit10216);
  }
// compiled string node returning strlit10216 (depth = 7)
  int op_slot_right_10215 = gc_frame_newslot(strlit10216);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_underScores (depth = 7)
  int op_slot_left_10215 = gc_frame_newslot(*var_underScores);
  params[0] = strlit10216;
  partcv[0] = 1;
  Object opresult10218 = callmethod(*var_underScores, "++(1)", 1, partcv, params);
// compiled op node returning opresult10218 (depth = 6)
  *var_underScores = opresult10218;
  if (opresult10218 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_canonicalName10191(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canonicalName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_underScores = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "underScores");
// Begin line 2674
  setline(2674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10194 = alloc_Float64(0);
// compiled num node returning num10194 (depth = 5)
  int op_slot_right_10193 = gc_frame_newslot(num10194);
// starting to compile member node (depth = 5)
  int callframe10196 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10197 = gc_frame_new();
// call case 4: self request
  Object call10198 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10197);
// compiled member node returning call10198 (depth = 6)
  Object call10199 = callmethodflags(call10198, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10196);
// compiled member node returning call10199 (depth = 5)
  int op_slot_left_10193 = gc_frame_newslot(call10199);
  params[0] = num10194;
  partcv[0] = 1;
  Object opresult10200 = callmethod(call10199, "==(1)", 1, partcv, params);
// compiled op node returning opresult10200 (depth = 4)
  Object if10192 = done;
  if (istrue(opresult10200)) {
// starting to compile return node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10201 = gc_frame_new();
// call case 4: self request
  Object call10202 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10201);
// compiled member node returning call10202 (depth = 5)
  return call10202;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if10192 = undefined;
  } else {
  }
// compiled if node returning if10192 (depth = 3)
// Begin line 2675
  setline(2675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10203 == NULL) {
    strlit10203 = alloc_String("");
    gc_root(strlit10203);
  }
// compiled string node returning strlit10203 (depth = 4)
  *var_underScores = strlit10203;
  if (strlit10203 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2676
  setline(2676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10204 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block10205 = alloc_Block(NULL, NULL, "ast", 2676);
  gc_frame_newslot(block10205);
// method "_apply(_)"
  block_savedest(block10205);
  Object closure10206 = createclosure(2, "_apply(1)");
  setclosureframe(closure10206, stackframe);
  addtoclosure(closure10206, var_underScores);
  addtoclosure(closure10206, selfslot);
  struct UserObject *uo10206 = (struct UserObject*)block10205;
  uo10206->data[0] = (Object)closure10206;
  Method *meth_meth_ast__apply_40_1_41_10206 = addmethod2pos(block10205, "_apply(1)", &meth_ast__apply_40_1_41_10206, 0);
  int argcv_meth_ast__apply_40_1_41_10206[] = {1};
  meth_meth_ast__apply_40_1_41_10206->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_10206);
  meth_meth_ast__apply_40_1_41_10206->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_10206->definitionLine = 2981;
// compiled block node returning block10205 (depth = 4)
  gc_frame_newslot(block10205);
// Begin line 2677
  setline(2677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block10213 = alloc_Block(NULL, NULL, "ast", 2677);
  gc_frame_newslot(block10213);
// method "_apply"
  block_savedest(block10213);
  Object closure10214 = createclosure(2, "_apply");
  setclosureframe(closure10214, stackframe);
  addtoclosure(closure10214, var_underScores);
  addtoclosure(closure10214, selfslot);
  struct UserObject *uo10214 = (struct UserObject*)block10213;
  uo10214->data[0] = (Object)closure10214;
  Method *meth_meth_ast__apply10214 = addmethod2pos(block10213, "_apply", &meth_ast__apply10214, 0);
  int argcv_meth_ast__apply10214[] = {0};
  meth_meth_ast__apply10214->type = alloc_MethodType(1, argcv_meth_ast__apply10214);
  meth_meth_ast__apply10214->definitionModule = modulename;
  meth_meth_ast__apply10214->definitionLine = 2981;
// compiled block node returning block10213 (depth = 4)
  gc_frame_newslot(block10213);
// call case 6: other requests
// Begin line 2676
  setline(2676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe10221 = gc_frame_new();
// call case 4: self request
  Object call10222 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10221);
// compiled member node returning call10222 (depth = 4)
  params[0] = block10205;
  params[1] = block10213;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10223 = callmethodflags(call10222, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10204);
// compiled call node returning call10223 (depth = 3)
// Begin line 2678
  setline(2678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10225 == NULL) {
    strlit10225 = alloc_String(")");
    gc_root(strlit10225);
  }
// compiled string node returning strlit10225 (depth = 4)
  int op_slot_right_10224 = gc_frame_newslot(strlit10225);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_underScores (depth = 5)
  int op_slot_right_10227 = gc_frame_newslot(*var_underScores);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10230 == NULL) {
    strlit10230 = alloc_String("(");
    gc_root(strlit10230);
  }
// compiled string node returning strlit10230 (depth = 6)
  int op_slot_right_10229 = gc_frame_newslot(strlit10230);
// starting to compile member node (depth = 6)
  int callframe10232 = gc_frame_new();
// call case 4: self request
  Object call10233 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10232);
// compiled member node returning call10233 (depth = 6)
  int op_slot_left_10229 = gc_frame_newslot(call10233);
  params[0] = strlit10230;
  partcv[0] = 1;
  Object opresult10234 = callmethod(call10233, "++(1)", 1, partcv, params);
// compiled op node returning opresult10234 (depth = 5)
  int op_slot_left_10227 = gc_frame_newslot(opresult10234);
  params[0] = *var_underScores;
  partcv[0] = 1;
  Object opresult10235 = callmethod(opresult10234, "++(1)", 1, partcv, params);
// compiled op node returning opresult10235 (depth = 4)
  int op_slot_left_10224 = gc_frame_newslot(opresult10235);
  params[0] = strlit10225;
  partcv[0] = 1;
  Object opresult10236 = callmethod(opresult10235, "++(1)", 1, partcv, params);
// compiled op node returning opresult10236 (depth = 3)
  gc_frame_end(frame);
  return opresult10236;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_10237(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2682
  setline(2682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10238 = gc_frame_new();
// call case 4: self request
  Object call10239 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10238);
// compiled member node returning call10239 (depth = 4)
  *var_n = call10239;
  if (call10239 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2683
  setline(2683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10240 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call10241 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10240);
// compiled call node returning call10241 (depth = 4)
  *var_newChain = call10241;
  if (call10241 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2684
  setline(2684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10242 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe10243 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe10244 = gc_frame_new();
// call case 4: self request
  Object call10245 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10244);
// compiled member node returning call10245 (depth = 5)
  gc_frame_newslot(call10245);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10246 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10247 = gc_frame_new();
// call case 3: self.outer request
  Object call10248 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10247);
// compiled member node returning call10248 (depth = 6)
  Object call10249 = callmethodflags(call10248, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe10246);
// compiled member node returning call10249 (depth = 5)
  params[0] = call10245;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call10250 = callmethodflags(call10249, "listMap(2)ancestors(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10243);
// compiled call node returning call10250 (depth = 4)
  gc_frame_newslot(call10250);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call10250;
  partcv[0] = 1;
  Object call10251 = callmethodflags(*var_n, "args:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10242);
// compiled call node returning call10251 (depth = 3)
// Begin line 2685
  setline(2685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10252 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call10253 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe10252);
// compiled call node returning call10253 (depth = 3)
  gc_frame_end(frame);
  return call10253;
}
Object meth_ast__apply10262(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 2690
  setline(2690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10264 == NULL) {
    strlit10264 = alloc_String("  ");
    gc_root(strlit10264);
  }
// compiled string node returning strlit10264 (depth = 7)
  int op_slot_right_10263 = gc_frame_newslot(strlit10264);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_10263 = gc_frame_newslot(*var_spc);
  params[0] = strlit10264;
  partcv[0] = 1;
  Object opresult10266 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult10266 (depth = 6)
  *var_spc = opresult10266;
  if (opresult10266 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_10309(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2695
  setline(2695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10311 == NULL) {
    strlit10311 = alloc_String("");
    gc_root(strlit10311);
  }
// compiled string node returning strlit10311 (depth = 7)
  int op_slot_right_10310 = gc_frame_newslot(strlit10311);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10314 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10316 = alloc_Float64(4);
// compiled num node returning num10316 (depth = 10)
  int op_slot_right_10315 = gc_frame_newslot(num10316);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_10315 = gc_frame_newslot(*var_depth);
  params[0] = num10316;
  partcv[0] = 1;
  Object sum10318 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum10318 (depth = 9)
  gc_frame_newslot(sum10318);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  params[0] = sum10318;
  partcv[0] = 1;
  Object call10319 = callmethodflags(*var_a, "pretty(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10314);
// compiled call node returning call10319 (depth = 8)
  int op_slot_right_10313 = gc_frame_newslot(call10319);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10322 == NULL) {
    strlit10322 = alloc_String("");
    gc_root(strlit10322);
  }
// compiled string node returning strlit10322 (depth = 9)
  int op_slot_right_10321 = gc_frame_newslot(strlit10322);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_10324 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit10327 == NULL) {
    strlit10327 = alloc_String("""\x0a""    ");
    gc_root(strlit10327);
  }
// compiled string node returning strlit10327 (depth = 11)
  int op_slot_right_10326 = gc_frame_newslot(strlit10327);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_10329 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit10331 == NULL) {
    strlit10331 = alloc_String("");
    gc_root(strlit10331);
  }
// compiled string node returning strlit10331 (depth = 12)
  int op_slot_left_10329 = gc_frame_newslot(strlit10331);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10332 = callmethod(strlit10331, "++(1)", 1, partcv, params);
// compiled op node returning opresult10332 (depth = 11)
  int op_slot_left_10326 = gc_frame_newslot(opresult10332);
  params[0] = strlit10327;
  partcv[0] = 1;
  Object opresult10333 = callmethod(opresult10332, "++(1)", 1, partcv, params);
// compiled op node returning opresult10333 (depth = 10)
  int op_slot_left_10324 = gc_frame_newslot(opresult10333);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10334 = callmethod(opresult10333, "++(1)", 1, partcv, params);
// compiled op node returning opresult10334 (depth = 9)
  int op_slot_left_10321 = gc_frame_newslot(opresult10334);
  params[0] = strlit10322;
  partcv[0] = 1;
  Object opresult10335 = callmethod(opresult10334, "++(1)", 1, partcv, params);
// compiled op node returning opresult10335 (depth = 8)
  int op_slot_left_10313 = gc_frame_newslot(opresult10335);
  params[0] = call10319;
  partcv[0] = 1;
  Object opresult10336 = callmethod(opresult10335, "++(1)", 1, partcv, params);
// compiled op node returning opresult10336 (depth = 7)
  int op_slot_left_10310 = gc_frame_newslot(opresult10336);
  params[0] = strlit10311;
  partcv[0] = 1;
  Object opresult10337 = callmethod(opresult10336, "++(1)", 1, partcv, params);
// compiled op node returning opresult10337 (depth = 6)
  *var_s = opresult10337;
  if (opresult10337 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_10254(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2688
  setline(2688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10255 == NULL) {
    strlit10255 = alloc_String("");
    gc_root(strlit10255);
  }
// compiled string node returning strlit10255 (depth = 4)
  *var_spc = strlit10255;
  if (strlit10255 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2689
  setline(2689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10256 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10258 = alloc_Float64(1);
// compiled num node returning num10258 (depth = 5)
  int op_slot_right_10257 = gc_frame_newslot(num10258);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_left_10257 = gc_frame_newslot(*var_depth);
  params[0] = num10258;
  partcv[0] = 1;
  Object sum10260 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum10260 (depth = 4)
  gc_frame_newslot(sum10260);
// starting to compile block node (depth = 4)
  Object block10261 = alloc_Block(NULL, NULL, "ast", 2689);
  gc_frame_newslot(block10261);
// method "_apply"
  block_savedest(block10261);
  Object closure10262 = createclosure(2, "_apply");
  setclosureframe(closure10262, stackframe);
  addtoclosure(closure10262, var_spc);
  addtoclosure(closure10262, selfslot);
  struct UserObject *uo10262 = (struct UserObject*)block10261;
  uo10262->data[0] = (Object)closure10262;
  Method *meth_meth_ast__apply10262 = addmethod2pos(block10261, "_apply", &meth_ast__apply10262, 0);
  int argcv_meth_ast__apply10262[] = {0};
  meth_meth_ast__apply10262->type = alloc_MethodType(1, argcv_meth_ast__apply10262);
  meth_meth_ast__apply10262->definitionModule = modulename;
  meth_meth_ast__apply10262->definitionLine = 2981;
// compiled block node returning block10261 (depth = 4)
  gc_frame_newslot(block10261);
// call case 5: prelude request
  params[0] = sum10260;
  params[1] = block10261;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10269 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10256);
// compiled call node returning call10269 (depth = 3)
// Begin line 2692
  setline(2692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10271 == NULL) {
    strlit10271 = alloc_String("");
    gc_root(strlit10271);
  }
// compiled string node returning strlit10271 (depth = 5)
  int op_slot_right_10270 = gc_frame_newslot(strlit10271);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe10274 = gc_frame_new();
// call case 4: self request
  Object call10275 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10274);
// compiled member node returning call10275 (depth = 6)
  int op_slot_right_10273 = gc_frame_newslot(call10275);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10278 == NULL) {
    strlit10278 = alloc_String(": ");
    gc_root(strlit10278);
  }
// compiled string node returning strlit10278 (depth = 7)
  int op_slot_right_10277 = gc_frame_newslot(strlit10278);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10281 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call10282 = callmethod4(self, "pretty(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe10281);
// compiled call node returning call10282 (depth = 8)
  int op_slot_right_10280 = gc_frame_newslot(call10282);
// starting to compile string node (depth = 8)
  if (strlit10284 == NULL) {
    strlit10284 = alloc_String("");
    gc_root(strlit10284);
  }
// compiled string node returning strlit10284 (depth = 8)
  int op_slot_left_10280 = gc_frame_newslot(strlit10284);
  params[0] = call10282;
  partcv[0] = 1;
  Object opresult10285 = callmethod(strlit10284, "++(1)", 1, partcv, params);
// compiled op node returning opresult10285 (depth = 7)
  int op_slot_left_10277 = gc_frame_newslot(opresult10285);
  params[0] = strlit10278;
  partcv[0] = 1;
  Object opresult10286 = callmethod(opresult10285, "++(1)", 1, partcv, params);
// compiled op node returning opresult10286 (depth = 6)
  int op_slot_left_10273 = gc_frame_newslot(opresult10286);
  params[0] = call10275;
  partcv[0] = 1;
  Object opresult10287 = callmethod(opresult10286, "++(1)", 1, partcv, params);
// compiled op node returning opresult10287 (depth = 5)
  int op_slot_left_10270 = gc_frame_newslot(opresult10287);
  params[0] = strlit10271;
  partcv[0] = 1;
  Object opresult10288 = callmethod(opresult10287, "++(1)", 1, partcv, params);
// compiled op node returning opresult10288 (depth = 4)
  *var_s = opresult10288;
  if (opresult10288 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2693
  setline(2693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10290 == NULL) {
    strlit10290 = alloc_String("Args:");
    gc_root(strlit10290);
  }
// compiled string node returning strlit10290 (depth = 5)
  int op_slot_right_10289 = gc_frame_newslot(strlit10290);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_10292 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10295 == NULL) {
    strlit10295 = alloc_String("""\x0a""    ");
    gc_root(strlit10295);
  }
// compiled string node returning strlit10295 (depth = 7)
  int op_slot_right_10294 = gc_frame_newslot(strlit10295);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_right_10297 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 8)
  if (strlit10299 == NULL) {
    strlit10299 = alloc_String("");
    gc_root(strlit10299);
  }
// compiled string node returning strlit10299 (depth = 8)
  int op_slot_left_10297 = gc_frame_newslot(strlit10299);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10300 = callmethod(strlit10299, "++(1)", 1, partcv, params);
// compiled op node returning opresult10300 (depth = 7)
  int op_slot_left_10294 = gc_frame_newslot(opresult10300);
  params[0] = strlit10295;
  partcv[0] = 1;
  Object opresult10301 = callmethod(opresult10300, "++(1)", 1, partcv, params);
// compiled op node returning opresult10301 (depth = 6)
  int op_slot_left_10292 = gc_frame_newslot(opresult10301);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult10302 = callmethod(opresult10301, "++(1)", 1, partcv, params);
// compiled op node returning opresult10302 (depth = 5)
  int op_slot_left_10289 = gc_frame_newslot(opresult10302);
  params[0] = strlit10290;
  partcv[0] = 1;
  Object opresult10303 = callmethod(opresult10302, "++(1)", 1, partcv, params);
// compiled op node returning opresult10303 (depth = 4)
  *var_s = opresult10303;
  if (opresult10303 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 3)
// Begin line 2694
  setline(2694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10305 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10306 = gc_frame_new();
// call case 4: self request
  Object call10307 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10306);
// compiled member node returning call10307 (depth = 4)
  gc_frame_newslot(call10307);
// starting to compile block node (depth = 4)
  Object block10308 = alloc_Block(NULL, NULL, "ast", 2694);
  gc_frame_newslot(block10308);
// method "_apply(_)"
  block_savedest(block10308);
  Object closure10309 = createclosure(4, "_apply(1)");
  setclosureframe(closure10309, stackframe);
  addtoclosure(closure10309, var_depth);
  addtoclosure(closure10309, var_spc);
  addtoclosure(closure10309, var_s);
  addtoclosure(closure10309, selfslot);
  struct UserObject *uo10309 = (struct UserObject*)block10308;
  uo10309->data[0] = (Object)closure10309;
  Method *meth_meth_ast__apply_40_1_41_10309 = addmethod2pos(block10308, "_apply(1)", &meth_ast__apply_40_1_41_10309, 0);
  int argcv_meth_ast__apply_40_1_41_10309[] = {1};
  meth_meth_ast__apply_40_1_41_10309->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_10309);
  meth_meth_ast__apply_40_1_41_10309->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_10309->definitionLine = 2981;
// compiled block node returning block10308 (depth = 4)
  gc_frame_newslot(block10308);
// call case 5: prelude request
  params[0] = call10307;
  params[1] = block10308;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10340 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10305);
// compiled call node returning call10340 (depth = 3)
// Begin line 2697
  setline(2697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply_40_1_41_10360(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_tArg = &(stackframe->slots[0]);
  *var_tArg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2704
  setline(2704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10362 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10364 = alloc_Float64(1);
// compiled num node returning num10364 (depth = 10)
  int op_slot_right_10363 = gc_frame_newslot(num10364);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_10363 = gc_frame_newslot(*var_depth);
  params[0] = num10364;
  partcv[0] = 1;
  Object sum10366 = callmethod(*var_depth, "+(1)", 1, partcv, params);
// compiled op node returning sum10366 (depth = 9)
  gc_frame_newslot(sum10366);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tArg (depth = 9)
  params[0] = sum10366;
  partcv[0] = 1;
  Object call10367 = callmethodflags(*var_tArg, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10362);
// compiled call node returning call10367 (depth = 8)
  int op_slot_right_10361 = gc_frame_newslot(call10367);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_10361 = gc_frame_newslot(*var_s);
  params[0] = call10367;
  partcv[0] = 1;
  Object opresult10369 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10369 (depth = 7)
  *var_s = opresult10369;
  if (opresult10369 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply10373(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10375 == NULL) {
    strlit10375 = alloc_String(", ");
    gc_root(strlit10375);
  }
// compiled string node returning strlit10375 (depth = 8)
  int op_slot_right_10374 = gc_frame_newslot(strlit10375);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_10374 = gc_frame_newslot(*var_s);
  params[0] = strlit10375;
  partcv[0] = 1;
  Object opresult10377 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10377 (depth = 7)
  *var_s = opresult10377;
  if (opresult10377 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply_40_1_41_10425(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2712
  setline(2712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10427 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_arg (depth = 9)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call10428 = callmethodflags(*var_arg, "toGrace(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10427);
// compiled call node returning call10428 (depth = 8)
  int op_slot_right_10426 = gc_frame_newslot(call10428);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_10426 = gc_frame_newslot(*var_s);
  params[0] = call10428;
  partcv[0] = 1;
  Object opresult10430 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10430 (depth = 7)
  *var_s = opresult10430;
  if (opresult10430 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply10434(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 2714
  setline(2714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10436 == NULL) {
    strlit10436 = alloc_String(", ");
    gc_root(strlit10436);
  }
// compiled string node returning strlit10436 (depth = 8)
  int op_slot_right_10435 = gc_frame_newslot(strlit10436);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_10435 = gc_frame_newslot(*var_s);
  params[0] = strlit10436;
  partcv[0] = 1;
  Object opresult10438 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10438 (depth = 7)
  *var_s = opresult10438;
  if (opresult10438 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_10341(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
  Object *var_needsParens = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "needsParens");
// Begin line 2700
  setline(2700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10342 = gc_frame_new();
// call case 4: self request
  Object call10343 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10342);
// compiled member node returning call10343 (depth = 4)
  *var_s = call10343;
  if (call10343 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2701
  setline(2701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10346 = alloc_Float64(0);
// compiled num node returning num10346 (depth = 5)
  int op_slot_right_10345 = gc_frame_newslot(num10346);
// starting to compile member node (depth = 5)
  int callframe10348 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10349 = gc_frame_new();
// call case 4: self request
  Object call10350 = callmethodflags(self, "typeArgs", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10349);
// compiled member node returning call10350 (depth = 6)
  Object call10351 = callmethodflags(call10350, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10348);
// compiled member node returning call10351 (depth = 5)
  int op_slot_left_10345 = gc_frame_newslot(call10351);
  params[0] = num10346;
  partcv[0] = 1;
  Object opresult10352 = callmethod(call10351, ">(1)", 1, partcv, params);
// compiled op node returning opresult10352 (depth = 4)
  Object if10344 = done;
  if (istrue(opresult10352)) {
// Begin line 2702
  setline(2702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10354 == NULL) {
    strlit10354 = alloc_String("""\xe2""""\x9f""""\xa6""");
    gc_root(strlit10354);
  }
// compiled string node returning strlit10354 (depth = 6)
  int op_slot_right_10353 = gc_frame_newslot(strlit10354);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_10353 = gc_frame_newslot(*var_s);
  params[0] = strlit10354;
  partcv[0] = 1;
  Object opresult10356 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10356 (depth = 5)
  *var_s = opresult10356;
  if (opresult10356 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2703
  setline(2703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10358 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block10359 = alloc_Block(NULL, NULL, "ast", 2703);
  gc_frame_newslot(block10359);
// method "_apply(_)"
  block_savedest(block10359);
  Object closure10360 = createclosure(3, "_apply(1)");
  setclosureframe(closure10360, stackframe);
  addtoclosure(closure10360, var_depth);
  addtoclosure(closure10360, var_s);
  addtoclosure(closure10360, selfslot);
  struct UserObject *uo10360 = (struct UserObject*)block10359;
  uo10360->data[0] = (Object)closure10360;
  Method *meth_meth_ast__apply_40_1_41_10360 = addmethod2pos(block10359, "_apply(1)", &meth_ast__apply_40_1_41_10360, 0);
  int argcv_meth_ast__apply_40_1_41_10360[] = {1};
  meth_meth_ast__apply_40_1_41_10360->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_10360);
  meth_meth_ast__apply_40_1_41_10360->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_10360->definitionLine = 2981;
// compiled block node returning block10359 (depth = 5)
  gc_frame_newslot(block10359);
// Begin line 2705
  setline(2705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block10372 = alloc_Block(NULL, NULL, "ast", 2705);
  gc_frame_newslot(block10372);
// method "_apply"
  block_savedest(block10372);
  Object closure10373 = createclosure(2, "_apply");
  setclosureframe(closure10373, stackframe);
  addtoclosure(closure10373, var_s);
  addtoclosure(closure10373, selfslot);
  struct UserObject *uo10373 = (struct UserObject*)block10372;
  uo10373->data[0] = (Object)closure10373;
  Method *meth_meth_ast__apply10373 = addmethod2pos(block10372, "_apply", &meth_ast__apply10373, 0);
  int argcv_meth_ast__apply10373[] = {0};
  meth_meth_ast__apply10373->type = alloc_MethodType(1, argcv_meth_ast__apply10373);
  meth_meth_ast__apply10373->definitionModule = modulename;
  meth_meth_ast__apply10373->definitionLine = 2981;
// compiled block node returning block10372 (depth = 5)
  gc_frame_newslot(block10372);
// call case 6: other requests
// Begin line 2703
  setline(2703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe10380 = gc_frame_new();
// call case 4: self request
  Object call10381 = callmethodflags(self, "typeArgs", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10380);
// compiled member node returning call10381 (depth = 5)
  params[0] = block10359;
  params[1] = block10372;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10382 = callmethodflags(call10381, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10358);
// compiled call node returning call10382 (depth = 4)
// Begin line 2706
  setline(2706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10384 == NULL) {
    strlit10384 = alloc_String("""\xe2""""\x9f""""\xa7""");
    gc_root(strlit10384);
  }
// compiled string node returning strlit10384 (depth = 6)
  int op_slot_right_10383 = gc_frame_newslot(strlit10384);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_10383 = gc_frame_newslot(*var_s);
  params[0] = strlit10384;
  partcv[0] = 1;
  Object opresult10386 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10386 (depth = 5)
  *var_s = opresult10386;
  if (opresult10386 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10344 = done;
  } else {
  }
// compiled if node returning if10344 (depth = 3)
// Begin line 2708
  setline(2708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10390 = alloc_Float64(0);
// compiled num node returning num10390 (depth = 5)
  int op_slot_right_10389 = gc_frame_newslot(num10390);
// starting to compile member node (depth = 5)
  int callframe10392 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10393 = gc_frame_new();
// call case 4: self request
  Object call10394 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10393);
// compiled member node returning call10394 (depth = 6)
  Object call10395 = callmethodflags(call10394, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10392);
// compiled member node returning call10395 (depth = 5)
  int op_slot_left_10389 = gc_frame_newslot(call10395);
  params[0] = num10390;
  partcv[0] = 1;
  Object opresult10396 = callmethod(call10395, ">(1)", 1, partcv, params);
// compiled op node returning opresult10396 (depth = 4)
  Object if10388 = done;
  if (istrue(opresult10396)) {
// Begin line 2709
  setline(2709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe10398 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe10399 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe10400 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe10401 = gc_frame_new();
// call case 4: self request
  Object call10402 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10401);
// compiled member node returning call10402 (depth = 9)
  Object call10403 = callmethodflags(call10402, "first", 0, partcv, params, 0);
  gc_frame_end(callframe10400);
// compiled member node returning call10403 (depth = 8)
  Object call10404 = callmethodflags(call10403, "isDelimited", 0, partcv, params, 0);
  gc_frame_end(callframe10399);
// compiled member node returning call10404 (depth = 7)
  Object call10405 = callmethodflags(call10404, "not", 0, partcv, params, 0);
  gc_frame_end(callframe10398);
// compiled member node returning call10405 (depth = 6)
  int op_slot_right_10397 = gc_frame_newslot(call10405);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10408 = alloc_Float64(1);
// compiled num node returning num10408 (depth = 7)
  int op_slot_right_10407 = gc_frame_newslot(num10408);
// starting to compile member node (depth = 7)
  int callframe10410 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe10411 = gc_frame_new();
// call case 4: self request
  Object call10412 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10411);
// compiled member node returning call10412 (depth = 8)
  Object call10413 = callmethodflags(call10412, "size", 0, partcv, params, 0);
  gc_frame_end(callframe10410);
// compiled member node returning call10413 (depth = 7)
  int op_slot_left_10407 = gc_frame_newslot(call10413);
  params[0] = num10408;
  partcv[0] = 1;
  Object opresult10414 = callmethod(call10413, ">(1)", 1, partcv, params);
// compiled op node returning opresult10414 (depth = 6)
  int op_slot_left_10397 = gc_frame_newslot(opresult10414);
  params[0] = call10405;
  partcv[0] = 1;
  Object opresult10415 = callmethod(opresult10414, "||(1)", 1, partcv, params);
// compiled op node returning opresult10415 (depth = 5)
  *var_needsParens = opresult10415;
  if (opresult10415 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2710
  setline(2710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile if node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_needsParens (depth = 7)
  Object if10417 = done;
struct StackFrameObject *iftmpstackframe10417 = stackframe;
  if (istrue(*var_needsParens)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10417);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 7)
  if (strlit10418 == NULL) {
    strlit10418 = alloc_String("(");
    gc_root(strlit10418);
  }
// compiled string node returning strlit10418 (depth = 7)
    gc_frame_newslot(strlit10418);
    if10417 = strlit10418;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe10417);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 7)
  if (strlit10419 == NULL) {
    strlit10419 = alloc_String(" ");
    gc_root(strlit10419);
  }
// compiled string node returning strlit10419 (depth = 7)
    gc_frame_newslot(strlit10419);
    if10417 = strlit10419;
  }
stackframe = iftmpstackframe10417;
// compiled if node returning if10417 (depth = 6)
  int op_slot_right_10416 = gc_frame_newslot(if10417);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_10416 = gc_frame_newslot(*var_s);
  params[0] = if10417;
  partcv[0] = 1;
  Object opresult10421 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10421 (depth = 5)
  *var_s = opresult10421;
  if (opresult10421 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2711
  setline(2711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10423 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block10424 = alloc_Block(NULL, NULL, "ast", 2711);
  gc_frame_newslot(block10424);
// method "_apply(_)"
  block_savedest(block10424);
  Object closure10425 = createclosure(3, "_apply(1)");
  setclosureframe(closure10425, stackframe);
  addtoclosure(closure10425, var_depth);
  addtoclosure(closure10425, var_s);
  addtoclosure(closure10425, selfslot);
  struct UserObject *uo10425 = (struct UserObject*)block10424;
  uo10425->data[0] = (Object)closure10425;
  Method *meth_meth_ast__apply_40_1_41_10425 = addmethod2pos(block10424, "_apply(1)", &meth_ast__apply_40_1_41_10425, 0);
  int argcv_meth_ast__apply_40_1_41_10425[] = {1};
  meth_meth_ast__apply_40_1_41_10425->type = alloc_MethodType(1, argcv_meth_ast__apply_40_1_41_10425);
  meth_meth_ast__apply_40_1_41_10425->definitionModule = modulename;
  meth_meth_ast__apply_40_1_41_10425->definitionLine = 2981;
// compiled block node returning block10424 (depth = 5)
  gc_frame_newslot(block10424);
// Begin line 2713
  setline(2713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block10433 = alloc_Block(NULL, NULL, "ast", 2713);
  gc_frame_newslot(block10433);
// method "_apply"
  block_savedest(block10433);
  Object closure10434 = createclosure(2, "_apply");
  setclosureframe(closure10434, stackframe);
  addtoclosure(closure10434, var_s);
  addtoclosure(closure10434, selfslot);
  struct UserObject *uo10434 = (struct UserObject*)block10433;
  uo10434->data[0] = (Object)closure10434;
  Method *meth_meth_ast__apply10434 = addmethod2pos(block10433, "_apply", &meth_ast__apply10434, 0);
  int argcv_meth_ast__apply10434[] = {0};
  meth_meth_ast__apply10434->type = alloc_MethodType(1, argcv_meth_ast__apply10434);
  meth_meth_ast__apply10434->definitionModule = modulename;
  meth_meth_ast__apply10434->definitionLine = 2981;
// compiled block node returning block10433 (depth = 5)
  gc_frame_newslot(block10433);
// call case 6: other requests
// Begin line 2711
  setline(2711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe10441 = gc_frame_new();
// call case 4: self request
  Object call10442 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10441);
// compiled member node returning call10442 (depth = 5)
  params[0] = block10424;
  params[1] = block10433;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10443 = callmethodflags(call10442, "do(1)separatedBy(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10423);
// compiled call node returning call10443 (depth = 4)
// Begin line 2716
  setline(2716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_needsParens (depth = 5)
  Object if10444 = done;
  if (istrue(*var_needsParens)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10446 == NULL) {
    strlit10446 = alloc_String(")");
    gc_root(strlit10446);
  }
// compiled string node returning strlit10446 (depth = 7)
  int op_slot_right_10445 = gc_frame_newslot(strlit10446);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_10445 = gc_frame_newslot(*var_s);
  params[0] = strlit10446;
  partcv[0] = 1;
  Object opresult10448 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10448 (depth = 6)
  *var_s = opresult10448;
  if (opresult10448 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if10444 = done;
  } else {
  }
// compiled if node returning if10444 (depth = 4)
    gc_frame_newslot(if10444);
    if10388 = if10444;
  } else {
  }
// compiled if node returning if10388 (depth = 3)
// Begin line 2718
  setline(2718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy10450(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_requestPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2722
  setline(2722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10451 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe10452 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe10453 = gc_frame_new();
// call case 4: self request
  Object call10454 = callmethodflags(self, "name", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10453);
// compiled member node returning call10454 (depth = 5)
  gc_frame_newslot(call10454);
// starting to compile member node (depth = 5)
  int callframe10455 = gc_frame_new();
// call case 4: self request
  Object call10456 = callmethodflags(self, "args", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10455);
// compiled member node returning call10456 (depth = 5)
  gc_frame_newslot(call10456);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_requestPart (depth = 5)
  params[0] = call10454;
  params[1] = call10456;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10457 = callmethodflags(*var_requestPart, "request(1)withArgs(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10452);
// compiled call node returning call10457 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call10458 = callmethodflags(call10457, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10451);
// compiled call node returning call10458 (depth = 3)
  gc_frame_end(frame);
  return call10458;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_10459(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2725
  setline(2725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10460 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call10461 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe10460);
// compiled call node returning call10461 (depth = 3)
// Begin line 2726
  setline(2726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10462 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10463 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call10464 = callmethodflags(*var_other, "lineLength", 0, partcv, params, 0);
  gc_frame_end(callframe10463);
// compiled member node returning call10464 (depth = 4)
  gc_frame_newslot(call10464);
// call case 4: self request
  params[0] = call10464;
  partcv[0] = 1;
  Object call10465 = callmethodflags(self, "lineLength:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10462);
// compiled call node returning call10465 (depth = 3)
// Begin line 2727
  setline(2727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName10466(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2729
  setline(2729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10467 == NULL) {
    strlit10467 = alloc_String("request");
    gc_root(strlit10467);
  }
// compiled string node returning strlit10467 (depth = 3)
  gc_frame_end(frame);
  return strlit10467;
}
Object meth_ast_request_40_1_41_withArgs_40_1_41_10154(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "request(1)withArgs(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request(_)withArgs(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request(_)withArgs(_)");
  Object params[1];
  int partcv[2];
  Object *var_requestPart = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for request(_)withArgs(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_rPart = &(stackframe->slots[0]);
  *var_rPart = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part request(_)");
  Object *var_xs = &(stackframe->slots[1]);
  *var_xs = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withArgs(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10155 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10155 = alloc_userobj2(17,14, objclass10155);
  gc_frame_newslot(obj10155);
if (objclass10155 == NULL) {
  glfree(obj10155->class->name);
  obj10155->class->name = "requestPart.request(_)withArgs(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10155, self, 0);
  addmethodreal(obj10155,"outer", &reader_ast_outer_10156);
  Object oldself10155 = self;
  struct StackFrameObject *oldstackframe10155 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10155);
  gc_frame_newslot((Object)stackframe);
  self = obj10155;
  Object *oldselfslot10155 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10155 = (*(struct UserObject *)self).data[0], lowerouter10155 = thisouter10155;
  if (inheritingObject10155) {
    struct UserObject *inho10155 = (struct UserObject *)inheritingObject10155;
    while (inho10155->super != GraceDefaultObject) inho10155 = (struct UserObject *)inho10155->super;
    inho10155->super = obj10155;
    self = inheritingObject10155;
    *selfslot = self;
    lowerouter10155 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10155;
  }
if (objclass10155 == NULL) {
  Method *reader10157 = addmethodrealflags(obj10155, "kind",&reader_ast_kind_10157, MFLAG_DEF);
  reader10157->definitionModule = modulename;
  reader10157->definitionLine = 2662;
}
adddatum2(obj10155, alloc_Undefined(), 1);
if (objclass10155 == NULL) {
  Method *reader10158 = addmethodrealflags(obj10155, "name", &reader_ast_name_10158, 0);
  Method *writer10158 = addmethodrealflags(obj10155, "name:=(1)", &writer_ast_name_10158, 0);
  reader10158->definitionModule = modulename;
  writer10158->definitionModule = modulename;
  reader10158->definitionLine = 2663;
  writer10158->definitionLine = 2663;
}
obj10155->flags |= OFLAG_MUTABLE;
adddatum2(obj10155, alloc_Undefined(), 2);
if (objclass10155 == NULL) {
  Method *reader10159 = addmethodrealflags(obj10155, "args", &reader_ast_args_10159, 0);
  Method *writer10159 = addmethodrealflags(obj10155, "args:=(1)", &writer_ast_args_10159, 0);
  reader10159->definitionModule = modulename;
  writer10159->definitionModule = modulename;
  reader10159->definitionLine = 2664;
  writer10159->definitionLine = 2664;
}
obj10155->flags |= OFLAG_MUTABLE;
adddatum2(obj10155, alloc_Undefined(), 3);
if (objclass10155 == NULL) {
  Method *reader10160 = addmethodrealflags(obj10155, "typeArgs", &reader_ast_typeArgs_10160, MFLAG_CONFIDENTIAL);
  Method *writer10160 = addmethodrealflags(obj10155, "typeArgs:=(1)", &writer_ast_typeArgs_10160, MFLAG_CONFIDENTIAL);
  reader10160->definitionModule = modulename;
  writer10160->definitionModule = modulename;
  reader10160->definitionLine = 2665;
  writer10160->definitionLine = 2665;
}
obj10155->flags |= OFLAG_MUTABLE;
adddatum2(obj10155, alloc_Undefined(), 4);
if (objclass10155 == NULL) {
  Method *reader10161 = addmethodrealflags(obj10155, "lineLength", &reader_ast_lineLength_10161, 0);
  Method *writer10161 = addmethodrealflags(obj10155, "lineLength:=(1)", &writer_ast_lineLength_10161, 0);
  reader10161->definitionModule = modulename;
  writer10161->definitionModule = modulename;
  reader10161->definitionLine = 2666;
  writer10161->definitionLine = 2666;
}
obj10155->flags |= OFLAG_MUTABLE;
adddatum2(obj10155, alloc_Undefined(), 5);
// method "nameString"
  struct UserObject *uo10162 = (struct UserObject*)obj10155;
  uo10162->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString10162 = addmethod2pos(obj10155, "nameString", &meth_ast_nameString10162, 6);
  int argcv_meth_ast_nameString10162[] = {0};
  meth_meth_ast_nameString10162->type = alloc_MethodType(1, argcv_meth_ast_nameString10162);
  meth_meth_ast_nameString10162->definitionModule = modulename;
  meth_meth_ast_nameString10162->definitionLine = 2668;
// method "canonicalName"
  struct UserObject *uo10191 = (struct UserObject*)obj10155;
  uo10191->data[7] = emptyclosure;
  Method *meth_meth_ast_canonicalName10191 = addmethod2pos(obj10155, "canonicalName", &meth_ast_canonicalName10191, 7);
  int argcv_meth_ast_canonicalName10191[] = {0};
  meth_meth_ast_canonicalName10191->type = alloc_MethodType(1, argcv_meth_ast_canonicalName10191);
  meth_meth_ast_canonicalName10191->definitionModule = modulename;
  meth_meth_ast_canonicalName10191->definitionLine = 2673;
// method "map(_)ancestors(_)"
  struct UserObject *uo10237 = (struct UserObject*)obj10155;
  uo10237->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_10237 = addmethod2pos(obj10155, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_10237, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_10237[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10237->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_10237);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10237->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10237->definitionLine = 2681;
// method "pretty(_)"
  struct UserObject *uo10254 = (struct UserObject*)obj10155;
  uo10254->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_10254 = addmethod2pos(obj10155, "pretty(1)", &meth_ast_pretty_40_1_41_10254, 9);
  int argcv_meth_ast_pretty_40_1_41_10254[] = {1};
  meth_meth_ast_pretty_40_1_41_10254->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_10254);
  meth_meth_ast_pretty_40_1_41_10254->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_10254->definitionLine = 2687;
// method "toGrace(_)"
  struct UserObject *uo10341 = (struct UserObject*)obj10155;
  uo10341->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_10341 = addmethod2pos(obj10155, "toGrace(1)", &meth_ast_toGrace_40_1_41_10341, 10);
  int argcv_meth_ast_toGrace_40_1_41_10341[] = {1};
  meth_meth_ast_toGrace_40_1_41_10341->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_10341);
  meth_meth_ast_toGrace_40_1_41_10341->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_10341->definitionLine = 2699;
// method "shallowCopy"
  block_savedest(obj10155);
  Object closure10450 = createclosure(1, "shallowCopy");
  setclosureframe(closure10450, stackframe);
  addtoclosure(closure10450, var_requestPart);
  struct UserObject *uo10450 = (struct UserObject*)obj10155;
  uo10450->data[11] = (Object)closure10450;
  Method *meth_meth_ast_shallowCopy10450 = addmethod2pos(obj10155, "shallowCopy", &meth_ast_shallowCopy10450, 11);
  int argcv_meth_ast_shallowCopy10450[] = {0};
  meth_meth_ast_shallowCopy10450->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10450);
  meth_meth_ast_shallowCopy10450->definitionModule = modulename;
  meth_meth_ast_shallowCopy10450->definitionLine = 2721;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo10459 = (struct UserObject*)obj10155;
  uo10459->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10459 = addmethod2pos(obj10155, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_10459, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10459[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10459->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10459);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10459->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10459->definitionLine = 2724;
// method "statementName"
  struct UserObject *uo10466 = (struct UserObject*)obj10155;
  uo10466->data[13] = emptyclosure;
  Method *meth_meth_ast_statementName10466 = addmethod2pos(obj10155, "statementName", &meth_ast_statementName10466, 13);
  int argcv_meth_ast_statementName10466[] = {0};
  meth_meth_ast_statementName10466->type = alloc_MethodType(1, argcv_meth_ast_statementName10466);
  meth_meth_ast_statementName10466->definitionModule = modulename;
  meth_meth_ast_statementName10466->definitionLine = 2729;
  sourceObject = obj10155;
// Begin line 2661
  setline(2661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10468 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10469 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10470 = gc_frame_new();
// call case 3: self.outer request
  Object call10471 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10470);
// compiled member node returning call10471 (depth = 5)
  Object call10472 = callmethodflags(call10471, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe10469);
// compiled member node returning call10472 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10473 = callmethodflags(call10472, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10468);
// compiled call node returning call10473 (depth = 3)
  struct UserObject *obj10155_uo = (struct UserObject *)obj10155;
  obj10155_uo->super = call10473;
  sourceObject = obj10155;
// Begin line 2662
  setline(2662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10474 == NULL) {
    strlit10474 = alloc_String("callwithpart");
    gc_root(strlit10474);
  }
// compiled string node returning strlit10474 (depth = 3)
  adddatum2(obj10155, strlit10474, 1);
  sourceObject = obj10155;
// Begin line 2663
  setline(2663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rPart (depth = 3)
  adddatum2(obj10155, *var_rPart, 2);
  sourceObject = obj10155;
// Begin line 2664
  setline(2664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_xs (depth = 3)
  adddatum2(obj10155, *var_xs, 3);
  sourceObject = obj10155;
// Begin line 2665
  setline(2665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySeq (depth = 3)
  adddatum2(obj10155, *var_emptySeq, 4);
  sourceObject = obj10155;
// Begin line 2666
  setline(2666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num10475 = alloc_Float64(0);
// compiled num node returning num10475 (depth = 3)
  adddatum2(obj10155, num10475, 5);
  sourceObject = obj10155;
  sourceObject = obj10155;
  sourceObject = obj10155;
  sourceObject = obj10155;
  sourceObject = obj10155;
  sourceObject = obj10155;
  sourceObject = obj10155;
  sourceObject = obj10155;
  objclass10155 = obj10155->class;
  objclass10155->definitionModule = modulename;
  objclass10155->definitionLine = 2660;
  (*(struct UserObject *)self).data[0] = lowerouter10155;
  self = oldself10155;
  selfslot = oldselfslot10155;
  stackframe = oldstackframe10155;
  gc_frame_end(frame);
  return obj10155;
}
Object meth_ast_request_40_1_41_withArgs_40_1_41_10154_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "request(1)withArgs(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method request(_)withArgs(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method request(_)withArgs(_)");
  Object params[1];
  int partcv[2];
  Object *var_requestPart = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for request(_)withArgs(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_rPart = &(stackframe->slots[0]);
  *var_rPart = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part request(_)");
  Object *var_xs = &(stackframe->slots[1]);
  *var_xs = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withArgs(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10155 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10155 = alloc_userobj2(17,14, objclass10155);
  gc_frame_newslot(obj10155);
if (objclass10155 == NULL) {
  glfree(obj10155->class->name);
  obj10155->class->name = "requestPart.request(_)withArgs(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10155, self, 0);
  addmethodreal(obj10155,"outer", &reader_ast_outer_10156);
  Object oldself10155 = self;
  struct StackFrameObject *oldstackframe10155 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10155);
  gc_frame_newslot((Object)stackframe);
  self = obj10155;
  Object *oldselfslot10155 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10155 = (*(struct UserObject *)self).data[0], lowerouter10155 = thisouter10155;
  if (inheritingObject10155) {
    struct UserObject *inho10155 = (struct UserObject *)inheritingObject10155;
    while (inho10155->super != GraceDefaultObject) inho10155 = (struct UserObject *)inho10155->super;
    inho10155->super = obj10155;
    self = inheritingObject10155;
    *selfslot = self;
    lowerouter10155 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10155;
  }
if (objclass10155 == NULL) {
  Method *reader10157 = addmethodrealflags(obj10155, "kind",&reader_ast_kind_10157, MFLAG_DEF);
  reader10157->definitionModule = modulename;
  reader10157->definitionLine = 2662;
}
adddatum2(obj10155, alloc_Undefined(), 1);
if (objclass10155 == NULL) {
  Method *reader10158 = addmethodrealflags(obj10155, "name", &reader_ast_name_10158, 0);
  Method *writer10158 = addmethodrealflags(obj10155, "name:=(1)", &writer_ast_name_10158, 0);
  reader10158->definitionModule = modulename;
  writer10158->definitionModule = modulename;
  reader10158->definitionLine = 2663;
  writer10158->definitionLine = 2663;
}
obj10155->flags |= OFLAG_MUTABLE;
adddatum2(obj10155, alloc_Undefined(), 2);
if (objclass10155 == NULL) {
  Method *reader10159 = addmethodrealflags(obj10155, "args", &reader_ast_args_10159, 0);
  Method *writer10159 = addmethodrealflags(obj10155, "args:=(1)", &writer_ast_args_10159, 0);
  reader10159->definitionModule = modulename;
  writer10159->definitionModule = modulename;
  reader10159->definitionLine = 2664;
  writer10159->definitionLine = 2664;
}
obj10155->flags |= OFLAG_MUTABLE;
adddatum2(obj10155, alloc_Undefined(), 3);
if (objclass10155 == NULL) {
  Method *reader10160 = addmethodrealflags(obj10155, "typeArgs", &reader_ast_typeArgs_10160, MFLAG_CONFIDENTIAL);
  Method *writer10160 = addmethodrealflags(obj10155, "typeArgs:=(1)", &writer_ast_typeArgs_10160, MFLAG_CONFIDENTIAL);
  reader10160->definitionModule = modulename;
  writer10160->definitionModule = modulename;
  reader10160->definitionLine = 2665;
  writer10160->definitionLine = 2665;
}
obj10155->flags |= OFLAG_MUTABLE;
adddatum2(obj10155, alloc_Undefined(), 4);
if (objclass10155 == NULL) {
  Method *reader10161 = addmethodrealflags(obj10155, "lineLength", &reader_ast_lineLength_10161, 0);
  Method *writer10161 = addmethodrealflags(obj10155, "lineLength:=(1)", &writer_ast_lineLength_10161, 0);
  reader10161->definitionModule = modulename;
  writer10161->definitionModule = modulename;
  reader10161->definitionLine = 2666;
  writer10161->definitionLine = 2666;
}
obj10155->flags |= OFLAG_MUTABLE;
adddatum2(obj10155, alloc_Undefined(), 5);
// method "nameString"
  struct UserObject *uo10162 = (struct UserObject*)obj10155;
  uo10162->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString10162 = addmethod2pos(obj10155, "nameString", &meth_ast_nameString10162, 6);
  int argcv_meth_ast_nameString10162[] = {0};
  meth_meth_ast_nameString10162->type = alloc_MethodType(1, argcv_meth_ast_nameString10162);
  meth_meth_ast_nameString10162->definitionModule = modulename;
  meth_meth_ast_nameString10162->definitionLine = 2668;
// method "canonicalName"
  struct UserObject *uo10191 = (struct UserObject*)obj10155;
  uo10191->data[7] = emptyclosure;
  Method *meth_meth_ast_canonicalName10191 = addmethod2pos(obj10155, "canonicalName", &meth_ast_canonicalName10191, 7);
  int argcv_meth_ast_canonicalName10191[] = {0};
  meth_meth_ast_canonicalName10191->type = alloc_MethodType(1, argcv_meth_ast_canonicalName10191);
  meth_meth_ast_canonicalName10191->definitionModule = modulename;
  meth_meth_ast_canonicalName10191->definitionLine = 2673;
// method "map(_)ancestors(_)"
  struct UserObject *uo10237 = (struct UserObject*)obj10155;
  uo10237->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_10237 = addmethod2pos(obj10155, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_10237, 8);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_10237[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10237->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_10237);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10237->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10237->definitionLine = 2681;
// method "pretty(_)"
  struct UserObject *uo10254 = (struct UserObject*)obj10155;
  uo10254->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_10254 = addmethod2pos(obj10155, "pretty(1)", &meth_ast_pretty_40_1_41_10254, 9);
  int argcv_meth_ast_pretty_40_1_41_10254[] = {1};
  meth_meth_ast_pretty_40_1_41_10254->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_10254);
  meth_meth_ast_pretty_40_1_41_10254->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_10254->definitionLine = 2687;
// method "toGrace(_)"
  struct UserObject *uo10341 = (struct UserObject*)obj10155;
  uo10341->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_10341 = addmethod2pos(obj10155, "toGrace(1)", &meth_ast_toGrace_40_1_41_10341, 10);
  int argcv_meth_ast_toGrace_40_1_41_10341[] = {1};
  meth_meth_ast_toGrace_40_1_41_10341->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_10341);
  meth_meth_ast_toGrace_40_1_41_10341->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_10341->definitionLine = 2699;
// method "shallowCopy"
  block_savedest(obj10155);
  Object closure10450 = createclosure(1, "shallowCopy");
  setclosureframe(closure10450, stackframe);
  addtoclosure(closure10450, var_requestPart);
  struct UserObject *uo10450 = (struct UserObject*)obj10155;
  uo10450->data[11] = (Object)closure10450;
  Method *meth_meth_ast_shallowCopy10450 = addmethod2pos(obj10155, "shallowCopy", &meth_ast_shallowCopy10450, 11);
  int argcv_meth_ast_shallowCopy10450[] = {0};
  meth_meth_ast_shallowCopy10450->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10450);
  meth_meth_ast_shallowCopy10450->definitionModule = modulename;
  meth_meth_ast_shallowCopy10450->definitionLine = 2721;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo10459 = (struct UserObject*)obj10155;
  uo10459->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10459 = addmethod2pos(obj10155, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_10459, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10459[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10459->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10459);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10459->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10459->definitionLine = 2724;
// method "statementName"
  struct UserObject *uo10466 = (struct UserObject*)obj10155;
  uo10466->data[13] = emptyclosure;
  Method *meth_meth_ast_statementName10466 = addmethod2pos(obj10155, "statementName", &meth_ast_statementName10466, 13);
  int argcv_meth_ast_statementName10466[] = {0};
  meth_meth_ast_statementName10466->type = alloc_MethodType(1, argcv_meth_ast_statementName10466);
  meth_meth_ast_statementName10466->definitionModule = modulename;
  meth_meth_ast_statementName10466->definitionLine = 2729;
  sourceObject = obj10155;
// Begin line 2661
  setline(2661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10468 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10469 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10470 = gc_frame_new();
// call case 3: self.outer request
  Object call10471 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10470);
// compiled member node returning call10471 (depth = 5)
  Object call10472 = callmethodflags(call10471, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe10469);
// compiled member node returning call10472 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10473 = callmethodflags(call10472, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10468);
// compiled call node returning call10473 (depth = 3)
  struct UserObject *obj10155_uo = (struct UserObject *)obj10155;
  obj10155_uo->super = call10473;
  sourceObject = obj10155;
// Begin line 2662
  setline(2662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10474 == NULL) {
    strlit10474 = alloc_String("callwithpart");
    gc_root(strlit10474);
  }
// compiled string node returning strlit10474 (depth = 3)
  adddatum2(obj10155, strlit10474, 1);
  sourceObject = obj10155;
// Begin line 2663
  setline(2663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rPart (depth = 3)
  adddatum2(obj10155, *var_rPart, 2);
  sourceObject = obj10155;
// Begin line 2664
  setline(2664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_xs (depth = 3)
  adddatum2(obj10155, *var_xs, 3);
  sourceObject = obj10155;
// Begin line 2665
  setline(2665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySeq (depth = 3)
  adddatum2(obj10155, *var_emptySeq, 4);
  sourceObject = obj10155;
// Begin line 2666
  setline(2666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num10475 = alloc_Float64(0);
// compiled num node returning num10475 (depth = 3)
  adddatum2(obj10155, num10475, 5);
  sourceObject = obj10155;
  sourceObject = obj10155;
  sourceObject = obj10155;
  sourceObject = obj10155;
  sourceObject = obj10155;
  sourceObject = obj10155;
  sourceObject = obj10155;
  sourceObject = obj10155;
  objclass10155 = obj10155->class;
  objclass10155->definitionModule = modulename;
  objclass10155->definitionLine = 2660;
  (*(struct UserObject *)self).data[0] = lowerouter10155;
  self = oldself10155;
  selfslot = oldselfslot10155;
  stackframe = oldstackframe10155;
  gc_frame_end(frame);
  return obj10155;
}
Object meth_ast_requestPart10477(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 50, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "requestPart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_requestPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2651
  setline(2651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_requestPart (depth = 3)
  gc_frame_end(frame);
  return *var_requestPart;
}
Object meth_ast_isComment10488(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isComment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2741
  setline(2741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10489 = alloc_Boolean(1);
// compiled identifier node returning bool10489 (depth = 3)
  gc_frame_end(frame);
  return bool10489;
}
Object meth_ast_isLegalInTrait10490(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2742
  setline(2742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10491 = alloc_Boolean(1);
// compiled identifier node returning bool10491 (depth = 3)
  gc_frame_end(frame);
  return bool10491;
}
Object meth_ast_isExecutable10492(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2743
  setline(2743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10493 = alloc_Boolean(0);
// compiled identifier node returning bool10493 (depth = 3)
  gc_frame_end(frame);
  return bool10493;
}
Object meth_ast_asString10494(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2744
  setline(2744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10496 == NULL) {
    strlit10496 = alloc_String("");
    gc_root(strlit10496);
  }
// compiled string node returning strlit10496 (depth = 4)
  int op_slot_right_10495 = gc_frame_newslot(strlit10496);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10499 = gc_frame_new();
// call case 4: self request
  Object call10500 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10499);
// compiled member node returning call10500 (depth = 5)
  int op_slot_right_10498 = gc_frame_newslot(call10500);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10503 == NULL) {
    strlit10503 = alloc_String("): ");
    gc_root(strlit10503);
  }
// compiled string node returning strlit10503 (depth = 6)
  int op_slot_right_10502 = gc_frame_newslot(strlit10503);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe10506 = gc_frame_new();
// call case 4: self request
  Object call10507 = callmethodflags(self, "endLine", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10506);
// compiled member node returning call10507 (depth = 7)
  int op_slot_right_10505 = gc_frame_newslot(call10507);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10510 == NULL) {
    strlit10510 = alloc_String("""\xe2""""\x80""""\x93""");
    gc_root(strlit10510);
  }
// compiled string node returning strlit10510 (depth = 8)
  int op_slot_right_10509 = gc_frame_newslot(strlit10510);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe10513 = gc_frame_new();
// call case 4: self request
  Object call10514 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10513);
// compiled member node returning call10514 (depth = 9)
  int op_slot_right_10512 = gc_frame_newslot(call10514);
// starting to compile string node (depth = 9)
  if (strlit10516 == NULL) {
    strlit10516 = alloc_String("comment (");
    gc_root(strlit10516);
  }
// compiled string node returning strlit10516 (depth = 9)
  int op_slot_left_10512 = gc_frame_newslot(strlit10516);
  params[0] = call10514;
  partcv[0] = 1;
  Object opresult10517 = callmethod(strlit10516, "++(1)", 1, partcv, params);
// compiled op node returning opresult10517 (depth = 8)
  int op_slot_left_10509 = gc_frame_newslot(opresult10517);
  params[0] = strlit10510;
  partcv[0] = 1;
  Object opresult10518 = callmethod(opresult10517, "++(1)", 1, partcv, params);
// compiled op node returning opresult10518 (depth = 7)
  int op_slot_left_10505 = gc_frame_newslot(opresult10518);
  params[0] = call10507;
  partcv[0] = 1;
  Object opresult10519 = callmethod(opresult10518, "++(1)", 1, partcv, params);
// compiled op node returning opresult10519 (depth = 6)
  int op_slot_left_10502 = gc_frame_newslot(opresult10519);
  params[0] = strlit10503;
  partcv[0] = 1;
  Object opresult10520 = callmethod(opresult10519, "++(1)", 1, partcv, params);
// compiled op node returning opresult10520 (depth = 5)
  int op_slot_left_10498 = gc_frame_newslot(opresult10520);
  params[0] = call10500;
  partcv[0] = 1;
  Object opresult10521 = callmethod(opresult10520, "++(1)", 1, partcv, params);
// compiled op node returning opresult10521 (depth = 4)
  int op_slot_left_10495 = gc_frame_newslot(opresult10521);
  params[0] = strlit10496;
  partcv[0] = 1;
  Object opresult10522 = callmethod(opresult10521, "++(1)", 1, partcv, params);
// compiled op node returning opresult10522 (depth = 3)
  gc_frame_end(frame);
  return opresult10522;
}
Object meth_ast_extendCommentUsing_40_1_41_10523(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extendCommentUsing(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extendCommentUsing(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extendCommentUsing(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cmtNode = &(stackframe->slots[0]);
  *var_cmtNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part extendCommentUsing(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2746
  setline(2746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10524 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10526 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cmtNode (depth = 6)
  Object call10527 = callmethodflags(*var_cmtNode, "value", 0, partcv, params, 0);
  gc_frame_end(callframe10526);
// compiled member node returning call10527 (depth = 5)
  int op_slot_right_10525 = gc_frame_newslot(call10527);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10530 == NULL) {
    strlit10530 = alloc_String(" ");
    gc_root(strlit10530);
  }
// compiled string node returning strlit10530 (depth = 6)
  int op_slot_right_10529 = gc_frame_newslot(strlit10530);
// starting to compile member node (depth = 6)
  int callframe10532 = gc_frame_new();
// call case 4: self request
  Object call10533 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10532);
// compiled member node returning call10533 (depth = 6)
  int op_slot_left_10529 = gc_frame_newslot(call10533);
  params[0] = strlit10530;
  partcv[0] = 1;
  Object opresult10534 = callmethod(call10533, "++(1)", 1, partcv, params);
// compiled op node returning opresult10534 (depth = 5)
  int op_slot_left_10525 = gc_frame_newslot(opresult10534);
  params[0] = call10527;
  partcv[0] = 1;
  Object opresult10535 = callmethod(opresult10534, "++(1)", 1, partcv, params);
// compiled op node returning opresult10535 (depth = 4)
  gc_frame_newslot(opresult10535);
// call case 4: self request
  params[0] = opresult10535;
  partcv[0] = 1;
  Object call10536 = callmethodflags(self, "value:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10524);
// compiled call node returning call10536 (depth = 3)
// Begin line 2747
  setline(2747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10537 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10538 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cmtNode (depth = 5)
  Object call10539 = callmethodflags(*var_cmtNode, "endLine", 0, partcv, params, 0);
  gc_frame_end(callframe10538);
// compiled member node returning call10539 (depth = 4)
  gc_frame_newslot(call10539);
// call case 4: self request
  params[0] = call10539;
  partcv[0] = 1;
  Object call10540 = callmethodflags(self, "endLine:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10537);
// compiled call node returning call10540 (depth = 3)
  gc_frame_end(frame);
  return call10540;
}
Object meth_ast_map_40_1_41_ancestors_40_1_41_10541(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)ancestors(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)ancestors(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map(_)ancestors(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ancestors(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2750
  setline(2750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10542 = gc_frame_new();
// call case 4: self request
  Object call10543 = callmethodflags(self, "shallowCopy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10542);
// compiled member node returning call10543 (depth = 4)
  *var_n = call10543;
  if (call10543 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2751
  setline(2751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10544 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call10545 = callmethodflags(*var_as, "extend(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10544);
// compiled call node returning call10545 (depth = 4)
  *var_newChain = call10545;
  if (call10545 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2752
  setline(2752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10546 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call10547 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe10546);
// compiled call node returning call10547 (depth = 3)
  gc_frame_end(frame);
  return call10547;
}
Object meth_ast_accept_40_1_41_from_40_1_41_10548(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept(1)from(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept(_)from(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept(_)from(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part accept(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2755
  setline(2755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10549 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10550 = callmethodflags(*var_visitor, "visitComment(1)up(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10549);
// compiled call node returning call10550 (depth = 3)
  gc_frame_end(frame);
  return call10550;
}
Object meth_ast__apply10559(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 2760
  setline(2760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10561 == NULL) {
    strlit10561 = alloc_String("  ");
    gc_root(strlit10561);
  }
// compiled string node returning strlit10561 (depth = 7)
  int op_slot_right_10560 = gc_frame_newslot(strlit10561);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_10560 = gc_frame_newslot(*var_s);
  params[0] = strlit10561;
  partcv[0] = 1;
  Object opresult10563 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult10563 (depth = 6)
  *var_s = opresult10563;
  if (opresult10563 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty_40_1_41_10551(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part pretty(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
  Object *var_pb = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "pb");
// Begin line 2758
  setline(2758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10552 == NULL) {
    strlit10552 = alloc_String("""\x0a""");
    gc_root(strlit10552);
  }
// compiled string node returning strlit10552 (depth = 4)
  *var_s = strlit10552;
  if (strlit10552 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2759
  setline(2759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10553 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10555 = alloc_Float64(1);
// compiled num node returning num10555 (depth = 5)
  int op_slot_right_10554 = gc_frame_newslot(num10555);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_left_10554 = gc_frame_newslot(*var_depth);
  params[0] = num10555;
  partcv[0] = 1;
  Object diff10557 = callmethod(*var_depth, "-(1)", 1, partcv, params);
// compiled op node returning diff10557 (depth = 4)
  gc_frame_newslot(diff10557);
// starting to compile block node (depth = 4)
  Object block10558 = alloc_Block(NULL, NULL, "ast", 2759);
  gc_frame_newslot(block10558);
// method "_apply"
  block_savedest(block10558);
  Object closure10559 = createclosure(2, "_apply");
  setclosureframe(closure10559, stackframe);
  addtoclosure(closure10559, var_s);
  addtoclosure(closure10559, selfslot);
  struct UserObject *uo10559 = (struct UserObject*)block10558;
  uo10559->data[0] = (Object)closure10559;
  Method *meth_meth_ast__apply10559 = addmethod2pos(block10558, "_apply", &meth_ast__apply10559, 0);
  int argcv_meth_ast__apply10559[] = {0};
  meth_meth_ast__apply10559->type = alloc_MethodType(1, argcv_meth_ast__apply10559);
  meth_meth_ast__apply10559->definitionModule = modulename;
  meth_meth_ast__apply10559->definitionLine = 2981;
// compiled block node returning block10558 (depth = 4)
  gc_frame_newslot(block10558);
// call case 5: prelude request
  params[0] = diff10557;
  params[1] = block10558;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10566 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10553);
// compiled call node returning call10566 (depth = 3)
// Begin line 2762
  setline(2762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10568 = gc_frame_new();
// call case 4: self request
  Object call10569 = callmethodflags(self, "isPreceededByBlankLine", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10568);
// compiled member node returning call10569 (depth = 5)
  Object if10567 = done;
struct StackFrameObject *iftmpstackframe10567 = stackframe;
  if (istrue(call10569)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10567);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit10570 == NULL) {
    strlit10570 = alloc_String(" > blank");
    gc_root(strlit10570);
  }
// compiled string node returning strlit10570 (depth = 5)
    gc_frame_newslot(strlit10570);
    if10567 = strlit10570;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe10567);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit10571 == NULL) {
    strlit10571 = alloc_String("");
    gc_root(strlit10571);
  }
// compiled string node returning strlit10571 (depth = 5)
    gc_frame_newslot(strlit10571);
    if10567 = strlit10571;
  }
stackframe = iftmpstackframe10567;
// compiled if node returning if10567 (depth = 4)
  *var_pb = if10567;
  if (if10567 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 2763
  setline(2763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10573 == NULL) {
    strlit10573 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit10573);
  }
// compiled string node returning strlit10573 (depth = 4)
  int op_slot_right_10572 = gc_frame_newslot(strlit10573);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe10576 = gc_frame_new();
// call case 4: self request
  Object call10577 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10576);
// compiled member node returning call10577 (depth = 5)
  int op_slot_right_10575 = gc_frame_newslot(call10577);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10580 == NULL) {
    strlit10580 = alloc_String("): ""\xe2""""\x80""""\xb9""");
    gc_root(strlit10580);
  }
// compiled string node returning strlit10580 (depth = 6)
  int op_slot_right_10579 = gc_frame_newslot(strlit10580);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe10583 = gc_frame_new();
// call case 4: self request
  Object call10584 = callmethodflags(self, "endLine", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10583);
// compiled member node returning call10584 (depth = 7)
  int op_slot_right_10582 = gc_frame_newslot(call10584);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10587 == NULL) {
    strlit10587 = alloc_String("""\xe2""""\x80""""\x93""");
    gc_root(strlit10587);
  }
// compiled string node returning strlit10587 (depth = 8)
  int op_slot_right_10586 = gc_frame_newslot(strlit10587);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe10590 = gc_frame_new();
// call case 4: self request
  Object call10591 = callmethodflags(self, "line", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10590);
// compiled member node returning call10591 (depth = 9)
  int op_slot_right_10589 = gc_frame_newslot(call10591);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10594 == NULL) {
    strlit10594 = alloc_String("(");
    gc_root(strlit10594);
  }
// compiled string node returning strlit10594 (depth = 10)
  int op_slot_right_10593 = gc_frame_newslot(strlit10594);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_pb (depth = 11)
  int op_slot_right_10596 = gc_frame_newslot(*var_pb);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit10599 == NULL) {
    strlit10599 = alloc_String("Comment");
    gc_root(strlit10599);
  }
// compiled string node returning strlit10599 (depth = 12)
  int op_slot_right_10598 = gc_frame_newslot(strlit10599);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_10601 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit10603 == NULL) {
    strlit10603 = alloc_String("");
    gc_root(strlit10603);
  }
// compiled string node returning strlit10603 (depth = 13)
  int op_slot_left_10601 = gc_frame_newslot(strlit10603);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult10604 = callmethod(strlit10603, "++(1)", 1, partcv, params);
// compiled op node returning opresult10604 (depth = 12)
  int op_slot_left_10598 = gc_frame_newslot(opresult10604);
  params[0] = strlit10599;
  partcv[0] = 1;
  Object opresult10605 = callmethod(opresult10604, "++(1)", 1, partcv, params);
// compiled op node returning opresult10605 (depth = 11)
  int op_slot_left_10596 = gc_frame_newslot(opresult10605);
  params[0] = *var_pb;
  partcv[0] = 1;
  Object opresult10606 = callmethod(opresult10605, "++(1)", 1, partcv, params);
// compiled op node returning opresult10606 (depth = 10)
  int op_slot_left_10593 = gc_frame_newslot(opresult10606);
  params[0] = strlit10594;
  partcv[0] = 1;
  Object opresult10607 = callmethod(opresult10606, "++(1)", 1, partcv, params);
// compiled op node returning opresult10607 (depth = 9)
  int op_slot_left_10589 = gc_frame_newslot(opresult10607);
  params[0] = call10591;
  partcv[0] = 1;
  Object opresult10608 = callmethod(opresult10607, "++(1)", 1, partcv, params);
// compiled op node returning opresult10608 (depth = 8)
  int op_slot_left_10586 = gc_frame_newslot(opresult10608);
  params[0] = strlit10587;
  partcv[0] = 1;
  Object opresult10609 = callmethod(opresult10608, "++(1)", 1, partcv, params);
// compiled op node returning opresult10609 (depth = 7)
  int op_slot_left_10582 = gc_frame_newslot(opresult10609);
  params[0] = call10584;
  partcv[0] = 1;
  Object opresult10610 = callmethod(opresult10609, "++(1)", 1, partcv, params);
// compiled op node returning opresult10610 (depth = 6)
  int op_slot_left_10579 = gc_frame_newslot(opresult10610);
  params[0] = strlit10580;
  partcv[0] = 1;
  Object opresult10611 = callmethod(opresult10610, "++(1)", 1, partcv, params);
// compiled op node returning opresult10611 (depth = 5)
  int op_slot_left_10575 = gc_frame_newslot(opresult10611);
  params[0] = call10577;
  partcv[0] = 1;
  Object opresult10612 = callmethod(opresult10611, "++(1)", 1, partcv, params);
// compiled op node returning opresult10612 (depth = 4)
  int op_slot_left_10572 = gc_frame_newslot(opresult10612);
  params[0] = strlit10573;
  partcv[0] = 1;
  Object opresult10613 = callmethod(opresult10612, "++(1)", 1, partcv, params);
// compiled op node returning opresult10613 (depth = 3)
  gc_frame_end(frame);
  return opresult10613;
}
Object meth_ast__apply10631(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10633 == NULL) {
    strlit10633 = alloc_String("    ");
    gc_root(strlit10633);
  }
// compiled string node returning strlit10633 (depth = 8)
  int op_slot_right_10632 = gc_frame_newslot(strlit10633);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_10632 = gc_frame_newslot(*var_spc);
  params[0] = strlit10633;
  partcv[0] = 1;
  Object opresult10635 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult10635 (depth = 7)
  *var_spc = opresult10635;
  if (opresult10635 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace_40_1_41_10614(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "toGrace(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace(_)");
  Object params[3];
  int partcv[3];
  Object *var_lineLength = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toGrace(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 2768
  setline(2768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe10616 = gc_frame_new();
// call case 4: self request
  Object call10617 = callmethodflags(self, "isPartialLine", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10616);
// compiled member node returning call10617 (depth = 4)
  Object if10615 = done;
  if (istrue(call10617)) {
// Begin line 2769
  setline(2769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10619 == NULL) {
    strlit10619 = alloc_String("");
    gc_root(strlit10619);
  }
// compiled string node returning strlit10619 (depth = 5)
  int op_slot_right_10618 = gc_frame_newslot(strlit10619);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe10622 = gc_frame_new();
// call case 4: self request
  Object call10623 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10622);
// compiled member node returning call10623 (depth = 6)
  int op_slot_right_10621 = gc_frame_newslot(call10623);
// starting to compile string node (depth = 6)
  if (strlit10625 == NULL) {
    strlit10625 = alloc_String("// (partial) ");
    gc_root(strlit10625);
  }
// compiled string node returning strlit10625 (depth = 6)
  int op_slot_left_10621 = gc_frame_newslot(strlit10625);
  params[0] = call10623;
  partcv[0] = 1;
  Object opresult10626 = callmethod(strlit10625, "++(1)", 1, partcv, params);
// compiled op node returning opresult10626 (depth = 5)
  int op_slot_left_10618 = gc_frame_newslot(opresult10626);
  params[0] = strlit10619;
  partcv[0] = 1;
  Object opresult10627 = callmethod(opresult10626, "++(1)", 1, partcv, params);
// compiled op node returning opresult10627 (depth = 4)
    gc_frame_newslot(opresult10627);
    if10615 = opresult10627;
  } else {
// Begin line 2771
  setline(2771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10628 == NULL) {
    strlit10628 = alloc_String("");
    gc_root(strlit10628);
  }
// compiled string node returning strlit10628 (depth = 5)
  *var_spc = strlit10628;
  if (strlit10628 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2772
  setline(2772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10629 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 5)
  Object block10630 = alloc_Block(NULL, NULL, "ast", 2772);
  gc_frame_newslot(block10630);
// method "_apply"
  block_savedest(block10630);
  Object closure10631 = createclosure(2, "_apply");
  setclosureframe(closure10631, stackframe);
  addtoclosure(closure10631, var_spc);
  addtoclosure(closure10631, selfslot);
  struct UserObject *uo10631 = (struct UserObject*)block10630;
  uo10631->data[0] = (Object)closure10631;
  Method *meth_meth_ast__apply10631 = addmethod2pos(block10630, "_apply", &meth_ast__apply10631, 0);
  int argcv_meth_ast__apply10631[] = {0};
  meth_meth_ast__apply10631->type = alloc_MethodType(1, argcv_meth_ast__apply10631);
  meth_meth_ast__apply10631->definitionModule = modulename;
  meth_meth_ast__apply10631->definitionLine = 2981;
// compiled block node returning block10630 (depth = 5)
  gc_frame_newslot(block10630);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block10630;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10638 = callmethodflags(prelude, "repeat(1)times(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10629);
// compiled call node returning call10638 (depth = 4)
// Begin line 2773
  setline(2773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10639 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe10640 = gc_frame_new();
// call case 4: self request
  Object call10641 = callmethodflags(self, "value", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10640);
// compiled member node returning call10641 (depth = 5)
  gc_frame_newslot(call10641);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineLength (depth = 5)
  gc_frame_newslot(*var_lineLength);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10643 == NULL) {
    strlit10643 = alloc_String("// ");
    gc_root(strlit10643);
  }
// compiled string node returning strlit10643 (depth = 6)
  int op_slot_right_10642 = gc_frame_newslot(strlit10643);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_10642 = gc_frame_newslot(*var_spc);
  params[0] = strlit10643;
  partcv[0] = 1;
  Object opresult10645 = callmethod(*var_spc, "++(1)", 1, partcv, params);
// compiled op node returning opresult10645 (depth = 5)
  gc_frame_newslot(opresult10645);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10646 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe10647 = gc_frame_new();
// call case 3: self.outer request
  Object call10648 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10647);
// compiled member node returning call10648 (depth = 6)
  Object call10649 = callmethodflags(call10648, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe10646);
// compiled member node returning call10649 (depth = 5)
  params[0] = call10641;
  params[1] = *var_lineLength;
  params[2] = opresult10645;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10650 = callmethodflags(call10649, "wrap(1)to(1)prefix(1)", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10639);
// compiled call node returning call10650 (depth = 4)
    gc_frame_newslot(call10650);
    if10615 = call10650;
  }
// compiled if node returning if10615 (depth = 3)
  gc_frame_end(frame);
  return if10615;
}
Object meth_ast_shallowCopy10651(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_commentNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2777
  setline(2777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10652 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe10653 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_commentNode (depth = 5)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call10654 = callmethodflags(*var_commentNode, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10653);
// compiled call node returning call10654 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call10655 = callmethodflags(call10654, "shallowCopyFieldsFrom(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10652);
// compiled call node returning call10655 (depth = 3)
  gc_frame_end(frame);
  return call10655;
}
Object meth_ast_shallowCopyFieldsFrom_40_1_41_10656(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part shallowCopyFieldsFrom(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2780
  setline(2780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10657 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call10658 = callmethod4(self, "shallowCopyFieldsFrom(1)", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe10657);
// compiled call node returning call10658 (depth = 3)
// Begin line 2781
  setline(2781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10659 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10660 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call10661 = callmethodflags(*var_other, "value", 0, partcv, params, 0);
  gc_frame_end(callframe10660);
// compiled member node returning call10661 (depth = 4)
  gc_frame_newslot(call10661);
// call case 4: self request
  params[0] = call10661;
  partcv[0] = 1;
  Object call10662 = callmethodflags(self, "value:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10659);
// compiled call node returning call10662 (depth = 3)
// Begin line 2782
  setline(2782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10663 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10664 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call10665 = callmethodflags(*var_other, "isPartialLine", 0, partcv, params, 0);
  gc_frame_end(callframe10664);
// compiled member node returning call10665 (depth = 4)
  gc_frame_newslot(call10665);
// call case 4: self request
  params[0] = call10665;
  partcv[0] = 1;
  Object call10666 = callmethodflags(self, "isPartialLine:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10663);
// compiled call node returning call10666 (depth = 3)
// Begin line 2783
  setline(2783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10667 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe10668 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  Object call10669 = callmethodflags(*var_other, "endLine", 0, partcv, params, 0);
  gc_frame_end(callframe10668);
// compiled member node returning call10669 (depth = 4)
  gc_frame_newslot(call10669);
// call case 4: self request
  params[0] = call10669;
  partcv[0] = 1;
  Object call10670 = callmethodflags(self, "endLine:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10667);
// compiled call node returning call10670 (depth = 3)
// Begin line 2784
  setline(2784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new_40_1_41_10480(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_lineLength = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_commentNode = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val_39_ = &(stackframe->slots[0]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10481 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10481 = alloc_userobj2(20,17, objclass10481);
  gc_frame_newslot(obj10481);
if (objclass10481 == NULL) {
  glfree(obj10481->class->name);
  obj10481->class->name = "commentNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10481, self, 0);
  addmethodreal(obj10481,"outer", &reader_ast_outer_10482);
  Object oldself10481 = self;
  struct StackFrameObject *oldstackframe10481 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10481);
  gc_frame_newslot((Object)stackframe);
  self = obj10481;
  Object *oldselfslot10481 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10481 = (*(struct UserObject *)self).data[0], lowerouter10481 = thisouter10481;
  if (inheritingObject10481) {
    struct UserObject *inho10481 = (struct UserObject *)inheritingObject10481;
    while (inho10481->super != GraceDefaultObject) inho10481 = (struct UserObject *)inho10481->super;
    inho10481->super = obj10481;
    self = inheritingObject10481;
    *selfslot = self;
    lowerouter10481 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10481;
  }
if (objclass10481 == NULL) {
  Method *reader10483 = addmethodrealflags(obj10481, "kind",&reader_ast_kind_10483, MFLAG_DEF);
  reader10483->definitionModule = modulename;
  reader10483->definitionLine = 2736;
}
adddatum2(obj10481, alloc_Undefined(), 1);
if (objclass10481 == NULL) {
  Method *reader10484 = addmethodrealflags(obj10481, "value", &reader_ast_value_10484, 0);
  Method *writer10484 = addmethodrealflags(obj10481, "value:=(1)", &writer_ast_value_10484, 0);
  reader10484->definitionModule = modulename;
  writer10484->definitionModule = modulename;
  reader10484->definitionLine = 2737;
  writer10484->definitionLine = 2737;
}
obj10481->flags |= OFLAG_MUTABLE;
adddatum2(obj10481, alloc_Undefined(), 2);
if (objclass10481 == NULL) {
  Method *reader10485 = addmethodrealflags(obj10481, "isPartialLine", &reader_ast_isPartialLine_10485, 0);
  Method *writer10485 = addmethodrealflags(obj10481, "isPartialLine:=(1)", &writer_ast_isPartialLine_10485, 0);
  reader10485->definitionModule = modulename;
  writer10485->definitionModule = modulename;
  reader10485->definitionLine = 2738;
  writer10485->definitionLine = 2738;
}
obj10481->flags |= OFLAG_MUTABLE;
adddatum2(obj10481, alloc_Undefined(), 3);
if (objclass10481 == NULL) {
  Method *reader10486 = addmethodrealflags(obj10481, "isPreceededByBlankLine", &reader_ast_isPreceededByBlankLine_10486, 0);
  Method *writer10486 = addmethodrealflags(obj10481, "isPreceededByBlankLine:=(1)", &writer_ast_isPreceededByBlankLine_10486, 0);
  reader10486->definitionModule = modulename;
  writer10486->definitionModule = modulename;
  reader10486->definitionLine = 2739;
  writer10486->definitionLine = 2739;
}
obj10481->flags |= OFLAG_MUTABLE;
adddatum2(obj10481, alloc_Undefined(), 4);
if (objclass10481 == NULL) {
  Method *reader10487 = addmethodrealflags(obj10481, "endLine", &reader_ast_endLine_10487, 0);
  Method *writer10487 = addmethodrealflags(obj10481, "endLine:=(1)", &writer_ast_endLine_10487, 0);
  reader10487->definitionModule = modulename;
  writer10487->definitionModule = modulename;
  reader10487->definitionLine = 2740;
  writer10487->definitionLine = 2740;
}
obj10481->flags |= OFLAG_MUTABLE;
adddatum2(obj10481, alloc_Undefined(), 5);
// method "isComment"
  struct UserObject *uo10488 = (struct UserObject*)obj10481;
  uo10488->data[6] = emptyclosure;
  Method *meth_meth_ast_isComment10488 = addmethod2pos(obj10481, "isComment", &meth_ast_isComment10488, 6);
  int argcv_meth_ast_isComment10488[] = {0};
  meth_meth_ast_isComment10488->type = alloc_MethodType(1, argcv_meth_ast_isComment10488);
  meth_meth_ast_isComment10488->definitionModule = modulename;
  meth_meth_ast_isComment10488->definitionLine = 2741;
// method "isLegalInTrait"
  struct UserObject *uo10490 = (struct UserObject*)obj10481;
  uo10490->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait10490 = addmethod2pos(obj10481, "isLegalInTrait", &meth_ast_isLegalInTrait10490, 7);
  int argcv_meth_ast_isLegalInTrait10490[] = {0};
  meth_meth_ast_isLegalInTrait10490->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait10490);
  meth_meth_ast_isLegalInTrait10490->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait10490->definitionLine = 2742;
// method "isExecutable"
  struct UserObject *uo10492 = (struct UserObject*)obj10481;
  uo10492->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable10492 = addmethod2pos(obj10481, "isExecutable", &meth_ast_isExecutable10492, 8);
  int argcv_meth_ast_isExecutable10492[] = {0};
  meth_meth_ast_isExecutable10492->type = alloc_MethodType(1, argcv_meth_ast_isExecutable10492);
  meth_meth_ast_isExecutable10492->definitionModule = modulename;
  meth_meth_ast_isExecutable10492->definitionLine = 2743;
// method "asString"
  struct UserObject *uo10494 = (struct UserObject*)obj10481;
  uo10494->data[9] = emptyclosure;
  Method *meth_meth_ast_asString10494 = addmethod2pos(obj10481, "asString", &meth_ast_asString10494, 9);
  int argcv_meth_ast_asString10494[] = {0};
  meth_meth_ast_asString10494->type = alloc_MethodType(1, argcv_meth_ast_asString10494);
  meth_meth_ast_asString10494->definitionModule = modulename;
  meth_meth_ast_asString10494->definitionLine = 2744;
// method "extendCommentUsing(_)"
  struct UserObject *uo10523 = (struct UserObject*)obj10481;
  uo10523->data[10] = emptyclosure;
  Method *meth_meth_ast_extendCommentUsing_40_1_41_10523 = addmethod2pos(obj10481, "extendCommentUsing(1)", &meth_ast_extendCommentUsing_40_1_41_10523, 10);
  int argcv_meth_ast_extendCommentUsing_40_1_41_10523[] = {1};
  meth_meth_ast_extendCommentUsing_40_1_41_10523->type = alloc_MethodType(1, argcv_meth_ast_extendCommentUsing_40_1_41_10523);
  meth_meth_ast_extendCommentUsing_40_1_41_10523->definitionModule = modulename;
  meth_meth_ast_extendCommentUsing_40_1_41_10523->definitionLine = 2745;
// method "map(_)ancestors(_)"
  struct UserObject *uo10541 = (struct UserObject*)obj10481;
  uo10541->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_10541 = addmethod2pos(obj10481, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_10541, 11);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_10541[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10541->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_10541);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10541->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10541->definitionLine = 2749;
// method "accept(_)from(_)"
  struct UserObject *uo10548 = (struct UserObject*)obj10481;
  uo10548->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_10548 = addmethod2pos(obj10481, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_10548, 12);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_10548[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_10548->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_10548);
  meth_meth_ast_accept_40_1_41_from_40_1_41_10548->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_10548->definitionLine = 2754;
// method "pretty(_)"
  struct UserObject *uo10551 = (struct UserObject*)obj10481;
  uo10551->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_10551 = addmethod2pos(obj10481, "pretty(1)", &meth_ast_pretty_40_1_41_10551, 13);
  int argcv_meth_ast_pretty_40_1_41_10551[] = {1};
  meth_meth_ast_pretty_40_1_41_10551->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_10551);
  meth_meth_ast_pretty_40_1_41_10551->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_10551->definitionLine = 2757;
// method "toGrace(_)"
  block_savedest(obj10481);
  Object closure10614 = createclosure(1, "toGrace(1)");
  setclosureframe(closure10614, stackframe);
  addtoclosure(closure10614, var_lineLength);
  struct UserObject *uo10614 = (struct UserObject*)obj10481;
  uo10614->data[14] = (Object)closure10614;
  Method *meth_meth_ast_toGrace_40_1_41_10614 = addmethod2pos(obj10481, "toGrace(1)", &meth_ast_toGrace_40_1_41_10614, 14);
  int argcv_meth_ast_toGrace_40_1_41_10614[] = {1};
  meth_meth_ast_toGrace_40_1_41_10614->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_10614);
  meth_meth_ast_toGrace_40_1_41_10614->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_10614->definitionLine = 2765;
// method "shallowCopy"
  block_savedest(obj10481);
  Object closure10651 = createclosure(2, "shallowCopy");
  setclosureframe(closure10651, stackframe);
  addtoclosure(closure10651, var_nullNode);
  addtoclosure(closure10651, var_commentNode);
  struct UserObject *uo10651 = (struct UserObject*)obj10481;
  uo10651->data[15] = (Object)closure10651;
  Method *meth_meth_ast_shallowCopy10651 = addmethod2pos(obj10481, "shallowCopy", &meth_ast_shallowCopy10651, 15);
  int argcv_meth_ast_shallowCopy10651[] = {0};
  meth_meth_ast_shallowCopy10651->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10651);
  meth_meth_ast_shallowCopy10651->definitionModule = modulename;
  meth_meth_ast_shallowCopy10651->definitionLine = 2776;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo10656 = (struct UserObject*)obj10481;
  uo10656->data[16] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10656 = addmethod2pos(obj10481, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_10656, 16);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10656[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10656->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10656);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10656->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10656->definitionLine = 2779;
  sourceObject = obj10481;
// Begin line 2735
  setline(2735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10671 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10672 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10673 = gc_frame_new();
// call case 3: self.outer request
  Object call10674 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10673);
// compiled member node returning call10674 (depth = 5)
  Object call10675 = callmethodflags(call10674, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe10672);
// compiled member node returning call10675 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10676 = callmethodflags(call10675, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10671);
// compiled call node returning call10676 (depth = 3)
  struct UserObject *obj10481_uo = (struct UserObject *)obj10481;
  obj10481_uo->super = call10676;
  sourceObject = obj10481;
// Begin line 2736
  setline(2736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10677 == NULL) {
    strlit10677 = alloc_String("comment");
    gc_root(strlit10677);
  }
// compiled string node returning strlit10677 (depth = 3)
  adddatum2(obj10481, strlit10677, 1);
  sourceObject = obj10481;
// Begin line 2737
  setline(2737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj10481, *var_val_39_, 2);
  sourceObject = obj10481;
// Begin line 2738
  setline(2738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10678 = alloc_Boolean(0);
// compiled identifier node returning bool10678 (depth = 3)
  adddatum2(obj10481, bool10678, 3);
  sourceObject = obj10481;
// Begin line 2739
  setline(2739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10679 = alloc_Boolean(0);
// compiled identifier node returning bool10679 (depth = 3)
  adddatum2(obj10481, bool10679, 4);
  sourceObject = obj10481;
// Begin line 2740
  setline(2740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe10680 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  Object call10681 = callmethodflags(*var_util, "linenum", 0, partcv, params, 0);
  gc_frame_end(callframe10680);
// compiled member node returning call10681 (depth = 3)
  adddatum2(obj10481, call10681, 5);
  sourceObject = obj10481;
  sourceObject = obj10481;
  sourceObject = obj10481;
  sourceObject = obj10481;
  sourceObject = obj10481;
  sourceObject = obj10481;
  sourceObject = obj10481;
  sourceObject = obj10481;
  sourceObject = obj10481;
  sourceObject = obj10481;
  sourceObject = obj10481;
  objclass10481 = obj10481->class;
  objclass10481->definitionModule = modulename;
  objclass10481->definitionLine = 2734;
  (*(struct UserObject *)self).data[0] = lowerouter10481;
  self = oldself10481;
  selfslot = oldselfslot10481;
  stackframe = oldstackframe10481;
  gc_frame_end(frame);
  return obj10481;
}
Object meth_ast_new_40_1_41_10480_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method new(_)");
  Object params[1];
  int partcv[2];
  Object *var_lineLength = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_commentNode = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val_39_ = &(stackframe->slots[0]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part new(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject10481 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10481 = alloc_userobj2(20,17, objclass10481);
  gc_frame_newslot(obj10481);
if (objclass10481 == NULL) {
  glfree(obj10481->class->name);
  obj10481->class->name = "commentNode.new(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10481, self, 0);
  addmethodreal(obj10481,"outer", &reader_ast_outer_10482);
  Object oldself10481 = self;
  struct StackFrameObject *oldstackframe10481 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10481);
  gc_frame_newslot((Object)stackframe);
  self = obj10481;
  Object *oldselfslot10481 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10481 = (*(struct UserObject *)self).data[0], lowerouter10481 = thisouter10481;
  if (inheritingObject10481) {
    struct UserObject *inho10481 = (struct UserObject *)inheritingObject10481;
    while (inho10481->super != GraceDefaultObject) inho10481 = (struct UserObject *)inho10481->super;
    inho10481->super = obj10481;
    self = inheritingObject10481;
    *selfslot = self;
    lowerouter10481 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10481;
  }
if (objclass10481 == NULL) {
  Method *reader10483 = addmethodrealflags(obj10481, "kind",&reader_ast_kind_10483, MFLAG_DEF);
  reader10483->definitionModule = modulename;
  reader10483->definitionLine = 2736;
}
adddatum2(obj10481, alloc_Undefined(), 1);
if (objclass10481 == NULL) {
  Method *reader10484 = addmethodrealflags(obj10481, "value", &reader_ast_value_10484, 0);
  Method *writer10484 = addmethodrealflags(obj10481, "value:=(1)", &writer_ast_value_10484, 0);
  reader10484->definitionModule = modulename;
  writer10484->definitionModule = modulename;
  reader10484->definitionLine = 2737;
  writer10484->definitionLine = 2737;
}
obj10481->flags |= OFLAG_MUTABLE;
adddatum2(obj10481, alloc_Undefined(), 2);
if (objclass10481 == NULL) {
  Method *reader10485 = addmethodrealflags(obj10481, "isPartialLine", &reader_ast_isPartialLine_10485, 0);
  Method *writer10485 = addmethodrealflags(obj10481, "isPartialLine:=(1)", &writer_ast_isPartialLine_10485, 0);
  reader10485->definitionModule = modulename;
  writer10485->definitionModule = modulename;
  reader10485->definitionLine = 2738;
  writer10485->definitionLine = 2738;
}
obj10481->flags |= OFLAG_MUTABLE;
adddatum2(obj10481, alloc_Undefined(), 3);
if (objclass10481 == NULL) {
  Method *reader10486 = addmethodrealflags(obj10481, "isPreceededByBlankLine", &reader_ast_isPreceededByBlankLine_10486, 0);
  Method *writer10486 = addmethodrealflags(obj10481, "isPreceededByBlankLine:=(1)", &writer_ast_isPreceededByBlankLine_10486, 0);
  reader10486->definitionModule = modulename;
  writer10486->definitionModule = modulename;
  reader10486->definitionLine = 2739;
  writer10486->definitionLine = 2739;
}
obj10481->flags |= OFLAG_MUTABLE;
adddatum2(obj10481, alloc_Undefined(), 4);
if (objclass10481 == NULL) {
  Method *reader10487 = addmethodrealflags(obj10481, "endLine", &reader_ast_endLine_10487, 0);
  Method *writer10487 = addmethodrealflags(obj10481, "endLine:=(1)", &writer_ast_endLine_10487, 0);
  reader10487->definitionModule = modulename;
  writer10487->definitionModule = modulename;
  reader10487->definitionLine = 2740;
  writer10487->definitionLine = 2740;
}
obj10481->flags |= OFLAG_MUTABLE;
adddatum2(obj10481, alloc_Undefined(), 5);
// method "isComment"
  struct UserObject *uo10488 = (struct UserObject*)obj10481;
  uo10488->data[6] = emptyclosure;
  Method *meth_meth_ast_isComment10488 = addmethod2pos(obj10481, "isComment", &meth_ast_isComment10488, 6);
  int argcv_meth_ast_isComment10488[] = {0};
  meth_meth_ast_isComment10488->type = alloc_MethodType(1, argcv_meth_ast_isComment10488);
  meth_meth_ast_isComment10488->definitionModule = modulename;
  meth_meth_ast_isComment10488->definitionLine = 2741;
// method "isLegalInTrait"
  struct UserObject *uo10490 = (struct UserObject*)obj10481;
  uo10490->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait10490 = addmethod2pos(obj10481, "isLegalInTrait", &meth_ast_isLegalInTrait10490, 7);
  int argcv_meth_ast_isLegalInTrait10490[] = {0};
  meth_meth_ast_isLegalInTrait10490->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait10490);
  meth_meth_ast_isLegalInTrait10490->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait10490->definitionLine = 2742;
// method "isExecutable"
  struct UserObject *uo10492 = (struct UserObject*)obj10481;
  uo10492->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable10492 = addmethod2pos(obj10481, "isExecutable", &meth_ast_isExecutable10492, 8);
  int argcv_meth_ast_isExecutable10492[] = {0};
  meth_meth_ast_isExecutable10492->type = alloc_MethodType(1, argcv_meth_ast_isExecutable10492);
  meth_meth_ast_isExecutable10492->definitionModule = modulename;
  meth_meth_ast_isExecutable10492->definitionLine = 2743;
// method "asString"
  struct UserObject *uo10494 = (struct UserObject*)obj10481;
  uo10494->data[9] = emptyclosure;
  Method *meth_meth_ast_asString10494 = addmethod2pos(obj10481, "asString", &meth_ast_asString10494, 9);
  int argcv_meth_ast_asString10494[] = {0};
  meth_meth_ast_asString10494->type = alloc_MethodType(1, argcv_meth_ast_asString10494);
  meth_meth_ast_asString10494->definitionModule = modulename;
  meth_meth_ast_asString10494->definitionLine = 2744;
// method "extendCommentUsing(_)"
  struct UserObject *uo10523 = (struct UserObject*)obj10481;
  uo10523->data[10] = emptyclosure;
  Method *meth_meth_ast_extendCommentUsing_40_1_41_10523 = addmethod2pos(obj10481, "extendCommentUsing(1)", &meth_ast_extendCommentUsing_40_1_41_10523, 10);
  int argcv_meth_ast_extendCommentUsing_40_1_41_10523[] = {1};
  meth_meth_ast_extendCommentUsing_40_1_41_10523->type = alloc_MethodType(1, argcv_meth_ast_extendCommentUsing_40_1_41_10523);
  meth_meth_ast_extendCommentUsing_40_1_41_10523->definitionModule = modulename;
  meth_meth_ast_extendCommentUsing_40_1_41_10523->definitionLine = 2745;
// method "map(_)ancestors(_)"
  struct UserObject *uo10541 = (struct UserObject*)obj10481;
  uo10541->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_10541 = addmethod2pos(obj10481, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_10541, 11);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_10541[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10541->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_10541);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10541->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_10541->definitionLine = 2749;
// method "accept(_)from(_)"
  struct UserObject *uo10548 = (struct UserObject*)obj10481;
  uo10548->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_10548 = addmethod2pos(obj10481, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_10548, 12);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_10548[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_10548->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_10548);
  meth_meth_ast_accept_40_1_41_from_40_1_41_10548->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_10548->definitionLine = 2754;
// method "pretty(_)"
  struct UserObject *uo10551 = (struct UserObject*)obj10481;
  uo10551->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_10551 = addmethod2pos(obj10481, "pretty(1)", &meth_ast_pretty_40_1_41_10551, 13);
  int argcv_meth_ast_pretty_40_1_41_10551[] = {1};
  meth_meth_ast_pretty_40_1_41_10551->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_10551);
  meth_meth_ast_pretty_40_1_41_10551->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_10551->definitionLine = 2757;
// method "toGrace(_)"
  block_savedest(obj10481);
  Object closure10614 = createclosure(1, "toGrace(1)");
  setclosureframe(closure10614, stackframe);
  addtoclosure(closure10614, var_lineLength);
  struct UserObject *uo10614 = (struct UserObject*)obj10481;
  uo10614->data[14] = (Object)closure10614;
  Method *meth_meth_ast_toGrace_40_1_41_10614 = addmethod2pos(obj10481, "toGrace(1)", &meth_ast_toGrace_40_1_41_10614, 14);
  int argcv_meth_ast_toGrace_40_1_41_10614[] = {1};
  meth_meth_ast_toGrace_40_1_41_10614->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_10614);
  meth_meth_ast_toGrace_40_1_41_10614->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_10614->definitionLine = 2765;
// method "shallowCopy"
  block_savedest(obj10481);
  Object closure10651 = createclosure(2, "shallowCopy");
  setclosureframe(closure10651, stackframe);
  addtoclosure(closure10651, var_nullNode);
  addtoclosure(closure10651, var_commentNode);
  struct UserObject *uo10651 = (struct UserObject*)obj10481;
  uo10651->data[15] = (Object)closure10651;
  Method *meth_meth_ast_shallowCopy10651 = addmethod2pos(obj10481, "shallowCopy", &meth_ast_shallowCopy10651, 15);
  int argcv_meth_ast_shallowCopy10651[] = {0};
  meth_meth_ast_shallowCopy10651->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10651);
  meth_meth_ast_shallowCopy10651->definitionModule = modulename;
  meth_meth_ast_shallowCopy10651->definitionLine = 2776;
// method "shallowCopyFieldsFrom(_)"
  struct UserObject *uo10656 = (struct UserObject*)obj10481;
  uo10656->data[16] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10656 = addmethod2pos(obj10481, "shallowCopyFieldsFrom(1)", &meth_ast_shallowCopyFieldsFrom_40_1_41_10656, 16);
  int argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10656[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10656->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom_40_1_41_10656);
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10656->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40_1_41_10656->definitionLine = 2779;
  sourceObject = obj10481;
// Begin line 2735
  setline(2735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10671 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10672 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe10673 = gc_frame_new();
// call case 3: self.outer request
  Object call10674 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10673);
// compiled member node returning call10674 (depth = 5)
  Object call10675 = callmethodflags(call10674, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe10672);
// compiled member node returning call10675 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10676 = callmethodflags(call10675, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10671);
// compiled call node returning call10676 (depth = 3)
  struct UserObject *obj10481_uo = (struct UserObject *)obj10481;
  obj10481_uo->super = call10676;
  sourceObject = obj10481;
// Begin line 2736
  setline(2736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10677 == NULL) {
    strlit10677 = alloc_String("comment");
    gc_root(strlit10677);
  }
// compiled string node returning strlit10677 (depth = 3)
  adddatum2(obj10481, strlit10677, 1);
  sourceObject = obj10481;
// Begin line 2737
  setline(2737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj10481, *var_val_39_, 2);
  sourceObject = obj10481;
// Begin line 2738
  setline(2738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10678 = alloc_Boolean(0);
// compiled identifier node returning bool10678 (depth = 3)
  adddatum2(obj10481, bool10678, 3);
  sourceObject = obj10481;
// Begin line 2739
  setline(2739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10679 = alloc_Boolean(0);
// compiled identifier node returning bool10679 (depth = 3)
  adddatum2(obj10481, bool10679, 4);
  sourceObject = obj10481;
// Begin line 2740
  setline(2740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe10680 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  Object call10681 = callmethodflags(*var_util, "linenum", 0, partcv, params, 0);
  gc_frame_end(callframe10680);
// compiled member node returning call10681 (depth = 3)
  adddatum2(obj10481, call10681, 5);
  sourceObject = obj10481;
  sourceObject = obj10481;
  sourceObject = obj10481;
  sourceObject = obj10481;
  sourceObject = obj10481;
  sourceObject = obj10481;
  sourceObject = obj10481;
  sourceObject = obj10481;
  sourceObject = obj10481;
  sourceObject = obj10481;
  sourceObject = obj10481;
  objclass10481 = obj10481->class;
  objclass10481->definitionModule = modulename;
  objclass10481->definitionLine = 2734;
  (*(struct UserObject *)self).data[0] = lowerouter10481;
  self = oldself10481;
  selfslot = oldselfslot10481;
  stackframe = oldstackframe10481;
  gc_frame_end(frame);
  return obj10481;
}
Object meth_ast_commentNode10683(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 51, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "commentNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_commentNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2733
  setline(2733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_commentNode (depth = 3)
  gc_frame_end(frame);
  return *var_commentNode;
}
Object meth_ast_ASTVisitor10686(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 52, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ASTVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ASTVisitor = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2823
  setline(2823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ASTVisitor (depth = 3)
  gc_frame_end(frame);
  return *var_ASTVisitor;
}
Object meth_ast_visitCall_40_1_41_up_40_1_41_10689(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall(1)up(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)up(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall(_)up(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitCall(_)up(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part visitCall(_)");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part up(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2966
  setline(2966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10690 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool10691 = alloc_Boolean(1);
// compiled identifier node returning bool10691 (depth = 4)
  gc_frame_newslot(bool10691);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  params[0] = bool10691;
  partcv[0] = 1;
  Object call10692 = callmethodflags(*var_c, "isPattern:=(1)", 1, partcv, params, 0);
  gc_frame_end(callframe10690);
// compiled call node returning call10692 (depth = 3)
// Begin line 2967
  setline(2967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10693 = alloc_Boolean(1);
// compiled identifier node returning bool10693 (depth = 3)
  gc_frame_end(frame);
  return bool10693;
}
Object meth_ast_patternMarkVisitor10698(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 53, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "patternMarkVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_patternMarkVisitor = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2963
  setline(2963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_patternMarkVisitor (depth = 3)
  gc_frame_end(frame);
  return *var_patternMarkVisitor;
}
Object module_ast_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(59, 59);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_standardGrace_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<ast>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(59, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[2];
  int partcv[2];
  Object *var_util = alloc_var();
  Object *var_k = alloc_var();
  Object *var_lineLength = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "lineLength");
  Object *var_uninitialized = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "uninitialized");
  Object *var_ancestorChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "ancestorChain");
  Object *var_emptySeq = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "emptySeq");
  Object *var_AstNode = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "AstNode");
  Object *var_SymbolTable = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "SymbolTable");
  Object *var_implicit = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "implicit");
  Object *var_nullNode = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "nullNode");
  Object *var_fakeSymbolTable = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "fakeSymbolTable");
  Object *var_ifNode = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "ifNode");
  Object *var_blockNode = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "blockNode");
  Object *var_tryCatchNode = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "tryCatchNode");
  Object *var_matchCaseNode = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "matchCaseNode");
  Object *var_methodTypeNode = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "methodTypeNode");
  Object *var_typeLiteralNode = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "typeLiteralNode");
  Object *var_typeDecNode = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "typeDecNode");
  Object *var_methodNode = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "methodNode");
  Object *var_callNode = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "callNode");
  Object *var_moduleNode = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "moduleNode");
  Object *var_objectNode = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "objectNode");
  Object *var_arrayNode = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "arrayNode");
  Object *var_memberNode = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "memberNode");
  Object *var_genericNode = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "genericNode");
  Object *var_typeParametersNode = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "typeParametersNode");
  Object *var_identifierNode = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "identifierNode");
  Object *var_typeType = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "typeType");
  Object *var_unknownType = &(stackframe->slots[27]);
  setframeelementname(stackframe, 27, "unknownType");
  Object *var_stringNode = &(stackframe->slots[28]);
  setframeelementname(stackframe, 28, "stringNode");
  Object *var_numNode = &(stackframe->slots[29]);
  setframeelementname(stackframe, 29, "numNode");
  Object *var_opNode = &(stackframe->slots[30]);
  setframeelementname(stackframe, 30, "opNode");
  Object *var_bindNode = &(stackframe->slots[31]);
  setframeelementname(stackframe, 31, "bindNode");
  Object *var_defDecNode = &(stackframe->slots[32]);
  setframeelementname(stackframe, 32, "defDecNode");
  Object *var_varDecNode = &(stackframe->slots[33]);
  setframeelementname(stackframe, 33, "varDecNode");
  Object *var_importNode = &(stackframe->slots[34]);
  setframeelementname(stackframe, 34, "importNode");
  Object *var_dialectNode = &(stackframe->slots[35]);
  setframeelementname(stackframe, 35, "dialectNode");
  Object *var_returnNode = &(stackframe->slots[36]);
  setframeelementname(stackframe, 36, "returnNode");
  Object *var_inheritsNode = &(stackframe->slots[37]);
  setframeelementname(stackframe, 37, "inheritsNode");
  Object *var_AliasPair = &(stackframe->slots[38]);
  setframeelementname(stackframe, 38, "AliasPair");
  Object *var_blankNode = &(stackframe->slots[39]);
  setframeelementname(stackframe, 39, "blankNode");
  Object *var_signaturePart = &(stackframe->slots[40]);
  setframeelementname(stackframe, 40, "signaturePart");
  Object *var_requestPart = &(stackframe->slots[41]);
  setframeelementname(stackframe, 41, "requestPart");
  Object *var_commentNode = &(stackframe->slots[42]);
  setframeelementname(stackframe, 42, "commentNode");
  Object *var_ASTVisitor = &(stackframe->slots[43]);
  setframeelementname(stackframe, 43, "ASTVisitor");
  Object *var_patternMarkVisitor = &(stackframe->slots[44]);
  setframeelementname(stackframe, 44, "patternMarkVisitor");
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "listMap(_,_)ancestors(_)"
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = emptyclosure;
  Method *meth_meth_ast_listMap_40_2_41_ancestors_40_1_41_1 = addmethod2pos(self, "listMap(2)ancestors(1)", &meth_ast_listMap_40_2_41_ancestors_40_1_41_1, 1);
  int argcv_meth_ast_listMap_40_2_41_ancestors_40_1_41_1[] = {2, 1};
  meth_meth_ast_listMap_40_2_41_ancestors_40_1_41_1->type = alloc_MethodType(2, argcv_meth_ast_listMap_40_2_41_ancestors_40_1_41_1);
  meth_meth_ast_listMap_40_2_41_ancestors_40_1_41_1->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_listMap_40_2_41_ancestors_40_1_41_1->definitionModule = modulename;
  meth_meth_ast_listMap_40_2_41_ancestors_40_1_41_1->definitionLine = 19;
// compiled method node returning  (depth = 1)
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "maybeMap(_,_)ancestors(_)"
  struct UserObject *uo12 = (struct UserObject*)self;
  uo12->data[2] = emptyclosure;
  Method *meth_meth_ast_maybeMap_40_2_41_ancestors_40_1_41_12 = addmethod2pos(self, "maybeMap(2)ancestors(1)", &meth_ast_maybeMap_40_2_41_ancestors_40_1_41_12, 2);
  int argcv_meth_ast_maybeMap_40_2_41_ancestors_40_1_41_12[] = {2, 1};
  meth_meth_ast_maybeMap_40_2_41_ancestors_40_1_41_12->type = alloc_MethodType(2, argcv_meth_ast_maybeMap_40_2_41_ancestors_40_1_41_12);
  meth_meth_ast_maybeMap_40_2_41_ancestors_40_1_41_12->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_maybeMap_40_2_41_ancestors_40_1_41_12->definitionModule = modulename;
  meth_meth_ast_maybeMap_40_2_41_ancestors_40_1_41_12->definitionLine = 24;
// compiled method node returning  (depth = 1)
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "maybeListMap(_,_)ancestors(_)"
  struct UserObject *uo20 = (struct UserObject*)self;
  uo20->data[3] = emptyclosure;
  Method *meth_meth_ast_maybeListMap_40_2_41_ancestors_40_1_41_20 = addmethod2pos(self, "maybeListMap(2)ancestors(1)", &meth_ast_maybeListMap_40_2_41_ancestors_40_1_41_20, 3);
  int argcv_meth_ast_maybeListMap_40_2_41_ancestors_40_1_41_20[] = {2, 1};
  meth_meth_ast_maybeListMap_40_2_41_ancestors_40_1_41_20->type = alloc_MethodType(2, argcv_meth_ast_maybeListMap_40_2_41_ancestors_40_1_41_20);
  meth_meth_ast_maybeListMap_40_2_41_ancestors_40_1_41_20->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_maybeListMap_40_2_41_ancestors_40_1_41_20->definitionModule = modulename;
  meth_meth_ast_maybeListMap_40_2_41_ancestors_40_1_41_20->definitionLine = 31;
// compiled method node returning  (depth = 1)
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "baseNode"
  block_savedest(self);
  Object closure28 = createclosure(4, "baseNode");
  setclosureframe(closure28, stackframe);
  addtoclosure(closure28, var_unknownType);
  addtoclosure(closure28, var_ancestorChain);
  addtoclosure(closure28, var_util);
  addtoclosure(closure28, var_fakeSymbolTable);
  struct UserObject *uo28 = (struct UserObject*)self;
  uo28->data[4] = (Object)closure28;
  Method *meth_meth_ast_baseNode28 = addmethod2pos(self, "baseNode", &meth_ast_baseNode28, 4);
  int argcv_meth_ast_baseNode28[] = {0};
  meth_meth_ast_baseNode28->type = alloc_MethodType(1, argcv_meth_ast_baseNode28);
  meth_meth_ast_baseNode28->definitionModule = modulename;
  meth_meth_ast_baseNode28->definitionLine = 87;
  block_savedest(self);
  Object closure432 = createclosure(4, "baseNode$object(1)");
  setclosureframe(closure432, stackframe);
  addtoclosure(closure432, var_unknownType);
  addtoclosure(closure432, var_ancestorChain);
  addtoclosure(closure432, var_util);
  addtoclosure(closure432, var_fakeSymbolTable);
  Method *meth_meth_ast_baseNode28_object = addmethod2pos(self, "baseNode$object(1)", &meth_ast_baseNode28_object, 4);
  meth_meth_ast_baseNode28_object->definitionModule = modulename;
  meth_meth_ast_baseNode28_object->definitionLine = 87;
// compiled method node returning  (depth = 1)
// Begin line 2515
  setline(2515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "aliasNew(_)old(_)"
  block_savedest(self);
  Object closure433 = createclosure(1, "aliasNew(1)old(1)");
  setclosureframe(closure433, stackframe);
  addtoclosure(closure433, var_AliasPair);
  struct UserObject *uo433 = (struct UserObject*)self;
  uo433->data[5] = (Object)closure433;
  Method *meth_meth_ast_aliasNew_40_1_41_old_40_1_41_433 = addmethod2pos(self, "aliasNew(1)old(1)", &meth_ast_aliasNew_40_1_41_old_40_1_41_433, 5);
  int argcv_meth_ast_aliasNew_40_1_41_old_40_1_41_433[] = {1, 1};
  meth_meth_ast_aliasNew_40_1_41_old_40_1_41_433->type = alloc_MethodType(2, argcv_meth_ast_aliasNew_40_1_41_old_40_1_41_433);
  meth_meth_ast_aliasNew_40_1_41_old_40_1_41_433->definitionModule = modulename;
  meth_meth_ast_aliasNew_40_1_41_old_40_1_41_433->definitionLine = 2515;
  block_savedest(self);
  Object closure545 = createclosure(1, "aliasNew(1)old(1)$object(1)");
  setclosureframe(closure545, stackframe);
  addtoclosure(closure545, var_AliasPair);
  Method *meth_meth_ast_aliasNew_40_1_41_old_40_1_41_433_object = addmethod2pos(self, "aliasNew(1)old(1)$object(1)", &meth_ast_aliasNew_40_1_41_old_40_1_41_433_object, 5);
  meth_meth_ast_aliasNew_40_1_41_old_40_1_41_433_object->definitionModule = modulename;
  meth_meth_ast_aliasNew_40_1_41_old_40_1_41_433_object->definitionLine = 2515;
// compiled method node returning  (depth = 1)
// Begin line 2789
  setline(2789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "wrap(_)to(_)prefix(_)"
  struct UserObject *uo546 = (struct UserObject*)self;
  uo546->data[6] = emptyclosure;
  Method *meth_meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_546 = addmethod2pos(self, "wrap(1)to(1)prefix(1)", &meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_546, 6);
  int argcv_meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_546[] = {1, 1, 1};
  meth_meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_546->type = alloc_MethodType(3, argcv_meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_546);
meth_meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_546->type->types[1] = type_Number;
meth_meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_546->type->names[1] = "l";
  meth_meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_546->definitionModule = modulename;
  meth_meth_ast_wrap_40_1_41_to_40_1_41_prefix_40_1_41_546->definitionLine = 2789;
// compiled method node returning  (depth = 1)
// Begin line 2856
  setline(2856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "baseVisitor"
  struct UserObject *uo716 = (struct UserObject*)self;
  uo716->data[7] = emptyclosure;
  Method *meth_meth_ast_baseVisitor716 = addmethod2pos(self, "baseVisitor", &meth_ast_baseVisitor716, 7);
  int argcv_meth_ast_baseVisitor716[] = {0};
  meth_meth_ast_baseVisitor716->type = alloc_MethodType(1, argcv_meth_ast_baseVisitor716);
  meth_meth_ast_baseVisitor716->definitionModule = modulename;
  meth_meth_ast_baseVisitor716->definitionLine = 2856;
  Method *meth_meth_ast_baseVisitor716_object = addmethod2pos(self, "baseVisitor$object(1)", &meth_ast_baseVisitor716_object, 7);
  int argcv_meth_ast_baseVisitor716_object[] = {0};
  meth_meth_ast_baseVisitor716_object->type = alloc_MethodType(1, argcv_meth_ast_baseVisitor716_object);
  meth_meth_ast_baseVisitor716_object->definitionModule = modulename;
  meth_meth_ast_baseVisitor716_object->definitionLine = 2856;
// compiled method node returning  (depth = 1)
// Begin line 2922
  setline(2922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pluggableVisitor(_)"
  struct UserObject *uo872 = (struct UserObject*)self;
  uo872->data[8] = emptyclosure;
  Method *meth_meth_ast_pluggableVisitor_40_1_41_872 = addmethod2pos(self, "pluggableVisitor(1)", &meth_ast_pluggableVisitor_40_1_41_872, 8);
  int argcv_meth_ast_pluggableVisitor_40_1_41_872[] = {1};
  meth_meth_ast_pluggableVisitor_40_1_41_872->type = alloc_MethodType(1, argcv_meth_ast_pluggableVisitor_40_1_41_872);
  meth_meth_ast_pluggableVisitor_40_1_41_872->definitionModule = modulename;
  meth_meth_ast_pluggableVisitor_40_1_41_872->definitionLine = 2922;
  Method *meth_meth_ast_pluggableVisitor_40_1_41_872_object = addmethod2pos(self, "pluggableVisitor(1)$object(1)", &meth_ast_pluggableVisitor_40_1_41_872_object, 8);
  int argcv_meth_ast_pluggableVisitor_40_1_41_872_object[] = {1};
  meth_meth_ast_pluggableVisitor_40_1_41_872_object->type = alloc_MethodType(1, argcv_meth_ast_pluggableVisitor_40_1_41_872_object);
  meth_meth_ast_pluggableVisitor_40_1_41_872_object->definitionModule = modulename;
  meth_meth_ast_pluggableVisitor_40_1_41_872_object->definitionLine = 2922;
// compiled method node returning  (depth = 1)
// Begin line 2971
  setline(2971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findAnnotation(_,_)"
  struct UserObject *uo965 = (struct UserObject*)self;
  uo965->data[9] = emptyclosure;
  Method *meth_meth_ast_findAnnotation_40_2_41_965 = addmethod2pos(self, "findAnnotation(2)", &meth_ast_findAnnotation_40_2_41_965, 9);
  int argcv_meth_ast_findAnnotation_40_2_41_965[] = {2};
  meth_meth_ast_findAnnotation_40_2_41_965->type = alloc_MethodType(1, argcv_meth_ast_findAnnotation_40_2_41_965);
  meth_meth_ast_findAnnotation_40_2_41_965->definitionModule = modulename;
  meth_meth_ast_findAnnotation_40_2_41_965->definitionLine = 2971;
// compiled method node returning  (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = LOAD_MODULE(util);
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of identifierKinds as k
  if (module_identifierKinds == NULL)
    module_identifierKinds = LOAD_MODULE(identifierKinds);
  *var_k = module_identifierKinds;
// compiled import node returning done (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num996 = alloc_Float64(80);
// compiled num node returning num996 (depth = 2)
  *var_lineLength = num996;
  if (num996 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lineLength"
  block_savedest(self);
  Object closure997 = createclosure(1, "lineLength");
  setclosureframe(closure997, stackframe);
  addtoclosure(closure997, var_lineLength);
  struct UserObject *uo997 = (struct UserObject*)self;
  uo997->data[10] = (Object)closure997;
  Method *meth_meth_ast_lineLength997 = addmethod2pos(self, "lineLength", &meth_ast_lineLength997, 10);
  int argcv_meth_ast_lineLength997[] = {0};
  meth_meth_ast_lineLength997->type = alloc_MethodType(1, argcv_meth_ast_lineLength997);
  meth_meth_ast_lineLength997->definitionModule = modulename;
  meth_meth_ast_lineLength997->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe998 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit999 == NULL) {
    strlit999 = alloc_String("uninitialized");
    gc_root(strlit999);
  }
// compiled string node returning strlit999 (depth = 3)
  gc_frame_newslot(strlit999);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1000 = gc_frame_new();
// call case 5: prelude request
  Object call1001 = callmethodflags(prelude, "Singleton", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1000);
// compiled member node returning call1001 (depth = 3)
  params[0] = strlit999;
  partcv[0] = 1;
  Object call1002 = callmethodflags(call1001, "named(1)", 1, partcv, params, 0);
  gc_frame_end(callframe998);
// compiled call node returning call1002 (depth = 2)
  *var_uninitialized = call1002;
  if (call1002 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "uninitialized"
  block_savedest(self);
  Object closure1003 = createclosure(1, "uninitialized");
  setclosureframe(closure1003, stackframe);
  addtoclosure(closure1003, var_uninitialized);
  struct UserObject *uo1003 = (struct UserObject*)self;
  uo1003->data[11] = (Object)closure1003;
  Method *meth_meth_ast_uninitialized1003 = addmethod2pos(self, "uninitialized", &meth_ast_uninitialized1003, 11);
  int argcv_meth_ast_uninitialized1003[] = {0};
  meth_meth_ast_uninitialized1003->type = alloc_MethodType(1, argcv_meth_ast_uninitialized1003);
  meth_meth_ast_uninitialized1003->definitionModule = modulename;
  meth_meth_ast_uninitialized1003->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1004 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1004 = alloc_userobj2(5,6, objclass1004);
  gc_frame_newslot(obj1004);
if (objclass1004 == NULL) {
  glfree(obj1004->class->name);
  obj1004->class->name = "ancestorChain";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1004, self, 0);
  addmethodreal(obj1004,"outer", &reader_ast_outer_1005);
  Object oldself1004 = self;
  struct StackFrameObject *oldstackframe1004 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1004);
  gc_frame_newslot((Object)stackframe);
  self = obj1004;
  Object *oldselfslot1004 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1004 = (*(struct UserObject *)self).data[0], lowerouter1004 = thisouter1004;
  if (inheritingObject1004) {
    struct UserObject *inho1004 = (struct UserObject *)inheritingObject1004;
    while (inho1004->super != GraceDefaultObject) inho1004 = (struct UserObject *)inho1004->super;
    inho1004->super = obj1004;
    self = inheritingObject1004;
    *selfslot = self;
    lowerouter1004 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1004;
  }
// method "empty"
  struct UserObject *uo1006 = (struct UserObject*)obj1004;
  uo1006->data[1] = emptyclosure;
  Method *meth_meth_ast_empty1006 = addmethod2pos(obj1004, "empty", &meth_ast_empty1006, 1);
  int argcv_meth_ast_empty1006[] = {0};
  meth_meth_ast_empty1006->type = alloc_MethodType(1, argcv_meth_ast_empty1006);
  meth_meth_ast_empty1006->definitionModule = modulename;
  meth_meth_ast_empty1006->definitionLine = 40;
  Method *meth_meth_ast_empty1006_object = addmethod2pos(obj1004, "empty$object(1)", &meth_ast_empty1006_object, 1);
  int argcv_meth_ast_empty1006_object[] = {0};
  meth_meth_ast_empty1006_object->type = alloc_MethodType(1, argcv_meth_ast_empty1006_object);
  meth_meth_ast_empty1006_object->definitionModule = modulename;
  meth_meth_ast_empty1006_object->definitionLine = 40;
// method "with(_)"
  struct UserObject *uo1019 = (struct UserObject*)obj1004;
  uo1019->data[2] = emptyclosure;
  Method *meth_meth_ast_with_40_1_41_1019 = addmethod2pos(obj1004, "with(1)", &meth_ast_with_40_1_41_1019, 2);
  int argcv_meth_ast_with_40_1_41_1019[] = {1};
  meth_meth_ast_with_40_1_41_1019->type = alloc_MethodType(1, argcv_meth_ast_with_40_1_41_1019);
  meth_meth_ast_with_40_1_41_1019->definitionModule = modulename;
  meth_meth_ast_with_40_1_41_1019->definitionLine = 45;
// method "cons(_)onto(_)"
  struct UserObject *uo1024 = (struct UserObject*)obj1004;
  uo1024->data[3] = emptyclosure;
  Method *meth_meth_ast_cons_40_1_41_onto_40_1_41_1024 = addmethod2pos(obj1004, "cons(1)onto(1)", &meth_ast_cons_40_1_41_onto_40_1_41_1024, 3);
  int argcv_meth_ast_cons_40_1_41_onto_40_1_41_1024[] = {1, 1};
  meth_meth_ast_cons_40_1_41_onto_40_1_41_1024->type = alloc_MethodType(2, argcv_meth_ast_cons_40_1_41_onto_40_1_41_1024);
  meth_meth_ast_cons_40_1_41_onto_40_1_41_1024->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_cons_40_1_41_onto_40_1_41_1024->definitionModule = modulename;
  meth_meth_ast_cons_40_1_41_onto_40_1_41_1024->definitionLine = 46;
  Method *meth_meth_ast_cons_40_1_41_onto_40_1_41_1024_object = addmethod2pos(obj1004, "cons(1)onto(1)$object(1)", &meth_ast_cons_40_1_41_onto_40_1_41_1024_object, 3);
  int argcv_meth_ast_cons_40_1_41_onto_40_1_41_1024_object[] = {1, 1};
  meth_meth_ast_cons_40_1_41_onto_40_1_41_1024_object->type = alloc_MethodType(2, argcv_meth_ast_cons_40_1_41_onto_40_1_41_1024_object);
  meth_meth_ast_cons_40_1_41_onto_40_1_41_1024_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_cons_40_1_41_onto_40_1_41_1024_object->definitionModule = modulename;
  meth_meth_ast_cons_40_1_41_onto_40_1_41_1024_object->definitionLine = 46;
  sourceObject = obj1004;
  sourceObject = obj1004;
  sourceObject = obj1004;
  objclass1004 = obj1004->class;
  objclass1004->definitionModule = modulename;
  objclass1004->definitionLine = 39;
  (*(struct UserObject *)self).data[0] = lowerouter1004;
  self = oldself1004;
  selfslot = oldselfslot1004;
  stackframe = oldstackframe1004;
// compiled object node returning obj1004 (depth = 2)
  *var_ancestorChain = obj1004;
  if (obj1004 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ancestorChain"
  block_savedest(self);
  Object closure1073 = createclosure(1, "ancestorChain");
  setclosureframe(closure1073, stackframe);
  addtoclosure(closure1073, var_ancestorChain);
  struct UserObject *uo1073 = (struct UserObject*)self;
  uo1073->data[12] = (Object)closure1073;
  Method *meth_meth_ast_ancestorChain1073 = addmethod2pos(self, "ancestorChain", &meth_ast_ancestorChain1073, 12);
  int argcv_meth_ast_ancestorChain1073[] = {0};
  meth_meth_ast_ancestorChain1073->type = alloc_MethodType(1, argcv_meth_ast_ancestorChain1073);
  meth_meth_ast_ancestorChain1073->definitionModule = modulename;
  meth_meth_ast_ancestorChain1073->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile member node (depth = 2)
  int callframe1074 = gc_frame_new();
// call case 5: prelude request
  Object call1075 = callmethodflags(prelude, "emptySequence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1074);
// compiled member node returning call1075 (depth = 2)
  *var_emptySeq = call1075;
  if (call1075 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "emptySeq"
  block_savedest(self);
  Object closure1076 = createclosure(1, "emptySeq");
  setclosureframe(closure1076, stackframe);
  addtoclosure(closure1076, var_emptySeq);
  struct UserObject *uo1076 = (struct UserObject*)self;
  uo1076->data[13] = (Object)closure1076;
  Method *meth_meth_ast_emptySeq1076 = addmethod2pos(self, "emptySeq", &meth_ast_emptySeq1076, 13);
  int argcv_meth_ast_emptySeq1076[] = {0};
  meth_meth_ast_emptySeq1076->type = alloc_MethodType(1, argcv_meth_ast_emptySeq1076);
  meth_meth_ast_emptySeq1076->definitionModule = modulename;
  meth_meth_ast_emptySeq1076->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl AstNode
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type1078 = alloc_Type("AstNode", 9);
    add_Method((ClassData)type1078, "kind", NULL);
    add_Method((ClassData)type1078, "register", NULL);
    add_Method((ClassData)type1078, "line", NULL);
    add_Method((ClassData)type1078, "line:=(1)", NULL);
    add_Method((ClassData)type1078, "linePos", NULL);
    add_Method((ClassData)type1078, "linePos:=(1)", NULL);
    add_Method((ClassData)type1078, "scope", NULL);
    add_Method((ClassData)type1078, "pretty(1)", NULL);
    add_Method((ClassData)type1078, "comments", NULL);
// compiled typeliteral node returning type1078 (depth = 2)
  *var_AstNode = type1078;
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "AstNode"
  block_savedest(self);
  Object closure1079 = createclosure(1, "AstNode");
  setclosureframe(closure1079, stackframe);
  addtoclosure(closure1079, var_AstNode);
  struct UserObject *uo1079 = (struct UserObject*)self;
  uo1079->data[14] = (Object)closure1079;
  Method *meth_meth_ast_AstNode1079 = addmethod2pos(self, "AstNode", &meth_ast_AstNode1079, 14);
  int argcv_meth_ast_AstNode1079[] = {0};
  meth_meth_ast_AstNode1079->type = alloc_MethodType(1, argcv_meth_ast_AstNode1079);
  meth_meth_ast_AstNode1079->definitionModule = modulename;
  meth_meth_ast_AstNode1079->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl SymbolTable
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_Unknown (depth = 2)
  *var_SymbolTable = *var_Unknown;
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "SymbolTable"
  block_savedest(self);
  Object closure1081 = createclosure(1, "SymbolTable");
  setclosureframe(closure1081, stackframe);
  addtoclosure(closure1081, var_SymbolTable);
  struct UserObject *uo1081 = (struct UserObject*)self;
  uo1081->data[15] = (Object)closure1081;
  Method *meth_meth_ast_SymbolTable1081 = addmethod2pos(self, "SymbolTable", &meth_ast_SymbolTable1081, 15);
  int argcv_meth_ast_SymbolTable1081[] = {0};
  meth_meth_ast_SymbolTable1081->type = alloc_MethodType(1, argcv_meth_ast_SymbolTable1081);
  meth_meth_ast_SymbolTable1081->definitionModule = modulename;
  meth_meth_ast_SymbolTable1081->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1082 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1082 = alloc_userobj2(11,12, objclass1082);
  gc_frame_newslot(obj1082);
if (objclass1082 == NULL) {
  glfree(obj1082->class->name);
  obj1082->class->name = "implicit";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1082, self, 0);
  addmethodreal(obj1082,"outer", &reader_ast_outer_1083);
  Object oldself1082 = self;
  struct StackFrameObject *oldstackframe1082 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1082);
  gc_frame_newslot((Object)stackframe);
  self = obj1082;
  Object *oldselfslot1082 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1082 = (*(struct UserObject *)self).data[0], lowerouter1082 = thisouter1082;
  if (inheritingObject1082) {
    struct UserObject *inho1082 = (struct UserObject *)inheritingObject1082;
    while (inho1082->super != GraceDefaultObject) inho1082 = (struct UserObject *)inho1082->super;
    inho1082->super = obj1082;
    self = inheritingObject1082;
    *selfslot = self;
    lowerouter1082 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1082;
  }
if (objclass1082 == NULL) {
  Method *reader1084 = addmethodrealflags(obj1082, "kind",&reader_ast_kind_1084, MFLAG_DEF);
  reader1084->definitionModule = modulename;
  reader1084->definitionLine = 210;
}
adddatum2(obj1082, alloc_Undefined(), 1);
if (objclass1082 == NULL) {
  Method *reader1085 = addmethodrealflags(obj1082, "nameString",&reader_ast_nameString_1085, MFLAG_DEF);
  reader1085->definitionModule = modulename;
  reader1085->definitionLine = 211;
}
adddatum2(obj1082, alloc_Undefined(), 2);
// method "isImplicit"
  struct UserObject *uo1086 = (struct UserObject*)obj1082;
  uo1086->data[3] = emptyclosure;
  Method *meth_meth_ast_isImplicit1086 = addmethod2pos(obj1082, "isImplicit", &meth_ast_isImplicit1086, 3);
  int argcv_meth_ast_isImplicit1086[] = {0};
  meth_meth_ast_isImplicit1086->type = alloc_MethodType(1, argcv_meth_ast_isImplicit1086);
  meth_meth_ast_isImplicit1086->definitionModule = modulename;
  meth_meth_ast_isImplicit1086->definitionLine = 212;
// method "toGrace(_)"
  struct UserObject *uo1088 = (struct UserObject*)obj1082;
  uo1088->data[4] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_1088 = addmethod2pos(obj1082, "toGrace(1)", &meth_ast_toGrace_40_1_41_1088, 4);
  int argcv_meth_ast_toGrace_40_1_41_1088[] = {1};
  meth_meth_ast_toGrace_40_1_41_1088->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_1088);
  meth_meth_ast_toGrace_40_1_41_1088->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_1088->definitionLine = 213;
// method "asString"
  struct UserObject *uo1090 = (struct UserObject*)obj1082;
  uo1090->data[5] = emptyclosure;
  Method *meth_meth_ast_asString1090 = addmethod2pos(obj1082, "asString", &meth_ast_asString1090, 5);
  int argcv_meth_ast_asString1090[] = {0};
  meth_meth_ast_asString1090->type = alloc_MethodType(1, argcv_meth_ast_asString1090);
  meth_meth_ast_asString1090->definitionModule = modulename;
  meth_meth_ast_asString1090->definitionLine = 214;
// method "==(_)"
  struct UserObject *uo1092 = (struct UserObject*)obj1082;
  uo1092->data[6] = emptyclosure;
  Method *meth_meth_ast__61__61__40_1_41_1092 = addmethod2pos(obj1082, "==(1)", &meth_ast__61__61__40_1_41_1092, 6);
  int argcv_meth_ast__61__61__40_1_41_1092[] = {1};
  meth_meth_ast__61__61__40_1_41_1092->type = alloc_MethodType(1, argcv_meth_ast__61__61__40_1_41_1092);
  meth_meth_ast__61__61__40_1_41_1092->definitionModule = modulename;
  meth_meth_ast__61__61__40_1_41_1092->definitionLine = 215;
// method "map(_)ancestors(_)"
  struct UserObject *uo1095 = (struct UserObject*)obj1082;
  uo1095->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40_1_41_ancestors_40_1_41_1095 = addmethod2pos(obj1082, "map(1)ancestors(1)", &meth_ast_map_40_1_41_ancestors_40_1_41_1095, 7);
  int argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1095[] = {1, 1};
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1095->type = alloc_MethodType(2, argcv_meth_ast_map_40_1_41_ancestors_40_1_41_1095);
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1095->definitionModule = modulename;
  meth_meth_ast_map_40_1_41_ancestors_40_1_41_1095->definitionLine = 216;
// method "accept(_)from(_)"
  struct UserObject *uo1096 = (struct UserObject*)obj1082;
  uo1096->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40_1_41_from_40_1_41_1096 = addmethod2pos(obj1082, "accept(1)from(1)", &meth_ast_accept_40_1_41_from_40_1_41_1096, 8);
  int argcv_meth_ast_accept_40_1_41_from_40_1_41_1096[] = {1, 1};
  meth_meth_ast_accept_40_1_41_from_40_1_41_1096->type = alloc_MethodType(2, argcv_meth_ast_accept_40_1_41_from_40_1_41_1096);
  meth_meth_ast_accept_40_1_41_from_40_1_41_1096->definitionModule = modulename;
  meth_meth_ast_accept_40_1_41_from_40_1_41_1096->definitionLine = 217;
// method "pretty(_)"
  struct UserObject *uo1099 = (struct UserObject*)obj1082;
  uo1099->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty_40_1_41_1099 = addmethod2pos(obj1082, "pretty(1)", &meth_ast_pretty_40_1_41_1099, 9);
  int argcv_meth_ast_pretty_40_1_41_1099[] = {1};
  meth_meth_ast_pretty_40_1_41_1099->type = alloc_MethodType(1, argcv_meth_ast_pretty_40_1_41_1099);
  meth_meth_ast_pretty_40_1_41_1099->definitionModule = modulename;
  meth_meth_ast_pretty_40_1_41_1099->definitionLine = 220;
  sourceObject = obj1082;
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1101 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1102 = gc_frame_new();
// call case 3: self.outer request
  Object call1103 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1102);
// compiled member node returning call1103 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1104 = callmethodflags(call1103, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1101);
// compiled call node returning call1104 (depth = 3)
  struct UserObject *obj1082_uo = (struct UserObject *)obj1082;
  obj1082_uo->super = call1104;
  sourceObject = obj1082;
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1105 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num1106 = alloc_Float64(0);
// compiled num node returning num1106 (depth = 4)
  gc_frame_newslot(num1106);
// call case 4: self request
  params[0] = num1106;
  partcv[0] = 1;
  Object call1107 = callmethodflags(self, "line:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1105);
// compiled call node returning call1107 (depth = 3)
  sourceObject = obj1082;
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1108 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num1109 = alloc_Float64(0);
// compiled num node returning num1109 (depth = 4)
  gc_frame_newslot(num1109);
// call case 4: self request
  params[0] = num1109;
  partcv[0] = 1;
  Object call1110 = callmethodflags(self, "linePos:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1108);
// compiled call node returning call1110 (depth = 3)
  sourceObject = obj1082;
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1111 == NULL) {
    strlit1111 = alloc_String("implicit");
    gc_root(strlit1111);
  }
// compiled string node returning strlit1111 (depth = 3)
  adddatum2(obj1082, strlit1111, 1);
  sourceObject = obj1082;
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1112 == NULL) {
    strlit1112 = alloc_String("implicit");
    gc_root(strlit1112);
  }
// compiled string node returning strlit1112 (depth = 3)
  adddatum2(obj1082, strlit1112, 2);
  sourceObject = obj1082;
  sourceObject = obj1082;
  sourceObject = obj1082;
  sourceObject = obj1082;
  sourceObject = obj1082;
  sourceObject = obj1082;
  sourceObject = obj1082;
  objclass1082 = obj1082->class;
  objclass1082->definitionModule = modulename;
  objclass1082->definitionLine = 206;
  (*(struct UserObject *)self).data[0] = lowerouter1082;
  self = oldself1082;
  selfslot = oldselfslot1082;
  stackframe = oldstackframe1082;
// compiled object node returning obj1082 (depth = 2)
  *var_implicit = obj1082;
  if (obj1082 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "implicit"
  block_savedest(self);
  Object closure1113 = createclosure(1, "implicit");
  setclosureframe(closure1113, stackframe);
  addtoclosure(closure1113, var_implicit);
  struct UserObject *uo1113 = (struct UserObject*)self;
  uo1113->data[16] = (Object)closure1113;
  Method *meth_meth_ast_implicit1113 = addmethod2pos(self, "implicit", &meth_ast_implicit1113, 16);
  int argcv_meth_ast_implicit1113[] = {0};
  meth_meth_ast_implicit1113->type = alloc_MethodType(1, argcv_meth_ast_implicit1113);
  meth_meth_ast_implicit1113->definitionModule = modulename;
  meth_meth_ast_implicit1113->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1114 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1114 = alloc_userobj2(4,5, objclass1114);
  gc_frame_newslot(obj1114);
if (objclass1114 == NULL) {
  glfree(obj1114->class->name);
  obj1114->class->name = "nullNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1114, self, 0);
  addmethodreal(obj1114,"outer", &reader_ast_outer_1115);
  Object oldself1114 = self;
  struct StackFrameObject *oldstackframe1114 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1114);
  gc_frame_newslot((Object)stackframe);
  self = obj1114;
  Object *oldselfslot1114 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1114 = (*(struct UserObject *)self).data[0], lowerouter1114 = thisouter1114;
  if (inheritingObject1114) {
    struct UserObject *inho1114 = (struct UserObject *)inheritingObject1114;
    while (inho1114->super != GraceDefaultObject) inho1114 = (struct UserObject *)inho1114->super;
    inho1114->super = obj1114;
    self = inheritingObject1114;
    *selfslot = self;
    lowerouter1114 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1114;
  }
if (objclass1114 == NULL) {
  Method *reader1116 = addmethodrealflags(obj1114, "kind",&reader_ast_kind_1116, MFLAG_DEF);
  reader1116->definitionModule = modulename;
  reader1116->definitionLine = 225;
}
adddatum2(obj1114, alloc_Undefined(), 1);
// method "toGrace(_)"
  struct UserObject *uo1117 = (struct UserObject*)obj1114;
  uo1117->data[2] = emptyclosure;
  Method *meth_meth_ast_toGrace_40_1_41_1117 = addmethod2pos(obj1114, "toGrace(1)", &meth_ast_toGrace_40_1_41_1117, 2);
  int argcv_meth_ast_toGrace_40_1_41_1117[] = {1};
  meth_meth_ast_toGrace_40_1_41_1117->type = alloc_MethodType(1, argcv_meth_ast_toGrace_40_1_41_1117);
  meth_meth_ast_toGrace_40_1_41_1117->definitionModule = modulename;
  meth_meth_ast_toGrace_40_1_41_1117->definitionLine = 226;
// method "asString"
  struct UserObject *uo1119 = (struct UserObject*)obj1114;
  uo1119->data[3] = emptyclosure;
  Method *meth_meth_ast_asString1119 = addmethod2pos(obj1114, "asString", &meth_ast_asString1119, 3);
  int argcv_meth_ast_asString1119[] = {0};
  meth_meth_ast_asString1119->type = alloc_MethodType(1, argcv_meth_ast_asString1119);
  meth_meth_ast_asString1119->definitionModule = modulename;
  meth_meth_ast_asString1119->definitionLine = 229;
// method "==(_)"
  struct UserObject *uo1121 = (struct UserObject*)obj1114;
  uo1121->data[4] = emptyclosure;
  Method *meth_meth_ast__61__61__40_1_41_1121 = addmethod2pos(obj1114, "==(1)", &meth_ast__61__61__40_1_41_1121, 4);
  int argcv_meth_ast__61__61__40_1_41_1121[] = {1};
  meth_meth_ast__61__61__40_1_41_1121->type = alloc_MethodType(1, argcv_meth_ast__61__61__40_1_41_1121);
  meth_meth_ast__61__61__40_1_41_1121->definitionModule = modulename;
  meth_meth_ast__61__61__40_1_41_1121->definitionLine = 230;
  sourceObject = obj1114;
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1124 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1125 = gc_frame_new();
// call case 3: self.outer request
  Object call1126 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1125);
// compiled member node returning call1126 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1127 = callmethodflags(call1126, "baseNode$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1124);
// compiled call node returning call1127 (depth = 3)
  struct UserObject *obj1114_uo = (struct UserObject *)obj1114;
  obj1114_uo->super = call1127;
  sourceObject = obj1114;
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1128 == NULL) {
    strlit1128 = alloc_String("null");
    gc_root(strlit1128);
  }
// compiled string node returning strlit1128 (depth = 3)
  adddatum2(obj1114, strlit1128, 1);
  sourceObject = obj1114;
  sourceObject = obj1114;
  sourceObject = obj1114;
  objclass1114 = obj1114->class;
  objclass1114->definitionModule = modulename;
  objclass1114->definitionLine = 223;
  (*(struct UserObject *)self).data[0] = lowerouter1114;
  self = oldself1114;
  selfslot = oldselfslot1114;
  stackframe = oldstackframe1114;
// compiled object node returning obj1114 (depth = 2)
  *var_nullNode = obj1114;
  if (obj1114 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "nullNode"
  block_savedest(self);
  Object closure1129 = createclosure(1, "nullNode");
  setclosureframe(closure1129, stackframe);
  addtoclosure(closure1129, var_nullNode);
  struct UserObject *uo1129 = (struct UserObject*)self;
  uo1129->data[17] = (Object)closure1129;
  Method *meth_meth_ast_nullNode1129 = addmethod2pos(self, "nullNode", &meth_ast_nullNode1129, 17);
  int argcv_meth_ast_nullNode1129[] = {0};
  meth_meth_ast_nullNode1129->type = alloc_MethodType(1, argcv_meth_ast_nullNode1129);
  meth_meth_ast_nullNode1129->definitionModule = modulename;
  meth_meth_ast_nullNode1129->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1130 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1130 = alloc_userobj2(8,8, objclass1130);
  gc_frame_newslot(obj1130);
if (objclass1130 == NULL) {
  glfree(obj1130->class->name);
  obj1130->class->name = "fakeSymbolTable";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1130, self, 0);
  addmethodreal(obj1130,"outer", &reader_ast_outer_1131);
  Object oldself1130 = self;
  struct StackFrameObject *oldstackframe1130 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1130);
  gc_frame_newslot((Object)stackframe);
  self = obj1130;
  Object *oldselfslot1130 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1130 = (*(struct UserObject *)self).data[0], lowerouter1130 = thisouter1130;
  if (inheritingObject1130) {
    struct UserObject *inho1130 = (struct UserObject *)inheritingObject1130;
    while (inho1130->super != GraceDefaultObject) inho1130 = (struct UserObject *)inho1130->super;
    inho1130->super = obj1130;
    self = inheritingObject1130;
    *selfslot = self;
    lowerouter1130 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1130;
  }
if (objclass1130 == NULL) {
  Method *reader1132 = addmethodrealflags(obj1130, "node", &reader_ast_node_1132, 0);
  Method *writer1132 = addmethodrealflags(obj1130, "node:=(1)", &writer_ast_node_1132, 0);
  reader1132->definitionModule = modulename;
  writer1132->definitionModule = modulename;
  reader1132->definitionLine = 234;
  writer1132->definitionLine = 234;
}
obj1130->flags |= OFLAG_MUTABLE;
adddatum2(obj1130, alloc_Undefined(), 1);
// method "asString"
  struct UserObject *uo1133 = (struct UserObject*)obj1130;
  uo1133->data[2] = emptyclosure;
  Method *meth_meth_ast_asString1133 = addmethod2pos(obj1130, "asString", &meth_ast_asString1133, 2);
  int argcv_meth_ast_asString1133[] = {0};
  meth_meth_ast_asString1133->type = alloc_MethodType(1, argcv_meth_ast_asString1133);
  meth_meth_ast_asString1133->definitionModule = modulename;
  meth_meth_ast_asString1133->definitionLine = 235;
// method "addNode(_)as(_)"
  struct UserObject *uo1135 = (struct UserObject*)obj1130;
  uo1135->data[3] = emptyclosure;
  Method *meth_meth_ast_addNode_40_1_41_as_40_1_41_1135 = addmethod2pos(obj1130, "addNode(1)as(1)", &meth_ast_addNode_40_1_41_as_40_1_41_1135, 3);
  int argcv_meth_ast_addNode_40_1_41_as_40_1_41_1135[] = {1, 1};
  meth_meth_ast_addNode_40_1_41_as_40_1_41_1135->type = alloc_MethodType(2, argcv_meth_ast_addNode_40_1_41_as_40_1_41_1135);
  meth_meth_ast_addNode_40_1_41_as_40_1_41_1135->definitionModule = modulename;
  meth_meth_ast_addNode_40_1_41_as_40_1_41_1135->definitionLine = 236;
// method "thatDefines(_)ifNone(_)"
  struct UserObject *uo1164 = (struct UserObject*)obj1130;
  uo1164->data[4] = emptyclosure;
  Method *meth_meth_ast_thatDefines_40_1_41_ifNone_40_1_41_1164 = addmethod2pos(obj1130, "thatDefines(1)ifNone(1)", &meth_ast_thatDefines_40_1_41_ifNone_40_1_41_1164, 4);
  int argcv_meth_ast_thatDefines_40_1_41_ifNone_40_1_41_1164[] = {1, 1};
  meth_meth_ast_thatDefines_40_1_41_ifNone_40_1_41_1164->type = alloc_MethodType(2, argcv_meth_ast_thatDefines_40_1_41_ifNone_40_1_41_1164);
  meth_meth_ast_thatDefines_40_1_41_ifNone_40_1_41_1164->definitionModule = modulename;
  meth_meth_ast_thatDefines_40_1_41_ifNone_40_1_41_1164->definitionLine = 239;
// method "enclosingObjectScope"
  struct UserObject *uo1177 = (struct UserObject*)obj1130;
  uo1177->data[5] = emptyclosure;
  Method *meth_meth_ast_enclosingObjectScope1177 = addmethod2pos(obj1130, "enclosingObjectScope", &meth_ast_enclosingObjectScope1177, 5);
  int argcv_meth_ast_enclosingObjectScope1177[] = {0};
  meth_meth_ast_enclosingObjectScope1177->type = alloc_MethodType(1, argcv_meth_ast_enclosingObjectScope1177);
  meth_meth_ast_enclosingObjectScope1177->definitionModule = modulename;
  meth_meth_ast_enclosingObjectScope1177->definitionLine = 242;
// method "variety"
  struct UserObject *uo1192 = (struct UserObject*)obj1130;
  uo1192->data[6] = emptyclosure;
  Method *meth_meth_ast_variety1192 = addmethod2pos(obj1130, "variety", &meth_ast_variety1192, 6);
  int argcv_meth_ast_variety1192[] = {0};
  meth_meth_ast_variety1192->type = alloc_MethodType(1, argcv_meth_ast_variety1192);
  meth_meth_ast_variety1192->definitionModule = modulename;
  meth_meth_ast_variety1192->definitionLine = 245;
// method "==(_)"
  struct UserObject *uo1194 = (struct UserObject*)obj1130;
  uo1194->data[7] = emptyclosure;
  Method *meth_meth_ast__61__61__40_1_41_1194 = addmethod2pos(obj1130, "==(1)", &meth_ast__61__61__40_1_41_1194, 7);
  int argcv_meth_ast__61__61__40_1_41_1194[] = {1};
  meth_meth_ast__61__61__40_1_41_1194->type = alloc_MethodType(1, argcv_meth_ast__61__61__40_1_41_1194);
  meth_meth_ast__61__61__40_1_41_1194->definitionModule = modulename;
  meth_meth_ast__61__61__40_1_41_1194->definitionLine = 246;
  sourceObject = obj1130;
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_nullNode (depth = 3)
  adddatum2(obj1130, *var_nullNode, 1);
  sourceObject = obj1130;
  sourceObject = obj1130;
  sourceObject = obj1130;
  sourceObject = obj1130;
  sourceObject = obj1130;
  sourceObject = obj1130;
  objclass1130 = obj1130->class;
  objclass1130->definitionModule = modulename;
  objclass1130->definitionLine = 233;
  (*(struct UserObject *)self).data[0] = lowerouter1130;
  self = oldself1130;
  selfslot = oldselfslot1130;
  stackframe = oldstackframe1130;
// compiled object node returning obj1130 (depth = 2)
  *var_fakeSymbolTable = obj1130;
  if (obj1130 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "fakeSymbolTable"
  block_savedest(self);
  Object closure1197 = createclosure(1, "fakeSymbolTable");
  setclosureframe(closure1197, stackframe);
  addtoclosure(closure1197, var_fakeSymbolTable);
  struct UserObject *uo1197 = (struct UserObject*)self;
  uo1197->data[18] = (Object)closure1197;
  Method *meth_meth_ast_fakeSymbolTable1197 = addmethod2pos(self, "fakeSymbolTable", &meth_ast_fakeSymbolTable1197, 18);
  int argcv_meth_ast_fakeSymbolTable1197[] = {0};
  meth_meth_ast_fakeSymbolTable1197->type = alloc_MethodType(1, argcv_meth_ast_fakeSymbolTable1197);
  meth_meth_ast_fakeSymbolTable1197->definitionModule = modulename;
  meth_meth_ast_fakeSymbolTable1197->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1198 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1198 = alloc_userobj2(2,4, objclass1198);
  gc_frame_newslot(obj1198);
if (objclass1198 == NULL) {
  glfree(obj1198->class->name);
  obj1198->class->name = "ifNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1198, self, 0);
  addmethodreal(obj1198,"outer", &reader_ast_outer_1199);
  Object oldself1198 = self;
  struct StackFrameObject *oldstackframe1198 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1198);
  gc_frame_newslot((Object)stackframe);
  self = obj1198;
  Object *oldselfslot1198 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1198 = (*(struct UserObject *)self).data[0], lowerouter1198 = thisouter1198;
  if (inheritingObject1198) {
    struct UserObject *inho1198 = (struct UserObject *)inheritingObject1198;
    while (inho1198->super != GraceDefaultObject) inho1198 = (struct UserObject *)inho1198->super;
    inho1198->super = obj1198;
    self = inheritingObject1198;
    *selfslot = self;
    lowerouter1198 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1198;
  }
// method "new(_,_,_)"
  block_savedest(obj1198);
  Object closure1200 = createclosure(3, "new(3)");
  setclosureframe(closure1200, stackframe);
  addtoclosure(closure1200, var_util);
  addtoclosure(closure1200, var_nullNode);
  addtoclosure(closure1200, var_ifNode);
  struct UserObject *uo1200 = (struct UserObject*)obj1198;
  uo1200->data[1] = (Object)closure1200;
  Method *meth_meth_ast_new_40_3_41_1200 = addmethod2pos(obj1198, "new(3)", &meth_ast_new_40_3_41_1200, 1);
  int argcv_meth_ast_new_40_3_41_1200[] = {3};
  meth_meth_ast_new_40_3_41_1200->type = alloc_MethodType(1, argcv_meth_ast_new_40_3_41_1200);
  meth_meth_ast_new_40_3_41_1200->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_1200->definitionLine = 250;
  block_savedest(obj1198);
  Object closure1555 = createclosure(3, "new(3)$object(1)");
  setclosureframe(closure1555, stackframe);
  addtoclosure(closure1555, var_util);
  addtoclosure(closure1555, var_nullNode);
  addtoclosure(closure1555, var_ifNode);
  Method *meth_meth_ast_new_40_3_41_1200_object = addmethod2pos(obj1198, "new(3)$object(1)", &meth_ast_new_40_3_41_1200_object, 1);
  meth_meth_ast_new_40_3_41_1200_object->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_1200_object->definitionLine = 250;
  sourceObject = obj1198;
  objclass1198 = obj1198->class;
  objclass1198->definitionModule = modulename;
  objclass1198->definitionLine = 249;
  (*(struct UserObject *)self).data[0] = lowerouter1198;
  self = oldself1198;
  selfslot = oldselfslot1198;
  stackframe = oldstackframe1198;
// compiled object node returning obj1198 (depth = 2)
  *var_ifNode = obj1198;
  if (obj1198 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ifNode"
  block_savedest(self);
  Object closure1556 = createclosure(1, "ifNode");
  setclosureframe(closure1556, stackframe);
  addtoclosure(closure1556, var_ifNode);
  struct UserObject *uo1556 = (struct UserObject*)self;
  uo1556->data[19] = (Object)closure1556;
  Method *meth_meth_ast_ifNode1556 = addmethod2pos(self, "ifNode", &meth_ast_ifNode1556, 19);
  int argcv_meth_ast_ifNode1556[] = {0};
  meth_meth_ast_ifNode1556->type = alloc_MethodType(1, argcv_meth_ast_ifNode1556);
  meth_meth_ast_ifNode1556->definitionModule = modulename;
  meth_meth_ast_ifNode1556->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1557 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1557 = alloc_userobj2(2,4, objclass1557);
  gc_frame_newslot(obj1557);
if (objclass1557 == NULL) {
  glfree(obj1557->class->name);
  obj1557->class->name = "blockNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1557, self, 0);
  addmethodreal(obj1557,"outer", &reader_ast_outer_1558);
  Object oldself1557 = self;
  struct StackFrameObject *oldstackframe1557 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1557);
  gc_frame_newslot((Object)stackframe);
  self = obj1557;
  Object *oldselfslot1557 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1557 = (*(struct UserObject *)self).data[0], lowerouter1557 = thisouter1557;
  if (inheritingObject1557) {
    struct UserObject *inho1557 = (struct UserObject *)inheritingObject1557;
    while (inho1557->super != GraceDefaultObject) inho1557 = (struct UserObject *)inho1557->super;
    inho1557->super = obj1557;
    self = inheritingObject1557;
    *selfslot = self;
    lowerouter1557 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1557;
  }
// method "new(_,_)"
  block_savedest(obj1557);
  Object closure1559 = createclosure(4, "new(2)");
  setclosureframe(closure1559, stackframe);
  addtoclosure(closure1559, var_k);
  addtoclosure(closure1559, var_blockNode);
  addtoclosure(closure1559, var_patternMarkVisitor);
  addtoclosure(closure1559, var_ancestorChain);
  struct UserObject *uo1559 = (struct UserObject*)obj1557;
  uo1559->data[1] = (Object)closure1559;
  Method *meth_meth_ast_new_40_2_41_1559 = addmethod2pos(obj1557, "new(2)", &meth_ast_new_40_2_41_1559, 1);
  int argcv_meth_ast_new_40_2_41_1559[] = {2};
  meth_meth_ast_new_40_2_41_1559->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_1559);
  meth_meth_ast_new_40_2_41_1559->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_1559->definitionLine = 327;
  block_savedest(obj1557);
  Object closure2017 = createclosure(4, "new(2)$object(1)");
  setclosureframe(closure2017, stackframe);
  addtoclosure(closure2017, var_k);
  addtoclosure(closure2017, var_blockNode);
  addtoclosure(closure2017, var_patternMarkVisitor);
  addtoclosure(closure2017, var_ancestorChain);
  Method *meth_meth_ast_new_40_2_41_1559_object = addmethod2pos(obj1557, "new(2)$object(1)", &meth_ast_new_40_2_41_1559_object, 1);
  meth_meth_ast_new_40_2_41_1559_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_1559_object->definitionLine = 327;
  sourceObject = obj1557;
  objclass1557 = obj1557->class;
  objclass1557->definitionModule = modulename;
  objclass1557->definitionLine = 326;
  (*(struct UserObject *)self).data[0] = lowerouter1557;
  self = oldself1557;
  selfslot = oldselfslot1557;
  stackframe = oldstackframe1557;
// compiled object node returning obj1557 (depth = 2)
  *var_blockNode = obj1557;
  if (obj1557 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blockNode"
  block_savedest(self);
  Object closure2018 = createclosure(1, "blockNode");
  setclosureframe(closure2018, stackframe);
  addtoclosure(closure2018, var_blockNode);
  struct UserObject *uo2018 = (struct UserObject*)self;
  uo2018->data[20] = (Object)closure2018;
  Method *meth_meth_ast_blockNode2018 = addmethod2pos(self, "blockNode", &meth_ast_blockNode2018, 20);
  int argcv_meth_ast_blockNode2018[] = {0};
  meth_meth_ast_blockNode2018->type = alloc_MethodType(1, argcv_meth_ast_blockNode2018);
  meth_meth_ast_blockNode2018->definitionModule = modulename;
  meth_meth_ast_blockNode2018->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject2019 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2019 = alloc_userobj2(2,4, objclass2019);
  gc_frame_newslot(obj2019);
if (objclass2019 == NULL) {
  glfree(obj2019->class->name);
  obj2019->class->name = "tryCatchNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2019, self, 0);
  addmethodreal(obj2019,"outer", &reader_ast_outer_2020);
  Object oldself2019 = self;
  struct StackFrameObject *oldstackframe2019 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2019);
  gc_frame_newslot((Object)stackframe);
  self = obj2019;
  Object *oldselfslot2019 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2019 = (*(struct UserObject *)self).data[0], lowerouter2019 = thisouter2019;
  if (inheritingObject2019) {
    struct UserObject *inho2019 = (struct UserObject *)inheritingObject2019;
    while (inho2019->super != GraceDefaultObject) inho2019 = (struct UserObject *)inho2019->super;
    inho2019->super = obj2019;
    self = inheritingObject2019;
    *selfslot = self;
    lowerouter2019 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2019;
  }
// method "new(_,_,_)"
  block_savedest(obj2019);
  Object closure2021 = createclosure(3, "new(3)");
  setclosureframe(closure2021, stackframe);
  addtoclosure(closure2021, var_nullNode);
  addtoclosure(closure2021, var_emptySeq);
  addtoclosure(closure2021, var_tryCatchNode);
  struct UserObject *uo2021 = (struct UserObject*)obj2019;
  uo2021->data[1] = (Object)closure2021;
  Method *meth_meth_ast_new_40_3_41_2021 = addmethod2pos(obj2019, "new(3)", &meth_ast_new_40_3_41_2021, 1);
  int argcv_meth_ast_new_40_3_41_2021[] = {3};
  meth_meth_ast_new_40_3_41_2021->type = alloc_MethodType(1, argcv_meth_ast_new_40_3_41_2021);
  meth_meth_ast_new_40_3_41_2021->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_2021->definitionLine = 446;
  block_savedest(obj2019);
  Object closure2329 = createclosure(3, "new(3)$object(1)");
  setclosureframe(closure2329, stackframe);
  addtoclosure(closure2329, var_nullNode);
  addtoclosure(closure2329, var_emptySeq);
  addtoclosure(closure2329, var_tryCatchNode);
  Method *meth_meth_ast_new_40_3_41_2021_object = addmethod2pos(obj2019, "new(3)$object(1)", &meth_ast_new_40_3_41_2021_object, 1);
  meth_meth_ast_new_40_3_41_2021_object->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_2021_object->definitionLine = 446;
  sourceObject = obj2019;
  objclass2019 = obj2019->class;
  objclass2019->definitionModule = modulename;
  objclass2019->definitionLine = 445;
  (*(struct UserObject *)self).data[0] = lowerouter2019;
  self = oldself2019;
  selfslot = oldselfslot2019;
  stackframe = oldstackframe2019;
// compiled object node returning obj2019 (depth = 2)
  *var_tryCatchNode = obj2019;
  if (obj2019 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "tryCatchNode"
  block_savedest(self);
  Object closure2330 = createclosure(1, "tryCatchNode");
  setclosureframe(closure2330, stackframe);
  addtoclosure(closure2330, var_tryCatchNode);
  struct UserObject *uo2330 = (struct UserObject*)self;
  uo2330->data[21] = (Object)closure2330;
  Method *meth_meth_ast_tryCatchNode2330 = addmethod2pos(self, "tryCatchNode", &meth_ast_tryCatchNode2330, 21);
  int argcv_meth_ast_tryCatchNode2330[] = {0};
  meth_meth_ast_tryCatchNode2330->type = alloc_MethodType(1, argcv_meth_ast_tryCatchNode2330);
  meth_meth_ast_tryCatchNode2330->definitionModule = modulename;
  meth_meth_ast_tryCatchNode2330->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject2331 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2331 = alloc_userobj2(2,4, objclass2331);
  gc_frame_newslot(obj2331);
if (objclass2331 == NULL) {
  glfree(obj2331->class->name);
  obj2331->class->name = "matchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2331, self, 0);
  addmethodreal(obj2331,"outer", &reader_ast_outer_2332);
  Object oldself2331 = self;
  struct StackFrameObject *oldstackframe2331 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2331);
  gc_frame_newslot((Object)stackframe);
  self = obj2331;
  Object *oldselfslot2331 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2331 = (*(struct UserObject *)self).data[0], lowerouter2331 = thisouter2331;
  if (inheritingObject2331) {
    struct UserObject *inho2331 = (struct UserObject *)inheritingObject2331;
    while (inho2331->super != GraceDefaultObject) inho2331 = (struct UserObject *)inho2331->super;
    inho2331->super = obj2331;
    self = inheritingObject2331;
    *selfslot = self;
    lowerouter2331 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2331;
  }
// method "new(_,_,_)"
  block_savedest(obj2331);
  Object closure2333 = createclosure(3, "new(3)");
  setclosureframe(closure2333, stackframe);
  addtoclosure(closure2333, var_nullNode);
  addtoclosure(closure2333, var_emptySeq);
  addtoclosure(closure2333, var_matchCaseNode);
  struct UserObject *uo2333 = (struct UserObject*)obj2331;
  uo2333->data[1] = (Object)closure2333;
  Method *meth_meth_ast_new_40_3_41_2333 = addmethod2pos(obj2331, "new(3)", &meth_ast_new_40_3_41_2333, 1);
  int argcv_meth_ast_new_40_3_41_2333[] = {3};
  meth_meth_ast_new_40_3_41_2333->type = alloc_MethodType(1, argcv_meth_ast_new_40_3_41_2333);
  meth_meth_ast_new_40_3_41_2333->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_2333->definitionLine = 509;
  block_savedest(obj2331);
  Object closure2637 = createclosure(3, "new(3)$object(1)");
  setclosureframe(closure2637, stackframe);
  addtoclosure(closure2637, var_nullNode);
  addtoclosure(closure2637, var_emptySeq);
  addtoclosure(closure2637, var_matchCaseNode);
  Method *meth_meth_ast_new_40_3_41_2333_object = addmethod2pos(obj2331, "new(3)$object(1)", &meth_ast_new_40_3_41_2333_object, 1);
  meth_meth_ast_new_40_3_41_2333_object->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_2333_object->definitionLine = 509;
  sourceObject = obj2331;
  objclass2331 = obj2331->class;
  objclass2331->definitionModule = modulename;
  objclass2331->definitionLine = 508;
  (*(struct UserObject *)self).data[0] = lowerouter2331;
  self = oldself2331;
  selfslot = oldselfslot2331;
  stackframe = oldstackframe2331;
// compiled object node returning obj2331 (depth = 2)
  *var_matchCaseNode = obj2331;
  if (obj2331 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "matchCaseNode"
  block_savedest(self);
  Object closure2638 = createclosure(1, "matchCaseNode");
  setclosureframe(closure2638, stackframe);
  addtoclosure(closure2638, var_matchCaseNode);
  struct UserObject *uo2638 = (struct UserObject*)self;
  uo2638->data[22] = (Object)closure2638;
  Method *meth_meth_ast_matchCaseNode2638 = addmethod2pos(self, "matchCaseNode", &meth_ast_matchCaseNode2638, 22);
  int argcv_meth_ast_matchCaseNode2638[] = {0};
  meth_meth_ast_matchCaseNode2638->type = alloc_MethodType(1, argcv_meth_ast_matchCaseNode2638);
  meth_meth_ast_matchCaseNode2638->definitionModule = modulename;
  meth_meth_ast_matchCaseNode2638->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject2639 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2639 = alloc_userobj2(2,4, objclass2639);
  gc_frame_newslot(obj2639);
if (objclass2639 == NULL) {
  glfree(obj2639->class->name);
  obj2639->class->name = "methodTypeNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2639, self, 0);
  addmethodreal(obj2639,"outer", &reader_ast_outer_2640);
  Object oldself2639 = self;
  struct StackFrameObject *oldstackframe2639 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2639);
  gc_frame_newslot((Object)stackframe);
  self = obj2639;
  Object *oldselfslot2639 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2639 = (*(struct UserObject *)self).data[0], lowerouter2639 = thisouter2639;
  if (inheritingObject2639) {
    struct UserObject *inho2639 = (struct UserObject *)inheritingObject2639;
    while (inho2639->super != GraceDefaultObject) inho2639 = (struct UserObject *)inho2639->super;
    inho2639->super = obj2639;
    self = inheritingObject2639;
    *selfslot = self;
    lowerouter2639 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2639;
  }
// method "new(_,_)"
  block_savedest(obj2639);
  Object closure2641 = createclosure(4, "new(2)");
  setclosureframe(closure2641, stackframe);
  addtoclosure(closure2641, var_uninitialized);
  addtoclosure(closure2641, var_identifierNode);
  addtoclosure(closure2641, var_k);
  addtoclosure(closure2641, var_methodTypeNode);
  struct UserObject *uo2641 = (struct UserObject*)obj2639;
  uo2641->data[1] = (Object)closure2641;
  Method *meth_meth_ast_new_40_2_41_2641 = addmethod2pos(obj2639, "new(2)", &meth_ast_new_40_2_41_2641, 1);
  int argcv_meth_ast_new_40_2_41_2641[] = {2};
  meth_meth_ast_new_40_2_41_2641->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_2641);
  meth_meth_ast_new_40_2_41_2641->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_2641->definitionLine = 572;
  block_savedest(obj2639);
  Object closure3020 = createclosure(4, "new(2)$object(1)");
  setclosureframe(closure3020, stackframe);
  addtoclosure(closure3020, var_uninitialized);
  addtoclosure(closure3020, var_identifierNode);
  addtoclosure(closure3020, var_k);
  addtoclosure(closure3020, var_methodTypeNode);
  Method *meth_meth_ast_new_40_2_41_2641_object = addmethod2pos(obj2639, "new(2)$object(1)", &meth_ast_new_40_2_41_2641_object, 1);
  meth_meth_ast_new_40_2_41_2641_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_2641_object->definitionLine = 572;
  sourceObject = obj2639;
  objclass2639 = obj2639->class;
  objclass2639->definitionModule = modulename;
  objclass2639->definitionLine = 571;
  (*(struct UserObject *)self).data[0] = lowerouter2639;
  self = oldself2639;
  selfslot = oldselfslot2639;
  stackframe = oldstackframe2639;
// compiled object node returning obj2639 (depth = 2)
  *var_methodTypeNode = obj2639;
  if (obj2639 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "methodTypeNode"
  block_savedest(self);
  Object closure3021 = createclosure(1, "methodTypeNode");
  setclosureframe(closure3021, stackframe);
  addtoclosure(closure3021, var_methodTypeNode);
  struct UserObject *uo3021 = (struct UserObject*)self;
  uo3021->data[23] = (Object)closure3021;
  Method *meth_meth_ast_methodTypeNode3021 = addmethod2pos(self, "methodTypeNode", &meth_ast_methodTypeNode3021, 23);
  int argcv_meth_ast_methodTypeNode3021[] = {0};
  meth_meth_ast_methodTypeNode3021->type = alloc_MethodType(1, argcv_meth_ast_methodTypeNode3021);
  meth_meth_ast_methodTypeNode3021->definitionModule = modulename;
  meth_meth_ast_methodTypeNode3021->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 583
  setline(583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject3022 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3022 = alloc_userobj2(2,4, objclass3022);
  gc_frame_newslot(obj3022);
if (objclass3022 == NULL) {
  glfree(obj3022->class->name);
  obj3022->class->name = "typeLiteralNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3022, self, 0);
  addmethodreal(obj3022,"outer", &reader_ast_outer_3023);
  Object oldself3022 = self;
  struct StackFrameObject *oldstackframe3022 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3022);
  gc_frame_newslot((Object)stackframe);
  self = obj3022;
  Object *oldselfslot3022 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3022 = (*(struct UserObject *)self).data[0], lowerouter3022 = thisouter3022;
  if (inheritingObject3022) {
    struct UserObject *inho3022 = (struct UserObject *)inheritingObject3022;
    while (inho3022->super != GraceDefaultObject) inho3022 = (struct UserObject *)inho3022->super;
    inho3022->super = obj3022;
    self = inheritingObject3022;
    *selfslot = self;
    lowerouter3022 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3022;
  }
// method "new(_,_)"
  block_savedest(obj3022);
  Object closure3024 = createclosure(3, "new(2)");
  setclosureframe(closure3024, stackframe);
  addtoclosure(closure3024, var_k);
  addtoclosure(closure3024, var_emptySeq);
  addtoclosure(closure3024, var_typeLiteralNode);
  struct UserObject *uo3024 = (struct UserObject*)obj3022;
  uo3024->data[1] = (Object)closure3024;
  Method *meth_meth_ast_new_40_2_41_3024 = addmethod2pos(obj3022, "new(2)", &meth_ast_new_40_2_41_3024, 1);
  int argcv_meth_ast_new_40_2_41_3024[] = {2};
  meth_meth_ast_new_40_2_41_3024->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_3024);
  meth_meth_ast_new_40_2_41_3024->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_3024->definitionLine = 663;
  block_savedest(obj3022);
  Object closure3333 = createclosure(3, "new(2)$object(1)");
  setclosureframe(closure3333, stackframe);
  addtoclosure(closure3333, var_k);
  addtoclosure(closure3333, var_emptySeq);
  addtoclosure(closure3333, var_typeLiteralNode);
  Method *meth_meth_ast_new_40_2_41_3024_object = addmethod2pos(obj3022, "new(2)$object(1)", &meth_ast_new_40_2_41_3024_object, 1);
  meth_meth_ast_new_40_2_41_3024_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_3024_object->definitionLine = 663;
  sourceObject = obj3022;
  objclass3022 = obj3022->class;
  objclass3022->definitionModule = modulename;
  objclass3022->definitionLine = 662;
  (*(struct UserObject *)self).data[0] = lowerouter3022;
  self = oldself3022;
  selfslot = oldselfslot3022;
  stackframe = oldstackframe3022;
// compiled object node returning obj3022 (depth = 2)
  *var_typeLiteralNode = obj3022;
  if (obj3022 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeLiteralNode"
  block_savedest(self);
  Object closure3334 = createclosure(1, "typeLiteralNode");
  setclosureframe(closure3334, stackframe);
  addtoclosure(closure3334, var_typeLiteralNode);
  struct UserObject *uo3334 = (struct UserObject*)self;
  uo3334->data[24] = (Object)closure3334;
  Method *meth_meth_ast_typeLiteralNode3334 = addmethod2pos(self, "typeLiteralNode", &meth_ast_typeLiteralNode3334, 24);
  int argcv_meth_ast_typeLiteralNode3334[] = {0};
  meth_meth_ast_typeLiteralNode3334->type = alloc_MethodType(1, argcv_meth_ast_typeLiteralNode3334);
  meth_meth_ast_typeLiteralNode3334->definitionModule = modulename;
  meth_meth_ast_typeLiteralNode3334->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject3335 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3335 = alloc_userobj2(2,4, objclass3335);
  gc_frame_newslot(obj3335);
if (objclass3335 == NULL) {
  glfree(obj3335->class->name);
  obj3335->class->name = "typeDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3335, self, 0);
  addmethodreal(obj3335,"outer", &reader_ast_outer_3336);
  Object oldself3335 = self;
  struct StackFrameObject *oldstackframe3335 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3335);
  gc_frame_newslot((Object)stackframe);
  self = obj3335;
  Object *oldselfslot3335 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3335 = (*(struct UserObject *)self).data[0], lowerouter3335 = thisouter3335;
  if (inheritingObject3335) {
    struct UserObject *inho3335 = (struct UserObject *)inheritingObject3335;
    while (inho3335->super != GraceDefaultObject) inho3335 = (struct UserObject *)inho3335->super;
    inho3335->super = obj3335;
    self = inheritingObject3335;
    *selfslot = self;
    lowerouter3335 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3335;
  }
// method "new(_,_)"
  block_savedest(obj3335);
  Object closure3337 = createclosure(3, "new(2)");
  setclosureframe(closure3337, stackframe);
  addtoclosure(closure3337, var_k);
  addtoclosure(closure3337, var_nullNode);
  addtoclosure(closure3337, var_typeDecNode);
  struct UserObject *uo3337 = (struct UserObject*)obj3335;
  uo3337->data[1] = (Object)closure3337;
  Method *meth_meth_ast_new_40_2_41_3337 = addmethod2pos(obj3335, "new(2)", &meth_ast_new_40_2_41_3337, 1);
  int argcv_meth_ast_new_40_2_41_3337[] = {2};
  meth_meth_ast_new_40_2_41_3337->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_3337);
  meth_meth_ast_new_40_2_41_3337->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_3337->definitionLine = 747;
  block_savedest(obj3335);
  Object closure3663 = createclosure(3, "new(2)$object(1)");
  setclosureframe(closure3663, stackframe);
  addtoclosure(closure3663, var_k);
  addtoclosure(closure3663, var_nullNode);
  addtoclosure(closure3663, var_typeDecNode);
  Method *meth_meth_ast_new_40_2_41_3337_object = addmethod2pos(obj3335, "new(2)$object(1)", &meth_ast_new_40_2_41_3337_object, 1);
  meth_meth_ast_new_40_2_41_3337_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_3337_object->definitionLine = 747;
  sourceObject = obj3335;
  objclass3335 = obj3335->class;
  objclass3335->definitionModule = modulename;
  objclass3335->definitionLine = 746;
  (*(struct UserObject *)self).data[0] = lowerouter3335;
  self = oldself3335;
  selfslot = oldselfslot3335;
  stackframe = oldstackframe3335;
// compiled object node returning obj3335 (depth = 2)
  *var_typeDecNode = obj3335;
  if (obj3335 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeDecNode"
  block_savedest(self);
  Object closure3664 = createclosure(1, "typeDecNode");
  setclosureframe(closure3664, stackframe);
  addtoclosure(closure3664, var_typeDecNode);
  struct UserObject *uo3664 = (struct UserObject*)self;
  uo3664->data[25] = (Object)closure3664;
  Method *meth_meth_ast_typeDecNode3664 = addmethod2pos(self, "typeDecNode", &meth_ast_typeDecNode3664, 25);
  int argcv_meth_ast_typeDecNode3664[] = {0};
  meth_meth_ast_typeDecNode3664->type = alloc_MethodType(1, argcv_meth_ast_typeDecNode3664);
  meth_meth_ast_typeDecNode3664->definitionModule = modulename;
  meth_meth_ast_typeDecNode3664->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject3665 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3665 = alloc_userobj2(3,4, objclass3665);
  gc_frame_newslot(obj3665);
if (objclass3665 == NULL) {
  glfree(obj3665->class->name);
  obj3665->class->name = "methodNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3665, self, 0);
  addmethodreal(obj3665,"outer", &reader_ast_outer_3666);
  Object oldself3665 = self;
  struct StackFrameObject *oldstackframe3665 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3665);
  gc_frame_newslot((Object)stackframe);
  self = obj3665;
  Object *oldselfslot3665 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3665 = (*(struct UserObject *)self).data[0], lowerouter3665 = thisouter3665;
  if (inheritingObject3665) {
    struct UserObject *inho3665 = (struct UserObject *)inheritingObject3665;
    while (inho3665->super != GraceDefaultObject) inho3665 = (struct UserObject *)inho3665->super;
    inho3665->super = obj3665;
    self = inheritingObject3665;
    *selfslot = self;
    lowerouter3665 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3665;
  }
// method "new(_,_,_)scope(_)"
  struct UserObject *uo3667 = (struct UserObject*)obj3665;
  uo3667->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40_3_41_scope_40_1_41_3667 = addmethod2pos(obj3665, "new(3)scope(1)", &meth_ast_new_40_3_41_scope_40_1_41_3667, 1);
  int argcv_meth_ast_new_40_3_41_scope_40_1_41_3667[] = {3, 1};
  meth_meth_ast_new_40_3_41_scope_40_1_41_3667->type = alloc_MethodType(2, argcv_meth_ast_new_40_3_41_scope_40_1_41_3667);
  meth_meth_ast_new_40_3_41_scope_40_1_41_3667->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_scope_40_1_41_3667->definitionLine = 832;
// method "new(_,_,_)"
  block_savedest(obj3665);
  Object closure3672 = createclosure(4, "new(3)");
  setclosureframe(closure3672, stackframe);
  addtoclosure(closure3672, var_uninitialized);
  addtoclosure(closure3672, var_identifierNode);
  addtoclosure(closure3672, var_k);
  addtoclosure(closure3672, var_methodNode);
  struct UserObject *uo3672 = (struct UserObject*)obj3665;
  uo3672->data[2] = (Object)closure3672;
  Method *meth_meth_ast_new_40_3_41_3672 = addmethod2pos(obj3665, "new(3)", &meth_ast_new_40_3_41_3672, 2);
  int argcv_meth_ast_new_40_3_41_3672[] = {3};
  meth_meth_ast_new_40_3_41_3672->type = alloc_MethodType(1, argcv_meth_ast_new_40_3_41_3672);
  meth_meth_ast_new_40_3_41_3672->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_3672->definitionLine = 838;
  block_savedest(obj3665);
  Object closure4788 = createclosure(4, "new(3)$object(1)");
  setclosureframe(closure4788, stackframe);
  addtoclosure(closure4788, var_uninitialized);
  addtoclosure(closure4788, var_identifierNode);
  addtoclosure(closure4788, var_k);
  addtoclosure(closure4788, var_methodNode);
  Method *meth_meth_ast_new_40_3_41_3672_object = addmethod2pos(obj3665, "new(3)$object(1)", &meth_ast_new_40_3_41_3672_object, 2);
  meth_meth_ast_new_40_3_41_3672_object->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_3672_object->definitionLine = 838;
  sourceObject = obj3665;
  sourceObject = obj3665;
  objclass3665 = obj3665->class;
  objclass3665->definitionModule = modulename;
  objclass3665->definitionLine = 831;
  (*(struct UserObject *)self).data[0] = lowerouter3665;
  self = oldself3665;
  selfslot = oldselfslot3665;
  stackframe = oldstackframe3665;
// compiled object node returning obj3665 (depth = 2)
  *var_methodNode = obj3665;
  if (obj3665 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "methodNode"
  block_savedest(self);
  Object closure4789 = createclosure(1, "methodNode");
  setclosureframe(closure4789, stackframe);
  addtoclosure(closure4789, var_methodNode);
  struct UserObject *uo4789 = (struct UserObject*)self;
  uo4789->data[26] = (Object)closure4789;
  Method *meth_meth_ast_methodNode4789 = addmethod2pos(self, "methodNode", &meth_ast_methodNode4789, 26);
  int argcv_meth_ast_methodNode4789[] = {0};
  meth_meth_ast_methodNode4789->type = alloc_MethodType(1, argcv_meth_ast_methodNode4789);
  meth_meth_ast_methodNode4789->definitionModule = modulename;
  meth_meth_ast_methodNode4789->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject4790 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4790 = alloc_userobj2(3,4, objclass4790);
  gc_frame_newslot(obj4790);
if (objclass4790 == NULL) {
  glfree(obj4790->class->name);
  obj4790->class->name = "callNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4790, self, 0);
  addmethodreal(obj4790,"outer", &reader_ast_outer_4791);
  Object oldself4790 = self;
  struct StackFrameObject *oldstackframe4790 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4790);
  gc_frame_newslot((Object)stackframe);
  self = obj4790;
  Object *oldselfslot4790 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4790 = (*(struct UserObject *)self).data[0], lowerouter4790 = thisouter4790;
  if (inheritingObject4790) {
    struct UserObject *inho4790 = (struct UserObject *)inheritingObject4790;
    while (inho4790->super != GraceDefaultObject) inho4790 = (struct UserObject *)inho4790->super;
    inho4790->super = obj4790;
    self = inheritingObject4790;
    *selfslot = self;
    lowerouter4790 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4790;
  }
// method "new(_,_)scope(_)"
  struct UserObject *uo4792 = (struct UserObject*)obj4790;
  uo4792->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40_2_41_scope_40_1_41_4792 = addmethod2pos(obj4790, "new(2)scope(1)", &meth_ast_new_40_2_41_scope_40_1_41_4792, 1);
  int argcv_meth_ast_new_40_2_41_scope_40_1_41_4792[] = {2, 1};
  meth_meth_ast_new_40_2_41_scope_40_1_41_4792->type = alloc_MethodType(2, argcv_meth_ast_new_40_2_41_scope_40_1_41_4792);
  meth_meth_ast_new_40_2_41_scope_40_1_41_4792->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_scope_40_1_41_4792->definitionLine = 1086;
// method "new(_,_)"
  block_savedest(obj4790);
  Object closure4797 = createclosure(3, "new(2)");
  setclosureframe(closure4797, stackframe);
  addtoclosure(closure4797, var_fakeSymbolTable);
  addtoclosure(closure4797, var_identifierNode);
  addtoclosure(closure4797, var_callNode);
  struct UserObject *uo4797 = (struct UserObject*)obj4790;
  uo4797->data[2] = (Object)closure4797;
  Method *meth_meth_ast_new_40_2_41_4797 = addmethod2pos(obj4790, "new(2)", &meth_ast_new_40_2_41_4797, 2);
  int argcv_meth_ast_new_40_2_41_4797[] = {2};
  meth_meth_ast_new_40_2_41_4797->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_4797);
  meth_meth_ast_new_40_2_41_4797->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_4797->definitionLine = 1091;
  block_savedest(obj4790);
  Object closure5324 = createclosure(3, "new(2)$object(1)");
  setclosureframe(closure5324, stackframe);
  addtoclosure(closure5324, var_fakeSymbolTable);
  addtoclosure(closure5324, var_identifierNode);
  addtoclosure(closure5324, var_callNode);
  Method *meth_meth_ast_new_40_2_41_4797_object = addmethod2pos(obj4790, "new(2)$object(1)", &meth_ast_new_40_2_41_4797_object, 2);
  meth_meth_ast_new_40_2_41_4797_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_4797_object->definitionLine = 1091;
  sourceObject = obj4790;
  sourceObject = obj4790;
  objclass4790 = obj4790->class;
  objclass4790->definitionModule = modulename;
  objclass4790->definitionLine = 1085;
  (*(struct UserObject *)self).data[0] = lowerouter4790;
  self = oldself4790;
  selfslot = oldselfslot4790;
  stackframe = oldstackframe4790;
// compiled object node returning obj4790 (depth = 2)
  *var_callNode = obj4790;
  if (obj4790 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "callNode"
  block_savedest(self);
  Object closure5325 = createclosure(1, "callNode");
  setclosureframe(closure5325, stackframe);
  addtoclosure(closure5325, var_callNode);
  struct UserObject *uo5325 = (struct UserObject*)self;
  uo5325->data[27] = (Object)closure5325;
  Method *meth_meth_ast_callNode5325 = addmethod2pos(self, "callNode", &meth_ast_callNode5325, 27);
  int argcv_meth_ast_callNode5325[] = {0};
  meth_meth_ast_callNode5325->type = alloc_MethodType(1, argcv_meth_ast_callNode5325);
  meth_meth_ast_callNode5325->definitionModule = modulename;
  meth_meth_ast_callNode5325->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1148
  setline(1148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1234
  setline(1234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5326 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5326 = alloc_userobj2(4,5, objclass5326);
  gc_frame_newslot(obj5326);
if (objclass5326 == NULL) {
  glfree(obj5326->class->name);
  obj5326->class->name = "moduleNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5326, self, 0);
  addmethodreal(obj5326,"outer", &reader_ast_outer_5327);
  Object oldself5326 = self;
  struct StackFrameObject *oldstackframe5326 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5326);
  gc_frame_newslot((Object)stackframe);
  self = obj5326;
  Object *oldselfslot5326 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5326 = (*(struct UserObject *)self).data[0], lowerouter5326 = thisouter5326;
  if (inheritingObject5326) {
    struct UserObject *inho5326 = (struct UserObject *)inheritingObject5326;
    while (inho5326->super != GraceDefaultObject) inho5326 = (struct UserObject *)inho5326->super;
    inho5326->super = obj5326;
    self = inheritingObject5326;
    *selfslot = self;
    lowerouter5326 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5326;
  }
// method "body(_)named(_)scope(_)"
  struct UserObject *uo5328 = (struct UserObject*)obj5326;
  uo5328->data[1] = emptyclosure;
  Method *meth_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5328 = addmethod2pos(obj5326, "body(1)named(1)scope(1)", &meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5328, 1);
  int argcv_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5328[] = {1, 1, 1};
  meth_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5328->type = alloc_MethodType(3, argcv_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5328);
  meth_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5328->definitionModule = modulename;
  meth_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5328->definitionLine = 1235;
// method "body(_)named(_)"
  struct UserObject *uo5335 = (struct UserObject*)obj5326;
  uo5335->data[2] = emptyclosure;
  Method *meth_meth_ast_body_40_1_41_named_40_1_41_5335 = addmethod2pos(obj5326, "body(1)named(1)", &meth_ast_body_40_1_41_named_40_1_41_5335, 2);
  int argcv_meth_ast_body_40_1_41_named_40_1_41_5335[] = {1, 1};
  meth_meth_ast_body_40_1_41_named_40_1_41_5335->type = alloc_MethodType(2, argcv_meth_ast_body_40_1_41_named_40_1_41_5335);
  meth_meth_ast_body_40_1_41_named_40_1_41_5335->definitionModule = modulename;
  meth_meth_ast_body_40_1_41_named_40_1_41_5335->definitionLine = 1241;
// method "body(_)"
  block_savedest(obj5326);
  Object closure5340 = createclosure(4, "body(1)");
  setclosureframe(closure5340, stackframe);
  addtoclosure(closure5340, var_emptySeq);
  addtoclosure(closure5340, var_moduleNode);
  addtoclosure(closure5340, var_objectNode);
  addtoclosure(closure5340, var_util);
  struct UserObject *uo5340 = (struct UserObject*)obj5326;
  uo5340->data[3] = (Object)closure5340;
  Method *meth_meth_ast_body_40_1_41_5340 = addmethod2pos(obj5326, "body(1)", &meth_ast_body_40_1_41_5340, 3);
  int argcv_meth_ast_body_40_1_41_5340[] = {1};
  meth_meth_ast_body_40_1_41_5340->type = alloc_MethodType(1, argcv_meth_ast_body_40_1_41_5340);
  meth_meth_ast_body_40_1_41_5340->definitionModule = modulename;
  meth_meth_ast_body_40_1_41_5340->definitionLine = 1246;
  block_savedest(obj5326);
  Object closure5414 = createclosure(4, "body(1)$object(1)");
  setclosureframe(closure5414, stackframe);
  addtoclosure(closure5414, var_emptySeq);
  addtoclosure(closure5414, var_moduleNode);
  addtoclosure(closure5414, var_objectNode);
  addtoclosure(closure5414, var_util);
  Method *meth_meth_ast_body_40_1_41_5340_object = addmethod2pos(obj5326, "body(1)$object(1)", &meth_ast_body_40_1_41_5340_object, 3);
  meth_meth_ast_body_40_1_41_5340_object->definitionModule = modulename;
  meth_meth_ast_body_40_1_41_5340_object->definitionLine = 1246;
  sourceObject = obj5326;
  sourceObject = obj5326;
  sourceObject = obj5326;
  objclass5326 = obj5326->class;
  objclass5326->definitionModule = modulename;
  objclass5326->definitionLine = 1234;
  (*(struct UserObject *)self).data[0] = lowerouter5326;
  self = oldself5326;
  selfslot = oldselfslot5326;
  stackframe = oldstackframe5326;
// compiled object node returning obj5326 (depth = 2)
  *var_moduleNode = obj5326;
  if (obj5326 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "moduleNode"
  block_savedest(self);
  Object closure5415 = createclosure(1, "moduleNode");
  setclosureframe(closure5415, stackframe);
  addtoclosure(closure5415, var_moduleNode);
  struct UserObject *uo5415 = (struct UserObject*)self;
  uo5415->data[28] = (Object)closure5415;
  Method *meth_meth_ast_moduleNode5415 = addmethod2pos(self, "moduleNode", &meth_ast_moduleNode5415, 28);
  int argcv_meth_ast_moduleNode5415[] = {0};
  meth_meth_ast_moduleNode5415->type = alloc_MethodType(1, argcv_meth_ast_moduleNode5415);
  meth_meth_ast_moduleNode5415->definitionModule = modulename;
  meth_meth_ast_moduleNode5415->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1282
  setline(1282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5416 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5416 = alloc_userobj2(4,5, objclass5416);
  gc_frame_newslot(obj5416);
if (objclass5416 == NULL) {
  glfree(obj5416->class->name);
  obj5416->class->name = "objectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5416, self, 0);
  addmethodreal(obj5416,"outer", &reader_ast_outer_5417);
  Object oldself5416 = self;
  struct StackFrameObject *oldstackframe5416 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5416);
  gc_frame_newslot((Object)stackframe);
  self = obj5416;
  Object *oldselfslot5416 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5416 = (*(struct UserObject *)self).data[0], lowerouter5416 = thisouter5416;
  if (inheritingObject5416) {
    struct UserObject *inho5416 = (struct UserObject *)inheritingObject5416;
    while (inho5416->super != GraceDefaultObject) inho5416 = (struct UserObject *)inho5416->super;
    inho5416->super = obj5416;
    self = inheritingObject5416;
    *selfslot = self;
    lowerouter5416 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5416;
  }
// method "body(_)named(_)scope(_)"
  struct UserObject *uo5418 = (struct UserObject*)obj5416;
  uo5418->data[1] = emptyclosure;
  Method *meth_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5418 = addmethod2pos(obj5416, "body(1)named(1)scope(1)", &meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5418, 1);
  int argcv_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5418[] = {1, 1, 1};
  meth_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5418->type = alloc_MethodType(3, argcv_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5418);
  meth_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5418->definitionModule = modulename;
  meth_meth_ast_body_40_1_41_named_40_1_41_scope_40_1_41_5418->definitionLine = 1283;
// method "body(_)named(_)"
  block_savedest(obj5416);
  Object closure5426 = createclosure(1, "body(1)named(1)");
  setclosureframe(closure5426, stackframe);
  addtoclosure(closure5426, var_fakeSymbolTable);
  struct UserObject *uo5426 = (struct UserObject*)obj5416;
  uo5426->data[2] = (Object)closure5426;
  Method *meth_meth_ast_body_40_1_41_named_40_1_41_5426 = addmethod2pos(obj5416, "body(1)named(1)", &meth_ast_body_40_1_41_named_40_1_41_5426, 2);
  int argcv_meth_ast_body_40_1_41_named_40_1_41_5426[] = {1, 1};
  meth_meth_ast_body_40_1_41_named_40_1_41_5426->type = alloc_MethodType(2, argcv_meth_ast_body_40_1_41_named_40_1_41_5426);
  meth_meth_ast_body_40_1_41_named_40_1_41_5426->definitionModule = modulename;
  meth_meth_ast_body_40_1_41_named_40_1_41_5426->definitionLine = 1289;
// method "new(_,_)"
  block_savedest(obj5416);
  Object closure5429 = createclosure(2, "new(2)");
  setclosureframe(closure5429, stackframe);
  addtoclosure(closure5429, var_emptySeq);
  addtoclosure(closure5429, var_objectNode);
  struct UserObject *uo5429 = (struct UserObject*)obj5416;
  uo5429->data[3] = (Object)closure5429;
  Method *meth_meth_ast_new_40_2_41_5429 = addmethod2pos(obj5416, "new(2)", &meth_ast_new_40_2_41_5429, 3);
  int argcv_meth_ast_new_40_2_41_5429[] = {2};
  meth_meth_ast_new_40_2_41_5429->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_5429);
  meth_meth_ast_new_40_2_41_5429->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_5429->definitionLine = 1292;
  block_savedest(obj5416);
  Object closure6027 = createclosure(2, "new(2)$object(1)");
  setclosureframe(closure6027, stackframe);
  addtoclosure(closure6027, var_emptySeq);
  addtoclosure(closure6027, var_objectNode);
  Method *meth_meth_ast_new_40_2_41_5429_object = addmethod2pos(obj5416, "new(2)$object(1)", &meth_ast_new_40_2_41_5429_object, 3);
  meth_meth_ast_new_40_2_41_5429_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_5429_object->definitionLine = 1292;
  sourceObject = obj5416;
  sourceObject = obj5416;
  sourceObject = obj5416;
  objclass5416 = obj5416->class;
  objclass5416->definitionModule = modulename;
  objclass5416->definitionLine = 1282;
  (*(struct UserObject *)self).data[0] = lowerouter5416;
  self = oldself5416;
  selfslot = oldselfslot5416;
  stackframe = oldstackframe5416;
// compiled object node returning obj5416 (depth = 2)
  *var_objectNode = obj5416;
  if (obj5416 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "objectNode"
  block_savedest(self);
  Object closure6028 = createclosure(1, "objectNode");
  setclosureframe(closure6028, stackframe);
  addtoclosure(closure6028, var_objectNode);
  struct UserObject *uo6028 = (struct UserObject*)self;
  uo6028->data[29] = (Object)closure6028;
  Method *meth_meth_ast_objectNode6028 = addmethod2pos(self, "objectNode", &meth_ast_objectNode6028, 29);
  int argcv_meth_ast_objectNode6028[] = {0};
  meth_meth_ast_objectNode6028->type = alloc_MethodType(1, argcv_meth_ast_objectNode6028);
  meth_meth_ast_objectNode6028->definitionModule = modulename;
  meth_meth_ast_objectNode6028->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1360
  setline(1360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6029 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6029 = alloc_userobj2(2,4, objclass6029);
  gc_frame_newslot(obj6029);
if (objclass6029 == NULL) {
  glfree(obj6029->class->name);
  obj6029->class->name = "arrayNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6029, self, 0);
  addmethodreal(obj6029,"outer", &reader_ast_outer_6030);
  Object oldself6029 = self;
  struct StackFrameObject *oldstackframe6029 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6029);
  gc_frame_newslot((Object)stackframe);
  self = obj6029;
  Object *oldselfslot6029 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6029 = (*(struct UserObject *)self).data[0], lowerouter6029 = thisouter6029;
  if (inheritingObject6029) {
    struct UserObject *inho6029 = (struct UserObject *)inheritingObject6029;
    while (inho6029->super != GraceDefaultObject) inho6029 = (struct UserObject *)inho6029->super;
    inho6029->super = obj6029;
    self = inheritingObject6029;
    *selfslot = self;
    lowerouter6029 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6029;
  }
// method "new(_)"
  block_savedest(obj6029);
  Object closure6031 = createclosure(2, "new(1)");
  setclosureframe(closure6031, stackframe);
  addtoclosure(closure6031, var_emptySeq);
  addtoclosure(closure6031, var_arrayNode);
  struct UserObject *uo6031 = (struct UserObject*)obj6029;
  uo6031->data[1] = (Object)closure6031;
  Method *meth_meth_ast_new_40_1_41_6031 = addmethod2pos(obj6029, "new(1)", &meth_ast_new_40_1_41_6031, 1);
  int argcv_meth_ast_new_40_1_41_6031[] = {1};
  meth_meth_ast_new_40_1_41_6031->type = alloc_MethodType(1, argcv_meth_ast_new_40_1_41_6031);
  meth_meth_ast_new_40_1_41_6031->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_6031->definitionLine = 1459;
  block_savedest(obj6029);
  Object closure6162 = createclosure(2, "new(1)$object(1)");
  setclosureframe(closure6162, stackframe);
  addtoclosure(closure6162, var_emptySeq);
  addtoclosure(closure6162, var_arrayNode);
  Method *meth_meth_ast_new_40_1_41_6031_object = addmethod2pos(obj6029, "new(1)$object(1)", &meth_ast_new_40_1_41_6031_object, 1);
  meth_meth_ast_new_40_1_41_6031_object->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_6031_object->definitionLine = 1459;
  sourceObject = obj6029;
  objclass6029 = obj6029->class;
  objclass6029->definitionModule = modulename;
  objclass6029->definitionLine = 1458;
  (*(struct UserObject *)self).data[0] = lowerouter6029;
  self = oldself6029;
  selfslot = oldselfslot6029;
  stackframe = oldstackframe6029;
// compiled object node returning obj6029 (depth = 2)
  *var_arrayNode = obj6029;
  if (obj6029 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "arrayNode"
  block_savedest(self);
  Object closure6163 = createclosure(1, "arrayNode");
  setclosureframe(closure6163, stackframe);
  addtoclosure(closure6163, var_arrayNode);
  struct UserObject *uo6163 = (struct UserObject*)self;
  uo6163->data[30] = (Object)closure6163;
  Method *meth_meth_ast_arrayNode6163 = addmethod2pos(self, "arrayNode", &meth_ast_arrayNode6163, 30);
  int argcv_meth_ast_arrayNode6163[] = {0};
  meth_meth_ast_arrayNode6163->type = alloc_MethodType(1, argcv_meth_ast_arrayNode6163);
  meth_meth_ast_arrayNode6163->definitionModule = modulename;
  meth_meth_ast_arrayNode6163->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1504
  setline(1504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6164 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6164 = alloc_userobj2(3,4, objclass6164);
  gc_frame_newslot(obj6164);
if (objclass6164 == NULL) {
  glfree(obj6164->class->name);
  obj6164->class->name = "memberNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6164, self, 0);
  addmethodreal(obj6164,"outer", &reader_ast_outer_6165);
  Object oldself6164 = self;
  struct StackFrameObject *oldstackframe6164 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6164);
  gc_frame_newslot((Object)stackframe);
  self = obj6164;
  Object *oldselfslot6164 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6164 = (*(struct UserObject *)self).data[0], lowerouter6164 = thisouter6164;
  if (inheritingObject6164) {
    struct UserObject *inho6164 = (struct UserObject *)inheritingObject6164;
    while (inho6164->super != GraceDefaultObject) inho6164 = (struct UserObject *)inho6164->super;
    inho6164->super = obj6164;
    self = inheritingObject6164;
    *selfslot = self;
    lowerouter6164 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6164;
  }
// method "new(_,_)scope(_)"
  struct UserObject *uo6166 = (struct UserObject*)obj6164;
  uo6166->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40_2_41_scope_40_1_41_6166 = addmethod2pos(obj6164, "new(2)scope(1)", &meth_ast_new_40_2_41_scope_40_1_41_6166, 1);
  int argcv_meth_ast_new_40_2_41_scope_40_1_41_6166[] = {2, 1};
  meth_meth_ast_new_40_2_41_scope_40_1_41_6166->type = alloc_MethodType(2, argcv_meth_ast_new_40_2_41_scope_40_1_41_6166);
  meth_meth_ast_new_40_2_41_scope_40_1_41_6166->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_scope_40_1_41_6166->definitionLine = 1505;
// method "new(_,_)"
  block_savedest(obj6164);
  Object closure6171 = createclosure(4, "new(2)");
  setclosureframe(closure6171, stackframe);
  addtoclosure(closure6171, var_emptySeq);
  addtoclosure(closure6171, var_fakeSymbolTable);
  addtoclosure(closure6171, var_identifierNode);
  addtoclosure(closure6171, var_memberNode);
  struct UserObject *uo6171 = (struct UserObject*)obj6164;
  uo6171->data[2] = (Object)closure6171;
  Method *meth_meth_ast_new_40_2_41_6171 = addmethod2pos(obj6164, "new(2)", &meth_ast_new_40_2_41_6171, 2);
  int argcv_meth_ast_new_40_2_41_6171[] = {2};
  meth_meth_ast_new_40_2_41_6171->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_6171);
  meth_meth_ast_new_40_2_41_6171->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_6171->definitionLine = 1511;
  block_savedest(obj6164);
  Object closure6556 = createclosure(4, "new(2)$object(1)");
  setclosureframe(closure6556, stackframe);
  addtoclosure(closure6556, var_emptySeq);
  addtoclosure(closure6556, var_fakeSymbolTable);
  addtoclosure(closure6556, var_identifierNode);
  addtoclosure(closure6556, var_memberNode);
  Method *meth_meth_ast_new_40_2_41_6171_object = addmethod2pos(obj6164, "new(2)$object(1)", &meth_ast_new_40_2_41_6171_object, 2);
  meth_meth_ast_new_40_2_41_6171_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_6171_object->definitionLine = 1511;
  sourceObject = obj6164;
  sourceObject = obj6164;
  objclass6164 = obj6164->class;
  objclass6164->definitionModule = modulename;
  objclass6164->definitionLine = 1504;
  (*(struct UserObject *)self).data[0] = lowerouter6164;
  self = oldself6164;
  selfslot = oldselfslot6164;
  stackframe = oldstackframe6164;
// compiled object node returning obj6164 (depth = 2)
  *var_memberNode = obj6164;
  if (obj6164 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "memberNode"
  block_savedest(self);
  Object closure6557 = createclosure(1, "memberNode");
  setclosureframe(closure6557, stackframe);
  addtoclosure(closure6557, var_memberNode);
  struct UserObject *uo6557 = (struct UserObject*)self;
  uo6557->data[31] = (Object)closure6557;
  Method *meth_meth_ast_memberNode6557 = addmethod2pos(self, "memberNode", &meth_ast_memberNode6557, 31);
  int argcv_meth_ast_memberNode6557[] = {0};
  meth_meth_ast_memberNode6557->type = alloc_MethodType(1, argcv_meth_ast_memberNode6557);
  meth_meth_ast_memberNode6557->definitionModule = modulename;
  meth_meth_ast_memberNode6557->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1528
  setline(1528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1610
  setline(1610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6558 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6558 = alloc_userobj2(2,4, objclass6558);
  gc_frame_newslot(obj6558);
if (objclass6558 == NULL) {
  glfree(obj6558->class->name);
  obj6558->class->name = "genericNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6558, self, 0);
  addmethodreal(obj6558,"outer", &reader_ast_outer_6559);
  Object oldself6558 = self;
  struct StackFrameObject *oldstackframe6558 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6558);
  gc_frame_newslot((Object)stackframe);
  self = obj6558;
  Object *oldselfslot6558 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6558 = (*(struct UserObject *)self).data[0], lowerouter6558 = thisouter6558;
  if (inheritingObject6558) {
    struct UserObject *inho6558 = (struct UserObject *)inheritingObject6558;
    while (inho6558->super != GraceDefaultObject) inho6558 = (struct UserObject *)inho6558->super;
    inho6558->super = obj6558;
    self = inheritingObject6558;
    *selfslot = self;
    lowerouter6558 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6558;
  }
// method "new(_,_)"
  block_savedest(obj6558);
  Object closure6560 = createclosure(1, "new(2)");
  setclosureframe(closure6560, stackframe);
  addtoclosure(closure6560, var_genericNode);
  struct UserObject *uo6560 = (struct UserObject*)obj6558;
  uo6560->data[1] = (Object)closure6560;
  Method *meth_meth_ast_new_40_2_41_6560 = addmethod2pos(obj6558, "new(2)", &meth_ast_new_40_2_41_6560, 1);
  int argcv_meth_ast_new_40_2_41_6560[] = {2};
  meth_meth_ast_new_40_2_41_6560->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_6560);
  meth_meth_ast_new_40_2_41_6560->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_6560->definitionLine = 1611;
  block_savedest(obj6558);
  Object closure6717 = createclosure(1, "new(2)$object(1)");
  setclosureframe(closure6717, stackframe);
  addtoclosure(closure6717, var_genericNode);
  Method *meth_meth_ast_new_40_2_41_6560_object = addmethod2pos(obj6558, "new(2)$object(1)", &meth_ast_new_40_2_41_6560_object, 1);
  meth_meth_ast_new_40_2_41_6560_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_6560_object->definitionLine = 1611;
  sourceObject = obj6558;
  objclass6558 = obj6558->class;
  objclass6558->definitionModule = modulename;
  objclass6558->definitionLine = 1610;
  (*(struct UserObject *)self).data[0] = lowerouter6558;
  self = oldself6558;
  selfslot = oldselfslot6558;
  stackframe = oldstackframe6558;
// compiled object node returning obj6558 (depth = 2)
  *var_genericNode = obj6558;
  if (obj6558 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "genericNode"
  block_savedest(self);
  Object closure6718 = createclosure(1, "genericNode");
  setclosureframe(closure6718, stackframe);
  addtoclosure(closure6718, var_genericNode);
  struct UserObject *uo6718 = (struct UserObject*)self;
  uo6718->data[32] = (Object)closure6718;
  Method *meth_meth_ast_genericNode6718 = addmethod2pos(self, "genericNode", &meth_ast_genericNode6718, 32);
  int argcv_meth_ast_genericNode6718[] = {0};
  meth_meth_ast_genericNode6718->type = alloc_MethodType(1, argcv_meth_ast_genericNode6718);
  meth_meth_ast_genericNode6718->definitionModule = modulename;
  meth_meth_ast_genericNode6718->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1654
  setline(1654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1655
  setline(1655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6719 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6719 = alloc_userobj2(2,4, objclass6719);
  gc_frame_newslot(obj6719);
if (objclass6719 == NULL) {
  glfree(obj6719->class->name);
  obj6719->class->name = "typeParametersNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6719, self, 0);
  addmethodreal(obj6719,"outer", &reader_ast_outer_6720);
  Object oldself6719 = self;
  struct StackFrameObject *oldstackframe6719 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6719);
  gc_frame_newslot((Object)stackframe);
  self = obj6719;
  Object *oldselfslot6719 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6719 = (*(struct UserObject *)self).data[0], lowerouter6719 = thisouter6719;
  if (inheritingObject6719) {
    struct UserObject *inho6719 = (struct UserObject *)inheritingObject6719;
    while (inho6719->super != GraceDefaultObject) inho6719 = (struct UserObject *)inho6719->super;
    inho6719->super = obj6719;
    self = inheritingObject6719;
    *selfslot = self;
    lowerouter6719 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6719;
  }
// method "new(_)"
  block_savedest(obj6719);
  Object closure6721 = createclosure(3, "new(1)");
  setclosureframe(closure6721, stackframe);
  addtoclosure(closure6721, var_k);
  addtoclosure(closure6721, var_emptySeq);
  addtoclosure(closure6721, var_typeParametersNode);
  struct UserObject *uo6721 = (struct UserObject*)obj6719;
  uo6721->data[1] = (Object)closure6721;
  Method *meth_meth_ast_new_40_1_41_6721 = addmethod2pos(obj6719, "new(1)", &meth_ast_new_40_1_41_6721, 1);
  int argcv_meth_ast_new_40_1_41_6721[] = {1};
  meth_meth_ast_new_40_1_41_6721->type = alloc_MethodType(1, argcv_meth_ast_new_40_1_41_6721);
  meth_meth_ast_new_40_1_41_6721->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_6721->definitionLine = 1656;
  block_savedest(obj6719);
  Object closure6880 = createclosure(3, "new(1)$object(1)");
  setclosureframe(closure6880, stackframe);
  addtoclosure(closure6880, var_k);
  addtoclosure(closure6880, var_emptySeq);
  addtoclosure(closure6880, var_typeParametersNode);
  Method *meth_meth_ast_new_40_1_41_6721_object = addmethod2pos(obj6719, "new(1)$object(1)", &meth_ast_new_40_1_41_6721_object, 1);
  meth_meth_ast_new_40_1_41_6721_object->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_6721_object->definitionLine = 1656;
  sourceObject = obj6719;
  objclass6719 = obj6719->class;
  objclass6719->definitionModule = modulename;
  objclass6719->definitionLine = 1655;
  (*(struct UserObject *)self).data[0] = lowerouter6719;
  self = oldself6719;
  selfslot = oldselfslot6719;
  stackframe = oldstackframe6719;
// compiled object node returning obj6719 (depth = 2)
  *var_typeParametersNode = obj6719;
  if (obj6719 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeParametersNode"
  block_savedest(self);
  Object closure6881 = createclosure(1, "typeParametersNode");
  setclosureframe(closure6881, stackframe);
  addtoclosure(closure6881, var_typeParametersNode);
  struct UserObject *uo6881 = (struct UserObject*)self;
  uo6881->data[33] = (Object)closure6881;
  Method *meth_meth_ast_typeParametersNode6881 = addmethod2pos(self, "typeParametersNode", &meth_ast_typeParametersNode6881, 33);
  int argcv_meth_ast_typeParametersNode6881[] = {0};
  meth_meth_ast_typeParametersNode6881->type = alloc_MethodType(1, argcv_meth_ast_typeParametersNode6881);
  meth_meth_ast_typeParametersNode6881->definitionModule = modulename;
  meth_meth_ast_typeParametersNode6881->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1662
  setline(1662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1702
  setline(1702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6882 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6882 = alloc_userobj2(3,4, objclass6882);
  gc_frame_newslot(obj6882);
if (objclass6882 == NULL) {
  glfree(obj6882->class->name);
  obj6882->class->name = "identifierNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6882, self, 0);
  addmethodreal(obj6882,"outer", &reader_ast_outer_6883);
  Object oldself6882 = self;
  struct StackFrameObject *oldstackframe6882 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6882);
  gc_frame_newslot((Object)stackframe);
  self = obj6882;
  Object *oldselfslot6882 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6882 = (*(struct UserObject *)self).data[0], lowerouter6882 = thisouter6882;
  if (inheritingObject6882) {
    struct UserObject *inho6882 = (struct UserObject *)inheritingObject6882;
    while (inho6882->super != GraceDefaultObject) inho6882 = (struct UserObject *)inho6882->super;
    inho6882->super = obj6882;
    self = inheritingObject6882;
    *selfslot = self;
    lowerouter6882 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6882;
  }
// method "new(_,_)scope(_)"
  struct UserObject *uo6884 = (struct UserObject*)obj6882;
  uo6884->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40_2_41_scope_40_1_41_6884 = addmethod2pos(obj6882, "new(2)scope(1)", &meth_ast_new_40_2_41_scope_40_1_41_6884, 1);
  int argcv_meth_ast_new_40_2_41_scope_40_1_41_6884[] = {2, 1};
  meth_meth_ast_new_40_2_41_scope_40_1_41_6884->type = alloc_MethodType(2, argcv_meth_ast_new_40_2_41_scope_40_1_41_6884);
  meth_meth_ast_new_40_2_41_scope_40_1_41_6884->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_scope_40_1_41_6884->definitionLine = 1704;
// method "new(_,_)"
  block_savedest(obj6882);
  Object closure6889 = createclosure(1, "new(2)");
  setclosureframe(closure6889, stackframe);
  addtoclosure(closure6889, var_identifierNode);
  struct UserObject *uo6889 = (struct UserObject*)obj6882;
  uo6889->data[2] = (Object)closure6889;
  Method *meth_meth_ast_new_40_2_41_6889 = addmethod2pos(obj6882, "new(2)", &meth_ast_new_40_2_41_6889, 2);
  int argcv_meth_ast_new_40_2_41_6889[] = {2};
  meth_meth_ast_new_40_2_41_6889->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_6889);
  meth_meth_ast_new_40_2_41_6889->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_6889->definitionLine = 1710;
  block_savedest(obj6882);
  Object closure7313 = createclosure(1, "new(2)$object(1)");
  setclosureframe(closure7313, stackframe);
  addtoclosure(closure7313, var_identifierNode);
  Method *meth_meth_ast_new_40_2_41_6889_object = addmethod2pos(obj6882, "new(2)$object(1)", &meth_ast_new_40_2_41_6889_object, 2);
  meth_meth_ast_new_40_2_41_6889_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_6889_object->definitionLine = 1710;
  sourceObject = obj6882;
  sourceObject = obj6882;
  objclass6882 = obj6882->class;
  objclass6882->definitionModule = modulename;
  objclass6882->definitionLine = 1702;
  (*(struct UserObject *)self).data[0] = lowerouter6882;
  self = oldself6882;
  selfslot = oldselfslot6882;
  stackframe = oldstackframe6882;
// compiled object node returning obj6882 (depth = 2)
  *var_identifierNode = obj6882;
  if (obj6882 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "identifierNode"
  block_savedest(self);
  Object closure7314 = createclosure(1, "identifierNode");
  setclosureframe(closure7314, stackframe);
  addtoclosure(closure7314, var_identifierNode);
  struct UserObject *uo7314 = (struct UserObject*)self;
  uo7314->data[34] = (Object)closure7314;
  Method *meth_meth_ast_identifierNode7314 = addmethod2pos(self, "identifierNode", &meth_ast_identifierNode7314, 34);
  int argcv_meth_ast_identifierNode7314[] = {0};
  meth_meth_ast_identifierNode7314->type = alloc_MethodType(1, argcv_meth_ast_identifierNode7314);
  meth_meth_ast_identifierNode7314->definitionModule = modulename;
  meth_meth_ast_identifierNode7314->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1837
  setline(1837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1838
  setline(1838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe7315 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit7316 == NULL) {
    strlit7316 = alloc_String("Type");
    gc_root(strlit7316);
  }
// compiled string node returning strlit7316 (depth = 3)
  gc_frame_newslot(strlit7316);
// starting to compile identifier node (depth = 3)
  Object bool7317 = alloc_Boolean(0);
// compiled identifier node returning bool7317 (depth = 3)
  gc_frame_newslot(bool7317);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  params[0] = strlit7316;
  params[1] = bool7317;
  partcv[0] = 2;
  Object call7318 = callmethodflags(*var_identifierNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7315);
// compiled call node returning call7318 (depth = 2)
  *var_typeType = call7318;
  if (call7318 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeType"
  block_savedest(self);
  Object closure7319 = createclosure(1, "typeType");
  setclosureframe(closure7319, stackframe);
  addtoclosure(closure7319, var_typeType);
  struct UserObject *uo7319 = (struct UserObject*)self;
  uo7319->data[35] = (Object)closure7319;
  Method *meth_meth_ast_typeType7319 = addmethod2pos(self, "typeType", &meth_ast_typeType7319, 35);
  int argcv_meth_ast_typeType7319[] = {0};
  meth_meth_ast_typeType7319->type = alloc_MethodType(1, argcv_meth_ast_typeType7319);
  meth_meth_ast_typeType7319->definitionModule = modulename;
  meth_meth_ast_typeType7319->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1839
  setline(1839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe7320 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit7321 == NULL) {
    strlit7321 = alloc_String("Unknown");
    gc_root(strlit7321);
  }
// compiled string node returning strlit7321 (depth = 3)
  gc_frame_newslot(strlit7321);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeType (depth = 3)
  gc_frame_newslot(*var_typeType);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  params[0] = strlit7321;
  params[1] = *var_typeType;
  partcv[0] = 2;
  Object call7322 = callmethodflags(*var_identifierNode, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe7320);
// compiled call node returning call7322 (depth = 2)
  *var_unknownType = call7322;
  if (call7322 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "unknownType"
  block_savedest(self);
  Object closure7323 = createclosure(1, "unknownType");
  setclosureframe(closure7323, stackframe);
  addtoclosure(closure7323, var_unknownType);
  struct UserObject *uo7323 = (struct UserObject*)self;
  uo7323->data[36] = (Object)closure7323;
  Method *meth_meth_ast_unknownType7323 = addmethod2pos(self, "unknownType", &meth_ast_unknownType7323, 36);
  int argcv_meth_ast_unknownType7323[] = {0};
  meth_meth_ast_unknownType7323->type = alloc_MethodType(1, argcv_meth_ast_unknownType7323);
  meth_meth_ast_unknownType7323->definitionModule = modulename;
  meth_meth_ast_unknownType7323->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1841
  setline(1841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7324 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7324 = alloc_userobj2(3,4, objclass7324);
  gc_frame_newslot(obj7324);
if (objclass7324 == NULL) {
  glfree(obj7324->class->name);
  obj7324->class->name = "stringNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7324, self, 0);
  addmethodreal(obj7324,"outer", &reader_ast_outer_7325);
  Object oldself7324 = self;
  struct StackFrameObject *oldstackframe7324 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7324);
  gc_frame_newslot((Object)stackframe);
  self = obj7324;
  Object *oldselfslot7324 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7324 = (*(struct UserObject *)self).data[0], lowerouter7324 = thisouter7324;
  if (inheritingObject7324) {
    struct UserObject *inho7324 = (struct UserObject *)inheritingObject7324;
    while (inho7324->super != GraceDefaultObject) inho7324 = (struct UserObject *)inho7324->super;
    inho7324->super = obj7324;
    self = inheritingObject7324;
    *selfslot = self;
    lowerouter7324 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7324;
  }
// method "new(_)scope(_)"
  struct UserObject *uo7326 = (struct UserObject*)obj7324;
  uo7326->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40_1_41_scope_40_1_41_7326 = addmethod2pos(obj7324, "new(1)scope(1)", &meth_ast_new_40_1_41_scope_40_1_41_7326, 1);
  int argcv_meth_ast_new_40_1_41_scope_40_1_41_7326[] = {1, 1};
  meth_meth_ast_new_40_1_41_scope_40_1_41_7326->type = alloc_MethodType(2, argcv_meth_ast_new_40_1_41_scope_40_1_41_7326);
  meth_meth_ast_new_40_1_41_scope_40_1_41_7326->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_scope_40_1_41_7326->definitionLine = 1842;
// method "new(_)"
  block_savedest(obj7324);
  Object closure7331 = createclosure(1, "new(1)");
  setclosureframe(closure7331, stackframe);
  addtoclosure(closure7331, var_stringNode);
  struct UserObject *uo7331 = (struct UserObject*)obj7324;
  uo7331->data[2] = (Object)closure7331;
  Method *meth_meth_ast_new_40_1_41_7331 = addmethod2pos(obj7324, "new(1)", &meth_ast_new_40_1_41_7331, 2);
  int argcv_meth_ast_new_40_1_41_7331[] = {1};
  meth_meth_ast_new_40_1_41_7331->type = alloc_MethodType(1, argcv_meth_ast_new_40_1_41_7331);
  meth_meth_ast_new_40_1_41_7331->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_7331->definitionLine = 1848;
  block_savedest(obj7324);
  Object closure7408 = createclosure(1, "new(1)$object(1)");
  setclosureframe(closure7408, stackframe);
  addtoclosure(closure7408, var_stringNode);
  Method *meth_meth_ast_new_40_1_41_7331_object = addmethod2pos(obj7324, "new(1)$object(1)", &meth_ast_new_40_1_41_7331_object, 2);
  meth_meth_ast_new_40_1_41_7331_object->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_7331_object->definitionLine = 1848;
  sourceObject = obj7324;
  sourceObject = obj7324;
  objclass7324 = obj7324->class;
  objclass7324->definitionModule = modulename;
  objclass7324->definitionLine = 1841;
  (*(struct UserObject *)self).data[0] = lowerouter7324;
  self = oldself7324;
  selfslot = oldselfslot7324;
  stackframe = oldstackframe7324;
// compiled object node returning obj7324 (depth = 2)
  *var_stringNode = obj7324;
  if (obj7324 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "stringNode"
  block_savedest(self);
  Object closure7409 = createclosure(1, "stringNode");
  setclosureframe(closure7409, stackframe);
  addtoclosure(closure7409, var_stringNode);
  struct UserObject *uo7409 = (struct UserObject*)self;
  uo7409->data[37] = (Object)closure7409;
  Method *meth_meth_ast_stringNode7409 = addmethod2pos(self, "stringNode", &meth_ast_stringNode7409, 37);
  int argcv_meth_ast_stringNode7409[] = {0};
  meth_meth_ast_stringNode7409->type = alloc_MethodType(1, argcv_meth_ast_stringNode7409);
  meth_meth_ast_stringNode7409->definitionModule = modulename;
  meth_meth_ast_stringNode7409->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1847
  setline(1847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7410 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7410 = alloc_userobj2(2,4, objclass7410);
  gc_frame_newslot(obj7410);
if (objclass7410 == NULL) {
  glfree(obj7410->class->name);
  obj7410->class->name = "numNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7410, self, 0);
  addmethodreal(obj7410,"outer", &reader_ast_outer_7411);
  Object oldself7410 = self;
  struct StackFrameObject *oldstackframe7410 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7410);
  gc_frame_newslot((Object)stackframe);
  self = obj7410;
  Object *oldselfslot7410 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7410 = (*(struct UserObject *)self).data[0], lowerouter7410 = thisouter7410;
  if (inheritingObject7410) {
    struct UserObject *inho7410 = (struct UserObject *)inheritingObject7410;
    while (inho7410->super != GraceDefaultObject) inho7410 = (struct UserObject *)inho7410->super;
    inho7410->super = obj7410;
    self = inheritingObject7410;
    *selfslot = self;
    lowerouter7410 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7410;
  }
// method "new(_)"
  block_savedest(obj7410);
  Object closure7412 = createclosure(1, "new(1)");
  setclosureframe(closure7412, stackframe);
  addtoclosure(closure7412, var_numNode);
  struct UserObject *uo7412 = (struct UserObject*)obj7410;
  uo7412->data[1] = (Object)closure7412;
  Method *meth_meth_ast_new_40_1_41_7412 = addmethod2pos(obj7410, "new(1)", &meth_ast_new_40_1_41_7412, 1);
  int argcv_meth_ast_new_40_1_41_7412[] = {1};
  meth_meth_ast_new_40_1_41_7412->type = alloc_MethodType(1, argcv_meth_ast_new_40_1_41_7412);
  meth_meth_ast_new_40_1_41_7412->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_7412->definitionLine = 1876;
  block_savedest(obj7410);
  Object closure7481 = createclosure(1, "new(1)$object(1)");
  setclosureframe(closure7481, stackframe);
  addtoclosure(closure7481, var_numNode);
  Method *meth_meth_ast_new_40_1_41_7412_object = addmethod2pos(obj7410, "new(1)$object(1)", &meth_ast_new_40_1_41_7412_object, 1);
  meth_meth_ast_new_40_1_41_7412_object->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_7412_object->definitionLine = 1876;
  sourceObject = obj7410;
  objclass7410 = obj7410->class;
  objclass7410->definitionModule = modulename;
  objclass7410->definitionLine = 1875;
  (*(struct UserObject *)self).data[0] = lowerouter7410;
  self = oldself7410;
  selfslot = oldselfslot7410;
  stackframe = oldstackframe7410;
// compiled object node returning obj7410 (depth = 2)
  *var_numNode = obj7410;
  if (obj7410 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "numNode"
  block_savedest(self);
  Object closure7482 = createclosure(1, "numNode");
  setclosureframe(closure7482, stackframe);
  addtoclosure(closure7482, var_numNode);
  struct UserObject *uo7482 = (struct UserObject*)self;
  uo7482->data[38] = (Object)closure7482;
  Method *meth_meth_ast_numNode7482 = addmethod2pos(self, "numNode", &meth_ast_numNode7482, 38);
  int argcv_meth_ast_numNode7482[] = {0};
  meth_meth_ast_numNode7482->type = alloc_MethodType(1, argcv_meth_ast_numNode7482);
  meth_meth_ast_numNode7482->definitionModule = modulename;
  meth_meth_ast_numNode7482->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1902
  setline(1902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7483 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7483 = alloc_userobj2(2,4, objclass7483);
  gc_frame_newslot(obj7483);
if (objclass7483 == NULL) {
  glfree(obj7483->class->name);
  obj7483->class->name = "opNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7483, self, 0);
  addmethodreal(obj7483,"outer", &reader_ast_outer_7484);
  Object oldself7483 = self;
  struct StackFrameObject *oldstackframe7483 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7483);
  gc_frame_newslot((Object)stackframe);
  self = obj7483;
  Object *oldselfslot7483 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7483 = (*(struct UserObject *)self).data[0], lowerouter7483 = thisouter7483;
  if (inheritingObject7483) {
    struct UserObject *inho7483 = (struct UserObject *)inheritingObject7483;
    while (inho7483->super != GraceDefaultObject) inho7483 = (struct UserObject *)inho7483->super;
    inho7483->super = obj7483;
    self = inheritingObject7483;
    *selfslot = self;
    lowerouter7483 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7483;
  }
// method "new(_,_,_)"
  block_savedest(obj7483);
  Object closure7485 = createclosure(3, "new(3)");
  setclosureframe(closure7485, stackframe);
  addtoclosure(closure7485, var_identifierNode);
  addtoclosure(closure7485, var_nullNode);
  addtoclosure(closure7485, var_opNode);
  struct UserObject *uo7485 = (struct UserObject*)obj7483;
  uo7485->data[1] = (Object)closure7485;
  Method *meth_meth_ast_new_40_3_41_7485 = addmethod2pos(obj7483, "new(3)", &meth_ast_new_40_3_41_7485, 1);
  int argcv_meth_ast_new_40_3_41_7485[] = {3};
  meth_meth_ast_new_40_3_41_7485->type = alloc_MethodType(1, argcv_meth_ast_new_40_3_41_7485);
  meth_meth_ast_new_40_3_41_7485->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_7485->definitionLine = 1903;
  block_savedest(obj7483);
  Object closure7765 = createclosure(3, "new(3)$object(1)");
  setclosureframe(closure7765, stackframe);
  addtoclosure(closure7765, var_identifierNode);
  addtoclosure(closure7765, var_nullNode);
  addtoclosure(closure7765, var_opNode);
  Method *meth_meth_ast_new_40_3_41_7485_object = addmethod2pos(obj7483, "new(3)$object(1)", &meth_ast_new_40_3_41_7485_object, 1);
  meth_meth_ast_new_40_3_41_7485_object->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_7485_object->definitionLine = 1903;
  sourceObject = obj7483;
  objclass7483 = obj7483->class;
  objclass7483->definitionModule = modulename;
  objclass7483->definitionLine = 1902;
  (*(struct UserObject *)self).data[0] = lowerouter7483;
  self = oldself7483;
  selfslot = oldselfslot7483;
  stackframe = oldstackframe7483;
// compiled object node returning obj7483 (depth = 2)
  *var_opNode = obj7483;
  if (obj7483 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "opNode"
  block_savedest(self);
  Object closure7766 = createclosure(1, "opNode");
  setclosureframe(closure7766, stackframe);
  addtoclosure(closure7766, var_opNode);
  struct UserObject *uo7766 = (struct UserObject*)self;
  uo7766->data[39] = (Object)closure7766;
  Method *meth_meth_ast_opNode7766 = addmethod2pos(self, "opNode", &meth_ast_opNode7766, 39);
  int argcv_meth_ast_opNode7766[] = {0};
  meth_meth_ast_opNode7766->type = alloc_MethodType(1, argcv_meth_ast_opNode7766);
  meth_meth_ast_opNode7766->definitionModule = modulename;
  meth_meth_ast_opNode7766->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1969
  setline(1969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7767 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7767 = alloc_userobj2(2,4, objclass7767);
  gc_frame_newslot(obj7767);
if (objclass7767 == NULL) {
  glfree(obj7767->class->name);
  obj7767->class->name = "bindNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7767, self, 0);
  addmethodreal(obj7767,"outer", &reader_ast_outer_7768);
  Object oldself7767 = self;
  struct StackFrameObject *oldstackframe7767 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7767);
  gc_frame_newslot((Object)stackframe);
  self = obj7767;
  Object *oldselfslot7767 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7767 = (*(struct UserObject *)self).data[0], lowerouter7767 = thisouter7767;
  if (inheritingObject7767) {
    struct UserObject *inho7767 = (struct UserObject *)inheritingObject7767;
    while (inho7767->super != GraceDefaultObject) inho7767 = (struct UserObject *)inho7767->super;
    inho7767->super = obj7767;
    self = inheritingObject7767;
    *selfslot = self;
    lowerouter7767 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7767;
  }
// method "new(_,_)"
  block_savedest(obj7767);
  Object closure7769 = createclosure(1, "new(2)");
  setclosureframe(closure7769, stackframe);
  addtoclosure(closure7769, var_bindNode);
  struct UserObject *uo7769 = (struct UserObject*)obj7767;
  uo7769->data[1] = (Object)closure7769;
  Method *meth_meth_ast_new_40_2_41_7769 = addmethod2pos(obj7767, "new(2)", &meth_ast_new_40_2_41_7769, 1);
  int argcv_meth_ast_new_40_2_41_7769[] = {2};
  meth_meth_ast_new_40_2_41_7769->type = alloc_MethodType(1, argcv_meth_ast_new_40_2_41_7769);
  meth_meth_ast_new_40_2_41_7769->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_7769->definitionLine = 1970;
  block_savedest(obj7767);
  Object closure7954 = createclosure(1, "new(2)$object(1)");
  setclosureframe(closure7954, stackframe);
  addtoclosure(closure7954, var_bindNode);
  Method *meth_meth_ast_new_40_2_41_7769_object = addmethod2pos(obj7767, "new(2)$object(1)", &meth_ast_new_40_2_41_7769_object, 1);
  meth_meth_ast_new_40_2_41_7769_object->definitionModule = modulename;
  meth_meth_ast_new_40_2_41_7769_object->definitionLine = 1970;
  sourceObject = obj7767;
  objclass7767 = obj7767->class;
  objclass7767->definitionModule = modulename;
  objclass7767->definitionLine = 1969;
  (*(struct UserObject *)self).data[0] = lowerouter7767;
  self = oldself7767;
  selfslot = oldselfslot7767;
  stackframe = oldstackframe7767;
// compiled object node returning obj7767 (depth = 2)
  *var_bindNode = obj7767;
  if (obj7767 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "bindNode"
  block_savedest(self);
  Object closure7955 = createclosure(1, "bindNode");
  setclosureframe(closure7955, stackframe);
  addtoclosure(closure7955, var_bindNode);
  struct UserObject *uo7955 = (struct UserObject*)self;
  uo7955->data[40] = (Object)closure7955;
  Method *meth_meth_ast_bindNode7955 = addmethod2pos(self, "bindNode", &meth_ast_bindNode7955, 40);
  int argcv_meth_ast_bindNode7955[] = {0};
  meth_meth_ast_bindNode7955->type = alloc_MethodType(1, argcv_meth_ast_bindNode7955);
  meth_meth_ast_bindNode7955->definitionModule = modulename;
  meth_meth_ast_bindNode7955->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2021
  setline(2021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7956 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7956 = alloc_userobj2(3,4, objclass7956);
  gc_frame_newslot(obj7956);
if (objclass7956 == NULL) {
  glfree(obj7956->class->name);
  obj7956->class->name = "defDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7956, self, 0);
  addmethodreal(obj7956,"outer", &reader_ast_outer_7957);
  Object oldself7956 = self;
  struct StackFrameObject *oldstackframe7956 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7956);
  gc_frame_newslot((Object)stackframe);
  self = obj7956;
  Object *oldselfslot7956 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7956 = (*(struct UserObject *)self).data[0], lowerouter7956 = thisouter7956;
  if (inheritingObject7956) {
    struct UserObject *inho7956 = (struct UserObject *)inheritingObject7956;
    while (inho7956->super != GraceDefaultObject) inho7956 = (struct UserObject *)inho7956->super;
    inho7956->super = obj7956;
    self = inheritingObject7956;
    *selfslot = self;
    lowerouter7956 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7956;
  }
// method "new(_,_,_)scope(_)"
  struct UserObject *uo7958 = (struct UserObject*)obj7956;
  uo7958->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40_3_41_scope_40_1_41_7958 = addmethod2pos(obj7956, "new(3)scope(1)", &meth_ast_new_40_3_41_scope_40_1_41_7958, 1);
  int argcv_meth_ast_new_40_3_41_scope_40_1_41_7958[] = {3, 1};
  meth_meth_ast_new_40_3_41_scope_40_1_41_7958->type = alloc_MethodType(2, argcv_meth_ast_new_40_3_41_scope_40_1_41_7958);
  meth_meth_ast_new_40_3_41_scope_40_1_41_7958->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_scope_40_1_41_7958->definitionLine = 2022;
// method "new(_,_,_)"
  block_savedest(obj7956);
  Object closure7963 = createclosure(2, "new(3)");
  setclosureframe(closure7963, stackframe);
  addtoclosure(closure7963, var_k);
  addtoclosure(closure7963, var_defDecNode);
  struct UserObject *uo7963 = (struct UserObject*)obj7956;
  uo7963->data[2] = (Object)closure7963;
  Method *meth_meth_ast_new_40_3_41_7963 = addmethod2pos(obj7956, "new(3)", &meth_ast_new_40_3_41_7963, 2);
  int argcv_meth_ast_new_40_3_41_7963[] = {3};
  meth_meth_ast_new_40_3_41_7963->type = alloc_MethodType(1, argcv_meth_ast_new_40_3_41_7963);
  meth_meth_ast_new_40_3_41_7963->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_7963->definitionLine = 2028;
  block_savedest(obj7956);
  Object closure8420 = createclosure(2, "new(3)$object(1)");
  setclosureframe(closure8420, stackframe);
  addtoclosure(closure8420, var_k);
  addtoclosure(closure8420, var_defDecNode);
  Method *meth_meth_ast_new_40_3_41_7963_object = addmethod2pos(obj7956, "new(3)$object(1)", &meth_ast_new_40_3_41_7963_object, 2);
  meth_meth_ast_new_40_3_41_7963_object->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_7963_object->definitionLine = 2028;
  sourceObject = obj7956;
  sourceObject = obj7956;
  objclass7956 = obj7956->class;
  objclass7956->definitionModule = modulename;
  objclass7956->definitionLine = 2021;
  (*(struct UserObject *)self).data[0] = lowerouter7956;
  self = oldself7956;
  selfslot = oldselfslot7956;
  stackframe = oldstackframe7956;
// compiled object node returning obj7956 (depth = 2)
  *var_defDecNode = obj7956;
  if (obj7956 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "defDecNode"
  block_savedest(self);
  Object closure8421 = createclosure(1, "defDecNode");
  setclosureframe(closure8421, stackframe);
  addtoclosure(closure8421, var_defDecNode);
  struct UserObject *uo8421 = (struct UserObject*)self;
  uo8421->data[41] = (Object)closure8421;
  Method *meth_meth_ast_defDecNode8421 = addmethod2pos(self, "defDecNode", &meth_ast_defDecNode8421, 41);
  int argcv_meth_ast_defDecNode8421[] = {0};
  meth_meth_ast_defDecNode8421->type = alloc_MethodType(1, argcv_meth_ast_defDecNode8421);
  meth_meth_ast_defDecNode8421->definitionModule = modulename;
  meth_meth_ast_defDecNode8421->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2059
  setline(2059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2138
  setline(2138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject8422 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8422 = alloc_userobj2(2,4, objclass8422);
  gc_frame_newslot(obj8422);
if (objclass8422 == NULL) {
  glfree(obj8422->class->name);
  obj8422->class->name = "varDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8422, self, 0);
  addmethodreal(obj8422,"outer", &reader_ast_outer_8423);
  Object oldself8422 = self;
  struct StackFrameObject *oldstackframe8422 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8422);
  gc_frame_newslot((Object)stackframe);
  self = obj8422;
  Object *oldselfslot8422 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8422 = (*(struct UserObject *)self).data[0], lowerouter8422 = thisouter8422;
  if (inheritingObject8422) {
    struct UserObject *inho8422 = (struct UserObject *)inheritingObject8422;
    while (inho8422->super != GraceDefaultObject) inho8422 = (struct UserObject *)inho8422->super;
    inho8422->super = obj8422;
    self = inheritingObject8422;
    *selfslot = self;
    lowerouter8422 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8422;
  }
// method "new(_,_,_)"
  block_savedest(obj8422);
  Object closure8424 = createclosure(2, "new(3)");
  setclosureframe(closure8424, stackframe);
  addtoclosure(closure8424, var_k);
  addtoclosure(closure8424, var_varDecNode);
  struct UserObject *uo8424 = (struct UserObject*)obj8422;
  uo8424->data[1] = (Object)closure8424;
  Method *meth_meth_ast_new_40_3_41_8424 = addmethod2pos(obj8422, "new(3)", &meth_ast_new_40_3_41_8424, 1);
  int argcv_meth_ast_new_40_3_41_8424[] = {3};
  meth_meth_ast_new_40_3_41_8424->type = alloc_MethodType(1, argcv_meth_ast_new_40_3_41_8424);
  meth_meth_ast_new_40_3_41_8424->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_8424->definitionLine = 2139;
  block_savedest(obj8422);
  Object closure8878 = createclosure(2, "new(3)$object(1)");
  setclosureframe(closure8878, stackframe);
  addtoclosure(closure8878, var_k);
  addtoclosure(closure8878, var_varDecNode);
  Method *meth_meth_ast_new_40_3_41_8424_object = addmethod2pos(obj8422, "new(3)$object(1)", &meth_ast_new_40_3_41_8424_object, 1);
  meth_meth_ast_new_40_3_41_8424_object->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_8424_object->definitionLine = 2139;
  sourceObject = obj8422;
  objclass8422 = obj8422->class;
  objclass8422->definitionModule = modulename;
  objclass8422->definitionLine = 2138;
  (*(struct UserObject *)self).data[0] = lowerouter8422;
  self = oldself8422;
  selfslot = oldselfslot8422;
  stackframe = oldstackframe8422;
// compiled object node returning obj8422 (depth = 2)
  *var_varDecNode = obj8422;
  if (obj8422 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "varDecNode"
  block_savedest(self);
  Object closure8879 = createclosure(1, "varDecNode");
  setclosureframe(closure8879, stackframe);
  addtoclosure(closure8879, var_varDecNode);
  struct UserObject *uo8879 = (struct UserObject*)self;
  uo8879->data[42] = (Object)closure8879;
  Method *meth_meth_ast_varDecNode8879 = addmethod2pos(self, "varDecNode", &meth_ast_varDecNode8879, 42);
  int argcv_meth_ast_varDecNode8879[] = {0};
  meth_meth_ast_varDecNode8879->type = alloc_MethodType(1, argcv_meth_ast_varDecNode8879);
  meth_meth_ast_varDecNode8879->definitionModule = modulename;
  meth_meth_ast_varDecNode8879->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2243
  setline(2243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2246
  setline(2246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject8880 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8880 = alloc_userobj2(2,4, objclass8880);
  gc_frame_newslot(obj8880);
if (objclass8880 == NULL) {
  glfree(obj8880->class->name);
  obj8880->class->name = "importNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8880, self, 0);
  addmethodreal(obj8880,"outer", &reader_ast_outer_8881);
  Object oldself8880 = self;
  struct StackFrameObject *oldstackframe8880 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8880);
  gc_frame_newslot((Object)stackframe);
  self = obj8880;
  Object *oldselfslot8880 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8880 = (*(struct UserObject *)self).data[0], lowerouter8880 = thisouter8880;
  if (inheritingObject8880) {
    struct UserObject *inho8880 = (struct UserObject *)inheritingObject8880;
    while (inho8880->super != GraceDefaultObject) inho8880 = (struct UserObject *)inho8880->super;
    inho8880->super = obj8880;
    self = inheritingObject8880;
    *selfslot = self;
    lowerouter8880 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8880;
  }
// method "new(_,_,_)"
  block_savedest(obj8880);
  Object closure8882 = createclosure(3, "new(3)");
  setclosureframe(closure8882, stackframe);
  addtoclosure(closure8882, var_k);
  addtoclosure(closure8882, var_nullNode);
  addtoclosure(closure8882, var_importNode);
  struct UserObject *uo8882 = (struct UserObject*)obj8880;
  uo8882->data[1] = (Object)closure8882;
  Method *meth_meth_ast_new_40_3_41_8882 = addmethod2pos(obj8880, "new(3)", &meth_ast_new_40_3_41_8882, 1);
  int argcv_meth_ast_new_40_3_41_8882[] = {3};
  meth_meth_ast_new_40_3_41_8882->type = alloc_MethodType(1, argcv_meth_ast_new_40_3_41_8882);
  meth_meth_ast_new_40_3_41_8882->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_8882->definitionLine = 2247;
  block_savedest(obj8880);
  Object closure9158 = createclosure(3, "new(3)$object(1)");
  setclosureframe(closure9158, stackframe);
  addtoclosure(closure9158, var_k);
  addtoclosure(closure9158, var_nullNode);
  addtoclosure(closure9158, var_importNode);
  Method *meth_meth_ast_new_40_3_41_8882_object = addmethod2pos(obj8880, "new(3)$object(1)", &meth_ast_new_40_3_41_8882_object, 1);
  meth_meth_ast_new_40_3_41_8882_object->definitionModule = modulename;
  meth_meth_ast_new_40_3_41_8882_object->definitionLine = 2247;
  sourceObject = obj8880;
  objclass8880 = obj8880->class;
  objclass8880->definitionModule = modulename;
  objclass8880->definitionLine = 2246;
  (*(struct UserObject *)self).data[0] = lowerouter8880;
  self = oldself8880;
  selfslot = oldselfslot8880;
  stackframe = oldstackframe8880;
// compiled object node returning obj8880 (depth = 2)
  *var_importNode = obj8880;
  if (obj8880 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "importNode"
  block_savedest(self);
  Object closure9159 = createclosure(1, "importNode");
  setclosureframe(closure9159, stackframe);
  addtoclosure(closure9159, var_importNode);
  struct UserObject *uo9159 = (struct UserObject*)self;
  uo9159->data[43] = (Object)closure9159;
  Method *meth_meth_ast_importNode9159 = addmethod2pos(self, "importNode", &meth_ast_importNode9159, 43);
  int argcv_meth_ast_importNode9159[] = {0};
  meth_meth_ast_importNode9159->type = alloc_MethodType(1, argcv_meth_ast_importNode9159);
  meth_meth_ast_importNode9159->definitionModule = modulename;
  meth_meth_ast_importNode9159->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2323
  setline(2323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9160 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9160 = alloc_userobj2(2,4, objclass9160);
  gc_frame_newslot(obj9160);
if (objclass9160 == NULL) {
  glfree(obj9160->class->name);
  obj9160->class->name = "dialectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9160, self, 0);
  addmethodreal(obj9160,"outer", &reader_ast_outer_9161);
  Object oldself9160 = self;
  struct StackFrameObject *oldstackframe9160 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9160);
  gc_frame_newslot((Object)stackframe);
  self = obj9160;
  Object *oldselfslot9160 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9160 = (*(struct UserObject *)self).data[0], lowerouter9160 = thisouter9160;
  if (inheritingObject9160) {
    struct UserObject *inho9160 = (struct UserObject *)inheritingObject9160;
    while (inho9160->super != GraceDefaultObject) inho9160 = (struct UserObject *)inho9160->super;
    inho9160->super = obj9160;
    self = inheritingObject9160;
    *selfslot = self;
    lowerouter9160 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9160;
  }
// method "new(_)"
  block_savedest(obj9160);
  Object closure9162 = createclosure(1, "new(1)");
  setclosureframe(closure9162, stackframe);
  addtoclosure(closure9162, var_dialectNode);
  struct UserObject *uo9162 = (struct UserObject*)obj9160;
  uo9162->data[1] = (Object)closure9162;
  Method *meth_meth_ast_new_40_1_41_9162 = addmethod2pos(obj9160, "new(1)", &meth_ast_new_40_1_41_9162, 1);
  int argcv_meth_ast_new_40_1_41_9162[] = {1};
  meth_meth_ast_new_40_1_41_9162->type = alloc_MethodType(1, argcv_meth_ast_new_40_1_41_9162);
  meth_meth_ast_new_40_1_41_9162->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_9162->definitionLine = 2324;
  block_savedest(obj9160);
  Object closure9274 = createclosure(1, "new(1)$object(1)");
  setclosureframe(closure9274, stackframe);
  addtoclosure(closure9274, var_dialectNode);
  Method *meth_meth_ast_new_40_1_41_9162_object = addmethod2pos(obj9160, "new(1)$object(1)", &meth_ast_new_40_1_41_9162_object, 1);
  meth_meth_ast_new_40_1_41_9162_object->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_9162_object->definitionLine = 2324;
  sourceObject = obj9160;
  objclass9160 = obj9160->class;
  objclass9160->definitionModule = modulename;
  objclass9160->definitionLine = 2323;
  (*(struct UserObject *)self).data[0] = lowerouter9160;
  self = oldself9160;
  selfslot = oldselfslot9160;
  stackframe = oldstackframe9160;
// compiled object node returning obj9160 (depth = 2)
  *var_dialectNode = obj9160;
  if (obj9160 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "dialectNode"
  block_savedest(self);
  Object closure9275 = createclosure(1, "dialectNode");
  setclosureframe(closure9275, stackframe);
  addtoclosure(closure9275, var_dialectNode);
  struct UserObject *uo9275 = (struct UserObject*)self;
  uo9275->data[44] = (Object)closure9275;
  Method *meth_meth_ast_dialectNode9275 = addmethod2pos(self, "dialectNode", &meth_ast_dialectNode9275, 44);
  int argcv_meth_ast_dialectNode9275[] = {0};
  meth_meth_ast_dialectNode9275->type = alloc_MethodType(1, argcv_meth_ast_dialectNode9275);
  meth_meth_ast_dialectNode9275->definitionModule = modulename;
  meth_meth_ast_dialectNode9275->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2328
  setline(2328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2371
  setline(2371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9276 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9276 = alloc_userobj2(2,4, objclass9276);
  gc_frame_newslot(obj9276);
if (objclass9276 == NULL) {
  glfree(obj9276->class->name);
  obj9276->class->name = "returnNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9276, self, 0);
  addmethodreal(obj9276,"outer", &reader_ast_outer_9277);
  Object oldself9276 = self;
  struct StackFrameObject *oldstackframe9276 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9276);
  gc_frame_newslot((Object)stackframe);
  self = obj9276;
  Object *oldselfslot9276 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9276 = (*(struct UserObject *)self).data[0], lowerouter9276 = thisouter9276;
  if (inheritingObject9276) {
    struct UserObject *inho9276 = (struct UserObject *)inheritingObject9276;
    while (inho9276->super != GraceDefaultObject) inho9276 = (struct UserObject *)inho9276->super;
    inho9276->super = obj9276;
    self = inheritingObject9276;
    *selfslot = self;
    lowerouter9276 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9276;
  }
// method "new(_)"
  block_savedest(obj9276);
  Object closure9278 = createclosure(2, "new(1)");
  setclosureframe(closure9278, stackframe);
  addtoclosure(closure9278, var_nullNode);
  addtoclosure(closure9278, var_returnNode);
  struct UserObject *uo9278 = (struct UserObject*)obj9276;
  uo9278->data[1] = (Object)closure9278;
  Method *meth_meth_ast_new_40_1_41_9278 = addmethod2pos(obj9276, "new(1)", &meth_ast_new_40_1_41_9278, 1);
  int argcv_meth_ast_new_40_1_41_9278[] = {1};
  meth_meth_ast_new_40_1_41_9278->type = alloc_MethodType(1, argcv_meth_ast_new_40_1_41_9278);
  meth_meth_ast_new_40_1_41_9278->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_9278->definitionLine = 2372;
  block_savedest(obj9276);
  Object closure9364 = createclosure(2, "new(1)$object(1)");
  setclosureframe(closure9364, stackframe);
  addtoclosure(closure9364, var_nullNode);
  addtoclosure(closure9364, var_returnNode);
  Method *meth_meth_ast_new_40_1_41_9278_object = addmethod2pos(obj9276, "new(1)$object(1)", &meth_ast_new_40_1_41_9278_object, 1);
  meth_meth_ast_new_40_1_41_9278_object->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_9278_object->definitionLine = 2372;
  sourceObject = obj9276;
  objclass9276 = obj9276->class;
  objclass9276->definitionModule = modulename;
  objclass9276->definitionLine = 2371;
  (*(struct UserObject *)self).data[0] = lowerouter9276;
  self = oldself9276;
  selfslot = oldselfslot9276;
  stackframe = oldstackframe9276;
// compiled object node returning obj9276 (depth = 2)
  *var_returnNode = obj9276;
  if (obj9276 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "returnNode"
  block_savedest(self);
  Object closure9365 = createclosure(1, "returnNode");
  setclosureframe(closure9365, stackframe);
  addtoclosure(closure9365, var_returnNode);
  struct UserObject *uo9365 = (struct UserObject*)self;
  uo9365->data[45] = (Object)closure9365;
  Method *meth_meth_ast_returnNode9365 = addmethod2pos(self, "returnNode", &meth_ast_returnNode9365, 45);
  int argcv_meth_ast_returnNode9365[] = {0};
  meth_meth_ast_returnNode9365->type = alloc_MethodType(1, argcv_meth_ast_returnNode9365);
  meth_meth_ast_returnNode9365->definitionModule = modulename;
  meth_meth_ast_returnNode9365->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2376
  setline(2376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2406
  setline(2406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9366 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9366 = alloc_userobj2(3,4, objclass9366);
  gc_frame_newslot(obj9366);
if (objclass9366 == NULL) {
  glfree(obj9366->class->name);
  obj9366->class->name = "inheritsNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9366, self, 0);
  addmethodreal(obj9366,"outer", &reader_ast_outer_9367);
  Object oldself9366 = self;
  struct StackFrameObject *oldstackframe9366 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9366);
  gc_frame_newslot((Object)stackframe);
  self = obj9366;
  Object *oldselfslot9366 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9366 = (*(struct UserObject *)self).data[0], lowerouter9366 = thisouter9366;
  if (inheritingObject9366) {
    struct UserObject *inho9366 = (struct UserObject *)inheritingObject9366;
    while (inho9366->super != GraceDefaultObject) inho9366 = (struct UserObject *)inho9366->super;
    inho9366->super = obj9366;
    self = inheritingObject9366;
    *selfslot = self;
    lowerouter9366 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9366;
  }
// method "new(_)scope(_)"
  struct UserObject *uo9368 = (struct UserObject*)obj9366;
  uo9368->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40_1_41_scope_40_1_41_9368 = addmethod2pos(obj9366, "new(1)scope(1)", &meth_ast_new_40_1_41_scope_40_1_41_9368, 1);
  int argcv_meth_ast_new_40_1_41_scope_40_1_41_9368[] = {1, 1};
  meth_meth_ast_new_40_1_41_scope_40_1_41_9368->type = alloc_MethodType(2, argcv_meth_ast_new_40_1_41_scope_40_1_41_9368);
  meth_meth_ast_new_40_1_41_scope_40_1_41_9368->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_scope_40_1_41_9368->definitionLine = 2407;
// method "new(_)"
  block_savedest(obj9366);
  Object closure9373 = createclosure(3, "new(1)");
  setclosureframe(closure9373, stackframe);
  addtoclosure(closure9373, var_k);
  addtoclosure(closure9373, var_nullNode);
  addtoclosure(closure9373, var_inheritsNode);
  struct UserObject *uo9373 = (struct UserObject*)obj9366;
  uo9373->data[2] = (Object)closure9373;
  Method *meth_meth_ast_new_40_1_41_9373 = addmethod2pos(obj9366, "new(1)", &meth_ast_new_40_1_41_9373, 2);
  int argcv_meth_ast_new_40_1_41_9373[] = {1};
  meth_meth_ast_new_40_1_41_9373->type = alloc_MethodType(1, argcv_meth_ast_new_40_1_41_9373);
  meth_meth_ast_new_40_1_41_9373->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_9373->definitionLine = 2412;
  block_savedest(obj9366);
  Object closure9757 = createclosure(3, "new(1)$object(1)");
  setclosureframe(closure9757, stackframe);
  addtoclosure(closure9757, var_k);
  addtoclosure(closure9757, var_nullNode);
  addtoclosure(closure9757, var_inheritsNode);
  Method *meth_meth_ast_new_40_1_41_9373_object = addmethod2pos(obj9366, "new(1)$object(1)", &meth_ast_new_40_1_41_9373_object, 2);
  meth_meth_ast_new_40_1_41_9373_object->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_9373_object->definitionLine = 2412;
  sourceObject = obj9366;
  sourceObject = obj9366;
  objclass9366 = obj9366->class;
  objclass9366->definitionModule = modulename;
  objclass9366->definitionLine = 2406;
  (*(struct UserObject *)self).data[0] = lowerouter9366;
  self = oldself9366;
  selfslot = oldselfslot9366;
  stackframe = oldstackframe9366;
// compiled object node returning obj9366 (depth = 2)
  *var_inheritsNode = obj9366;
  if (obj9366 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "inheritsNode"
  block_savedest(self);
  Object closure9758 = createclosure(1, "inheritsNode");
  setclosureframe(closure9758, stackframe);
  addtoclosure(closure9758, var_inheritsNode);
  struct UserObject *uo9758 = (struct UserObject*)self;
  uo9758->data[46] = (Object)closure9758;
  Method *meth_meth_ast_inheritsNode9758 = addmethod2pos(self, "inheritsNode", &meth_ast_inheritsNode9758, 46);
  int argcv_meth_ast_inheritsNode9758[] = {0};
  meth_meth_ast_inheritsNode9758->type = alloc_MethodType(1, argcv_meth_ast_inheritsNode9758);
  meth_meth_ast_inheritsNode9758->definitionModule = modulename;
  meth_meth_ast_inheritsNode9758->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2420
  setline(2420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2510
  setline(2510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl AliasPair
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type9760 = alloc_Type("AliasPair", 2);
    add_Method((ClassData)type9760, "newName", NULL);
    add_Method((ClassData)type9760, "oldName", NULL);
// compiled typeliteral node returning type9760 (depth = 2)
  *var_AliasPair = type9760;
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "AliasPair"
  block_savedest(self);
  Object closure9761 = createclosure(1, "AliasPair");
  setclosureframe(closure9761, stackframe);
  addtoclosure(closure9761, var_AliasPair);
  struct UserObject *uo9761 = (struct UserObject*)self;
  uo9761->data[47] = (Object)closure9761;
  Method *meth_meth_ast_AliasPair9761 = addmethod2pos(self, "AliasPair", &meth_ast_AliasPair9761, 47);
  int argcv_meth_ast_AliasPair9761[] = {0};
  meth_meth_ast_AliasPair9761->type = alloc_MethodType(1, argcv_meth_ast_AliasPair9761);
  meth_meth_ast_AliasPair9761->definitionModule = modulename;
  meth_meth_ast_AliasPair9761->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 2514
  setline(2514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2534
  setline(2534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9762 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9762 = alloc_userobj2(2,4, objclass9762);
  gc_frame_newslot(obj9762);
if (objclass9762 == NULL) {
  glfree(obj9762->class->name);
  obj9762->class->name = "blankNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9762, self, 0);
  addmethodreal(obj9762,"outer", &reader_ast_outer_9763);
  Object oldself9762 = self;
  struct StackFrameObject *oldstackframe9762 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9762);
  gc_frame_newslot((Object)stackframe);
  self = obj9762;
  Object *oldselfslot9762 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9762 = (*(struct UserObject *)self).data[0], lowerouter9762 = thisouter9762;
  if (inheritingObject9762) {
    struct UserObject *inho9762 = (struct UserObject *)inheritingObject9762;
    while (inho9762->super != GraceDefaultObject) inho9762 = (struct UserObject *)inho9762->super;
    inho9762->super = obj9762;
    self = inheritingObject9762;
    *selfslot = self;
    lowerouter9762 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9762;
  }
// method "new"
  block_savedest(obj9762);
  Object closure9764 = createclosure(1, "new");
  setclosureframe(closure9764, stackframe);
  addtoclosure(closure9764, var_blankNode);
  struct UserObject *uo9764 = (struct UserObject*)obj9762;
  uo9764->data[1] = (Object)closure9764;
  Method *meth_meth_ast_new9764 = addmethod2pos(obj9762, "new", &meth_ast_new9764, 1);
  int argcv_meth_ast_new9764[] = {0};
  meth_meth_ast_new9764->type = alloc_MethodType(1, argcv_meth_ast_new9764);
  meth_meth_ast_new9764->definitionModule = modulename;
  meth_meth_ast_new9764->definitionLine = 2535;
  block_savedest(obj9762);
  Object closure9800 = createclosure(1, "new$object(1)");
  setclosureframe(closure9800, stackframe);
  addtoclosure(closure9800, var_blankNode);
  Method *meth_meth_ast_new9764_object = addmethod2pos(obj9762, "new$object(1)", &meth_ast_new9764_object, 1);
  meth_meth_ast_new9764_object->definitionModule = modulename;
  meth_meth_ast_new9764_object->definitionLine = 2535;
  sourceObject = obj9762;
  objclass9762 = obj9762->class;
  objclass9762->definitionModule = modulename;
  objclass9762->definitionLine = 2534;
  (*(struct UserObject *)self).data[0] = lowerouter9762;
  self = oldself9762;
  selfslot = oldselfslot9762;
  stackframe = oldstackframe9762;
// compiled object node returning obj9762 (depth = 2)
  *var_blankNode = obj9762;
  if (obj9762 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blankNode"
  block_savedest(self);
  Object closure9801 = createclosure(1, "blankNode");
  setclosureframe(closure9801, stackframe);
  addtoclosure(closure9801, var_blankNode);
  struct UserObject *uo9801 = (struct UserObject*)self;
  uo9801->data[48] = (Object)closure9801;
  Method *meth_meth_ast_blankNode9801 = addmethod2pos(self, "blankNode", &meth_ast_blankNode9801, 48);
  int argcv_meth_ast_blankNode9801[] = {0};
  meth_meth_ast_blankNode9801->type = alloc_MethodType(1, argcv_meth_ast_blankNode9801);
  meth_meth_ast_blankNode9801->definitionModule = modulename;
  meth_meth_ast_blankNode9801->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2541
  setline(2541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2558
  setline(2558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9802 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9802 = alloc_userobj2(6,7, objclass9802);
  gc_frame_newslot(obj9802);
if (objclass9802 == NULL) {
  glfree(obj9802->class->name);
  obj9802->class->name = "signaturePart";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9802, self, 0);
  addmethodreal(obj9802,"outer", &reader_ast_outer_9803);
  Object oldself9802 = self;
  struct StackFrameObject *oldstackframe9802 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9802);
  gc_frame_newslot((Object)stackframe);
  self = obj9802;
  Object *oldselfslot9802 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9802 = (*(struct UserObject *)self).data[0], lowerouter9802 = thisouter9802;
  if (inheritingObject9802) {
    struct UserObject *inho9802 = (struct UserObject *)inheritingObject9802;
    while (inho9802->super != GraceDefaultObject) inho9802 = (struct UserObject *)inho9802->super;
    inho9802->super = obj9802;
    self = inheritingObject9802;
    *selfslot = self;
    lowerouter9802 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9802;
  }
// method "new"
  struct UserObject *uo9804 = (struct UserObject*)obj9802;
  uo9804->data[1] = emptyclosure;
  Method *meth_meth_ast_new9804 = addmethod2pos(obj9802, "new", &meth_ast_new9804, 1);
  int argcv_meth_ast_new9804[] = {0};
  meth_meth_ast_new9804->type = alloc_MethodType(1, argcv_meth_ast_new9804);
  meth_meth_ast_new9804->definitionModule = modulename;
  meth_meth_ast_new9804->definitionLine = 2559;
// method "partName(_)scope(_)"
  struct UserObject *uo9809 = (struct UserObject*)obj9802;
  uo9809->data[2] = emptyclosure;
  Method *meth_meth_ast_partName_40_1_41_scope_40_1_41_9809 = addmethod2pos(obj9802, "partName(1)scope(1)", &meth_ast_partName_40_1_41_scope_40_1_41_9809, 2);
  int argcv_meth_ast_partName_40_1_41_scope_40_1_41_9809[] = {1, 1};
  meth_meth_ast_partName_40_1_41_scope_40_1_41_9809->type = alloc_MethodType(2, argcv_meth_ast_partName_40_1_41_scope_40_1_41_9809);
  meth_meth_ast_partName_40_1_41_scope_40_1_41_9809->definitionModule = modulename;
  meth_meth_ast_partName_40_1_41_scope_40_1_41_9809->definitionLine = 2562;
// method "partName(_)params(_)scope(_)"
  struct UserObject *uo9815 = (struct UserObject*)obj9802;
  uo9815->data[3] = emptyclosure;
  Method *meth_meth_ast_partName_40_1_41_params_40_1_41_scope_40_1_41_9815 = addmethod2pos(obj9802, "partName(1)params(1)scope(1)", &meth_ast_partName_40_1_41_params_40_1_41_scope_40_1_41_9815, 3);
  int argcv_meth_ast_partName_40_1_41_params_40_1_41_scope_40_1_41_9815[] = {1, 1, 1};
  meth_meth_ast_partName_40_1_41_params_40_1_41_scope_40_1_41_9815->type = alloc_MethodType(3, argcv_meth_ast_partName_40_1_41_params_40_1_41_scope_40_1_41_9815);
  meth_meth_ast_partName_40_1_41_params_40_1_41_scope_40_1_41_9815->definitionModule = modulename;
  meth_meth_ast_partName_40_1_41_params_40_1_41_scope_40_1_41_9815->definitionLine = 2567;
// method "partName(_)"
  struct UserObject *uo9820 = (struct UserObject*)obj9802;
  uo9820->data[4] = emptyclosure;
  Method *meth_meth_ast_partName_40_1_41_9820 = addmethod2pos(obj9802, "partName(1)", &meth_ast_partName_40_1_41_9820, 4);
  int argcv_meth_ast_partName_40_1_41_9820[] = {1};
  meth_meth_ast_partName_40_1_41_9820->type = alloc_MethodType(1, argcv_meth_ast_partName_40_1_41_9820);
  meth_meth_ast_partName_40_1_41_9820->definitionModule = modulename;
  meth_meth_ast_partName_40_1_41_9820->definitionLine = 2572;
// method "partName(_)params(_)"
  block_savedest(obj9802);
  Object closure9824 = createclosure(2, "partName(1)params(1)");
  setclosureframe(closure9824, stackframe);
  addtoclosure(closure9824, var_k);
  addtoclosure(closure9824, var_signaturePart);
  struct UserObject *uo9824 = (struct UserObject*)obj9802;
  uo9824->data[5] = (Object)closure9824;
  Method *meth_meth_ast_partName_40_1_41_params_40_1_41_9824 = addmethod2pos(obj9802, "partName(1)params(1)", &meth_ast_partName_40_1_41_params_40_1_41_9824, 5);
  int argcv_meth_ast_partName_40_1_41_params_40_1_41_9824[] = {1, 1};
  meth_meth_ast_partName_40_1_41_params_40_1_41_9824->type = alloc_MethodType(2, argcv_meth_ast_partName_40_1_41_params_40_1_41_9824);
  meth_meth_ast_partName_40_1_41_params_40_1_41_9824->definitionModule = modulename;
  meth_meth_ast_partName_40_1_41_params_40_1_41_9824->definitionLine = 2575;
  block_savedest(obj9802);
  Object closure10140 = createclosure(2, "partName(1)params(1)$object(1)");
  setclosureframe(closure10140, stackframe);
  addtoclosure(closure10140, var_k);
  addtoclosure(closure10140, var_signaturePart);
  Method *meth_meth_ast_partName_40_1_41_params_40_1_41_9824_object = addmethod2pos(obj9802, "partName(1)params(1)$object(1)", &meth_ast_partName_40_1_41_params_40_1_41_9824_object, 5);
  meth_meth_ast_partName_40_1_41_params_40_1_41_9824_object->definitionModule = modulename;
  meth_meth_ast_partName_40_1_41_params_40_1_41_9824_object->definitionLine = 2575;
  sourceObject = obj9802;
  sourceObject = obj9802;
  sourceObject = obj9802;
  sourceObject = obj9802;
  sourceObject = obj9802;
  objclass9802 = obj9802->class;
  objclass9802->definitionModule = modulename;
  objclass9802->definitionLine = 2558;
  (*(struct UserObject *)self).data[0] = lowerouter9802;
  self = oldself9802;
  selfslot = oldselfslot9802;
  stackframe = oldstackframe9802;
// compiled object node returning obj9802 (depth = 2)
  *var_signaturePart = obj9802;
  if (obj9802 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "signaturePart"
  block_savedest(self);
  Object closure10141 = createclosure(1, "signaturePart");
  setclosureframe(closure10141, stackframe);
  addtoclosure(closure10141, var_signaturePart);
  struct UserObject *uo10141 = (struct UserObject*)self;
  uo10141->data[49] = (Object)closure10141;
  Method *meth_meth_ast_signaturePart10141 = addmethod2pos(self, "signaturePart", &meth_ast_signaturePart10141, 49);
  int argcv_meth_ast_signaturePart10141[] = {0};
  meth_meth_ast_signaturePart10141->type = alloc_MethodType(1, argcv_meth_ast_signaturePart10141);
  meth_meth_ast_signaturePart10141->definitionModule = modulename;
  meth_meth_ast_signaturePart10141->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2650
  setline(2650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2651
  setline(2651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject10142 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10142 = alloc_userobj2(4,5, objclass10142);
  gc_frame_newslot(obj10142);
if (objclass10142 == NULL) {
  glfree(obj10142->class->name);
  obj10142->class->name = "requestPart";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10142, self, 0);
  addmethodreal(obj10142,"outer", &reader_ast_outer_10143);
  Object oldself10142 = self;
  struct StackFrameObject *oldstackframe10142 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10142);
  gc_frame_newslot((Object)stackframe);
  self = obj10142;
  Object *oldselfslot10142 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10142 = (*(struct UserObject *)self).data[0], lowerouter10142 = thisouter10142;
  if (inheritingObject10142) {
    struct UserObject *inho10142 = (struct UserObject *)inheritingObject10142;
    while (inho10142->super != GraceDefaultObject) inho10142 = (struct UserObject *)inho10142->super;
    inho10142->super = obj10142;
    self = inheritingObject10142;
    *selfslot = self;
    lowerouter10142 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10142;
  }
// method "new"
  struct UserObject *uo10144 = (struct UserObject*)obj10142;
  uo10144->data[1] = emptyclosure;
  Method *meth_meth_ast_new10144 = addmethod2pos(obj10142, "new", &meth_ast_new10144, 1);
  int argcv_meth_ast_new10144[] = {0};
  meth_meth_ast_new10144->type = alloc_MethodType(1, argcv_meth_ast_new10144);
  meth_meth_ast_new10144->definitionModule = modulename;
  meth_meth_ast_new10144->definitionLine = 2652;
// method "request(_)withArgs(_)scope(_)"
  struct UserObject *uo10149 = (struct UserObject*)obj10142;
  uo10149->data[2] = emptyclosure;
  Method *meth_meth_ast_request_40_1_41_withArgs_40_1_41_scope_40_1_41_10149 = addmethod2pos(obj10142, "request(1)withArgs(1)scope(1)", &meth_ast_request_40_1_41_withArgs_40_1_41_scope_40_1_41_10149, 2);
  int argcv_meth_ast_request_40_1_41_withArgs_40_1_41_scope_40_1_41_10149[] = {1, 1, 1};
  meth_meth_ast_request_40_1_41_withArgs_40_1_41_scope_40_1_41_10149->type = alloc_MethodType(3, argcv_meth_ast_request_40_1_41_withArgs_40_1_41_scope_40_1_41_10149);
  meth_meth_ast_request_40_1_41_withArgs_40_1_41_scope_40_1_41_10149->definitionModule = modulename;
  meth_meth_ast_request_40_1_41_withArgs_40_1_41_scope_40_1_41_10149->definitionLine = 2655;
// method "request(_)withArgs(_)"
  block_savedest(obj10142);
  Object closure10154 = createclosure(2, "request(1)withArgs(1)");
  setclosureframe(closure10154, stackframe);
  addtoclosure(closure10154, var_requestPart);
  addtoclosure(closure10154, var_emptySeq);
  struct UserObject *uo10154 = (struct UserObject*)obj10142;
  uo10154->data[3] = (Object)closure10154;
  Method *meth_meth_ast_request_40_1_41_withArgs_40_1_41_10154 = addmethod2pos(obj10142, "request(1)withArgs(1)", &meth_ast_request_40_1_41_withArgs_40_1_41_10154, 3);
  int argcv_meth_ast_request_40_1_41_withArgs_40_1_41_10154[] = {1, 1};
  meth_meth_ast_request_40_1_41_withArgs_40_1_41_10154->type = alloc_MethodType(2, argcv_meth_ast_request_40_1_41_withArgs_40_1_41_10154);
  meth_meth_ast_request_40_1_41_withArgs_40_1_41_10154->definitionModule = modulename;
  meth_meth_ast_request_40_1_41_withArgs_40_1_41_10154->definitionLine = 2660;
  block_savedest(obj10142);
  Object closure10476 = createclosure(2, "request(1)withArgs(1)$object(1)");
  setclosureframe(closure10476, stackframe);
  addtoclosure(closure10476, var_requestPart);
  addtoclosure(closure10476, var_emptySeq);
  Method *meth_meth_ast_request_40_1_41_withArgs_40_1_41_10154_object = addmethod2pos(obj10142, "request(1)withArgs(1)$object(1)", &meth_ast_request_40_1_41_withArgs_40_1_41_10154_object, 3);
  meth_meth_ast_request_40_1_41_withArgs_40_1_41_10154_object->definitionModule = modulename;
  meth_meth_ast_request_40_1_41_withArgs_40_1_41_10154_object->definitionLine = 2660;
  sourceObject = obj10142;
  sourceObject = obj10142;
  sourceObject = obj10142;
  objclass10142 = obj10142->class;
  objclass10142->definitionModule = modulename;
  objclass10142->definitionLine = 2651;
  (*(struct UserObject *)self).data[0] = lowerouter10142;
  self = oldself10142;
  selfslot = oldselfslot10142;
  stackframe = oldstackframe10142;
// compiled object node returning obj10142 (depth = 2)
  *var_requestPart = obj10142;
  if (obj10142 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "requestPart"
  block_savedest(self);
  Object closure10477 = createclosure(1, "requestPart");
  setclosureframe(closure10477, stackframe);
  addtoclosure(closure10477, var_requestPart);
  struct UserObject *uo10477 = (struct UserObject*)self;
  uo10477->data[50] = (Object)closure10477;
  Method *meth_meth_ast_requestPart10477 = addmethod2pos(self, "requestPart", &meth_ast_requestPart10477, 50);
  int argcv_meth_ast_requestPart10477[] = {0};
  meth_meth_ast_requestPart10477->type = alloc_MethodType(1, argcv_meth_ast_requestPart10477);
  meth_meth_ast_requestPart10477->definitionModule = modulename;
  meth_meth_ast_requestPart10477->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2732
  setline(2732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2733
  setline(2733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject10478 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10478 = alloc_userobj2(2,4, objclass10478);
  gc_frame_newslot(obj10478);
if (objclass10478 == NULL) {
  glfree(obj10478->class->name);
  obj10478->class->name = "commentNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10478, self, 0);
  addmethodreal(obj10478,"outer", &reader_ast_outer_10479);
  Object oldself10478 = self;
  struct StackFrameObject *oldstackframe10478 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10478);
  gc_frame_newslot((Object)stackframe);
  self = obj10478;
  Object *oldselfslot10478 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10478 = (*(struct UserObject *)self).data[0], lowerouter10478 = thisouter10478;
  if (inheritingObject10478) {
    struct UserObject *inho10478 = (struct UserObject *)inheritingObject10478;
    while (inho10478->super != GraceDefaultObject) inho10478 = (struct UserObject *)inho10478->super;
    inho10478->super = obj10478;
    self = inheritingObject10478;
    *selfslot = self;
    lowerouter10478 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10478;
  }
// method "new(_)"
  block_savedest(obj10478);
  Object closure10480 = createclosure(4, "new(1)");
  setclosureframe(closure10480, stackframe);
  addtoclosure(closure10480, var_lineLength);
  addtoclosure(closure10480, var_nullNode);
  addtoclosure(closure10480, var_commentNode);
  addtoclosure(closure10480, var_util);
  struct UserObject *uo10480 = (struct UserObject*)obj10478;
  uo10480->data[1] = (Object)closure10480;
  Method *meth_meth_ast_new_40_1_41_10480 = addmethod2pos(obj10478, "new(1)", &meth_ast_new_40_1_41_10480, 1);
  int argcv_meth_ast_new_40_1_41_10480[] = {1};
  meth_meth_ast_new_40_1_41_10480->type = alloc_MethodType(1, argcv_meth_ast_new_40_1_41_10480);
  meth_meth_ast_new_40_1_41_10480->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_10480->definitionLine = 2734;
  block_savedest(obj10478);
  Object closure10682 = createclosure(4, "new(1)$object(1)");
  setclosureframe(closure10682, stackframe);
  addtoclosure(closure10682, var_lineLength);
  addtoclosure(closure10682, var_nullNode);
  addtoclosure(closure10682, var_commentNode);
  addtoclosure(closure10682, var_util);
  Method *meth_meth_ast_new_40_1_41_10480_object = addmethod2pos(obj10478, "new(1)$object(1)", &meth_ast_new_40_1_41_10480_object, 1);
  meth_meth_ast_new_40_1_41_10480_object->definitionModule = modulename;
  meth_meth_ast_new_40_1_41_10480_object->definitionLine = 2734;
  sourceObject = obj10478;
  objclass10478 = obj10478->class;
  objclass10478->definitionModule = modulename;
  objclass10478->definitionLine = 2733;
  (*(struct UserObject *)self).data[0] = lowerouter10478;
  self = oldself10478;
  selfslot = oldselfslot10478;
  stackframe = oldstackframe10478;
// compiled object node returning obj10478 (depth = 2)
  *var_commentNode = obj10478;
  if (obj10478 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "commentNode"
  block_savedest(self);
  Object closure10683 = createclosure(1, "commentNode");
  setclosureframe(closure10683, stackframe);
  addtoclosure(closure10683, var_commentNode);
  struct UserObject *uo10683 = (struct UserObject*)self;
  uo10683->data[51] = (Object)closure10683;
  Method *meth_meth_ast_commentNode10683 = addmethod2pos(self, "commentNode", &meth_ast_commentNode10683, 51);
  int argcv_meth_ast_commentNode10683[] = {0};
  meth_meth_ast_commentNode10683->type = alloc_MethodType(1, argcv_meth_ast_commentNode10683);
  meth_meth_ast_commentNode10683->definitionModule = modulename;
  meth_meth_ast_commentNode10683->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2788
  setline(2788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2822
  setline(2822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2823
  setline(2823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl ASTVisitor
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type10685 = alloc_Type("ASTVisitor", 30);
    add_Method((ClassData)type10685, "visitIf(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitBlock(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitMatchCase(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitTryCatch(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitMethodType(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitSignaturePart(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitTypeLiteral(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitTypeParameters(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitTypeDec(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitMethod(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitCall(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitObject(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitModule(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitArray(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitMember(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitGeneric(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitIdentifier(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitString(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitNum(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitOp(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitBind(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitDefDec(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitVarDec(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitImport(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitReturn(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitInherits(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitDialect(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitBlank(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitComment(1)up(1)", NULL);
    add_Method((ClassData)type10685, "visitImplicit(1)up(1)", NULL);
// compiled typeliteral node returning type10685 (depth = 2)
  *var_ASTVisitor = type10685;
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ASTVisitor"
  block_savedest(self);
  Object closure10686 = createclosure(1, "ASTVisitor");
  setclosureframe(closure10686, stackframe);
  addtoclosure(closure10686, var_ASTVisitor);
  struct UserObject *uo10686 = (struct UserObject*)self;
  uo10686->data[52] = (Object)closure10686;
  Method *meth_meth_ast_ASTVisitor10686 = addmethod2pos(self, "ASTVisitor", &meth_ast_ASTVisitor10686, 52);
  int argcv_meth_ast_ASTVisitor10686[] = {0};
  meth_meth_ast_ASTVisitor10686->type = alloc_MethodType(1, argcv_meth_ast_ASTVisitor10686);
  meth_meth_ast_ASTVisitor10686->definitionModule = modulename;
  meth_meth_ast_ASTVisitor10686->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 2855
  setline(2855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2921
  setline(2921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2962
  setline(2962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2963
  setline(2963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject10687 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10687 = alloc_userobj2(1,2, objclass10687);
  gc_frame_newslot(obj10687);
if (objclass10687 == NULL) {
  glfree(obj10687->class->name);
  obj10687->class->name = "patternMarkVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10687, self, 0);
  addmethodreal(obj10687,"outer", &reader_ast_outer_10688);
  Object oldself10687 = self;
  struct StackFrameObject *oldstackframe10687 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10687);
  gc_frame_newslot((Object)stackframe);
  self = obj10687;
  Object *oldselfslot10687 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10687 = (*(struct UserObject *)self).data[0], lowerouter10687 = thisouter10687;
  if (inheritingObject10687) {
    struct UserObject *inho10687 = (struct UserObject *)inheritingObject10687;
    while (inho10687->super != GraceDefaultObject) inho10687 = (struct UserObject *)inho10687->super;
    inho10687->super = obj10687;
    self = inheritingObject10687;
    *selfslot = self;
    lowerouter10687 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10687;
  }
// method "visitCall(_)up(_)"
  struct UserObject *uo10689 = (struct UserObject*)obj10687;
  uo10689->data[1] = emptyclosure;
  Method *meth_meth_ast_visitCall_40_1_41_up_40_1_41_10689 = addmethod2pos(obj10687, "visitCall(1)up(1)", &meth_ast_visitCall_40_1_41_up_40_1_41_10689, 1);
  int argcv_meth_ast_visitCall_40_1_41_up_40_1_41_10689[] = {1, 1};
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_10689->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40_1_41_up_40_1_41_10689);
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_10689->definitionModule = modulename;
  meth_meth_ast_visitCall_40_1_41_up_40_1_41_10689->definitionLine = 2965;
  sourceObject = obj10687;
// Begin line 2964
  setline(2964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10694 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe10695 = gc_frame_new();
// call case 3: self.outer request
  Object call10696 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10695);
// compiled member node returning call10696 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10697 = callmethodflags(call10696, "baseVisitor$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe10694);
// compiled call node returning call10697 (depth = 3)
  struct UserObject *obj10687_uo = (struct UserObject *)obj10687;
  obj10687_uo->super = call10697;
  sourceObject = obj10687;
  objclass10687 = obj10687->class;
  objclass10687->definitionModule = modulename;
  objclass10687->definitionLine = 2963;
  (*(struct UserObject *)self).data[0] = lowerouter10687;
  self = oldself10687;
  selfslot = oldselfslot10687;
  stackframe = oldstackframe10687;
// compiled object node returning obj10687 (depth = 2)
  *var_patternMarkVisitor = obj10687;
  if (obj10687 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "patternMarkVisitor"
  block_savedest(self);
  Object closure10698 = createclosure(1, "patternMarkVisitor");
  setclosureframe(closure10698, stackframe);
  addtoclosure(closure10698, var_patternMarkVisitor);
  struct UserObject *uo10698 = (struct UserObject*)self;
  uo10698->data[53] = (Object)closure10698;
  Method *meth_meth_ast_patternMarkVisitor10698 = addmethod2pos(self, "patternMarkVisitor", &meth_ast_patternMarkVisitor10698, 53);
  int argcv_meth_ast_patternMarkVisitor10698[] = {0};
  meth_meth_ast_patternMarkVisitor10698->type = alloc_MethodType(1, argcv_meth_ast_patternMarkVisitor10698);
  meth_meth_ast_patternMarkVisitor10698->definitionModule = modulename;
  meth_meth_ast_patternMarkVisitor10698->definitionLine = 2981;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2970
  setline(2970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
