#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "2e7432b299d4ba499027a17319654f4bcd9372c2";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "collectionsPrelude";
Object module_standardGrace_init();
static char *originalSourceLines[] = {
  "#pragma NativePrelude",
  "",
  "def BoundsError = ProgrammingError.refine \"BoundsError\"",
  "def IteratorExhausted = ProgrammingError.refine \"IteratorExhausted\"",
  "def SubobjectResponsibility = ProgrammingError.refine \"SubobjectResponsibility\"",
  "def NoSuchObject = ProgrammingError.refine \"NoSuchObject\"",
  "def RequestError = ProgrammingError.refine \"RequestError\"",
  "def ConcurrentModification = ProgrammingError.refine \"ConcurrentModification\"",
  "def SizeUnknown = Exception.refine \"SizeUnknown\"",
  "",
  "method abstract is confidential {",
  "    // copied from standardGrace",
  "    SubobjectResponsibility.raise \"abstract method not overriden by subobject\"",
  "}",
  "",
  "type Block0⟦R⟧ = type {",
  "    apply -> R",
  "}",
  "",
  "type Block1⟦T,R⟧ = type {",
  "    apply(a:T) -> R",
  "}",
  "",
  "type Block2⟦S,T,R⟧ = type {",
  "    apply(a:S, b:T) -> R",
  "}",
  "",
  "type SelfType = Unknown     // becuase it's not yet in the language",
  "",
  "type Iterable⟦T⟧ = Object & type {",
  "    iterator -> Iterator⟦T⟧",
  "        // the iterator on which I am based",
  "    isEmpty -> Boolean",
  "        // true if I have no elements",
  "    size -> Number",
  "        // my size (the number of elements that I contain);",
  "        // may raise SizeUnknown.",
  "    sizeIfUnknown(action: Block0⟦Number⟧)",
  "        // my size; if not known, then the result of applying action",
  "    first -> T",
  "        // my first element; raises BoundsError if I have none.",
  "    do(block1: Block1⟦T, Done⟧) -> Done",
  "        // an internal iterator; applies block1 to each of my elements",
  "    do(body:Block1⟦T, Done⟧) separatedBy(separator:Block0⟦Done⟧) -> Done",
  "        // an internal iterator; ; applies block1 to each of my elements, and applies separator in between",
  "    ++(other: Iterable⟦T⟧) -> Iterable⟦T⟧",
  "        // returns a new Iterable over the concatenation of self and other",
  "    fold(binaryFunction:Block2⟦T, T, T⟧) startingWith(initial:T) -> Object",
  "        // the left-associative fold of binaryFunction over self, starting with initial",
  "    map⟦U⟧(function:Block1⟦T, U⟧) -> Iterable⟦U⟧",
  "        // returns a new iterator that yields my elements mapped by function",
  "    filter(condition:Block1⟦T,Boolean⟧) -> Iterable⟦T⟧",
  "        // returns a new iterator that yields those of my elements for which condition holds",
  "}",
  "",
  "type Expandable⟦T⟧ = Iterable⟦T⟧ & type {",
  "    add(x: T) -> SelfType",
  "    addAll(xs: Iterable⟦T⟧) -> SelfType",
  "}",
  "",
  "type Collection⟦T⟧ = Iterable⟦T⟧ & type {",
  "    asList -> List⟦T⟧",
  "    asSequence -> Sequence⟦T⟧",
  "    asSet -> Set⟦T⟧",
  "}",
  "",
  "type Enumerable⟦T⟧ = Collection⟦T⟧ & type {",
  "    values -> Collection⟦T⟧",
  "    asDictionary -> Dictionary⟦Number,T⟧",
  "    keysAndValuesDo(action:Block2⟦Number,T,Object⟧) -> Done",
  "    into(existing: Expandable⟦Unknown⟧) -> Collection⟦Unknown⟧",
  "    sortedBy(comparison:Block2⟦T,T,Number⟧) -> SelfType",
  "    sorted -> SelfType",
  "}",
  "",
  "type Sequence⟦T⟧ = Enumerable⟦T⟧ & type {",
  "    size -> Number",
  "    at(n:Number) -> T",
  "    indices -> Sequence⟦Number⟧",
  "    keys -> Sequence⟦Number⟧",
  "    second -> T",
  "    third -> T",
  "    fourth -> T",
  "    fifth -> T",
  "    last -> T",
  "    indexOf⟦W⟧(elem:T)ifAbsent(action:Block0⟦W⟧) -> Number | W",
  "    indexOf(elem:T) -> Number",
  "    contains(elem:T) -> Boolean",
  "    reversed -> Sequence⟦T⟧",
  "}",
  "",
  "type List⟦T⟧ = Sequence⟦T⟧ & type {",
  "    add(x: T) -> List⟦T⟧",
  "    addAll(xs: Iterable⟦T⟧) -> List⟦T⟧",
  "    addFirst(x: T) -> List⟦T⟧",
  "    addAllFirst(xs: Iterable⟦T⟧) -> List⟦T⟧",
  "    addLast(x: T) -> List⟦T⟧    // same as add",
  "    at(ix:Number) put(v:T) -> List⟦T⟧",
  "    clear -> List⟦T⟧",
  "    removeFirst -> T",
  "    removeAt(n: Number) -> T",
  "    removeLast -> T",
  "    remove(v:T)",
  "    remove(v:T) ifAbsent(action:Block0⟦Done⟧)",
  "    removeAll(vs: Iterable⟦T⟧)",
  "    removeAll(vs: Iterable⟦T⟧) ifAbsent(action:Block0⟦Unknown⟧)",
  "    pop -> T",
  "    ++(o: List⟦T⟧) -> List⟦T⟧",
  "    addAll(l: Iterable⟦T⟧) -> List⟦T⟧",
  "    copy -> List⟦T⟧",
  "    sort -> List⟦T⟧",
  "    sortBy(sortBlock:Block2⟦T,T,Number⟧) -> List⟦T⟧",
  "    reverse -> List⟦T⟧",
  "    reversed -> List⟦T⟧",
  "}",
  "",
  "type Set⟦T⟧ = Collection⟦T⟧ & type {",
  "    size -> Number",
  "    add(x:T) -> SelfType",
  "    addAll(elements: Iterable⟦T⟧) -> SelfType",
  "    remove(x: T) -> Set⟦T⟧",
  "    remove(x: T) ifAbsent(block: Block0⟦Done⟧) -> Set⟦T⟧",
  "    clear -> Set⟦T⟧",
  "    includes(booleanBlock: Block1⟦T,Boolean⟧) -> Boolean",
  "    find(booleanBlock: Block1⟦T,Boolean⟧) ifNone(notFoundBlock: Block0⟦T⟧) -> T",
  "    copy -> Set⟦T⟧",
  "    contains(elem:T) -> Boolean",
  "    ** (other:Set⟦T⟧) -> Set⟦T⟧",
  "    -- (other:Set⟦T⟧) -> Set⟦T⟧",
  "    ++ (other:Set⟦T⟧) -> Set⟦T⟧",
  "    isSubset(s2: Set⟦T⟧) -> Boolean",
  "    isSuperset(s2: Iterable⟦T⟧) -> Boolean",
  "    removeAll(elems: Iterable⟦T⟧)",
  "    removeAll(elems: Iterable⟦T⟧)ifAbsent(action:Block0⟦Done⟧) -> Set⟦T⟧",
  "    into(existing: Expandable⟦Unknown⟧) -> Collection⟦Unknown⟧",
  "}",
  "",
  "type Dictionary⟦K,T⟧ = Collection⟦T⟧ & type {",
  "    size -> Number",
  "    containsKey(k:K) -> Boolean",
  "    containsValue(v:T) -> Boolean",
  "    contains(elem:T) -> Boolean",
  "    at(key:K)ifAbsent(action:Block0⟦Unknown⟧) -> Unknown",
  "    at(key:K)put(value:T) -> Dictionary⟦K,T⟧",
  "    at(k:K) -> T",
  "    removeAllKeys(keys: Iterable⟦K⟧) -> Dictionary⟦K,T⟧",
  "    removeKey(key:K) -> Dictionary⟦K,T⟧",
  "    removeAllValues(removals: Iterable⟦T⟧) -> Dictionary⟦K,T⟧",
  "    removeValue(v:T) -> Dictionary⟦K,T⟧",
  "    clear -> Dictionary⟦K,T⟧",
  "    keys -> Enumerable⟦K⟧",
  "    values -> Enumerable⟦T⟧",
  "    bindings -> Enumerable⟦Binding⟦K,T⟧⟧",
  "    keysAndValuesDo(action:Block2⟦K,T,Done⟧) -> Done",
  "    keysDo(action:Block1⟦K,Done⟧) -> Done",
  "    valuesDo(action:Block1⟦T,Done⟧) -> Done",
  "    == (other:Object) -> Boolean",
  "    copy -> Dictionary⟦K,T⟧",
  "    ++ (other:Dictionary⟦K, T⟧) -> Dictionary⟦K, T⟧",
  "    -- (other:Dictionary⟦K, T⟧) -> Dictionary⟦K, T⟧",
  "    asDictionary -> Dictionary⟦K, T⟧",
  "}",
  "",
  "type Iterator⟦T⟧ = type {",
  "    hasNext -> Boolean",
  "    next -> T",
  "}",
  "",
  "class lazySequenceOver⟦T,R⟧ (source: Iterable⟦T⟧)",
  "        mappedBy (function:Block1⟦T,R⟧) -> Enumerable⟦R⟧ is confidential {",
  "    inherits enumerable.TRAIT⟦T⟧",
  "    class iterator {",
  "        def sourceIterator = source.iterator",
  "        method asString { \"an iterator over a lazy map sequence\" }",
  "        method hasNext { sourceIterator.hasNext }",
  "        method next { function.apply(sourceIterator.next) }",
  "    }",
  "    method size { source.size }",
  "    method isEmpty { source.isEmpty }",
  "    method asDebugString { \"a lazy sequence mapping over {source}\" }",
  "}",
  "",
  "class lazySequenceOver⟦T⟧ (source: Iterable⟦T⟧)",
  "        filteredBy(predicate:Block1⟦T,Boolean⟧) -> Enumerable⟦T⟧ is confidential {",
  "    inherits enumerable.TRAIT⟦T⟧",
  "    class iterator {",
  "        var cache",
  "        var cacheLoaded := false",
  "        def sourceIterator = source.iterator",
  "        method asString { \"an iterator over filtered {source}\" }",
  "        method hasNext {",
  "        // To determine if this iterator has a next element, we have to find",
  "        // an acceptable element; this is then cached, for the use of next",
  "            if (cacheLoaded) then { true } else { hasNextAcceptableElement }",
  "        }",
  "        method next {",
  "            if (cacheLoaded.not) then { cache := nextAcceptableElement }",
  "            cacheLoaded := false",
  "            return cache",
  "        }",
  "        method nextAcceptableElement is confidential {",
  "        // return the next element of the underlying iterator satisfying",
  "        // predicate; if there is none, raises IteratorExhausted.",
  "            while { true } do {",
  "                def outerNext = sourceIterator.next",
  "                def isAcceptable = predicate.apply(outerNext)",
  "                if (isAcceptable) then { return outerNext }",
  "            }",
  "        }",
  "        method hasNextAcceptableElement is confidential {",
  "        // returns true is there is another element in the underlying iterator",
  "        // satisfying predicate, otherwise false",
  "            while { true } do {",
  "                if (sourceIterator.hasNext.not) then { return false }",
  "                def outerNext = sourceIterator.next",
  "                def isAcceptable = predicate.apply(outerNext)",
  "                if (isAcceptable) then {",
  "                    cacheLoaded := true",
  "                    cache := outerNext",
  "                    return true",
  "                }",
  "            }",
  "        }",
  "    }",
  "    method asDebugString { \"a lazy sequence filtering {source}\" }",
  "}",
  "",
  "class iteratorConcat⟦T⟧(left:Iterator⟦T⟧, right:Iterator⟦T⟧) {",
  "    method next {",
  "        if (left.hasNext) then {",
  "            left.next",
  "        } else {",
  "            right.next",
  "        }",
  "    }",
  "    method hasNext {",
  "        if (left.hasNext) then { return true }",
  "        return right.hasNext",
  "    }",
  "    method asDebugString { \"iteratorConcat of {left} and {right}\" }",
  "    method asString { \"an iterator over a concatenation\" }",
  "}",
  "class lazyConcatenation⟦T⟧(left, right) -> Enumerable⟦T⟧{",
  "    inherits enumerable.TRAIT⟦T⟧",
  "    method iterator {",
  "        iteratorConcat(left.iterator, right.iterator)",
  "    }",
  "    method asDebugString { \"lazy concatenation of {left} and {right}\" }",
  "    method asString { super.asString }",
  "    method size { left.size + right.size }  // may raise SizeUnknown",
  "}",
  "",
  "class collection.TRAIT⟦T⟧ {",
  "    ",
  "    method asString { \"a collection TRAIT\" }",
  "    method sizeIfUnknown(action) {",
  "        action.apply",
  "    }",
  "    method size {",
  "        SizeUnknown.raise \"this collection does not know its size\"",
  "    }",
  "    method do { abstract }",
  "    method iterator { abstract }",
  "    method isEmpty {",
  "        // override if size is known",
  "        iterator.hasNext.not",
  "    }",
  "    method first {",
  "        def it = self.iterator",
  "        if (it.hasNext) then { ",
  "            it.next",
  "        } else {",
  "            BoundsError.raise \"no first element in {self}\"",
  "        }",
  "    }",
  "    method do(block1) separatedBy(block0) {",
  "        var firstTime := true",
  "        var i := 0",
  "        self.do { each ->",
  "            if (firstTime) then {",
  "                firstTime := false",
  "            } else {",
  "                block0.apply",
  "            }",
  "            block1.apply(each)",
  "        }",
  "        return self",
  "    }",
  "    method reduce(initial, blk) {",
  "    // deprecated; for compatibility with builtInList",
  "        fold(blk)startingWith(initial)",
  "    }",
  "    method fold(blk)startingWith(initial) {",
  "        var result := initial",
  "        self.do {it ->",
  "            result := blk.apply(result, it)",
  "        }",
  "        return result",
  "    }",
  "    method map⟦R⟧(block1:Block1⟦T,R⟧) -> Enumerable⟦R⟧ {",
  "        lazySequenceOver(self) mappedBy(block1)",
  "    }",
  "    method filter(selectionCondition:Block1⟦T,Boolean⟧) -> Enumerable⟦T⟧ {",
  "        lazySequenceOver(self) filteredBy(selectionCondition)",
  "    }",
  "",
  "    method iter { self.iterator }",
  "",
  "    method asSequence {",
  "        sequence.withAll(self)",
  "    }",
  "    method asList {",
  "        list.withAll(self)",
  "    }",
  "    method asSet {",
  "        set.withAll(self)",
  "    }",
  "}",
  "",
  "class enumerable.TRAIT⟦T⟧ {",
  "    inherits collection.TRAIT⟦T⟧",
  "    method iterator { abstract }",
  "    method size {",
  "        // override if size is known",
  "        SizeUnknown.raise \"size requested on {asDebugString}\"",
  "    }",
  "    method asDictionary {",
  "        def result = dictionary.empty",
  "        keysAndValuesDo { k, v ->",
  "            result.at(k) put(v)",
  "        }",
  "        return result",
  "    }",
  "    method into(existing: Expandable⟦T⟧) -> Collection⟦T⟧ {",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            existing.add(selfIterator.next)",
  "        }",
  "        existing",
  "    }",
  "    method ==(other) {",
  "        isEqual (self) toIterable (other)",
  "    }",
  "    method do(block1:Block1⟦T,Done⟧) -> Done {",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            block1.apply(selfIterator.next)",
  "        }",
  "    }",
  "    method keysAndValuesDo(block2:Block2⟦Number,T,Done⟧) -> Done {",
  "        var ix := 0",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            ix := ix + 1",
  "            block2.apply(ix, selfIterator.next)",
  "        }",
  "    }",
  "    method values -> Collection⟦T⟧ {",
  "        self",
  "    }",
  "    method fold⟦R⟧(block2)startingWith(initial) -> R {",
  "        var res := initial",
  "        def selfIterator = self.iterator",
  "        while { selfIterator.hasNext } do {",
  "            res := block2.apply(res, selfIterator.next)",
  "        }",
  "        return res",
  "    }",
  "    method ++ (other) -> Enumerable⟦T⟧ {",
  "        lazyConcatenation(self, other)",
  "    }",
  "    method sortedBy(sortBlock:Block2) -> List⟦T⟧ {",
  "        self.asList.sortBy(sortBlock:Block2)",
  "    }",
  "    method sorted -> List⟦T⟧ {",
  "        self.asList.sort",
  "    }",
  "    method asString {",
  "        var s := \"⟨\"",
  "        do { each -> s := s ++ each.asString } separatedBy { s := s ++ \", \" }",
  "        s ++ \"⟩\"",
  "    }",
  "}",
  "",
  "class indexable.TRAIT⟦T⟧ {",
  "    inherits collection.TRAIT⟦T⟧",
  "    method at(index) { abstract }",
  "    method size { abstract }",
  "    method isEmpty { size == 0 }",
  "    method keysAndValuesDo(action:Block2⟦Number,T,Done⟧) -> Done {",
  "        def curSize = size",
  "        var i := 1",
  "        while {i <= curSize} do {",
  "            action.apply(i, self.at(i))",
  "            i := i + 1",
  "        }",
  "    }",
  "    method first { at(1) }",
  "    method second { at(2) }",
  "    method third { at(3) }",
  "    method fourth { at(4) }",
  "    method fifth { at(5) }",
  "    method last { at(size) }",
  "    method indices { range.from 1 to(size) }",
  "    method indexOf(sought:T)  {",
  "        indexOf(sought) ifAbsent { NoSuchObject.raise \"collection does not contain {sought}\" }",
  "    }",
  "    method indexOf(sought:T) ifAbsent(action:Block0)  {",
  "        keysAndValuesDo { ix, v ->",
  "            if (v == sought) then { return ix }",
  "        }",
  "        action.apply",
  "    }",
  "    method asDictionary {",
  "        def result = dictionary.empty",
  "        keysAndValuesDo { k, v ->",
  "            result.at(k) put(v)",
  "        }",
  "        return result",
  "    }",
  "    method into(existing: Expandable⟦T⟧) -> Collection⟦T⟧ {",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            existing.add(selfIterator.next)",
  "        }",
  "        existing",
  "    }",
  "}",
  "",
  "method max(a,b) is confidential {       // copied from standard prelude",
  "    if (a > b) then { a } else { b }",
  "}",
  "",
  "def emptySequence is confidential = object {",
  "    inherits indexable.TRAIT",
  "    method size { 0 }",
  "    method isEmpty { true }",
  "    method at(n) { BoundsError.raise \"index {n} of empty sequence\" }",
  "    method keys { self }",
  "    method values { self }",
  "    method keysAndValuesDo(block2) { done }",
  "    method reversed { self }",
  "    method ++(other: Iterable) { sequence.withAll(other) }",
  "    method asString { \"⟨⟩\" }",
  "    method contains(element) { false }",
  "    method do(block1) { done }",
  "    method ==(other) {",
  "        match (other)",
  "            case {o: Iterable ->",
  "                o.isEmpty",
  "            }",
  "            case {_ ->",
  "                false",
  "            }",
  "    }",
  "    class iterator {",
  "        method asString { \"emptySequenceIterator\" }",
  "        method hasNext { false }",
  "        method next { IteratorExhausted.raise \"on empty sequence\" }",
  "    }",
  "    method sorted { self }",
  "    method sortedBy(sortBlock:Block2){ self }",
  "}",
  "",
  "class sequence⟦T⟧ {",
  "",
  "    method asString { \"a sequence factory\" }",
  "",
  "    method empty {",
  "        // this is an optimization: there need be just one empty sequence",
  "        emptySequence",
  "    }",
  "",
  "    method withAll(arg: Iterable⟦T⟧) {",
  "        var sizeCertain := true",
  "        // size might be uncertain if arg is a lazy collection.",
  "        def forecastSize = arg.sizeIfUnknown {",
  "            sizeCertain := false",
  "            8",
  "        }",
  "        var inner := _prelude.primitiveArray.new(forecastSize)",
  "        var innerSize := inner.size",
  "        var ix := 0",
  "        if (sizeCertain) then {",
  "            // common, fast path",
  "            for (arg) do { elt ->",
  "                inner.at(ix)put(elt)",
  "                ix := ix + 1",
  "            }",
  "        } else {",
  "            // less-than-optimal path",
  "            for (arg) do { elt ->",
  "                if (innerSize <= ix) then {",
  "                    def newInner = _prelude.primitiveArray.new(innerSize * 2)",
  "                    for (0..(innerSize-1)) do { i ->",
  "                        newInner.at(i)put(inner.at(i))",
  "                    }",
  "                    inner := newInner",
  "                    innerSize := inner.size",
  "                }",
  "                inner.at(ix)put(elt)",
  "                ix := ix + 1",
  "            }",
  "        }",
  "        if (ix == 0) then { return emptySequence }",
  "        self.fromprimitiveArray(inner, ix)",
  "    }",
  "    method fromprimitiveArray(pArray, sz) is confidential {",
  "        // constructs a sequence from the first sz elements of pArray",
  "",
  "        object {",
  "            inherits indexable.TRAIT",
  "            def size is public = sz",
  "            def inner = pArray",
  "",
  "            method boundsCheck(n) is confidential {",
  "                if (!(n >= 1) || !(n <= size)) then {",
  "                    // the condition is written this way because NaN always",
  "                    // compares false",
  "                    BoundsError.raise \"index {n} out of bounds 1..{size}\"",
  "                }",
  "            }",
  "            method at(n) {",
  "                boundsCheck(n)",
  "                inner.at(n-1)",
  "            }",
  "            method keys {",
  "                range.from(1)to(size)",
  "            }",
  "            method values {",
  "                self",
  "            }",
  "            method keysAndValuesDo(block2) {",
  "                var i := 0",
  "                while {i < size} do {",
  "                    block2.apply(i+1, inner.at(i))",
  "                    i := i + 1",
  "                }",
  "            }",
  "            method reversed {",
  "                def freshArray = _prelude.primitiveArray.new(size)",
  "                var ix := size - 1",
  "                do { each ->",
  "                    freshArray.at (ix) put(each)",
  "                    ix := ix - 1",
  "                }",
  "                outer.fromprimitiveArray(freshArray, size)",
  "            }",
  "            method ++(other: Iterable) {",
  "                sequence.withAll(lazyConcatenation(self, other))",
  "            }",
  "            method asString {",
  "                var s := \"⟨\"",
  "                for (0..(size-1)) do {i->",
  "                    s := s ++ inner.at(i).asString",
  "                    if (i < (size-1)) then { s := s ++ \", \" }",
  "                }",
  "                s ++ \"⟩\"",
  "            }",
  "            method contains(element) {",
  "                do { each -> if (each == element) then { return true } }",
  "                return false",
  "            }",
  "            method do(block1) {",
  "                var i := 0",
  "                while {i < size} do {",
  "                    block1.apply(inner.at(i))",
  "                    i := i + 1",
  "                }",
  "            }",
  "            method ==(other) {",
  "                isEqual (self) toIterable (other)",
  "            }",
  "            method iterator {",
  "                object {",
  "                    var idx := 1",
  "                    method asDebugString { \"{asString}⟪{idx}⟫\" }",
  "                    method asString { \"aSequenceIterator\" }",
  "                    method hasNext { idx <= sz }",
  "                    method next {",
  "                        if (idx > sz) then { IteratorExhausted.raise \"on sequence {outer}⟪{idx}⟫\" }",
  "                        def ret = at(idx)",
  "                        idx := idx + 1",
  "                        ret",
  "                    }",
  "                }",
  "            }",
  "            method sorted {",
  "                asList.sortBy { l, r ->",
  "                    if (l == r) then {0}",
  "                        elseif {l < r} then {-1}",
  "                        else {1}",
  "                }.asSequence",
  "            }",
  "            method sortedBy(sortBlock:Block2){",
  "                asList.sortBy(sortBlock:Block2).asSequence",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "type MinimalyIterable = type {",
  "    iterator -> Iterator",
  "}",
  "",
  "method isEqual(left) toIterable(right) {",
  "    if (MinimalyIterable.match(right)) then {",
  "        def leftIter = left.iterator",
  "        def rightIter = right.iterator",
  "        while {leftIter.hasNext && rightIter.hasNext} do {",
  "            if (leftIter.next != rightIter.next) then {",
  "                return false",
  "            }",
  "        }",
  "        leftIter.hasNext == rightIter.hasNext",
  "    } else { ",
  "        false",
  "    }",
  "}",
  "",
  "class list⟦T⟧ {",
  "    ",
  "    method asString { \"a list factory\" }",
  "    ",
  "    method empty -> List⟦T⟧ {",
  "        withAll(emptySequence)",
  "    }",
  "",
  "    method withAll(a: Iterable⟦T⟧) -> List⟦T⟧ {",
  "        if (engine == \"js\") then {",
  "          if (native \"js\" code ‹result = (this === superDepth) ? GraceTrue : GraceFalse;›) then {",
  "            return object {",
  "                inherits indexable.TRAIT⟦T⟧",
  "",
  "                var mods is readable := 0",
  "                var sz := 0",
  "                var jsArray := native \"js\" code ‹result = [];›",
  "                a.do { each ->",
  "                    native \"js\" code ‹this.data.jsArray.push(var_each);›",
  "                }",
  "",
  "                method size {",
  "                    native \"js\" code ‹return new GraceNum(this.data.jsArray.length);›",
  "                    sz",
  "                }",
  "",
  "                method at(n) {",
  "                    native \"js\" code ‹var ix = var_n._value;",
  "                        if ( !(ix >= 1) || !(ix <= this.data.jsArray.length)) {",
  "                            var msg = \"index \" + ix + \" out of bounds 1..\" + this.data.jsArray.length;",
  "                            var BoundsError = callmethod(Grace_prelude, \"BoundsError\", [0]);",
  "                            callmethod(BoundsError, \"raise(1)\", [1], new GraceString(msg));",
  "                        }",
  "                        return this.data.jsArray[ix - 1];›",
  "                }",
  "",
  "                method at(n)put(x) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹var  ix = var_n._value;",
  "                        if (!(ix >= 1) || !(ix <= this.data.jsArray.length + 1)) {",
  "                            var msg = \"index \" + ix + \" out of bounds 1..\" + this.data.jsArray.length;",
  "                            var BoundsError = callmethod(Grace_prelude, \"BoundsError\", [0]);",
  "                            callmethod(BoundsError, \"raise(1)\", [1], new GraceString(msg));",
  "                        }",
  "                        this.data.jsArray[ix-1] = var_x;",
  "                        return this;›",
  "                }",
  "",
  "                method add(x:T) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹this.data.jsArray.push(var_x);",
  "                        return this;›",
  "                }",
  "",
  "                method push(x) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹this.data.jsArray.push(var_x);",
  "                        return this;›",
  "                }",
  "",
  "                method removeLast {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹if (this.data.jsArray.length === 0) {",
  "                        var msg = \"you can't remove an element from an empty list\";",
  "                        var BoundsError = callmethod(Grace_prelude, \"BoundsError\", [0]);",
  "                        callmethod(BoundsError, \"raise(1)\", [1], new GraceString(msg));",
  "                    } else",
  "                        return this.data.jsArray.pop();›",
  "                }",
  "                method clear {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹this.data.jsArray = [];",
  "                        return this;›",
  "                }",
  "                method addAllFirst(l) {",
  "                    mods := mods + 1",
  "                    var ix := l.size;",
  "                    while {ix > 0} do {",
  "                        def each = l.at(ix)",
  "                        ix := ix - 1",
  "                        native \"js\" code ‹this.data.jsArray.unshift(var_each);›",
  "                    }",
  "                    self",
  "                }",
  "",
  "                method removeAt(n) {",
  "                    mods := mods + 1",
  "                    def removed = self.at(n)    // does the bounds check",
  "                    native \"js\" code ‹this.data.jsArray.splice(var_n._value - 1, 1);›",
  "                    return removed",
  "                }",
  "",
  "                method sortBy(sortBlock:Block2) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹var compareFun = function compareFun(a, b) {",
  "                              var res = callmethod(var_sortBlock, \"apply(2)\", [2], a, b);",
  "                              if (res.className == \"number\") return res._value;",
  "                              throw new GraceExceptionPacket(TypeErrorObject,",
  "                                     new GraceString(\"sort block in list.sortBy method did not return a number\"));",
  "                          };",
  "                          this.data.jsArray.sort(compareFun);›",
  "                    self",
  "                }",
  "                // end of native methods",
  "",
  "",
  "                method addLast(x) { push(x) }    // compatibility",
  "                method addAll(l) {",
  "                    for (l) do { each -> push(each) }",
  "                    self",
  "                }",
  "",
  "                method addFirst(elem) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹this.data.jsArray.unshift(var_elem);›",
  "                    self",
  "                }                ",
  "",
  "                method removeFirst {",
  "                    removeAt(1)",
  "                }",
  "",
  "",
  "                method remove(elt:T) {",
  "                    def ix = self.indexOf(elt) ifAbsent {",
  "                        NoSuchObject.raise \"list does not contain object {elt}\"",
  "                    }",
  "                    removeAt(ix)",
  "                    self",
  "                }",
  "",
  "",
  "                method remove(elt:T) ifAbsent(action:Block0⟦Done⟧) {",
  "                    def ix = self.indexOf(elt) ifAbsent {",
  "                        return action.apply",
  "                    }",
  "                    removeAt(ix)",
  "                    self",
  "                }",
  "",
  "                method removeAll(vs: Iterable⟦T⟧) {",
  "                    removeAll(vs) ifAbsent { NoSuchObject.raise \"list does not contain object\" }",
  "                }",
  "",
  "",
  "                method removeAll(vs: Iterable⟦T⟧) ifAbsent(action:Block0⟦Unknown⟧)  {",
  "                    for (vs) do { each ->",
  "                        def ix = self.indexOf(each) ifAbsent { 0 }",
  "                        if (ix ≠ 0) then {",
  "                            removeAt(ix)",
  "                        } else {",
  "                            action.apply",
  "                        }",
  "                    }",
  "                    self",
  "                }",
  "",
  "                method pop { removeLast }",
  "",
  "                method reversed {",
  "                    def result = list.empty",
  "                    do { each -> result.addFirst(each) }",
  "                    result",
  "                }",
  "                method reverse {",
  "                    mods := mods + 1",
  "                    var hiIx := size",
  "                    var loIx := 1",
  "                    while {loIx < hiIx} do {",
  "                        def hiVal = self.at(hiIx)",
  "                        self.at(hiIx) put (self.at(loIx))",
  "                        self.at(loIx) put (hiVal)",
  "                        hiIx := hiIx - 1",
  "                        loIx := loIx + 1",
  "                    }",
  "                    self",
  "                }",
  "",
  "                method ++(o) {",
  "                    def l = list.withAll(self)",
  "                    l.addAll(o)",
  "                }",
  "",
  "",
  "                method asString {",
  "                    var s := \"[\"",
  "                    def curSize = self.size",
  "                    for (1..curSize) do { i ->",
  "                        s := s ++ at(i).asString",
  "                        if (i < curSize) then { s := s ++ \", \" }",
  "                    }",
  "                    s ++ \"]\"",
  "                }",
  "",
  "                method asDebugString {",
  "                    var s := \"[\"",
  "                    def curSize = self.size",
  "                    for (1..curSize) do { i ->",
  "                        s := s ++ at(i).asDebugString",
  "                        if (i < curSize) then { s := s ++ \", \" }",
  "                    }",
  "                    s ++ \"]\"",
  "                }",
  "",
  "                method extend(l) { addAll(l); done }    // compatibility",
  "",
  "",
  "                method contains(element) {",
  "                    do { each -> if (each == element) then { return true } }",
  "                    return false",
  "                }",
  "",
  "                method do(block1) {",
  "                    var i := 1",
  "                    def curSize = self.size",
  "                    while {i <= curSize} do {",
  "                        block1.apply(self.at(i))",
  "                        i := i + 1",
  "                    }",
  "                }",
  "",
  "                method ==(other) {",
  "                    isEqual (self) toIterable (other)",
  "                }",
  "",
  "                method iterator {",
  "                    object {",
  "                        var imods := mods",
  "                        var idx := 1",
  "                        method asDebugString { \"{asString}⟪{idx}⟫\" }",
  "                        method asString { \"aListIterator\" }",
  "                        method hasNext { idx <= size }",
  "                        method next {",
  "                            if (imods != mods) then {",
  "                                ConcurrentModification.raise (asDebugString)",
  "                            }",
  "                            if (idx > size) then { IteratorExhausted.raise \"on list\" }",
  "                            def ret = at(idx)",
  "                            idx := idx + 1",
  "                            ret",
  "                        }",
  "                    }",
  "                }",
  "",
  "                method values {",
  "                    self",
  "                }",
  "",
  "                method keys {",
  "                    self.indices",
  "                }",
  "",
  "                method sort {",
  "                    mods := mods + 1",
  "                    sortBy { l, r ->",
  "                        if (l == r) then {0}",
  "                            elseif {l < r} then {-1}",
  "                            else {1}",
  "                    }",
  "                }",
  "                method sortedBy(sortBlock:Block2) {",
  "                    copy.sortBy(sortBlock:Block2)",
  "                }",
  "                method sorted {",
  "                    copy.sort",
  "                }",
  "                method copy {",
  "                    outer.withAll(self)",
  "                }",
  "            }",
  "          }",
  "        }   // end of if (engine == \"js\") then ...",
  "",
  "        object {",
  "            // the new list object without native code",
  "            inherits indexable.TRAIT⟦T⟧",
  "",
  "            var mods is readable := 0",
  "            var sizeCertain := true",
  "            // size might be uncertain if a is a lazy collection.",
  "            def initialSize = a.sizeIfUnknown{ sizeCertain := false ; 4 } * 2 + 1",
  "            var inner := _prelude.primitiveArray.new(initialSize)",
  "            var size is readable := 0",
  "            if (sizeCertain) then {",
  "                // common, fast path",
  "                for (a) do { x ->",
  "                    inner.at(size)put(x)",
  "                    size := size + 1",
  "                }",
  "            } else {",
  "                // less-than-optimal path",
  "                var innerSize := initialSize",
  "                for (a) do { x ->",
  "                    if (innerSize <= size) then {",
  "                        def newInner = _prelude.primitiveArray.new(innerSize * 2)",
  "                        for (0..(innerSize-1)) do { i ->",
  "                            newInner.at (i) put (inner.at(i) )",
  "                        }",
  "                        inner := newInner",
  "                        innerSize := inner.size",
  "                    }",
  "                    inner.at(size)put(x)",
  "                    size := size + 1",
  "                }",
  "            }",
  "            method boundsCheck(n) is confidential {",
  "                if ( !(n >= 1) || !(n <= size)) then {",
  "                    BoundsError.raise \"index {n} out of bounds 1..{size}\"",
  "                }",
  "            }",
  "            method at(n) {",
  "                boundsCheck(n)",
  "                inner.at(n-1)",
  "            }",
  "            method at(n)put(x) {",
  "                mods := mods + 1",
  "                if (n == (size+1)) then {",
  "                    addLast(x)",
  "                } else {",
  "                    boundsCheck(n)",
  "                    inner.at(n-1)put(x)",
  "                }",
  "                self",
  "            }",
  "            method add(x) {",
  "                mods := mods + 1",
  "                if (size == inner.size) then { expandTo(inner.size * 2) }",
  "                inner.at(size)put(x)",
  "                size := size + 1",
  "                self",
  "            }",
  "            method addAll(l) {",
  "                mods := mods + 1",
  "                if ((size + l.size) > inner.size) then {",
  "                    expandTo(max(size + l.size, size * 2))",
  "                }",
  "                for (l) do {each ->",
  "                    inner.at(size)put(each)",
  "                    size := size + 1",
  "                }",
  "                self",
  "            }",
  "            method push(x) {",
  "                mods := mods + 1",
  "                if (size == inner.size) then { expandTo(inner.size * 2) }",
  "                inner.at(size)put(x)",
  "                size := size + 1",
  "                self",
  "            }",
  "            method addLast(x) { push(x) }    // compatibility",
  "            method removeLast {",
  "                mods := mods + 1",
  "                def result = inner.at(size - 1)",
  "                size := size - 1",
  "                result",
  "            }",
  "            method addAllFirst(l) {",
  "                mods := mods + 1",
  "                def increase = l.size",
  "                if ((size + increase) > inner.size) then {",
  "                    expandTo(max(size + increase, size * 2))",
  "                }",
  "                for (range.from(size-1)downTo(0)) do {i->",
  "                    inner.at(i+increase)put(inner.at(i))",
  "                }",
  "                var insertionIndex := 0",
  "                for (l) do {each ->",
  "                    inner.at(insertionIndex)put(each)",
  "                    insertionIndex := insertionIndex + 1",
  "                }",
  "                size := size + increase",
  "                self",
  "            }",
  "            method addFirst(elt:T) {",
  "                mods := mods + 1",
  "                if ((size + 1) > inner.size) then {",
  "                    expandTo(size * 2)",
  "                }",
  "                for (range.from (size-1) downTo 0) do {i->",
  "                    inner.at (i+1) put (inner.at(i) )",
  "                }",
  "                inner.at(0)put(elt)",
  "                size := size + 1",
  "                self",
  "            }",
  "            method clear {",
  "                mods := mods + 1",
  "                inner := _prelude.primitiveArray.new(initialSize)",
  "                size := 0",
  "                self",
  "            }",
  "            method removeFirst {",
  "                removeAt(1)",
  "            }",
  "            method removeAt(n) {",
  "                mods := mods + 1",
  "                boundsCheck(n)",
  "                def removed = inner.at(n-1)",
  "                for (n..(size-1)) do {i->",
  "                    inner.at(i-1)put(inner.at(i))",
  "                }",
  "                size := size - 1",
  "                return removed",
  "            }",
  "",
  "            method remove(elt:T) {",
  "                def ix = self.indexOf(elt) ifAbsent {",
  "                    NoSuchObject.raise \"list does not contain {elt}\"",
  "                }",
  "                removeAt(ix)",
  "                self",
  "            }",
  "",
  "            method remove(elt:T) ifAbsent(action:Block0⟦Done⟧) {",
  "                def ix = self.indexOf(elt) ifAbsent {",
  "                    action.apply",
  "                    return self",
  "                }",
  "                removeAt(ix)",
  "                self",
  "            }",
  "",
  "            method removeAll(vs: Iterable⟦T⟧) {",
  "                removeAll(vs) ifAbsent { NoSuchObject.raise \"list does not contain object\" }",
  "                self",
  "            }",
  "            method removeAll(vs: Iterable⟦T⟧) ifAbsent(action:Block0⟦Done⟧)  {",
  "                for (vs) do { each ->",
  "                    def ix = indexOf(each) ifAbsent { 0 }",
  "                    if (ix ≠ 0) then {",
  "                        removeAt(ix)",
  "                    } else {",
  "                        action.apply",
  "                    }",
  "                }",
  "                self",
  "            }",
  "            method pop { removeLast }",
  "            method reversed {",
  "                def result = list.empty",
  "                do { each -> result.addFirst(each) }",
  "                result",
  "            }",
  "            method reverse {",
  "                mods := mods + 1",
  "                var hiIx := size",
  "                var loIx := 1",
  "                while {loIx < hiIx} do {",
  "                    def hiVal = self.at(hiIx)",
  "                    self.at(hiIx) put (self.at(loIx))",
  "                    self.at(loIx) put (hiVal)",
  "                    hiIx := hiIx - 1",
  "                    loIx := loIx + 1",
  "                }",
  "                self",
  "            }",
  "            method ++(o) {",
  "                def l = list.withAll(self)",
  "                l.addAll(o)",
  "            }",
  "            method asString {",
  "                var s := \"[\"",
  "                for (0..(size-1)) do {i->",
  "                    s := s ++ inner.at(i).asString",
  "                    if (i < (size-1)) then { s := s ++ \", \" }",
  "                }",
  "                s ++ \"]\"",
  "            }",
  "            method asDebugString {",
  "                var s := \"[\"",
  "                for (0..(size-1)) do {i->",
  "                    s := s ++ inner.at(i).asDebugString",
  "                    if (i < (size-1)) then { s := s ++ \", \" }",
  "                }",
  "                s ++ \"]\"",
  "            }",
  "            method contains(element) {",
  "                do { each -> if (each == element) then { return true } }",
  "                return false",
  "            }",
  "            method do(block1) {",
  "                var i := 0",
  "                while {i < size} do {",
  "                    block1.apply(inner.at(i))",
  "                    i := i + 1",
  "                }",
  "            }",
  "",
  "            method ==(other) {",
  "                isEqual (self) toIterable (other)",
  "            }",
  "            method iterator {",
  "                object {",
  "                    var imods := mods",
  "                    var idx := 1",
  "                    method asDebugString { \"{asString}⟪{idx}⟫\" }",
  "                    method asString { \"aListIterator\" }",
  "                    method hasNext { idx <= size }",
  "                    method next {",
  "                        if (imods != mods) then {",
  "                            ConcurrentModification.raise (asDebugString)",
  "                        }",
  "                        if (idx > size) then { IteratorExhausted.raise \"on list\" }",
  "                        def ret = at(idx)",
  "                        idx := idx + 1",
  "                        ret",
  "                    }",
  "                }",
  "            }",
  "            method values {",
  "                self",
  "            }",
  "            method keys {",
  "                self.indices",
  "            }",
  "            method expandTo(newSize) is confidential {",
  "                def newInner = _prelude.primitiveArray.new(newSize)",
  "                for (0..(size-1)) do {i->",
  "                    newInner.at(i)put(inner.at(i))",
  "                }",
  "                inner := newInner",
  "            }",
  "            method sortBy(sortBlock:Block2) {",
  "                mods := mods + 1",
  "                inner.sortInitial(size) by(sortBlock)",
  "                self",
  "            }",
  "            method sort {",
  "                sortBy { l, r ->",
  "                    if (l == r) then {0}",
  "                        elseif {l < r} then {-1}",
  "                        else {1}",
  "                }",
  "            }",
  "            method sortedBy(sortBlock:Block2) {",
  "                copy.sortBy(sortBlock:Block2)",
  "            }",
  "            method sorted {",
  "                copy.sort",
  "            }",
  "            method copy {",
  "                outer.withAll(self)",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "",
  "def unused = object {",
  "    var unused := true",
  "    def key is public = self",
  "    def value is public = self",
  "    method asString { \"unused\" }",
  "    method == (other) { self.isMe(other) }",
  "}",
  "",
  "def removed = object {",
  "    var removed := true",
  "    def key is public = self",
  "    def value is public = self",
  "    method asString { \"removed\" }",
  "    method == (other) { self.isMe(other) }",
  "}",
  "",
  "class set⟦T⟧ {",
  "",
  "    method asString { \"a set factory\" }",
  "",
  "    method withAll(a: Iterable⟦T⟧) -> Set⟦T⟧ {",
  "        def cap = max (a.sizeIfUnknown{2} * 3 + 1, 8)",
  "        def result = ofCapacity (cap)",
  "        a.do { x -> result.add(x) }",
  "        result",
  "    }",
  "    ",
  "    method empty -> Set⟦T⟧ {",
  "        ofCapacity 8",
  "    }",
  "",
  "    class ofCapacity(cap) -> Set⟦T⟧ is confidential {",
  "        inherits collection.TRAIT",
  "        var mods is readable := 0",
  "        var inner := _prelude.primitiveArray.new(cap)",
  "        var size is readable := 0",
  "        (0..(cap - 1)).do { i ->",
  "            inner.at (i) put (unused)",
  "        }",
  "",
  "        method addAll(elements) {",
  "            mods := mods + 1",
  "            for (elements) do { x ->",
  "                if (! contains(x)) then {",
  "                    def t = findPositionForAdd(x)",
  "                    inner.at(t)put(x)",
  "                    size := size + 1",
  "                    if (size > (inner.size / 2)) then {",
  "                        expand",
  "                    }",
  "                }",
  "            }",
  "            self    // for chaining",
  "        }",
  "",
  "        method add(x:T) {",
  "            if (! contains(x)) then {",
  "                mods := mods + 1",
  "                def t = findPositionForAdd(x)",
  "                inner.at(t)put(x)",
  "                size := size + 1",
  "                if (size > (inner.size / 2)) then {",
  "                    expand",
  "                }",
  "            }",
  "            self    // for chaining",
  "        }",
  "",
  "        method removeAll(elements) {",
  "            for (elements) do { x ->",
  "                remove (x) ifAbsent {",
  "                    NoSuchObject.raise \"set does not contain {x}\"",
  "                }",
  "            }",
  "            self    // for chaining",
  "        }",
  "        method removeAll(elements)ifAbsent(block:Block1⟦T,Done⟧) {",
  "            mods := mods + 1",
  "            for (elements) do { x ->",
  "                var t := findPosition(x)",
  "                if (inner.at(t) == x) then {",
  "                    inner.at(t) put (removed)",
  "                    size := size - 1",
  "                } else {",
  "                    block.apply(x)",
  "                }",
  "            }",
  "            self    // for chaining",
  "        }",
  "        method clear {",
  "            mods := mods + 1",
  "            inner := _prelude.primitiveArray.new(cap)",
  "            size := 0",
  "            self",
  "        }",
  "",
  "        method remove (elt:T) ifAbsent (block) {",
  "            var t := findPosition(elt)",
  "            if (inner.at(t) == elt) then {",
  "                inner.at(t) put (removed)",
  "                mods := mods + 1",
  "                size := size - 1",
  "            } else {",
  "                block.apply",
  "            }",
  "            self    // for chaining",
  "        }",
  "",
  "        method remove(elt:T) {",
  "            remove (elt) ifAbsent {",
  "                NoSuchObject.raise \"set does not contain {elt}\"",
  "            }",
  "            self    // for chaining",
  "        }",
  "",
  "        method contains(x) {",
  "            var t := findPosition(x)",
  "            if (inner.at(t) == x) then {",
  "                return true",
  "            }",
  "            return false",
  "        }",
  "        method includes(booleanBlock) {",
  "            self.do { each ->",
  "                if (booleanBlock.apply(each)) then { return true }",
  "            }",
  "            return false",
  "        }",
  "        method find(booleanBlock)ifNone(notFoundBlock) {",
  "            self.do { each ->",
  "                if (booleanBlock.apply(each)) then { return each }",
  "            }",
  "            return notFoundBlock.apply",
  "        }",
  "        method findPosition(x) is confidential {",
  "            def h = x.hash",
  "            def s = inner.size",
  "            var t := h % s",
  "            var jump := 5",
  "            var candidate",
  "            while {",
  "                candidate := inner.at(t)",
  "                unused ≠ candidate",
  "            } do {",
  "                if (candidate == x) then {",
  "                    return t",
  "                }",
  "                if (jump != 0) then {",
  "                    t := (t * 3 + 1) % s",
  "                    jump := jump - 1",
  "                } else {",
  "                    t := (t + 1) % s",
  "                }",
  "            }",
  "            return t",
  "        }",
  "        method findPositionForAdd(x) is confidential {",
  "            def h = x.hash",
  "            def s = inner.size",
  "            var t := h % s",
  "            var jump := 5",
  "            var candidate",
  "            while {",
  "                candidate := inner.at(t)",
  "                (unused != candidate) && (removed != candidate)",
  "            } do {",
  "                if (candidate == x) then {",
  "                    return t",
  "                }",
  "                if (jump != 0) then {",
  "                    t := (t * 3 + 1) % s",
  "                    jump := jump - 1",
  "                } else {",
  "                    t := (t + 1) % s",
  "                }",
  "            }",
  "            return t",
  "        }",
  "",
  "        method asString {",
  "            var s := \"set\\{\"",
  "            do {each -> s := s ++ each.asString }",
  "                separatedBy { s := s ++ \", \" }",
  "            s ++ \"\\}\"",
  "        }",
  "        method asDebugString {",
  "            var s := \"set\\{\"",
  "            do {each -> s := s ++ each.asDebugString }",
  "                separatedBy { s := s ++ \", \" }",
  "            s ++ \"\\}\"",
  "        }",
  "        method extend(l) {",
  "            for (l) do {i->",
  "                add(i)",
  "            }",
  "        }",
  "        method do(block1) {",
  "            var i := 0",
  "            var found := 0",
  "            var candidate",
  "            while {found < size} do {",
  "                candidate := inner.at(i)",
  "                if ((unused != candidate) && (removed != candidate)) then {",
  "                    found := found + 1",
  "                    block1.apply(candidate)",
  "                }",
  "                i := i + 1",
  "            }",
  "        }",
  "        method iterator {",
  "            object {",
  "                var imods:Number := mods",
  "                var count := 1",
  "                var idx := -1",
  "                method hasNext { size >= count }",
  "                method next {",
  "                    var candidate",
  "                    def innerSize = inner.size",
  "                    while {",
  "                        idx := idx + 1",
  "                        if (imods != mods) then {",
  "                            ConcurrentModification.raise (outer.asString)",
  "                        }",
  "                        if (idx >= innerSize) then {",
  "                            IteratorExhausted.raise \"iterator over {outer.asString}\"",
  "                        }",
  "                        candidate := inner.at(idx)",
  "                        (unused == candidate) || (removed == candidate)",
  "                    } do { }",
  "                    count := count + 1",
  "                    candidate",
  "                }",
  "            }",
  "        }",
  "",
  "        method expand is confidential {",
  "            def c = inner.size",
  "            def n = c * 2",
  "            def oldInner = inner",
  "            size := 0",
  "            inner := _prelude.primitiveArray.new(n)",
  "            for (0..(inner.size-1)) do {i->",
  "                inner.at(i)put(unused)",
  "            }",
  "            for (0..(oldInner.size-1)) do {i->",
  "                if ((unused != oldInner.at(i)) && (removed != oldInner.at(i))) then {",
  "                    add(oldInner.at(i))",
  "                }",
  "            }",
  "        }",
  "        method ==(other) {",
  "            if (Iterable.match(other)) then {",
  "                var otherSize := 0",
  "                other.do { each ->",
  "                    otherSize := otherSize + 1",
  "                    if (! self.contains(each)) then {",
  "                        return false",
  "                    }",
  "                }",
  "                otherSize == self.size",
  "            } else { ",
  "                false",
  "            }",
  "        }",
  "        method copy {",
  "            outer.withAll(self)",
  "        }",
  "        method ++ (other) {",
  "        // set union",
  "            copy.addAll(other)",
  "        }",
  "        method -- (other) {",
  "        // set difference",
  "            def result = set.empty",
  "            for (self) do {v->",
  "                if (!other.contains(v)) then {",
  "                    result.add(v)",
  "                }",
  "            }",
  "            result",
  "        }",
  "        method ** (other) {",
  "        // set intersection",
  "            (filter {each -> other.contains(each)}).asSet",
  "        }",
  "        method isSubset(s2: Set⟦T⟧) {",
  "            self.do{ each ->",
  "                if (s2.contains(each).not) then { return false }",
  "            }",
  "            return true",
  "        }",
  "",
  "        method isSuperset(s2: Iterable⟦T⟧) {",
  "            s2.do{ each ->",
  "                if (self.contains(each).not) then { return false }",
  "            }",
  "            return true",
  "        }",
  "        method into(existing: Expandable⟦T⟧) -> Collection⟦T⟧ {",
  "            do { each -> existing.add(each) }",
  "            existing",
  "        }",
  "    }",
  "}",
  "",
  "type Binding⟦K,T⟧ = {",
  "    key -> K",
  "    value -> T",
  "    hash -> Number",
  "    ==(other) -> Boolean",
  "}",
  "",
  "def binding = object {",
  "    method asString { \"binding class\" }",
  "",
  "    class key(k)value(v) {",
  "        method key {k}",
  "        method value {v}",
  "        method asString { \"{k}::{v}\" }",
  "        method hashcode { (k.hashcode * 1021) + v.hashcode }",
  "        method hash { (k.hash * 1021) + v.hash }",
  "        method == (other) {",
  "            match (other)",
  "                case {o:Binding -> (k == o.key) && (v == o.value) }",
  "                case {_ -> return false }",
  "        }",
  "    }",
  "}",
  "",
  "type ComparableToDictionary⟦K,T⟧ = type {",
  "    size -> Number",
  "    at(_:K)ifAbsent(_) -> T",
  "}",
  "",
  "class dictionary⟦K,T⟧ {",
  "",
  "    method asString { \"a dictionary factory\" }",
  "",
  "    method withAll(initialBindings: Iterable⟦Binding⟦K,T⟧⟧) -> Dictionary⟦K,T⟧ {",
  "        def result = empty",
  "        for (initialBindings) do { b -> result.add(b) }",
  "        result",
  "    }",
  "",
  "    class empty -> Dictionary⟦K,T⟧ {",
  "        inherits collection.TRAIT⟦T⟧",
  "        var mods is readable := 0",
  "        var numBindings := 0",
  "        var inner := _prelude.primitiveArray.new(8)",
  "        for (0..(inner.size-1)) do { i ->",
  "            inner.at(i)put(unused)",
  "        }",
  "        method size { numBindings }",
  "        method at(key')put(value') {",
  "            mods := mods + 1",
  "            var t := findPositionForAdd(key')",
  "            if ((unused == inner.at(t)) || (removed == inner.at(t))) then {",
  "                numBindings := numBindings + 1",
  "            }",
  "            inner.at(t)put(binding.key(key')value(value'))",
  "            if ((size * 2) > inner.size) then { expand }",
  "            self    // for chaining",
  "        }",
  "        method add(aBinding) {",
  "            mods := mods + 1",
  "            var t := findPositionForAdd (aBinding.key)",
  "            if ((unused == inner.at(t)) || (removed == inner.at(t))) then {",
  "                numBindings := numBindings + 1",
  "            }",
  "            inner.at(t)put(aBinding)",
  "            if ((size * 2) > inner.size) then { expand }",
  "            self    // for chaining",
  "        }",
  "        method at(k) {",
  "            var b := inner.at(findPosition(k))",
  "            if (b.key == k) then {",
  "                return b.value",
  "            }",
  "            NoSuchObject.raise \"dictionary does not contain entry with key {k}\"",
  "        }",
  "        method at(k) ifAbsent(action) {",
  "            var b := inner.at(findPosition(k))",
  "            if (b.key == k) then {",
  "                return b.value",
  "            }",
  "            action.apply",
  "        }",
  "        method containsKey(k) {",
  "            var t := findPosition(k)",
  "            if (inner.at(t).key == k) then {",
  "                return true",
  "            }",
  "            false",
  "        }",
  "        method removeAllKeys(keys) {",
  "            mods := mods + 1",
  "            for (keys) do { k ->",
  "                var t := findPosition(k)",
  "                if (inner.at(t).key == k) then {",
  "                    inner.at(t)put(removed)",
  "                    numBindings := numBindings - 1",
  "                } else {",
  "                    NoSuchObject.raise \"dictionary does not contain entry with key {k}\"",
  "                }",
  "            }",
  "            self",
  "        }",
  "        method removeKey(k:K) {",
  "            mods := mods + 1",
  "            var t := findPosition(k)",
  "            if (inner.at(t).key == k) then {",
  "                inner.at(t)put(removed)",
  "                numBindings := numBindings - 1",
  "            } else {",
  "                NoSuchObject.raise \"dictionary does not contain entry with key {k}\"",
  "            }",
  "            self",
  "        }",
  "        method removeAllValues(removals) {",
  "            mods := mods + 1",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if (removals.contains(a.value)) then {",
  "                    inner.at(i)put(removed)",
  "                    numBindings := numBindings - 1",
  "                }",
  "            }",
  "            self",
  "        }",
  "        method removeValue(v) {",
  "            // remove all bindings with value v",
  "            mods := mods + 1",
  "            def initialNumBindings = numBindings",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if (v == a.value) then {",
  "                    inner.at (i) put (removed)",
  "                    numBindings := numBindings - 1",
  "                }",
  "            }",
  "            if (numBindings == initialNumBindings) then {",
  "                NoSuchObject.raise \"dictionary does not contain entry with value {v}\"",
  "            }",
  "            self",
  "        }",
  "        method removeValue(v) ifAbsent (action:Block0⟦Unknown⟧) {",
  "            // remove all bindings with value v",
  "            mods := mods + 1",
  "            def initialNumBindings = numBindings",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if (v == a.value) then {",
  "                    inner.at (i) put (removed)",
  "                    numBindings := numBindings - 1",
  "                }",
  "            }",
  "            if (numBindings == initialNumBindings) then {",
  "                action.apply",
  "            }",
  "            self",
  "        }",
  "        method clear {",
  "            inner := _prelude.primitiveArray.new(8)",
  "            numBindings := 0",
  "            mods := mods + 1",
  "            for (0..(inner.size-1)) do { i ->",
  "                inner.at(i)put(unused)",
  "            }",
  "            self",
  "        }",
  "        method containsValue(v) {",
  "            self.valuesDo{ each ->",
  "                if (v == each) then { return true }",
  "            }",
  "            false",
  "        }",
  "        method contains(v) { containsValue(v) }",
  "",
  "        method findPosition(x) is confidential {",
  "            def h = x.hash",
  "            def s = inner.size",
  "            var t := h % s",
  "            var jump := 5",
  "            while { unused ≠ inner.at(t) } do {",
  "                if (inner.at(t).key == x) then {",
  "                    return t",
  "                }",
  "                if (jump != 0) then {",
  "                    t := (t * 3 + 1) % s",
  "                    jump := jump - 1",
  "                } else {",
  "                    t := (t + 1) % s",
  "                }",
  "            }",
  "            return t",
  "        }",
  "        method findPositionForAdd(x) is confidential {",
  "            def h = x.hash",
  "            def s = inner.size",
  "            var t := h % s",
  "            var jump := 5",
  "            while { (unused ≠ inner.at(t)) && (removed ≠ inner.at(t)) } do {",
  "                if (inner.at(t).key == x) then {",
  "                    return t",
  "                }",
  "                if (jump != 0) then {",
  "                    t := (t * 3 + 1) % s",
  "                    jump := jump - 1",
  "                } else {",
  "                    t := (t + 1) % s",
  "                }",
  "            }",
  "            return t",
  "        }",
  "        method asString {",
  "            // do()separatedBy won't work, because it iterates over values,",
  "            // and we need an iterator over bindings.",
  "            var s := \"dict⟬\"",
  "            var firstElement := true",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    if (! firstElement) then {",
  "                        s := s ++ \", \"",
  "                    } else {",
  "                        firstElement := false",
  "                    }",
  "                    s := s ++ \"{a.key}::{a.value}\"",
  "                }",
  "            }",
  "            s ++ \"⟭\"",
  "        }",
  "        method asDebugString {",
  "            var s := \"dict⟬\"",
  "            for (0..(inner.size-1)) do {i->",
  "                if (i > 0) then { s := s ++ \", \" }",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    s := s ++ \"{i}→{a.key}::{a.value}\"",
  "                } else {",
  "                    s := s ++ \"{i}→{a.asDebugString}\"",
  "                }",
  "            }",
  "            s ++ \"⟭\"",
  "        }",
  "        method keys -> Enumerable⟦K⟧ {",
  "            def sourceDictionary = self",
  "            object {",
  "                inherits enumerable.TRAIT⟦K⟧",
  "                class iterator {",
  "                    def sourceIterator = sourceDictionary.bindingsIterator",
  "                    method hasNext { sourceIterator.hasNext }",
  "                    method next { sourceIterator.next.key }",
  "                    method asString {",
  "                        \"an iterator over keys of {sourceDictionary}\"",
  "                    }",
  "                }",
  "                def size is public = sourceDictionary.size",
  "                method asDebugString {",
  "                    \"a lazy sequence over keys of {sourceDictionary}\"",
  "                }",
  "            }",
  "        }",
  "        method values -> Enumerable⟦T⟧ {",
  "            def sourceDictionary = self",
  "            object {",
  "                inherits enumerable.TRAIT⟦T⟧",
  "                class iterator {",
  "                    def sourceIterator = sourceDictionary.bindingsIterator",
  "                    // should be request on outer",
  "                    method hasNext { sourceIterator.hasNext }",
  "                    method next { sourceIterator.next.value }",
  "                    method asString {",
  "                        \"an iterator over values of {sourceDictionary}\"",
  "                    }",
  "                }",
  "                def size is public = sourceDictionary.size",
  "                method asDebugString {",
  "                    \"a lazy sequence over values of {sourceDictionary}\"",
  "                }",
  "            }",
  "        }",
  "        method bindings -> Enumerable⟦T⟧ {",
  "            def sourceDictionary = self",
  "            object {",
  "                inherits enumerable.TRAIT⟦T⟧",
  "                method iterator { sourceDictionary.bindingsIterator }",
  "                // should be request on outer",
  "                def size is public = sourceDictionary.size",
  "                method asDebugString {",
  "                    \"a lazy sequence over bindings of {sourceDictionary}\"",
  "                }",
  "            }",
  "        }",
  "        method iterator -> Iterator⟦T⟧ { values.iterator }",
  "        class bindingsIterator -> Iterator⟦Binding⟦K, T⟧⟧ {",
  "            // this should be confidential, but can't be until `outer` is fixed.",
  "            def imods:Number = mods",
  "            var count := 1",
  "            var idx := 0",
  "            var elt",
  "            method hasNext { size >= count }",
  "            method next {",
  "                if (imods != mods) then {",
  "                    ConcurrentModification.raise (outer.asString)",
  "                }",
  "                if (size < count) then { IteratorExhausted.raise \"over {outer.asString}\" }",
  "                while {",
  "                    elt := inner.at(idx)",
  "                    (unused == elt) || (removed == elt)",
  "                } do {",
  "                    idx := idx + 1",
  "                }",
  "                count := count + 1",
  "                idx := idx + 1",
  "                elt",
  "            }",
  "        }",
  "        method expand is confidential {",
  "            def c = inner.size",
  "            def n = c * 2",
  "            def oldInner = inner",
  "            inner := _prelude.primitiveArray.new(n)",
  "            for (0..(n - 1)) do {i->",
  "                inner.at(i)put(unused)",
  "            }",
  "            numBindings := 0",
  "            for (0..(c - 1)) do {i->",
  "                def a = oldInner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    self.at(a.key)put(a.value)",
  "                }",
  "            }",
  "        }",
  "        method keysAndValuesDo(block2) {",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    block2.apply(a.key, a.value)",
  "                }",
  "            }",
  "        }",
  "        method keysDo(block1) {",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    block1.apply(a.key)",
  "                }",
  "            }",
  "        }",
  "        method valuesDo(block1) {",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    block1.apply(a.value)",
  "                }",
  "            }",
  "        }",
  "        method do(block1) { valuesDo(block1) }",
  "",
  "        method ==(other) {",
  "            match (other)",
  "                case {o:ComparableToDictionary⟦K,V⟧ ->",
  "                    if (self.size != o.size) then {return false}",
  "                    self.keysAndValuesDo { k, v ->",
  "                        if (o.at(k)ifAbsent{return false} != v) then {",
  "                            return false",
  "                        }",
  "                    }",
  "                    return true",
  "                }",
  "                case {_ ->",
  "                    return false",
  "                }",
  "        }",
  "",
  "        method copy {",
  "            def newCopy = dictionary.empty",
  "            self.keysAndValuesDo{ k, v ->",
  "                newCopy.at(k)put(v)",
  "            }",
  "            newCopy",
  "        }",
  "",
  "        method asDictionary {",
  "            self",
  "        }",
  "",
  "        method ++(other) {",
  "            def newDict = self.copy",
  "            other.keysAndValuesDo {k, v ->",
  "                newDict.at(k) put(v)",
  "            }",
  "            return newDict",
  "        }",
  "",
  "        method --(other) {",
  "            def newDict = dictionary.empty",
  "            keysAndValuesDo { k, v ->",
  "                if (! other.containsKey(k)) then {",
  "                    newDict.at(k) put(v)",
  "                }",
  "            }",
  "            return newDict",
  "        }",
  "    }",
  "}",
  "",
  "class range {",
  "    method from(lower)to(upper) -> Sequence⟦Number⟧ {",
  "        match (lower)",
  "            case {_:Number -> }",
  "            case {_ -> RequestError.raise (\"lower bound {lower}\" ++",
  "                \" in range.from({lower})to({upper}) is not an integer\") }",
  "        def start = lower.truncated",
  "        if (start != lower) then {",
  "            RequestError.raise (\"lower bound {lower}\" ++",
  "                \" in range.from({lower})to({upper}) is not an integer\") }",
  "",
  "        match (upper)",
  "            case {_:Number -> }",
  "            case {_ -> RequestError.raise (\"upper bound {upper}\" ++",
  "                \" in range.from({lower})to({upper}) is not an integer\") }",
  "        def stop = upper.truncated",
  "        if (stop != upper) then {",
  "            RequestError.raise (\"upper bound {upper}\" ++",
  "                \" in range.from()to() is not an integer\")",
  "        }",
  "",
  "        uncheckedFrom (lower) to (upper)",
  "    }",
  "",
  "    method uncheckedFrom (lower) to (upper) -> Sequence⟦Number⟧ {",
  "        object {",
  "            inherits indexable.TRAIT⟦Number⟧",
  "            def start = lower",
  "            def stop = upper",
  "            def size is public =",
  "                if ((upper-lower+1) < 0) then { 0 } else {upper-lower+1}",
  "",
  "            def hash is public = { ((start.hash * 1021) + stop.hash) * 3 }",
  "",
  "            method iterator -> Iterator {",
  "                object {",
  "                    var val := start",
  "                    method hasNext { val <= stop }",
  "                    method next {",
  "                        if (val > stop) then {",
  "                            IteratorExhausted.raise \"over {outer.asString}\"",
  "                        }",
  "                        val := val + 1",
  "                        return (val - 1)",
  "                    }",
  "                    method asString { \"{super.asString} from {upper} to {lower}\" }",
  "                }",
  "            }",
  "            method at(ix:Number) {",
  "                if (!(ix <= self.size)) then {",
  "                    BoundsError.raise \"requested range.at({ix}), but upper bound is {size}\"",
  "                }",
  "                if (!(ix >= 1)) then {",
  "                    BoundsError.raise \"requested range.at({ix}), but lower bound is 1\"",
  "                }",
  "                return start + (ix - 1)",
  "            }",
  "            method contains(elem) -> Boolean {",
  "                try {",
  "                    def intElem = elem.truncated",
  "                    if (intElem != elem) then {return false}",
  "                    if (intElem < start) then {return false}",
  "                    if (intElem > stop) then {return false}",
  "                } catch { ex:_prelude.Exception -> return false }",
  "                return true",
  "            }",
  "            method do(block1) {",
  "                var val := start",
  "                while {val <= stop} do {",
  "                    block1.apply(val)",
  "                    val := val + 1",
  "                }",
  "            }",
  "            method keysAndValuesDo(block2) {",
  "                var key := 1",
  "                var val := start",
  "                while {val <= stop} do {",
  "                    block2.apply(key, val)",
  "                    key := key + 1",
  "                    val := val + 1",
  "                }",
  "            }",
  "            method reversed {",
  "                from(upper)downTo(lower)",
  "            }",
  "            method ++(other) {",
  "                sequence.withAll(lazyConcatenation(self, other))",
  "            }",
  "            method ==(other) {",
  "                isEqual (self) toIterable (other)",
  "            }",
  "            method sorted { self }",
  "",
  "            method sortedBy(c) { self.asList.sortBy(c) }",
  "",
  "            method keys { 1..self.size }",
  "",
  "            method values { self }",
  "",
  "            method asString -> String{",
  "                \"range.from({lower})to({upper})\"",
  "            }",
  "",
  "            method asList{",
  "                var result := list.empty",
  "                for (self) do { each -> result.add(each) }",
  "                result",
  "            }",
  "",
  "            method asSequence {",
  "                self",
  "            }",
  "        }",
  "    }",
  "    method from(upper)downTo(lower) -> Sequence⟦Number⟧ {",
  "        object {",
  "            inherits indexable.TRAIT",
  "            match (upper)",
  "                case {_:Number -> }",
  "                case {_ -> RequestError.raise (\"upper bound {upper}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\") }",
  "            def start = upper.truncated",
  "            if (start != upper) then {",
  "                RequestError.raise (\"upper bound {upper}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\")",
  "            }",
  "            match (lower)",
  "                case {_:Number -> }",
  "                case {_ -> RequestError.raise (\"lower bound {lower}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\") }",
  "            def stop = lower.truncated",
  "            if (stop != lower) then {",
  "                RequestError.raise (\"lower bound {lower}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\")",
  "            }",
  "            def size is public =",
  "                if ((upper-lower+1) < 0) then { 0 } else {upper-lower+1}",
  "            method iterator {",
  "                object {",
  "                    var val := start",
  "                    method hasNext { val >= stop }",
  "                    method next {",
  "                        if (val < stop) then { IteratorExhausted.raise \"over {outer.asString}\" }",
  "                        val := val - 1",
  "                        return (val + 1)",
  "                    }",
  "                    method asString { \"anIterator over {super.asString}\" }",
  "                }",
  "            }",
  "            method at(ix:Number) {",
  "                if (!(ix <= self.size)) then {",
  "                    BoundsError.raise \"requested range.at({ix}) but upper bound is {size}\"",
  "                }",
  "                if (!(ix >= 1)) then {",
  "                    BoundsError.raise \"requested range.at({ix}) but lower bound is 1\"",
  "                }",
  "                return start - (ix - 1)",
  "            }",
  "            method contains(elem) -> Boolean {",
  "                try {",
  "                    def intElem = elem.truncated",
  "                    if (intElem != elem) then {return false}",
  "                    if (intElem > start) then {return false}",
  "                    if (intElem < stop) then {return false}",
  "                } catch { ex:_prelude.Exception -> return false }",
  "                return true",
  "            }",
  "            method do(block1) {",
  "                var val := start",
  "                while {val >= stop} do {",
  "                    block1.apply(val)",
  "                    val := val - 1",
  "                }",
  "            }",
  "            method keysAndValuesDo(block2) {",
  "                var key := 1",
  "                var val := start",
  "                while {val >= stop} do {",
  "                    block2.apply(key, val)",
  "                    key := key + 1",
  "                    val := val - 1",
  "                }",
  "            }",
  "            method reversed {",
  "                from(lower)to(upper)",
  "            }",
  "            method ++(other) {",
  "                sequence.withAll(lazyConcatenation(self, other))",
  "            }",
  "            method ==(other) {",
  "                isEqual (self) toIterable (other)",
  "            }",
  "            method sorted { self.reversed }",
  "",
  "            method sortedBy(c) { self.asList.sortBy(c) }",
  "",
  "            method keys { 1..self.size }",
  "",
  "            method values { self }",
  "",
  "            method asString -> String {",
  "                \"range.from {upper} downTo {lower}\"",
  "            }",
  "            method asSequence {",
  "                self",
  "            }",
  "        }",
  "    }",
  "}",
  NULL
};
Object reader_collectionsPrelude_outer_7(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_10(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_sourceIterator_11(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_outer_49(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_52(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_cache_53(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_cache_53(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_cacheLoaded_54(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_cacheLoaded_54(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_sourceIterator_55(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_153(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_190(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_325(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_size_326(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_inner_327(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_558(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_idx_559(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_idx_559(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_708(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_724(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_725(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_725(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_sz_726(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_sz_726(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_jsArray_727(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_jsArray_727(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_1096(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_imods_1097(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_imods_1097(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_1098(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_idx_1098(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_1235(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_1236(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_1236(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_sizeCertain_1237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_sizeCertain_1237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_initialSize_1238(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_inner_1239(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_collectionsPrelude_inner_1239(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_collectionsPrelude_size_1240(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_collectionsPrelude_size_1240(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_2017(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_imods_2018(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_imods_2018(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_2019(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_idx_2019(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_2296(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_2334(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_2335(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_2335(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_inner_2336(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_inner_2336(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_size_2337(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_size_2337(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_2823(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_imods_2824(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_imods_2824(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_count_2825(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_count_2825(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_2826(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_idx_2826(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_3136(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_3151(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_3152(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_3152(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_numBindings_3153(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_numBindings_3153(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_inner_3154(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_inner_3154(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_3963(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_3966(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_sourceIterator_3967(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_size_3992(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_4009(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_4012(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_sourceIterator_4013(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_size_4038(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_4055(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_size_4059(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_4081(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_imods_4082(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_count_4083(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_count_4083(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_4084(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_idx_4084(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_elt_4085(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_collectionsPrelude_elt_4085(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_4508(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_4656(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_start_4657(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_stop_4658(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_size_4659(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_hash_4660(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_collectionsPrelude_outer_4663(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_val_4664(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_val_4664(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_5013(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_start_5014(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_stop_5015(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_size_5016(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_5019(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_val_5020(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_val_5020(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_5583(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5586(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5711(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5714(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5883(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5886(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_6037(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_6091(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_6110(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_unused_6111(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_unused_6111(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_key_6112(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_value_6113(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_6122(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_removed_6123(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_removed_6123(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_key_6124(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_value_6125(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_6137(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_6142(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
static Object strlit3;
static ClassData objclass6;
static ClassData objclass9;
static Object strlit13;
static Object strlit37;
static Object strlit41;
static ClassData objclass48;
static ClassData objclass51;
static Object strlit58;
static Object strlit62;
static Object strlit141;
static Object strlit145;
static ClassData objclass152;
static Object strlit171;
static Object strlit176;
static Object strlit180;
static Object strlit186;
static ClassData objclass189;
static Object strlit202;
static Object strlit207;
static Object strlit211;
static ClassData objclass236;
static Object strlit239;
static ClassData objclass324;
static Object strlit348;
static Object strlit355;
static Object strlit359;
static Object strlit466;
static Object strlit501;
static Object strlit508;
static ClassData objclass557;
static Object strlit562;
static Object strlit569;
static Object strlit575;
static Object strlit581;
static Object strlit597;
static Object strlit604;
static Object strlit610;
static ClassData objclass707;
static Object strlit710;
static Object strlit717;
static ClassData objclass723;
static Object strlit857;
static Object strlit861;
static Object strlit884;
static Object strlit981;
static Object strlit1004;
static Object strlit1011;
static Object strlit1015;
static Object strlit1038;
static Object strlit1045;
static ClassData objclass1095;
static Object strlit1101;
static Object strlit1108;
static Object strlit1114;
static Object strlit1120;
static Object strlit1157;
static ClassData objclass1234;
static Object strlit1261;
static Object strlit1268;
static Object strlit1272;
static Object strlit1755;
static Object strlit1759;
static Object strlit1782;
static Object strlit1879;
static Object strlit1914;
static Object strlit1921;
static Object strlit1925;
static Object strlit1960;
static Object strlit1967;
static ClassData objclass2016;
static Object strlit2022;
static Object strlit2029;
static Object strlit2035;
static Object strlit2041;
static Object strlit2078;
static ClassData objclass2295;
static Object strlit2298;
static ClassData objclass2333;
static Object strlit2440;
static Object strlit2444;
static Object strlit2547;
static Object strlit2551;
static Object strlit2721;
static Object strlit2735;
static Object strlit2742;
static Object strlit2746;
static Object strlit2760;
static Object strlit2767;
static ClassData objclass2822;
static Object strlit2879;
static Object strlit2887;
static ClassData objclass3135;
static Object strlit3138;
static ClassData objclass3150;
static Object strlit3293;
static Object strlit3297;
static Object strlit3371;
static Object strlit3375;
static Object strlit3416;
static Object strlit3420;
static Object strlit3529;
static Object strlit3533;
static Object strlit3793;
static Object strlit3828;
static Object strlit3836;
static Object strlit3843;
static Object strlit3849;
static Object strlit3860;
static Object strlit3864;
static Object strlit3886;
static Object strlit3906;
static Object strlit3913;
static Object strlit3920;
static Object strlit3924;
static Object strlit3936;
static Object strlit3943;
static Object strlit3947;
static Object strlit3958;
static ClassData objclass3962;
static ClassData objclass3965;
static Object strlit3982;
static Object strlit3986;
static Object strlit3995;
static Object strlit3999;
static ClassData objclass4008;
static ClassData objclass4011;
static Object strlit4028;
static Object strlit4032;
static Object strlit4041;
static Object strlit4045;
static ClassData objclass4054;
static Object strlit4062;
static Object strlit4066;
static ClassData objclass4080;
static Object strlit4125;
static Object strlit4133;
static Object strlit4415;
static ClassData objclass4507;
static Object strlit4516;
static Object strlit4528;
static Object strlit4533;
static Object strlit4537;
static Object strlit4544;
static Object strlit4548;
static Object strlit4563;
static Object strlit4568;
static Object strlit4572;
static Object strlit4579;
static Object strlit4583;
static Object strlit4594;
static Object strlit4606;
static Object strlit4611;
static Object strlit4615;
static Object strlit4622;
static Object strlit4626;
static Object strlit4640;
static Object strlit4643;
static Object strlit4647;
static ClassData objclass4655;
static ClassData objclass4662;
static Object strlit4688;
static Object strlit4696;
static Object strlit4716;
static Object strlit4721;
static Object strlit4726;
static Object strlit4732;
static Object strlit4755;
static Object strlit4762;
static Object strlit4766;
static Object strlit4781;
static Object strlit4785;
static Object strlit4830;
static Object strlit4935;
static Object strlit4940;
static Object strlit4944;
static ClassData objclass5012;
static ClassData objclass5018;
static Object strlit5044;
static Object strlit5052;
static Object strlit5072;
static Object strlit5078;
static Object strlit5097;
static Object strlit5104;
static Object strlit5108;
static Object strlit5123;
static Object strlit5127;
static Object strlit5172;
static Object strlit5279;
static Object strlit5284;
static Object strlit5288;
static Object strlit5302;
static Object strlit5314;
static Object strlit5319;
static Object strlit5323;
static Object strlit5330;
static Object strlit5334;
static Object strlit5351;
static Object strlit5356;
static Object strlit5360;
static Object strlit5367;
static Object strlit5371;
static Object strlit5382;
static Object strlit5394;
static Object strlit5399;
static Object strlit5403;
static Object strlit5410;
static Object strlit5414;
static Object strlit5431;
static Object strlit5436;
static Object strlit5440;
static Object strlit5447;
static Object strlit5451;
static Object strlit5479;
static Object strlit5485;
static Object strlit5491;
static Object strlit5497;
static Object strlit5503;
static Object strlit5509;
static Object strlit5515;
static ClassData objclass5582;
static ClassData objclass5585;
static Object strlit5588;
static Object strlit5594;
static Object strlit5627;
static Object strlit5631;
static Object strlit5708;
static ClassData objclass5710;
static ClassData objclass5713;
static Object strlit5725;
static Object strlit5731;
static Object strlit5852;
static Object strlit5866;
static Object strlit5873;
static Object strlit5880;
static ClassData objclass5882;
static ClassData objclass5885;
static Object strlit5975;
static Object strlit5979;
static Object strlit6034;
static ClassData objclass6036;
static Object strlit6045;
static Object strlit6049;
static Object strlit6065;
static Object strlit6078;
static ClassData objclass6090;
static Object strlit6093;
static Object strlit6098;
static ClassData objclass6109;
static Object strlit6115;
static ClassData objclass6121;
static Object strlit6127;
static ClassData objclass6136;
static Object strlit6139;
static ClassData objclass6141;
static Object strlit6147;
static Object strlit6152;
static Object strlit6156;
static Object strlit6205;
Object meth_collectionsPrelude_abstract1(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "abstract");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SubobjectResponsibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit3 == NULL) {
    strlit3 = alloc_String("abstract method not overriden by subobject");
    gc_root(strlit3);
  }
// compiled string node returning strlit3 (depth = 3)
  gc_frame_newslot(strlit3);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SubobjectResponsibility (depth = 3)
  params[0] = strlit3;
  partcv[0] = 1;
  Object call4 = callmethodflags(*var_SubobjectResponsibility, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2);
// compiled call node returning call4 (depth = 2)
  gc_frame_end(frame);
  return call4;
}
Object meth_collectionsPrelude_asString12(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit13 == NULL) {
    strlit13 = alloc_String("an iterator over a lazy map sequence");
    gc_root(strlit13);
  }
// compiled string node returning strlit13 (depth = 2)
  gc_frame_end(frame);
  return strlit13;
}
Object meth_collectionsPrelude_hasNext14(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe15 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe16 = gc_frame_new();
// call case 4: self request
  Object call17 = callmethodflags(self, "sourceIterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe16);
// compiled member node returning call17 (depth = 3)
  Object call18 = callmethodflags(call17, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe15);
// compiled member node returning call18 (depth = 2)
  gc_frame_end(frame);
  return call18;
}
Object meth_collectionsPrelude_next19(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_function = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe20 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe21 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe22 = gc_frame_new();
// call case 4: self request
  Object call23 = callmethodflags(self, "sourceIterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe22);
// compiled member node returning call23 (depth = 4)
  Object call24 = callmethodflags(call23, "next", 0, partcv, params, 0);
  gc_frame_end(callframe21);
// compiled member node returning call24 (depth = 3)
  gc_frame_newslot(call24);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_function (depth = 3)
  params[0] = call24;
  partcv[0] = 1;
  Object call25 = callmethodflags(*var_function, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe20);
// compiled call node returning call25 (depth = 2)
  gc_frame_end(frame);
  return call25;
}
Object meth_collectionsPrelude_iterator8(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_function = getfromclosure(closure, 0);
  Object *var_source = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9 = alloc_userobj2(4,5, objclass9);
  gc_frame_newslot(obj9);
if (objclass9 == NULL) {
  glfree(obj9->class->name);
  obj9->class->name = "lazySequenceOver(_)mappedBy(_).iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9, self, 0);
  addmethodreal(obj9,"outer", &reader_collectionsPrelude_outer_10);
  Object oldself9 = self;
  struct StackFrameObject *oldstackframe9 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9);
  gc_frame_newslot((Object)stackframe);
  self = obj9;
  Object *oldselfslot9 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9 = (*(struct UserObject *)self).data[0], lowerouter9 = thisouter9;
  if (inheritingObject9) {
    struct UserObject *inho9 = (struct UserObject *)inheritingObject9;
    while (inho9->super != GraceDefaultObject) inho9 = (struct UserObject *)inho9->super;
    inho9->super = obj9;
    self = inheritingObject9;
    *selfslot = self;
    lowerouter9 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9;
  }
if (objclass9 == NULL) {
  Method *reader11 = addmethodrealflags(obj9, "sourceIterator",&reader_collectionsPrelude_sourceIterator_11, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader11->definitionModule = modulename;
  reader11->definitionLine = 173;
}
adddatum2(obj9, alloc_Undefined(), 1);
// method "asString"
  struct UserObject *uo12 = (struct UserObject*)obj9;
  uo12->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString12 = addmethod2pos(obj9, "asString", &meth_collectionsPrelude_asString12, 2);
  int argcv_meth_collectionsPrelude_asString12[] = {0};
  meth_meth_collectionsPrelude_asString12->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString12);
  meth_meth_collectionsPrelude_asString12->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString12->definitionLine = 174;
// method "hasNext"
  struct UserObject *uo14 = (struct UserObject*)obj9;
  uo14->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext14 = addmethod2pos(obj9, "hasNext", &meth_collectionsPrelude_hasNext14, 3);
  int argcv_meth_collectionsPrelude_hasNext14[] = {0};
  meth_meth_collectionsPrelude_hasNext14->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext14);
  meth_meth_collectionsPrelude_hasNext14->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext14->definitionLine = 175;
// method "next"
  block_savedest(obj9);
  Object closure19 = createclosure(1, "next");
  setclosureframe(closure19, stackframe);
  addtoclosure(closure19, var_function);
  struct UserObject *uo19 = (struct UserObject*)obj9;
  uo19->data[4] = (Object)closure19;
  Method *meth_meth_collectionsPrelude_next19 = addmethod2pos(obj9, "next", &meth_collectionsPrelude_next19, 4);
  int argcv_meth_collectionsPrelude_next19[] = {0};
  meth_meth_collectionsPrelude_next19->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next19);
  meth_meth_collectionsPrelude_next19->definitionModule = modulename;
  meth_meth_collectionsPrelude_next19->definitionLine = 176;
  sourceObject = obj9;
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe26 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_source (depth = 3)
  Object call27 = callmethodflags(*var_source, "iterator", 0, partcv, params, 0);
  gc_frame_end(callframe26);
// compiled member node returning call27 (depth = 2)
  adddatum2(obj9, call27, 1);
  sourceObject = obj9;
  sourceObject = obj9;
  sourceObject = obj9;
  objclass9 = obj9->class;
  objclass9->definitionModule = modulename;
  objclass9->definitionLine = 172;
  (*(struct UserObject *)self).data[0] = lowerouter9;
  self = oldself9;
  selfslot = oldselfslot9;
  stackframe = oldstackframe9;
  gc_frame_end(frame);
  return obj9;
}
Object meth_collectionsPrelude_iterator8_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_function = getfromclosure(closure, 0);
  Object *var_source = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9 = alloc_userobj2(4,5, objclass9);
  gc_frame_newslot(obj9);
if (objclass9 == NULL) {
  glfree(obj9->class->name);
  obj9->class->name = "lazySequenceOver(_)mappedBy(_).iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9, self, 0);
  addmethodreal(obj9,"outer", &reader_collectionsPrelude_outer_10);
  Object oldself9 = self;
  struct StackFrameObject *oldstackframe9 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9);
  gc_frame_newslot((Object)stackframe);
  self = obj9;
  Object *oldselfslot9 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9 = (*(struct UserObject *)self).data[0], lowerouter9 = thisouter9;
  if (inheritingObject9) {
    struct UserObject *inho9 = (struct UserObject *)inheritingObject9;
    while (inho9->super != GraceDefaultObject) inho9 = (struct UserObject *)inho9->super;
    inho9->super = obj9;
    self = inheritingObject9;
    *selfslot = self;
    lowerouter9 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9;
  }
if (objclass9 == NULL) {
  Method *reader11 = addmethodrealflags(obj9, "sourceIterator",&reader_collectionsPrelude_sourceIterator_11, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader11->definitionModule = modulename;
  reader11->definitionLine = 173;
}
adddatum2(obj9, alloc_Undefined(), 1);
// method "asString"
  struct UserObject *uo12 = (struct UserObject*)obj9;
  uo12->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString12 = addmethod2pos(obj9, "asString", &meth_collectionsPrelude_asString12, 2);
  int argcv_meth_collectionsPrelude_asString12[] = {0};
  meth_meth_collectionsPrelude_asString12->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString12);
  meth_meth_collectionsPrelude_asString12->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString12->definitionLine = 174;
// method "hasNext"
  struct UserObject *uo14 = (struct UserObject*)obj9;
  uo14->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext14 = addmethod2pos(obj9, "hasNext", &meth_collectionsPrelude_hasNext14, 3);
  int argcv_meth_collectionsPrelude_hasNext14[] = {0};
  meth_meth_collectionsPrelude_hasNext14->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext14);
  meth_meth_collectionsPrelude_hasNext14->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext14->definitionLine = 175;
// method "next"
  block_savedest(obj9);
  Object closure19 = createclosure(1, "next");
  setclosureframe(closure19, stackframe);
  addtoclosure(closure19, var_function);
  struct UserObject *uo19 = (struct UserObject*)obj9;
  uo19->data[4] = (Object)closure19;
  Method *meth_meth_collectionsPrelude_next19 = addmethod2pos(obj9, "next", &meth_collectionsPrelude_next19, 4);
  int argcv_meth_collectionsPrelude_next19[] = {0};
  meth_meth_collectionsPrelude_next19->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next19);
  meth_meth_collectionsPrelude_next19->definitionModule = modulename;
  meth_meth_collectionsPrelude_next19->definitionLine = 176;
  sourceObject = obj9;
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe26 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_source (depth = 3)
  Object call27 = callmethodflags(*var_source, "iterator", 0, partcv, params, 0);
  gc_frame_end(callframe26);
// compiled member node returning call27 (depth = 2)
  adddatum2(obj9, call27, 1);
  sourceObject = obj9;
  sourceObject = obj9;
  sourceObject = obj9;
  objclass9 = obj9->class;
  objclass9->definitionModule = modulename;
  objclass9->definitionLine = 172;
  (*(struct UserObject *)self).data[0] = lowerouter9;
  self = oldself9;
  selfslot = oldselfslot9;
  stackframe = oldstackframe9;
  gc_frame_end(frame);
  return obj9;
}
Object meth_collectionsPrelude_size29(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe30 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_source (depth = 3)
  Object call31 = callmethodflags(*var_source, "size", 0, partcv, params, 0);
  gc_frame_end(callframe30);
// compiled member node returning call31 (depth = 2)
  gc_frame_end(frame);
  return call31;
}
Object meth_collectionsPrelude_isEmpty32(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe33 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_source (depth = 3)
  Object call34 = callmethodflags(*var_source, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe33);
// compiled member node returning call34 (depth = 2)
  gc_frame_end(frame);
  return call34;
}
Object meth_collectionsPrelude_asDebugString35(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit37 == NULL) {
    strlit37 = alloc_String("");
    gc_root(strlit37);
  }
// compiled string node returning strlit37 (depth = 3)
  int op_slot_right_36 = gc_frame_newslot(strlit37);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  int op_slot_right_39 = gc_frame_newslot(*var_source);
// starting to compile string node (depth = 4)
  if (strlit41 == NULL) {
    strlit41 = alloc_String("a lazy sequence mapping over ");
    gc_root(strlit41);
  }
// compiled string node returning strlit41 (depth = 4)
  int op_slot_left_39 = gc_frame_newslot(strlit41);
  params[0] = *var_source;
  partcv[0] = 1;
  Object opresult42 = callmethod(strlit41, "++(1)", 1, partcv, params);
// compiled op node returning opresult42 (depth = 3)
  int op_slot_left_36 = gc_frame_newslot(opresult42);
  params[0] = strlit37;
  partcv[0] = 1;
  Object opresult43 = callmethod(opresult42, "++(1)", 1, partcv, params);
// compiled op node returning opresult43 (depth = 2)
  gc_frame_end(frame);
  return opresult43;
}
Object meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazySequenceOver(1)mappedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver(_)mappedBy(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver(_)mappedBy(_)");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for lazySequenceOver(_)mappedBy(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lazySequenceOver(_)");
  Object *var_function = &(stackframe->slots[1]);
  *var_function = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part mappedBy(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  Object *var_R = &(stackframe->slots[4]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
    *var_R = args[curarg++];
  } else {
    *var_T = Unknown;
    *var_R = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6 = alloc_userobj2(5,6, objclass6);
  gc_frame_newslot(obj6);
if (objclass6 == NULL) {
  glfree(obj6->class->name);
  obj6->class->name = "lazySequenceOver(_)mappedBy(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6, self, 0);
  addmethodreal(obj6,"outer", &reader_collectionsPrelude_outer_7);
  Object oldself6 = self;
  struct StackFrameObject *oldstackframe6 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6);
  gc_frame_newslot((Object)stackframe);
  self = obj6;
  Object *oldselfslot6 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6 = (*(struct UserObject *)self).data[0], lowerouter6 = thisouter6;
  if (inheritingObject6) {
    struct UserObject *inho6 = (struct UserObject *)inheritingObject6;
    while (inho6->super != GraceDefaultObject) inho6 = (struct UserObject *)inho6->super;
    inho6->super = obj6;
    self = inheritingObject6;
    *selfslot = self;
    lowerouter6 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6;
  }
// method "iterator"
  block_savedest(obj6);
  Object closure8 = createclosure(2, "iterator");
  setclosureframe(closure8, stackframe);
  addtoclosure(closure8, var_function);
  addtoclosure(closure8, var_source);
  struct UserObject *uo8 = (struct UserObject*)obj6;
  uo8->data[1] = (Object)closure8;
  Method *meth_meth_collectionsPrelude_iterator8 = addmethod2pos(obj6, "iterator", &meth_collectionsPrelude_iterator8, 1);
  int argcv_meth_collectionsPrelude_iterator8[] = {0};
  meth_meth_collectionsPrelude_iterator8->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator8);
  meth_meth_collectionsPrelude_iterator8->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator8->definitionLine = 172;
  block_savedest(obj6);
  Object closure28 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure28, stackframe);
  addtoclosure(closure28, var_function);
  addtoclosure(closure28, var_source);
  Method *meth_meth_collectionsPrelude_iterator8_object = addmethod2pos(obj6, "iterator$object(1)", &meth_collectionsPrelude_iterator8_object, 1);
  meth_meth_collectionsPrelude_iterator8_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator8_object->definitionLine = 172;
// method "size"
  block_savedest(obj6);
  Object closure29 = createclosure(1, "size");
  setclosureframe(closure29, stackframe);
  addtoclosure(closure29, var_source);
  struct UserObject *uo29 = (struct UserObject*)obj6;
  uo29->data[2] = (Object)closure29;
  Method *meth_meth_collectionsPrelude_size29 = addmethod2pos(obj6, "size", &meth_collectionsPrelude_size29, 2);
  int argcv_meth_collectionsPrelude_size29[] = {0};
  meth_meth_collectionsPrelude_size29->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size29);
  meth_meth_collectionsPrelude_size29->definitionModule = modulename;
  meth_meth_collectionsPrelude_size29->definitionLine = 178;
// method "isEmpty"
  block_savedest(obj6);
  Object closure32 = createclosure(1, "isEmpty");
  setclosureframe(closure32, stackframe);
  addtoclosure(closure32, var_source);
  struct UserObject *uo32 = (struct UserObject*)obj6;
  uo32->data[3] = (Object)closure32;
  Method *meth_meth_collectionsPrelude_isEmpty32 = addmethod2pos(obj6, "isEmpty", &meth_collectionsPrelude_isEmpty32, 3);
  int argcv_meth_collectionsPrelude_isEmpty32[] = {0};
  meth_meth_collectionsPrelude_isEmpty32->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty32);
  meth_meth_collectionsPrelude_isEmpty32->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty32->definitionLine = 179;
// method "asDebugString"
  block_savedest(obj6);
  Object closure35 = createclosure(1, "asDebugString");
  setclosureframe(closure35, stackframe);
  addtoclosure(closure35, var_source);
  struct UserObject *uo35 = (struct UserObject*)obj6;
  uo35->data[4] = (Object)closure35;
  Method *meth_meth_collectionsPrelude_asDebugString35 = addmethod2pos(obj6, "asDebugString", &meth_collectionsPrelude_asDebugString35, 4);
  int argcv_meth_collectionsPrelude_asDebugString35[] = {0};
  meth_meth_collectionsPrelude_asDebugString35->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString35);
  meth_meth_collectionsPrelude_asDebugString35->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString35->definitionLine = 180;
  sourceObject = obj6;
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe44 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call45 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe44);
// compiled call node returning call45 (depth = 2)
  struct UserObject *obj6_uo = (struct UserObject *)obj6;
  obj6_uo->super = call45;
  sourceObject = obj6;
  sourceObject = obj6;
  sourceObject = obj6;
  sourceObject = obj6;
  objclass6 = obj6->class;
  objclass6->definitionModule = modulename;
  objclass6->definitionLine = 169;
  (*(struct UserObject *)self).data[0] = lowerouter6;
  self = oldself6;
  selfslot = oldselfslot6;
  stackframe = oldstackframe6;
  gc_frame_end(frame);
  return obj6;
}
Object meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazySequenceOver(1)mappedBy(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method lazySequenceOver(_)mappedBy(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method lazySequenceOver(_)mappedBy(_)");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for lazySequenceOver(_)mappedBy(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lazySequenceOver(_)");
  Object *var_function = &(stackframe->slots[1]);
  *var_function = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part mappedBy(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  Object *var_R = &(stackframe->slots[4]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
    *var_R = args[curarg++];
  } else {
    *var_T = Unknown;
    *var_R = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6 = alloc_userobj2(5,6, objclass6);
  gc_frame_newslot(obj6);
if (objclass6 == NULL) {
  glfree(obj6->class->name);
  obj6->class->name = "lazySequenceOver(_)mappedBy(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6, self, 0);
  addmethodreal(obj6,"outer", &reader_collectionsPrelude_outer_7);
  Object oldself6 = self;
  struct StackFrameObject *oldstackframe6 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6);
  gc_frame_newslot((Object)stackframe);
  self = obj6;
  Object *oldselfslot6 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6 = (*(struct UserObject *)self).data[0], lowerouter6 = thisouter6;
  if (inheritingObject6) {
    struct UserObject *inho6 = (struct UserObject *)inheritingObject6;
    while (inho6->super != GraceDefaultObject) inho6 = (struct UserObject *)inho6->super;
    inho6->super = obj6;
    self = inheritingObject6;
    *selfslot = self;
    lowerouter6 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6;
  }
// method "iterator"
  block_savedest(obj6);
  Object closure8 = createclosure(2, "iterator");
  setclosureframe(closure8, stackframe);
  addtoclosure(closure8, var_function);
  addtoclosure(closure8, var_source);
  struct UserObject *uo8 = (struct UserObject*)obj6;
  uo8->data[1] = (Object)closure8;
  Method *meth_meth_collectionsPrelude_iterator8 = addmethod2pos(obj6, "iterator", &meth_collectionsPrelude_iterator8, 1);
  int argcv_meth_collectionsPrelude_iterator8[] = {0};
  meth_meth_collectionsPrelude_iterator8->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator8);
  meth_meth_collectionsPrelude_iterator8->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator8->definitionLine = 172;
  block_savedest(obj6);
  Object closure28 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure28, stackframe);
  addtoclosure(closure28, var_function);
  addtoclosure(closure28, var_source);
  Method *meth_meth_collectionsPrelude_iterator8_object = addmethod2pos(obj6, "iterator$object(1)", &meth_collectionsPrelude_iterator8_object, 1);
  meth_meth_collectionsPrelude_iterator8_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator8_object->definitionLine = 172;
// method "size"
  block_savedest(obj6);
  Object closure29 = createclosure(1, "size");
  setclosureframe(closure29, stackframe);
  addtoclosure(closure29, var_source);
  struct UserObject *uo29 = (struct UserObject*)obj6;
  uo29->data[2] = (Object)closure29;
  Method *meth_meth_collectionsPrelude_size29 = addmethod2pos(obj6, "size", &meth_collectionsPrelude_size29, 2);
  int argcv_meth_collectionsPrelude_size29[] = {0};
  meth_meth_collectionsPrelude_size29->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size29);
  meth_meth_collectionsPrelude_size29->definitionModule = modulename;
  meth_meth_collectionsPrelude_size29->definitionLine = 178;
// method "isEmpty"
  block_savedest(obj6);
  Object closure32 = createclosure(1, "isEmpty");
  setclosureframe(closure32, stackframe);
  addtoclosure(closure32, var_source);
  struct UserObject *uo32 = (struct UserObject*)obj6;
  uo32->data[3] = (Object)closure32;
  Method *meth_meth_collectionsPrelude_isEmpty32 = addmethod2pos(obj6, "isEmpty", &meth_collectionsPrelude_isEmpty32, 3);
  int argcv_meth_collectionsPrelude_isEmpty32[] = {0};
  meth_meth_collectionsPrelude_isEmpty32->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty32);
  meth_meth_collectionsPrelude_isEmpty32->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty32->definitionLine = 179;
// method "asDebugString"
  block_savedest(obj6);
  Object closure35 = createclosure(1, "asDebugString");
  setclosureframe(closure35, stackframe);
  addtoclosure(closure35, var_source);
  struct UserObject *uo35 = (struct UserObject*)obj6;
  uo35->data[4] = (Object)closure35;
  Method *meth_meth_collectionsPrelude_asDebugString35 = addmethod2pos(obj6, "asDebugString", &meth_collectionsPrelude_asDebugString35, 4);
  int argcv_meth_collectionsPrelude_asDebugString35[] = {0};
  meth_meth_collectionsPrelude_asDebugString35->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString35);
  meth_meth_collectionsPrelude_asDebugString35->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString35->definitionLine = 180;
  sourceObject = obj6;
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe44 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call45 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe44);
// compiled call node returning call45 (depth = 2)
  struct UserObject *obj6_uo = (struct UserObject *)obj6;
  obj6_uo->super = call45;
  sourceObject = obj6;
  sourceObject = obj6;
  sourceObject = obj6;
  sourceObject = obj6;
  objclass6 = obj6->class;
  objclass6->definitionModule = modulename;
  objclass6->definitionLine = 169;
  (*(struct UserObject *)self).data[0] = lowerouter6;
  self = oldself6;
  selfslot = oldselfslot6;
  stackframe = oldstackframe6;
  gc_frame_end(frame);
  return obj6;
}
Object meth_collectionsPrelude_asString56(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit58 == NULL) {
    strlit58 = alloc_String("");
    gc_root(strlit58);
  }
// compiled string node returning strlit58 (depth = 3)
  int op_slot_right_57 = gc_frame_newslot(strlit58);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  int op_slot_right_60 = gc_frame_newslot(*var_source);
// starting to compile string node (depth = 4)
  if (strlit62 == NULL) {
    strlit62 = alloc_String("an iterator over filtered ");
    gc_root(strlit62);
  }
// compiled string node returning strlit62 (depth = 4)
  int op_slot_left_60 = gc_frame_newslot(strlit62);
  params[0] = *var_source;
  partcv[0] = 1;
  Object opresult63 = callmethod(strlit62, "++(1)", 1, partcv, params);
// compiled op node returning opresult63 (depth = 3)
  int op_slot_left_57 = gc_frame_newslot(opresult63);
  params[0] = strlit58;
  partcv[0] = 1;
  Object opresult64 = callmethod(opresult63, "++(1)", 1, partcv, params);
// compiled op node returning opresult64 (depth = 2)
  gc_frame_end(frame);
  return opresult64;
}
Object meth_collectionsPrelude_hasNext65(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe67 = gc_frame_new();
// call case 4: self request
  Object call68 = callmethodflags(self, "cacheLoaded", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe67);
// compiled member node returning call68 (depth = 3)
  Object if66 = done;
  if (istrue(call68)) {
// starting to compile identifier node (depth = 3)
  Object bool69 = alloc_Boolean(1);
// compiled identifier node returning bool69 (depth = 3)
    gc_frame_newslot(bool69);
    if66 = bool69;
  } else {
// starting to compile member node (depth = 3)
  int callframe70 = gc_frame_new();
// call case 4: self request
  Object call71 = callmethodflags(self, "hasNextAcceptableElement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe70);
// compiled member node returning call71 (depth = 3)
    gc_frame_newslot(call71);
    if66 = call71;
  }
// compiled if node returning if66 (depth = 2)
  gc_frame_end(frame);
  return if66;
}
Object meth_collectionsPrelude_next72(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe74 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe75 = gc_frame_new();
// call case 4: self request
  Object call76 = callmethodflags(self, "cacheLoaded", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe75);
// compiled member node returning call76 (depth = 4)
  Object call77 = callmethodflags(call76, "not", 0, partcv, params, 0);
  gc_frame_end(callframe74);
// compiled member node returning call77 (depth = 3)
  Object if73 = done;
  if (istrue(call77)) {
// starting to compile call node (depth = 3)
  int callframe78 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe79 = gc_frame_new();
// call case 4: self request
  Object call80 = callmethodflags(self, "nextAcceptableElement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe79);
// compiled member node returning call80 (depth = 4)
  gc_frame_newslot(call80);
// call case 4: self request
  params[0] = call80;
  partcv[0] = 1;
  Object call81 = callmethodflags(self, "cache:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe78);
// compiled call node returning call81 (depth = 3)
    gc_frame_newslot(call81);
    if73 = call81;
  } else {
  }
// compiled if node returning if73 (depth = 2)
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe82 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool83 = alloc_Boolean(0);
// compiled identifier node returning bool83 (depth = 3)
  gc_frame_newslot(bool83);
// call case 4: self request
  params[0] = bool83;
  partcv[0] = 1;
  Object call84 = callmethodflags(self, "cacheLoaded:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe82);
// compiled call node returning call84 (depth = 2)
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe85 = gc_frame_new();
// call case 4: self request
  Object call86 = callmethodflags(self, "cache", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe85);
// compiled member node returning call86 (depth = 3)
  return call86;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply90(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 4)
  Object bool91 = alloc_Boolean(1);
// compiled identifier node returning bool91 (depth = 4)
  gc_frame_end(frame);
  return bool91;
}
Object meth_collectionsPrelude__apply94(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_predicate = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_outerNext = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "outerNext");
  Object *var_isAcceptable = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "isAcceptable");
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe95 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe96 = gc_frame_new();
// call case 4: self request
  Object call97 = callmethodflags(self, "sourceIterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe96);
// compiled member node returning call97 (depth = 6)
  Object call98 = callmethodflags(call97, "next", 0, partcv, params, 0);
  gc_frame_end(callframe95);
// compiled member node returning call98 (depth = 5)
  *var_outerNext = call98;
  if (call98 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe99 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_outerNext (depth = 6)
  gc_frame_newslot(*var_outerNext);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_predicate (depth = 6)
  params[0] = *var_outerNext;
  partcv[0] = 1;
  Object call100 = callmethodflags(*var_predicate, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe99);
// compiled call node returning call100 (depth = 5)
  *var_isAcceptable = call100;
  if (call100 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_isAcceptable (depth = 5)
  Object if101 = done;
  if (istrue(*var_isAcceptable)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_outerNext (depth = 6)
  block_return(realself, *var_outerNext);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if101 = undefined;
  } else {
  }
// compiled if node returning if101 (depth = 4)
  gc_frame_end(frame);
  return if101;
}
Object meth_collectionsPrelude_nextAcceptableElement87(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "nextAcceptableElement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_predicate = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe88 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block89 = alloc_Block(NULL, NULL, "collectionsPrelude", 204);
  gc_frame_newslot(block89);
// method "_apply"
  block_savedest(block89);
  Object closure90 = createclosure(1, "_apply");
  setclosureframe(closure90, stackframe);
  addtoclosure(closure90, selfslot);
  struct UserObject *uo90 = (struct UserObject*)block89;
  uo90->data[0] = (Object)closure90;
  Method *meth_meth_collectionsPrelude__apply90 = addmethod2pos(block89, "_apply", &meth_collectionsPrelude__apply90, 0);
  int argcv_meth_collectionsPrelude__apply90[] = {0};
  meth_meth_collectionsPrelude__apply90->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply90);
  meth_meth_collectionsPrelude__apply90->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply90->definitionLine = 1991;
// compiled block node returning block89 (depth = 3)
  gc_frame_newslot(block89);
// starting to compile block node (depth = 3)
  Object block93 = alloc_Block(NULL, NULL, "collectionsPrelude", 204);
  gc_frame_newslot(block93);
// method "_apply"
  block_savedest(block93);
  Object closure94 = createclosure(2, "_apply");
  setclosureframe(closure94, stackframe);
  addtoclosure(closure94, var_predicate);
  addtoclosure(closure94, selfslot);
  struct UserObject *uo94 = (struct UserObject*)block93;
  uo94->data[0] = (Object)closure94;
  Method *meth_meth_collectionsPrelude__apply94 = addmethod2pos(block93, "_apply", &meth_collectionsPrelude__apply94, 0);
  int argcv_meth_collectionsPrelude__apply94[] = {0};
  meth_meth_collectionsPrelude__apply94->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply94);
  meth_meth_collectionsPrelude__apply94->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply94->definitionLine = 1991;
// compiled block node returning block93 (depth = 3)
  gc_frame_newslot(block93);
// call case 5: prelude request
  params[0] = block89;
  params[1] = block93;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call103 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe88);
// compiled call node returning call103 (depth = 2)
  gc_frame_end(frame);
  return call103;
}
Object meth_collectionsPrelude__apply107(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 4)
  Object bool108 = alloc_Boolean(1);
// compiled identifier node returning bool108 (depth = 4)
  gc_frame_end(frame);
  return bool108;
}
Object meth_collectionsPrelude__apply111(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_predicate = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_outerNext = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "outerNext");
  Object *var_isAcceptable = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "isAcceptable");
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe113 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe114 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe115 = gc_frame_new();
// call case 4: self request
  Object call116 = callmethodflags(self, "sourceIterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe115);
// compiled member node returning call116 (depth = 7)
  Object call117 = callmethodflags(call116, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe114);
// compiled member node returning call117 (depth = 6)
  Object call118 = callmethodflags(call117, "not", 0, partcv, params, 0);
  gc_frame_end(callframe113);
// compiled member node returning call118 (depth = 5)
  Object if112 = done;
  if (istrue(call118)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool119 = alloc_Boolean(0);
// compiled identifier node returning bool119 (depth = 6)
  block_return(realself, bool119);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if112 = undefined;
  } else {
  }
// compiled if node returning if112 (depth = 4)
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe120 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe121 = gc_frame_new();
// call case 4: self request
  Object call122 = callmethodflags(self, "sourceIterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe121);
// compiled member node returning call122 (depth = 6)
  Object call123 = callmethodflags(call122, "next", 0, partcv, params, 0);
  gc_frame_end(callframe120);
// compiled member node returning call123 (depth = 5)
  *var_outerNext = call123;
  if (call123 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe124 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_outerNext (depth = 6)
  gc_frame_newslot(*var_outerNext);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_predicate (depth = 6)
  params[0] = *var_outerNext;
  partcv[0] = 1;
  Object call125 = callmethodflags(*var_predicate, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe124);
// compiled call node returning call125 (depth = 5)
  *var_isAcceptable = call125;
  if (call125 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_isAcceptable (depth = 5)
  Object if126 = done;
  if (istrue(*var_isAcceptable)) {
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe127 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool128 = alloc_Boolean(1);
// compiled identifier node returning bool128 (depth = 6)
  gc_frame_newslot(bool128);
// call case 4: self request
  params[0] = bool128;
  partcv[0] = 1;
  Object call129 = callmethodflags(self, "cacheLoaded:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe127);
// compiled call node returning call129 (depth = 5)
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe130 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_outerNext (depth = 6)
  gc_frame_newslot(*var_outerNext);
// call case 4: self request
  params[0] = *var_outerNext;
  partcv[0] = 1;
  Object call131 = callmethodflags(self, "cache:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe130);
// compiled call node returning call131 (depth = 5)
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool132 = alloc_Boolean(1);
// compiled identifier node returning bool132 (depth = 6)
  block_return(realself, bool132);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if126 = undefined;
  } else {
  }
// compiled if node returning if126 (depth = 4)
  gc_frame_end(frame);
  return if126;
}
Object meth_collectionsPrelude_hasNextAcceptableElement104(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hasNextAcceptableElement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_predicate = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe105 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block106 = alloc_Block(NULL, NULL, "collectionsPrelude", 213);
  gc_frame_newslot(block106);
// method "_apply"
  block_savedest(block106);
  Object closure107 = createclosure(1, "_apply");
  setclosureframe(closure107, stackframe);
  addtoclosure(closure107, selfslot);
  struct UserObject *uo107 = (struct UserObject*)block106;
  uo107->data[0] = (Object)closure107;
  Method *meth_meth_collectionsPrelude__apply107 = addmethod2pos(block106, "_apply", &meth_collectionsPrelude__apply107, 0);
  int argcv_meth_collectionsPrelude__apply107[] = {0};
  meth_meth_collectionsPrelude__apply107->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply107);
  meth_meth_collectionsPrelude__apply107->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply107->definitionLine = 1991;
// compiled block node returning block106 (depth = 3)
  gc_frame_newslot(block106);
// starting to compile block node (depth = 3)
  Object block110 = alloc_Block(NULL, NULL, "collectionsPrelude", 213);
  gc_frame_newslot(block110);
// method "_apply"
  block_savedest(block110);
  Object closure111 = createclosure(2, "_apply");
  setclosureframe(closure111, stackframe);
  addtoclosure(closure111, var_predicate);
  addtoclosure(closure111, selfslot);
  struct UserObject *uo111 = (struct UserObject*)block110;
  uo111->data[0] = (Object)closure111;
  Method *meth_meth_collectionsPrelude__apply111 = addmethod2pos(block110, "_apply", &meth_collectionsPrelude__apply111, 0);
  int argcv_meth_collectionsPrelude__apply111[] = {0};
  meth_meth_collectionsPrelude__apply111->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply111);
  meth_meth_collectionsPrelude__apply111->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply111->definitionLine = 1991;
// compiled block node returning block110 (depth = 3)
  gc_frame_newslot(block110);
// call case 5: prelude request
  params[0] = block106;
  params[1] = block110;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call134 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe105);
// compiled call node returning call134 (depth = 2)
  gc_frame_end(frame);
  return call134;
}
Object meth_collectionsPrelude_iterator50(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  Object *var_predicate = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject51 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj51 = alloc_userobj2(10,9, objclass51);
  gc_frame_newslot(obj51);
if (objclass51 == NULL) {
  glfree(obj51->class->name);
  obj51->class->name = "lazySequenceOver(_)filteredBy(_).iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj51, self, 0);
  addmethodreal(obj51,"outer", &reader_collectionsPrelude_outer_52);
  Object oldself51 = self;
  struct StackFrameObject *oldstackframe51 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe51);
  gc_frame_newslot((Object)stackframe);
  self = obj51;
  Object *oldselfslot51 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter51 = (*(struct UserObject *)self).data[0], lowerouter51 = thisouter51;
  if (inheritingObject51) {
    struct UserObject *inho51 = (struct UserObject *)inheritingObject51;
    while (inho51->super != GraceDefaultObject) inho51 = (struct UserObject *)inho51->super;
    inho51->super = obj51;
    self = inheritingObject51;
    *selfslot = self;
    lowerouter51 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter51;
  }
if (objclass51 == NULL) {
  Method *reader53 = addmethodrealflags(obj51, "cache", &reader_collectionsPrelude_cache_53, MFLAG_CONFIDENTIAL);
  Method *writer53 = addmethodrealflags(obj51, "cache:=(1)", &writer_collectionsPrelude_cache_53, MFLAG_CONFIDENTIAL);
  reader53->definitionModule = modulename;
  writer53->definitionModule = modulename;
  reader53->definitionLine = 187;
  writer53->definitionLine = 187;
}
obj51->flags |= OFLAG_MUTABLE;
adddatum2(obj51, alloc_Undefined(), 1);
if (objclass51 == NULL) {
  Method *reader54 = addmethodrealflags(obj51, "cacheLoaded", &reader_collectionsPrelude_cacheLoaded_54, MFLAG_CONFIDENTIAL);
  Method *writer54 = addmethodrealflags(obj51, "cacheLoaded:=(1)", &writer_collectionsPrelude_cacheLoaded_54, MFLAG_CONFIDENTIAL);
  reader54->definitionModule = modulename;
  writer54->definitionModule = modulename;
  reader54->definitionLine = 188;
  writer54->definitionLine = 188;
}
obj51->flags |= OFLAG_MUTABLE;
adddatum2(obj51, alloc_Undefined(), 2);
if (objclass51 == NULL) {
  Method *reader55 = addmethodrealflags(obj51, "sourceIterator",&reader_collectionsPrelude_sourceIterator_55, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader55->definitionModule = modulename;
  reader55->definitionLine = 189;
}
adddatum2(obj51, alloc_Undefined(), 3);
// method "asString"
  block_savedest(obj51);
  Object closure56 = createclosure(1, "asString");
  setclosureframe(closure56, stackframe);
  addtoclosure(closure56, var_source);
  struct UserObject *uo56 = (struct UserObject*)obj51;
  uo56->data[4] = (Object)closure56;
  Method *meth_meth_collectionsPrelude_asString56 = addmethod2pos(obj51, "asString", &meth_collectionsPrelude_asString56, 4);
  int argcv_meth_collectionsPrelude_asString56[] = {0};
  meth_meth_collectionsPrelude_asString56->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString56);
  meth_meth_collectionsPrelude_asString56->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString56->definitionLine = 190;
// method "hasNext"
  struct UserObject *uo65 = (struct UserObject*)obj51;
  uo65->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext65 = addmethod2pos(obj51, "hasNext", &meth_collectionsPrelude_hasNext65, 5);
  int argcv_meth_collectionsPrelude_hasNext65[] = {0};
  meth_meth_collectionsPrelude_hasNext65->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext65);
  meth_meth_collectionsPrelude_hasNext65->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext65->definitionLine = 191;
// method "next"
  struct UserObject *uo72 = (struct UserObject*)obj51;
  uo72->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next72 = addmethod2pos(obj51, "next", &meth_collectionsPrelude_next72, 6);
  int argcv_meth_collectionsPrelude_next72[] = {0};
  meth_meth_collectionsPrelude_next72->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next72);
  meth_meth_collectionsPrelude_next72->definitionModule = modulename;
  meth_meth_collectionsPrelude_next72->definitionLine = 196;
// method "nextAcceptableElement"
  block_savedest(obj51);
  Object closure87 = createclosure(1, "nextAcceptableElement");
  setclosureframe(closure87, stackframe);
  addtoclosure(closure87, var_predicate);
  struct UserObject *uo87 = (struct UserObject*)obj51;
  uo87->data[7] = (Object)closure87;
  Method *meth_meth_collectionsPrelude_nextAcceptableElement87 = addmethod2pos(obj51, "nextAcceptableElement", &meth_collectionsPrelude_nextAcceptableElement87, 7);
  int argcv_meth_collectionsPrelude_nextAcceptableElement87[] = {0};
  meth_meth_collectionsPrelude_nextAcceptableElement87->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_nextAcceptableElement87);
  meth_meth_collectionsPrelude_nextAcceptableElement87->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_nextAcceptableElement87->definitionModule = modulename;
  meth_meth_collectionsPrelude_nextAcceptableElement87->definitionLine = 201;
// method "hasNextAcceptableElement"
  block_savedest(obj51);
  Object closure104 = createclosure(1, "hasNextAcceptableElement");
  setclosureframe(closure104, stackframe);
  addtoclosure(closure104, var_predicate);
  struct UserObject *uo104 = (struct UserObject*)obj51;
  uo104->data[8] = (Object)closure104;
  Method *meth_meth_collectionsPrelude_hasNextAcceptableElement104 = addmethod2pos(obj51, "hasNextAcceptableElement", &meth_collectionsPrelude_hasNextAcceptableElement104, 8);
  int argcv_meth_collectionsPrelude_hasNextAcceptableElement104[] = {0};
  meth_meth_collectionsPrelude_hasNextAcceptableElement104->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNextAcceptableElement104);
  meth_meth_collectionsPrelude_hasNextAcceptableElement104->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_hasNextAcceptableElement104->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNextAcceptableElement104->definitionLine = 210;
  sourceObject = obj51;
  adddatum2(obj51, undefined, 1);
  sourceObject = obj51;
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool135 = alloc_Boolean(0);
// compiled identifier node returning bool135 (depth = 2)
  adddatum2(obj51, bool135, 2);
  sourceObject = obj51;
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe136 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_source (depth = 3)
  Object call137 = callmethodflags(*var_source, "iterator", 0, partcv, params, 0);
  gc_frame_end(callframe136);
// compiled member node returning call137 (depth = 2)
  adddatum2(obj51, call137, 3);
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  objclass51 = obj51->class;
  objclass51->definitionModule = modulename;
  objclass51->definitionLine = 186;
  (*(struct UserObject *)self).data[0] = lowerouter51;
  self = oldself51;
  selfslot = oldselfslot51;
  stackframe = oldstackframe51;
  gc_frame_end(frame);
  return obj51;
}
Object meth_collectionsPrelude_iterator50_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  Object *var_predicate = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject51 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj51 = alloc_userobj2(10,9, objclass51);
  gc_frame_newslot(obj51);
if (objclass51 == NULL) {
  glfree(obj51->class->name);
  obj51->class->name = "lazySequenceOver(_)filteredBy(_).iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj51, self, 0);
  addmethodreal(obj51,"outer", &reader_collectionsPrelude_outer_52);
  Object oldself51 = self;
  struct StackFrameObject *oldstackframe51 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe51);
  gc_frame_newslot((Object)stackframe);
  self = obj51;
  Object *oldselfslot51 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter51 = (*(struct UserObject *)self).data[0], lowerouter51 = thisouter51;
  if (inheritingObject51) {
    struct UserObject *inho51 = (struct UserObject *)inheritingObject51;
    while (inho51->super != GraceDefaultObject) inho51 = (struct UserObject *)inho51->super;
    inho51->super = obj51;
    self = inheritingObject51;
    *selfslot = self;
    lowerouter51 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter51;
  }
if (objclass51 == NULL) {
  Method *reader53 = addmethodrealflags(obj51, "cache", &reader_collectionsPrelude_cache_53, MFLAG_CONFIDENTIAL);
  Method *writer53 = addmethodrealflags(obj51, "cache:=(1)", &writer_collectionsPrelude_cache_53, MFLAG_CONFIDENTIAL);
  reader53->definitionModule = modulename;
  writer53->definitionModule = modulename;
  reader53->definitionLine = 187;
  writer53->definitionLine = 187;
}
obj51->flags |= OFLAG_MUTABLE;
adddatum2(obj51, alloc_Undefined(), 1);
if (objclass51 == NULL) {
  Method *reader54 = addmethodrealflags(obj51, "cacheLoaded", &reader_collectionsPrelude_cacheLoaded_54, MFLAG_CONFIDENTIAL);
  Method *writer54 = addmethodrealflags(obj51, "cacheLoaded:=(1)", &writer_collectionsPrelude_cacheLoaded_54, MFLAG_CONFIDENTIAL);
  reader54->definitionModule = modulename;
  writer54->definitionModule = modulename;
  reader54->definitionLine = 188;
  writer54->definitionLine = 188;
}
obj51->flags |= OFLAG_MUTABLE;
adddatum2(obj51, alloc_Undefined(), 2);
if (objclass51 == NULL) {
  Method *reader55 = addmethodrealflags(obj51, "sourceIterator",&reader_collectionsPrelude_sourceIterator_55, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader55->definitionModule = modulename;
  reader55->definitionLine = 189;
}
adddatum2(obj51, alloc_Undefined(), 3);
// method "asString"
  block_savedest(obj51);
  Object closure56 = createclosure(1, "asString");
  setclosureframe(closure56, stackframe);
  addtoclosure(closure56, var_source);
  struct UserObject *uo56 = (struct UserObject*)obj51;
  uo56->data[4] = (Object)closure56;
  Method *meth_meth_collectionsPrelude_asString56 = addmethod2pos(obj51, "asString", &meth_collectionsPrelude_asString56, 4);
  int argcv_meth_collectionsPrelude_asString56[] = {0};
  meth_meth_collectionsPrelude_asString56->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString56);
  meth_meth_collectionsPrelude_asString56->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString56->definitionLine = 190;
// method "hasNext"
  struct UserObject *uo65 = (struct UserObject*)obj51;
  uo65->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext65 = addmethod2pos(obj51, "hasNext", &meth_collectionsPrelude_hasNext65, 5);
  int argcv_meth_collectionsPrelude_hasNext65[] = {0};
  meth_meth_collectionsPrelude_hasNext65->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext65);
  meth_meth_collectionsPrelude_hasNext65->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext65->definitionLine = 191;
// method "next"
  struct UserObject *uo72 = (struct UserObject*)obj51;
  uo72->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next72 = addmethod2pos(obj51, "next", &meth_collectionsPrelude_next72, 6);
  int argcv_meth_collectionsPrelude_next72[] = {0};
  meth_meth_collectionsPrelude_next72->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next72);
  meth_meth_collectionsPrelude_next72->definitionModule = modulename;
  meth_meth_collectionsPrelude_next72->definitionLine = 196;
// method "nextAcceptableElement"
  block_savedest(obj51);
  Object closure87 = createclosure(1, "nextAcceptableElement");
  setclosureframe(closure87, stackframe);
  addtoclosure(closure87, var_predicate);
  struct UserObject *uo87 = (struct UserObject*)obj51;
  uo87->data[7] = (Object)closure87;
  Method *meth_meth_collectionsPrelude_nextAcceptableElement87 = addmethod2pos(obj51, "nextAcceptableElement", &meth_collectionsPrelude_nextAcceptableElement87, 7);
  int argcv_meth_collectionsPrelude_nextAcceptableElement87[] = {0};
  meth_meth_collectionsPrelude_nextAcceptableElement87->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_nextAcceptableElement87);
  meth_meth_collectionsPrelude_nextAcceptableElement87->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_nextAcceptableElement87->definitionModule = modulename;
  meth_meth_collectionsPrelude_nextAcceptableElement87->definitionLine = 201;
// method "hasNextAcceptableElement"
  block_savedest(obj51);
  Object closure104 = createclosure(1, "hasNextAcceptableElement");
  setclosureframe(closure104, stackframe);
  addtoclosure(closure104, var_predicate);
  struct UserObject *uo104 = (struct UserObject*)obj51;
  uo104->data[8] = (Object)closure104;
  Method *meth_meth_collectionsPrelude_hasNextAcceptableElement104 = addmethod2pos(obj51, "hasNextAcceptableElement", &meth_collectionsPrelude_hasNextAcceptableElement104, 8);
  int argcv_meth_collectionsPrelude_hasNextAcceptableElement104[] = {0};
  meth_meth_collectionsPrelude_hasNextAcceptableElement104->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNextAcceptableElement104);
  meth_meth_collectionsPrelude_hasNextAcceptableElement104->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_hasNextAcceptableElement104->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNextAcceptableElement104->definitionLine = 210;
  sourceObject = obj51;
  adddatum2(obj51, undefined, 1);
  sourceObject = obj51;
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool135 = alloc_Boolean(0);
// compiled identifier node returning bool135 (depth = 2)
  adddatum2(obj51, bool135, 2);
  sourceObject = obj51;
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe136 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_source (depth = 3)
  Object call137 = callmethodflags(*var_source, "iterator", 0, partcv, params, 0);
  gc_frame_end(callframe136);
// compiled member node returning call137 (depth = 2)
  adddatum2(obj51, call137, 3);
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  objclass51 = obj51->class;
  objclass51->definitionModule = modulename;
  objclass51->definitionLine = 186;
  (*(struct UserObject *)self).data[0] = lowerouter51;
  self = oldself51;
  selfslot = oldselfslot51;
  stackframe = oldstackframe51;
  gc_frame_end(frame);
  return obj51;
}
Object meth_collectionsPrelude_asDebugString139(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit141 == NULL) {
    strlit141 = alloc_String("");
    gc_root(strlit141);
  }
// compiled string node returning strlit141 (depth = 3)
  int op_slot_right_140 = gc_frame_newslot(strlit141);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  int op_slot_right_143 = gc_frame_newslot(*var_source);
// starting to compile string node (depth = 4)
  if (strlit145 == NULL) {
    strlit145 = alloc_String("a lazy sequence filtering ");
    gc_root(strlit145);
  }
// compiled string node returning strlit145 (depth = 4)
  int op_slot_left_143 = gc_frame_newslot(strlit145);
  params[0] = *var_source;
  partcv[0] = 1;
  Object opresult146 = callmethod(strlit145, "++(1)", 1, partcv, params);
// compiled op node returning opresult146 (depth = 3)
  int op_slot_left_140 = gc_frame_newslot(opresult146);
  params[0] = strlit141;
  partcv[0] = 1;
  Object opresult147 = callmethod(opresult146, "++(1)", 1, partcv, params);
// compiled op node returning opresult147 (depth = 2)
  gc_frame_end(frame);
  return opresult147;
}
Object meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazySequenceOver(1)filteredBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver(_)filteredBy(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver(_)filteredBy(_)");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for lazySequenceOver(_)filteredBy(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lazySequenceOver(_)");
  Object *var_predicate = &(stackframe->slots[1]);
  *var_predicate = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part filteredBy(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject48 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj48 = alloc_userobj2(3,4, objclass48);
  gc_frame_newslot(obj48);
if (objclass48 == NULL) {
  glfree(obj48->class->name);
  obj48->class->name = "lazySequenceOver(_)filteredBy(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj48, self, 0);
  addmethodreal(obj48,"outer", &reader_collectionsPrelude_outer_49);
  Object oldself48 = self;
  struct StackFrameObject *oldstackframe48 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe48);
  gc_frame_newslot((Object)stackframe);
  self = obj48;
  Object *oldselfslot48 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter48 = (*(struct UserObject *)self).data[0], lowerouter48 = thisouter48;
  if (inheritingObject48) {
    struct UserObject *inho48 = (struct UserObject *)inheritingObject48;
    while (inho48->super != GraceDefaultObject) inho48 = (struct UserObject *)inho48->super;
    inho48->super = obj48;
    self = inheritingObject48;
    *selfslot = self;
    lowerouter48 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter48;
  }
// method "iterator"
  block_savedest(obj48);
  Object closure50 = createclosure(2, "iterator");
  setclosureframe(closure50, stackframe);
  addtoclosure(closure50, var_source);
  addtoclosure(closure50, var_predicate);
  struct UserObject *uo50 = (struct UserObject*)obj48;
  uo50->data[1] = (Object)closure50;
  Method *meth_meth_collectionsPrelude_iterator50 = addmethod2pos(obj48, "iterator", &meth_collectionsPrelude_iterator50, 1);
  int argcv_meth_collectionsPrelude_iterator50[] = {0};
  meth_meth_collectionsPrelude_iterator50->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator50);
  meth_meth_collectionsPrelude_iterator50->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator50->definitionLine = 186;
  block_savedest(obj48);
  Object closure138 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure138, stackframe);
  addtoclosure(closure138, var_source);
  addtoclosure(closure138, var_predicate);
  Method *meth_meth_collectionsPrelude_iterator50_object = addmethod2pos(obj48, "iterator$object(1)", &meth_collectionsPrelude_iterator50_object, 1);
  meth_meth_collectionsPrelude_iterator50_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator50_object->definitionLine = 186;
// method "asDebugString"
  block_savedest(obj48);
  Object closure139 = createclosure(1, "asDebugString");
  setclosureframe(closure139, stackframe);
  addtoclosure(closure139, var_source);
  struct UserObject *uo139 = (struct UserObject*)obj48;
  uo139->data[2] = (Object)closure139;
  Method *meth_meth_collectionsPrelude_asDebugString139 = addmethod2pos(obj48, "asDebugString", &meth_collectionsPrelude_asDebugString139, 2);
  int argcv_meth_collectionsPrelude_asDebugString139[] = {0};
  meth_meth_collectionsPrelude_asDebugString139->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString139);
  meth_meth_collectionsPrelude_asDebugString139->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString139->definitionLine = 225;
  sourceObject = obj48;
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe148 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call149 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe148);
// compiled call node returning call149 (depth = 2)
  struct UserObject *obj48_uo = (struct UserObject *)obj48;
  obj48_uo->super = call149;
  sourceObject = obj48;
  sourceObject = obj48;
  objclass48 = obj48->class;
  objclass48->definitionModule = modulename;
  objclass48->definitionLine = 183;
  (*(struct UserObject *)self).data[0] = lowerouter48;
  self = oldself48;
  selfslot = oldselfslot48;
  stackframe = oldstackframe48;
  gc_frame_end(frame);
  return obj48;
}
Object meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazySequenceOver(1)filteredBy(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method lazySequenceOver(_)filteredBy(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method lazySequenceOver(_)filteredBy(_)");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for lazySequenceOver(_)filteredBy(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lazySequenceOver(_)");
  Object *var_predicate = &(stackframe->slots[1]);
  *var_predicate = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part filteredBy(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject48 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj48 = alloc_userobj2(3,4, objclass48);
  gc_frame_newslot(obj48);
if (objclass48 == NULL) {
  glfree(obj48->class->name);
  obj48->class->name = "lazySequenceOver(_)filteredBy(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj48, self, 0);
  addmethodreal(obj48,"outer", &reader_collectionsPrelude_outer_49);
  Object oldself48 = self;
  struct StackFrameObject *oldstackframe48 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe48);
  gc_frame_newslot((Object)stackframe);
  self = obj48;
  Object *oldselfslot48 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter48 = (*(struct UserObject *)self).data[0], lowerouter48 = thisouter48;
  if (inheritingObject48) {
    struct UserObject *inho48 = (struct UserObject *)inheritingObject48;
    while (inho48->super != GraceDefaultObject) inho48 = (struct UserObject *)inho48->super;
    inho48->super = obj48;
    self = inheritingObject48;
    *selfslot = self;
    lowerouter48 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter48;
  }
// method "iterator"
  block_savedest(obj48);
  Object closure50 = createclosure(2, "iterator");
  setclosureframe(closure50, stackframe);
  addtoclosure(closure50, var_source);
  addtoclosure(closure50, var_predicate);
  struct UserObject *uo50 = (struct UserObject*)obj48;
  uo50->data[1] = (Object)closure50;
  Method *meth_meth_collectionsPrelude_iterator50 = addmethod2pos(obj48, "iterator", &meth_collectionsPrelude_iterator50, 1);
  int argcv_meth_collectionsPrelude_iterator50[] = {0};
  meth_meth_collectionsPrelude_iterator50->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator50);
  meth_meth_collectionsPrelude_iterator50->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator50->definitionLine = 186;
  block_savedest(obj48);
  Object closure138 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure138, stackframe);
  addtoclosure(closure138, var_source);
  addtoclosure(closure138, var_predicate);
  Method *meth_meth_collectionsPrelude_iterator50_object = addmethod2pos(obj48, "iterator$object(1)", &meth_collectionsPrelude_iterator50_object, 1);
  meth_meth_collectionsPrelude_iterator50_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator50_object->definitionLine = 186;
// method "asDebugString"
  block_savedest(obj48);
  Object closure139 = createclosure(1, "asDebugString");
  setclosureframe(closure139, stackframe);
  addtoclosure(closure139, var_source);
  struct UserObject *uo139 = (struct UserObject*)obj48;
  uo139->data[2] = (Object)closure139;
  Method *meth_meth_collectionsPrelude_asDebugString139 = addmethod2pos(obj48, "asDebugString", &meth_collectionsPrelude_asDebugString139, 2);
  int argcv_meth_collectionsPrelude_asDebugString139[] = {0};
  meth_meth_collectionsPrelude_asDebugString139->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString139);
  meth_meth_collectionsPrelude_asDebugString139->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString139->definitionLine = 225;
  sourceObject = obj48;
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe148 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call149 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe148);
// compiled call node returning call149 (depth = 2)
  struct UserObject *obj48_uo = (struct UserObject *)obj48;
  obj48_uo->super = call149;
  sourceObject = obj48;
  sourceObject = obj48;
  objclass48 = obj48->class;
  objclass48->definitionModule = modulename;
  objclass48->definitionLine = 183;
  (*(struct UserObject *)self).data[0] = lowerouter48;
  self = oldself48;
  selfslot = oldselfslot48;
  stackframe = oldstackframe48;
  gc_frame_end(frame);
  return obj48;
}
Object meth_collectionsPrelude_next154(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_left = getfromclosure(closure, 0);
  Object *var_right = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe156 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_left (depth = 4)
  Object call157 = callmethodflags(*var_left, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe156);
// compiled member node returning call157 (depth = 3)
  Object if155 = done;
  if (istrue(call157)) {
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe158 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_left (depth = 4)
  Object call159 = callmethodflags(*var_left, "next", 0, partcv, params, 0);
  gc_frame_end(callframe158);
// compiled member node returning call159 (depth = 3)
    gc_frame_newslot(call159);
    if155 = call159;
  } else {
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe160 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  Object call161 = callmethodflags(*var_right, "next", 0, partcv, params, 0);
  gc_frame_end(callframe160);
// compiled member node returning call161 (depth = 3)
    gc_frame_newslot(call161);
    if155 = call161;
  }
// compiled if node returning if155 (depth = 2)
  gc_frame_end(frame);
  return if155;
}
Object meth_collectionsPrelude_hasNext162(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_left = getfromclosure(closure, 0);
  Object *var_right = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe164 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_left (depth = 4)
  Object call165 = callmethodflags(*var_left, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe164);
// compiled member node returning call165 (depth = 3)
  Object if163 = done;
  if (istrue(call165)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool166 = alloc_Boolean(1);
// compiled identifier node returning bool166 (depth = 4)
  return bool166;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if163 = undefined;
  } else {
  }
// compiled if node returning if163 (depth = 2)
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe167 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  Object call168 = callmethodflags(*var_right, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe167);
// compiled member node returning call168 (depth = 3)
  return call168;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_asDebugString169(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_right = getfromclosure(closure, 0);
  Object *var_left = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit171 == NULL) {
    strlit171 = alloc_String("");
    gc_root(strlit171);
  }
// compiled string node returning strlit171 (depth = 3)
  int op_slot_right_170 = gc_frame_newslot(strlit171);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  int op_slot_right_173 = gc_frame_newslot(*var_right);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit176 == NULL) {
    strlit176 = alloc_String(" and ");
    gc_root(strlit176);
  }
// compiled string node returning strlit176 (depth = 5)
  int op_slot_right_175 = gc_frame_newslot(strlit176);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_left (depth = 6)
  int op_slot_right_178 = gc_frame_newslot(*var_left);
// starting to compile string node (depth = 6)
  if (strlit180 == NULL) {
    strlit180 = alloc_String("iteratorConcat of ");
    gc_root(strlit180);
  }
// compiled string node returning strlit180 (depth = 6)
  int op_slot_left_178 = gc_frame_newslot(strlit180);
  params[0] = *var_left;
  partcv[0] = 1;
  Object opresult181 = callmethod(strlit180, "++(1)", 1, partcv, params);
// compiled op node returning opresult181 (depth = 5)
  int op_slot_left_175 = gc_frame_newslot(opresult181);
  params[0] = strlit176;
  partcv[0] = 1;
  Object opresult182 = callmethod(opresult181, "++(1)", 1, partcv, params);
// compiled op node returning opresult182 (depth = 4)
  int op_slot_left_173 = gc_frame_newslot(opresult182);
  params[0] = *var_right;
  partcv[0] = 1;
  Object opresult183 = callmethod(opresult182, "++(1)", 1, partcv, params);
// compiled op node returning opresult183 (depth = 3)
  int op_slot_left_170 = gc_frame_newslot(opresult183);
  params[0] = strlit171;
  partcv[0] = 1;
  Object opresult184 = callmethod(opresult183, "++(1)", 1, partcv, params);
// compiled op node returning opresult184 (depth = 2)
  gc_frame_end(frame);
  return opresult184;
}
Object meth_collectionsPrelude_asString185(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit186 == NULL) {
    strlit186 = alloc_String("an iterator over a concatenation");
    gc_root(strlit186);
  }
// compiled string node returning strlit186 (depth = 2)
  gc_frame_end(frame);
  return strlit186;
}
Object meth_collectionsPrelude_iteratorConcat_40_2_41_151(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iteratorConcat(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method iteratorConcat(_,_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iteratorConcat(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part iteratorConcat(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject152 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj152 = alloc_userobj2(4,5, objclass152);
  gc_frame_newslot(obj152);
if (objclass152 == NULL) {
  glfree(obj152->class->name);
  obj152->class->name = "iteratorConcat(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj152, self, 0);
  addmethodreal(obj152,"outer", &reader_collectionsPrelude_outer_153);
  Object oldself152 = self;
  struct StackFrameObject *oldstackframe152 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe152);
  gc_frame_newslot((Object)stackframe);
  self = obj152;
  Object *oldselfslot152 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter152 = (*(struct UserObject *)self).data[0], lowerouter152 = thisouter152;
  if (inheritingObject152) {
    struct UserObject *inho152 = (struct UserObject *)inheritingObject152;
    while (inho152->super != GraceDefaultObject) inho152 = (struct UserObject *)inho152->super;
    inho152->super = obj152;
    self = inheritingObject152;
    *selfslot = self;
    lowerouter152 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter152;
  }
// method "next"
  block_savedest(obj152);
  Object closure154 = createclosure(2, "next");
  setclosureframe(closure154, stackframe);
  addtoclosure(closure154, var_left);
  addtoclosure(closure154, var_right);
  struct UserObject *uo154 = (struct UserObject*)obj152;
  uo154->data[1] = (Object)closure154;
  Method *meth_meth_collectionsPrelude_next154 = addmethod2pos(obj152, "next", &meth_collectionsPrelude_next154, 1);
  int argcv_meth_collectionsPrelude_next154[] = {0};
  meth_meth_collectionsPrelude_next154->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next154);
  meth_meth_collectionsPrelude_next154->definitionModule = modulename;
  meth_meth_collectionsPrelude_next154->definitionLine = 229;
// method "hasNext"
  block_savedest(obj152);
  Object closure162 = createclosure(2, "hasNext");
  setclosureframe(closure162, stackframe);
  addtoclosure(closure162, var_left);
  addtoclosure(closure162, var_right);
  struct UserObject *uo162 = (struct UserObject*)obj152;
  uo162->data[2] = (Object)closure162;
  Method *meth_meth_collectionsPrelude_hasNext162 = addmethod2pos(obj152, "hasNext", &meth_collectionsPrelude_hasNext162, 2);
  int argcv_meth_collectionsPrelude_hasNext162[] = {0};
  meth_meth_collectionsPrelude_hasNext162->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext162);
  meth_meth_collectionsPrelude_hasNext162->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext162->definitionLine = 236;
// method "asDebugString"
  block_savedest(obj152);
  Object closure169 = createclosure(2, "asDebugString");
  setclosureframe(closure169, stackframe);
  addtoclosure(closure169, var_right);
  addtoclosure(closure169, var_left);
  struct UserObject *uo169 = (struct UserObject*)obj152;
  uo169->data[3] = (Object)closure169;
  Method *meth_meth_collectionsPrelude_asDebugString169 = addmethod2pos(obj152, "asDebugString", &meth_collectionsPrelude_asDebugString169, 3);
  int argcv_meth_collectionsPrelude_asDebugString169[] = {0};
  meth_meth_collectionsPrelude_asDebugString169->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString169);
  meth_meth_collectionsPrelude_asDebugString169->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString169->definitionLine = 240;
// method "asString"
  struct UserObject *uo185 = (struct UserObject*)obj152;
  uo185->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString185 = addmethod2pos(obj152, "asString", &meth_collectionsPrelude_asString185, 4);
  int argcv_meth_collectionsPrelude_asString185[] = {0};
  meth_meth_collectionsPrelude_asString185->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString185);
  meth_meth_collectionsPrelude_asString185->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString185->definitionLine = 241;
  sourceObject = obj152;
  sourceObject = obj152;
  sourceObject = obj152;
  sourceObject = obj152;
  objclass152 = obj152->class;
  objclass152->definitionModule = modulename;
  objclass152->definitionLine = 228;
  (*(struct UserObject *)self).data[0] = lowerouter152;
  self = oldself152;
  selfslot = oldselfslot152;
  stackframe = oldstackframe152;
  gc_frame_end(frame);
  return obj152;
}
Object meth_collectionsPrelude_iteratorConcat_40_2_41_151_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iteratorConcat(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method iteratorConcat(_,_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iteratorConcat(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part iteratorConcat(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject152 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj152 = alloc_userobj2(4,5, objclass152);
  gc_frame_newslot(obj152);
if (objclass152 == NULL) {
  glfree(obj152->class->name);
  obj152->class->name = "iteratorConcat(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj152, self, 0);
  addmethodreal(obj152,"outer", &reader_collectionsPrelude_outer_153);
  Object oldself152 = self;
  struct StackFrameObject *oldstackframe152 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe152);
  gc_frame_newslot((Object)stackframe);
  self = obj152;
  Object *oldselfslot152 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter152 = (*(struct UserObject *)self).data[0], lowerouter152 = thisouter152;
  if (inheritingObject152) {
    struct UserObject *inho152 = (struct UserObject *)inheritingObject152;
    while (inho152->super != GraceDefaultObject) inho152 = (struct UserObject *)inho152->super;
    inho152->super = obj152;
    self = inheritingObject152;
    *selfslot = self;
    lowerouter152 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter152;
  }
// method "next"
  block_savedest(obj152);
  Object closure154 = createclosure(2, "next");
  setclosureframe(closure154, stackframe);
  addtoclosure(closure154, var_left);
  addtoclosure(closure154, var_right);
  struct UserObject *uo154 = (struct UserObject*)obj152;
  uo154->data[1] = (Object)closure154;
  Method *meth_meth_collectionsPrelude_next154 = addmethod2pos(obj152, "next", &meth_collectionsPrelude_next154, 1);
  int argcv_meth_collectionsPrelude_next154[] = {0};
  meth_meth_collectionsPrelude_next154->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next154);
  meth_meth_collectionsPrelude_next154->definitionModule = modulename;
  meth_meth_collectionsPrelude_next154->definitionLine = 229;
// method "hasNext"
  block_savedest(obj152);
  Object closure162 = createclosure(2, "hasNext");
  setclosureframe(closure162, stackframe);
  addtoclosure(closure162, var_left);
  addtoclosure(closure162, var_right);
  struct UserObject *uo162 = (struct UserObject*)obj152;
  uo162->data[2] = (Object)closure162;
  Method *meth_meth_collectionsPrelude_hasNext162 = addmethod2pos(obj152, "hasNext", &meth_collectionsPrelude_hasNext162, 2);
  int argcv_meth_collectionsPrelude_hasNext162[] = {0};
  meth_meth_collectionsPrelude_hasNext162->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext162);
  meth_meth_collectionsPrelude_hasNext162->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext162->definitionLine = 236;
// method "asDebugString"
  block_savedest(obj152);
  Object closure169 = createclosure(2, "asDebugString");
  setclosureframe(closure169, stackframe);
  addtoclosure(closure169, var_right);
  addtoclosure(closure169, var_left);
  struct UserObject *uo169 = (struct UserObject*)obj152;
  uo169->data[3] = (Object)closure169;
  Method *meth_meth_collectionsPrelude_asDebugString169 = addmethod2pos(obj152, "asDebugString", &meth_collectionsPrelude_asDebugString169, 3);
  int argcv_meth_collectionsPrelude_asDebugString169[] = {0};
  meth_meth_collectionsPrelude_asDebugString169->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString169);
  meth_meth_collectionsPrelude_asDebugString169->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString169->definitionLine = 240;
// method "asString"
  struct UserObject *uo185 = (struct UserObject*)obj152;
  uo185->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString185 = addmethod2pos(obj152, "asString", &meth_collectionsPrelude_asString185, 4);
  int argcv_meth_collectionsPrelude_asString185[] = {0};
  meth_meth_collectionsPrelude_asString185->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString185);
  meth_meth_collectionsPrelude_asString185->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString185->definitionLine = 241;
  sourceObject = obj152;
  sourceObject = obj152;
  sourceObject = obj152;
  sourceObject = obj152;
  objclass152 = obj152->class;
  objclass152->definitionModule = modulename;
  objclass152->definitionLine = 228;
  (*(struct UserObject *)self).data[0] = lowerouter152;
  self = oldself152;
  selfslot = oldselfslot152;
  stackframe = oldstackframe152;
  gc_frame_end(frame);
  return obj152;
}
Object meth_collectionsPrelude_iterator191(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_left = getfromclosure(closure, 0);
  Object *var_right = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe192 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe193 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_left (depth = 4)
  Object call194 = callmethodflags(*var_left, "iterator", 0, partcv, params, 0);
  gc_frame_end(callframe193);
// compiled member node returning call194 (depth = 3)
  gc_frame_newslot(call194);
// starting to compile member node (depth = 3)
  int callframe195 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  Object call196 = callmethodflags(*var_right, "iterator", 0, partcv, params, 0);
  gc_frame_end(callframe195);
// compiled member node returning call196 (depth = 3)
  gc_frame_newslot(call196);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe197 = gc_frame_new();
// call case 3: self.outer request
  Object call198 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe197);
// compiled member node returning call198 (depth = 3)
  params[0] = call194;
  params[1] = call196;
  partcv[0] = 2;
  Object call199 = callmethodflags(call198, "iteratorConcat(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe192);
// compiled call node returning call199 (depth = 2)
  gc_frame_end(frame);
  return call199;
}
Object meth_collectionsPrelude_asDebugString200(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_right = getfromclosure(closure, 0);
  Object *var_left = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit202 == NULL) {
    strlit202 = alloc_String("");
    gc_root(strlit202);
  }
// compiled string node returning strlit202 (depth = 3)
  int op_slot_right_201 = gc_frame_newslot(strlit202);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  int op_slot_right_204 = gc_frame_newslot(*var_right);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit207 == NULL) {
    strlit207 = alloc_String(" and ");
    gc_root(strlit207);
  }
// compiled string node returning strlit207 (depth = 5)
  int op_slot_right_206 = gc_frame_newslot(strlit207);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_left (depth = 6)
  int op_slot_right_209 = gc_frame_newslot(*var_left);
// starting to compile string node (depth = 6)
  if (strlit211 == NULL) {
    strlit211 = alloc_String("lazy concatenation of ");
    gc_root(strlit211);
  }
// compiled string node returning strlit211 (depth = 6)
  int op_slot_left_209 = gc_frame_newslot(strlit211);
  params[0] = *var_left;
  partcv[0] = 1;
  Object opresult212 = callmethod(strlit211, "++(1)", 1, partcv, params);
// compiled op node returning opresult212 (depth = 5)
  int op_slot_left_206 = gc_frame_newslot(opresult212);
  params[0] = strlit207;
  partcv[0] = 1;
  Object opresult213 = callmethod(opresult212, "++(1)", 1, partcv, params);
// compiled op node returning opresult213 (depth = 4)
  int op_slot_left_204 = gc_frame_newslot(opresult213);
  params[0] = *var_right;
  partcv[0] = 1;
  Object opresult214 = callmethod(opresult213, "++(1)", 1, partcv, params);
// compiled op node returning opresult214 (depth = 3)
  int op_slot_left_201 = gc_frame_newslot(opresult214);
  params[0] = strlit202;
  partcv[0] = 1;
  Object opresult215 = callmethod(opresult214, "++(1)", 1, partcv, params);
// compiled op node returning opresult215 (depth = 2)
  gc_frame_end(frame);
  return opresult215;
}
Object meth_collectionsPrelude_asString216(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe217 = gc_frame_new();
// call case 1: super request
  Object call218 = callmethod4(self, "asString", 0, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe217);
// compiled member node returning call218 (depth = 2)
  gc_frame_end(frame);
  return call218;
}
Object meth_collectionsPrelude_size219(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_right = getfromclosure(closure, 0);
  Object *var_left = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe221 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  Object call222 = callmethodflags(*var_right, "size", 0, partcv, params, 0);
  gc_frame_end(callframe221);
// compiled member node returning call222 (depth = 3)
  int op_slot_right_220 = gc_frame_newslot(call222);
// starting to compile member node (depth = 3)
  int callframe224 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_left (depth = 4)
  Object call225 = callmethodflags(*var_left, "size", 0, partcv, params, 0);
  gc_frame_end(callframe224);
// compiled member node returning call225 (depth = 3)
  int op_slot_left_220 = gc_frame_newslot(call225);
  params[0] = call222;
  partcv[0] = 1;
  Object sum226 = callmethod(call225, "+(1)", 1, partcv, params);
// compiled op node returning sum226 (depth = 2)
  gc_frame_end(frame);
  return sum226;
}
Object meth_collectionsPrelude_lazyConcatenation_40_2_41_188(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazyConcatenation(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method lazyConcatenation(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lazyConcatenation(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part lazyConcatenation(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject189 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj189 = alloc_userobj2(4,5, objclass189);
  gc_frame_newslot(obj189);
if (objclass189 == NULL) {
  glfree(obj189->class->name);
  obj189->class->name = "lazyConcatenation(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj189, self, 0);
  addmethodreal(obj189,"outer", &reader_collectionsPrelude_outer_190);
  Object oldself189 = self;
  struct StackFrameObject *oldstackframe189 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe189);
  gc_frame_newslot((Object)stackframe);
  self = obj189;
  Object *oldselfslot189 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter189 = (*(struct UserObject *)self).data[0], lowerouter189 = thisouter189;
  if (inheritingObject189) {
    struct UserObject *inho189 = (struct UserObject *)inheritingObject189;
    while (inho189->super != GraceDefaultObject) inho189 = (struct UserObject *)inho189->super;
    inho189->super = obj189;
    self = inheritingObject189;
    *selfslot = self;
    lowerouter189 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter189;
  }
// method "iterator"
  block_savedest(obj189);
  Object closure191 = createclosure(2, "iterator");
  setclosureframe(closure191, stackframe);
  addtoclosure(closure191, var_left);
  addtoclosure(closure191, var_right);
  struct UserObject *uo191 = (struct UserObject*)obj189;
  uo191->data[1] = (Object)closure191;
  Method *meth_meth_collectionsPrelude_iterator191 = addmethod2pos(obj189, "iterator", &meth_collectionsPrelude_iterator191, 1);
  int argcv_meth_collectionsPrelude_iterator191[] = {0};
  meth_meth_collectionsPrelude_iterator191->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator191);
  meth_meth_collectionsPrelude_iterator191->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator191->definitionLine = 245;
// method "asDebugString"
  block_savedest(obj189);
  Object closure200 = createclosure(2, "asDebugString");
  setclosureframe(closure200, stackframe);
  addtoclosure(closure200, var_right);
  addtoclosure(closure200, var_left);
  struct UserObject *uo200 = (struct UserObject*)obj189;
  uo200->data[2] = (Object)closure200;
  Method *meth_meth_collectionsPrelude_asDebugString200 = addmethod2pos(obj189, "asDebugString", &meth_collectionsPrelude_asDebugString200, 2);
  int argcv_meth_collectionsPrelude_asDebugString200[] = {0};
  meth_meth_collectionsPrelude_asDebugString200->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString200);
  meth_meth_collectionsPrelude_asDebugString200->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString200->definitionLine = 248;
// method "asString"
  struct UserObject *uo216 = (struct UserObject*)obj189;
  uo216->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString216 = addmethod2pos(obj189, "asString", &meth_collectionsPrelude_asString216, 3);
  int argcv_meth_collectionsPrelude_asString216[] = {0};
  meth_meth_collectionsPrelude_asString216->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString216);
  meth_meth_collectionsPrelude_asString216->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString216->definitionLine = 249;
// method "size"
  block_savedest(obj189);
  Object closure219 = createclosure(2, "size");
  setclosureframe(closure219, stackframe);
  addtoclosure(closure219, var_right);
  addtoclosure(closure219, var_left);
  struct UserObject *uo219 = (struct UserObject*)obj189;
  uo219->data[4] = (Object)closure219;
  Method *meth_meth_collectionsPrelude_size219 = addmethod2pos(obj189, "size", &meth_collectionsPrelude_size219, 4);
  int argcv_meth_collectionsPrelude_size219[] = {0};
  meth_meth_collectionsPrelude_size219->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size219);
  meth_meth_collectionsPrelude_size219->definitionModule = modulename;
  meth_meth_collectionsPrelude_size219->definitionLine = 250;
  sourceObject = obj189;
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe227 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call228 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe227);
// compiled call node returning call228 (depth = 2)
  struct UserObject *obj189_uo = (struct UserObject *)obj189;
  obj189_uo->super = call228;
  sourceObject = obj189;
  sourceObject = obj189;
  sourceObject = obj189;
  sourceObject = obj189;
  objclass189 = obj189->class;
  objclass189->definitionModule = modulename;
  objclass189->definitionLine = 243;
  (*(struct UserObject *)self).data[0] = lowerouter189;
  self = oldself189;
  selfslot = oldselfslot189;
  stackframe = oldstackframe189;
  gc_frame_end(frame);
  return obj189;
}
Object meth_collectionsPrelude_lazyConcatenation_40_2_41_188_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazyConcatenation(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method lazyConcatenation(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lazyConcatenation(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part lazyConcatenation(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject189 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj189 = alloc_userobj2(4,5, objclass189);
  gc_frame_newslot(obj189);
if (objclass189 == NULL) {
  glfree(obj189->class->name);
  obj189->class->name = "lazyConcatenation(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj189, self, 0);
  addmethodreal(obj189,"outer", &reader_collectionsPrelude_outer_190);
  Object oldself189 = self;
  struct StackFrameObject *oldstackframe189 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe189);
  gc_frame_newslot((Object)stackframe);
  self = obj189;
  Object *oldselfslot189 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter189 = (*(struct UserObject *)self).data[0], lowerouter189 = thisouter189;
  if (inheritingObject189) {
    struct UserObject *inho189 = (struct UserObject *)inheritingObject189;
    while (inho189->super != GraceDefaultObject) inho189 = (struct UserObject *)inho189->super;
    inho189->super = obj189;
    self = inheritingObject189;
    *selfslot = self;
    lowerouter189 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter189;
  }
// method "iterator"
  block_savedest(obj189);
  Object closure191 = createclosure(2, "iterator");
  setclosureframe(closure191, stackframe);
  addtoclosure(closure191, var_left);
  addtoclosure(closure191, var_right);
  struct UserObject *uo191 = (struct UserObject*)obj189;
  uo191->data[1] = (Object)closure191;
  Method *meth_meth_collectionsPrelude_iterator191 = addmethod2pos(obj189, "iterator", &meth_collectionsPrelude_iterator191, 1);
  int argcv_meth_collectionsPrelude_iterator191[] = {0};
  meth_meth_collectionsPrelude_iterator191->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator191);
  meth_meth_collectionsPrelude_iterator191->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator191->definitionLine = 245;
// method "asDebugString"
  block_savedest(obj189);
  Object closure200 = createclosure(2, "asDebugString");
  setclosureframe(closure200, stackframe);
  addtoclosure(closure200, var_right);
  addtoclosure(closure200, var_left);
  struct UserObject *uo200 = (struct UserObject*)obj189;
  uo200->data[2] = (Object)closure200;
  Method *meth_meth_collectionsPrelude_asDebugString200 = addmethod2pos(obj189, "asDebugString", &meth_collectionsPrelude_asDebugString200, 2);
  int argcv_meth_collectionsPrelude_asDebugString200[] = {0};
  meth_meth_collectionsPrelude_asDebugString200->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString200);
  meth_meth_collectionsPrelude_asDebugString200->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString200->definitionLine = 248;
// method "asString"
  struct UserObject *uo216 = (struct UserObject*)obj189;
  uo216->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString216 = addmethod2pos(obj189, "asString", &meth_collectionsPrelude_asString216, 3);
  int argcv_meth_collectionsPrelude_asString216[] = {0};
  meth_meth_collectionsPrelude_asString216->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString216);
  meth_meth_collectionsPrelude_asString216->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString216->definitionLine = 249;
// method "size"
  block_savedest(obj189);
  Object closure219 = createclosure(2, "size");
  setclosureframe(closure219, stackframe);
  addtoclosure(closure219, var_right);
  addtoclosure(closure219, var_left);
  struct UserObject *uo219 = (struct UserObject*)obj189;
  uo219->data[4] = (Object)closure219;
  Method *meth_meth_collectionsPrelude_size219 = addmethod2pos(obj189, "size", &meth_collectionsPrelude_size219, 4);
  int argcv_meth_collectionsPrelude_size219[] = {0};
  meth_meth_collectionsPrelude_size219->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size219);
  meth_meth_collectionsPrelude_size219->definitionModule = modulename;
  meth_meth_collectionsPrelude_size219->definitionLine = 250;
  sourceObject = obj189;
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe227 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call228 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe227);
// compiled call node returning call228 (depth = 2)
  struct UserObject *obj189_uo = (struct UserObject *)obj189;
  obj189_uo->super = call228;
  sourceObject = obj189;
  sourceObject = obj189;
  sourceObject = obj189;
  sourceObject = obj189;
  objclass189 = obj189->class;
  objclass189->definitionModule = modulename;
  objclass189->definitionLine = 243;
  (*(struct UserObject *)self).data[0] = lowerouter189;
  self = oldself189;
  selfslot = oldselfslot189;
  stackframe = oldstackframe189;
  gc_frame_end(frame);
  return obj189;
}
Object meth_collectionsPrelude_max_40_2_41_230(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "max(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method max(_,_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for max(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part max(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  int op_slot_right_232 = gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  int op_slot_left_232 = gc_frame_newslot(*var_a);
  params[0] = *var_b;
  partcv[0] = 1;
  Object opresult234 = callmethod(*var_a, ">(1)", 1, partcv, params);
// compiled op node returning opresult234 (depth = 3)
  Object if231 = done;
  if (istrue(opresult234)) {
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_a (depth = 3)
    gc_frame_newslot(*var_a);
    if231 = *var_a;
  } else {
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_b (depth = 3)
    gc_frame_newslot(*var_b);
    if231 = *var_b;
  }
// compiled if node returning if231 (depth = 2)
  gc_frame_end(frame);
  return if231;
}
Object meth_collectionsPrelude_asString238(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit239 == NULL) {
    strlit239 = alloc_String("a sequence factory");
    gc_root(strlit239);
  }
// compiled string node returning strlit239 (depth = 2)
  gc_frame_end(frame);
  return strlit239;
}
Object meth_collectionsPrelude_empty240(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_emptySequence (depth = 2)
  gc_frame_end(frame);
  return *var_emptySequence;
}
Object meth_collectionsPrelude__apply245(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sizeCertain = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 478
  setline(478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool246 = alloc_Boolean(0);
// compiled identifier node returning bool246 (depth = 6)
  *var_sizeCertain = bool246;
  if (bool246 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num248 = alloc_Float64(8);
// compiled num node returning num248 (depth = 5)
  gc_frame_end(frame);
  return num248;
}
Object meth_collectionsPrelude__apply_40_1_41_261(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_inner = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe262 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elt (depth = 6)
  gc_frame_newslot(*var_elt);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inner (depth = 6)
  params[0] = *var_ix;
  params[1] = *var_elt;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call263 = callmethodflags(*var_inner, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe262);
// compiled call node returning call263 (depth = 5)
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num265 = alloc_Float64(1);
// compiled num node returning num265 (depth = 7)
  int op_slot_right_264 = gc_frame_newslot(num265);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  int op_slot_left_264 = gc_frame_newslot(*var_ix);
  params[0] = num265;
  partcv[0] = 1;
  Object sum267 = callmethod(*var_ix, "+(1)", 1, partcv, params);
// compiled op node returning sum267 (depth = 6)
  *var_ix = sum267;
  if (sum267 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply_40_1_41_296(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_inner = getfromclosure(closure, 0);
  Object *var_newInner = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 496
  setline(496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe297 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 9)
  int callframe298 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_inner (depth = 10)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call299 = callmethodflags(*var_inner, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe298);
// compiled call node returning call299 (depth = 9)
  gc_frame_newslot(call299);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newInner (depth = 9)
  params[0] = *var_i;
  params[1] = call299;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call300 = callmethodflags(*var_newInner, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe297);
// compiled call node returning call300 (depth = 8)
  gc_frame_end(frame);
  return call300;
}
Object meth_collectionsPrelude__apply_40_1_41_273(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_innerSize = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_inner = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newInner = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newInner");
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  int op_slot_right_275 = gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_innerSize (depth = 7)
  int op_slot_left_275 = gc_frame_newslot(*var_innerSize);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult277 = callmethod(*var_innerSize, "≤(1)", 1, partcv, params);
// compiled op node returning opresult277 (depth = 6)
  Object if274 = done;
  if (istrue(opresult277)) {
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe278 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num280 = alloc_Float64(2);
// compiled num node returning num280 (depth = 9)
  int op_slot_right_279 = gc_frame_newslot(num280);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_innerSize (depth = 9)
  int op_slot_left_279 = gc_frame_newslot(*var_innerSize);
  params[0] = num280;
  partcv[0] = 1;
  Object prod282 = callmethod(*var_innerSize, "*(1)", 1, partcv, params);
// compiled op node returning prod282 (depth = 8)
  gc_frame_newslot(prod282);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe283 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var__prelude (depth = 9)
  Object call284 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe283);
// compiled member node returning call284 (depth = 8)
  params[0] = prod282;
  partcv[0] = 1;
  Object call285 = callmethodflags(call284, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe278);
// compiled call node returning call285 (depth = 7)
  *var_newInner = call285;
  if (call285 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe286 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num289 = alloc_Float64(1);
// compiled num node returning num289 (depth = 9)
  int op_slot_right_288 = gc_frame_newslot(num289);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_innerSize (depth = 9)
  int op_slot_left_288 = gc_frame_newslot(*var_innerSize);
  params[0] = num289;
  partcv[0] = 1;
  Object diff291 = callmethod(*var_innerSize, "-(1)", 1, partcv, params);
// compiled op node returning diff291 (depth = 8)
  int op_slot_right_287 = gc_frame_newslot(diff291);
// starting to compile num node (depth = 8)
  Object num293 = alloc_Float64(0);
// compiled num node returning num293 (depth = 8)
  int op_slot_left_287 = gc_frame_newslot(num293);
  params[0] = diff291;
  partcv[0] = 1;
  Object opresult294 = callmethod(num293, "..(1)", 1, partcv, params);
// compiled op node returning opresult294 (depth = 7)
  gc_frame_newslot(opresult294);
// starting to compile block node (depth = 7)
  Object block295 = alloc_Block(NULL, NULL, "collectionsPrelude", 495);
  gc_frame_newslot(block295);
// method "_apply(_)"
  block_savedest(block295);
  Object closure296 = createclosure(3, "_apply(1)");
  setclosureframe(closure296, stackframe);
  addtoclosure(closure296, var_inner);
  addtoclosure(closure296, var_newInner);
  addtoclosure(closure296, selfslot);
  struct UserObject *uo296 = (struct UserObject*)block295;
  uo296->data[0] = (Object)closure296;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_296 = addmethod2pos(block295, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_296, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_296[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_296->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_296);
  meth_meth_collectionsPrelude__apply_40_1_41_296->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_296->definitionLine = 1991;
// compiled block node returning block295 (depth = 7)
  gc_frame_newslot(block295);
// call case 5: prelude request
  params[0] = opresult294;
  params[1] = block295;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call302 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe286);
// compiled call node returning call302 (depth = 6)
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newInner (depth = 7)
  *var_inner = *var_newInner;
  if (*var_newInner == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 499
  setline(499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe304 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_inner (depth = 8)
  Object call305 = callmethodflags(*var_inner, "size", 0, partcv, params, 0);
  gc_frame_end(callframe304);
// compiled member node returning call305 (depth = 7)
  *var_innerSize = call305;
  if (call305 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if274 = done;
  } else {
  }
// compiled if node returning if274 (depth = 5)
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe307 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elt (depth = 6)
  gc_frame_newslot(*var_elt);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inner (depth = 6)
  params[0] = *var_ix;
  params[1] = *var_elt;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call308 = callmethodflags(*var_inner, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe307);
// compiled call node returning call308 (depth = 5)
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num310 = alloc_Float64(1);
// compiled num node returning num310 (depth = 7)
  int op_slot_right_309 = gc_frame_newslot(num310);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  int op_slot_left_309 = gc_frame_newslot(*var_ix);
  params[0] = num310;
  partcv[0] = 1;
  Object sum312 = callmethod(*var_ix, "+(1)", 1, partcv, params);
// compiled op node returning sum312 (depth = 6)
  *var_ix = sum312;
  if (sum312 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_withAll_40_1_41_241(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method withAll(_)");
  Object params[2];
  int partcv[2];
  Object *var__prelude = getfromclosure(closure, 0);
  Object *var_emptySequence = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sizeCertain = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sizeCertain");
  Object *var_forecastSize = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "forecastSize");
  Object *var_inner = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "inner");
  Object *var_innerSize = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "innerSize");
  Object *var_ix = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "ix");
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool242 = alloc_Boolean(1);
// compiled identifier node returning bool242 (depth = 3)
  *var_sizeCertain = bool242;
  if (bool242 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe243 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block244 = alloc_Block(NULL, NULL, "collectionsPrelude", 477);
  gc_frame_newslot(block244);
// method "_apply"
  block_savedest(block244);
  Object closure245 = createclosure(2, "_apply");
  setclosureframe(closure245, stackframe);
  addtoclosure(closure245, var_sizeCertain);
  addtoclosure(closure245, selfslot);
  struct UserObject *uo245 = (struct UserObject*)block244;
  uo245->data[0] = (Object)closure245;
  Method *meth_meth_collectionsPrelude__apply245 = addmethod2pos(block244, "_apply", &meth_collectionsPrelude__apply245, 0);
  int argcv_meth_collectionsPrelude__apply245[] = {0};
  meth_meth_collectionsPrelude__apply245->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply245);
  meth_meth_collectionsPrelude__apply245->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply245->definitionLine = 1991;
// compiled block node returning block244 (depth = 4)
  gc_frame_newslot(block244);
// call case 6: other requests
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_arg (depth = 4)
  params[0] = block244;
  partcv[0] = 1;
  Object call250 = callmethodflags(*var_arg, "sizeIfUnknown(1)", 1, partcv, params, 0);
  gc_frame_end(callframe243);
// compiled call node returning call250 (depth = 3)
  *var_forecastSize = call250;
  if (call250 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe251 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_forecastSize (depth = 4)
  gc_frame_newslot(*var_forecastSize);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe252 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  Object call253 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe252);
// compiled member node returning call253 (depth = 4)
  params[0] = *var_forecastSize;
  partcv[0] = 1;
  Object call254 = callmethodflags(call253, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe251);
// compiled call node returning call254 (depth = 3)
  *var_inner = call254;
  if (call254 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe255 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_inner (depth = 4)
  Object call256 = callmethodflags(*var_inner, "size", 0, partcv, params, 0);
  gc_frame_end(callframe255);
// compiled member node returning call256 (depth = 3)
  *var_innerSize = call256;
  if (call256 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num257 = alloc_Float64(0);
// compiled num node returning num257 (depth = 3)
  *var_ix = num257;
  if (num257 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sizeCertain (depth = 3)
  Object if258 = done;
  if (istrue(*var_sizeCertain)) {
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe259 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_arg (depth = 4)
  gc_frame_newslot(*var_arg);
// starting to compile block node (depth = 4)
  Object block260 = alloc_Block(NULL, NULL, "collectionsPrelude", 486);
  gc_frame_newslot(block260);
// method "_apply(_)"
  block_savedest(block260);
  Object closure261 = createclosure(3, "_apply(1)");
  setclosureframe(closure261, stackframe);
  addtoclosure(closure261, var_ix);
  addtoclosure(closure261, var_inner);
  addtoclosure(closure261, selfslot);
  struct UserObject *uo261 = (struct UserObject*)block260;
  uo261->data[0] = (Object)closure261;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_261 = addmethod2pos(block260, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_261, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_261[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_261->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_261);
  meth_meth_collectionsPrelude__apply_40_1_41_261->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_261->definitionLine = 1991;
// compiled block node returning block260 (depth = 4)
  gc_frame_newslot(block260);
// call case 5: prelude request
  params[0] = *var_arg;
  params[1] = block260;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call270 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe259);
// compiled call node returning call270 (depth = 3)
    gc_frame_newslot(call270);
    if258 = call270;
  } else {
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe271 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_arg (depth = 4)
  gc_frame_newslot(*var_arg);
// starting to compile block node (depth = 4)
  Object block272 = alloc_Block(NULL, NULL, "collectionsPrelude", 492);
  gc_frame_newslot(block272);
// method "_apply(_)"
  block_savedest(block272);
  Object closure273 = createclosure(5, "_apply(1)");
  setclosureframe(closure273, stackframe);
  addtoclosure(closure273, var_ix);
  addtoclosure(closure273, var_innerSize);
  addtoclosure(closure273, var__prelude);
  addtoclosure(closure273, var_inner);
  addtoclosure(closure273, selfslot);
  struct UserObject *uo273 = (struct UserObject*)block272;
  uo273->data[0] = (Object)closure273;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_273 = addmethod2pos(block272, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_273, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_273[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_273->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_273);
  meth_meth_collectionsPrelude__apply_40_1_41_273->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_273->definitionLine = 1991;
// compiled block node returning block272 (depth = 4)
  gc_frame_newslot(block272);
// call case 5: prelude request
  params[0] = *var_arg;
  params[1] = block272;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call315 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe271);
// compiled call node returning call315 (depth = 3)
    gc_frame_newslot(call315);
    if258 = call315;
  }
// compiled if node returning if258 (depth = 2)
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num318 = alloc_Float64(0);
// compiled num node returning num318 (depth = 4)
  int op_slot_right_317 = gc_frame_newslot(num318);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ix (depth = 4)
  int op_slot_left_317 = gc_frame_newslot(*var_ix);
  params[0] = num318;
  partcv[0] = 1;
  Object opresult320 = callmethod(*var_ix, "==(1)", 1, partcv, params);
// compiled op node returning opresult320 (depth = 3)
  Object if316 = done;
  if (istrue(opresult320)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_emptySequence (depth = 4)
  return *var_emptySequence;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if316 = undefined;
  } else {
  }
// compiled if node returning if316 (depth = 2)
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe321 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_inner (depth = 3)
  gc_frame_newslot(*var_inner);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ix (depth = 3)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_inner;
  params[1] = *var_ix;
  partcv[0] = 2;
  Object call322 = callmethodflags(self, "fromprimitiveArray(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe321);
// compiled call node returning call322 (depth = 2)
  gc_frame_end(frame);
  return call322;
}
Object meth_collectionsPrelude_boundsCheck_40_1_41_328(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "boundsCheck(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method boundsCheck(_)");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for boundsCheck(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part boundsCheck(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe331 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe333 = gc_frame_new();
// call case 4: self request
  Object call334 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe333);
// compiled member node returning call334 (depth = 6)
  int op_slot_right_332 = gc_frame_newslot(call334);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_332 = gc_frame_newslot(*var_n);
  params[0] = call334;
  partcv[0] = 1;
  Object opresult336 = callmethod(*var_n, "≤(1)", 1, partcv, params);
// compiled op node returning opresult336 (depth = 5)
  partcv[0] = 0;
  Object call337 = callmethodflags(opresult336, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe331);
// compiled call node returning call337 (depth = 4)
  int op_slot_right_330 = gc_frame_newslot(call337);
// starting to compile call node (depth = 4)
  int callframe339 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num341 = alloc_Float64(1);
// compiled num node returning num341 (depth = 6)
  int op_slot_right_340 = gc_frame_newslot(num341);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_340 = gc_frame_newslot(*var_n);
  params[0] = num341;
  partcv[0] = 1;
  Object opresult343 = callmethod(*var_n, "≥(1)", 1, partcv, params);
// compiled op node returning opresult343 (depth = 5)
  partcv[0] = 0;
  Object call344 = callmethodflags(opresult343, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe339);
// compiled call node returning call344 (depth = 4)
  int op_slot_left_330 = gc_frame_newslot(call344);
  params[0] = call337;
  partcv[0] = 1;
  Object opresult345 = callmethod(call344, "||(1)", 1, partcv, params);
// compiled op node returning opresult345 (depth = 3)
  Object if329 = done;
  if (istrue(opresult345)) {
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe346 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit348 == NULL) {
    strlit348 = alloc_String("");
    gc_root(strlit348);
  }
// compiled string node returning strlit348 (depth = 5)
  int op_slot_right_347 = gc_frame_newslot(strlit348);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe351 = gc_frame_new();
// call case 4: self request
  Object call352 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe351);
// compiled member node returning call352 (depth = 6)
  int op_slot_right_350 = gc_frame_newslot(call352);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit355 == NULL) {
    strlit355 = alloc_String(" out of bounds 1..");
    gc_root(strlit355);
  }
// compiled string node returning strlit355 (depth = 7)
  int op_slot_right_354 = gc_frame_newslot(strlit355);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_right_357 = gc_frame_newslot(*var_n);
// starting to compile string node (depth = 8)
  if (strlit359 == NULL) {
    strlit359 = alloc_String("index ");
    gc_root(strlit359);
  }
// compiled string node returning strlit359 (depth = 8)
  int op_slot_left_357 = gc_frame_newslot(strlit359);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult360 = callmethod(strlit359, "++(1)", 1, partcv, params);
// compiled op node returning opresult360 (depth = 7)
  int op_slot_left_354 = gc_frame_newslot(opresult360);
  params[0] = strlit355;
  partcv[0] = 1;
  Object opresult361 = callmethod(opresult360, "++(1)", 1, partcv, params);
// compiled op node returning opresult361 (depth = 6)
  int op_slot_left_350 = gc_frame_newslot(opresult361);
  params[0] = call352;
  partcv[0] = 1;
  Object opresult362 = callmethod(opresult361, "++(1)", 1, partcv, params);
// compiled op node returning opresult362 (depth = 5)
  int op_slot_left_347 = gc_frame_newslot(opresult362);
  params[0] = strlit348;
  partcv[0] = 1;
  Object opresult363 = callmethod(opresult362, "++(1)", 1, partcv, params);
// compiled op node returning opresult363 (depth = 4)
  gc_frame_newslot(opresult363);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult363;
  partcv[0] = 1;
  Object call364 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe346);
// compiled call node returning call364 (depth = 3)
    gc_frame_newslot(call364);
    if329 = call364;
  } else {
  }
// compiled if node returning if329 (depth = 2)
  gc_frame_end(frame);
  return if329;
}
Object meth_collectionsPrelude_at_40_1_41_365(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe366 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call367 = callmethodflags(self, "boundsCheck(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe366);
// compiled call node returning call367 (depth = 2)
// Begin line 525
  setline(525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe368 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num370 = alloc_Float64(1);
// compiled num node returning num370 (depth = 4)
  int op_slot_right_369 = gc_frame_newslot(num370);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_369 = gc_frame_newslot(*var_n);
  params[0] = num370;
  partcv[0] = 1;
  Object diff372 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff372 (depth = 3)
  gc_frame_newslot(diff372);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe373 = gc_frame_new();
// call case 4: self request
  Object call374 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe373);
// compiled member node returning call374 (depth = 3)
  params[0] = diff372;
  partcv[0] = 1;
  Object call375 = callmethodflags(call374, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe368);
// compiled call node returning call375 (depth = 2)
  gc_frame_end(frame);
  return call375;
}
Object meth_collectionsPrelude_keys376(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe377 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num378 = alloc_Float64(1);
// compiled num node returning num378 (depth = 3)
  gc_frame_newslot(num378);
// starting to compile member node (depth = 3)
  int callframe379 = gc_frame_new();
// call case 4: self request
  Object call380 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe379);
// compiled member node returning call380 (depth = 3)
  gc_frame_newslot(call380);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe381 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe382 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe383 = gc_frame_new();
// call case 3: self.outer request
  Object call384 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe383);
// compiled member node returning call384 (depth = 5)
  Object call385 = callmethodflags(call384, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe382);
// compiled member node returning call385 (depth = 4)
  Object call386 = callmethodflags(call385, "range", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe381);
// compiled member node returning call386 (depth = 3)
  params[0] = num378;
  params[1] = call380;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call387 = callmethodflags(call386, "from(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe377);
// compiled call node returning call387 (depth = 2)
  gc_frame_end(frame);
  return call387;
}
Object meth_collectionsPrelude_values388(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply393(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe395 = gc_frame_new();
// call case 4: self request
  Object call396 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe395);
// compiled member node returning call396 (depth = 5)
  int op_slot_right_394 = gc_frame_newslot(call396);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_394 = gc_frame_newslot(*var_i);
  params[0] = call396;
  partcv[0] = 1;
  Object opresult398 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult398 (depth = 4)
  gc_frame_end(frame);
  return opresult398;
}
Object meth_collectionsPrelude__apply401(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_block2 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 536
  setline(536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe402 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num404 = alloc_Float64(1);
// compiled num node returning num404 (depth = 6)
  int op_slot_right_403 = gc_frame_newslot(num404);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_403 = gc_frame_newslot(*var_i);
  params[0] = num404;
  partcv[0] = 1;
  Object sum406 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum406 (depth = 5)
  gc_frame_newslot(sum406);
// starting to compile call node (depth = 5)
  int callframe407 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe408 = gc_frame_new();
// call case 4: self request
  Object call409 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe408);
// compiled member node returning call409 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call410 = callmethodflags(call409, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe407);
// compiled call node returning call410 (depth = 5)
  gc_frame_newslot(call410);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block2 (depth = 5)
  params[0] = sum406;
  params[1] = call410;
  partcv[0] = 2;
  Object call411 = callmethodflags(*var_block2, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe402);
// compiled call node returning call411 (depth = 4)
// Begin line 537
  setline(537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num413 = alloc_Float64(1);
// compiled num node returning num413 (depth = 6)
  int op_slot_right_412 = gc_frame_newslot(num413);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_412 = gc_frame_newslot(*var_i);
  params[0] = num413;
  partcv[0] = 1;
  Object sum415 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum415 (depth = 5)
  *var_i = sum415;
  if (sum415 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_keysAndValuesDo_40_1_41_389(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num390 = alloc_Float64(0);
// compiled num node returning num390 (depth = 3)
  *var_i = num390;
  if (num390 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe391 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block392 = alloc_Block(NULL, NULL, "collectionsPrelude", 535);
  gc_frame_newslot(block392);
// method "_apply"
  block_savedest(block392);
  Object closure393 = createclosure(2, "_apply");
  setclosureframe(closure393, stackframe);
  addtoclosure(closure393, var_i);
  addtoclosure(closure393, selfslot);
  struct UserObject *uo393 = (struct UserObject*)block392;
  uo393->data[0] = (Object)closure393;
  Method *meth_meth_collectionsPrelude__apply393 = addmethod2pos(block392, "_apply", &meth_collectionsPrelude__apply393, 0);
  int argcv_meth_collectionsPrelude__apply393[] = {0};
  meth_meth_collectionsPrelude__apply393->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply393);
  meth_meth_collectionsPrelude__apply393->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply393->definitionLine = 1991;
// compiled block node returning block392 (depth = 3)
  gc_frame_newslot(block392);
// starting to compile block node (depth = 3)
  Object block400 = alloc_Block(NULL, NULL, "collectionsPrelude", 535);
  gc_frame_newslot(block400);
// method "_apply"
  block_savedest(block400);
  Object closure401 = createclosure(3, "_apply");
  setclosureframe(closure401, stackframe);
  addtoclosure(closure401, var_i);
  addtoclosure(closure401, var_block2);
  addtoclosure(closure401, selfslot);
  struct UserObject *uo401 = (struct UserObject*)block400;
  uo401->data[0] = (Object)closure401;
  Method *meth_meth_collectionsPrelude__apply401 = addmethod2pos(block400, "_apply", &meth_collectionsPrelude__apply401, 0);
  int argcv_meth_collectionsPrelude__apply401[] = {0};
  meth_meth_collectionsPrelude__apply401->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply401);
  meth_meth_collectionsPrelude__apply401->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply401->definitionLine = 1991;
// compiled block node returning block400 (depth = 3)
  gc_frame_newslot(block400);
// call case 5: prelude request
  params[0] = block392;
  params[1] = block400;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call418 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe391);
// compiled call node returning call418 (depth = 2)
  gc_frame_end(frame);
  return call418;
}
Object meth_collectionsPrelude__apply_40_1_41_434(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_freshArray = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe435 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_freshArray (depth = 5)
  params[0] = *var_ix;
  params[1] = *var_each;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call436 = callmethodflags(*var_freshArray, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe435);
// compiled call node returning call436 (depth = 4)
// Begin line 545
  setline(545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num438 = alloc_Float64(1);
// compiled num node returning num438 (depth = 6)
  int op_slot_right_437 = gc_frame_newslot(num438);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_left_437 = gc_frame_newslot(*var_ix);
  params[0] = num438;
  partcv[0] = 1;
  Object diff440 = callmethod(*var_ix, "-(1)", 1, partcv, params);
// compiled op node returning diff440 (depth = 5)
  *var_ix = diff440;
  if (diff440 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_reversed419(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_freshArray = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "freshArray");
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe420 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe421 = gc_frame_new();
// call case 4: self request
  Object call422 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe421);
// compiled member node returning call422 (depth = 4)
  gc_frame_newslot(call422);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe423 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  Object call424 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe423);
// compiled member node returning call424 (depth = 4)
  params[0] = call422;
  partcv[0] = 1;
  Object call425 = callmethodflags(call424, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe420);
// compiled call node returning call425 (depth = 3)
  *var_freshArray = call425;
  if (call425 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num427 = alloc_Float64(1);
// compiled num node returning num427 (depth = 4)
  int op_slot_right_426 = gc_frame_newslot(num427);
// starting to compile member node (depth = 4)
  int callframe429 = gc_frame_new();
// call case 4: self request
  Object call430 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe429);
// compiled member node returning call430 (depth = 4)
  int op_slot_left_426 = gc_frame_newslot(call430);
  params[0] = num427;
  partcv[0] = 1;
  Object diff431 = callmethod(call430, "-(1)", 1, partcv, params);
// compiled op node returning diff431 (depth = 3)
  *var_ix = diff431;
  if (diff431 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe432 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block433 = alloc_Block(NULL, NULL, "collectionsPrelude", 543);
  gc_frame_newslot(block433);
// method "_apply(_)"
  block_savedest(block433);
  Object closure434 = createclosure(3, "_apply(1)");
  setclosureframe(closure434, stackframe);
  addtoclosure(closure434, var_ix);
  addtoclosure(closure434, var_freshArray);
  addtoclosure(closure434, selfslot);
  struct UserObject *uo434 = (struct UserObject*)block433;
  uo434->data[0] = (Object)closure434;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_434 = addmethod2pos(block433, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_434, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_434[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_434->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_434);
  meth_meth_collectionsPrelude__apply_40_1_41_434->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_434->definitionLine = 1991;
// compiled block node returning block433 (depth = 3)
  gc_frame_newslot(block433);
// call case 4: self request
  params[0] = block433;
  partcv[0] = 1;
  Object call443 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe432);
// compiled call node returning call443 (depth = 2)
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe444 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_freshArray (depth = 3)
  gc_frame_newslot(*var_freshArray);
// starting to compile member node (depth = 3)
  int callframe445 = gc_frame_new();
// call case 4: self request
  Object call446 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe445);
// compiled member node returning call446 (depth = 3)
  gc_frame_newslot(call446);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe447 = gc_frame_new();
// call case 3: self.outer request
  Object call448 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe447);
// compiled member node returning call448 (depth = 3)
  params[0] = *var_freshArray;
  params[1] = call446;
  partcv[0] = 2;
  Object call449 = callmethodflags(call448, "fromprimitiveArray(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe444);
// compiled call node returning call449 (depth = 2)
  gc_frame_end(frame);
  return call449;
}
Object meth_collectionsPrelude__43__43__40_1_41_450(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe451 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe452 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe453 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe454 = gc_frame_new();
// call case 3: self.outer request
  Object call455 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe454);
// compiled member node returning call455 (depth = 5)
  Object call456 = callmethodflags(call455, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe453);
// compiled member node returning call456 (depth = 4)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call457 = callmethodflags(call456, "lazyConcatenation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe452);
// compiled call node returning call457 (depth = 3)
  gc_frame_newslot(call457);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe458 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe459 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe460 = gc_frame_new();
// call case 3: self.outer request
  Object call461 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe460);
// compiled member node returning call461 (depth = 5)
  Object call462 = callmethodflags(call461, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe459);
// compiled member node returning call462 (depth = 4)
  Object call463 = callmethodflags(call462, "sequence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe458);
// compiled member node returning call463 (depth = 3)
  params[0] = call457;
  partcv[0] = 1;
  Object call464 = callmethodflags(call463, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe451);
// compiled call node returning call464 (depth = 2)
  gc_frame_end(frame);
  return call464;
}
Object meth_collectionsPrelude__apply_40_1_41_479(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe481 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe482 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe483 = gc_frame_new();
// call case 4: self request
  Object call484 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe483);
// compiled member node returning call484 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call485 = callmethodflags(call484, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe482);
// compiled call node returning call485 (depth = 7)
  Object call486 = callmethodflags(call485, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe481);
// compiled member node returning call486 (depth = 6)
  int op_slot_right_480 = gc_frame_newslot(call486);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_480 = gc_frame_newslot(*var_s);
  params[0] = call486;
  partcv[0] = 1;
  Object opresult488 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult488 (depth = 5)
  *var_s = opresult488;
  if (opresult488 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num493 = alloc_Float64(1);
// compiled num node returning num493 (depth = 7)
  int op_slot_right_492 = gc_frame_newslot(num493);
// starting to compile member node (depth = 7)
  int callframe495 = gc_frame_new();
// call case 4: self request
  Object call496 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe495);
// compiled member node returning call496 (depth = 7)
  int op_slot_left_492 = gc_frame_newslot(call496);
  params[0] = num493;
  partcv[0] = 1;
  Object diff497 = callmethod(call496, "-(1)", 1, partcv, params);
// compiled op node returning diff497 (depth = 6)
  int op_slot_right_491 = gc_frame_newslot(diff497);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_491 = gc_frame_newslot(*var_i);
  params[0] = diff497;
  partcv[0] = 1;
  Object opresult499 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult499 (depth = 5)
  Object if490 = done;
  if (istrue(opresult499)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit501 == NULL) {
    strlit501 = alloc_String(", ");
    gc_root(strlit501);
  }
// compiled string node returning strlit501 (depth = 7)
  int op_slot_right_500 = gc_frame_newslot(strlit501);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_500 = gc_frame_newslot(*var_s);
  params[0] = strlit501;
  partcv[0] = 1;
  Object opresult503 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult503 (depth = 6)
  *var_s = opresult503;
  if (opresult503 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if490 = done;
  } else {
  }
// compiled if node returning if490 (depth = 4)
  gc_frame_end(frame);
  return if490;
}
Object meth_collectionsPrelude_asString465(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit466 == NULL) {
    strlit466 = alloc_String("""\xe2""""\x9f""""\xa8""");
    gc_root(strlit466);
  }
// compiled string node returning strlit466 (depth = 3)
  *var_s = strlit466;
  if (strlit466 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe467 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num470 = alloc_Float64(1);
// compiled num node returning num470 (depth = 5)
  int op_slot_right_469 = gc_frame_newslot(num470);
// starting to compile member node (depth = 5)
  int callframe472 = gc_frame_new();
// call case 4: self request
  Object call473 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe472);
// compiled member node returning call473 (depth = 5)
  int op_slot_left_469 = gc_frame_newslot(call473);
  params[0] = num470;
  partcv[0] = 1;
  Object diff474 = callmethod(call473, "-(1)", 1, partcv, params);
// compiled op node returning diff474 (depth = 4)
  int op_slot_right_468 = gc_frame_newslot(diff474);
// starting to compile num node (depth = 4)
  Object num476 = alloc_Float64(0);
// compiled num node returning num476 (depth = 4)
  int op_slot_left_468 = gc_frame_newslot(num476);
  params[0] = diff474;
  partcv[0] = 1;
  Object opresult477 = callmethod(num476, "..(1)", 1, partcv, params);
// compiled op node returning opresult477 (depth = 3)
  gc_frame_newslot(opresult477);
// starting to compile block node (depth = 3)
  Object block478 = alloc_Block(NULL, NULL, "collectionsPrelude", 554);
  gc_frame_newslot(block478);
// method "_apply(_)"
  block_savedest(block478);
  Object closure479 = createclosure(2, "_apply(1)");
  setclosureframe(closure479, stackframe);
  addtoclosure(closure479, var_s);
  addtoclosure(closure479, selfslot);
  struct UserObject *uo479 = (struct UserObject*)block478;
  uo479->data[0] = (Object)closure479;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_479 = addmethod2pos(block478, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_479, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_479[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_479->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_479);
  meth_meth_collectionsPrelude__apply_40_1_41_479->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_479->definitionLine = 1991;
// compiled block node returning block478 (depth = 3)
  gc_frame_newslot(block478);
// call case 5: prelude request
  params[0] = opresult477;
  params[1] = block478;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call506 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe467);
// compiled call node returning call506 (depth = 2)
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit508 == NULL) {
    strlit508 = alloc_String("""\xe2""""\x9f""""\xa9""");
    gc_root(strlit508);
  }
// compiled string node returning strlit508 (depth = 3)
  int op_slot_right_507 = gc_frame_newslot(strlit508);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_507 = gc_frame_newslot(*var_s);
  params[0] = strlit508;
  partcv[0] = 1;
  Object opresult510 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult510 (depth = 2)
  gc_frame_end(frame);
  return opresult510;
}
Object meth_collectionsPrelude__apply_40_1_41_514(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_element = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_element (depth = 6)
  int op_slot_right_516 = gc_frame_newslot(*var_element);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  int op_slot_left_516 = gc_frame_newslot(*var_each);
  params[0] = *var_element;
  partcv[0] = 1;
  Object opresult518 = callmethod(*var_each, "==(1)", 1, partcv, params);
// compiled op node returning opresult518 (depth = 5)
  Object if515 = done;
  if (istrue(opresult518)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool519 = alloc_Boolean(1);
// compiled identifier node returning bool519 (depth = 6)
  block_return(realself, bool519);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if515 = undefined;
  } else {
  }
// compiled if node returning if515 (depth = 4)
  gc_frame_end(frame);
  return if515;
}
Object meth_collectionsPrelude_contains_40_1_41_511(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_element = &(stackframe->slots[0]);
  *var_element = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 561
  setline(561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe512 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block513 = alloc_Block(NULL, NULL, "collectionsPrelude", 561);
  gc_frame_newslot(block513);
// method "_apply(_)"
  block_savedest(block513);
  Object closure514 = createclosure(2, "_apply(1)");
  setclosureframe(closure514, stackframe);
  addtoclosure(closure514, var_element);
  addtoclosure(closure514, selfslot);
  struct UserObject *uo514 = (struct UserObject*)block513;
  uo514->data[0] = (Object)closure514;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_514 = addmethod2pos(block513, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_514, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_514[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_514->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_514);
  meth_meth_collectionsPrelude__apply_40_1_41_514->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_514->definitionLine = 1991;
// compiled block node returning block513 (depth = 3)
  gc_frame_newslot(block513);
// call case 4: self request
  params[0] = block513;
  partcv[0] = 1;
  Object call521 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe512);
// compiled call node returning call521 (depth = 2)
// Begin line 562
  setline(562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool522 = alloc_Boolean(0);
// compiled identifier node returning bool522 (depth = 3)
  return bool522;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply527(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe529 = gc_frame_new();
// call case 4: self request
  Object call530 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe529);
// compiled member node returning call530 (depth = 5)
  int op_slot_right_528 = gc_frame_newslot(call530);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_528 = gc_frame_newslot(*var_i);
  params[0] = call530;
  partcv[0] = 1;
  Object opresult532 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult532 (depth = 4)
  gc_frame_end(frame);
  return opresult532;
}
Object meth_collectionsPrelude__apply535(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe536 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe537 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe538 = gc_frame_new();
// call case 4: self request
  Object call539 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe538);
// compiled member node returning call539 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call540 = callmethodflags(call539, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe537);
// compiled call node returning call540 (depth = 5)
  gc_frame_newslot(call540);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = call540;
  partcv[0] = 1;
  Object call541 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe536);
// compiled call node returning call541 (depth = 4)
// Begin line 568
  setline(568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num543 = alloc_Float64(1);
// compiled num node returning num543 (depth = 6)
  int op_slot_right_542 = gc_frame_newslot(num543);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_542 = gc_frame_newslot(*var_i);
  params[0] = num543;
  partcv[0] = 1;
  Object sum545 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum545 (depth = 5)
  *var_i = sum545;
  if (sum545 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do_40_1_41_523(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
// Begin line 565
  setline(565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num524 = alloc_Float64(0);
// compiled num node returning num524 (depth = 3)
  *var_i = num524;
  if (num524 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe525 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block526 = alloc_Block(NULL, NULL, "collectionsPrelude", 566);
  gc_frame_newslot(block526);
// method "_apply"
  block_savedest(block526);
  Object closure527 = createclosure(2, "_apply");
  setclosureframe(closure527, stackframe);
  addtoclosure(closure527, var_i);
  addtoclosure(closure527, selfslot);
  struct UserObject *uo527 = (struct UserObject*)block526;
  uo527->data[0] = (Object)closure527;
  Method *meth_meth_collectionsPrelude__apply527 = addmethod2pos(block526, "_apply", &meth_collectionsPrelude__apply527, 0);
  int argcv_meth_collectionsPrelude__apply527[] = {0};
  meth_meth_collectionsPrelude__apply527->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply527);
  meth_meth_collectionsPrelude__apply527->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply527->definitionLine = 1991;
// compiled block node returning block526 (depth = 3)
  gc_frame_newslot(block526);
// starting to compile block node (depth = 3)
  Object block534 = alloc_Block(NULL, NULL, "collectionsPrelude", 566);
  gc_frame_newslot(block534);
// method "_apply"
  block_savedest(block534);
  Object closure535 = createclosure(3, "_apply");
  setclosureframe(closure535, stackframe);
  addtoclosure(closure535, var_i);
  addtoclosure(closure535, var_block1);
  addtoclosure(closure535, selfslot);
  struct UserObject *uo535 = (struct UserObject*)block534;
  uo535->data[0] = (Object)closure535;
  Method *meth_meth_collectionsPrelude__apply535 = addmethod2pos(block534, "_apply", &meth_collectionsPrelude__apply535, 0);
  int argcv_meth_collectionsPrelude__apply535[] = {0};
  meth_meth_collectionsPrelude__apply535->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply535);
  meth_meth_collectionsPrelude__apply535->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply535->definitionLine = 1991;
// compiled block node returning block534 (depth = 3)
  gc_frame_newslot(block534);
// call case 5: prelude request
  params[0] = block526;
  params[1] = block534;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call548 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe525);
// compiled call node returning call548 (depth = 2)
  gc_frame_end(frame);
  return call548;
}
Object meth_collectionsPrelude__61__61__40_1_41_549(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe550 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe551 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe552 = gc_frame_new();
// call case 3: self.outer request
  Object call553 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe552);
// compiled member node returning call553 (depth = 4)
  Object call554 = callmethodflags(call553, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe551);
// compiled member node returning call554 (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call555 = callmethodflags(call554, "isEqual(1)toIterable(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe550);
// compiled call node returning call555 (depth = 2)
  gc_frame_end(frame);
  return call555;
}
Object meth_collectionsPrelude_asDebugString560(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit562 == NULL) {
    strlit562 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit562);
  }
// compiled string node returning strlit562 (depth = 3)
  int op_slot_right_561 = gc_frame_newslot(strlit562);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe565 = gc_frame_new();
// call case 4: self request
  Object call566 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe565);
// compiled member node returning call566 (depth = 4)
  int op_slot_right_564 = gc_frame_newslot(call566);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit569 == NULL) {
    strlit569 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit569);
  }
// compiled string node returning strlit569 (depth = 5)
  int op_slot_right_568 = gc_frame_newslot(strlit569);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe572 = gc_frame_new();
// call case 4: self request
  Object call573 = callmethodflags(self, "asString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe572);
// compiled member node returning call573 (depth = 6)
  int op_slot_right_571 = gc_frame_newslot(call573);
// starting to compile string node (depth = 6)
  if (strlit575 == NULL) {
    strlit575 = alloc_String("");
    gc_root(strlit575);
  }
// compiled string node returning strlit575 (depth = 6)
  int op_slot_left_571 = gc_frame_newslot(strlit575);
  params[0] = call573;
  partcv[0] = 1;
  Object opresult576 = callmethod(strlit575, "++(1)", 1, partcv, params);
// compiled op node returning opresult576 (depth = 5)
  int op_slot_left_568 = gc_frame_newslot(opresult576);
  params[0] = strlit569;
  partcv[0] = 1;
  Object opresult577 = callmethod(opresult576, "++(1)", 1, partcv, params);
// compiled op node returning opresult577 (depth = 4)
  int op_slot_left_564 = gc_frame_newslot(opresult577);
  params[0] = call566;
  partcv[0] = 1;
  Object opresult578 = callmethod(opresult577, "++(1)", 1, partcv, params);
// compiled op node returning opresult578 (depth = 3)
  int op_slot_left_561 = gc_frame_newslot(opresult578);
  params[0] = strlit562;
  partcv[0] = 1;
  Object opresult579 = callmethod(opresult578, "++(1)", 1, partcv, params);
// compiled op node returning opresult579 (depth = 2)
  gc_frame_end(frame);
  return opresult579;
}
Object meth_collectionsPrelude_asString580(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit581 == NULL) {
    strlit581 = alloc_String("aSequenceIterator");
    gc_root(strlit581);
  }
// compiled string node returning strlit581 (depth = 2)
  gc_frame_end(frame);
  return strlit581;
}
Object meth_collectionsPrelude_hasNext582(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sz (depth = 3)
  int op_slot_right_583 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 3)
  int callframe585 = gc_frame_new();
// call case 4: self request
  Object call586 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe585);
// compiled member node returning call586 (depth = 3)
  int op_slot_left_583 = gc_frame_newslot(call586);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult587 = callmethod(call586, "≤(1)", 1, partcv, params);
// compiled op node returning opresult587 (depth = 2)
  gc_frame_end(frame);
  return opresult587;
}
Object meth_collectionsPrelude_next588(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ret = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ret");
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_590 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
  int callframe592 = gc_frame_new();
// call case 4: self request
  Object call593 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe592);
// compiled member node returning call593 (depth = 4)
  int op_slot_left_590 = gc_frame_newslot(call593);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult594 = callmethod(call593, ">(1)", 1, partcv, params);
// compiled op node returning opresult594 (depth = 3)
  Object if589 = done;
  if (istrue(opresult594)) {
// starting to compile call node (depth = 3)
  int callframe595 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit597 == NULL) {
    strlit597 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit597);
  }
// compiled string node returning strlit597 (depth = 5)
  int op_slot_right_596 = gc_frame_newslot(strlit597);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe600 = gc_frame_new();
// call case 4: self request
  Object call601 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe600);
// compiled member node returning call601 (depth = 6)
  int op_slot_right_599 = gc_frame_newslot(call601);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit604 == NULL) {
    strlit604 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit604);
  }
// compiled string node returning strlit604 (depth = 7)
  int op_slot_right_603 = gc_frame_newslot(strlit604);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe607 = gc_frame_new();
// call case 3: self.outer request
  Object call608 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe607);
// compiled member node returning call608 (depth = 8)
  int op_slot_right_606 = gc_frame_newslot(call608);
// starting to compile string node (depth = 8)
  if (strlit610 == NULL) {
    strlit610 = alloc_String("on sequence ");
    gc_root(strlit610);
  }
// compiled string node returning strlit610 (depth = 8)
  int op_slot_left_606 = gc_frame_newslot(strlit610);
  params[0] = call608;
  partcv[0] = 1;
  Object opresult611 = callmethod(strlit610, "++(1)", 1, partcv, params);
// compiled op node returning opresult611 (depth = 7)
  int op_slot_left_603 = gc_frame_newslot(opresult611);
  params[0] = strlit604;
  partcv[0] = 1;
  Object opresult612 = callmethod(opresult611, "++(1)", 1, partcv, params);
// compiled op node returning opresult612 (depth = 6)
  int op_slot_left_599 = gc_frame_newslot(opresult612);
  params[0] = call601;
  partcv[0] = 1;
  Object opresult613 = callmethod(opresult612, "++(1)", 1, partcv, params);
// compiled op node returning opresult613 (depth = 5)
  int op_slot_left_596 = gc_frame_newslot(opresult613);
  params[0] = strlit597;
  partcv[0] = 1;
  Object opresult614 = callmethod(opresult613, "++(1)", 1, partcv, params);
// compiled op node returning opresult614 (depth = 4)
  gc_frame_newslot(opresult614);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = opresult614;
  partcv[0] = 1;
  Object call615 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe595);
// compiled call node returning call615 (depth = 3)
    gc_frame_newslot(call615);
    if589 = call615;
  } else {
  }
// compiled if node returning if589 (depth = 2)
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe616 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe617 = gc_frame_new();
// call case 4: self request
  Object call618 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe617);
// compiled member node returning call618 (depth = 4)
  gc_frame_newslot(call618);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe619 = gc_frame_new();
// call case 3: self.outer request
  Object call620 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe619);
// compiled member node returning call620 (depth = 4)
  params[0] = call618;
  partcv[0] = 1;
  Object call621 = callmethodflags(call620, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe616);
// compiled call node returning call621 (depth = 3)
  *var_ret = call621;
  if (call621 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 583
  setline(583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe622 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num624 = alloc_Float64(1);
// compiled num node returning num624 (depth = 4)
  int op_slot_right_623 = gc_frame_newslot(num624);
// starting to compile member node (depth = 4)
  int callframe626 = gc_frame_new();
// call case 4: self request
  Object call627 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe626);
// compiled member node returning call627 (depth = 4)
  int op_slot_left_623 = gc_frame_newslot(call627);
  params[0] = num624;
  partcv[0] = 1;
  Object sum628 = callmethod(call627, "+(1)", 1, partcv, params);
// compiled op node returning sum628 (depth = 3)
  gc_frame_newslot(sum628);
// call case 4: self request
  params[0] = sum628;
  partcv[0] = 1;
  Object call629 = callmethodflags(self, "idx:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe622);
// compiled call node returning call629 (depth = 2)
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_ret (depth = 2)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_collectionsPrelude_iterator556(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject557 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj557 = alloc_userobj2(6,6, objclass557);
  gc_frame_newslot(obj557);
if (objclass557 == NULL) {
  glfree(obj557->class->name);
  obj557->class->name = "sequence.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj557, self, 0);
  addmethodreal(obj557,"outer", &reader_collectionsPrelude_outer_558);
  Object oldself557 = self;
  struct StackFrameObject *oldstackframe557 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe557);
  gc_frame_newslot((Object)stackframe);
  self = obj557;
  Object *oldselfslot557 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter557 = (*(struct UserObject *)self).data[0], lowerouter557 = thisouter557;
  if (inheritingObject557) {
    struct UserObject *inho557 = (struct UserObject *)inheritingObject557;
    while (inho557->super != GraceDefaultObject) inho557 = (struct UserObject *)inho557->super;
    inho557->super = obj557;
    self = inheritingObject557;
    *selfslot = self;
    lowerouter557 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter557;
  }
if (objclass557 == NULL) {
  Method *reader559 = addmethodrealflags(obj557, "idx", &reader_collectionsPrelude_idx_559, MFLAG_CONFIDENTIAL);
  Method *writer559 = addmethodrealflags(obj557, "idx:=(1)", &writer_collectionsPrelude_idx_559, MFLAG_CONFIDENTIAL);
  reader559->definitionModule = modulename;
  writer559->definitionModule = modulename;
  reader559->definitionLine = 576;
  writer559->definitionLine = 576;
}
obj557->flags |= OFLAG_MUTABLE;
adddatum2(obj557, alloc_Undefined(), 1);
// method "asDebugString"
  struct UserObject *uo560 = (struct UserObject*)obj557;
  uo560->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString560 = addmethod2pos(obj557, "asDebugString", &meth_collectionsPrelude_asDebugString560, 2);
  int argcv_meth_collectionsPrelude_asDebugString560[] = {0};
  meth_meth_collectionsPrelude_asDebugString560->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString560);
  meth_meth_collectionsPrelude_asDebugString560->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString560->definitionLine = 577;
// method "asString"
  struct UserObject *uo580 = (struct UserObject*)obj557;
  uo580->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString580 = addmethod2pos(obj557, "asString", &meth_collectionsPrelude_asString580, 3);
  int argcv_meth_collectionsPrelude_asString580[] = {0};
  meth_meth_collectionsPrelude_asString580->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString580);
  meth_meth_collectionsPrelude_asString580->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString580->definitionLine = 578;
// method "hasNext"
  block_savedest(obj557);
  Object closure582 = createclosure(1, "hasNext");
  setclosureframe(closure582, stackframe);
  addtoclosure(closure582, var_sz);
  struct UserObject *uo582 = (struct UserObject*)obj557;
  uo582->data[4] = (Object)closure582;
  Method *meth_meth_collectionsPrelude_hasNext582 = addmethod2pos(obj557, "hasNext", &meth_collectionsPrelude_hasNext582, 4);
  int argcv_meth_collectionsPrelude_hasNext582[] = {0};
  meth_meth_collectionsPrelude_hasNext582->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext582);
  meth_meth_collectionsPrelude_hasNext582->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext582->definitionLine = 579;
// method "next"
  block_savedest(obj557);
  Object closure588 = createclosure(2, "next");
  setclosureframe(closure588, stackframe);
  addtoclosure(closure588, var_sz);
  addtoclosure(closure588, var_IteratorExhausted);
  struct UserObject *uo588 = (struct UserObject*)obj557;
  uo588->data[5] = (Object)closure588;
  Method *meth_meth_collectionsPrelude_next588 = addmethod2pos(obj557, "next", &meth_collectionsPrelude_next588, 5);
  int argcv_meth_collectionsPrelude_next588[] = {0};
  meth_meth_collectionsPrelude_next588->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next588);
  meth_meth_collectionsPrelude_next588->definitionModule = modulename;
  meth_meth_collectionsPrelude_next588->definitionLine = 580;
  sourceObject = obj557;
// Begin line 576
  setline(576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num630 = alloc_Float64(1);
// compiled num node returning num630 (depth = 2)
  adddatum2(obj557, num630, 1);
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
  objclass557 = obj557->class;
  objclass557->definitionModule = modulename;
  objclass557->definitionLine = 575;
  (*(struct UserObject *)self).data[0] = lowerouter557;
  self = oldself557;
  selfslot = oldselfslot557;
  stackframe = oldstackframe557;
  gc_frame_end(frame);
  return obj557;
}
Object meth_collectionsPrelude_iterator556_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject557 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj557 = alloc_userobj2(6,6, objclass557);
  gc_frame_newslot(obj557);
if (objclass557 == NULL) {
  glfree(obj557->class->name);
  obj557->class->name = "sequence.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj557, self, 0);
  addmethodreal(obj557,"outer", &reader_collectionsPrelude_outer_558);
  Object oldself557 = self;
  struct StackFrameObject *oldstackframe557 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe557);
  gc_frame_newslot((Object)stackframe);
  self = obj557;
  Object *oldselfslot557 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter557 = (*(struct UserObject *)self).data[0], lowerouter557 = thisouter557;
  if (inheritingObject557) {
    struct UserObject *inho557 = (struct UserObject *)inheritingObject557;
    while (inho557->super != GraceDefaultObject) inho557 = (struct UserObject *)inho557->super;
    inho557->super = obj557;
    self = inheritingObject557;
    *selfslot = self;
    lowerouter557 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter557;
  }
if (objclass557 == NULL) {
  Method *reader559 = addmethodrealflags(obj557, "idx", &reader_collectionsPrelude_idx_559, MFLAG_CONFIDENTIAL);
  Method *writer559 = addmethodrealflags(obj557, "idx:=(1)", &writer_collectionsPrelude_idx_559, MFLAG_CONFIDENTIAL);
  reader559->definitionModule = modulename;
  writer559->definitionModule = modulename;
  reader559->definitionLine = 576;
  writer559->definitionLine = 576;
}
obj557->flags |= OFLAG_MUTABLE;
adddatum2(obj557, alloc_Undefined(), 1);
// method "asDebugString"
  struct UserObject *uo560 = (struct UserObject*)obj557;
  uo560->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString560 = addmethod2pos(obj557, "asDebugString", &meth_collectionsPrelude_asDebugString560, 2);
  int argcv_meth_collectionsPrelude_asDebugString560[] = {0};
  meth_meth_collectionsPrelude_asDebugString560->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString560);
  meth_meth_collectionsPrelude_asDebugString560->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString560->definitionLine = 577;
// method "asString"
  struct UserObject *uo580 = (struct UserObject*)obj557;
  uo580->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString580 = addmethod2pos(obj557, "asString", &meth_collectionsPrelude_asString580, 3);
  int argcv_meth_collectionsPrelude_asString580[] = {0};
  meth_meth_collectionsPrelude_asString580->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString580);
  meth_meth_collectionsPrelude_asString580->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString580->definitionLine = 578;
// method "hasNext"
  block_savedest(obj557);
  Object closure582 = createclosure(1, "hasNext");
  setclosureframe(closure582, stackframe);
  addtoclosure(closure582, var_sz);
  struct UserObject *uo582 = (struct UserObject*)obj557;
  uo582->data[4] = (Object)closure582;
  Method *meth_meth_collectionsPrelude_hasNext582 = addmethod2pos(obj557, "hasNext", &meth_collectionsPrelude_hasNext582, 4);
  int argcv_meth_collectionsPrelude_hasNext582[] = {0};
  meth_meth_collectionsPrelude_hasNext582->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext582);
  meth_meth_collectionsPrelude_hasNext582->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext582->definitionLine = 579;
// method "next"
  block_savedest(obj557);
  Object closure588 = createclosure(2, "next");
  setclosureframe(closure588, stackframe);
  addtoclosure(closure588, var_sz);
  addtoclosure(closure588, var_IteratorExhausted);
  struct UserObject *uo588 = (struct UserObject*)obj557;
  uo588->data[5] = (Object)closure588;
  Method *meth_meth_collectionsPrelude_next588 = addmethod2pos(obj557, "next", &meth_collectionsPrelude_next588, 5);
  int argcv_meth_collectionsPrelude_next588[] = {0};
  meth_meth_collectionsPrelude_next588->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next588);
  meth_meth_collectionsPrelude_next588->definitionModule = modulename;
  meth_meth_collectionsPrelude_next588->definitionLine = 580;
  sourceObject = obj557;
// Begin line 576
  setline(576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num630 = alloc_Float64(1);
// compiled num node returning num630 (depth = 2)
  adddatum2(obj557, num630, 1);
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
  objclass557 = obj557->class;
  objclass557->definitionModule = modulename;
  objclass557->definitionLine = 575;
  (*(struct UserObject *)self).data[0] = lowerouter557;
  self = oldself557;
  selfslot = oldselfslot557;
  stackframe = oldstackframe557;
  gc_frame_end(frame);
  return obj557;
}
Object meth_collectionsPrelude__apply_40_2_41_636(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_r (depth = 7)
  int op_slot_right_638 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  int op_slot_left_638 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult640 = callmethod(*var_l, "==(1)", 1, partcv, params);
// compiled op node returning opresult640 (depth = 6)
  Object if637 = done;
  if (istrue(opresult640)) {
// starting to compile num node (depth = 6)
  Object num641 = alloc_Float64(0);
// compiled num node returning num641 (depth = 6)
    gc_frame_newslot(num641);
    if637 = num641;
  } else {
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 591
  setline(591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_r (depth = 8)
  int op_slot_right_643 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_l (depth = 8)
  int op_slot_left_643 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult645 = callmethod(*var_l, "<(1)", 1, partcv, params);
// compiled op node returning opresult645 (depth = 7)
  Object if642 = done;
  if (istrue(opresult645)) {
// starting to compile call node (depth = 7)
  int callframe646 = gc_frame_new();
// call case 6: other requests
// starting to compile num node (depth = 8)
  Object num647 = alloc_Float64(1);
// compiled num node returning num647 (depth = 8)
  partcv[0] = 0;
  Object call648 = callmethodflags(num647, "prefix-", 1, partcv, params, 0);
  gc_frame_end(callframe646);
// compiled call node returning call648 (depth = 7)
    gc_frame_newslot(call648);
    if642 = call648;
  } else {
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num649 = alloc_Float64(1);
// compiled num node returning num649 (depth = 7)
    gc_frame_newslot(num649);
    if642 = num649;
  }
// compiled if node returning if642 (depth = 6)
    gc_frame_newslot(if642);
    if637 = if642;
  }
// compiled if node returning if637 (depth = 5)
  gc_frame_end(frame);
  return if637;
}
Object meth_collectionsPrelude_sorted632(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe633 = gc_frame_new();
// call case 6: other requests
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe634 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block635 = alloc_Block(NULL, NULL, "collectionsPrelude", 589);
  gc_frame_newslot(block635);
// method "_apply(_,_)"
  block_savedest(block635);
  Object closure636 = createclosure(1, "_apply(2)");
  setclosureframe(closure636, stackframe);
  addtoclosure(closure636, selfslot);
  struct UserObject *uo636 = (struct UserObject*)block635;
  uo636->data[0] = (Object)closure636;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_636 = addmethod2pos(block635, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_636, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_636[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_636->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_636);
  meth_meth_collectionsPrelude__apply_40_2_41_636->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_636->definitionLine = 1991;
// compiled block node returning block635 (depth = 4)
  gc_frame_newslot(block635);
// call case 6: other requests
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe651 = gc_frame_new();
// call case 4: self request
  Object call652 = callmethodflags(self, "asList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe651);
// compiled member node returning call652 (depth = 4)
  params[0] = block635;
  partcv[0] = 1;
  Object call653 = callmethodflags(call652, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe634);
// compiled call node returning call653 (depth = 3)
  Object call654 = callmethodflags(call653, "asSequence", 0, partcv, params, 0);
  gc_frame_end(callframe633);
// compiled member node returning call654 (depth = 2)
  gc_frame_end(frame);
  return call654;
}
Object meth_collectionsPrelude_sortedBy_40_1_41_655(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe656 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 3)
  int callframe657 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sortBlock (depth = 4)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe658 = gc_frame_new();
// call case 4: self request
  Object call659 = callmethodflags(self, "asList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe658);
// compiled member node returning call659 (depth = 4)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call660 = callmethodflags(call659, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe657);
// compiled call node returning call660 (depth = 3)
  Object call661 = callmethodflags(call660, "asSequence", 0, partcv, params, 0);
  gc_frame_end(callframe656);
// compiled member node returning call661 (depth = 2)
  gc_frame_end(frame);
  return call661;
}
Object meth_collectionsPrelude_fromprimitiveArray_40_2_41_323(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fromprimitiveArray(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method fromprimitiveArray(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_BoundsError = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  Object *var_indexable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for fromprimitiveArray(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_pArray = &(stackframe->slots[0]);
  *var_pArray = args[curarg];
  curarg++;
  Object *var_sz = &(stackframe->slots[1]);
  *var_sz = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part fromprimitiveArray(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject324 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj324 = alloc_userobj2(17,18, objclass324);
  gc_frame_newslot(obj324);
if (objclass324 == NULL) {
  glfree(obj324->class->name);
  obj324->class->name = "sequence.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj324, self, 0);
  addmethodreal(obj324,"outer", &reader_collectionsPrelude_outer_325);
  Object oldself324 = self;
  struct StackFrameObject *oldstackframe324 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe324);
  gc_frame_newslot((Object)stackframe);
  self = obj324;
  Object *oldselfslot324 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter324 = (*(struct UserObject *)self).data[0], lowerouter324 = thisouter324;
  if (inheritingObject324) {
    struct UserObject *inho324 = (struct UserObject *)inheritingObject324;
    while (inho324->super != GraceDefaultObject) inho324 = (struct UserObject *)inho324->super;
    inho324->super = obj324;
    self = inheritingObject324;
    *selfslot = self;
    lowerouter324 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter324;
  }
if (objclass324 == NULL) {
  Method *reader326 = addmethodrealflags(obj324, "size",&reader_collectionsPrelude_size_326, MFLAG_DEF);
  reader326->definitionModule = modulename;
  reader326->definitionLine = 513;
}
adddatum2(obj324, alloc_Undefined(), 1);
if (objclass324 == NULL) {
  Method *reader327 = addmethodrealflags(obj324, "inner",&reader_collectionsPrelude_inner_327, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader327->definitionModule = modulename;
  reader327->definitionLine = 514;
}
adddatum2(obj324, alloc_Undefined(), 2);
// method "boundsCheck(_)"
  block_savedest(obj324);
  Object closure328 = createclosure(1, "boundsCheck(1)");
  setclosureframe(closure328, stackframe);
  addtoclosure(closure328, var_BoundsError);
  struct UserObject *uo328 = (struct UserObject*)obj324;
  uo328->data[3] = (Object)closure328;
  Method *meth_meth_collectionsPrelude_boundsCheck_40_1_41_328 = addmethod2pos(obj324, "boundsCheck(1)", &meth_collectionsPrelude_boundsCheck_40_1_41_328, 3);
  int argcv_meth_collectionsPrelude_boundsCheck_40_1_41_328[] = {1};
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_328->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_boundsCheck_40_1_41_328);
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_328->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_328->definitionModule = modulename;
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_328->definitionLine = 516;
// method "at(_)"
  struct UserObject *uo365 = (struct UserObject*)obj324;
  uo365->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_365 = addmethod2pos(obj324, "at(1)", &meth_collectionsPrelude_at_40_1_41_365, 4);
  int argcv_meth_collectionsPrelude_at_40_1_41_365[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_365->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_365);
  meth_meth_collectionsPrelude_at_40_1_41_365->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_365->definitionLine = 523;
// method "keys"
  struct UserObject *uo376 = (struct UserObject*)obj324;
  uo376->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys376 = addmethod2pos(obj324, "keys", &meth_collectionsPrelude_keys376, 5);
  int argcv_meth_collectionsPrelude_keys376[] = {0};
  meth_meth_collectionsPrelude_keys376->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys376);
  meth_meth_collectionsPrelude_keys376->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys376->definitionLine = 527;
// method "values"
  struct UserObject *uo388 = (struct UserObject*)obj324;
  uo388->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values388 = addmethod2pos(obj324, "values", &meth_collectionsPrelude_values388, 6);
  int argcv_meth_collectionsPrelude_values388[] = {0};
  meth_meth_collectionsPrelude_values388->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values388);
  meth_meth_collectionsPrelude_values388->definitionModule = modulename;
  meth_meth_collectionsPrelude_values388->definitionLine = 530;
// method "keysAndValuesDo(_)"
  struct UserObject *uo389 = (struct UserObject*)obj324;
  uo389->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389 = addmethod2pos(obj324, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_389, 7);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389->definitionLine = 533;
// method "reversed"
  block_savedest(obj324);
  Object closure419 = createclosure(1, "reversed");
  setclosureframe(closure419, stackframe);
  addtoclosure(closure419, var__prelude);
  struct UserObject *uo419 = (struct UserObject*)obj324;
  uo419->data[8] = (Object)closure419;
  Method *meth_meth_collectionsPrelude_reversed419 = addmethod2pos(obj324, "reversed", &meth_collectionsPrelude_reversed419, 8);
  int argcv_meth_collectionsPrelude_reversed419[] = {0};
  meth_meth_collectionsPrelude_reversed419->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed419);
  meth_meth_collectionsPrelude_reversed419->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed419->definitionLine = 540;
// method "++(_)"
  struct UserObject *uo450 = (struct UserObject*)obj324;
  uo450->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_450 = addmethod2pos(obj324, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_450, 9);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_450[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_450->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_450);
  meth_meth_collectionsPrelude__43__43__40_1_41_450->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_450->definitionLine = 549;
// method "asString"
  struct UserObject *uo465 = (struct UserObject*)obj324;
  uo465->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString465 = addmethod2pos(obj324, "asString", &meth_collectionsPrelude_asString465, 10);
  int argcv_meth_collectionsPrelude_asString465[] = {0};
  meth_meth_collectionsPrelude_asString465->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString465);
  meth_meth_collectionsPrelude_asString465->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString465->definitionLine = 552;
// method "contains(_)"
  struct UserObject *uo511 = (struct UserObject*)obj324;
  uo511->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_511 = addmethod2pos(obj324, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_511, 11);
  int argcv_meth_collectionsPrelude_contains_40_1_41_511[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_511->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_511);
  meth_meth_collectionsPrelude_contains_40_1_41_511->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_511->definitionLine = 560;
// method "do(_)"
  struct UserObject *uo523 = (struct UserObject*)obj324;
  uo523->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_523 = addmethod2pos(obj324, "do(1)", &meth_collectionsPrelude_do_40_1_41_523, 12);
  int argcv_meth_collectionsPrelude_do_40_1_41_523[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_523->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_523);
  meth_meth_collectionsPrelude_do_40_1_41_523->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_523->definitionLine = 564;
// method "==(_)"
  struct UserObject *uo549 = (struct UserObject*)obj324;
  uo549->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_549 = addmethod2pos(obj324, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_549, 13);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_549[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_549->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_549);
  meth_meth_collectionsPrelude__61__61__40_1_41_549->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_549->definitionLine = 571;
// method "iterator"
  block_savedest(obj324);
  Object closure556 = createclosure(2, "iterator");
  setclosureframe(closure556, stackframe);
  addtoclosure(closure556, var_sz);
  addtoclosure(closure556, var_IteratorExhausted);
  struct UserObject *uo556 = (struct UserObject*)obj324;
  uo556->data[14] = (Object)closure556;
  Method *meth_meth_collectionsPrelude_iterator556 = addmethod2pos(obj324, "iterator", &meth_collectionsPrelude_iterator556, 14);
  int argcv_meth_collectionsPrelude_iterator556[] = {0};
  meth_meth_collectionsPrelude_iterator556->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator556);
  meth_meth_collectionsPrelude_iterator556->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator556->definitionLine = 574;
  block_savedest(obj324);
  Object closure631 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure631, stackframe);
  addtoclosure(closure631, var_sz);
  addtoclosure(closure631, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator556_object = addmethod2pos(obj324, "iterator$object(1)", &meth_collectionsPrelude_iterator556_object, 14);
  meth_meth_collectionsPrelude_iterator556_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator556_object->definitionLine = 574;
// method "sorted"
  struct UserObject *uo632 = (struct UserObject*)obj324;
  uo632->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted632 = addmethod2pos(obj324, "sorted", &meth_collectionsPrelude_sorted632, 15);
  int argcv_meth_collectionsPrelude_sorted632[] = {0};
  meth_meth_collectionsPrelude_sorted632->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted632);
  meth_meth_collectionsPrelude_sorted632->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted632->definitionLine = 588;
// method "sortedBy(_)"
  struct UserObject *uo655 = (struct UserObject*)obj324;
  uo655->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_655 = addmethod2pos(obj324, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_655, 16);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_655[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_655->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_655);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_655->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_655->definitionLine = 595;
  sourceObject = obj324;
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe662 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call663 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe662);
// compiled call node returning call663 (depth = 2)
  struct UserObject *obj324_uo = (struct UserObject *)obj324;
  obj324_uo->super = call663;
  sourceObject = obj324;
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_sz (depth = 2)
  adddatum2(obj324, *var_sz, 1);
  sourceObject = obj324;
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_pArray (depth = 2)
  adddatum2(obj324, *var_pArray, 2);
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  objclass324 = obj324->class;
  objclass324->definitionModule = modulename;
  objclass324->definitionLine = 511;
  (*(struct UserObject *)self).data[0] = lowerouter324;
  self = oldself324;
  selfslot = oldselfslot324;
  stackframe = oldstackframe324;
  gc_frame_end(frame);
  return obj324;
}
Object meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fromprimitiveArray(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method fromprimitiveArray(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_BoundsError = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  Object *var_indexable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for fromprimitiveArray(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_pArray = &(stackframe->slots[0]);
  *var_pArray = args[curarg];
  curarg++;
  Object *var_sz = &(stackframe->slots[1]);
  *var_sz = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part fromprimitiveArray(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject324 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj324 = alloc_userobj2(17,18, objclass324);
  gc_frame_newslot(obj324);
if (objclass324 == NULL) {
  glfree(obj324->class->name);
  obj324->class->name = "sequence.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj324, self, 0);
  addmethodreal(obj324,"outer", &reader_collectionsPrelude_outer_325);
  Object oldself324 = self;
  struct StackFrameObject *oldstackframe324 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe324);
  gc_frame_newslot((Object)stackframe);
  self = obj324;
  Object *oldselfslot324 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter324 = (*(struct UserObject *)self).data[0], lowerouter324 = thisouter324;
  if (inheritingObject324) {
    struct UserObject *inho324 = (struct UserObject *)inheritingObject324;
    while (inho324->super != GraceDefaultObject) inho324 = (struct UserObject *)inho324->super;
    inho324->super = obj324;
    self = inheritingObject324;
    *selfslot = self;
    lowerouter324 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter324;
  }
if (objclass324 == NULL) {
  Method *reader326 = addmethodrealflags(obj324, "size",&reader_collectionsPrelude_size_326, MFLAG_DEF);
  reader326->definitionModule = modulename;
  reader326->definitionLine = 513;
}
adddatum2(obj324, alloc_Undefined(), 1);
if (objclass324 == NULL) {
  Method *reader327 = addmethodrealflags(obj324, "inner",&reader_collectionsPrelude_inner_327, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader327->definitionModule = modulename;
  reader327->definitionLine = 514;
}
adddatum2(obj324, alloc_Undefined(), 2);
// method "boundsCheck(_)"
  block_savedest(obj324);
  Object closure328 = createclosure(1, "boundsCheck(1)");
  setclosureframe(closure328, stackframe);
  addtoclosure(closure328, var_BoundsError);
  struct UserObject *uo328 = (struct UserObject*)obj324;
  uo328->data[3] = (Object)closure328;
  Method *meth_meth_collectionsPrelude_boundsCheck_40_1_41_328 = addmethod2pos(obj324, "boundsCheck(1)", &meth_collectionsPrelude_boundsCheck_40_1_41_328, 3);
  int argcv_meth_collectionsPrelude_boundsCheck_40_1_41_328[] = {1};
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_328->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_boundsCheck_40_1_41_328);
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_328->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_328->definitionModule = modulename;
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_328->definitionLine = 516;
// method "at(_)"
  struct UserObject *uo365 = (struct UserObject*)obj324;
  uo365->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_365 = addmethod2pos(obj324, "at(1)", &meth_collectionsPrelude_at_40_1_41_365, 4);
  int argcv_meth_collectionsPrelude_at_40_1_41_365[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_365->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_365);
  meth_meth_collectionsPrelude_at_40_1_41_365->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_365->definitionLine = 523;
// method "keys"
  struct UserObject *uo376 = (struct UserObject*)obj324;
  uo376->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys376 = addmethod2pos(obj324, "keys", &meth_collectionsPrelude_keys376, 5);
  int argcv_meth_collectionsPrelude_keys376[] = {0};
  meth_meth_collectionsPrelude_keys376->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys376);
  meth_meth_collectionsPrelude_keys376->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys376->definitionLine = 527;
// method "values"
  struct UserObject *uo388 = (struct UserObject*)obj324;
  uo388->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values388 = addmethod2pos(obj324, "values", &meth_collectionsPrelude_values388, 6);
  int argcv_meth_collectionsPrelude_values388[] = {0};
  meth_meth_collectionsPrelude_values388->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values388);
  meth_meth_collectionsPrelude_values388->definitionModule = modulename;
  meth_meth_collectionsPrelude_values388->definitionLine = 530;
// method "keysAndValuesDo(_)"
  struct UserObject *uo389 = (struct UserObject*)obj324;
  uo389->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389 = addmethod2pos(obj324, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_389, 7);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389->definitionLine = 533;
// method "reversed"
  block_savedest(obj324);
  Object closure419 = createclosure(1, "reversed");
  setclosureframe(closure419, stackframe);
  addtoclosure(closure419, var__prelude);
  struct UserObject *uo419 = (struct UserObject*)obj324;
  uo419->data[8] = (Object)closure419;
  Method *meth_meth_collectionsPrelude_reversed419 = addmethod2pos(obj324, "reversed", &meth_collectionsPrelude_reversed419, 8);
  int argcv_meth_collectionsPrelude_reversed419[] = {0};
  meth_meth_collectionsPrelude_reversed419->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed419);
  meth_meth_collectionsPrelude_reversed419->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed419->definitionLine = 540;
// method "++(_)"
  struct UserObject *uo450 = (struct UserObject*)obj324;
  uo450->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_450 = addmethod2pos(obj324, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_450, 9);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_450[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_450->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_450);
  meth_meth_collectionsPrelude__43__43__40_1_41_450->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_450->definitionLine = 549;
// method "asString"
  struct UserObject *uo465 = (struct UserObject*)obj324;
  uo465->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString465 = addmethod2pos(obj324, "asString", &meth_collectionsPrelude_asString465, 10);
  int argcv_meth_collectionsPrelude_asString465[] = {0};
  meth_meth_collectionsPrelude_asString465->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString465);
  meth_meth_collectionsPrelude_asString465->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString465->definitionLine = 552;
// method "contains(_)"
  struct UserObject *uo511 = (struct UserObject*)obj324;
  uo511->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_511 = addmethod2pos(obj324, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_511, 11);
  int argcv_meth_collectionsPrelude_contains_40_1_41_511[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_511->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_511);
  meth_meth_collectionsPrelude_contains_40_1_41_511->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_511->definitionLine = 560;
// method "do(_)"
  struct UserObject *uo523 = (struct UserObject*)obj324;
  uo523->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_523 = addmethod2pos(obj324, "do(1)", &meth_collectionsPrelude_do_40_1_41_523, 12);
  int argcv_meth_collectionsPrelude_do_40_1_41_523[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_523->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_523);
  meth_meth_collectionsPrelude_do_40_1_41_523->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_523->definitionLine = 564;
// method "==(_)"
  struct UserObject *uo549 = (struct UserObject*)obj324;
  uo549->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_549 = addmethod2pos(obj324, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_549, 13);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_549[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_549->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_549);
  meth_meth_collectionsPrelude__61__61__40_1_41_549->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_549->definitionLine = 571;
// method "iterator"
  block_savedest(obj324);
  Object closure556 = createclosure(2, "iterator");
  setclosureframe(closure556, stackframe);
  addtoclosure(closure556, var_sz);
  addtoclosure(closure556, var_IteratorExhausted);
  struct UserObject *uo556 = (struct UserObject*)obj324;
  uo556->data[14] = (Object)closure556;
  Method *meth_meth_collectionsPrelude_iterator556 = addmethod2pos(obj324, "iterator", &meth_collectionsPrelude_iterator556, 14);
  int argcv_meth_collectionsPrelude_iterator556[] = {0};
  meth_meth_collectionsPrelude_iterator556->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator556);
  meth_meth_collectionsPrelude_iterator556->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator556->definitionLine = 574;
  block_savedest(obj324);
  Object closure631 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure631, stackframe);
  addtoclosure(closure631, var_sz);
  addtoclosure(closure631, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator556_object = addmethod2pos(obj324, "iterator$object(1)", &meth_collectionsPrelude_iterator556_object, 14);
  meth_meth_collectionsPrelude_iterator556_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator556_object->definitionLine = 574;
// method "sorted"
  struct UserObject *uo632 = (struct UserObject*)obj324;
  uo632->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted632 = addmethod2pos(obj324, "sorted", &meth_collectionsPrelude_sorted632, 15);
  int argcv_meth_collectionsPrelude_sorted632[] = {0};
  meth_meth_collectionsPrelude_sorted632->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted632);
  meth_meth_collectionsPrelude_sorted632->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted632->definitionLine = 588;
// method "sortedBy(_)"
  struct UserObject *uo655 = (struct UserObject*)obj324;
  uo655->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_655 = addmethod2pos(obj324, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_655, 16);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_655[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_655->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_655);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_655->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_655->definitionLine = 595;
  sourceObject = obj324;
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe662 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call663 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe662);
// compiled call node returning call663 (depth = 2)
  struct UserObject *obj324_uo = (struct UserObject *)obj324;
  obj324_uo->super = call663;
  sourceObject = obj324;
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_sz (depth = 2)
  adddatum2(obj324, *var_sz, 1);
  sourceObject = obj324;
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_pArray (depth = 2)
  adddatum2(obj324, *var_pArray, 2);
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  objclass324 = obj324->class;
  objclass324->definitionModule = modulename;
  objclass324->definitionLine = 511;
  (*(struct UserObject *)self).data[0] = lowerouter324;
  self = oldself324;
  selfslot = oldselfslot324;
  stackframe = oldstackframe324;
  gc_frame_end(frame);
  return obj324;
}
Object meth_collectionsPrelude_sequence235(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object *var_BoundsError = getfromclosure(closure, 2);
  Object *var_IteratorExhausted = getfromclosure(closure, 3);
  Object *var_indexable = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject236 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj236 = alloc_userobj2(5,6, objclass236);
  gc_frame_newslot(obj236);
if (objclass236 == NULL) {
  glfree(obj236->class->name);
  obj236->class->name = "sequence";
}
// OBJECT OUTER DEC outer
  adddatum2(obj236, self, 0);
  addmethodreal(obj236,"outer", &reader_collectionsPrelude_outer_237);
  Object oldself236 = self;
  struct StackFrameObject *oldstackframe236 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe236);
  gc_frame_newslot((Object)stackframe);
  self = obj236;
  Object *oldselfslot236 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter236 = (*(struct UserObject *)self).data[0], lowerouter236 = thisouter236;
  if (inheritingObject236) {
    struct UserObject *inho236 = (struct UserObject *)inheritingObject236;
    while (inho236->super != GraceDefaultObject) inho236 = (struct UserObject *)inho236->super;
    inho236->super = obj236;
    self = inheritingObject236;
    *selfslot = self;
    lowerouter236 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter236;
  }
// method "asString"
  struct UserObject *uo238 = (struct UserObject*)obj236;
  uo238->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString238 = addmethod2pos(obj236, "asString", &meth_collectionsPrelude_asString238, 1);
  int argcv_meth_collectionsPrelude_asString238[] = {0};
  meth_meth_collectionsPrelude_asString238->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString238);
  meth_meth_collectionsPrelude_asString238->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString238->definitionLine = 467;
// method "empty"
  block_savedest(obj236);
  Object closure240 = createclosure(1, "empty");
  setclosureframe(closure240, stackframe);
  addtoclosure(closure240, var_emptySequence);
  struct UserObject *uo240 = (struct UserObject*)obj236;
  uo240->data[2] = (Object)closure240;
  Method *meth_meth_collectionsPrelude_empty240 = addmethod2pos(obj236, "empty", &meth_collectionsPrelude_empty240, 2);
  int argcv_meth_collectionsPrelude_empty240[] = {0};
  meth_meth_collectionsPrelude_empty240->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty240);
  meth_meth_collectionsPrelude_empty240->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty240->definitionLine = 469;
// method "withAll(_)"
  block_savedest(obj236);
  Object closure241 = createclosure(2, "withAll(1)");
  setclosureframe(closure241, stackframe);
  addtoclosure(closure241, var__prelude);
  addtoclosure(closure241, var_emptySequence);
  struct UserObject *uo241 = (struct UserObject*)obj236;
  uo241->data[3] = (Object)closure241;
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_241 = addmethod2pos(obj236, "withAll(1)", &meth_collectionsPrelude_withAll_40_1_41_241, 3);
  int argcv_meth_collectionsPrelude_withAll_40_1_41_241[] = {1};
  meth_meth_collectionsPrelude_withAll_40_1_41_241->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll_40_1_41_241);
  meth_meth_collectionsPrelude_withAll_40_1_41_241->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_241->definitionLine = 474;
// method "fromprimitiveArray(_,_)"
  block_savedest(obj236);
  Object closure323 = createclosure(4, "fromprimitiveArray(2)");
  setclosureframe(closure323, stackframe);
  addtoclosure(closure323, var_BoundsError);
  addtoclosure(closure323, var__prelude);
  addtoclosure(closure323, var_IteratorExhausted);
  addtoclosure(closure323, var_indexable);
  struct UserObject *uo323 = (struct UserObject*)obj236;
  uo323->data[4] = (Object)closure323;
  Method *meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323 = addmethod2pos(obj236, "fromprimitiveArray(2)", &meth_collectionsPrelude_fromprimitiveArray_40_2_41_323, 4);
  int argcv_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323[] = {2};
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323);
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323->definitionModule = modulename;
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323->definitionLine = 508;
  block_savedest(obj236);
  Object closure664 = createclosure(4, "fromprimitiveArray(2)$object(1)");
  setclosureframe(closure664, stackframe);
  addtoclosure(closure664, var_BoundsError);
  addtoclosure(closure664, var__prelude);
  addtoclosure(closure664, var_IteratorExhausted);
  addtoclosure(closure664, var_indexable);
  Method *meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object = addmethod2pos(obj236, "fromprimitiveArray(2)$object(1)", &meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object, 4);
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object->definitionLine = 508;
  sourceObject = obj236;
  sourceObject = obj236;
  sourceObject = obj236;
  sourceObject = obj236;
  objclass236 = obj236->class;
  objclass236->definitionModule = modulename;
  objclass236->definitionLine = 465;
  (*(struct UserObject *)self).data[0] = lowerouter236;
  self = oldself236;
  selfslot = oldselfslot236;
  stackframe = oldstackframe236;
  gc_frame_end(frame);
  return obj236;
}
Object meth_collectionsPrelude_sequence235_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sequence$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object *var_BoundsError = getfromclosure(closure, 2);
  Object *var_IteratorExhausted = getfromclosure(closure, 3);
  Object *var_indexable = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject236 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj236 = alloc_userobj2(5,6, objclass236);
  gc_frame_newslot(obj236);
if (objclass236 == NULL) {
  glfree(obj236->class->name);
  obj236->class->name = "sequence";
}
// OBJECT OUTER DEC outer
  adddatum2(obj236, self, 0);
  addmethodreal(obj236,"outer", &reader_collectionsPrelude_outer_237);
  Object oldself236 = self;
  struct StackFrameObject *oldstackframe236 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe236);
  gc_frame_newslot((Object)stackframe);
  self = obj236;
  Object *oldselfslot236 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter236 = (*(struct UserObject *)self).data[0], lowerouter236 = thisouter236;
  if (inheritingObject236) {
    struct UserObject *inho236 = (struct UserObject *)inheritingObject236;
    while (inho236->super != GraceDefaultObject) inho236 = (struct UserObject *)inho236->super;
    inho236->super = obj236;
    self = inheritingObject236;
    *selfslot = self;
    lowerouter236 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter236;
  }
// method "asString"
  struct UserObject *uo238 = (struct UserObject*)obj236;
  uo238->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString238 = addmethod2pos(obj236, "asString", &meth_collectionsPrelude_asString238, 1);
  int argcv_meth_collectionsPrelude_asString238[] = {0};
  meth_meth_collectionsPrelude_asString238->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString238);
  meth_meth_collectionsPrelude_asString238->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString238->definitionLine = 467;
// method "empty"
  block_savedest(obj236);
  Object closure240 = createclosure(1, "empty");
  setclosureframe(closure240, stackframe);
  addtoclosure(closure240, var_emptySequence);
  struct UserObject *uo240 = (struct UserObject*)obj236;
  uo240->data[2] = (Object)closure240;
  Method *meth_meth_collectionsPrelude_empty240 = addmethod2pos(obj236, "empty", &meth_collectionsPrelude_empty240, 2);
  int argcv_meth_collectionsPrelude_empty240[] = {0};
  meth_meth_collectionsPrelude_empty240->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty240);
  meth_meth_collectionsPrelude_empty240->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty240->definitionLine = 469;
// method "withAll(_)"
  block_savedest(obj236);
  Object closure241 = createclosure(2, "withAll(1)");
  setclosureframe(closure241, stackframe);
  addtoclosure(closure241, var__prelude);
  addtoclosure(closure241, var_emptySequence);
  struct UserObject *uo241 = (struct UserObject*)obj236;
  uo241->data[3] = (Object)closure241;
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_241 = addmethod2pos(obj236, "withAll(1)", &meth_collectionsPrelude_withAll_40_1_41_241, 3);
  int argcv_meth_collectionsPrelude_withAll_40_1_41_241[] = {1};
  meth_meth_collectionsPrelude_withAll_40_1_41_241->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll_40_1_41_241);
  meth_meth_collectionsPrelude_withAll_40_1_41_241->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_241->definitionLine = 474;
// method "fromprimitiveArray(_,_)"
  block_savedest(obj236);
  Object closure323 = createclosure(4, "fromprimitiveArray(2)");
  setclosureframe(closure323, stackframe);
  addtoclosure(closure323, var_BoundsError);
  addtoclosure(closure323, var__prelude);
  addtoclosure(closure323, var_IteratorExhausted);
  addtoclosure(closure323, var_indexable);
  struct UserObject *uo323 = (struct UserObject*)obj236;
  uo323->data[4] = (Object)closure323;
  Method *meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323 = addmethod2pos(obj236, "fromprimitiveArray(2)", &meth_collectionsPrelude_fromprimitiveArray_40_2_41_323, 4);
  int argcv_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323[] = {2};
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323);
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323->definitionModule = modulename;
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323->definitionLine = 508;
  block_savedest(obj236);
  Object closure664 = createclosure(4, "fromprimitiveArray(2)$object(1)");
  setclosureframe(closure664, stackframe);
  addtoclosure(closure664, var_BoundsError);
  addtoclosure(closure664, var__prelude);
  addtoclosure(closure664, var_IteratorExhausted);
  addtoclosure(closure664, var_indexable);
  Method *meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object = addmethod2pos(obj236, "fromprimitiveArray(2)$object(1)", &meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object, 4);
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object->definitionLine = 508;
  sourceObject = obj236;
  sourceObject = obj236;
  sourceObject = obj236;
  sourceObject = obj236;
  objclass236 = obj236->class;
  objclass236->definitionModule = modulename;
  objclass236->definitionLine = 465;
  (*(struct UserObject *)self).data[0] = lowerouter236;
  self = oldself236;
  selfslot = oldselfslot236;
  stackframe = oldstackframe236;
  gc_frame_end(frame);
  return obj236;
}
Object meth_collectionsPrelude__apply676(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_rightIter = getfromclosure(closure, 0);
  Object *var_leftIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe678 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_rightIter (depth = 7)
  Object call679 = callmethodflags(*var_rightIter, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe678);
// compiled member node returning call679 (depth = 6)
  int op_slot_right_677 = gc_frame_newslot(call679);
// starting to compile member node (depth = 6)
  int callframe681 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_leftIter (depth = 7)
  Object call682 = callmethodflags(*var_leftIter, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe681);
// compiled member node returning call682 (depth = 6)
  int op_slot_left_677 = gc_frame_newslot(call682);
  params[0] = call679;
  partcv[0] = 1;
  Object opresult683 = callmethod(call682, "&&(1)", 1, partcv, params);
// compiled op node returning opresult683 (depth = 5)
  gc_frame_end(frame);
  return opresult683;
}
Object meth_collectionsPrelude__apply686(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_rightIter = getfromclosure(closure, 0);
  Object *var_leftIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe689 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_rightIter (depth = 8)
  Object call690 = callmethodflags(*var_rightIter, "next", 0, partcv, params, 0);
  gc_frame_end(callframe689);
// compiled member node returning call690 (depth = 7)
  int op_slot_right_688 = gc_frame_newslot(call690);
// starting to compile member node (depth = 7)
  int callframe692 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_leftIter (depth = 8)
  Object call693 = callmethodflags(*var_leftIter, "next", 0, partcv, params, 0);
  gc_frame_end(callframe692);
// compiled member node returning call693 (depth = 7)
  int op_slot_left_688 = gc_frame_newslot(call693);
  params[0] = call690;
  partcv[0] = 1;
  Object opresult694 = callmethod(call693, "≠(1)", 1, partcv, params);
// compiled op node returning opresult694 (depth = 6)
  Object if687 = done;
  if (istrue(opresult694)) {
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool695 = alloc_Boolean(0);
// compiled identifier node returning bool695 (depth = 7)
  block_return(realself, bool695);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if687 = undefined;
  } else {
  }
// compiled if node returning if687 (depth = 5)
  gc_frame_end(frame);
  return if687;
}
Object meth_collectionsPrelude_isEqual_40_1_41_toIterable_40_1_41_666(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isEqual(1)toIterable(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isEqual(_)toIterable(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isEqual(_)toIterable(_)");
  Object params[2];
  int partcv[2];
  Object *var_MinimalyIterable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for isEqual(_)toIterable(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part isEqual(_)");
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toIterable(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_leftIter = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "leftIter");
  Object *var_rightIter = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "rightIter");
// Begin line 607
  setline(607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe668 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  gc_frame_newslot(*var_right);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_MinimalyIterable (depth = 4)
  params[0] = *var_right;
  partcv[0] = 1;
  Object call669 = callmethodflags(*var_MinimalyIterable, "match(1)", 1, partcv, params, 0);
  gc_frame_end(callframe668);
// compiled call node returning call669 (depth = 3)
  Object if667 = done;
  if (istrue(call669)) {
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe670 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_left (depth = 5)
  Object call671 = callmethodflags(*var_left, "iterator", 0, partcv, params, 0);
  gc_frame_end(callframe670);
// compiled member node returning call671 (depth = 4)
  *var_leftIter = call671;
  if (call671 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe672 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_right (depth = 5)
  Object call673 = callmethodflags(*var_right, "iterator", 0, partcv, params, 0);
  gc_frame_end(callframe672);
// compiled member node returning call673 (depth = 4)
  *var_rightIter = call673;
  if (call673 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe674 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block675 = alloc_Block(NULL, NULL, "collectionsPrelude", 610);
  gc_frame_newslot(block675);
// method "_apply"
  block_savedest(block675);
  Object closure676 = createclosure(3, "_apply");
  setclosureframe(closure676, stackframe);
  addtoclosure(closure676, var_rightIter);
  addtoclosure(closure676, var_leftIter);
  addtoclosure(closure676, selfslot);
  struct UserObject *uo676 = (struct UserObject*)block675;
  uo676->data[0] = (Object)closure676;
  Method *meth_meth_collectionsPrelude__apply676 = addmethod2pos(block675, "_apply", &meth_collectionsPrelude__apply676, 0);
  int argcv_meth_collectionsPrelude__apply676[] = {0};
  meth_meth_collectionsPrelude__apply676->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply676);
  meth_meth_collectionsPrelude__apply676->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply676->definitionLine = 1991;
// compiled block node returning block675 (depth = 4)
  gc_frame_newslot(block675);
// starting to compile block node (depth = 4)
  Object block685 = alloc_Block(NULL, NULL, "collectionsPrelude", 610);
  gc_frame_newslot(block685);
// method "_apply"
  block_savedest(block685);
  Object closure686 = createclosure(3, "_apply");
  setclosureframe(closure686, stackframe);
  addtoclosure(closure686, var_rightIter);
  addtoclosure(closure686, var_leftIter);
  addtoclosure(closure686, selfslot);
  struct UserObject *uo686 = (struct UserObject*)block685;
  uo686->data[0] = (Object)closure686;
  Method *meth_meth_collectionsPrelude__apply686 = addmethod2pos(block685, "_apply", &meth_collectionsPrelude__apply686, 0);
  int argcv_meth_collectionsPrelude__apply686[] = {0};
  meth_meth_collectionsPrelude__apply686->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply686);
  meth_meth_collectionsPrelude__apply686->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply686->definitionLine = 1991;
// compiled block node returning block685 (depth = 4)
  gc_frame_newslot(block685);
// call case 5: prelude request
  params[0] = block675;
  params[1] = block685;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call697 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe674);
// compiled call node returning call697 (depth = 3)
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe699 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_rightIter (depth = 5)
  Object call700 = callmethodflags(*var_rightIter, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe699);
// compiled member node returning call700 (depth = 4)
  int op_slot_right_698 = gc_frame_newslot(call700);
// starting to compile member node (depth = 4)
  int callframe702 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_leftIter (depth = 5)
  Object call703 = callmethodflags(*var_leftIter, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe702);
// compiled member node returning call703 (depth = 4)
  int op_slot_left_698 = gc_frame_newslot(call703);
  params[0] = call700;
  partcv[0] = 1;
  Object opresult704 = callmethod(call703, "==(1)", 1, partcv, params);
// compiled op node returning opresult704 (depth = 3)
    gc_frame_newslot(opresult704);
    if667 = opresult704;
  } else {
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool705 = alloc_Boolean(0);
// compiled identifier node returning bool705 (depth = 3)
    gc_frame_newslot(bool705);
    if667 = bool705;
  }
// compiled if node returning if667 (depth = 2)
  gc_frame_end(frame);
  return if667;
}
Object meth_collectionsPrelude_asString709(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit710 == NULL) {
    strlit710 = alloc_String("a list factory");
    gc_root(strlit710);
  }
// compiled string node returning strlit710 (depth = 2)
  gc_frame_end(frame);
  return strlit710;
}
Object meth_collectionsPrelude_empty711(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe712 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySequence (depth = 3)
  gc_frame_newslot(*var_emptySequence);
// call case 4: self request
  params[0] = *var_emptySequence;
  partcv[0] = 1;
  Object call713 = callmethodflags(self, "withAll(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe712);
// compiled call node returning call713 (depth = 2)
  gc_frame_end(frame);
  return call713;
}
Object meth_collectionsPrelude_size728(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
// Begin line 644
  setline(644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe729 = gc_frame_new();
// call case 4: self request
  Object call730 = callmethodflags(self, "sz", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe729);
// compiled member node returning call730 (depth = 6)
  gc_frame_end(frame);
  return call730;
}
Object meth_collectionsPrelude_at_40_1_41_731(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_at_40_1_41_put_40_1_41_732(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)put(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)put(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)put(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for at(_)put(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *var_x = &(stackframe->slots[1]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part put(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe733 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num735 = alloc_Float64(1);
// compiled num node returning num735 (depth = 8)
  int op_slot_right_734 = gc_frame_newslot(num735);
// starting to compile member node (depth = 8)
  int callframe737 = gc_frame_new();
// call case 4: self request
  Object call738 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe737);
// compiled member node returning call738 (depth = 8)
  int op_slot_left_734 = gc_frame_newslot(call738);
  params[0] = num735;
  partcv[0] = 1;
  Object sum739 = callmethod(call738, "+(1)", 1, partcv, params);
// compiled op node returning sum739 (depth = 7)
  gc_frame_newslot(sum739);
// call case 4: self request
  params[0] = sum739;
  partcv[0] = 1;
  Object call740 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe733);
// compiled call node returning call740 (depth = 6)
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_add_40_1_41_741(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "add(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method add(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for add(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part add(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe742 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num744 = alloc_Float64(1);
// compiled num node returning num744 (depth = 8)
  int op_slot_right_743 = gc_frame_newslot(num744);
// starting to compile member node (depth = 8)
  int callframe746 = gc_frame_new();
// call case 4: self request
  Object call747 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe746);
// compiled member node returning call747 (depth = 8)
  int op_slot_left_743 = gc_frame_newslot(call747);
  params[0] = num744;
  partcv[0] = 1;
  Object sum748 = callmethod(call747, "+(1)", 1, partcv, params);
// compiled op node returning sum748 (depth = 7)
  gc_frame_newslot(sum748);
// call case 4: self request
  params[0] = sum748;
  partcv[0] = 1;
  Object call749 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe742);
// compiled call node returning call749 (depth = 6)
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_push_40_1_41_750(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "push(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method push(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for push(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part push(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 676
  setline(676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe751 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num753 = alloc_Float64(1);
// compiled num node returning num753 (depth = 8)
  int op_slot_right_752 = gc_frame_newslot(num753);
// starting to compile member node (depth = 8)
  int callframe755 = gc_frame_new();
// call case 4: self request
  Object call756 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe755);
// compiled member node returning call756 (depth = 8)
  int op_slot_left_752 = gc_frame_newslot(call756);
  params[0] = num753;
  partcv[0] = 1;
  Object sum757 = callmethod(call756, "+(1)", 1, partcv, params);
// compiled op node returning sum757 (depth = 7)
  gc_frame_newslot(sum757);
// call case 4: self request
  params[0] = sum757;
  partcv[0] = 1;
  Object call758 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe751);
// compiled call node returning call758 (depth = 6)
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_removeLast759(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeLast");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe760 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num762 = alloc_Float64(1);
// compiled num node returning num762 (depth = 8)
  int op_slot_right_761 = gc_frame_newslot(num762);
// starting to compile member node (depth = 8)
  int callframe764 = gc_frame_new();
// call case 4: self request
  Object call765 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe764);
// compiled member node returning call765 (depth = 8)
  int op_slot_left_761 = gc_frame_newslot(call765);
  params[0] = num762;
  partcv[0] = 1;
  Object sum766 = callmethod(call765, "+(1)", 1, partcv, params);
// compiled op node returning sum766 (depth = 7)
  gc_frame_newslot(sum766);
// call case 4: self request
  params[0] = sum766;
  partcv[0] = 1;
  Object call767 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe760);
// compiled call node returning call767 (depth = 6)
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_clear768(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "clear");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 691
  setline(691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe769 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num771 = alloc_Float64(1);
// compiled num node returning num771 (depth = 8)
  int op_slot_right_770 = gc_frame_newslot(num771);
// starting to compile member node (depth = 8)
  int callframe773 = gc_frame_new();
// call case 4: self request
  Object call774 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe773);
// compiled member node returning call774 (depth = 8)
  int op_slot_left_770 = gc_frame_newslot(call774);
  params[0] = num771;
  partcv[0] = 1;
  Object sum775 = callmethod(call774, "+(1)", 1, partcv, params);
// compiled op node returning sum775 (depth = 7)
  gc_frame_newslot(sum775);
// call case 4: self request
  params[0] = sum775;
  partcv[0] = 1;
  Object call776 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe769);
// compiled call node returning call776 (depth = 6)
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply790(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num792 = alloc_Float64(0);
// compiled num node returning num792 (depth = 9)
  int op_slot_right_791 = gc_frame_newslot(num792);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  int op_slot_left_791 = gc_frame_newslot(*var_ix);
  params[0] = num792;
  partcv[0] = 1;
  Object opresult794 = callmethod(*var_ix, ">(1)", 1, partcv, params);
// compiled op node returning opresult794 (depth = 8)
  gc_frame_end(frame);
  return opresult794;
}
Object meth_collectionsPrelude__apply797(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_l = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_each = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "each");
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe798 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_l (depth = 10)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call799 = callmethodflags(*var_l, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe798);
// compiled call node returning call799 (depth = 9)
  *var_each = call799;
  if (call799 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 700
  setline(700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num801 = alloc_Float64(1);
// compiled num node returning num801 (depth = 10)
  int op_slot_right_800 = gc_frame_newslot(num801);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  int op_slot_left_800 = gc_frame_newslot(*var_ix);
  params[0] = num801;
  partcv[0] = 1;
  Object diff803 = callmethod(*var_ix, "-(1)", 1, partcv, params);
// compiled op node returning diff803 (depth = 9)
  *var_ix = diff803;
  if (diff803 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
// compiled call node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_addAllFirst_40_1_41_777(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAllFirst(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAllFirst(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addAllFirst(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addAllFirst(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe778 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num780 = alloc_Float64(1);
// compiled num node returning num780 (depth = 8)
  int op_slot_right_779 = gc_frame_newslot(num780);
// starting to compile member node (depth = 8)
  int callframe782 = gc_frame_new();
// call case 4: self request
  Object call783 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe782);
// compiled member node returning call783 (depth = 8)
  int op_slot_left_779 = gc_frame_newslot(call783);
  params[0] = num780;
  partcv[0] = 1;
  Object sum784 = callmethod(call783, "+(1)", 1, partcv, params);
// compiled op node returning sum784 (depth = 7)
  gc_frame_newslot(sum784);
// call case 4: self request
  params[0] = sum784;
  partcv[0] = 1;
  Object call785 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe778);
// compiled call node returning call785 (depth = 6)
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe786 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_l (depth = 8)
  Object call787 = callmethodflags(*var_l, "size", 0, partcv, params, 0);
  gc_frame_end(callframe786);
// compiled member node returning call787 (depth = 7)
  *var_ix = call787;
  if (call787 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe788 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block789 = alloc_Block(NULL, NULL, "collectionsPrelude", 698);
  gc_frame_newslot(block789);
// method "_apply"
  block_savedest(block789);
  Object closure790 = createclosure(2, "_apply");
  setclosureframe(closure790, stackframe);
  addtoclosure(closure790, var_ix);
  addtoclosure(closure790, selfslot);
  struct UserObject *uo790 = (struct UserObject*)block789;
  uo790->data[0] = (Object)closure790;
  Method *meth_meth_collectionsPrelude__apply790 = addmethod2pos(block789, "_apply", &meth_collectionsPrelude__apply790, 0);
  int argcv_meth_collectionsPrelude__apply790[] = {0};
  meth_meth_collectionsPrelude__apply790->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply790);
  meth_meth_collectionsPrelude__apply790->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply790->definitionLine = 1991;
// compiled block node returning block789 (depth = 7)
  gc_frame_newslot(block789);
// starting to compile block node (depth = 7)
  Object block796 = alloc_Block(NULL, NULL, "collectionsPrelude", 698);
  gc_frame_newslot(block796);
// method "_apply"
  block_savedest(block796);
  Object closure797 = createclosure(3, "_apply");
  setclosureframe(closure797, stackframe);
  addtoclosure(closure797, var_ix);
  addtoclosure(closure797, var_l);
  addtoclosure(closure797, selfslot);
  struct UserObject *uo797 = (struct UserObject*)block796;
  uo797->data[0] = (Object)closure797;
  Method *meth_meth_collectionsPrelude__apply797 = addmethod2pos(block796, "_apply", &meth_collectionsPrelude__apply797, 0);
  int argcv_meth_collectionsPrelude__apply797[] = {0};
  meth_meth_collectionsPrelude__apply797->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply797);
  meth_meth_collectionsPrelude__apply797->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply797->definitionLine = 1991;
// compiled block node returning block796 (depth = 7)
  gc_frame_newslot(block796);
// call case 5: prelude request
  params[0] = block789;
  params[1] = block796;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call806 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe788);
// compiled call node returning call806 (depth = 6)
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_removeAt_40_1_41_807(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAt(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAt(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAt(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAt(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_removed = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "removed");
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe808 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num810 = alloc_Float64(1);
// compiled num node returning num810 (depth = 8)
  int op_slot_right_809 = gc_frame_newslot(num810);
// starting to compile member node (depth = 8)
  int callframe812 = gc_frame_new();
// call case 4: self request
  Object call813 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe812);
// compiled member node returning call813 (depth = 8)
  int op_slot_left_809 = gc_frame_newslot(call813);
  params[0] = num810;
  partcv[0] = 1;
  Object sum814 = callmethod(call813, "+(1)", 1, partcv, params);
// compiled op node returning sum814 (depth = 7)
  gc_frame_newslot(sum814);
// call case 4: self request
  params[0] = sum814;
  partcv[0] = 1;
  Object call815 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe808);
// compiled call node returning call815 (depth = 6)
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe816 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call817 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe816);
// compiled call node returning call817 (depth = 7)
  *var_removed = call817;
  if (call817 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 709
  setline(709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  return *var_removed;
// compiled return node returning undefined (depth = 6)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_sortBy_40_1_41_818(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe819 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num821 = alloc_Float64(1);
// compiled num node returning num821 (depth = 8)
  int op_slot_right_820 = gc_frame_newslot(num821);
// starting to compile member node (depth = 8)
  int callframe823 = gc_frame_new();
// call case 4: self request
  Object call824 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe823);
// compiled member node returning call824 (depth = 8)
  int op_slot_left_820 = gc_frame_newslot(call824);
  params[0] = num821;
  partcv[0] = 1;
  Object sum825 = callmethod(call824, "+(1)", 1, partcv, params);
// compiled op node returning sum825 (depth = 7)
  gc_frame_newslot(sum825);
// call case 4: self request
  params[0] = sum825;
  partcv[0] = 1;
  Object call826 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe819);
// compiled call node returning call826 (depth = 6)
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_addLast_40_1_41_827(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addLast(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addLast(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addLast(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addLast(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe828 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call829 = callmethodflags(self, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe828);
// compiled call node returning call829 (depth = 6)
  gc_frame_end(frame);
  return call829;
}
Object meth_collectionsPrelude__apply_40_1_41_833(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe834 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call835 = callmethodflags(self, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe834);
// compiled call node returning call835 (depth = 8)
  gc_frame_end(frame);
  return call835;
}
Object meth_collectionsPrelude_addAll_40_1_41_830(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAll(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe831 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 7)
  Object block832 = alloc_Block(NULL, NULL, "collectionsPrelude", 729);
  gc_frame_newslot(block832);
// method "_apply(_)"
  block_savedest(block832);
  Object closure833 = createclosure(1, "_apply(1)");
  setclosureframe(closure833, stackframe);
  addtoclosure(closure833, selfslot);
  struct UserObject *uo833 = (struct UserObject*)block832;
  uo833->data[0] = (Object)closure833;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_833 = addmethod2pos(block832, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_833, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_833[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_833->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_833);
  meth_meth_collectionsPrelude__apply_40_1_41_833->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_833->definitionLine = 1991;
// compiled block node returning block832 (depth = 7)
  gc_frame_newslot(block832);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block832;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call837 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe831);
// compiled call node returning call837 (depth = 6)
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_addFirst_40_1_41_838(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addFirst(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addFirst(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addFirst(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elem = &(stackframe->slots[0]);
  *var_elem = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addFirst(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe839 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num841 = alloc_Float64(1);
// compiled num node returning num841 (depth = 8)
  int op_slot_right_840 = gc_frame_newslot(num841);
// starting to compile member node (depth = 8)
  int callframe843 = gc_frame_new();
// call case 4: self request
  Object call844 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe843);
// compiled member node returning call844 (depth = 8)
  int op_slot_left_840 = gc_frame_newslot(call844);
  params[0] = num841;
  partcv[0] = 1;
  Object sum845 = callmethod(call844, "+(1)", 1, partcv, params);
// compiled op node returning sum845 (depth = 7)
  gc_frame_newslot(sum845);
// call case 4: self request
  params[0] = sum845;
  partcv[0] = 1;
  Object call846 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe839);
// compiled call node returning call846 (depth = 6)
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_removeFirst847(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeFirst");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe848 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num849 = alloc_Float64(1);
// compiled num node returning num849 (depth = 7)
  gc_frame_newslot(num849);
// call case 4: self request
  params[0] = num849;
  partcv[0] = 1;
  Object call850 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe848);
// compiled call node returning call850 (depth = 6)
  gc_frame_end(frame);
  return call850;
}
Object meth_collectionsPrelude__apply854(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elt = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe855 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit857 == NULL) {
    strlit857 = alloc_String("");
    gc_root(strlit857);
  }
// compiled string node returning strlit857 (depth = 11)
  int op_slot_right_856 = gc_frame_newslot(strlit857);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_elt (depth = 12)
  int op_slot_right_859 = gc_frame_newslot(*var_elt);
// starting to compile string node (depth = 12)
  if (strlit861 == NULL) {
    strlit861 = alloc_String("list does not contain object ");
    gc_root(strlit861);
  }
// compiled string node returning strlit861 (depth = 12)
  int op_slot_left_859 = gc_frame_newslot(strlit861);
  params[0] = *var_elt;
  partcv[0] = 1;
  Object opresult862 = callmethod(strlit861, "++(1)", 1, partcv, params);
// compiled op node returning opresult862 (depth = 11)
  int op_slot_left_856 = gc_frame_newslot(opresult862);
  params[0] = strlit857;
  partcv[0] = 1;
  Object opresult863 = callmethod(opresult862, "++(1)", 1, partcv, params);
// compiled op node returning opresult863 (depth = 10)
  gc_frame_newslot(opresult863);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_NoSuchObject (depth = 10)
  params[0] = opresult863;
  partcv[0] = 1;
  Object call864 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe855);
// compiled call node returning call864 (depth = 9)
  gc_frame_end(frame);
  return call864;
}
Object meth_collectionsPrelude_remove_40_1_41_851(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "remove(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for remove(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part remove(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe852 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_elt (depth = 8)
  gc_frame_newslot(*var_elt);
// starting to compile block node (depth = 8)
  Object block853 = alloc_Block(NULL, NULL, "collectionsPrelude", 745);
  gc_frame_newslot(block853);
// method "_apply"
  block_savedest(block853);
  Object closure854 = createclosure(3, "_apply");
  setclosureframe(closure854, stackframe);
  addtoclosure(closure854, var_elt);
  addtoclosure(closure854, var_NoSuchObject);
  addtoclosure(closure854, selfslot);
  struct UserObject *uo854 = (struct UserObject*)block853;
  uo854->data[0] = (Object)closure854;
  Method *meth_meth_collectionsPrelude__apply854 = addmethod2pos(block853, "_apply", &meth_collectionsPrelude__apply854, 0);
  int argcv_meth_collectionsPrelude__apply854[] = {0};
  meth_meth_collectionsPrelude__apply854->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply854);
  meth_meth_collectionsPrelude__apply854->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply854->definitionLine = 1991;
// compiled block node returning block853 (depth = 8)
  gc_frame_newslot(block853);
// call case 4: self request
  params[0] = *var_elt;
  params[1] = block853;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call866 = callmethodflags(self, "indexOf(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe852);
// compiled call node returning call866 (depth = 7)
  *var_ix = call866;
  if (call866 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe867 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call868 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe867);
// compiled call node returning call868 (depth = 6)
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply872(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe873 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_action (depth = 11)
  Object call874 = callmethodflags(*var_action, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe873);
// compiled member node returning call874 (depth = 10)
  block_return(realself, call874);
// compiled return node returning undefined (depth = 9)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_869(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "remove(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for remove(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part remove(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "ix");
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe870 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_elt (depth = 8)
  gc_frame_newslot(*var_elt);
// starting to compile block node (depth = 8)
  Object block871 = alloc_Block(NULL, NULL, "collectionsPrelude", 754);
  gc_frame_newslot(block871);
// method "_apply"
  block_savedest(block871);
  Object closure872 = createclosure(2, "_apply");
  setclosureframe(closure872, stackframe);
  addtoclosure(closure872, var_action);
  addtoclosure(closure872, selfslot);
  struct UserObject *uo872 = (struct UserObject*)block871;
  uo872->data[0] = (Object)closure872;
  Method *meth_meth_collectionsPrelude__apply872 = addmethod2pos(block871, "_apply", &meth_collectionsPrelude__apply872, 0);
  int argcv_meth_collectionsPrelude__apply872[] = {0};
  meth_meth_collectionsPrelude__apply872->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply872);
  meth_meth_collectionsPrelude__apply872->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply872->definitionLine = 1991;
// compiled block node returning block871 (depth = 8)
  gc_frame_newslot(block871);
// call case 4: self request
  params[0] = *var_elt;
  params[1] = block871;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call876 = callmethodflags(self, "indexOf(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe870);
// compiled call node returning call876 (depth = 7)
  *var_ix = call876;
  if (call876 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe877 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call878 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe877);
// compiled call node returning call878 (depth = 6)
// Begin line 758
  setline(758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply882(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe883 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit884 == NULL) {
    strlit884 = alloc_String("list does not contain object");
    gc_root(strlit884);
  }
// compiled string node returning strlit884 (depth = 9)
  gc_frame_newslot(strlit884);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_NoSuchObject (depth = 9)
  params[0] = strlit884;
  partcv[0] = 1;
  Object call885 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe883);
// compiled call node returning call885 (depth = 8)
  gc_frame_end(frame);
  return call885;
}
Object meth_collectionsPrelude_removeAll_40_1_41_879(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_vs = &(stackframe->slots[0]);
  *var_vs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe880 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_vs (depth = 7)
  gc_frame_newslot(*var_vs);
// starting to compile block node (depth = 7)
  Object block881 = alloc_Block(NULL, NULL, "collectionsPrelude", 762);
  gc_frame_newslot(block881);
// method "_apply"
  block_savedest(block881);
  Object closure882 = createclosure(2, "_apply");
  setclosureframe(closure882, stackframe);
  addtoclosure(closure882, var_NoSuchObject);
  addtoclosure(closure882, selfslot);
  struct UserObject *uo882 = (struct UserObject*)block881;
  uo882->data[0] = (Object)closure882;
  Method *meth_meth_collectionsPrelude__apply882 = addmethod2pos(block881, "_apply", &meth_collectionsPrelude__apply882, 0);
  int argcv_meth_collectionsPrelude__apply882[] = {0};
  meth_meth_collectionsPrelude__apply882->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply882);
  meth_meth_collectionsPrelude__apply882->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply882->definitionLine = 1991;
// compiled block node returning block881 (depth = 7)
  gc_frame_newslot(block881);
// call case 4: self request
  params[0] = *var_vs;
  params[1] = block881;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call887 = callmethodflags(self, "removeAll(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe880);
// compiled call node returning call887 (depth = 6)
  gc_frame_end(frame);
  return call887;
}
Object meth_collectionsPrelude__apply894(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile num node (depth = 11)
  Object num895 = alloc_Float64(0);
// compiled num node returning num895 (depth = 11)
  gc_frame_end(frame);
  return num895;
}
Object meth_collectionsPrelude__apply_40_1_41_891(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe892 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_each (depth = 10)
  gc_frame_newslot(*var_each);
// starting to compile block node (depth = 10)
  Object block893 = alloc_Block(NULL, NULL, "collectionsPrelude", 768);
  gc_frame_newslot(block893);
// method "_apply"
  block_savedest(block893);
  Object closure894 = createclosure(1, "_apply");
  setclosureframe(closure894, stackframe);
  addtoclosure(closure894, selfslot);
  struct UserObject *uo894 = (struct UserObject*)block893;
  uo894->data[0] = (Object)closure894;
  Method *meth_meth_collectionsPrelude__apply894 = addmethod2pos(block893, "_apply", &meth_collectionsPrelude__apply894, 0);
  int argcv_meth_collectionsPrelude__apply894[] = {0};
  meth_meth_collectionsPrelude__apply894->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply894);
  meth_meth_collectionsPrelude__apply894->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply894->definitionLine = 1991;
// compiled block node returning block893 (depth = 10)
  gc_frame_newslot(block893);
// call case 4: self request
  params[0] = *var_each;
  params[1] = block893;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call897 = callmethodflags(self, "indexOf(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe892);
// compiled call node returning call897 (depth = 9)
  *var_ix = call897;
  if (call897 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num900 = alloc_Float64(0);
// compiled num node returning num900 (depth = 10)
  int op_slot_right_899 = gc_frame_newslot(num900);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  int op_slot_left_899 = gc_frame_newslot(*var_ix);
  params[0] = num900;
  partcv[0] = 1;
  Object opresult902 = callmethod(*var_ix, "≠(1)", 1, partcv, params);
// compiled op node returning opresult902 (depth = 9)
  Object if898 = done;
  if (istrue(opresult902)) {
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe903 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call904 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe903);
// compiled call node returning call904 (depth = 9)
    gc_frame_newslot(call904);
    if898 = call904;
  } else {
// Begin line 772
  setline(772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe905 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_action (depth = 10)
  Object call906 = callmethodflags(*var_action, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe905);
// compiled member node returning call906 (depth = 9)
    gc_frame_newslot(call906);
    if898 = call906;
  }
// compiled if node returning if898 (depth = 8)
  gc_frame_end(frame);
  return if898;
}
Object meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_888(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAll(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for removeAll(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_vs = &(stackframe->slots[0]);
  *var_vs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAll(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe889 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_vs (depth = 7)
  gc_frame_newslot(*var_vs);
// starting to compile block node (depth = 7)
  Object block890 = alloc_Block(NULL, NULL, "collectionsPrelude", 767);
  gc_frame_newslot(block890);
// method "_apply(_)"
  block_savedest(block890);
  Object closure891 = createclosure(2, "_apply(1)");
  setclosureframe(closure891, stackframe);
  addtoclosure(closure891, var_action);
  addtoclosure(closure891, selfslot);
  struct UserObject *uo891 = (struct UserObject*)block890;
  uo891->data[0] = (Object)closure891;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_891 = addmethod2pos(block890, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_891, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_891[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_891->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_891);
  meth_meth_collectionsPrelude__apply_40_1_41_891->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_891->definitionLine = 1991;
// compiled block node returning block890 (depth = 7)
  gc_frame_newslot(block890);
// call case 5: prelude request
  params[0] = *var_vs;
  params[1] = block890;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call908 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe889);
// compiled call node returning call908 (depth = 6)
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_pop909(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe910 = gc_frame_new();
// call case 4: self request
  Object call911 = callmethodflags(self, "removeLast", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe910);
// compiled member node returning call911 (depth = 6)
  gc_frame_end(frame);
  return call911;
}
Object meth_collectionsPrelude__apply_40_1_41_923(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe924 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_result (depth = 9)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call925 = callmethodflags(*var_result, "addFirst(1)", 1, partcv, params, 0);
  gc_frame_end(callframe924);
// compiled call node returning call925 (depth = 8)
  gc_frame_end(frame);
  return call925;
}
Object meth_collectionsPrelude_reversed912(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe913 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe914 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe915 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe916 = gc_frame_new();
// call case 3: self.outer request
  Object call917 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe916);
// compiled member node returning call917 (depth = 10)
  Object call918 = callmethodflags(call917, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe915);
// compiled member node returning call918 (depth = 9)
  Object call919 = callmethodflags(call918, "list", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe914);
// compiled member node returning call919 (depth = 8)
  Object call920 = callmethodflags(call919, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe913);
// compiled member node returning call920 (depth = 7)
  *var_result = call920;
  if (call920 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe921 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block922 = alloc_Block(NULL, NULL, "collectionsPrelude", 782);
  gc_frame_newslot(block922);
// method "_apply(_)"
  block_savedest(block922);
  Object closure923 = createclosure(2, "_apply(1)");
  setclosureframe(closure923, stackframe);
  addtoclosure(closure923, var_result);
  addtoclosure(closure923, selfslot);
  struct UserObject *uo923 = (struct UserObject*)block922;
  uo923->data[0] = (Object)closure923;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_923 = addmethod2pos(block922, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_923, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_923[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_923->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_923);
  meth_meth_collectionsPrelude__apply_40_1_41_923->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_923->definitionLine = 1991;
// compiled block node returning block922 (depth = 7)
  gc_frame_newslot(block922);
// call case 4: self request
  params[0] = block922;
  partcv[0] = 1;
  Object call927 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe921);
// compiled call node returning call927 (depth = 6)
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude__apply942(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_hiIx = getfromclosure(closure, 0);
  Object *var_loIx = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_hiIx (depth = 9)
  int op_slot_right_943 = gc_frame_newslot(*var_hiIx);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_loIx (depth = 9)
  int op_slot_left_943 = gc_frame_newslot(*var_loIx);
  params[0] = *var_hiIx;
  partcv[0] = 1;
  Object opresult945 = callmethod(*var_loIx, "<(1)", 1, partcv, params);
// compiled op node returning opresult945 (depth = 8)
  gc_frame_end(frame);
  return opresult945;
}
Object meth_collectionsPrelude__apply948(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_hiIx = getfromclosure(closure, 0);
  Object *var_loIx = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_hiVal = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "hiVal");
// Begin line 790
  setline(790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe949 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_hiIx (depth = 10)
  gc_frame_newslot(*var_hiIx);
// call case 4: self request
  params[0] = *var_hiIx;
  partcv[0] = 1;
  Object call950 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe949);
// compiled call node returning call950 (depth = 9)
  *var_hiVal = call950;
  if (call950 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 791
  setline(791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe951 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_hiIx (depth = 9)
  gc_frame_newslot(*var_hiIx);
// starting to compile call node (depth = 9)
  int callframe952 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_loIx (depth = 10)
  gc_frame_newslot(*var_loIx);
// call case 4: self request
  params[0] = *var_loIx;
  partcv[0] = 1;
  Object call953 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe952);
// compiled call node returning call953 (depth = 9)
  gc_frame_newslot(call953);
// call case 4: self request
  params[0] = *var_hiIx;
  params[1] = call953;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call954 = callmethodflags(self, "at(1)put(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe951);
// compiled call node returning call954 (depth = 8)
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe955 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_loIx (depth = 9)
  gc_frame_newslot(*var_loIx);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_hiVal (depth = 9)
  gc_frame_newslot(*var_hiVal);
// call case 4: self request
  params[0] = *var_loIx;
  params[1] = *var_hiVal;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call956 = callmethodflags(self, "at(1)put(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe955);
// compiled call node returning call956 (depth = 8)
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num958 = alloc_Float64(1);
// compiled num node returning num958 (depth = 10)
  int op_slot_right_957 = gc_frame_newslot(num958);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_hiIx (depth = 10)
  int op_slot_left_957 = gc_frame_newslot(*var_hiIx);
  params[0] = num958;
  partcv[0] = 1;
  Object diff960 = callmethod(*var_hiIx, "-(1)", 1, partcv, params);
// compiled op node returning diff960 (depth = 9)
  *var_hiIx = diff960;
  if (diff960 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num963 = alloc_Float64(1);
// compiled num node returning num963 (depth = 10)
  int op_slot_right_962 = gc_frame_newslot(num963);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_loIx (depth = 10)
  int op_slot_left_962 = gc_frame_newslot(*var_loIx);
  params[0] = num963;
  partcv[0] = 1;
  Object sum965 = callmethod(*var_loIx, "+(1)", 1, partcv, params);
// compiled op node returning sum965 (depth = 9)
  *var_loIx = sum965;
  if (sum965 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_reverse928(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reverse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_hiIx = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "hiIx");
  Object *var_loIx = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "loIx");
// Begin line 786
  setline(786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe929 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num931 = alloc_Float64(1);
// compiled num node returning num931 (depth = 8)
  int op_slot_right_930 = gc_frame_newslot(num931);
// starting to compile member node (depth = 8)
  int callframe933 = gc_frame_new();
// call case 4: self request
  Object call934 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe933);
// compiled member node returning call934 (depth = 8)
  int op_slot_left_930 = gc_frame_newslot(call934);
  params[0] = num931;
  partcv[0] = 1;
  Object sum935 = callmethod(call934, "+(1)", 1, partcv, params);
// compiled op node returning sum935 (depth = 7)
  gc_frame_newslot(sum935);
// call case 4: self request
  params[0] = sum935;
  partcv[0] = 1;
  Object call936 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe929);
// compiled call node returning call936 (depth = 6)
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe937 = gc_frame_new();
// call case 4: self request
  Object call938 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe937);
// compiled member node returning call938 (depth = 7)
  *var_hiIx = call938;
  if (call938 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile num node (depth = 7)
  Object num939 = alloc_Float64(1);
// compiled num node returning num939 (depth = 7)
  *var_loIx = num939;
  if (num939 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe940 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block941 = alloc_Block(NULL, NULL, "collectionsPrelude", 789);
  gc_frame_newslot(block941);
// method "_apply"
  block_savedest(block941);
  Object closure942 = createclosure(3, "_apply");
  setclosureframe(closure942, stackframe);
  addtoclosure(closure942, var_hiIx);
  addtoclosure(closure942, var_loIx);
  addtoclosure(closure942, selfslot);
  struct UserObject *uo942 = (struct UserObject*)block941;
  uo942->data[0] = (Object)closure942;
  Method *meth_meth_collectionsPrelude__apply942 = addmethod2pos(block941, "_apply", &meth_collectionsPrelude__apply942, 0);
  int argcv_meth_collectionsPrelude__apply942[] = {0};
  meth_meth_collectionsPrelude__apply942->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply942);
  meth_meth_collectionsPrelude__apply942->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply942->definitionLine = 1991;
// compiled block node returning block941 (depth = 7)
  gc_frame_newslot(block941);
// starting to compile block node (depth = 7)
  Object block947 = alloc_Block(NULL, NULL, "collectionsPrelude", 789);
  gc_frame_newslot(block947);
// method "_apply"
  block_savedest(block947);
  Object closure948 = createclosure(3, "_apply");
  setclosureframe(closure948, stackframe);
  addtoclosure(closure948, var_hiIx);
  addtoclosure(closure948, var_loIx);
  addtoclosure(closure948, selfslot);
  struct UserObject *uo948 = (struct UserObject*)block947;
  uo948->data[0] = (Object)closure948;
  Method *meth_meth_collectionsPrelude__apply948 = addmethod2pos(block947, "_apply", &meth_collectionsPrelude__apply948, 0);
  int argcv_meth_collectionsPrelude__apply948[] = {0};
  meth_meth_collectionsPrelude__apply948->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply948);
  meth_meth_collectionsPrelude__apply948->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply948->definitionLine = 1991;
// compiled block node returning block947 (depth = 7)
  gc_frame_newslot(block947);
// call case 5: prelude request
  params[0] = block941;
  params[1] = block947;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call968 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe940);
// compiled call node returning call968 (depth = 6)
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__43__43__40_1_41_969(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_l = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "l");
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe970 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe971 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe972 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe973 = gc_frame_new();
// call case 3: self.outer request
  Object call974 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe973);
// compiled member node returning call974 (depth = 10)
  Object call975 = callmethodflags(call974, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe972);
// compiled member node returning call975 (depth = 9)
  Object call976 = callmethodflags(call975, "list", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe971);
// compiled member node returning call976 (depth = 8)
  params[0] = self;
  partcv[0] = 1;
  Object call977 = callmethodflags(call976, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe970);
// compiled call node returning call977 (depth = 7)
  *var_l = call977;
  if (call977 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe978 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call979 = callmethodflags(*var_l, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe978);
// compiled call node returning call979 (depth = 6)
  gc_frame_end(frame);
  return call979;
}
Object meth_collectionsPrelude__apply_40_1_41_990(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_curSize = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 809
  setline(809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe992 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 11)
  int callframe993 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call994 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe993);
// compiled call node returning call994 (depth = 11)
  Object call995 = callmethodflags(call994, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe992);
// compiled member node returning call995 (depth = 10)
  int op_slot_right_991 = gc_frame_newslot(call995);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_991 = gc_frame_newslot(*var_s);
  params[0] = call995;
  partcv[0] = 1;
  Object opresult997 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult997 (depth = 9)
  *var_s = opresult997;
  if (opresult997 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 810
  setline(810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_curSize (depth = 10)
  int op_slot_right_1000 = gc_frame_newslot(*var_curSize);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_1000 = gc_frame_newslot(*var_i);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult1002 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult1002 (depth = 9)
  Object if999 = done;
  if (istrue(opresult1002)) {
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1004 == NULL) {
    strlit1004 = alloc_String(", ");
    gc_root(strlit1004);
  }
// compiled string node returning strlit1004 (depth = 11)
  int op_slot_right_1003 = gc_frame_newslot(strlit1004);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1003 = gc_frame_newslot(*var_s);
  params[0] = strlit1004;
  partcv[0] = 1;
  Object opresult1006 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1006 (depth = 10)
  *var_s = opresult1006;
  if (opresult1006 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if999 = done;
  } else {
  }
// compiled if node returning if999 (depth = 8)
  gc_frame_end(frame);
  return if999;
}
Object meth_collectionsPrelude_asString980(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
  Object *var_curSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "curSize");
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit981 == NULL) {
    strlit981 = alloc_String("[");
    gc_root(strlit981);
  }
// compiled string node returning strlit981 (depth = 7)
  *var_s = strlit981;
  if (strlit981 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 807
  setline(807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe982 = gc_frame_new();
// call case 4: self request
  Object call983 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe982);
// compiled member node returning call983 (depth = 7)
  *var_curSize = call983;
  if (call983 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe984 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_curSize (depth = 8)
  int op_slot_right_985 = gc_frame_newslot(*var_curSize);
// starting to compile num node (depth = 8)
  Object num987 = alloc_Float64(1);
// compiled num node returning num987 (depth = 8)
  int op_slot_left_985 = gc_frame_newslot(num987);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult988 = callmethod(num987, "..(1)", 1, partcv, params);
// compiled op node returning opresult988 (depth = 7)
  gc_frame_newslot(opresult988);
// starting to compile block node (depth = 7)
  Object block989 = alloc_Block(NULL, NULL, "collectionsPrelude", 808);
  gc_frame_newslot(block989);
// method "_apply(_)"
  block_savedest(block989);
  Object closure990 = createclosure(3, "_apply(1)");
  setclosureframe(closure990, stackframe);
  addtoclosure(closure990, var_s);
  addtoclosure(closure990, var_curSize);
  addtoclosure(closure990, selfslot);
  struct UserObject *uo990 = (struct UserObject*)block989;
  uo990->data[0] = (Object)closure990;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_990 = addmethod2pos(block989, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_990, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_990[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_990->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_990);
  meth_meth_collectionsPrelude__apply_40_1_41_990->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_990->definitionLine = 1991;
// compiled block node returning block989 (depth = 7)
  gc_frame_newslot(block989);
// call case 5: prelude request
  params[0] = opresult988;
  params[1] = block989;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1009 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe984);
// compiled call node returning call1009 (depth = 6)
// Begin line 812
  setline(812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1011 == NULL) {
    strlit1011 = alloc_String("]");
    gc_root(strlit1011);
  }
// compiled string node returning strlit1011 (depth = 7)
  int op_slot_right_1010 = gc_frame_newslot(strlit1011);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1010 = gc_frame_newslot(*var_s);
  params[0] = strlit1011;
  partcv[0] = 1;
  Object opresult1013 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1013 (depth = 6)
  gc_frame_end(frame);
  return opresult1013;
}
Object meth_collectionsPrelude__apply_40_1_41_1024(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_curSize = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe1026 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 11)
  int callframe1027 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1028 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1027);
// compiled call node returning call1028 (depth = 11)
  Object call1029 = callmethodflags(call1028, "asDebugString", 0, partcv, params, 0);
  gc_frame_end(callframe1026);
// compiled member node returning call1029 (depth = 10)
  int op_slot_right_1025 = gc_frame_newslot(call1029);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1025 = gc_frame_newslot(*var_s);
  params[0] = call1029;
  partcv[0] = 1;
  Object opresult1031 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1031 (depth = 9)
  *var_s = opresult1031;
  if (opresult1031 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_curSize (depth = 10)
  int op_slot_right_1034 = gc_frame_newslot(*var_curSize);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_1034 = gc_frame_newslot(*var_i);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult1036 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult1036 (depth = 9)
  Object if1033 = done;
  if (istrue(opresult1036)) {
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1038 == NULL) {
    strlit1038 = alloc_String(", ");
    gc_root(strlit1038);
  }
// compiled string node returning strlit1038 (depth = 11)
  int op_slot_right_1037 = gc_frame_newslot(strlit1038);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1037 = gc_frame_newslot(*var_s);
  params[0] = strlit1038;
  partcv[0] = 1;
  Object opresult1040 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1040 (depth = 10)
  *var_s = opresult1040;
  if (opresult1040 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if1033 = done;
  } else {
  }
// compiled if node returning if1033 (depth = 8)
  gc_frame_end(frame);
  return if1033;
}
Object meth_collectionsPrelude_asDebugString1014(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
  Object *var_curSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "curSize");
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1015 == NULL) {
    strlit1015 = alloc_String("[");
    gc_root(strlit1015);
  }
// compiled string node returning strlit1015 (depth = 7)
  *var_s = strlit1015;
  if (strlit1015 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1016 = gc_frame_new();
// call case 4: self request
  Object call1017 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1016);
// compiled member node returning call1017 (depth = 7)
  *var_curSize = call1017;
  if (call1017 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1018 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_curSize (depth = 8)
  int op_slot_right_1019 = gc_frame_newslot(*var_curSize);
// starting to compile num node (depth = 8)
  Object num1021 = alloc_Float64(1);
// compiled num node returning num1021 (depth = 8)
  int op_slot_left_1019 = gc_frame_newslot(num1021);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult1022 = callmethod(num1021, "..(1)", 1, partcv, params);
// compiled op node returning opresult1022 (depth = 7)
  gc_frame_newslot(opresult1022);
// starting to compile block node (depth = 7)
  Object block1023 = alloc_Block(NULL, NULL, "collectionsPrelude", 818);
  gc_frame_newslot(block1023);
// method "_apply(_)"
  block_savedest(block1023);
  Object closure1024 = createclosure(3, "_apply(1)");
  setclosureframe(closure1024, stackframe);
  addtoclosure(closure1024, var_s);
  addtoclosure(closure1024, var_curSize);
  addtoclosure(closure1024, selfslot);
  struct UserObject *uo1024 = (struct UserObject*)block1023;
  uo1024->data[0] = (Object)closure1024;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1024 = addmethod2pos(block1023, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1024, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1024[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1024->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1024);
  meth_meth_collectionsPrelude__apply_40_1_41_1024->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1024->definitionLine = 1991;
// compiled block node returning block1023 (depth = 7)
  gc_frame_newslot(block1023);
// call case 5: prelude request
  params[0] = opresult1022;
  params[1] = block1023;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1043 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1018);
// compiled call node returning call1043 (depth = 6)
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1045 == NULL) {
    strlit1045 = alloc_String("]");
    gc_root(strlit1045);
  }
// compiled string node returning strlit1045 (depth = 7)
  int op_slot_right_1044 = gc_frame_newslot(strlit1045);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1044 = gc_frame_newslot(*var_s);
  params[0] = strlit1045;
  partcv[0] = 1;
  Object opresult1047 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1047 (depth = 6)
  gc_frame_end(frame);
  return opresult1047;
}
Object meth_collectionsPrelude_extend_40_1_41_1048(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "extend(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extend(_)");
  Object params[1];
  int partcv[1];
  Object *var_done = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extend(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part extend(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1049 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  gc_frame_newslot(*var_l);
// call case 4: self request
  params[0] = *var_l;
  partcv[0] = 1;
  Object call1050 = callmethodflags(self, "addAll(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1049);
// compiled call node returning call1050 (depth = 6)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_done (depth = 6)
  gc_frame_end(frame);
  return *var_done;
}
Object meth_collectionsPrelude__apply_40_1_41_1054(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_element = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_element (depth = 10)
  int op_slot_right_1056 = gc_frame_newslot(*var_element);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_each (depth = 10)
  int op_slot_left_1056 = gc_frame_newslot(*var_each);
  params[0] = *var_element;
  partcv[0] = 1;
  Object opresult1058 = callmethod(*var_each, "==(1)", 1, partcv, params);
// compiled op node returning opresult1058 (depth = 9)
  Object if1055 = done;
  if (istrue(opresult1058)) {
// starting to compile return node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool1059 = alloc_Boolean(1);
// compiled identifier node returning bool1059 (depth = 10)
  block_return(realself, bool1059);
// compiled return node returning undefined (depth = 9)
    gc_frame_newslot(undefined);
    if1055 = undefined;
  } else {
  }
// compiled if node returning if1055 (depth = 8)
  gc_frame_end(frame);
  return if1055;
}
Object meth_collectionsPrelude_contains_40_1_41_1051(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_element = &(stackframe->slots[0]);
  *var_element = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1052 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1053 = alloc_Block(NULL, NULL, "collectionsPrelude", 829);
  gc_frame_newslot(block1053);
// method "_apply(_)"
  block_savedest(block1053);
  Object closure1054 = createclosure(2, "_apply(1)");
  setclosureframe(closure1054, stackframe);
  addtoclosure(closure1054, var_element);
  addtoclosure(closure1054, selfslot);
  struct UserObject *uo1054 = (struct UserObject*)block1053;
  uo1054->data[0] = (Object)closure1054;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1054 = addmethod2pos(block1053, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1054, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1054[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1054->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1054);
  meth_meth_collectionsPrelude__apply_40_1_41_1054->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1054->definitionLine = 1991;
// compiled block node returning block1053 (depth = 7)
  gc_frame_newslot(block1053);
// call case 4: self request
  params[0] = block1053;
  partcv[0] = 1;
  Object call1061 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1052);
// compiled call node returning call1061 (depth = 6)
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1062 = alloc_Boolean(0);
// compiled identifier node returning bool1062 (depth = 7)
  return bool1062;
// compiled return node returning undefined (depth = 6)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply1069(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_curSize = getfromclosure(closure, 0);
  Object *var_i = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_curSize (depth = 9)
  int op_slot_right_1070 = gc_frame_newslot(*var_curSize);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_1070 = gc_frame_newslot(*var_i);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult1072 = callmethod(*var_i, "≤(1)", 1, partcv, params);
// compiled op node returning opresult1072 (depth = 8)
  gc_frame_end(frame);
  return opresult1072;
}
Object meth_collectionsPrelude__apply1075(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1076 = gc_frame_new();
// starting to compile call node (depth = 9)
  int callframe1077 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1078 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1077);
// compiled call node returning call1078 (depth = 9)
  gc_frame_newslot(call1078);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_block1 (depth = 9)
  params[0] = call1078;
  partcv[0] = 1;
  Object call1079 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1076);
// compiled call node returning call1079 (depth = 8)
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1081 = alloc_Float64(1);
// compiled num node returning num1081 (depth = 10)
  int op_slot_right_1080 = gc_frame_newslot(num1081);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_1080 = gc_frame_newslot(*var_i);
  params[0] = num1081;
  partcv[0] = 1;
  Object sum1083 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum1083 (depth = 9)
  *var_i = sum1083;
  if (sum1083 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do_40_1_41_1063(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
  Object *var_curSize = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "curSize");
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1064 = alloc_Float64(1);
// compiled num node returning num1064 (depth = 7)
  *var_i = num1064;
  if (num1064 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1065 = gc_frame_new();
// call case 4: self request
  Object call1066 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1065);
// compiled member node returning call1066 (depth = 7)
  *var_curSize = call1066;
  if (call1066 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1067 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1068 = alloc_Block(NULL, NULL, "collectionsPrelude", 836);
  gc_frame_newslot(block1068);
// method "_apply"
  block_savedest(block1068);
  Object closure1069 = createclosure(3, "_apply");
  setclosureframe(closure1069, stackframe);
  addtoclosure(closure1069, var_curSize);
  addtoclosure(closure1069, var_i);
  addtoclosure(closure1069, selfslot);
  struct UserObject *uo1069 = (struct UserObject*)block1068;
  uo1069->data[0] = (Object)closure1069;
  Method *meth_meth_collectionsPrelude__apply1069 = addmethod2pos(block1068, "_apply", &meth_collectionsPrelude__apply1069, 0);
  int argcv_meth_collectionsPrelude__apply1069[] = {0};
  meth_meth_collectionsPrelude__apply1069->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1069);
  meth_meth_collectionsPrelude__apply1069->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1069->definitionLine = 1991;
// compiled block node returning block1068 (depth = 7)
  gc_frame_newslot(block1068);
// starting to compile block node (depth = 7)
  Object block1074 = alloc_Block(NULL, NULL, "collectionsPrelude", 836);
  gc_frame_newslot(block1074);
// method "_apply"
  block_savedest(block1074);
  Object closure1075 = createclosure(3, "_apply");
  setclosureframe(closure1075, stackframe);
  addtoclosure(closure1075, var_i);
  addtoclosure(closure1075, var_block1);
  addtoclosure(closure1075, selfslot);
  struct UserObject *uo1075 = (struct UserObject*)block1074;
  uo1075->data[0] = (Object)closure1075;
  Method *meth_meth_collectionsPrelude__apply1075 = addmethod2pos(block1074, "_apply", &meth_collectionsPrelude__apply1075, 0);
  int argcv_meth_collectionsPrelude__apply1075[] = {0};
  meth_meth_collectionsPrelude__apply1075->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1075);
  meth_meth_collectionsPrelude__apply1075->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1075->definitionLine = 1991;
// compiled block node returning block1074 (depth = 7)
  gc_frame_newslot(block1074);
// call case 5: prelude request
  params[0] = block1068;
  params[1] = block1074;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1086 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1067);
// compiled call node returning call1086 (depth = 6)
  gc_frame_end(frame);
  return call1086;
}
Object meth_collectionsPrelude__61__61__40_1_41_1087(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1088 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1089 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1090 = gc_frame_new();
// call case 3: self.outer request
  Object call1091 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1090);
// compiled member node returning call1091 (depth = 8)
  Object call1092 = callmethodflags(call1091, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1089);
// compiled member node returning call1092 (depth = 7)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1093 = callmethodflags(call1092, "isEqual(1)toIterable(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1088);
// compiled call node returning call1093 (depth = 6)
  gc_frame_end(frame);
  return call1093;
}
Object meth_collectionsPrelude_asDebugString1099(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1101 == NULL) {
    strlit1101 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit1101);
  }
// compiled string node returning strlit1101 (depth = 7)
  int op_slot_right_1100 = gc_frame_newslot(strlit1101);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1104 = gc_frame_new();
// call case 4: self request
  Object call1105 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1104);
// compiled member node returning call1105 (depth = 8)
  int op_slot_right_1103 = gc_frame_newslot(call1105);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1108 == NULL) {
    strlit1108 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit1108);
  }
// compiled string node returning strlit1108 (depth = 9)
  int op_slot_right_1107 = gc_frame_newslot(strlit1108);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe1111 = gc_frame_new();
// call case 4: self request
  Object call1112 = callmethodflags(self, "asString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1111);
// compiled member node returning call1112 (depth = 10)
  int op_slot_right_1110 = gc_frame_newslot(call1112);
// starting to compile string node (depth = 10)
  if (strlit1114 == NULL) {
    strlit1114 = alloc_String("");
    gc_root(strlit1114);
  }
// compiled string node returning strlit1114 (depth = 10)
  int op_slot_left_1110 = gc_frame_newslot(strlit1114);
  params[0] = call1112;
  partcv[0] = 1;
  Object opresult1115 = callmethod(strlit1114, "++(1)", 1, partcv, params);
// compiled op node returning opresult1115 (depth = 9)
  int op_slot_left_1107 = gc_frame_newslot(opresult1115);
  params[0] = strlit1108;
  partcv[0] = 1;
  Object opresult1116 = callmethod(opresult1115, "++(1)", 1, partcv, params);
// compiled op node returning opresult1116 (depth = 8)
  int op_slot_left_1103 = gc_frame_newslot(opresult1116);
  params[0] = call1105;
  partcv[0] = 1;
  Object opresult1117 = callmethod(opresult1116, "++(1)", 1, partcv, params);
// compiled op node returning opresult1117 (depth = 7)
  int op_slot_left_1100 = gc_frame_newslot(opresult1117);
  params[0] = strlit1101;
  partcv[0] = 1;
  Object opresult1118 = callmethod(opresult1117, "++(1)", 1, partcv, params);
// compiled op node returning opresult1118 (depth = 6)
  gc_frame_end(frame);
  return opresult1118;
}
Object meth_collectionsPrelude_asString1119(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1120 == NULL) {
    strlit1120 = alloc_String("aListIterator");
    gc_root(strlit1120);
  }
// compiled string node returning strlit1120 (depth = 6)
  gc_frame_end(frame);
  return strlit1120;
}
Object meth_collectionsPrelude_hasNext1121(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1123 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1124 = gc_frame_new();
// call case 3: self.outer request
  Object call1125 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1124);
// compiled member node returning call1125 (depth = 8)
  Object call1126 = callmethodflags(call1125, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1123);
// compiled member node returning call1126 (depth = 7)
  int op_slot_right_1122 = gc_frame_newslot(call1126);
// starting to compile member node (depth = 7)
  int callframe1128 = gc_frame_new();
// call case 4: self request
  Object call1129 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1128);
// compiled member node returning call1129 (depth = 7)
  int op_slot_left_1122 = gc_frame_newslot(call1129);
  params[0] = call1126;
  partcv[0] = 1;
  Object opresult1130 = callmethod(call1129, "≤(1)", 1, partcv, params);
// compiled op node returning opresult1130 (depth = 6)
  gc_frame_end(frame);
  return opresult1130;
}
Object meth_collectionsPrelude_next1131(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ret = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ret");
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1134 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1135 = gc_frame_new();
// call case 3: self.outer request
  Object call1136 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1135);
// compiled member node returning call1136 (depth = 9)
  Object call1137 = callmethodflags(call1136, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1134);
// compiled member node returning call1137 (depth = 8)
  int op_slot_right_1133 = gc_frame_newslot(call1137);
// starting to compile member node (depth = 8)
  int callframe1139 = gc_frame_new();
// call case 4: self request
  Object call1140 = callmethodflags(self, "imods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1139);
// compiled member node returning call1140 (depth = 8)
  int op_slot_left_1133 = gc_frame_newslot(call1140);
  params[0] = call1137;
  partcv[0] = 1;
  Object opresult1141 = callmethod(call1140, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1141 (depth = 7)
  Object if1132 = done;
  if (istrue(opresult1141)) {
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1142 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe1143 = gc_frame_new();
// call case 4: self request
  Object call1144 = callmethodflags(self, "asDebugString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1143);
// compiled member node returning call1144 (depth = 8)
  gc_frame_newslot(call1144);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ConcurrentModification (depth = 8)
  params[0] = call1144;
  partcv[0] = 1;
  Object call1145 = callmethodflags(*var_ConcurrentModification, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1142);
// compiled call node returning call1145 (depth = 7)
    gc_frame_newslot(call1145);
    if1132 = call1145;
  } else {
  }
// compiled if node returning if1132 (depth = 6)
// Begin line 857
  setline(857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1148 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1149 = gc_frame_new();
// call case 3: self.outer request
  Object call1150 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1149);
// compiled member node returning call1150 (depth = 9)
  Object call1151 = callmethodflags(call1150, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1148);
// compiled member node returning call1151 (depth = 8)
  int op_slot_right_1147 = gc_frame_newslot(call1151);
// starting to compile member node (depth = 8)
  int callframe1153 = gc_frame_new();
// call case 4: self request
  Object call1154 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1153);
// compiled member node returning call1154 (depth = 8)
  int op_slot_left_1147 = gc_frame_newslot(call1154);
  params[0] = call1151;
  partcv[0] = 1;
  Object opresult1155 = callmethod(call1154, ">(1)", 1, partcv, params);
// compiled op node returning opresult1155 (depth = 7)
  Object if1146 = done;
  if (istrue(opresult1155)) {
// starting to compile call node (depth = 7)
  int callframe1156 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1157 == NULL) {
    strlit1157 = alloc_String("on list");
    gc_root(strlit1157);
  }
// compiled string node returning strlit1157 (depth = 8)
  gc_frame_newslot(strlit1157);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_IteratorExhausted (depth = 8)
  params[0] = strlit1157;
  partcv[0] = 1;
  Object call1158 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1156);
// compiled call node returning call1158 (depth = 7)
    gc_frame_newslot(call1158);
    if1146 = call1158;
  } else {
  }
// compiled if node returning if1146 (depth = 6)
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1159 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe1160 = gc_frame_new();
// call case 4: self request
  Object call1161 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1160);
// compiled member node returning call1161 (depth = 8)
  gc_frame_newslot(call1161);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1162 = gc_frame_new();
// call case 3: self.outer request
  Object call1163 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1162);
// compiled member node returning call1163 (depth = 8)
  params[0] = call1161;
  partcv[0] = 1;
  Object call1164 = callmethodflags(call1163, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1159);
// compiled call node returning call1164 (depth = 7)
  *var_ret = call1164;
  if (call1164 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1165 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1167 = alloc_Float64(1);
// compiled num node returning num1167 (depth = 8)
  int op_slot_right_1166 = gc_frame_newslot(num1167);
// starting to compile member node (depth = 8)
  int callframe1169 = gc_frame_new();
// call case 4: self request
  Object call1170 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1169);
// compiled member node returning call1170 (depth = 8)
  int op_slot_left_1166 = gc_frame_newslot(call1170);
  params[0] = num1167;
  partcv[0] = 1;
  Object sum1171 = callmethod(call1170, "+(1)", 1, partcv, params);
// compiled op node returning sum1171 (depth = 7)
  gc_frame_newslot(sum1171);
// call case 4: self request
  params[0] = sum1171;
  partcv[0] = 1;
  Object call1172 = callmethodflags(self, "idx:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1165);
// compiled call node returning call1172 (depth = 6)
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ret (depth = 6)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_collectionsPrelude_iterator1094(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1095 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1095 = alloc_userobj2(8,7, objclass1095);
  gc_frame_newslot(obj1095);
if (objclass1095 == NULL) {
  glfree(obj1095->class->name);
  obj1095->class->name = "obj723.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1095, self, 0);
  addmethodreal(obj1095,"outer", &reader_collectionsPrelude_outer_1096);
  Object oldself1095 = self;
  struct StackFrameObject *oldstackframe1095 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1095);
  gc_frame_newslot((Object)stackframe);
  self = obj1095;
  Object *oldselfslot1095 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1095 = (*(struct UserObject *)self).data[0], lowerouter1095 = thisouter1095;
  if (inheritingObject1095) {
    struct UserObject *inho1095 = (struct UserObject *)inheritingObject1095;
    while (inho1095->super != GraceDefaultObject) inho1095 = (struct UserObject *)inho1095->super;
    inho1095->super = obj1095;
    self = inheritingObject1095;
    *selfslot = self;
    lowerouter1095 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1095;
  }
if (objclass1095 == NULL) {
  Method *reader1097 = addmethodrealflags(obj1095, "imods", &reader_collectionsPrelude_imods_1097, MFLAG_CONFIDENTIAL);
  Method *writer1097 = addmethodrealflags(obj1095, "imods:=(1)", &writer_collectionsPrelude_imods_1097, MFLAG_CONFIDENTIAL);
  reader1097->definitionModule = modulename;
  writer1097->definitionModule = modulename;
  reader1097->definitionLine = 848;
  writer1097->definitionLine = 848;
}
obj1095->flags |= OFLAG_MUTABLE;
adddatum2(obj1095, alloc_Undefined(), 1);
if (objclass1095 == NULL) {
  Method *reader1098 = addmethodrealflags(obj1095, "idx", &reader_collectionsPrelude_idx_1098, MFLAG_CONFIDENTIAL);
  Method *writer1098 = addmethodrealflags(obj1095, "idx:=(1)", &writer_collectionsPrelude_idx_1098, MFLAG_CONFIDENTIAL);
  reader1098->definitionModule = modulename;
  writer1098->definitionModule = modulename;
  reader1098->definitionLine = 849;
  writer1098->definitionLine = 849;
}
obj1095->flags |= OFLAG_MUTABLE;
adddatum2(obj1095, alloc_Undefined(), 2);
// method "asDebugString"
  struct UserObject *uo1099 = (struct UserObject*)obj1095;
  uo1099->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1099 = addmethod2pos(obj1095, "asDebugString", &meth_collectionsPrelude_asDebugString1099, 3);
  int argcv_meth_collectionsPrelude_asDebugString1099[] = {0};
  meth_meth_collectionsPrelude_asDebugString1099->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1099);
  meth_meth_collectionsPrelude_asDebugString1099->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1099->definitionLine = 850;
// method "asString"
  struct UserObject *uo1119 = (struct UserObject*)obj1095;
  uo1119->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString1119 = addmethod2pos(obj1095, "asString", &meth_collectionsPrelude_asString1119, 4);
  int argcv_meth_collectionsPrelude_asString1119[] = {0};
  meth_meth_collectionsPrelude_asString1119->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString1119);
  meth_meth_collectionsPrelude_asString1119->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString1119->definitionLine = 851;
// method "hasNext"
  struct UserObject *uo1121 = (struct UserObject*)obj1095;
  uo1121->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext1121 = addmethod2pos(obj1095, "hasNext", &meth_collectionsPrelude_hasNext1121, 5);
  int argcv_meth_collectionsPrelude_hasNext1121[] = {0};
  meth_meth_collectionsPrelude_hasNext1121->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext1121);
  meth_meth_collectionsPrelude_hasNext1121->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext1121->definitionLine = 852;
// method "next"
  block_savedest(obj1095);
  Object closure1131 = createclosure(2, "next");
  setclosureframe(closure1131, stackframe);
  addtoclosure(closure1131, var_ConcurrentModification);
  addtoclosure(closure1131, var_IteratorExhausted);
  struct UserObject *uo1131 = (struct UserObject*)obj1095;
  uo1131->data[6] = (Object)closure1131;
  Method *meth_meth_collectionsPrelude_next1131 = addmethod2pos(obj1095, "next", &meth_collectionsPrelude_next1131, 6);
  int argcv_meth_collectionsPrelude_next1131[] = {0};
  meth_meth_collectionsPrelude_next1131->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next1131);
  meth_meth_collectionsPrelude_next1131->definitionModule = modulename;
  meth_meth_collectionsPrelude_next1131->definitionLine = 853;
  sourceObject = obj1095;
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1173 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1174 = gc_frame_new();
// call case 3: self.outer request
  Object call1175 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1174);
// compiled member node returning call1175 (depth = 7)
  Object call1176 = callmethodflags(call1175, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1173);
// compiled member node returning call1176 (depth = 6)
  adddatum2(obj1095, call1176, 1);
  sourceObject = obj1095;
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1177 = alloc_Float64(1);
// compiled num node returning num1177 (depth = 6)
  adddatum2(obj1095, num1177, 2);
  sourceObject = obj1095;
  sourceObject = obj1095;
  sourceObject = obj1095;
  sourceObject = obj1095;
  objclass1095 = obj1095->class;
  objclass1095->definitionModule = modulename;
  objclass1095->definitionLine = 847;
  (*(struct UserObject *)self).data[0] = lowerouter1095;
  self = oldself1095;
  selfslot = oldselfslot1095;
  stackframe = oldstackframe1095;
  gc_frame_end(frame);
  return obj1095;
}
Object meth_collectionsPrelude_iterator1094_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1095 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1095 = alloc_userobj2(8,7, objclass1095);
  gc_frame_newslot(obj1095);
if (objclass1095 == NULL) {
  glfree(obj1095->class->name);
  obj1095->class->name = "obj723.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1095, self, 0);
  addmethodreal(obj1095,"outer", &reader_collectionsPrelude_outer_1096);
  Object oldself1095 = self;
  struct StackFrameObject *oldstackframe1095 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1095);
  gc_frame_newslot((Object)stackframe);
  self = obj1095;
  Object *oldselfslot1095 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1095 = (*(struct UserObject *)self).data[0], lowerouter1095 = thisouter1095;
  if (inheritingObject1095) {
    struct UserObject *inho1095 = (struct UserObject *)inheritingObject1095;
    while (inho1095->super != GraceDefaultObject) inho1095 = (struct UserObject *)inho1095->super;
    inho1095->super = obj1095;
    self = inheritingObject1095;
    *selfslot = self;
    lowerouter1095 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1095;
  }
if (objclass1095 == NULL) {
  Method *reader1097 = addmethodrealflags(obj1095, "imods", &reader_collectionsPrelude_imods_1097, MFLAG_CONFIDENTIAL);
  Method *writer1097 = addmethodrealflags(obj1095, "imods:=(1)", &writer_collectionsPrelude_imods_1097, MFLAG_CONFIDENTIAL);
  reader1097->definitionModule = modulename;
  writer1097->definitionModule = modulename;
  reader1097->definitionLine = 848;
  writer1097->definitionLine = 848;
}
obj1095->flags |= OFLAG_MUTABLE;
adddatum2(obj1095, alloc_Undefined(), 1);
if (objclass1095 == NULL) {
  Method *reader1098 = addmethodrealflags(obj1095, "idx", &reader_collectionsPrelude_idx_1098, MFLAG_CONFIDENTIAL);
  Method *writer1098 = addmethodrealflags(obj1095, "idx:=(1)", &writer_collectionsPrelude_idx_1098, MFLAG_CONFIDENTIAL);
  reader1098->definitionModule = modulename;
  writer1098->definitionModule = modulename;
  reader1098->definitionLine = 849;
  writer1098->definitionLine = 849;
}
obj1095->flags |= OFLAG_MUTABLE;
adddatum2(obj1095, alloc_Undefined(), 2);
// method "asDebugString"
  struct UserObject *uo1099 = (struct UserObject*)obj1095;
  uo1099->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1099 = addmethod2pos(obj1095, "asDebugString", &meth_collectionsPrelude_asDebugString1099, 3);
  int argcv_meth_collectionsPrelude_asDebugString1099[] = {0};
  meth_meth_collectionsPrelude_asDebugString1099->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1099);
  meth_meth_collectionsPrelude_asDebugString1099->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1099->definitionLine = 850;
// method "asString"
  struct UserObject *uo1119 = (struct UserObject*)obj1095;
  uo1119->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString1119 = addmethod2pos(obj1095, "asString", &meth_collectionsPrelude_asString1119, 4);
  int argcv_meth_collectionsPrelude_asString1119[] = {0};
  meth_meth_collectionsPrelude_asString1119->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString1119);
  meth_meth_collectionsPrelude_asString1119->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString1119->definitionLine = 851;
// method "hasNext"
  struct UserObject *uo1121 = (struct UserObject*)obj1095;
  uo1121->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext1121 = addmethod2pos(obj1095, "hasNext", &meth_collectionsPrelude_hasNext1121, 5);
  int argcv_meth_collectionsPrelude_hasNext1121[] = {0};
  meth_meth_collectionsPrelude_hasNext1121->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext1121);
  meth_meth_collectionsPrelude_hasNext1121->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext1121->definitionLine = 852;
// method "next"
  block_savedest(obj1095);
  Object closure1131 = createclosure(2, "next");
  setclosureframe(closure1131, stackframe);
  addtoclosure(closure1131, var_ConcurrentModification);
  addtoclosure(closure1131, var_IteratorExhausted);
  struct UserObject *uo1131 = (struct UserObject*)obj1095;
  uo1131->data[6] = (Object)closure1131;
  Method *meth_meth_collectionsPrelude_next1131 = addmethod2pos(obj1095, "next", &meth_collectionsPrelude_next1131, 6);
  int argcv_meth_collectionsPrelude_next1131[] = {0};
  meth_meth_collectionsPrelude_next1131->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next1131);
  meth_meth_collectionsPrelude_next1131->definitionModule = modulename;
  meth_meth_collectionsPrelude_next1131->definitionLine = 853;
  sourceObject = obj1095;
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1173 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1174 = gc_frame_new();
// call case 3: self.outer request
  Object call1175 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1174);
// compiled member node returning call1175 (depth = 7)
  Object call1176 = callmethodflags(call1175, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1173);
// compiled member node returning call1176 (depth = 6)
  adddatum2(obj1095, call1176, 1);
  sourceObject = obj1095;
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1177 = alloc_Float64(1);
// compiled num node returning num1177 (depth = 6)
  adddatum2(obj1095, num1177, 2);
  sourceObject = obj1095;
  sourceObject = obj1095;
  sourceObject = obj1095;
  sourceObject = obj1095;
  objclass1095 = obj1095->class;
  objclass1095->definitionModule = modulename;
  objclass1095->definitionLine = 847;
  (*(struct UserObject *)self).data[0] = lowerouter1095;
  self = oldself1095;
  selfslot = oldselfslot1095;
  stackframe = oldstackframe1095;
  gc_frame_end(frame);
  return obj1095;
}
Object meth_collectionsPrelude_values1179(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_keys1180(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1181 = gc_frame_new();
// call case 4: self request
  Object call1182 = callmethodflags(self, "indices", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1181);
// compiled member node returning call1182 (depth = 6)
  gc_frame_end(frame);
  return call1182;
}
Object meth_collectionsPrelude__apply_40_2_41_1194(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_r (depth = 10)
  int op_slot_right_1196 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_l (depth = 10)
  int op_slot_left_1196 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult1198 = callmethod(*var_l, "==(1)", 1, partcv, params);
// compiled op node returning opresult1198 (depth = 9)
  Object if1195 = done;
  if (istrue(opresult1198)) {
// starting to compile num node (depth = 9)
  Object num1199 = alloc_Float64(0);
// compiled num node returning num1199 (depth = 9)
    gc_frame_newslot(num1199);
    if1195 = num1199;
  } else {
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 877
  setline(877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_r (depth = 11)
  int op_slot_right_1201 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_l (depth = 11)
  int op_slot_left_1201 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult1203 = callmethod(*var_l, "<(1)", 1, partcv, params);
// compiled op node returning opresult1203 (depth = 10)
  Object if1200 = done;
  if (istrue(opresult1203)) {
// starting to compile call node (depth = 10)
  int callframe1204 = gc_frame_new();
// call case 6: other requests
// starting to compile num node (depth = 11)
  Object num1205 = alloc_Float64(1);
// compiled num node returning num1205 (depth = 11)
  partcv[0] = 0;
  Object call1206 = callmethodflags(num1205, "prefix-", 1, partcv, params, 0);
  gc_frame_end(callframe1204);
// compiled call node returning call1206 (depth = 10)
    gc_frame_newslot(call1206);
    if1200 = call1206;
  } else {
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 10)
  Object num1207 = alloc_Float64(1);
// compiled num node returning num1207 (depth = 10)
    gc_frame_newslot(num1207);
    if1200 = num1207;
  }
// compiled if node returning if1200 (depth = 9)
    gc_frame_newslot(if1200);
    if1195 = if1200;
  }
// compiled if node returning if1195 (depth = 8)
  gc_frame_end(frame);
  return if1195;
}
Object meth_collectionsPrelude_sort1183(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sort");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1184 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1186 = alloc_Float64(1);
// compiled num node returning num1186 (depth = 8)
  int op_slot_right_1185 = gc_frame_newslot(num1186);
// starting to compile member node (depth = 8)
  int callframe1188 = gc_frame_new();
// call case 4: self request
  Object call1189 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1188);
// compiled member node returning call1189 (depth = 8)
  int op_slot_left_1185 = gc_frame_newslot(call1189);
  params[0] = num1186;
  partcv[0] = 1;
  Object sum1190 = callmethod(call1189, "+(1)", 1, partcv, params);
// compiled op node returning sum1190 (depth = 7)
  gc_frame_newslot(sum1190);
// call case 4: self request
  params[0] = sum1190;
  partcv[0] = 1;
  Object call1191 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1184);
// compiled call node returning call1191 (depth = 6)
// Begin line 875
  setline(875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1192 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1193 = alloc_Block(NULL, NULL, "collectionsPrelude", 875);
  gc_frame_newslot(block1193);
// method "_apply(_,_)"
  block_savedest(block1193);
  Object closure1194 = createclosure(1, "_apply(2)");
  setclosureframe(closure1194, stackframe);
  addtoclosure(closure1194, selfslot);
  struct UserObject *uo1194 = (struct UserObject*)block1193;
  uo1194->data[0] = (Object)closure1194;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_1194 = addmethod2pos(block1193, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_1194, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_1194[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_1194->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_1194);
  meth_meth_collectionsPrelude__apply_40_2_41_1194->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_1194->definitionLine = 1991;
// compiled block node returning block1193 (depth = 7)
  gc_frame_newslot(block1193);
// call case 4: self request
  params[0] = block1193;
  partcv[0] = 1;
  Object call1209 = callmethodflags(self, "sortBy(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1192);
// compiled call node returning call1209 (depth = 6)
  gc_frame_end(frame);
  return call1209;
}
Object meth_collectionsPrelude_sortedBy_40_1_41_1210(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1211 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sortBlock (depth = 7)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1212 = gc_frame_new();
// call case 4: self request
  Object call1213 = callmethodflags(self, "copy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1212);
// compiled member node returning call1213 (depth = 7)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call1214 = callmethodflags(call1213, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1211);
// compiled call node returning call1214 (depth = 6)
  gc_frame_end(frame);
  return call1214;
}
Object meth_collectionsPrelude_sorted1215(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1216 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1217 = gc_frame_new();
// call case 4: self request
  Object call1218 = callmethodflags(self, "copy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1217);
// compiled member node returning call1218 (depth = 7)
  Object call1219 = callmethodflags(call1218, "sort", 0, partcv, params, 0);
  gc_frame_end(callframe1216);
// compiled member node returning call1219 (depth = 6)
  gc_frame_end(frame);
  return call1219;
}
Object meth_collectionsPrelude_copy1220(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1221 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1222 = gc_frame_new();
// call case 3: self.outer request
  Object call1223 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1222);
// compiled member node returning call1223 (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call1224 = callmethodflags(call1223, "withAll(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1221);
// compiled call node returning call1224 (depth = 6)
  gc_frame_end(frame);
  return call1224;
}
Object meth_collectionsPrelude__apply_40_1_41_1231(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
// compiled call node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_boundsCheck_40_1_41_1241(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "boundsCheck(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method boundsCheck(_)");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for boundsCheck(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part boundsCheck(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1244 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1246 = gc_frame_new();
// call case 4: self request
  Object call1247 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1246);
// compiled member node returning call1247 (depth = 6)
  int op_slot_right_1245 = gc_frame_newslot(call1247);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_1245 = gc_frame_newslot(*var_n);
  params[0] = call1247;
  partcv[0] = 1;
  Object opresult1249 = callmethod(*var_n, "≤(1)", 1, partcv, params);
// compiled op node returning opresult1249 (depth = 5)
  partcv[0] = 0;
  Object call1250 = callmethodflags(opresult1249, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe1244);
// compiled call node returning call1250 (depth = 4)
  int op_slot_right_1243 = gc_frame_newslot(call1250);
// starting to compile call node (depth = 4)
  int callframe1252 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1254 = alloc_Float64(1);
// compiled num node returning num1254 (depth = 6)
  int op_slot_right_1253 = gc_frame_newslot(num1254);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_1253 = gc_frame_newslot(*var_n);
  params[0] = num1254;
  partcv[0] = 1;
  Object opresult1256 = callmethod(*var_n, "≥(1)", 1, partcv, params);
// compiled op node returning opresult1256 (depth = 5)
  partcv[0] = 0;
  Object call1257 = callmethodflags(opresult1256, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe1252);
// compiled call node returning call1257 (depth = 4)
  int op_slot_left_1243 = gc_frame_newslot(call1257);
  params[0] = call1250;
  partcv[0] = 1;
  Object opresult1258 = callmethod(call1257, "||(1)", 1, partcv, params);
// compiled op node returning opresult1258 (depth = 3)
  Object if1242 = done;
  if (istrue(opresult1258)) {
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1259 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1261 == NULL) {
    strlit1261 = alloc_String("");
    gc_root(strlit1261);
  }
// compiled string node returning strlit1261 (depth = 5)
  int op_slot_right_1260 = gc_frame_newslot(strlit1261);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1264 = gc_frame_new();
// call case 4: self request
  Object call1265 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1264);
// compiled member node returning call1265 (depth = 6)
  int op_slot_right_1263 = gc_frame_newslot(call1265);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1268 == NULL) {
    strlit1268 = alloc_String(" out of bounds 1..");
    gc_root(strlit1268);
  }
// compiled string node returning strlit1268 (depth = 7)
  int op_slot_right_1267 = gc_frame_newslot(strlit1268);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_right_1270 = gc_frame_newslot(*var_n);
// starting to compile string node (depth = 8)
  if (strlit1272 == NULL) {
    strlit1272 = alloc_String("index ");
    gc_root(strlit1272);
  }
// compiled string node returning strlit1272 (depth = 8)
  int op_slot_left_1270 = gc_frame_newslot(strlit1272);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult1273 = callmethod(strlit1272, "++(1)", 1, partcv, params);
// compiled op node returning opresult1273 (depth = 7)
  int op_slot_left_1267 = gc_frame_newslot(opresult1273);
  params[0] = strlit1268;
  partcv[0] = 1;
  Object opresult1274 = callmethod(opresult1273, "++(1)", 1, partcv, params);
// compiled op node returning opresult1274 (depth = 6)
  int op_slot_left_1263 = gc_frame_newslot(opresult1274);
  params[0] = call1265;
  partcv[0] = 1;
  Object opresult1275 = callmethod(opresult1274, "++(1)", 1, partcv, params);
// compiled op node returning opresult1275 (depth = 5)
  int op_slot_left_1260 = gc_frame_newslot(opresult1275);
  params[0] = strlit1261;
  partcv[0] = 1;
  Object opresult1276 = callmethod(opresult1275, "++(1)", 1, partcv, params);
// compiled op node returning opresult1276 (depth = 4)
  gc_frame_newslot(opresult1276);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult1276;
  partcv[0] = 1;
  Object call1277 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1259);
// compiled call node returning call1277 (depth = 3)
    gc_frame_newslot(call1277);
    if1242 = call1277;
  } else {
  }
// compiled if node returning if1242 (depth = 2)
  gc_frame_end(frame);
  return if1242;
}
Object meth_collectionsPrelude_at_40_1_41_1278(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1279 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1280 = callmethodflags(self, "boundsCheck(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1279);
// compiled call node returning call1280 (depth = 2)
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1281 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1283 = alloc_Float64(1);
// compiled num node returning num1283 (depth = 4)
  int op_slot_right_1282 = gc_frame_newslot(num1283);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_1282 = gc_frame_newslot(*var_n);
  params[0] = num1283;
  partcv[0] = 1;
  Object diff1285 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff1285 (depth = 3)
  gc_frame_newslot(diff1285);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1286 = gc_frame_new();
// call case 4: self request
  Object call1287 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1286);
// compiled member node returning call1287 (depth = 3)
  params[0] = diff1285;
  partcv[0] = 1;
  Object call1288 = callmethodflags(call1287, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1281);
// compiled call node returning call1288 (depth = 2)
  gc_frame_end(frame);
  return call1288;
}
Object meth_collectionsPrelude_at_40_1_41_put_40_1_41_1289(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)put(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)put(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)put(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for at(_)put(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *var_x = &(stackframe->slots[1]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part put(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1290 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1292 = alloc_Float64(1);
// compiled num node returning num1292 (depth = 4)
  int op_slot_right_1291 = gc_frame_newslot(num1292);
// starting to compile member node (depth = 4)
  int callframe1294 = gc_frame_new();
// call case 4: self request
  Object call1295 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1294);
// compiled member node returning call1295 (depth = 4)
  int op_slot_left_1291 = gc_frame_newslot(call1295);
  params[0] = num1292;
  partcv[0] = 1;
  Object sum1296 = callmethod(call1295, "+(1)", 1, partcv, params);
// compiled op node returning sum1296 (depth = 3)
  gc_frame_newslot(sum1296);
// call case 4: self request
  params[0] = sum1296;
  partcv[0] = 1;
  Object call1297 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1290);
// compiled call node returning call1297 (depth = 2)
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1301 = alloc_Float64(1);
// compiled num node returning num1301 (depth = 5)
  int op_slot_right_1300 = gc_frame_newslot(num1301);
// starting to compile member node (depth = 5)
  int callframe1303 = gc_frame_new();
// call case 4: self request
  Object call1304 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1303);
// compiled member node returning call1304 (depth = 5)
  int op_slot_left_1300 = gc_frame_newslot(call1304);
  params[0] = num1301;
  partcv[0] = 1;
  Object sum1305 = callmethod(call1304, "+(1)", 1, partcv, params);
// compiled op node returning sum1305 (depth = 4)
  int op_slot_right_1299 = gc_frame_newslot(sum1305);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_1299 = gc_frame_newslot(*var_n);
  params[0] = sum1305;
  partcv[0] = 1;
  Object opresult1307 = callmethod(*var_n, "==(1)", 1, partcv, params);
// compiled op node returning opresult1307 (depth = 3)
  Object if1298 = done;
  if (istrue(opresult1307)) {
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1308 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call1309 = callmethodflags(self, "addLast(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1308);
// compiled call node returning call1309 (depth = 3)
    gc_frame_newslot(call1309);
    if1298 = call1309;
  } else {
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1310 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1311 = callmethodflags(self, "boundsCheck(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1310);
// compiled call node returning call1311 (depth = 3)
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1312 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1314 = alloc_Float64(1);
// compiled num node returning num1314 (depth = 5)
  int op_slot_right_1313 = gc_frame_newslot(num1314);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  int op_slot_left_1313 = gc_frame_newslot(*var_n);
  params[0] = num1314;
  partcv[0] = 1;
  Object diff1316 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff1316 (depth = 4)
  gc_frame_newslot(diff1316);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1317 = gc_frame_new();
// call case 4: self request
  Object call1318 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1317);
// compiled member node returning call1318 (depth = 4)
  params[0] = diff1316;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1319 = callmethodflags(call1318, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1312);
// compiled call node returning call1319 (depth = 3)
    gc_frame_newslot(call1319);
    if1298 = call1319;
  }
// compiled if node returning if1298 (depth = 2)
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_add_40_1_41_1320(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "add(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method add(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for add(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part add(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 946
  setline(946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1321 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1323 = alloc_Float64(1);
// compiled num node returning num1323 (depth = 4)
  int op_slot_right_1322 = gc_frame_newslot(num1323);
// starting to compile member node (depth = 4)
  int callframe1325 = gc_frame_new();
// call case 4: self request
  Object call1326 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1325);
// compiled member node returning call1326 (depth = 4)
  int op_slot_left_1322 = gc_frame_newslot(call1326);
  params[0] = num1323;
  partcv[0] = 1;
  Object sum1327 = callmethod(call1326, "+(1)", 1, partcv, params);
// compiled op node returning sum1327 (depth = 3)
  gc_frame_newslot(sum1327);
// call case 4: self request
  params[0] = sum1327;
  partcv[0] = 1;
  Object call1328 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1321);
// compiled call node returning call1328 (depth = 2)
// Begin line 947
  setline(947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1331 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1332 = gc_frame_new();
// call case 4: self request
  Object call1333 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1332);
// compiled member node returning call1333 (depth = 5)
  Object call1334 = callmethodflags(call1333, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1331);
// compiled member node returning call1334 (depth = 4)
  int op_slot_right_1330 = gc_frame_newslot(call1334);
// starting to compile member node (depth = 4)
  int callframe1336 = gc_frame_new();
// call case 4: self request
  Object call1337 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1336);
// compiled member node returning call1337 (depth = 4)
  int op_slot_left_1330 = gc_frame_newslot(call1337);
  params[0] = call1334;
  partcv[0] = 1;
  Object opresult1338 = callmethod(call1337, "==(1)", 1, partcv, params);
// compiled op node returning opresult1338 (depth = 3)
  Object if1329 = done;
  if (istrue(opresult1338)) {
// starting to compile call node (depth = 3)
  int callframe1339 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1341 = alloc_Float64(2);
// compiled num node returning num1341 (depth = 5)
  int op_slot_right_1340 = gc_frame_newslot(num1341);
// starting to compile member node (depth = 5)
  int callframe1343 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1344 = gc_frame_new();
// call case 4: self request
  Object call1345 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1344);
// compiled member node returning call1345 (depth = 6)
  Object call1346 = callmethodflags(call1345, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1343);
// compiled member node returning call1346 (depth = 5)
  int op_slot_left_1340 = gc_frame_newslot(call1346);
  params[0] = num1341;
  partcv[0] = 1;
  Object prod1347 = callmethod(call1346, "*(1)", 1, partcv, params);
// compiled op node returning prod1347 (depth = 4)
  gc_frame_newslot(prod1347);
// call case 4: self request
  params[0] = prod1347;
  partcv[0] = 1;
  Object call1348 = callmethodflags(self, "expandTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1339);
// compiled call node returning call1348 (depth = 3)
    gc_frame_newslot(call1348);
    if1329 = call1348;
  } else {
  }
// compiled if node returning if1329 (depth = 2)
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1349 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe1350 = gc_frame_new();
// call case 4: self request
  Object call1351 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1350);
// compiled member node returning call1351 (depth = 3)
  gc_frame_newslot(call1351);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_x (depth = 3)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1352 = gc_frame_new();
// call case 4: self request
  Object call1353 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1352);
// compiled member node returning call1353 (depth = 3)
  params[0] = call1351;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1354 = callmethodflags(call1353, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1349);
// compiled call node returning call1354 (depth = 2)
// Begin line 949
  setline(949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1355 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1357 = alloc_Float64(1);
// compiled num node returning num1357 (depth = 4)
  int op_slot_right_1356 = gc_frame_newslot(num1357);
// starting to compile member node (depth = 4)
  int callframe1359 = gc_frame_new();
// call case 4: self request
  Object call1360 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1359);
// compiled member node returning call1360 (depth = 4)
  int op_slot_left_1356 = gc_frame_newslot(call1360);
  params[0] = num1357;
  partcv[0] = 1;
  Object sum1361 = callmethod(call1360, "+(1)", 1, partcv, params);
// compiled op node returning sum1361 (depth = 3)
  gc_frame_newslot(sum1361);
// call case 4: self request
  params[0] = sum1361;
  partcv[0] = 1;
  Object call1362 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1355);
// compiled call node returning call1362 (depth = 2)
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_1_41_1410(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1411 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1412 = gc_frame_new();
// call case 4: self request
  Object call1413 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1412);
// compiled member node returning call1413 (depth = 5)
  gc_frame_newslot(call1413);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1414 = gc_frame_new();
// call case 4: self request
  Object call1415 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1414);
// compiled member node returning call1415 (depth = 5)
  params[0] = call1413;
  params[1] = *var_each;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1416 = callmethodflags(call1415, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1411);
// compiled call node returning call1416 (depth = 4)
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1417 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1419 = alloc_Float64(1);
// compiled num node returning num1419 (depth = 6)
  int op_slot_right_1418 = gc_frame_newslot(num1419);
// starting to compile member node (depth = 6)
  int callframe1421 = gc_frame_new();
// call case 4: self request
  Object call1422 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1421);
// compiled member node returning call1422 (depth = 6)
  int op_slot_left_1418 = gc_frame_newslot(call1422);
  params[0] = num1419;
  partcv[0] = 1;
  Object sum1423 = callmethod(call1422, "+(1)", 1, partcv, params);
// compiled op node returning sum1423 (depth = 5)
  gc_frame_newslot(sum1423);
// call case 4: self request
  params[0] = sum1423;
  partcv[0] = 1;
  Object call1424 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1417);
// compiled call node returning call1424 (depth = 4)
  gc_frame_end(frame);
  return call1424;
}
Object meth_collectionsPrelude_addAll_40_1_41_1363(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAll(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1364 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1366 = alloc_Float64(1);
// compiled num node returning num1366 (depth = 4)
  int op_slot_right_1365 = gc_frame_newslot(num1366);
// starting to compile member node (depth = 4)
  int callframe1368 = gc_frame_new();
// call case 4: self request
  Object call1369 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1368);
// compiled member node returning call1369 (depth = 4)
  int op_slot_left_1365 = gc_frame_newslot(call1369);
  params[0] = num1366;
  partcv[0] = 1;
  Object sum1370 = callmethod(call1369, "+(1)", 1, partcv, params);
// compiled op node returning sum1370 (depth = 3)
  gc_frame_newslot(sum1370);
// call case 4: self request
  params[0] = sum1370;
  partcv[0] = 1;
  Object call1371 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1364);
// compiled call node returning call1371 (depth = 2)
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1374 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1375 = gc_frame_new();
// call case 4: self request
  Object call1376 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1375);
// compiled member node returning call1376 (depth = 5)
  Object call1377 = callmethodflags(call1376, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1374);
// compiled member node returning call1377 (depth = 4)
  int op_slot_right_1373 = gc_frame_newslot(call1377);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1380 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_l (depth = 6)
  Object call1381 = callmethodflags(*var_l, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1380);
// compiled member node returning call1381 (depth = 5)
  int op_slot_right_1379 = gc_frame_newslot(call1381);
// starting to compile member node (depth = 5)
  int callframe1383 = gc_frame_new();
// call case 4: self request
  Object call1384 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1383);
// compiled member node returning call1384 (depth = 5)
  int op_slot_left_1379 = gc_frame_newslot(call1384);
  params[0] = call1381;
  partcv[0] = 1;
  Object sum1385 = callmethod(call1384, "+(1)", 1, partcv, params);
// compiled op node returning sum1385 (depth = 4)
  int op_slot_left_1373 = gc_frame_newslot(sum1385);
  params[0] = call1377;
  partcv[0] = 1;
  Object opresult1386 = callmethod(sum1385, ">(1)", 1, partcv, params);
// compiled op node returning opresult1386 (depth = 3)
  Object if1372 = done;
  if (istrue(opresult1386)) {
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1387 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1388 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1390 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  Object call1391 = callmethodflags(*var_l, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1390);
// compiled member node returning call1391 (depth = 6)
  int op_slot_right_1389 = gc_frame_newslot(call1391);
// starting to compile member node (depth = 6)
  int callframe1393 = gc_frame_new();
// call case 4: self request
  Object call1394 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1393);
// compiled member node returning call1394 (depth = 6)
  int op_slot_left_1389 = gc_frame_newslot(call1394);
  params[0] = call1391;
  partcv[0] = 1;
  Object sum1395 = callmethod(call1394, "+(1)", 1, partcv, params);
// compiled op node returning sum1395 (depth = 5)
  gc_frame_newslot(sum1395);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1397 = alloc_Float64(2);
// compiled num node returning num1397 (depth = 6)
  int op_slot_right_1396 = gc_frame_newslot(num1397);
// starting to compile member node (depth = 6)
  int callframe1399 = gc_frame_new();
// call case 4: self request
  Object call1400 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1399);
// compiled member node returning call1400 (depth = 6)
  int op_slot_left_1396 = gc_frame_newslot(call1400);
  params[0] = num1397;
  partcv[0] = 1;
  Object prod1401 = callmethod(call1400, "*(1)", 1, partcv, params);
// compiled op node returning prod1401 (depth = 5)
  gc_frame_newslot(prod1401);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1402 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1403 = gc_frame_new();
// call case 3: self.outer request
  Object call1404 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1403);
// compiled member node returning call1404 (depth = 6)
  Object call1405 = callmethodflags(call1404, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1402);
// compiled member node returning call1405 (depth = 5)
  params[0] = sum1395;
  params[1] = prod1401;
  partcv[0] = 2;
  Object call1406 = callmethodflags(call1405, "max(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1388);
// compiled call node returning call1406 (depth = 4)
  gc_frame_newslot(call1406);
// call case 4: self request
  params[0] = call1406;
  partcv[0] = 1;
  Object call1407 = callmethodflags(self, "expandTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1387);
// compiled call node returning call1407 (depth = 3)
    gc_frame_newslot(call1407);
    if1372 = call1407;
  } else {
  }
// compiled if node returning if1372 (depth = 2)
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1408 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 3)
  Object block1409 = alloc_Block(NULL, NULL, "collectionsPrelude", 957);
  gc_frame_newslot(block1409);
// method "_apply(_)"
  block_savedest(block1409);
  Object closure1410 = createclosure(1, "_apply(1)");
  setclosureframe(closure1410, stackframe);
  addtoclosure(closure1410, selfslot);
  struct UserObject *uo1410 = (struct UserObject*)block1409;
  uo1410->data[0] = (Object)closure1410;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1410 = addmethod2pos(block1409, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1410, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1410[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1410->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1410);
  meth_meth_collectionsPrelude__apply_40_1_41_1410->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1410->definitionLine = 1991;
// compiled block node returning block1409 (depth = 3)
  gc_frame_newslot(block1409);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block1409;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1426 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1408);
// compiled call node returning call1426 (depth = 2)
// Begin line 961
  setline(961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_push_40_1_41_1427(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "push(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method push(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for push(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part push(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1428 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1430 = alloc_Float64(1);
// compiled num node returning num1430 (depth = 4)
  int op_slot_right_1429 = gc_frame_newslot(num1430);
// starting to compile member node (depth = 4)
  int callframe1432 = gc_frame_new();
// call case 4: self request
  Object call1433 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1432);
// compiled member node returning call1433 (depth = 4)
  int op_slot_left_1429 = gc_frame_newslot(call1433);
  params[0] = num1430;
  partcv[0] = 1;
  Object sum1434 = callmethod(call1433, "+(1)", 1, partcv, params);
// compiled op node returning sum1434 (depth = 3)
  gc_frame_newslot(sum1434);
// call case 4: self request
  params[0] = sum1434;
  partcv[0] = 1;
  Object call1435 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1428);
// compiled call node returning call1435 (depth = 2)
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1438 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1439 = gc_frame_new();
// call case 4: self request
  Object call1440 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1439);
// compiled member node returning call1440 (depth = 5)
  Object call1441 = callmethodflags(call1440, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1438);
// compiled member node returning call1441 (depth = 4)
  int op_slot_right_1437 = gc_frame_newslot(call1441);
// starting to compile member node (depth = 4)
  int callframe1443 = gc_frame_new();
// call case 4: self request
  Object call1444 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1443);
// compiled member node returning call1444 (depth = 4)
  int op_slot_left_1437 = gc_frame_newslot(call1444);
  params[0] = call1441;
  partcv[0] = 1;
  Object opresult1445 = callmethod(call1444, "==(1)", 1, partcv, params);
// compiled op node returning opresult1445 (depth = 3)
  Object if1436 = done;
  if (istrue(opresult1445)) {
// starting to compile call node (depth = 3)
  int callframe1446 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1448 = alloc_Float64(2);
// compiled num node returning num1448 (depth = 5)
  int op_slot_right_1447 = gc_frame_newslot(num1448);
// starting to compile member node (depth = 5)
  int callframe1450 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1451 = gc_frame_new();
// call case 4: self request
  Object call1452 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1451);
// compiled member node returning call1452 (depth = 6)
  Object call1453 = callmethodflags(call1452, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1450);
// compiled member node returning call1453 (depth = 5)
  int op_slot_left_1447 = gc_frame_newslot(call1453);
  params[0] = num1448;
  partcv[0] = 1;
  Object prod1454 = callmethod(call1453, "*(1)", 1, partcv, params);
// compiled op node returning prod1454 (depth = 4)
  gc_frame_newslot(prod1454);
// call case 4: self request
  params[0] = prod1454;
  partcv[0] = 1;
  Object call1455 = callmethodflags(self, "expandTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1446);
// compiled call node returning call1455 (depth = 3)
    gc_frame_newslot(call1455);
    if1436 = call1455;
  } else {
  }
// compiled if node returning if1436 (depth = 2)
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1456 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe1457 = gc_frame_new();
// call case 4: self request
  Object call1458 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1457);
// compiled member node returning call1458 (depth = 3)
  gc_frame_newslot(call1458);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_x (depth = 3)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1459 = gc_frame_new();
// call case 4: self request
  Object call1460 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1459);
// compiled member node returning call1460 (depth = 3)
  params[0] = call1458;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1461 = callmethodflags(call1460, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1456);
// compiled call node returning call1461 (depth = 2)
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1462 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1464 = alloc_Float64(1);
// compiled num node returning num1464 (depth = 4)
  int op_slot_right_1463 = gc_frame_newslot(num1464);
// starting to compile member node (depth = 4)
  int callframe1466 = gc_frame_new();
// call case 4: self request
  Object call1467 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1466);
// compiled member node returning call1467 (depth = 4)
  int op_slot_left_1463 = gc_frame_newslot(call1467);
  params[0] = num1464;
  partcv[0] = 1;
  Object sum1468 = callmethod(call1467, "+(1)", 1, partcv, params);
// compiled op node returning sum1468 (depth = 3)
  gc_frame_newslot(sum1468);
// call case 4: self request
  params[0] = sum1468;
  partcv[0] = 1;
  Object call1469 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1462);
// compiled call node returning call1469 (depth = 2)
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_addLast_40_1_41_1470(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addLast(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addLast(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addLast(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addLast(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1471 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_x (depth = 3)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call1472 = callmethodflags(self, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1471);
// compiled call node returning call1472 (depth = 2)
  gc_frame_end(frame);
  return call1472;
}
Object meth_collectionsPrelude_removeLast1473(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeLast");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1474 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1476 = alloc_Float64(1);
// compiled num node returning num1476 (depth = 4)
  int op_slot_right_1475 = gc_frame_newslot(num1476);
// starting to compile member node (depth = 4)
  int callframe1478 = gc_frame_new();
// call case 4: self request
  Object call1479 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1478);
// compiled member node returning call1479 (depth = 4)
  int op_slot_left_1475 = gc_frame_newslot(call1479);
  params[0] = num1476;
  partcv[0] = 1;
  Object sum1480 = callmethod(call1479, "+(1)", 1, partcv, params);
// compiled op node returning sum1480 (depth = 3)
  gc_frame_newslot(sum1480);
// call case 4: self request
  params[0] = sum1480;
  partcv[0] = 1;
  Object call1481 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1474);
// compiled call node returning call1481 (depth = 2)
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1482 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1484 = alloc_Float64(1);
// compiled num node returning num1484 (depth = 5)
  int op_slot_right_1483 = gc_frame_newslot(num1484);
// starting to compile member node (depth = 5)
  int callframe1486 = gc_frame_new();
// call case 4: self request
  Object call1487 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1486);
// compiled member node returning call1487 (depth = 5)
  int op_slot_left_1483 = gc_frame_newslot(call1487);
  params[0] = num1484;
  partcv[0] = 1;
  Object diff1488 = callmethod(call1487, "-(1)", 1, partcv, params);
// compiled op node returning diff1488 (depth = 4)
  gc_frame_newslot(diff1488);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1489 = gc_frame_new();
// call case 4: self request
  Object call1490 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1489);
// compiled member node returning call1490 (depth = 4)
  params[0] = diff1488;
  partcv[0] = 1;
  Object call1491 = callmethodflags(call1490, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1482);
// compiled call node returning call1491 (depth = 3)
  *var_result = call1491;
  if (call1491 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1492 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1494 = alloc_Float64(1);
// compiled num node returning num1494 (depth = 4)
  int op_slot_right_1493 = gc_frame_newslot(num1494);
// starting to compile member node (depth = 4)
  int callframe1496 = gc_frame_new();
// call case 4: self request
  Object call1497 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1496);
// compiled member node returning call1497 (depth = 4)
  int op_slot_left_1493 = gc_frame_newslot(call1497);
  params[0] = num1494;
  partcv[0] = 1;
  Object diff1498 = callmethod(call1497, "-(1)", 1, partcv, params);
// compiled op node returning diff1498 (depth = 3)
  gc_frame_newslot(diff1498);
// call case 4: self request
  params[0] = diff1498;
  partcv[0] = 1;
  Object call1499 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1492);
// compiled call node returning call1499 (depth = 2)
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude__apply_40_1_41_1560(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_increase = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1561 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_increase (depth = 6)
  int op_slot_right_1562 = gc_frame_newslot(*var_increase);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1562 = gc_frame_newslot(*var_i);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1564 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum1564 (depth = 5)
  gc_frame_newslot(sum1564);
// starting to compile call node (depth = 5)
  int callframe1565 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1566 = gc_frame_new();
// call case 4: self request
  Object call1567 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1566);
// compiled member node returning call1567 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1568 = callmethodflags(call1567, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1565);
// compiled call node returning call1568 (depth = 5)
  gc_frame_newslot(call1568);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1569 = gc_frame_new();
// call case 4: self request
  Object call1570 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1569);
// compiled member node returning call1570 (depth = 5)
  params[0] = sum1564;
  params[1] = call1568;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1571 = callmethodflags(call1570, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1561);
// compiled call node returning call1571 (depth = 4)
  gc_frame_end(frame);
  return call1571;
}
Object meth_collectionsPrelude__apply_40_1_41_1577(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_insertionIndex = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1578 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_insertionIndex (depth = 5)
  gc_frame_newslot(*var_insertionIndex);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1579 = gc_frame_new();
// call case 4: self request
  Object call1580 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1579);
// compiled member node returning call1580 (depth = 5)
  params[0] = *var_insertionIndex;
  params[1] = *var_each;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1581 = callmethodflags(call1580, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1578);
// compiled call node returning call1581 (depth = 4)
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1583 = alloc_Float64(1);
// compiled num node returning num1583 (depth = 6)
  int op_slot_right_1582 = gc_frame_newslot(num1583);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_insertionIndex (depth = 6)
  int op_slot_left_1582 = gc_frame_newslot(*var_insertionIndex);
  params[0] = num1583;
  partcv[0] = 1;
  Object sum1585 = callmethod(*var_insertionIndex, "+(1)", 1, partcv, params);
// compiled op node returning sum1585 (depth = 5)
  *var_insertionIndex = sum1585;
  if (sum1585 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_addAllFirst_40_1_41_1500(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAllFirst(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAllFirst(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addAllFirst(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addAllFirst(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_increase = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "increase");
  Object *var_insertionIndex = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "insertionIndex");
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1501 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1503 = alloc_Float64(1);
// compiled num node returning num1503 (depth = 4)
  int op_slot_right_1502 = gc_frame_newslot(num1503);
// starting to compile member node (depth = 4)
  int callframe1505 = gc_frame_new();
// call case 4: self request
  Object call1506 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1505);
// compiled member node returning call1506 (depth = 4)
  int op_slot_left_1502 = gc_frame_newslot(call1506);
  params[0] = num1503;
  partcv[0] = 1;
  Object sum1507 = callmethod(call1506, "+(1)", 1, partcv, params);
// compiled op node returning sum1507 (depth = 3)
  gc_frame_newslot(sum1507);
// call case 4: self request
  params[0] = sum1507;
  partcv[0] = 1;
  Object call1508 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1501);
// compiled call node returning call1508 (depth = 2)
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1509 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  Object call1510 = callmethodflags(*var_l, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1509);
// compiled member node returning call1510 (depth = 3)
  *var_increase = call1510;
  if (call1510 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1513 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1514 = gc_frame_new();
// call case 4: self request
  Object call1515 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1514);
// compiled member node returning call1515 (depth = 5)
  Object call1516 = callmethodflags(call1515, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1513);
// compiled member node returning call1516 (depth = 4)
  int op_slot_right_1512 = gc_frame_newslot(call1516);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_increase (depth = 5)
  int op_slot_right_1518 = gc_frame_newslot(*var_increase);
// starting to compile member node (depth = 5)
  int callframe1520 = gc_frame_new();
// call case 4: self request
  Object call1521 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1520);
// compiled member node returning call1521 (depth = 5)
  int op_slot_left_1518 = gc_frame_newslot(call1521);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1522 = callmethod(call1521, "+(1)", 1, partcv, params);
// compiled op node returning sum1522 (depth = 4)
  int op_slot_left_1512 = gc_frame_newslot(sum1522);
  params[0] = call1516;
  partcv[0] = 1;
  Object opresult1523 = callmethod(sum1522, ">(1)", 1, partcv, params);
// compiled op node returning opresult1523 (depth = 3)
  Object if1511 = done;
  if (istrue(opresult1523)) {
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1524 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1525 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_increase (depth = 6)
  int op_slot_right_1526 = gc_frame_newslot(*var_increase);
// starting to compile member node (depth = 6)
  int callframe1528 = gc_frame_new();
// call case 4: self request
  Object call1529 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1528);
// compiled member node returning call1529 (depth = 6)
  int op_slot_left_1526 = gc_frame_newslot(call1529);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1530 = callmethod(call1529, "+(1)", 1, partcv, params);
// compiled op node returning sum1530 (depth = 5)
  gc_frame_newslot(sum1530);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1532 = alloc_Float64(2);
// compiled num node returning num1532 (depth = 6)
  int op_slot_right_1531 = gc_frame_newslot(num1532);
// starting to compile member node (depth = 6)
  int callframe1534 = gc_frame_new();
// call case 4: self request
  Object call1535 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1534);
// compiled member node returning call1535 (depth = 6)
  int op_slot_left_1531 = gc_frame_newslot(call1535);
  params[0] = num1532;
  partcv[0] = 1;
  Object prod1536 = callmethod(call1535, "*(1)", 1, partcv, params);
// compiled op node returning prod1536 (depth = 5)
  gc_frame_newslot(prod1536);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1537 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1538 = gc_frame_new();
// call case 3: self.outer request
  Object call1539 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1538);
// compiled member node returning call1539 (depth = 6)
  Object call1540 = callmethodflags(call1539, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1537);
// compiled member node returning call1540 (depth = 5)
  params[0] = sum1530;
  params[1] = prod1536;
  partcv[0] = 2;
  Object call1541 = callmethodflags(call1540, "max(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1525);
// compiled call node returning call1541 (depth = 4)
  gc_frame_newslot(call1541);
// call case 4: self request
  params[0] = call1541;
  partcv[0] = 1;
  Object call1542 = callmethodflags(self, "expandTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1524);
// compiled call node returning call1542 (depth = 3)
    gc_frame_newslot(call1542);
    if1511 = call1542;
  } else {
  }
// compiled if node returning if1511 (depth = 2)
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1543 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe1544 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1546 = alloc_Float64(1);
// compiled num node returning num1546 (depth = 5)
  int op_slot_right_1545 = gc_frame_newslot(num1546);
// starting to compile member node (depth = 5)
  int callframe1548 = gc_frame_new();
// call case 4: self request
  Object call1549 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1548);
// compiled member node returning call1549 (depth = 5)
  int op_slot_left_1545 = gc_frame_newslot(call1549);
  params[0] = num1546;
  partcv[0] = 1;
  Object diff1550 = callmethod(call1549, "-(1)", 1, partcv, params);
// compiled op node returning diff1550 (depth = 4)
  gc_frame_newslot(diff1550);
// starting to compile num node (depth = 4)
  Object num1551 = alloc_Float64(0);
// compiled num node returning num1551 (depth = 4)
  gc_frame_newslot(num1551);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1552 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1553 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1554 = gc_frame_new();
// call case 3: self.outer request
  Object call1555 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1554);
// compiled member node returning call1555 (depth = 6)
  Object call1556 = callmethodflags(call1555, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1553);
// compiled member node returning call1556 (depth = 5)
  Object call1557 = callmethodflags(call1556, "range", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1552);
// compiled member node returning call1557 (depth = 4)
  params[0] = diff1550;
  params[1] = num1551;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1558 = callmethodflags(call1557, "from(1)downTo(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1544);
// compiled call node returning call1558 (depth = 3)
  gc_frame_newslot(call1558);
// starting to compile block node (depth = 3)
  Object block1559 = alloc_Block(NULL, NULL, "collectionsPrelude", 983);
  gc_frame_newslot(block1559);
// method "_apply(_)"
  block_savedest(block1559);
  Object closure1560 = createclosure(2, "_apply(1)");
  setclosureframe(closure1560, stackframe);
  addtoclosure(closure1560, var_increase);
  addtoclosure(closure1560, selfslot);
  struct UserObject *uo1560 = (struct UserObject*)block1559;
  uo1560->data[0] = (Object)closure1560;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1560 = addmethod2pos(block1559, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1560, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1560[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1560->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1560);
  meth_meth_collectionsPrelude__apply_40_1_41_1560->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1560->definitionLine = 1991;
// compiled block node returning block1559 (depth = 3)
  gc_frame_newslot(block1559);
// call case 5: prelude request
  params[0] = call1558;
  params[1] = block1559;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1573 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1543);
// compiled call node returning call1573 (depth = 2)
// Begin line 986
  setline(986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1574 = alloc_Float64(0);
// compiled num node returning num1574 (depth = 3)
  *var_insertionIndex = num1574;
  if (num1574 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1575 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 3)
  Object block1576 = alloc_Block(NULL, NULL, "collectionsPrelude", 987);
  gc_frame_newslot(block1576);
// method "_apply(_)"
  block_savedest(block1576);
  Object closure1577 = createclosure(2, "_apply(1)");
  setclosureframe(closure1577, stackframe);
  addtoclosure(closure1577, var_insertionIndex);
  addtoclosure(closure1577, selfslot);
  struct UserObject *uo1577 = (struct UserObject*)block1576;
  uo1577->data[0] = (Object)closure1577;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1577 = addmethod2pos(block1576, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1577, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1577[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1577->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1577);
  meth_meth_collectionsPrelude__apply_40_1_41_1577->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1577->definitionLine = 1991;
// compiled block node returning block1576 (depth = 3)
  gc_frame_newslot(block1576);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block1576;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1588 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1575);
// compiled call node returning call1588 (depth = 2)
// Begin line 991
  setline(991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1589 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_increase (depth = 4)
  int op_slot_right_1590 = gc_frame_newslot(*var_increase);
// starting to compile member node (depth = 4)
  int callframe1592 = gc_frame_new();
// call case 4: self request
  Object call1593 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1592);
// compiled member node returning call1593 (depth = 4)
  int op_slot_left_1590 = gc_frame_newslot(call1593);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1594 = callmethod(call1593, "+(1)", 1, partcv, params);
// compiled op node returning sum1594 (depth = 3)
  gc_frame_newslot(sum1594);
// call case 4: self request
  params[0] = sum1594;
  partcv[0] = 1;
  Object call1595 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1589);
// compiled call node returning call1595 (depth = 2)
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_1_41_1644(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1000
  setline(1000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1645 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1647 = alloc_Float64(1);
// compiled num node returning num1647 (depth = 6)
  int op_slot_right_1646 = gc_frame_newslot(num1647);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1646 = gc_frame_newslot(*var_i);
  params[0] = num1647;
  partcv[0] = 1;
  Object sum1649 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum1649 (depth = 5)
  gc_frame_newslot(sum1649);
// starting to compile call node (depth = 5)
  int callframe1650 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1651 = gc_frame_new();
// call case 4: self request
  Object call1652 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1651);
// compiled member node returning call1652 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1653 = callmethodflags(call1652, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1650);
// compiled call node returning call1653 (depth = 5)
  gc_frame_newslot(call1653);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1654 = gc_frame_new();
// call case 4: self request
  Object call1655 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1654);
// compiled member node returning call1655 (depth = 5)
  params[0] = sum1649;
  params[1] = call1653;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1656 = callmethodflags(call1655, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1645);
// compiled call node returning call1656 (depth = 4)
  gc_frame_end(frame);
  return call1656;
}
Object meth_collectionsPrelude_addFirst_40_1_41_1596(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addFirst(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addFirst(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addFirst(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addFirst(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1597 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1599 = alloc_Float64(1);
// compiled num node returning num1599 (depth = 4)
  int op_slot_right_1598 = gc_frame_newslot(num1599);
// starting to compile member node (depth = 4)
  int callframe1601 = gc_frame_new();
// call case 4: self request
  Object call1602 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1601);
// compiled member node returning call1602 (depth = 4)
  int op_slot_left_1598 = gc_frame_newslot(call1602);
  params[0] = num1599;
  partcv[0] = 1;
  Object sum1603 = callmethod(call1602, "+(1)", 1, partcv, params);
// compiled op node returning sum1603 (depth = 3)
  gc_frame_newslot(sum1603);
// call case 4: self request
  params[0] = sum1603;
  partcv[0] = 1;
  Object call1604 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1597);
// compiled call node returning call1604 (depth = 2)
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1607 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1608 = gc_frame_new();
// call case 4: self request
  Object call1609 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1608);
// compiled member node returning call1609 (depth = 5)
  Object call1610 = callmethodflags(call1609, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1607);
// compiled member node returning call1610 (depth = 4)
  int op_slot_right_1606 = gc_frame_newslot(call1610);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1613 = alloc_Float64(1);
// compiled num node returning num1613 (depth = 5)
  int op_slot_right_1612 = gc_frame_newslot(num1613);
// starting to compile member node (depth = 5)
  int callframe1615 = gc_frame_new();
// call case 4: self request
  Object call1616 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1615);
// compiled member node returning call1616 (depth = 5)
  int op_slot_left_1612 = gc_frame_newslot(call1616);
  params[0] = num1613;
  partcv[0] = 1;
  Object sum1617 = callmethod(call1616, "+(1)", 1, partcv, params);
// compiled op node returning sum1617 (depth = 4)
  int op_slot_left_1606 = gc_frame_newslot(sum1617);
  params[0] = call1610;
  partcv[0] = 1;
  Object opresult1618 = callmethod(sum1617, ">(1)", 1, partcv, params);
// compiled op node returning opresult1618 (depth = 3)
  Object if1605 = done;
  if (istrue(opresult1618)) {
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1619 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1621 = alloc_Float64(2);
// compiled num node returning num1621 (depth = 5)
  int op_slot_right_1620 = gc_frame_newslot(num1621);
// starting to compile member node (depth = 5)
  int callframe1623 = gc_frame_new();
// call case 4: self request
  Object call1624 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1623);
// compiled member node returning call1624 (depth = 5)
  int op_slot_left_1620 = gc_frame_newslot(call1624);
  params[0] = num1621;
  partcv[0] = 1;
  Object prod1625 = callmethod(call1624, "*(1)", 1, partcv, params);
// compiled op node returning prod1625 (depth = 4)
  gc_frame_newslot(prod1625);
// call case 4: self request
  params[0] = prod1625;
  partcv[0] = 1;
  Object call1626 = callmethodflags(self, "expandTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1619);
// compiled call node returning call1626 (depth = 3)
    gc_frame_newslot(call1626);
    if1605 = call1626;
  } else {
  }
// compiled if node returning if1605 (depth = 2)
// Begin line 999
  setline(999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1627 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe1628 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1630 = alloc_Float64(1);
// compiled num node returning num1630 (depth = 5)
  int op_slot_right_1629 = gc_frame_newslot(num1630);
// starting to compile member node (depth = 5)
  int callframe1632 = gc_frame_new();
// call case 4: self request
  Object call1633 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1632);
// compiled member node returning call1633 (depth = 5)
  int op_slot_left_1629 = gc_frame_newslot(call1633);
  params[0] = num1630;
  partcv[0] = 1;
  Object diff1634 = callmethod(call1633, "-(1)", 1, partcv, params);
// compiled op node returning diff1634 (depth = 4)
  gc_frame_newslot(diff1634);
// starting to compile num node (depth = 4)
  Object num1635 = alloc_Float64(0);
// compiled num node returning num1635 (depth = 4)
  gc_frame_newslot(num1635);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1636 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1637 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1638 = gc_frame_new();
// call case 3: self.outer request
  Object call1639 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1638);
// compiled member node returning call1639 (depth = 6)
  Object call1640 = callmethodflags(call1639, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1637);
// compiled member node returning call1640 (depth = 5)
  Object call1641 = callmethodflags(call1640, "range", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1636);
// compiled member node returning call1641 (depth = 4)
  params[0] = diff1634;
  params[1] = num1635;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1642 = callmethodflags(call1641, "from(1)downTo(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1628);
// compiled call node returning call1642 (depth = 3)
  gc_frame_newslot(call1642);
// starting to compile block node (depth = 3)
  Object block1643 = alloc_Block(NULL, NULL, "collectionsPrelude", 999);
  gc_frame_newslot(block1643);
// method "_apply(_)"
  block_savedest(block1643);
  Object closure1644 = createclosure(1, "_apply(1)");
  setclosureframe(closure1644, stackframe);
  addtoclosure(closure1644, selfslot);
  struct UserObject *uo1644 = (struct UserObject*)block1643;
  uo1644->data[0] = (Object)closure1644;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1644 = addmethod2pos(block1643, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1644, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1644[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1644->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1644);
  meth_meth_collectionsPrelude__apply_40_1_41_1644->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1644->definitionLine = 1991;
// compiled block node returning block1643 (depth = 3)
  gc_frame_newslot(block1643);
// call case 5: prelude request
  params[0] = call1642;
  params[1] = block1643;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1658 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1627);
// compiled call node returning call1658 (depth = 2)
// Begin line 1002
  setline(1002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1659 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num1660 = alloc_Float64(0);
// compiled num node returning num1660 (depth = 3)
  gc_frame_newslot(num1660);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elt (depth = 3)
  gc_frame_newslot(*var_elt);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1661 = gc_frame_new();
// call case 4: self request
  Object call1662 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1661);
// compiled member node returning call1662 (depth = 3)
  params[0] = num1660;
  params[1] = *var_elt;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1663 = callmethodflags(call1662, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1659);
// compiled call node returning call1663 (depth = 2)
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1664 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1666 = alloc_Float64(1);
// compiled num node returning num1666 (depth = 4)
  int op_slot_right_1665 = gc_frame_newslot(num1666);
// starting to compile member node (depth = 4)
  int callframe1668 = gc_frame_new();
// call case 4: self request
  Object call1669 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1668);
// compiled member node returning call1669 (depth = 4)
  int op_slot_left_1665 = gc_frame_newslot(call1669);
  params[0] = num1666;
  partcv[0] = 1;
  Object sum1670 = callmethod(call1669, "+(1)", 1, partcv, params);
// compiled op node returning sum1670 (depth = 3)
  gc_frame_newslot(sum1670);
// call case 4: self request
  params[0] = sum1670;
  partcv[0] = 1;
  Object call1671 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1664);
// compiled call node returning call1671 (depth = 2)
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_clear1672(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "clear");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1673 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1675 = alloc_Float64(1);
// compiled num node returning num1675 (depth = 4)
  int op_slot_right_1674 = gc_frame_newslot(num1675);
// starting to compile member node (depth = 4)
  int callframe1677 = gc_frame_new();
// call case 4: self request
  Object call1678 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1677);
// compiled member node returning call1678 (depth = 4)
  int op_slot_left_1674 = gc_frame_newslot(call1678);
  params[0] = num1675;
  partcv[0] = 1;
  Object sum1679 = callmethod(call1678, "+(1)", 1, partcv, params);
// compiled op node returning sum1679 (depth = 3)
  gc_frame_newslot(sum1679);
// call case 4: self request
  params[0] = sum1679;
  partcv[0] = 1;
  Object call1680 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1673);
// compiled call node returning call1680 (depth = 2)
// Begin line 1008
  setline(1008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1681 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe1682 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe1683 = gc_frame_new();
// call case 4: self request
  Object call1684 = callmethodflags(self, "initialSize", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1683);
// compiled member node returning call1684 (depth = 4)
  gc_frame_newslot(call1684);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1685 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  Object call1686 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe1685);
// compiled member node returning call1686 (depth = 4)
  params[0] = call1684;
  partcv[0] = 1;
  Object call1687 = callmethodflags(call1686, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1682);
// compiled call node returning call1687 (depth = 3)
  gc_frame_newslot(call1687);
// call case 4: self request
  params[0] = call1687;
  partcv[0] = 1;
  Object call1688 = callmethodflags(self, "inner:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1681);
// compiled call node returning call1688 (depth = 2)
// Begin line 1009
  setline(1009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1689 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num1690 = alloc_Float64(0);
// compiled num node returning num1690 (depth = 3)
  gc_frame_newslot(num1690);
// call case 4: self request
  params[0] = num1690;
  partcv[0] = 1;
  Object call1691 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1689);
// compiled call node returning call1691 (depth = 2)
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_removeFirst1692(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeFirst");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1013
  setline(1013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1693 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num1694 = alloc_Float64(1);
// compiled num node returning num1694 (depth = 3)
  gc_frame_newslot(num1694);
// call case 4: self request
  params[0] = num1694;
  partcv[0] = 1;
  Object call1695 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1693);
// compiled call node returning call1695 (depth = 2)
  gc_frame_end(frame);
  return call1695;
}
Object meth_collectionsPrelude__apply_40_1_41_1726(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1727 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1729 = alloc_Float64(1);
// compiled num node returning num1729 (depth = 6)
  int op_slot_right_1728 = gc_frame_newslot(num1729);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1728 = gc_frame_newslot(*var_i);
  params[0] = num1729;
  partcv[0] = 1;
  Object diff1731 = callmethod(*var_i, "-(1)", 1, partcv, params);
// compiled op node returning diff1731 (depth = 5)
  gc_frame_newslot(diff1731);
// starting to compile call node (depth = 5)
  int callframe1732 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1733 = gc_frame_new();
// call case 4: self request
  Object call1734 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1733);
// compiled member node returning call1734 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1735 = callmethodflags(call1734, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1732);
// compiled call node returning call1735 (depth = 5)
  gc_frame_newslot(call1735);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1736 = gc_frame_new();
// call case 4: self request
  Object call1737 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1736);
// compiled member node returning call1737 (depth = 5)
  params[0] = diff1731;
  params[1] = call1735;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1738 = callmethodflags(call1737, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1727);
// compiled call node returning call1738 (depth = 4)
  gc_frame_end(frame);
  return call1738;
}
Object meth_collectionsPrelude_removeAt_40_1_41_1696(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAt(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAt(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAt(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAt(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_removed = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "removed");
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1697 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1699 = alloc_Float64(1);
// compiled num node returning num1699 (depth = 4)
  int op_slot_right_1698 = gc_frame_newslot(num1699);
// starting to compile member node (depth = 4)
  int callframe1701 = gc_frame_new();
// call case 4: self request
  Object call1702 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1701);
// compiled member node returning call1702 (depth = 4)
  int op_slot_left_1698 = gc_frame_newslot(call1702);
  params[0] = num1699;
  partcv[0] = 1;
  Object sum1703 = callmethod(call1702, "+(1)", 1, partcv, params);
// compiled op node returning sum1703 (depth = 3)
  gc_frame_newslot(sum1703);
// call case 4: self request
  params[0] = sum1703;
  partcv[0] = 1;
  Object call1704 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1697);
// compiled call node returning call1704 (depth = 2)
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1705 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1706 = callmethodflags(self, "boundsCheck(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1705);
// compiled call node returning call1706 (depth = 2)
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1707 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1709 = alloc_Float64(1);
// compiled num node returning num1709 (depth = 5)
  int op_slot_right_1708 = gc_frame_newslot(num1709);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  int op_slot_left_1708 = gc_frame_newslot(*var_n);
  params[0] = num1709;
  partcv[0] = 1;
  Object diff1711 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff1711 (depth = 4)
  gc_frame_newslot(diff1711);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1712 = gc_frame_new();
// call case 4: self request
  Object call1713 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1712);
// compiled member node returning call1713 (depth = 4)
  params[0] = diff1711;
  partcv[0] = 1;
  Object call1714 = callmethodflags(call1713, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1707);
// compiled call node returning call1714 (depth = 3)
  *var_removed = call1714;
  if (call1714 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1019
  setline(1019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1715 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1718 = alloc_Float64(1);
// compiled num node returning num1718 (depth = 5)
  int op_slot_right_1717 = gc_frame_newslot(num1718);
// starting to compile member node (depth = 5)
  int callframe1720 = gc_frame_new();
// call case 4: self request
  Object call1721 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1720);
// compiled member node returning call1721 (depth = 5)
  int op_slot_left_1717 = gc_frame_newslot(call1721);
  params[0] = num1718;
  partcv[0] = 1;
  Object diff1722 = callmethod(call1721, "-(1)", 1, partcv, params);
// compiled op node returning diff1722 (depth = 4)
  int op_slot_right_1716 = gc_frame_newslot(diff1722);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_1716 = gc_frame_newslot(*var_n);
  params[0] = diff1722;
  partcv[0] = 1;
  Object opresult1724 = callmethod(*var_n, "..(1)", 1, partcv, params);
// compiled op node returning opresult1724 (depth = 3)
  gc_frame_newslot(opresult1724);
// starting to compile block node (depth = 3)
  Object block1725 = alloc_Block(NULL, NULL, "collectionsPrelude", 1019);
  gc_frame_newslot(block1725);
// method "_apply(_)"
  block_savedest(block1725);
  Object closure1726 = createclosure(1, "_apply(1)");
  setclosureframe(closure1726, stackframe);
  addtoclosure(closure1726, selfslot);
  struct UserObject *uo1726 = (struct UserObject*)block1725;
  uo1726->data[0] = (Object)closure1726;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1726 = addmethod2pos(block1725, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1726, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1726[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1726->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1726);
  meth_meth_collectionsPrelude__apply_40_1_41_1726->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1726->definitionLine = 1991;
// compiled block node returning block1725 (depth = 3)
  gc_frame_newslot(block1725);
// call case 5: prelude request
  params[0] = opresult1724;
  params[1] = block1725;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1740 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1715);
// compiled call node returning call1740 (depth = 2)
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1741 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1743 = alloc_Float64(1);
// compiled num node returning num1743 (depth = 4)
  int op_slot_right_1742 = gc_frame_newslot(num1743);
// starting to compile member node (depth = 4)
  int callframe1745 = gc_frame_new();
// call case 4: self request
  Object call1746 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1745);
// compiled member node returning call1746 (depth = 4)
  int op_slot_left_1742 = gc_frame_newslot(call1746);
  params[0] = num1743;
  partcv[0] = 1;
  Object diff1747 = callmethod(call1746, "-(1)", 1, partcv, params);
// compiled op node returning diff1747 (depth = 3)
  gc_frame_newslot(diff1747);
// call case 4: self request
  params[0] = diff1747;
  partcv[0] = 1;
  Object call1748 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1741);
// compiled call node returning call1748 (depth = 2)
// Begin line 1023
  setline(1023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_removed (depth = 3)
  return *var_removed;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply1752(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elt = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1753 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1755 == NULL) {
    strlit1755 = alloc_String("");
    gc_root(strlit1755);
  }
// compiled string node returning strlit1755 (depth = 7)
  int op_slot_right_1754 = gc_frame_newslot(strlit1755);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_elt (depth = 8)
  int op_slot_right_1757 = gc_frame_newslot(*var_elt);
// starting to compile string node (depth = 8)
  if (strlit1759 == NULL) {
    strlit1759 = alloc_String("list does not contain ");
    gc_root(strlit1759);
  }
// compiled string node returning strlit1759 (depth = 8)
  int op_slot_left_1757 = gc_frame_newslot(strlit1759);
  params[0] = *var_elt;
  partcv[0] = 1;
  Object opresult1760 = callmethod(strlit1759, "++(1)", 1, partcv, params);
// compiled op node returning opresult1760 (depth = 7)
  int op_slot_left_1754 = gc_frame_newslot(opresult1760);
  params[0] = strlit1755;
  partcv[0] = 1;
  Object opresult1761 = callmethod(opresult1760, "++(1)", 1, partcv, params);
// compiled op node returning opresult1761 (depth = 6)
  gc_frame_newslot(opresult1761);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_NoSuchObject (depth = 6)
  params[0] = opresult1761;
  partcv[0] = 1;
  Object call1762 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1753);
// compiled call node returning call1762 (depth = 5)
  gc_frame_end(frame);
  return call1762;
}
Object meth_collectionsPrelude_remove_40_1_41_1749(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "remove(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for remove(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part remove(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1750 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elt (depth = 4)
  gc_frame_newslot(*var_elt);
// starting to compile block node (depth = 4)
  Object block1751 = alloc_Block(NULL, NULL, "collectionsPrelude", 1027);
  gc_frame_newslot(block1751);
// method "_apply"
  block_savedest(block1751);
  Object closure1752 = createclosure(3, "_apply");
  setclosureframe(closure1752, stackframe);
  addtoclosure(closure1752, var_elt);
  addtoclosure(closure1752, var_NoSuchObject);
  addtoclosure(closure1752, selfslot);
  struct UserObject *uo1752 = (struct UserObject*)block1751;
  uo1752->data[0] = (Object)closure1752;
  Method *meth_meth_collectionsPrelude__apply1752 = addmethod2pos(block1751, "_apply", &meth_collectionsPrelude__apply1752, 0);
  int argcv_meth_collectionsPrelude__apply1752[] = {0};
  meth_meth_collectionsPrelude__apply1752->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1752);
  meth_meth_collectionsPrelude__apply1752->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1752->definitionLine = 1991;
// compiled block node returning block1751 (depth = 4)
  gc_frame_newslot(block1751);
// call case 4: self request
  params[0] = *var_elt;
  params[1] = block1751;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1764 = callmethodflags(self, "indexOf(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1750);
// compiled call node returning call1764 (depth = 3)
  *var_ix = call1764;
  if (call1764 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1765 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ix (depth = 3)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call1766 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1765);
// compiled call node returning call1766 (depth = 2)
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply1770(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1771 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_action (depth = 6)
  Object call1772 = callmethodflags(*var_action, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe1771);
// compiled member node returning call1772 (depth = 5)
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  block_return(realself, self);
// compiled return node returning undefined (depth = 5)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1767(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "remove(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for remove(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part remove(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "ix");
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1768 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elt (depth = 4)
  gc_frame_newslot(*var_elt);
// starting to compile block node (depth = 4)
  Object block1769 = alloc_Block(NULL, NULL, "collectionsPrelude", 1035);
  gc_frame_newslot(block1769);
// method "_apply"
  block_savedest(block1769);
  Object closure1770 = createclosure(2, "_apply");
  setclosureframe(closure1770, stackframe);
  addtoclosure(closure1770, var_action);
  addtoclosure(closure1770, selfslot);
  struct UserObject *uo1770 = (struct UserObject*)block1769;
  uo1770->data[0] = (Object)closure1770;
  Method *meth_meth_collectionsPrelude__apply1770 = addmethod2pos(block1769, "_apply", &meth_collectionsPrelude__apply1770, 0);
  int argcv_meth_collectionsPrelude__apply1770[] = {0};
  meth_meth_collectionsPrelude__apply1770->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1770);
  meth_meth_collectionsPrelude__apply1770->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1770->definitionLine = 1991;
// compiled block node returning block1769 (depth = 4)
  gc_frame_newslot(block1769);
// call case 4: self request
  params[0] = *var_elt;
  params[1] = block1769;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1774 = callmethodflags(self, "indexOf(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1768);
// compiled call node returning call1774 (depth = 3)
  *var_ix = call1774;
  if (call1774 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1775 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ix (depth = 3)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call1776 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1775);
// compiled call node returning call1776 (depth = 2)
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply1780(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe1781 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1782 == NULL) {
    strlit1782 = alloc_String("list does not contain object");
    gc_root(strlit1782);
  }
// compiled string node returning strlit1782 (depth = 5)
  gc_frame_newslot(strlit1782);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_NoSuchObject (depth = 5)
  params[0] = strlit1782;
  partcv[0] = 1;
  Object call1783 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1781);
// compiled call node returning call1783 (depth = 4)
  gc_frame_end(frame);
  return call1783;
}
Object meth_collectionsPrelude_removeAll_40_1_41_1777(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_vs = &(stackframe->slots[0]);
  *var_vs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1778 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_vs (depth = 3)
  gc_frame_newslot(*var_vs);
// starting to compile block node (depth = 3)
  Object block1779 = alloc_Block(NULL, NULL, "collectionsPrelude", 1044);
  gc_frame_newslot(block1779);
// method "_apply"
  block_savedest(block1779);
  Object closure1780 = createclosure(2, "_apply");
  setclosureframe(closure1780, stackframe);
  addtoclosure(closure1780, var_NoSuchObject);
  addtoclosure(closure1780, selfslot);
  struct UserObject *uo1780 = (struct UserObject*)block1779;
  uo1780->data[0] = (Object)closure1780;
  Method *meth_meth_collectionsPrelude__apply1780 = addmethod2pos(block1779, "_apply", &meth_collectionsPrelude__apply1780, 0);
  int argcv_meth_collectionsPrelude__apply1780[] = {0};
  meth_meth_collectionsPrelude__apply1780->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1780);
  meth_meth_collectionsPrelude__apply1780->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1780->definitionLine = 1991;
// compiled block node returning block1779 (depth = 3)
  gc_frame_newslot(block1779);
// call case 4: self request
  params[0] = *var_vs;
  params[1] = block1779;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1785 = callmethodflags(self, "removeAll(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1778);
// compiled call node returning call1785 (depth = 2)
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply1792(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile num node (depth = 7)
  Object num1793 = alloc_Float64(0);
// compiled num node returning num1793 (depth = 7)
  gc_frame_end(frame);
  return num1793;
}
Object meth_collectionsPrelude__apply_40_1_41_1789(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1790 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// starting to compile block node (depth = 6)
  Object block1791 = alloc_Block(NULL, NULL, "collectionsPrelude", 1049);
  gc_frame_newslot(block1791);
// method "_apply"
  block_savedest(block1791);
  Object closure1792 = createclosure(1, "_apply");
  setclosureframe(closure1792, stackframe);
  addtoclosure(closure1792, selfslot);
  struct UserObject *uo1792 = (struct UserObject*)block1791;
  uo1792->data[0] = (Object)closure1792;
  Method *meth_meth_collectionsPrelude__apply1792 = addmethod2pos(block1791, "_apply", &meth_collectionsPrelude__apply1792, 0);
  int argcv_meth_collectionsPrelude__apply1792[] = {0};
  meth_meth_collectionsPrelude__apply1792->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1792);
  meth_meth_collectionsPrelude__apply1792->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1792->definitionLine = 1991;
// compiled block node returning block1791 (depth = 6)
  gc_frame_newslot(block1791);
// call case 4: self request
  params[0] = *var_each;
  params[1] = block1791;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1795 = callmethodflags(self, "indexOf(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1790);
// compiled call node returning call1795 (depth = 5)
  *var_ix = call1795;
  if (call1795 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1798 = alloc_Float64(0);
// compiled num node returning num1798 (depth = 6)
  int op_slot_right_1797 = gc_frame_newslot(num1798);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_left_1797 = gc_frame_newslot(*var_ix);
  params[0] = num1798;
  partcv[0] = 1;
  Object opresult1800 = callmethod(*var_ix, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1800 (depth = 5)
  Object if1796 = done;
  if (istrue(opresult1800)) {
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1801 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call1802 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1801);
// compiled call node returning call1802 (depth = 5)
    gc_frame_newslot(call1802);
    if1796 = call1802;
  } else {
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1803 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_action (depth = 6)
  Object call1804 = callmethodflags(*var_action, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe1803);
// compiled member node returning call1804 (depth = 5)
    gc_frame_newslot(call1804);
    if1796 = call1804;
  }
// compiled if node returning if1796 (depth = 4)
  gc_frame_end(frame);
  return if1796;
}
Object meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1786(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAll(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for removeAll(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_vs = &(stackframe->slots[0]);
  *var_vs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAll(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1787 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_vs (depth = 3)
  gc_frame_newslot(*var_vs);
// starting to compile block node (depth = 3)
  Object block1788 = alloc_Block(NULL, NULL, "collectionsPrelude", 1048);
  gc_frame_newslot(block1788);
// method "_apply(_)"
  block_savedest(block1788);
  Object closure1789 = createclosure(2, "_apply(1)");
  setclosureframe(closure1789, stackframe);
  addtoclosure(closure1789, var_action);
  addtoclosure(closure1789, selfslot);
  struct UserObject *uo1789 = (struct UserObject*)block1788;
  uo1789->data[0] = (Object)closure1789;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1789 = addmethod2pos(block1788, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1789, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1789[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1789->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1789);
  meth_meth_collectionsPrelude__apply_40_1_41_1789->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1789->definitionLine = 1991;
// compiled block node returning block1788 (depth = 3)
  gc_frame_newslot(block1788);
// call case 5: prelude request
  params[0] = *var_vs;
  params[1] = block1788;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1806 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1787);
// compiled call node returning call1806 (depth = 2)
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_pop1807(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe1808 = gc_frame_new();
// call case 4: self request
  Object call1809 = callmethodflags(self, "removeLast", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1808);
// compiled member node returning call1809 (depth = 2)
  gc_frame_end(frame);
  return call1809;
}
Object meth_collectionsPrelude__apply_40_1_41_1821(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe1822 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call1823 = callmethodflags(*var_result, "addFirst(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1822);
// compiled call node returning call1823 (depth = 4)
  gc_frame_end(frame);
  return call1823;
}
Object meth_collectionsPrelude_reversed1810(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1811 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1812 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1813 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1814 = gc_frame_new();
// call case 3: self.outer request
  Object call1815 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1814);
// compiled member node returning call1815 (depth = 6)
  Object call1816 = callmethodflags(call1815, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1813);
// compiled member node returning call1816 (depth = 5)
  Object call1817 = callmethodflags(call1816, "list", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1812);
// compiled member node returning call1817 (depth = 4)
  Object call1818 = callmethodflags(call1817, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe1811);
// compiled member node returning call1818 (depth = 3)
  *var_result = call1818;
  if (call1818 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1819 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1820 = alloc_Block(NULL, NULL, "collectionsPrelude", 1061);
  gc_frame_newslot(block1820);
// method "_apply(_)"
  block_savedest(block1820);
  Object closure1821 = createclosure(2, "_apply(1)");
  setclosureframe(closure1821, stackframe);
  addtoclosure(closure1821, var_result);
  addtoclosure(closure1821, selfslot);
  struct UserObject *uo1821 = (struct UserObject*)block1820;
  uo1821->data[0] = (Object)closure1821;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1821 = addmethod2pos(block1820, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1821, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1821[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1821->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1821);
  meth_meth_collectionsPrelude__apply_40_1_41_1821->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1821->definitionLine = 1991;
// compiled block node returning block1820 (depth = 3)
  gc_frame_newslot(block1820);
// call case 4: self request
  params[0] = block1820;
  partcv[0] = 1;
  Object call1825 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1819);
// compiled call node returning call1825 (depth = 2)
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude__apply1840(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_hiIx = getfromclosure(closure, 0);
  Object *var_loIx = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_hiIx (depth = 5)
  int op_slot_right_1841 = gc_frame_newslot(*var_hiIx);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_loIx (depth = 5)
  int op_slot_left_1841 = gc_frame_newslot(*var_loIx);
  params[0] = *var_hiIx;
  partcv[0] = 1;
  Object opresult1843 = callmethod(*var_loIx, "<(1)", 1, partcv, params);
// compiled op node returning opresult1843 (depth = 4)
  gc_frame_end(frame);
  return opresult1843;
}
Object meth_collectionsPrelude__apply1846(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_hiIx = getfromclosure(closure, 0);
  Object *var_loIx = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_hiVal = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "hiVal");
// Begin line 1069
  setline(1069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1847 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_hiIx (depth = 6)
  gc_frame_newslot(*var_hiIx);
// call case 4: self request
  params[0] = *var_hiIx;
  partcv[0] = 1;
  Object call1848 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1847);
// compiled call node returning call1848 (depth = 5)
  *var_hiVal = call1848;
  if (call1848 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1070
  setline(1070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1849 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_hiIx (depth = 5)
  gc_frame_newslot(*var_hiIx);
// starting to compile call node (depth = 5)
  int callframe1850 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_loIx (depth = 6)
  gc_frame_newslot(*var_loIx);
// call case 4: self request
  params[0] = *var_loIx;
  partcv[0] = 1;
  Object call1851 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1850);
// compiled call node returning call1851 (depth = 5)
  gc_frame_newslot(call1851);
// call case 4: self request
  params[0] = *var_hiIx;
  params[1] = call1851;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1852 = callmethodflags(self, "at(1)put(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1849);
// compiled call node returning call1852 (depth = 4)
// Begin line 1071
  setline(1071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1853 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_loIx (depth = 5)
  gc_frame_newslot(*var_loIx);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_hiVal (depth = 5)
  gc_frame_newslot(*var_hiVal);
// call case 4: self request
  params[0] = *var_loIx;
  params[1] = *var_hiVal;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1854 = callmethodflags(self, "at(1)put(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1853);
// compiled call node returning call1854 (depth = 4)
// Begin line 1072
  setline(1072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1856 = alloc_Float64(1);
// compiled num node returning num1856 (depth = 6)
  int op_slot_right_1855 = gc_frame_newslot(num1856);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_hiIx (depth = 6)
  int op_slot_left_1855 = gc_frame_newslot(*var_hiIx);
  params[0] = num1856;
  partcv[0] = 1;
  Object diff1858 = callmethod(*var_hiIx, "-(1)", 1, partcv, params);
// compiled op node returning diff1858 (depth = 5)
  *var_hiIx = diff1858;
  if (diff1858 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1861 = alloc_Float64(1);
// compiled num node returning num1861 (depth = 6)
  int op_slot_right_1860 = gc_frame_newslot(num1861);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_loIx (depth = 6)
  int op_slot_left_1860 = gc_frame_newslot(*var_loIx);
  params[0] = num1861;
  partcv[0] = 1;
  Object sum1863 = callmethod(*var_loIx, "+(1)", 1, partcv, params);
// compiled op node returning sum1863 (depth = 5)
  *var_loIx = sum1863;
  if (sum1863 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_reverse1826(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reverse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_hiIx = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "hiIx");
  Object *var_loIx = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "loIx");
// Begin line 1065
  setline(1065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1827 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1829 = alloc_Float64(1);
// compiled num node returning num1829 (depth = 4)
  int op_slot_right_1828 = gc_frame_newslot(num1829);
// starting to compile member node (depth = 4)
  int callframe1831 = gc_frame_new();
// call case 4: self request
  Object call1832 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1831);
// compiled member node returning call1832 (depth = 4)
  int op_slot_left_1828 = gc_frame_newslot(call1832);
  params[0] = num1829;
  partcv[0] = 1;
  Object sum1833 = callmethod(call1832, "+(1)", 1, partcv, params);
// compiled op node returning sum1833 (depth = 3)
  gc_frame_newslot(sum1833);
// call case 4: self request
  params[0] = sum1833;
  partcv[0] = 1;
  Object call1834 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1827);
// compiled call node returning call1834 (depth = 2)
// Begin line 1066
  setline(1066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1835 = gc_frame_new();
// call case 4: self request
  Object call1836 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1835);
// compiled member node returning call1836 (depth = 3)
  *var_hiIx = call1836;
  if (call1836 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1837 = alloc_Float64(1);
// compiled num node returning num1837 (depth = 3)
  *var_loIx = num1837;
  if (num1837 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1838 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1839 = alloc_Block(NULL, NULL, "collectionsPrelude", 1068);
  gc_frame_newslot(block1839);
// method "_apply"
  block_savedest(block1839);
  Object closure1840 = createclosure(3, "_apply");
  setclosureframe(closure1840, stackframe);
  addtoclosure(closure1840, var_hiIx);
  addtoclosure(closure1840, var_loIx);
  addtoclosure(closure1840, selfslot);
  struct UserObject *uo1840 = (struct UserObject*)block1839;
  uo1840->data[0] = (Object)closure1840;
  Method *meth_meth_collectionsPrelude__apply1840 = addmethod2pos(block1839, "_apply", &meth_collectionsPrelude__apply1840, 0);
  int argcv_meth_collectionsPrelude__apply1840[] = {0};
  meth_meth_collectionsPrelude__apply1840->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1840);
  meth_meth_collectionsPrelude__apply1840->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1840->definitionLine = 1991;
// compiled block node returning block1839 (depth = 3)
  gc_frame_newslot(block1839);
// starting to compile block node (depth = 3)
  Object block1845 = alloc_Block(NULL, NULL, "collectionsPrelude", 1068);
  gc_frame_newslot(block1845);
// method "_apply"
  block_savedest(block1845);
  Object closure1846 = createclosure(3, "_apply");
  setclosureframe(closure1846, stackframe);
  addtoclosure(closure1846, var_hiIx);
  addtoclosure(closure1846, var_loIx);
  addtoclosure(closure1846, selfslot);
  struct UserObject *uo1846 = (struct UserObject*)block1845;
  uo1846->data[0] = (Object)closure1846;
  Method *meth_meth_collectionsPrelude__apply1846 = addmethod2pos(block1845, "_apply", &meth_collectionsPrelude__apply1846, 0);
  int argcv_meth_collectionsPrelude__apply1846[] = {0};
  meth_meth_collectionsPrelude__apply1846->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1846);
  meth_meth_collectionsPrelude__apply1846->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1846->definitionLine = 1991;
// compiled block node returning block1845 (depth = 3)
  gc_frame_newslot(block1845);
// call case 5: prelude request
  params[0] = block1839;
  params[1] = block1845;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1866 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1838);
// compiled call node returning call1866 (depth = 2)
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__43__43__40_1_41_1867(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_l = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "l");
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1868 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1869 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1870 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1871 = gc_frame_new();
// call case 3: self.outer request
  Object call1872 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1871);
// compiled member node returning call1872 (depth = 6)
  Object call1873 = callmethodflags(call1872, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1870);
// compiled member node returning call1873 (depth = 5)
  Object call1874 = callmethodflags(call1873, "list", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1869);
// compiled member node returning call1874 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call1875 = callmethodflags(call1874, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1868);
// compiled call node returning call1875 (depth = 3)
  *var_l = call1875;
  if (call1875 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1876 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1877 = callmethodflags(*var_l, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1876);
// compiled call node returning call1877 (depth = 2)
  gc_frame_end(frame);
  return call1877;
}
Object meth_collectionsPrelude__apply_40_1_41_1892(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1894 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe1895 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1896 = gc_frame_new();
// call case 4: self request
  Object call1897 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1896);
// compiled member node returning call1897 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1898 = callmethodflags(call1897, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1895);
// compiled call node returning call1898 (depth = 7)
  Object call1899 = callmethodflags(call1898, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe1894);
// compiled member node returning call1899 (depth = 6)
  int op_slot_right_1893 = gc_frame_newslot(call1899);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1893 = gc_frame_newslot(*var_s);
  params[0] = call1899;
  partcv[0] = 1;
  Object opresult1901 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1901 (depth = 5)
  *var_s = opresult1901;
  if (opresult1901 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1906 = alloc_Float64(1);
// compiled num node returning num1906 (depth = 7)
  int op_slot_right_1905 = gc_frame_newslot(num1906);
// starting to compile member node (depth = 7)
  int callframe1908 = gc_frame_new();
// call case 4: self request
  Object call1909 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1908);
// compiled member node returning call1909 (depth = 7)
  int op_slot_left_1905 = gc_frame_newslot(call1909);
  params[0] = num1906;
  partcv[0] = 1;
  Object diff1910 = callmethod(call1909, "-(1)", 1, partcv, params);
// compiled op node returning diff1910 (depth = 6)
  int op_slot_right_1904 = gc_frame_newslot(diff1910);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1904 = gc_frame_newslot(*var_i);
  params[0] = diff1910;
  partcv[0] = 1;
  Object opresult1912 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult1912 (depth = 5)
  Object if1903 = done;
  if (istrue(opresult1912)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1914 == NULL) {
    strlit1914 = alloc_String(", ");
    gc_root(strlit1914);
  }
// compiled string node returning strlit1914 (depth = 7)
  int op_slot_right_1913 = gc_frame_newslot(strlit1914);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1913 = gc_frame_newslot(*var_s);
  params[0] = strlit1914;
  partcv[0] = 1;
  Object opresult1916 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1916 (depth = 6)
  *var_s = opresult1916;
  if (opresult1916 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1903 = done;
  } else {
  }
// compiled if node returning if1903 (depth = 4)
  gc_frame_end(frame);
  return if1903;
}
Object meth_collectionsPrelude_asString1878(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1879 == NULL) {
    strlit1879 = alloc_String("[");
    gc_root(strlit1879);
  }
// compiled string node returning strlit1879 (depth = 3)
  *var_s = strlit1879;
  if (strlit1879 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1083
  setline(1083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1880 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1883 = alloc_Float64(1);
// compiled num node returning num1883 (depth = 5)
  int op_slot_right_1882 = gc_frame_newslot(num1883);
// starting to compile member node (depth = 5)
  int callframe1885 = gc_frame_new();
// call case 4: self request
  Object call1886 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1885);
// compiled member node returning call1886 (depth = 5)
  int op_slot_left_1882 = gc_frame_newslot(call1886);
  params[0] = num1883;
  partcv[0] = 1;
  Object diff1887 = callmethod(call1886, "-(1)", 1, partcv, params);
// compiled op node returning diff1887 (depth = 4)
  int op_slot_right_1881 = gc_frame_newslot(diff1887);
// starting to compile num node (depth = 4)
  Object num1889 = alloc_Float64(0);
// compiled num node returning num1889 (depth = 4)
  int op_slot_left_1881 = gc_frame_newslot(num1889);
  params[0] = diff1887;
  partcv[0] = 1;
  Object opresult1890 = callmethod(num1889, "..(1)", 1, partcv, params);
// compiled op node returning opresult1890 (depth = 3)
  gc_frame_newslot(opresult1890);
// starting to compile block node (depth = 3)
  Object block1891 = alloc_Block(NULL, NULL, "collectionsPrelude", 1083);
  gc_frame_newslot(block1891);
// method "_apply(_)"
  block_savedest(block1891);
  Object closure1892 = createclosure(2, "_apply(1)");
  setclosureframe(closure1892, stackframe);
  addtoclosure(closure1892, var_s);
  addtoclosure(closure1892, selfslot);
  struct UserObject *uo1892 = (struct UserObject*)block1891;
  uo1892->data[0] = (Object)closure1892;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1892 = addmethod2pos(block1891, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1892, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1892[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1892->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1892);
  meth_meth_collectionsPrelude__apply_40_1_41_1892->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1892->definitionLine = 1991;
// compiled block node returning block1891 (depth = 3)
  gc_frame_newslot(block1891);
// call case 5: prelude request
  params[0] = opresult1890;
  params[1] = block1891;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1919 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1880);
// compiled call node returning call1919 (depth = 2)
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1921 == NULL) {
    strlit1921 = alloc_String("]");
    gc_root(strlit1921);
  }
// compiled string node returning strlit1921 (depth = 3)
  int op_slot_right_1920 = gc_frame_newslot(strlit1921);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_1920 = gc_frame_newslot(*var_s);
  params[0] = strlit1921;
  partcv[0] = 1;
  Object opresult1923 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1923 (depth = 2)
  gc_frame_end(frame);
  return opresult1923;
}
Object meth_collectionsPrelude__apply_40_1_41_1938(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1940 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe1941 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1942 = gc_frame_new();
// call case 4: self request
  Object call1943 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1942);
// compiled member node returning call1943 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1944 = callmethodflags(call1943, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1941);
// compiled call node returning call1944 (depth = 7)
  Object call1945 = callmethodflags(call1944, "asDebugString", 0, partcv, params, 0);
  gc_frame_end(callframe1940);
// compiled member node returning call1945 (depth = 6)
  int op_slot_right_1939 = gc_frame_newslot(call1945);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1939 = gc_frame_newslot(*var_s);
  params[0] = call1945;
  partcv[0] = 1;
  Object opresult1947 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1947 (depth = 5)
  *var_s = opresult1947;
  if (opresult1947 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1952 = alloc_Float64(1);
// compiled num node returning num1952 (depth = 7)
  int op_slot_right_1951 = gc_frame_newslot(num1952);
// starting to compile member node (depth = 7)
  int callframe1954 = gc_frame_new();
// call case 4: self request
  Object call1955 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1954);
// compiled member node returning call1955 (depth = 7)
  int op_slot_left_1951 = gc_frame_newslot(call1955);
  params[0] = num1952;
  partcv[0] = 1;
  Object diff1956 = callmethod(call1955, "-(1)", 1, partcv, params);
// compiled op node returning diff1956 (depth = 6)
  int op_slot_right_1950 = gc_frame_newslot(diff1956);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1950 = gc_frame_newslot(*var_i);
  params[0] = diff1956;
  partcv[0] = 1;
  Object opresult1958 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult1958 (depth = 5)
  Object if1949 = done;
  if (istrue(opresult1958)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1960 == NULL) {
    strlit1960 = alloc_String(", ");
    gc_root(strlit1960);
  }
// compiled string node returning strlit1960 (depth = 7)
  int op_slot_right_1959 = gc_frame_newslot(strlit1960);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1959 = gc_frame_newslot(*var_s);
  params[0] = strlit1960;
  partcv[0] = 1;
  Object opresult1962 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1962 (depth = 6)
  *var_s = opresult1962;
  if (opresult1962 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1949 = done;
  } else {
  }
// compiled if node returning if1949 (depth = 4)
  gc_frame_end(frame);
  return if1949;
}
Object meth_collectionsPrelude_asDebugString1924(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1925 == NULL) {
    strlit1925 = alloc_String("[");
    gc_root(strlit1925);
  }
// compiled string node returning strlit1925 (depth = 3)
  *var_s = strlit1925;
  if (strlit1925 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1926 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1929 = alloc_Float64(1);
// compiled num node returning num1929 (depth = 5)
  int op_slot_right_1928 = gc_frame_newslot(num1929);
// starting to compile member node (depth = 5)
  int callframe1931 = gc_frame_new();
// call case 4: self request
  Object call1932 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1931);
// compiled member node returning call1932 (depth = 5)
  int op_slot_left_1928 = gc_frame_newslot(call1932);
  params[0] = num1929;
  partcv[0] = 1;
  Object diff1933 = callmethod(call1932, "-(1)", 1, partcv, params);
// compiled op node returning diff1933 (depth = 4)
  int op_slot_right_1927 = gc_frame_newslot(diff1933);
// starting to compile num node (depth = 4)
  Object num1935 = alloc_Float64(0);
// compiled num node returning num1935 (depth = 4)
  int op_slot_left_1927 = gc_frame_newslot(num1935);
  params[0] = diff1933;
  partcv[0] = 1;
  Object opresult1936 = callmethod(num1935, "..(1)", 1, partcv, params);
// compiled op node returning opresult1936 (depth = 3)
  gc_frame_newslot(opresult1936);
// starting to compile block node (depth = 3)
  Object block1937 = alloc_Block(NULL, NULL, "collectionsPrelude", 1091);
  gc_frame_newslot(block1937);
// method "_apply(_)"
  block_savedest(block1937);
  Object closure1938 = createclosure(2, "_apply(1)");
  setclosureframe(closure1938, stackframe);
  addtoclosure(closure1938, var_s);
  addtoclosure(closure1938, selfslot);
  struct UserObject *uo1938 = (struct UserObject*)block1937;
  uo1938->data[0] = (Object)closure1938;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1938 = addmethod2pos(block1937, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1938, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1938[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1938->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1938);
  meth_meth_collectionsPrelude__apply_40_1_41_1938->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1938->definitionLine = 1991;
// compiled block node returning block1937 (depth = 3)
  gc_frame_newslot(block1937);
// call case 5: prelude request
  params[0] = opresult1936;
  params[1] = block1937;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1965 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1926);
// compiled call node returning call1965 (depth = 2)
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1967 == NULL) {
    strlit1967 = alloc_String("]");
    gc_root(strlit1967);
  }
// compiled string node returning strlit1967 (depth = 3)
  int op_slot_right_1966 = gc_frame_newslot(strlit1967);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_1966 = gc_frame_newslot(*var_s);
  params[0] = strlit1967;
  partcv[0] = 1;
  Object opresult1969 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1969 (depth = 2)
  gc_frame_end(frame);
  return opresult1969;
}
Object meth_collectionsPrelude__apply_40_1_41_1973(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_element = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_element (depth = 6)
  int op_slot_right_1975 = gc_frame_newslot(*var_element);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  int op_slot_left_1975 = gc_frame_newslot(*var_each);
  params[0] = *var_element;
  partcv[0] = 1;
  Object opresult1977 = callmethod(*var_each, "==(1)", 1, partcv, params);
// compiled op node returning opresult1977 (depth = 5)
  Object if1974 = done;
  if (istrue(opresult1977)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1978 = alloc_Boolean(1);
// compiled identifier node returning bool1978 (depth = 6)
  block_return(realself, bool1978);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if1974 = undefined;
  } else {
  }
// compiled if node returning if1974 (depth = 4)
  gc_frame_end(frame);
  return if1974;
}
Object meth_collectionsPrelude_contains_40_1_41_1970(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_element = &(stackframe->slots[0]);
  *var_element = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1971 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1972 = alloc_Block(NULL, NULL, "collectionsPrelude", 1098);
  gc_frame_newslot(block1972);
// method "_apply(_)"
  block_savedest(block1972);
  Object closure1973 = createclosure(2, "_apply(1)");
  setclosureframe(closure1973, stackframe);
  addtoclosure(closure1973, var_element);
  addtoclosure(closure1973, selfslot);
  struct UserObject *uo1973 = (struct UserObject*)block1972;
  uo1973->data[0] = (Object)closure1973;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1973 = addmethod2pos(block1972, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1973, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1973[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1973->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1973);
  meth_meth_collectionsPrelude__apply_40_1_41_1973->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1973->definitionLine = 1991;
// compiled block node returning block1972 (depth = 3)
  gc_frame_newslot(block1972);
// call case 4: self request
  params[0] = block1972;
  partcv[0] = 1;
  Object call1980 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1971);
// compiled call node returning call1980 (depth = 2)
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool1981 = alloc_Boolean(0);
// compiled identifier node returning bool1981 (depth = 3)
  return bool1981;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply1986(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1988 = gc_frame_new();
// call case 4: self request
  Object call1989 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1988);
// compiled member node returning call1989 (depth = 5)
  int op_slot_right_1987 = gc_frame_newslot(call1989);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_1987 = gc_frame_newslot(*var_i);
  params[0] = call1989;
  partcv[0] = 1;
  Object opresult1991 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult1991 (depth = 4)
  gc_frame_end(frame);
  return opresult1991;
}
Object meth_collectionsPrelude__apply1994(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1104
  setline(1104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1995 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe1996 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1997 = gc_frame_new();
// call case 4: self request
  Object call1998 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1997);
// compiled member node returning call1998 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1999 = callmethodflags(call1998, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1996);
// compiled call node returning call1999 (depth = 5)
  gc_frame_newslot(call1999);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = call1999;
  partcv[0] = 1;
  Object call2000 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1995);
// compiled call node returning call2000 (depth = 4)
// Begin line 1105
  setline(1105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2002 = alloc_Float64(1);
// compiled num node returning num2002 (depth = 6)
  int op_slot_right_2001 = gc_frame_newslot(num2002);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_2001 = gc_frame_newslot(*var_i);
  params[0] = num2002;
  partcv[0] = 1;
  Object sum2004 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum2004 (depth = 5)
  *var_i = sum2004;
  if (sum2004 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do_40_1_41_1982(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1983 = alloc_Float64(0);
// compiled num node returning num1983 (depth = 3)
  *var_i = num1983;
  if (num1983 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1103
  setline(1103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1984 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1985 = alloc_Block(NULL, NULL, "collectionsPrelude", 1103);
  gc_frame_newslot(block1985);
// method "_apply"
  block_savedest(block1985);
  Object closure1986 = createclosure(2, "_apply");
  setclosureframe(closure1986, stackframe);
  addtoclosure(closure1986, var_i);
  addtoclosure(closure1986, selfslot);
  struct UserObject *uo1986 = (struct UserObject*)block1985;
  uo1986->data[0] = (Object)closure1986;
  Method *meth_meth_collectionsPrelude__apply1986 = addmethod2pos(block1985, "_apply", &meth_collectionsPrelude__apply1986, 0);
  int argcv_meth_collectionsPrelude__apply1986[] = {0};
  meth_meth_collectionsPrelude__apply1986->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1986);
  meth_meth_collectionsPrelude__apply1986->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1986->definitionLine = 1991;
// compiled block node returning block1985 (depth = 3)
  gc_frame_newslot(block1985);
// starting to compile block node (depth = 3)
  Object block1993 = alloc_Block(NULL, NULL, "collectionsPrelude", 1103);
  gc_frame_newslot(block1993);
// method "_apply"
  block_savedest(block1993);
  Object closure1994 = createclosure(3, "_apply");
  setclosureframe(closure1994, stackframe);
  addtoclosure(closure1994, var_i);
  addtoclosure(closure1994, var_block1);
  addtoclosure(closure1994, selfslot);
  struct UserObject *uo1994 = (struct UserObject*)block1993;
  uo1994->data[0] = (Object)closure1994;
  Method *meth_meth_collectionsPrelude__apply1994 = addmethod2pos(block1993, "_apply", &meth_collectionsPrelude__apply1994, 0);
  int argcv_meth_collectionsPrelude__apply1994[] = {0};
  meth_meth_collectionsPrelude__apply1994->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1994);
  meth_meth_collectionsPrelude__apply1994->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1994->definitionLine = 1991;
// compiled block node returning block1993 (depth = 3)
  gc_frame_newslot(block1993);
// call case 5: prelude request
  params[0] = block1985;
  params[1] = block1993;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2007 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1984);
// compiled call node returning call2007 (depth = 2)
  gc_frame_end(frame);
  return call2007;
}
Object meth_collectionsPrelude__61__61__40_1_41_2008(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2009 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2010 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2011 = gc_frame_new();
// call case 3: self.outer request
  Object call2012 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2011);
// compiled member node returning call2012 (depth = 4)
  Object call2013 = callmethodflags(call2012, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2010);
// compiled member node returning call2013 (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2014 = callmethodflags(call2013, "isEqual(1)toIterable(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2009);
// compiled call node returning call2014 (depth = 2)
  gc_frame_end(frame);
  return call2014;
}
Object meth_collectionsPrelude_asDebugString2020(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1116
  setline(1116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2022 == NULL) {
    strlit2022 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit2022);
  }
// compiled string node returning strlit2022 (depth = 3)
  int op_slot_right_2021 = gc_frame_newslot(strlit2022);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2025 = gc_frame_new();
// call case 4: self request
  Object call2026 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2025);
// compiled member node returning call2026 (depth = 4)
  int op_slot_right_2024 = gc_frame_newslot(call2026);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2029 == NULL) {
    strlit2029 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit2029);
  }
// compiled string node returning strlit2029 (depth = 5)
  int op_slot_right_2028 = gc_frame_newslot(strlit2029);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2032 = gc_frame_new();
// call case 4: self request
  Object call2033 = callmethodflags(self, "asString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2032);
// compiled member node returning call2033 (depth = 6)
  int op_slot_right_2031 = gc_frame_newslot(call2033);
// starting to compile string node (depth = 6)
  if (strlit2035 == NULL) {
    strlit2035 = alloc_String("");
    gc_root(strlit2035);
  }
// compiled string node returning strlit2035 (depth = 6)
  int op_slot_left_2031 = gc_frame_newslot(strlit2035);
  params[0] = call2033;
  partcv[0] = 1;
  Object opresult2036 = callmethod(strlit2035, "++(1)", 1, partcv, params);
// compiled op node returning opresult2036 (depth = 5)
  int op_slot_left_2028 = gc_frame_newslot(opresult2036);
  params[0] = strlit2029;
  partcv[0] = 1;
  Object opresult2037 = callmethod(opresult2036, "++(1)", 1, partcv, params);
// compiled op node returning opresult2037 (depth = 4)
  int op_slot_left_2024 = gc_frame_newslot(opresult2037);
  params[0] = call2026;
  partcv[0] = 1;
  Object opresult2038 = callmethod(opresult2037, "++(1)", 1, partcv, params);
// compiled op node returning opresult2038 (depth = 3)
  int op_slot_left_2021 = gc_frame_newslot(opresult2038);
  params[0] = strlit2022;
  partcv[0] = 1;
  Object opresult2039 = callmethod(opresult2038, "++(1)", 1, partcv, params);
// compiled op node returning opresult2039 (depth = 2)
  gc_frame_end(frame);
  return opresult2039;
}
Object meth_collectionsPrelude_asString2040(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit2041 == NULL) {
    strlit2041 = alloc_String("aListIterator");
    gc_root(strlit2041);
  }
// compiled string node returning strlit2041 (depth = 2)
  gc_frame_end(frame);
  return strlit2041;
}
Object meth_collectionsPrelude_hasNext2042(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2044 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2045 = gc_frame_new();
// call case 3: self.outer request
  Object call2046 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2045);
// compiled member node returning call2046 (depth = 4)
  Object call2047 = callmethodflags(call2046, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2044);
// compiled member node returning call2047 (depth = 3)
  int op_slot_right_2043 = gc_frame_newslot(call2047);
// starting to compile member node (depth = 3)
  int callframe2049 = gc_frame_new();
// call case 4: self request
  Object call2050 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2049);
// compiled member node returning call2050 (depth = 3)
  int op_slot_left_2043 = gc_frame_newslot(call2050);
  params[0] = call2047;
  partcv[0] = 1;
  Object opresult2051 = callmethod(call2050, "≤(1)", 1, partcv, params);
// compiled op node returning opresult2051 (depth = 2)
  gc_frame_end(frame);
  return opresult2051;
}
Object meth_collectionsPrelude_next2052(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ret = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ret");
// Begin line 1120
  setline(1120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2055 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2056 = gc_frame_new();
// call case 3: self.outer request
  Object call2057 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2056);
// compiled member node returning call2057 (depth = 5)
  Object call2058 = callmethodflags(call2057, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2055);
// compiled member node returning call2058 (depth = 4)
  int op_slot_right_2054 = gc_frame_newslot(call2058);
// starting to compile member node (depth = 4)
  int callframe2060 = gc_frame_new();
// call case 4: self request
  Object call2061 = callmethodflags(self, "imods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2060);
// compiled member node returning call2061 (depth = 4)
  int op_slot_left_2054 = gc_frame_newslot(call2061);
  params[0] = call2058;
  partcv[0] = 1;
  Object opresult2062 = callmethod(call2061, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2062 (depth = 3)
  Object if2053 = done;
  if (istrue(opresult2062)) {
// Begin line 1121
  setline(1121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2063 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2064 = gc_frame_new();
// call case 4: self request
  Object call2065 = callmethodflags(self, "asDebugString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2064);
// compiled member node returning call2065 (depth = 4)
  gc_frame_newslot(call2065);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ConcurrentModification (depth = 4)
  params[0] = call2065;
  partcv[0] = 1;
  Object call2066 = callmethodflags(*var_ConcurrentModification, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2063);
// compiled call node returning call2066 (depth = 3)
    gc_frame_newslot(call2066);
    if2053 = call2066;
  } else {
  }
// compiled if node returning if2053 (depth = 2)
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2069 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2070 = gc_frame_new();
// call case 3: self.outer request
  Object call2071 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2070);
// compiled member node returning call2071 (depth = 5)
  Object call2072 = callmethodflags(call2071, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2069);
// compiled member node returning call2072 (depth = 4)
  int op_slot_right_2068 = gc_frame_newslot(call2072);
// starting to compile member node (depth = 4)
  int callframe2074 = gc_frame_new();
// call case 4: self request
  Object call2075 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2074);
// compiled member node returning call2075 (depth = 4)
  int op_slot_left_2068 = gc_frame_newslot(call2075);
  params[0] = call2072;
  partcv[0] = 1;
  Object opresult2076 = callmethod(call2075, ">(1)", 1, partcv, params);
// compiled op node returning opresult2076 (depth = 3)
  Object if2067 = done;
  if (istrue(opresult2076)) {
// starting to compile call node (depth = 3)
  int callframe2077 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit2078 == NULL) {
    strlit2078 = alloc_String("on list");
    gc_root(strlit2078);
  }
// compiled string node returning strlit2078 (depth = 4)
  gc_frame_newslot(strlit2078);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = strlit2078;
  partcv[0] = 1;
  Object call2079 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2077);
// compiled call node returning call2079 (depth = 3)
    gc_frame_newslot(call2079);
    if2067 = call2079;
  } else {
  }
// compiled if node returning if2067 (depth = 2)
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2080 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2081 = gc_frame_new();
// call case 4: self request
  Object call2082 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2081);
// compiled member node returning call2082 (depth = 4)
  gc_frame_newslot(call2082);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2083 = gc_frame_new();
// call case 3: self.outer request
  Object call2084 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2083);
// compiled member node returning call2084 (depth = 4)
  params[0] = call2082;
  partcv[0] = 1;
  Object call2085 = callmethodflags(call2084, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2080);
// compiled call node returning call2085 (depth = 3)
  *var_ret = call2085;
  if (call2085 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2086 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2088 = alloc_Float64(1);
// compiled num node returning num2088 (depth = 4)
  int op_slot_right_2087 = gc_frame_newslot(num2088);
// starting to compile member node (depth = 4)
  int callframe2090 = gc_frame_new();
// call case 4: self request
  Object call2091 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2090);
// compiled member node returning call2091 (depth = 4)
  int op_slot_left_2087 = gc_frame_newslot(call2091);
  params[0] = num2088;
  partcv[0] = 1;
  Object sum2092 = callmethod(call2091, "+(1)", 1, partcv, params);
// compiled op node returning sum2092 (depth = 3)
  gc_frame_newslot(sum2092);
// call case 4: self request
  params[0] = sum2092;
  partcv[0] = 1;
  Object call2093 = callmethodflags(self, "idx:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2086);
// compiled call node returning call2093 (depth = 2)
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_ret (depth = 2)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_collectionsPrelude_iterator2015(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2016 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2016 = alloc_userobj2(8,7, objclass2016);
  gc_frame_newslot(obj2016);
if (objclass2016 == NULL) {
  glfree(obj2016->class->name);
  obj2016->class->name = "list.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2016, self, 0);
  addmethodreal(obj2016,"outer", &reader_collectionsPrelude_outer_2017);
  Object oldself2016 = self;
  struct StackFrameObject *oldstackframe2016 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2016);
  gc_frame_newslot((Object)stackframe);
  self = obj2016;
  Object *oldselfslot2016 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2016 = (*(struct UserObject *)self).data[0], lowerouter2016 = thisouter2016;
  if (inheritingObject2016) {
    struct UserObject *inho2016 = (struct UserObject *)inheritingObject2016;
    while (inho2016->super != GraceDefaultObject) inho2016 = (struct UserObject *)inho2016->super;
    inho2016->super = obj2016;
    self = inheritingObject2016;
    *selfslot = self;
    lowerouter2016 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2016;
  }
if (objclass2016 == NULL) {
  Method *reader2018 = addmethodrealflags(obj2016, "imods", &reader_collectionsPrelude_imods_2018, MFLAG_CONFIDENTIAL);
  Method *writer2018 = addmethodrealflags(obj2016, "imods:=(1)", &writer_collectionsPrelude_imods_2018, MFLAG_CONFIDENTIAL);
  reader2018->definitionModule = modulename;
  writer2018->definitionModule = modulename;
  reader2018->definitionLine = 1114;
  writer2018->definitionLine = 1114;
}
obj2016->flags |= OFLAG_MUTABLE;
adddatum2(obj2016, alloc_Undefined(), 1);
if (objclass2016 == NULL) {
  Method *reader2019 = addmethodrealflags(obj2016, "idx", &reader_collectionsPrelude_idx_2019, MFLAG_CONFIDENTIAL);
  Method *writer2019 = addmethodrealflags(obj2016, "idx:=(1)", &writer_collectionsPrelude_idx_2019, MFLAG_CONFIDENTIAL);
  reader2019->definitionModule = modulename;
  writer2019->definitionModule = modulename;
  reader2019->definitionLine = 1115;
  writer2019->definitionLine = 1115;
}
obj2016->flags |= OFLAG_MUTABLE;
adddatum2(obj2016, alloc_Undefined(), 2);
// method "asDebugString"
  struct UserObject *uo2020 = (struct UserObject*)obj2016;
  uo2020->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString2020 = addmethod2pos(obj2016, "asDebugString", &meth_collectionsPrelude_asDebugString2020, 3);
  int argcv_meth_collectionsPrelude_asDebugString2020[] = {0};
  meth_meth_collectionsPrelude_asDebugString2020->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString2020);
  meth_meth_collectionsPrelude_asDebugString2020->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString2020->definitionLine = 1116;
// method "asString"
  struct UserObject *uo2040 = (struct UserObject*)obj2016;
  uo2040->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2040 = addmethod2pos(obj2016, "asString", &meth_collectionsPrelude_asString2040, 4);
  int argcv_meth_collectionsPrelude_asString2040[] = {0};
  meth_meth_collectionsPrelude_asString2040->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2040);
  meth_meth_collectionsPrelude_asString2040->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2040->definitionLine = 1117;
// method "hasNext"
  struct UserObject *uo2042 = (struct UserObject*)obj2016;
  uo2042->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext2042 = addmethod2pos(obj2016, "hasNext", &meth_collectionsPrelude_hasNext2042, 5);
  int argcv_meth_collectionsPrelude_hasNext2042[] = {0};
  meth_meth_collectionsPrelude_hasNext2042->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext2042);
  meth_meth_collectionsPrelude_hasNext2042->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext2042->definitionLine = 1118;
// method "next"
  block_savedest(obj2016);
  Object closure2052 = createclosure(2, "next");
  setclosureframe(closure2052, stackframe);
  addtoclosure(closure2052, var_ConcurrentModification);
  addtoclosure(closure2052, var_IteratorExhausted);
  struct UserObject *uo2052 = (struct UserObject*)obj2016;
  uo2052->data[6] = (Object)closure2052;
  Method *meth_meth_collectionsPrelude_next2052 = addmethod2pos(obj2016, "next", &meth_collectionsPrelude_next2052, 6);
  int argcv_meth_collectionsPrelude_next2052[] = {0};
  meth_meth_collectionsPrelude_next2052->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next2052);
  meth_meth_collectionsPrelude_next2052->definitionModule = modulename;
  meth_meth_collectionsPrelude_next2052->definitionLine = 1119;
  sourceObject = obj2016;
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe2094 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2095 = gc_frame_new();
// call case 3: self.outer request
  Object call2096 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2095);
// compiled member node returning call2096 (depth = 3)
  Object call2097 = callmethodflags(call2096, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2094);
// compiled member node returning call2097 (depth = 2)
  adddatum2(obj2016, call2097, 1);
  sourceObject = obj2016;
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2098 = alloc_Float64(1);
// compiled num node returning num2098 (depth = 2)
  adddatum2(obj2016, num2098, 2);
  sourceObject = obj2016;
  sourceObject = obj2016;
  sourceObject = obj2016;
  sourceObject = obj2016;
  objclass2016 = obj2016->class;
  objclass2016->definitionModule = modulename;
  objclass2016->definitionLine = 1113;
  (*(struct UserObject *)self).data[0] = lowerouter2016;
  self = oldself2016;
  selfslot = oldselfslot2016;
  stackframe = oldstackframe2016;
  gc_frame_end(frame);
  return obj2016;
}
Object meth_collectionsPrelude_iterator2015_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2016 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2016 = alloc_userobj2(8,7, objclass2016);
  gc_frame_newslot(obj2016);
if (objclass2016 == NULL) {
  glfree(obj2016->class->name);
  obj2016->class->name = "list.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2016, self, 0);
  addmethodreal(obj2016,"outer", &reader_collectionsPrelude_outer_2017);
  Object oldself2016 = self;
  struct StackFrameObject *oldstackframe2016 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2016);
  gc_frame_newslot((Object)stackframe);
  self = obj2016;
  Object *oldselfslot2016 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2016 = (*(struct UserObject *)self).data[0], lowerouter2016 = thisouter2016;
  if (inheritingObject2016) {
    struct UserObject *inho2016 = (struct UserObject *)inheritingObject2016;
    while (inho2016->super != GraceDefaultObject) inho2016 = (struct UserObject *)inho2016->super;
    inho2016->super = obj2016;
    self = inheritingObject2016;
    *selfslot = self;
    lowerouter2016 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2016;
  }
if (objclass2016 == NULL) {
  Method *reader2018 = addmethodrealflags(obj2016, "imods", &reader_collectionsPrelude_imods_2018, MFLAG_CONFIDENTIAL);
  Method *writer2018 = addmethodrealflags(obj2016, "imods:=(1)", &writer_collectionsPrelude_imods_2018, MFLAG_CONFIDENTIAL);
  reader2018->definitionModule = modulename;
  writer2018->definitionModule = modulename;
  reader2018->definitionLine = 1114;
  writer2018->definitionLine = 1114;
}
obj2016->flags |= OFLAG_MUTABLE;
adddatum2(obj2016, alloc_Undefined(), 1);
if (objclass2016 == NULL) {
  Method *reader2019 = addmethodrealflags(obj2016, "idx", &reader_collectionsPrelude_idx_2019, MFLAG_CONFIDENTIAL);
  Method *writer2019 = addmethodrealflags(obj2016, "idx:=(1)", &writer_collectionsPrelude_idx_2019, MFLAG_CONFIDENTIAL);
  reader2019->definitionModule = modulename;
  writer2019->definitionModule = modulename;
  reader2019->definitionLine = 1115;
  writer2019->definitionLine = 1115;
}
obj2016->flags |= OFLAG_MUTABLE;
adddatum2(obj2016, alloc_Undefined(), 2);
// method "asDebugString"
  struct UserObject *uo2020 = (struct UserObject*)obj2016;
  uo2020->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString2020 = addmethod2pos(obj2016, "asDebugString", &meth_collectionsPrelude_asDebugString2020, 3);
  int argcv_meth_collectionsPrelude_asDebugString2020[] = {0};
  meth_meth_collectionsPrelude_asDebugString2020->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString2020);
  meth_meth_collectionsPrelude_asDebugString2020->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString2020->definitionLine = 1116;
// method "asString"
  struct UserObject *uo2040 = (struct UserObject*)obj2016;
  uo2040->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2040 = addmethod2pos(obj2016, "asString", &meth_collectionsPrelude_asString2040, 4);
  int argcv_meth_collectionsPrelude_asString2040[] = {0};
  meth_meth_collectionsPrelude_asString2040->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2040);
  meth_meth_collectionsPrelude_asString2040->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2040->definitionLine = 1117;
// method "hasNext"
  struct UserObject *uo2042 = (struct UserObject*)obj2016;
  uo2042->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext2042 = addmethod2pos(obj2016, "hasNext", &meth_collectionsPrelude_hasNext2042, 5);
  int argcv_meth_collectionsPrelude_hasNext2042[] = {0};
  meth_meth_collectionsPrelude_hasNext2042->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext2042);
  meth_meth_collectionsPrelude_hasNext2042->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext2042->definitionLine = 1118;
// method "next"
  block_savedest(obj2016);
  Object closure2052 = createclosure(2, "next");
  setclosureframe(closure2052, stackframe);
  addtoclosure(closure2052, var_ConcurrentModification);
  addtoclosure(closure2052, var_IteratorExhausted);
  struct UserObject *uo2052 = (struct UserObject*)obj2016;
  uo2052->data[6] = (Object)closure2052;
  Method *meth_meth_collectionsPrelude_next2052 = addmethod2pos(obj2016, "next", &meth_collectionsPrelude_next2052, 6);
  int argcv_meth_collectionsPrelude_next2052[] = {0};
  meth_meth_collectionsPrelude_next2052->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next2052);
  meth_meth_collectionsPrelude_next2052->definitionModule = modulename;
  meth_meth_collectionsPrelude_next2052->definitionLine = 1119;
  sourceObject = obj2016;
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe2094 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2095 = gc_frame_new();
// call case 3: self.outer request
  Object call2096 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2095);
// compiled member node returning call2096 (depth = 3)
  Object call2097 = callmethodflags(call2096, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2094);
// compiled member node returning call2097 (depth = 2)
  adddatum2(obj2016, call2097, 1);
  sourceObject = obj2016;
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2098 = alloc_Float64(1);
// compiled num node returning num2098 (depth = 2)
  adddatum2(obj2016, num2098, 2);
  sourceObject = obj2016;
  sourceObject = obj2016;
  sourceObject = obj2016;
  sourceObject = obj2016;
  objclass2016 = obj2016->class;
  objclass2016->definitionModule = modulename;
  objclass2016->definitionLine = 1113;
  (*(struct UserObject *)self).data[0] = lowerouter2016;
  self = oldself2016;
  selfslot = oldselfslot2016;
  stackframe = oldstackframe2016;
  gc_frame_end(frame);
  return obj2016;
}
Object meth_collectionsPrelude_values2100(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_keys2101(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe2102 = gc_frame_new();
// call case 4: self request
  Object call2103 = callmethodflags(self, "indices", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2102);
// compiled member node returning call2103 (depth = 2)
  gc_frame_end(frame);
  return call2103;
}
Object meth_collectionsPrelude__apply_40_1_41_2121(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_newInner = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1139
  setline(1139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2122 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 5)
  int callframe2123 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2124 = gc_frame_new();
// call case 4: self request
  Object call2125 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2124);
// compiled member node returning call2125 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2126 = callmethodflags(call2125, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2123);
// compiled call node returning call2126 (depth = 5)
  gc_frame_newslot(call2126);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newInner (depth = 5)
  params[0] = *var_i;
  params[1] = call2126;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2127 = callmethodflags(*var_newInner, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2122);
// compiled call node returning call2127 (depth = 4)
  gc_frame_end(frame);
  return call2127;
}
Object meth_collectionsPrelude_expandTo_40_1_41_2104(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expandTo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expandTo(_)");
  Object params[2];
  int partcv[2];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for expandTo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_newSize = &(stackframe->slots[0]);
  *var_newSize = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part expandTo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newInner = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newInner");
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2105 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_newSize (depth = 4)
  gc_frame_newslot(*var_newSize);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2106 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  Object call2107 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe2106);
// compiled member node returning call2107 (depth = 4)
  params[0] = *var_newSize;
  partcv[0] = 1;
  Object call2108 = callmethodflags(call2107, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2105);
// compiled call node returning call2108 (depth = 3)
  *var_newInner = call2108;
  if (call2108 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1138
  setline(1138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2109 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2112 = alloc_Float64(1);
// compiled num node returning num2112 (depth = 5)
  int op_slot_right_2111 = gc_frame_newslot(num2112);
// starting to compile member node (depth = 5)
  int callframe2114 = gc_frame_new();
// call case 4: self request
  Object call2115 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2114);
// compiled member node returning call2115 (depth = 5)
  int op_slot_left_2111 = gc_frame_newslot(call2115);
  params[0] = num2112;
  partcv[0] = 1;
  Object diff2116 = callmethod(call2115, "-(1)", 1, partcv, params);
// compiled op node returning diff2116 (depth = 4)
  int op_slot_right_2110 = gc_frame_newslot(diff2116);
// starting to compile num node (depth = 4)
  Object num2118 = alloc_Float64(0);
// compiled num node returning num2118 (depth = 4)
  int op_slot_left_2110 = gc_frame_newslot(num2118);
  params[0] = diff2116;
  partcv[0] = 1;
  Object opresult2119 = callmethod(num2118, "..(1)", 1, partcv, params);
// compiled op node returning opresult2119 (depth = 3)
  gc_frame_newslot(opresult2119);
// starting to compile block node (depth = 3)
  Object block2120 = alloc_Block(NULL, NULL, "collectionsPrelude", 1138);
  gc_frame_newslot(block2120);
// method "_apply(_)"
  block_savedest(block2120);
  Object closure2121 = createclosure(2, "_apply(1)");
  setclosureframe(closure2121, stackframe);
  addtoclosure(closure2121, var_newInner);
  addtoclosure(closure2121, selfslot);
  struct UserObject *uo2121 = (struct UserObject*)block2120;
  uo2121->data[0] = (Object)closure2121;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2121 = addmethod2pos(block2120, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2121, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2121[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2121->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2121);
  meth_meth_collectionsPrelude__apply_40_1_41_2121->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2121->definitionLine = 1991;
// compiled block node returning block2120 (depth = 3)
  gc_frame_newslot(block2120);
// call case 5: prelude request
  params[0] = opresult2119;
  params[1] = block2120;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2129 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2109);
// compiled call node returning call2129 (depth = 2)
// Begin line 1141
  setline(1141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2130 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newInner (depth = 3)
  gc_frame_newslot(*var_newInner);
// call case 4: self request
  params[0] = *var_newInner;
  partcv[0] = 1;
  Object call2131 = callmethodflags(self, "inner:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2130);
// compiled call node returning call2131 (depth = 2)
  gc_frame_end(frame);
  return call2131;
}
Object meth_collectionsPrelude_sortBy_40_1_41_2132(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortBy(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1144
  setline(1144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2133 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2135 = alloc_Float64(1);
// compiled num node returning num2135 (depth = 4)
  int op_slot_right_2134 = gc_frame_newslot(num2135);
// starting to compile member node (depth = 4)
  int callframe2137 = gc_frame_new();
// call case 4: self request
  Object call2138 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2137);
// compiled member node returning call2138 (depth = 4)
  int op_slot_left_2134 = gc_frame_newslot(call2138);
  params[0] = num2135;
  partcv[0] = 1;
  Object sum2139 = callmethod(call2138, "+(1)", 1, partcv, params);
// compiled op node returning sum2139 (depth = 3)
  gc_frame_newslot(sum2139);
// call case 4: self request
  params[0] = sum2139;
  partcv[0] = 1;
  Object call2140 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2133);
// compiled call node returning call2140 (depth = 2)
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2141 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe2142 = gc_frame_new();
// call case 4: self request
  Object call2143 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2142);
// compiled member node returning call2143 (depth = 3)
  gc_frame_newslot(call2143);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sortBlock (depth = 3)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2144 = gc_frame_new();
// call case 4: self request
  Object call2145 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2144);
// compiled member node returning call2145 (depth = 3)
  params[0] = call2143;
  params[1] = *var_sortBlock;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2146 = callmethodflags(call2145, "sortInitial(1)by(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2141);
// compiled call node returning call2146 (depth = 2)
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_2_41_2150(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_r (depth = 6)
  int op_slot_right_2152 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_l (depth = 6)
  int op_slot_left_2152 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult2154 = callmethod(*var_l, "==(1)", 1, partcv, params);
// compiled op node returning opresult2154 (depth = 5)
  Object if2151 = done;
  if (istrue(opresult2154)) {
// starting to compile num node (depth = 5)
  Object num2155 = alloc_Float64(0);
// compiled num node returning num2155 (depth = 5)
    gc_frame_newslot(num2155);
    if2151 = num2155;
  } else {
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_r (depth = 7)
  int op_slot_right_2157 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  int op_slot_left_2157 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult2159 = callmethod(*var_l, "<(1)", 1, partcv, params);
// compiled op node returning opresult2159 (depth = 6)
  Object if2156 = done;
  if (istrue(opresult2159)) {
// starting to compile call node (depth = 6)
  int callframe2160 = gc_frame_new();
// call case 6: other requests
// starting to compile num node (depth = 7)
  Object num2161 = alloc_Float64(1);
// compiled num node returning num2161 (depth = 7)
  partcv[0] = 0;
  Object call2162 = callmethodflags(num2161, "prefix-", 1, partcv, params, 0);
  gc_frame_end(callframe2160);
// compiled call node returning call2162 (depth = 6)
    gc_frame_newslot(call2162);
    if2156 = call2162;
  } else {
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num2163 = alloc_Float64(1);
// compiled num node returning num2163 (depth = 6)
    gc_frame_newslot(num2163);
    if2156 = num2163;
  }
// compiled if node returning if2156 (depth = 5)
    gc_frame_newslot(if2156);
    if2151 = if2156;
  }
// compiled if node returning if2151 (depth = 4)
  gc_frame_end(frame);
  return if2151;
}
Object meth_collectionsPrelude_sort2147(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sort");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2148 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2149 = alloc_Block(NULL, NULL, "collectionsPrelude", 1149);
  gc_frame_newslot(block2149);
// method "_apply(_,_)"
  block_savedest(block2149);
  Object closure2150 = createclosure(1, "_apply(2)");
  setclosureframe(closure2150, stackframe);
  addtoclosure(closure2150, selfslot);
  struct UserObject *uo2150 = (struct UserObject*)block2149;
  uo2150->data[0] = (Object)closure2150;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_2150 = addmethod2pos(block2149, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_2150, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_2150[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_2150->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_2150);
  meth_meth_collectionsPrelude__apply_40_2_41_2150->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_2150->definitionLine = 1991;
// compiled block node returning block2149 (depth = 3)
  gc_frame_newslot(block2149);
// call case 4: self request
  params[0] = block2149;
  partcv[0] = 1;
  Object call2165 = callmethodflags(self, "sortBy(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2148);
// compiled call node returning call2165 (depth = 2)
  gc_frame_end(frame);
  return call2165;
}
Object meth_collectionsPrelude_sortedBy_40_1_41_2166(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2167 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sortBlock (depth = 3)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2168 = gc_frame_new();
// call case 4: self request
  Object call2169 = callmethodflags(self, "copy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2168);
// compiled member node returning call2169 (depth = 3)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call2170 = callmethodflags(call2169, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2167);
// compiled call node returning call2170 (depth = 2)
  gc_frame_end(frame);
  return call2170;
}
Object meth_collectionsPrelude_sorted2171(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe2172 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2173 = gc_frame_new();
// call case 4: self request
  Object call2174 = callmethodflags(self, "copy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2173);
// compiled member node returning call2174 (depth = 3)
  Object call2175 = callmethodflags(call2174, "sort", 0, partcv, params, 0);
  gc_frame_end(callframe2172);
// compiled member node returning call2175 (depth = 2)
  gc_frame_end(frame);
  return call2175;
}
Object meth_collectionsPrelude_copy2176(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2177 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2178 = gc_frame_new();
// call case 3: self.outer request
  Object call2179 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2178);
// compiled member node returning call2179 (depth = 3)
  params[0] = self;
  partcv[0] = 1;
  Object call2180 = callmethodflags(call2179, "withAll(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2177);
// compiled call node returning call2180 (depth = 2)
  gc_frame_end(frame);
  return call2180;
}
Object meth_collectionsPrelude__apply2193(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe2194 = gc_frame_new();
// starting to compile identifier node (depth = 7)
  Object bool2195 = alloc_Boolean(0);
// compiled identifier node returning bool2195 (depth = 7)
  gc_frame_newslot(bool2195);
// call case 4: self request
  params[0] = bool2195;
  partcv[0] = 1;
  Object call2196 = callmethodflags(self, "sizeCertain:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2194);
// compiled call node returning call2196 (depth = 6)
// starting to compile num node (depth = 6)
  Object num2197 = alloc_Float64(4);
// compiled num node returning num2197 (depth = 6)
  gc_frame_end(frame);
  return num2197;
}
Object meth_collectionsPrelude__apply_40_1_41_2214(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 907
  setline(907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2215 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2216 = gc_frame_new();
// call case 4: self request
  Object call2217 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2216);
// compiled member node returning call2217 (depth = 6)
  gc_frame_newslot(call2217);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2218 = gc_frame_new();
// call case 4: self request
  Object call2219 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2218);
// compiled member node returning call2219 (depth = 6)
  params[0] = call2217;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2220 = callmethodflags(call2219, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2215);
// compiled call node returning call2220 (depth = 5)
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2221 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2223 = alloc_Float64(1);
// compiled num node returning num2223 (depth = 7)
  int op_slot_right_2222 = gc_frame_newslot(num2223);
// starting to compile member node (depth = 7)
  int callframe2225 = gc_frame_new();
// call case 4: self request
  Object call2226 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2225);
// compiled member node returning call2226 (depth = 7)
  int op_slot_left_2222 = gc_frame_newslot(call2226);
  params[0] = num2223;
  partcv[0] = 1;
  Object sum2227 = callmethod(call2226, "+(1)", 1, partcv, params);
// compiled op node returning sum2227 (depth = 6)
  gc_frame_newslot(sum2227);
// call case 4: self request
  params[0] = sum2227;
  partcv[0] = 1;
  Object call2228 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2221);
// compiled call node returning call2228 (depth = 5)
  gc_frame_end(frame);
  return call2228;
}
Object meth_collectionsPrelude__apply_40_1_41_2260(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_newInner = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2261 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 9)
  int callframe2262 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2263 = gc_frame_new();
// call case 4: self request
  Object call2264 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2263);
// compiled member node returning call2264 (depth = 10)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2265 = callmethodflags(call2264, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2262);
// compiled call node returning call2265 (depth = 9)
  gc_frame_newslot(call2265);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newInner (depth = 9)
  params[0] = *var_i;
  params[1] = call2265;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2266 = callmethodflags(*var_newInner, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2261);
// compiled call node returning call2266 (depth = 8)
  gc_frame_end(frame);
  return call2266;
}
Object meth_collectionsPrelude__apply_40_1_41_2235(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_innerSize = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newInner = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newInner");
// Begin line 914
  setline(914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2238 = gc_frame_new();
// call case 4: self request
  Object call2239 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2238);
// compiled member node returning call2239 (depth = 7)
  int op_slot_right_2237 = gc_frame_newslot(call2239);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_innerSize (depth = 7)
  int op_slot_left_2237 = gc_frame_newslot(*var_innerSize);
  params[0] = call2239;
  partcv[0] = 1;
  Object opresult2241 = callmethod(*var_innerSize, "≤(1)", 1, partcv, params);
// compiled op node returning opresult2241 (depth = 6)
  Object if2236 = done;
  if (istrue(opresult2241)) {
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2242 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2244 = alloc_Float64(2);
// compiled num node returning num2244 (depth = 9)
  int op_slot_right_2243 = gc_frame_newslot(num2244);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_innerSize (depth = 9)
  int op_slot_left_2243 = gc_frame_newslot(*var_innerSize);
  params[0] = num2244;
  partcv[0] = 1;
  Object prod2246 = callmethod(*var_innerSize, "*(1)", 1, partcv, params);
// compiled op node returning prod2246 (depth = 8)
  gc_frame_newslot(prod2246);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2247 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var__prelude (depth = 9)
  Object call2248 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe2247);
// compiled member node returning call2248 (depth = 8)
  params[0] = prod2246;
  partcv[0] = 1;
  Object call2249 = callmethodflags(call2248, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2242);
// compiled call node returning call2249 (depth = 7)
  *var_newInner = call2249;
  if (call2249 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2250 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2253 = alloc_Float64(1);
// compiled num node returning num2253 (depth = 9)
  int op_slot_right_2252 = gc_frame_newslot(num2253);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_innerSize (depth = 9)
  int op_slot_left_2252 = gc_frame_newslot(*var_innerSize);
  params[0] = num2253;
  partcv[0] = 1;
  Object diff2255 = callmethod(*var_innerSize, "-(1)", 1, partcv, params);
// compiled op node returning diff2255 (depth = 8)
  int op_slot_right_2251 = gc_frame_newslot(diff2255);
// starting to compile num node (depth = 8)
  Object num2257 = alloc_Float64(0);
// compiled num node returning num2257 (depth = 8)
  int op_slot_left_2251 = gc_frame_newslot(num2257);
  params[0] = diff2255;
  partcv[0] = 1;
  Object opresult2258 = callmethod(num2257, "..(1)", 1, partcv, params);
// compiled op node returning opresult2258 (depth = 7)
  gc_frame_newslot(opresult2258);
// starting to compile block node (depth = 7)
  Object block2259 = alloc_Block(NULL, NULL, "collectionsPrelude", 916);
  gc_frame_newslot(block2259);
// method "_apply(_)"
  block_savedest(block2259);
  Object closure2260 = createclosure(2, "_apply(1)");
  setclosureframe(closure2260, stackframe);
  addtoclosure(closure2260, var_newInner);
  addtoclosure(closure2260, selfslot);
  struct UserObject *uo2260 = (struct UserObject*)block2259;
  uo2260->data[0] = (Object)closure2260;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2260 = addmethod2pos(block2259, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2260, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2260[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2260->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2260);
  meth_meth_collectionsPrelude__apply_40_1_41_2260->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2260->definitionLine = 1991;
// compiled block node returning block2259 (depth = 7)
  gc_frame_newslot(block2259);
// call case 5: prelude request
  params[0] = opresult2258;
  params[1] = block2259;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2268 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2250);
// compiled call node returning call2268 (depth = 6)
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2269 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newInner (depth = 7)
  gc_frame_newslot(*var_newInner);
// call case 4: self request
  params[0] = *var_newInner;
  partcv[0] = 1;
  Object call2270 = callmethodflags(self, "inner:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2269);
// compiled call node returning call2270 (depth = 6)
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2271 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2272 = gc_frame_new();
// call case 4: self request
  Object call2273 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2272);
// compiled member node returning call2273 (depth = 8)
  Object call2274 = callmethodflags(call2273, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2271);
// compiled member node returning call2274 (depth = 7)
  *var_innerSize = call2274;
  if (call2274 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2236 = done;
  } else {
  }
// compiled if node returning if2236 (depth = 5)
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2276 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2277 = gc_frame_new();
// call case 4: self request
  Object call2278 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2277);
// compiled member node returning call2278 (depth = 6)
  gc_frame_newslot(call2278);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2279 = gc_frame_new();
// call case 4: self request
  Object call2280 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2279);
// compiled member node returning call2280 (depth = 6)
  params[0] = call2278;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2281 = callmethodflags(call2280, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2276);
// compiled call node returning call2281 (depth = 5)
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2282 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2284 = alloc_Float64(1);
// compiled num node returning num2284 (depth = 7)
  int op_slot_right_2283 = gc_frame_newslot(num2284);
// starting to compile member node (depth = 7)
  int callframe2286 = gc_frame_new();
// call case 4: self request
  Object call2287 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2286);
// compiled member node returning call2287 (depth = 7)
  int op_slot_left_2283 = gc_frame_newslot(call2287);
  params[0] = num2284;
  partcv[0] = 1;
  Object sum2288 = callmethod(call2287, "+(1)", 1, partcv, params);
// compiled op node returning sum2288 (depth = 6)
  gc_frame_newslot(sum2288);
// call case 4: self request
  params[0] = sum2288;
  partcv[0] = 1;
  Object call2289 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2282);
// compiled call node returning call2289 (depth = 5)
  gc_frame_end(frame);
  return call2289;
}
Object meth_collectionsPrelude_withAll_40_1_41_714(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method withAll(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_done = getfromclosure(closure, 1);
  Object *var_ConcurrentModification = getfromclosure(closure, 2);
  Object *var_IteratorExhausted = getfromclosure(closure, 3);
  Object *var_indexable = getfromclosure(closure, 4);
  Object *var_BoundsError = getfromclosure(closure, 5);
  Object *var__prelude = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit717 == NULL) {
    strlit717 = alloc_String("js");
    gc_root(strlit717);
  }
// compiled string node returning strlit717 (depth = 4)
  int op_slot_right_716 = gc_frame_newslot(strlit717);
// starting to compile member node (depth = 4)
  int callframe719 = gc_frame_new();
// call case 5: prelude request
  Object call720 = callmethodflags(prelude, "engine", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe719);
// compiled member node returning call720 (depth = 4)
  int op_slot_left_716 = gc_frame_newslot(call720);
  params[0] = strlit717;
  partcv[0] = 1;
  Object opresult721 = callmethod(call720, "==(1)", 1, partcv, params);
// compiled op node returning opresult721 (depth = 3)
  Object if715 = done;
  if (istrue(opresult721)) {
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
// compiled call node returning done (depth = 4)
  Object if722 = done;
  if (istrue(done)) {
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject723 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj723 = alloc_userobj2(43,41, objclass723);
  gc_frame_newslot(obj723);
// OBJECT OUTER DEC outer
  adddatum2(obj723, self, 0);
  addmethodreal(obj723,"outer", &reader_collectionsPrelude_outer_724);
  Object oldself723 = self;
  struct StackFrameObject *oldstackframe723 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe723);
  gc_frame_newslot((Object)stackframe);
  self = obj723;
  Object *oldselfslot723 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter723 = (*(struct UserObject *)self).data[0], lowerouter723 = thisouter723;
  if (inheritingObject723) {
    struct UserObject *inho723 = (struct UserObject *)inheritingObject723;
    while (inho723->super != GraceDefaultObject) inho723 = (struct UserObject *)inho723->super;
    inho723->super = obj723;
    self = inheritingObject723;
    *selfslot = self;
    lowerouter723 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter723;
  }
if (objclass723 == NULL) {
  Method *reader725 = addmethodrealflags(obj723, "mods", &reader_collectionsPrelude_mods_725, 0);
  Method *writer725 = addmethodrealflags(obj723, "mods:=(1)", &writer_collectionsPrelude_mods_725, MFLAG_CONFIDENTIAL);
  reader725->definitionModule = modulename;
  writer725->definitionModule = modulename;
  reader725->definitionLine = 635;
  writer725->definitionLine = 635;
}
obj723->flags |= OFLAG_MUTABLE;
adddatum2(obj723, alloc_Undefined(), 1);
if (objclass723 == NULL) {
  Method *reader726 = addmethodrealflags(obj723, "sz", &reader_collectionsPrelude_sz_726, MFLAG_CONFIDENTIAL);
  Method *writer726 = addmethodrealflags(obj723, "sz:=(1)", &writer_collectionsPrelude_sz_726, MFLAG_CONFIDENTIAL);
  reader726->definitionModule = modulename;
  writer726->definitionModule = modulename;
  reader726->definitionLine = 636;
  writer726->definitionLine = 636;
}
obj723->flags |= OFLAG_MUTABLE;
adddatum2(obj723, alloc_Undefined(), 2);
if (objclass723 == NULL) {
  Method *reader727 = addmethodrealflags(obj723, "jsArray", &reader_collectionsPrelude_jsArray_727, MFLAG_CONFIDENTIAL);
  Method *writer727 = addmethodrealflags(obj723, "jsArray:=(1)", &writer_collectionsPrelude_jsArray_727, MFLAG_CONFIDENTIAL);
  reader727->definitionModule = modulename;
  writer727->definitionModule = modulename;
  reader727->definitionLine = 637;
  writer727->definitionLine = 637;
}
obj723->flags |= OFLAG_MUTABLE;
adddatum2(obj723, alloc_Undefined(), 3);
// method "size"
  struct UserObject *uo728 = (struct UserObject*)obj723;
  uo728->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size728 = addmethod2pos(obj723, "size", &meth_collectionsPrelude_size728, 4);
  int argcv_meth_collectionsPrelude_size728[] = {0};
  meth_meth_collectionsPrelude_size728->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size728);
  meth_meth_collectionsPrelude_size728->definitionModule = modulename;
  meth_meth_collectionsPrelude_size728->definitionLine = 642;
// method "at(_)"
  struct UserObject *uo731 = (struct UserObject*)obj723;
  uo731->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_731 = addmethod2pos(obj723, "at(1)", &meth_collectionsPrelude_at_40_1_41_731, 5);
  int argcv_meth_collectionsPrelude_at_40_1_41_731[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_731->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_731);
  meth_meth_collectionsPrelude_at_40_1_41_731->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_731->definitionLine = 647;
// method "at(_)put(_)"
  struct UserObject *uo732 = (struct UserObject*)obj723;
  uo732->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732 = addmethod2pos(obj723, "at(1)put(1)", &meth_collectionsPrelude_at_40_1_41_put_40_1_41_732, 6);
  int argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732[] = {1, 1};
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732);
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732->definitionLine = 657;
// method "add(_)"
  struct UserObject *uo741 = (struct UserObject*)obj723;
  uo741->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add_40_1_41_741 = addmethod2pos(obj723, "add(1)", &meth_collectionsPrelude_add_40_1_41_741, 7);
  int argcv_meth_collectionsPrelude_add_40_1_41_741[] = {1};
  meth_meth_collectionsPrelude_add_40_1_41_741->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add_40_1_41_741);
  meth_meth_collectionsPrelude_add_40_1_41_741->definitionModule = modulename;
  meth_meth_collectionsPrelude_add_40_1_41_741->definitionLine = 669;
// method "push(_)"
  struct UserObject *uo750 = (struct UserObject*)obj723;
  uo750->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_push_40_1_41_750 = addmethod2pos(obj723, "push(1)", &meth_collectionsPrelude_push_40_1_41_750, 8);
  int argcv_meth_collectionsPrelude_push_40_1_41_750[] = {1};
  meth_meth_collectionsPrelude_push_40_1_41_750->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_push_40_1_41_750);
  meth_meth_collectionsPrelude_push_40_1_41_750->definitionModule = modulename;
  meth_meth_collectionsPrelude_push_40_1_41_750->definitionLine = 675;
// method "removeLast"
  struct UserObject *uo759 = (struct UserObject*)obj723;
  uo759->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeLast759 = addmethod2pos(obj723, "removeLast", &meth_collectionsPrelude_removeLast759, 9);
  int argcv_meth_collectionsPrelude_removeLast759[] = {0};
  meth_meth_collectionsPrelude_removeLast759->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeLast759);
  meth_meth_collectionsPrelude_removeLast759->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeLast759->definitionLine = 681;
// method "clear"
  struct UserObject *uo768 = (struct UserObject*)obj723;
  uo768->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_clear768 = addmethod2pos(obj723, "clear", &meth_collectionsPrelude_clear768, 10);
  int argcv_meth_collectionsPrelude_clear768[] = {0};
  meth_meth_collectionsPrelude_clear768->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_clear768);
  meth_meth_collectionsPrelude_clear768->definitionModule = modulename;
  meth_meth_collectionsPrelude_clear768->definitionLine = 690;
// method "addAllFirst(_)"
  struct UserObject *uo777 = (struct UserObject*)obj723;
  uo777->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAllFirst_40_1_41_777 = addmethod2pos(obj723, "addAllFirst(1)", &meth_collectionsPrelude_addAllFirst_40_1_41_777, 11);
  int argcv_meth_collectionsPrelude_addAllFirst_40_1_41_777[] = {1};
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_777->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAllFirst_40_1_41_777);
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_777->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_777->definitionLine = 695;
// method "removeAt(_)"
  struct UserObject *uo807 = (struct UserObject*)obj723;
  uo807->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAt_40_1_41_807 = addmethod2pos(obj723, "removeAt(1)", &meth_collectionsPrelude_removeAt_40_1_41_807, 12);
  int argcv_meth_collectionsPrelude_removeAt_40_1_41_807[] = {1};
  meth_meth_collectionsPrelude_removeAt_40_1_41_807->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAt_40_1_41_807);
  meth_meth_collectionsPrelude_removeAt_40_1_41_807->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAt_40_1_41_807->definitionLine = 706;
// method "sortBy(_)"
  struct UserObject *uo818 = (struct UserObject*)obj723;
  uo818->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortBy_40_1_41_818 = addmethod2pos(obj723, "sortBy(1)", &meth_collectionsPrelude_sortBy_40_1_41_818, 13);
  int argcv_meth_collectionsPrelude_sortBy_40_1_41_818[] = {1};
  meth_meth_collectionsPrelude_sortBy_40_1_41_818->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortBy_40_1_41_818);
  meth_meth_collectionsPrelude_sortBy_40_1_41_818->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortBy_40_1_41_818->definitionLine = 713;
// method "addLast(_)"
  struct UserObject *uo827 = (struct UserObject*)obj723;
  uo827->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addLast_40_1_41_827 = addmethod2pos(obj723, "addLast(1)", &meth_collectionsPrelude_addLast_40_1_41_827, 14);
  int argcv_meth_collectionsPrelude_addLast_40_1_41_827[] = {1};
  meth_meth_collectionsPrelude_addLast_40_1_41_827->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addLast_40_1_41_827);
  meth_meth_collectionsPrelude_addLast_40_1_41_827->definitionModule = modulename;
  meth_meth_collectionsPrelude_addLast_40_1_41_827->definitionLine = 727;
// method "addAll(_)"
  struct UserObject *uo830 = (struct UserObject*)obj723;
  uo830->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll_40_1_41_830 = addmethod2pos(obj723, "addAll(1)", &meth_collectionsPrelude_addAll_40_1_41_830, 15);
  int argcv_meth_collectionsPrelude_addAll_40_1_41_830[] = {1};
  meth_meth_collectionsPrelude_addAll_40_1_41_830->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll_40_1_41_830);
  meth_meth_collectionsPrelude_addAll_40_1_41_830->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll_40_1_41_830->definitionLine = 728;
// method "addFirst(_)"
  struct UserObject *uo838 = (struct UserObject*)obj723;
  uo838->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addFirst_40_1_41_838 = addmethod2pos(obj723, "addFirst(1)", &meth_collectionsPrelude_addFirst_40_1_41_838, 16);
  int argcv_meth_collectionsPrelude_addFirst_40_1_41_838[] = {1};
  meth_meth_collectionsPrelude_addFirst_40_1_41_838->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addFirst_40_1_41_838);
  meth_meth_collectionsPrelude_addFirst_40_1_41_838->definitionModule = modulename;
  meth_meth_collectionsPrelude_addFirst_40_1_41_838->definitionLine = 733;
// method "removeFirst"
  struct UserObject *uo847 = (struct UserObject*)obj723;
  uo847->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeFirst847 = addmethod2pos(obj723, "removeFirst", &meth_collectionsPrelude_removeFirst847, 17);
  int argcv_meth_collectionsPrelude_removeFirst847[] = {0};
  meth_meth_collectionsPrelude_removeFirst847->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeFirst847);
  meth_meth_collectionsPrelude_removeFirst847->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeFirst847->definitionLine = 739;
// method "remove(_)"
  block_savedest(obj723);
  Object closure851 = createclosure(1, "remove(1)");
  setclosureframe(closure851, stackframe);
  addtoclosure(closure851, var_NoSuchObject);
  struct UserObject *uo851 = (struct UserObject*)obj723;
  uo851->data[18] = (Object)closure851;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_851 = addmethod2pos(obj723, "remove(1)", &meth_collectionsPrelude_remove_40_1_41_851, 18);
  int argcv_meth_collectionsPrelude_remove_40_1_41_851[] = {1};
  meth_meth_collectionsPrelude_remove_40_1_41_851->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove_40_1_41_851);
  meth_meth_collectionsPrelude_remove_40_1_41_851->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_851->definitionLine = 744;
// method "remove(_)ifAbsent(_)"
  struct UserObject *uo869 = (struct UserObject*)obj723;
  uo869->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_869 = addmethod2pos(obj723, "remove(1)ifAbsent(1)", &meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_869, 19);
  int argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_869[] = {1, 1};
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_869->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_869);
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_869->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_869->definitionLine = 753;
// method "removeAll(_)"
  block_savedest(obj723);
  Object closure879 = createclosure(1, "removeAll(1)");
  setclosureframe(closure879, stackframe);
  addtoclosure(closure879, var_NoSuchObject);
  struct UserObject *uo879 = (struct UserObject*)obj723;
  uo879->data[20] = (Object)closure879;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_879 = addmethod2pos(obj723, "removeAll(1)", &meth_collectionsPrelude_removeAll_40_1_41_879, 20);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_879[] = {1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_879->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll_40_1_41_879);
  meth_meth_collectionsPrelude_removeAll_40_1_41_879->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_879->definitionLine = 761;
// method "removeAll(_)ifAbsent(_)"
  struct UserObject *uo888 = (struct UserObject*)obj723;
  uo888->data[21] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_888 = addmethod2pos(obj723, "removeAll(1)ifAbsent(1)", &meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_888, 21);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_888[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_888->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_888);
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_888->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_888->definitionLine = 766;
// method "pop"
  struct UserObject *uo909 = (struct UserObject*)obj723;
  uo909->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_pop909 = addmethod2pos(obj723, "pop", &meth_collectionsPrelude_pop909, 22);
  int argcv_meth_collectionsPrelude_pop909[] = {0};
  meth_meth_collectionsPrelude_pop909->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_pop909);
  meth_meth_collectionsPrelude_pop909->definitionModule = modulename;
  meth_meth_collectionsPrelude_pop909->definitionLine = 778;
// method "reversed"
  struct UserObject *uo912 = (struct UserObject*)obj723;
  uo912->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed912 = addmethod2pos(obj723, "reversed", &meth_collectionsPrelude_reversed912, 23);
  int argcv_meth_collectionsPrelude_reversed912[] = {0};
  meth_meth_collectionsPrelude_reversed912->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed912);
  meth_meth_collectionsPrelude_reversed912->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed912->definitionLine = 780;
// method "reverse"
  struct UserObject *uo928 = (struct UserObject*)obj723;
  uo928->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reverse928 = addmethod2pos(obj723, "reverse", &meth_collectionsPrelude_reverse928, 24);
  int argcv_meth_collectionsPrelude_reverse928[] = {0};
  meth_meth_collectionsPrelude_reverse928->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reverse928);
  meth_meth_collectionsPrelude_reverse928->definitionModule = modulename;
  meth_meth_collectionsPrelude_reverse928->definitionLine = 785;
// method "++(_)"
  struct UserObject *uo969 = (struct UserObject*)obj723;
  uo969->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_969 = addmethod2pos(obj723, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_969, 25);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_969[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_969->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_969);
  meth_meth_collectionsPrelude__43__43__40_1_41_969->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_969->definitionLine = 799;
// method "asString"
  struct UserObject *uo980 = (struct UserObject*)obj723;
  uo980->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString980 = addmethod2pos(obj723, "asString", &meth_collectionsPrelude_asString980, 26);
  int argcv_meth_collectionsPrelude_asString980[] = {0};
  meth_meth_collectionsPrelude_asString980->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString980);
  meth_meth_collectionsPrelude_asString980->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString980->definitionLine = 805;
// method "asDebugString"
  struct UserObject *uo1014 = (struct UserObject*)obj723;
  uo1014->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1014 = addmethod2pos(obj723, "asDebugString", &meth_collectionsPrelude_asDebugString1014, 27);
  int argcv_meth_collectionsPrelude_asDebugString1014[] = {0};
  meth_meth_collectionsPrelude_asDebugString1014->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1014);
  meth_meth_collectionsPrelude_asDebugString1014->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1014->definitionLine = 815;
// method "extend(_)"
  block_savedest(obj723);
  Object closure1048 = createclosure(1, "extend(1)");
  setclosureframe(closure1048, stackframe);
  addtoclosure(closure1048, var_done);
  struct UserObject *uo1048 = (struct UserObject*)obj723;
  uo1048->data[28] = (Object)closure1048;
  Method *meth_meth_collectionsPrelude_extend_40_1_41_1048 = addmethod2pos(obj723, "extend(1)", &meth_collectionsPrelude_extend_40_1_41_1048, 28);
  int argcv_meth_collectionsPrelude_extend_40_1_41_1048[] = {1};
  meth_meth_collectionsPrelude_extend_40_1_41_1048->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_extend_40_1_41_1048);
  meth_meth_collectionsPrelude_extend_40_1_41_1048->definitionModule = modulename;
  meth_meth_collectionsPrelude_extend_40_1_41_1048->definitionLine = 825;
// method "contains(_)"
  struct UserObject *uo1051 = (struct UserObject*)obj723;
  uo1051->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_1051 = addmethod2pos(obj723, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_1051, 29);
  int argcv_meth_collectionsPrelude_contains_40_1_41_1051[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_1051->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_1051);
  meth_meth_collectionsPrelude_contains_40_1_41_1051->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_1051->definitionLine = 828;
// method "do(_)"
  struct UserObject *uo1063 = (struct UserObject*)obj723;
  uo1063->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_1063 = addmethod2pos(obj723, "do(1)", &meth_collectionsPrelude_do_40_1_41_1063, 30);
  int argcv_meth_collectionsPrelude_do_40_1_41_1063[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_1063->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_1063);
  meth_meth_collectionsPrelude_do_40_1_41_1063->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_1063->definitionLine = 833;
// method "==(_)"
  struct UserObject *uo1087 = (struct UserObject*)obj723;
  uo1087->data[31] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_1087 = addmethod2pos(obj723, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_1087, 31);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_1087[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_1087->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_1087);
  meth_meth_collectionsPrelude__61__61__40_1_41_1087->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_1087->definitionLine = 842;
// method "iterator"
  block_savedest(obj723);
  Object closure1094 = createclosure(2, "iterator");
  setclosureframe(closure1094, stackframe);
  addtoclosure(closure1094, var_ConcurrentModification);
  addtoclosure(closure1094, var_IteratorExhausted);
  struct UserObject *uo1094 = (struct UserObject*)obj723;
  uo1094->data[32] = (Object)closure1094;
  Method *meth_meth_collectionsPrelude_iterator1094 = addmethod2pos(obj723, "iterator", &meth_collectionsPrelude_iterator1094, 32);
  int argcv_meth_collectionsPrelude_iterator1094[] = {0};
  meth_meth_collectionsPrelude_iterator1094->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator1094);
  meth_meth_collectionsPrelude_iterator1094->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1094->definitionLine = 846;
  block_savedest(obj723);
  Object closure1178 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure1178, stackframe);
  addtoclosure(closure1178, var_ConcurrentModification);
  addtoclosure(closure1178, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator1094_object = addmethod2pos(obj723, "iterator$object(1)", &meth_collectionsPrelude_iterator1094_object, 32);
  meth_meth_collectionsPrelude_iterator1094_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1094_object->definitionLine = 846;
// method "values"
  struct UserObject *uo1179 = (struct UserObject*)obj723;
  uo1179->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values1179 = addmethod2pos(obj723, "values", &meth_collectionsPrelude_values1179, 33);
  int argcv_meth_collectionsPrelude_values1179[] = {0};
  meth_meth_collectionsPrelude_values1179->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values1179);
  meth_meth_collectionsPrelude_values1179->definitionModule = modulename;
  meth_meth_collectionsPrelude_values1179->definitionLine = 865;
// method "keys"
  struct UserObject *uo1180 = (struct UserObject*)obj723;
  uo1180->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys1180 = addmethod2pos(obj723, "keys", &meth_collectionsPrelude_keys1180, 34);
  int argcv_meth_collectionsPrelude_keys1180[] = {0};
  meth_meth_collectionsPrelude_keys1180->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys1180);
  meth_meth_collectionsPrelude_keys1180->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys1180->definitionLine = 869;
// method "sort"
  struct UserObject *uo1183 = (struct UserObject*)obj723;
  uo1183->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sort1183 = addmethod2pos(obj723, "sort", &meth_collectionsPrelude_sort1183, 35);
  int argcv_meth_collectionsPrelude_sort1183[] = {0};
  meth_meth_collectionsPrelude_sort1183->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sort1183);
  meth_meth_collectionsPrelude_sort1183->definitionModule = modulename;
  meth_meth_collectionsPrelude_sort1183->definitionLine = 873;
// method "sortedBy(_)"
  struct UserObject *uo1210 = (struct UserObject*)obj723;
  uo1210->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_1210 = addmethod2pos(obj723, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_1210, 36);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_1210[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_1210->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_1210);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_1210->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_1210->definitionLine = 881;
// method "sorted"
  struct UserObject *uo1215 = (struct UserObject*)obj723;
  uo1215->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted1215 = addmethod2pos(obj723, "sorted", &meth_collectionsPrelude_sorted1215, 37);
  int argcv_meth_collectionsPrelude_sorted1215[] = {0};
  meth_meth_collectionsPrelude_sorted1215->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted1215);
  meth_meth_collectionsPrelude_sorted1215->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted1215->definitionLine = 884;
// method "copy"
  struct UserObject *uo1220 = (struct UserObject*)obj723;
  uo1220->data[38] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy1220 = addmethod2pos(obj723, "copy", &meth_collectionsPrelude_copy1220, 38);
  int argcv_meth_collectionsPrelude_copy1220[] = {0};
  meth_meth_collectionsPrelude_copy1220->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy1220);
  meth_meth_collectionsPrelude_copy1220->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy1220->definitionLine = 887;
  sourceObject = obj723;
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1225 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_indexable (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1226 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1225);
// compiled call node returning call1226 (depth = 6)
  struct UserObject *obj723_uo = (struct UserObject *)obj723;
  obj723_uo->super = call1226;
  sourceObject = obj723;
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1227 = alloc_Float64(0);
// compiled num node returning num1227 (depth = 6)
  adddatum2(obj723, num1227, 1);
  sourceObject = obj723;
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1228 = alloc_Float64(0);
// compiled num node returning num1228 (depth = 6)
  adddatum2(obj723, num1228, 2);
  sourceObject = obj723;
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  adddatum2(obj723, done, 3);
  sourceObject = obj723;
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1229 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1230 = alloc_Block(NULL, NULL, "collectionsPrelude", 638);
  gc_frame_newslot(block1230);
// method "_apply(_)"
  block_savedest(block1230);
  Object closure1231 = createclosure(1, "_apply(1)");
  setclosureframe(closure1231, stackframe);
  addtoclosure(closure1231, selfslot);
  struct UserObject *uo1231 = (struct UserObject*)block1230;
  uo1231->data[0] = (Object)closure1231;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1231 = addmethod2pos(block1230, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1231, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1231[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1231->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1231);
  meth_meth_collectionsPrelude__apply_40_1_41_1231->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1231->definitionLine = 1991;
// compiled block node returning block1230 (depth = 7)
  gc_frame_newslot(block1230);
// call case 6: other requests
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  params[0] = block1230;
  partcv[0] = 1;
  Object call1233 = callmethodflags(*var_a, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1229);
// compiled call node returning call1233 (depth = 6)
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  objclass723 = obj723->class;
  objclass723->definitionModule = modulename;
  objclass723->definitionLine = 632;
  (*(struct UserObject *)self).data[0] = lowerouter723;
  self = oldself723;
  selfslot = oldselfslot723;
  stackframe = oldstackframe723;
// compiled object node returning obj723 (depth = 5)
  return obj723;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if722 = undefined;
  } else {
  }
// compiled if node returning if722 (depth = 3)
    gc_frame_newslot(if722);
    if715 = if722;
  } else {
  }
// compiled if node returning if715 (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1234 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1234 = alloc_userobj2(46,43, objclass1234);
  gc_frame_newslot(obj1234);
if (objclass1234 == NULL) {
  glfree(obj1234->class->name);
  obj1234->class->name = "list.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1234, self, 0);
  addmethodreal(obj1234,"outer", &reader_collectionsPrelude_outer_1235);
  Object oldself1234 = self;
  struct StackFrameObject *oldstackframe1234 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1234);
  gc_frame_newslot((Object)stackframe);
  self = obj1234;
  Object *oldselfslot1234 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1234 = (*(struct UserObject *)self).data[0], lowerouter1234 = thisouter1234;
  if (inheritingObject1234) {
    struct UserObject *inho1234 = (struct UserObject *)inheritingObject1234;
    while (inho1234->super != GraceDefaultObject) inho1234 = (struct UserObject *)inho1234->super;
    inho1234->super = obj1234;
    self = inheritingObject1234;
    *selfslot = self;
    lowerouter1234 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1234;
  }
if (objclass1234 == NULL) {
  Method *reader1236 = addmethodrealflags(obj1234, "mods", &reader_collectionsPrelude_mods_1236, 0);
  Method *writer1236 = addmethodrealflags(obj1234, "mods:=(1)", &writer_collectionsPrelude_mods_1236, MFLAG_CONFIDENTIAL);
  reader1236->definitionModule = modulename;
  writer1236->definitionModule = modulename;
  reader1236->definitionLine = 898;
  writer1236->definitionLine = 898;
}
obj1234->flags |= OFLAG_MUTABLE;
adddatum2(obj1234, alloc_Undefined(), 1);
if (objclass1234 == NULL) {
  Method *reader1237 = addmethodrealflags(obj1234, "sizeCertain", &reader_collectionsPrelude_sizeCertain_1237, MFLAG_CONFIDENTIAL);
  Method *writer1237 = addmethodrealflags(obj1234, "sizeCertain:=(1)", &writer_collectionsPrelude_sizeCertain_1237, MFLAG_CONFIDENTIAL);
  reader1237->definitionModule = modulename;
  writer1237->definitionModule = modulename;
  reader1237->definitionLine = 899;
  writer1237->definitionLine = 899;
}
obj1234->flags |= OFLAG_MUTABLE;
adddatum2(obj1234, alloc_Undefined(), 2);
if (objclass1234 == NULL) {
  Method *reader1238 = addmethodrealflags(obj1234, "initialSize",&reader_collectionsPrelude_initialSize_1238, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader1238->definitionModule = modulename;
  reader1238->definitionLine = 901;
}
adddatum2(obj1234, alloc_Undefined(), 3);
if (objclass1234 == NULL) {
  Method *reader1239 = addmethodrealflags(obj1234, "inner", &reader_collectionsPrelude_inner_1239, MFLAG_CONFIDENTIAL);
  Method *writer1239 = addmethodrealflags(obj1234, "inner:=(1)", &writer_collectionsPrelude_inner_1239, MFLAG_CONFIDENTIAL);
  reader1239->definitionModule = modulename;
  writer1239->definitionModule = modulename;
  reader1239->definitionLine = 902;
  writer1239->definitionLine = 902;
}
obj1234->flags |= OFLAG_MUTABLE;
adddatum2(obj1234, alloc_Undefined(), 4);
if (objclass1234 == NULL) {
  Method *reader1240 = addmethodrealflags(obj1234, "size", &reader_collectionsPrelude_size_1240, 0);
  Method *writer1240 = addmethodrealflags(obj1234, "size:=(1)", &writer_collectionsPrelude_size_1240, MFLAG_CONFIDENTIAL);
  reader1240->definitionModule = modulename;
  writer1240->definitionModule = modulename;
  reader1240->definitionLine = 903;
  writer1240->definitionLine = 903;
}
obj1234->flags |= OFLAG_MUTABLE;
adddatum2(obj1234, alloc_Undefined(), 5);
// method "boundsCheck(_)"
  block_savedest(obj1234);
  Object closure1241 = createclosure(1, "boundsCheck(1)");
  setclosureframe(closure1241, stackframe);
  addtoclosure(closure1241, var_BoundsError);
  struct UserObject *uo1241 = (struct UserObject*)obj1234;
  uo1241->data[6] = (Object)closure1241;
  Method *meth_meth_collectionsPrelude_boundsCheck_40_1_41_1241 = addmethod2pos(obj1234, "boundsCheck(1)", &meth_collectionsPrelude_boundsCheck_40_1_41_1241, 6);
  int argcv_meth_collectionsPrelude_boundsCheck_40_1_41_1241[] = {1};
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_1241->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_boundsCheck_40_1_41_1241);
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_1241->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_1241->definitionModule = modulename;
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_1241->definitionLine = 926;
// method "at(_)"
  struct UserObject *uo1278 = (struct UserObject*)obj1234;
  uo1278->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_1278 = addmethod2pos(obj1234, "at(1)", &meth_collectionsPrelude_at_40_1_41_1278, 7);
  int argcv_meth_collectionsPrelude_at_40_1_41_1278[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_1278->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_1278);
  meth_meth_collectionsPrelude_at_40_1_41_1278->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_1278->definitionLine = 931;
// method "at(_)put(_)"
  struct UserObject *uo1289 = (struct UserObject*)obj1234;
  uo1289->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1289 = addmethod2pos(obj1234, "at(1)put(1)", &meth_collectionsPrelude_at_40_1_41_put_40_1_41_1289, 8);
  int argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1289[] = {1, 1};
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1289->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1289);
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1289->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1289->definitionLine = 935;
// method "add(_)"
  struct UserObject *uo1320 = (struct UserObject*)obj1234;
  uo1320->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add_40_1_41_1320 = addmethod2pos(obj1234, "add(1)", &meth_collectionsPrelude_add_40_1_41_1320, 9);
  int argcv_meth_collectionsPrelude_add_40_1_41_1320[] = {1};
  meth_meth_collectionsPrelude_add_40_1_41_1320->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add_40_1_41_1320);
  meth_meth_collectionsPrelude_add_40_1_41_1320->definitionModule = modulename;
  meth_meth_collectionsPrelude_add_40_1_41_1320->definitionLine = 945;
// method "addAll(_)"
  struct UserObject *uo1363 = (struct UserObject*)obj1234;
  uo1363->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll_40_1_41_1363 = addmethod2pos(obj1234, "addAll(1)", &meth_collectionsPrelude_addAll_40_1_41_1363, 10);
  int argcv_meth_collectionsPrelude_addAll_40_1_41_1363[] = {1};
  meth_meth_collectionsPrelude_addAll_40_1_41_1363->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll_40_1_41_1363);
  meth_meth_collectionsPrelude_addAll_40_1_41_1363->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll_40_1_41_1363->definitionLine = 952;
// method "push(_)"
  struct UserObject *uo1427 = (struct UserObject*)obj1234;
  uo1427->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_push_40_1_41_1427 = addmethod2pos(obj1234, "push(1)", &meth_collectionsPrelude_push_40_1_41_1427, 11);
  int argcv_meth_collectionsPrelude_push_40_1_41_1427[] = {1};
  meth_meth_collectionsPrelude_push_40_1_41_1427->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_push_40_1_41_1427);
  meth_meth_collectionsPrelude_push_40_1_41_1427->definitionModule = modulename;
  meth_meth_collectionsPrelude_push_40_1_41_1427->definitionLine = 963;
// method "addLast(_)"
  struct UserObject *uo1470 = (struct UserObject*)obj1234;
  uo1470->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addLast_40_1_41_1470 = addmethod2pos(obj1234, "addLast(1)", &meth_collectionsPrelude_addLast_40_1_41_1470, 12);
  int argcv_meth_collectionsPrelude_addLast_40_1_41_1470[] = {1};
  meth_meth_collectionsPrelude_addLast_40_1_41_1470->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addLast_40_1_41_1470);
  meth_meth_collectionsPrelude_addLast_40_1_41_1470->definitionModule = modulename;
  meth_meth_collectionsPrelude_addLast_40_1_41_1470->definitionLine = 970;
// method "removeLast"
  struct UserObject *uo1473 = (struct UserObject*)obj1234;
  uo1473->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeLast1473 = addmethod2pos(obj1234, "removeLast", &meth_collectionsPrelude_removeLast1473, 13);
  int argcv_meth_collectionsPrelude_removeLast1473[] = {0};
  meth_meth_collectionsPrelude_removeLast1473->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeLast1473);
  meth_meth_collectionsPrelude_removeLast1473->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeLast1473->definitionLine = 971;
// method "addAllFirst(_)"
  struct UserObject *uo1500 = (struct UserObject*)obj1234;
  uo1500->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAllFirst_40_1_41_1500 = addmethod2pos(obj1234, "addAllFirst(1)", &meth_collectionsPrelude_addAllFirst_40_1_41_1500, 14);
  int argcv_meth_collectionsPrelude_addAllFirst_40_1_41_1500[] = {1};
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_1500->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAllFirst_40_1_41_1500);
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_1500->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_1500->definitionLine = 977;
// method "addFirst(_)"
  struct UserObject *uo1596 = (struct UserObject*)obj1234;
  uo1596->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addFirst_40_1_41_1596 = addmethod2pos(obj1234, "addFirst(1)", &meth_collectionsPrelude_addFirst_40_1_41_1596, 15);
  int argcv_meth_collectionsPrelude_addFirst_40_1_41_1596[] = {1};
  meth_meth_collectionsPrelude_addFirst_40_1_41_1596->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addFirst_40_1_41_1596);
  meth_meth_collectionsPrelude_addFirst_40_1_41_1596->definitionModule = modulename;
  meth_meth_collectionsPrelude_addFirst_40_1_41_1596->definitionLine = 994;
// method "clear"
  block_savedest(obj1234);
  Object closure1672 = createclosure(1, "clear");
  setclosureframe(closure1672, stackframe);
  addtoclosure(closure1672, var__prelude);
  struct UserObject *uo1672 = (struct UserObject*)obj1234;
  uo1672->data[16] = (Object)closure1672;
  Method *meth_meth_collectionsPrelude_clear1672 = addmethod2pos(obj1234, "clear", &meth_collectionsPrelude_clear1672, 16);
  int argcv_meth_collectionsPrelude_clear1672[] = {0};
  meth_meth_collectionsPrelude_clear1672->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_clear1672);
  meth_meth_collectionsPrelude_clear1672->definitionModule = modulename;
  meth_meth_collectionsPrelude_clear1672->definitionLine = 1006;
// method "removeFirst"
  struct UserObject *uo1692 = (struct UserObject*)obj1234;
  uo1692->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeFirst1692 = addmethod2pos(obj1234, "removeFirst", &meth_collectionsPrelude_removeFirst1692, 17);
  int argcv_meth_collectionsPrelude_removeFirst1692[] = {0};
  meth_meth_collectionsPrelude_removeFirst1692->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeFirst1692);
  meth_meth_collectionsPrelude_removeFirst1692->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeFirst1692->definitionLine = 1012;
// method "removeAt(_)"
  struct UserObject *uo1696 = (struct UserObject*)obj1234;
  uo1696->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAt_40_1_41_1696 = addmethod2pos(obj1234, "removeAt(1)", &meth_collectionsPrelude_removeAt_40_1_41_1696, 18);
  int argcv_meth_collectionsPrelude_removeAt_40_1_41_1696[] = {1};
  meth_meth_collectionsPrelude_removeAt_40_1_41_1696->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAt_40_1_41_1696);
  meth_meth_collectionsPrelude_removeAt_40_1_41_1696->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAt_40_1_41_1696->definitionLine = 1015;
// method "remove(_)"
  block_savedest(obj1234);
  Object closure1749 = createclosure(1, "remove(1)");
  setclosureframe(closure1749, stackframe);
  addtoclosure(closure1749, var_NoSuchObject);
  struct UserObject *uo1749 = (struct UserObject*)obj1234;
  uo1749->data[19] = (Object)closure1749;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_1749 = addmethod2pos(obj1234, "remove(1)", &meth_collectionsPrelude_remove_40_1_41_1749, 19);
  int argcv_meth_collectionsPrelude_remove_40_1_41_1749[] = {1};
  meth_meth_collectionsPrelude_remove_40_1_41_1749->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove_40_1_41_1749);
  meth_meth_collectionsPrelude_remove_40_1_41_1749->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_1749->definitionLine = 1026;
// method "remove(_)ifAbsent(_)"
  struct UserObject *uo1767 = (struct UserObject*)obj1234;
  uo1767->data[20] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1767 = addmethod2pos(obj1234, "remove(1)ifAbsent(1)", &meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1767, 20);
  int argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1767[] = {1, 1};
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1767->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1767);
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1767->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1767->definitionLine = 1034;
// method "removeAll(_)"
  block_savedest(obj1234);
  Object closure1777 = createclosure(1, "removeAll(1)");
  setclosureframe(closure1777, stackframe);
  addtoclosure(closure1777, var_NoSuchObject);
  struct UserObject *uo1777 = (struct UserObject*)obj1234;
  uo1777->data[21] = (Object)closure1777;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_1777 = addmethod2pos(obj1234, "removeAll(1)", &meth_collectionsPrelude_removeAll_40_1_41_1777, 21);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_1777[] = {1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_1777->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll_40_1_41_1777);
  meth_meth_collectionsPrelude_removeAll_40_1_41_1777->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_1777->definitionLine = 1043;
// method "removeAll(_)ifAbsent(_)"
  struct UserObject *uo1786 = (struct UserObject*)obj1234;
  uo1786->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1786 = addmethod2pos(obj1234, "removeAll(1)ifAbsent(1)", &meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1786, 22);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1786[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1786->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1786);
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1786->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1786->definitionLine = 1047;
// method "pop"
  struct UserObject *uo1807 = (struct UserObject*)obj1234;
  uo1807->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_pop1807 = addmethod2pos(obj1234, "pop", &meth_collectionsPrelude_pop1807, 23);
  int argcv_meth_collectionsPrelude_pop1807[] = {0};
  meth_meth_collectionsPrelude_pop1807->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_pop1807);
  meth_meth_collectionsPrelude_pop1807->definitionModule = modulename;
  meth_meth_collectionsPrelude_pop1807->definitionLine = 1058;
// method "reversed"
  struct UserObject *uo1810 = (struct UserObject*)obj1234;
  uo1810->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed1810 = addmethod2pos(obj1234, "reversed", &meth_collectionsPrelude_reversed1810, 24);
  int argcv_meth_collectionsPrelude_reversed1810[] = {0};
  meth_meth_collectionsPrelude_reversed1810->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed1810);
  meth_meth_collectionsPrelude_reversed1810->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed1810->definitionLine = 1059;
// method "reverse"
  struct UserObject *uo1826 = (struct UserObject*)obj1234;
  uo1826->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reverse1826 = addmethod2pos(obj1234, "reverse", &meth_collectionsPrelude_reverse1826, 25);
  int argcv_meth_collectionsPrelude_reverse1826[] = {0};
  meth_meth_collectionsPrelude_reverse1826->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reverse1826);
  meth_meth_collectionsPrelude_reverse1826->definitionModule = modulename;
  meth_meth_collectionsPrelude_reverse1826->definitionLine = 1064;
// method "++(_)"
  struct UserObject *uo1867 = (struct UserObject*)obj1234;
  uo1867->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_1867 = addmethod2pos(obj1234, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_1867, 26);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_1867[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_1867->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_1867);
  meth_meth_collectionsPrelude__43__43__40_1_41_1867->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_1867->definitionLine = 1077;
// method "asString"
  struct UserObject *uo1878 = (struct UserObject*)obj1234;
  uo1878->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString1878 = addmethod2pos(obj1234, "asString", &meth_collectionsPrelude_asString1878, 27);
  int argcv_meth_collectionsPrelude_asString1878[] = {0};
  meth_meth_collectionsPrelude_asString1878->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString1878);
  meth_meth_collectionsPrelude_asString1878->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString1878->definitionLine = 1081;
// method "asDebugString"
  struct UserObject *uo1924 = (struct UserObject*)obj1234;
  uo1924->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1924 = addmethod2pos(obj1234, "asDebugString", &meth_collectionsPrelude_asDebugString1924, 28);
  int argcv_meth_collectionsPrelude_asDebugString1924[] = {0};
  meth_meth_collectionsPrelude_asDebugString1924->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1924);
  meth_meth_collectionsPrelude_asDebugString1924->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1924->definitionLine = 1089;
// method "contains(_)"
  struct UserObject *uo1970 = (struct UserObject*)obj1234;
  uo1970->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_1970 = addmethod2pos(obj1234, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_1970, 29);
  int argcv_meth_collectionsPrelude_contains_40_1_41_1970[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_1970->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_1970);
  meth_meth_collectionsPrelude_contains_40_1_41_1970->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_1970->definitionLine = 1097;
// method "do(_)"
  struct UserObject *uo1982 = (struct UserObject*)obj1234;
  uo1982->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_1982 = addmethod2pos(obj1234, "do(1)", &meth_collectionsPrelude_do_40_1_41_1982, 30);
  int argcv_meth_collectionsPrelude_do_40_1_41_1982[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_1982->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_1982);
  meth_meth_collectionsPrelude_do_40_1_41_1982->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_1982->definitionLine = 1101;
// method "==(_)"
  struct UserObject *uo2008 = (struct UserObject*)obj1234;
  uo2008->data[31] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_2008 = addmethod2pos(obj1234, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_2008, 31);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_2008[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_2008->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_2008);
  meth_meth_collectionsPrelude__61__61__40_1_41_2008->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_2008->definitionLine = 1109;
// method "iterator"
  block_savedest(obj1234);
  Object closure2015 = createclosure(2, "iterator");
  setclosureframe(closure2015, stackframe);
  addtoclosure(closure2015, var_ConcurrentModification);
  addtoclosure(closure2015, var_IteratorExhausted);
  struct UserObject *uo2015 = (struct UserObject*)obj1234;
  uo2015->data[32] = (Object)closure2015;
  Method *meth_meth_collectionsPrelude_iterator2015 = addmethod2pos(obj1234, "iterator", &meth_collectionsPrelude_iterator2015, 32);
  int argcv_meth_collectionsPrelude_iterator2015[] = {0};
  meth_meth_collectionsPrelude_iterator2015->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator2015);
  meth_meth_collectionsPrelude_iterator2015->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2015->definitionLine = 1112;
  block_savedest(obj1234);
  Object closure2099 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure2099, stackframe);
  addtoclosure(closure2099, var_ConcurrentModification);
  addtoclosure(closure2099, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator2015_object = addmethod2pos(obj1234, "iterator$object(1)", &meth_collectionsPrelude_iterator2015_object, 32);
  meth_meth_collectionsPrelude_iterator2015_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2015_object->definitionLine = 1112;
// method "values"
  struct UserObject *uo2100 = (struct UserObject*)obj1234;
  uo2100->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values2100 = addmethod2pos(obj1234, "values", &meth_collectionsPrelude_values2100, 33);
  int argcv_meth_collectionsPrelude_values2100[] = {0};
  meth_meth_collectionsPrelude_values2100->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values2100);
  meth_meth_collectionsPrelude_values2100->definitionModule = modulename;
  meth_meth_collectionsPrelude_values2100->definitionLine = 1130;
// method "keys"
  struct UserObject *uo2101 = (struct UserObject*)obj1234;
  uo2101->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys2101 = addmethod2pos(obj1234, "keys", &meth_collectionsPrelude_keys2101, 34);
  int argcv_meth_collectionsPrelude_keys2101[] = {0};
  meth_meth_collectionsPrelude_keys2101->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys2101);
  meth_meth_collectionsPrelude_keys2101->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys2101->definitionLine = 1133;
// method "expandTo(_)"
  block_savedest(obj1234);
  Object closure2104 = createclosure(1, "expandTo(1)");
  setclosureframe(closure2104, stackframe);
  addtoclosure(closure2104, var__prelude);
  struct UserObject *uo2104 = (struct UserObject*)obj1234;
  uo2104->data[35] = (Object)closure2104;
  Method *meth_meth_collectionsPrelude_expandTo_40_1_41_2104 = addmethod2pos(obj1234, "expandTo(1)", &meth_collectionsPrelude_expandTo_40_1_41_2104, 35);
  int argcv_meth_collectionsPrelude_expandTo_40_1_41_2104[] = {1};
  meth_meth_collectionsPrelude_expandTo_40_1_41_2104->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expandTo_40_1_41_2104);
  meth_meth_collectionsPrelude_expandTo_40_1_41_2104->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expandTo_40_1_41_2104->definitionModule = modulename;
  meth_meth_collectionsPrelude_expandTo_40_1_41_2104->definitionLine = 1136;
// method "sortBy(_)"
  struct UserObject *uo2132 = (struct UserObject*)obj1234;
  uo2132->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortBy_40_1_41_2132 = addmethod2pos(obj1234, "sortBy(1)", &meth_collectionsPrelude_sortBy_40_1_41_2132, 36);
  int argcv_meth_collectionsPrelude_sortBy_40_1_41_2132[] = {1};
  meth_meth_collectionsPrelude_sortBy_40_1_41_2132->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortBy_40_1_41_2132);
  meth_meth_collectionsPrelude_sortBy_40_1_41_2132->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortBy_40_1_41_2132->definitionLine = 1143;
// method "sort"
  struct UserObject *uo2147 = (struct UserObject*)obj1234;
  uo2147->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sort2147 = addmethod2pos(obj1234, "sort", &meth_collectionsPrelude_sort2147, 37);
  int argcv_meth_collectionsPrelude_sort2147[] = {0};
  meth_meth_collectionsPrelude_sort2147->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sort2147);
  meth_meth_collectionsPrelude_sort2147->definitionModule = modulename;
  meth_meth_collectionsPrelude_sort2147->definitionLine = 1148;
// method "sortedBy(_)"
  struct UserObject *uo2166 = (struct UserObject*)obj1234;
  uo2166->data[38] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_2166 = addmethod2pos(obj1234, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_2166, 38);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_2166[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_2166->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_2166);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_2166->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_2166->definitionLine = 1155;
// method "sorted"
  struct UserObject *uo2171 = (struct UserObject*)obj1234;
  uo2171->data[39] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted2171 = addmethod2pos(obj1234, "sorted", &meth_collectionsPrelude_sorted2171, 39);
  int argcv_meth_collectionsPrelude_sorted2171[] = {0};
  meth_meth_collectionsPrelude_sorted2171->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted2171);
  meth_meth_collectionsPrelude_sorted2171->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted2171->definitionLine = 1158;
// method "copy"
  struct UserObject *uo2176 = (struct UserObject*)obj1234;
  uo2176->data[40] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy2176 = addmethod2pos(obj1234, "copy", &meth_collectionsPrelude_copy2176, 40);
  int argcv_meth_collectionsPrelude_copy2176[] = {0};
  meth_meth_collectionsPrelude_copy2176->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy2176);
  meth_meth_collectionsPrelude_copy2176->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy2176->definitionLine = 1161;
  sourceObject = obj1234;
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2181 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2182 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2181);
// compiled call node returning call2182 (depth = 2)
  struct UserObject *obj1234_uo = (struct UserObject *)obj1234;
  obj1234_uo->super = call2182;
  sourceObject = obj1234;
// Begin line 898
  setline(898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2183 = alloc_Float64(0);
// compiled num node returning num2183 (depth = 2)
  adddatum2(obj1234, num2183, 1);
  sourceObject = obj1234;
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool2184 = alloc_Boolean(1);
// compiled identifier node returning bool2184 (depth = 2)
  adddatum2(obj1234, bool2184, 2);
  sourceObject = obj1234;
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2186 = alloc_Float64(1);
// compiled num node returning num2186 (depth = 3)
  int op_slot_right_2185 = gc_frame_newslot(num2186);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2189 = alloc_Float64(2);
// compiled num node returning num2189 (depth = 4)
  int op_slot_right_2188 = gc_frame_newslot(num2189);
// starting to compile call node (depth = 4)
  int callframe2191 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2192 = alloc_Block(NULL, NULL, "collectionsPrelude", 901);
  gc_frame_newslot(block2192);
// method "_apply"
  block_savedest(block2192);
  Object closure2193 = createclosure(1, "_apply");
  setclosureframe(closure2193, stackframe);
  addtoclosure(closure2193, selfslot);
  struct UserObject *uo2193 = (struct UserObject*)block2192;
  uo2193->data[0] = (Object)closure2193;
  Method *meth_meth_collectionsPrelude__apply2193 = addmethod2pos(block2192, "_apply", &meth_collectionsPrelude__apply2193, 0);
  int argcv_meth_collectionsPrelude__apply2193[] = {0};
  meth_meth_collectionsPrelude__apply2193->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2193);
  meth_meth_collectionsPrelude__apply2193->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2193->definitionLine = 1991;
// compiled block node returning block2192 (depth = 5)
  gc_frame_newslot(block2192);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_a (depth = 5)
  params[0] = block2192;
  partcv[0] = 1;
  Object call2199 = callmethodflags(*var_a, "sizeIfUnknown(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2191);
// compiled call node returning call2199 (depth = 4)
  int op_slot_left_2188 = gc_frame_newslot(call2199);
  params[0] = num2189;
  partcv[0] = 1;
  Object prod2200 = callmethod(call2199, "*(1)", 1, partcv, params);
// compiled op node returning prod2200 (depth = 3)
  int op_slot_left_2185 = gc_frame_newslot(prod2200);
  params[0] = num2186;
  partcv[0] = 1;
  Object sum2201 = callmethod(prod2200, "+(1)", 1, partcv, params);
// compiled op node returning sum2201 (depth = 2)
  adddatum2(obj1234, sum2201, 3);
  sourceObject = obj1234;
// Begin line 902
  setline(902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2202 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe2203 = gc_frame_new();
// call case 4: self request
  Object call2204 = callmethodflags(self, "initialSize", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2203);
// compiled member node returning call2204 (depth = 3)
  gc_frame_newslot(call2204);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2205 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__prelude (depth = 4)
  Object call2206 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe2205);
// compiled member node returning call2206 (depth = 3)
  params[0] = call2204;
  partcv[0] = 1;
  Object call2207 = callmethodflags(call2206, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2202);
// compiled call node returning call2207 (depth = 2)
  adddatum2(obj1234, call2207, 4);
  sourceObject = obj1234;
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2208 = alloc_Float64(0);
// compiled num node returning num2208 (depth = 2)
  adddatum2(obj1234, num2208, 5);
  sourceObject = obj1234;
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2210 = gc_frame_new();
// call case 4: self request
  Object call2211 = callmethodflags(self, "sizeCertain", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2210);
// compiled member node returning call2211 (depth = 3)
  Object if2209 = done;
struct StackFrameObject *iftmpstackframe2209 = stackframe;
  if (istrue(call2211)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2209);
gc_frame_newslot((Object)stackframe);
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2212 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 4)
  Object block2213 = alloc_Block(NULL, NULL, "collectionsPrelude", 906);
  gc_frame_newslot(block2213);
// method "_apply(_)"
  block_savedest(block2213);
  Object closure2214 = createclosure(1, "_apply(1)");
  setclosureframe(closure2214, stackframe);
  addtoclosure(closure2214, selfslot);
  struct UserObject *uo2214 = (struct UserObject*)block2213;
  uo2214->data[0] = (Object)closure2214;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2214 = addmethod2pos(block2213, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2214, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2214[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2214->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2214);
  meth_meth_collectionsPrelude__apply_40_1_41_2214->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2214->definitionLine = 1991;
// compiled block node returning block2213 (depth = 4)
  gc_frame_newslot(block2213);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2213;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2230 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2212);
// compiled call node returning call2230 (depth = 3)
    gc_frame_newslot(call2230);
    if2209 = call2230;
  } else {
  stackframe = alloc_StackFrame(1, iftmpstackframe2209);
  gc_frame_newslot((Object)stackframe);
  Object *var_innerSize = &(stackframe->slots[0]);
  setframeelementname(stackframe, 0, "innerSize");
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2231 = gc_frame_new();
// call case 4: self request
  Object call2232 = callmethodflags(self, "initialSize", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2231);
// compiled member node returning call2232 (depth = 4)
  *var_innerSize = call2232;
  if (call2232 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2233 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 4)
  Object block2234 = alloc_Block(NULL, NULL, "collectionsPrelude", 913);
  gc_frame_newslot(block2234);
// method "_apply(_)"
  block_savedest(block2234);
  Object closure2235 = createclosure(3, "_apply(1)");
  setclosureframe(closure2235, stackframe);
  addtoclosure(closure2235, var_innerSize);
  addtoclosure(closure2235, var__prelude);
  addtoclosure(closure2235, selfslot);
  struct UserObject *uo2235 = (struct UserObject*)block2234;
  uo2235->data[0] = (Object)closure2235;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2235 = addmethod2pos(block2234, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2235, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2235[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2235->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2235);
  meth_meth_collectionsPrelude__apply_40_1_41_2235->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2235->definitionLine = 1991;
// compiled block node returning block2234 (depth = 4)
  gc_frame_newslot(block2234);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2234;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2291 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2233);
// compiled call node returning call2291 (depth = 3)
    gc_frame_newslot(call2291);
    if2209 = call2291;
  }
stackframe = iftmpstackframe2209;
// compiled if node returning if2209 (depth = 2)
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  objclass1234 = obj1234->class;
  objclass1234->definitionModule = modulename;
  objclass1234->definitionLine = 894;
  (*(struct UserObject *)self).data[0] = lowerouter1234;
  self = oldself1234;
  selfslot = oldselfslot1234;
  stackframe = oldstackframe1234;
  gc_frame_end(frame);
  return obj1234;
}
Object meth_collectionsPrelude_withAll_40_1_41_714_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method withAll(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_done = getfromclosure(closure, 1);
  Object *var_ConcurrentModification = getfromclosure(closure, 2);
  Object *var_IteratorExhausted = getfromclosure(closure, 3);
  Object *var_indexable = getfromclosure(closure, 4);
  Object *var_BoundsError = getfromclosure(closure, 5);
  Object *var__prelude = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit717 == NULL) {
    strlit717 = alloc_String("js");
    gc_root(strlit717);
  }
// compiled string node returning strlit717 (depth = 4)
  int op_slot_right_716 = gc_frame_newslot(strlit717);
// starting to compile member node (depth = 4)
  int callframe719 = gc_frame_new();
// call case 5: prelude request
  Object call720 = callmethodflags(prelude, "engine", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe719);
// compiled member node returning call720 (depth = 4)
  int op_slot_left_716 = gc_frame_newslot(call720);
  params[0] = strlit717;
  partcv[0] = 1;
  Object opresult721 = callmethod(call720, "==(1)", 1, partcv, params);
// compiled op node returning opresult721 (depth = 3)
  Object if715 = done;
  if (istrue(opresult721)) {
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
// compiled call node returning done (depth = 4)
  Object if722 = done;
  if (istrue(done)) {
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject723 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj723 = alloc_userobj2(43,41, objclass723);
  gc_frame_newslot(obj723);
// OBJECT OUTER DEC outer
  adddatum2(obj723, self, 0);
  addmethodreal(obj723,"outer", &reader_collectionsPrelude_outer_724);
  Object oldself723 = self;
  struct StackFrameObject *oldstackframe723 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe723);
  gc_frame_newslot((Object)stackframe);
  self = obj723;
  Object *oldselfslot723 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter723 = (*(struct UserObject *)self).data[0], lowerouter723 = thisouter723;
  if (inheritingObject723) {
    struct UserObject *inho723 = (struct UserObject *)inheritingObject723;
    while (inho723->super != GraceDefaultObject) inho723 = (struct UserObject *)inho723->super;
    inho723->super = obj723;
    self = inheritingObject723;
    *selfslot = self;
    lowerouter723 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter723;
  }
if (objclass723 == NULL) {
  Method *reader725 = addmethodrealflags(obj723, "mods", &reader_collectionsPrelude_mods_725, 0);
  Method *writer725 = addmethodrealflags(obj723, "mods:=(1)", &writer_collectionsPrelude_mods_725, MFLAG_CONFIDENTIAL);
  reader725->definitionModule = modulename;
  writer725->definitionModule = modulename;
  reader725->definitionLine = 635;
  writer725->definitionLine = 635;
}
obj723->flags |= OFLAG_MUTABLE;
adddatum2(obj723, alloc_Undefined(), 1);
if (objclass723 == NULL) {
  Method *reader726 = addmethodrealflags(obj723, "sz", &reader_collectionsPrelude_sz_726, MFLAG_CONFIDENTIAL);
  Method *writer726 = addmethodrealflags(obj723, "sz:=(1)", &writer_collectionsPrelude_sz_726, MFLAG_CONFIDENTIAL);
  reader726->definitionModule = modulename;
  writer726->definitionModule = modulename;
  reader726->definitionLine = 636;
  writer726->definitionLine = 636;
}
obj723->flags |= OFLAG_MUTABLE;
adddatum2(obj723, alloc_Undefined(), 2);
if (objclass723 == NULL) {
  Method *reader727 = addmethodrealflags(obj723, "jsArray", &reader_collectionsPrelude_jsArray_727, MFLAG_CONFIDENTIAL);
  Method *writer727 = addmethodrealflags(obj723, "jsArray:=(1)", &writer_collectionsPrelude_jsArray_727, MFLAG_CONFIDENTIAL);
  reader727->definitionModule = modulename;
  writer727->definitionModule = modulename;
  reader727->definitionLine = 637;
  writer727->definitionLine = 637;
}
obj723->flags |= OFLAG_MUTABLE;
adddatum2(obj723, alloc_Undefined(), 3);
// method "size"
  struct UserObject *uo728 = (struct UserObject*)obj723;
  uo728->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size728 = addmethod2pos(obj723, "size", &meth_collectionsPrelude_size728, 4);
  int argcv_meth_collectionsPrelude_size728[] = {0};
  meth_meth_collectionsPrelude_size728->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size728);
  meth_meth_collectionsPrelude_size728->definitionModule = modulename;
  meth_meth_collectionsPrelude_size728->definitionLine = 642;
// method "at(_)"
  struct UserObject *uo731 = (struct UserObject*)obj723;
  uo731->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_731 = addmethod2pos(obj723, "at(1)", &meth_collectionsPrelude_at_40_1_41_731, 5);
  int argcv_meth_collectionsPrelude_at_40_1_41_731[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_731->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_731);
  meth_meth_collectionsPrelude_at_40_1_41_731->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_731->definitionLine = 647;
// method "at(_)put(_)"
  struct UserObject *uo732 = (struct UserObject*)obj723;
  uo732->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732 = addmethod2pos(obj723, "at(1)put(1)", &meth_collectionsPrelude_at_40_1_41_put_40_1_41_732, 6);
  int argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732[] = {1, 1};
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732);
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732->definitionLine = 657;
// method "add(_)"
  struct UserObject *uo741 = (struct UserObject*)obj723;
  uo741->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add_40_1_41_741 = addmethod2pos(obj723, "add(1)", &meth_collectionsPrelude_add_40_1_41_741, 7);
  int argcv_meth_collectionsPrelude_add_40_1_41_741[] = {1};
  meth_meth_collectionsPrelude_add_40_1_41_741->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add_40_1_41_741);
  meth_meth_collectionsPrelude_add_40_1_41_741->definitionModule = modulename;
  meth_meth_collectionsPrelude_add_40_1_41_741->definitionLine = 669;
// method "push(_)"
  struct UserObject *uo750 = (struct UserObject*)obj723;
  uo750->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_push_40_1_41_750 = addmethod2pos(obj723, "push(1)", &meth_collectionsPrelude_push_40_1_41_750, 8);
  int argcv_meth_collectionsPrelude_push_40_1_41_750[] = {1};
  meth_meth_collectionsPrelude_push_40_1_41_750->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_push_40_1_41_750);
  meth_meth_collectionsPrelude_push_40_1_41_750->definitionModule = modulename;
  meth_meth_collectionsPrelude_push_40_1_41_750->definitionLine = 675;
// method "removeLast"
  struct UserObject *uo759 = (struct UserObject*)obj723;
  uo759->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeLast759 = addmethod2pos(obj723, "removeLast", &meth_collectionsPrelude_removeLast759, 9);
  int argcv_meth_collectionsPrelude_removeLast759[] = {0};
  meth_meth_collectionsPrelude_removeLast759->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeLast759);
  meth_meth_collectionsPrelude_removeLast759->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeLast759->definitionLine = 681;
// method "clear"
  struct UserObject *uo768 = (struct UserObject*)obj723;
  uo768->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_clear768 = addmethod2pos(obj723, "clear", &meth_collectionsPrelude_clear768, 10);
  int argcv_meth_collectionsPrelude_clear768[] = {0};
  meth_meth_collectionsPrelude_clear768->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_clear768);
  meth_meth_collectionsPrelude_clear768->definitionModule = modulename;
  meth_meth_collectionsPrelude_clear768->definitionLine = 690;
// method "addAllFirst(_)"
  struct UserObject *uo777 = (struct UserObject*)obj723;
  uo777->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAllFirst_40_1_41_777 = addmethod2pos(obj723, "addAllFirst(1)", &meth_collectionsPrelude_addAllFirst_40_1_41_777, 11);
  int argcv_meth_collectionsPrelude_addAllFirst_40_1_41_777[] = {1};
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_777->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAllFirst_40_1_41_777);
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_777->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_777->definitionLine = 695;
// method "removeAt(_)"
  struct UserObject *uo807 = (struct UserObject*)obj723;
  uo807->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAt_40_1_41_807 = addmethod2pos(obj723, "removeAt(1)", &meth_collectionsPrelude_removeAt_40_1_41_807, 12);
  int argcv_meth_collectionsPrelude_removeAt_40_1_41_807[] = {1};
  meth_meth_collectionsPrelude_removeAt_40_1_41_807->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAt_40_1_41_807);
  meth_meth_collectionsPrelude_removeAt_40_1_41_807->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAt_40_1_41_807->definitionLine = 706;
// method "sortBy(_)"
  struct UserObject *uo818 = (struct UserObject*)obj723;
  uo818->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortBy_40_1_41_818 = addmethod2pos(obj723, "sortBy(1)", &meth_collectionsPrelude_sortBy_40_1_41_818, 13);
  int argcv_meth_collectionsPrelude_sortBy_40_1_41_818[] = {1};
  meth_meth_collectionsPrelude_sortBy_40_1_41_818->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortBy_40_1_41_818);
  meth_meth_collectionsPrelude_sortBy_40_1_41_818->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortBy_40_1_41_818->definitionLine = 713;
// method "addLast(_)"
  struct UserObject *uo827 = (struct UserObject*)obj723;
  uo827->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addLast_40_1_41_827 = addmethod2pos(obj723, "addLast(1)", &meth_collectionsPrelude_addLast_40_1_41_827, 14);
  int argcv_meth_collectionsPrelude_addLast_40_1_41_827[] = {1};
  meth_meth_collectionsPrelude_addLast_40_1_41_827->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addLast_40_1_41_827);
  meth_meth_collectionsPrelude_addLast_40_1_41_827->definitionModule = modulename;
  meth_meth_collectionsPrelude_addLast_40_1_41_827->definitionLine = 727;
// method "addAll(_)"
  struct UserObject *uo830 = (struct UserObject*)obj723;
  uo830->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll_40_1_41_830 = addmethod2pos(obj723, "addAll(1)", &meth_collectionsPrelude_addAll_40_1_41_830, 15);
  int argcv_meth_collectionsPrelude_addAll_40_1_41_830[] = {1};
  meth_meth_collectionsPrelude_addAll_40_1_41_830->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll_40_1_41_830);
  meth_meth_collectionsPrelude_addAll_40_1_41_830->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll_40_1_41_830->definitionLine = 728;
// method "addFirst(_)"
  struct UserObject *uo838 = (struct UserObject*)obj723;
  uo838->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addFirst_40_1_41_838 = addmethod2pos(obj723, "addFirst(1)", &meth_collectionsPrelude_addFirst_40_1_41_838, 16);
  int argcv_meth_collectionsPrelude_addFirst_40_1_41_838[] = {1};
  meth_meth_collectionsPrelude_addFirst_40_1_41_838->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addFirst_40_1_41_838);
  meth_meth_collectionsPrelude_addFirst_40_1_41_838->definitionModule = modulename;
  meth_meth_collectionsPrelude_addFirst_40_1_41_838->definitionLine = 733;
// method "removeFirst"
  struct UserObject *uo847 = (struct UserObject*)obj723;
  uo847->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeFirst847 = addmethod2pos(obj723, "removeFirst", &meth_collectionsPrelude_removeFirst847, 17);
  int argcv_meth_collectionsPrelude_removeFirst847[] = {0};
  meth_meth_collectionsPrelude_removeFirst847->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeFirst847);
  meth_meth_collectionsPrelude_removeFirst847->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeFirst847->definitionLine = 739;
// method "remove(_)"
  block_savedest(obj723);
  Object closure851 = createclosure(1, "remove(1)");
  setclosureframe(closure851, stackframe);
  addtoclosure(closure851, var_NoSuchObject);
  struct UserObject *uo851 = (struct UserObject*)obj723;
  uo851->data[18] = (Object)closure851;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_851 = addmethod2pos(obj723, "remove(1)", &meth_collectionsPrelude_remove_40_1_41_851, 18);
  int argcv_meth_collectionsPrelude_remove_40_1_41_851[] = {1};
  meth_meth_collectionsPrelude_remove_40_1_41_851->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove_40_1_41_851);
  meth_meth_collectionsPrelude_remove_40_1_41_851->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_851->definitionLine = 744;
// method "remove(_)ifAbsent(_)"
  struct UserObject *uo869 = (struct UserObject*)obj723;
  uo869->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_869 = addmethod2pos(obj723, "remove(1)ifAbsent(1)", &meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_869, 19);
  int argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_869[] = {1, 1};
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_869->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_869);
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_869->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_869->definitionLine = 753;
// method "removeAll(_)"
  block_savedest(obj723);
  Object closure879 = createclosure(1, "removeAll(1)");
  setclosureframe(closure879, stackframe);
  addtoclosure(closure879, var_NoSuchObject);
  struct UserObject *uo879 = (struct UserObject*)obj723;
  uo879->data[20] = (Object)closure879;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_879 = addmethod2pos(obj723, "removeAll(1)", &meth_collectionsPrelude_removeAll_40_1_41_879, 20);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_879[] = {1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_879->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll_40_1_41_879);
  meth_meth_collectionsPrelude_removeAll_40_1_41_879->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_879->definitionLine = 761;
// method "removeAll(_)ifAbsent(_)"
  struct UserObject *uo888 = (struct UserObject*)obj723;
  uo888->data[21] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_888 = addmethod2pos(obj723, "removeAll(1)ifAbsent(1)", &meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_888, 21);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_888[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_888->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_888);
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_888->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_888->definitionLine = 766;
// method "pop"
  struct UserObject *uo909 = (struct UserObject*)obj723;
  uo909->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_pop909 = addmethod2pos(obj723, "pop", &meth_collectionsPrelude_pop909, 22);
  int argcv_meth_collectionsPrelude_pop909[] = {0};
  meth_meth_collectionsPrelude_pop909->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_pop909);
  meth_meth_collectionsPrelude_pop909->definitionModule = modulename;
  meth_meth_collectionsPrelude_pop909->definitionLine = 778;
// method "reversed"
  struct UserObject *uo912 = (struct UserObject*)obj723;
  uo912->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed912 = addmethod2pos(obj723, "reversed", &meth_collectionsPrelude_reversed912, 23);
  int argcv_meth_collectionsPrelude_reversed912[] = {0};
  meth_meth_collectionsPrelude_reversed912->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed912);
  meth_meth_collectionsPrelude_reversed912->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed912->definitionLine = 780;
// method "reverse"
  struct UserObject *uo928 = (struct UserObject*)obj723;
  uo928->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reverse928 = addmethod2pos(obj723, "reverse", &meth_collectionsPrelude_reverse928, 24);
  int argcv_meth_collectionsPrelude_reverse928[] = {0};
  meth_meth_collectionsPrelude_reverse928->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reverse928);
  meth_meth_collectionsPrelude_reverse928->definitionModule = modulename;
  meth_meth_collectionsPrelude_reverse928->definitionLine = 785;
// method "++(_)"
  struct UserObject *uo969 = (struct UserObject*)obj723;
  uo969->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_969 = addmethod2pos(obj723, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_969, 25);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_969[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_969->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_969);
  meth_meth_collectionsPrelude__43__43__40_1_41_969->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_969->definitionLine = 799;
// method "asString"
  struct UserObject *uo980 = (struct UserObject*)obj723;
  uo980->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString980 = addmethod2pos(obj723, "asString", &meth_collectionsPrelude_asString980, 26);
  int argcv_meth_collectionsPrelude_asString980[] = {0};
  meth_meth_collectionsPrelude_asString980->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString980);
  meth_meth_collectionsPrelude_asString980->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString980->definitionLine = 805;
// method "asDebugString"
  struct UserObject *uo1014 = (struct UserObject*)obj723;
  uo1014->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1014 = addmethod2pos(obj723, "asDebugString", &meth_collectionsPrelude_asDebugString1014, 27);
  int argcv_meth_collectionsPrelude_asDebugString1014[] = {0};
  meth_meth_collectionsPrelude_asDebugString1014->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1014);
  meth_meth_collectionsPrelude_asDebugString1014->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1014->definitionLine = 815;
// method "extend(_)"
  block_savedest(obj723);
  Object closure1048 = createclosure(1, "extend(1)");
  setclosureframe(closure1048, stackframe);
  addtoclosure(closure1048, var_done);
  struct UserObject *uo1048 = (struct UserObject*)obj723;
  uo1048->data[28] = (Object)closure1048;
  Method *meth_meth_collectionsPrelude_extend_40_1_41_1048 = addmethod2pos(obj723, "extend(1)", &meth_collectionsPrelude_extend_40_1_41_1048, 28);
  int argcv_meth_collectionsPrelude_extend_40_1_41_1048[] = {1};
  meth_meth_collectionsPrelude_extend_40_1_41_1048->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_extend_40_1_41_1048);
  meth_meth_collectionsPrelude_extend_40_1_41_1048->definitionModule = modulename;
  meth_meth_collectionsPrelude_extend_40_1_41_1048->definitionLine = 825;
// method "contains(_)"
  struct UserObject *uo1051 = (struct UserObject*)obj723;
  uo1051->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_1051 = addmethod2pos(obj723, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_1051, 29);
  int argcv_meth_collectionsPrelude_contains_40_1_41_1051[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_1051->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_1051);
  meth_meth_collectionsPrelude_contains_40_1_41_1051->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_1051->definitionLine = 828;
// method "do(_)"
  struct UserObject *uo1063 = (struct UserObject*)obj723;
  uo1063->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_1063 = addmethod2pos(obj723, "do(1)", &meth_collectionsPrelude_do_40_1_41_1063, 30);
  int argcv_meth_collectionsPrelude_do_40_1_41_1063[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_1063->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_1063);
  meth_meth_collectionsPrelude_do_40_1_41_1063->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_1063->definitionLine = 833;
// method "==(_)"
  struct UserObject *uo1087 = (struct UserObject*)obj723;
  uo1087->data[31] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_1087 = addmethod2pos(obj723, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_1087, 31);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_1087[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_1087->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_1087);
  meth_meth_collectionsPrelude__61__61__40_1_41_1087->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_1087->definitionLine = 842;
// method "iterator"
  block_savedest(obj723);
  Object closure1094 = createclosure(2, "iterator");
  setclosureframe(closure1094, stackframe);
  addtoclosure(closure1094, var_ConcurrentModification);
  addtoclosure(closure1094, var_IteratorExhausted);
  struct UserObject *uo1094 = (struct UserObject*)obj723;
  uo1094->data[32] = (Object)closure1094;
  Method *meth_meth_collectionsPrelude_iterator1094 = addmethod2pos(obj723, "iterator", &meth_collectionsPrelude_iterator1094, 32);
  int argcv_meth_collectionsPrelude_iterator1094[] = {0};
  meth_meth_collectionsPrelude_iterator1094->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator1094);
  meth_meth_collectionsPrelude_iterator1094->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1094->definitionLine = 846;
  block_savedest(obj723);
  Object closure1178 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure1178, stackframe);
  addtoclosure(closure1178, var_ConcurrentModification);
  addtoclosure(closure1178, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator1094_object = addmethod2pos(obj723, "iterator$object(1)", &meth_collectionsPrelude_iterator1094_object, 32);
  meth_meth_collectionsPrelude_iterator1094_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1094_object->definitionLine = 846;
// method "values"
  struct UserObject *uo1179 = (struct UserObject*)obj723;
  uo1179->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values1179 = addmethod2pos(obj723, "values", &meth_collectionsPrelude_values1179, 33);
  int argcv_meth_collectionsPrelude_values1179[] = {0};
  meth_meth_collectionsPrelude_values1179->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values1179);
  meth_meth_collectionsPrelude_values1179->definitionModule = modulename;
  meth_meth_collectionsPrelude_values1179->definitionLine = 865;
// method "keys"
  struct UserObject *uo1180 = (struct UserObject*)obj723;
  uo1180->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys1180 = addmethod2pos(obj723, "keys", &meth_collectionsPrelude_keys1180, 34);
  int argcv_meth_collectionsPrelude_keys1180[] = {0};
  meth_meth_collectionsPrelude_keys1180->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys1180);
  meth_meth_collectionsPrelude_keys1180->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys1180->definitionLine = 869;
// method "sort"
  struct UserObject *uo1183 = (struct UserObject*)obj723;
  uo1183->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sort1183 = addmethod2pos(obj723, "sort", &meth_collectionsPrelude_sort1183, 35);
  int argcv_meth_collectionsPrelude_sort1183[] = {0};
  meth_meth_collectionsPrelude_sort1183->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sort1183);
  meth_meth_collectionsPrelude_sort1183->definitionModule = modulename;
  meth_meth_collectionsPrelude_sort1183->definitionLine = 873;
// method "sortedBy(_)"
  struct UserObject *uo1210 = (struct UserObject*)obj723;
  uo1210->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_1210 = addmethod2pos(obj723, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_1210, 36);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_1210[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_1210->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_1210);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_1210->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_1210->definitionLine = 881;
// method "sorted"
  struct UserObject *uo1215 = (struct UserObject*)obj723;
  uo1215->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted1215 = addmethod2pos(obj723, "sorted", &meth_collectionsPrelude_sorted1215, 37);
  int argcv_meth_collectionsPrelude_sorted1215[] = {0};
  meth_meth_collectionsPrelude_sorted1215->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted1215);
  meth_meth_collectionsPrelude_sorted1215->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted1215->definitionLine = 884;
// method "copy"
  struct UserObject *uo1220 = (struct UserObject*)obj723;
  uo1220->data[38] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy1220 = addmethod2pos(obj723, "copy", &meth_collectionsPrelude_copy1220, 38);
  int argcv_meth_collectionsPrelude_copy1220[] = {0};
  meth_meth_collectionsPrelude_copy1220->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy1220);
  meth_meth_collectionsPrelude_copy1220->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy1220->definitionLine = 887;
  sourceObject = obj723;
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1225 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_indexable (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1226 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1225);
// compiled call node returning call1226 (depth = 6)
  struct UserObject *obj723_uo = (struct UserObject *)obj723;
  obj723_uo->super = call1226;
  sourceObject = obj723;
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1227 = alloc_Float64(0);
// compiled num node returning num1227 (depth = 6)
  adddatum2(obj723, num1227, 1);
  sourceObject = obj723;
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1228 = alloc_Float64(0);
// compiled num node returning num1228 (depth = 6)
  adddatum2(obj723, num1228, 2);
  sourceObject = obj723;
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  adddatum2(obj723, done, 3);
  sourceObject = obj723;
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1229 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1230 = alloc_Block(NULL, NULL, "collectionsPrelude", 638);
  gc_frame_newslot(block1230);
// method "_apply(_)"
  block_savedest(block1230);
  Object closure1231 = createclosure(1, "_apply(1)");
  setclosureframe(closure1231, stackframe);
  addtoclosure(closure1231, selfslot);
  struct UserObject *uo1231 = (struct UserObject*)block1230;
  uo1231->data[0] = (Object)closure1231;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1231 = addmethod2pos(block1230, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1231, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1231[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1231->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1231);
  meth_meth_collectionsPrelude__apply_40_1_41_1231->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1231->definitionLine = 1991;
// compiled block node returning block1230 (depth = 7)
  gc_frame_newslot(block1230);
// call case 6: other requests
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  params[0] = block1230;
  partcv[0] = 1;
  Object call1233 = callmethodflags(*var_a, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1229);
// compiled call node returning call1233 (depth = 6)
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  objclass723 = obj723->class;
  objclass723->definitionModule = modulename;
  objclass723->definitionLine = 632;
  (*(struct UserObject *)self).data[0] = lowerouter723;
  self = oldself723;
  selfslot = oldselfslot723;
  stackframe = oldstackframe723;
// compiled object node returning obj723 (depth = 5)
  return obj723;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if722 = undefined;
  } else {
  }
// compiled if node returning if722 (depth = 3)
    gc_frame_newslot(if722);
    if715 = if722;
  } else {
  }
// compiled if node returning if715 (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1234 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1234 = alloc_userobj2(46,43, objclass1234);
  gc_frame_newslot(obj1234);
if (objclass1234 == NULL) {
  glfree(obj1234->class->name);
  obj1234->class->name = "list.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1234, self, 0);
  addmethodreal(obj1234,"outer", &reader_collectionsPrelude_outer_1235);
  Object oldself1234 = self;
  struct StackFrameObject *oldstackframe1234 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1234);
  gc_frame_newslot((Object)stackframe);
  self = obj1234;
  Object *oldselfslot1234 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1234 = (*(struct UserObject *)self).data[0], lowerouter1234 = thisouter1234;
  if (inheritingObject1234) {
    struct UserObject *inho1234 = (struct UserObject *)inheritingObject1234;
    while (inho1234->super != GraceDefaultObject) inho1234 = (struct UserObject *)inho1234->super;
    inho1234->super = obj1234;
    self = inheritingObject1234;
    *selfslot = self;
    lowerouter1234 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1234;
  }
if (objclass1234 == NULL) {
  Method *reader1236 = addmethodrealflags(obj1234, "mods", &reader_collectionsPrelude_mods_1236, 0);
  Method *writer1236 = addmethodrealflags(obj1234, "mods:=(1)", &writer_collectionsPrelude_mods_1236, MFLAG_CONFIDENTIAL);
  reader1236->definitionModule = modulename;
  writer1236->definitionModule = modulename;
  reader1236->definitionLine = 898;
  writer1236->definitionLine = 898;
}
obj1234->flags |= OFLAG_MUTABLE;
adddatum2(obj1234, alloc_Undefined(), 1);
if (objclass1234 == NULL) {
  Method *reader1237 = addmethodrealflags(obj1234, "sizeCertain", &reader_collectionsPrelude_sizeCertain_1237, MFLAG_CONFIDENTIAL);
  Method *writer1237 = addmethodrealflags(obj1234, "sizeCertain:=(1)", &writer_collectionsPrelude_sizeCertain_1237, MFLAG_CONFIDENTIAL);
  reader1237->definitionModule = modulename;
  writer1237->definitionModule = modulename;
  reader1237->definitionLine = 899;
  writer1237->definitionLine = 899;
}
obj1234->flags |= OFLAG_MUTABLE;
adddatum2(obj1234, alloc_Undefined(), 2);
if (objclass1234 == NULL) {
  Method *reader1238 = addmethodrealflags(obj1234, "initialSize",&reader_collectionsPrelude_initialSize_1238, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader1238->definitionModule = modulename;
  reader1238->definitionLine = 901;
}
adddatum2(obj1234, alloc_Undefined(), 3);
if (objclass1234 == NULL) {
  Method *reader1239 = addmethodrealflags(obj1234, "inner", &reader_collectionsPrelude_inner_1239, MFLAG_CONFIDENTIAL);
  Method *writer1239 = addmethodrealflags(obj1234, "inner:=(1)", &writer_collectionsPrelude_inner_1239, MFLAG_CONFIDENTIAL);
  reader1239->definitionModule = modulename;
  writer1239->definitionModule = modulename;
  reader1239->definitionLine = 902;
  writer1239->definitionLine = 902;
}
obj1234->flags |= OFLAG_MUTABLE;
adddatum2(obj1234, alloc_Undefined(), 4);
if (objclass1234 == NULL) {
  Method *reader1240 = addmethodrealflags(obj1234, "size", &reader_collectionsPrelude_size_1240, 0);
  Method *writer1240 = addmethodrealflags(obj1234, "size:=(1)", &writer_collectionsPrelude_size_1240, MFLAG_CONFIDENTIAL);
  reader1240->definitionModule = modulename;
  writer1240->definitionModule = modulename;
  reader1240->definitionLine = 903;
  writer1240->definitionLine = 903;
}
obj1234->flags |= OFLAG_MUTABLE;
adddatum2(obj1234, alloc_Undefined(), 5);
// method "boundsCheck(_)"
  block_savedest(obj1234);
  Object closure1241 = createclosure(1, "boundsCheck(1)");
  setclosureframe(closure1241, stackframe);
  addtoclosure(closure1241, var_BoundsError);
  struct UserObject *uo1241 = (struct UserObject*)obj1234;
  uo1241->data[6] = (Object)closure1241;
  Method *meth_meth_collectionsPrelude_boundsCheck_40_1_41_1241 = addmethod2pos(obj1234, "boundsCheck(1)", &meth_collectionsPrelude_boundsCheck_40_1_41_1241, 6);
  int argcv_meth_collectionsPrelude_boundsCheck_40_1_41_1241[] = {1};
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_1241->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_boundsCheck_40_1_41_1241);
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_1241->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_1241->definitionModule = modulename;
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_1241->definitionLine = 926;
// method "at(_)"
  struct UserObject *uo1278 = (struct UserObject*)obj1234;
  uo1278->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_1278 = addmethod2pos(obj1234, "at(1)", &meth_collectionsPrelude_at_40_1_41_1278, 7);
  int argcv_meth_collectionsPrelude_at_40_1_41_1278[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_1278->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_1278);
  meth_meth_collectionsPrelude_at_40_1_41_1278->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_1278->definitionLine = 931;
// method "at(_)put(_)"
  struct UserObject *uo1289 = (struct UserObject*)obj1234;
  uo1289->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1289 = addmethod2pos(obj1234, "at(1)put(1)", &meth_collectionsPrelude_at_40_1_41_put_40_1_41_1289, 8);
  int argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1289[] = {1, 1};
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1289->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1289);
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1289->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1289->definitionLine = 935;
// method "add(_)"
  struct UserObject *uo1320 = (struct UserObject*)obj1234;
  uo1320->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add_40_1_41_1320 = addmethod2pos(obj1234, "add(1)", &meth_collectionsPrelude_add_40_1_41_1320, 9);
  int argcv_meth_collectionsPrelude_add_40_1_41_1320[] = {1};
  meth_meth_collectionsPrelude_add_40_1_41_1320->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add_40_1_41_1320);
  meth_meth_collectionsPrelude_add_40_1_41_1320->definitionModule = modulename;
  meth_meth_collectionsPrelude_add_40_1_41_1320->definitionLine = 945;
// method "addAll(_)"
  struct UserObject *uo1363 = (struct UserObject*)obj1234;
  uo1363->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll_40_1_41_1363 = addmethod2pos(obj1234, "addAll(1)", &meth_collectionsPrelude_addAll_40_1_41_1363, 10);
  int argcv_meth_collectionsPrelude_addAll_40_1_41_1363[] = {1};
  meth_meth_collectionsPrelude_addAll_40_1_41_1363->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll_40_1_41_1363);
  meth_meth_collectionsPrelude_addAll_40_1_41_1363->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll_40_1_41_1363->definitionLine = 952;
// method "push(_)"
  struct UserObject *uo1427 = (struct UserObject*)obj1234;
  uo1427->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_push_40_1_41_1427 = addmethod2pos(obj1234, "push(1)", &meth_collectionsPrelude_push_40_1_41_1427, 11);
  int argcv_meth_collectionsPrelude_push_40_1_41_1427[] = {1};
  meth_meth_collectionsPrelude_push_40_1_41_1427->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_push_40_1_41_1427);
  meth_meth_collectionsPrelude_push_40_1_41_1427->definitionModule = modulename;
  meth_meth_collectionsPrelude_push_40_1_41_1427->definitionLine = 963;
// method "addLast(_)"
  struct UserObject *uo1470 = (struct UserObject*)obj1234;
  uo1470->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addLast_40_1_41_1470 = addmethod2pos(obj1234, "addLast(1)", &meth_collectionsPrelude_addLast_40_1_41_1470, 12);
  int argcv_meth_collectionsPrelude_addLast_40_1_41_1470[] = {1};
  meth_meth_collectionsPrelude_addLast_40_1_41_1470->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addLast_40_1_41_1470);
  meth_meth_collectionsPrelude_addLast_40_1_41_1470->definitionModule = modulename;
  meth_meth_collectionsPrelude_addLast_40_1_41_1470->definitionLine = 970;
// method "removeLast"
  struct UserObject *uo1473 = (struct UserObject*)obj1234;
  uo1473->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeLast1473 = addmethod2pos(obj1234, "removeLast", &meth_collectionsPrelude_removeLast1473, 13);
  int argcv_meth_collectionsPrelude_removeLast1473[] = {0};
  meth_meth_collectionsPrelude_removeLast1473->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeLast1473);
  meth_meth_collectionsPrelude_removeLast1473->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeLast1473->definitionLine = 971;
// method "addAllFirst(_)"
  struct UserObject *uo1500 = (struct UserObject*)obj1234;
  uo1500->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAllFirst_40_1_41_1500 = addmethod2pos(obj1234, "addAllFirst(1)", &meth_collectionsPrelude_addAllFirst_40_1_41_1500, 14);
  int argcv_meth_collectionsPrelude_addAllFirst_40_1_41_1500[] = {1};
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_1500->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAllFirst_40_1_41_1500);
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_1500->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_1500->definitionLine = 977;
// method "addFirst(_)"
  struct UserObject *uo1596 = (struct UserObject*)obj1234;
  uo1596->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addFirst_40_1_41_1596 = addmethod2pos(obj1234, "addFirst(1)", &meth_collectionsPrelude_addFirst_40_1_41_1596, 15);
  int argcv_meth_collectionsPrelude_addFirst_40_1_41_1596[] = {1};
  meth_meth_collectionsPrelude_addFirst_40_1_41_1596->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addFirst_40_1_41_1596);
  meth_meth_collectionsPrelude_addFirst_40_1_41_1596->definitionModule = modulename;
  meth_meth_collectionsPrelude_addFirst_40_1_41_1596->definitionLine = 994;
// method "clear"
  block_savedest(obj1234);
  Object closure1672 = createclosure(1, "clear");
  setclosureframe(closure1672, stackframe);
  addtoclosure(closure1672, var__prelude);
  struct UserObject *uo1672 = (struct UserObject*)obj1234;
  uo1672->data[16] = (Object)closure1672;
  Method *meth_meth_collectionsPrelude_clear1672 = addmethod2pos(obj1234, "clear", &meth_collectionsPrelude_clear1672, 16);
  int argcv_meth_collectionsPrelude_clear1672[] = {0};
  meth_meth_collectionsPrelude_clear1672->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_clear1672);
  meth_meth_collectionsPrelude_clear1672->definitionModule = modulename;
  meth_meth_collectionsPrelude_clear1672->definitionLine = 1006;
// method "removeFirst"
  struct UserObject *uo1692 = (struct UserObject*)obj1234;
  uo1692->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeFirst1692 = addmethod2pos(obj1234, "removeFirst", &meth_collectionsPrelude_removeFirst1692, 17);
  int argcv_meth_collectionsPrelude_removeFirst1692[] = {0};
  meth_meth_collectionsPrelude_removeFirst1692->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeFirst1692);
  meth_meth_collectionsPrelude_removeFirst1692->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeFirst1692->definitionLine = 1012;
// method "removeAt(_)"
  struct UserObject *uo1696 = (struct UserObject*)obj1234;
  uo1696->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAt_40_1_41_1696 = addmethod2pos(obj1234, "removeAt(1)", &meth_collectionsPrelude_removeAt_40_1_41_1696, 18);
  int argcv_meth_collectionsPrelude_removeAt_40_1_41_1696[] = {1};
  meth_meth_collectionsPrelude_removeAt_40_1_41_1696->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAt_40_1_41_1696);
  meth_meth_collectionsPrelude_removeAt_40_1_41_1696->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAt_40_1_41_1696->definitionLine = 1015;
// method "remove(_)"
  block_savedest(obj1234);
  Object closure1749 = createclosure(1, "remove(1)");
  setclosureframe(closure1749, stackframe);
  addtoclosure(closure1749, var_NoSuchObject);
  struct UserObject *uo1749 = (struct UserObject*)obj1234;
  uo1749->data[19] = (Object)closure1749;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_1749 = addmethod2pos(obj1234, "remove(1)", &meth_collectionsPrelude_remove_40_1_41_1749, 19);
  int argcv_meth_collectionsPrelude_remove_40_1_41_1749[] = {1};
  meth_meth_collectionsPrelude_remove_40_1_41_1749->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove_40_1_41_1749);
  meth_meth_collectionsPrelude_remove_40_1_41_1749->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_1749->definitionLine = 1026;
// method "remove(_)ifAbsent(_)"
  struct UserObject *uo1767 = (struct UserObject*)obj1234;
  uo1767->data[20] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1767 = addmethod2pos(obj1234, "remove(1)ifAbsent(1)", &meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1767, 20);
  int argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1767[] = {1, 1};
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1767->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1767);
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1767->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1767->definitionLine = 1034;
// method "removeAll(_)"
  block_savedest(obj1234);
  Object closure1777 = createclosure(1, "removeAll(1)");
  setclosureframe(closure1777, stackframe);
  addtoclosure(closure1777, var_NoSuchObject);
  struct UserObject *uo1777 = (struct UserObject*)obj1234;
  uo1777->data[21] = (Object)closure1777;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_1777 = addmethod2pos(obj1234, "removeAll(1)", &meth_collectionsPrelude_removeAll_40_1_41_1777, 21);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_1777[] = {1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_1777->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll_40_1_41_1777);
  meth_meth_collectionsPrelude_removeAll_40_1_41_1777->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_1777->definitionLine = 1043;
// method "removeAll(_)ifAbsent(_)"
  struct UserObject *uo1786 = (struct UserObject*)obj1234;
  uo1786->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1786 = addmethod2pos(obj1234, "removeAll(1)ifAbsent(1)", &meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1786, 22);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1786[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1786->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1786);
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1786->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1786->definitionLine = 1047;
// method "pop"
  struct UserObject *uo1807 = (struct UserObject*)obj1234;
  uo1807->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_pop1807 = addmethod2pos(obj1234, "pop", &meth_collectionsPrelude_pop1807, 23);
  int argcv_meth_collectionsPrelude_pop1807[] = {0};
  meth_meth_collectionsPrelude_pop1807->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_pop1807);
  meth_meth_collectionsPrelude_pop1807->definitionModule = modulename;
  meth_meth_collectionsPrelude_pop1807->definitionLine = 1058;
// method "reversed"
  struct UserObject *uo1810 = (struct UserObject*)obj1234;
  uo1810->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed1810 = addmethod2pos(obj1234, "reversed", &meth_collectionsPrelude_reversed1810, 24);
  int argcv_meth_collectionsPrelude_reversed1810[] = {0};
  meth_meth_collectionsPrelude_reversed1810->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed1810);
  meth_meth_collectionsPrelude_reversed1810->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed1810->definitionLine = 1059;
// method "reverse"
  struct UserObject *uo1826 = (struct UserObject*)obj1234;
  uo1826->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reverse1826 = addmethod2pos(obj1234, "reverse", &meth_collectionsPrelude_reverse1826, 25);
  int argcv_meth_collectionsPrelude_reverse1826[] = {0};
  meth_meth_collectionsPrelude_reverse1826->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reverse1826);
  meth_meth_collectionsPrelude_reverse1826->definitionModule = modulename;
  meth_meth_collectionsPrelude_reverse1826->definitionLine = 1064;
// method "++(_)"
  struct UserObject *uo1867 = (struct UserObject*)obj1234;
  uo1867->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_1867 = addmethod2pos(obj1234, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_1867, 26);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_1867[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_1867->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_1867);
  meth_meth_collectionsPrelude__43__43__40_1_41_1867->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_1867->definitionLine = 1077;
// method "asString"
  struct UserObject *uo1878 = (struct UserObject*)obj1234;
  uo1878->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString1878 = addmethod2pos(obj1234, "asString", &meth_collectionsPrelude_asString1878, 27);
  int argcv_meth_collectionsPrelude_asString1878[] = {0};
  meth_meth_collectionsPrelude_asString1878->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString1878);
  meth_meth_collectionsPrelude_asString1878->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString1878->definitionLine = 1081;
// method "asDebugString"
  struct UserObject *uo1924 = (struct UserObject*)obj1234;
  uo1924->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1924 = addmethod2pos(obj1234, "asDebugString", &meth_collectionsPrelude_asDebugString1924, 28);
  int argcv_meth_collectionsPrelude_asDebugString1924[] = {0};
  meth_meth_collectionsPrelude_asDebugString1924->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1924);
  meth_meth_collectionsPrelude_asDebugString1924->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1924->definitionLine = 1089;
// method "contains(_)"
  struct UserObject *uo1970 = (struct UserObject*)obj1234;
  uo1970->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_1970 = addmethod2pos(obj1234, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_1970, 29);
  int argcv_meth_collectionsPrelude_contains_40_1_41_1970[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_1970->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_1970);
  meth_meth_collectionsPrelude_contains_40_1_41_1970->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_1970->definitionLine = 1097;
// method "do(_)"
  struct UserObject *uo1982 = (struct UserObject*)obj1234;
  uo1982->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_1982 = addmethod2pos(obj1234, "do(1)", &meth_collectionsPrelude_do_40_1_41_1982, 30);
  int argcv_meth_collectionsPrelude_do_40_1_41_1982[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_1982->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_1982);
  meth_meth_collectionsPrelude_do_40_1_41_1982->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_1982->definitionLine = 1101;
// method "==(_)"
  struct UserObject *uo2008 = (struct UserObject*)obj1234;
  uo2008->data[31] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_2008 = addmethod2pos(obj1234, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_2008, 31);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_2008[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_2008->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_2008);
  meth_meth_collectionsPrelude__61__61__40_1_41_2008->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_2008->definitionLine = 1109;
// method "iterator"
  block_savedest(obj1234);
  Object closure2015 = createclosure(2, "iterator");
  setclosureframe(closure2015, stackframe);
  addtoclosure(closure2015, var_ConcurrentModification);
  addtoclosure(closure2015, var_IteratorExhausted);
  struct UserObject *uo2015 = (struct UserObject*)obj1234;
  uo2015->data[32] = (Object)closure2015;
  Method *meth_meth_collectionsPrelude_iterator2015 = addmethod2pos(obj1234, "iterator", &meth_collectionsPrelude_iterator2015, 32);
  int argcv_meth_collectionsPrelude_iterator2015[] = {0};
  meth_meth_collectionsPrelude_iterator2015->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator2015);
  meth_meth_collectionsPrelude_iterator2015->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2015->definitionLine = 1112;
  block_savedest(obj1234);
  Object closure2099 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure2099, stackframe);
  addtoclosure(closure2099, var_ConcurrentModification);
  addtoclosure(closure2099, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator2015_object = addmethod2pos(obj1234, "iterator$object(1)", &meth_collectionsPrelude_iterator2015_object, 32);
  meth_meth_collectionsPrelude_iterator2015_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2015_object->definitionLine = 1112;
// method "values"
  struct UserObject *uo2100 = (struct UserObject*)obj1234;
  uo2100->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values2100 = addmethod2pos(obj1234, "values", &meth_collectionsPrelude_values2100, 33);
  int argcv_meth_collectionsPrelude_values2100[] = {0};
  meth_meth_collectionsPrelude_values2100->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values2100);
  meth_meth_collectionsPrelude_values2100->definitionModule = modulename;
  meth_meth_collectionsPrelude_values2100->definitionLine = 1130;
// method "keys"
  struct UserObject *uo2101 = (struct UserObject*)obj1234;
  uo2101->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys2101 = addmethod2pos(obj1234, "keys", &meth_collectionsPrelude_keys2101, 34);
  int argcv_meth_collectionsPrelude_keys2101[] = {0};
  meth_meth_collectionsPrelude_keys2101->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys2101);
  meth_meth_collectionsPrelude_keys2101->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys2101->definitionLine = 1133;
// method "expandTo(_)"
  block_savedest(obj1234);
  Object closure2104 = createclosure(1, "expandTo(1)");
  setclosureframe(closure2104, stackframe);
  addtoclosure(closure2104, var__prelude);
  struct UserObject *uo2104 = (struct UserObject*)obj1234;
  uo2104->data[35] = (Object)closure2104;
  Method *meth_meth_collectionsPrelude_expandTo_40_1_41_2104 = addmethod2pos(obj1234, "expandTo(1)", &meth_collectionsPrelude_expandTo_40_1_41_2104, 35);
  int argcv_meth_collectionsPrelude_expandTo_40_1_41_2104[] = {1};
  meth_meth_collectionsPrelude_expandTo_40_1_41_2104->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expandTo_40_1_41_2104);
  meth_meth_collectionsPrelude_expandTo_40_1_41_2104->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expandTo_40_1_41_2104->definitionModule = modulename;
  meth_meth_collectionsPrelude_expandTo_40_1_41_2104->definitionLine = 1136;
// method "sortBy(_)"
  struct UserObject *uo2132 = (struct UserObject*)obj1234;
  uo2132->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortBy_40_1_41_2132 = addmethod2pos(obj1234, "sortBy(1)", &meth_collectionsPrelude_sortBy_40_1_41_2132, 36);
  int argcv_meth_collectionsPrelude_sortBy_40_1_41_2132[] = {1};
  meth_meth_collectionsPrelude_sortBy_40_1_41_2132->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortBy_40_1_41_2132);
  meth_meth_collectionsPrelude_sortBy_40_1_41_2132->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortBy_40_1_41_2132->definitionLine = 1143;
// method "sort"
  struct UserObject *uo2147 = (struct UserObject*)obj1234;
  uo2147->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sort2147 = addmethod2pos(obj1234, "sort", &meth_collectionsPrelude_sort2147, 37);
  int argcv_meth_collectionsPrelude_sort2147[] = {0};
  meth_meth_collectionsPrelude_sort2147->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sort2147);
  meth_meth_collectionsPrelude_sort2147->definitionModule = modulename;
  meth_meth_collectionsPrelude_sort2147->definitionLine = 1148;
// method "sortedBy(_)"
  struct UserObject *uo2166 = (struct UserObject*)obj1234;
  uo2166->data[38] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_2166 = addmethod2pos(obj1234, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_2166, 38);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_2166[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_2166->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_2166);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_2166->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_2166->definitionLine = 1155;
// method "sorted"
  struct UserObject *uo2171 = (struct UserObject*)obj1234;
  uo2171->data[39] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted2171 = addmethod2pos(obj1234, "sorted", &meth_collectionsPrelude_sorted2171, 39);
  int argcv_meth_collectionsPrelude_sorted2171[] = {0};
  meth_meth_collectionsPrelude_sorted2171->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted2171);
  meth_meth_collectionsPrelude_sorted2171->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted2171->definitionLine = 1158;
// method "copy"
  struct UserObject *uo2176 = (struct UserObject*)obj1234;
  uo2176->data[40] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy2176 = addmethod2pos(obj1234, "copy", &meth_collectionsPrelude_copy2176, 40);
  int argcv_meth_collectionsPrelude_copy2176[] = {0};
  meth_meth_collectionsPrelude_copy2176->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy2176);
  meth_meth_collectionsPrelude_copy2176->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy2176->definitionLine = 1161;
  sourceObject = obj1234;
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2181 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2182 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2181);
// compiled call node returning call2182 (depth = 2)
  struct UserObject *obj1234_uo = (struct UserObject *)obj1234;
  obj1234_uo->super = call2182;
  sourceObject = obj1234;
// Begin line 898
  setline(898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2183 = alloc_Float64(0);
// compiled num node returning num2183 (depth = 2)
  adddatum2(obj1234, num2183, 1);
  sourceObject = obj1234;
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool2184 = alloc_Boolean(1);
// compiled identifier node returning bool2184 (depth = 2)
  adddatum2(obj1234, bool2184, 2);
  sourceObject = obj1234;
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2186 = alloc_Float64(1);
// compiled num node returning num2186 (depth = 3)
  int op_slot_right_2185 = gc_frame_newslot(num2186);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2189 = alloc_Float64(2);
// compiled num node returning num2189 (depth = 4)
  int op_slot_right_2188 = gc_frame_newslot(num2189);
// starting to compile call node (depth = 4)
  int callframe2191 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2192 = alloc_Block(NULL, NULL, "collectionsPrelude", 901);
  gc_frame_newslot(block2192);
// method "_apply"
  block_savedest(block2192);
  Object closure2193 = createclosure(1, "_apply");
  setclosureframe(closure2193, stackframe);
  addtoclosure(closure2193, selfslot);
  struct UserObject *uo2193 = (struct UserObject*)block2192;
  uo2193->data[0] = (Object)closure2193;
  Method *meth_meth_collectionsPrelude__apply2193 = addmethod2pos(block2192, "_apply", &meth_collectionsPrelude__apply2193, 0);
  int argcv_meth_collectionsPrelude__apply2193[] = {0};
  meth_meth_collectionsPrelude__apply2193->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2193);
  meth_meth_collectionsPrelude__apply2193->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2193->definitionLine = 1991;
// compiled block node returning block2192 (depth = 5)
  gc_frame_newslot(block2192);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_a (depth = 5)
  params[0] = block2192;
  partcv[0] = 1;
  Object call2199 = callmethodflags(*var_a, "sizeIfUnknown(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2191);
// compiled call node returning call2199 (depth = 4)
  int op_slot_left_2188 = gc_frame_newslot(call2199);
  params[0] = num2189;
  partcv[0] = 1;
  Object prod2200 = callmethod(call2199, "*(1)", 1, partcv, params);
// compiled op node returning prod2200 (depth = 3)
  int op_slot_left_2185 = gc_frame_newslot(prod2200);
  params[0] = num2186;
  partcv[0] = 1;
  Object sum2201 = callmethod(prod2200, "+(1)", 1, partcv, params);
// compiled op node returning sum2201 (depth = 2)
  adddatum2(obj1234, sum2201, 3);
  sourceObject = obj1234;
// Begin line 902
  setline(902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2202 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe2203 = gc_frame_new();
// call case 4: self request
  Object call2204 = callmethodflags(self, "initialSize", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2203);
// compiled member node returning call2204 (depth = 3)
  gc_frame_newslot(call2204);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2205 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__prelude (depth = 4)
  Object call2206 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe2205);
// compiled member node returning call2206 (depth = 3)
  params[0] = call2204;
  partcv[0] = 1;
  Object call2207 = callmethodflags(call2206, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2202);
// compiled call node returning call2207 (depth = 2)
  adddatum2(obj1234, call2207, 4);
  sourceObject = obj1234;
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2208 = alloc_Float64(0);
// compiled num node returning num2208 (depth = 2)
  adddatum2(obj1234, num2208, 5);
  sourceObject = obj1234;
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2210 = gc_frame_new();
// call case 4: self request
  Object call2211 = callmethodflags(self, "sizeCertain", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2210);
// compiled member node returning call2211 (depth = 3)
  Object if2209 = done;
struct StackFrameObject *iftmpstackframe2209 = stackframe;
  if (istrue(call2211)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2209);
gc_frame_newslot((Object)stackframe);
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2212 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 4)
  Object block2213 = alloc_Block(NULL, NULL, "collectionsPrelude", 906);
  gc_frame_newslot(block2213);
// method "_apply(_)"
  block_savedest(block2213);
  Object closure2214 = createclosure(1, "_apply(1)");
  setclosureframe(closure2214, stackframe);
  addtoclosure(closure2214, selfslot);
  struct UserObject *uo2214 = (struct UserObject*)block2213;
  uo2214->data[0] = (Object)closure2214;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2214 = addmethod2pos(block2213, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2214, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2214[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2214->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2214);
  meth_meth_collectionsPrelude__apply_40_1_41_2214->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2214->definitionLine = 1991;
// compiled block node returning block2213 (depth = 4)
  gc_frame_newslot(block2213);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2213;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2230 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2212);
// compiled call node returning call2230 (depth = 3)
    gc_frame_newslot(call2230);
    if2209 = call2230;
  } else {
  stackframe = alloc_StackFrame(1, iftmpstackframe2209);
  gc_frame_newslot((Object)stackframe);
  Object *var_innerSize = &(stackframe->slots[0]);
  setframeelementname(stackframe, 0, "innerSize");
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2231 = gc_frame_new();
// call case 4: self request
  Object call2232 = callmethodflags(self, "initialSize", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2231);
// compiled member node returning call2232 (depth = 4)
  *var_innerSize = call2232;
  if (call2232 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2233 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 4)
  Object block2234 = alloc_Block(NULL, NULL, "collectionsPrelude", 913);
  gc_frame_newslot(block2234);
// method "_apply(_)"
  block_savedest(block2234);
  Object closure2235 = createclosure(3, "_apply(1)");
  setclosureframe(closure2235, stackframe);
  addtoclosure(closure2235, var_innerSize);
  addtoclosure(closure2235, var__prelude);
  addtoclosure(closure2235, selfslot);
  struct UserObject *uo2235 = (struct UserObject*)block2234;
  uo2235->data[0] = (Object)closure2235;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2235 = addmethod2pos(block2234, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2235, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2235[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2235->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2235);
  meth_meth_collectionsPrelude__apply_40_1_41_2235->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2235->definitionLine = 1991;
// compiled block node returning block2234 (depth = 4)
  gc_frame_newslot(block2234);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2234;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2291 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2233);
// compiled call node returning call2291 (depth = 3)
    gc_frame_newslot(call2291);
    if2209 = call2291;
  }
stackframe = iftmpstackframe2209;
// compiled if node returning if2209 (depth = 2)
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  sourceObject = obj1234;
  objclass1234 = obj1234->class;
  objclass1234->definitionModule = modulename;
  objclass1234->definitionLine = 894;
  (*(struct UserObject *)self).data[0] = lowerouter1234;
  self = oldself1234;
  selfslot = oldselfslot1234;
  stackframe = oldstackframe1234;
  gc_frame_end(frame);
  return obj1234;
}
Object meth_collectionsPrelude_list706(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "list");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  Object *var_indexable = getfromclosure(closure, 5);
  Object *var_BoundsError = getfromclosure(closure, 6);
  Object *var__prelude = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject707 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj707 = alloc_userobj2(4,5, objclass707);
  gc_frame_newslot(obj707);
if (objclass707 == NULL) {
  glfree(obj707->class->name);
  obj707->class->name = "list";
}
// OBJECT OUTER DEC outer
  adddatum2(obj707, self, 0);
  addmethodreal(obj707,"outer", &reader_collectionsPrelude_outer_708);
  Object oldself707 = self;
  struct StackFrameObject *oldstackframe707 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe707);
  gc_frame_newslot((Object)stackframe);
  self = obj707;
  Object *oldselfslot707 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter707 = (*(struct UserObject *)self).data[0], lowerouter707 = thisouter707;
  if (inheritingObject707) {
    struct UserObject *inho707 = (struct UserObject *)inheritingObject707;
    while (inho707->super != GraceDefaultObject) inho707 = (struct UserObject *)inho707->super;
    inho707->super = obj707;
    self = inheritingObject707;
    *selfslot = self;
    lowerouter707 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter707;
  }
// method "asString"
  struct UserObject *uo709 = (struct UserObject*)obj707;
  uo709->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString709 = addmethod2pos(obj707, "asString", &meth_collectionsPrelude_asString709, 1);
  int argcv_meth_collectionsPrelude_asString709[] = {0};
  meth_meth_collectionsPrelude_asString709->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString709);
  meth_meth_collectionsPrelude_asString709->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString709->definitionLine = 623;
// method "empty"
  block_savedest(obj707);
  Object closure711 = createclosure(1, "empty");
  setclosureframe(closure711, stackframe);
  addtoclosure(closure711, var_emptySequence);
  struct UserObject *uo711 = (struct UserObject*)obj707;
  uo711->data[2] = (Object)closure711;
  Method *meth_meth_collectionsPrelude_empty711 = addmethod2pos(obj707, "empty", &meth_collectionsPrelude_empty711, 2);
  int argcv_meth_collectionsPrelude_empty711[] = {0};
  meth_meth_collectionsPrelude_empty711->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty711);
  meth_meth_collectionsPrelude_empty711->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty711->definitionLine = 625;
// method "withAll(_)"
  block_savedest(obj707);
  Object closure714 = createclosure(7, "withAll(1)");
  setclosureframe(closure714, stackframe);
  addtoclosure(closure714, var_NoSuchObject);
  addtoclosure(closure714, var_done);
  addtoclosure(closure714, var_ConcurrentModification);
  addtoclosure(closure714, var_IteratorExhausted);
  addtoclosure(closure714, var_indexable);
  addtoclosure(closure714, var_BoundsError);
  addtoclosure(closure714, var__prelude);
  struct UserObject *uo714 = (struct UserObject*)obj707;
  uo714->data[3] = (Object)closure714;
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_714 = addmethod2pos(obj707, "withAll(1)", &meth_collectionsPrelude_withAll_40_1_41_714, 3);
  int argcv_meth_collectionsPrelude_withAll_40_1_41_714[] = {1};
  meth_meth_collectionsPrelude_withAll_40_1_41_714->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll_40_1_41_714);
  meth_meth_collectionsPrelude_withAll_40_1_41_714->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_714->definitionLine = 629;
  block_savedest(obj707);
  Object closure2292 = createclosure(7, "withAll(1)$object(1)");
  setclosureframe(closure2292, stackframe);
  addtoclosure(closure2292, var_NoSuchObject);
  addtoclosure(closure2292, var_done);
  addtoclosure(closure2292, var_ConcurrentModification);
  addtoclosure(closure2292, var_IteratorExhausted);
  addtoclosure(closure2292, var_indexable);
  addtoclosure(closure2292, var_BoundsError);
  addtoclosure(closure2292, var__prelude);
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_714_object = addmethod2pos(obj707, "withAll(1)$object(1)", &meth_collectionsPrelude_withAll_40_1_41_714_object, 3);
  meth_meth_collectionsPrelude_withAll_40_1_41_714_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_714_object->definitionLine = 629;
  sourceObject = obj707;
  sourceObject = obj707;
  sourceObject = obj707;
  objclass707 = obj707->class;
  objclass707->definitionModule = modulename;
  objclass707->definitionLine = 621;
  (*(struct UserObject *)self).data[0] = lowerouter707;
  self = oldself707;
  selfslot = oldselfslot707;
  stackframe = oldstackframe707;
  gc_frame_end(frame);
  return obj707;
}
Object meth_collectionsPrelude_list706_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "list$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  Object *var_indexable = getfromclosure(closure, 5);
  Object *var_BoundsError = getfromclosure(closure, 6);
  Object *var__prelude = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject707 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj707 = alloc_userobj2(4,5, objclass707);
  gc_frame_newslot(obj707);
if (objclass707 == NULL) {
  glfree(obj707->class->name);
  obj707->class->name = "list";
}
// OBJECT OUTER DEC outer
  adddatum2(obj707, self, 0);
  addmethodreal(obj707,"outer", &reader_collectionsPrelude_outer_708);
  Object oldself707 = self;
  struct StackFrameObject *oldstackframe707 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe707);
  gc_frame_newslot((Object)stackframe);
  self = obj707;
  Object *oldselfslot707 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter707 = (*(struct UserObject *)self).data[0], lowerouter707 = thisouter707;
  if (inheritingObject707) {
    struct UserObject *inho707 = (struct UserObject *)inheritingObject707;
    while (inho707->super != GraceDefaultObject) inho707 = (struct UserObject *)inho707->super;
    inho707->super = obj707;
    self = inheritingObject707;
    *selfslot = self;
    lowerouter707 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter707;
  }
// method "asString"
  struct UserObject *uo709 = (struct UserObject*)obj707;
  uo709->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString709 = addmethod2pos(obj707, "asString", &meth_collectionsPrelude_asString709, 1);
  int argcv_meth_collectionsPrelude_asString709[] = {0};
  meth_meth_collectionsPrelude_asString709->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString709);
  meth_meth_collectionsPrelude_asString709->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString709->definitionLine = 623;
// method "empty"
  block_savedest(obj707);
  Object closure711 = createclosure(1, "empty");
  setclosureframe(closure711, stackframe);
  addtoclosure(closure711, var_emptySequence);
  struct UserObject *uo711 = (struct UserObject*)obj707;
  uo711->data[2] = (Object)closure711;
  Method *meth_meth_collectionsPrelude_empty711 = addmethod2pos(obj707, "empty", &meth_collectionsPrelude_empty711, 2);
  int argcv_meth_collectionsPrelude_empty711[] = {0};
  meth_meth_collectionsPrelude_empty711->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty711);
  meth_meth_collectionsPrelude_empty711->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty711->definitionLine = 625;
// method "withAll(_)"
  block_savedest(obj707);
  Object closure714 = createclosure(7, "withAll(1)");
  setclosureframe(closure714, stackframe);
  addtoclosure(closure714, var_NoSuchObject);
  addtoclosure(closure714, var_done);
  addtoclosure(closure714, var_ConcurrentModification);
  addtoclosure(closure714, var_IteratorExhausted);
  addtoclosure(closure714, var_indexable);
  addtoclosure(closure714, var_BoundsError);
  addtoclosure(closure714, var__prelude);
  struct UserObject *uo714 = (struct UserObject*)obj707;
  uo714->data[3] = (Object)closure714;
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_714 = addmethod2pos(obj707, "withAll(1)", &meth_collectionsPrelude_withAll_40_1_41_714, 3);
  int argcv_meth_collectionsPrelude_withAll_40_1_41_714[] = {1};
  meth_meth_collectionsPrelude_withAll_40_1_41_714->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll_40_1_41_714);
  meth_meth_collectionsPrelude_withAll_40_1_41_714->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_714->definitionLine = 629;
  block_savedest(obj707);
  Object closure2292 = createclosure(7, "withAll(1)$object(1)");
  setclosureframe(closure2292, stackframe);
  addtoclosure(closure2292, var_NoSuchObject);
  addtoclosure(closure2292, var_done);
  addtoclosure(closure2292, var_ConcurrentModification);
  addtoclosure(closure2292, var_IteratorExhausted);
  addtoclosure(closure2292, var_indexable);
  addtoclosure(closure2292, var_BoundsError);
  addtoclosure(closure2292, var__prelude);
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_714_object = addmethod2pos(obj707, "withAll(1)$object(1)", &meth_collectionsPrelude_withAll_40_1_41_714_object, 3);
  meth_meth_collectionsPrelude_withAll_40_1_41_714_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_714_object->definitionLine = 629;
  sourceObject = obj707;
  sourceObject = obj707;
  sourceObject = obj707;
  objclass707 = obj707->class;
  objclass707->definitionModule = modulename;
  objclass707->definitionLine = 621;
  (*(struct UserObject *)self).data[0] = lowerouter707;
  self = oldself707;
  selfslot = oldselfslot707;
  stackframe = oldstackframe707;
  gc_frame_end(frame);
  return obj707;
}
Object meth_collectionsPrelude_asString2297(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit2298 == NULL) {
    strlit2298 = alloc_String("a set factory");
    gc_root(strlit2298);
  }
// compiled string node returning strlit2298 (depth = 2)
  gc_frame_end(frame);
  return strlit2298;
}
Object meth_collectionsPrelude__apply2309(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile num node (depth = 8)
  Object num2310 = alloc_Float64(2);
// compiled num node returning num2310 (depth = 8)
  gc_frame_end(frame);
  return num2310;
}
Object meth_collectionsPrelude__apply_40_1_41_2323(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe2324 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2325 = callmethodflags(*var_result, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2324);
// compiled call node returning call2325 (depth = 4)
  gc_frame_end(frame);
  return call2325;
}
Object meth_collectionsPrelude_withAll_40_1_41_2299(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "withAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method withAll(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_cap = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "cap");
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2300 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2302 = alloc_Float64(1);
// compiled num node returning num2302 (depth = 5)
  int op_slot_right_2301 = gc_frame_newslot(num2302);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2305 = alloc_Float64(3);
// compiled num node returning num2305 (depth = 6)
  int op_slot_right_2304 = gc_frame_newslot(num2305);
// starting to compile call node (depth = 6)
  int callframe2307 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block2308 = alloc_Block(NULL, NULL, "collectionsPrelude", 1190);
  gc_frame_newslot(block2308);
// method "_apply"
  block_savedest(block2308);
  Object closure2309 = createclosure(1, "_apply");
  setclosureframe(closure2309, stackframe);
  addtoclosure(closure2309, selfslot);
  struct UserObject *uo2309 = (struct UserObject*)block2308;
  uo2309->data[0] = (Object)closure2309;
  Method *meth_meth_collectionsPrelude__apply2309 = addmethod2pos(block2308, "_apply", &meth_collectionsPrelude__apply2309, 0);
  int argcv_meth_collectionsPrelude__apply2309[] = {0};
  meth_meth_collectionsPrelude__apply2309->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2309);
  meth_meth_collectionsPrelude__apply2309->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2309->definitionLine = 1991;
// compiled block node returning block2308 (depth = 7)
  gc_frame_newslot(block2308);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  params[0] = block2308;
  partcv[0] = 1;
  Object call2312 = callmethodflags(*var_a, "sizeIfUnknown(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2307);
// compiled call node returning call2312 (depth = 6)
  int op_slot_left_2304 = gc_frame_newslot(call2312);
  params[0] = num2305;
  partcv[0] = 1;
  Object prod2313 = callmethod(call2312, "*(1)", 1, partcv, params);
// compiled op node returning prod2313 (depth = 5)
  int op_slot_left_2301 = gc_frame_newslot(prod2313);
  params[0] = num2302;
  partcv[0] = 1;
  Object sum2314 = callmethod(prod2313, "+(1)", 1, partcv, params);
// compiled op node returning sum2314 (depth = 4)
  gc_frame_newslot(sum2314);
// starting to compile num node (depth = 4)
  Object num2315 = alloc_Float64(8);
// compiled num node returning num2315 (depth = 4)
  gc_frame_newslot(num2315);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2316 = gc_frame_new();
// call case 3: self.outer request
  Object call2317 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2316);
// compiled member node returning call2317 (depth = 4)
  params[0] = sum2314;
  params[1] = num2315;
  partcv[0] = 2;
  Object call2318 = callmethodflags(call2317, "max(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2300);
// compiled call node returning call2318 (depth = 3)
  *var_cap = call2318;
  if (call2318 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1191
  setline(1191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2319 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cap (depth = 4)
  gc_frame_newslot(*var_cap);
// call case 4: self request
  params[0] = *var_cap;
  partcv[0] = 1;
  Object call2320 = callmethodflags(self, "ofCapacity(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2319);
// compiled call node returning call2320 (depth = 3)
  *var_result = call2320;
  if (call2320 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2321 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2322 = alloc_Block(NULL, NULL, "collectionsPrelude", 1192);
  gc_frame_newslot(block2322);
// method "_apply(_)"
  block_savedest(block2322);
  Object closure2323 = createclosure(2, "_apply(1)");
  setclosureframe(closure2323, stackframe);
  addtoclosure(closure2323, var_result);
  addtoclosure(closure2323, selfslot);
  struct UserObject *uo2323 = (struct UserObject*)block2322;
  uo2323->data[0] = (Object)closure2323;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2323 = addmethod2pos(block2322, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2323, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2323[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2323->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2323);
  meth_meth_collectionsPrelude__apply_40_1_41_2323->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2323->definitionLine = 1991;
// compiled block node returning block2322 (depth = 3)
  gc_frame_newslot(block2322);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_a (depth = 3)
  params[0] = block2322;
  partcv[0] = 1;
  Object call2327 = callmethodflags(*var_a, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2321);
// compiled call node returning call2327 (depth = 2)
// Begin line 1193
  setline(1193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude_empty2328(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2329 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num2330 = alloc_Float64(8);
// compiled num node returning num2330 (depth = 3)
  gc_frame_newslot(num2330);
// call case 4: self request
  params[0] = num2330;
  partcv[0] = 1;
  Object call2331 = callmethodflags(self, "ofCapacity(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2329);
// compiled call node returning call2331 (depth = 2)
  gc_frame_end(frame);
  return call2331;
}
Object meth_collectionsPrelude__apply_40_1_41_2349(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1212
  setline(1212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2351 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe2352 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2353 = callmethodflags(self, "contains(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2352);
// compiled call node returning call2353 (depth = 6)
  partcv[0] = 0;
  Object call2354 = callmethodflags(call2353, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe2351);
// compiled call node returning call2354 (depth = 5)
  Object if2350 = done;
  if (istrue(call2354)) {
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2355 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2356 = callmethodflags(self, "findPositionForAdd(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2355);
// compiled call node returning call2356 (depth = 6)
  *var_t = call2356;
  if (call2356 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1214
  setline(1214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2357 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2358 = gc_frame_new();
// call case 4: self request
  Object call2359 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2358);
// compiled member node returning call2359 (depth = 6)
  params[0] = *var_t;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2360 = callmethodflags(call2359, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2357);
// compiled call node returning call2360 (depth = 5)
// Begin line 1215
  setline(1215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2361 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2363 = alloc_Float64(1);
// compiled num node returning num2363 (depth = 7)
  int op_slot_right_2362 = gc_frame_newslot(num2363);
// starting to compile member node (depth = 7)
  int callframe2365 = gc_frame_new();
// call case 4: self request
  Object call2366 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2365);
// compiled member node returning call2366 (depth = 7)
  int op_slot_left_2362 = gc_frame_newslot(call2366);
  params[0] = num2363;
  partcv[0] = 1;
  Object sum2367 = callmethod(call2366, "+(1)", 1, partcv, params);
// compiled op node returning sum2367 (depth = 6)
  gc_frame_newslot(sum2367);
// call case 4: self request
  params[0] = sum2367;
  partcv[0] = 1;
  Object call2368 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2361);
// compiled call node returning call2368 (depth = 5)
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2372 = alloc_Float64(2);
// compiled num node returning num2372 (depth = 8)
  int op_slot_right_2371 = gc_frame_newslot(num2372);
// starting to compile member node (depth = 8)
  int callframe2374 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2375 = gc_frame_new();
// call case 4: self request
  Object call2376 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2375);
// compiled member node returning call2376 (depth = 9)
  Object call2377 = callmethodflags(call2376, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2374);
// compiled member node returning call2377 (depth = 8)
  int op_slot_left_2371 = gc_frame_newslot(call2377);
  params[0] = num2372;
  partcv[0] = 1;
  Object quotient2378 = callmethod(call2377, "/(1)", 1, partcv, params);
// compiled op node returning quotient2378 (depth = 7)
  int op_slot_right_2370 = gc_frame_newslot(quotient2378);
// starting to compile member node (depth = 7)
  int callframe2380 = gc_frame_new();
// call case 4: self request
  Object call2381 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2380);
// compiled member node returning call2381 (depth = 7)
  int op_slot_left_2370 = gc_frame_newslot(call2381);
  params[0] = quotient2378;
  partcv[0] = 1;
  Object opresult2382 = callmethod(call2381, ">(1)", 1, partcv, params);
// compiled op node returning opresult2382 (depth = 6)
  Object if2369 = done;
  if (istrue(opresult2382)) {
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2383 = gc_frame_new();
// call case 4: self request
  Object call2384 = callmethodflags(self, "expand", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2383);
// compiled member node returning call2384 (depth = 6)
    gc_frame_newslot(call2384);
    if2369 = call2384;
  } else {
  }
// compiled if node returning if2369 (depth = 5)
    gc_frame_newslot(if2369);
    if2350 = if2369;
  } else {
  }
// compiled if node returning if2350 (depth = 4)
  gc_frame_end(frame);
  return if2350;
}
Object meth_collectionsPrelude_addAll_40_1_41_2338(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAll(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elements = &(stackframe->slots[0]);
  *var_elements = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2339 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2341 = alloc_Float64(1);
// compiled num node returning num2341 (depth = 4)
  int op_slot_right_2340 = gc_frame_newslot(num2341);
// starting to compile member node (depth = 4)
  int callframe2343 = gc_frame_new();
// call case 4: self request
  Object call2344 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2343);
// compiled member node returning call2344 (depth = 4)
  int op_slot_left_2340 = gc_frame_newslot(call2344);
  params[0] = num2341;
  partcv[0] = 1;
  Object sum2345 = callmethod(call2344, "+(1)", 1, partcv, params);
// compiled op node returning sum2345 (depth = 3)
  gc_frame_newslot(sum2345);
// call case 4: self request
  params[0] = sum2345;
  partcv[0] = 1;
  Object call2346 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2339);
// compiled call node returning call2346 (depth = 2)
// Begin line 1211
  setline(1211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2347 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elements (depth = 3)
  gc_frame_newslot(*var_elements);
// starting to compile block node (depth = 3)
  Object block2348 = alloc_Block(NULL, NULL, "collectionsPrelude", 1211);
  gc_frame_newslot(block2348);
// method "_apply(_)"
  block_savedest(block2348);
  Object closure2349 = createclosure(1, "_apply(1)");
  setclosureframe(closure2349, stackframe);
  addtoclosure(closure2349, selfslot);
  struct UserObject *uo2349 = (struct UserObject*)block2348;
  uo2349->data[0] = (Object)closure2349;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2349 = addmethod2pos(block2348, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2349, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2349[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2349->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2349);
  meth_meth_collectionsPrelude__apply_40_1_41_2349->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2349->definitionLine = 1991;
// compiled block node returning block2348 (depth = 3)
  gc_frame_newslot(block2348);
// call case 5: prelude request
  params[0] = *var_elements;
  params[1] = block2348;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2386 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2347);
// compiled call node returning call2386 (depth = 2)
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_add_40_1_41_2387(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "add(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method add(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for add(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part add(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2389 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe2390 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2391 = callmethodflags(self, "contains(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2390);
// compiled call node returning call2391 (depth = 4)
  partcv[0] = 0;
  Object call2392 = callmethodflags(call2391, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe2389);
// compiled call node returning call2392 (depth = 3)
  Object if2388 = done;
  if (istrue(call2392)) {
// Begin line 1226
  setline(1226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2393 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2395 = alloc_Float64(1);
// compiled num node returning num2395 (depth = 5)
  int op_slot_right_2394 = gc_frame_newslot(num2395);
// starting to compile member node (depth = 5)
  int callframe2397 = gc_frame_new();
// call case 4: self request
  Object call2398 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2397);
// compiled member node returning call2398 (depth = 5)
  int op_slot_left_2394 = gc_frame_newslot(call2398);
  params[0] = num2395;
  partcv[0] = 1;
  Object sum2399 = callmethod(call2398, "+(1)", 1, partcv, params);
// compiled op node returning sum2399 (depth = 4)
  gc_frame_newslot(sum2399);
// call case 4: self request
  params[0] = sum2399;
  partcv[0] = 1;
  Object call2400 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2393);
// compiled call node returning call2400 (depth = 3)
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2401 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2402 = callmethodflags(self, "findPositionForAdd(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2401);
// compiled call node returning call2402 (depth = 4)
  *var_t = call2402;
  if (call2402 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1228
  setline(1228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2403 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2404 = gc_frame_new();
// call case 4: self request
  Object call2405 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2404);
// compiled member node returning call2405 (depth = 4)
  params[0] = *var_t;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2406 = callmethodflags(call2405, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2403);
// compiled call node returning call2406 (depth = 3)
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2407 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2409 = alloc_Float64(1);
// compiled num node returning num2409 (depth = 5)
  int op_slot_right_2408 = gc_frame_newslot(num2409);
// starting to compile member node (depth = 5)
  int callframe2411 = gc_frame_new();
// call case 4: self request
  Object call2412 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2411);
// compiled member node returning call2412 (depth = 5)
  int op_slot_left_2408 = gc_frame_newslot(call2412);
  params[0] = num2409;
  partcv[0] = 1;
  Object sum2413 = callmethod(call2412, "+(1)", 1, partcv, params);
// compiled op node returning sum2413 (depth = 4)
  gc_frame_newslot(sum2413);
// call case 4: self request
  params[0] = sum2413;
  partcv[0] = 1;
  Object call2414 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2407);
// compiled call node returning call2414 (depth = 3)
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2418 = alloc_Float64(2);
// compiled num node returning num2418 (depth = 6)
  int op_slot_right_2417 = gc_frame_newslot(num2418);
// starting to compile member node (depth = 6)
  int callframe2420 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2421 = gc_frame_new();
// call case 4: self request
  Object call2422 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2421);
// compiled member node returning call2422 (depth = 7)
  Object call2423 = callmethodflags(call2422, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2420);
// compiled member node returning call2423 (depth = 6)
  int op_slot_left_2417 = gc_frame_newslot(call2423);
  params[0] = num2418;
  partcv[0] = 1;
  Object quotient2424 = callmethod(call2423, "/(1)", 1, partcv, params);
// compiled op node returning quotient2424 (depth = 5)
  int op_slot_right_2416 = gc_frame_newslot(quotient2424);
// starting to compile member node (depth = 5)
  int callframe2426 = gc_frame_new();
// call case 4: self request
  Object call2427 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2426);
// compiled member node returning call2427 (depth = 5)
  int op_slot_left_2416 = gc_frame_newslot(call2427);
  params[0] = quotient2424;
  partcv[0] = 1;
  Object opresult2428 = callmethod(call2427, ">(1)", 1, partcv, params);
// compiled op node returning opresult2428 (depth = 4)
  Object if2415 = done;
  if (istrue(opresult2428)) {
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2429 = gc_frame_new();
// call case 4: self request
  Object call2430 = callmethodflags(self, "expand", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2429);
// compiled member node returning call2430 (depth = 4)
    gc_frame_newslot(call2430);
    if2415 = call2430;
  } else {
  }
// compiled if node returning if2415 (depth = 3)
    gc_frame_newslot(if2415);
    if2388 = if2415;
  } else {
  }
// compiled if node returning if2388 (depth = 2)
// Begin line 1234
  setline(1234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply2437(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2438 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2440 == NULL) {
    strlit2440 = alloc_String("");
    gc_root(strlit2440);
  }
// compiled string node returning strlit2440 (depth = 8)
  int op_slot_right_2439 = gc_frame_newslot(strlit2440);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_x (depth = 9)
  int op_slot_right_2442 = gc_frame_newslot(*var_x);
// starting to compile string node (depth = 9)
  if (strlit2444 == NULL) {
    strlit2444 = alloc_String("set does not contain ");
    gc_root(strlit2444);
  }
// compiled string node returning strlit2444 (depth = 9)
  int op_slot_left_2442 = gc_frame_newslot(strlit2444);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2445 = callmethod(strlit2444, "++(1)", 1, partcv, params);
// compiled op node returning opresult2445 (depth = 8)
  int op_slot_left_2439 = gc_frame_newslot(opresult2445);
  params[0] = strlit2440;
  partcv[0] = 1;
  Object opresult2446 = callmethod(opresult2445, "++(1)", 1, partcv, params);
// compiled op node returning opresult2446 (depth = 7)
  gc_frame_newslot(opresult2446);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_NoSuchObject (depth = 7)
  params[0] = opresult2446;
  partcv[0] = 1;
  Object call2447 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2438);
// compiled call node returning call2447 (depth = 6)
  gc_frame_end(frame);
  return call2447;
}
Object meth_collectionsPrelude__apply_40_1_41_2434(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2435 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// starting to compile block node (depth = 5)
  Object block2436 = alloc_Block(NULL, NULL, "collectionsPrelude", 1239);
  gc_frame_newslot(block2436);
// method "_apply"
  block_savedest(block2436);
  Object closure2437 = createclosure(3, "_apply");
  setclosureframe(closure2437, stackframe);
  addtoclosure(closure2437, var_x);
  addtoclosure(closure2437, var_NoSuchObject);
  addtoclosure(closure2437, selfslot);
  struct UserObject *uo2437 = (struct UserObject*)block2436;
  uo2437->data[0] = (Object)closure2437;
  Method *meth_meth_collectionsPrelude__apply2437 = addmethod2pos(block2436, "_apply", &meth_collectionsPrelude__apply2437, 0);
  int argcv_meth_collectionsPrelude__apply2437[] = {0};
  meth_meth_collectionsPrelude__apply2437->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2437);
  meth_meth_collectionsPrelude__apply2437->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2437->definitionLine = 1991;
// compiled block node returning block2436 (depth = 5)
  gc_frame_newslot(block2436);
// call case 4: self request
  params[0] = *var_x;
  params[1] = block2436;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2449 = callmethodflags(self, "remove(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2435);
// compiled call node returning call2449 (depth = 4)
  gc_frame_end(frame);
  return call2449;
}
Object meth_collectionsPrelude_removeAll_40_1_41_2431(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elements = &(stackframe->slots[0]);
  *var_elements = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1238
  setline(1238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2432 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elements (depth = 3)
  gc_frame_newslot(*var_elements);
// starting to compile block node (depth = 3)
  Object block2433 = alloc_Block(NULL, NULL, "collectionsPrelude", 1238);
  gc_frame_newslot(block2433);
// method "_apply(_)"
  block_savedest(block2433);
  Object closure2434 = createclosure(2, "_apply(1)");
  setclosureframe(closure2434, stackframe);
  addtoclosure(closure2434, var_NoSuchObject);
  addtoclosure(closure2434, selfslot);
  struct UserObject *uo2434 = (struct UserObject*)block2433;
  uo2434->data[0] = (Object)closure2434;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2434 = addmethod2pos(block2433, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2434, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2434[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2434->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2434);
  meth_meth_collectionsPrelude__apply_40_1_41_2434->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2434->definitionLine = 1991;
// compiled block node returning block2433 (depth = 3)
  gc_frame_newslot(block2433);
// call case 5: prelude request
  params[0] = *var_elements;
  params[1] = block2433;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2451 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2432);
// compiled call node returning call2451 (depth = 2)
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_1_41_2463(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_block = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2464 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2465 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2464);
// compiled call node returning call2465 (depth = 5)
  *var_t = call2465;
  if (call2465 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_2467 = gc_frame_newslot(*var_x);
// starting to compile call node (depth = 6)
  int callframe2469 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2470 = gc_frame_new();
// call case 4: self request
  Object call2471 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2470);
// compiled member node returning call2471 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2472 = callmethodflags(call2471, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2469);
// compiled call node returning call2472 (depth = 6)
  int op_slot_left_2467 = gc_frame_newslot(call2472);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2473 = callmethod(call2472, "==(1)", 1, partcv, params);
// compiled op node returning opresult2473 (depth = 5)
  Object if2466 = done;
  if (istrue(opresult2473)) {
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2474 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2475 = gc_frame_new();
// call case 4: self request
  Object call2476 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2475);
// compiled member node returning call2476 (depth = 6)
  params[0] = *var_t;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2477 = callmethodflags(call2476, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2474);
// compiled call node returning call2477 (depth = 5)
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2478 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2480 = alloc_Float64(1);
// compiled num node returning num2480 (depth = 7)
  int op_slot_right_2479 = gc_frame_newslot(num2480);
// starting to compile member node (depth = 7)
  int callframe2482 = gc_frame_new();
// call case 4: self request
  Object call2483 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2482);
// compiled member node returning call2483 (depth = 7)
  int op_slot_left_2479 = gc_frame_newslot(call2483);
  params[0] = num2480;
  partcv[0] = 1;
  Object diff2484 = callmethod(call2483, "-(1)", 1, partcv, params);
// compiled op node returning diff2484 (depth = 6)
  gc_frame_newslot(diff2484);
// call case 4: self request
  params[0] = diff2484;
  partcv[0] = 1;
  Object call2485 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2478);
// compiled call node returning call2485 (depth = 5)
    gc_frame_newslot(call2485);
    if2466 = call2485;
  } else {
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2486 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block (depth = 6)
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2487 = callmethodflags(*var_block, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2486);
// compiled call node returning call2487 (depth = 5)
    gc_frame_newslot(call2487);
    if2466 = call2487;
  }
// compiled if node returning if2466 (depth = 4)
  gc_frame_end(frame);
  return if2466;
}
Object meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2452(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAll(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for removeAll(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_elements = &(stackframe->slots[0]);
  *var_elements = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAll(_)");
  Object *var_block = &(stackframe->slots[1]);
  *var_block = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2453 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2455 = alloc_Float64(1);
// compiled num node returning num2455 (depth = 4)
  int op_slot_right_2454 = gc_frame_newslot(num2455);
// starting to compile member node (depth = 4)
  int callframe2457 = gc_frame_new();
// call case 4: self request
  Object call2458 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2457);
// compiled member node returning call2458 (depth = 4)
  int op_slot_left_2454 = gc_frame_newslot(call2458);
  params[0] = num2455;
  partcv[0] = 1;
  Object sum2459 = callmethod(call2458, "+(1)", 1, partcv, params);
// compiled op node returning sum2459 (depth = 3)
  gc_frame_newslot(sum2459);
// call case 4: self request
  params[0] = sum2459;
  partcv[0] = 1;
  Object call2460 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2453);
// compiled call node returning call2460 (depth = 2)
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2461 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elements (depth = 3)
  gc_frame_newslot(*var_elements);
// starting to compile block node (depth = 3)
  Object block2462 = alloc_Block(NULL, NULL, "collectionsPrelude", 1247);
  gc_frame_newslot(block2462);
// method "_apply(_)"
  block_savedest(block2462);
  Object closure2463 = createclosure(3, "_apply(1)");
  setclosureframe(closure2463, stackframe);
  addtoclosure(closure2463, var_removed);
  addtoclosure(closure2463, var_block);
  addtoclosure(closure2463, selfslot);
  struct UserObject *uo2463 = (struct UserObject*)block2462;
  uo2463->data[0] = (Object)closure2463;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2463 = addmethod2pos(block2462, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2463, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2463[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2463->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2463);
  meth_meth_collectionsPrelude__apply_40_1_41_2463->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2463->definitionLine = 1991;
// compiled block node returning block2462 (depth = 3)
  gc_frame_newslot(block2462);
// call case 5: prelude request
  params[0] = *var_elements;
  params[1] = block2462;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2489 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2461);
// compiled call node returning call2489 (depth = 2)
// Begin line 1256
  setline(1256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_clear2490(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "clear");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_cap = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1259
  setline(1259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2491 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2493 = alloc_Float64(1);
// compiled num node returning num2493 (depth = 4)
  int op_slot_right_2492 = gc_frame_newslot(num2493);
// starting to compile member node (depth = 4)
  int callframe2495 = gc_frame_new();
// call case 4: self request
  Object call2496 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2495);
// compiled member node returning call2496 (depth = 4)
  int op_slot_left_2492 = gc_frame_newslot(call2496);
  params[0] = num2493;
  partcv[0] = 1;
  Object sum2497 = callmethod(call2496, "+(1)", 1, partcv, params);
// compiled op node returning sum2497 (depth = 3)
  gc_frame_newslot(sum2497);
// call case 4: self request
  params[0] = sum2497;
  partcv[0] = 1;
  Object call2498 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2491);
// compiled call node returning call2498 (depth = 2)
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2499 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe2500 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cap (depth = 4)
  gc_frame_newslot(*var_cap);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2501 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  Object call2502 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe2501);
// compiled member node returning call2502 (depth = 4)
  params[0] = *var_cap;
  partcv[0] = 1;
  Object call2503 = callmethodflags(call2502, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2500);
// compiled call node returning call2503 (depth = 3)
  gc_frame_newslot(call2503);
// call case 4: self request
  params[0] = call2503;
  partcv[0] = 1;
  Object call2504 = callmethodflags(self, "inner:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2499);
// compiled call node returning call2504 (depth = 2)
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2505 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num2506 = alloc_Float64(0);
// compiled num node returning num2506 (depth = 3)
  gc_frame_newslot(num2506);
// call case 4: self request
  params[0] = num2506;
  partcv[0] = 1;
  Object call2507 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2505);
// compiled call node returning call2507 (depth = 2)
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2508(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "remove(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for remove(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part remove(_)");
  Object *var_block = &(stackframe->slots[1]);
  *var_block = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "t");
// Begin line 1266
  setline(1266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2509 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elt (depth = 4)
  gc_frame_newslot(*var_elt);
// call case 4: self request
  params[0] = *var_elt;
  partcv[0] = 1;
  Object call2510 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2509);
// compiled call node returning call2510 (depth = 3)
  *var_t = call2510;
  if (call2510 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elt (depth = 4)
  int op_slot_right_2512 = gc_frame_newslot(*var_elt);
// starting to compile call node (depth = 4)
  int callframe2514 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_t (depth = 5)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2515 = gc_frame_new();
// call case 4: self request
  Object call2516 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2515);
// compiled member node returning call2516 (depth = 5)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2517 = callmethodflags(call2516, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2514);
// compiled call node returning call2517 (depth = 4)
  int op_slot_left_2512 = gc_frame_newslot(call2517);
  params[0] = *var_elt;
  partcv[0] = 1;
  Object opresult2518 = callmethod(call2517, "==(1)", 1, partcv, params);
// compiled op node returning opresult2518 (depth = 3)
  Object if2511 = done;
  if (istrue(opresult2518)) {
// Begin line 1268
  setline(1268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2519 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_removed (depth = 4)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2520 = gc_frame_new();
// call case 4: self request
  Object call2521 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2520);
// compiled member node returning call2521 (depth = 4)
  params[0] = *var_t;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2522 = callmethodflags(call2521, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2519);
// compiled call node returning call2522 (depth = 3)
// Begin line 1269
  setline(1269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2523 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2525 = alloc_Float64(1);
// compiled num node returning num2525 (depth = 5)
  int op_slot_right_2524 = gc_frame_newslot(num2525);
// starting to compile member node (depth = 5)
  int callframe2527 = gc_frame_new();
// call case 4: self request
  Object call2528 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2527);
// compiled member node returning call2528 (depth = 5)
  int op_slot_left_2524 = gc_frame_newslot(call2528);
  params[0] = num2525;
  partcv[0] = 1;
  Object sum2529 = callmethod(call2528, "+(1)", 1, partcv, params);
// compiled op node returning sum2529 (depth = 4)
  gc_frame_newslot(sum2529);
// call case 4: self request
  params[0] = sum2529;
  partcv[0] = 1;
  Object call2530 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2523);
// compiled call node returning call2530 (depth = 3)
// Begin line 1270
  setline(1270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2531 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2533 = alloc_Float64(1);
// compiled num node returning num2533 (depth = 5)
  int op_slot_right_2532 = gc_frame_newslot(num2533);
// starting to compile member node (depth = 5)
  int callframe2535 = gc_frame_new();
// call case 4: self request
  Object call2536 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2535);
// compiled member node returning call2536 (depth = 5)
  int op_slot_left_2532 = gc_frame_newslot(call2536);
  params[0] = num2533;
  partcv[0] = 1;
  Object diff2537 = callmethod(call2536, "-(1)", 1, partcv, params);
// compiled op node returning diff2537 (depth = 4)
  gc_frame_newslot(diff2537);
// call case 4: self request
  params[0] = diff2537;
  partcv[0] = 1;
  Object call2538 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2531);
// compiled call node returning call2538 (depth = 3)
    gc_frame_newslot(call2538);
    if2511 = call2538;
  } else {
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe2539 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_block (depth = 4)
  Object call2540 = callmethodflags(*var_block, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe2539);
// compiled member node returning call2540 (depth = 3)
    gc_frame_newslot(call2540);
    if2511 = call2540;
  }
// compiled if node returning if2511 (depth = 2)
// Begin line 1274
  setline(1274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply2544(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elt = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1279
  setline(1279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2545 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2547 == NULL) {
    strlit2547 = alloc_String("");
    gc_root(strlit2547);
  }
// compiled string node returning strlit2547 (depth = 6)
  int op_slot_right_2546 = gc_frame_newslot(strlit2547);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_elt (depth = 7)
  int op_slot_right_2549 = gc_frame_newslot(*var_elt);
// starting to compile string node (depth = 7)
  if (strlit2551 == NULL) {
    strlit2551 = alloc_String("set does not contain ");
    gc_root(strlit2551);
  }
// compiled string node returning strlit2551 (depth = 7)
  int op_slot_left_2549 = gc_frame_newslot(strlit2551);
  params[0] = *var_elt;
  partcv[0] = 1;
  Object opresult2552 = callmethod(strlit2551, "++(1)", 1, partcv, params);
// compiled op node returning opresult2552 (depth = 6)
  int op_slot_left_2546 = gc_frame_newslot(opresult2552);
  params[0] = strlit2547;
  partcv[0] = 1;
  Object opresult2553 = callmethod(opresult2552, "++(1)", 1, partcv, params);
// compiled op node returning opresult2553 (depth = 5)
  gc_frame_newslot(opresult2553);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_NoSuchObject (depth = 5)
  params[0] = opresult2553;
  partcv[0] = 1;
  Object call2554 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2545);
// compiled call node returning call2554 (depth = 4)
  gc_frame_end(frame);
  return call2554;
}
Object meth_collectionsPrelude_remove_40_1_41_2541(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "remove(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for remove(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part remove(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2542 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elt (depth = 3)
  gc_frame_newslot(*var_elt);
// starting to compile block node (depth = 3)
  Object block2543 = alloc_Block(NULL, NULL, "collectionsPrelude", 1278);
  gc_frame_newslot(block2543);
// method "_apply"
  block_savedest(block2543);
  Object closure2544 = createclosure(3, "_apply");
  setclosureframe(closure2544, stackframe);
  addtoclosure(closure2544, var_elt);
  addtoclosure(closure2544, var_NoSuchObject);
  addtoclosure(closure2544, selfslot);
  struct UserObject *uo2544 = (struct UserObject*)block2543;
  uo2544->data[0] = (Object)closure2544;
  Method *meth_meth_collectionsPrelude__apply2544 = addmethod2pos(block2543, "_apply", &meth_collectionsPrelude__apply2544, 0);
  int argcv_meth_collectionsPrelude__apply2544[] = {0};
  meth_meth_collectionsPrelude__apply2544->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2544);
  meth_meth_collectionsPrelude__apply2544->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2544->definitionLine = 1991;
// compiled block node returning block2543 (depth = 3)
  gc_frame_newslot(block2543);
// call case 4: self request
  params[0] = *var_elt;
  params[1] = block2543;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2556 = callmethodflags(self, "remove(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2542);
// compiled call node returning call2556 (depth = 2)
// Begin line 1281
  setline(1281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_contains_40_1_41_2557(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2558 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2559 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2558);
// compiled call node returning call2559 (depth = 3)
  *var_t = call2559;
  if (call2559 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  int op_slot_right_2561 = gc_frame_newslot(*var_x);
// starting to compile call node (depth = 4)
  int callframe2563 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_t (depth = 5)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2564 = gc_frame_new();
// call case 4: self request
  Object call2565 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2564);
// compiled member node returning call2565 (depth = 5)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2566 = callmethodflags(call2565, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2563);
// compiled call node returning call2566 (depth = 4)
  int op_slot_left_2561 = gc_frame_newslot(call2566);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2567 = callmethod(call2566, "==(1)", 1, partcv, params);
// compiled op node returning opresult2567 (depth = 3)
  Object if2560 = done;
  if (istrue(opresult2567)) {
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool2568 = alloc_Boolean(1);
// compiled identifier node returning bool2568 (depth = 4)
  return bool2568;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if2560 = undefined;
  } else {
  }
// compiled if node returning if2560 (depth = 2)
// Begin line 1289
  setline(1289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2569 = alloc_Boolean(0);
// compiled identifier node returning bool2569 (depth = 3)
  return bool2569;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_1_41_2573(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_booleanBlock = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1293
  setline(1293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2575 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_booleanBlock (depth = 6)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2576 = callmethodflags(*var_booleanBlock, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2575);
// compiled call node returning call2576 (depth = 5)
  Object if2574 = done;
  if (istrue(call2576)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool2577 = alloc_Boolean(1);
// compiled identifier node returning bool2577 (depth = 6)
  block_return(realself, bool2577);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2574 = undefined;
  } else {
  }
// compiled if node returning if2574 (depth = 4)
  gc_frame_end(frame);
  return if2574;
}
Object meth_collectionsPrelude_includes_40_1_41_2570(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "includes(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method includes(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for includes(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_booleanBlock = &(stackframe->slots[0]);
  *var_booleanBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part includes(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1292
  setline(1292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2571 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2572 = alloc_Block(NULL, NULL, "collectionsPrelude", 1292);
  gc_frame_newslot(block2572);
// method "_apply(_)"
  block_savedest(block2572);
  Object closure2573 = createclosure(2, "_apply(1)");
  setclosureframe(closure2573, stackframe);
  addtoclosure(closure2573, var_booleanBlock);
  addtoclosure(closure2573, selfslot);
  struct UserObject *uo2573 = (struct UserObject*)block2572;
  uo2573->data[0] = (Object)closure2573;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2573 = addmethod2pos(block2572, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2573, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2573[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2573->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2573);
  meth_meth_collectionsPrelude__apply_40_1_41_2573->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2573->definitionLine = 1991;
// compiled block node returning block2572 (depth = 3)
  gc_frame_newslot(block2572);
// call case 4: self request
  params[0] = block2572;
  partcv[0] = 1;
  Object call2579 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2571);
// compiled call node returning call2579 (depth = 2)
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2580 = alloc_Boolean(0);
// compiled identifier node returning bool2580 (depth = 3)
  return bool2580;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_1_41_2584(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_booleanBlock = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2586 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_booleanBlock (depth = 6)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2587 = callmethodflags(*var_booleanBlock, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2586);
// compiled call node returning call2587 (depth = 5)
  Object if2585 = done;
  if (istrue(call2587)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  block_return(realself, *var_each);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2585 = undefined;
  } else {
  }
// compiled if node returning if2585 (depth = 4)
  gc_frame_end(frame);
  return if2585;
}
Object meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2581(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "find(1)ifNone(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method find(_)ifNone(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method find(_)ifNone(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for find(_)ifNone(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_booleanBlock = &(stackframe->slots[0]);
  *var_booleanBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part find(_)");
  Object *var_notFoundBlock = &(stackframe->slots[1]);
  *var_notFoundBlock = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifNone(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2582 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2583 = alloc_Block(NULL, NULL, "collectionsPrelude", 1298);
  gc_frame_newslot(block2583);
// method "_apply(_)"
  block_savedest(block2583);
  Object closure2584 = createclosure(2, "_apply(1)");
  setclosureframe(closure2584, stackframe);
  addtoclosure(closure2584, var_booleanBlock);
  addtoclosure(closure2584, selfslot);
  struct UserObject *uo2584 = (struct UserObject*)block2583;
  uo2584->data[0] = (Object)closure2584;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2584 = addmethod2pos(block2583, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2584, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2584[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2584->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2584);
  meth_meth_collectionsPrelude__apply_40_1_41_2584->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2584->definitionLine = 1991;
// compiled block node returning block2583 (depth = 3)
  gc_frame_newslot(block2583);
// call case 4: self request
  params[0] = block2583;
  partcv[0] = 1;
  Object call2589 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2582);
// compiled call node returning call2589 (depth = 2)
// Begin line 1301
  setline(1301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2590 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_notFoundBlock (depth = 4)
  Object call2591 = callmethodflags(*var_notFoundBlock, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe2590);
// compiled member node returning call2591 (depth = 3)
  return call2591;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply2605(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2606 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2607 = gc_frame_new();
// call case 4: self request
  Object call2608 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2607);
// compiled member node returning call2608 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2609 = callmethodflags(call2608, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2606);
// compiled call node returning call2609 (depth = 5)
  *var_candidate = call2609;
  if (call2609 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1311
  setline(1311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_candidate (depth = 5)
  int op_slot_right_2611 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  int op_slot_left_2611 = gc_frame_newslot(*var_unused);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2613 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2613 (depth = 4)
  gc_frame_end(frame);
  return opresult2613;
}
Object meth_collectionsPrelude__apply2616(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_t = getfromclosure(closure, 2);
  Object *var_jump = getfromclosure(closure, 3);
  Object *var_s = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1313
  setline(1313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_2618 = gc_frame_newslot(*var_x);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_left_2618 = gc_frame_newslot(*var_candidate);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2620 = callmethod(*var_candidate, "==(1)", 1, partcv, params);
// compiled op node returning opresult2620 (depth = 5)
  Object if2617 = done;
  if (istrue(opresult2620)) {
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2617 = undefined;
  } else {
  }
// compiled if node returning if2617 (depth = 4)
// Begin line 1316
  setline(1316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2623 = alloc_Float64(0);
// compiled num node returning num2623 (depth = 6)
  int op_slot_right_2622 = gc_frame_newslot(num2623);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_2622 = gc_frame_newslot(*var_jump);
  params[0] = num2623;
  partcv[0] = 1;
  Object opresult2625 = callmethod(*var_jump, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2625 (depth = 5)
  Object if2621 = done;
  if (istrue(opresult2625)) {
// Begin line 1317
  setline(1317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2626 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2629 = alloc_Float64(1);
// compiled num node returning num2629 (depth = 8)
  int op_slot_right_2628 = gc_frame_newslot(num2629);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2632 = alloc_Float64(3);
// compiled num node returning num2632 (depth = 9)
  int op_slot_right_2631 = gc_frame_newslot(num2632);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_2631 = gc_frame_newslot(*var_t);
  params[0] = num2632;
  partcv[0] = 1;
  Object prod2634 = callmethod(*var_t, "*(1)", 1, partcv, params);
// compiled op node returning prod2634 (depth = 8)
  int op_slot_left_2628 = gc_frame_newslot(prod2634);
  params[0] = num2629;
  partcv[0] = 1;
  Object sum2635 = callmethod(prod2634, "+(1)", 1, partcv, params);
// compiled op node returning sum2635 (depth = 7)
  int op_slot_left_2626 = gc_frame_newslot(sum2635);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2636 = callmethod(sum2635, "%(1)", 1, partcv, params);
// compiled op node returning modulus2636 (depth = 6)
  *var_t = modulus2636;
  if (modulus2636 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2639 = alloc_Float64(1);
// compiled num node returning num2639 (depth = 7)
  int op_slot_right_2638 = gc_frame_newslot(num2639);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_2638 = gc_frame_newslot(*var_jump);
  params[0] = num2639;
  partcv[0] = 1;
  Object diff2641 = callmethod(*var_jump, "-(1)", 1, partcv, params);
// compiled op node returning diff2641 (depth = 6)
  *var_jump = diff2641;
  if (diff2641 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2621 = done;
  } else {
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2643 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2646 = alloc_Float64(1);
// compiled num node returning num2646 (depth = 8)
  int op_slot_right_2645 = gc_frame_newslot(num2646);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_2645 = gc_frame_newslot(*var_t);
  params[0] = num2646;
  partcv[0] = 1;
  Object sum2648 = callmethod(*var_t, "+(1)", 1, partcv, params);
// compiled op node returning sum2648 (depth = 7)
  int op_slot_left_2643 = gc_frame_newslot(sum2648);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2649 = callmethod(sum2648, "%(1)", 1, partcv, params);
// compiled op node returning modulus2649 (depth = 6)
  *var_t = modulus2649;
  if (modulus2649 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2621 = done;
  }
// compiled if node returning if2621 (depth = 4)
  gc_frame_end(frame);
  return if2621;
}
Object meth_collectionsPrelude_findPosition_40_1_41_2592(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findPosition(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findPosition(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findPosition(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findPosition(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
  Object *var_candidate = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "candidate");
// Begin line 1304
  setline(1304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2593 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  Object call2594 = callmethodflags(*var_x, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe2593);
// compiled member node returning call2594 (depth = 3)
  *var_h = call2594;
  if (call2594 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1305
  setline(1305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2595 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2596 = gc_frame_new();
// call case 4: self request
  Object call2597 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2596);
// compiled member node returning call2597 (depth = 4)
  Object call2598 = callmethodflags(call2597, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2595);
// compiled member node returning call2598 (depth = 3)
  *var_s = call2598;
  if (call2598 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_2599 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_2599 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2601 = callmethod(*var_h, "%(1)", 1, partcv, params);
// compiled op node returning modulus2601 (depth = 3)
  *var_t = modulus2601;
  if (modulus2601 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1307
  setline(1307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2602 = alloc_Float64(5);
// compiled num node returning num2602 (depth = 3)
  *var_jump = num2602;
  if (num2602 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1308
  setline(1308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1309
  setline(1309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2603 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2604 = alloc_Block(NULL, NULL, "collectionsPrelude", 1309);
  gc_frame_newslot(block2604);
// method "_apply"
  block_savedest(block2604);
  Object closure2605 = createclosure(4, "_apply");
  setclosureframe(closure2605, stackframe);
  addtoclosure(closure2605, var_t);
  addtoclosure(closure2605, var_candidate);
  addtoclosure(closure2605, var_unused);
  addtoclosure(closure2605, selfslot);
  struct UserObject *uo2605 = (struct UserObject*)block2604;
  uo2605->data[0] = (Object)closure2605;
  Method *meth_meth_collectionsPrelude__apply2605 = addmethod2pos(block2604, "_apply", &meth_collectionsPrelude__apply2605, 0);
  int argcv_meth_collectionsPrelude__apply2605[] = {0};
  meth_meth_collectionsPrelude__apply2605->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2605);
  meth_meth_collectionsPrelude__apply2605->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2605->definitionLine = 1991;
// compiled block node returning block2604 (depth = 3)
  gc_frame_newslot(block2604);
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2615 = alloc_Block(NULL, NULL, "collectionsPrelude", 1312);
  gc_frame_newslot(block2615);
// method "_apply"
  block_savedest(block2615);
  Object closure2616 = createclosure(6, "_apply");
  setclosureframe(closure2616, stackframe);
  addtoclosure(closure2616, var_x);
  addtoclosure(closure2616, var_candidate);
  addtoclosure(closure2616, var_t);
  addtoclosure(closure2616, var_jump);
  addtoclosure(closure2616, var_s);
  addtoclosure(closure2616, selfslot);
  struct UserObject *uo2616 = (struct UserObject*)block2615;
  uo2616->data[0] = (Object)closure2616;
  Method *meth_meth_collectionsPrelude__apply2616 = addmethod2pos(block2615, "_apply", &meth_collectionsPrelude__apply2616, 0);
  int argcv_meth_collectionsPrelude__apply2616[] = {0};
  meth_meth_collectionsPrelude__apply2616->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2616);
  meth_meth_collectionsPrelude__apply2616->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2616->definitionLine = 1991;
// compiled block node returning block2615 (depth = 3)
  gc_frame_newslot(block2615);
// call case 5: prelude request
  params[0] = block2604;
  params[1] = block2615;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2652 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2603);
// compiled call node returning call2652 (depth = 2)
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply2666(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2667 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2668 = gc_frame_new();
// call case 4: self request
  Object call2669 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2668);
// compiled member node returning call2669 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2670 = callmethodflags(call2669, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2667);
// compiled call node returning call2670 (depth = 5)
  *var_candidate = call2670;
  if (call2670 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1333
  setline(1333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_right_2673 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  int op_slot_left_2673 = gc_frame_newslot(*var_removed);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2675 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2675 (depth = 5)
  int op_slot_right_2672 = gc_frame_newslot(opresult2675);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_right_2677 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unused (depth = 6)
  int op_slot_left_2677 = gc_frame_newslot(*var_unused);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2679 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2679 (depth = 5)
  int op_slot_left_2672 = gc_frame_newslot(opresult2679);
  params[0] = opresult2675;
  partcv[0] = 1;
  Object opresult2680 = callmethod(opresult2679, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2680 (depth = 4)
  gc_frame_end(frame);
  return opresult2680;
}
Object meth_collectionsPrelude__apply2683(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_t = getfromclosure(closure, 2);
  Object *var_jump = getfromclosure(closure, 3);
  Object *var_s = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1335
  setline(1335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_2685 = gc_frame_newslot(*var_x);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_left_2685 = gc_frame_newslot(*var_candidate);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2687 = callmethod(*var_candidate, "==(1)", 1, partcv, params);
// compiled op node returning opresult2687 (depth = 5)
  Object if2684 = done;
  if (istrue(opresult2687)) {
// Begin line 1336
  setline(1336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2684 = undefined;
  } else {
  }
// compiled if node returning if2684 (depth = 4)
// Begin line 1338
  setline(1338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2690 = alloc_Float64(0);
// compiled num node returning num2690 (depth = 6)
  int op_slot_right_2689 = gc_frame_newslot(num2690);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_2689 = gc_frame_newslot(*var_jump);
  params[0] = num2690;
  partcv[0] = 1;
  Object opresult2692 = callmethod(*var_jump, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2692 (depth = 5)
  Object if2688 = done;
  if (istrue(opresult2692)) {
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2693 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2696 = alloc_Float64(1);
// compiled num node returning num2696 (depth = 8)
  int op_slot_right_2695 = gc_frame_newslot(num2696);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2699 = alloc_Float64(3);
// compiled num node returning num2699 (depth = 9)
  int op_slot_right_2698 = gc_frame_newslot(num2699);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_2698 = gc_frame_newslot(*var_t);
  params[0] = num2699;
  partcv[0] = 1;
  Object prod2701 = callmethod(*var_t, "*(1)", 1, partcv, params);
// compiled op node returning prod2701 (depth = 8)
  int op_slot_left_2695 = gc_frame_newslot(prod2701);
  params[0] = num2696;
  partcv[0] = 1;
  Object sum2702 = callmethod(prod2701, "+(1)", 1, partcv, params);
// compiled op node returning sum2702 (depth = 7)
  int op_slot_left_2693 = gc_frame_newslot(sum2702);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2703 = callmethod(sum2702, "%(1)", 1, partcv, params);
// compiled op node returning modulus2703 (depth = 6)
  *var_t = modulus2703;
  if (modulus2703 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2706 = alloc_Float64(1);
// compiled num node returning num2706 (depth = 7)
  int op_slot_right_2705 = gc_frame_newslot(num2706);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_2705 = gc_frame_newslot(*var_jump);
  params[0] = num2706;
  partcv[0] = 1;
  Object diff2708 = callmethod(*var_jump, "-(1)", 1, partcv, params);
// compiled op node returning diff2708 (depth = 6)
  *var_jump = diff2708;
  if (diff2708 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2688 = done;
  } else {
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2710 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2713 = alloc_Float64(1);
// compiled num node returning num2713 (depth = 8)
  int op_slot_right_2712 = gc_frame_newslot(num2713);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_2712 = gc_frame_newslot(*var_t);
  params[0] = num2713;
  partcv[0] = 1;
  Object sum2715 = callmethod(*var_t, "+(1)", 1, partcv, params);
// compiled op node returning sum2715 (depth = 7)
  int op_slot_left_2710 = gc_frame_newslot(sum2715);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2716 = callmethod(sum2715, "%(1)", 1, partcv, params);
// compiled op node returning modulus2716 (depth = 6)
  *var_t = modulus2716;
  if (modulus2716 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2688 = done;
  }
// compiled if node returning if2688 (depth = 4)
  gc_frame_end(frame);
  return if2688;
}
Object meth_collectionsPrelude_findPositionForAdd_40_1_41_2653(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findPositionForAdd(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findPositionForAdd(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findPositionForAdd(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findPositionForAdd(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
  Object *var_candidate = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "candidate");
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2654 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  Object call2655 = callmethodflags(*var_x, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe2654);
// compiled member node returning call2655 (depth = 3)
  *var_h = call2655;
  if (call2655 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1327
  setline(1327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2656 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2657 = gc_frame_new();
// call case 4: self request
  Object call2658 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2657);
// compiled member node returning call2658 (depth = 4)
  Object call2659 = callmethodflags(call2658, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2656);
// compiled member node returning call2659 (depth = 3)
  *var_s = call2659;
  if (call2659 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_2660 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_2660 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2662 = callmethod(*var_h, "%(1)", 1, partcv, params);
// compiled op node returning modulus2662 (depth = 3)
  *var_t = modulus2662;
  if (modulus2662 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2663 = alloc_Float64(5);
// compiled num node returning num2663 (depth = 3)
  *var_jump = num2663;
  if (num2663 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1330
  setline(1330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1331
  setline(1331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2664 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2665 = alloc_Block(NULL, NULL, "collectionsPrelude", 1331);
  gc_frame_newslot(block2665);
// method "_apply"
  block_savedest(block2665);
  Object closure2666 = createclosure(5, "_apply");
  setclosureframe(closure2666, stackframe);
  addtoclosure(closure2666, var_t);
  addtoclosure(closure2666, var_candidate);
  addtoclosure(closure2666, var_removed);
  addtoclosure(closure2666, var_unused);
  addtoclosure(closure2666, selfslot);
  struct UserObject *uo2666 = (struct UserObject*)block2665;
  uo2666->data[0] = (Object)closure2666;
  Method *meth_meth_collectionsPrelude__apply2666 = addmethod2pos(block2665, "_apply", &meth_collectionsPrelude__apply2666, 0);
  int argcv_meth_collectionsPrelude__apply2666[] = {0};
  meth_meth_collectionsPrelude__apply2666->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2666);
  meth_meth_collectionsPrelude__apply2666->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2666->definitionLine = 1991;
// compiled block node returning block2665 (depth = 3)
  gc_frame_newslot(block2665);
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2682 = alloc_Block(NULL, NULL, "collectionsPrelude", 1334);
  gc_frame_newslot(block2682);
// method "_apply"
  block_savedest(block2682);
  Object closure2683 = createclosure(6, "_apply");
  setclosureframe(closure2683, stackframe);
  addtoclosure(closure2683, var_x);
  addtoclosure(closure2683, var_candidate);
  addtoclosure(closure2683, var_t);
  addtoclosure(closure2683, var_jump);
  addtoclosure(closure2683, var_s);
  addtoclosure(closure2683, selfslot);
  struct UserObject *uo2683 = (struct UserObject*)block2682;
  uo2683->data[0] = (Object)closure2683;
  Method *meth_meth_collectionsPrelude__apply2683 = addmethod2pos(block2682, "_apply", &meth_collectionsPrelude__apply2683, 0);
  int argcv_meth_collectionsPrelude__apply2683[] = {0};
  meth_meth_collectionsPrelude__apply2683->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2683);
  meth_meth_collectionsPrelude__apply2683->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2683->definitionLine = 1991;
// compiled block node returning block2682 (depth = 3)
  gc_frame_newslot(block2682);
// call case 5: prelude request
  params[0] = block2665;
  params[1] = block2682;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2719 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2664);
// compiled call node returning call2719 (depth = 2)
// Begin line 1345
  setline(1345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_1_41_2724(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2726 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  Object call2727 = callmethodflags(*var_each, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe2726);
// compiled member node returning call2727 (depth = 6)
  int op_slot_right_2725 = gc_frame_newslot(call2727);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2725 = gc_frame_newslot(*var_s);
  params[0] = call2727;
  partcv[0] = 1;
  Object opresult2729 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2729 (depth = 5)
  *var_s = opresult2729;
  if (opresult2729 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply2733(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2735 == NULL) {
    strlit2735 = alloc_String(", ");
    gc_root(strlit2735);
  }
// compiled string node returning strlit2735 (depth = 6)
  int op_slot_right_2734 = gc_frame_newslot(strlit2735);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2734 = gc_frame_newslot(*var_s);
  params[0] = strlit2735;
  partcv[0] = 1;
  Object opresult2737 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2737 (depth = 5)
  *var_s = opresult2737;
  if (opresult2737 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_asString2720(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1349
  setline(1349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2721 == NULL) {
    strlit2721 = alloc_String("set{");
    gc_root(strlit2721);
  }
// compiled string node returning strlit2721 (depth = 3)
  *var_s = strlit2721;
  if (strlit2721 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1350
  setline(1350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2722 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2723 = alloc_Block(NULL, NULL, "collectionsPrelude", 1350);
  gc_frame_newslot(block2723);
// method "_apply(_)"
  block_savedest(block2723);
  Object closure2724 = createclosure(2, "_apply(1)");
  setclosureframe(closure2724, stackframe);
  addtoclosure(closure2724, var_s);
  addtoclosure(closure2724, selfslot);
  struct UserObject *uo2724 = (struct UserObject*)block2723;
  uo2724->data[0] = (Object)closure2724;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2724 = addmethod2pos(block2723, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2724, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2724[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2724->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2724);
  meth_meth_collectionsPrelude__apply_40_1_41_2724->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2724->definitionLine = 1991;
// compiled block node returning block2723 (depth = 3)
  gc_frame_newslot(block2723);
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2732 = alloc_Block(NULL, NULL, "collectionsPrelude", 1351);
  gc_frame_newslot(block2732);
// method "_apply"
  block_savedest(block2732);
  Object closure2733 = createclosure(2, "_apply");
  setclosureframe(closure2733, stackframe);
  addtoclosure(closure2733, var_s);
  addtoclosure(closure2733, selfslot);
  struct UserObject *uo2733 = (struct UserObject*)block2732;
  uo2733->data[0] = (Object)closure2733;
  Method *meth_meth_collectionsPrelude__apply2733 = addmethod2pos(block2732, "_apply", &meth_collectionsPrelude__apply2733, 0);
  int argcv_meth_collectionsPrelude__apply2733[] = {0};
  meth_meth_collectionsPrelude__apply2733->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2733);
  meth_meth_collectionsPrelude__apply2733->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2733->definitionLine = 1991;
// compiled block node returning block2732 (depth = 3)
  gc_frame_newslot(block2732);
// call case 4: self request
  params[0] = block2723;
  params[1] = block2732;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2740 = callmethodflags(self, "do(1)separatedBy(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2722);
// compiled call node returning call2740 (depth = 2)
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2742 == NULL) {
    strlit2742 = alloc_String("}");
    gc_root(strlit2742);
  }
// compiled string node returning strlit2742 (depth = 3)
  int op_slot_right_2741 = gc_frame_newslot(strlit2742);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_2741 = gc_frame_newslot(*var_s);
  params[0] = strlit2742;
  partcv[0] = 1;
  Object opresult2744 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2744 (depth = 2)
  gc_frame_end(frame);
  return opresult2744;
}
Object meth_collectionsPrelude__apply_40_1_41_2749(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2751 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  Object call2752 = callmethodflags(*var_each, "asDebugString", 0, partcv, params, 0);
  gc_frame_end(callframe2751);
// compiled member node returning call2752 (depth = 6)
  int op_slot_right_2750 = gc_frame_newslot(call2752);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2750 = gc_frame_newslot(*var_s);
  params[0] = call2752;
  partcv[0] = 1;
  Object opresult2754 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2754 (depth = 5)
  *var_s = opresult2754;
  if (opresult2754 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply2758(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2760 == NULL) {
    strlit2760 = alloc_String(", ");
    gc_root(strlit2760);
  }
// compiled string node returning strlit2760 (depth = 6)
  int op_slot_right_2759 = gc_frame_newslot(strlit2760);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2759 = gc_frame_newslot(*var_s);
  params[0] = strlit2760;
  partcv[0] = 1;
  Object opresult2762 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2762 (depth = 5)
  *var_s = opresult2762;
  if (opresult2762 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_asDebugString2745(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2746 == NULL) {
    strlit2746 = alloc_String("set{");
    gc_root(strlit2746);
  }
// compiled string node returning strlit2746 (depth = 3)
  *var_s = strlit2746;
  if (strlit2746 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2747 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2748 = alloc_Block(NULL, NULL, "collectionsPrelude", 1356);
  gc_frame_newslot(block2748);
// method "_apply(_)"
  block_savedest(block2748);
  Object closure2749 = createclosure(2, "_apply(1)");
  setclosureframe(closure2749, stackframe);
  addtoclosure(closure2749, var_s);
  addtoclosure(closure2749, selfslot);
  struct UserObject *uo2749 = (struct UserObject*)block2748;
  uo2749->data[0] = (Object)closure2749;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2749 = addmethod2pos(block2748, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2749, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2749[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2749->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2749);
  meth_meth_collectionsPrelude__apply_40_1_41_2749->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2749->definitionLine = 1991;
// compiled block node returning block2748 (depth = 3)
  gc_frame_newslot(block2748);
// Begin line 1357
  setline(1357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2757 = alloc_Block(NULL, NULL, "collectionsPrelude", 1357);
  gc_frame_newslot(block2757);
// method "_apply"
  block_savedest(block2757);
  Object closure2758 = createclosure(2, "_apply");
  setclosureframe(closure2758, stackframe);
  addtoclosure(closure2758, var_s);
  addtoclosure(closure2758, selfslot);
  struct UserObject *uo2758 = (struct UserObject*)block2757;
  uo2758->data[0] = (Object)closure2758;
  Method *meth_meth_collectionsPrelude__apply2758 = addmethod2pos(block2757, "_apply", &meth_collectionsPrelude__apply2758, 0);
  int argcv_meth_collectionsPrelude__apply2758[] = {0};
  meth_meth_collectionsPrelude__apply2758->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2758);
  meth_meth_collectionsPrelude__apply2758->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2758->definitionLine = 1991;
// compiled block node returning block2757 (depth = 3)
  gc_frame_newslot(block2757);
// call case 4: self request
  params[0] = block2748;
  params[1] = block2757;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2765 = callmethodflags(self, "do(1)separatedBy(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2747);
// compiled call node returning call2765 (depth = 2)
// Begin line 1358
  setline(1358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2767 == NULL) {
    strlit2767 = alloc_String("}");
    gc_root(strlit2767);
  }
// compiled string node returning strlit2767 (depth = 3)
  int op_slot_right_2766 = gc_frame_newslot(strlit2767);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_2766 = gc_frame_newslot(*var_s);
  params[0] = strlit2767;
  partcv[0] = 1;
  Object opresult2769 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2769 (depth = 2)
  gc_frame_end(frame);
  return opresult2769;
}
Object meth_collectionsPrelude__apply_40_1_41_2773(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1362
  setline(1362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2774 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2775 = callmethodflags(self, "add(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2774);
// compiled call node returning call2775 (depth = 4)
  gc_frame_end(frame);
  return call2775;
}
Object meth_collectionsPrelude_extend_40_1_41_2770(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extend(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extend(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extend(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part extend(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2771 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 3)
  Object block2772 = alloc_Block(NULL, NULL, "collectionsPrelude", 1361);
  gc_frame_newslot(block2772);
// method "_apply(_)"
  block_savedest(block2772);
  Object closure2773 = createclosure(1, "_apply(1)");
  setclosureframe(closure2773, stackframe);
  addtoclosure(closure2773, selfslot);
  struct UserObject *uo2773 = (struct UserObject*)block2772;
  uo2773->data[0] = (Object)closure2773;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2773 = addmethod2pos(block2772, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2773, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2773[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2773->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2773);
  meth_meth_collectionsPrelude__apply_40_1_41_2773->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2773->definitionLine = 1991;
// compiled block node returning block2772 (depth = 3)
  gc_frame_newslot(block2772);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block2772;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2777 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2771);
// compiled call node returning call2777 (depth = 2)
  gc_frame_end(frame);
  return call2777;
}
Object meth_collectionsPrelude__apply2783(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_found = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2785 = gc_frame_new();
// call case 4: self request
  Object call2786 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2785);
// compiled member node returning call2786 (depth = 5)
  int op_slot_right_2784 = gc_frame_newslot(call2786);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_found (depth = 5)
  int op_slot_left_2784 = gc_frame_newslot(*var_found);
  params[0] = call2786;
  partcv[0] = 1;
  Object opresult2788 = callmethod(*var_found, "<(1)", 1, partcv, params);
// compiled op node returning opresult2788 (depth = 4)
  gc_frame_end(frame);
  return opresult2788;
}
Object meth_collectionsPrelude__apply2791(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  Object *var_found = getfromclosure(closure, 4);
  Object *var_block1 = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2792 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2793 = gc_frame_new();
// call case 4: self request
  Object call2794 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2793);
// compiled member node returning call2794 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2795 = callmethodflags(call2794, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2792);
// compiled call node returning call2795 (depth = 5)
  *var_candidate = call2795;
  if (call2795 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_candidate (depth = 7)
  int op_slot_right_2799 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_2799 = gc_frame_newslot(*var_removed);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2801 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2801 (depth = 6)
  int op_slot_right_2798 = gc_frame_newslot(opresult2801);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_candidate (depth = 7)
  int op_slot_right_2803 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_2803 = gc_frame_newslot(*var_unused);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2805 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2805 (depth = 6)
  int op_slot_left_2798 = gc_frame_newslot(opresult2805);
  params[0] = opresult2801;
  partcv[0] = 1;
  Object opresult2806 = callmethod(opresult2805, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2806 (depth = 5)
  Object if2797 = done;
  if (istrue(opresult2806)) {
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2808 = alloc_Float64(1);
// compiled num node returning num2808 (depth = 7)
  int op_slot_right_2807 = gc_frame_newslot(num2808);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_found (depth = 7)
  int op_slot_left_2807 = gc_frame_newslot(*var_found);
  params[0] = num2808;
  partcv[0] = 1;
  Object sum2810 = callmethod(*var_found, "+(1)", 1, partcv, params);
// compiled op node returning sum2810 (depth = 6)
  *var_found = sum2810;
  if (sum2810 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1373
  setline(1373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2812 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  gc_frame_newslot(*var_candidate);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object call2813 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2812);
// compiled call node returning call2813 (depth = 5)
    gc_frame_newslot(call2813);
    if2797 = call2813;
  } else {
  }
// compiled if node returning if2797 (depth = 4)
// Begin line 1375
  setline(1375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2815 = alloc_Float64(1);
// compiled num node returning num2815 (depth = 6)
  int op_slot_right_2814 = gc_frame_newslot(num2815);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_2814 = gc_frame_newslot(*var_i);
  params[0] = num2815;
  partcv[0] = 1;
  Object sum2817 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum2817 (depth = 5)
  *var_i = sum2817;
  if (sum2817 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do_40_1_41_2778(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
  Object *var_found = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "found");
  Object *var_candidate = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "candidate");
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2779 = alloc_Float64(0);
// compiled num node returning num2779 (depth = 3)
  *var_i = num2779;
  if (num2779 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2780 = alloc_Float64(0);
// compiled num node returning num2780 (depth = 3)
  *var_found = num2780;
  if (num2780 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2781 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2782 = alloc_Block(NULL, NULL, "collectionsPrelude", 1369);
  gc_frame_newslot(block2782);
// method "_apply"
  block_savedest(block2782);
  Object closure2783 = createclosure(2, "_apply");
  setclosureframe(closure2783, stackframe);
  addtoclosure(closure2783, var_found);
  addtoclosure(closure2783, selfslot);
  struct UserObject *uo2783 = (struct UserObject*)block2782;
  uo2783->data[0] = (Object)closure2783;
  Method *meth_meth_collectionsPrelude__apply2783 = addmethod2pos(block2782, "_apply", &meth_collectionsPrelude__apply2783, 0);
  int argcv_meth_collectionsPrelude__apply2783[] = {0};
  meth_meth_collectionsPrelude__apply2783->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2783);
  meth_meth_collectionsPrelude__apply2783->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2783->definitionLine = 1991;
// compiled block node returning block2782 (depth = 3)
  gc_frame_newslot(block2782);
// starting to compile block node (depth = 3)
  Object block2790 = alloc_Block(NULL, NULL, "collectionsPrelude", 1369);
  gc_frame_newslot(block2790);
// method "_apply"
  block_savedest(block2790);
  Object closure2791 = createclosure(7, "_apply");
  setclosureframe(closure2791, stackframe);
  addtoclosure(closure2791, var_i);
  addtoclosure(closure2791, var_candidate);
  addtoclosure(closure2791, var_removed);
  addtoclosure(closure2791, var_unused);
  addtoclosure(closure2791, var_found);
  addtoclosure(closure2791, var_block1);
  addtoclosure(closure2791, selfslot);
  struct UserObject *uo2791 = (struct UserObject*)block2790;
  uo2791->data[0] = (Object)closure2791;
  Method *meth_meth_collectionsPrelude__apply2791 = addmethod2pos(block2790, "_apply", &meth_collectionsPrelude__apply2791, 0);
  int argcv_meth_collectionsPrelude__apply2791[] = {0};
  meth_meth_collectionsPrelude__apply2791->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2791);
  meth_meth_collectionsPrelude__apply2791->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2791->definitionLine = 1991;
// compiled block node returning block2790 (depth = 3)
  gc_frame_newslot(block2790);
// call case 5: prelude request
  params[0] = block2782;
  params[1] = block2790;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2820 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2781);
// compiled call node returning call2820 (depth = 2)
  gc_frame_end(frame);
  return call2820;
}
Object meth_collectionsPrelude_hasNext2827(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2829 = gc_frame_new();
// call case 4: self request
  Object call2830 = callmethodflags(self, "count", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2829);
// compiled member node returning call2830 (depth = 3)
  int op_slot_right_2828 = gc_frame_newslot(call2830);
// starting to compile member node (depth = 3)
  int callframe2832 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2833 = gc_frame_new();
// call case 3: self.outer request
  Object call2834 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2833);
// compiled member node returning call2834 (depth = 4)
  Object call2835 = callmethodflags(call2834, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2832);
// compiled member node returning call2835 (depth = 3)
  int op_slot_left_2828 = gc_frame_newslot(call2835);
  params[0] = call2830;
  partcv[0] = 1;
  Object opresult2836 = callmethod(call2835, "≥(1)", 1, partcv, params);
// compiled op node returning opresult2836 (depth = 2)
  gc_frame_end(frame);
  return opresult2836;
}
Object meth_collectionsPrelude__apply2846(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_innerSize = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  Object *var_candidate = getfromclosure(closure, 3);
  Object *var_removed = getfromclosure(closure, 4);
  Object *var_unused = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe2847 = gc_frame_new();
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2849 = alloc_Float64(1);
// compiled num node returning num2849 (depth = 6)
  int op_slot_right_2848 = gc_frame_newslot(num2849);
// starting to compile member node (depth = 6)
  int callframe2851 = gc_frame_new();
// call case 4: self request
  Object call2852 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2851);
// compiled member node returning call2852 (depth = 6)
  int op_slot_left_2848 = gc_frame_newslot(call2852);
  params[0] = num2849;
  partcv[0] = 1;
  Object sum2853 = callmethod(call2852, "+(1)", 1, partcv, params);
// compiled op node returning sum2853 (depth = 5)
  gc_frame_newslot(sum2853);
// call case 4: self request
  params[0] = sum2853;
  partcv[0] = 1;
  Object call2854 = callmethodflags(self, "idx:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2847);
// compiled call node returning call2854 (depth = 4)
// Begin line 1389
  setline(1389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2857 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2858 = gc_frame_new();
// call case 3: self.outer request
  Object call2859 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2858);
// compiled member node returning call2859 (depth = 7)
  Object call2860 = callmethodflags(call2859, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2857);
// compiled member node returning call2860 (depth = 6)
  int op_slot_right_2856 = gc_frame_newslot(call2860);
// starting to compile member node (depth = 6)
  int callframe2862 = gc_frame_new();
// call case 4: self request
  Object call2863 = callmethodflags(self, "imods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2862);
// compiled member node returning call2863 (depth = 6)
  int op_slot_left_2856 = gc_frame_newslot(call2863);
  params[0] = call2860;
  partcv[0] = 1;
  Object opresult2864 = callmethod(call2863, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2864 (depth = 5)
  Object if2855 = done;
  if (istrue(opresult2864)) {
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2865 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2866 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2867 = gc_frame_new();
// call case 3: self.outer request
  Object call2868 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2867);
// compiled member node returning call2868 (depth = 7)
  Object call2869 = callmethodflags(call2868, "asString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2866);
// compiled member node returning call2869 (depth = 6)
  gc_frame_newslot(call2869);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ConcurrentModification (depth = 6)
  params[0] = call2869;
  partcv[0] = 1;
  Object call2870 = callmethodflags(*var_ConcurrentModification, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2865);
// compiled call node returning call2870 (depth = 5)
    gc_frame_newslot(call2870);
    if2855 = call2870;
  } else {
  }
// compiled if node returning if2855 (depth = 4)
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_innerSize (depth = 6)
  int op_slot_right_2872 = gc_frame_newslot(*var_innerSize);
// starting to compile member node (depth = 6)
  int callframe2874 = gc_frame_new();
// call case 4: self request
  Object call2875 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2874);
// compiled member node returning call2875 (depth = 6)
  int op_slot_left_2872 = gc_frame_newslot(call2875);
  params[0] = *var_innerSize;
  partcv[0] = 1;
  Object opresult2876 = callmethod(call2875, "≥(1)", 1, partcv, params);
// compiled op node returning opresult2876 (depth = 5)
  Object if2871 = done;
  if (istrue(opresult2876)) {
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2877 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2879 == NULL) {
    strlit2879 = alloc_String("");
    gc_root(strlit2879);
  }
// compiled string node returning strlit2879 (depth = 7)
  int op_slot_right_2878 = gc_frame_newslot(strlit2879);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2882 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2883 = gc_frame_new();
// call case 3: self.outer request
  Object call2884 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2883);
// compiled member node returning call2884 (depth = 9)
  Object call2885 = callmethodflags(call2884, "asString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2882);
// compiled member node returning call2885 (depth = 8)
  int op_slot_right_2881 = gc_frame_newslot(call2885);
// starting to compile string node (depth = 8)
  if (strlit2887 == NULL) {
    strlit2887 = alloc_String("iterator over ");
    gc_root(strlit2887);
  }
// compiled string node returning strlit2887 (depth = 8)
  int op_slot_left_2881 = gc_frame_newslot(strlit2887);
  params[0] = call2885;
  partcv[0] = 1;
  Object opresult2888 = callmethod(strlit2887, "++(1)", 1, partcv, params);
// compiled op node returning opresult2888 (depth = 7)
  int op_slot_left_2878 = gc_frame_newslot(opresult2888);
  params[0] = strlit2879;
  partcv[0] = 1;
  Object opresult2889 = callmethod(opresult2888, "++(1)", 1, partcv, params);
// compiled op node returning opresult2889 (depth = 6)
  gc_frame_newslot(opresult2889);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_IteratorExhausted (depth = 6)
  params[0] = opresult2889;
  partcv[0] = 1;
  Object call2890 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2877);
// compiled call node returning call2890 (depth = 5)
    gc_frame_newslot(call2890);
    if2871 = call2890;
  } else {
  }
// compiled if node returning if2871 (depth = 4)
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2891 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2892 = gc_frame_new();
// call case 4: self request
  Object call2893 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2892);
// compiled member node returning call2893 (depth = 6)
  gc_frame_newslot(call2893);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2894 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2895 = gc_frame_new();
// call case 3: self.outer request
  Object call2896 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2895);
// compiled member node returning call2896 (depth = 7)
  Object call2897 = callmethodflags(call2896, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2894);
// compiled member node returning call2897 (depth = 6)
  params[0] = call2893;
  partcv[0] = 1;
  Object call2898 = callmethodflags(call2897, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2891);
// compiled call node returning call2898 (depth = 5)
  *var_candidate = call2898;
  if (call2898 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1396
  setline(1396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_right_2901 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  int op_slot_left_2901 = gc_frame_newslot(*var_removed);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2903 = callmethod(*var_removed, "==(1)", 1, partcv, params);
// compiled op node returning opresult2903 (depth = 5)
  int op_slot_right_2900 = gc_frame_newslot(opresult2903);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_right_2905 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unused (depth = 6)
  int op_slot_left_2905 = gc_frame_newslot(*var_unused);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2907 = callmethod(*var_unused, "==(1)", 1, partcv, params);
// compiled op node returning opresult2907 (depth = 5)
  int op_slot_left_2900 = gc_frame_newslot(opresult2907);
  params[0] = opresult2903;
  partcv[0] = 1;
  Object opresult2908 = callmethod(opresult2907, "||(1)", 1, partcv, params);
// compiled op node returning opresult2908 (depth = 4)
  gc_frame_end(frame);
  return opresult2908;
}
Object meth_collectionsPrelude__apply2911(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_next2837(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_candidate = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "candidate");
  Object *var_innerSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "innerSize");
// Begin line 1385
  setline(1385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1386
  setline(1386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2838 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2839 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2840 = gc_frame_new();
// call case 3: self.outer request
  Object call2841 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2840);
// compiled member node returning call2841 (depth = 5)
  Object call2842 = callmethodflags(call2841, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2839);
// compiled member node returning call2842 (depth = 4)
  Object call2843 = callmethodflags(call2842, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2838);
// compiled member node returning call2843 (depth = 3)
  *var_innerSize = call2843;
  if (call2843 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2844 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2845 = alloc_Block(NULL, NULL, "collectionsPrelude", 1387);
  gc_frame_newslot(block2845);
// method "_apply"
  block_savedest(block2845);
  Object closure2846 = createclosure(7, "_apply");
  setclosureframe(closure2846, stackframe);
  addtoclosure(closure2846, var_ConcurrentModification);
  addtoclosure(closure2846, var_innerSize);
  addtoclosure(closure2846, var_IteratorExhausted);
  addtoclosure(closure2846, var_candidate);
  addtoclosure(closure2846, var_removed);
  addtoclosure(closure2846, var_unused);
  addtoclosure(closure2846, selfslot);
  struct UserObject *uo2846 = (struct UserObject*)block2845;
  uo2846->data[0] = (Object)closure2846;
  Method *meth_meth_collectionsPrelude__apply2846 = addmethod2pos(block2845, "_apply", &meth_collectionsPrelude__apply2846, 0);
  int argcv_meth_collectionsPrelude__apply2846[] = {0};
  meth_meth_collectionsPrelude__apply2846->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2846);
  meth_meth_collectionsPrelude__apply2846->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2846->definitionLine = 1991;
// compiled block node returning block2845 (depth = 3)
  gc_frame_newslot(block2845);
// Begin line 1397
  setline(1397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2910 = alloc_Block(NULL, NULL, "collectionsPrelude", 1397);
  gc_frame_newslot(block2910);
// method "_apply"
  block_savedest(block2910);
  Object closure2911 = createclosure(1, "_apply");
  setclosureframe(closure2911, stackframe);
  addtoclosure(closure2911, selfslot);
  struct UserObject *uo2911 = (struct UserObject*)block2910;
  uo2911->data[0] = (Object)closure2911;
  Method *meth_meth_collectionsPrelude__apply2911 = addmethod2pos(block2910, "_apply", &meth_collectionsPrelude__apply2911, 0);
  int argcv_meth_collectionsPrelude__apply2911[] = {0};
  meth_meth_collectionsPrelude__apply2911->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2911);
  meth_meth_collectionsPrelude__apply2911->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2911->definitionLine = 1991;
// compiled block node returning block2910 (depth = 3)
  gc_frame_newslot(block2910);
// call case 5: prelude request
  params[0] = block2845;
  params[1] = block2910;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2913 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2844);
// compiled call node returning call2913 (depth = 2)
// Begin line 1398
  setline(1398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2914 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2916 = alloc_Float64(1);
// compiled num node returning num2916 (depth = 4)
  int op_slot_right_2915 = gc_frame_newslot(num2916);
// starting to compile member node (depth = 4)
  int callframe2918 = gc_frame_new();
// call case 4: self request
  Object call2919 = callmethodflags(self, "count", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2918);
// compiled member node returning call2919 (depth = 4)
  int op_slot_left_2915 = gc_frame_newslot(call2919);
  params[0] = num2916;
  partcv[0] = 1;
  Object sum2920 = callmethod(call2919, "+(1)", 1, partcv, params);
// compiled op node returning sum2920 (depth = 3)
  gc_frame_newslot(sum2920);
// call case 4: self request
  params[0] = sum2920;
  partcv[0] = 1;
  Object call2921 = callmethodflags(self, "count:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2914);
// compiled call node returning call2921 (depth = 2)
// Begin line 1399
  setline(1399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_candidate (depth = 2)
  gc_frame_end(frame);
  return *var_candidate;
}
Object meth_collectionsPrelude_iterator2821(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2822 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2822 = alloc_userobj2(8,6, objclass2822);
  gc_frame_newslot(obj2822);
if (objclass2822 == NULL) {
  glfree(obj2822->class->name);
  obj2822->class->name = "set.ofCapacity(_).object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2822, self, 0);
  addmethodreal(obj2822,"outer", &reader_collectionsPrelude_outer_2823);
  Object oldself2822 = self;
  struct StackFrameObject *oldstackframe2822 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2822);
  gc_frame_newslot((Object)stackframe);
  self = obj2822;
  Object *oldselfslot2822 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2822 = (*(struct UserObject *)self).data[0], lowerouter2822 = thisouter2822;
  if (inheritingObject2822) {
    struct UserObject *inho2822 = (struct UserObject *)inheritingObject2822;
    while (inho2822->super != GraceDefaultObject) inho2822 = (struct UserObject *)inho2822->super;
    inho2822->super = obj2822;
    self = inheritingObject2822;
    *selfslot = self;
    lowerouter2822 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2822;
  }
if (objclass2822 == NULL) {
  Method *reader2824 = addmethodrealflags(obj2822, "imods", &reader_collectionsPrelude_imods_2824, MFLAG_CONFIDENTIAL);
  Method *writer2824 = addmethodrealflags(obj2822, "imods:=(1)", &writer_collectionsPrelude_imods_2824, MFLAG_CONFIDENTIAL);
  reader2824->definitionModule = modulename;
  writer2824->definitionModule = modulename;
  reader2824->definitionLine = 1380;
  writer2824->definitionLine = 1380;
}
obj2822->flags |= OFLAG_MUTABLE;
adddatum2(obj2822, alloc_Undefined(), 1);
if (objclass2822 == NULL) {
  Method *reader2825 = addmethodrealflags(obj2822, "count", &reader_collectionsPrelude_count_2825, MFLAG_CONFIDENTIAL);
  Method *writer2825 = addmethodrealflags(obj2822, "count:=(1)", &writer_collectionsPrelude_count_2825, MFLAG_CONFIDENTIAL);
  reader2825->definitionModule = modulename;
  writer2825->definitionModule = modulename;
  reader2825->definitionLine = 1381;
  writer2825->definitionLine = 1381;
}
obj2822->flags |= OFLAG_MUTABLE;
adddatum2(obj2822, alloc_Undefined(), 2);
if (objclass2822 == NULL) {
  Method *reader2826 = addmethodrealflags(obj2822, "idx", &reader_collectionsPrelude_idx_2826, MFLAG_CONFIDENTIAL);
  Method *writer2826 = addmethodrealflags(obj2822, "idx:=(1)", &writer_collectionsPrelude_idx_2826, MFLAG_CONFIDENTIAL);
  reader2826->definitionModule = modulename;
  writer2826->definitionModule = modulename;
  reader2826->definitionLine = 1382;
  writer2826->definitionLine = 1382;
}
obj2822->flags |= OFLAG_MUTABLE;
adddatum2(obj2822, alloc_Undefined(), 3);
// method "hasNext"
  struct UserObject *uo2827 = (struct UserObject*)obj2822;
  uo2827->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext2827 = addmethod2pos(obj2822, "hasNext", &meth_collectionsPrelude_hasNext2827, 4);
  int argcv_meth_collectionsPrelude_hasNext2827[] = {0};
  meth_meth_collectionsPrelude_hasNext2827->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext2827);
  meth_meth_collectionsPrelude_hasNext2827->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext2827->definitionLine = 1383;
// method "next"
  block_savedest(obj2822);
  Object closure2837 = createclosure(4, "next");
  setclosureframe(closure2837, stackframe);
  addtoclosure(closure2837, var_ConcurrentModification);
  addtoclosure(closure2837, var_IteratorExhausted);
  addtoclosure(closure2837, var_removed);
  addtoclosure(closure2837, var_unused);
  struct UserObject *uo2837 = (struct UserObject*)obj2822;
  uo2837->data[5] = (Object)closure2837;
  Method *meth_meth_collectionsPrelude_next2837 = addmethod2pos(obj2822, "next", &meth_collectionsPrelude_next2837, 5);
  int argcv_meth_collectionsPrelude_next2837[] = {0};
  meth_meth_collectionsPrelude_next2837->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next2837);
  meth_meth_collectionsPrelude_next2837->definitionModule = modulename;
  meth_meth_collectionsPrelude_next2837->definitionLine = 1384;
  sourceObject = obj2822;
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe2922 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2923 = gc_frame_new();
// call case 3: self.outer request
  Object call2924 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2923);
// compiled member node returning call2924 (depth = 3)
  Object call2925 = callmethodflags(call2924, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2922);
// compiled member node returning call2925 (depth = 2)
  adddatum2(obj2822, call2925, 1);
  sourceObject = obj2822;
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2926 = alloc_Float64(1);
// compiled num node returning num2926 (depth = 2)
  adddatum2(obj2822, num2926, 2);
  sourceObject = obj2822;
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2927 = gc_frame_new();
// call case 6: other requests
// Begin line 1382
  setline(1382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num2928 = alloc_Float64(1);
// compiled num node returning num2928 (depth = 3)
  partcv[0] = 0;
  Object call2929 = callmethodflags(num2928, "prefix-", 1, partcv, params, 0);
  gc_frame_end(callframe2927);
// compiled call node returning call2929 (depth = 2)
  adddatum2(obj2822, call2929, 3);
  sourceObject = obj2822;
  sourceObject = obj2822;
  objclass2822 = obj2822->class;
  objclass2822->definitionModule = modulename;
  objclass2822->definitionLine = 1379;
  (*(struct UserObject *)self).data[0] = lowerouter2822;
  self = oldself2822;
  selfslot = oldselfslot2822;
  stackframe = oldstackframe2822;
  gc_frame_end(frame);
  return obj2822;
}
Object meth_collectionsPrelude_iterator2821_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2822 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2822 = alloc_userobj2(8,6, objclass2822);
  gc_frame_newslot(obj2822);
if (objclass2822 == NULL) {
  glfree(obj2822->class->name);
  obj2822->class->name = "set.ofCapacity(_).object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2822, self, 0);
  addmethodreal(obj2822,"outer", &reader_collectionsPrelude_outer_2823);
  Object oldself2822 = self;
  struct StackFrameObject *oldstackframe2822 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2822);
  gc_frame_newslot((Object)stackframe);
  self = obj2822;
  Object *oldselfslot2822 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2822 = (*(struct UserObject *)self).data[0], lowerouter2822 = thisouter2822;
  if (inheritingObject2822) {
    struct UserObject *inho2822 = (struct UserObject *)inheritingObject2822;
    while (inho2822->super != GraceDefaultObject) inho2822 = (struct UserObject *)inho2822->super;
    inho2822->super = obj2822;
    self = inheritingObject2822;
    *selfslot = self;
    lowerouter2822 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2822;
  }
if (objclass2822 == NULL) {
  Method *reader2824 = addmethodrealflags(obj2822, "imods", &reader_collectionsPrelude_imods_2824, MFLAG_CONFIDENTIAL);
  Method *writer2824 = addmethodrealflags(obj2822, "imods:=(1)", &writer_collectionsPrelude_imods_2824, MFLAG_CONFIDENTIAL);
  reader2824->definitionModule = modulename;
  writer2824->definitionModule = modulename;
  reader2824->definitionLine = 1380;
  writer2824->definitionLine = 1380;
}
obj2822->flags |= OFLAG_MUTABLE;
adddatum2(obj2822, alloc_Undefined(), 1);
if (objclass2822 == NULL) {
  Method *reader2825 = addmethodrealflags(obj2822, "count", &reader_collectionsPrelude_count_2825, MFLAG_CONFIDENTIAL);
  Method *writer2825 = addmethodrealflags(obj2822, "count:=(1)", &writer_collectionsPrelude_count_2825, MFLAG_CONFIDENTIAL);
  reader2825->definitionModule = modulename;
  writer2825->definitionModule = modulename;
  reader2825->definitionLine = 1381;
  writer2825->definitionLine = 1381;
}
obj2822->flags |= OFLAG_MUTABLE;
adddatum2(obj2822, alloc_Undefined(), 2);
if (objclass2822 == NULL) {
  Method *reader2826 = addmethodrealflags(obj2822, "idx", &reader_collectionsPrelude_idx_2826, MFLAG_CONFIDENTIAL);
  Method *writer2826 = addmethodrealflags(obj2822, "idx:=(1)", &writer_collectionsPrelude_idx_2826, MFLAG_CONFIDENTIAL);
  reader2826->definitionModule = modulename;
  writer2826->definitionModule = modulename;
  reader2826->definitionLine = 1382;
  writer2826->definitionLine = 1382;
}
obj2822->flags |= OFLAG_MUTABLE;
adddatum2(obj2822, alloc_Undefined(), 3);
// method "hasNext"
  struct UserObject *uo2827 = (struct UserObject*)obj2822;
  uo2827->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext2827 = addmethod2pos(obj2822, "hasNext", &meth_collectionsPrelude_hasNext2827, 4);
  int argcv_meth_collectionsPrelude_hasNext2827[] = {0};
  meth_meth_collectionsPrelude_hasNext2827->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext2827);
  meth_meth_collectionsPrelude_hasNext2827->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext2827->definitionLine = 1383;
// method "next"
  block_savedest(obj2822);
  Object closure2837 = createclosure(4, "next");
  setclosureframe(closure2837, stackframe);
  addtoclosure(closure2837, var_ConcurrentModification);
  addtoclosure(closure2837, var_IteratorExhausted);
  addtoclosure(closure2837, var_removed);
  addtoclosure(closure2837, var_unused);
  struct UserObject *uo2837 = (struct UserObject*)obj2822;
  uo2837->data[5] = (Object)closure2837;
  Method *meth_meth_collectionsPrelude_next2837 = addmethod2pos(obj2822, "next", &meth_collectionsPrelude_next2837, 5);
  int argcv_meth_collectionsPrelude_next2837[] = {0};
  meth_meth_collectionsPrelude_next2837->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next2837);
  meth_meth_collectionsPrelude_next2837->definitionModule = modulename;
  meth_meth_collectionsPrelude_next2837->definitionLine = 1384;
  sourceObject = obj2822;
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe2922 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2923 = gc_frame_new();
// call case 3: self.outer request
  Object call2924 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2923);
// compiled member node returning call2924 (depth = 3)
  Object call2925 = callmethodflags(call2924, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2922);
// compiled member node returning call2925 (depth = 2)
  adddatum2(obj2822, call2925, 1);
  sourceObject = obj2822;
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2926 = alloc_Float64(1);
// compiled num node returning num2926 (depth = 2)
  adddatum2(obj2822, num2926, 2);
  sourceObject = obj2822;
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2927 = gc_frame_new();
// call case 6: other requests
// Begin line 1382
  setline(1382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num2928 = alloc_Float64(1);
// compiled num node returning num2928 (depth = 3)
  partcv[0] = 0;
  Object call2929 = callmethodflags(num2928, "prefix-", 1, partcv, params, 0);
  gc_frame_end(callframe2927);
// compiled call node returning call2929 (depth = 2)
  adddatum2(obj2822, call2929, 3);
  sourceObject = obj2822;
  sourceObject = obj2822;
  objclass2822 = obj2822->class;
  objclass2822->definitionModule = modulename;
  objclass2822->definitionLine = 1379;
  (*(struct UserObject *)self).data[0] = lowerouter2822;
  self = oldself2822;
  selfslot = oldselfslot2822;
  stackframe = oldstackframe2822;
  gc_frame_end(frame);
  return obj2822;
}
Object meth_collectionsPrelude__apply_40_1_41_2965(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2966 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2967 = gc_frame_new();
// call case 4: self request
  Object call2968 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2967);
// compiled member node returning call2968 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2969 = callmethodflags(call2968, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2966);
// compiled call node returning call2969 (depth = 4)
  gc_frame_end(frame);
  return call2969;
}
Object meth_collectionsPrelude__apply_40_1_41_2984(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_oldInner = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1414
  setline(1414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2988 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oldInner (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2989 = callmethodflags(*var_oldInner, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2988);
// compiled call node returning call2989 (depth = 7)
  int op_slot_right_2987 = gc_frame_newslot(call2989);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_2987 = gc_frame_newslot(*var_removed);
  params[0] = call2989;
  partcv[0] = 1;
  Object opresult2991 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2991 (depth = 6)
  int op_slot_right_2986 = gc_frame_newslot(opresult2991);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2994 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oldInner (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2995 = callmethodflags(*var_oldInner, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2994);
// compiled call node returning call2995 (depth = 7)
  int op_slot_right_2993 = gc_frame_newslot(call2995);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_2993 = gc_frame_newslot(*var_unused);
  params[0] = call2995;
  partcv[0] = 1;
  Object opresult2997 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2997 (depth = 6)
  int op_slot_left_2986 = gc_frame_newslot(opresult2997);
  params[0] = opresult2991;
  partcv[0] = 1;
  Object opresult2998 = callmethod(opresult2997, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2998 (depth = 5)
  Object if2985 = done;
  if (istrue(opresult2998)) {
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2999 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe3000 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_oldInner (depth = 7)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3001 = callmethodflags(*var_oldInner, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3000);
// compiled call node returning call3001 (depth = 6)
  gc_frame_newslot(call3001);
// call case 4: self request
  params[0] = call3001;
  partcv[0] = 1;
  Object call3002 = callmethodflags(self, "add(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2999);
// compiled call node returning call3002 (depth = 5)
    gc_frame_newslot(call3002);
    if2985 = call3002;
  } else {
  }
// compiled if node returning if2985 (depth = 4)
  gc_frame_end(frame);
  return if2985;
}
Object meth_collectionsPrelude_expand2931(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expand");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var__prelude = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_c = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "c");
  Object *var_n = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "n");
  Object *var_oldInner = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldInner");
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2932 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2933 = gc_frame_new();
// call case 4: self request
  Object call2934 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2933);
// compiled member node returning call2934 (depth = 4)
  Object call2935 = callmethodflags(call2934, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2932);
// compiled member node returning call2935 (depth = 3)
  *var_c = call2935;
  if (call2935 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2937 = alloc_Float64(2);
// compiled num node returning num2937 (depth = 4)
  int op_slot_right_2936 = gc_frame_newslot(num2937);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_2936 = gc_frame_newslot(*var_c);
  params[0] = num2937;
  partcv[0] = 1;
  Object prod2939 = callmethod(*var_c, "*(1)", 1, partcv, params);
// compiled op node returning prod2939 (depth = 3)
  *var_n = prod2939;
  if (prod2939 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1407
  setline(1407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2940 = gc_frame_new();
// call case 4: self request
  Object call2941 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2940);
// compiled member node returning call2941 (depth = 3)
  *var_oldInner = call2941;
  if (call2941 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1408
  setline(1408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2942 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num2943 = alloc_Float64(0);
// compiled num node returning num2943 (depth = 3)
  gc_frame_newslot(num2943);
// call case 4: self request
  params[0] = num2943;
  partcv[0] = 1;
  Object call2944 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2942);
// compiled call node returning call2944 (depth = 2)
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2945 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe2946 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2947 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  Object call2948 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe2947);
// compiled member node returning call2948 (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2949 = callmethodflags(call2948, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2946);
// compiled call node returning call2949 (depth = 3)
  gc_frame_newslot(call2949);
// call case 4: self request
  params[0] = call2949;
  partcv[0] = 1;
  Object call2950 = callmethodflags(self, "inner:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2945);
// compiled call node returning call2950 (depth = 2)
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2951 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2954 = alloc_Float64(1);
// compiled num node returning num2954 (depth = 5)
  int op_slot_right_2953 = gc_frame_newslot(num2954);
// starting to compile member node (depth = 5)
  int callframe2956 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2957 = gc_frame_new();
// call case 4: self request
  Object call2958 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2957);
// compiled member node returning call2958 (depth = 6)
  Object call2959 = callmethodflags(call2958, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2956);
// compiled member node returning call2959 (depth = 5)
  int op_slot_left_2953 = gc_frame_newslot(call2959);
  params[0] = num2954;
  partcv[0] = 1;
  Object diff2960 = callmethod(call2959, "-(1)", 1, partcv, params);
// compiled op node returning diff2960 (depth = 4)
  int op_slot_right_2952 = gc_frame_newslot(diff2960);
// starting to compile num node (depth = 4)
  Object num2962 = alloc_Float64(0);
// compiled num node returning num2962 (depth = 4)
  int op_slot_left_2952 = gc_frame_newslot(num2962);
  params[0] = diff2960;
  partcv[0] = 1;
  Object opresult2963 = callmethod(num2962, "..(1)", 1, partcv, params);
// compiled op node returning opresult2963 (depth = 3)
  gc_frame_newslot(opresult2963);
// starting to compile block node (depth = 3)
  Object block2964 = alloc_Block(NULL, NULL, "collectionsPrelude", 1410);
  gc_frame_newslot(block2964);
// method "_apply(_)"
  block_savedest(block2964);
  Object closure2965 = createclosure(2, "_apply(1)");
  setclosureframe(closure2965, stackframe);
  addtoclosure(closure2965, var_unused);
  addtoclosure(closure2965, selfslot);
  struct UserObject *uo2965 = (struct UserObject*)block2964;
  uo2965->data[0] = (Object)closure2965;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2965 = addmethod2pos(block2964, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2965, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2965[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2965->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2965);
  meth_meth_collectionsPrelude__apply_40_1_41_2965->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2965->definitionLine = 1991;
// compiled block node returning block2964 (depth = 3)
  gc_frame_newslot(block2964);
// call case 5: prelude request
  params[0] = opresult2963;
  params[1] = block2964;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2971 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2951);
// compiled call node returning call2971 (depth = 2)
// Begin line 1413
  setline(1413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2972 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2975 = alloc_Float64(1);
// compiled num node returning num2975 (depth = 5)
  int op_slot_right_2974 = gc_frame_newslot(num2975);
// starting to compile member node (depth = 5)
  int callframe2977 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldInner (depth = 6)
  Object call2978 = callmethodflags(*var_oldInner, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2977);
// compiled member node returning call2978 (depth = 5)
  int op_slot_left_2974 = gc_frame_newslot(call2978);
  params[0] = num2975;
  partcv[0] = 1;
  Object diff2979 = callmethod(call2978, "-(1)", 1, partcv, params);
// compiled op node returning diff2979 (depth = 4)
  int op_slot_right_2973 = gc_frame_newslot(diff2979);
// starting to compile num node (depth = 4)
  Object num2981 = alloc_Float64(0);
// compiled num node returning num2981 (depth = 4)
  int op_slot_left_2973 = gc_frame_newslot(num2981);
  params[0] = diff2979;
  partcv[0] = 1;
  Object opresult2982 = callmethod(num2981, "..(1)", 1, partcv, params);
// compiled op node returning opresult2982 (depth = 3)
  gc_frame_newslot(opresult2982);
// starting to compile block node (depth = 3)
  Object block2983 = alloc_Block(NULL, NULL, "collectionsPrelude", 1413);
  gc_frame_newslot(block2983);
// method "_apply(_)"
  block_savedest(block2983);
  Object closure2984 = createclosure(4, "_apply(1)");
  setclosureframe(closure2984, stackframe);
  addtoclosure(closure2984, var_oldInner);
  addtoclosure(closure2984, var_removed);
  addtoclosure(closure2984, var_unused);
  addtoclosure(closure2984, selfslot);
  struct UserObject *uo2984 = (struct UserObject*)block2983;
  uo2984->data[0] = (Object)closure2984;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2984 = addmethod2pos(block2983, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2984, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2984[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2984->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2984);
  meth_meth_collectionsPrelude__apply_40_1_41_2984->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2984->definitionLine = 1991;
// compiled block node returning block2983 (depth = 3)
  gc_frame_newslot(block2983);
// call case 5: prelude request
  params[0] = opresult2982;
  params[1] = block2983;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3004 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2972);
// compiled call node returning call3004 (depth = 2)
  gc_frame_end(frame);
  return call3004;
}
Object meth_collectionsPrelude__apply_40_1_41_3012(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_otherSize = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3014 = alloc_Float64(1);
// compiled num node returning num3014 (depth = 7)
  int op_slot_right_3013 = gc_frame_newslot(num3014);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_otherSize (depth = 7)
  int op_slot_left_3013 = gc_frame_newslot(*var_otherSize);
  params[0] = num3014;
  partcv[0] = 1;
  Object sum3016 = callmethod(*var_otherSize, "+(1)", 1, partcv, params);
// compiled op node returning sum3016 (depth = 6)
  *var_otherSize = sum3016;
  if (sum3016 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3019 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe3020 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call3021 = callmethodflags(self, "contains(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3020);
// compiled call node returning call3021 (depth = 7)
  partcv[0] = 0;
  Object call3022 = callmethodflags(call3021, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe3019);
// compiled call node returning call3022 (depth = 6)
  Object if3018 = done;
  if (istrue(call3022)) {
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool3023 = alloc_Boolean(0);
// compiled identifier node returning bool3023 (depth = 7)
  block_return(realself, bool3023);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if3018 = undefined;
  } else {
  }
// compiled if node returning if3018 (depth = 5)
  gc_frame_end(frame);
  return if3018;
}
Object meth_collectionsPrelude__61__61__40_1_41_3005(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  Object *var_Iterable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_otherSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "otherSize");
// Begin line 1420
  setline(1420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3007 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_Iterable (depth = 4)
  params[0] = *var_other;
  partcv[0] = 1;
  Object call3008 = callmethodflags(*var_Iterable, "match(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3007);
// compiled call node returning call3008 (depth = 3)
  Object if3006 = done;
  if (istrue(call3008)) {
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3009 = alloc_Float64(0);
// compiled num node returning num3009 (depth = 4)
  *var_otherSize = num3009;
  if (num3009 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3010 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3011 = alloc_Block(NULL, NULL, "collectionsPrelude", 1422);
  gc_frame_newslot(block3011);
// method "_apply(_)"
  block_savedest(block3011);
  Object closure3012 = createclosure(2, "_apply(1)");
  setclosureframe(closure3012, stackframe);
  addtoclosure(closure3012, var_otherSize);
  addtoclosure(closure3012, selfslot);
  struct UserObject *uo3012 = (struct UserObject*)block3011;
  uo3012->data[0] = (Object)closure3012;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3012 = addmethod2pos(block3011, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3012, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3012[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3012->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3012);
  meth_meth_collectionsPrelude__apply_40_1_41_3012->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3012->definitionLine = 1991;
// compiled block node returning block3011 (depth = 4)
  gc_frame_newslot(block3011);
// call case 6: other requests
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  params[0] = block3011;
  partcv[0] = 1;
  Object call3025 = callmethodflags(*var_other, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3010);
// compiled call node returning call3025 (depth = 3)
// Begin line 1428
  setline(1428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3027 = gc_frame_new();
// call case 4: self request
  Object call3028 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3027);
// compiled member node returning call3028 (depth = 4)
  int op_slot_right_3026 = gc_frame_newslot(call3028);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_otherSize (depth = 4)
  int op_slot_left_3026 = gc_frame_newslot(*var_otherSize);
  params[0] = call3028;
  partcv[0] = 1;
  Object opresult3030 = callmethod(*var_otherSize, "==(1)", 1, partcv, params);
// compiled op node returning opresult3030 (depth = 3)
    gc_frame_newslot(opresult3030);
    if3006 = opresult3030;
  } else {
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3031 = alloc_Boolean(0);
// compiled identifier node returning bool3031 (depth = 3)
    gc_frame_newslot(bool3031);
    if3006 = bool3031;
  }
// compiled if node returning if3006 (depth = 2)
  gc_frame_end(frame);
  return if3006;
}
Object meth_collectionsPrelude_copy3032(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1434
  setline(1434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3033 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3034 = gc_frame_new();
// call case 3: self.outer request
  Object call3035 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3034);
// compiled member node returning call3035 (depth = 3)
  params[0] = self;
  partcv[0] = 1;
  Object call3036 = callmethodflags(call3035, "withAll(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3033);
// compiled call node returning call3036 (depth = 2)
  gc_frame_end(frame);
  return call3036;
}
Object meth_collectionsPrelude__43__43__40_1_41_3037(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1438
  setline(1438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3038 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3039 = gc_frame_new();
// call case 4: self request
  Object call3040 = callmethodflags(self, "copy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3039);
// compiled member node returning call3040 (depth = 3)
  params[0] = *var_other;
  partcv[0] = 1;
  Object call3041 = callmethodflags(call3040, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3038);
// compiled call node returning call3041 (depth = 2)
  gc_frame_end(frame);
  return call3041;
}
Object meth_collectionsPrelude__apply_40_1_41_3053(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_other = getfromclosure(closure, 0);
  Object *var_result = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1444
  setline(1444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3055 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe3056 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call3057 = callmethodflags(*var_other, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3056);
// compiled call node returning call3057 (depth = 6)
  partcv[0] = 0;
  Object call3058 = callmethodflags(call3057, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe3055);
// compiled call node returning call3058 (depth = 5)
  Object if3054 = done;
  if (istrue(call3058)) {
// Begin line 1445
  setline(1445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3059 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call3060 = callmethodflags(*var_result, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3059);
// compiled call node returning call3060 (depth = 5)
    gc_frame_newslot(call3060);
    if3054 = call3060;
  } else {
  }
// compiled if node returning if3054 (depth = 4)
  gc_frame_end(frame);
  return if3054;
}
Object meth_collectionsPrelude__45__45__40_1_41_3042(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "--(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method --(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for --(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part --(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "result");
// Begin line 1442
  setline(1442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3043 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3044 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3045 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3046 = gc_frame_new();
// call case 3: self.outer request
  Object call3047 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3046);
// compiled member node returning call3047 (depth = 6)
  Object call3048 = callmethodflags(call3047, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe3045);
// compiled member node returning call3048 (depth = 5)
  Object call3049 = callmethodflags(call3048, "set", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3044);
// compiled member node returning call3049 (depth = 4)
  Object call3050 = callmethodflags(call3049, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe3043);
// compiled member node returning call3050 (depth = 3)
  *var_result = call3050;
  if (call3050 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3051 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile block node (depth = 3)
  Object block3052 = alloc_Block(NULL, NULL, "collectionsPrelude", 1443);
  gc_frame_newslot(block3052);
// method "_apply(_)"
  block_savedest(block3052);
  Object closure3053 = createclosure(3, "_apply(1)");
  setclosureframe(closure3053, stackframe);
  addtoclosure(closure3053, var_other);
  addtoclosure(closure3053, var_result);
  addtoclosure(closure3053, selfslot);
  struct UserObject *uo3053 = (struct UserObject*)block3052;
  uo3053->data[0] = (Object)closure3053;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3053 = addmethod2pos(block3052, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3053, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3053[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3053->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3053);
  meth_meth_collectionsPrelude__apply_40_1_41_3053->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3053->definitionLine = 1991;
// compiled block node returning block3052 (depth = 3)
  gc_frame_newslot(block3052);
// call case 5: prelude request
  params[0] = self;
  params[1] = block3052;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3062 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3051);
// compiled call node returning call3062 (depth = 2)
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude__apply_40_1_41_3067(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_other = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe3068 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call3069 = callmethodflags(*var_other, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3068);
// compiled call node returning call3069 (depth = 5)
  gc_frame_end(frame);
  return call3069;
}
Object meth_collectionsPrelude__42__42__40_1_41_3063(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "**(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method **(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for **(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part **(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3064 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 3)
  int callframe3065 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3066 = alloc_Block(NULL, NULL, "collectionsPrelude", 1452);
  gc_frame_newslot(block3066);
// method "_apply(_)"
  block_savedest(block3066);
  Object closure3067 = createclosure(2, "_apply(1)");
  setclosureframe(closure3067, stackframe);
  addtoclosure(closure3067, var_other);
  addtoclosure(closure3067, selfslot);
  struct UserObject *uo3067 = (struct UserObject*)block3066;
  uo3067->data[0] = (Object)closure3067;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3067 = addmethod2pos(block3066, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3067, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3067[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3067->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3067);
  meth_meth_collectionsPrelude__apply_40_1_41_3067->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3067->definitionLine = 1991;
// compiled block node returning block3066 (depth = 4)
  gc_frame_newslot(block3066);
// call case 4: self request
  params[0] = block3066;
  partcv[0] = 1;
  Object call3071 = callmethodflags(self, "filter(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3065);
// compiled call node returning call3071 (depth = 3)
  Object call3072 = callmethodflags(call3071, "asSet", 0, partcv, params, 0);
  gc_frame_end(callframe3064);
// compiled member node returning call3072 (depth = 2)
  gc_frame_end(frame);
  return call3072;
}
Object meth_collectionsPrelude__apply_40_1_41_3076(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s2 = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3078 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe3079 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s2 (depth = 7)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call3080 = callmethodflags(*var_s2, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3079);
// compiled call node returning call3080 (depth = 6)
  Object call3081 = callmethodflags(call3080, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3078);
// compiled member node returning call3081 (depth = 5)
  Object if3077 = done;
  if (istrue(call3081)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3082 = alloc_Boolean(0);
// compiled identifier node returning bool3082 (depth = 6)
  block_return(realself, bool3082);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3077 = undefined;
  } else {
  }
// compiled if node returning if3077 (depth = 4)
  gc_frame_end(frame);
  return if3077;
}
Object meth_collectionsPrelude_isSubset_40_1_41_3073(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSubset(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isSubset(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSubset(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s2 = &(stackframe->slots[0]);
  *var_s2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part isSubset(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3074 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3075 = alloc_Block(NULL, NULL, "collectionsPrelude", 1455);
  gc_frame_newslot(block3075);
// method "_apply(_)"
  block_savedest(block3075);
  Object closure3076 = createclosure(2, "_apply(1)");
  setclosureframe(closure3076, stackframe);
  addtoclosure(closure3076, var_s2);
  addtoclosure(closure3076, selfslot);
  struct UserObject *uo3076 = (struct UserObject*)block3075;
  uo3076->data[0] = (Object)closure3076;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3076 = addmethod2pos(block3075, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3076, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3076[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3076->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3076);
  meth_meth_collectionsPrelude__apply_40_1_41_3076->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3076->definitionLine = 1991;
// compiled block node returning block3075 (depth = 3)
  gc_frame_newslot(block3075);
// call case 4: self request
  params[0] = block3075;
  partcv[0] = 1;
  Object call3084 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3074);
// compiled call node returning call3084 (depth = 2)
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3085 = alloc_Boolean(1);
// compiled identifier node returning bool3085 (depth = 3)
  return bool3085;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_1_41_3089(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3091 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe3092 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call3093 = callmethodflags(self, "contains(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3092);
// compiled call node returning call3093 (depth = 6)
  Object call3094 = callmethodflags(call3093, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3091);
// compiled member node returning call3094 (depth = 5)
  Object if3090 = done;
  if (istrue(call3094)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3095 = alloc_Boolean(0);
// compiled identifier node returning bool3095 (depth = 6)
  block_return(realself, bool3095);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3090 = undefined;
  } else {
  }
// compiled if node returning if3090 (depth = 4)
  gc_frame_end(frame);
  return if3090;
}
Object meth_collectionsPrelude_isSuperset_40_1_41_3086(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSuperset(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isSuperset(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSuperset(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s2 = &(stackframe->slots[0]);
  *var_s2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part isSuperset(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3087 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3088 = alloc_Block(NULL, NULL, "collectionsPrelude", 1462);
  gc_frame_newslot(block3088);
// method "_apply(_)"
  block_savedest(block3088);
  Object closure3089 = createclosure(1, "_apply(1)");
  setclosureframe(closure3089, stackframe);
  addtoclosure(closure3089, selfslot);
  struct UserObject *uo3089 = (struct UserObject*)block3088;
  uo3089->data[0] = (Object)closure3089;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3089 = addmethod2pos(block3088, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3089, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3089[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3089->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3089);
  meth_meth_collectionsPrelude__apply_40_1_41_3089->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3089->definitionLine = 1991;
// compiled block node returning block3088 (depth = 3)
  gc_frame_newslot(block3088);
// call case 6: other requests
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s2 (depth = 3)
  params[0] = block3088;
  partcv[0] = 1;
  Object call3097 = callmethodflags(*var_s2, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3087);
// compiled call node returning call3097 (depth = 2)
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3098 = alloc_Boolean(1);
// compiled identifier node returning bool3098 (depth = 3)
  return bool3098;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_1_41_3102(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_existing = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe3103 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_existing (depth = 5)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call3104 = callmethodflags(*var_existing, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3103);
// compiled call node returning call3104 (depth = 4)
  gc_frame_end(frame);
  return call3104;
}
Object meth_collectionsPrelude_into_40_1_41_3099(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "into(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method into(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for into(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_existing = &(stackframe->slots[0]);
  *var_existing = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part into(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1468
  setline(1468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3100 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3101 = alloc_Block(NULL, NULL, "collectionsPrelude", 1468);
  gc_frame_newslot(block3101);
// method "_apply(_)"
  block_savedest(block3101);
  Object closure3102 = createclosure(2, "_apply(1)");
  setclosureframe(closure3102, stackframe);
  addtoclosure(closure3102, var_existing);
  addtoclosure(closure3102, selfslot);
  struct UserObject *uo3102 = (struct UserObject*)block3101;
  uo3102->data[0] = (Object)closure3102;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3102 = addmethod2pos(block3101, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3102, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3102[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3102->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3102);
  meth_meth_collectionsPrelude__apply_40_1_41_3102->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3102->definitionLine = 1991;
// compiled block node returning block3101 (depth = 3)
  gc_frame_newslot(block3101);
// call case 4: self request
  params[0] = block3101;
  partcv[0] = 1;
  Object call3106 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3100);
// compiled call node returning call3106 (depth = 2)
// Begin line 1469
  setline(1469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_existing (depth = 2)
  gc_frame_end(frame);
  return *var_existing;
}
Object meth_collectionsPrelude__apply_40_1_41_3117(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3118 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3119 = gc_frame_new();
// call case 4: self request
  Object call3120 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3119);
// compiled member node returning call3120 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3121 = callmethodflags(call3120, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3118);
// compiled call node returning call3121 (depth = 4)
  gc_frame_end(frame);
  return call3121;
}
Object meth_collectionsPrelude_ofCapacity_40_1_41_2332(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ofCapacity(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ofCapacity(_)");
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  Object *var_ConcurrentModification = getfromclosure(closure, 4);
  Object *var_IteratorExhausted = getfromclosure(closure, 5);
  Object *var_Iterable = getfromclosure(closure, 6);
  Object *var_collection = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ofCapacity(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cap = &(stackframe->slots[0]);
  *var_cap = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ofCapacity(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2333 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2333 = alloc_userobj2(34,32, objclass2333);
  gc_frame_newslot(obj2333);
if (objclass2333 == NULL) {
  glfree(obj2333->class->name);
  obj2333->class->name = "set.ofCapacity(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2333, self, 0);
  addmethodreal(obj2333,"outer", &reader_collectionsPrelude_outer_2334);
  Object oldself2333 = self;
  struct StackFrameObject *oldstackframe2333 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2333);
  gc_frame_newslot((Object)stackframe);
  self = obj2333;
  Object *oldselfslot2333 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2333 = (*(struct UserObject *)self).data[0], lowerouter2333 = thisouter2333;
  if (inheritingObject2333) {
    struct UserObject *inho2333 = (struct UserObject *)inheritingObject2333;
    while (inho2333->super != GraceDefaultObject) inho2333 = (struct UserObject *)inho2333->super;
    inho2333->super = obj2333;
    self = inheritingObject2333;
    *selfslot = self;
    lowerouter2333 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2333;
  }
if (objclass2333 == NULL) {
  Method *reader2335 = addmethodrealflags(obj2333, "mods", &reader_collectionsPrelude_mods_2335, 0);
  Method *writer2335 = addmethodrealflags(obj2333, "mods:=(1)", &writer_collectionsPrelude_mods_2335, MFLAG_CONFIDENTIAL);
  reader2335->definitionModule = modulename;
  writer2335->definitionModule = modulename;
  reader2335->definitionLine = 1202;
  writer2335->definitionLine = 1202;
}
obj2333->flags |= OFLAG_MUTABLE;
adddatum2(obj2333, alloc_Undefined(), 1);
if (objclass2333 == NULL) {
  Method *reader2336 = addmethodrealflags(obj2333, "inner", &reader_collectionsPrelude_inner_2336, MFLAG_CONFIDENTIAL);
  Method *writer2336 = addmethodrealflags(obj2333, "inner:=(1)", &writer_collectionsPrelude_inner_2336, MFLAG_CONFIDENTIAL);
  reader2336->definitionModule = modulename;
  writer2336->definitionModule = modulename;
  reader2336->definitionLine = 1203;
  writer2336->definitionLine = 1203;
}
obj2333->flags |= OFLAG_MUTABLE;
adddatum2(obj2333, alloc_Undefined(), 2);
if (objclass2333 == NULL) {
  Method *reader2337 = addmethodrealflags(obj2333, "size", &reader_collectionsPrelude_size_2337, 0);
  Method *writer2337 = addmethodrealflags(obj2333, "size:=(1)", &writer_collectionsPrelude_size_2337, MFLAG_CONFIDENTIAL);
  reader2337->definitionModule = modulename;
  writer2337->definitionModule = modulename;
  reader2337->definitionLine = 1204;
  writer2337->definitionLine = 1204;
}
obj2333->flags |= OFLAG_MUTABLE;
adddatum2(obj2333, alloc_Undefined(), 3);
// method "addAll(_)"
  struct UserObject *uo2338 = (struct UserObject*)obj2333;
  uo2338->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll_40_1_41_2338 = addmethod2pos(obj2333, "addAll(1)", &meth_collectionsPrelude_addAll_40_1_41_2338, 4);
  int argcv_meth_collectionsPrelude_addAll_40_1_41_2338[] = {1};
  meth_meth_collectionsPrelude_addAll_40_1_41_2338->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll_40_1_41_2338);
  meth_meth_collectionsPrelude_addAll_40_1_41_2338->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll_40_1_41_2338->definitionLine = 1209;
// method "add(_)"
  struct UserObject *uo2387 = (struct UserObject*)obj2333;
  uo2387->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add_40_1_41_2387 = addmethod2pos(obj2333, "add(1)", &meth_collectionsPrelude_add_40_1_41_2387, 5);
  int argcv_meth_collectionsPrelude_add_40_1_41_2387[] = {1};
  meth_meth_collectionsPrelude_add_40_1_41_2387->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add_40_1_41_2387);
  meth_meth_collectionsPrelude_add_40_1_41_2387->definitionModule = modulename;
  meth_meth_collectionsPrelude_add_40_1_41_2387->definitionLine = 1224;
// method "removeAll(_)"
  block_savedest(obj2333);
  Object closure2431 = createclosure(1, "removeAll(1)");
  setclosureframe(closure2431, stackframe);
  addtoclosure(closure2431, var_NoSuchObject);
  struct UserObject *uo2431 = (struct UserObject*)obj2333;
  uo2431->data[6] = (Object)closure2431;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_2431 = addmethod2pos(obj2333, "removeAll(1)", &meth_collectionsPrelude_removeAll_40_1_41_2431, 6);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_2431[] = {1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_2431->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll_40_1_41_2431);
  meth_meth_collectionsPrelude_removeAll_40_1_41_2431->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_2431->definitionLine = 1237;
// method "removeAll(_)ifAbsent(_)"
  block_savedest(obj2333);
  Object closure2452 = createclosure(1, "removeAll(1)ifAbsent(1)");
  setclosureframe(closure2452, stackframe);
  addtoclosure(closure2452, var_removed);
  struct UserObject *uo2452 = (struct UserObject*)obj2333;
  uo2452->data[7] = (Object)closure2452;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2452 = addmethod2pos(obj2333, "removeAll(1)ifAbsent(1)", &meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2452, 7);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2452[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2452->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2452);
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2452->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2452->definitionLine = 1245;
// method "clear"
  block_savedest(obj2333);
  Object closure2490 = createclosure(2, "clear");
  setclosureframe(closure2490, stackframe);
  addtoclosure(closure2490, var_cap);
  addtoclosure(closure2490, var__prelude);
  struct UserObject *uo2490 = (struct UserObject*)obj2333;
  uo2490->data[8] = (Object)closure2490;
  Method *meth_meth_collectionsPrelude_clear2490 = addmethod2pos(obj2333, "clear", &meth_collectionsPrelude_clear2490, 8);
  int argcv_meth_collectionsPrelude_clear2490[] = {0};
  meth_meth_collectionsPrelude_clear2490->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_clear2490);
  meth_meth_collectionsPrelude_clear2490->definitionModule = modulename;
  meth_meth_collectionsPrelude_clear2490->definitionLine = 1258;
// method "remove(_)ifAbsent(_)"
  block_savedest(obj2333);
  Object closure2508 = createclosure(1, "remove(1)ifAbsent(1)");
  setclosureframe(closure2508, stackframe);
  addtoclosure(closure2508, var_removed);
  struct UserObject *uo2508 = (struct UserObject*)obj2333;
  uo2508->data[9] = (Object)closure2508;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2508 = addmethod2pos(obj2333, "remove(1)ifAbsent(1)", &meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2508, 9);
  int argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2508[] = {1, 1};
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2508->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2508);
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2508->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2508->definitionLine = 1265;
// method "remove(_)"
  block_savedest(obj2333);
  Object closure2541 = createclosure(1, "remove(1)");
  setclosureframe(closure2541, stackframe);
  addtoclosure(closure2541, var_NoSuchObject);
  struct UserObject *uo2541 = (struct UserObject*)obj2333;
  uo2541->data[10] = (Object)closure2541;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_2541 = addmethod2pos(obj2333, "remove(1)", &meth_collectionsPrelude_remove_40_1_41_2541, 10);
  int argcv_meth_collectionsPrelude_remove_40_1_41_2541[] = {1};
  meth_meth_collectionsPrelude_remove_40_1_41_2541->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove_40_1_41_2541);
  meth_meth_collectionsPrelude_remove_40_1_41_2541->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_2541->definitionLine = 1277;
// method "contains(_)"
  struct UserObject *uo2557 = (struct UserObject*)obj2333;
  uo2557->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_2557 = addmethod2pos(obj2333, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_2557, 11);
  int argcv_meth_collectionsPrelude_contains_40_1_41_2557[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_2557->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_2557);
  meth_meth_collectionsPrelude_contains_40_1_41_2557->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_2557->definitionLine = 1284;
// method "includes(_)"
  struct UserObject *uo2570 = (struct UserObject*)obj2333;
  uo2570->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_includes_40_1_41_2570 = addmethod2pos(obj2333, "includes(1)", &meth_collectionsPrelude_includes_40_1_41_2570, 12);
  int argcv_meth_collectionsPrelude_includes_40_1_41_2570[] = {1};
  meth_meth_collectionsPrelude_includes_40_1_41_2570->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_includes_40_1_41_2570);
  meth_meth_collectionsPrelude_includes_40_1_41_2570->definitionModule = modulename;
  meth_meth_collectionsPrelude_includes_40_1_41_2570->definitionLine = 1291;
// method "find(_)ifNone(_)"
  struct UserObject *uo2581 = (struct UserObject*)obj2333;
  uo2581->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2581 = addmethod2pos(obj2333, "find(1)ifNone(1)", &meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2581, 13);
  int argcv_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2581[] = {1, 1};
  meth_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2581->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2581);
  meth_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2581->definitionModule = modulename;
  meth_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2581->definitionLine = 1297;
// method "findPosition(_)"
  block_savedest(obj2333);
  Object closure2592 = createclosure(1, "findPosition(1)");
  setclosureframe(closure2592, stackframe);
  addtoclosure(closure2592, var_unused);
  struct UserObject *uo2592 = (struct UserObject*)obj2333;
  uo2592->data[14] = (Object)closure2592;
  Method *meth_meth_collectionsPrelude_findPosition_40_1_41_2592 = addmethod2pos(obj2333, "findPosition(1)", &meth_collectionsPrelude_findPosition_40_1_41_2592, 14);
  int argcv_meth_collectionsPrelude_findPosition_40_1_41_2592[] = {1};
  meth_meth_collectionsPrelude_findPosition_40_1_41_2592->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPosition_40_1_41_2592);
  meth_meth_collectionsPrelude_findPosition_40_1_41_2592->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPosition_40_1_41_2592->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPosition_40_1_41_2592->definitionLine = 1303;
// method "findPositionForAdd(_)"
  block_savedest(obj2333);
  Object closure2653 = createclosure(2, "findPositionForAdd(1)");
  setclosureframe(closure2653, stackframe);
  addtoclosure(closure2653, var_removed);
  addtoclosure(closure2653, var_unused);
  struct UserObject *uo2653 = (struct UserObject*)obj2333;
  uo2653->data[15] = (Object)closure2653;
  Method *meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2653 = addmethod2pos(obj2333, "findPositionForAdd(1)", &meth_collectionsPrelude_findPositionForAdd_40_1_41_2653, 15);
  int argcv_meth_collectionsPrelude_findPositionForAdd_40_1_41_2653[] = {1};
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2653->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPositionForAdd_40_1_41_2653);
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2653->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2653->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2653->definitionLine = 1325;
// method "asString"
  struct UserObject *uo2720 = (struct UserObject*)obj2333;
  uo2720->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2720 = addmethod2pos(obj2333, "asString", &meth_collectionsPrelude_asString2720, 16);
  int argcv_meth_collectionsPrelude_asString2720[] = {0};
  meth_meth_collectionsPrelude_asString2720->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2720);
  meth_meth_collectionsPrelude_asString2720->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2720->definitionLine = 1348;
// method "asDebugString"
  struct UserObject *uo2745 = (struct UserObject*)obj2333;
  uo2745->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString2745 = addmethod2pos(obj2333, "asDebugString", &meth_collectionsPrelude_asDebugString2745, 17);
  int argcv_meth_collectionsPrelude_asDebugString2745[] = {0};
  meth_meth_collectionsPrelude_asDebugString2745->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString2745);
  meth_meth_collectionsPrelude_asDebugString2745->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString2745->definitionLine = 1354;
// method "extend(_)"
  struct UserObject *uo2770 = (struct UserObject*)obj2333;
  uo2770->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_extend_40_1_41_2770 = addmethod2pos(obj2333, "extend(1)", &meth_collectionsPrelude_extend_40_1_41_2770, 18);
  int argcv_meth_collectionsPrelude_extend_40_1_41_2770[] = {1};
  meth_meth_collectionsPrelude_extend_40_1_41_2770->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_extend_40_1_41_2770);
  meth_meth_collectionsPrelude_extend_40_1_41_2770->definitionModule = modulename;
  meth_meth_collectionsPrelude_extend_40_1_41_2770->definitionLine = 1360;
// method "do(_)"
  block_savedest(obj2333);
  Object closure2778 = createclosure(2, "do(1)");
  setclosureframe(closure2778, stackframe);
  addtoclosure(closure2778, var_removed);
  addtoclosure(closure2778, var_unused);
  struct UserObject *uo2778 = (struct UserObject*)obj2333;
  uo2778->data[19] = (Object)closure2778;
  Method *meth_meth_collectionsPrelude_do_40_1_41_2778 = addmethod2pos(obj2333, "do(1)", &meth_collectionsPrelude_do_40_1_41_2778, 19);
  int argcv_meth_collectionsPrelude_do_40_1_41_2778[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_2778->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_2778);
  meth_meth_collectionsPrelude_do_40_1_41_2778->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_2778->definitionLine = 1365;
// method "iterator"
  block_savedest(obj2333);
  Object closure2821 = createclosure(4, "iterator");
  setclosureframe(closure2821, stackframe);
  addtoclosure(closure2821, var_ConcurrentModification);
  addtoclosure(closure2821, var_IteratorExhausted);
  addtoclosure(closure2821, var_removed);
  addtoclosure(closure2821, var_unused);
  struct UserObject *uo2821 = (struct UserObject*)obj2333;
  uo2821->data[20] = (Object)closure2821;
  Method *meth_meth_collectionsPrelude_iterator2821 = addmethod2pos(obj2333, "iterator", &meth_collectionsPrelude_iterator2821, 20);
  int argcv_meth_collectionsPrelude_iterator2821[] = {0};
  meth_meth_collectionsPrelude_iterator2821->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator2821);
  meth_meth_collectionsPrelude_iterator2821->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2821->definitionLine = 1378;
  block_savedest(obj2333);
  Object closure2930 = createclosure(4, "iterator$object(1)");
  setclosureframe(closure2930, stackframe);
  addtoclosure(closure2930, var_ConcurrentModification);
  addtoclosure(closure2930, var_IteratorExhausted);
  addtoclosure(closure2930, var_removed);
  addtoclosure(closure2930, var_unused);
  Method *meth_meth_collectionsPrelude_iterator2821_object = addmethod2pos(obj2333, "iterator$object(1)", &meth_collectionsPrelude_iterator2821_object, 20);
  meth_meth_collectionsPrelude_iterator2821_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2821_object->definitionLine = 1378;
// method "expand"
  block_savedest(obj2333);
  Object closure2931 = createclosure(3, "expand");
  setclosureframe(closure2931, stackframe);
  addtoclosure(closure2931, var__prelude);
  addtoclosure(closure2931, var_unused);
  addtoclosure(closure2931, var_removed);
  struct UserObject *uo2931 = (struct UserObject*)obj2333;
  uo2931->data[21] = (Object)closure2931;
  Method *meth_meth_collectionsPrelude_expand2931 = addmethod2pos(obj2333, "expand", &meth_collectionsPrelude_expand2931, 21);
  int argcv_meth_collectionsPrelude_expand2931[] = {0};
  meth_meth_collectionsPrelude_expand2931->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expand2931);
  meth_meth_collectionsPrelude_expand2931->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expand2931->definitionModule = modulename;
  meth_meth_collectionsPrelude_expand2931->definitionLine = 1404;
// method "==(_)"
  block_savedest(obj2333);
  Object closure3005 = createclosure(1, "==(1)");
  setclosureframe(closure3005, stackframe);
  addtoclosure(closure3005, var_Iterable);
  struct UserObject *uo3005 = (struct UserObject*)obj2333;
  uo3005->data[22] = (Object)closure3005;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_3005 = addmethod2pos(obj2333, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_3005, 22);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_3005[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_3005->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_3005);
  meth_meth_collectionsPrelude__61__61__40_1_41_3005->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_3005->definitionLine = 1419;
// method "copy"
  struct UserObject *uo3032 = (struct UserObject*)obj2333;
  uo3032->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy3032 = addmethod2pos(obj2333, "copy", &meth_collectionsPrelude_copy3032, 23);
  int argcv_meth_collectionsPrelude_copy3032[] = {0};
  meth_meth_collectionsPrelude_copy3032->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy3032);
  meth_meth_collectionsPrelude_copy3032->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy3032->definitionLine = 1433;
// method "++(_)"
  struct UserObject *uo3037 = (struct UserObject*)obj2333;
  uo3037->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_3037 = addmethod2pos(obj2333, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_3037, 24);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_3037[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_3037->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_3037);
  meth_meth_collectionsPrelude__43__43__40_1_41_3037->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_3037->definitionLine = 1436;
// method "--(_)"
  struct UserObject *uo3042 = (struct UserObject*)obj2333;
  uo3042->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude__45__45__40_1_41_3042 = addmethod2pos(obj2333, "--(1)", &meth_collectionsPrelude__45__45__40_1_41_3042, 25);
  int argcv_meth_collectionsPrelude__45__45__40_1_41_3042[] = {1};
  meth_meth_collectionsPrelude__45__45__40_1_41_3042->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__45__45__40_1_41_3042);
  meth_meth_collectionsPrelude__45__45__40_1_41_3042->definitionModule = modulename;
  meth_meth_collectionsPrelude__45__45__40_1_41_3042->definitionLine = 1440;
// method "**(_)"
  struct UserObject *uo3063 = (struct UserObject*)obj2333;
  uo3063->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude__42__42__40_1_41_3063 = addmethod2pos(obj2333, "**(1)", &meth_collectionsPrelude__42__42__40_1_41_3063, 26);
  int argcv_meth_collectionsPrelude__42__42__40_1_41_3063[] = {1};
  meth_meth_collectionsPrelude__42__42__40_1_41_3063->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__42__42__40_1_41_3063);
  meth_meth_collectionsPrelude__42__42__40_1_41_3063->definitionModule = modulename;
  meth_meth_collectionsPrelude__42__42__40_1_41_3063->definitionLine = 1450;
// method "isSubset(_)"
  struct UserObject *uo3073 = (struct UserObject*)obj2333;
  uo3073->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isSubset_40_1_41_3073 = addmethod2pos(obj2333, "isSubset(1)", &meth_collectionsPrelude_isSubset_40_1_41_3073, 27);
  int argcv_meth_collectionsPrelude_isSubset_40_1_41_3073[] = {1};
  meth_meth_collectionsPrelude_isSubset_40_1_41_3073->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isSubset_40_1_41_3073);
  meth_meth_collectionsPrelude_isSubset_40_1_41_3073->definitionModule = modulename;
  meth_meth_collectionsPrelude_isSubset_40_1_41_3073->definitionLine = 1454;
// method "isSuperset(_)"
  struct UserObject *uo3086 = (struct UserObject*)obj2333;
  uo3086->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isSuperset_40_1_41_3086 = addmethod2pos(obj2333, "isSuperset(1)", &meth_collectionsPrelude_isSuperset_40_1_41_3086, 28);
  int argcv_meth_collectionsPrelude_isSuperset_40_1_41_3086[] = {1};
  meth_meth_collectionsPrelude_isSuperset_40_1_41_3086->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isSuperset_40_1_41_3086);
  meth_meth_collectionsPrelude_isSuperset_40_1_41_3086->definitionModule = modulename;
  meth_meth_collectionsPrelude_isSuperset_40_1_41_3086->definitionLine = 1461;
// method "into(_)"
  struct UserObject *uo3099 = (struct UserObject*)obj2333;
  uo3099->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into_40_1_41_3099 = addmethod2pos(obj2333, "into(1)", &meth_collectionsPrelude_into_40_1_41_3099, 29);
  int argcv_meth_collectionsPrelude_into_40_1_41_3099[] = {1};
  meth_meth_collectionsPrelude_into_40_1_41_3099->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into_40_1_41_3099);
  meth_meth_collectionsPrelude_into_40_1_41_3099->definitionModule = modulename;
  meth_meth_collectionsPrelude_into_40_1_41_3099->definitionLine = 1467;
  sourceObject = obj2333;
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3107 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3108 = callmethodflags(*var_collection, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3107);
// compiled call node returning call3108 (depth = 2)
  struct UserObject *obj2333_uo = (struct UserObject *)obj2333;
  obj2333_uo->super = call3108;
  sourceObject = obj2333;
// Begin line 1202
  setline(1202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num3109 = alloc_Float64(0);
// compiled num node returning num3109 (depth = 2)
  adddatum2(obj2333, num3109, 1);
  sourceObject = obj2333;
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3110 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cap (depth = 3)
  gc_frame_newslot(*var_cap);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3111 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__prelude (depth = 4)
  Object call3112 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe3111);
// compiled member node returning call3112 (depth = 3)
  params[0] = *var_cap;
  partcv[0] = 1;
  Object call3113 = callmethodflags(call3112, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3110);
// compiled call node returning call3113 (depth = 2)
  adddatum2(obj2333, call3113, 2);
  sourceObject = obj2333;
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num3114 = alloc_Float64(0);
// compiled num node returning num3114 (depth = 2)
  adddatum2(obj2333, num3114, 3);
  sourceObject = obj2333;
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3115 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3116 = alloc_Block(NULL, NULL, "collectionsPrelude", 1205);
  gc_frame_newslot(block3116);
// method "_apply(_)"
  block_savedest(block3116);
  Object closure3117 = createclosure(2, "_apply(1)");
  setclosureframe(closure3117, stackframe);
  addtoclosure(closure3117, var_unused);
  addtoclosure(closure3117, selfslot);
  struct UserObject *uo3117 = (struct UserObject*)block3116;
  uo3117->data[0] = (Object)closure3117;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3117 = addmethod2pos(block3116, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3117, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3117[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3117->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3117);
  meth_meth_collectionsPrelude__apply_40_1_41_3117->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3117->definitionLine = 1991;
// compiled block node returning block3116 (depth = 3)
  gc_frame_newslot(block3116);
// call case 6: other requests
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3125 = alloc_Float64(1);
// compiled num node returning num3125 (depth = 5)
  int op_slot_right_3124 = gc_frame_newslot(num3125);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cap (depth = 5)
  int op_slot_left_3124 = gc_frame_newslot(*var_cap);
  params[0] = num3125;
  partcv[0] = 1;
  Object diff3127 = callmethod(*var_cap, "-(1)", 1, partcv, params);
// compiled op node returning diff3127 (depth = 4)
  int op_slot_right_3123 = gc_frame_newslot(diff3127);
// starting to compile num node (depth = 4)
  Object num3129 = alloc_Float64(0);
// compiled num node returning num3129 (depth = 4)
  int op_slot_left_3123 = gc_frame_newslot(num3129);
  params[0] = diff3127;
  partcv[0] = 1;
  Object opresult3130 = callmethod(num3129, "..(1)", 1, partcv, params);
// compiled op node returning opresult3130 (depth = 3)
  params[0] = block3116;
  partcv[0] = 1;
  Object call3131 = callmethodflags(opresult3130, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3115);
// compiled call node returning call3131 (depth = 2)
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  objclass2333 = obj2333->class;
  objclass2333->definitionModule = modulename;
  objclass2333->definitionLine = 1200;
  (*(struct UserObject *)self).data[0] = lowerouter2333;
  self = oldself2333;
  selfslot = oldselfslot2333;
  stackframe = oldstackframe2333;
  gc_frame_end(frame);
  return obj2333;
}
Object meth_collectionsPrelude_ofCapacity_40_1_41_2332_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ofCapacity(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method ofCapacity(_)");
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  Object *var_ConcurrentModification = getfromclosure(closure, 4);
  Object *var_IteratorExhausted = getfromclosure(closure, 5);
  Object *var_Iterable = getfromclosure(closure, 6);
  Object *var_collection = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ofCapacity(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cap = &(stackframe->slots[0]);
  *var_cap = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ofCapacity(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2333 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2333 = alloc_userobj2(34,32, objclass2333);
  gc_frame_newslot(obj2333);
if (objclass2333 == NULL) {
  glfree(obj2333->class->name);
  obj2333->class->name = "set.ofCapacity(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2333, self, 0);
  addmethodreal(obj2333,"outer", &reader_collectionsPrelude_outer_2334);
  Object oldself2333 = self;
  struct StackFrameObject *oldstackframe2333 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2333);
  gc_frame_newslot((Object)stackframe);
  self = obj2333;
  Object *oldselfslot2333 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2333 = (*(struct UserObject *)self).data[0], lowerouter2333 = thisouter2333;
  if (inheritingObject2333) {
    struct UserObject *inho2333 = (struct UserObject *)inheritingObject2333;
    while (inho2333->super != GraceDefaultObject) inho2333 = (struct UserObject *)inho2333->super;
    inho2333->super = obj2333;
    self = inheritingObject2333;
    *selfslot = self;
    lowerouter2333 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2333;
  }
if (objclass2333 == NULL) {
  Method *reader2335 = addmethodrealflags(obj2333, "mods", &reader_collectionsPrelude_mods_2335, 0);
  Method *writer2335 = addmethodrealflags(obj2333, "mods:=(1)", &writer_collectionsPrelude_mods_2335, MFLAG_CONFIDENTIAL);
  reader2335->definitionModule = modulename;
  writer2335->definitionModule = modulename;
  reader2335->definitionLine = 1202;
  writer2335->definitionLine = 1202;
}
obj2333->flags |= OFLAG_MUTABLE;
adddatum2(obj2333, alloc_Undefined(), 1);
if (objclass2333 == NULL) {
  Method *reader2336 = addmethodrealflags(obj2333, "inner", &reader_collectionsPrelude_inner_2336, MFLAG_CONFIDENTIAL);
  Method *writer2336 = addmethodrealflags(obj2333, "inner:=(1)", &writer_collectionsPrelude_inner_2336, MFLAG_CONFIDENTIAL);
  reader2336->definitionModule = modulename;
  writer2336->definitionModule = modulename;
  reader2336->definitionLine = 1203;
  writer2336->definitionLine = 1203;
}
obj2333->flags |= OFLAG_MUTABLE;
adddatum2(obj2333, alloc_Undefined(), 2);
if (objclass2333 == NULL) {
  Method *reader2337 = addmethodrealflags(obj2333, "size", &reader_collectionsPrelude_size_2337, 0);
  Method *writer2337 = addmethodrealflags(obj2333, "size:=(1)", &writer_collectionsPrelude_size_2337, MFLAG_CONFIDENTIAL);
  reader2337->definitionModule = modulename;
  writer2337->definitionModule = modulename;
  reader2337->definitionLine = 1204;
  writer2337->definitionLine = 1204;
}
obj2333->flags |= OFLAG_MUTABLE;
adddatum2(obj2333, alloc_Undefined(), 3);
// method "addAll(_)"
  struct UserObject *uo2338 = (struct UserObject*)obj2333;
  uo2338->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll_40_1_41_2338 = addmethod2pos(obj2333, "addAll(1)", &meth_collectionsPrelude_addAll_40_1_41_2338, 4);
  int argcv_meth_collectionsPrelude_addAll_40_1_41_2338[] = {1};
  meth_meth_collectionsPrelude_addAll_40_1_41_2338->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll_40_1_41_2338);
  meth_meth_collectionsPrelude_addAll_40_1_41_2338->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll_40_1_41_2338->definitionLine = 1209;
// method "add(_)"
  struct UserObject *uo2387 = (struct UserObject*)obj2333;
  uo2387->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add_40_1_41_2387 = addmethod2pos(obj2333, "add(1)", &meth_collectionsPrelude_add_40_1_41_2387, 5);
  int argcv_meth_collectionsPrelude_add_40_1_41_2387[] = {1};
  meth_meth_collectionsPrelude_add_40_1_41_2387->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add_40_1_41_2387);
  meth_meth_collectionsPrelude_add_40_1_41_2387->definitionModule = modulename;
  meth_meth_collectionsPrelude_add_40_1_41_2387->definitionLine = 1224;
// method "removeAll(_)"
  block_savedest(obj2333);
  Object closure2431 = createclosure(1, "removeAll(1)");
  setclosureframe(closure2431, stackframe);
  addtoclosure(closure2431, var_NoSuchObject);
  struct UserObject *uo2431 = (struct UserObject*)obj2333;
  uo2431->data[6] = (Object)closure2431;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_2431 = addmethod2pos(obj2333, "removeAll(1)", &meth_collectionsPrelude_removeAll_40_1_41_2431, 6);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_2431[] = {1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_2431->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll_40_1_41_2431);
  meth_meth_collectionsPrelude_removeAll_40_1_41_2431->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_2431->definitionLine = 1237;
// method "removeAll(_)ifAbsent(_)"
  block_savedest(obj2333);
  Object closure2452 = createclosure(1, "removeAll(1)ifAbsent(1)");
  setclosureframe(closure2452, stackframe);
  addtoclosure(closure2452, var_removed);
  struct UserObject *uo2452 = (struct UserObject*)obj2333;
  uo2452->data[7] = (Object)closure2452;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2452 = addmethod2pos(obj2333, "removeAll(1)ifAbsent(1)", &meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2452, 7);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2452[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2452->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2452);
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2452->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2452->definitionLine = 1245;
// method "clear"
  block_savedest(obj2333);
  Object closure2490 = createclosure(2, "clear");
  setclosureframe(closure2490, stackframe);
  addtoclosure(closure2490, var_cap);
  addtoclosure(closure2490, var__prelude);
  struct UserObject *uo2490 = (struct UserObject*)obj2333;
  uo2490->data[8] = (Object)closure2490;
  Method *meth_meth_collectionsPrelude_clear2490 = addmethod2pos(obj2333, "clear", &meth_collectionsPrelude_clear2490, 8);
  int argcv_meth_collectionsPrelude_clear2490[] = {0};
  meth_meth_collectionsPrelude_clear2490->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_clear2490);
  meth_meth_collectionsPrelude_clear2490->definitionModule = modulename;
  meth_meth_collectionsPrelude_clear2490->definitionLine = 1258;
// method "remove(_)ifAbsent(_)"
  block_savedest(obj2333);
  Object closure2508 = createclosure(1, "remove(1)ifAbsent(1)");
  setclosureframe(closure2508, stackframe);
  addtoclosure(closure2508, var_removed);
  struct UserObject *uo2508 = (struct UserObject*)obj2333;
  uo2508->data[9] = (Object)closure2508;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2508 = addmethod2pos(obj2333, "remove(1)ifAbsent(1)", &meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2508, 9);
  int argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2508[] = {1, 1};
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2508->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2508);
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2508->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2508->definitionLine = 1265;
// method "remove(_)"
  block_savedest(obj2333);
  Object closure2541 = createclosure(1, "remove(1)");
  setclosureframe(closure2541, stackframe);
  addtoclosure(closure2541, var_NoSuchObject);
  struct UserObject *uo2541 = (struct UserObject*)obj2333;
  uo2541->data[10] = (Object)closure2541;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_2541 = addmethod2pos(obj2333, "remove(1)", &meth_collectionsPrelude_remove_40_1_41_2541, 10);
  int argcv_meth_collectionsPrelude_remove_40_1_41_2541[] = {1};
  meth_meth_collectionsPrelude_remove_40_1_41_2541->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove_40_1_41_2541);
  meth_meth_collectionsPrelude_remove_40_1_41_2541->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_2541->definitionLine = 1277;
// method "contains(_)"
  struct UserObject *uo2557 = (struct UserObject*)obj2333;
  uo2557->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_2557 = addmethod2pos(obj2333, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_2557, 11);
  int argcv_meth_collectionsPrelude_contains_40_1_41_2557[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_2557->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_2557);
  meth_meth_collectionsPrelude_contains_40_1_41_2557->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_2557->definitionLine = 1284;
// method "includes(_)"
  struct UserObject *uo2570 = (struct UserObject*)obj2333;
  uo2570->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_includes_40_1_41_2570 = addmethod2pos(obj2333, "includes(1)", &meth_collectionsPrelude_includes_40_1_41_2570, 12);
  int argcv_meth_collectionsPrelude_includes_40_1_41_2570[] = {1};
  meth_meth_collectionsPrelude_includes_40_1_41_2570->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_includes_40_1_41_2570);
  meth_meth_collectionsPrelude_includes_40_1_41_2570->definitionModule = modulename;
  meth_meth_collectionsPrelude_includes_40_1_41_2570->definitionLine = 1291;
// method "find(_)ifNone(_)"
  struct UserObject *uo2581 = (struct UserObject*)obj2333;
  uo2581->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2581 = addmethod2pos(obj2333, "find(1)ifNone(1)", &meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2581, 13);
  int argcv_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2581[] = {1, 1};
  meth_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2581->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2581);
  meth_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2581->definitionModule = modulename;
  meth_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2581->definitionLine = 1297;
// method "findPosition(_)"
  block_savedest(obj2333);
  Object closure2592 = createclosure(1, "findPosition(1)");
  setclosureframe(closure2592, stackframe);
  addtoclosure(closure2592, var_unused);
  struct UserObject *uo2592 = (struct UserObject*)obj2333;
  uo2592->data[14] = (Object)closure2592;
  Method *meth_meth_collectionsPrelude_findPosition_40_1_41_2592 = addmethod2pos(obj2333, "findPosition(1)", &meth_collectionsPrelude_findPosition_40_1_41_2592, 14);
  int argcv_meth_collectionsPrelude_findPosition_40_1_41_2592[] = {1};
  meth_meth_collectionsPrelude_findPosition_40_1_41_2592->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPosition_40_1_41_2592);
  meth_meth_collectionsPrelude_findPosition_40_1_41_2592->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPosition_40_1_41_2592->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPosition_40_1_41_2592->definitionLine = 1303;
// method "findPositionForAdd(_)"
  block_savedest(obj2333);
  Object closure2653 = createclosure(2, "findPositionForAdd(1)");
  setclosureframe(closure2653, stackframe);
  addtoclosure(closure2653, var_removed);
  addtoclosure(closure2653, var_unused);
  struct UserObject *uo2653 = (struct UserObject*)obj2333;
  uo2653->data[15] = (Object)closure2653;
  Method *meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2653 = addmethod2pos(obj2333, "findPositionForAdd(1)", &meth_collectionsPrelude_findPositionForAdd_40_1_41_2653, 15);
  int argcv_meth_collectionsPrelude_findPositionForAdd_40_1_41_2653[] = {1};
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2653->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPositionForAdd_40_1_41_2653);
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2653->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2653->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2653->definitionLine = 1325;
// method "asString"
  struct UserObject *uo2720 = (struct UserObject*)obj2333;
  uo2720->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2720 = addmethod2pos(obj2333, "asString", &meth_collectionsPrelude_asString2720, 16);
  int argcv_meth_collectionsPrelude_asString2720[] = {0};
  meth_meth_collectionsPrelude_asString2720->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2720);
  meth_meth_collectionsPrelude_asString2720->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2720->definitionLine = 1348;
// method "asDebugString"
  struct UserObject *uo2745 = (struct UserObject*)obj2333;
  uo2745->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString2745 = addmethod2pos(obj2333, "asDebugString", &meth_collectionsPrelude_asDebugString2745, 17);
  int argcv_meth_collectionsPrelude_asDebugString2745[] = {0};
  meth_meth_collectionsPrelude_asDebugString2745->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString2745);
  meth_meth_collectionsPrelude_asDebugString2745->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString2745->definitionLine = 1354;
// method "extend(_)"
  struct UserObject *uo2770 = (struct UserObject*)obj2333;
  uo2770->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_extend_40_1_41_2770 = addmethod2pos(obj2333, "extend(1)", &meth_collectionsPrelude_extend_40_1_41_2770, 18);
  int argcv_meth_collectionsPrelude_extend_40_1_41_2770[] = {1};
  meth_meth_collectionsPrelude_extend_40_1_41_2770->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_extend_40_1_41_2770);
  meth_meth_collectionsPrelude_extend_40_1_41_2770->definitionModule = modulename;
  meth_meth_collectionsPrelude_extend_40_1_41_2770->definitionLine = 1360;
// method "do(_)"
  block_savedest(obj2333);
  Object closure2778 = createclosure(2, "do(1)");
  setclosureframe(closure2778, stackframe);
  addtoclosure(closure2778, var_removed);
  addtoclosure(closure2778, var_unused);
  struct UserObject *uo2778 = (struct UserObject*)obj2333;
  uo2778->data[19] = (Object)closure2778;
  Method *meth_meth_collectionsPrelude_do_40_1_41_2778 = addmethod2pos(obj2333, "do(1)", &meth_collectionsPrelude_do_40_1_41_2778, 19);
  int argcv_meth_collectionsPrelude_do_40_1_41_2778[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_2778->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_2778);
  meth_meth_collectionsPrelude_do_40_1_41_2778->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_2778->definitionLine = 1365;
// method "iterator"
  block_savedest(obj2333);
  Object closure2821 = createclosure(4, "iterator");
  setclosureframe(closure2821, stackframe);
  addtoclosure(closure2821, var_ConcurrentModification);
  addtoclosure(closure2821, var_IteratorExhausted);
  addtoclosure(closure2821, var_removed);
  addtoclosure(closure2821, var_unused);
  struct UserObject *uo2821 = (struct UserObject*)obj2333;
  uo2821->data[20] = (Object)closure2821;
  Method *meth_meth_collectionsPrelude_iterator2821 = addmethod2pos(obj2333, "iterator", &meth_collectionsPrelude_iterator2821, 20);
  int argcv_meth_collectionsPrelude_iterator2821[] = {0};
  meth_meth_collectionsPrelude_iterator2821->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator2821);
  meth_meth_collectionsPrelude_iterator2821->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2821->definitionLine = 1378;
  block_savedest(obj2333);
  Object closure2930 = createclosure(4, "iterator$object(1)");
  setclosureframe(closure2930, stackframe);
  addtoclosure(closure2930, var_ConcurrentModification);
  addtoclosure(closure2930, var_IteratorExhausted);
  addtoclosure(closure2930, var_removed);
  addtoclosure(closure2930, var_unused);
  Method *meth_meth_collectionsPrelude_iterator2821_object = addmethod2pos(obj2333, "iterator$object(1)", &meth_collectionsPrelude_iterator2821_object, 20);
  meth_meth_collectionsPrelude_iterator2821_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2821_object->definitionLine = 1378;
// method "expand"
  block_savedest(obj2333);
  Object closure2931 = createclosure(3, "expand");
  setclosureframe(closure2931, stackframe);
  addtoclosure(closure2931, var__prelude);
  addtoclosure(closure2931, var_unused);
  addtoclosure(closure2931, var_removed);
  struct UserObject *uo2931 = (struct UserObject*)obj2333;
  uo2931->data[21] = (Object)closure2931;
  Method *meth_meth_collectionsPrelude_expand2931 = addmethod2pos(obj2333, "expand", &meth_collectionsPrelude_expand2931, 21);
  int argcv_meth_collectionsPrelude_expand2931[] = {0};
  meth_meth_collectionsPrelude_expand2931->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expand2931);
  meth_meth_collectionsPrelude_expand2931->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expand2931->definitionModule = modulename;
  meth_meth_collectionsPrelude_expand2931->definitionLine = 1404;
// method "==(_)"
  block_savedest(obj2333);
  Object closure3005 = createclosure(1, "==(1)");
  setclosureframe(closure3005, stackframe);
  addtoclosure(closure3005, var_Iterable);
  struct UserObject *uo3005 = (struct UserObject*)obj2333;
  uo3005->data[22] = (Object)closure3005;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_3005 = addmethod2pos(obj2333, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_3005, 22);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_3005[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_3005->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_3005);
  meth_meth_collectionsPrelude__61__61__40_1_41_3005->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_3005->definitionLine = 1419;
// method "copy"
  struct UserObject *uo3032 = (struct UserObject*)obj2333;
  uo3032->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy3032 = addmethod2pos(obj2333, "copy", &meth_collectionsPrelude_copy3032, 23);
  int argcv_meth_collectionsPrelude_copy3032[] = {0};
  meth_meth_collectionsPrelude_copy3032->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy3032);
  meth_meth_collectionsPrelude_copy3032->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy3032->definitionLine = 1433;
// method "++(_)"
  struct UserObject *uo3037 = (struct UserObject*)obj2333;
  uo3037->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_3037 = addmethod2pos(obj2333, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_3037, 24);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_3037[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_3037->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_3037);
  meth_meth_collectionsPrelude__43__43__40_1_41_3037->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_3037->definitionLine = 1436;
// method "--(_)"
  struct UserObject *uo3042 = (struct UserObject*)obj2333;
  uo3042->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude__45__45__40_1_41_3042 = addmethod2pos(obj2333, "--(1)", &meth_collectionsPrelude__45__45__40_1_41_3042, 25);
  int argcv_meth_collectionsPrelude__45__45__40_1_41_3042[] = {1};
  meth_meth_collectionsPrelude__45__45__40_1_41_3042->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__45__45__40_1_41_3042);
  meth_meth_collectionsPrelude__45__45__40_1_41_3042->definitionModule = modulename;
  meth_meth_collectionsPrelude__45__45__40_1_41_3042->definitionLine = 1440;
// method "**(_)"
  struct UserObject *uo3063 = (struct UserObject*)obj2333;
  uo3063->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude__42__42__40_1_41_3063 = addmethod2pos(obj2333, "**(1)", &meth_collectionsPrelude__42__42__40_1_41_3063, 26);
  int argcv_meth_collectionsPrelude__42__42__40_1_41_3063[] = {1};
  meth_meth_collectionsPrelude__42__42__40_1_41_3063->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__42__42__40_1_41_3063);
  meth_meth_collectionsPrelude__42__42__40_1_41_3063->definitionModule = modulename;
  meth_meth_collectionsPrelude__42__42__40_1_41_3063->definitionLine = 1450;
// method "isSubset(_)"
  struct UserObject *uo3073 = (struct UserObject*)obj2333;
  uo3073->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isSubset_40_1_41_3073 = addmethod2pos(obj2333, "isSubset(1)", &meth_collectionsPrelude_isSubset_40_1_41_3073, 27);
  int argcv_meth_collectionsPrelude_isSubset_40_1_41_3073[] = {1};
  meth_meth_collectionsPrelude_isSubset_40_1_41_3073->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isSubset_40_1_41_3073);
  meth_meth_collectionsPrelude_isSubset_40_1_41_3073->definitionModule = modulename;
  meth_meth_collectionsPrelude_isSubset_40_1_41_3073->definitionLine = 1454;
// method "isSuperset(_)"
  struct UserObject *uo3086 = (struct UserObject*)obj2333;
  uo3086->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isSuperset_40_1_41_3086 = addmethod2pos(obj2333, "isSuperset(1)", &meth_collectionsPrelude_isSuperset_40_1_41_3086, 28);
  int argcv_meth_collectionsPrelude_isSuperset_40_1_41_3086[] = {1};
  meth_meth_collectionsPrelude_isSuperset_40_1_41_3086->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isSuperset_40_1_41_3086);
  meth_meth_collectionsPrelude_isSuperset_40_1_41_3086->definitionModule = modulename;
  meth_meth_collectionsPrelude_isSuperset_40_1_41_3086->definitionLine = 1461;
// method "into(_)"
  struct UserObject *uo3099 = (struct UserObject*)obj2333;
  uo3099->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into_40_1_41_3099 = addmethod2pos(obj2333, "into(1)", &meth_collectionsPrelude_into_40_1_41_3099, 29);
  int argcv_meth_collectionsPrelude_into_40_1_41_3099[] = {1};
  meth_meth_collectionsPrelude_into_40_1_41_3099->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into_40_1_41_3099);
  meth_meth_collectionsPrelude_into_40_1_41_3099->definitionModule = modulename;
  meth_meth_collectionsPrelude_into_40_1_41_3099->definitionLine = 1467;
  sourceObject = obj2333;
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3107 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3108 = callmethodflags(*var_collection, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3107);
// compiled call node returning call3108 (depth = 2)
  struct UserObject *obj2333_uo = (struct UserObject *)obj2333;
  obj2333_uo->super = call3108;
  sourceObject = obj2333;
// Begin line 1202
  setline(1202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num3109 = alloc_Float64(0);
// compiled num node returning num3109 (depth = 2)
  adddatum2(obj2333, num3109, 1);
  sourceObject = obj2333;
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3110 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cap (depth = 3)
  gc_frame_newslot(*var_cap);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3111 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__prelude (depth = 4)
  Object call3112 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe3111);
// compiled member node returning call3112 (depth = 3)
  params[0] = *var_cap;
  partcv[0] = 1;
  Object call3113 = callmethodflags(call3112, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3110);
// compiled call node returning call3113 (depth = 2)
  adddatum2(obj2333, call3113, 2);
  sourceObject = obj2333;
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num3114 = alloc_Float64(0);
// compiled num node returning num3114 (depth = 2)
  adddatum2(obj2333, num3114, 3);
  sourceObject = obj2333;
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3115 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3116 = alloc_Block(NULL, NULL, "collectionsPrelude", 1205);
  gc_frame_newslot(block3116);
// method "_apply(_)"
  block_savedest(block3116);
  Object closure3117 = createclosure(2, "_apply(1)");
  setclosureframe(closure3117, stackframe);
  addtoclosure(closure3117, var_unused);
  addtoclosure(closure3117, selfslot);
  struct UserObject *uo3117 = (struct UserObject*)block3116;
  uo3117->data[0] = (Object)closure3117;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3117 = addmethod2pos(block3116, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3117, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3117[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3117->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3117);
  meth_meth_collectionsPrelude__apply_40_1_41_3117->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3117->definitionLine = 1991;
// compiled block node returning block3116 (depth = 3)
  gc_frame_newslot(block3116);
// call case 6: other requests
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3125 = alloc_Float64(1);
// compiled num node returning num3125 (depth = 5)
  int op_slot_right_3124 = gc_frame_newslot(num3125);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cap (depth = 5)
  int op_slot_left_3124 = gc_frame_newslot(*var_cap);
  params[0] = num3125;
  partcv[0] = 1;
  Object diff3127 = callmethod(*var_cap, "-(1)", 1, partcv, params);
// compiled op node returning diff3127 (depth = 4)
  int op_slot_right_3123 = gc_frame_newslot(diff3127);
// starting to compile num node (depth = 4)
  Object num3129 = alloc_Float64(0);
// compiled num node returning num3129 (depth = 4)
  int op_slot_left_3123 = gc_frame_newslot(num3129);
  params[0] = diff3127;
  partcv[0] = 1;
  Object opresult3130 = callmethod(num3129, "..(1)", 1, partcv, params);
// compiled op node returning opresult3130 (depth = 3)
  params[0] = block3116;
  partcv[0] = 1;
  Object call3131 = callmethodflags(opresult3130, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3115);
// compiled call node returning call3131 (depth = 2)
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  sourceObject = obj2333;
  objclass2333 = obj2333->class;
  objclass2333->definitionModule = modulename;
  objclass2333->definitionLine = 1200;
  (*(struct UserObject *)self).data[0] = lowerouter2333;
  self = oldself2333;
  selfslot = oldselfslot2333;
  stackframe = oldstackframe2333;
  gc_frame_end(frame);
  return obj2333;
}
Object meth_collectionsPrelude_set2294(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "set");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  Object *var_ConcurrentModification = getfromclosure(closure, 4);
  Object *var_IteratorExhausted = getfromclosure(closure, 5);
  Object *var_Iterable = getfromclosure(closure, 6);
  Object *var_collection = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2295 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2295 = alloc_userobj2(5,6, objclass2295);
  gc_frame_newslot(obj2295);
if (objclass2295 == NULL) {
  glfree(obj2295->class->name);
  obj2295->class->name = "set";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2295, self, 0);
  addmethodreal(obj2295,"outer", &reader_collectionsPrelude_outer_2296);
  Object oldself2295 = self;
  struct StackFrameObject *oldstackframe2295 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2295);
  gc_frame_newslot((Object)stackframe);
  self = obj2295;
  Object *oldselfslot2295 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2295 = (*(struct UserObject *)self).data[0], lowerouter2295 = thisouter2295;
  if (inheritingObject2295) {
    struct UserObject *inho2295 = (struct UserObject *)inheritingObject2295;
    while (inho2295->super != GraceDefaultObject) inho2295 = (struct UserObject *)inho2295->super;
    inho2295->super = obj2295;
    self = inheritingObject2295;
    *selfslot = self;
    lowerouter2295 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2295;
  }
// method "asString"
  struct UserObject *uo2297 = (struct UserObject*)obj2295;
  uo2297->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2297 = addmethod2pos(obj2295, "asString", &meth_collectionsPrelude_asString2297, 1);
  int argcv_meth_collectionsPrelude_asString2297[] = {0};
  meth_meth_collectionsPrelude_asString2297->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2297);
  meth_meth_collectionsPrelude_asString2297->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2297->definitionLine = 1187;
// method "withAll(_)"
  struct UserObject *uo2299 = (struct UserObject*)obj2295;
  uo2299->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_2299 = addmethod2pos(obj2295, "withAll(1)", &meth_collectionsPrelude_withAll_40_1_41_2299, 2);
  int argcv_meth_collectionsPrelude_withAll_40_1_41_2299[] = {1};
  meth_meth_collectionsPrelude_withAll_40_1_41_2299->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll_40_1_41_2299);
  meth_meth_collectionsPrelude_withAll_40_1_41_2299->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_2299->definitionLine = 1189;
// method "empty"
  struct UserObject *uo2328 = (struct UserObject*)obj2295;
  uo2328->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_empty2328 = addmethod2pos(obj2295, "empty", &meth_collectionsPrelude_empty2328, 3);
  int argcv_meth_collectionsPrelude_empty2328[] = {0};
  meth_meth_collectionsPrelude_empty2328->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty2328);
  meth_meth_collectionsPrelude_empty2328->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty2328->definitionLine = 1196;
// method "ofCapacity(_)"
  block_savedest(obj2295);
  Object closure2332 = createclosure(8, "ofCapacity(1)");
  setclosureframe(closure2332, stackframe);
  addtoclosure(closure2332, var_NoSuchObject);
  addtoclosure(closure2332, var_removed);
  addtoclosure(closure2332, var__prelude);
  addtoclosure(closure2332, var_unused);
  addtoclosure(closure2332, var_ConcurrentModification);
  addtoclosure(closure2332, var_IteratorExhausted);
  addtoclosure(closure2332, var_Iterable);
  addtoclosure(closure2332, var_collection);
  struct UserObject *uo2332 = (struct UserObject*)obj2295;
  uo2332->data[4] = (Object)closure2332;
  Method *meth_meth_collectionsPrelude_ofCapacity_40_1_41_2332 = addmethod2pos(obj2295, "ofCapacity(1)", &meth_collectionsPrelude_ofCapacity_40_1_41_2332, 4);
  int argcv_meth_collectionsPrelude_ofCapacity_40_1_41_2332[] = {1};
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2332->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_ofCapacity_40_1_41_2332);
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2332->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2332->definitionModule = modulename;
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2332->definitionLine = 1200;
  block_savedest(obj2295);
  Object closure3132 = createclosure(8, "ofCapacity(1)$object(1)");
  setclosureframe(closure3132, stackframe);
  addtoclosure(closure3132, var_NoSuchObject);
  addtoclosure(closure3132, var_removed);
  addtoclosure(closure3132, var__prelude);
  addtoclosure(closure3132, var_unused);
  addtoclosure(closure3132, var_ConcurrentModification);
  addtoclosure(closure3132, var_IteratorExhausted);
  addtoclosure(closure3132, var_Iterable);
  addtoclosure(closure3132, var_collection);
  Method *meth_meth_collectionsPrelude_ofCapacity_40_1_41_2332_object = addmethod2pos(obj2295, "ofCapacity(1)$object(1)", &meth_collectionsPrelude_ofCapacity_40_1_41_2332_object, 4);
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2332_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2332_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2332_object->definitionLine = 1200;
  sourceObject = obj2295;
  sourceObject = obj2295;
  sourceObject = obj2295;
  sourceObject = obj2295;
  objclass2295 = obj2295->class;
  objclass2295->definitionModule = modulename;
  objclass2295->definitionLine = 1185;
  (*(struct UserObject *)self).data[0] = lowerouter2295;
  self = oldself2295;
  selfslot = oldselfslot2295;
  stackframe = oldstackframe2295;
  gc_frame_end(frame);
  return obj2295;
}
Object meth_collectionsPrelude_set2294_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "set$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  Object *var_ConcurrentModification = getfromclosure(closure, 4);
  Object *var_IteratorExhausted = getfromclosure(closure, 5);
  Object *var_Iterable = getfromclosure(closure, 6);
  Object *var_collection = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2295 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2295 = alloc_userobj2(5,6, objclass2295);
  gc_frame_newslot(obj2295);
if (objclass2295 == NULL) {
  glfree(obj2295->class->name);
  obj2295->class->name = "set";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2295, self, 0);
  addmethodreal(obj2295,"outer", &reader_collectionsPrelude_outer_2296);
  Object oldself2295 = self;
  struct StackFrameObject *oldstackframe2295 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2295);
  gc_frame_newslot((Object)stackframe);
  self = obj2295;
  Object *oldselfslot2295 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2295 = (*(struct UserObject *)self).data[0], lowerouter2295 = thisouter2295;
  if (inheritingObject2295) {
    struct UserObject *inho2295 = (struct UserObject *)inheritingObject2295;
    while (inho2295->super != GraceDefaultObject) inho2295 = (struct UserObject *)inho2295->super;
    inho2295->super = obj2295;
    self = inheritingObject2295;
    *selfslot = self;
    lowerouter2295 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2295;
  }
// method "asString"
  struct UserObject *uo2297 = (struct UserObject*)obj2295;
  uo2297->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2297 = addmethod2pos(obj2295, "asString", &meth_collectionsPrelude_asString2297, 1);
  int argcv_meth_collectionsPrelude_asString2297[] = {0};
  meth_meth_collectionsPrelude_asString2297->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2297);
  meth_meth_collectionsPrelude_asString2297->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2297->definitionLine = 1187;
// method "withAll(_)"
  struct UserObject *uo2299 = (struct UserObject*)obj2295;
  uo2299->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_2299 = addmethod2pos(obj2295, "withAll(1)", &meth_collectionsPrelude_withAll_40_1_41_2299, 2);
  int argcv_meth_collectionsPrelude_withAll_40_1_41_2299[] = {1};
  meth_meth_collectionsPrelude_withAll_40_1_41_2299->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll_40_1_41_2299);
  meth_meth_collectionsPrelude_withAll_40_1_41_2299->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_2299->definitionLine = 1189;
// method "empty"
  struct UserObject *uo2328 = (struct UserObject*)obj2295;
  uo2328->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_empty2328 = addmethod2pos(obj2295, "empty", &meth_collectionsPrelude_empty2328, 3);
  int argcv_meth_collectionsPrelude_empty2328[] = {0};
  meth_meth_collectionsPrelude_empty2328->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty2328);
  meth_meth_collectionsPrelude_empty2328->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty2328->definitionLine = 1196;
// method "ofCapacity(_)"
  block_savedest(obj2295);
  Object closure2332 = createclosure(8, "ofCapacity(1)");
  setclosureframe(closure2332, stackframe);
  addtoclosure(closure2332, var_NoSuchObject);
  addtoclosure(closure2332, var_removed);
  addtoclosure(closure2332, var__prelude);
  addtoclosure(closure2332, var_unused);
  addtoclosure(closure2332, var_ConcurrentModification);
  addtoclosure(closure2332, var_IteratorExhausted);
  addtoclosure(closure2332, var_Iterable);
  addtoclosure(closure2332, var_collection);
  struct UserObject *uo2332 = (struct UserObject*)obj2295;
  uo2332->data[4] = (Object)closure2332;
  Method *meth_meth_collectionsPrelude_ofCapacity_40_1_41_2332 = addmethod2pos(obj2295, "ofCapacity(1)", &meth_collectionsPrelude_ofCapacity_40_1_41_2332, 4);
  int argcv_meth_collectionsPrelude_ofCapacity_40_1_41_2332[] = {1};
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2332->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_ofCapacity_40_1_41_2332);
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2332->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2332->definitionModule = modulename;
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2332->definitionLine = 1200;
  block_savedest(obj2295);
  Object closure3132 = createclosure(8, "ofCapacity(1)$object(1)");
  setclosureframe(closure3132, stackframe);
  addtoclosure(closure3132, var_NoSuchObject);
  addtoclosure(closure3132, var_removed);
  addtoclosure(closure3132, var__prelude);
  addtoclosure(closure3132, var_unused);
  addtoclosure(closure3132, var_ConcurrentModification);
  addtoclosure(closure3132, var_IteratorExhausted);
  addtoclosure(closure3132, var_Iterable);
  addtoclosure(closure3132, var_collection);
  Method *meth_meth_collectionsPrelude_ofCapacity_40_1_41_2332_object = addmethod2pos(obj2295, "ofCapacity(1)$object(1)", &meth_collectionsPrelude_ofCapacity_40_1_41_2332_object, 4);
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2332_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2332_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2332_object->definitionLine = 1200;
  sourceObject = obj2295;
  sourceObject = obj2295;
  sourceObject = obj2295;
  sourceObject = obj2295;
  objclass2295 = obj2295->class;
  objclass2295->definitionModule = modulename;
  objclass2295->definitionLine = 1185;
  (*(struct UserObject *)self).data[0] = lowerouter2295;
  self = oldself2295;
  selfslot = oldselfslot2295;
  stackframe = oldstackframe2295;
  gc_frame_end(frame);
  return obj2295;
}
Object meth_collectionsPrelude_asString3137(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1505
  setline(1505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit3138 == NULL) {
    strlit3138 = alloc_String("a dictionary factory");
    gc_root(strlit3138);
  }
// compiled string node returning strlit3138 (depth = 2)
  gc_frame_end(frame);
  return strlit3138;
}
Object meth_collectionsPrelude__apply_40_1_41_3144(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe3145 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_b;
  partcv[0] = 1;
  Object call3146 = callmethodflags(*var_result, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3145);
// compiled call node returning call3146 (depth = 4)
  gc_frame_end(frame);
  return call3146;
}
Object meth_collectionsPrelude_withAll_40_1_41_3139(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "withAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method withAll(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_initialBindings = &(stackframe->slots[0]);
  *var_initialBindings = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "result");
// Begin line 1508
  setline(1508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3140 = gc_frame_new();
// call case 4: self request
  Object call3141 = callmethodflags(self, "empty", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3140);
// compiled member node returning call3141 (depth = 3)
  *var_result = call3141;
  if (call3141 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1509
  setline(1509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3142 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_initialBindings (depth = 3)
  gc_frame_newslot(*var_initialBindings);
// starting to compile block node (depth = 3)
  Object block3143 = alloc_Block(NULL, NULL, "collectionsPrelude", 1509);
  gc_frame_newslot(block3143);
// method "_apply(_)"
  block_savedest(block3143);
  Object closure3144 = createclosure(2, "_apply(1)");
  setclosureframe(closure3144, stackframe);
  addtoclosure(closure3144, var_result);
  addtoclosure(closure3144, selfslot);
  struct UserObject *uo3144 = (struct UserObject*)block3143;
  uo3144->data[0] = (Object)closure3144;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3144 = addmethod2pos(block3143, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3144, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3144[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3144->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3144);
  meth_meth_collectionsPrelude__apply_40_1_41_3144->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3144->definitionLine = 1991;
// compiled block node returning block3143 (depth = 3)
  gc_frame_newslot(block3143);
// call case 5: prelude request
  params[0] = *var_initialBindings;
  params[1] = block3143;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3148 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3142);
// compiled call node returning call3148 (depth = 2)
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude_size3155(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1521
  setline(1521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3156 = gc_frame_new();
// call case 4: self request
  Object call3157 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3156);
// compiled member node returning call3157 (depth = 2)
  gc_frame_end(frame);
  return call3157;
}
Object meth_collectionsPrelude_at_40_1_41_put_40_1_41_3158(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at(1)put(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)put(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)put(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for at(_)put(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_key_39_ = &(stackframe->slots[0]);
  *var_key_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *var_value_39_ = &(stackframe->slots[1]);
  *var_value_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part put(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "t");
// Begin line 1523
  setline(1523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3159 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3161 = alloc_Float64(1);
// compiled num node returning num3161 (depth = 4)
  int op_slot_right_3160 = gc_frame_newslot(num3161);
// starting to compile member node (depth = 4)
  int callframe3163 = gc_frame_new();
// call case 4: self request
  Object call3164 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3163);
// compiled member node returning call3164 (depth = 4)
  int op_slot_left_3160 = gc_frame_newslot(call3164);
  params[0] = num3161;
  partcv[0] = 1;
  Object sum3165 = callmethod(call3164, "+(1)", 1, partcv, params);
// compiled op node returning sum3165 (depth = 3)
  gc_frame_newslot(sum3165);
// call case 4: self request
  params[0] = sum3165;
  partcv[0] = 1;
  Object call3166 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3159);
// compiled call node returning call3166 (depth = 2)
// Begin line 1524
  setline(1524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3167 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_key_39_ (depth = 4)
  gc_frame_newslot(*var_key_39_);
// call case 4: self request
  params[0] = *var_key_39_;
  partcv[0] = 1;
  Object call3168 = callmethodflags(self, "findPositionForAdd(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3167);
// compiled call node returning call3168 (depth = 3)
  *var_t = call3168;
  if (call3168 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1525
  setline(1525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3172 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3173 = gc_frame_new();
// call case 4: self request
  Object call3174 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3173);
// compiled member node returning call3174 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3175 = callmethodflags(call3174, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3172);
// compiled call node returning call3175 (depth = 5)
  int op_slot_right_3171 = gc_frame_newslot(call3175);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_removed (depth = 5)
  int op_slot_left_3171 = gc_frame_newslot(*var_removed);
  params[0] = call3175;
  partcv[0] = 1;
  Object opresult3177 = callmethod(*var_removed, "==(1)", 1, partcv, params);
// compiled op node returning opresult3177 (depth = 4)
  int op_slot_right_3170 = gc_frame_newslot(opresult3177);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3180 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3181 = gc_frame_new();
// call case 4: self request
  Object call3182 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3181);
// compiled member node returning call3182 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3183 = callmethodflags(call3182, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3180);
// compiled call node returning call3183 (depth = 5)
  int op_slot_right_3179 = gc_frame_newslot(call3183);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  int op_slot_left_3179 = gc_frame_newslot(*var_unused);
  params[0] = call3183;
  partcv[0] = 1;
  Object opresult3185 = callmethod(*var_unused, "==(1)", 1, partcv, params);
// compiled op node returning opresult3185 (depth = 4)
  int op_slot_left_3170 = gc_frame_newslot(opresult3185);
  params[0] = opresult3177;
  partcv[0] = 1;
  Object opresult3186 = callmethod(opresult3185, "||(1)", 1, partcv, params);
// compiled op node returning opresult3186 (depth = 3)
  Object if3169 = done;
  if (istrue(opresult3186)) {
// Begin line 1526
  setline(1526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3187 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3189 = alloc_Float64(1);
// compiled num node returning num3189 (depth = 5)
  int op_slot_right_3188 = gc_frame_newslot(num3189);
// starting to compile member node (depth = 5)
  int callframe3191 = gc_frame_new();
// call case 4: self request
  Object call3192 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3191);
// compiled member node returning call3192 (depth = 5)
  int op_slot_left_3188 = gc_frame_newslot(call3192);
  params[0] = num3189;
  partcv[0] = 1;
  Object sum3193 = callmethod(call3192, "+(1)", 1, partcv, params);
// compiled op node returning sum3193 (depth = 4)
  gc_frame_newslot(sum3193);
// call case 4: self request
  params[0] = sum3193;
  partcv[0] = 1;
  Object call3194 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3187);
// compiled call node returning call3194 (depth = 3)
    gc_frame_newslot(call3194);
    if3169 = call3194;
  } else {
  }
// compiled if node returning if3169 (depth = 2)
// Begin line 1528
  setline(1528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3195 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  gc_frame_newslot(*var_t);
// starting to compile call node (depth = 3)
  int callframe3196 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_key_39_ (depth = 4)
  gc_frame_newslot(*var_key_39_);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_value_39_ (depth = 4)
  gc_frame_newslot(*var_value_39_);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_binding (depth = 4)
  params[0] = *var_key_39_;
  params[1] = *var_value_39_;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3197 = callmethodflags(*var_binding, "key(1)value(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3196);
// compiled call node returning call3197 (depth = 3)
  gc_frame_newslot(call3197);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3198 = gc_frame_new();
// call case 4: self request
  Object call3199 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3198);
// compiled member node returning call3199 (depth = 3)
  params[0] = *var_t;
  params[1] = call3197;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3200 = callmethodflags(call3199, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3195);
// compiled call node returning call3200 (depth = 2)
// Begin line 1529
  setline(1529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3203 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3204 = gc_frame_new();
// call case 4: self request
  Object call3205 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3204);
// compiled member node returning call3205 (depth = 5)
  Object call3206 = callmethodflags(call3205, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3203);
// compiled member node returning call3206 (depth = 4)
  int op_slot_right_3202 = gc_frame_newslot(call3206);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3209 = alloc_Float64(2);
// compiled num node returning num3209 (depth = 5)
  int op_slot_right_3208 = gc_frame_newslot(num3209);
// starting to compile member node (depth = 5)
  int callframe3211 = gc_frame_new();
// call case 4: self request
  Object call3212 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3211);
// compiled member node returning call3212 (depth = 5)
  int op_slot_left_3208 = gc_frame_newslot(call3212);
  params[0] = num3209;
  partcv[0] = 1;
  Object prod3213 = callmethod(call3212, "*(1)", 1, partcv, params);
// compiled op node returning prod3213 (depth = 4)
  int op_slot_left_3202 = gc_frame_newslot(prod3213);
  params[0] = call3206;
  partcv[0] = 1;
  Object opresult3214 = callmethod(prod3213, ">(1)", 1, partcv, params);
// compiled op node returning opresult3214 (depth = 3)
  Object if3201 = done;
  if (istrue(opresult3214)) {
// starting to compile member node (depth = 3)
  int callframe3215 = gc_frame_new();
// call case 4: self request
  Object call3216 = callmethodflags(self, "expand", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3215);
// compiled member node returning call3216 (depth = 3)
    gc_frame_newslot(call3216);
    if3201 = call3216;
  } else {
  }
// compiled if node returning if3201 (depth = 2)
// Begin line 1530
  setline(1530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_add_40_1_41_3217(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "add(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method add(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for add(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aBinding = &(stackframe->slots[0]);
  *var_aBinding = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part add(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1533
  setline(1533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3218 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3220 = alloc_Float64(1);
// compiled num node returning num3220 (depth = 4)
  int op_slot_right_3219 = gc_frame_newslot(num3220);
// starting to compile member node (depth = 4)
  int callframe3222 = gc_frame_new();
// call case 4: self request
  Object call3223 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3222);
// compiled member node returning call3223 (depth = 4)
  int op_slot_left_3219 = gc_frame_newslot(call3223);
  params[0] = num3220;
  partcv[0] = 1;
  Object sum3224 = callmethod(call3223, "+(1)", 1, partcv, params);
// compiled op node returning sum3224 (depth = 3)
  gc_frame_newslot(sum3224);
// call case 4: self request
  params[0] = sum3224;
  partcv[0] = 1;
  Object call3225 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3218);
// compiled call node returning call3225 (depth = 2)
// Begin line 1534
  setline(1534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3226 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3227 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_aBinding (depth = 5)
  Object call3228 = callmethodflags(*var_aBinding, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3227);
// compiled member node returning call3228 (depth = 4)
  gc_frame_newslot(call3228);
// call case 4: self request
  params[0] = call3228;
  partcv[0] = 1;
  Object call3229 = callmethodflags(self, "findPositionForAdd(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3226);
// compiled call node returning call3229 (depth = 3)
  *var_t = call3229;
  if (call3229 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1535
  setline(1535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3233 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3234 = gc_frame_new();
// call case 4: self request
  Object call3235 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3234);
// compiled member node returning call3235 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3236 = callmethodflags(call3235, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3233);
// compiled call node returning call3236 (depth = 5)
  int op_slot_right_3232 = gc_frame_newslot(call3236);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_removed (depth = 5)
  int op_slot_left_3232 = gc_frame_newslot(*var_removed);
  params[0] = call3236;
  partcv[0] = 1;
  Object opresult3238 = callmethod(*var_removed, "==(1)", 1, partcv, params);
// compiled op node returning opresult3238 (depth = 4)
  int op_slot_right_3231 = gc_frame_newslot(opresult3238);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3241 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3242 = gc_frame_new();
// call case 4: self request
  Object call3243 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3242);
// compiled member node returning call3243 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3244 = callmethodflags(call3243, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3241);
// compiled call node returning call3244 (depth = 5)
  int op_slot_right_3240 = gc_frame_newslot(call3244);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  int op_slot_left_3240 = gc_frame_newslot(*var_unused);
  params[0] = call3244;
  partcv[0] = 1;
  Object opresult3246 = callmethod(*var_unused, "==(1)", 1, partcv, params);
// compiled op node returning opresult3246 (depth = 4)
  int op_slot_left_3231 = gc_frame_newslot(opresult3246);
  params[0] = opresult3238;
  partcv[0] = 1;
  Object opresult3247 = callmethod(opresult3246, "||(1)", 1, partcv, params);
// compiled op node returning opresult3247 (depth = 3)
  Object if3230 = done;
  if (istrue(opresult3247)) {
// Begin line 1536
  setline(1536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3248 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3250 = alloc_Float64(1);
// compiled num node returning num3250 (depth = 5)
  int op_slot_right_3249 = gc_frame_newslot(num3250);
// starting to compile member node (depth = 5)
  int callframe3252 = gc_frame_new();
// call case 4: self request
  Object call3253 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3252);
// compiled member node returning call3253 (depth = 5)
  int op_slot_left_3249 = gc_frame_newslot(call3253);
  params[0] = num3250;
  partcv[0] = 1;
  Object sum3254 = callmethod(call3253, "+(1)", 1, partcv, params);
// compiled op node returning sum3254 (depth = 4)
  gc_frame_newslot(sum3254);
// call case 4: self request
  params[0] = sum3254;
  partcv[0] = 1;
  Object call3255 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3248);
// compiled call node returning call3255 (depth = 3)
    gc_frame_newslot(call3255);
    if3230 = call3255;
  } else {
  }
// compiled if node returning if3230 (depth = 2)
// Begin line 1538
  setline(1538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3256 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_aBinding (depth = 3)
  gc_frame_newslot(*var_aBinding);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3257 = gc_frame_new();
// call case 4: self request
  Object call3258 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3257);
// compiled member node returning call3258 (depth = 3)
  params[0] = *var_t;
  params[1] = *var_aBinding;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3259 = callmethodflags(call3258, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3256);
// compiled call node returning call3259 (depth = 2)
// Begin line 1539
  setline(1539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3262 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3263 = gc_frame_new();
// call case 4: self request
  Object call3264 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3263);
// compiled member node returning call3264 (depth = 5)
  Object call3265 = callmethodflags(call3264, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3262);
// compiled member node returning call3265 (depth = 4)
  int op_slot_right_3261 = gc_frame_newslot(call3265);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3268 = alloc_Float64(2);
// compiled num node returning num3268 (depth = 5)
  int op_slot_right_3267 = gc_frame_newslot(num3268);
// starting to compile member node (depth = 5)
  int callframe3270 = gc_frame_new();
// call case 4: self request
  Object call3271 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3270);
// compiled member node returning call3271 (depth = 5)
  int op_slot_left_3267 = gc_frame_newslot(call3271);
  params[0] = num3268;
  partcv[0] = 1;
  Object prod3272 = callmethod(call3271, "*(1)", 1, partcv, params);
// compiled op node returning prod3272 (depth = 4)
  int op_slot_left_3261 = gc_frame_newslot(prod3272);
  params[0] = call3265;
  partcv[0] = 1;
  Object opresult3273 = callmethod(prod3272, ">(1)", 1, partcv, params);
// compiled op node returning opresult3273 (depth = 3)
  Object if3260 = done;
  if (istrue(opresult3273)) {
// starting to compile member node (depth = 3)
  int callframe3274 = gc_frame_new();
// call case 4: self request
  Object call3275 = callmethodflags(self, "expand", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3274);
// compiled member node returning call3275 (depth = 3)
    gc_frame_newslot(call3275);
    if3260 = call3275;
  } else {
  }
// compiled if node returning if3260 (depth = 2)
// Begin line 1540
  setline(1540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_at_40_1_41_3276(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_b = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "b");
// Begin line 1543
  setline(1543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3277 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3278 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3279 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3278);
// compiled call node returning call3279 (depth = 4)
  gc_frame_newslot(call3279);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3280 = gc_frame_new();
// call case 4: self request
  Object call3281 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3280);
// compiled member node returning call3281 (depth = 4)
  params[0] = call3279;
  partcv[0] = 1;
  Object call3282 = callmethodflags(call3281, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3277);
// compiled call node returning call3282 (depth = 3)
  *var_b = call3282;
  if (call3282 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1544
  setline(1544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3284 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
  int callframe3286 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  Object call3287 = callmethodflags(*var_b, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3286);
// compiled member node returning call3287 (depth = 4)
  int op_slot_left_3284 = gc_frame_newslot(call3287);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3288 = callmethod(call3287, "==(1)", 1, partcv, params);
// compiled op node returning opresult3288 (depth = 3)
  Object if3283 = done;
  if (istrue(opresult3288)) {
// Begin line 1545
  setline(1545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3289 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  Object call3290 = callmethodflags(*var_b, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3289);
// compiled member node returning call3290 (depth = 4)
  return call3290;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3283 = undefined;
  } else {
  }
// compiled if node returning if3283 (depth = 2)
// Begin line 1547
  setline(1547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3291 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3293 == NULL) {
    strlit3293 = alloc_String("");
    gc_root(strlit3293);
  }
// compiled string node returning strlit3293 (depth = 4)
  int op_slot_right_3292 = gc_frame_newslot(strlit3293);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  int op_slot_right_3295 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 5)
  if (strlit3297 == NULL) {
    strlit3297 = alloc_String("dictionary does not contain entry with key ");
    gc_root(strlit3297);
  }
// compiled string node returning strlit3297 (depth = 5)
  int op_slot_left_3295 = gc_frame_newslot(strlit3297);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3298 = callmethod(strlit3297, "++(1)", 1, partcv, params);
// compiled op node returning opresult3298 (depth = 4)
  int op_slot_left_3292 = gc_frame_newslot(opresult3298);
  params[0] = strlit3293;
  partcv[0] = 1;
  Object opresult3299 = callmethod(opresult3298, "++(1)", 1, partcv, params);
// compiled op node returning opresult3299 (depth = 3)
  gc_frame_newslot(opresult3299);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_NoSuchObject (depth = 3)
  params[0] = opresult3299;
  partcv[0] = 1;
  Object call3300 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3291);
// compiled call node returning call3300 (depth = 2)
  gc_frame_end(frame);
  return call3300;
}
Object meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3301(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)ifAbsent(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for at(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_b = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "b");
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3302 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3303 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3304 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3303);
// compiled call node returning call3304 (depth = 4)
  gc_frame_newslot(call3304);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3305 = gc_frame_new();
// call case 4: self request
  Object call3306 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3305);
// compiled member node returning call3306 (depth = 4)
  params[0] = call3304;
  partcv[0] = 1;
  Object call3307 = callmethodflags(call3306, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3302);
// compiled call node returning call3307 (depth = 3)
  *var_b = call3307;
  if (call3307 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3309 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
  int callframe3311 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  Object call3312 = callmethodflags(*var_b, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3311);
// compiled member node returning call3312 (depth = 4)
  int op_slot_left_3309 = gc_frame_newslot(call3312);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3313 = callmethod(call3312, "==(1)", 1, partcv, params);
// compiled op node returning opresult3313 (depth = 3)
  Object if3308 = done;
  if (istrue(opresult3313)) {
// Begin line 1552
  setline(1552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3314 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  Object call3315 = callmethodflags(*var_b, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3314);
// compiled member node returning call3315 (depth = 4)
  return call3315;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3308 = undefined;
  } else {
  }
// compiled if node returning if3308 (depth = 2)
// Begin line 1554
  setline(1554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3316 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_action (depth = 3)
  Object call3317 = callmethodflags(*var_action, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe3316);
// compiled member node returning call3317 (depth = 2)
  gc_frame_end(frame);
  return call3317;
}
Object meth_collectionsPrelude_containsKey_40_1_41_3318(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "containsKey(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method containsKey(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for containsKey(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part containsKey(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1557
  setline(1557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3319 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3320 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3319);
// compiled call node returning call3320 (depth = 3)
  *var_t = call3320;
  if (call3320 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1558
  setline(1558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3322 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
  int callframe3324 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe3325 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3326 = gc_frame_new();
// call case 4: self request
  Object call3327 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3326);
// compiled member node returning call3327 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3328 = callmethodflags(call3327, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3325);
// compiled call node returning call3328 (depth = 5)
  Object call3329 = callmethodflags(call3328, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3324);
// compiled member node returning call3329 (depth = 4)
  int op_slot_left_3322 = gc_frame_newslot(call3329);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3330 = callmethod(call3329, "==(1)", 1, partcv, params);
// compiled op node returning opresult3330 (depth = 3)
  Object if3321 = done;
  if (istrue(opresult3330)) {
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool3331 = alloc_Boolean(1);
// compiled identifier node returning bool3331 (depth = 4)
  return bool3331;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3321 = undefined;
  } else {
  }
// compiled if node returning if3321 (depth = 2)
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool3332 = alloc_Boolean(0);
// compiled identifier node returning bool3332 (depth = 2)
  gc_frame_end(frame);
  return bool3332;
}
Object meth_collectionsPrelude__apply_40_1_41_3344(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3345 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3346 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3345);
// compiled call node returning call3346 (depth = 5)
  *var_t = call3346;
  if (call3346 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1567
  setline(1567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  int op_slot_right_3348 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 6)
  int callframe3350 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe3351 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3352 = gc_frame_new();
// call case 4: self request
  Object call3353 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3352);
// compiled member node returning call3353 (depth = 8)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3354 = callmethodflags(call3353, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3351);
// compiled call node returning call3354 (depth = 7)
  Object call3355 = callmethodflags(call3354, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3350);
// compiled member node returning call3355 (depth = 6)
  int op_slot_left_3348 = gc_frame_newslot(call3355);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3356 = callmethod(call3355, "==(1)", 1, partcv, params);
// compiled op node returning opresult3356 (depth = 5)
  Object if3347 = done;
  if (istrue(opresult3356)) {
// Begin line 1568
  setline(1568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3357 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3358 = gc_frame_new();
// call case 4: self request
  Object call3359 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3358);
// compiled member node returning call3359 (depth = 6)
  params[0] = *var_t;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3360 = callmethodflags(call3359, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3357);
// compiled call node returning call3360 (depth = 5)
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3361 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3363 = alloc_Float64(1);
// compiled num node returning num3363 (depth = 7)
  int op_slot_right_3362 = gc_frame_newslot(num3363);
// starting to compile member node (depth = 7)
  int callframe3365 = gc_frame_new();
// call case 4: self request
  Object call3366 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3365);
// compiled member node returning call3366 (depth = 7)
  int op_slot_left_3362 = gc_frame_newslot(call3366);
  params[0] = num3363;
  partcv[0] = 1;
  Object diff3367 = callmethod(call3366, "-(1)", 1, partcv, params);
// compiled op node returning diff3367 (depth = 6)
  gc_frame_newslot(diff3367);
// call case 4: self request
  params[0] = diff3367;
  partcv[0] = 1;
  Object call3368 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3361);
// compiled call node returning call3368 (depth = 5)
    gc_frame_newslot(call3368);
    if3347 = call3368;
  } else {
// Begin line 1571
  setline(1571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3369 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3371 == NULL) {
    strlit3371 = alloc_String("");
    gc_root(strlit3371);
  }
// compiled string node returning strlit3371 (depth = 7)
  int op_slot_right_3370 = gc_frame_newslot(strlit3371);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_k (depth = 8)
  int op_slot_right_3373 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 8)
  if (strlit3375 == NULL) {
    strlit3375 = alloc_String("dictionary does not contain entry with key ");
    gc_root(strlit3375);
  }
// compiled string node returning strlit3375 (depth = 8)
  int op_slot_left_3373 = gc_frame_newslot(strlit3375);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3376 = callmethod(strlit3375, "++(1)", 1, partcv, params);
// compiled op node returning opresult3376 (depth = 7)
  int op_slot_left_3370 = gc_frame_newslot(opresult3376);
  params[0] = strlit3371;
  partcv[0] = 1;
  Object opresult3377 = callmethod(opresult3376, "++(1)", 1, partcv, params);
// compiled op node returning opresult3377 (depth = 6)
  gc_frame_newslot(opresult3377);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_NoSuchObject (depth = 6)
  params[0] = opresult3377;
  partcv[0] = 1;
  Object call3378 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3369);
// compiled call node returning call3378 (depth = 5)
    gc_frame_newslot(call3378);
    if3347 = call3378;
  }
// compiled if node returning if3347 (depth = 4)
  gc_frame_end(frame);
  return if3347;
}
Object meth_collectionsPrelude_removeAllKeys_40_1_41_3333(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAllKeys(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAllKeys(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAllKeys(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_keys = &(stackframe->slots[0]);
  *var_keys = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAllKeys(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3334 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3336 = alloc_Float64(1);
// compiled num node returning num3336 (depth = 4)
  int op_slot_right_3335 = gc_frame_newslot(num3336);
// starting to compile member node (depth = 4)
  int callframe3338 = gc_frame_new();
// call case 4: self request
  Object call3339 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3338);
// compiled member node returning call3339 (depth = 4)
  int op_slot_left_3335 = gc_frame_newslot(call3339);
  params[0] = num3336;
  partcv[0] = 1;
  Object sum3340 = callmethod(call3339, "+(1)", 1, partcv, params);
// compiled op node returning sum3340 (depth = 3)
  gc_frame_newslot(sum3340);
// call case 4: self request
  params[0] = sum3340;
  partcv[0] = 1;
  Object call3341 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3334);
// compiled call node returning call3341 (depth = 2)
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3342 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_keys (depth = 3)
  gc_frame_newslot(*var_keys);
// starting to compile block node (depth = 3)
  Object block3343 = alloc_Block(NULL, NULL, "collectionsPrelude", 1565);
  gc_frame_newslot(block3343);
// method "_apply(_)"
  block_savedest(block3343);
  Object closure3344 = createclosure(3, "_apply(1)");
  setclosureframe(closure3344, stackframe);
  addtoclosure(closure3344, var_removed);
  addtoclosure(closure3344, var_NoSuchObject);
  addtoclosure(closure3344, selfslot);
  struct UserObject *uo3344 = (struct UserObject*)block3343;
  uo3344->data[0] = (Object)closure3344;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3344 = addmethod2pos(block3343, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3344, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3344[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3344->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3344);
  meth_meth_collectionsPrelude__apply_40_1_41_3344->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3344->definitionLine = 1991;
// compiled block node returning block3343 (depth = 3)
  gc_frame_newslot(block3343);
// call case 5: prelude request
  params[0] = *var_keys;
  params[1] = block3343;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3380 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3342);
// compiled call node returning call3380 (depth = 2)
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_removeKey_40_1_41_3381(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeKey(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeKey(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeKey(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeKey(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1577
  setline(1577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3382 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3384 = alloc_Float64(1);
// compiled num node returning num3384 (depth = 4)
  int op_slot_right_3383 = gc_frame_newslot(num3384);
// starting to compile member node (depth = 4)
  int callframe3386 = gc_frame_new();
// call case 4: self request
  Object call3387 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3386);
// compiled member node returning call3387 (depth = 4)
  int op_slot_left_3383 = gc_frame_newslot(call3387);
  params[0] = num3384;
  partcv[0] = 1;
  Object sum3388 = callmethod(call3387, "+(1)", 1, partcv, params);
// compiled op node returning sum3388 (depth = 3)
  gc_frame_newslot(sum3388);
// call case 4: self request
  params[0] = sum3388;
  partcv[0] = 1;
  Object call3389 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3382);
// compiled call node returning call3389 (depth = 2)
// Begin line 1578
  setline(1578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3390 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3391 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3390);
// compiled call node returning call3391 (depth = 3)
  *var_t = call3391;
  if (call3391 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1579
  setline(1579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3393 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
  int callframe3395 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe3396 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3397 = gc_frame_new();
// call case 4: self request
  Object call3398 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3397);
// compiled member node returning call3398 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3399 = callmethodflags(call3398, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3396);
// compiled call node returning call3399 (depth = 5)
  Object call3400 = callmethodflags(call3399, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3395);
// compiled member node returning call3400 (depth = 4)
  int op_slot_left_3393 = gc_frame_newslot(call3400);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3401 = callmethod(call3400, "==(1)", 1, partcv, params);
// compiled op node returning opresult3401 (depth = 3)
  Object if3392 = done;
  if (istrue(opresult3401)) {
// Begin line 1580
  setline(1580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3402 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_removed (depth = 4)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3403 = gc_frame_new();
// call case 4: self request
  Object call3404 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3403);
// compiled member node returning call3404 (depth = 4)
  params[0] = *var_t;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3405 = callmethodflags(call3404, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3402);
// compiled call node returning call3405 (depth = 3)
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3406 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3408 = alloc_Float64(1);
// compiled num node returning num3408 (depth = 5)
  int op_slot_right_3407 = gc_frame_newslot(num3408);
// starting to compile member node (depth = 5)
  int callframe3410 = gc_frame_new();
// call case 4: self request
  Object call3411 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3410);
// compiled member node returning call3411 (depth = 5)
  int op_slot_left_3407 = gc_frame_newslot(call3411);
  params[0] = num3408;
  partcv[0] = 1;
  Object diff3412 = callmethod(call3411, "-(1)", 1, partcv, params);
// compiled op node returning diff3412 (depth = 4)
  gc_frame_newslot(diff3412);
// call case 4: self request
  params[0] = diff3412;
  partcv[0] = 1;
  Object call3413 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3406);
// compiled call node returning call3413 (depth = 3)
    gc_frame_newslot(call3413);
    if3392 = call3413;
  } else {
// Begin line 1583
  setline(1583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3414 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3416 == NULL) {
    strlit3416 = alloc_String("");
    gc_root(strlit3416);
  }
// compiled string node returning strlit3416 (depth = 5)
  int op_slot_right_3415 = gc_frame_newslot(strlit3416);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  int op_slot_right_3418 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 6)
  if (strlit3420 == NULL) {
    strlit3420 = alloc_String("dictionary does not contain entry with key ");
    gc_root(strlit3420);
  }
// compiled string node returning strlit3420 (depth = 6)
  int op_slot_left_3418 = gc_frame_newslot(strlit3420);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3421 = callmethod(strlit3420, "++(1)", 1, partcv, params);
// compiled op node returning opresult3421 (depth = 5)
  int op_slot_left_3415 = gc_frame_newslot(opresult3421);
  params[0] = strlit3416;
  partcv[0] = 1;
  Object opresult3422 = callmethod(opresult3421, "++(1)", 1, partcv, params);
// compiled op node returning opresult3422 (depth = 4)
  gc_frame_newslot(opresult3422);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_NoSuchObject (depth = 4)
  params[0] = opresult3422;
  partcv[0] = 1;
  Object call3423 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3414);
// compiled call node returning call3423 (depth = 3)
    gc_frame_newslot(call3423);
    if3392 = call3423;
  }
// compiled if node returning if3392 (depth = 2)
// Begin line 1585
  setline(1585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_1_41_3447(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_removals = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3448 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3449 = gc_frame_new();
// call case 4: self request
  Object call3450 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3449);
// compiled member node returning call3450 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3451 = callmethodflags(call3450, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3448);
// compiled call node returning call3451 (depth = 5)
  *var_a = call3451;
  if (call3451 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1591
  setline(1591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3453 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe3454 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call3455 = callmethodflags(*var_a, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3454);
// compiled member node returning call3455 (depth = 6)
  gc_frame_newslot(call3455);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removals (depth = 6)
  params[0] = call3455;
  partcv[0] = 1;
  Object call3456 = callmethodflags(*var_removals, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3453);
// compiled call node returning call3456 (depth = 5)
  Object if3452 = done;
  if (istrue(call3456)) {
// Begin line 1592
  setline(1592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3457 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3458 = gc_frame_new();
// call case 4: self request
  Object call3459 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3458);
// compiled member node returning call3459 (depth = 6)
  params[0] = *var_i;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3460 = callmethodflags(call3459, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3457);
// compiled call node returning call3460 (depth = 5)
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3461 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3463 = alloc_Float64(1);
// compiled num node returning num3463 (depth = 7)
  int op_slot_right_3462 = gc_frame_newslot(num3463);
// starting to compile member node (depth = 7)
  int callframe3465 = gc_frame_new();
// call case 4: self request
  Object call3466 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3465);
// compiled member node returning call3466 (depth = 7)
  int op_slot_left_3462 = gc_frame_newslot(call3466);
  params[0] = num3463;
  partcv[0] = 1;
  Object diff3467 = callmethod(call3466, "-(1)", 1, partcv, params);
// compiled op node returning diff3467 (depth = 6)
  gc_frame_newslot(diff3467);
// call case 4: self request
  params[0] = diff3467;
  partcv[0] = 1;
  Object call3468 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3461);
// compiled call node returning call3468 (depth = 5)
    gc_frame_newslot(call3468);
    if3452 = call3468;
  } else {
  }
// compiled if node returning if3452 (depth = 4)
  gc_frame_end(frame);
  return if3452;
}
Object meth_collectionsPrelude_removeAllValues_40_1_41_3424(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAllValues(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAllValues(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAllValues(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_removals = &(stackframe->slots[0]);
  *var_removals = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAllValues(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1588
  setline(1588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3425 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3427 = alloc_Float64(1);
// compiled num node returning num3427 (depth = 4)
  int op_slot_right_3426 = gc_frame_newslot(num3427);
// starting to compile member node (depth = 4)
  int callframe3429 = gc_frame_new();
// call case 4: self request
  Object call3430 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3429);
// compiled member node returning call3430 (depth = 4)
  int op_slot_left_3426 = gc_frame_newslot(call3430);
  params[0] = num3427;
  partcv[0] = 1;
  Object sum3431 = callmethod(call3430, "+(1)", 1, partcv, params);
// compiled op node returning sum3431 (depth = 3)
  gc_frame_newslot(sum3431);
// call case 4: self request
  params[0] = sum3431;
  partcv[0] = 1;
  Object call3432 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3425);
// compiled call node returning call3432 (depth = 2)
// Begin line 1589
  setline(1589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3433 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3436 = alloc_Float64(1);
// compiled num node returning num3436 (depth = 5)
  int op_slot_right_3435 = gc_frame_newslot(num3436);
// starting to compile member node (depth = 5)
  int callframe3438 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3439 = gc_frame_new();
// call case 4: self request
  Object call3440 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3439);
// compiled member node returning call3440 (depth = 6)
  Object call3441 = callmethodflags(call3440, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3438);
// compiled member node returning call3441 (depth = 5)
  int op_slot_left_3435 = gc_frame_newslot(call3441);
  params[0] = num3436;
  partcv[0] = 1;
  Object diff3442 = callmethod(call3441, "-(1)", 1, partcv, params);
// compiled op node returning diff3442 (depth = 4)
  int op_slot_right_3434 = gc_frame_newslot(diff3442);
// starting to compile num node (depth = 4)
  Object num3444 = alloc_Float64(0);
// compiled num node returning num3444 (depth = 4)
  int op_slot_left_3434 = gc_frame_newslot(num3444);
  params[0] = diff3442;
  partcv[0] = 1;
  Object opresult3445 = callmethod(num3444, "..(1)", 1, partcv, params);
// compiled op node returning opresult3445 (depth = 3)
  gc_frame_newslot(opresult3445);
// starting to compile block node (depth = 3)
  Object block3446 = alloc_Block(NULL, NULL, "collectionsPrelude", 1589);
  gc_frame_newslot(block3446);
// method "_apply(_)"
  block_savedest(block3446);
  Object closure3447 = createclosure(3, "_apply(1)");
  setclosureframe(closure3447, stackframe);
  addtoclosure(closure3447, var_removals);
  addtoclosure(closure3447, var_removed);
  addtoclosure(closure3447, selfslot);
  struct UserObject *uo3447 = (struct UserObject*)block3446;
  uo3447->data[0] = (Object)closure3447;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3447 = addmethod2pos(block3446, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3447, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3447[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3447->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3447);
  meth_meth_collectionsPrelude__apply_40_1_41_3447->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3447->definitionLine = 1991;
// compiled block node returning block3446 (depth = 3)
  gc_frame_newslot(block3446);
// call case 5: prelude request
  params[0] = opresult3445;
  params[1] = block3446;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3470 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3433);
// compiled call node returning call3470 (depth = 2)
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_1_41_3496(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1603
  setline(1603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3497 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3498 = gc_frame_new();
// call case 4: self request
  Object call3499 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3498);
// compiled member node returning call3499 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3500 = callmethodflags(call3499, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3497);
// compiled call node returning call3500 (depth = 5)
  *var_a = call3500;
  if (call3500 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3503 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call3504 = callmethodflags(*var_a, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3503);
// compiled member node returning call3504 (depth = 6)
  int op_slot_right_3502 = gc_frame_newslot(call3504);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_left_3502 = gc_frame_newslot(*var_v);
  params[0] = call3504;
  partcv[0] = 1;
  Object opresult3506 = callmethod(*var_v, "==(1)", 1, partcv, params);
// compiled op node returning opresult3506 (depth = 5)
  Object if3501 = done;
  if (istrue(opresult3506)) {
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3507 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3508 = gc_frame_new();
// call case 4: self request
  Object call3509 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3508);
// compiled member node returning call3509 (depth = 6)
  params[0] = *var_i;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3510 = callmethodflags(call3509, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3507);
// compiled call node returning call3510 (depth = 5)
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3511 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3513 = alloc_Float64(1);
// compiled num node returning num3513 (depth = 7)
  int op_slot_right_3512 = gc_frame_newslot(num3513);
// starting to compile member node (depth = 7)
  int callframe3515 = gc_frame_new();
// call case 4: self request
  Object call3516 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3515);
// compiled member node returning call3516 (depth = 7)
  int op_slot_left_3512 = gc_frame_newslot(call3516);
  params[0] = num3513;
  partcv[0] = 1;
  Object diff3517 = callmethod(call3516, "-(1)", 1, partcv, params);
// compiled op node returning diff3517 (depth = 6)
  gc_frame_newslot(diff3517);
// call case 4: self request
  params[0] = diff3517;
  partcv[0] = 1;
  Object call3518 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3511);
// compiled call node returning call3518 (depth = 5)
    gc_frame_newslot(call3518);
    if3501 = call3518;
  } else {
  }
// compiled if node returning if3501 (depth = 4)
  gc_frame_end(frame);
  return if3501;
}
Object meth_collectionsPrelude_removeValue_40_1_41_3471(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeValue(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeValue(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeValue(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeValue(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_initialNumBindings = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "initialNumBindings");
// Begin line 1600
  setline(1600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3472 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3474 = alloc_Float64(1);
// compiled num node returning num3474 (depth = 4)
  int op_slot_right_3473 = gc_frame_newslot(num3474);
// starting to compile member node (depth = 4)
  int callframe3476 = gc_frame_new();
// call case 4: self request
  Object call3477 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3476);
// compiled member node returning call3477 (depth = 4)
  int op_slot_left_3473 = gc_frame_newslot(call3477);
  params[0] = num3474;
  partcv[0] = 1;
  Object sum3478 = callmethod(call3477, "+(1)", 1, partcv, params);
// compiled op node returning sum3478 (depth = 3)
  gc_frame_newslot(sum3478);
// call case 4: self request
  params[0] = sum3478;
  partcv[0] = 1;
  Object call3479 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3472);
// compiled call node returning call3479 (depth = 2)
// Begin line 1601
  setline(1601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3480 = gc_frame_new();
// call case 4: self request
  Object call3481 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3480);
// compiled member node returning call3481 (depth = 3)
  *var_initialNumBindings = call3481;
  if (call3481 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3482 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3485 = alloc_Float64(1);
// compiled num node returning num3485 (depth = 5)
  int op_slot_right_3484 = gc_frame_newslot(num3485);
// starting to compile member node (depth = 5)
  int callframe3487 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3488 = gc_frame_new();
// call case 4: self request
  Object call3489 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3488);
// compiled member node returning call3489 (depth = 6)
  Object call3490 = callmethodflags(call3489, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3487);
// compiled member node returning call3490 (depth = 5)
  int op_slot_left_3484 = gc_frame_newslot(call3490);
  params[0] = num3485;
  partcv[0] = 1;
  Object diff3491 = callmethod(call3490, "-(1)", 1, partcv, params);
// compiled op node returning diff3491 (depth = 4)
  int op_slot_right_3483 = gc_frame_newslot(diff3491);
// starting to compile num node (depth = 4)
  Object num3493 = alloc_Float64(0);
// compiled num node returning num3493 (depth = 4)
  int op_slot_left_3483 = gc_frame_newslot(num3493);
  params[0] = diff3491;
  partcv[0] = 1;
  Object opresult3494 = callmethod(num3493, "..(1)", 1, partcv, params);
// compiled op node returning opresult3494 (depth = 3)
  gc_frame_newslot(opresult3494);
// starting to compile block node (depth = 3)
  Object block3495 = alloc_Block(NULL, NULL, "collectionsPrelude", 1602);
  gc_frame_newslot(block3495);
// method "_apply(_)"
  block_savedest(block3495);
  Object closure3496 = createclosure(3, "_apply(1)");
  setclosureframe(closure3496, stackframe);
  addtoclosure(closure3496, var_v);
  addtoclosure(closure3496, var_removed);
  addtoclosure(closure3496, selfslot);
  struct UserObject *uo3496 = (struct UserObject*)block3495;
  uo3496->data[0] = (Object)closure3496;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3496 = addmethod2pos(block3495, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3496, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3496[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3496->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3496);
  meth_meth_collectionsPrelude__apply_40_1_41_3496->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3496->definitionLine = 1991;
// compiled block node returning block3495 (depth = 3)
  gc_frame_newslot(block3495);
// call case 5: prelude request
  params[0] = opresult3494;
  params[1] = block3495;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3520 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3482);
// compiled call node returning call3520 (depth = 2)
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_initialNumBindings (depth = 4)
  int op_slot_right_3522 = gc_frame_newslot(*var_initialNumBindings);
// starting to compile member node (depth = 4)
  int callframe3524 = gc_frame_new();
// call case 4: self request
  Object call3525 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3524);
// compiled member node returning call3525 (depth = 4)
  int op_slot_left_3522 = gc_frame_newslot(call3525);
  params[0] = *var_initialNumBindings;
  partcv[0] = 1;
  Object opresult3526 = callmethod(call3525, "==(1)", 1, partcv, params);
// compiled op node returning opresult3526 (depth = 3)
  Object if3521 = done;
  if (istrue(opresult3526)) {
// Begin line 1610
  setline(1610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3527 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3529 == NULL) {
    strlit3529 = alloc_String("");
    gc_root(strlit3529);
  }
// compiled string node returning strlit3529 (depth = 5)
  int op_slot_right_3528 = gc_frame_newslot(strlit3529);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_right_3531 = gc_frame_newslot(*var_v);
// starting to compile string node (depth = 6)
  if (strlit3533 == NULL) {
    strlit3533 = alloc_String("dictionary does not contain entry with value ");
    gc_root(strlit3533);
  }
// compiled string node returning strlit3533 (depth = 6)
  int op_slot_left_3531 = gc_frame_newslot(strlit3533);
  params[0] = *var_v;
  partcv[0] = 1;
  Object opresult3534 = callmethod(strlit3533, "++(1)", 1, partcv, params);
// compiled op node returning opresult3534 (depth = 5)
  int op_slot_left_3528 = gc_frame_newslot(opresult3534);
  params[0] = strlit3529;
  partcv[0] = 1;
  Object opresult3535 = callmethod(opresult3534, "++(1)", 1, partcv, params);
// compiled op node returning opresult3535 (depth = 4)
  gc_frame_newslot(opresult3535);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_NoSuchObject (depth = 4)
  params[0] = opresult3535;
  partcv[0] = 1;
  Object call3536 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3527);
// compiled call node returning call3536 (depth = 3)
    gc_frame_newslot(call3536);
    if3521 = call3536;
  } else {
  }
// compiled if node returning if3521 (depth = 2)
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_1_41_3562(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1619
  setline(1619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3563 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3564 = gc_frame_new();
// call case 4: self request
  Object call3565 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3564);
// compiled member node returning call3565 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3566 = callmethodflags(call3565, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3563);
// compiled call node returning call3566 (depth = 5)
  *var_a = call3566;
  if (call3566 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1620
  setline(1620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3569 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call3570 = callmethodflags(*var_a, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3569);
// compiled member node returning call3570 (depth = 6)
  int op_slot_right_3568 = gc_frame_newslot(call3570);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_left_3568 = gc_frame_newslot(*var_v);
  params[0] = call3570;
  partcv[0] = 1;
  Object opresult3572 = callmethod(*var_v, "==(1)", 1, partcv, params);
// compiled op node returning opresult3572 (depth = 5)
  Object if3567 = done;
  if (istrue(opresult3572)) {
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3573 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3574 = gc_frame_new();
// call case 4: self request
  Object call3575 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3574);
// compiled member node returning call3575 (depth = 6)
  params[0] = *var_i;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3576 = callmethodflags(call3575, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3573);
// compiled call node returning call3576 (depth = 5)
// Begin line 1622
  setline(1622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3577 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3579 = alloc_Float64(1);
// compiled num node returning num3579 (depth = 7)
  int op_slot_right_3578 = gc_frame_newslot(num3579);
// starting to compile member node (depth = 7)
  int callframe3581 = gc_frame_new();
// call case 4: self request
  Object call3582 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3581);
// compiled member node returning call3582 (depth = 7)
  int op_slot_left_3578 = gc_frame_newslot(call3582);
  params[0] = num3579;
  partcv[0] = 1;
  Object diff3583 = callmethod(call3582, "-(1)", 1, partcv, params);
// compiled op node returning diff3583 (depth = 6)
  gc_frame_newslot(diff3583);
// call case 4: self request
  params[0] = diff3583;
  partcv[0] = 1;
  Object call3584 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3577);
// compiled call node returning call3584 (depth = 5)
    gc_frame_newslot(call3584);
    if3567 = call3584;
  } else {
  }
// compiled if node returning if3567 (depth = 4)
  gc_frame_end(frame);
  return if3567;
}
Object meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3537(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeValue(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeValue(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeValue(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for removeValue(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeValue(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_initialNumBindings = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "initialNumBindings");
// Begin line 1616
  setline(1616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3538 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3540 = alloc_Float64(1);
// compiled num node returning num3540 (depth = 4)
  int op_slot_right_3539 = gc_frame_newslot(num3540);
// starting to compile member node (depth = 4)
  int callframe3542 = gc_frame_new();
// call case 4: self request
  Object call3543 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3542);
// compiled member node returning call3543 (depth = 4)
  int op_slot_left_3539 = gc_frame_newslot(call3543);
  params[0] = num3540;
  partcv[0] = 1;
  Object sum3544 = callmethod(call3543, "+(1)", 1, partcv, params);
// compiled op node returning sum3544 (depth = 3)
  gc_frame_newslot(sum3544);
// call case 4: self request
  params[0] = sum3544;
  partcv[0] = 1;
  Object call3545 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3538);
// compiled call node returning call3545 (depth = 2)
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3546 = gc_frame_new();
// call case 4: self request
  Object call3547 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3546);
// compiled member node returning call3547 (depth = 3)
  *var_initialNumBindings = call3547;
  if (call3547 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3548 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3551 = alloc_Float64(1);
// compiled num node returning num3551 (depth = 5)
  int op_slot_right_3550 = gc_frame_newslot(num3551);
// starting to compile member node (depth = 5)
  int callframe3553 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3554 = gc_frame_new();
// call case 4: self request
  Object call3555 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3554);
// compiled member node returning call3555 (depth = 6)
  Object call3556 = callmethodflags(call3555, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3553);
// compiled member node returning call3556 (depth = 5)
  int op_slot_left_3550 = gc_frame_newslot(call3556);
  params[0] = num3551;
  partcv[0] = 1;
  Object diff3557 = callmethod(call3556, "-(1)", 1, partcv, params);
// compiled op node returning diff3557 (depth = 4)
  int op_slot_right_3549 = gc_frame_newslot(diff3557);
// starting to compile num node (depth = 4)
  Object num3559 = alloc_Float64(0);
// compiled num node returning num3559 (depth = 4)
  int op_slot_left_3549 = gc_frame_newslot(num3559);
  params[0] = diff3557;
  partcv[0] = 1;
  Object opresult3560 = callmethod(num3559, "..(1)", 1, partcv, params);
// compiled op node returning opresult3560 (depth = 3)
  gc_frame_newslot(opresult3560);
// starting to compile block node (depth = 3)
  Object block3561 = alloc_Block(NULL, NULL, "collectionsPrelude", 1618);
  gc_frame_newslot(block3561);
// method "_apply(_)"
  block_savedest(block3561);
  Object closure3562 = createclosure(3, "_apply(1)");
  setclosureframe(closure3562, stackframe);
  addtoclosure(closure3562, var_v);
  addtoclosure(closure3562, var_removed);
  addtoclosure(closure3562, selfslot);
  struct UserObject *uo3562 = (struct UserObject*)block3561;
  uo3562->data[0] = (Object)closure3562;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3562 = addmethod2pos(block3561, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3562, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3562[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3562->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3562);
  meth_meth_collectionsPrelude__apply_40_1_41_3562->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3562->definitionLine = 1991;
// compiled block node returning block3561 (depth = 3)
  gc_frame_newslot(block3561);
// call case 5: prelude request
  params[0] = opresult3560;
  params[1] = block3561;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3586 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3548);
// compiled call node returning call3586 (depth = 2)
// Begin line 1625
  setline(1625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_initialNumBindings (depth = 4)
  int op_slot_right_3588 = gc_frame_newslot(*var_initialNumBindings);
// starting to compile member node (depth = 4)
  int callframe3590 = gc_frame_new();
// call case 4: self request
  Object call3591 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3590);
// compiled member node returning call3591 (depth = 4)
  int op_slot_left_3588 = gc_frame_newslot(call3591);
  params[0] = *var_initialNumBindings;
  partcv[0] = 1;
  Object opresult3592 = callmethod(call3591, "==(1)", 1, partcv, params);
// compiled op node returning opresult3592 (depth = 3)
  Object if3587 = done;
  if (istrue(opresult3592)) {
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3593 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_action (depth = 4)
  Object call3594 = callmethodflags(*var_action, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe3593);
// compiled member node returning call3594 (depth = 3)
    gc_frame_newslot(call3594);
    if3587 = call3594;
  } else {
  }
// compiled if node returning if3587 (depth = 2)
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_1_41_3628(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3629 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3630 = gc_frame_new();
// call case 4: self request
  Object call3631 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3630);
// compiled member node returning call3631 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3632 = callmethodflags(call3631, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3629);
// compiled call node returning call3632 (depth = 4)
  gc_frame_end(frame);
  return call3632;
}
Object meth_collectionsPrelude_clear3595(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "clear");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var__prelude = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3596 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe3597 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num3598 = alloc_Float64(8);
// compiled num node returning num3598 (depth = 4)
  gc_frame_newslot(num3598);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3599 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  Object call3600 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe3599);
// compiled member node returning call3600 (depth = 4)
  params[0] = num3598;
  partcv[0] = 1;
  Object call3601 = callmethodflags(call3600, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3597);
// compiled call node returning call3601 (depth = 3)
  gc_frame_newslot(call3601);
// call case 4: self request
  params[0] = call3601;
  partcv[0] = 1;
  Object call3602 = callmethodflags(self, "inner:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3596);
// compiled call node returning call3602 (depth = 2)
// Begin line 1632
  setline(1632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3603 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num3604 = alloc_Float64(0);
// compiled num node returning num3604 (depth = 3)
  gc_frame_newslot(num3604);
// call case 4: self request
  params[0] = num3604;
  partcv[0] = 1;
  Object call3605 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3603);
// compiled call node returning call3605 (depth = 2)
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3606 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3608 = alloc_Float64(1);
// compiled num node returning num3608 (depth = 4)
  int op_slot_right_3607 = gc_frame_newslot(num3608);
// starting to compile member node (depth = 4)
  int callframe3610 = gc_frame_new();
// call case 4: self request
  Object call3611 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3610);
// compiled member node returning call3611 (depth = 4)
  int op_slot_left_3607 = gc_frame_newslot(call3611);
  params[0] = num3608;
  partcv[0] = 1;
  Object sum3612 = callmethod(call3611, "+(1)", 1, partcv, params);
// compiled op node returning sum3612 (depth = 3)
  gc_frame_newslot(sum3612);
// call case 4: self request
  params[0] = sum3612;
  partcv[0] = 1;
  Object call3613 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3606);
// compiled call node returning call3613 (depth = 2)
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3614 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3617 = alloc_Float64(1);
// compiled num node returning num3617 (depth = 5)
  int op_slot_right_3616 = gc_frame_newslot(num3617);
// starting to compile member node (depth = 5)
  int callframe3619 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3620 = gc_frame_new();
// call case 4: self request
  Object call3621 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3620);
// compiled member node returning call3621 (depth = 6)
  Object call3622 = callmethodflags(call3621, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3619);
// compiled member node returning call3622 (depth = 5)
  int op_slot_left_3616 = gc_frame_newslot(call3622);
  params[0] = num3617;
  partcv[0] = 1;
  Object diff3623 = callmethod(call3622, "-(1)", 1, partcv, params);
// compiled op node returning diff3623 (depth = 4)
  int op_slot_right_3615 = gc_frame_newslot(diff3623);
// starting to compile num node (depth = 4)
  Object num3625 = alloc_Float64(0);
// compiled num node returning num3625 (depth = 4)
  int op_slot_left_3615 = gc_frame_newslot(num3625);
  params[0] = diff3623;
  partcv[0] = 1;
  Object opresult3626 = callmethod(num3625, "..(1)", 1, partcv, params);
// compiled op node returning opresult3626 (depth = 3)
  gc_frame_newslot(opresult3626);
// starting to compile block node (depth = 3)
  Object block3627 = alloc_Block(NULL, NULL, "collectionsPrelude", 1634);
  gc_frame_newslot(block3627);
// method "_apply(_)"
  block_savedest(block3627);
  Object closure3628 = createclosure(2, "_apply(1)");
  setclosureframe(closure3628, stackframe);
  addtoclosure(closure3628, var_unused);
  addtoclosure(closure3628, selfslot);
  struct UserObject *uo3628 = (struct UserObject*)block3627;
  uo3628->data[0] = (Object)closure3628;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3628 = addmethod2pos(block3627, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3628, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3628[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3628->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3628);
  meth_meth_collectionsPrelude__apply_40_1_41_3628->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3628->definitionLine = 1991;
// compiled block node returning block3627 (depth = 3)
  gc_frame_newslot(block3627);
// call case 5: prelude request
  params[0] = opresult3626;
  params[1] = block3627;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3634 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3614);
// compiled call node returning call3634 (depth = 2)
// Begin line 1637
  setline(1637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_1_41_3638(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  int op_slot_right_3640 = gc_frame_newslot(*var_each);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_left_3640 = gc_frame_newslot(*var_v);
  params[0] = *var_each;
  partcv[0] = 1;
  Object opresult3642 = callmethod(*var_v, "==(1)", 1, partcv, params);
// compiled op node returning opresult3642 (depth = 5)
  Object if3639 = done;
  if (istrue(opresult3642)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3643 = alloc_Boolean(1);
// compiled identifier node returning bool3643 (depth = 6)
  block_return(realself, bool3643);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3639 = undefined;
  } else {
  }
// compiled if node returning if3639 (depth = 4)
  gc_frame_end(frame);
  return if3639;
}
Object meth_collectionsPrelude_containsValue_40_1_41_3635(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "containsValue(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method containsValue(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for containsValue(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part containsValue(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1640
  setline(1640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3636 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3637 = alloc_Block(NULL, NULL, "collectionsPrelude", 1640);
  gc_frame_newslot(block3637);
// method "_apply(_)"
  block_savedest(block3637);
  Object closure3638 = createclosure(2, "_apply(1)");
  setclosureframe(closure3638, stackframe);
  addtoclosure(closure3638, var_v);
  addtoclosure(closure3638, selfslot);
  struct UserObject *uo3638 = (struct UserObject*)block3637;
  uo3638->data[0] = (Object)closure3638;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3638 = addmethod2pos(block3637, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3638, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3638[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3638->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3638);
  meth_meth_collectionsPrelude__apply_40_1_41_3638->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3638->definitionLine = 1991;
// compiled block node returning block3637 (depth = 3)
  gc_frame_newslot(block3637);
// call case 4: self request
  params[0] = block3637;
  partcv[0] = 1;
  Object call3645 = callmethodflags(self, "valuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3636);
// compiled call node returning call3645 (depth = 2)
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool3646 = alloc_Boolean(0);
// compiled identifier node returning bool3646 (depth = 2)
  gc_frame_end(frame);
  return bool3646;
}
Object meth_collectionsPrelude_contains_40_1_41_3647(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1645
  setline(1645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3648 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  gc_frame_newslot(*var_v);
// call case 4: self request
  params[0] = *var_v;
  partcv[0] = 1;
  Object call3649 = callmethodflags(self, "containsValue(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3648);
// compiled call node returning call3649 (depth = 2)
  gc_frame_end(frame);
  return call3649;
}
Object meth_collectionsPrelude__apply3663(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3665 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3666 = gc_frame_new();
// call case 4: self request
  Object call3667 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3666);
// compiled member node returning call3667 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3668 = callmethodflags(call3667, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3665);
// compiled call node returning call3668 (depth = 5)
  int op_slot_right_3664 = gc_frame_newslot(call3668);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  int op_slot_left_3664 = gc_frame_newslot(*var_unused);
  params[0] = call3668;
  partcv[0] = 1;
  Object opresult3670 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3670 (depth = 4)
  gc_frame_end(frame);
  return opresult3670;
}
Object meth_collectionsPrelude__apply3673(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_t = getfromclosure(closure, 1);
  Object *var_jump = getfromclosure(closure, 2);
  Object *var_s = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1653
  setline(1653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_3675 = gc_frame_newslot(*var_x);
// starting to compile member node (depth = 6)
  int callframe3677 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe3678 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3679 = gc_frame_new();
// call case 4: self request
  Object call3680 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3679);
// compiled member node returning call3680 (depth = 8)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3681 = callmethodflags(call3680, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3678);
// compiled call node returning call3681 (depth = 7)
  Object call3682 = callmethodflags(call3681, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3677);
// compiled member node returning call3682 (depth = 6)
  int op_slot_left_3675 = gc_frame_newslot(call3682);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult3683 = callmethod(call3682, "==(1)", 1, partcv, params);
// compiled op node returning opresult3683 (depth = 5)
  Object if3674 = done;
  if (istrue(opresult3683)) {
// Begin line 1654
  setline(1654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3674 = undefined;
  } else {
  }
// compiled if node returning if3674 (depth = 4)
// Begin line 1656
  setline(1656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3686 = alloc_Float64(0);
// compiled num node returning num3686 (depth = 6)
  int op_slot_right_3685 = gc_frame_newslot(num3686);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_3685 = gc_frame_newslot(*var_jump);
  params[0] = num3686;
  partcv[0] = 1;
  Object opresult3688 = callmethod(*var_jump, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3688 (depth = 5)
  Object if3684 = done;
  if (istrue(opresult3688)) {
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3689 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3692 = alloc_Float64(1);
// compiled num node returning num3692 (depth = 8)
  int op_slot_right_3691 = gc_frame_newslot(num3692);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3695 = alloc_Float64(3);
// compiled num node returning num3695 (depth = 9)
  int op_slot_right_3694 = gc_frame_newslot(num3695);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_3694 = gc_frame_newslot(*var_t);
  params[0] = num3695;
  partcv[0] = 1;
  Object prod3697 = callmethod(*var_t, "*(1)", 1, partcv, params);
// compiled op node returning prod3697 (depth = 8)
  int op_slot_left_3691 = gc_frame_newslot(prod3697);
  params[0] = num3692;
  partcv[0] = 1;
  Object sum3698 = callmethod(prod3697, "+(1)", 1, partcv, params);
// compiled op node returning sum3698 (depth = 7)
  int op_slot_left_3689 = gc_frame_newslot(sum3698);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3699 = callmethod(sum3698, "%(1)", 1, partcv, params);
// compiled op node returning modulus3699 (depth = 6)
  *var_t = modulus3699;
  if (modulus3699 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1658
  setline(1658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3702 = alloc_Float64(1);
// compiled num node returning num3702 (depth = 7)
  int op_slot_right_3701 = gc_frame_newslot(num3702);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_3701 = gc_frame_newslot(*var_jump);
  params[0] = num3702;
  partcv[0] = 1;
  Object diff3704 = callmethod(*var_jump, "-(1)", 1, partcv, params);
// compiled op node returning diff3704 (depth = 6)
  *var_jump = diff3704;
  if (diff3704 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3684 = done;
  } else {
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3706 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3709 = alloc_Float64(1);
// compiled num node returning num3709 (depth = 8)
  int op_slot_right_3708 = gc_frame_newslot(num3709);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_3708 = gc_frame_newslot(*var_t);
  params[0] = num3709;
  partcv[0] = 1;
  Object sum3711 = callmethod(*var_t, "+(1)", 1, partcv, params);
// compiled op node returning sum3711 (depth = 7)
  int op_slot_left_3706 = gc_frame_newslot(sum3711);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3712 = callmethod(sum3711, "%(1)", 1, partcv, params);
// compiled op node returning modulus3712 (depth = 6)
  *var_t = modulus3712;
  if (modulus3712 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3684 = done;
  }
// compiled if node returning if3684 (depth = 4)
  gc_frame_end(frame);
  return if3684;
}
Object meth_collectionsPrelude_findPosition_40_1_41_3650(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findPosition(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findPosition(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findPosition(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findPosition(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
// Begin line 1648
  setline(1648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3651 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  Object call3652 = callmethodflags(*var_x, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe3651);
// compiled member node returning call3652 (depth = 3)
  *var_h = call3652;
  if (call3652 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1649
  setline(1649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3653 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3654 = gc_frame_new();
// call case 4: self request
  Object call3655 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3654);
// compiled member node returning call3655 (depth = 4)
  Object call3656 = callmethodflags(call3655, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3653);
// compiled member node returning call3656 (depth = 3)
  *var_s = call3656;
  if (call3656 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_3657 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_3657 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3659 = callmethod(*var_h, "%(1)", 1, partcv, params);
// compiled op node returning modulus3659 (depth = 3)
  *var_t = modulus3659;
  if (modulus3659 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1651
  setline(1651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num3660 = alloc_Float64(5);
// compiled num node returning num3660 (depth = 3)
  *var_jump = num3660;
  if (num3660 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3661 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3662 = alloc_Block(NULL, NULL, "collectionsPrelude", 1652);
  gc_frame_newslot(block3662);
// method "_apply"
  block_savedest(block3662);
  Object closure3663 = createclosure(3, "_apply");
  setclosureframe(closure3663, stackframe);
  addtoclosure(closure3663, var_t);
  addtoclosure(closure3663, var_unused);
  addtoclosure(closure3663, selfslot);
  struct UserObject *uo3663 = (struct UserObject*)block3662;
  uo3663->data[0] = (Object)closure3663;
  Method *meth_meth_collectionsPrelude__apply3663 = addmethod2pos(block3662, "_apply", &meth_collectionsPrelude__apply3663, 0);
  int argcv_meth_collectionsPrelude__apply3663[] = {0};
  meth_meth_collectionsPrelude__apply3663->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3663);
  meth_meth_collectionsPrelude__apply3663->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3663->definitionLine = 1991;
// compiled block node returning block3662 (depth = 3)
  gc_frame_newslot(block3662);
// starting to compile block node (depth = 3)
  Object block3672 = alloc_Block(NULL, NULL, "collectionsPrelude", 1652);
  gc_frame_newslot(block3672);
// method "_apply"
  block_savedest(block3672);
  Object closure3673 = createclosure(5, "_apply");
  setclosureframe(closure3673, stackframe);
  addtoclosure(closure3673, var_x);
  addtoclosure(closure3673, var_t);
  addtoclosure(closure3673, var_jump);
  addtoclosure(closure3673, var_s);
  addtoclosure(closure3673, selfslot);
  struct UserObject *uo3673 = (struct UserObject*)block3672;
  uo3673->data[0] = (Object)closure3673;
  Method *meth_meth_collectionsPrelude__apply3673 = addmethod2pos(block3672, "_apply", &meth_collectionsPrelude__apply3673, 0);
  int argcv_meth_collectionsPrelude__apply3673[] = {0};
  meth_meth_collectionsPrelude__apply3673->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3673);
  meth_meth_collectionsPrelude__apply3673->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3673->definitionLine = 1991;
// compiled block node returning block3672 (depth = 3)
  gc_frame_newslot(block3672);
// call case 5: prelude request
  params[0] = block3662;
  params[1] = block3672;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3715 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3661);
// compiled call node returning call3715 (depth = 2)
// Begin line 1663
  setline(1663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply3729(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3732 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3733 = gc_frame_new();
// call case 4: self request
  Object call3734 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3733);
// compiled member node returning call3734 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3735 = callmethodflags(call3734, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3732);
// compiled call node returning call3735 (depth = 6)
  int op_slot_right_3731 = gc_frame_newslot(call3735);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  int op_slot_left_3731 = gc_frame_newslot(*var_removed);
  params[0] = call3735;
  partcv[0] = 1;
  Object opresult3737 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3737 (depth = 5)
  int op_slot_right_3730 = gc_frame_newslot(opresult3737);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3740 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3741 = gc_frame_new();
// call case 4: self request
  Object call3742 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3741);
// compiled member node returning call3742 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3743 = callmethodflags(call3742, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3740);
// compiled call node returning call3743 (depth = 6)
  int op_slot_right_3739 = gc_frame_newslot(call3743);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unused (depth = 6)
  int op_slot_left_3739 = gc_frame_newslot(*var_unused);
  params[0] = call3743;
  partcv[0] = 1;
  Object opresult3745 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3745 (depth = 5)
  int op_slot_left_3730 = gc_frame_newslot(opresult3745);
  params[0] = opresult3737;
  partcv[0] = 1;
  Object opresult3746 = callmethod(opresult3745, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3746 (depth = 4)
  gc_frame_end(frame);
  return opresult3746;
}
Object meth_collectionsPrelude__apply3749(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_t = getfromclosure(closure, 1);
  Object *var_jump = getfromclosure(closure, 2);
  Object *var_s = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1671
  setline(1671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_3751 = gc_frame_newslot(*var_x);
// starting to compile member node (depth = 6)
  int callframe3753 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe3754 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3755 = gc_frame_new();
// call case 4: self request
  Object call3756 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3755);
// compiled member node returning call3756 (depth = 8)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3757 = callmethodflags(call3756, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3754);
// compiled call node returning call3757 (depth = 7)
  Object call3758 = callmethodflags(call3757, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3753);
// compiled member node returning call3758 (depth = 6)
  int op_slot_left_3751 = gc_frame_newslot(call3758);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult3759 = callmethod(call3758, "==(1)", 1, partcv, params);
// compiled op node returning opresult3759 (depth = 5)
  Object if3750 = done;
  if (istrue(opresult3759)) {
// Begin line 1672
  setline(1672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3750 = undefined;
  } else {
  }
// compiled if node returning if3750 (depth = 4)
// Begin line 1674
  setline(1674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3762 = alloc_Float64(0);
// compiled num node returning num3762 (depth = 6)
  int op_slot_right_3761 = gc_frame_newslot(num3762);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_3761 = gc_frame_newslot(*var_jump);
  params[0] = num3762;
  partcv[0] = 1;
  Object opresult3764 = callmethod(*var_jump, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3764 (depth = 5)
  Object if3760 = done;
  if (istrue(opresult3764)) {
// Begin line 1675
  setline(1675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3765 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3768 = alloc_Float64(1);
// compiled num node returning num3768 (depth = 8)
  int op_slot_right_3767 = gc_frame_newslot(num3768);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3771 = alloc_Float64(3);
// compiled num node returning num3771 (depth = 9)
  int op_slot_right_3770 = gc_frame_newslot(num3771);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_3770 = gc_frame_newslot(*var_t);
  params[0] = num3771;
  partcv[0] = 1;
  Object prod3773 = callmethod(*var_t, "*(1)", 1, partcv, params);
// compiled op node returning prod3773 (depth = 8)
  int op_slot_left_3767 = gc_frame_newslot(prod3773);
  params[0] = num3768;
  partcv[0] = 1;
  Object sum3774 = callmethod(prod3773, "+(1)", 1, partcv, params);
// compiled op node returning sum3774 (depth = 7)
  int op_slot_left_3765 = gc_frame_newslot(sum3774);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3775 = callmethod(sum3774, "%(1)", 1, partcv, params);
// compiled op node returning modulus3775 (depth = 6)
  *var_t = modulus3775;
  if (modulus3775 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1676
  setline(1676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3778 = alloc_Float64(1);
// compiled num node returning num3778 (depth = 7)
  int op_slot_right_3777 = gc_frame_newslot(num3778);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_3777 = gc_frame_newslot(*var_jump);
  params[0] = num3778;
  partcv[0] = 1;
  Object diff3780 = callmethod(*var_jump, "-(1)", 1, partcv, params);
// compiled op node returning diff3780 (depth = 6)
  *var_jump = diff3780;
  if (diff3780 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3760 = done;
  } else {
// Begin line 1678
  setline(1678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3782 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3785 = alloc_Float64(1);
// compiled num node returning num3785 (depth = 8)
  int op_slot_right_3784 = gc_frame_newslot(num3785);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_3784 = gc_frame_newslot(*var_t);
  params[0] = num3785;
  partcv[0] = 1;
  Object sum3787 = callmethod(*var_t, "+(1)", 1, partcv, params);
// compiled op node returning sum3787 (depth = 7)
  int op_slot_left_3782 = gc_frame_newslot(sum3787);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3788 = callmethod(sum3787, "%(1)", 1, partcv, params);
// compiled op node returning modulus3788 (depth = 6)
  *var_t = modulus3788;
  if (modulus3788 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3760 = done;
  }
// compiled if node returning if3760 (depth = 4)
  gc_frame_end(frame);
  return if3760;
}
Object meth_collectionsPrelude_findPositionForAdd_40_1_41_3716(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findPositionForAdd(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findPositionForAdd(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findPositionForAdd(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findPositionForAdd(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3717 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  Object call3718 = callmethodflags(*var_x, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe3717);
// compiled member node returning call3718 (depth = 3)
  *var_h = call3718;
  if (call3718 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3719 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3720 = gc_frame_new();
// call case 4: self request
  Object call3721 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3720);
// compiled member node returning call3721 (depth = 4)
  Object call3722 = callmethodflags(call3721, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3719);
// compiled member node returning call3722 (depth = 3)
  *var_s = call3722;
  if (call3722 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1668
  setline(1668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_3723 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_3723 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3725 = callmethod(*var_h, "%(1)", 1, partcv, params);
// compiled op node returning modulus3725 (depth = 3)
  *var_t = modulus3725;
  if (modulus3725 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1669
  setline(1669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num3726 = alloc_Float64(5);
// compiled num node returning num3726 (depth = 3)
  *var_jump = num3726;
  if (num3726 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1670
  setline(1670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3727 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3728 = alloc_Block(NULL, NULL, "collectionsPrelude", 1670);
  gc_frame_newslot(block3728);
// method "_apply"
  block_savedest(block3728);
  Object closure3729 = createclosure(4, "_apply");
  setclosureframe(closure3729, stackframe);
  addtoclosure(closure3729, var_t);
  addtoclosure(closure3729, var_removed);
  addtoclosure(closure3729, var_unused);
  addtoclosure(closure3729, selfslot);
  struct UserObject *uo3729 = (struct UserObject*)block3728;
  uo3729->data[0] = (Object)closure3729;
  Method *meth_meth_collectionsPrelude__apply3729 = addmethod2pos(block3728, "_apply", &meth_collectionsPrelude__apply3729, 0);
  int argcv_meth_collectionsPrelude__apply3729[] = {0};
  meth_meth_collectionsPrelude__apply3729->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3729);
  meth_meth_collectionsPrelude__apply3729->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3729->definitionLine = 1991;
// compiled block node returning block3728 (depth = 3)
  gc_frame_newslot(block3728);
// starting to compile block node (depth = 3)
  Object block3748 = alloc_Block(NULL, NULL, "collectionsPrelude", 1670);
  gc_frame_newslot(block3748);
// method "_apply"
  block_savedest(block3748);
  Object closure3749 = createclosure(5, "_apply");
  setclosureframe(closure3749, stackframe);
  addtoclosure(closure3749, var_x);
  addtoclosure(closure3749, var_t);
  addtoclosure(closure3749, var_jump);
  addtoclosure(closure3749, var_s);
  addtoclosure(closure3749, selfslot);
  struct UserObject *uo3749 = (struct UserObject*)block3748;
  uo3749->data[0] = (Object)closure3749;
  Method *meth_meth_collectionsPrelude__apply3749 = addmethod2pos(block3748, "_apply", &meth_collectionsPrelude__apply3749, 0);
  int argcv_meth_collectionsPrelude__apply3749[] = {0};
  meth_meth_collectionsPrelude__apply3749->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3749);
  meth_meth_collectionsPrelude__apply3749->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3749->definitionLine = 1991;
// compiled block node returning block3748 (depth = 3)
  gc_frame_newslot(block3748);
// call case 5: prelude request
  params[0] = block3728;
  params[1] = block3748;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3791 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3727);
// compiled call node returning call3791 (depth = 2)
// Begin line 1681
  setline(1681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_1_41_3809(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_firstElement = getfromclosure(closure, 2);
  Object *var_s = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3810 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3811 = gc_frame_new();
// call case 4: self request
  Object call3812 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3811);
// compiled member node returning call3812 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3813 = callmethodflags(call3812, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3810);
// compiled call node returning call3813 (depth = 5)
  *var_a = call3813;
  if (call3813 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1690
  setline(1690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_3816 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_3816 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult3818 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3818 (depth = 6)
  int op_slot_right_3815 = gc_frame_newslot(opresult3818);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_3820 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_3820 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult3822 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3822 (depth = 6)
  int op_slot_left_3815 = gc_frame_newslot(opresult3822);
  params[0] = opresult3818;
  partcv[0] = 1;
  Object opresult3823 = callmethod(opresult3822, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3823 (depth = 5)
  Object if3814 = done;
  if (istrue(opresult3823)) {
// Begin line 1691
  setline(1691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3825 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_firstElement (depth = 7)
  partcv[0] = 0;
  Object call3826 = callmethodflags(*var_firstElement, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe3825);
// compiled call node returning call3826 (depth = 6)
  Object if3824 = done;
  if (istrue(call3826)) {
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3828 == NULL) {
    strlit3828 = alloc_String(", ");
    gc_root(strlit3828);
  }
// compiled string node returning strlit3828 (depth = 8)
  int op_slot_right_3827 = gc_frame_newslot(strlit3828);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_3827 = gc_frame_newslot(*var_s);
  params[0] = strlit3828;
  partcv[0] = 1;
  Object opresult3830 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3830 (depth = 7)
  *var_s = opresult3830;
  if (opresult3830 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if3824 = done;
  } else {
// Begin line 1694
  setline(1694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool3832 = alloc_Boolean(0);
// compiled identifier node returning bool3832 (depth = 7)
  *var_firstElement = bool3832;
  if (bool3832 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if3824 = done;
  }
// compiled if node returning if3824 (depth = 5)
// Begin line 1696
  setline(1696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3836 == NULL) {
    strlit3836 = alloc_String("");
    gc_root(strlit3836);
  }
// compiled string node returning strlit3836 (depth = 8)
  int op_slot_right_3835 = gc_frame_newslot(strlit3836);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3839 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_a (depth = 10)
  Object call3840 = callmethodflags(*var_a, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3839);
// compiled member node returning call3840 (depth = 9)
  int op_slot_right_3838 = gc_frame_newslot(call3840);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3843 == NULL) {
    strlit3843 = alloc_String("::");
    gc_root(strlit3843);
  }
// compiled string node returning strlit3843 (depth = 10)
  int op_slot_right_3842 = gc_frame_newslot(strlit3843);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe3846 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  Object call3847 = callmethodflags(*var_a, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3846);
// compiled member node returning call3847 (depth = 11)
  int op_slot_right_3845 = gc_frame_newslot(call3847);
// starting to compile string node (depth = 11)
  if (strlit3849 == NULL) {
    strlit3849 = alloc_String("");
    gc_root(strlit3849);
  }
// compiled string node returning strlit3849 (depth = 11)
  int op_slot_left_3845 = gc_frame_newslot(strlit3849);
  params[0] = call3847;
  partcv[0] = 1;
  Object opresult3850 = callmethod(strlit3849, "++(1)", 1, partcv, params);
// compiled op node returning opresult3850 (depth = 10)
  int op_slot_left_3842 = gc_frame_newslot(opresult3850);
  params[0] = strlit3843;
  partcv[0] = 1;
  Object opresult3851 = callmethod(opresult3850, "++(1)", 1, partcv, params);
// compiled op node returning opresult3851 (depth = 9)
  int op_slot_left_3838 = gc_frame_newslot(opresult3851);
  params[0] = call3840;
  partcv[0] = 1;
  Object opresult3852 = callmethod(opresult3851, "++(1)", 1, partcv, params);
// compiled op node returning opresult3852 (depth = 8)
  int op_slot_left_3835 = gc_frame_newslot(opresult3852);
  params[0] = strlit3836;
  partcv[0] = 1;
  Object opresult3853 = callmethod(opresult3852, "++(1)", 1, partcv, params);
// compiled op node returning opresult3853 (depth = 7)
  int op_slot_right_3834 = gc_frame_newslot(opresult3853);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3834 = gc_frame_newslot(*var_s);
  params[0] = opresult3853;
  partcv[0] = 1;
  Object opresult3855 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3855 (depth = 6)
  *var_s = opresult3855;
  if (opresult3855 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3814 = done;
  } else {
  }
// compiled if node returning if3814 (depth = 4)
  gc_frame_end(frame);
  return if3814;
}
Object meth_collectionsPrelude_asString3792(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
  Object *var_firstElement = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "firstElement");
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3793 == NULL) {
    strlit3793 = alloc_String("dict""\xe2""""\x9f""""\xac""");
    gc_root(strlit3793);
  }
// compiled string node returning strlit3793 (depth = 3)
  *var_s = strlit3793;
  if (strlit3793 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3794 = alloc_Boolean(1);
// compiled identifier node returning bool3794 (depth = 3)
  *var_firstElement = bool3794;
  if (bool3794 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3795 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3798 = alloc_Float64(1);
// compiled num node returning num3798 (depth = 5)
  int op_slot_right_3797 = gc_frame_newslot(num3798);
// starting to compile member node (depth = 5)
  int callframe3800 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3801 = gc_frame_new();
// call case 4: self request
  Object call3802 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3801);
// compiled member node returning call3802 (depth = 6)
  Object call3803 = callmethodflags(call3802, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3800);
// compiled member node returning call3803 (depth = 5)
  int op_slot_left_3797 = gc_frame_newslot(call3803);
  params[0] = num3798;
  partcv[0] = 1;
  Object diff3804 = callmethod(call3803, "-(1)", 1, partcv, params);
// compiled op node returning diff3804 (depth = 4)
  int op_slot_right_3796 = gc_frame_newslot(diff3804);
// starting to compile num node (depth = 4)
  Object num3806 = alloc_Float64(0);
// compiled num node returning num3806 (depth = 4)
  int op_slot_left_3796 = gc_frame_newslot(num3806);
  params[0] = diff3804;
  partcv[0] = 1;
  Object opresult3807 = callmethod(num3806, "..(1)", 1, partcv, params);
// compiled op node returning opresult3807 (depth = 3)
  gc_frame_newslot(opresult3807);
// starting to compile block node (depth = 3)
  Object block3808 = alloc_Block(NULL, NULL, "collectionsPrelude", 1688);
  gc_frame_newslot(block3808);
// method "_apply(_)"
  block_savedest(block3808);
  Object closure3809 = createclosure(5, "_apply(1)");
  setclosureframe(closure3809, stackframe);
  addtoclosure(closure3809, var_removed);
  addtoclosure(closure3809, var_unused);
  addtoclosure(closure3809, var_firstElement);
  addtoclosure(closure3809, var_s);
  addtoclosure(closure3809, selfslot);
  struct UserObject *uo3809 = (struct UserObject*)block3808;
  uo3809->data[0] = (Object)closure3809;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3809 = addmethod2pos(block3808, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3809, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3809[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3809->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3809);
  meth_meth_collectionsPrelude__apply_40_1_41_3809->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3809->definitionLine = 1991;
// compiled block node returning block3808 (depth = 3)
  gc_frame_newslot(block3808);
// call case 5: prelude request
  params[0] = opresult3807;
  params[1] = block3808;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3858 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3795);
// compiled call node returning call3858 (depth = 2)
// Begin line 1699
  setline(1699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3860 == NULL) {
    strlit3860 = alloc_String("""\xe2""""\x9f""""\xad""");
    gc_root(strlit3860);
  }
// compiled string node returning strlit3860 (depth = 3)
  int op_slot_right_3859 = gc_frame_newslot(strlit3860);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_3859 = gc_frame_newslot(*var_s);
  params[0] = strlit3860;
  partcv[0] = 1;
  Object opresult3862 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3862 (depth = 2)
  gc_frame_end(frame);
  return opresult3862;
}
Object meth_collectionsPrelude__apply_40_1_41_3879(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1704
  setline(1704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3882 = alloc_Float64(0);
// compiled num node returning num3882 (depth = 6)
  int op_slot_right_3881 = gc_frame_newslot(num3882);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_3881 = gc_frame_newslot(*var_i);
  params[0] = num3882;
  partcv[0] = 1;
  Object opresult3884 = callmethod(*var_i, ">(1)", 1, partcv, params);
// compiled op node returning opresult3884 (depth = 5)
  Object if3880 = done;
  if (istrue(opresult3884)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3886 == NULL) {
    strlit3886 = alloc_String(", ");
    gc_root(strlit3886);
  }
// compiled string node returning strlit3886 (depth = 7)
  int op_slot_right_3885 = gc_frame_newslot(strlit3886);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3885 = gc_frame_newslot(*var_s);
  params[0] = strlit3886;
  partcv[0] = 1;
  Object opresult3888 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3888 (depth = 6)
  *var_s = opresult3888;
  if (opresult3888 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3880 = done;
  } else {
  }
// compiled if node returning if3880 (depth = 4)
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3890 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3891 = gc_frame_new();
// call case 4: self request
  Object call3892 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3891);
// compiled member node returning call3892 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3893 = callmethodflags(call3892, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3890);
// compiled call node returning call3893 (depth = 5)
  *var_a = call3893;
  if (call3893 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1706
  setline(1706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_3896 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_3896 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult3898 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3898 (depth = 6)
  int op_slot_right_3895 = gc_frame_newslot(opresult3898);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_3900 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_3900 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult3902 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3902 (depth = 6)
  int op_slot_left_3895 = gc_frame_newslot(opresult3902);
  params[0] = opresult3898;
  partcv[0] = 1;
  Object opresult3903 = callmethod(opresult3902, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3903 (depth = 5)
  Object if3894 = done;
  if (istrue(opresult3903)) {
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3906 == NULL) {
    strlit3906 = alloc_String("");
    gc_root(strlit3906);
  }
// compiled string node returning strlit3906 (depth = 8)
  int op_slot_right_3905 = gc_frame_newslot(strlit3906);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3909 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_a (depth = 10)
  Object call3910 = callmethodflags(*var_a, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3909);
// compiled member node returning call3910 (depth = 9)
  int op_slot_right_3908 = gc_frame_newslot(call3910);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3913 == NULL) {
    strlit3913 = alloc_String("::");
    gc_root(strlit3913);
  }
// compiled string node returning strlit3913 (depth = 10)
  int op_slot_right_3912 = gc_frame_newslot(strlit3913);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe3916 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  Object call3917 = callmethodflags(*var_a, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3916);
// compiled member node returning call3917 (depth = 11)
  int op_slot_right_3915 = gc_frame_newslot(call3917);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3920 == NULL) {
    strlit3920 = alloc_String("""\xe2""""\x86""""\x92""");
    gc_root(strlit3920);
  }
// compiled string node returning strlit3920 (depth = 12)
  int op_slot_right_3919 = gc_frame_newslot(strlit3920);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  int op_slot_right_3922 = gc_frame_newslot(*var_i);
// starting to compile string node (depth = 13)
  if (strlit3924 == NULL) {
    strlit3924 = alloc_String("");
    gc_root(strlit3924);
  }
// compiled string node returning strlit3924 (depth = 13)
  int op_slot_left_3922 = gc_frame_newslot(strlit3924);
  params[0] = *var_i;
  partcv[0] = 1;
  Object opresult3925 = callmethod(strlit3924, "++(1)", 1, partcv, params);
// compiled op node returning opresult3925 (depth = 12)
  int op_slot_left_3919 = gc_frame_newslot(opresult3925);
  params[0] = strlit3920;
  partcv[0] = 1;
  Object opresult3926 = callmethod(opresult3925, "++(1)", 1, partcv, params);
// compiled op node returning opresult3926 (depth = 11)
  int op_slot_left_3915 = gc_frame_newslot(opresult3926);
  params[0] = call3917;
  partcv[0] = 1;
  Object opresult3927 = callmethod(opresult3926, "++(1)", 1, partcv, params);
// compiled op node returning opresult3927 (depth = 10)
  int op_slot_left_3912 = gc_frame_newslot(opresult3927);
  params[0] = strlit3913;
  partcv[0] = 1;
  Object opresult3928 = callmethod(opresult3927, "++(1)", 1, partcv, params);
// compiled op node returning opresult3928 (depth = 9)
  int op_slot_left_3908 = gc_frame_newslot(opresult3928);
  params[0] = call3910;
  partcv[0] = 1;
  Object opresult3929 = callmethod(opresult3928, "++(1)", 1, partcv, params);
// compiled op node returning opresult3929 (depth = 8)
  int op_slot_left_3905 = gc_frame_newslot(opresult3929);
  params[0] = strlit3906;
  partcv[0] = 1;
  Object opresult3930 = callmethod(opresult3929, "++(1)", 1, partcv, params);
// compiled op node returning opresult3930 (depth = 7)
  int op_slot_right_3904 = gc_frame_newslot(opresult3930);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3904 = gc_frame_newslot(*var_s);
  params[0] = opresult3930;
  partcv[0] = 1;
  Object opresult3932 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3932 (depth = 6)
  *var_s = opresult3932;
  if (opresult3932 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3894 = done;
  } else {
// Begin line 1709
  setline(1709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3936 == NULL) {
    strlit3936 = alloc_String("");
    gc_root(strlit3936);
  }
// compiled string node returning strlit3936 (depth = 8)
  int op_slot_right_3935 = gc_frame_newslot(strlit3936);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3939 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_a (depth = 10)
  Object call3940 = callmethodflags(*var_a, "asDebugString", 0, partcv, params, 0);
  gc_frame_end(callframe3939);
// compiled member node returning call3940 (depth = 9)
  int op_slot_right_3938 = gc_frame_newslot(call3940);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3943 == NULL) {
    strlit3943 = alloc_String("""\xe2""""\x86""""\x92""");
    gc_root(strlit3943);
  }
// compiled string node returning strlit3943 (depth = 10)
  int op_slot_right_3942 = gc_frame_newslot(strlit3943);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_i (depth = 11)
  int op_slot_right_3945 = gc_frame_newslot(*var_i);
// starting to compile string node (depth = 11)
  if (strlit3947 == NULL) {
    strlit3947 = alloc_String("");
    gc_root(strlit3947);
  }
// compiled string node returning strlit3947 (depth = 11)
  int op_slot_left_3945 = gc_frame_newslot(strlit3947);
  params[0] = *var_i;
  partcv[0] = 1;
  Object opresult3948 = callmethod(strlit3947, "++(1)", 1, partcv, params);
// compiled op node returning opresult3948 (depth = 10)
  int op_slot_left_3942 = gc_frame_newslot(opresult3948);
  params[0] = strlit3943;
  partcv[0] = 1;
  Object opresult3949 = callmethod(opresult3948, "++(1)", 1, partcv, params);
// compiled op node returning opresult3949 (depth = 9)
  int op_slot_left_3938 = gc_frame_newslot(opresult3949);
  params[0] = call3940;
  partcv[0] = 1;
  Object opresult3950 = callmethod(opresult3949, "++(1)", 1, partcv, params);
// compiled op node returning opresult3950 (depth = 8)
  int op_slot_left_3935 = gc_frame_newslot(opresult3950);
  params[0] = strlit3936;
  partcv[0] = 1;
  Object opresult3951 = callmethod(opresult3950, "++(1)", 1, partcv, params);
// compiled op node returning opresult3951 (depth = 7)
  int op_slot_right_3934 = gc_frame_newslot(opresult3951);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3934 = gc_frame_newslot(*var_s);
  params[0] = opresult3951;
  partcv[0] = 1;
  Object opresult3953 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3953 (depth = 6)
  *var_s = opresult3953;
  if (opresult3953 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3894 = done;
  }
// compiled if node returning if3894 (depth = 4)
  gc_frame_end(frame);
  return if3894;
}
Object meth_collectionsPrelude_asDebugString3863(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1702
  setline(1702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3864 == NULL) {
    strlit3864 = alloc_String("dict""\xe2""""\x9f""""\xac""");
    gc_root(strlit3864);
  }
// compiled string node returning strlit3864 (depth = 3)
  *var_s = strlit3864;
  if (strlit3864 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3865 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3868 = alloc_Float64(1);
// compiled num node returning num3868 (depth = 5)
  int op_slot_right_3867 = gc_frame_newslot(num3868);
// starting to compile member node (depth = 5)
  int callframe3870 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3871 = gc_frame_new();
// call case 4: self request
  Object call3872 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3871);
// compiled member node returning call3872 (depth = 6)
  Object call3873 = callmethodflags(call3872, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3870);
// compiled member node returning call3873 (depth = 5)
  int op_slot_left_3867 = gc_frame_newslot(call3873);
  params[0] = num3868;
  partcv[0] = 1;
  Object diff3874 = callmethod(call3873, "-(1)", 1, partcv, params);
// compiled op node returning diff3874 (depth = 4)
  int op_slot_right_3866 = gc_frame_newslot(diff3874);
// starting to compile num node (depth = 4)
  Object num3876 = alloc_Float64(0);
// compiled num node returning num3876 (depth = 4)
  int op_slot_left_3866 = gc_frame_newslot(num3876);
  params[0] = diff3874;
  partcv[0] = 1;
  Object opresult3877 = callmethod(num3876, "..(1)", 1, partcv, params);
// compiled op node returning opresult3877 (depth = 3)
  gc_frame_newslot(opresult3877);
// starting to compile block node (depth = 3)
  Object block3878 = alloc_Block(NULL, NULL, "collectionsPrelude", 1703);
  gc_frame_newslot(block3878);
// method "_apply(_)"
  block_savedest(block3878);
  Object closure3879 = createclosure(4, "_apply(1)");
  setclosureframe(closure3879, stackframe);
  addtoclosure(closure3879, var_s);
  addtoclosure(closure3879, var_removed);
  addtoclosure(closure3879, var_unused);
  addtoclosure(closure3879, selfslot);
  struct UserObject *uo3879 = (struct UserObject*)block3878;
  uo3879->data[0] = (Object)closure3879;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3879 = addmethod2pos(block3878, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3879, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3879[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3879->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3879);
  meth_meth_collectionsPrelude__apply_40_1_41_3879->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3879->definitionLine = 1991;
// compiled block node returning block3878 (depth = 3)
  gc_frame_newslot(block3878);
// call case 5: prelude request
  params[0] = opresult3877;
  params[1] = block3878;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3956 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3865);
// compiled call node returning call3956 (depth = 2)
// Begin line 1712
  setline(1712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3958 == NULL) {
    strlit3958 = alloc_String("""\xe2""""\x9f""""\xad""");
    gc_root(strlit3958);
  }
// compiled string node returning strlit3958 (depth = 3)
  int op_slot_right_3957 = gc_frame_newslot(strlit3958);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_3957 = gc_frame_newslot(*var_s);
  params[0] = strlit3958;
  partcv[0] = 1;
  Object opresult3960 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3960 (depth = 2)
  gc_frame_end(frame);
  return opresult3960;
}
Object meth_collectionsPrelude_hasNext3968(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3969 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3970 = gc_frame_new();
// call case 4: self request
  Object call3971 = callmethodflags(self, "sourceIterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3970);
// compiled member node returning call3971 (depth = 3)
  Object call3972 = callmethodflags(call3971, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe3969);
// compiled member node returning call3972 (depth = 2)
  gc_frame_end(frame);
  return call3972;
}
Object meth_collectionsPrelude_next3973(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3974 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3975 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3976 = gc_frame_new();
// call case 4: self request
  Object call3977 = callmethodflags(self, "sourceIterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3976);
// compiled member node returning call3977 (depth = 4)
  Object call3978 = callmethodflags(call3977, "next", 0, partcv, params, 0);
  gc_frame_end(callframe3975);
// compiled member node returning call3978 (depth = 3)
  Object call3979 = callmethodflags(call3978, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3974);
// compiled member node returning call3979 (depth = 2)
  gc_frame_end(frame);
  return call3979;
}
Object meth_collectionsPrelude_asString3980(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1723
  setline(1723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3982 == NULL) {
    strlit3982 = alloc_String("");
    gc_root(strlit3982);
  }
// compiled string node returning strlit3982 (depth = 3)
  int op_slot_right_3981 = gc_frame_newslot(strlit3982);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3984 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3986 == NULL) {
    strlit3986 = alloc_String("an iterator over keys of ");
    gc_root(strlit3986);
  }
// compiled string node returning strlit3986 (depth = 4)
  int op_slot_left_3984 = gc_frame_newslot(strlit3986);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3987 = callmethod(strlit3986, "++(1)", 1, partcv, params);
// compiled op node returning opresult3987 (depth = 3)
  int op_slot_left_3981 = gc_frame_newslot(opresult3987);
  params[0] = strlit3982;
  partcv[0] = 1;
  Object opresult3988 = callmethod(opresult3987, "++(1)", 1, partcv, params);
// compiled op node returning opresult3988 (depth = 2)
  gc_frame_end(frame);
  return opresult3988;
}
Object meth_collectionsPrelude_iterator3964(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3965 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3965 = alloc_userobj2(4,5, objclass3965);
  gc_frame_newslot(obj3965);
if (objclass3965 == NULL) {
  glfree(obj3965->class->name);
  obj3965->class->name = "dictionary.empty.object.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3965, self, 0);
  addmethodreal(obj3965,"outer", &reader_collectionsPrelude_outer_3966);
  Object oldself3965 = self;
  struct StackFrameObject *oldstackframe3965 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3965);
  gc_frame_newslot((Object)stackframe);
  self = obj3965;
  Object *oldselfslot3965 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3965 = (*(struct UserObject *)self).data[0], lowerouter3965 = thisouter3965;
  if (inheritingObject3965) {
    struct UserObject *inho3965 = (struct UserObject *)inheritingObject3965;
    while (inho3965->super != GraceDefaultObject) inho3965 = (struct UserObject *)inho3965->super;
    inho3965->super = obj3965;
    self = inheritingObject3965;
    *selfslot = self;
    lowerouter3965 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3965;
  }
if (objclass3965 == NULL) {
  Method *reader3967 = addmethodrealflags(obj3965, "sourceIterator",&reader_collectionsPrelude_sourceIterator_3967, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3967->definitionModule = modulename;
  reader3967->definitionLine = 1719;
}
adddatum2(obj3965, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo3968 = (struct UserObject*)obj3965;
  uo3968->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3968 = addmethod2pos(obj3965, "hasNext", &meth_collectionsPrelude_hasNext3968, 2);
  int argcv_meth_collectionsPrelude_hasNext3968[] = {0};
  meth_meth_collectionsPrelude_hasNext3968->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3968);
  meth_meth_collectionsPrelude_hasNext3968->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3968->definitionLine = 1720;
// method "next"
  struct UserObject *uo3973 = (struct UserObject*)obj3965;
  uo3973->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next3973 = addmethod2pos(obj3965, "next", &meth_collectionsPrelude_next3973, 3);
  int argcv_meth_collectionsPrelude_next3973[] = {0};
  meth_meth_collectionsPrelude_next3973->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next3973);
  meth_meth_collectionsPrelude_next3973->definitionModule = modulename;
  meth_meth_collectionsPrelude_next3973->definitionLine = 1721;
// method "asString"
  block_savedest(obj3965);
  Object closure3980 = createclosure(1, "asString");
  setclosureframe(closure3980, stackframe);
  addtoclosure(closure3980, var_sourceDictionary);
  struct UserObject *uo3980 = (struct UserObject*)obj3965;
  uo3980->data[4] = (Object)closure3980;
  Method *meth_meth_collectionsPrelude_asString3980 = addmethod2pos(obj3965, "asString", &meth_collectionsPrelude_asString3980, 4);
  int argcv_meth_collectionsPrelude_asString3980[] = {0};
  meth_meth_collectionsPrelude_asString3980->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3980);
  meth_meth_collectionsPrelude_asString3980->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3980->definitionLine = 1722;
  sourceObject = obj3965;
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3989 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call3990 = callmethodflags(*var_sourceDictionary, "bindingsIterator", 0, partcv, params, 0);
  gc_frame_end(callframe3989);
// compiled member node returning call3990 (depth = 2)
  adddatum2(obj3965, call3990, 1);
  sourceObject = obj3965;
  sourceObject = obj3965;
  sourceObject = obj3965;
  objclass3965 = obj3965->class;
  objclass3965->definitionModule = modulename;
  objclass3965->definitionLine = 1718;
  (*(struct UserObject *)self).data[0] = lowerouter3965;
  self = oldself3965;
  selfslot = oldselfslot3965;
  stackframe = oldstackframe3965;
  gc_frame_end(frame);
  return obj3965;
}
Object meth_collectionsPrelude_iterator3964_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3965 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3965 = alloc_userobj2(4,5, objclass3965);
  gc_frame_newslot(obj3965);
if (objclass3965 == NULL) {
  glfree(obj3965->class->name);
  obj3965->class->name = "dictionary.empty.object.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3965, self, 0);
  addmethodreal(obj3965,"outer", &reader_collectionsPrelude_outer_3966);
  Object oldself3965 = self;
  struct StackFrameObject *oldstackframe3965 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3965);
  gc_frame_newslot((Object)stackframe);
  self = obj3965;
  Object *oldselfslot3965 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3965 = (*(struct UserObject *)self).data[0], lowerouter3965 = thisouter3965;
  if (inheritingObject3965) {
    struct UserObject *inho3965 = (struct UserObject *)inheritingObject3965;
    while (inho3965->super != GraceDefaultObject) inho3965 = (struct UserObject *)inho3965->super;
    inho3965->super = obj3965;
    self = inheritingObject3965;
    *selfslot = self;
    lowerouter3965 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3965;
  }
if (objclass3965 == NULL) {
  Method *reader3967 = addmethodrealflags(obj3965, "sourceIterator",&reader_collectionsPrelude_sourceIterator_3967, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3967->definitionModule = modulename;
  reader3967->definitionLine = 1719;
}
adddatum2(obj3965, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo3968 = (struct UserObject*)obj3965;
  uo3968->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3968 = addmethod2pos(obj3965, "hasNext", &meth_collectionsPrelude_hasNext3968, 2);
  int argcv_meth_collectionsPrelude_hasNext3968[] = {0};
  meth_meth_collectionsPrelude_hasNext3968->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3968);
  meth_meth_collectionsPrelude_hasNext3968->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3968->definitionLine = 1720;
// method "next"
  struct UserObject *uo3973 = (struct UserObject*)obj3965;
  uo3973->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next3973 = addmethod2pos(obj3965, "next", &meth_collectionsPrelude_next3973, 3);
  int argcv_meth_collectionsPrelude_next3973[] = {0};
  meth_meth_collectionsPrelude_next3973->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next3973);
  meth_meth_collectionsPrelude_next3973->definitionModule = modulename;
  meth_meth_collectionsPrelude_next3973->definitionLine = 1721;
// method "asString"
  block_savedest(obj3965);
  Object closure3980 = createclosure(1, "asString");
  setclosureframe(closure3980, stackframe);
  addtoclosure(closure3980, var_sourceDictionary);
  struct UserObject *uo3980 = (struct UserObject*)obj3965;
  uo3980->data[4] = (Object)closure3980;
  Method *meth_meth_collectionsPrelude_asString3980 = addmethod2pos(obj3965, "asString", &meth_collectionsPrelude_asString3980, 4);
  int argcv_meth_collectionsPrelude_asString3980[] = {0};
  meth_meth_collectionsPrelude_asString3980->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3980);
  meth_meth_collectionsPrelude_asString3980->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3980->definitionLine = 1722;
  sourceObject = obj3965;
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3989 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call3990 = callmethodflags(*var_sourceDictionary, "bindingsIterator", 0, partcv, params, 0);
  gc_frame_end(callframe3989);
// compiled member node returning call3990 (depth = 2)
  adddatum2(obj3965, call3990, 1);
  sourceObject = obj3965;
  sourceObject = obj3965;
  sourceObject = obj3965;
  objclass3965 = obj3965->class;
  objclass3965->definitionModule = modulename;
  objclass3965->definitionLine = 1718;
  (*(struct UserObject *)self).data[0] = lowerouter3965;
  self = oldself3965;
  selfslot = oldselfslot3965;
  stackframe = oldstackframe3965;
  gc_frame_end(frame);
  return obj3965;
}
Object meth_collectionsPrelude_asDebugString3993(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3995 == NULL) {
    strlit3995 = alloc_String("");
    gc_root(strlit3995);
  }
// compiled string node returning strlit3995 (depth = 3)
  int op_slot_right_3994 = gc_frame_newslot(strlit3995);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3997 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3999 == NULL) {
    strlit3999 = alloc_String("a lazy sequence over keys of ");
    gc_root(strlit3999);
  }
// compiled string node returning strlit3999 (depth = 4)
  int op_slot_left_3997 = gc_frame_newslot(strlit3999);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult4000 = callmethod(strlit3999, "++(1)", 1, partcv, params);
// compiled op node returning opresult4000 (depth = 3)
  int op_slot_left_3994 = gc_frame_newslot(opresult4000);
  params[0] = strlit3995;
  partcv[0] = 1;
  Object opresult4001 = callmethod(opresult4000, "++(1)", 1, partcv, params);
// compiled op node returning opresult4001 (depth = 2)
  gc_frame_end(frame);
  return opresult4001;
}
Object meth_collectionsPrelude_keys3961(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3962 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3962 = alloc_userobj2(4,5, objclass3962);
  gc_frame_newslot(obj3962);
if (objclass3962 == NULL) {
  glfree(obj3962->class->name);
  obj3962->class->name = "dictionary.empty.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3962, self, 0);
  addmethodreal(obj3962,"outer", &reader_collectionsPrelude_outer_3963);
  Object oldself3962 = self;
  struct StackFrameObject *oldstackframe3962 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3962);
  gc_frame_newslot((Object)stackframe);
  self = obj3962;
  Object *oldselfslot3962 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3962 = (*(struct UserObject *)self).data[0], lowerouter3962 = thisouter3962;
  if (inheritingObject3962) {
    struct UserObject *inho3962 = (struct UserObject *)inheritingObject3962;
    while (inho3962->super != GraceDefaultObject) inho3962 = (struct UserObject *)inho3962->super;
    inho3962->super = obj3962;
    self = inheritingObject3962;
    *selfslot = self;
    lowerouter3962 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3962;
  }
// method "iterator"
  block_savedest(obj3962);
  Object closure3964 = createclosure(1, "iterator");
  setclosureframe(closure3964, stackframe);
  addtoclosure(closure3964, var_sourceDictionary);
  struct UserObject *uo3964 = (struct UserObject*)obj3962;
  uo3964->data[1] = (Object)closure3964;
  Method *meth_meth_collectionsPrelude_iterator3964 = addmethod2pos(obj3962, "iterator", &meth_collectionsPrelude_iterator3964, 1);
  int argcv_meth_collectionsPrelude_iterator3964[] = {0};
  meth_meth_collectionsPrelude_iterator3964->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3964);
  meth_meth_collectionsPrelude_iterator3964->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3964->definitionLine = 1718;
  block_savedest(obj3962);
  Object closure3991 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure3991, stackframe);
  addtoclosure(closure3991, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_iterator3964_object = addmethod2pos(obj3962, "iterator$object(1)", &meth_collectionsPrelude_iterator3964_object, 1);
  meth_meth_collectionsPrelude_iterator3964_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3964_object->definitionLine = 1718;
if (objclass3962 == NULL) {
  Method *reader3992 = addmethodrealflags(obj3962, "size",&reader_collectionsPrelude_size_3992, MFLAG_DEF);
  reader3992->definitionModule = modulename;
  reader3992->definitionLine = 1726;
}
adddatum2(obj3962, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3962);
  Object closure3993 = createclosure(1, "asDebugString");
  setclosureframe(closure3993, stackframe);
  addtoclosure(closure3993, var_sourceDictionary);
  struct UserObject *uo3993 = (struct UserObject*)obj3962;
  uo3993->data[3] = (Object)closure3993;
  Method *meth_meth_collectionsPrelude_asDebugString3993 = addmethod2pos(obj3962, "asDebugString", &meth_collectionsPrelude_asDebugString3993, 3);
  int argcv_meth_collectionsPrelude_asDebugString3993[] = {0};
  meth_meth_collectionsPrelude_asDebugString3993->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3993);
  meth_meth_collectionsPrelude_asDebugString3993->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3993->definitionLine = 1727;
  sourceObject = obj3962;
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4002 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4003 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4002);
// compiled call node returning call4003 (depth = 2)
  struct UserObject *obj3962_uo = (struct UserObject *)obj3962;
  obj3962_uo->super = call4003;
  sourceObject = obj3962;
  sourceObject = obj3962;
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4004 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call4005 = callmethodflags(*var_sourceDictionary, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4004);
// compiled member node returning call4005 (depth = 2)
  adddatum2(obj3962, call4005, 2);
  sourceObject = obj3962;
  objclass3962 = obj3962->class;
  objclass3962->definitionModule = modulename;
  objclass3962->definitionLine = 1716;
  (*(struct UserObject *)self).data[0] = lowerouter3962;
  self = oldself3962;
  selfslot = oldselfslot3962;
  stackframe = oldstackframe3962;
  gc_frame_end(frame);
  return obj3962;
}
Object meth_collectionsPrelude_keys3961_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keys$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3962 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3962 = alloc_userobj2(4,5, objclass3962);
  gc_frame_newslot(obj3962);
if (objclass3962 == NULL) {
  glfree(obj3962->class->name);
  obj3962->class->name = "dictionary.empty.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3962, self, 0);
  addmethodreal(obj3962,"outer", &reader_collectionsPrelude_outer_3963);
  Object oldself3962 = self;
  struct StackFrameObject *oldstackframe3962 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3962);
  gc_frame_newslot((Object)stackframe);
  self = obj3962;
  Object *oldselfslot3962 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3962 = (*(struct UserObject *)self).data[0], lowerouter3962 = thisouter3962;
  if (inheritingObject3962) {
    struct UserObject *inho3962 = (struct UserObject *)inheritingObject3962;
    while (inho3962->super != GraceDefaultObject) inho3962 = (struct UserObject *)inho3962->super;
    inho3962->super = obj3962;
    self = inheritingObject3962;
    *selfslot = self;
    lowerouter3962 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3962;
  }
// method "iterator"
  block_savedest(obj3962);
  Object closure3964 = createclosure(1, "iterator");
  setclosureframe(closure3964, stackframe);
  addtoclosure(closure3964, var_sourceDictionary);
  struct UserObject *uo3964 = (struct UserObject*)obj3962;
  uo3964->data[1] = (Object)closure3964;
  Method *meth_meth_collectionsPrelude_iterator3964 = addmethod2pos(obj3962, "iterator", &meth_collectionsPrelude_iterator3964, 1);
  int argcv_meth_collectionsPrelude_iterator3964[] = {0};
  meth_meth_collectionsPrelude_iterator3964->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3964);
  meth_meth_collectionsPrelude_iterator3964->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3964->definitionLine = 1718;
  block_savedest(obj3962);
  Object closure3991 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure3991, stackframe);
  addtoclosure(closure3991, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_iterator3964_object = addmethod2pos(obj3962, "iterator$object(1)", &meth_collectionsPrelude_iterator3964_object, 1);
  meth_meth_collectionsPrelude_iterator3964_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3964_object->definitionLine = 1718;
if (objclass3962 == NULL) {
  Method *reader3992 = addmethodrealflags(obj3962, "size",&reader_collectionsPrelude_size_3992, MFLAG_DEF);
  reader3992->definitionModule = modulename;
  reader3992->definitionLine = 1726;
}
adddatum2(obj3962, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3962);
  Object closure3993 = createclosure(1, "asDebugString");
  setclosureframe(closure3993, stackframe);
  addtoclosure(closure3993, var_sourceDictionary);
  struct UserObject *uo3993 = (struct UserObject*)obj3962;
  uo3993->data[3] = (Object)closure3993;
  Method *meth_meth_collectionsPrelude_asDebugString3993 = addmethod2pos(obj3962, "asDebugString", &meth_collectionsPrelude_asDebugString3993, 3);
  int argcv_meth_collectionsPrelude_asDebugString3993[] = {0};
  meth_meth_collectionsPrelude_asDebugString3993->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3993);
  meth_meth_collectionsPrelude_asDebugString3993->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3993->definitionLine = 1727;
  sourceObject = obj3962;
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4002 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4003 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4002);
// compiled call node returning call4003 (depth = 2)
  struct UserObject *obj3962_uo = (struct UserObject *)obj3962;
  obj3962_uo->super = call4003;
  sourceObject = obj3962;
  sourceObject = obj3962;
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4004 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call4005 = callmethodflags(*var_sourceDictionary, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4004);
// compiled member node returning call4005 (depth = 2)
  adddatum2(obj3962, call4005, 2);
  sourceObject = obj3962;
  objclass3962 = obj3962->class;
  objclass3962->definitionModule = modulename;
  objclass3962->definitionLine = 1716;
  (*(struct UserObject *)self).data[0] = lowerouter3962;
  self = oldself3962;
  selfslot = oldselfslot3962;
  stackframe = oldstackframe3962;
  gc_frame_end(frame);
  return obj3962;
}
Object meth_collectionsPrelude_hasNext4014(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4015 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4016 = gc_frame_new();
// call case 4: self request
  Object call4017 = callmethodflags(self, "sourceIterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4016);
// compiled member node returning call4017 (depth = 3)
  Object call4018 = callmethodflags(call4017, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe4015);
// compiled member node returning call4018 (depth = 2)
  gc_frame_end(frame);
  return call4018;
}
Object meth_collectionsPrelude_next4019(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4020 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4021 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4022 = gc_frame_new();
// call case 4: self request
  Object call4023 = callmethodflags(self, "sourceIterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4022);
// compiled member node returning call4023 (depth = 4)
  Object call4024 = callmethodflags(call4023, "next", 0, partcv, params, 0);
  gc_frame_end(callframe4021);
// compiled member node returning call4024 (depth = 3)
  Object call4025 = callmethodflags(call4024, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4020);
// compiled member node returning call4025 (depth = 2)
  gc_frame_end(frame);
  return call4025;
}
Object meth_collectionsPrelude_asString4026(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1742
  setline(1742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4028 == NULL) {
    strlit4028 = alloc_String("");
    gc_root(strlit4028);
  }
// compiled string node returning strlit4028 (depth = 3)
  int op_slot_right_4027 = gc_frame_newslot(strlit4028);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_4030 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit4032 == NULL) {
    strlit4032 = alloc_String("an iterator over values of ");
    gc_root(strlit4032);
  }
// compiled string node returning strlit4032 (depth = 4)
  int op_slot_left_4030 = gc_frame_newslot(strlit4032);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult4033 = callmethod(strlit4032, "++(1)", 1, partcv, params);
// compiled op node returning opresult4033 (depth = 3)
  int op_slot_left_4027 = gc_frame_newslot(opresult4033);
  params[0] = strlit4028;
  partcv[0] = 1;
  Object opresult4034 = callmethod(opresult4033, "++(1)", 1, partcv, params);
// compiled op node returning opresult4034 (depth = 2)
  gc_frame_end(frame);
  return opresult4034;
}
Object meth_collectionsPrelude_iterator4010(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4011 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4011 = alloc_userobj2(4,5, objclass4011);
  gc_frame_newslot(obj4011);
if (objclass4011 == NULL) {
  glfree(obj4011->class->name);
  obj4011->class->name = "dictionary.empty.object.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4011, self, 0);
  addmethodreal(obj4011,"outer", &reader_collectionsPrelude_outer_4012);
  Object oldself4011 = self;
  struct StackFrameObject *oldstackframe4011 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4011);
  gc_frame_newslot((Object)stackframe);
  self = obj4011;
  Object *oldselfslot4011 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4011 = (*(struct UserObject *)self).data[0], lowerouter4011 = thisouter4011;
  if (inheritingObject4011) {
    struct UserObject *inho4011 = (struct UserObject *)inheritingObject4011;
    while (inho4011->super != GraceDefaultObject) inho4011 = (struct UserObject *)inho4011->super;
    inho4011->super = obj4011;
    self = inheritingObject4011;
    *selfslot = self;
    lowerouter4011 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4011;
  }
if (objclass4011 == NULL) {
  Method *reader4013 = addmethodrealflags(obj4011, "sourceIterator",&reader_collectionsPrelude_sourceIterator_4013, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4013->definitionModule = modulename;
  reader4013->definitionLine = 1737;
}
adddatum2(obj4011, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo4014 = (struct UserObject*)obj4011;
  uo4014->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext4014 = addmethod2pos(obj4011, "hasNext", &meth_collectionsPrelude_hasNext4014, 2);
  int argcv_meth_collectionsPrelude_hasNext4014[] = {0};
  meth_meth_collectionsPrelude_hasNext4014->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext4014);
  meth_meth_collectionsPrelude_hasNext4014->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext4014->definitionLine = 1739;
// method "next"
  struct UserObject *uo4019 = (struct UserObject*)obj4011;
  uo4019->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next4019 = addmethod2pos(obj4011, "next", &meth_collectionsPrelude_next4019, 3);
  int argcv_meth_collectionsPrelude_next4019[] = {0};
  meth_meth_collectionsPrelude_next4019->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4019);
  meth_meth_collectionsPrelude_next4019->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4019->definitionLine = 1740;
// method "asString"
  block_savedest(obj4011);
  Object closure4026 = createclosure(1, "asString");
  setclosureframe(closure4026, stackframe);
  addtoclosure(closure4026, var_sourceDictionary);
  struct UserObject *uo4026 = (struct UserObject*)obj4011;
  uo4026->data[4] = (Object)closure4026;
  Method *meth_meth_collectionsPrelude_asString4026 = addmethod2pos(obj4011, "asString", &meth_collectionsPrelude_asString4026, 4);
  int argcv_meth_collectionsPrelude_asString4026[] = {0};
  meth_meth_collectionsPrelude_asString4026->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4026);
  meth_meth_collectionsPrelude_asString4026->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4026->definitionLine = 1741;
  sourceObject = obj4011;
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4035 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call4036 = callmethodflags(*var_sourceDictionary, "bindingsIterator", 0, partcv, params, 0);
  gc_frame_end(callframe4035);
// compiled member node returning call4036 (depth = 2)
  adddatum2(obj4011, call4036, 1);
  sourceObject = obj4011;
  sourceObject = obj4011;
  sourceObject = obj4011;
  objclass4011 = obj4011->class;
  objclass4011->definitionModule = modulename;
  objclass4011->definitionLine = 1736;
  (*(struct UserObject *)self).data[0] = lowerouter4011;
  self = oldself4011;
  selfslot = oldselfslot4011;
  stackframe = oldstackframe4011;
  gc_frame_end(frame);
  return obj4011;
}
Object meth_collectionsPrelude_iterator4010_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4011 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4011 = alloc_userobj2(4,5, objclass4011);
  gc_frame_newslot(obj4011);
if (objclass4011 == NULL) {
  glfree(obj4011->class->name);
  obj4011->class->name = "dictionary.empty.object.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4011, self, 0);
  addmethodreal(obj4011,"outer", &reader_collectionsPrelude_outer_4012);
  Object oldself4011 = self;
  struct StackFrameObject *oldstackframe4011 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4011);
  gc_frame_newslot((Object)stackframe);
  self = obj4011;
  Object *oldselfslot4011 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4011 = (*(struct UserObject *)self).data[0], lowerouter4011 = thisouter4011;
  if (inheritingObject4011) {
    struct UserObject *inho4011 = (struct UserObject *)inheritingObject4011;
    while (inho4011->super != GraceDefaultObject) inho4011 = (struct UserObject *)inho4011->super;
    inho4011->super = obj4011;
    self = inheritingObject4011;
    *selfslot = self;
    lowerouter4011 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4011;
  }
if (objclass4011 == NULL) {
  Method *reader4013 = addmethodrealflags(obj4011, "sourceIterator",&reader_collectionsPrelude_sourceIterator_4013, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4013->definitionModule = modulename;
  reader4013->definitionLine = 1737;
}
adddatum2(obj4011, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo4014 = (struct UserObject*)obj4011;
  uo4014->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext4014 = addmethod2pos(obj4011, "hasNext", &meth_collectionsPrelude_hasNext4014, 2);
  int argcv_meth_collectionsPrelude_hasNext4014[] = {0};
  meth_meth_collectionsPrelude_hasNext4014->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext4014);
  meth_meth_collectionsPrelude_hasNext4014->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext4014->definitionLine = 1739;
// method "next"
  struct UserObject *uo4019 = (struct UserObject*)obj4011;
  uo4019->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next4019 = addmethod2pos(obj4011, "next", &meth_collectionsPrelude_next4019, 3);
  int argcv_meth_collectionsPrelude_next4019[] = {0};
  meth_meth_collectionsPrelude_next4019->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4019);
  meth_meth_collectionsPrelude_next4019->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4019->definitionLine = 1740;
// method "asString"
  block_savedest(obj4011);
  Object closure4026 = createclosure(1, "asString");
  setclosureframe(closure4026, stackframe);
  addtoclosure(closure4026, var_sourceDictionary);
  struct UserObject *uo4026 = (struct UserObject*)obj4011;
  uo4026->data[4] = (Object)closure4026;
  Method *meth_meth_collectionsPrelude_asString4026 = addmethod2pos(obj4011, "asString", &meth_collectionsPrelude_asString4026, 4);
  int argcv_meth_collectionsPrelude_asString4026[] = {0};
  meth_meth_collectionsPrelude_asString4026->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4026);
  meth_meth_collectionsPrelude_asString4026->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4026->definitionLine = 1741;
  sourceObject = obj4011;
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4035 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call4036 = callmethodflags(*var_sourceDictionary, "bindingsIterator", 0, partcv, params, 0);
  gc_frame_end(callframe4035);
// compiled member node returning call4036 (depth = 2)
  adddatum2(obj4011, call4036, 1);
  sourceObject = obj4011;
  sourceObject = obj4011;
  sourceObject = obj4011;
  objclass4011 = obj4011->class;
  objclass4011->definitionModule = modulename;
  objclass4011->definitionLine = 1736;
  (*(struct UserObject *)self).data[0] = lowerouter4011;
  self = oldself4011;
  selfslot = oldselfslot4011;
  stackframe = oldstackframe4011;
  gc_frame_end(frame);
  return obj4011;
}
Object meth_collectionsPrelude_asDebugString4039(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1747
  setline(1747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4041 == NULL) {
    strlit4041 = alloc_String("");
    gc_root(strlit4041);
  }
// compiled string node returning strlit4041 (depth = 3)
  int op_slot_right_4040 = gc_frame_newslot(strlit4041);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_4043 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit4045 == NULL) {
    strlit4045 = alloc_String("a lazy sequence over values of ");
    gc_root(strlit4045);
  }
// compiled string node returning strlit4045 (depth = 4)
  int op_slot_left_4043 = gc_frame_newslot(strlit4045);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult4046 = callmethod(strlit4045, "++(1)", 1, partcv, params);
// compiled op node returning opresult4046 (depth = 3)
  int op_slot_left_4040 = gc_frame_newslot(opresult4046);
  params[0] = strlit4041;
  partcv[0] = 1;
  Object opresult4047 = callmethod(opresult4046, "++(1)", 1, partcv, params);
// compiled op node returning opresult4047 (depth = 2)
  gc_frame_end(frame);
  return opresult4047;
}
Object meth_collectionsPrelude_values4007(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4008 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4008 = alloc_userobj2(4,5, objclass4008);
  gc_frame_newslot(obj4008);
if (objclass4008 == NULL) {
  glfree(obj4008->class->name);
  obj4008->class->name = "dictionary.empty.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4008, self, 0);
  addmethodreal(obj4008,"outer", &reader_collectionsPrelude_outer_4009);
  Object oldself4008 = self;
  struct StackFrameObject *oldstackframe4008 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4008);
  gc_frame_newslot((Object)stackframe);
  self = obj4008;
  Object *oldselfslot4008 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4008 = (*(struct UserObject *)self).data[0], lowerouter4008 = thisouter4008;
  if (inheritingObject4008) {
    struct UserObject *inho4008 = (struct UserObject *)inheritingObject4008;
    while (inho4008->super != GraceDefaultObject) inho4008 = (struct UserObject *)inho4008->super;
    inho4008->super = obj4008;
    self = inheritingObject4008;
    *selfslot = self;
    lowerouter4008 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4008;
  }
// method "iterator"
  block_savedest(obj4008);
  Object closure4010 = createclosure(1, "iterator");
  setclosureframe(closure4010, stackframe);
  addtoclosure(closure4010, var_sourceDictionary);
  struct UserObject *uo4010 = (struct UserObject*)obj4008;
  uo4010->data[1] = (Object)closure4010;
  Method *meth_meth_collectionsPrelude_iterator4010 = addmethod2pos(obj4008, "iterator", &meth_collectionsPrelude_iterator4010, 1);
  int argcv_meth_collectionsPrelude_iterator4010[] = {0};
  meth_meth_collectionsPrelude_iterator4010->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4010);
  meth_meth_collectionsPrelude_iterator4010->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4010->definitionLine = 1736;
  block_savedest(obj4008);
  Object closure4037 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure4037, stackframe);
  addtoclosure(closure4037, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_iterator4010_object = addmethod2pos(obj4008, "iterator$object(1)", &meth_collectionsPrelude_iterator4010_object, 1);
  meth_meth_collectionsPrelude_iterator4010_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4010_object->definitionLine = 1736;
if (objclass4008 == NULL) {
  Method *reader4038 = addmethodrealflags(obj4008, "size",&reader_collectionsPrelude_size_4038, MFLAG_DEF);
  reader4038->definitionModule = modulename;
  reader4038->definitionLine = 1745;
}
adddatum2(obj4008, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj4008);
  Object closure4039 = createclosure(1, "asDebugString");
  setclosureframe(closure4039, stackframe);
  addtoclosure(closure4039, var_sourceDictionary);
  struct UserObject *uo4039 = (struct UserObject*)obj4008;
  uo4039->data[3] = (Object)closure4039;
  Method *meth_meth_collectionsPrelude_asDebugString4039 = addmethod2pos(obj4008, "asDebugString", &meth_collectionsPrelude_asDebugString4039, 3);
  int argcv_meth_collectionsPrelude_asDebugString4039[] = {0};
  meth_meth_collectionsPrelude_asDebugString4039->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString4039);
  meth_meth_collectionsPrelude_asDebugString4039->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString4039->definitionLine = 1746;
  sourceObject = obj4008;
// Begin line 1735
  setline(1735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4048 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4049 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4048);
// compiled call node returning call4049 (depth = 2)
  struct UserObject *obj4008_uo = (struct UserObject *)obj4008;
  obj4008_uo->super = call4049;
  sourceObject = obj4008;
  sourceObject = obj4008;
// Begin line 1745
  setline(1745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4050 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call4051 = callmethodflags(*var_sourceDictionary, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4050);
// compiled member node returning call4051 (depth = 2)
  adddatum2(obj4008, call4051, 2);
  sourceObject = obj4008;
  objclass4008 = obj4008->class;
  objclass4008->definitionModule = modulename;
  objclass4008->definitionLine = 1734;
  (*(struct UserObject *)self).data[0] = lowerouter4008;
  self = oldself4008;
  selfslot = oldselfslot4008;
  stackframe = oldstackframe4008;
  gc_frame_end(frame);
  return obj4008;
}
Object meth_collectionsPrelude_values4007_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4008 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4008 = alloc_userobj2(4,5, objclass4008);
  gc_frame_newslot(obj4008);
if (objclass4008 == NULL) {
  glfree(obj4008->class->name);
  obj4008->class->name = "dictionary.empty.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4008, self, 0);
  addmethodreal(obj4008,"outer", &reader_collectionsPrelude_outer_4009);
  Object oldself4008 = self;
  struct StackFrameObject *oldstackframe4008 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4008);
  gc_frame_newslot((Object)stackframe);
  self = obj4008;
  Object *oldselfslot4008 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4008 = (*(struct UserObject *)self).data[0], lowerouter4008 = thisouter4008;
  if (inheritingObject4008) {
    struct UserObject *inho4008 = (struct UserObject *)inheritingObject4008;
    while (inho4008->super != GraceDefaultObject) inho4008 = (struct UserObject *)inho4008->super;
    inho4008->super = obj4008;
    self = inheritingObject4008;
    *selfslot = self;
    lowerouter4008 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4008;
  }
// method "iterator"
  block_savedest(obj4008);
  Object closure4010 = createclosure(1, "iterator");
  setclosureframe(closure4010, stackframe);
  addtoclosure(closure4010, var_sourceDictionary);
  struct UserObject *uo4010 = (struct UserObject*)obj4008;
  uo4010->data[1] = (Object)closure4010;
  Method *meth_meth_collectionsPrelude_iterator4010 = addmethod2pos(obj4008, "iterator", &meth_collectionsPrelude_iterator4010, 1);
  int argcv_meth_collectionsPrelude_iterator4010[] = {0};
  meth_meth_collectionsPrelude_iterator4010->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4010);
  meth_meth_collectionsPrelude_iterator4010->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4010->definitionLine = 1736;
  block_savedest(obj4008);
  Object closure4037 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure4037, stackframe);
  addtoclosure(closure4037, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_iterator4010_object = addmethod2pos(obj4008, "iterator$object(1)", &meth_collectionsPrelude_iterator4010_object, 1);
  meth_meth_collectionsPrelude_iterator4010_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4010_object->definitionLine = 1736;
if (objclass4008 == NULL) {
  Method *reader4038 = addmethodrealflags(obj4008, "size",&reader_collectionsPrelude_size_4038, MFLAG_DEF);
  reader4038->definitionModule = modulename;
  reader4038->definitionLine = 1745;
}
adddatum2(obj4008, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj4008);
  Object closure4039 = createclosure(1, "asDebugString");
  setclosureframe(closure4039, stackframe);
  addtoclosure(closure4039, var_sourceDictionary);
  struct UserObject *uo4039 = (struct UserObject*)obj4008;
  uo4039->data[3] = (Object)closure4039;
  Method *meth_meth_collectionsPrelude_asDebugString4039 = addmethod2pos(obj4008, "asDebugString", &meth_collectionsPrelude_asDebugString4039, 3);
  int argcv_meth_collectionsPrelude_asDebugString4039[] = {0};
  meth_meth_collectionsPrelude_asDebugString4039->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString4039);
  meth_meth_collectionsPrelude_asDebugString4039->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString4039->definitionLine = 1746;
  sourceObject = obj4008;
// Begin line 1735
  setline(1735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4048 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4049 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4048);
// compiled call node returning call4049 (depth = 2)
  struct UserObject *obj4008_uo = (struct UserObject *)obj4008;
  obj4008_uo->super = call4049;
  sourceObject = obj4008;
  sourceObject = obj4008;
// Begin line 1745
  setline(1745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4050 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call4051 = callmethodflags(*var_sourceDictionary, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4050);
// compiled member node returning call4051 (depth = 2)
  adddatum2(obj4008, call4051, 2);
  sourceObject = obj4008;
  objclass4008 = obj4008->class;
  objclass4008->definitionModule = modulename;
  objclass4008->definitionLine = 1734;
  (*(struct UserObject *)self).data[0] = lowerouter4008;
  self = oldself4008;
  selfslot = oldselfslot4008;
  stackframe = oldstackframe4008;
  gc_frame_end(frame);
  return obj4008;
}
Object meth_collectionsPrelude_iterator4056(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4057 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call4058 = callmethodflags(*var_sourceDictionary, "bindingsIterator", 0, partcv, params, 0);
  gc_frame_end(callframe4057);
// compiled member node returning call4058 (depth = 2)
  gc_frame_end(frame);
  return call4058;
}
Object meth_collectionsPrelude_asDebugString4060(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4062 == NULL) {
    strlit4062 = alloc_String("");
    gc_root(strlit4062);
  }
// compiled string node returning strlit4062 (depth = 3)
  int op_slot_right_4061 = gc_frame_newslot(strlit4062);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_4064 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit4066 == NULL) {
    strlit4066 = alloc_String("a lazy sequence over bindings of ");
    gc_root(strlit4066);
  }
// compiled string node returning strlit4066 (depth = 4)
  int op_slot_left_4064 = gc_frame_newslot(strlit4066);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult4067 = callmethod(strlit4066, "++(1)", 1, partcv, params);
// compiled op node returning opresult4067 (depth = 3)
  int op_slot_left_4061 = gc_frame_newslot(opresult4067);
  params[0] = strlit4062;
  partcv[0] = 1;
  Object opresult4068 = callmethod(opresult4067, "++(1)", 1, partcv, params);
// compiled op node returning opresult4068 (depth = 2)
  gc_frame_end(frame);
  return opresult4068;
}
Object meth_collectionsPrelude_bindings4053(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindings");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1752
  setline(1752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4054 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4054 = alloc_userobj2(3,4, objclass4054);
  gc_frame_newslot(obj4054);
if (objclass4054 == NULL) {
  glfree(obj4054->class->name);
  obj4054->class->name = "dictionary.empty.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4054, self, 0);
  addmethodreal(obj4054,"outer", &reader_collectionsPrelude_outer_4055);
  Object oldself4054 = self;
  struct StackFrameObject *oldstackframe4054 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4054);
  gc_frame_newslot((Object)stackframe);
  self = obj4054;
  Object *oldselfslot4054 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4054 = (*(struct UserObject *)self).data[0], lowerouter4054 = thisouter4054;
  if (inheritingObject4054) {
    struct UserObject *inho4054 = (struct UserObject *)inheritingObject4054;
    while (inho4054->super != GraceDefaultObject) inho4054 = (struct UserObject *)inho4054->super;
    inho4054->super = obj4054;
    self = inheritingObject4054;
    *selfslot = self;
    lowerouter4054 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4054;
  }
// method "iterator"
  block_savedest(obj4054);
  Object closure4056 = createclosure(1, "iterator");
  setclosureframe(closure4056, stackframe);
  addtoclosure(closure4056, var_sourceDictionary);
  struct UserObject *uo4056 = (struct UserObject*)obj4054;
  uo4056->data[1] = (Object)closure4056;
  Method *meth_meth_collectionsPrelude_iterator4056 = addmethod2pos(obj4054, "iterator", &meth_collectionsPrelude_iterator4056, 1);
  int argcv_meth_collectionsPrelude_iterator4056[] = {0};
  meth_meth_collectionsPrelude_iterator4056->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4056);
  meth_meth_collectionsPrelude_iterator4056->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4056->definitionLine = 1755;
if (objclass4054 == NULL) {
  Method *reader4059 = addmethodrealflags(obj4054, "size",&reader_collectionsPrelude_size_4059, MFLAG_DEF);
  reader4059->definitionModule = modulename;
  reader4059->definitionLine = 1757;
}
adddatum2(obj4054, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj4054);
  Object closure4060 = createclosure(1, "asDebugString");
  setclosureframe(closure4060, stackframe);
  addtoclosure(closure4060, var_sourceDictionary);
  struct UserObject *uo4060 = (struct UserObject*)obj4054;
  uo4060->data[3] = (Object)closure4060;
  Method *meth_meth_collectionsPrelude_asDebugString4060 = addmethod2pos(obj4054, "asDebugString", &meth_collectionsPrelude_asDebugString4060, 3);
  int argcv_meth_collectionsPrelude_asDebugString4060[] = {0};
  meth_meth_collectionsPrelude_asDebugString4060->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString4060);
  meth_meth_collectionsPrelude_asDebugString4060->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString4060->definitionLine = 1758;
  sourceObject = obj4054;
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4069 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4070 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4069);
// compiled call node returning call4070 (depth = 2)
  struct UserObject *obj4054_uo = (struct UserObject *)obj4054;
  obj4054_uo->super = call4070;
  sourceObject = obj4054;
  sourceObject = obj4054;
// Begin line 1757
  setline(1757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4071 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call4072 = callmethodflags(*var_sourceDictionary, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4071);
// compiled member node returning call4072 (depth = 2)
  adddatum2(obj4054, call4072, 2);
  sourceObject = obj4054;
  objclass4054 = obj4054->class;
  objclass4054->definitionModule = modulename;
  objclass4054->definitionLine = 1753;
  (*(struct UserObject *)self).data[0] = lowerouter4054;
  self = oldself4054;
  selfslot = oldselfslot4054;
  stackframe = oldstackframe4054;
  gc_frame_end(frame);
  return obj4054;
}
Object meth_collectionsPrelude_bindings4053_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindings$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1752
  setline(1752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4054 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4054 = alloc_userobj2(3,4, objclass4054);
  gc_frame_newslot(obj4054);
if (objclass4054 == NULL) {
  glfree(obj4054->class->name);
  obj4054->class->name = "dictionary.empty.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4054, self, 0);
  addmethodreal(obj4054,"outer", &reader_collectionsPrelude_outer_4055);
  Object oldself4054 = self;
  struct StackFrameObject *oldstackframe4054 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4054);
  gc_frame_newslot((Object)stackframe);
  self = obj4054;
  Object *oldselfslot4054 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4054 = (*(struct UserObject *)self).data[0], lowerouter4054 = thisouter4054;
  if (inheritingObject4054) {
    struct UserObject *inho4054 = (struct UserObject *)inheritingObject4054;
    while (inho4054->super != GraceDefaultObject) inho4054 = (struct UserObject *)inho4054->super;
    inho4054->super = obj4054;
    self = inheritingObject4054;
    *selfslot = self;
    lowerouter4054 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4054;
  }
// method "iterator"
  block_savedest(obj4054);
  Object closure4056 = createclosure(1, "iterator");
  setclosureframe(closure4056, stackframe);
  addtoclosure(closure4056, var_sourceDictionary);
  struct UserObject *uo4056 = (struct UserObject*)obj4054;
  uo4056->data[1] = (Object)closure4056;
  Method *meth_meth_collectionsPrelude_iterator4056 = addmethod2pos(obj4054, "iterator", &meth_collectionsPrelude_iterator4056, 1);
  int argcv_meth_collectionsPrelude_iterator4056[] = {0};
  meth_meth_collectionsPrelude_iterator4056->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4056);
  meth_meth_collectionsPrelude_iterator4056->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4056->definitionLine = 1755;
if (objclass4054 == NULL) {
  Method *reader4059 = addmethodrealflags(obj4054, "size",&reader_collectionsPrelude_size_4059, MFLAG_DEF);
  reader4059->definitionModule = modulename;
  reader4059->definitionLine = 1757;
}
adddatum2(obj4054, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj4054);
  Object closure4060 = createclosure(1, "asDebugString");
  setclosureframe(closure4060, stackframe);
  addtoclosure(closure4060, var_sourceDictionary);
  struct UserObject *uo4060 = (struct UserObject*)obj4054;
  uo4060->data[3] = (Object)closure4060;
  Method *meth_meth_collectionsPrelude_asDebugString4060 = addmethod2pos(obj4054, "asDebugString", &meth_collectionsPrelude_asDebugString4060, 3);
  int argcv_meth_collectionsPrelude_asDebugString4060[] = {0};
  meth_meth_collectionsPrelude_asDebugString4060->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString4060);
  meth_meth_collectionsPrelude_asDebugString4060->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString4060->definitionLine = 1758;
  sourceObject = obj4054;
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4069 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4070 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4069);
// compiled call node returning call4070 (depth = 2)
  struct UserObject *obj4054_uo = (struct UserObject *)obj4054;
  obj4054_uo->super = call4070;
  sourceObject = obj4054;
  sourceObject = obj4054;
// Begin line 1757
  setline(1757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4071 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call4072 = callmethodflags(*var_sourceDictionary, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4071);
// compiled member node returning call4072 (depth = 2)
  adddatum2(obj4054, call4072, 2);
  sourceObject = obj4054;
  objclass4054 = obj4054->class;
  objclass4054->definitionModule = modulename;
  objclass4054->definitionLine = 1753;
  (*(struct UserObject *)self).data[0] = lowerouter4054;
  self = oldself4054;
  selfslot = oldselfslot4054;
  stackframe = oldstackframe4054;
  gc_frame_end(frame);
  return obj4054;
}
Object meth_collectionsPrelude_iterator4074(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4075 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4076 = gc_frame_new();
// call case 4: self request
  Object call4077 = callmethodflags(self, "values", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4076);
// compiled member node returning call4077 (depth = 3)
  Object call4078 = callmethodflags(call4077, "iterator", 0, partcv, params, 0);
  gc_frame_end(callframe4075);
// compiled member node returning call4078 (depth = 2)
  gc_frame_end(frame);
  return call4078;
}
Object meth_collectionsPrelude_hasNext4086(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1770
  setline(1770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4088 = gc_frame_new();
// call case 4: self request
  Object call4089 = callmethodflags(self, "count", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4088);
// compiled member node returning call4089 (depth = 3)
  int op_slot_right_4087 = gc_frame_newslot(call4089);
// starting to compile member node (depth = 3)
  int callframe4091 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4092 = gc_frame_new();
// call case 3: self.outer request
  Object call4093 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4092);
// compiled member node returning call4093 (depth = 4)
  Object call4094 = callmethodflags(call4093, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4091);
// compiled member node returning call4094 (depth = 3)
  int op_slot_left_4087 = gc_frame_newslot(call4094);
  params[0] = call4089;
  partcv[0] = 1;
  Object opresult4095 = callmethod(call4094, "≥(1)", 1, partcv, params);
// compiled op node returning opresult4095 (depth = 2)
  gc_frame_end(frame);
  return opresult4095;
}
Object meth_collectionsPrelude__apply4139(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe4140 = gc_frame_new();
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4141 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4142 = gc_frame_new();
// call case 4: self request
  Object call4143 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4142);
// compiled member node returning call4143 (depth = 6)
  gc_frame_newslot(call4143);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4144 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4145 = gc_frame_new();
// call case 3: self.outer request
  Object call4146 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4145);
// compiled member node returning call4146 (depth = 7)
  Object call4147 = callmethodflags(call4146, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4144);
// compiled member node returning call4147 (depth = 6)
  params[0] = call4143;
  partcv[0] = 1;
  Object call4148 = callmethodflags(call4147, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4141);
// compiled call node returning call4148 (depth = 5)
  gc_frame_newslot(call4148);
// call case 4: self request
  params[0] = call4148;
  partcv[0] = 1;
  Object call4149 = callmethodflags(self, "elt:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4140);
// compiled call node returning call4149 (depth = 4)
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4152 = gc_frame_new();
// call case 4: self request
  Object call4153 = callmethodflags(self, "elt", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4152);
// compiled member node returning call4153 (depth = 6)
  int op_slot_right_4151 = gc_frame_newslot(call4153);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  int op_slot_left_4151 = gc_frame_newslot(*var_removed);
  params[0] = call4153;
  partcv[0] = 1;
  Object opresult4155 = callmethod(*var_removed, "==(1)", 1, partcv, params);
// compiled op node returning opresult4155 (depth = 5)
  int op_slot_right_4150 = gc_frame_newslot(opresult4155);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4158 = gc_frame_new();
// call case 4: self request
  Object call4159 = callmethodflags(self, "elt", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4158);
// compiled member node returning call4159 (depth = 6)
  int op_slot_right_4157 = gc_frame_newslot(call4159);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unused (depth = 6)
  int op_slot_left_4157 = gc_frame_newslot(*var_unused);
  params[0] = call4159;
  partcv[0] = 1;
  Object opresult4161 = callmethod(*var_unused, "==(1)", 1, partcv, params);
// compiled op node returning opresult4161 (depth = 5)
  int op_slot_left_4150 = gc_frame_newslot(opresult4161);
  params[0] = opresult4155;
  partcv[0] = 1;
  Object opresult4162 = callmethod(opresult4161, "||(1)", 1, partcv, params);
// compiled op node returning opresult4162 (depth = 4)
  gc_frame_end(frame);
  return opresult4162;
}
Object meth_collectionsPrelude__apply4165(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe4166 = gc_frame_new();
// Begin line 1780
  setline(1780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4168 = alloc_Float64(1);
// compiled num node returning num4168 (depth = 6)
  int op_slot_right_4167 = gc_frame_newslot(num4168);
// starting to compile member node (depth = 6)
  int callframe4170 = gc_frame_new();
// call case 4: self request
  Object call4171 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4170);
// compiled member node returning call4171 (depth = 6)
  int op_slot_left_4167 = gc_frame_newslot(call4171);
  params[0] = num4168;
  partcv[0] = 1;
  Object sum4172 = callmethod(call4171, "+(1)", 1, partcv, params);
// compiled op node returning sum4172 (depth = 5)
  gc_frame_newslot(sum4172);
// call case 4: self request
  params[0] = sum4172;
  partcv[0] = 1;
  Object call4173 = callmethodflags(self, "idx:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4166);
// compiled call node returning call4173 (depth = 4)
  gc_frame_end(frame);
  return call4173;
}
Object meth_collectionsPrelude_next4096(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1772
  setline(1772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4099 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4100 = gc_frame_new();
// call case 3: self.outer request
  Object call4101 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4100);
// compiled member node returning call4101 (depth = 5)
  Object call4102 = callmethodflags(call4101, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4099);
// compiled member node returning call4102 (depth = 4)
  int op_slot_right_4098 = gc_frame_newslot(call4102);
// starting to compile member node (depth = 4)
  int callframe4104 = gc_frame_new();
// call case 4: self request
  Object call4105 = callmethodflags(self, "imods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4104);
// compiled member node returning call4105 (depth = 4)
  int op_slot_left_4098 = gc_frame_newslot(call4105);
  params[0] = call4102;
  partcv[0] = 1;
  Object opresult4106 = callmethod(call4105, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4106 (depth = 3)
  Object if4097 = done;
  if (istrue(opresult4106)) {
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4107 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4108 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4109 = gc_frame_new();
// call case 3: self.outer request
  Object call4110 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4109);
// compiled member node returning call4110 (depth = 5)
  Object call4111 = callmethodflags(call4110, "asString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4108);
// compiled member node returning call4111 (depth = 4)
  gc_frame_newslot(call4111);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ConcurrentModification (depth = 4)
  params[0] = call4111;
  partcv[0] = 1;
  Object call4112 = callmethodflags(*var_ConcurrentModification, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4107);
// compiled call node returning call4112 (depth = 3)
    gc_frame_newslot(call4112);
    if4097 = call4112;
  } else {
  }
// compiled if node returning if4097 (depth = 2)
// Begin line 1775
  setline(1775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4115 = gc_frame_new();
// call case 4: self request
  Object call4116 = callmethodflags(self, "count", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4115);
// compiled member node returning call4116 (depth = 4)
  int op_slot_right_4114 = gc_frame_newslot(call4116);
// starting to compile member node (depth = 4)
  int callframe4118 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4119 = gc_frame_new();
// call case 3: self.outer request
  Object call4120 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4119);
// compiled member node returning call4120 (depth = 5)
  Object call4121 = callmethodflags(call4120, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4118);
// compiled member node returning call4121 (depth = 4)
  int op_slot_left_4114 = gc_frame_newslot(call4121);
  params[0] = call4116;
  partcv[0] = 1;
  Object opresult4122 = callmethod(call4121, "<(1)", 1, partcv, params);
// compiled op node returning opresult4122 (depth = 3)
  Object if4113 = done;
  if (istrue(opresult4122)) {
// starting to compile call node (depth = 3)
  int callframe4123 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4125 == NULL) {
    strlit4125 = alloc_String("");
    gc_root(strlit4125);
  }
// compiled string node returning strlit4125 (depth = 5)
  int op_slot_right_4124 = gc_frame_newslot(strlit4125);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4128 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4129 = gc_frame_new();
// call case 3: self.outer request
  Object call4130 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4129);
// compiled member node returning call4130 (depth = 7)
  Object call4131 = callmethodflags(call4130, "asString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4128);
// compiled member node returning call4131 (depth = 6)
  int op_slot_right_4127 = gc_frame_newslot(call4131);
// starting to compile string node (depth = 6)
  if (strlit4133 == NULL) {
    strlit4133 = alloc_String("over ");
    gc_root(strlit4133);
  }
// compiled string node returning strlit4133 (depth = 6)
  int op_slot_left_4127 = gc_frame_newslot(strlit4133);
  params[0] = call4131;
  partcv[0] = 1;
  Object opresult4134 = callmethod(strlit4133, "++(1)", 1, partcv, params);
// compiled op node returning opresult4134 (depth = 5)
  int op_slot_left_4124 = gc_frame_newslot(opresult4134);
  params[0] = strlit4125;
  partcv[0] = 1;
  Object opresult4135 = callmethod(opresult4134, "++(1)", 1, partcv, params);
// compiled op node returning opresult4135 (depth = 4)
  gc_frame_newslot(opresult4135);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = opresult4135;
  partcv[0] = 1;
  Object call4136 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4123);
// compiled call node returning call4136 (depth = 3)
    gc_frame_newslot(call4136);
    if4113 = call4136;
  } else {
  }
// compiled if node returning if4113 (depth = 2)
// Begin line 1776
  setline(1776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4137 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4138 = alloc_Block(NULL, NULL, "collectionsPrelude", 1776);
  gc_frame_newslot(block4138);
// method "_apply"
  block_savedest(block4138);
  Object closure4139 = createclosure(3, "_apply");
  setclosureframe(closure4139, stackframe);
  addtoclosure(closure4139, var_removed);
  addtoclosure(closure4139, var_unused);
  addtoclosure(closure4139, selfslot);
  struct UserObject *uo4139 = (struct UserObject*)block4138;
  uo4139->data[0] = (Object)closure4139;
  Method *meth_meth_collectionsPrelude__apply4139 = addmethod2pos(block4138, "_apply", &meth_collectionsPrelude__apply4139, 0);
  int argcv_meth_collectionsPrelude__apply4139[] = {0};
  meth_meth_collectionsPrelude__apply4139->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4139);
  meth_meth_collectionsPrelude__apply4139->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4139->definitionLine = 1991;
// compiled block node returning block4138 (depth = 3)
  gc_frame_newslot(block4138);
// Begin line 1779
  setline(1779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4164 = alloc_Block(NULL, NULL, "collectionsPrelude", 1779);
  gc_frame_newslot(block4164);
// method "_apply"
  block_savedest(block4164);
  Object closure4165 = createclosure(1, "_apply");
  setclosureframe(closure4165, stackframe);
  addtoclosure(closure4165, selfslot);
  struct UserObject *uo4165 = (struct UserObject*)block4164;
  uo4165->data[0] = (Object)closure4165;
  Method *meth_meth_collectionsPrelude__apply4165 = addmethod2pos(block4164, "_apply", &meth_collectionsPrelude__apply4165, 0);
  int argcv_meth_collectionsPrelude__apply4165[] = {0};
  meth_meth_collectionsPrelude__apply4165->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4165);
  meth_meth_collectionsPrelude__apply4165->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4165->definitionLine = 1991;
// compiled block node returning block4164 (depth = 3)
  gc_frame_newslot(block4164);
// call case 5: prelude request
  params[0] = block4138;
  params[1] = block4164;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4175 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4137);
// compiled call node returning call4175 (depth = 2)
// Begin line 1782
  setline(1782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4176 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4178 = alloc_Float64(1);
// compiled num node returning num4178 (depth = 4)
  int op_slot_right_4177 = gc_frame_newslot(num4178);
// starting to compile member node (depth = 4)
  int callframe4180 = gc_frame_new();
// call case 4: self request
  Object call4181 = callmethodflags(self, "count", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4180);
// compiled member node returning call4181 (depth = 4)
  int op_slot_left_4177 = gc_frame_newslot(call4181);
  params[0] = num4178;
  partcv[0] = 1;
  Object sum4182 = callmethod(call4181, "+(1)", 1, partcv, params);
// compiled op node returning sum4182 (depth = 3)
  gc_frame_newslot(sum4182);
// call case 4: self request
  params[0] = sum4182;
  partcv[0] = 1;
  Object call4183 = callmethodflags(self, "count:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4176);
// compiled call node returning call4183 (depth = 2)
// Begin line 1783
  setline(1783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4184 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4186 = alloc_Float64(1);
// compiled num node returning num4186 (depth = 4)
  int op_slot_right_4185 = gc_frame_newslot(num4186);
// starting to compile member node (depth = 4)
  int callframe4188 = gc_frame_new();
// call case 4: self request
  Object call4189 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4188);
// compiled member node returning call4189 (depth = 4)
  int op_slot_left_4185 = gc_frame_newslot(call4189);
  params[0] = num4186;
  partcv[0] = 1;
  Object sum4190 = callmethod(call4189, "+(1)", 1, partcv, params);
// compiled op node returning sum4190 (depth = 3)
  gc_frame_newslot(sum4190);
// call case 4: self request
  params[0] = sum4190;
  partcv[0] = 1;
  Object call4191 = callmethodflags(self, "idx:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4184);
// compiled call node returning call4191 (depth = 2)
// Begin line 1784
  setline(1784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4192 = gc_frame_new();
// call case 4: self request
  Object call4193 = callmethodflags(self, "elt", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4192);
// compiled member node returning call4193 (depth = 2)
  gc_frame_end(frame);
  return call4193;
}
Object meth_collectionsPrelude_bindingsIterator4079(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindingsIterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4080 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4080 = alloc_userobj2(9,7, objclass4080);
  gc_frame_newslot(obj4080);
if (objclass4080 == NULL) {
  glfree(obj4080->class->name);
  obj4080->class->name = "dictionary.empty.bindingsIterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4080, self, 0);
  addmethodreal(obj4080,"outer", &reader_collectionsPrelude_outer_4081);
  Object oldself4080 = self;
  struct StackFrameObject *oldstackframe4080 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4080);
  gc_frame_newslot((Object)stackframe);
  self = obj4080;
  Object *oldselfslot4080 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4080 = (*(struct UserObject *)self).data[0], lowerouter4080 = thisouter4080;
  if (inheritingObject4080) {
    struct UserObject *inho4080 = (struct UserObject *)inheritingObject4080;
    while (inho4080->super != GraceDefaultObject) inho4080 = (struct UserObject *)inho4080->super;
    inho4080->super = obj4080;
    self = inheritingObject4080;
    *selfslot = self;
    lowerouter4080 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4080;
  }
if (objclass4080 == NULL) {
  Method *reader4082 = addmethodrealflags(obj4080, "imods",&reader_collectionsPrelude_imods_4082, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4082->definitionModule = modulename;
  reader4082->definitionLine = 1766;
}
adddatum2(obj4080, alloc_Undefined(), 1);
if (objclass4080 == NULL) {
  Method *reader4083 = addmethodrealflags(obj4080, "count", &reader_collectionsPrelude_count_4083, MFLAG_CONFIDENTIAL);
  Method *writer4083 = addmethodrealflags(obj4080, "count:=(1)", &writer_collectionsPrelude_count_4083, MFLAG_CONFIDENTIAL);
  reader4083->definitionModule = modulename;
  writer4083->definitionModule = modulename;
  reader4083->definitionLine = 1767;
  writer4083->definitionLine = 1767;
}
obj4080->flags |= OFLAG_MUTABLE;
adddatum2(obj4080, alloc_Undefined(), 2);
if (objclass4080 == NULL) {
  Method *reader4084 = addmethodrealflags(obj4080, "idx", &reader_collectionsPrelude_idx_4084, MFLAG_CONFIDENTIAL);
  Method *writer4084 = addmethodrealflags(obj4080, "idx:=(1)", &writer_collectionsPrelude_idx_4084, MFLAG_CONFIDENTIAL);
  reader4084->definitionModule = modulename;
  writer4084->definitionModule = modulename;
  reader4084->definitionLine = 1768;
  writer4084->definitionLine = 1768;
}
obj4080->flags |= OFLAG_MUTABLE;
adddatum2(obj4080, alloc_Undefined(), 3);
if (objclass4080 == NULL) {
  Method *reader4085 = addmethodrealflags(obj4080, "elt", &reader_collectionsPrelude_elt_4085, MFLAG_CONFIDENTIAL);
  Method *writer4085 = addmethodrealflags(obj4080, "elt:=(1)", &writer_collectionsPrelude_elt_4085, MFLAG_CONFIDENTIAL);
  reader4085->definitionModule = modulename;
  writer4085->definitionModule = modulename;
  reader4085->definitionLine = 1769;
  writer4085->definitionLine = 1769;
}
obj4080->flags |= OFLAG_MUTABLE;
adddatum2(obj4080, alloc_Undefined(), 4);
// method "hasNext"
  struct UserObject *uo4086 = (struct UserObject*)obj4080;
  uo4086->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext4086 = addmethod2pos(obj4080, "hasNext", &meth_collectionsPrelude_hasNext4086, 5);
  int argcv_meth_collectionsPrelude_hasNext4086[] = {0};
  meth_meth_collectionsPrelude_hasNext4086->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext4086);
  meth_meth_collectionsPrelude_hasNext4086->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext4086->definitionLine = 1770;
// method "next"
  block_savedest(obj4080);
  Object closure4096 = createclosure(4, "next");
  setclosureframe(closure4096, stackframe);
  addtoclosure(closure4096, var_ConcurrentModification);
  addtoclosure(closure4096, var_IteratorExhausted);
  addtoclosure(closure4096, var_removed);
  addtoclosure(closure4096, var_unused);
  struct UserObject *uo4096 = (struct UserObject*)obj4080;
  uo4096->data[6] = (Object)closure4096;
  Method *meth_meth_collectionsPrelude_next4096 = addmethod2pos(obj4080, "next", &meth_collectionsPrelude_next4096, 6);
  int argcv_meth_collectionsPrelude_next4096[] = {0};
  meth_meth_collectionsPrelude_next4096->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4096);
  meth_meth_collectionsPrelude_next4096->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4096->definitionLine = 1771;
  sourceObject = obj4080;
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4194 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4195 = gc_frame_new();
// call case 3: self.outer request
  Object call4196 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4195);
// compiled member node returning call4196 (depth = 3)
  Object call4197 = callmethodflags(call4196, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4194);
// compiled member node returning call4197 (depth = 2)
  adddatum2(obj4080, call4197, 1);
  sourceObject = obj4080;
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4198 = alloc_Float64(1);
// compiled num node returning num4198 (depth = 2)
  adddatum2(obj4080, num4198, 2);
  sourceObject = obj4080;
// Begin line 1768
  setline(1768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4199 = alloc_Float64(0);
// compiled num node returning num4199 (depth = 2)
  adddatum2(obj4080, num4199, 3);
  sourceObject = obj4080;
  adddatum2(obj4080, undefined, 4);
  sourceObject = obj4080;
  sourceObject = obj4080;
  objclass4080 = obj4080->class;
  objclass4080->definitionModule = modulename;
  objclass4080->definitionLine = 1764;
  (*(struct UserObject *)self).data[0] = lowerouter4080;
  self = oldself4080;
  selfslot = oldselfslot4080;
  stackframe = oldstackframe4080;
  gc_frame_end(frame);
  return obj4080;
}
Object meth_collectionsPrelude_bindingsIterator4079_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindingsIterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4080 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4080 = alloc_userobj2(9,7, objclass4080);
  gc_frame_newslot(obj4080);
if (objclass4080 == NULL) {
  glfree(obj4080->class->name);
  obj4080->class->name = "dictionary.empty.bindingsIterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4080, self, 0);
  addmethodreal(obj4080,"outer", &reader_collectionsPrelude_outer_4081);
  Object oldself4080 = self;
  struct StackFrameObject *oldstackframe4080 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4080);
  gc_frame_newslot((Object)stackframe);
  self = obj4080;
  Object *oldselfslot4080 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4080 = (*(struct UserObject *)self).data[0], lowerouter4080 = thisouter4080;
  if (inheritingObject4080) {
    struct UserObject *inho4080 = (struct UserObject *)inheritingObject4080;
    while (inho4080->super != GraceDefaultObject) inho4080 = (struct UserObject *)inho4080->super;
    inho4080->super = obj4080;
    self = inheritingObject4080;
    *selfslot = self;
    lowerouter4080 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4080;
  }
if (objclass4080 == NULL) {
  Method *reader4082 = addmethodrealflags(obj4080, "imods",&reader_collectionsPrelude_imods_4082, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4082->definitionModule = modulename;
  reader4082->definitionLine = 1766;
}
adddatum2(obj4080, alloc_Undefined(), 1);
if (objclass4080 == NULL) {
  Method *reader4083 = addmethodrealflags(obj4080, "count", &reader_collectionsPrelude_count_4083, MFLAG_CONFIDENTIAL);
  Method *writer4083 = addmethodrealflags(obj4080, "count:=(1)", &writer_collectionsPrelude_count_4083, MFLAG_CONFIDENTIAL);
  reader4083->definitionModule = modulename;
  writer4083->definitionModule = modulename;
  reader4083->definitionLine = 1767;
  writer4083->definitionLine = 1767;
}
obj4080->flags |= OFLAG_MUTABLE;
adddatum2(obj4080, alloc_Undefined(), 2);
if (objclass4080 == NULL) {
  Method *reader4084 = addmethodrealflags(obj4080, "idx", &reader_collectionsPrelude_idx_4084, MFLAG_CONFIDENTIAL);
  Method *writer4084 = addmethodrealflags(obj4080, "idx:=(1)", &writer_collectionsPrelude_idx_4084, MFLAG_CONFIDENTIAL);
  reader4084->definitionModule = modulename;
  writer4084->definitionModule = modulename;
  reader4084->definitionLine = 1768;
  writer4084->definitionLine = 1768;
}
obj4080->flags |= OFLAG_MUTABLE;
adddatum2(obj4080, alloc_Undefined(), 3);
if (objclass4080 == NULL) {
  Method *reader4085 = addmethodrealflags(obj4080, "elt", &reader_collectionsPrelude_elt_4085, MFLAG_CONFIDENTIAL);
  Method *writer4085 = addmethodrealflags(obj4080, "elt:=(1)", &writer_collectionsPrelude_elt_4085, MFLAG_CONFIDENTIAL);
  reader4085->definitionModule = modulename;
  writer4085->definitionModule = modulename;
  reader4085->definitionLine = 1769;
  writer4085->definitionLine = 1769;
}
obj4080->flags |= OFLAG_MUTABLE;
adddatum2(obj4080, alloc_Undefined(), 4);
// method "hasNext"
  struct UserObject *uo4086 = (struct UserObject*)obj4080;
  uo4086->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext4086 = addmethod2pos(obj4080, "hasNext", &meth_collectionsPrelude_hasNext4086, 5);
  int argcv_meth_collectionsPrelude_hasNext4086[] = {0};
  meth_meth_collectionsPrelude_hasNext4086->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext4086);
  meth_meth_collectionsPrelude_hasNext4086->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext4086->definitionLine = 1770;
// method "next"
  block_savedest(obj4080);
  Object closure4096 = createclosure(4, "next");
  setclosureframe(closure4096, stackframe);
  addtoclosure(closure4096, var_ConcurrentModification);
  addtoclosure(closure4096, var_IteratorExhausted);
  addtoclosure(closure4096, var_removed);
  addtoclosure(closure4096, var_unused);
  struct UserObject *uo4096 = (struct UserObject*)obj4080;
  uo4096->data[6] = (Object)closure4096;
  Method *meth_meth_collectionsPrelude_next4096 = addmethod2pos(obj4080, "next", &meth_collectionsPrelude_next4096, 6);
  int argcv_meth_collectionsPrelude_next4096[] = {0};
  meth_meth_collectionsPrelude_next4096->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4096);
  meth_meth_collectionsPrelude_next4096->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4096->definitionLine = 1771;
  sourceObject = obj4080;
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4194 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4195 = gc_frame_new();
// call case 3: self.outer request
  Object call4196 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4195);
// compiled member node returning call4196 (depth = 3)
  Object call4197 = callmethodflags(call4196, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4194);
// compiled member node returning call4197 (depth = 2)
  adddatum2(obj4080, call4197, 1);
  sourceObject = obj4080;
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4198 = alloc_Float64(1);
// compiled num node returning num4198 (depth = 2)
  adddatum2(obj4080, num4198, 2);
  sourceObject = obj4080;
// Begin line 1768
  setline(1768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4199 = alloc_Float64(0);
// compiled num node returning num4199 (depth = 2)
  adddatum2(obj4080, num4199, 3);
  sourceObject = obj4080;
  adddatum2(obj4080, undefined, 4);
  sourceObject = obj4080;
  sourceObject = obj4080;
  objclass4080 = obj4080->class;
  objclass4080->definitionModule = modulename;
  objclass4080->definitionLine = 1764;
  (*(struct UserObject *)self).data[0] = lowerouter4080;
  self = oldself4080;
  selfslot = oldselfslot4080;
  stackframe = oldstackframe4080;
  gc_frame_end(frame);
  return obj4080;
}
Object meth_collectionsPrelude__apply_40_1_41_4228(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4229 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4230 = gc_frame_new();
// call case 4: self request
  Object call4231 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4230);
// compiled member node returning call4231 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4232 = callmethodflags(call4231, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4229);
// compiled call node returning call4232 (depth = 4)
  gc_frame_end(frame);
  return call4232;
}
Object meth_collectionsPrelude__apply_40_1_41_4248(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_oldInner = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1797
  setline(1797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4249 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldInner (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call4250 = callmethodflags(*var_oldInner, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4249);
// compiled call node returning call4250 (depth = 5)
  *var_a = call4250;
  if (call4250 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4253 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_4253 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4255 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4255 (depth = 6)
  int op_slot_right_4252 = gc_frame_newslot(opresult4255);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4257 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_4257 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4259 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4259 (depth = 6)
  int op_slot_left_4252 = gc_frame_newslot(opresult4259);
  params[0] = opresult4255;
  partcv[0] = 1;
  Object opresult4260 = callmethod(opresult4259, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4260 (depth = 5)
  Object if4251 = done;
  if (istrue(opresult4260)) {
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4261 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4262 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call4263 = callmethodflags(*var_a, "key", 0, partcv, params, 0);
  gc_frame_end(callframe4262);
// compiled member node returning call4263 (depth = 6)
  gc_frame_newslot(call4263);
// starting to compile member node (depth = 6)
  int callframe4264 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call4265 = callmethodflags(*var_a, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4264);
// compiled member node returning call4265 (depth = 6)
  gc_frame_newslot(call4265);
// call case 4: self request
  params[0] = call4263;
  params[1] = call4265;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4266 = callmethodflags(self, "at(1)put(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4261);
// compiled call node returning call4266 (depth = 5)
    gc_frame_newslot(call4266);
    if4251 = call4266;
  } else {
  }
// compiled if node returning if4251 (depth = 4)
  gc_frame_end(frame);
  return if4251;
}
Object meth_collectionsPrelude_expand4201(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expand");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var__prelude = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_c = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "c");
  Object *var_n = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "n");
  Object *var_oldInner = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldInner");
// Begin line 1788
  setline(1788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4202 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4203 = gc_frame_new();
// call case 4: self request
  Object call4204 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4203);
// compiled member node returning call4204 (depth = 4)
  Object call4205 = callmethodflags(call4204, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4202);
// compiled member node returning call4205 (depth = 3)
  *var_c = call4205;
  if (call4205 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1789
  setline(1789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4207 = alloc_Float64(2);
// compiled num node returning num4207 (depth = 4)
  int op_slot_right_4206 = gc_frame_newslot(num4207);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_4206 = gc_frame_newslot(*var_c);
  params[0] = num4207;
  partcv[0] = 1;
  Object prod4209 = callmethod(*var_c, "*(1)", 1, partcv, params);
// compiled op node returning prod4209 (depth = 3)
  *var_n = prod4209;
  if (prod4209 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4210 = gc_frame_new();
// call case 4: self request
  Object call4211 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4210);
// compiled member node returning call4211 (depth = 3)
  *var_oldInner = call4211;
  if (call4211 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1791
  setline(1791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4212 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4213 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4214 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  Object call4215 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe4214);
// compiled member node returning call4215 (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call4216 = callmethodflags(call4215, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4213);
// compiled call node returning call4216 (depth = 3)
  gc_frame_newslot(call4216);
// call case 4: self request
  params[0] = call4216;
  partcv[0] = 1;
  Object call4217 = callmethodflags(self, "inner:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4212);
// compiled call node returning call4217 (depth = 2)
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4218 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4221 = alloc_Float64(1);
// compiled num node returning num4221 (depth = 5)
  int op_slot_right_4220 = gc_frame_newslot(num4221);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  int op_slot_left_4220 = gc_frame_newslot(*var_n);
  params[0] = num4221;
  partcv[0] = 1;
  Object diff4223 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff4223 (depth = 4)
  int op_slot_right_4219 = gc_frame_newslot(diff4223);
// starting to compile num node (depth = 4)
  Object num4225 = alloc_Float64(0);
// compiled num node returning num4225 (depth = 4)
  int op_slot_left_4219 = gc_frame_newslot(num4225);
  params[0] = diff4223;
  partcv[0] = 1;
  Object opresult4226 = callmethod(num4225, "..(1)", 1, partcv, params);
// compiled op node returning opresult4226 (depth = 3)
  gc_frame_newslot(opresult4226);
// starting to compile block node (depth = 3)
  Object block4227 = alloc_Block(NULL, NULL, "collectionsPrelude", 1792);
  gc_frame_newslot(block4227);
// method "_apply(_)"
  block_savedest(block4227);
  Object closure4228 = createclosure(2, "_apply(1)");
  setclosureframe(closure4228, stackframe);
  addtoclosure(closure4228, var_unused);
  addtoclosure(closure4228, selfslot);
  struct UserObject *uo4228 = (struct UserObject*)block4227;
  uo4228->data[0] = (Object)closure4228;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4228 = addmethod2pos(block4227, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4228, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4228[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4228->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4228);
  meth_meth_collectionsPrelude__apply_40_1_41_4228->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4228->definitionLine = 1991;
// compiled block node returning block4227 (depth = 3)
  gc_frame_newslot(block4227);
// call case 5: prelude request
  params[0] = opresult4226;
  params[1] = block4227;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4234 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4218);
// compiled call node returning call4234 (depth = 2)
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4235 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num4236 = alloc_Float64(0);
// compiled num node returning num4236 (depth = 3)
  gc_frame_newslot(num4236);
// call case 4: self request
  params[0] = num4236;
  partcv[0] = 1;
  Object call4237 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4235);
// compiled call node returning call4237 (depth = 2)
// Begin line 1796
  setline(1796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4238 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4241 = alloc_Float64(1);
// compiled num node returning num4241 (depth = 5)
  int op_slot_right_4240 = gc_frame_newslot(num4241);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  int op_slot_left_4240 = gc_frame_newslot(*var_c);
  params[0] = num4241;
  partcv[0] = 1;
  Object diff4243 = callmethod(*var_c, "-(1)", 1, partcv, params);
// compiled op node returning diff4243 (depth = 4)
  int op_slot_right_4239 = gc_frame_newslot(diff4243);
// starting to compile num node (depth = 4)
  Object num4245 = alloc_Float64(0);
// compiled num node returning num4245 (depth = 4)
  int op_slot_left_4239 = gc_frame_newslot(num4245);
  params[0] = diff4243;
  partcv[0] = 1;
  Object opresult4246 = callmethod(num4245, "..(1)", 1, partcv, params);
// compiled op node returning opresult4246 (depth = 3)
  gc_frame_newslot(opresult4246);
// starting to compile block node (depth = 3)
  Object block4247 = alloc_Block(NULL, NULL, "collectionsPrelude", 1796);
  gc_frame_newslot(block4247);
// method "_apply(_)"
  block_savedest(block4247);
  Object closure4248 = createclosure(4, "_apply(1)");
  setclosureframe(closure4248, stackframe);
  addtoclosure(closure4248, var_oldInner);
  addtoclosure(closure4248, var_removed);
  addtoclosure(closure4248, var_unused);
  addtoclosure(closure4248, selfslot);
  struct UserObject *uo4248 = (struct UserObject*)block4247;
  uo4248->data[0] = (Object)closure4248;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4248 = addmethod2pos(block4247, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4248, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4248[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4248->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4248);
  meth_meth_collectionsPrelude__apply_40_1_41_4248->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4248->definitionLine = 1991;
// compiled block node returning block4247 (depth = 3)
  gc_frame_newslot(block4247);
// call case 5: prelude request
  params[0] = opresult4246;
  params[1] = block4247;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4268 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4238);
// compiled call node returning call4268 (depth = 2)
  gc_frame_end(frame);
  return call4268;
}
Object meth_collectionsPrelude__apply_40_1_41_4284(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1805
  setline(1805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4285 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4286 = gc_frame_new();
// call case 4: self request
  Object call4287 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4286);
// compiled member node returning call4287 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call4288 = callmethodflags(call4287, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4285);
// compiled call node returning call4288 (depth = 5)
  *var_a = call4288;
  if (call4288 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4291 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_4291 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4293 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4293 (depth = 6)
  int op_slot_right_4290 = gc_frame_newslot(opresult4293);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4295 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_4295 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4297 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4297 (depth = 6)
  int op_slot_left_4290 = gc_frame_newslot(opresult4297);
  params[0] = opresult4293;
  partcv[0] = 1;
  Object opresult4298 = callmethod(opresult4297, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4298 (depth = 5)
  Object if4289 = done;
  if (istrue(opresult4298)) {
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4299 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4300 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call4301 = callmethodflags(*var_a, "key", 0, partcv, params, 0);
  gc_frame_end(callframe4300);
// compiled member node returning call4301 (depth = 6)
  gc_frame_newslot(call4301);
// starting to compile member node (depth = 6)
  int callframe4302 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call4303 = callmethodflags(*var_a, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4302);
// compiled member node returning call4303 (depth = 6)
  gc_frame_newslot(call4303);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block2 (depth = 6)
  params[0] = call4301;
  params[1] = call4303;
  partcv[0] = 2;
  Object call4304 = callmethodflags(*var_block2, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4299);
// compiled call node returning call4304 (depth = 5)
    gc_frame_newslot(call4304);
    if4289 = call4304;
  } else {
  }
// compiled if node returning if4289 (depth = 4)
  gc_frame_end(frame);
  return if4289;
}
Object meth_collectionsPrelude_keysAndValuesDo_40_1_41_4269(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1804
  setline(1804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4270 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4273 = alloc_Float64(1);
// compiled num node returning num4273 (depth = 5)
  int op_slot_right_4272 = gc_frame_newslot(num4273);
// starting to compile member node (depth = 5)
  int callframe4275 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4276 = gc_frame_new();
// call case 4: self request
  Object call4277 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4276);
// compiled member node returning call4277 (depth = 6)
  Object call4278 = callmethodflags(call4277, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4275);
// compiled member node returning call4278 (depth = 5)
  int op_slot_left_4272 = gc_frame_newslot(call4278);
  params[0] = num4273;
  partcv[0] = 1;
  Object diff4279 = callmethod(call4278, "-(1)", 1, partcv, params);
// compiled op node returning diff4279 (depth = 4)
  int op_slot_right_4271 = gc_frame_newslot(diff4279);
// starting to compile num node (depth = 4)
  Object num4281 = alloc_Float64(0);
// compiled num node returning num4281 (depth = 4)
  int op_slot_left_4271 = gc_frame_newslot(num4281);
  params[0] = diff4279;
  partcv[0] = 1;
  Object opresult4282 = callmethod(num4281, "..(1)", 1, partcv, params);
// compiled op node returning opresult4282 (depth = 3)
  gc_frame_newslot(opresult4282);
// starting to compile block node (depth = 3)
  Object block4283 = alloc_Block(NULL, NULL, "collectionsPrelude", 1804);
  gc_frame_newslot(block4283);
// method "_apply(_)"
  block_savedest(block4283);
  Object closure4284 = createclosure(4, "_apply(1)");
  setclosureframe(closure4284, stackframe);
  addtoclosure(closure4284, var_removed);
  addtoclosure(closure4284, var_unused);
  addtoclosure(closure4284, var_block2);
  addtoclosure(closure4284, selfslot);
  struct UserObject *uo4284 = (struct UserObject*)block4283;
  uo4284->data[0] = (Object)closure4284;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4284 = addmethod2pos(block4283, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4284, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4284[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4284->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4284);
  meth_meth_collectionsPrelude__apply_40_1_41_4284->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4284->definitionLine = 1991;
// compiled block node returning block4283 (depth = 3)
  gc_frame_newslot(block4283);
// call case 5: prelude request
  params[0] = opresult4282;
  params[1] = block4283;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4306 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4270);
// compiled call node returning call4306 (depth = 2)
  gc_frame_end(frame);
  return call4306;
}
Object meth_collectionsPrelude__apply_40_1_41_4322(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_block1 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1813
  setline(1813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4323 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4324 = gc_frame_new();
// call case 4: self request
  Object call4325 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4324);
// compiled member node returning call4325 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call4326 = callmethodflags(call4325, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4323);
// compiled call node returning call4326 (depth = 5)
  *var_a = call4326;
  if (call4326 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1814
  setline(1814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4329 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_4329 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4331 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4331 (depth = 6)
  int op_slot_right_4328 = gc_frame_newslot(opresult4331);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4333 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_4333 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4335 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4335 (depth = 6)
  int op_slot_left_4328 = gc_frame_newslot(opresult4335);
  params[0] = opresult4331;
  partcv[0] = 1;
  Object opresult4336 = callmethod(opresult4335, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4336 (depth = 5)
  Object if4327 = done;
  if (istrue(opresult4336)) {
// Begin line 1815
  setline(1815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4337 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4338 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call4339 = callmethodflags(*var_a, "key", 0, partcv, params, 0);
  gc_frame_end(callframe4338);
// compiled member node returning call4339 (depth = 6)
  gc_frame_newslot(call4339);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = call4339;
  partcv[0] = 1;
  Object call4340 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4337);
// compiled call node returning call4340 (depth = 5)
    gc_frame_newslot(call4340);
    if4327 = call4340;
  } else {
  }
// compiled if node returning if4327 (depth = 4)
  gc_frame_end(frame);
  return if4327;
}
Object meth_collectionsPrelude_keysDo_40_1_41_4307(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keysDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysDo(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4308 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4311 = alloc_Float64(1);
// compiled num node returning num4311 (depth = 5)
  int op_slot_right_4310 = gc_frame_newslot(num4311);
// starting to compile member node (depth = 5)
  int callframe4313 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4314 = gc_frame_new();
// call case 4: self request
  Object call4315 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4314);
// compiled member node returning call4315 (depth = 6)
  Object call4316 = callmethodflags(call4315, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4313);
// compiled member node returning call4316 (depth = 5)
  int op_slot_left_4310 = gc_frame_newslot(call4316);
  params[0] = num4311;
  partcv[0] = 1;
  Object diff4317 = callmethod(call4316, "-(1)", 1, partcv, params);
// compiled op node returning diff4317 (depth = 4)
  int op_slot_right_4309 = gc_frame_newslot(diff4317);
// starting to compile num node (depth = 4)
  Object num4319 = alloc_Float64(0);
// compiled num node returning num4319 (depth = 4)
  int op_slot_left_4309 = gc_frame_newslot(num4319);
  params[0] = diff4317;
  partcv[0] = 1;
  Object opresult4320 = callmethod(num4319, "..(1)", 1, partcv, params);
// compiled op node returning opresult4320 (depth = 3)
  gc_frame_newslot(opresult4320);
// starting to compile block node (depth = 3)
  Object block4321 = alloc_Block(NULL, NULL, "collectionsPrelude", 1812);
  gc_frame_newslot(block4321);
// method "_apply(_)"
  block_savedest(block4321);
  Object closure4322 = createclosure(4, "_apply(1)");
  setclosureframe(closure4322, stackframe);
  addtoclosure(closure4322, var_removed);
  addtoclosure(closure4322, var_unused);
  addtoclosure(closure4322, var_block1);
  addtoclosure(closure4322, selfslot);
  struct UserObject *uo4322 = (struct UserObject*)block4321;
  uo4322->data[0] = (Object)closure4322;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4322 = addmethod2pos(block4321, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4322, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4322[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4322->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4322);
  meth_meth_collectionsPrelude__apply_40_1_41_4322->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4322->definitionLine = 1991;
// compiled block node returning block4321 (depth = 3)
  gc_frame_newslot(block4321);
// call case 5: prelude request
  params[0] = opresult4320;
  params[1] = block4321;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4342 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4308);
// compiled call node returning call4342 (depth = 2)
  gc_frame_end(frame);
  return call4342;
}
Object meth_collectionsPrelude__apply_40_1_41_4358(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_block1 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1821
  setline(1821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4359 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4360 = gc_frame_new();
// call case 4: self request
  Object call4361 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4360);
// compiled member node returning call4361 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call4362 = callmethodflags(call4361, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4359);
// compiled call node returning call4362 (depth = 5)
  *var_a = call4362;
  if (call4362 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1822
  setline(1822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4365 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_4365 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4367 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4367 (depth = 6)
  int op_slot_right_4364 = gc_frame_newslot(opresult4367);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4369 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_4369 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4371 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4371 (depth = 6)
  int op_slot_left_4364 = gc_frame_newslot(opresult4371);
  params[0] = opresult4367;
  partcv[0] = 1;
  Object opresult4372 = callmethod(opresult4371, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4372 (depth = 5)
  Object if4363 = done;
  if (istrue(opresult4372)) {
// Begin line 1823
  setline(1823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4373 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4374 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call4375 = callmethodflags(*var_a, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4374);
// compiled member node returning call4375 (depth = 6)
  gc_frame_newslot(call4375);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = call4375;
  partcv[0] = 1;
  Object call4376 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4373);
// compiled call node returning call4376 (depth = 5)
    gc_frame_newslot(call4376);
    if4363 = call4376;
  } else {
  }
// compiled if node returning if4363 (depth = 4)
  gc_frame_end(frame);
  return if4363;
}
Object meth_collectionsPrelude_valuesDo_40_1_41_4343(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "valuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method valuesDo(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for valuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part valuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1820
  setline(1820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4344 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4347 = alloc_Float64(1);
// compiled num node returning num4347 (depth = 5)
  int op_slot_right_4346 = gc_frame_newslot(num4347);
// starting to compile member node (depth = 5)
  int callframe4349 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4350 = gc_frame_new();
// call case 4: self request
  Object call4351 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4350);
// compiled member node returning call4351 (depth = 6)
  Object call4352 = callmethodflags(call4351, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4349);
// compiled member node returning call4352 (depth = 5)
  int op_slot_left_4346 = gc_frame_newslot(call4352);
  params[0] = num4347;
  partcv[0] = 1;
  Object diff4353 = callmethod(call4352, "-(1)", 1, partcv, params);
// compiled op node returning diff4353 (depth = 4)
  int op_slot_right_4345 = gc_frame_newslot(diff4353);
// starting to compile num node (depth = 4)
  Object num4355 = alloc_Float64(0);
// compiled num node returning num4355 (depth = 4)
  int op_slot_left_4345 = gc_frame_newslot(num4355);
  params[0] = diff4353;
  partcv[0] = 1;
  Object opresult4356 = callmethod(num4355, "..(1)", 1, partcv, params);
// compiled op node returning opresult4356 (depth = 3)
  gc_frame_newslot(opresult4356);
// starting to compile block node (depth = 3)
  Object block4357 = alloc_Block(NULL, NULL, "collectionsPrelude", 1820);
  gc_frame_newslot(block4357);
// method "_apply(_)"
  block_savedest(block4357);
  Object closure4358 = createclosure(4, "_apply(1)");
  setclosureframe(closure4358, stackframe);
  addtoclosure(closure4358, var_removed);
  addtoclosure(closure4358, var_unused);
  addtoclosure(closure4358, var_block1);
  addtoclosure(closure4358, selfslot);
  struct UserObject *uo4358 = (struct UserObject*)block4357;
  uo4358->data[0] = (Object)closure4358;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4358 = addmethod2pos(block4357, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4358, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4358[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4358->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4358);
  meth_meth_collectionsPrelude__apply_40_1_41_4358->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4358->definitionLine = 1991;
// compiled block node returning block4357 (depth = 3)
  gc_frame_newslot(block4357);
// call case 5: prelude request
  params[0] = opresult4356;
  params[1] = block4357;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4378 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4344);
// compiled call node returning call4378 (depth = 2)
  gc_frame_end(frame);
  return call4378;
}
Object meth_collectionsPrelude_do_40_1_41_4379(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4380 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_block1 (depth = 3)
  gc_frame_newslot(*var_block1);
// call case 4: self request
  params[0] = *var_block1;
  partcv[0] = 1;
  Object call4381 = callmethodflags(self, "valuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4380);
// compiled call node returning call4381 (depth = 2)
  gc_frame_end(frame);
  return call4381;
}
Object meth_collectionsPrelude__apply4403(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool4404 = alloc_Boolean(0);
// compiled identifier node returning bool4404 (depth = 11)
  block_return(realself, bool4404);
// compiled return node returning undefined (depth = 10)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_2_41_4397(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_o = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1834
  setline(1834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  int op_slot_right_4399 = gc_frame_newslot(*var_v);
// starting to compile call node (depth = 8)
  int callframe4401 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_k (depth = 9)
  gc_frame_newslot(*var_k);
// starting to compile block node (depth = 9)
  Object block4402 = alloc_Block(NULL, NULL, "collectionsPrelude", 1834);
  gc_frame_newslot(block4402);
// method "_apply"
  block_savedest(block4402);
  Object closure4403 = createclosure(1, "_apply");
  setclosureframe(closure4403, stackframe);
  addtoclosure(closure4403, selfslot);
  struct UserObject *uo4403 = (struct UserObject*)block4402;
  uo4403->data[0] = (Object)closure4403;
  Method *meth_meth_collectionsPrelude__apply4403 = addmethod2pos(block4402, "_apply", &meth_collectionsPrelude__apply4403, 0);
  int argcv_meth_collectionsPrelude__apply4403[] = {0};
  meth_meth_collectionsPrelude__apply4403->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4403);
  meth_meth_collectionsPrelude__apply4403->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4403->definitionLine = 1991;
// compiled block node returning block4402 (depth = 9)
  gc_frame_newslot(block4402);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  params[0] = *var_k;
  params[1] = block4402;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4406 = callmethodflags(*var_o, "at(1)ifAbsent(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4401);
// compiled call node returning call4406 (depth = 8)
  int op_slot_left_4399 = gc_frame_newslot(call4406);
  params[0] = *var_v;
  partcv[0] = 1;
  Object opresult4407 = callmethod(call4406, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4407 (depth = 7)
  Object if4398 = done;
  if (istrue(opresult4407)) {
// Begin line 1835
  setline(1835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool4408 = alloc_Boolean(0);
// compiled identifier node returning bool4408 (depth = 8)
  block_return(realself, bool4408);
// compiled return node returning undefined (depth = 7)
    gc_frame_newslot(undefined);
    if4398 = undefined;
  } else {
  }
// compiled if node returning if4398 (depth = 6)
  gc_frame_end(frame);
  return if4398;
}
Object meth_collectionsPrelude__apply_40_1_41_4385(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4388 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  Object call4389 = callmethodflags(*var_o, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4388);
// compiled member node returning call4389 (depth = 6)
  int op_slot_right_4387 = gc_frame_newslot(call4389);
// starting to compile member node (depth = 6)
  int callframe4391 = gc_frame_new();
// call case 4: self request
  Object call4392 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4391);
// compiled member node returning call4392 (depth = 6)
  int op_slot_left_4387 = gc_frame_newslot(call4392);
  params[0] = call4389;
  partcv[0] = 1;
  Object opresult4393 = callmethod(call4392, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4393 (depth = 5)
  Object if4386 = done;
  if (istrue(opresult4393)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4394 = alloc_Boolean(0);
// compiled identifier node returning bool4394 (depth = 6)
  block_return(realself, bool4394);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4386 = undefined;
  } else {
  }
// compiled if node returning if4386 (depth = 4)
// Begin line 1833
  setline(1833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4395 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4396 = alloc_Block(NULL, NULL, "collectionsPrelude", 1833);
  gc_frame_newslot(block4396);
// method "_apply(_,_)"
  block_savedest(block4396);
  Object closure4397 = createclosure(2, "_apply(2)");
  setclosureframe(closure4397, stackframe);
  addtoclosure(closure4397, var_o);
  addtoclosure(closure4397, selfslot);
  struct UserObject *uo4397 = (struct UserObject*)block4396;
  uo4397->data[0] = (Object)closure4397;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_4397 = addmethod2pos(block4396, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_4397, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_4397[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_4397->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_4397);
  meth_meth_collectionsPrelude__apply_40_2_41_4397->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_4397->definitionLine = 1991;
// compiled block node returning block4396 (depth = 5)
  gc_frame_newslot(block4396);
// call case 4: self request
  params[0] = block4396;
  partcv[0] = 1;
  Object call4410 = callmethodflags(self, "keysAndValuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4395);
// compiled call node returning call4410 (depth = 4)
// Begin line 1838
  setline(1838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4411 = alloc_Boolean(1);
// compiled identifier node returning bool4411 (depth = 5)
  block_return(realself, bool4411);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_1_41_4423(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___19 = &(stackframe->slots[0]);
  *var___19 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1841
  setline(1841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4424 = alloc_Boolean(0);
// compiled identifier node returning bool4424 (depth = 5)
  block_return(realself, bool4424);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__61__61__40_1_41_4382(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[1];
  Object *var_ComparableToDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  int frame4383 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4384 = alloc_Block(NULL, NULL, "collectionsPrelude", 1831);
  gc_frame_newslot(block4384);
// method "_apply(_)"
  block_savedest(block4384);
  Object closure4385 = createclosure(1, "_apply(1)");
  setclosureframe(closure4385, stackframe);
  addtoclosure(closure4385, selfslot);
  struct UserObject *uo4385 = (struct UserObject*)block4384;
  uo4385->data[0] = (Object)closure4385;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4385 = addmethod2pos(block4384, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4385, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4385[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4385->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4385);
  meth_meth_collectionsPrelude__apply_40_1_41_4385->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4385->definitionLine = 1991;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4413 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4414 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4415 == NULL) {
    strlit4415 = alloc_String("o");
    gc_root(strlit4415);
  }
// compiled string node returning strlit4415 (depth = 6)
  gc_frame_newslot(strlit4415);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4416 = gc_frame_new();
// call case 5: prelude request
  Object call4417 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4416);
// compiled member node returning call4417 (depth = 6)
  params[0] = strlit4415;
  partcv[0] = 1;
  Object call4418 = callmethodflags(call4417, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4414);
// compiled call node returning call4418 (depth = 5)
  gc_frame_newslot(call4418);
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ComparableToDictionary (depth = 5)
  gc_frame_newslot(*var_ComparableToDictionary);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4419 = gc_frame_new();
// call case 5: prelude request
  Object call4420 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4419);
// compiled member node returning call4420 (depth = 5)
  params[0] = call4418;
  params[1] = *var_ComparableToDictionary;
  partcv[0] = 2;
  Object call4421 = callmethodflags(call4420, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4413);
// compiled call node returning call4421 (depth = 4)
((struct UserObject *)block4384)->data[1] = call4421;
// compiled block node returning block4384 (depth = 3)
  gc_frame_newslot(block4384);
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4422 = alloc_Block(NULL, NULL, "collectionsPrelude", 1840);
  gc_frame_newslot(block4422);
// method "_apply(_)"
  block_savedest(block4422);
  Object closure4423 = createclosure(1, "_apply(1)");
  setclosureframe(closure4423, stackframe);
  addtoclosure(closure4423, selfslot);
  struct UserObject *uo4423 = (struct UserObject*)block4422;
  uo4423->data[0] = (Object)closure4423;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4423 = addmethod2pos(block4422, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4423, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4423[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4423->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4423);
  meth_meth_collectionsPrelude__apply_40_1_41_4423->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4423->definitionLine = 1991;
// compiled block node returning block4422 (depth = 3)
  gc_frame_newslot(block4422);
  params[0] = block4384;
  params[1] = block4422;
  Object matchres4383 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame4383);
// compiled matchcase node returning matchres4383 (depth = 2)
  gc_frame_end(frame);
  return matchres4383;
}
Object meth_collectionsPrelude__apply_40_2_41_4437(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_newCopy = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4438 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newCopy (depth = 5)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4439 = callmethodflags(*var_newCopy, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4438);
// compiled call node returning call4439 (depth = 4)
  gc_frame_end(frame);
  return call4439;
}
Object meth_collectionsPrelude_copy4426(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newCopy = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "newCopy");
// Begin line 1846
  setline(1846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4427 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4428 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4429 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4430 = gc_frame_new();
// call case 3: self.outer request
  Object call4431 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4430);
// compiled member node returning call4431 (depth = 6)
  Object call4432 = callmethodflags(call4431, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4429);
// compiled member node returning call4432 (depth = 5)
  Object call4433 = callmethodflags(call4432, "dictionary", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4428);
// compiled member node returning call4433 (depth = 4)
  Object call4434 = callmethodflags(call4433, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe4427);
// compiled member node returning call4434 (depth = 3)
  *var_newCopy = call4434;
  if (call4434 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1847
  setline(1847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4435 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4436 = alloc_Block(NULL, NULL, "collectionsPrelude", 1847);
  gc_frame_newslot(block4436);
// method "_apply(_,_)"
  block_savedest(block4436);
  Object closure4437 = createclosure(2, "_apply(2)");
  setclosureframe(closure4437, stackframe);
  addtoclosure(closure4437, var_newCopy);
  addtoclosure(closure4437, selfslot);
  struct UserObject *uo4437 = (struct UserObject*)block4436;
  uo4437->data[0] = (Object)closure4437;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_4437 = addmethod2pos(block4436, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_4437, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_4437[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_4437->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_4437);
  meth_meth_collectionsPrelude__apply_40_2_41_4437->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_4437->definitionLine = 1991;
// compiled block node returning block4436 (depth = 3)
  gc_frame_newslot(block4436);
// call case 4: self request
  params[0] = block4436;
  partcv[0] = 1;
  Object call4441 = callmethodflags(self, "keysAndValuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4435);
// compiled call node returning call4441 (depth = 2)
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_newCopy (depth = 2)
  gc_frame_end(frame);
  return *var_newCopy;
}
Object meth_collectionsPrelude_asDictionary4442(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_2_41_4448(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_newDict = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4449 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newDict (depth = 5)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4450 = callmethodflags(*var_newDict, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4449);
// compiled call node returning call4450 (depth = 4)
  gc_frame_end(frame);
  return call4450;
}
Object meth_collectionsPrelude__43__43__40_1_41_4443(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newDict = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newDict");
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4444 = gc_frame_new();
// call case 4: self request
  Object call4445 = callmethodflags(self, "copy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4444);
// compiled member node returning call4445 (depth = 3)
  *var_newDict = call4445;
  if (call4445 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4446 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4447 = alloc_Block(NULL, NULL, "collectionsPrelude", 1859);
  gc_frame_newslot(block4447);
// method "_apply(_,_)"
  block_savedest(block4447);
  Object closure4448 = createclosure(2, "_apply(2)");
  setclosureframe(closure4448, stackframe);
  addtoclosure(closure4448, var_newDict);
  addtoclosure(closure4448, selfslot);
  struct UserObject *uo4448 = (struct UserObject*)block4447;
  uo4448->data[0] = (Object)closure4448;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_4448 = addmethod2pos(block4447, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_4448, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_4448[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_4448->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_4448);
  meth_meth_collectionsPrelude__apply_40_2_41_4448->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_4448->definitionLine = 1991;
// compiled block node returning block4447 (depth = 3)
  gc_frame_newslot(block4447);
// call case 6: other requests
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  params[0] = block4447;
  partcv[0] = 1;
  Object call4452 = callmethodflags(*var_other, "keysAndValuesDo(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4446);
// compiled call node returning call4452 (depth = 2)
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newDict (depth = 3)
  return *var_newDict;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_2_41_4464(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_other = getfromclosure(closure, 0);
  Object *var_newDict = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4466 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe4467 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_k (depth = 7)
  gc_frame_newslot(*var_k);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  params[0] = *var_k;
  partcv[0] = 1;
  Object call4468 = callmethodflags(*var_other, "containsKey(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4467);
// compiled call node returning call4468 (depth = 6)
  partcv[0] = 0;
  Object call4469 = callmethodflags(call4468, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe4466);
// compiled call node returning call4469 (depth = 5)
  Object if4465 = done;
  if (istrue(call4469)) {
// Begin line 1869
  setline(1869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4470 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newDict (depth = 6)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4471 = callmethodflags(*var_newDict, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4470);
// compiled call node returning call4471 (depth = 5)
    gc_frame_newslot(call4471);
    if4465 = call4471;
  } else {
  }
// compiled if node returning if4465 (depth = 4)
  gc_frame_end(frame);
  return if4465;
}
Object meth_collectionsPrelude__45__45__40_1_41_4453(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "--(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method --(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for --(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part --(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newDict = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newDict");
// Begin line 1866
  setline(1866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4454 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4455 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4456 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4457 = gc_frame_new();
// call case 3: self.outer request
  Object call4458 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4457);
// compiled member node returning call4458 (depth = 6)
  Object call4459 = callmethodflags(call4458, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4456);
// compiled member node returning call4459 (depth = 5)
  Object call4460 = callmethodflags(call4459, "dictionary", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4455);
// compiled member node returning call4460 (depth = 4)
  Object call4461 = callmethodflags(call4460, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe4454);
// compiled member node returning call4461 (depth = 3)
  *var_newDict = call4461;
  if (call4461 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4462 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4463 = alloc_Block(NULL, NULL, "collectionsPrelude", 1867);
  gc_frame_newslot(block4463);
// method "_apply(_,_)"
  block_savedest(block4463);
  Object closure4464 = createclosure(3, "_apply(2)");
  setclosureframe(closure4464, stackframe);
  addtoclosure(closure4464, var_other);
  addtoclosure(closure4464, var_newDict);
  addtoclosure(closure4464, selfslot);
  struct UserObject *uo4464 = (struct UserObject*)block4463;
  uo4464->data[0] = (Object)closure4464;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_4464 = addmethod2pos(block4463, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_4464, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_4464[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_4464->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_4464);
  meth_meth_collectionsPrelude__apply_40_2_41_4464->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_4464->definitionLine = 1991;
// compiled block node returning block4463 (depth = 3)
  gc_frame_newslot(block4463);
// call case 4: self request
  params[0] = block4463;
  partcv[0] = 1;
  Object call4473 = callmethodflags(self, "keysAndValuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4462);
// compiled call node returning call4473 (depth = 2)
// Begin line 1872
  setline(1872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newDict (depth = 3)
  return *var_newDict;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_1_41_4497(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1519
  setline(1519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4498 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4499 = gc_frame_new();
// call case 4: self request
  Object call4500 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4499);
// compiled member node returning call4500 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4501 = callmethodflags(call4500, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4498);
// compiled call node returning call4501 (depth = 4)
  gc_frame_end(frame);
  return call4501;
}
Object meth_collectionsPrelude_empty3149(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  Object *var_NoSuchObject = getfromclosure(closure, 3);
  Object *var__prelude = getfromclosure(closure, 4);
  Object *var_enumerable = getfromclosure(closure, 5);
  Object *var_ConcurrentModification = getfromclosure(closure, 6);
  Object *var_IteratorExhausted = getfromclosure(closure, 7);
  Object *var_ComparableToDictionary = getfromclosure(closure, 8);
  Object *var_collection = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3150 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3150 = alloc_userobj2(44,42, objclass3150);
  gc_frame_newslot(obj3150);
if (objclass3150 == NULL) {
  glfree(obj3150->class->name);
  obj3150->class->name = "dictionary.empty";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3150, self, 0);
  addmethodreal(obj3150,"outer", &reader_collectionsPrelude_outer_3151);
  Object oldself3150 = self;
  struct StackFrameObject *oldstackframe3150 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3150);
  gc_frame_newslot((Object)stackframe);
  self = obj3150;
  Object *oldselfslot3150 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3150 = (*(struct UserObject *)self).data[0], lowerouter3150 = thisouter3150;
  if (inheritingObject3150) {
    struct UserObject *inho3150 = (struct UserObject *)inheritingObject3150;
    while (inho3150->super != GraceDefaultObject) inho3150 = (struct UserObject *)inho3150->super;
    inho3150->super = obj3150;
    self = inheritingObject3150;
    *selfslot = self;
    lowerouter3150 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3150;
  }
if (objclass3150 == NULL) {
  Method *reader3152 = addmethodrealflags(obj3150, "mods", &reader_collectionsPrelude_mods_3152, 0);
  Method *writer3152 = addmethodrealflags(obj3150, "mods:=(1)", &writer_collectionsPrelude_mods_3152, MFLAG_CONFIDENTIAL);
  reader3152->definitionModule = modulename;
  writer3152->definitionModule = modulename;
  reader3152->definitionLine = 1515;
  writer3152->definitionLine = 1515;
}
obj3150->flags |= OFLAG_MUTABLE;
adddatum2(obj3150, alloc_Undefined(), 1);
if (objclass3150 == NULL) {
  Method *reader3153 = addmethodrealflags(obj3150, "numBindings", &reader_collectionsPrelude_numBindings_3153, MFLAG_CONFIDENTIAL);
  Method *writer3153 = addmethodrealflags(obj3150, "numBindings:=(1)", &writer_collectionsPrelude_numBindings_3153, MFLAG_CONFIDENTIAL);
  reader3153->definitionModule = modulename;
  writer3153->definitionModule = modulename;
  reader3153->definitionLine = 1516;
  writer3153->definitionLine = 1516;
}
obj3150->flags |= OFLAG_MUTABLE;
adddatum2(obj3150, alloc_Undefined(), 2);
if (objclass3150 == NULL) {
  Method *reader3154 = addmethodrealflags(obj3150, "inner", &reader_collectionsPrelude_inner_3154, MFLAG_CONFIDENTIAL);
  Method *writer3154 = addmethodrealflags(obj3150, "inner:=(1)", &writer_collectionsPrelude_inner_3154, MFLAG_CONFIDENTIAL);
  reader3154->definitionModule = modulename;
  writer3154->definitionModule = modulename;
  reader3154->definitionLine = 1517;
  writer3154->definitionLine = 1517;
}
obj3150->flags |= OFLAG_MUTABLE;
adddatum2(obj3150, alloc_Undefined(), 3);
// method "size"
  struct UserObject *uo3155 = (struct UserObject*)obj3150;
  uo3155->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size3155 = addmethod2pos(obj3150, "size", &meth_collectionsPrelude_size3155, 4);
  int argcv_meth_collectionsPrelude_size3155[] = {0};
  meth_meth_collectionsPrelude_size3155->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size3155);
  meth_meth_collectionsPrelude_size3155->definitionModule = modulename;
  meth_meth_collectionsPrelude_size3155->definitionLine = 1521;
// method "at(_)put(_)"
  block_savedest(obj3150);
  Object closure3158 = createclosure(3, "at(1)put(1)");
  setclosureframe(closure3158, stackframe);
  addtoclosure(closure3158, var_removed);
  addtoclosure(closure3158, var_unused);
  addtoclosure(closure3158, var_binding);
  struct UserObject *uo3158 = (struct UserObject*)obj3150;
  uo3158->data[5] = (Object)closure3158;
  Method *meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3158 = addmethod2pos(obj3150, "at(1)put(1)", &meth_collectionsPrelude_at_40_1_41_put_40_1_41_3158, 5);
  int argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3158[] = {1, 1};
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3158->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3158);
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3158->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3158->definitionLine = 1522;
// method "add(_)"
  block_savedest(obj3150);
  Object closure3217 = createclosure(2, "add(1)");
  setclosureframe(closure3217, stackframe);
  addtoclosure(closure3217, var_removed);
  addtoclosure(closure3217, var_unused);
  struct UserObject *uo3217 = (struct UserObject*)obj3150;
  uo3217->data[6] = (Object)closure3217;
  Method *meth_meth_collectionsPrelude_add_40_1_41_3217 = addmethod2pos(obj3150, "add(1)", &meth_collectionsPrelude_add_40_1_41_3217, 6);
  int argcv_meth_collectionsPrelude_add_40_1_41_3217[] = {1};
  meth_meth_collectionsPrelude_add_40_1_41_3217->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add_40_1_41_3217);
  meth_meth_collectionsPrelude_add_40_1_41_3217->definitionModule = modulename;
  meth_meth_collectionsPrelude_add_40_1_41_3217->definitionLine = 1532;
// method "at(_)"
  block_savedest(obj3150);
  Object closure3276 = createclosure(1, "at(1)");
  setclosureframe(closure3276, stackframe);
  addtoclosure(closure3276, var_NoSuchObject);
  struct UserObject *uo3276 = (struct UserObject*)obj3150;
  uo3276->data[7] = (Object)closure3276;
  Method *meth_meth_collectionsPrelude_at_40_1_41_3276 = addmethod2pos(obj3150, "at(1)", &meth_collectionsPrelude_at_40_1_41_3276, 7);
  int argcv_meth_collectionsPrelude_at_40_1_41_3276[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_3276->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_3276);
  meth_meth_collectionsPrelude_at_40_1_41_3276->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_3276->definitionLine = 1542;
// method "at(_)ifAbsent(_)"
  struct UserObject *uo3301 = (struct UserObject*)obj3150;
  uo3301->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3301 = addmethod2pos(obj3150, "at(1)ifAbsent(1)", &meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3301, 8);
  int argcv_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3301[] = {1, 1};
  meth_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3301->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3301);
  meth_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3301->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3301->definitionLine = 1549;
// method "containsKey(_)"
  struct UserObject *uo3318 = (struct UserObject*)obj3150;
  uo3318->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_containsKey_40_1_41_3318 = addmethod2pos(obj3150, "containsKey(1)", &meth_collectionsPrelude_containsKey_40_1_41_3318, 9);
  int argcv_meth_collectionsPrelude_containsKey_40_1_41_3318[] = {1};
  meth_meth_collectionsPrelude_containsKey_40_1_41_3318->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_containsKey_40_1_41_3318);
  meth_meth_collectionsPrelude_containsKey_40_1_41_3318->definitionModule = modulename;
  meth_meth_collectionsPrelude_containsKey_40_1_41_3318->definitionLine = 1556;
// method "removeAllKeys(_)"
  block_savedest(obj3150);
  Object closure3333 = createclosure(2, "removeAllKeys(1)");
  setclosureframe(closure3333, stackframe);
  addtoclosure(closure3333, var_removed);
  addtoclosure(closure3333, var_NoSuchObject);
  struct UserObject *uo3333 = (struct UserObject*)obj3150;
  uo3333->data[10] = (Object)closure3333;
  Method *meth_meth_collectionsPrelude_removeAllKeys_40_1_41_3333 = addmethod2pos(obj3150, "removeAllKeys(1)", &meth_collectionsPrelude_removeAllKeys_40_1_41_3333, 10);
  int argcv_meth_collectionsPrelude_removeAllKeys_40_1_41_3333[] = {1};
  meth_meth_collectionsPrelude_removeAllKeys_40_1_41_3333->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAllKeys_40_1_41_3333);
  meth_meth_collectionsPrelude_removeAllKeys_40_1_41_3333->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAllKeys_40_1_41_3333->definitionLine = 1563;
// method "removeKey(_)"
  block_savedest(obj3150);
  Object closure3381 = createclosure(2, "removeKey(1)");
  setclosureframe(closure3381, stackframe);
  addtoclosure(closure3381, var_removed);
  addtoclosure(closure3381, var_NoSuchObject);
  struct UserObject *uo3381 = (struct UserObject*)obj3150;
  uo3381->data[11] = (Object)closure3381;
  Method *meth_meth_collectionsPrelude_removeKey_40_1_41_3381 = addmethod2pos(obj3150, "removeKey(1)", &meth_collectionsPrelude_removeKey_40_1_41_3381, 11);
  int argcv_meth_collectionsPrelude_removeKey_40_1_41_3381[] = {1};
  meth_meth_collectionsPrelude_removeKey_40_1_41_3381->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeKey_40_1_41_3381);
  meth_meth_collectionsPrelude_removeKey_40_1_41_3381->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeKey_40_1_41_3381->definitionLine = 1576;
// method "removeAllValues(_)"
  block_savedest(obj3150);
  Object closure3424 = createclosure(1, "removeAllValues(1)");
  setclosureframe(closure3424, stackframe);
  addtoclosure(closure3424, var_removed);
  struct UserObject *uo3424 = (struct UserObject*)obj3150;
  uo3424->data[12] = (Object)closure3424;
  Method *meth_meth_collectionsPrelude_removeAllValues_40_1_41_3424 = addmethod2pos(obj3150, "removeAllValues(1)", &meth_collectionsPrelude_removeAllValues_40_1_41_3424, 12);
  int argcv_meth_collectionsPrelude_removeAllValues_40_1_41_3424[] = {1};
  meth_meth_collectionsPrelude_removeAllValues_40_1_41_3424->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAllValues_40_1_41_3424);
  meth_meth_collectionsPrelude_removeAllValues_40_1_41_3424->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAllValues_40_1_41_3424->definitionLine = 1587;
// method "removeValue(_)"
  block_savedest(obj3150);
  Object closure3471 = createclosure(2, "removeValue(1)");
  setclosureframe(closure3471, stackframe);
  addtoclosure(closure3471, var_removed);
  addtoclosure(closure3471, var_NoSuchObject);
  struct UserObject *uo3471 = (struct UserObject*)obj3150;
  uo3471->data[13] = (Object)closure3471;
  Method *meth_meth_collectionsPrelude_removeValue_40_1_41_3471 = addmethod2pos(obj3150, "removeValue(1)", &meth_collectionsPrelude_removeValue_40_1_41_3471, 13);
  int argcv_meth_collectionsPrelude_removeValue_40_1_41_3471[] = {1};
  meth_meth_collectionsPrelude_removeValue_40_1_41_3471->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeValue_40_1_41_3471);
  meth_meth_collectionsPrelude_removeValue_40_1_41_3471->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeValue_40_1_41_3471->definitionLine = 1598;
// method "removeValue(_)ifAbsent(_)"
  block_savedest(obj3150);
  Object closure3537 = createclosure(1, "removeValue(1)ifAbsent(1)");
  setclosureframe(closure3537, stackframe);
  addtoclosure(closure3537, var_removed);
  struct UserObject *uo3537 = (struct UserObject*)obj3150;
  uo3537->data[14] = (Object)closure3537;
  Method *meth_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3537 = addmethod2pos(obj3150, "removeValue(1)ifAbsent(1)", &meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3537, 14);
  int argcv_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3537[] = {1, 1};
  meth_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3537->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3537);
  meth_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3537->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3537->definitionLine = 1614;
// method "clear"
  block_savedest(obj3150);
  Object closure3595 = createclosure(2, "clear");
  setclosureframe(closure3595, stackframe);
  addtoclosure(closure3595, var__prelude);
  addtoclosure(closure3595, var_unused);
  struct UserObject *uo3595 = (struct UserObject*)obj3150;
  uo3595->data[15] = (Object)closure3595;
  Method *meth_meth_collectionsPrelude_clear3595 = addmethod2pos(obj3150, "clear", &meth_collectionsPrelude_clear3595, 15);
  int argcv_meth_collectionsPrelude_clear3595[] = {0};
  meth_meth_collectionsPrelude_clear3595->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_clear3595);
  meth_meth_collectionsPrelude_clear3595->definitionModule = modulename;
  meth_meth_collectionsPrelude_clear3595->definitionLine = 1630;
// method "containsValue(_)"
  struct UserObject *uo3635 = (struct UserObject*)obj3150;
  uo3635->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_containsValue_40_1_41_3635 = addmethod2pos(obj3150, "containsValue(1)", &meth_collectionsPrelude_containsValue_40_1_41_3635, 16);
  int argcv_meth_collectionsPrelude_containsValue_40_1_41_3635[] = {1};
  meth_meth_collectionsPrelude_containsValue_40_1_41_3635->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_containsValue_40_1_41_3635);
  meth_meth_collectionsPrelude_containsValue_40_1_41_3635->definitionModule = modulename;
  meth_meth_collectionsPrelude_containsValue_40_1_41_3635->definitionLine = 1639;
// method "contains(_)"
  struct UserObject *uo3647 = (struct UserObject*)obj3150;
  uo3647->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_3647 = addmethod2pos(obj3150, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_3647, 17);
  int argcv_meth_collectionsPrelude_contains_40_1_41_3647[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_3647->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_3647);
  meth_meth_collectionsPrelude_contains_40_1_41_3647->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_3647->definitionLine = 1645;
// method "findPosition(_)"
  block_savedest(obj3150);
  Object closure3650 = createclosure(1, "findPosition(1)");
  setclosureframe(closure3650, stackframe);
  addtoclosure(closure3650, var_unused);
  struct UserObject *uo3650 = (struct UserObject*)obj3150;
  uo3650->data[18] = (Object)closure3650;
  Method *meth_meth_collectionsPrelude_findPosition_40_1_41_3650 = addmethod2pos(obj3150, "findPosition(1)", &meth_collectionsPrelude_findPosition_40_1_41_3650, 18);
  int argcv_meth_collectionsPrelude_findPosition_40_1_41_3650[] = {1};
  meth_meth_collectionsPrelude_findPosition_40_1_41_3650->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPosition_40_1_41_3650);
  meth_meth_collectionsPrelude_findPosition_40_1_41_3650->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPosition_40_1_41_3650->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPosition_40_1_41_3650->definitionLine = 1647;
// method "findPositionForAdd(_)"
  block_savedest(obj3150);
  Object closure3716 = createclosure(2, "findPositionForAdd(1)");
  setclosureframe(closure3716, stackframe);
  addtoclosure(closure3716, var_removed);
  addtoclosure(closure3716, var_unused);
  struct UserObject *uo3716 = (struct UserObject*)obj3150;
  uo3716->data[19] = (Object)closure3716;
  Method *meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3716 = addmethod2pos(obj3150, "findPositionForAdd(1)", &meth_collectionsPrelude_findPositionForAdd_40_1_41_3716, 19);
  int argcv_meth_collectionsPrelude_findPositionForAdd_40_1_41_3716[] = {1};
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3716->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPositionForAdd_40_1_41_3716);
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3716->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3716->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3716->definitionLine = 1665;
// method "asString"
  block_savedest(obj3150);
  Object closure3792 = createclosure(2, "asString");
  setclosureframe(closure3792, stackframe);
  addtoclosure(closure3792, var_removed);
  addtoclosure(closure3792, var_unused);
  struct UserObject *uo3792 = (struct UserObject*)obj3150;
  uo3792->data[20] = (Object)closure3792;
  Method *meth_meth_collectionsPrelude_asString3792 = addmethod2pos(obj3150, "asString", &meth_collectionsPrelude_asString3792, 20);
  int argcv_meth_collectionsPrelude_asString3792[] = {0};
  meth_meth_collectionsPrelude_asString3792->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3792);
  meth_meth_collectionsPrelude_asString3792->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3792->definitionLine = 1683;
// method "asDebugString"
  block_savedest(obj3150);
  Object closure3863 = createclosure(2, "asDebugString");
  setclosureframe(closure3863, stackframe);
  addtoclosure(closure3863, var_removed);
  addtoclosure(closure3863, var_unused);
  struct UserObject *uo3863 = (struct UserObject*)obj3150;
  uo3863->data[21] = (Object)closure3863;
  Method *meth_meth_collectionsPrelude_asDebugString3863 = addmethod2pos(obj3150, "asDebugString", &meth_collectionsPrelude_asDebugString3863, 21);
  int argcv_meth_collectionsPrelude_asDebugString3863[] = {0};
  meth_meth_collectionsPrelude_asDebugString3863->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3863);
  meth_meth_collectionsPrelude_asDebugString3863->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3863->definitionLine = 1701;
// method "keys"
  block_savedest(obj3150);
  Object closure3961 = createclosure(1, "keys");
  setclosureframe(closure3961, stackframe);
  addtoclosure(closure3961, var_enumerable);
  struct UserObject *uo3961 = (struct UserObject*)obj3150;
  uo3961->data[22] = (Object)closure3961;
  Method *meth_meth_collectionsPrelude_keys3961 = addmethod2pos(obj3150, "keys", &meth_collectionsPrelude_keys3961, 22);
  int argcv_meth_collectionsPrelude_keys3961[] = {0};
  meth_meth_collectionsPrelude_keys3961->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys3961);
  meth_meth_collectionsPrelude_keys3961->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys3961->definitionLine = 1714;
  block_savedest(obj3150);
  Object closure4006 = createclosure(1, "keys$object(1)");
  setclosureframe(closure4006, stackframe);
  addtoclosure(closure4006, var_enumerable);
  Method *meth_meth_collectionsPrelude_keys3961_object = addmethod2pos(obj3150, "keys$object(1)", &meth_collectionsPrelude_keys3961_object, 22);
  meth_meth_collectionsPrelude_keys3961_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys3961_object->definitionLine = 1714;
// method "values"
  block_savedest(obj3150);
  Object closure4007 = createclosure(1, "values");
  setclosureframe(closure4007, stackframe);
  addtoclosure(closure4007, var_enumerable);
  struct UserObject *uo4007 = (struct UserObject*)obj3150;
  uo4007->data[23] = (Object)closure4007;
  Method *meth_meth_collectionsPrelude_values4007 = addmethod2pos(obj3150, "values", &meth_collectionsPrelude_values4007, 23);
  int argcv_meth_collectionsPrelude_values4007[] = {0};
  meth_meth_collectionsPrelude_values4007->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values4007);
  meth_meth_collectionsPrelude_values4007->definitionModule = modulename;
  meth_meth_collectionsPrelude_values4007->definitionLine = 1732;
  block_savedest(obj3150);
  Object closure4052 = createclosure(1, "values$object(1)");
  setclosureframe(closure4052, stackframe);
  addtoclosure(closure4052, var_enumerable);
  Method *meth_meth_collectionsPrelude_values4007_object = addmethod2pos(obj3150, "values$object(1)", &meth_collectionsPrelude_values4007_object, 23);
  meth_meth_collectionsPrelude_values4007_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_values4007_object->definitionLine = 1732;
// method "bindings"
  block_savedest(obj3150);
  Object closure4053 = createclosure(1, "bindings");
  setclosureframe(closure4053, stackframe);
  addtoclosure(closure4053, var_enumerable);
  struct UserObject *uo4053 = (struct UserObject*)obj3150;
  uo4053->data[24] = (Object)closure4053;
  Method *meth_meth_collectionsPrelude_bindings4053 = addmethod2pos(obj3150, "bindings", &meth_collectionsPrelude_bindings4053, 24);
  int argcv_meth_collectionsPrelude_bindings4053[] = {0};
  meth_meth_collectionsPrelude_bindings4053->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_bindings4053);
  meth_meth_collectionsPrelude_bindings4053->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindings4053->definitionLine = 1751;
  block_savedest(obj3150);
  Object closure4073 = createclosure(1, "bindings$object(1)");
  setclosureframe(closure4073, stackframe);
  addtoclosure(closure4073, var_enumerable);
  Method *meth_meth_collectionsPrelude_bindings4053_object = addmethod2pos(obj3150, "bindings$object(1)", &meth_collectionsPrelude_bindings4053_object, 24);
  meth_meth_collectionsPrelude_bindings4053_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindings4053_object->definitionLine = 1751;
// method "iterator"
  struct UserObject *uo4074 = (struct UserObject*)obj3150;
  uo4074->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator4074 = addmethod2pos(obj3150, "iterator", &meth_collectionsPrelude_iterator4074, 25);
  int argcv_meth_collectionsPrelude_iterator4074[] = {0};
  meth_meth_collectionsPrelude_iterator4074->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4074);
  meth_meth_collectionsPrelude_iterator4074->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4074->definitionLine = 1763;
// method "bindingsIterator"
  block_savedest(obj3150);
  Object closure4079 = createclosure(4, "bindingsIterator");
  setclosureframe(closure4079, stackframe);
  addtoclosure(closure4079, var_ConcurrentModification);
  addtoclosure(closure4079, var_IteratorExhausted);
  addtoclosure(closure4079, var_removed);
  addtoclosure(closure4079, var_unused);
  struct UserObject *uo4079 = (struct UserObject*)obj3150;
  uo4079->data[26] = (Object)closure4079;
  Method *meth_meth_collectionsPrelude_bindingsIterator4079 = addmethod2pos(obj3150, "bindingsIterator", &meth_collectionsPrelude_bindingsIterator4079, 26);
  int argcv_meth_collectionsPrelude_bindingsIterator4079[] = {0};
  meth_meth_collectionsPrelude_bindingsIterator4079->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_bindingsIterator4079);
  meth_meth_collectionsPrelude_bindingsIterator4079->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindingsIterator4079->definitionLine = 1764;
  block_savedest(obj3150);
  Object closure4200 = createclosure(4, "bindingsIterator$object(1)");
  setclosureframe(closure4200, stackframe);
  addtoclosure(closure4200, var_ConcurrentModification);
  addtoclosure(closure4200, var_IteratorExhausted);
  addtoclosure(closure4200, var_removed);
  addtoclosure(closure4200, var_unused);
  Method *meth_meth_collectionsPrelude_bindingsIterator4079_object = addmethod2pos(obj3150, "bindingsIterator$object(1)", &meth_collectionsPrelude_bindingsIterator4079_object, 26);
  meth_meth_collectionsPrelude_bindingsIterator4079_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindingsIterator4079_object->definitionLine = 1764;
// method "expand"
  block_savedest(obj3150);
  Object closure4201 = createclosure(3, "expand");
  setclosureframe(closure4201, stackframe);
  addtoclosure(closure4201, var__prelude);
  addtoclosure(closure4201, var_unused);
  addtoclosure(closure4201, var_removed);
  struct UserObject *uo4201 = (struct UserObject*)obj3150;
  uo4201->data[27] = (Object)closure4201;
  Method *meth_meth_collectionsPrelude_expand4201 = addmethod2pos(obj3150, "expand", &meth_collectionsPrelude_expand4201, 27);
  int argcv_meth_collectionsPrelude_expand4201[] = {0};
  meth_meth_collectionsPrelude_expand4201->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expand4201);
  meth_meth_collectionsPrelude_expand4201->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expand4201->definitionModule = modulename;
  meth_meth_collectionsPrelude_expand4201->definitionLine = 1787;
// method "keysAndValuesDo(_)"
  block_savedest(obj3150);
  Object closure4269 = createclosure(2, "keysAndValuesDo(1)");
  setclosureframe(closure4269, stackframe);
  addtoclosure(closure4269, var_removed);
  addtoclosure(closure4269, var_unused);
  struct UserObject *uo4269 = (struct UserObject*)obj3150;
  uo4269->data[28] = (Object)closure4269;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4269 = addmethod2pos(obj3150, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_4269, 28);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4269[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4269->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4269);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4269->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4269->definitionLine = 1803;
// method "keysDo(_)"
  block_savedest(obj3150);
  Object closure4307 = createclosure(2, "keysDo(1)");
  setclosureframe(closure4307, stackframe);
  addtoclosure(closure4307, var_removed);
  addtoclosure(closure4307, var_unused);
  struct UserObject *uo4307 = (struct UserObject*)obj3150;
  uo4307->data[29] = (Object)closure4307;
  Method *meth_meth_collectionsPrelude_keysDo_40_1_41_4307 = addmethod2pos(obj3150, "keysDo(1)", &meth_collectionsPrelude_keysDo_40_1_41_4307, 29);
  int argcv_meth_collectionsPrelude_keysDo_40_1_41_4307[] = {1};
  meth_meth_collectionsPrelude_keysDo_40_1_41_4307->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysDo_40_1_41_4307);
  meth_meth_collectionsPrelude_keysDo_40_1_41_4307->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysDo_40_1_41_4307->definitionLine = 1811;
// method "valuesDo(_)"
  block_savedest(obj3150);
  Object closure4343 = createclosure(2, "valuesDo(1)");
  setclosureframe(closure4343, stackframe);
  addtoclosure(closure4343, var_removed);
  addtoclosure(closure4343, var_unused);
  struct UserObject *uo4343 = (struct UserObject*)obj3150;
  uo4343->data[30] = (Object)closure4343;
  Method *meth_meth_collectionsPrelude_valuesDo_40_1_41_4343 = addmethod2pos(obj3150, "valuesDo(1)", &meth_collectionsPrelude_valuesDo_40_1_41_4343, 30);
  int argcv_meth_collectionsPrelude_valuesDo_40_1_41_4343[] = {1};
  meth_meth_collectionsPrelude_valuesDo_40_1_41_4343->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_valuesDo_40_1_41_4343);
  meth_meth_collectionsPrelude_valuesDo_40_1_41_4343->definitionModule = modulename;
  meth_meth_collectionsPrelude_valuesDo_40_1_41_4343->definitionLine = 1819;
// method "do(_)"
  struct UserObject *uo4379 = (struct UserObject*)obj3150;
  uo4379->data[31] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_4379 = addmethod2pos(obj3150, "do(1)", &meth_collectionsPrelude_do_40_1_41_4379, 31);
  int argcv_meth_collectionsPrelude_do_40_1_41_4379[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_4379->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_4379);
  meth_meth_collectionsPrelude_do_40_1_41_4379->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_4379->definitionLine = 1827;
// method "==(_)"
  block_savedest(obj3150);
  Object closure4382 = createclosure(1, "==(1)");
  setclosureframe(closure4382, stackframe);
  addtoclosure(closure4382, var_ComparableToDictionary);
  struct UserObject *uo4382 = (struct UserObject*)obj3150;
  uo4382->data[32] = (Object)closure4382;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_4382 = addmethod2pos(obj3150, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_4382, 32);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_4382[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_4382->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_4382);
  meth_meth_collectionsPrelude__61__61__40_1_41_4382->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_4382->definitionLine = 1829;
// method "copy"
  struct UserObject *uo4426 = (struct UserObject*)obj3150;
  uo4426->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy4426 = addmethod2pos(obj3150, "copy", &meth_collectionsPrelude_copy4426, 33);
  int argcv_meth_collectionsPrelude_copy4426[] = {0};
  meth_meth_collectionsPrelude_copy4426->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy4426);
  meth_meth_collectionsPrelude_copy4426->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy4426->definitionLine = 1845;
// method "asDictionary"
  struct UserObject *uo4442 = (struct UserObject*)obj3150;
  uo4442->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary4442 = addmethod2pos(obj3150, "asDictionary", &meth_collectionsPrelude_asDictionary4442, 34);
  int argcv_meth_collectionsPrelude_asDictionary4442[] = {0};
  meth_meth_collectionsPrelude_asDictionary4442->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary4442);
  meth_meth_collectionsPrelude_asDictionary4442->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary4442->definitionLine = 1853;
// method "++(_)"
  struct UserObject *uo4443 = (struct UserObject*)obj3150;
  uo4443->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_4443 = addmethod2pos(obj3150, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_4443, 35);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_4443[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_4443->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_4443);
  meth_meth_collectionsPrelude__43__43__40_1_41_4443->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_4443->definitionLine = 1857;
// method "--(_)"
  struct UserObject *uo4453 = (struct UserObject*)obj3150;
  uo4453->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude__45__45__40_1_41_4453 = addmethod2pos(obj3150, "--(1)", &meth_collectionsPrelude__45__45__40_1_41_4453, 36);
  int argcv_meth_collectionsPrelude__45__45__40_1_41_4453[] = {1};
  meth_meth_collectionsPrelude__45__45__40_1_41_4453->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__45__45__40_1_41_4453);
  meth_meth_collectionsPrelude__45__45__40_1_41_4453->definitionModule = modulename;
  meth_meth_collectionsPrelude__45__45__40_1_41_4453->definitionLine = 1865;
  sourceObject = obj3150;
// Begin line 1514
  setline(1514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4474 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4475 = callmethodflags(*var_collection, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4474);
// compiled call node returning call4475 (depth = 2)
  struct UserObject *obj3150_uo = (struct UserObject *)obj3150;
  obj3150_uo->super = call4475;
  sourceObject = obj3150;
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4476 = alloc_Float64(0);
// compiled num node returning num4476 (depth = 2)
  adddatum2(obj3150, num4476, 1);
  sourceObject = obj3150;
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4477 = alloc_Float64(0);
// compiled num node returning num4477 (depth = 2)
  adddatum2(obj3150, num4477, 2);
  sourceObject = obj3150;
// Begin line 1517
  setline(1517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4478 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num4479 = alloc_Float64(8);
// compiled num node returning num4479 (depth = 3)
  gc_frame_newslot(num4479);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4480 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__prelude (depth = 4)
  Object call4481 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe4480);
// compiled member node returning call4481 (depth = 3)
  params[0] = num4479;
  partcv[0] = 1;
  Object call4482 = callmethodflags(call4481, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4478);
// compiled call node returning call4482 (depth = 2)
  adddatum2(obj3150, call4482, 3);
  sourceObject = obj3150;
// Begin line 1518
  setline(1518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4483 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4486 = alloc_Float64(1);
// compiled num node returning num4486 (depth = 5)
  int op_slot_right_4485 = gc_frame_newslot(num4486);
// starting to compile member node (depth = 5)
  int callframe4488 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4489 = gc_frame_new();
// call case 4: self request
  Object call4490 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4489);
// compiled member node returning call4490 (depth = 6)
  Object call4491 = callmethodflags(call4490, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4488);
// compiled member node returning call4491 (depth = 5)
  int op_slot_left_4485 = gc_frame_newslot(call4491);
  params[0] = num4486;
  partcv[0] = 1;
  Object diff4492 = callmethod(call4491, "-(1)", 1, partcv, params);
// compiled op node returning diff4492 (depth = 4)
  int op_slot_right_4484 = gc_frame_newslot(diff4492);
// starting to compile num node (depth = 4)
  Object num4494 = alloc_Float64(0);
// compiled num node returning num4494 (depth = 4)
  int op_slot_left_4484 = gc_frame_newslot(num4494);
  params[0] = diff4492;
  partcv[0] = 1;
  Object opresult4495 = callmethod(num4494, "..(1)", 1, partcv, params);
// compiled op node returning opresult4495 (depth = 3)
  gc_frame_newslot(opresult4495);
// starting to compile block node (depth = 3)
  Object block4496 = alloc_Block(NULL, NULL, "collectionsPrelude", 1518);
  gc_frame_newslot(block4496);
// method "_apply(_)"
  block_savedest(block4496);
  Object closure4497 = createclosure(2, "_apply(1)");
  setclosureframe(closure4497, stackframe);
  addtoclosure(closure4497, var_unused);
  addtoclosure(closure4497, selfslot);
  struct UserObject *uo4497 = (struct UserObject*)block4496;
  uo4497->data[0] = (Object)closure4497;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4497 = addmethod2pos(block4496, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4497, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4497[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4497->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4497);
  meth_meth_collectionsPrelude__apply_40_1_41_4497->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4497->definitionLine = 1991;
// compiled block node returning block4496 (depth = 3)
  gc_frame_newslot(block4496);
// call case 5: prelude request
  params[0] = opresult4495;
  params[1] = block4496;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4503 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4483);
// compiled call node returning call4503 (depth = 2)
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  objclass3150 = obj3150->class;
  objclass3150->definitionModule = modulename;
  objclass3150->definitionLine = 1513;
  (*(struct UserObject *)self).data[0] = lowerouter3150;
  self = oldself3150;
  selfslot = oldselfslot3150;
  stackframe = oldstackframe3150;
  gc_frame_end(frame);
  return obj3150;
}
Object meth_collectionsPrelude_empty3149_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "empty$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  Object *var_NoSuchObject = getfromclosure(closure, 3);
  Object *var__prelude = getfromclosure(closure, 4);
  Object *var_enumerable = getfromclosure(closure, 5);
  Object *var_ConcurrentModification = getfromclosure(closure, 6);
  Object *var_IteratorExhausted = getfromclosure(closure, 7);
  Object *var_ComparableToDictionary = getfromclosure(closure, 8);
  Object *var_collection = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3150 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3150 = alloc_userobj2(44,42, objclass3150);
  gc_frame_newslot(obj3150);
if (objclass3150 == NULL) {
  glfree(obj3150->class->name);
  obj3150->class->name = "dictionary.empty";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3150, self, 0);
  addmethodreal(obj3150,"outer", &reader_collectionsPrelude_outer_3151);
  Object oldself3150 = self;
  struct StackFrameObject *oldstackframe3150 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3150);
  gc_frame_newslot((Object)stackframe);
  self = obj3150;
  Object *oldselfslot3150 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3150 = (*(struct UserObject *)self).data[0], lowerouter3150 = thisouter3150;
  if (inheritingObject3150) {
    struct UserObject *inho3150 = (struct UserObject *)inheritingObject3150;
    while (inho3150->super != GraceDefaultObject) inho3150 = (struct UserObject *)inho3150->super;
    inho3150->super = obj3150;
    self = inheritingObject3150;
    *selfslot = self;
    lowerouter3150 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3150;
  }
if (objclass3150 == NULL) {
  Method *reader3152 = addmethodrealflags(obj3150, "mods", &reader_collectionsPrelude_mods_3152, 0);
  Method *writer3152 = addmethodrealflags(obj3150, "mods:=(1)", &writer_collectionsPrelude_mods_3152, MFLAG_CONFIDENTIAL);
  reader3152->definitionModule = modulename;
  writer3152->definitionModule = modulename;
  reader3152->definitionLine = 1515;
  writer3152->definitionLine = 1515;
}
obj3150->flags |= OFLAG_MUTABLE;
adddatum2(obj3150, alloc_Undefined(), 1);
if (objclass3150 == NULL) {
  Method *reader3153 = addmethodrealflags(obj3150, "numBindings", &reader_collectionsPrelude_numBindings_3153, MFLAG_CONFIDENTIAL);
  Method *writer3153 = addmethodrealflags(obj3150, "numBindings:=(1)", &writer_collectionsPrelude_numBindings_3153, MFLAG_CONFIDENTIAL);
  reader3153->definitionModule = modulename;
  writer3153->definitionModule = modulename;
  reader3153->definitionLine = 1516;
  writer3153->definitionLine = 1516;
}
obj3150->flags |= OFLAG_MUTABLE;
adddatum2(obj3150, alloc_Undefined(), 2);
if (objclass3150 == NULL) {
  Method *reader3154 = addmethodrealflags(obj3150, "inner", &reader_collectionsPrelude_inner_3154, MFLAG_CONFIDENTIAL);
  Method *writer3154 = addmethodrealflags(obj3150, "inner:=(1)", &writer_collectionsPrelude_inner_3154, MFLAG_CONFIDENTIAL);
  reader3154->definitionModule = modulename;
  writer3154->definitionModule = modulename;
  reader3154->definitionLine = 1517;
  writer3154->definitionLine = 1517;
}
obj3150->flags |= OFLAG_MUTABLE;
adddatum2(obj3150, alloc_Undefined(), 3);
// method "size"
  struct UserObject *uo3155 = (struct UserObject*)obj3150;
  uo3155->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size3155 = addmethod2pos(obj3150, "size", &meth_collectionsPrelude_size3155, 4);
  int argcv_meth_collectionsPrelude_size3155[] = {0};
  meth_meth_collectionsPrelude_size3155->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size3155);
  meth_meth_collectionsPrelude_size3155->definitionModule = modulename;
  meth_meth_collectionsPrelude_size3155->definitionLine = 1521;
// method "at(_)put(_)"
  block_savedest(obj3150);
  Object closure3158 = createclosure(3, "at(1)put(1)");
  setclosureframe(closure3158, stackframe);
  addtoclosure(closure3158, var_removed);
  addtoclosure(closure3158, var_unused);
  addtoclosure(closure3158, var_binding);
  struct UserObject *uo3158 = (struct UserObject*)obj3150;
  uo3158->data[5] = (Object)closure3158;
  Method *meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3158 = addmethod2pos(obj3150, "at(1)put(1)", &meth_collectionsPrelude_at_40_1_41_put_40_1_41_3158, 5);
  int argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3158[] = {1, 1};
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3158->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3158);
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3158->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3158->definitionLine = 1522;
// method "add(_)"
  block_savedest(obj3150);
  Object closure3217 = createclosure(2, "add(1)");
  setclosureframe(closure3217, stackframe);
  addtoclosure(closure3217, var_removed);
  addtoclosure(closure3217, var_unused);
  struct UserObject *uo3217 = (struct UserObject*)obj3150;
  uo3217->data[6] = (Object)closure3217;
  Method *meth_meth_collectionsPrelude_add_40_1_41_3217 = addmethod2pos(obj3150, "add(1)", &meth_collectionsPrelude_add_40_1_41_3217, 6);
  int argcv_meth_collectionsPrelude_add_40_1_41_3217[] = {1};
  meth_meth_collectionsPrelude_add_40_1_41_3217->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add_40_1_41_3217);
  meth_meth_collectionsPrelude_add_40_1_41_3217->definitionModule = modulename;
  meth_meth_collectionsPrelude_add_40_1_41_3217->definitionLine = 1532;
// method "at(_)"
  block_savedest(obj3150);
  Object closure3276 = createclosure(1, "at(1)");
  setclosureframe(closure3276, stackframe);
  addtoclosure(closure3276, var_NoSuchObject);
  struct UserObject *uo3276 = (struct UserObject*)obj3150;
  uo3276->data[7] = (Object)closure3276;
  Method *meth_meth_collectionsPrelude_at_40_1_41_3276 = addmethod2pos(obj3150, "at(1)", &meth_collectionsPrelude_at_40_1_41_3276, 7);
  int argcv_meth_collectionsPrelude_at_40_1_41_3276[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_3276->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_3276);
  meth_meth_collectionsPrelude_at_40_1_41_3276->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_3276->definitionLine = 1542;
// method "at(_)ifAbsent(_)"
  struct UserObject *uo3301 = (struct UserObject*)obj3150;
  uo3301->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3301 = addmethod2pos(obj3150, "at(1)ifAbsent(1)", &meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3301, 8);
  int argcv_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3301[] = {1, 1};
  meth_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3301->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3301);
  meth_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3301->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3301->definitionLine = 1549;
// method "containsKey(_)"
  struct UserObject *uo3318 = (struct UserObject*)obj3150;
  uo3318->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_containsKey_40_1_41_3318 = addmethod2pos(obj3150, "containsKey(1)", &meth_collectionsPrelude_containsKey_40_1_41_3318, 9);
  int argcv_meth_collectionsPrelude_containsKey_40_1_41_3318[] = {1};
  meth_meth_collectionsPrelude_containsKey_40_1_41_3318->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_containsKey_40_1_41_3318);
  meth_meth_collectionsPrelude_containsKey_40_1_41_3318->definitionModule = modulename;
  meth_meth_collectionsPrelude_containsKey_40_1_41_3318->definitionLine = 1556;
// method "removeAllKeys(_)"
  block_savedest(obj3150);
  Object closure3333 = createclosure(2, "removeAllKeys(1)");
  setclosureframe(closure3333, stackframe);
  addtoclosure(closure3333, var_removed);
  addtoclosure(closure3333, var_NoSuchObject);
  struct UserObject *uo3333 = (struct UserObject*)obj3150;
  uo3333->data[10] = (Object)closure3333;
  Method *meth_meth_collectionsPrelude_removeAllKeys_40_1_41_3333 = addmethod2pos(obj3150, "removeAllKeys(1)", &meth_collectionsPrelude_removeAllKeys_40_1_41_3333, 10);
  int argcv_meth_collectionsPrelude_removeAllKeys_40_1_41_3333[] = {1};
  meth_meth_collectionsPrelude_removeAllKeys_40_1_41_3333->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAllKeys_40_1_41_3333);
  meth_meth_collectionsPrelude_removeAllKeys_40_1_41_3333->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAllKeys_40_1_41_3333->definitionLine = 1563;
// method "removeKey(_)"
  block_savedest(obj3150);
  Object closure3381 = createclosure(2, "removeKey(1)");
  setclosureframe(closure3381, stackframe);
  addtoclosure(closure3381, var_removed);
  addtoclosure(closure3381, var_NoSuchObject);
  struct UserObject *uo3381 = (struct UserObject*)obj3150;
  uo3381->data[11] = (Object)closure3381;
  Method *meth_meth_collectionsPrelude_removeKey_40_1_41_3381 = addmethod2pos(obj3150, "removeKey(1)", &meth_collectionsPrelude_removeKey_40_1_41_3381, 11);
  int argcv_meth_collectionsPrelude_removeKey_40_1_41_3381[] = {1};
  meth_meth_collectionsPrelude_removeKey_40_1_41_3381->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeKey_40_1_41_3381);
  meth_meth_collectionsPrelude_removeKey_40_1_41_3381->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeKey_40_1_41_3381->definitionLine = 1576;
// method "removeAllValues(_)"
  block_savedest(obj3150);
  Object closure3424 = createclosure(1, "removeAllValues(1)");
  setclosureframe(closure3424, stackframe);
  addtoclosure(closure3424, var_removed);
  struct UserObject *uo3424 = (struct UserObject*)obj3150;
  uo3424->data[12] = (Object)closure3424;
  Method *meth_meth_collectionsPrelude_removeAllValues_40_1_41_3424 = addmethod2pos(obj3150, "removeAllValues(1)", &meth_collectionsPrelude_removeAllValues_40_1_41_3424, 12);
  int argcv_meth_collectionsPrelude_removeAllValues_40_1_41_3424[] = {1};
  meth_meth_collectionsPrelude_removeAllValues_40_1_41_3424->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAllValues_40_1_41_3424);
  meth_meth_collectionsPrelude_removeAllValues_40_1_41_3424->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAllValues_40_1_41_3424->definitionLine = 1587;
// method "removeValue(_)"
  block_savedest(obj3150);
  Object closure3471 = createclosure(2, "removeValue(1)");
  setclosureframe(closure3471, stackframe);
  addtoclosure(closure3471, var_removed);
  addtoclosure(closure3471, var_NoSuchObject);
  struct UserObject *uo3471 = (struct UserObject*)obj3150;
  uo3471->data[13] = (Object)closure3471;
  Method *meth_meth_collectionsPrelude_removeValue_40_1_41_3471 = addmethod2pos(obj3150, "removeValue(1)", &meth_collectionsPrelude_removeValue_40_1_41_3471, 13);
  int argcv_meth_collectionsPrelude_removeValue_40_1_41_3471[] = {1};
  meth_meth_collectionsPrelude_removeValue_40_1_41_3471->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeValue_40_1_41_3471);
  meth_meth_collectionsPrelude_removeValue_40_1_41_3471->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeValue_40_1_41_3471->definitionLine = 1598;
// method "removeValue(_)ifAbsent(_)"
  block_savedest(obj3150);
  Object closure3537 = createclosure(1, "removeValue(1)ifAbsent(1)");
  setclosureframe(closure3537, stackframe);
  addtoclosure(closure3537, var_removed);
  struct UserObject *uo3537 = (struct UserObject*)obj3150;
  uo3537->data[14] = (Object)closure3537;
  Method *meth_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3537 = addmethod2pos(obj3150, "removeValue(1)ifAbsent(1)", &meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3537, 14);
  int argcv_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3537[] = {1, 1};
  meth_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3537->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3537);
  meth_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3537->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3537->definitionLine = 1614;
// method "clear"
  block_savedest(obj3150);
  Object closure3595 = createclosure(2, "clear");
  setclosureframe(closure3595, stackframe);
  addtoclosure(closure3595, var__prelude);
  addtoclosure(closure3595, var_unused);
  struct UserObject *uo3595 = (struct UserObject*)obj3150;
  uo3595->data[15] = (Object)closure3595;
  Method *meth_meth_collectionsPrelude_clear3595 = addmethod2pos(obj3150, "clear", &meth_collectionsPrelude_clear3595, 15);
  int argcv_meth_collectionsPrelude_clear3595[] = {0};
  meth_meth_collectionsPrelude_clear3595->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_clear3595);
  meth_meth_collectionsPrelude_clear3595->definitionModule = modulename;
  meth_meth_collectionsPrelude_clear3595->definitionLine = 1630;
// method "containsValue(_)"
  struct UserObject *uo3635 = (struct UserObject*)obj3150;
  uo3635->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_containsValue_40_1_41_3635 = addmethod2pos(obj3150, "containsValue(1)", &meth_collectionsPrelude_containsValue_40_1_41_3635, 16);
  int argcv_meth_collectionsPrelude_containsValue_40_1_41_3635[] = {1};
  meth_meth_collectionsPrelude_containsValue_40_1_41_3635->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_containsValue_40_1_41_3635);
  meth_meth_collectionsPrelude_containsValue_40_1_41_3635->definitionModule = modulename;
  meth_meth_collectionsPrelude_containsValue_40_1_41_3635->definitionLine = 1639;
// method "contains(_)"
  struct UserObject *uo3647 = (struct UserObject*)obj3150;
  uo3647->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_3647 = addmethod2pos(obj3150, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_3647, 17);
  int argcv_meth_collectionsPrelude_contains_40_1_41_3647[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_3647->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_3647);
  meth_meth_collectionsPrelude_contains_40_1_41_3647->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_3647->definitionLine = 1645;
// method "findPosition(_)"
  block_savedest(obj3150);
  Object closure3650 = createclosure(1, "findPosition(1)");
  setclosureframe(closure3650, stackframe);
  addtoclosure(closure3650, var_unused);
  struct UserObject *uo3650 = (struct UserObject*)obj3150;
  uo3650->data[18] = (Object)closure3650;
  Method *meth_meth_collectionsPrelude_findPosition_40_1_41_3650 = addmethod2pos(obj3150, "findPosition(1)", &meth_collectionsPrelude_findPosition_40_1_41_3650, 18);
  int argcv_meth_collectionsPrelude_findPosition_40_1_41_3650[] = {1};
  meth_meth_collectionsPrelude_findPosition_40_1_41_3650->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPosition_40_1_41_3650);
  meth_meth_collectionsPrelude_findPosition_40_1_41_3650->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPosition_40_1_41_3650->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPosition_40_1_41_3650->definitionLine = 1647;
// method "findPositionForAdd(_)"
  block_savedest(obj3150);
  Object closure3716 = createclosure(2, "findPositionForAdd(1)");
  setclosureframe(closure3716, stackframe);
  addtoclosure(closure3716, var_removed);
  addtoclosure(closure3716, var_unused);
  struct UserObject *uo3716 = (struct UserObject*)obj3150;
  uo3716->data[19] = (Object)closure3716;
  Method *meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3716 = addmethod2pos(obj3150, "findPositionForAdd(1)", &meth_collectionsPrelude_findPositionForAdd_40_1_41_3716, 19);
  int argcv_meth_collectionsPrelude_findPositionForAdd_40_1_41_3716[] = {1};
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3716->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPositionForAdd_40_1_41_3716);
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3716->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3716->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3716->definitionLine = 1665;
// method "asString"
  block_savedest(obj3150);
  Object closure3792 = createclosure(2, "asString");
  setclosureframe(closure3792, stackframe);
  addtoclosure(closure3792, var_removed);
  addtoclosure(closure3792, var_unused);
  struct UserObject *uo3792 = (struct UserObject*)obj3150;
  uo3792->data[20] = (Object)closure3792;
  Method *meth_meth_collectionsPrelude_asString3792 = addmethod2pos(obj3150, "asString", &meth_collectionsPrelude_asString3792, 20);
  int argcv_meth_collectionsPrelude_asString3792[] = {0};
  meth_meth_collectionsPrelude_asString3792->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3792);
  meth_meth_collectionsPrelude_asString3792->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3792->definitionLine = 1683;
// method "asDebugString"
  block_savedest(obj3150);
  Object closure3863 = createclosure(2, "asDebugString");
  setclosureframe(closure3863, stackframe);
  addtoclosure(closure3863, var_removed);
  addtoclosure(closure3863, var_unused);
  struct UserObject *uo3863 = (struct UserObject*)obj3150;
  uo3863->data[21] = (Object)closure3863;
  Method *meth_meth_collectionsPrelude_asDebugString3863 = addmethod2pos(obj3150, "asDebugString", &meth_collectionsPrelude_asDebugString3863, 21);
  int argcv_meth_collectionsPrelude_asDebugString3863[] = {0};
  meth_meth_collectionsPrelude_asDebugString3863->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3863);
  meth_meth_collectionsPrelude_asDebugString3863->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3863->definitionLine = 1701;
// method "keys"
  block_savedest(obj3150);
  Object closure3961 = createclosure(1, "keys");
  setclosureframe(closure3961, stackframe);
  addtoclosure(closure3961, var_enumerable);
  struct UserObject *uo3961 = (struct UserObject*)obj3150;
  uo3961->data[22] = (Object)closure3961;
  Method *meth_meth_collectionsPrelude_keys3961 = addmethod2pos(obj3150, "keys", &meth_collectionsPrelude_keys3961, 22);
  int argcv_meth_collectionsPrelude_keys3961[] = {0};
  meth_meth_collectionsPrelude_keys3961->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys3961);
  meth_meth_collectionsPrelude_keys3961->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys3961->definitionLine = 1714;
  block_savedest(obj3150);
  Object closure4006 = createclosure(1, "keys$object(1)");
  setclosureframe(closure4006, stackframe);
  addtoclosure(closure4006, var_enumerable);
  Method *meth_meth_collectionsPrelude_keys3961_object = addmethod2pos(obj3150, "keys$object(1)", &meth_collectionsPrelude_keys3961_object, 22);
  meth_meth_collectionsPrelude_keys3961_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys3961_object->definitionLine = 1714;
// method "values"
  block_savedest(obj3150);
  Object closure4007 = createclosure(1, "values");
  setclosureframe(closure4007, stackframe);
  addtoclosure(closure4007, var_enumerable);
  struct UserObject *uo4007 = (struct UserObject*)obj3150;
  uo4007->data[23] = (Object)closure4007;
  Method *meth_meth_collectionsPrelude_values4007 = addmethod2pos(obj3150, "values", &meth_collectionsPrelude_values4007, 23);
  int argcv_meth_collectionsPrelude_values4007[] = {0};
  meth_meth_collectionsPrelude_values4007->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values4007);
  meth_meth_collectionsPrelude_values4007->definitionModule = modulename;
  meth_meth_collectionsPrelude_values4007->definitionLine = 1732;
  block_savedest(obj3150);
  Object closure4052 = createclosure(1, "values$object(1)");
  setclosureframe(closure4052, stackframe);
  addtoclosure(closure4052, var_enumerable);
  Method *meth_meth_collectionsPrelude_values4007_object = addmethod2pos(obj3150, "values$object(1)", &meth_collectionsPrelude_values4007_object, 23);
  meth_meth_collectionsPrelude_values4007_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_values4007_object->definitionLine = 1732;
// method "bindings"
  block_savedest(obj3150);
  Object closure4053 = createclosure(1, "bindings");
  setclosureframe(closure4053, stackframe);
  addtoclosure(closure4053, var_enumerable);
  struct UserObject *uo4053 = (struct UserObject*)obj3150;
  uo4053->data[24] = (Object)closure4053;
  Method *meth_meth_collectionsPrelude_bindings4053 = addmethod2pos(obj3150, "bindings", &meth_collectionsPrelude_bindings4053, 24);
  int argcv_meth_collectionsPrelude_bindings4053[] = {0};
  meth_meth_collectionsPrelude_bindings4053->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_bindings4053);
  meth_meth_collectionsPrelude_bindings4053->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindings4053->definitionLine = 1751;
  block_savedest(obj3150);
  Object closure4073 = createclosure(1, "bindings$object(1)");
  setclosureframe(closure4073, stackframe);
  addtoclosure(closure4073, var_enumerable);
  Method *meth_meth_collectionsPrelude_bindings4053_object = addmethod2pos(obj3150, "bindings$object(1)", &meth_collectionsPrelude_bindings4053_object, 24);
  meth_meth_collectionsPrelude_bindings4053_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindings4053_object->definitionLine = 1751;
// method "iterator"
  struct UserObject *uo4074 = (struct UserObject*)obj3150;
  uo4074->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator4074 = addmethod2pos(obj3150, "iterator", &meth_collectionsPrelude_iterator4074, 25);
  int argcv_meth_collectionsPrelude_iterator4074[] = {0};
  meth_meth_collectionsPrelude_iterator4074->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4074);
  meth_meth_collectionsPrelude_iterator4074->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4074->definitionLine = 1763;
// method "bindingsIterator"
  block_savedest(obj3150);
  Object closure4079 = createclosure(4, "bindingsIterator");
  setclosureframe(closure4079, stackframe);
  addtoclosure(closure4079, var_ConcurrentModification);
  addtoclosure(closure4079, var_IteratorExhausted);
  addtoclosure(closure4079, var_removed);
  addtoclosure(closure4079, var_unused);
  struct UserObject *uo4079 = (struct UserObject*)obj3150;
  uo4079->data[26] = (Object)closure4079;
  Method *meth_meth_collectionsPrelude_bindingsIterator4079 = addmethod2pos(obj3150, "bindingsIterator", &meth_collectionsPrelude_bindingsIterator4079, 26);
  int argcv_meth_collectionsPrelude_bindingsIterator4079[] = {0};
  meth_meth_collectionsPrelude_bindingsIterator4079->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_bindingsIterator4079);
  meth_meth_collectionsPrelude_bindingsIterator4079->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindingsIterator4079->definitionLine = 1764;
  block_savedest(obj3150);
  Object closure4200 = createclosure(4, "bindingsIterator$object(1)");
  setclosureframe(closure4200, stackframe);
  addtoclosure(closure4200, var_ConcurrentModification);
  addtoclosure(closure4200, var_IteratorExhausted);
  addtoclosure(closure4200, var_removed);
  addtoclosure(closure4200, var_unused);
  Method *meth_meth_collectionsPrelude_bindingsIterator4079_object = addmethod2pos(obj3150, "bindingsIterator$object(1)", &meth_collectionsPrelude_bindingsIterator4079_object, 26);
  meth_meth_collectionsPrelude_bindingsIterator4079_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindingsIterator4079_object->definitionLine = 1764;
// method "expand"
  block_savedest(obj3150);
  Object closure4201 = createclosure(3, "expand");
  setclosureframe(closure4201, stackframe);
  addtoclosure(closure4201, var__prelude);
  addtoclosure(closure4201, var_unused);
  addtoclosure(closure4201, var_removed);
  struct UserObject *uo4201 = (struct UserObject*)obj3150;
  uo4201->data[27] = (Object)closure4201;
  Method *meth_meth_collectionsPrelude_expand4201 = addmethod2pos(obj3150, "expand", &meth_collectionsPrelude_expand4201, 27);
  int argcv_meth_collectionsPrelude_expand4201[] = {0};
  meth_meth_collectionsPrelude_expand4201->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expand4201);
  meth_meth_collectionsPrelude_expand4201->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expand4201->definitionModule = modulename;
  meth_meth_collectionsPrelude_expand4201->definitionLine = 1787;
// method "keysAndValuesDo(_)"
  block_savedest(obj3150);
  Object closure4269 = createclosure(2, "keysAndValuesDo(1)");
  setclosureframe(closure4269, stackframe);
  addtoclosure(closure4269, var_removed);
  addtoclosure(closure4269, var_unused);
  struct UserObject *uo4269 = (struct UserObject*)obj3150;
  uo4269->data[28] = (Object)closure4269;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4269 = addmethod2pos(obj3150, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_4269, 28);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4269[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4269->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4269);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4269->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4269->definitionLine = 1803;
// method "keysDo(_)"
  block_savedest(obj3150);
  Object closure4307 = createclosure(2, "keysDo(1)");
  setclosureframe(closure4307, stackframe);
  addtoclosure(closure4307, var_removed);
  addtoclosure(closure4307, var_unused);
  struct UserObject *uo4307 = (struct UserObject*)obj3150;
  uo4307->data[29] = (Object)closure4307;
  Method *meth_meth_collectionsPrelude_keysDo_40_1_41_4307 = addmethod2pos(obj3150, "keysDo(1)", &meth_collectionsPrelude_keysDo_40_1_41_4307, 29);
  int argcv_meth_collectionsPrelude_keysDo_40_1_41_4307[] = {1};
  meth_meth_collectionsPrelude_keysDo_40_1_41_4307->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysDo_40_1_41_4307);
  meth_meth_collectionsPrelude_keysDo_40_1_41_4307->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysDo_40_1_41_4307->definitionLine = 1811;
// method "valuesDo(_)"
  block_savedest(obj3150);
  Object closure4343 = createclosure(2, "valuesDo(1)");
  setclosureframe(closure4343, stackframe);
  addtoclosure(closure4343, var_removed);
  addtoclosure(closure4343, var_unused);
  struct UserObject *uo4343 = (struct UserObject*)obj3150;
  uo4343->data[30] = (Object)closure4343;
  Method *meth_meth_collectionsPrelude_valuesDo_40_1_41_4343 = addmethod2pos(obj3150, "valuesDo(1)", &meth_collectionsPrelude_valuesDo_40_1_41_4343, 30);
  int argcv_meth_collectionsPrelude_valuesDo_40_1_41_4343[] = {1};
  meth_meth_collectionsPrelude_valuesDo_40_1_41_4343->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_valuesDo_40_1_41_4343);
  meth_meth_collectionsPrelude_valuesDo_40_1_41_4343->definitionModule = modulename;
  meth_meth_collectionsPrelude_valuesDo_40_1_41_4343->definitionLine = 1819;
// method "do(_)"
  struct UserObject *uo4379 = (struct UserObject*)obj3150;
  uo4379->data[31] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_4379 = addmethod2pos(obj3150, "do(1)", &meth_collectionsPrelude_do_40_1_41_4379, 31);
  int argcv_meth_collectionsPrelude_do_40_1_41_4379[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_4379->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_4379);
  meth_meth_collectionsPrelude_do_40_1_41_4379->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_4379->definitionLine = 1827;
// method "==(_)"
  block_savedest(obj3150);
  Object closure4382 = createclosure(1, "==(1)");
  setclosureframe(closure4382, stackframe);
  addtoclosure(closure4382, var_ComparableToDictionary);
  struct UserObject *uo4382 = (struct UserObject*)obj3150;
  uo4382->data[32] = (Object)closure4382;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_4382 = addmethod2pos(obj3150, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_4382, 32);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_4382[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_4382->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_4382);
  meth_meth_collectionsPrelude__61__61__40_1_41_4382->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_4382->definitionLine = 1829;
// method "copy"
  struct UserObject *uo4426 = (struct UserObject*)obj3150;
  uo4426->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy4426 = addmethod2pos(obj3150, "copy", &meth_collectionsPrelude_copy4426, 33);
  int argcv_meth_collectionsPrelude_copy4426[] = {0};
  meth_meth_collectionsPrelude_copy4426->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy4426);
  meth_meth_collectionsPrelude_copy4426->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy4426->definitionLine = 1845;
// method "asDictionary"
  struct UserObject *uo4442 = (struct UserObject*)obj3150;
  uo4442->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary4442 = addmethod2pos(obj3150, "asDictionary", &meth_collectionsPrelude_asDictionary4442, 34);
  int argcv_meth_collectionsPrelude_asDictionary4442[] = {0};
  meth_meth_collectionsPrelude_asDictionary4442->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary4442);
  meth_meth_collectionsPrelude_asDictionary4442->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary4442->definitionLine = 1853;
// method "++(_)"
  struct UserObject *uo4443 = (struct UserObject*)obj3150;
  uo4443->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_4443 = addmethod2pos(obj3150, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_4443, 35);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_4443[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_4443->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_4443);
  meth_meth_collectionsPrelude__43__43__40_1_41_4443->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_4443->definitionLine = 1857;
// method "--(_)"
  struct UserObject *uo4453 = (struct UserObject*)obj3150;
  uo4453->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude__45__45__40_1_41_4453 = addmethod2pos(obj3150, "--(1)", &meth_collectionsPrelude__45__45__40_1_41_4453, 36);
  int argcv_meth_collectionsPrelude__45__45__40_1_41_4453[] = {1};
  meth_meth_collectionsPrelude__45__45__40_1_41_4453->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__45__45__40_1_41_4453);
  meth_meth_collectionsPrelude__45__45__40_1_41_4453->definitionModule = modulename;
  meth_meth_collectionsPrelude__45__45__40_1_41_4453->definitionLine = 1865;
  sourceObject = obj3150;
// Begin line 1514
  setline(1514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4474 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4475 = callmethodflags(*var_collection, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4474);
// compiled call node returning call4475 (depth = 2)
  struct UserObject *obj3150_uo = (struct UserObject *)obj3150;
  obj3150_uo->super = call4475;
  sourceObject = obj3150;
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4476 = alloc_Float64(0);
// compiled num node returning num4476 (depth = 2)
  adddatum2(obj3150, num4476, 1);
  sourceObject = obj3150;
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4477 = alloc_Float64(0);
// compiled num node returning num4477 (depth = 2)
  adddatum2(obj3150, num4477, 2);
  sourceObject = obj3150;
// Begin line 1517
  setline(1517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4478 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num4479 = alloc_Float64(8);
// compiled num node returning num4479 (depth = 3)
  gc_frame_newslot(num4479);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4480 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__prelude (depth = 4)
  Object call4481 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe4480);
// compiled member node returning call4481 (depth = 3)
  params[0] = num4479;
  partcv[0] = 1;
  Object call4482 = callmethodflags(call4481, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4478);
// compiled call node returning call4482 (depth = 2)
  adddatum2(obj3150, call4482, 3);
  sourceObject = obj3150;
// Begin line 1518
  setline(1518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4483 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4486 = alloc_Float64(1);
// compiled num node returning num4486 (depth = 5)
  int op_slot_right_4485 = gc_frame_newslot(num4486);
// starting to compile member node (depth = 5)
  int callframe4488 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4489 = gc_frame_new();
// call case 4: self request
  Object call4490 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4489);
// compiled member node returning call4490 (depth = 6)
  Object call4491 = callmethodflags(call4490, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4488);
// compiled member node returning call4491 (depth = 5)
  int op_slot_left_4485 = gc_frame_newslot(call4491);
  params[0] = num4486;
  partcv[0] = 1;
  Object diff4492 = callmethod(call4491, "-(1)", 1, partcv, params);
// compiled op node returning diff4492 (depth = 4)
  int op_slot_right_4484 = gc_frame_newslot(diff4492);
// starting to compile num node (depth = 4)
  Object num4494 = alloc_Float64(0);
// compiled num node returning num4494 (depth = 4)
  int op_slot_left_4484 = gc_frame_newslot(num4494);
  params[0] = diff4492;
  partcv[0] = 1;
  Object opresult4495 = callmethod(num4494, "..(1)", 1, partcv, params);
// compiled op node returning opresult4495 (depth = 3)
  gc_frame_newslot(opresult4495);
// starting to compile block node (depth = 3)
  Object block4496 = alloc_Block(NULL, NULL, "collectionsPrelude", 1518);
  gc_frame_newslot(block4496);
// method "_apply(_)"
  block_savedest(block4496);
  Object closure4497 = createclosure(2, "_apply(1)");
  setclosureframe(closure4497, stackframe);
  addtoclosure(closure4497, var_unused);
  addtoclosure(closure4497, selfslot);
  struct UserObject *uo4497 = (struct UserObject*)block4496;
  uo4497->data[0] = (Object)closure4497;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4497 = addmethod2pos(block4496, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4497, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4497[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4497->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4497);
  meth_meth_collectionsPrelude__apply_40_1_41_4497->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4497->definitionLine = 1991;
// compiled block node returning block4496 (depth = 3)
  gc_frame_newslot(block4496);
// call case 5: prelude request
  params[0] = opresult4495;
  params[1] = block4496;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4503 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4483);
// compiled call node returning call4503 (depth = 2)
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  sourceObject = obj3150;
  objclass3150 = obj3150->class;
  objclass3150->definitionModule = modulename;
  objclass3150->definitionLine = 1513;
  (*(struct UserObject *)self).data[0] = lowerouter3150;
  self = oldself3150;
  selfslot = oldselfslot3150;
  stackframe = oldstackframe3150;
  gc_frame_end(frame);
  return obj3150;
}
Object meth_collectionsPrelude_dictionary3134(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  Object *var_NoSuchObject = getfromclosure(closure, 3);
  Object *var__prelude = getfromclosure(closure, 4);
  Object *var_enumerable = getfromclosure(closure, 5);
  Object *var_ConcurrentModification = getfromclosure(closure, 6);
  Object *var_IteratorExhausted = getfromclosure(closure, 7);
  Object *var_ComparableToDictionary = getfromclosure(closure, 8);
  Object *var_collection = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_K = &(stackframe->slots[1]);
  Object *var_T = &(stackframe->slots[2]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_K = args[curarg++];
    *var_T = args[curarg++];
  } else {
    *var_K = Unknown;
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3135 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3135 = alloc_userobj2(4,5, objclass3135);
  gc_frame_newslot(obj3135);
if (objclass3135 == NULL) {
  glfree(obj3135->class->name);
  obj3135->class->name = "dictionary";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3135, self, 0);
  addmethodreal(obj3135,"outer", &reader_collectionsPrelude_outer_3136);
  Object oldself3135 = self;
  struct StackFrameObject *oldstackframe3135 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3135);
  gc_frame_newslot((Object)stackframe);
  self = obj3135;
  Object *oldselfslot3135 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3135 = (*(struct UserObject *)self).data[0], lowerouter3135 = thisouter3135;
  if (inheritingObject3135) {
    struct UserObject *inho3135 = (struct UserObject *)inheritingObject3135;
    while (inho3135->super != GraceDefaultObject) inho3135 = (struct UserObject *)inho3135->super;
    inho3135->super = obj3135;
    self = inheritingObject3135;
    *selfslot = self;
    lowerouter3135 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3135;
  }
// method "asString"
  struct UserObject *uo3137 = (struct UserObject*)obj3135;
  uo3137->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString3137 = addmethod2pos(obj3135, "asString", &meth_collectionsPrelude_asString3137, 1);
  int argcv_meth_collectionsPrelude_asString3137[] = {0};
  meth_meth_collectionsPrelude_asString3137->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3137);
  meth_meth_collectionsPrelude_asString3137->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3137->definitionLine = 1505;
// method "withAll(_)"
  struct UserObject *uo3139 = (struct UserObject*)obj3135;
  uo3139->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_3139 = addmethod2pos(obj3135, "withAll(1)", &meth_collectionsPrelude_withAll_40_1_41_3139, 2);
  int argcv_meth_collectionsPrelude_withAll_40_1_41_3139[] = {1};
  meth_meth_collectionsPrelude_withAll_40_1_41_3139->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll_40_1_41_3139);
  meth_meth_collectionsPrelude_withAll_40_1_41_3139->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_3139->definitionLine = 1507;
// method "empty"
  block_savedest(obj3135);
  Object closure3149 = createclosure(10, "empty");
  setclosureframe(closure3149, stackframe);
  addtoclosure(closure3149, var_removed);
  addtoclosure(closure3149, var_unused);
  addtoclosure(closure3149, var_binding);
  addtoclosure(closure3149, var_NoSuchObject);
  addtoclosure(closure3149, var__prelude);
  addtoclosure(closure3149, var_enumerable);
  addtoclosure(closure3149, var_ConcurrentModification);
  addtoclosure(closure3149, var_IteratorExhausted);
  addtoclosure(closure3149, var_ComparableToDictionary);
  addtoclosure(closure3149, var_collection);
  struct UserObject *uo3149 = (struct UserObject*)obj3135;
  uo3149->data[3] = (Object)closure3149;
  Method *meth_meth_collectionsPrelude_empty3149 = addmethod2pos(obj3135, "empty", &meth_collectionsPrelude_empty3149, 3);
  int argcv_meth_collectionsPrelude_empty3149[] = {0};
  meth_meth_collectionsPrelude_empty3149->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty3149);
  meth_meth_collectionsPrelude_empty3149->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty3149->definitionLine = 1513;
  block_savedest(obj3135);
  Object closure4504 = createclosure(10, "empty$object(1)");
  setclosureframe(closure4504, stackframe);
  addtoclosure(closure4504, var_removed);
  addtoclosure(closure4504, var_unused);
  addtoclosure(closure4504, var_binding);
  addtoclosure(closure4504, var_NoSuchObject);
  addtoclosure(closure4504, var__prelude);
  addtoclosure(closure4504, var_enumerable);
  addtoclosure(closure4504, var_ConcurrentModification);
  addtoclosure(closure4504, var_IteratorExhausted);
  addtoclosure(closure4504, var_ComparableToDictionary);
  addtoclosure(closure4504, var_collection);
  Method *meth_meth_collectionsPrelude_empty3149_object = addmethod2pos(obj3135, "empty$object(1)", &meth_collectionsPrelude_empty3149_object, 3);
  meth_meth_collectionsPrelude_empty3149_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty3149_object->definitionLine = 1513;
  sourceObject = obj3135;
  sourceObject = obj3135;
  sourceObject = obj3135;
  objclass3135 = obj3135->class;
  objclass3135->definitionModule = modulename;
  objclass3135->definitionLine = 1503;
  (*(struct UserObject *)self).data[0] = lowerouter3135;
  self = oldself3135;
  selfslot = oldselfslot3135;
  stackframe = oldstackframe3135;
  gc_frame_end(frame);
  return obj3135;
}
Object meth_collectionsPrelude_dictionary3134_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dictionary$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  Object *var_NoSuchObject = getfromclosure(closure, 3);
  Object *var__prelude = getfromclosure(closure, 4);
  Object *var_enumerable = getfromclosure(closure, 5);
  Object *var_ConcurrentModification = getfromclosure(closure, 6);
  Object *var_IteratorExhausted = getfromclosure(closure, 7);
  Object *var_ComparableToDictionary = getfromclosure(closure, 8);
  Object *var_collection = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_K = &(stackframe->slots[1]);
  Object *var_T = &(stackframe->slots[2]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_K = args[curarg++];
    *var_T = args[curarg++];
  } else {
    *var_K = Unknown;
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3135 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3135 = alloc_userobj2(4,5, objclass3135);
  gc_frame_newslot(obj3135);
if (objclass3135 == NULL) {
  glfree(obj3135->class->name);
  obj3135->class->name = "dictionary";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3135, self, 0);
  addmethodreal(obj3135,"outer", &reader_collectionsPrelude_outer_3136);
  Object oldself3135 = self;
  struct StackFrameObject *oldstackframe3135 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3135);
  gc_frame_newslot((Object)stackframe);
  self = obj3135;
  Object *oldselfslot3135 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3135 = (*(struct UserObject *)self).data[0], lowerouter3135 = thisouter3135;
  if (inheritingObject3135) {
    struct UserObject *inho3135 = (struct UserObject *)inheritingObject3135;
    while (inho3135->super != GraceDefaultObject) inho3135 = (struct UserObject *)inho3135->super;
    inho3135->super = obj3135;
    self = inheritingObject3135;
    *selfslot = self;
    lowerouter3135 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3135;
  }
// method "asString"
  struct UserObject *uo3137 = (struct UserObject*)obj3135;
  uo3137->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString3137 = addmethod2pos(obj3135, "asString", &meth_collectionsPrelude_asString3137, 1);
  int argcv_meth_collectionsPrelude_asString3137[] = {0};
  meth_meth_collectionsPrelude_asString3137->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3137);
  meth_meth_collectionsPrelude_asString3137->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3137->definitionLine = 1505;
// method "withAll(_)"
  struct UserObject *uo3139 = (struct UserObject*)obj3135;
  uo3139->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_3139 = addmethod2pos(obj3135, "withAll(1)", &meth_collectionsPrelude_withAll_40_1_41_3139, 2);
  int argcv_meth_collectionsPrelude_withAll_40_1_41_3139[] = {1};
  meth_meth_collectionsPrelude_withAll_40_1_41_3139->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll_40_1_41_3139);
  meth_meth_collectionsPrelude_withAll_40_1_41_3139->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_3139->definitionLine = 1507;
// method "empty"
  block_savedest(obj3135);
  Object closure3149 = createclosure(10, "empty");
  setclosureframe(closure3149, stackframe);
  addtoclosure(closure3149, var_removed);
  addtoclosure(closure3149, var_unused);
  addtoclosure(closure3149, var_binding);
  addtoclosure(closure3149, var_NoSuchObject);
  addtoclosure(closure3149, var__prelude);
  addtoclosure(closure3149, var_enumerable);
  addtoclosure(closure3149, var_ConcurrentModification);
  addtoclosure(closure3149, var_IteratorExhausted);
  addtoclosure(closure3149, var_ComparableToDictionary);
  addtoclosure(closure3149, var_collection);
  struct UserObject *uo3149 = (struct UserObject*)obj3135;
  uo3149->data[3] = (Object)closure3149;
  Method *meth_meth_collectionsPrelude_empty3149 = addmethod2pos(obj3135, "empty", &meth_collectionsPrelude_empty3149, 3);
  int argcv_meth_collectionsPrelude_empty3149[] = {0};
  meth_meth_collectionsPrelude_empty3149->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty3149);
  meth_meth_collectionsPrelude_empty3149->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty3149->definitionLine = 1513;
  block_savedest(obj3135);
  Object closure4504 = createclosure(10, "empty$object(1)");
  setclosureframe(closure4504, stackframe);
  addtoclosure(closure4504, var_removed);
  addtoclosure(closure4504, var_unused);
  addtoclosure(closure4504, var_binding);
  addtoclosure(closure4504, var_NoSuchObject);
  addtoclosure(closure4504, var__prelude);
  addtoclosure(closure4504, var_enumerable);
  addtoclosure(closure4504, var_ConcurrentModification);
  addtoclosure(closure4504, var_IteratorExhausted);
  addtoclosure(closure4504, var_ComparableToDictionary);
  addtoclosure(closure4504, var_collection);
  Method *meth_meth_collectionsPrelude_empty3149_object = addmethod2pos(obj3135, "empty$object(1)", &meth_collectionsPrelude_empty3149_object, 3);
  meth_meth_collectionsPrelude_empty3149_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty3149_object->definitionLine = 1513;
  sourceObject = obj3135;
  sourceObject = obj3135;
  sourceObject = obj3135;
  objclass3135 = obj3135->class;
  objclass3135->definitionModule = modulename;
  objclass3135->definitionLine = 1503;
  (*(struct UserObject *)self).data[0] = lowerouter3135;
  self = oldself3135;
  selfslot = oldselfslot3135;
  stackframe = oldstackframe3135;
  gc_frame_end(frame);
  return obj3135;
}
Object meth_collectionsPrelude__apply_40_1_41_4512(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___20 = &(stackframe->slots[0]);
  *var___20 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply_40_1_41_4524(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___21 = &(stackframe->slots[0]);
  *var___21 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe4525 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1882
  setline(1882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4528 == NULL) {
    strlit4528 = alloc_String(") is not an integer");
    gc_root(strlit4528);
  }
// compiled string node returning strlit4528 (depth = 7)
  int op_slot_right_4527 = gc_frame_newslot(strlit4528);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_4530 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4533 == NULL) {
    strlit4533 = alloc_String(")to(");
    gc_root(strlit4533);
  }
// compiled string node returning strlit4533 (depth = 9)
  int op_slot_right_4532 = gc_frame_newslot(strlit4533);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lower (depth = 10)
  int op_slot_right_4535 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 10)
  if (strlit4537 == NULL) {
    strlit4537 = alloc_String(" in range.from(");
    gc_root(strlit4537);
  }
// compiled string node returning strlit4537 (depth = 10)
  int op_slot_left_4535 = gc_frame_newslot(strlit4537);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4538 = callmethod(strlit4537, "++(1)", 1, partcv, params);
// compiled op node returning opresult4538 (depth = 9)
  int op_slot_left_4532 = gc_frame_newslot(opresult4538);
  params[0] = strlit4533;
  partcv[0] = 1;
  Object opresult4539 = callmethod(opresult4538, "++(1)", 1, partcv, params);
// compiled op node returning opresult4539 (depth = 8)
  int op_slot_left_4530 = gc_frame_newslot(opresult4539);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4540 = callmethod(opresult4539, "++(1)", 1, partcv, params);
// compiled op node returning opresult4540 (depth = 7)
  int op_slot_left_4527 = gc_frame_newslot(opresult4540);
  params[0] = strlit4528;
  partcv[0] = 1;
  Object opresult4541 = callmethod(opresult4540, "++(1)", 1, partcv, params);
// compiled op node returning opresult4541 (depth = 6)
  int op_slot_right_4526 = gc_frame_newslot(opresult4541);
// Begin line 1881
  setline(1881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4544 == NULL) {
    strlit4544 = alloc_String("");
    gc_root(strlit4544);
  }
// compiled string node returning strlit4544 (depth = 7)
  int op_slot_right_4543 = gc_frame_newslot(strlit4544);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_4546 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 8)
  if (strlit4548 == NULL) {
    strlit4548 = alloc_String("lower bound ");
    gc_root(strlit4548);
  }
// compiled string node returning strlit4548 (depth = 8)
  int op_slot_left_4546 = gc_frame_newslot(strlit4548);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4549 = callmethod(strlit4548, "++(1)", 1, partcv, params);
// compiled op node returning opresult4549 (depth = 7)
  int op_slot_left_4543 = gc_frame_newslot(opresult4549);
  params[0] = strlit4544;
  partcv[0] = 1;
  Object opresult4550 = callmethod(opresult4549, "++(1)", 1, partcv, params);
// compiled op node returning opresult4550 (depth = 6)
  int op_slot_left_4526 = gc_frame_newslot(opresult4550);
  params[0] = opresult4541;
  partcv[0] = 1;
  Object opresult4551 = callmethod(opresult4550, "++(1)", 1, partcv, params);
// compiled op node returning opresult4551 (depth = 5)
  gc_frame_newslot(opresult4551);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult4551;
  partcv[0] = 1;
  Object call4552 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4525);
// compiled call node returning call4552 (depth = 4)
  gc_frame_end(frame);
  return call4552;
}
Object meth_collectionsPrelude__apply_40_1_41_4590(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___22 = &(stackframe->slots[0]);
  *var___22 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply_40_1_41_4602(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___23 = &(stackframe->slots[0]);
  *var___23 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe4603 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4606 == NULL) {
    strlit4606 = alloc_String(") is not an integer");
    gc_root(strlit4606);
  }
// compiled string node returning strlit4606 (depth = 7)
  int op_slot_right_4605 = gc_frame_newslot(strlit4606);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_4608 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4611 == NULL) {
    strlit4611 = alloc_String(")to(");
    gc_root(strlit4611);
  }
// compiled string node returning strlit4611 (depth = 9)
  int op_slot_right_4610 = gc_frame_newslot(strlit4611);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lower (depth = 10)
  int op_slot_right_4613 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 10)
  if (strlit4615 == NULL) {
    strlit4615 = alloc_String(" in range.from(");
    gc_root(strlit4615);
  }
// compiled string node returning strlit4615 (depth = 10)
  int op_slot_left_4613 = gc_frame_newslot(strlit4615);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4616 = callmethod(strlit4615, "++(1)", 1, partcv, params);
// compiled op node returning opresult4616 (depth = 9)
  int op_slot_left_4610 = gc_frame_newslot(opresult4616);
  params[0] = strlit4611;
  partcv[0] = 1;
  Object opresult4617 = callmethod(opresult4616, "++(1)", 1, partcv, params);
// compiled op node returning opresult4617 (depth = 8)
  int op_slot_left_4608 = gc_frame_newslot(opresult4617);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4618 = callmethod(opresult4617, "++(1)", 1, partcv, params);
// compiled op node returning opresult4618 (depth = 7)
  int op_slot_left_4605 = gc_frame_newslot(opresult4618);
  params[0] = strlit4606;
  partcv[0] = 1;
  Object opresult4619 = callmethod(opresult4618, "++(1)", 1, partcv, params);
// compiled op node returning opresult4619 (depth = 6)
  int op_slot_right_4604 = gc_frame_newslot(opresult4619);
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4622 == NULL) {
    strlit4622 = alloc_String("");
    gc_root(strlit4622);
  }
// compiled string node returning strlit4622 (depth = 7)
  int op_slot_right_4621 = gc_frame_newslot(strlit4622);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_4624 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 8)
  if (strlit4626 == NULL) {
    strlit4626 = alloc_String("upper bound ");
    gc_root(strlit4626);
  }
// compiled string node returning strlit4626 (depth = 8)
  int op_slot_left_4624 = gc_frame_newslot(strlit4626);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4627 = callmethod(strlit4626, "++(1)", 1, partcv, params);
// compiled op node returning opresult4627 (depth = 7)
  int op_slot_left_4621 = gc_frame_newslot(opresult4627);
  params[0] = strlit4622;
  partcv[0] = 1;
  Object opresult4628 = callmethod(opresult4627, "++(1)", 1, partcv, params);
// compiled op node returning opresult4628 (depth = 6)
  int op_slot_left_4604 = gc_frame_newslot(opresult4628);
  params[0] = opresult4619;
  partcv[0] = 1;
  Object opresult4629 = callmethod(opresult4628, "++(1)", 1, partcv, params);
// compiled op node returning opresult4629 (depth = 5)
  gc_frame_newslot(opresult4629);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult4629;
  partcv[0] = 1;
  Object call4630 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4603);
// compiled call node returning call4630 (depth = 4)
  gc_frame_end(frame);
  return call4630;
}
Object meth_collectionsPrelude_from_40_1_41_to_40_1_41_4509(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "from(1)to(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method from(_)to(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method from(_)to(_)");
  Object params[2];
  int partcv[2];
  Object *var_Number = getfromclosure(closure, 0);
  Object *var_RequestError = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for from(_)to(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_lower = &(stackframe->slots[0]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *var_upper = &(stackframe->slots[1]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part to(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_start = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "start");
  Object *var_stop = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "stop");
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  int frame4510 = gc_frame_new();
  gc_frame_newslot(*var_lower);
// Begin line 1880
  setline(1880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4511 = alloc_Block(NULL, NULL, "collectionsPrelude", 1880);
  gc_frame_newslot(block4511);
// method "_apply(_)"
  block_savedest(block4511);
  Object closure4512 = createclosure(1, "_apply(1)");
  setclosureframe(closure4512, stackframe);
  addtoclosure(closure4512, selfslot);
  struct UserObject *uo4512 = (struct UserObject*)block4511;
  uo4512->data[0] = (Object)closure4512;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4512 = addmethod2pos(block4511, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4512, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4512[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4512->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4512);
meth_meth_collectionsPrelude__apply_40_1_41_4512->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply_40_1_41_4512->type->names[0] = "__20";
  meth_meth_collectionsPrelude__apply_40_1_41_4512->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4512->definitionLine = 1991;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4514 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4515 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4516 == NULL) {
    strlit4516 = alloc_String("__20");
    gc_root(strlit4516);
  }
// compiled string node returning strlit4516 (depth = 6)
  gc_frame_newslot(strlit4516);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4517 = gc_frame_new();
// call case 5: prelude request
  Object call4518 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4517);
// compiled member node returning call4518 (depth = 6)
  params[0] = strlit4516;
  partcv[0] = 1;
  Object call4519 = callmethodflags(call4518, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4515);
// compiled call node returning call4519 (depth = 5)
  gc_frame_newslot(call4519);
// Begin line 1880
  setline(1880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4520 = gc_frame_new();
// call case 5: prelude request
  Object call4521 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4520);
// compiled member node returning call4521 (depth = 5)
  params[0] = call4519;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call4522 = callmethodflags(call4521, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4514);
// compiled call node returning call4522 (depth = 4)
((struct UserObject *)block4511)->data[1] = call4522;
// compiled block node returning block4511 (depth = 3)
  gc_frame_newslot(block4511);
// Begin line 1881
  setline(1881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4523 = alloc_Block(NULL, NULL, "collectionsPrelude", 1881);
  gc_frame_newslot(block4523);
// method "_apply(_)"
  block_savedest(block4523);
  Object closure4524 = createclosure(4, "_apply(1)");
  setclosureframe(closure4524, stackframe);
  addtoclosure(closure4524, var_upper);
  addtoclosure(closure4524, var_lower);
  addtoclosure(closure4524, var_RequestError);
  addtoclosure(closure4524, selfslot);
  struct UserObject *uo4524 = (struct UserObject*)block4523;
  uo4524->data[0] = (Object)closure4524;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4524 = addmethod2pos(block4523, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4524, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4524[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4524->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4524);
  meth_meth_collectionsPrelude__apply_40_1_41_4524->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4524->definitionLine = 1991;
// compiled block node returning block4523 (depth = 3)
  gc_frame_newslot(block4523);
  params[0] = block4511;
  params[1] = block4523;
  Object matchres4510 = matchCase(*var_lower, params, 2,NULL);
  gc_frame_end(frame4510);
// compiled matchcase node returning matchres4510 (depth = 2)
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4554 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  Object call4555 = callmethodflags(*var_lower, "truncated", 0, partcv, params, 0);
  gc_frame_end(callframe4554);
// compiled member node returning call4555 (depth = 3)
  *var_start = call4555;
  if (call4555 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1884
  setline(1884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_4557 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  int op_slot_left_4557 = gc_frame_newslot(*var_start);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4559 = callmethod(*var_start, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4559 (depth = 3)
  Object if4556 = done;
  if (istrue(opresult4559)) {
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4560 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4563 == NULL) {
    strlit4563 = alloc_String(") is not an integer");
    gc_root(strlit4563);
  }
// compiled string node returning strlit4563 (depth = 6)
  int op_slot_right_4562 = gc_frame_newslot(strlit4563);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_4565 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4568 == NULL) {
    strlit4568 = alloc_String(")to(");
    gc_root(strlit4568);
  }
// compiled string node returning strlit4568 (depth = 8)
  int op_slot_right_4567 = gc_frame_newslot(strlit4568);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lower (depth = 9)
  int op_slot_right_4570 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 9)
  if (strlit4572 == NULL) {
    strlit4572 = alloc_String(" in range.from(");
    gc_root(strlit4572);
  }
// compiled string node returning strlit4572 (depth = 9)
  int op_slot_left_4570 = gc_frame_newslot(strlit4572);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4573 = callmethod(strlit4572, "++(1)", 1, partcv, params);
// compiled op node returning opresult4573 (depth = 8)
  int op_slot_left_4567 = gc_frame_newslot(opresult4573);
  params[0] = strlit4568;
  partcv[0] = 1;
  Object opresult4574 = callmethod(opresult4573, "++(1)", 1, partcv, params);
// compiled op node returning opresult4574 (depth = 7)
  int op_slot_left_4565 = gc_frame_newslot(opresult4574);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4575 = callmethod(opresult4574, "++(1)", 1, partcv, params);
// compiled op node returning opresult4575 (depth = 6)
  int op_slot_left_4562 = gc_frame_newslot(opresult4575);
  params[0] = strlit4563;
  partcv[0] = 1;
  Object opresult4576 = callmethod(opresult4575, "++(1)", 1, partcv, params);
// compiled op node returning opresult4576 (depth = 5)
  int op_slot_right_4561 = gc_frame_newslot(opresult4576);
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4579 == NULL) {
    strlit4579 = alloc_String("");
    gc_root(strlit4579);
  }
// compiled string node returning strlit4579 (depth = 6)
  int op_slot_right_4578 = gc_frame_newslot(strlit4579);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_4581 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 7)
  if (strlit4583 == NULL) {
    strlit4583 = alloc_String("lower bound ");
    gc_root(strlit4583);
  }
// compiled string node returning strlit4583 (depth = 7)
  int op_slot_left_4581 = gc_frame_newslot(strlit4583);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4584 = callmethod(strlit4583, "++(1)", 1, partcv, params);
// compiled op node returning opresult4584 (depth = 6)
  int op_slot_left_4578 = gc_frame_newslot(opresult4584);
  params[0] = strlit4579;
  partcv[0] = 1;
  Object opresult4585 = callmethod(opresult4584, "++(1)", 1, partcv, params);
// compiled op node returning opresult4585 (depth = 5)
  int op_slot_left_4561 = gc_frame_newslot(opresult4585);
  params[0] = opresult4576;
  partcv[0] = 1;
  Object opresult4586 = callmethod(opresult4585, "++(1)", 1, partcv, params);
// compiled op node returning opresult4586 (depth = 4)
  gc_frame_newslot(opresult4586);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult4586;
  partcv[0] = 1;
  Object call4587 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4560);
// compiled call node returning call4587 (depth = 3)
    gc_frame_newslot(call4587);
    if4556 = call4587;
  } else {
  }
// compiled if node returning if4556 (depth = 2)
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  int frame4588 = gc_frame_new();
  gc_frame_newslot(*var_upper);
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4589 = alloc_Block(NULL, NULL, "collectionsPrelude", 1889);
  gc_frame_newslot(block4589);
// method "_apply(_)"
  block_savedest(block4589);
  Object closure4590 = createclosure(1, "_apply(1)");
  setclosureframe(closure4590, stackframe);
  addtoclosure(closure4590, selfslot);
  struct UserObject *uo4590 = (struct UserObject*)block4589;
  uo4590->data[0] = (Object)closure4590;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4590 = addmethod2pos(block4589, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4590, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4590[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4590->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4590);
meth_meth_collectionsPrelude__apply_40_1_41_4590->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply_40_1_41_4590->type->names[0] = "__22";
  meth_meth_collectionsPrelude__apply_40_1_41_4590->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4590->definitionLine = 1991;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4592 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4593 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4594 == NULL) {
    strlit4594 = alloc_String("__22");
    gc_root(strlit4594);
  }
// compiled string node returning strlit4594 (depth = 6)
  gc_frame_newslot(strlit4594);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4595 = gc_frame_new();
// call case 5: prelude request
  Object call4596 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4595);
// compiled member node returning call4596 (depth = 6)
  params[0] = strlit4594;
  partcv[0] = 1;
  Object call4597 = callmethodflags(call4596, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4593);
// compiled call node returning call4597 (depth = 5)
  gc_frame_newslot(call4597);
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4598 = gc_frame_new();
// call case 5: prelude request
  Object call4599 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4598);
// compiled member node returning call4599 (depth = 5)
  params[0] = call4597;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call4600 = callmethodflags(call4599, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4592);
// compiled call node returning call4600 (depth = 4)
((struct UserObject *)block4589)->data[1] = call4600;
// compiled block node returning block4589 (depth = 3)
  gc_frame_newslot(block4589);
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4601 = alloc_Block(NULL, NULL, "collectionsPrelude", 1890);
  gc_frame_newslot(block4601);
// method "_apply(_)"
  block_savedest(block4601);
  Object closure4602 = createclosure(4, "_apply(1)");
  setclosureframe(closure4602, stackframe);
  addtoclosure(closure4602, var_upper);
  addtoclosure(closure4602, var_lower);
  addtoclosure(closure4602, var_RequestError);
  addtoclosure(closure4602, selfslot);
  struct UserObject *uo4602 = (struct UserObject*)block4601;
  uo4602->data[0] = (Object)closure4602;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4602 = addmethod2pos(block4601, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4602, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4602[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4602->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4602);
  meth_meth_collectionsPrelude__apply_40_1_41_4602->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4602->definitionLine = 1991;
// compiled block node returning block4601 (depth = 3)
  gc_frame_newslot(block4601);
  params[0] = block4589;
  params[1] = block4601;
  Object matchres4588 = matchCase(*var_upper, params, 2,NULL);
  gc_frame_end(frame4588);
// compiled matchcase node returning matchres4588 (depth = 2)
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4632 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  Object call4633 = callmethodflags(*var_upper, "truncated", 0, partcv, params, 0);
  gc_frame_end(callframe4632);
// compiled member node returning call4633 (depth = 3)
  *var_stop = call4633;
  if (call4633 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_4635 = gc_frame_newslot(*var_upper);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_stop (depth = 4)
  int op_slot_left_4635 = gc_frame_newslot(*var_stop);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4637 = callmethod(*var_stop, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4637 (depth = 3)
  Object if4634 = done;
  if (istrue(opresult4637)) {
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4638 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit4640 == NULL) {
    strlit4640 = alloc_String(" in range.from()to() is not an integer");
    gc_root(strlit4640);
  }
// compiled string node returning strlit4640 (depth = 5)
  int op_slot_right_4639 = gc_frame_newslot(strlit4640);
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4643 == NULL) {
    strlit4643 = alloc_String("");
    gc_root(strlit4643);
  }
// compiled string node returning strlit4643 (depth = 6)
  int op_slot_right_4642 = gc_frame_newslot(strlit4643);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_4645 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 7)
  if (strlit4647 == NULL) {
    strlit4647 = alloc_String("upper bound ");
    gc_root(strlit4647);
  }
// compiled string node returning strlit4647 (depth = 7)
  int op_slot_left_4645 = gc_frame_newslot(strlit4647);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4648 = callmethod(strlit4647, "++(1)", 1, partcv, params);
// compiled op node returning opresult4648 (depth = 6)
  int op_slot_left_4642 = gc_frame_newslot(opresult4648);
  params[0] = strlit4643;
  partcv[0] = 1;
  Object opresult4649 = callmethod(opresult4648, "++(1)", 1, partcv, params);
// compiled op node returning opresult4649 (depth = 5)
  int op_slot_left_4639 = gc_frame_newslot(opresult4649);
  params[0] = strlit4640;
  partcv[0] = 1;
  Object opresult4650 = callmethod(opresult4649, "++(1)", 1, partcv, params);
// compiled op node returning opresult4650 (depth = 4)
  gc_frame_newslot(opresult4650);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult4650;
  partcv[0] = 1;
  Object call4651 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4638);
// compiled call node returning call4651 (depth = 3)
    gc_frame_newslot(call4651);
    if4634 = call4651;
  } else {
  }
// compiled if node returning if4634 (depth = 2)
// Begin line 1898
  setline(1898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4652 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  gc_frame_newslot(*var_upper);
// call case 4: self request
  params[0] = *var_lower;
  params[1] = *var_upper;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4653 = callmethodflags(self, "uncheckedFrom(1)to(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4652);
// compiled call node returning call4653 (depth = 2)
  gc_frame_end(frame);
  return call4653;
}
Object meth_collectionsPrelude_hasNext4665(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1914
  setline(1914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4667 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4668 = gc_frame_new();
// call case 3: self.outer request
  Object call4669 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4668);
// compiled member node returning call4669 (depth = 4)
  Object call4670 = callmethodflags(call4669, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4667);
// compiled member node returning call4670 (depth = 3)
  int op_slot_right_4666 = gc_frame_newslot(call4670);
// starting to compile member node (depth = 3)
  int callframe4672 = gc_frame_new();
// call case 4: self request
  Object call4673 = callmethodflags(self, "val", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4672);
// compiled member node returning call4673 (depth = 3)
  int op_slot_left_4666 = gc_frame_newslot(call4673);
  params[0] = call4670;
  partcv[0] = 1;
  Object opresult4674 = callmethod(call4673, "≤(1)", 1, partcv, params);
// compiled op node returning opresult4674 (depth = 2)
  gc_frame_end(frame);
  return opresult4674;
}
Object meth_collectionsPrelude_next4675(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1916
  setline(1916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4678 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4679 = gc_frame_new();
// call case 3: self.outer request
  Object call4680 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4679);
// compiled member node returning call4680 (depth = 5)
  Object call4681 = callmethodflags(call4680, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4678);
// compiled member node returning call4681 (depth = 4)
  int op_slot_right_4677 = gc_frame_newslot(call4681);
// starting to compile member node (depth = 4)
  int callframe4683 = gc_frame_new();
// call case 4: self request
  Object call4684 = callmethodflags(self, "val", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4683);
// compiled member node returning call4684 (depth = 4)
  int op_slot_left_4677 = gc_frame_newslot(call4684);
  params[0] = call4681;
  partcv[0] = 1;
  Object opresult4685 = callmethod(call4684, ">(1)", 1, partcv, params);
// compiled op node returning opresult4685 (depth = 3)
  Object if4676 = done;
  if (istrue(opresult4685)) {
// Begin line 1917
  setline(1917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4686 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4688 == NULL) {
    strlit4688 = alloc_String("");
    gc_root(strlit4688);
  }
// compiled string node returning strlit4688 (depth = 5)
  int op_slot_right_4687 = gc_frame_newslot(strlit4688);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4691 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4692 = gc_frame_new();
// call case 3: self.outer request
  Object call4693 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4692);
// compiled member node returning call4693 (depth = 7)
  Object call4694 = callmethodflags(call4693, "asString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4691);
// compiled member node returning call4694 (depth = 6)
  int op_slot_right_4690 = gc_frame_newslot(call4694);
// starting to compile string node (depth = 6)
  if (strlit4696 == NULL) {
    strlit4696 = alloc_String("over ");
    gc_root(strlit4696);
  }
// compiled string node returning strlit4696 (depth = 6)
  int op_slot_left_4690 = gc_frame_newslot(strlit4696);
  params[0] = call4694;
  partcv[0] = 1;
  Object opresult4697 = callmethod(strlit4696, "++(1)", 1, partcv, params);
// compiled op node returning opresult4697 (depth = 5)
  int op_slot_left_4687 = gc_frame_newslot(opresult4697);
  params[0] = strlit4688;
  partcv[0] = 1;
  Object opresult4698 = callmethod(opresult4697, "++(1)", 1, partcv, params);
// compiled op node returning opresult4698 (depth = 4)
  gc_frame_newslot(opresult4698);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = opresult4698;
  partcv[0] = 1;
  Object call4699 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4686);
// compiled call node returning call4699 (depth = 3)
    gc_frame_newslot(call4699);
    if4676 = call4699;
  } else {
  }
// compiled if node returning if4676 (depth = 2)
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4700 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4702 = alloc_Float64(1);
// compiled num node returning num4702 (depth = 4)
  int op_slot_right_4701 = gc_frame_newslot(num4702);
// starting to compile member node (depth = 4)
  int callframe4704 = gc_frame_new();
// call case 4: self request
  Object call4705 = callmethodflags(self, "val", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4704);
// compiled member node returning call4705 (depth = 4)
  int op_slot_left_4701 = gc_frame_newslot(call4705);
  params[0] = num4702;
  partcv[0] = 1;
  Object sum4706 = callmethod(call4705, "+(1)", 1, partcv, params);
// compiled op node returning sum4706 (depth = 3)
  gc_frame_newslot(sum4706);
// call case 4: self request
  params[0] = sum4706;
  partcv[0] = 1;
  Object call4707 = callmethodflags(self, "val:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4700);
// compiled call node returning call4707 (depth = 2)
// Begin line 1920
  setline(1920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4709 = alloc_Float64(1);
// compiled num node returning num4709 (depth = 4)
  int op_slot_right_4708 = gc_frame_newslot(num4709);
// starting to compile member node (depth = 4)
  int callframe4711 = gc_frame_new();
// call case 4: self request
  Object call4712 = callmethodflags(self, "val", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4711);
// compiled member node returning call4712 (depth = 4)
  int op_slot_left_4708 = gc_frame_newslot(call4712);
  params[0] = num4709;
  partcv[0] = 1;
  Object diff4713 = callmethod(call4712, "-(1)", 1, partcv, params);
// compiled op node returning diff4713 (depth = 3)
  return diff4713;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_asString4714(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1922
  setline(1922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4716 == NULL) {
    strlit4716 = alloc_String("");
    gc_root(strlit4716);
  }
// compiled string node returning strlit4716 (depth = 3)
  int op_slot_right_4715 = gc_frame_newslot(strlit4716);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_4718 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4721 == NULL) {
    strlit4721 = alloc_String(" to ");
    gc_root(strlit4721);
  }
// compiled string node returning strlit4721 (depth = 5)
  int op_slot_right_4720 = gc_frame_newslot(strlit4721);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_right_4723 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4726 == NULL) {
    strlit4726 = alloc_String(" from ");
    gc_root(strlit4726);
  }
// compiled string node returning strlit4726 (depth = 7)
  int op_slot_right_4725 = gc_frame_newslot(strlit4726);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4729 = gc_frame_new();
// call case 1: super request
  Object call4730 = callmethod4(self, "asString", 0, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4729);
// compiled member node returning call4730 (depth = 8)
  int op_slot_right_4728 = gc_frame_newslot(call4730);
// starting to compile string node (depth = 8)
  if (strlit4732 == NULL) {
    strlit4732 = alloc_String("");
    gc_root(strlit4732);
  }
// compiled string node returning strlit4732 (depth = 8)
  int op_slot_left_4728 = gc_frame_newslot(strlit4732);
  params[0] = call4730;
  partcv[0] = 1;
  Object opresult4733 = callmethod(strlit4732, "++(1)", 1, partcv, params);
// compiled op node returning opresult4733 (depth = 7)
  int op_slot_left_4725 = gc_frame_newslot(opresult4733);
  params[0] = strlit4726;
  partcv[0] = 1;
  Object opresult4734 = callmethod(opresult4733, "++(1)", 1, partcv, params);
// compiled op node returning opresult4734 (depth = 6)
  int op_slot_left_4723 = gc_frame_newslot(opresult4734);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4735 = callmethod(opresult4734, "++(1)", 1, partcv, params);
// compiled op node returning opresult4735 (depth = 5)
  int op_slot_left_4720 = gc_frame_newslot(opresult4735);
  params[0] = strlit4721;
  partcv[0] = 1;
  Object opresult4736 = callmethod(opresult4735, "++(1)", 1, partcv, params);
// compiled op node returning opresult4736 (depth = 4)
  int op_slot_left_4718 = gc_frame_newslot(opresult4736);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4737 = callmethod(opresult4736, "++(1)", 1, partcv, params);
// compiled op node returning opresult4737 (depth = 3)
  int op_slot_left_4715 = gc_frame_newslot(opresult4737);
  params[0] = strlit4716;
  partcv[0] = 1;
  Object opresult4738 = callmethod(opresult4737, "++(1)", 1, partcv, params);
// compiled op node returning opresult4738 (depth = 2)
  gc_frame_end(frame);
  return opresult4738;
}
Object meth_collectionsPrelude_iterator4661(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  Object *var_upper = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4662 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4662 = alloc_userobj2(5,5, objclass4662);
  gc_frame_newslot(obj4662);
if (objclass4662 == NULL) {
  glfree(obj4662->class->name);
  obj4662->class->name = "range.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4662, self, 0);
  addmethodreal(obj4662,"outer", &reader_collectionsPrelude_outer_4663);
  Object oldself4662 = self;
  struct StackFrameObject *oldstackframe4662 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4662);
  gc_frame_newslot((Object)stackframe);
  self = obj4662;
  Object *oldselfslot4662 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4662 = (*(struct UserObject *)self).data[0], lowerouter4662 = thisouter4662;
  if (inheritingObject4662) {
    struct UserObject *inho4662 = (struct UserObject *)inheritingObject4662;
    while (inho4662->super != GraceDefaultObject) inho4662 = (struct UserObject *)inho4662->super;
    inho4662->super = obj4662;
    self = inheritingObject4662;
    *selfslot = self;
    lowerouter4662 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4662;
  }
if (objclass4662 == NULL) {
  Method *reader4664 = addmethodrealflags(obj4662, "val", &reader_collectionsPrelude_val_4664, MFLAG_CONFIDENTIAL);
  Method *writer4664 = addmethodrealflags(obj4662, "val:=(1)", &writer_collectionsPrelude_val_4664, MFLAG_CONFIDENTIAL);
  reader4664->definitionModule = modulename;
  writer4664->definitionModule = modulename;
  reader4664->definitionLine = 1913;
  writer4664->definitionLine = 1913;
}
obj4662->flags |= OFLAG_MUTABLE;
adddatum2(obj4662, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo4665 = (struct UserObject*)obj4662;
  uo4665->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext4665 = addmethod2pos(obj4662, "hasNext", &meth_collectionsPrelude_hasNext4665, 2);
  int argcv_meth_collectionsPrelude_hasNext4665[] = {0};
  meth_meth_collectionsPrelude_hasNext4665->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext4665);
  meth_meth_collectionsPrelude_hasNext4665->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext4665->definitionLine = 1914;
// method "next"
  block_savedest(obj4662);
  Object closure4675 = createclosure(1, "next");
  setclosureframe(closure4675, stackframe);
  addtoclosure(closure4675, var_IteratorExhausted);
  struct UserObject *uo4675 = (struct UserObject*)obj4662;
  uo4675->data[3] = (Object)closure4675;
  Method *meth_meth_collectionsPrelude_next4675 = addmethod2pos(obj4662, "next", &meth_collectionsPrelude_next4675, 3);
  int argcv_meth_collectionsPrelude_next4675[] = {0};
  meth_meth_collectionsPrelude_next4675->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4675);
  meth_meth_collectionsPrelude_next4675->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4675->definitionLine = 1915;
// method "asString"
  block_savedest(obj4662);
  Object closure4714 = createclosure(2, "asString");
  setclosureframe(closure4714, stackframe);
  addtoclosure(closure4714, var_lower);
  addtoclosure(closure4714, var_upper);
  struct UserObject *uo4714 = (struct UserObject*)obj4662;
  uo4714->data[4] = (Object)closure4714;
  Method *meth_meth_collectionsPrelude_asString4714 = addmethod2pos(obj4662, "asString", &meth_collectionsPrelude_asString4714, 4);
  int argcv_meth_collectionsPrelude_asString4714[] = {0};
  meth_meth_collectionsPrelude_asString4714->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4714);
  meth_meth_collectionsPrelude_asString4714->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4714->definitionLine = 1922;
  sourceObject = obj4662;
// Begin line 1913
  setline(1913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4739 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4740 = gc_frame_new();
// call case 3: self.outer request
  Object call4741 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4740);
// compiled member node returning call4741 (depth = 3)
  Object call4742 = callmethodflags(call4741, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4739);
// compiled member node returning call4742 (depth = 2)
  adddatum2(obj4662, call4742, 1);
  sourceObject = obj4662;
  sourceObject = obj4662;
  sourceObject = obj4662;
  objclass4662 = obj4662->class;
  objclass4662->definitionModule = modulename;
  objclass4662->definitionLine = 1912;
  (*(struct UserObject *)self).data[0] = lowerouter4662;
  self = oldself4662;
  selfslot = oldselfslot4662;
  stackframe = oldstackframe4662;
  gc_frame_end(frame);
  return obj4662;
}
Object meth_collectionsPrelude_iterator4661_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  Object *var_upper = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4662 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4662 = alloc_userobj2(5,5, objclass4662);
  gc_frame_newslot(obj4662);
if (objclass4662 == NULL) {
  glfree(obj4662->class->name);
  obj4662->class->name = "range.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4662, self, 0);
  addmethodreal(obj4662,"outer", &reader_collectionsPrelude_outer_4663);
  Object oldself4662 = self;
  struct StackFrameObject *oldstackframe4662 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4662);
  gc_frame_newslot((Object)stackframe);
  self = obj4662;
  Object *oldselfslot4662 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4662 = (*(struct UserObject *)self).data[0], lowerouter4662 = thisouter4662;
  if (inheritingObject4662) {
    struct UserObject *inho4662 = (struct UserObject *)inheritingObject4662;
    while (inho4662->super != GraceDefaultObject) inho4662 = (struct UserObject *)inho4662->super;
    inho4662->super = obj4662;
    self = inheritingObject4662;
    *selfslot = self;
    lowerouter4662 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4662;
  }
if (objclass4662 == NULL) {
  Method *reader4664 = addmethodrealflags(obj4662, "val", &reader_collectionsPrelude_val_4664, MFLAG_CONFIDENTIAL);
  Method *writer4664 = addmethodrealflags(obj4662, "val:=(1)", &writer_collectionsPrelude_val_4664, MFLAG_CONFIDENTIAL);
  reader4664->definitionModule = modulename;
  writer4664->definitionModule = modulename;
  reader4664->definitionLine = 1913;
  writer4664->definitionLine = 1913;
}
obj4662->flags |= OFLAG_MUTABLE;
adddatum2(obj4662, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo4665 = (struct UserObject*)obj4662;
  uo4665->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext4665 = addmethod2pos(obj4662, "hasNext", &meth_collectionsPrelude_hasNext4665, 2);
  int argcv_meth_collectionsPrelude_hasNext4665[] = {0};
  meth_meth_collectionsPrelude_hasNext4665->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext4665);
  meth_meth_collectionsPrelude_hasNext4665->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext4665->definitionLine = 1914;
// method "next"
  block_savedest(obj4662);
  Object closure4675 = createclosure(1, "next");
  setclosureframe(closure4675, stackframe);
  addtoclosure(closure4675, var_IteratorExhausted);
  struct UserObject *uo4675 = (struct UserObject*)obj4662;
  uo4675->data[3] = (Object)closure4675;
  Method *meth_meth_collectionsPrelude_next4675 = addmethod2pos(obj4662, "next", &meth_collectionsPrelude_next4675, 3);
  int argcv_meth_collectionsPrelude_next4675[] = {0};
  meth_meth_collectionsPrelude_next4675->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4675);
  meth_meth_collectionsPrelude_next4675->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4675->definitionLine = 1915;
// method "asString"
  block_savedest(obj4662);
  Object closure4714 = createclosure(2, "asString");
  setclosureframe(closure4714, stackframe);
  addtoclosure(closure4714, var_lower);
  addtoclosure(closure4714, var_upper);
  struct UserObject *uo4714 = (struct UserObject*)obj4662;
  uo4714->data[4] = (Object)closure4714;
  Method *meth_meth_collectionsPrelude_asString4714 = addmethod2pos(obj4662, "asString", &meth_collectionsPrelude_asString4714, 4);
  int argcv_meth_collectionsPrelude_asString4714[] = {0};
  meth_meth_collectionsPrelude_asString4714->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4714);
  meth_meth_collectionsPrelude_asString4714->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4714->definitionLine = 1922;
  sourceObject = obj4662;
// Begin line 1913
  setline(1913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4739 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4740 = gc_frame_new();
// call case 3: self.outer request
  Object call4741 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4740);
// compiled member node returning call4741 (depth = 3)
  Object call4742 = callmethodflags(call4741, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4739);
// compiled member node returning call4742 (depth = 2)
  adddatum2(obj4662, call4742, 1);
  sourceObject = obj4662;
  sourceObject = obj4662;
  sourceObject = obj4662;
  objclass4662 = obj4662->class;
  objclass4662->definitionModule = modulename;
  objclass4662->definitionLine = 1912;
  (*(struct UserObject *)self).data[0] = lowerouter4662;
  self = oldself4662;
  selfslot = oldselfslot4662;
  stackframe = oldstackframe4662;
  gc_frame_end(frame);
  return obj4662;
}
Object meth_collectionsPrelude_at_40_1_41_4744(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4746 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4748 = gc_frame_new();
// call case 4: self request
  Object call4749 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4748);
// compiled member node returning call4749 (depth = 5)
  int op_slot_right_4747 = gc_frame_newslot(call4749);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4747 = gc_frame_newslot(*var_ix);
  params[0] = call4749;
  partcv[0] = 1;
  Object opresult4751 = callmethod(*var_ix, "≤(1)", 1, partcv, params);
// compiled op node returning opresult4751 (depth = 4)
  partcv[0] = 0;
  Object call4752 = callmethodflags(opresult4751, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe4746);
// compiled call node returning call4752 (depth = 3)
  Object if4745 = done;
  if (istrue(call4752)) {
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4753 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4755 == NULL) {
    strlit4755 = alloc_String("");
    gc_root(strlit4755);
  }
// compiled string node returning strlit4755 (depth = 5)
  int op_slot_right_4754 = gc_frame_newslot(strlit4755);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4758 = gc_frame_new();
// call case 4: self request
  Object call4759 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4758);
// compiled member node returning call4759 (depth = 6)
  int op_slot_right_4757 = gc_frame_newslot(call4759);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4762 == NULL) {
    strlit4762 = alloc_String("), but upper bound is ");
    gc_root(strlit4762);
  }
// compiled string node returning strlit4762 (depth = 7)
  int op_slot_right_4761 = gc_frame_newslot(strlit4762);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  int op_slot_right_4764 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 8)
  if (strlit4766 == NULL) {
    strlit4766 = alloc_String("requested range.at(");
    gc_root(strlit4766);
  }
// compiled string node returning strlit4766 (depth = 8)
  int op_slot_left_4764 = gc_frame_newslot(strlit4766);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult4767 = callmethod(strlit4766, "++(1)", 1, partcv, params);
// compiled op node returning opresult4767 (depth = 7)
  int op_slot_left_4761 = gc_frame_newslot(opresult4767);
  params[0] = strlit4762;
  partcv[0] = 1;
  Object opresult4768 = callmethod(opresult4767, "++(1)", 1, partcv, params);
// compiled op node returning opresult4768 (depth = 6)
  int op_slot_left_4757 = gc_frame_newslot(opresult4768);
  params[0] = call4759;
  partcv[0] = 1;
  Object opresult4769 = callmethod(opresult4768, "++(1)", 1, partcv, params);
// compiled op node returning opresult4769 (depth = 5)
  int op_slot_left_4754 = gc_frame_newslot(opresult4769);
  params[0] = strlit4755;
  partcv[0] = 1;
  Object opresult4770 = callmethod(opresult4769, "++(1)", 1, partcv, params);
// compiled op node returning opresult4770 (depth = 4)
  gc_frame_newslot(opresult4770);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult4770;
  partcv[0] = 1;
  Object call4771 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4753);
// compiled call node returning call4771 (depth = 3)
    gc_frame_newslot(call4771);
    if4745 = call4771;
  } else {
  }
// compiled if node returning if4745 (depth = 2)
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4773 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4775 = alloc_Float64(1);
// compiled num node returning num4775 (depth = 5)
  int op_slot_right_4774 = gc_frame_newslot(num4775);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4774 = gc_frame_newslot(*var_ix);
  params[0] = num4775;
  partcv[0] = 1;
  Object opresult4777 = callmethod(*var_ix, "≥(1)", 1, partcv, params);
// compiled op node returning opresult4777 (depth = 4)
  partcv[0] = 0;
  Object call4778 = callmethodflags(opresult4777, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe4773);
// compiled call node returning call4778 (depth = 3)
  Object if4772 = done;
  if (istrue(call4778)) {
// Begin line 1930
  setline(1930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4779 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4781 == NULL) {
    strlit4781 = alloc_String("), but lower bound is 1");
    gc_root(strlit4781);
  }
// compiled string node returning strlit4781 (depth = 5)
  int op_slot_right_4780 = gc_frame_newslot(strlit4781);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_right_4783 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 6)
  if (strlit4785 == NULL) {
    strlit4785 = alloc_String("requested range.at(");
    gc_root(strlit4785);
  }
// compiled string node returning strlit4785 (depth = 6)
  int op_slot_left_4783 = gc_frame_newslot(strlit4785);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult4786 = callmethod(strlit4785, "++(1)", 1, partcv, params);
// compiled op node returning opresult4786 (depth = 5)
  int op_slot_left_4780 = gc_frame_newslot(opresult4786);
  params[0] = strlit4781;
  partcv[0] = 1;
  Object opresult4787 = callmethod(opresult4786, "++(1)", 1, partcv, params);
// compiled op node returning opresult4787 (depth = 4)
  gc_frame_newslot(opresult4787);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult4787;
  partcv[0] = 1;
  Object call4788 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4779);
// compiled call node returning call4788 (depth = 3)
    gc_frame_newslot(call4788);
    if4772 = call4788;
  } else {
  }
// compiled if node returning if4772 (depth = 2)
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4791 = alloc_Float64(1);
// compiled num node returning num4791 (depth = 5)
  int op_slot_right_4790 = gc_frame_newslot(num4791);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4790 = gc_frame_newslot(*var_ix);
  params[0] = num4791;
  partcv[0] = 1;
  Object diff4793 = callmethod(*var_ix, "-(1)", 1, partcv, params);
// compiled op node returning diff4793 (depth = 4)
  int op_slot_right_4789 = gc_frame_newslot(diff4793);
// starting to compile member node (depth = 4)
  int callframe4795 = gc_frame_new();
// call case 4: self request
  Object call4796 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4795);
// compiled member node returning call4796 (depth = 4)
  int op_slot_left_4789 = gc_frame_newslot(call4796);
  params[0] = diff4793;
  partcv[0] = 1;
  Object sum4797 = callmethod(call4796, "+(1)", 1, partcv, params);
// compiled op node returning sum4797 (depth = 3)
  return sum4797;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply4801(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elem = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_intElem = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "intElem");
// Begin line 1936
  setline(1936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4802 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elem (depth = 6)
  Object call4803 = callmethodflags(*var_elem, "truncated", 0, partcv, params, 0);
  gc_frame_end(callframe4802);
// compiled member node returning call4803 (depth = 5)
  *var_intElem = call4803;
  if (call4803 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1937
  setline(1937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elem (depth = 6)
  int op_slot_right_4805 = gc_frame_newslot(*var_elem);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_4805 = gc_frame_newslot(*var_intElem);
  params[0] = *var_elem;
  partcv[0] = 1;
  Object opresult4807 = callmethod(*var_intElem, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4807 (depth = 5)
  Object if4804 = done;
  if (istrue(opresult4807)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4808 = alloc_Boolean(0);
// compiled identifier node returning bool4808 (depth = 6)
  block_return(realself, bool4808);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4804 = undefined;
  } else {
  }
// compiled if node returning if4804 (depth = 4)
// Begin line 1938
  setline(1938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4811 = gc_frame_new();
// call case 4: self request
  Object call4812 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4811);
// compiled member node returning call4812 (depth = 6)
  int op_slot_right_4810 = gc_frame_newslot(call4812);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_4810 = gc_frame_newslot(*var_intElem);
  params[0] = call4812;
  partcv[0] = 1;
  Object opresult4814 = callmethod(*var_intElem, "<(1)", 1, partcv, params);
// compiled op node returning opresult4814 (depth = 5)
  Object if4809 = done;
  if (istrue(opresult4814)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4815 = alloc_Boolean(0);
// compiled identifier node returning bool4815 (depth = 6)
  block_return(realself, bool4815);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4809 = undefined;
  } else {
  }
// compiled if node returning if4809 (depth = 4)
// Begin line 1939
  setline(1939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4818 = gc_frame_new();
// call case 4: self request
  Object call4819 = callmethodflags(self, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4818);
// compiled member node returning call4819 (depth = 6)
  int op_slot_right_4817 = gc_frame_newslot(call4819);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_4817 = gc_frame_newslot(*var_intElem);
  params[0] = call4819;
  partcv[0] = 1;
  Object opresult4821 = callmethod(*var_intElem, ">(1)", 1, partcv, params);
// compiled op node returning opresult4821 (depth = 5)
  Object if4816 = done;
  if (istrue(opresult4821)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4822 = alloc_Boolean(0);
// compiled identifier node returning bool4822 (depth = 6)
  block_return(realself, bool4822);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4816 = undefined;
  } else {
  }
// compiled if node returning if4816 (depth = 4)
  gc_frame_end(frame);
  return if4816;
}
Object meth_collectionsPrelude__apply_40_1_41_4825(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ex = &(stackframe->slots[0]);
  *var_ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4826 = alloc_Boolean(0);
// compiled identifier node returning bool4826 (depth = 5)
  block_return(realself, bool4826);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_contains_40_1_41_4798(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[2];
  int partcv[1];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elem = &(stackframe->slots[0]);
  *var_elem = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile trycatch node (depth = 2)
// starting to compile block node (depth = 3)
  Object block4800 = alloc_Block(NULL, NULL, "collectionsPrelude", 1935);
  gc_frame_newslot(block4800);
// method "_apply"
  block_savedest(block4800);
  Object closure4801 = createclosure(2, "_apply");
  setclosureframe(closure4801, stackframe);
  addtoclosure(closure4801, var_elem);
  addtoclosure(closure4801, selfslot);
  struct UserObject *uo4801 = (struct UserObject*)block4800;
  uo4801->data[0] = (Object)closure4801;
  Method *meth_meth_collectionsPrelude__apply4801 = addmethod2pos(block4800, "_apply", &meth_collectionsPrelude__apply4801, 0);
  int argcv_meth_collectionsPrelude__apply4801[] = {0};
  meth_meth_collectionsPrelude__apply4801->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4801);
  meth_meth_collectionsPrelude__apply4801->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4801->definitionLine = 1991;
// compiled block node returning block4800 (depth = 3)
  int frame4799 = gc_frame_new();
  gc_frame_newslot(block4800);
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4824 = alloc_Block(NULL, NULL, "collectionsPrelude", 1940);
  gc_frame_newslot(block4824);
// method "_apply(_)"
  block_savedest(block4824);
  Object closure4825 = createclosure(1, "_apply(1)");
  setclosureframe(closure4825, stackframe);
  addtoclosure(closure4825, selfslot);
  struct UserObject *uo4825 = (struct UserObject*)block4824;
  uo4825->data[0] = (Object)closure4825;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4825 = addmethod2pos(block4824, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4825, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4825[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4825->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4825);
  meth_meth_collectionsPrelude__apply_40_1_41_4825->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4825->definitionLine = 1991;
// starting to compile call node (depth = 4)
  int callframe4828 = gc_frame_new();
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4829 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4830 == NULL) {
    strlit4830 = alloc_String("ex");
    gc_root(strlit4830);
  }
// compiled string node returning strlit4830 (depth = 6)
  gc_frame_newslot(strlit4830);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4831 = gc_frame_new();
// call case 5: prelude request
  Object call4832 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4831);
// compiled member node returning call4832 (depth = 6)
  params[0] = strlit4830;
  partcv[0] = 1;
  Object call4833 = callmethodflags(call4832, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4829);
// compiled call node returning call4833 (depth = 5)
  gc_frame_newslot(call4833);
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4834 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var__prelude (depth = 6)
  Object call4835 = callmethodflags(*var__prelude, "Exception", 0, partcv, params, 0);
  gc_frame_end(callframe4834);
// compiled member node returning call4835 (depth = 5)
  gc_frame_newslot(call4835);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4836 = gc_frame_new();
// call case 5: prelude request
  Object call4837 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4836);
// compiled member node returning call4837 (depth = 5)
  params[0] = call4833;
  params[1] = call4835;
  partcv[0] = 2;
  Object call4838 = callmethodflags(call4837, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4828);
// compiled call node returning call4838 (depth = 4)
((struct UserObject *)block4824)->data[1] = call4838;
// compiled block node returning block4824 (depth = 3)
  gc_frame_newslot(block4824);
  params[0] = block4824;
  setline(1935);
  Object catchres4799 = tryCatch(block4800, params, 1,NULL);
  gc_frame_end(frame4799);
// compiled trycatch node returning catchres4799 (depth = 2)
// Begin line 1941
  setline(1941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool4839 = alloc_Boolean(1);
// compiled identifier node returning bool4839 (depth = 3)
  return bool4839;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply4845(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4847 = gc_frame_new();
// call case 4: self request
  Object call4848 = callmethodflags(self, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4847);
// compiled member node returning call4848 (depth = 5)
  int op_slot_right_4846 = gc_frame_newslot(call4848);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_4846 = gc_frame_newslot(*var_val);
  params[0] = call4848;
  partcv[0] = 1;
  Object opresult4850 = callmethod(*var_val, "≤(1)", 1, partcv, params);
// compiled op node returning opresult4850 (depth = 4)
  gc_frame_end(frame);
  return opresult4850;
}
Object meth_collectionsPrelude__apply4853(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1946
  setline(1946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4854 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = *var_val;
  partcv[0] = 1;
  Object call4855 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4854);
// compiled call node returning call4855 (depth = 4)
// Begin line 1947
  setline(1947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4857 = alloc_Float64(1);
// compiled num node returning num4857 (depth = 6)
  int op_slot_right_4856 = gc_frame_newslot(num4857);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_4856 = gc_frame_newslot(*var_val);
  params[0] = num4857;
  partcv[0] = 1;
  Object sum4859 = callmethod(*var_val, "+(1)", 1, partcv, params);
// compiled op node returning sum4859 (depth = 5)
  *var_val = sum4859;
  if (sum4859 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do_40_1_41_4840(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_val = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "val");
// Begin line 1944
  setline(1944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4841 = gc_frame_new();
// call case 4: self request
  Object call4842 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4841);
// compiled member node returning call4842 (depth = 3)
  *var_val = call4842;
  if (call4842 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1945
  setline(1945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4843 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4844 = alloc_Block(NULL, NULL, "collectionsPrelude", 1945);
  gc_frame_newslot(block4844);
// method "_apply"
  block_savedest(block4844);
  Object closure4845 = createclosure(2, "_apply");
  setclosureframe(closure4845, stackframe);
  addtoclosure(closure4845, var_val);
  addtoclosure(closure4845, selfslot);
  struct UserObject *uo4845 = (struct UserObject*)block4844;
  uo4845->data[0] = (Object)closure4845;
  Method *meth_meth_collectionsPrelude__apply4845 = addmethod2pos(block4844, "_apply", &meth_collectionsPrelude__apply4845, 0);
  int argcv_meth_collectionsPrelude__apply4845[] = {0};
  meth_meth_collectionsPrelude__apply4845->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4845);
  meth_meth_collectionsPrelude__apply4845->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4845->definitionLine = 1991;
// compiled block node returning block4844 (depth = 3)
  gc_frame_newslot(block4844);
// starting to compile block node (depth = 3)
  Object block4852 = alloc_Block(NULL, NULL, "collectionsPrelude", 1945);
  gc_frame_newslot(block4852);
// method "_apply"
  block_savedest(block4852);
  Object closure4853 = createclosure(3, "_apply");
  setclosureframe(closure4853, stackframe);
  addtoclosure(closure4853, var_val);
  addtoclosure(closure4853, var_block1);
  addtoclosure(closure4853, selfslot);
  struct UserObject *uo4853 = (struct UserObject*)block4852;
  uo4853->data[0] = (Object)closure4853;
  Method *meth_meth_collectionsPrelude__apply4853 = addmethod2pos(block4852, "_apply", &meth_collectionsPrelude__apply4853, 0);
  int argcv_meth_collectionsPrelude__apply4853[] = {0};
  meth_meth_collectionsPrelude__apply4853->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4853);
  meth_meth_collectionsPrelude__apply4853->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4853->definitionLine = 1991;
// compiled block node returning block4852 (depth = 3)
  gc_frame_newslot(block4852);
// call case 5: prelude request
  params[0] = block4844;
  params[1] = block4852;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4862 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4843);
// compiled call node returning call4862 (depth = 2)
  gc_frame_end(frame);
  return call4862;
}
Object meth_collectionsPrelude__apply4869(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4871 = gc_frame_new();
// call case 4: self request
  Object call4872 = callmethodflags(self, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4871);
// compiled member node returning call4872 (depth = 5)
  int op_slot_right_4870 = gc_frame_newslot(call4872);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_4870 = gc_frame_newslot(*var_val);
  params[0] = call4872;
  partcv[0] = 1;
  Object opresult4874 = callmethod(*var_val, "≤(1)", 1, partcv, params);
// compiled op node returning opresult4874 (depth = 4)
  gc_frame_end(frame);
  return opresult4874;
}
Object meth_collectionsPrelude__apply4877(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_key = getfromclosure(closure, 0);
  Object *var_val = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1954
  setline(1954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4878 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_key (depth = 5)
  gc_frame_newslot(*var_key);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block2 (depth = 5)
  params[0] = *var_key;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call4879 = callmethodflags(*var_block2, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4878);
// compiled call node returning call4879 (depth = 4)
// Begin line 1955
  setline(1955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4881 = alloc_Float64(1);
// compiled num node returning num4881 (depth = 6)
  int op_slot_right_4880 = gc_frame_newslot(num4881);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_key (depth = 6)
  int op_slot_left_4880 = gc_frame_newslot(*var_key);
  params[0] = num4881;
  partcv[0] = 1;
  Object sum4883 = callmethod(*var_key, "+(1)", 1, partcv, params);
// compiled op node returning sum4883 (depth = 5)
  *var_key = sum4883;
  if (sum4883 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1956
  setline(1956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4886 = alloc_Float64(1);
// compiled num node returning num4886 (depth = 6)
  int op_slot_right_4885 = gc_frame_newslot(num4886);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_4885 = gc_frame_newslot(*var_val);
  params[0] = num4886;
  partcv[0] = 1;
  Object sum4888 = callmethod(*var_val, "+(1)", 1, partcv, params);
// compiled op node returning sum4888 (depth = 5)
  *var_val = sum4888;
  if (sum4888 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_keysAndValuesDo_40_1_41_4863(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_key = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "key");
  Object *var_val = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "val");
// Begin line 1951
  setline(1951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num4864 = alloc_Float64(1);
// compiled num node returning num4864 (depth = 3)
  *var_key = num4864;
  if (num4864 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4865 = gc_frame_new();
// call case 4: self request
  Object call4866 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4865);
// compiled member node returning call4866 (depth = 3)
  *var_val = call4866;
  if (call4866 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1953
  setline(1953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4867 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4868 = alloc_Block(NULL, NULL, "collectionsPrelude", 1953);
  gc_frame_newslot(block4868);
// method "_apply"
  block_savedest(block4868);
  Object closure4869 = createclosure(2, "_apply");
  setclosureframe(closure4869, stackframe);
  addtoclosure(closure4869, var_val);
  addtoclosure(closure4869, selfslot);
  struct UserObject *uo4869 = (struct UserObject*)block4868;
  uo4869->data[0] = (Object)closure4869;
  Method *meth_meth_collectionsPrelude__apply4869 = addmethod2pos(block4868, "_apply", &meth_collectionsPrelude__apply4869, 0);
  int argcv_meth_collectionsPrelude__apply4869[] = {0};
  meth_meth_collectionsPrelude__apply4869->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4869);
  meth_meth_collectionsPrelude__apply4869->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4869->definitionLine = 1991;
// compiled block node returning block4868 (depth = 3)
  gc_frame_newslot(block4868);
// starting to compile block node (depth = 3)
  Object block4876 = alloc_Block(NULL, NULL, "collectionsPrelude", 1953);
  gc_frame_newslot(block4876);
// method "_apply"
  block_savedest(block4876);
  Object closure4877 = createclosure(4, "_apply");
  setclosureframe(closure4877, stackframe);
  addtoclosure(closure4877, var_key);
  addtoclosure(closure4877, var_val);
  addtoclosure(closure4877, var_block2);
  addtoclosure(closure4877, selfslot);
  struct UserObject *uo4877 = (struct UserObject*)block4876;
  uo4877->data[0] = (Object)closure4877;
  Method *meth_meth_collectionsPrelude__apply4877 = addmethod2pos(block4876, "_apply", &meth_collectionsPrelude__apply4877, 0);
  int argcv_meth_collectionsPrelude__apply4877[] = {0};
  meth_meth_collectionsPrelude__apply4877->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4877);
  meth_meth_collectionsPrelude__apply4877->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4877->definitionLine = 1991;
// compiled block node returning block4876 (depth = 3)
  gc_frame_newslot(block4876);
// call case 5: prelude request
  params[0] = block4868;
  params[1] = block4876;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4891 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4867);
// compiled call node returning call4891 (depth = 2)
  gc_frame_end(frame);
  return call4891;
}
Object meth_collectionsPrelude_reversed4892(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1960
  setline(1960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4893 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  gc_frame_newslot(*var_upper);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  gc_frame_newslot(*var_lower);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4894 = gc_frame_new();
// call case 3: self.outer request
  Object call4895 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4894);
// compiled member node returning call4895 (depth = 3)
  params[0] = *var_upper;
  params[1] = *var_lower;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4896 = callmethodflags(call4895, "from(1)downTo(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4893);
// compiled call node returning call4896 (depth = 2)
  gc_frame_end(frame);
  return call4896;
}
Object meth_collectionsPrelude__43__43__40_1_41_4897(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4898 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4899 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4900 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4901 = gc_frame_new();
// call case 3: self.outer request
  Object call4902 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4901);
// compiled member node returning call4902 (depth = 5)
  Object call4903 = callmethodflags(call4902, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4900);
// compiled member node returning call4903 (depth = 4)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call4904 = callmethodflags(call4903, "lazyConcatenation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4899);
// compiled call node returning call4904 (depth = 3)
  gc_frame_newslot(call4904);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4905 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4906 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4907 = gc_frame_new();
// call case 3: self.outer request
  Object call4908 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4907);
// compiled member node returning call4908 (depth = 5)
  Object call4909 = callmethodflags(call4908, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4906);
// compiled member node returning call4909 (depth = 4)
  Object call4910 = callmethodflags(call4909, "sequence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4905);
// compiled member node returning call4910 (depth = 3)
  params[0] = call4904;
  partcv[0] = 1;
  Object call4911 = callmethodflags(call4910, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4898);
// compiled call node returning call4911 (depth = 2)
  gc_frame_end(frame);
  return call4911;
}
Object meth_collectionsPrelude__61__61__40_1_41_4912(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4913 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4914 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4915 = gc_frame_new();
// call case 3: self.outer request
  Object call4916 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4915);
// compiled member node returning call4916 (depth = 4)
  Object call4917 = callmethodflags(call4916, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4914);
// compiled member node returning call4917 (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4918 = callmethodflags(call4917, "isEqual(1)toIterable(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4913);
// compiled call node returning call4918 (depth = 2)
  gc_frame_end(frame);
  return call4918;
}
Object meth_collectionsPrelude_sorted4919(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_sortedBy_40_1_41_4920(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4921 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4922 = gc_frame_new();
// call case 4: self request
  Object call4923 = callmethodflags(self, "asList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4922);
// compiled member node returning call4923 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4924 = callmethodflags(call4923, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4921);
// compiled call node returning call4924 (depth = 2)
  gc_frame_end(frame);
  return call4924;
}
Object meth_collectionsPrelude_keys4925(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4927 = gc_frame_new();
// call case 4: self request
  Object call4928 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4927);
// compiled member node returning call4928 (depth = 3)
  int op_slot_right_4926 = gc_frame_newslot(call4928);
// starting to compile num node (depth = 3)
  Object num4930 = alloc_Float64(1);
// compiled num node returning num4930 (depth = 3)
  int op_slot_left_4926 = gc_frame_newslot(num4930);
  params[0] = call4928;
  partcv[0] = 1;
  Object opresult4931 = callmethod(num4930, "..(1)", 1, partcv, params);
// compiled op node returning opresult4931 (depth = 2)
  gc_frame_end(frame);
  return opresult4931;
}
Object meth_collectionsPrelude_values4932(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1974
  setline(1974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_asString4933(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4935 == NULL) {
    strlit4935 = alloc_String(")");
    gc_root(strlit4935);
  }
// compiled string node returning strlit4935 (depth = 3)
  int op_slot_right_4934 = gc_frame_newslot(strlit4935);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_4937 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4940 == NULL) {
    strlit4940 = alloc_String(")to(");
    gc_root(strlit4940);
  }
// compiled string node returning strlit4940 (depth = 5)
  int op_slot_right_4939 = gc_frame_newslot(strlit4940);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_4942 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 6)
  if (strlit4944 == NULL) {
    strlit4944 = alloc_String("range.from(");
    gc_root(strlit4944);
  }
// compiled string node returning strlit4944 (depth = 6)
  int op_slot_left_4942 = gc_frame_newslot(strlit4944);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4945 = callmethod(strlit4944, "++(1)", 1, partcv, params);
// compiled op node returning opresult4945 (depth = 5)
  int op_slot_left_4939 = gc_frame_newslot(opresult4945);
  params[0] = strlit4940;
  partcv[0] = 1;
  Object opresult4946 = callmethod(opresult4945, "++(1)", 1, partcv, params);
// compiled op node returning opresult4946 (depth = 4)
  int op_slot_left_4937 = gc_frame_newslot(opresult4946);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4947 = callmethod(opresult4946, "++(1)", 1, partcv, params);
// compiled op node returning opresult4947 (depth = 3)
  int op_slot_left_4934 = gc_frame_newslot(opresult4947);
  params[0] = strlit4935;
  partcv[0] = 1;
  Object opresult4948 = callmethod(opresult4947, "++(1)", 1, partcv, params);
// compiled op node returning opresult4948 (depth = 2)
  gc_frame_end(frame);
  return opresult4948;
}
Object meth_collectionsPrelude__apply_40_1_41_4960(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe4961 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call4962 = callmethodflags(*var_result, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4961);
// compiled call node returning call4962 (depth = 4)
  gc_frame_end(frame);
  return call4962;
}
Object meth_collectionsPrelude_asList4949(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asList");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 1981
  setline(1981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4950 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4951 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4952 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4953 = gc_frame_new();
// call case 3: self.outer request
  Object call4954 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4953);
// compiled member node returning call4954 (depth = 6)
  Object call4955 = callmethodflags(call4954, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4952);
// compiled member node returning call4955 (depth = 5)
  Object call4956 = callmethodflags(call4955, "list", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4951);
// compiled member node returning call4956 (depth = 4)
  Object call4957 = callmethodflags(call4956, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe4950);
// compiled member node returning call4957 (depth = 3)
  *var_result = call4957;
  if (call4957 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1982
  setline(1982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4958 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile block node (depth = 3)
  Object block4959 = alloc_Block(NULL, NULL, "collectionsPrelude", 1982);
  gc_frame_newslot(block4959);
// method "_apply(_)"
  block_savedest(block4959);
  Object closure4960 = createclosure(2, "_apply(1)");
  setclosureframe(closure4960, stackframe);
  addtoclosure(closure4960, var_result);
  addtoclosure(closure4960, selfslot);
  struct UserObject *uo4960 = (struct UserObject*)block4959;
  uo4960->data[0] = (Object)closure4960;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4960 = addmethod2pos(block4959, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4960, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4960[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4960->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4960);
  meth_meth_collectionsPrelude__apply_40_1_41_4960->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4960->definitionLine = 1991;
// compiled block node returning block4959 (depth = 3)
  gc_frame_newslot(block4959);
// call case 5: prelude request
  params[0] = self;
  params[1] = block4959;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4964 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4958);
// compiled call node returning call4964 (depth = 2)
// Begin line 1983
  setline(1983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude_asSequence4965(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asSequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply4989(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4991 = alloc_Float64(3);
// compiled num node returning num4991 (depth = 4)
  int op_slot_right_4990 = gc_frame_newslot(num4991);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4994 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4995 = gc_frame_new();
// call case 4: self request
  Object call4996 = callmethodflags(self, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4995);
// compiled member node returning call4996 (depth = 6)
  Object call4997 = callmethodflags(call4996, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe4994);
// compiled member node returning call4997 (depth = 5)
  int op_slot_right_4993 = gc_frame_newslot(call4997);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5000 = alloc_Float64(1021);
// compiled num node returning num5000 (depth = 6)
  int op_slot_right_4999 = gc_frame_newslot(num5000);
// starting to compile member node (depth = 6)
  int callframe5002 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5003 = gc_frame_new();
// call case 4: self request
  Object call5004 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5003);
// compiled member node returning call5004 (depth = 7)
  Object call5005 = callmethodflags(call5004, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe5002);
// compiled member node returning call5005 (depth = 6)
  int op_slot_left_4999 = gc_frame_newslot(call5005);
  params[0] = num5000;
  partcv[0] = 1;
  Object prod5006 = callmethod(call5005, "*(1)", 1, partcv, params);
// compiled op node returning prod5006 (depth = 5)
  int op_slot_left_4993 = gc_frame_newslot(prod5006);
  params[0] = call4997;
  partcv[0] = 1;
  Object sum5007 = callmethod(prod5006, "+(1)", 1, partcv, params);
// compiled op node returning sum5007 (depth = 4)
  int op_slot_left_4990 = gc_frame_newslot(sum5007);
  params[0] = num4991;
  partcv[0] = 1;
  Object prod5008 = callmethod(sum5007, "*(1)", 1, partcv, params);
// compiled op node returning prod5008 (depth = 3)
  gc_frame_end(frame);
  return prod5008;
}
Object meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "uncheckedFrom(1)to(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method uncheckedFrom(_)to(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method uncheckedFrom(_)to(_)");
  Object params[1];
  int partcv[2];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_indexable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for uncheckedFrom(_)to(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_lower = &(stackframe->slots[0]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part uncheckedFrom(_)");
  Object *var_upper = &(stackframe->slots[1]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part to(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4655 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4655 = alloc_userobj2(20,21, objclass4655);
  gc_frame_newslot(obj4655);
if (objclass4655 == NULL) {
  glfree(obj4655->class->name);
  obj4655->class->name = "range.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4655, self, 0);
  addmethodreal(obj4655,"outer", &reader_collectionsPrelude_outer_4656);
  Object oldself4655 = self;
  struct StackFrameObject *oldstackframe4655 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4655);
  gc_frame_newslot((Object)stackframe);
  self = obj4655;
  Object *oldselfslot4655 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4655 = (*(struct UserObject *)self).data[0], lowerouter4655 = thisouter4655;
  if (inheritingObject4655) {
    struct UserObject *inho4655 = (struct UserObject *)inheritingObject4655;
    while (inho4655->super != GraceDefaultObject) inho4655 = (struct UserObject *)inho4655->super;
    inho4655->super = obj4655;
    self = inheritingObject4655;
    *selfslot = self;
    lowerouter4655 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4655;
  }
if (objclass4655 == NULL) {
  Method *reader4657 = addmethodrealflags(obj4655, "start",&reader_collectionsPrelude_start_4657, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4657->definitionModule = modulename;
  reader4657->definitionLine = 1904;
}
adddatum2(obj4655, alloc_Undefined(), 1);
if (objclass4655 == NULL) {
  Method *reader4658 = addmethodrealflags(obj4655, "stop",&reader_collectionsPrelude_stop_4658, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4658->definitionModule = modulename;
  reader4658->definitionLine = 1905;
}
adddatum2(obj4655, alloc_Undefined(), 2);
if (objclass4655 == NULL) {
  Method *reader4659 = addmethodrealflags(obj4655, "size",&reader_collectionsPrelude_size_4659, MFLAG_DEF);
  reader4659->definitionModule = modulename;
  reader4659->definitionLine = 1906;
}
adddatum2(obj4655, alloc_Undefined(), 3);
if (objclass4655 == NULL) {
  Method *reader4660 = addmethodrealflags(obj4655, "hash",&reader_collectionsPrelude_hash_4660, MFLAG_DEF);
  reader4660->definitionModule = modulename;
  reader4660->definitionLine = 1909;
}
adddatum2(obj4655, alloc_Undefined(), 4);
// method "iterator"
  block_savedest(obj4655);
  Object closure4661 = createclosure(3, "iterator");
  setclosureframe(closure4661, stackframe);
  addtoclosure(closure4661, var_IteratorExhausted);
  addtoclosure(closure4661, var_lower);
  addtoclosure(closure4661, var_upper);
  struct UserObject *uo4661 = (struct UserObject*)obj4655;
  uo4661->data[5] = (Object)closure4661;
  Method *meth_meth_collectionsPrelude_iterator4661 = addmethod2pos(obj4655, "iterator", &meth_collectionsPrelude_iterator4661, 5);
  int argcv_meth_collectionsPrelude_iterator4661[] = {0};
  meth_meth_collectionsPrelude_iterator4661->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4661);
  meth_meth_collectionsPrelude_iterator4661->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4661->definitionLine = 1911;
  block_savedest(obj4655);
  Object closure4743 = createclosure(3, "iterator$object(1)");
  setclosureframe(closure4743, stackframe);
  addtoclosure(closure4743, var_IteratorExhausted);
  addtoclosure(closure4743, var_lower);
  addtoclosure(closure4743, var_upper);
  Method *meth_meth_collectionsPrelude_iterator4661_object = addmethod2pos(obj4655, "iterator$object(1)", &meth_collectionsPrelude_iterator4661_object, 5);
  meth_meth_collectionsPrelude_iterator4661_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4661_object->definitionLine = 1911;
// method "at(_)"
  block_savedest(obj4655);
  Object closure4744 = createclosure(1, "at(1)");
  setclosureframe(closure4744, stackframe);
  addtoclosure(closure4744, var_BoundsError);
  struct UserObject *uo4744 = (struct UserObject*)obj4655;
  uo4744->data[6] = (Object)closure4744;
  Method *meth_meth_collectionsPrelude_at_40_1_41_4744 = addmethod2pos(obj4655, "at(1)", &meth_collectionsPrelude_at_40_1_41_4744, 6);
  int argcv_meth_collectionsPrelude_at_40_1_41_4744[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_4744->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_4744);
meth_meth_collectionsPrelude_at_40_1_41_4744->type->types[0] = type_Number;
meth_meth_collectionsPrelude_at_40_1_41_4744->type->names[0] = "ix";
  meth_meth_collectionsPrelude_at_40_1_41_4744->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_4744->definitionLine = 1925;
// method "contains(_)"
  block_savedest(obj4655);
  Object closure4798 = createclosure(1, "contains(1)");
  setclosureframe(closure4798, stackframe);
  addtoclosure(closure4798, var__prelude);
  struct UserObject *uo4798 = (struct UserObject*)obj4655;
  uo4798->data[7] = (Object)closure4798;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_4798 = addmethod2pos(obj4655, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_4798, 7);
  int argcv_meth_collectionsPrelude_contains_40_1_41_4798[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_4798->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_4798);
  meth_meth_collectionsPrelude_contains_40_1_41_4798->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_4798->definitionLine = 1934;
// method "do(_)"
  struct UserObject *uo4840 = (struct UserObject*)obj4655;
  uo4840->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_4840 = addmethod2pos(obj4655, "do(1)", &meth_collectionsPrelude_do_40_1_41_4840, 8);
  int argcv_meth_collectionsPrelude_do_40_1_41_4840[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_4840->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_4840);
  meth_meth_collectionsPrelude_do_40_1_41_4840->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_4840->definitionLine = 1943;
// method "keysAndValuesDo(_)"
  struct UserObject *uo4863 = (struct UserObject*)obj4655;
  uo4863->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4863 = addmethod2pos(obj4655, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_4863, 9);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4863[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4863->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4863);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4863->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4863->definitionLine = 1950;
// method "reversed"
  block_savedest(obj4655);
  Object closure4892 = createclosure(2, "reversed");
  setclosureframe(closure4892, stackframe);
  addtoclosure(closure4892, var_upper);
  addtoclosure(closure4892, var_lower);
  struct UserObject *uo4892 = (struct UserObject*)obj4655;
  uo4892->data[10] = (Object)closure4892;
  Method *meth_meth_collectionsPrelude_reversed4892 = addmethod2pos(obj4655, "reversed", &meth_collectionsPrelude_reversed4892, 10);
  int argcv_meth_collectionsPrelude_reversed4892[] = {0};
  meth_meth_collectionsPrelude_reversed4892->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed4892);
  meth_meth_collectionsPrelude_reversed4892->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed4892->definitionLine = 1959;
// method "++(_)"
  struct UserObject *uo4897 = (struct UserObject*)obj4655;
  uo4897->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_4897 = addmethod2pos(obj4655, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_4897, 11);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_4897[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_4897->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_4897);
  meth_meth_collectionsPrelude__43__43__40_1_41_4897->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_4897->definitionLine = 1962;
// method "==(_)"
  struct UserObject *uo4912 = (struct UserObject*)obj4655;
  uo4912->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_4912 = addmethod2pos(obj4655, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_4912, 12);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_4912[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_4912->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_4912);
  meth_meth_collectionsPrelude__61__61__40_1_41_4912->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_4912->definitionLine = 1965;
// method "sorted"
  struct UserObject *uo4919 = (struct UserObject*)obj4655;
  uo4919->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted4919 = addmethod2pos(obj4655, "sorted", &meth_collectionsPrelude_sorted4919, 13);
  int argcv_meth_collectionsPrelude_sorted4919[] = {0};
  meth_meth_collectionsPrelude_sorted4919->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted4919);
  meth_meth_collectionsPrelude_sorted4919->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted4919->definitionLine = 1968;
// method "sortedBy(_)"
  struct UserObject *uo4920 = (struct UserObject*)obj4655;
  uo4920->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_4920 = addmethod2pos(obj4655, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_4920, 14);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_4920[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_4920->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_4920);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_4920->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_4920->definitionLine = 1970;
// method "keys"
  struct UserObject *uo4925 = (struct UserObject*)obj4655;
  uo4925->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys4925 = addmethod2pos(obj4655, "keys", &meth_collectionsPrelude_keys4925, 15);
  int argcv_meth_collectionsPrelude_keys4925[] = {0};
  meth_meth_collectionsPrelude_keys4925->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys4925);
  meth_meth_collectionsPrelude_keys4925->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys4925->definitionLine = 1972;
// method "values"
  struct UserObject *uo4932 = (struct UserObject*)obj4655;
  uo4932->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values4932 = addmethod2pos(obj4655, "values", &meth_collectionsPrelude_values4932, 16);
  int argcv_meth_collectionsPrelude_values4932[] = {0};
  meth_meth_collectionsPrelude_values4932->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values4932);
  meth_meth_collectionsPrelude_values4932->definitionModule = modulename;
  meth_meth_collectionsPrelude_values4932->definitionLine = 1974;
// method "asString"
  block_savedest(obj4655);
  Object closure4933 = createclosure(2, "asString");
  setclosureframe(closure4933, stackframe);
  addtoclosure(closure4933, var_upper);
  addtoclosure(closure4933, var_lower);
  struct UserObject *uo4933 = (struct UserObject*)obj4655;
  uo4933->data[17] = (Object)closure4933;
  Method *meth_meth_collectionsPrelude_asString4933 = addmethod2pos(obj4655, "asString", &meth_collectionsPrelude_asString4933, 17);
  int argcv_meth_collectionsPrelude_asString4933[] = {0};
  meth_meth_collectionsPrelude_asString4933->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4933);
  meth_meth_collectionsPrelude_asString4933->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4933->definitionLine = 1976;
// method "asList"
  struct UserObject *uo4949 = (struct UserObject*)obj4655;
  uo4949->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asList4949 = addmethod2pos(obj4655, "asList", &meth_collectionsPrelude_asList4949, 18);
  int argcv_meth_collectionsPrelude_asList4949[] = {0};
  meth_meth_collectionsPrelude_asList4949->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asList4949);
  meth_meth_collectionsPrelude_asList4949->definitionModule = modulename;
  meth_meth_collectionsPrelude_asList4949->definitionLine = 1980;
// method "asSequence"
  struct UserObject *uo4965 = (struct UserObject*)obj4655;
  uo4965->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence4965 = addmethod2pos(obj4655, "asSequence", &meth_collectionsPrelude_asSequence4965, 19);
  int argcv_meth_collectionsPrelude_asSequence4965[] = {0};
  meth_meth_collectionsPrelude_asSequence4965->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence4965);
  meth_meth_collectionsPrelude_asSequence4965->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence4965->definitionLine = 1986;
  sourceObject = obj4655;
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4966 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4967 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4966);
// compiled call node returning call4967 (depth = 2)
  struct UserObject *obj4655_uo = (struct UserObject *)obj4655;
  obj4655_uo->super = call4967;
  sourceObject = obj4655;
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lower (depth = 2)
  adddatum2(obj4655, *var_lower, 1);
  sourceObject = obj4655;
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_upper (depth = 2)
  adddatum2(obj4655, *var_upper, 2);
  sourceObject = obj4655;
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4970 = alloc_Float64(0);
// compiled num node returning num4970 (depth = 4)
  int op_slot_right_4969 = gc_frame_newslot(num4970);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4973 = alloc_Float64(1);
// compiled num node returning num4973 (depth = 5)
  int op_slot_right_4972 = gc_frame_newslot(num4973);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_4975 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_4975 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4977 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff4977 (depth = 5)
  int op_slot_left_4972 = gc_frame_newslot(diff4977);
  params[0] = num4973;
  partcv[0] = 1;
  Object sum4978 = callmethod(diff4977, "+(1)", 1, partcv, params);
// compiled op node returning sum4978 (depth = 4)
  int op_slot_left_4969 = gc_frame_newslot(sum4978);
  params[0] = num4970;
  partcv[0] = 1;
  Object opresult4979 = callmethod(sum4978, "<(1)", 1, partcv, params);
// compiled op node returning opresult4979 (depth = 3)
  Object if4968 = done;
struct StackFrameObject *iftmpstackframe4968 = stackframe;
  if (istrue(opresult4979)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4968);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 3)
  Object num4980 = alloc_Float64(0);
// compiled num node returning num4980 (depth = 3)
    gc_frame_newslot(num4980);
    if4968 = num4980;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe4968);
  gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4982 = alloc_Float64(1);
// compiled num node returning num4982 (depth = 4)
  int op_slot_right_4981 = gc_frame_newslot(num4982);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_4984 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_4984 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4986 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff4986 (depth = 4)
  int op_slot_left_4981 = gc_frame_newslot(diff4986);
  params[0] = num4982;
  partcv[0] = 1;
  Object sum4987 = callmethod(diff4986, "+(1)", 1, partcv, params);
// compiled op node returning sum4987 (depth = 3)
    gc_frame_newslot(sum4987);
    if4968 = sum4987;
  }
stackframe = iftmpstackframe4968;
// compiled if node returning if4968 (depth = 2)
  adddatum2(obj4655, if4968, 3);
  sourceObject = obj4655;
// Begin line 1909
  setline(1909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 2)
  Object block4988 = alloc_Block(NULL, NULL, "collectionsPrelude", 1909);
  gc_frame_newslot(block4988);
// method "_apply"
  block_savedest(block4988);
  Object closure4989 = createclosure(1, "_apply");
  setclosureframe(closure4989, stackframe);
  addtoclosure(closure4989, selfslot);
  struct UserObject *uo4989 = (struct UserObject*)block4988;
  uo4989->data[0] = (Object)closure4989;
  Method *meth_meth_collectionsPrelude__apply4989 = addmethod2pos(block4988, "_apply", &meth_collectionsPrelude__apply4989, 0);
  int argcv_meth_collectionsPrelude__apply4989[] = {0};
  meth_meth_collectionsPrelude__apply4989->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4989);
  meth_meth_collectionsPrelude__apply4989->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4989->definitionLine = 1991;
// compiled block node returning block4988 (depth = 2)
  adddatum2(obj4655, block4988, 4);
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  objclass4655 = obj4655->class;
  objclass4655->definitionModule = modulename;
  objclass4655->definitionLine = 1902;
  (*(struct UserObject *)self).data[0] = lowerouter4655;
  self = oldself4655;
  selfslot = oldselfslot4655;
  stackframe = oldstackframe4655;
  gc_frame_end(frame);
  return obj4655;
}
Object meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "uncheckedFrom(1)to(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method uncheckedFrom(_)to(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method uncheckedFrom(_)to(_)");
  Object params[1];
  int partcv[2];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_indexable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for uncheckedFrom(_)to(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_lower = &(stackframe->slots[0]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part uncheckedFrom(_)");
  Object *var_upper = &(stackframe->slots[1]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part to(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4655 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4655 = alloc_userobj2(20,21, objclass4655);
  gc_frame_newslot(obj4655);
if (objclass4655 == NULL) {
  glfree(obj4655->class->name);
  obj4655->class->name = "range.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4655, self, 0);
  addmethodreal(obj4655,"outer", &reader_collectionsPrelude_outer_4656);
  Object oldself4655 = self;
  struct StackFrameObject *oldstackframe4655 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4655);
  gc_frame_newslot((Object)stackframe);
  self = obj4655;
  Object *oldselfslot4655 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4655 = (*(struct UserObject *)self).data[0], lowerouter4655 = thisouter4655;
  if (inheritingObject4655) {
    struct UserObject *inho4655 = (struct UserObject *)inheritingObject4655;
    while (inho4655->super != GraceDefaultObject) inho4655 = (struct UserObject *)inho4655->super;
    inho4655->super = obj4655;
    self = inheritingObject4655;
    *selfslot = self;
    lowerouter4655 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4655;
  }
if (objclass4655 == NULL) {
  Method *reader4657 = addmethodrealflags(obj4655, "start",&reader_collectionsPrelude_start_4657, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4657->definitionModule = modulename;
  reader4657->definitionLine = 1904;
}
adddatum2(obj4655, alloc_Undefined(), 1);
if (objclass4655 == NULL) {
  Method *reader4658 = addmethodrealflags(obj4655, "stop",&reader_collectionsPrelude_stop_4658, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4658->definitionModule = modulename;
  reader4658->definitionLine = 1905;
}
adddatum2(obj4655, alloc_Undefined(), 2);
if (objclass4655 == NULL) {
  Method *reader4659 = addmethodrealflags(obj4655, "size",&reader_collectionsPrelude_size_4659, MFLAG_DEF);
  reader4659->definitionModule = modulename;
  reader4659->definitionLine = 1906;
}
adddatum2(obj4655, alloc_Undefined(), 3);
if (objclass4655 == NULL) {
  Method *reader4660 = addmethodrealflags(obj4655, "hash",&reader_collectionsPrelude_hash_4660, MFLAG_DEF);
  reader4660->definitionModule = modulename;
  reader4660->definitionLine = 1909;
}
adddatum2(obj4655, alloc_Undefined(), 4);
// method "iterator"
  block_savedest(obj4655);
  Object closure4661 = createclosure(3, "iterator");
  setclosureframe(closure4661, stackframe);
  addtoclosure(closure4661, var_IteratorExhausted);
  addtoclosure(closure4661, var_lower);
  addtoclosure(closure4661, var_upper);
  struct UserObject *uo4661 = (struct UserObject*)obj4655;
  uo4661->data[5] = (Object)closure4661;
  Method *meth_meth_collectionsPrelude_iterator4661 = addmethod2pos(obj4655, "iterator", &meth_collectionsPrelude_iterator4661, 5);
  int argcv_meth_collectionsPrelude_iterator4661[] = {0};
  meth_meth_collectionsPrelude_iterator4661->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4661);
  meth_meth_collectionsPrelude_iterator4661->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4661->definitionLine = 1911;
  block_savedest(obj4655);
  Object closure4743 = createclosure(3, "iterator$object(1)");
  setclosureframe(closure4743, stackframe);
  addtoclosure(closure4743, var_IteratorExhausted);
  addtoclosure(closure4743, var_lower);
  addtoclosure(closure4743, var_upper);
  Method *meth_meth_collectionsPrelude_iterator4661_object = addmethod2pos(obj4655, "iterator$object(1)", &meth_collectionsPrelude_iterator4661_object, 5);
  meth_meth_collectionsPrelude_iterator4661_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4661_object->definitionLine = 1911;
// method "at(_)"
  block_savedest(obj4655);
  Object closure4744 = createclosure(1, "at(1)");
  setclosureframe(closure4744, stackframe);
  addtoclosure(closure4744, var_BoundsError);
  struct UserObject *uo4744 = (struct UserObject*)obj4655;
  uo4744->data[6] = (Object)closure4744;
  Method *meth_meth_collectionsPrelude_at_40_1_41_4744 = addmethod2pos(obj4655, "at(1)", &meth_collectionsPrelude_at_40_1_41_4744, 6);
  int argcv_meth_collectionsPrelude_at_40_1_41_4744[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_4744->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_4744);
meth_meth_collectionsPrelude_at_40_1_41_4744->type->types[0] = type_Number;
meth_meth_collectionsPrelude_at_40_1_41_4744->type->names[0] = "ix";
  meth_meth_collectionsPrelude_at_40_1_41_4744->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_4744->definitionLine = 1925;
// method "contains(_)"
  block_savedest(obj4655);
  Object closure4798 = createclosure(1, "contains(1)");
  setclosureframe(closure4798, stackframe);
  addtoclosure(closure4798, var__prelude);
  struct UserObject *uo4798 = (struct UserObject*)obj4655;
  uo4798->data[7] = (Object)closure4798;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_4798 = addmethod2pos(obj4655, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_4798, 7);
  int argcv_meth_collectionsPrelude_contains_40_1_41_4798[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_4798->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_4798);
  meth_meth_collectionsPrelude_contains_40_1_41_4798->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_4798->definitionLine = 1934;
// method "do(_)"
  struct UserObject *uo4840 = (struct UserObject*)obj4655;
  uo4840->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_4840 = addmethod2pos(obj4655, "do(1)", &meth_collectionsPrelude_do_40_1_41_4840, 8);
  int argcv_meth_collectionsPrelude_do_40_1_41_4840[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_4840->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_4840);
  meth_meth_collectionsPrelude_do_40_1_41_4840->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_4840->definitionLine = 1943;
// method "keysAndValuesDo(_)"
  struct UserObject *uo4863 = (struct UserObject*)obj4655;
  uo4863->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4863 = addmethod2pos(obj4655, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_4863, 9);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4863[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4863->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4863);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4863->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4863->definitionLine = 1950;
// method "reversed"
  block_savedest(obj4655);
  Object closure4892 = createclosure(2, "reversed");
  setclosureframe(closure4892, stackframe);
  addtoclosure(closure4892, var_upper);
  addtoclosure(closure4892, var_lower);
  struct UserObject *uo4892 = (struct UserObject*)obj4655;
  uo4892->data[10] = (Object)closure4892;
  Method *meth_meth_collectionsPrelude_reversed4892 = addmethod2pos(obj4655, "reversed", &meth_collectionsPrelude_reversed4892, 10);
  int argcv_meth_collectionsPrelude_reversed4892[] = {0};
  meth_meth_collectionsPrelude_reversed4892->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed4892);
  meth_meth_collectionsPrelude_reversed4892->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed4892->definitionLine = 1959;
// method "++(_)"
  struct UserObject *uo4897 = (struct UserObject*)obj4655;
  uo4897->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_4897 = addmethod2pos(obj4655, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_4897, 11);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_4897[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_4897->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_4897);
  meth_meth_collectionsPrelude__43__43__40_1_41_4897->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_4897->definitionLine = 1962;
// method "==(_)"
  struct UserObject *uo4912 = (struct UserObject*)obj4655;
  uo4912->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_4912 = addmethod2pos(obj4655, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_4912, 12);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_4912[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_4912->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_4912);
  meth_meth_collectionsPrelude__61__61__40_1_41_4912->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_4912->definitionLine = 1965;
// method "sorted"
  struct UserObject *uo4919 = (struct UserObject*)obj4655;
  uo4919->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted4919 = addmethod2pos(obj4655, "sorted", &meth_collectionsPrelude_sorted4919, 13);
  int argcv_meth_collectionsPrelude_sorted4919[] = {0};
  meth_meth_collectionsPrelude_sorted4919->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted4919);
  meth_meth_collectionsPrelude_sorted4919->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted4919->definitionLine = 1968;
// method "sortedBy(_)"
  struct UserObject *uo4920 = (struct UserObject*)obj4655;
  uo4920->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_4920 = addmethod2pos(obj4655, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_4920, 14);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_4920[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_4920->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_4920);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_4920->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_4920->definitionLine = 1970;
// method "keys"
  struct UserObject *uo4925 = (struct UserObject*)obj4655;
  uo4925->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys4925 = addmethod2pos(obj4655, "keys", &meth_collectionsPrelude_keys4925, 15);
  int argcv_meth_collectionsPrelude_keys4925[] = {0};
  meth_meth_collectionsPrelude_keys4925->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys4925);
  meth_meth_collectionsPrelude_keys4925->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys4925->definitionLine = 1972;
// method "values"
  struct UserObject *uo4932 = (struct UserObject*)obj4655;
  uo4932->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values4932 = addmethod2pos(obj4655, "values", &meth_collectionsPrelude_values4932, 16);
  int argcv_meth_collectionsPrelude_values4932[] = {0};
  meth_meth_collectionsPrelude_values4932->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values4932);
  meth_meth_collectionsPrelude_values4932->definitionModule = modulename;
  meth_meth_collectionsPrelude_values4932->definitionLine = 1974;
// method "asString"
  block_savedest(obj4655);
  Object closure4933 = createclosure(2, "asString");
  setclosureframe(closure4933, stackframe);
  addtoclosure(closure4933, var_upper);
  addtoclosure(closure4933, var_lower);
  struct UserObject *uo4933 = (struct UserObject*)obj4655;
  uo4933->data[17] = (Object)closure4933;
  Method *meth_meth_collectionsPrelude_asString4933 = addmethod2pos(obj4655, "asString", &meth_collectionsPrelude_asString4933, 17);
  int argcv_meth_collectionsPrelude_asString4933[] = {0};
  meth_meth_collectionsPrelude_asString4933->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4933);
  meth_meth_collectionsPrelude_asString4933->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4933->definitionLine = 1976;
// method "asList"
  struct UserObject *uo4949 = (struct UserObject*)obj4655;
  uo4949->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asList4949 = addmethod2pos(obj4655, "asList", &meth_collectionsPrelude_asList4949, 18);
  int argcv_meth_collectionsPrelude_asList4949[] = {0};
  meth_meth_collectionsPrelude_asList4949->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asList4949);
  meth_meth_collectionsPrelude_asList4949->definitionModule = modulename;
  meth_meth_collectionsPrelude_asList4949->definitionLine = 1980;
// method "asSequence"
  struct UserObject *uo4965 = (struct UserObject*)obj4655;
  uo4965->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence4965 = addmethod2pos(obj4655, "asSequence", &meth_collectionsPrelude_asSequence4965, 19);
  int argcv_meth_collectionsPrelude_asSequence4965[] = {0};
  meth_meth_collectionsPrelude_asSequence4965->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence4965);
  meth_meth_collectionsPrelude_asSequence4965->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence4965->definitionLine = 1986;
  sourceObject = obj4655;
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4966 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4967 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4966);
// compiled call node returning call4967 (depth = 2)
  struct UserObject *obj4655_uo = (struct UserObject *)obj4655;
  obj4655_uo->super = call4967;
  sourceObject = obj4655;
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lower (depth = 2)
  adddatum2(obj4655, *var_lower, 1);
  sourceObject = obj4655;
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_upper (depth = 2)
  adddatum2(obj4655, *var_upper, 2);
  sourceObject = obj4655;
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4970 = alloc_Float64(0);
// compiled num node returning num4970 (depth = 4)
  int op_slot_right_4969 = gc_frame_newslot(num4970);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4973 = alloc_Float64(1);
// compiled num node returning num4973 (depth = 5)
  int op_slot_right_4972 = gc_frame_newslot(num4973);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_4975 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_4975 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4977 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff4977 (depth = 5)
  int op_slot_left_4972 = gc_frame_newslot(diff4977);
  params[0] = num4973;
  partcv[0] = 1;
  Object sum4978 = callmethod(diff4977, "+(1)", 1, partcv, params);
// compiled op node returning sum4978 (depth = 4)
  int op_slot_left_4969 = gc_frame_newslot(sum4978);
  params[0] = num4970;
  partcv[0] = 1;
  Object opresult4979 = callmethod(sum4978, "<(1)", 1, partcv, params);
// compiled op node returning opresult4979 (depth = 3)
  Object if4968 = done;
struct StackFrameObject *iftmpstackframe4968 = stackframe;
  if (istrue(opresult4979)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4968);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 3)
  Object num4980 = alloc_Float64(0);
// compiled num node returning num4980 (depth = 3)
    gc_frame_newslot(num4980);
    if4968 = num4980;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe4968);
  gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4982 = alloc_Float64(1);
// compiled num node returning num4982 (depth = 4)
  int op_slot_right_4981 = gc_frame_newslot(num4982);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_4984 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_4984 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4986 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff4986 (depth = 4)
  int op_slot_left_4981 = gc_frame_newslot(diff4986);
  params[0] = num4982;
  partcv[0] = 1;
  Object sum4987 = callmethod(diff4986, "+(1)", 1, partcv, params);
// compiled op node returning sum4987 (depth = 3)
    gc_frame_newslot(sum4987);
    if4968 = sum4987;
  }
stackframe = iftmpstackframe4968;
// compiled if node returning if4968 (depth = 2)
  adddatum2(obj4655, if4968, 3);
  sourceObject = obj4655;
// Begin line 1909
  setline(1909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 2)
  Object block4988 = alloc_Block(NULL, NULL, "collectionsPrelude", 1909);
  gc_frame_newslot(block4988);
// method "_apply"
  block_savedest(block4988);
  Object closure4989 = createclosure(1, "_apply");
  setclosureframe(closure4989, stackframe);
  addtoclosure(closure4989, selfslot);
  struct UserObject *uo4989 = (struct UserObject*)block4988;
  uo4989->data[0] = (Object)closure4989;
  Method *meth_meth_collectionsPrelude__apply4989 = addmethod2pos(block4988, "_apply", &meth_collectionsPrelude__apply4989, 0);
  int argcv_meth_collectionsPrelude__apply4989[] = {0};
  meth_meth_collectionsPrelude__apply4989->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4989);
  meth_meth_collectionsPrelude__apply4989->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4989->definitionLine = 1991;
// compiled block node returning block4988 (depth = 2)
  adddatum2(obj4655, block4988, 4);
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  sourceObject = obj4655;
  objclass4655 = obj4655->class;
  objclass4655->definitionModule = modulename;
  objclass4655->definitionLine = 1902;
  (*(struct UserObject *)self).data[0] = lowerouter4655;
  self = oldself4655;
  selfslot = oldselfslot4655;
  stackframe = oldstackframe4655;
  gc_frame_end(frame);
  return obj4655;
}
Object meth_collectionsPrelude_hasNext5021(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5023 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5024 = gc_frame_new();
// call case 3: self.outer request
  Object call5025 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5024);
// compiled member node returning call5025 (depth = 4)
  Object call5026 = callmethodflags(call5025, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5023);
// compiled member node returning call5026 (depth = 3)
  int op_slot_right_5022 = gc_frame_newslot(call5026);
// starting to compile member node (depth = 3)
  int callframe5028 = gc_frame_new();
// call case 4: self request
  Object call5029 = callmethodflags(self, "val", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5028);
// compiled member node returning call5029 (depth = 3)
  int op_slot_left_5022 = gc_frame_newslot(call5029);
  params[0] = call5026;
  partcv[0] = 1;
  Object opresult5030 = callmethod(call5029, "≥(1)", 1, partcv, params);
// compiled op node returning opresult5030 (depth = 2)
  gc_frame_end(frame);
  return opresult5030;
}
Object meth_collectionsPrelude_next5031(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2019
  setline(2019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5034 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5035 = gc_frame_new();
// call case 3: self.outer request
  Object call5036 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5035);
// compiled member node returning call5036 (depth = 5)
  Object call5037 = callmethodflags(call5036, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5034);
// compiled member node returning call5037 (depth = 4)
  int op_slot_right_5033 = gc_frame_newslot(call5037);
// starting to compile member node (depth = 4)
  int callframe5039 = gc_frame_new();
// call case 4: self request
  Object call5040 = callmethodflags(self, "val", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5039);
// compiled member node returning call5040 (depth = 4)
  int op_slot_left_5033 = gc_frame_newslot(call5040);
  params[0] = call5037;
  partcv[0] = 1;
  Object opresult5041 = callmethod(call5040, "<(1)", 1, partcv, params);
// compiled op node returning opresult5041 (depth = 3)
  Object if5032 = done;
  if (istrue(opresult5041)) {
// starting to compile call node (depth = 3)
  int callframe5042 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5044 == NULL) {
    strlit5044 = alloc_String("");
    gc_root(strlit5044);
  }
// compiled string node returning strlit5044 (depth = 5)
  int op_slot_right_5043 = gc_frame_newslot(strlit5044);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5047 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5048 = gc_frame_new();
// call case 3: self.outer request
  Object call5049 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5048);
// compiled member node returning call5049 (depth = 7)
  Object call5050 = callmethodflags(call5049, "asString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5047);
// compiled member node returning call5050 (depth = 6)
  int op_slot_right_5046 = gc_frame_newslot(call5050);
// starting to compile string node (depth = 6)
  if (strlit5052 == NULL) {
    strlit5052 = alloc_String("over ");
    gc_root(strlit5052);
  }
// compiled string node returning strlit5052 (depth = 6)
  int op_slot_left_5046 = gc_frame_newslot(strlit5052);
  params[0] = call5050;
  partcv[0] = 1;
  Object opresult5053 = callmethod(strlit5052, "++(1)", 1, partcv, params);
// compiled op node returning opresult5053 (depth = 5)
  int op_slot_left_5043 = gc_frame_newslot(opresult5053);
  params[0] = strlit5044;
  partcv[0] = 1;
  Object opresult5054 = callmethod(opresult5053, "++(1)", 1, partcv, params);
// compiled op node returning opresult5054 (depth = 4)
  gc_frame_newslot(opresult5054);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = opresult5054;
  partcv[0] = 1;
  Object call5055 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5042);
// compiled call node returning call5055 (depth = 3)
    gc_frame_newslot(call5055);
    if5032 = call5055;
  } else {
  }
// compiled if node returning if5032 (depth = 2)
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5056 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5058 = alloc_Float64(1);
// compiled num node returning num5058 (depth = 4)
  int op_slot_right_5057 = gc_frame_newslot(num5058);
// starting to compile member node (depth = 4)
  int callframe5060 = gc_frame_new();
// call case 4: self request
  Object call5061 = callmethodflags(self, "val", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5060);
// compiled member node returning call5061 (depth = 4)
  int op_slot_left_5057 = gc_frame_newslot(call5061);
  params[0] = num5058;
  partcv[0] = 1;
  Object diff5062 = callmethod(call5061, "-(1)", 1, partcv, params);
// compiled op node returning diff5062 (depth = 3)
  gc_frame_newslot(diff5062);
// call case 4: self request
  params[0] = diff5062;
  partcv[0] = 1;
  Object call5063 = callmethodflags(self, "val:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5056);
// compiled call node returning call5063 (depth = 2)
// Begin line 2021
  setline(2021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5065 = alloc_Float64(1);
// compiled num node returning num5065 (depth = 4)
  int op_slot_right_5064 = gc_frame_newslot(num5065);
// starting to compile member node (depth = 4)
  int callframe5067 = gc_frame_new();
// call case 4: self request
  Object call5068 = callmethodflags(self, "val", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5067);
// compiled member node returning call5068 (depth = 4)
  int op_slot_left_5064 = gc_frame_newslot(call5068);
  params[0] = num5065;
  partcv[0] = 1;
  Object sum5069 = callmethod(call5068, "+(1)", 1, partcv, params);
// compiled op node returning sum5069 (depth = 3)
  return sum5069;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_asString5070(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2023
  setline(2023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit5072 == NULL) {
    strlit5072 = alloc_String("");
    gc_root(strlit5072);
  }
// compiled string node returning strlit5072 (depth = 3)
  int op_slot_right_5071 = gc_frame_newslot(strlit5072);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5075 = gc_frame_new();
// call case 1: super request
  Object call5076 = callmethod4(self, "asString", 0, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5075);
// compiled member node returning call5076 (depth = 4)
  int op_slot_right_5074 = gc_frame_newslot(call5076);
// starting to compile string node (depth = 4)
  if (strlit5078 == NULL) {
    strlit5078 = alloc_String("anIterator over ");
    gc_root(strlit5078);
  }
// compiled string node returning strlit5078 (depth = 4)
  int op_slot_left_5074 = gc_frame_newslot(strlit5078);
  params[0] = call5076;
  partcv[0] = 1;
  Object opresult5079 = callmethod(strlit5078, "++(1)", 1, partcv, params);
// compiled op node returning opresult5079 (depth = 3)
  int op_slot_left_5071 = gc_frame_newslot(opresult5079);
  params[0] = strlit5072;
  partcv[0] = 1;
  Object opresult5080 = callmethod(opresult5079, "++(1)", 1, partcv, params);
// compiled op node returning opresult5080 (depth = 2)
  gc_frame_end(frame);
  return opresult5080;
}
Object meth_collectionsPrelude_iterator5017(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5018 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5018 = alloc_userobj2(5,5, objclass5018);
  gc_frame_newslot(obj5018);
if (objclass5018 == NULL) {
  glfree(obj5018->class->name);
  obj5018->class->name = "range.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5018, self, 0);
  addmethodreal(obj5018,"outer", &reader_collectionsPrelude_outer_5019);
  Object oldself5018 = self;
  struct StackFrameObject *oldstackframe5018 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5018);
  gc_frame_newslot((Object)stackframe);
  self = obj5018;
  Object *oldselfslot5018 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5018 = (*(struct UserObject *)self).data[0], lowerouter5018 = thisouter5018;
  if (inheritingObject5018) {
    struct UserObject *inho5018 = (struct UserObject *)inheritingObject5018;
    while (inho5018->super != GraceDefaultObject) inho5018 = (struct UserObject *)inho5018->super;
    inho5018->super = obj5018;
    self = inheritingObject5018;
    *selfslot = self;
    lowerouter5018 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5018;
  }
if (objclass5018 == NULL) {
  Method *reader5020 = addmethodrealflags(obj5018, "val", &reader_collectionsPrelude_val_5020, MFLAG_CONFIDENTIAL);
  Method *writer5020 = addmethodrealflags(obj5018, "val:=(1)", &writer_collectionsPrelude_val_5020, MFLAG_CONFIDENTIAL);
  reader5020->definitionModule = modulename;
  writer5020->definitionModule = modulename;
  reader5020->definitionLine = 2016;
  writer5020->definitionLine = 2016;
}
obj5018->flags |= OFLAG_MUTABLE;
adddatum2(obj5018, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo5021 = (struct UserObject*)obj5018;
  uo5021->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext5021 = addmethod2pos(obj5018, "hasNext", &meth_collectionsPrelude_hasNext5021, 2);
  int argcv_meth_collectionsPrelude_hasNext5021[] = {0};
  meth_meth_collectionsPrelude_hasNext5021->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext5021);
  meth_meth_collectionsPrelude_hasNext5021->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext5021->definitionLine = 2017;
// method "next"
  block_savedest(obj5018);
  Object closure5031 = createclosure(1, "next");
  setclosureframe(closure5031, stackframe);
  addtoclosure(closure5031, var_IteratorExhausted);
  struct UserObject *uo5031 = (struct UserObject*)obj5018;
  uo5031->data[3] = (Object)closure5031;
  Method *meth_meth_collectionsPrelude_next5031 = addmethod2pos(obj5018, "next", &meth_collectionsPrelude_next5031, 3);
  int argcv_meth_collectionsPrelude_next5031[] = {0};
  meth_meth_collectionsPrelude_next5031->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next5031);
  meth_meth_collectionsPrelude_next5031->definitionModule = modulename;
  meth_meth_collectionsPrelude_next5031->definitionLine = 2018;
// method "asString"
  struct UserObject *uo5070 = (struct UserObject*)obj5018;
  uo5070->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5070 = addmethod2pos(obj5018, "asString", &meth_collectionsPrelude_asString5070, 4);
  int argcv_meth_collectionsPrelude_asString5070[] = {0};
  meth_meth_collectionsPrelude_asString5070->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5070);
  meth_meth_collectionsPrelude_asString5070->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5070->definitionLine = 2023;
  sourceObject = obj5018;
// Begin line 2016
  setline(2016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5081 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5082 = gc_frame_new();
// call case 3: self.outer request
  Object call5083 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5082);
// compiled member node returning call5083 (depth = 3)
  Object call5084 = callmethodflags(call5083, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5081);
// compiled member node returning call5084 (depth = 2)
  adddatum2(obj5018, call5084, 1);
  sourceObject = obj5018;
  sourceObject = obj5018;
  sourceObject = obj5018;
  objclass5018 = obj5018->class;
  objclass5018->definitionModule = modulename;
  objclass5018->definitionLine = 2015;
  (*(struct UserObject *)self).data[0] = lowerouter5018;
  self = oldself5018;
  selfslot = oldselfslot5018;
  stackframe = oldstackframe5018;
  gc_frame_end(frame);
  return obj5018;
}
Object meth_collectionsPrelude_iterator5017_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5018 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5018 = alloc_userobj2(5,5, objclass5018);
  gc_frame_newslot(obj5018);
if (objclass5018 == NULL) {
  glfree(obj5018->class->name);
  obj5018->class->name = "range.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5018, self, 0);
  addmethodreal(obj5018,"outer", &reader_collectionsPrelude_outer_5019);
  Object oldself5018 = self;
  struct StackFrameObject *oldstackframe5018 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5018);
  gc_frame_newslot((Object)stackframe);
  self = obj5018;
  Object *oldselfslot5018 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5018 = (*(struct UserObject *)self).data[0], lowerouter5018 = thisouter5018;
  if (inheritingObject5018) {
    struct UserObject *inho5018 = (struct UserObject *)inheritingObject5018;
    while (inho5018->super != GraceDefaultObject) inho5018 = (struct UserObject *)inho5018->super;
    inho5018->super = obj5018;
    self = inheritingObject5018;
    *selfslot = self;
    lowerouter5018 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5018;
  }
if (objclass5018 == NULL) {
  Method *reader5020 = addmethodrealflags(obj5018, "val", &reader_collectionsPrelude_val_5020, MFLAG_CONFIDENTIAL);
  Method *writer5020 = addmethodrealflags(obj5018, "val:=(1)", &writer_collectionsPrelude_val_5020, MFLAG_CONFIDENTIAL);
  reader5020->definitionModule = modulename;
  writer5020->definitionModule = modulename;
  reader5020->definitionLine = 2016;
  writer5020->definitionLine = 2016;
}
obj5018->flags |= OFLAG_MUTABLE;
adddatum2(obj5018, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo5021 = (struct UserObject*)obj5018;
  uo5021->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext5021 = addmethod2pos(obj5018, "hasNext", &meth_collectionsPrelude_hasNext5021, 2);
  int argcv_meth_collectionsPrelude_hasNext5021[] = {0};
  meth_meth_collectionsPrelude_hasNext5021->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext5021);
  meth_meth_collectionsPrelude_hasNext5021->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext5021->definitionLine = 2017;
// method "next"
  block_savedest(obj5018);
  Object closure5031 = createclosure(1, "next");
  setclosureframe(closure5031, stackframe);
  addtoclosure(closure5031, var_IteratorExhausted);
  struct UserObject *uo5031 = (struct UserObject*)obj5018;
  uo5031->data[3] = (Object)closure5031;
  Method *meth_meth_collectionsPrelude_next5031 = addmethod2pos(obj5018, "next", &meth_collectionsPrelude_next5031, 3);
  int argcv_meth_collectionsPrelude_next5031[] = {0};
  meth_meth_collectionsPrelude_next5031->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next5031);
  meth_meth_collectionsPrelude_next5031->definitionModule = modulename;
  meth_meth_collectionsPrelude_next5031->definitionLine = 2018;
// method "asString"
  struct UserObject *uo5070 = (struct UserObject*)obj5018;
  uo5070->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5070 = addmethod2pos(obj5018, "asString", &meth_collectionsPrelude_asString5070, 4);
  int argcv_meth_collectionsPrelude_asString5070[] = {0};
  meth_meth_collectionsPrelude_asString5070->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5070);
  meth_meth_collectionsPrelude_asString5070->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5070->definitionLine = 2023;
  sourceObject = obj5018;
// Begin line 2016
  setline(2016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5081 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5082 = gc_frame_new();
// call case 3: self.outer request
  Object call5083 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5082);
// compiled member node returning call5083 (depth = 3)
  Object call5084 = callmethodflags(call5083, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5081);
// compiled member node returning call5084 (depth = 2)
  adddatum2(obj5018, call5084, 1);
  sourceObject = obj5018;
  sourceObject = obj5018;
  sourceObject = obj5018;
  objclass5018 = obj5018->class;
  objclass5018->definitionModule = modulename;
  objclass5018->definitionLine = 2015;
  (*(struct UserObject *)self).data[0] = lowerouter5018;
  self = oldself5018;
  selfslot = oldselfslot5018;
  stackframe = oldstackframe5018;
  gc_frame_end(frame);
  return obj5018;
}
Object meth_collectionsPrelude_at_40_1_41_5086(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5088 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5090 = gc_frame_new();
// call case 4: self request
  Object call5091 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5090);
// compiled member node returning call5091 (depth = 5)
  int op_slot_right_5089 = gc_frame_newslot(call5091);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_5089 = gc_frame_newslot(*var_ix);
  params[0] = call5091;
  partcv[0] = 1;
  Object opresult5093 = callmethod(*var_ix, "≤(1)", 1, partcv, params);
// compiled op node returning opresult5093 (depth = 4)
  partcv[0] = 0;
  Object call5094 = callmethodflags(opresult5093, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe5088);
// compiled call node returning call5094 (depth = 3)
  Object if5087 = done;
  if (istrue(call5094)) {
// Begin line 2028
  setline(2028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5095 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5097 == NULL) {
    strlit5097 = alloc_String("");
    gc_root(strlit5097);
  }
// compiled string node returning strlit5097 (depth = 5)
  int op_slot_right_5096 = gc_frame_newslot(strlit5097);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5100 = gc_frame_new();
// call case 4: self request
  Object call5101 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5100);
// compiled member node returning call5101 (depth = 6)
  int op_slot_right_5099 = gc_frame_newslot(call5101);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5104 == NULL) {
    strlit5104 = alloc_String(") but upper bound is ");
    gc_root(strlit5104);
  }
// compiled string node returning strlit5104 (depth = 7)
  int op_slot_right_5103 = gc_frame_newslot(strlit5104);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  int op_slot_right_5106 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 8)
  if (strlit5108 == NULL) {
    strlit5108 = alloc_String("requested range.at(");
    gc_root(strlit5108);
  }
// compiled string node returning strlit5108 (depth = 8)
  int op_slot_left_5106 = gc_frame_newslot(strlit5108);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult5109 = callmethod(strlit5108, "++(1)", 1, partcv, params);
// compiled op node returning opresult5109 (depth = 7)
  int op_slot_left_5103 = gc_frame_newslot(opresult5109);
  params[0] = strlit5104;
  partcv[0] = 1;
  Object opresult5110 = callmethod(opresult5109, "++(1)", 1, partcv, params);
// compiled op node returning opresult5110 (depth = 6)
  int op_slot_left_5099 = gc_frame_newslot(opresult5110);
  params[0] = call5101;
  partcv[0] = 1;
  Object opresult5111 = callmethod(opresult5110, "++(1)", 1, partcv, params);
// compiled op node returning opresult5111 (depth = 5)
  int op_slot_left_5096 = gc_frame_newslot(opresult5111);
  params[0] = strlit5097;
  partcv[0] = 1;
  Object opresult5112 = callmethod(opresult5111, "++(1)", 1, partcv, params);
// compiled op node returning opresult5112 (depth = 4)
  gc_frame_newslot(opresult5112);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult5112;
  partcv[0] = 1;
  Object call5113 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5095);
// compiled call node returning call5113 (depth = 3)
    gc_frame_newslot(call5113);
    if5087 = call5113;
  } else {
  }
// compiled if node returning if5087 (depth = 2)
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5115 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5117 = alloc_Float64(1);
// compiled num node returning num5117 (depth = 5)
  int op_slot_right_5116 = gc_frame_newslot(num5117);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_5116 = gc_frame_newslot(*var_ix);
  params[0] = num5117;
  partcv[0] = 1;
  Object opresult5119 = callmethod(*var_ix, "≥(1)", 1, partcv, params);
// compiled op node returning opresult5119 (depth = 4)
  partcv[0] = 0;
  Object call5120 = callmethodflags(opresult5119, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe5115);
// compiled call node returning call5120 (depth = 3)
  Object if5114 = done;
  if (istrue(call5120)) {
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5121 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5123 == NULL) {
    strlit5123 = alloc_String(") but lower bound is 1");
    gc_root(strlit5123);
  }
// compiled string node returning strlit5123 (depth = 5)
  int op_slot_right_5122 = gc_frame_newslot(strlit5123);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_right_5125 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 6)
  if (strlit5127 == NULL) {
    strlit5127 = alloc_String("requested range.at(");
    gc_root(strlit5127);
  }
// compiled string node returning strlit5127 (depth = 6)
  int op_slot_left_5125 = gc_frame_newslot(strlit5127);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult5128 = callmethod(strlit5127, "++(1)", 1, partcv, params);
// compiled op node returning opresult5128 (depth = 5)
  int op_slot_left_5122 = gc_frame_newslot(opresult5128);
  params[0] = strlit5123;
  partcv[0] = 1;
  Object opresult5129 = callmethod(opresult5128, "++(1)", 1, partcv, params);
// compiled op node returning opresult5129 (depth = 4)
  gc_frame_newslot(opresult5129);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult5129;
  partcv[0] = 1;
  Object call5130 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5121);
// compiled call node returning call5130 (depth = 3)
    gc_frame_newslot(call5130);
    if5114 = call5130;
  } else {
  }
// compiled if node returning if5114 (depth = 2)
// Begin line 2033
  setline(2033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5133 = alloc_Float64(1);
// compiled num node returning num5133 (depth = 5)
  int op_slot_right_5132 = gc_frame_newslot(num5133);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_5132 = gc_frame_newslot(*var_ix);
  params[0] = num5133;
  partcv[0] = 1;
  Object diff5135 = callmethod(*var_ix, "-(1)", 1, partcv, params);
// compiled op node returning diff5135 (depth = 4)
  int op_slot_right_5131 = gc_frame_newslot(diff5135);
// starting to compile member node (depth = 4)
  int callframe5137 = gc_frame_new();
// call case 4: self request
  Object call5138 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5137);
// compiled member node returning call5138 (depth = 4)
  int op_slot_left_5131 = gc_frame_newslot(call5138);
  params[0] = diff5135;
  partcv[0] = 1;
  Object diff5139 = callmethod(call5138, "-(1)", 1, partcv, params);
// compiled op node returning diff5139 (depth = 3)
  return diff5139;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply5143(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elem = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_intElem = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "intElem");
// Begin line 2037
  setline(2037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5144 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elem (depth = 6)
  Object call5145 = callmethodflags(*var_elem, "truncated", 0, partcv, params, 0);
  gc_frame_end(callframe5144);
// compiled member node returning call5145 (depth = 5)
  *var_intElem = call5145;
  if (call5145 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2038
  setline(2038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elem (depth = 6)
  int op_slot_right_5147 = gc_frame_newslot(*var_elem);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_5147 = gc_frame_newslot(*var_intElem);
  params[0] = *var_elem;
  partcv[0] = 1;
  Object opresult5149 = callmethod(*var_intElem, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5149 (depth = 5)
  Object if5146 = done;
  if (istrue(opresult5149)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5150 = alloc_Boolean(0);
// compiled identifier node returning bool5150 (depth = 6)
  block_return(realself, bool5150);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if5146 = undefined;
  } else {
  }
// compiled if node returning if5146 (depth = 4)
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5153 = gc_frame_new();
// call case 4: self request
  Object call5154 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5153);
// compiled member node returning call5154 (depth = 6)
  int op_slot_right_5152 = gc_frame_newslot(call5154);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_5152 = gc_frame_newslot(*var_intElem);
  params[0] = call5154;
  partcv[0] = 1;
  Object opresult5156 = callmethod(*var_intElem, ">(1)", 1, partcv, params);
// compiled op node returning opresult5156 (depth = 5)
  Object if5151 = done;
  if (istrue(opresult5156)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5157 = alloc_Boolean(0);
// compiled identifier node returning bool5157 (depth = 6)
  block_return(realself, bool5157);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if5151 = undefined;
  } else {
  }
// compiled if node returning if5151 (depth = 4)
// Begin line 2040
  setline(2040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5160 = gc_frame_new();
// call case 4: self request
  Object call5161 = callmethodflags(self, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5160);
// compiled member node returning call5161 (depth = 6)
  int op_slot_right_5159 = gc_frame_newslot(call5161);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_5159 = gc_frame_newslot(*var_intElem);
  params[0] = call5161;
  partcv[0] = 1;
  Object opresult5163 = callmethod(*var_intElem, "<(1)", 1, partcv, params);
// compiled op node returning opresult5163 (depth = 5)
  Object if5158 = done;
  if (istrue(opresult5163)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5164 = alloc_Boolean(0);
// compiled identifier node returning bool5164 (depth = 6)
  block_return(realself, bool5164);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if5158 = undefined;
  } else {
  }
// compiled if node returning if5158 (depth = 4)
  gc_frame_end(frame);
  return if5158;
}
Object meth_collectionsPrelude__apply_40_1_41_5167(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ex = &(stackframe->slots[0]);
  *var_ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool5168 = alloc_Boolean(0);
// compiled identifier node returning bool5168 (depth = 5)
  block_return(realself, bool5168);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_contains_40_1_41_5140(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[2];
  int partcv[1];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elem = &(stackframe->slots[0]);
  *var_elem = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile trycatch node (depth = 2)
// starting to compile block node (depth = 3)
  Object block5142 = alloc_Block(NULL, NULL, "collectionsPrelude", 2036);
  gc_frame_newslot(block5142);
// method "_apply"
  block_savedest(block5142);
  Object closure5143 = createclosure(2, "_apply");
  setclosureframe(closure5143, stackframe);
  addtoclosure(closure5143, var_elem);
  addtoclosure(closure5143, selfslot);
  struct UserObject *uo5143 = (struct UserObject*)block5142;
  uo5143->data[0] = (Object)closure5143;
  Method *meth_meth_collectionsPrelude__apply5143 = addmethod2pos(block5142, "_apply", &meth_collectionsPrelude__apply5143, 0);
  int argcv_meth_collectionsPrelude__apply5143[] = {0};
  meth_meth_collectionsPrelude__apply5143->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5143);
  meth_meth_collectionsPrelude__apply5143->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5143->definitionLine = 1991;
// compiled block node returning block5142 (depth = 3)
  int frame5141 = gc_frame_new();
  gc_frame_newslot(block5142);
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5166 = alloc_Block(NULL, NULL, "collectionsPrelude", 2041);
  gc_frame_newslot(block5166);
// method "_apply(_)"
  block_savedest(block5166);
  Object closure5167 = createclosure(1, "_apply(1)");
  setclosureframe(closure5167, stackframe);
  addtoclosure(closure5167, selfslot);
  struct UserObject *uo5167 = (struct UserObject*)block5166;
  uo5167->data[0] = (Object)closure5167;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5167 = addmethod2pos(block5166, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5167, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5167[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5167->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5167);
  meth_meth_collectionsPrelude__apply_40_1_41_5167->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5167->definitionLine = 1991;
// starting to compile call node (depth = 4)
  int callframe5170 = gc_frame_new();
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5171 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5172 == NULL) {
    strlit5172 = alloc_String("ex");
    gc_root(strlit5172);
  }
// compiled string node returning strlit5172 (depth = 6)
  gc_frame_newslot(strlit5172);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5173 = gc_frame_new();
// call case 5: prelude request
  Object call5174 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5173);
// compiled member node returning call5174 (depth = 6)
  params[0] = strlit5172;
  partcv[0] = 1;
  Object call5175 = callmethodflags(call5174, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5171);
// compiled call node returning call5175 (depth = 5)
  gc_frame_newslot(call5175);
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5176 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var__prelude (depth = 6)
  Object call5177 = callmethodflags(*var__prelude, "Exception", 0, partcv, params, 0);
  gc_frame_end(callframe5176);
// compiled member node returning call5177 (depth = 5)
  gc_frame_newslot(call5177);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5178 = gc_frame_new();
// call case 5: prelude request
  Object call5179 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5178);
// compiled member node returning call5179 (depth = 5)
  params[0] = call5175;
  params[1] = call5177;
  partcv[0] = 2;
  Object call5180 = callmethodflags(call5179, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5170);
// compiled call node returning call5180 (depth = 4)
((struct UserObject *)block5166)->data[1] = call5180;
// compiled block node returning block5166 (depth = 3)
  gc_frame_newslot(block5166);
  params[0] = block5166;
  setline(2036);
  Object catchres5141 = tryCatch(block5142, params, 1,NULL);
  gc_frame_end(frame5141);
// compiled trycatch node returning catchres5141 (depth = 2)
// Begin line 2042
  setline(2042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool5181 = alloc_Boolean(1);
// compiled identifier node returning bool5181 (depth = 3)
  return bool5181;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply5187(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5189 = gc_frame_new();
// call case 4: self request
  Object call5190 = callmethodflags(self, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5189);
// compiled member node returning call5190 (depth = 5)
  int op_slot_right_5188 = gc_frame_newslot(call5190);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_5188 = gc_frame_newslot(*var_val);
  params[0] = call5190;
  partcv[0] = 1;
  Object opresult5192 = callmethod(*var_val, "≥(1)", 1, partcv, params);
// compiled op node returning opresult5192 (depth = 4)
  gc_frame_end(frame);
  return opresult5192;
}
Object meth_collectionsPrelude__apply5195(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5196 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = *var_val;
  partcv[0] = 1;
  Object call5197 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5196);
// compiled call node returning call5197 (depth = 4)
// Begin line 2048
  setline(2048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5199 = alloc_Float64(1);
// compiled num node returning num5199 (depth = 6)
  int op_slot_right_5198 = gc_frame_newslot(num5199);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_5198 = gc_frame_newslot(*var_val);
  params[0] = num5199;
  partcv[0] = 1;
  Object diff5201 = callmethod(*var_val, "-(1)", 1, partcv, params);
// compiled op node returning diff5201 (depth = 5)
  *var_val = diff5201;
  if (diff5201 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do_40_1_41_5182(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_val = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "val");
// Begin line 2045
  setline(2045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5183 = gc_frame_new();
// call case 4: self request
  Object call5184 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5183);
// compiled member node returning call5184 (depth = 3)
  *var_val = call5184;
  if (call5184 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2046
  setline(2046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5185 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5186 = alloc_Block(NULL, NULL, "collectionsPrelude", 2046);
  gc_frame_newslot(block5186);
// method "_apply"
  block_savedest(block5186);
  Object closure5187 = createclosure(2, "_apply");
  setclosureframe(closure5187, stackframe);
  addtoclosure(closure5187, var_val);
  addtoclosure(closure5187, selfslot);
  struct UserObject *uo5187 = (struct UserObject*)block5186;
  uo5187->data[0] = (Object)closure5187;
  Method *meth_meth_collectionsPrelude__apply5187 = addmethod2pos(block5186, "_apply", &meth_collectionsPrelude__apply5187, 0);
  int argcv_meth_collectionsPrelude__apply5187[] = {0};
  meth_meth_collectionsPrelude__apply5187->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5187);
  meth_meth_collectionsPrelude__apply5187->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5187->definitionLine = 1991;
// compiled block node returning block5186 (depth = 3)
  gc_frame_newslot(block5186);
// starting to compile block node (depth = 3)
  Object block5194 = alloc_Block(NULL, NULL, "collectionsPrelude", 2046);
  gc_frame_newslot(block5194);
// method "_apply"
  block_savedest(block5194);
  Object closure5195 = createclosure(3, "_apply");
  setclosureframe(closure5195, stackframe);
  addtoclosure(closure5195, var_val);
  addtoclosure(closure5195, var_block1);
  addtoclosure(closure5195, selfslot);
  struct UserObject *uo5195 = (struct UserObject*)block5194;
  uo5195->data[0] = (Object)closure5195;
  Method *meth_meth_collectionsPrelude__apply5195 = addmethod2pos(block5194, "_apply", &meth_collectionsPrelude__apply5195, 0);
  int argcv_meth_collectionsPrelude__apply5195[] = {0};
  meth_meth_collectionsPrelude__apply5195->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5195);
  meth_meth_collectionsPrelude__apply5195->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5195->definitionLine = 1991;
// compiled block node returning block5194 (depth = 3)
  gc_frame_newslot(block5194);
// call case 5: prelude request
  params[0] = block5186;
  params[1] = block5194;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5204 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5185);
// compiled call node returning call5204 (depth = 2)
  gc_frame_end(frame);
  return call5204;
}
Object meth_collectionsPrelude__apply5211(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5213 = gc_frame_new();
// call case 4: self request
  Object call5214 = callmethodflags(self, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5213);
// compiled member node returning call5214 (depth = 5)
  int op_slot_right_5212 = gc_frame_newslot(call5214);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_5212 = gc_frame_newslot(*var_val);
  params[0] = call5214;
  partcv[0] = 1;
  Object opresult5216 = callmethod(*var_val, "≥(1)", 1, partcv, params);
// compiled op node returning opresult5216 (depth = 4)
  gc_frame_end(frame);
  return opresult5216;
}
Object meth_collectionsPrelude__apply5219(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_key = getfromclosure(closure, 0);
  Object *var_val = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2055
  setline(2055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5220 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_key (depth = 5)
  gc_frame_newslot(*var_key);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block2 (depth = 5)
  params[0] = *var_key;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call5221 = callmethodflags(*var_block2, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5220);
// compiled call node returning call5221 (depth = 4)
// Begin line 2056
  setline(2056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5223 = alloc_Float64(1);
// compiled num node returning num5223 (depth = 6)
  int op_slot_right_5222 = gc_frame_newslot(num5223);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_key (depth = 6)
  int op_slot_left_5222 = gc_frame_newslot(*var_key);
  params[0] = num5223;
  partcv[0] = 1;
  Object sum5225 = callmethod(*var_key, "+(1)", 1, partcv, params);
// compiled op node returning sum5225 (depth = 5)
  *var_key = sum5225;
  if (sum5225 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2057
  setline(2057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5228 = alloc_Float64(1);
// compiled num node returning num5228 (depth = 6)
  int op_slot_right_5227 = gc_frame_newslot(num5228);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_5227 = gc_frame_newslot(*var_val);
  params[0] = num5228;
  partcv[0] = 1;
  Object diff5230 = callmethod(*var_val, "-(1)", 1, partcv, params);
// compiled op node returning diff5230 (depth = 5)
  *var_val = diff5230;
  if (diff5230 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_keysAndValuesDo_40_1_41_5205(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_key = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "key");
  Object *var_val = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "val");
// Begin line 2052
  setline(2052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num5206 = alloc_Float64(1);
// compiled num node returning num5206 (depth = 3)
  *var_key = num5206;
  if (num5206 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5207 = gc_frame_new();
// call case 4: self request
  Object call5208 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5207);
// compiled member node returning call5208 (depth = 3)
  *var_val = call5208;
  if (call5208 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2054
  setline(2054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5209 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5210 = alloc_Block(NULL, NULL, "collectionsPrelude", 2054);
  gc_frame_newslot(block5210);
// method "_apply"
  block_savedest(block5210);
  Object closure5211 = createclosure(2, "_apply");
  setclosureframe(closure5211, stackframe);
  addtoclosure(closure5211, var_val);
  addtoclosure(closure5211, selfslot);
  struct UserObject *uo5211 = (struct UserObject*)block5210;
  uo5211->data[0] = (Object)closure5211;
  Method *meth_meth_collectionsPrelude__apply5211 = addmethod2pos(block5210, "_apply", &meth_collectionsPrelude__apply5211, 0);
  int argcv_meth_collectionsPrelude__apply5211[] = {0};
  meth_meth_collectionsPrelude__apply5211->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5211);
  meth_meth_collectionsPrelude__apply5211->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5211->definitionLine = 1991;
// compiled block node returning block5210 (depth = 3)
  gc_frame_newslot(block5210);
// starting to compile block node (depth = 3)
  Object block5218 = alloc_Block(NULL, NULL, "collectionsPrelude", 2054);
  gc_frame_newslot(block5218);
// method "_apply"
  block_savedest(block5218);
  Object closure5219 = createclosure(4, "_apply");
  setclosureframe(closure5219, stackframe);
  addtoclosure(closure5219, var_key);
  addtoclosure(closure5219, var_val);
  addtoclosure(closure5219, var_block2);
  addtoclosure(closure5219, selfslot);
  struct UserObject *uo5219 = (struct UserObject*)block5218;
  uo5219->data[0] = (Object)closure5219;
  Method *meth_meth_collectionsPrelude__apply5219 = addmethod2pos(block5218, "_apply", &meth_collectionsPrelude__apply5219, 0);
  int argcv_meth_collectionsPrelude__apply5219[] = {0};
  meth_meth_collectionsPrelude__apply5219->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5219);
  meth_meth_collectionsPrelude__apply5219->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5219->definitionLine = 1991;
// compiled block node returning block5218 (depth = 3)
  gc_frame_newslot(block5218);
// call case 5: prelude request
  params[0] = block5210;
  params[1] = block5218;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5233 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5209);
// compiled call node returning call5233 (depth = 2)
  gc_frame_end(frame);
  return call5233;
}
Object meth_collectionsPrelude_reversed5234(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5235 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  gc_frame_newslot(*var_upper);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5236 = gc_frame_new();
// call case 3: self.outer request
  Object call5237 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5236);
// compiled member node returning call5237 (depth = 3)
  params[0] = *var_lower;
  params[1] = *var_upper;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5238 = callmethodflags(call5237, "from(1)to(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5235);
// compiled call node returning call5238 (depth = 2)
  gc_frame_end(frame);
  return call5238;
}
Object meth_collectionsPrelude__43__43__40_1_41_5239(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2064
  setline(2064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5240 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe5241 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5242 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5243 = gc_frame_new();
// call case 3: self.outer request
  Object call5244 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5243);
// compiled member node returning call5244 (depth = 5)
  Object call5245 = callmethodflags(call5244, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5242);
// compiled member node returning call5245 (depth = 4)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call5246 = callmethodflags(call5245, "lazyConcatenation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5241);
// compiled call node returning call5246 (depth = 3)
  gc_frame_newslot(call5246);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5247 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5248 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5249 = gc_frame_new();
// call case 3: self.outer request
  Object call5250 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5249);
// compiled member node returning call5250 (depth = 5)
  Object call5251 = callmethodflags(call5250, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5248);
// compiled member node returning call5251 (depth = 4)
  Object call5252 = callmethodflags(call5251, "sequence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5247);
// compiled member node returning call5252 (depth = 3)
  params[0] = call5246;
  partcv[0] = 1;
  Object call5253 = callmethodflags(call5252, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5240);
// compiled call node returning call5253 (depth = 2)
  gc_frame_end(frame);
  return call5253;
}
Object meth_collectionsPrelude__61__61__40_1_41_5254(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2067
  setline(2067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5255 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5256 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5257 = gc_frame_new();
// call case 3: self.outer request
  Object call5258 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5257);
// compiled member node returning call5258 (depth = 4)
  Object call5259 = callmethodflags(call5258, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5256);
// compiled member node returning call5259 (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5260 = callmethodflags(call5259, "isEqual(1)toIterable(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5255);
// compiled call node returning call5260 (depth = 2)
  gc_frame_end(frame);
  return call5260;
}
Object meth_collectionsPrelude_sorted5261(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2069
  setline(2069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5262 = gc_frame_new();
// call case 4: self request
  Object call5263 = callmethodflags(self, "reversed", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5262);
// compiled member node returning call5263 (depth = 2)
  gc_frame_end(frame);
  return call5263;
}
Object meth_collectionsPrelude_sortedBy_40_1_41_5264(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2071
  setline(2071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5265 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5266 = gc_frame_new();
// call case 4: self request
  Object call5267 = callmethodflags(self, "asList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5266);
// compiled member node returning call5267 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call5268 = callmethodflags(call5267, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5265);
// compiled call node returning call5268 (depth = 2)
  gc_frame_end(frame);
  return call5268;
}
Object meth_collectionsPrelude_keys5269(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2073
  setline(2073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5271 = gc_frame_new();
// call case 4: self request
  Object call5272 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5271);
// compiled member node returning call5272 (depth = 3)
  int op_slot_right_5270 = gc_frame_newslot(call5272);
// starting to compile num node (depth = 3)
  Object num5274 = alloc_Float64(1);
// compiled num node returning num5274 (depth = 3)
  int op_slot_left_5270 = gc_frame_newslot(num5274);
  params[0] = call5272;
  partcv[0] = 1;
  Object opresult5275 = callmethod(num5274, "..(1)", 1, partcv, params);
// compiled op node returning opresult5275 (depth = 2)
  gc_frame_end(frame);
  return opresult5275;
}
Object meth_collectionsPrelude_values5276(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2075
  setline(2075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_asString5277(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2078
  setline(2078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit5279 == NULL) {
    strlit5279 = alloc_String("");
    gc_root(strlit5279);
  }
// compiled string node returning strlit5279 (depth = 3)
  int op_slot_right_5278 = gc_frame_newslot(strlit5279);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_5281 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5284 == NULL) {
    strlit5284 = alloc_String(" downTo ");
    gc_root(strlit5284);
  }
// compiled string node returning strlit5284 (depth = 5)
  int op_slot_right_5283 = gc_frame_newslot(strlit5284);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_right_5286 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 6)
  if (strlit5288 == NULL) {
    strlit5288 = alloc_String("range.from ");
    gc_root(strlit5288);
  }
// compiled string node returning strlit5288 (depth = 6)
  int op_slot_left_5286 = gc_frame_newslot(strlit5288);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5289 = callmethod(strlit5288, "++(1)", 1, partcv, params);
// compiled op node returning opresult5289 (depth = 5)
  int op_slot_left_5283 = gc_frame_newslot(opresult5289);
  params[0] = strlit5284;
  partcv[0] = 1;
  Object opresult5290 = callmethod(opresult5289, "++(1)", 1, partcv, params);
// compiled op node returning opresult5290 (depth = 4)
  int op_slot_left_5281 = gc_frame_newslot(opresult5290);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5291 = callmethod(opresult5290, "++(1)", 1, partcv, params);
// compiled op node returning opresult5291 (depth = 3)
  int op_slot_left_5278 = gc_frame_newslot(opresult5291);
  params[0] = strlit5279;
  partcv[0] = 1;
  Object opresult5292 = callmethod(opresult5291, "++(1)", 1, partcv, params);
// compiled op node returning opresult5292 (depth = 2)
  gc_frame_end(frame);
  return opresult5292;
}
Object meth_collectionsPrelude_asSequence5293(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asSequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2081
  setline(2081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_1_41_5298(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___24 = &(stackframe->slots[0]);
  *var___24 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply_40_1_41_5310(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___25 = &(stackframe->slots[0]);
  *var___25 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe5311 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5314 == NULL) {
    strlit5314 = alloc_String(") is not an integer");
    gc_root(strlit5314);
  }
// compiled string node returning strlit5314 (depth = 7)
  int op_slot_right_5313 = gc_frame_newslot(strlit5314);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_5316 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5319 == NULL) {
    strlit5319 = alloc_String(")downTo(");
    gc_root(strlit5319);
  }
// compiled string node returning strlit5319 (depth = 9)
  int op_slot_right_5318 = gc_frame_newslot(strlit5319);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_upper (depth = 10)
  int op_slot_right_5321 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 10)
  if (strlit5323 == NULL) {
    strlit5323 = alloc_String(" in range.from(");
    gc_root(strlit5323);
  }
// compiled string node returning strlit5323 (depth = 10)
  int op_slot_left_5321 = gc_frame_newslot(strlit5323);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5324 = callmethod(strlit5323, "++(1)", 1, partcv, params);
// compiled op node returning opresult5324 (depth = 9)
  int op_slot_left_5318 = gc_frame_newslot(opresult5324);
  params[0] = strlit5319;
  partcv[0] = 1;
  Object opresult5325 = callmethod(opresult5324, "++(1)", 1, partcv, params);
// compiled op node returning opresult5325 (depth = 8)
  int op_slot_left_5316 = gc_frame_newslot(opresult5325);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5326 = callmethod(opresult5325, "++(1)", 1, partcv, params);
// compiled op node returning opresult5326 (depth = 7)
  int op_slot_left_5313 = gc_frame_newslot(opresult5326);
  params[0] = strlit5314;
  partcv[0] = 1;
  Object opresult5327 = callmethod(opresult5326, "++(1)", 1, partcv, params);
// compiled op node returning opresult5327 (depth = 6)
  int op_slot_right_5312 = gc_frame_newslot(opresult5327);
// Begin line 1996
  setline(1996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5330 == NULL) {
    strlit5330 = alloc_String("");
    gc_root(strlit5330);
  }
// compiled string node returning strlit5330 (depth = 7)
  int op_slot_right_5329 = gc_frame_newslot(strlit5330);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_5332 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 8)
  if (strlit5334 == NULL) {
    strlit5334 = alloc_String("upper bound ");
    gc_root(strlit5334);
  }
// compiled string node returning strlit5334 (depth = 8)
  int op_slot_left_5332 = gc_frame_newslot(strlit5334);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5335 = callmethod(strlit5334, "++(1)", 1, partcv, params);
// compiled op node returning opresult5335 (depth = 7)
  int op_slot_left_5329 = gc_frame_newslot(opresult5335);
  params[0] = strlit5330;
  partcv[0] = 1;
  Object opresult5336 = callmethod(opresult5335, "++(1)", 1, partcv, params);
// compiled op node returning opresult5336 (depth = 6)
  int op_slot_left_5312 = gc_frame_newslot(opresult5336);
  params[0] = opresult5327;
  partcv[0] = 1;
  Object opresult5337 = callmethod(opresult5336, "++(1)", 1, partcv, params);
// compiled op node returning opresult5337 (depth = 5)
  gc_frame_newslot(opresult5337);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult5337;
  partcv[0] = 1;
  Object call5338 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5311);
// compiled call node returning call5338 (depth = 4)
  gc_frame_end(frame);
  return call5338;
}
Object meth_collectionsPrelude__apply_40_1_41_5378(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___26 = &(stackframe->slots[0]);
  *var___26 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply_40_1_41_5390(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___27 = &(stackframe->slots[0]);
  *var___27 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe5391 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 2006
  setline(2006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5394 == NULL) {
    strlit5394 = alloc_String(") is not an integer");
    gc_root(strlit5394);
  }
// compiled string node returning strlit5394 (depth = 7)
  int op_slot_right_5393 = gc_frame_newslot(strlit5394);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_5396 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5399 == NULL) {
    strlit5399 = alloc_String(")downTo(");
    gc_root(strlit5399);
  }
// compiled string node returning strlit5399 (depth = 9)
  int op_slot_right_5398 = gc_frame_newslot(strlit5399);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_upper (depth = 10)
  int op_slot_right_5401 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 10)
  if (strlit5403 == NULL) {
    strlit5403 = alloc_String(" in range.from(");
    gc_root(strlit5403);
  }
// compiled string node returning strlit5403 (depth = 10)
  int op_slot_left_5401 = gc_frame_newslot(strlit5403);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5404 = callmethod(strlit5403, "++(1)", 1, partcv, params);
// compiled op node returning opresult5404 (depth = 9)
  int op_slot_left_5398 = gc_frame_newslot(opresult5404);
  params[0] = strlit5399;
  partcv[0] = 1;
  Object opresult5405 = callmethod(opresult5404, "++(1)", 1, partcv, params);
// compiled op node returning opresult5405 (depth = 8)
  int op_slot_left_5396 = gc_frame_newslot(opresult5405);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5406 = callmethod(opresult5405, "++(1)", 1, partcv, params);
// compiled op node returning opresult5406 (depth = 7)
  int op_slot_left_5393 = gc_frame_newslot(opresult5406);
  params[0] = strlit5394;
  partcv[0] = 1;
  Object opresult5407 = callmethod(opresult5406, "++(1)", 1, partcv, params);
// compiled op node returning opresult5407 (depth = 6)
  int op_slot_right_5392 = gc_frame_newslot(opresult5407);
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5410 == NULL) {
    strlit5410 = alloc_String("");
    gc_root(strlit5410);
  }
// compiled string node returning strlit5410 (depth = 7)
  int op_slot_right_5409 = gc_frame_newslot(strlit5410);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_5412 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 8)
  if (strlit5414 == NULL) {
    strlit5414 = alloc_String("lower bound ");
    gc_root(strlit5414);
  }
// compiled string node returning strlit5414 (depth = 8)
  int op_slot_left_5412 = gc_frame_newslot(strlit5414);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5415 = callmethod(strlit5414, "++(1)", 1, partcv, params);
// compiled op node returning opresult5415 (depth = 7)
  int op_slot_left_5409 = gc_frame_newslot(opresult5415);
  params[0] = strlit5410;
  partcv[0] = 1;
  Object opresult5416 = callmethod(opresult5415, "++(1)", 1, partcv, params);
// compiled op node returning opresult5416 (depth = 6)
  int op_slot_left_5392 = gc_frame_newslot(opresult5416);
  params[0] = opresult5407;
  partcv[0] = 1;
  Object opresult5417 = callmethod(opresult5416, "++(1)", 1, partcv, params);
// compiled op node returning opresult5417 (depth = 5)
  gc_frame_newslot(opresult5417);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult5417;
  partcv[0] = 1;
  Object call5418 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5391);
// compiled call node returning call5418 (depth = 4)
  gc_frame_end(frame);
  return call5418;
}
Object meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "from(1)downTo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method from(_)downTo(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method from(_)downTo(_)");
  Object params[2];
  int partcv[2];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_indexable = getfromclosure(closure, 3);
  Object *var_Number = getfromclosure(closure, 4);
  Object *var_RequestError = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for from(_)downTo(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_upper = &(stackframe->slots[0]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *var_lower = &(stackframe->slots[1]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part downTo(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5012 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5012 = alloc_userobj2(22,23, objclass5012);
  gc_frame_newslot(obj5012);
if (objclass5012 == NULL) {
  glfree(obj5012->class->name);
  obj5012->class->name = "range.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5012, self, 0);
  addmethodreal(obj5012,"outer", &reader_collectionsPrelude_outer_5013);
  Object oldself5012 = self;
  struct StackFrameObject *oldstackframe5012 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5012);
  gc_frame_newslot((Object)stackframe);
  self = obj5012;
  Object *oldselfslot5012 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5012 = (*(struct UserObject *)self).data[0], lowerouter5012 = thisouter5012;
  if (inheritingObject5012) {
    struct UserObject *inho5012 = (struct UserObject *)inheritingObject5012;
    while (inho5012->super != GraceDefaultObject) inho5012 = (struct UserObject *)inho5012->super;
    inho5012->super = obj5012;
    self = inheritingObject5012;
    *selfslot = self;
    lowerouter5012 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5012;
  }
if (objclass5012 == NULL) {
  Method *reader5014 = addmethodrealflags(obj5012, "start",&reader_collectionsPrelude_start_5014, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader5014->definitionModule = modulename;
  reader5014->definitionLine = 1998;
}
adddatum2(obj5012, alloc_Undefined(), 1);
if (objclass5012 == NULL) {
  Method *reader5015 = addmethodrealflags(obj5012, "stop",&reader_collectionsPrelude_stop_5015, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader5015->definitionModule = modulename;
  reader5015->definitionLine = 2007;
}
adddatum2(obj5012, alloc_Undefined(), 2);
if (objclass5012 == NULL) {
  Method *reader5016 = addmethodrealflags(obj5012, "size",&reader_collectionsPrelude_size_5016, MFLAG_DEF);
  reader5016->definitionModule = modulename;
  reader5016->definitionLine = 2012;
}
adddatum2(obj5012, alloc_Undefined(), 3);
// method "iterator"
  block_savedest(obj5012);
  Object closure5017 = createclosure(1, "iterator");
  setclosureframe(closure5017, stackframe);
  addtoclosure(closure5017, var_IteratorExhausted);
  struct UserObject *uo5017 = (struct UserObject*)obj5012;
  uo5017->data[4] = (Object)closure5017;
  Method *meth_meth_collectionsPrelude_iterator5017 = addmethod2pos(obj5012, "iterator", &meth_collectionsPrelude_iterator5017, 4);
  int argcv_meth_collectionsPrelude_iterator5017[] = {0};
  meth_meth_collectionsPrelude_iterator5017->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5017);
  meth_meth_collectionsPrelude_iterator5017->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5017->definitionLine = 2014;
  block_savedest(obj5012);
  Object closure5085 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure5085, stackframe);
  addtoclosure(closure5085, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator5017_object = addmethod2pos(obj5012, "iterator$object(1)", &meth_collectionsPrelude_iterator5017_object, 4);
  meth_meth_collectionsPrelude_iterator5017_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5017_object->definitionLine = 2014;
// method "at(_)"
  block_savedest(obj5012);
  Object closure5086 = createclosure(1, "at(1)");
  setclosureframe(closure5086, stackframe);
  addtoclosure(closure5086, var_BoundsError);
  struct UserObject *uo5086 = (struct UserObject*)obj5012;
  uo5086->data[5] = (Object)closure5086;
  Method *meth_meth_collectionsPrelude_at_40_1_41_5086 = addmethod2pos(obj5012, "at(1)", &meth_collectionsPrelude_at_40_1_41_5086, 5);
  int argcv_meth_collectionsPrelude_at_40_1_41_5086[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_5086->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_5086);
meth_meth_collectionsPrelude_at_40_1_41_5086->type->types[0] = type_Number;
meth_meth_collectionsPrelude_at_40_1_41_5086->type->names[0] = "ix";
  meth_meth_collectionsPrelude_at_40_1_41_5086->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_5086->definitionLine = 2026;
// method "contains(_)"
  block_savedest(obj5012);
  Object closure5140 = createclosure(1, "contains(1)");
  setclosureframe(closure5140, stackframe);
  addtoclosure(closure5140, var__prelude);
  struct UserObject *uo5140 = (struct UserObject*)obj5012;
  uo5140->data[6] = (Object)closure5140;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_5140 = addmethod2pos(obj5012, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_5140, 6);
  int argcv_meth_collectionsPrelude_contains_40_1_41_5140[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_5140->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_5140);
  meth_meth_collectionsPrelude_contains_40_1_41_5140->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_5140->definitionLine = 2035;
// method "do(_)"
  struct UserObject *uo5182 = (struct UserObject*)obj5012;
  uo5182->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_5182 = addmethod2pos(obj5012, "do(1)", &meth_collectionsPrelude_do_40_1_41_5182, 7);
  int argcv_meth_collectionsPrelude_do_40_1_41_5182[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_5182->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_5182);
  meth_meth_collectionsPrelude_do_40_1_41_5182->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_5182->definitionLine = 2044;
// method "keysAndValuesDo(_)"
  struct UserObject *uo5205 = (struct UserObject*)obj5012;
  uo5205->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5205 = addmethod2pos(obj5012, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_5205, 8);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5205[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5205->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5205);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5205->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5205->definitionLine = 2051;
// method "reversed"
  block_savedest(obj5012);
  Object closure5234 = createclosure(2, "reversed");
  setclosureframe(closure5234, stackframe);
  addtoclosure(closure5234, var_lower);
  addtoclosure(closure5234, var_upper);
  struct UserObject *uo5234 = (struct UserObject*)obj5012;
  uo5234->data[9] = (Object)closure5234;
  Method *meth_meth_collectionsPrelude_reversed5234 = addmethod2pos(obj5012, "reversed", &meth_collectionsPrelude_reversed5234, 9);
  int argcv_meth_collectionsPrelude_reversed5234[] = {0};
  meth_meth_collectionsPrelude_reversed5234->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed5234);
  meth_meth_collectionsPrelude_reversed5234->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed5234->definitionLine = 2060;
// method "++(_)"
  struct UserObject *uo5239 = (struct UserObject*)obj5012;
  uo5239->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_5239 = addmethod2pos(obj5012, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_5239, 10);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_5239[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_5239->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_5239);
  meth_meth_collectionsPrelude__43__43__40_1_41_5239->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_5239->definitionLine = 2063;
// method "==(_)"
  struct UserObject *uo5254 = (struct UserObject*)obj5012;
  uo5254->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_5254 = addmethod2pos(obj5012, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_5254, 11);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_5254[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_5254->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_5254);
  meth_meth_collectionsPrelude__61__61__40_1_41_5254->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_5254->definitionLine = 2066;
// method "sorted"
  struct UserObject *uo5261 = (struct UserObject*)obj5012;
  uo5261->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted5261 = addmethod2pos(obj5012, "sorted", &meth_collectionsPrelude_sorted5261, 12);
  int argcv_meth_collectionsPrelude_sorted5261[] = {0};
  meth_meth_collectionsPrelude_sorted5261->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted5261);
  meth_meth_collectionsPrelude_sorted5261->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted5261->definitionLine = 2069;
// method "sortedBy(_)"
  struct UserObject *uo5264 = (struct UserObject*)obj5012;
  uo5264->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_5264 = addmethod2pos(obj5012, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_5264, 13);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_5264[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5264->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_5264);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5264->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5264->definitionLine = 2071;
// method "keys"
  struct UserObject *uo5269 = (struct UserObject*)obj5012;
  uo5269->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys5269 = addmethod2pos(obj5012, "keys", &meth_collectionsPrelude_keys5269, 14);
  int argcv_meth_collectionsPrelude_keys5269[] = {0};
  meth_meth_collectionsPrelude_keys5269->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys5269);
  meth_meth_collectionsPrelude_keys5269->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys5269->definitionLine = 2073;
// method "values"
  struct UserObject *uo5276 = (struct UserObject*)obj5012;
  uo5276->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values5276 = addmethod2pos(obj5012, "values", &meth_collectionsPrelude_values5276, 15);
  int argcv_meth_collectionsPrelude_values5276[] = {0};
  meth_meth_collectionsPrelude_values5276->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values5276);
  meth_meth_collectionsPrelude_values5276->definitionModule = modulename;
  meth_meth_collectionsPrelude_values5276->definitionLine = 2075;
// method "asString"
  block_savedest(obj5012);
  Object closure5277 = createclosure(2, "asString");
  setclosureframe(closure5277, stackframe);
  addtoclosure(closure5277, var_lower);
  addtoclosure(closure5277, var_upper);
  struct UserObject *uo5277 = (struct UserObject*)obj5012;
  uo5277->data[16] = (Object)closure5277;
  Method *meth_meth_collectionsPrelude_asString5277 = addmethod2pos(obj5012, "asString", &meth_collectionsPrelude_asString5277, 16);
  int argcv_meth_collectionsPrelude_asString5277[] = {0};
  meth_meth_collectionsPrelude_asString5277->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5277);
  meth_meth_collectionsPrelude_asString5277->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5277->definitionLine = 2077;
// method "asSequence"
  struct UserObject *uo5293 = (struct UserObject*)obj5012;
  uo5293->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence5293 = addmethod2pos(obj5012, "asSequence", &meth_collectionsPrelude_asSequence5293, 17);
  int argcv_meth_collectionsPrelude_asSequence5293[] = {0};
  meth_meth_collectionsPrelude_asSequence5293->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence5293);
  meth_meth_collectionsPrelude_asSequence5293->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence5293->definitionLine = 2080;
  sourceObject = obj5012;
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5294 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5295 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5294);
// compiled call node returning call5295 (depth = 2)
  struct UserObject *obj5012_uo = (struct UserObject *)obj5012;
  obj5012_uo->super = call5295;
  sourceObject = obj5012;
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  int frame5296 = gc_frame_new();
  gc_frame_newslot(*var_upper);
// Begin line 1995
  setline(1995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5297 = alloc_Block(NULL, NULL, "collectionsPrelude", 1995);
  gc_frame_newslot(block5297);
// method "_apply(_)"
  block_savedest(block5297);
  Object closure5298 = createclosure(1, "_apply(1)");
  setclosureframe(closure5298, stackframe);
  addtoclosure(closure5298, selfslot);
  struct UserObject *uo5298 = (struct UserObject*)block5297;
  uo5298->data[0] = (Object)closure5298;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5298 = addmethod2pos(block5297, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5298, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5298[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5298->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5298);
meth_meth_collectionsPrelude__apply_40_1_41_5298->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply_40_1_41_5298->type->names[0] = "__24";
  meth_meth_collectionsPrelude__apply_40_1_41_5298->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5298->definitionLine = 1991;
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5300 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5301 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5302 == NULL) {
    strlit5302 = alloc_String("__24");
    gc_root(strlit5302);
  }
// compiled string node returning strlit5302 (depth = 6)
  gc_frame_newslot(strlit5302);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5303 = gc_frame_new();
// call case 5: prelude request
  Object call5304 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5303);
// compiled member node returning call5304 (depth = 6)
  params[0] = strlit5302;
  partcv[0] = 1;
  Object call5305 = callmethodflags(call5304, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5301);
// compiled call node returning call5305 (depth = 5)
  gc_frame_newslot(call5305);
// Begin line 1995
  setline(1995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other requests
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5306 = gc_frame_new();
// call case 5: prelude request
  Object call5307 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5306);
// compiled member node returning call5307 (depth = 5)
  params[0] = call5305;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5308 = callmethodflags(call5307, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5300);
// compiled call node returning call5308 (depth = 4)
((struct UserObject *)block5297)->data[1] = call5308;
// compiled block node returning block5297 (depth = 3)
  gc_frame_newslot(block5297);
// Begin line 1996
  setline(1996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5309 = alloc_Block(NULL, NULL, "collectionsPrelude", 1996);
  gc_frame_newslot(block5309);
// method "_apply(_)"
  block_savedest(block5309);
  Object closure5310 = createclosure(4, "_apply(1)");
  setclosureframe(closure5310, stackframe);
  addtoclosure(closure5310, var_lower);
  addtoclosure(closure5310, var_upper);
  addtoclosure(closure5310, var_RequestError);
  addtoclosure(closure5310, selfslot);
  struct UserObject *uo5310 = (struct UserObject*)block5309;
  uo5310->data[0] = (Object)closure5310;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5310 = addmethod2pos(block5309, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5310, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5310[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5310->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5310);
  meth_meth_collectionsPrelude__apply_40_1_41_5310->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5310->definitionLine = 1991;
// compiled block node returning block5309 (depth = 3)
  gc_frame_newslot(block5309);
  params[0] = block5297;
  params[1] = block5309;
  Object matchres5296 = matchCase(*var_upper, params, 2,NULL);
  gc_frame_end(frame5296);
// compiled matchcase node returning matchres5296 (depth = 2)
  sourceObject = obj5012;
// Begin line 1998
  setline(1998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5340 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  Object call5341 = callmethodflags(*var_upper, "truncated", 0, partcv, params, 0);
  gc_frame_end(callframe5340);
// compiled member node returning call5341 (depth = 2)
  adddatum2(obj5012, call5341, 1);
  sourceObject = obj5012;
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_5343 = gc_frame_newslot(*var_upper);
// starting to compile member node (depth = 4)
  int callframe5345 = gc_frame_new();
// call case 4: self request
  Object call5346 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5345);
// compiled member node returning call5346 (depth = 4)
  int op_slot_left_5343 = gc_frame_newslot(call5346);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5347 = callmethod(call5346, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5347 (depth = 3)
  Object if5342 = done;
struct StackFrameObject *iftmpstackframe5342 = stackframe;
  if (istrue(opresult5347)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5342);
gc_frame_newslot((Object)stackframe);
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5348 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 2001
  setline(2001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5351 == NULL) {
    strlit5351 = alloc_String(") is not an integer");
    gc_root(strlit5351);
  }
// compiled string node returning strlit5351 (depth = 6)
  int op_slot_right_5350 = gc_frame_newslot(strlit5351);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5353 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5356 == NULL) {
    strlit5356 = alloc_String(")downTo(");
    gc_root(strlit5356);
  }
// compiled string node returning strlit5356 (depth = 8)
  int op_slot_right_5355 = gc_frame_newslot(strlit5356);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_upper (depth = 9)
  int op_slot_right_5358 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 9)
  if (strlit5360 == NULL) {
    strlit5360 = alloc_String(" in range.from(");
    gc_root(strlit5360);
  }
// compiled string node returning strlit5360 (depth = 9)
  int op_slot_left_5358 = gc_frame_newslot(strlit5360);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5361 = callmethod(strlit5360, "++(1)", 1, partcv, params);
// compiled op node returning opresult5361 (depth = 8)
  int op_slot_left_5355 = gc_frame_newslot(opresult5361);
  params[0] = strlit5356;
  partcv[0] = 1;
  Object opresult5362 = callmethod(opresult5361, "++(1)", 1, partcv, params);
// compiled op node returning opresult5362 (depth = 7)
  int op_slot_left_5353 = gc_frame_newslot(opresult5362);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5363 = callmethod(opresult5362, "++(1)", 1, partcv, params);
// compiled op node returning opresult5363 (depth = 6)
  int op_slot_left_5350 = gc_frame_newslot(opresult5363);
  params[0] = strlit5351;
  partcv[0] = 1;
  Object opresult5364 = callmethod(opresult5363, "++(1)", 1, partcv, params);
// compiled op node returning opresult5364 (depth = 5)
  int op_slot_right_5349 = gc_frame_newslot(opresult5364);
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5367 == NULL) {
    strlit5367 = alloc_String("");
    gc_root(strlit5367);
  }
// compiled string node returning strlit5367 (depth = 6)
  int op_slot_right_5366 = gc_frame_newslot(strlit5367);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_5369 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 7)
  if (strlit5371 == NULL) {
    strlit5371 = alloc_String("upper bound ");
    gc_root(strlit5371);
  }
// compiled string node returning strlit5371 (depth = 7)
  int op_slot_left_5369 = gc_frame_newslot(strlit5371);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5372 = callmethod(strlit5371, "++(1)", 1, partcv, params);
// compiled op node returning opresult5372 (depth = 6)
  int op_slot_left_5366 = gc_frame_newslot(opresult5372);
  params[0] = strlit5367;
  partcv[0] = 1;
  Object opresult5373 = callmethod(opresult5372, "++(1)", 1, partcv, params);
// compiled op node returning opresult5373 (depth = 5)
  int op_slot_left_5349 = gc_frame_newslot(opresult5373);
  params[0] = opresult5364;
  partcv[0] = 1;
  Object opresult5374 = callmethod(opresult5373, "++(1)", 1, partcv, params);
// compiled op node returning opresult5374 (depth = 4)
  gc_frame_newslot(opresult5374);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult5374;
  partcv[0] = 1;
  Object call5375 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5348);
// compiled call node returning call5375 (depth = 3)
    gc_frame_newslot(call5375);
    if5342 = call5375;
  } else {
  }
stackframe = iftmpstackframe5342;
// compiled if node returning if5342 (depth = 2)
  sourceObject = obj5012;
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  int frame5376 = gc_frame_new();
  gc_frame_newslot(*var_lower);
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5377 = alloc_Block(NULL, NULL, "collectionsPrelude", 2004);
  gc_frame_newslot(block5377);
// method "_apply(_)"
  block_savedest(block5377);
  Object closure5378 = createclosure(1, "_apply(1)");
  setclosureframe(closure5378, stackframe);
  addtoclosure(closure5378, selfslot);
  struct UserObject *uo5378 = (struct UserObject*)block5377;
  uo5378->data[0] = (Object)closure5378;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5378 = addmethod2pos(block5377, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5378, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5378[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5378->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5378);
meth_meth_collectionsPrelude__apply_40_1_41_5378->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply_40_1_41_5378->type->names[0] = "__26";
  meth_meth_collectionsPrelude__apply_40_1_41_5378->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5378->definitionLine = 1991;
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5380 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5381 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5382 == NULL) {
    strlit5382 = alloc_String("__26");
    gc_root(strlit5382);
  }
// compiled string node returning strlit5382 (depth = 6)
  gc_frame_newslot(strlit5382);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5383 = gc_frame_new();
// call case 5: prelude request
  Object call5384 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5383);
// compiled member node returning call5384 (depth = 6)
  params[0] = strlit5382;
  partcv[0] = 1;
  Object call5385 = callmethodflags(call5384, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5381);
// compiled call node returning call5385 (depth = 5)
  gc_frame_newslot(call5385);
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other requests
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5386 = gc_frame_new();
// call case 5: prelude request
  Object call5387 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5386);
// compiled member node returning call5387 (depth = 5)
  params[0] = call5385;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5388 = callmethodflags(call5387, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5380);
// compiled call node returning call5388 (depth = 4)
((struct UserObject *)block5377)->data[1] = call5388;
// compiled block node returning block5377 (depth = 3)
  gc_frame_newslot(block5377);
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5389 = alloc_Block(NULL, NULL, "collectionsPrelude", 2005);
  gc_frame_newslot(block5389);
// method "_apply(_)"
  block_savedest(block5389);
  Object closure5390 = createclosure(4, "_apply(1)");
  setclosureframe(closure5390, stackframe);
  addtoclosure(closure5390, var_lower);
  addtoclosure(closure5390, var_upper);
  addtoclosure(closure5390, var_RequestError);
  addtoclosure(closure5390, selfslot);
  struct UserObject *uo5390 = (struct UserObject*)block5389;
  uo5390->data[0] = (Object)closure5390;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5390 = addmethod2pos(block5389, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5390, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5390[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5390->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5390);
  meth_meth_collectionsPrelude__apply_40_1_41_5390->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5390->definitionLine = 1991;
// compiled block node returning block5389 (depth = 3)
  gc_frame_newslot(block5389);
  params[0] = block5377;
  params[1] = block5389;
  Object matchres5376 = matchCase(*var_lower, params, 2,NULL);
  gc_frame_end(frame5376);
// compiled matchcase node returning matchres5376 (depth = 2)
  sourceObject = obj5012;
// Begin line 2007
  setline(2007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5420 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  Object call5421 = callmethodflags(*var_lower, "truncated", 0, partcv, params, 0);
  gc_frame_end(callframe5420);
// compiled member node returning call5421 (depth = 2)
  adddatum2(obj5012, call5421, 2);
  sourceObject = obj5012;
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_5423 = gc_frame_newslot(*var_lower);
// starting to compile member node (depth = 4)
  int callframe5425 = gc_frame_new();
// call case 4: self request
  Object call5426 = callmethodflags(self, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5425);
// compiled member node returning call5426 (depth = 4)
  int op_slot_left_5423 = gc_frame_newslot(call5426);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5427 = callmethod(call5426, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5427 (depth = 3)
  Object if5422 = done;
struct StackFrameObject *iftmpstackframe5422 = stackframe;
  if (istrue(opresult5427)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5422);
gc_frame_newslot((Object)stackframe);
// Begin line 2009
  setline(2009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5428 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 2010
  setline(2010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5431 == NULL) {
    strlit5431 = alloc_String(") is not an integer");
    gc_root(strlit5431);
  }
// compiled string node returning strlit5431 (depth = 6)
  int op_slot_right_5430 = gc_frame_newslot(strlit5431);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5433 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5436 == NULL) {
    strlit5436 = alloc_String(")downTo(");
    gc_root(strlit5436);
  }
// compiled string node returning strlit5436 (depth = 8)
  int op_slot_right_5435 = gc_frame_newslot(strlit5436);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_upper (depth = 9)
  int op_slot_right_5438 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 9)
  if (strlit5440 == NULL) {
    strlit5440 = alloc_String(" in range.from(");
    gc_root(strlit5440);
  }
// compiled string node returning strlit5440 (depth = 9)
  int op_slot_left_5438 = gc_frame_newslot(strlit5440);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5441 = callmethod(strlit5440, "++(1)", 1, partcv, params);
// compiled op node returning opresult5441 (depth = 8)
  int op_slot_left_5435 = gc_frame_newslot(opresult5441);
  params[0] = strlit5436;
  partcv[0] = 1;
  Object opresult5442 = callmethod(opresult5441, "++(1)", 1, partcv, params);
// compiled op node returning opresult5442 (depth = 7)
  int op_slot_left_5433 = gc_frame_newslot(opresult5442);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5443 = callmethod(opresult5442, "++(1)", 1, partcv, params);
// compiled op node returning opresult5443 (depth = 6)
  int op_slot_left_5430 = gc_frame_newslot(opresult5443);
  params[0] = strlit5431;
  partcv[0] = 1;
  Object opresult5444 = callmethod(opresult5443, "++(1)", 1, partcv, params);
// compiled op node returning opresult5444 (depth = 5)
  int op_slot_right_5429 = gc_frame_newslot(opresult5444);
// Begin line 2009
  setline(2009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5447 == NULL) {
    strlit5447 = alloc_String("");
    gc_root(strlit5447);
  }
// compiled string node returning strlit5447 (depth = 6)
  int op_slot_right_5446 = gc_frame_newslot(strlit5447);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5449 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 7)
  if (strlit5451 == NULL) {
    strlit5451 = alloc_String("lower bound ");
    gc_root(strlit5451);
  }
// compiled string node returning strlit5451 (depth = 7)
  int op_slot_left_5449 = gc_frame_newslot(strlit5451);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5452 = callmethod(strlit5451, "++(1)", 1, partcv, params);
// compiled op node returning opresult5452 (depth = 6)
  int op_slot_left_5446 = gc_frame_newslot(opresult5452);
  params[0] = strlit5447;
  partcv[0] = 1;
  Object opresult5453 = callmethod(opresult5452, "++(1)", 1, partcv, params);
// compiled op node returning opresult5453 (depth = 5)
  int op_slot_left_5429 = gc_frame_newslot(opresult5453);
  params[0] = opresult5444;
  partcv[0] = 1;
  Object opresult5454 = callmethod(opresult5453, "++(1)", 1, partcv, params);
// compiled op node returning opresult5454 (depth = 4)
  gc_frame_newslot(opresult5454);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult5454;
  partcv[0] = 1;
  Object call5455 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5428);
// compiled call node returning call5455 (depth = 3)
    gc_frame_newslot(call5455);
    if5422 = call5455;
  } else {
  }
stackframe = iftmpstackframe5422;
// compiled if node returning if5422 (depth = 2)
  sourceObject = obj5012;
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5458 = alloc_Float64(0);
// compiled num node returning num5458 (depth = 4)
  int op_slot_right_5457 = gc_frame_newslot(num5458);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5461 = alloc_Float64(1);
// compiled num node returning num5461 (depth = 5)
  int op_slot_right_5460 = gc_frame_newslot(num5461);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_5463 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_5463 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5465 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff5465 (depth = 5)
  int op_slot_left_5460 = gc_frame_newslot(diff5465);
  params[0] = num5461;
  partcv[0] = 1;
  Object sum5466 = callmethod(diff5465, "+(1)", 1, partcv, params);
// compiled op node returning sum5466 (depth = 4)
  int op_slot_left_5457 = gc_frame_newslot(sum5466);
  params[0] = num5458;
  partcv[0] = 1;
  Object opresult5467 = callmethod(sum5466, "<(1)", 1, partcv, params);
// compiled op node returning opresult5467 (depth = 3)
  Object if5456 = done;
struct StackFrameObject *iftmpstackframe5456 = stackframe;
  if (istrue(opresult5467)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5456);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 3)
  Object num5468 = alloc_Float64(0);
// compiled num node returning num5468 (depth = 3)
    gc_frame_newslot(num5468);
    if5456 = num5468;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe5456);
  gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5470 = alloc_Float64(1);
// compiled num node returning num5470 (depth = 4)
  int op_slot_right_5469 = gc_frame_newslot(num5470);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_5472 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_5472 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5474 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff5474 (depth = 4)
  int op_slot_left_5469 = gc_frame_newslot(diff5474);
  params[0] = num5470;
  partcv[0] = 1;
  Object sum5475 = callmethod(diff5474, "+(1)", 1, partcv, params);
// compiled op node returning sum5475 (depth = 3)
    gc_frame_newslot(sum5475);
    if5456 = sum5475;
  }
stackframe = iftmpstackframe5456;
// compiled if node returning if5456 (depth = 2)
  adddatum2(obj5012, if5456, 3);
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  objclass5012 = obj5012->class;
  objclass5012->definitionModule = modulename;
  objclass5012->definitionLine = 1992;
  (*(struct UserObject *)self).data[0] = lowerouter5012;
  self = oldself5012;
  selfslot = oldselfslot5012;
  stackframe = oldstackframe5012;
  gc_frame_end(frame);
  return obj5012;
}
Object meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "from(1)downTo(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method from(_)downTo(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method from(_)downTo(_)");
  Object params[2];
  int partcv[2];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_indexable = getfromclosure(closure, 3);
  Object *var_Number = getfromclosure(closure, 4);
  Object *var_RequestError = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for from(_)downTo(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_upper = &(stackframe->slots[0]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *var_lower = &(stackframe->slots[1]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part downTo(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5012 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5012 = alloc_userobj2(22,23, objclass5012);
  gc_frame_newslot(obj5012);
if (objclass5012 == NULL) {
  glfree(obj5012->class->name);
  obj5012->class->name = "range.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5012, self, 0);
  addmethodreal(obj5012,"outer", &reader_collectionsPrelude_outer_5013);
  Object oldself5012 = self;
  struct StackFrameObject *oldstackframe5012 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5012);
  gc_frame_newslot((Object)stackframe);
  self = obj5012;
  Object *oldselfslot5012 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5012 = (*(struct UserObject *)self).data[0], lowerouter5012 = thisouter5012;
  if (inheritingObject5012) {
    struct UserObject *inho5012 = (struct UserObject *)inheritingObject5012;
    while (inho5012->super != GraceDefaultObject) inho5012 = (struct UserObject *)inho5012->super;
    inho5012->super = obj5012;
    self = inheritingObject5012;
    *selfslot = self;
    lowerouter5012 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5012;
  }
if (objclass5012 == NULL) {
  Method *reader5014 = addmethodrealflags(obj5012, "start",&reader_collectionsPrelude_start_5014, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader5014->definitionModule = modulename;
  reader5014->definitionLine = 1998;
}
adddatum2(obj5012, alloc_Undefined(), 1);
if (objclass5012 == NULL) {
  Method *reader5015 = addmethodrealflags(obj5012, "stop",&reader_collectionsPrelude_stop_5015, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader5015->definitionModule = modulename;
  reader5015->definitionLine = 2007;
}
adddatum2(obj5012, alloc_Undefined(), 2);
if (objclass5012 == NULL) {
  Method *reader5016 = addmethodrealflags(obj5012, "size",&reader_collectionsPrelude_size_5016, MFLAG_DEF);
  reader5016->definitionModule = modulename;
  reader5016->definitionLine = 2012;
}
adddatum2(obj5012, alloc_Undefined(), 3);
// method "iterator"
  block_savedest(obj5012);
  Object closure5017 = createclosure(1, "iterator");
  setclosureframe(closure5017, stackframe);
  addtoclosure(closure5017, var_IteratorExhausted);
  struct UserObject *uo5017 = (struct UserObject*)obj5012;
  uo5017->data[4] = (Object)closure5017;
  Method *meth_meth_collectionsPrelude_iterator5017 = addmethod2pos(obj5012, "iterator", &meth_collectionsPrelude_iterator5017, 4);
  int argcv_meth_collectionsPrelude_iterator5017[] = {0};
  meth_meth_collectionsPrelude_iterator5017->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5017);
  meth_meth_collectionsPrelude_iterator5017->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5017->definitionLine = 2014;
  block_savedest(obj5012);
  Object closure5085 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure5085, stackframe);
  addtoclosure(closure5085, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator5017_object = addmethod2pos(obj5012, "iterator$object(1)", &meth_collectionsPrelude_iterator5017_object, 4);
  meth_meth_collectionsPrelude_iterator5017_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5017_object->definitionLine = 2014;
// method "at(_)"
  block_savedest(obj5012);
  Object closure5086 = createclosure(1, "at(1)");
  setclosureframe(closure5086, stackframe);
  addtoclosure(closure5086, var_BoundsError);
  struct UserObject *uo5086 = (struct UserObject*)obj5012;
  uo5086->data[5] = (Object)closure5086;
  Method *meth_meth_collectionsPrelude_at_40_1_41_5086 = addmethod2pos(obj5012, "at(1)", &meth_collectionsPrelude_at_40_1_41_5086, 5);
  int argcv_meth_collectionsPrelude_at_40_1_41_5086[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_5086->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_5086);
meth_meth_collectionsPrelude_at_40_1_41_5086->type->types[0] = type_Number;
meth_meth_collectionsPrelude_at_40_1_41_5086->type->names[0] = "ix";
  meth_meth_collectionsPrelude_at_40_1_41_5086->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_5086->definitionLine = 2026;
// method "contains(_)"
  block_savedest(obj5012);
  Object closure5140 = createclosure(1, "contains(1)");
  setclosureframe(closure5140, stackframe);
  addtoclosure(closure5140, var__prelude);
  struct UserObject *uo5140 = (struct UserObject*)obj5012;
  uo5140->data[6] = (Object)closure5140;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_5140 = addmethod2pos(obj5012, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_5140, 6);
  int argcv_meth_collectionsPrelude_contains_40_1_41_5140[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_5140->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_5140);
  meth_meth_collectionsPrelude_contains_40_1_41_5140->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_5140->definitionLine = 2035;
// method "do(_)"
  struct UserObject *uo5182 = (struct UserObject*)obj5012;
  uo5182->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_5182 = addmethod2pos(obj5012, "do(1)", &meth_collectionsPrelude_do_40_1_41_5182, 7);
  int argcv_meth_collectionsPrelude_do_40_1_41_5182[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_5182->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_5182);
  meth_meth_collectionsPrelude_do_40_1_41_5182->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_5182->definitionLine = 2044;
// method "keysAndValuesDo(_)"
  struct UserObject *uo5205 = (struct UserObject*)obj5012;
  uo5205->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5205 = addmethod2pos(obj5012, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_5205, 8);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5205[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5205->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5205);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5205->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5205->definitionLine = 2051;
// method "reversed"
  block_savedest(obj5012);
  Object closure5234 = createclosure(2, "reversed");
  setclosureframe(closure5234, stackframe);
  addtoclosure(closure5234, var_lower);
  addtoclosure(closure5234, var_upper);
  struct UserObject *uo5234 = (struct UserObject*)obj5012;
  uo5234->data[9] = (Object)closure5234;
  Method *meth_meth_collectionsPrelude_reversed5234 = addmethod2pos(obj5012, "reversed", &meth_collectionsPrelude_reversed5234, 9);
  int argcv_meth_collectionsPrelude_reversed5234[] = {0};
  meth_meth_collectionsPrelude_reversed5234->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed5234);
  meth_meth_collectionsPrelude_reversed5234->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed5234->definitionLine = 2060;
// method "++(_)"
  struct UserObject *uo5239 = (struct UserObject*)obj5012;
  uo5239->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_5239 = addmethod2pos(obj5012, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_5239, 10);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_5239[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_5239->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_5239);
  meth_meth_collectionsPrelude__43__43__40_1_41_5239->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_5239->definitionLine = 2063;
// method "==(_)"
  struct UserObject *uo5254 = (struct UserObject*)obj5012;
  uo5254->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_5254 = addmethod2pos(obj5012, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_5254, 11);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_5254[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_5254->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_5254);
  meth_meth_collectionsPrelude__61__61__40_1_41_5254->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_5254->definitionLine = 2066;
// method "sorted"
  struct UserObject *uo5261 = (struct UserObject*)obj5012;
  uo5261->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted5261 = addmethod2pos(obj5012, "sorted", &meth_collectionsPrelude_sorted5261, 12);
  int argcv_meth_collectionsPrelude_sorted5261[] = {0};
  meth_meth_collectionsPrelude_sorted5261->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted5261);
  meth_meth_collectionsPrelude_sorted5261->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted5261->definitionLine = 2069;
// method "sortedBy(_)"
  struct UserObject *uo5264 = (struct UserObject*)obj5012;
  uo5264->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_5264 = addmethod2pos(obj5012, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_5264, 13);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_5264[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5264->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_5264);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5264->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5264->definitionLine = 2071;
// method "keys"
  struct UserObject *uo5269 = (struct UserObject*)obj5012;
  uo5269->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys5269 = addmethod2pos(obj5012, "keys", &meth_collectionsPrelude_keys5269, 14);
  int argcv_meth_collectionsPrelude_keys5269[] = {0};
  meth_meth_collectionsPrelude_keys5269->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys5269);
  meth_meth_collectionsPrelude_keys5269->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys5269->definitionLine = 2073;
// method "values"
  struct UserObject *uo5276 = (struct UserObject*)obj5012;
  uo5276->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values5276 = addmethod2pos(obj5012, "values", &meth_collectionsPrelude_values5276, 15);
  int argcv_meth_collectionsPrelude_values5276[] = {0};
  meth_meth_collectionsPrelude_values5276->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values5276);
  meth_meth_collectionsPrelude_values5276->definitionModule = modulename;
  meth_meth_collectionsPrelude_values5276->definitionLine = 2075;
// method "asString"
  block_savedest(obj5012);
  Object closure5277 = createclosure(2, "asString");
  setclosureframe(closure5277, stackframe);
  addtoclosure(closure5277, var_lower);
  addtoclosure(closure5277, var_upper);
  struct UserObject *uo5277 = (struct UserObject*)obj5012;
  uo5277->data[16] = (Object)closure5277;
  Method *meth_meth_collectionsPrelude_asString5277 = addmethod2pos(obj5012, "asString", &meth_collectionsPrelude_asString5277, 16);
  int argcv_meth_collectionsPrelude_asString5277[] = {0};
  meth_meth_collectionsPrelude_asString5277->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5277);
  meth_meth_collectionsPrelude_asString5277->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5277->definitionLine = 2077;
// method "asSequence"
  struct UserObject *uo5293 = (struct UserObject*)obj5012;
  uo5293->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence5293 = addmethod2pos(obj5012, "asSequence", &meth_collectionsPrelude_asSequence5293, 17);
  int argcv_meth_collectionsPrelude_asSequence5293[] = {0};
  meth_meth_collectionsPrelude_asSequence5293->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence5293);
  meth_meth_collectionsPrelude_asSequence5293->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence5293->definitionLine = 2080;
  sourceObject = obj5012;
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5294 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5295 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5294);
// compiled call node returning call5295 (depth = 2)
  struct UserObject *obj5012_uo = (struct UserObject *)obj5012;
  obj5012_uo->super = call5295;
  sourceObject = obj5012;
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  int frame5296 = gc_frame_new();
  gc_frame_newslot(*var_upper);
// Begin line 1995
  setline(1995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5297 = alloc_Block(NULL, NULL, "collectionsPrelude", 1995);
  gc_frame_newslot(block5297);
// method "_apply(_)"
  block_savedest(block5297);
  Object closure5298 = createclosure(1, "_apply(1)");
  setclosureframe(closure5298, stackframe);
  addtoclosure(closure5298, selfslot);
  struct UserObject *uo5298 = (struct UserObject*)block5297;
  uo5298->data[0] = (Object)closure5298;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5298 = addmethod2pos(block5297, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5298, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5298[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5298->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5298);
meth_meth_collectionsPrelude__apply_40_1_41_5298->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply_40_1_41_5298->type->names[0] = "__24";
  meth_meth_collectionsPrelude__apply_40_1_41_5298->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5298->definitionLine = 1991;
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5300 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5301 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5302 == NULL) {
    strlit5302 = alloc_String("__24");
    gc_root(strlit5302);
  }
// compiled string node returning strlit5302 (depth = 6)
  gc_frame_newslot(strlit5302);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5303 = gc_frame_new();
// call case 5: prelude request
  Object call5304 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5303);
// compiled member node returning call5304 (depth = 6)
  params[0] = strlit5302;
  partcv[0] = 1;
  Object call5305 = callmethodflags(call5304, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5301);
// compiled call node returning call5305 (depth = 5)
  gc_frame_newslot(call5305);
// Begin line 1995
  setline(1995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other requests
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5306 = gc_frame_new();
// call case 5: prelude request
  Object call5307 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5306);
// compiled member node returning call5307 (depth = 5)
  params[0] = call5305;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5308 = callmethodflags(call5307, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5300);
// compiled call node returning call5308 (depth = 4)
((struct UserObject *)block5297)->data[1] = call5308;
// compiled block node returning block5297 (depth = 3)
  gc_frame_newslot(block5297);
// Begin line 1996
  setline(1996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5309 = alloc_Block(NULL, NULL, "collectionsPrelude", 1996);
  gc_frame_newslot(block5309);
// method "_apply(_)"
  block_savedest(block5309);
  Object closure5310 = createclosure(4, "_apply(1)");
  setclosureframe(closure5310, stackframe);
  addtoclosure(closure5310, var_lower);
  addtoclosure(closure5310, var_upper);
  addtoclosure(closure5310, var_RequestError);
  addtoclosure(closure5310, selfslot);
  struct UserObject *uo5310 = (struct UserObject*)block5309;
  uo5310->data[0] = (Object)closure5310;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5310 = addmethod2pos(block5309, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5310, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5310[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5310->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5310);
  meth_meth_collectionsPrelude__apply_40_1_41_5310->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5310->definitionLine = 1991;
// compiled block node returning block5309 (depth = 3)
  gc_frame_newslot(block5309);
  params[0] = block5297;
  params[1] = block5309;
  Object matchres5296 = matchCase(*var_upper, params, 2,NULL);
  gc_frame_end(frame5296);
// compiled matchcase node returning matchres5296 (depth = 2)
  sourceObject = obj5012;
// Begin line 1998
  setline(1998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5340 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  Object call5341 = callmethodflags(*var_upper, "truncated", 0, partcv, params, 0);
  gc_frame_end(callframe5340);
// compiled member node returning call5341 (depth = 2)
  adddatum2(obj5012, call5341, 1);
  sourceObject = obj5012;
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_5343 = gc_frame_newslot(*var_upper);
// starting to compile member node (depth = 4)
  int callframe5345 = gc_frame_new();
// call case 4: self request
  Object call5346 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5345);
// compiled member node returning call5346 (depth = 4)
  int op_slot_left_5343 = gc_frame_newslot(call5346);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5347 = callmethod(call5346, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5347 (depth = 3)
  Object if5342 = done;
struct StackFrameObject *iftmpstackframe5342 = stackframe;
  if (istrue(opresult5347)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5342);
gc_frame_newslot((Object)stackframe);
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5348 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 2001
  setline(2001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5351 == NULL) {
    strlit5351 = alloc_String(") is not an integer");
    gc_root(strlit5351);
  }
// compiled string node returning strlit5351 (depth = 6)
  int op_slot_right_5350 = gc_frame_newslot(strlit5351);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5353 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5356 == NULL) {
    strlit5356 = alloc_String(")downTo(");
    gc_root(strlit5356);
  }
// compiled string node returning strlit5356 (depth = 8)
  int op_slot_right_5355 = gc_frame_newslot(strlit5356);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_upper (depth = 9)
  int op_slot_right_5358 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 9)
  if (strlit5360 == NULL) {
    strlit5360 = alloc_String(" in range.from(");
    gc_root(strlit5360);
  }
// compiled string node returning strlit5360 (depth = 9)
  int op_slot_left_5358 = gc_frame_newslot(strlit5360);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5361 = callmethod(strlit5360, "++(1)", 1, partcv, params);
// compiled op node returning opresult5361 (depth = 8)
  int op_slot_left_5355 = gc_frame_newslot(opresult5361);
  params[0] = strlit5356;
  partcv[0] = 1;
  Object opresult5362 = callmethod(opresult5361, "++(1)", 1, partcv, params);
// compiled op node returning opresult5362 (depth = 7)
  int op_slot_left_5353 = gc_frame_newslot(opresult5362);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5363 = callmethod(opresult5362, "++(1)", 1, partcv, params);
// compiled op node returning opresult5363 (depth = 6)
  int op_slot_left_5350 = gc_frame_newslot(opresult5363);
  params[0] = strlit5351;
  partcv[0] = 1;
  Object opresult5364 = callmethod(opresult5363, "++(1)", 1, partcv, params);
// compiled op node returning opresult5364 (depth = 5)
  int op_slot_right_5349 = gc_frame_newslot(opresult5364);
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5367 == NULL) {
    strlit5367 = alloc_String("");
    gc_root(strlit5367);
  }
// compiled string node returning strlit5367 (depth = 6)
  int op_slot_right_5366 = gc_frame_newslot(strlit5367);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_5369 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 7)
  if (strlit5371 == NULL) {
    strlit5371 = alloc_String("upper bound ");
    gc_root(strlit5371);
  }
// compiled string node returning strlit5371 (depth = 7)
  int op_slot_left_5369 = gc_frame_newslot(strlit5371);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5372 = callmethod(strlit5371, "++(1)", 1, partcv, params);
// compiled op node returning opresult5372 (depth = 6)
  int op_slot_left_5366 = gc_frame_newslot(opresult5372);
  params[0] = strlit5367;
  partcv[0] = 1;
  Object opresult5373 = callmethod(opresult5372, "++(1)", 1, partcv, params);
// compiled op node returning opresult5373 (depth = 5)
  int op_slot_left_5349 = gc_frame_newslot(opresult5373);
  params[0] = opresult5364;
  partcv[0] = 1;
  Object opresult5374 = callmethod(opresult5373, "++(1)", 1, partcv, params);
// compiled op node returning opresult5374 (depth = 4)
  gc_frame_newslot(opresult5374);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult5374;
  partcv[0] = 1;
  Object call5375 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5348);
// compiled call node returning call5375 (depth = 3)
    gc_frame_newslot(call5375);
    if5342 = call5375;
  } else {
  }
stackframe = iftmpstackframe5342;
// compiled if node returning if5342 (depth = 2)
  sourceObject = obj5012;
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  int frame5376 = gc_frame_new();
  gc_frame_newslot(*var_lower);
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5377 = alloc_Block(NULL, NULL, "collectionsPrelude", 2004);
  gc_frame_newslot(block5377);
// method "_apply(_)"
  block_savedest(block5377);
  Object closure5378 = createclosure(1, "_apply(1)");
  setclosureframe(closure5378, stackframe);
  addtoclosure(closure5378, selfslot);
  struct UserObject *uo5378 = (struct UserObject*)block5377;
  uo5378->data[0] = (Object)closure5378;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5378 = addmethod2pos(block5377, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5378, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5378[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5378->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5378);
meth_meth_collectionsPrelude__apply_40_1_41_5378->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply_40_1_41_5378->type->names[0] = "__26";
  meth_meth_collectionsPrelude__apply_40_1_41_5378->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5378->definitionLine = 1991;
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5380 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5381 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5382 == NULL) {
    strlit5382 = alloc_String("__26");
    gc_root(strlit5382);
  }
// compiled string node returning strlit5382 (depth = 6)
  gc_frame_newslot(strlit5382);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5383 = gc_frame_new();
// call case 5: prelude request
  Object call5384 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5383);
// compiled member node returning call5384 (depth = 6)
  params[0] = strlit5382;
  partcv[0] = 1;
  Object call5385 = callmethodflags(call5384, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5381);
// compiled call node returning call5385 (depth = 5)
  gc_frame_newslot(call5385);
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other requests
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5386 = gc_frame_new();
// call case 5: prelude request
  Object call5387 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5386);
// compiled member node returning call5387 (depth = 5)
  params[0] = call5385;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5388 = callmethodflags(call5387, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5380);
// compiled call node returning call5388 (depth = 4)
((struct UserObject *)block5377)->data[1] = call5388;
// compiled block node returning block5377 (depth = 3)
  gc_frame_newslot(block5377);
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5389 = alloc_Block(NULL, NULL, "collectionsPrelude", 2005);
  gc_frame_newslot(block5389);
// method "_apply(_)"
  block_savedest(block5389);
  Object closure5390 = createclosure(4, "_apply(1)");
  setclosureframe(closure5390, stackframe);
  addtoclosure(closure5390, var_lower);
  addtoclosure(closure5390, var_upper);
  addtoclosure(closure5390, var_RequestError);
  addtoclosure(closure5390, selfslot);
  struct UserObject *uo5390 = (struct UserObject*)block5389;
  uo5390->data[0] = (Object)closure5390;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5390 = addmethod2pos(block5389, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5390, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5390[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5390->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5390);
  meth_meth_collectionsPrelude__apply_40_1_41_5390->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5390->definitionLine = 1991;
// compiled block node returning block5389 (depth = 3)
  gc_frame_newslot(block5389);
  params[0] = block5377;
  params[1] = block5389;
  Object matchres5376 = matchCase(*var_lower, params, 2,NULL);
  gc_frame_end(frame5376);
// compiled matchcase node returning matchres5376 (depth = 2)
  sourceObject = obj5012;
// Begin line 2007
  setline(2007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5420 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  Object call5421 = callmethodflags(*var_lower, "truncated", 0, partcv, params, 0);
  gc_frame_end(callframe5420);
// compiled member node returning call5421 (depth = 2)
  adddatum2(obj5012, call5421, 2);
  sourceObject = obj5012;
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_5423 = gc_frame_newslot(*var_lower);
// starting to compile member node (depth = 4)
  int callframe5425 = gc_frame_new();
// call case 4: self request
  Object call5426 = callmethodflags(self, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5425);
// compiled member node returning call5426 (depth = 4)
  int op_slot_left_5423 = gc_frame_newslot(call5426);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5427 = callmethod(call5426, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5427 (depth = 3)
  Object if5422 = done;
struct StackFrameObject *iftmpstackframe5422 = stackframe;
  if (istrue(opresult5427)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5422);
gc_frame_newslot((Object)stackframe);
// Begin line 2009
  setline(2009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5428 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 2010
  setline(2010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5431 == NULL) {
    strlit5431 = alloc_String(") is not an integer");
    gc_root(strlit5431);
  }
// compiled string node returning strlit5431 (depth = 6)
  int op_slot_right_5430 = gc_frame_newslot(strlit5431);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5433 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5436 == NULL) {
    strlit5436 = alloc_String(")downTo(");
    gc_root(strlit5436);
  }
// compiled string node returning strlit5436 (depth = 8)
  int op_slot_right_5435 = gc_frame_newslot(strlit5436);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_upper (depth = 9)
  int op_slot_right_5438 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 9)
  if (strlit5440 == NULL) {
    strlit5440 = alloc_String(" in range.from(");
    gc_root(strlit5440);
  }
// compiled string node returning strlit5440 (depth = 9)
  int op_slot_left_5438 = gc_frame_newslot(strlit5440);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5441 = callmethod(strlit5440, "++(1)", 1, partcv, params);
// compiled op node returning opresult5441 (depth = 8)
  int op_slot_left_5435 = gc_frame_newslot(opresult5441);
  params[0] = strlit5436;
  partcv[0] = 1;
  Object opresult5442 = callmethod(opresult5441, "++(1)", 1, partcv, params);
// compiled op node returning opresult5442 (depth = 7)
  int op_slot_left_5433 = gc_frame_newslot(opresult5442);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5443 = callmethod(opresult5442, "++(1)", 1, partcv, params);
// compiled op node returning opresult5443 (depth = 6)
  int op_slot_left_5430 = gc_frame_newslot(opresult5443);
  params[0] = strlit5431;
  partcv[0] = 1;
  Object opresult5444 = callmethod(opresult5443, "++(1)", 1, partcv, params);
// compiled op node returning opresult5444 (depth = 5)
  int op_slot_right_5429 = gc_frame_newslot(opresult5444);
// Begin line 2009
  setline(2009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5447 == NULL) {
    strlit5447 = alloc_String("");
    gc_root(strlit5447);
  }
// compiled string node returning strlit5447 (depth = 6)
  int op_slot_right_5446 = gc_frame_newslot(strlit5447);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5449 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 7)
  if (strlit5451 == NULL) {
    strlit5451 = alloc_String("lower bound ");
    gc_root(strlit5451);
  }
// compiled string node returning strlit5451 (depth = 7)
  int op_slot_left_5449 = gc_frame_newslot(strlit5451);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5452 = callmethod(strlit5451, "++(1)", 1, partcv, params);
// compiled op node returning opresult5452 (depth = 6)
  int op_slot_left_5446 = gc_frame_newslot(opresult5452);
  params[0] = strlit5447;
  partcv[0] = 1;
  Object opresult5453 = callmethod(opresult5452, "++(1)", 1, partcv, params);
// compiled op node returning opresult5453 (depth = 5)
  int op_slot_left_5429 = gc_frame_newslot(opresult5453);
  params[0] = opresult5444;
  partcv[0] = 1;
  Object opresult5454 = callmethod(opresult5453, "++(1)", 1, partcv, params);
// compiled op node returning opresult5454 (depth = 4)
  gc_frame_newslot(opresult5454);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult5454;
  partcv[0] = 1;
  Object call5455 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5428);
// compiled call node returning call5455 (depth = 3)
    gc_frame_newslot(call5455);
    if5422 = call5455;
  } else {
  }
stackframe = iftmpstackframe5422;
// compiled if node returning if5422 (depth = 2)
  sourceObject = obj5012;
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5458 = alloc_Float64(0);
// compiled num node returning num5458 (depth = 4)
  int op_slot_right_5457 = gc_frame_newslot(num5458);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5461 = alloc_Float64(1);
// compiled num node returning num5461 (depth = 5)
  int op_slot_right_5460 = gc_frame_newslot(num5461);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_5463 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_5463 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5465 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff5465 (depth = 5)
  int op_slot_left_5460 = gc_frame_newslot(diff5465);
  params[0] = num5461;
  partcv[0] = 1;
  Object sum5466 = callmethod(diff5465, "+(1)", 1, partcv, params);
// compiled op node returning sum5466 (depth = 4)
  int op_slot_left_5457 = gc_frame_newslot(sum5466);
  params[0] = num5458;
  partcv[0] = 1;
  Object opresult5467 = callmethod(sum5466, "<(1)", 1, partcv, params);
// compiled op node returning opresult5467 (depth = 3)
  Object if5456 = done;
struct StackFrameObject *iftmpstackframe5456 = stackframe;
  if (istrue(opresult5467)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5456);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 3)
  Object num5468 = alloc_Float64(0);
// compiled num node returning num5468 (depth = 3)
    gc_frame_newslot(num5468);
    if5456 = num5468;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe5456);
  gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5470 = alloc_Float64(1);
// compiled num node returning num5470 (depth = 4)
  int op_slot_right_5469 = gc_frame_newslot(num5470);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_5472 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_5472 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5474 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff5474 (depth = 4)
  int op_slot_left_5469 = gc_frame_newslot(diff5474);
  params[0] = num5470;
  partcv[0] = 1;
  Object sum5475 = callmethod(diff5474, "+(1)", 1, partcv, params);
// compiled op node returning sum5475 (depth = 3)
    gc_frame_newslot(sum5475);
    if5456 = sum5475;
  }
stackframe = iftmpstackframe5456;
// compiled if node returning if5456 (depth = 2)
  adddatum2(obj5012, if5456, 3);
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  sourceObject = obj5012;
  objclass5012 = obj5012->class;
  objclass5012->definitionModule = modulename;
  objclass5012->definitionLine = 1992;
  (*(struct UserObject *)self).data[0] = lowerouter5012;
  self = oldself5012;
  selfslot = oldselfslot5012;
  stackframe = oldstackframe5012;
  gc_frame_end(frame);
  return obj5012;
}
Object meth_collectionsPrelude_range4506(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "range");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Number = getfromclosure(closure, 0);
  Object *var_RequestError = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  Object *var_BoundsError = getfromclosure(closure, 3);
  Object *var__prelude = getfromclosure(closure, 4);
  Object *var_indexable = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4507 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4507 = alloc_userobj2(5,6, objclass4507);
  gc_frame_newslot(obj4507);
if (objclass4507 == NULL) {
  glfree(obj4507->class->name);
  obj4507->class->name = "range";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4507, self, 0);
  addmethodreal(obj4507,"outer", &reader_collectionsPrelude_outer_4508);
  Object oldself4507 = self;
  struct StackFrameObject *oldstackframe4507 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4507);
  gc_frame_newslot((Object)stackframe);
  self = obj4507;
  Object *oldselfslot4507 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4507 = (*(struct UserObject *)self).data[0], lowerouter4507 = thisouter4507;
  if (inheritingObject4507) {
    struct UserObject *inho4507 = (struct UserObject *)inheritingObject4507;
    while (inho4507->super != GraceDefaultObject) inho4507 = (struct UserObject *)inho4507->super;
    inho4507->super = obj4507;
    self = inheritingObject4507;
    *selfslot = self;
    lowerouter4507 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4507;
  }
// method "from(_)to(_)"
  block_savedest(obj4507);
  Object closure4509 = createclosure(2, "from(1)to(1)");
  setclosureframe(closure4509, stackframe);
  addtoclosure(closure4509, var_Number);
  addtoclosure(closure4509, var_RequestError);
  struct UserObject *uo4509 = (struct UserObject*)obj4507;
  uo4509->data[1] = (Object)closure4509;
  Method *meth_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4509 = addmethod2pos(obj4507, "from(1)to(1)", &meth_collectionsPrelude_from_40_1_41_to_40_1_41_4509, 1);
  int argcv_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4509[] = {1, 1};
  meth_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4509->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4509);
  meth_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4509->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4509->definitionLine = 1878;
// method "uncheckedFrom(_)to(_)"
  block_savedest(obj4507);
  Object closure4654 = createclosure(4, "uncheckedFrom(1)to(1)");
  setclosureframe(closure4654, stackframe);
  addtoclosure(closure4654, var_IteratorExhausted);
  addtoclosure(closure4654, var_BoundsError);
  addtoclosure(closure4654, var__prelude);
  addtoclosure(closure4654, var_indexable);
  struct UserObject *uo4654 = (struct UserObject*)obj4507;
  uo4654->data[2] = (Object)closure4654;
  Method *meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654 = addmethod2pos(obj4507, "uncheckedFrom(1)to(1)", &meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654, 2);
  int argcv_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654[] = {1, 1};
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654);
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654->definitionModule = modulename;
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654->definitionLine = 1901;
  block_savedest(obj4507);
  Object closure5010 = createclosure(4, "uncheckedFrom(1)to(1)$object(1)");
  setclosureframe(closure5010, stackframe);
  addtoclosure(closure5010, var_IteratorExhausted);
  addtoclosure(closure5010, var_BoundsError);
  addtoclosure(closure5010, var__prelude);
  addtoclosure(closure5010, var_indexable);
  Method *meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654_object = addmethod2pos(obj4507, "uncheckedFrom(1)to(1)$object(1)", &meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654_object, 2);
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654_object->definitionLine = 1901;
// method "from(_)downTo(_)"
  block_savedest(obj4507);
  Object closure5011 = createclosure(6, "from(1)downTo(1)");
  setclosureframe(closure5011, stackframe);
  addtoclosure(closure5011, var_IteratorExhausted);
  addtoclosure(closure5011, var_BoundsError);
  addtoclosure(closure5011, var__prelude);
  addtoclosure(closure5011, var_indexable);
  addtoclosure(closure5011, var_Number);
  addtoclosure(closure5011, var_RequestError);
  struct UserObject *uo5011 = (struct UserObject*)obj4507;
  uo5011->data[3] = (Object)closure5011;
  Method *meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011 = addmethod2pos(obj4507, "from(1)downTo(1)", &meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011, 3);
  int argcv_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011[] = {1, 1};
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011);
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011->definitionLine = 1991;
  block_savedest(obj4507);
  Object closure5476 = createclosure(6, "from(1)downTo(1)$object(1)");
  setclosureframe(closure5476, stackframe);
  addtoclosure(closure5476, var_IteratorExhausted);
  addtoclosure(closure5476, var_BoundsError);
  addtoclosure(closure5476, var__prelude);
  addtoclosure(closure5476, var_indexable);
  addtoclosure(closure5476, var_Number);
  addtoclosure(closure5476, var_RequestError);
  Method *meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011_object = addmethod2pos(obj4507, "from(1)downTo(1)$object(1)", &meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011_object, 3);
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011_object->definitionLine = 1991;
  sourceObject = obj4507;
  sourceObject = obj4507;
  sourceObject = obj4507;
  objclass4507 = obj4507->class;
  objclass4507->definitionModule = modulename;
  objclass4507->definitionLine = 1877;
  (*(struct UserObject *)self).data[0] = lowerouter4507;
  self = oldself4507;
  selfslot = oldselfslot4507;
  stackframe = oldstackframe4507;
  gc_frame_end(frame);
  return obj4507;
}
Object meth_collectionsPrelude_range4506_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "range$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_Number = getfromclosure(closure, 0);
  Object *var_RequestError = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  Object *var_BoundsError = getfromclosure(closure, 3);
  Object *var__prelude = getfromclosure(closure, 4);
  Object *var_indexable = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4507 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4507 = alloc_userobj2(5,6, objclass4507);
  gc_frame_newslot(obj4507);
if (objclass4507 == NULL) {
  glfree(obj4507->class->name);
  obj4507->class->name = "range";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4507, self, 0);
  addmethodreal(obj4507,"outer", &reader_collectionsPrelude_outer_4508);
  Object oldself4507 = self;
  struct StackFrameObject *oldstackframe4507 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4507);
  gc_frame_newslot((Object)stackframe);
  self = obj4507;
  Object *oldselfslot4507 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4507 = (*(struct UserObject *)self).data[0], lowerouter4507 = thisouter4507;
  if (inheritingObject4507) {
    struct UserObject *inho4507 = (struct UserObject *)inheritingObject4507;
    while (inho4507->super != GraceDefaultObject) inho4507 = (struct UserObject *)inho4507->super;
    inho4507->super = obj4507;
    self = inheritingObject4507;
    *selfslot = self;
    lowerouter4507 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4507;
  }
// method "from(_)to(_)"
  block_savedest(obj4507);
  Object closure4509 = createclosure(2, "from(1)to(1)");
  setclosureframe(closure4509, stackframe);
  addtoclosure(closure4509, var_Number);
  addtoclosure(closure4509, var_RequestError);
  struct UserObject *uo4509 = (struct UserObject*)obj4507;
  uo4509->data[1] = (Object)closure4509;
  Method *meth_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4509 = addmethod2pos(obj4507, "from(1)to(1)", &meth_collectionsPrelude_from_40_1_41_to_40_1_41_4509, 1);
  int argcv_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4509[] = {1, 1};
  meth_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4509->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4509);
  meth_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4509->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4509->definitionLine = 1878;
// method "uncheckedFrom(_)to(_)"
  block_savedest(obj4507);
  Object closure4654 = createclosure(4, "uncheckedFrom(1)to(1)");
  setclosureframe(closure4654, stackframe);
  addtoclosure(closure4654, var_IteratorExhausted);
  addtoclosure(closure4654, var_BoundsError);
  addtoclosure(closure4654, var__prelude);
  addtoclosure(closure4654, var_indexable);
  struct UserObject *uo4654 = (struct UserObject*)obj4507;
  uo4654->data[2] = (Object)closure4654;
  Method *meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654 = addmethod2pos(obj4507, "uncheckedFrom(1)to(1)", &meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654, 2);
  int argcv_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654[] = {1, 1};
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654);
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654->definitionModule = modulename;
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654->definitionLine = 1901;
  block_savedest(obj4507);
  Object closure5010 = createclosure(4, "uncheckedFrom(1)to(1)$object(1)");
  setclosureframe(closure5010, stackframe);
  addtoclosure(closure5010, var_IteratorExhausted);
  addtoclosure(closure5010, var_BoundsError);
  addtoclosure(closure5010, var__prelude);
  addtoclosure(closure5010, var_indexable);
  Method *meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654_object = addmethod2pos(obj4507, "uncheckedFrom(1)to(1)$object(1)", &meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654_object, 2);
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4654_object->definitionLine = 1901;
// method "from(_)downTo(_)"
  block_savedest(obj4507);
  Object closure5011 = createclosure(6, "from(1)downTo(1)");
  setclosureframe(closure5011, stackframe);
  addtoclosure(closure5011, var_IteratorExhausted);
  addtoclosure(closure5011, var_BoundsError);
  addtoclosure(closure5011, var__prelude);
  addtoclosure(closure5011, var_indexable);
  addtoclosure(closure5011, var_Number);
  addtoclosure(closure5011, var_RequestError);
  struct UserObject *uo5011 = (struct UserObject*)obj4507;
  uo5011->data[3] = (Object)closure5011;
  Method *meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011 = addmethod2pos(obj4507, "from(1)downTo(1)", &meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011, 3);
  int argcv_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011[] = {1, 1};
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011);
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011->definitionLine = 1991;
  block_savedest(obj4507);
  Object closure5476 = createclosure(6, "from(1)downTo(1)$object(1)");
  setclosureframe(closure5476, stackframe);
  addtoclosure(closure5476, var_IteratorExhausted);
  addtoclosure(closure5476, var_BoundsError);
  addtoclosure(closure5476, var__prelude);
  addtoclosure(closure5476, var_indexable);
  addtoclosure(closure5476, var_Number);
  addtoclosure(closure5476, var_RequestError);
  Method *meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011_object = addmethod2pos(obj4507, "from(1)downTo(1)$object(1)", &meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011_object, 3);
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_5011_object->definitionLine = 1991;
  sourceObject = obj4507;
  sourceObject = obj4507;
  sourceObject = obj4507;
  objclass4507 = obj4507->class;
  objclass4507->definitionModule = modulename;
  objclass4507->definitionLine = 1877;
  (*(struct UserObject *)self).data[0] = lowerouter4507;
  self = oldself4507;
  selfslot = oldselfslot4507;
  stackframe = oldstackframe4507;
  gc_frame_end(frame);
  return obj4507;
}
Object meth_collectionsPrelude_BoundsError5483(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "BoundsError");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_BoundsError (depth = 3)
  gc_frame_end(frame);
  return *var_BoundsError;
}
Object meth_collectionsPrelude_IteratorExhausted5489(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "IteratorExhausted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_IteratorExhausted (depth = 3)
  gc_frame_end(frame);
  return *var_IteratorExhausted;
}
Object meth_collectionsPrelude_SubobjectResponsibility5495(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SubobjectResponsibility");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SubobjectResponsibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SubobjectResponsibility (depth = 3)
  gc_frame_end(frame);
  return *var_SubobjectResponsibility;
}
Object meth_collectionsPrelude_NoSuchObject5501(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "NoSuchObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_NoSuchObject (depth = 3)
  gc_frame_end(frame);
  return *var_NoSuchObject;
}
Object meth_collectionsPrelude_RequestError5507(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "RequestError");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_RequestError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_RequestError (depth = 3)
  gc_frame_end(frame);
  return *var_RequestError;
}
Object meth_collectionsPrelude_ConcurrentModification5513(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ConcurrentModification");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ConcurrentModification (depth = 3)
  gc_frame_end(frame);
  return *var_ConcurrentModification;
}
Object meth_collectionsPrelude_SizeUnknown5519(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SizeUnknown");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SizeUnknown (depth = 3)
  gc_frame_end(frame);
  return *var_SizeUnknown;
}
Object meth_collectionsPrelude_Block05522(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Block0");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Block0 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Block0 (depth = 3)
  gc_frame_end(frame);
  return *var_Block0;
}
Object meth_collectionsPrelude_Block15525(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Block1");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Block1 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Block1 (depth = 3)
  gc_frame_end(frame);
  return *var_Block1;
}
Object meth_collectionsPrelude_Block25528(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Block2");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Block2 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Block2 (depth = 3)
  gc_frame_end(frame);
  return *var_Block2;
}
Object meth_collectionsPrelude_SelfType5530(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SelfType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SelfType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SelfType (depth = 3)
  gc_frame_end(frame);
  return *var_SelfType;
}
Object meth_collectionsPrelude_Iterable5536(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Iterable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Iterable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Iterable (depth = 3)
  gc_frame_end(frame);
  return *var_Iterable;
}
Object meth_collectionsPrelude_Expandable5542(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Expandable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Expandable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Expandable (depth = 3)
  gc_frame_end(frame);
  return *var_Expandable;
}
Object meth_collectionsPrelude_Collection5548(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Collection");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Collection = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  gc_frame_end(frame);
  return *var_Collection;
}
Object meth_collectionsPrelude_Enumerable5554(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Enumerable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Enumerable (depth = 3)
  gc_frame_end(frame);
  return *var_Enumerable;
}
Object meth_collectionsPrelude_Sequence5560(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Sequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Sequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Sequence (depth = 3)
  gc_frame_end(frame);
  return *var_Sequence;
}
Object meth_collectionsPrelude_List5566(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "List");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_List = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_List (depth = 3)
  gc_frame_end(frame);
  return *var_List;
}
Object meth_collectionsPrelude_Set5572(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Set");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Set = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Set (depth = 3)
  gc_frame_end(frame);
  return *var_Set;
}
Object meth_collectionsPrelude_Dictionary5578(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Dictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Dictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Dictionary (depth = 3)
  gc_frame_end(frame);
  return *var_Dictionary;
}
Object meth_collectionsPrelude_Iterator5581(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Iterator = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Iterator (depth = 3)
  gc_frame_end(frame);
  return *var_Iterator;
}
Object meth_collectionsPrelude_asString5587(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5588 == NULL) {
    strlit5588 = alloc_String("a collection TRAIT");
    gc_root(strlit5588);
  }
// compiled string node returning strlit5588 (depth = 3)
  gc_frame_end(frame);
  return strlit5588;
}
Object meth_collectionsPrelude_sizeIfUnknown_40_1_41_5589(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sizeIfUnknown(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sizeIfUnknown(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sizeIfUnknown(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sizeIfUnknown(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5590 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_action (depth = 4)
  Object call5591 = callmethodflags(*var_action, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe5590);
// compiled member node returning call5591 (depth = 3)
  gc_frame_end(frame);
  return call5591;
}
Object meth_collectionsPrelude_size5592(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5593 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5594 == NULL) {
    strlit5594 = alloc_String("this collection does not know its size");
    gc_root(strlit5594);
  }
// compiled string node returning strlit5594 (depth = 4)
  gc_frame_newslot(strlit5594);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_SizeUnknown (depth = 4)
  params[0] = strlit5594;
  partcv[0] = 1;
  Object call5595 = callmethodflags(*var_SizeUnknown, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5593);
// compiled call node returning call5595 (depth = 3)
  gc_frame_end(frame);
  return call5595;
}
Object meth_collectionsPrelude_do5596(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5597 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5598 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5599 = gc_frame_new();
// call case 3: self.outer request
  Object call5600 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5599);
// compiled member node returning call5600 (depth = 5)
  Object call5601 = callmethodflags(call5600, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5598);
// compiled member node returning call5601 (depth = 4)
  Object call5602 = callmethodflags(call5601, "abstract", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5597);
// compiled member node returning call5602 (depth = 3)
  gc_frame_end(frame);
  return call5602;
}
Object meth_collectionsPrelude_iterator5603(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5604 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5605 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5606 = gc_frame_new();
// call case 3: self.outer request
  Object call5607 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5606);
// compiled member node returning call5607 (depth = 5)
  Object call5608 = callmethodflags(call5607, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5605);
// compiled member node returning call5608 (depth = 4)
  Object call5609 = callmethodflags(call5608, "abstract", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5604);
// compiled member node returning call5609 (depth = 3)
  gc_frame_end(frame);
  return call5609;
}
Object meth_collectionsPrelude_isEmpty5610(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5611 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5612 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5613 = gc_frame_new();
// call case 4: self request
  Object call5614 = callmethodflags(self, "iterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5613);
// compiled member node returning call5614 (depth = 5)
  Object call5615 = callmethodflags(call5614, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe5612);
// compiled member node returning call5615 (depth = 4)
  Object call5616 = callmethodflags(call5615, "not", 0, partcv, params, 0);
  gc_frame_end(callframe5611);
// compiled member node returning call5616 (depth = 3)
  gc_frame_end(frame);
  return call5616;
}
Object meth_collectionsPrelude_first5617(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "first");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_it = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "it");
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5618 = gc_frame_new();
// call case 4: self request
  Object call5619 = callmethodflags(self, "iterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5618);
// compiled member node returning call5619 (depth = 4)
  *var_it = call5619;
  if (call5619 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5621 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_it (depth = 5)
  Object call5622 = callmethodflags(*var_it, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe5621);
// compiled member node returning call5622 (depth = 4)
  Object if5620 = done;
  if (istrue(call5622)) {
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5623 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_it (depth = 5)
  Object call5624 = callmethodflags(*var_it, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5623);
// compiled member node returning call5624 (depth = 4)
    gc_frame_newslot(call5624);
    if5620 = call5624;
  } else {
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5625 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5627 == NULL) {
    strlit5627 = alloc_String("");
    gc_root(strlit5627);
  }
// compiled string node returning strlit5627 (depth = 6)
  int op_slot_right_5626 = gc_frame_newslot(strlit5627);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  int op_slot_right_5629 = gc_frame_newslot(self);
// starting to compile string node (depth = 7)
  if (strlit5631 == NULL) {
    strlit5631 = alloc_String("no first element in ");
    gc_root(strlit5631);
  }
// compiled string node returning strlit5631 (depth = 7)
  int op_slot_left_5629 = gc_frame_newslot(strlit5631);
  params[0] = self;
  partcv[0] = 1;
  Object opresult5632 = callmethod(strlit5631, "++(1)", 1, partcv, params);
// compiled op node returning opresult5632 (depth = 6)
  int op_slot_left_5626 = gc_frame_newslot(opresult5632);
  params[0] = strlit5627;
  partcv[0] = 1;
  Object opresult5633 = callmethod(opresult5632, "++(1)", 1, partcv, params);
// compiled op node returning opresult5633 (depth = 5)
  gc_frame_newslot(opresult5633);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_BoundsError (depth = 5)
  params[0] = opresult5633;
  partcv[0] = 1;
  Object call5634 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5625);
// compiled call node returning call5634 (depth = 4)
    gc_frame_newslot(call5634);
    if5620 = call5634;
  }
// compiled if node returning if5620 (depth = 3)
  gc_frame_end(frame);
  return if5620;
}
Object meth_collectionsPrelude__apply_40_1_41_5640(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_firstTime = getfromclosure(closure, 0);
  Object *var_block0 = getfromclosure(closure, 1);
  Object *var_block1 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_firstTime (depth = 6)
  Object if5641 = done;
  if (istrue(*var_firstTime)) {
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool5642 = alloc_Boolean(0);
// compiled identifier node returning bool5642 (depth = 7)
  *var_firstTime = bool5642;
  if (bool5642 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if5641 = done;
  } else {
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe5644 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_block0 (depth = 7)
  Object call5645 = callmethodflags(*var_block0, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe5644);
// compiled member node returning call5645 (depth = 6)
    gc_frame_newslot(call5645);
    if5641 = call5645;
  }
// compiled if node returning if5641 (depth = 5)
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5646 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call5647 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5646);
// compiled call node returning call5647 (depth = 5)
  gc_frame_end(frame);
  return call5647;
}
Object meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5635(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)separatedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)separatedBy(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)separatedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for do(_)separatedBy(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *var_block0 = &(stackframe->slots[1]);
  *var_block0 = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part separatedBy(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_firstTime = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "firstTime");
  Object *var_i = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "i");
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool5636 = alloc_Boolean(1);
// compiled identifier node returning bool5636 (depth = 4)
  *var_firstTime = bool5636;
  if (bool5636 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5637 = alloc_Float64(0);
// compiled num node returning num5637 (depth = 4)
  *var_i = num5637;
  if (num5637 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5638 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5639 = alloc_Block(NULL, NULL, "collectionsPrelude", 279);
  gc_frame_newslot(block5639);
// method "_apply(_)"
  block_savedest(block5639);
  Object closure5640 = createclosure(4, "_apply(1)");
  setclosureframe(closure5640, stackframe);
  addtoclosure(closure5640, var_firstTime);
  addtoclosure(closure5640, var_block0);
  addtoclosure(closure5640, var_block1);
  addtoclosure(closure5640, selfslot);
  struct UserObject *uo5640 = (struct UserObject*)block5639;
  uo5640->data[0] = (Object)closure5640;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5640 = addmethod2pos(block5639, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5640, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5640[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5640->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5640);
  meth_meth_collectionsPrelude__apply_40_1_41_5640->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5640->definitionLine = 1991;
// compiled block node returning block5639 (depth = 4)
  gc_frame_newslot(block5639);
// call case 4: self request
  params[0] = block5639;
  partcv[0] = 1;
  Object call5649 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5638);
// compiled call node returning call5649 (depth = 3)
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  return self;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_reduce_40_2_41_5650(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reduce(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method reduce(_,_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for reduce(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_initial = &(stackframe->slots[0]);
  *var_initial = args[curarg];
  curarg++;
  Object *var_blk = &(stackframe->slots[1]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part reduce(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5651 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_initial (depth = 4)
  gc_frame_newslot(*var_initial);
// call case 4: self request
  params[0] = *var_blk;
  params[1] = *var_initial;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5652 = callmethodflags(self, "fold(1)startingWith(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5651);
// compiled call node returning call5652 (depth = 3)
  gc_frame_end(frame);
  return call5652;
}
Object meth_collectionsPrelude__apply_40_1_41_5656(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object *var_blk = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_it = &(stackframe->slots[0]);
  *var_it = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5657 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_result (depth = 7)
  gc_frame_newslot(*var_result);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_it (depth = 7)
  gc_frame_newslot(*var_it);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  params[0] = *var_result;
  params[1] = *var_it;
  partcv[0] = 2;
  Object call5658 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5657);
// compiled call node returning call5658 (depth = 6)
  *var_result = call5658;
  if (call5658 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5653(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fold(1)startingWith(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method fold(_)startingWith(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method fold(_)startingWith(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for fold(_)startingWith(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part fold(_)");
  Object *var_initial = &(stackframe->slots[1]);
  *var_initial = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part startingWith(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_initial (depth = 4)
  *var_result = *var_initial;
  if (*var_initial == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5654 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5655 = alloc_Block(NULL, NULL, "collectionsPrelude", 295);
  gc_frame_newslot(block5655);
// method "_apply(_)"
  block_savedest(block5655);
  Object closure5656 = createclosure(3, "_apply(1)");
  setclosureframe(closure5656, stackframe);
  addtoclosure(closure5656, var_result);
  addtoclosure(closure5656, var_blk);
  addtoclosure(closure5656, selfslot);
  struct UserObject *uo5656 = (struct UserObject*)block5655;
  uo5656->data[0] = (Object)closure5656;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5656 = addmethod2pos(block5655, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5656, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5656[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5656->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5656);
  meth_meth_collectionsPrelude__apply_40_1_41_5656->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5656->definitionLine = 1991;
// compiled block node returning block5655 (depth = 4)
  gc_frame_newslot(block5655);
// call case 4: self request
  params[0] = block5655;
  partcv[0] = 1;
  Object call5661 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5654);
// compiled call node returning call5661 (depth = 3)
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  return *var_result;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_map_40_1_41_5662(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for map(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_R = &(stackframe->slots[2]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_R = args[curarg++];
  } else {
    *var_R = Unknown;
  }
// End typeParams
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5663 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_block1 (depth = 4)
  gc_frame_newslot(*var_block1);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5664 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5665 = gc_frame_new();
// call case 3: self.outer request
  Object call5666 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5665);
// compiled member node returning call5666 (depth = 5)
  Object call5667 = callmethodflags(call5666, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5664);
// compiled member node returning call5667 (depth = 4)
  params[0] = self;
  params[1] = *var_block1;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5668 = callmethodflags(call5667, "lazySequenceOver(1)mappedBy(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5663);
// compiled call node returning call5668 (depth = 3)
  gc_frame_end(frame);
  return call5668;
}
Object meth_collectionsPrelude_filter_40_1_41_5669(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "filter(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method filter(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for filter(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_selectionCondition = &(stackframe->slots[0]);
  *var_selectionCondition = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part filter(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5670 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_selectionCondition (depth = 4)
  gc_frame_newslot(*var_selectionCondition);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5671 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5672 = gc_frame_new();
// call case 3: self.outer request
  Object call5673 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5672);
// compiled member node returning call5673 (depth = 5)
  Object call5674 = callmethodflags(call5673, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5671);
// compiled member node returning call5674 (depth = 4)
  params[0] = self;
  params[1] = *var_selectionCondition;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5675 = callmethodflags(call5674, "lazySequenceOver(1)filteredBy(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5670);
// compiled call node returning call5675 (depth = 3)
  gc_frame_end(frame);
  return call5675;
}
Object meth_collectionsPrelude_iter5676(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5677 = gc_frame_new();
// call case 4: self request
  Object call5678 = callmethodflags(self, "iterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5677);
// compiled member node returning call5678 (depth = 3)
  gc_frame_end(frame);
  return call5678;
}
Object meth_collectionsPrelude_asSequence5679(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asSequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5680 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5681 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5682 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5683 = gc_frame_new();
// call case 3: self.outer request
  Object call5684 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5683);
// compiled member node returning call5684 (depth = 6)
  Object call5685 = callmethodflags(call5684, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5682);
// compiled member node returning call5685 (depth = 5)
  Object call5686 = callmethodflags(call5685, "sequence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5681);
// compiled member node returning call5686 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5687 = callmethodflags(call5686, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5680);
// compiled call node returning call5687 (depth = 3)
  gc_frame_end(frame);
  return call5687;
}
Object meth_collectionsPrelude_asList5688(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asList");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5689 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5690 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5691 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5692 = gc_frame_new();
// call case 3: self.outer request
  Object call5693 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5692);
// compiled member node returning call5693 (depth = 6)
  Object call5694 = callmethodflags(call5693, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5691);
// compiled member node returning call5694 (depth = 5)
  Object call5695 = callmethodflags(call5694, "list", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5690);
// compiled member node returning call5695 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5696 = callmethodflags(call5695, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5689);
// compiled call node returning call5696 (depth = 3)
  gc_frame_end(frame);
  return call5696;
}
Object meth_collectionsPrelude_asSet5697(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asSet");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5698 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5699 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5700 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5701 = gc_frame_new();
// call case 3: self.outer request
  Object call5702 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5701);
// compiled member node returning call5702 (depth = 6)
  Object call5703 = callmethodflags(call5702, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5700);
// compiled member node returning call5703 (depth = 5)
  Object call5704 = callmethodflags(call5703, "set", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5699);
// compiled member node returning call5704 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5705 = callmethodflags(call5704, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5698);
// compiled call node returning call5705 (depth = 3)
  gc_frame_end(frame);
  return call5705;
}
Object meth_collectionsPrelude_TRAIT5584(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "TRAIT");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5585 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5585 = alloc_userobj2(16,17, objclass5585);
  gc_frame_newslot(obj5585);
if (objclass5585 == NULL) {
  glfree(obj5585->class->name);
  obj5585->class->name = "collection.collection.TRAIT";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5585, self, 0);
  addmethodreal(obj5585,"outer", &reader_collectionsPrelude_outer_5586);
  Object oldself5585 = self;
  struct StackFrameObject *oldstackframe5585 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5585);
  gc_frame_newslot((Object)stackframe);
  self = obj5585;
  Object *oldselfslot5585 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5585 = (*(struct UserObject *)self).data[0], lowerouter5585 = thisouter5585;
  if (inheritingObject5585) {
    struct UserObject *inho5585 = (struct UserObject *)inheritingObject5585;
    while (inho5585->super != GraceDefaultObject) inho5585 = (struct UserObject *)inho5585->super;
    inho5585->super = obj5585;
    self = inheritingObject5585;
    *selfslot = self;
    lowerouter5585 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5585;
  }
// method "asString"
  struct UserObject *uo5587 = (struct UserObject*)obj5585;
  uo5587->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5587 = addmethod2pos(obj5585, "asString", &meth_collectionsPrelude_asString5587, 1);
  int argcv_meth_collectionsPrelude_asString5587[] = {0};
  meth_meth_collectionsPrelude_asString5587->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5587);
  meth_meth_collectionsPrelude_asString5587->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5587->definitionLine = 255;
// method "sizeIfUnknown(_)"
  struct UserObject *uo5589 = (struct UserObject*)obj5585;
  uo5589->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5589 = addmethod2pos(obj5585, "sizeIfUnknown(1)", &meth_collectionsPrelude_sizeIfUnknown_40_1_41_5589, 2);
  int argcv_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5589[] = {1};
  meth_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5589->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5589);
  meth_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5589->definitionModule = modulename;
  meth_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5589->definitionLine = 256;
// method "size"
  block_savedest(obj5585);
  Object closure5592 = createclosure(1, "size");
  setclosureframe(closure5592, stackframe);
  addtoclosure(closure5592, var_SizeUnknown);
  struct UserObject *uo5592 = (struct UserObject*)obj5585;
  uo5592->data[3] = (Object)closure5592;
  Method *meth_meth_collectionsPrelude_size5592 = addmethod2pos(obj5585, "size", &meth_collectionsPrelude_size5592, 3);
  int argcv_meth_collectionsPrelude_size5592[] = {0};
  meth_meth_collectionsPrelude_size5592->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5592);
  meth_meth_collectionsPrelude_size5592->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5592->definitionLine = 259;
// method "do"
  struct UserObject *uo5596 = (struct UserObject*)obj5585;
  uo5596->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do5596 = addmethod2pos(obj5585, "do", &meth_collectionsPrelude_do5596, 4);
  int argcv_meth_collectionsPrelude_do5596[] = {0};
  meth_meth_collectionsPrelude_do5596->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do5596);
  meth_meth_collectionsPrelude_do5596->definitionModule = modulename;
  meth_meth_collectionsPrelude_do5596->definitionLine = 262;
// method "iterator"
  struct UserObject *uo5603 = (struct UserObject*)obj5585;
  uo5603->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator5603 = addmethod2pos(obj5585, "iterator", &meth_collectionsPrelude_iterator5603, 5);
  int argcv_meth_collectionsPrelude_iterator5603[] = {0};
  meth_meth_collectionsPrelude_iterator5603->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5603);
  meth_meth_collectionsPrelude_iterator5603->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5603->definitionLine = 263;
// method "isEmpty"
  struct UserObject *uo5610 = (struct UserObject*)obj5585;
  uo5610->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty5610 = addmethod2pos(obj5585, "isEmpty", &meth_collectionsPrelude_isEmpty5610, 6);
  int argcv_meth_collectionsPrelude_isEmpty5610[] = {0};
  meth_meth_collectionsPrelude_isEmpty5610->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty5610);
  meth_meth_collectionsPrelude_isEmpty5610->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty5610->definitionLine = 264;
// method "first"
  block_savedest(obj5585);
  Object closure5617 = createclosure(1, "first");
  setclosureframe(closure5617, stackframe);
  addtoclosure(closure5617, var_BoundsError);
  struct UserObject *uo5617 = (struct UserObject*)obj5585;
  uo5617->data[7] = (Object)closure5617;
  Method *meth_meth_collectionsPrelude_first5617 = addmethod2pos(obj5585, "first", &meth_collectionsPrelude_first5617, 7);
  int argcv_meth_collectionsPrelude_first5617[] = {0};
  meth_meth_collectionsPrelude_first5617->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_first5617);
  meth_meth_collectionsPrelude_first5617->definitionModule = modulename;
  meth_meth_collectionsPrelude_first5617->definitionLine = 268;
// method "do(_)separatedBy(_)"
  struct UserObject *uo5635 = (struct UserObject*)obj5585;
  uo5635->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5635 = addmethod2pos(obj5585, "do(1)separatedBy(1)", &meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5635, 8);
  int argcv_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5635[] = {1, 1};
  meth_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5635->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5635);
  meth_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5635->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5635->definitionLine = 276;
// method "reduce(_,_)"
  struct UserObject *uo5650 = (struct UserObject*)obj5585;
  uo5650->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reduce_40_2_41_5650 = addmethod2pos(obj5585, "reduce(2)", &meth_collectionsPrelude_reduce_40_2_41_5650, 9);
  int argcv_meth_collectionsPrelude_reduce_40_2_41_5650[] = {2};
  meth_meth_collectionsPrelude_reduce_40_2_41_5650->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reduce_40_2_41_5650);
  meth_meth_collectionsPrelude_reduce_40_2_41_5650->definitionModule = modulename;
  meth_meth_collectionsPrelude_reduce_40_2_41_5650->definitionLine = 289;
// method "fold(_)startingWith(_)"
  struct UserObject *uo5653 = (struct UserObject*)obj5585;
  uo5653->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5653 = addmethod2pos(obj5585, "fold(1)startingWith(1)", &meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5653, 10);
  int argcv_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5653[] = {1, 1};
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5653->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5653);
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5653->definitionModule = modulename;
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5653->definitionLine = 293;
// method "map(_)"
  struct UserObject *uo5662 = (struct UserObject*)obj5585;
  uo5662->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_map_40_1_41_5662 = addmethod2pos(obj5585, "map(1)", &meth_collectionsPrelude_map_40_1_41_5662, 11);
  int argcv_meth_collectionsPrelude_map_40_1_41_5662[] = {1};
  meth_meth_collectionsPrelude_map_40_1_41_5662->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_map_40_1_41_5662);
  meth_meth_collectionsPrelude_map_40_1_41_5662->definitionModule = modulename;
  meth_meth_collectionsPrelude_map_40_1_41_5662->definitionLine = 300;
// method "filter(_)"
  struct UserObject *uo5669 = (struct UserObject*)obj5585;
  uo5669->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_filter_40_1_41_5669 = addmethod2pos(obj5585, "filter(1)", &meth_collectionsPrelude_filter_40_1_41_5669, 12);
  int argcv_meth_collectionsPrelude_filter_40_1_41_5669[] = {1};
  meth_meth_collectionsPrelude_filter_40_1_41_5669->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_filter_40_1_41_5669);
  meth_meth_collectionsPrelude_filter_40_1_41_5669->definitionModule = modulename;
  meth_meth_collectionsPrelude_filter_40_1_41_5669->definitionLine = 303;
// method "iter"
  struct UserObject *uo5676 = (struct UserObject*)obj5585;
  uo5676->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iter5676 = addmethod2pos(obj5585, "iter", &meth_collectionsPrelude_iter5676, 13);
  int argcv_meth_collectionsPrelude_iter5676[] = {0};
  meth_meth_collectionsPrelude_iter5676->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iter5676);
  meth_meth_collectionsPrelude_iter5676->definitionModule = modulename;
  meth_meth_collectionsPrelude_iter5676->definitionLine = 307;
// method "asSequence"
  struct UserObject *uo5679 = (struct UserObject*)obj5585;
  uo5679->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence5679 = addmethod2pos(obj5585, "asSequence", &meth_collectionsPrelude_asSequence5679, 14);
  int argcv_meth_collectionsPrelude_asSequence5679[] = {0};
  meth_meth_collectionsPrelude_asSequence5679->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence5679);
  meth_meth_collectionsPrelude_asSequence5679->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence5679->definitionLine = 309;
// method "asList"
  struct UserObject *uo5688 = (struct UserObject*)obj5585;
  uo5688->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asList5688 = addmethod2pos(obj5585, "asList", &meth_collectionsPrelude_asList5688, 15);
  int argcv_meth_collectionsPrelude_asList5688[] = {0};
  meth_meth_collectionsPrelude_asList5688->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asList5688);
  meth_meth_collectionsPrelude_asList5688->definitionModule = modulename;
  meth_meth_collectionsPrelude_asList5688->definitionLine = 312;
// method "asSet"
  struct UserObject *uo5697 = (struct UserObject*)obj5585;
  uo5697->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSet5697 = addmethod2pos(obj5585, "asSet", &meth_collectionsPrelude_asSet5697, 16);
  int argcv_meth_collectionsPrelude_asSet5697[] = {0};
  meth_meth_collectionsPrelude_asSet5697->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSet5697);
  meth_meth_collectionsPrelude_asSet5697->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSet5697->definitionLine = 315;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  objclass5585 = obj5585->class;
  objclass5585->definitionModule = modulename;
  objclass5585->definitionLine = 253;
  (*(struct UserObject *)self).data[0] = lowerouter5585;
  self = oldself5585;
  selfslot = oldselfslot5585;
  stackframe = oldstackframe5585;
  gc_frame_end(frame);
  return obj5585;
}
Object meth_collectionsPrelude_TRAIT5584_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "TRAIT$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5585 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5585 = alloc_userobj2(16,17, objclass5585);
  gc_frame_newslot(obj5585);
if (objclass5585 == NULL) {
  glfree(obj5585->class->name);
  obj5585->class->name = "collection.collection.TRAIT";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5585, self, 0);
  addmethodreal(obj5585,"outer", &reader_collectionsPrelude_outer_5586);
  Object oldself5585 = self;
  struct StackFrameObject *oldstackframe5585 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5585);
  gc_frame_newslot((Object)stackframe);
  self = obj5585;
  Object *oldselfslot5585 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5585 = (*(struct UserObject *)self).data[0], lowerouter5585 = thisouter5585;
  if (inheritingObject5585) {
    struct UserObject *inho5585 = (struct UserObject *)inheritingObject5585;
    while (inho5585->super != GraceDefaultObject) inho5585 = (struct UserObject *)inho5585->super;
    inho5585->super = obj5585;
    self = inheritingObject5585;
    *selfslot = self;
    lowerouter5585 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5585;
  }
// method "asString"
  struct UserObject *uo5587 = (struct UserObject*)obj5585;
  uo5587->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5587 = addmethod2pos(obj5585, "asString", &meth_collectionsPrelude_asString5587, 1);
  int argcv_meth_collectionsPrelude_asString5587[] = {0};
  meth_meth_collectionsPrelude_asString5587->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5587);
  meth_meth_collectionsPrelude_asString5587->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5587->definitionLine = 255;
// method "sizeIfUnknown(_)"
  struct UserObject *uo5589 = (struct UserObject*)obj5585;
  uo5589->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5589 = addmethod2pos(obj5585, "sizeIfUnknown(1)", &meth_collectionsPrelude_sizeIfUnknown_40_1_41_5589, 2);
  int argcv_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5589[] = {1};
  meth_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5589->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5589);
  meth_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5589->definitionModule = modulename;
  meth_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5589->definitionLine = 256;
// method "size"
  block_savedest(obj5585);
  Object closure5592 = createclosure(1, "size");
  setclosureframe(closure5592, stackframe);
  addtoclosure(closure5592, var_SizeUnknown);
  struct UserObject *uo5592 = (struct UserObject*)obj5585;
  uo5592->data[3] = (Object)closure5592;
  Method *meth_meth_collectionsPrelude_size5592 = addmethod2pos(obj5585, "size", &meth_collectionsPrelude_size5592, 3);
  int argcv_meth_collectionsPrelude_size5592[] = {0};
  meth_meth_collectionsPrelude_size5592->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5592);
  meth_meth_collectionsPrelude_size5592->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5592->definitionLine = 259;
// method "do"
  struct UserObject *uo5596 = (struct UserObject*)obj5585;
  uo5596->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do5596 = addmethod2pos(obj5585, "do", &meth_collectionsPrelude_do5596, 4);
  int argcv_meth_collectionsPrelude_do5596[] = {0};
  meth_meth_collectionsPrelude_do5596->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do5596);
  meth_meth_collectionsPrelude_do5596->definitionModule = modulename;
  meth_meth_collectionsPrelude_do5596->definitionLine = 262;
// method "iterator"
  struct UserObject *uo5603 = (struct UserObject*)obj5585;
  uo5603->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator5603 = addmethod2pos(obj5585, "iterator", &meth_collectionsPrelude_iterator5603, 5);
  int argcv_meth_collectionsPrelude_iterator5603[] = {0};
  meth_meth_collectionsPrelude_iterator5603->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5603);
  meth_meth_collectionsPrelude_iterator5603->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5603->definitionLine = 263;
// method "isEmpty"
  struct UserObject *uo5610 = (struct UserObject*)obj5585;
  uo5610->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty5610 = addmethod2pos(obj5585, "isEmpty", &meth_collectionsPrelude_isEmpty5610, 6);
  int argcv_meth_collectionsPrelude_isEmpty5610[] = {0};
  meth_meth_collectionsPrelude_isEmpty5610->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty5610);
  meth_meth_collectionsPrelude_isEmpty5610->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty5610->definitionLine = 264;
// method "first"
  block_savedest(obj5585);
  Object closure5617 = createclosure(1, "first");
  setclosureframe(closure5617, stackframe);
  addtoclosure(closure5617, var_BoundsError);
  struct UserObject *uo5617 = (struct UserObject*)obj5585;
  uo5617->data[7] = (Object)closure5617;
  Method *meth_meth_collectionsPrelude_first5617 = addmethod2pos(obj5585, "first", &meth_collectionsPrelude_first5617, 7);
  int argcv_meth_collectionsPrelude_first5617[] = {0};
  meth_meth_collectionsPrelude_first5617->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_first5617);
  meth_meth_collectionsPrelude_first5617->definitionModule = modulename;
  meth_meth_collectionsPrelude_first5617->definitionLine = 268;
// method "do(_)separatedBy(_)"
  struct UserObject *uo5635 = (struct UserObject*)obj5585;
  uo5635->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5635 = addmethod2pos(obj5585, "do(1)separatedBy(1)", &meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5635, 8);
  int argcv_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5635[] = {1, 1};
  meth_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5635->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5635);
  meth_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5635->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5635->definitionLine = 276;
// method "reduce(_,_)"
  struct UserObject *uo5650 = (struct UserObject*)obj5585;
  uo5650->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reduce_40_2_41_5650 = addmethod2pos(obj5585, "reduce(2)", &meth_collectionsPrelude_reduce_40_2_41_5650, 9);
  int argcv_meth_collectionsPrelude_reduce_40_2_41_5650[] = {2};
  meth_meth_collectionsPrelude_reduce_40_2_41_5650->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reduce_40_2_41_5650);
  meth_meth_collectionsPrelude_reduce_40_2_41_5650->definitionModule = modulename;
  meth_meth_collectionsPrelude_reduce_40_2_41_5650->definitionLine = 289;
// method "fold(_)startingWith(_)"
  struct UserObject *uo5653 = (struct UserObject*)obj5585;
  uo5653->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5653 = addmethod2pos(obj5585, "fold(1)startingWith(1)", &meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5653, 10);
  int argcv_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5653[] = {1, 1};
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5653->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5653);
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5653->definitionModule = modulename;
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5653->definitionLine = 293;
// method "map(_)"
  struct UserObject *uo5662 = (struct UserObject*)obj5585;
  uo5662->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_map_40_1_41_5662 = addmethod2pos(obj5585, "map(1)", &meth_collectionsPrelude_map_40_1_41_5662, 11);
  int argcv_meth_collectionsPrelude_map_40_1_41_5662[] = {1};
  meth_meth_collectionsPrelude_map_40_1_41_5662->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_map_40_1_41_5662);
  meth_meth_collectionsPrelude_map_40_1_41_5662->definitionModule = modulename;
  meth_meth_collectionsPrelude_map_40_1_41_5662->definitionLine = 300;
// method "filter(_)"
  struct UserObject *uo5669 = (struct UserObject*)obj5585;
  uo5669->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_filter_40_1_41_5669 = addmethod2pos(obj5585, "filter(1)", &meth_collectionsPrelude_filter_40_1_41_5669, 12);
  int argcv_meth_collectionsPrelude_filter_40_1_41_5669[] = {1};
  meth_meth_collectionsPrelude_filter_40_1_41_5669->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_filter_40_1_41_5669);
  meth_meth_collectionsPrelude_filter_40_1_41_5669->definitionModule = modulename;
  meth_meth_collectionsPrelude_filter_40_1_41_5669->definitionLine = 303;
// method "iter"
  struct UserObject *uo5676 = (struct UserObject*)obj5585;
  uo5676->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iter5676 = addmethod2pos(obj5585, "iter", &meth_collectionsPrelude_iter5676, 13);
  int argcv_meth_collectionsPrelude_iter5676[] = {0};
  meth_meth_collectionsPrelude_iter5676->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iter5676);
  meth_meth_collectionsPrelude_iter5676->definitionModule = modulename;
  meth_meth_collectionsPrelude_iter5676->definitionLine = 307;
// method "asSequence"
  struct UserObject *uo5679 = (struct UserObject*)obj5585;
  uo5679->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence5679 = addmethod2pos(obj5585, "asSequence", &meth_collectionsPrelude_asSequence5679, 14);
  int argcv_meth_collectionsPrelude_asSequence5679[] = {0};
  meth_meth_collectionsPrelude_asSequence5679->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence5679);
  meth_meth_collectionsPrelude_asSequence5679->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence5679->definitionLine = 309;
// method "asList"
  struct UserObject *uo5688 = (struct UserObject*)obj5585;
  uo5688->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asList5688 = addmethod2pos(obj5585, "asList", &meth_collectionsPrelude_asList5688, 15);
  int argcv_meth_collectionsPrelude_asList5688[] = {0};
  meth_meth_collectionsPrelude_asList5688->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asList5688);
  meth_meth_collectionsPrelude_asList5688->definitionModule = modulename;
  meth_meth_collectionsPrelude_asList5688->definitionLine = 312;
// method "asSet"
  struct UserObject *uo5697 = (struct UserObject*)obj5585;
  uo5697->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSet5697 = addmethod2pos(obj5585, "asSet", &meth_collectionsPrelude_asSet5697, 16);
  int argcv_meth_collectionsPrelude_asSet5697[] = {0};
  meth_meth_collectionsPrelude_asSet5697->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSet5697);
  meth_meth_collectionsPrelude_asSet5697->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSet5697->definitionLine = 315;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  sourceObject = obj5585;
  objclass5585 = obj5585->class;
  objclass5585->definitionModule = modulename;
  objclass5585->definitionLine = 253;
  (*(struct UserObject *)self).data[0] = lowerouter5585;
  self = oldself5585;
  selfslot = oldselfslot5585;
  stackframe = oldstackframe5585;
  gc_frame_end(frame);
  return obj5585;
}
Object meth_collectionsPrelude_asString5707(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5708 == NULL) {
    strlit5708 = alloc_String("class collection");
    gc_root(strlit5708);
  }
// compiled string node returning strlit5708 (depth = 3)
  gc_frame_end(frame);
  return strlit5708;
}
Object meth_collectionsPrelude_collection5709(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "collection");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_collection = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  gc_frame_end(frame);
  return *var_collection;
}
Object meth_collectionsPrelude_iterator5715(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5716 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5717 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5718 = gc_frame_new();
// call case 3: self.outer request
  Object call5719 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5718);
// compiled member node returning call5719 (depth = 5)
  Object call5720 = callmethodflags(call5719, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5717);
// compiled member node returning call5720 (depth = 4)
  Object call5721 = callmethodflags(call5720, "abstract", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5716);
// compiled member node returning call5721 (depth = 3)
  gc_frame_end(frame);
  return call5721;
}
Object meth_collectionsPrelude_size5722(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5723 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5725 == NULL) {
    strlit5725 = alloc_String("");
    gc_root(strlit5725);
  }
// compiled string node returning strlit5725 (depth = 5)
  int op_slot_right_5724 = gc_frame_newslot(strlit5725);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5728 = gc_frame_new();
// call case 4: self request
  Object call5729 = callmethodflags(self, "asDebugString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5728);
// compiled member node returning call5729 (depth = 6)
  int op_slot_right_5727 = gc_frame_newslot(call5729);
// starting to compile string node (depth = 6)
  if (strlit5731 == NULL) {
    strlit5731 = alloc_String("size requested on ");
    gc_root(strlit5731);
  }
// compiled string node returning strlit5731 (depth = 6)
  int op_slot_left_5727 = gc_frame_newslot(strlit5731);
  params[0] = call5729;
  partcv[0] = 1;
  Object opresult5732 = callmethod(strlit5731, "++(1)", 1, partcv, params);
// compiled op node returning opresult5732 (depth = 5)
  int op_slot_left_5724 = gc_frame_newslot(opresult5732);
  params[0] = strlit5725;
  partcv[0] = 1;
  Object opresult5733 = callmethod(opresult5732, "++(1)", 1, partcv, params);
// compiled op node returning opresult5733 (depth = 4)
  gc_frame_newslot(opresult5733);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_SizeUnknown (depth = 4)
  params[0] = opresult5733;
  partcv[0] = 1;
  Object call5734 = callmethodflags(*var_SizeUnknown, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5723);
// compiled call node returning call5734 (depth = 3)
  gc_frame_end(frame);
  return call5734;
}
Object meth_collectionsPrelude__apply_40_2_41_5746(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5747 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5748 = callmethodflags(*var_result, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5747);
// compiled call node returning call5748 (depth = 5)
  gc_frame_end(frame);
  return call5748;
}
Object meth_collectionsPrelude_asDictionary5735(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5736 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5737 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5738 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5739 = gc_frame_new();
// call case 3: self.outer request
  Object call5740 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5739);
// compiled member node returning call5740 (depth = 7)
  Object call5741 = callmethodflags(call5740, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5738);
// compiled member node returning call5741 (depth = 6)
  Object call5742 = callmethodflags(call5741, "dictionary", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5737);
// compiled member node returning call5742 (depth = 5)
  Object call5743 = callmethodflags(call5742, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe5736);
// compiled member node returning call5743 (depth = 4)
  *var_result = call5743;
  if (call5743 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5744 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5745 = alloc_Block(NULL, NULL, "collectionsPrelude", 329);
  gc_frame_newslot(block5745);
// method "_apply(_,_)"
  block_savedest(block5745);
  Object closure5746 = createclosure(2, "_apply(2)");
  setclosureframe(closure5746, stackframe);
  addtoclosure(closure5746, var_result);
  addtoclosure(closure5746, selfslot);
  struct UserObject *uo5746 = (struct UserObject*)block5745;
  uo5746->data[0] = (Object)closure5746;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_5746 = addmethod2pos(block5745, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_5746, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_5746[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_5746->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_5746);
  meth_meth_collectionsPrelude__apply_40_2_41_5746->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_5746->definitionLine = 1991;
// compiled block node returning block5745 (depth = 4)
  gc_frame_newslot(block5745);
// call case 4: self request
  params[0] = block5745;
  partcv[0] = 1;
  Object call5750 = callmethodflags(self, "keysAndValuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5744);
// compiled call node returning call5750 (depth = 3)
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  return *var_result;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply5756(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe5757 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_selfIterator (depth = 6)
  Object call5758 = callmethodflags(*var_selfIterator, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe5757);
// compiled member node returning call5758 (depth = 5)
  gc_frame_end(frame);
  return call5758;
}
Object meth_collectionsPrelude__apply5761(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object *var_existing = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5762 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5763 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_selfIterator (depth = 7)
  Object call5764 = callmethodflags(*var_selfIterator, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5763);
// compiled member node returning call5764 (depth = 6)
  gc_frame_newslot(call5764);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_existing (depth = 6)
  params[0] = call5764;
  partcv[0] = 1;
  Object call5765 = callmethodflags(*var_existing, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5762);
// compiled call node returning call5765 (depth = 5)
  gc_frame_end(frame);
  return call5765;
}
Object meth_collectionsPrelude_into_40_1_41_5751(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "into(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method into(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for into(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_existing = &(stackframe->slots[0]);
  *var_existing = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part into(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_selfIterator = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIterator");
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5752 = gc_frame_new();
// call case 4: self request
  Object call5753 = callmethodflags(self, "iterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5752);
// compiled member node returning call5753 (depth = 4)
  *var_selfIterator = call5753;
  if (call5753 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5754 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5755 = alloc_Block(NULL, NULL, "collectionsPrelude", 336);
  gc_frame_newslot(block5755);
// method "_apply"
  block_savedest(block5755);
  Object closure5756 = createclosure(2, "_apply");
  setclosureframe(closure5756, stackframe);
  addtoclosure(closure5756, var_selfIterator);
  addtoclosure(closure5756, selfslot);
  struct UserObject *uo5756 = (struct UserObject*)block5755;
  uo5756->data[0] = (Object)closure5756;
  Method *meth_meth_collectionsPrelude__apply5756 = addmethod2pos(block5755, "_apply", &meth_collectionsPrelude__apply5756, 0);
  int argcv_meth_collectionsPrelude__apply5756[] = {0};
  meth_meth_collectionsPrelude__apply5756->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5756);
  meth_meth_collectionsPrelude__apply5756->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5756->definitionLine = 1991;
// compiled block node returning block5755 (depth = 4)
  gc_frame_newslot(block5755);
// starting to compile block node (depth = 4)
  Object block5760 = alloc_Block(NULL, NULL, "collectionsPrelude", 336);
  gc_frame_newslot(block5760);
// method "_apply"
  block_savedest(block5760);
  Object closure5761 = createclosure(3, "_apply");
  setclosureframe(closure5761, stackframe);
  addtoclosure(closure5761, var_selfIterator);
  addtoclosure(closure5761, var_existing);
  addtoclosure(closure5761, selfslot);
  struct UserObject *uo5761 = (struct UserObject*)block5760;
  uo5761->data[0] = (Object)closure5761;
  Method *meth_meth_collectionsPrelude__apply5761 = addmethod2pos(block5760, "_apply", &meth_collectionsPrelude__apply5761, 0);
  int argcv_meth_collectionsPrelude__apply5761[] = {0};
  meth_meth_collectionsPrelude__apply5761->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5761);
  meth_meth_collectionsPrelude__apply5761->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5761->definitionLine = 1991;
// compiled block node returning block5760 (depth = 4)
  gc_frame_newslot(block5760);
// call case 5: prelude request
  params[0] = block5755;
  params[1] = block5760;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5767 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5754);
// compiled call node returning call5767 (depth = 3)
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_existing (depth = 3)
  gc_frame_end(frame);
  return *var_existing;
}
Object meth_collectionsPrelude__61__61__40_1_41_5768(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5769 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5770 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5771 = gc_frame_new();
// call case 3: self.outer request
  Object call5772 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5771);
// compiled member node returning call5772 (depth = 5)
  Object call5773 = callmethodflags(call5772, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5770);
// compiled member node returning call5773 (depth = 4)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5774 = callmethodflags(call5773, "isEqual(1)toIterable(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5769);
// compiled call node returning call5774 (depth = 3)
  gc_frame_end(frame);
  return call5774;
}
Object meth_collectionsPrelude__apply5780(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe5781 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_selfIterator (depth = 6)
  Object call5782 = callmethodflags(*var_selfIterator, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe5781);
// compiled member node returning call5782 (depth = 5)
  gc_frame_end(frame);
  return call5782;
}
Object meth_collectionsPrelude__apply5785(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5786 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5787 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_selfIterator (depth = 7)
  Object call5788 = callmethodflags(*var_selfIterator, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5787);
// compiled member node returning call5788 (depth = 6)
  gc_frame_newslot(call5788);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = call5788;
  partcv[0] = 1;
  Object call5789 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5786);
// compiled call node returning call5789 (depth = 5)
  gc_frame_end(frame);
  return call5789;
}
Object meth_collectionsPrelude_do_40_1_41_5775(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_selfIterator = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIterator");
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5776 = gc_frame_new();
// call case 4: self request
  Object call5777 = callmethodflags(self, "iterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5776);
// compiled member node returning call5777 (depth = 4)
  *var_selfIterator = call5777;
  if (call5777 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5778 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5779 = alloc_Block(NULL, NULL, "collectionsPrelude", 346);
  gc_frame_newslot(block5779);
// method "_apply"
  block_savedest(block5779);
  Object closure5780 = createclosure(2, "_apply");
  setclosureframe(closure5780, stackframe);
  addtoclosure(closure5780, var_selfIterator);
  addtoclosure(closure5780, selfslot);
  struct UserObject *uo5780 = (struct UserObject*)block5779;
  uo5780->data[0] = (Object)closure5780;
  Method *meth_meth_collectionsPrelude__apply5780 = addmethod2pos(block5779, "_apply", &meth_collectionsPrelude__apply5780, 0);
  int argcv_meth_collectionsPrelude__apply5780[] = {0};
  meth_meth_collectionsPrelude__apply5780->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5780);
  meth_meth_collectionsPrelude__apply5780->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5780->definitionLine = 1991;
// compiled block node returning block5779 (depth = 4)
  gc_frame_newslot(block5779);
// starting to compile block node (depth = 4)
  Object block5784 = alloc_Block(NULL, NULL, "collectionsPrelude", 346);
  gc_frame_newslot(block5784);
// method "_apply"
  block_savedest(block5784);
  Object closure5785 = createclosure(3, "_apply");
  setclosureframe(closure5785, stackframe);
  addtoclosure(closure5785, var_selfIterator);
  addtoclosure(closure5785, var_block1);
  addtoclosure(closure5785, selfslot);
  struct UserObject *uo5785 = (struct UserObject*)block5784;
  uo5785->data[0] = (Object)closure5785;
  Method *meth_meth_collectionsPrelude__apply5785 = addmethod2pos(block5784, "_apply", &meth_collectionsPrelude__apply5785, 0);
  int argcv_meth_collectionsPrelude__apply5785[] = {0};
  meth_meth_collectionsPrelude__apply5785->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5785);
  meth_meth_collectionsPrelude__apply5785->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5785->definitionLine = 1991;
// compiled block node returning block5784 (depth = 4)
  gc_frame_newslot(block5784);
// call case 5: prelude request
  params[0] = block5779;
  params[1] = block5784;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5791 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5778);
// compiled call node returning call5791 (depth = 3)
  gc_frame_end(frame);
  return call5791;
}
Object meth_collectionsPrelude__apply5798(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe5799 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_selfIterator (depth = 6)
  Object call5800 = callmethodflags(*var_selfIterator, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe5799);
// compiled member node returning call5800 (depth = 5)
  gc_frame_end(frame);
  return call5800;
}
Object meth_collectionsPrelude__apply5803(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_selfIterator = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num5805 = alloc_Float64(1);
// compiled num node returning num5805 (depth = 7)
  int op_slot_right_5804 = gc_frame_newslot(num5805);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  int op_slot_left_5804 = gc_frame_newslot(*var_ix);
  params[0] = num5805;
  partcv[0] = 1;
  Object sum5807 = callmethod(*var_ix, "+(1)", 1, partcv, params);
// compiled op node returning sum5807 (depth = 6)
  *var_ix = sum5807;
  if (sum5807 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5809 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// starting to compile member node (depth = 6)
  int callframe5810 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_selfIterator (depth = 7)
  Object call5811 = callmethodflags(*var_selfIterator, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5810);
// compiled member node returning call5811 (depth = 6)
  gc_frame_newslot(call5811);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block2 (depth = 6)
  params[0] = *var_ix;
  params[1] = call5811;
  partcv[0] = 2;
  Object call5812 = callmethodflags(*var_block2, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5809);
// compiled call node returning call5812 (depth = 5)
  gc_frame_end(frame);
  return call5812;
}
Object meth_collectionsPrelude_keysAndValuesDo_40_1_41_5792(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
  Object *var_selfIterator = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "selfIterator");
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5793 = alloc_Float64(0);
// compiled num node returning num5793 (depth = 4)
  *var_ix = num5793;
  if (num5793 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5794 = gc_frame_new();
// call case 4: self request
  Object call5795 = callmethodflags(self, "iterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5794);
// compiled member node returning call5795 (depth = 4)
  *var_selfIterator = call5795;
  if (call5795 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5796 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5797 = alloc_Block(NULL, NULL, "collectionsPrelude", 353);
  gc_frame_newslot(block5797);
// method "_apply"
  block_savedest(block5797);
  Object closure5798 = createclosure(2, "_apply");
  setclosureframe(closure5798, stackframe);
  addtoclosure(closure5798, var_selfIterator);
  addtoclosure(closure5798, selfslot);
  struct UserObject *uo5798 = (struct UserObject*)block5797;
  uo5798->data[0] = (Object)closure5798;
  Method *meth_meth_collectionsPrelude__apply5798 = addmethod2pos(block5797, "_apply", &meth_collectionsPrelude__apply5798, 0);
  int argcv_meth_collectionsPrelude__apply5798[] = {0};
  meth_meth_collectionsPrelude__apply5798->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5798);
  meth_meth_collectionsPrelude__apply5798->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5798->definitionLine = 1991;
// compiled block node returning block5797 (depth = 4)
  gc_frame_newslot(block5797);
// starting to compile block node (depth = 4)
  Object block5802 = alloc_Block(NULL, NULL, "collectionsPrelude", 353);
  gc_frame_newslot(block5802);
// method "_apply"
  block_savedest(block5802);
  Object closure5803 = createclosure(4, "_apply");
  setclosureframe(closure5803, stackframe);
  addtoclosure(closure5803, var_ix);
  addtoclosure(closure5803, var_selfIterator);
  addtoclosure(closure5803, var_block2);
  addtoclosure(closure5803, selfslot);
  struct UserObject *uo5803 = (struct UserObject*)block5802;
  uo5803->data[0] = (Object)closure5803;
  Method *meth_meth_collectionsPrelude__apply5803 = addmethod2pos(block5802, "_apply", &meth_collectionsPrelude__apply5803, 0);
  int argcv_meth_collectionsPrelude__apply5803[] = {0};
  meth_meth_collectionsPrelude__apply5803->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5803);
  meth_meth_collectionsPrelude__apply5803->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5803->definitionLine = 1991;
// compiled block node returning block5802 (depth = 4)
  gc_frame_newslot(block5802);
// call case 5: prelude request
  params[0] = block5797;
  params[1] = block5802;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5814 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5796);
// compiled call node returning call5814 (depth = 3)
  gc_frame_end(frame);
  return call5814;
}
Object meth_collectionsPrelude_values5815(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply5821(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe5822 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_selfIterator (depth = 6)
  Object call5823 = callmethodflags(*var_selfIterator, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe5822);
// compiled member node returning call5823 (depth = 5)
  gc_frame_end(frame);
  return call5823;
}
Object meth_collectionsPrelude__apply5826(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_res = getfromclosure(closure, 0);
  Object *var_selfIterator = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5827 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_res (depth = 7)
  gc_frame_newslot(*var_res);
// starting to compile member node (depth = 7)
  int callframe5828 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_selfIterator (depth = 8)
  Object call5829 = callmethodflags(*var_selfIterator, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5828);
// compiled member node returning call5829 (depth = 7)
  gc_frame_newslot(call5829);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_block2 (depth = 7)
  params[0] = *var_res;
  params[1] = call5829;
  partcv[0] = 2;
  Object call5830 = callmethodflags(*var_block2, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5827);
// compiled call node returning call5830 (depth = 6)
  *var_res = call5830;
  if (call5830 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5816(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fold(1)startingWith(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method fold(_)startingWith(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method fold(_)startingWith(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for fold(_)startingWith(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part fold(_)");
  Object *var_initial = &(stackframe->slots[1]);
  *var_initial = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part startingWith(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_R = &(stackframe->slots[3]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_R = args[curarg++];
  } else {
    *var_R = Unknown;
  }
// End typeParams
  Object *var_res = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "res");
  Object *var_selfIterator = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "selfIterator");
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_initial (depth = 4)
  *var_res = *var_initial;
  if (*var_initial == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5817 = gc_frame_new();
// call case 4: self request
  Object call5818 = callmethodflags(self, "iterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5817);
// compiled member node returning call5818 (depth = 4)
  *var_selfIterator = call5818;
  if (call5818 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5819 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5820 = alloc_Block(NULL, NULL, "collectionsPrelude", 364);
  gc_frame_newslot(block5820);
// method "_apply"
  block_savedest(block5820);
  Object closure5821 = createclosure(2, "_apply");
  setclosureframe(closure5821, stackframe);
  addtoclosure(closure5821, var_selfIterator);
  addtoclosure(closure5821, selfslot);
  struct UserObject *uo5821 = (struct UserObject*)block5820;
  uo5821->data[0] = (Object)closure5821;
  Method *meth_meth_collectionsPrelude__apply5821 = addmethod2pos(block5820, "_apply", &meth_collectionsPrelude__apply5821, 0);
  int argcv_meth_collectionsPrelude__apply5821[] = {0};
  meth_meth_collectionsPrelude__apply5821->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5821);
  meth_meth_collectionsPrelude__apply5821->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5821->definitionLine = 1991;
// compiled block node returning block5820 (depth = 4)
  gc_frame_newslot(block5820);
// starting to compile block node (depth = 4)
  Object block5825 = alloc_Block(NULL, NULL, "collectionsPrelude", 364);
  gc_frame_newslot(block5825);
// method "_apply"
  block_savedest(block5825);
  Object closure5826 = createclosure(4, "_apply");
  setclosureframe(closure5826, stackframe);
  addtoclosure(closure5826, var_res);
  addtoclosure(closure5826, var_selfIterator);
  addtoclosure(closure5826, var_block2);
  addtoclosure(closure5826, selfslot);
  struct UserObject *uo5826 = (struct UserObject*)block5825;
  uo5826->data[0] = (Object)closure5826;
  Method *meth_meth_collectionsPrelude__apply5826 = addmethod2pos(block5825, "_apply", &meth_collectionsPrelude__apply5826, 0);
  int argcv_meth_collectionsPrelude__apply5826[] = {0};
  meth_meth_collectionsPrelude__apply5826->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5826);
  meth_meth_collectionsPrelude__apply5826->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5826->definitionLine = 1991;
// compiled block node returning block5825 (depth = 4)
  gc_frame_newslot(block5825);
// call case 5: prelude request
  params[0] = block5820;
  params[1] = block5825;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5833 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5819);
// compiled call node returning call5833 (depth = 3)
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_res (depth = 4)
  return *var_res;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__43__43__40_1_41_5834(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5835 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5836 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5837 = gc_frame_new();
// call case 3: self.outer request
  Object call5838 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5837);
// compiled member node returning call5838 (depth = 5)
  Object call5839 = callmethodflags(call5838, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5836);
// compiled member node returning call5839 (depth = 4)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call5840 = callmethodflags(call5839, "lazyConcatenation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5835);
// compiled call node returning call5840 (depth = 3)
  gc_frame_end(frame);
  return call5840;
}
Object meth_collectionsPrelude_sortedBy_40_1_41_5841(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5842 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sortBlock (depth = 4)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5843 = gc_frame_new();
// call case 4: self request
  Object call5844 = callmethodflags(self, "asList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5843);
// compiled member node returning call5844 (depth = 4)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call5845 = callmethodflags(call5844, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5842);
// compiled call node returning call5845 (depth = 3)
  gc_frame_end(frame);
  return call5845;
}
Object meth_collectionsPrelude_sorted5846(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5847 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5848 = gc_frame_new();
// call case 4: self request
  Object call5849 = callmethodflags(self, "asList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5848);
// compiled member node returning call5849 (depth = 4)
  Object call5850 = callmethodflags(call5849, "sort", 0, partcv, params, 0);
  gc_frame_end(callframe5847);
// compiled member node returning call5850 (depth = 3)
  gc_frame_end(frame);
  return call5850;
}
Object meth_collectionsPrelude__apply_40_1_41_5855(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5857 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  Object call5858 = callmethodflags(*var_each, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe5857);
// compiled member node returning call5858 (depth = 7)
  int op_slot_right_5856 = gc_frame_newslot(call5858);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5856 = gc_frame_newslot(*var_s);
  params[0] = call5858;
  partcv[0] = 1;
  Object opresult5860 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5860 (depth = 6)
  *var_s = opresult5860;
  if (opresult5860 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply5864(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5866 == NULL) {
    strlit5866 = alloc_String(", ");
    gc_root(strlit5866);
  }
// compiled string node returning strlit5866 (depth = 7)
  int op_slot_right_5865 = gc_frame_newslot(strlit5866);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5865 = gc_frame_newslot(*var_s);
  params[0] = strlit5866;
  partcv[0] = 1;
  Object opresult5868 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5868 (depth = 6)
  *var_s = opresult5868;
  if (opresult5868 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_asString5851(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5852 == NULL) {
    strlit5852 = alloc_String("""\xe2""""\x9f""""\xa8""");
    gc_root(strlit5852);
  }
// compiled string node returning strlit5852 (depth = 4)
  *var_s = strlit5852;
  if (strlit5852 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5853 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5854 = alloc_Block(NULL, NULL, "collectionsPrelude", 380);
  gc_frame_newslot(block5854);
// method "_apply(_)"
  block_savedest(block5854);
  Object closure5855 = createclosure(2, "_apply(1)");
  setclosureframe(closure5855, stackframe);
  addtoclosure(closure5855, var_s);
  addtoclosure(closure5855, selfslot);
  struct UserObject *uo5855 = (struct UserObject*)block5854;
  uo5855->data[0] = (Object)closure5855;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5855 = addmethod2pos(block5854, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5855, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5855[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5855->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5855);
  meth_meth_collectionsPrelude__apply_40_1_41_5855->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5855->definitionLine = 1991;
// compiled block node returning block5854 (depth = 4)
  gc_frame_newslot(block5854);
// starting to compile block node (depth = 4)
  Object block5863 = alloc_Block(NULL, NULL, "collectionsPrelude", 380);
  gc_frame_newslot(block5863);
// method "_apply"
  block_savedest(block5863);
  Object closure5864 = createclosure(2, "_apply");
  setclosureframe(closure5864, stackframe);
  addtoclosure(closure5864, var_s);
  addtoclosure(closure5864, selfslot);
  struct UserObject *uo5864 = (struct UserObject*)block5863;
  uo5864->data[0] = (Object)closure5864;
  Method *meth_meth_collectionsPrelude__apply5864 = addmethod2pos(block5863, "_apply", &meth_collectionsPrelude__apply5864, 0);
  int argcv_meth_collectionsPrelude__apply5864[] = {0};
  meth_meth_collectionsPrelude__apply5864->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5864);
  meth_meth_collectionsPrelude__apply5864->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5864->definitionLine = 1991;
// compiled block node returning block5863 (depth = 4)
  gc_frame_newslot(block5863);
// call case 4: self request
  params[0] = block5854;
  params[1] = block5863;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5871 = callmethodflags(self, "do(1)separatedBy(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5853);
// compiled call node returning call5871 (depth = 3)
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5873 == NULL) {
    strlit5873 = alloc_String("""\xe2""""\x9f""""\xa9""");
    gc_root(strlit5873);
  }
// compiled string node returning strlit5873 (depth = 4)
  int op_slot_right_5872 = gc_frame_newslot(strlit5873);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_5872 = gc_frame_newslot(*var_s);
  params[0] = strlit5873;
  partcv[0] = 1;
  Object opresult5875 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5875 (depth = 3)
  gc_frame_end(frame);
  return opresult5875;
}
Object meth_collectionsPrelude_TRAIT5712(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "TRAIT");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var_collection = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5713 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5713 = alloc_userobj2(13,14, objclass5713);
  gc_frame_newslot(obj5713);
if (objclass5713 == NULL) {
  glfree(obj5713->class->name);
  obj5713->class->name = "enumerable.enumerable.TRAIT";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5713, self, 0);
  addmethodreal(obj5713,"outer", &reader_collectionsPrelude_outer_5714);
  Object oldself5713 = self;
  struct StackFrameObject *oldstackframe5713 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5713);
  gc_frame_newslot((Object)stackframe);
  self = obj5713;
  Object *oldselfslot5713 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5713 = (*(struct UserObject *)self).data[0], lowerouter5713 = thisouter5713;
  if (inheritingObject5713) {
    struct UserObject *inho5713 = (struct UserObject *)inheritingObject5713;
    while (inho5713->super != GraceDefaultObject) inho5713 = (struct UserObject *)inho5713->super;
    inho5713->super = obj5713;
    self = inheritingObject5713;
    *selfslot = self;
    lowerouter5713 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5713;
  }
// method "iterator"
  struct UserObject *uo5715 = (struct UserObject*)obj5713;
  uo5715->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator5715 = addmethod2pos(obj5713, "iterator", &meth_collectionsPrelude_iterator5715, 1);
  int argcv_meth_collectionsPrelude_iterator5715[] = {0};
  meth_meth_collectionsPrelude_iterator5715->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5715);
  meth_meth_collectionsPrelude_iterator5715->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5715->definitionLine = 322;
// method "size"
  block_savedest(obj5713);
  Object closure5722 = createclosure(1, "size");
  setclosureframe(closure5722, stackframe);
  addtoclosure(closure5722, var_SizeUnknown);
  struct UserObject *uo5722 = (struct UserObject*)obj5713;
  uo5722->data[2] = (Object)closure5722;
  Method *meth_meth_collectionsPrelude_size5722 = addmethod2pos(obj5713, "size", &meth_collectionsPrelude_size5722, 2);
  int argcv_meth_collectionsPrelude_size5722[] = {0};
  meth_meth_collectionsPrelude_size5722->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5722);
  meth_meth_collectionsPrelude_size5722->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5722->definitionLine = 323;
// method "asDictionary"
  struct UserObject *uo5735 = (struct UserObject*)obj5713;
  uo5735->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary5735 = addmethod2pos(obj5713, "asDictionary", &meth_collectionsPrelude_asDictionary5735, 3);
  int argcv_meth_collectionsPrelude_asDictionary5735[] = {0};
  meth_meth_collectionsPrelude_asDictionary5735->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary5735);
  meth_meth_collectionsPrelude_asDictionary5735->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary5735->definitionLine = 327;
// method "into(_)"
  struct UserObject *uo5751 = (struct UserObject*)obj5713;
  uo5751->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into_40_1_41_5751 = addmethod2pos(obj5713, "into(1)", &meth_collectionsPrelude_into_40_1_41_5751, 4);
  int argcv_meth_collectionsPrelude_into_40_1_41_5751[] = {1};
  meth_meth_collectionsPrelude_into_40_1_41_5751->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into_40_1_41_5751);
  meth_meth_collectionsPrelude_into_40_1_41_5751->definitionModule = modulename;
  meth_meth_collectionsPrelude_into_40_1_41_5751->definitionLine = 334;
// method "==(_)"
  struct UserObject *uo5768 = (struct UserObject*)obj5713;
  uo5768->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_5768 = addmethod2pos(obj5713, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_5768, 5);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_5768[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_5768->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_5768);
  meth_meth_collectionsPrelude__61__61__40_1_41_5768->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_5768->definitionLine = 341;
// method "do(_)"
  struct UserObject *uo5775 = (struct UserObject*)obj5713;
  uo5775->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_5775 = addmethod2pos(obj5713, "do(1)", &meth_collectionsPrelude_do_40_1_41_5775, 6);
  int argcv_meth_collectionsPrelude_do_40_1_41_5775[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_5775->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_5775);
  meth_meth_collectionsPrelude_do_40_1_41_5775->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_5775->definitionLine = 344;
// method "keysAndValuesDo(_)"
  struct UserObject *uo5792 = (struct UserObject*)obj5713;
  uo5792->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5792 = addmethod2pos(obj5713, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_5792, 7);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5792[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5792->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5792);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5792->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5792->definitionLine = 350;
// method "values"
  struct UserObject *uo5815 = (struct UserObject*)obj5713;
  uo5815->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values5815 = addmethod2pos(obj5713, "values", &meth_collectionsPrelude_values5815, 8);
  int argcv_meth_collectionsPrelude_values5815[] = {0};
  meth_meth_collectionsPrelude_values5815->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values5815);
  meth_meth_collectionsPrelude_values5815->definitionModule = modulename;
  meth_meth_collectionsPrelude_values5815->definitionLine = 358;
// method "fold(_)startingWith(_)"
  struct UserObject *uo5816 = (struct UserObject*)obj5713;
  uo5816->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5816 = addmethod2pos(obj5713, "fold(1)startingWith(1)", &meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5816, 9);
  int argcv_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5816[] = {1, 1};
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5816->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5816);
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5816->definitionModule = modulename;
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5816->definitionLine = 361;
// method "++(_)"
  struct UserObject *uo5834 = (struct UserObject*)obj5713;
  uo5834->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_5834 = addmethod2pos(obj5713, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_5834, 10);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_5834[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_5834->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_5834);
  meth_meth_collectionsPrelude__43__43__40_1_41_5834->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_5834->definitionLine = 369;
// method "sortedBy(_)"
  struct UserObject *uo5841 = (struct UserObject*)obj5713;
  uo5841->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_5841 = addmethod2pos(obj5713, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_5841, 11);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_5841[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5841->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_5841);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5841->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5841->definitionLine = 372;
// method "sorted"
  struct UserObject *uo5846 = (struct UserObject*)obj5713;
  uo5846->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted5846 = addmethod2pos(obj5713, "sorted", &meth_collectionsPrelude_sorted5846, 12);
  int argcv_meth_collectionsPrelude_sorted5846[] = {0};
  meth_meth_collectionsPrelude_sorted5846->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted5846);
  meth_meth_collectionsPrelude_sorted5846->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted5846->definitionLine = 375;
// method "asString"
  struct UserObject *uo5851 = (struct UserObject*)obj5713;
  uo5851->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5851 = addmethod2pos(obj5713, "asString", &meth_collectionsPrelude_asString5851, 13);
  int argcv_meth_collectionsPrelude_asString5851[] = {0};
  meth_meth_collectionsPrelude_asString5851->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5851);
  meth_meth_collectionsPrelude_asString5851->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5851->definitionLine = 378;
  sourceObject = obj5713;
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5876 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_collection (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5877 = callmethodflags(*var_collection, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5876);
// compiled call node returning call5877 (depth = 3)
  struct UserObject *obj5713_uo = (struct UserObject *)obj5713;
  obj5713_uo->super = call5877;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  objclass5713 = obj5713->class;
  objclass5713->definitionModule = modulename;
  objclass5713->definitionLine = 320;
  (*(struct UserObject *)self).data[0] = lowerouter5713;
  self = oldself5713;
  selfslot = oldselfslot5713;
  stackframe = oldstackframe5713;
  gc_frame_end(frame);
  return obj5713;
}
Object meth_collectionsPrelude_TRAIT5712_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "TRAIT$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var_collection = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5713 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5713 = alloc_userobj2(13,14, objclass5713);
  gc_frame_newslot(obj5713);
if (objclass5713 == NULL) {
  glfree(obj5713->class->name);
  obj5713->class->name = "enumerable.enumerable.TRAIT";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5713, self, 0);
  addmethodreal(obj5713,"outer", &reader_collectionsPrelude_outer_5714);
  Object oldself5713 = self;
  struct StackFrameObject *oldstackframe5713 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5713);
  gc_frame_newslot((Object)stackframe);
  self = obj5713;
  Object *oldselfslot5713 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5713 = (*(struct UserObject *)self).data[0], lowerouter5713 = thisouter5713;
  if (inheritingObject5713) {
    struct UserObject *inho5713 = (struct UserObject *)inheritingObject5713;
    while (inho5713->super != GraceDefaultObject) inho5713 = (struct UserObject *)inho5713->super;
    inho5713->super = obj5713;
    self = inheritingObject5713;
    *selfslot = self;
    lowerouter5713 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5713;
  }
// method "iterator"
  struct UserObject *uo5715 = (struct UserObject*)obj5713;
  uo5715->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator5715 = addmethod2pos(obj5713, "iterator", &meth_collectionsPrelude_iterator5715, 1);
  int argcv_meth_collectionsPrelude_iterator5715[] = {0};
  meth_meth_collectionsPrelude_iterator5715->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5715);
  meth_meth_collectionsPrelude_iterator5715->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5715->definitionLine = 322;
// method "size"
  block_savedest(obj5713);
  Object closure5722 = createclosure(1, "size");
  setclosureframe(closure5722, stackframe);
  addtoclosure(closure5722, var_SizeUnknown);
  struct UserObject *uo5722 = (struct UserObject*)obj5713;
  uo5722->data[2] = (Object)closure5722;
  Method *meth_meth_collectionsPrelude_size5722 = addmethod2pos(obj5713, "size", &meth_collectionsPrelude_size5722, 2);
  int argcv_meth_collectionsPrelude_size5722[] = {0};
  meth_meth_collectionsPrelude_size5722->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5722);
  meth_meth_collectionsPrelude_size5722->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5722->definitionLine = 323;
// method "asDictionary"
  struct UserObject *uo5735 = (struct UserObject*)obj5713;
  uo5735->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary5735 = addmethod2pos(obj5713, "asDictionary", &meth_collectionsPrelude_asDictionary5735, 3);
  int argcv_meth_collectionsPrelude_asDictionary5735[] = {0};
  meth_meth_collectionsPrelude_asDictionary5735->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary5735);
  meth_meth_collectionsPrelude_asDictionary5735->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary5735->definitionLine = 327;
// method "into(_)"
  struct UserObject *uo5751 = (struct UserObject*)obj5713;
  uo5751->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into_40_1_41_5751 = addmethod2pos(obj5713, "into(1)", &meth_collectionsPrelude_into_40_1_41_5751, 4);
  int argcv_meth_collectionsPrelude_into_40_1_41_5751[] = {1};
  meth_meth_collectionsPrelude_into_40_1_41_5751->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into_40_1_41_5751);
  meth_meth_collectionsPrelude_into_40_1_41_5751->definitionModule = modulename;
  meth_meth_collectionsPrelude_into_40_1_41_5751->definitionLine = 334;
// method "==(_)"
  struct UserObject *uo5768 = (struct UserObject*)obj5713;
  uo5768->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_5768 = addmethod2pos(obj5713, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_5768, 5);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_5768[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_5768->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_5768);
  meth_meth_collectionsPrelude__61__61__40_1_41_5768->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_5768->definitionLine = 341;
// method "do(_)"
  struct UserObject *uo5775 = (struct UserObject*)obj5713;
  uo5775->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_5775 = addmethod2pos(obj5713, "do(1)", &meth_collectionsPrelude_do_40_1_41_5775, 6);
  int argcv_meth_collectionsPrelude_do_40_1_41_5775[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_5775->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_5775);
  meth_meth_collectionsPrelude_do_40_1_41_5775->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_5775->definitionLine = 344;
// method "keysAndValuesDo(_)"
  struct UserObject *uo5792 = (struct UserObject*)obj5713;
  uo5792->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5792 = addmethod2pos(obj5713, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_5792, 7);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5792[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5792->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5792);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5792->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5792->definitionLine = 350;
// method "values"
  struct UserObject *uo5815 = (struct UserObject*)obj5713;
  uo5815->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values5815 = addmethod2pos(obj5713, "values", &meth_collectionsPrelude_values5815, 8);
  int argcv_meth_collectionsPrelude_values5815[] = {0};
  meth_meth_collectionsPrelude_values5815->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values5815);
  meth_meth_collectionsPrelude_values5815->definitionModule = modulename;
  meth_meth_collectionsPrelude_values5815->definitionLine = 358;
// method "fold(_)startingWith(_)"
  struct UserObject *uo5816 = (struct UserObject*)obj5713;
  uo5816->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5816 = addmethod2pos(obj5713, "fold(1)startingWith(1)", &meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5816, 9);
  int argcv_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5816[] = {1, 1};
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5816->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5816);
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5816->definitionModule = modulename;
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5816->definitionLine = 361;
// method "++(_)"
  struct UserObject *uo5834 = (struct UserObject*)obj5713;
  uo5834->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_5834 = addmethod2pos(obj5713, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_5834, 10);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_5834[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_5834->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_5834);
  meth_meth_collectionsPrelude__43__43__40_1_41_5834->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_5834->definitionLine = 369;
// method "sortedBy(_)"
  struct UserObject *uo5841 = (struct UserObject*)obj5713;
  uo5841->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_5841 = addmethod2pos(obj5713, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_5841, 11);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_5841[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5841->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_5841);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5841->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5841->definitionLine = 372;
// method "sorted"
  struct UserObject *uo5846 = (struct UserObject*)obj5713;
  uo5846->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted5846 = addmethod2pos(obj5713, "sorted", &meth_collectionsPrelude_sorted5846, 12);
  int argcv_meth_collectionsPrelude_sorted5846[] = {0};
  meth_meth_collectionsPrelude_sorted5846->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted5846);
  meth_meth_collectionsPrelude_sorted5846->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted5846->definitionLine = 375;
// method "asString"
  struct UserObject *uo5851 = (struct UserObject*)obj5713;
  uo5851->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5851 = addmethod2pos(obj5713, "asString", &meth_collectionsPrelude_asString5851, 13);
  int argcv_meth_collectionsPrelude_asString5851[] = {0};
  meth_meth_collectionsPrelude_asString5851->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5851);
  meth_meth_collectionsPrelude_asString5851->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5851->definitionLine = 378;
  sourceObject = obj5713;
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5876 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_collection (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5877 = callmethodflags(*var_collection, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5876);
// compiled call node returning call5877 (depth = 3)
  struct UserObject *obj5713_uo = (struct UserObject *)obj5713;
  obj5713_uo->super = call5877;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  objclass5713 = obj5713->class;
  objclass5713->definitionModule = modulename;
  objclass5713->definitionLine = 320;
  (*(struct UserObject *)self).data[0] = lowerouter5713;
  self = oldself5713;
  selfslot = oldselfslot5713;
  stackframe = oldstackframe5713;
  gc_frame_end(frame);
  return obj5713;
}
Object meth_collectionsPrelude_asString5879(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5880 == NULL) {
    strlit5880 = alloc_String("class enumerable");
    gc_root(strlit5880);
  }
// compiled string node returning strlit5880 (depth = 3)
  gc_frame_end(frame);
  return strlit5880;
}
Object meth_collectionsPrelude_enumerable5881(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "enumerable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  gc_frame_end(frame);
  return *var_enumerable;
}
Object meth_collectionsPrelude_at_40_1_41_5887(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_index = &(stackframe->slots[0]);
  *var_index = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5888 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5889 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5890 = gc_frame_new();
// call case 3: self.outer request
  Object call5891 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5890);
// compiled member node returning call5891 (depth = 5)
  Object call5892 = callmethodflags(call5891, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5889);
// compiled member node returning call5892 (depth = 4)
  Object call5893 = callmethodflags(call5892, "abstract", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5888);
// compiled member node returning call5893 (depth = 3)
  gc_frame_end(frame);
  return call5893;
}
Object meth_collectionsPrelude_size5894(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5895 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5896 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5897 = gc_frame_new();
// call case 3: self.outer request
  Object call5898 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5897);
// compiled member node returning call5898 (depth = 5)
  Object call5899 = callmethodflags(call5898, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5896);
// compiled member node returning call5899 (depth = 4)
  Object call5900 = callmethodflags(call5899, "abstract", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5895);
// compiled member node returning call5900 (depth = 3)
  gc_frame_end(frame);
  return call5900;
}
Object meth_collectionsPrelude_isEmpty5901(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5903 = alloc_Float64(0);
// compiled num node returning num5903 (depth = 4)
  int op_slot_right_5902 = gc_frame_newslot(num5903);
// starting to compile member node (depth = 4)
  int callframe5905 = gc_frame_new();
// call case 4: self request
  Object call5906 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5905);
// compiled member node returning call5906 (depth = 4)
  int op_slot_left_5902 = gc_frame_newslot(call5906);
  params[0] = num5903;
  partcv[0] = 1;
  Object opresult5907 = callmethod(call5906, "==(1)", 1, partcv, params);
// compiled op node returning opresult5907 (depth = 3)
  gc_frame_end(frame);
  return opresult5907;
}
Object meth_collectionsPrelude__apply5914(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_curSize = getfromclosure(closure, 0);
  Object *var_i = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_curSize (depth = 6)
  int op_slot_right_5915 = gc_frame_newslot(*var_curSize);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_5915 = gc_frame_newslot(*var_i);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult5917 = callmethod(*var_i, "≤(1)", 1, partcv, params);
// compiled op node returning opresult5917 (depth = 5)
  gc_frame_end(frame);
  return opresult5917;
}
Object meth_collectionsPrelude__apply5920(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_action = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5921 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 6)
  int callframe5922 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call5923 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5922);
// compiled call node returning call5923 (depth = 6)
  gc_frame_newslot(call5923);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_action (depth = 6)
  params[0] = *var_i;
  params[1] = call5923;
  partcv[0] = 2;
  Object call5924 = callmethodflags(*var_action, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5921);
// compiled call node returning call5924 (depth = 5)
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num5926 = alloc_Float64(1);
// compiled num node returning num5926 (depth = 7)
  int op_slot_right_5925 = gc_frame_newslot(num5926);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  int op_slot_left_5925 = gc_frame_newslot(*var_i);
  params[0] = num5926;
  partcv[0] = 1;
  Object sum5928 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum5928 (depth = 6)
  *var_i = sum5928;
  if (sum5928 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_keysAndValuesDo_40_1_41_5908(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_curSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "curSize");
  Object *var_i = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "i");
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5909 = gc_frame_new();
// call case 4: self request
  Object call5910 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5909);
// compiled member node returning call5910 (depth = 4)
  *var_curSize = call5910;
  if (call5910 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5911 = alloc_Float64(1);
// compiled num node returning num5911 (depth = 4)
  *var_i = num5911;
  if (num5911 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5912 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5913 = alloc_Block(NULL, NULL, "collectionsPrelude", 393);
  gc_frame_newslot(block5913);
// method "_apply"
  block_savedest(block5913);
  Object closure5914 = createclosure(3, "_apply");
  setclosureframe(closure5914, stackframe);
  addtoclosure(closure5914, var_curSize);
  addtoclosure(closure5914, var_i);
  addtoclosure(closure5914, selfslot);
  struct UserObject *uo5914 = (struct UserObject*)block5913;
  uo5914->data[0] = (Object)closure5914;
  Method *meth_meth_collectionsPrelude__apply5914 = addmethod2pos(block5913, "_apply", &meth_collectionsPrelude__apply5914, 0);
  int argcv_meth_collectionsPrelude__apply5914[] = {0};
  meth_meth_collectionsPrelude__apply5914->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5914);
  meth_meth_collectionsPrelude__apply5914->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5914->definitionLine = 1991;
// compiled block node returning block5913 (depth = 4)
  gc_frame_newslot(block5913);
// starting to compile block node (depth = 4)
  Object block5919 = alloc_Block(NULL, NULL, "collectionsPrelude", 393);
  gc_frame_newslot(block5919);
// method "_apply"
  block_savedest(block5919);
  Object closure5920 = createclosure(3, "_apply");
  setclosureframe(closure5920, stackframe);
  addtoclosure(closure5920, var_i);
  addtoclosure(closure5920, var_action);
  addtoclosure(closure5920, selfslot);
  struct UserObject *uo5920 = (struct UserObject*)block5919;
  uo5920->data[0] = (Object)closure5920;
  Method *meth_meth_collectionsPrelude__apply5920 = addmethod2pos(block5919, "_apply", &meth_collectionsPrelude__apply5920, 0);
  int argcv_meth_collectionsPrelude__apply5920[] = {0};
  meth_meth_collectionsPrelude__apply5920->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5920);
  meth_meth_collectionsPrelude__apply5920->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5920->definitionLine = 1991;
// compiled block node returning block5919 (depth = 4)
  gc_frame_newslot(block5919);
// call case 5: prelude request
  params[0] = block5913;
  params[1] = block5919;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5931 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5912);
// compiled call node returning call5931 (depth = 3)
  gc_frame_end(frame);
  return call5931;
}
Object meth_collectionsPrelude_first5932(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "first");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5933 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5934 = alloc_Float64(1);
// compiled num node returning num5934 (depth = 4)
  gc_frame_newslot(num5934);
// call case 4: self request
  params[0] = num5934;
  partcv[0] = 1;
  Object call5935 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5933);
// compiled call node returning call5935 (depth = 3)
  gc_frame_end(frame);
  return call5935;
}
Object meth_collectionsPrelude_second5936(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "second");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5937 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5938 = alloc_Float64(2);
// compiled num node returning num5938 (depth = 4)
  gc_frame_newslot(num5938);
// call case 4: self request
  params[0] = num5938;
  partcv[0] = 1;
  Object call5939 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5937);
// compiled call node returning call5939 (depth = 3)
  gc_frame_end(frame);
  return call5939;
}
Object meth_collectionsPrelude_third5940(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "third");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5941 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5942 = alloc_Float64(3);
// compiled num node returning num5942 (depth = 4)
  gc_frame_newslot(num5942);
// call case 4: self request
  params[0] = num5942;
  partcv[0] = 1;
  Object call5943 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5941);
// compiled call node returning call5943 (depth = 3)
  gc_frame_end(frame);
  return call5943;
}
Object meth_collectionsPrelude_fourth5944(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fourth");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 401
  setline(401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5945 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5946 = alloc_Float64(4);
// compiled num node returning num5946 (depth = 4)
  gc_frame_newslot(num5946);
// call case 4: self request
  params[0] = num5946;
  partcv[0] = 1;
  Object call5947 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5945);
// compiled call node returning call5947 (depth = 3)
  gc_frame_end(frame);
  return call5947;
}
Object meth_collectionsPrelude_fifth5948(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fifth");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5949 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5950 = alloc_Float64(5);
// compiled num node returning num5950 (depth = 4)
  gc_frame_newslot(num5950);
// call case 4: self request
  params[0] = num5950;
  partcv[0] = 1;
  Object call5951 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5949);
// compiled call node returning call5951 (depth = 3)
  gc_frame_end(frame);
  return call5951;
}
Object meth_collectionsPrelude_last5952(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "last");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5953 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5954 = gc_frame_new();
// call case 4: self request
  Object call5955 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5954);
// compiled member node returning call5955 (depth = 4)
  gc_frame_newslot(call5955);
// call case 4: self request
  params[0] = call5955;
  partcv[0] = 1;
  Object call5956 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5953);
// compiled call node returning call5956 (depth = 3)
  gc_frame_end(frame);
  return call5956;
}
Object meth_collectionsPrelude_indices5957(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "indices");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 404
  setline(404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5958 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5959 = alloc_Float64(1);
// compiled num node returning num5959 (depth = 4)
  gc_frame_newslot(num5959);
// starting to compile member node (depth = 4)
  int callframe5960 = gc_frame_new();
// call case 4: self request
  Object call5961 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5960);
// compiled member node returning call5961 (depth = 4)
  gc_frame_newslot(call5961);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5962 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5963 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5964 = gc_frame_new();
// call case 3: self.outer request
  Object call5965 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5964);
// compiled member node returning call5965 (depth = 6)
  Object call5966 = callmethodflags(call5965, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5963);
// compiled member node returning call5966 (depth = 5)
  Object call5967 = callmethodflags(call5966, "range", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5962);
// compiled member node returning call5967 (depth = 4)
  params[0] = num5959;
  params[1] = call5961;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5968 = callmethodflags(call5967, "from(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5958);
// compiled call node returning call5968 (depth = 3)
  gc_frame_end(frame);
  return call5968;
}
Object meth_collectionsPrelude__apply5972(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sought = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe5973 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5975 == NULL) {
    strlit5975 = alloc_String("");
    gc_root(strlit5975);
  }
// compiled string node returning strlit5975 (depth = 7)
  int op_slot_right_5974 = gc_frame_newslot(strlit5975);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sought (depth = 8)
  int op_slot_right_5977 = gc_frame_newslot(*var_sought);
// starting to compile string node (depth = 8)
  if (strlit5979 == NULL) {
    strlit5979 = alloc_String("collection does not contain ");
    gc_root(strlit5979);
  }
// compiled string node returning strlit5979 (depth = 8)
  int op_slot_left_5977 = gc_frame_newslot(strlit5979);
  params[0] = *var_sought;
  partcv[0] = 1;
  Object opresult5980 = callmethod(strlit5979, "++(1)", 1, partcv, params);
// compiled op node returning opresult5980 (depth = 7)
  int op_slot_left_5974 = gc_frame_newslot(opresult5980);
  params[0] = strlit5975;
  partcv[0] = 1;
  Object opresult5981 = callmethod(opresult5980, "++(1)", 1, partcv, params);
// compiled op node returning opresult5981 (depth = 6)
  gc_frame_newslot(opresult5981);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_NoSuchObject (depth = 6)
  params[0] = opresult5981;
  partcv[0] = 1;
  Object call5982 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5973);
// compiled call node returning call5982 (depth = 5)
  gc_frame_end(frame);
  return call5982;
}
Object meth_collectionsPrelude_indexOf_40_1_41_5969(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indexOf(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method indexOf(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for indexOf(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sought = &(stackframe->slots[0]);
  *var_sought = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part indexOf(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5970 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sought (depth = 4)
  gc_frame_newslot(*var_sought);
// starting to compile block node (depth = 4)
  Object block5971 = alloc_Block(NULL, NULL, "collectionsPrelude", 406);
  gc_frame_newslot(block5971);
// method "_apply"
  block_savedest(block5971);
  Object closure5972 = createclosure(3, "_apply");
  setclosureframe(closure5972, stackframe);
  addtoclosure(closure5972, var_sought);
  addtoclosure(closure5972, var_NoSuchObject);
  addtoclosure(closure5972, selfslot);
  struct UserObject *uo5972 = (struct UserObject*)block5971;
  uo5972->data[0] = (Object)closure5972;
  Method *meth_meth_collectionsPrelude__apply5972 = addmethod2pos(block5971, "_apply", &meth_collectionsPrelude__apply5972, 0);
  int argcv_meth_collectionsPrelude__apply5972[] = {0};
  meth_meth_collectionsPrelude__apply5972->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5972);
  meth_meth_collectionsPrelude__apply5972->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5972->definitionLine = 1991;
// compiled block node returning block5971 (depth = 4)
  gc_frame_newslot(block5971);
// call case 4: self request
  params[0] = *var_sought;
  params[1] = block5971;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5984 = callmethodflags(self, "indexOf(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5970);
// compiled call node returning call5984 (depth = 3)
  gc_frame_end(frame);
  return call5984;
}
Object meth_collectionsPrelude__apply_40_2_41_5988(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object *var_sought = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sought (depth = 7)
  int op_slot_right_5990 = gc_frame_newslot(*var_sought);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  int op_slot_left_5990 = gc_frame_newslot(*var_v);
  params[0] = *var_sought;
  partcv[0] = 1;
  Object opresult5992 = callmethod(*var_v, "==(1)", 1, partcv, params);
// compiled op node returning opresult5992 (depth = 6)
  Object if5989 = done;
  if (istrue(opresult5992)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  block_return(realself, *var_ix);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if5989 = undefined;
  } else {
  }
// compiled if node returning if5989 (depth = 5)
  gc_frame_end(frame);
  return if5989;
}
Object meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5985(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "indexOf(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method indexOf(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method indexOf(_)ifAbsent(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for indexOf(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_sought = &(stackframe->slots[0]);
  *var_sought = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part indexOf(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5986 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5987 = alloc_Block(NULL, NULL, "collectionsPrelude", 409);
  gc_frame_newslot(block5987);
// method "_apply(_,_)"
  block_savedest(block5987);
  Object closure5988 = createclosure(2, "_apply(2)");
  setclosureframe(closure5988, stackframe);
  addtoclosure(closure5988, var_sought);
  addtoclosure(closure5988, selfslot);
  struct UserObject *uo5988 = (struct UserObject*)block5987;
  uo5988->data[0] = (Object)closure5988;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_5988 = addmethod2pos(block5987, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_5988, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_5988[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_5988->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_5988);
  meth_meth_collectionsPrelude__apply_40_2_41_5988->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_5988->definitionLine = 1991;
// compiled block node returning block5987 (depth = 4)
  gc_frame_newslot(block5987);
// call case 4: self request
  params[0] = block5987;
  partcv[0] = 1;
  Object call5994 = callmethodflags(self, "keysAndValuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5986);
// compiled call node returning call5994 (depth = 3)
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5995 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_action (depth = 4)
  Object call5996 = callmethodflags(*var_action, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe5995);
// compiled member node returning call5996 (depth = 3)
  gc_frame_end(frame);
  return call5996;
}
Object meth_collectionsPrelude__apply_40_2_41_6008(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 417
  setline(417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6009 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6010 = callmethodflags(*var_result, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6009);
// compiled call node returning call6010 (depth = 5)
  gc_frame_end(frame);
  return call6010;
}
Object meth_collectionsPrelude_asDictionary5997(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5998 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5999 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe6000 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6001 = gc_frame_new();
// call case 3: self.outer request
  Object call6002 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6001);
// compiled member node returning call6002 (depth = 7)
  Object call6003 = callmethodflags(call6002, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe6000);
// compiled member node returning call6003 (depth = 6)
  Object call6004 = callmethodflags(call6003, "dictionary", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5999);
// compiled member node returning call6004 (depth = 5)
  Object call6005 = callmethodflags(call6004, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe5998);
// compiled member node returning call6005 (depth = 4)
  *var_result = call6005;
  if (call6005 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6006 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6007 = alloc_Block(NULL, NULL, "collectionsPrelude", 416);
  gc_frame_newslot(block6007);
// method "_apply(_,_)"
  block_savedest(block6007);
  Object closure6008 = createclosure(2, "_apply(2)");
  setclosureframe(closure6008, stackframe);
  addtoclosure(closure6008, var_result);
  addtoclosure(closure6008, selfslot);
  struct UserObject *uo6008 = (struct UserObject*)block6007;
  uo6008->data[0] = (Object)closure6008;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_6008 = addmethod2pos(block6007, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_6008, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_6008[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_6008->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_6008);
  meth_meth_collectionsPrelude__apply_40_2_41_6008->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_6008->definitionLine = 1991;
// compiled block node returning block6007 (depth = 4)
  gc_frame_newslot(block6007);
// call case 4: self request
  params[0] = block6007;
  partcv[0] = 1;
  Object call6012 = callmethodflags(self, "keysAndValuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6006);
// compiled call node returning call6012 (depth = 3)
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  return *var_result;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply6018(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe6019 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_selfIterator (depth = 6)
  Object call6020 = callmethodflags(*var_selfIterator, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe6019);
// compiled member node returning call6020 (depth = 5)
  gc_frame_end(frame);
  return call6020;
}
Object meth_collectionsPrelude__apply6023(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object *var_existing = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6024 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe6025 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_selfIterator (depth = 7)
  Object call6026 = callmethodflags(*var_selfIterator, "next", 0, partcv, params, 0);
  gc_frame_end(callframe6025);
// compiled member node returning call6026 (depth = 6)
  gc_frame_newslot(call6026);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_existing (depth = 6)
  params[0] = call6026;
  partcv[0] = 1;
  Object call6027 = callmethodflags(*var_existing, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6024);
// compiled call node returning call6027 (depth = 5)
  gc_frame_end(frame);
  return call6027;
}
Object meth_collectionsPrelude_into_40_1_41_6013(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "into(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method into(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for into(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_existing = &(stackframe->slots[0]);
  *var_existing = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part into(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_selfIterator = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIterator");
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6014 = gc_frame_new();
// call case 4: self request
  Object call6015 = callmethodflags(self, "iterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6014);
// compiled member node returning call6015 (depth = 4)
  *var_selfIterator = call6015;
  if (call6015 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6016 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6017 = alloc_Block(NULL, NULL, "collectionsPrelude", 423);
  gc_frame_newslot(block6017);
// method "_apply"
  block_savedest(block6017);
  Object closure6018 = createclosure(2, "_apply");
  setclosureframe(closure6018, stackframe);
  addtoclosure(closure6018, var_selfIterator);
  addtoclosure(closure6018, selfslot);
  struct UserObject *uo6018 = (struct UserObject*)block6017;
  uo6018->data[0] = (Object)closure6018;
  Method *meth_meth_collectionsPrelude__apply6018 = addmethod2pos(block6017, "_apply", &meth_collectionsPrelude__apply6018, 0);
  int argcv_meth_collectionsPrelude__apply6018[] = {0};
  meth_meth_collectionsPrelude__apply6018->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply6018);
  meth_meth_collectionsPrelude__apply6018->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply6018->definitionLine = 1991;
// compiled block node returning block6017 (depth = 4)
  gc_frame_newslot(block6017);
// starting to compile block node (depth = 4)
  Object block6022 = alloc_Block(NULL, NULL, "collectionsPrelude", 423);
  gc_frame_newslot(block6022);
// method "_apply"
  block_savedest(block6022);
  Object closure6023 = createclosure(3, "_apply");
  setclosureframe(closure6023, stackframe);
  addtoclosure(closure6023, var_selfIterator);
  addtoclosure(closure6023, var_existing);
  addtoclosure(closure6023, selfslot);
  struct UserObject *uo6023 = (struct UserObject*)block6022;
  uo6023->data[0] = (Object)closure6023;
  Method *meth_meth_collectionsPrelude__apply6023 = addmethod2pos(block6022, "_apply", &meth_collectionsPrelude__apply6023, 0);
  int argcv_meth_collectionsPrelude__apply6023[] = {0};
  meth_meth_collectionsPrelude__apply6023->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply6023);
  meth_meth_collectionsPrelude__apply6023->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply6023->definitionLine = 1991;
// compiled block node returning block6022 (depth = 4)
  gc_frame_newslot(block6022);
// call case 5: prelude request
  params[0] = block6017;
  params[1] = block6022;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6029 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6016);
// compiled call node returning call6029 (depth = 3)
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_existing (depth = 3)
  gc_frame_end(frame);
  return *var_existing;
}
Object meth_collectionsPrelude_TRAIT5884(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "TRAIT");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_collection = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5885 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5885 = alloc_userobj2(15,16, objclass5885);
  gc_frame_newslot(obj5885);
if (objclass5885 == NULL) {
  glfree(obj5885->class->name);
  obj5885->class->name = "indexable.indexable.TRAIT";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5885, self, 0);
  addmethodreal(obj5885,"outer", &reader_collectionsPrelude_outer_5886);
  Object oldself5885 = self;
  struct StackFrameObject *oldstackframe5885 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5885);
  gc_frame_newslot((Object)stackframe);
  self = obj5885;
  Object *oldselfslot5885 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5885 = (*(struct UserObject *)self).data[0], lowerouter5885 = thisouter5885;
  if (inheritingObject5885) {
    struct UserObject *inho5885 = (struct UserObject *)inheritingObject5885;
    while (inho5885->super != GraceDefaultObject) inho5885 = (struct UserObject *)inho5885->super;
    inho5885->super = obj5885;
    self = inheritingObject5885;
    *selfslot = self;
    lowerouter5885 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5885;
  }
// method "at(_)"
  struct UserObject *uo5887 = (struct UserObject*)obj5885;
  uo5887->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_5887 = addmethod2pos(obj5885, "at(1)", &meth_collectionsPrelude_at_40_1_41_5887, 1);
  int argcv_meth_collectionsPrelude_at_40_1_41_5887[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_5887->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_5887);
  meth_meth_collectionsPrelude_at_40_1_41_5887->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_5887->definitionLine = 387;
// method "size"
  struct UserObject *uo5894 = (struct UserObject*)obj5885;
  uo5894->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size5894 = addmethod2pos(obj5885, "size", &meth_collectionsPrelude_size5894, 2);
  int argcv_meth_collectionsPrelude_size5894[] = {0};
  meth_meth_collectionsPrelude_size5894->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5894);
  meth_meth_collectionsPrelude_size5894->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5894->definitionLine = 388;
// method "isEmpty"
  struct UserObject *uo5901 = (struct UserObject*)obj5885;
  uo5901->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty5901 = addmethod2pos(obj5885, "isEmpty", &meth_collectionsPrelude_isEmpty5901, 3);
  int argcv_meth_collectionsPrelude_isEmpty5901[] = {0};
  meth_meth_collectionsPrelude_isEmpty5901->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty5901);
  meth_meth_collectionsPrelude_isEmpty5901->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty5901->definitionLine = 389;
// method "keysAndValuesDo(_)"
  struct UserObject *uo5908 = (struct UserObject*)obj5885;
  uo5908->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5908 = addmethod2pos(obj5885, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_5908, 4);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5908[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5908->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5908);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5908->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5908->definitionLine = 390;
// method "first"
  struct UserObject *uo5932 = (struct UserObject*)obj5885;
  uo5932->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_first5932 = addmethod2pos(obj5885, "first", &meth_collectionsPrelude_first5932, 5);
  int argcv_meth_collectionsPrelude_first5932[] = {0};
  meth_meth_collectionsPrelude_first5932->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_first5932);
  meth_meth_collectionsPrelude_first5932->definitionModule = modulename;
  meth_meth_collectionsPrelude_first5932->definitionLine = 398;
// method "second"
  struct UserObject *uo5936 = (struct UserObject*)obj5885;
  uo5936->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_second5936 = addmethod2pos(obj5885, "second", &meth_collectionsPrelude_second5936, 6);
  int argcv_meth_collectionsPrelude_second5936[] = {0};
  meth_meth_collectionsPrelude_second5936->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_second5936);
  meth_meth_collectionsPrelude_second5936->definitionModule = modulename;
  meth_meth_collectionsPrelude_second5936->definitionLine = 399;
// method "third"
  struct UserObject *uo5940 = (struct UserObject*)obj5885;
  uo5940->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_third5940 = addmethod2pos(obj5885, "third", &meth_collectionsPrelude_third5940, 7);
  int argcv_meth_collectionsPrelude_third5940[] = {0};
  meth_meth_collectionsPrelude_third5940->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_third5940);
  meth_meth_collectionsPrelude_third5940->definitionModule = modulename;
  meth_meth_collectionsPrelude_third5940->definitionLine = 400;
// method "fourth"
  struct UserObject *uo5944 = (struct UserObject*)obj5885;
  uo5944->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fourth5944 = addmethod2pos(obj5885, "fourth", &meth_collectionsPrelude_fourth5944, 8);
  int argcv_meth_collectionsPrelude_fourth5944[] = {0};
  meth_meth_collectionsPrelude_fourth5944->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fourth5944);
  meth_meth_collectionsPrelude_fourth5944->definitionModule = modulename;
  meth_meth_collectionsPrelude_fourth5944->definitionLine = 401;
// method "fifth"
  struct UserObject *uo5948 = (struct UserObject*)obj5885;
  uo5948->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fifth5948 = addmethod2pos(obj5885, "fifth", &meth_collectionsPrelude_fifth5948, 9);
  int argcv_meth_collectionsPrelude_fifth5948[] = {0};
  meth_meth_collectionsPrelude_fifth5948->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fifth5948);
  meth_meth_collectionsPrelude_fifth5948->definitionModule = modulename;
  meth_meth_collectionsPrelude_fifth5948->definitionLine = 402;
// method "last"
  struct UserObject *uo5952 = (struct UserObject*)obj5885;
  uo5952->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_last5952 = addmethod2pos(obj5885, "last", &meth_collectionsPrelude_last5952, 10);
  int argcv_meth_collectionsPrelude_last5952[] = {0};
  meth_meth_collectionsPrelude_last5952->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_last5952);
  meth_meth_collectionsPrelude_last5952->definitionModule = modulename;
  meth_meth_collectionsPrelude_last5952->definitionLine = 403;
// method "indices"
  struct UserObject *uo5957 = (struct UserObject*)obj5885;
  uo5957->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_indices5957 = addmethod2pos(obj5885, "indices", &meth_collectionsPrelude_indices5957, 11);
  int argcv_meth_collectionsPrelude_indices5957[] = {0};
  meth_meth_collectionsPrelude_indices5957->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indices5957);
  meth_meth_collectionsPrelude_indices5957->definitionModule = modulename;
  meth_meth_collectionsPrelude_indices5957->definitionLine = 404;
// method "indexOf(_)"
  block_savedest(obj5885);
  Object closure5969 = createclosure(1, "indexOf(1)");
  setclosureframe(closure5969, stackframe);
  addtoclosure(closure5969, var_NoSuchObject);
  struct UserObject *uo5969 = (struct UserObject*)obj5885;
  uo5969->data[12] = (Object)closure5969;
  Method *meth_meth_collectionsPrelude_indexOf_40_1_41_5969 = addmethod2pos(obj5885, "indexOf(1)", &meth_collectionsPrelude_indexOf_40_1_41_5969, 12);
  int argcv_meth_collectionsPrelude_indexOf_40_1_41_5969[] = {1};
  meth_meth_collectionsPrelude_indexOf_40_1_41_5969->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indexOf_40_1_41_5969);
  meth_meth_collectionsPrelude_indexOf_40_1_41_5969->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexOf_40_1_41_5969->definitionLine = 405;
// method "indexOf(_)ifAbsent(_)"
  struct UserObject *uo5985 = (struct UserObject*)obj5885;
  uo5985->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5985 = addmethod2pos(obj5885, "indexOf(1)ifAbsent(1)", &meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5985, 13);
  int argcv_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5985[] = {1, 1};
  meth_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5985->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5985);
  meth_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5985->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5985->definitionLine = 408;
// method "asDictionary"
  struct UserObject *uo5997 = (struct UserObject*)obj5885;
  uo5997->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary5997 = addmethod2pos(obj5885, "asDictionary", &meth_collectionsPrelude_asDictionary5997, 14);
  int argcv_meth_collectionsPrelude_asDictionary5997[] = {0};
  meth_meth_collectionsPrelude_asDictionary5997->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary5997);
  meth_meth_collectionsPrelude_asDictionary5997->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary5997->definitionLine = 414;
// method "into(_)"
  struct UserObject *uo6013 = (struct UserObject*)obj5885;
  uo6013->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into_40_1_41_6013 = addmethod2pos(obj5885, "into(1)", &meth_collectionsPrelude_into_40_1_41_6013, 15);
  int argcv_meth_collectionsPrelude_into_40_1_41_6013[] = {1};
  meth_meth_collectionsPrelude_into_40_1_41_6013->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into_40_1_41_6013);
  meth_meth_collectionsPrelude_into_40_1_41_6013->definitionModule = modulename;
  meth_meth_collectionsPrelude_into_40_1_41_6013->definitionLine = 421;
  sourceObject = obj5885;
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6030 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_collection (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6031 = callmethodflags(*var_collection, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6030);
// compiled call node returning call6031 (depth = 3)
  struct UserObject *obj5885_uo = (struct UserObject *)obj5885;
  obj5885_uo->super = call6031;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  objclass5885 = obj5885->class;
  objclass5885->definitionModule = modulename;
  objclass5885->definitionLine = 385;
  (*(struct UserObject *)self).data[0] = lowerouter5885;
  self = oldself5885;
  selfslot = oldselfslot5885;
  stackframe = oldstackframe5885;
  gc_frame_end(frame);
  return obj5885;
}
Object meth_collectionsPrelude_TRAIT5884_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "TRAIT$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_collection = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5885 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5885 = alloc_userobj2(15,16, objclass5885);
  gc_frame_newslot(obj5885);
if (objclass5885 == NULL) {
  glfree(obj5885->class->name);
  obj5885->class->name = "indexable.indexable.TRAIT";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5885, self, 0);
  addmethodreal(obj5885,"outer", &reader_collectionsPrelude_outer_5886);
  Object oldself5885 = self;
  struct StackFrameObject *oldstackframe5885 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5885);
  gc_frame_newslot((Object)stackframe);
  self = obj5885;
  Object *oldselfslot5885 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5885 = (*(struct UserObject *)self).data[0], lowerouter5885 = thisouter5885;
  if (inheritingObject5885) {
    struct UserObject *inho5885 = (struct UserObject *)inheritingObject5885;
    while (inho5885->super != GraceDefaultObject) inho5885 = (struct UserObject *)inho5885->super;
    inho5885->super = obj5885;
    self = inheritingObject5885;
    *selfslot = self;
    lowerouter5885 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5885;
  }
// method "at(_)"
  struct UserObject *uo5887 = (struct UserObject*)obj5885;
  uo5887->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_5887 = addmethod2pos(obj5885, "at(1)", &meth_collectionsPrelude_at_40_1_41_5887, 1);
  int argcv_meth_collectionsPrelude_at_40_1_41_5887[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_5887->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_5887);
  meth_meth_collectionsPrelude_at_40_1_41_5887->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_5887->definitionLine = 387;
// method "size"
  struct UserObject *uo5894 = (struct UserObject*)obj5885;
  uo5894->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size5894 = addmethod2pos(obj5885, "size", &meth_collectionsPrelude_size5894, 2);
  int argcv_meth_collectionsPrelude_size5894[] = {0};
  meth_meth_collectionsPrelude_size5894->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5894);
  meth_meth_collectionsPrelude_size5894->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5894->definitionLine = 388;
// method "isEmpty"
  struct UserObject *uo5901 = (struct UserObject*)obj5885;
  uo5901->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty5901 = addmethod2pos(obj5885, "isEmpty", &meth_collectionsPrelude_isEmpty5901, 3);
  int argcv_meth_collectionsPrelude_isEmpty5901[] = {0};
  meth_meth_collectionsPrelude_isEmpty5901->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty5901);
  meth_meth_collectionsPrelude_isEmpty5901->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty5901->definitionLine = 389;
// method "keysAndValuesDo(_)"
  struct UserObject *uo5908 = (struct UserObject*)obj5885;
  uo5908->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5908 = addmethod2pos(obj5885, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_5908, 4);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5908[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5908->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5908);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5908->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5908->definitionLine = 390;
// method "first"
  struct UserObject *uo5932 = (struct UserObject*)obj5885;
  uo5932->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_first5932 = addmethod2pos(obj5885, "first", &meth_collectionsPrelude_first5932, 5);
  int argcv_meth_collectionsPrelude_first5932[] = {0};
  meth_meth_collectionsPrelude_first5932->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_first5932);
  meth_meth_collectionsPrelude_first5932->definitionModule = modulename;
  meth_meth_collectionsPrelude_first5932->definitionLine = 398;
// method "second"
  struct UserObject *uo5936 = (struct UserObject*)obj5885;
  uo5936->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_second5936 = addmethod2pos(obj5885, "second", &meth_collectionsPrelude_second5936, 6);
  int argcv_meth_collectionsPrelude_second5936[] = {0};
  meth_meth_collectionsPrelude_second5936->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_second5936);
  meth_meth_collectionsPrelude_second5936->definitionModule = modulename;
  meth_meth_collectionsPrelude_second5936->definitionLine = 399;
// method "third"
  struct UserObject *uo5940 = (struct UserObject*)obj5885;
  uo5940->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_third5940 = addmethod2pos(obj5885, "third", &meth_collectionsPrelude_third5940, 7);
  int argcv_meth_collectionsPrelude_third5940[] = {0};
  meth_meth_collectionsPrelude_third5940->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_third5940);
  meth_meth_collectionsPrelude_third5940->definitionModule = modulename;
  meth_meth_collectionsPrelude_third5940->definitionLine = 400;
// method "fourth"
  struct UserObject *uo5944 = (struct UserObject*)obj5885;
  uo5944->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fourth5944 = addmethod2pos(obj5885, "fourth", &meth_collectionsPrelude_fourth5944, 8);
  int argcv_meth_collectionsPrelude_fourth5944[] = {0};
  meth_meth_collectionsPrelude_fourth5944->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fourth5944);
  meth_meth_collectionsPrelude_fourth5944->definitionModule = modulename;
  meth_meth_collectionsPrelude_fourth5944->definitionLine = 401;
// method "fifth"
  struct UserObject *uo5948 = (struct UserObject*)obj5885;
  uo5948->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fifth5948 = addmethod2pos(obj5885, "fifth", &meth_collectionsPrelude_fifth5948, 9);
  int argcv_meth_collectionsPrelude_fifth5948[] = {0};
  meth_meth_collectionsPrelude_fifth5948->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fifth5948);
  meth_meth_collectionsPrelude_fifth5948->definitionModule = modulename;
  meth_meth_collectionsPrelude_fifth5948->definitionLine = 402;
// method "last"
  struct UserObject *uo5952 = (struct UserObject*)obj5885;
  uo5952->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_last5952 = addmethod2pos(obj5885, "last", &meth_collectionsPrelude_last5952, 10);
  int argcv_meth_collectionsPrelude_last5952[] = {0};
  meth_meth_collectionsPrelude_last5952->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_last5952);
  meth_meth_collectionsPrelude_last5952->definitionModule = modulename;
  meth_meth_collectionsPrelude_last5952->definitionLine = 403;
// method "indices"
  struct UserObject *uo5957 = (struct UserObject*)obj5885;
  uo5957->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_indices5957 = addmethod2pos(obj5885, "indices", &meth_collectionsPrelude_indices5957, 11);
  int argcv_meth_collectionsPrelude_indices5957[] = {0};
  meth_meth_collectionsPrelude_indices5957->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indices5957);
  meth_meth_collectionsPrelude_indices5957->definitionModule = modulename;
  meth_meth_collectionsPrelude_indices5957->definitionLine = 404;
// method "indexOf(_)"
  block_savedest(obj5885);
  Object closure5969 = createclosure(1, "indexOf(1)");
  setclosureframe(closure5969, stackframe);
  addtoclosure(closure5969, var_NoSuchObject);
  struct UserObject *uo5969 = (struct UserObject*)obj5885;
  uo5969->data[12] = (Object)closure5969;
  Method *meth_meth_collectionsPrelude_indexOf_40_1_41_5969 = addmethod2pos(obj5885, "indexOf(1)", &meth_collectionsPrelude_indexOf_40_1_41_5969, 12);
  int argcv_meth_collectionsPrelude_indexOf_40_1_41_5969[] = {1};
  meth_meth_collectionsPrelude_indexOf_40_1_41_5969->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indexOf_40_1_41_5969);
  meth_meth_collectionsPrelude_indexOf_40_1_41_5969->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexOf_40_1_41_5969->definitionLine = 405;
// method "indexOf(_)ifAbsent(_)"
  struct UserObject *uo5985 = (struct UserObject*)obj5885;
  uo5985->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5985 = addmethod2pos(obj5885, "indexOf(1)ifAbsent(1)", &meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5985, 13);
  int argcv_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5985[] = {1, 1};
  meth_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5985->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5985);
  meth_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5985->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5985->definitionLine = 408;
// method "asDictionary"
  struct UserObject *uo5997 = (struct UserObject*)obj5885;
  uo5997->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary5997 = addmethod2pos(obj5885, "asDictionary", &meth_collectionsPrelude_asDictionary5997, 14);
  int argcv_meth_collectionsPrelude_asDictionary5997[] = {0};
  meth_meth_collectionsPrelude_asDictionary5997->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary5997);
  meth_meth_collectionsPrelude_asDictionary5997->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary5997->definitionLine = 414;
// method "into(_)"
  struct UserObject *uo6013 = (struct UserObject*)obj5885;
  uo6013->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into_40_1_41_6013 = addmethod2pos(obj5885, "into(1)", &meth_collectionsPrelude_into_40_1_41_6013, 15);
  int argcv_meth_collectionsPrelude_into_40_1_41_6013[] = {1};
  meth_meth_collectionsPrelude_into_40_1_41_6013->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into_40_1_41_6013);
  meth_meth_collectionsPrelude_into_40_1_41_6013->definitionModule = modulename;
  meth_meth_collectionsPrelude_into_40_1_41_6013->definitionLine = 421;
  sourceObject = obj5885;
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6030 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_collection (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6031 = callmethodflags(*var_collection, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6030);
// compiled call node returning call6031 (depth = 3)
  struct UserObject *obj5885_uo = (struct UserObject *)obj5885;
  obj5885_uo->super = call6031;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  sourceObject = obj5885;
  objclass5885 = obj5885->class;
  objclass5885->definitionModule = modulename;
  objclass5885->definitionLine = 385;
  (*(struct UserObject *)self).data[0] = lowerouter5885;
  self = oldself5885;
  selfslot = oldselfslot5885;
  stackframe = oldstackframe5885;
  gc_frame_end(frame);
  return obj5885;
}
Object meth_collectionsPrelude_asString6033(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6034 == NULL) {
    strlit6034 = alloc_String("class indexable");
    gc_root(strlit6034);
  }
// compiled string node returning strlit6034 (depth = 3)
  gc_frame_end(frame);
  return strlit6034;
}
Object meth_collectionsPrelude_indexable6035(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indexable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_indexable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  gc_frame_end(frame);
  return *var_indexable;
}
Object meth_collectionsPrelude_size6038(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num6039 = alloc_Float64(0);
// compiled num node returning num6039 (depth = 3)
  gc_frame_end(frame);
  return num6039;
}
Object meth_collectionsPrelude_isEmpty6040(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6041 = alloc_Boolean(1);
// compiled identifier node returning bool6041 (depth = 3)
  gc_frame_end(frame);
  return bool6041;
}
Object meth_collectionsPrelude_at_40_1_41_6042(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6043 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6045 == NULL) {
    strlit6045 = alloc_String(" of empty sequence");
    gc_root(strlit6045);
  }
// compiled string node returning strlit6045 (depth = 5)
  int op_slot_right_6044 = gc_frame_newslot(strlit6045);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_right_6047 = gc_frame_newslot(*var_n);
// starting to compile string node (depth = 6)
  if (strlit6049 == NULL) {
    strlit6049 = alloc_String("index ");
    gc_root(strlit6049);
  }
// compiled string node returning strlit6049 (depth = 6)
  int op_slot_left_6047 = gc_frame_newslot(strlit6049);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult6050 = callmethod(strlit6049, "++(1)", 1, partcv, params);
// compiled op node returning opresult6050 (depth = 5)
  int op_slot_left_6044 = gc_frame_newslot(opresult6050);
  params[0] = strlit6045;
  partcv[0] = 1;
  Object opresult6051 = callmethod(opresult6050, "++(1)", 1, partcv, params);
// compiled op node returning opresult6051 (depth = 4)
  gc_frame_newslot(opresult6051);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult6051;
  partcv[0] = 1;
  Object call6052 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6043);
// compiled call node returning call6052 (depth = 3)
  gc_frame_end(frame);
  return call6052;
}
Object meth_collectionsPrelude_keys6053(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_values6054(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_keysAndValuesDo_40_1_41_6055(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[1];
  int partcv[1];
  Object *var_done = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_done (depth = 3)
  gc_frame_end(frame);
  return *var_done;
}
Object meth_collectionsPrelude_reversed6056(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__43__43__40_1_41_6057(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6058 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe6059 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe6060 = gc_frame_new();
// call case 3: self.outer request
  Object call6061 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6060);
// compiled member node returning call6061 (depth = 5)
  Object call6062 = callmethodflags(call6061, "sequence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6059);
// compiled member node returning call6062 (depth = 4)
  params[0] = *var_other;
  partcv[0] = 1;
  Object call6063 = callmethodflags(call6062, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6058);
// compiled call node returning call6063 (depth = 3)
  gc_frame_end(frame);
  return call6063;
}
Object meth_collectionsPrelude_asString6064(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6065 == NULL) {
    strlit6065 = alloc_String("""\xe2""""\x9f""""\xa8""""\xe2""""\x9f""""\xa9""");
    gc_root(strlit6065);
  }
// compiled string node returning strlit6065 (depth = 3)
  gc_frame_end(frame);
  return strlit6065;
}
Object meth_collectionsPrelude_contains_40_1_41_6066(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_element = &(stackframe->slots[0]);
  *var_element = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6067 = alloc_Boolean(0);
// compiled identifier node returning bool6067 (depth = 3)
  gc_frame_end(frame);
  return bool6067;
}
Object meth_collectionsPrelude_do_40_1_41_6068(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[1];
  int partcv[1];
  Object *var_done = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_done (depth = 3)
  gc_frame_end(frame);
  return *var_done;
}
Object meth_collectionsPrelude__apply_40_1_41_6072(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe6073 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  Object call6074 = callmethodflags(*var_o, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe6073);
// compiled member node returning call6074 (depth = 5)
  gc_frame_end(frame);
  return call6074;
}
Object meth_collectionsPrelude__apply_40_1_41_6086(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___12 = &(stackframe->slots[0]);
  *var___12 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool6087 = alloc_Boolean(0);
// compiled identifier node returning bool6087 (depth = 5)
  gc_frame_end(frame);
  return bool6087;
}
Object meth_collectionsPrelude__61__61__40_1_41_6069(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[1];
  Object *var_Iterable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  int frame6070 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6071 = alloc_Block(NULL, NULL, "collectionsPrelude", 449);
  gc_frame_newslot(block6071);
// method "_apply(_)"
  block_savedest(block6071);
  Object closure6072 = createclosure(1, "_apply(1)");
  setclosureframe(closure6072, stackframe);
  addtoclosure(closure6072, selfslot);
  struct UserObject *uo6072 = (struct UserObject*)block6071;
  uo6072->data[0] = (Object)closure6072;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_6072 = addmethod2pos(block6071, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_6072, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_6072[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_6072->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_6072);
  meth_meth_collectionsPrelude__apply_40_1_41_6072->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_6072->definitionLine = 1991;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6076 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe6077 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6078 == NULL) {
    strlit6078 = alloc_String("o");
    gc_root(strlit6078);
  }
// compiled string node returning strlit6078 (depth = 7)
  gc_frame_newslot(strlit6078);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6079 = gc_frame_new();
// call case 5: prelude request
  Object call6080 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6079);
// compiled member node returning call6080 (depth = 7)
  params[0] = strlit6078;
  partcv[0] = 1;
  Object call6081 = callmethodflags(call6080, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6077);
// compiled call node returning call6081 (depth = 6)
  gc_frame_newslot(call6081);
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Iterable (depth = 6)
  gc_frame_newslot(*var_Iterable);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe6082 = gc_frame_new();
// call case 5: prelude request
  Object call6083 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6082);
// compiled member node returning call6083 (depth = 6)
  params[0] = call6081;
  params[1] = *var_Iterable;
  partcv[0] = 2;
  Object call6084 = callmethodflags(call6083, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6076);
// compiled call node returning call6084 (depth = 5)
((struct UserObject *)block6071)->data[1] = call6084;
// compiled block node returning block6071 (depth = 4)
  gc_frame_newslot(block6071);
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6085 = alloc_Block(NULL, NULL, "collectionsPrelude", 452);
  gc_frame_newslot(block6085);
// method "_apply(_)"
  block_savedest(block6085);
  Object closure6086 = createclosure(1, "_apply(1)");
  setclosureframe(closure6086, stackframe);
  addtoclosure(closure6086, selfslot);
  struct UserObject *uo6086 = (struct UserObject*)block6085;
  uo6086->data[0] = (Object)closure6086;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_6086 = addmethod2pos(block6085, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_6086, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_6086[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_6086->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_6086);
  meth_meth_collectionsPrelude__apply_40_1_41_6086->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_6086->definitionLine = 1991;
// compiled block node returning block6085 (depth = 4)
  gc_frame_newslot(block6085);
  params[0] = block6071;
  params[1] = block6085;
  Object matchres6070 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame6070);
// compiled matchcase node returning matchres6070 (depth = 3)
  gc_frame_end(frame);
  return matchres6070;
}
Object meth_collectionsPrelude_asString6092(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6093 == NULL) {
    strlit6093 = alloc_String("emptySequenceIterator");
    gc_root(strlit6093);
  }
// compiled string node returning strlit6093 (depth = 3)
  gc_frame_end(frame);
  return strlit6093;
}
Object meth_collectionsPrelude_hasNext6094(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6095 = alloc_Boolean(0);
// compiled identifier node returning bool6095 (depth = 3)
  gc_frame_end(frame);
  return bool6095;
}
Object meth_collectionsPrelude_next6096(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6097 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6098 == NULL) {
    strlit6098 = alloc_String("on empty sequence");
    gc_root(strlit6098);
  }
// compiled string node returning strlit6098 (depth = 4)
  gc_frame_newslot(strlit6098);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = strlit6098;
  partcv[0] = 1;
  Object call6099 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6097);
// compiled call node returning call6099 (depth = 3)
  gc_frame_end(frame);
  return call6099;
}
Object meth_collectionsPrelude_iterator6089(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6090 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6090 = alloc_userobj2(3,4, objclass6090);
  gc_frame_newslot(obj6090);
if (objclass6090 == NULL) {
  glfree(obj6090->class->name);
  obj6090->class->name = "emptySequence.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6090, self, 0);
  addmethodreal(obj6090,"outer", &reader_collectionsPrelude_outer_6091);
  Object oldself6090 = self;
  struct StackFrameObject *oldstackframe6090 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6090);
  gc_frame_newslot((Object)stackframe);
  self = obj6090;
  Object *oldselfslot6090 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6090 = (*(struct UserObject *)self).data[0], lowerouter6090 = thisouter6090;
  if (inheritingObject6090) {
    struct UserObject *inho6090 = (struct UserObject *)inheritingObject6090;
    while (inho6090->super != GraceDefaultObject) inho6090 = (struct UserObject *)inho6090->super;
    inho6090->super = obj6090;
    self = inheritingObject6090;
    *selfslot = self;
    lowerouter6090 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6090;
  }
// method "asString"
  struct UserObject *uo6092 = (struct UserObject*)obj6090;
  uo6092->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString6092 = addmethod2pos(obj6090, "asString", &meth_collectionsPrelude_asString6092, 1);
  int argcv_meth_collectionsPrelude_asString6092[] = {0};
  meth_meth_collectionsPrelude_asString6092->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6092);
  meth_meth_collectionsPrelude_asString6092->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6092->definitionLine = 457;
// method "hasNext"
  struct UserObject *uo6094 = (struct UserObject*)obj6090;
  uo6094->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext6094 = addmethod2pos(obj6090, "hasNext", &meth_collectionsPrelude_hasNext6094, 2);
  int argcv_meth_collectionsPrelude_hasNext6094[] = {0};
  meth_meth_collectionsPrelude_hasNext6094->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext6094);
  meth_meth_collectionsPrelude_hasNext6094->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext6094->definitionLine = 458;
// method "next"
  block_savedest(obj6090);
  Object closure6096 = createclosure(1, "next");
  setclosureframe(closure6096, stackframe);
  addtoclosure(closure6096, var_IteratorExhausted);
  struct UserObject *uo6096 = (struct UserObject*)obj6090;
  uo6096->data[3] = (Object)closure6096;
  Method *meth_meth_collectionsPrelude_next6096 = addmethod2pos(obj6090, "next", &meth_collectionsPrelude_next6096, 3);
  int argcv_meth_collectionsPrelude_next6096[] = {0};
  meth_meth_collectionsPrelude_next6096->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next6096);
  meth_meth_collectionsPrelude_next6096->definitionModule = modulename;
  meth_meth_collectionsPrelude_next6096->definitionLine = 459;
  sourceObject = obj6090;
  sourceObject = obj6090;
  sourceObject = obj6090;
  objclass6090 = obj6090->class;
  objclass6090->definitionModule = modulename;
  objclass6090->definitionLine = 456;
  (*(struct UserObject *)self).data[0] = lowerouter6090;
  self = oldself6090;
  selfslot = oldselfslot6090;
  stackframe = oldstackframe6090;
  gc_frame_end(frame);
  return obj6090;
}
Object meth_collectionsPrelude_iterator6089_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6090 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6090 = alloc_userobj2(3,4, objclass6090);
  gc_frame_newslot(obj6090);
if (objclass6090 == NULL) {
  glfree(obj6090->class->name);
  obj6090->class->name = "emptySequence.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6090, self, 0);
  addmethodreal(obj6090,"outer", &reader_collectionsPrelude_outer_6091);
  Object oldself6090 = self;
  struct StackFrameObject *oldstackframe6090 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6090);
  gc_frame_newslot((Object)stackframe);
  self = obj6090;
  Object *oldselfslot6090 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6090 = (*(struct UserObject *)self).data[0], lowerouter6090 = thisouter6090;
  if (inheritingObject6090) {
    struct UserObject *inho6090 = (struct UserObject *)inheritingObject6090;
    while (inho6090->super != GraceDefaultObject) inho6090 = (struct UserObject *)inho6090->super;
    inho6090->super = obj6090;
    self = inheritingObject6090;
    *selfslot = self;
    lowerouter6090 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6090;
  }
// method "asString"
  struct UserObject *uo6092 = (struct UserObject*)obj6090;
  uo6092->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString6092 = addmethod2pos(obj6090, "asString", &meth_collectionsPrelude_asString6092, 1);
  int argcv_meth_collectionsPrelude_asString6092[] = {0};
  meth_meth_collectionsPrelude_asString6092->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6092);
  meth_meth_collectionsPrelude_asString6092->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6092->definitionLine = 457;
// method "hasNext"
  struct UserObject *uo6094 = (struct UserObject*)obj6090;
  uo6094->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext6094 = addmethod2pos(obj6090, "hasNext", &meth_collectionsPrelude_hasNext6094, 2);
  int argcv_meth_collectionsPrelude_hasNext6094[] = {0};
  meth_meth_collectionsPrelude_hasNext6094->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext6094);
  meth_meth_collectionsPrelude_hasNext6094->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext6094->definitionLine = 458;
// method "next"
  block_savedest(obj6090);
  Object closure6096 = createclosure(1, "next");
  setclosureframe(closure6096, stackframe);
  addtoclosure(closure6096, var_IteratorExhausted);
  struct UserObject *uo6096 = (struct UserObject*)obj6090;
  uo6096->data[3] = (Object)closure6096;
  Method *meth_meth_collectionsPrelude_next6096 = addmethod2pos(obj6090, "next", &meth_collectionsPrelude_next6096, 3);
  int argcv_meth_collectionsPrelude_next6096[] = {0};
  meth_meth_collectionsPrelude_next6096->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next6096);
  meth_meth_collectionsPrelude_next6096->definitionModule = modulename;
  meth_meth_collectionsPrelude_next6096->definitionLine = 459;
  sourceObject = obj6090;
  sourceObject = obj6090;
  sourceObject = obj6090;
  objclass6090 = obj6090->class;
  objclass6090->definitionModule = modulename;
  objclass6090->definitionLine = 456;
  (*(struct UserObject *)self).data[0] = lowerouter6090;
  self = oldself6090;
  selfslot = oldselfslot6090;
  stackframe = oldstackframe6090;
  gc_frame_end(frame);
  return obj6090;
}
Object meth_collectionsPrelude_sorted6101(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_sortedBy_40_1_41_6102(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_emptySequence6105(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "emptySequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySequence (depth = 3)
  gc_frame_end(frame);
  return *var_emptySequence;
}
Object meth_collectionsPrelude_MinimalyIterable6108(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "MinimalyIterable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_MinimalyIterable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_MinimalyIterable (depth = 3)
  gc_frame_end(frame);
  return *var_MinimalyIterable;
}
Object meth_collectionsPrelude_asString6114(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1173
  setline(1173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6115 == NULL) {
    strlit6115 = alloc_String("unused");
    gc_root(strlit6115);
  }
// compiled string node returning strlit6115 (depth = 3)
  gc_frame_end(frame);
  return strlit6115;
}
Object meth_collectionsPrelude__61__61__40_1_41_6116(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6117 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call6118 = callmethodflags(self, "isMe(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6117);
// compiled call node returning call6118 (depth = 3)
  gc_frame_end(frame);
  return call6118;
}
Object meth_collectionsPrelude_unused6120(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "unused");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_unused (depth = 3)
  gc_frame_end(frame);
  return *var_unused;
}
Object meth_collectionsPrelude_asString6126(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6127 == NULL) {
    strlit6127 = alloc_String("removed");
    gc_root(strlit6127);
  }
// compiled string node returning strlit6127 (depth = 3)
  gc_frame_end(frame);
  return strlit6127;
}
Object meth_collectionsPrelude__61__61__40_1_41_6128(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6129 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call6130 = callmethodflags(self, "isMe(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6129);
// compiled call node returning call6130 (depth = 3)
  gc_frame_end(frame);
  return call6130;
}
Object meth_collectionsPrelude_removed6132(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_removed (depth = 3)
  gc_frame_end(frame);
  return *var_removed;
}
Object meth_collectionsPrelude_Binding6135(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Binding");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Binding (depth = 3)
  gc_frame_end(frame);
  return *var_Binding;
}
Object meth_collectionsPrelude_asString6138(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1482
  setline(1482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6139 == NULL) {
    strlit6139 = alloc_String("binding class");
    gc_root(strlit6139);
  }
// compiled string node returning strlit6139 (depth = 3)
  gc_frame_end(frame);
  return strlit6139;
}
Object meth_collectionsPrelude_key6143(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "key");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1485
  setline(1485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_k (depth = 3)
  gc_frame_end(frame);
  return *var_k;
}
Object meth_collectionsPrelude_value6144(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "value");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1486
  setline(1486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  gc_frame_end(frame);
  return *var_v;
}
Object meth_collectionsPrelude_asString6145(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6147 == NULL) {
    strlit6147 = alloc_String("");
    gc_root(strlit6147);
  }
// compiled string node returning strlit6147 (depth = 4)
  int op_slot_right_6146 = gc_frame_newslot(strlit6147);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  int op_slot_right_6149 = gc_frame_newslot(*var_v);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6152 == NULL) {
    strlit6152 = alloc_String("::");
    gc_root(strlit6152);
  }
// compiled string node returning strlit6152 (depth = 6)
  int op_slot_right_6151 = gc_frame_newslot(strlit6152);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_k (depth = 7)
  int op_slot_right_6154 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 7)
  if (strlit6156 == NULL) {
    strlit6156 = alloc_String("");
    gc_root(strlit6156);
  }
// compiled string node returning strlit6156 (depth = 7)
  int op_slot_left_6154 = gc_frame_newslot(strlit6156);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult6157 = callmethod(strlit6156, "++(1)", 1, partcv, params);
// compiled op node returning opresult6157 (depth = 6)
  int op_slot_left_6151 = gc_frame_newslot(opresult6157);
  params[0] = strlit6152;
  partcv[0] = 1;
  Object opresult6158 = callmethod(opresult6157, "++(1)", 1, partcv, params);
// compiled op node returning opresult6158 (depth = 5)
  int op_slot_left_6149 = gc_frame_newslot(opresult6158);
  params[0] = *var_v;
  partcv[0] = 1;
  Object opresult6159 = callmethod(opresult6158, "++(1)", 1, partcv, params);
// compiled op node returning opresult6159 (depth = 4)
  int op_slot_left_6146 = gc_frame_newslot(opresult6159);
  params[0] = strlit6147;
  partcv[0] = 1;
  Object opresult6160 = callmethod(opresult6159, "++(1)", 1, partcv, params);
// compiled op node returning opresult6160 (depth = 3)
  gc_frame_end(frame);
  return opresult6160;
}
Object meth_collectionsPrelude_hashcode6161(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hashcode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6163 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  Object call6164 = callmethodflags(*var_v, "hashcode", 0, partcv, params, 0);
  gc_frame_end(callframe6163);
// compiled member node returning call6164 (depth = 4)
  int op_slot_right_6162 = gc_frame_newslot(call6164);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num6167 = alloc_Float64(1021);
// compiled num node returning num6167 (depth = 5)
  int op_slot_right_6166 = gc_frame_newslot(num6167);
// starting to compile member node (depth = 5)
  int callframe6169 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  Object call6170 = callmethodflags(*var_k, "hashcode", 0, partcv, params, 0);
  gc_frame_end(callframe6169);
// compiled member node returning call6170 (depth = 5)
  int op_slot_left_6166 = gc_frame_newslot(call6170);
  params[0] = num6167;
  partcv[0] = 1;
  Object prod6171 = callmethod(call6170, "*(1)", 1, partcv, params);
// compiled op node returning prod6171 (depth = 4)
  int op_slot_left_6162 = gc_frame_newslot(prod6171);
  params[0] = call6164;
  partcv[0] = 1;
  Object sum6172 = callmethod(prod6171, "+(1)", 1, partcv, params);
// compiled op node returning sum6172 (depth = 3)
  gc_frame_end(frame);
  return sum6172;
}
Object meth_collectionsPrelude_hash6173(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hash");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6175 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  Object call6176 = callmethodflags(*var_v, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe6175);
// compiled member node returning call6176 (depth = 4)
  int op_slot_right_6174 = gc_frame_newslot(call6176);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num6179 = alloc_Float64(1021);
// compiled num node returning num6179 (depth = 5)
  int op_slot_right_6178 = gc_frame_newslot(num6179);
// starting to compile member node (depth = 5)
  int callframe6181 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  Object call6182 = callmethodflags(*var_k, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe6181);
// compiled member node returning call6182 (depth = 5)
  int op_slot_left_6178 = gc_frame_newslot(call6182);
  params[0] = num6179;
  partcv[0] = 1;
  Object prod6183 = callmethod(call6182, "*(1)", 1, partcv, params);
// compiled op node returning prod6183 (depth = 4)
  int op_slot_left_6174 = gc_frame_newslot(prod6183);
  params[0] = call6176;
  partcv[0] = 1;
  Object sum6184 = callmethod(prod6183, "+(1)", 1, partcv, params);
// compiled op node returning sum6184 (depth = 3)
  gc_frame_end(frame);
  return sum6184;
}
Object meth_collectionsPrelude__apply_40_1_41_6188(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6191 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  Object call6192 = callmethodflags(*var_o, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6191);
// compiled member node returning call6192 (depth = 7)
  int op_slot_right_6190 = gc_frame_newslot(call6192);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  int op_slot_left_6190 = gc_frame_newslot(*var_v);
  params[0] = call6192;
  partcv[0] = 1;
  Object opresult6194 = callmethod(*var_v, "==(1)", 1, partcv, params);
// compiled op node returning opresult6194 (depth = 6)
  int op_slot_right_6189 = gc_frame_newslot(opresult6194);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6197 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  Object call6198 = callmethodflags(*var_o, "key", 0, partcv, params, 0);
  gc_frame_end(callframe6197);
// compiled member node returning call6198 (depth = 7)
  int op_slot_right_6196 = gc_frame_newslot(call6198);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_k (depth = 7)
  int op_slot_left_6196 = gc_frame_newslot(*var_k);
  params[0] = call6198;
  partcv[0] = 1;
  Object opresult6200 = callmethod(*var_k, "==(1)", 1, partcv, params);
// compiled op node returning opresult6200 (depth = 6)
  int op_slot_left_6189 = gc_frame_newslot(opresult6200);
  params[0] = opresult6194;
  partcv[0] = 1;
  Object opresult6201 = callmethod(opresult6200, "&&(1)", 1, partcv, params);
// compiled op node returning opresult6201 (depth = 5)
  gc_frame_end(frame);
  return opresult6201;
}
Object meth_collectionsPrelude__apply_40_1_41_6213(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___15 = &(stackframe->slots[0]);
  *var___15 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool6214 = alloc_Boolean(0);
// compiled identifier node returning bool6214 (depth = 6)
  block_return(realself, bool6214);
// compiled return node returning undefined (depth = 5)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__61__61__40_1_41_6185(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  Object *var_Binding = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1491
  setline(1491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  int frame6186 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6187 = alloc_Block(NULL, NULL, "collectionsPrelude", 1492);
  gc_frame_newslot(block6187);
// method "_apply(_)"
  block_savedest(block6187);
  Object closure6188 = createclosure(3, "_apply(1)");
  setclosureframe(closure6188, stackframe);
  addtoclosure(closure6188, var_v);
  addtoclosure(closure6188, var_k);
  addtoclosure(closure6188, selfslot);
  struct UserObject *uo6188 = (struct UserObject*)block6187;
  uo6188->data[0] = (Object)closure6188;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_6188 = addmethod2pos(block6187, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_6188, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_6188[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_6188->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_6188);
  meth_meth_collectionsPrelude__apply_40_1_41_6188->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_6188->definitionLine = 1991;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6203 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe6204 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6205 == NULL) {
    strlit6205 = alloc_String("o");
    gc_root(strlit6205);
  }
// compiled string node returning strlit6205 (depth = 7)
  gc_frame_newslot(strlit6205);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6206 = gc_frame_new();
// call case 5: prelude request
  Object call6207 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6206);
// compiled member node returning call6207 (depth = 7)
  params[0] = strlit6205;
  partcv[0] = 1;
  Object call6208 = callmethodflags(call6207, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6204);
// compiled call node returning call6208 (depth = 6)
  gc_frame_newslot(call6208);
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Binding (depth = 6)
  gc_frame_newslot(*var_Binding);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe6209 = gc_frame_new();
// call case 5: prelude request
  Object call6210 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6209);
// compiled member node returning call6210 (depth = 6)
  params[0] = call6208;
  params[1] = *var_Binding;
  partcv[0] = 2;
  Object call6211 = callmethodflags(call6210, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6203);
// compiled call node returning call6211 (depth = 5)
((struct UserObject *)block6187)->data[1] = call6211;
// compiled block node returning block6187 (depth = 4)
  gc_frame_newslot(block6187);
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6212 = alloc_Block(NULL, NULL, "collectionsPrelude", 1493);
  gc_frame_newslot(block6212);
// method "_apply(_)"
  block_savedest(block6212);
  Object closure6213 = createclosure(1, "_apply(1)");
  setclosureframe(closure6213, stackframe);
  addtoclosure(closure6213, selfslot);
  struct UserObject *uo6213 = (struct UserObject*)block6212;
  uo6213->data[0] = (Object)closure6213;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_6213 = addmethod2pos(block6212, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_6213, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_6213[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_6213->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_6213);
  meth_meth_collectionsPrelude__apply_40_1_41_6213->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_6213->definitionLine = 1991;
// compiled block node returning block6212 (depth = 4)
  gc_frame_newslot(block6212);
  params[0] = block6187;
  params[1] = block6212;
  Object matchres6186 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame6186);
// compiled matchcase node returning matchres6186 (depth = 3)
  gc_frame_end(frame);
  return matchres6186;
}
Object meth_collectionsPrelude_key_40_1_41_value_40_1_41_6140(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "key(1)value(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method key(_)value(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method key(_)value(_)");
  Object params[1];
  int partcv[1];
  Object *var_Binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for key(_)value(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part key(_)");
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part value(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6141 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6141 = alloc_userobj2(6,7, objclass6141);
  gc_frame_newslot(obj6141);
if (objclass6141 == NULL) {
  glfree(obj6141->class->name);
  obj6141->class->name = "binding.key(_)value(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6141, self, 0);
  addmethodreal(obj6141,"outer", &reader_collectionsPrelude_outer_6142);
  Object oldself6141 = self;
  struct StackFrameObject *oldstackframe6141 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6141);
  gc_frame_newslot((Object)stackframe);
  self = obj6141;
  Object *oldselfslot6141 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6141 = (*(struct UserObject *)self).data[0], lowerouter6141 = thisouter6141;
  if (inheritingObject6141) {
    struct UserObject *inho6141 = (struct UserObject *)inheritingObject6141;
    while (inho6141->super != GraceDefaultObject) inho6141 = (struct UserObject *)inho6141->super;
    inho6141->super = obj6141;
    self = inheritingObject6141;
    *selfslot = self;
    lowerouter6141 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6141;
  }
// method "key"
  block_savedest(obj6141);
  Object closure6143 = createclosure(1, "key");
  setclosureframe(closure6143, stackframe);
  addtoclosure(closure6143, var_k);
  struct UserObject *uo6143 = (struct UserObject*)obj6141;
  uo6143->data[1] = (Object)closure6143;
  Method *meth_meth_collectionsPrelude_key6143 = addmethod2pos(obj6141, "key", &meth_collectionsPrelude_key6143, 1);
  int argcv_meth_collectionsPrelude_key6143[] = {0};
  meth_meth_collectionsPrelude_key6143->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_key6143);
  meth_meth_collectionsPrelude_key6143->definitionModule = modulename;
  meth_meth_collectionsPrelude_key6143->definitionLine = 1485;
// method "value"
  block_savedest(obj6141);
  Object closure6144 = createclosure(1, "value");
  setclosureframe(closure6144, stackframe);
  addtoclosure(closure6144, var_v);
  struct UserObject *uo6144 = (struct UserObject*)obj6141;
  uo6144->data[2] = (Object)closure6144;
  Method *meth_meth_collectionsPrelude_value6144 = addmethod2pos(obj6141, "value", &meth_collectionsPrelude_value6144, 2);
  int argcv_meth_collectionsPrelude_value6144[] = {0};
  meth_meth_collectionsPrelude_value6144->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_value6144);
  meth_meth_collectionsPrelude_value6144->definitionModule = modulename;
  meth_meth_collectionsPrelude_value6144->definitionLine = 1486;
// method "asString"
  block_savedest(obj6141);
  Object closure6145 = createclosure(2, "asString");
  setclosureframe(closure6145, stackframe);
  addtoclosure(closure6145, var_v);
  addtoclosure(closure6145, var_k);
  struct UserObject *uo6145 = (struct UserObject*)obj6141;
  uo6145->data[3] = (Object)closure6145;
  Method *meth_meth_collectionsPrelude_asString6145 = addmethod2pos(obj6141, "asString", &meth_collectionsPrelude_asString6145, 3);
  int argcv_meth_collectionsPrelude_asString6145[] = {0};
  meth_meth_collectionsPrelude_asString6145->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6145);
  meth_meth_collectionsPrelude_asString6145->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6145->definitionLine = 1487;
// method "hashcode"
  block_savedest(obj6141);
  Object closure6161 = createclosure(2, "hashcode");
  setclosureframe(closure6161, stackframe);
  addtoclosure(closure6161, var_v);
  addtoclosure(closure6161, var_k);
  struct UserObject *uo6161 = (struct UserObject*)obj6141;
  uo6161->data[4] = (Object)closure6161;
  Method *meth_meth_collectionsPrelude_hashcode6161 = addmethod2pos(obj6141, "hashcode", &meth_collectionsPrelude_hashcode6161, 4);
  int argcv_meth_collectionsPrelude_hashcode6161[] = {0};
  meth_meth_collectionsPrelude_hashcode6161->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hashcode6161);
  meth_meth_collectionsPrelude_hashcode6161->definitionModule = modulename;
  meth_meth_collectionsPrelude_hashcode6161->definitionLine = 1488;
// method "hash"
  block_savedest(obj6141);
  Object closure6173 = createclosure(2, "hash");
  setclosureframe(closure6173, stackframe);
  addtoclosure(closure6173, var_v);
  addtoclosure(closure6173, var_k);
  struct UserObject *uo6173 = (struct UserObject*)obj6141;
  uo6173->data[5] = (Object)closure6173;
  Method *meth_meth_collectionsPrelude_hash6173 = addmethod2pos(obj6141, "hash", &meth_collectionsPrelude_hash6173, 5);
  int argcv_meth_collectionsPrelude_hash6173[] = {0};
  meth_meth_collectionsPrelude_hash6173->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hash6173);
  meth_meth_collectionsPrelude_hash6173->definitionModule = modulename;
  meth_meth_collectionsPrelude_hash6173->definitionLine = 1489;
// method "==(_)"
  block_savedest(obj6141);
  Object closure6185 = createclosure(3, "==(1)");
  setclosureframe(closure6185, stackframe);
  addtoclosure(closure6185, var_v);
  addtoclosure(closure6185, var_k);
  addtoclosure(closure6185, var_Binding);
  struct UserObject *uo6185 = (struct UserObject*)obj6141;
  uo6185->data[6] = (Object)closure6185;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_6185 = addmethod2pos(obj6141, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_6185, 6);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_6185[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_6185->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_6185);
  meth_meth_collectionsPrelude__61__61__40_1_41_6185->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_6185->definitionLine = 1490;
  sourceObject = obj6141;
  sourceObject = obj6141;
  sourceObject = obj6141;
  sourceObject = obj6141;
  sourceObject = obj6141;
  sourceObject = obj6141;
  objclass6141 = obj6141->class;
  objclass6141->definitionModule = modulename;
  objclass6141->definitionLine = 1484;
  (*(struct UserObject *)self).data[0] = lowerouter6141;
  self = oldself6141;
  selfslot = oldselfslot6141;
  stackframe = oldstackframe6141;
  gc_frame_end(frame);
  return obj6141;
}
Object meth_collectionsPrelude_key_40_1_41_value_40_1_41_6140_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "key(1)value(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method key(_)value(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method key(_)value(_)");
  Object params[1];
  int partcv[1];
  Object *var_Binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for key(_)value(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part key(_)");
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part value(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6141 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6141 = alloc_userobj2(6,7, objclass6141);
  gc_frame_newslot(obj6141);
if (objclass6141 == NULL) {
  glfree(obj6141->class->name);
  obj6141->class->name = "binding.key(_)value(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6141, self, 0);
  addmethodreal(obj6141,"outer", &reader_collectionsPrelude_outer_6142);
  Object oldself6141 = self;
  struct StackFrameObject *oldstackframe6141 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6141);
  gc_frame_newslot((Object)stackframe);
  self = obj6141;
  Object *oldselfslot6141 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6141 = (*(struct UserObject *)self).data[0], lowerouter6141 = thisouter6141;
  if (inheritingObject6141) {
    struct UserObject *inho6141 = (struct UserObject *)inheritingObject6141;
    while (inho6141->super != GraceDefaultObject) inho6141 = (struct UserObject *)inho6141->super;
    inho6141->super = obj6141;
    self = inheritingObject6141;
    *selfslot = self;
    lowerouter6141 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6141;
  }
// method "key"
  block_savedest(obj6141);
  Object closure6143 = createclosure(1, "key");
  setclosureframe(closure6143, stackframe);
  addtoclosure(closure6143, var_k);
  struct UserObject *uo6143 = (struct UserObject*)obj6141;
  uo6143->data[1] = (Object)closure6143;
  Method *meth_meth_collectionsPrelude_key6143 = addmethod2pos(obj6141, "key", &meth_collectionsPrelude_key6143, 1);
  int argcv_meth_collectionsPrelude_key6143[] = {0};
  meth_meth_collectionsPrelude_key6143->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_key6143);
  meth_meth_collectionsPrelude_key6143->definitionModule = modulename;
  meth_meth_collectionsPrelude_key6143->definitionLine = 1485;
// method "value"
  block_savedest(obj6141);
  Object closure6144 = createclosure(1, "value");
  setclosureframe(closure6144, stackframe);
  addtoclosure(closure6144, var_v);
  struct UserObject *uo6144 = (struct UserObject*)obj6141;
  uo6144->data[2] = (Object)closure6144;
  Method *meth_meth_collectionsPrelude_value6144 = addmethod2pos(obj6141, "value", &meth_collectionsPrelude_value6144, 2);
  int argcv_meth_collectionsPrelude_value6144[] = {0};
  meth_meth_collectionsPrelude_value6144->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_value6144);
  meth_meth_collectionsPrelude_value6144->definitionModule = modulename;
  meth_meth_collectionsPrelude_value6144->definitionLine = 1486;
// method "asString"
  block_savedest(obj6141);
  Object closure6145 = createclosure(2, "asString");
  setclosureframe(closure6145, stackframe);
  addtoclosure(closure6145, var_v);
  addtoclosure(closure6145, var_k);
  struct UserObject *uo6145 = (struct UserObject*)obj6141;
  uo6145->data[3] = (Object)closure6145;
  Method *meth_meth_collectionsPrelude_asString6145 = addmethod2pos(obj6141, "asString", &meth_collectionsPrelude_asString6145, 3);
  int argcv_meth_collectionsPrelude_asString6145[] = {0};
  meth_meth_collectionsPrelude_asString6145->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6145);
  meth_meth_collectionsPrelude_asString6145->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6145->definitionLine = 1487;
// method "hashcode"
  block_savedest(obj6141);
  Object closure6161 = createclosure(2, "hashcode");
  setclosureframe(closure6161, stackframe);
  addtoclosure(closure6161, var_v);
  addtoclosure(closure6161, var_k);
  struct UserObject *uo6161 = (struct UserObject*)obj6141;
  uo6161->data[4] = (Object)closure6161;
  Method *meth_meth_collectionsPrelude_hashcode6161 = addmethod2pos(obj6141, "hashcode", &meth_collectionsPrelude_hashcode6161, 4);
  int argcv_meth_collectionsPrelude_hashcode6161[] = {0};
  meth_meth_collectionsPrelude_hashcode6161->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hashcode6161);
  meth_meth_collectionsPrelude_hashcode6161->definitionModule = modulename;
  meth_meth_collectionsPrelude_hashcode6161->definitionLine = 1488;
// method "hash"
  block_savedest(obj6141);
  Object closure6173 = createclosure(2, "hash");
  setclosureframe(closure6173, stackframe);
  addtoclosure(closure6173, var_v);
  addtoclosure(closure6173, var_k);
  struct UserObject *uo6173 = (struct UserObject*)obj6141;
  uo6173->data[5] = (Object)closure6173;
  Method *meth_meth_collectionsPrelude_hash6173 = addmethod2pos(obj6141, "hash", &meth_collectionsPrelude_hash6173, 5);
  int argcv_meth_collectionsPrelude_hash6173[] = {0};
  meth_meth_collectionsPrelude_hash6173->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hash6173);
  meth_meth_collectionsPrelude_hash6173->definitionModule = modulename;
  meth_meth_collectionsPrelude_hash6173->definitionLine = 1489;
// method "==(_)"
  block_savedest(obj6141);
  Object closure6185 = createclosure(3, "==(1)");
  setclosureframe(closure6185, stackframe);
  addtoclosure(closure6185, var_v);
  addtoclosure(closure6185, var_k);
  addtoclosure(closure6185, var_Binding);
  struct UserObject *uo6185 = (struct UserObject*)obj6141;
  uo6185->data[6] = (Object)closure6185;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_6185 = addmethod2pos(obj6141, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_6185, 6);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_6185[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_6185->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_6185);
  meth_meth_collectionsPrelude__61__61__40_1_41_6185->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_6185->definitionLine = 1490;
  sourceObject = obj6141;
  sourceObject = obj6141;
  sourceObject = obj6141;
  sourceObject = obj6141;
  sourceObject = obj6141;
  sourceObject = obj6141;
  objclass6141 = obj6141->class;
  objclass6141->definitionModule = modulename;
  objclass6141->definitionLine = 1484;
  (*(struct UserObject *)self).data[0] = lowerouter6141;
  self = oldself6141;
  selfslot = oldselfslot6141;
  stackframe = oldstackframe6141;
  gc_frame_end(frame);
  return obj6141;
}
Object meth_collectionsPrelude_binding6217(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "binding");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_binding (depth = 3)
  gc_frame_end(frame);
  return *var_binding;
}
Object meth_collectionsPrelude_ComparableToDictionary6220(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ComparableToDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ComparableToDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ComparableToDictionary (depth = 3)
  gc_frame_end(frame);
  return *var_ComparableToDictionary;
}
Object module_collectionsPrelude_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(53, 53);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = grace_prelude();
  adddatum2(self, grace_prelude(), 0);
  Object ObjectType = alloc_ObjectType();
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<collectionsPrelude>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(53, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[1];
  int partcv[2];
  Object *var_BoundsError = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "BoundsError");
  Object *var_IteratorExhausted = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "IteratorExhausted");
  Object *var_SubobjectResponsibility = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "SubobjectResponsibility");
  Object *var_NoSuchObject = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "NoSuchObject");
  Object *var_RequestError = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "RequestError");
  Object *var_ConcurrentModification = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "ConcurrentModification");
  Object *var_SizeUnknown = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "SizeUnknown");
  Object *var_Block0 = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "Block0");
  Object *var_Block1 = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "Block1");
  Object *var_Block2 = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "Block2");
  Object *var_SelfType = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "SelfType");
  Object *var_Iterable = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "Iterable");
  Object *var_Expandable = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "Expandable");
  Object *var_Collection = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "Collection");
  Object *var_Enumerable = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "Enumerable");
  Object *var_Sequence = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "Sequence");
  Object *var_List = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "List");
  Object *var_Set = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "Set");
  Object *var_Dictionary = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "Dictionary");
  Object *var_Iterator = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "Iterator");
  Object *var_collection = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "collection");
  Object *var_enumerable = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "enumerable");
  Object *var_indexable = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "indexable");
  Object *var_emptySequence = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "emptySequence");
  Object *var_MinimalyIterable = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "MinimalyIterable");
  Object *var_unused = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "unused");
  Object *var_removed = &(stackframe->slots[27]);
  setframeelementname(stackframe, 27, "removed");
  Object *var_Binding = &(stackframe->slots[28]);
  setframeelementname(stackframe, 28, "Binding");
  Object *var_binding = &(stackframe->slots[29]);
  setframeelementname(stackframe, 29, "binding");
  Object *var_ComparableToDictionary = &(stackframe->slots[30]);
  setframeelementname(stackframe, 30, "ComparableToDictionary");
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "abstract"
  block_savedest(self);
  Object closure1 = createclosure(1, "abstract");
  setclosureframe(closure1, stackframe);
  addtoclosure(closure1, var_SubobjectResponsibility);
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = (Object)closure1;
  Method *meth_meth_collectionsPrelude_abstract1 = addmethod2pos(self, "abstract", &meth_collectionsPrelude_abstract1, 1);
  int argcv_meth_collectionsPrelude_abstract1[] = {0};
  meth_meth_collectionsPrelude_abstract1->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_abstract1);
  meth_meth_collectionsPrelude_abstract1->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_abstract1->definitionModule = modulename;
  meth_meth_collectionsPrelude_abstract1->definitionLine = 11;
// compiled method node returning  (depth = 1)
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "lazySequenceOver(_)mappedBy(_)"
  block_savedest(self);
  Object closure5 = createclosure(1, "lazySequenceOver(1)mappedBy(1)");
  setclosureframe(closure5, stackframe);
  addtoclosure(closure5, var_enumerable);
  struct UserObject *uo5 = (struct UserObject*)self;
  uo5->data[2] = (Object)closure5;
  Method *meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5 = addmethod2pos(self, "lazySequenceOver(1)mappedBy(1)", &meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5, 2);
  int argcv_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5[] = {1, 1};
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5);
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5->definitionLine = 169;
  block_savedest(self);
  Object closure46 = createclosure(1, "lazySequenceOver(1)mappedBy(1)$object(1)");
  setclosureframe(closure46, stackframe);
  addtoclosure(closure46, var_enumerable);
  Method *meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5_object = addmethod2pos(self, "lazySequenceOver(1)mappedBy(1)$object(1)", &meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5_object, 2);
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5_object->definitionLine = 169;
// compiled method node returning  (depth = 1)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "lazySequenceOver(_)filteredBy(_)"
  block_savedest(self);
  Object closure47 = createclosure(1, "lazySequenceOver(1)filteredBy(1)");
  setclosureframe(closure47, stackframe);
  addtoclosure(closure47, var_enumerable);
  struct UserObject *uo47 = (struct UserObject*)self;
  uo47->data[3] = (Object)closure47;
  Method *meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47 = addmethod2pos(self, "lazySequenceOver(1)filteredBy(1)", &meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47, 3);
  int argcv_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47[] = {1, 1};
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47);
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47->definitionLine = 183;
  block_savedest(self);
  Object closure150 = createclosure(1, "lazySequenceOver(1)filteredBy(1)$object(1)");
  setclosureframe(closure150, stackframe);
  addtoclosure(closure150, var_enumerable);
  Method *meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47_object = addmethod2pos(self, "lazySequenceOver(1)filteredBy(1)$object(1)", &meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47_object, 3);
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47_object->definitionLine = 183;
// compiled method node returning  (depth = 1)
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "iteratorConcat(_,_)"
  struct UserObject *uo151 = (struct UserObject*)self;
  uo151->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iteratorConcat_40_2_41_151 = addmethod2pos(self, "iteratorConcat(2)", &meth_collectionsPrelude_iteratorConcat_40_2_41_151, 4);
  int argcv_meth_collectionsPrelude_iteratorConcat_40_2_41_151[] = {2};
  meth_meth_collectionsPrelude_iteratorConcat_40_2_41_151->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iteratorConcat_40_2_41_151);
  meth_meth_collectionsPrelude_iteratorConcat_40_2_41_151->definitionModule = modulename;
  meth_meth_collectionsPrelude_iteratorConcat_40_2_41_151->definitionLine = 228;
  Method *meth_meth_collectionsPrelude_iteratorConcat_40_2_41_151_object = addmethod2pos(self, "iteratorConcat(2)$object(1)", &meth_collectionsPrelude_iteratorConcat_40_2_41_151_object, 4);
  int argcv_meth_collectionsPrelude_iteratorConcat_40_2_41_151_object[] = {2};
  meth_meth_collectionsPrelude_iteratorConcat_40_2_41_151_object->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iteratorConcat_40_2_41_151_object);
  meth_meth_collectionsPrelude_iteratorConcat_40_2_41_151_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iteratorConcat_40_2_41_151_object->definitionLine = 228;
// compiled method node returning  (depth = 1)
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "lazyConcatenation(_,_)"
  block_savedest(self);
  Object closure188 = createclosure(1, "lazyConcatenation(2)");
  setclosureframe(closure188, stackframe);
  addtoclosure(closure188, var_enumerable);
  struct UserObject *uo188 = (struct UserObject*)self;
  uo188->data[5] = (Object)closure188;
  Method *meth_meth_collectionsPrelude_lazyConcatenation_40_2_41_188 = addmethod2pos(self, "lazyConcatenation(2)", &meth_collectionsPrelude_lazyConcatenation_40_2_41_188, 5);
  int argcv_meth_collectionsPrelude_lazyConcatenation_40_2_41_188[] = {2};
  meth_meth_collectionsPrelude_lazyConcatenation_40_2_41_188->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_lazyConcatenation_40_2_41_188);
  meth_meth_collectionsPrelude_lazyConcatenation_40_2_41_188->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazyConcatenation_40_2_41_188->definitionLine = 243;
  block_savedest(self);
  Object closure229 = createclosure(1, "lazyConcatenation(2)$object(1)");
  setclosureframe(closure229, stackframe);
  addtoclosure(closure229, var_enumerable);
  Method *meth_meth_collectionsPrelude_lazyConcatenation_40_2_41_188_object = addmethod2pos(self, "lazyConcatenation(2)$object(1)", &meth_collectionsPrelude_lazyConcatenation_40_2_41_188_object, 5);
  meth_meth_collectionsPrelude_lazyConcatenation_40_2_41_188_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazyConcatenation_40_2_41_188_object->definitionLine = 243;
// compiled method node returning  (depth = 1)
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "max(_,_)"
  struct UserObject *uo230 = (struct UserObject*)self;
  uo230->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_max_40_2_41_230 = addmethod2pos(self, "max(2)", &meth_collectionsPrelude_max_40_2_41_230, 6);
  int argcv_meth_collectionsPrelude_max_40_2_41_230[] = {2};
  meth_meth_collectionsPrelude_max_40_2_41_230->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_max_40_2_41_230);
  meth_meth_collectionsPrelude_max_40_2_41_230->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_max_40_2_41_230->definitionModule = modulename;
  meth_meth_collectionsPrelude_max_40_2_41_230->definitionLine = 430;
// compiled method node returning  (depth = 1)
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "sequence"
  block_savedest(self);
  Object closure235 = createclosure(5, "sequence");
  setclosureframe(closure235, stackframe);
  addtoclosure(closure235, var_emptySequence);
  addtoclosure(closure235, var__prelude);
  addtoclosure(closure235, var_BoundsError);
  addtoclosure(closure235, var_IteratorExhausted);
  addtoclosure(closure235, var_indexable);
  struct UserObject *uo235 = (struct UserObject*)self;
  uo235->data[7] = (Object)closure235;
  Method *meth_meth_collectionsPrelude_sequence235 = addmethod2pos(self, "sequence", &meth_collectionsPrelude_sequence235, 7);
  int argcv_meth_collectionsPrelude_sequence235[] = {0};
  meth_meth_collectionsPrelude_sequence235->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sequence235);
  meth_meth_collectionsPrelude_sequence235->definitionModule = modulename;
  meth_meth_collectionsPrelude_sequence235->definitionLine = 465;
  block_savedest(self);
  Object closure665 = createclosure(5, "sequence$object(1)");
  setclosureframe(closure665, stackframe);
  addtoclosure(closure665, var_emptySequence);
  addtoclosure(closure665, var__prelude);
  addtoclosure(closure665, var_BoundsError);
  addtoclosure(closure665, var_IteratorExhausted);
  addtoclosure(closure665, var_indexable);
  Method *meth_meth_collectionsPrelude_sequence235_object = addmethod2pos(self, "sequence$object(1)", &meth_collectionsPrelude_sequence235_object, 7);
  meth_meth_collectionsPrelude_sequence235_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_sequence235_object->definitionLine = 465;
// compiled method node returning  (depth = 1)
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "isEqual(_)toIterable(_)"
  block_savedest(self);
  Object closure666 = createclosure(1, "isEqual(1)toIterable(1)");
  setclosureframe(closure666, stackframe);
  addtoclosure(closure666, var_MinimalyIterable);
  struct UserObject *uo666 = (struct UserObject*)self;
  uo666->data[8] = (Object)closure666;
  Method *meth_meth_collectionsPrelude_isEqual_40_1_41_toIterable_40_1_41_666 = addmethod2pos(self, "isEqual(1)toIterable(1)", &meth_collectionsPrelude_isEqual_40_1_41_toIterable_40_1_41_666, 8);
  int argcv_meth_collectionsPrelude_isEqual_40_1_41_toIterable_40_1_41_666[] = {1, 1};
  meth_meth_collectionsPrelude_isEqual_40_1_41_toIterable_40_1_41_666->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_isEqual_40_1_41_toIterable_40_1_41_666);
  meth_meth_collectionsPrelude_isEqual_40_1_41_toIterable_40_1_41_666->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEqual_40_1_41_toIterable_40_1_41_666->definitionLine = 606;
// compiled method node returning  (depth = 1)
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "list"
  block_savedest(self);
  Object closure706 = createclosure(8, "list");
  setclosureframe(closure706, stackframe);
  addtoclosure(closure706, var_emptySequence);
  addtoclosure(closure706, var_NoSuchObject);
  addtoclosure(closure706, var_done);
  addtoclosure(closure706, var_ConcurrentModification);
  addtoclosure(closure706, var_IteratorExhausted);
  addtoclosure(closure706, var_indexable);
  addtoclosure(closure706, var_BoundsError);
  addtoclosure(closure706, var__prelude);
  struct UserObject *uo706 = (struct UserObject*)self;
  uo706->data[9] = (Object)closure706;
  Method *meth_meth_collectionsPrelude_list706 = addmethod2pos(self, "list", &meth_collectionsPrelude_list706, 9);
  int argcv_meth_collectionsPrelude_list706[] = {0};
  meth_meth_collectionsPrelude_list706->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_list706);
  meth_meth_collectionsPrelude_list706->definitionModule = modulename;
  meth_meth_collectionsPrelude_list706->definitionLine = 621;
  block_savedest(self);
  Object closure2293 = createclosure(8, "list$object(1)");
  setclosureframe(closure2293, stackframe);
  addtoclosure(closure2293, var_emptySequence);
  addtoclosure(closure2293, var_NoSuchObject);
  addtoclosure(closure2293, var_done);
  addtoclosure(closure2293, var_ConcurrentModification);
  addtoclosure(closure2293, var_IteratorExhausted);
  addtoclosure(closure2293, var_indexable);
  addtoclosure(closure2293, var_BoundsError);
  addtoclosure(closure2293, var__prelude);
  Method *meth_meth_collectionsPrelude_list706_object = addmethod2pos(self, "list$object(1)", &meth_collectionsPrelude_list706_object, 9);
  meth_meth_collectionsPrelude_list706_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_list706_object->definitionLine = 621;
// compiled method node returning  (depth = 1)
// Begin line 1185
  setline(1185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "set"
  block_savedest(self);
  Object closure2294 = createclosure(8, "set");
  setclosureframe(closure2294, stackframe);
  addtoclosure(closure2294, var_NoSuchObject);
  addtoclosure(closure2294, var_removed);
  addtoclosure(closure2294, var__prelude);
  addtoclosure(closure2294, var_unused);
  addtoclosure(closure2294, var_ConcurrentModification);
  addtoclosure(closure2294, var_IteratorExhausted);
  addtoclosure(closure2294, var_Iterable);
  addtoclosure(closure2294, var_collection);
  struct UserObject *uo2294 = (struct UserObject*)self;
  uo2294->data[10] = (Object)closure2294;
  Method *meth_meth_collectionsPrelude_set2294 = addmethod2pos(self, "set", &meth_collectionsPrelude_set2294, 10);
  int argcv_meth_collectionsPrelude_set2294[] = {0};
  meth_meth_collectionsPrelude_set2294->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_set2294);
  meth_meth_collectionsPrelude_set2294->definitionModule = modulename;
  meth_meth_collectionsPrelude_set2294->definitionLine = 1185;
  block_savedest(self);
  Object closure3133 = createclosure(8, "set$object(1)");
  setclosureframe(closure3133, stackframe);
  addtoclosure(closure3133, var_NoSuchObject);
  addtoclosure(closure3133, var_removed);
  addtoclosure(closure3133, var__prelude);
  addtoclosure(closure3133, var_unused);
  addtoclosure(closure3133, var_ConcurrentModification);
  addtoclosure(closure3133, var_IteratorExhausted);
  addtoclosure(closure3133, var_Iterable);
  addtoclosure(closure3133, var_collection);
  Method *meth_meth_collectionsPrelude_set2294_object = addmethod2pos(self, "set$object(1)", &meth_collectionsPrelude_set2294_object, 10);
  meth_meth_collectionsPrelude_set2294_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_set2294_object->definitionLine = 1185;
// compiled method node returning  (depth = 1)
// Begin line 1503
  setline(1503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dictionary"
  block_savedest(self);
  Object closure3134 = createclosure(10, "dictionary");
  setclosureframe(closure3134, stackframe);
  addtoclosure(closure3134, var_removed);
  addtoclosure(closure3134, var_unused);
  addtoclosure(closure3134, var_binding);
  addtoclosure(closure3134, var_NoSuchObject);
  addtoclosure(closure3134, var__prelude);
  addtoclosure(closure3134, var_enumerable);
  addtoclosure(closure3134, var_ConcurrentModification);
  addtoclosure(closure3134, var_IteratorExhausted);
  addtoclosure(closure3134, var_ComparableToDictionary);
  addtoclosure(closure3134, var_collection);
  struct UserObject *uo3134 = (struct UserObject*)self;
  uo3134->data[11] = (Object)closure3134;
  Method *meth_meth_collectionsPrelude_dictionary3134 = addmethod2pos(self, "dictionary", &meth_collectionsPrelude_dictionary3134, 11);
  int argcv_meth_collectionsPrelude_dictionary3134[] = {0};
  meth_meth_collectionsPrelude_dictionary3134->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_dictionary3134);
  meth_meth_collectionsPrelude_dictionary3134->definitionModule = modulename;
  meth_meth_collectionsPrelude_dictionary3134->definitionLine = 1503;
  block_savedest(self);
  Object closure4505 = createclosure(10, "dictionary$object(1)");
  setclosureframe(closure4505, stackframe);
  addtoclosure(closure4505, var_removed);
  addtoclosure(closure4505, var_unused);
  addtoclosure(closure4505, var_binding);
  addtoclosure(closure4505, var_NoSuchObject);
  addtoclosure(closure4505, var__prelude);
  addtoclosure(closure4505, var_enumerable);
  addtoclosure(closure4505, var_ConcurrentModification);
  addtoclosure(closure4505, var_IteratorExhausted);
  addtoclosure(closure4505, var_ComparableToDictionary);
  addtoclosure(closure4505, var_collection);
  Method *meth_meth_collectionsPrelude_dictionary3134_object = addmethod2pos(self, "dictionary$object(1)", &meth_collectionsPrelude_dictionary3134_object, 11);
  meth_meth_collectionsPrelude_dictionary3134_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_dictionary3134_object->definitionLine = 1503;
// compiled method node returning  (depth = 1)
// Begin line 1877
  setline(1877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "range"
  block_savedest(self);
  Object closure4506 = createclosure(6, "range");
  setclosureframe(closure4506, stackframe);
  addtoclosure(closure4506, var_Number);
  addtoclosure(closure4506, var_RequestError);
  addtoclosure(closure4506, var_IteratorExhausted);
  addtoclosure(closure4506, var_BoundsError);
  addtoclosure(closure4506, var__prelude);
  addtoclosure(closure4506, var_indexable);
  struct UserObject *uo4506 = (struct UserObject*)self;
  uo4506->data[12] = (Object)closure4506;
  Method *meth_meth_collectionsPrelude_range4506 = addmethod2pos(self, "range", &meth_collectionsPrelude_range4506, 12);
  int argcv_meth_collectionsPrelude_range4506[] = {0};
  meth_meth_collectionsPrelude_range4506->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_range4506);
  meth_meth_collectionsPrelude_range4506->definitionModule = modulename;
  meth_meth_collectionsPrelude_range4506->definitionLine = 1877;
  block_savedest(self);
  Object closure5477 = createclosure(6, "range$object(1)");
  setclosureframe(closure5477, stackframe);
  addtoclosure(closure5477, var_Number);
  addtoclosure(closure5477, var_RequestError);
  addtoclosure(closure5477, var_IteratorExhausted);
  addtoclosure(closure5477, var_BoundsError);
  addtoclosure(closure5477, var__prelude);
  addtoclosure(closure5477, var_indexable);
  Method *meth_meth_collectionsPrelude_range4506_object = addmethod2pos(self, "range$object(1)", &meth_collectionsPrelude_range4506_object, 12);
  meth_meth_collectionsPrelude_range4506_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_range4506_object->definitionLine = 1877;
// compiled method node returning  (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5478 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5479 == NULL) {
    strlit5479 = alloc_String("BoundsError");
    gc_root(strlit5479);
  }
// compiled string node returning strlit5479 (depth = 3)
  gc_frame_newslot(strlit5479);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5480 = gc_frame_new();
// call case 5: prelude request
  Object call5481 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5480);
// compiled member node returning call5481 (depth = 3)
  params[0] = strlit5479;
  partcv[0] = 1;
  Object call5482 = callmethodflags(call5481, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5478);
// compiled call node returning call5482 (depth = 2)
  *var_BoundsError = call5482;
  if (call5482 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "BoundsError"
  block_savedest(self);
  Object closure5483 = createclosure(1, "BoundsError");
  setclosureframe(closure5483, stackframe);
  addtoclosure(closure5483, var_BoundsError);
  struct UserObject *uo5483 = (struct UserObject*)self;
  uo5483->data[13] = (Object)closure5483;
  Method *meth_meth_collectionsPrelude_BoundsError5483 = addmethod2pos(self, "BoundsError", &meth_collectionsPrelude_BoundsError5483, 13);
  int argcv_meth_collectionsPrelude_BoundsError5483[] = {0};
  meth_meth_collectionsPrelude_BoundsError5483->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_BoundsError5483);
  meth_meth_collectionsPrelude_BoundsError5483->definitionModule = modulename;
  meth_meth_collectionsPrelude_BoundsError5483->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5484 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5485 == NULL) {
    strlit5485 = alloc_String("IteratorExhausted");
    gc_root(strlit5485);
  }
// compiled string node returning strlit5485 (depth = 3)
  gc_frame_newslot(strlit5485);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5486 = gc_frame_new();
// call case 5: prelude request
  Object call5487 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5486);
// compiled member node returning call5487 (depth = 3)
  params[0] = strlit5485;
  partcv[0] = 1;
  Object call5488 = callmethodflags(call5487, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5484);
// compiled call node returning call5488 (depth = 2)
  *var_IteratorExhausted = call5488;
  if (call5488 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "IteratorExhausted"
  block_savedest(self);
  Object closure5489 = createclosure(1, "IteratorExhausted");
  setclosureframe(closure5489, stackframe);
  addtoclosure(closure5489, var_IteratorExhausted);
  struct UserObject *uo5489 = (struct UserObject*)self;
  uo5489->data[14] = (Object)closure5489;
  Method *meth_meth_collectionsPrelude_IteratorExhausted5489 = addmethod2pos(self, "IteratorExhausted", &meth_collectionsPrelude_IteratorExhausted5489, 14);
  int argcv_meth_collectionsPrelude_IteratorExhausted5489[] = {0};
  meth_meth_collectionsPrelude_IteratorExhausted5489->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_IteratorExhausted5489);
  meth_meth_collectionsPrelude_IteratorExhausted5489->definitionModule = modulename;
  meth_meth_collectionsPrelude_IteratorExhausted5489->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5490 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5491 == NULL) {
    strlit5491 = alloc_String("SubobjectResponsibility");
    gc_root(strlit5491);
  }
// compiled string node returning strlit5491 (depth = 3)
  gc_frame_newslot(strlit5491);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5492 = gc_frame_new();
// call case 5: prelude request
  Object call5493 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5492);
// compiled member node returning call5493 (depth = 3)
  params[0] = strlit5491;
  partcv[0] = 1;
  Object call5494 = callmethodflags(call5493, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5490);
// compiled call node returning call5494 (depth = 2)
  *var_SubobjectResponsibility = call5494;
  if (call5494 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "SubobjectResponsibility"
  block_savedest(self);
  Object closure5495 = createclosure(1, "SubobjectResponsibility");
  setclosureframe(closure5495, stackframe);
  addtoclosure(closure5495, var_SubobjectResponsibility);
  struct UserObject *uo5495 = (struct UserObject*)self;
  uo5495->data[15] = (Object)closure5495;
  Method *meth_meth_collectionsPrelude_SubobjectResponsibility5495 = addmethod2pos(self, "SubobjectResponsibility", &meth_collectionsPrelude_SubobjectResponsibility5495, 15);
  int argcv_meth_collectionsPrelude_SubobjectResponsibility5495[] = {0};
  meth_meth_collectionsPrelude_SubobjectResponsibility5495->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_SubobjectResponsibility5495);
  meth_meth_collectionsPrelude_SubobjectResponsibility5495->definitionModule = modulename;
  meth_meth_collectionsPrelude_SubobjectResponsibility5495->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5496 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5497 == NULL) {
    strlit5497 = alloc_String("NoSuchObject");
    gc_root(strlit5497);
  }
// compiled string node returning strlit5497 (depth = 3)
  gc_frame_newslot(strlit5497);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5498 = gc_frame_new();
// call case 5: prelude request
  Object call5499 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5498);
// compiled member node returning call5499 (depth = 3)
  params[0] = strlit5497;
  partcv[0] = 1;
  Object call5500 = callmethodflags(call5499, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5496);
// compiled call node returning call5500 (depth = 2)
  *var_NoSuchObject = call5500;
  if (call5500 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "NoSuchObject"
  block_savedest(self);
  Object closure5501 = createclosure(1, "NoSuchObject");
  setclosureframe(closure5501, stackframe);
  addtoclosure(closure5501, var_NoSuchObject);
  struct UserObject *uo5501 = (struct UserObject*)self;
  uo5501->data[16] = (Object)closure5501;
  Method *meth_meth_collectionsPrelude_NoSuchObject5501 = addmethod2pos(self, "NoSuchObject", &meth_collectionsPrelude_NoSuchObject5501, 16);
  int argcv_meth_collectionsPrelude_NoSuchObject5501[] = {0};
  meth_meth_collectionsPrelude_NoSuchObject5501->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_NoSuchObject5501);
  meth_meth_collectionsPrelude_NoSuchObject5501->definitionModule = modulename;
  meth_meth_collectionsPrelude_NoSuchObject5501->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5502 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5503 == NULL) {
    strlit5503 = alloc_String("RequestError");
    gc_root(strlit5503);
  }
// compiled string node returning strlit5503 (depth = 3)
  gc_frame_newslot(strlit5503);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5504 = gc_frame_new();
// call case 5: prelude request
  Object call5505 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5504);
// compiled member node returning call5505 (depth = 3)
  params[0] = strlit5503;
  partcv[0] = 1;
  Object call5506 = callmethodflags(call5505, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5502);
// compiled call node returning call5506 (depth = 2)
  *var_RequestError = call5506;
  if (call5506 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "RequestError"
  block_savedest(self);
  Object closure5507 = createclosure(1, "RequestError");
  setclosureframe(closure5507, stackframe);
  addtoclosure(closure5507, var_RequestError);
  struct UserObject *uo5507 = (struct UserObject*)self;
  uo5507->data[17] = (Object)closure5507;
  Method *meth_meth_collectionsPrelude_RequestError5507 = addmethod2pos(self, "RequestError", &meth_collectionsPrelude_RequestError5507, 17);
  int argcv_meth_collectionsPrelude_RequestError5507[] = {0};
  meth_meth_collectionsPrelude_RequestError5507->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_RequestError5507);
  meth_meth_collectionsPrelude_RequestError5507->definitionModule = modulename;
  meth_meth_collectionsPrelude_RequestError5507->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5508 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5509 == NULL) {
    strlit5509 = alloc_String("ConcurrentModification");
    gc_root(strlit5509);
  }
// compiled string node returning strlit5509 (depth = 3)
  gc_frame_newslot(strlit5509);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5510 = gc_frame_new();
// call case 5: prelude request
  Object call5511 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5510);
// compiled member node returning call5511 (depth = 3)
  params[0] = strlit5509;
  partcv[0] = 1;
  Object call5512 = callmethodflags(call5511, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5508);
// compiled call node returning call5512 (depth = 2)
  *var_ConcurrentModification = call5512;
  if (call5512 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ConcurrentModification"
  block_savedest(self);
  Object closure5513 = createclosure(1, "ConcurrentModification");
  setclosureframe(closure5513, stackframe);
  addtoclosure(closure5513, var_ConcurrentModification);
  struct UserObject *uo5513 = (struct UserObject*)self;
  uo5513->data[18] = (Object)closure5513;
  Method *meth_meth_collectionsPrelude_ConcurrentModification5513 = addmethod2pos(self, "ConcurrentModification", &meth_collectionsPrelude_ConcurrentModification5513, 18);
  int argcv_meth_collectionsPrelude_ConcurrentModification5513[] = {0};
  meth_meth_collectionsPrelude_ConcurrentModification5513->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_ConcurrentModification5513);
  meth_meth_collectionsPrelude_ConcurrentModification5513->definitionModule = modulename;
  meth_meth_collectionsPrelude_ConcurrentModification5513->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5514 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5515 == NULL) {
    strlit5515 = alloc_String("SizeUnknown");
    gc_root(strlit5515);
  }
// compiled string node returning strlit5515 (depth = 3)
  gc_frame_newslot(strlit5515);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5516 = gc_frame_new();
// call case 5: prelude request
  Object call5517 = callmethodflags(prelude, "Exception", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5516);
// compiled member node returning call5517 (depth = 3)
  params[0] = strlit5515;
  partcv[0] = 1;
  Object call5518 = callmethodflags(call5517, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5514);
// compiled call node returning call5518 (depth = 2)
  *var_SizeUnknown = call5518;
  if (call5518 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "SizeUnknown"
  block_savedest(self);
  Object closure5519 = createclosure(1, "SizeUnknown");
  setclosureframe(closure5519, stackframe);
  addtoclosure(closure5519, var_SizeUnknown);
  struct UserObject *uo5519 = (struct UserObject*)self;
  uo5519->data[19] = (Object)closure5519;
  Method *meth_meth_collectionsPrelude_SizeUnknown5519 = addmethod2pos(self, "SizeUnknown", &meth_collectionsPrelude_SizeUnknown5519, 19);
  int argcv_meth_collectionsPrelude_SizeUnknown5519[] = {0};
  meth_meth_collectionsPrelude_SizeUnknown5519->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_SizeUnknown5519);
  meth_meth_collectionsPrelude_SizeUnknown5519->definitionModule = modulename;
  meth_meth_collectionsPrelude_SizeUnknown5519->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Block0
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5521 = alloc_Type("Block0", 1);
    add_Method((ClassData)type5521, "apply", NULL);
// compiled typeliteral node returning type5521 (depth = 2)
  *var_Block0 = type5521;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Block0"
  block_savedest(self);
  Object closure5522 = createclosure(1, "Block0");
  setclosureframe(closure5522, stackframe);
  addtoclosure(closure5522, var_Block0);
  struct UserObject *uo5522 = (struct UserObject*)self;
  uo5522->data[20] = (Object)closure5522;
  Method *meth_meth_collectionsPrelude_Block05522 = addmethod2pos(self, "Block0", &meth_collectionsPrelude_Block05522, 20);
  int argcv_meth_collectionsPrelude_Block05522[] = {0};
  meth_meth_collectionsPrelude_Block05522->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Block05522);
  meth_meth_collectionsPrelude_Block05522->definitionModule = modulename;
  meth_meth_collectionsPrelude_Block05522->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Block1
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5524 = alloc_Type("Block1", 1);
    add_Method((ClassData)type5524, "apply(1)", NULL);
// compiled typeliteral node returning type5524 (depth = 2)
  *var_Block1 = type5524;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Block1"
  block_savedest(self);
  Object closure5525 = createclosure(1, "Block1");
  setclosureframe(closure5525, stackframe);
  addtoclosure(closure5525, var_Block1);
  struct UserObject *uo5525 = (struct UserObject*)self;
  uo5525->data[21] = (Object)closure5525;
  Method *meth_meth_collectionsPrelude_Block15525 = addmethod2pos(self, "Block1", &meth_collectionsPrelude_Block15525, 21);
  int argcv_meth_collectionsPrelude_Block15525[] = {0};
  meth_meth_collectionsPrelude_Block15525->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Block15525);
  meth_meth_collectionsPrelude_Block15525->definitionModule = modulename;
  meth_meth_collectionsPrelude_Block15525->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Block2
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5527 = alloc_Type("Block2", 1);
    add_Method((ClassData)type5527, "apply(2)", NULL);
// compiled typeliteral node returning type5527 (depth = 2)
  *var_Block2 = type5527;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Block2"
  block_savedest(self);
  Object closure5528 = createclosure(1, "Block2");
  setclosureframe(closure5528, stackframe);
  addtoclosure(closure5528, var_Block2);
  struct UserObject *uo5528 = (struct UserObject*)self;
  uo5528->data[22] = (Object)closure5528;
  Method *meth_meth_collectionsPrelude_Block25528 = addmethod2pos(self, "Block2", &meth_collectionsPrelude_Block25528, 22);
  int argcv_meth_collectionsPrelude_Block25528[] = {0};
  meth_meth_collectionsPrelude_Block25528->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Block25528);
  meth_meth_collectionsPrelude_Block25528->definitionModule = modulename;
  meth_meth_collectionsPrelude_Block25528->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl SelfType
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_Unknown (depth = 2)
  *var_SelfType = *var_Unknown;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "SelfType"
  block_savedest(self);
  Object closure5530 = createclosure(1, "SelfType");
  setclosureframe(closure5530, stackframe);
  addtoclosure(closure5530, var_SelfType);
  struct UserObject *uo5530 = (struct UserObject*)self;
  uo5530->data[23] = (Object)closure5530;
  Method *meth_meth_collectionsPrelude_SelfType5530 = addmethod2pos(self, "SelfType", &meth_collectionsPrelude_SelfType5530, 23);
  int argcv_meth_collectionsPrelude_SelfType5530[] = {0};
  meth_meth_collectionsPrelude_SelfType5530->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_SelfType5530);
  meth_meth_collectionsPrelude_SelfType5530->definitionModule = modulename;
  meth_meth_collectionsPrelude_SelfType5530->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Iterable
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5533 = alloc_Type("‹anon›", 11);
    add_Method((ClassData)type5533, "iterator", NULL);
    add_Method((ClassData)type5533, "isEmpty", NULL);
    add_Method((ClassData)type5533, "size", NULL);
    add_Method((ClassData)type5533, "sizeIfUnknown(1)", NULL);
    add_Method((ClassData)type5533, "first", NULL);
    add_Method((ClassData)type5533, "do(1)", NULL);
    add_Method((ClassData)type5533, "do(1)separatedBy(1)", NULL);
    add_Method((ClassData)type5533, "++(1)", NULL);
    add_Method((ClassData)type5533, "fold(1)startingWith(1)", NULL);
    add_Method((ClassData)type5533, "map(1)", NULL);
    add_Method((ClassData)type5533, "filter(1)", NULL);
// compiled typeliteral node returning type5533 (depth = 3)
  int op_slot_right_5532 = gc_frame_newslot(type5533);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Object (depth = 3)
  int op_slot_left_5532 = gc_frame_newslot(*var_Object);
  params[0] = type5533;
  partcv[0] = 1;
  Object opresult5535 = callmethod(*var_Object, "&(1)", 1, partcv, params);
// compiled op node returning opresult5535 (depth = 2)
  *var_Iterable = opresult5535;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Iterable"
  block_savedest(self);
  Object closure5536 = createclosure(1, "Iterable");
  setclosureframe(closure5536, stackframe);
  addtoclosure(closure5536, var_Iterable);
  struct UserObject *uo5536 = (struct UserObject*)self;
  uo5536->data[24] = (Object)closure5536;
  Method *meth_meth_collectionsPrelude_Iterable5536 = addmethod2pos(self, "Iterable", &meth_collectionsPrelude_Iterable5536, 24);
  int argcv_meth_collectionsPrelude_Iterable5536[] = {0};
  meth_meth_collectionsPrelude_Iterable5536->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Iterable5536);
  meth_meth_collectionsPrelude_Iterable5536->definitionModule = modulename;
  meth_meth_collectionsPrelude_Iterable5536->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Expandable
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5539 = alloc_Type("‹anon›", 2);
    add_Method((ClassData)type5539, "add(1)", NULL);
    add_Method((ClassData)type5539, "addAll(1)", NULL);
// compiled typeliteral node returning type5539 (depth = 3)
  int op_slot_right_5538 = gc_frame_newslot(type5539);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Iterable (depth = 3)
  int op_slot_left_5538 = gc_frame_newslot(*var_Iterable);
  params[0] = type5539;
  partcv[0] = 1;
  Object opresult5541 = callmethod(*var_Iterable, "&(1)", 1, partcv, params);
// compiled op node returning opresult5541 (depth = 2)
  *var_Expandable = opresult5541;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Expandable"
  block_savedest(self);
  Object closure5542 = createclosure(1, "Expandable");
  setclosureframe(closure5542, stackframe);
  addtoclosure(closure5542, var_Expandable);
  struct UserObject *uo5542 = (struct UserObject*)self;
  uo5542->data[25] = (Object)closure5542;
  Method *meth_meth_collectionsPrelude_Expandable5542 = addmethod2pos(self, "Expandable", &meth_collectionsPrelude_Expandable5542, 25);
  int argcv_meth_collectionsPrelude_Expandable5542[] = {0};
  meth_meth_collectionsPrelude_Expandable5542->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Expandable5542);
  meth_meth_collectionsPrelude_Expandable5542->definitionModule = modulename;
  meth_meth_collectionsPrelude_Expandable5542->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Collection
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5545 = alloc_Type("‹anon›", 3);
    add_Method((ClassData)type5545, "asList", NULL);
    add_Method((ClassData)type5545, "asSequence", NULL);
    add_Method((ClassData)type5545, "asSet", NULL);
// compiled typeliteral node returning type5545 (depth = 3)
  int op_slot_right_5544 = gc_frame_newslot(type5545);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Iterable (depth = 3)
  int op_slot_left_5544 = gc_frame_newslot(*var_Iterable);
  params[0] = type5545;
  partcv[0] = 1;
  Object opresult5547 = callmethod(*var_Iterable, "&(1)", 1, partcv, params);
// compiled op node returning opresult5547 (depth = 2)
  *var_Collection = opresult5547;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Collection"
  block_savedest(self);
  Object closure5548 = createclosure(1, "Collection");
  setclosureframe(closure5548, stackframe);
  addtoclosure(closure5548, var_Collection);
  struct UserObject *uo5548 = (struct UserObject*)self;
  uo5548->data[26] = (Object)closure5548;
  Method *meth_meth_collectionsPrelude_Collection5548 = addmethod2pos(self, "Collection", &meth_collectionsPrelude_Collection5548, 26);
  int argcv_meth_collectionsPrelude_Collection5548[] = {0};
  meth_meth_collectionsPrelude_Collection5548->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Collection5548);
  meth_meth_collectionsPrelude_Collection5548->definitionModule = modulename;
  meth_meth_collectionsPrelude_Collection5548->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Enumerable
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5551 = alloc_Type("‹anon›", 6);
    add_Method((ClassData)type5551, "values", NULL);
    add_Method((ClassData)type5551, "asDictionary", NULL);
    add_Method((ClassData)type5551, "keysAndValuesDo(1)", NULL);
    add_Method((ClassData)type5551, "into(1)", NULL);
    add_Method((ClassData)type5551, "sortedBy(1)", NULL);
    add_Method((ClassData)type5551, "sorted", NULL);
// compiled typeliteral node returning type5551 (depth = 3)
  int op_slot_right_5550 = gc_frame_newslot(type5551);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  int op_slot_left_5550 = gc_frame_newslot(*var_Collection);
  params[0] = type5551;
  partcv[0] = 1;
  Object opresult5553 = callmethod(*var_Collection, "&(1)", 1, partcv, params);
// compiled op node returning opresult5553 (depth = 2)
  *var_Enumerable = opresult5553;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Enumerable"
  block_savedest(self);
  Object closure5554 = createclosure(1, "Enumerable");
  setclosureframe(closure5554, stackframe);
  addtoclosure(closure5554, var_Enumerable);
  struct UserObject *uo5554 = (struct UserObject*)self;
  uo5554->data[27] = (Object)closure5554;
  Method *meth_meth_collectionsPrelude_Enumerable5554 = addmethod2pos(self, "Enumerable", &meth_collectionsPrelude_Enumerable5554, 27);
  int argcv_meth_collectionsPrelude_Enumerable5554[] = {0};
  meth_meth_collectionsPrelude_Enumerable5554->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Enumerable5554);
  meth_meth_collectionsPrelude_Enumerable5554->definitionModule = modulename;
  meth_meth_collectionsPrelude_Enumerable5554->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Sequence
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5557 = alloc_Type("‹anon›", 13);
    add_Method((ClassData)type5557, "size", NULL);
    add_Method((ClassData)type5557, "at(1)", NULL);
    add_Method((ClassData)type5557, "indices", NULL);
    add_Method((ClassData)type5557, "keys", NULL);
    add_Method((ClassData)type5557, "second", NULL);
    add_Method((ClassData)type5557, "third", NULL);
    add_Method((ClassData)type5557, "fourth", NULL);
    add_Method((ClassData)type5557, "fifth", NULL);
    add_Method((ClassData)type5557, "last", NULL);
    add_Method((ClassData)type5557, "indexOf(1)ifAbsent(1)", NULL);
    add_Method((ClassData)type5557, "indexOf(1)", NULL);
    add_Method((ClassData)type5557, "contains(1)", NULL);
    add_Method((ClassData)type5557, "reversed", NULL);
// compiled typeliteral node returning type5557 (depth = 3)
  int op_slot_right_5556 = gc_frame_newslot(type5557);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Enumerable (depth = 3)
  int op_slot_left_5556 = gc_frame_newslot(*var_Enumerable);
  params[0] = type5557;
  partcv[0] = 1;
  Object opresult5559 = callmethod(*var_Enumerable, "&(1)", 1, partcv, params);
// compiled op node returning opresult5559 (depth = 2)
  *var_Sequence = opresult5559;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Sequence"
  block_savedest(self);
  Object closure5560 = createclosure(1, "Sequence");
  setclosureframe(closure5560, stackframe);
  addtoclosure(closure5560, var_Sequence);
  struct UserObject *uo5560 = (struct UserObject*)self;
  uo5560->data[28] = (Object)closure5560;
  Method *meth_meth_collectionsPrelude_Sequence5560 = addmethod2pos(self, "Sequence", &meth_collectionsPrelude_Sequence5560, 28);
  int argcv_meth_collectionsPrelude_Sequence5560[] = {0};
  meth_meth_collectionsPrelude_Sequence5560->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Sequence5560);
  meth_meth_collectionsPrelude_Sequence5560->definitionModule = modulename;
  meth_meth_collectionsPrelude_Sequence5560->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl List
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5563 = alloc_Type("‹anon›", 22);
    add_Method((ClassData)type5563, "add(1)", NULL);
    add_Method((ClassData)type5563, "addAll(1)", NULL);
    add_Method((ClassData)type5563, "addFirst(1)", NULL);
    add_Method((ClassData)type5563, "addAllFirst(1)", NULL);
    add_Method((ClassData)type5563, "addLast(1)", NULL);
    add_Method((ClassData)type5563, "at(1)put(1)", NULL);
    add_Method((ClassData)type5563, "clear", NULL);
    add_Method((ClassData)type5563, "removeFirst", NULL);
    add_Method((ClassData)type5563, "removeAt(1)", NULL);
    add_Method((ClassData)type5563, "removeLast", NULL);
    add_Method((ClassData)type5563, "remove(1)", NULL);
    add_Method((ClassData)type5563, "remove(1)ifAbsent(1)", NULL);
    add_Method((ClassData)type5563, "removeAll(1)", NULL);
    add_Method((ClassData)type5563, "removeAll(1)ifAbsent(1)", NULL);
    add_Method((ClassData)type5563, "pop", NULL);
    add_Method((ClassData)type5563, "++(1)", NULL);
    add_Method((ClassData)type5563, "addAll(1)", NULL);
    add_Method((ClassData)type5563, "copy", NULL);
    add_Method((ClassData)type5563, "sort", NULL);
    add_Method((ClassData)type5563, "sortBy(1)", NULL);
    add_Method((ClassData)type5563, "reverse", NULL);
    add_Method((ClassData)type5563, "reversed", NULL);
// compiled typeliteral node returning type5563 (depth = 3)
  int op_slot_right_5562 = gc_frame_newslot(type5563);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Sequence (depth = 3)
  int op_slot_left_5562 = gc_frame_newslot(*var_Sequence);
  params[0] = type5563;
  partcv[0] = 1;
  Object opresult5565 = callmethod(*var_Sequence, "&(1)", 1, partcv, params);
// compiled op node returning opresult5565 (depth = 2)
  *var_List = opresult5565;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "List"
  block_savedest(self);
  Object closure5566 = createclosure(1, "List");
  setclosureframe(closure5566, stackframe);
  addtoclosure(closure5566, var_List);
  struct UserObject *uo5566 = (struct UserObject*)self;
  uo5566->data[29] = (Object)closure5566;
  Method *meth_meth_collectionsPrelude_List5566 = addmethod2pos(self, "List", &meth_collectionsPrelude_List5566, 29);
  int argcv_meth_collectionsPrelude_List5566[] = {0};
  meth_meth_collectionsPrelude_List5566->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_List5566);
  meth_meth_collectionsPrelude_List5566->definitionModule = modulename;
  meth_meth_collectionsPrelude_List5566->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 116
  setline(116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Set
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5569 = alloc_Type("‹anon›", 18);
    add_Method((ClassData)type5569, "size", NULL);
    add_Method((ClassData)type5569, "add(1)", NULL);
    add_Method((ClassData)type5569, "addAll(1)", NULL);
    add_Method((ClassData)type5569, "remove(1)", NULL);
    add_Method((ClassData)type5569, "remove(1)ifAbsent(1)", NULL);
    add_Method((ClassData)type5569, "clear", NULL);
    add_Method((ClassData)type5569, "includes(1)", NULL);
    add_Method((ClassData)type5569, "find(1)ifNone(1)", NULL);
    add_Method((ClassData)type5569, "copy", NULL);
    add_Method((ClassData)type5569, "contains(1)", NULL);
    add_Method((ClassData)type5569, "**(1)", NULL);
    add_Method((ClassData)type5569, "--(1)", NULL);
    add_Method((ClassData)type5569, "++(1)", NULL);
    add_Method((ClassData)type5569, "isSubset(1)", NULL);
    add_Method((ClassData)type5569, "isSuperset(1)", NULL);
    add_Method((ClassData)type5569, "removeAll(1)", NULL);
    add_Method((ClassData)type5569, "removeAll(1)ifAbsent(1)", NULL);
    add_Method((ClassData)type5569, "into(1)", NULL);
// compiled typeliteral node returning type5569 (depth = 3)
  int op_slot_right_5568 = gc_frame_newslot(type5569);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  int op_slot_left_5568 = gc_frame_newslot(*var_Collection);
  params[0] = type5569;
  partcv[0] = 1;
  Object opresult5571 = callmethod(*var_Collection, "&(1)", 1, partcv, params);
// compiled op node returning opresult5571 (depth = 2)
  *var_Set = opresult5571;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Set"
  block_savedest(self);
  Object closure5572 = createclosure(1, "Set");
  setclosureframe(closure5572, stackframe);
  addtoclosure(closure5572, var_Set);
  struct UserObject *uo5572 = (struct UserObject*)self;
  uo5572->data[30] = (Object)closure5572;
  Method *meth_meth_collectionsPrelude_Set5572 = addmethod2pos(self, "Set", &meth_collectionsPrelude_Set5572, 30);
  int argcv_meth_collectionsPrelude_Set5572[] = {0};
  meth_meth_collectionsPrelude_Set5572->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Set5572);
  meth_meth_collectionsPrelude_Set5572->definitionModule = modulename;
  meth_meth_collectionsPrelude_Set5572->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Dictionary
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5575 = alloc_Type("‹anon›", 23);
    add_Method((ClassData)type5575, "size", NULL);
    add_Method((ClassData)type5575, "containsKey(1)", NULL);
    add_Method((ClassData)type5575, "containsValue(1)", NULL);
    add_Method((ClassData)type5575, "contains(1)", NULL);
    add_Method((ClassData)type5575, "at(1)ifAbsent(1)", NULL);
    add_Method((ClassData)type5575, "at(1)put(1)", NULL);
    add_Method((ClassData)type5575, "at(1)", NULL);
    add_Method((ClassData)type5575, "removeAllKeys(1)", NULL);
    add_Method((ClassData)type5575, "removeKey(1)", NULL);
    add_Method((ClassData)type5575, "removeAllValues(1)", NULL);
    add_Method((ClassData)type5575, "removeValue(1)", NULL);
    add_Method((ClassData)type5575, "clear", NULL);
    add_Method((ClassData)type5575, "keys", NULL);
    add_Method((ClassData)type5575, "values", NULL);
    add_Method((ClassData)type5575, "bindings", NULL);
    add_Method((ClassData)type5575, "keysAndValuesDo(1)", NULL);
    add_Method((ClassData)type5575, "keysDo(1)", NULL);
    add_Method((ClassData)type5575, "valuesDo(1)", NULL);
    add_Method((ClassData)type5575, "==(1)", NULL);
    add_Method((ClassData)type5575, "copy", NULL);
    add_Method((ClassData)type5575, "++(1)", NULL);
    add_Method((ClassData)type5575, "--(1)", NULL);
    add_Method((ClassData)type5575, "asDictionary", NULL);
// compiled typeliteral node returning type5575 (depth = 3)
  int op_slot_right_5574 = gc_frame_newslot(type5575);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  int op_slot_left_5574 = gc_frame_newslot(*var_Collection);
  params[0] = type5575;
  partcv[0] = 1;
  Object opresult5577 = callmethod(*var_Collection, "&(1)", 1, partcv, params);
// compiled op node returning opresult5577 (depth = 2)
  *var_Dictionary = opresult5577;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Dictionary"
  block_savedest(self);
  Object closure5578 = createclosure(1, "Dictionary");
  setclosureframe(closure5578, stackframe);
  addtoclosure(closure5578, var_Dictionary);
  struct UserObject *uo5578 = (struct UserObject*)self;
  uo5578->data[31] = (Object)closure5578;
  Method *meth_meth_collectionsPrelude_Dictionary5578 = addmethod2pos(self, "Dictionary", &meth_collectionsPrelude_Dictionary5578, 31);
  int argcv_meth_collectionsPrelude_Dictionary5578[] = {0};
  meth_meth_collectionsPrelude_Dictionary5578->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Dictionary5578);
  meth_meth_collectionsPrelude_Dictionary5578->definitionModule = modulename;
  meth_meth_collectionsPrelude_Dictionary5578->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 163
  setline(163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Iterator
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5580 = alloc_Type("Iterator", 2);
    add_Method((ClassData)type5580, "hasNext", NULL);
    add_Method((ClassData)type5580, "next", NULL);
// compiled typeliteral node returning type5580 (depth = 2)
  *var_Iterator = type5580;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Iterator"
  block_savedest(self);
  Object closure5581 = createclosure(1, "Iterator");
  setclosureframe(closure5581, stackframe);
  addtoclosure(closure5581, var_Iterator);
  struct UserObject *uo5581 = (struct UserObject*)self;
  uo5581->data[32] = (Object)closure5581;
  Method *meth_meth_collectionsPrelude_Iterator5581 = addmethod2pos(self, "Iterator", &meth_collectionsPrelude_Iterator5581, 32);
  int argcv_meth_collectionsPrelude_Iterator5581[] = {0};
  meth_meth_collectionsPrelude_Iterator5581->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Iterator5581);
  meth_meth_collectionsPrelude_Iterator5581->definitionModule = modulename;
  meth_meth_collectionsPrelude_Iterator5581->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5582 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5582 = alloc_userobj2(3,4, objclass5582);
  gc_frame_newslot(obj5582);
if (objclass5582 == NULL) {
  glfree(obj5582->class->name);
  obj5582->class->name = "collection";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5582, self, 0);
  addmethodreal(obj5582,"outer", &reader_collectionsPrelude_outer_5583);
  Object oldself5582 = self;
  struct StackFrameObject *oldstackframe5582 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5582);
  gc_frame_newslot((Object)stackframe);
  self = obj5582;
  Object *oldselfslot5582 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5582 = (*(struct UserObject *)self).data[0], lowerouter5582 = thisouter5582;
  if (inheritingObject5582) {
    struct UserObject *inho5582 = (struct UserObject *)inheritingObject5582;
    while (inho5582->super != GraceDefaultObject) inho5582 = (struct UserObject *)inho5582->super;
    inho5582->super = obj5582;
    self = inheritingObject5582;
    *selfslot = self;
    lowerouter5582 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5582;
  }
// method "TRAIT"
  block_savedest(obj5582);
  Object closure5584 = createclosure(2, "TRAIT");
  setclosureframe(closure5584, stackframe);
  addtoclosure(closure5584, var_SizeUnknown);
  addtoclosure(closure5584, var_BoundsError);
  struct UserObject *uo5584 = (struct UserObject*)obj5582;
  uo5584->data[1] = (Object)closure5584;
  Method *meth_meth_collectionsPrelude_TRAIT5584 = addmethod2pos(obj5582, "TRAIT", &meth_collectionsPrelude_TRAIT5584, 1);
  int argcv_meth_collectionsPrelude_TRAIT5584[] = {0};
  meth_meth_collectionsPrelude_TRAIT5584->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_TRAIT5584);
  meth_meth_collectionsPrelude_TRAIT5584->definitionModule = modulename;
  meth_meth_collectionsPrelude_TRAIT5584->definitionLine = 253;
  block_savedest(obj5582);
  Object closure5706 = createclosure(2, "TRAIT$object(1)");
  setclosureframe(closure5706, stackframe);
  addtoclosure(closure5706, var_SizeUnknown);
  addtoclosure(closure5706, var_BoundsError);
  Method *meth_meth_collectionsPrelude_TRAIT5584_object = addmethod2pos(obj5582, "TRAIT$object(1)", &meth_collectionsPrelude_TRAIT5584_object, 1);
  meth_meth_collectionsPrelude_TRAIT5584_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_TRAIT5584_object->definitionLine = 253;
// method "asString"
  struct UserObject *uo5707 = (struct UserObject*)obj5582;
  uo5707->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5707 = addmethod2pos(obj5582, "asString", &meth_collectionsPrelude_asString5707, 2);
  int argcv_meth_collectionsPrelude_asString5707[] = {0};
  meth_meth_collectionsPrelude_asString5707->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5707);
  meth_meth_collectionsPrelude_asString5707->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5707->definitionLine = 253;
  sourceObject = obj5582;
  sourceObject = obj5582;
  objclass5582 = obj5582->class;
  objclass5582->definitionModule = modulename;
  objclass5582->definitionLine = 253;
  (*(struct UserObject *)self).data[0] = lowerouter5582;
  self = oldself5582;
  selfslot = oldselfslot5582;
  stackframe = oldstackframe5582;
// compiled object node returning obj5582 (depth = 2)
  *var_collection = obj5582;
  if (obj5582 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "collection"
  block_savedest(self);
  Object closure5709 = createclosure(1, "collection");
  setclosureframe(closure5709, stackframe);
  addtoclosure(closure5709, var_collection);
  struct UserObject *uo5709 = (struct UserObject*)self;
  uo5709->data[33] = (Object)closure5709;
  Method *meth_meth_collectionsPrelude_collection5709 = addmethod2pos(self, "collection", &meth_collectionsPrelude_collection5709, 33);
  int argcv_meth_collectionsPrelude_collection5709[] = {0};
  meth_meth_collectionsPrelude_collection5709->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_collection5709);
  meth_meth_collectionsPrelude_collection5709->definitionModule = modulename;
  meth_meth_collectionsPrelude_collection5709->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5710 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5710 = alloc_userobj2(3,4, objclass5710);
  gc_frame_newslot(obj5710);
if (objclass5710 == NULL) {
  glfree(obj5710->class->name);
  obj5710->class->name = "enumerable";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5710, self, 0);
  addmethodreal(obj5710,"outer", &reader_collectionsPrelude_outer_5711);
  Object oldself5710 = self;
  struct StackFrameObject *oldstackframe5710 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5710);
  gc_frame_newslot((Object)stackframe);
  self = obj5710;
  Object *oldselfslot5710 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5710 = (*(struct UserObject *)self).data[0], lowerouter5710 = thisouter5710;
  if (inheritingObject5710) {
    struct UserObject *inho5710 = (struct UserObject *)inheritingObject5710;
    while (inho5710->super != GraceDefaultObject) inho5710 = (struct UserObject *)inho5710->super;
    inho5710->super = obj5710;
    self = inheritingObject5710;
    *selfslot = self;
    lowerouter5710 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5710;
  }
// method "TRAIT"
  block_savedest(obj5710);
  Object closure5712 = createclosure(2, "TRAIT");
  setclosureframe(closure5712, stackframe);
  addtoclosure(closure5712, var_SizeUnknown);
  addtoclosure(closure5712, var_collection);
  struct UserObject *uo5712 = (struct UserObject*)obj5710;
  uo5712->data[1] = (Object)closure5712;
  Method *meth_meth_collectionsPrelude_TRAIT5712 = addmethod2pos(obj5710, "TRAIT", &meth_collectionsPrelude_TRAIT5712, 1);
  int argcv_meth_collectionsPrelude_TRAIT5712[] = {0};
  meth_meth_collectionsPrelude_TRAIT5712->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_TRAIT5712);
  meth_meth_collectionsPrelude_TRAIT5712->definitionModule = modulename;
  meth_meth_collectionsPrelude_TRAIT5712->definitionLine = 320;
  block_savedest(obj5710);
  Object closure5878 = createclosure(2, "TRAIT$object(1)");
  setclosureframe(closure5878, stackframe);
  addtoclosure(closure5878, var_SizeUnknown);
  addtoclosure(closure5878, var_collection);
  Method *meth_meth_collectionsPrelude_TRAIT5712_object = addmethod2pos(obj5710, "TRAIT$object(1)", &meth_collectionsPrelude_TRAIT5712_object, 1);
  meth_meth_collectionsPrelude_TRAIT5712_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_TRAIT5712_object->definitionLine = 320;
// method "asString"
  struct UserObject *uo5879 = (struct UserObject*)obj5710;
  uo5879->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5879 = addmethod2pos(obj5710, "asString", &meth_collectionsPrelude_asString5879, 2);
  int argcv_meth_collectionsPrelude_asString5879[] = {0};
  meth_meth_collectionsPrelude_asString5879->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5879);
  meth_meth_collectionsPrelude_asString5879->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5879->definitionLine = 320;
  sourceObject = obj5710;
  sourceObject = obj5710;
  objclass5710 = obj5710->class;
  objclass5710->definitionModule = modulename;
  objclass5710->definitionLine = 320;
  (*(struct UserObject *)self).data[0] = lowerouter5710;
  self = oldself5710;
  selfslot = oldselfslot5710;
  stackframe = oldstackframe5710;
// compiled object node returning obj5710 (depth = 2)
  *var_enumerable = obj5710;
  if (obj5710 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "enumerable"
  block_savedest(self);
  Object closure5881 = createclosure(1, "enumerable");
  setclosureframe(closure5881, stackframe);
  addtoclosure(closure5881, var_enumerable);
  struct UserObject *uo5881 = (struct UserObject*)self;
  uo5881->data[34] = (Object)closure5881;
  Method *meth_meth_collectionsPrelude_enumerable5881 = addmethod2pos(self, "enumerable", &meth_collectionsPrelude_enumerable5881, 34);
  int argcv_meth_collectionsPrelude_enumerable5881[] = {0};
  meth_meth_collectionsPrelude_enumerable5881->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_enumerable5881);
  meth_meth_collectionsPrelude_enumerable5881->definitionModule = modulename;
  meth_meth_collectionsPrelude_enumerable5881->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5882 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5882 = alloc_userobj2(3,4, objclass5882);
  gc_frame_newslot(obj5882);
if (objclass5882 == NULL) {
  glfree(obj5882->class->name);
  obj5882->class->name = "indexable";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5882, self, 0);
  addmethodreal(obj5882,"outer", &reader_collectionsPrelude_outer_5883);
  Object oldself5882 = self;
  struct StackFrameObject *oldstackframe5882 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5882);
  gc_frame_newslot((Object)stackframe);
  self = obj5882;
  Object *oldselfslot5882 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5882 = (*(struct UserObject *)self).data[0], lowerouter5882 = thisouter5882;
  if (inheritingObject5882) {
    struct UserObject *inho5882 = (struct UserObject *)inheritingObject5882;
    while (inho5882->super != GraceDefaultObject) inho5882 = (struct UserObject *)inho5882->super;
    inho5882->super = obj5882;
    self = inheritingObject5882;
    *selfslot = self;
    lowerouter5882 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5882;
  }
// method "TRAIT"
  block_savedest(obj5882);
  Object closure5884 = createclosure(2, "TRAIT");
  setclosureframe(closure5884, stackframe);
  addtoclosure(closure5884, var_NoSuchObject);
  addtoclosure(closure5884, var_collection);
  struct UserObject *uo5884 = (struct UserObject*)obj5882;
  uo5884->data[1] = (Object)closure5884;
  Method *meth_meth_collectionsPrelude_TRAIT5884 = addmethod2pos(obj5882, "TRAIT", &meth_collectionsPrelude_TRAIT5884, 1);
  int argcv_meth_collectionsPrelude_TRAIT5884[] = {0};
  meth_meth_collectionsPrelude_TRAIT5884->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_TRAIT5884);
  meth_meth_collectionsPrelude_TRAIT5884->definitionModule = modulename;
  meth_meth_collectionsPrelude_TRAIT5884->definitionLine = 385;
  block_savedest(obj5882);
  Object closure6032 = createclosure(2, "TRAIT$object(1)");
  setclosureframe(closure6032, stackframe);
  addtoclosure(closure6032, var_NoSuchObject);
  addtoclosure(closure6032, var_collection);
  Method *meth_meth_collectionsPrelude_TRAIT5884_object = addmethod2pos(obj5882, "TRAIT$object(1)", &meth_collectionsPrelude_TRAIT5884_object, 1);
  meth_meth_collectionsPrelude_TRAIT5884_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_TRAIT5884_object->definitionLine = 385;
// method "asString"
  struct UserObject *uo6033 = (struct UserObject*)obj5882;
  uo6033->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString6033 = addmethod2pos(obj5882, "asString", &meth_collectionsPrelude_asString6033, 2);
  int argcv_meth_collectionsPrelude_asString6033[] = {0};
  meth_meth_collectionsPrelude_asString6033->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6033);
  meth_meth_collectionsPrelude_asString6033->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6033->definitionLine = 385;
  sourceObject = obj5882;
  sourceObject = obj5882;
  objclass5882 = obj5882->class;
  objclass5882->definitionModule = modulename;
  objclass5882->definitionLine = 385;
  (*(struct UserObject *)self).data[0] = lowerouter5882;
  self = oldself5882;
  selfslot = oldselfslot5882;
  stackframe = oldstackframe5882;
// compiled object node returning obj5882 (depth = 2)
  *var_indexable = obj5882;
  if (obj5882 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "indexable"
  block_savedest(self);
  Object closure6035 = createclosure(1, "indexable");
  setclosureframe(closure6035, stackframe);
  addtoclosure(closure6035, var_indexable);
  struct UserObject *uo6035 = (struct UserObject*)self;
  uo6035->data[35] = (Object)closure6035;
  Method *meth_meth_collectionsPrelude_indexable6035 = addmethod2pos(self, "indexable", &meth_collectionsPrelude_indexable6035, 35);
  int argcv_meth_collectionsPrelude_indexable6035[] = {0};
  meth_meth_collectionsPrelude_indexable6035->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indexable6035);
  meth_meth_collectionsPrelude_indexable6035->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexable6035->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6036 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6036 = alloc_userobj2(16,17, objclass6036);
  gc_frame_newslot(obj6036);
if (objclass6036 == NULL) {
  glfree(obj6036->class->name);
  obj6036->class->name = "emptySequence";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6036, self, 0);
  addmethodreal(obj6036,"outer", &reader_collectionsPrelude_outer_6037);
  Object oldself6036 = self;
  struct StackFrameObject *oldstackframe6036 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6036);
  gc_frame_newslot((Object)stackframe);
  self = obj6036;
  Object *oldselfslot6036 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6036 = (*(struct UserObject *)self).data[0], lowerouter6036 = thisouter6036;
  if (inheritingObject6036) {
    struct UserObject *inho6036 = (struct UserObject *)inheritingObject6036;
    while (inho6036->super != GraceDefaultObject) inho6036 = (struct UserObject *)inho6036->super;
    inho6036->super = obj6036;
    self = inheritingObject6036;
    *selfslot = self;
    lowerouter6036 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6036;
  }
// method "size"
  struct UserObject *uo6038 = (struct UserObject*)obj6036;
  uo6038->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size6038 = addmethod2pos(obj6036, "size", &meth_collectionsPrelude_size6038, 1);
  int argcv_meth_collectionsPrelude_size6038[] = {0};
  meth_meth_collectionsPrelude_size6038->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size6038);
  meth_meth_collectionsPrelude_size6038->definitionModule = modulename;
  meth_meth_collectionsPrelude_size6038->definitionLine = 436;
// method "isEmpty"
  struct UserObject *uo6040 = (struct UserObject*)obj6036;
  uo6040->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty6040 = addmethod2pos(obj6036, "isEmpty", &meth_collectionsPrelude_isEmpty6040, 2);
  int argcv_meth_collectionsPrelude_isEmpty6040[] = {0};
  meth_meth_collectionsPrelude_isEmpty6040->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty6040);
  meth_meth_collectionsPrelude_isEmpty6040->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty6040->definitionLine = 437;
// method "at(_)"
  block_savedest(obj6036);
  Object closure6042 = createclosure(1, "at(1)");
  setclosureframe(closure6042, stackframe);
  addtoclosure(closure6042, var_BoundsError);
  struct UserObject *uo6042 = (struct UserObject*)obj6036;
  uo6042->data[3] = (Object)closure6042;
  Method *meth_meth_collectionsPrelude_at_40_1_41_6042 = addmethod2pos(obj6036, "at(1)", &meth_collectionsPrelude_at_40_1_41_6042, 3);
  int argcv_meth_collectionsPrelude_at_40_1_41_6042[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_6042->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_6042);
  meth_meth_collectionsPrelude_at_40_1_41_6042->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_6042->definitionLine = 438;
// method "keys"
  struct UserObject *uo6053 = (struct UserObject*)obj6036;
  uo6053->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys6053 = addmethod2pos(obj6036, "keys", &meth_collectionsPrelude_keys6053, 4);
  int argcv_meth_collectionsPrelude_keys6053[] = {0};
  meth_meth_collectionsPrelude_keys6053->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys6053);
  meth_meth_collectionsPrelude_keys6053->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys6053->definitionLine = 439;
// method "values"
  struct UserObject *uo6054 = (struct UserObject*)obj6036;
  uo6054->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values6054 = addmethod2pos(obj6036, "values", &meth_collectionsPrelude_values6054, 5);
  int argcv_meth_collectionsPrelude_values6054[] = {0};
  meth_meth_collectionsPrelude_values6054->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values6054);
  meth_meth_collectionsPrelude_values6054->definitionModule = modulename;
  meth_meth_collectionsPrelude_values6054->definitionLine = 440;
// method "keysAndValuesDo(_)"
  block_savedest(obj6036);
  Object closure6055 = createclosure(1, "keysAndValuesDo(1)");
  setclosureframe(closure6055, stackframe);
  addtoclosure(closure6055, var_done);
  struct UserObject *uo6055 = (struct UserObject*)obj6036;
  uo6055->data[6] = (Object)closure6055;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_6055 = addmethod2pos(obj6036, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_6055, 6);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_6055[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_6055->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_6055);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_6055->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_6055->definitionLine = 441;
// method "reversed"
  struct UserObject *uo6056 = (struct UserObject*)obj6036;
  uo6056->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed6056 = addmethod2pos(obj6036, "reversed", &meth_collectionsPrelude_reversed6056, 7);
  int argcv_meth_collectionsPrelude_reversed6056[] = {0};
  meth_meth_collectionsPrelude_reversed6056->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed6056);
  meth_meth_collectionsPrelude_reversed6056->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed6056->definitionLine = 442;
// method "++(_)"
  struct UserObject *uo6057 = (struct UserObject*)obj6036;
  uo6057->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_6057 = addmethod2pos(obj6036, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_6057, 8);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_6057[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_6057->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_6057);
  meth_meth_collectionsPrelude__43__43__40_1_41_6057->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_6057->definitionLine = 443;
// method "asString"
  struct UserObject *uo6064 = (struct UserObject*)obj6036;
  uo6064->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString6064 = addmethod2pos(obj6036, "asString", &meth_collectionsPrelude_asString6064, 9);
  int argcv_meth_collectionsPrelude_asString6064[] = {0};
  meth_meth_collectionsPrelude_asString6064->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6064);
  meth_meth_collectionsPrelude_asString6064->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6064->definitionLine = 444;
// method "contains(_)"
  struct UserObject *uo6066 = (struct UserObject*)obj6036;
  uo6066->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_6066 = addmethod2pos(obj6036, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_6066, 10);
  int argcv_meth_collectionsPrelude_contains_40_1_41_6066[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_6066->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_6066);
  meth_meth_collectionsPrelude_contains_40_1_41_6066->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_6066->definitionLine = 445;
// method "do(_)"
  block_savedest(obj6036);
  Object closure6068 = createclosure(1, "do(1)");
  setclosureframe(closure6068, stackframe);
  addtoclosure(closure6068, var_done);
  struct UserObject *uo6068 = (struct UserObject*)obj6036;
  uo6068->data[11] = (Object)closure6068;
  Method *meth_meth_collectionsPrelude_do_40_1_41_6068 = addmethod2pos(obj6036, "do(1)", &meth_collectionsPrelude_do_40_1_41_6068, 11);
  int argcv_meth_collectionsPrelude_do_40_1_41_6068[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_6068->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_6068);
  meth_meth_collectionsPrelude_do_40_1_41_6068->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_6068->definitionLine = 446;
// method "==(_)"
  block_savedest(obj6036);
  Object closure6069 = createclosure(1, "==(1)");
  setclosureframe(closure6069, stackframe);
  addtoclosure(closure6069, var_Iterable);
  struct UserObject *uo6069 = (struct UserObject*)obj6036;
  uo6069->data[12] = (Object)closure6069;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_6069 = addmethod2pos(obj6036, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_6069, 12);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_6069[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_6069->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_6069);
  meth_meth_collectionsPrelude__61__61__40_1_41_6069->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_6069->definitionLine = 447;
// method "iterator"
  block_savedest(obj6036);
  Object closure6089 = createclosure(1, "iterator");
  setclosureframe(closure6089, stackframe);
  addtoclosure(closure6089, var_IteratorExhausted);
  struct UserObject *uo6089 = (struct UserObject*)obj6036;
  uo6089->data[13] = (Object)closure6089;
  Method *meth_meth_collectionsPrelude_iterator6089 = addmethod2pos(obj6036, "iterator", &meth_collectionsPrelude_iterator6089, 13);
  int argcv_meth_collectionsPrelude_iterator6089[] = {0};
  meth_meth_collectionsPrelude_iterator6089->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator6089);
  meth_meth_collectionsPrelude_iterator6089->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator6089->definitionLine = 456;
  block_savedest(obj6036);
  Object closure6100 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure6100, stackframe);
  addtoclosure(closure6100, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator6089_object = addmethod2pos(obj6036, "iterator$object(1)", &meth_collectionsPrelude_iterator6089_object, 13);
  meth_meth_collectionsPrelude_iterator6089_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator6089_object->definitionLine = 456;
// method "sorted"
  struct UserObject *uo6101 = (struct UserObject*)obj6036;
  uo6101->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted6101 = addmethod2pos(obj6036, "sorted", &meth_collectionsPrelude_sorted6101, 14);
  int argcv_meth_collectionsPrelude_sorted6101[] = {0};
  meth_meth_collectionsPrelude_sorted6101->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted6101);
  meth_meth_collectionsPrelude_sorted6101->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted6101->definitionLine = 461;
// method "sortedBy(_)"
  struct UserObject *uo6102 = (struct UserObject*)obj6036;
  uo6102->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_6102 = addmethod2pos(obj6036, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_6102, 15);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_6102[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_6102->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_6102);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_6102->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_6102->definitionLine = 462;
  sourceObject = obj6036;
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6103 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_indexable (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6104 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6103);
// compiled call node returning call6104 (depth = 3)
  struct UserObject *obj6036_uo = (struct UserObject *)obj6036;
  obj6036_uo->super = call6104;
  sourceObject = obj6036;
  sourceObject = obj6036;
  sourceObject = obj6036;
  sourceObject = obj6036;
  sourceObject = obj6036;
  sourceObject = obj6036;
  sourceObject = obj6036;
  sourceObject = obj6036;
  sourceObject = obj6036;
  sourceObject = obj6036;
  sourceObject = obj6036;
  sourceObject = obj6036;
  sourceObject = obj6036;
  sourceObject = obj6036;
  sourceObject = obj6036;
  objclass6036 = obj6036->class;
  objclass6036->definitionModule = modulename;
  objclass6036->definitionLine = 434;
  (*(struct UserObject *)self).data[0] = lowerouter6036;
  self = oldself6036;
  selfslot = oldselfslot6036;
  stackframe = oldstackframe6036;
// compiled object node returning obj6036 (depth = 2)
  *var_emptySequence = obj6036;
  if (obj6036 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "emptySequence"
  block_savedest(self);
  Object closure6105 = createclosure(1, "emptySequence");
  setclosureframe(closure6105, stackframe);
  addtoclosure(closure6105, var_emptySequence);
  struct UserObject *uo6105 = (struct UserObject*)self;
  uo6105->data[36] = (Object)closure6105;
  Method *meth_meth_collectionsPrelude_emptySequence6105 = addmethod2pos(self, "emptySequence", &meth_collectionsPrelude_emptySequence6105, 36);
  int argcv_meth_collectionsPrelude_emptySequence6105[] = {0};
  meth_meth_collectionsPrelude_emptySequence6105->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_emptySequence6105);
  meth_meth_collectionsPrelude_emptySequence6105->definitionModule = modulename;
  meth_meth_collectionsPrelude_emptySequence6105->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl MinimalyIterable
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type6107 = alloc_Type("MinimalyIterable", 1);
    add_Method((ClassData)type6107, "iterator", NULL);
// compiled typeliteral node returning type6107 (depth = 2)
  *var_MinimalyIterable = type6107;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "MinimalyIterable"
  block_savedest(self);
  Object closure6108 = createclosure(1, "MinimalyIterable");
  setclosureframe(closure6108, stackframe);
  addtoclosure(closure6108, var_MinimalyIterable);
  struct UserObject *uo6108 = (struct UserObject*)self;
  uo6108->data[37] = (Object)closure6108;
  Method *meth_meth_collectionsPrelude_MinimalyIterable6108 = addmethod2pos(self, "MinimalyIterable", &meth_collectionsPrelude_MinimalyIterable6108, 37);
  int argcv_meth_collectionsPrelude_MinimalyIterable6108[] = {0};
  meth_meth_collectionsPrelude_MinimalyIterable6108->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_MinimalyIterable6108);
  meth_meth_collectionsPrelude_MinimalyIterable6108->definitionModule = modulename;
  meth_meth_collectionsPrelude_MinimalyIterable6108->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6109 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6109 = alloc_userobj2(6,6, objclass6109);
  gc_frame_newslot(obj6109);
if (objclass6109 == NULL) {
  glfree(obj6109->class->name);
  obj6109->class->name = "unused";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6109, self, 0);
  addmethodreal(obj6109,"outer", &reader_collectionsPrelude_outer_6110);
  Object oldself6109 = self;
  struct StackFrameObject *oldstackframe6109 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6109);
  gc_frame_newslot((Object)stackframe);
  self = obj6109;
  Object *oldselfslot6109 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6109 = (*(struct UserObject *)self).data[0], lowerouter6109 = thisouter6109;
  if (inheritingObject6109) {
    struct UserObject *inho6109 = (struct UserObject *)inheritingObject6109;
    while (inho6109->super != GraceDefaultObject) inho6109 = (struct UserObject *)inho6109->super;
    inho6109->super = obj6109;
    self = inheritingObject6109;
    *selfslot = self;
    lowerouter6109 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6109;
  }
if (objclass6109 == NULL) {
  Method *reader6111 = addmethodrealflags(obj6109, "unused", &reader_collectionsPrelude_unused_6111, MFLAG_CONFIDENTIAL);
  Method *writer6111 = addmethodrealflags(obj6109, "unused:=(1)", &writer_collectionsPrelude_unused_6111, MFLAG_CONFIDENTIAL);
  reader6111->definitionModule = modulename;
  writer6111->definitionModule = modulename;
  reader6111->definitionLine = 1170;
  writer6111->definitionLine = 1170;
}
obj6109->flags |= OFLAG_MUTABLE;
adddatum2(obj6109, alloc_Undefined(), 1);
if (objclass6109 == NULL) {
  Method *reader6112 = addmethodrealflags(obj6109, "key",&reader_collectionsPrelude_key_6112, MFLAG_DEF);
  reader6112->definitionModule = modulename;
  reader6112->definitionLine = 1171;
}
adddatum2(obj6109, alloc_Undefined(), 2);
if (objclass6109 == NULL) {
  Method *reader6113 = addmethodrealflags(obj6109, "value",&reader_collectionsPrelude_value_6113, MFLAG_DEF);
  reader6113->definitionModule = modulename;
  reader6113->definitionLine = 1172;
}
adddatum2(obj6109, alloc_Undefined(), 3);
// method "asString"
  struct UserObject *uo6114 = (struct UserObject*)obj6109;
  uo6114->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString6114 = addmethod2pos(obj6109, "asString", &meth_collectionsPrelude_asString6114, 4);
  int argcv_meth_collectionsPrelude_asString6114[] = {0};
  meth_meth_collectionsPrelude_asString6114->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6114);
  meth_meth_collectionsPrelude_asString6114->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6114->definitionLine = 1173;
// method "==(_)"
  struct UserObject *uo6116 = (struct UserObject*)obj6109;
  uo6116->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_6116 = addmethod2pos(obj6109, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_6116, 5);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_6116[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_6116->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_6116);
  meth_meth_collectionsPrelude__61__61__40_1_41_6116->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_6116->definitionLine = 1174;
  sourceObject = obj6109;
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6119 = alloc_Boolean(1);
// compiled identifier node returning bool6119 (depth = 3)
  adddatum2(obj6109, bool6119, 1);
  sourceObject = obj6109;
// Begin line 1171
  setline(1171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  adddatum2(obj6109, self, 2);
  sourceObject = obj6109;
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  adddatum2(obj6109, self, 3);
  sourceObject = obj6109;
  sourceObject = obj6109;
  objclass6109 = obj6109->class;
  objclass6109->definitionModule = modulename;
  objclass6109->definitionLine = 1169;
  (*(struct UserObject *)self).data[0] = lowerouter6109;
  self = oldself6109;
  selfslot = oldselfslot6109;
  stackframe = oldstackframe6109;
// compiled object node returning obj6109 (depth = 2)
  *var_unused = obj6109;
  if (obj6109 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "unused"
  block_savedest(self);
  Object closure6120 = createclosure(1, "unused");
  setclosureframe(closure6120, stackframe);
  addtoclosure(closure6120, var_unused);
  struct UserObject *uo6120 = (struct UserObject*)self;
  uo6120->data[38] = (Object)closure6120;
  Method *meth_meth_collectionsPrelude_unused6120 = addmethod2pos(self, "unused", &meth_collectionsPrelude_unused6120, 38);
  int argcv_meth_collectionsPrelude_unused6120[] = {0};
  meth_meth_collectionsPrelude_unused6120->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_unused6120);
  meth_meth_collectionsPrelude_unused6120->definitionModule = modulename;
  meth_meth_collectionsPrelude_unused6120->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1176
  setline(1176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6121 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6121 = alloc_userobj2(6,6, objclass6121);
  gc_frame_newslot(obj6121);
if (objclass6121 == NULL) {
  glfree(obj6121->class->name);
  obj6121->class->name = "removed";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6121, self, 0);
  addmethodreal(obj6121,"outer", &reader_collectionsPrelude_outer_6122);
  Object oldself6121 = self;
  struct StackFrameObject *oldstackframe6121 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6121);
  gc_frame_newslot((Object)stackframe);
  self = obj6121;
  Object *oldselfslot6121 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6121 = (*(struct UserObject *)self).data[0], lowerouter6121 = thisouter6121;
  if (inheritingObject6121) {
    struct UserObject *inho6121 = (struct UserObject *)inheritingObject6121;
    while (inho6121->super != GraceDefaultObject) inho6121 = (struct UserObject *)inho6121->super;
    inho6121->super = obj6121;
    self = inheritingObject6121;
    *selfslot = self;
    lowerouter6121 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6121;
  }
if (objclass6121 == NULL) {
  Method *reader6123 = addmethodrealflags(obj6121, "removed", &reader_collectionsPrelude_removed_6123, MFLAG_CONFIDENTIAL);
  Method *writer6123 = addmethodrealflags(obj6121, "removed:=(1)", &writer_collectionsPrelude_removed_6123, MFLAG_CONFIDENTIAL);
  reader6123->definitionModule = modulename;
  writer6123->definitionModule = modulename;
  reader6123->definitionLine = 1178;
  writer6123->definitionLine = 1178;
}
obj6121->flags |= OFLAG_MUTABLE;
adddatum2(obj6121, alloc_Undefined(), 1);
if (objclass6121 == NULL) {
  Method *reader6124 = addmethodrealflags(obj6121, "key",&reader_collectionsPrelude_key_6124, MFLAG_DEF);
  reader6124->definitionModule = modulename;
  reader6124->definitionLine = 1179;
}
adddatum2(obj6121, alloc_Undefined(), 2);
if (objclass6121 == NULL) {
  Method *reader6125 = addmethodrealflags(obj6121, "value",&reader_collectionsPrelude_value_6125, MFLAG_DEF);
  reader6125->definitionModule = modulename;
  reader6125->definitionLine = 1180;
}
adddatum2(obj6121, alloc_Undefined(), 3);
// method "asString"
  struct UserObject *uo6126 = (struct UserObject*)obj6121;
  uo6126->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString6126 = addmethod2pos(obj6121, "asString", &meth_collectionsPrelude_asString6126, 4);
  int argcv_meth_collectionsPrelude_asString6126[] = {0};
  meth_meth_collectionsPrelude_asString6126->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6126);
  meth_meth_collectionsPrelude_asString6126->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6126->definitionLine = 1181;
// method "==(_)"
  struct UserObject *uo6128 = (struct UserObject*)obj6121;
  uo6128->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_6128 = addmethod2pos(obj6121, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_6128, 5);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_6128[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_6128->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_6128);
  meth_meth_collectionsPrelude__61__61__40_1_41_6128->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_6128->definitionLine = 1182;
  sourceObject = obj6121;
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6131 = alloc_Boolean(1);
// compiled identifier node returning bool6131 (depth = 3)
  adddatum2(obj6121, bool6131, 1);
  sourceObject = obj6121;
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  adddatum2(obj6121, self, 2);
  sourceObject = obj6121;
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  adddatum2(obj6121, self, 3);
  sourceObject = obj6121;
  sourceObject = obj6121;
  objclass6121 = obj6121->class;
  objclass6121->definitionModule = modulename;
  objclass6121->definitionLine = 1177;
  (*(struct UserObject *)self).data[0] = lowerouter6121;
  self = oldself6121;
  selfslot = oldselfslot6121;
  stackframe = oldstackframe6121;
// compiled object node returning obj6121 (depth = 2)
  *var_removed = obj6121;
  if (obj6121 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "removed"
  block_savedest(self);
  Object closure6132 = createclosure(1, "removed");
  setclosureframe(closure6132, stackframe);
  addtoclosure(closure6132, var_removed);
  struct UserObject *uo6132 = (struct UserObject*)self;
  uo6132->data[39] = (Object)closure6132;
  Method *meth_meth_collectionsPrelude_removed6132 = addmethod2pos(self, "removed", &meth_collectionsPrelude_removed6132, 39);
  int argcv_meth_collectionsPrelude_removed6132[] = {0};
  meth_meth_collectionsPrelude_removed6132->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removed6132);
  meth_meth_collectionsPrelude_removed6132->definitionModule = modulename;
  meth_meth_collectionsPrelude_removed6132->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Binding
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type6134 = alloc_Type("Binding", 4);
    add_Method((ClassData)type6134, "key", NULL);
    add_Method((ClassData)type6134, "value", NULL);
    add_Method((ClassData)type6134, "hash", NULL);
    add_Method((ClassData)type6134, "==(1)", NULL);
// compiled typeliteral node returning type6134 (depth = 2)
  *var_Binding = type6134;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Binding"
  block_savedest(self);
  Object closure6135 = createclosure(1, "Binding");
  setclosureframe(closure6135, stackframe);
  addtoclosure(closure6135, var_Binding);
  struct UserObject *uo6135 = (struct UserObject*)self;
  uo6135->data[40] = (Object)closure6135;
  Method *meth_meth_collectionsPrelude_Binding6135 = addmethod2pos(self, "Binding", &meth_collectionsPrelude_Binding6135, 40);
  int argcv_meth_collectionsPrelude_Binding6135[] = {0};
  meth_meth_collectionsPrelude_Binding6135->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Binding6135);
  meth_meth_collectionsPrelude_Binding6135->definitionModule = modulename;
  meth_meth_collectionsPrelude_Binding6135->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 1480
  setline(1480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6136 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6136 = alloc_userobj2(3,4, objclass6136);
  gc_frame_newslot(obj6136);
if (objclass6136 == NULL) {
  glfree(obj6136->class->name);
  obj6136->class->name = "binding";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6136, self, 0);
  addmethodreal(obj6136,"outer", &reader_collectionsPrelude_outer_6137);
  Object oldself6136 = self;
  struct StackFrameObject *oldstackframe6136 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6136);
  gc_frame_newslot((Object)stackframe);
  self = obj6136;
  Object *oldselfslot6136 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6136 = (*(struct UserObject *)self).data[0], lowerouter6136 = thisouter6136;
  if (inheritingObject6136) {
    struct UserObject *inho6136 = (struct UserObject *)inheritingObject6136;
    while (inho6136->super != GraceDefaultObject) inho6136 = (struct UserObject *)inho6136->super;
    inho6136->super = obj6136;
    self = inheritingObject6136;
    *selfslot = self;
    lowerouter6136 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6136;
  }
// method "asString"
  struct UserObject *uo6138 = (struct UserObject*)obj6136;
  uo6138->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString6138 = addmethod2pos(obj6136, "asString", &meth_collectionsPrelude_asString6138, 1);
  int argcv_meth_collectionsPrelude_asString6138[] = {0};
  meth_meth_collectionsPrelude_asString6138->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6138);
  meth_meth_collectionsPrelude_asString6138->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6138->definitionLine = 1482;
// method "key(_)value(_)"
  block_savedest(obj6136);
  Object closure6140 = createclosure(1, "key(1)value(1)");
  setclosureframe(closure6140, stackframe);
  addtoclosure(closure6140, var_Binding);
  struct UserObject *uo6140 = (struct UserObject*)obj6136;
  uo6140->data[2] = (Object)closure6140;
  Method *meth_meth_collectionsPrelude_key_40_1_41_value_40_1_41_6140 = addmethod2pos(obj6136, "key(1)value(1)", &meth_collectionsPrelude_key_40_1_41_value_40_1_41_6140, 2);
  int argcv_meth_collectionsPrelude_key_40_1_41_value_40_1_41_6140[] = {1, 1};
  meth_meth_collectionsPrelude_key_40_1_41_value_40_1_41_6140->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_key_40_1_41_value_40_1_41_6140);
  meth_meth_collectionsPrelude_key_40_1_41_value_40_1_41_6140->definitionModule = modulename;
  meth_meth_collectionsPrelude_key_40_1_41_value_40_1_41_6140->definitionLine = 1484;
  block_savedest(obj6136);
  Object closure6216 = createclosure(1, "key(1)value(1)$object(1)");
  setclosureframe(closure6216, stackframe);
  addtoclosure(closure6216, var_Binding);
  Method *meth_meth_collectionsPrelude_key_40_1_41_value_40_1_41_6140_object = addmethod2pos(obj6136, "key(1)value(1)$object(1)", &meth_collectionsPrelude_key_40_1_41_value_40_1_41_6140_object, 2);
  meth_meth_collectionsPrelude_key_40_1_41_value_40_1_41_6140_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_key_40_1_41_value_40_1_41_6140_object->definitionLine = 1484;
  sourceObject = obj6136;
  sourceObject = obj6136;
  objclass6136 = obj6136->class;
  objclass6136->definitionModule = modulename;
  objclass6136->definitionLine = 1481;
  (*(struct UserObject *)self).data[0] = lowerouter6136;
  self = oldself6136;
  selfslot = oldselfslot6136;
  stackframe = oldstackframe6136;
// compiled object node returning obj6136 (depth = 2)
  *var_binding = obj6136;
  if (obj6136 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "binding"
  block_savedest(self);
  Object closure6217 = createclosure(1, "binding");
  setclosureframe(closure6217, stackframe);
  addtoclosure(closure6217, var_binding);
  struct UserObject *uo6217 = (struct UserObject*)self;
  uo6217->data[41] = (Object)closure6217;
  Method *meth_meth_collectionsPrelude_binding6217 = addmethod2pos(self, "binding", &meth_collectionsPrelude_binding6217, 41);
  int argcv_meth_collectionsPrelude_binding6217[] = {0};
  meth_meth_collectionsPrelude_binding6217->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_binding6217);
  meth_meth_collectionsPrelude_binding6217->definitionModule = modulename;
  meth_meth_collectionsPrelude_binding6217->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1497
  setline(1497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl ComparableToDictionary
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type6219 = alloc_Type("ComparableToDictionary", 2);
    add_Method((ClassData)type6219, "size", NULL);
    add_Method((ClassData)type6219, "at(1)ifAbsent(1)", NULL);
// compiled typeliteral node returning type6219 (depth = 2)
  *var_ComparableToDictionary = type6219;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ComparableToDictionary"
  block_savedest(self);
  Object closure6220 = createclosure(1, "ComparableToDictionary");
  setclosureframe(closure6220, stackframe);
  addtoclosure(closure6220, var_ComparableToDictionary);
  struct UserObject *uo6220 = (struct UserObject*)self;
  uo6220->data[42] = (Object)closure6220;
  Method *meth_meth_collectionsPrelude_ComparableToDictionary6220 = addmethod2pos(self, "ComparableToDictionary", &meth_collectionsPrelude_ComparableToDictionary6220, 42);
  int argcv_meth_collectionsPrelude_ComparableToDictionary6220[] = {0};
  meth_meth_collectionsPrelude_ComparableToDictionary6220->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_ComparableToDictionary6220);
  meth_meth_collectionsPrelude_ComparableToDictionary6220->definitionModule = modulename;
  meth_meth_collectionsPrelude_ComparableToDictionary6220->definitionLine = 1991;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 1502
  setline(1502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2076
  setline(2076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
